function RuntimeException_3(cause){
  $fillInStackTrace(this);
  this.detailMessage = !cause?null:$toString_0(cause);
  this.cause = cause;
}

defineSeed(6, 7, makeCastMap([Q$Serializable, Q$Exception, Q$RuntimeException, Q$Throwable]), RuntimeException_3);
function $setDate(this$static, dayOfMonth){
  this$static.setDate(dayOfMonth);
  return this$static.getTime();
}

function $setHours(this$static, hours){
  this$static.setHours(hours);
  return this$static.getTime();
}

function $setMinutes(this$static, minutes){
  this$static.setMinutes(minutes);
  return this$static.getTime();
}

function $setSeconds(this$static, seconds){
  this$static.setSeconds(seconds);
  return this$static.getTime();
}

function $setTime(this$static, milliseconds){
  this$static.setTime(milliseconds);
  return this$static.getTime();
}

function create_1(year, month, dayOfMonth, hours, minutes, seconds, millis){
  return new Date(year, month, dayOfMonth, hours, minutes, seconds, millis);
}

function $flushPostEventPumpCommands(this$static){
  var oldDeferred;
  if (this$static.deferredCommands) {
    oldDeferred = this$static.deferredCommands;
    this$static.deferredCommands = null;
    !this$static.incrementalCommands && (this$static.incrementalCommands = []);
    runScheduledTasks(oldDeferred, this$static.incrementalCommands);
  }
  !!this$static.incrementalCommands && (this$static.incrementalCommands = runRepeatingTasks(this$static.incrementalCommands));
}

function $isWorkQueued(this$static){
  return !!this$static.deferredCommands || !!this$static.incrementalCommands;
}

function $maybeSchedulePostEventPumpCommands(this$static){
  if (!this$static.shouldBeRunning) {
    this$static.shouldBeRunning = true;
    !this$static.flusher && (this$static.flusher = new SchedulerImpl$Flusher_0(this$static));
    scheduleFixedDelayImpl(this$static.flusher, 1);
    !this$static.rescue && (this$static.rescue = new SchedulerImpl$Rescuer_0(this$static));
    scheduleFixedDelayImpl(this$static.rescue, 50);
  }
}

function $scheduleDeferred(this$static, cmd){
  this$static.deferredCommands = push(this$static.deferredCommands, [cmd, false]);
  $maybeSchedulePostEventPumpCommands(this$static);
}

function execute(cmd){
  return cmd.execute();
}

function runRepeatingTasks(tasks){
  var canceledSomeTasks, i, length_0, newTasks, start, t;
  length_0 = tasks.length;
  if (length_0 == 0) {
    return null;
  }
  canceledSomeTasks = false;
  start = currentTimeMillis();
  while (currentTimeMillis() - start < 100) {
    for (i = 0; i < length_0; ++i) {
      t = tasks[i];
      if (!t) {
        continue;
      }
      if (!t[0].execute()) {
        tasks[i] = null;
        canceledSomeTasks = true;
      }
    }
  }
  if (canceledSomeTasks) {
    newTasks = [];
    for (i = 0; i < length_0; ++i) {
      !!tasks[i] && (newTasks[newTasks.length] = tasks[i] , undefined);
    }
    return newTasks.length == 0?null:newTasks;
  }
   else {
    return tasks;
  }
}

function scheduleFixedDelayImpl(cmd, delayMs){
  $clinit_SchedulerImpl();
  $wnd.setTimeout(function(){
    var ret = $entry(execute)(cmd);
    ret && $wnd.setTimeout(arguments.callee, delayMs);
  }
  , delayMs);
}

function SchedulerImpl$Flusher_0(this$0){
  this.this$0 = this$0;
}

defineSeed(26, 1, {}, SchedulerImpl$Flusher_0);
_.execute = function execute_0(){
  this.this$0.flushRunning = true;
  $flushPostEventPumpCommands(this.this$0);
  this.this$0.flushRunning = false;
  return this.this$0.shouldBeRunning = $isWorkQueued(this.this$0);
}
;
_.this$0 = null;
function SchedulerImpl$Rescuer_0(this$0){
  this.this$0 = this$0;
}

defineSeed(27, 1, {}, SchedulerImpl$Rescuer_0);
_.execute = function execute_1(){
  this.this$0.flushRunning && scheduleFixedDelayImpl(this.this$0.flusher, 1);
  return this.this$0.shouldBeRunning;
}
;
_.this$0 = null;
function valueOf_0(enumType, name_0){
  var enumValueOfFunc;
  enumValueOfFunc = enumType.enumValueOfFunc;
  if (!enumValueOfFunc) {
    throw new IllegalArgumentException_0;
  }
  return enumValueOfFunc(name_0);
}

function $doRemoveNow(this$static, type, source, handler){
  var l_0, removed, sourceMap;
  l_0 = $getHandlerList(this$static, type, source);
  removed = l_0.remove_0(handler);
  removed && l_0.isEmpty_0() && (sourceMap = dynamicCast(this$static.map.get_2(type), Q$Map) , dynamicCast(sourceMap.remove_3(source), Q$List) , sourceMap.isEmpty_0() && this$static.map.remove_3(type) , undefined);
}

function $doRemove(this$static, type, source, handler){
  this$static.firingDepth > 0?$defer(this$static, new SimpleEventBus$3_0(this$static, type, source, handler)):$doRemoveNow(this$static, type, source, handler);
}

function encode(decodedURL){
  throwIfNull('decodedURL', decodedURL);
  return encodeURI(decodedURL);
}

function $getDefaultNative(){
  return ['USD', '$', 2, 'US$', '$'];
}

function $getNumberConstants(this$static){
  !this$static.numberConstants && (this$static.numberConstants = new NumberConstantsImpl_en_0);
  return this$static.numberConstants;
}

function $clinit_NumberFormat(){
  $clinit_NumberFormat = nullMethod;
  $getNumberConstants(($clinit_LocaleInfo() , $clinit_LocaleInfo() , instance_0));
}

function $addExponent(this$static, digits){
  var exponentDigits, i;
  $append_1(digits.data_0, 'E');
  if (this$static.exponent < 0) {
    this$static.exponent = -this$static.exponent;
    $append_1(digits.data_0, '-');
  }
  exponentDigits = '' + this$static.exponent;
  for (i = exponentDigits.length; i < this$static.minExponentDigits; ++i) {
    $appendNonNull(digits.data_0, '0');
  }
  $append_1(digits.data_0, exponentDigits);
}

function $addZeroAndDecimal(this$static, digits, decimalSeparator){
  if (this$static.digitsLength == 0) {
    $replace(digits.data_0, 0, 0, '0');
    ++this$static.decimalPosition;
    ++this$static.digitsLength;
  }
  if (this$static.decimalPosition < this$static.digitsLength || this$static.decimalSeparatorAlwaysShown) {
    $insert_0(digits, this$static.decimalPosition, String.fromCharCode(decimalSeparator));
    ++this$static.digitsLength;
  }
}

function $adjustFractionDigits(this$static, digits){
  var requiredDigits, toRemove;
  requiredDigits = this$static.decimalPosition + this$static.minimumFractionDigits;
  if (this$static.digitsLength < requiredDigits) {
    while (this$static.digitsLength < requiredDigits) {
      $appendNonNull(digits.data_0, '0');
      ++this$static.digitsLength;
    }
  }
   else {
    toRemove = this$static.decimalPosition + this$static.maximumFractionDigits;
    toRemove > this$static.digitsLength && (toRemove = this$static.digitsLength);
    while (toRemove > requiredDigits && $charAt($toString_1(digits.data_0), toRemove - 1) == 48) {
      --toRemove;
    }
    if (toRemove < this$static.digitsLength) {
      $delete_0(digits, toRemove, this$static.digitsLength);
      this$static.digitsLength = toRemove;
    }
  }
}

function $computeExponent(this$static, digits){
  var remainder, strip;
  strip = 0;
  while (strip < this$static.digitsLength - 1 && $charAt($toString_1(digits.data_0), strip) == 48) {
    ++strip;
  }
  if (strip > 0) {
    $replace(digits.data_0, 0, strip, '');
    this$static.digitsLength -= strip;
    this$static.exponent -= strip;
  }
  if (this$static.maximumIntegerDigits > this$static.minimumIntegerDigits && this$static.maximumIntegerDigits > 0) {
    this$static.exponent += this$static.decimalPosition - 1;
    remainder = this$static.exponent % this$static.maximumIntegerDigits;
    remainder < 0 && (remainder += this$static.maximumIntegerDigits);
    this$static.decimalPosition = remainder + 1;
    this$static.exponent -= remainder;
  }
   else {
    this$static.exponent += this$static.decimalPosition - this$static.minimumIntegerDigits;
    this$static.decimalPosition = this$static.minimumIntegerDigits;
  }
  if (this$static.digitsLength == 1 && $toString_1(digits.data_0).charCodeAt(0) == 48) {
    this$static.exponent = 0;
    this$static.decimalPosition = this$static.minimumIntegerDigits;
  }
}

function $format_0(this$static, number){
  var buf, isNegative, preRound, scale, useExponent, currentGroupingSize;
  if (isNaN(number)) {
    return 'NaN';
  }
  isNegative = number < 0 || number == 0 && 1 / number < 0;
  isNegative && (number = -number);
  buf = new StringBuilder_0;
  if (!isFinite(number)) {
    $append_12(buf, isNegative?this$static.negativePrefix:this$static.positivePrefix);
    $append_1(buf.data_0, '\u221E');
    $append_12(buf, isNegative?this$static.negativeSuffix:this$static.positiveSuffix);
    return $toString_1(buf.data_0);
  }
  number *= this$static.multiplier;
  scale = toScaledString(buf, number);
  preRound = $toString_1(buf.data_0).length + scale + this$static.maximumFractionDigits + 3;
  if (preRound > 0 && preRound < $toString_1(buf.data_0).length && $charAt($toString_1(buf.data_0), preRound) == 57) {
    $propagateCarry(this$static, buf, preRound - 1);
    scale += $toString_1(buf.data_0).length - preRound;
    $delete_0(buf, preRound, $toString_1(buf.data_0).length);
  }
  this$static.exponent = 0;
  this$static.digitsLength = $toString_1(buf.data_0).length;
  this$static.decimalPosition = this$static.digitsLength + scale;
  useExponent = this$static.useExponentialNotation;
  currentGroupingSize = this$static.groupingSize;
  this$static.decimalPosition > 1024 && (useExponent = true);
  useExponent && $computeExponent(this$static, buf);
  $processLeadingZeros(this$static, buf);
  $roundValue(this$static, buf);
  $insertGroupingSeparators(this$static, buf, 44, currentGroupingSize);
  $adjustFractionDigits(this$static, buf);
  $addZeroAndDecimal(this$static, buf, 46);
  useExponent && $addExponent(this$static, buf);
  $insert_0(buf, 0, isNegative?this$static.negativePrefix:this$static.positivePrefix);
  $append_12(buf, isNegative?this$static.negativeSuffix:this$static.positiveSuffix);
  return $toString_1(buf.data_0);
}

function $insertGroupingSeparators(this$static, digits, groupingSeparator, g){
  var i;
  if (g > 0) {
    for (i = g; i < this$static.decimalPosition; i += g + 1) {
      $insert_0(digits, this$static.decimalPosition - i, String.fromCharCode(groupingSeparator));
      ++this$static.decimalPosition;
      ++this$static.digitsLength;
    }
  }
}

function $parse(this$static, text){
  var pos, result;
  pos = initValues(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [0]);
  result = $parse_0(this$static, text, pos);
  if (pos[0] == 0 || pos[0] != text.length) {
    throw new NumberFormatException_1(text);
  }
  return result;
}

function $parse_0(this$static, text, inOutPos){
  var gotNegative, gotNegativePrefix, gotNegativeSuffix, gotPositive, gotPositivePrefix, gotPositiveSuffix, ret, tempPos, valueOnly;
  gotPositivePrefix = $startsWith(text, this$static.positivePrefix, inOutPos[0]);
  gotNegativePrefix = $startsWith(text, this$static.negativePrefix, inOutPos[0]);
  gotPositiveSuffix = $endsWith(text, this$static.positiveSuffix);
  gotNegativeSuffix = $endsWith(text, this$static.negativeSuffix);
  gotPositive = gotPositivePrefix && gotPositiveSuffix;
  gotNegative = gotNegativePrefix && gotNegativeSuffix;
  if (gotPositive && gotNegative) {
    this$static.positivePrefix.length > this$static.negativePrefix.length?(gotNegative = false):this$static.positivePrefix.length < this$static.negativePrefix.length?(gotPositive = false):this$static.positiveSuffix.length > this$static.negativeSuffix.length?(gotNegative = false):this$static.positiveSuffix.length < this$static.negativeSuffix.length?(gotPositive = false):(gotNegative = false);
  }
   else if (!gotPositive && !gotNegative) {
    throw new NumberFormatException_1(text + ' does not have either positive or negative affixes');
  }
  if (gotPositive) {
    inOutPos[0] += this$static.positivePrefix.length;
    valueOnly = $substring_0(text, inOutPos[0], text.length - this$static.positiveSuffix.length);
  }
   else {
    inOutPos[0] += this$static.negativePrefix.length;
    valueOnly = $substring_0(text, inOutPos[0], text.length - this$static.negativeSuffix.length);
  }
  if ($equals_6(valueOnly, '\u221E')) {
    inOutPos[0] += 1;
    ret = Infinity;
  }
   else if ($equals_6(valueOnly, 'NaN')) {
    inOutPos[0] += 3;
    ret = NaN;
  }
   else {
    tempPos = initValues(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [0]);
    ret = $parseNumber(this$static, valueOnly, tempPos);
    inOutPos[0] += tempPos[0];
  }
  gotPositive?(inOutPos[0] += this$static.positiveSuffix.length):gotNegative && (inOutPos[0] += this$static.negativeSuffix.length);
  gotNegative && (ret = -ret);
  return ret;
}

function $parseAffix(this$static, pattern, start, affix, inNegativePattern){
  var ch, inQuote, len, pos;
  $delete(affix, $toString_1(affix.data_0).length);
  inQuote = false;
  len = pattern.length;
  for (pos = start; pos < len; ++pos) {
    ch = pattern.charCodeAt(pos);
    if (ch == 39) {
      if (pos + 1 < len && pattern.charCodeAt(pos + 1) == 39) {
        ++pos;
        $append_1(affix.data_0, "'");
      }
       else {
        inQuote = !inQuote;
      }
      continue;
    }
    if (inQuote) {
      $appendNonNull(affix.data_0, String.fromCharCode(ch));
    }
     else {
      switch (ch) {
        case 35:
        case 48:
        case 44:
        case 46:
        case 59:
          return pos - start;
        case 164:
          this$static.isCurrencyFormat = true;
          if (pos + 1 < len && pattern.charCodeAt(pos + 1) == 164) {
            ++pos;
            if (pos < len - 3 && pattern.charCodeAt(pos + 1) == 164 && pattern.charCodeAt(pos + 2) == 164) {
              pos += 2;
              $append_5(affix, $getSimpleCurrencySymbol(this$static.currencyData));
            }
             else {
              $append_5(affix, this$static.currencyData[0]);
            }
          }
           else {
            $append_5(affix, this$static.currencyData[1]);
          }

          break;
        case 37:
          if (!inNegativePattern) {
            if (this$static.multiplier != 1) {
              throw new IllegalArgumentException_1('Too many percent/per mille characters in pattern "' + pattern + '"');
            }
            this$static.multiplier = 100;
          }

          $append_1(affix.data_0, '%');
          break;
        case 8240:
          if (!inNegativePattern) {
            if (this$static.multiplier != 1) {
              throw new IllegalArgumentException_1('Too many percent/per mille characters in pattern "' + pattern + '"');
            }
            this$static.multiplier = 1000;
          }

          $append_1(affix.data_0, '\u2030');
          break;
        case 45:
          $append_1(affix.data_0, '-');
          break;
        default:$appendNonNull(affix.data_0, String.fromCharCode(ch));
      }
    }
  }
  return len - start;
}

function $parseNumber(this$static, text, pos){
  var $e0, ch, decimal, digit, grouping, normalizedText, ret, sawDecimal, sawDigit, sawExponent, scale;
  sawDecimal = false;
  sawExponent = false;
  sawDigit = false;
  scale = 1;
  decimal = this$static.isCurrencyFormat?'.':'.';
  grouping = this$static.isCurrencyFormat?',':',';
  normalizedText = new StringBuffer_0;
  for (; pos[0] < text.length; ++pos[0]) {
    ch = text.charCodeAt(pos[0]);
    digit = 48 <= ch && ch <= 57?ch - 48:48 <= ch && ch <= 57?ch - 48:-1;
    if (digit >= 0 && digit <= 9) {
      $appendNonNull(normalizedText.data_0, String.fromCharCode(digit + 48 & 65535));
      sawDigit = true;
    }
     else if (ch == decimal.charCodeAt(0)) {
      if (sawDecimal || sawExponent) {
        break;
      }
      $appendNonNull(normalizedText.data_0, '.');
      sawDecimal = true;
    }
     else if (ch == grouping.charCodeAt(0)) {
      if (sawDecimal || sawExponent) {
        break;
      }
      continue;
    }
     else if (ch == 69) {
      if (sawExponent) {
        break;
      }
      $appendNonNull(normalizedText.data_0, 'E');
      sawExponent = true;
    }
     else if (ch == 43 || ch == 45) {
      $appendNonNull(normalizedText.data_0, String.fromCharCode(ch));
    }
     else if (ch == 37) {
      if (scale != 1) {
        break;
      }
      scale = 100;
      if (sawDigit) {
        ++pos[0];
        break;
      }
    }
     else if (ch == 8240) {
      if (scale != 1) {
        break;
      }
      scale = 1000;
      if (sawDigit) {
        ++pos[0];
        break;
      }
    }
     else {
      break;
    }
  }
  try {
    ret = __parseAndValidateDouble($toString_1(normalizedText.data_0));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$NumberFormatException)) {
      throw new NumberFormatException_1(text);
    }
     else 
      throw $e0;
  }
  ret = ret / scale;
  return ret;
}

function $parsePattern_0(this$static, pattern){
  var affix, pos;
  pos = 0;
  affix = new StringBuffer_0;
  pos += $parseAffix(this$static, pattern, 0, affix, false);
  this$static.positivePrefix = $toString_1(affix.data_0);
  pos += $parseTrunk(this$static, pattern, pos, false);
  pos += $parseAffix(this$static, pattern, pos, affix, false);
  this$static.positiveSuffix = $toString_1(affix.data_0);
  if (pos < pattern.length && pattern.charCodeAt(pos) == 59) {
    ++pos;
    pos += $parseAffix(this$static, pattern, pos, affix, true);
    this$static.negativePrefix = $toString_1(affix.data_0);
    pos += $parseTrunk(this$static, pattern, pos, true);
    pos += $parseAffix(this$static, pattern, pos, affix, true);
    this$static.negativeSuffix = $toString_1(affix.data_0);
  }
   else {
    this$static.negativePrefix = '-' + this$static.positivePrefix;
    this$static.negativeSuffix = this$static.positiveSuffix;
  }
}

function $parseTrunk(this$static, pattern, start, ignorePattern){
  var ch, decimalPos, digitLeftCount, digitRightCount, effectiveDecimalPos, groupingCount, len, loop, n, pos, totalDigits, zeroDigitCount;
  decimalPos = -1;
  digitLeftCount = 0;
  zeroDigitCount = 0;
  digitRightCount = 0;
  groupingCount = -1;
  len = pattern.length;
  pos = start;
  loop = true;
  for (; pos < len && loop; ++pos) {
    ch = pattern.charCodeAt(pos);
    switch (ch) {
      case 35:
        zeroDigitCount > 0?++digitRightCount:++digitLeftCount;
        groupingCount >= 0 && decimalPos < 0 && ++groupingCount;
        break;
      case 48:
        if (digitRightCount > 0) {
          throw new IllegalArgumentException_1("Unexpected '0' in pattern \"" + pattern + '"');
        }

        ++zeroDigitCount;
        groupingCount >= 0 && decimalPos < 0 && ++groupingCount;
        break;
      case 44:
        groupingCount = 0;
        break;
      case 46:
        if (decimalPos >= 0) {
          throw new IllegalArgumentException_1('Multiple decimal separators in pattern "' + pattern + '"');
        }

        decimalPos = digitLeftCount + zeroDigitCount + digitRightCount;
        break;
      case 69:
        if (!ignorePattern) {
          if (this$static.useExponentialNotation) {
            throw new IllegalArgumentException_1('Multiple exponential symbols in pattern "' + pattern + '"');
          }
          this$static.useExponentialNotation = true;
          this$static.minExponentDigits = 0;
        }

        while (pos + 1 < len && pattern.charCodeAt(pos + 1) == 48) {
          ++pos;
          ignorePattern || ++this$static.minExponentDigits;
        }

        if (!ignorePattern && digitLeftCount + zeroDigitCount < 1 || this$static.minExponentDigits < 1) {
          throw new IllegalArgumentException_1('Malformed exponential pattern "' + pattern + '"');
        }

        loop = false;
        break;
      default:--pos;
        loop = false;
    }
  }
  if (zeroDigitCount == 0 && digitLeftCount > 0 && decimalPos >= 0) {
    n = decimalPos;
    decimalPos == 0 && ++n;
    digitRightCount = digitLeftCount - n;
    digitLeftCount = n - 1;
    zeroDigitCount = 1;
  }
  if (decimalPos < 0 && digitRightCount > 0 || decimalPos >= 0 && (decimalPos < digitLeftCount || decimalPos > digitLeftCount + zeroDigitCount) || groupingCount == 0) {
    throw new IllegalArgumentException_1('Malformed pattern "' + pattern + '"');
  }
  if (ignorePattern) {
    return pos - start;
  }
  totalDigits = digitLeftCount + zeroDigitCount + digitRightCount;
  this$static.maximumFractionDigits = decimalPos >= 0?totalDigits - decimalPos:0;
  if (decimalPos >= 0) {
    this$static.minimumFractionDigits = digitLeftCount + zeroDigitCount - decimalPos;
    this$static.minimumFractionDigits < 0 && (this$static.minimumFractionDigits = 0);
  }
  effectiveDecimalPos = decimalPos >= 0?decimalPos:totalDigits;
  this$static.minimumIntegerDigits = effectiveDecimalPos - digitLeftCount;
  if (this$static.useExponentialNotation) {
    this$static.maximumIntegerDigits = digitLeftCount + this$static.minimumIntegerDigits;
    this$static.maximumFractionDigits == 0 && this$static.minimumIntegerDigits == 0 && (this$static.minimumIntegerDigits = 1);
  }
  this$static.groupingSize = groupingCount > 0?groupingCount:0;
  this$static.decimalSeparatorAlwaysShown = decimalPos == 0 || decimalPos == totalDigits;
  return pos - start;
}

function $processLeadingZeros(this$static, digits){
  var i, prefix, strip;
  if (this$static.decimalPosition > this$static.digitsLength) {
    while (this$static.digitsLength < this$static.decimalPosition) {
      $appendNonNull(digits.data_0, '0');
      ++this$static.digitsLength;
    }
  }
  if (!this$static.useExponentialNotation) {
    if (this$static.decimalPosition < this$static.minimumIntegerDigits) {
      prefix = new StringBuilder_0;
      while (this$static.decimalPosition < this$static.minimumIntegerDigits) {
        $appendNonNull(prefix.data_0, '0');
        ++this$static.decimalPosition;
        ++this$static.digitsLength;
      }
      $insert_0(digits, 0, $toString_1(prefix.data_0));
    }
     else if (this$static.decimalPosition > this$static.minimumIntegerDigits) {
      strip = this$static.decimalPosition - this$static.minimumIntegerDigits;
      for (i = 0; i < strip; ++i) {
        if ($charAt($toString_1(digits.data_0), i) != 48) {
          strip = i;
          break;
        }
      }
      if (strip > 0) {
        $replace(digits.data_0, 0, strip, '');
        this$static.digitsLength -= strip;
        this$static.decimalPosition -= strip;
      }
    }
  }
}

function $propagateCarry(this$static, digits, i){
  var carry, digit;
  carry = true;
  while (carry && i >= 0) {
    digit = $charAt($toString_1(digits.data_0), i);
    if (digit == 57) {
      $setCharAt(digits, i--, 48);
    }
     else {
      $setCharAt(digits, i, digit + 1 & 65535);
      carry = false;
    }
  }
  if (carry) {
    $replace(digits.data_0, 0, 0, '1');
    ++this$static.decimalPosition;
    ++this$static.digitsLength;
  }
}

function $roundValue(this$static, digits){
  var i;
  if (this$static.digitsLength > this$static.decimalPosition + this$static.maximumFractionDigits && $charAt_0(digits, this$static.decimalPosition + this$static.maximumFractionDigits) >= 53) {
    i = this$static.decimalPosition + this$static.maximumFractionDigits - 1;
    $propagateCarry(this$static, digits, i);
  }
}

function NumberFormat_0(pattern, cdata, userSuppliedPattern){
  if (!cdata) {
    throw new IllegalArgumentException_1('Unknown currency code');
  }
  this.pattern = pattern;
  this.currencyData = cdata;
  $parsePattern_0(this, this.pattern);
  if (!userSuppliedPattern && this.isCurrencyFormat) {
    this.minimumFractionDigits = this.currencyData[2] & 7;
    this.maximumFractionDigits = this.minimumFractionDigits;
  }
}

function NumberFormat_1(pattern, cdata, userSuppliedPattern){
  $clinit_NumberFormat();
  NumberFormat_0.call(this, pattern, cdata, userSuppliedPattern);
}

function toScaledString(buf, val){
  var dot, expDigits, expIdx, scale, startLen;
  startLen = $toString_1(buf.data_0).length;
  $append_12(buf, val.toPrecision(20));
  scale = 0;
  expIdx = $indexOf_3($toString_1(buf.data_0), 'e', startLen);
  expIdx < 0 && (expIdx = $indexOf_3($toString_1(buf.data_0), 'E', startLen));
  if (expIdx >= 0) {
    expDigits = expIdx + 1;
    expDigits < $toString_1(buf.data_0).length && $charAt($toString_1(buf.data_0), expDigits) == 43 && ++expDigits;
    expDigits < $toString_1(buf.data_0).length && (scale = __parseAndValidateInt($substring($toString_1(buf.data_0), expDigits)));
    $delete_0(buf, expIdx, $toString_1(buf.data_0).length);
  }
  dot = $indexOf_3($toString_1(buf.data_0), '.', startLen);
  if (dot >= 0) {
    $replace(buf.data_0, dot, dot + 1, '');
    scale -= $toString_1(buf.data_0).length - dot;
  }
  return scale;
}

defineSeed(96, 1, {}, NumberFormat_1);
_.currencyData = null;
_.decimalPosition = 0;
_.decimalSeparatorAlwaysShown = false;
_.digitsLength = 0;
_.exponent = 0;
_.groupingSize = 3;
_.isCurrencyFormat = false;
_.maximumFractionDigits = 3;
_.maximumIntegerDigits = 40;
_.minExponentDigits = 0;
_.minimumFractionDigits = 0;
_.minimumIntegerDigits = 1;
_.multiplier = 1;
_.negativePrefix = '-';
_.negativeSuffix = '';
_.pattern = null;
_.positivePrefix = '';
_.positiveSuffix = '';
_.useExponentialNotation = false;
var cachedDecimalFormat = null;
function NumberConstantsImpl_en_0(){
}

defineSeed(98, 1, {}, NumberConstantsImpl_en_0);
function $getSimpleCurrencySymbol(this$static){
  return this$static[4] || this$static[1];
}

function $after(this$static, when){
  return gt(this$static.getTime_0(), when.getTime_0());
}

function $fixDaylightSavings(this$static, hours){
  var badHours, copy, day, newTime, timeDiff, timeDiffHours, timeDiffMinutes;
  if (this$static.jsdate.getHours() % 24 != hours % 24) {
    copy = create_0(this$static.jsdate.getTime());
    $setDate(copy, copy.getDate() + 1);
    timeDiff = this$static.jsdate.getTimezoneOffset() - copy.getTimezoneOffset();
    if (timeDiff > 0) {
      timeDiffHours = ~~(timeDiff / 60);
      timeDiffMinutes = timeDiff % 60;
      day = this$static.jsdate.getDate();
      badHours = this$static.jsdate.getHours();
      badHours + timeDiffHours >= 24 && ++day;
      newTime = create_1(this$static.jsdate.getFullYear(), this$static.jsdate.getMonth(), day, hours + timeDiffHours, this$static.jsdate.getMinutes() + timeDiffMinutes, this$static.jsdate.getSeconds(), this$static.jsdate.getMilliseconds());
      $setTime(this$static.jsdate, newTime.getTime());
    }
  }
}

function $setTime_0(this$static, time){
  $setTime(this$static.jsdate, toDouble(time));
}

defineSeed(104, 1, makeCastMap([Q$Serializable, Q$Cloneable, Q$Comparable, Q$Date]));
_.setDate_0 = function setDate(date){
  var hours;
  hours = this.jsdate.getHours();
  $setDate(this.jsdate, date);
  $fixDaylightSavings(this, hours);
}
;
_.setHours_0 = function setHours(hours){
  $setHours(this.jsdate, hours);
  $fixDaylightSavings(this, hours);
}
;
_.setMinutes_0 = function setMinutes(minutes){
  var hours;
  hours = this.getHours_0() + ~~(minutes / 60);
  $setMinutes(this.jsdate, minutes);
  $fixDaylightSavings(this, hours);
}
;
_.setSeconds_0 = function setSeconds(seconds){
  var hours;
  hours = this.getHours_0() + ~~(seconds / 3600);
  $setSeconds(this.jsdate, seconds);
  $fixDaylightSavings(this, hours);
}
;
_.setTime_0 = function setTime(time){
  $setTime_0(this, time);
}
;
function DateRecord_0(){
  Date_1.call(this);
  this.era = -1;
  this.ambiguousYear = false;
  this.year = -2147483648;
  this.month = -1;
  this.dayOfMonth = -1;
  this.ampm = -1;
  this.hours = -1;
  this.minutes = -1;
  this.seconds = -1;
  this.milliseconds = -1;
  this.dayOfWeek = -1;
  this.tzOffset = -2147483648;
}

defineSeed(103, 104, makeCastMap([Q$Serializable, Q$Cloneable, Q$Comparable, Q$Date]), DateRecord_0);
_.setHours_0 = function setHours_0(hours){
  this.hours = hours;
}
;
_.setMinutes_0 = function setMinutes_0(minutes){
  this.minutes = minutes;
}
;
_.setSeconds_0 = function setSeconds_0(seconds){
  this.seconds = seconds;
}
;
_.ambiguousYear = false;
_.ampm = 0;
_.dayOfMonth = 0;
_.dayOfWeek = 0;
_.era = 0;
_.hours = 0;
_.milliseconds = 0;
_.minutes = 0;
_.month = 0;
_.seconds = 0;
_.tzOffset = 0;
_.year = 0;
function deserialize_1(streamReader, instance){
  setAmbiguousYear(instance, $readBoolean(streamReader));
  setAmpm(instance, $readInt(streamReader));
  setDayOfMonth(instance, $readInt(streamReader));
  setDayOfWeek(instance, $readInt(streamReader));
  setEra(instance, $readInt(streamReader));
  setHours_1(instance, $readInt(streamReader));
  setMilliseconds(instance, $readInt(streamReader));
  setMinutes_1(instance, $readInt(streamReader));
  setMonth(instance, $readInt(streamReader));
  setSeconds_1(instance, $readInt(streamReader));
  setTzOffset(instance, $readInt(streamReader));
  setYear(instance, $readInt(streamReader));
}

function instantiate_1(streamReader){
  return new DateRecord_0;
}

function serialize(streamWriter, instance){
  $writeBoolean(streamWriter, instance.ambiguousYear);
  $writeInt(streamWriter, instance.ampm);
  $writeInt(streamWriter, instance.dayOfMonth);
  $writeInt(streamWriter, instance.dayOfWeek);
  $writeInt(streamWriter, instance.era);
  $writeInt(streamWriter, instance.hours);
  $writeInt(streamWriter, instance.milliseconds);
  $writeInt(streamWriter, instance.minutes);
  $writeInt(streamWriter, instance.month);
  $writeInt(streamWriter, instance.seconds);
  $writeInt(streamWriter, instance.tzOffset);
  $writeInt(streamWriter, instance.year);
  $append_3(streamWriter, toBase64(fromDouble(instance.jsdate.getTime())));
}

function setAmbiguousYear(instance, value){
  instance.ambiguousYear = value;
}

function setAmpm(instance, value){
  instance.ampm = value;
}

function setDayOfMonth(instance, value){
  instance.dayOfMonth = value;
}

function setDayOfWeek(instance, value){
  instance.dayOfWeek = value;
}

function setEra(instance, value){
  instance.era = value;
}

function setHours_1(instance, value){
  instance.hours = value;
}

function setMilliseconds(instance, value){
  instance.milliseconds = value;
}

function setMinutes_1(instance, value){
  instance.minutes = value;
}

function setMonth(instance, value){
  instance.month = value;
}

function setSeconds_1(instance, value){
  instance.seconds = value;
}

function setTzOffset(instance, value){
  instance.tzOffset = value;
}

function setYear(instance, value){
  instance.year = value;
}

function appendChild(parent_0, child){
  $appendChild(parent_0, ($clinit_PotentialElement() , child.__gwt_resolve?child.__gwt_resolve():child));
}

function back_0(){
  $clinit_History();
  $wnd.history.back();
}

function $setEventListener(elem, listener){
  elem.__listener = listener;
}

function $sinkEvents(elem, bits){
  $maybeInitializeEventSystem();
  $sinkEventsImpl(elem, bits);
}

function $sinkEventsImpl(elem, bits){
  var chMask = (elem.__eventBits || 0) ^ bits;
  elem.__eventBits = bits;
  if (!chMask)
    return;
  chMask & 1 && (elem.onclick = bits & 1?callDispatchEvent:null);
  chMask & 3 && (elem.ondblclick = bits & 3?callDispatchDblClickEvent:null);
  chMask & 4 && (elem.onmousedown = bits & 4?callDispatchEvent:null);
  chMask & 8 && (elem.onmouseup = bits & 8?callDispatchEvent:null);
  chMask & 16 && (elem.onmouseover = bits & 16?callDispatchEvent:null);
  chMask & 32 && (elem.onmouseout = bits & 32?callDispatchEvent:null);
  chMask & 64 && (elem.onmousemove = bits & 64?callDispatchEvent:null);
  chMask & 128 && (elem.onkeydown = bits & 128?callDispatchEvent:null);
  chMask & 256 && (elem.onkeypress = bits & 256?callDispatchEvent:null);
  chMask & 512 && (elem.onkeyup = bits & 512?callDispatchEvent:null);
  chMask & 1024 && (elem.onchange = bits & 1024?callDispatchEvent:null);
  chMask & 2048 && (elem.onfocus = bits & 2048?callDispatchEvent:null);
  chMask & 4096 && (elem.onblur = bits & 4096?callDispatchEvent:null);
  chMask & 8192 && (elem.onlosecapture = bits & 8192?callDispatchEvent:null);
  chMask & 16384 && (elem.onscroll = bits & 16384?callDispatchEvent:null);
  chMask & 32768 && (elem.nodeName == 'IFRAME'?bits & 32768?elem.attachEvent('onload', callDispatchOnLoadEvent):elem.detachEvent('onload', callDispatchOnLoadEvent):(elem.onload = bits & 32768?callDispatchUnhandledEvent:null));
  chMask & 65536 && (elem.onerror = bits & 65536?callDispatchEvent:null);
  chMask & 131072 && (elem.onmousewheel = bits & 131072?callDispatchEvent:null);
  chMask & 262144 && (elem.oncontextmenu = bits & 262144?callDispatchEvent:null);
  chMask & 524288 && (elem.onpaste = bits & 524288?callDispatchEvent:null);
}

function deserialize_35(streamReader, instance){
  var i, n;
  for (i = 0 , n = instance.length; i < n; ++i) {
    instance[i] = $getString(streamReader, $readInt(streamReader));
  }
}

function instantiate_34(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, size, 0);
}

function deserialize_44(streamReader, instance){
}

function instantiate_43(streamReader){
  return new Date_4($readLong(streamReader));
}

function serialize_15(streamWriter, instance){
  $append_3(streamWriter, toBase64(fromDouble(instance.jsdate.getTime())));
}

function deserialize_45(streamReader, instance){
}

function instantiate_44(streamReader){
  return new Time_0($readLong(streamReader));
}

function serialize_16(streamWriter, instance){
  $append_3(streamWriter, toBase64(fromDouble(instance.jsdate.getTime())));
}

function deserialize_46(streamReader, instance){
  $setNanos(instance, $readInt(streamReader));
}

function instantiate_45(streamReader){
  return new Timestamp_0($readLong(streamReader));
}

function serialize_17(streamWriter, instance){
  $append_3(streamWriter, toBase64(fromDouble(instance.jsdate.getTime())));
  $writeInt(streamWriter, instance.nanos);
}

function deserialize_47(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_46(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Ljava_util_AbstractList_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$AbstractList, size, 0);
}

function deserialize_48(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_47(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Ljava_util_AbstractSequentialList_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$AbstractSequentialList, size, 0);
}

function deserialize_49(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_48(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Ljava_util_ArrayList_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ArrayList, size, 0);
}

function deserialize_58(streamReader, instance){
}

function instantiate_56(streamReader){
  return new Date_2($readLong(streamReader));
}

function serialize_25(streamWriter, instance){
  $append_3(streamWriter, toBase64(instance.getTime_0()));
}

function deserialize_60(streamReader, instance){
  deserialize_69(streamReader, instance);
}

function instantiate_58(streamReader){
  var clazz, exemplar;
  exemplar = $readObject(streamReader);
  clazz = getClass__devirtual$(exemplar);
  return new EnumMap_0(clazz);
}

function deserialize_66(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_64(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Ljava_util_LinkedList_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$LinkedList, size, 0);
}

function deserialize_68(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_66(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Ljava_util_List_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$List, size, 0);
}

function deserialize_71(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_68(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Ljava_util_Stack_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Stack, size, 0);
}

function deserialize_76(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_73(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Ljava_util_Vector_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Vector, size, 0);
}

function setStylePrimaryName(elem, style){
  if (!elem) {
    throw new RuntimeException_1('Null widget handle. If you are creating a composite, ensure that initWidget() has been called.');
  }
  style = $trim(style);
  if (style.length == 0) {
    throw new IllegalArgumentException_1('Style names cannot be empty');
  }
  updatePrimaryAndDependentStyleNames(elem, style);
}

function updatePrimaryAndDependentStyleNames(elem, newPrimaryStyle){
  var classes = elem.className.split(/\s+/);
  if (!classes) {
    return;
  }
  var oldPrimaryStyle = classes[0];
  var oldPrimaryStyleLen = oldPrimaryStyle.length;
  classes[0] = newPrimaryStyle;
  for (var i = 1, n = classes.length; i < n; i++) {
    var name_0 = classes[i];
    name_0.length > oldPrimaryStyleLen && name_0.charAt(oldPrimaryStyleLen) == '-' && name_0.indexOf(oldPrimaryStyle) == 0 && (classes[i] = newPrimaryStyle + name_0.substring(oldPrimaryStyleLen));
  }
  elem.className = classes.join(' ');
}

function $onAttach(this$static){
  var bitsToAdd;
  if (this$static.attached) {
    throw new IllegalStateException_1("Should only call onAttach when the widget is detached from the browser's document");
  }
  this$static.attached = true;
  $setEventListener(this$static.getElement(), this$static);
  bitsToAdd = this$static.eventsToSink;
  this$static.eventsToSink = -1;
  bitsToAdd > 0 && (this$static.eventsToSink == -1?$sinkEvents(this$static.getElement(), bitsToAdd | (this$static.getElement().__eventBits || 0)):(this$static.eventsToSink |= bitsToAdd));
  this$static.doAttachChildren();
}

function $onDetach(this$static){
  if (!this$static.attached) {
    throw new IllegalStateException_1("Should only call onDetach when the widget is attached to the browser's document");
  }
  try {
    this$static.doDetachChildren();
  }
   finally {
    this$static.getElement().__listener = null;
    this$static.attached = false;
  }
}

function $removeFromParent(this$static){
  if (!this$static.parent_0) {
    ($clinit_RootPanel() , $contains_2(widgetsToDetach, this$static)) && detachNow(this$static);
  }
   else if (this$static.parent_0) {
    $remove_1(this$static.parent_0, this$static);
  }
   else if (this$static.parent_0) {
    throw new IllegalStateException_1("This widget's parent does not implement HasWidgets");
  }
}

function $setParent_0(this$static, parent_0){
  var oldParent;
  oldParent = this$static.parent_0;
  if (!parent_0) {
    try {
      !!oldParent && oldParent.attached && $onDetach(this$static);
    }
     finally {
      this$static.parent_0 = null;
    }
  }
   else {
    if (oldParent) {
      throw new IllegalStateException_1('Cannot set a new parent without first clearing the old parent');
    }
    this$static.parent_0 = parent_0;
    parent_0.attached && this$static.onAttach();
  }
}

defineSeed(283, 284, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget]));
_.doAttachChildren = function doAttachChildren(){
}
;
_.doDetachChildren = function doDetachChildren(){
}
;
_.onAttach = function onAttach(){
  $onAttach(this);
}
;
defineSeed(282, 283, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$Iterable]));
_.doAttachChildren = function doAttachChildren_0(){
  tryCommand(this, ($clinit_AttachDetachException() , attachCommand));
}
;
_.doDetachChildren = function doDetachChildren_0(){
  tryCommand(this, ($clinit_AttachDetachException() , detachCommand));
}
;
function $add_0(this$static, child, container){
  $removeFromParent(child);
  $add_4(this$static.children_0, child);
  appendChild(container, child.element);
  $setParent_0(child, this$static);
}

function $remove_0(this$static, w){
  var elem;
  if (w.parent_0 != this$static) {
    return false;
  }
  try {
    $setParent_0(w, null);
  }
   finally {
    elem = w.getElement();
    $removeChild($getParentElement(elem), elem);
    $remove_6(this$static.children_0, w);
  }
  return true;
}

defineSeed(281, 282, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$Iterable]));
_.iterator = function iterator_1(){
  return new WidgetCollection$WidgetIterator_0(this.children_0);
}
;
_.remove = function remove_0(w){
  return $remove_0(this, w);
}
;
function $add_1(this$static, w){
  $add_0(this$static, w, this$static.element);
}

function $remove_1(this$static, w){
  var removed;
  removed = $remove_0(this$static, w);
  removed && changeToStaticPositioning(w.getElement());
  return removed;
}

function changeToStaticPositioning(elem){
  elem.style['left'] = '';
  elem.style['top'] = '';
  elem.style['position'] = '';
}

defineSeed(280, 281, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$Iterable]));
_.remove = function remove_1(w){
  return $remove_1(this, w);
}
;
function $clinit_AttachDetachException(){
  $clinit_AttachDetachException = nullMethod;
  attachCommand = new AttachDetachException$1_0;
  detachCommand = new AttachDetachException$2_0;
}

function AttachDetachException_0(causes){
  UmbrellaException_4.call(this, causes);
}

function tryCommand(hasWidgets, c){
  $clinit_AttachDetachException();
  var $e0, caught, e, w, w$iterator;
  caught = null;
  for (w$iterator = hasWidgets.iterator(); w$iterator.hasNext();) {
    w = dynamicCast(w$iterator.next_0(), Q$Widget);
    try {
      c.execute_0(w);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Throwable)) {
        e = $e0;
        !caught && (caught = new HashSet_0);
        $add_6(caught, e);
      }
       else 
        throw $e0;
    }
  }
  if (caught) {
    throw new AttachDetachException_0(caught);
  }
}

defineSeed(285, 66, makeCastMap([Q$UmbrellaException, Q$Serializable, Q$Exception, Q$RuntimeException, Q$Throwable]), AttachDetachException_0);
var attachCommand, detachCommand;
function AttachDetachException$1_0(){
}

defineSeed(286, 1, {}, AttachDetachException$1_0);
_.execute_0 = function execute_2(w){
  w.onAttach();
}
;
function AttachDetachException$2_0(){
}

defineSeed(287, 1, {}, AttachDetachException$2_0);
_.execute_0 = function execute_3(w){
  $onDetach(w);
}
;
function $removeAll(this$static, c){
  var changed, iter;
  iter = new AbstractList$IteratorImpl_0(this$static);
  changed = false;
  while (iter.i < iter.this$0_0.size_1()) {
    if ($indexOf_0(c, $next_0(iter), 0) != -1) {
      $remove_7(iter);
      changed = true;
    }
  }
  return changed;
}

defineSeed(291, 1, makeCastMap([Q$Iterable, Q$AbstractCollection, Q$Collection]));
_.remove_0 = function remove_2(o){
  return $remove_2(this, o);
}
;
defineSeed(290, 291, makeCastMap([Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$Collection, Q$List]));
_.set_0 = function set_0(index, o){
  throw new UnsupportedOperationException_1('Set not supported on this list');
}
;
_.subList = function subList(fromIndex, toIndex){
  return new AbstractList$SubList_0(this, fromIndex, toIndex);
}
;
function ArrayList_2(c){
  $$init(this);
  spliceArray(this.array, 0, 0, c.toArray());
  this.size_0 = this.array.length;
}

defineSeed(289, 290, makeCastMap([Q$Serializable, Q$Cloneable, Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$ArrayList, Q$Collection, Q$List, Q$RandomAccess]), ArrayList_2);
_.remove_0 = function remove_5(o){
  return $remove_4(this, o);
}
;
_.set_0 = function set_1(index, o){
  return $set(this, index, o);
}
;
function ChangeListenerCollection_0(){
  $$init(this);
}

defineSeed(288, 289, makeCastMap([Q$Serializable, Q$Cloneable, Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$ArrayList, Q$Collection, Q$List, Q$RandomAccess]), ChangeListenerCollection_0);
function deserialize_83(streamReader, instance){
  deserialize_52(streamReader, instance);
}

function instantiate_80(streamReader){
  return new ChangeListenerCollection_0;
}

function ClickListenerCollection_0(){
  $$init(this);
}

defineSeed(293, 289, makeCastMap([Q$Serializable, Q$Cloneable, Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$ArrayList, Q$Collection, Q$List, Q$RandomAccess]), ClickListenerCollection_0);
function deserialize_84(streamReader, instance){
  deserialize_52(streamReader, instance);
}

function instantiate_81(streamReader){
  return new ClickListenerCollection_0;
}

function FocusListenerCollection_0(){
  $$init(this);
}

defineSeed(296, 289, makeCastMap([Q$Serializable, Q$Cloneable, Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$ArrayList, Q$Collection, Q$List, Q$RandomAccess]), FocusListenerCollection_0);
function deserialize_85(streamReader, instance){
  deserialize_52(streamReader, instance);
}

function instantiate_82(streamReader){
  return new FocusListenerCollection_0;
}

function $setHorizontalAlignment(this$static, align){
  this$static.autoHorizontalAlignment = align;
  $updateHorizontalAlignment(this$static);
}

function $setText(this$static, text){
  $setTextOrHtml(this$static.directionalTextHelper, text, false);
  $updateHorizontalAlignment(this$static);
}

function KeyboardListenerCollection_0(){
  $$init(this);
}

defineSeed(303, 289, makeCastMap([Q$Serializable, Q$Cloneable, Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$ArrayList, Q$Collection, Q$List, Q$RandomAccess]), KeyboardListenerCollection_0);
function deserialize_86(streamReader, instance){
  deserialize_52(streamReader, instance);
}

function instantiate_83(streamReader){
  return new KeyboardListenerCollection_0;
}

function $clinit_PotentialElement(){
  $clinit_PotentialElement = nullMethod;
  declareShim();
}

function declareShim(){
  var shim = function(){
  }
  ;
  shim.prototype = {className:'', clientHeight:0, clientWidth:0, dir:'', getAttribute:function(name_0, value){
    return this[name_0];
  }
  , href:'', id:'', lang:'', nodeType:1, removeAttribute:function(name_0, value){
    this[name_0] = undefined;
  }
  , setAttribute:function(name_0, value){
    this[name_0] = value;
  }
  , src:'', style:{}, title:''};
  $wnd.GwtPotentialElementShim = shim;
}

function RootPanel_0(elem){
  this.children_0 = new WidgetCollection_0(this);
  this.element = elem;
  $onAttach(this);
}

function detachNow(widget){
  $clinit_RootPanel();
  try {
    $onDetach(widget);
  }
   finally {
    $remove_10(widgetsToDetach, widget);
  }
}

function detachWidgets(){
  $clinit_RootPanel();
  try {
    tryCommand(widgetsToDetach, maybeDetachCommand);
  }
   finally {
    widgetsToDetach.map.clear_0();
    rootPanels.clear_0();
  }
}

function get_1(id){
  $clinit_RootPanel();
  var elem, rp;
  rp = dynamicCast(rootPanels.get_2(id), Q$RootPanel);
  elem = null;
  if (id != null) {
    if (!(elem = $getElementById($doc, id))) {
      return null;
    }
  }
  if (rp) {
    if (!elem || rp.element == elem) {
      return rp;
    }
  }
  if (rootPanels.size_1() == 0) {
    addCloseHandler(new RootPanel$2_0);
    ($clinit_LocaleInfo() , false) && setDirectionOnElement($doc, ($clinit_HasDirection$Direction() , RTL));
  }
  !elem?(rp = new RootPanel$DefaultRootPanel_0):(rp = new RootPanel_0(elem));
  rootPanels.put(id, rp);
  $add_6(widgetsToDetach, rp);
  return rp;
}

defineSeed(306, 280, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$RootPanel, Q$UIObject, Q$Widget, Q$Iterable]), RootPanel_0);
defineSeed(307, 1, {});
_.execute_0 = function execute_4(w){
  w.attached && $onDetach(w);
}
;
function RootPanel$2_0(){
}

defineSeed(308, 1, makeCastMap([Q$CloseHandler, Q$EventHandler]), RootPanel$2_0);
_.onClose = function onClose_0(closeEvent){
  detachWidgets();
}
;
function RootPanel$DefaultRootPanel_0(){
  RootPanel_0.call(this, getBodyElement());
}

defineSeed(309, 306, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$RootPanel, Q$UIObject, Q$Widget, Q$Iterable]), RootPanel$DefaultRootPanel_0);
function $add_4(this$static, w){
  $insert(this$static, w, this$static.size_0);
}

function $indexOf_1(this$static, w){
  var i;
  for (i = 0; i < this$static.size_0; ++i) {
    if (this$static.array[i] == w) {
      return i;
    }
  }
  return -1;
}

function $insert(this$static, w, beforeIndex){
  var i, newArray;
  if (beforeIndex < 0 || beforeIndex > this$static.size_0) {
    throw new IndexOutOfBoundsException_0;
  }
  if (this$static.size_0 == this$static.array.length) {
    newArray = initDim(_3Lcom_google_gwt_user_client_ui_Widget_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Widget, this$static.array.length * 2, 0);
    for (i = 0; i < this$static.array.length; ++i) {
      setCheck(newArray, i, this$static.array[i]);
    }
    this$static.array = newArray;
  }
  ++this$static.size_0;
  for (i = this$static.size_0 - 1; i > beforeIndex; --i) {
    setCheck(this$static.array, i, this$static.array[i - 1]);
  }
  setCheck(this$static.array, beforeIndex, w);
}

function $remove_5(this$static, index){
  var i;
  if (index < 0 || index >= this$static.size_0) {
    throw new IndexOutOfBoundsException_0;
  }
  --this$static.size_0;
  for (i = index; i < this$static.size_0; ++i) {
    setCheck(this$static.array, i, this$static.array[i + 1]);
  }
  setCheck(this$static.array, this$static.size_0, null);
}

function $remove_6(this$static, w){
  var index;
  index = $indexOf_1(this$static, w);
  if (index == -1) {
    throw new NoSuchElementException_0;
  }
  $remove_5(this$static, index);
}

function WidgetCollection_0(parent_0){
  this.parent_0 = parent_0;
  this.array = initDim(_3Lcom_google_gwt_user_client_ui_Widget_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Widget, 4, 0);
}

defineSeed(310, 1, makeCastMap([Q$Iterable]), WidgetCollection_0);
_.iterator = function iterator_3(){
  return new WidgetCollection$WidgetIterator_0(this);
}
;
_.array = null;
_.parent_0 = null;
_.size_0 = 0;
function $next(this$static){
  if (this$static.index_0 >= this$static.this$0.size_0) {
    throw new NoSuchElementException_0;
  }
  return this$static.this$0.array[++this$static.index_0];
}

function WidgetCollection$WidgetIterator_0(this$0){
  this.this$0 = this$0;
}

defineSeed(311, 1, {}, WidgetCollection$WidgetIterator_0);
_.hasNext = function hasNext(){
  return this.index_0 < this.this$0.size_0 - 1;
}
;
_.next_0 = function next_0(){
  return $next(this);
}
;
_.remove_2 = function remove_6(){
  if (this.index_0 < 0 || this.index_0 >= this.this$0.size_0) {
    throw new IllegalStateException_0;
  }
  this.this$0.parent_0.remove(this.this$0.array[this.index_0--]);
}
;
_.index_0 = -1;
_.this$0 = null;
function $clinit_CalendarUtil(){
  $clinit_CalendarUtil = nullMethod;
  $getDateTimeFormatInfo(($clinit_LocaleInfo() , $clinit_LocaleInfo() , instance_0));
}

function addDaysToDate(date, days){
  $clinit_CalendarUtil();
  date.setDate_0(date.getDate_0() + days);
}

function copyDate(date){
  var newDate;
  if (!date) {
    return null;
  }
  newDate = new Date_1;
  newDate.setTime_0(date.getTime_0());
  return newDate;
}

function getDaysBetween(start, finish){
  $clinit_CalendarUtil();
  var aTime, adjust, bTime;
  start = copyDate(start);
  resetTime(start);
  finish = copyDate(finish);
  resetTime(finish);
  aTime = start.getTime_0();
  bTime = finish.getTime_0();
  adjust = P36ee80_longLit;
  adjust = gt(bTime, aTime)?adjust:neg(adjust);
  return toInt(div(add(sub(bTime, aTime), adjust), P5265c00_longLit));
}

function resetTime(date){
  var msec;
  msec = date.getTime_0();
  msec = mul(div(msec, P3e8_longLit), P3e8_longLit);
  date.setTime_0(msec);
  date.setHours_0(12);
  date.setMinutes_0(0);
  date.setSeconds_0(0);
}

function $removeHandler(this$static){
  $doRemove(this$static.this$0, this$static.val$type, this$static.val$source, this$static.val$handler);
}

function SimpleEventBus$3_0(this$0, val$type, val$source, val$handler){
  this.this$0 = this$0;
  this.val$type = val$type;
  this.val$source = val$source;
  this.val$handler = val$handler;
}

defineSeed(321, 1, makeCastMap([Q$SimpleEventBus$Command]), SimpleEventBus$3_0);
_.execute_1 = function execute_6(){
  $doRemoveNow(this.this$0, this.val$type, this.val$source, this.val$handler);
}
;
_.this$0 = null;
_.val$handler = null;
_.val$source = null;
_.val$type = null;
function $getAttributeAsJavaScriptObject(this$static, property){
  var ret;
  if (this$static.isCreated()) {
    var widget = this$static.getJsObj();
    ret = widget.getProperty(property);
  }
   else {
    var config = this$static.config;
    if (config[property] != undefined) {
      ret = config[property];
    }
     else {
      var scClassName = this$static.scClassName;
      ret = eval('($wnd.isc.' + scClassName + ".getInstanceProperty('" + property + "'))");
    }
  }
  return ret === undefined?null:ret;
}

function $setAttribute(this$static, value){
  var self_0;
  $isCreated(this$static)?$isCreated(this$static)?($getJsObj(this$static)['root'] = value , undefined):(self_0 = this$static.getJsObj() , self_0.setProperty('root', value) , undefined):(this$static.config['root'] = value , undefined);
}

function $setAttribute_0(this$static, attribute, value, allowPostCreate){
  $isCreated_0(this$static)?allowPostCreate?$setProperty(this$static, attribute, value.value_0):undefined:setAttribute_5(this$static.config, attribute, value);
}

function $setAttribute_1(this$static, attribute, value){
  $isCreated_0(this$static)?undefined:(this$static.config[attribute] = value , undefined);
}

function $setProperty(this$static, property, value){
  var self_0 = this$static.getJsObj();
  self_0.setProperty(property, value);
}

defineSeed(327, 1, makeCastMap([Q$JsObject]));
_.setJsObj = function setJsObj(jsObj){
  this.jsObj = jsObj;
}
;
function $getAttributeAsBoolean_0(this$static, property){
  return $clinit_Boolean() , getAttributeAsBoolean(this$static.jsObj, property)?TRUE:FALSE;
}

function $getAttributeAsDouble(this$static, property){
  return getAttributeAsDouble(this$static.jsObj, property);
}

function $getAttributeAsJavaScriptObject_0(this$static, property){
  return getAttributeAsJavaScriptObject(this$static.jsObj, property);
}

function $setAttribute_6(this$static, value){
  this$static.jsObj['optionDataSource'] = !value?null:$getOrCreateJsObj(value);
}

function $setAttribute_9(this$static, property, value){
  setAttribute_6(this$static.jsObj, property, value);
}

function $setAttribute_10(this$static, property, value){
  setAttribute_7(this$static.jsObj, property, value);
}

function $setAttribute_15(this$static, property, value){
  setAttribute_10(this$static.jsObj, property, value);
}

function $setAttribute_17(this$static, property, value){
  this$static.jsObj[property] = convertToJavaScriptArray(value);
}

function Criteria_0(){
  DataClass_0.call(this);
}

function Criteria_2(field, value){
  Criteria_0.call(this);
  this.jsObj[field] = value;
}

defineSeed(332, 326, makeCastMap([Q$DataClass, Q$JsObject]), Criteria_0, Criteria_2);
function $getCriteria(this$static){
  if (dynamicCast(getEnum(($clinit_DSOperationType() , $clinit_DSOperationType() , $VALUES_9), getAttribute(this$static.jsObj, 'operationType')), Q$DSOperationType) == FETCH) {
    return !getAttributeAsJavaScriptObject(this$static.jsObj, 'data')?null:new Criteria_1(getAttributeAsJavaScriptObject(this$static.jsObj, 'data'));
  }
   else {
    throw new IllegalStateException_1('This method should only be called during FETCH operations');
  }
}

function $getSortBy(this$static){
  var self_0 = this$static.getJsObj();
  var sortBy = self_0.sortBy;
  if (sortBy == null || sortBy === undefined)
    return null;
  $wnd.isc.isA.Array(sortBy) && (sortBy = sortBy.join(','));
  return convertToArray(sortBy);
}

function $setAttribute_18(this$static, value){
  !value?(this$static.jsObj['parameters'] = null , undefined):(this$static.jsObj['parameters'] = value , undefined);
}

function $setEndRow(this$static, endRow){
  setAttribute_8(this$static.jsObj, 'endRow', endRow);
}

function $setStartRow(this$static, startRow){
  setAttribute_8(this$static.jsObj, 'startRow', startRow);
}

function DSRequest_0(){
  DataClass_0.call(this);
}

defineSeed(333, 334, makeCastMap([Q$DataClass, Q$JsObject]), DSRequest_0);
function $getData(this$static){
  var dataJS;
  dataJS = getAttributeAsJavaScriptObject(this$static.jsObj, 'data');
  return convertToRecordArray(dataJS);
}

function $getErrors(this$static){
  var jsObj, result;
  jsObj = getAttributeAsJavaScriptObject(this$static.jsObj, 'errors');
  isArray(jsObj) && (jsObj = (result = jsObj[0] , result == null || result === undefined?null:result));
  return convertToMap(jsObj);
}

function $setTotalRows(this$static, totalRows){
  setAttribute_8(this$static.jsObj, 'totalRows', totalRows);
}

function DSResponse_0(){
  DataClass_0.call(this);
}

defineSeed(335, 336, makeCastMap([Q$DataClass, Q$JsObject]), DSResponse_0);
function $fetchData(this$static, criteria, callback){
  var self_0 = this$static.getOrCreateJsObj();
  var critJS = criteria == null?null:criteria.getJsObj();
  self_0.fetchData(critJS, $entry(function(dsResponse, data, dsRequest){
    var responseJ = new DSResponse_1(dsResponse);
    var requestJ = new DSRequest_1(dsRequest);
    callback != null && callback.execute_2(responseJ, data, requestJ);
  }
  ));
}

function $fetchData_0(this$static, criteria, callback, requestProperties){
  var self_0 = this$static.getOrCreateJsObj();
  var critJS = criteria == null?null:criteria.getJsObj();
  var requestPropertiesJS = requestProperties == null?null:requestProperties.getJsObj();
  self_0.fetchData(critJS, $entry(function(dsResponse, data, dsRequest){
    var responseJ = new DSResponse_1(dsResponse);
    var requestJ = new DSRequest_1(dsRequest);
    callback != null && callback.execute_2(responseJ, data, requestJ);
  }
  ), requestPropertiesJS);
}

function $getField(this$static, fieldName){
  var self_0 = this$static.getOrCreateJsObj();
  var ret = self_0.getField(fieldName);
  if (ret == null || ret === undefined)
    return null;
  return new DataSourceField_0(ret);
}

function $getFieldNames(this$static, excludeHidden){
  var self_0 = this$static.getOrCreateJsObj();
  var value = self_0.getFieldNames(excludeHidden);
  if (value == null)
    return null;
  !isArray(value) && (value = [value]);
  return convertToJavaStringArray(value);
}

function $processResponse(this$static, requestId, responseProperties){
  var self_0 = this$static.getOrCreateJsObj();
  var responsePropertiesJS = responseProperties == null?null:responseProperties.getJsObj();
  self_0.processResponse(requestId, responsePropertiesJS);
}

function $setCacheAllData(this$static, cacheAllData){
  $isCreated_0(this$static)?$setProperty(this$static, 'cacheAllData', cacheAllData.value_0):setAttribute_5(this$static.config, 'cacheAllData', cacheAllData);
}

function $setCanMultiSort(this$static, canMultiSort){
  $isCreated_0(this$static)?undefined:setAttribute_5(this$static.config, 'canMultiSort', canMultiSort);
}

function $setDropExtraFields(this$static, dropExtraFields){
  $isCreated_0(this$static)?undefined:setAttribute_5(this$static.config, 'dropExtraFields', dropExtraFields);
}

function DataSourceField_0(jsObj){
  this.jsObj = jsObj;
}

function DataSourceField_1(name_0, type){
  DataClass_0.call(this);
  this.jsObj['name'] = name_0;
  $setAttribute_13(this, 'type', type.value_0);
}

function DataSourceField_3(name_0, type, title, length_0){
  DataClass_0.call(this);
  this.jsObj['name'] = name_0;
  $setAttribute_13(this, 'type', type.value_0);
  this.jsObj['title'] = title;
  $setAttribute_11(this, 'length', valueOf_44(length_0));
}

function DataSourceField_4(name_0, type, title, length_0){
  DataClass_0.call(this);
  this.jsObj['name'] = name_0;
  $setAttribute_13(this, 'type', type.value_0);
  this.jsObj['title'] = title;
  $setAttribute_11(this, 'length', valueOf_44(length_0));
  $setAttribute_8(this, 'required', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
}

function getOrCreateRef_0(jsObj){
  if (!jsObj)
    return null;
  return new DataSourceField_0(jsObj);
}

defineSeed(338, 326, makeCastMap([Q$DataClass, Q$JsObject, Q$DataSourceField]), DataSourceField_0);
function $getEndDate(this$static){
  if (this$static.endDate)
    return this$static.endDate;
  if (this$static.relativeEndDate)
    return getAbsoluteDate_0(this$static.relativeEndDate);
  return null;
}

function $getStartDate(this$static){
  if (this$static.startDate)
    return this$static.startDate;
  if (this$static.relativeStartDate)
    return getAbsoluteDate_0(this$static.relativeStartDate);
  return null;
}

function $isEmpty_0(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.isEmpty();
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

defineSeed(342, 326, makeCastMap([Q$DataClass, Q$JsObject, Q$RelativeDate]));
_.getValue_0 = function getValue(){
  return this.value_0;
}
;
function convertToArray(sortByString){
  var i, sortDirection, sortField, sortFields, sortSpecifiers;
  if (sortByString == null) {
    return initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, []);
  }
  sortFields = $split(sortByString, ',', 0);
  sortSpecifiers = initDim(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, sortFields.length, 0);
  for (i = 0; i < sortFields.length; ++i) {
    sortField = sortFields[i];
    sortDirection = ($clinit_SortDirection() , ASCENDING);
    if (sortField.indexOf('-') == 0) {
      sortDirection = DESCENDING;
      sortField = $substring_0(sortField, 1, sortField.length);
    }
    sortSpecifiers[i] = new SortSpecifier_0(sortField, sortDirection);
  }
  return sortSpecifiers;
}

function DataSourceBooleanField_0(name_0){
  DataSourceField_1.call(this, name_0, ($clinit_FieldType() , BOOLEAN_0));
}

defineSeed(345, 338, makeCastMap([Q$DataClass, Q$JsObject, Q$DataSourceField]), DataSourceBooleanField_0);
function DataSourceDateTimeField_0(name_0, title){
  DataSourceField_2.call(this, name_0, ($clinit_FieldType() , DATETIME), title);
}

defineSeed(346, 338, makeCastMap([Q$DataClass, Q$JsObject, Q$DataSourceField]), DataSourceDateTimeField_0);
function DataSourceImageField_0(){
  DataSourceField_1.call(this, 'category', ($clinit_FieldType() , IMAGE));
}

function DataSourceImageField_1(name_0, title){
  DataSourceField_2.call(this, name_0, ($clinit_FieldType() , IMAGE), title);
}

function DataSourceImageField_2(name_0, title){
  DataSourceField_3.call(this, name_0, ($clinit_FieldType() , IMAGE), title, 20);
}

defineSeed(347, 338, makeCastMap([Q$DataClass, Q$JsObject, Q$DataSourceField]), DataSourceImageField_0, DataSourceImageField_1, DataSourceImageField_2);
function DataSourceIntegerField_0(){
  DataSourceField_1.call(this, 'count', ($clinit_FieldType() , INTEGER));
}

function DataSourceIntegerField_1(name_0, title){
  DataSourceField_2.call(this, name_0, ($clinit_FieldType() , INTEGER), title);
}

function DataSourceIntegerField_2(name_0, title, length_0){
  DataSourceField_3.call(this, name_0, ($clinit_FieldType() , INTEGER), title, length_0);
}

defineSeed(348, 338, makeCastMap([Q$DataClass, Q$JsObject, Q$DataSourceField]), DataSourceIntegerField_0, DataSourceIntegerField_1, DataSourceIntegerField_2);
function DataSourceLinkField_0(){
  DataSourceField_1.call(this, 'typeName', ($clinit_FieldType() , LINK));
}

function DataSourceLinkField_1(){
  DataSourceField_2.call(this, 'parent', ($clinit_FieldType() , LINK), 'Parent');
}

defineSeed(349, 338, makeCastMap([Q$DataClass, Q$JsObject, Q$DataSourceField]), DataSourceLinkField_0, DataSourceLinkField_1);
function DataSourcePasswordField_0(name_0, title){
  DataSourceField_4.call(this, name_0, ($clinit_FieldType() , PASSWORD), title, 100);
}

defineSeed(350, 338, makeCastMap([Q$DataClass, Q$JsObject, Q$DataSourceField]), DataSourcePasswordField_0);
function DataSourceTextField_0(name_0){
  DataSourceField_1.call(this, name_0, ($clinit_FieldType() , TEXT));
}

function DataSourceTextField_2(name_0, title, length_0){
  DataSourceField_3.call(this, name_0, ($clinit_FieldType() , TEXT), title, length_0);
}

function DataSourceTextField_3(name_0, title, length_0){
  DataSourceField_4.call(this, name_0, ($clinit_FieldType() , TEXT), title, length_0);
}

defineSeed(351, 338, makeCastMap([Q$DataClass, Q$JsObject, Q$DataSourceField]), DataSourceTextField_0, DataSourceTextField_2, DataSourceTextField_3);
function $clinit_AnimationEffect(){
  $clinit_AnimationEffect = nullMethod;
  SLIDE = new AnimationEffect_0('SLIDE', 0, 'slide');
  WIPE = new AnimationEffect_0('WIPE', 1, 'wipe');
  FADE = new AnimationEffect_0('FADE', 2, 'fade');
  FLY = new AnimationEffect_0('FLY', 3, 'fly');
  $VALUES_4 = initValues(_3Lcom_smartgwt_client_types_AnimationEffect_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$AnimationEffect, [SLIDE, WIPE, FADE, FLY]);
}

function AnimationEffect_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_6(name_0){
  $clinit_AnimationEffect();
  return valueOf(($clinit_AnimationEffect$Map() , $MAP_4), name_0);
}

function values_5(){
  $clinit_AnimationEffect();
  return $VALUES_4;
}

defineSeed(356, 48, makeCastMap([Q$AnimationEffect, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), AnimationEffect_0);
_.getValue_0 = function getValue_1(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_4, FADE, FLY, SLIDE, WIPE;
function $clinit_AnimationEffect$Map(){
  $clinit_AnimationEffect$Map = nullMethod;
  $MAP_4 = createValueOfMap(($clinit_AnimationEffect() , $VALUES_4));
}

var $MAP_4;
function $clinit_AutoFitWidthApproach(){
  $clinit_AutoFitWidthApproach = nullMethod;
  VALUE = new AutoFitWidthApproach_0('VALUE', 0, 'value');
  TITLE = new AutoFitWidthApproach_0('TITLE', 1, 'title');
  BOTH = new AutoFitWidthApproach_0('BOTH', 2, 'both');
  $VALUES_5 = initValues(_3Lcom_smartgwt_client_types_AutoFitWidthApproach_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$AutoFitWidthApproach, [VALUE, TITLE, BOTH]);
}

function AutoFitWidthApproach_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_7(name_0){
  $clinit_AutoFitWidthApproach();
  return valueOf(($clinit_AutoFitWidthApproach$Map() , $MAP_5), name_0);
}

function values_6(){
  $clinit_AutoFitWidthApproach();
  return $VALUES_5;
}

defineSeed(358, 48, makeCastMap([Q$AutoFitWidthApproach, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), AutoFitWidthApproach_0);
_.getValue_0 = function getValue_2(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_5, BOTH, TITLE, VALUE;
function $clinit_AutoFitWidthApproach$Map(){
  $clinit_AutoFitWidthApproach$Map = nullMethod;
  $MAP_5 = createValueOfMap(($clinit_AutoFitWidthApproach() , $VALUES_5));
}

var $MAP_5;
function $clinit_Autofit(){
  $clinit_Autofit = nullMethod;
  VERTICAL = new Autofit_0('VERTICAL', 0, 'vertical');
  HORIZONTAL = new Autofit_0('HORIZONTAL', 1, 'horizontal');
  BOTH_0 = new Autofit_0('BOTH', 2, 'both');
  $VALUES_6 = initValues(_3Lcom_smartgwt_client_types_Autofit_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Autofit, [VERTICAL, HORIZONTAL, BOTH_0]);
}

function Autofit_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_8(name_0){
  $clinit_Autofit();
  return valueOf(($clinit_Autofit$Map() , $MAP_6), name_0);
}

function values_7(){
  $clinit_Autofit();
  return $VALUES_6;
}

defineSeed(360, 48, makeCastMap([Q$Autofit, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), Autofit_0);
_.getValue_0 = function getValue_3(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_6, BOTH_0, HORIZONTAL, VERTICAL;
function $clinit_Autofit$Map(){
  $clinit_Autofit$Map = nullMethod;
  $MAP_6 = createValueOfMap(($clinit_Autofit() , $VALUES_6));
}

var $MAP_6;
function $clinit_ContentsType(){
  $clinit_ContentsType = nullMethod;
  PAGE = new ContentsType_0('PAGE', 0, 'page');
  FRAGMENT = new ContentsType_0('FRAGMENT', 1, 'fragment');
  $VALUES_7 = initValues(_3Lcom_smartgwt_client_types_ContentsType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ContentsType, [PAGE, FRAGMENT]);
}

function ContentsType_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_9(name_0){
  $clinit_ContentsType();
  return valueOf(($clinit_ContentsType$Map() , $MAP_7), name_0);
}

function values_8(){
  $clinit_ContentsType();
  return $VALUES_7;
}

defineSeed(362, 48, makeCastMap([Q$ContentsType, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), ContentsType_0);
_.getValue_0 = function getValue_4(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_7, FRAGMENT, PAGE;
function $clinit_ContentsType$Map(){
  $clinit_ContentsType$Map = nullMethod;
  $MAP_7 = createValueOfMap(($clinit_ContentsType() , $VALUES_7));
}

var $MAP_7;
function $clinit_DSDataFormat(){
  $clinit_DSDataFormat = nullMethod;
  ISCSERVER = new DSDataFormat_0('ISCSERVER', 0, 'iscServer');
  XML = new DSDataFormat_0('XML', 1, 'xml');
  JSON = new DSDataFormat_0('JSON', 2, 'json');
  CUSTOM = new DSDataFormat_0('CUSTOM', 3, 'custom');
  $VALUES_8 = initValues(_3Lcom_smartgwt_client_types_DSDataFormat_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DSDataFormat, [ISCSERVER, XML, JSON, CUSTOM]);
}

function DSDataFormat_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_10(name_0){
  $clinit_DSDataFormat();
  return valueOf(($clinit_DSDataFormat$Map() , $MAP_8), name_0);
}

function values_9(){
  $clinit_DSDataFormat();
  return $VALUES_8;
}

defineSeed(364, 48, makeCastMap([Q$DSDataFormat, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), DSDataFormat_0);
_.getValue_0 = function getValue_5(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_8, CUSTOM, ISCSERVER, JSON, XML;
function $clinit_DSDataFormat$Map(){
  $clinit_DSDataFormat$Map = nullMethod;
  $MAP_8 = createValueOfMap(($clinit_DSDataFormat() , $VALUES_8));
}

var $MAP_8;
function $clinit_DSOperationType(){
  $clinit_DSOperationType = nullMethod;
  FETCH = new DSOperationType_0('FETCH', 0, 'fetch');
  ADD = new DSOperationType_0('ADD', 1, 'add');
  UPDATE = new DSOperationType_0('UPDATE', 2, 'update');
  REMOVE = new DSOperationType_0('REMOVE', 3, 'remove');
  VALIDATE = new DSOperationType_0('VALIDATE', 4, 'validate');
  CUSTOM_0 = new DSOperationType_0('CUSTOM', 5, 'custom');
  $VALUES_9 = initValues(_3Lcom_smartgwt_client_types_DSOperationType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DSOperationType, [FETCH, ADD, UPDATE, REMOVE, VALIDATE, CUSTOM_0]);
}

function DSOperationType_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_11(name_0){
  $clinit_DSOperationType();
  return valueOf(($clinit_DSOperationType$Map() , $MAP_9), name_0);
}

function values_10(){
  $clinit_DSOperationType();
  return $VALUES_9;
}

defineSeed(366, 48, makeCastMap([Q$DSOperationType, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), DSOperationType_0);
_.getValue_0 = function getValue_6(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_9, ADD, CUSTOM_0, FETCH, REMOVE, UPDATE, VALIDATE;
function $clinit_DSOperationType$Map(){
  $clinit_DSOperationType$Map = nullMethod;
  $MAP_9 = createValueOfMap(($clinit_DSOperationType() , $VALUES_9));
}

var $MAP_9;
function $clinit_DSProtocol(){
  $clinit_DSProtocol = nullMethod;
  GETPARAMS = new DSProtocol_0('GETPARAMS', 0, 'getParams');
  POSTPARAMS = new DSProtocol_0('POSTPARAMS', 1, 'postParams');
  POSTXML = new DSProtocol_0('POSTXML', 2, 'postXML');
  SOAP = new DSProtocol_0('SOAP', 3, 'soap');
  POSTMESSAGE = new DSProtocol_0('POSTMESSAGE', 4, 'postMessage');
  CLIENTCUSTOM = new DSProtocol_0('CLIENTCUSTOM', 5, 'clientCustom');
  $VALUES_10 = initValues(_3Lcom_smartgwt_client_types_DSProtocol_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DSProtocol, [GETPARAMS, POSTPARAMS, POSTXML, SOAP, POSTMESSAGE, CLIENTCUSTOM]);
}

function DSProtocol_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_12(name_0){
  $clinit_DSProtocol();
  return valueOf(($clinit_DSProtocol$Map() , $MAP_10), name_0);
}

function values_11(){
  $clinit_DSProtocol();
  return $VALUES_10;
}

defineSeed(368, 48, makeCastMap([Q$DSProtocol, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), DSProtocol_0);
_.getValue_0 = function getValue_7(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_10, CLIENTCUSTOM, GETPARAMS, POSTMESSAGE, POSTPARAMS, POSTXML, SOAP;
function $clinit_DSProtocol$Map(){
  $clinit_DSProtocol$Map = nullMethod;
  $MAP_10 = createValueOfMap(($clinit_DSProtocol() , $VALUES_10));
}

var $MAP_10;
function $clinit_DateDisplayFormat(){
  $clinit_DateDisplayFormat = nullMethod;
  TOSTRING = new DateDisplayFormat_0('TOSTRING', 0, 'toString');
  TOLOCALESTRING = new DateDisplayFormat_0('TOLOCALESTRING', 1, 'toLocaleString');
  TOUSSHORTDATE = new DateDisplayFormat_0('TOUSSHORTDATE', 2, 'toUSShortDate');
  TOUSSHORTDATETIME = new DateDisplayFormat_0('TOUSSHORTDATETIME', 3, 'toUSShortDatetime');
  TOEUROPEANSHORTDATE = new DateDisplayFormat_0('TOEUROPEANSHORTDATE', 4, 'toEuropeanShortDate');
  TOEUROPEANSHORTDATETIME = new DateDisplayFormat_0('TOEUROPEANSHORTDATETIME', 5, 'toEuropeanShortDatetime');
  TOJAPANSHORTDATE = new DateDisplayFormat_0('TOJAPANSHORTDATE', 6, 'toJapanShortDate');
  TOJAPANSHORTDATETIME = new DateDisplayFormat_0('TOJAPANSHORTDATETIME', 7, 'toJapanShortDatetime');
  TOSERIALIZEABLEDATE = new DateDisplayFormat_0('TOSERIALIZEABLEDATE', 8, 'toSerializeableDate');
  TODATESTAMP = new DateDisplayFormat_0('TODATESTAMP', 9, 'toDateStamp');
  $VALUES_11 = initValues(_3Lcom_smartgwt_client_types_DateDisplayFormat_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DateDisplayFormat, [TOSTRING, TOLOCALESTRING, TOUSSHORTDATE, TOUSSHORTDATETIME, TOEUROPEANSHORTDATE, TOEUROPEANSHORTDATETIME, TOJAPANSHORTDATE, TOJAPANSHORTDATETIME, TOSERIALIZEABLEDATE, TODATESTAMP]);
}

function DateDisplayFormat_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_13(name_0){
  $clinit_DateDisplayFormat();
  return valueOf(($clinit_DateDisplayFormat$Map() , $MAP_11), name_0);
}

function values_12(){
  $clinit_DateDisplayFormat();
  return $VALUES_11;
}

defineSeed(370, 48, makeCastMap([Q$DateDisplayFormat, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), DateDisplayFormat_0);
_.getValue_0 = function getValue_8(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_11, TODATESTAMP, TOEUROPEANSHORTDATE, TOEUROPEANSHORTDATETIME, TOJAPANSHORTDATE, TOJAPANSHORTDATETIME, TOLOCALESTRING, TOSERIALIZEABLEDATE, TOSTRING, TOUSSHORTDATE, TOUSSHORTDATETIME;
function $clinit_DateDisplayFormat$Map(){
  $clinit_DateDisplayFormat$Map = nullMethod;
  $MAP_11 = createValueOfMap(($clinit_DateDisplayFormat() , $VALUES_11));
}

var $MAP_11;
function $clinit_DragAppearance(){
  $clinit_DragAppearance = nullMethod;
  NONE = new DragAppearance_0('NONE', 0, 'none');
  TRACKER = new DragAppearance_0('TRACKER', 1, 'tracker');
  TARGET = new DragAppearance_0('TARGET', 2, 'target');
  OUTLINE = new DragAppearance_0('OUTLINE', 3, 'outline');
  $VALUES_12 = initValues(_3Lcom_smartgwt_client_types_DragAppearance_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DragAppearance, [NONE, TRACKER, TARGET, OUTLINE]);
}

function DragAppearance_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_14(name_0){
  $clinit_DragAppearance();
  return valueOf(($clinit_DragAppearance$Map() , $MAP_12), name_0);
}

function values_13(){
  $clinit_DragAppearance();
  return $VALUES_12;
}

defineSeed(372, 48, makeCastMap([Q$DragAppearance, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), DragAppearance_0);
_.getValue_0 = function getValue_9(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_12, NONE, OUTLINE, TARGET, TRACKER;
function $clinit_DragAppearance$Map(){
  $clinit_DragAppearance$Map = nullMethod;
  $MAP_12 = createValueOfMap(($clinit_DragAppearance() , $VALUES_12));
}

var $MAP_12;
function $clinit_DragDataAction(){
  $clinit_DragDataAction = nullMethod;
  NONE_0 = new DragDataAction_0('NONE', 0, 'none');
  COPY = new DragDataAction_0('COPY', 1, 'copy');
  MOVE = new DragDataAction_0('MOVE', 2, 'move');
  $VALUES_13 = initValues(_3Lcom_smartgwt_client_types_DragDataAction_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DragDataAction, [NONE_0, COPY, MOVE]);
}

function DragDataAction_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_15(name_0){
  $clinit_DragDataAction();
  return valueOf(($clinit_DragDataAction$Map() , $MAP_13), name_0);
}

function values_14(){
  $clinit_DragDataAction();
  return $VALUES_13;
}

defineSeed(374, 48, makeCastMap([Q$DragDataAction, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), DragDataAction_0);
_.getValue_0 = function getValue_10(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_13, COPY, MOVE, NONE_0;
function $clinit_DragDataAction$Map(){
  $clinit_DragDataAction$Map = nullMethod;
  $MAP_13 = createValueOfMap(($clinit_DragDataAction() , $VALUES_13));
}

var $MAP_13;
function $clinit_DragTrackerMode(){
  $clinit_DragTrackerMode = nullMethod;
  NONE_1 = new DragTrackerMode_0('NONE', 0, 'none');
  ICON = new DragTrackerMode_0('ICON', 1, 'icon');
  TITLE_0 = new DragTrackerMode_0('TITLE', 2, 'title');
  RECORD = new DragTrackerMode_0('RECORD', 3, 'record');
  $VALUES_14 = initValues(_3Lcom_smartgwt_client_types_DragTrackerMode_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DragTrackerMode, [NONE_1, ICON, TITLE_0, RECORD]);
}

function DragTrackerMode_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_16(name_0){
  $clinit_DragTrackerMode();
  return valueOf(($clinit_DragTrackerMode$Map() , $MAP_14), name_0);
}

function values_15(){
  $clinit_DragTrackerMode();
  return $VALUES_14;
}

defineSeed(376, 48, makeCastMap([Q$DragTrackerMode, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), DragTrackerMode_0);
_.getValue_0 = function getValue_11(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_14, ICON, NONE_1, RECORD, TITLE_0;
function $clinit_DragTrackerMode$Map(){
  $clinit_DragTrackerMode$Map = nullMethod;
  $MAP_14 = createValueOfMap(($clinit_DragTrackerMode() , $VALUES_14));
}

var $MAP_14;
function $clinit_EmbeddedPosition(){
  $clinit_EmbeddedPosition = nullMethod;
  EXPAND = new EmbeddedPosition_0('EXPAND', 0, 'expand');
  WITHIN = new EmbeddedPosition_0('WITHIN', 1, 'within');
  $VALUES_15 = initValues(_3Lcom_smartgwt_client_types_EmbeddedPosition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$EmbeddedPosition, [EXPAND, WITHIN]);
}

function EmbeddedPosition_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_17(name_0){
  $clinit_EmbeddedPosition();
  return valueOf(($clinit_EmbeddedPosition$Map() , $MAP_15), name_0);
}

function values_16(){
  $clinit_EmbeddedPosition();
  return $VALUES_15;
}

defineSeed(378, 48, makeCastMap([Q$EmbeddedPosition, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), EmbeddedPosition_0);
_.getValue_0 = function getValue_12(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_15, EXPAND, WITHIN;
function $clinit_EmbeddedPosition$Map(){
  $clinit_EmbeddedPosition$Map = nullMethod;
  $MAP_15 = createValueOfMap(($clinit_EmbeddedPosition() , $VALUES_15));
}

var $MAP_15;
function $clinit_Encoding(){
  $clinit_Encoding = nullMethod;
  NORMAL = new Encoding_0('NORMAL', 0, 'normal');
  MULTIPART = new Encoding_0('MULTIPART', 1, 'multipart');
  $VALUES_16 = initValues(_3Lcom_smartgwt_client_types_Encoding_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Encoding, [NORMAL, MULTIPART]);
}

function Encoding_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_18(name_0){
  $clinit_Encoding();
  return valueOf(($clinit_Encoding$Map() , $MAP_16), name_0);
}

function values_17(){
  $clinit_Encoding();
  return $VALUES_16;
}

defineSeed(380, 48, makeCastMap([Q$Encoding, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), Encoding_0);
_.getValue_0 = function getValue_13(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_16, MULTIPART, NORMAL;
function $clinit_Encoding$Map(){
  $clinit_Encoding$Map = nullMethod;
  $MAP_16 = createValueOfMap(($clinit_Encoding() , $VALUES_16));
}

var $MAP_16;
function $clinit_ExpansionMode(){
  $clinit_ExpansionMode = nullMethod;
  DETAIL_FIELD = new ExpansionMode_0('DETAIL_FIELD', 0, 'detailField');
  DETAILS = new ExpansionMode_0('DETAILS', 1, 'details');
  RELATED = new ExpansionMode_0('RELATED', 2, 'related');
  EDITOR = new ExpansionMode_0('EDITOR', 3, 'editor');
  DETAIL_RELATED = new ExpansionMode_0('DETAIL_RELATED', 4, 'detailRelated');
  $VALUES_17 = initValues(_3Lcom_smartgwt_client_types_ExpansionMode_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ExpansionMode, [DETAIL_FIELD, DETAILS, RELATED, EDITOR, DETAIL_RELATED]);
}

function ExpansionMode_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_19(name_0){
  $clinit_ExpansionMode();
  return valueOf(($clinit_ExpansionMode$Map() , $MAP_17), name_0);
}

function values_18(){
  $clinit_ExpansionMode();
  return $VALUES_17;
}

defineSeed(382, 48, makeCastMap([Q$ExpansionMode, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), ExpansionMode_0);
_.getValue_0 = function getValue_14(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_17, DETAILS, DETAIL_FIELD, DETAIL_RELATED, EDITOR, RELATED;
function $clinit_ExpansionMode$Map(){
  $clinit_ExpansionMode$Map = nullMethod;
  $MAP_17 = createValueOfMap(($clinit_ExpansionMode() , $VALUES_17));
}

var $MAP_17;
function $clinit_HeaderControls(){
  $clinit_HeaderControls = nullMethod;
  HEADER_ICON = new HeaderControls_0('HEADER_ICON', 0, 'headerIcon');
  HEADER_LABEL = new HeaderControls_0('HEADER_LABEL', 1, 'headerLabel');
  MINIMIZE_BUTTON = new HeaderControls_0('MINIMIZE_BUTTON', 2, 'minimizeButton');
  MAXIMIZE_BUTTON = new HeaderControls_0('MAXIMIZE_BUTTON', 3, 'maximizeButton');
  CLOSE_BUTTON = new HeaderControls_0('CLOSE_BUTTON', 4, 'closeButton');
  $VALUES_20 = initValues(_3Lcom_smartgwt_client_types_HeaderControls_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$HeaderControls, [HEADER_ICON, HEADER_LABEL, MINIMIZE_BUTTON, MAXIMIZE_BUTTON, CLOSE_BUTTON]);
}

function HeaderControls_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_22(name_0){
  $clinit_HeaderControls();
  return valueOf(($clinit_HeaderControls$Map() , $MAP_20), name_0);
}

function values_21(){
  $clinit_HeaderControls();
  return $VALUES_20;
}

defineSeed(388, 48, makeCastMap([Q$HeaderControls, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), HeaderControls_0);
_.getValue_0 = function getValue_17(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_20, CLOSE_BUTTON, HEADER_ICON, HEADER_LABEL, MAXIMIZE_BUTTON, MINIMIZE_BUTTON;
function $clinit_HeaderControls$Map(){
  $clinit_HeaderControls$Map = nullMethod;
  $MAP_20 = createValueOfMap(($clinit_HeaderControls() , $VALUES_20));
}

var $MAP_20;
function $clinit_ImageStyle(){
  $clinit_ImageStyle = nullMethod;
  CENTER_1 = new ImageStyle_0('CENTER', 0, 'center');
  TILE = new ImageStyle_0('TILE', 1, 'tile');
  STRETCH = new ImageStyle_0('STRETCH', 2, 'stretch');
  NORMAL_0 = new ImageStyle_0('NORMAL', 3, 'normal');
  $VALUES_21 = initValues(_3Lcom_smartgwt_client_types_ImageStyle_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ImageStyle, [CENTER_1, TILE, STRETCH, NORMAL_0]);
}

function ImageStyle_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_23(name_0){
  $clinit_ImageStyle();
  return valueOf(($clinit_ImageStyle$Map() , $MAP_21), name_0);
}

function values_22(){
  $clinit_ImageStyle();
  return $VALUES_21;
}

defineSeed(390, 48, makeCastMap([Q$ImageStyle, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), ImageStyle_0);
_.getValue_0 = function getValue_18(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_21, CENTER_1, NORMAL_0, STRETCH, TILE;
function $clinit_ImageStyle$Map(){
  $clinit_ImageStyle$Map = nullMethod;
  $MAP_21 = createValueOfMap(($clinit_ImageStyle() , $VALUES_21));
}

var $MAP_21;
function $clinit_LayoutPolicy(){
  $clinit_LayoutPolicy = nullMethod;
  NONE_2 = new LayoutPolicy_0('NONE', 0, 'none');
  FILL = new LayoutPolicy_0('FILL', 1, 'fill');
  $VALUES_22 = initValues(_3Lcom_smartgwt_client_types_LayoutPolicy_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$LayoutPolicy, [NONE_2, FILL]);
}

function LayoutPolicy_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_24(name_0){
  $clinit_LayoutPolicy();
  return valueOf(($clinit_LayoutPolicy$Map() , $MAP_22), name_0);
}

function values_23(){
  $clinit_LayoutPolicy();
  return $VALUES_22;
}

defineSeed(392, 48, makeCastMap([Q$LayoutPolicy, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), LayoutPolicy_0);
_.getValue_0 = function getValue_19(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_22, FILL, NONE_2;
function $clinit_LayoutPolicy$Map(){
  $clinit_LayoutPolicy$Map = nullMethod;
  $MAP_22 = createValueOfMap(($clinit_LayoutPolicy() , $VALUES_22));
}

var $MAP_22;
function $clinit_ListGridEditEvent(){
  $clinit_ListGridEditEvent = nullMethod;
  CLICK = new ListGridEditEvent_0('CLICK', 0, 'click');
  DOUBLECLICK = new ListGridEditEvent_0('DOUBLECLICK', 1, 'doubleClick');
  NONE_3 = new ListGridEditEvent_0('NONE', 2, 'none');
  $VALUES_23 = initValues(_3Lcom_smartgwt_client_types_ListGridEditEvent_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ListGridEditEvent, [CLICK, DOUBLECLICK, NONE_3]);
}

function ListGridEditEvent_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_25(name_0){
  $clinit_ListGridEditEvent();
  return valueOf(($clinit_ListGridEditEvent$Map() , $MAP_23), name_0);
}

function values_24(){
  $clinit_ListGridEditEvent();
  return $VALUES_23;
}

defineSeed(394, 48, makeCastMap([Q$ListGridEditEvent, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), ListGridEditEvent_0);
_.getValue_0 = function getValue_20(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_23, CLICK, DOUBLECLICK, NONE_3;
function $clinit_ListGridEditEvent$Map(){
  $clinit_ListGridEditEvent$Map = nullMethod;
  $MAP_23 = createValueOfMap(($clinit_ListGridEditEvent() , $VALUES_23));
}

var $MAP_23;
function $clinit_MultipleAppearance(){
  $clinit_MultipleAppearance = nullMethod;
  PICKLIST = new MultipleAppearance_0('PICKLIST', 0, 'picklist');
  GRID = new MultipleAppearance_0('GRID', 1, 'grid');
  $VALUES_25 = initValues(_3Lcom_smartgwt_client_types_MultipleAppearance_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$MultipleAppearance, [PICKLIST, GRID]);
}

function MultipleAppearance_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_27(name_0){
  $clinit_MultipleAppearance();
  return valueOf(($clinit_MultipleAppearance$Map() , $MAP_25), name_0);
}

function values_26(){
  $clinit_MultipleAppearance();
  return $VALUES_25;
}

defineSeed(398, 48, makeCastMap([Q$MultipleAppearance, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), MultipleAppearance_0);
_.getValue_0 = function getValue_22(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_25, GRID, PICKLIST;
function $clinit_MultipleAppearance$Map(){
  $clinit_MultipleAppearance$Map = nullMethod;
  $MAP_25 = createValueOfMap(($clinit_MultipleAppearance() , $VALUES_25));
}

var $MAP_25;
function $clinit_RelativeDateRangePosition(){
  $clinit_RelativeDateRangePosition = nullMethod;
  START = new RelativeDateRangePosition_0('START', 0, 'start');
  END = new RelativeDateRangePosition_0('END', 1, 'end');
  $VALUES_28 = initValues(_3Lcom_smartgwt_client_types_RelativeDateRangePosition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$RelativeDateRangePosition, [START, END]);
}

function RelativeDateRangePosition_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_30(name_0){
  $clinit_RelativeDateRangePosition();
  return valueOf(($clinit_RelativeDateRangePosition$Map() , $MAP_28), name_0);
}

function values_29(){
  $clinit_RelativeDateRangePosition();
  return $VALUES_28;
}

defineSeed(404, 48, makeCastMap([Q$RelativeDateRangePosition, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), RelativeDateRangePosition_0);
_.getValue_0 = function getValue_25(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_28, END, START;
function $clinit_RelativeDateRangePosition$Map(){
  $clinit_RelativeDateRangePosition$Map = nullMethod;
  $MAP_28 = createValueOfMap(($clinit_RelativeDateRangePosition() , $VALUES_28));
}

var $MAP_28;
function $clinit_SelectionAppearance(){
  $clinit_SelectionAppearance = nullMethod;
  ROW_STYLE = new SelectionAppearance_0('ROW_STYLE', 0, 'rowStyle');
  CHECKBOX = new SelectionAppearance_0('CHECKBOX', 1, 'checkbox');
  $VALUES_29 = initValues(_3Lcom_smartgwt_client_types_SelectionAppearance_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$SelectionAppearance, [ROW_STYLE, CHECKBOX]);
}

function SelectionAppearance_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_31(name_0){
  $clinit_SelectionAppearance();
  return valueOf(($clinit_SelectionAppearance$Map() , $MAP_29), name_0);
}

function values_30(){
  $clinit_SelectionAppearance();
  return $VALUES_29;
}

defineSeed(406, 48, makeCastMap([Q$SelectionAppearance, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), SelectionAppearance_0);
_.getValue_0 = function getValue_26(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_29, CHECKBOX, ROW_STYLE;
function $clinit_SelectionAppearance$Map(){
  $clinit_SelectionAppearance$Map = nullMethod;
  $MAP_29 = createValueOfMap(($clinit_SelectionAppearance() , $VALUES_29));
}

var $MAP_29;
function $clinit_SelectionType(){
  $clinit_SelectionType = nullMethod;
  BUTTON = new SelectionType_0('BUTTON', 0, 'button');
  CHECKBOX_0 = new SelectionType_0('CHECKBOX', 1, 'checkbox');
  RADIO = new SelectionType_0('RADIO', 2, 'radio');
  $VALUES_31 = initValues(_3Lcom_smartgwt_client_types_SelectionType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$SelectionType, [BUTTON, CHECKBOX_0, RADIO]);
}

function SelectionType_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_33(name_0){
  $clinit_SelectionType();
  return valueOf(($clinit_SelectionType$Map() , $MAP_31), name_0);
}

function values_32(){
  $clinit_SelectionType();
  return $VALUES_31;
}

defineSeed(410, 48, makeCastMap([Q$SelectionType, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), SelectionType_0);
_.getValue_0 = function getValue_28(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_31, BUTTON, CHECKBOX_0, RADIO;
function $clinit_SelectionType$Map(){
  $clinit_SelectionType$Map = nullMethod;
  $MAP_31 = createValueOfMap(($clinit_SelectionType() , $VALUES_31));
}

var $MAP_31;
function $clinit_Side(){
  $clinit_Side = nullMethod;
  LEFT_2 = new Side_0('LEFT', 0, 'left');
  RIGHT_2 = new Side_0('RIGHT', 1, 'right');
  TOP_0 = new Side_0('TOP', 2, 'top');
  BOTTOM_0 = new Side_0('BOTTOM', 3, 'bottom');
  $VALUES_32 = initValues(_3Lcom_smartgwt_client_types_Side_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Side, [LEFT_2, RIGHT_2, TOP_0, BOTTOM_0]);
}

function Side_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_34(name_0){
  $clinit_Side();
  return valueOf(($clinit_Side$Map() , $MAP_32), name_0);
}

function values_33(){
  $clinit_Side();
  return $VALUES_32;
}

defineSeed(412, 48, makeCastMap([Q$Side, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), Side_0);
_.getValue_0 = function getValue_29(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_32, BOTTOM_0, LEFT_2, RIGHT_2, TOP_0;
function $clinit_Side$Map(){
  $clinit_Side$Map = nullMethod;
  $MAP_32 = createValueOfMap(($clinit_Side() , $VALUES_32));
}

var $MAP_32;
function $clinit_TextMatchStyle(){
  $clinit_TextMatchStyle = nullMethod;
  EXACT = new TextMatchStyle_0('EXACT', 0, 'exact');
  SUBSTRING = new TextMatchStyle_0('SUBSTRING', 1, 'substring');
  STARTS_WITH = new TextMatchStyle_0('STARTS_WITH', 2, 'startsWith');
  $VALUES_34 = initValues(_3Lcom_smartgwt_client_types_TextMatchStyle_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$TextMatchStyle, [EXACT, SUBSTRING, STARTS_WITH]);
}

function TextMatchStyle_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_36(name_0){
  $clinit_TextMatchStyle();
  return valueOf(($clinit_TextMatchStyle$Map() , $MAP_34), name_0);
}

function values_35(){
  $clinit_TextMatchStyle();
  return $VALUES_34;
}

defineSeed(416, 48, makeCastMap([Q$TextMatchStyle, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), TextMatchStyle_0);
_.getValue_0 = function getValue_31(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_34, EXACT, STARTS_WITH, SUBSTRING;
function $clinit_TextMatchStyle$Map(){
  $clinit_TextMatchStyle$Map = nullMethod;
  $MAP_34 = createValueOfMap(($clinit_TextMatchStyle() , $VALUES_34));
}

var $MAP_34;
function $clinit_TitleOrientation(){
  $clinit_TitleOrientation = nullMethod;
  LEFT_3 = new TitleOrientation_0('LEFT', 0, 'left');
  TOP_1 = new TitleOrientation_0('TOP', 1, 'top');
  RIGHT_3 = new TitleOrientation_0('RIGHT', 2, 'right');
  $VALUES_36 = initValues(_3Lcom_smartgwt_client_types_TitleOrientation_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$TitleOrientation, [LEFT_3, TOP_1, RIGHT_3]);
}

function TitleOrientation_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_38(name_0){
  $clinit_TitleOrientation();
  return valueOf(($clinit_TitleOrientation$Map() , $MAP_36), name_0);
}

function values_37(){
  $clinit_TitleOrientation();
  return $VALUES_36;
}

defineSeed(420, 48, makeCastMap([Q$TitleOrientation, Q$ValueEnum, Q$Serializable, Q$Comparable, Q$Enum]), TitleOrientation_0);
_.getValue_0 = function getValue_33(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_36, LEFT_3, RIGHT_3, TOP_1;
function $clinit_TitleOrientation$Map(){
  $clinit_TitleOrientation$Map = nullMethod;
  $MAP_36 = createValueOfMap(($clinit_TitleOrientation() , $VALUES_36));
}

var $MAP_36;
function $clinit_VisibilityMode(){
  $clinit_VisibilityMode = nullMethod;
  MUTEX = new VisibilityMode_0('MUTEX', 0, 'mutex');
  MULTIPLE_0 = new VisibilityMode_0('MULTIPLE', 1, 'multiple');
  $VALUES_39 = initValues(_3Lcom_smartgwt_client_types_VisibilityMode_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$VisibilityMode, [MUTEX, MULTIPLE_0]);
}

function VisibilityMode_0(enum$name, enum$ordinal, value){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.value_0 = value;
}

function valueOf_41(name_0){
  $clinit_VisibilityMode();
  return valueOf(($clinit_VisibilityMode$Map() , $MAP_39), name_0);
}

function values_40(){
  $clinit_VisibilityMode();
  return $VALUES_39;
}

defineSeed(426, 48, makeCastMap([Q$ValueEnum, Q$VisibilityMode, Q$Serializable, Q$Comparable, Q$Enum]), VisibilityMode_0);
_.getValue_0 = function getValue_36(){
  return this.value_0;
}
;
_.value_0 = null;
var $VALUES_39, MULTIPLE_0, MUTEX;
function $clinit_VisibilityMode$Map(){
  $clinit_VisibilityMode$Map = nullMethod;
  $MAP_39 = createValueOfMap(($clinit_VisibilityMode() , $VALUES_39));
}

var $MAP_39;
function getAbsoluteDate(relativeDate, baseDate, position){
  relativeDate = relativeDate.getJsObj();
  baseDate != null && (baseDate = convertToJavaScriptDate(baseDate));
  position != null && (position = position.getValue_0());
  var jsDate = $wnd.isc.DateUtil.getAbsoluteDate(relativeDate, baseDate, position);
  if (jsDate == null)
    return null;
  return toDate(jsDate.getTime());
}

function getEnum(enums, value){
  var anEnum, anEnum$index, anEnum$max;
  if (value == null)
    return null;
  for (anEnum$index = 0 , anEnum$max = enums.length; anEnum$index < anEnum$max; ++anEnum$index) {
    anEnum = enums[anEnum$index];
    if ($equals_6(anEnum.getValue_0(), value)) {
      return anEnum;
    }
  }
  return null;
}

function getDragTarget(){
  var ret = $wnd.isc.EventHandler.getDragTarget();
  if (ret == null || ret === undefined)
    return null;
  var retVal = getRef_0(ret);
  retVal == null && (retVal = new Canvas_2(ret));
  return retVal;
}

function apply_0(config, jsObj){
  for (var k in config) {
    jsObj[k] = config[k];
  }
}

function convertToJavaStringArray(array){
  var arr, i, length_0, result;
  if (!array)
    return initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, []);
  length_0 = array.length;
  arr = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, length_0, 0);
  for (i = 0; i < length_0; ++i) {
    arr[i] = (result = array[i] , result == null || result === undefined?null:result);
  }
  return arr;
}

function getAttributeAsBoolean(elem, attr){
  var ret = elem[attr];
  return ret == null || ret === undefined?false:ret;
}

function getAttributeAsDouble(elem, attr){
  var ret = elem[attr];
  if (ret === undefined || ret == null) {
    return null;
  }
   else {
    if (typeof ret == 'object') {
      return ret;
    }
     else {
      return new Double_0(ret);
    }
  }
}

function getAttributeAsIntArray(elem, attr){
  var hold, i, rtn;
  rtn = null;
  hold = getAttributeAsJavaScriptObject(elem, attr);
  if (hold) {
    rtn = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, getJavaScriptObjectArraySize(hold), 1);
    for (i = 0; i < rtn.length; ++i) {
      rtn[i] = hold[i];
    }
  }
  return rtn;
}

function getAttributeAsStringArray(elem, attr){
  var hold, i, rtn;
  rtn = null;
  hold = getAttributeAsJavaScriptObject(elem, attr);
  if (hold) {
    rtn = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, getJavaScriptObjectArraySize(hold), 0);
    for (i = 0; i < rtn.length; ++i) {
      rtn[i] = hold[i];
    }
  }
  return rtn;
}

function getProperties(jsObj){
  var props = createJavaScriptArray();
  for (var k in jsObj) {
    props.push(k);
  }
  return convertToJavaStringArray(props);
}

function setAttribute_6(elem, attr, value){
  !value?setNullAttribute(elem, attr):(elem[attr] = value.value_0 , undefined);
}

function ask_0(title, message, callback){
  $wnd.isc.ask(message, function(value){
    var valueJ = value == null?null:toBoolean(value);
    callback.execute_3(valueJ);
  }
  , {title:title});
}

function askforValue(message, callback){
  $wnd.isc.askForValue(message, function(value){
    value === undefined && (value = null);
    callback.execute_4(value);
  }
  , {width:275});
}

function confirm_0(message, callback){
  $wnd.isc.confirm(message, function(value){
    var valueJ = value == null?null:toBoolean(value);
    callback.execute_3(valueJ);
  }
  );
}

function say(message){
  $wnd.isc.say(message);
}

function warn(message, callback){
  $wnd.isc.warn(message, function(value){
    var valueJ = value == null?null:toBoolean(value);
    callback != null && callback.execute_3(valueJ);
  }
  );
}

function $setAttribute_21(this$static, attribute, value){
  var valueJS;
  valueJS = value.configOnly?value.config_0:$getOrCreateJsObj_0(value);
  $isCreated_1(this$static)?($toString_4(value) , undefined):(this$static.config_0[attribute] = valueJS , undefined);
}

function $setAttribute_26(this$static, value){
  $isCreated_1(this$static)?undefined:(this$static.config_0['tabBarControls'] = convertToJavaScriptArray(value) , undefined);
}

function $addChild(this$static, newChild){
  var self_0 = this$static.getOrCreateJsObj();
  var ret = self_0.addChild(newChild.getOrCreateJsObj());
  if (ret == null || ret === undefined)
    return null;
  var retVal = getRef_0(ret);
  retVal == null && (retVal = new Canvas_2(ret));
  return retVal;
}

function $addDragResizeStartHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_6 && (TYPE_6 = new GwtEvent$Type_0) , TYPE_6)) == 0 && $setupDragResizeStartEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_6 && (TYPE_6 = new GwtEvent$Type_0) , TYPE_6));
}

function $addDragResizeStopHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_7 && (TYPE_7 = new GwtEvent$Type_0) , TYPE_7)) == 0 && $setupDragResizeStopEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_7 && (TYPE_7 = new GwtEvent$Type_0) , TYPE_7));
}

function $addDropHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_9 && (TYPE_9 = new GwtEvent$Type_0) , TYPE_9)) == 0 && $setupDropEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_9 && (TYPE_9 = new GwtEvent$Type_0) , TYPE_9));
}

function $addKeyPressHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_10 && (TYPE_10 = new GwtEvent$Type_0) , TYPE_10)) == 0 && $setupKeyPressEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_10 && (TYPE_10 = new GwtEvent$Type_0) , TYPE_10));
}

function $addMouseOutHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_12 && (TYPE_12 = new GwtEvent$Type_0) , TYPE_12)) == 0 && $setupMouseOutEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_12 && (TYPE_12 = new GwtEvent$Type_0) , TYPE_12));
}

function $addMouseOverHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_13 && (TYPE_13 = new GwtEvent$Type_0) , TYPE_13)) == 0 && $setupMouseOverEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_13 && (TYPE_13 = new GwtEvent$Type_0) , TYPE_13));
}

function $addResizedHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_14 && (TYPE_14 = new GwtEvent$Type_0) , TYPE_14)) == 0 && $setupResizedEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_14 && (TYPE_14 = new GwtEvent$Type_0) , TYPE_14));
}

function $addVisibilityChangedHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_17 && (TYPE_17 = new GwtEvent$Type_0) , TYPE_17)) == 0 && $setupVisibilityChangedEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_17 && (TYPE_17 = new GwtEvent$Type_0) , TYPE_17));
}

function $animateHide(this$static, effect){
  var effectVal = effect.getValue_0();
  var self_0 = this$static.getOrCreateJsObj();
  self_0.animateHide(effectVal);
}

function $animateHide_0(this$static, effect, callback){
  var effectVal = effect.getValue_0();
  var self_0 = this$static.getOrCreateJsObj();
  self_0.animateHide(effectVal, $entry(function(earlyFinish){
    earlyFinish = earlyFinish === undefined?false:earlyFinish;
    callback != null && callback.execute_5(earlyFinish);
  }
  ));
}

function $animateRect(this$static, left, top_0, width, height, callback, duration){
  var self_0 = this$static.getOrCreateJsObj();
  var leftJS = left == null?null:left.intValue();
  var topJS = top_0 == null?null:top_0.intValue();
  var widthJS = width == null?null:width.intValue();
  var heightJS = height == null?null:height.intValue();
  self_0.animateRect(leftJS, topJS, widthJS, heightJS, $entry(function(earlyFinish){
    earlyFinish = earlyFinish === undefined?false:earlyFinish;
    callback != null && callback.execute_5(earlyFinish);
  }
  ), duration);
}

function $animateShow(this$static, effect){
  var effectVal = effect.getValue_0();
  var self_0 = this$static.getOrCreateJsObj();
  self_0.animateShow(effectVal);
}

function $getDisabled(this$static){
  var disabled;
  disabled = $getAttributeAsBoolean_1(this$static, 'disabled');
  return !!disabled && disabled.value_0;
}

function $getPageLeft(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  return self_0.getPageLeft();
}

function $getPageTop(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  return self_0.getPageTop();
}

function $isDisabled(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.isDisabled();
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $moveTo(this$static, left, top_0){
  var widget = this$static.getOrCreateJsObj();
  return widget.moveTo(left, top_0);
}

function $setBackgroundColor(this$static, backgroundColor){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'backgroundColor', backgroundColor):(this$static.config_0['backgroundColor'] = backgroundColor , undefined);
}

function $setBorder(this$static){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'border', null):(this$static.config_0['border'] = null , undefined);
}

function $setCanAcceptDrop(this$static, canAcceptDrop){
  $isCreated_1(this$static)?!canAcceptDrop?$setNullProperty(this$static, 'canAcceptDrop'):$setProperty_4(this$static, 'canAcceptDrop', canAcceptDrop.value_0):setAttribute_5(this$static.config_0, 'canAcceptDrop', canAcceptDrop);
}

function $setCanDrag(this$static, canDrag){
  $isCreated_1(this$static)?!canDrag?$setNullProperty(this$static, 'canDrag'):$setProperty_4(this$static, 'canDrag', canDrag.value_0):setAttribute_5(this$static.config_0, 'canDrag', canDrag);
}

function $setCanDragResize(this$static, canDragResize){
  $isCreated_1(this$static)?!canDragResize?$setNullProperty(this$static, 'canDragResize'):$setProperty_4(this$static, 'canDragResize', canDragResize.value_0):setAttribute_5(this$static.config_0, 'canDragResize', canDragResize);
}

function $setCanDrop(this$static, canDrop){
  $isCreated_1(this$static)?!canDrop?$setNullProperty(this$static, 'canDrop'):$setProperty_4(this$static, 'canDrop', canDrop.value_0):setAttribute_5(this$static.config_0, 'canDrop', canDrop);
}

function $setContextMenu(this$static, contextMenu){
  $setAttribute_20(this$static, 'contextMenu', !contextMenu?null:$getOrCreateJsObj_0(contextMenu), true);
}

function $setDragOpacity(this$static, dragOpacity){
  $isCreated_1(this$static)?!dragOpacity?$setNullProperty(this$static, 'dragOpacity'):$setProperty_1(this$static, 'dragOpacity', dragOpacity.value_0):setAttribute_8(this$static.config_0, 'dragOpacity', dragOpacity);
}

function $setEdgeMarginSize(this$static){
  $isCreated_1(this$static)?$setProperty_0(this$static, 'edgeMarginSize', 0):(this$static.config_0['edgeMarginSize'] = 0 , undefined);
}

function $setEdgeSize(this$static){
  $isCreated_1(this$static)?undefined:(this$static.config_0['edgeSize'] = 0 , undefined);
}

function $setExtraSpace(this$static, extraSpace){
  $isCreated_1(this$static)?undefined:(this$static.config_0['extraSpace'] = extraSpace , undefined);
}

function $setGroupTitle(this$static, groupTitle){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'groupTitle', groupTitle):(this$static.config_0['groupTitle'] = groupTitle , undefined);
}

function $setHoverWidth(this$static, hoverWidth){
  $isCreated_1(this$static)?!hoverWidth?$setNullProperty(this$static, 'hoverWidth'):$setProperty_1(this$static, 'hoverWidth', hoverWidth.value_0):setAttribute_8(this$static.config_0, 'hoverWidth', hoverWidth);
}

function $setHoverWrap(this$static, hoverWrap){
  $isCreated_1(this$static)?!hoverWrap?$setNullProperty(this$static, 'hoverWrap'):$setProperty_4(this$static, 'hoverWrap', hoverWrap.value_0):setAttribute_5(this$static.config_0, 'hoverWrap', hoverWrap);
}

function $setIsGroup(this$static, isGroup){
  $isCreated_1(this$static)?!isGroup?$setNullProperty(this$static, 'isGroup'):$setProperty_4(this$static, 'isGroup', isGroup.value_0):setAttribute_5(this$static.config_0, 'isGroup', isGroup);
}

function $setRedrawOnResize(this$static, redrawOnResize){
  $isCreated_1(this$static)?!redrawOnResize?$setNullProperty(this$static, 'redrawOnResize'):$setProperty_4(this$static, 'redrawOnResize', redrawOnResize.value_0):setAttribute_5(this$static.config_0, 'redrawOnResize', redrawOnResize);
}

function $setShowEdges(this$static, showEdges){
  $isCreated_1(this$static)?undefined:setAttribute_5(this$static.config_0, 'showEdges', showEdges);
}

function $setShowResizeBar(this$static, showResizeBar){
  $isCreated_1(this$static)?!showResizeBar?$setNullProperty(this$static, 'showResizeBar'):$setProperty_4(this$static, 'showResizeBar', showResizeBar.value_0):setAttribute_5(this$static.config_0, 'showResizeBar', showResizeBar);
}

function $setShowShadow(this$static, showShadow){
  $isCreated_1(this$static)?undefined:setAttribute_5(this$static.config_0, 'showShadow', showShadow);
}

function $setupDragResizeStartEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({dragResizeStart:$debox($entry(function(){
      var param = {};
      var event_0 = new DragResizeStartEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.dragResizeStart = $debox($entry(function(){
      var param = {};
      var event_0 = new DragResizeStartEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupDragResizeStopEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({dragResizeStop:$debox($entry(function(){
      var param = {};
      var event_0 = new DragResizeStopEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.dragResizeStop = $debox($entry(function(){
      var param = {};
      var event_0 = new DragResizeStopEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupDropEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({onDrop:$debox($entry(function(){
      var param = {};
      var event_0 = new DropEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.onDrop = $debox($entry(function(){
      var param = {};
      var event_0 = new DropEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupKeyPressEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({keyPress:$debox($entry(function(){
      var param = {};
      var event_0 = new KeyPressEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.keyPress = $debox($entry(function(){
      var param = {};
      var event_0 = new KeyPressEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupMouseOutEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({mouseOut:$debox($entry(function(){
      var param = {};
      var event_0 = new MouseOutEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.mouseOut = $debox($entry(function(){
      var param = {};
      var event_0 = new MouseOutEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupMouseOverEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({mouseOver:$debox($entry(function(){
      var param = {};
      var event_0 = new MouseOverEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.mouseOver = $debox($entry(function(){
      var param = {};
      var event_0 = new MouseOverEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupResizedEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({resized:$entry(function(){
      var param = {};
      var event_0 = new ResizedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    )});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.resized = $entry(function(){
      var param = {};
      var event_0 = new ResizedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    );
  }
}

function $setupVisibilityChangedEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({visibilityChanged:$entry(function(){
      var param = {isVisible:arguments[0]};
      var event_0 = new VisibilityChangedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    )});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.visibilityChanged = $entry(function(){
      var param = {isVisible:arguments[0]};
      var event_0 = new VisibilityChangedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    );
  }
}

function getImgURL(URL){
  $clinit_BaseWidget();
  return $wnd.isc.Canvas.getImgURL(URL);
}

function imgHTML(src){
  $clinit_BaseWidget();
  return $wnd.isc.Canvas.imgHTML(src);
}

function imgHTML_0(src, width, height){
  $clinit_BaseWidget();
  return $wnd.isc.Canvas.imgHTML(src, width, height);
}

defineSeed(441, 438, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]));
_.hide_0 = function hide(){
  $hide(this);
}
;
_.redraw_0 = function redraw(){
  $redraw(this);
}
;
_.setContents = function setContents_0(contents){
  $isCreated_1(this)?$setProperty_3(this, 'contents', contents):(this.config_0['contents'] = contents , undefined);
}
;
_.setOverflow = function setOverflow(overflow){
  $setAttribute_24(this, 'overflow', overflow.value_0, true);
}
;
function $setIcon(this$static, icon){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'icon', icon):(this$static.config_0['icon'] = icon , undefined);
}

function $setShowRollOver(this$static, showRollOver){
  $isCreated_1(this$static)?!showRollOver?$setNullProperty(this$static, 'showRollOver'):$setProperty_4(this$static, 'showRollOver', showRollOver.value_0):setAttribute_5(this$static.config_0, 'showRollOver', showRollOver);
}

function $setDisabled_0(this$static, disabled){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.setDisabled(disabled);
}

function $setShowRollOver_0(this$static, showRollOver){
  $isCreated_1(this$static)?!showRollOver?$setNullProperty(this$static, 'showRollOver'):$setProperty_4(this$static, 'showRollOver', showRollOver.value_0):setAttribute_5(this$static.config_0, 'showRollOver', showRollOver);
}

function Button_1(jsObj){
  Canvas_2.call(this, jsObj);
}

function Button_2(title){
  $clinit_BaseWidget();
  StatefulCanvas_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'title', title):(this.config_0['title'] = title , undefined);
  this.scClassName = 'Button';
}

function getOrCreateRef_4(jsObj){
  $clinit_BaseWidget();
  var obj_0;
  if (!jsObj)
    return null;
  obj_0 = !jsObj?null:dynamicCast(getAttributeAsObject(jsObj, '__ref'), Q$BaseWidget);
  return obj_0?dynamicCast(obj_0, Q$Button):new Button_1(jsObj);
}

defineSeed(439, 440, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Button, Q$Canvas, Q$StatefulCanvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasIconClickHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), Button_1, Button_2);
_.setAutoFit = function setAutoFit(autoFit){
  $isCreated_1(this)?!autoFit?$setNullProperty(this, 'autoFit'):$setProperty_4(this, 'autoFit', autoFit.value_0):setAttribute_5(this.config_0, 'autoFit', autoFit);
}
;
function $getMember_0(this$static, memberID){
  var self_0 = this$static.getOrCreateJsObj();
  var ret = self_0.getMember(memberID);
  return ret == null?null:getOrCreateRef_3(ret);
}

function $getMemberNumber(this$static, memberID){
  var self_0 = this$static.getOrCreateJsObj();
  return self_0.getMemberNumber(memberID);
}

function $hasMember(this$static, canvas){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.hasMember(canvas.getOrCreateJsObj());
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $setAnimateMemberTime(this$static, animateMemberTime){
  $isCreated_1(this$static)?!animateMemberTime?$setNullProperty(this$static, 'animateMemberTime'):$setProperty_1(this$static, 'animateMemberTime', animateMemberTime.value_0):setAttribute_8(this$static.config_0, 'animateMemberTime', animateMemberTime);
}

function $setAnimateMembers(this$static, animateMembers){
  $isCreated_1(this$static)?!animateMembers?$setNullProperty(this$static, 'animateMembers'):$setProperty_4(this$static, 'animateMembers', animateMembers.value_0):setAttribute_5(this$static.config_0, 'animateMembers', animateMembers);
}

function $setMembers(this$static, members){
  var member, member$index, member$max, membersToRemove;
  if ($isCreated_1(this$static)) {
    membersToRemove = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members'));
    for (member$index = 0 , member$max = membersToRemove.length; member$index < member$max; ++member$index) {
      member = membersToRemove[member$index];
      $removeMember(this$static, member);
    }
    for (member$index = 0 , member$max = members.length; member$index < member$max; ++member$index) {
      member = members[member$index];
      this$static.addMember_0(member);
    }
  }
   else {
    $isCreated_1(this$static)?$setProperty_2(this$static, 'members', convertToJavaScriptArray(members)):(this$static.config_0['members'] = convertToJavaScriptArray(members) , undefined);
  }
}

function $setShowDragPlaceHolder(this$static, showDragPlaceHolder){
  $isCreated_1(this$static)?!showDragPlaceHolder?$setNullProperty(this$static, 'showDragPlaceHolder'):$setProperty_4(this$static, 'showDragPlaceHolder', showDragPlaceHolder.value_0):setAttribute_5(this$static.config_0, 'showDragPlaceHolder', showDragPlaceHolder);
}

function $setVertical(this$static, vertical){
  $isCreated_1(this$static)?!vertical?$setNullProperty(this$static, 'vertical'):$setProperty_4(this$static, 'vertical', vertical.value_0):setAttribute_5(this$static.config_0, 'vertical', vertical);
}

function $setVisibleMember(this$static, member){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.setVisibleMember(member.getOrCreateJsObj());
}

defineSeed(446, 441, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout]));
_.setOverflow = function setOverflow_0(overflow){
  $setAttribute_24(this, 'overflow', overflow.value_0, false);
}
;
function VLayout_1(membersMargin){
  $clinit_BaseWidget();
  Layout_0.call(this);
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', membersMargin):(this.config_0['membersMargin'] = membersMargin , undefined);
  this.scClassName = 'VLayout';
}

defineSeed(445, 446, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), VLayout_1);
function $addMinimizeClickHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_11 && (TYPE_11 = new GwtEvent$Type_0) , TYPE_11)) == 0 && $setupMinimizeClickEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_11 && (TYPE_11 = new GwtEvent$Type_0) , TYPE_11));
}

function $addRestoreClickHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_15 && (TYPE_15 = new GwtEvent$Type_0) , TYPE_15)) == 0 && $setupRestoreClickEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_15 && (TYPE_15 = new GwtEvent$Type_0) , TYPE_15));
}

function $setAnimateMinimize(this$static, animateMinimize){
  $isCreated_1(this$static)?!animateMinimize?$setNullProperty(this$static, 'animateMinimize'):$setProperty_4(this$static, 'animateMinimize', animateMinimize.value_0):setAttribute_5(this$static.config_0, 'animateMinimize', animateMinimize);
}

function $setDismissOnOutsideClick(this$static, dismissOnOutsideClick){
  $isCreated_1(this$static)?!dismissOnOutsideClick?$setNullProperty(this$static, 'dismissOnOutsideClick'):$setProperty_4(this$static, 'dismissOnOutsideClick', dismissOnOutsideClick.value_0):setAttribute_5(this$static.config_0, 'dismissOnOutsideClick', dismissOnOutsideClick);
}

function $setHeaderControls(this$static, headerControls){
  $isCreated_1(this$static)?undefined:(this$static.config_0['headerControls'] = convertToJavaScriptArray(headerControls) , undefined);
}

function $setShowFooter(this$static, showFooter){
  $isCreated_1(this$static)?!showFooter?$setNullProperty(this$static, 'showFooter'):$setProperty_4(this$static, 'showFooter', showFooter.value_0):setAttribute_5(this$static.config_0, 'showFooter', showFooter);
}

function $setShowHeader(this$static, showHeader){
  $isCreated_1(this$static)?!showHeader?$setNullProperty(this$static, 'showHeader'):$setProperty_4(this$static, 'showHeader', showHeader.value_0):setAttribute_5(this$static.config_0, 'showHeader', showHeader);
}

function $setupMinimizeClickEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({onMinimizeClick:$debox($entry(function(){
      var param = {};
      var event_0 = new MinimizeClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.onMinimizeClick = $debox($entry(function(){
      var param = {};
      var event_0 = new MinimizeClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupRestoreClickEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({onRestoreClick:$debox($entry(function(){
      var param = {};
      var event_0 = new RestoreClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.onRestoreClick = $debox($entry(function(){
      var param = {};
      var event_0 = new RestoreClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $clinit_Dialog(){
  $clinit_Dialog = nullMethod;
  $clinit_BaseWidget();
  new Button_2('OK');
  new Button_2('Apply');
  new Button_2('Yes');
  new Button_2('No');
  new Button_2('Cancel');
  new Button_2('Done');
}

defineSeed(443, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]));
_.create_0 = function create_15(){
  var config = this.getConfig();
  var scClassName = this.scClassName;
  var widget = $wnd.isc[scClassName].create(config);
  this.doInit();
  return widget;
}
;
_.setStyleName = function setStyleName_0(styleName){
  $isCreated_1(this)?$setProperty_3(this, 'styleName', styleName):(this.config_0['styleName'] = styleName , undefined);
}
;
function $setContents(this$static, contents){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'contents', contents):(this$static.config_0['contents'] = contents , undefined);
}

function $setContentsURL(this$static, contentsURL){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'contentsURL', contentsURL):(this$static.config_0['contentsURL'] = contentsURL , undefined);
}

defineSeed(447, 441, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]));
_.setContents = function setContents_1(contents){
  $setContents(this, contents);
}
;
function Img_0(){
  $clinit_BaseWidget();
  StatefulCanvas_0.call(this);
  this.scClassName = 'Img';
}

function $clinit_HeaderControl(){
  var imgType;
  $clinit_HeaderControl = nullMethod;
  $clinit_BaseWidget();
  IMG_TYPE = (imgType = $wnd.isc.headerImgType , imgType == null || imgType === undefined?'png':imgType);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/arrow_down.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/arrow_left.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/arrow_right.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/arrow_up.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/calculator.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/cart.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/cascade.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/clipboard.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/clock.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/close.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/comment.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/document.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/double_arrow_down.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/double_arrow_left.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/double_arrow_right.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/double_arrow_up.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/favourite.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/find.' + IMG_TYPE);
  HELP = new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/help.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/home.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/mail.' + IMG_TYPE);
  MAXIMIZE = new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/maximize.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/minimize.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/minus.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/person.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/pin_down.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/pin_left.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/plus.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/print.' + IMG_TYPE);
  REFRESH = new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/refresh.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/refresh_thin.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/save.' + IMG_TYPE);
  SETTINGS = new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/settings.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/transfer.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/trash.' + IMG_TYPE);
  new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/zoom.' + IMG_TYPE);
}

function HeaderControl_0(icon){
  $clinit_HeaderControl();
  Img_0.call(this);
  $setSrc(this, icon.url);
  $isCreated_1(this)?$setProperty_0(this, 'width', 15):(this.config_0['width'] = 15 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'height', 15):(this.config_0['height'] = 15 , undefined);
  $setAttribute_24(this, 'layoutAlign', ($clinit_Alignment() , CENTER_0).value_0, false);
  $setShowRollOver(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
}

function HeaderControl_1(icon, clickHandler){
  $clinit_HeaderControl();
  HeaderControl_0.call(this, icon);
  $getHandlerCount_1(this, (!TYPE_3 && (TYPE_3 = new GwtEvent$Type_0) , TYPE_3)) == 0 && $setupClickEvent(this);
  $doAddHandler_0(this, clickHandler, (!TYPE_3 && (TYPE_3 = new GwtEvent$Type_0) , TYPE_3));
}

defineSeed(449, 450, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$StatefulCanvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), HeaderControl_0, HeaderControl_1);
var HELP, IMG_TYPE, MAXIMIZE, REFRESH, SETTINGS;
function HeaderControl$HeaderIcon_0(url){
  this.url = url;
}

defineSeed(451, 1, {}, HeaderControl$HeaderIcon_0);
_.url = null;
function $setIcon_0(this$static, icon){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'icon', icon):(this$static.config_0['icon'] = icon , undefined);
}

function $setIconHeight(this$static, iconHeight){
  $isCreated_1(this$static)?undefined:setAttribute_8(this$static.config_0, 'iconHeight', iconHeight);
}

function $setIconOrientation(this$static){
  $isCreated_1(this$static)?undefined:(this$static.config_0['iconOrientation'] = 'left' , undefined);
}

function $setIconWidth(this$static, iconWidth){
  $isCreated_1(this$static)?undefined:setAttribute_8(this$static.config_0, 'iconWidth', iconWidth);
}

function $setShowTitle(this$static, showTitle){
  $isCreated_1(this$static)?!showTitle?$setNullProperty(this$static, 'showTitle'):$setProperty_4(this$static, 'showTitle', showTitle.value_0):setAttribute_5(this$static.config_0, 'showTitle', showTitle);
}

function $setTitle_0(this$static, title){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'title', title):(this$static.config_0['title'] = title , undefined);
}

function $setWrap(this$static, wrap){
  $isCreated_1(this$static)?!wrap?$setNullProperty(this$static, 'wrap'):$setProperty_4(this$static, 'wrap', wrap.value_0):setAttribute_5(this$static.config_0, 'wrap', wrap);
}

function IButton_0(){
  $clinit_BaseWidget();
  StretchImgButton_0.call(this);
  this.scClassName = 'IButton';
}

defineSeed(452, 453, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$IButton, Q$StatefulCanvas, Q$StretchImg, Q$StretchImgButton, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasIconClickHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), IButton_0);
function $setDisabled_1(this$static, disabled){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.setDisabled(disabled);
}

defineSeed(455, 450, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$StatefulCanvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]));
_.create_0 = function create_22(){
  var config = this.getConfig();
  var scClassName = this.scClassName;
  var widget = $wnd.isc[scClassName].create(config);
  this.doInit();
  return widget;
}
;
_.setSrc = function setSrc_0(src){
  $isCreated_1(this)?$setProperty_3(this, 'src', src):(this.config_0['src'] = src , undefined);
}
;
function ImgProperties_0(src){
  DataClass_0.call(this);
  this.jsObj['src'] = src;
  $setAttribute_11(this, 'width', valueOf_44(16));
  $setAttribute_11(this, 'height', valueOf_44(16));
}

defineSeed(456, 326, makeCastMap([Q$DataClass, Q$JsObject]), ImgProperties_0);
function $setAutoFit_0(this$static, autoFit){
  $isCreated_1(this$static)?!autoFit?$setNullProperty(this$static, 'autoFit'):$setProperty_4(this$static, 'autoFit', autoFit.value_0):setAttribute_5(this$static.config_0, 'autoFit', autoFit);
}

defineSeed(457, 439, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Button, Q$Canvas, Q$StatefulCanvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasIconClickHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]));
_.setAutoFit = function setAutoFit_0(autoFit){
  $setAutoFit_0(this, autoFit);
}
;
_.setContents = function setContents_2(contents){
  $setContents_0(this, contents);
}
;
function $clinit_TransferImgButton(){
  var imgType;
  $clinit_TransferImgButton = nullMethod;
  $clinit_BaseWidget();
  IMG_TYPE_0 = (imgType = $wnd.isc.transferImgType , imgType == null || imgType === undefined?'png':imgType);
  LEFT_4 = new TransferImgButton$TransferImg_0('[SKIN]/TransferIcons/left.' + IMG_TYPE_0);
  LEFT_ALL = new TransferImgButton$TransferImg_0('[SKIN]/TransferIcons/left_all.' + IMG_TYPE_0);
  RIGHT_4 = new TransferImgButton$TransferImg_0('[SKIN]/TransferIcons/right.' + IMG_TYPE_0);
  RIGHT_ALL = new TransferImgButton$TransferImg_0('[SKIN]/TransferIcons/right_all.' + IMG_TYPE_0);
  new TransferImgButton$TransferImg_0('[SKIN]/TransferIcons/up.' + IMG_TYPE_0);
  new TransferImgButton$TransferImg_0('[SKIN]/TransferIcons/up_first.' + IMG_TYPE_0);
  new TransferImgButton$TransferImg_0('[SKIN]/TransferIcons/down.' + IMG_TYPE_0);
  new TransferImgButton$TransferImg_0('[SKIN]/TransferIcons/down_last.' + IMG_TYPE_0);
  new TransferImgButton$TransferImg_0('[SKIN]/TransferIcons/delete.' + IMG_TYPE_0);
}

function TransferImgButton_0(transferImg){
  $clinit_TransferImgButton();
  $clinit_BaseWidget();
  Img_0.call(this);
  this.scClassName = 'ImgButton';
  $setAttribute_24(this, 'src', transferImg.url, true);
  $isCreated_1(this)?$setProperty_0(this, 'width', 24):(this.config_0['width'] = 24 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'height', 22):(this.config_0['height'] = 22 , undefined);
  $setAttribute_24(this, 'layoutAlign', ($clinit_Alignment() , CENTER_0).value_0, false);
  $setAttribute_22(this, 'showRollOver', ($clinit_Boolean() , $clinit_Boolean() , TRUE), true);
  $setAttribute_22(this, 'showDownIcon', FALSE, false);
  $setAttribute_22(this, 'showDown', FALSE, true);
}

defineSeed(458, 455, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$StatefulCanvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), TransferImgButton_0);
var IMG_TYPE_0, LEFT_4, LEFT_ALL, RIGHT_4, RIGHT_ALL;
function TransferImgButton$TransferImg_0(url){
  this.url = url;
}

defineSeed(459, 1, {}, TransferImgButton$TransferImg_0);
_.url = null;
function WidgetCanvas_0(widget){
  $clinit_BaseWidget();
  var height, width;
  Canvas_1.call(this);
  this.widget = widget;
  $setRedrawOnResize(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_22(this, '_redrawWithParent', FALSE, false);
  $setAttribute_22(this, '_clearWithRemoveChild', TRUE, false);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, true);
  width = widget.element.style['width'];
  height = widget.element.style['height'];
  width != null && !$equals_6(width, '') && ($isCreated_1(this)?$setProperty_3(this, 'width', width):(this.config_0['width'] = width , undefined));
  height != null && !$equals_6(height, '') && ($isCreated_1(this)?$setProperty_3(this, 'height', height):(this.config_0['height'] = height , undefined));
}

defineSeed(460, 441, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), WidgetCanvas_0);
_.getInnerHTML_0 = function getInnerHTML_0(){
  this.widget.attached && $removeFromParent(this.widget);
  return "<DIV STYLE='width:100%;height:100%' ID=" + this.id_0 + '_widget><\/DIV>';
}
;
_.onDraw_0 = function onDraw_0(){
  var attached, height, rp, width;
  attached = this.widget.attached;
  if (!attached) {
    rp = get_1(this.id_0 + '_widget');
    $add_1(rp, this.widget);
    width = this.widget.element.style['width'];
    width != null && !$equals_6(width, '') && ($isCreated_1(this)?$setProperty_3(this, 'width', width):(this.config_0['width'] = width , undefined));
    height = this.widget.element.style['height'];
    height != null && !$equals_6(height, '') && ($isCreated_1(this)?$setProperty_3(this, 'height', height):(this.config_0['height'] = height , undefined));
  }
}
;
_.widget = null;
function $isRightButtonDown(){
  return $wnd.isc.EH.rightButtonDown();
}

function DragResizeStartEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(465, 461, {}, DragResizeStartEvent_0);
_.dispatch = function dispatch_6(handler){
  dynamicCast(dynamicCast(handler, Q$DragResizeStartHandler), Q$PortalLayout$2).this$0.dragResizeColumnCount = valueOf_44(0);
}
;
_.getAssociatedType = function getAssociatedType_6(){
  return TYPE_6;
}
;
_.isCancelled = function isCancelled_2(){
  return false;
}
;
var TYPE_6 = null;
function $dispatch_0(this$static, handler){
  $setHeight_3(handler.this$0.storedPortlet, $getAttributeAsInt_0(dynamicCast(this$static.source, Q$Canvas), 'height').value_0);
  $resize(handler.this$0.dashboardView.portalLayout);
  $save_3(handler.this$0.dashboardView);
}

function DragResizeStopEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(466, 461, {}, DragResizeStopEvent_0);
_.dispatch = function dispatch_7(handler){
  $dispatch_0(this, dynamicCast(handler, Q$DragResizeStopHandler));
}
;
_.getAssociatedType = function getAssociatedType_7(){
  return TYPE_7;
}
;
_.isCancelled = function isCancelled_3(){
  return false;
}
;
var TYPE_7 = null;
function DropEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(468, 461, {}, DropEvent_0);
_.dispatch = function dispatch_9(handler){
  $onDrop(dynamicCast(handler, Q$DropHandler));
}
;
_.getAssociatedType = function getAssociatedType_9(){
  return TYPE_9;
}
;
_.isCancelled = function isCancelled_4(){
  return false;
}
;
var TYPE_9 = null;
function $dispatch_1(handler){
  var keyName;
  $equals_6('Delete', (keyName = $wnd.isc.EventHandler.getKey() , keyName == undefined?null:keyName)) && $removeSelectedRows(handler.this$0);
}

function KeyPressEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(469, 461, {}, KeyPressEvent_0);
_.dispatch = function dispatch_10(handler){
  $dispatch_1(dynamicCast(handler, Q$KeyPressHandler));
}
;
_.getAssociatedType = function getAssociatedType_10(){
  return TYPE_10;
}
;
_.isCancelled = function isCancelled_5(){
  return false;
}
;
var TYPE_10 = null;
function MinimizeClickEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(470, 461, {}, MinimizeClickEvent_0);
_.dispatch = function dispatch_11(handler){
  $hide(dynamicCast(dynamicCast(handler, Q$MinimizeClickHandler), Q$PortletWindow$10).this$0.maximizeHeaderControl);
}
;
_.getAssociatedType = function getAssociatedType_11(){
  return TYPE_11;
}
;
_.isCancelled = function isCancelled_6(){
  return false;
}
;
var TYPE_11 = null;
function MouseOutEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(471, 461, {}, MouseOutEvent_0);
_.dispatch = function dispatch_12(handler){
  dynamicCast(handler, Q$MouseOutHandler).onMouseOut(this);
}
;
_.getAssociatedType = function getAssociatedType_12(){
  return TYPE_12;
}
;
_.isCancelled = function isCancelled_7(){
  return false;
}
;
var TYPE_12 = null;
function MouseOverEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(472, 461, {}, MouseOverEvent_0);
_.dispatch = function dispatch_13(handler){
  dynamicCast(handler, Q$MouseOverHandler).onMouseOver(this);
}
;
_.getAssociatedType = function getAssociatedType_13(){
  return TYPE_13;
}
;
_.isCancelled = function isCancelled_8(){
  return false;
}
;
var TYPE_13 = null;
function ResizedEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(473, 461, {}, ResizedEvent_0);
_.dispatch = function dispatch_14(handler){
  $onResized(dynamicCast(handler, Q$ResizedHandler));
}
;
_.getAssociatedType = function getAssociatedType_14(){
  return TYPE_14;
}
;
var TYPE_14 = null;
function RestoreClickEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(474, 461, {}, RestoreClickEvent_0);
_.dispatch = function dispatch_15(handler){
  $show(dynamicCast(dynamicCast(handler, Q$RestoreClickHandler), Q$PortletWindow$11).this$0.maximizeHeaderControl);
}
;
_.getAssociatedType = function getAssociatedType_15(){
  return TYPE_15;
}
;
_.isCancelled = function isCancelled_9(){
  return false;
}
;
var TYPE_15 = null;
function $dispatch_3(this$static, handler){
  var jsObj;
  (jsObj = this$static.jsObj , jsObj.isVisible) || ask(($clinit_Enhanced() , 'Do you want to save the modified alert definition?'), new SingleAlertDefinitionView$5$1_0(handler));
}

function VisibilityChangedEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(476, 461, {}, VisibilityChangedEvent_0);
_.dispatch = function dispatch_17(handler){
  $dispatch_3(this, dynamicCast(handler, Q$VisibilityChangedHandler));
}
;
_.getAssociatedType = function getAssociatedType_17(){
  return TYPE_17;
}
;
var TYPE_17 = null;
function $addColorSelectedHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_18 && (TYPE_18 = new GwtEvent$Type_0) , TYPE_18)) == 0 && $setupColorSelectedEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_18 && (TYPE_18 = new GwtEvent$Type_0) , TYPE_18));
}

function $setupColorSelectedEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({colorSelected:$entry(function(){
      var param = {color:arguments[0], opacity:arguments[1]};
      var event_0 = new ColorSelectedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    )});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.colorSelected = $entry(function(){
      var param = {color:arguments[0], opacity:arguments[1]};
      var event_0 = new ColorSelectedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    );
  }
}

function ColorPicker_0(){
  $clinit_BaseWidget();
  Window_1.call(this);
  this.scClassName = 'ColorPicker';
}

defineSeed(477, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), ColorPicker_0);
_.create_0 = function create_24(){
  var config = this.getConfig();
  var scClassName = this.scClassName;
  var widget = $wnd.isc[scClassName].create(config);
  this.doInit();
  return widget;
}
;
function $addFormSubmitFailedHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_19 && (TYPE_19 = new GwtEvent$Type_0) , TYPE_19)) == 0 && $setupFormSubmitFailedEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_19 && (TYPE_19 = new GwtEvent$Type_0) , TYPE_19));
}

function $addItemChangeHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_20 && (TYPE_20 = new GwtEvent$Type_0) , TYPE_20)) == 0 && $setupItemChangeEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_20 && (TYPE_20 = new GwtEvent$Type_0) , TYPE_20));
}

function $addItemChangedHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_21 && (TYPE_21 = new GwtEvent$Type_0) , TYPE_21)) == 0 && $setupItemChangedEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_21 && (TYPE_21 = new GwtEvent$Type_0) , TYPE_21));
}

function $clearValue(this$static, fieldName){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.clearValue(fieldName);
}

function $editRecord(this$static, record){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.editRecord(record.getJsObj());
}

function $fetchData_1(this$static, criteria, callback){
  var self_0 = this$static.getOrCreateJsObj();
  var critJS = criteria == null?null:criteria.getJsObj();
  self_0.fetchData(critJS, $entry(function(dsResponse, data, dsRequest){
    var responseJ = new DSResponse_1(dsResponse);
    var requestJ = new DSRequest_1(dsRequest);
    callback != null && callback.execute_2(responseJ, data, requestJ);
  }
  ));
}

function $getField_0(this$static, name_0){
  var field, field$array, field$index, field$max, fieldJS;
  if (this$static.fields_0 != null) {
    for (field$array = this$static.fields_0 , field$index = 0 , field$max = field$array.length; field$index < field$max; ++field$index) {
      field = field$array[field$index];
      if ($equals_6(name_0, $isCreated_2(field)?$getPropertyAsString(field, 'name'):getAttribute(field.jsObj, 'name'))) {
        return field;
      }
    }
  }
   else {
    fieldJS = $getFieldJS(this$static, name_0);
    return fieldJS?getFormItem(fieldJS):null;
  }
  return null;
}

function $getValue(this$static, fieldName){
  var self_0 = this$static.getOrCreateJsObj();
  var val = self_0.getValue(fieldName);
  return val == null || val === undefined?null:$wnd.SmartGWT.convertToJavaType(val);
}

function $hideItem(this$static, itemName){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.hideItem(itemName);
}

function $isNewRecord(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.isNewRecord();
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $resetValues(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.resetValues();
}

function $saveData(this$static, callback){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.saveData($entry(function(dsResponse, data, dsRequest){
    var responseJ = new DSResponse_1(dsResponse);
    var requestJ = new DSRequest_1(dsRequest);
    callback != null && callback.execute_2(responseJ, data, requestJ);
  }
  ));
}

function $saveData_0(this$static, callback, requestProperties){
  var self_0 = this$static.getOrCreateJsObj();
  var requestPropertiesJS = requestProperties == null?null:requestProperties.getJsObj();
  self_0.saveData($entry(function(dsResponse, data, dsRequest){
    var responseJ = new DSResponse_1(dsResponse);
    var requestJ = new DSRequest_1(dsRequest);
    callback != null && callback.execute_2(responseJ, data, requestJ);
  }
  ), requestPropertiesJS);
}

function $setAction(this$static, action){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'action', action):(this$static.config_0['action'] = action , undefined);
}

function $setAutoFetchData(this$static, autoFetchData){
  $isCreated_1(this$static)?undefined:setAttribute_5(this$static.config_0, 'autoFetchData', autoFetchData);
}

function $setCanFocus(this$static, canFocus){
  $isCreated_1(this$static)?!canFocus?$setNullProperty(this$static, 'canFocus'):$setProperty_4(this$static, 'canFocus', canFocus.value_0):setAttribute_5(this$static.config_0, 'canFocus', canFocus);
}

function $setCellPadding(this$static){
  $isCreated_1(this$static)?$setProperty_0(this$static, 'cellPadding', 5):(this$static.config_0['cellPadding'] = 5 , undefined);
}

function $setColWidths(this$static, colWidths){
  $isCreated_1(this$static)?$setProperty_2(this$static, 'colWidths', convertToJavaScriptArray(colWidths)):(this$static.config_0['colWidths'] = convertToJavaScriptArray(colWidths) , undefined);
}

function $setErrors(this$static, errors, showErrors){
  var self_0 = this$static.getOrCreateJsObj();
  var errorsJS = convertMapToJavascriptObject(errors);
  return self_0.setErrors(errorsJS, showErrors);
}

function $setHiliteRequiredFields(this$static, hiliteRequiredFields){
  $isCreated_1(this$static)?!hiliteRequiredFields?$setNullProperty(this$static, 'hiliteRequiredFields'):$setProperty_4(this$static, 'hiliteRequiredFields', hiliteRequiredFields.value_0):setAttribute_5(this$static.config_0, 'hiliteRequiredFields', hiliteRequiredFields);
}

function $setShowInlineErrors(this$static, showInlineErrors){
  $isCreated_1(this$static)?!showInlineErrors?$setNullProperty(this$static, 'showInlineErrors'):$setProperty_4(this$static, 'showInlineErrors', showInlineErrors.value_0):setAttribute_5(this$static.config_0, 'showInlineErrors', showInlineErrors);
}

function $setStopOnError(this$static, stopOnError){
  $isCreated_1(this$static)?undefined:setAttribute_5(this$static.config_0, 'stopOnError', stopOnError);
}

function $setTarget(this$static, target){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'target', target):(this$static.config_0['target'] = target , undefined);
}

function $setValidateOnChange(this$static, validateOnChange){
  $isCreated_1(this$static)?!validateOnChange?$setNullProperty(this$static, 'validateOnChange'):$setProperty_4(this$static, 'validateOnChange', validateOnChange.value_0):setAttribute_5(this$static.config_0, 'validateOnChange', validateOnChange);
}

function $setValue(this$static, fieldName, value){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.setValue(fieldName, value);
}

function $setValue_1(this$static, fieldName, value){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.setValue(fieldName, value);
}

function $setValue_2(this$static, fieldName, value){
  var self_0 = this$static.getOrCreateJsObj();
  var valueJS = convertToJavaScriptArray(value);
  self_0.setValue(fieldName, valueJS);
}

function $setupFormSubmitFailedEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({formSubmitFailed:$entry(function(){
      var param = {};
      var event_0 = new FormSubmitFailedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    )});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.formSubmitFailed = $entry(function(){
      var param = {};
      var event_0 = new FormSubmitFailedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    );
  }
}

function $setupItemChangeEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({itemChange:$debox($entry(function(){
      var param = {item:arguments[0], newValue:arguments[1], oldValue:arguments[2]};
      var event_0 = new ItemChangeEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.itemChange = $debox($entry(function(){
      var param = {item:arguments[0], newValue:arguments[1], oldValue:arguments[2]};
      var event_0 = new ItemChangeEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupItemChangedEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({itemChanged:$entry(function(){
      var param = {item:arguments[0], newValue:arguments[1]};
      var event_0 = new ItemChangedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    )});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.itemChanged = $entry(function(){
      var param = {item:arguments[0], newValue:arguments[1]};
      var event_0 = new ItemChangedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    );
  }
}

function $showItem(this$static, itemName){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.showItem(itemName);
}

function $submitForm(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.submitForm();
}

function $validate_0(this$static, validateHiddenFields){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.validate(validateHiddenFields);
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function DynamicForm_1(jsObj){
  Canvas_2.call(this, jsObj);
}

function getOrCreateRef_5(jsObj){
  $clinit_BaseWidget();
  var obj_0;
  if (!jsObj)
    return null;
  obj_0 = !jsObj?null:dynamicCast(getAttributeAsObject(jsObj, '__ref'), Q$BaseWidget);
  return obj_0?dynamicCast(obj_0, Q$DynamicForm):new DynamicForm_1(jsObj);
}

defineSeed(478, 441, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), DynamicForm_1);
function $addMember_1(this$static, member){
  var self_0 = this$static.getOrCreateJsObj();
  var memberJS = member.getOrCreateJsObj();
  self_0.addMember(memberJS);
}

function $getErrors_0(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var value = self_0.getErrors();
  if (value == null)
    return null;
  var valueJ = convertToMap(value);
  return valueJ;
}

function $hasErrors(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.hasErrors();
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $validate_1(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.validate();
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function ValuesManager_0(){
  BaseClass_0.call(this);
  this.scClassName = 'ValuesManager';
}

defineSeed(479, 325, makeCastMap([Q$HasHandlers, Q$BaseClass]), ValuesManager_0);
_.create_0 = function create_26(){
  var config = this.getConfig();
  var scClassName = this.scClassName;
  return $wnd.isc[scClassName].create(config);
}
;
function $getColor_0(this$static){
  var jsObj = this$static.jsObj;
  return jsObj.color;
}

function ColorSelectedEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(480, 461, {}, ColorSelectedEvent_0);
_.dispatch = function dispatch_18(handler){
  dynamicCast(handler, Q$ColorSelectedHandler).onColorSelected(this);
}
;
_.getAssociatedType = function getAssociatedType_18(){
  return TYPE_18;
}
;
var TYPE_18 = null;
function FormSubmitFailedEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(481, 461, {}, FormSubmitFailedEvent_0);
_.dispatch = function dispatch_19(handler){
  dynamicCast(handler, Q$FormSubmitFailedHandler).onFormSubmitFailed(this);
}
;
_.getAssociatedType = function getAssociatedType_19(){
  return TYPE_19;
}
;
var TYPE_19 = null;
function $dispatch_4(this$static, handler){
  $onItemChange(handler, this$static);
}

function $getNewValue(this$static){
  var jsObj = this$static.jsObj;
  return $wnd.SmartGWT.convertToJavaType(jsObj.newValue);
}

function ItemChangeEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(482, 461, {}, ItemChangeEvent_0);
_.dispatch = function dispatch_20(handler){
  $dispatch_4(this, dynamicCast(handler, Q$ItemChangeHandler));
}
;
_.getAssociatedType = function getAssociatedType_20(){
  return TYPE_20;
}
;
_.isCancelled = function isCancelled_11(){
  return false;
}
;
var TYPE_20 = null;
function ItemChangedEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(483, 461, {}, ItemChangedEvent_0);
_.dispatch = function dispatch_21(handler){
  dynamicCast(handler, Q$ItemChangedHandler).onItemChanged(this);
}
;
_.getAssociatedType = function getAssociatedType_21(){
  return TYPE_21;
}
;
var TYPE_21 = null;
function $addBlurHandler(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_23 && (TYPE_23 = new GwtEvent$Type_0) , TYPE_23)) == 0 && $setupBlurEvent(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_23 && (TYPE_23 = new GwtEvent$Type_0) , TYPE_23));
}

function $addChangeHandler(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_24 && (TYPE_24 = new GwtEvent$Type_0) , TYPE_24)) == 0 && $setupChangeEvent(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_24 && (TYPE_24 = new GwtEvent$Type_0) , TYPE_24));
}

function $addChangedHandler(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_25 && (TYPE_25 = new GwtEvent$Type_0) , TYPE_25)) == 0 && $setupChangedEvent(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_25 && (TYPE_25 = new GwtEvent$Type_0) , TYPE_25));
}

function $addFocusHandler(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_28 && (TYPE_28 = new GwtEvent$Type_0) , TYPE_28)) == 0 && $setupFocusEvent(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_28 && (TYPE_28 = new GwtEvent$Type_0) , TYPE_28));
}

function $addIconClickHandler(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_30 && (TYPE_30 = new GwtEvent$Type_0) , TYPE_30)) == 0 && $setupIconClickEvent(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_30 && (TYPE_30 = new GwtEvent$Type_0) , TYPE_30));
}

function $addItemHoverHandler(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_31 && (TYPE_31 = new GwtEvent$Type_0) , TYPE_31)) == 0 && $setupItemHoverEvent(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_31 && (TYPE_31 = new GwtEvent$Type_0) , TYPE_31));
}

function $doSetValue(this$static, value){
  var self_0 = this$static.getJsObj();
  self_0.setValue?self_0.setValue(value):(self_0.value = value);
}

function $getAttribute_0(this$static, attribute){
  return $isCreated_2(this$static)?$getPropertyAsString(this$static, attribute):getAttribute(this$static.jsObj, attribute);
}

function $getAttributeAsInt_1(this$static){
  var self_0, ret;
  return $isCreated_2(this$static)?(self_0 = this$static.getJsObj() , ret = self_0.getProperty('singleResourceId') , ret == null || ret === undefined?null:valueOf_44(ret)):getAttributeAsInt(this$static.jsObj, 'singleResourceId');
}

function $getConfig(this$static){
  var self_0 = this$static.getJsObj();
  var config = {};
  for (var k in self_0) {
    k != '__ref' && k != 'type' && k != 'editorType' && k != 'name' && (config[k] = self_0[k]);
  }
  self_0.transformInput && (config['transformInput'] = self_0.transformInput);
  return config;
}

function $getDisplayValue(this$static){
  var self_0 = this$static.getJsObj();
  if (self_0.setValue) {
    var val = self_0.getDisplayValue();
    return val == null?null:val.toString();
  }
   else {
    return '';
  }
}

function $getForm(this$static){
  var self_0 = this$static.getJsObj();
  if (self_0.form) {
    return getOrCreateRef_5(self_0.form);
  }
   else {
    return null;
  }
}

function $getIcon(this$static, name_0){
  var self_0 = this$static.getJsObj();
  var ret = self_0.getIcon(name_0);
  if (ret == null || ret === undefined)
    return null;
  return new FormItemIcon_1(ret);
}

function $getPropertyAsBoolean(this$static, property){
  var self_0 = this$static.getJsObj();
  var ret = self_0.getProperty(property);
  return ret == null || ret === undefined?null:toBoolean(ret);
}

function $isDisabled_0(this$static){
  var self_0 = this$static.getJsObj();
  var retVal = self_0.isDisabled();
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $redraw_0(this$static){
  var self_0 = this$static.getJsObj();
  self_0.setValue && self_0.redraw();
}

function $setAttribute_29(this$static, attribute, value){
  $isCreated_2(this$static)?$setProperty_9(this$static, attribute, value.value_0):setAttribute_5(this$static.jsObj, attribute, value);
}

function $setCanFocus_0(this$static, canFocus){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'canFocus', canFocus.value_0):setAttribute_5(this$static.jsObj, 'canFocus', canFocus);
}

function $setColSpan_0(this$static, colSpan){
  $isCreated_2(this$static)?$setProperty_8(this$static, 'colSpan', colSpan):(this$static.jsObj['colSpan'] = colSpan , undefined);
}

function $setDefaultValue(this$static, defaultValue){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'defaultValue', defaultValue.value_0):setAttribute_5(this$static.jsObj, 'defaultValue', defaultValue);
}

function $setDefaultValue_0(this$static, defaultValue){
  setAttribute_8(this$static.jsObj, 'defaultValue', defaultValue);
}

function $setDefaultValue_1(this$static, defaultValue){
  $isCreated_2(this$static)?$setProperty_8(this$static, 'defaultValue', defaultValue):(this$static.jsObj['defaultValue'] = defaultValue , undefined);
}

function $setEmptyDisplayValue(this$static, emptyDisplayValue){
  $isCreated_2(this$static)?$setProperty_8(this$static, 'emptyDisplayValue', emptyDisplayValue):(this$static.jsObj['emptyDisplayValue'] = emptyDisplayValue , undefined);
}

function $setEndRow_0(this$static, endRow){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'endRow', endRow.value_0):setAttribute_5(this$static.jsObj, 'endRow', endRow);
}

function $setErrorOrientation_0(this$static, errorOrientation){
  this$static.jsObj['errorOrientation'] = !errorOrientation?null:errorOrientation.value_0;
}

function $setHeight_1(this$static, height){
  $equals_6('100%', height) && (height = '*');
  $isCreated_2(this$static)?$setProperty_8(this$static, 'height', height):(this$static.jsObj['height'] = height , undefined);
}

function $setHint(this$static, hint){
  $isCreated_2(this$static)?$setProperty_8(this$static, 'hint', hint):(this$static.jsObj['hint'] = hint , undefined);
}

function $setHoverWidth_0(this$static, hoverWidth){
  setAttribute_8(this$static.jsObj, 'hoverWidth', hoverWidth);
}

function $setIcons(this$static, icons){
  $isCreated_2(this$static)?$setProperty_7(this$static, 'icons', convertToJavaScriptArray(icons)):(this$static.jsObj['icons'] = convertToJavaScriptArray(icons) , undefined);
}

function $setPrompt_1(this$static, prompt_0){
  $isCreated_2(this$static)?$setProperty_8(this$static, 'prompt', prompt_0):(this$static.jsObj['prompt'] = prompt_0 , undefined);
}

function $setRedrawOnChange(this$static){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'redrawOnChange', true):(this$static.jsObj['redrawOnChange'] = true , undefined);
}

function $setShowHint(this$static, showHint){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'showHint', showHint.value_0):setAttribute_5(this$static.jsObj, 'showHint', showHint);
}

function $setShowIcons(this$static, showIcons){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'showIcons', showIcons.value_0):setAttribute_5(this$static.jsObj, 'showIcons', showIcons);
}

function $setShowIfCondition(this$static, showIf){
  var self_0 = this$static.getJsObj();
  self_0.showIf = $debox($entry(function(item, value, form, values){
    var itemJ = getOrCreateRef_6(item);
    var valueJ = $wnd.SmartGWT.convertToJavaType(value);
    var formJ = getOrCreateRef_5(form);
    return showIf.execute_6(itemJ, valueJ, formJ);
  }
  ));
}

function $setShowPickerIcon(this$static, showPickerIcon){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'showPickerIcon', showPickerIcon.value_0):setAttribute_5(this$static.jsObj, 'showPickerIcon', showPickerIcon);
}

function $setShowValueIconOnly(this$static, showValueIconOnly){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'showValueIconOnly', showValueIconOnly.value_0):setAttribute_5(this$static.jsObj, 'showValueIconOnly', showValueIconOnly);
}

function $setStartRow_0(this$static, startRow){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'startRow', startRow.value_0):setAttribute_5(this$static.jsObj, 'startRow', startRow);
}

function $setTabIndex(this$static, tabIndex){
  setAttribute_8(this$static.jsObj, 'tabIndex', tabIndex);
}

function $setType(this$static, type){
  $isCreated_2(this$static)?$setProperty_8(this$static, 'type', type):(this$static.jsObj['type'] = type , undefined);
}

function $setValidateOnChange_0(this$static, validateOnChange){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'validateOnChange', validateOnChange.value_0):setAttribute_5(this$static.jsObj, 'validateOnChange', validateOnChange);
}

function $setValidateOnExit_0(this$static, validateOnExit){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'validateOnExit', validateOnExit.value_0):setAttribute_5(this$static.jsObj, 'validateOnExit', validateOnExit);
}

function $setValue_3(this$static, value){
  var self_0 = this$static.getJsObj();
  self_0.setValue?self_0.setValue(value):(self_0.value = value);
}

function $setValue_4(this$static, value){
  var self_0 = this$static.getJsObj();
  self_0.setValue?self_0.setValue(value):(self_0.value = value);
}

function $setValue_5(this$static, value){
  var self_0 = this$static.getJsObj();
  self_0.setValue?self_0.setValue(value):(self_0.value = value);
}

function $setValue_6(this$static, value){
  value == null || instanceOf(value, Q$String)?this$static.setValue_4(dynamicCast(value, Q$String)):instanceOf(value, Q$Integer)?this$static.setValue_2(dynamicCast(value, Q$Integer).value_0):instanceOf(value, Q$Long)?this$static.setValue_2(toInt(dynamicCast(value, Q$Long).value_0)):instanceOf(value, Q$Double)?this$static.setValue_0(dynamicCast(value, Q$Double).value_0):instanceOf(value, Q$Float)?this$static.setValue_1(dynamicCast(value, Q$Float).value_0):instanceOf(value, Q$Boolean)?this$static.setValue_6(dynamicCast(value, Q$Boolean).value_0):instanceOf(value, Q$Date)?this$static.setValue_5(dynamicCast(value, Q$Date)):instanceOf(value, Q$RelativeDate)?this$static.setValue_4(dynamicCast(value, Q$RelativeDate).value_0):$doSetValue(this$static, value);
}

function $setValue_8(this$static, value){
  var self_0 = this$static.getJsObj();
  var valueJS = convertToJavaScriptDate(value);
  self_0.setValue?self_0.setValue(valueJS):(self_0.value = valueJS);
}

function $setValue_9(this$static, value){
  var self_0 = this$static.getJsObj();
  self_0.setValue?self_0.setValue(value):(self_0.value = value);
}

function $setValueIconHeight(this$static, valueIconHeight){
  setAttribute_8(this$static.jsObj, 'valueIconHeight', valueIconHeight);
}

function $setValueIconWidth(this$static, valueIconWidth){
  setAttribute_8(this$static.jsObj, 'valueIconWidth', valueIconWidth);
}

function $setValueIcons(this$static, valueIcons){
  $isCreated_2(this$static)?$setProperty_7(this$static, 'valueIcons', convertMapToJavascriptObject(valueIcons)):(this$static.jsObj['valueIcons'] = convertMapToJavascriptObject(valueIcons) , undefined);
}

function $setValueMap(this$static, valueMap){
  $isCreated_2(this$static)?$setValueMapMethod(this$static, convertMapToJavascriptObject(valueMap)):$isCreated_2(this$static)?$setProperty_7(this$static, 'valueMap', convertMapToJavascriptObject(valueMap)):(this$static.jsObj['valueMap'] = convertMapToJavascriptObject(valueMap) , undefined);
}

function $setValueMap_0(this$static, valueMap){
  $isCreated_2(this$static)?$setValueMapMethod(this$static, convertToJavaScriptArray(valueMap)):$isCreated_2(this$static)?$setProperty_7(this$static, 'valueMap', convertToJavaScriptArray(valueMap)):(this$static.jsObj['valueMap'] = convertToJavaScriptArray(valueMap) , undefined);
}

function $setValueMapMethod(this$static, value){
  var self_0 = this$static.getJsObj();
  self_0.setValueMap(value);
}

function $setupBlurEvent(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.blur = $entry(function(){
    var param = {form:arguments[0], item:arguments[1]};
    var event_0 = new BlurEvent_0(param);
    selfJ.fireEvent_0(event_0);
  }
  );
}

function $setupChangeEvent(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.change = $debox($entry(function(){
    var param = {form:arguments[0], item:arguments[1], value:arguments[2], oldValue:arguments[3]};
    var event_0 = new ChangeEvent_0(param);
    selfJ.fireEvent_0(event_0);
    var ret = event_0.isCancelled();
    return !ret;
  }
  ));
}

function $setupFocusEvent(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.focus = $entry(function(){
    var param = {form:arguments[0], item:arguments[1]};
    var event_0 = new FocusEvent_0(param);
    selfJ.fireEvent_0(event_0);
  }
  );
}

function $setupIconClickEvent(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.iconClick = $entry(function(){
    var param = {form:arguments[0], item:arguments[1], icon:arguments[2]};
    var event_0 = new IconClickEvent_0(param);
    selfJ.fireEvent_0(event_0);
  }
  );
}

function $setupItemHoverEvent(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.itemHover = $entry(function(){
    var param = {item:arguments[0], form:arguments[1]};
    var event_0 = new ItemHoverEvent_0(param);
    selfJ.fireEvent_0(event_0);
  }
  );
}

function $validate_2(this$static){
  var self_0 = this$static.getJsObj();
  var retVal = self_0.validate();
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

defineSeed(487, 331, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]));
_.addClickHandler = function addClickHandler(handler){
  return $addClickHandler_0(this, handler);
}
;
_.enable_0 = function enable(){
  $setDisabled_2(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
}
;
_.getPrompt = function getPrompt(){
  return $isCreated_2(this)?$getPropertyAsString(this, 'prompt'):getAttribute(this.jsObj, 'prompt');
}
;
_.getShowTitle = function getShowTitle(){
  return $isCreated_2(this)?$getPropertyAsBoolean(this, 'showTitle'):($clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'showTitle')?TRUE:FALSE);
}
;
_.getTitle = function getTitle(){
  return $isCreated_2(this)?$getPropertyAsString(this, 'title'):getAttribute(this.jsObj, 'title');
}
;
_.setDefaultValue = function setDefaultValue(defaultValue){
  $setDefaultValue_0(this, defaultValue);
}
;
_.setDefaultValue_0 = function setDefaultValue_0(defaultValue){
  $setDefaultValue_1(this, defaultValue);
}
;
_.setEndRow = function setEndRow(endRow){
  $setEndRow_0(this, endRow);
}
;
_.setIconVAlign = function setIconVAlign(iconVAlign){
  $setAttribute_30(this, 'iconVAlign', iconVAlign.value_0);
}
;
_.setPrompt = function setPrompt(prompt_0){
  $setPrompt_1(this, prompt_0);
}
;
_.setStartRow = function setStartRow(startRow){
  $setStartRow_0(this, startRow);
}
;
_.setValidateOnChange = function setValidateOnChange(validateOnChange){
  $setValidateOnChange_0(this, validateOnChange);
}
;
_.setValidateOnExit = function setValidateOnExit(validateOnExit){
  $setValidateOnExit_0(this, validateOnExit);
}
;
_.setValue_0 = function setValue(value){
  $setValue_3(this, value);
}
;
_.setValue_1 = function setValue_0(value){
  $setValue_4(this, value);
}
;
_.setValue_2 = function setValue_1(value){
  $setValue_5(this, value);
}
;
_.setValue_3 = function setValue_2(value){
  $setValue_6(this, value);
}
;
_.setValue_4 = function setValue_3(value){
  $setValue_7(this, value);
}
;
_.setValue_5 = function setValue_4(value){
  $setValue_8(this, value);
}
;
_.setValue_6 = function setValue_5(value){
  $setValue_9(this, value);
}
;
_.setValueMap_0 = function setValueMap(valueMap){
  $setValueMap(this, valueMap);
}
;
_.setValueMap_1 = function setValueMap_0(valueMap){
  $setValueMap_0(this, valueMap);
}
;
_.validate_1 = function validate_0(){
  return $validate_2(this);
}
;
function $getValueAsString_0(this$static){
  var self_0 = this$static.getJsObj();
  var ret;
  self_0.setValue?(ret = self_0.getValue()):(ret = self_0.value);
  return ret == null || ret === undefined?null:ret.toString();
}

function $setLength(this$static, length_0){
  setAttribute_8(this$static.jsObj, 'length', length_0);
}

function TextAreaItem_0(){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'TextAreaItem'):(this.jsObj['editorType'] = 'TextAreaItem' , undefined);
}

function TextAreaItem_1(){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', 'recipeText'):(this.jsObj['name'] = 'recipeText' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'TextAreaItem'):(this.jsObj['editorType'] = 'TextAreaItem' , undefined);
}

function TextAreaItem_2(name_0, title){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'TextAreaItem'):(this.jsObj['editorType'] = 'TextAreaItem' , undefined);
}

defineSeed(486, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$TextAreaItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), TextAreaItem_0, TextAreaItem_1, TextAreaItem_2);
_.setIconVAlign = function setIconVAlign_0(iconVAlign){
  $setAttribute_30(this, 'iconVAlign', iconVAlign.value_0);
}
;
_.setWidth = function setWidth_0(width){
  $isCreated_2(this)?$setProperty_6(this, 'width', width):(this.jsObj['width'] = width , undefined);
}
;
function AutoFitTextAreaItem_0(title){
  TextAreaItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', 'description'):(this.jsObj['name'] = 'description' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'AutoFitTextAreaItem'):(this.jsObj['editorType'] = 'AutoFitTextAreaItem' , undefined);
}

defineSeed(485, 486, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$TextAreaItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), AutoFitTextAreaItem_0);
function $setPrompt_2(this$static, prompt_0){
  $isCreated_2(this$static)?$setProperty_8(this$static, 'prompt', prompt_0):(this$static.jsObj['prompt'] = prompt_0 , undefined);
}

function CanvasItem_1(name_0){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'CanvasItem'):(this.jsObj['editorType'] = 'CanvasItem' , undefined);
  $setupCanvasConstructor(this);
}

defineSeed(489, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), CanvasItem_1);
_.getCanvas = function getCanvas(){
  return getOrCreateRef_3($isCreated_2(this)?$getPropertyAsJSO(this, 'canvas'):getAttributeAsJavaScriptObject(this.jsObj, 'canvas'));
}
;
_.getPrompt = function getPrompt_0(){
  return $isCreated_2(this)?$getPropertyAsString(this, 'prompt'):getAttribute(this.jsObj, 'prompt');
}
;
_.setPrompt = function setPrompt_0(prompt_0){
  $setPrompt_2(this, prompt_0);
}
;
function $addClickHandler_1(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_26 && (TYPE_26 = new GwtEvent$Type_0) , TYPE_26)) == 0 && $setupClickEvent_1(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_26 && (TYPE_26 = new GwtEvent$Type_0) , TYPE_26));
}

function $setAutoFit_1(this$static, autoFit){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'autoFit', autoFit.value_0):setAttribute_5(this$static.jsObj, 'autoFit', autoFit);
}

function $setEndRow_1(this$static, endRow){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'endRow', endRow.value_0):setAttribute_5(this$static.jsObj, 'endRow', endRow);
}

function $setIcon_2(this$static){
  $isCreated_2(this$static)?$setProperty_8(this$static, 'icon', 'global/upload.png'):(this$static.jsObj['icon'] = 'global/upload.png' , undefined);
}

function $setStartRow_1(this$static, startRow){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'startRow', startRow.value_0):setAttribute_5(this$static.jsObj, 'startRow', startRow);
}

function $setupClickEvent_1(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.click = $entry(function(){
    var param = {form:arguments[0], item:arguments[1]};
    var event_0 = new ClickEvent_2(param);
    selfJ.fireEvent_0(event_0);
  }
  );
}

function ButtonItem_0(){
  CanvasItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', 'Upload'):(this.jsObj['name'] = 'Upload' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'ButtonItem'):(this.jsObj['editorType'] = 'ButtonItem' , undefined);
}

function ButtonItem_1(name_0, title){
  CanvasItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  this.setTitle(title);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'ButtonItem'):(this.jsObj['editorType'] = 'ButtonItem' , undefined);
}

defineSeed(488, 489, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), ButtonItem_1);
_.addClickHandler = function addClickHandler_0(handler){
  return $addClickHandler_1(this, handler);
}
;
_.getCanvas = function getCanvas_0(){
  return getOrCreateRef_4($isCreated_2(this)?$getPropertyAsJSO(this, 'canvas'):getAttributeAsJavaScriptObject(this.jsObj, 'canvas'));
}
;
_.getShowTitle = function getShowTitle_0(){
  return $isCreated_2(this)?$getPropertyAsBoolean(this, 'showTitle'):($clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'showTitle')?TRUE:FALSE);
}
;
_.setEndRow = function setEndRow_0(endRow){
  $setEndRow_1(this, endRow);
}
;
_.setStartRow = function setStartRow_0(startRow){
  $setStartRow_1(this, startRow);
}
;
function $getValueAsBoolean(this$static){
  var origValue;
  origValue = dynamicCast($getValue_0(this$static), Q$Boolean);
  return $clinit_Boolean() , !(!($isCreated_2(this$static)?$getPropertyAsBoolean(this$static, 'allowEmptyValue'):getAttributeAsBoolean(this$static.jsObj, 'allowEmptyValue')?TRUE:FALSE).value_0 && !origValue) && origValue.value_0?TRUE:FALSE;
}

function $setLabelAsTitle(this$static, labelAsTitle){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'labelAsTitle', labelAsTitle.value_0):setAttribute_5(this$static.jsObj, 'labelAsTitle', labelAsTitle);
}

function $setShowLabel(this$static, showLabel){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'showLabel', showLabel.value_0):setAttribute_5(this$static.jsObj, 'showLabel', showLabel);
}

function $setShowTitle_2(this$static, showTitle){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'showTitle', showTitle.value_0):setAttribute_5(this$static.jsObj, 'showTitle', showTitle);
}

function CheckboxItem_0(){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'CheckboxItem'):(this.jsObj['editorType'] = 'CheckboxItem' , undefined);
}

function CheckboxItem_1(name_0){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'CheckboxItem'):(this.jsObj['editorType'] = 'CheckboxItem' , undefined);
}

function CheckboxItem_2(name_0, title){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'CheckboxItem'):(this.jsObj['editorType'] = 'CheckboxItem' , undefined);
}

defineSeed(490, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CheckboxItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), CheckboxItem_0, CheckboxItem_1, CheckboxItem_2);
_.getShowTitle = function getShowTitle_1(){
  return $isCreated_2(this)?$getPropertyAsBoolean(this, 'showTitle'):($clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'showTitle')?TRUE:FALSE);
}
;
_.setShowTitle = function setShowTitle_1(showTitle){
  $setShowTitle_2(this, showTitle);
}
;
function $getEnteredValue(this$static){
  var self_0 = this$static.getJsObj();
  return self_0.getEnteredValue();
}

function $setLength_0(this$static, length_0){
  setAttribute_8(this$static.jsObj, 'length', length_0);
}

function $setSelectOnFocus(this$static, selectOnFocus){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'selectOnFocus', selectOnFocus.value_0):setAttribute_5(this$static.jsObj, 'selectOnFocus', selectOnFocus);
}

defineSeed(492, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$TextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]));
_.getEnteredValue_0 = function getEnteredValue(){
  return $getEnteredValue(this);
}
;
function $clinit_ComboBoxItem(){
  $clinit_ComboBoxItem = nullMethod;
  init_2();
}

function $addDataArrivedHandler(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_27 && (TYPE_27 = new GwtEvent$Type_0) , TYPE_27)) == 0 && $setupDataArrivedEvent(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_27 && (TYPE_27 = new GwtEvent$Type_0) , TYPE_27));
}

function $getEnteredValue_0(this$static){
  var self_0 = this$static.getJsObj();
  return self_0.getEnteredValue();
}

function $getSelectedRecord(this$static){
  var self_0 = this$static.getJsObj();
  var ret = self_0.getSelectedRecord();
  if (ret == null || ret === undefined)
    return null;
  var retVal = getRef(ret);
  retVal == null && (retVal = new ListGridRecord_1(ret));
  return retVal;
}

function $getValueAsString_2(this$static){
  var self_0 = this$static.getJsObj();
  var ret;
  self_0.setValue?(ret = self_0.getValue()):(ret = self_0.value);
  return ret == null || ret === undefined?null:ret.toString();
}

function $setAddUnknownValues(this$static, addUnknownValues){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'addUnknownValues', addUnknownValues.value_0):setAttribute_5(this$static.jsObj, 'addUnknownValues', addUnknownValues);
}

function $setDefaultToFirstOption(this$static, defaultToFirstOption){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'defaultToFirstOption', defaultToFirstOption.value_0):setAttribute_5(this$static.jsObj, 'defaultToFirstOption', defaultToFirstOption);
}

function $setOptionDataSource(this$static, dataSource){
  this$static.jsObj['optionDataSource'] = !dataSource?null:$getOrCreateJsObj(dataSource);
}

function $setPickListWidth(this$static, pickListWidth){
  setAttribute_8(this$static.jsObj, 'pickListWidth', pickListWidth);
}

function $setupDataArrivedEvent(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.dataArrived = $entry(function(){
    var param = {startRow:arguments[0], endRow:arguments[1], data:arguments[2]};
    var event_0 = new DataArrivedEvent_0(param);
    selfJ.fireEvent_0(event_0);
  }
  );
}

function ComboBoxItem_0(){
  $clinit_ComboBoxItem();
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'ComboBoxItem'):(this.jsObj['editorType'] = 'ComboBoxItem' , undefined);
}

function ComboBoxItem_1(name_0){
  $clinit_ComboBoxItem();
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'ComboBoxItem'):(this.jsObj['editorType'] = 'ComboBoxItem' , undefined);
}

function ComboBoxItem_2(name_0, title){
  $clinit_ComboBoxItem();
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'ComboBoxItem'):(this.jsObj['editorType'] = 'ComboBoxItem' , undefined);
}

function init_2(){
  if ($wnd.isc.ComboBoxItem.getPrototype().__getPickListFilterCriteria == null) {
    $wnd.isc.ComboBoxItem.getPrototype().__getPickListFilterCriteria = $wnd.isc.ComboBoxItem.getPrototype().getPickListFilterCriteria;
    $wnd.isc.ComboBoxItem.getPrototype().getPickListFilterCriteria = $entry(function(){
      var jObj = this.__ref;
      if (jObj && instanceOf(jObj, Q$ComboBoxItem)) {
        jObj.setJsObj(this);
        var critJ = jObj.getPickListFilterCriteria_0();
        return critJ == null?{}:critJ.getJsObj();
      }
       else {
        return this.__getPickListFilterCriteria();
      }
    }
    );
  }
}

defineSeed(491, 492, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$ComboBoxItem, Q$FormItem, Q$TextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), ComboBoxItem_0, ComboBoxItem_1);
_.getEnteredValue_0 = function getEnteredValue_0(){
  return $getEnteredValue_0(this);
}
;
_.getPickListFilterCriteria_0 = function getPickListFilterCriteria(){
  var self_0 = this.getJsObj();
  var critJS = self_0.__getPickListFilterCriteria();
  return critJS == null?null:new Criteria_1(critJS);
}
;
_.getValueAsString = function getValueAsString_0(){
  return $getValueAsString_2(this);
}
;
function $getValueAsDate(this$static){
  var self_0 = this$static.getJsObj();
  var ret;
  self_0.setValue?(ret = self_0.getValue()):(ret = self_0.value);
  return ret == null?null:toDate(ret.getTime());
}

function $setEndDate_0(this$static, endDate){
  $isCreated_2(this$static)?$setProperty_7(this$static, 'endDate', convertToJavaScriptDate(endDate)):setAttribute_9(this$static.jsObj, 'endDate', endDate);
}

function $setEnforceDate(this$static, enforceDate){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'enforceDate', enforceDate.value_0):setAttribute_5(this$static.jsObj, 'enforceDate', enforceDate);
}

function $setStartDate_0(this$static, startDate){
  $isCreated_2(this$static)?$setProperty_7(this$static, 'startDate', convertToJavaScriptDate(startDate)):setAttribute_9(this$static.jsObj, 'startDate', startDate);
}

function $setUseMask(this$static, useMask){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'useMask', useMask.value_0):setAttribute_5(this$static.jsObj, 'useMask', useMask);
}

function $setUseTextField(this$static, useTextField){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'useTextField', useTextField.value_0):setAttribute_5(this$static.jsObj, 'useTextField', useTextField);
}

function DateItem_0(){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'DateItem'):(this.jsObj['editorType'] = 'DateItem' , undefined);
}

defineSeed(493, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]));
function $setUseTextField_0(this$static, useTextField){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'useTextField', useTextField.value_0):setAttribute_5(this$static.jsObj, 'useTextField', useTextField);
}

function DateTimeItem_0(name_0){
  DateItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'DateTimeItem'):(this.jsObj['editorType'] = 'DateTimeItem' , undefined);
}

function DateTimeItem_1(name_0, title){
  DateItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'DateTimeItem'):(this.jsObj['editorType'] = 'DateTimeItem' , undefined);
}

defineSeed(495, 493, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$DateTimeItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), DateTimeItem_0, DateTimeItem_1);
function FloatItem_0(){
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'type', 'float'):(this.jsObj['type'] = 'float' , undefined);
}

defineSeed(496, 492, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$TextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), FloatItem_0);
function $addFormItemClickHandler(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_29 && (TYPE_29 = new GwtEvent$Type_0) , TYPE_29)) == 0 && $setupFormItemClickEvent(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_29 && (TYPE_29 = new GwtEvent$Type_0) , TYPE_29));
}

function $setHeight_2(this$static, height){
  setAttribute_8(this$static.jsObj, 'height', height);
}

function $setWidth_4(this$static, width){
  setAttribute_8(this$static.jsObj, 'width', width);
}

function $setupFormItemClickEvent(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.click = $entry(function(){
    var param = {form:arguments[0], item:arguments[1], icon:arguments[2]};
    var event_0 = new FormItemIconClickEvent_0(param);
    selfJ.fireEvent_0(event_0);
  }
  );
}

function FormItemIcon_1(jsObj){
  this.jsObj = jsObj;
}

defineSeed(498, 326, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$FormItemIcon, Q$HasFormItemClickHandlers]), FormItemIcon_1);
function HeaderItem_1(title){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', 'header'):(this.jsObj['name'] = 'header' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'HeaderItem'):(this.jsObj['editorType'] = 'HeaderItem' , undefined);
}

defineSeed(499, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), HeaderItem_1);
_.getShowTitle = function getShowTitle_2(){
  return $isCreated_2(this)?$getPropertyAsBoolean(this, 'showTitle'):($clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'showTitle')?TRUE:FALSE);
}
;
_.setDefaultValue_0 = function setDefaultValue_1(defaultValue){
  $isCreated_2(this)?$setProperty_8(this, 'defaultValue', defaultValue):(this.jsObj['defaultValue'] = defaultValue , undefined);
}
;
_.setEndRow = function setEndRow_1(endRow){
  $isCreated_2(this)?$setProperty_9(this, 'endRow', endRow.value_0):setAttribute_5(this.jsObj, 'endRow', endRow);
}
;
_.setStartRow = function setStartRow_1(startRow){
  $isCreated_2(this)?$setProperty_9(this, 'startRow', startRow.value_0):setAttribute_5(this.jsObj, 'startRow', startRow);
}
;
defineSeed(500, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]));
_.getShowTitle = function getShowTitle_3(){
  return $isCreated_2(this)?$getPropertyAsBoolean(this, 'showTitle'):($clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'showTitle')?TRUE:FALSE);
}
;
defineSeed(502, 489, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]));
function IPickTreeItem_0(title){
  CanvasItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'PickTreeItem'):(this.jsObj['editorType'] = 'PickTreeItem' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'name', 'type'):(this.jsObj['name'] = 'type' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'IPickTreeItem'):(this.jsObj['editorType'] = 'IPickTreeItem' , undefined);
}

defineSeed(501, 502, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), IPickTreeItem_0);
function IntegerItem_0(){
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'type', 'integer'):(this.jsObj['type'] = 'integer' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'TextItem'):(this.jsObj['editorType'] = 'TextItem' , undefined);
}

function IntegerItem_1(title){
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', 'value'):(this.jsObj['name'] = 'value' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'type', 'integer'):(this.jsObj['type'] = 'integer' , undefined);
}

defineSeed(503, 492, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$IntegerItem, Q$TextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), IntegerItem_0, IntegerItem_1);
function $setEscapeHTML(this$static, escapeHTML){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'escapeHTML', escapeHTML.value_0):setAttribute_5(this$static.jsObj, 'escapeHTML', escapeHTML);
}

function $setTextBoxStyle(this$static){
  $isCreated_2(this$static)?$setProperty_8(this$static, 'textBoxStyle', null):(this$static.jsObj['textBoxStyle'] = null , undefined);
}

function $setWrap_1(this$static, wrap){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'wrap', wrap.value_0):setAttribute_5(this$static.jsObj, 'wrap', wrap);
}

function StaticTextItem_0(){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'StaticTextItem'):(this.jsObj['editorType'] = 'StaticTextItem' , undefined);
}

function StaticTextItem_1(name_0){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'StaticTextItem'):(this.jsObj['editorType'] = 'StaticTextItem' , undefined);
}

defineSeed(505, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$StaticTextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), StaticTextItem_0, StaticTextItem_1);
function $addClickHandler_2(this$static, handler){
  $isCreated_2(this$static)?$setProperty_8(this$static, 'target', 'javascript'):(this$static.jsObj['target'] = 'javascript' , undefined);
  return $getHandlerCount_0(this$static, (!TYPE_26 && (TYPE_26 = new GwtEvent$Type_0) , TYPE_26)) == 0 && $setupClickEvent_0(this$static) , $doAddHandler(this$static, handler, (!TYPE_26 && (TYPE_26 = new GwtEvent$Type_0) , TYPE_26));
}

function LinkItem_0(){
  StaticTextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'LinkItem'):(this.jsObj['editorType'] = 'LinkItem' , undefined);
}

function LinkItem_1(name_0){
  StaticTextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'LinkItem'):(this.jsObj['editorType'] = 'LinkItem' , undefined);
}

defineSeed(504, 505, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$StaticTextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), LinkItem_0, LinkItem_1);
_.addClickHandler = function addClickHandler_1(handler){
  return $addClickHandler_2(this, handler);
}
;
function PasswordItem_0(){
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'PasswordItem'):(this.jsObj['editorType'] = 'PasswordItem' , undefined);
}

function PasswordItem_1(name_0){
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'PasswordItem'):(this.jsObj['editorType'] = 'PasswordItem' , undefined);
}

defineSeed(506, 492, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$PasswordItem, Q$TextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), PasswordItem_0, PasswordItem_1);
function $getValueAsString_3(this$static){
  var self_0 = this$static.getJsObj();
  var ret;
  self_0.setValue?(ret = self_0.getValue()):(ret = self_0.value);
  return ret == null || ret === undefined?null:ret.toString();
}

function $setVertical_0(this$static, vertical){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'vertical', vertical.value_0):setAttribute_5(this$static.jsObj, 'vertical', vertical);
}

function $setWrap_2(this$static, wrap){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'wrap', wrap.value_0):setAttribute_5(this$static.jsObj, 'wrap', wrap);
}

function RadioGroupItem_0(){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'RadioGroupItem'):(this.jsObj['editorType'] = 'RadioGroupItem' , undefined);
}

function RadioGroupItem_1(name_0){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'RadioGroupItem'):(this.jsObj['editorType'] = 'RadioGroupItem' , undefined);
}

function RadioGroupItem_2(name_0, title){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'RadioGroupItem'):(this.jsObj['editorType'] = 'RadioGroupItem' , undefined);
}

defineSeed(507, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$RadioGroupItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), RadioGroupItem_0, RadioGroupItem_1, RadioGroupItem_2);
function getAbsoluteDate_0(relativeDate){
  var retVal = $wnd.isc.RelativeDateItem.getAbsoluteDate(relativeDate.getValue_0());
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toDate(retVal.getTime());
  }
}

function SpacerItem_1(name_0){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'SpacerItem'):(this.jsObj['editorType'] = 'SpacerItem' , undefined);
}

defineSeed(510, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$SpacerItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), SpacerItem_1);
_.getShowTitle = function getShowTitle_4(){
  return $isCreated_2(this)?$getPropertyAsBoolean(this, 'showTitle'):($clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'showTitle')?TRUE:FALSE);
}
;
defineSeed(509, 510, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$SpacerItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]));
_.getShowTitle = function getShowTitle_5(){
  return $isCreated_2(this)?$getPropertyAsBoolean(this, 'showTitle'):($clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'showTitle')?TRUE:FALSE);
}
;
_.setEndRow = function setEndRow_2(endRow){
  $isCreated_2(this)?$setProperty_9(this, 'endRow', endRow.value_0):setAttribute_5(this.jsObj, 'endRow', endRow);
}
;
_.setStartRow = function setStartRow_2(startRow){
  $isCreated_2(this)?$setProperty_9(this, 'startRow', startRow.value_0):setAttribute_5(this.jsObj, 'startRow', startRow);
}
;
function SectionItem_0(name_0){
  CanvasItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'SectionItem'):(this.jsObj['editorType'] = 'SectionItem' , undefined);
}

defineSeed(511, 489, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), SectionItem_0);
function $clinit_SelectItem(){
  $clinit_SelectItem = nullMethod;
  init_3();
}

function $fetchData_2(this$static){
  var self_0 = this$static.getJsObj();
  self_0.fetchData();
}

function $getValueAsString_4(this$static){
  var self_0 = this$static.getJsObj();
  var ret;
  self_0.setValue?(ret = self_0.getValue()):(ret = self_0.value);
  return ret == null || ret === undefined?null:ret.toString();
}

function $getValues(this$static){
  var self_0 = this$static.getJsObj();
  var value;
  self_0.getValue?(value = self_0.getValue()):(value = self_0.value);
  value == null?(value = []):!$wnd.isc.isA.Array(value) && (value = [value]);
  return convertToJavaStringArray(value);
}

function $setAllowEmptyValue(this$static, allowEmptyValue){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'allowEmptyValue', allowEmptyValue.value_0):setAttribute_5(this$static.jsObj, 'allowEmptyValue', allowEmptyValue);
}

function $setDefaultToFirstOption_0(this$static, defaultToFirstOption){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'defaultToFirstOption', defaultToFirstOption.value_0):setAttribute_5(this$static.jsObj, 'defaultToFirstOption', defaultToFirstOption);
}

function $setMultiple(this$static, multiple){
  $isCreated_2(this$static)?$setProperty_9(this$static, 'multiple', multiple.value_0):setAttribute_5(this$static.jsObj, 'multiple', multiple);
}

function $setOptionDataSource_0(this$static, dataSource){
  this$static.jsObj['optionDataSource'] = !dataSource?null:$getOrCreateJsObj(dataSource);
}

function $setValues(this$static, values){
  var self_0 = this$static.getJsObj();
  var valuesJS = convertToJavaScriptArray(values);
  self_0.setValue?self_0.setValue(valuesJS):(self_0.value = valuesJS);
}

function SelectItem_0(){
  $clinit_SelectItem();
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'SelectItem'):(this.jsObj['editorType'] = 'SelectItem' , undefined);
}

function SelectItem_1(name_0){
  $clinit_SelectItem();
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'SelectItem'):(this.jsObj['editorType'] = 'SelectItem' , undefined);
}

function SelectItem_2(name_0, title){
  $clinit_SelectItem();
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'SelectItem'):(this.jsObj['editorType'] = 'SelectItem' , undefined);
}

function init_3(){
  if ($wnd.isc.SelectItem.getPrototype().__getPickListFilterCriteria == null) {
    $wnd.isc.SelectItem.getPrototype().__getPickListFilterCriteria = $wnd.isc.SelectItem.getPrototype().getPickListFilterCriteria;
    $wnd.isc.SelectItem.getPrototype().getPickListFilterCriteria = $entry(function(){
      var jObj = this.__ref;
      if (jObj && instanceOf(jObj, Q$SelectItem)) {
        jObj.setJsObj(this);
        var critJ = jObj.getPickListFilterCriteria_0();
        return critJ == null?{}:critJ.getJsObj();
      }
       else {
        return this.__getPickListFilterCriteria();
      }
    }
    );
  }
}

defineSeed(512, 487, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$SelectItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), SelectItem_0, SelectItem_1, SelectItem_2);
_.getPickListFilterCriteria_0 = function getPickListFilterCriteria_0(){
  var self_0 = this.getJsObj();
  var critJS = self_0.__getPickListFilterCriteria();
  return critJS == null?null:new Criteria_1(critJS);
}
;
_.setValues = function setValues(values){
  $setValues(this, values);
}
;
function SliderItem_0(){
  CanvasItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', 'exceptionItem'):(this.jsObj['name'] = 'exceptionItem' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', 'Exception Depth'):(this.jsObj['title'] = 'Exception Depth' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'SliderItem'):(this.jsObj['editorType'] = 'SliderItem' , undefined);
}

defineSeed(513, 489, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), SliderItem_0);
function $setDefaultValue_2(this$static, defaultValue){
  setAttribute_8(this$static.jsObj, 'defaultValue', defaultValue);
}

function $setMax(this$static, max){
  setAttribute_8(this$static.jsObj, 'max', max);
}

function $setMin(this$static, min){
  setAttribute_8(this$static.jsObj, 'min', min);
}

function $setStep(this$static){
  $isCreated_2(this$static)?$setProperty_6(this$static, 'step', 1):(this$static.jsObj['step'] = 1 , undefined);
}

function SpinnerItem_0(){
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'SpinnerItem'):(this.jsObj['editorType'] = 'SpinnerItem' , undefined);
}

function SpinnerItem_1(name_0, title){
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'SpinnerItem'):(this.jsObj['editorType'] = 'SpinnerItem' , undefined);
}

defineSeed(514, 492, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$SpinnerItem, Q$TextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), SpinnerItem_0, SpinnerItem_1);
_.setDefaultValue = function setDefaultValue_2(defaultValue){
  $setDefaultValue_2(this, defaultValue);
}
;
defineSeed(515, 488, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]));
_.getTitle = function getTitle_0(){
  return $isCreated_2(this)?$getPropertyAsString(this, 'title'):getAttribute(this.jsObj, 'title');
}
;
function UploadItem_0(name_0, title){
  TextItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'UploadItem'):(this.jsObj['editorType'] = 'UploadItem' , undefined);
}

defineSeed(516, 492, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$TextItem, Q$UploadItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), UploadItem_0);
function $getItem(this$static){
  var jsObj = this$static.jsObj;
  return getOrCreateRef_6(jsObj.item);
}

function BlurEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(517, 352, {}, BlurEvent_0);
_.dispatch = function dispatch_23(handler){
  dynamicCast(handler, Q$BlurHandler).onBlur(this);
}
;
_.getAssociatedType = function getAssociatedType_23(){
  return TYPE_23;
}
;
var TYPE_23 = null;
function $getValue_1(this$static){
  var jsObj = this$static.jsObj;
  return $wnd.SmartGWT.convertToJavaType(jsObj.value);
}

function ChangeEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(518, 352, {}, ChangeEvent_0);
_.dispatch = function dispatch_24(handler){
  dynamicCast(handler, Q$ChangeHandler).onChange(this);
}
;
_.getAssociatedType = function getAssociatedType_24(){
  return TYPE_24;
}
;
_.isCancelled = function isCancelled_12(){
  return this.cancel;
}
;
_.cancel = false;
var TYPE_24 = null;
function $getItem_0(this$static){
  var jsObj = this$static.jsObj;
  return getOrCreateRef_6(jsObj.item);
}

function $getValue_2(this$static){
  var jsObj = this$static.jsObj;
  return $wnd.SmartGWT.convertToJavaType(jsObj.value);
}

function DataArrivedEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(521, 352, {}, DataArrivedEvent_0);
_.dispatch = function dispatch_27(handler){
  $onDataArrived(dynamicCast(handler, Q$DataArrivedHandler));
}
;
_.getAssociatedType = function getAssociatedType_27(){
  return TYPE_27;
}
;
var TYPE_27 = null;
function $dispatch_5(handler){
  $handleFocusChange(handler.this$0, handler.val$valueItem, handler.val$unsetItem);
}

function FocusEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(522, 352, {}, FocusEvent_0);
_.dispatch = function dispatch_28(handler){
  $dispatch_5(dynamicCast(handler, Q$FocusHandler));
}
;
_.getAssociatedType = function getAssociatedType_28(){
  return TYPE_28;
}
;
var TYPE_28 = null;
function FormItemIconClickEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(523, 352, {}, FormItemIconClickEvent_0);
_.dispatch = function dispatch_29(handler){
  dynamicCast(handler, Q$FormItemClickHandler).onFormItemClick(this);
}
;
_.getAssociatedType = function getAssociatedType_29(){
  return TYPE_29;
}
;
var TYPE_29 = null;
function $getIcon_0(this$static){
  var jsObj = this$static.jsObj;
  return new FormItemIcon_1(jsObj.icon);
}

function IconClickEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(524, 352, {}, IconClickEvent_0);
_.dispatch = function dispatch_30(handler){
  dynamicCast(handler, Q$IconClickHandler).onIconClick(this);
}
;
_.getAssociatedType = function getAssociatedType_30(){
  return TYPE_30;
}
;
var TYPE_30 = null;
function ItemHoverEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(525, 352, {}, ItemHoverEvent_0);
_.dispatch = function dispatch_31(handler){
  $onItemHover(dynamicCast(handler, Q$ItemHoverHandler));
}
;
_.getAssociatedType = function getAssociatedType_31(){
  return TYPE_31;
}
;
var TYPE_31 = null;
function $setup(this$static, jsObj){
  var self_0 = this$static;
  jsObj.condition = function(item, validator, value, record){
    var ref;
    if ($wnd.isc.isA.FormItem(item)) {
      self_0.formItem = getFormItem(item);
    }
     else {
      if (item.__ref && (ref = getAttributeAsObject(item, '__ref') , ref != null && instanceOf(ref, Q$DataSourceField))) {
        self_0.dataSourceField = getOrCreateRef_0(item);
      }
       else {
        var dataSourceField = $wnd.isc.addProperties({}, item);
        dataSourceField.__ref && delete dataSourceField.__ref;
        self_0.dataSourceField = new DataSourceField_0(dataSourceField);
      }
    }
    validator && (self_0.validatorProperties = convertToMap(validator));
    record != null && (self_0.record_0 = getOrCreateRef_1(record));
    var valueJ = $wnd.SmartGWT.convertToJavaType(value);
    var ret = self_0.condition_1(valueJ);
    var jsValidatorDefinition = self_0.getJsObj();
    var resultingValue = self_0.resultingValue_0;
    resultingValue != null && validator && (validator.resultingValue = $wnd.SmartGWT.convertToPrimitiveType(resultingValue));
    if (validator && validator != jsValidatorDefinition && jsValidatorDefinition.errorMessage != null) {
      validator.errorMessage = jsValidatorDefinition.errorMessage;
      jsValidatorDefinition.errorMessage = null;
    }
    self_0.reset_0();
    return ret;
  }
  ;
}

function CustomValidator_0(){
  Validator_0.call(this);
  this.validatorProperties = new HashMap_0;
  this.jsObj['type'] = 'custom';
  $setup(this, this.jsObj);
}

defineSeed(528, 529, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]));
_.reset_0 = function reset(){
  this.formItem = null;
  this.dataSourceField = null;
  this.record_0 = null;
  this.validatorProperties.clear_0();
  this.resultingValue_0 = null;
}
;
_.dataSourceField = null;
_.formItem = null;
_.record_0 = null;
_.resultingValue_0 = null;
function FloatRangeValidator_0(){
  Validator_0.call(this);
  this.jsObj['type'] = 'floatRange';
}

defineSeed(530, 529, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), FloatRangeValidator_0);
function IntegerRangeValidator_0(){
  Validator_0.call(this);
  this.jsObj['type'] = 'integerRange';
}

defineSeed(531, 529, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), IntegerRangeValidator_0);
function IsFloatValidator_0(){
  Validator_0.call(this);
  this.jsObj['type'] = 'isFloat';
}

defineSeed(532, 529, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), IsFloatValidator_0);
function IsIntegerValidator_0(){
  Validator_0.call(this);
  this.jsObj['type'] = 'isInteger';
}

defineSeed(533, 529, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), IsIntegerValidator_0);
function $setMax_0(this$static, max){
  setAttribute_8(this$static.jsObj, 'max', max);
}

function $setMin_0(this$static, min){
  setAttribute_8(this$static.jsObj, 'min', min);
}

function LengthRangeValidator_0(){
  Validator_0.call(this);
  this.jsObj['type'] = 'lengthRange';
}

defineSeed(534, 529, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), LengthRangeValidator_0);
function MatchesFieldValidator_0(){
  Validator_0.call(this);
  this.jsObj['type'] = 'matchesField';
}

defineSeed(535, 529, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), MatchesFieldValidator_0);
function RegExpValidator_1(expression){
  RegExpValidator_0.call(this);
  this.jsObj['expression'] = expression;
}

defineSeed(536, 529, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), RegExpValidator_1);
function $addCellClickHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_34 && (TYPE_34 = new GwtEvent$Type_0) , TYPE_34)) == 0 && $setupCellClickEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_34 && (TYPE_34 = new GwtEvent$Type_0) , TYPE_34));
}

function $addData_0(this$static, record){
  var self_0 = this$static.getOrCreateJsObj();
  var recordJS = record.getJsObj();
  self_0.addData(recordJS);
}

function $addFieldStateChangedHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_38 && (TYPE_38 = new GwtEvent$Type_0) , TYPE_38)) == 0 && $setupFieldStateChangedEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_38 && (TYPE_38 = new GwtEvent$Type_0) , TYPE_38));
}

function $addRecordCollapseHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_40 && (TYPE_40 = new GwtEvent$Type_0) , TYPE_40)) == 0 && $setupRecordCollapseEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_40 && (TYPE_40 = new GwtEvent$Type_0) , TYPE_40));
}

function $addRecordExpandHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_43 && (TYPE_43 = new GwtEvent$Type_0) , TYPE_43)) == 0 && $setupRecordExpandEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_43 && (TYPE_43 = new GwtEvent$Type_0) , TYPE_43));
}

function $addRowEditorExitHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_44 && (TYPE_44 = new GwtEvent$Type_0) , TYPE_44)) == 0 && $setupRowEditorExitEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_44 && (TYPE_44 = new GwtEvent$Type_0) , TYPE_44));
}

function $anySelected(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.anySelected();
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $deselectRecord(this$static, record){
  var self_0 = this$static.getOrCreateJsObj();
  var recordJS = record.getJsObj();
  self_0.deselectRecord(recordJS);
}

function $getCriteria_0(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var ret = self_0.getCriteria();
  if (ret == null || ret === undefined)
    return null;
  return new Criteria_1(ret);
}

function $getFieldName(this$static, colNum){
  var self_0 = this$static.getOrCreateJsObj();
  return self_0.getFieldName(colNum);
}

function $getViewState(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  return self_0.getViewState();
}

function $hasErrors_0(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.hasErrors();
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $isSelected(this$static, record){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.isSelected(record.getJsObj());
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $removeSelectedData(this$static, callback, requestProperties){
  var self_0 = this$static.getOrCreateJsObj();
  var requestPropertiesJS = requestProperties == null?null:requestProperties.getJsObj();
  self_0.removeSelectedData($entry(function(dsResponse, data, dsRequest){
    var responseJ = new DSResponse_1(dsResponse);
    var requestJ = new DSRequest_1(dsRequest);
    callback != null && callback.execute_2(responseJ, data, requestJ);
  }
  ), requestPropertiesJS);
}

function $selectAllRecords(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.selectAllRecords();
}

function $setAutoFetchData_0(this$static, autoFetchData){
  $isCreated_1(this$static)?undefined:setAttribute_5(this$static.config_0, 'autoFetchData', autoFetchData);
}

function $setAutoFitFieldWidths(this$static, autoFitFieldWidths){
  $isCreated_1(this$static)?undefined:setAttribute_5(this$static.config_0, 'autoFitFieldWidths', autoFitFieldWidths);
}

function $setCanEdit(this$static, canEdit){
  $isCreated_1(this$static)?!canEdit?$setNullProperty(this$static, 'canEdit'):$setProperty_4(this$static, 'canEdit', canEdit.value_0):setAttribute_5(this$static.config_0, 'canEdit', canEdit);
}

function $setCanExpandMultipleRecords(this$static, canExpandMultipleRecords){
  $isCreated_1(this$static)?!canExpandMultipleRecords?$setNullProperty(this$static, 'canExpandMultipleRecords'):$setProperty_4(this$static, 'canExpandMultipleRecords', canExpandMultipleRecords.value_0):setAttribute_5(this$static.config_0, 'canExpandMultipleRecords', canExpandMultipleRecords);
}

function $setCanExpandRecords(this$static, canExpandRecords){
  $isCreated_1(this$static)?!canExpandRecords?$setNullProperty(this$static, 'canExpandRecords'):$setProperty_4(this$static, 'canExpandRecords', canExpandRecords.value_0):setAttribute_5(this$static.config_0, 'canExpandRecords', canExpandRecords);
}

function $setCanHover(this$static, canHover){
  $isCreated_1(this$static)?!canHover?$setNullProperty(this$static, 'canHover'):$setProperty_4(this$static, 'canHover', canHover.value_0):setAttribute_5(this$static.config_0, 'canHover', canHover);
}

function $setEditByCell(this$static, editByCell){
  $isCreated_1(this$static)?!editByCell?$setNullProperty(this$static, 'editByCell'):$setProperty_4(this$static, 'editByCell', editByCell.value_0):setAttribute_5(this$static.config_0, 'editByCell', editByCell);
}

function $setEditValue(this$static, rowNum, fieldName, value){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.setEditValue(rowNum, fieldName, value);
}

function $setEditValue_0(this$static, rowNum, fieldName, value){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.setEditValue(rowNum, fieldName, value);
}

function $setFields_1(this$static, fields){
  $isCreated_1(this$static)?$setProperty_2(this$static, 'fields', convertToJavaScriptArray(fields)):(this$static.config_0['fields'] = convertToJavaScriptArray(fields) , undefined);
}

function $setFixedRecordHeights(this$static, fixedRecordHeights){
  $isCreated_1(this$static)?!fixedRecordHeights?$setNullProperty(this$static, 'fixedRecordHeights'):$setProperty_4(this$static, 'fixedRecordHeights', fixedRecordHeights.value_0):setAttribute_5(this$static.config_0, 'fixedRecordHeights', fixedRecordHeights);
}

function $setHoverCustomizer(this$static, hoverCustomizer){
  var self_0;
  this$static.isCreated()?(self_0 = this$static.getJsObj()):(self_0 = this$static.getConfig());
  self_0.cellHoverHTML = $debox($entry(function(record, rowNum, colNum){
    var recordJ = getOrCreateRef_8(record);
    var valueJ = null;
    return hoverCustomizer.hoverHTML_0(valueJ, recordJ, rowNum, colNum);
  }
  ));
}

function $setLeaveScrollbarGap(this$static, leaveScrollbarGap){
  $isCreated_1(this$static)?!leaveScrollbarGap?$setNullProperty(this$static, 'leaveScrollbarGap'):$setProperty_4(this$static, 'leaveScrollbarGap', leaveScrollbarGap.value_0):setAttribute_5(this$static.config_0, 'leaveScrollbarGap', leaveScrollbarGap);
}

function $setLoadingDataMessage(this$static){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'loadingDataMessage', null):(this$static.config_0['loadingDataMessage'] = null , undefined);
}

function $setLoadingMessage(this$static, loadingMessage){
  $isCreated_1(this$static)?undefined:(this$static.config_0['loadingMessage'] = loadingMessage , undefined);
}

function $setRecords(this$static, records){
  $isCreated_1(this$static)?$setProperty_2(this$static, 'data', convertToJavaScriptArray(records)):(this$static.config_0['data'] = convertToJavaScriptArray(records) , undefined);
}

function $setResizeFieldsInRealTime(this$static, resizeFieldsInRealTime){
  $isCreated_1(this$static)?!resizeFieldsInRealTime?$setNullProperty(this$static, 'resizeFieldsInRealTime'):$setProperty_4(this$static, 'resizeFieldsInRealTime', resizeFieldsInRealTime.value_0):setAttribute_5(this$static.config_0, 'resizeFieldsInRealTime', resizeFieldsInRealTime);
}

function $setShowAllRecords(this$static, showAllRecords){
  $isCreated_1(this$static)?!showAllRecords?$setNullProperty(this$static, 'showAllRecords'):$setProperty_4(this$static, 'showAllRecords', showAllRecords.value_0):setAttribute_5(this$static.config_0, 'showAllRecords', showAllRecords);
}

function $setShowEmptyMessage(this$static, showEmptyMessage){
  $isCreated_1(this$static)?!showEmptyMessage?$setNullProperty(this$static, 'showEmptyMessage'):$setProperty_4(this$static, 'showEmptyMessage', showEmptyMessage.value_0):setAttribute_5(this$static.config_0, 'showEmptyMessage', showEmptyMessage);
}

function $setShowHover(this$static, showHover){
  $isCreated_1(this$static)?!showHover?$setNullProperty(this$static, 'showHover'):$setProperty_4(this$static, 'showHover', showHover.value_0):setAttribute_5(this$static.config_0, 'showHover', showHover);
}

function $setShowRecordComponents(this$static, showRecordComponents){
  $isCreated_1(this$static)?!showRecordComponents?$setNullProperty(this$static, 'showRecordComponents'):$setProperty_4(this$static, 'showRecordComponents', showRecordComponents.value_0):setAttribute_5(this$static.config_0, 'showRecordComponents', showRecordComponents);
}

function $setShowRecordComponentsByCell(this$static, showRecordComponentsByCell){
  $isCreated_1(this$static)?!showRecordComponentsByCell?$setNullProperty(this$static, 'showRecordComponentsByCell'):$setProperty_4(this$static, 'showRecordComponentsByCell', showRecordComponentsByCell.value_0):setAttribute_5(this$static.config_0, 'showRecordComponentsByCell', showRecordComponentsByCell);
  showRecordComponentsByCell.value_0 && $setAttribute_24(this$static, 'recordComponentPosition', ($clinit_EmbeddedPosition() , WITHIN).value_0, true);
}

function $setShowRollOver_2(this$static, showRollOver){
  $isCreated_1(this$static)?!showRollOver?$setNullProperty(this$static, 'showRollOver'):$setProperty_4(this$static, 'showRollOver', showRollOver.value_0):setAttribute_5(this$static.config_0, 'showRollOver', showRollOver);
}

function $setSort(this$static, sortSpecifiers){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.setSort(convertToJavaScriptArray(sortSpecifiers));
}

function $setSortDirection(this$static, sortDirection){
  !sortDirection?$isCreated_1(this$static)?$setNullProperty(this$static, 'sortDirection'):setAttribute_5(this$static.config_0, 'sortDirection', null):$setAttribute_22(this$static, 'sortDirection', ($clinit_Boolean() , sortDirection == ($clinit_SortDirection() , ASCENDING)?TRUE:FALSE), true);
}

function $setSortField(this$static){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'sortField', 'name'):(this$static.config_0['sortField'] = 'name' , undefined);
}

function $setUseAllDataSourceFields(this$static, useAllDataSourceFields){
  $isCreated_1(this$static)?!useAllDataSourceFields?$setNullProperty(this$static, 'useAllDataSourceFields'):$setProperty_4(this$static, 'useAllDataSourceFields', useAllDataSourceFields.value_0):setAttribute_5(this$static.config_0, 'useAllDataSourceFields', useAllDataSourceFields);
}

function $setViewState(this$static, viewState){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.setViewState(viewState);
}

function $setWrapCells(this$static, wrapCells){
  $isCreated_1(this$static)?!wrapCells?$setNullProperty(this$static, 'wrapCells'):$setProperty_4(this$static, 'wrapCells', wrapCells.value_0):setAttribute_5(this$static.config_0, 'wrapCells', wrapCells);
}

function $setupCellClickEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({cellClick:$debox($entry(function(){
      var param = {record:arguments[0], rowNum:arguments[1], colNum:arguments[2]};
      var event_0 = new CellClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.cellClick = $debox($entry(function(){
      var param = {record:arguments[0], rowNum:arguments[1], colNum:arguments[2]};
      var event_0 = new CellClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupFieldStateChangedEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({fieldStateChanged:$entry(function(){
      var param = {};
      var event_0 = new FieldStateChangedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    )});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.fieldStateChanged = $entry(function(){
      var param = {};
      var event_0 = new FieldStateChangedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    );
  }
}

function $setupRecordCollapseEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({onCollapseRecord:$debox($entry(function(){
      var param = {record:arguments[0]};
      var event_0 = new RecordCollapseEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.onCollapseRecord = $debox($entry(function(){
      var param = {record:arguments[0]};
      var event_0 = new RecordCollapseEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupRecordDropEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({onRecordDrop:$debox($entry(function(){
      var param = {dropRecords:arguments[0], targetRecord:arguments[1], index:arguments[2], sourceWidget:arguments[3]};
      var event_0 = new RecordDropEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.onRecordDrop = $debox($entry(function(){
      var param = {dropRecords:arguments[0], targetRecord:arguments[1], index:arguments[2], sourceWidget:arguments[3]};
      var event_0 = new RecordDropEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupRecordExpandEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({onExpandRecord:$debox($entry(function(){
      var param = {record:arguments[0]};
      var event_0 = new RecordExpandEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.onExpandRecord = $debox($entry(function(){
      var param = {record:arguments[0]};
      var event_0 = new RecordExpandEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupRowEditorExitEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({rowEditorExit:$debox($entry(function(){
      var param = {editCompletionEvent:arguments[0], record:arguments[1], newValues:arguments[2], rowNum:arguments[3]};
      var event_0 = new RowEditorExitEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.rowEditorExit = $debox($entry(function(){
      var param = {editCompletionEvent:arguments[0], record:arguments[1], newValues:arguments[2], rowNum:arguments[3]};
      var event_0 = new RowEditorExitEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $showField(this$static, fieldName){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.showField(fieldName);
}

function $sort(this$static, sortField, sortDirection){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.sort(sortField, sortDirection.getValue_0());
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $updateData(this$static, record){
  var self_0 = this$static.getOrCreateJsObj();
  var recordJS = record.getJsObj();
  self_0.updateData(recordJS);
}

function $validateRow(this$static, rowNum){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.validateRow(rowNum);
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

defineSeed(538, 441, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers]));
_.addRecordDropHandler = function addRecordDropHandler(handler){
  $getHandlerCount_1(this, (!TYPE_42 && (TYPE_42 = new GwtEvent$Type_0) , TYPE_42)) == 0 && $setupRecordDropEvent(this);
  return $doAddHandler_0(this, handler, (!TYPE_42 && (TYPE_42 = new GwtEvent$Type_0) , TYPE_42));
}
;
_.getRecords = function getRecords(){
  return getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this, 'groupTree'))?convertToListGridRecordArray($getAttributeAsJavaScriptObject_1(this, 'originalData')):convertToListGridRecordArray($getAttributeAsJavaScriptObject_1(this, 'data'));
}
;
_.getSelectedRecord_0 = function getSelectedRecord(){
  var self_0 = this.getOrCreateJsObj();
  var ret = self_0.getSelectedRecord();
  if (ret == null || ret === undefined)
    return null;
  var retVal = getRef(ret);
  retVal == null && (retVal = new ListGridRecord_1(ret));
  return retVal;
}
;
_.setCanAcceptDroppedRecords = function setCanAcceptDroppedRecords(canAcceptDroppedRecords){
  $isCreated_1(this)?!canAcceptDroppedRecords?$setNullProperty(this, 'canAcceptDroppedRecords'):$setProperty_4(this, 'canAcceptDroppedRecords', canAcceptDroppedRecords.value_0):setAttribute_5(this.config_0, 'canAcceptDroppedRecords', canAcceptDroppedRecords);
}
;
_.setCanDragRecordsOut = function setCanDragRecordsOut(canDragRecordsOut){
  $isCreated_1(this)?!canDragRecordsOut?$setNullProperty(this, 'canDragRecordsOut'):$setProperty_4(this, 'canDragRecordsOut', canDragRecordsOut.value_0):setAttribute_5(this.config_0, 'canDragRecordsOut', canDragRecordsOut);
}
;
_.setCanReorderRecords = function setCanReorderRecords(canReorderRecords){
  $isCreated_1(this)?!canReorderRecords?$setNullProperty(this, 'canReorderRecords'):$setProperty_4(this, 'canReorderRecords', canReorderRecords.value_0):setAttribute_5(this.config_0, 'canReorderRecords', canReorderRecords);
}
;
_.setData = function setData(data){
  $isCreated_1(this)?$setProperty_2(this, 'data', convertToJavaScriptArray(data)):(this.config_0['data'] = convertToJavaScriptArray(data) , undefined);
}
;
function $addChangeHandler_0(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_35 && (TYPE_35 = new GwtEvent$Type_0) , TYPE_35)) == 0 && $setupChangeEvent_0(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_35 && (TYPE_35 = new GwtEvent$Type_0) , TYPE_35));
}

function $addChangedHandler_0(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_36 && (TYPE_36 = new GwtEvent$Type_0) , TYPE_36)) == 0 && $setupChangedEvent_0(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_36 && (TYPE_36 = new GwtEvent$Type_0) , TYPE_36));
}

function $addRecordClickHandler_0(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_39 && (TYPE_39 = new GwtEvent$Type_0) , TYPE_39)) == 0 && $setupRecordClickEvent_0(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_39 && (TYPE_39 = new GwtEvent$Type_0) , TYPE_39));
}

function $setEditorType(this$static, editorType){
  var editorConfig, fiEditorType;
  if (!$equals_6(editorType.___clazz$.typeName, Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit.typeName)) {
    fiEditorType = $isCreated_2(editorType)?$getPropertyAsString(editorType, 'editorType'):getAttribute(editorType.jsObj, 'editorType');
    fiEditorType == null && (fiEditorType = $isCreated_2(editorType)?$getPropertyAsString(editorType, 'type'):getAttribute(editorType.jsObj, 'type'));
    fiEditorType != null && (this$static.jsObj['editorType'] = fiEditorType , undefined);
  }
  editorConfig = $getConfig(editorType);
  this$static.jsObj['editorProperties'] = editorConfig;
}

function $setFilterEditorType(this$static, filterEditorType){
  var editorConfig, type;
  type = $isCreated_2(filterEditorType)?$getPropertyAsString(filterEditorType, 'editorType'):getAttribute(filterEditorType.jsObj, 'editorType');
  type == null && (type = $isCreated_2(filterEditorType)?$getPropertyAsString(filterEditorType, 'type'):getAttribute(filterEditorType.jsObj, 'type'));
  this$static.jsObj['filterEditorType'] = type;
  editorConfig = $getConfig(filterEditorType);
  this$static.jsObj['filterEditorProperties'] = editorConfig;
}

function $setIconHeight_1(this$static, iconHeight){
  setAttribute_8(this$static.jsObj, 'iconHeight', iconHeight);
}

function $setIconWidth_1(this$static, iconWidth){
  setAttribute_8(this$static.jsObj, 'iconWidth', iconWidth);
}

function $setValueIconHeight_0(this$static, valueIconHeight){
  setAttribute_8(this$static.jsObj, 'valueIconHeight', valueIconHeight);
}

function $setValueIconSize(this$static, valueIconSize){
  setAttribute_8(this$static.jsObj, 'valueIconSize', valueIconSize);
}

function $setValueIconWidth_0(this$static, valueIconWidth){
  setAttribute_8(this$static.jsObj, 'valueIconWidth', valueIconWidth);
}

function $setupChangeEvent_0(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.change = $debox($entry(function(){
    var param = {form:arguments[0], item:arguments[1], value:arguments[2], oldValue:arguments[3], sourceJSO:this};
    var event_0 = new ChangeEvent_2(param);
    selfJ.fireEvent_0(event_0);
    var ret = event_0.isCancelled();
    return !ret;
  }
  ));
}

function $setupChangedEvent_0(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.changed = $entry(function(){
    var param = {form:arguments[0], item:arguments[1], value:arguments[2], sourceJSO:this};
    var event_0 = new ChangedEvent_2(param);
    selfJ.fireEvent_0(event_0);
  }
  );
}

function $setupRecordClickEvent_0(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.recordClick = $debox($entry(function(){
    var param = {viewer:arguments[0], record:arguments[1], recordNum:arguments[2], field:arguments[3], fieldNum:arguments[4], value:arguments[5], rawValue:arguments[6]};
    var event_0 = new RecordClickEvent_0(param);
    selfJ.fireEvent_0(event_0);
    var ret = event_0.isCancelled();
    return !ret;
  }
  ));
}

function ListGridField_2(name_0, width){
  DataClass_0.call(this);
  this.jsObj['name'] = name_0;
  this.jsObj['width'] = width;
}

function ListGridField_4(name_0, title, width){
  DataClass_0.call(this);
  this.jsObj['name'] = name_0;
  this.jsObj['title'] = title;
  this.jsObj['width'] = width;
}

defineSeed(539, 326, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$ListGridField, Q$HasCellSavedHandlers, Q$HasChangeHandlers_0, Q$HasChangedHandlers_0, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers]), ListGridField_2, ListGridField_4);
function $setBackgroundComponent(this$static, backgroundComponent){
  $setAttribute_5(this$static, 'backgroundComponent', !backgroundComponent?null:$getOrCreateJsObj_0(backgroundComponent));
}

defineSeed(540, 340, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord]));
_.getEnabled = function getEnabled(){
  return $clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'enabled')?TRUE:FALSE;
}
;
_.setEnabled = function setEnabled(enabled){
  setAttribute_5(this.jsObj, 'enabled', enabled);
}
;
function $getRecord(this$static){
  var jsObj = this$static.jsObj;
  if (jsObj.record == null)
    return null;
  var retVal = getRef(jsObj.record);
  retVal == null && (retVal = new ListGridRecord_1(jsObj.record));
  return retVal;
}

defineSeed(542, 461, {});
function CellClickEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(541, 542, {}, CellClickEvent_0);
_.dispatch = function dispatch_34(handler){
  dynamicCast(handler, Q$CellClickHandler).onCellClick(this);
}
;
_.getAssociatedType = function getAssociatedType_34(){
  return TYPE_34;
}
;
_.isCancelled = function isCancelled_15(){
  return false;
}
;
var TYPE_34 = null;
function $dispatch_6(this$static, handler){
  var rowNum;
  rowNum = $getRowNum(this$static);
  $getValue_3(this$static) == null || toString__devirtual$($getValue_3(this$static)).length == 0?$setEditValue_0(handler.val$memberValuesGrid, rowNum, 'memberValuesEditor-unsetField', true):$setEditValue_0(handler.val$memberValuesGrid, rowNum, 'memberValuesEditor-unsetField', false);
}

function $getRowNum(this$static){
  var jsObj = this$static.jsObj;
  if (jsObj.item) {
    return jsObj.item.rowNum;
  }
   else {
    var listGrid = jsObj.sourceJSO;
    return listGrid.getEventRow();
  }
}

function $getValue_3(this$static){
  var jsObj = this$static.jsObj;
  return $wnd.SmartGWT.convertToJavaType(jsObj.value);
}

function ChangeEvent_2(jsObj){
  this.jsObj = jsObj;
}

defineSeed(543, 352, {}, ChangeEvent_2);
_.dispatch = function dispatch_35(handler){
  $dispatch_6(this, dynamicCast(handler, Q$ChangeHandler_0));
}
;
_.getAssociatedType = function getAssociatedType_35(){
  return TYPE_35;
}
;
_.isCancelled = function isCancelled_16(){
  return false;
}
;
var TYPE_35 = null;
function $getRowNum_0(this$static){
  var jsObj = this$static.jsObj;
  if (jsObj.item) {
    return jsObj.item.rowNum;
  }
   else {
    var listGrid = jsObj.sourceJSO;
    return listGrid.getEventRow();
  }
}

function $getValue_4(this$static){
  var jsObj = this$static.jsObj;
  return $wnd.SmartGWT.convertToJavaType(jsObj.value);
}

function ChangedEvent_2(jsObj){
  this.jsObj = jsObj;
}

defineSeed(544, 352, {}, ChangedEvent_2);
_.dispatch = function dispatch_36(handler){
  dynamicCast(handler, Q$ChangedHandler_0).onChanged_0(this);
}
;
_.getAssociatedType = function getAssociatedType_36(){
  return TYPE_36;
}
;
var TYPE_36 = null;
function FieldStateChangedEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(546, 461, {}, FieldStateChangedEvent_0);
_.dispatch = function dispatch_38(handler){
  dynamicCast(handler, Q$FieldStateChangedHandler).onFieldStateChanged(this);
}
;
_.getAssociatedType = function getAssociatedType_38(){
  return TYPE_38;
}
;
var TYPE_38 = null;
function $dispatch_7(this$static){
  var jsObj;
  (jsObj = this$static.jsObj , getOrCreateRef_1(jsObj.record)).jsObj['Expanded'] = false;
}

function RecordCollapseEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(548, 461, {}, RecordCollapseEvent_0);
_.dispatch = function dispatch_40(handler){
  $dispatch_7(this, dynamicCast(handler, Q$RecordCollapseHandler));
}
;
_.getAssociatedType = function getAssociatedType_40(){
  return TYPE_40;
}
;
_.isCancelled = function isCancelled_18(){
  return false;
}
;
var TYPE_40 = null;
function RecordDropEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(550, 461, {}, RecordDropEvent_0);
_.dispatch = function dispatch_42(handler){
  dynamicCast(handler, Q$RecordDropHandler).onRecordDrop_0(this);
}
;
_.getAssociatedType = function getAssociatedType_42(){
  return TYPE_42;
}
;
_.isCancelled = function isCancelled_19(){
  return this.cancel;
}
;
_.cancel = false;
var TYPE_42 = null;
function $dispatch_8(this$static){
  var jsObj;
  (jsObj = this$static.jsObj , getOrCreateRef_1(jsObj.record)).jsObj['Expanded'] = true;
}

function RecordExpandEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(551, 461, {}, RecordExpandEvent_0);
_.dispatch = function dispatch_43(handler){
  $dispatch_8(this, dynamicCast(handler, Q$RecordExpandHandler));
}
;
_.getAssociatedType = function getAssociatedType_43(){
  return TYPE_43;
}
;
_.isCancelled = function isCancelled_20(){
  return false;
}
;
var TYPE_43 = null;
function $dispatch_9(this$static, handler){
  var jsObj;
  $validateRow(handler.val$memberValuesGrid, (jsObj = this$static.jsObj , jsObj.rowNum));
  $hasErrors_0(handler.val$memberValuesGrid).value_0?$disable(handler.val$okButton):$enable(handler.val$okButton);
}

function RowEditorExitEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(552, 461, {}, RowEditorExitEvent_0);
_.dispatch = function dispatch_44(handler){
  $dispatch_9(this, dynamicCast(handler, Q$RowEditorExitHandler));
}
;
_.getAssociatedType = function getAssociatedType_44(){
  return TYPE_44;
}
;
_.isCancelled = function isCancelled_21(){
  return false;
}
;
var TYPE_44 = null;
function $getRecord_1(this$static){
  var jsObj = this$static.jsObj;
  return getOrCreateRef_1(jsObj.record);
}

function $getState(this$static){
  var jsObj = this$static.jsObj;
  return jsObj.state;
}

function HLayout_1(membersMargin){
  $clinit_BaseWidget();
  Layout_0.call(this);
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', membersMargin):(this.config_0['membersMargin'] = membersMargin , undefined);
  this.scClassName = 'HLayout';
}

defineSeed(554, 446, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout]), HLayout_1);
function $addSection(this$static, section){
  var componentJS, container, config;
  componentJS = section.jsObj;
  $isCreated_1(this$static)?(container = this$static.getOrCreateJsObj() , container.addSection(componentJS) , undefined):(config = this$static.config_0 , !config.sections && (config.sections = createJavaScriptArray()) , config.sections.push(componentJS) , undefined);
  section.stack = this$static;
}

function $collapseSection(this$static, index){
  var container = this$static.getOrCreateJsObj();
  container.collapseSection(index);
}

function $collapseSection_0(this$static, sectionID){
  var container = this$static.getOrCreateJsObj();
  container.collapseSection(sectionID);
}

function $expandSection(this$static, index){
  var container = this$static.getOrCreateJsObj();
  container.expandSection(index);
}

function $expandSection_0(this$static, sectionID){
  var container = this$static.getOrCreateJsObj();
  container.expandSection(sectionID);
}

function $getSection(this$static, sectionID){
  var self_0 = this$static.getOrCreateJsObj();
  var ret = self_0.getSectionConfig(sectionID);
  if (ret == null || ret === undefined)
    return null;
  var retVal = getOrCreateRef_9(ret);
  return retVal;
}

function $getSections(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var ret = self_0.sections;
  if (ret == null || ret === undefined)
    return null;
  var sectionsArr = createJavaScriptArray();
  for (var i = 0; i < ret.length; i++) {
    var jsSectionHeader = ret[i];
    sectionsArr[i] = jsSectionHeader.getSectionConfig?jsSectionHeader.getSectionConfig():jsSectionHeader;
  }
  return this$static.convertToSectionArray(sectionsArr);
}

function $setScrollSectionIntoView(this$static, scrollSectionIntoView){
  $isCreated_1(this$static)?undefined:setAttribute_5(this$static.config_0, 'scrollSectionIntoView', scrollSectionIntoView);
}

function $setSectionTitle(this$static, sectionID, newTitle){
  var self_0 = this$static.getOrCreateJsObj();
  return self_0.setSectionTitle(sectionID, newTitle);
}

function $showSection(this$static, index){
  var container = this$static.getOrCreateJsObj();
  container.showSection(index);
}

function SectionStack_0(){
  $clinit_BaseWidget();
  VLayout_0.call(this);
  this.scClassName = 'SectionStack';
}

defineSeed(557, 445, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), SectionStack_0);
_.convertToSectionArray = function convertToSectionArray(nativeArray){
  var componentJS, componentsj, i, obj_0, objects;
  if (!nativeArray) {
    return initValues(_3Lcom_smartgwt_client_widgets_layout_SectionStackSection_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SectionStackSection, []);
  }
  componentsj = toArray_3(nativeArray);
  objects = initDim(_3Lcom_smartgwt_client_widgets_layout_SectionStackSection_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SectionStackSection, componentsj.length, 0);
  for (i = 0; i < componentsj.length; ++i) {
    componentJS = componentsj[i];
    obj_0 = getOrCreateRef_9(componentJS);
    objects[i] = obj_0;
  }
  return objects;
}
;
_.create_0 = function create_31(){
  var config = this.getConfig();
  var scClassName = this.scClassName;
  var widget = $wnd.isc[scClassName].create(config);
  this.doInit();
  return widget;
}
;
_.setOverflow = function setOverflow_1(overflow){
  $setAttribute_24(this, 'overflow', overflow.value_0, false);
}
;
_.setStyleName = function setStyleName_3(styleName){
  $isCreated_1(this)?undefined:(this.config_0['styleName'] = styleName , undefined);
}
;
function $addItemJS(this$static, componentJS){
  var jsObj = this$static.getJsObj();
  !jsObj.items && (jsObj.items = createJavaScriptArray());
  jsObj.items.push(componentJS);
}

function $setExpanded(this$static, expanded){
  !this$static.stack || !$isDrawn(this$static.stack).value_0?setAttribute_5(this$static.jsObj, 'expanded', expanded):expanded.value_0?$expandSection_0(this$static.stack, getAttribute(this$static.jsObj, 'name')):$collapseSection_0(this$static.stack, getAttribute(this$static.jsObj, 'name'));
}

function $setItems(this$static, items){
  var item, item$index, item$max;
  for (item$index = 0 , item$max = items.length; item$index < item$max; ++item$index) {
    item = items[item$index];
    $addItemJS(this$static, $getOrCreateJsObj_0(item));
  }
}

function SectionStackSection_0(jsObj){
  RefDataClass_1.call(this, jsObj);
}

function SectionStackSection_1(title){
  RefDataClass_0.call(this);
  !this.stack || !$isDrawn(this.stack).value_0?(this.jsObj['title'] = title , undefined):$setSectionTitle(this.stack, getAttribute(this.jsObj, 'name'), title);
  $setAttribute_13(this, 'ID', generateID('SectionStackSection'));
}

function getOrCreateRef_9(jsObj){
  var obj_0;
  if (!jsObj)
    return null;
  obj_0 = getRef(jsObj);
  if (obj_0) {
    obj_0.jsObj = jsObj;
    return dynamicCast(obj_0, Q$SectionStackSection);
  }
   else {
    return new SectionStackSection_0(jsObj);
  }
}

defineSeed(558, 331, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$SectionStackSection]), SectionStackSection_0, SectionStackSection_1);
_.stack = null;
function VStack_0(){
  $clinit_BaseWidget();
  Layout_0.call(this);
  this.scClassName = 'VStack';
}

defineSeed(559, 446, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout]), VStack_0);
_.create_0 = function create_32(){
  var config = this.getConfig();
  var scClassName = this.scClassName;
  var widget = $wnd.isc[scClassName].create(config);
  this.doInit();
  return widget;
}
;
function $setShowMenuBelow(this$static, showMenuBelow){
  $isCreated_1(this$static)?!showMenuBelow?$setNullProperty(this$static, 'showMenuBelow'):$setProperty_4(this$static, 'showMenuBelow', showMenuBelow.value_0):setAttribute_5(this$static.config_0, 'showMenuBelow', showMenuBelow);
}

function IMenuButton_1(title, menu){
  $clinit_BaseWidget();
  StretchImgButton_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'title', title):(this.config_0['title'] = title , undefined);
  $setAttribute_20(this, 'menu', !menu?null:$getOrCreateJsObj_0(menu), true);
  this.scClassName = 'IMenuButton';
}

defineSeed(560, 453, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$StatefulCanvas, Q$StretchImg, Q$StretchImgButton, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasIconClickHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), IMenuButton_1);
function $addItemClickHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_46 && (TYPE_46 = new GwtEvent$Type_0) , TYPE_46)) == 0 && $setupItemClickEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_46 && (TYPE_46 = new GwtEvent$Type_0) , TYPE_46));
}

function $getItemNum(this$static, item){
  var self_0 = this$static.getOrCreateJsObj();
  var itemJS = item.getJsObj();
  return self_0.getItemNum(itemJS);
}

function $setupItemClickEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({itemClick:$debox($entry(function(){
      var param = {item:arguments[0], colNum:arguments[1]};
      var event_0 = new ItemClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.itemClick = $debox($entry(function(){
      var param = {item:arguments[0], colNum:arguments[1]};
      var event_0 = new ItemClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function Menu_1(jsObj){
  Canvas_2.call(this, jsObj);
}

function getOrCreateRef_10(jsObj){
  $clinit_BaseWidget();
  var obj_0;
  if (!jsObj)
    return null;
  obj_0 = !jsObj?null:dynamicCast(getAttributeAsObject(jsObj, '__ref'), Q$BaseWidget);
  return obj_0?dynamicCast(obj_0, Q$Menu):new Menu_1(jsObj);
}

defineSeed(561, 538, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$Menu]), Menu_1);
_.setData = function setData_0(data){
  $isCreated_1(this)?$setProperty_2(this, 'data', convertToJavaScriptArray(data)):(this.config_0['data'] = convertToJavaScriptArray(data) , undefined);
}
;
defineSeed(562, 540, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$MenuItem, Q$HasClickHandlers_1]));
_.getEnabled = function getEnabled_0(){
  return $clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'enabled')?TRUE:FALSE;
}
;
_.setEnabled = function setEnabled_0(enabled){
  setAttribute_5(this.jsObj, 'enabled', enabled);
}
;
function $dispatch_10(this$static, handler){
  var key, name_0;
  key = $getAttribute($getItem_1(this$static), 'portletKey');
  name_0 = $getAttributeAsString($getItem_1(this$static), 'title');
  $addPortlet_1(handler.this$0, key, name_0);
}

function $getItem_1(this$static){
  var jsObj = this$static.jsObj;
  var retVal = getOrCreateRef_11(jsObj.item);
  return retVal;
}

function ItemClickEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(564, 461, {}, ItemClickEvent_0);
_.dispatch = function dispatch_46(handler){
  $dispatch_10(this, dynamicCast(handler, Q$ItemClickHandler));
}
;
_.getAssociatedType = function getAssociatedType_46(){
  return TYPE_46;
}
;
_.isCancelled = function isCancelled_22(){
  return false;
}
;
var TYPE_46 = null;
function $getItem_2(this$static){
  var jsObj = this$static.jsObj;
  return getOrCreateRef_11(jsObj.item);
}

function $addTabDeselectedHandler(this$static, handler){
  $getHandlerCount_0(this$static, (!TYPE_49 && (TYPE_49 = new GwtEvent$Type_0) , TYPE_49)) == 0 && $setupTabDeselectedEvent(this$static);
  return $doAddHandler(this$static, handler, (!TYPE_49 && (TYPE_49 = new GwtEvent$Type_0) , TYPE_49));
}

function $setID_1(this$static, ID){
  isValidID(ID);
  this$static.jsObj['ID'] = ID;
}

function $setIcon_3(this$static, icon){
  !this$static.tabSet || !$isDrawn(this$static.tabSet).value_0?(this$static.jsObj['icon'] = icon , undefined):$setTabIcon(this$static.tabSet, getAttribute(this$static.jsObj, 'ID'), icon);
}

function $setPane(this$static, pane){
  !this$static.tabSet || !$isCreated_1(this$static.tabSet)?$setAttribute_5(this$static, 'pane', $getOrCreateJsObj_0(pane)):$updateTab(this$static.tabSet, this$static, pane);
}

function $setTitle_2(this$static, title){
  !this$static.tabSet || !$isDrawn(this$static.tabSet).value_0?(this$static.jsObj['title'] = title , undefined):$setTabTitle(this$static.tabSet, this$static, title);
}

function $setupTabDeselectedEvent(this$static){
  var obj_0 = null;
  obj_0 = this$static.getJsObj();
  var selfJ = this$static;
  obj_0.tabDeselected = $debox($entry(function(){
    var param = {tabSet:arguments[0], tabNum:arguments[1], tabPane:arguments[2], ID:arguments[3], tab:arguments[4], newTab:arguments[5]};
    var event_0 = new TabDeselectedEvent_0(param);
    selfJ.fireEvent_0(event_0);
    var ret = event_0.isCancelled();
    return !ret;
  }
  ));
}

function Tab_0(jsObj){
  RefDataClass_1.call(this, jsObj);
}

function Tab_1(title){
  RefDataClass_0.call(this);
  !this.tabSet || !$isDrawn(this.tabSet).value_0?(this.jsObj['title'] = title , undefined):$setTabTitle(this.tabSet, this, title);
  $setID_1(this, generateID(this.___clazz$.typeName));
}

function Tab_2(title, icon){
  RefDataClass_0.call(this);
  !this.tabSet || !$isDrawn(this.tabSet).value_0?(this.jsObj['title'] = title , undefined):$setTabTitle(this.tabSet, this, title);
  !this.tabSet || !$isDrawn(this.tabSet).value_0?(this.jsObj['icon'] = icon , undefined):$setTabIcon(this.tabSet, getAttribute(this.jsObj, 'ID'), icon);
  $setID_1(this, generateID(this.___clazz$.typeName));
}

function getOrCreateRef_12(jsObj){
  var obj_0;
  if (!jsObj)
    return null;
  obj_0 = getRef(jsObj);
  if (obj_0) {
    obj_0.jsObj = jsObj;
    return dynamicCast(obj_0, Q$Tab);
  }
   else {
    return new Tab_0(jsObj);
  }
}

defineSeed(566, 331, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Tab, Q$HasTabDeselectedHandlers, Q$HasTabSelectedHandlers]), Tab_0, Tab_1, Tab_2);
_.getPane = function getPane(){
  return getOrCreateRef_3(getAttributeAsJavaScriptObject(this.jsObj, 'pane'));
}
;
_.getTabSet = function getTabSet(){
  return this.tabSet;
}
;
_.getTitle = function getTitle_1(){
  return !this.tabSet || !$isDrawn(this.tabSet).value_0?getAttribute(this.jsObj, 'title'):$getAttributeAsString($getTab(this.tabSet, getAttribute(this.jsObj, 'ID')), 'title');
}
;
_.tabSet = null;
function $addCloseClickHandler_0(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_48 && (TYPE_48 = new GwtEvent$Type_0) , TYPE_48)) == 0 && $setupCloseClickEvent_0(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_48 && (TYPE_48 = new GwtEvent$Type_0) , TYPE_48));
}

function $addTab(this$static, tab){
  var tabJS, container, config;
  tab.tabSet = this$static;
  tabJS = tab.jsObj;
  $isCreated_1(this$static)?(container = this$static.getOrCreateJsObj() , container.addTab(tabJS) , undefined):(config = this$static.config_0 , !config.tabs && (config.tabs = createJavaScriptArray()) , config.tabs.push(tabJS) , undefined);
}

function $addTab_0(this$static, tab, position){
  var tabJS, container, config;
  tabJS = tab.jsObj;
  $isCreated_1(this$static)?(container = this$static.getOrCreateJsObj() , container.addTab(tabJS, position) , undefined):(config = this$static.config_0 , !config.tabs && (config.tabs = createJavaScriptArray()) , config.tabs.splice(position, 0, tabJS) , undefined);
}

function $addTabSelectedHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_50 && (TYPE_50 = new GwtEvent$Type_0) , TYPE_50)) == 0 && $setupTabSelectedEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_50 && (TYPE_50 = new GwtEvent$Type_0) , TYPE_50));
}

function $getSelectedTab(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var ret = self_0.getSelectedTab();
  return ret == null?null:getRef(ret);
}

function $getTab(this$static, ID){
  var self_0 = this$static.getOrCreateJsObj();
  var ret = self_0.getTabObject(ID);
  return ret == null?null:getRef(ret);
}

function $getTabNumber(this$static, ID){
  var self_0 = this$static.getOrCreateJsObj();
  return self_0.getTabNumber(ID);
}

function $removeTab(this$static, tab){
  var self_0 = this$static.getOrCreateJsObj();
  var tabJS = tab.getJsObj();
  self_0.removeTab(tabJS);
}

function $selectTab(this$static, tabIndex){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.selectTab(tabIndex);
}

function $selectTab_0(this$static, tab){
  var self_0 = this$static.getOrCreateJsObj();
  var tabJS = tab.getJsObj();
  self_0.selectTab(tabJS);
}

function $setDestroyPanes(this$static, destroyPanes){
  $isCreated_1(this$static)?undefined:setAttribute_5(this$static.config_0, 'destroyPanes', destroyPanes);
}

function $setTabIcon(this$static, ID, iconURL){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.setTabIcon(ID, iconURL);
}

function $setTabTitle(this$static, tab, title){
  var self_0 = this$static.getOrCreateJsObj();
  var tabJS = tab.getJsObj();
  self_0.setTabTitle(tabJS, title);
}

function $setTabs(this$static, tabs){
  var tab, tab$index, tab$max;
  for (tab$index = 0 , tab$max = tabs.length; tab$index < tab$max; ++tab$index) {
    tab = tabs[tab$index];
    $addTab(this$static, tab);
  }
}

function $setupCloseClickEvent_0(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({onCloseClick:$debox($entry(function(){
      var liveTab = arguments[0];
      var tabObj = this.getTabObject(liveTab);
      var param = {tab:tabObj};
      var event_0 = new TabCloseClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.onCloseClick = $debox($entry(function(){
      var liveTab = arguments[0];
      var tabObj = this.getTabObject(liveTab);
      var param = {tab:tabObj};
      var event_0 = new TabCloseClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function $setupTabSelectedEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({tabSelected:$entry(function(){
      var param = {tabNum:arguments[0], tabPane:arguments[1], ID:arguments[2], tab:arguments[3]};
      var event_0 = new TabSelectedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    )});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.tabSelected = $entry(function(){
      var param = {tabNum:arguments[0], tabPane:arguments[1], ID:arguments[2], tab:arguments[3]};
      var event_0 = new TabSelectedEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    );
  }
}

function $updateTab(this$static, tab, pane){
  var self_0 = this$static.getOrCreateJsObj();
  var tabJS = tab.getJsObj();
  var paneJS = pane == null?null:pane.getOrCreateJsObj();
  self_0.updateTab(tabJS, paneJS);
}

function TabSet_0(){
  $clinit_BaseWidget();
  Canvas_1.call(this);
  this.scClassName = 'TabSet';
}

function convertToTabArray(nativeArray){
  var componentJS, componentsj, i, obj_0, objects;
  if (!nativeArray) {
    return initValues(_3Lcom_smartgwt_client_widgets_tab_Tab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Tab, []);
  }
  componentsj = toArray_3(nativeArray);
  objects = initDim(_3Lcom_smartgwt_client_widgets_tab_Tab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Tab, componentsj.length, 0);
  for (i = 0; i < componentsj.length; ++i) {
    componentJS = componentsj[i];
    obj_0 = dynamicCast(getRef(componentJS), Q$Tab);
    setCheck(objects, i, obj_0);
  }
  return objects;
}

defineSeed(567, 441, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$HasTabDeselectedHandlers, Q$HasTabSelectedHandlers]), TabSet_0);
_.create_0 = function create_35(){
  var config = this.getConfig();
  var scClassName = this.scClassName;
  var widget = $wnd.isc[scClassName].create(config);
  this.doInit();
  return widget;
}
;
function $dispatch_11(this$static, handler){
  var dashboardView;
  this$static.cancel = true;
  dashboardView = dynamicCast($getTab_0(this$static).getPane(), Q$DashboardView);
  ask(($clinit_Enhanced() , 'Are you sure you want to delete') + ' [' + dashboardView.storedDashboard.name_0 + ']?', new DashboardsView$6$1_0(handler, this$static, dashboardView));
}

function $getTab_0(this$static){
  var jsObj = this$static.jsObj;
  var retVal = getOrCreateRef_12(jsObj.tab);
  retVal == null && (retVal = new Tab_0(jsObj.tab));
  return retVal;
}

function TabCloseClickEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(568, 461, {}, TabCloseClickEvent_0);
_.dispatch = function dispatch_48(handler){
  $dispatch_11(this, dynamicCast(handler, Q$CloseClickHandler_0));
}
;
_.getAssociatedType = function getAssociatedType_48(){
  return TYPE_48;
}
;
_.isCancelled = function isCancelled_23(){
  return this.cancel;
}
;
_.cancel = false;
var TYPE_48 = null;
function $dispatch_12(this$static, handler){
  $validate_3(handler.this$0.generalProperties) || (this$static.cancel = true);
}

function TabDeselectedEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(569, 461, {}, TabDeselectedEvent_0);
_.dispatch = function dispatch_49(handler){
  $dispatch_12(this, dynamicCast(handler, Q$TabDeselectedHandler));
}
;
_.getAssociatedType = function getAssociatedType_49(){
  return TYPE_49;
}
;
_.isCancelled = function isCancelled_24(){
  return this.cancel;
}
;
_.cancel = false;
var TYPE_49 = null;
function $getTabNum(this$static){
  var jsObj = this$static.jsObj;
  return jsObj.tabNum;
}

function TabSelectedEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(570, 461, {}, TabSelectedEvent_0);
_.dispatch = function dispatch_50(handler){
  dynamicCast(handler, Q$TabSelectedHandler).onTabSelected(this);
}
;
_.getAssociatedType = function getAssociatedType_50(){
  return TYPE_50;
}
;
var TYPE_50 = null;
function $addSpacer(this$static, toolStripSpacer){
  var canvas;
  canvas = new Canvas_1;
  $isCreated_1(canvas)?$setProperty_0(canvas, 'width', 1):(canvas.config_0['width'] = 1 , undefined);
  $isCreated_1(canvas)?$setProperty_0(canvas, 'height', 1):(canvas.config_0['height'] = 1 , undefined);
  $isCreated_1(canvas)?$setProperty_3(canvas, 'border', 'none'):(canvas.config_0['border'] = 'none' , undefined);
  $setExtraSpace(canvas, toolStripSpacer.space);
  $addMember(this$static, canvas);
}

function ToolStripSpacer_0(space){
  this.space = space;
}

defineSeed(573, 1, {}, ToolStripSpacer_0);
_.space = 0;
function $find(this$static, fieldNameOrPath, value){
  var self_0 = this$static.getOrCreateJsObj();
  var nodeJS = self_0.find(fieldNameOrPath, value);
  return nodeJS == null?null:getOrCreateRef_14(nodeJS);
}

function $getAttributeAsJavaScriptObject_2(this$static){
  return $isCreated(this$static)?getAttributeAsJavaScriptObject($getJsObj(this$static), 'root'):$getAttributeAsJavaScriptObject(this$static, 'root');
}

function $getChildren(this$static, node){
  var self_0 = this$static.getOrCreateJsObj();
  var nodesJS = self_0.getChildren(node.getJsObj());
  return convertToTreeNodeArray(nodesJS);
}

function $getOpenList(this$static, node){
  var self_0 = this$static.getOrCreateJsObj();
  var nodesJS = self_0.getOpenList(node.getJsObj());
  return convertToTreeNodeArray(nodesJS);
}

function $getParent(this$static, node){
  var self_0 = this$static.getOrCreateJsObj();
  var parent_0 = self_0.getParent(node.getJsObj());
  if (parent_0 == null || parent_0 === undefined)
    return null;
  var parentJ = getOrCreateRef_14(parent_0);
  return parentJ;
}

function $getParents(this$static, node){
  var self_0 = this$static.getOrCreateJsObj();
  var nodesJS = self_0.getParents(node.getJsObj());
  return convertToTreeNodeArray(nodesJS);
}

function $getRoot(this$static){
  return getOrCreateRef_14($isCreated(this$static)?getAttributeAsJavaScriptObject($getJsObj(this$static), 'root'):$getAttributeAsJavaScriptObject(this$static, 'root'));
}

function $isOpen(this$static, node){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.isOpen(node.getJsObj());
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $isRoot(this$static, node){
  var self_0 = this$static.getOrCreateJsObj();
  var retVal = self_0.isRoot(node.getJsObj());
  if (retVal == null || retVal === undefined) {
    return null;
  }
   else {
    return toBoolean(retVal);
  }
}

function $linkNodes(this$static, nodes){
  var self_0 = this$static.getOrCreateJsObj();
  var nodesJS = convertToJavaScriptArray(nodes);
  self_0.linkNodes(nodesJS);
}

function $openFolder(this$static, node){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.openFolder(node.getJsObj());
}

function $openFolders(this$static, nodeList){
  var self_0 = this$static.getOrCreateJsObj();
  var nodeListJS = convertToJavaScriptArray(nodeList);
  self_0.openFolders(nodeListJS);
}

function $reloadChildren(this$static, node){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.reloadChildren(node.getJsObj());
}

function Tree_0(){
  BaseClass_0.call(this);
  this.scClassName = 'Tree';
}

function convertToTreeNodeArray(nativeArray){
  var componentJS, componentsj, i, obj_0, objects;
  if (!nativeArray) {
    return initValues(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, []);
  }
  componentsj = toArray_3(nativeArray);
  objects = initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, componentsj.length, 0);
  for (i = 0; i < componentsj.length; ++i) {
    componentJS = componentsj[i];
    obj_0 = getOrCreateRef_14(componentJS);
    setCheck(objects, i, obj_0);
  }
  return objects;
}

function convertToTreeNodeRecordArray(nativeArray){
  var componentJS, componentsj, i, obj_0, objects;
  if (!nativeArray) {
    return initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, []);
  }
  componentsj = toArray_3(nativeArray);
  objects = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, componentsj.length, 0);
  for (i = 0; i < componentsj.length; ++i) {
    componentJS = componentsj[i];
    obj_0 = dynamicCast(getRef(componentJS), Q$ListGridRecord);
    !obj_0 && (obj_0 = new TreeNode_1(componentJS));
    setCheck(objects, i, obj_0);
  }
  return objects;
}

defineSeed(574, 325, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$Tree]), Tree_0);
function $addDataArrivedHandler_1(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_51 && (TYPE_51 = new GwtEvent$Type_0) , TYPE_51)) == 0 && $setupDataArrivedEvent_1(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_51 && (TYPE_51 = new GwtEvent$Type_0) , TYPE_51));
}

function $addNodeClickHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_52 && (TYPE_52 = new GwtEvent$Type_0) , TYPE_52)) == 0 && $setupNodeClickEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_52 && (TYPE_52 = new GwtEvent$Type_0) , TYPE_52));
}

function $addNodeContextClickHandler(this$static, handler){
  $getHandlerCount_1(this$static, (!TYPE_53 && (TYPE_53 = new GwtEvent$Type_0) , TYPE_53)) == 0 && $setupNodeContextClickEvent(this$static);
  return $doAddHandler_0(this$static, handler, (!TYPE_53 && (TYPE_53 = new GwtEvent$Type_0) , TYPE_53));
}

function $fetchData_3(this$static, criteria){
  var self_0 = this$static.getOrCreateJsObj();
  self_0.fetchData(criteria == null?null:criteria.getJsObj());
}

function $fetchData_4(this$static, criteria, callback){
  var self_0 = this$static.getOrCreateJsObj();
  var critJS = criteria == null?null:criteria.getJsObj();
  self_0.fetchData(critJS, $entry(function(dsResponse, data, dsRequest){
    var responseJ = new DSResponse_1(dsResponse);
    var requestJ = new DSRequest_1(dsRequest);
    callback != null && callback.execute_2(responseJ, data, requestJ);
  }
  ));
}

function $getRecords(this$static){
  var i, node, nodes, records, root, tree, dataJS;
  tree = getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static, 'data'));
  if ($isCreated_1(this$static)) {
    root = getOrCreateRef_14($getAttributeAsJavaScriptObject_2(tree));
    if (!root) {
      return null;
    }
     else {
      nodes = $getOpenList(tree, getOrCreateRef_14($getAttributeAsJavaScriptObject_2(tree)));
      records = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, nodes.length, 0);
      for (i = 0; i < nodes.length; ++i) {
        node = nodes[i];
        setCheck(records, i, new ListGridRecord_1(node.jsObj));
      }
      return records;
    }
  }
   else {
    return dataJS = $isCreated(tree)?getAttributeAsJavaScriptObject($getJsObj(tree), 'data'):$getAttributeAsJavaScriptObject(tree, 'data') , convertToTreeNodeRecordArray(dataJS);
  }
}

function $getSelectedRecord_0(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  var ret = self_0.getSelectedRecord();
  if (ret == null || ret === undefined)
    return null;
  var retVal = getOrCreateRef_14(ret);
  return retVal;
}

function $onInit_TreeGrid(this$static){
  var self_0 = this$static.getOrCreateJsObj();
  self_0._getNodeTitle = self_0.getNodeTitle;
  self_0.getNodeTitle = $debox($entry(function(node, recordNum, field){
    var jObj = this.__ref;
    var nodeJ = getOrCreateRef_1(node);
    var fieldJ = getOrCreateRef_7(field);
    return jObj.getNodeTitle_0(nodeJ, recordNum, fieldJ);
  }
  ));
  self_0._getIcon = self_0.getIcon;
  self_0.getIcon = $debox($entry(function(node, defaultState){
    defaultState = !!defaultState;
    $wnd.isc.isA.Number(node) && (node = this.data.get(node));
    var jObj = this.__ref;
    var nodeJ = getOrCreateRef_1(node);
    return jObj.getIcon_0(nodeJ, defaultState);
  }
  ));
}

function $setAnimateFolders(this$static, animateFolders){
  $isCreated_1(this$static)?!animateFolders?$setNullProperty(this$static, 'animateFolders'):$setProperty_4(this$static, 'animateFolders', animateFolders.value_0):setAttribute_5(this$static.config_0, 'animateFolders', animateFolders);
}

function $setData_0(this$static, data){
  $setAttribute_20(this$static, 'data', !data?null:$getOrCreateJsObj(data), true);
}

function $setFields_2(this$static, fields){
  $isCreated_1(this$static)?$setProperty_2(this$static, 'fields', convertToJavaScriptArray(fields)):(this$static.config_0['fields'] = convertToJavaScriptArray(fields) , undefined);
}

function $setFolderIcon(this$static){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'folderIcon', 'global/DiscoveryQueue_Platform_16.png'):(this$static.config_0['folderIcon'] = 'global/DiscoveryQueue_Platform_16.png' , undefined);
}

function $setLoadDataOnDemand(this$static, loadDataOnDemand){
  $isCreated_1(this$static)?!loadDataOnDemand?$setNullProperty(this$static, 'loadDataOnDemand'):$setProperty_4(this$static, 'loadDataOnDemand', loadDataOnDemand.value_0):setAttribute_5(this$static.config_0, 'loadDataOnDemand', loadDataOnDemand);
}

function $setNodeIcon(this$static, nodeIcon){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'nodeIcon', nodeIcon):(this$static.config_0['nodeIcon'] = nodeIcon , undefined);
}

function $setShowRoot(this$static, showRoot){
  $isCreated_1(this$static)?undefined:setAttribute_5(this$static.config_0, 'showRoot', showRoot);
}

function $setTreeFieldTitle(this$static){
  $isCreated_1(this$static)?undefined:(this$static.config_0['treeFieldTitle'] = 'Resource Name' , undefined);
}

function $setupDataArrivedEvent_1(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({dataArrived:$entry(function(){
      var param = {parentNode:arguments[0]};
      var event_0 = new DataArrivedEvent_4(param);
      selfJ.fireEvent_0(event_0);
    }
    )});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.dataArrived = $entry(function(){
      var param = {parentNode:arguments[0]};
      var event_0 = new DataArrivedEvent_4(param);
      selfJ.fireEvent_0(event_0);
    }
    );
  }
}

function $setupNodeClickEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({nodeClick:$entry(function(){
      var param = {viewer:arguments[0], node:arguments[1], recordNum:arguments[2]};
      var event_0 = new NodeClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    )});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.nodeClick = $entry(function(){
      var param = {viewer:arguments[0], node:arguments[1], recordNum:arguments[2]};
      var event_0 = new NodeClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
    }
    );
  }
}

function $setupNodeContextClickEvent(this$static){
  var obj_0 = null;
  var selfJ = this$static;
  if (this$static.isCreated()) {
    obj_0 = this$static.getJsObj();
    obj_0.addProperties({nodeContextClick:$debox($entry(function(){
      var param = {viewer:arguments[0], node:arguments[1], recordNum:arguments[2]};
      var event_0 = new NodeContextClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ))});
  }
   else {
    obj_0 = this$static.getConfig();
    obj_0.nodeContextClick = $debox($entry(function(){
      var param = {viewer:arguments[0], node:arguments[1], recordNum:arguments[2]};
      var event_0 = new NodeContextClickEvent_0(param);
      selfJ.fireEvent_0(event_0);
      var ret = event_0.isCancelled();
      return !ret;
    }
    ));
  }
}

function TreeGrid_0(){
  $clinit_BaseWidget();
  ListGrid_0.call(this);
  $isCreated_1(this)?$setProperty_0(this, 'animateFolderSpeed', 3000):(this.config_0['animateFolderSpeed'] = 3000 , undefined);
  $setAlternateRecordStyles(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  this.scClassName = 'TreeGrid';
}

defineSeed(575, 538, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$TreeGrid]), TreeGrid_0);
_.addRecordDropHandler = function addRecordDropHandler_0(handler){
  throw new UnsupportedOperationException_1('This event inherited from ListGrid does not fire for a TreeGrid. Use TreeGrid.addFolgerDropHandler instead');
}
;
_.create_0 = function create_39(){
  var config = this.getConfig();
  var scClassName = this.scClassName;
  var widget = $wnd.isc[scClassName].create(config);
  this.doInit();
  return widget;
}
;
_.fetchData_0 = function fetchData_1(){
  var self_0 = this.getOrCreateJsObj();
  self_0.fetchData();
}
;
_.fetchData_1 = function fetchData_2(criteria){
  $fetchData_3(this, criteria);
}
;
_.getIcon_0 = function getIcon(node, defaultState){
  var self_0 = this.getOrCreateJsObj();
  return self_0._getIcon(node.getJsObj(), defaultState);
}
;
_.getNodeTitle_0 = function getNodeTitle(node, recordNum, field){
  var self_0 = this.getOrCreateJsObj();
  var title = self_0._getNodeTitle(node.getJsObj(), recordNum, field.getJsObj());
  return title == null?'':title.toString();
}
;
_.getRecord_0 = function getRecord_0(recordNum){
  var self_0 = this.getOrCreateJsObj();
  var ret = self_0.getRecord(recordNum);
  if (ret == null || ret === undefined)
    return null;
  var retVal = getOrCreateRef_14(ret);
  return retVal;
}
;
_.getRecords = function getRecords_0(){
  return $getRecords(this);
}
;
_.getSelectedRecord_0 = function getSelectedRecord_0(){
  return $getSelectedRecord_0(this);
}
;
_.onInit = function onInit_6(){
  $onInit(this);
  $onInit_ListGrid(this);
  $onInit_TreeGrid(this);
}
;
_.setCanAcceptDroppedRecords = function setCanAcceptDroppedRecords_0(canAcceptDroppedRecords){
  $isCreated_1(this)?!canAcceptDroppedRecords?$setNullProperty(this, 'canAcceptDroppedRecords'):$setProperty_4(this, 'canAcceptDroppedRecords', canAcceptDroppedRecords.value_0):setAttribute_5(this.config_0, 'canAcceptDroppedRecords', canAcceptDroppedRecords);
}
;
_.setCanDragRecordsOut = function setCanDragRecordsOut_0(canDragRecordsOut){
  $isCreated_1(this)?!canDragRecordsOut?$setNullProperty(this, 'canDragRecordsOut'):$setProperty_4(this, 'canDragRecordsOut', canDragRecordsOut.value_0):setAttribute_5(this.config_0, 'canDragRecordsOut', canDragRecordsOut);
}
;
_.setCanReorderRecords = function setCanReorderRecords_0(canReorderRecords){
  $isCreated_1(this)?!canReorderRecords?$setNullProperty(this, 'canReorderRecords'):$setProperty_4(this, 'canReorderRecords', canReorderRecords.value_0):setAttribute_5(this.config_0, 'canReorderRecords', canReorderRecords);
}
;
_.willAcceptDrop_0 = function willAcceptDrop_1(){
  return $willAcceptDrop(this);
}
;
function TreeGridField_0(name_0){
  ListGridField_1.call(this, name_0);
}

function TreeGridField_1(name_0, title){
  ListGridField_3.call(this, name_0, title);
}

function TreeGridField_2(name_0, title, width){
  ListGridField_4.call(this, name_0, title, width);
}

defineSeed(576, 539, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$ListGridField, Q$HasCellSavedHandlers, Q$HasChangeHandlers_0, Q$HasChangedHandlers_0, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$TreeGridField]), TreeGridField_0, TreeGridField_1, TreeGridField_2);
function TreeNode_0(){
  ListGridRecord_0.call(this);
}

function TreeNode_2(name_0){
  ListGridRecord_0.call(this);
  this.setName(name_0);
}

defineSeed(577, 540, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode]), TreeNode_0, TreeNode_2);
_.getEnabled = function getEnabled_1(){
  return $clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'enabled')?TRUE:FALSE;
}
;
_.setEnabled = function setEnabled_1(enabled){
  setAttribute_5(this.jsObj, 'enabled', enabled);
}
;
_.setID = function setID_1(id){
  this.jsObj['id'] = id;
}
;
_.setName = function setName(name_0){
  this.jsObj['name'] = name_0;
}
;
_.setParentID = function setParentID(parentID){
  this.jsObj['parentId'] = parentID;
}
;
function $dispatch_13(this$static, handler){
  var parent_0, jsObj;
  handler.this$0.selectedNodeId == null && $updateSelection(handler.this$0, false);
  parent_0 = (jsObj = this$static.jsObj , getOrCreateRef_14(jsObj.parentNode));
  instanceOf(parent_0, Q$EnhancedTreeNode) && $equals_6($getAttribute(dynamicCast(parent_0, Q$EnhancedTreeNode), 'id'), handler.this$0.selectedNodeId) && $updateSelection(handler.this$0, false);
}

function DataArrivedEvent_4(jsObj){
  this.jsObj = jsObj;
}

defineSeed(578, 461, {}, DataArrivedEvent_4);
_.dispatch = function dispatch_51(handler){
  $dispatch_13(this, dynamicCast(handler, Q$DataArrivedHandler_1));
}
;
_.getAssociatedType = function getAssociatedType_51(){
  return TYPE_51;
}
;
var TYPE_51 = null;
function $getNode(this$static){
  var jsObj = this$static.jsObj;
  return getOrCreateRef_14(jsObj.node);
}

function NodeClickEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(579, 461, {}, NodeClickEvent_0);
_.dispatch = function dispatch_52(handler){
  dynamicCast(handler, Q$NodeClickHandler).onNodeClick(this);
}
;
_.getAssociatedType = function getAssociatedType_52(){
  return TYPE_52;
}
;
var TYPE_52 = null;
function $getNode_0(this$static){
  var jsObj = this$static.jsObj;
  return getOrCreateRef_14(jsObj.node);
}

function NodeContextClickEvent_0(jsObj){
  this.jsObj = jsObj;
}

defineSeed(580, 461, {}, NodeContextClickEvent_0);
_.dispatch = function dispatch_53(handler){
  dynamicCast(handler, Q$NodeContextClickHandler).onNodeContextClick(this);
}
;
_.getAssociatedType = function getAssociatedType_53(){
  return TYPE_53;
}
;
_.isCancelled = function isCancelled_25(){
  return this.cancel;
}
;
_.cancel = false;
var TYPE_53 = null;
function __parseAndValidateDouble(s){
  var toReturn;
  toReturn = __parseDouble(s);
  if (isNaN(toReturn)) {
    throw new NumberFormatException_1('For input string: "' + s + '"');
  }
  return toReturn;
}

function __parseDouble(str){
  var floatRegex = floatRegex_0;
  !floatRegex && (floatRegex = floatRegex_0 = /^\s*[+-]?((\d+\.?\d*)|(\.\d+))([eE][+-]?\d+)?[dDfF]?\s*$/i);
  if (floatRegex.test(str)) {
    return parseFloat(str);
  }
   else {
    return Number.NaN;
  }
}

var floatRegex_0 = null;
defineSeed(590, 591, makeCastMap([Q$Serializable, Q$Byte, Q$Comparable, Q$Number]));
_.intValue = function intValue_0(){
  return this.value_0;
}
;
_.longValue = function longValue_0(){
  return fromInt(this.value_0);
}
;
defineSeed(597, 591, makeCastMap([Q$Serializable, Q$Comparable, Q$Double, Q$Number]));
_.intValue = function intValue_1(){
  return round_int(this.value_0);
}
;
_.longValue = function longValue_1(){
  return fromDouble(this.value_0);
}
;
function parseFloat_0(s){
  var doubleValue;
  doubleValue = __parseAndValidateDouble(s);
  if (doubleValue > 3.4028234663852886E38) {
    return Infinity;
  }
   else if (doubleValue < -3.4028234663852886E38) {
    return -Infinity;
  }
  return doubleValue;
}

defineSeed(598, 591, makeCastMap([Q$Serializable, Q$Comparable, Q$Float, Q$Number]));
_.intValue = function intValue_2(){
  return round_int(this.value_0);
}
;
_.longValue = function longValue_2(){
  return fromDouble(this.value_0);
}
;
function Integer_1(s){
  this.value_0 = __parseAndValidateInt(s);
}

defineSeed(601, 591, makeCastMap([Q$Serializable, Q$Comparable, Q$Integer, Q$Number]), Integer_1);
_.longValue = function longValue_3(){
  return fromInt(this.value_0);
}
;
defineSeed(603, 591, makeCastMap([Q$Serializable, Q$Comparable, Q$Long, Q$Number]));
_.intValue = function intValue_4(){
  return toInt(this.value_0);
}
;
_.longValue = function longValue_4(){
  return this.value_0;
}
;
function abs(x){
  return x <= 0?0 - x:x;
}

defineSeed(612, 591, makeCastMap([Q$Serializable, Q$Comparable, Q$Number, Q$Short]));
_.intValue = function intValue_5(){
  return this.value_0;
}
;
_.longValue = function longValue_5(){
  return fromInt(this.value_0);
}
;
function $replace_0(this$static, from, to){
  var regex;
  if (from < 256) {
    regex = toPowerOfTwoString(from);
    regex = '\\x' + '00'.substring(regex.length) + regex;
  }
   else {
    regex = String.fromCharCode(from);
  }
  return this$static.replace(RegExp(regex, 'g'), String.fromCharCode(to));
}

function $replace_1(this$static, from, to){
  var regex, replacement;
  regex = $replaceAll(from, '([/\\\\\\.\\*\\+\\?\\|\\(\\)\\[\\]\\{\\}$^])', '\\\\$1');
  replacement = $replaceAll($replaceAll(to, '\\\\', '\\\\\\\\'), '\\$', '\\\\$');
  return $replaceAll(this$static, regex, replacement);
}

function $startsWith(this$static, prefix, toffset){
  return !(toffset < 0 || toffset >= this$static.length) && this$static.indexOf(prefix, toffset) == toffset;
}

function $delete(this$static, end){
  return $replace(this$static.data_0, 0, end, '') , this$static;
}

function $replace_2(this$static, start, toInsert){
  $replace(this$static.data_0, start, 9, toInsert);
  return this$static;
}

function $append_14(this$static, x){
  $appendNonNull(this$static.data_0, valueOf_48(x));
  return this$static;
}

function $charAt_0(this$static, index){
  return $charAt($toString_1(this$static.data_0), index);
}

function $delete_0(this$static, start, end){
  return $replace(this$static.data_0, start, end, '') , this$static;
}

function $insert_0(this$static, index, x){
  return $replace(this$static.data_0, index, index, x) , this$static;
}

function $replace_3(this$static, start, end, toInsert){
  $replace(this$static.data_0, start, end, toInsert);
  return this$static;
}

function $setCharAt(this$static, index, x){
  $replace_3(this$static, index, index + 1, String.fromCharCode(x));
}

function $setLength_1(this$static, newLength){
  var oldLength;
  oldLength = $toString_1(this$static.data_0).length;
  newLength < oldLength?($replace(this$static.data_0, newLength, oldLength, '') , this$static):newLength > oldLength && $append_14(this$static, initDim(_3C_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, newLength - oldLength, 1));
}

function $substring_1(this$static, end){
  return $substring_0($toString_1(this$static.data_0), 0, end);
}

function Date_4(date){
  Date_2.call(this, date);
}

defineSeed(626, 104, makeCastMap([Q$Serializable, Q$Cloneable, Q$Comparable, Q$Date]), Date_4);
_.getHours_0 = function getHours_0(){
  throw new IllegalArgumentException_0;
}
;
_.getMinutes_0 = function getMinutes_0(){
  throw new IllegalArgumentException_0;
}
;
_.getSeconds_0 = function getSeconds_0(){
  throw new IllegalArgumentException_0;
}
;
_.setHours_0 = function setHours_2(i){
  throw new IllegalArgumentException_0;
}
;
_.setMinutes_0 = function setMinutes_2(i){
  throw new IllegalArgumentException_0;
}
;
_.setSeconds_0 = function setSeconds_2(i){
  throw new IllegalArgumentException_0;
}
;
_.toString$ = function toString_25(){
  return '' + (1900 + (this.jsdate.getFullYear() - 1900)) + '-' + padTwo(this.jsdate.getMonth() + 1) + '-' + padTwo(this.jsdate.getDate());
}
;
function Time_0(time){
  Date_2.call(this, time);
}

defineSeed(627, 104, makeCastMap([Q$Serializable, Q$Cloneable, Q$Comparable, Q$Date]), Time_0);
_.getDate_0 = function getDate_0(){
  throw new IllegalArgumentException_0;
}
;
_.getDay_0 = function getDay_0(){
  throw new IllegalArgumentException_0;
}
;
_.getMonth_0 = function getMonth_0(){
  throw new IllegalArgumentException_0;
}
;
_.getYear = function getYear_0(){
  throw new IllegalArgumentException_0;
}
;
_.setDate_0 = function setDate_0(i){
  throw new IllegalArgumentException_0;
}
;
_.toString$ = function toString_26(){
  return padTwo(this.jsdate.getHours()) + ':' + padTwo(this.jsdate.getMinutes()) + ':' + padTwo(this.jsdate.getSeconds());
}
;
function $compareTo_8(this$static, o){
  var sign;
  sign = signum(sub(fromDouble(this$static.jsdate.getTime()), fromDouble(o.jsdate.getTime())));
  return sign == 0?this$static.nanos - o.nanos:sign;
}

function $equals_7(this$static, ts){
  return eq(fromDouble(this$static.jsdate.getTime()), fromDouble(ts.jsdate.getTime())) && this$static.nanos == ts.nanos;
}

function $setNanos(this$static, n){
  if (n < 0 || n > 999999999) {
    throw new IllegalArgumentException_1('nanos out of range ' + n);
  }
  this$static.nanos = n;
  $setTime_0(this$static, add(mul(div(fromDouble(this$static.jsdate.getTime()), P3e8_longLit), P3e8_longLit), fromInt(~~(this$static.nanos / 1000000))));
}

function Timestamp_0(time){
  Date_2.call(this, time);
  this.nanos = toInt(mod(time, P3e8_longLit)) * 1000000;
}

function padNine(value){
  var asString, toReturn;
  toReturn = new StringBuffer_2('000000000');
  asString = '' + value;
  toReturn = $replace_2(toReturn, 9 - asString.length, asString);
  return $toString_1(toReturn.data_0);
}

defineSeed(628, 104, makeCastMap([Q$Serializable, Q$Cloneable, Q$Comparable, Q$Timestamp, Q$Date]), Timestamp_0);
_.compareTo = function compareTo_12(o){
  return instanceOf(o, Q$Timestamp)?$compareTo_8(this, dynamicCast(o, Q$Timestamp)):$compareTo_8(this, new Timestamp_0(o.getTime_0()));
}
;
_.equals$ = function equals_14(ts){
  return instanceOf(ts, Q$Timestamp) && $equals_7(this, dynamicCast(ts, Q$Timestamp));
}
;
_.getTime_0 = function getTime_0(){
  return fromDouble(this.jsdate.getTime());
}
;
_.hashCode$ = function hashCode_16(){
  return $hashCode(this);
}
;
_.setTime_0 = function setTime_0(time){
  $setTime(this.jsdate, toDouble(time));
  this.nanos = toInt(mod(time, P3e8_longLit)) * 1000000;
}
;
_.toString$ = function toString_27(){
  return '' + (1900 + (this.jsdate.getFullYear() - 1900)) + '-' + padTwo(1 + this.jsdate.getMonth()) + '-' + padTwo(this.jsdate.getDate()) + ' ' + padTwo(this.jsdate.getHours()) + ':' + padTwo(this.jsdate.getMinutes()) + ':' + padTwo(this.jsdate.getSeconds()) + '.' + padNine(this.nanos);
}
;
_.nanos = 0;
function $putAll(this$static, t){
  var e, iter;
  for (iter = t.entrySet().iterator(); iter.hasNext();) {
    e = dynamicCast(iter.next_0(), Q$Map$Entry);
    this$static.put(e.getKey_0(), e.getValue_1());
  }
}

function $values(this$static){
  var entrySet;
  entrySet = this$static.entrySet();
  return new AbstractMap$2_0(this$static, entrySet);
}

defineSeed(630, 1, makeCastMap([Q$Map]));
_.clear_0 = function clear_2(){
  this.entrySet().clear_0();
}
;
_.containsValue = function containsValue(value){
  var entry, iter, v;
  for (iter = this.entrySet().iterator(); iter.hasNext();) {
    entry = dynamicCast(iter.next_0(), Q$Map$Entry);
    v = entry.getValue_1();
    if (value == null?v == null:equals__devirtual$(value, v)) {
      return true;
    }
  }
  return false;
}
;
_.putAll = function putAll(t){
  $putAll(this, t);
}
;
_.remove_3 = function remove_7(key){
  var entry;
  entry = $implFindEntry(this, key, true);
  return !entry?null:entry.getValue_1();
}
;
_.values_0 = function values_41(){
  return $values(this);
}
;
function $containsHashValue(this$static, value){
  var hashCodeMap = this$static.hashCodeMap;
  for (var hashCode in hashCodeMap) {
    var hashCodeInt = parseInt(hashCode, 10);
    if (hashCode == hashCodeInt) {
      var array = hashCodeMap[hashCodeInt];
      for (var i = 0, c = array.length; i < c; ++i) {
        var entry = array[i];
        var entryValue = entry.getValue_1();
        if (this$static.equalsBridge(value, entryValue)) {
          return true;
        }
      }
    }
  }
  return false;
}

function $containsStringValue(this$static, value){
  var stringMap = this$static.stringMap;
  for (var key in stringMap) {
    if (key.charCodeAt(0) == 58) {
      var entryValue = stringMap[key];
      if (this$static.equalsBridge(value, entryValue)) {
        return true;
      }
    }
  }
  return false;
}

defineSeed(629, 630, makeCastMap([Q$Map]));
_.containsValue = function containsValue_0(value){
  if (this.nullSlotLive && this.equals(this.nullSlot, value)) {
    return true;
  }
   else if ($containsStringValue(this, value)) {
    return true;
  }
   else if ($containsHashValue(this, value)) {
    return true;
  }
  return false;
}
;
function $removeAll_0(this$static, c){
  var iter, o, size;
  size = this$static.map.size_1();
  if (size < c.val$entrySet.size_1()) {
    for (iter = $iterator($keySet(this$static.map)); iter.val$outerIter.hasNext();) {
      o = $next_1(iter);
      c.this$0.containsKey(o) && iter.val$outerIter.remove_2();
    }
  }
   else {
    for (iter = $iterator(c); iter.val$outerIter.hasNext();) {
      o = $next_1(iter);
      this$static.map.remove_3(o) != null;
    }
  }
  return size != this$static.map.size_1();
}

defineSeed(631, 632, makeCastMap([Q$Iterable, Q$AbstractCollection, Q$Collection, Q$Set]));
_.remove_0 = function remove_9(entry){
  var key;
  if ($contains(this, entry)) {
    key = dynamicCast(entry, Q$Map$Entry).getKey_0();
    this.this$0.remove_3(key);
    return true;
  }
  return false;
}
;
defineSeed(639, 290, makeCastMap([Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$Collection, Q$List]));
_.set_0 = function set_2(index, element){
  checkIndex(index, this.size_0);
  return this.wrapped.set_0(this.fromIndex + index, element);
}
;
function $iterator_0(this$static){
  var outerIter;
  outerIter = this$static.val$entrySet.iterator();
  return new AbstractMap$2$1_0(outerIter);
}

function AbstractMap$2_0(this$0, val$entrySet){
  this.this$0 = this$0;
  this.val$entrySet = val$entrySet;
}

defineSeed(642, 291, makeCastMap([Q$Iterable, Q$AbstractCollection, Q$Collection]), AbstractMap$2_0);
_.contains_0 = function contains_3(value){
  return this.this$0.containsValue(value);
}
;
_.iterator = function iterator_6(){
  return $iterator_0(this);
}
;
_.size_1 = function size_6(){
  return this.val$entrySet.size_1();
}
;
_.this$0 = null;
_.val$entrySet = null;
function $next_2(this$static){
  var value;
  value = dynamicCast(this$static.val$outerIter.next_0(), Q$Map$Entry).getValue_1();
  return value;
}

function AbstractMap$2$1_0(val$outerIter){
  this.val$outerIter = val$outerIter;
}

defineSeed(643, 1, {}, AbstractMap$2$1_0);
_.hasNext = function hasNext_3(){
  return this.val$outerIter.hasNext();
}
;
_.next_0 = function next_4(){
  return $next_2(this);
}
;
_.remove_2 = function remove_14(){
  this.val$outerIter.remove_2();
}
;
_.val$outerIter = null;
defineSeed(644, 290, makeCastMap([Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$AbstractSequentialList, Q$Collection, Q$List]));
_.set_0 = function set_3(index, element){
  var $e0, iter, old;
  iter = $listIterator(this, index);
  try {
    old = $next_5(iter);
    $verifyCurrentElement(iter);
    iter.lastNode.value_0 = element;
    return old;
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$NoSuchElementException)) {
      throw new IndexOutOfBoundsException_1("Can't set element " + index);
    }
     else 
      throw $e0;
  }
}
;
function fill(a, toIndex){
  var i;
  for (i = 0; i < toIndex; ++i) {
    a[i] = 0;
  }
}

function insertionSort(array, low, high, comp){
  var i, j, t;
  for (i = low + 1; i < high; ++i) {
    for (j = i; j > low && comp.compare(array[j - 1], array[j]) > 0; --j) {
      t = array[j];
      setCheck(array, j, array[j - 1]);
      setCheck(array, j - 1, t);
    }
  }
}

function merge(src, srcLow, srcMid, srcHigh, dest, destLow, destHigh, comp){
  var topIdx;
  topIdx = srcMid;
  while (destLow < destHigh) {
    topIdx >= srcHigh || srcLow < srcMid && comp.compare(src[srcLow], src[topIdx]) <= 0?setCheck(dest, destLow++, src[srcLow++]):setCheck(dest, destLow++, src[topIdx++]);
  }
}

function mergeSort(x, fromIndex, toIndex, comp){
  var temp;
  temp = cloneSubrange(x, fromIndex, toIndex);
  mergeSort_0(temp, x, fromIndex, toIndex, -fromIndex, comp);
}

function mergeSort_0(temp, array, low, high, ofs, comp){
  var length_0, tempHigh, tempLow, tempMid;
  length_0 = high - low;
  if (length_0 < 7) {
    insertionSort(array, low, high, comp);
    return;
  }
  tempLow = low + ofs;
  tempHigh = high + ofs;
  tempMid = tempLow + (tempHigh - tempLow >> 1);
  mergeSort_0(array, temp, tempLow, tempMid, -ofs, comp);
  mergeSort_0(array, temp, tempMid, tempHigh, -ofs, comp);
  if (comp.compare(temp[tempMid - 1], temp[tempMid]) <= 0) {
    while (low < high) {
      setCheck(array, low++, temp[tempLow++]);
    }
    return;
  }
  merge(temp, tempLow, tempMid, tempHigh, array, low, high, comp);
}

function toString_30(a){
  var b, i;
  if (a == null) {
    return 'null';
  }
  b = new StringBuffer_2('[');
  for (i = 0; i < a.length; ++i) {
    i != 0 && ($append_1(b.data_0, ', ') , b);
    $append_1(b.data_0, '' + a[i]);
  }
  $append_1(b.data_0, ']');
  return $toString_1(b.data_0);
}

function toString_31(x){
  if (x == null) {
    return 'null';
  }
  return $toString_3(new Arrays$ArrayList_0(x));
}

defineSeed(646, 290, makeCastMap([Q$Serializable, Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$Collection, Q$List, Q$RandomAccess]));
_.set_0 = function set_4(index, value){
  var was;
  checkIndex(index, this.array.length);
  was = this.array[index];
  setCheck(this.array, index, value);
  return was;
}
;
function replaceContents(target, x){
  var i, size;
  size = target.size_1();
  for (i = 0; i < size; ++i) {
    target.set_0(i, x[i]);
  }
}

function sort_0(target){
  $clinit_Collections();
  var x;
  x = cloneSubrange(target.array, 0, target.size_0);
  mergeSort(x, 0, x.length, ($clinit_Comparators() , $clinit_Comparators() , NATURAL));
  replaceContents(target, x);
}

function sort_1(target, c){
  $clinit_Collections();
  var x;
  x = target.toArray();
  mergeSort(x, 0, x.length, c?c:($clinit_Comparators() , $clinit_Comparators() , NATURAL));
  replaceContents(target, x);
}

defineSeed(649, 630, makeCastMap([Q$Serializable, Q$Map]));
_.containsValue = function containsValue_1(value){
  return false;
}
;
_.values_0 = function values_42(){
  return $clinit_Collections() , EMPTY_LIST;
}
;
function $clinit_Comparators(){
  $clinit_Comparators = nullMethod;
  NATURAL = new Comparators$1_0;
}

var NATURAL;
function Comparators$1_0(){
}

defineSeed(654, 1, makeCastMap([Q$Comparator]), Comparators$1_0);
_.compare = function compare_0(o1, o2){
  return dynamicCast(o1, Q$Comparable).compareTo$(o2);
}
;
defineSeed(658, 630, makeCastMap([Q$Map]));
_.clear_0 = function clear_5(){
  $clear_4(this);
}
;
_.containsValue = function containsValue_2(value){
  var key, key$iterator;
  for (key$iterator = new EnumSet$EnumSetImpl$IteratorImpl_0(this.keySet); key$iterator.i < key$iterator.this$1.all.length;) {
    key = $next_3(key$iterator);
    if (equalsWithNullCheck(value, this.values[key.ordinal])) {
      return true;
    }
  }
  return false;
}
;
_.remove_3 = function remove_17(key){
  return $remove_8(this, key);
}
;
defineSeed(659, 632, makeCastMap([Q$Iterable, Q$AbstractCollection, Q$Collection, Q$Set]));
_.remove_0 = function remove_18(entry){
  var key;
  if ($contains_0(this, entry)) {
    key = dynamicCast(entry, Q$Map$Entry).getKey_0();
    $remove_8(this.this$0, key);
    return true;
  }
  return false;
}
;
function allOf(elementType){
  var all, set;
  all = dynamicCast($getEnumConstants(elementType), Q$Enum_$1);
  set = dynamicCast(cloneSubrange(all, 0, all.length), Q$Enum_$1);
  return new EnumSet$EnumSetImpl_0(all, set, all.length);
}

function complementOf(other){
  var all, c, i, newSet, oldSet;
  all = other.all;
  oldSet = other.set;
  newSet = dynamicCast(createFrom(oldSet, oldSet.length), Q$Enum_$1);
  for (i = 0 , c = oldSet.length; i < c; ++i) {
    !oldSet[i] && setCheck(newSet, i, all[i]);
  }
  return new EnumSet$EnumSetImpl_0(all, newSet, all.length - other.size_0);
}

function of(first){
  var all, set;
  all = dynamicCast($getEnumConstants($getDeclaringClass(first)), Q$Enum_$1);
  set = dynamicCast(createFrom(all, all.length), Q$Enum_$1);
  setCheck(set, first.ordinal, first);
  return new EnumSet$EnumSetImpl_0(all, set, 1);
}

function of_0(first, rest){
  var all, e, e$index, e$max, ordinal, set, size;
  all = dynamicCast($getEnumConstants($getDeclaringClass(first)), Q$Enum_$1);
  set = dynamicCast(createFrom(all, all.length), Q$Enum_$1);
  setCheck(set, first.ordinal, first);
  size = 1;
  for (e$index = 0 , e$max = rest.length; e$index < e$max; ++e$index) {
    e = rest[e$index];
    ordinal = e.ordinal;
    if (!set[ordinal]) {
      setCheck(set, ordinal, e);
      ++size;
    }
  }
  return new EnumSet$EnumSetImpl_0(all, set, size);
}

defineSeed(663, 662, makeCastMap([Q$Iterable, Q$AbstractCollection, Q$Collection, Q$EnumSet, Q$Set]));
_.remove_0 = function remove_20(o){
  return $remove_9(this, o);
}
;
defineSeed(665, 1, {});
function HashSet_1(initialCapacity){
  this.map = new HashMap_1(initialCapacity);
}

defineSeed(667, 632, makeCastMap([Q$Serializable, Q$Cloneable, Q$Iterable, Q$AbstractCollection, Q$Collection, Q$Set]), HashSet_1);
_.remove_0 = function remove_22(o){
  return $remove_10(this, o);
}
;
function LinkedHashMap_1(ignored){
  HashMap_1.call(this, ignored);
  $$init_4(this);
}

function LinkedHashMap_4(toBeCopied){
  $clearImpl(this);
  $$init_4(this);
  $putAll(this, toBeCopied);
}

defineSeed(669, 666, makeCastMap([Q$Serializable, Q$Cloneable, Q$HashMap, Q$Map]), LinkedHashMap_1, LinkedHashMap_4);
_.containsValue = function containsValue_3(value){
  var node;
  node = this.head.next;
  while (node != this.head) {
    if (equalsWithNullCheck(node.value_0, value)) {
      return true;
    }
    node = node.next;
  }
  return false;
}
;
function MissingResourceException_0(s){
  RuntimeException_1.call(this, s);
}

defineSeed(678, 6, makeCastMap([Q$Serializable, Q$Exception, Q$RuntimeException, Q$Throwable, Q$MissingResourceException]), MissingResourceException_0);
defineSeed(681, 290, makeCastMap([Q$Serializable, Q$Cloneable, Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$Collection, Q$List, Q$RandomAccess, Q$Vector]));
_.set_0 = function set_5(index, elem){
  return $set(this.arrayList, index, elem);
}
;
_.subList = function subList_0(fromIndex, toIndex){
  return new AbstractList$SubList_0(this.arrayList, fromIndex, toIndex);
}
;
defineSeed(683, 630, makeCastMap([Q$Serializable, Q$Map]));
_.clear_0 = function clear_12(){
  $clear_7(this);
}
;
_.remove_3 = function remove_27(keyObj){
  return $remove_15(this, keyObj);
}
;
defineSeed(686, 632, makeCastMap([Q$Iterable, Q$AbstractCollection, Q$Collection, Q$Set]));
_.remove_0 = function remove_29(o){
  var entry, state;
  if (!instanceOf(o, Q$Map$Entry)) {
    return false;
  }
  entry = dynamicCast(o, Q$Map$Entry);
  state = new TreeMap$State_0;
  state.matchValue = true;
  state.value_0 = entry.getValue_1();
  return $removeWithState(this.this$0, entry.getKey_0(), state);
}
;
defineSeed(694, 632, makeCastMap([Q$Serializable, Q$Iterable, Q$AbstractCollection, Q$Collection, Q$Set]));
_.remove_0 = function remove_30(o){
  return $remove_15(this.map, o) != null;
}
;
function $setCategory(this$static, category){
  this$static.category = category;
}

function $setComparator(this$static, comparator){
  this$static.comparator = comparator;
}

function $setMeasurementDefinition(this$static, measurementDefinition){
  this$static.measurementDefinition = measurementDefinition;
}

function $setName_1(this$static, name_0){
  this$static.name_0 = name_0;
}

function $setOption(this$static, option){
  this$static.option = option;
}

function $setThreshold(this$static, threshold){
  this$static.threshold = threshold;
}

function $setTriggerId(this$static, triggerId){
  this$static.triggerId = triggerId;
}

function AlertCondition_1(cond){
  $$init_5(this);
  this.category = cond.category;
  this.measurementDefinition = cond.measurementDefinition;
  this.name_0 = cond.name_0;
  this.comparator = cond.comparator;
  this.threshold = cond.threshold;
  this.option = cond.option;
  this.triggerId = cond.triggerId;
}

defineSeed(717, 1, makeCastMap([Q$Serializable, Q$AlertCondition]), AlertCondition_1);
function $clinit_AlertConditionOperator(){
  $clinit_AlertConditionOperator = nullMethod;
  LESS_THAN_OR_EQUAL_TO = new AlertConditionOperator_0('LESS_THAN_OR_EQUAL_TO', 0);
  LESS_THAN = new AlertConditionOperator_0('LESS_THAN', 1);
  EQUALS = new AlertConditionOperator_0('EQUALS', 2);
  REGEX = new AlertConditionOperator_0('REGEX', 3);
  GREATER_THAN = new AlertConditionOperator_0('GREATER_THAN', 4);
  GREATER_THAN_OR_EQUAL_TO = new AlertConditionOperator_0('GREATER_THAN_OR_EQUAL_TO', 5);
  CHANGES = new AlertConditionOperator_0('CHANGES', 6);
  CHANGES_TO = new AlertConditionOperator_0('CHANGES_TO', 7);
  CHANGES_FROM = new AlertConditionOperator_0('CHANGES_FROM', 8);
  AVAIL_GOES_DOWN = new AlertConditionOperator_0('AVAIL_GOES_DOWN', 9);
  AVAIL_GOES_DISABLED = new AlertConditionOperator_0('AVAIL_GOES_DISABLED', 10);
  AVAIL_GOES_UNKNOWN = new AlertConditionOperator_0('AVAIL_GOES_UNKNOWN', 11);
  AVAIL_GOES_NOT_UP = new AlertConditionOperator_0('AVAIL_GOES_NOT_UP', 12);
  AVAIL_GOES_UP = new AlertConditionOperator_0('AVAIL_GOES_UP', 13);
  AVAIL_DURATION_DOWN = new AlertConditionOperator_0('AVAIL_DURATION_DOWN', 14);
  AVAIL_DURATION_NOT_UP = new AlertConditionOperator_0('AVAIL_DURATION_NOT_UP', 15);
  $VALUES_42 = initValues(_3Lorg_rhq_core_domain_alert_AlertConditionOperator_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$AlertConditionOperator, [LESS_THAN_OR_EQUAL_TO, LESS_THAN, EQUALS, REGEX, GREATER_THAN, GREATER_THAN_OR_EQUAL_TO, CHANGES, CHANGES_TO, CHANGES_FROM, AVAIL_GOES_DOWN, AVAIL_GOES_DISABLED, AVAIL_GOES_UNKNOWN, AVAIL_GOES_NOT_UP, AVAIL_GOES_UP, AVAIL_DURATION_DOWN, AVAIL_DURATION_NOT_UP]);
}

function AlertConditionOperator_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_51(name_0){
  $clinit_AlertConditionOperator();
  return valueOf(($clinit_AlertConditionOperator$Map() , $MAP_42), name_0);
}

function values_45(){
  $clinit_AlertConditionOperator();
  return $VALUES_42;
}

defineSeed(723, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$AlertConditionOperator]), AlertConditionOperator_0);
var $VALUES_42, AVAIL_DURATION_DOWN, AVAIL_DURATION_NOT_UP, AVAIL_GOES_DISABLED, AVAIL_GOES_DOWN, AVAIL_GOES_NOT_UP, AVAIL_GOES_UNKNOWN, AVAIL_GOES_UP, CHANGES, CHANGES_FROM, CHANGES_TO, EQUALS, GREATER_THAN, GREATER_THAN_OR_EQUAL_TO, LESS_THAN, LESS_THAN_OR_EQUAL_TO, REGEX;
function $clinit_AlertConditionOperator$Map(){
  $clinit_AlertConditionOperator$Map = nullMethod;
  $MAP_42 = createValueOfMap(($clinit_AlertConditionOperator() , $VALUES_42));
}

var $MAP_42;
function $setPeriod(this$static, period){
  this$static.period = period;
}

function $setPeriodUnits(this$static, periodUnits){
  this$static.periodUnits = periodUnits;
}

function $setValue_11(this$static, value){
  this$static.value_0 = value;
}

function AlertDampening_1(category){
  $$init_6(this);
  this.category = category;
}

defineSeed(727, 1, makeCastMap([Q$Serializable, Q$AlertDampening]), AlertDampening_1);
function $removeAllConditions(this$static){
  var condition, condition$iterator;
  for (condition$iterator = this$static.conditions.iterator(); condition$iterator.hasNext();) {
    condition = dynamicCast(condition$iterator.next_0(), Q$AlertCondition);
    condition.alertDefinition = null;
  }
  this$static.conditions.clear_0();
}

function $setAlertDampening(this$static, alertDampening){
  this$static.alertDampening = alertDampening;
}

function $setAlertNotifications(this$static, alertNotifications){
  !alertNotifications && (alertNotifications = new ArrayList_0);
  this$static.alertNotifications = alertNotifications;
}

function $setConditionExpression(this$static, conditionExpression){
  this$static.conditionExpression = conditionExpression;
}

function $setConditions(this$static, conditions){
  var condition, condition$iterator;
  $removeAllConditions(this$static);
  if (conditions) {
    for (condition$iterator = $iterator($keySet(conditions.map)); condition$iterator.val$outerIter.hasNext();) {
      condition = dynamicCast($next_1(condition$iterator), Q$AlertCondition);
      this$static.conditions.add(condition);
      condition.alertDefinition = this$static;
    }
  }
}

function $setDescription(this$static, description){
  this$static.description = description;
}

function $setEnabled(this$static, enabled){
  this$static.enabled = enabled;
}

function $setGroup(this$static, group){
  this$static.group = group;
}

function $setId(this$static, id){
  this$static.id = id;
}

function $setName_2(this$static, name_0){
  this$static.name_0 = name_0;
}

function $setParentId(this$static, parentId){
  this$static.parentId = parentId;
}

function $setPriority(this$static, priority){
  this$static.priority = priority;
}

function $setReadOnly(this$static, readOnly){
  this$static.readOnly = readOnly;
}

function $setRecoveryId(this$static, actOnTriggerId){
  if (this$static.willRecover && actOnTriggerId.value_0 != 0) {
    throw new IllegalStateException_1('An alert definition can either be a recovery definition or a definition to-be-recovered, but not both.');
  }
  this$static.recoveryId = actOnTriggerId;
}

function $setResource(this$static, resource){
  this$static.resource = resource;
  !!this$static.resource && $getAlertDefinitions(this$static.resource).add(this$static);
}

function $setResourceType(this$static, resourceType){
  this$static.resourceType = resourceType;
}

function $setWillRecover(this$static, willRecover){
  if (willRecover && this$static.recoveryId.value_0 != 0) {
    throw new IllegalStateException_1('An alert definition can either be a recovery definition or a definition to-be-recovered, but not both.');
  }
  this$static.willRecover = willRecover;
}

function serialize_47(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function $setAlertDefinition(this$static, alertDefinition){
  if (!alertDefinition) {
    throw new IllegalArgumentException_1('alertDefinition must be non-null.');
  }
  this$static.alertDefinition = alertDefinition;
}

function $setConfiguration(this$static, configuration){
  if (!configuration) {
    throw new IllegalArgumentException_1('configuration must be non-null');
  }
  this$static.configuration = configuration;
}

function $setExtraConfiguration(this$static, extraConfiguration){
  this$static.extraConfiguration = extraConfiguration;
}

function AlertNotification_1(sender){
  this.senderName = sender;
}

defineSeed(750, 1, makeCastMap([Q$Serializable, Q$AlertNotification]), AlertNotification_1);
function $setFactive(this$static, factive){
  this$static.factive = factive;
}

function $setFsystem(this$static, fsystem){
  this$static.fsystem = fsystem;
}

function $setId_0(this$static, id){
  this$static.id = id;
}

function $setRoles(this$static, roles){
  this$static.roles = roles;
}

function $addPermission(this$static, permission){
  this$static.permissions.add(permission);
}

function $setDescription_0(this$static, description){
  this$static.description = description;
}

function $setId_1(this$static, id){
  this$static.id = id;
}

function $setName_4(this$static, name_0){
  this$static.name_0 = name_0;
}

function $setResourceGroups(this$static, resourceGroups){
  var resourceGroup, resourceGroup$iterator;
  if (!resourceGroups) {
    this$static.resourceGroups = new HashSet_0;
  }
   else {
    this$static.resourceGroups = resourceGroups;
    for (resourceGroup$iterator = this$static.resourceGroups.iterator(); resourceGroup$iterator.hasNext();) {
      resourceGroup = dynamicCast(resourceGroup$iterator.next_0(), Q$ResourceGroup);
      (!resourceGroup.roles && (resourceGroup.roles = new HashSet_0) , resourceGroup.roles).add(this$static);
      this$static.resourceGroups.add(resourceGroup);
    }
  }
}

function $setSubjects(this$static, subjects){
  var subject, subject$iterator;
  if (!subjects) {
    this$static.subjects = new HashSet_0;
  }
   else {
    this$static.subjects = subjects;
    for (subject$iterator = $iterator($keySet(subjects.map)); subject$iterator.val$outerIter.hasNext();) {
      subject = dynamicCast($next_1(subject$iterator), Q$Subject);
      !subject.roles && (subject.roles = new HashSet_0);
      subject.roles.add(this$static);
      this$static.subjects.add(subject);
    }
  }
}

function $setBundleVersion(this$static, bundleVersion){
  this$static.bundleVersion = bundleVersion;
}

function $setResourceDeployments(this$static, resourceDeployments){
  this$static.resourceDeployments = resourceDeployments;
}

function $setDeployDir(this$static, deployDir){
  this$static.deployDir = deployDir;
}

function $setDescription_1(this$static, description){
  this$static.description = description;
}

function $setDestinationBaseDirectoryName(this$static, destinationBaseDirectoryName){
  this$static.destinationBaseDirectoryName = destinationBaseDirectoryName;
}

function $setName_5(this$static, name_0){
  this$static.name_0 = name_0;
}

function $setBundle(this$static, bundle){
  this$static.bundle = bundle;
}

function $getBundleDestinationBaseDirectories(this$static){
  var bdbd, description, list, listItem, listItem$iterator, map, name_0, propertyList, retVal, valueContext, valueName;
  if (!this$static.bundleConfiguration) {
    return null;
  }
  propertyList = $getList(this$static.bundleConfiguration, 'bundleDestBaseDirsList');
  if (!propertyList) {
    return null;
  }
  list = (!propertyList.list && (propertyList.list = new ArrayList_0) , propertyList.list);
  if (list.size_1() == 0) {
    return null;
  }
  retVal = new HashSet_1(list.size_1());
  for (listItem$iterator = list.iterator(); listItem$iterator.hasNext();) {
    listItem = dynamicCast(listItem$iterator.next_0(), Q$Property);
    map = dynamicCast(listItem, Q$PropertyMap);
    name_0 = $getSimpleValue_0(map, 'name', null);
    valueContext = $getSimpleValue_0(map, 'valueContext', null);
    valueName = $getSimpleValue_0(map, 'valueName', null);
    description = $getSimpleValue_0(map, 'description', null);
    bdbd = new ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory_0(name_0, valueContext, valueName, description);
    $add_6(retVal, bdbd);
  }
  return retVal;
}

function ResourceTypeBundleConfiguration_0(){
  this.bundleConfiguration = null;
}

defineSeed(800, 1, makeCastMap([Q$Serializable, Q$ResourceTypeBundleConfiguration]), ResourceTypeBundleConfiguration_0);
function ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory_0(name_0, valueContext, valueName, description){
  if (name_0 == null) {
    throw new NullPointerException_1('name == null');
  }
  this.name_0 = name_0;
  this.valueContext = ($clinit_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context() , dynamicCast(valueOf(($clinit_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context$Map() , $MAP_54), valueContext), Q$ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context));
  this.valueName = valueName;
  this.description = description;
}

defineSeed(801, 1, makeCastMap([Q$Serializable, Q$ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory]), ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory_0);
_.equals$ = function equals_38(obj_0){
  var other;
  if (this === obj_0) {
    return true;
  }
  if (!instanceOf(obj_0, Q$ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory)) {
    return false;
  }
  other = dynamicCast(obj_0, Q$ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory);
  return $equals_6(this.name_0, other.name_0);
}
;
_.hashCode$ = function hashCode_38(){
  return getHashCode_0(this.name_0);
}
;
_.toString$ = function toString_60(){
  var builder;
  builder = new StringBuilder_0;
  $append_12($append_12($append_12($append_12($append_12($append_11($append_12($append_12(($append_1(builder.data_0, 'BundleDestinationBaseDirectory [name=') , builder), this.name_0), ', valueContext='), this.valueContext), ', valueName='), this.valueName), ', description='), this.description), ']');
  return $toString_1(builder.data_0);
}
;
_.description = null;
_.name_0 = null;
_.valueContext = null;
_.valueName = null;
function $clinit_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context(){
  $clinit_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context = nullMethod;
  pluginConfiguration_0 = new ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context_0('pluginConfiguration', 0);
  resourceConfiguration_0 = new ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context_0('resourceConfiguration', 1);
  measurementTrait = new ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context_0('measurementTrait', 2);
  fileSystem = new ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context_0('fileSystem', 3);
  $VALUES_54 = initValues(_3Lorg_rhq_core_domain_bundle_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context, [pluginConfiguration_0, resourceConfiguration_0, measurementTrait, fileSystem]);
}

function ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_63(name_0){
  $clinit_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context();
  return valueOf(($clinit_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context$Map() , $MAP_54), name_0);
}

function values_57(){
  $clinit_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context();
  return $VALUES_54;
}

defineSeed(802, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context]), ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context_0);
var $VALUES_54, fileSystem, measurementTrait, pluginConfiguration_0, resourceConfiguration_0;
function $clinit_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context$Map(){
  $clinit_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context$Map = nullMethod;
  $MAP_54 = createValueOfMap(($clinit_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context() , $VALUES_54));
}

var $MAP_54;
function deserialize_128(streamReader, instance){
  setBundleConfiguration(instance, dynamicCast($readObject(streamReader), Q$Configuration));
}

function instantiate_125(streamReader){
  return new ResourceTypeBundleConfiguration_0;
}

function setBundleConfiguration(instance, value){
  instance.bundleConfiguration = value;
}

function BundleWithLatestVersionComposite_0(){
}

defineSeed(805, 1, makeCastMap([Q$Serializable, Q$BundleWithLatestVersionComposite]), BundleWithLatestVersionComposite_0);
_.toString$ = function toString_61(){
  var builder;
  builder = new StringBuilder_0;
  $append_11(($append_1(builder.data_0, 'BundleWithLatestVersionComposite [bundleId=') , builder), this.bundleId);
  $append_12(($append_1(builder.data_0, ', bundleName=') , builder), this.bundleName);
  $append_12(($append_1(builder.data_0, ', bundleDescription=') , builder), this.bundleDescription);
  $append_12(($append_1(builder.data_0, ', latestVersion=') , builder), this.latestVersion);
  $append_11(($append_1(builder.data_0, ', versionsCount=') , builder), this.versionsCount);
  $append_1(builder.data_0, ']');
  return $toString_1(builder.data_0);
}
;
_.bundleDescription = null;
_.bundleId = null;
_.bundleName = null;
_.latestVersion = null;
_.versionsCount = null;
function deserialize_129(streamReader, instance){
  setBundleDescription(instance, $getString(streamReader, $readInt(streamReader)));
  setBundleId(instance, dynamicCast($readObject(streamReader), Q$Integer));
  setBundleName(instance, $getString(streamReader, $readInt(streamReader)));
  setLatestVersion(instance, $getString(streamReader, $readInt(streamReader)));
  setVersionsCount(instance, dynamicCast($readObject(streamReader), Q$Long));
}

function instantiate_126(streamReader){
  return new BundleWithLatestVersionComposite_0;
}

function setBundleDescription(instance, value){
  instance.bundleDescription = value;
}

function setBundleId(instance, value){
  instance.bundleId = value;
}

function setBundleName(instance, value){
  instance.bundleName = value;
}

function setLatestVersion(instance, value){
  instance.latestVersion = value;
}

function setVersionsCount(instance, value){
  instance.versionsCount = value;
}

function $setName_6(this$static, name_0){
  this$static.name_0 = name_0;
}

function AffinityGroup_1(name_0){
  $$init_7(this);
  this.name_0 = name_0;
}

defineSeed(807, 1, makeCastMap([Q$Serializable, Q$AffinityGroup]), AffinityGroup_1);
function $equals_16(this$static, obj_0){
  var other;
  if (this$static === obj_0) {
    return true;
  }
  if (obj_0 == null || !instanceOf(obj_0, Q$FailoverList)) {
    return false;
  }
  other = dynamicCast(obj_0, Q$FailoverList);
  if (this$static.agentId != other.agentId) {
    return false;
  }
  if (neq(this$static.ctime, other.ctime)) {
    return false;
  }
  return true;
}

function FailoverList_0(){
  this.serverList = new ArrayList_0;
}

defineSeed(809, 1, makeCastMap([Q$Serializable, Q$FailoverList]), FailoverList_0);
_.equals$ = function equals_40(obj_0){
  return $equals_16(this, obj_0);
}
;
_.hashCode$ = function hashCode_40(){
  var result;
  result = 31 + this.agentId;
  result = 31 * result + toInt(xor(this.ctime, shru(this.ctime, 32)));
  return result;
}
;
_.agentId = 0;
_.ctime = P0_longLit;
_.id = 0;
function FailoverListDetails_0(){
}

defineSeed(810, 1, makeCastMap([Q$Serializable, Q$FailoverListDetails]), FailoverListDetails_0);
_.equals$ = function equals_41(obj_0){
  var other;
  if (this === obj_0) {
    return true;
  }
  if (obj_0 == null || !instanceOf(obj_0, Q$FailoverListDetails)) {
    return false;
  }
  other = dynamicCast(obj_0, Q$FailoverListDetails);
  if (!this.failoverList) {
    if (other.failoverList) {
      return false;
    }
  }
   else if (!$equals_16(this.failoverList, other.failoverList)) {
    return false;
  }
  if (this.ordinal != other.ordinal) {
    return false;
  }
  return true;
}
;
_.hashCode$ = function hashCode_41(){
  var result;
  result = 31 + this.serverId;
  return result;
}
;
_.failoverList = null;
_.id = 0;
_.ordinal = 0;
_.server = null;
_.serverId = 0;
function deserialize_131(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_128(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_cloud_FailoverListDetails_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FailoverListDetails, size, 0);
}

function deserialize_132(streamReader, instance){
  setNative(instance, 'server-enhanced-data-1', $getString(streamReader, $readInt(streamReader)));
  instance.failoverList = dynamicCast($readObject(streamReader), Q$FailoverList);
  setId_17(instance, $readInt(streamReader));
  setOrdinal(instance, $readInt(streamReader));
  instance.server = dynamicCast($readObject(streamReader), Q$Server);
  setServerId(instance, $readInt(streamReader));
}

function instantiate_129(streamReader){
  return new FailoverListDetails_0;
}

function setId_17(instance, value){
  instance.id = value;
}

function setOrdinal(instance, value){
  instance.ordinal = value;
}

function setServerId(instance, value){
  instance.serverId = value;
}

function deserialize_133(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_130(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_cloud_FailoverList_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FailoverList, size, 0);
}

function deserialize_134(streamReader, instance){
  setNative(instance, 'server-enhanced-data-1', $getString(streamReader, $readInt(streamReader)));
  dynamicCast($readObject(streamReader), Q$Agent);
  setAgentId(instance, $readInt(streamReader));
  setCtime_5(instance, $readLong(streamReader));
  setId_18(instance, $readInt(streamReader));
  dynamicCast($readObject(streamReader), Q$PartitionEvent);
  setServerList(instance, dynamicCast($readObject(streamReader), Q$List));
}

function instantiate_131(streamReader){
  return new FailoverList_0;
}

function setAgentId(instance, value){
  instance.agentId = value;
}

function setCtime_5(instance, value){
  instance.ctime = value;
}

function setId_18(instance, value){
  instance.id = value;
}

function setServerList(instance, value){
  instance.serverList = value;
}

function $equals_17(this$static, obj_0){
  var other;
  if (this$static === obj_0) {
    return true;
  }
  if (obj_0 == null || !instanceOf(obj_0, Q$PartitionEvent)) {
    return false;
  }
  other = dynamicCast(obj_0, Q$PartitionEvent);
  if (neq(this$static.ctime, other.ctime)) {
    return false;
  }
  if (this$static.subjectName == null) {
    if (other.subjectName != null) {
      return false;
    }
  }
   else if (!$equals_6(this$static.subjectName, other.subjectName)) {
    return false;
  }
  return true;
}

function $hashCode_6(this$static){
  var result;
  result = 31 + toInt(xor(this$static.ctime, shru(this$static.ctime, 32)));
  result = 31 * result + (this$static.subjectName == null?0:getHashCode_0(this$static.subjectName));
  return result;
}

function PartitionEvent_0(){
  this.partitionDetails = new ArrayList_0;
  this.serverLists = new ArrayList_0;
}

defineSeed(815, 1, makeCastMap([Q$Serializable, Q$PartitionEvent]), PartitionEvent_0);
_.equals$ = function equals_42(obj_0){
  return $equals_17(this, obj_0);
}
;
_.hashCode$ = function hashCode_42(){
  return $hashCode_6(this);
}
;
_.ctime = P0_longLit;
_.eventDetail = null;
_.eventType = null;
_.executionStatus = null;
_.id = 0;
_.subjectName = null;
function $clinit_PartitionEvent$ExecutionStatus(){
  $clinit_PartitionEvent$ExecutionStatus = nullMethod;
  AUDIT = new PartitionEvent$ExecutionStatus_0('AUDIT', 0);
  COMPLETED = new PartitionEvent$ExecutionStatus_0('COMPLETED', 1);
  IMMEDIATE = new PartitionEvent$ExecutionStatus_0('IMMEDIATE', 2);
  REQUESTED = new PartitionEvent$ExecutionStatus_0('REQUESTED', 3);
  $VALUES_55 = initValues(_3Lorg_rhq_core_domain_cloud_PartitionEvent$ExecutionStatus_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$PartitionEvent$ExecutionStatus_$1]), Q$PartitionEvent$ExecutionStatus, [AUDIT, COMPLETED, IMMEDIATE, REQUESTED]);
}

function PartitionEvent$ExecutionStatus_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_64(name_0){
  $clinit_PartitionEvent$ExecutionStatus();
  return valueOf(($clinit_PartitionEvent$ExecutionStatus$Map() , $MAP_55), name_0);
}

function values_58(){
  $clinit_PartitionEvent$ExecutionStatus();
  return $VALUES_55;
}

defineSeed(816, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$PartitionEvent$ExecutionStatus]), PartitionEvent$ExecutionStatus_0);
var $VALUES_55, AUDIT, COMPLETED, IMMEDIATE, REQUESTED;
function $clinit_PartitionEvent$ExecutionStatus$Map(){
  $clinit_PartitionEvent$ExecutionStatus$Map = nullMethod;
  $MAP_55 = createValueOfMap(($clinit_PartitionEvent$ExecutionStatus() , $VALUES_55));
}

var $MAP_55;
function PartitionEventDetails_0(){
}

defineSeed(818, 1, makeCastMap([Q$Serializable, Q$PartitionEventDetails]), PartitionEventDetails_0);
_.equals$ = function equals_43(obj_0){
  var other;
  if (this === obj_0) {
    return true;
  }
  if (obj_0 == null || !instanceOf(obj_0, Q$PartitionEventDetails)) {
    return false;
  }
  other = dynamicCast(obj_0, Q$PartitionEventDetails);
  if (this.agentName == null) {
    if (other.agentName != null) {
      return false;
    }
  }
   else if (!$equals_6(this.agentName, other.agentName)) {
    return false;
  }
  if (this.serverName == null) {
    if (other.serverName != null) {
      return false;
    }
  }
   else if (!$equals_6(this.serverName, other.serverName)) {
    return false;
  }
  if (!this.partitionEvent) {
    if (other.partitionEvent) {
      return false;
    }
  }
   else if (!$equals_17(this.partitionEvent, other.partitionEvent)) {
    return false;
  }
  return true;
}
;
_.hashCode$ = function hashCode_43(){
  var result;
  result = 31 + (this.agentName == null?0:getHashCode_0(this.agentName));
  result = 31 * result + (!this.partitionEvent?0:$hashCode_6(this.partitionEvent));
  result = 31 * result + (this.serverName == null?0:getHashCode_0(this.serverName));
  return result;
}
;
_.agentName = null;
_.id = 0;
_.partitionEvent = null;
_.serverName = null;
function deserialize_135(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_132(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_cloud_PartitionEventDetails_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PartitionEventDetails, size, 0);
}

function deserialize_136(streamReader, instance){
  setNative(instance, 'server-enhanced-data-1', $getString(streamReader, $readInt(streamReader)));
  instance.agentName = $getString(streamReader, $readInt(streamReader));
  setId_19(instance, $readInt(streamReader));
  instance.partitionEvent = dynamicCast($readObject(streamReader), Q$PartitionEvent);
  instance.serverName = $getString(streamReader, $readInt(streamReader));
}

function instantiate_133(streamReader){
  return new PartitionEventDetails_0;
}

function setId_19(instance, value){
  instance.id = value;
}

function $clinit_PartitionEventType(){
  $clinit_PartitionEventType = nullMethod;
  AGENT_REGISTRATION = new PartitionEventType_0('AGENT_REGISTRATION', 0);
  AGENT_CONNECT = new PartitionEventType_0('AGENT_CONNECT', 1);
  AGENT_SHUTDOWN = new PartitionEventType_0('AGENT_SHUTDOWN', 2);
  AGENT_LEAVE = new PartitionEventType_0('AGENT_LEAVE', 3);
  SERVER_DELETION = new PartitionEventType_0('SERVER_DELETION', 4);
  SERVER_COMPUTE_POWER_CHANGE = new PartitionEventType_0('SERVER_COMPUTE_POWER_CHANGE', 5);
  OPERATION_MODE_CHANGE = new PartitionEventType_0('OPERATION_MODE_CHANGE', 6);
  AGENT_AFFINITY_GROUP_ASSIGN = new PartitionEventType_0('AGENT_AFFINITY_GROUP_ASSIGN', 7);
  AGENT_AFFINITY_GROUP_REMOVE = new PartitionEventType_0('AGENT_AFFINITY_GROUP_REMOVE', 8);
  SERVER_AFFINITY_GROUP_ASSIGN = new PartitionEventType_0('SERVER_AFFINITY_GROUP_ASSIGN', 9);
  SERVER_AFFINITY_GROUP_REMOVE = new PartitionEventType_0('SERVER_AFFINITY_GROUP_REMOVE', 10);
  AFFINITY_GROUP_CHANGE = new PartitionEventType_0('AFFINITY_GROUP_CHANGE', 11);
  AFFINITY_GROUP_DELETE = new PartitionEventType_0('AFFINITY_GROUP_DELETE', 12);
  ADMIN_INITIATED_PARTITION = new PartitionEventType_0('ADMIN_INITIATED_PARTITION', 13);
  SYSTEM_INITIATED_PARTITION = new PartitionEventType_0('SYSTEM_INITIATED_PARTITION', 14);
  $VALUES_56 = initValues(_3Lorg_rhq_core_domain_cloud_PartitionEventType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$PartitionEventType_$1]), Q$PartitionEventType, [AGENT_REGISTRATION, AGENT_CONNECT, AGENT_SHUTDOWN, AGENT_LEAVE, SERVER_DELETION, SERVER_COMPUTE_POWER_CHANGE, OPERATION_MODE_CHANGE, AGENT_AFFINITY_GROUP_ASSIGN, AGENT_AFFINITY_GROUP_REMOVE, SERVER_AFFINITY_GROUP_ASSIGN, SERVER_AFFINITY_GROUP_REMOVE, AFFINITY_GROUP_CHANGE, AFFINITY_GROUP_DELETE, ADMIN_INITIATED_PARTITION, SYSTEM_INITIATED_PARTITION]);
}

function PartitionEventType_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_65(name_0){
  $clinit_PartitionEventType();
  return valueOf(($clinit_PartitionEventType$Map() , $MAP_56), name_0);
}

function values_59(){
  $clinit_PartitionEventType();
  return $VALUES_56;
}

defineSeed(821, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$PartitionEventType]), PartitionEventType_0);
var $VALUES_56, ADMIN_INITIATED_PARTITION, AFFINITY_GROUP_CHANGE, AFFINITY_GROUP_DELETE, AGENT_AFFINITY_GROUP_ASSIGN, AGENT_AFFINITY_GROUP_REMOVE, AGENT_CONNECT, AGENT_LEAVE, AGENT_REGISTRATION, AGENT_SHUTDOWN, OPERATION_MODE_CHANGE, SERVER_AFFINITY_GROUP_ASSIGN, SERVER_AFFINITY_GROUP_REMOVE, SERVER_COMPUTE_POWER_CHANGE, SERVER_DELETION, SYSTEM_INITIATED_PARTITION;
function $clinit_PartitionEventType$Map(){
  $clinit_PartitionEventType$Map = nullMethod;
  $MAP_56 = createValueOfMap(($clinit_PartitionEventType() , $VALUES_56));
}

var $MAP_56;
function serialize_78(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function deserialize_137(streamReader, instance){
}

function instantiate_134(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_PartitionEventType() , $clinit_PartitionEventType() , $VALUES_56);
  return values[ordinal];
}

function serialize_79(streamWriter, instance){
  $writeInt(streamWriter, instance.ordinal);
}

function serialize_80(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function deserialize_138(streamReader, instance){
}

function instantiate_135(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_PartitionEvent$ExecutionStatus() , $clinit_PartitionEvent$ExecutionStatus() , $VALUES_55);
  return values[ordinal];
}

function serialize_81(streamWriter, instance){
  $writeInt(streamWriter, instance.ordinal);
}

function deserialize_139(streamReader, instance){
  setNative(instance, 'server-enhanced-data-1', $getString(streamReader, $readInt(streamReader)));
  setCtime_6(instance, $readLong(streamReader));
  setEventDetail(instance, $getString(streamReader, $readInt(streamReader)));
  setEventType_0(instance, dynamicCast($readObject(streamReader), Q$PartitionEventType));
  setExecutionStatus(instance, dynamicCast($readObject(streamReader), Q$PartitionEvent$ExecutionStatus));
  setId_20(instance, $readInt(streamReader));
  setPartitionDetails(instance, dynamicCast($readObject(streamReader), Q$List));
  setServerLists(instance, dynamicCast($readObject(streamReader), Q$List));
  instance.subjectName = $getString(streamReader, $readInt(streamReader));
}

function instantiate_136(streamReader){
  return new PartitionEvent_0;
}

function setCtime_6(instance, value){
  instance.ctime = value;
}

function setEventDetail(instance, value){
  instance.eventDetail = value;
}

function setEventType_0(instance, value){
  instance.eventType = value;
}

function setExecutionStatus(instance, value){
  instance.executionStatus = value;
}

function setId_20(instance, value){
  instance.id = value;
}

function setPartitionDetails(instance, value){
  instance.partitionDetails = value;
}

function setServerLists(instance, value){
  instance.serverLists = value;
}

function $setAddress(this$static, address){
  this$static.address = address;
}

function $setOperationMode(this$static, operationMode){
  this$static.operationMode = operationMode;
}

function $setPort(this$static, port){
  this$static.port = port;
}

function $setSecurePort(this$static, securePort){
  this$static.securePort = securePort;
}

function serialize_84(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function AffinityGroupCountComposite_0(){
}

defineSeed(835, 1, makeCastMap([Q$Serializable, Q$AffinityGroupCountComposite]), AffinityGroupCountComposite_0);
_.affinityGroup = null;
_.agentCount = 0;
_.serverCount = 0;
function deserialize_143(streamReader, instance){
  setAffinityGroup_0(instance, dynamicCast($readObject(streamReader), Q$AffinityGroup));
  setAgentCount(instance, $readInt(streamReader));
  setServerCount(instance, $readInt(streamReader));
}

function instantiate_140(streamReader){
  return new AffinityGroupCountComposite_0;
}

function setAffinityGroup_0(instance, value){
  instance.affinityGroup = value;
}

function setAgentCount(instance, value){
  instance.agentCount = value;
}

function setServerCount(instance, value){
  instance.serverCount = value;
}

function ServerWithAgentCountComposite_0(){
}

defineSeed(837, 1, makeCastMap([Q$Serializable, Q$ServerWithAgentCountComposite]), ServerWithAgentCountComposite_0);
_.agentCount = 0;
_.server = null;
function deserialize_144(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_141(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_cloud_composite_ServerWithAgentCountComposite_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ServerWithAgentCountComposite, size, 0);
}

function deserialize_145(streamReader, instance){
  setAgentCount_0(instance, $readInt(streamReader));
  setServer(instance, dynamicCast($readObject(streamReader), Q$Server));
}

function instantiate_142(streamReader){
  return new ServerWithAgentCountComposite_0;
}

function setAgentCount_0(instance, value){
  instance.agentCount = value;
}

function setServer(instance, value){
  instance.server = value;
}

function $isAutoCluster(this$static){
  return ($clinit_EntityContext$Type() , ResourceGroup) == this$static.type_0 && this$static.isAutoCluster;
}

function $isAutoGroup(this$static){
  return ($clinit_EntityContext$Type() , ResourceGroup) == this$static.type_0 && this$static.isAutoGroup;
}

function $toShortString(this$static){
  switch (this$static.type_0.ordinal) {
    case 0:
      return 'resource[id=' + this$static.resourceId + ']';
    case 2:
      return 'resourceGroup[groupId=' + this$static.resourceId + ']';
    case 3:
      return 'autoGroup[parent=' + this$static.parentResourceId + ',type=' + this$static.resourceTypeId + ']';
    case 1:
      return 'template[type=' + this$static.resourceTypeId + ']';
    default:return 'EntityContext[category=' + this$static.type_0 + ',resourceId=' + this$static.resourceId + ',groupId=' + this$static.groupId + ',parent=' + this$static.parentResourceId + ',type=' + this$static.resourceTypeId + ']';
  }
}

function forGroup(groupId, isAutoCluster, isAutoGroup){
  var context;
  context = new EntityContext_0(null, valueOf_44(groupId), null);
  context.isAutoCluster = isAutoCluster;
  context.isAutoGroup = isAutoGroup;
  return context;
}

function serialize_86(streamWriter, instance){
  $writeInt(streamWriter, instance.groupId);
  $writeBoolean(streamWriter, instance.isAutoCluster);
  $writeBoolean(streamWriter, instance.isAutoGroup);
  $writeInt(streamWriter, instance.parentResourceId);
  $writeInt(streamWriter, instance.resourceId);
  $writeInt(streamWriter, instance.resourceTypeId);
  $writeObject(streamWriter, instance.type_0);
}

function serialize_87(streamWriter, instance){
  $writeInt(streamWriter, instance.ordinal);
}

function JobTrigger_0(){
  JobTrigger_7.call(this, ($clinit_JobTrigger$StartType() , NOW), ($clinit_JobTrigger$RecurrenceType() , NONE_6), null);
}

function JobTrigger_1(repeatInterval, repeatCount){
  JobTrigger_7.call(this, ($clinit_JobTrigger$StartType() , NOW), ($clinit_JobTrigger$RecurrenceType() , REPEAT_INTERVAL), ($clinit_JobTrigger$EndType() , REPEAT_COUNT));
  this.repeatInterval = valueOf_45(repeatInterval);
  this.repeatCount = valueOf_44(repeatCount);
}

function JobTrigger_2(repeatInterval, endDate){
  JobTrigger_7.call(this, ($clinit_JobTrigger$StartType() , NOW), ($clinit_JobTrigger$RecurrenceType() , REPEAT_INTERVAL), ($clinit_JobTrigger$EndType() , DATETIME_0));
  this.repeatInterval = valueOf_45(repeatInterval);
  this.endDate = endDate;
}

function JobTrigger_3(cronExpression){
  JobTrigger_7.call(this, ($clinit_JobTrigger$StartType() , NOW), ($clinit_JobTrigger$RecurrenceType() , CRON_EXPRESSION), ($clinit_JobTrigger$EndType() , NEVER));
  this.cronExpression = cronExpression;
}

function JobTrigger_4(startDate){
  JobTrigger_7.call(this, ($clinit_JobTrigger$StartType() , DATETIME_1), ($clinit_JobTrigger$RecurrenceType() , NONE_6), ($clinit_JobTrigger$EndType() , REPEAT_COUNT));
  this.startDate = startDate;
  this.repeatCount = valueOf_44(1);
}

function JobTrigger_5(startDate, repeatInterval, repeatCount){
  JobTrigger_7.call(this, ($clinit_JobTrigger$StartType() , DATETIME_1), ($clinit_JobTrigger$RecurrenceType() , REPEAT_INTERVAL), ($clinit_JobTrigger$EndType() , REPEAT_COUNT));
  this.startDate = startDate;
  this.repeatInterval = valueOf_45(repeatInterval);
  this.repeatCount = valueOf_44(repeatCount);
}

function JobTrigger_6(startDate, repeatInterval, endDate){
  JobTrigger_7.call(this, ($clinit_JobTrigger$StartType() , DATETIME_1), ($clinit_JobTrigger$RecurrenceType() , REPEAT_INTERVAL), ($clinit_JobTrigger$EndType() , DATETIME_0));
  this.startDate = startDate;
  this.repeatInterval = valueOf_45(repeatInterval);
  this.endDate = endDate;
}

function JobTrigger_7(startType, recurrenceType, endType){
  this.startType = startType;
  this.recurrenceType = recurrenceType;
  this.endType = endType;
}

defineSeed(845, 1, makeCastMap([Q$Serializable, Q$JobTrigger]), JobTrigger_0, JobTrigger_1, JobTrigger_2, JobTrigger_3, JobTrigger_4, JobTrigger_5, JobTrigger_6);
_.toString$ = function toString_64(){
  var sb;
  sb = new StringBuilder_0;
  $append_1(sb.data_0, 'Trigger');
  $append_7($append_12(($append_1(sb.data_0, "[cronExpression='") , sb), this.cronExpression), 39);
  $append_11(($append_1(sb.data_0, ', startType=') , sb), this.startType);
  $append_11(($append_1(sb.data_0, ', recurrenceType=') , sb), this.recurrenceType);
  $append_11(($append_1(sb.data_0, ', endType=') , sb), this.endType);
  $append_11(($append_1(sb.data_0, ', startDate=') , sb), this.startDate);
  $append_11(($append_1(sb.data_0, ', repeatInterval=') , sb), this.repeatInterval);
  $append_11(($append_1(sb.data_0, ', endDate=') , sb), this.endDate);
  $append_11(($append_1(sb.data_0, ', repeatCount=') , sb), this.repeatCount);
  $appendNonNull(sb.data_0, ']');
  return $toString_1(sb.data_0);
}
;
_.cronExpression = null;
_.endDate = null;
_.endType = null;
_.recurrenceType = null;
_.repeatCount = null;
_.repeatInterval = null;
_.startDate = null;
_.startType = null;
function $clinit_JobTrigger$EndType(){
  $clinit_JobTrigger$EndType = nullMethod;
  NEVER = new JobTrigger$EndType_0('NEVER', 0);
  DATETIME_0 = new JobTrigger$EndType_0('DATETIME', 1);
  REPEAT_COUNT = new JobTrigger$EndType_0('REPEAT_COUNT', 2);
  $VALUES_59 = initValues(_3Lorg_rhq_core_domain_common_JobTrigger$EndType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$JobTrigger$EndType, [NEVER, DATETIME_0, REPEAT_COUNT]);
}

function JobTrigger$EndType_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_68(name_0){
  $clinit_JobTrigger$EndType();
  return valueOf(($clinit_JobTrigger$EndType$Map() , $MAP_59), name_0);
}

function values_62(){
  $clinit_JobTrigger$EndType();
  return $VALUES_59;
}

defineSeed(846, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$JobTrigger$EndType]), JobTrigger$EndType_0);
var $VALUES_59, DATETIME_0, NEVER, REPEAT_COUNT;
function $clinit_JobTrigger$EndType$Map(){
  $clinit_JobTrigger$EndType$Map = nullMethod;
  $MAP_59 = createValueOfMap(($clinit_JobTrigger$EndType() , $VALUES_59));
}

var $MAP_59;
function $clinit_JobTrigger$RecurrenceType(){
  $clinit_JobTrigger$RecurrenceType = nullMethod;
  NONE_6 = new JobTrigger$RecurrenceType_0('NONE', 0);
  REPEAT_INTERVAL = new JobTrigger$RecurrenceType_0('REPEAT_INTERVAL', 1);
  CRON_EXPRESSION = new JobTrigger$RecurrenceType_0('CRON_EXPRESSION', 2);
  $VALUES_60 = initValues(_3Lorg_rhq_core_domain_common_JobTrigger$RecurrenceType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$JobTrigger$RecurrenceType, [NONE_6, REPEAT_INTERVAL, CRON_EXPRESSION]);
}

function JobTrigger$RecurrenceType_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_69(name_0){
  $clinit_JobTrigger$RecurrenceType();
  return valueOf(($clinit_JobTrigger$RecurrenceType$Map() , $MAP_60), name_0);
}

function values_63(){
  $clinit_JobTrigger$RecurrenceType();
  return $VALUES_60;
}

defineSeed(848, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$JobTrigger$RecurrenceType]), JobTrigger$RecurrenceType_0);
var $VALUES_60, CRON_EXPRESSION, NONE_6, REPEAT_INTERVAL;
function $clinit_JobTrigger$RecurrenceType$Map(){
  $clinit_JobTrigger$RecurrenceType$Map = nullMethod;
  $MAP_60 = createValueOfMap(($clinit_JobTrigger$RecurrenceType() , $VALUES_60));
}

var $MAP_60;
function $clinit_JobTrigger$StartType(){
  $clinit_JobTrigger$StartType = nullMethod;
  NOW = new JobTrigger$StartType_0('NOW', 0);
  DATETIME_1 = new JobTrigger$StartType_0('DATETIME', 1);
  $VALUES_61 = initValues(_3Lorg_rhq_core_domain_common_JobTrigger$StartType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$JobTrigger$StartType, [NOW, DATETIME_1]);
}

function JobTrigger$StartType_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_70(name_0){
  $clinit_JobTrigger$StartType();
  return valueOf(($clinit_JobTrigger$StartType$Map() , $MAP_61), name_0);
}

function values_64(){
  $clinit_JobTrigger$StartType();
  return $VALUES_61;
}

defineSeed(850, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$JobTrigger$StartType]), JobTrigger$StartType_0);
var $VALUES_61, DATETIME_1, NOW;
function $clinit_JobTrigger$StartType$Map(){
  $clinit_JobTrigger$StartType$Map = nullMethod;
  $MAP_61 = createValueOfMap(($clinit_JobTrigger$StartType() , $VALUES_61));
}

var $MAP_61;
function deserialize_146(streamReader, instance){
}

function instantiate_143(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_JobTrigger$EndType() , $clinit_JobTrigger$EndType() , $VALUES_59);
  return values[ordinal];
}

function serialize_88(streamWriter, instance){
  $writeInt(streamWriter, instance.ordinal);
}

function deserialize_147(streamReader, instance){
  setCronExpression(instance, $getString(streamReader, $readInt(streamReader)));
  setEndDate_0(instance, dynamicCast($readObject(streamReader), Q$Date));
  setEndType(instance, dynamicCast($readObject(streamReader), Q$JobTrigger$EndType));
  setRecurrenceType(instance, dynamicCast($readObject(streamReader), Q$JobTrigger$RecurrenceType));
  setRepeatCount(instance, dynamicCast($readObject(streamReader), Q$Integer));
  setRepeatInterval(instance, dynamicCast($readObject(streamReader), Q$Long));
  setStartDate_0(instance, dynamicCast($readObject(streamReader), Q$Date));
  setStartType(instance, dynamicCast($readObject(streamReader), Q$JobTrigger$StartType));
}

function instantiate_144(streamReader){
  return new JobTrigger_0;
}

function serialize_89(streamWriter, instance){
  $writeString(streamWriter, instance.cronExpression);
  $writeObject(streamWriter, instance.endDate);
  $writeObject(streamWriter, instance.endType);
  $writeObject(streamWriter, instance.recurrenceType);
  $writeObject(streamWriter, instance.repeatCount);
  $writeObject(streamWriter, instance.repeatInterval);
  $writeObject(streamWriter, instance.startDate);
  $writeObject(streamWriter, instance.startType);
}

function setCronExpression(instance, value){
  instance.cronExpression = value;
}

function setEndDate_0(instance, value){
  instance.endDate = value;
}

function setEndType(instance, value){
  instance.endType = value;
}

function setRecurrenceType(instance, value){
  instance.recurrenceType = value;
}

function setRepeatCount(instance, value){
  instance.repeatCount = value;
}

function setRepeatInterval(instance, value){
  instance.repeatInterval = value;
}

function setStartDate_0(instance, value){
  instance.startDate = value;
}

function setStartType(instance, value){
  instance.startType = value;
}

function deserialize_148(streamReader, instance){
}

function instantiate_145(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_JobTrigger$RecurrenceType() , $clinit_JobTrigger$RecurrenceType() , $VALUES_60);
  return values[ordinal];
}

function serialize_90(streamWriter, instance){
  $writeInt(streamWriter, instance.ordinal);
}

function deserialize_149(streamReader, instance){
}

function instantiate_146(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_JobTrigger$StartType() , $clinit_JobTrigger$StartType() , $VALUES_61);
  return values[ordinal];
}

function serialize_91(streamWriter, instance){
  $writeInt(streamWriter, instance.ordinal);
}

function getByInternalName(internalName){
  $clinit_SystemSetting();
  var p, p$array, p$index, p$max;
  for (p$array = $VALUES_63 , p$index = 0 , p$max = p$array.length; p$index < p$max; ++p$index) {
    p = p$array[p$index];
    if ($equals_6(p.internalName, internalName)) {
      return p;
    }
  }
  return null;
}

function fromMap(properties){
  var e, e$iterator, p, ret;
  ret = new SystemSettings_0;
  for (e$iterator = properties.entrySet().iterator(); e$iterator.hasNext();) {
    e = dynamicCast(e$iterator.next_0(), Q$Map$Entry);
    p = getByInternalName(dynamicCast(e.getKey_0(), Q$String));
    if (!p) {
      throw new IllegalArgumentException_1("'" + dynamicCast(e.getKey_0(), Q$String) + "' is not a system property.");
    }
    $put_3(ret, p, dynamicCast(e.getValue_1(), Q$String));
  }
  return ret;
}

defineSeed(866, 666, makeCastMap([Q$Serializable, Q$Cloneable, Q$HashMap, Q$Map, Q$SystemSettings]));
_.putAll = function putAll_0(m_0){
  var e, e$iterator;
  for (e$iterator = m_0.entrySet().iterator(); e$iterator.hasNext();) {
    e = dynamicCast(e$iterator.next_0(), Q$Map$Entry);
    $put_3(this, dynamicCast(e.getKey_0(), Q$SystemSetting), dynamicCast(e.getValue_1(), Q$String));
  }
}
;
function $addRawConfiguration(this$static, rawConfiguration){
  rawConfiguration.configuration = this$static;
  this$static.rawConfigurations.add(rawConfiguration);
}

function $createDeepCopyOfProperties(this$static, copy, keepId){
  var property, property$iterator;
  for (property$iterator = this$static.properties.values_0().iterator(); property$iterator.hasNext();) {
    property = dynamicCast(property$iterator.next_0(), Q$Property);
    $put_4(copy, property.deepCopy(keepId));
  }
}

function $createDeepCopyOfRawConfigs(this$static, copy, keepId){
  var rawConfig, rawConfig$iterator, copy_0;
  for (rawConfig$iterator = this$static.rawConfigurations.iterator(); rawConfig$iterator.hasNext();) {
    rawConfig = dynamicCast(rawConfig$iterator.next_0(), Q$RawConfiguration);
    $addRawConfiguration(copy, (copy_0 = new RawConfiguration_0 , keepId && (copy_0.id = rawConfig.id) , copy_0.path = rawConfig.path , rawConfig.contents_0 != null && $setContents_1(copy_0, rawConfig.contents_0, rawConfig.sha256) , copy_0.errorMessage_0 = rawConfig.errorMessage_0 , copy_0));
  }
}

function $deepCopy(this$static, keepIds){
  var copy;
  copy = new Configuration_0;
  keepIds && (copy.id = this$static.id);
  copy.notes = this$static.notes;
  copy.version_0 = this$static.version_0;
  $createDeepCopyOfProperties(this$static, copy, keepIds);
  $createDeepCopyOfRawConfigs(this$static, copy, keepIds);
  return copy;
}

function $deepCopyWithoutProxies(this$static){
  var copy;
  copy = new Configuration_0;
  copy.notes = this$static.notes;
  copy.version_0 = this$static.version_0;
  $createDeepCopyOfProperties(this$static, copy, false);
  $createDeepCopyOfRawConfigs(this$static, copy, false);
  return copy;
}

function $get_6(this$static, name_0){
  return dynamicCast(this$static.properties.get_2(name_0), Q$Property);
}

function $getSimple(this$static, name_0){
  return dynamicCast(this$static.properties.get_2(name_0), Q$PropertySimple);
}

function $getSimpleProperties(this$static){
  var map, prop, prop$iterator;
  map = new LinkedHashMap_0;
  for (prop$iterator = (!this$static.propertiesProxy && (this$static.propertiesProxy = new Configuration$PropertiesProxy_0(this$static)) , this$static.propertiesProxy.this$0.properties.values_0().iterator()); prop$iterator.hasNext();) {
    prop = dynamicCast(prop$iterator.next_0(), Q$Property);
    instanceOf(prop, Q$PropertySimple) && $put_1(map, prop.name_0, dynamicCast(prop, Q$PropertySimple));
  }
  return map;
}

function $remove_16(this$static, name_0){
  return dynamicCast(this$static.properties.remove_3(name_0), Q$Property);
}

defineSeed(872, 1, makeCastMap([Q$Serializable, Q$Cloneable, Q$AbstractPropertyMap, Q$Configuration]));
_.get_3 = function get_16(name_0){
  return $get_6(this, name_0);
}
;
_.getList = function getList(name_0){
  return $getList(this, name_0);
}
;
_.getMap = function getMap(){
  return this.properties;
}
;
_.getMap_0 = function getMap_0(name_0){
  return $getMap(this, name_0);
}
;
_.getSimple = function getSimple(name_0){
  return $getSimple(this, name_0);
}
;
_.put_0 = function put_5(value){
  $put_4(this, value);
}
;
function $add_9(this$static, e){
  $put_4(this$static.this$0, e);
  return true;
}

function Configuration$PropertiesProxy_0(this$0){
  this.this$0 = this$0;
}

defineSeed(873, 1, makeCastMap([Q$Iterable, Q$Collection]), Configuration$PropertiesProxy_0);
_.add = function add_13(e){
  return $add_9(this, dynamicCast(e, Q$Property));
}
;
_.equals$ = function equals_47(obj_0){
  if (this === obj_0) {
    return true;
  }
  if (!instanceOf(obj_0, Q$Collection)) {
    return false;
  }
  return this.this$0.properties.values_0().equals$(obj_0);
}
;
_.hashCode$ = function hashCode_47(){
  return this.this$0.properties.values_0().hashCode$();
}
;
_.iterator = function iterator_16(){
  return this.this$0.properties.values_0().iterator();
}
;
_.size_1 = function size_23(){
  return this.this$0.properties.size_1();
}
;
_.toArray = function toArray_8(){
  return this.this$0.properties.values_0().toArray();
}
;
_.toString$ = function toString_67(){
  return this.this$0.properties.values_0().toString$();
}
;
_.this$0 = null;
function serialize_96(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function normalizeConfiguration(configuration, configurationDefinition){
  var childPropertyDefinition, childPropertyDefinition$iterator, childPropertyDefinitions;
  if (!configuration) {
    throw new IllegalArgumentException_1('Configuration parameter is null.');
  }
  if (configurationDefinition) {
    childPropertyDefinitions = (!configurationDefinition.propertyDefinitions && (configurationDefinition.propertyDefinitions = new LinkedHashMap_0) , configurationDefinition.propertyDefinitions);
    for (childPropertyDefinition$iterator = childPropertyDefinitions.values_0().iterator(); childPropertyDefinition$iterator.hasNext();) {
      childPropertyDefinition = dynamicCast(childPropertyDefinition$iterator.next_0(), Q$PropertyDefinition);
      normalizeProperty(childPropertyDefinition, configuration, true);
    }
  }
}

function normalizeProperty(propertyDefinition, parentPropertyMap, normalizeRequiredDefaults){
  var listMemberPropertyDefinition, property, property$iterator, propertyDefinitionList, propertyDefinitionMap, propertyList, propertyMap, propertySimple, value;
  if (parentPropertyMap.getMap().keySet_0().contains_0(propertyDefinition.name_0)) {
    if (instanceOf(propertyDefinition, Q$PropertyDefinitionSimple)) {
      propertySimple = parentPropertyMap.getSimple(propertyDefinition.name_0);
      value = propertySimple.stringValue;
      value != null && ($equals_6(value, '')?$setValue_12(propertySimple, null):value.length > 2000 && $setValue_12(propertySimple, value.substr(0, 2000 - 0)));
    }
     else if (instanceOf(propertyDefinition, Q$PropertyDefinitionMap)) {
      propertyMap = parentPropertyMap.getMap_0(propertyDefinition.name_0);
      propertyDefinitionMap = dynamicCast(propertyDefinition, Q$PropertyDefinitionMap);
      normalizePropertyMap(propertyMap, propertyDefinitionMap);
    }
     else if (instanceOf(propertyDefinition, Q$PropertyDefinitionList)) {
      propertyDefinitionList = dynamicCast(propertyDefinition, Q$PropertyDefinitionList);
      listMemberPropertyDefinition = propertyDefinitionList.memberDefinition;
      if (instanceOf(listMemberPropertyDefinition, Q$PropertyDefinitionMap)) {
        propertyDefinitionMap = dynamicCast(listMemberPropertyDefinition, Q$PropertyDefinitionMap);
        propertyList = parentPropertyMap.getList(propertyDefinition.name_0);
        for (property$iterator = (!propertyList.list && (propertyList.list = new ArrayList_0) , propertyList.list).iterator(); property$iterator.hasNext();) {
          property = dynamicCast(property$iterator.next_0(), Q$Property);
          propertyMap = dynamicCast(property, Q$PropertyMap);
          normalizePropertyMap(propertyMap, propertyDefinitionMap);
        }
      }
    }
  }
   else {
    if (instanceOf(propertyDefinition, Q$PropertyDefinitionSimple)) {
      value = null;
      normalizeRequiredDefaults && propertyDefinition.required && (value = dynamicCast(propertyDefinition, Q$PropertyDefinitionSimple).defaultValue);
      property = new PropertySimple_1(propertyDefinition.name_0, value);
    }
     else if (instanceOf(propertyDefinition, Q$PropertyDefinitionMap)) {
      property = new PropertyMap_1(propertyDefinition.name_0);
    }
     else if (instanceOf(propertyDefinition, Q$PropertyDefinitionList)) {
      property = new PropertyList_1(propertyDefinition.name_0);
    }
     else if (instanceOf(propertyDefinition, Q$PropertyDefinitionDynamic)) {
      property = new PropertySimple_1(propertyDefinition.name_0, null);
    }
     else {
      throw new IllegalStateException_1('Unsupported PropertyDefinition subclass: ' + propertyDefinition.___clazz$.typeName);
    }
    parentPropertyMap.put_0(property);
  }
}

function normalizePropertyMap(propertyMap, propertyDefinitionMap){
  var childPropertyDefinition, childPropertyDefinition$iterator, childPropertyDefinitions;
  childPropertyDefinitions = (!propertyDefinitionMap.map && (propertyDefinitionMap.map = new HashMap_0) , propertyDefinitionMap.map);
  for (childPropertyDefinition$iterator = childPropertyDefinitions.values_0().iterator(); childPropertyDefinition$iterator.hasNext();) {
    childPropertyDefinition = dynamicCast(childPropertyDefinition$iterator.next_0(), Q$PropertyDefinition);
    normalizeProperty(childPropertyDefinition, propertyMap, false);
  }
}

function $setErrorMessage(this$static, errorMessage){
  this$static.errorMessage_0 = errorMessage != null?$trim(errorMessage):null;
}

function Property_1(original, keepId){
  keepId && (this.id = original.id);
  this.errorMessage_0 = original.errorMessage_0;
  this.name_0 = original.name_0;
}

defineSeed(882, 1, makeCastMap([Q$Serializable, Q$Comparable, Q$DeepCopyable, Q$Property]));
_.deepCopy = function deepCopy(keepId){
  return null;
}
;
function $getIntegerValue(this$static){
  return this$static.stringValue == null?null:valueOf_44(__parseAndValidateInt(this$static.stringValue));
}

function $setOverride(this$static, override){
  this$static.override = override;
}

function PropertySimple_2(original, keepId){
  Property_1.call(this, original, keepId);
  this.stringValue = original.stringValue;
  this.override = original.override;
}

defineSeed(881, 882, makeCastMap([Q$Serializable, Q$Comparable, Q$DeepCopyable, Q$Property, Q$PropertySimple]), PropertySimple_2);
_.deepCopy = function deepCopy_0(keepId){
  return this.deepCopy_0(keepId);
}
;
_.deepCopy_0 = function deepCopy_1(keepId){
  return new PropertySimple_2(this, keepId);
}
;
function ObfuscatedPropertySimple_1(original, keepId){
  PropertySimple_2.call(this, original, keepId);
}

defineSeed(880, 881, makeCastMap([Q$Serializable, Q$Comparable, Q$DeepCopyable, Q$ObfuscatedPropertySimple, Q$Property, Q$PropertySimple]), ObfuscatedPropertySimple_1);
_.deepCopy_0 = function deepCopy_2(keepId){
  return new ObfuscatedPropertySimple_1(this, keepId);
}
;
defineSeed(885, 870, makeCastMap([Q$Serializable, Q$AbstractConfigurationUpdate, Q$AbstractResourceConfigurationUpdate, Q$PluginConfigurationUpdate]));
_.getAbstractGroupConfigurationUpdate = function getAbstractGroupConfigurationUpdate(){
  return this.groupConfigurationUpdate;
}
;
_.getResource = function getResource(){
  return this.resource;
}
;
function $setConfigurationDefinition(this$static, configurationDefinition){
  this$static.configurationDefinition = configurationDefinition;
}

function $setDisplayName(this$static, displayName){
  this$static.displayName = displayName;
}

function $setOrder(this$static, order){
  this$static.order = order;
}

function $setReadOnly_0(this$static, readOnly){
  this$static.readOnly = readOnly;
}

function PropertyDefinition_1(name_0, description, required){
  this.name_0 = name_0;
  this.description = description;
  this.required = required;
}

function $add_10(this$static, property){
  this$static.memberPropertyName == null && (this$static.memberPropertyName = property.name_0);
  if (!$equals_6(property.name_0, this$static.memberPropertyName)) {
    throw new IllegalStateException_1('All properties in a PropertyList (id=[' + this$static.id + '], name=[' + this$static.name_0 + ']) must have the same name: [' + property.name_0 + '] != [' + this$static.memberPropertyName + ']');
  }
  (!this$static.list && (this$static.list = new ArrayList_0) , this$static.list).add(property);
  property.parentList = this$static;
}

function $deepCopy_0(this$static, keepId){
  var copy, property, property$iterator;
  copy = new PropertyList_3(this$static, keepId);
  for (property$iterator = this$static.list.iterator(); property$iterator.hasNext();) {
    property = dynamicCast(property$iterator.next_0(), Q$Property);
    $add_10(copy, property.deepCopy(false));
  }
  return copy;
}

function $getList_0(this$static){
  !this$static.list && (this$static.list = new ArrayList_0);
  return this$static.list;
}

function PropertyList_1(name_0){
  $$init_8(this);
  this.name_0 = name_0;
}

function PropertyList_2(name_0, startingList){
  var property, property$index, property$max;
  PropertyList_1.call(this, name_0);
  for (property$index = 0 , property$max = startingList.length; property$index < property$max; ++property$index) {
    property = startingList[property$index];
    $add_10(this, property);
  }
}

function PropertyList_3(original, keepId){
  Property_1.call(this, original, keepId);
  $$init_8(this);
}

defineSeed(894, 882, makeCastMap([Q$Serializable, Q$Comparable, Q$DeepCopyable, Q$Property, Q$PropertyList]), PropertyList_1, PropertyList_2, PropertyList_3);
_.deepCopy = function deepCopy_3(keepId){
  return $deepCopy_0(this, keepId);
}
;
function $deepCopy_1(this$static, keepId){
  var copy, property, property$iterator;
  copy = new PropertyMap_2(this$static, keepId);
  for (property$iterator = this$static.map.values_0().iterator(); property$iterator.hasNext();) {
    property = dynamicCast(property$iterator.next_0(), Q$Property);
    $put_5(copy, property.deepCopy(keepId));
  }
  return copy;
}

function $get_7(this$static, name_0){
  return dynamicCast((!this$static.map && (this$static.map = new LinkedHashMap_0) , this$static.map).get_2(name_0), Q$Property);
}

function $getSimple_0(this$static, name_0){
  return dynamicCast(dynamicCast((!this$static.map && (this$static.map = new LinkedHashMap_0) , this$static.map).get_2(name_0), Q$Property), Q$PropertySimple);
}

function $put_5(this$static, property){
  (!this$static.map && (this$static.map = new LinkedHashMap_0) , this$static.map).put(property.name_0, property);
  property.parentMap = this$static;
}

function PropertyMap_1(name_0){
  $$init_9(this);
  this.name_0 = name_0;
}

function PropertyMap_2(original, keepId){
  Property_1.call(this, original, keepId);
  $$init_9(this);
}

defineSeed(896, 882, makeCastMap([Q$Serializable, Q$Comparable, Q$AbstractPropertyMap, Q$DeepCopyable, Q$Property, Q$PropertyMap]), PropertyMap_1, PropertyMap_2);
_.deepCopy = function deepCopy_4(keepId){
  return $deepCopy_1(this, keepId);
}
;
_.get_3 = function get_17(name_0){
  return $get_7(this, name_0);
}
;
_.getList = function getList_0(name_0){
  return dynamicCast(dynamicCast((!this.map && (this.map = new LinkedHashMap_0) , this.map).get_2(name_0), Q$Property), Q$PropertyList);
}
;
_.getMap = function getMap_1(){
  return !this.map && (this.map = new LinkedHashMap_0) , this.map;
}
;
_.getMap_0 = function getMap_2(name_0){
  return dynamicCast(dynamicCast((!this.map && (this.map = new LinkedHashMap_0) , this.map).get_2(name_0), Q$Property), Q$PropertyMap);
}
;
_.getSimple = function getSimple_0(name_0){
  return $getSimple_0(this, name_0);
}
;
_.put_0 = function put_6(property){
  $put_5(this, property);
}
;
function $setContents_1(this$static, contents, sha256){
  this$static.contents_0 = contents;
  this$static.errorMessage_0 = null;
  this$static.sha256 = sha256;
}

defineSeed(904, 870, makeCastMap([Q$Serializable, Q$AbstractConfigurationUpdate, Q$AbstractResourceConfigurationUpdate, Q$ResourceConfigurationUpdate]));
_.getAbstractGroupConfigurationUpdate = function getAbstractGroupConfigurationUpdate_0(){
  return this.groupConfigurationUpdate;
}
;
_.getResource = function getResource_0(){
  return this.resource;
}
;
function ResourceConfigurationComposite_0(resourceId, configuration){
  this.resourceId = resourceId;
  this.configuration = configuration;
}

defineSeed(907, 1, makeCastMap([Q$Serializable]), ResourceConfigurationComposite_0);
_.configuration = null;
_.resourceId = 0;
function serialize_114(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function serialize_115(streamWriter, instance){
  $writeObject(streamWriter, instance.configuration);
  $writeInt(streamWriter, instance.resourceId);
}

function $get_8(this$static, name_0){
  return dynamicCast(this$static.propertyDefinitions.get_2(name_0), Q$PropertyDefinition);
}

function $getConfigurationFormat(this$static){
  !this$static.configurationFormat && (this$static.configurationFormat = ($clinit_ConfigurationFormat() , STRUCTURED));
  return this$static.configurationFormat;
}

function $getDefaultTemplate(this$static){
  return dynamicCast((!this$static.templates && (this$static.templates = new LinkedHashMap_0) , this$static.templates).get_2('default'), Q$ConfigurationTemplate);
}

function $getGroupDefinitions(this$static){
  var group, group$iterator, groupSet, groups, propertyDefinition, propertyDefinition$iterator;
  groupSet = new HashSet_0;
  for (propertyDefinition$iterator = (!this$static.propertyDefinitions && (this$static.propertyDefinitions = new LinkedHashMap_0) , this$static.propertyDefinitions).values_0().iterator(); propertyDefinition$iterator.hasNext();) {
    propertyDefinition = dynamicCast(propertyDefinition$iterator.next_0(), Q$PropertyDefinition);
    !!propertyDefinition.propertyGroupDefinition && $add_6(groupSet, propertyDefinition.propertyGroupDefinition);
  }
  groups = new ArrayList_1(groupSet.map.size_1());
  for (group$iterator = $iterator($keySet(groupSet.map)); group$iterator.val$outerIter.hasNext();) {
    group = dynamicCast($next_1(group$iterator), Q$PropertyGroupDefinition);
    setCheck(groups.array, groups.size_0++, group);
  }
  sort_1(groups, new ConfigurationDefinition$GroupComparator_0);
  return groups;
}

function $getNonGroupedProperties(this$static){
  var propertyDefinition, propertyDefinition$iterator, propertyDefinitions;
  propertyDefinitions = new ArrayList_0;
  for (propertyDefinition$iterator = this$static.propertyDefinitions.values_0().iterator(); propertyDefinition$iterator.hasNext();) {
    propertyDefinition = dynamicCast(propertyDefinition$iterator.next_0(), Q$PropertyDefinition);
    !propertyDefinition.propertyGroupDefinition && (setCheck(propertyDefinitions.array, propertyDefinitions.size_0++, propertyDefinition) , true);
  }
  sort_1(propertyDefinitions, new ConfigurationDefinition$PropertyDefinitionComparator_0);
  return propertyDefinitions;
}

function $getPropertiesInGroup(this$static, groupName){
  var group, propertyDefinition, propertyDefinition$iterator, propertyDefinitions;
  propertyDefinitions = new ArrayList_0;
  for (propertyDefinition$iterator = this$static.propertyDefinitions.values_0().iterator(); propertyDefinition$iterator.hasNext();) {
    propertyDefinition = dynamicCast(propertyDefinition$iterator.next_0(), Q$PropertyDefinition);
    group = propertyDefinition.propertyGroupDefinition;
    !!group && $equals_6(group.name_0, groupName) && (setCheck(propertyDefinitions.array, propertyDefinitions.size_0++, propertyDefinition) , true);
  }
  sort_1(propertyDefinitions, new ConfigurationDefinition$PropertyDefinitionComparator_0);
  return propertyDefinitions;
}

function $put_6(this$static, propertyDefinition){
  !this$static.propertyDefinitions && (this$static.propertyDefinitions = new LinkedHashMap_0);
  this$static.propertyDefinitions.put(propertyDefinition.name_0, propertyDefinition);
  propertyDefinition.configurationDefinition = this$static;
}

function $setConfigurationFormat(this$static, configurationFormat){
  this$static.configurationFormat = configurationFormat;
}

function ConfigurationDefinition_1(name_0, description){
  $$init_10(this);
  this.name_0 = name_0;
  this.description = description;
}

defineSeed(913, 1, makeCastMap([Q$Serializable, Q$ConfigurationDefinition]), ConfigurationDefinition_1);
function $compare_0(group1, group2){
  return group1.order == group2.order?compareTo_11(group1.name_0, group2.name_0):$compareTo_5(valueOf_44(group1.order), valueOf_44(group2.order));
}

function ConfigurationDefinition$GroupComparator_0(){
}

defineSeed(914, 1, makeCastMap([Q$Comparator]), ConfigurationDefinition$GroupComparator_0);
_.compare = function compare_2(group1, group2){
  return $compare_0(dynamicCast(group1, Q$PropertyGroupDefinition), dynamicCast(group2, Q$PropertyGroupDefinition));
}
;
function $compare_1(propDef1, propDef2){
  return propDef1.order == propDef2.order?compareTo_11(propDef1.name_0, propDef2.name_0):$compareTo_5(valueOf_44(propDef1.order), valueOf_44(propDef2.order));
}

function ConfigurationDefinition$PropertyDefinitionComparator_0(){
}

defineSeed(915, 1, makeCastMap([Q$Comparator]), ConfigurationDefinition$PropertyDefinitionComparator_0);
_.compare = function compare_3(propDef1, propDef2){
  return $compare_1(dynamicCast(propDef1, Q$PropertyDefinition), dynamicCast(propDef2, Q$PropertyDefinition));
}
;
function ConfigurationTemplate_1(){
  this.name_0 = 'default';
  this.description = 'default template';
}

defineSeed(920, 1, makeCastMap([Q$Serializable, Q$ConfigurationTemplate]), ConfigurationTemplate_1);
function $setOrderIndex(this$static, orderIndex){
  this$static.orderIndex = orderIndex;
}

function PropertyDefinitionEnumeration_1(name_0, value){
  this.name_0 = name_0;
  this.value_0 = value;
}

defineSeed(922, 1, makeCastMap([Q$Serializable, Q$PropertyDefinitionEnumeration]), PropertyDefinitionEnumeration_1);
function $setMax_1(this$static, max){
  this$static.max_0 = max;
}

function $setMin_1(this$static, min){
  this$static.min_0 = min;
}

function PropertyDefinitionList_1(name_0, description, required, memberDefinition){
  PropertyDefinition_1.call(this, name_0, description, required);
  this.memberDefinition = memberDefinition;
  !!memberDefinition && (this.memberDefinition.parentPropertyListDefinition = this , undefined);
}

defineSeed(925, 889, makeCastMap([Q$Serializable, Q$PropertyDefinition, Q$PropertyDefinitionList]), PropertyDefinitionList_1);
function $get_9(this$static, name_0){
  return dynamicCast((!this$static.map && (this$static.map = new HashMap_0) , this$static.map).get_2(name_0), Q$PropertyDefinition);
}

function $getPropertyDefinitions(this$static){
  var key, key$iterator, map, orderComparator, result;
  map = (!this$static.map && (this$static.map = new HashMap_0) , this$static.map);
  if (map.size_1() <= 1) {
    return map;
  }
  orderComparator = new PropertyDefinitionMap$1_0(this$static);
  result = new TreeMap_1(orderComparator);
  for (key$iterator = map.keySet_0().iterator(); key$iterator.hasNext();) {
    key = dynamicCast(key$iterator.next_0(), Q$String);
    $put_2(result, key, dynamicCast(map.get_2(key), Q$PropertyDefinition));
  }
  return result;
}

function $put_7(this$static, propertyDefinition){
  var map, order, p, p$iterator, size;
  map = (!this$static.map && (this$static.map = new HashMap_0) , this$static.map);
  if (map.isEmpty_0()) {
    propertyDefinition.order = 0;
  }
   else {
    order = propertyDefinition.order;
    size = map.size_1();
    if (order <= 0 || order >= size) {
      propertyDefinition.order = size;
    }
     else {
      for (p$iterator = map.values_0().iterator(); p$iterator.hasNext();) {
        p = dynamicCast(p$iterator.next_0(), Q$PropertyDefinition);
        p.order >= order && $setOrder(p, p.order + 1);
      }
    }
  }
  map.put(propertyDefinition.name_0, propertyDefinition);
  propertyDefinition.parentPropertyMapDefinition = this$static;
}

function PropertyDefinitionMap_1(name_0, description, required, properties){
  var property, property$index, property$max;
  PropertyDefinition_1.call(this, name_0, description, required);
  if (properties != null) {
    for (property$index = 0 , property$max = properties.length; property$index < property$max; ++property$index) {
      property = properties[property$index];
      $put_7(this, property);
    }
  }
}

defineSeed(927, 889, makeCastMap([Q$Serializable, Q$PropertyDefinition, Q$PropertyDefinitionMap]), PropertyDefinitionMap_1);
function $compare_2(this$static, o1, o2){
  return $compareTo_5(valueOf_44($get_9(this$static.this$0, o1).order), valueOf_44($get_9(this$static.this$0, o2).order));
}

function PropertyDefinitionMap$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(928, 1, makeCastMap([Q$Comparator]), PropertyDefinitionMap$1_0);
_.compare = function compare_4(o1, o2){
  return $compare_2(this, dynamicCast(o1, Q$String), dynamicCast(o2, Q$String));
}
;
_.this$0 = null;
function $addConstraints(this$static, constraintsToAdd){
  var constraint, constraint$index, constraint$max;
  for (constraint$index = 0 , constraint$max = constraintsToAdd.length; constraint$index < constraint$max; ++constraint$index) {
    constraint = constraintsToAdd[constraint$index];
    this$static.constraints.add(constraint);
    constraint.propertyDefinitionSimple = this$static;
  }
}

function $addEnumeratedValues(this$static, enumerations){
  var enumeration, enumeration$index, enumeration$max;
  for (enumeration$index = 0 , enumeration$max = enumerations.length; enumeration$index < enumeration$max; ++enumeration$index) {
    enumeration = enumerations[enumeration$index];
    enumeration.propertyDefinitionSimple = this$static;
    this$static.enumeratedValues.add(enumeration);
  }
  $ensureOrdering(this$static);
}

function $ensureOrdering(this$static){
  var i, size;
  if (!this$static.enumeratedValues) {
    return;
  }
  for (i = 0 , size = this$static.enumeratedValues.size_1(); i < size; ++i) {
    $setOrderIndex(dynamicCast(this$static.enumeratedValues.get_0(i), Q$PropertyDefinitionEnumeration), i);
  }
}

function $setDefaultValue_3(this$static, defaultValue){
  this$static.defaultValue = defaultValue;
}

function $setEnumeratedValues(this$static, enumeratedValues){
  $addEnumeratedValues(this$static, dynamicCast($toArray_1(enumeratedValues, initDim(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$PropertyDefinitionEnumeration_$1]), Q$PropertyDefinitionEnumeration, enumeratedValues.size_0, 0)), Q$PropertyDefinitionEnumeration_$1));
  this$static.allowCustomEnumeratedValue = false;
  $ensureOrdering(this$static);
}

function PropertyDefinitionSimple_1(name_0, description, required, type){
  PropertyDefinition_1.call(this, name_0, description, required);
  $$init_11(this);
  this.type_0 = type;
}

defineSeed(930, 889, makeCastMap([Q$Serializable, Q$PropertyDefinition, Q$PropertyDefinitionSimple]), PropertyDefinitionSimple_1);
function $setDefaultHidden(this$static, defaultHidden){
  this$static.defaultHidden = defaultHidden;
}

function $setDisplayName_0(this$static, displayName){
  this$static.displayName = displayName;
}

function PropertyGroupDefinition_1(name_0){
  this.name_0 = name_0;
}

defineSeed(933, 1, makeCastMap([Q$Serializable, Q$PropertyGroupDefinition]), PropertyGroupDefinition_1);
function IntegerRangeConstraint_1(minimum, maximum){
  var min, max;
  this.minimum = minimum;
  this.maximum = maximum;
  min = !this.minimum?'*':'' + toString_8(this.minimum.value_0);
  max = !this.maximum?'*':'' + toString_8(this.maximum.value_0);
  this.details = min + '#' + max;
}

defineSeed(948, 944, makeCastMap([Q$Serializable, Q$Constraint, Q$IntegerRangeConstraint]), IntegerRangeConstraint_1);
function deserialize_202(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_195(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_content_Architecture_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Architecture, size, 0);
}

function PackageVersionFormatDescription_0(){
}

defineSeed(1019, 1, makeCastMap([Q$Serializable, Q$PackageVersionFormatDescription]), PackageVersionFormatDescription_0);
_.fullFormatRegex = null;
_.osgiVersionExtractionRegex = null;
_.osgiVersionGroupIndex = 0;
_.textualDesctiption = null;
function deserialize_226(streamReader, instance){
  setFullFormatRegex(instance, $getString(streamReader, $readInt(streamReader)));
  setOsgiVersionExtractionRegex(instance, $getString(streamReader, $readInt(streamReader)));
  setOsgiVersionGroupIndex(instance, $readInt(streamReader));
  setTextualDesctiption(instance, $getString(streamReader, $readInt(streamReader)));
}

function instantiate_219(streamReader){
  return new PackageVersionFormatDescription_0;
}

function setFullFormatRegex(instance, value){
  instance.fullFormatRegex = value;
}

function setOsgiVersionExtractionRegex(instance, value){
  instance.osgiVersionExtractionRegex = value;
}

function setOsgiVersionGroupIndex(instance, value){
  instance.osgiVersionGroupIndex = value;
}

function setTextualDesctiption(instance, value){
  instance.textualDesctiption = value;
}

function PackageAndLatestVersionComposite_0(){
}

defineSeed(1054, 1, makeCastMap([Q$Serializable, Q$PackageAndLatestVersionComposite]), PackageAndLatestVersionComposite_0);
_.generalPackage = null;
_.latestPackageVersion = null;
function deserialize_246(streamReader, instance){
  setGeneralPackage_0(instance, dynamicCast($readObject(streamReader), Q$Package));
  setLatestPackageVersion(instance, dynamicCast($readObject(streamReader), Q$PackageVersion));
}

function instantiate_239(streamReader){
  return new PackageAndLatestVersionComposite_0;
}

function setGeneralPackage_0(instance, value){
  instance.generalPackage = value;
}

function setLatestPackageVersion(instance, value){
  instance.latestPackageVersion = value;
}

function PackageTypeAndVersionFormatComposite_0(){
}

defineSeed(1056, 1, makeCastMap([Q$Serializable, Q$PackageTypeAndVersionFormatComposite]), PackageTypeAndVersionFormatComposite_0);
_.packageType = null;
_.versionFormat = null;
function deserialize_247(streamReader, instance){
  setPackageType_1(instance, dynamicCast($readObject(streamReader), Q$PackageType));
  setVersionFormat(instance, dynamicCast($readObject(streamReader), Q$PackageVersionFormatDescription));
}

function instantiate_240(streamReader){
  return new PackageTypeAndVersionFormatComposite_0;
}

function setPackageType_1(instance, value){
  instance.packageType = value;
}

function setVersionFormat(instance, value){
  instance.versionFormat = value;
}

function $addRequiredPermissions(this$static, requiredPermissions){
  this$static.requiredPermissions = new Arrays$ArrayList_0(requiredPermissions);
}

function $getAlias(this$static){
  var className, classSimpleName;
  if (this$static.alias == null) {
    className = this$static.getPersistentClass().typeName;
    classSimpleName = $substring(className, className.lastIndexOf('.') + 1);
    this$static.alias = classSimpleName.toLowerCase();
  }
  return this$static.alias;
}

function $setRestriction(this$static, restriction){
  this$static.restriction = restriction;
}

function $setSearchExpression(this$static, searchExpression){
  this$static.searchExpression = searchExpression;
}

defineSeed(1062, 1, makeCastMap([Q$Serializable, Q$Criteria]));
_.getPageControlOverrides = function getPageControlOverrides(){
  return this.pageControlOverrides;
}
;
_.setPageControl = function setPageControl(pageControl){
  this.pageControlOverrides = pageControl;
}
;
function $addFilterEndTime(this$static, filterEndTime){
  this$static.filterEndTime = filterEndTime;
}

function $addFilterStartTime(this$static, filterStartTime){
  this$static.filterStartTime = filterStartTime;
}

function $addSortStatus(this$static, sortStatus){
  $add_3(this$static.orderingFieldNames, 'sort' + charToString(toUpperCase(115)) + 'tatus');
  this$static.sortStatus = sortStatus;
}

function AbstractConfigurationUpdateCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('startTime', 'createdTime >= ?');
  this.filterOverrides.put('endTime', 'createdTime <= ?');
  this.filterOverrides.put('statuses', 'status IN ( ? )');
}

defineSeed(1061, 1062, makeCastMap([Q$Serializable, Q$Criteria]));
_.fetchConfiguration = false;
_.filterEndTime = null;
_.filterStartTime = null;
_.filterStatus = null;
_.filterStatuses = null;
_.sortCreatedTime = null;
_.sortStatus = null;
function serialize_187(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchConfiguration);
  $writeObject(streamWriter, instance.filterEndTime);
  $writeObject(streamWriter, instance.filterStartTime);
  $writeObject(streamWriter, instance.filterStatus);
  $writeObject(streamWriter, instance.filterStatuses);
  $writeObject(streamWriter, instance.sortCreatedTime);
  $writeObject(streamWriter, instance.sortStatus);
  serialize_200(streamWriter, instance);
}

function $addFilterResourceGroupIds(this$static, filterResourceGroupIds){
  this$static.filterResourceGroupIds = filterResourceGroupIds;
}

function AbstractGroupConfigurationUpdateCriteria_0(){
  AbstractConfigurationUpdateCriteria_0.call(this);
  this.filterOverrides.put('resourceGroupIds', 'group.id IN ( ? )');
}

defineSeed(1064, 1061, makeCastMap([Q$Serializable, Q$Criteria]));
_.fetchConfigurationUpdates = false;
_.filterResourceGroupIds = null;
function serialize_188(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchConfigurationUpdates);
  $writeObject(streamWriter, instance.filterResourceGroupIds);
  serialize_187(streamWriter, instance);
}

function AbstractResourceConfigurationUpdateCriteria_0(){
  AbstractConfigurationUpdateCriteria_0.call(this);
}

defineSeed(1066, 1061, makeCastMap([Q$Serializable, Q$Criteria]));
function $addFilterAddress(this$static, filterAddress){
  this$static.filterAddress = filterAddress;
}

function $addFilterAffinityGroupId(this$static, filterAffinityGroupId){
  this$static.filterAffinityGroupId = filterAffinityGroupId;
}

function $addFilterAgenttoken(this$static, filterAgenttoken){
  this$static.filterAgenttoken = filterAgenttoken;
}

function $addFilterName(this$static, filterName){
  this$static.filterName = filterName;
}

function $addFilterPort(this$static, filterPort){
  this$static.filterPort = filterPort;
}

function $addFilterServerId(this$static, filterServerId){
  this$static.filterServerId = filterServerId;
}

function AgentCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('serverId', 'server.id = ?');
  this.filterOverrides.put('affinityGroupId', 'affinityGroup.id = ?');
}

defineSeed(1067, 1062, makeCastMap([Q$Serializable, Q$AgentCriteria, Q$Criteria]), AgentCriteria_0);
_.getPersistentClass = function getPersistentClass(){
  return Lorg_rhq_core_domain_resource_Agent_2_classLit;
}
;
_.fetchAffinityGroup = false;
_.fetchServer = false;
_.filterAddress = null;
_.filterAffinityGroupId = null;
_.filterAgenttoken = null;
_.filterName = null;
_.filterPort = null;
_.filterServerId = null;
_.sortCtime = null;
_.sortName = null;
function serialize_189(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchAffinityGroup);
  $writeBoolean(streamWriter, instance.fetchServer);
  $writeString(streamWriter, instance.filterAddress);
  $writeObject(streamWriter, instance.filterAffinityGroupId);
  $writeString(streamWriter, instance.filterAgenttoken);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterPort);
  $writeObject(streamWriter, instance.filterServerId);
  $writeObject(streamWriter, instance.sortCtime);
  $writeObject(streamWriter, instance.sortName);
  serialize_200(streamWriter, instance);
}

function $addFilterEndTime_0(this$static, filterEndTime){
  this$static.filterEndTime = filterEndTime;
}

function $addFilterEntityContext(this$static, filterEntityContext){
  filterEntityContext.type_0 == ($clinit_EntityContext$Type() , Resource)?$addFilterResourceIds(this$static, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(filterEntityContext.resourceId)])):filterEntityContext.type_0 == ResourceGroup && $addFilterResourceGroupIds_0(this$static, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(filterEntityContext.groupId)]));
}

function $addFilterResourceGroupIds_0(this$static, filterResourceGroupIds){
  this$static.filterResourceGroupIds = getListIgnoringNulls(filterResourceGroupIds);
}

function $addFilterResourceIds(this$static, filterResourceIds){
  this$static.filterResourceIds = getListIgnoringNulls(filterResourceIds);
}

function $addFilterStartTime_0(this$static, filterStartTime){
  this$static.filterStartTime = filterStartTime;
}

function AlertCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('triggeredOperationName', 'triggeredOperation like ?');
  this.filterOverrides.put('startTime', 'ctime >= ?');
  this.filterOverrides.put('endTime', 'ctime <= ?');
  this.filterOverrides.put('name', 'alertDefinition.name like ?');
  this.filterOverrides.put('description', 'alertDefinition.description like ?');
  this.filterOverrides.put('priorities', 'alertDefinition.priority IN ( ? )');
  this.filterOverrides.put('resourceTypeId', 'alertDefinition.resource.resourceType.id = ?');
  this.filterOverrides.put('resourceTypeName', 'alertDefinition.resource.resourceType.name like ?');
  this.filterOverrides.put('resourceIds', 'alertDefinition.resource.id IN ( ? )');
  this.filterOverrides.put('resourceGroupIds', 'alertDefinition.resource.id IN ( SELECT res.id     FROM ResourceGroup rg     JOIN rg.explicitResources res    WHERE rg.id = ? )');
  this.filterOverrides.put('alertDefinitionIds', 'alertDefinition.id IN ( ? )');
  this.filterOverrides.put('groupAlertDefinitionIds', 'alertDefinition.groupAlertDefinition.id IN ( ? )');
  this.sortOverrides.put('name', 'alertDefinition.name');
  this.sortOverrides.put('priority', 'alertDefinition.priority');
  this.sortOverrides.put('resourceId', 'alertDefinition.resource.id');
  this.sortOverrides.put('resourceName', 'alertDefinition.resource.name');
  this.fetchConditionLogs = true;
}

defineSeed(1069, 1062, makeCastMap([Q$Serializable, Q$AlertCriteria, Q$Criteria]), AlertCriteria_0);
_.getPersistentClass = function getPersistentClass_0(){
  return Lorg_rhq_core_domain_alert_Alert_2_classLit;
}
;
_.fetchAlertDefinition = false;
_.fetchConditionLogs = false;
_.fetchNotificationLogs = false;
_.fetchRecoveryAlertDefinition = false;
_.filterAcknowledgingSubject = null;
_.filterAlertDefinitionIds = null;
_.filterDescription = null;
_.filterEndTime = null;
_.filterGroupAlertDefinitionIds = null;
_.filterName = null;
_.filterPriorities = null;
_.filterResourceGroupIds = null;
_.filterResourceIds = null;
_.filterResourceTypeId = null;
_.filterResourceTypeName = null;
_.filterStartTime = null;
_.filterTriggeredOperationName = null;
_.sortCtime = null;
_.sortName = null;
_.sortPriority = null;
_.sortResourceId = null;
_.sortResourceName = null;
function serialize_190(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchAlertDefinition);
  $writeBoolean(streamWriter, instance.fetchConditionLogs);
  $writeBoolean(streamWriter, instance.fetchNotificationLogs);
  $writeBoolean(streamWriter, instance.fetchRecoveryAlertDefinition);
  $writeString(streamWriter, instance.filterAcknowledgingSubject);
  $writeObject(streamWriter, instance.filterAlertDefinitionIds);
  $writeString(streamWriter, instance.filterDescription);
  $writeObject(streamWriter, instance.filterEndTime);
  $writeObject(streamWriter, instance.filterGroupAlertDefinitionIds);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterPriorities);
  $writeObject(streamWriter, instance.filterResourceGroupIds);
  $writeObject(streamWriter, instance.filterResourceIds);
  $writeString(streamWriter, instance.filterResourceTypeId);
  $writeString(streamWriter, instance.filterResourceTypeName);
  $writeObject(streamWriter, instance.filterStartTime);
  $writeString(streamWriter, instance.filterTriggeredOperationName);
  $writeObject(streamWriter, instance.sortCtime);
  $writeObject(streamWriter, instance.sortName);
  $writeObject(streamWriter, instance.sortPriority);
  $writeObject(streamWriter, instance.sortResourceId);
  $writeObject(streamWriter, instance.sortResourceName);
  serialize_200(streamWriter, instance);
}

function $addFilterAlertTemplateResourceTypeId(this$static, filterAlertTemplateResourceTypeId){
  this$static.filterAlertTemplateResourceTypeId = filterAlertTemplateResourceTypeId;
}

function $addFilterResourceGroupIds_1(this$static, filterResourceGroupIds){
  this$static.filterResourceGroupIds = new Arrays$ArrayList_0(filterResourceGroupIds);
}

function $addFilterResourceIds_0(this$static, filterResourceIds){
  this$static.filterResourceIds = new Arrays$ArrayList_0(filterResourceIds);
}

function AlertDefinitionCriteria_0(){
  Criteria_4.call(this);
  this.filterDeleted = ($clinit_Boolean() , $clinit_Boolean() , FALSE);
  this.filterOverrides.put('alertTemplateOnly', 'resourceType IS NOT NULL');
  this.filterOverrides.put('alertTemplateParentId', 'parentId = ?');
  this.filterOverrides.put('alertTemplateResourceTypeId', 'resourceType.id = ?');
  this.filterOverrides.put('alertTemplateResourceTypeName', 'resourceType.name like ?');
  this.filterOverrides.put('resourceIds', 'resource.id IN ( ? )');
  this.filterOverrides.put('resourceGroupIds', 'group.id IN ( ? )');
  this.filterOverrides.put('groupAlertDefinitionId', 'groupAlertDefinition.id = ?');
  this.filterOverrides.put('groupAlertDefinitionGroupId', 'groupAlertDefinition.group.id = ?');
  this.filterOverrides.put('resourceOnly', 'resource IS NOT NULL');
  this.filterOverrides.put('notificationSenderNames', 'id IN (SELECT notif.alertDefinition.id FROM AlertNotification notif WHERE notif.senderName IN ( ? ))');
  this.sortOverrides.put('resourceId', 'resource.id');
  this.sortOverrides.put('resourceName', 'resource.name');
  this.fetchGroupAlertDefinition = true;
}

defineSeed(1071, 1062, makeCastMap([Q$Serializable, Q$AlertDefinitionCriteria, Q$Criteria]), AlertDefinitionCriteria_0);
_.getPersistentClass = function getPersistentClass_1(){
  return Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit;
}
;
_.fetchAlertNotifications = false;
_.fetchAlerts = false;
_.fetchConditions = false;
_.fetchGroupAlertDefinition = false;
_.fetchResource = false;
_.fetchResourceType = false;
_.filterAlertTemplateOnly = null;
_.filterAlertTemplateParentId = null;
_.filterAlertTemplateResourceTypeId = null;
_.filterAlertTemplateResourceTypeName = null;
_.filterDescription = null;
_.filterEnabled = null;
_.filterGroupAlertDefinitionGroupId = null;
_.filterGroupAlertDefinitionId = null;
_.filterName = null;
_.filterNotificationSenderNames = null;
_.filterPriority = null;
_.filterReadOnly = null;
_.filterResourceGroupIds = null;
_.filterResourceIds = null;
_.filterResourceOnly = null;
_.sortName = null;
_.sortPriority = null;
_.sortResourceId = null;
_.sortResourceName = null;
function serialize_191(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchAlertNotifications);
  $writeBoolean(streamWriter, instance.fetchAlerts);
  $writeBoolean(streamWriter, instance.fetchConditions);
  $writeBoolean(streamWriter, instance.fetchGroupAlertDefinition);
  $writeBoolean(streamWriter, instance.fetchResource);
  $writeBoolean(streamWriter, instance.fetchResourceType);
  $writeObject(streamWriter, instance.filterAlertTemplateOnly);
  $writeObject(streamWriter, instance.filterAlertTemplateParentId);
  $writeObject(streamWriter, instance.filterAlertTemplateResourceTypeId);
  $writeString(streamWriter, instance.filterAlertTemplateResourceTypeName);
  $writeObject(streamWriter, instance.filterDeleted);
  $writeString(streamWriter, instance.filterDescription);
  $writeObject(streamWriter, instance.filterEnabled);
  $writeObject(streamWriter, instance.filterGroupAlertDefinitionGroupId);
  $writeObject(streamWriter, instance.filterGroupAlertDefinitionId);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterNotificationSenderNames);
  $writeObject(streamWriter, instance.filterPriority);
  $writeObject(streamWriter, instance.filterReadOnly);
  $writeObject(streamWriter, instance.filterResourceGroupIds);
  $writeObject(streamWriter, instance.filterResourceIds);
  $writeObject(streamWriter, instance.filterResourceOnly);
  $writeObject(streamWriter, instance.sortName);
  $writeObject(streamWriter, instance.sortPriority);
  $writeObject(streamWriter, instance.sortResourceId);
  $writeObject(streamWriter, instance.sortResourceName);
  serialize_200(streamWriter, instance);
}

function $addFilterInitialAvailability(this$static, initialAvailability){
  if (this$static.filterStartTime) {
    throw new IllegalStateException_1('This filter is mutually exclusive with filterInterval, which has already been set.');
  }
  this$static.filterStartTime = valueOf_45(initialAvailability.value_0?P0_longLit:P1_longLit);
  this$static.filterOverrides.put('startTime', 'startTime >= ?');
}

function $addFilterResourceId(this$static, filterResourceId){
  this$static.filterResourceId = filterResourceId;
}

function AvailabilityCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('resourceId', 'resource.id = ?');
}

defineSeed(1073, 1062, makeCastMap([Q$Serializable, Q$AvailabilityCriteria, Q$Criteria]), AvailabilityCriteria_0);
_.getPersistentClass = function getPersistentClass_2(){
  return Lorg_rhq_core_domain_measurement_Availability_2_classLit;
}
;
_.fetchResource = false;
_.filterAvailabilityTypes = null;
_.filterResourceId = null;
_.filterStartTime = null;
_.sortStartTime = null;
function serialize_192(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchResource);
  $writeObject(streamWriter, instance.filterAvailabilityTypes);
  $writeObject(streamWriter, instance.filterResourceId);
  $writeObject(streamWriter, instance.filterStartTime);
  $writeObject(streamWriter, instance.sortStartTime);
  serialize_200(streamWriter, instance);
}

function $addFilterTagName(this$static, filterTagName){
  if (filterTagName == null) {
    return;
  }
  !this$static.filterTag && (this$static.filterTag = new Tag_0);
  $setName_12(this$static.filterTag, filterTagName);
}

function $addFilterTagNamespace(this$static, filterTagNamespace){
  if (filterTagNamespace == null) {
    return;
  }
  !this$static.filterTag && (this$static.filterTag = new Tag_0);
  $setNamespace(this$static.filterTag, filterTagNamespace);
}

function $addFilterTagSemantic(this$static, filterTagSemantic){
  if (filterTagSemantic == null) {
    return;
  }
  !this$static.filterTag && (this$static.filterTag = new Tag_0);
  $setSemantic(this$static.filterTag, filterTagSemantic);
}

function $addFilterBundleTypeId(this$static, filterBundleTypeId){
  this$static.filterBundleTypeId = filterBundleTypeId;
}

function $addFilterName_0(this$static, filterName){
  this$static.filterName = filterName;
}

function BundleCriteria_0(){
  TaggedCriteria_0.call(this);
  this.filterOverrides.put('bundleVersionIds', 'id IN ( SELECT bv.bundle.id           FROM BundleVersion bv          WHERE bv.id IN ( ? ) )');
  this.filterOverrides.put('bundleTypeId', 'bundleType.id = ?');
  this.filterOverrides.put('bundleTypeName', 'bundleType.name like ?');
  this.filterOverrides.put('destinationIds', 'id IN ( SELECT bd.bundle.id           FROM BundleDestination bd          WHERE bd.id IN ( ? ) )');
  this.filterOverrides.put('packageTypeId', 'packageType.id = ?');
  this.filterOverrides.put('packageTypeName', 'packageType.name like ?');
}

defineSeed(1075, 1076, makeCastMap([Q$Serializable, Q$BundleCriteria, Q$Criteria]), BundleCriteria_0);
_.getPersistentClass = function getPersistentClass_3(){
  return Lorg_rhq_core_domain_bundle_Bundle_2_classLit;
}
;
_.fetchBundleVersions = false;
_.fetchDestinations = false;
_.fetchPackageType = false;
_.fetchRepo = false;
_.filterBundleTypeId = null;
_.filterBundleTypeName = null;
_.filterBundleVersionIds = null;
_.filterDescription = null;
_.filterDestinationIds = null;
_.filterName = null;
_.filterPackageTypeId = null;
_.filterPackageTypeName = null;
_.sortDescription = null;
_.sortName = null;
function serialize_193(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchBundleVersions);
  $writeBoolean(streamWriter, instance.fetchDestinations);
  $writeBoolean(streamWriter, instance.fetchPackageType);
  $writeBoolean(streamWriter, instance.fetchRepo);
  $writeObject(streamWriter, instance.filterBundleTypeId);
  $writeString(streamWriter, instance.filterBundleTypeName);
  $writeObject(streamWriter, instance.filterBundleVersionIds);
  $writeString(streamWriter, instance.filterDescription);
  $writeObject(streamWriter, instance.filterDestinationIds);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterPackageTypeId);
  $writeString(streamWriter, instance.filterPackageTypeName);
  $writeObject(streamWriter, instance.sortDescription);
  $writeObject(streamWriter, instance.sortName);
  serialize_235(streamWriter, instance);
}

function $addFilterBundleId(this$static, filterBundleId){
  this$static.filterBundleId = filterBundleId;
}

function $addFilterBundleVersionId(this$static, filterBundleVersionId){
  this$static.filterBundleVersionId = filterBundleVersionId;
}

function $addFilterDestinationId(this$static, filterDestinationId){
  this$static.filterDestinationId = filterDestinationId;
}

function $addFilterIsLive(this$static, filterIsLive){
  this$static.filterIsLive = filterIsLive;
}

function $addSortStatus_0(this$static, sortStatus){
  $add_3(this$static.orderingFieldNames, 'sort' + charToString(toUpperCase(115)) + 'ort');
  this$static.sortStatus = sortStatus;
}

function BundleDeploymentCriteria_0(){
  TaggedCriteria_0.call(this);
  this.filterOverrides.put('bundleId', 'bundleVersion.bundle.id = ?');
  this.filterOverrides.put('bundleVersionId', 'bundleVersion.id = ?');
  this.filterOverrides.put('destinationId', 'destination.id = ?');
  this.filterOverrides.put('destinationName', 'destination.name like ?');
}

defineSeed(1078, 1076, makeCastMap([Q$Serializable, Q$BundleDeploymentCriteria, Q$Criteria]), BundleDeploymentCriteria_0);
_.getPersistentClass = function getPersistentClass_4(){
  return Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit;
}
;
_.fetchBundleVersion = false;
_.fetchConfiguration = false;
_.fetchDestination = false;
_.fetchResourceDeployments = false;
_.filterBundleId = null;
_.filterBundleVersionId = null;
_.filterDescription = null;
_.filterDestinationId = null;
_.filterDestinationName = null;
_.filterIsLive = null;
_.filterName = null;
_.filterStatus = null;
_.filterSubjectName = null;
_.sortStatus = null;
function serialize_194(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchBundleVersion);
  $writeBoolean(streamWriter, instance.fetchConfiguration);
  $writeBoolean(streamWriter, instance.fetchDestination);
  $writeBoolean(streamWriter, instance.fetchResourceDeployments);
  $writeObject(streamWriter, instance.filterBundleId);
  $writeObject(streamWriter, instance.filterBundleVersionId);
  $writeString(streamWriter, instance.filterDescription);
  $writeObject(streamWriter, instance.filterDestinationId);
  $writeString(streamWriter, instance.filterDestinationName);
  $writeObject(streamWriter, instance.filterIsLive);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterStatus);
  $writeString(streamWriter, instance.filterSubjectName);
  $writeObject(streamWriter, instance.sortStatus);
  serialize_235(streamWriter, instance);
}

function $addFilterBundleId_0(this$static, filterBundleId){
  this$static.filterBundleId = filterBundleId;
}

function BundleDestinationCriteria_0(){
  TaggedCriteria_0.call(this);
  this.filterOverrides.put('bundleId', 'bundle.id = ?');
  this.filterOverrides.put('bundleVersionId', 'deployments.bundleVersion.id = ?');
  this.filterOverrides.put('status', 'deployment.status like ?');
  this.filterOverrides.put('groupId', 'group.id = ?');
}

defineSeed(1080, 1076, makeCastMap([Q$Serializable, Q$BundleDestinationCriteria, Q$Criteria]), BundleDestinationCriteria_0);
_.getPersistentClass = function getPersistentClass_5(){
  return Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit;
}
;
_.fetchBundle = false;
_.fetchDeployments = false;
_.fetchGroup = false;
_.filterBundleId = null;
_.filterBundleVersionId = null;
_.filterDeployDir = null;
_.filterDescription = null;
_.filterGroupId = null;
_.filterName = null;
_.filterStatus = null;
function serialize_195(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchBundle);
  $writeBoolean(streamWriter, instance.fetchDeployments);
  $writeBoolean(streamWriter, instance.fetchGroup);
  $writeObject(streamWriter, instance.filterBundleId);
  $writeObject(streamWriter, instance.filterBundleVersionId);
  $writeString(streamWriter, instance.filterDeployDir);
  $writeString(streamWriter, instance.filterDescription);
  $writeObject(streamWriter, instance.filterGroupId);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterStatus);
  serialize_235(streamWriter, instance);
}

function $addFilterBundleVersionId_0(this$static, filterBundleVersionId){
  this$static.filterBundleVersionId = filterBundleVersionId;
}

function BundleFileCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('bundleVersionId', 'bundleVersion.id = ?');
  this.filterOverrides.put('packageVersionId', 'packageVersion.id = ?');
}

defineSeed(1082, 1062, makeCastMap([Q$Serializable, Q$Criteria]), BundleFileCriteria_0);
_.getPersistentClass = function getPersistentClass_6(){
  return Lorg_rhq_core_domain_bundle_BundleFile_2_classLit;
}
;
_.fetchBundleVersion = false;
_.fetchPackageVersion = false;
_.filterBundleVersionId = null;
_.filterPackageVersionId = null;
function serialize_196(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchBundleVersion);
  $writeBoolean(streamWriter, instance.fetchPackageVersion);
  $writeObject(streamWriter, instance.filterBundleVersionId);
  $writeObject(streamWriter, instance.filterPackageVersionId);
  serialize_200(streamWriter, instance);
}

function $addFilterBundleDeploymentId(this$static, filterBundleDeploymentId){
  this$static.filterBundleDeploymentId = filterBundleDeploymentId;
}

function BundleResourceDeploymentCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('bundleDeploymentId', 'bundleDeployment.id = ?');
  this.filterOverrides.put('bundleDeploymentName', 'bundleDeployment.name like ?');
  this.filterOverrides.put('resourceId', 'resource.id = ?');
  this.filterOverrides.put('resourceName', 'resource.name like ?');
}

defineSeed(1084, 1062, makeCastMap([Q$Serializable, Q$Criteria]), BundleResourceDeploymentCriteria_0);
_.getPersistentClass = function getPersistentClass_7(){
  return Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit;
}
;
_.fetchBundleDeployment = false;
_.fetchHistories = false;
_.fetchResource = false;
_.filterBundleDeploymentId = null;
_.filterBundleDeploymentName = null;
_.filterResourceId = null;
_.filterResourceName = null;
_.filterStatus = null;
function serialize_197(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchBundleDeployment);
  $writeBoolean(streamWriter, instance.fetchHistories);
  $writeBoolean(streamWriter, instance.fetchResource);
  $writeObject(streamWriter, instance.filterBundleDeploymentId);
  $writeString(streamWriter, instance.filterBundleDeploymentName);
  $writeObject(streamWriter, instance.filterResourceId);
  $writeString(streamWriter, instance.filterResourceName);
  $writeObject(streamWriter, instance.filterStatus);
  serialize_200(streamWriter, instance);
}

function $addFilterBundleId_1(this$static, filterBundleId){
  this$static.filterBundleId = filterBundleId;
}

function BundleVersionCriteria_0(){
  TaggedCriteria_0.call(this);
  this.filterOverrides.put('bundleId', 'bundle.id = ?');
  this.filterOverrides.put('bundleName', 'bundle.name like ?');
}

defineSeed(1086, 1076, makeCastMap([Q$Serializable, Q$BundleVersionCriteria, Q$Criteria]), BundleVersionCriteria_0);
_.getPersistentClass = function getPersistentClass_8(){
  return Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit;
}
;
_.fetchBundle = false;
_.fetchBundleDeployments = false;
_.fetchBundleFiles = false;
_.fetchConfigurationDefinition = false;
_.filterBundleId = null;
_.filterBundleName = null;
_.filterDescription = null;
_.filterName = null;
_.filterVersion = null;
function serialize_198(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchBundle);
  $writeBoolean(streamWriter, instance.fetchBundleDeployments);
  $writeBoolean(streamWriter, instance.fetchBundleFiles);
  $writeBoolean(streamWriter, instance.fetchConfigurationDefinition);
  $writeObject(streamWriter, instance.filterBundleId);
  $writeString(streamWriter, instance.filterBundleName);
  $writeString(streamWriter, instance.filterDescription);
  $writeString(streamWriter, instance.filterName);
  $writeString(streamWriter, instance.filterVersion);
  serialize_235(streamWriter, instance);
}

function $addFilterBeginTime(this$static, filterBeginTime){
  this$static.filterBeginTime = filterBeginTime;
}

function $addFilterEndTime_1(this$static, filterEndTime){
  this$static.filterEndTime = filterEndTime;
}

function CallTimeDataCriteria_0(){
  Criteria_4.call(this);
  this.filterDataType = ($clinit_DataType() , CALLTIME);
  this.filterOverrides.put('resourceId', 'id IN ( SELECT callData.id     FROM CallTimeDataValue callData    WHERE callData.key.schedule.resource.id = ? )');
  this.filterOverrides.put('resourceGroupId', 'id IN ( SELECT callData.id     FROM CallTimeDataValue callData, Resource res     JOIN res.implicitGroups ig    WHERE callData.key.schedule.resource.id = res.id      AND ig.id = ? ) ');
  this.filterOverrides.put('autoGroupResourceTypeId', 'id IN ( SELECT callData.id     FROM CallTimeDataValue callData, Resource res    WHERE callData.key.schedule.resource.id = res.id      AND res.resourceType.id = ? )');
  this.filterOverrides.put('autoGroupParentResourceId', 'id IN ( SELECT callData.id     FROM CallTimeDataValue callData, Resource res    WHERE callData.key.schedule.resource.id = res.id      AND res.parentResource.id = ? )');
  this.filterOverrides.put('beginTime', 'beginTime > ?');
  this.filterOverrides.put('endTime', 'endTime < ?');
  this.filterOverrides.put('destination', 'key.callDestination like ?');
  this.filterOverrides.put('dataType', 'key.schedule.definition.dataType = ?');
  this.sortOverrides.put('minimum', 'MIN(' + $getAlias(this) + '.minimum)');
  this.sortOverrides.put('maximum', 'MAX(' + $getAlias(this) + '.maximum)');
  this.sortOverrides.put('average', '(SUM(' + $getAlias(this) + '.total) / SUM(' + $getAlias(this) + '.count))');
  this.sortOverrides.put('total', 'SUM(' + $getAlias(this) + '.total)');
  this.sortOverrides.put('count', 'SUM(' + $getAlias(this) + '.count)');
}

defineSeed(1088, 1062, makeCastMap([Q$Serializable, Q$CallTimeDataCriteria, Q$Criteria]), CallTimeDataCriteria_0);
_.getPersistentClass = function getPersistentClass_9(){
  return Lorg_rhq_core_domain_measurement_calltime_CallTimeDataValue_2_classLit;
}
;
_.filterAutoGroupParentResourceId = null;
_.filterAutoGroupResourceTypeId = null;
_.filterBeginTime = null;
_.filterCount = null;
_.filterDestination = null;
_.filterEndTime = null;
_.filterMaximum = null;
_.filterMinimum = null;
_.filterResourceGroupId = null;
_.filterResourceId = null;
_.filterTotal = null;
_.sortAverage = null;
_.sortCount = null;
_.sortMaximum = null;
_.sortMinimum = null;
_.sortTotal = null;
function serialize_199(streamWriter, instance){
  $writeObject(streamWriter, instance.filterAutoGroupParentResourceId);
  $writeObject(streamWriter, instance.filterAutoGroupResourceTypeId);
  $writeObject(streamWriter, instance.filterBeginTime);
  $writeObject(streamWriter, instance.filterCount);
  $writeObject(streamWriter, instance.filterDataType);
  $writeString(streamWriter, instance.filterDestination);
  $writeObject(streamWriter, instance.filterEndTime);
  $writeObject(streamWriter, instance.filterMaximum);
  $writeObject(streamWriter, instance.filterMinimum);
  $writeObject(streamWriter, instance.filterResourceGroupId);
  $writeObject(streamWriter, instance.filterResourceId);
  $writeObject(streamWriter, instance.filterTotal);
  $writeObject(streamWriter, instance.sortAverage);
  $writeObject(streamWriter, instance.sortCount);
  $writeObject(streamWriter, instance.sortMaximum);
  $writeObject(streamWriter, instance.sortMinimum);
  $writeObject(streamWriter, instance.sortTotal);
  serialize_200(streamWriter, instance);
}

function $addFilterCategory(this$static, category){
  this$static.filterCategory = category;
}

function $addFilterGroupId(this$static, filterGroupId){
  this$static.filterGroupId = filterGroupId;
}

function $addFilterResourceId_0(this$static, filterResourceId){
  this$static.filterResourceId = filterResourceId;
}

function $addSortName(this$static, sortName){
  $add_3(this$static.orderingFieldNames, 'sort' + charToString(toUpperCase(110)) + 'ame');
  this$static.sortName = sortName;
}

function DashboardCriteria_0(){
  Criteria_4.call(this);
  this.filterCategory = ($clinit_DashboardCategory() , INVENTORY);
  this.filterOverrides.put('groupId', 'group.id = ?');
  this.filterOverrides.put('ownerId', 'owner.id = ?');
  this.filterOverrides.put('resourceId', 'resource.id = ?');
}

defineSeed(1097, 1062, makeCastMap([Q$Serializable, Q$Criteria]), DashboardCriteria_0);
_.getPersistentClass = function getPersistentClass_10(){
  return Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit;
}
;
_.fetchConfiguration = false;
_.fetchOwner = false;
_.filterGroupId = null;
_.filterName = null;
_.filterOwnerId = null;
_.filterResourceId = null;
_.filterShared = null;
_.sortName = null;
function serialize_203(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchConfiguration);
  $writeBoolean(streamWriter, instance.fetchOwner);
  $writeObject(streamWriter, instance.filterCategory);
  $writeObject(streamWriter, instance.filterGroupId);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterOwnerId);
  $writeObject(streamWriter, instance.filterResourceId);
  $writeObject(streamWriter, instance.filterShared);
  $writeObject(streamWriter, instance.sortName);
  serialize_200(streamWriter, instance);
}

function $addFilterResourceIds_1(this$static, filterResourceIds){
  this$static.filterResourceIds = getListIgnoringNulls(filterResourceIds);
}

function $addFilterTemplateId(this$static, filterTemplateId){
  this$static.filterTemplateId = filterTemplateId;
}

function $fetchConfiguration(this$static, fetchConfiguration){
  this$static.fetchConfiguration = fetchConfiguration;
}

function $fetchResource(this$static, fetchResource){
  this$static.fetchResource = fetchResource;
}

function $fetchTemplate(this$static, fetchTemplate){
  this$static.fetchTemplate = fetchTemplate;
}

function DriftDefinitionCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('resourceIds', 'resource.id IN ( ? )');
  this.filterOverrides.put('templateId', 'template.id = ?');
}

defineSeed(1099, 1062, makeCastMap([Q$Serializable, Q$Criteria, Q$DriftDefinitionCriteria]), DriftDefinitionCriteria_0);
_.getPersistentClass = function getPersistentClass_11(){
  return Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit;
}
;
_.fetchConfiguration = null;
_.fetchResource = null;
_.fetchTemplate = null;
_.filterName = null;
_.filterResourceIds = null;
_.filterTemplateId = null;
_.sortName = null;
function serialize_204(streamWriter, instance){
  $writeObject(streamWriter, instance.fetchConfiguration);
  $writeObject(streamWriter, instance.fetchResource);
  $writeObject(streamWriter, instance.fetchTemplate);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterResourceIds);
  $writeObject(streamWriter, instance.filterTemplateId);
  $writeObject(streamWriter, instance.sortName);
  serialize_200(streamWriter, instance);
}

function $addFilterResourceTypeId(this$static, filterResourceTypeId){
  this$static.filterResourceTypeId = filterResourceTypeId;
}

function DriftDefinitionTemplateCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('resourceTypeId', 'resourceType.id = ?');
}

defineSeed(1101, 1062, makeCastMap([Q$Serializable, Q$Criteria, Q$DriftDefinitionTemplateCriteria]), DriftDefinitionTemplateCriteria_0);
_.getPersistentClass = function getPersistentClass_12(){
  return Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit;
}
;
_.fetchDriftDefinitions = false;
_.fetchResourceType = false;
_.filterName = null;
_.filterResourceTypeId = null;
function serialize_205(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchDriftDefinitions);
  $writeBoolean(streamWriter, instance.fetchResourceType);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterResourceTypeId);
  serialize_200(streamWriter, instance);
}

function $addFilterAutoGroupParentResourceId(this$static, filterAutoGroupParentResourceId){
  this$static.filterAutoGroupParentResourceId = filterAutoGroupParentResourceId;
}

function $addFilterAutoGroupResourceTypeId(this$static, filterAutoGroupResourceTypeId){
  this$static.filterAutoGroupResourceTypeId = filterAutoGroupResourceTypeId;
}

function $addFilterDetail(this$static, filterDetail){
  this$static.filterDetail = filterDetail;
}

function $addFilterEndTime_2(this$static, filterEndTime){
  this$static.filterEndTime = filterEndTime;
}

function $addFilterEntityContext_0(this$static, filterEntityContext){
  if (filterEntityContext.type_0 == ($clinit_EntityContext$Type() , Resource)) {
    $addFilterResourceId_1(this$static, valueOf_44(filterEntityContext.resourceId));
  }
   else if (filterEntityContext.type_0 == ResourceGroup) {
    $addFilterResourceGroupId(this$static, valueOf_44(filterEntityContext.groupId));
  }
   else if (filterEntityContext.type_0 == AutoGroup) {
    $addFilterAutoGroupParentResourceId(this$static, valueOf_44(filterEntityContext.parentResourceId));
    $addFilterAutoGroupResourceTypeId(this$static, valueOf_44(filterEntityContext.resourceTypeId));
  }
}

function $addFilterResourceGroupId(this$static, filterResourceGroupId){
  this$static.filterResourceGroupId = filterResourceGroupId;
}

function $addFilterResourceId_1(this$static, filterResourceId){
  this$static.filterResourceId = filterResourceId;
}

function $addFilterSourceName(this$static, filterSourceName){
  this$static.filterSourceName = filterSourceName;
}

function $addFilterStartTime_1(this$static, filterStartTime){
  this$static.filterStartTime = filterStartTime;
}

function EventCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('sourceName', 'source.location like ?');
  this.filterOverrides.put('sourceId', 'source.id = ?');
  this.filterOverrides.put('startTime', 'timestamp >= ?');
  this.filterOverrides.put('endTime', 'timestamp <= ?');
  this.filterOverrides.put('resourceId', 'source.resourceId = ?');
  this.filterOverrides.put('resourceGroupId', 'source.resourceId IN ( SELECT res.id     FROM Resource res     JOIN res.implicitGroups ig    WHERE ig.id = ? )');
  this.filterOverrides.put('autoGroupResourceTypeId', 'source.resourceId IN ( SELECT res.id     FROM Resource res     JOIN res.resourceType type    WHERE type.id = ? )');
  this.filterOverrides.put('autoGroupParentResourceId', 'source.resourceId IN ( SELECT res.id     FROM Resource res     JOIN res.parentResource parent    WHERE parent.id = ? )');
  this.filterOverrides.put('severities', 'severity IN ( ? )');
}

defineSeed(1103, 1062, makeCastMap([Q$Serializable, Q$Criteria, Q$EventCriteria]), EventCriteria_0);
_.getPersistentClass = function getPersistentClass_13(){
  return Lorg_rhq_core_domain_event_Event_2_classLit;
}
;
_.fetchSource = false;
_.filterAutoGroupParentResourceId = null;
_.filterAutoGroupResourceTypeId = null;
_.filterDetail = null;
_.filterEndTime = null;
_.filterResourceGroupId = null;
_.filterResourceId = null;
_.filterSeverities = null;
_.filterSourceId = null;
_.filterSourceName = null;
_.filterStartTime = null;
_.sortSeverity = null;
_.sortTimestamp = null;
function serialize_206(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchSource);
  $writeObject(streamWriter, instance.filterAutoGroupParentResourceId);
  $writeObject(streamWriter, instance.filterAutoGroupResourceTypeId);
  $writeString(streamWriter, instance.filterDetail);
  $writeObject(streamWriter, instance.filterEndTime);
  $writeObject(streamWriter, instance.filterResourceGroupId);
  $writeObject(streamWriter, instance.filterResourceId);
  $writeObject(streamWriter, instance.filterSeverities);
  $writeObject(streamWriter, instance.filterSourceId);
  $writeString(streamWriter, instance.filterSourceName);
  $writeObject(streamWriter, instance.filterStartTime);
  $writeObject(streamWriter, instance.sortSeverity);
  $writeObject(streamWriter, instance.sortTimestamp);
  serialize_200(streamWriter, instance);
}

function $addFilterDriftDefinitionId(this$static, filterDriftDefId){
  this$static.filterDriftDefId = filterDriftDefId;
}

function $addSortVersion(this$static, sortVersion){
  this$static.sortVersion = sortVersion;
}

function GenericDriftChangeSetCriteria_0(){
}

defineSeed(1105, 1, makeCastMap([Q$Serializable, Q$GenericDriftChangeSetCriteria]), GenericDriftChangeSetCriteria_0);
_.getPageControlOverrides = function getPageControlOverrides_0(){
  return this.pageControl;
}
;
_.setPageControl = function setPageControl_0(pageControl){
  this.pageControl = pageControl;
}
;
_.fetchDrifts = false;
_.filterCategory = null;
_.filterCreatedAfter = null;
_.filterCreatedBefore = null;
_.filterDriftCategories = null;
_.filterDriftDefId = null;
_.filterDriftDirectory = null;
_.filterDriftPath = null;
_.filterEndVersion = null;
_.filterId = null;
_.filterResourceId = null;
_.filterStartVersion = null;
_.filterVersion = null;
_.pageControl = null;
_.sortId = null;
_.sortVersion = null;
_.strict = false;
function serialize_207(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchDrifts);
  $writeObject(streamWriter, instance.filterCategory);
  $writeObject(streamWriter, instance.filterCreatedAfter);
  $writeObject(streamWriter, instance.filterCreatedBefore);
  $writeObject(streamWriter, instance.filterDriftCategories);
  $writeObject(streamWriter, instance.filterDriftDefId);
  $writeString(streamWriter, instance.filterDriftDirectory);
  $writeString(streamWriter, instance.filterDriftPath);
  $writeString(streamWriter, instance.filterEndVersion);
  $writeString(streamWriter, instance.filterId);
  $writeObject(streamWriter, instance.filterResourceId);
  $writeString(streamWriter, instance.filterStartVersion);
  $writeString(streamWriter, instance.filterVersion);
  $writeObject(streamWriter, instance.pageControl);
  $writeObject(streamWriter, instance.sortId);
  $writeObject(streamWriter, instance.sortVersion);
  $writeBoolean(streamWriter, instance.strict);
}

function $addFilterChangeSetId(this$static, filterChangeSetId){
  this$static.filterChangeSetId = filterChangeSetId;
}

function $addFilterChangeSetStartVersion(this$static, filterChangeSetStartVersion){
  this$static.filterChangeSetStartVersion = filterChangeSetStartVersion;
}

function $addFilterDriftHandlingModes(this$static, filterDriftHandlingModes){
  this$static.filterDriftHandlingModes = getListIgnoringNulls(filterDriftHandlingModes);
}

function $addFilterEndTime_3(this$static, filterEndTime){
  this$static.filterEndTime = filterEndTime;
}

function $addFilterResourceIds_2(this$static, filterResourceIds){
  this$static.filterResourceIds = getListIgnoringNulls(filterResourceIds);
}

function $addFilterStartTime_2(this$static, filterStartTime){
  this$static.filterStartTime = filterStartTime;
}

function GenericDriftCriteria_0(){
  this.filterCategories = new ArrayList_0;
  this.filterDriftHandlingModes = new ArrayList_0;
  this.filterResourceIds = new ArrayList_0;
}

defineSeed(1107, 1, makeCastMap([Q$Serializable, Q$GenericDriftCriteria]), GenericDriftCriteria_0);
_.getPageControlOverrides = function getPageControlOverrides_1(){
  return this.pageControl;
}
;
_.setPageControl = function setPageControl_1(pageControl){
  this.pageControl = pageControl;
}
;
_.fetchChangeSet = false;
_.filterChangeSetEndVersion = null;
_.filterChangeSetId = null;
_.filterChangeSetStartVersion = null;
_.filterDirectory = null;
_.filterDriftDefinitionId = null;
_.filterEndTime = null;
_.filterId = null;
_.filterPath = null;
_.filterStartTime = null;
_.pageControl = null;
_.sortCtime = null;
_.sortId = null;
_.strict = false;
function serialize_208(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchChangeSet);
  $writeObject(streamWriter, instance.filterCategories);
  $writeObject(streamWriter, instance.filterChangeSetEndVersion);
  $writeString(streamWriter, instance.filterChangeSetId);
  $writeObject(streamWriter, instance.filterChangeSetStartVersion);
  $writeString(streamWriter, instance.filterDirectory);
  $writeObject(streamWriter, instance.filterDriftDefinitionId);
  $writeObject(streamWriter, instance.filterDriftHandlingModes);
  $writeObject(streamWriter, instance.filterEndTime);
  $writeString(streamWriter, instance.filterId);
  $writeString(streamWriter, instance.filterPath);
  $writeObject(streamWriter, instance.filterResourceIds);
  $writeObject(streamWriter, instance.filterStartTime);
  $writeObject(streamWriter, instance.pageControl);
  $writeObject(streamWriter, instance.sortCtime);
  $writeObject(streamWriter, instance.sortId);
  $writeBoolean(streamWriter, instance.strict);
}

function $addFilterResourceGroupIds_2(this$static, filterResourceGroupIds){
  this$static.filterResourceGroupIds = new Arrays$ArrayList_0(filterResourceGroupIds);
}

function GroupBundleDeploymentCriteria_0(){
  BundleDeploymentCriteria_0.call(this);
  this.filterOverrides.put('resourceGroupIds', 'destination.group.id IN ( SELECT rg.id     FROM ResourceGroup rg     JOIN rg.bundleDestinations bds    WHERE rg.id = ? )');
}

defineSeed(1109, 1078, makeCastMap([Q$Serializable, Q$BundleDeploymentCriteria, Q$Criteria]), GroupBundleDeploymentCriteria_0);
_.filterResourceGroupIds = null;
function serialize_209(streamWriter, instance){
  $writeObject(streamWriter, instance.filterResourceGroupIds);
  serialize_194(streamWriter, instance);
}

function $addFilterEndTime_4(this$static, filterEndTime){
  this$static.filterEndTime = filterEndTime;
}

function $addFilterStartTime_3(this$static, filterStartTime){
  this$static.filterStartTime = filterStartTime;
}

function OperationHistoryCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('operationDefinitionId', 'operationDefinition.id = ?');
  this.filterOverrides.put('operationName', 'operationDefinition.name like ?');
  this.filterOverrides.put('startTime', 'startedTime >= ?');
  this.filterOverrides.put('endTime', 'modifiedTime <= ?');
  this.filterOverrides.put('resourceIds', 'id IN  ( SELECT roh.id      FROM ResourceOperationHistory roh     WHERE roh.resource.id IN ( ? ) ) ');
  this.filterOverrides.put('statuses', 'status IN ( ? )');
  this.sortOverrides.put('startTime', 'startedTime');
  this.sortOverrides.put('endTime', 'modifiedTime');
  this.sortOverrides.put('operationName', 'operationDefinition.name');
}

defineSeed(1112, 1062, makeCastMap([Q$Serializable, Q$Criteria]));
_.getPersistentClass = function getPersistentClass_14(){
  return Lorg_rhq_core_domain_operation_OperationHistory_2_classLit;
}
;
_.fetchOperationDefinition = false;
_.fetchParameters = false;
_.filterEndTime = null;
_.filterErrorMessage = null;
_.filterJobGroup = null;
_.filterJobName = null;
_.filterOperationDefinitionId = null;
_.filterOperationName = null;
_.filterStartTime = null;
_.filterStatus = null;
_.filterStatuses = null;
_.sortEndTime = null;
_.sortOperationName = null;
_.sortStartTime = null;
_.sortStatus = null;
function $addFilterResourceGroupIds_3(this$static, filterResourceGroupIds){
  this$static.filterResourceGroupIds = filterResourceGroupIds;
}

function GroupOperationHistoryCriteria_0(){
  OperationHistoryCriteria_0.call(this);
  this.filterOverrides.put('resourceGroupIds', 'group.id IN ( ? )');
}

defineSeed(1111, 1112, makeCastMap([Q$Serializable, Q$Criteria, Q$GroupOperationHistoryCriteria]), GroupOperationHistoryCriteria_0);
_.getPersistentClass = function getPersistentClass_15(){
  return Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit;
}
;
_.filterResourceGroupIds = null;
function serialize_210(streamWriter, instance){
  $writeObject(streamWriter, instance.filterResourceGroupIds);
  serialize_217(streamWriter, instance);
}

function GroupPluginConfigurationUpdateCriteria_0(){
  AbstractGroupConfigurationUpdateCriteria_0.call(this);
}

defineSeed(1114, 1064, makeCastMap([Q$Serializable, Q$Criteria, Q$GroupPluginConfigurationUpdateCriteria]), GroupPluginConfigurationUpdateCriteria_0);
_.getPersistentClass = function getPersistentClass_16(){
  return Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit;
}
;
function serialize_211(streamWriter, instance){
  serialize_188(streamWriter, instance);
}

function GroupResourceConfigurationUpdateCriteria_0(){
  AbstractGroupConfigurationUpdateCriteria_0.call(this);
}

defineSeed(1116, 1064, makeCastMap([Q$Serializable, Q$Criteria, Q$GroupResourceConfigurationUpdateCriteria]), GroupResourceConfigurationUpdateCriteria_0);
_.getPersistentClass = function getPersistentClass_17(){
  return Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit;
}
;
function serialize_212(streamWriter, instance){
  serialize_188(streamWriter, instance);
}

function $addFilterResourceGroupIds_4(this$static, filterResourceGroupIds){
  this$static.filterResourceGroupIds = new Arrays$ArrayList_0(filterResourceGroupIds);
}

function $addFilterResourceId_2(this$static, filterResourceId){
  this$static.filterResourceId = filterResourceId;
}

function $addSortStatus_1(this$static, sortStatus){
  $add_3(this$static.orderingFieldNames, 'sort' + charToString(toUpperCase(115)) + 'ort');
  this$static.sortStatus = sortStatus;
}

function InstalledPackageHistoryCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('installationTimeMinimum', 'installationDate >= ?');
  this.filterOverrides.put('installationTimeMaximum', 'installationDate <= ?');
  this.filterOverrides.put('packageVersionId', 'packageVersion.id = ? ');
  this.filterOverrides.put('resourceId', 'resource.id = ? ');
  this.filterOverrides.put('groupId', 'resource.explicitGroups.id = ? ');
  this.filterOverrides.put('resourceGroupIds', 'resource.id IN ( SELECT res.id     FROM ResourceGroup rg     JOIN rg.explicitResources res    WHERE rg.id = ? )');
  this.filterOverrides.put('userId', 'user.id = ? ');
}

defineSeed(1118, 1062, makeCastMap([Q$Serializable, Q$Criteria]), InstalledPackageHistoryCriteria_0);
_.getPersistentClass = function getPersistentClass_18(){
  return Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit;
}
;
_.fetchPackageVersion = false;
_.fetchResource = false;
_.fetchUser = false;
_.filterInstallationTimeMaximum = null;
_.filterInstallationTimeMinimum = null;
_.filterPackageVersionId = null;
_.filterResourceGroupIds = null;
_.filterResourceId = null;
_.filterUserId = null;
_.sortInstallationDate = null;
_.sortStatus = null;
function serialize_213(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchPackageVersion);
  $writeBoolean(streamWriter, instance.fetchResource);
  $writeBoolean(streamWriter, instance.fetchUser);
  $writeObject(streamWriter, instance.filterInstallationTimeMaximum);
  $writeObject(streamWriter, instance.filterInstallationTimeMinimum);
  $writeObject(streamWriter, instance.filterPackageVersionId);
  $writeObject(streamWriter, instance.filterResourceGroupIds);
  $writeObject(streamWriter, instance.filterResourceId);
  $writeObject(streamWriter, instance.filterUserId);
  $writeObject(streamWriter, instance.sortInstallationDate);
  $writeObject(streamWriter, instance.sortStatus);
  serialize_200(streamWriter, instance);
}

function $addFilterGroupId_0(this$static, filterGroupId){
  if (this$static.filterResourceId) {
    throw new IllegalArgumentException_1('This criteria cannot be filtered by both a Resource id and a group id.');
  }
  this$static.filterGroupId = filterGroupId;
}

function $addFilterResourceId_3(this$static, filterResourceId){
  if (this$static.filterGroupId) {
    throw new IllegalArgumentException_1('This criteria cannot be filtered by both a Resource id and a group id.');
  }
  this$static.filterResourceId = filterResourceId;
}

function MeasurementDataTraitCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('scheduleId', 'id.scheduleId = ?');
  this.filterOverrides.put('resourceId', 'schedule.resource.id = ?');
  this.filterOverrides.put('groupId', 'schedule.resource.id IN ( SELECT res.id     FROM Resource res     JOIN res.explicitGroups grp    WHERE grp.id = ? )');
  this.filterOverrides.put('definitionId', 'schedule.definition.id = ?');
  this.filterOverrides.put('maxTimestamp', 'id.timestamp = ( SELECT MAX(mdt.id.timestamp)     FROM MeasurementDataTrait mdt    WHERE mdt.id.scheduleId = ' + $getAlias(this) + '.id.scheduleId )      AND 1 = ?');
  this.sortOverrides.put('timestamp', 'id.timestamp');
  this.sortOverrides.put('displayName', 'schedule.definition.displayName');
  this.sortOverrides.put('resourceName', 'schedule.resource.name');
}

defineSeed(1120, 1062, makeCastMap([Q$Serializable, Q$Criteria, Q$MeasurementDataTraitCriteria]), MeasurementDataTraitCriteria_0);
_.getPersistentClass = function getPersistentClass_19(){
  return Lorg_rhq_core_domain_measurement_MeasurementDataTrait_2_classLit;
}
;
_.fetchSchedule = false;
_.filterDefinitionId = null;
_.filterGroupId = null;
_.filterMaxTimestamp = null;
_.filterResourceId = null;
_.filterScheduleId = null;
_.sortDisplayName = null;
_.sortResourceName = null;
_.sortTimestamp = null;
function serialize_214(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchSchedule);
  $writeObject(streamWriter, instance.filterDefinitionId);
  $writeObject(streamWriter, instance.filterGroupId);
  $writeObject(streamWriter, instance.filterMaxTimestamp);
  $writeObject(streamWriter, instance.filterResourceId);
  $writeObject(streamWriter, instance.filterScheduleId);
  $writeObject(streamWriter, instance.sortDisplayName);
  $writeObject(streamWriter, instance.sortResourceName);
  $writeObject(streamWriter, instance.sortTimestamp);
  serialize_200(streamWriter, instance);
}

function MeasurementDefinitionCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('resourceTypeName', 'resourceType.name like ?');
  this.filterOverrides.put('resourceTypeId', 'resourceType.id = ?');
  this.sortOverrides.put('resourceTypeName', 'resourceType.name');
}

defineSeed(1122, 1062, makeCastMap([Q$Serializable, Q$Criteria]), MeasurementDefinitionCriteria_0);
_.getPersistentClass = function getPersistentClass_20(){
  return Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit;
}
;
_.fetchResourceType = false;
_.filterCategory = null;
_.filterDataType = null;
_.filterDefaultInterval = null;
_.filterDefaultOn = null;
_.filterDescription = null;
_.filterDisplayName = null;
_.filterDisplayType = null;
_.filterName = null;
_.filterNumericType = null;
_.filterResourceTypeId = null;
_.filterResourceTypeName = null;
_.filterUnits = null;
_.sortCategory = null;
_.sortDataType = null;
_.sortDefaultInterval = null;
_.sortDefaultOn = null;
_.sortDisplayName = null;
_.sortDisplayType = null;
_.sortName = null;
_.sortNumericType = null;
_.sortResourceTypeName = null;
_.sortUnits = null;
function serialize_215(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchResourceType);
  $writeObject(streamWriter, instance.filterCategory);
  $writeObject(streamWriter, instance.filterDataType);
  $writeObject(streamWriter, instance.filterDefaultInterval);
  $writeObject(streamWriter, instance.filterDefaultOn);
  $writeString(streamWriter, instance.filterDescription);
  $writeString(streamWriter, instance.filterDisplayName);
  $writeObject(streamWriter, instance.filterDisplayType);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterNumericType);
  $writeObject(streamWriter, instance.filterResourceTypeId);
  $writeString(streamWriter, instance.filterResourceTypeName);
  $writeObject(streamWriter, instance.filterUnits);
  $writeObject(streamWriter, instance.sortCategory);
  $writeObject(streamWriter, instance.sortDataType);
  $writeObject(streamWriter, instance.sortDefaultInterval);
  $writeObject(streamWriter, instance.sortDefaultOn);
  $writeObject(streamWriter, instance.sortDisplayName);
  $writeObject(streamWriter, instance.sortDisplayType);
  $writeObject(streamWriter, instance.sortName);
  $writeObject(streamWriter, instance.sortNumericType);
  $writeObject(streamWriter, instance.sortResourceTypeName);
  $writeObject(streamWriter, instance.sortUnits);
  serialize_200(streamWriter, instance);
}

function $addFilterResourceGroupId_0(this$static, filterResourceGroupId){
  this$static.filterResourceGroupId = filterResourceGroupId;
}

function $addFilterResourceId_4(this$static, filterResourceId){
  this$static.filterResourceId = filterResourceId;
}

function MeasurementScheduleCriteria_0(){
  var defaults;
  Criteria_4.call(this);
  this.filterOverrides.put('definitionIds', 'definition.id IN ( ? )');
  this.filterOverrides.put('resourceId', 'resource.id IN ( ? )');
  this.filterOverrides.put('resourceGroupId', 'resource.id IN ( SELECT res.id     FROM Resource res     JOIN res.explicitGroups eg    WHERE eg.id = ? )');
  this.filterOverrides.put('resourceInventoryStatuses', 'resource.inventoryStatus IN ( ? )');
  this.filterOverrides.put('autoGroupResourceTypeId', 'resource.id IN ( SELECT res.id     FROM Resource res     JOIN res.resourceType type    WHERE type.id = ? )');
  this.filterOverrides.put('autoGroupParentResourceId', 'resource.id IN ( SELECT res.id     FROM Resource res     JOIN res.parentResource parent    WHERE parent.id = ? )');
  this.filterOverrides.put('resourceTypeId', 'resource.type.id = ?');
  this.sortOverrides.put('name', 'definition.name');
  this.sortOverrides.put('displayName', 'definition.displayName');
  this.sortOverrides.put('dataType', 'definition.dataType');
  defaults = new ArrayList_1(1);
  $add_3(defaults, ($clinit_InventoryStatus() , COMMITTED));
  this.filterResourceInventoryStatuses = defaults;
}

defineSeed(1124, 1062, makeCastMap([Q$Serializable, Q$Criteria]), MeasurementScheduleCriteria_0);
_.getPersistentClass = function getPersistentClass_21(){
  return Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit;
}
;
_.fetchBaseline = false;
_.fetchDefinition = false;
_.fetchResource = false;
_.filterAutoGroupParentResourceId = null;
_.filterAutoGroupResourceTypeId = null;
_.filterDefinitionIds = null;
_.filterEnabled = null;
_.filterResourceGroupId = null;
_.filterResourceId = null;
_.filterResourceInventoryStatuses = null;
_.filterResourceTypeId = null;
_.sortDataType = null;
_.sortDisplayName = null;
_.sortName = null;
function serialize_216(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchBaseline);
  $writeBoolean(streamWriter, instance.fetchDefinition);
  $writeBoolean(streamWriter, instance.fetchResource);
  $writeObject(streamWriter, instance.filterAutoGroupParentResourceId);
  $writeObject(streamWriter, instance.filterAutoGroupResourceTypeId);
  $writeObject(streamWriter, instance.filterDefinitionIds);
  $writeObject(streamWriter, instance.filterEnabled);
  $writeObject(streamWriter, instance.filterResourceGroupId);
  $writeObject(streamWriter, instance.filterResourceId);
  $writeObject(streamWriter, instance.filterResourceInventoryStatuses);
  $writeObject(streamWriter, instance.filterResourceTypeId);
  $writeObject(streamWriter, instance.sortDataType);
  $writeObject(streamWriter, instance.sortDisplayName);
  $writeObject(streamWriter, instance.sortName);
  serialize_200(streamWriter, instance);
}

function serialize_217(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchOperationDefinition);
  $writeBoolean(streamWriter, instance.fetchParameters);
  $writeObject(streamWriter, instance.filterEndTime);
  $writeString(streamWriter, instance.filterErrorMessage);
  $writeString(streamWriter, instance.filterJobGroup);
  $writeString(streamWriter, instance.filterJobName);
  $writeObject(streamWriter, instance.filterOperationDefinitionId);
  $writeString(streamWriter, instance.filterOperationName);
  $writeObject(streamWriter, instance.filterStartTime);
  $writeObject(streamWriter, instance.filterStatus);
  $writeObject(streamWriter, instance.filterStatuses);
  $writeObject(streamWriter, instance.sortEndTime);
  $writeObject(streamWriter, instance.sortOperationName);
  $writeObject(streamWriter, instance.sortStartTime);
  $writeObject(streamWriter, instance.sortStatus);
  serialize_200(streamWriter, instance);
}

function $addFilterPackageTypeId(this$static, packageTypeId){
  this$static.filterPackageTypeId = packageTypeId;
}

function $addFilterRepoId(this$static, repoId){
  this$static.filterRepoId = repoId;
}

function PackageCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('packageTypeId', 'packageType.id = ? ');
  this.filterOverrides.put('repoId', 'id IN (SELECT rpv.packageVersion.generalPackage.id FROM RepoPackageVersion rpv WHERE rpv.repo.id = ?)');
}

defineSeed(1127, 1062, makeCastMap([Q$Serializable, Q$Criteria]), PackageCriteria_0);
_.getPersistentClass = function getPersistentClass_22(){
  return Lorg_rhq_core_domain_content_Package_2_classLit;
}
;
_.fetchVersions = false;
_.filterClassification = null;
_.filterName = null;
_.filterPackageTypeId = null;
_.filterRepoId = null;
_.sortName = null;
function serialize_218(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchVersions);
  $writeString(streamWriter, instance.filterClassification);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterPackageTypeId);
  $writeObject(streamWriter, instance.filterRepoId);
  $writeObject(streamWriter, instance.sortName);
  serialize_200(streamWriter, instance);
}

function serialize_219(streamWriter, instance){
  $writeBoolean(streamWriter, instance.nullField);
  $writeBoolean(streamWriter, instance.nullField);
  $writeBoolean(streamWriter, instance.nullField);
  $writeBoolean(streamWriter, instance.nullField);
  $writeBoolean(streamWriter, instance.nullField);
  $writeBoolean(streamWriter, instance.nullField);
  $writeBoolean(streamWriter, instance.nullField);
  $writeString(streamWriter, instance.nullField);
  $writeString(streamWriter, instance.nullField);
  $writeObject(streamWriter, instance.nullField);
  $writeObject(streamWriter, instance.nullField);
  $writeString(streamWriter, instance.nullField);
  $writeString(streamWriter, instance.nullField);
  $writeObject(streamWriter, instance.nullField);
  $writeObject(streamWriter, instance.nullField);
  $writeObject(streamWriter, instance.nullField);
  $writeObject(streamWriter, instance.nullField);
  $writeString(streamWriter, instance.nullField);
  $writeObject(streamWriter, instance.nullField);
  serialize_200(streamWriter, instance);
}

function $addFilterEventDetail(this$static, eventDetail){
  this$static.filterEventDetail = eventDetail;
}

function PartitionEventCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('eventType', 'eventType IN ( ? )');
  this.filterOverrides.put('executionStatus', 'executionStatus IN ( ? )');
}

defineSeed(1130, 1062, makeCastMap([Q$Serializable, Q$Criteria, Q$PartitionEventCriteria]), PartitionEventCriteria_0);
_.getPersistentClass = function getPersistentClass_23(){
  return Lorg_rhq_core_domain_cloud_PartitionEvent_2_classLit;
}
;
_.filterEventDetail = null;
_.filterEventType = null;
_.filterExecutionStatus = null;
_.sortCtime = null;
function serialize_220(streamWriter, instance){
  $writeString(streamWriter, instance.filterEventDetail);
  $writeObject(streamWriter, instance.filterEventType);
  $writeObject(streamWriter, instance.filterExecutionStatus);
  $writeObject(streamWriter, instance.sortCtime);
  serialize_200(streamWriter, instance);
}

function $addFilterGroupConfigurationUpdateId(this$static, filterGroupConfigurationUpdateId){
  this$static.filterGroupConfigurationUpdateId = filterGroupConfigurationUpdateId;
}

function PluginConfigurationUpdateCriteria_0(){
  AbstractResourceConfigurationUpdateCriteria_0.call(this);
  this.filterOverrides.put('groupConfigurationUpdateId', 'groupConfigurationUpdate.id = ?');
  this.filterOverrides.put('resourceTypeId', 'resource.resourceType.id = ?');
  this.filterOverrides.put('resourceTypeName', 'resource.resourceType.name like ?');
  this.filterOverrides.put('resourceIds', 'resource.id IN ( ? )');
  this.filterOverrides.put('resourceGroupIds', 'resource.id IN ( SELECT res.id     FROM ResourceGroup rg     JOIN rg.explicitResources res    WHERE rg.id = ? )');
  this.sortOverrides.put('name', 'resource.name');
  this.sortOverrides.put('resourceId', 'resource.id');
}

defineSeed(1132, 1066, makeCastMap([Q$Serializable, Q$Criteria, Q$PluginConfigurationUpdateCriteria]), PluginConfigurationUpdateCriteria_0);
_.getPersistentClass = function getPersistentClass_24(){
  return Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit;
}
;
_.fetchGroupConfigurationUpdate = false;
_.fetchResource = false;
_.filterGroupConfigurationUpdateId = null;
_.filterResourceGroupIds = null;
_.filterResourceIds = null;
_.filterResourceTypeId = null;
_.filterResourceTypeName = null;
_.sortName = null;
_.sortResourceId = null;
function serialize_221(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchGroupConfigurationUpdate);
  $writeBoolean(streamWriter, instance.fetchResource);
  $writeObject(streamWriter, instance.filterGroupConfigurationUpdateId);
  $writeObject(streamWriter, instance.filterResourceGroupIds);
  $writeObject(streamWriter, instance.filterResourceIds);
  $writeObject(streamWriter, instance.filterResourceTypeId);
  $writeString(streamWriter, instance.filterResourceTypeName);
  $writeObject(streamWriter, instance.sortName);
  $writeObject(streamWriter, instance.sortResourceId);
  serialize_187(streamWriter, instance);
}

function RepoCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('resourceIds', 'resourceRepos.resource.id IN ( ? )');
  this.filterOverrides.put('contentSourceIds', 'id IN ( SELECT innerRepo           FROM Repo innerRepo           JOIN innerRepo.repoContentSources rcs          WHERE rcs.contentSource.id IN ( ? ))');
  this.filterOverrides.put('ownerId', 'owner.id = ?');
}

defineSeed(1134, 1062, makeCastMap([Q$Serializable, Q$Criteria, Q$RepoCriteria]), RepoCriteria_0);
_.getPersistentClass = function getPersistentClass_25(){
  return Lorg_rhq_core_domain_content_Repo_2_classLit;
}
;
_.fetchRepoContentSources = false;
_.fetchRepoPackageVersions = false;
_.fetchRepoRepoGroups = false;
_.fetchRepoRepoRelationships = false;
_.fetchResourceRepos = false;
_.filterCandidate = null;
_.filterContentSourceIds = null;
_.filterDescription = null;
_.filterIsPrivate = null;
_.filterName = null;
_.filterOwnerId = null;
_.filterResourceIds = null;
_.sortName = null;
function serialize_222(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchRepoContentSources);
  $writeBoolean(streamWriter, instance.fetchRepoPackageVersions);
  $writeBoolean(streamWriter, instance.fetchRepoRepoGroups);
  $writeBoolean(streamWriter, instance.fetchRepoRepoRelationships);
  $writeBoolean(streamWriter, instance.fetchResourceRepos);
  $writeObject(streamWriter, instance.filterCandidate);
  $writeObject(streamWriter, instance.filterContentSourceIds);
  $writeString(streamWriter, instance.filterDescription);
  $writeObject(streamWriter, instance.filterIsPrivate);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterOwnerId);
  $writeObject(streamWriter, instance.filterResourceIds);
  $writeObject(streamWriter, instance.sortName);
  serialize_200(streamWriter, instance);
}

function $addFilterResourceIds_3(this$static, filterResourceGroupIds){
  this$static.filterResourceIds = new Arrays$ArrayList_0(filterResourceGroupIds);
}

function ResourceBundleDeploymentCriteria_0(){
  BundleDeploymentCriteria_0.call(this);
  this.filterOverrides.put('resourceIds', 'id IN ( SELECT ibd.id     FROM BundleDeployment ibd     JOIN ibd.resourceDeployments resourceDeployment    WHERE resourceDeployment.resource.id IN ( ? ) )');
}

defineSeed(1136, 1078, makeCastMap([Q$Serializable, Q$BundleDeploymentCriteria, Q$Criteria]), ResourceBundleDeploymentCriteria_0);
_.filterResourceIds = null;
function serialize_223(streamWriter, instance){
  $writeObject(streamWriter, instance.filterResourceIds);
  serialize_194(streamWriter, instance);
}

function $addFilterGroupConfigurationUpdateId_0(this$static, filterGroupConfigurationUpdateId){
  this$static.filterGroupConfigurationUpdateId = filterGroupConfigurationUpdateId;
}

function $addFilterResourceIds_4(this$static, filterResourceIds){
  this$static.filterResourceIds = new Arrays$ArrayList_0(filterResourceIds);
}

function ResourceConfigurationUpdateCriteria_0(){
  AbstractResourceConfigurationUpdateCriteria_0.call(this);
  $addRequiredPermissions(this, initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , CONFIGURE_READ)]));
  this.filterOverrides.put('groupConfigurationUpdateId', 'groupConfigurationUpdate.id = ?');
  this.filterOverrides.put('resourceTypeId', 'resource.resourceType.id = ?');
  this.filterOverrides.put('resourceTypeName', 'resource.resourceType.name like ?');
  this.filterOverrides.put('resourceIds', 'resource.id IN ( ? )');
  this.filterOverrides.put('resourceGroupIds', 'resource.id IN ( SELECT res.id     FROM ResourceGroup rg     JOIN rg.explicitResources res    WHERE rg.id = ? )');
  this.sortOverrides.put('resourceName', 'resource.name');
  this.sortOverrides.put('resourceId', 'resource.id');
}

defineSeed(1138, 1066, makeCastMap([Q$Serializable, Q$Criteria, Q$ResourceConfigurationUpdateCriteria]), ResourceConfigurationUpdateCriteria_0);
_.getPersistentClass = function getPersistentClass_26(){
  return Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit;
}
;
_.fetchGroupConfigurationUpdate = false;
_.fetchResource = false;
_.filterGroupConfigurationUpdateId = null;
_.filterResourceGroupIds = null;
_.filterResourceIds = null;
_.filterResourceTypeId = null;
_.filterResourceTypeName = null;
_.sortResourceId = null;
_.sortResourceName = null;
function serialize_224(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchGroupConfigurationUpdate);
  $writeBoolean(streamWriter, instance.fetchResource);
  $writeObject(streamWriter, instance.filterGroupConfigurationUpdateId);
  $writeObject(streamWriter, instance.filterResourceGroupIds);
  $writeObject(streamWriter, instance.filterResourceIds);
  $writeObject(streamWriter, instance.filterResourceTypeId);
  $writeString(streamWriter, instance.filterResourceTypeName);
  $writeObject(streamWriter, instance.sortResourceId);
  $writeObject(streamWriter, instance.sortResourceName);
  serialize_187(streamWriter, instance);
}

function $addFilterCurrentAvailability(this$static, filterCurrentAvailability){
  this$static.filterCurrentAvailability = filterCurrentAvailability;
}

function $addFilterExplicitGroupIds(this$static, filterExplicitGroupIds){
  this$static.filterExplicitGroupIds = getListIgnoringNulls(filterExplicitGroupIds);
}

function $addFilterImplicitGroupIds(this$static, filterImplicitGroupIds){
  this$static.filterImplicitGroupIds = getListIgnoringNulls(filterImplicitGroupIds);
}

function $addFilterName_1(this$static, filterName){
  this$static.filterName = filterName;
}

function $addFilterParentResourceCategory(this$static, filterParentResourceCategory){
  this$static.filterParentResourceCategory = filterParentResourceCategory;
}

function $addFilterParentResourceId(this$static, filterParentResourceId){
  this$static.filterParentResourceId = filterParentResourceId;
}

function $addFilterPluginName(this$static, filterPluginName){
  this$static.filterPluginName = filterPluginName;
}

function $addFilterResourceCategories(this$static, filterResourceCategories){
  this$static.filterResourceCategories = getListIgnoringNulls(filterResourceCategories);
}

function $addFilterResourceTypeId_0(this$static, filterResourceTypeId){
  this$static.filterResourceTypeId = filterResourceTypeId;
}

function $addFilterVersion(this$static, filterVersion){
  this$static.filterVersion = filterVersion;
}

function $addSortName_0(this$static, sortName){
  $add_3(this$static.orderingFieldNames, 'sort' + charToString(toUpperCase(110)) + 'ame');
  this$static.sortName = sortName;
}

function $addFilterAutoGroupParentResourceId_0(this$static, filterAutoGroupParentResourceId){
  this$static.filterAutoGroupParentResourceId = filterAutoGroupParentResourceId;
}

function $addFilterDownMemberCount(this$static, filterDownMemberCount){
  this$static.filterDownMemberCount = filterDownMemberCount;
}

function $addFilterExplicitResourceIds(this$static, filterExplicitResourceIds){
  this$static.filterExplicitResourceIds = getListIgnoringNulls(filterExplicitResourceIds);
}

function $addFilterGroupCategory(this$static, filterGroupCategory){
  this$static.filterGroupCategory = filterGroupCategory;
}

function $addFilterGroupDefinitionId(this$static, filterGroupDefinitionId){
  this$static.filterGroupDefinitionId = filterGroupDefinitionId;
}

function $addFilterName_2(this$static, filterName){
  this$static.filterName = filterName;
}

function $addFilterPrivate(this$static, filterPrivate){
  this$static.filterPrivate = filterPrivate;
}

function $addFilterResourceTypeId_1(this$static, filterResourceTypeId){
  this$static.filterResourceTypeId = filterResourceTypeId;
}

function $addFilterVisible(this$static, filterVisible){
  if (!filterVisible) {
    throw new IllegalArgumentException_1('A single fetch may be for visible or invisible groups, but not both.');
  }
  this$static.filterVisible = filterVisible;
}

function ResourceGroupDefinitionCriteria_0(){
  Criteria_4.call(this);
}

defineSeed(1144, 1062, makeCastMap([Q$Serializable, Q$Criteria, Q$ResourceGroupDefinitionCriteria]), ResourceGroupDefinitionCriteria_0);
_.getPersistentClass = function getPersistentClass_29(){
  return Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit;
}
;
_.fetchManagedResourceGroups = false;
_.filterDescription = null;
_.filterExpression = null;
_.filterName = null;
_.filterRecursive = null;
_.sortDescription = null;
_.sortExpression = null;
_.sortName = null;
_.sortRecursive = null;
function $addFilterGroupOperationHistoryId(this$static, groupOperationHistoryId){
  this$static.filterGroupOperationHistoryId = groupOperationHistoryId;
}

function $addFilterResourceIds_5(this$static, filterResourceIds){
  this$static.filterResourceIds = new Arrays$ArrayList_0(filterResourceIds);
}

function ResourceOperationHistoryCriteria_0(){
  OperationHistoryCriteria_0.call(this);
  this.filterOverrides.put('resourceIds', 'resource.id IN ( ? )');
  this.filterOverrides.put('groupOperationHistoryId', 'groupOperationHistory.id = ?');
  this.sortOverrides.put('resourceName', 'resource.id');
  this.sortOverrides.put('resourceName', 'resource.name');
}

defineSeed(1146, 1112, makeCastMap([Q$Serializable, Q$Criteria, Q$ResourceOperationHistoryCriteria]), ResourceOperationHistoryCriteria_0);
_.getPersistentClass = function getPersistentClass_30(){
  return Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit;
}
;
_.fetchResults = false;
_.filterGroupOperationHistoryId = null;
_.filterResourceIds = null;
_.sortResourceId = null;
_.sortResourceName = null;
function serialize_228(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchResults);
  $writeObject(streamWriter, instance.filterGroupOperationHistoryId);
  $writeObject(streamWriter, instance.filterResourceIds);
  $writeObject(streamWriter, instance.sortResourceId);
  $writeObject(streamWriter, instance.sortResourceName);
  serialize_217(streamWriter, instance);
}

function $addFilterIgnored(this$static, ignored){
  this$static.filterIgnored = ignored;
}

function RoleCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('subjectId', 'id IN ( SELECT innerRole.id           FROM Role innerRole           JOIN innerRole.subjects innerSubject          WHERE innerSubject.id = ? )');
  this.filterOverrides.put('ldapSubjectId', 'id IN ( SELECT innerRole.id           FROM Role innerRole           JOIN innerRole.ldapSubjects innerSubject          WHERE innerSubject.id = ? )');
}

defineSeed(1150, 1062, makeCastMap([Q$Serializable, Q$Criteria, Q$RoleCriteria]), RoleCriteria_0);
_.getPersistentClass = function getPersistentClass_32(){
  return Lorg_rhq_core_domain_authz_Role_2_classLit;
}
;
_.fetchLdapGroups = false;
_.fetchPermissions = false;
_.fetchResourceGroups = false;
_.fetchRoleNotifications = false;
_.fetchSubjects = false;
_.filterDescription = null;
_.filterLdapSubjectId = null;
_.filterName = null;
_.filterSubjectId = null;
_.sortName = null;
function serialize_230(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchLdapGroups);
  $writeBoolean(streamWriter, instance.fetchPermissions);
  $writeBoolean(streamWriter, instance.fetchResourceGroups);
  $writeBoolean(streamWriter, instance.fetchRoleNotifications);
  $writeBoolean(streamWriter, instance.fetchSubjects);
  $writeString(streamWriter, instance.filterDescription);
  $writeObject(streamWriter, instance.filterLdapSubjectId);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterSubjectId);
  $writeObject(streamWriter, instance.sortName);
  serialize_200(streamWriter, instance);
}

function $addFilterAddress_0(this$static, filterAddress){
  this$static.filterAddress = filterAddress;
}

function $addFilterAffinityGroupId_0(this$static, filterAffinityGroupId){
  this$static.filterAffinityGroupId = filterAffinityGroupId;
}

function $addFilterComputePower(this$static, filterComputePower){
  this$static.filterComputePower = filterComputePower;
}

function $addFilterName_3(this$static, filterName){
  this$static.filterName = filterName;
}

function $addFilterPort_0(this$static, filterPort){
  this$static.filterPort = filterPort;
}

function $addFilterSecurePort(this$static, filterSecurePort){
  this$static.filterSecurePort = filterSecurePort;
}

function ServerCriteria_0(){
  Criteria_4.call(this);
  this.filterOverrides.put('operationMode', 'operationMode IN ( ? )');
  this.filterOverrides.put('affinityGroupId', 'affinityGroup.id = ?');
}

defineSeed(1154, 1062, makeCastMap([Q$Serializable, Q$Criteria, Q$ServerCriteria]), ServerCriteria_0);
_.getPersistentClass = function getPersistentClass_34(){
  return Lorg_rhq_core_domain_cloud_Server_2_classLit;
}
;
_.fetchAffinityGroup = false;
_.fetchAgents = false;
_.filterAddress = null;
_.filterAffinityGroupId = null;
_.filterComputePower = null;
_.filterName = null;
_.filterOperationMode = null;
_.filterPort = null;
_.filterSecurePort = null;
_.sortComputePower = null;
_.sortCtime = null;
_.sortName = null;
function serialize_232(streamWriter, instance){
  $writeBoolean(streamWriter, instance.fetchAffinityGroup);
  $writeBoolean(streamWriter, instance.fetchAgents);
  $writeString(streamWriter, instance.filterAddress);
  $writeObject(streamWriter, instance.filterAffinityGroupId);
  $writeObject(streamWriter, instance.filterComputePower);
  $writeString(streamWriter, instance.filterName);
  $writeObject(streamWriter, instance.filterOperationMode);
  $writeObject(streamWriter, instance.filterPort);
  $writeObject(streamWriter, instance.filterSecurePort);
  $writeObject(streamWriter, instance.sortComputePower);
  $writeObject(streamWriter, instance.sortCtime);
  $writeObject(streamWriter, instance.sortName);
  serialize_200(streamWriter, instance);
}

function $addFilterFsystem(this$static, filterFsystem){
  this$static.filterFsystem = filterFsystem;
}

function $addSortName_2(this$static, sortName){
  $add_3(this$static.orderingFieldNames, 'sort' + charToString(toUpperCase(110)) + 'ame');
  this$static.sortName = sortName;
}

function $addSortNamespace(this$static, sortNamespace){
  $add_3(this$static.orderingFieldNames, 'sort' + charToString(toUpperCase(110)) + 'amespace');
  this$static.sortNamespace = sortNamespace;
}

function $addSortSemantic(this$static, sortSemantic){
  $add_3(this$static.orderingFieldNames, 'sort' + charToString(toUpperCase(115)) + 'emantic');
  this$static.sortSemantic = sortSemantic;
}

function TagCriteria_0(){
  Criteria_4.call(this);
}

defineSeed(1158, 1062, makeCastMap([Q$Serializable, Q$Criteria]), TagCriteria_0);
_.getPersistentClass = function getPersistentClass_36(){
  return Lorg_rhq_core_domain_tagging_Tag_2_classLit;
}
;
_.filterName = null;
_.filterNamespace = null;
_.filterSemantic = null;
_.sortName = null;
_.sortNamespace = null;
_.sortSemantic = null;
function serialize_234(streamWriter, instance){
  $writeString(streamWriter, instance.filterName);
  $writeString(streamWriter, instance.filterNamespace);
  $writeString(streamWriter, instance.filterSemantic);
  $writeObject(streamWriter, instance.sortName);
  $writeObject(streamWriter, instance.sortNamespace);
  $writeObject(streamWriter, instance.sortSemantic);
  serialize_200(streamWriter, instance);
}

function $addPortlet(this$static, storedPortlet){
  var bestColumn, column, columnCounts, dashboardPortlet, dashboardPortlet$iterator, minPortlets;
  columnCounts = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, valueOf_44(__parseAndValidateInt($getSimpleValue(this$static.configuration, 'columns', '1'))).value_0, 1);
  fill(columnCounts, columnCounts.length);
  for (dashboardPortlet$iterator = this$static.portlets.iterator(); dashboardPortlet$iterator.hasNext();) {
    dashboardPortlet = dynamicCast(dashboardPortlet$iterator.next_0(), Q$DashboardPortlet);
    ++columnCounts[dashboardPortlet.column];
  }
  bestColumn = -1;
  minPortlets = 2147483647;
  for (column = 0; column < columnCounts.length; ++column) {
    if (columnCounts[column] < minPortlets) {
      bestColumn = column;
      minPortlets = columnCounts[column];
    }
  }
  $addPortlet_0(this$static, storedPortlet, bestColumn, minPortlets);
}

function $addPortlet_0(this$static, storedPortlet, column, index){
  storedPortlet.column = column;
  storedPortlet.index_0 = index;
  storedPortlet.dashboard = this$static;
  this$static.portlets.add(storedPortlet);
}

function $getPortlets(this$static, column){
  var columnPortlets, p, p$iterator;
  columnPortlets = new ArrayList_0;
  for (p$iterator = this$static.portlets.iterator(); p$iterator.hasNext();) {
    p = dynamicCast(p$iterator.next_0(), Q$DashboardPortlet);
    p.column == column && (setCheck(columnPortlets.array, columnPortlets.size_0++, p) , true);
  }
  sort_1(columnPortlets, new Dashboard$1_0);
  return columnPortlets;
}

function $removePortlet(this$static, storedPortlet){
  var col, i, index, next;
  if (!this$static.portlets.contains_0(storedPortlet)) {
    return false;
  }
  col = storedPortlet.column;
  index = storedPortlet.index_0;
  this$static.portlets.remove_0(storedPortlet);
  for (i = this$static.portlets.iterator(); i.hasNext();) {
    next = dynamicCast(i.next_0(), Q$DashboardPortlet);
    col == next.column && index < next.index_0 && $setIndex(next, next.index_0 - 1);
  }
  return true;
}

function $setCategory_0(this$static, category){
  this$static.category = category;
}

function $setColumnWidths(this$static, columnWidths){
  var i, sb;
  if (null == columnWidths || columnWidths.length == 0) {
    return;
  }
  sb = new StringBuilder_0;
  $append_1(sb.data_0, columnWidths[0]);
  for (i = 1; i < columnWidths.length; ++i) {
    $append_1(sb.data_0, ',');
    $append_1(sb.data_0, columnWidths[i]);
  }
  $put_4(this$static.configuration, new PropertySimple_1('widths', sb));
}

function $setColumns(this$static, columns){
  $put_4(this$static.configuration, new PropertySimple_1('columns', valueOf_44(columns)));
}

function $setName_7(this$static, name_0){
  this$static.name_0 = name_0;
}

function $compare_4(o1, o2){
  return o1.index_0 < o2.index_0?-1:o1.index_0 == o2.index_0?0:1;
}

function Dashboard$1_0(){
}

defineSeed(1162, 1, makeCastMap([Q$Comparator]), Dashboard$1_0);
_.compare = function compare_6(o1, o2){
  return $compare_4(dynamicCast(o1, Q$DashboardPortlet), dynamicCast(o2, Q$DashboardPortlet));
}
;
function $setColumn(this$static, column){
  this$static.column = column;
}

function $setConfiguration_0(this$static, configuration){
  this$static.configuration = configuration;
}

function $setHeight_3(this$static, height){
  this$static.height = height;
}

function $setIndex(this$static, index){
  this$static.index_0 = index;
}

function DashboardPortlet_1(name_0, portletKey, height){
  $$init_12(this);
  this.name_0 = name_0;
  this.portletKey = portletKey;
  this.height = height;
}

defineSeed(1166, 1, makeCastMap([Q$Serializable, Q$DashboardPortlet]), DashboardPortlet_1);
defineSeed(1170, 1, makeCastMap([Q$Serializable]));
_.dataSize = null;
function $clinit_DriftCategory(){
  $clinit_DriftCategory = nullMethod;
  FILE_ADDED = new DriftCategory_0('FILE_ADDED', 0);
  FILE_CHANGED = new DriftCategory_0('FILE_CHANGED', 1);
  FILE_REMOVED = new DriftCategory_0('FILE_REMOVED', 2);
  $VALUES_80 = initValues(_3Lorg_rhq_core_domain_drift_DriftCategory_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$DriftCategory_$1]), Q$DriftCategory, [FILE_ADDED, FILE_CHANGED, FILE_REMOVED]);
}

function DriftCategory_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_89(name_0){
  $clinit_DriftCategory();
  return valueOf(($clinit_DriftCategory$Map() , $MAP_80), name_0);
}

function values_83(){
  $clinit_DriftCategory();
  return $VALUES_80;
}

defineSeed(1172, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$DriftCategory]), DriftCategory_0);
var $VALUES_80, FILE_ADDED, FILE_CHANGED, FILE_REMOVED;
function $clinit_DriftCategory$Map(){
  $clinit_DriftCategory$Map = nullMethod;
  $MAP_80 = createValueOfMap(($clinit_DriftCategory() , $VALUES_80));
}

var $MAP_80;
function serialize_240(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function deserialize_253(streamReader, instance){
}

function instantiate_246(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_DriftCategory() , $clinit_DriftCategory() , $VALUES_80);
  return values[ordinal];
}

function serialize_241(streamWriter, instance){
  $writeInt(streamWriter, instance.ordinal);
}

function $clinit_DriftChangeSetCategory(){
  $clinit_DriftChangeSetCategory = nullMethod;
  COVERAGE = new DriftChangeSetCategory_0('COVERAGE', 0);
  DRIFT_0 = new DriftChangeSetCategory_0('DRIFT', 1);
  $VALUES_81 = initValues(_3Lorg_rhq_core_domain_drift_DriftChangeSetCategory_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DriftChangeSetCategory, [COVERAGE, DRIFT_0]);
}

function DriftChangeSetCategory_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_90(name_0){
  $clinit_DriftChangeSetCategory();
  return valueOf(($clinit_DriftChangeSetCategory$Map() , $MAP_81), name_0);
}

function values_84(){
  $clinit_DriftChangeSetCategory();
  return $VALUES_81;
}

defineSeed(1176, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$DriftChangeSetCategory]), DriftChangeSetCategory_0);
var $VALUES_81, COVERAGE, DRIFT_0;
function $clinit_DriftChangeSetCategory$Map(){
  $clinit_DriftChangeSetCategory$Map = nullMethod;
  $MAP_81 = createValueOfMap(($clinit_DriftChangeSetCategory() , $VALUES_81));
}

var $MAP_81;
function deserialize_254(streamReader, instance){
}

function instantiate_247(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_DriftChangeSetCategory() , $clinit_DriftChangeSetCategory() , $VALUES_81);
  return values[ordinal];
}

function serialize_242(streamWriter, instance){
  $writeInt(streamWriter, instance.ordinal);
}

function fromCode(code){
  $clinit_DriftComplianceStatus();
  switch (code) {
    case 0:
      return IN_COMPLIANCE;
    case 1:
      return OUT_OF_COMPLIANCE_NO_BASEDIR;
    case 2:
      return OUT_OF_COMPLIANCE_DRIFT;
    default:throw new IllegalArgumentException_1(code + ' is not a DriftComplianceStatus code');
  }
}

function DriftComposite_0(){
}

defineSeed(1182, 1, makeCastMap([Q$Serializable, Q$DriftComposite]), DriftComposite_0);
_.drift = null;
_.driftDefName = null;
_.resource = null;
function deserialize_256(streamReader, instance){
  setDrift(instance, dynamicCast($readObject(streamReader), Q$Drift));
  setDriftDefName(instance, $getString(streamReader, $readInt(streamReader)));
  setResource_8(instance, dynamicCast($readObject(streamReader), Q$Resource));
}

function instantiate_249(streamReader){
  return new DriftComposite_0;
}

function setDrift(instance, value){
  instance.drift = value;
}

function setDriftDefName(instance, value){
  instance.driftDefName = value;
}

function setResource_8(instance, value){
  instance.resource = value;
}

function $clinit_DriftConfigurationDefinition(){
  $clinit_DriftConfigurationDefinition = nullMethod;
  DEFAULT_DRIFT_HANDLING_MODE = ($clinit_DriftConfigurationDefinition$DriftHandlingMode() , normal);
  INSTANCE_0 = new ConfigurationDefinition_1('GLOBAL_DRIFT_CONFIG_DEF', 'The drift detection definition');
  INSTANCE_FOR_EXISTING_CONFIGS = new ConfigurationDefinition_1('GLOBAL_DRIFT_CONFIG_DEF', 'The drift detection definition');
  NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE = new ConfigurationDefinition_1('NEW_RESOURCE_DRIFT_DEF_BY_PINNED_TEMPLATE', 'A new resource drift definition created from a pinned template');
  EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE = new ConfigurationDefinition_1('EXISTING_RESOURCE_DRIFT_DEF_BY_PINNED_TEMPLATE', 'An existing resource drift definition created from a pinned template');
  NEW_TEMPLATE_INSTANCE = new ConfigurationDefinition_1('NEW_TEMPLATE_DRIFT_CONFIG_DEF', 'A new template drift definition');
  EXISTING_TEMPLATE_INSTANCE = new ConfigurationDefinition_1('EXISTING_TEMPLATE_DRIFT_CONFIG_DEF', 'An existing template drift definition');
  NEW_PINNED_TEMPLATE_INSTANCE = new ConfigurationDefinition_1('NEW_PINNED_TEMPLATE_DRIFT_CONFIG_DEF', 'A new pinned template drift definition');
  $setConfigurationFormat(INSTANCE_0, ($clinit_ConfigurationFormat() , STRUCTURED));
  $put_6(INSTANCE_0, createName(INSTANCE_0, false));
  $put_6(INSTANCE_0, createDescription(INSTANCE_0));
  $put_6(INSTANCE_0, createEnabled(INSTANCE_0));
  $put_6(INSTANCE_0, createDriftHandlingMode(INSTANCE_0));
  $put_6(INSTANCE_0, createInterval_0(INSTANCE_0));
  $put_6(INSTANCE_0, createBasedir(INSTANCE_0, false));
  $put_6(INSTANCE_0, createIncludes(INSTANCE_0, false));
  $put_6(INSTANCE_0, createExcludes(INSTANCE_0, false));
  $put_6(INSTANCE_0, createPinned(INSTANCE_0, false));
  $put_6(INSTANCE_0, createAttached(INSTANCE_0, false));
  $setConfigurationFormat(INSTANCE_FOR_EXISTING_CONFIGS, STRUCTURED);
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createName(INSTANCE_FOR_EXISTING_CONFIGS, true));
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createDescription(INSTANCE_FOR_EXISTING_CONFIGS));
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createEnabled(INSTANCE_FOR_EXISTING_CONFIGS));
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createDriftHandlingMode(INSTANCE_FOR_EXISTING_CONFIGS));
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createInterval_0(INSTANCE_FOR_EXISTING_CONFIGS));
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createBasedir(INSTANCE_FOR_EXISTING_CONFIGS, true));
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createIncludes(INSTANCE_FOR_EXISTING_CONFIGS, true));
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createExcludes(INSTANCE_FOR_EXISTING_CONFIGS, true));
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createExcludes(INSTANCE_FOR_EXISTING_CONFIGS, true));
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createAttached(INSTANCE_FOR_EXISTING_CONFIGS, false));
  $put_6(INSTANCE_FOR_EXISTING_CONFIGS, createPinned(INSTANCE_FOR_EXISTING_CONFIGS, false));
  $setConfigurationFormat(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, STRUCTURED);
  $put_6(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createName(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, false));
  $put_6(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createDescription(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE));
  $put_6(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createInterval_0(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE));
  $put_6(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createEnabled(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE));
  $put_6(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createDriftHandlingMode(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE));
  $put_6(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createBasedir(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $put_6(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createIncludes(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $put_6(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createExcludes(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $put_6(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createPinned(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $put_6(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createAttached(NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $setConfigurationFormat(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, STRUCTURED);
  $put_6(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createName(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $put_6(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createDescription(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE));
  $put_6(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createInterval_0(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE));
  $put_6(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createEnabled(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE));
  $put_6(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createDriftHandlingMode(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE));
  $put_6(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createBasedir(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $put_6(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createIncludes(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $put_6(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createExcludes(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $put_6(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createPinned(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $put_6(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, createAttached(EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, true));
  $setConfigurationFormat(NEW_TEMPLATE_INSTANCE, STRUCTURED);
  $put_6(NEW_TEMPLATE_INSTANCE, createName(NEW_TEMPLATE_INSTANCE, false));
  $put_6(NEW_TEMPLATE_INSTANCE, createDescription(NEW_TEMPLATE_INSTANCE));
  $put_6(NEW_TEMPLATE_INSTANCE, createInterval_0(NEW_TEMPLATE_INSTANCE));
  $put_6(NEW_TEMPLATE_INSTANCE, createEnabled(NEW_TEMPLATE_INSTANCE));
  $put_6(NEW_TEMPLATE_INSTANCE, createDriftHandlingMode(NEW_TEMPLATE_INSTANCE));
  $put_6(NEW_TEMPLATE_INSTANCE, createBasedir(NEW_TEMPLATE_INSTANCE, false));
  $put_6(NEW_TEMPLATE_INSTANCE, createIncludes(NEW_TEMPLATE_INSTANCE, false));
  $put_6(NEW_TEMPLATE_INSTANCE, createExcludes(NEW_TEMPLATE_INSTANCE, false));
  $setConfigurationFormat(EXISTING_TEMPLATE_INSTANCE, STRUCTURED);
  $put_6(EXISTING_TEMPLATE_INSTANCE, createName(EXISTING_TEMPLATE_INSTANCE, true));
  $put_6(EXISTING_TEMPLATE_INSTANCE, createDescription(EXISTING_TEMPLATE_INSTANCE));
  $put_6(EXISTING_TEMPLATE_INSTANCE, createInterval_0(EXISTING_TEMPLATE_INSTANCE));
  $put_6(EXISTING_TEMPLATE_INSTANCE, createEnabled(EXISTING_TEMPLATE_INSTANCE));
  $put_6(EXISTING_TEMPLATE_INSTANCE, createDriftHandlingMode(EXISTING_TEMPLATE_INSTANCE));
  $put_6(EXISTING_TEMPLATE_INSTANCE, createBasedir(EXISTING_TEMPLATE_INSTANCE, true));
  $put_6(EXISTING_TEMPLATE_INSTANCE, createIncludes(EXISTING_TEMPLATE_INSTANCE, true));
  $put_6(EXISTING_TEMPLATE_INSTANCE, createExcludes(EXISTING_TEMPLATE_INSTANCE, true));
  $setConfigurationFormat(NEW_PINNED_TEMPLATE_INSTANCE, STRUCTURED);
  $put_6(NEW_PINNED_TEMPLATE_INSTANCE, createName(NEW_PINNED_TEMPLATE_INSTANCE, false));
  $put_6(NEW_PINNED_TEMPLATE_INSTANCE, createDescription(NEW_PINNED_TEMPLATE_INSTANCE));
  $put_6(NEW_PINNED_TEMPLATE_INSTANCE, createInterval_0(NEW_PINNED_TEMPLATE_INSTANCE));
  $put_6(NEW_PINNED_TEMPLATE_INSTANCE, createEnabled(NEW_PINNED_TEMPLATE_INSTANCE));
  $put_6(NEW_PINNED_TEMPLATE_INSTANCE, createDriftHandlingMode(NEW_PINNED_TEMPLATE_INSTANCE));
  $put_6(NEW_PINNED_TEMPLATE_INSTANCE, createBasedir(NEW_PINNED_TEMPLATE_INSTANCE, true));
  $put_6(NEW_PINNED_TEMPLATE_INSTANCE, createIncludes(NEW_PINNED_TEMPLATE_INSTANCE, true));
  $put_6(NEW_PINNED_TEMPLATE_INSTANCE, createExcludes(NEW_PINNED_TEMPLATE_INSTANCE, true));
}

function createAttached(configDef, readOnly){
  var pd, type;
  type = ($clinit_PropertySimpleType() , BOOLEAN_2);
  pd = new PropertyDefinitionSimple_1('attached', 'A flag that indicates whether or not the definition is attached to the template from which it is created. When a template is updated, the changes will be propagated to any attached definitions. Furthermore, if you pin an existing template to a snapshot, then attached definitions will become pinned as well. Finally, if you delete a template, attached definitions will also be deleted.', true, type);
  pd.displayName = 'Attached to Template';
  pd.defaultValue = 'true';
  pd.order = 3;
  pd.readOnly = readOnly;
  pd.configurationDefinition = configDef;
  return pd;
}

function createBasedir(configDef, readOnly){
  var pd, valueContext, valueName, type, pd_0, pcEnum, rcEnum, mtEnum, fsEnum, pdEnums, type_0, pd_1, constraint;
  valueContext = (type = ($clinit_PropertySimpleType() , STRING_0) , pd_0 = new PropertyDefinitionSimple_1('valueContext', 'Identifies where the named value can be found.', true, type) , pd_0.displayName = 'Value Context' , pd_0.readOnly = readOnly , pd_0.summary = true , pd_0.order = 0 , pcEnum = new PropertyDefinitionEnumeration_1(($clinit_DriftConfigurationDefinition$BaseDirValueContext() , pluginConfiguration_1).name_0, pluginConfiguration_1.name_0) , pcEnum.orderIndex = 0 , rcEnum = new PropertyDefinitionEnumeration_1(resourceConfiguration_1.name_0, resourceConfiguration_1.name_0) , rcEnum.orderIndex = 1 , mtEnum = new PropertyDefinitionEnumeration_1(measurementTrait_0.name_0, measurementTrait_0.name_0) , mtEnum.orderIndex = 2 , fsEnum = new PropertyDefinitionEnumeration_1(fileSystem_0.name_0, fileSystem_0.name_0) , fsEnum.orderIndex = 3 , pdEnums = new ArrayList_1(4) , setCheck(pdEnums.array, pdEnums.size_0++, pcEnum) , setCheck(pdEnums.array, pdEnums.size_0++, rcEnum) , setCheck(pdEnums.array, pdEnums.size_0++, mtEnum) , setCheck(pdEnums.array, pdEnums.size_0++, fsEnum) , $setEnumeratedValues(pd_0, pdEnums) , pd_0);
  valueName = (type_0 = STRING_0 , pd_1 = new PropertyDefinitionSimple_1('valueName', 'The name of the value as found in the context.', true, type_0) , pd_1.displayName = 'Value Name' , pd_1.readOnly = readOnly , pd_1.summary = true , pd_1.order = 1 , pd_1.allowCustomEnumeratedValue = false , constraint = new RegexConstraint_0 , constraint.details = '[ \\.\\-\\(\\)\\w/\\:\\\\]+' , $addConstraints(pd_1, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [constraint])) , pd_1);
  pd = new PropertyDefinitionMap_1('basedir', 'The root directory from which snapshots will be generated during drift monitoring.', true, initValues(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PropertyDefinition, [valueContext, valueName]));
  pd.displayName = 'Base Directory';
  pd.readOnly = readOnly;
  pd.summary = true;
  pd.order = 7;
  pd.configurationDefinition = configDef;
  return pd;
}

function createDescription(configDef){
  var pd, type;
  type = ($clinit_PropertySimpleType() , STRING_0);
  pd = new PropertyDefinitionSimple_1('description', 'A description of the drift detection definition or template', false, type);
  pd.displayName = 'Drift Definition Description';
  pd.summary = true;
  pd.order = 1;
  pd.allowCustomEnumeratedValue = false;
  pd.configurationDefinition = configDef;
  return pd;
}

function createDriftHandlingMode(configDef){
  var normalEnum, pd, pdEnums, plannedEnum, type;
  type = ($clinit_PropertySimpleType() , STRING_0);
  pd = new PropertyDefinitionSimple_1('driftHandlingMode', "Specifies the way in which drift instances will be handled when reported. Normal handling implies the reported drift is unexpected and as such can trigger alerts, will be present in recent drift reports, etc.  Setting to 'Planned Changes' implies that the reported drift is happening at a time when drift is expected due to planned changes in the monitored environment, such as an application deployment, a configuration change, or something similar.  With this setting drift is only reported  for inspection, in drift snapshot views.", true, type);
  pd.displayName = 'Drift Handling Mode';
  pd.readOnly = false;
  pd.summary = true;
  pd.order = 4;
  pd.configurationDefinition = configDef;
  normalEnum = new PropertyDefinitionEnumeration_1(($clinit_DriftConfigurationDefinition$DriftHandlingMode() , normal).name_0, normal.name_0);
  normalEnum.orderIndex = 0;
  plannedEnum = new PropertyDefinitionEnumeration_1(plannedChanges.name_0, plannedChanges.name_0);
  plannedEnum.orderIndex = 1;
  pdEnums = new ArrayList_1(2);
  setCheck(pdEnums.array, pdEnums.size_0++, normalEnum);
  setCheck(pdEnums.array, pdEnums.size_0++, plannedEnum);
  $setEnumeratedValues(pd, pdEnums);
  $setDefaultValue_3(pd, DEFAULT_DRIFT_HANDLING_MODE.name_0);
  return pd;
}

function createEnabled(configDef){
  var pd, type;
  type = ($clinit_PropertySimpleType() , BOOLEAN_2);
  pd = new PropertyDefinitionSimple_1('enabled', 'Enables or disables the drift definition', true, type);
  pd.displayName = 'Enabled';
  pd.readOnly = false;
  pd.summary = true;
  pd.order = 2;
  pd.allowCustomEnumeratedValue = false;
  pd.configurationDefinition = configDef;
  pd.defaultValue = 'true';
  return pd;
}

function createExcludes(configDef, readOnly){
  var map, pd, path, type, pd_0, pattern, type_0, pd_1, pd_2;
  map = (path = (type = ($clinit_PropertySimpleType() , STRING_0) , pd_0 = new PropertyDefinitionSimple_1('path', "A file system directory path that is relative to (a sub-directory of) the base directory of the drift definition. The default is '.', the base directory itself.  Note that '/' and './' will be normalized to '.' for consistent handling.", true, type) , pd_0.displayName = 'Path' , pd_0.readOnly = readOnly , pd_0.summary = true , pd_0.order = 0 , pd_0.allowCustomEnumeratedValue = false , pd_0) , pattern = (type_0 = STRING_0 , pd_1 = new PropertyDefinitionSimple_1('pattern', 'Pathname pattern that must match for the items in the directory path to be excluded.', false, type_0) , pd_1.displayName = 'Pattern' , pd_1.readOnly = readOnly , pd_1.summary = true , pd_1.order = 1 , pd_1.allowCustomEnumeratedValue = false , pd_1) , pd_2 = new PropertyDefinitionMap_1('exclude', 'A pattern that specifies a file or directory to exclude.', true, initValues(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PropertyDefinition, [path, pattern])) , pd_2.displayName = 'Exclude' , pd_2.readOnly = readOnly , pd_2.summary = true , pd_2.order = 0 , pd_2);
  pd = new PropertyDefinitionList_1('excludes', 'A set of patterns that specify files and/or directories to exclude.', false, map);
  pd.displayName = 'Excludes';
  pd.readOnly = readOnly;
  pd.summary = true;
  pd.order = 9;
  pd.configurationDefinition = configDef;
  return pd;
}

function createIncludes(configDef, readOnly){
  var map, pd, path, type, pd_0, constraint, pattern, type_0, pd_1, constraint_0, pd_2;
  map = (path = (type = ($clinit_PropertySimpleType() , STRING_0) , pd_0 = new PropertyDefinitionSimple_1('path', "A file system directory path that is relative to (a sub-directory of) the base directory of the drift definition. The default is '.', the base directory itself.  Note that '/' and './' will be normalized to '.' for consistent handling.", false, type) , pd_0.displayName = 'Path' , pd_0.readOnly = readOnly , pd_0.summary = true , pd_0.order = 0 , pd_0.allowCustomEnumeratedValue = false , pd_0.defaultValue = '.' , constraint = new RegexConstraint_0 , constraint.details = '[ \\.\\-\\(\\)\\w/\\\\]+' , $addConstraints(pd_0, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [constraint])) , pd_0) , pattern = (type_0 = STRING_0 , pd_1 = new PropertyDefinitionSimple_1('pattern', "Pathname pattern that must match for the items in the directory path to be included. '*' matches zero or more characters, '?' matches one character. For example, '*.txt' (no quotes) will match text files in the filter's path directory.  '**/*.txt' will match text files in any subdirectory below the filter's path directory.", false, type_0) , pd_1.displayName = 'Pattern' , pd_1.readOnly = readOnly , pd_1.summary = true , pd_1.order = 1 , pd_1.allowCustomEnumeratedValue = false , constraint_0 = new RegexConstraint_0 , constraint_0.details = '[ \\.\\-\\(\\)\\w/\\\\\\?\\*]+' , $addConstraints(pd_1, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [constraint_0])) , pd_1) , pd_2 = new PropertyDefinitionMap_1('include', 'A pattern that specifies a file or directory to include.', true, initValues(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PropertyDefinition, [path, pattern])) , pd_2.displayName = 'Include' , pd_2.readOnly = readOnly , pd_2.summary = true , pd_2.order = 0 , pd_2);
  pd = new PropertyDefinitionList_1('includes', 'A set of patterns that specify files and/or directories to include.', false, map);
  pd.displayName = 'Includes';
  pd.readOnly = readOnly;
  pd.summary = true;
  pd.order = 8;
  pd.configurationDefinition = configDef;
  return pd;
}

function createInterval_0(configDef){
  var pd, type;
  type = ($clinit_PropertySimpleType() , LONG_0);
  pd = new PropertyDefinitionSimple_1('interval', 'The frequency in seconds in which drift detection should run. Defaults to 1800 seconds (i.e. 30 minutes)', false, type);
  pd.displayName = 'Interval';
  pd.readOnly = false;
  pd.summary = true;
  pd.order = 6;
  pd.allowCustomEnumeratedValue = false;
  pd.configurationDefinition = configDef;
  pd.defaultValue = '1800';
  return pd;
}

function createName(configDef, readOnly){
  var constraint, pd, type;
  type = ($clinit_PropertySimpleType() , STRING_0);
  pd = new PropertyDefinitionSimple_1('name', 'The drift detection definition name', true, type);
  pd.displayName = 'Drift Definition Name';
  pd.readOnly = readOnly;
  pd.summary = true;
  pd.order = 0;
  pd.allowCustomEnumeratedValue = false;
  pd.configurationDefinition = configDef;
  constraint = new RegexConstraint_0;
  constraint.details = '[ \\.\\-\\w]+';
  $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [constraint]));
  return pd;
}

function createPinned(configDef, readOnly){
  var pd, type;
  type = ($clinit_PropertySimpleType() , BOOLEAN_2);
  pd = new PropertyDefinitionSimple_1('pinned', 'If set, pins the snapshot that the agent uses for comparing files during drift detection. Normally, the agent compares those files being monitored for drift against the latest snapshot. If you pin a snapshot, the agent will use that pinned version to compare against files being monitored for drift', true, type);
  pd.displayName = 'Pinned';
  pd.defaultValue = 'false';
  pd.order = 5;
  pd.readOnly = readOnly;
  pd.configurationDefinition = configDef;
  return pd;
}

var DEFAULT_DRIFT_HANDLING_MODE, EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, EXISTING_TEMPLATE_INSTANCE, INSTANCE_0, INSTANCE_FOR_EXISTING_CONFIGS, NEW_PINNED_TEMPLATE_INSTANCE, NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE, NEW_TEMPLATE_INSTANCE;
function serialize_244(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function $addExclude(this$static, filter){
  var filterMap, filtersList;
  filtersList = $getList(this$static.configuration, 'excludes');
  if (!filtersList) {
    filtersList = new PropertyList_1('excludes');
    $put_4(this$static.configuration, filtersList);
  }
  filterMap = new PropertyMap_1('exclude');
  $put_5(filterMap, new PropertySimple_1('path', useForwardSlash(filter.path)));
  $put_5(filterMap, new PropertySimple_1('pattern', filter.pattern));
  $add_10(filtersList, filterMap);
}

function $addInclude(this$static, filter){
  var filterMap, filtersList;
  filtersList = $getList(this$static.configuration, 'includes');
  if (!filtersList) {
    filtersList = new PropertyList_1('includes');
    $put_4(this$static.configuration, filtersList);
  }
  filterMap = new PropertyMap_1('include');
  $put_5(filterMap, new PropertySimple_1('path', useForwardSlash(filter.path)));
  $put_5(filterMap, new PropertySimple_1('pattern', filter.pattern));
  $add_10(filtersList, filterMap);
}

function $setAttached(this$static, attached){
  this$static.attached = attached.value_0;
  $setAttachedProperty(this$static, attached.value_0);
}

function $setAttachedProperty(this$static, attached){
  $put_4(this$static.configuration, new PropertySimple_1('attached', '' + attached));
}

function $setBasedir(this$static, basedir){
  var basedirMap, valueContext, valueName;
  if (!basedir) {
    throw new NullPointerException_1('basedir is null');
  }
  if (!basedir.context) {
    throw new NullPointerException_1('valueContext is null');
  }
  if (basedir.name_0 == null) {
    throw new NullPointerException_1('valueName is null');
  }
  valueContext = basedir.context.name_0;
  valueName = basedir.name_0;
  basedirMap = new PropertyMap_1('basedir');
  $put_5(basedirMap, new PropertySimple_1('valueContext', valueContext));
  $put_5(basedirMap, new PropertySimple_1('valueName', ($clinit_StringUtils() , null != valueName?$replace_0(valueName, 92, 47):null)));
  $put_4(this$static.configuration, basedirMap);
}

function $setExcludes(this$static, excludesFilters){
  var filter, filter$iterator;
  $remove_16(this$static.configuration, 'excludes');
  if (excludesFilters) {
    for (filter$iterator = excludesFilters.iterator(); filter$iterator.hasNext();) {
      filter = dynamicCast(filter$iterator.next_0(), Q$Filter);
      $addExclude(this$static, filter);
    }
  }
}

function $setIncludes(this$static, includesFilters){
  var filter, filter$iterator;
  $remove_16(this$static.configuration, 'includes');
  if (includesFilters) {
    for (filter$iterator = includesFilters.iterator(); filter$iterator.hasNext();) {
      filter = dynamicCast(filter$iterator.next_0(), Q$Filter);
      $addInclude(this$static, filter);
    }
  }
}

function $setPinned(this$static, isPinned){
  this$static.isPinned = isPinned;
  $put_4(this$static.configuration, new PropertySimple_1('pinned', ($clinit_Boolean() , isPinned?TRUE:FALSE)));
}

function $setTemplate(this$static, template){
  this$static.template = template;
}

function DriftDefinition_1(c){
  var baseDir;
  $$init_13(this);
  this.configuration = c;
  baseDir = $getBasedir(this);
  !!baseDir && $setBasedir(this, baseDir);
  $setIncludes(this, $getFilters(this, 'includes'));
  $setExcludes(this, $getFilters(this, 'excludes'));
  this.name_0 = $getSimpleValue(this.configuration, 'name', null);
  this.description = $getSimpleValue(this.configuration, 'description', null);
  this.isEnabled = $equals_6($getSimpleValue(this.configuration, 'enabled', 'true'), 'true');
  this.interval = valueOf_45(__parseAndValidateLong($getSimpleValue(this.configuration, 'interval', '1800'))).value_0;
  this.driftHandlingMode = valueOf_93($getSimpleValue(this.configuration, 'driftHandlingMode', ($clinit_DriftConfigurationDefinition() , DEFAULT_DRIFT_HANDLING_MODE).name_0));
  this.isPinned = ($clinit_Boolean() , $equalsIgnoreCase('true', $getSimpleValue(this.configuration, 'pinned', 'false'))?TRUE:FALSE).value_0;
  this.attached = $equals_6($getSimpleValue(this.configuration, 'attached', 'true'), 'true');
}

defineSeed(1191, 1, makeCastMap([Q$Serializable, Q$DriftDefinition]), DriftDefinition_1);
function $compare_5(this$static, dc1, dc2){
  var filters1, filters2, hash1, hash2, results;
  if (this$static.compareMode != 1) {
    if (dc1.name_0 != null) {
      if (dc2.name_0 != null) {
        results = compareTo_11(dc1.name_0, dc2.name_0);
        if (results != 0) {
          return results;
        }
      }
       else {
        return 1;
      }
    }
     else if (dc2.name_0 != null) {
      return -1;
    }
    if (dc1.description != null) {
      if (dc2.description != null) {
        results = compareTo_11(dc1.description, dc2.description);
        if (results != 0) {
          return results;
        }
      }
       else {
        return 1;
      }
    }
     else if (dc2.description != null) {
      return -1;
    }
    if (neq(dc1.interval, dc2.interval)) {
      return lt(dc1.interval, dc2.interval)?-1:1;
    }
    if (dc1.driftHandlingMode != dc2.driftHandlingMode) {
      return dc1.driftHandlingMode.ordinal < dc2.driftHandlingMode.ordinal?-1:1;
    }
    if (dc1.isEnabled != dc2.isEnabled) {
      return dc1.isEnabled?1:-1;
    }
    if (dc1.attached != dc2.attached) {
      return dc1.attached?1:-1;
    }
    if (dc1.isPinned != dc2.isPinned) {
      return dc1.isPinned?1:-1;
    }
  }
  if (this$static.compareMode != 0) {
    if ($getBasedir(dc1)) {
      if (!$equals_32($getBasedir(dc1), $getBasedir(dc2))) {
        hash1 = $hashCode_20($getBasedir(dc1));
        hash2 = $getBasedir(dc2)?$hashCode_20($getBasedir(dc2)):0;
        return hash1 < hash2?-1:1;
      }
    }
     else if ($getBasedir(dc2)) {
      return -1;
    }
    filters1 = $getFilters(dc1, 'includes');
    filters2 = $getFilters(dc2, 'includes');
    results = $compareFilters(filters1, filters2);
    if (results != 0) {
      return results;
    }
    filters1 = $getFilters(dc1, 'excludes');
    filters2 = $getFilters(dc2, 'excludes');
    results = $compareFilters(filters1, filters2);
    if (results != 0) {
      return results;
    }
  }
  return 0;
}

function $compareFilters(filters1, filters2){
  if (!filters1) {
    return !filters2?0:-1;
  }
   else if (!filters2) {
    return 1;
  }
  if (filters1.size_1() != filters2.size_1()) {
    return filters1.size_1() < filters2.size_1()?-1:1;
  }
  if (!filters1.containsAll(filters2)) {
    return -1;
  }
  return 0;
}

function DriftDefinitionComparator_0(){
  this.compareMode = 1;
}

defineSeed(1193, 1, makeCastMap([Q$Comparator]), DriftDefinitionComparator_0);
_.compare = function compare_7(dc1, dc2){
  return $compare_5(this, dynamicCast(dc1, Q$DriftDefinition), dynamicCast(dc2, Q$DriftDefinition));
}
;
_.compareMode = 0;
function DriftDefinitionComposite_0(){
}

defineSeed(1194, 1, makeCastMap([Q$Serializable, Q$DriftDefinitionComposite]), DriftDefinitionComposite_0);
_.driftDefinition = null;
_.mostRecentChangeset = null;
function deserialize_258(streamReader, instance){
  setDriftDefinition(instance, dynamicCast($readObject(streamReader), Q$DriftDefinition));
  setMostRecentChangeset(instance, dynamicCast($readObject(streamReader), Q$DriftChangeSet));
}

function instantiate_251(streamReader){
  return new DriftDefinitionComposite_0;
}

function setDriftDefinition(instance, value){
  instance.driftDefinition = value;
}

function setMostRecentChangeset(instance, value){
  instance.mostRecentChangeset = value;
}

function $setTemplateDefinition(this$static, templateDefinition){
  this$static.configuration = $deepCopyWithoutProxies(templateDefinition.configuration);
  this$static.name_0 = templateDefinition.name_0;
  this$static.description = templateDefinition.description;
}

function DriftDetails_0(){
}

defineSeed(1199, 1, makeCastMap([Q$Serializable, Q$DriftDetails]), DriftDetails_0);
_.drift = null;
_.isBinary = false;
_.newFileStatus = null;
_.oldFileStatus = null;
_.previousChangeSet = null;
function deserialize_261(streamReader, instance){
  setDrift_0(instance, dynamicCast($readObject(streamReader), Q$Drift));
  setIsBinary(instance, $readBoolean(streamReader));
  setNewFileStatus(instance, dynamicCast($readObject(streamReader), Q$DriftFileStatus));
  setOldFileStatus(instance, dynamicCast($readObject(streamReader), Q$DriftFileStatus));
  setPreviousChangeSet(instance, dynamicCast($readObject(streamReader), Q$DriftChangeSet));
}

function instantiate_254(streamReader){
  return new DriftDetails_0;
}

function setDrift_0(instance, value){
  instance.drift = value;
}

function setIsBinary(instance, value){
  instance.isBinary = value;
}

function setNewFileStatus(instance, value){
  instance.newFileStatus = value;
}

function setOldFileStatus(instance, value){
  instance.oldFileStatus = value;
}

function setPreviousChangeSet(instance, value){
  instance.previousChangeSet = value;
}

function $clinit_DriftFileStatus(){
  $clinit_DriftFileStatus = nullMethod;
  EMPTY = new DriftFileStatus_0('EMPTY', 0);
  REQUESTED_0 = new DriftFileStatus_0('REQUESTED', 1);
  LOADED = new DriftFileStatus_0('LOADED', 2);
  $VALUES_85 = initValues(_3Lorg_rhq_core_domain_drift_DriftFileStatus_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DriftFileStatus, [EMPTY, REQUESTED_0, LOADED]);
}

function DriftFileStatus_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_94(name_0){
  $clinit_DriftFileStatus();
  return valueOf(($clinit_DriftFileStatus$Map() , $MAP_85), name_0);
}

function values_88(){
  $clinit_DriftFileStatus();
  return $VALUES_85;
}

defineSeed(1201, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$DriftFileStatus]), DriftFileStatus_0);
var $VALUES_85, EMPTY, LOADED, REQUESTED_0;
function $clinit_DriftFileStatus$Map(){
  $clinit_DriftFileStatus$Map = nullMethod;
  $MAP_85 = createValueOfMap(($clinit_DriftFileStatus() , $VALUES_85));
}

var $MAP_85;
function deserialize_262(streamReader, instance){
}

function instantiate_255(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_DriftFileStatus() , $clinit_DriftFileStatus() , $VALUES_85);
  return values[ordinal];
}

function serialize_248(streamWriter, instance){
  $writeInt(streamWriter, instance.ordinal);
}

function $getDriftDirectories(this$static){
  if (!this$static.directoryMap) {
    return null;
  }
  return this$static.directoryMap.values_0();
}

function $getDriftInstances(this$static){
  if (!this$static.driftMap) {
    return null;
  }
  return this$static.driftMap.values_0();
}

function DriftSnapshot_0(){
}

defineSeed(1204, 1, makeCastMap([Q$Serializable, Q$DriftSnapshot]), DriftSnapshot_0);
_.directoryMap = null;
_.driftMap = null;
_.request = null;
_.version_0 = -1;
function DriftSnapshot$DriftSnapshotDirectory_0(){
}

defineSeed(1205, 1, makeCastMap([Q$Serializable, Q$DriftSnapshot$DriftSnapshotDirectory]), DriftSnapshot$DriftSnapshotDirectory_0);
_.added = 0;
_.changed_0 = 0;
_.directoryPath = null;
_.files = 0;
_.removed = 0;
function DriftSnapshotRequest_0(){
}

function DriftSnapshotRequest_1(driftDefinitionId, version, directory, includeDriftDirectories, includeDriftInstances){
  this.driftDefinitionId = valueOf_44(driftDefinitionId);
  this.version_0 = !!version && version.value_0 >= 0?version:null;
  this.startVersion = valueOf_44(0);
  if (null != directory) {
    directory = $trim(directory);
    this.directory = $equals_6('', directory)?'./':directory;
  }
  this.includeDriftDirectories = includeDriftDirectories;
  this.includeDriftInstances = includeDriftInstances;
}

function DriftSnapshotRequest_2(templateChangesetIdString, directory, includeDriftDirectories, includeDriftInstances){
  this.templateChangeSetId = templateChangesetIdString;
  if (null != directory) {
    directory = $trim(directory);
    this.directory = $equals_6('', directory)?'./':directory;
  }
  this.includeDriftDirectories = includeDriftDirectories;
  this.includeDriftInstances = includeDriftInstances;
  this.driftDefinitionId = null;
  this.version_0 = valueOf_44(0);
  this.startVersion = valueOf_44(0);
}

defineSeed(1206, 1, makeCastMap([Q$Serializable, Q$DriftSnapshotRequest]), DriftSnapshotRequest_0, DriftSnapshotRequest_1, DriftSnapshotRequest_2);
_.toString$ = function toString_115(){
  return 'DriftSnapshotRequest [directory=' + this.directory + ', driftDefinitionId=' + this.driftDefinitionId + ', includeDriftDirectories=' + this.includeDriftDirectories + ', includeDriftInstances=' + this.includeDriftInstances + ', startVersion=' + this.startVersion + ', templateChangeSetId=' + this.templateChangeSetId + ', version=' + this.version_0 + ']';
}
;
_.directory = null;
_.driftDefinitionId = null;
_.includeDriftDirectories = false;
_.includeDriftInstances = false;
_.startVersion = null;
_.templateChangeSetId = null;
_.version_0 = null;
function deserialize_263(streamReader, instance){
  setDirectory(instance, $getString(streamReader, $readInt(streamReader)));
  setDriftDefinitionId(instance, dynamicCast($readObject(streamReader), Q$Integer));
  setIncludeDriftDirectories(instance, $readBoolean(streamReader));
  setIncludeDriftInstances(instance, $readBoolean(streamReader));
  setStartVersion(instance, dynamicCast($readObject(streamReader), Q$Integer));
  setTemplateChangeSetId(instance, $getString(streamReader, $readInt(streamReader)));
  setVersion_4(instance, dynamicCast($readObject(streamReader), Q$Integer));
}

function instantiate_256(streamReader){
  return new DriftSnapshotRequest_0;
}

function serialize_249(streamWriter, instance){
  $writeString(streamWriter, instance.directory);
  $writeObject(streamWriter, instance.driftDefinitionId);
  $writeBoolean(streamWriter, instance.includeDriftDirectories);
  $writeBoolean(streamWriter, instance.includeDriftInstances);
  $writeObject(streamWriter, instance.startVersion);
  $writeString(streamWriter, instance.templateChangeSetId);
  $writeObject(streamWriter, instance.version_0);
}

function setDirectory(instance, value){
  instance.directory = value;
}

function setDriftDefinitionId(instance, value){
  instance.driftDefinitionId = value;
}

function setIncludeDriftDirectories(instance, value){
  instance.includeDriftDirectories = value;
}

function setIncludeDriftInstances(instance, value){
  instance.includeDriftInstances = value;
}

function setStartVersion(instance, value){
  instance.startVersion = value;
}

function setTemplateChangeSetId(instance, value){
  instance.templateChangeSetId = value;
}

function setVersion_4(instance, value){
  instance.version_0 = value;
}

function deserialize_264(streamReader, instance){
  setAdded(instance, $readInt(streamReader));
  setChanged(instance, $readInt(streamReader));
  setDirectoryPath(instance, $getString(streamReader, $readInt(streamReader)));
  setFiles(instance, $readInt(streamReader));
  setRemoved(instance, $readInt(streamReader));
}

function instantiate_257(streamReader){
  return new DriftSnapshot$DriftSnapshotDirectory_0;
}

function setAdded(instance, value){
  instance.added = value;
}

function setChanged(instance, value){
  instance.changed_0 = value;
}

function setDirectoryPath(instance, value){
  instance.directoryPath = value;
}

function setFiles(instance, value){
  instance.files = value;
}

function setRemoved(instance, value){
  instance.removed = value;
}

function deserialize_265(streamReader, instance){
  setDirectoryMap(instance, dynamicCast($readObject(streamReader), Q$Map));
  setDriftMap(instance, dynamicCast($readObject(streamReader), Q$Map));
  setRequest(instance, dynamicCast($readObject(streamReader), Q$DriftSnapshotRequest));
  setVersion_5(instance, $readInt(streamReader));
}

function instantiate_258(streamReader){
  return new DriftSnapshot_0;
}

function setDirectoryMap(instance, value){
  instance.directoryMap = value;
}

function setDriftMap(instance, value){
  instance.driftMap = value;
}

function setRequest(instance, value){
  instance.request = value;
}

function setVersion_5(instance, value){
  instance.version_0 = value;
}

function FileDiffReport_0(){
}

defineSeed(1210, 1, makeCastMap([Q$Serializable, Q$FileDiffReport]), FileDiffReport_0);
_.changes = 0;
_.diff = null;
function deserialize_266(streamReader, instance){
  setChanges(instance, $readInt(streamReader));
  instance.diff = dynamicCast($readObject(streamReader), Q$List);
}

function instantiate_259(streamReader){
  return new FileDiffReport_0;
}

function setChanges(instance, value){
  instance.changes = value;
}

function JPADrift_0(){
  this.ctime = valueOf_45(N1_longLit);
}

defineSeed(1213, 1, makeCastMap([Q$Serializable, Q$Drift]), JPADrift_0);
_.getCategory = function getCategory(){
  return this.category;
}
;
_.getChangeSet = function getChangeSet(){
  return this.changeSet;
}
;
_.getCtime = function getCtime(){
  return this.ctime;
}
;
_.getId = function getId(){
  return '' + this.id;
}
;
_.getNewDriftFile = function getNewDriftFile(){
  return this.newDriftFile;
}
;
_.getOldDriftFile = function getOldDriftFile(){
  return this.oldDriftFile;
}
;
_.getPath = function getPath(){
  return this.path;
}
;
_.toString$ = function toString_117(){
  var $e0, sb;
  sb = new StringBuilder_1('JPADrift [');
  $append_12($append_12($append_12(sb, 'id=' + this.id), ', category=' + this.category), ', path=' + this.path);
  try {
    $append_12(sb, ', changeSet=' + this.changeSet);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (!instanceOf($e0, Q$Exception))
      throw $e0;
  }
  $append_1(sb.data_0, ']');
  return $toString_1(sb.data_0);
}
;
_.category = null;
_.changeSet = null;
_.directory = null;
_.id = 0;
_.newDriftFile = null;
_.oldDriftFile = null;
_.path = null;
function JPADriftChangeSet_0(){
  this.ctime = valueOf_45(N1_longLit);
  this.drifts = new LinkedHashSet_0;
}

defineSeed(1214, 1, makeCastMap([Q$Serializable, Q$DriftChangeSet, Q$JPADriftChangeSet]), JPADriftChangeSet_0);
_.getCategory_0 = function getCategory_0(){
  return this.category;
}
;
_.getCtime = function getCtime_0(){
  return this.ctime;
}
;
_.getDriftDefinitionId = function getDriftDefinitionId(){
  if (!this.driftDefinition) {
    return 0;
  }
  return this.driftDefinition.id;
}
;
_.getDriftHandlingMode = function getDriftHandlingMode(){
  return this.driftHandlingMode;
}
;
_.getId = function getId_0(){
  return '' + this.id;
}
;
_.getVersion = function getVersion(){
  return this.version_0;
}
;
_.toString$ = function toString_118(){
  return 'JPADriftChangeSet [id=' + this.id + ', resource=' + this.resource + ', version=' + this.version_0 + ']';
}
;
_.category = null;
_.driftDefinition = null;
_.driftHandlingMode = null;
_.id = 0;
_.initialDriftSet = null;
_.resource = null;
_.version_0 = 0;
function deserialize_267(streamReader, instance){
  setNative(instance, 'server-enhanced-data-1', $getString(streamReader, $readInt(streamReader)));
  setCategory_4(instance, dynamicCast($readObject(streamReader), Q$DriftChangeSetCategory));
  setCtime_14(instance, dynamicCast($readObject(streamReader), Q$Long));
  setDriftDefinition_0(instance, dynamicCast($readObject(streamReader), Q$DriftDefinition));
  setDriftHandlingMode_0(instance, dynamicCast($readObject(streamReader), Q$DriftConfigurationDefinition$DriftHandlingMode));
  setDrifts(instance, dynamicCast($readObject(streamReader), Q$Set));
  setId_62(instance, $readInt(streamReader));
  setInitialDriftSet(instance, dynamicCast($readObject(streamReader), Q$JPADriftSet));
  setResource_10(instance, dynamicCast($readObject(streamReader), Q$Resource));
  setVersion_6(instance, $readInt(streamReader));
}

function instantiate_260(streamReader){
  return new JPADriftChangeSet_0;
}

function serialize_250(streamWriter, instance){
  $writeString(streamWriter, dynamicCast(get(instance, 'server-enhanced-data-1'), Q$String));
  $writeObject(streamWriter, instance.category);
  $writeObject(streamWriter, instance.ctime);
  $writeObject(streamWriter, instance.driftDefinition);
  $writeObject(streamWriter, instance.driftHandlingMode);
  $writeObject(streamWriter, instance.drifts);
  $writeInt(streamWriter, instance.id);
  $writeObject(streamWriter, instance.initialDriftSet);
  $writeObject(streamWriter, instance.resource);
  $writeInt(streamWriter, instance.version_0);
}

function setCategory_4(instance, value){
  instance.category = value;
}

function setCtime_14(instance, value){
  instance.ctime = value;
}

function setDriftDefinition_0(instance, value){
  instance.driftDefinition = value;
}

function setDriftHandlingMode_0(instance, value){
  instance.driftHandlingMode = value;
}

function setDrifts(instance, value){
  instance.drifts = value;
}

function setId_62(instance, value){
  instance.id = value;
}

function setInitialDriftSet(instance, value){
  instance.initialDriftSet = value;
}

function setResource_10(instance, value){
  instance.resource = value;
}

function setVersion_6(instance, value){
  instance.version_0 = value;
}

function JPADriftFile_0(){
  this.ctime = valueOf_45(N1_longLit);
  this.status_0 = ($clinit_DriftFileStatus() , EMPTY);
}

defineSeed(1216, 1170, makeCastMap([Q$Serializable, Q$JPADriftFile]), JPADriftFile_0);
_.getHashId = function getHashId(){
  return this.hashId;
}
;
_.toString$ = function toString_119(){
  return 'JPADriftFile [hashId=' + this.hashId + ', status=' + this.status_0 + ']';
}
;
_.hashId = null;
function deserialize_268(streamReader, instance){
  setNative(instance, 'server-enhanced-data-2', $getString(streamReader, $readInt(streamReader)));
  setHashId(instance, $getString(streamReader, $readInt(streamReader)));
  instance.ctime = dynamicCast($readObject(streamReader), Q$Long);
  instance.dataSize = dynamicCast($readObject(streamReader), Q$Long);
  instance.status_0 = dynamicCast($readObject(streamReader), Q$DriftFileStatus);
}

function instantiate_261(streamReader){
  return new JPADriftFile_0;
}

function serialize_251(streamWriter, instance){
  $writeString(streamWriter, dynamicCast(get(instance, 'server-enhanced-data-2'), Q$String));
  $writeString(streamWriter, instance.hashId);
  $writeObject(streamWriter, instance.ctime);
  $writeObject(streamWriter, instance.dataSize);
  $writeObject(streamWriter, instance.status_0);
}

function setHashId(instance, value){
  instance.hashId = value;
}

function JPADriftSet_0(){
  this.drifts = new LinkedHashSet_0;
}

defineSeed(1218, 1, makeCastMap([Q$Serializable, Q$JPADriftSet]), JPADriftSet_0);
_.id = 0;
function deserialize_269(streamReader, instance){
  setNative(instance, 'server-enhanced-data-1', $getString(streamReader, $readInt(streamReader)));
  setDrifts_0(instance, dynamicCast($readObject(streamReader), Q$Set));
  setId_63(instance, $readInt(streamReader));
}

function instantiate_262(streamReader){
  return new JPADriftSet_0;
}

function serialize_252(streamWriter, instance){
  $writeString(streamWriter, dynamicCast(get(instance, 'server-enhanced-data-1'), Q$String));
  $writeObject(streamWriter, instance.drifts);
  $writeInt(streamWriter, instance.id);
}

function setDrifts_0(instance, value){
  instance.drifts = value;
}

function setId_63(instance, value){
  instance.id = value;
}

function deserialize_270(streamReader, instance){
  setNative(instance, 'server-enhanced-data-1', $getString(streamReader, $readInt(streamReader)));
  setCategory_5(instance, dynamicCast($readObject(streamReader), Q$DriftCategory));
  setChangeSet(instance, dynamicCast($readObject(streamReader), Q$JPADriftChangeSet));
  setCtime_15(instance, dynamicCast($readObject(streamReader), Q$Long));
  setDirectory_0(instance, $getString(streamReader, $readInt(streamReader)));
  setId_64(instance, $readInt(streamReader));
  setNewDriftFile(instance, dynamicCast($readObject(streamReader), Q$JPADriftFile));
  setOldDriftFile(instance, dynamicCast($readObject(streamReader), Q$JPADriftFile));
  setPath_0(instance, $getString(streamReader, $readInt(streamReader)));
}

function instantiate_263(streamReader){
  return new JPADrift_0;
}

function serialize_253(streamWriter, instance){
  $writeString(streamWriter, dynamicCast(get(instance, 'server-enhanced-data-1'), Q$String));
  $writeObject(streamWriter, instance.category);
  $writeObject(streamWriter, instance.changeSet);
  $writeObject(streamWriter, instance.ctime);
  $writeString(streamWriter, instance.directory);
  $writeInt(streamWriter, instance.id);
  $writeObject(streamWriter, instance.newDriftFile);
  $writeObject(streamWriter, instance.oldDriftFile);
  $writeString(streamWriter, instance.path);
}

function setCategory_5(instance, value){
  instance.category = value;
}

function setChangeSet(instance, value){
  instance.changeSet = value;
}

function setCtime_15(instance, value){
  instance.ctime = value;
}

function setDirectory_0(instance, value){
  instance.directory = value;
}

function setId_64(instance, value){
  instance.id = value;
}

function setNewDriftFile(instance, value){
  instance.newDriftFile = value;
}

function setOldDriftFile(instance, value){
  instance.oldDriftFile = value;
}

function setPath_0(instance, value){
  instance.path = value;
}

function DriftChangeSetDTO_0(){
  this.drifts = new HashSet_0;
}

defineSeed(1221, 1, makeCastMap([Q$Serializable, Q$DriftChangeSet, Q$DriftChangeSetDTO]), DriftChangeSetDTO_0);
_.getCategory_0 = function getCategory_1(){
  return this.category;
}
;
_.getCtime = function getCtime_1(){
  return this.ctime;
}
;
_.getDriftDefinitionId = function getDriftDefinitionId_0(){
  return this.driftDefId;
}
;
_.getDriftHandlingMode = function getDriftHandlingMode_0(){
  return this.driftHandlingMode;
}
;
_.getId = function getId_1(){
  return this.id;
}
;
_.getVersion = function getVersion_0(){
  return this.version_0;
}
;
_.category = null;
_.ctime = null;
_.driftDefId = 0;
_.driftHandlingMode = null;
_.id = null;
_.resourceId = 0;
_.version_0 = 0;
function deserialize_271(streamReader, instance){
  setCategory_6(instance, dynamicCast($readObject(streamReader), Q$DriftChangeSetCategory));
  setCtime_16(instance, dynamicCast($readObject(streamReader), Q$Long));
  setDriftDefId(instance, $readInt(streamReader));
  setDriftHandlingMode_1(instance, dynamicCast($readObject(streamReader), Q$DriftConfigurationDefinition$DriftHandlingMode));
  setDrifts_1(instance, dynamicCast($readObject(streamReader), Q$Set));
  setId_65(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceId(instance, $readInt(streamReader));
  setVersion_7(instance, $readInt(streamReader));
}

function instantiate_264(streamReader){
  return new DriftChangeSetDTO_0;
}

function serialize_254(streamWriter, instance){
  $writeObject(streamWriter, instance.category);
  $writeObject(streamWriter, instance.ctime);
  $writeInt(streamWriter, instance.driftDefId);
  $writeObject(streamWriter, instance.driftHandlingMode);
  $writeObject(streamWriter, instance.drifts);
  $writeString(streamWriter, instance.id);
  $writeInt(streamWriter, instance.resourceId);
  $writeInt(streamWriter, instance.version_0);
}

function setCategory_6(instance, value){
  instance.category = value;
}

function setCtime_16(instance, value){
  instance.ctime = value;
}

function setDriftDefId(instance, value){
  instance.driftDefId = value;
}

function setDriftHandlingMode_1(instance, value){
  instance.driftHandlingMode = value;
}

function setDrifts_1(instance, value){
  instance.drifts = value;
}

function setId_65(instance, value){
  instance.id = value;
}

function setResourceId(instance, value){
  instance.resourceId = value;
}

function setVersion_7(instance, value){
  instance.version_0 = value;
}

function DriftDTO_0(){
}

defineSeed(1223, 1, makeCastMap([Q$Serializable, Q$Drift]), DriftDTO_0);
_.getCategory = function getCategory_2(){
  return this.category;
}
;
_.getChangeSet = function getChangeSet_0(){
  return this.changeSet;
}
;
_.getCtime = function getCtime_2(){
  return this.ctime;
}
;
_.getId = function getId_2(){
  return this.id;
}
;
_.getNewDriftFile = function getNewDriftFile_0(){
  return this.newDriftFile;
}
;
_.getOldDriftFile = function getOldDriftFile_0(){
  return this.oldDriftFile;
}
;
_.getPath = function getPath_0(){
  return this.path;
}
;
_.category = null;
_.changeSet = null;
_.ctime = null;
_.directory = null;
_.id = null;
_.newDriftFile = null;
_.oldDriftFile = null;
_.path = null;
function deserialize_272(streamReader, instance){
  setCategory_7(instance, dynamicCast($readObject(streamReader), Q$DriftCategory));
  setChangeSet_0(instance, dynamicCast($readObject(streamReader), Q$DriftChangeSetDTO));
  setCtime_17(instance, dynamicCast($readObject(streamReader), Q$Long));
  setDirectory_1(instance, $getString(streamReader, $readInt(streamReader)));
  setId_66(instance, $getString(streamReader, $readInt(streamReader)));
  setNewDriftFile_0(instance, dynamicCast($readObject(streamReader), Q$DriftFileDTO));
  setOldDriftFile_0(instance, dynamicCast($readObject(streamReader), Q$DriftFileDTO));
  setPath_1(instance, $getString(streamReader, $readInt(streamReader)));
}

function instantiate_265(streamReader){
  return new DriftDTO_0;
}

function serialize_255(streamWriter, instance){
  $writeObject(streamWriter, instance.category);
  $writeObject(streamWriter, instance.changeSet);
  $writeObject(streamWriter, instance.ctime);
  $writeString(streamWriter, instance.directory);
  $writeString(streamWriter, instance.id);
  $writeObject(streamWriter, instance.newDriftFile);
  $writeObject(streamWriter, instance.oldDriftFile);
  $writeString(streamWriter, instance.path);
}

function setCategory_7(instance, value){
  instance.category = value;
}

function setChangeSet_0(instance, value){
  instance.changeSet = value;
}

function setCtime_17(instance, value){
  instance.ctime = value;
}

function setDirectory_1(instance, value){
  instance.directory = value;
}

function setId_66(instance, value){
  instance.id = value;
}

function setNewDriftFile_0(instance, value){
  instance.newDriftFile = value;
}

function setOldDriftFile_0(instance, value){
  instance.oldDriftFile = value;
}

function setPath_1(instance, value){
  instance.path = value;
}

function DriftFileDTO_0(){
}

defineSeed(1225, 1, makeCastMap([Q$Serializable, Q$DriftFileDTO]), DriftFileDTO_0);
_.getHashId = function getHashId_0(){
  return this.hash_0;
}
;
_.ctime = null;
_.hash_0 = null;
_.size_0 = null;
_.status_0 = null;
function deserialize_273(streamReader, instance){
  setCtime_18(instance, dynamicCast($readObject(streamReader), Q$Long));
  setHash(instance, $getString(streamReader, $readInt(streamReader)));
  setSize(instance, dynamicCast($readObject(streamReader), Q$Long));
  setStatus_5(instance, dynamicCast($readObject(streamReader), Q$DriftFileStatus));
}

function instantiate_266(streamReader){
  return new DriftFileDTO_0;
}

function serialize_256(streamWriter, instance){
  $writeObject(streamWriter, instance.ctime);
  $writeString(streamWriter, instance.hash_0);
  $writeObject(streamWriter, instance.size_0);
  $writeObject(streamWriter, instance.status_0);
}

function setCtime_18(instance, value){
  instance.ctime = value;
}

function setHash(instance, value){
  instance.hash_0 = value;
}

function setSize(instance, value){
  instance.size_0 = value;
}

function setStatus_5(instance, value){
  instance.status_0 = value;
}

function deserialize_275(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_268(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_event_EventSeverity_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$EventSeverity_$1]), Q$EventSeverity, size, 0);
}

function serialize_258(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function EventComposite_0(){
}

defineSeed(1237, 1, makeCastMap([Q$Serializable, Q$EventComposite]), EventComposite_0);
_.eventDetail = null;
_.eventId = 0;
_.resourceAncestry = null;
_.resourceId = 0;
_.resourceName = null;
_.resourceTypeId = 0;
_.severity = null;
_.sourceLocation = null;
_.timestamp = N1_longLit;
function deserialize_279(streamReader, instance){
  setEventDetail_0(instance, $getString(streamReader, $readInt(streamReader)));
  setEventId(instance, $readInt(streamReader));
  setResourceAncestry(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceId_1(instance, $readInt(streamReader));
  setResourceName(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceTypeId_0(instance, $readInt(streamReader));
  setSeverity_1(instance, dynamicCast($readObject(streamReader), Q$EventSeverity));
  setSourceLocation(instance, $getString(streamReader, $readInt(streamReader)));
  setTimestamp_1(instance, $readLong(streamReader));
}

function instantiate_272(streamReader){
  return new EventComposite_0;
}

function setEventDetail_0(instance, value){
  instance.eventDetail = value;
}

function setEventId(instance, value){
  instance.eventId = value;
}

function setResourceAncestry(instance, value){
  instance.resourceAncestry = value;
}

function setResourceId_1(instance, value){
  instance.resourceId = value;
}

function setResourceName(instance, value){
  instance.resourceName = value;
}

function setResourceTypeId_0(instance, value){
  instance.resourceTypeId = value;
}

function setSeverity_1(instance, value){
  instance.severity = value;
}

function setSourceLocation(instance, value){
  instance.sourceLocation = value;
}

function setTimestamp_1(instance, value){
  instance.timestamp = value;
}

function AgentInstallInfo_0(){
  this.steps = new ArrayList_0;
}

defineSeed(1239, 1, makeCastMap([Q$Serializable, Q$AgentInstallInfo]), AgentInstallInfo_0);
_.agentAddress = null;
_.owner = null;
_.path = null;
_.serverAddress = null;
_.version_0 = null;
function deserialize_280(streamReader, instance){
  setAgentAddress(instance, $getString(streamReader, $readInt(streamReader)));
  setOwner_1(instance, $getString(streamReader, $readInt(streamReader)));
  setPath_2(instance, $getString(streamReader, $readInt(streamReader)));
  setServerAddress(instance, $getString(streamReader, $readInt(streamReader)));
  instance.steps = dynamicCast($readObject(streamReader), Q$List);
  setVersion_8(instance, $getString(streamReader, $readInt(streamReader)));
}

function instantiate_273(streamReader){
  return new AgentInstallInfo_0;
}

function setAgentAddress(instance, value){
  instance.agentAddress = value;
}

function setOwner_1(instance, value){
  instance.owner = value;
}

function setPath_2(instance, value){
  instance.path = value;
}

function setServerAddress(instance, value){
  instance.serverAddress = value;
}

function setVersion_8(instance, value){
  instance.version_0 = value;
}

function AgentInstallStep_0(){
}

defineSeed(1241, 1, makeCastMap([Q$Serializable, Q$AgentInstallStep]), AgentInstallStep_0);
_.toString$ = function toString_124(){
  var builder;
  builder = new StringBuilder_0;
  $append_12($append_10($append_12($append_9($append_12($append_12($append_12($append_12(($append_1(builder.data_0, 'AgentInstallStep [description=') , builder), this.description), ', result='), this.result), ', resultCode='), this.resultCode), ', duration='), this.duration_0), ']');
  return $toString_1(builder.data_0);
}
;
_.command = null;
_.description = null;
_.duration_0 = P0_longLit;
_.result = null;
_.resultCode = 0;
function deserialize_281(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_274(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_install_remote_AgentInstallStep_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$AgentInstallStep, size, 0);
}

function deserialize_282(streamReader, instance){
  setCommand(instance, $getString(streamReader, $readInt(streamReader)));
  setDescription_22(instance, $getString(streamReader, $readInt(streamReader)));
  setDuration(instance, $readLong(streamReader));
  setResult_0(instance, $getString(streamReader, $readInt(streamReader)));
  setResultCode(instance, $readInt(streamReader));
}

function instantiate_275(streamReader){
  return new AgentInstallStep_0;
}

function setCommand(instance, value){
  instance.command = value;
}

function setDescription_22(instance, value){
  instance.description = value;
}

function setDuration(instance, value){
  instance.duration_0 = value;
}

function setResult_0(instance, value){
  instance.result = value;
}

function setResultCode(instance, value){
  instance.resultCode = value;
}

function RemoteAccessInfo_0(host, port, user, password){
  this.host_0 = host;
  this.port = port;
  this.user = user;
  this.password = password;
}

defineSeed(1244, 1, makeCastMap([Q$Serializable]), RemoteAccessInfo_0);
_.host_0 = null;
_.key = null;
_.password = null;
_.port = 22;
_.user = null;
function serialize_262(streamWriter, instance){
  $writeString(streamWriter, instance.host_0);
  $writeObject(streamWriter, instance.key);
  $writeString(streamWriter, instance.password);
  $writeInt(streamWriter, instance.port);
  $writeString(streamWriter, instance.user);
}

function serialize_263(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function MeasurementData_0(){
  MeasurementData_1.call(this, new MeasurementDataPK_1(fromDouble(currentTimeMillis0())));
}

function MeasurementData_1(pk){
  if (!pk) {
    throw new NullPointerException_1('pk==null');
  }
  this.id = pk;
}

defineSeed(1264, 1, makeCastMap([Q$Serializable, Q$MeasurementData]));
_.equals$ = function equals_89(o){
  var that;
  if (this === o) {
    return true;
  }
  if (o == null || !instanceOf(o, Q$MeasurementData)) {
    return false;
  }
  that = dynamicCast(o, Q$MeasurementData);
  if (!$equals_34(this.id, that.id)) {
    return false;
  }
  if (this.name_0 != null?!$equals_6(this.name_0, that.name_0):that.name_0 != null) {
    return false;
  }
  return true;
}
;
_.hashCode$ = function hashCode_89(){
  var result;
  result = $hashCode_22(this.id);
  result = 31 * result + (this.name_0 != null?getHashCode_0(this.name_0):0);
  return result;
}
;
_.toString$ = function toString_128(){
  return 'MeasurementData[name=' + this.name_0 + ', scheduleId=' + this.id.scheduleId + ', timestamp=' + toString_8(this.id.timestamp) + ']';
}
;
_.id = null;
_.name_0 = null;
_.schedule = null;
function MeasurementDataNumeric_0(){
  MeasurementData_0.call(this);
}

defineSeed(1265, 1264, makeCastMap([Q$Serializable, Q$MeasurementData]), MeasurementDataNumeric_0);
_.getValue_1 = function getValue_43(){
  return this.value_0;
}
;
_.toString$ = function toString_129(){
  return 'MeasurementDataNumeric[name=' + this.name_0 + ', value=' + this.value_0 + ', scheduleId=' + this.id.scheduleId + ', timestamp=' + toString_8(this.id.timestamp) + ']';
}
;
_.value_0 = null;
function MeasurementDataNumeric1D_0(){
  MeasurementData_0.call(this);
}

defineSeed(1266, 1264, makeCastMap([Q$Serializable, Q$MeasurementData]), MeasurementDataNumeric1D_0);
_.getValue_1 = function getValue_44(){
  return this.value_0;
}
;
_.toString$ = function toString_130(){
  return 'MeasurementDataNumeric1D[average=[' + this.value_0 + '], MeasurementData[name=' + this.name_0 + ', scheduleId=' + this.id.scheduleId + ', timestamp=' + toString_8(this.id.timestamp) + ']]';
}
;
_.max_0 = null;
_.min_0 = null;
_.value_0 = null;
function deserialize_290(streamReader, instance){
  setNative(instance, 'server-enhanced-data-2', $getString(streamReader, $readInt(streamReader)));
  setMax_0(instance, dynamicCast($readObject(streamReader), Q$Double));
  setMin_0(instance, dynamicCast($readObject(streamReader), Q$Double));
  setValue_14(instance, dynamicCast($readObject(streamReader), Q$Double));
  deserialize_297(streamReader, instance);
}

function instantiate_283(streamReader){
  return new MeasurementDataNumeric1D_0;
}

function setMax_0(instance, value){
  instance.max_0 = value;
}

function setMin_0(instance, value){
  instance.min_0 = value;
}

function setValue_14(instance, value){
  instance.value_0 = value;
}

function MeasurementDataNumeric1H_0(){
  MeasurementData_0.call(this);
}

defineSeed(1268, 1264, makeCastMap([Q$Serializable, Q$MeasurementData]), MeasurementDataNumeric1H_0);
_.getValue_1 = function getValue_45(){
  return this.value_0;
}
;
_.toString$ = function toString_131(){
  return 'MeasurementDataNumeric1H[average=[' + this.value_0 + '], MeasurementData[name=' + this.name_0 + ', scheduleId=' + this.id.scheduleId + ', timestamp=' + toString_8(this.id.timestamp) + ']]';
}
;
_.max_0 = null;
_.min_0 = null;
_.value_0 = null;
function deserialize_291(streamReader, instance){
  setNative(instance, 'server-enhanced-data-2', $getString(streamReader, $readInt(streamReader)));
  setMax_1(instance, dynamicCast($readObject(streamReader), Q$Double));
  setMin_1(instance, dynamicCast($readObject(streamReader), Q$Double));
  setValue_15(instance, dynamicCast($readObject(streamReader), Q$Double));
  deserialize_297(streamReader, instance);
}

function instantiate_284(streamReader){
  return new MeasurementDataNumeric1H_0;
}

function setMax_1(instance, value){
  instance.max_0 = value;
}

function setMin_1(instance, value){
  instance.min_0 = value;
}

function setValue_15(instance, value){
  instance.value_0 = value;
}

function MeasurementDataNumeric6H_0(){
  MeasurementData_0.call(this);
}

defineSeed(1270, 1264, makeCastMap([Q$Serializable, Q$MeasurementData]), MeasurementDataNumeric6H_0);
_.getValue_1 = function getValue_46(){
  return this.value_0;
}
;
_.toString$ = function toString_132(){
  return 'MeasurementDataNumeric6H[average=[' + this.value_0 + '], MeasurementData[name=' + this.name_0 + ', scheduleId=' + this.id.scheduleId + ', timestamp=' + toString_8(this.id.timestamp) + ']]';
}
;
_.max_0 = null;
_.min_0 = null;
_.value_0 = null;
function deserialize_292(streamReader, instance){
  setNative(instance, 'server-enhanced-data-2', $getString(streamReader, $readInt(streamReader)));
  setMax_2(instance, dynamicCast($readObject(streamReader), Q$Double));
  setMin_2(instance, dynamicCast($readObject(streamReader), Q$Double));
  setValue_16(instance, dynamicCast($readObject(streamReader), Q$Double));
  deserialize_297(streamReader, instance);
}

function instantiate_285(streamReader){
  return new MeasurementDataNumeric6H_0;
}

function setMax_2(instance, value){
  instance.max_0 = value;
}

function setMin_2(instance, value){
  instance.min_0 = value;
}

function setValue_16(instance, value){
  instance.value_0 = value;
}

function deserialize_293(streamReader, instance){
  setValue_17(instance, dynamicCast($readObject(streamReader), Q$Double));
  deserialize_297(streamReader, instance);
}

function instantiate_286(streamReader){
  return new MeasurementDataNumeric_0;
}

function setValue_17(instance, value){
  instance.value_0 = value;
}

function $equals_34(this$static, obj_0){
  var other;
  if (this$static === obj_0) {
    return true;
  }
  if (obj_0 == null) {
    return false;
  }
  if (!instanceOf(obj_0, Q$MeasurementDataPK)) {
    return false;
  }
  other = dynamicCast(obj_0, Q$MeasurementDataPK);
  if (this$static.scheduleId != other.scheduleId) {
    return false;
  }
  if (neq(this$static.timestamp, other.timestamp)) {
    return false;
  }
  return true;
}

function $hashCode_22(this$static){
  var result;
  result = 31 + this$static.scheduleId;
  result = 31 * result + toInt(xor(this$static.timestamp, shru(this$static.timestamp, 32)));
  return result;
}

function MeasurementDataPK_0(){
}

function MeasurementDataPK_1(timestamp){
  this.timestamp = timestamp;
  this.scheduleId = 0;
}

defineSeed(1273, 1, makeCastMap([Q$Serializable, Q$MeasurementDataPK]), MeasurementDataPK_0, MeasurementDataPK_1);
_.equals$ = function equals_90(obj_0){
  return $equals_34(this, obj_0);
}
;
_.hashCode$ = function hashCode_90(){
  return $hashCode_22(this);
}
;
_.toString$ = function toString_133(){
  return 'MeasurementDataPK: timestamp=[' + (new Date_2(this.timestamp)).toString$() + '], scheduleId=[' + this.scheduleId + ']';
}
;
_.scheduleId = 0;
_.timestamp = P0_longLit;
function deserialize_294(streamReader, instance){
  instance.scheduleId = $readInt(streamReader);
  instance.timestamp = $readLong(streamReader);
}

function instantiate_287(streamReader){
  return new MeasurementDataPK_0;
}

function MeasurementDataTrait_0(){
  MeasurementData_0.call(this);
}

defineSeed(1275, 1264, makeCastMap([Q$Serializable, Q$MeasurementData, Q$MeasurementDataTrait]), MeasurementDataTrait_0);
_.getValue_1 = function getValue_47(){
  return this.value_0;
}
;
_.toString$ = function toString_134(){
  return 'MeasurementDataTrait[name=' + this.name_0 + ', value="' + this.value_0 + '", scheduleId=' + this.id.scheduleId + ', timestamp=' + toString_8(this.id.timestamp) + ']';
}
;
_.value_0 = null;
function deserialize_295(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_288(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_measurement_MeasurementDataTrait_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$MeasurementDataTrait, size, 0);
}

function deserialize_296(streamReader, instance){
  setNative(instance, 'server-enhanced-data-2', $getString(streamReader, $readInt(streamReader)));
  setValue_18(instance, $getString(streamReader, $readInt(streamReader)));
  deserialize_297(streamReader, instance);
}

function instantiate_289(streamReader){
  return new MeasurementDataTrait_0;
}

function setValue_18(instance, value){
  instance.value_0 = value;
}

function deserialize_297(streamReader, instance){
  setNative(instance, 'server-enhanced-data-1', $getString(streamReader, $readInt(streamReader)));
  instance.id = dynamicCast($readObject(streamReader), Q$MeasurementDataPK);
  setName_33(instance, $getString(streamReader, $readInt(streamReader)));
  instance.schedule = dynamicCast($readObject(streamReader), Q$MeasurementSchedule);
}

function setName_33(instance, value){
  instance.name_0 = value;
}

function calculateOffset(first, second){
  $clinit_MeasurementUnits();
  if (first.family != second.family) {
    throw new MeasurementConversionException_0('Can not convert ' + first.name_0 + ' to ' + second.name_0);
  }
  return calculateOffset_0(first.scale_0, second.scale_0);
}

function getUsingDisplayUnits(displayUnits, family){
  $clinit_MeasurementUnits();
  var units, units$array, units$index, units$max;
  for (units$array = $VALUES_91 , units$index = 0 , units$max = units$array.length; units$index < units$max; ++units$index) {
    units = units$array[units$index];
    if (units.family == family && $equalsIgnoreCase(units.displayUnits, displayUnits)) {
      return units;
    }
  }
  return null;
}

function scaleDown(value, units){
  $clinit_MeasurementUnits();
  if (!units || ($clinit_MeasurementUnits$Family() , RELATIVE_0) != units.family) {
    return value;
  }
  return scaleDown_0(value, units.scale_0);
}

function scaleUp(value, units){
  $clinit_MeasurementUnits();
  if (!units || ($clinit_MeasurementUnits$Family() , RELATIVE_0) != units.family) {
    return value;
  }
  return scaleUp_0(value, units.scale_0);
}

function calculateOffset_0(first, second){
  $clinit_MeasurementUnits$Scale();
  var higher, lower, movingScale, results;
  if (first.type_0 != second.type_0) {
    return null;
  }
  if (!first.comparisonScale && !second.comparisonScale) {
    return new Double_0(1);
  }
  if (!first.comparisonScale) {
    higher = second;
    lower = first;
  }
   else if (!second.comparisonScale) {
    higher = first;
    lower = second;
  }
   else {
    if (first.comparisonScale.ordinal > second.comparisonScale.ordinal) {
      higher = first;
      lower = second;
    }
     else if (first.comparisonScale.ordinal < second.comparisonScale.ordinal) {
      higher = second;
      lower = first;
    }
     else {
      return new Double_0(1);
    }
  }
  results = 1;
  movingScale = higher;
  while (movingScale != lower && !!movingScale.comparisonScale) {
    results *= movingScale.offset;
    movingScale = movingScale.comparisonScale;
  }
  if (first == lower) {
    return new Double_0(1 / results);
  }
  return new Double_0(results);
}

function scaleDown_0(value, scale){
  $clinit_MeasurementUnits$Scale();
  if (!scale) {
    return new Double_0(0);
  }
  return new Double_0(value.value_0 / scale.offset);
}

function scaleUp_0(value, scale){
  $clinit_MeasurementUnits$Scale();
  if (!scale) {
    return new Double_0(0);
  }
  return new Double_0(value.value_0 * scale.offset);
}

function CallTimeDataComposite_0(){
}

defineSeed(1298, 1, makeCastMap([Q$Serializable, Q$CallTimeDataComposite]), CallTimeDataComposite_0);
_.toString$ = function toString_139(){
  return $substring(Lorg_rhq_core_domain_measurement_calltime_CallTimeDataComposite_2_classLit.typeName, Lorg_rhq_core_domain_measurement_calltime_CallTimeDataComposite_2_classLit.typeName.lastIndexOf('.') + 1) + '[callDestination=' + this.callDestination + ', minimum=' + this.minimum + ', maximum=' + this.maximum + ', total=' + this.total + ', count=' + this.total + ', average=' + this.average + ']';
}
;
_.average = 0;
_.callDestination = null;
_.count = P0_longLit;
_.maximum = 0;
_.minimum = 0;
_.total = 0;
function deserialize_304(streamReader, instance){
  setAverage(instance, $readDouble(streamReader));
  instance.callDestination = $getString(streamReader, $readInt(streamReader));
  setCount(instance, $readLong(streamReader));
  setMaximum_1(instance, $readDouble(streamReader));
  setMinimum_1(instance, $readDouble(streamReader));
  setTotal(instance, $readDouble(streamReader));
}

function instantiate_296(streamReader){
  return new CallTimeDataComposite_0;
}

function setAverage(instance, value){
  instance.average = value;
}

function setCount(instance, value){
  instance.count = value;
}

function setMaximum_1(instance, value){
  instance.maximum = value;
}

function setMinimum_1(instance, value){
  instance.minimum = value;
}

function setTotal(instance, value){
  instance.total = value;
}

function MeasurementDataNumericHighLowComposite_0(){
}

defineSeed(1300, 1, makeCastMap([Q$Serializable, Q$MeasurementDataNumericHighLowComposite]), MeasurementDataNumericHighLowComposite_0);
_.toString$ = function toString_140(){
  return 'MeasurementDataNumericHighLowComposite[value=' + this.value_0 + ', lowValue=' + this.lowValue + ', highValue=' + this.highValue + ']';
}
;
_.highValue = 0;
_.lowValue = 0;
_.timestamp = P0_longLit;
_.value_0 = 0;
function deserialize_305(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_297(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_measurement_composite_MeasurementDataNumericHighLowComposite_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$MeasurementDataNumericHighLowComposite, size, 0);
}

function deserialize_306(streamReader, instance){
  setHighValue(instance, $readDouble(streamReader));
  setLowValue(instance, $readDouble(streamReader));
  setTimestamp_2(instance, $readLong(streamReader));
  setValue_19(instance, $readDouble(streamReader));
}

function instantiate_298(streamReader){
  return new MeasurementDataNumericHighLowComposite_0;
}

function setHighValue(instance, value){
  instance.highValue = value;
}

function setLowValue(instance, value){
  instance.lowValue = value;
}

function setTimestamp_2(instance, value){
  instance.timestamp = value;
}

function setValue_19(instance, value){
  instance.value_0 = value;
}

function $clinit_MeasurementNumericValueAndUnits(){
  $clinit_MeasurementNumericValueAndUnits = nullMethod;
  new MeasurementNumericValueAndUnits_0(new Double_0(0), ($clinit_MeasurementUnits() , NONE_8));
}

function MeasurementNumericValueAndUnits_0(value, units){
  $clinit_MeasurementNumericValueAndUnits();
  this.value_0 = value;
  this.units = units;
}

defineSeed(1303, 1, {}, MeasurementNumericValueAndUnits_0);
_.toString$ = function toString_141(){
  return this.value_0 + ' ' + this.units;
}
;
_.units = null;
_.value_0 = null;
function $setFormattedOutlier(this$static, formattedOutlier){
  this$static.formattedOutlier = formattedOutlier;
}

function MeasurementOOBComposite_0(){
}

defineSeed(1304, 1, makeCastMap([Q$Serializable, Q$MeasurementOOBComposite]), MeasurementOOBComposite_0);
_.toString$ = function toString_142(){
  var sb;
  sb = new StringBuilder_0;
  $append_1(sb.data_0, 'MeasurementOOBComposite');
  $append_7($append_12(($append_1(sb.data_0, "{resourceName='") , sb), this.resourceName), 39);
  $append_9(($append_1(sb.data_0, ', resourceId=') , sb), this.resourceId);
  $append_7($append_12(($append_1(sb.data_0, ", scheduleName='") , sb), this.scheduleName), 39);
  $append_9(($append_1(sb.data_0, ', scheduleId=') , sb), this.scheduleId);
  $append_10(($append_1(sb.data_0, ', timestamp=') , sb), this.timestamp);
  $append_9(($append_1(sb.data_0, ', definitionId=') , sb), this.definitionId);
  $append_9(($append_1(sb.data_0, ', factor=') , sb), this.factor);
  $append_8(($append_1(sb.data_0, ', blMin=') , sb), this.blMin);
  $append_8(($append_1(sb.data_0, ', blMax=') , sb), this.blMax);
  $append_8(($append_1(sb.data_0, ', dataMin=') , sb), this.dataMin);
  $append_8(($append_1(sb.data_0, ', dataMax=') , sb), this.dataMax);
  $append_8(($append_1(sb.data_0, ', outlier=') , sb), this.outlier);
  $append_11(($append_1(sb.data_0, ', units=') , sb), this.units);
  $append_7($append_12(($append_1(sb.data_0, ", parentName='") , sb), this.parentName), 39);
  $append_11(($append_1(sb.data_0, ', parentId=') , sb), this.parentId);
  $appendNonNull(sb.data_0, '}');
  return $toString_1(sb.data_0);
}
;
_.blMax = 0;
_.blMin = 0;
_.dataMax = 0;
_.dataMin = 0;
_.definitionId = 0;
_.factor = 0;
_.formattedBaseband = null;
_.formattedOutlier = null;
_.outlier = 0;
_.parentId = null;
_.parentName = null;
_.resourceAncestry = null;
_.resourceId = 0;
_.resourceName = null;
_.resourceTypeId = 0;
_.scheduleId = 0;
_.scheduleName = null;
_.timestamp = P0_longLit;
_.units = null;
function deserialize_307(streamReader, instance){
  setBlMax(instance, $readDouble(streamReader));
  setBlMin(instance, $readDouble(streamReader));
  setDataMax(instance, $readDouble(streamReader));
  setDataMin(instance, $readDouble(streamReader));
  setDefinitionId(instance, $readInt(streamReader));
  setFactor(instance, $readInt(streamReader));
  setFormattedBaseband(instance, $getString(streamReader, $readInt(streamReader)));
  setFormattedOutlier(instance, $getString(streamReader, $readInt(streamReader)));
  setOutlier(instance, $readDouble(streamReader));
  setParentId_0(instance, dynamicCast($readObject(streamReader), Q$Integer));
  setParentName(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceAncestry_0(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceId_3(instance, $readInt(streamReader));
  setResourceName_0(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceTypeId_1(instance, $readInt(streamReader));
  setScheduleId_0(instance, $readInt(streamReader));
  setScheduleName(instance, $getString(streamReader, $readInt(streamReader)));
  setTimestamp_3(instance, $readLong(streamReader));
  setUnits_1(instance, dynamicCast($readObject(streamReader), Q$MeasurementUnits));
}

function instantiate_299(streamReader){
  return new MeasurementOOBComposite_0;
}

function setBlMax(instance, value){
  instance.blMax = value;
}

function setBlMin(instance, value){
  instance.blMin = value;
}

function setDataMax(instance, value){
  instance.dataMax = value;
}

function setDataMin(instance, value){
  instance.dataMin = value;
}

function setDefinitionId(instance, value){
  instance.definitionId = value;
}

function setFactor(instance, value){
  instance.factor = value;
}

function setFormattedBaseband(instance, value){
  instance.formattedBaseband = value;
}

function setFormattedOutlier(instance, value){
  instance.formattedOutlier = value;
}

function setOutlier(instance, value){
  instance.outlier = value;
}

function setParentId_0(instance, value){
  instance.parentId = value;
}

function setParentName(instance, value){
  instance.parentName = value;
}

function setResourceAncestry_0(instance, value){
  instance.resourceAncestry = value;
}

function setResourceId_3(instance, value){
  instance.resourceId = value;
}

function setResourceName_0(instance, value){
  instance.resourceName = value;
}

function setResourceTypeId_1(instance, value){
  instance.resourceTypeId = value;
}

function setScheduleId_0(instance, value){
  instance.scheduleId = value;
}

function setScheduleName(instance, value){
  instance.scheduleName = value;
}

function setTimestamp_3(instance, value){
  instance.timestamp = value;
}

function setUnits_1(instance, value){
  instance.units = value;
}

function MeasurementScheduleComposite_0(){
}

defineSeed(1306, 1, makeCastMap([Q$Serializable, Q$MeasurementScheduleComposite]), MeasurementScheduleComposite_0);
_.toString$ = function toString_143(){
  return 'MeasurementScheduleComposite[measurementDefinition=' + this.measurementDefinition + ', collectionEnabled=' + this.collectionEnabled + ', collectionInterval=' + toString_8(this.collectionInterval) + ']';
}
;
_.collectionEnabled = null;
_.collectionInterval = P0_longLit;
_.measurementDefinition = null;
function deserialize_308(streamReader, instance){
  setCollectionEnabled(instance, dynamicCast($readObject(streamReader), Q$Boolean));
  setCollectionInterval(instance, $readLong(streamReader));
  setMeasurementDefinition_0(instance, dynamicCast($readObject(streamReader), Q$MeasurementDefinition));
}

function instantiate_300(streamReader){
  return new MeasurementScheduleComposite_0;
}

function setCollectionEnabled(instance, value){
  instance.collectionEnabled = value;
}

function setCollectionInterval(instance, value){
  instance.collectionInterval = value;
}

function setMeasurementDefinition_0(instance, value){
  instance.measurementDefinition = value;
}

defineSeed(1309, 1, makeCastMap([Q$Serializable]));
_.toString$ = function toString_144(){
  var sb;
  sb = new StringBuffer_2(Lorg_rhq_core_domain_measurement_ui_MeasurementSummary_2_classLit.typeName);
  $append_4(($append_1(sb.data_0, '(availUp=') , sb), this.availUp);
  $append_4(($append_1(sb.data_0, ',availDown=') , sb), this.availDown);
  $append_4(($append_1(sb.data_0, ',availUnknown=') , sb), this.availUnknown);
  $append_1(sb.data_0, ')');
  return $toString_1(sb.data_0);
}
;
_.availDown = null;
_.availUnknown = null;
_.availUp = null;
function $clinit_BaseMetricDisplay(){
  $clinit_BaseMetricDisplay = nullMethod;
  new Arrays$ArrayList_0(($clinit_MetricDisplayConstants() , attrKey));
}

function $getAvgMetric(this$static){
  var mdv;
  mdv = $getMetric(this$static, 'average');
  if (!mdv) {
    throw new IllegalArgumentException_1('No valid metric key: average');
  }
  return mdv;
}

function $getLastMetric(this$static){
  var mdv;
  mdv = $getMetric(this$static, 'last');
  if (!mdv) {
    throw new IllegalArgumentException_1('No valid metric key: last');
  }
  return mdv;
}

function $getMaxMetric(this$static){
  var mdv;
  mdv = $getMetric(this$static, 'max');
  if (!mdv) {
    throw new IllegalArgumentException_1('No valid metric key: max');
  }
  return mdv;
}

function $getMetric(this$static, key){
  if (key == null) {
    throw new IllegalArgumentException_1("'null' is not a valid metric key");
  }
  return dynamicCast(this$static.metrics.get_2(key), Q$MetricDisplayValue);
}

function $getMetricKeys(this$static){
  var ent, ent$iterator, i, key, key$iterator, keys, rv;
  keys = new ArrayList_0;
  for (ent$iterator = this$static.metrics.entrySet().iterator(); ent$iterator.hasNext();) {
    ent = dynamicCast(ent$iterator.next_0(), Q$Map$Entry);
    ent.getKey_0() != null && ent.getValue_1() != null && $add_3(keys, dynamicCast(ent.getKey_0(), Q$String));
  }
  i = 0;
  rv = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, keys.size_0, 0);
  for (key$iterator = new AbstractList$IteratorImpl_0(keys); key$iterator.i < key$iterator.this$0_0.size_1();) {
    key = dynamicCast($next_0(key$iterator), Q$String);
    rv[i] = key;
    ++i;
  }
  return rv;
}

function $getMetricValueDoubles(this$static){
  var ent, ent$iterator, i, rv, v, v$iterator, values;
  values = new ArrayList_0;
  for (ent$iterator = this$static.metrics.entrySet().iterator(); ent$iterator.hasNext();) {
    ent = dynamicCast(ent$iterator.next_0(), Q$Map$Entry);
    ent.getKey_0() != null && ent.getValue_1() != null && $add_3(values, dynamicCast(ent.getValue_1(), Q$MetricDisplayValue).value_0);
  }
  i = 0;
  rv = initDim(_3D_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, values.size_0, 1);
  for (v$iterator = new AbstractList$IteratorImpl_0(values); v$iterator.i < v$iterator.this$0_0.size_1();) {
    v = dynamicCast($next_0(v$iterator), Q$Double);
    rv[i] = v.value_0;
    ++i;
  }
  return rv;
}

function $getMinMetric(this$static){
  var mdv;
  mdv = $getMetric(this$static, 'min');
  if (!mdv) {
    throw new IllegalArgumentException_1('No valid metric key: min');
  }
  return mdv;
}

function $setUnits(this$static, units){
  this$static.units = units;
}

function $toString_11(this$static){
  var anAttrKey, anAttrKey$array, anAttrKey$index, anAttrKey$max, sb;
  sb = new StringBuffer_2(Lorg_rhq_core_domain_measurement_ui_BaseMetricDisplay_2_classLit.typeName);
  $append_5(($append_1(sb.data_0, '(label=') , sb), this$static.label);
  $append_4(($append_1(sb.data_0, ',beginTimeFrame=') , sb), this$static.beginTimeFrame);
  $append_4(($append_1(sb.data_0, ',endTimeFrame=') , sb), this$static.endTimeFrame);
  $append_5(($append_1(sb.data_0, ',units=') , sb), this$static.units);
  $append_4(($append_1(sb.data_0, ',collectionType=') , sb), this$static.collectionType);
  $append_5(($append_1(sb.data_0, ',metricSource=') , sb), this$static.metricSource);
  $append_4(($append_1(sb.data_0, ',scheduleId=') , sb), this$static.scheduleId);
  $append_4(($append_1(sb.data_0, ',showNumberCollecting=') , sb), this$static.showNumberCollecting);
  $append_1(sb.data_0, 'metrics[');
  for (anAttrKey$array = ($clinit_MetricDisplayConstants() , attrKey) , anAttrKey$index = 0 , anAttrKey$max = anAttrKey$array.length; anAttrKey$index < anAttrKey$max; ++anAttrKey$index) {
    anAttrKey = anAttrKey$array[anAttrKey$index];
    $append_4($append_5($append_5(($append_1(sb.data_0, '\n') , sb), anAttrKey), '='), this$static.metrics.get_2(anAttrKey));
  }
  $append_1(sb.data_0, ']\n)');
  return $toString_1(sb.data_0);
}

defineSeed(1308, 1309, makeCastMap([Q$Serializable, Q$Comparable, Q$BaseMetricDisplay]));
_.compareTo$ = function compareTo_14(arg0){
  var to;
  if (instanceOf(arg0, Q$BaseMetricDisplay)) {
    to = dynamicCast(arg0, Q$BaseMetricDisplay);
    return compareTo_11(this.label, to.label);
  }
  throw new IllegalArgumentException_1('Cannot compare to non-BaseMetricDisplay object: ' + arg0);
}
;
_.toString$ = function toString_145(){
  return $toString_11(this);
}
;
_.beginTimeFrame = null;
_.collectionType = null;
_.definitionId = null;
_.description = null;
_.endTimeFrame = null;
_.label = null;
_.metricName = null;
_.metricSource = null;
_.metricSourceId = 0;
_.metrics = null;
_.numberCollecting = -1;
_.scheduleId = null;
_.showNumberCollecting = null;
_.units = null;
function setBeginTimeFrame(instance, value){
  instance.beginTimeFrame = value;
}

function setCollectionType(instance, value){
  instance.collectionType = value;
}

function setDefinitionId_0(instance, value){
  instance.definitionId = value;
}

function setDescription_24(instance, value){
  instance.description = value;
}

function setEndTimeFrame(instance, value){
  instance.endTimeFrame = value;
}

function setLabel_0(instance, value){
  instance.label = value;
}

function setMetricName(instance, value){
  instance.metricName = value;
}

function setMetricSource(instance, value){
  instance.metricSource = value;
}

function setMetricSourceId(instance, value){
  instance.metricSourceId = value;
}

function setMetrics(instance, value){
  instance.metrics = value;
}

function setNumberCollecting(instance, value){
  instance.numberCollecting = value;
}

function setScheduleId_1(instance, value){
  instance.scheduleId = value;
}

function setShowNumberCollecting(instance, value){
  instance.showNumberCollecting = value;
}

function setUnits_2(instance, value){
  instance.units = value;
}

function setAvailDown(instance, value){
  instance.availDown = value;
}

function setAvailUnknown(instance, value){
  instance.availUnknown = value;
}

function setAvailUp(instance, value){
  instance.availUp = value;
}

function $clinit_MetricDisplayConstants(){
  $clinit_MetricDisplayConstants = nullMethod;
  attrKey = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['max', 'min', 'average', 'last', 'baseline', 'high', 'low', 'summary']);
}

var attrKey;
function MetricDisplaySummary_0(){
  $clinit_BaseMetricDisplay();
  this.metrics = new HashMap_0;
}

defineSeed(1313, 1308, makeCastMap([Q$Serializable, Q$Comparable, Q$BaseMetricDisplay, Q$MetricDisplaySummary]), MetricDisplaySummary_0);
_.toString$ = function toString_146(){
  return 'token=' + this.metricToken + ',' + Lorg_rhq_core_domain_measurement_ui_MetricDisplaySummary_2_classLit.typeName + ',group=' + this.groupId + ',super(' + $toString_11(this) + ')';
}
;
_.alertCount = 0;
_.childTypeId = -1;
_.groupId = -1;
_.isTrait = false;
_.metricToken = null;
_.parent_0 = null;
_.parentId = -1;
_.resource = null;
_.timestamp = P0_longLit;
_.value_0 = null;
_.valuesPresent = true;
function deserialize_309(streamReader, instance){
  setAlertCount(instance, $readInt(streamReader));
  setChildTypeId(instance, $readInt(streamReader));
  setGroupId(instance, $readInt(streamReader));
  setIsTrait(instance, $readBoolean(streamReader));
  setMetricToken(instance, $getString(streamReader, $readInt(streamReader)));
  setParent(instance, dynamicCast($readObject(streamReader), Q$Resource));
  setParentId_1(instance, $readInt(streamReader));
  setResource_15(instance, dynamicCast($readObject(streamReader), Q$Resource));
  $readInt(streamReader);
  setTimestamp_4(instance, $readLong(streamReader));
  setValue_20(instance, $getString(streamReader, $readInt(streamReader)));
  setValuesPresent(instance, $readBoolean(streamReader));
  setBeginTimeFrame(instance, dynamicCast($readObject(streamReader), Q$Long));
  setCollectionType(instance, dynamicCast($readObject(streamReader), Q$Integer));
  setDefinitionId_0(instance, dynamicCast($readObject(streamReader), Q$Integer));
  setDescription_24(instance, $getString(streamReader, $readInt(streamReader)));
  setEndTimeFrame(instance, dynamicCast($readObject(streamReader), Q$Long));
  setLabel_0(instance, $getString(streamReader, $readInt(streamReader)));
  setMetricName(instance, $getString(streamReader, $readInt(streamReader)));
  setMetricSource(instance, $getString(streamReader, $readInt(streamReader)));
  setMetricSourceId(instance, $readInt(streamReader));
  setMetrics(instance, dynamicCast($readObject(streamReader), Q$Map));
  setNumberCollecting(instance, $readInt(streamReader));
  setScheduleId_1(instance, dynamicCast($readObject(streamReader), Q$Integer));
  setShowNumberCollecting(instance, dynamicCast($readObject(streamReader), Q$Boolean));
  setUnits_2(instance, $getString(streamReader, $readInt(streamReader)));
  setAvailDown(instance, dynamicCast($readObject(streamReader), Q$Integer));
  setAvailUnknown(instance, dynamicCast($readObject(streamReader), Q$Integer));
  setAvailUp(instance, dynamicCast($readObject(streamReader), Q$Integer));
}

function instantiate_301(streamReader){
  return new MetricDisplaySummary_0;
}

function setAlertCount(instance, value){
  instance.alertCount = value;
}

function setChildTypeId(instance, value){
  instance.childTypeId = value;
}

function setGroupId(instance, value){
  instance.groupId = value;
}

function setIsTrait(instance, value){
  instance.isTrait = value;
}

function setMetricToken(instance, value){
  instance.metricToken = value;
}

function setParent(instance, value){
  instance.parent_0 = value;
}

function setParentId_1(instance, value){
  instance.parentId = value;
}

function setResource_15(instance, value){
  instance.resource = value;
}

function setTimestamp_4(instance, value){
  instance.timestamp = value;
}

function setValue_20(instance, value){
  instance.value_0 = value;
}

function setValuesPresent(instance, value){
  instance.valuesPresent = value;
}

function $setValueFmt(this$static, aValueFmt){
  this$static.valueFmt = aValueFmt;
}

function $toString_12(this$static){
  if (this$static.valueFmt != null) {
    return this$static.valueFmt;
  }
  return '' + this$static.value_0.value_0;
}

function MetricDisplayValue_0(){
}

defineSeed(1315, 1, makeCastMap([Q$Serializable, Q$MetricDisplayValue]), MetricDisplayValue_0);
_.toString$ = function toString_147(){
  return $toString_12(this);
}
;
_.highlighted = null;
_.value_0 = null;
_.valueFmt = null;
function deserialize_310(streamReader, instance){
  setHighlighted(instance, dynamicCast($readObject(streamReader), Q$Boolean));
  setValue_21(instance, dynamicCast($readObject(streamReader), Q$Double));
  setValueFmt(instance, $getString(streamReader, $readInt(streamReader)));
}

function instantiate_302(streamReader){
  return new MetricDisplayValue_0;
}

function setHighlighted(instance, value){
  instance.highlighted = value;
}

function setValue_21(instance, value){
  instance.value_0 = value;
}

function setValueFmt(instance, value){
  instance.valueFmt = value;
}

function MeasurementConversionException_0(message){
  RuntimeException_1.call(this, message);
}

defineSeed(1317, 6, makeCastMap([Q$Serializable, Q$Exception, Q$RuntimeException, Q$Throwable]), MeasurementConversionException_0);
function $setId_2(this$static, id){
  this$static.id = id;
}

function $setStartedTime(this$static){
  if (neq(this$static.startedTime, P0_longLit)) {
    throw new IllegalArgumentException_1('Can only start an operation once');
  }
  this$static.startedTime = fromDouble(currentTimeMillis0());
}

function OperationHistory_0(subjectName, operationDefinition, parameters){
  $$init_14(this);
  this.jobName = null;
  this.jobGroup = null;
  this.subjectName = subjectName;
  this.operationDefinition = operationDefinition;
  this.parameters = parameters;
  this.status_0 = ($clinit_OperationRequestStatus() , INPROGRESS_1);
}

function GroupOperationHistory_1(){
  OperationHistory_0.call(this, null, null, null);
  $$init_15(this);
  this.group = null;
  $setStartedTime(this);
}

defineSeed(1318, 1319, makeCastMap([Q$Serializable, Q$GroupOperationHistory, Q$OperationHistory]), GroupOperationHistory_1);
function JobId_0(){
}

defineSeed(1323, 1, makeCastMap([Q$Serializable, Q$JobId]), JobId_0);
function deserialize_313(streamReader, instance){
  setJobGroup(instance, $getString(streamReader, $readInt(streamReader)));
  setJobName(instance, $getString(streamReader, $readInt(streamReader)));
}

function instantiate_305(streamReader){
  return new JobId_0;
}

function setJobGroup(instance, value){
  instance.jobGroup = value;
}

function setJobName(instance, value){
  instance.jobName = value;
}

function serialize_281(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function ResourceOperationHistory_1(subjectName, operationDefinition, parameters, resource){
  OperationHistory_0.call(this, subjectName, operationDefinition, parameters);
  this.resource = resource;
  this.groupOperationHistory = null;
  !!this.groupOperationHistory && null.resourceOperationHistories.add(this);
}

defineSeed(1332, 1319, makeCastMap([Q$Serializable, Q$OperationHistory, Q$ResourceOperationHistory]), ResourceOperationHistory_1);
function ScheduleJobId_0(){
  JobId_1.call(this, '', '');
}

defineSeed(1335, 1323, makeCastMap([Q$Serializable, Q$JobId]), ScheduleJobId_0);
function deserialize_319(streamReader, instance){
  setJobGroup(instance, $getString(streamReader, $readInt(streamReader)));
  setJobName(instance, $getString(streamReader, $readInt(streamReader)));
}

function instantiate_310(streamReader){
  return new ScheduleJobId_0;
}

function $getOperationDisplayName(this$static){
  if (this$static.operationDisplayName == null || $equals_6(this$static.operationDisplayName, '')) {
    return this$static.operationName;
  }
  return this$static.operationDisplayName;
}

function $setDescription_2(this$static, description){
  this$static.description = description;
}

function $setId_3(this$static, id){
  this$static.id = id;
}

function $setJobGroup(this$static, jobGroup){
  this$static.jobGroup = jobGroup;
}

function $setJobName(this$static, jobName){
  this$static.jobName = jobName;
}

function $setJobTrigger(this$static, jobTrigger){
  this$static.jobTrigger = jobTrigger;
}

function $setNextFireTime(this$static, nextFireTime){
  this$static.nextFireTime = nextFireTime;
}

function $setOperationDisplayName(this$static, operationDisplayName){
  this$static.operationDisplayName = operationDisplayName;
}

function $setOperationName(this$static, operationName){
  this$static.operationName = operationName;
}

function $setSubject(this$static, subject){
  if (!subject) {
    throw new NullPointerException_1('Cannot schedule an operation without a user associated with it');
  }
  this$static.subject = subject;
}

function $toString_16(this$static){
  var str;
  str = new StringBuilder_0;
  $append_12(str, 'job-name=[' + this$static.jobName);
  $append_12(str, '], job-group=[' + this$static.jobGroup);
  $append_12(str, '], operation-name=[' + this$static.operationName);
  $append_12(str, '], subject=[' + this$static.subject);
  $append_12(str, '], description=[' + this$static.description);
  $append_1(str.data_0, ']');
  return $toString_1(str.data_0);
}

defineSeed(1338, 1, makeCastMap([Q$Serializable, Q$OperationSchedule]));
_.toString$ = function toString_155(){
  return $toString_16(this);
}
;
_.description = null;
_.id = 0;
_.jobGroup = null;
_.jobName = null;
_.jobTrigger = null;
_.nextFireTime = null;
_.operationDisplayName = null;
_.operationName = null;
_.parameters = null;
_.subject = null;
function $setGroup_0(this$static, group){
  this$static.group = group;
}

function $setHaltOnFailure(this$static, haltOnFailure){
  this$static.haltOnFailure = haltOnFailure;
}

function GroupOperationSchedule_0(){
}

defineSeed(1337, 1338, makeCastMap([Q$Serializable, Q$GroupOperationSchedule, Q$OperationSchedule]), GroupOperationSchedule_0);
_.toString$ = function toString_156(){
  var str;
  str = new StringBuilder_1('GroupOperationSchedule: ');
  $append_12(str, 'group=[' + this.group);
  $append_12(str, '], execution-order=[' + this.executionOrder);
  $append_12(str, '], halt-on-failure=[' + this.haltOnFailure);
  $append_1(str.data_0, '],');
  $append_12(str, $toString_16(this));
  return $toString_1(str.data_0);
}
;
_.executionOrder = null;
_.group = null;
_.haltOnFailure = false;
function deserialize_320(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_311(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_operation_bean_GroupOperationSchedule_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$GroupOperationSchedule, size, 0);
}

function deserialize_321(streamReader, instance){
  setExecutionOrder(instance, dynamicCast($readObject(streamReader), Q$List));
  setGroup_4(instance, dynamicCast($readObject(streamReader), Q$ResourceGroup));
  setHaltOnFailure(instance, $readBoolean(streamReader));
  deserialize_322(streamReader, instance);
}

function instantiate_312(streamReader){
  return new GroupOperationSchedule_0;
}

function serialize_285(streamWriter, instance){
  $writeObject(streamWriter, instance.executionOrder);
  $writeObject(streamWriter, instance.group);
  $writeBoolean(streamWriter, instance.haltOnFailure);
  serialize_286(streamWriter, instance);
}

function setExecutionOrder(instance, value){
  instance.executionOrder = value;
}

function setGroup_4(instance, value){
  instance.group = value;
}

function setHaltOnFailure(instance, value){
  instance.haltOnFailure = value;
}

function deserialize_322(streamReader, instance){
  setDescription_26(instance, $getString(streamReader, $readInt(streamReader)));
  setId_77(instance, $readInt(streamReader));
  setJobGroup_1(instance, $getString(streamReader, $readInt(streamReader)));
  setJobName_1(instance, $getString(streamReader, $readInt(streamReader)));
  setJobTrigger(instance, dynamicCast($readObject(streamReader), Q$JobTrigger));
  setNextFireTime(instance, dynamicCast($readObject(streamReader), Q$Date));
  setOperationDisplayName(instance, $getString(streamReader, $readInt(streamReader)));
  setOperationName(instance, $getString(streamReader, $readInt(streamReader)));
  setParameters_0(instance, dynamicCast($readObject(streamReader), Q$Configuration));
  setSubject(instance, dynamicCast($readObject(streamReader), Q$Subject));
}

function serialize_286(streamWriter, instance){
  $writeString(streamWriter, instance.description);
  $writeInt(streamWriter, instance.id);
  $writeString(streamWriter, instance.jobGroup);
  $writeString(streamWriter, instance.jobName);
  $writeObject(streamWriter, instance.jobTrigger);
  $writeObject(streamWriter, instance.nextFireTime);
  $writeString(streamWriter, instance.operationDisplayName);
  $writeString(streamWriter, instance.operationName);
  $writeObject(streamWriter, instance.parameters);
  $writeObject(streamWriter, instance.subject);
}

function setDescription_26(instance, value){
  instance.description = value;
}

function setId_77(instance, value){
  instance.id = value;
}

function setJobGroup_1(instance, value){
  instance.jobGroup = value;
}

function setJobName_1(instance, value){
  instance.jobName = value;
}

function setJobTrigger(instance, value){
  instance.jobTrigger = value;
}

function setNextFireTime(instance, value){
  instance.nextFireTime = value;
}

function setOperationDisplayName(instance, value){
  instance.operationDisplayName = value;
}

function setOperationName(instance, value){
  instance.operationName = value;
}

function setParameters_0(instance, value){
  instance.parameters = value;
}

function setSubject(instance, value){
  instance.subject = value;
}

function $setResource_0(this$static, resource){
  this$static.resource = resource;
}

function ResourceOperationSchedule_0(){
}

defineSeed(1342, 1338, makeCastMap([Q$Serializable, Q$OperationSchedule, Q$ResourceOperationSchedule]), ResourceOperationSchedule_0);
_.toString$ = function toString_157(){
  var str;
  str = new StringBuilder_1('ResourceOperationSchedule: ');
  $append_12(str, 'resource=[' + this.resource);
  $append_1(str.data_0, '],');
  $append_12(str, $toString_16(this));
  return $toString_1(str.data_0);
}
;
_.resource = null;
function deserialize_323(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_313(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_operation_bean_ResourceOperationSchedule_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ResourceOperationSchedule, size, 0);
}

function deserialize_324(streamReader, instance){
  setResource_17(instance, dynamicCast($readObject(streamReader), Q$Resource));
  deserialize_322(streamReader, instance);
}

function instantiate_314(streamReader){
  return new ResourceOperationSchedule_0;
}

function serialize_287(streamWriter, instance){
  $writeObject(streamWriter, instance.resource);
  serialize_286(streamWriter, instance);
}

function setResource_17(instance, value){
  instance.resource = value;
}

function $toString_17(this$static){
  var str;
  str = new StringBuilder_0;
  $append_12(str, 'operation-job-id=[' + this$static.id);
  $append_12(str, '], operation-name=[' + this$static.operationName);
  $append_12(str, '], operation-next-fire-time=[' + new Date_2(this$static.operationNextFireTime));
  $append_1(str.data_0, ']');
  return $toString_1(str.data_0);
}

function OperationScheduleComposite_0(){
  this.operationNextFireTime = N1_longLit;
  this.id = 0;
  this.operationName = '(uninitialized)';
}

defineSeed(1346, 1, makeCastMap([Q$Serializable, Q$OperationScheduleComposite]));
_.toString$ = function toString_158(){
  return $toString_17(this);
}
;
_.id = 0;
_.jobId = null;
_.operationName = null;
_.operationNextFireTime = P0_longLit;
function GroupOperationScheduleComposite_0(){
  OperationScheduleComposite_0.call(this);
}

defineSeed(1345, 1346, makeCastMap([Q$Serializable, Q$GroupOperationScheduleComposite, Q$OperationScheduleComposite]), GroupOperationScheduleComposite_0);
_.toString$ = function toString_159(){
  var str;
  str = new StringBuilder_1('GroupOperationScheduleComposite: ' + $toString_17(this));
  $append_12(str, ', group-id=[' + this.groupId);
  $append_12(str, '], group-name=[' + this.groupName);
  $append_12(str, '], group-resource-type-name=[' + this.groupResourceTypeName);
  $append_1(str.data_0, ']');
  return $toString_1(str.data_0);
}
;
_.groupId = 0;
_.groupName = null;
_.groupResourceTypeName = null;
function deserialize_325(streamReader, instance){
  setGroupId_0(instance, $readInt(streamReader));
  setGroupName(instance, $getString(streamReader, $readInt(streamReader)));
  setGroupResourceTypeName(instance, $getString(streamReader, $readInt(streamReader)));
  deserialize_326(streamReader, instance);
}

function instantiate_315(streamReader){
  return new GroupOperationScheduleComposite_0;
}

function setGroupId_0(instance, value){
  instance.groupId = value;
}

function setGroupName(instance, value){
  instance.groupName = value;
}

function setGroupResourceTypeName(instance, value){
  instance.groupResourceTypeName = value;
}

defineSeed(1348, 1, makeCastMap([Q$Serializable]));
_.operationHistoryId = 0;
_.operationName = null;
_.operationStartTime = P0_longLit;
_.operationStatus = null;
function setOperationHistoryId(instance, value){
  instance.operationHistoryId = value;
}

function setOperationName_0(instance, value){
  instance.operationName = value;
}

function setOperationStartTime(instance, value){
  instance.operationStartTime = value;
}

function setOperationStatus(instance, value){
  instance.operationStatus = value;
}

function deserialize_326(streamReader, instance){
  setId_78(instance, $readInt(streamReader));
  setJobId(instance, dynamicCast($readObject(streamReader), Q$JobId));
  setOperationName_1(instance, $getString(streamReader, $readInt(streamReader)));
  setOperationNextFireTime(instance, $readLong(streamReader));
}

function setId_78(instance, value){
  instance.id = value;
}

function setJobId(instance, value){
  instance.jobId = value;
}

function setOperationName_1(instance, value){
  instance.operationName = value;
}

function setOperationNextFireTime(instance, value){
  instance.operationNextFireTime = value;
}

function ResourceOperationLastCompletedComposite_0(){
  this.operationHistoryId = 0;
  this.operationName = '(uninitialized)';
  this.operationStartTime = N1_longLit;
  this.operationStatus = ($clinit_OperationRequestStatus() , FAILURE_6);
  this.resourceId = 0;
  this.resourceTypeId = 0;
  this.resourceName = '(uninitialized)';
  this.ancestry = '(uninitialized)';
}

defineSeed(1351, 1348, makeCastMap([Q$Serializable]), ResourceOperationLastCompletedComposite_0);
_.ancestry = null;
_.resourceId = 0;
_.resourceName = null;
_.resourceTypeId = 0;
function deserialize_327(streamReader, instance){
  setAncestry(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceId_4(instance, $readInt(streamReader));
  setResourceName_1(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceTypeId_2(instance, $readInt(streamReader));
  setOperationHistoryId(instance, $readInt(streamReader));
  setOperationName_0(instance, $getString(streamReader, $readInt(streamReader)));
  setOperationStartTime(instance, $readLong(streamReader));
  setOperationStatus(instance, dynamicCast($readObject(streamReader), Q$OperationRequestStatus));
}

function instantiate_316(streamReader){
  return new ResourceOperationLastCompletedComposite_0;
}

function setAncestry(instance, value){
  instance.ancestry = value;
}

function setResourceId_4(instance, value){
  instance.resourceId = value;
}

function setResourceName_1(instance, value){
  instance.resourceName = value;
}

function setResourceTypeId_2(instance, value){
  instance.resourceTypeId = value;
}

function ResourceOperationScheduleComposite_0(){
  OperationScheduleComposite_0.call(this);
  this.resourceId = 0;
  this.resourceTypeId = 0;
  this.resourceName = '(uninitialized)';
  this.ancestry = '(uninitialized)';
}

defineSeed(1353, 1346, makeCastMap([Q$Serializable, Q$OperationScheduleComposite, Q$ResourceOperationScheduleComposite]), ResourceOperationScheduleComposite_0);
_.toString$ = function toString_160(){
  var str;
  str = new StringBuilder_1('ResourceOperationScheduleComposite: ' + $toString_17(this));
  $append_12(str, ', resource-id=[' + this.resourceId);
  $append_12(str, '], resource-name=[' + this.resourceName);
  $append_12(str, '], resource-type-id=[' + this.resourceTypeId);
  $append_1(str.data_0, ']');
  return $toString_1(str.data_0);
}
;
_.ancestry = null;
_.resourceId = 0;
_.resourceName = null;
_.resourceTypeId = 0;
function deserialize_328(streamReader, instance){
  setAncestry_0(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceId_5(instance, $readInt(streamReader));
  setResourceName_2(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceTypeId_3(instance, $readInt(streamReader));
  deserialize_326(streamReader, instance);
}

function instantiate_317(streamReader){
  return new ResourceOperationScheduleComposite_0;
}

function setAncestry_0(instance, value){
  instance.ancestry = value;
}

function setResourceId_5(instance, value){
  instance.resourceId = value;
}

function setResourceName_2(instance, value){
  instance.resourceName = value;
}

function setResourceTypeId_3(instance, value){
  instance.resourceTypeId = value;
}

function $equals_37(this$static, obj_0){
  var that;
  if (this$static === obj_0) {
    return true;
  }
  if (obj_0 == null || !instanceOf(obj_0, Q$AbstractPlugin)) {
    return false;
  }
  that = dynamicCast(obj_0, Q$AbstractPlugin);
  return $equals_6(this$static.name_0, that.name_0);
}

function AbstractPlugin_0(){
  this.status_0 = ($clinit_PluginStatusType() , INSTALLED_1);
}

defineSeed(1355, 1, makeCastMap([Q$Serializable, Q$AbstractPlugin]));
_.equals$ = function equals_97(obj_0){
  return $equals_37(this, obj_0);
}
;
_.hashCode$ = function hashCode_97(){
  return getHashCode_0(this.name_0);
}
;
_.toString$ = function toString_161(){
  return '[id=' + this.id + ', name=' + this.name_0 + ', md5=' + this.md5 + ']';
}
;
_.ampsVersion = null;
_.content_0 = null;
_.ctime = P0_longLit;
_.deployment = null;
_.description = null;
_.displayName = null;
_.enabled = true;
_.help = null;
_.helpContentType = null;
_.id = 0;
_.md5 = null;
_.mtime = P0_longLit;
_.name_0 = null;
_.path = null;
_.version_0 = null;
function deserialize_329(streamReader, instance){
  setNative(instance, 'server-enhanced-data-1', $getString(streamReader, $readInt(streamReader)));
  setAmpsVersion(instance, $getString(streamReader, $readInt(streamReader)));
  setContent(instance, dynamicCast($readObject(streamReader), Q$byte_$1));
  setCtime_19(instance, $readLong(streamReader));
  setDeployment(instance, dynamicCast($readObject(streamReader), Q$PluginDeploymentType));
  setDescription_27(instance, $getString(streamReader, $readInt(streamReader)));
  setDisplayName_7(instance, $getString(streamReader, $readInt(streamReader)));
  setEnabled_4(instance, $readBoolean(streamReader));
  setHelp(instance, $getString(streamReader, $readInt(streamReader)));
  setHelpContentType(instance, $getString(streamReader, $readInt(streamReader)));
  setId_79(instance, $readInt(streamReader));
  setMd5_0(instance, $getString(streamReader, $readInt(streamReader)));
  setMtime_7(instance, $readLong(streamReader));
  setName_36(instance, $getString(streamReader, $readInt(streamReader)));
  setPath_3(instance, $getString(streamReader, $readInt(streamReader)));
  setStatus_7(instance, dynamicCast($readObject(streamReader), Q$PluginStatusType));
  setVersion_10(instance, $getString(streamReader, $readInt(streamReader)));
}

function setAmpsVersion(instance, value){
  instance.ampsVersion = value;
}

function setContent(instance, value){
  instance.content_0 = value;
}

function setCtime_19(instance, value){
  instance.ctime = value;
}

function setDeployment(instance, value){
  instance.deployment = value;
}

function setDescription_27(instance, value){
  instance.description = value;
}

function setDisplayName_7(instance, value){
  instance.displayName = value;
}

function setEnabled_4(instance, value){
  instance.enabled = value;
}

function setHelp(instance, value){
  instance.help = value;
}

function setHelpContentType(instance, value){
  instance.helpContentType = value;
}

function setId_79(instance, value){
  instance.id = value;
}

function setMd5_0(instance, value){
  instance.md5 = value;
}

function setMtime_7(instance, value){
  instance.mtime = value;
}

function setName_36(instance, value){
  instance.name_0 = value;
}

function setPath_3(instance, value){
  instance.path = value;
}

function setStatus_7(instance, value){
  instance.status_0 = value;
}

function setVersion_10(instance, value){
  instance.version_0 = value;
}

function $setDeployment(this$static, deployment){
  if (deployment != ($clinit_PluginDeploymentType() , AGENT)) {
    throw new IllegalArgumentException_1('Plugin can only ever have deployment type of AGENT: ' + deployment);
  }
  this$static.deployment = deployment;
}

function Plugin_1(){
  AbstractPlugin_0.call(this);
  $setDeployment(this, ($clinit_PluginDeploymentType() , AGENT));
}

defineSeed(1357, 1355, makeCastMap([Q$Serializable, Q$AbstractPlugin, Q$Plugin]), Plugin_1);
_.equals$ = function equals_98(obj_0){
  if (this === obj_0) {
    return true;
  }
  if (obj_0 == null || !instanceOf(obj_0, Q$Plugin)) {
    return false;
  }
  return $equals_37(this, obj_0);
}
;
_.hashCode$ = function hashCode_98(){
  return getHashCode_0(this.name_0);
}
;
_.toString$ = function toString_162(){
  return 'AgentPlugin [id=' + this.id + ', name=' + this.name_0 + ', md5=' + this.md5 + ']';
}
;
function $clinit_PluginDeploymentType(){
  $clinit_PluginDeploymentType = nullMethod;
  AGENT = new PluginDeploymentType_0('AGENT', 0);
  SERVER = new PluginDeploymentType_0('SERVER', 1);
  $VALUES_97 = initValues(_3Lorg_rhq_core_domain_plugin_PluginDeploymentType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$PluginDeploymentType, [AGENT, SERVER]);
}

function PluginDeploymentType_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_106(name_0){
  $clinit_PluginDeploymentType();
  return valueOf(($clinit_PluginDeploymentType$Map() , $MAP_97), name_0);
}

function values_100(){
  $clinit_PluginDeploymentType();
  return $VALUES_97;
}

defineSeed(1358, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$PluginDeploymentType]), PluginDeploymentType_0);
var $VALUES_97, AGENT, SERVER;
function $clinit_PluginDeploymentType$Map(){
  $clinit_PluginDeploymentType$Map = nullMethod;
  $MAP_97 = createValueOfMap(($clinit_PluginDeploymentType() , $VALUES_97));
}

var $MAP_97;
function deserialize_330(streamReader, instance){
}

function instantiate_318(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_PluginDeploymentType() , $clinit_PluginDeploymentType() , $VALUES_97);
  return values[ordinal];
}

function serialize_288(streamWriter, instance){
  $writeInt(streamWriter, instance.ordinal);
}

function PluginKey_0(deployment, pluginType, pluginName){
  if (!deployment) {
    throw new IllegalArgumentException_1('deployment==null');
  }
  if (pluginType == null && deployment != ($clinit_PluginDeploymentType() , AGENT)) {
    throw new IllegalArgumentException_1('only agent plugins can have null type');
  }
  if (pluginType != null && deployment == ($clinit_PluginDeploymentType() , AGENT)) {
    throw new IllegalArgumentException_1('agent plugins must have null type');
  }
  if (pluginName == null || pluginName.length == 0) {
    throw new IllegalArgumentException_1('invalid pluginName: ' + pluginName);
  }
  this.deployment = deployment;
  this.pluginType = pluginType;
  this.pluginName = pluginName;
}

function createServerPluginKey(pluginType, pluginName){
  if (pluginType == null || pluginType.length == 0) {
    throw new IllegalArgumentException_1('invalid pluginType: ' + pluginType);
  }
  return new PluginKey_0(($clinit_PluginDeploymentType() , SERVER), pluginType, pluginName);
}

defineSeed(1361, 1, makeCastMap([Q$Serializable, Q$PluginKey]), PluginKey_0);
_.equals$ = function equals_99(obj_0){
  var other;
  if (this === obj_0) {
    return true;
  }
  if (!instanceOf(obj_0, Q$PluginKey)) {
    return false;
  }
  other = dynamicCast(obj_0, Q$PluginKey);
  if (!$equals_6(this.pluginName, other.pluginName)) {
    return false;
  }
  if (this.pluginType == null) {
    if (other.pluginType != null) {
      return false;
    }
  }
   else if (!$equals_6(this.pluginType, other.pluginType)) {
    return false;
  }
  if (this.deployment != other.deployment) {
    return false;
  }
  return true;
}
;
_.hashCode$ = function hashCode_99(){
  var result;
  result = 31 + getHashCode(this.deployment);
  result = 31 * result + (this.pluginType == null?0:getHashCode_0(this.pluginType));
  result = 31 * result + getHashCode_0(this.pluginName);
  return result;
}
;
_.toString$ = function toString_163(){
  var builder;
  builder = new StringBuilder_0;
  $append_12($append_12($append_12($append_12($append_12($append_11(($append_1(builder.data_0, 'PluginKey [deployment=') , builder), this.deployment), ', pluginType='), this.pluginType), ', pluginName='), this.pluginName), ']');
  return $toString_1(builder.data_0);
}
;
_.deployment = null;
_.pluginName = null;
_.pluginType = null;
function serialize_289(streamWriter, instance){
  $writeObject(streamWriter, instance.deployment);
  $writeString(streamWriter, instance.pluginName);
  $writeString(streamWriter, instance.pluginType);
}

function $clinit_PluginStatusType(){
  $clinit_PluginStatusType = nullMethod;
  INSTALLED_1 = new PluginStatusType_0('INSTALLED', 0);
  DELETED_0 = new PluginStatusType_0('DELETED', 1);
  $VALUES_98 = initValues(_3Lorg_rhq_core_domain_plugin_PluginStatusType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$PluginStatusType, [INSTALLED_1, DELETED_0]);
}

function PluginStatusType_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_107(name_0){
  $clinit_PluginStatusType();
  return valueOf(($clinit_PluginStatusType$Map() , $MAP_98), name_0);
}

function values_101(){
  $clinit_PluginStatusType();
  return $VALUES_98;
}

defineSeed(1363, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$PluginStatusType]), PluginStatusType_0);
var $VALUES_98, DELETED_0, INSTALLED_1;
function $clinit_PluginStatusType$Map(){
  $clinit_PluginStatusType$Map = nullMethod;
  $MAP_98 = createValueOfMap(($clinit_PluginStatusType() , $VALUES_98));
}

var $MAP_98;
function deserialize_331(streamReader, instance){
}

function instantiate_319(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_PluginStatusType() , $clinit_PluginStatusType() , $VALUES_98);
  return values[ordinal];
}

function deserialize_332(streamReader, instance){
  setNative(instance, 'server-enhanced-data-2', $getString(streamReader, $readInt(streamReader)));
  deserialize_329(streamReader, instance);
}

function instantiate_320(streamReader){
  return new Plugin_1;
}

function $setDeployment_0(this$static, deployment){
  if (deployment != ($clinit_PluginDeploymentType() , SERVER)) {
    throw new IllegalArgumentException_1('ServerPlugin can only ever have deployment type of SERVER: ' + deployment);
  }
  this$static.deployment = deployment;
}

function ServerPlugin_0(){
  AbstractPlugin_0.call(this);
  $setDeployment_0(this, ($clinit_PluginDeploymentType() , SERVER));
}

defineSeed(1367, 1355, makeCastMap([Q$Serializable, Q$AbstractPlugin, Q$ServerPlugin]), ServerPlugin_0);
_.equals$ = function equals_100(obj_0){
  if (this === obj_0) {
    return true;
  }
  if (obj_0 == null || !instanceOf(obj_0, Q$ServerPlugin)) {
    return false;
  }
  return $equals_37(this, obj_0);
}
;
_.hashCode$ = function hashCode_100(){
  return getHashCode_0(this.name_0);
}
;
_.toString$ = function toString_164(){
  return 'ServerPlugin [id=' + this.id + ', name=' + this.name_0 + ', md5=' + this.md5 + ']';
}
;
_.pluginConfiguration = null;
_.scheduledJobsConfiguration = null;
_.type_0 = null;
function ServerPluginControlDefinition_0(){
}

defineSeed(1368, 1, makeCastMap([Q$Serializable, Q$ServerPluginControlDefinition]), ServerPluginControlDefinition_0);
_.toString$ = function toString_165(){
  var builder;
  builder = new StringBuilder_0;
  $append_12($append_12(($append_1(builder.data_0, 'ControlDefinition name=[') , builder), this.name_0), ']');
  $append_12($append_12(($append_1(builder.data_0, ', description=[') , builder), this.description), ']');
  return $toString_1(builder.data_0);
}
;
_.description = null;
_.displayName = null;
_.name_0 = null;
_.parameters = null;
_.results = null;
function deserialize_333(streamReader, instance){
  setDescription_28(instance, $getString(streamReader, $readInt(streamReader)));
  setDisplayName_8(instance, $getString(streamReader, $readInt(streamReader)));
  setName_37(instance, $getString(streamReader, $readInt(streamReader)));
  setParameters_1(instance, dynamicCast($readObject(streamReader), Q$ConfigurationDefinition));
  setResults_2(instance, dynamicCast($readObject(streamReader), Q$ConfigurationDefinition));
}

function instantiate_321(streamReader){
  return new ServerPluginControlDefinition_0;
}

function setDescription_28(instance, value){
  instance.description = value;
}

function setDisplayName_8(instance, value){
  instance.displayName = value;
}

function setName_37(instance, value){
  instance.name_0 = value;
}

function setParameters_1(instance, value){
  instance.parameters = value;
}

function setResults_2(instance, value){
  instance.results = value;
}

function ServerPluginControlResults_0(){
  this.complexResults = new Configuration_0;
}

defineSeed(1370, 1, makeCastMap([Q$Serializable, Q$ServerPluginControlResults]), ServerPluginControlResults_0);
_.toString$ = function toString_166(){
  var str;
  str = new StringBuilder_1('ServerPluginControlResults');
  this.errorMessage_0 != null && $append_12($append_12(($append_1(str.data_0, ' error=[') , str), this.errorMessage_0), '];');
  $append_12($append_11(($append_1(str.data_0, ' results=[') , str), this.complexResults), ']');
  return $toString_1(str.data_0);
}
;
_.errorMessage_0 = null;
function deserialize_334(streamReader, instance){
  setComplexResults(instance, dynamicCast($readObject(streamReader), Q$Configuration));
  setErrorMessage_4(instance, $getString(streamReader, $readInt(streamReader)));
}

function instantiate_322(streamReader){
  return new ServerPluginControlResults_0;
}

function setComplexResults(instance, value){
  instance.complexResults = value;
}

function setErrorMessage_4(instance, value){
  instance.errorMessage_0 = value;
}

function deserialize_335(streamReader, instance){
  setNative(instance, 'server-enhanced-data-2', $getString(streamReader, $readInt(streamReader)));
  setPluginConfiguration(instance, dynamicCast($readObject(streamReader), Q$Configuration));
  setScheduledJobsConfiguration(instance, dynamicCast($readObject(streamReader), Q$Configuration));
  setType_1(instance, $getString(streamReader, $readInt(streamReader)));
  deserialize_329(streamReader, instance);
}

function instantiate_323(streamReader){
  return new ServerPlugin_0;
}

function setPluginConfiguration(instance, value){
  instance.pluginConfiguration = value;
}

function setScheduledJobsConfiguration(instance, value){
  instance.scheduledJobsConfiguration = value;
}

function setType_1(instance, value){
  instance.type_0 = value;
}

function InventorySummary_0(){
}

defineSeed(1397, 1, makeCastMap([Q$Serializable, Q$InventorySummary]), InventorySummary_0);
_.compatibleGroupCount = 0;
_.groupDefinitionCount = 0;
_.mixedGroupCount = 0;
_.platformCount = 0;
_.scheduledMeasurementsPerMinute = 0;
_.serverCount = 0;
_.serviceCount = 0;
_.softwareProductCount = 0;
_.softwareUpdateCount = 0;
function deserialize_347(streamReader, instance){
  setCompatibleGroupCount(instance, $readInt(streamReader));
  setGroupDefinitionCount(instance, $readInt(streamReader));
  setMixedGroupCount(instance, $readInt(streamReader));
  setPlatformCount(instance, $readInt(streamReader));
  setScheduledMeasurementsPerMinute(instance, $readInt(streamReader));
  setServerCount_0(instance, $readInt(streamReader));
  setServiceCount(instance, $readInt(streamReader));
  setSoftwareProductCount(instance, $readInt(streamReader));
  setSoftwareUpdateCount(instance, $readInt(streamReader));
}

function instantiate_335(streamReader){
  return new InventorySummary_0;
}

function setCompatibleGroupCount(instance, value){
  instance.compatibleGroupCount = value;
}

function setGroupDefinitionCount(instance, value){
  instance.groupDefinitionCount = value;
}

function setMixedGroupCount(instance, value){
  instance.mixedGroupCount = value;
}

function setPlatformCount(instance, value){
  instance.platformCount = value;
}

function setScheduledMeasurementsPerMinute(instance, value){
  instance.scheduledMeasurementsPerMinute = value;
}

function setServerCount_0(instance, value){
  instance.serverCount = value;
}

function setServiceCount(instance, value){
  instance.serviceCount = value;
}

function setSoftwareProductCount(instance, value){
  instance.softwareProductCount = value;
}

function setSoftwareUpdateCount(instance, value){
  instance.softwareUpdateCount = value;
}

function $getAlertDefinitions(this$static){
  !this$static.alertDefinitions && (this$static.alertDefinitions = new LinkedHashSet_0);
  return this$static.alertDefinitions;
}

function $setAncestry(this$static, ancestry){
  this$static.ancestry = ancestry;
}

function $setDescription_3(this$static, description){
  this$static.description = description;
}

function $setId_4(this$static, id){
  this$static.id = id;
}

function $setLocation(this$static, location_0){
  this$static.location_0 = location_0;
}

function $setName_8(this$static, name_0){
  this$static.name_0 = name_0;
}

function $setResourceType_0(this$static, resourceType){
  this$static.resourceType = resourceType;
}

function $setTags(this$static, tags){
  this$static.tags = tags;
}

function $setUuid(this$static, uuid){
  var i, spacesNeeded;
  if (uuid != null && uuid.length != 36) {
    if (uuid.length > 36) {
      throw new IllegalArgumentException_1('UUIDs must not be longer than [36]');
    }
     else {
      spacesNeeded = 36 - uuid.length;
      for (i = 0; i < spacesNeeded; ++i) {
        uuid = uuid + ' ';
      }
    }
  }
  this$static.uuid = uuid;
}

function $updateAncestryForResource(this$static){
  var ancestry, parentAncestry, parentResource;
  parentResource = this$static.parentResource;
  if (!parentResource || parentResource.id <= 0 || !parentResource.resourceType) {
    return null;
  }
  ancestry = new StringBuilder_0;
  $append_9(ancestry, parentResource.resourceType.id);
  $append_1(ancestry.data_0, '_:_');
  $append_9(ancestry, parentResource.id);
  $append_1(ancestry.data_0, '_:_');
  $append_12(ancestry, parentResource.name_0);
  parentAncestry = parentResource.ancestry;
  if (null != parentAncestry) {
    $append_1(ancestry.data_0, '_::_');
    $append_1(ancestry.data_0, parentAncestry);
  }
  $toString_1(ancestry.data_0).length < 4000 && $setAncestry(this$static, $toString_1(ancestry.data_0));
  return this$static.ancestry;
}

function Resource_2(id){
  Resource_1.call(this);
  this.id = id;
}

defineSeed(1403, 1, makeCastMap([Q$Serializable, Q$Comparable, Q$Resource]), Resource_2);
function $addDriftDefinitionTemplate(this$static, template){
  !this$static.driftDefinitionTemplates && (this$static.driftDefinitionTemplates = new HashSet_0);
  template.resourceType = this$static;
  this$static.driftDefinitionTemplates.add(template);
}

function $getResourceTypeBundleConfiguration(this$static){
  return !this$static.bundleConfiguration?null:new ResourceTypeBundleConfiguration_1(this$static.bundleConfiguration);
}

function $isDeletable(this$static){
  return this$static.createDeletePolicy == ($clinit_CreateDeletePolicy() , BOTH_1) || this$static.createDeletePolicy == DELETE_ONLY;
}

function $setIgnored(this$static, ignored){
  this$static.ignored = ignored;
}

function PlatformMetricsSummary_0(){
}

defineSeed(1430, 1, makeCastMap([Q$Serializable, Q$PlatformMetricsSummary]), PlatformMetricsSummary_0);
_.actualFreeMemory = null;
_.actualUsedMemory = null;
_.freeMemory = null;
_.freeSwap = null;
_.idleCPU = null;
_.metricsAvailable = true;
_.resource = null;
_.systemCPU = null;
_.totalMemory = null;
_.totalSwap = null;
_.usedMemory = null;
_.usedSwap = null;
_.userCPU = null;
_.waitCPU = null;
function $clinit_PlatformMetricsSummary$CPUMetric(){
  $clinit_PlatformMetricsSummary$CPUMetric = nullMethod;
  Idle = new PlatformMetricsSummary$CPUMetric_0('Idle', 0, 'CpuPerc.idle');
  System = new PlatformMetricsSummary$CPUMetric_0('System', 1, 'CpuPerc.sys');
  User = new PlatformMetricsSummary$CPUMetric_0('User', 2, 'CpuPerc.user');
  Wait = new PlatformMetricsSummary$CPUMetric_0('Wait', 3, 'CpuPerc.wait');
  $VALUES_108 = initValues(_3Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$CPUMetric_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$PlatformMetricsSummary$CPUMetric, [Idle, System, User, Wait]);
}

function PlatformMetricsSummary$CPUMetric_0(enum$name, enum$ordinal, property){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.property = property;
}

function valueOf_117(name_0){
  $clinit_PlatformMetricsSummary$CPUMetric();
  return valueOf(($clinit_PlatformMetricsSummary$CPUMetric$Map() , $MAP_108), name_0);
}

function values_111(){
  $clinit_PlatformMetricsSummary$CPUMetric();
  return $VALUES_108;
}

defineSeed(1431, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$PlatformMetricsSummary$CPUMetric]), PlatformMetricsSummary$CPUMetric_0);
_.property = null;
var $VALUES_108, Idle, System, User, Wait;
function $clinit_PlatformMetricsSummary$CPUMetric$Map(){
  $clinit_PlatformMetricsSummary$CPUMetric$Map = nullMethod;
  $MAP_108 = createValueOfMap(($clinit_PlatformMetricsSummary$CPUMetric() , $VALUES_108));
}

var $MAP_108;
function $clinit_PlatformMetricsSummary$MemoryMetric(){
  $clinit_PlatformMetricsSummary$MemoryMetric = nullMethod;
  ActualUsed = new PlatformMetricsSummary$MemoryMetric_0('ActualUsed', 0, 'Native.MemoryInfo.actualUsed');
  Used = new PlatformMetricsSummary$MemoryMetric_0('Used', 1, 'Native.MemoryInfo.used');
  ActualFree = new PlatformMetricsSummary$MemoryMetric_0('ActualFree', 2, 'Native.MemoryInfo.actualFree');
  Free = new PlatformMetricsSummary$MemoryMetric_0('Free', 3, 'Native.MemoryInfo.free');
  Total = new PlatformMetricsSummary$MemoryMetric_0('Total', 4, 'Native.MemoryInfo.total');
  $VALUES_109 = initValues(_3Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$MemoryMetric_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$PlatformMetricsSummary$MemoryMetric, [ActualUsed, Used, ActualFree, Free, Total]);
}

function PlatformMetricsSummary$MemoryMetric_0(enum$name, enum$ordinal, property){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.property = property;
}

function valueOf_118(name_0){
  $clinit_PlatformMetricsSummary$MemoryMetric();
  return valueOf(($clinit_PlatformMetricsSummary$MemoryMetric$Map() , $MAP_109), name_0);
}

function values_112(){
  $clinit_PlatformMetricsSummary$MemoryMetric();
  return $VALUES_109;
}

defineSeed(1433, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$PlatformMetricsSummary$MemoryMetric]), PlatformMetricsSummary$MemoryMetric_0);
_.property = null;
var $VALUES_109, ActualFree, ActualUsed, Free, Total, Used;
function $clinit_PlatformMetricsSummary$MemoryMetric$Map(){
  $clinit_PlatformMetricsSummary$MemoryMetric$Map = nullMethod;
  $MAP_109 = createValueOfMap(($clinit_PlatformMetricsSummary$MemoryMetric() , $VALUES_109));
}

var $MAP_109;
function $clinit_PlatformMetricsSummary$SwapMetric(){
  $clinit_PlatformMetricsSummary$SwapMetric = nullMethod;
  Used_0 = new PlatformMetricsSummary$SwapMetric_0('Used', 0, 'Native.SwapInfo.used');
  Free_0 = new PlatformMetricsSummary$SwapMetric_0('Free', 1, 'Native.SwapInfo.free');
  Total_0 = new PlatformMetricsSummary$SwapMetric_0('Total', 2, 'Native.SwapInfo.total');
  $VALUES_110 = initValues(_3Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$SwapMetric_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$PlatformMetricsSummary$SwapMetric, [Used_0, Free_0, Total_0]);
}

function PlatformMetricsSummary$SwapMetric_0(enum$name, enum$ordinal, property){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.property = property;
}

function valueOf_119(name_0){
  $clinit_PlatformMetricsSummary$SwapMetric();
  return valueOf(($clinit_PlatformMetricsSummary$SwapMetric$Map() , $MAP_110), name_0);
}

function values_113(){
  $clinit_PlatformMetricsSummary$SwapMetric();
  return $VALUES_110;
}

defineSeed(1435, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$PlatformMetricsSummary$SwapMetric]), PlatformMetricsSummary$SwapMetric_0);
_.property = null;
var $VALUES_110, Free_0, Total_0, Used_0;
function $clinit_PlatformMetricsSummary$SwapMetric$Map(){
  $clinit_PlatformMetricsSummary$SwapMetric$Map = nullMethod;
  $MAP_110 = createValueOfMap(($clinit_PlatformMetricsSummary$SwapMetric() , $VALUES_110));
}

var $MAP_110;
function deserialize_361(streamReader, instance){
  setActualFreeMemory(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setActualUsedMemory(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setFreeMemory(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setFreeSwap(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setIdleCPU(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setMetricsAvailable(instance, $readBoolean(streamReader));
  setResource_20(instance, dynamicCast($readObject(streamReader), Q$Resource));
  setSystemCPU(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setTotalMemory(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setTotalSwap(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setUsedMemory(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setUsedSwap(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setUserCPU(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
  setWaitCPU(instance, dynamicCast($readObject(streamReader), Q$MeasurementData));
}

function instantiate_349(streamReader){
  return new PlatformMetricsSummary_0;
}

function setActualFreeMemory(instance, value){
  instance.actualFreeMemory = value;
}

function setActualUsedMemory(instance, value){
  instance.actualUsedMemory = value;
}

function setFreeMemory(instance, value){
  instance.freeMemory = value;
}

function setFreeSwap(instance, value){
  instance.freeSwap = value;
}

function setIdleCPU(instance, value){
  instance.idleCPU = value;
}

function setMetricsAvailable(instance, value){
  instance.metricsAvailable = value;
}

function setResource_20(instance, value){
  instance.resource = value;
}

function setSystemCPU(instance, value){
  instance.systemCPU = value;
}

function setTotalMemory(instance, value){
  instance.totalMemory = value;
}

function setTotalSwap(instance, value){
  instance.totalSwap = value;
}

function setUsedMemory(instance, value){
  instance.usedMemory = value;
}

function setUsedSwap(instance, value){
  instance.usedSwap = value;
}

function setUserCPU(instance, value){
  instance.userCPU = value;
}

function setWaitCPU(instance, value){
  instance.waitCPU = value;
}

function $getMTBF(this$static){
  if (this$static.failures <= 1) {
    return P0_longLit;
  }
  return this$static.current == ($clinit_AvailabilityType() , UP)?div(sub(this$static.upTime, sub(this$static.now, this$static.lastChange)), fromInt(this$static.failures - 1)):div(this$static.upTime, fromInt(this$static.failures - 1));
}

function $getMTTR(this$static){
  if (this$static.failures <= 0) {
    return P0_longLit;
  }
  return this$static.current == ($clinit_AvailabilityType() , DOWN_0)?this$static.failures > 1?div(sub(this$static.downTime, sub(this$static.now, this$static.lastChange)), fromInt(this$static.failures - 1)):P0_longLit:div(this$static.downTime, fromInt(this$static.failures));
}

function ResourceComposite_1(resource, availability){
  ResourceComposite_2.call(this, resource, availability, new ResourcePermission_0);
}

function ResourceComposite_2(resource, availability, resourcePermission){
  this.resource = resource;
  this.parent_0 = null;
  this.availability = availability;
  this.resourcePermission = resourcePermission;
}

defineSeed(1445, 1, makeCastMap([Q$Serializable, Q$ResourceComposite]), ResourceComposite_1);
function $getKey(this$static){
  var b, node, node$iterator;
  if (null == this$static.key) {
    b = new StringBuilder_0;
    $append_9(b, this$static.clusterGroupId);
    for (node$iterator = new AbstractList$IteratorImpl_0(this$static.hierarchy); node$iterator.i < node$iterator.this$0_0.size_1();) {
      node = dynamicCast($next_0(node$iterator), Q$ClusterKey$Node);
      $append_1(b.data_0, '::');
      $append_12(b, node.resourceTypeId + ':' + node.resourceKey);
    }
    this$static.key = $toString_1(b.data_0);
  }
  return this$static.key;
}

function ClusterKey_0(clusterResourceGroupId){
  this.clusterGroupId = clusterResourceGroupId;
  this.hierarchy = new ArrayList_0;
}

function ClusterKey_1(parentKey, childResourceTypeId, childResourceKey){
  var rootClusterNodes;
  rootClusterNodes = parentKey.hierarchy;
  this.clusterGroupId = parentKey.clusterGroupId;
  this.hierarchy = new ArrayList_2(rootClusterNodes);
  $add_3(this.hierarchy, new ClusterKey$Node_0(childResourceTypeId, childResourceKey));
}

defineSeed(1459, 1, makeCastMap([Q$Serializable, Q$ClusterKey]), ClusterKey_0, ClusterKey_1);
_.equals$ = function equals_111(o){
  var that;
  if (this === o)
    return true;
  if (!instanceOf(o, Q$ClusterKey))
    return false;
  that = dynamicCast(o, Q$ClusterKey);
  if (!$equals_6($getKey(this), $getKey(that)))
    return false;
  return true;
}
;
_.hashCode$ = function hashCode_111(){
  return getHashCode_0($getKey(this));
}
;
_.toString$ = function toString_181(){
  return $getKey(this);
}
;
_.clusterGroupId = 0;
_.hierarchy = null;
_.key = null;
function ClusterKey$Node_0(resourceTypeId, resourceKey){
  this.resourceTypeId = resourceTypeId;
  this.resourceKey = $replace_1(resourceKey, ':', '%3a');
}

defineSeed(1460, 1, makeCastMap([Q$Serializable, Q$ClusterKey$Node]), ClusterKey$Node_0);
_.toString$ = function toString_182(){
  return this.resourceTypeId + ':' + this.resourceKey;
}
;
_.resourceKey = null;
_.resourceTypeId = 0;
function serialize_315(streamWriter, instance){
  $writeInt(streamWriter, instance.clusterGroupId);
  $writeObject(streamWriter, instance.hierarchy);
  $writeString(streamWriter, instance.key);
}

function serialize_316(streamWriter, instance){
  serialize_10(streamWriter, instance);
}

function serialize_317(streamWriter, instance){
  $writeString(streamWriter, instance.resourceKey);
  $writeInt(streamWriter, instance.resourceTypeId);
}

function $setDescription_4(this$static, description){
  this$static.description = description;
}

function $setName_9(this$static, name_0){
  this$static.name_0 = name_0;
}

function $getNextCalculationTime(this$static){
  var mt, ri;
  ri = valueOf_45(this$static.recalculationInterval);
  if (!ri || eq(ri.value_0, P0_longLit)) {
    return valueOf_45(P0_longLit);
  }
   else {
    if (this$static.lastCalculationTime) {
      return valueOf_45(add(this$static.lastCalculationTime.value_0, ri.value_0));
    }
     else {
      mt = this$static.modifiedTime;
      return valueOf_45(add(mt?mt.value_0:fromDouble(currentTimeMillis0()), ri.value_0));
    }
  }
}

function $setDescription_5(this$static, description){
  this$static.description = description;
}

function $setExpression(this$static, expression){
  this$static.expression = expression;
}

function $setId_5(this$static, id){
  this$static.id = id;
}

function $setName_10(this$static, name_0){
  this$static.name_0 = name_0;
}

function $setRecalculationInterval(this$static, recalculationInterval){
  this$static.recalculationInterval = recalculationInterval.value_0;
}

function $setRecursive(this$static, recursive){
  this$static.recursive = recursive;
}

function $setDescription_6(this$static, description){
  this$static.description = description;
}

function $setId_6(this$static, id){
  this$static.id = id;
}

function $setName_11(this$static, name_0){
  this$static.name_0 = name_0;
}

function $setAutoGroupParentResource(this$static, autoGroupParentResource){
  this$static.autoGroupParentResource = autoGroupParentResource;
}

function $setGroupCategory(this$static, groupCategory){
  this$static.groupCategory = groupCategory;
}

function $setId_7(this$static, id){
  this$static.id = id;
}

function $setRecursive_0(this$static, recursive){
  this$static.recursive = recursive;
}

function $setResourceType_1(this$static, resourceType){
  this$static.resourceType = resourceType;
  !resourceType?$setGroupCategory(this$static, ($clinit_GroupCategory() , MIXED_0)):$setGroupCategory(this$static, ($clinit_GroupCategory() , COMPATIBLE));
}

function $setTags_0(this$static, tags){
  this$static.tags = tags;
}

function ResourceGroup_2(name_0){
  this.name_0 = name_0;
  $$init_16(this);
  this.resourceType = null;
  $setGroupCategory(this, ($clinit_GroupCategory() , MIXED_0));
}

defineSeed(1477, 1467, makeCastMap([Q$Serializable, Q$Group, Q$ResourceGroup]), ResourceGroup_2);
function ClusterFlyweight_0(){
  this.children_0 = new ArrayList_1(0);
}

defineSeed(1480, 1, makeCastMap([Q$Serializable, Q$ClusterFlyweight]), ClusterFlyweight_0);
_.equals$ = function equals_115(obj_0){
  var other;
  if (this === obj_0) {
    return true;
  }
  if (!instanceOf(obj_0, Q$ClusterFlyweight)) {
    return false;
  }
  other = dynamicCast(obj_0, Q$ClusterFlyweight);
  if (this.groupId != other.groupId) {
    return false;
  }
  if (!this.clusterKey) {
    if (other.clusterKey) {
      return false;
    }
  }
   else if (!$equals_42(this.clusterKey, other.clusterKey)) {
    return false;
  }
  return true;
}
;
_.hashCode$ = function hashCode_115(){
  var result;
  result = 31 + this.groupId;
  result = 31 * result + (!this.clusterKey?0:$hashCode_27(this.clusterKey));
  return result;
}
;
_.toString$ = function toString_187(){
  var builder;
  builder = new StringBuilder_0;
  $append_12($append_11($append_12($append_12(($append_1(builder.data_0, 'ClusterFlyweight [name=') , builder), this.name_0), ', clusterKey='), this.clusterKey), ']');
  return $toString_1(builder.data_0);
}
;
_.clusterKey = null;
_.clusterSize = 0;
_.groupId = 0;
_.members_0 = 0;
_.name_0 = null;
function deserialize_381(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_369(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_resource_group_composite_ClusterFlyweight_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ClusterFlyweight, size, 0);
}

function deserialize_382(streamReader, instance){
  setChildren_0(instance, dynamicCast($readObject(streamReader), Q$List));
  setClusterKey_0(instance, dynamicCast($readObject(streamReader), Q$ClusterKeyFlyweight));
  setClusterSize(instance, $readInt(streamReader));
  setGroupId_1(instance, $readInt(streamReader));
  setMembers(instance, $readInt(streamReader));
  setName_47(instance, $getString(streamReader, $readInt(streamReader)));
}

function instantiate_370(streamReader){
  return new ClusterFlyweight_0;
}

function setChildren_0(instance, value){
  instance.children_0 = value;
}

function setClusterKey_0(instance, value){
  instance.clusterKey = value;
}

function setClusterSize(instance, value){
  instance.clusterSize = value;
}

function setGroupId_1(instance, value){
  instance.groupId = value;
}

function setMembers(instance, value){
  instance.members_0 = value;
}

function setName_47(instance, value){
  instance.name_0 = value;
}

function $equals_42(this$static, o){
  var node;
  if (this$static === o) {
    return true;
  }
  if (!instanceOf(o, Q$ClusterKeyFlyweight)) {
    return false;
  }
  node = dynamicCast(o, Q$ClusterKeyFlyweight);
  if (this$static.resourceTypeId != node.resourceTypeId) {
    return false;
  }
  if (this$static.resourceKey != null?!$equals_6(this$static.resourceKey, node.resourceKey):node.resourceKey != null) {
    return false;
  }
  return true;
}

function $hashCode_27(this$static){
  var result;
  result = this$static.resourceTypeId;
  result = 31 * result + (this$static.resourceKey != null?getHashCode_0(this$static.resourceKey):0);
  return result;
}

function ClusterKeyFlyweight_0(){
}

defineSeed(1483, 1, makeCastMap([Q$Serializable, Q$ClusterKeyFlyweight]), ClusterKeyFlyweight_0);
_.equals$ = function equals_116(o){
  return $equals_42(this, o);
}
;
_.hashCode$ = function hashCode_116(){
  return $hashCode_27(this);
}
;
_.toString$ = function toString_188(){
  return 'ClusterKeyFlyweight[type=' + this.resourceTypeId + ',key=' + this.resourceKey + ']';
}
;
_.resourceKey = null;
_.resourceTypeId = 0;
function deserialize_383(streamReader, instance){
  setResourceKey_0(instance, $getString(streamReader, $readInt(streamReader)));
  setResourceTypeId_6(instance, $readInt(streamReader));
}

function instantiate_371(streamReader){
  return new ClusterKeyFlyweight_0;
}

function setResourceKey_0(instance, value){
  instance.resourceKey = value;
}

function setResourceTypeId_6(instance, value){
  instance.resourceTypeId = value;
}

function ResourceGroupAvailability_0(){
}

defineSeed(1485, 1, makeCastMap([Q$Serializable, Q$ResourceGroupAvailability]), ResourceGroupAvailability_0);
_.endTime = null;
_.groupAvailabilityType = null;
_.resourceGroupId = 0;
_.startTime = null;
function deserialize_384(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_372(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_resource_group_composite_ResourceGroupAvailability_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ResourceGroupAvailability, size, 0);
}

function deserialize_385(streamReader, instance){
  setEndTime_2(instance, dynamicCast($readObject(streamReader), Q$Long));
  setGroupAvailabilityType(instance, dynamicCast($readObject(streamReader), Q$ResourceGroupComposite$GroupAvailabilityType));
  setResourceGroupId(instance, $readInt(streamReader));
  setStartTime_2(instance, dynamicCast($readObject(streamReader), Q$Long));
}

function instantiate_373(streamReader){
  return new ResourceGroupAvailability_0;
}

function setEndTime_2(instance, value){
  instance.endTime = value;
}

function setGroupAvailabilityType(instance, value){
  instance.groupAvailabilityType = value;
}

function setResourceGroupId(instance, value){
  instance.resourceGroupId = value;
}

function setStartTime_2(instance, value){
  instance.startTime = value;
}

function ResourceGroupComposite_1(explicitCount, explicitDown, explicitUnknown, explicitDisabled, implicitCount, implicitDown, implicitUnknown, implicitDisabled, resourceGroup){
  ResourceGroupComposite_2.call(this, explicitCount, explicitDown, explicitUnknown, explicitDisabled, implicitCount, implicitDown, implicitUnknown, implicitDisabled, resourceGroup, new ResourcePermission_0);
}

function ResourceGroupComposite_2(explicitCount, explicitDown, explicitUnknown, explicitDisabled, implicitCount, implicitDown, implicitUnknown, implicitDisabled, resourceGroup, permissions){
  this.implicitCount = implicitCount.value_0;
  this.implicitDown = implicitDown.value_0;
  this.implicitUnknown = implicitUnknown.value_0;
  this.implicitDisabled = implicitDisabled.value_0;
  this.explicitCount = explicitCount.value_0;
  this.explicitDown = explicitDown.value_0;
  this.explicitUnknown = explicitUnknown.value_0;
  this.explicitDisabled = explicitDisabled.value_0;
  this.resourceGroup = resourceGroup;
  if (this.resourceGroup.groupCategory == ($clinit_GroupCategory() , COMPATIBLE)) {
    this.category = COMPATIBLE;
  }
   else if (this.resourceGroup.groupCategory == MIXED_0) {
    this.category = MIXED_0;
  }
   else {
    throw new IllegalArgumentException_1('Unknown category [' + this.resourceGroup.groupCategory + '] for ResourceGroup [' + this.resourceGroup.name_0 + ']');
  }
  this.resourceFacets = null;
  this.resourcePermission = permissions;
}

defineSeed(1488, 1, makeCastMap([Q$Serializable, Q$ResourceGroupComposite]), ResourceGroupComposite_1);
function deserialize_387(streamReader, instance){
}

function instantiate_375(streamReader){
  var ordinal, values;
  ordinal = $readInt(streamReader);
  values = ($clinit_ResourceGroupComposite$GroupAvailabilityType() , $clinit_ResourceGroupComposite$GroupAvailabilityType() , $VALUES_112);
  return values[ordinal];
}

function $setName_12(this$static, name_0){
  this$static.name_0 = name_0;
}

function $setNamespace(this$static, namespace){
  this$static.namespace = namespace;
}

function $setSemantic(this$static, semantic){
  this$static.semantic = semantic;
}

function Tag_1(tag){
  if (tag.indexOf(':') != -1) {
    this.namespace = $split(tag, ':', 0)[0];
    tag = $split(tag, ':', 0)[1];
  }
  if (tag.indexOf('=') != -1) {
    this.semantic = $split(tag, '=', 0)[0];
    tag = $split(tag, '=', 0)[1];
  }
  this.name_0 = tag;
}

defineSeed(1505, 1, makeCastMap([Q$Serializable, Q$Tag]), Tag_1);
function $setMajor(this$static, major){
  this$static.major = major;
}

function $setMicro(this$static, micro){
  this$static.micro = micro;
}

function $setMinor(this$static, minor){
  this$static.minor = minor;
}

function OrderingField_1(field, ordering){
  this.field = field;
  this.ordering = ordering?ordering:($clinit_PageOrdering() , ASC);
}

defineSeed(1512, 1, makeCastMap([Q$Serializable, Q$OrderingField]), OrderingField_1);
function $addDefaultOrderingField(this$static, defaultField, defaultPageOrdering){
  var ordering, ordering$iterator;
  if (this$static.orderingFields.size_0 >= 3) {
    return;
  }
  for (ordering$iterator = $listIterator(this$static.orderingFields, 0); ordering$iterator.currentNode != ordering$iterator.this$0.header;) {
    ordering = dynamicCast($next_5(ordering$iterator), Q$OrderingField);
    if ($equals_6(ordering.field, defaultField)) {
      return;
    }
  }
  $add_7(this$static.orderingFields, new OrderingField_1(defaultField, defaultPageOrdering));
}

function $initDefaultOrderingField(this$static, defaultField, defaultPageOrdering){
  if (this$static.orderingFields.size_0 > 0) {
    return;
  }
  $addDefaultOrderingField(this$static, defaultField, defaultPageOrdering);
}

function $removeOrderingField(this$static, doomedField){
  var field, i;
  for (i = $listIterator(this$static.orderingFields, 0); i.currentNode != i.this$0.header;) {
    field = dynamicCast($next_5(i), Q$OrderingField);
    if ($equals_6(field.field, doomedField)) {
      $remove_13(i);
      break;
    }
  }
}

function getExplicitPageControl(firstRecord, recordCount){
  var pc;
  pc = new PageControl_1(-1, recordCount);
  pc.firstRecord = valueOf_44(firstRecord);
  return pc;
}

defineSeed(1514, 1, makeCastMap([Q$Serializable, Q$Cloneable, Q$PageControl]));
_.setPageSize = function setPageSize(pageSize){
  this.pageNumber = pageSize != 0 && pageSize != -1?~~((this.firstRecord?this.firstRecord.value_0:this.pageNumber * this.pageSize) / pageSize):0;
  this.pageSize = pageSize;
}
;
function $getTotalSize(this$static){
  return max_0(this$static.size_0, this$static.totalSize);
}

function $setPageControl_0(this$static, pageControl){
  this$static.pageControl = pageControl;
}

function $setTotalSize(this$static, totalSize){
  this$static.isUnbounded = false;
  this$static.totalSize = totalSize;
}

function $setUnbounded(this$static, isUnbounded){
  this$static.isUnbounded = isUnbounded;
}

function PageList_1(collection, pageControl){
  ArrayList_2.call(this, collection);
  this.isUnbounded = true;
  this.pageControl = pageControl;
}

function PageList_2(pageControl){
  $$init(this);
  this.isUnbounded = true;
  this.pageControl = pageControl;
}

defineSeed(1516, 289, makeCastMap([Q$Serializable, Q$Cloneable, Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$ArrayList, Q$Collection, Q$List, Q$RandomAccess, Q$PageList]), PageList_1, PageList_2);
function deserialize_398(streamReader, instance){
  deserialize_32(streamReader, instance);
}

function instantiate_386(streamReader){
  var size;
  size = $readInt(streamReader);
  return initDim(_3Lorg_rhq_core_domain_util_PageList_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PageList, size, 0);
}

function useForwardSlash(path){
  $clinit_StringUtils();
  return null != path?$replace_0(path, 92, 47):null;
}

defineSeed(1523, 1514, makeCastMap([Q$Serializable, Q$Cloneable, Q$PageControl]));
_.setPageSize = function setPageSize_1(pageSize){
  throw new UnsupportedOperationException_1('page size cannot be changed from -1 for an UnlimitedPageControl.');
}
;
function unwrapArray(input){
  var i, output;
  if (input == null) {
    return null;
  }
  output = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, input.length, 1);
  for (i = 0; i < input.length; ++i) {
    output[i] = input[i].value_0;
  }
  return output;
}

function unwrapCollection(input){
  var intermediate;
  if (!input) {
    return null;
  }
  intermediate = dynamicCast($toArray(input, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, input.map.size_1(), 0)), Q$Integer_$1);
  return unwrapArray(intermediate);
}

function $createContent(this$static, viewName){
  var canvas, logoutView;
  if ($equals_6(viewName, ($clinit_DashboardsView() , VIEW_ID_16).name_0)) {
    canvas = new DashboardsView_0;
  }
   else if ($equals_6(viewName, ($clinit_InventoryView() , VIEW_ID_21).name_0)) {
    canvas = new InventoryView_0;
  }
   else if ($equals_6(viewName, ($clinit_ResourceTopView() , VIEW_ID_24).name_0)) {
    canvas = new ResourceTopView_0;
  }
   else if ($equals_6(viewName, ($clinit_ResourceGroupTopView() , VIEW_ID_22).name_0)) {
    canvas = new ResourceGroupTopView_0;
  }
   else if ($equals_6(viewName, ($clinit_ReportTopView() , VIEW_ID_27).name_0)) {
    canvas = new ReportTopView_0;
  }
   else if ($equals_6(viewName, ($clinit_BundleTopView() , VIEW_ID_15).name_0)) {
    canvas = new BundleTopView_0;
  }
   else if ($equals_6(viewName, ($clinit_AdministrationView() , VIEW_ID).name_0)) {
    canvas = new AdministrationView_0;
  }
   else if ($equals_6(viewName, ($clinit_HelpView() , VIEW_ID_20).name_0)) {
    canvas = new HelpView_0;
  }
   else if ($equals_6(viewName, 'LogOut')) {
    logout();
    $hide(this$static.rootCanvas);
    logoutView = new LoginView_0;
    canvas = logoutView;
    $showLoginDialog(logoutView);
  }
   else 
    $equals_6(viewName, ($clinit_TaggedView() , VIEW_ID_31).name_0)?(canvas = new TaggedView_0):$equals_6(viewName, 'Subsystems')?(canvas = new AlertHistoryView_0):$equals_6(viewName, ($clinit_TestTopView() , VIEW_ID_32).name_0)?(canvas = new TestTopView_0):(canvas = null);
  return canvas;
}

defineSeed(1534, 1, makeCastMap([Q$RunAsyncCallback]));
_.onSuccess = function onSuccess_0(){
  this.this$1.currentCanvas = $createContent(this.this$1.this$0, this.this$1.currentViewId.path);
  !!this.this$1.currentCanvas && $addChild(this.val$contentCanvas, this.this$1.currentCanvas);
  this.val$contentCanvas.markForRedraw_0();
  $render(this.this$1, this.val$viewPath);
  info_0('Time to Load first codesplit fragment: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this.val$startTime)) + ' ms.');
}
;
function $setupWindow(this$static, title, item){
  $isCreated_1(this$static)?$setProperty_3(this$static, 'title', title):(this$static.config_0['title'] = title , undefined);
  $setShowMinimizeButton(this$static, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowMaximizeButton(this$static, TRUE);
  $setIsModal(this$static, TRUE);
  $setShowModalMask(this$static, TRUE);
  $setAutoSize(this$static, TRUE);
  $setAutoCenter(this$static, TRUE);
  $setShowResizer(this$static, TRUE);
  $setCanDragResize_0(this$static, TRUE);
  $centerInPage(this$static);
  $addCloseClickHandler(this$static, new ErrorMessageWindow$1_0(this$static));
  $addItem(this$static, item);
}

function ErrorMessageWindow_0(title, item){
  Window_1.call(this);
  $setupWindow(this, title, item);
}

function ErrorMessageWindow_1(title, message){
  $clinit_BaseWidget();
  var htmlPane;
  Window_1.call(this);
  htmlPane = new HTMLPane_0;
  $setMargin(htmlPane, valueOf_44(10));
  $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultWidth', 500):(htmlPane.config_0['defaultWidth'] = 500 , undefined);
  $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultHeight', 400):(htmlPane.config_0['defaultHeight'] = 400 , undefined);
  $isCreated_1(htmlPane)?$setProperty_3(htmlPane, 'contents', message):(htmlPane.config_0['contents'] = message , undefined);
  $setupWindow(this, title, htmlPane);
}

defineSeed(1536, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), ErrorMessageWindow_0, ErrorMessageWindow_1);
function ErrorMessageWindow$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1537, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), ErrorMessageWindow$1_0);
_.onCloseClick_0 = function onCloseClick(event_0){
  $markForDestroy(this.this$0);
}
;
_.this$0 = null;
function getAlertNotificationResultIcon(status_0){
  !status_0 && (status_0 = ($clinit_ResultState() , UNKNOWN));
  switch (status_0.ordinal) {
    case 0:
      return getAvailabilityIcon(($clinit_Boolean() , $clinit_Boolean() , TRUE));
    case 2:
      return getAvailabilityIcon(($clinit_Boolean() , $clinit_Boolean() , FALSE));
    case 1:
      return 'subsystems/availability/availability_yellow_16.png';
    case 3:
      return '[skin]/actions/redo.png';
    case 4:
    default:return getAvailabilityIcon(null);
  }
}

function getAvailabilityGroupLargeIcon(groupAvailType){
  switch (groupAvailType.ordinal) {
    case 0:
      return 'subsystems/availability/availability_grey_24.png';
    case 2:
      return 'subsystems/availability/availability_red_24.png';
    case 3:
      return 'subsystems/availability/availability_yellow_24.png';
    case 4:
      return 'subsystems/availability/availability_orange_24.png';
    default:return 'subsystems/availability/availability_green_24.png';
  }
}

function getAvailabilityIcon(status_0){
  var availType;
  availType = !status_0?($clinit_AvailabilityType() , UNKNOWN_0):($clinit_Boolean() , TRUE) == status_0?($clinit_AvailabilityType() , UP):($clinit_AvailabilityType() , DOWN_0);
  return getAvailabilityIconFromAvailTypeAndSize(availType, false);
}

function getAvailabilityIconFromAvailTypeAndSize(availType, isLarge){
  var color;
  !availType && (availType = ($clinit_AvailabilityType() , UNKNOWN_0));
  color = null;
  switch (availType.ordinal) {
    case 1:
      color = 'green';
      break;
    case 0:
      color = 'red';
      break;
    case 3:
      color = 'orange';
      break;
    case 2:
      color = 'grey';
  }
  return 'subsystems/availability/availability_' + color + '_' + (isLarge?'24':'16') + '.png';
}

function getAvailabilityLargeIcon(status_0){
  var availType;
  availType = !status_0?($clinit_AvailabilityType() , UNKNOWN_0):($clinit_Boolean() , TRUE) == status_0?($clinit_AvailabilityType() , UP):($clinit_AvailabilityType() , DOWN_0);
  return getAvailabilityIconFromAvailTypeAndSize(availType, true);
}

function getClusteredResourceIcon(category){
  var categoryName;
  categoryName = null;
  switch (category.ordinal) {
    case 0:
      {
        categoryName = 'Platform';
        break;
      }

    case 1:
      {
        categoryName = 'Server';
        break;
      }

    case 2:
      {
        categoryName = 'Service';
        break;
      }

  }
  return 'resources/' + categoryName + '_Group_16.png';
}

function getDriftCategoryIcon(category){
  if (!category) {
    return 'subsystems/drift/Drift_new_16.png';
  }
  switch (category.ordinal) {
    case 0:
      return 'subsystems/drift/Drift_add_16.png';
    case 1:
      return 'subsystems/drift/Drift_change_16.png';
    case 2:
      return 'subsystems/drift/Drift_remove_16.png';
  }
  return null;
}

function getEventSeverityIcon(severity){
  var icon;
  icon = '';
  if (severity) {
    switch (severity.ordinal) {
      case 0:
        icon = '_debug';
        break;
      case 1:
        icon = '_info';
        break;
      case 2:
        icon = '_warning';
        break;
      case 3:
        icon = '_error';
        break;
      case 4:
        icon = '_fatal';
    }
  }
  return 'subsystems/event/Events' + icon + '_16.png';
}

function getGroupIcon(groupType){
  var category;
  category = groupType == ($clinit_GroupCategory() , COMPATIBLE)?'Cluster':'Group';
  return 'types/' + category + '_up_16.png';
}

function getGroupLargeIcon(groupType){
  var category;
  category = groupType == ($clinit_GroupCategory() , COMPATIBLE)?'Cluster':'Group';
  return 'types/' + category + '_up_24.png';
}

function getOperationResultsIcon(status_0){
  var icon;
  icon = '';
  if (status_0) {
    switch (status_0.ordinal) {
      case 0:
        icon = '_inprogress';
        break;
      case 1:
        icon = '_ok';
        break;
      case 2:
        icon = '_failed';
        break;
      case 3:
        icon = '_cancel';
    }
  }
  return 'subsystems/control/Operation' + icon + '_16.png';
}

function getPluginConfigurationIcon(updateStatus){
  if (updateStatus) {
    switch (updateStatus.ordinal) {
      case 1:
        {
          return 'subsystems/inventory/Connection_ok_16.png';
        }

      case 2:
        {
          return 'subsystems/inventory/Connection_failed_16.png';
        }

      case 0:
        {
          return 'subsystems/inventory/Connection_inprogress_16.png';
        }

      case 3:
        return 'subsystems/inventory/Connection_16.png';
    }
  }
  return 'subsystems/inventory/Connection_16.png';
}

function getResourceConfigurationIcon(updateStatus){
  if (updateStatus) {
    switch (updateStatus.ordinal) {
      case 1:
        {
          return 'subsystems/configure/Configure_ok_16.png';
        }

      case 2:
        {
          return 'subsystems/configure/Configure_failed_16.png';
        }

      case 0:
        {
          return 'subsystems/configure/Configure_inprogress_16.png';
        }

      case 3:
        return 'subsystems/configure/Configure_16.png';
    }
  }
  return 'subsystems/configure/Configure_16.png';
}

function getAlertDetailLink(entityContext, alertId){
  var baseLink, link;
  baseLink = getEntityTabLink(entityContext, 'Alerts', 'History');
  link = baseLink + '/' + alertId;
  return link;
}

function getAutoClusterTabLink(autoClusterGroupId, tabName, subTabName){
  return '#ResourceGroup/AutoCluster/' + autoClusterGroupId + '/' + tabName + (null == subTabName?'':'/' + subTabName);
}

function getAutoGroupTabLink(autoGroupId, tabName, subTabName){
  return '#Resource/AutoGroup/' + autoGroupId + '/' + tabName + (null == subTabName?'':'/' + subTabName);
}

function getBundleDestinationLink(bundleId, bundleDestinationId){
  return '#Bundles/Bundle/' + bundleId + '/destinations' + (bundleDestinationId == 0?'':'/' + bundleDestinationId);
}

function getBundleVersionLink(bundleId, bundleVersionId){
  return '#Bundles/Bundle/' + bundleId + '/versions' + (bundleVersionId == 0?'':'/' + bundleVersionId);
}

function getDriftCarouselDriftLink(resourceId, driftDefId, driftId){
  driftId.indexOf('0id_') == 0 || (driftId = '0id_' + driftId);
  return '#Resource/' + resourceId + '/Drift/Definitions/' + driftDefId + '/Drift/' + driftId;
}

function getEntityTabLink(entityContext, tabName, subTabName){
  var link;
  switch (entityContext.type_0.ordinal) {
    case 0:
      link = getResourceTabLink(entityContext.resourceId, tabName, subTabName);
      break;
    case 2:
      ($clinit_EntityContext$Type() , ResourceGroup) == entityContext.type_0 && entityContext.isAutoGroup?(link = getAutoGroupTabLink(entityContext.groupId, tabName, subTabName)):ResourceGroup == entityContext.type_0 && entityContext.isAutoCluster?(link = getAutoClusterTabLink(entityContext.groupId, tabName, subTabName)):(link = getResourceGroupTabLink(entityContext.groupId, tabName, subTabName));
      break;
    case 4:
      if ($equals_6(tabName, 'Alerts') && $equals_6(subTabName, 'Definitions')) {
        link = '#Reports/Subsystems/AlertDefinitions';
      }
       else if ($equals_6(tabName, 'Alerts') && $equals_6(subTabName, 'History')) {
        link = '#Reports/Subsystems/RecentAlerts';
      }
       else if ($equals_6(tabName, 'Operations') && $equals_6(subTabName, 'History')) {
        link = '#Reports/Subsystems/RecentOperations';
      }
       else if ($equals_6(tabName, 'Configuration') && $equals_6(subTabName, 'History')) {
        link = '#Reports/Subsystems/ConfigurationHistoryView';
      }
       else {
        throw new IllegalArgumentException_1('Subsystem link not supported for tab ' + tabName + '>' + subTabName + '.');
      }

      break;
    default:throw new IllegalArgumentException_1('Unsupported entity context type: ' + entityContext.type_0);
  }
  return link;
}

function getGroupOperationHistoryLink(group, groupOperationHistoryId){
  return getEntityTabLink(forGroup_0(group), 'Operations', 'History') + '/' + groupOperationHistoryId;
}

function getGroupPluginConfigurationUpdateHistoryLink(group, groupUpdateHistoryId){
  return groupUpdateHistoryId?getEntityTabLink(group, 'Inventory', 'ConnectionSettingsHistory') + '/' + groupUpdateHistoryId:getEntityTabLink(group, 'Inventory', 'ConnectionSettingsHistory');
}

function getGroupResourceConfigurationUpdateHistoryLink(group, groupUpdateHistoryId){
  return groupUpdateHistoryId?getEntityTabLink(group, 'Configuration', 'History') + '/' + groupUpdateHistoryId:getEntityTabLink(group, 'Configuration', 'History');
}

function getHref(url, value){
  var result;
  result = '<a href="' + url + '">' + value + '<\/a>';
  return result;
}

function getResourceGroupTabLink(resourceGroupId, tabName, subTabName){
  return '#ResourceGroup/' + resourceGroupId + '/' + tabName + (null == subTabName?'':'/' + subTabName);
}

function getResourceTabLink(resourceId, tabName, subTabName){
  return '#Resource/' + resourceId + '/' + tabName + (null == subTabName?'':'/' + subTabName);
}

function getSubsystemAlertDefinitionLink(resourceId, alertDefinitionId){
  var link;
  link = '#Resource/' + resourceId + '/Alerts/Definitions/' + alertDefinitionId;
  return link;
}

function getTagLink(tag){
  return tag == null?'#Reports/Subsystems/Tags':'#Reports/Subsystems/Tags/' + tag;
}

function $getString_0(this$static, arg0){
  var target;
  target = dynamicCast(this$static.cache.get_2(arg0), Q$String);
  if (target != null) {
    return target;
  }
  if ($equals_6(arg0, 'view_help_section_1_item_count')) {
    this$static.cache.put('view_help_section_1_item_count', '3');
    return '3';
  }
  if ($equals_6(arg0, 'view_help_section_1_propTitle_1')) {
    this$static.cache.put('view_help_section_1_propTitle_1', 'Frequently Asked Questions (FAQ) ');
    return 'Frequently Asked Questions (FAQ) ';
  }
  if ($equals_6(arg0, 'view_help_section_1_propTitle_2')) {
    this$static.cache.put('view_help_section_1_propTitle_2', 'Documentation Set ');
    return 'Documentation Set ';
  }
  if ($equals_6(arg0, 'view_help_section_1_propTitle_3')) {
    this$static.cache.put('view_help_section_1_propTitle_3', 'API Javadoc ');
    return 'API Javadoc ';
  }
  if ($equals_6(arg0, 'view_help_section_1_propUrl_1')) {
    this$static.cache.put('view_help_section_1_propUrl_1', 'https://docs.jboss.org/author/display/RHQ/FAQ');
    return 'https://docs.jboss.org/author/display/RHQ/FAQ';
  }
  if ($equals_6(arg0, 'view_help_section_1_propUrl_2')) {
    this$static.cache.put('view_help_section_1_propUrl_2', 'https://docs.jboss.org/author/display/RHQ/User+Documentation');
    return 'https://docs.jboss.org/author/display/RHQ/User+Documentation';
  }
  if ($equals_6(arg0, 'view_help_section_1_propUrl_3')) {
    this$static.cache.put('view_help_section_1_propUrl_3', 'https://docs.jboss.org/author/display/RHQ/API+Documentation');
    return 'https://docs.jboss.org/author/display/RHQ/API+Documentation';
  }
  if ($equals_6(arg0, 'view_help_section_1_title')) {
    this$static.cache.put('view_help_section_1_title', 'Documentation');
    return 'Documentation';
  }
  if ($equals_6(arg0, 'view_help_section_2_item_count')) {
    this$static.cache.put('view_help_section_2_item_count', '4');
    return '4';
  }
  if ($equals_6(arg0, 'view_help_section_2_propIcon_3')) {
    this$static.cache.put('view_help_section_2_propIcon_3', '[SKIN]/../actions/help.png');
    return '[SKIN]/../actions/help.png';
  }
  if ($equals_6(arg0, 'view_help_section_2_propIcon_4')) {
    this$static.cache.put('view_help_section_2_propIcon_4', '[SKIN]/../actions/help.png');
    return '[SKIN]/../actions/help.png';
  }
  if ($equals_6(arg0, 'view_help_section_2_propTitle_1')) {
    this$static.cache.put('view_help_section_2_propTitle_1', 'Demo: All Demos ');
    return 'Demo: All Demos ';
  }
  if ($equals_6(arg0, 'view_help_section_2_propTitle_2')) {
    this$static.cache.put('view_help_section_2_propTitle_2', 'Demo: Bundle Provisioning ');
    return 'Demo: Bundle Provisioning ';
  }
  if ($equals_6(arg0, 'view_help_section_2_propTitle_3')) {
    this$static.cache.put('view_help_section_2_propTitle_3', 'How to build Group Definitions ');
    return 'How to build Group Definitions ';
  }
  if ($equals_6(arg0, 'view_help_section_2_propTitle_4')) {
    this$static.cache.put('view_help_section_2_propTitle_4', 'How to use the Search Bar ');
    return 'How to use the Search Bar ';
  }
  if ($equals_6(arg0, 'view_help_section_2_propUrl_1')) {
    this$static.cache.put('view_help_section_2_propUrl_1', 'https://docs.jboss.org/author/display/RHQ/Demos');
    return 'https://docs.jboss.org/author/display/RHQ/Demos';
  }
  if ($equals_6(arg0, 'view_help_section_2_propUrl_2')) {
    this$static.cache.put('view_help_section_2_propUrl_2', 'http://management-platform.blogspot.com/2011/01/bundle-provisioning-via-rhq.html ');
    return 'http://management-platform.blogspot.com/2011/01/bundle-provisioning-via-rhq.html ';
  }
  if ($equals_6(arg0, 'view_help_section_2_propUrl_3')) {
    this$static.cache.put('view_help_section_2_propUrl_3', 'https://docs.jboss.org/author/display/RHQ/Group+Definitions');
    return 'https://docs.jboss.org/author/display/RHQ/Group+Definitions';
  }
  if ($equals_6(arg0, 'view_help_section_2_propUrl_4')) {
    this$static.cache.put('view_help_section_2_propUrl_4', 'https://docs.jboss.org/author/display/RHQ/Search');
    return 'https://docs.jboss.org/author/display/RHQ/Search';
  }
  if ($equals_6(arg0, 'view_help_section_2_title')) {
    this$static.cache.put('view_help_section_2_title', 'Tutorial');
    return 'Tutorial';
  }
  if ($equals_6(arg0, 'view_help_section_count')) {
    this$static.cache.put('view_help_section_count', '2');
    return '2';
  }
  throw new MissingResourceException_0("Cannot find constant '" + arg0 + "'; expecting a method name");
}

function $view_adminRoles_permissions_illegalDeselectionDueToCorrespondingWritePermSelection(arg0){
  return arg0 + ' read permission cannot be deselected, unless the ' + arg0 + ' write permission, which implies the read permission, is deselected first.';
}

function $view_admin_downloads_connectors_help(arg0){
  return 'Connectors are software that is needed in order for some products to be manageable by ' + arg0 + '. You install connectors into some managed products so ' + arg0 + ' agents can talk to them. See the documentation for more information.';
}

function $view_admin_landing(arg0){
  return 'From this section, the ' + arg0 + ' global settings can be administered. This includes configuring security, setting up plugins, and managing ' + arg0 + ' Servers and Agents.';
}

function $clinit_PermissionsLoader(){
  $clinit_PermissionsLoader = nullMethod;
  $clinit_CoreGUI();
}

function $loadExplicitGlobalPermissions(callback){
  $getExplicitGlobalPermissions(dynamicCast(secure(getInstance_34(), -1), Q$AuthorizationGWTServiceAsync), new PermissionsLoader$1_0(callback));
}

function $processFailure(msg, caught){
  var options, severity;
  options = of(($clinit_Message$Option() , BackgroundJobResult));
  severity = ($clinit_Message$Severity() , Error_2);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_5(msg, caught, severity, options));
}

function $onSuccess_2(this$static, result){
  this$static.val$callback.onPermissionsLoaded(result);
}

function PermissionsLoader$1_0(val$callback){
  this.val$callback = val$callback;
}

defineSeed(1558, 1, {}, PermissionsLoader$1_0);
_.onFailure = function onFailure_3(caught){
  $processFailure(($clinit_PermissionsLoader() , 'Failed to load your global permissions - none granted.'), caught);
  this.val$callback.onPermissionsLoaded(null);
}
;
_.onSuccess_0 = function onSuccess_3(result){
  $onSuccess_2(this, dynamicCast(result, Q$Set));
}
;
_.val$callback = null;
function PopupWindow_0(canvas){
  $clinit_BaseWidget();
  Window_1.call(this);
  $setTitle(this, ($clinit_CoreGUI() , 'Details'));
  $setShowMinimizeButton(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowMaximizeButton(this, TRUE);
  $setIsModal(this, TRUE);
  $setShowModalMask(this, TRUE);
  $isCreated_1(this)?$setProperty_0(this, 'width', 600):(this.config_0['width'] = 600 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'height', 400):(this.config_0['height'] = 400 , undefined);
  $setAutoCenter(this, TRUE);
  $setShowResizer(this, TRUE);
  $setCanDragResize_0(this, TRUE);
  $centerInPage(this);
  $addCloseClickHandler(this, new PopupWindow$1_0(this));
  !!canvas && $addItem(this, canvas);
}

defineSeed(1559, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), PopupWindow_0);
function PopupWindow$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1560, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), PopupWindow$1_0);
_.onCloseClick_0 = function onCloseClick_0(event_0){
  $markForDestroy(this.this$0);
}
;
_.this$0 = null;
function ViewChangedException_1(obsoleteView){
  $fillInStackTrace(this);
  this.obsoleteView = obsoleteView != null?obsoleteView:'?';
}

defineSeed(1576, 6, makeCastMap([Q$Serializable, Q$Exception, Q$RuntimeException, Q$Throwable, Q$ViewChangedException]), ViewChangedException_1);
function $getCurrent(this$static){
  return this$static.index_0 >= this$static.viewPath.size_0?null:dynamicCast($get_0(this$static.viewPath, this$static.index_0), Q$ViewId);
}

function $getCurrentAsInt(this$static){
  return __parseAndValidateInt((this$static.index_0 >= this$static.viewPath.size_0?null:dynamicCast($get_0(this$static.viewPath, this$static.index_0), Q$ViewId)).path);
}

function $getNext(this$static){
  return dynamicCast($get_0(this$static.viewPath, this$static.index_0 + 1), Q$ViewId);
}

function $getParentViewPath(this$static){
  return $getPathToIndex(this$static, this$static.index_0 - 1);
}

function $getPathToCurrent(this$static){
  return $getPathToIndex(this$static, this$static.index_0);
}

function $getPathToIndex(this$static, endIndex){
  var i, path;
  path = '';
  for (i = 0; i < endIndex; ++i) {
    i > 0 && (path += '/');
    path += dynamicCast($get_0(this$static.viewPath, i), Q$ViewId).path;
  }
  return path;
}

function $getViewForIndex(this$static, index){
  return dynamicCast($get_0(this$static.viewPath, index), Q$ViewId);
}

function $isCurrent(this$static, providedViewId){
  return !(this$static.viewPath.size_0 <= this$static.index_0 || !providedViewId || !$equals_43(this$static.index_0 >= this$static.viewPath.size_0?null:dynamicCast($get_0(this$static.viewPath, this$static.index_0), Q$ViewId), providedViewId));
}

function $isEnd(this$static){
  return this$static.viewPath.size_0 <= this$static.index_0;
}

function $isNext(this$static, providedViewId){
  return this$static.index_0 + 1 < this$static.viewPath.size_0 && !!providedViewId && $equals_43(dynamicCast($get_0(this$static.viewPath, this$static.index_0 + 1), Q$ViewId), providedViewId);
}

function $addSection_0(this$static, treeGrid){
  var section, sectionName, sectionTitle;
  sectionName = $getAttributeAsString(getOrCreateRef_14($getAttributeAsJavaScriptObject_2(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(treeGrid, 'data')))), 'name');
  sectionTitle = $getAttributeAsString(getOrCreateRef_14($getAttributeAsJavaScriptObject_2(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(treeGrid, 'data')))), 'title');
  $put_1(this$static.treeGrids, sectionName, treeGrid);
  $addCellClickHandler(treeGrid, new AbstractSectionedLeftNavigationView$2_0(this$static, treeGrid, sectionName));
  section = new SectionStackSection_1(sectionTitle);
  $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $addItemJS(section, $getOrCreateJsObj_0(treeGrid));
  $addSection(this$static.sectionStack, section);
}

function $buildTreeGridForSection(navigationSection){
  var i, item, navigationItems, navigationItemsSize, rootNode, tree, treeGrid, treeNode, treeNodes;
  treeGrid = new TreeGrid_0;
  $setLeaveScrollbarGap(treeGrid, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowHeader_0(treeGrid, FALSE);
  $setAttribute_24(treeGrid, 'selectionType', ($clinit_SelectionStyle() , SINGLE).value_0, true);
  navigationItems = navigationSection.navigationItems;
  treeNodes = initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, navigationItems.array.length, 0);
  for (i = 0 , navigationItemsSize = navigationItems.array.length; i < navigationItemsSize; ++i) {
    item = dynamicCast((checkIndex(i, navigationItems.array.length) , navigationItems.array[i]), Q$NavigationItem);
    treeNode = new EnhancedTreeNode_1(item.viewName.name_0, item.viewName.title_0, initValues(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, []));
    $setAttribute_13(treeNode, 'icon', item.icon_0);
    $setAttribute_8(treeNode, 'enabled', item.enabled?TRUE:FALSE);
    setCheck(treeNodes, i, treeNode);
  }
  rootNode = new EnhancedTreeNode_1(navigationSection.viewName.name_0, navigationSection.viewName.title_0, treeNodes);
  tree = new Tree_0;
  $setAttribute(tree, rootNode.jsObj);
  $setAttribute_20(treeGrid, 'data', !tree?null:$getOrCreateJsObj(tree), true);
  return treeGrid;
}

function $decorateWithTitleBar(viewName, pageBody){
  var iconPath, vLayout;
  vLayout = new EnhancedVLayout_0;
  $isCreated_1(vLayout)?$setProperty_3(vLayout, 'width', '100%'):(vLayout.config_0['width'] = '100%' , undefined);
  $isCreated_1(vLayout)?$setProperty_3(vLayout, 'height', '100%'):(vLayout.config_0['height'] = '100%' , undefined);
  iconPath = viewName.icon_0.icon24x24Path != null?viewName.icon_0.icon24x24Path:viewName.icon_0.icon16x16Path;
  $addMember(vLayout, new TitleBar_1(viewName.title_0, iconPath));
  $addMember(vLayout, pageBody);
  return vLayout;
}

function $destroyCurrentContent(this$static){
  var children;
  if (this$static.contentCanvas) {
    while ((children = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.contentCanvas, 'children'))).length > 0) {
      children[0].destroy_0();
    }
  }
}

function $initSectionPageTreeGrids(this$static){
  var name_0, name$iterator, treeGrid;
  for (name$iterator = $iterator($keySet(this$static.treeGrids)); name$iterator.val$outerIter.hasNext();) {
    name_0 = dynamicCast($next_1(name$iterator), Q$String);
    treeGrid = dynamicCast($get_4(this$static.treeGrids, name_0), Q$TreeGrid);
    $deselectAllRecords(treeGrid);
    this$static.currentSectionViewId = null;
    this$static.currentPageViewId = null;
  }
}

function $onInit_0(this$static){
  $onInit(this$static);
  $onInit_Layout(this$static);
  $isCreated_1(this$static)?$setProperty_3(this$static, 'width', '100%'):(this$static.config_0['width'] = '100%' , undefined);
  $isCreated_1(this$static)?$setProperty_3(this$static, 'height', '100%'):(this$static.config_0['height'] = '100%' , undefined);
  this$static.contentCanvas = new Canvas_1;
  $setWidth_0(this$static.contentCanvas, '*');
  $setAttribute_24(this$static.contentCanvas, 'height', '100%', true);
  this$static.sectionStack = new SectionStack_0;
  $setShowResizeBar(this$static.sectionStack, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_24(this$static.sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
  $setWidth(this$static.sectionStack, 250);
  $setAttribute_24(this$static.sectionStack, 'height', '100%', true);
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new AbstractSectionedLeftNavigationView$1_0(this$static)));
}

function $renderContentView(this$static, viewPath){
  var content_0, item, pageName, section, sectionName, viewFactory;
  this$static.currentSectionViewId = viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId);
  this$static.currentPageViewId = dynamicCast($get_0(viewPath.viewPath, viewPath.index_0 + 1), Q$ViewId);
  sectionName = this$static.currentSectionViewId.path;
  pageName = this$static.currentPageViewId.path;
  section = dynamicCast(this$static.sectionsByName.get_2(sectionName), Q$NavigationSection);
  if (!section) {
    throw new IllegalStateException_1('Invalid section: ' + sectionName);
  }
  item = dynamicCast($get_4(section.navigationItemsByName, pageName), Q$NavigationItem);
  if (!item) {
    throw new IllegalStateException_1('Invalid page: ' + pageName);
  }
  item.refreshRequired && (this$static.currentPageViewId = null);
  $selectSectionPageTreeGridNode(this$static, sectionName, pageName);
  viewFactory = item.viewFactory;
  if (viewFactory) {
    $destroyCurrentContent(this$static);
    content_0 = viewFactory.createView();
    if (content_0) {
      $setContent(this$static, content_0);
      instanceOf(content_0, Q$BookmarkableView) && dynamicCast(content_0, Q$BookmarkableView).renderView($next_6((++viewPath.index_0 , viewPath)));
    }
  }
}

function $selectSectionPageTreeGridNode(this$static, sectionName, pageName){
  var name_0, name$iterator, node, tree, treeGrid, self_0, nodeJS, self_1;
  for (name$iterator = $iterator($keySet(this$static.treeGrids)); name$iterator.val$outerIter.hasNext();) {
    name_0 = dynamicCast($next_1(name$iterator), Q$String);
    treeGrid = dynamicCast($get_4(this$static.treeGrids, name_0), Q$TreeGrid);
    if ($equals_6(name_0, sectionName)) {
      tree = getOrCreateRef_13($getAttributeAsJavaScriptObject_1(treeGrid, 'data'));
      node = (self_0 = tree.getOrCreateJsObj() , nodeJS = self_0.find(sectionName + '/' + pageName) , nodeJS == null?null:getOrCreateRef_14(nodeJS));
      node?(self_1 = treeGrid.getOrCreateJsObj() , self_1.selectSingleRecord(node.getJsObj()) , undefined):$handleError_0(($clinit_CoreGUI() , 'Unknown page name [' + ($clinit_Enhanced() , pageName) + '] for section [' + sectionName + '] - URL is invalid.'), null);
    }
     else {
      $deselectAllRecords(treeGrid);
    }
  }
}

function $setContent(this$static, newContent){
  var decoratedContent;
  if (instanceOf(newContent, Q$HasViewName)) {
    decoratedContent = $decorateWithTitleBar(dynamicCast(newContent, Q$HasViewName).getViewName(), newContent);
    $addChild(this$static.contentCanvas, decoratedContent);
  }
   else {
    $addChild(this$static.contentCanvas, newContent);
  }
  this$static.contentCanvas.markForRedraw_0();
  this$static.currentContent = newContent;
}

function AbstractSectionedLeftNavigationView_0(viewId){
  $clinit_BaseWidget();
  EnhancedHLayout_0.call(this);
  this.treeGrids = new LinkedHashMap_0;
  this.globalPermissions_0 = noneOf(Lorg_rhq_core_domain_authz_Permission_2_classLit);
  this.viewId = viewId;
}

defineSeed(1581, 1539, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$Enhanced, Q$EnhancedHLayout]));
_.isInitialized_0 = function isInitialized(){
  return this.initialized;
}
;
_.onInit = function onInit_7(){
  $onInit_0(this);
}
;
_.renderView = function renderView_0(viewPath){
  if (!$isCurrent(viewPath, this.currentSectionViewId) || !$isNext(viewPath, this.currentPageViewId)) {
    if (viewPath.viewPath.size_0 <= viewPath.index_0) {
      $destroyCurrentContent(this);
      $setContent(this, this.defaultView());
      $initSectionPageTreeGrids(this);
    }
     else {
      $renderContentView(this, viewPath);
    }
  }
   else {
    if (instanceOf(this.currentContent, Q$BookmarkableView)) {
      dynamicCast(this.currentContent, Q$BookmarkableView).renderView($next_6((++viewPath.index_0 , viewPath)));
    }
     else if (instanceOf(this.currentContent, Q$RefreshableView) && $isDrawn(this.currentContent).value_0) {
      debug('Refreshing data for [' + this.currentContent.___clazz$.typeName + ']...');
      dynamicCast(this.currentContent, Q$RefreshableView).refresh_0();
    }
  }
}
;
_.contentCanvas = null;
_.currentContent = null;
_.currentPageViewId = null;
_.currentSectionViewId = null;
_.initialized = false;
_.sectionStack = null;
_.sectionsByName = null;
_.viewId = null;
function AdministrationView_0(){
  $clinit_AdministrationView();
  AbstractSectionedLeftNavigationView_0.call(this, VIEW_ID.name_0);
}

defineSeed(1580, 1581, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$Enhanced, Q$EnhancedHLayout]), AdministrationView_0);
_.defaultView = function defaultView(){
  var vLayout, titleBar, productInfo, label;
  return vLayout = new EnhancedVLayout_0 , $isCreated_1(vLayout)?$setProperty_3(vLayout, 'width', '100%'):(vLayout.config_0['width'] = '100%' , undefined) , titleBar = new TitleBar_1(($clinit_Enhanced() , 'Administration'), ($clinit_IconEnum() , ADMIN).icon24x24Path) , $addMember(vLayout, titleBar) , productInfo = ($clinit_CoreGUI() , $clinit_CoreGUI() , coreGUI).productInfo , label = new Label_4($view_admin_landing(productInfo.shortName)) , $setPadding(label, valueOf_44(10)) , $addMember(vLayout, label) , vLayout;
}
;
_.getNavigationSections = function getNavigationSections(){
  var configurationSection, contentSection, sections, securitySection, topologySection, usersItem, rolesItem, productInfo, isRHQ, remoteAgentInstallItem, serversItem, agentsItem, affinityGroupsItem, partitionEventsItem, navigationItems, systemSettingsItem, alertTemplatesItem, driftTemplatesItem, metricTemplatesItem, ignoreResourceTypesItem, downloadsItem, agentPluginsItem, serverPluginsItem, contentSourcesItem, reposItem;
  sections = new ArrayList_0;
  securitySection = (usersItem = new NavigationItem_2(($clinit_UsersView() , VIEW_ID_14), new AdministrationView$1_0(this)) , rolesItem = new NavigationItem_2(($clinit_RolesView() , VIEW_ID_5), new AdministrationView$2_0(this)) , new NavigationSection_0(SECTION_SECURITY_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [usersItem, rolesItem])));
  setCheck(sections.array, sections.size_0++, securitySection);
  topologySection = (productInfo = ($clinit_CoreGUI() , $clinit_CoreGUI() , coreGUI).productInfo , isRHQ = !!productInfo && $equals_6('RHQ', productInfo.shortName) , remoteAgentInstallItem = new NavigationItem_3(($clinit_RemoteAgentInstallView() , VIEW_ID_4), new AdministrationView$3_0, this.globalPermissions_0.contains_0(($clinit_Permission() , MANAGE_SETTINGS))) , serversItem = new NavigationItem_3(($clinit_ServerTableView() , VIEW_ID_13), new AdministrationView$4_0, this.globalPermissions_0.contains_0(MANAGE_SETTINGS)) , agentsItem = new NavigationItem_3(($clinit_AgentTableView() , VIEW_ID_11), new AdministrationView$5_0, this.globalPermissions_0.contains_0(MANAGE_SETTINGS)) , affinityGroupsItem = new NavigationItem_3(($clinit_AffinityGroupTableView() , VIEW_ID_10), new AdministrationView$6_0, this.globalPermissions_0.contains_0(MANAGE_SETTINGS)) , partitionEventsItem = new NavigationItem_3(($clinit_PartitionEventTableView() , VIEW_ID_12), new AdministrationView$7_0, this.globalPermissions_0.contains_0(MANAGE_SETTINGS)) , navigationItems = new ArrayList_2(new Arrays$ArrayList_0(initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [serversItem, agentsItem, affinityGroupsItem, partitionEventsItem]))) , isRHQ && (setCheck(navigationItems.array, navigationItems.size_0++, remoteAgentInstallItem) , true) , new NavigationSection_0(SECTION_TOPOLOGY_VIEW_ID, dynamicCast($toArray_1(navigationItems, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [])), Q$NavigationItem_$1)));
  setCheck(sections.array, sections.size_0++, topologySection);
  configurationSection = (systemSettingsItem = new NavigationItem_3(($clinit_SystemSettingsView() , VIEW_ID_3), new AdministrationView$8_0, this.globalPermissions_0.contains_0(MANAGE_SETTINGS)) , systemSettingsItem.refreshRequired = true , alertTemplatesItem = new NavigationItem_2(($clinit_AlertDefinitionTemplateTypeView() , VIEW_ID_6), new AdministrationView$9_0) , alertTemplatesItem.refreshRequired = true , driftTemplatesItem = new NavigationItem_2(($clinit_DriftDefinitionTemplateTypeView() , VIEW_ID_7), new AdministrationView$10_0) , driftTemplatesItem.refreshRequired = true , metricTemplatesItem = new NavigationItem_2(($clinit_MetricTemplateTypeView() , VIEW_ID_9), new AdministrationView$11_0) , metricTemplatesItem.refreshRequired = true , ignoreResourceTypesItem = new NavigationItem_2(($clinit_IgnoreResourceTypesView() , VIEW_ID_8), new AdministrationView$12_0) , ignoreResourceTypesItem.refreshRequired = true , downloadsItem = new NavigationItem_2(($clinit_DownloadsView() , VIEW_ID_1), new AdministrationView$13_0) , agentPluginsItem = new NavigationItem_3(($clinit_AgentPluginTableView() , VIEW_ID_0), new AdministrationView$14_0, this.globalPermissions_0.contains_0(MANAGE_SETTINGS)) , serverPluginsItem = new NavigationItem_3(($clinit_ServerPluginTableView() , VIEW_ID_2), new AdministrationView$15_0, this.globalPermissions_0.contains_0(MANAGE_SETTINGS)) , new NavigationSection_0(SECTION_CONFIGURATION_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [systemSettingsItem, alertTemplatesItem, driftTemplatesItem, metricTemplatesItem, ignoreResourceTypesItem, downloadsItem, agentPluginsItem, serverPluginsItem])));
  setCheck(sections.array, sections.size_0++, configurationSection);
  contentSection = (contentSourcesItem = new NavigationItem_3(PAGE_CONTENT_SOURCES_VIEW_ID, new AdministrationView$16_0, this.globalPermissions_0.contains_0(MANAGE_REPOSITORIES)) , reposItem = new NavigationItem_2(PAGE_REPOS_VIEW_ID, new AdministrationView$17_0) , new NavigationSection_0(SECTION_CONTENT_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [contentSourcesItem, reposItem])));
  setCheck(sections.array, sections.size_0++, contentSection);
  return sections;
}
;
function AdministrationView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1582, 1, {}, AdministrationView$1_0);
_.createView = function createView(){
  return new UsersView_0(this.this$0.globalPermissions_0.contains_0(($clinit_Permission() , MANAGE_SECURITY)));
}
;
_.this$0 = null;
function AdministrationView$10_0(){
}

defineSeed(1583, 1, {}, AdministrationView$10_0);
_.createView = function createView_0(){
  return new DriftDefinitionTemplateTypeView_0;
}
;
function AdministrationView$11_0(){
}

defineSeed(1584, 1, {}, AdministrationView$11_0);
_.createView = function createView_1(){
  return new MetricTemplateTypeView_0;
}
;
function AdministrationView$12_0(){
}

defineSeed(1585, 1, {}, AdministrationView$12_0);
_.createView = function createView_2(){
  return new IgnoreResourceTypesView_0;
}
;
function AdministrationView$13_0(){
}

defineSeed(1586, 1, {}, AdministrationView$13_0);
_.createView = function createView_3(){
  return new DownloadsView_0;
}
;
function AdministrationView$14_0(){
}

defineSeed(1587, 1, {}, AdministrationView$14_0);
_.createView = function createView_4(){
  return new AgentPluginTableView_0;
}
;
function AdministrationView$15_0(){
}

defineSeed(1588, 1, {}, AdministrationView$15_0);
_.createView = function createView_5(){
  return new ServerPluginTableView_0;
}
;
function AdministrationView$16_0(){
}

defineSeed(1589, 1, {}, AdministrationView$16_0);
_.createView = function createView_6(){
  return new FullHTMLPane_0('/rhq/content/listContentProviders-plain.xhtml');
}
;
function AdministrationView$17_0(){
}

defineSeed(1590, 1, {}, AdministrationView$17_0);
_.createView = function createView_7(){
  return new FullHTMLPane_0('/rhq/content/listRepos-plain.xhtml');
}
;
function AdministrationView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1591, 1, {}, AdministrationView$2_0);
_.createView = function createView_8(){
  return new RolesView_0(this.this$0.globalPermissions_0.contains_0(($clinit_Permission() , MANAGE_SECURITY)));
}
;
_.this$0 = null;
function AdministrationView$3_0(){
}

defineSeed(1592, 1, {}, AdministrationView$3_0);
_.createView = function createView_9(){
  return new RemoteAgentInstallView_0;
}
;
function AdministrationView$4_0(){
}

defineSeed(1593, 1, {}, AdministrationView$4_0);
_.createView = function createView_10(){
  return new ServerTableView_0(null, false);
}
;
function AdministrationView$5_0(){
}

defineSeed(1594, 1, {}, AdministrationView$5_0);
_.createView = function createView_11(){
  return new AgentTableView_0(null, false);
}
;
function AdministrationView$6_0(){
}

defineSeed(1595, 1, {}, AdministrationView$6_0);
_.createView = function createView_12(){
  return new AffinityGroupTableView_0;
}
;
function AdministrationView$7_0(){
}

defineSeed(1596, 1, {}, AdministrationView$7_0);
_.createView = function createView_13(){
  return new PartitionEventTableView_0(($clinit_PartitionEventTableView() , VIEW_ID_12).title_0);
}
;
function AdministrationView$8_0(){
}

defineSeed(1597, 1, {}, AdministrationView$8_0);
_.createView = function createView_14(){
  return new SystemSettingsView_0;
}
;
function AdministrationView$9_0(){
}

defineSeed(1598, 1, {}, AdministrationView$9_0);
_.createView = function createView_15(){
  return new AlertDefinitionTemplateTypeView_0;
}
;
function EnhancedVLayout_1(){
  $clinit_BaseWidget();
  VLayout_1.call(this, 10);
}

defineSeed(1600, 445, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), EnhancedVLayout_1);
function $prepareDetailsSection(stack, plugin){
  var ampsItem, descItem, displayNameItem, enabledItem, form, img, kindItem, md5Item, mtimeItem, nameItem, pathItem, section, versionItem;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 4):(form.config_0['numCols'] = 4 , undefined);
  nameItem = new StaticTextItem_2('name', ($clinit_Enhanced() , 'Name'));
  $setValue_7(nameItem, plugin.name_0);
  displayNameItem = new StaticTextItem_2('displayName', 'Display Name');
  $setValue_7(displayNameItem, plugin.displayName);
  versionItem = new StaticTextItem_2('version', 'Version');
  $setValue_7(versionItem, plugin.version_0);
  md5Item = new StaticTextItem_2('MD5', 'MD5');
  $setValue_7(md5Item, plugin.md5);
  pathItem = new StaticTextItem_2('path', 'Path');
  $setValue_7(pathItem, plugin.path);
  ampsItem = new StaticTextItem_2('ampsVersion', 'AMPS Version');
  $setValue_7(ampsItem, plugin.ampsVersion);
  descItem = new StaticTextItem_2('desc', 'Description');
  $setValue_7(descItem, plugin.description);
  mtimeItem = new StaticTextItem_2('mtime', 'Last Updated');
  $setValue_7(mtimeItem, format_30(valueOf_45(plugin.mtime), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_MEDIUM)));
  kindItem = new StaticTextItem_2('kind', 'Kind');
  switch (plugin.deployment.ordinal) {
    case 0:
      $setValue_7(kindItem, 'Agent');
      break;
    case 1:
      $setValue_7(kindItem, 'Server');
  }
  enabledItem = new CanvasItem_2('enabled', 'Enabled?');
  img = new Img_2(getAvailabilityIcon(plugin.enabled?TRUE:FALSE), 16, 16);
  $setAttribute_28(enabledItem, 'canvas', !img?null:$getOrCreateJsObj_0(img));
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [displayNameItem, nameItem, versionItem, ampsItem, md5Item, kindItem, descItem, pathItem, mtimeItem, enabledItem]));
  section = new SectionStackSection_1('Details');
  $setExpanded(section, TRUE);
  $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form]));
  $addSection(stack, section);
  return;
}

function $prepareHelpSection(stack, plugin){
  var help, section;
  if (plugin.help != null && plugin.help.length > 0) {
    section = new SectionStackSection_1(($clinit_Enhanced() , 'Help'));
    $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    help = new Label_4(plugin.help);
    $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [help]));
    $addSection(stack, section);
  }
  return;
}

function AgentPluginDetailView_0(pluginId){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.pluginManager = dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync);
  this.pluginId = pluginId;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
}

defineSeed(1599, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), AgentPluginDetailView_0);
_.onDraw_0 = function onDraw_2(){
  var sectionStack;
  sectionStack = new SectionStack_0;
  $setAttribute_24(sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
  $isCreated_1(sectionStack)?$setProperty_3(sectionStack, 'width', '100%'):(sectionStack.config_0['width'] = '100%' , undefined);
  $isCreated_1(sectionStack)?$setProperty_3(sectionStack, 'height', '100%'):(sectionStack.config_0['height'] = '100%' , undefined);
  $setAttribute_24(sectionStack, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $getAgentPlugin(this.pluginManager, this.pluginId, new AgentPluginDetailView$1_0(sectionStack));
  $addMember(this, sectionStack);
}
;
_.pluginId = 0;
function $onSuccess_10(this$static, plugin){
  $prepareDetailsSection(this$static.val$sectionStack, plugin);
  $prepareHelpSection(this$static.val$sectionStack, plugin);
}

function AgentPluginDetailView$1_0(val$sectionStack){
  this.val$sectionStack = val$sectionStack;
}

defineSeed(1601, 1, {}, AgentPluginDetailView$1_0);
_.onFailure = function onFailure_10(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load plugin data'), caught);
}
;
_.onSuccess_0 = function onSuccess_10(plugin){
  $onSuccess_10(this, dynamicCast(plugin, Q$Plugin));
}
;
_.val$sectionStack = null;
function $addExtraWidget(this$static, widget, aboveFooter){
  aboveFooter?$add_3(this$static.extraWidgetsAboveFooter, widget):$add_3(this$static.extraWidgetsInMainFooter, widget);
}

function $deleteSelectedRecords(this$static){
  var deletedRecordNames, listGrid, selectedRecordCount;
  listGrid = this$static.listGrid;
  selectedRecordCount = $getSelectedRecords(listGrid).length;
  deletedRecordNames = new ArrayList_1(selectedRecordCount);
  $removeSelectedData(listGrid, new Table$8_0(this$static, deletedRecordNames, selectedRecordCount), null);
}

function $getDeletedMessage(numDeleted){
  var num, thing;
  num = '' + numDeleted;
  thing = 1 == numDeleted?($clinit_Enhanced() , 'item'):($clinit_Enhanced() , 'items');
  return ($clinit_Enhanced() , num) + ' ' + thing + ' deleted.';
}

function $setDataSource(this$static, dataSource){
  this$static.dataSource_1 = dataSource;
}

function $setHeaderIcon(this$static, headerIcon){
  this$static.headerIcons.size_0 > 0 && $clear_2(this$static.headerIcons);
  $add_3(this$static.headerIcons, headerIcon);
}

function $setListGridFields(this$static, forceIdField, fields){
  var dataSourceField, dataSourceFieldName, dataSourceFieldName$iterator, dataSourceFieldNames, dataSourceFieldNamesSet, dataSourceIdField, datasourceFieldTitle, destIndex, hideIdField, listGridField, listGridField$index, listGridField$max, listGridFieldTitle, listGridFieldsMap, listGridIdField, newFields;
  if (!this$static.getDataSource_0()) {
    throw new IllegalStateException_1('setListGridFields() called on ' + this$static.___clazz$.typeName + ', which is not a DataSource-backed Table.');
  }
  dataSourceFieldNames = $getFieldNames(this$static.getDataSource_0(), false);
  dataSourceFieldNamesSet = new LinkedHashSet_0;
  dataSourceFieldNamesSet.addAll(new Arrays$ArrayList_0(dataSourceFieldNames));
  listGridFieldsMap = new LinkedHashMap_0;
  for (listGridField$index = 0 , listGridField$max = fields.length; listGridField$index < listGridField$max; ++listGridField$index) {
    listGridField = fields[listGridField$index];
    $put_1(listGridFieldsMap, getAttribute(listGridField.jsObj, 'name'), listGridField);
  }
  $removeAll_0(dataSourceFieldNamesSet, $keySet(listGridFieldsMap));
  dataSourceIdField = $getField(this$static.getDataSource_0(), 'id');
  hideIdField = ($clinit_CoreGUI() , true) && !forceIdField;
  !!dataSourceIdField && hideIdField && $hideField(this$static.listGrid, 'id');
  listGridIdField = dynamicCast($get_4(listGridFieldsMap, 'id'), Q$ListGridField);
  !!listGridIdField && (listGridIdField.jsObj['showIf'] = hideIdField?'false':'true' , undefined);
  if (dataSourceFieldNamesSet.map.size_1() == 0) {
    $setAttribute_25(this$static.listGrid, 'fields', fields, true);
  }
   else {
    newFields = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.length + dataSourceFieldNamesSet.map.size_1(), 0);
    destIndex = 0;
    if (dataSourceFieldNamesSet.map.containsKey('id')) {
      datasourceFieldTitle = $getAttributeAsString($getField(this$static.getDataSource_0(), 'id'), 'title');
      listGridFieldTitle = datasourceFieldTitle != null?datasourceFieldTitle:($clinit_Enhanced() , 'ID');
      listGridIdField = new ListGridField_4('id', listGridFieldTitle, 55);
      $setAttribute_13(listGridIdField, 'type', ($clinit_ListGridFieldType() , INTEGER_0).value_0);
      $setAttribute_8(listGridIdField, 'canEdit', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
      listGridIdField.jsObj['showIf'] = hideIdField?'false':'true';
      setCheck(newFields, destIndex++, listGridIdField);
      dataSourceFieldNamesSet.map.remove_3('id') != null;
    }
    arraycopy(fields, 0, newFields, destIndex, fields.length);
    destIndex += fields.length;
    for (dataSourceFieldName$iterator = $iterator($keySet(dataSourceFieldNamesSet.map)); dataSourceFieldName$iterator.val$outerIter.hasNext();) {
      dataSourceFieldName = dynamicCast($next_1(dataSourceFieldName$iterator), Q$String);
      dataSourceField = $getField(this$static.getDataSource_0(), dataSourceFieldName);
      listGridField = new ListGridField_1(getAttribute(dataSourceField.jsObj, 'name'));
      $hideField(this$static.listGrid, dataSourceFieldName);
      listGridField.jsObj['showIf'] = 'false';
      setCheck(newFields, destIndex++, listGridField);
    }
    $setAttribute_25(this$static.listGrid, 'fields', newFields, true);
  }
}

function $setTableActionDisableOverride(this$static, disabled){
  this$static.tableActionDisableOverride = disabled;
  this$static.refreshTableInfo();
}

function $setTitleString(this$static, titleString){
  this$static.titleString = titleString;
  !!this$static.titleCanvas && $markForRedraw(this$static.titleCanvas);
}

function $updateTableAction(this$static, title, valueMap, tableAction){
  var info, info$iterator;
  if (title == null) {
    return;
  }
  for (info$iterator = new AbstractList$IteratorImpl_0(this$static.tableActions); info$iterator.i < info$iterator.this$0_0.size_1();) {
    info = dynamicCast($next_0(info$iterator), Q$Table$TableActionInfo);
    if ($equals_6(title, info.title_0)) {
      !!valueMap && (info.valueMap = valueMap);
      !!tableAction && (info.action = tableAction);
      this$static.initialized_0 && this$static.initialized && $drawFooter(this$static);
      break;
    }
  }
}

function Table_1(){
  $clinit_BaseWidget();
  Table_6.call(this, null, null, null, null, true);
}

function Table_2(tableTitle){
  $clinit_BaseWidget();
  Table_6.call(this, tableTitle, null, null, null, true);
}

function Table_3(tableTitle, criteria){
  $clinit_BaseWidget();
  Table_6.call(this, tableTitle, criteria, null, null, !criteria);
}

function Table_4(tableTitle, criteria, icon){
  Table_6.call(this, tableTitle, criteria, null, null, !criteria);
  this.titleIcon = icon;
}

function Table_5(tableTitle, criteria, sortSpecifiers, excludedFieldNames){
  $clinit_BaseWidget();
  Table_6.call(this, tableTitle, criteria, sortSpecifiers, excludedFieldNames, !criteria);
}

function Table_7(tableTitle, autoFetchData){
  $clinit_BaseWidget();
  Table_6.call(this, tableTitle, null, null, null, autoFetchData);
}

function Table_8(tableTitle, sortSpecifiers){
  $clinit_BaseWidget();
  Table_6.call(this, tableTitle, null, sortSpecifiers, null, true);
}

defineSeed(1605, 1539, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), Table_2);
_.getTitleFieldName = function getTitleFieldName(){
  return 'name';
}
;
function $buildDetailsView(this$static){
  var backButton, isEditable, verticalSpacer;
  $setAttribute_24(this$static.detailsView_0, 'width', '100%', true);
  $setAttribute_24(this$static.detailsView_0, 'height', '100%', true);
  isEditable = instanceOf(this$static.detailsView_0, Q$DetailsView) && dynamicCast(this$static.detailsView_0, Q$DetailsView).isEditable_0();
  if (!isEditable) {
    backButton = new BackButton_0(($clinit_Enhanced() , 'Back to List'), this$static.basePath);
    $addMember(this$static.detailsHolder, backButton);
    verticalSpacer = new EnhancedVLayout_0;
    $isCreated_1(verticalSpacer)?$setProperty_0(verticalSpacer, 'height', 8):(verticalSpacer.config_0['height'] = 8 , undefined);
    $addMember(this$static.detailsHolder, verticalSpacer);
  }
  $addMember(this$static.detailsHolder, this$static.detailsView_0);
  $animateShow(this$static.detailsHolder, ($clinit_AnimationEffect() , WIPE));
}

function $configureTable(this$static){
  var field, grid;
  if (this$static.isDetailsEnabled()) {
    grid = this$static.listGrid;
    field = grid?$getField_1(grid, this$static.getDetailsLinkColumnName()):null;
    !!field && $setCellFormatter_0(field, this$static.getDetailsLinkColumnCellFormatter());
    $setListGridDoubleClickHandler(this$static, new AbstractTableSection$1_0(this$static));
  }
}

function $isInitialized(this$static){
  return this$static.initialized_0 && this$static.initialized;
}

function $newDetails(this$static){
  $clinit_CoreGUI();
  goToView(this$static.basePath + '/0', null, false);
}

function $onInit_2(this$static){
  $onInit_1(this$static);
  this$static.initialDisplay = true;
  this$static.detailsHolder = new EnhancedVLayout_0;
  $setAttribute_24(this$static.detailsHolder, 'align', ($clinit_VerticalAlignment() , TOP_2).value_0, true);
  $setMargin(this$static.detailsHolder, valueOf_44(4));
  this$static.detailsHolder.hide_0();
  $addMember(this$static, this$static.detailsHolder);
  !!this$static.detailsView_0 && $switchToDetailsView(this$static);
  this$static.initialized = true;
}

function $renderView_0(this$static, viewPath){
  var id;
  this$static.basePath = $getPathToIndex(viewPath, viewPath.index_0);
  if (viewPath.viewPath.size_0 <= viewPath.index_0) {
    $switchToTableView(this$static);
  }
   else {
    id = this$static.convertCurrentViewPathToID((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
    this$static.detailsView_0 = this$static.getDetailsView(id);
    instanceOf(this$static.detailsView_0, Q$BookmarkableView) && dynamicCast(this$static.detailsView_0, Q$BookmarkableView).renderView(viewPath);
    $switchToDetailsView(this$static);
  }
}

function $switchToDetailsView(this$static){
  var contents;
  contents = this$static.contents_0;
  if (contents) {
    if ($isVisible(contents)) {
      $animateHide_0(contents, ($clinit_AnimationEffect() , WIPE), new AbstractTableSection$3_0(this$static));
    }
     else {
      contents.hide_0();
      destroyMembers(this$static.detailsHolder);
      $buildDetailsView(this$static);
    }
  }
}

function $switchToTableView(this$static){
  var contents;
  contents = this$static.contents_0;
  if (contents) {
    if (this$static.initialDisplay) {
      this$static.initialDisplay = false;
    }
     else {
      debug('Refreshing data for Table [' + this$static.___clazz$.typeName + ']...');
      this$static.refresh_0();
    }
    if (!!this$static.detailsHolder && $isVisible(this$static.detailsHolder)) {
      $animateHide_0(this$static.detailsHolder, ($clinit_AnimationEffect() , WIPE), new AbstractTableSection$4_0(this$static, contents));
    }
     else {
      !!this$static.detailsHolder && destroyMembers(this$static.detailsHolder);
      $animateShow(contents, ($clinit_AnimationEffect() , WIPE));
    }
  }
}

function AbstractTableSection_0(tableTitle, criteria, sortSpecifiers){
  Table_6.call(this, tableTitle, criteria, sortSpecifiers, null, !criteria);
}

defineSeed(1604, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_0(){
  $configureTable(this);
}
;
_.destroy_0 = function destroy_3(){
  this.initialized = false;
  $destroy_2(this);
}
;
_.getBasePath = function getBasePath(){
  return this.basePath;
}
;
_.getDetailsLinkColumnCellFormatter = function getDetailsLinkColumnCellFormatter(){
  return new AbstractTableSection$2_0(this);
}
;
_.getDetailsLinkColumnName = function getDetailsLinkColumnName(){
  return 'name';
}
;
_.isDetailsEnabled = function isDetailsEnabled(){
  return true;
}
;
_.isInitialized_0 = function isInitialized_1(){
  return this.initialized_0 && this.initialized;
}
;
_.onInit = function onInit_9(){
  $onInit_2(this);
}
;
_.renderView = function renderView_1(viewPath){
  $renderView_0(this, viewPath);
}
;
_.showDetails = function showDetails(record){
  var id;
  if (!record) {
    throw new IllegalArgumentException_1("'record' parameter is null.");
  }
  id = this.getId_0(record);
  this.showDetails_0(id);
}
;
_.basePath = null;
_.detailsHolder = null;
_.detailsView_0 = null;
_.escapeHtmlInDetailsLinkColumn = false;
_.initialDisplay = false;
_.initialized = false;
function $convertIDToCurrentViewPath(id){
  if (!id) {
    return '0';
  }
  return '' + id.value_0;
}

function $getId(this$static, record){
  var id, msg;
  id = valueOf_44(record?getAttributeAsInt(record.jsObj, 'id').value_0:0);
  if (!id) {
    msg = 'Table [' + ($clinit_Enhanced() , $toString_5(this$static.___clazz$)) + '] record is missing id attribute - please report this bug.';
    $handleError_0(($clinit_CoreGUI() , msg), null);
    throw new IllegalStateException_1(msg);
  }
  return id;
}

function $showDetails(this$static, id){
  var msg;
  if (!!id && id.value_0 > 0) {
    $clinit_CoreGUI();
    goToView(this$static.getBasePath() + '/' + id, null, false);
  }
   else {
    msg = 'Can not show detail for [' + ($clinit_Enhanced() , $toString_5(this$static.___clazz$)) + ']. Illegal id: [' + (!id?'null':'' + id.value_0) + ']. Please report this bug';
    $handleError_0(($clinit_CoreGUI() , msg), null);
    throw new IllegalArgumentException_1(msg);
  }
}

function TableSection_0(tableTitle){
  $clinit_BaseWidget();
  Table_2.call(this, tableTitle);
}

function TableSection_1(tableTitle, criteria){
  Table_3.call(this, tableTitle, criteria);
}

function TableSection_2(tableTitle, criteria, sortSpecifiers){
  $clinit_BaseWidget();
  AbstractTableSection_0.call(this, tableTitle, criteria, sortSpecifiers);
}

function TableSection_3(tableTitle, criteria, sortSpecifiers, excludedFieldNames){
  $clinit_BaseWidget();
  Table_5.call(this, tableTitle, criteria, sortSpecifiers, excludedFieldNames);
}

defineSeed(1603, 1604, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.convertCurrentViewPathToID = function convertCurrentViewPathToID(path){
  return valueOf_44(__parseAndValidateInt(path));
}
;
_.convertIDToCurrentViewPath = function convertIDToCurrentViewPath(id){
  return $convertIDToCurrentViewPath(dynamicCast(id, Q$Integer));
}
;
_.getDetailsView = function getDetailsView(id){
  return this.getDetailsView_0(dynamicCast(id, Q$Integer));
}
;
_.getId_0 = function getId_3(record){
  return $getId(this, record);
}
;
_.showDetails_0 = function showDetails_0(id){
  $showDetails(this, dynamicCast(id, Q$Integer));
}
;
function $clinit_AgentPluginTableView(){
  $clinit_AgentPluginTableView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_0 = new ViewName_2('AgentPlugins', ($clinit_Enhanced() , 'Agent Plugins'), ($clinit_IconEnum() , PLUGIN_0));
  ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_CONFIGURATION_VIEW_ID + '/' + VIEW_ID_0;
}

function $getSelectedIds(selections){
  var i, ids, selection, selection$index, selection$max;
  if (selections == null) {
    return initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, 0, 1);
  }
  ids = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selections.length, 1);
  i = 0;
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    ids[i++] = getAttributeAsInt(selection.jsObj, 'id').value_0;
  }
  return ids;
}

function $getSelectedNames(selections){
  var ids, selection, selection$index, selection$max;
  if (selections == null) {
    return new ArrayList_1(0);
  }
  ids = new ArrayList_1(selections.length);
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    $add_3(ids, getAttribute(selection.jsObj, 'name'));
  }
  return ids;
}

function AgentPluginTableView_0(){
  $clinit_AgentPluginTableView();
  TableSection_0.call(this, null);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setDataSource(this, new AgentPluginTableView$AgentPluginDataSource_0(this));
}

defineSeed(1602, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), AgentPluginTableView_0);
_.configureTable = function configureTable_1(){
  var fields, listGrid, pluginUploadForm, scanForUpdatesButton, showDeletedButton;
  fields = $getListGridFields(dynamicCast(this.dataSource_1, Q$AgentPluginTableView$AgentPluginDataSource));
  listGrid = this.listGrid;
  $setFields_1(listGrid, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $sort(listGrid, 'name', ($clinit_SortDirection() , ASCENDING));
  $addTableAction(this, ($clinit_Enhanced() , 'Enable'), 'Are You Sure?', null, new AgentPluginTableView$1_0(this, this, ($clinit_TableActionEnablement() , ANY_1), initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , MANAGE_SETTINGS)])));
  $addTableAction(this, 'Disable', null, null, new AgentPluginTableView$2_0(this, this, ANY_1, initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [MANAGE_SETTINGS])));
  $addTableAction(this, 'Delete', null, null, new AgentPluginTableView$3_0(this, this, ANY_1, initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [MANAGE_SETTINGS])));
  $addTableAction(this, 'Purge', 'Are You Sure?', null, new AgentPluginTableView$4_0(this, this, ANY_1, initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [MANAGE_SETTINGS])));
  scanForUpdatesButton = new EnhancedIButton_1('Scan For Updates');
  $addClickHandler(scanForUpdatesButton, new AgentPluginTableView$5_0(this));
  showDeletedButton = new EnhancedIButton_1('Show Deleted');
  $addClickHandler(showDeletedButton, new AgentPluginTableView$6_0(this, showDeletedButton));
  pluginUploadForm = new PluginFileUploadForm_0('Upload Plugin');
  $add_3(this.extraWidgetsAboveFooter, scanForUpdatesButton);
  $add_3(this.extraWidgetsAboveFooter, showDeletedButton);
  $add_3(this.extraWidgetsAboveFooter, pluginUploadForm);
  $configureTable(this);
}
;
_.getDetailsView_0 = function getDetailsView_0(id){
  return new AgentPluginDetailView_0(id.value_0);
}
;
_.showDeleted = false;
var VIEW_ID_0;
function $enableIfRecordsExist(listGrid){
  return !!listGrid && $getTotalRows(listGrid) != 0;
}

function AbstractTableAction_0(){
  AbstractTableAction_1.call(this, ($clinit_TableActionEnablement() , ALWAYS));
}

function $isEnabled_0(this$static, selection){
  if (!$isEnabled(this$static, selection)) {
    return false;
  }
  if (!this$static.isGlobalAuthorized) {
    $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new AuthorizedTableAction$1_0(this$static)));
    return false;
  }
  return this$static.isGlobalAuthorized.value_0;
}

function AuthorizedTableAction_0(table, enablement, permissions){
  var p, p$index, p$max;
  this.enablement = enablement;
  this.globalPermissions = new HashSet_0;
  this.table = table;
  for (p$index = 0 , p$max = permissions.length; p$index < p$max; ++p$index) {
    p = permissions[p$index];
    switch (p.target.ordinal) {
      case 0:
        $add_6(this.globalPermissions, p);
        break;
      case 1:
        throw new IllegalArgumentException_1('Does not support Resource permissions');
    }
  }
  this.globalPermissions.map.size_1() == 0 && (this.isGlobalAuthorized = ($clinit_Boolean() , $clinit_Boolean() , TRUE));
}

defineSeed(1607, 1608, {});
_.isEnabled_0 = function isEnabled_1(selection){
  return $isEnabled_0(this, selection);
}
;
_.isGlobalAuthorized = null;
_.table = null;
function AgentPluginTableView$1_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1606, 1607, {}, AgentPluginTableView$1_0);
_.executeAction = function executeAction(selections, actionValue){
  var selectedIds;
  selectedIds = $getSelectedIds(selections);
  $enableAgentPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), selectedIds, new AgentPluginTableView$1$1_0(this));
}
;
_.this$0 = null;
function $onSuccess_11(this$static, result){
  var msg;
  msg = new Message_7('Enabled agent plugins: ' + ($clinit_Enhanced() , result.toString$()), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$1.this$0, false);
}

function AgentPluginTableView$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1609, 1, {}, AgentPluginTableView$1$1_0);
_.onFailure = function onFailure_11(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to enable agent plugins.') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_11(result){
  $onSuccess_11(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$1 = null;
function AgentPluginTableView$2_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1610, 1607, {}, AgentPluginTableView$2_0);
_.executeAction = function executeAction_0(selections, actionValue){
  var message, selectedNames;
  selectedNames = $getSelectedNames(selections);
  message = '<b>Warning!<\/b><br/>\nThe following agent plugins are about to be disabled:<br/>\n' + ($clinit_Enhanced() , selectedNames.toString$()) + '<br/>\nAre you sure you want to disable these?';
  ask(message, new AgentPluginTableView$2$1_0(this, selections));
}
;
_.this$0 = null;
function AgentPluginTableView$2$1_0(this$1, val$selections){
  this.this$1 = this$1;
  this.val$selections = val$selections;
}

defineSeed(1611, 1, {}, AgentPluginTableView$2$1_0);
_.execute_3 = function execute_11(confirmed){
  var selectedIds;
  if (confirmed.value_0) {
    selectedIds = $getSelectedIds(this.val$selections);
    $disableAgentPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), selectedIds, new AgentPluginTableView$2$1$1_0(this));
  }
   else {
    $refreshTableInfo(this.this$1.this$0);
  }
}
;
_.this$1 = null;
_.val$selections = null;
function $onSuccess_12(this$static, result){
  var msg;
  msg = new Message_7('Disabled agent plugins: ' + ($clinit_Enhanced() , result.toString$()), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$2.this$1.this$0, false);
}

function AgentPluginTableView$2$1$1_0(this$2){
  this.this$2 = this$2;
}

defineSeed(1612, 1, {}, AgentPluginTableView$2$1$1_0);
_.onFailure = function onFailure_12(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to disable agent plugins.') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$2.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_12(result){
  $onSuccess_12(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$2 = null;
function AgentPluginTableView$3_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1613, 1607, {}, AgentPluginTableView$3_0);
_.executeAction = function executeAction_1(selections, actionValue){
  var message, selectedNames;
  selectedNames = $getSelectedNames(selections);
  message = '<b>Warning!<\/b><br/>\nThe following agent plugins are about to be deleted:<br/>\n' + ($clinit_Enhanced() , selectedNames.toString$()) + '<br/>\nAre you sure you want to delete these?';
  ask(message, new AgentPluginTableView$3$1_0(this, selections));
}
;
_.this$0 = null;
function AgentPluginTableView$3$1_0(this$1, val$selections){
  this.this$1 = this$1;
  this.val$selections = val$selections;
}

defineSeed(1614, 1, {}, AgentPluginTableView$3$1_0);
_.execute_3 = function execute_12(confirmed){
  var selectedIds;
  if (confirmed.value_0) {
    selectedIds = $getSelectedIds(this.val$selections);
    $deleteAgentPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), selectedIds, new AgentPluginTableView$3$1$1_0(this));
  }
   else {
    $refreshTableInfo(this.this$1.this$0);
  }
}
;
_.this$1 = null;
_.val$selections = null;
function $onSuccess_13(this$static, result){
  var msg;
  msg = new Message_7('Deleted agent plugins: ' + ($clinit_Enhanced() , result.toString$()), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$2.this$1.this$0, false);
}

function AgentPluginTableView$3$1$1_0(this$2){
  this.this$2 = this$2;
}

defineSeed(1615, 1, {}, AgentPluginTableView$3$1$1_0);
_.onFailure = function onFailure_13(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to delete agent plugins.') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$2.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_13(result){
  $onSuccess_13(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$2 = null;
function AgentPluginTableView$4_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1616, 1607, {}, AgentPluginTableView$4_0);
_.executeAction = function executeAction_2(selections, actionValue){
  var selectedIds;
  selectedIds = $getSelectedIds(selections);
  $purgeAgentPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), selectedIds, new AgentPluginTableView$4$1_0(this));
}
;
_.isEnabled_0 = function isEnabled_2(selection){
  return this.this$0.showDeleted && $isEnabled_0(this, selection);
}
;
_.this$0 = null;
function $onSuccess_14(this$static, result){
  var msg;
  msg = new Message_7('Preparing to purge agent plugins ' + ($clinit_Enhanced() , result.toString$()) + '. This may take a few minutes since all type definitions from the plugins must first be purged from the system. The plugins will still be visible on this page until they have been purged. Please note that you must not re-install the plugin while the purge is running, otherwise failures will occur. Therefore, please wait before attempting to re-install the plugin into the system until this purge is complete.', ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$1.this$0, false);
}

function AgentPluginTableView$4$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1617, 1, {}, AgentPluginTableView$4$1_0);
_.onFailure = function onFailure_14(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to purge agent plugins.') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_14(result){
  $onSuccess_14(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$1 = null;
function AgentPluginTableView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1618, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AgentPluginTableView$5_0);
_.onClick = function onClick_3(event_0){
  $scanAndRegister(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), new AgentPluginTableView$5$1_0(this));
}
;
_.this$0 = null;
function $onSuccess_15(this$static){
  var msg;
  msg = new Message_7(($clinit_Enhanced() , 'Finished scanning for updated plugins'), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$1.this$0, false);
}

function AgentPluginTableView$5$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1619, 1, {}, AgentPluginTableView$5$1_0);
_.onFailure = function onFailure_15(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to scan for updated plugins.') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_15(result){
  $onSuccess_15(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
function AgentPluginTableView$6_0(this$0, val$showDeletedButton){
  this.this$0 = this$0;
  this.val$showDeletedButton = val$showDeletedButton;
}

defineSeed(1620, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AgentPluginTableView$6_0);
_.onClick = function onClick_4(event_0){
  this.this$0.showDeleted = !this.this$0.showDeleted;
  if (this.this$0.showDeleted) {
    $setTitle_0(this.val$showDeletedButton, ($clinit_Enhanced() , 'Hide Deleted'));
    $showField(this.this$0.listGrid, 'deployed');
  }
   else {
    $setTitle_0(this.val$showDeletedButton, ($clinit_Enhanced() , 'Show Deleted'));
    $hideField(this.this$0.listGrid, 'deployed');
  }
  $refresh(this.this$0, false);
}
;
_.this$0 = null;
_.val$showDeletedButton = null;
function $clinit_RPCDataSource(){
  $clinit_RPCDataSource = nullMethod;
  $clinit_CoreGUI();
}

function $addFields(this$static, fields){
  var field, field$iterator;
  for (field$iterator = new AbstractList$IteratorImpl_0(fields); field$iterator.i < field$iterator.this$0_0.size_1();) {
    field = dynamicCast($next_0(field$iterator), Q$DataSourceField);
    $addField(this$static, field);
  }
}

function $buildDataObjects(this$static, records){
  var record, record$index, record$max, results;
  if (records == null) {
    return null;
  }
  results = new LinkedHashSet_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_6(results, this$static.copyValues(record));
  }
  return results;
}

function $buildRecords(this$static, dataObjects, cascade){
  var i, item, item$iterator, records;
  if (!dataObjects) {
    return null;
  }
  records = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, dataObjects.size_1(), 0);
  i = 0;
  for (item$iterator = dataObjects.iterator(); item$iterator.hasNext();) {
    item = item$iterator.next_0();
    setCheck(records, i++, this$static.copyValues_1(item, cascade));
  }
  return records;
}

function $getPageControl(this$static, request){
  var endRow, pageControl, startRow;
  if (!!this$static.previousCriteria && !equals_129($getCriteria(request), this$static.previousCriteria)) {
    debug('Resetting paging on ' + this$static.___clazz$.typeName + '...');
    $setAttribute_11(request, 'startRow', valueOf_44(0));
    $setAttribute_11(request, 'endRow', this$static.dataPageSize);
  }
  this$static.previousCriteria = $getCriteria(request)?$getCriteria(request):new Criteria_0;
  if (!getAttributeAsInt(request.jsObj, 'endRow')) {
    pageControl = getExplicitPageControl(0, this$static.dataPageSize.value_0);
  }
   else {
    startRow = getAttributeAsInt(request.jsObj, 'startRow')?getAttributeAsInt(request.jsObj, 'startRow').value_0:0;
    endRow = getAttributeAsInt(request.jsObj, 'endRow').value_0;
    pageControl = getExplicitPageControl(startRow, endRow - startRow);
  }
  $initializeSorting(this$static, pageControl, request);
  return pageControl;
}

function $highlightFilterMatches(this$static, request, records){
  var criteriaMap, decoratedData, filterName, filterName$iterator, filterValue, nextRecord, nextRecord$index, nextRecord$max, originalData;
  criteriaMap = convertToMap($getCriteria(request).jsObj);
  for (filterName$iterator = new AbstractList$IteratorImpl_0(this$static.hightlightingFieldNames); filterName$iterator.i < filterName$iterator.this$0_0.size_1();) {
    filterName = dynamicCast($next_0(filterName$iterator), Q$String);
    filterValue = dynamicCast(criteriaMap.get_2(filterName), Q$String);
    for (nextRecord$index = 0 , nextRecord$max = records.length; nextRecord$index < nextRecord$max; ++nextRecord$index) {
      nextRecord = records[nextRecord$index];
      originalData = getAttribute(nextRecord.jsObj, filterName);
      decoratedData = filterValue != null?highlight_0(originalData, filterValue):originalData;
      nextRecord.jsObj[filterName + '-highlight'] = decoratedData;
    }
  }
}

function $initializeSorting(this$static, pageControl, request){
  var columnName, ordering, sortField, sortSpecifier, sortSpecifier$index, sortSpecifier$max, sortSpecifiers;
  sortSpecifiers = $getSortBy(request);
  if (sortSpecifiers != null) {
    for (sortSpecifier$index = 0 , sortSpecifier$max = sortSpecifiers.length; sortSpecifier$index < sortSpecifier$max; ++sortSpecifier$index) {
      sortSpecifier = sortSpecifiers[sortSpecifier$index];
      ordering = dynamicCast(getEnum(($clinit_SortDirection() , $clinit_SortDirection() , $VALUES_33), getAttribute(sortSpecifier.jsObj, 'direction')), Q$SortDirection) == ASCENDING?($clinit_PageOrdering() , ASC):($clinit_PageOrdering() , DESC);
      columnName = getAttribute(sortSpecifier.jsObj, 'property');
      sortField = this$static.getSortFieldForColumn(columnName);
      sortField != null?$addDefaultOrderingField(pageControl, sortField, ordering):warn_0('Field [' + columnName + '] in [' + this$static.___clazz$.typeName + '] could not be mapped to a PageControl ordering field.');
    }
  }
}

function $processResponse_0(this$static, requestId, responseProperties){
  $processResponse(this$static, requestId, responseProperties);
  record_1(requestId, responseProperties);
}

function $sendFailureResponse(this$static, request, response, message, caught){
  $handleError_0(($clinit_CoreGUI() , message), caught);
  response.jsObj['status'] = -1;
  $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
}

function $sendSuccessResponse(this$static, request, response, record, message){
  response.jsObj['status'] = 0;
  $setAttribute_17(response, 'data', initValues(_3Lcom_smartgwt_client_data_Record_2_classLit, makeCastMap([Q$Record_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Record, [record]));
  $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
  !!message && $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
}

function $sendSuccessResponse_0(this$static, request, response, dataObject, message){
  var record;
  record = this$static.copyValues_0(dataObject);
  $sendSuccessResponse(this$static, request, response, record, message);
}

function $sendSuccessResponse_1(this$static, request, response, dataObjects){
  var records, recordsPageList;
  records = this$static.buildRecords(dataObjects);
  recordsPageList = new PageList_2(dataObjects.pageControl);
  $setTotalSize(recordsPageList, max_0(dataObjects.size_0, dataObjects.totalSize));
  $setUnbounded(recordsPageList, dataObjects.isUnbounded);
  $addAll_0(recordsPageList, new Arrays$ArrayList_0(records));
  this$static.sendSuccessResponseRecords(request, response, recordsPageList);
}

function $sendSuccessResponseRecords(this$static, request, response, records){
  var recordsArray;
  response.jsObj['status'] = 0;
  recordsArray = dynamicCast($toArray_1(records, initDim(_3Lcom_smartgwt_client_data_Record_2_classLit, makeCastMap([Q$Record_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Record, records.size_0, 0)), Q$Record_$1);
  $setAttribute_17(response, 'data', recordsArray);
  $setPagingInfo(response, records);
  $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
}

function $sendValidationErrorResponse(this$static, request, response, errorMessages){
  response.jsObj['status'] = -4;
  setAttribute_10(response.jsObj, 'errors', errorMessages);
  $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
}

function $setDataPageSize(this$static, dataPageSize){
  if (dataPageSize.value_0 <= 0) {
    throw new IllegalArgumentException_1('Page size must be greater than 0.');
  }
  this$static.dataPageSize = dataPageSize;
}

function $setPagingInfo(response, pageList){
  var totalRows;
  totalRows = pageList.isUnbounded?pageList.size_0:max_0(pageList.size_0, pageList.totalSize);
  $setAttribute_11(response, 'totalRows', valueOf_44(totalRows));
}

function RPCDataSource_0(){
  $clinit_RPCDataSource();
  DataSource_0.call(this);
  this.hightlightingFieldNames = new ArrayList_0;
  $setAttribute_0(this, 'clientOnly', ($clinit_Boolean() , $clinit_Boolean() , FALSE), false);
  $setAttribute_0(this, 'autoCacheAllData', FALSE, true);
  $setAttribute_0(this, 'cacheAllData', FALSE, true);
  $setAttribute_1(this, 'dataProtocol', ($clinit_DSProtocol() , CLIENTCUSTOM).value_0);
  $setAttribute_1(this, 'dataFormat', ($clinit_DSDataFormat() , CUSTOM).value_0);
  $setDataPageSize(this, valueOf_44(50));
}

function convertTimestampToDate(timestamp){
  if (!timestamp) {
    return null;
  }
  return neq(timestamp.value_0, P0_longLit)?new Date_2(timestamp.value_0):null;
}

function createBooleanField(name_0, title, required){
  var textField, valueMap;
  textField = new DataSourceTextField_1(name_0, title);
  $setAttribute_11(textField, 'length', valueOf_44((($clinit_Boolean() , FALSE).value_0?'true':'false').length));
  setAttribute_5(textField.jsObj, 'required', required);
  valueMap = new LinkedHashMap_0;
  $put_1(valueMap, TRUE.value_0?'true':'false', 'yes');
  $put_1(valueMap, FALSE.value_0?'true':'false', 'no');
  setAttribute_10(textField.jsObj, 'valueMap', valueMap);
  return textField;
}

function createIntegerField(minValue, required){
  var integerRangeValidator, textField;
  textField = new DataSourceIntegerField_1('timeout', 'Timeout (in seconds)');
  setAttribute_5(textField.jsObj, 'required', required);
  if (minValue) {
    integerRangeValidator = new IntegerRangeValidator_0;
    minValue?$setAttribute_3(integerRangeValidator, 'min', minValue.value_0):(integerRangeValidator.jsObj['min'] = -2147483648 , undefined);
    integerRangeValidator.jsObj['max'] = 2147483647;
    textField.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [integerRangeValidator]));
  }
  return textField;
}

function createTextField(name_0, title, minLength, maxLength, required){
  var lengthRangeValidator, textField;
  textField = new DataSourceTextField_1(name_0, title);
  setAttribute_8(textField.jsObj, 'length', maxLength);
  setAttribute_5(textField.jsObj, 'required', required);
  if (!!minLength || !!maxLength) {
    lengthRangeValidator = new LengthRangeValidator_0;
    setAttribute_8(lengthRangeValidator.jsObj, 'min', minLength);
    setAttribute_8(lengthRangeValidator.jsObj, 'max', maxLength);
    textField.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [lengthRangeValidator]));
  }
  return textField;
}

function getArrayFilter(criteria, paramName, type){
  $clinit_RPCDataSource();
  var buffer, criteriaMap, index, intermediates, next, next$index, next$max, resultArray, value;
  criteriaMap = convertToMap(criteria.jsObj);
  value = criteriaMap.get_2(paramName);
  if (value == null) {
    resultArray = null;
  }
   else if (type == Ljava_lang_Integer_2_classLit) {
    (getClass__devirtual$(value).modifiers & 4) != 0 || getClass__devirtual$(value) == Ljava_util_ArrayList_2_classLit?(intermediates = getAttributeAsIntArray(criteria.jsObj, paramName)):(intermediates = initValues(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [getAttributeAsInt(criteria.jsObj, paramName).value_0]));
    resultArray = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, intermediates.length, 0);
    index = 0;
    for (next$index = 0 , next$max = intermediates.length; next$index < next$max; ++next$index) {
      next = intermediates[next$index];
      setCheck(resultArray, index++, valueOf_44(next));
    }
  }
   else if (type == Ljava_lang_String_2_classLit) {
    (getClass__devirtual$(value).modifiers & 4) != 0 || getClass__devirtual$(value) == Ljava_util_ArrayList_2_classLit?(intermediates = getAttributeAsStringArray(criteria.jsObj, paramName)):(intermediates = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [getAttribute(criteria.jsObj, paramName)]));
    resultArray = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, intermediates.length, 0);
    index = 0;
    for (next$index = 0 , next$max = intermediates.length; next$index < next$max; ++next$index) {
      next = intermediates[next$index];
      setCheck(resultArray, index++, next);
    }
  }
   else if ((type.modifiers & 8) != 0) {
    (getClass__devirtual$(value).modifiers & 4) != 0 || getClass__devirtual$(value) == Ljava_util_ArrayList_2_classLit?(intermediates = getAttributeAsStringArray(criteria.jsObj, paramName)):(intermediates = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [getAttribute(criteria.jsObj, paramName)]));
    buffer = new ArrayList_0;
    for (next$index = 0 , next$max = intermediates.length; next$index < next$max; ++next$index) {
      next = intermediates[next$index];
      $add_3(buffer, valueOf_0(type, next));
    }
    resultArray = $toArray_1(buffer, getEnumArray(type, buffer.size_0));
  }
   else {
    throw new IllegalArgumentException_1('No support for passing array filters of type ' + type.typeName + '.');
  }
  ($clinit_Log() , $isLoggable_0(logger_0, ($clinit_Level() , FINE))) && resultArray != null && debug('Array filter: ' + paramName + '=[' + toString_31(resultArray) + ']');
  return resultArray;
}

function getArrayFilter_0(request, paramName, type){
  $clinit_RPCDataSource();
  return getArrayFilter($getCriteria(request), paramName, type);
}

function getDataObject(request){
  var data, newRecord;
  data = getAttributeAsJavaScriptObject(request.jsObj, 'data');
  newRecord = new ListGridRecord_1(data);
  return newRecord;
}

function getEnumArray(genericEnumType, size){
  if (genericEnumType == Lorg_rhq_core_domain_alert_AlertPriority_2_classLit) {
    return initDim(_3Lorg_rhq_core_domain_alert_AlertPriority_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$AlertPriority_$1]), Q$AlertPriority, size, 0);
  }
   else if (genericEnumType == Lorg_rhq_core_domain_event_EventSeverity_2_classLit) {
    return initDim(_3Lorg_rhq_core_domain_event_EventSeverity_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$EventSeverity_$1]), Q$EventSeverity, size, 0);
  }
   else if (genericEnumType == Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit) {
    return initDim(_3Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$OperationRequestStatus_$1]), Q$OperationRequestStatus, size, 0);
  }
   else if (genericEnumType == Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit) {
    return initDim(_3Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$ResourceCategory_$1]), Q$ResourceCategory, size, 0);
  }
   else if (genericEnumType == Lorg_rhq_core_domain_drift_DriftCategory_2_classLit) {
    return initDim(_3Lorg_rhq_core_domain_drift_DriftCategory_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$DriftCategory_$1]), Q$DriftCategory, size, 0);
  }
   else if (genericEnumType == Lorg_rhq_core_domain_cloud_PartitionEvent$ExecutionStatus_2_classLit) {
    return initDim(_3Lorg_rhq_core_domain_cloud_PartitionEvent$ExecutionStatus_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$PartitionEvent$ExecutionStatus_$1]), Q$PartitionEvent$ExecutionStatus, size, 0);
  }
   else if (genericEnumType == Lorg_rhq_core_domain_cloud_PartitionEventType_2_classLit) {
    return initDim(_3Lorg_rhq_core_domain_cloud_PartitionEventType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$PartitionEventType_$1]), Q$PartitionEventType, size, 0);
  }
   else if (genericEnumType == Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit) {
    return initDim(_3Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$Server$OperationMode_$1]), Q$Server$OperationMode, size, 0);
  }
   else {
    throw new IllegalArgumentException_1('Please add an appropriate code block for enum ' + genericEnumType.typeName + ' to RPCDataSource.getEnumArray(Class)');
  }
}

function getFilter(criteria, paramName, type){
  $clinit_RPCDataSource();
  var criteriaMap, result, strValue, value;
  criteriaMap = criteria?convertToMap(criteria.jsObj):($clinit_Collections() , $clinit_Collections() , EMPTY_MAP);
  value = criteriaMap.get_2(paramName);
  if (value == null || $equals_6(toString__devirtual$(value), '')) {
    result = null;
  }
   else {
    strValue = toString__devirtual$(value);
    type == Ljava_lang_String_2_classLit?(result = strValue):type == Ljava_lang_Integer_2_classLit?(result = valueOf_44(__parseAndValidateInt(strValue))):type == Ljava_lang_Long_2_classLit?(result = new Long_0(__parseAndValidateLong(strValue))):(type.modifiers & 8) != 0?(result = valueOf_0(type, strValue)):(result = value);
  }
  $clinit_Log();
  $fine_0(logger_0, 'Filter: ' + paramName + '=[' + result + ']');
  return result;
}

function getFilter_0(request, paramName, type){
  $clinit_RPCDataSource();
  return getFilter($getCriteria(request), paramName, type);
}

function printRequestCriteria(request){
  var criteria, criteriaMap, nextEntry, nextEntry$iterator;
  criteria = $getCriteria(request);
  criteriaMap = convertToMap(criteria.jsObj);
  for (nextEntry$iterator = criteriaMap.entrySet().iterator(); nextEntry$iterator.hasNext();) {
    nextEntry = dynamicCast(nextEntry$iterator.next_0(), Q$Map$Entry);
    debug('Request Criteria: ' + dynamicCast(nextEntry.getKey_0(), Q$String) + ':' + nextEntry.getValue_1());
  }
}

defineSeed(1622, 337, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]));
_.addField = function addField_0(field){
  $addField(this, field);
}
;
_.buildRecords = function buildRecords(dataObjects){
  return $buildRecords(this, dataObjects, true);
}
;
_.copyValues_1 = function copyValues(from, cascade){
  return this.copyValues_0(from);
}
;
_.executeAdd = function executeAdd(recordToAdd, request, response){
  throw new UnsupportedOperationException_1('This dataSource does not support additions.');
}
;
_.executeRemove = function executeRemove(recordToRemove, request, response){
  throw new UnsupportedOperationException_1('This dataSource does not support removals.');
}
;
_.executeUpdate = function executeUpdate(editedRecord, oldRecord, request, response){
  throw new UnsupportedOperationException_1('This dataSource does not support updates.');
}
;
_.getPageControl = function getPageControl(request){
  return $getPageControl(this, request);
}
;
_.getSortFieldForColumn = function getSortFieldForColumn(columnName){
  return columnName;
}
;
_.sendSuccessResponseRecords = function sendSuccessResponseRecords(request, response, records){
  $sendSuccessResponseRecords(this, request, response, records);
}
;
_.setDataPageSize = function setDataPageSize(dataPageSize){
  $setDataPageSize(this, dataPageSize);
}
;
_.transformRequest_0 = function transformRequest_0(request){
  var $e0, criteria, deletedRecord, newRecord, oldRecord, response, t, updatedRecord, data;
  try {
    response = new DSResponse_0;
    $setAttribute_12(response, 'clientContext', getAttributeAsObject(request.jsObj, 'clientContext'));
    response.jsObj['status'] = 0;
    switch (dynamicCast(getEnum(($clinit_DSOperationType() , $clinit_DSOperationType() , $VALUES_9), getAttribute(request.jsObj, 'operationType')), Q$DSOperationType).ordinal) {
      case 0:
        criteria = this.getFetchCriteria(request);
        if (criteria) {
          !criteria.getPageControlOverrides() && criteria.setPageControl(this.getPageControl(request));
          ($clinit_Log() , $isLoggable_0(logger_0, ($clinit_Level() , FINE))) && debug(this.___clazz$.typeName + ' using [' + criteria.getPageControlOverrides() + '] for fetch request.');
        }
         else {
          warn_0(this.___clazz$.typeName + '.getFetchCriteria() returned null - no paging of results will be done.');
        }

        this.executeFetch(request, response, criteria);
        break;
      case 1:
        newRecord = getDataObject(request);
        this.executeAdd(newRecord, request, response);
        break;
      case 2:
        oldRecord = getOrCreateRef_1(getAttributeAsJavaScriptObject(request.jsObj, 'oldValues'));
        updatedRecord = (data = getAttributeAsJavaScriptObject(request.jsObj, 'data') , apply_0(data, oldRecord.jsObj) , new ListGridRecord_1(data));
        this.executeUpdate(updatedRecord, oldRecord, request, response);
        break;
      case 3:
        deletedRecord = getDataObject(request);
        this.executeRemove(deletedRecord, request, response);
        break;
      default:$transformRequest(this, request);
    }
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Throwable)) {
      t = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failure in datasource while processing ' + dynamicCast(getEnum(($clinit_DSOperationType() , $clinit_DSOperationType() , $VALUES_9), getAttribute(request.jsObj, 'operationType')), Q$DSOperationType).name_0 + '  request.'), t);
      return null;
    }
     else 
      throw $e0;
  }
  return getAttributeAsJavaScriptObject(request.jsObj, 'data');
}
;
_.dataPageSize = null;
_.previousCriteria = null;
function $copyValues(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'name', from.displayName);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_14(record, 'lastUpdate', new Date_2(from.mtime));
  $setAttribute_13(record, 'enabled', getAvailabilityIcon(($clinit_Boolean() , from.enabled?TRUE:FALSE)));
  $setAttribute_13(record, 'deployed', getAvailabilityIcon(from.status_0 == ($clinit_PluginStatusType() , INSTALLED_1)?TRUE:FALSE));
  $setAttribute_13(record, 'version', from.version_0);
  return record;
}

function $executeFetch(this$static, request, response){
  $getAgentPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), this$static.this$0.showDeleted, new AgentPluginTableView$AgentPluginDataSource$1_0(this$static, response, request));
}

function $getListGridFields(){
  var deployedField, descriptionField, enabledField, fields, idField, lastUpdateField, nameField, versionField;
  fields = new ArrayList_0;
  idField = new ListGridField_3('id', 'ID');
  idField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, idField);
  nameField = new ListGridField_3('name', 'Name');
  setCheck(fields.array, fields.size_0++, nameField);
  descriptionField = new ListGridField_3('description', 'Description');
  setCheck(fields.array, fields.size_0++, descriptionField);
  lastUpdateField = new ListGridField_3('lastUpdate', 'Last Updated');
  $clinit_TimestampCellFormatter();
  prepareDateField(lastUpdateField, getAttribute(lastUpdateField.jsObj, 'name'));
  setCheck(fields.array, fields.size_0++, lastUpdateField);
  enabledField = new ListGridField_3('enabled', 'Enabled?');
  $setAttribute_13(enabledField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(enabledField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  setCheck(fields.array, fields.size_0++, enabledField);
  deployedField = new ListGridField_3('deployed', 'Deployed?');
  $setAttribute_13(deployedField, 'type', IMAGE_0.value_0);
  $setAttribute_13(deployedField, 'align', CENTER_0.value_0);
  deployedField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, deployedField);
  versionField = new ListGridField_3('version', 'Version');
  versionField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, versionField);
  idField.jsObj['width'] = 100;
  nameField.jsObj['width'] = '30%';
  descriptionField.jsObj['width'] = '*';
  lastUpdateField.jsObj['width'] = '20%';
  enabledField.jsObj['width'] = 65;
  deployedField.jsObj['width'] = 75;
  versionField.jsObj['width'] = 100;
  return fields;
}

function AgentPluginTableView$AgentPluginDataSource_0(this$0){
  var fields_0, idField;
  $clinit_RPCDataSource();
  var fields;
  this.this$0 = this$0;
  RPCDataSource_0.call(this);
  fields = (fields_0 = new ArrayList_0 , idField = new DataSourceIntegerField_2('id', 'ID', 50) , $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setAttribute_8(idField, 'hidden', TRUE) , setCheck(fields_0.array, fields_0.size_0++, idField) , fields_0);
  $addFields(this, fields);
}

defineSeed(1621, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AgentPluginTableView$AgentPluginDataSource]), AgentPluginTableView$AgentPluginDataSource_0);
_.copyValues = function copyValues_0(from){
  return null;
}
;
_.copyValues_0 = function copyValues_1(from){
  return $copyValues(dynamicCast(from, Q$Plugin));
}
;
_.executeFetch = function executeFetch(request, response, criteria){
  $executeFetch(this, request, response, dynamicCast(criteria, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria(request){
  return null;
}
;
_.this$0 = null;
function $onSuccess_16(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$1, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function AgentPluginTableView$AgentPluginDataSource$1_0(this$1, val$response, val$request){
  this.this$1 = this$1;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1623, 1, {}, AgentPluginTableView$AgentPluginDataSource$1_0);
_.onFailure = function onFailure_16(t){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load plugin data'), t);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$1, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_16(result){
  $onSuccess_16(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function $clinit_DownloadsView(){
  $clinit_DownloadsView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_1 = new ViewName_2('Downloads', ($clinit_Enhanced() , 'Downloads'), ($clinit_IconEnum() , DOWNLOAD));
  ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_CONFIGURATION_VIEW_ID + '/' + VIEW_ID_1;
}

function DownloadsView_0(){
  $clinit_DownloadsView();
  EnhancedVLayout_0.call(this);
  this.systemManager = dynamicCast(secure(getInstance_55(), -1), Q$SystemGWTServiceAsync);
  this.productInfo = ($clinit_CoreGUI() , $clinit_CoreGUI() , coreGUI).productInfo;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  this.sectionStack = new SectionStack_0;
  $setShowResizeBar(this.sectionStack, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_24(this.sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
  $setAttribute_24(this.sectionStack, 'width', '100%', true);
  $setAttribute_24(this.sectionStack, 'height', '100%', true);
  $setAttribute_24(this.sectionStack, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  this.agentSection = new SectionStackSection_1(($clinit_Enhanced() , 'Agent Download'));
  this.cliSection = new SectionStackSection_1('Command Line Client Download');
  this.bundleSection = new SectionStackSection_1('Bundle Deployer Download');
  this.connectorsSection = new SectionStackSection_1('Connectors Download');
  this.cliAlertScriptsSection = new SectionStackSection_1('CLI Alert Scripts Download');
  this.scriptModulesSection = new SectionStackSection_1('Script Modules Download');
  $setExpanded(this.agentSection, FALSE);
  $setExpanded(this.cliSection, FALSE);
  $setExpanded(this.bundleSection, FALSE);
  $setExpanded(this.connectorsSection, FALSE);
  $setExpanded(this.cliAlertScriptsSection, FALSE);
  $setExpanded(this.scriptModulesSection, FALSE);
  $addSection(this.sectionStack, this.agentSection);
  $addSection(this.sectionStack, this.cliSection);
  $addSection(this.sectionStack, this.bundleSection);
  $addSection(this.sectionStack, this.connectorsSection);
  $addSection(this.sectionStack, this.cliAlertScriptsSection);
  $addSection(this.sectionStack, this.scriptModulesSection);
  $addMember(this, this.sectionStack);
}

defineSeed(1624, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), DownloadsView_0);
_.onDraw_0 = function onDraw_4(){
  $getAgentVersionProperties(this.systemManager, new DownloadsView$1_0(this));
  $getClientVersionProperties(this.systemManager, new DownloadsView$2_0(this));
  $getBundleDeployerDownload(this.systemManager, new DownloadsView$3_0(this));
  $getConnectorDownloads(this.systemManager, new DownloadsView$4_0(this));
  $getCliAlertScriptDownloads(this.systemManager, new DownloadsView$5_0(this));
  $getScriptModulesDownloads(this.systemManager, new DownloadsView$6_0(this));
}
;
_.agentSection = null;
_.bundleSection = null;
_.cliAlertScriptsSection = null;
_.cliSection = null;
_.connectorsSection = null;
_.productInfo = null;
_.scriptModulesSection = null;
_.sectionStack = null;
var VIEW_ID_1;
function $onSuccess_17(this$static, result){
  var build, buildItem, form, helpItem, linkItem, md5, md5Item, spacerItem, version, versionItem;
  version = dynamicCast(result.get_2('rhq-agent.latest.version'), Q$String);
  build = dynamicCast(result.get_2('rhq-agent.latest.build-number'), Q$String);
  md5 = dynamicCast(result.get_2('rhq-agent.latest.md5'), Q$String);
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  versionItem = new StaticTextItem_2('agentVersion', ($clinit_Enhanced() , 'Agent Version'));
  $setValue_7(versionItem, version);
  $setWrapTitle(versionItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  buildItem = new StaticTextItem_2('agentBuild', 'Agent Build');
  $setValue_7(buildItem, build);
  $setWrapTitle(buildItem, FALSE);
  md5Item = new StaticTextItem_2('agentMd5', 'Agent MD5');
  $setValue_7(md5Item, md5);
  $setWrapTitle(md5Item, FALSE);
  linkItem = new StaticTextItem_1('agentLink');
  $setTitle_1(linkItem, 'Link');
  $setValue_7(linkItem, '<a href="/agentupdate/download">Download Agent ' + version + ' (' + build + ')<\/a>');
  spacerItem = new SpacerItem_1('agentSpacer');
  $isCreated_2(spacerItem)?$setProperty_6(spacerItem, 'height', 10):(spacerItem.jsObj['height'] = 10 , undefined);
  helpItem = new StaticTextItem_1('agentHelp');
  $isCreated_2(helpItem)?$setProperty_6(helpItem, 'colSpan', 2):(helpItem.jsObj['colSpan'] = 2 , undefined);
  $setShowTitle_0(helpItem, FALSE);
  $setValue_7(helpItem, '<p> This is the ' + this$static.this$0.productInfo.shortName + ' Agent Update Binary jar file.  The purpose of this jar file is to allow you to install a fresh agent on a machine where an agent does not yet exist and to allow you to update an agent that is already installed on a machine. For more details, run this agent download jar with the --help command line option:<br/> <b>java -jar &lt;agent-download.jar&gt; --help<\/b> <\/p> <h3>Agent Install<\/h3> <p> <b>java -jar &lt;agent-download.jar&gt; --install[=&lt;new agent directory&gt;]<\/b><br/> This command will install a new agent. If you do not specify the new agent directory, the default will be "." <\/p> <h3>Agent Update<\/h3> <p> <b>java -jar &lt;agent-download.jar&gt; --update[=&lt;old agent home&gt;]<\/b><br/> This will update an existing agent that was already installed. If you do not specify the directory where the old, existing agent was installed, it will assumed to be "rhq-agent". <\/p>');
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [versionItem, buildItem, md5Item, linkItem, spacerItem, helpItem]));
  $setItems(this$static.this$0.agentSection, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form]));
  $setExpanded(this$static.this$0.agentSection, TRUE);
  $markForRedraw(this$static.this$0.sectionStack);
}

function DownloadsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1625, 1, {}, DownloadsView$1_0);
_.onFailure = function onFailure_17(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get agent version info'), caught);
}
;
_.onSuccess_0 = function onSuccess_17(result){
  $onSuccess_17(this, dynamicCast(result, Q$HashMap));
}
;
_.this$0 = null;
function $onSuccess_18(this$static, result){
  var build, buildItem, form, helpItem, linkItem, md5, md5Item, spacerItem, version, versionItem;
  version = dynamicCast(result.get_2('rhq-server.version'), Q$String);
  build = dynamicCast(result.get_2('rhq-server.build-number'), Q$String);
  md5 = dynamicCast(result.get_2('rhq-client.md5'), Q$String);
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  versionItem = new StaticTextItem_2('cliVersion', ($clinit_Enhanced() , 'CLI Version'));
  $setValue_7(versionItem, version);
  $setWrapTitle(versionItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  buildItem = new StaticTextItem_2('cliBuild', 'CLI Build');
  $setValue_7(buildItem, build);
  $setWrapTitle(buildItem, FALSE);
  md5Item = new StaticTextItem_2('cliMd5', 'CLI MD5');
  $setValue_7(md5Item, md5);
  $setWrapTitle(md5Item, FALSE);
  linkItem = new StaticTextItem_1('cliLink');
  $setTitle_1(linkItem, 'Link');
  $setValue_7(linkItem, '<a href="/client/download">Download CLI ' + version + ' (' + build + ')<\/a>');
  spacerItem = new SpacerItem_1('clientSpacer');
  $isCreated_2(spacerItem)?$setProperty_6(spacerItem, 'height', 1):(spacerItem.jsObj['height'] = 1 , undefined);
  helpItem = new StaticTextItem_1('clientHelp');
  $isCreated_2(helpItem)?$setProperty_6(helpItem, 'colSpan', 2):(helpItem.jsObj['colSpan'] = 2 , undefined);
  $setShowTitle_0(helpItem, FALSE);
  $setValue_7(helpItem, '<p> This is the Command Line Client tool, otherwise known as the CLI. It is a standalone tool that runs from within a console and provides a command line interface to the ' + this$static.this$0.productInfo.shortName + ' Server. You can invoke commands via the CLI as well as run scripts to perform automated tasks. See the documentation for more information on how to install and use the CLI. <\/p>');
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [versionItem, buildItem, md5Item, linkItem, spacerItem, helpItem]));
  $setItems(this$static.this$0.cliSection, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form]));
  $setExpanded(this$static.this$0.cliSection, TRUE);
  $markForRedraw(this$static.this$0.sectionStack);
}

function DownloadsView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1626, 1, {}, DownloadsView$2_0);
_.onFailure = function onFailure_18(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get CLI version info'), caught);
}
;
_.onSuccess_0 = function onSuccess_18(result){
  $onSuccess_18(this, dynamicCast(result, Q$HashMap));
}
;
_.this$0 = null;
function $onSuccess_19(this$static, result){
  var form, helpItem, linkItem, name_0, spacerItem, url;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  name_0 = dynamicCast($next_1($iterator($keySet(result))), Q$String);
  url = dynamicCast($next_2($iterator_0($values(result))), Q$String);
  linkItem = new StaticTextItem_1('bundleLink');
  $setTitle_1(linkItem, ($clinit_Enhanced() , 'Link'));
  $setValue_7(linkItem, '<a href="' + url + '">Download Bundle Deployer ' + name_0 + '<\/a>');
  spacerItem = new SpacerItem_1('bundleSpacer');
  $isCreated_2(spacerItem)?$setProperty_6(spacerItem, 'height', 1):(spacerItem.jsObj['height'] = 1 , undefined);
  helpItem = new StaticTextItem_1('bundleHelp');
  $isCreated_2(helpItem)?$setProperty_6(helpItem, 'colSpan', 2):(helpItem.jsObj['colSpan'] = 2 , undefined);
  $setShowTitle_0(helpItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setValue_7(helpItem, '<p> This is the Bundle Deployer tool. It is for use by developers and packagers of ' + this$static.this$0.productInfo.shortName + ' bundles. This standalone tool allows you to test your bundles and their recipes from a console. <\/p>');
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [linkItem, spacerItem, helpItem]));
  $setItems(this$static.this$0.bundleSection, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form]));
  $setExpanded(this$static.this$0.bundleSection, TRUE);
  $markForRedraw(this$static.this$0.sectionStack);
}

function DownloadsView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1627, 1, {}, DownloadsView$3_0);
_.onFailure = function onFailure_19(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get bundle deployer info'), caught);
}
;
_.onSuccess_0 = function onSuccess_19(result){
  $onSuccess_19(this, dynamicCast(result, Q$HashMap));
}
;
_.this$0 = null;
function $onSuccess_20(this$static, result){
  var entry, entry$iterator, form, helpText, i, item, items, linkItem, spacerItem;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  if (!!result && result.size_1() != 0) {
    i = 0;
    items = initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, result.size_1() + 2, 0);
    for (entry$iterator = result.entrySet().iterator(); entry$iterator.hasNext();) {
      entry = dynamicCast(entry$iterator.next_0(), Q$Map$Entry);
      linkItem = new StaticTextItem_1('link' + i);
      $setTitle_1(linkItem, ($clinit_Enhanced() , 'Link'));
      $setValue_7(linkItem, '<a href="' + dynamicCast(entry.getValue_1(), Q$String) + '">' + dynamicCast(entry.getKey_0(), Q$String) + '<\/a>');
      setCheck(items, i++, linkItem);
    }
    spacerItem = new SpacerItem_1('spacer');
    $isCreated_2(spacerItem)?$setProperty_6(spacerItem, 'height', 5):(spacerItem.jsObj['height'] = 5 , undefined);
    setCheck(items, i++, spacerItem);
    helpText = new StaticTextItem_1('connectorHelp');
    $isCreated_2(helpText)?$setProperty_6(helpText, 'colSpan', 2):(helpText.jsObj['colSpan'] = 2 , undefined);
    $setShowTitle_0(helpText, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setValue_7(helpText, $view_admin_downloads_connectors_help(($clinit_Enhanced() , this$static.this$0.productInfo.shortName)));
    setCheck(items, i++, helpText);
    form.setItems(items);
  }
   else {
    item = new StaticTextItem_1('noConnectors');
    $isCreated_2(item)?$setProperty_6(item, 'colSpan', 2):(item.jsObj['colSpan'] = 2 , undefined);
    $setShowTitle_0(item, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setValue_7(item, ($clinit_Enhanced() , 'No connectors are available for download'));
    form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [item]));
  }
  $setItems(this$static.this$0.connectorsSection, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form]));
  $setExpanded(this$static.this$0.connectorsSection, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $markForRedraw(this$static.this$0.sectionStack);
}

function DownloadsView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1628, 1, {}, DownloadsView$4_0);
_.onFailure = function onFailure_20(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get connectors info'), caught);
}
;
_.onSuccess_0 = function onSuccess_20(result){
  $onSuccess_20(this, dynamicCast(result, Q$HashMap));
}
;
_.this$0 = null;
function $onSuccess_21(this$static, result){
  var entry, entry$iterator, form, helpText, i, item, items, linkItem, spacerItem;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  if (!!result && result.size_1() != 0) {
    i = 0;
    items = initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, result.size_1() + 2, 0);
    for (entry$iterator = result.entrySet().iterator(); entry$iterator.hasNext();) {
      entry = dynamicCast(entry$iterator.next_0(), Q$Map$Entry);
      linkItem = new StaticTextItem_1('link' + i);
      $setTitle_1(linkItem, ($clinit_Enhanced() , 'Link'));
      $setValue_7(linkItem, '<a href="' + dynamicCast(entry.getValue_1(), Q$String) + '">' + dynamicCast(entry.getKey_0(), Q$String) + '<\/a>');
      setCheck(items, i++, linkItem);
    }
    spacerItem = new SpacerItem_1('spacer');
    $isCreated_2(spacerItem)?$setProperty_6(spacerItem, 'height', 5):(spacerItem.jsObj['height'] = 5 , undefined);
    setCheck(items, i++, spacerItem);
    helpText = new StaticTextItem_1('cliAlertScriptsHelp');
    $isCreated_2(helpText)?$setProperty_6(helpText, 'colSpan', 2):(helpText.jsObj['colSpan'] = 2 , undefined);
    $setShowTitle_0(helpText, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setValue_7(helpText, ($clinit_Enhanced() , 'CLI alert scripts are pre-canned scripts that can be used for creating scripted alert notifications. The scripts will usually require some tweaking before they can be used as a notification on a particular alert definition.'));
    setCheck(items, i++, helpText);
    form.setItems(items);
  }
   else {
    item = new StaticTextItem_1('noCliAlertScripts');
    $isCreated_2(item)?$setProperty_6(item, 'colSpan', 2):(item.jsObj['colSpan'] = 2 , undefined);
    $setShowTitle_0(item, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setValue_7(item, ($clinit_Enhanced() , 'No CLI alert scripts are available for download'));
    form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [item]));
  }
  $setItems(this$static.this$0.cliAlertScriptsSection, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form]));
  $setExpanded(this$static.this$0.cliAlertScriptsSection, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $markForRedraw(this$static.this$0.sectionStack);
}

function DownloadsView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1629, 1, {}, DownloadsView$5_0);
_.onFailure = function onFailure_21(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get info on available CLI alert scripts for download'), caught);
}
;
_.onSuccess_0 = function onSuccess_21(result){
  $onSuccess_21(this, dynamicCast(result, Q$HashMap));
}
;
_.this$0 = null;
function $onSuccess_22(this$static, result){
  var entry, entry$iterator, form, helpText, i, item, items, linkItem, spacerItem;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  if (!!result && result.size_1() != 0) {
    i = 0;
    items = initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, result.size_1() + 2, 0);
    for (entry$iterator = result.entrySet().iterator(); entry$iterator.hasNext();) {
      entry = dynamicCast(entry$iterator.next_0(), Q$Map$Entry);
      linkItem = new StaticTextItem_1('link' + i);
      $setTitle_1(linkItem, ($clinit_Enhanced() , 'Link'));
      $setValue_7(linkItem, '<a href="' + dynamicCast(entry.getValue_1(), Q$String) + '">' + dynamicCast(entry.getKey_0(), Q$String) + '<\/a>');
      setCheck(items, i++, linkItem);
    }
    spacerItem = new SpacerItem_1('spacer');
    $isCreated_2(spacerItem)?$setProperty_6(spacerItem, 'height', 5):(spacerItem.jsObj['height'] = 5 , undefined);
    setCheck(items, i++, spacerItem);
    helpText = new StaticTextItem_1('scriptModulesHelp');
    $isCreated_2(helpText)?$setProperty_6(helpText, 'colSpan', 2):(helpText.jsObj['colSpan'] = 2 , undefined);
    $setShowTitle_0(helpText, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setValue_7(helpText, ($clinit_Enhanced() , '<p> Script modules are reusable components provided by RHQ to be used in your scripts (either alert scripts or CLI scripts). You can access them by using the "rhq://downloads/&lt;module-name-without-file-extension&gt;" URI in your scripting language of choice (i.e. in javascript, you would use the "require" function).<\/p>'));
    setCheck(items, i++, helpText);
    form.setItems(items);
  }
   else {
    item = new StaticTextItem_1('noScriptModules');
    $isCreated_2(item)?$setProperty_6(item, 'colSpan', 2):(item.jsObj['colSpan'] = 2 , undefined);
    $setShowTitle_0(item, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setValue_7(item, ($clinit_Enhanced() , 'No script modules are available for download'));
    form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [item]));
  }
  $setItems(this$static.this$0.scriptModulesSection, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form]));
  $setExpanded(this$static.this$0.scriptModulesSection, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $markForRedraw(this$static.this$0.sectionStack);
}

function DownloadsView$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1630, 1, {}, DownloadsView$6_0);
_.onFailure = function onFailure_22(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot load the list of available script modules'), caught);
}
;
_.onSuccess_0 = function onSuccess_22(result){
  $onSuccess_22(this, dynamicCast(result, Q$HashMap));
}
;
_.this$0 = null;
function EnhancedVStack_0(){
  $clinit_BaseWidget();
  VStack_0.call(this);
}

function EnhancedVStack_1(){
  Layout_0.call(this);
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 6):(this.config_0['membersMargin'] = 6 , undefined);
  this.scClassName = 'VStack';
}

defineSeed(1632, 559, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$Enhanced]), EnhancedVStack_1);
_.destroy_0 = function destroy_4(){
  destroyMembers(this);
  $destroy(this);
}
;
function $getControlDefinition(this$static, controlName){
  var def, def$iterator;
  for (def$iterator = new AbstractList$IteratorImpl_0(this$static.controlDefinitions); def$iterator.i < def$iterator.this$0_0.size_1();) {
    def = dynamicCast($next_0(def$iterator), Q$ServerPluginControlDefinition);
    if ($equals_6(def.name_0, controlName)) {
      return def;
    }
  }
  return null;
}

function $getParameters(this$static){
  if (this$static.selectedParamsDef) {
    if (!$validate_1(this$static.selectedParamsEditor.topLevelPropertiesValuesManager).value_0) {
      throw new IllegalStateException_0;
    }
    return this$static.selectedParamsEditor.configuration;
  }
  return null;
}

function $showParameters(this$static){
  var config, paramsCanvas, paramsForm;
  destroyMembers(this$static.paramsLayout);
  if (this$static.selectedParamsDef) {
    $setAttribute_24(this$static.paramsLayout, 'visibility', ($clinit_Visibility() , INHERIT).value_0, true);
    config = new Configuration_0;
    this$static.selectedParamsEditor = new ConfigurationEditor_1(this$static.selectedParamsDef, config);
    $setAutoHeight(this$static.selectedParamsEditor);
    paramsForm = new DynamicForm_0;
    $isCreated_1(paramsForm)?$setProperty_3(paramsForm, 'width', '100%'):(paramsForm.config_0['width'] = '100%' , undefined);
    $setIsGroup(paramsForm, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $setGroupTitle(paramsForm, ($clinit_Enhanced() , 'Parameters'));
    paramsCanvas = new CanvasItem_1('paramsCanvas');
    paramsCanvas.setShowTitle(FALSE);
    $isCreated_2(paramsCanvas)?$setProperty_6(paramsCanvas, 'colSpan', 2):(paramsCanvas.jsObj['colSpan'] = 2 , undefined);
    $setCanvas(paramsCanvas, this$static.selectedParamsEditor);
    paramsForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [paramsCanvas]));
    $addMember(this$static.paramsLayout, paramsForm);
  }
   else {
    $setAttribute_24(this$static.paramsLayout, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  }
  return;
}

function $showResults(this$static, results){
  var editor, formItems, paramsCanvas, resultsForm, statusItem;
  destroyMembers(this$static.resultsLayout);
  resultsForm = new DynamicForm_0;
  $isCreated_1(resultsForm)?$setProperty_3(resultsForm, 'width', '100%'):(resultsForm.config_0['width'] = '100%' , undefined);
  $setIsGroup(resultsForm, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setGroupTitle(resultsForm, ($clinit_Enhanced() , 'Results'));
  formItems = new ArrayList_1(3);
  statusItem = new StaticTextItem_2('status', 'Status');
  $setValue_7(statusItem, imgHTML(getAvailabilityIcon(results.errorMessage_0 == null?TRUE:FALSE)));
  setCheck(formItems.array, formItems.size_0++, statusItem);
  if (results.errorMessage_0 != null) {
    $setPrompt_1(statusItem, 'Click for the error message');
    statusItem.addClickHandler(new ServerPluginControlView$3_0(results));
  }
  if (!!this$static.selectedResultsDef && !!results.complexResults) {
    editor = new ConfigurationEditor_1(this$static.selectedResultsDef, results.complexResults);
    editor.readOnly = true;
    $isCreated_1(editor)?$setProperty_0(editor, 'height', 1):(editor.config_0['height'] = 1 , undefined);
    paramsCanvas = new CanvasItem_1('resultsCanvas');
    paramsCanvas.setShowTitle(FALSE);
    $isCreated_2(paramsCanvas)?$setProperty_6(paramsCanvas, 'colSpan', 2):(paramsCanvas.jsObj['colSpan'] = 2 , undefined);
    $setAttribute_28(paramsCanvas, 'canvas', !editor?null:$getOrCreateJsObj_0(editor));
    setCheck(formItems.array, formItems.size_0++, paramsCanvas);
  }
  resultsForm.setItems(dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, 0, 0)), Q$FormItem_$1));
  $addMember(this$static.resultsLayout, resultsForm);
  $setAttribute_24(this$static.resultsLayout, 'visibility', ($clinit_Visibility() , INHERIT).value_0, true);
  return;
}

function ServerPluginControlView_0(plugin, controlDefs){
  $clinit_BaseWidget();
  EnhancedVStack_0.call(this);
  this.plugin = plugin;
  this.controlDefinitions = controlDefs;
  $isCreated_1(this)?$setProperty_0(this, 'height', 1):(this.config_0['height'] = 1 , undefined);
  $setMargin(this, valueOf_44(5));
}

defineSeed(1631, 1632, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$Enhanced]), ServerPluginControlView_0);
_.onDraw_0 = function onDraw_5(){
  var controlNames, controlNamesItem, def, def$iterator, executeButton, form, retStr;
  form = new DynamicForm_0;
  $addMember(this, form);
  this.paramsLayout = new EnhancedVLayout_0;
  $setAttribute_24(this.paramsLayout, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  $addMember(this, this.paramsLayout);
  this.resultsLayout = new EnhancedVLayout_0;
  $setAttribute_24(this.resultsLayout, 'visibility', HIDDEN_0.value_0, true);
  $addMember(this, this.resultsLayout);
  executeButton = new FormItemIcon_0;
  executeButton.jsObj['name'] = 'execute';
  executeButton.jsObj['src'] = 'subsystems/control/Operation_16.png';
  $setAttribute_13(executeButton, 'prompt', ($clinit_Enhanced() , 'Execute'));
  controlNamesItem = new SortedSelectItem_2('controlMenu', 'Control');
  controlNames = new LinkedHashMap_0;
  for (def$iterator = new AbstractList$IteratorImpl_0(this.controlDefinitions); def$iterator.i < def$iterator.this$0_0.size_1();) {
    def = dynamicCast($next_0(def$iterator), Q$ServerPluginControlDefinition);
    $put_1(controlNames, def.name_0, (retStr = def.displayName , retStr == null && (retStr = deCamelCase(def.name_0)) , retStr));
  }
  $setValueMap_1(controlNamesItem, controlNames);
  $isCreated_2(controlNamesItem)?$setProperty_6(controlNamesItem, 'width', 300):(controlNamesItem.jsObj['width'] = 300 , undefined);
  $addChangedHandler(controlNamesItem, new ServerPluginControlView$1_0(this, controlNamesItem, executeButton));
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [controlNamesItem]));
  $addFormItemClickHandler(executeButton, new ServerPluginControlView$2_0(this));
}
;
_.controlDefinitions = null;
_.paramsLayout = null;
_.plugin = null;
_.resultsLayout = null;
_.selectedControlName = null;
_.selectedParamsDef = null;
_.selectedParamsEditor = null;
_.selectedResultsDef = null;
function ServerPluginControlView$1_0(this$0, val$controlNamesItem, val$executeButton){
  this.this$0 = this$0;
  this.val$controlNamesItem = val$controlNamesItem;
  this.val$executeButton = val$executeButton;
}

defineSeed(1633, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ServerPluginControlView$1_0);
_.onChanged = function onChanged(event_0){
  var def;
  this.this$0.selectedControlName = dynamicCast($getValue_2(event_0), Q$String);
  def = $getControlDefinition(this.this$0, this.this$0.selectedControlName);
  this.this$0.selectedParamsDef = def.parameters;
  this.this$0.selectedResultsDef = def.results;
  destroyMembers(this.this$0.resultsLayout);
  $setAttribute_24(this.this$0.resultsLayout, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  $showParameters(this.this$0);
  !$getIcon(this.val$controlNamesItem, $getAttributeAsString(this.val$executeButton, 'name')) && $setIcons(this.val$controlNamesItem, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [this.val$executeButton]));
}
;
_.this$0 = null;
_.val$controlNamesItem = null;
_.val$executeButton = null;
function ServerPluginControlView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1634, 1, makeCastMap([Q$EventHandler, Q$FormItemClickHandler]), ServerPluginControlView$2_0);
_.onFormItemClick = function onFormItemClick(event_0){
  var $e0, msg, params, pluginKey, pm;
  try {
    params = $getParameters(this.this$0);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$IllegalStateException)) {
      msg = new Message_8(($clinit_Enhanced() , 'Please enter valid parameters'), ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient)));
      $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
      return;
    }
     else 
      throw $e0;
  }
  pm = dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync);
  pluginKey = createServerPluginKey(this.this$0.plugin.type_0, this.this$0.plugin.name_0);
  $invokeServerPluginControl(pm, pluginKey, this.this$0.selectedControlName, params, new ServerPluginControlView$2$1_0(this));
}
;
_.this$0 = null;
function $onSuccess_23(this$static, results){
  $showResults(this$static.this$1.this$0, results);
}

function ServerPluginControlView$2$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1635, 1, {}, ServerPluginControlView$2$1_0);
_.onFailure = function onFailure_23(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to invoke the control'), caught);
}
;
_.onSuccess_0 = function onSuccess_23(results){
  $onSuccess_23(this, dynamicCast(results, Q$ServerPluginControlResults));
}
;
_.this$1 = null;
function ServerPluginControlView$3_0(val$results){
  this.val$results = val$results;
}

defineSeed(1636, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), ServerPluginControlView$3_0);
_.onClick_0 = function onClick_5(event_0){
  var win;
  win = new ErrorMessageWindow_1(($clinit_Enhanced() , 'Error'), this.val$results.errorMessage_0);
  $show(win);
}
;
_.val$results = null;
function $prepareControlsSection(this$static, plugin){
  var pluginKey;
  pluginKey = createServerPluginKey(plugin.type_0, plugin.name_0);
  $getServerPluginControlDefinitions(this$static.pluginManager, pluginKey, new ServerPluginDetailView$3_0(this$static, plugin));
}

function $prepareDetailsSection_0(this$static, plugin){
  var ampsItem, descItem, displayNameItem, enabledItem, form, img, kindItem, md5Item, mtimeItem, nameItem, pathItem, section, typeItem, versionItem;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 4):(form.config_0['numCols'] = 4 , undefined);
  nameItem = new StaticTextItem_2('name', ($clinit_Enhanced() , 'Name'));
  $setValue_7(nameItem, plugin.name_0);
  displayNameItem = new StaticTextItem_2('displayName', 'Display Name');
  $setValue_7(displayNameItem, plugin.displayName);
  versionItem = new StaticTextItem_2('version', 'Version');
  $setValue_7(versionItem, plugin.version_0);
  md5Item = new StaticTextItem_2('MD5', 'MD5');
  $setValue_7(md5Item, plugin.md5);
  pathItem = new StaticTextItem_2('path', 'Path');
  $setValue_7(pathItem, plugin.path);
  ampsItem = new StaticTextItem_2('ampsVersion', 'AMPS Version');
  $setValue_7(ampsItem, plugin.ampsVersion);
  descItem = new StaticTextItem_2('desc', 'Description');
  $setValue_7(descItem, plugin.description);
  mtimeItem = new StaticTextItem_2('mtime', 'Last Updated');
  $setValue_7(mtimeItem, format_30(valueOf_45(plugin.mtime), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_MEDIUM)));
  kindItem = new StaticTextItem_2('kind', 'Kind');
  switch (plugin.deployment.ordinal) {
    case 0:
      $setValue_7(kindItem, 'Agent');
      break;
    case 1:
      $setValue_7(kindItem, 'Server');
  }
  enabledItem = new CanvasItem_2('enabled', 'Enabled?');
  img = new Img_2(getAvailabilityIcon(plugin.enabled?TRUE:FALSE), 16, 16);
  $setAttribute_28(enabledItem, 'canvas', !img?null:$getOrCreateJsObj_0(img));
  typeItem = new StaticTextItem_2('type', 'Type');
  $setValue_7(typeItem, plugin.type_0);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [displayNameItem, nameItem, versionItem, ampsItem, md5Item, kindItem, descItem, pathItem, mtimeItem, enabledItem, typeItem]));
  section = new SectionStackSection_1('Details');
  $setExpanded(section, TRUE);
  $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form]));
  this$static.detailsSection = section;
  ++this$static.initSectionCount;
  return;
}

function $prepareHelpSection_0(this$static, plugin){
  var help, section;
  if (plugin.help != null && plugin.help.length > 0) {
    section = new SectionStackSection_1(($clinit_Enhanced() , 'Help'));
    $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    help = new Label_4(plugin.help);
    $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [help]));
    this$static.helpSection = section;
  }
  ++this$static.initSectionCount;
  return;
}

function $preparePluginConfigurationSection(this$static, plugin){
  var pluginKey;
  pluginKey = createServerPluginKey(plugin.type_0, plugin.name_0);
  $getServerPluginConfigurationDefinition(this$static.pluginManager, pluginKey, new ServerPluginDetailView$4_0(this$static, plugin, pluginKey));
  return;
}

function $prepareScheduledJobsSection(this$static, plugin){
  var pluginKey;
  pluginKey = createServerPluginKey(plugin.type_0, plugin.name_0);
  $getServerPluginScheduledJobsDefinition(this$static.pluginManager, pluginKey, new ServerPluginDetailView$5_0(this$static, plugin, pluginKey));
  return;
}

function ServerPluginDetailView_0(pluginId){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.pluginManager = dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync);
  this.pluginId = pluginId;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  this.sectionStack = new SectionStack_0;
  $setAttribute_24(this.sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
  $setAttribute_24(this.sectionStack, 'width', '100%', true);
  $setAttribute_24(this.sectionStack, 'height', '100%', true);
  $setMargin(this.sectionStack, valueOf_44(5));
  $setAttribute_24(this.sectionStack, 'overflow', VISIBLE.value_0, false);
}

defineSeed(1637, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ServerPluginDetailView_0);
_.onDraw_0 = function onDraw_6(){
  $run_0(new ServerPluginDetailView$2_0(this));
}
;
_.onInit = function onInit_10(){
  $onInit(this);
  $onInit_Layout(this);
  $getServerPlugin(this.pluginManager, this.pluginId, new ServerPluginDetailView$1_0(this));
}
;
_.controlsSection = null;
_.detailsSection = null;
_.helpSection = null;
_.initSectionCount = 0;
_.pluginConfigSection = null;
_.pluginId = 0;
_.scheduledJobsSection = null;
_.sectionStack = null;
function $onSuccess_24(this$static, plugin){
  $prepareDetailsSection_0(this$static.this$0, plugin);
  $prepareHelpSection_0(this$static.this$0, plugin);
  $prepareControlsSection(this$static.this$0, plugin);
  $preparePluginConfigurationSection(this$static.this$0, plugin);
  $prepareScheduledJobsSection(this$static.this$0, plugin);
}

function ServerPluginDetailView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1638, 1, {}, ServerPluginDetailView$1_0);
_.onFailure = function onFailure_24(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load plugin data'), caught);
}
;
_.onSuccess_0 = function onSuccess_24(plugin){
  $onSuccess_24(this, dynamicCast(plugin, Q$ServerPlugin));
}
;
_.this$0 = null;
function $run_0(this$static){
  var elapsedMillis;
  if (this$static.this$0.initSectionCount >= 5) {
    !!this$static.this$0.detailsSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.detailsSection);
    !!this$static.this$0.helpSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.helpSection);
    !!this$static.this$0.controlsSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.controlsSection);
    !!this$static.this$0.pluginConfigSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.pluginConfigSection);
    !!this$static.this$0.scheduledJobsSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.scheduledJobsSection);
    $addMember(this$static.this$0, this$static.this$0.sectionStack);
    $markForRedraw(this$static.this$0);
  }
   else {
    elapsedMillis = sub(fromDouble(currentTimeMillis0()), this$static.startTime);
    gt(elapsedMillis, P4e20_longLit) && (this$static.this$0.initSectionCount = 5);
    $schedule(this$static, 100);
  }
}

function ServerPluginDetailView$2_0(this$0){
  $clinit_Timer();
  this.this$0 = this$0;
  this.startTime = fromDouble(currentTimeMillis0());
}

defineSeed(1639, 73, makeCastMap([Q$Timer]), ServerPluginDetailView$2_0);
_.run = function run_4(){
  $run_0(this);
}
;
_.this$0 = null;
function $onSuccess_25(this$static, result){
  var section;
  if (!!result && result.size_0 != 0) {
    section = new SectionStackSection_1(($clinit_Enhanced() , 'Controls'));
    $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addItemJS(section, $getOrCreateJsObj_0(new ServerPluginControlView_0(this$static.val$plugin, result)));
    this$static.this$0.controlsSection = section;
  }
  ++this$static.this$0.initSectionCount;
}

function ServerPluginDetailView$3_0(this$0, val$plugin){
  this.this$0 = this$0;
  this.val$plugin = val$plugin;
}

defineSeed(1640, 1, {}, ServerPluginDetailView$3_0);
_.onFailure = function onFailure_25(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load plugin data'), caught);
}
;
_.onSuccess_0 = function onSuccess_25(result){
  $onSuccess_25(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$0 = null;
_.val$plugin = null;
function $onSuccess_26(this$static, def){
  var buttons, config, editorPC, layout, resetButtonPC, saveButtonPC, section;
  if (def) {
    layout = new EnhancedVLayout_0;
    buttons = new ToolStrip_0;
    $isCreated_1(buttons)?$setProperty_3(buttons, 'width', '100%'):(buttons.config_0['width'] = '100%' , undefined);
    $isCreated_1(buttons)?undefined:(buttons.config_0['extraSpace'] = 10 , undefined);
    $isCreated_1(buttons)?$setProperty_0(buttons, 'membersMargin', 5):(buttons.config_0['membersMargin'] = 5 , undefined);
    $setLayoutMargin(buttons, valueOf_44(5));
    saveButtonPC = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
    resetButtonPC = new EnhancedIButton_1('Reset');
    config = this$static.val$plugin.pluginConfiguration;
    editorPC = new ConfigurationEditor_1(def, config);
    $setAttribute_24(editorPC, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
    $addPropertyValueChangeListener(editorPC, new ServerPluginDetailView$4$1_0(saveButtonPC));
    $addClickHandler(resetButtonPC, new ServerPluginDetailView$4$2_0(editorPC));
    $addClickHandler(saveButtonPC, new ServerPluginDetailView$4$3_0(this$static, editorPC, this$static.val$pluginKey));
    $addMember(buttons, saveButtonPC);
    $addMember(buttons, resetButtonPC);
    $addMember(layout, buttons);
    $addMember(layout, editorPC);
    section = new SectionStackSection_1('Plugin Configuration');
    $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [layout]));
    this$static.this$0.pluginConfigSection = section;
  }
  ++this$static.this$0.initSectionCount;
}

function ServerPluginDetailView$4_0(this$0, val$plugin, val$pluginKey){
  this.this$0 = this$0;
  this.val$plugin = val$plugin;
  this.val$pluginKey = val$pluginKey;
}

defineSeed(1641, 1, {}, ServerPluginDetailView$4_0);
_.onFailure = function onFailure_26(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load plugin data'), caught);
}
;
_.onSuccess_0 = function onSuccess_26(def){
  $onSuccess_26(this, dynamicCast(def, Q$ConfigurationDefinition));
}
;
_.this$0 = null;
_.val$plugin = null;
_.val$pluginKey = null;
function ServerPluginDetailView$4$1_0(val$saveButtonPC){
  this.val$saveButtonPC = val$saveButtonPC;
}

defineSeed(1642, 1, makeCastMap([Q$PropertyValueChangeListener]), ServerPluginDetailView$4$1_0);
_.propertyValueChanged = function propertyValueChanged(event_0){
  var invalidPropertyNames;
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    invalidPropertyNames.size_1() == 0?$enable(this.val$saveButtonPC):$disable(this.val$saveButtonPC);
  }
}
;
_.val$saveButtonPC = null;
function ServerPluginDetailView$4$2_0(val$editorPC){
  this.val$editorPC = val$editorPC;
}

defineSeed(1643, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ServerPluginDetailView$4$2_0);
_.onClick = function onClick_6(event_0){
  $reset_2(this.val$editorPC);
}
;
_.val$editorPC = null;
function ServerPluginDetailView$4$3_0(this$1, val$editorPC, val$pluginKey){
  this.this$1 = this$1;
  this.val$editorPC = val$editorPC;
  this.val$pluginKey = val$pluginKey;
}

defineSeed(1644, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ServerPluginDetailView$4$3_0);
_.onClick = function onClick_7(event_0){
  var msg;
  if (!$validate_1(this.val$editorPC.topLevelPropertiesValuesManager).value_0) {
    msg = new Message_8(($clinit_Enhanced() , 'Please enter valid settings'), ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient)));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
    return;
  }
  $updateServerPluginConfiguration(this.this$1.this$0.pluginManager, this.val$pluginKey, this.val$editorPC.configuration, new ServerPluginDetailView$4$3$1_0);
}
;
_.this$1 = null;
_.val$editorPC = null;
_.val$pluginKey = null;
function $onSuccess_27(){
  var m_0;
  m_0 = new Message_0(($clinit_Enhanced() , 'The settings have been saved.'));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), m_0);
}

function ServerPluginDetailView$4$3$1_0(){
}

defineSeed(1645, 1, {}, ServerPluginDetailView$4$3$1_0);
_.onFailure = function onFailure_27(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to save the settings'), caught);
}
;
_.onSuccess_0 = function onSuccess_27(result){
  $onSuccess_27(throwClassCastExceptionUnlessNull(result));
}
;
function $onSuccess_28(this$static, def){
  var buttons, config, editorSJ, layout, resetButtonSJ, saveButtonSJ, section;
  if (def) {
    layout = new EnhancedVLayout_0;
    buttons = new ToolStrip_0;
    $isCreated_1(buttons)?$setProperty_3(buttons, 'width', '100%'):(buttons.config_0['width'] = '100%' , undefined);
    $isCreated_1(buttons)?undefined:(buttons.config_0['extraSpace'] = 10 , undefined);
    $isCreated_1(buttons)?$setProperty_0(buttons, 'membersMargin', 5):(buttons.config_0['membersMargin'] = 5 , undefined);
    $setLayoutMargin(buttons, valueOf_44(5));
    saveButtonSJ = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
    $addMember(buttons, saveButtonSJ);
    resetButtonSJ = new EnhancedIButton_1('Reset');
    $addMember(buttons, resetButtonSJ);
    config = this$static.val$plugin.scheduledJobsConfiguration;
    editorSJ = new ConfigurationEditor_1(def, config);
    $setAttribute_24(editorSJ, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
    $addPropertyValueChangeListener(editorSJ, new ServerPluginDetailView$5$1_0(saveButtonSJ));
    $addClickHandler(resetButtonSJ, new ServerPluginDetailView$5$2_0(editorSJ));
    $addClickHandler(saveButtonSJ, new ServerPluginDetailView$5$3_0(this$static, editorSJ, this$static.val$pluginKey));
    $addMember(layout, buttons);
    $addMember(layout, editorSJ);
    section = new SectionStackSection_1('Scheduled Jobs');
    $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [layout]));
    this$static.this$0.scheduledJobsSection = section;
  }
  ++this$static.this$0.initSectionCount;
}

function ServerPluginDetailView$5_0(this$0, val$plugin, val$pluginKey){
  this.this$0 = this$0;
  this.val$plugin = val$plugin;
  this.val$pluginKey = val$pluginKey;
}

defineSeed(1646, 1, {}, ServerPluginDetailView$5_0);
_.onFailure = function onFailure_28(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load plugin data'), caught);
}
;
_.onSuccess_0 = function onSuccess_28(def){
  $onSuccess_28(this, dynamicCast(def, Q$ConfigurationDefinition));
}
;
_.this$0 = null;
_.val$plugin = null;
_.val$pluginKey = null;
function ServerPluginDetailView$5$1_0(val$saveButtonSJ){
  this.val$saveButtonSJ = val$saveButtonSJ;
}

defineSeed(1647, 1, makeCastMap([Q$PropertyValueChangeListener]), ServerPluginDetailView$5$1_0);
_.propertyValueChanged = function propertyValueChanged_0(event_0){
  var invalidPropertyNames;
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    invalidPropertyNames.size_1() == 0?$enable(this.val$saveButtonSJ):$disable(this.val$saveButtonSJ);
  }
}
;
_.val$saveButtonSJ = null;
function ServerPluginDetailView$5$2_0(val$editorSJ){
  this.val$editorSJ = val$editorSJ;
}

defineSeed(1648, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ServerPluginDetailView$5$2_0);
_.onClick = function onClick_8(event_0){
  $reset_2(this.val$editorSJ);
}
;
_.val$editorSJ = null;
function ServerPluginDetailView$5$3_0(this$1, val$editorSJ, val$pluginKey){
  this.this$1 = this$1;
  this.val$editorSJ = val$editorSJ;
  this.val$pluginKey = val$pluginKey;
}

defineSeed(1649, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ServerPluginDetailView$5$3_0);
_.onClick = function onClick_9(event_0){
  var msg;
  if (!$validate_1(this.val$editorSJ.topLevelPropertiesValuesManager).value_0) {
    msg = new Message_8(($clinit_Enhanced() , 'Please enter valid settings'), ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient)));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
    return;
  }
  $updateServerPluginScheduledJobs(this.this$1.this$0.pluginManager, this.val$pluginKey, this.val$editorSJ.configuration, new ServerPluginDetailView$5$3$1_0);
}
;
_.this$1 = null;
_.val$editorSJ = null;
_.val$pluginKey = null;
function $onSuccess_29(){
  var m_0;
  m_0 = new Message_0(($clinit_Enhanced() , 'The settings have been saved.'));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), m_0);
}

function ServerPluginDetailView$5$3$1_0(){
}

defineSeed(1650, 1, {}, ServerPluginDetailView$5$3$1_0);
_.onFailure = function onFailure_29(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to save the settings'), caught);
}
;
_.onSuccess_0 = function onSuccess_29(result){
  $onSuccess_29(throwClassCastExceptionUnlessNull(result));
}
;
function $clinit_ServerPluginTableView(){
  $clinit_ServerPluginTableView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_2 = new ViewName_2('ServerPlugins', ($clinit_Enhanced() , 'Server Plugins'), ($clinit_IconEnum() , PLUGIN_0));
  ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_CONFIGURATION_VIEW_ID + '/' + VIEW_ID_2;
}

function $getSelectedIds_0(selections){
  var i, ids, selection, selection$index, selection$max;
  if (selections == null) {
    return initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, 0, 1);
  }
  ids = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selections.length, 1);
  i = 0;
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    ids[i++] = getAttributeAsInt(selection.jsObj, 'id').value_0;
  }
  return ids;
}

function $getSelectedNames_0(selections){
  var ids, selection, selection$index, selection$max;
  if (selections == null) {
    return new ArrayList_1(0);
  }
  ids = new ArrayList_1(selections.length);
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    $add_3(ids, getAttribute(selection.jsObj, 'name'));
  }
  return ids;
}

function ServerPluginTableView_0(){
  $clinit_ServerPluginTableView();
  TableSection_0.call(this, null);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setDataSource(this, new ServerPluginTableView$ServerPluginDataSource_0(this));
}

defineSeed(1651, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ServerPluginTableView_0);
_.configureTable = function configureTable_2(){
  var fields, listGrid, pluginUploadForm, restartMasterPCButton, scanForUpdatesButton, showUndeployedButton;
  fields = $getListGridFields_0(dynamicCast(this.dataSource_1, Q$ServerPluginTableView$ServerPluginDataSource));
  listGrid = this.listGrid;
  $setFields_1(listGrid, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $sort(listGrid, 'name', ($clinit_SortDirection() , ASCENDING));
  $addTableAction(this, ($clinit_Enhanced() , 'Enable'), 'Are You Sure?', null, new ServerPluginTableView$1_0(this, this, ($clinit_TableActionEnablement() , ANY_1), initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , MANAGE_SETTINGS)])));
  $addTableAction(this, 'Disable', null, null, new ServerPluginTableView$2_0(this, this, ANY_1, initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [MANAGE_SETTINGS])));
  $addTableAction(this, 'Undeploy', null, null, new ServerPluginTableView$3_0(this, this, ANY_1, initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [MANAGE_SETTINGS])));
  $addTableAction(this, 'Purge', 'Are You Sure?', null, new ServerPluginTableView$4_0(this, this, ANY_1, initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [MANAGE_SETTINGS])));
  scanForUpdatesButton = new EnhancedIButton_1('Scan For Updates');
  $addClickHandler(scanForUpdatesButton, new ServerPluginTableView$5_0(this));
  restartMasterPCButton = new EnhancedIButton_1('Restart Master Plugin Container');
  $addClickHandler(restartMasterPCButton, new ServerPluginTableView$6_0(this));
  showUndeployedButton = new EnhancedIButton_1('Show Undeployed');
  $addClickHandler(showUndeployedButton, new ServerPluginTableView$7_0(this, showUndeployedButton));
  pluginUploadForm = new PluginFileUploadForm_0('Upload Plugin');
  $add_3(this.extraWidgetsAboveFooter, scanForUpdatesButton);
  $add_3(this.extraWidgetsAboveFooter, restartMasterPCButton);
  $add_3(this.extraWidgetsAboveFooter, showUndeployedButton);
  $add_3(this.extraWidgetsAboveFooter, pluginUploadForm);
  $configureTable(this);
}
;
_.getDetailsView_0 = function getDetailsView_1(id){
  return new ServerPluginDetailView_0(id.value_0);
}
;
_.showUndeployed = false;
var VIEW_ID_2;
function ServerPluginTableView$1_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1652, 1607, {}, ServerPluginTableView$1_0);
_.executeAction = function executeAction_3(selections, actionValue){
  var selectedIds;
  selectedIds = $getSelectedIds_0(selections);
  $enableServerPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), selectedIds, new ServerPluginTableView$1$1_0(this));
}
;
_.this$0 = null;
function $onSuccess_30(this$static, result){
  var msg;
  msg = new Message_7('Enabled server plugins: ' + ($clinit_Enhanced() , result.toString$()), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$1.this$0, false);
}

function ServerPluginTableView$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1653, 1, {}, ServerPluginTableView$1$1_0);
_.onFailure = function onFailure_30(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to enable server plugins.') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_30(result){
  $onSuccess_30(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$1 = null;
function ServerPluginTableView$2_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1654, 1607, {}, ServerPluginTableView$2_0);
_.executeAction = function executeAction_4(selections, actionValue){
  var message, selectedNames;
  selectedNames = $getSelectedNames_0(selections);
  message = '<b>Warning!<\/b><br/>\nThe following server plugins are about to be disabled:<br/>\n' + ($clinit_Enhanced() , selectedNames.toString$()) + '<br/>\nAre you sure you want to disable these?';
  ask(message, new ServerPluginTableView$2$1_0(this, selections));
}
;
_.this$0 = null;
function ServerPluginTableView$2$1_0(this$1, val$selections){
  this.this$1 = this$1;
  this.val$selections = val$selections;
}

defineSeed(1655, 1, {}, ServerPluginTableView$2$1_0);
_.execute_3 = function execute_13(confirmed){
  var selectedIds;
  if (confirmed.value_0) {
    selectedIds = $getSelectedIds_0(this.val$selections);
    $disableServerPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), selectedIds, new ServerPluginTableView$2$1$1_0(this));
  }
   else {
    $refreshTableInfo(this.this$1.this$0);
  }
}
;
_.this$1 = null;
_.val$selections = null;
function $onSuccess_31(this$static, result){
  var msg;
  msg = new Message_7('Disabled server plugins: ' + ($clinit_Enhanced() , result.toString$()), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$2.this$1.this$0, false);
}

function ServerPluginTableView$2$1$1_0(this$2){
  this.this$2 = this$2;
}

defineSeed(1656, 1, {}, ServerPluginTableView$2$1$1_0);
_.onFailure = function onFailure_31(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to disable server plugins.') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$2.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_31(result){
  $onSuccess_31(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$2 = null;
function ServerPluginTableView$3_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1657, 1607, {}, ServerPluginTableView$3_0);
_.executeAction = function executeAction_5(selections, actionValue){
  var message, selectedNames;
  selectedNames = $getSelectedNames_0(selections);
  message = '<b>Warning!<\/b><br/>\nThe following server plugins are about to be undeployed:<br/>\n' + ($clinit_Enhanced() , selectedNames.toString$()) + '<br/>\nAre you sure you want to undeploy these?';
  ask(message, new ServerPluginTableView$3$1_0(this, selections));
}
;
_.this$0 = null;
function ServerPluginTableView$3$1_0(this$1, val$selections){
  this.this$1 = this$1;
  this.val$selections = val$selections;
}

defineSeed(1658, 1, {}, ServerPluginTableView$3$1_0);
_.execute_3 = function execute_14(confirmed){
  var selectedIds;
  if (confirmed.value_0) {
    selectedIds = $getSelectedIds_0(this.val$selections);
    $undeployServerPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), selectedIds, new ServerPluginTableView$3$1$1_0(this));
  }
   else {
    $refreshTableInfo(this.this$1.this$0);
  }
}
;
_.this$1 = null;
_.val$selections = null;
function $onSuccess_32(this$static, result){
  var msg;
  msg = new Message_7('Undeployed server plugins: ' + ($clinit_Enhanced() , result.toString$()), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$2.this$1.this$0, false);
}

function ServerPluginTableView$3$1$1_0(this$2){
  this.this$2 = this$2;
}

defineSeed(1659, 1, {}, ServerPluginTableView$3$1$1_0);
_.onFailure = function onFailure_32(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to undeploy server plugins.') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$2.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_32(result){
  $onSuccess_32(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$2 = null;
function ServerPluginTableView$4_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1660, 1607, {}, ServerPluginTableView$4_0);
_.executeAction = function executeAction_6(selections, actionValue){
  var selectedIds;
  selectedIds = $getSelectedIds_0(selections);
  $purgeServerPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), selectedIds, new ServerPluginTableView$4$1_0(this));
}
;
_.isEnabled_0 = function isEnabled_3(selection){
  return this.this$0.showUndeployed && $isEnabled_0(this, selection);
}
;
_.this$0 = null;
function $onSuccess_33(this$static, result){
  var msg;
  msg = new Message_7('Purged server plugins: ' + ($clinit_Enhanced() , result.toString$()) + '.', ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$1.this$0, false);
}

function ServerPluginTableView$4$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1661, 1, {}, ServerPluginTableView$4$1_0);
_.onFailure = function onFailure_33(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to purge server plugins.') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_33(result){
  $onSuccess_33(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$1 = null;
function ServerPluginTableView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1662, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ServerPluginTableView$5_0);
_.onClick = function onClick_10(event_0){
  $scanAndRegister(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), new ServerPluginTableView$5$1_0(this));
}
;
_.this$0 = null;
function $onSuccess_34(this$static){
  var msg;
  msg = new Message_7(($clinit_Enhanced() , 'Finished scanning for updated plugins'), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$1.this$0, false);
}

function ServerPluginTableView$5$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1663, 1, {}, ServerPluginTableView$5$1_0);
_.onFailure = function onFailure_34(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to scan for updated plugins.') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_34(result){
  $onSuccess_34(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
function ServerPluginTableView$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1664, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ServerPluginTableView$6_0);
_.onClick = function onClick_11(event_0){
  var msg;
  msg = new Message_7(($clinit_Enhanced() , 'Restarting the master plugin container...'), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $restartMasterPluginContainer(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), new ServerPluginTableView$6$1_0(this));
}
;
_.this$0 = null;
function $onSuccess_35(this$static){
  var msg;
  msg = new Message_7(($clinit_Enhanced() , 'Master plugin container has been restarted.'), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$1.this$0, false);
}

function ServerPluginTableView$6$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1665, 1, {}, ServerPluginTableView$6$1_0);
_.onFailure = function onFailure_35(caught){
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to restart the master plugin container') + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_35(result){
  $onSuccess_35(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
function ServerPluginTableView$7_0(this$0, val$showUndeployedButton){
  this.this$0 = this$0;
  this.val$showUndeployedButton = val$showUndeployedButton;
}

defineSeed(1666, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ServerPluginTableView$7_0);
_.onClick = function onClick_12(event_0){
  this.this$0.showUndeployed = !this.this$0.showUndeployed;
  if (this.this$0.showUndeployed) {
    $setTitle_0(this.val$showUndeployedButton, ($clinit_Enhanced() , 'Hide Undeployed'));
    $showField(this.this$0.listGrid, 'deployed');
  }
   else {
    $setTitle_0(this.val$showUndeployedButton, ($clinit_Enhanced() , 'Show Undeployed'));
    $hideField(this.this$0.listGrid, 'deployed');
  }
  $refresh(this.this$0, false);
}
;
_.this$0 = null;
_.val$showUndeployedButton = null;
function $copyValues_0(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'name', from.displayName);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_14(record, 'lastUpdate', new Date_2(from.mtime));
  $setAttribute_13(record, 'enabled', getAvailabilityIcon(($clinit_Boolean() , from.enabled?TRUE:FALSE)));
  $setAttribute_13(record, 'deployed', getAvailabilityIcon(from.status_0 == ($clinit_PluginStatusType() , INSTALLED_1)?TRUE:FALSE));
  $setAttribute_13(record, 'version', from.version_0);
  return record;
}

function $executeFetch_0(this$static, request, response){
  $getServerPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), this$static.this$0.showUndeployed, new ServerPluginTableView$ServerPluginDataSource$1_0(this$static, response, request));
}

function $getListGridFields_0(){
  var deployedField, descriptionField, enabledField, fields, idField, lastUpdateField, nameField, versionField;
  fields = new ArrayList_0;
  idField = new ListGridField_3('id', 'ID');
  idField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, idField);
  nameField = new ListGridField_3('name', 'Name');
  setCheck(fields.array, fields.size_0++, nameField);
  descriptionField = new ListGridField_3('description', 'Description');
  setCheck(fields.array, fields.size_0++, descriptionField);
  lastUpdateField = new ListGridField_3('lastUpdate', 'Last Updated');
  $clinit_TimestampCellFormatter();
  prepareDateField(lastUpdateField, getAttribute(lastUpdateField.jsObj, 'name'));
  setCheck(fields.array, fields.size_0++, lastUpdateField);
  enabledField = new ListGridField_3('enabled', 'Enabled?');
  $setAttribute_13(enabledField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(enabledField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  setCheck(fields.array, fields.size_0++, enabledField);
  deployedField = new ListGridField_3('deployed', 'Deployed?');
  $setAttribute_13(deployedField, 'type', IMAGE_0.value_0);
  $setAttribute_13(deployedField, 'align', CENTER_0.value_0);
  deployedField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, deployedField);
  versionField = new ListGridField_3('version', 'Version');
  versionField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, versionField);
  idField.jsObj['width'] = 100;
  nameField.jsObj['width'] = '30%';
  descriptionField.jsObj['width'] = '*';
  lastUpdateField.jsObj['width'] = '20%';
  enabledField.jsObj['width'] = 65;
  deployedField.jsObj['width'] = 75;
  versionField.jsObj['width'] = 100;
  return fields;
}

function ServerPluginTableView$ServerPluginDataSource_0(this$0){
  var fields_0, idField;
  $clinit_RPCDataSource();
  var fields;
  this.this$0 = this$0;
  RPCDataSource_0.call(this);
  fields = (fields_0 = new ArrayList_0 , idField = new DataSourceIntegerField_2('id', 'ID', 50) , $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setAttribute_8(idField, 'hidden', TRUE) , setCheck(fields_0.array, fields_0.size_0++, idField) , fields_0);
  $addFields(this, fields);
}

defineSeed(1667, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$ServerPluginTableView$ServerPluginDataSource]), ServerPluginTableView$ServerPluginDataSource_0);
_.copyValues = function copyValues_2(from){
  return null;
}
;
_.copyValues_0 = function copyValues_3(from){
  return $copyValues_0(dynamicCast(from, Q$ServerPlugin));
}
;
_.executeFetch = function executeFetch_0(request, response, criteria){
  $executeFetch_0(this, request, response, dynamicCast(criteria, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_0(request){
  return null;
}
;
_.this$0 = null;
function $onFailure(this$static, t){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load plugin data'), t);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_36(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$1, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ServerPluginTableView$ServerPluginDataSource$1_0(this$1, val$response, val$request){
  this.this$1 = this$1;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1668, 1, {}, ServerPluginTableView$ServerPluginDataSource$1_0);
_.onFailure = function onFailure_36(t){
  $onFailure(this, t);
}
;
_.onSuccess_0 = function onSuccess_36(result){
  $onSuccess_36(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function $clinit_SystemSettingsView(){
  $clinit_SystemSettingsView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_3 = new ViewName_2('SystemSettings', ($clinit_Enhanced() , 'System Settings'), ($clinit_IconEnum() , CONFIGURE));
  ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_CONFIGURATION_VIEW_ID + '/' + VIEW_ID_3;
}

function $convertMillisToDays(num){
  return num == null?'0':'' + toString_8(div(__parseAndValidateLong(num), P5265c00_longLit));
}

function $convertMillisToHours(num){
  return num == null?'0':'' + toString_8(div(__parseAndValidateLong(num), P36ee80_longLit));
}

function $convertMillisToMinutes(num){
  return num == null?'0':'' + toString_8(div(__parseAndValidateLong(num), Pea60_longLit));
}

function $getSystemSettingsDefinition(config, driftPlugins){
  var allDefinitions, baselineGroup, dataManagerGroup, def, defEntry, defEntry$iterator, driftGroup, entry, entry$iterator, generalGroup, ldapGroup, options, pd, prop, prop$array, prop$index, prop$max, propertyDef, propertyName;
  def = new ConfigurationDefinition_1('sysset', ($clinit_Enhanced() , 'System Settings'));
  generalGroup = new PropertyGroupDefinition_1('general');
  generalGroup.displayName = 'General Configuration Properties';
  generalGroup.defaultHidden = false;
  generalGroup.order = 0;
  dataManagerGroup = new PropertyGroupDefinition_1('datamanager');
  dataManagerGroup.displayName = 'Data Manager Configuration Properties';
  dataManagerGroup.defaultHidden = false;
  dataManagerGroup.order = 1;
  baselineGroup = new PropertyGroupDefinition_1('baseline');
  baselineGroup.displayName = 'Automatic Baseline Configuration Properties';
  baselineGroup.defaultHidden = false;
  baselineGroup.order = 2;
  ldapGroup = new PropertyGroupDefinition_1('ldap');
  ldapGroup.displayName = 'LDAP Configuration Properties';
  $setDefaultHidden(ldapGroup, ($clinit_Boolean() , !$equalsIgnoreCase('true', $getSimpleValue(config, ($clinit_SystemSetting() , LDAP_BASED_JAAS_PROVIDER).internalName, 'false'))));
  ldapGroup.order = 3;
  driftGroup = new PropertyGroupDefinition_1('drift');
  driftGroup.displayName = 'Drift Server Configuration Settings';
  driftGroup.order = 4;
  driftGroup.defaultHidden = false;
  for (prop$array = $VALUES_63 , prop$index = 0 , prop$max = prop$array.length; prop$index < prop$max; ++prop$index) {
    prop = prop$array[prop$index];
    if (prop.readOnly) {
      continue;
    }
    pd = new PropertyDefinitionSimple_1(prop.internalName, null, prop.requiringValue, prop.type_0);
    $put_6(def, pd);
    switch (prop.ordinal) {
      case 0:
        pd.description = 'A URL to the server GUI, used mainly within alert email notifications.';
        pd.displayName = 'GUI Console URL';
        pd.propertyGroupDefinition = generalGroup;
        pd.defaultValue = 'http://localhost:7080';
        break;
      case 1:
        pd.description = 'If this amount of time passes without hearing from an agent, that quiet agent will be considered down. This value is specified in minutes.';
        pd.displayName = 'Agent Max Quiet Time Allowed';
        pd.propertyGroupDefinition = generalGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P3_longLit), null)]));
        pd.defaultValue = '5';
        break;
      case 34:
        pd.description = 'If this amount of time passes without any user interaction in the browser, the session is considered as expired and user is aked to log in again. This value is specified in hours.';
        pd.displayName = 'GUI Session Timeout';
        pd.propertyGroupDefinition = generalGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P1_longLit), null)]));
        pd.defaultValue = '1';
        break;
      case 2:
        pd.description = 'Determines if the server will allow agents to auto-update themselves. You will not be able to download agent distributions from the server if this is disabled.';
        pd.displayName = 'Enable Agent Auto-Updates';
        pd.propertyGroupDefinition = generalGroup;
        pd.defaultValue = 'true';
        break;
      case 3:
        pd.description = 'If enabled, the server will enter debug mode.';
        pd.displayName = 'Enable Debug Mode';
        pd.propertyGroupDefinition = generalGroup;
        pd.defaultValue = 'false';
        break;
      case 4:
        pd.description = 'If enabled, any experimental features that exist in the current product will be available.';
        pd.displayName = 'Enable Experimental Features';
        pd.propertyGroupDefinition = generalGroup;
        pd.defaultValue = 'false';
        break;
      case 5:
        pd.description = 'How often database maintenance is performed (for example, vacuuming if using Postgres). This is specified in hours.';
        pd.displayName = 'Database Maintenance Period';
        pd.propertyGroupDefinition = dataManagerGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P1_longLit), null)]));
        pd.defaultValue = '1';
        break;
      case 6:
        pd.description = 'How old availability data must be before being purged from the database. This is specified in days.';
        pd.displayName = 'Delete Availability Data Older Than';
        pd.propertyGroupDefinition = dataManagerGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P1_longLit), null)]));
        pd.defaultValue = '365';
        break;
      case 7:
        pd.description = 'How old alert history items must be before being purged from the database. This is specified in days.';
        pd.displayName = 'Delete Alerts Older Than';
        pd.propertyGroupDefinition = dataManagerGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P1_longLit), null)]));
        pd.defaultValue = '31';
        break;
      case 8:
        pd.description = 'How old measurement trait data must be before being purged from the database. This is specified in days.';
        pd.displayName = 'Delete Measurement Traits Older Than';
        pd.propertyGroupDefinition = dataManagerGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P1_longLit), null)]));
        pd.defaultValue = '365';
        break;
      case 9:
        pd.description = 'How old response time data must be before being purged from the database. This is specified in days.';
        pd.displayName = 'Delete Response Time Data Older Than';
        pd.propertyGroupDefinition = dataManagerGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P1_longLit), null)]));
        pd.defaultValue = '31';
        break;
      case 10:
        pd.description = 'How old event data must be before being purged from the database. This is specified in days.';
        pd.displayName = 'Delete Events Older Than';
        pd.propertyGroupDefinition = dataManagerGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P1_longLit), null)]));
        pd.defaultValue = '14';
        break;
      case 11:
        pd.description = 'How old unused and orphaned drift files must be before being purged from backend storage. This is specified in days.';
        pd.displayName = 'Delete Unused Drift Files Older Than';
        pd.propertyGroupDefinition = dataManagerGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P1_longLit), null)]));
        pd.defaultValue = '31';
        break;
      case 12:
        pd.description = 'If enabled, certain database tables will be re-indexed periodically.';
        pd.displayName = 'Reindex Data Tables Nightly';
        pd.propertyGroupDefinition = dataManagerGroup;
        pd.defaultValue = 'true';
        break;
      case 13:
        pd.description = 'The frequency which the auto-calculation of baselines will be performed. If 0, baseline auto-calculation is disabled. This is specified in days. Maximum value is Baseline Dataset.';
        pd.displayName = 'Baseline Calculation Frequency';
        pd.propertyGroupDefinition = baselineGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P0_longLit), null)]));
        pd.defaultValue = '3';
        break;
      case 14:
        pd.description = 'The amount of past measurement data that is used to determine a baseline. This is specified in days.';
        pd.displayName = 'Baseline Dataset';
        pd.propertyGroupDefinition = baselineGroup;
        $addConstraints(pd, initValues(_3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Constraint, [new IntegerRangeConstraint_1(valueOf_45(P1_longLit), valueOf_45(Pe_longLit))]));
        pd.defaultValue = '7';
        break;
      case 15:
        pd.description = 'Should LDAP be used to determine user identity?';
        pd.displayName = 'Enable LDAP';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = 'false';
        break;
      case 16:
        pd.description = 'URL to the LDAP Server';
        pd.displayName = 'LDAP URL';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = 'ldap://localhost';
        break;
      case 17:
        pd.description = 'Should communication with the LDAP server be done over SSL?';
        pd.displayName = 'SSL';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = 'false';
        break;
      case 18:
        pd.description = 'The LDAP property that contains the user name. Defaults to "cn". If multiple matches are found, the first entry found is used.';
        pd.displayName = 'Login Property';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = 'cn';
        break;
      case 19:
        pd.description = 'Any additional filters to apply when doing the LDAP search. This is useful if the population to authenticate can be identified via a given LDAP property, e.g. RHQUser=true';
        pd.displayName = 'Search Filter';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = '';
        break;
      case 20:
        pd.description = 'LDAP search filter that must return all LDAP groups available for authorization. This is used for LDAP group authorization.';
        pd.displayName = 'Group Search Filter';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = 'objectclass=groupOfNames';
        break;
      case 21:
        pd.description = 'LDAP search filter that is used in conjunction with the group search filter to determine user authorization. This is used for LDAP group authorization.';
        pd.displayName = 'Group Member Filter';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = 'member';
        break;
      case 26:
        pd.description = 'Defines whether to use PosixGroup symantics for group membership check. With PosixGroups the Group Member Filter is usually set to memberUid and the Group Filter to objectclass=posixGroup.';
        pd.displayName = 'Is PosixGroup';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = 'false';
        break;
      case 22:
        pd.description = 'The base of the directory tree to search for usernames and passwords while authenticating users, e.g. ou=People,dc=redhat,dc=com';
        pd.displayName = 'Search Base';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = 'o=RedHat,c=US';
        break;
      case 23:
        pd.description = 'The username to connect to the LDAP server when querying the LDAP user database. This is typically the full LDAP distinguished name (DN) of a manager user, e.g. cn=Manager,dc=redhat,dc=com';
        pd.displayName = 'Username';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = '';
        break;
      case 24:
        pd.description = 'The credentials of the user used to connect to the LDAP server when querying the LDAP user database.';
        pd.displayName = 'Password';
        pd.propertyGroupDefinition = ldapGroup;
        pd.defaultValue = '';
        break;
      case 27:
        pd.description = 'The drift server plugin that manages the persistence of drift-related entities and content.';
        pd.displayName = 'Active Drift Server Plugin';
        pd.propertyGroupDefinition = driftGroup;
        options = new ArrayList_0;
        for (entry$iterator = driftPlugins.entrySet().iterator(); entry$iterator.hasNext();) {
          entry = dynamicCast(entry$iterator.next_0(), Q$Map$Entry);
          $add_3(options, new PropertyDefinitionEnumeration_1(dynamicCast(entry.getValue_1(), Q$String), dynamicCast(entry.getKey_0(), Q$String)));
        }

        $setEnumeratedValues(pd, options);
    }
  }
  allDefinitions = (!def.propertyDefinitions && (def.propertyDefinitions = new LinkedHashMap_0) , def.propertyDefinitions);
  for (defEntry$iterator = allDefinitions.entrySet().iterator(); defEntry$iterator.hasNext();) {
    defEntry = dynamicCast(defEntry$iterator.next_0(), Q$Map$Entry);
    propertyName = dynamicCast(defEntry.getKey_0(), Q$String);
    propertyDef = dynamicCast(defEntry.getValue_1(), Q$PropertyDefinition);
    !dynamicCast(config.properties.get_2(propertyName), Q$Property) && instanceOf(propertyDef, Q$PropertyDefinitionSimple) && dynamicCast(propertyDef, Q$PropertyDefinitionSimple).defaultValue != null && $put_4(config, new PropertySimple_1(propertyName, dynamicCast(propertyDef, Q$PropertyDefinitionSimple).defaultValue));
  }
  return def;
}

function $save(this$static){
  var props, settings, simple, simple$iterator, simpleProperties, value;
  if ($validate_1(this$static.editor.topLevelPropertiesValuesManager).value_0) {
    simpleProperties = $getSimpleProperties(this$static.editor.configuration);
    props = new HashMap_0;
    for (simple$iterator = $iterator_0($values(simpleProperties)); simple$iterator.val$outerIter.hasNext();) {
      simple = dynamicCast($next_2(simple$iterator), Q$PropertySimple);
      value = simple.stringValue != null?simple.stringValue:'';
      $equals_6(($clinit_SystemSetting() , AGENT_MAX_QUIET_TIME_ALLOWED).internalName, simple.name_0)?(value = value == null?'0':'' + toString_8(mul(mul(__parseAndValidateLong(value), P3c_longLit), P3e8_longLit))):$equals_6(DATA_MAINTENANCE_PERIOD.internalName, simple.name_0) || $equals_6(RHQ_SESSION_TIMEOUT.internalName, simple.name_0)?(value = value == null?'0':'' + toString_8(mul(mul(mul(__parseAndValidateLong(value), P3c_longLit), P3c_longLit), P3e8_longLit))):($equals_6(AVAILABILITY_PURGE_PERIOD.internalName, simple.name_0) || $equals_6(ALERT_PURGE_PERIOD.internalName, simple.name_0) || $equals_6(TRAIT_PURGE_PERIOD.internalName, simple.name_0) || $equals_6(RT_DATA_PURGE_PERIOD.internalName, simple.name_0) || $equals_6(EVENT_PURGE_PERIOD.internalName, simple.name_0) || $equals_6(DRIFT_FILE_PURGE_PERIOD.internalName, simple.name_0) || $equals_6(BASE_LINE_FREQUENCY.internalName, simple.name_0) || $equals_6(BASE_LINE_DATASET.internalName, simple.name_0)) && (value = value == null?'0':'' + toString_8(mul(mul(mul(mul(__parseAndValidateLong(value), P18_longLit), P3c_longLit), P3c_longLit), P3e8_longLit)));
      props.put(simple.name_0, value);
    }
    settings = fromMap(props);
    $setSystemSettings(dynamicCast(secure(getInstance_55(), -1), Q$SystemGWTServiceAsync), settings, new SystemSettingsView$2_0);
  }
   else {
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_8(($clinit_Enhanced() , 'Please fix the invalid values before saving'), ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient))));
  }
}

function SystemSettingsView_0(){
  $clinit_SystemSettingsView();
  EnhancedVLayout_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  this.canvas_0 = new EnhancedVLayout_0;
  $setAttribute_24(this.canvas_0, 'height', '100%', true);
  $setAttribute_24(this.canvas_0, 'width', '100%', true);
  $setMargin(this.canvas_0, valueOf_44(15));
  $addMember(this, this.canvas_0);
}

defineSeed(1669, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$PropertyValueChangeListener, Q$Enhanced]), SystemSettingsView_0);
_.onDraw_0 = function onDraw_7(){
  $getSystemSettings(dynamicCast(secure(getInstance_55(), -1), Q$SystemGWTServiceAsync), new SystemSettingsView$1_0(this));
}
;
_.propertyValueChanged = function propertyValueChanged_1(event_0){
  var invalidPropertyNames;
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    invalidPropertyNames.size_1() == 0?$enable(this.saveButton):$disable(this.saveButton);
  }
}
;
_.canvas_0 = null;
_.dumpToLogButton = null;
_.editor = null;
_.saveButton = null;
var VIEW_ID_3;
function $onSuccess_37(this$static, result){
  var config, prop, toolStrip, form, productName, productVersion, productBuildNumber, serverName, serverTimezone, serverTime, serverInstallDir, dbUrl, dbProductName, dbProductVersion, dbDriverName, dbDriverVersion, currentMeasRawTable, nextMeasTableRotation;
  $addMember(this$static.this$0.canvas_0, (form = new DynamicForm_0 , $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined) , $isCreated_1(form)?undefined:(form.config_0['extraSpace'] = 15 , undefined) , $setIsGroup(form, ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setGroupTitle(form, ($clinit_Enhanced() , 'Server Details')) , productName = new StaticTextItem_2('productname', 'Product Name') , productVersion = new StaticTextItem_2('productversion', 'Version') , productBuildNumber = new StaticTextItem_2('productbuild', 'Build Number') , serverName = new StaticTextItem_2('servername', 'Server Name') , serverTimezone = new StaticTextItem_2('timezone', 'Server Time Zone') , serverTime = new StaticTextItem_2('localtime', 'Server Local Time') , serverInstallDir = new StaticTextItem_2('installdir', 'Server Installation Directory') , dbUrl = new StaticTextItem_2('dbUrl', 'Database Connection URL') , dbProductName = new StaticTextItem_2('dbProductName', 'Database Product Name') , dbProductVersion = new StaticTextItem_2('dbProductVersion', 'Database Product Version') , dbDriverName = new StaticTextItem_2('dbDriverName', 'Database Driver Name') , dbDriverVersion = new StaticTextItem_2('dbDriverVersion', 'Database Driver Version') , currentMeasRawTable = new StaticTextItem_2('currentMeasRawTable', 'Current Measurement Raw Table') , nextMeasTableRotation = new StaticTextItem_2('nextMeasTableRotation', 'Next Measurement Table Rotation') , $setWrapTitle(productName, FALSE) , $setWrapTitle(productVersion, FALSE) , $setWrapTitle(productBuildNumber, FALSE) , $setWrapTitle(serverName, FALSE) , $setWrapTitle(serverTimezone, FALSE) , $setWrapTitle(serverTime, FALSE) , $setWrapTitle(serverInstallDir, FALSE) , $setWrapTitle(dbUrl, FALSE) , $setWrapTitle(dbProductName, FALSE) , $setWrapTitle(dbProductVersion, FALSE) , $setWrapTitle(dbDriverName, FALSE) , $setWrapTitle(dbDriverVersion, FALSE) , $setWrapTitle(currentMeasRawTable, FALSE) , $setWrapTitle(nextMeasTableRotation, FALSE) , form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [productName, productVersion, productBuildNumber, serverName, serverTimezone, serverTime, serverInstallDir, dbUrl, dbProductName, dbProductVersion, dbDriverName, dbDriverVersion, currentMeasRawTable, nextMeasTableRotation])) , $getServerDetails(dynamicCast(secure(getInstance_55(), -1), Q$SystemGWTServiceAsync), new SystemSettingsView$4_0(form, productName, productVersion, productBuildNumber, serverName, serverTimezone, serverTime, serverInstallDir, dbUrl, dbProductName, dbProductVersion, dbDriverName, dbDriverVersion, currentMeasRawTable, nextMeasTableRotation)) , form));
  config = $toConfiguration(result);
  prop = $getSimple(config, ($clinit_SystemSetting() , AGENT_MAX_QUIET_TIME_ALLOWED).internalName);
  $setValue_12(prop, $convertMillisToMinutes(prop.stringValue));
  prop = $getSimple(config, RHQ_SESSION_TIMEOUT.internalName);
  $setValue_12(prop, $convertMillisToHours(prop.stringValue));
  prop = $getSimple(config, DATA_MAINTENANCE_PERIOD.internalName);
  $setValue_12(prop, $convertMillisToHours(prop.stringValue));
  prop = $getSimple(config, AVAILABILITY_PURGE_PERIOD.internalName);
  $setValue_12(prop, $convertMillisToDays(prop.stringValue));
  prop = $getSimple(config, ALERT_PURGE_PERIOD.internalName);
  $setValue_12(prop, $convertMillisToDays(prop.stringValue));
  prop = $getSimple(config, TRAIT_PURGE_PERIOD.internalName);
  $setValue_12(prop, $convertMillisToDays(prop.stringValue));
  prop = $getSimple(config, RT_DATA_PURGE_PERIOD.internalName);
  $setValue_12(prop, $convertMillisToDays(prop.stringValue));
  prop = $getSimple(config, EVENT_PURGE_PERIOD.internalName);
  $setValue_12(prop, $convertMillisToDays(prop.stringValue));
  prop = $getSimple(config, DRIFT_FILE_PURGE_PERIOD.internalName);
  $setValue_12(prop, $convertMillisToDays(prop.stringValue));
  prop = $getSimple(config, BASE_LINE_FREQUENCY.internalName);
  $setValue_12(prop, $convertMillisToDays(prop.stringValue));
  prop = $getSimple(config, BASE_LINE_DATASET.internalName);
  $setValue_12(prop, $convertMillisToDays(prop.stringValue));
  this$static.this$0.editor = new ConfigurationEditor_1($getSystemSettingsDefinition(config, result.driftPlugins), config);
  $addPropertyValueChangeListener(this$static.this$0.editor, this$static.this$0);
  $addMember(this$static.this$0.canvas_0, this$static.this$0.editor);
  toolStrip = new ToolStrip_0;
  $isCreated_1(toolStrip)?$setProperty_3(toolStrip, 'width', '100%'):(toolStrip.config_0['width'] = '100%' , undefined);
  $isCreated_1(toolStrip)?$setProperty_0(toolStrip, 'membersMargin', 5):(toolStrip.config_0['membersMargin'] = 5 , undefined);
  $setLayoutMargin(toolStrip, valueOf_44(5));
  this$static.this$0.saveButton = new EnhancedIButton_1('Save');
  $addClickHandler(this$static.this$0.saveButton, new SystemSettingsView$1$1_0(this$static));
  $addMember(toolStrip, this$static.this$0.saveButton);
  this$static.this$0.dumpToLogButton = new EnhancedIButton_1('Dump System Info');
  $addClickHandler(this$static.this$0.dumpToLogButton, new SystemSettingsView$1$2_0);
  $addMember(toolStrip, this$static.this$0.dumpToLogButton);
  $addMember(this$static.this$0.canvas_0, toolStrip);
}

function SystemSettingsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1670, 1, {}, SystemSettingsView$1_0);
_.onFailure = function onFailure_37(t){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot obtain the current system settings'), t);
}
;
_.onSuccess_0 = function onSuccess_37(result){
  $onSuccess_37(this, dynamicCast(result, Q$SystemSettings));
}
;
_.this$0 = null;
function SystemSettingsView$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1671, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), SystemSettingsView$1$1_0);
_.onClick = function onClick_13(clickEvent){
  $save(this.this$1.this$0);
}
;
_.this$1 = null;
function SystemSettingsView$1$2_0(){
}

defineSeed(1672, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), SystemSettingsView$1$2_0);
_.onClick = function onClick_14(clickEvent){
  $dumpToLog(dynamicCast(secure(getInstance_55(), -1), Q$SystemGWTServiceAsync), new SystemSettingsView$3_0);
}
;
function SystemSettingsView$2_0(){
}

defineSeed(1673, 1, {}, SystemSettingsView$2_0);
_.onFailure = function onFailure_38(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to save the system settings'), caught);
}
;
_.onSuccess_0 = function onSuccess_38(result){
  throwClassCastExceptionUnlessNull(result);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You successfully saved the system properties'), ($clinit_Message$Severity() , Info)));
}
;
function SystemSettingsView$3_0(){
}

defineSeed(1674, 1, {}, SystemSettingsView$3_0);
_.onFailure = function onFailure_39(throwable){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Writing of system info to server log file failed'), ($clinit_Message$Severity() , Warning)));
}
;
_.onSuccess_0 = function onSuccess_39(aVoid){
  throwClassCastExceptionUnlessNull(aVoid);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'System info was successfully written to server log file'), ($clinit_Message$Severity() , Info)));
}
;
function $onSuccess_38(this$static, result){
  var details, productInfo;
  productInfo = result.productInfo;
  $setValue_0(this$static.val$form, $getName(this$static.val$productName), productInfo.name_0);
  $setValue_0(this$static.val$form, $getName(this$static.val$productVersion), productInfo.version_0);
  $setValue_0(this$static.val$form, $getName(this$static.val$productBuildNumber), productInfo.buildNumber);
  details = result.details;
  $setValue_0(this$static.val$form, $getName(this$static.val$serverName), dynamicCast(details.get_2(($clinit_ServerDetails$Detail() , SERVER_IDENTITY)), Q$String));
  $setValue_0(this$static.val$form, $getName(this$static.val$serverTimezone), dynamicCast(details.get_2(SERVER_TIMEZONE), Q$String));
  $setValue_0(this$static.val$form, $getName(this$static.val$serverTime), dynamicCast(details.get_2(SERVER_LOCAL_TIME), Q$String));
  $setValue_0(this$static.val$form, $getName(this$static.val$serverInstallDir), dynamicCast(details.get_2(SERVER_INSTALL_DIR), Q$String));
  $setValue_0(this$static.val$form, $getName(this$static.val$dbUrl), dynamicCast(details.get_2(DATABASE_CONNECTION_URL), Q$String));
  $setValue_0(this$static.val$form, $getName(this$static.val$dbProductName), dynamicCast(details.get_2(DATABASE_PRODUCT_NAME), Q$String));
  $setValue_0(this$static.val$form, $getName(this$static.val$dbProductVersion), dynamicCast(details.get_2(DATABASE_PRODUCT_VERSION), Q$String));
  $setValue_0(this$static.val$form, $getName(this$static.val$dbDriverName), dynamicCast(details.get_2(DATABASE_DRIVER_NAME), Q$String));
  $setValue_0(this$static.val$form, $getName(this$static.val$dbDriverVersion), dynamicCast(details.get_2(DATABASE_DRIVER_VERSION), Q$String));
  $setValue_0(this$static.val$form, $getName(this$static.val$currentMeasRawTable), dynamicCast(details.get_2(CURRENT_MEASUREMENT_TABLE), Q$String));
  $setValue_0(this$static.val$form, $getName(this$static.val$nextMeasTableRotation), dynamicCast(details.get_2(NEXT_MEASUREMENT_TABLE_ROTATION), Q$String));
}

function SystemSettingsView$4_0(val$form, val$productName, val$productVersion, val$productBuildNumber, val$serverName, val$serverTimezone, val$serverTime, val$serverInstallDir, val$dbUrl, val$dbProductName, val$dbProductVersion, val$dbDriverName, val$dbDriverVersion, val$currentMeasRawTable, val$nextMeasTableRotation){
  this.val$form = val$form;
  this.val$productName = val$productName;
  this.val$productVersion = val$productVersion;
  this.val$productBuildNumber = val$productBuildNumber;
  this.val$serverName = val$serverName;
  this.val$serverTimezone = val$serverTimezone;
  this.val$serverTime = val$serverTime;
  this.val$serverInstallDir = val$serverInstallDir;
  this.val$dbUrl = val$dbUrl;
  this.val$dbProductName = val$dbProductName;
  this.val$dbProductVersion = val$dbProductVersion;
  this.val$dbDriverName = val$dbDriverName;
  this.val$dbDriverVersion = val$dbDriverVersion;
  this.val$currentMeasRawTable = val$currentMeasRawTable;
  this.val$nextMeasTableRotation = val$nextMeasTableRotation;
}

defineSeed(1675, 1, {}, SystemSettingsView$4_0);
_.onFailure = function onFailure_40(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot load server details'), caught);
}
;
_.onSuccess_0 = function onSuccess_40(result){
  $onSuccess_38(this, dynamicCast(result, Q$ServerDetails));
}
;
_.val$currentMeasRawTable = null;
_.val$dbDriverName = null;
_.val$dbDriverVersion = null;
_.val$dbProductName = null;
_.val$dbProductVersion = null;
_.val$dbUrl = null;
_.val$form = null;
_.val$nextMeasTableRotation = null;
_.val$productBuildNumber = null;
_.val$productName = null;
_.val$productVersion = null;
_.val$serverInstallDir = null;
_.val$serverName = null;
_.val$serverTime = null;
_.val$serverTimezone = null;
function $clinit_RemoteAgentInstallView(){
  $clinit_RemoteAgentInstallView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_4 = new ViewName_2('RemoteAgentInstall', ($clinit_Enhanced() , 'Remote Agent Install'), ($clinit_IconEnum() , AGENT_0));
}

function $agentStatusCheck(this$static){
  $disableButtons(this$static, true);
  $agentStatus(this$static.remoteInstallService, $getRemoteAccessInfo(this$static), (($getValueAsString(this$static.connectionForm, 'agentInstallPath') == null || !$trim($getValueAsString(this$static.connectionForm, 'agentInstallPath')).length) && $findAgentInstallPath(this$static) , $getValueAsString(this$static.connectionForm, 'agentInstallPath')), new RemoteAgentInstallView$7_0(this$static));
}

function $buildInstallInfoCanvas(installInfo, info){
  var config, duration, infoForm, infoHeader, listCanvas, listGrid, listLayout, owner, path, result, resultCode, step, version, buf;
  infoForm = new DynamicForm_0;
  $setMargin(infoForm, valueOf_44(20));
  $isCreated_1(infoForm)?$setProperty_3(infoForm, 'width', '100%'):(infoForm.config_0['width'] = '100%' , undefined);
  $isCreated_1(infoForm)?$setProperty_3(infoForm, 'height', '100%'):(infoForm.config_0['height'] = '100%' , undefined);
  infoHeader = new HeaderItem_0;
  $setValue_7(infoHeader, ($clinit_Enhanced() , 'Agent Installation Information'));
  version = new StaticTextItem_2('version', 'Version');
  $setValue_7(version, info.version_0);
  path = new StaticTextItem_2('path', 'Path');
  $setValue_7(path, info.path);
  owner = new StaticTextItem_2('owner', 'Owner');
  $setValue_7(owner, info.owner);
  config = new StaticTextItem_2('config', 'Configuration');
  $setValue_7(config, (buf = new StringBuilder_0 , $append_12($append_12($append_12(($append_1(buf.data_0, '-D') , buf), 'rhq.agent.server.bind-address'), '='), info.serverAddress) , $append_1(buf.data_0, ' ') , $append_12($append_12($append_12(($append_1(buf.data_0, '-D') , buf), 'rhq.communications.connector.bind-address'), '='), info.agentAddress) , $append_1(buf.data_0, ' ') , $append_12($append_12($append_12(($append_1(buf.data_0, '-D') , buf), 'rhq.agent.configuration-setup-flag'), '='), 'true') , $append_1(buf.data_0, ' ') , $append_1(buf.data_0, '--daemon ') , $toString_1(buf.data_0)));
  listCanvas = new CanvasItem_0;
  listCanvas.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_2(listCanvas)?$setProperty_6(listCanvas, 'colSpan', 2):(listCanvas.jsObj['colSpan'] = 2 , undefined);
  listLayout = new VLayout_1(0);
  $isCreated_1(listLayout)?$setProperty_3(listLayout, 'width', '100%'):(listLayout.config_0['width'] = '100%' , undefined);
  $isCreated_1(listLayout)?$setProperty_3(listLayout, 'height', '100%'):(listLayout.config_0['height'] = '100%' , undefined);
  listGrid = new RemoteAgentInstallView$11_0;
  $isCreated_1(listGrid)?$setProperty_3(listGrid, 'width', '100%'):(listGrid.config_0['width'] = '100%' , undefined);
  $isCreated_1(listGrid)?$setProperty_3(listGrid, 'height', '100%'):(listGrid.config_0['height'] = '100%' , undefined);
  $setCanExpandRecords(listGrid, TRUE);
  $setAttribute_24(listGrid, 'expansionMode', ($clinit_ExpansionMode() , DETAIL_FIELD).value_0, true);
  $isCreated_1(listGrid)?$setProperty_3(listGrid, 'detailField', 'result'):(listGrid.config_0['detailField'] = 'result' , undefined);
  step = new ListGridField_3('description', 'Step');
  result = new ListGridField_3('result', 'Result');
  resultCode = new ListGridField_4('resultCode', 'ResultCode', 90);
  duration = new ListGridField_4('duration', 'Duration', 90);
  $isCreated_1(listGrid)?$setProperty_2(listGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [step, result, resultCode, duration]))):(listGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [step, result, resultCode, duration])) , undefined);
  $setData(listGrid, $getStepRecords(info));
  listLayout.addMember_0(listGrid);
  $setAttribute_28(listCanvas, 'canvas', !listLayout?null:$getOrCreateJsObj_0(listLayout));
  infoForm.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [infoHeader, version, path, owner, config, listCanvas]));
  installInfo.addMember_0(infoForm);
  return;
}

function $disableButtons(this$static, disabled){
  $setDisabled(this$static.installButton, disabled);
  $setDisabled(this$static.startButton, disabled);
  $setDisabled(this$static.stopButton, disabled);
  $setDisabled(this$static.buttonsForm, disabled);
  $setDisabled_2(this$static.findAgentInstallPathButton, ($clinit_Boolean() , disabled?TRUE:FALSE));
  $setDisabled_2(this$static.statusCheckButton, disabled?TRUE:FALSE);
}

function $findAgentInstallPath(this$static){
  var errors, parentPath;
  errors = new HashMap_1(2);
  ($getValueAsString(this$static.connectionForm, 'host') == null || !$trim($getValueAsString(this$static.connectionForm, 'host')).length) && errors.put('host', ($clinit_CoreGUI() , 'Field is required'));
  ($getValueAsString(this$static.connectionForm, 'username') == null || !$trim($getValueAsString(this$static.connectionForm, 'username')).length) && errors.put('username', ($clinit_CoreGUI() , 'Field is required'));
  $setErrors(this$static.connectionForm, errors, true);
  if (errors.size_1() == 0) {
    $disableButtons(this$static, true);
    parentPath = $getValueAsString(this$static.connectionForm, 'agentInstallPath');
    $findAgentInstallPath_0(this$static.remoteInstallService, $getRemoteAccessInfo(this$static), parentPath, new RemoteAgentInstallView$6_0(this$static, parentPath));
  }
}

function $getConnectionForm(this$static){
  var agentInstallPath, agentStatus, host, password, port, username;
  this$static.connectionForm = new DynamicForm_0;
  $setNumCols(this$static.connectionForm, 4);
  $setWrapItemTitles(this$static.connectionForm, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setColWidths(this$static.connectionForm, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['130', '450', '110']));
  host = new TextItem_3('host', ($clinit_Enhanced() , 'Host'));
  $setRequired(host, TRUE);
  $isCreated_2(host)?$setProperty_6(host, 'width', 440):(host.jsObj['width'] = 440 , undefined);
  $setPrompt_1(host, 'The host where the agent is or will be installed');
  $setHoverWidth_0(host, valueOf_44(300));
  $setEndRow_0(host, TRUE);
  port = new TextItem_3('port', 'Port');
  $setRequired(port, FALSE);
  $isCreated_2(port)?$setProperty_6(port, 'width', 440):(port.jsObj['width'] = 440 , undefined);
  $setPrompt_1(port, 'The port the SSH server is listening to. If not specified, the default is 22');
  $setHoverWidth_0(port, valueOf_44(300));
  $setEndRow_0(port, TRUE);
  username = new TextItem_3('username', 'User');
  $setRequired(username, TRUE);
  $isCreated_2(username)?$setProperty_6(username, 'width', 440):(username.jsObj['width'] = 440 , undefined);
  $setPrompt_1(username, 'The name of the user whose credentials are passed to the host via SSH');
  $setHoverWidth_0(username, valueOf_44(300));
  $setEndRow_0(username, TRUE);
  password = new PasswordItem_2('Password');
  $setRequired(password, FALSE);
  $isCreated_2(password)?$setProperty_6(password, 'width', 440):(password.jsObj['width'] = 440 , undefined);
  $setPrompt_1(password, 'The credentials that are used to authenticate the user on the host via SSH');
  $setHoverWidth_0(password, valueOf_44(300));
  $setEndRow_0(password, TRUE);
  agentInstallPath = new TextItem_3('agentInstallPath', 'Agent Install Path');
  $isCreated_2(agentInstallPath)?$setProperty_6(agentInstallPath, 'width', 440):(agentInstallPath.jsObj['width'] = 440 , undefined);
  $setPrompt_1(agentInstallPath, "Where the agent is or will be installed. If you aren't sure where an agent is installed, enter a parent directory and click the 'Find Agent' button to scan that directory and below. If you enter an empty path, common locations are searched on the host for an agent install.");
  $setHoverWidth_0(agentInstallPath, valueOf_44(300));
  $setStartRow_0(agentInstallPath, TRUE);
  $setEndRow_0(agentInstallPath, FALSE);
  this$static.findAgentInstallPathButton = new ButtonItem_1('findAgentInstallPathButton', 'Find Agent');
  $setStartRow_1(this$static.findAgentInstallPathButton, FALSE);
  $setEndRow_1(this$static.findAgentInstallPathButton, TRUE);
  this$static.findAgentInstallPathButton.getTitle().length < 15 && $setWidth_1(this$static.findAgentInstallPathButton, 100);
  $addClickHandler_1(this$static.findAgentInstallPathButton, new RemoteAgentInstallView$1_0(this$static));
  agentStatus = new StaticTextItem_2('agentStatus', 'Agent Status');
  $setDefaultValue_1(agentStatus, '-Click Update Status Button-');
  $isCreated_2(agentStatus)?$setProperty_9(agentStatus, 'redrawOnChange', true):(agentStatus.jsObj['redrawOnChange'] = true , undefined);
  $isCreated_2(agentStatus)?$setProperty_9(agentStatus, 'redrawOnChange', true):(agentStatus.jsObj['redrawOnChange'] = true , undefined);
  $setStartRow_0(agentStatus, TRUE);
  $setEndRow_0(agentStatus, FALSE);
  this$static.statusCheckButton = new ButtonItem_1('updateStatus', 'Update Status');
  $setStartRow_1(this$static.statusCheckButton, FALSE);
  $setEndRow_1(this$static.statusCheckButton, TRUE);
  this$static.findAgentInstallPathButton.getTitle().length < 15 && $setWidth_1(this$static.statusCheckButton, 100);
  $addClickHandler_1(this$static.statusCheckButton, new RemoteAgentInstallView$2_0(this$static));
  this$static.connectionForm.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [host, port, username, password, agentInstallPath, this$static.findAgentInstallPathButton, agentStatus, this$static.statusCheckButton]));
  $setExtraSpace(this$static.connectionForm, 15);
  return this$static.connectionForm;
}

function $getRemoteAccessInfo(this$static){
  var $e0, host, info, password, port, portInt, username;
  host = $getValueAsString(this$static.connectionForm, 'host');
  port = $getValueAsString(this$static.connectionForm, 'port');
  username = $getValueAsString(this$static.connectionForm, 'username');
  password = $getValueAsString(this$static.connectionForm, 'password');
  try {
    portInt = __parseAndValidateInt(port);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$NumberFormatException)) {
      portInt = 22;
    }
     else 
      throw $e0;
  }
  $setValue(this$static.connectionForm, 'port', portInt);
  info = new RemoteAccessInfo_0(host, portInt, username, password);
  return info;
}

function $getStepRecords(info){
  var rec, result, step, step$iterator, steps;
  steps = new ArrayList_0;
  for (step$iterator = info.steps.iterator(); step$iterator.hasNext();) {
    step = dynamicCast(step$iterator.next_0(), Q$AgentInstallStep);
    rec = new ListGridRecord_0;
    $setAttribute_13(rec, 'description', step.description);
    result = step.result;
    (result == null || $trim(result).length == 0) && (result = ($clinit_Enhanced() , 'ResultCode') + '=' + step.resultCode);
    rec.jsObj['result'] = result;
    $setAttribute_13(rec, 'resultCode', '' + step.resultCode);
    $setAttribute_13(rec, 'duration', ($clinit_MeasurementConverterClient() , format_91(new Double_0(toDouble(step.duration_0)), ($clinit_MeasurementUnits() , MILLISECONDS))));
    setCheck(steps.array, steps.size_0++, rec);
  }
  return dynamicCast($toArray_1(steps, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, steps.size_0, 0)), Q$ListGridRecord_$1);
}

function $installAgent(this$static){
  $disableButtons(this$static, true);
  $installAgent_0(this$static.remoteInstallService, $getRemoteAccessInfo(this$static), (($getValueAsString(this$static.connectionForm, 'agentInstallPath') == null || !$trim($getValueAsString(this$static.connectionForm, 'agentInstallPath')).length) && $findAgentInstallPath(this$static) , $getValueAsString(this$static.connectionForm, 'agentInstallPath')), new RemoteAgentInstallView$8_0(this$static));
}

function $startAgent(this$static){
  $disableButtons(this$static, true);
  $startAgent_0(this$static.remoteInstallService, $getRemoteAccessInfo(this$static), (($getValueAsString(this$static.connectionForm, 'agentInstallPath') == null || !$trim($getValueAsString(this$static.connectionForm, 'agentInstallPath')).length) && $findAgentInstallPath(this$static) , $getValueAsString(this$static.connectionForm, 'agentInstallPath')), new RemoteAgentInstallView$9_0(this$static));
}

function $stopAgent(this$static){
  $disableButtons(this$static, true);
  $stopAgent_0(this$static.remoteInstallService, $getRemoteAccessInfo(this$static), (($getValueAsString(this$static.connectionForm, 'agentInstallPath') == null || !$trim($getValueAsString(this$static.connectionForm, 'agentInstallPath')).length) && $findAgentInstallPath(this$static) , $getValueAsString(this$static.connectionForm, 'agentInstallPath')), new RemoteAgentInstallView$10_0(this$static));
}

function RemoteAgentInstallView_0(){
  $clinit_RemoteAgentInstallView();
  EnhancedVLayout_0.call(this);
  this.remoteInstallService = dynamicCast(secure(getInstance_48(), 600000), Q$RemoteInstallGWTServiceAsync);
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 1):(this.config_0['membersMargin'] = 1 , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(1676, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), RemoteAgentInstallView_0);
_.onInit = function onInit_11(){
  var header, layout;
  $onInit(this);
  $onInit_Layout(this);
  layout = new VLayout_0;
  $setPadding(layout, valueOf_44(10));
  header = new HTMLFlow_1(($clinit_Enhanced() , 'Connection Information'));
  $isCreated_1(header)?$setProperty_3(header, 'styleName', 'headerItem'):(header.config_0['styleName'] = 'headerItem' , undefined);
  $isCreated_1(header)?undefined:(header.config_0['extraSpace'] = 5 , undefined);
  layout.addMember_0(header);
  layout.addMember_0($getConnectionForm(this));
  header = new HTMLFlow_1('Operations');
  $isCreated_1(header)?$setProperty_3(header, 'styleName', 'headerItem'):(header.config_0['styleName'] = 'headerItem' , undefined);
  $isCreated_1(header)?undefined:(header.config_0['extraSpace'] = 5 , undefined);
  layout.addMember_0(header);
  layout.addMember_0((this.buttonsForm = new HLayout_0 , this.installButton = new EnhancedIButton_1('Install Agent') , $setExtraSpace(this.installButton, 10) , $addClickHandler(this.installButton, new RemoteAgentInstallView$3_0(this)) , this.startButton = new EnhancedIButton_1('Start Agent') , $setExtraSpace(this.startButton, 10) , $addClickHandler(this.startButton, new RemoteAgentInstallView$4_0(this)) , this.stopButton = new EnhancedIButton_1('Stop Agent') , $setExtraSpace(this.stopButton, 10) , $addClickHandler(this.stopButton, new RemoteAgentInstallView$5_0(this)) , $setMembers(this.buttonsForm, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [this.installButton, this.startButton, this.stopButton])) , this.buttonsForm));
  this.agentInfoLayout = new VLayout_0;
  $setAttribute_24(this.agentInfoLayout, 'width', '100%', true);
  $setAttribute_24(this.agentInfoLayout, 'height', '100%', true);
  $setMembersMargin(this.agentInfoLayout, 1);
  layout.addMember_0(this.agentInfoLayout);
  $addMember(this, layout);
}
;
_.agentInfoLayout = null;
_.buttonsForm = null;
_.connectionForm = null;
_.findAgentInstallPathButton = null;
_.installButton = null;
_.startButton = null;
_.statusCheckButton = null;
_.stopButton = null;
var VIEW_ID_4;
function RemoteAgentInstallView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1677, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), RemoteAgentInstallView$1_0);
_.onClick_0 = function onClick_15(clickEvent){
  $findAgentInstallPath(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_39(this$static, result){
  $disableButtons(this$static.this$0, false);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Agent stop results: [' + ($clinit_Enhanced() , result) + ']', ($clinit_Message$Severity() , Info)));
  $agentStatusCheck(this$static.this$0);
}

function RemoteAgentInstallView$10_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1678, 1, {}, RemoteAgentInstallView$10_0);
_.onFailure = function onFailure_41(caught){
  $disableButtons(this.this$0, false);
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to stop agent'), caught);
}
;
_.onSuccess_0 = function onSuccess_41(result){
  $onSuccess_39(this, dynamicCast(result, Q$String));
}
;
_.this$0 = null;
function RemoteAgentInstallView$11_0(){
  $clinit_BaseWidget();
  ListGrid_0.call(this);
}

defineSeed(1679, 538, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers]), RemoteAgentInstallView$11_0);
_.getExpansionComponent_0 = function getExpansionComponent_0(record){
  var canvas;
  canvas = $getExpansionComponent(this, record);
  $setPadding(canvas, valueOf_44(5));
  return canvas;
}
;
function RemoteAgentInstallView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1680, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), RemoteAgentInstallView$2_0);
_.onClick_0 = function onClick_16(clickEvent){
  this.this$0.connectionForm.validate_0() && $agentStatusCheck(this.this$0);
}
;
_.this$0 = null;
function RemoteAgentInstallView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1681, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), RemoteAgentInstallView$3_0);
_.onClick = function onClick_17(clickEvent){
  this.this$0.connectionForm.validate_0() && $installAgent(this.this$0);
}
;
_.this$0 = null;
function RemoteAgentInstallView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1682, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), RemoteAgentInstallView$4_0);
_.onClick = function onClick_18(clickEvent){
  this.this$0.connectionForm.validate_0() && $startAgent(this.this$0);
}
;
_.this$0 = null;
function RemoteAgentInstallView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1683, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), RemoteAgentInstallView$5_0);
_.onClick = function onClick_19(clickEvent){
  this.this$0.connectionForm.validate_0() && $stopAgent(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_40(this$static, result){
  var err;
  $disableButtons(this$static.this$0, false);
  if (result != null) {
    $setValue_0(this$static.this$0.connectionForm, 'agentInstallPath', result);
  }
   else {
    this$static.val$parentPath == null || this$static.val$parentPath.length == 0?(err = ($clinit_Enhanced() , 'Could not find an agent installed when looking in common locations')):(err = 'Could not find an agent installed at or under [' + ($clinit_Enhanced() , this$static.val$parentPath) + ']');
    $handleError_0(($clinit_CoreGUI() , err), null);
  }
  $agentStatusCheck(this$static.this$0);
}

function RemoteAgentInstallView$6_0(this$0, val$parentPath){
  this.this$0 = this$0;
  this.val$parentPath = val$parentPath;
}

defineSeed(1684, 1, {}, RemoteAgentInstallView$6_0);
_.onFailure = function onFailure_42(caught){
  $disableButtons(this.this$0, false);
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Error occurred while trying to find agent install path'), caught);
}
;
_.onSuccess_0 = function onSuccess_42(result){
  $onSuccess_40(this, dynamicCast(result, Q$String));
}
;
_.this$0 = null;
_.val$parentPath = null;
function $onSuccess_41(this$static, result){
  $disableButtons(this$static.this$0, false);
  $setValue_0(this$static.this$0.connectionForm, 'agentStatus', result);
}

function RemoteAgentInstallView$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1685, 1, {}, RemoteAgentInstallView$7_0);
_.onFailure = function onFailure_43(caught){
  $disableButtons(this.this$0, false);
  $setValue_0(this.this$0.connectionForm, 'agentStatus', caught.getMessage());
}
;
_.onSuccess_0 = function onSuccess_43(result){
  $onSuccess_41(this, dynamicCast(result, Q$String));
}
;
_.this$0 = null;
function $onSuccess_42(this$static, result){
  var child, child$array, child$index, child$max;
  $disableButtons(this$static.this$0, false);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Agent installation complete'), ($clinit_Message$Severity() , Info)));
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.agentInfoLayout, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $buildInstallInfoCanvas(this$static.this$0.agentInfoLayout, result);
  this$static.this$0.agentInfoLayout.markForRedraw_0();
  $agentStatusCheck(this$static.this$0);
}

function RemoteAgentInstallView$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1686, 1, {}, RemoteAgentInstallView$8_0);
_.onFailure = function onFailure_44(caught){
  $disableButtons(this.this$0, false);
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to install agent'), caught);
}
;
_.onSuccess_0 = function onSuccess_44(result){
  $onSuccess_42(this, dynamicCast(result, Q$AgentInstallInfo));
}
;
_.this$0 = null;
function $onSuccess_43(this$static, result){
  $disableButtons(this$static.this$0, false);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Agent start results: [' + ($clinit_Enhanced() , result) + ']', ($clinit_Message$Severity() , Info)));
  $agentStatusCheck(this$static.this$0);
}

function RemoteAgentInstallView$9_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1687, 1, {}, RemoteAgentInstallView$9_0);
_.onFailure = function onFailure_45(caught){
  $disableButtons(this.this$0, false);
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to start agent'), caught);
}
;
_.onSuccess_0 = function onSuccess_45(result){
  $onSuccess_43(this, dynamicCast(result, Q$String));
}
;
_.this$0 = null;
function $clinit_PermissionsEditor(){
  $clinit_PermissionsEditor = nullMethod;
  $clinit_BaseWidget();
  $clinit_CoreGUI();
}

function $createAuthorizedField(this$static, name_0, title, nameField, grid, readOnlyColumn){
  var authorizedField, editor, recordBeingEdited, valueMap;
  authorizedField = new ListGridField_4(name_0, title, 65);
  $setAttribute_13(authorizedField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  authorizedField.jsObj['imageSize'] = 11;
  valueMap = new LinkedHashMap_1(2);
  if (readOnlyColumn) {
    $put_1(valueMap, ($clinit_Boolean() , TRUE).value_0?'true':'false', 'global/permission_checked_disabled_11.png');
    $put_1(valueMap, FALSE.value_0?'true':'false', 'global/permission_disabled_11.png');
  }
   else {
    $put_1(valueMap, ($clinit_Boolean() , TRUE).value_0?'true':'false', 'global/permission_enabled_11.png');
    $put_1(valueMap, FALSE.value_0?'true':'false', 'global/permission_disabled_11.png');
  }
  setAttribute_10(authorizedField.jsObj, 'valueMap', valueMap);
  $setAttribute_8(authorizedField, 'canEdit', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  editor = new CheckboxItem_0;
  $setEditorType(authorizedField, editor);
  if (!this$static.isReadOnly) {
    $setAttribute_24(grid, 'editEvent', ($clinit_ListGridEditEvent() , CLICK).value_0, true);
    recordBeingEdited = initValues(_3Lcom_smartgwt_client_data_Record_2_classLit, makeCastMap([Q$Record_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Record, [null]);
    $addRecordClickHandler_0(authorizedField, new PermissionsEditor$1_0(recordBeingEdited));
    $addChangedHandler_0(authorizedField, new PermissionsEditor$2_0(this$static, grid, nameField));
  }
  return authorizedField;
}

function $createGlobalPermissionRecord(this$static, displayName, icon, globalPermission, description){
  var record;
  record = new ListGridRecord_0;
  record.jsObj['displayName'] = displayName;
  record.jsObj['icon'] = icon;
  $setAttribute_13(record, 'name', globalPermission.name_0);
  record.jsObj['description'] = description;
  $setAttribute_16(record, 'authorized', this$static.selectedPermissions.contains_0(globalPermission));
  return record;
}

function $createIconField(){
  var iconField;
  iconField = new ListGridField_4('icon', '&nbsp;', 28);
  $setAttribute_8(iconField, 'showDefaultContextMenu', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_8(iconField, 'canSort', FALSE);
  $setAttribute_13(iconField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_13(iconField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  iconField.jsObj['imageURLSuffix'] = '_16.png';
  iconField.jsObj['imageWidth'] = 16;
  iconField.jsObj['imageHeight'] = 16;
  return iconField;
}

function $createPermissionsGrid(){
  var grid;
  grid = new ListGrid_0;
  $setAttribute_24(grid, 'autoFitData', ($clinit_Autofit() , BOTH_0).value_0, true);
  $setWrapCells(grid, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setFixedRecordHeights(grid, FALSE);
  return grid;
}

function $createResourcePermissionRecord(this$static, displayName, icon, readPermission, readDescription, writePermission, writeDescription){
  var record;
  record = new ListGridRecord_0;
  record.jsObj['displayName'] = displayName;
  record.jsObj['icon'] = icon;
  $setAttribute_13(record, 'readName', readPermission.name_0);
  $setAttribute_16(record, 'readAuthorized', this$static.selectedPermissions.contains_0(readPermission));
  record.jsObj['description'] = '<b>Read:<\/b> ' + readDescription + '<br/><b>Write:<\/b> ' + writeDescription;
  $setAttribute_13(record, 'writeName', writePermission.name_0);
  $setAttribute_16(record, 'writeAuthorized', this$static.selectedPermissions.contains_0(writePermission));
  return record;
}

function $createVerticalSpacer(){
  var spacer;
  spacer = new VLayout_0;
  $isCreated_1(spacer)?$setProperty_0(spacer, 'height', 13):(spacer.config_0['height'] = 13 , undefined);
  return spacer;
}

function $redraw_1(this$static){
  var globalPermissionRecords, permission, permissionName, readPermission, readPermissionName, record, record$index, record$max, resourcePermissionRecords, writePermission, writePermissionName, nativeArray, permissionRecords;
  this$static.selectedPermissions = (nativeArray = $getValue(this$static.roleEditView.form_0, 'permissions') , this$static.originalValue == null && (this$static.originalValue = nativeArray) , permissionRecords = convertToListGridRecordArray_0(dynamicCastJso(nativeArray)) , toPermissionSet(permissionRecords));
  globalPermissionRecords = this$static.globalPermissionsGrid.getRecords();
  for (record$index = 0 , record$max = globalPermissionRecords.length; record$index < record$max; ++record$index) {
    record = globalPermissionRecords[record$index];
    permissionName = getAttribute(record.jsObj, 'name');
    permission = ($clinit_Permission() , dynamicCast(valueOf(($clinit_Permission$Map() , $MAP_49), permissionName), Q$Permission));
    $setAttribute_16(record, 'authorized', this$static.selectedPermissions.contains_0(permission));
  }
  resourcePermissionRecords = this$static.resourcePermissionsGrid.getRecords();
  for (record$index = 0 , record$max = resourcePermissionRecords.length; record$index < record$max; ++record$index) {
    record = resourcePermissionRecords[record$index];
    readPermissionName = getAttribute(record.jsObj, 'readName');
    readPermission = ($clinit_Permission() , dynamicCast(valueOf(($clinit_Permission$Map() , $MAP_49), readPermissionName), Q$Permission));
    $setAttribute_16(record, 'readAuthorized', this$static.selectedPermissions.contains_0(readPermission));
    writePermissionName = getAttribute(record.jsObj, 'writeName');
    writePermission = dynamicCast(valueOf($MAP_49, writePermissionName), Q$Permission);
    $setAttribute_16(record, 'writeAuthorized', this$static.selectedPermissions.contains_0(writePermission));
  }
  $markForRedraw(this$static);
}

function $updatePermissions(this$static, authorized, permission){
  var message, messageString, permissionRecords, redrawRequired;
  messageString = null;
  redrawRequired = false;
  if (authorized.value_0) {
    this$static.selectedPermissions.add(permission);
    if (permission == ($clinit_Permission() , MANAGE_SECURITY)) {
      if (this$static.selectedPermissions.addAll(allOf(Lorg_rhq_core_domain_authz_Permission_2_classLit))) {
        messageString = 'Autoselected unselected permissions, since MANAGE_SECURITY implies all other permissions...';
        redrawRequired = true;
      }
    }
     else if (permission == MANAGE_INVENTORY) {
      if (this$static.selectedPermissions.addAll(RESOURCE_ALL)) {
        messageString = 'Autoselected unselected Resource permissions, since MANAGE_INVENTORY implies all Resource permissions...';
        redrawRequired = true;
      }
    }
     else if (permission == CONFIGURE_WRITE) {
      if (this$static.selectedPermissions.add(CONFIGURE_READ)) {
        messageString = 'Autoselected CONFIGURE_READ permission, since CONFIGURE_WRITE implies it...';
        redrawRequired = true;
      }
    }
  }
   else {
    this$static.selectedPermissions.remove_0(permission);
  }
  permissionRecords = toRecordArray(this$static.selectedPermissions);
  $setValue_2(this$static.roleEditView.form_0, 'permissions', permissionRecords);
  redrawRequired && $redraw_1(this$static);
  if (messageString != null) {
    message = new Message_6(messageString, of(($clinit_Message$Option() , Transient)));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
}

function PermissionsEditor_0(roleEditView, isReadOnly){
  var productInfo, grid, iconField, displayNameField, descriptionField, authorizedField, records, record, grid_0, iconField_0, displayNameField_0, descriptionField_0, readField, writeField, records_0, record_0;
  $clinit_PermissionsEditor();
  var globalPermissionsHeader, resourcePermissionsHeader, spacer;
  EnhancedVStack_0.call(this);
  this.roleEditView = roleEditView;
  this.isReadOnly = isReadOnly;
  this.selectedPermissions = of(($clinit_Permission() , VIEW_RESOURCE));
  $isCreated_1(this)?$setProperty_3(this, 'width', '95%'):(this.config_0['width'] = '95%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  spacer = $createVerticalSpacer();
  $addMember(this, spacer);
  globalPermissionsHeader = new Label_4('<h4>Global Permissions<\/h4>');
  $isCreated_1(globalPermissionsHeader)?$setProperty_0(globalPermissionsHeader, 'height', 17):(globalPermissionsHeader.config_0['height'] = 17 , undefined);
  $addMember(this, globalPermissionsHeader);
  this.globalPermissionsGrid = (productInfo = ($clinit_CoreGUI() , $clinit_CoreGUI() , coreGUI).productInfo , grid = $createPermissionsGrid() , iconField = $createIconField() , displayNameField = new ListGridField_4('displayName', 'Name', 130) , descriptionField = new ListGridField_3('description', 'Description') , descriptionField.jsObj['wrap'] = true , authorizedField = $createAuthorizedField(this, 'authorized', 'Authorized?', 'name', grid, false) , $isCreated_1(grid)?$setProperty_2(grid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [iconField, displayNameField, authorizedField, descriptionField]))):(grid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [iconField, displayNameField, authorizedField, descriptionField])) , undefined) , records = new ArrayList_0 , record = $createGlobalPermissionRecord(this, 'Manage Security', 'global/Locked', MANAGE_SECURITY, 'can create, update, or delete users and roles - implies all other permissions') , setCheck(records.array, records.size_0++, record) , record = $createGlobalPermissionRecord(this, 'Manage Inventory', 'subsystems/inventory/Inventory', MANAGE_INVENTORY, 'has all Resource permissions, as described below, for all Resources; can create, update, and delete groups; and can import auto-discovered or manually discovered Resources') , setCheck(records.array, records.size_0++, record) , record = $createGlobalPermissionRecord(this, 'Manage Settings', 'subsystems/configure/Configure', MANAGE_SETTINGS, 'can modify the ' + productInfo.shortName + ' Server configuration and perform any Server-related functionality') , setCheck(records.array, records.size_0++, record) , record = $createGlobalPermissionRecord(this, 'Manage Bundles', 'subsystems/bundle/Bundle', MANAGE_BUNDLE, 'can create, update, or delete provisioning bundles (viewing is implied for everyone)') , setCheck(records.array, records.size_0++, record) , record = $createGlobalPermissionRecord(this, 'Manage Repositories', 'subsystems/content/Content', MANAGE_REPOSITORIES, 'can create, update, or delete repositories of any user (everyone can create their own repositories), can associate content sources to repositories.') , setCheck(records.array, records.size_0++, record) , record = $createGlobalPermissionRecord(this, 'View Users', 'global/User', VIEW_USERS, 'can view other users, with the exception of their assigned roles') , setCheck(records.array, records.size_0++, record) , $setData(grid, dynamicCast($toArray_1(records, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, records.size_0, 0)), Q$ListGridRecord_$1)) , grid);
  $addMember(this, this.globalPermissionsGrid);
  spacer = $createVerticalSpacer();
  $addMember(this, spacer);
  resourcePermissionsHeader = new Label_4('<h4>Resource Permissions<\/h4>');
  $isCreated_1(resourcePermissionsHeader)?$setProperty_0(resourcePermissionsHeader, 'height', 17):(resourcePermissionsHeader.config_0['height'] = 17 , undefined);
  $addMember(this, resourcePermissionsHeader);
  this.resourcePermissionsGrid = (grid_0 = $createPermissionsGrid() , iconField_0 = $createIconField() , displayNameField_0 = new ListGridField_4('displayName', 'Name', 130) , descriptionField_0 = new ListGridField_3('description', 'Description') , descriptionField_0.jsObj['wrap'] = true , readField = $createAuthorizedField(this, 'readAuthorized', 'Read?', 'readName', grid_0, true) , writeField = $createAuthorizedField(this, 'writeAuthorized', 'Write?', 'writeName', grid_0, false) , $isCreated_1(grid_0)?$setProperty_2(grid_0, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [iconField_0, displayNameField_0, readField, writeField, descriptionField_0]))):(grid_0.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [iconField_0, displayNameField_0, readField, writeField, descriptionField_0])) , undefined) , records_0 = new ArrayList_0 , record_0 = $createResourcePermissionRecord(this, 'Inventory', 'subsystems/inventory/Inventory', VIEW_RESOURCE, '(IMPLIED) view Resource properties (name, description, version, etc.), connection settings, and connection settings history', MODIFY_RESOURCE, 'update Resource name, version, description, and connection settings; delete connection settings history items') , setCheck(records_0.array, records_0.size_0++, record_0) , record_0 = $createResourcePermissionRecord(this, 'Manage Measurements', 'subsystems/monitor/Monitor', VIEW_RESOURCE, '(IMPLIED) view metric data and collection schedules', MANAGE_MEASUREMENTS, 'update metric collection schedules') , setCheck(records_0.array, records_0.size_0++, record_0) , record_0 = $createResourcePermissionRecord(this, 'Manage Alerts', 'subsystems/alert/Alerts', VIEW_RESOURCE, '(IMPLIED) view alert definitions and alert history', MANAGE_ALERTS, 'create, update, and delete alert definitions; acknowledge and delete alert history items') , setCheck(records_0.array, records_0.size_0++, record_0) , record_0 = $createResourcePermissionRecord(this, 'Configure', 'subsystems/configure/Configure', CONFIGURE_READ, 'view Resource configuration and Resource configuration revision history', CONFIGURE_WRITE, 'update Resource configuration; delete Resource configuration revision history items') , setCheck(records_0.array, records_0.size_0++, record_0) , record_0 = $createResourcePermissionRecord(this, 'Control', 'subsystems/control/Operation', VIEW_RESOURCE, '(IMPLIED) view available operations and operation execution history', CONTROL_0, 'execute operations; delete operation execution history items') , setCheck(records_0.array, records_0.size_0++, record_0) , record_0 = $createResourcePermissionRecord(this, 'Manage Events', 'subsystems/event/Events', VIEW_RESOURCE, '(IMPLIED) view events', MANAGE_EVENTS, 'delete events') , setCheck(records_0.array, records_0.size_0++, record_0) , record_0 = $createResourcePermissionRecord(this, 'Manage Content', 'subsystems/content/Content', VIEW_RESOURCE, '(IMPLIED) view installed and available packages; view package installation history', MANAGE_CONTENT, 'subscribe to content sources; install and uninstall packages') , setCheck(records_0.array, records_0.size_0++, record_0) , record_0 = $createResourcePermissionRecord(this, 'Create Child Resources', 'subsystems/inventory/CreateChild', VIEW_RESOURCE, '(IMPLIED) view child Resource creation history', CREATE_CHILD_RESOURCES, 'create new child Resources (for child Resources of types that are creatable)') , setCheck(records_0.array, records_0.size_0++, record_0) , record_0 = $createResourcePermissionRecord(this, 'Delete Child Resources', 'subsystems/inventory/DeleteChild', VIEW_RESOURCE, '(IMPLIED) view child Resource deletion history', DELETE_RESOURCE, 'uninventory resources; delete Resources (for Resources of types that are deletable)') , setCheck(records_0.array, records_0.size_0++, record_0) , record_0 = $createResourcePermissionRecord(this, 'Manage Drift', 'subsystems/drift/Drift', VIEW_RESOURCE, '(IMPLIED) view drift definitions and drift history', MANAGE_DRIFT, 'create, update, and delete drift definitions; and manage drift instances') , setCheck(records_0.array, records_0.size_0++, record_0) , $setData(grid_0, dynamicCast($toArray_1(records_0, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, records_0.size_0, 0)), Q$ListGridRecord_$1)) , grid_0);
  $addMember(this, this.resourcePermissionsGrid);
}

function convertToListGridRecordArray_0(jsObject){
  var i, jsArray, jsArrayItem, record, records;
  if (!jsObject) {
    return initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, 0, 0);
  }
  jsArray = toArray_3(jsObject);
  records = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, jsArray.length, 0);
  for (i = 0; i < jsArray.length; ++i) {
    jsArrayItem = jsArray[i];
    record = dynamicCast(getRef(jsArrayItem), Q$ListGridRecord);
    !record && (record = new ListGridRecord_1(jsArrayItem));
    setCheck(records, i, record);
  }
  return records;
}

function handleIllegalPermissionSelection(event_0, messageString){
  var jsObj;
  $clinit_PermissionsEditor();
  var message;
  (jsObj = event_0.jsObj , getOrCreateRef_6(jsObj.item)).setValue_6(true);
  message = new Message_8(messageString, ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient)));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
}

defineSeed(1688, 1632, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$Enhanced]), PermissionsEditor_0);
_.redraw_0 = function redraw_0(){
  $redraw_1(this);
}
;
_.globalPermissionsGrid = null;
_.isReadOnly = false;
_.originalValue = null;
_.resourcePermissionsGrid = null;
_.roleEditView = null;
_.selectedPermissions = null;
function PermissionsEditor$1_0(val$recordBeingEdited){
  this.val$recordBeingEdited = val$recordBeingEdited;
}

defineSeed(1689, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), PermissionsEditor$1_0);
_.onRecordClick = function onRecordClick(event_0){
  setCheck(this.val$recordBeingEdited, 0, $getRecord_0(event_0));
}
;
_.val$recordBeingEdited = null;
function PermissionsEditor$2_0(this$0, val$grid, val$nameField){
  this.this$0 = this$0;
  this.val$grid = val$grid;
  this.val$nameField = val$nameField;
}

defineSeed(1690, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler_0]), PermissionsEditor$2_0);
_.onChanged_0 = function onChanged_0(event_0){
  var authorized, messageString, permission, permissionDisplayName, permissionName, record, recordNum;
  authorized = dynamicCast($getValue_4(event_0), Q$Boolean);
  recordNum = $getRowNum_0(event_0);
  record = this.val$grid.getRecord_0(recordNum);
  permissionName = $getAttribute(record, this.val$nameField);
  permission = ($clinit_Permission() , dynamicCast(valueOf(($clinit_Permission$Map() , $MAP_49), permissionName), Q$Permission));
  permissionDisplayName = getAttribute(record.jsObj, 'displayName');
  if (permission == VIEW_RESOURCE) {
    messageString = 'Read access for the ' + ($clinit_PermissionsEditor() , permissionDisplayName) + ' permission is implied and cannot be disabled.';
    handleIllegalPermissionSelection(event_0, messageString);
  }
   else if (!authorized.value_0 && this.this$0.selectedPermissions.contains_0(MANAGE_SECURITY) && permission != MANAGE_SECURITY) {
    messageString = ($clinit_PermissionsEditor() , permissionDisplayName) + ' permission cannot be deselected, unless the Manage Security permission, which implies all other permissions, is deselected first.';
    handleIllegalPermissionSelection(event_0, messageString);
  }
   else if (!authorized.value_0 && this.this$0.selectedPermissions.contains_0(MANAGE_INVENTORY) && permission.target == ($clinit_Permission$Target() , RESOURCE)) {
    messageString = ($clinit_PermissionsEditor() , permissionDisplayName) + ' permission cannot be deselected, unless Manage Inventory, which implies all Resource permissions, is deselected first.';
    handleIllegalPermissionSelection(event_0, messageString);
  }
   else if (!authorized.value_0 && this.this$0.selectedPermissions.contains_0(CONFIGURE_WRITE) && permission == CONFIGURE_READ) {
    messageString = $view_adminRoles_permissions_illegalDeselectionDueToCorrespondingWritePermSelection(($clinit_PermissionsEditor() , permissionDisplayName));
    handleIllegalPermissionSelection(event_0, messageString);
  }
   else {
    $updatePermissions(this.this$0, authorized, permission);
    $onItemChanged(this.this$0.roleEditView);
  }
}
;
_.this$0 = null;
_.val$grid = null;
_.val$nameField = null;
function $clinit_AbstractRecordEditor(){
  $clinit_AbstractRecordEditor = nullMethod;
  $clinit_BaseWidget();
  LOADING_LABEL = new Label_4(($clinit_Enhanced() , 'Loading...'));
}

function $buildButtonBar(this$static){
  if (this$static.isReadOnly) {
    return null;
  }
  return new AbstractRecordEditor$ButtonBar_0(this$static);
}

function $buildContentPane(this$static){
  var contentPane;
  contentPane = new EnhancedVLayout_0;
  $isCreated_1(contentPane)?$setProperty_3(contentPane, 'width', '100%'):(contentPane.config_0['width'] = '100%' , undefined);
  $isCreated_1(contentPane)?$setProperty_3(contentPane, 'height', '100%'):(contentPane.config_0['height'] = '100%' , undefined);
  $setAttribute_24(contentPane, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  this$static.form_0 = this$static.buildForm();
  $addMember(contentPane, this$static.form_0);
  return contentPane;
}

function $buildForm(this$static){
  var form, isNewRecord, items;
  isNewRecord = this$static.recordId == 0;
  form = new EnhancedDynamicForm_2(this$static.isFormReadOnly(), isNewRecord);
  $setAttribute_20(form, 'dataSource', $getOrCreateJsObj(this$static.dataSource), true);
  items = this$static.createFormItems(form);
  $setFields_3(form, dynamicCast($toArray_1(items, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, items.size_0, 0)), Q$FormItem_$1));
  $addItemChangedHandler(form, new AbstractRecordEditor$1_0(this$static));
  return form;
}

function $displayForm(this$static){
  var member, member$array, member$index, member$max;
  $removeMember(this$static, LOADING_LABEL);
  $destroy(LOADING_LABEL);
  for (member$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members')) , member$index = 0 , member$max = member$array.length; member$index < member$max; ++member$index) {
    member = member$array[member$index];
    member.show_0();
  }
  $markForRedraw(this$static);
}

function $editExistingRecord(this$static, record){
  var recordName, title;
  recordName = $getAttribute(record, this$static.getTitleFieldName());
  title = this$static.isReadOnly?'View ' + ($clinit_Enhanced() , this$static.dataTypeName) + ' [' + recordName + ']':'Edit ' + ($clinit_Enhanced() , this$static.dataTypeName) + ' [' + recordName + ']';
  $setTitle_3(this$static.titleBar, title);
  $editRecord(this$static.form_0, record);
  $validate(this$static.form_0);
  this$static.editRecord_0(record);
}

function $editNewRecord(this$static){
  var idItem, record;
  $setTitle_3(this$static.titleBar, 'Create New ' + ($clinit_Enhanced() , this$static.dataTypeName));
  record = this$static.createNewRecord();
  $editRecord(this$static.form_0, record);
  $setAttribute_24(this$static.form_0, 'saveOperationType', ($clinit_DSOperationType() , ADD).value_0, true);
  idItem = $getField_0(this$static.form_0, 'id');
  if (idItem) {
    idItem.setDefaultValue(valueOf_44(0));
    $hide_0(idItem);
  }
  this$static.editRecord_0(record);
}

function $fetchExistingRecord(this$static, recordId){
  var criteria;
  criteria = new Criteria_0;
  $addCriteria_1(criteria, 'id', valueOf_44(recordId));
  $fetchData_1(this$static.form_0, criteria, new AbstractRecordEditor$3_0(this$static));
}

function $init_1(this$static, isReadOnly){
  var message;
  if (this$static.recordId == 0 && isReadOnly) {
    message = new Message_7('You do not have the permissions required to create a new [' + ($clinit_Enhanced() , this$static.dataTypeName) + ']', ($clinit_Message$Severity() , Error_2));
    $clinit_CoreGUI();
    goToView(this$static.getListViewPath(), message, false);
  }
   else {
    this$static.isReadOnly = isReadOnly;
    this$static.contentPane = this$static.buildContentPane();
    this$static.contentPane.hide_0();
    $addMember(this$static, this$static.contentPane);
    this$static.buttonBar = this$static.buildButtonBar();
    if (this$static.buttonBar) {
      $hide(this$static.buttonBar);
      $addMember(this$static, this$static.buttonBar);
    }
    if (this$static.recordId == 0) {
      $editNewRecord(this$static);
      $displayForm(this$static);
    }
     else {
      $fetchExistingRecord(this$static, this$static.recordId);
    }
  }
}

function $onItemChanged(this$static){
  var resetButton, saveButton;
  if (!this$static.isReadOnly) {
    saveButton = this$static.buttonBar.saveButton;
    $isDisabled(saveButton).value_0 && $setAttribute_22(saveButton, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , FALSE), true);
    resetButton = this$static.buttonBar.resetButton;
    $isDisabled(resetButton).value_0 && $setAttribute_22(resetButton, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , FALSE), true);
  }
}

function $renderView_1(this$static, viewPath){
  var parentViewPath;
  ++viewPath.index_0;
  parentViewPath = $getPathToIndex(viewPath, viewPath.index_0 - 1);
  this$static.listViewPath = parentViewPath;
}

function $save_0(this$static, requestProperties){
  var message;
  if (!$validate(this$static.form_0)) {
    message = new Message_8('One or more fields have invalid values. This [' + ($clinit_Enhanced() , this$static.dataTypeName) + '] cannot be saved until these values are corrected', ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient)));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
    return;
  }
  $saveData_0(this$static.form_0, new AbstractRecordEditor$2_0(this$static), requestProperties);
}

function AbstractRecordEditor_0(dataSource, recordId, dataTypeName, headerIcon){
  EnhancedVLayout_0.call(this);
  this.dataSource = dataSource;
  this.recordId = recordId;
  this.dataTypeName = charToString(toUpperCase(dataTypeName.charCodeAt(0))) + $substring(dataTypeName, 1);
  $setLayoutMargin(this, valueOf_44(0));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 16):(this.config_0['membersMargin'] = 16 , undefined);
  $addMember(this, LOADING_LABEL);
  this.titleBar = new TitleBar_1(null, headerIcon);
  $hide(this.titleBar);
  $addMember(this, this.titleBar);
}

function toListGridRecordArray(roleRecords){
  var i, roleListGridRecords, roleRecord, roleRecordsLength;
  roleListGridRecords = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, roleRecords.length, 0);
  for (i = 0 , roleRecordsLength = roleRecords.length; i < roleRecordsLength; ++i) {
    roleRecord = roleRecords[i];
    setCheck(roleListGridRecords, i, dynamicCast(roleRecord, Q$ListGridRecord));
  }
  return roleListGridRecords;
}

defineSeed(1692, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$DetailsView, Q$Enhanced]));
_.buildButtonBar = function buildButtonBar(){
  return $buildButtonBar(this);
}
;
_.buildContentPane = function buildContentPane(){
  return $buildContentPane(this);
}
;
_.buildForm = function buildForm(){
  return $buildForm(this);
}
;
_.createNewRecord = function createNewRecord(){
  return new ListGridRecord_0;
}
;
_.editExistingRecord = function editExistingRecord(record){
  $editExistingRecord(this, record);
}
;
_.editRecord_0 = function editRecord(record){
}
;
_.getListViewPath = function getListViewPath(){
  return this.listViewPath;
}
;
_.getTitleFieldName = function getTitleFieldName_0(){
  return 'name';
}
;
_.isEditable_0 = function isEditable_0(){
  return !this.isReadOnly;
}
;
_.isFormReadOnly = function isFormReadOnly(){
  return this.isReadOnly;
}
;
_.renderView = function renderView_2(viewPath){
  $renderView_1(this, viewPath);
}
;
_.reset_1 = function reset_0(){
  $resetValues(this.form_0);
}
;
_.save = function save_0(requestProperties){
  $save_0(this, requestProperties);
}
;
_.buttonBar = null;
_.contentPane = null;
_.dataSource = null;
_.dataTypeName = null;
_.form_0 = null;
_.isReadOnly = false;
_.listViewPath = null;
_.postFetchHandlerExecutedAlready = false;
_.recordId = 0;
_.titleBar = null;
var LOADING_LABEL;
function $checkIfLdapConfigured(this$static){
  $checkLdapConfiguredStatus(dynamicCast(secure(getInstance_44(), -1), Q$LdapGWTServiceAsync), new RoleEditView$2_0(this$static));
}

function $init_2(this$static){
  var isReadOnly;
  isReadOnly = !this$static.hasManageSecurityPermission;
  $init_1(this$static, isReadOnly);
}

function RoleEditView_0(roleId){
  $clinit_AbstractRecordEditor();
  AbstractRecordEditor_0.call(this, new RolesDataSource_0, roleId, ($clinit_Enhanced() , 'role'), 'global/Role_24.png');
}

function updateTab(tab, content_0){
  if (!tab) {
    throw new IllegalStateException_1('A null tab was specified.');
  }
  $updateTab(tab.tabSet, tab, content_0);
}

defineSeed(1691, 1692, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$DetailsView, Q$Enhanced]), RoleEditView_0);
_.buildContentPane = function buildContentPane_0(){
  var contentPane, form, tabSet, topPane;
  contentPane = new EnhancedVLayout_0;
  $isCreated_1(contentPane)?$setProperty_3(contentPane, 'width', '100%'):(contentPane.config_0['width'] = '100%' , undefined);
  $isCreated_1(contentPane)?$setProperty_3(contentPane, 'height', '100%'):(contentPane.config_0['height'] = '100%' , undefined);
  $setAttribute_24(contentPane, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  form = $buildForm(this);
  this.form_0 = form;
  topPane = new EnhancedVLayout_0;
  $isCreated_1(topPane)?$setProperty_3(topPane, 'width', '100%'):(topPane.config_0['width'] = '100%' , undefined);
  $isCreated_1(topPane)?$setProperty_0(topPane, 'height', 80):(topPane.config_0['height'] = 80 , undefined);
  $addMember(topPane, form);
  $addMember(contentPane, topPane);
  tabSet = new TabSet_0;
  $isCreated_1(tabSet)?$setProperty_3(tabSet, 'width', '100%'):(tabSet.config_0['width'] = '100%' , undefined);
  $isCreated_1(tabSet)?$setProperty_3(tabSet, 'height', '100%'):(tabSet.config_0['height'] = '100%' , undefined);
  if (this.hasManageSecurityPermission) {
    this.permissionsTab = new Tab_2(($clinit_Enhanced() , 'Permissions'), 'global/Locked_16.png');
    $addTab(tabSet, this.permissionsTab);
    if (!this.isSystemRole) {
      this.resourceGroupsTab = new Tab_2('Resource Groups', getGroupIcon(($clinit_GroupCategory() , MIXED_0)));
      $addTab(tabSet, this.resourceGroupsTab);
    }
    this.subjectsTab = new Tab_2('Users', 'global/User_16.png');
    $addTab(tabSet, this.subjectsTab);
    this.ldapGroupsTab = new Tab_2('LDAP Groups', 'global/Role_16.png');
    $addTab(tabSet, this.ldapGroupsTab);
  }
  $addMember(contentPane, tabSet);
  return contentPane;
}
;
_.createFormItems = function createFormItems(form){
  var descriptionItem, items, nameItem;
  items = new ArrayList_0;
  nameItem = new TextItem_2('name');
  $setShowTitle_0(nameItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setSelectOnFocus(nameItem, TRUE);
  $setTabIndex(nameItem, valueOf_44(1));
  $isCreated_2(nameItem)?$setProperty_9(nameItem, 'outputAsHTML', true):(nameItem.jsObj['outputAsHTML'] = true , undefined);
  setCheck(items.array, items.size_0++, nameItem);
  descriptionItem = new TextItem_2('description');
  $setShowTitle_0(descriptionItem, TRUE);
  $setTabIndex(descriptionItem, valueOf_44(5));
  $setColSpan(descriptionItem, $getAttributeAsInt_0(form, 'numCols').value_0);
  $isCreated_2(descriptionItem)?$setProperty_9(descriptionItem, 'outputAsHTML', true):(descriptionItem.jsObj['outputAsHTML'] = true , undefined);
  setCheck(items.array, items.size_0++, descriptionItem);
  return items;
}
;
_.createNewRecord = function createNewRecord_0(){
  var role, roleRecord;
  role = new Role_0;
  $addPermission(role, ($clinit_Permission() , VIEW_USERS));
  roleRecord = $copyValues_5(($clinit_RPCDataSource() , !INSTANCE_2 && (INSTANCE_2 = new RolesDataSource_0) , $clinit_RPCDataSource() , role), true);
  return roleRecord;
}
;
_.editRecord_0 = function editRecord_0(record){
  var filteredSubjectRecords, groupListGridRecords, groupRecords, isMemberOfRole, label, ldapGroupListGridRecords, ldapGroupRecords, sessionSubject, sessionSubjectId, subjectId, subjectListGridRecord, subjectListGridRecord$index, subjectListGridRecord$max, subjectListGridRecords, subjectRecord, subjectRecord$index, subjectRecord$max, subjectRecords;
  sessionSubject = ($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0);
  sessionSubjectId = sessionSubject.id;
  subjectRecords = convertToRecordArray(getAttributeAsJavaScriptObject(record.jsObj, 'subjects'));
  isMemberOfRole = false;
  for (subjectRecord$index = 0 , subjectRecord$max = subjectRecords.length; subjectRecord$index < subjectRecord$max; ++subjectRecord$index) {
    subjectRecord = subjectRecords[subjectRecord$index];
    subjectId = getAttributeAsInt(subjectRecord.jsObj, 'id').value_0;
    subjectId == sessionSubjectId && (isMemberOfRole = true);
  }
  if (this.hasManageSecurityPermission || isMemberOfRole) {
    this.permissionsEditor = new PermissionsEditor_0(this, !this.hasManageSecurityPermission || this.isSystemRole);
    updateTab(this.permissionsTab, this.permissionsEditor);
    if (!this.isSystemRole) {
      groupRecords = convertToRecordArray(getAttributeAsJavaScriptObject(record.jsObj, 'resourceGroups'));
      groupListGridRecords = toListGridRecordArray(groupRecords);
      this.resourceGroupSelector = new RoleResourceGroupSelector_0(groupListGridRecords, !this.hasManageSecurityPermission);
      $addAssignedItemsChangedHandler(this.resourceGroupSelector, new RoleEditView$3_0(this));
      updateTab(this.resourceGroupsTab, this.resourceGroupSelector);
    }
    subjectListGridRecords = toListGridRecordArray(subjectRecords);
    if (this.recordId == 1) {
      filteredSubjectRecords = new ArrayList_0;
      for (subjectListGridRecord$index = 0 , subjectListGridRecord$max = subjectListGridRecords.length; subjectListGridRecord$index < subjectListGridRecord$max; ++subjectListGridRecord$index) {
        subjectListGridRecord = subjectListGridRecords[subjectListGridRecord$index];
        subjectId = getAttributeAsInt(subjectListGridRecord.jsObj, 'id').value_0;
        subjectId == 2 && subjectListGridRecord.setEnabled(($clinit_Boolean() , $clinit_Boolean() , FALSE));
        subjectId != 1 && (setCheck(filteredSubjectRecords.array, filteredSubjectRecords.size_0++, subjectListGridRecord) , true);
      }
      subjectListGridRecords = dynamicCast($toArray_1(filteredSubjectRecords, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, filteredSubjectRecords.size_0, 0)), Q$ListGridRecord_$1);
    }
    this.subjectSelector = new RoleSubjectSelector_0(subjectListGridRecords, !this.hasManageSecurityPermission);
    $addAssignedItemsChangedHandler(this.subjectSelector, new RoleEditView$4_0(this));
    updateTab(this.subjectsTab, this.subjectSelector);
    if (this.isLdapConfigured) {
      ldapGroupRecords = convertToRecordArray(getAttributeAsJavaScriptObject(record.jsObj, 'ldapGroups'));
      ldapGroupListGridRecords = toListGridRecordArray(ldapGroupRecords);
      this.ldapGroupSelector = new RoleLdapGroupSelector_0(ldapGroupListGridRecords, !this.hasManageSecurityPermission);
      $addAssignedItemsChangedHandler(this.ldapGroupSelector, new RoleEditView$5_0(this));
      updateTab(this.ldapGroupsTab, this.ldapGroupSelector);
    }
     else {
      label = new Label_4('<b>' + ($clinit_Enhanced() , 'NOTE:') + "<\/b> The LDAP security integration is not configured. To configure LDAP, go to <a href='#Administration/Configuration/SystemSettings'>System Settings<\/a>.");
      $isCreated_1(label)?$setProperty_3(label, 'width', '100%'):(label.config_0['width'] = '100%' , undefined);
      $isCreated_1(label)?$setProperty_0(label, 'height', 20):(label.config_0['height'] = 20 , undefined);
      $setPadding(label, valueOf_44(10));
      updateTab(this.ldapGroupsTab, label);
    }
  }
  $redraw_1(this.permissionsEditor);
}
;
_.isFormReadOnly = function isFormReadOnly_0(){
  return this.isReadOnly || this.isSystemRole;
}
;
_.renderView = function renderView_3(viewPath){
  $renderView_1(this, viewPath);
  this.isSystemRole = ($clinit_RPCDataSource() , this.recordId == 1);
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new RoleEditView$1_0(this)));
}
;
_.reset_1 = function reset_1(){
  $resetValues(this.form_0);
  !!this.permissionsEditor && $redraw_1(this.permissionsEditor);
  !!this.resourceGroupSelector && $reset_1(this.resourceGroupSelector);
  !!this.subjectSelector && $reset_1(this.subjectSelector);
  !!this.ldapGroupSelector && $reset_1(this.ldapGroupSelector);
}
;
_.save = function save_1(requestProperties){
  var ldapGroupRecords, resourceGroupRecords, subjectRecords;
  if (this.resourceGroupSelector) {
    resourceGroupRecords = this.resourceGroupSelector.assignedGrid.getRecords();
    $setValue_2(this.form_0, 'resourceGroups', resourceGroupRecords);
  }
  if (this.subjectSelector) {
    subjectRecords = this.subjectSelector.assignedGrid.getRecords();
    $setValue_2(this.form_0, 'subjects', subjectRecords);
  }
  if (this.ldapGroupSelector) {
    ldapGroupRecords = this.ldapGroupSelector.assignedGrid.getRecords();
    $setValue_2(this.form_0, 'ldapGroups', ldapGroupRecords);
  }
  $save_0(this, requestProperties);
}
;
_.hasManageSecurityPermission = false;
_.isLdapConfigured = false;
_.isSystemRole = false;
_.ldapGroupSelector = null;
_.ldapGroupsTab = null;
_.permissionsEditor = null;
_.permissionsTab = null;
_.resourceGroupSelector = null;
_.resourceGroupsTab = null;
_.subjectSelector = null;
_.subjectsTab = null;
function RoleEditView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1693, 1, {}, RoleEditView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded(perms){
  if (!perms) {
    $handleError_0(($clinit_CoreGUI() , 'Failed to load global permissions for current user. Perhaps the Server is down.'), null);
    return;
  }
  this.this$0.hasManageSecurityPermission = perms.contains_0(($clinit_Permission() , MANAGE_SECURITY));
  $checkIfLdapConfigured(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_44(this$static, isLdapConfigured){
  this$static.this$0.isLdapConfigured = isLdapConfigured.value_0;
  $init_2(this$static.this$0);
}

function RoleEditView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1694, 1, {}, RoleEditView$2_0);
_.onFailure = function onFailure_46(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to determine if LDAP configured - assuming no LDAP.'), caught);
}
;
_.onSuccess_0 = function onSuccess_46(isLdapConfigured){
  $onSuccess_44(this, dynamicCast(isLdapConfigured, Q$Boolean));
}
;
_.this$0 = null;
function RoleEditView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1695, 1, makeCastMap([Q$EventHandler, Q$AssignedItemsChangedHandler]), RoleEditView$3_0);
_.onSelectionChanged_0 = function onSelectionChanged(event_0){
  $onItemChanged(this.this$0);
}
;
_.this$0 = null;
function RoleEditView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1696, 1, makeCastMap([Q$EventHandler, Q$AssignedItemsChangedHandler]), RoleEditView$4_0);
_.onSelectionChanged_0 = function onSelectionChanged_0(event_0){
  $onItemChanged(this.this$0);
}
;
_.this$0 = null;
function RoleEditView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1697, 1, makeCastMap([Q$EventHandler, Q$AssignedItemsChangedHandler]), RoleEditView$5_0);
_.onSelectionChanged_0 = function onSelectionChanged_1(event_0){
  $onItemChanged(this.this$0);
}
;
_.this$0 = null;
function $addAssignedItemsChangedHandler(this$static, handler){
  $add_6(this$static.assignedItemsChangedHandlers, handler);
  return new AbstractSelector$14_0;
}

function $addSelectedRows(this$static){
  $moveSelectedData(this$static.availableGrid, this$static.assignedGrid);
  $notifyAssignedItemsChangedHandlers(this$static);
  this$static.updateButtonEnablement();
}

function $buildAssignedItemsStack(this$static){
  var assignedFields, assignedSection, assignedSectionStack, iconField, itemIcon, nameField, itemTitle;
  assignedSectionStack = new SectionStack_0;
  $isCreated_1(assignedSectionStack)?$setProperty_3(assignedSectionStack, 'width', '*'):(assignedSectionStack.config_0['width'] = '*' , undefined);
  $isCreated_1(assignedSectionStack)?$setProperty_3(assignedSectionStack, 'height', '100%'):(assignedSectionStack.config_0['height'] = '100%' , undefined);
  $setAttribute_24(assignedSectionStack, 'align', ($clinit_Alignment() , LEFT_0).value_0, true);
  assignedSection = new SectionStackSection_1((itemTitle = this$static.getItemTitle() , 'Assigned ' + ($clinit_Enhanced() , itemTitle)));
  $setAttribute_8(assignedSection, 'canCollapse', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setExpanded(assignedSection, TRUE);
  this$static.assignedGrid.setCanReorderRecords(TRUE);
  this$static.assignedGrid.setCanDragRecordsOut(TRUE);
  $setAttribute_24(this$static.assignedGrid, 'dragDataAction', ($clinit_DragDataAction() , MOVE).value_0, true);
  if (this$static.getItemIcon() != null) {
    $setAttribute_24(this$static.assignedGrid, 'dragTrackerMode', ($clinit_DragTrackerMode() , ICON).value_0, false);
    $setAttribute_20(this$static.assignedGrid, 'trackerImage', (new ImgProperties_0(this$static.getItemIcon())).jsObj, true);
  }
  this$static.assignedGrid.setCanAcceptDroppedRecords(TRUE);
  $setLoadingMessage(this$static.assignedGrid, 'Loading...');
  this$static.assignedGrid.setEmptyMessage('No items to show');
  assignedFields = new ArrayList_0;
  itemIcon = this$static.getItemIcon();
  if (itemIcon != null) {
    iconField = new ListGridField_2('icon', 25);
    $setAttribute_13(iconField, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0);
    iconField.jsObj['cellIcon'] = itemIcon;
    $setAttribute_8(iconField, 'showDefaultContextMenu', FALSE);
    setCheck(assignedFields.array, assignedFields.size_0++, iconField);
  }
  nameField = new ListGridField_3('name', 'Name');
  if (this$static.supportsNameHoverCustomizer()) {
    $setAttribute_8(nameField, 'showHover', TRUE);
    $setHoverCustomizer_0(nameField, this$static.getNameHoverCustomizer());
  }
  setCheck(assignedFields.array, assignedFields.size_0++, nameField);
  $setFields_1(this$static.assignedGrid, dynamicCast($toArray_1(assignedFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, assignedFields.size_0, 0)), Q$ListGridField_$1));
  $setItems(assignedSection, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [this$static.assignedGrid]));
  $addSection(assignedSectionStack, assignedSection);
  this$static.initialSelection != null && $setData(this$static.assignedGrid, this$static.initialSelection);
  if (this$static.isReadOnly) {
    $setDisabled(this$static.assignedGrid, true);
  }
   else {
    $addSelectionChangedHandler(this$static.assignedGrid, new AbstractSelector$10_0(this$static));
    $addDoubleClickHandler(this$static.assignedGrid, new AbstractSelector$11_0(this$static));
    $addKeyPressHandler(this$static.assignedGrid, new AbstractSelector$12_0(this$static));
    this$static.assignedGrid.addRecordDropHandler(new AbstractSelector$13_0(this$static));
  }
  return assignedSectionStack;
}

function $buildAvailableItemsStack(this$static){
  var availableFields, availableSection, availableSectionStack, iconField, itemIcon, nameField, itemTitle;
  availableSectionStack = new SectionStack_0;
  $isCreated_1(availableSectionStack)?$setProperty_3(availableSectionStack, 'width', '*'):(availableSectionStack.config_0['width'] = '*' , undefined);
  $isCreated_1(availableSectionStack)?$setProperty_3(availableSectionStack, 'height', '100%'):(availableSectionStack.config_0['height'] = '100%' , undefined);
  availableSection = new SectionStackSection_1((itemTitle = this$static.getItemTitle() , 'Available ' + ($clinit_Enhanced() , itemTitle)));
  $setAttribute_8(availableSection, 'canCollapse', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setExpanded(availableSection, TRUE);
  this$static.availableGrid.setCanReorderRecords(TRUE);
  this$static.availableGrid.setCanDragRecordsOut(TRUE);
  $setAttribute_24(this$static.availableGrid, 'dragDataAction', ($clinit_DragDataAction() , MOVE).value_0, true);
  if (this$static.getItemIcon() != null) {
    $setAttribute_24(this$static.availableGrid, 'dragTrackerMode', ($clinit_DragTrackerMode() , ICON).value_0, false);
    $setAttribute_20(this$static.availableGrid, 'trackerImage', (new ImgProperties_0(this$static.getItemIcon())).jsObj, true);
  }
  this$static.availableGrid.setCanAcceptDroppedRecords(TRUE);
  $setLoadingMessage(this$static.availableGrid, 'Loading...');
  this$static.availableGrid.setEmptyMessage('No items to show');
  availableFields = new ArrayList_0;
  itemIcon = this$static.getItemIcon();
  if (itemIcon != null) {
    iconField = new ListGridField_2('icon', 25);
    $setAttribute_13(iconField, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0);
    iconField.jsObj['cellIcon'] = itemIcon;
    $setAttribute_8(iconField, 'showDefaultContextMenu', FALSE);
    setCheck(availableFields.array, availableFields.size_0++, iconField);
  }
  nameField = new ListGridField_3('name', 'Name');
  if (this$static.supportsNameHoverCustomizer()) {
    $setAttribute_8(nameField, 'showHover', TRUE);
    $setHoverCustomizer_0(nameField, this$static.getNameHoverCustomizer());
  }
  setCheck(availableFields.array, availableFields.size_0++, nameField);
  $setFields_1(this$static.availableGrid, dynamicCast($toArray_1(availableFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, availableFields.size_0, 0)), Q$ListGridField_$1));
  $setItems(availableSection, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [this$static.availableGrid]));
  $addSection(availableSectionStack, availableSection);
  this$static.datasource = this$static.getDataSource_0();
  $setDataPageSize(this$static.datasource, valueOf_44(this$static.getMaxAvailableRecords()));
  if (this$static.availableFilterForm) {
    this$static.latestCriteria = this$static.getLatestCriteria(this$static.availableFilterForm);
    $addItemChangedHandler(this$static.availableFilterForm, new AbstractSelector$1_0(this$static));
  }
  $populateAvailableGrid(this$static, !this$static.latestCriteria?new Criteria_0:this$static.latestCriteria);
  $addSelectionChangedHandler(this$static.availableGrid, new AbstractSelector$2_0(this$static));
  $addDoubleClickHandler(this$static.availableGrid, new AbstractSelector$3_0(this$static));
  this$static.availableGrid.addRecordDropHandler(new AbstractSelector$4_0(this$static));
  return availableSectionStack;
}

function $getSelectedItems(this$static){
  var selectedRecords;
  selectedRecords = this$static.assignedGrid.getRecords();
  return $buildDataObjects(new ResourceGroupSelector$SelectedResourceGroupsDataSource_0, selectedRecords);
}

function $getSelection(this$static){
  var id, ids, selectedRecord, selectedRecord$index, selectedRecord$max, selectedRecords;
  selectedRecords = this$static.assignedGrid.getRecords();
  ids = new HashSet_1(selectedRecords.length);
  for (selectedRecord$index = 0 , selectedRecord$max = selectedRecords.length; selectedRecord$index < selectedRecord$max; ++selectedRecord$index) {
    selectedRecord = selectedRecords[selectedRecord$index];
    id = $getAttributeAsInt(selectedRecord, this$static.getSelectorKey());
    $add_6(ids, id);
  }
  return ids;
}

function $moveSelectedData(sourceGrid, targetGrid){
  var self_0, self_1;
  self_0 = targetGrid.getOrCreateJsObj();
  self_0.transferSelectedData(sourceGrid.getOrCreateJsObj());
  self_1 = sourceGrid.getOrCreateJsObj();
  self_1.removeSelectedData();
}

function $notifyAssignedItemsChangedHandlers(this$static){
  var handler, handler$iterator;
  for (handler$iterator = $iterator($keySet(this$static.assignedItemsChangedHandlers.map)); handler$iterator.val$outerIter.hasNext();) {
    handler = dynamicCast($next_1(handler$iterator), Q$AssignedItemsChangedHandler);
    handler.onSelectionChanged_0(new AssignedItemsChangedEvent_0($getSelectedRecords(this$static.assignedGrid)));
  }
}

function $onInit_3(this$static){
  var assignedItemsStack, availableItemsStack, moveButtonStack, spacer, moveButtonStack_0;
  $onInit(this$static);
  $onInit_Layout(this$static);
  $setAttribute_24(this$static.hlayout, 'align', ($clinit_Alignment() , LEFT_0).value_0, true);
  if (!this$static.isReadOnly) {
    this$static.messageLayout = new Label_3;
    $setMargin(this$static.messageLayout, valueOf_44(3));
    $setAutoHeight(this$static.messageLayout);
    $addMember(this$static, this$static.messageLayout);
    this$static.availableFilterForm = this$static.getAvailableFilterForm();
    if (this$static.availableFilterForm) {
      $addMember(this$static, this$static.availableFilterForm);
      spacer = new LayoutSpacer_0;
      $isCreated_1(spacer)?$setProperty_0(spacer, 'height', 10):(spacer.config_0['height'] = 10 , undefined);
      $addMember(this$static, spacer);
    }
    availableItemsStack = $buildAvailableItemsStack(this$static);
    $addMember(this$static.hlayout, availableItemsStack);
    moveButtonStack = (moveButtonStack_0 = new EnhancedVStack_1 , $isCreated_1(moveButtonStack_0)?$setProperty_0(moveButtonStack_0, 'width', 42):(moveButtonStack_0.config_0['width'] = 42 , undefined) , $isCreated_1(moveButtonStack_0)?$setProperty_0(moveButtonStack_0, 'height', 250):(moveButtonStack_0.config_0['height'] = 250 , undefined) , $setAttribute_24(moveButtonStack_0, 'align', ($clinit_VerticalAlignment() , CENTER_2).value_0, true) , this$static.addButton = new TransferImgButton_0(($clinit_TransferImgButton() , RIGHT_4)) , $addClickHandler(this$static.addButton, new AbstractSelector$6_0(this$static)) , $addMember(moveButtonStack_0, this$static.addButton) , this$static.removeButton = new TransferImgButton_0(LEFT_4) , $addClickHandler(this$static.removeButton, new AbstractSelector$7_0(this$static)) , $addMember(moveButtonStack_0, this$static.removeButton) , this$static.addAllButton = new TransferImgButton_0(RIGHT_ALL) , $addClickHandler(this$static.addAllButton, new AbstractSelector$8_0(this$static)) , $addMember(moveButtonStack_0, this$static.addAllButton) , this$static.removeAllButton = new TransferImgButton_0(LEFT_ALL) , $addClickHandler(this$static.removeAllButton, new AbstractSelector$9_0(this$static)) , $addMember(moveButtonStack_0, this$static.removeAllButton) , moveButtonStack_0);
    $addMember(this$static.hlayout, moveButtonStack);
  }
  assignedItemsStack = $buildAssignedItemsStack(this$static);
  $addMember(this$static.hlayout, assignedItemsStack);
  this$static.updateButtonEnablement();
  $addMember(this$static, this$static.hlayout);
}

function $populateAvailableGrid(this$static, criteria){
  var requestProperties;
  $invalidateCache(this$static.datasource);
  requestProperties = new DSRequest_0;
  $setStartRow(requestProperties, valueOf_44(0));
  $setEndRow(requestProperties, valueOf_44(this$static.getMaxAvailableRecords()));
  $fetchData_0(this$static.datasource, criteria, new AbstractSelector$5_0(this$static), requestProperties);
}

function $removeSelectedRows(this$static){
  $moveSelectedData(this$static.assignedGrid, this$static.availableGrid);
  $notifyAssignedItemsChangedHandlers(this$static);
  this$static.updateButtonEnablement();
}

function $reset_1(this$static){
  $setData(this$static.assignedGrid, this$static.initialSelection);
  $populateAvailableGrid(this$static, this$static.getLatestCriteria(this$static.getAvailableFilterForm()));
}

function $setAssigned(this$static, assignedRecords){
  this$static.initialSelection = assignedRecords;
}

function AbstractSelector_0(){
  AbstractSelector_1.call(this, false);
}

function AbstractSelector_1(isReadOnly){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.assignedItemsChangedHandlers = new HashSet_0;
  this.isReadOnly = isReadOnly;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setMargin(this, valueOf_44(7));
  this.hlayout = new HLayout_0;
  this.assignedGrid = new ListGrid_0;
  this.isReadOnly?$setAttribute_24(this.assignedGrid, 'selectionType', ($clinit_SelectionStyle() , NONE_4).value_0, true):(this.availableGrid = new ListGrid_0);
}

function containsAtLeastOneEnabledRecord(grid){
  var assignedRecord, assignedRecord$index, assignedRecord$max, assignedRecords, result;
  result = false;
  assignedRecords = grid.getRecords();
  for (assignedRecord$index = 0 , assignedRecord$max = assignedRecords.length; assignedRecord$index < assignedRecord$max; ++assignedRecord$index) {
    assignedRecord = assignedRecords[assignedRecord$index];
    if (getAttribute(assignedRecord.jsObj, 'enabled') == null || assignedRecord.getEnabled().value_0) {
      result = true;
      break;
    }
  }
  return result;
}

defineSeed(1699, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]));
_.addSelectedRows = function addSelectedRows(){
  $addSelectedRows(this);
}
;
_.destroy_0 = function destroy_5(){
  destroyMembers(this.hlayout);
  destroyMembers(this);
  $destroy(this);
  if (this.availableGrid) {
    $removeFromParent(this.availableGrid);
    $destroy(this.availableGrid);
  }
  if (this.assignedGrid) {
    $removeFromParent(this.assignedGrid);
    $destroy(this.assignedGrid);
  }
  if (this.addButton) {
    $removeFromParent(this.addButton);
    $destroy(this.addButton);
  }
  if (this.addAllButton) {
    $removeFromParent(this.addAllButton);
    $destroy(this.addAllButton);
  }
  if (this.removeButton) {
    $removeFromParent(this.removeButton);
    $destroy(this.removeButton);
  }
  if (this.removeAllButton) {
    $removeFromParent(this.removeAllButton);
    $destroy(this.removeAllButton);
  }
}
;
_.getItemIcon = function getItemIcon(){
  return null;
}
;
_.getMaxAvailableRecords = function getMaxAvailableRecords(){
  return 100;
}
;
_.getNameHoverCustomizer = function getNameHoverCustomizer(){
  return null;
}
;
_.getSelectorKey = function getSelectorKey(){
  return 'id';
}
;
_.onInit = function onInit_12(){
  $onInit_3(this);
}
;
_.supportsNameHoverCustomizer = function supportsNameHoverCustomizer(){
  return false;
}
;
_.updateButtonEnablement = function updateButtonEnablement(){
  if (!this.isReadOnly) {
    $setDisabled_1(this.addButton, !$anySelected(this.availableGrid).value_0);
    $setDisabled_1(this.removeButton, !$anySelected(this.assignedGrid).value_0);
    $setDisabled_1(this.addAllButton, !containsAtLeastOneEnabledRecord(this.availableGrid));
    $setDisabled_1(this.removeAllButton, !containsAtLeastOneEnabledRecord(this.assignedGrid));
  }
}
;
_.addAllButton = null;
_.addButton = null;
_.assignedGrid = null;
_.availableFilterForm = null;
_.availableGrid = null;
_.availableRecords = null;
_.datasource = null;
_.hlayout = null;
_.initialSelection = null;
_.isReadOnly = false;
_.latestCriteria = null;
_.messageLayout = null;
_.removeAllButton = null;
_.removeButton = null;
function RoleLdapGroupSelector_0(assignedRecords, isReadOnly){
  $clinit_BaseWidget();
  AbstractSelector_1.call(this, isReadOnly);
  this.initialSelection = assignedRecords;
}

function convertToPageList(locatedGroupMaps){
  $clinit_BaseWidget();
  var converted, group, locatedGroupMap, locatedGroupMap$iterator;
  converted = new PageList_0;
  $setPageControl_0(converted, new PageControl_1(0, -1));
  if (locatedGroupMaps) {
    for (locatedGroupMap$iterator = locatedGroupMaps.iterator(); locatedGroupMap$iterator.hasNext();) {
      locatedGroupMap = dynamicCast(locatedGroupMap$iterator.next_0(), Q$Map);
      group = new LdapGroup_0;
      $setDescription_6(group, dynamicCast(locatedGroupMap.get_2('description'), Q$String));
      $setName_11(group, dynamicCast(locatedGroupMap.get_2('name'), Q$String));
      setCheck(converted.array, converted.size_0++, group);
    }
  }
  return converted;
}

defineSeed(1698, 1699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), RoleLdapGroupSelector_0);
_.getAvailableFilterForm = function getAvailableFilterForm(){
  var availableFilterForm, search;
  availableFilterForm = new DynamicForm_0;
  $isCreated_1(availableFilterForm)?$setProperty_3(availableFilterForm, 'width', '100%'):(availableFilterForm.config_0['width'] = '100%' , undefined);
  $isCreated_1(availableFilterForm)?$setProperty_0(availableFilterForm, 'numCols', 2):(availableFilterForm.config_0['numCols'] = 2 , undefined);
  search = new TextItem_3('search', ($clinit_Enhanced() , 'Search'));
  availableFilterForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [search, new SpacerItem_0]));
  return availableFilterForm;
}
;
_.getDataSource_0 = function getDataSource_0(){
  return new RoleLdapGroupSelector$LdapGroupsDataSource_0;
}
;
_.getItemTitle = function getItemTitle(){
  return $clinit_Enhanced() , 'LDAP Groups';
}
;
_.getLatestCriteria = function getLatestCriteria(availableFilterForm){
  var criteria, search;
  search = dynamicCast($getValue(availableFilterForm, 'search'), Q$String);
  criteria = new Criteria_0;
  null != search && (criteria.jsObj['name'] = search , undefined);
  return criteria;
}
;
_.getSelectorKey = function getSelectorKey_0(){
  return 'name';
}
;
function $copyValues_1(from){
  var to;
  to = new ListGridRecord_0;
  $setAttribute_3(to, 'id', from.id);
  $setAttribute_13(to, 'name', from.name_0);
  $setAttribute_13(to, 'description', from.description);
  return to;
}

function $executeFetch_1(this$static, request, response){
  var ldapGroups;
  if (!this$static.cachedLdapGroupsAvailable) {
    $findAvailableGroups(dynamicCast(secure(getInstance_44(), -1), Q$LdapGWTServiceAsync), new RoleLdapGroupSelector$LdapGroupsDataSource$1_0(this$static, request, response));
  }
   else {
    ldapGroups = $filterCachedLdapGroups(this$static, request);
    $sendSuccessResponse_1(this$static, request, response, ldapGroups);
  }
}

function $filterCachedLdapGroups(this$static, request){
  var criteria, id, key, key$iterator, keySet, ldapGroups, locatedGroupMaps, map, map$iterator, nameFilter;
  if (!this$static.cachedNameKeyedMap) {
    this$static.cachedNameKeyedMap = new HashMap_0;
    for (map$iterator = this$static.cachedLdapGroupsAvailable.iterator(); map$iterator.hasNext();) {
      map = dynamicCast(map$iterator.next_0(), Q$Map);
      id = dynamicCast(map.get_2('name'), Q$String);
      this$static.cachedNameKeyedMap.put(id, map);
    }
  }
  criteria = $getCriteria(request);
  nameFilter = dynamicCast(convertToMap(criteria.jsObj).get_2('name'), Q$String);
  if (nameFilter != null && !!$trim(nameFilter).length) {
    locatedGroupMaps = new HashSet_0;
    keySet = $keySet(this$static.cachedNameKeyedMap);
    for (key$iterator = $iterator(keySet); key$iterator.val$outerIter.hasNext();) {
      key = dynamicCast($next_1(key$iterator), Q$String);
      $indexOf_2(key.toLowerCase(), $trim(nameFilter).toLowerCase()) != -1 && locatedGroupMaps.add(dynamicCast(this$static.cachedNameKeyedMap.get_2(key), Q$Map));
    }
  }
   else {
    locatedGroupMaps = this$static.cachedLdapGroupsAvailable;
  }
  ldapGroups = convertToPageList(locatedGroupMaps);
  return ldapGroups;
}

function RoleLdapGroupSelector$LdapGroupsDataSource_0(){
  $clinit_RPCDataSource();
  var descriptionField, nameField;
  RPCDataSource_0.call(this);
  nameField = new DataSourceTextField_1('name', 'name');
  $setAttribute_8(nameField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  descriptionField = new DataSourceTextField_1('description', 'description');
  $setFields(this, initValues(_3Lcom_smartgwt_client_data_DataSourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$DataSourceField, [nameField, descriptionField]));
}

defineSeed(1700, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), RoleLdapGroupSelector$LdapGroupsDataSource_0);
_.copyValues = function copyValues_4(from){
  var to;
  return to = new LdapGroup_0 , $setId_6(to, getAttributeAsInt(from.jsObj, 'id').value_0) , $setName_11(to, getAttribute(from.jsObj, 'name')) , $setDescription_6(to, getAttribute(from.jsObj, 'description')) , to;
}
;
_.copyValues_0 = function copyValues_5(from){
  return $copyValues_1(dynamicCast(from, Q$LdapGroup));
}
;
_.executeFetch = function executeFetch_1(request, response, unused){
  $executeFetch_1(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_1(request){
  return null;
}
;
_.cachedLdapGroupsAvailable = null;
_.cachedNameKeyedMap = null;
function $onSuccess_45(this$static, locatedGroupMaps){
  var ldapGroups;
  debug('Successfully located ' + locatedGroupMaps.size_1() + ' available LDAP groups.');
  this$static.this$1.cachedLdapGroupsAvailable = locatedGroupMaps;
  ldapGroups = convertToPageList(locatedGroupMaps);
  $sendSuccessResponse_1(this$static.this$1, this$static.val$request, this$static.val$response, ldapGroups);
}

function RoleLdapGroupSelector$LdapGroupsDataSource$1_0(this$1, val$request, val$response){
  this.this$1 = this$1;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(1701, 1, {}, RoleLdapGroupSelector$LdapGroupsDataSource$1_0);
_.onFailure = function onFailure_47(throwable){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load LDAP groups available for role.'), throwable);
}
;
_.onSuccess_0 = function onSuccess_47(locatedGroupMaps){
  $onSuccess_45(this, dynamicCast(locatedGroupMaps, Q$Set));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function $clinit_ResourceGroupSelector(){
  $clinit_ResourceGroupSelector = nullMethod;
  $clinit_BaseWidget();
  CATEGORY_VALUE_MAP = new LinkedHashMap_0;
  $put_1(CATEGORY_VALUE_MAP, ($clinit_GroupCategory() , COMPATIBLE).name_0, ($clinit_Enhanced() , 'Compatible'));
  $put_1(CATEGORY_VALUE_MAP, MIXED_0.name_0, 'Mixed');
}

function ResourceGroupSelector_0(categoryFilter, isReadOnly){
  AbstractSelector_1.call(this, isReadOnly);
  this.categoryFilter = categoryFilter;
}

function ResourceGroupSelector_1(isReadOnly){
  ResourceGroupSelector_0.call(this, null, isReadOnly);
}

defineSeed(1703, 1699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]));
_.getAvailableFilterForm = function getAvailableFilterForm_0(){
  var availableFilterForm, groupCategorySelect, search;
  availableFilterForm = new DynamicForm_0;
  $isCreated_1(availableFilterForm)?$setProperty_3(availableFilterForm, 'width', '100%'):(availableFilterForm.config_0['width'] = '100%' , undefined);
  $isCreated_1(availableFilterForm)?$setProperty_0(availableFilterForm, 'numCols', 4):(availableFilterForm.config_0['numCols'] = 4 , undefined);
  search = new TextItem_3('search', ($clinit_Enhanced() , 'Search'));
  groupCategorySelect = new SelectItem_2('groupCategory', 'Group Category');
  groupCategorySelect.setValueMap_0(CATEGORY_VALUE_MAP);
  if (!this.categoryFilter) {
    $setAllowEmptyValue(groupCategorySelect, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  }
   else {
    switch (this.categoryFilter.ordinal) {
      case 0:
        $setValue_7(groupCategorySelect, ($clinit_GroupCategory() , COMPATIBLE).name_0);
        break;
      case 1:
        $setValue_7(groupCategorySelect, ($clinit_GroupCategory() , MIXED_0).name_0);
    }
    $setDisabled_2(groupCategorySelect, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  }
  availableFilterForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [search, groupCategorySelect, new SpacerItem_0]));
  return availableFilterForm;
}
;
_.getDataSource_0 = function getDataSource_1(){
  return new ResourceGroupSelector$SelectedResourceGroupsDataSource_0;
}
;
_.getItemTitle = function getItemTitle_0(){
  return $clinit_Enhanced() , 'Resource Groups';
}
;
_.getLatestCriteria = function getLatestCriteria_0(availableFilterForm){
  var category, criteria, search;
  search = dynamicCast($getValue(availableFilterForm, 'search'), Q$String);
  category = dynamicCast($getValue(availableFilterForm, 'groupCategory'), Q$String);
  criteria = new Criteria_0;
  null != search && $addCriteria_2(criteria, ($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName, search);
  null != category && $addCriteria_2(criteria, ($clinit_ResourceGroupDataSourceField() , CATEGORY).propertyName, category);
  return criteria;
}
;
_.categoryFilter = null;
var CATEGORY_VALUE_MAP;
function RoleResourceGroupSelector_0(groupRecords, isReadOnly){
  $clinit_ResourceGroupSelector();
  ResourceGroupSelector_1.call(this, isReadOnly);
  this.initialSelection = groupRecords;
}

defineSeed(1702, 1703, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), RoleResourceGroupSelector_0);
function RoleSubjectSelector_0(subjectRecords, isReadOnly){
  $clinit_BaseWidget();
  AbstractSelector_1.call(this, isReadOnly);
  this.initialSelection = subjectRecords;
}

defineSeed(1704, 1699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), RoleSubjectSelector_0);
_.getAvailableFilterForm = function getAvailableFilterForm_1(){
  return null;
}
;
_.getDataSource_0 = function getDataSource_2(){
  return new RoleSubjectSelector$RoleUsersDataSource_0;
}
;
_.getItemIcon = function getItemIcon_0(){
  return 'global/User_16.png';
}
;
_.getItemTitle = function getItemTitle_1(){
  return $clinit_Enhanced() , 'Users';
}
;
_.getLatestCriteria = function getLatestCriteria_1(availableFilterForm){
  return null;
}
;
_.getMaxAvailableRecords = function getMaxAvailableRecords_0(){
  return 500;
}
;
function $copyUserValues(subject, isLdap){
  var targetRecord;
  targetRecord = $copyValues_3(subject, true);
  targetRecord.jsObj['ldap'] = isLdap;
  if (subject.name_0 != null) {
    targetRecord.jsObj['password'] = 'XXXXXXXX';
    targetRecord.jsObj['passwordVerify'] = 'XXXXXXXX';
  }
  return targetRecord;
}

function $copyValues_2(from){
  var roleRecords, to;
  to = new Subject_0;
  $setId_0(to, getAttributeAsInt(from.jsObj, 'id').value_0);
  $setName_3(to, getAttribute(from.jsObj, 'name'));
  $setFirstName(to, getAttribute(from.jsObj, 'firstName'));
  $setLastName(to, getAttribute(from.jsObj, 'lastName'));
  $setFactive(to, ($clinit_Boolean() , $equalsIgnoreCase('true', getAttribute(from.jsObj, 'factive'))?TRUE:FALSE).value_0);
  $setFsystem(to, ($equalsIgnoreCase('true', getAttribute(from.jsObj, 'fsystem'))?TRUE:FALSE).value_0);
  $setDepartment(to, getAttribute(from.jsObj, 'department'));
  $setPhoneNumber(to, getAttribute(from.jsObj, 'phoneNumber'));
  $setEmailAddress(to, getAttribute(from.jsObj, 'emailAddress'));
  roleRecords = convertToRecordArray(getAttributeAsJavaScriptObject(from.jsObj, 'roles'));
  $setRoles(to, $buildDataObjects((!INSTANCE_2 && (INSTANCE_2 = new RolesDataSource_0) , INSTANCE_2), roleRecords));
  return to;
}

function $copyValues_3(from, cascade){
  var roleRecords, to;
  to = new ListGridRecord_0;
  $setAttribute_3(to, 'id', from.id);
  $setAttribute_13(to, 'name', from.name_0);
  $setAttribute_13(to, 'firstName', from.firstName);
  $setAttribute_13(to, 'lastName', from.lastName);
  $setAttribute_16(to, 'factive', from.factive);
  $setAttribute_16(to, 'fsystem', from.fsystem);
  $setAttribute_13(to, 'department', from.department);
  $setAttribute_13(to, 'phoneNumber', from.phoneNumber);
  $setAttribute_13(to, 'emailAddress', from.emailAddress);
  if (cascade) {
    roleRecords = $buildRecords((!INSTANCE_2 && (INSTANCE_2 = new RolesDataSource_0) , INSTANCE_2), (!from.roles && (from.roles = new HashSet_0) , from.roles), false);
    to.jsObj['roles'] = convertToJavaScriptArray(roleRecords);
  }
  return to;
}

function $executeFetch_2(this$static, request, response, criteria){
  $findSubjectsByCriteria(this$static.subjectService, criteria, new UsersDataSource$1_0(this$static, request, response));
}

function UsersDataSource_0(){
  var fields_0, idDataField, usernameField, regExpValidator, ldapField, passwordField, passwordValidator, passwordVerifyField, passwordsEqualValidator, firstNameField, lastNameField, emailAddressField, emailAddressValidator, phoneNumberField, departmentField, enabledField, rolesField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.subjectService = dynamicCast(secure(getInstance_54(), -1), Q$SubjectGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , idDataField = new DataSourceIntegerField_1('id', 'ID') , $setAttribute_8(idDataField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setAttribute_8(idDataField, 'canEdit', FALSE) , setCheck(fields_0.array, fields_0.size_0++, idDataField) , usernameField = createTextField('name', 'User Name', valueOf_44(3), valueOf_44(100), TRUE) , regExpValidator = new RegExpValidator_1('[^&<]*') , usernameField.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [regExpValidator])) , setCheck(fields_0.array, fields_0.size_0++, usernameField) , ldapField = createBooleanField('ldap', 'LDAP Login?', TRUE) , $setAttribute_8(ldapField, 'canEdit', FALSE) , setCheck(fields_0.array, fields_0.size_0++, ldapField) , passwordField = new DataSourcePasswordField_0('password', 'Password') , passwordValidator = new LengthRangeValidator_0 , $setAttribute_11(passwordValidator, 'min', valueOf_44(6)) , $setAttribute_11(passwordValidator, 'max', valueOf_44(100)) , passwordField.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [passwordValidator])) , setCheck(fields_0.array, fields_0.size_0++, passwordField) , passwordVerifyField = new DataSourcePasswordField_0('passwordVerify', 'Verify Password') , passwordsEqualValidator = new MatchesFieldValidator_0 , passwordsEqualValidator.jsObj['otherField'] = 'password' , passwordsEqualValidator.jsObj['errorMessage'] = 'Passwords do not match.' , passwordVerifyField.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [passwordsEqualValidator])) , setCheck(fields_0.array, fields_0.size_0++, passwordVerifyField) , firstNameField = createTextField('firstName', 'First Name', null, valueOf_44(100), TRUE) , setCheck(fields_0.array, fields_0.size_0++, firstNameField) , lastNameField = createTextField('lastName', 'Last Name', null, valueOf_44(100), TRUE) , setCheck(fields_0.array, fields_0.size_0++, lastNameField) , emailAddressField = createTextField('emailAddress', 'Email Address', null, valueOf_44(100), TRUE) , setCheck(fields_0.array, fields_0.size_0++, emailAddressField) , emailAddressValidator = new RegExpValidator_1('^([a-zA-Z0-9_.\\-+])+@([a-zA-Z0-9\\-])+(\\.([a-zA-Z0-9\\-])+)*$') , emailAddressValidator.jsObj['errorMessage'] = 'Invalid email address.' , emailAddressField.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [emailAddressValidator])) , phoneNumberField = createTextField('phoneNumber', 'Phone Number', null, valueOf_44(100), FALSE) , setCheck(fields_0.array, fields_0.size_0++, phoneNumberField) , departmentField = createTextField('department', 'Department', null, valueOf_44(100), FALSE) , setCheck(fields_0.array, fields_0.size_0++, departmentField) , enabledField = createBooleanField('factive', 'Login Enabled?', TRUE) , setCheck(fields_0.array, fields_0.size_0++, enabledField) , rolesField = new DataSourceField_2('roles', ($clinit_FieldType() , ANY), 'Roles') , setCheck(fields_0.array, fields_0.size_0++, rolesField) , fields_0);
  $addFields(this, fields);
}

defineSeed(1706, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), UsersDataSource_0);
_.copyValues = function copyValues_6(from){
  return $copyValues_2(from);
}
;
_.copyValues_0 = function copyValues_7(from){
  return $copyValues_3(dynamicCast(from, Q$Subject), true);
}
;
_.copyValues_1 = function copyValues_8(from, cascade){
  return $copyValues_3(dynamicCast(from, Q$Subject), cascade);
}
;
_.executeAdd = function executeAdd_0(recordToAdd, request, response){
  var newSubject, password;
  newSubject = $copyValues_2(recordToAdd);
  password = getAttribute(recordToAdd.jsObj, 'password');
  $createSubject(this.subjectService, newSubject, password, new UsersDataSource$2_0(this, newSubject, request, response));
}
;
_.executeFetch = function executeFetch_2(request, response, criteria){
  $executeFetch_2(this, request, response, dynamicCast(criteria, Q$SubjectCriteria));
}
;
_.executeUpdate = function executeUpdate_0(editedUserRecord, oldUserRecord, request, response){
  var editedPassword, editedSubject, newPassword, passwordWasEdited, username;
  editedSubject = $copyValues_2(editedUserRecord);
  username = editedSubject.name_0;
  editedPassword = getAttribute(editedUserRecord.jsObj, 'password');
  passwordWasEdited = !$equals_6('XXXXXXXX', editedPassword);
  newPassword = passwordWasEdited?editedPassword:null;
  $updateSubject(this.subjectService, editedSubject, newPassword, new UsersDataSource$3_0(this, username, request, response, editedUserRecord));
}
;
_.getFetchCriteria = function getFetchCriteria_2(request){
  var criteria, subjectId;
  return criteria = new SubjectCriteria_0 , subjectId = dynamicCast(getFilter($getCriteria(request), 'id', Ljava_lang_Integer_2_classLit), Q$Integer) , criteria.filterId = subjectId , $addFilterFsystem(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , !!subjectId && (criteria.fetchRoles = true) , criteria;
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_0(columnName){
  if ($equals_6('ldap', columnName)) {
    return null;
  }
  return columnName;
}
;
var INSTANCE_1 = null;
function RoleSubjectSelector$RoleUsersDataSource_0(){
  $clinit_RPCDataSource();
  UsersDataSource_0.call(this);
}

defineSeed(1705, 1706, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), RoleSubjectSelector$RoleUsersDataSource_0);
_.sendSuccessResponseRecords = function sendSuccessResponseRecords_0(request, response, records){
  var id, record, record$iterator, rhqAdminRecord;
  rhqAdminRecord = null;
  for (record$iterator = new AbstractList$IteratorImpl_0(records); record$iterator.i < record$iterator.this$0_0.size_1();) {
    record = dynamicCast($next_0(record$iterator), Q$Record);
    id = getAttributeAsInt(record.jsObj, 'id');
    if ($equals_4(id, valueOf_44(2))) {
      rhqAdminRecord = record;
      break;
    }
  }
  if (rhqAdminRecord) {
    $setTotalSize(records, max_0(records.size_0, records.totalSize) - 1);
    $remove_4(records, rhqAdminRecord);
  }
  $sendSuccessResponseRecords(this, request, response, records);
}
;
function $copyValues_4(from){
  var ldapGroupRecords, ldapGroups, permissionRecords, permissions, resourceGroupRecords, resourceGroups, subjectRecords, subjects, to;
  to = new Role_0;
  $setId_1(to, getAttributeAsInt(from.jsObj, 'id').value_0);
  $setName_4(to, getAttribute(from.jsObj, 'name'));
  $setDescription_0(to, getAttribute(from.jsObj, 'description'));
  permissionRecords = convertToRecordArray(getAttributeAsJavaScriptObject(from.jsObj, 'permissions'));
  permissions = toPermissionSet(permissionRecords);
  to.permissions.clear_0();
  !!permissions && to.permissions.addAll(permissions);
  resourceGroupRecords = convertToRecordArray(getAttributeAsJavaScriptObject(from.jsObj, 'resourceGroups'));
  resourceGroups = $buildDataObjects((!INSTANCE_4 && (INSTANCE_4 = new ResourceGroupsDataSource_0) , INSTANCE_4), resourceGroupRecords);
  $setResourceGroups(to, resourceGroups);
  subjectRecords = convertToRecordArray(getAttributeAsJavaScriptObject(from.jsObj, 'subjects'));
  subjects = $buildDataObjects((!INSTANCE_1 && (INSTANCE_1 = new UsersDataSource_0) , INSTANCE_1), subjectRecords);
  $setSubjects(to, subjects);
  ldapGroupRecords = convertToRecordArray(getAttributeAsJavaScriptObject(from.jsObj, 'ldapGroups'));
  ldapGroups = $buildDataObjects(new RoleLdapGroupSelector$LdapGroupsDataSource_0, ldapGroupRecords);
  to.ldapGroups = ldapGroups;
  return to;
}

function $copyValues_5(sourceRole, cascade){
  var ldapGroupRecords, ldapGroups, permissionRecords, permissions, resourceGroupRecords, resourceGroups, subjectRecords, subjects, targetRecord;
  targetRecord = new ListGridRecord_0;
  $setAttribute_3(targetRecord, 'id', sourceRole.id);
  $setAttribute_13(targetRecord, 'name', sourceRole.name_0);
  $setAttribute_13(targetRecord, 'description', sourceRole.description);
  permissions = sourceRole.permissions;
  permissionRecords = toRecordArray(permissions);
  targetRecord.jsObj['permissions'] = convertToJavaScriptArray(permissionRecords);
  if (cascade) {
    resourceGroups = sourceRole.resourceGroups;
    resourceGroupRecords = $buildRecords((!INSTANCE_4 && (INSTANCE_4 = new ResourceGroupsDataSource_0) , INSTANCE_4), resourceGroups, false);
    targetRecord.jsObj['resourceGroups'] = convertToJavaScriptArray(resourceGroupRecords);
    subjects = sourceRole.subjects;
    subjectRecords = $buildRecords((!INSTANCE_1 && (INSTANCE_1 = new UsersDataSource_0) , INSTANCE_1), subjects, false);
    targetRecord.jsObj['subjects'] = convertToJavaScriptArray(subjectRecords);
    ldapGroups = (!sourceRole.ldapGroups && (sourceRole.ldapGroups = new HashSet_0) , sourceRole.ldapGroups);
    ldapGroupRecords = $buildRecords(new RoleLdapGroupSelector$LdapGroupsDataSource_0, ldapGroups, true);
    targetRecord.jsObj['ldapGroups'] = convertToJavaScriptArray(ldapGroupRecords);
  }
  return targetRecord;
}

function $executeFetch_3(this$static, request, response, criteria){
  $findRolesByCriteria(this$static.roleService, criteria, new RolesDataSource$1_0(this$static, request, response));
}

function $getFetchCriteria(request){
  var criteria, id, subjectId;
  criteria = new RoleCriteria_0;
  id = dynamicCast(getFilter($getCriteria(request), 'id', Ljava_lang_Integer_2_classLit), Q$Integer);
  criteria.filterId = id;
  subjectId = dynamicCast(getFilter($getCriteria(request), 'subjectId', Ljava_lang_Integer_2_classLit), Q$Integer);
  !!subjectId && (criteria.filterSubjectId = subjectId);
  criteria.fetchPermissions = true;
  if (id) {
    criteria.fetchSubjects = true;
    criteria.fetchResourceGroups = true;
    criteria.fetchLdapGroups = true;
  }
  return criteria;
}

function RolesDataSource_0(){
  var fields_0, idDataField, nameField, descriptionField, resourceGroupsField, permissionsField, subjectsField, ldapGroupsField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.roleService = dynamicCast(secure(getInstance_52(), -1), Q$RoleGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , idDataField = new DataSourceIntegerField_1('id', 'ID') , $setAttribute_8(idDataField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setAttribute_8(idDataField, 'canEdit', FALSE) , setCheck(fields_0.array, fields_0.size_0++, idDataField) , nameField = createTextField('name', 'Name', valueOf_44(3), valueOf_44(100), TRUE) , setCheck(fields_0.array, fields_0.size_0++, nameField) , descriptionField = createTextField('description', 'Description', null, valueOf_44(100), FALSE) , setCheck(fields_0.array, fields_0.size_0++, descriptionField) , resourceGroupsField = new DataSourceField_2('resourceGroups', ($clinit_FieldType() , ANY), 'Resource Groups') , setCheck(fields_0.array, fields_0.size_0++, resourceGroupsField) , permissionsField = new DataSourceField_2('permissions', ANY, 'Permissions') , setCheck(fields_0.array, fields_0.size_0++, permissionsField) , subjectsField = new DataSourceField_2('subjects', ANY, 'Subjects') , setCheck(fields_0.array, fields_0.size_0++, subjectsField) , ldapGroupsField = new DataSourceField_2('ldapGroups', ANY, 'LDAP Groups') , setCheck(fields_0.array, fields_0.size_0++, ldapGroupsField) , fields_0);
  $addFields(this, fields);
}

function toPermissionSet(permissionRecords){
  $clinit_RPCDataSource();
  var permission, permissionName, permissionRecord, permissionRecord$index, permissionRecord$max, permissions;
  permissions = new HashSet_0;
  $add_6(permissions, ($clinit_Permission() , VIEW_RESOURCE));
  for (permissionRecord$index = 0 , permissionRecord$max = permissionRecords.length; permissionRecord$index < permissionRecord$max; ++permissionRecord$index) {
    permissionRecord = permissionRecords[permissionRecord$index];
    permissionName = getAttribute(permissionRecord.jsObj, 'name');
    permission = dynamicCast(valueOf(($clinit_Permission$Map() , $MAP_49), permissionName), Q$Permission);
    $add_6(permissions, permission);
  }
  return permissions;
}

function toRecordArray(permissions){
  $clinit_RPCDataSource();
  var index, permission, permission$iterator, permissionRecord, permissionRecords;
  permissionRecords = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, permissions.size_1(), 0);
  index = 0;
  for (permission$iterator = permissions.iterator(); permission$iterator.hasNext();) {
    permission = dynamicCast(permission$iterator.next_0(), Q$Permission);
    permissionRecord = new ListGridRecord_0;
    $setAttribute_13(permissionRecord, 'name', permission.name_0);
    setCheck(permissionRecords, index++, permissionRecord);
  }
  return permissionRecords;
}

defineSeed(1707, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), RolesDataSource_0);
_.copyValues = function copyValues_9(from){
  return $copyValues_4(from);
}
;
_.copyValues_0 = function copyValues_10(sourceRole){
  return $copyValues_5(dynamicCast(sourceRole, Q$Role), true);
}
;
_.copyValues_1 = function copyValues_11(sourceRole, cascade){
  return $copyValues_5(dynamicCast(sourceRole, Q$Role), cascade);
}
;
_.executeAdd = function executeAdd_1(recordToAdd, request, response){
  var roleToAdd;
  roleToAdd = $copyValues_4(recordToAdd);
  $createRole(this.roleService, roleToAdd, new RolesDataSource$2_0(this, roleToAdd, request, response));
}
;
_.executeFetch = function executeFetch_3(request, response, criteria){
  $executeFetch_3(this, request, response, dynamicCast(criteria, Q$RoleCriteria));
}
;
_.executeRemove = function executeRemove_0(recordToRemove, request, response){
  var roleToRemove, rolename;
  roleToRemove = $copyValues_4(recordToRemove);
  rolename = roleToRemove.name_0;
  $removeRoles(this.roleService, initValues(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [roleToRemove.id]), new RolesDataSource$4_0(this, request, response, rolename, roleToRemove));
}
;
_.executeUpdate = function executeUpdate_1(recordToUpdate, oldRecord, request, response){
  var roleToUpdate, rolename;
  roleToUpdate = $copyValues_4(recordToUpdate);
  rolename = roleToUpdate.name_0;
  $updateRole(this.roleService, roleToUpdate, new RolesDataSource$3_0(this, request, response, rolename));
}
;
_.getFetchCriteria = function getFetchCriteria_3(request){
  return $getFetchCriteria(request);
}
;
var INSTANCE_2 = null;
function $onSuccess_46(this$static, result){
  $sendSuccessResponse_1(this$static.this$0, this$static.val$request, this$static.val$response, result);
}

function RolesDataSource$1_0(this$0, val$request, val$response){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(1708, 1, {}, RolesDataSource$1_0);
_.onFailure = function onFailure_48(caught){
  $sendFailureResponse(this.this$0, this.val$request, this.val$response, ($clinit_RPCDataSource() , 'Failed to fetch roles.'), caught);
}
;
_.onSuccess_0 = function onSuccess_48(result){
  $onSuccess_46(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onFailure_0(this$static, caught){
  var errorMessages;
  if (caught.getMessage() != null && caught.getMessage().indexOf('javax.persistence.EntityExistsException') != -1) {
    errorMessages = new HashMap_0;
    errorMessages.put('name', 'Failed to create role with existing name [' + ($clinit_RPCDataSource() , this$static.val$roleToAdd.name_0) + ']. Please use another name.');
    $sendValidationErrorResponse(this$static.this$0, this$static.val$request, this$static.val$response, errorMessages);
  }
   else {
    throw new RuntimeException_3(caught);
  }
}

function $onSuccess_47(this$static, addedRole){
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, addedRole, null);
}

function RolesDataSource$2_0(this$0, val$roleToAdd, val$request, val$response){
  this.this$0 = this$0;
  this.val$roleToAdd = val$roleToAdd;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(1709, 1, {}, RolesDataSource$2_0);
_.onFailure = function onFailure_49(caught){
  $onFailure_0(this, caught);
}
;
_.onSuccess_0 = function onSuccess_49(addedRole){
  $onSuccess_47(this, dynamicCast(addedRole, Q$Role));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$roleToAdd = null;
function $onSuccess_48(this$static, updatedRole){
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, updatedRole, null);
}

function RolesDataSource$3_0(this$0, val$request, val$response, val$rolename){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$rolename = val$rolename;
}

defineSeed(1710, 1, {}, RolesDataSource$3_0);
_.onFailure = function onFailure_50(caught){
  $sendFailureResponse(this.this$0, this.val$request, this.val$response, 'Failed to update role [' + ($clinit_RPCDataSource() , this.val$rolename) + '].', caught);
}
;
_.onSuccess_0 = function onSuccess_50(updatedRole){
  $onSuccess_48(this, dynamicCast(updatedRole, Q$Role));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$rolename = null;
function $onSuccess_49(this$static){
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, this$static.val$roleToRemove, new Message_0('Role [' + ($clinit_RPCDataSource() , this$static.val$rolename) + '] deleted.'));
}

function RolesDataSource$4_0(this$0, val$request, val$response, val$rolename, val$roleToRemove){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$rolename = val$rolename;
  this.val$roleToRemove = val$roleToRemove;
}

defineSeed(1711, 1, {}, RolesDataSource$4_0);
_.onFailure = function onFailure_51(caught){
  $sendFailureResponse(this.this$0, this.val$request, this.val$response, 'Failed to delete role [' + ($clinit_RPCDataSource() , this.val$rolename) + '].', caught);
}
;
_.onSuccess_0 = function onSuccess_51(result){
  $onSuccess_49(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$roleToRemove = null;
_.val$rolename = null;
function $clinit_RolesView(){
  $clinit_RolesView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_5 = new ViewName_2('Roles', ($clinit_Enhanced() , 'Roles'), ($clinit_IconEnum() , ROLES));
  ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_SECURITY_VIEW_ID + '/' + VIEW_ID_5;
}

function $updateSelectionStyle(this$static){
  var selectionStyle;
  this$static.hasManageSecurity || $deselectAllRecords(this$static.listGrid);
  selectionStyle = this$static.hasManageSecurity?($clinit_SelectionStyle() , MULTIPLE):($clinit_SelectionStyle() , NONE_4);
  $setAttribute_24(this$static.listGrid, 'selectionType', selectionStyle.value_0, true);
}

function RolesView_0(hasManageSecurity){
  $clinit_RolesView();
  var datasource;
  TableSection_0.call(this, null);
  datasource = ($clinit_RPCDataSource() , !INSTANCE_2 && (INSTANCE_2 = new RolesDataSource_0) , $clinit_RPCDataSource() , INSTANCE_2);
  this.dataSource_1 = datasource;
  this.escapeHtmlInDetailsLinkColumn = true;
  this.hasManageSecurity = hasManageSecurity;
}

defineSeed(1712, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), RolesView_0);
_.configureTable = function configureTable_3(){
  var fields, fields_0, nameField, descriptionField;
  $updateSelectionStyle(this);
  $addCellClickHandler(this.listGrid, new RolesView$1_0(this));
  fields = (fields_0 = new ArrayList_0 , nameField = new ListGridField_2('name', 150) , setCheck(fields_0.array, fields_0.size_0++, nameField) , descriptionField = new ListGridField_1('description') , $setCellFormatter_0(descriptionField, new EscapedHtmlCellFormatter_0) , setCheck(fields_0.array, fields_0.size_0++, descriptionField) , fields_0);
  $setListGridFields(this, false, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $addTableAction(this, ($clinit_Enhanced() , 'New'), null, null, new RolesView$2_0(this));
  $addTableAction(this, 'Delete', 'Are you sure you want to delete the # selected roles?', null, new RolesView$3_0(this));
  $configureTable(this);
}
;
_.getDetailsView_0 = function getDetailsView_2(roleId){
  return new RoleEditView_0(roleId.value_0);
}
;
_.getViewName = function getViewName(){
  return VIEW_ID_5;
}
;
_.isDetailsEnabled = function isDetailsEnabled_0(){
  return this.hasManageSecurity;
}
;
_.refresh_0 = function refresh_2(){
  $refresh(this, false);
  $updateSelectionStyle(this);
}
;
_.hasManageSecurity = false;
var VIEW_ID_5;
function RolesView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1713, 1, makeCastMap([Q$EventHandler, Q$CellClickHandler]), RolesView$1_0);
_.onCellClick = function onCellClick(event_0){
  $updateSelectionStyle(this.this$0);
}
;
_.this$0 = null;
function RolesView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1714, 1, {}, RolesView$2_0);
_.executeAction = function executeAction_7(selection, actionValue){
  $newDetails(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_4(selection){
  return this.this$0.hasManageSecurity;
}
;
_.this$0 = null;
function RolesView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1715, 1, {}, RolesView$3_0);
_.executeAction = function executeAction_8(selection, actionValue){
  $deleteSelectedRecords(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_5(selection){
  var count, record, record$index, record$max, roleId;
  if (!this.this$0.hasManageSecurity) {
    return false;
  }
  count = selection.length;
  if (count == 0) {
    return false;
  }
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    roleId = getAttributeAsInt(record.jsObj, 'id').value_0;
    $clinit_RPCDataSource();
    if (roleId == 1) {
      return false;
    }
  }
  return true;
}
;
_.this$0 = null;
function $clinit_ResourceTypeTreeView(){
  $clinit_ResourceTypeTreeView = nullMethod;
  $clinit_BaseWidget();
  VIEW_PATH = ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_CONFIGURATION_VIEW_ID + '/';
}

function $getGridCanvas(this$static){
  var layout, platformServices, platformServicesList, platforms, platformsList, sectionStack, servers, serversTreeGrid, titleBar;
  if (!this$static.gridCanvas) {
    layout = new EnhancedVLayout_0;
    titleBar = this$static.getTitleBar();
    $isCreated_1(titleBar)?undefined:(titleBar.config_0['extraSpace'] = 10 , undefined);
    $addMember(layout, titleBar);
    sectionStack = new SectionStack_0;
    $setAttribute_24(sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
    platformsList = new ResourceTypeTreeView$CustomResourceTypeListGrid_0(this$static);
    platforms = new SectionStackSection_1(($clinit_Enhanced() , 'Platforms'));
    $setExpanded(platforms, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $addItemJS(platforms, $getOrCreateJsObj_0(platformsList));
    platformServicesList = new ResourceTypeTreeView$CustomResourceTypeListGrid_0(this$static);
    platformServices = new SectionStackSection_1('Platform Services');
    $setExpanded(platformServices, TRUE);
    $addItemJS(platformServices, $getOrCreateJsObj_0(platformServicesList));
    serversTreeGrid = new ResourceTypeTreeView$CustomResourceTypeTreeGrid_0(this$static);
    servers = new SectionStackSection_1('Servers');
    $setExpanded(servers, TRUE);
    $addItemJS(servers, $getOrCreateJsObj_0(serversTreeGrid));
    $addSection(sectionStack, platforms);
    $addSection(sectionStack, platformServices);
    $addSection(sectionStack, servers);
    $addMember(layout, sectionStack);
    this$static.gridCanvas = layout;
    this$static.getNodeBuilderInstance(platformsList, platformServicesList, serversTreeGrid);
  }
  return this$static.gridCanvas;
}

function $prepareSubCanvas(this$static, parentCanvas, canvasToShow, showBackButton){
  var backButton, backLink;
  destroyMembers(parentCanvas);
  if (showBackButton) {
    backLink = $substring(this$static.getEditLink(null), 1);
    backButton = new BackButton_0(($clinit_Enhanced() , 'Back to List'), backLink);
    $addMember(parentCanvas, backButton);
  }
  $addMember(parentCanvas, canvasToShow);
  parentCanvas.markForRedraw_0();
}

function $switchToCanvas(parentCanvas, canvasToShow){
  destroyMembers(parentCanvas);
  $addMember(parentCanvas, canvasToShow);
  $markForRedraw(parentCanvas);
}

function ResourceTypeTreeView_0(){
  $clinit_ResourceTypeTreeView();
  EnhancedVLayout_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(1717, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]));
_.editTemplates = function editTemplates(type, event_0){
  return;
}
;
_.editTemplates_0 = function editTemplates_0(type, viewPath){
  return;
}
;
_.getEditColumnTitle = function getEditColumnTitle(){
  return $clinit_Enhanced() , 'Edit?';
}
;
_.getTypeMetadataTypes = function getTypeMetadataTypes(){
  return noneOf(Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit);
}
;
_.renderView = function renderView_4(viewPath){
  var $e0, resourceTypeId;
  if (viewPath.viewPath.size_0 <= viewPath.index_0) {
    $switchToCanvas(this, $getGridCanvas(this));
  }
   else {
    try {
      resourceTypeId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        $handleError_0(($clinit_CoreGUI() , 'Invalid URL. Bad resource type ID [' + ($clinit_Enhanced() , (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path) + ']'), null);
        return;
      }
       else 
        throw $e0;
    }
    $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(resourceTypeId), this.getTypeMetadataTypes(), new ResourceTypeTreeView$1_0(this, viewPath));
  }
}
;
_.gridCanvas = null;
var VIEW_PATH;
function $clinit_AlertDefinitionTemplateTypeView(){
  $clinit_AlertDefinitionTemplateTypeView = nullMethod;
  $clinit_ResourceTypeTreeView();
  VIEW_ID_6 = new ViewName_2('AlertDefTemplates', ($clinit_Enhanced() , 'Alert Definition Templates'), ($clinit_IconEnum() , ALERT_FLAG_BLUE));
}

function $getCanvas(this$static){
  var layout;
  if (!this$static.canvas_0) {
    layout = new EnhancedVLayout_0;
    $isCreated_1(layout)?$setProperty_3(layout, 'height', '100%'):(layout.config_0['height'] = '100%' , undefined);
    $isCreated_1(layout)?$setProperty_3(layout, 'width', '100%'):(layout.config_0['width'] = '100%' , undefined);
    $setMargin(layout, valueOf_44(5));
    this$static.canvas_0 = layout;
  }
  return this$static.canvas_0;
}

function $renderTemplateAlertView(this$static, defsHolderLayout, defsView, viewPath){
  var showBackButton;
  showBackButton = viewPath.viewPath.size_0 - viewPath.index_0 - 1 == 0;
  $prepareSubCanvas(this$static, defsHolderLayout, defsView, showBackButton);
  $run_1(new AlertDefinitionTemplateTypeView$2_0(this$static, defsView, viewPath, defsHolderLayout));
}

function AlertDefinitionTemplateTypeView_0(){
  $clinit_AlertDefinitionTemplateTypeView();
  ResourceTypeTreeView_0.call(this);
}

defineSeed(1716, 1717, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), AlertDefinitionTemplateTypeView_0);
_.editTemplates_0 = function editTemplates_1(type, viewPath){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new AlertDefinitionTemplateTypeView$1_0(this, type, viewPath)));
}
;
_.getAdditionalListGridFields = function getAdditionalListGridFields(isTreeGrid){
  var disabledTemplatesField, enabledTemplatesField, fields;
  fields = new ArrayList_1(2);
  enabledTemplatesField = isTreeGrid?new TreeGridField_1('enabledTemplates', ($clinit_Enhanced() , 'Enabled Templates')):new ListGridField_3('enabledTemplates', ($clinit_Enhanced() , 'Enabled Templates'));
  enabledTemplatesField.jsObj['width'] = '150';
  $setAttribute_13(enabledTemplatesField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_13(enabledTemplatesField, 'prompt', ($clinit_Enhanced() , 'Number of alert templates that are enabled on this resource type'));
  setCheck(fields.array, fields.size_0++, enabledTemplatesField);
  disabledTemplatesField = isTreeGrid?new TreeGridField_1('disabledTemplates', 'Disabled Templates'):new ListGridField_3('disabledTemplates', 'Disabled Templates');
  disabledTemplatesField.jsObj['width'] = '150';
  $setAttribute_13(disabledTemplatesField, 'align', CENTER_0.value_0);
  disabledTemplatesField.jsObj['prompt'] = 'Number of alert templates that are created but disabled on this resource type';
  setCheck(fields.array, fields.size_0++, disabledTemplatesField);
  return fields;
}
;
_.getEditLink = function getEditLink(typeId){
  if (null == typeId) {
    return '#Administration/Configuration/' + VIEW_ID_6.name_0;
  }
  return '#Administration/Configuration/' + VIEW_ID_6.name_0 + '/' + valueOf_44(__parseAndValidateInt(typeId)).value_0;
}
;
_.getNodeBuilderInstance = function getNodeBuilderInstance(platformsList, platformServicesList, serversTreeGrid){
  return new AlertDefinitionTemplateTypeView$NodeBuilder_0(platformsList, platformServicesList, serversTreeGrid);
}
;
_.getTitleBar = function getTitleBar(){
  return new TitleBar_1(($clinit_Enhanced() , 'Alert Definition Templates'), VIEW_ID_6.icon_0.icon24x24Path);
}
;
_.canvas_0 = null;
var VIEW_ID_6;
function AlertDefinitionTemplateTypeView$1_0(this$0, val$type, val$viewPath){
  this.this$0 = this$0;
  this.val$type = val$type;
  this.val$viewPath = val$viewPath;
}

defineSeed(1718, 1, {}, AlertDefinitionTemplateTypeView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_0(permissions){
  var alertCanvas, defsView;
  alertCanvas = $getCanvas(this.this$0);
  defsView = new TemplateAlertDefinitionsView_0(this.val$type, permissions);
  $renderTemplateAlertView(this.this$0, alertCanvas, defsView, this.val$viewPath);
}
;
_.this$0 = null;
_.val$type = null;
_.val$viewPath = null;
function $run_1(this$static){
  var elapsedMillis;
  if ($isInitialized(this$static.val$defsView)) {
    $renderView_0(this$static.val$defsView, $next_6(this$static.val$viewPath));
    $switchToCanvas(this$static.this$0, this$static.val$defsHolderLayout);
  }
   else {
    elapsedMillis = sub(fromDouble(currentTimeMillis0()), this$static.startTime);
    if (lt(elapsedMillis, P2710_longLit)) {
      $schedule(this$static, 100);
    }
     else {
      error_0('Initialization of ' + Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_TemplateAlertDefinitionsView_2_classLit.typeName + ' timed out.');
      $renderView_0(this$static.val$defsView, $next_6(this$static.val$viewPath));
      $switchToCanvas(this$static.this$0, this$static.val$defsHolderLayout);
    }
  }
}

function AlertDefinitionTemplateTypeView$2_0(this$0, val$defsView, val$viewPath, val$defsHolderLayout){
  $clinit_Timer();
  this.this$0 = this$0;
  this.val$defsView = val$defsView;
  this.val$viewPath = val$viewPath;
  this.val$defsHolderLayout = val$defsHolderLayout;
  this.startTime = fromDouble(currentTimeMillis0());
}

defineSeed(1719, 73, makeCastMap([Q$Timer]), AlertDefinitionTemplateTypeView$2_0);
_.run = function run_5(){
  $run_1(this);
}
;
_.this$0 = null;
_.val$defsHolderLayout = null;
_.val$defsView = null;
_.val$viewPath = null;
function $clinit_ResourceTypeTreeNodeBuilder(){
  $clinit_ResourceTypeTreeNodeBuilder = nullMethod;
  $clinit_CoreGUI();
}

function $isEmpty_1(set){
  return !set || set.isEmpty_0();
}

function ResourceTypeTreeNodeBuilder_0(platformsGrid, platformServicesGrid, serversGrid){
  var resourceTypeService;
  resourceTypeService = dynamicCast(secure((!instance_28 && (instance_28 = new ResourceTypeGWTService_Proxy_0) , instance_28), 30000), Q$ResourceTypeGWTServiceAsync);
  $getTemplateCountCompositeMap(resourceTypeService, new ResourceTypeTreeNodeBuilder$1_0(this, platformsGrid, platformServicesGrid, serversGrid));
}

defineSeed(1721, 1, {});
function AlertDefinitionTemplateTypeView$NodeBuilder_0(platformsList, platformServicesList, serversTreeGrid){
  $clinit_ResourceTypeTreeNodeBuilder();
  ResourceTypeTreeNodeBuilder_0.call(this, platformsList, platformServicesList, serversTreeGrid);
}

defineSeed(1720, 1721, {}, AlertDefinitionTemplateTypeView$NodeBuilder_0);
_.getGridRecordInstance = function getGridRecordInstance(composite){
  return new AlertDefinitionTemplateTypeView$NodeBuilder$GridRecord_0(composite);
}
;
_.getTreeNodeInstance = function getTreeNodeInstance(composite, plugin){
  return new AlertDefinitionTemplateTypeView$NodeBuilder$TreeNode_0(composite, plugin);
}
;
function ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord_0(composite){
  var resourceType;
  ListGridRecord_0.call(this);
  resourceType = composite.type_0;
  this.id = resourceType.id;
  $setAttribute_13(this, 'id', '' + this.id);
  $setAttribute_13(this, 'name', resourceType.name_0);
  $setAttribute_13(this, 'plugin', resourceType.plugin);
  $setAttribute_13(this, 'category', resourceType.category.name_0);
  this.jsObj['edit'] = '[SKIN]/actions/edit.png';
}

defineSeed(1723, 540, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord]));
_.equals$ = function equals_122(o){
  if (this === o) {
    return true;
  }
  if (!instanceOf(o, Q$ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord)) {
    return false;
  }
  return this.id == dynamicCast(o, Q$ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord).id;
}
;
_.hashCode$ = function hashCode_122(){
  return 31 * this.id;
}
;
_.id = 0;
function AlertDefinitionTemplateTypeView$NodeBuilder$GridRecord_0(composite){
  ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord_0.call(this, composite);
  $setAttribute_4(this, 'enabledTemplates', composite.enabledAlertCount);
  $setAttribute_4(this, 'disabledTemplates', composite.disabledAlertCount);
}

defineSeed(1722, 1723, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord]), AlertDefinitionTemplateTypeView$NodeBuilder$GridRecord_0);
function ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode_0(composite, parentId){
  var id, resourceType;
  TreeNode_0.call(this);
  resourceType = composite.type_0;
  id = '' + resourceType.id;
  this.jsObj['id'] = id;
  this.id = id;
  this.jsObj['parentId'] = parentId;
  this.parentId = parentId;
  this.jsObj['id'] = id;
  this.jsObj['parentId'] = parentId;
  $setAttribute_13(this, 'name', resourceType.name_0);
  $setAttribute_13(this, 'plugin', resourceType.plugin);
  $setAttribute_13(this, 'category', resourceType.category.name_0);
  this.jsObj['edit'] = '[SKIN]/actions/edit.png';
}

defineSeed(1725, 577, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode]));
_.equals$ = function equals_123(o){
  var that;
  if (this === o) {
    return true;
  }
  if (!instanceOf(o, Q$ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode)) {
    return false;
  }
  that = dynamicCast(o, Q$ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode);
  if (!$equals_6(this.id, that.id)) {
    return false;
  }
  if (this.parentId == null) {
    return that.parentId == null;
  }
  return $equals_6(this.parentId, that.parentId);
}
;
_.hashCode$ = function hashCode_123(){
  var result;
  result = 31 * getHashCode_0(this.id);
  result = result + (this.parentId != null?getHashCode_0(this.parentId):0);
  return result;
}
;
_.id = null;
_.parentId = null;
function AlertDefinitionTemplateTypeView$NodeBuilder$TreeNode_0(composite, plugin){
  ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode_0.call(this, composite, plugin);
  $setAttribute_4(this, 'enabledTemplates', composite.enabledAlertCount);
  $setAttribute_4(this, 'disabledTemplates', composite.disabledAlertCount);
}

defineSeed(1724, 1725, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode]), AlertDefinitionTemplateTypeView$NodeBuilder$TreeNode_0);
function $clinit_DriftDefinitionTemplateTypeView(){
  $clinit_DriftDefinitionTemplateTypeView = nullMethod;
  $clinit_ResourceTypeTreeView();
  VIEW_ID_7 = new ViewName_2('DriftDefTemplates', ($clinit_Enhanced() , 'Drift Definition Templates'), ($clinit_IconEnum() , DRIFT_COMPLIANCE));
}

function $getCanvas_0(this$static){
  var layout;
  if (!this$static.canvas_0) {
    layout = new EnhancedVLayout_0;
    $isCreated_1(layout)?$setProperty_3(layout, 'height', '100%'):(layout.config_0['height'] = '100%' , undefined);
    $isCreated_1(layout)?$setProperty_3(layout, 'width', '100%'):(layout.config_0['width'] = '100%' , undefined);
    $setMargin(layout, valueOf_44(5));
    this$static.canvas_0 = layout;
  }
  return this$static.canvas_0;
}

function $renderTemplateView(this$static, defsHolderLayout, defsView, viewPath){
  var showBackButton;
  showBackButton = viewPath.viewPath.size_0 - viewPath.index_0 - 1 == 0;
  $prepareSubCanvas(this$static, defsHolderLayout, defsView, showBackButton);
  $run_2(new DriftDefinitionTemplateTypeView$2_0(this$static, defsView, viewPath, defsHolderLayout));
}

function DriftDefinitionTemplateTypeView_0(){
  $clinit_DriftDefinitionTemplateTypeView();
  ResourceTypeTreeView_0.call(this);
}

defineSeed(1726, 1717, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), DriftDefinitionTemplateTypeView_0);
_.editTemplates_0 = function editTemplates_2(type, viewPath){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new DriftDefinitionTemplateTypeView$1_0(this, type, viewPath)));
}
;
_.getAdditionalListGridFields = function getAdditionalListGridFields_0(isTreeGrid){
  var fields, pluginTemplatesField, userTemplatesField;
  fields = new ArrayList_1(2);
  pluginTemplatesField = isTreeGrid?new TreeGridField_1('pluginTemplates', ($clinit_Enhanced() , 'Plugin Templates')):new ListGridField_3('pluginTemplates', ($clinit_Enhanced() , 'Plugin Templates'));
  pluginTemplatesField.jsObj['width'] = '150';
  $setAttribute_13(pluginTemplatesField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  setCheck(fields.array, fields.size_0++, pluginTemplatesField);
  userTemplatesField = isTreeGrid?new TreeGridField_1('userTemplates', ($clinit_Enhanced() , 'User Templates')):new ListGridField_3('userTemplates', ($clinit_Enhanced() , 'User Templates'));
  userTemplatesField.jsObj['width'] = '150';
  $setAttribute_13(userTemplatesField, 'align', CENTER_0.value_0);
  setCheck(fields.array, fields.size_0++, userTemplatesField);
  return fields;
}
;
_.getEditLink = function getEditLink_0(typeId){
  if (null == typeId) {
    return '#Administration/Configuration/' + VIEW_ID_7.name_0;
  }
  return '#Administration/Configuration/' + VIEW_ID_7.name_0 + '/' + valueOf_44(__parseAndValidateInt(typeId)).value_0;
}
;
_.getNodeBuilderInstance = function getNodeBuilderInstance_0(platformsList, platformServicesList, serversTreeGrid){
  return new DriftDefinitionTemplateTypeView$NodeBuilder_0(platformsList, platformServicesList, serversTreeGrid);
}
;
_.getTitleBar = function getTitleBar_0(){
  return new TitleBar_1(($clinit_Enhanced() , 'Drift Definition Templates'), 'subsystems/drift/Drift_16.png');
}
;
_.getTypeMetadataTypes = function getTypeMetadataTypes_0(){
  return of(($clinit_ResourceTypeRepository$MetadataType() , driftDefinitionTemplates_0));
}
;
_.canvas_0 = null;
var VIEW_ID_7;
function DriftDefinitionTemplateTypeView$1_0(this$0, val$type, val$viewPath){
  this.this$0 = this$0;
  this.val$type = val$type;
  this.val$viewPath = val$viewPath;
}

defineSeed(1727, 1, {}, DriftDefinitionTemplateTypeView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_1(permissions){
  var templatesCanvas, view;
  templatesCanvas = $getCanvas_0(this.this$0);
  view = new DriftDefinitionTemplatesView_1(this.val$type, permissions.contains_0(($clinit_Permission() , MANAGE_SETTINGS)));
  $renderTemplateView(this.this$0, templatesCanvas, view, this.val$viewPath);
}
;
_.this$0 = null;
_.val$type = null;
_.val$viewPath = null;
function $run_2(this$static){
  var elapsedMillis;
  if ($isInitialized(this$static.val$defsView)) {
    $renderView_7(this$static.val$defsView, $next_6(this$static.val$viewPath));
    $switchToCanvas(this$static.this$0, this$static.val$defsHolderLayout);
  }
   else {
    elapsedMillis = sub(fromDouble(currentTimeMillis0()), this$static.startTime);
    if (lt(elapsedMillis, P2710_longLit)) {
      $schedule(this$static, 100);
    }
     else {
      error_0('Initialization of ' + Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView_2_classLit.typeName + ' timed out.');
      $renderView_7(this$static.val$defsView, $next_6(this$static.val$viewPath));
      $switchToCanvas(this$static.this$0, this$static.val$defsHolderLayout);
    }
  }
}

function DriftDefinitionTemplateTypeView$2_0(this$0, val$defsView, val$viewPath, val$defsHolderLayout){
  $clinit_Timer();
  this.this$0 = this$0;
  this.val$defsView = val$defsView;
  this.val$viewPath = val$viewPath;
  this.val$defsHolderLayout = val$defsHolderLayout;
  this.startTime = fromDouble(currentTimeMillis0());
}

defineSeed(1728, 73, makeCastMap([Q$Timer]), DriftDefinitionTemplateTypeView$2_0);
_.run = function run_6(){
  $run_2(this);
}
;
_.this$0 = null;
_.val$defsHolderLayout = null;
_.val$defsView = null;
_.val$viewPath = null;
function DriftDefinitionTemplateTypeView$NodeBuilder_0(platformsList, platformServicesList, serversTreeGrid){
  $clinit_ResourceTypeTreeNodeBuilder();
  ResourceTypeTreeNodeBuilder_0.call(this, platformsList, platformServicesList, serversTreeGrid);
}

defineSeed(1729, 1721, {}, DriftDefinitionTemplateTypeView$NodeBuilder_0);
_.getGridRecordInstance = function getGridRecordInstance_0(composite){
  return new DriftDefinitionTemplateTypeView$NodeBuilder$GridRecord_0(composite);
}
;
_.getTreeNodeInstance = function getTreeNodeInstance_0(composite, plugin){
  return new DriftDefinitionTemplateTypeView$NodeBuilder$TreeNode_0(composite, plugin);
}
;
function DriftDefinitionTemplateTypeView$NodeBuilder$GridRecord_0(composite){
  ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord_0.call(this, composite);
  $setAttribute_4(this, 'pluginTemplates', composite.pluginDriftTemplates);
  $setAttribute_4(this, 'userTemplates', composite.userDriftTemplates);
  eq(P0_longLit, composite.pluginDriftTemplates) && (this.jsObj['edit'] = '[SKIN]/actions/edit_Disabled.png' , undefined);
}

defineSeed(1730, 1723, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord]), DriftDefinitionTemplateTypeView$NodeBuilder$GridRecord_0);
function DriftDefinitionTemplateTypeView$NodeBuilder$TreeNode_0(composite, plugin){
  ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode_0.call(this, composite, plugin);
  $setAttribute_4(this, 'pluginTemplates', composite.pluginDriftTemplates);
  $setAttribute_4(this, 'userTemplates', composite.userDriftTemplates);
  eq(P0_longLit, composite.pluginDriftTemplates) && (this.jsObj['edit'] = '[SKIN]/actions/edit_Disabled.png' , undefined);
}

defineSeed(1731, 1725, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode]), DriftDefinitionTemplateTypeView$NodeBuilder$TreeNode_0);
function $clinit_IgnoreResourceTypesView(){
  $clinit_IgnoreResourceTypesView = nullMethod;
  $clinit_ResourceTypeTreeView();
  VIEW_ID_8 = new ViewName_2('IgnoreResourceTypes', ($clinit_Enhanced() , 'Ignored Resource Types'), ($clinit_IconEnum() , SERVICES));
}

function IgnoreResourceTypesView_0(){
  $clinit_IgnoreResourceTypesView();
  ResourceTypeTreeView_0.call(this);
}

defineSeed(1732, 1717, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), IgnoreResourceTypesView_0);
_.editTemplates = function editTemplates_3(type, event_0){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new IgnoreResourceTypesView$1_0(type)));
}
;
_.getAdditionalListGridFields = function getAdditionalListGridFields_1(isTreeGrid){
  var enabledTemplatesField, fields;
  fields = new ArrayList_1(1);
  enabledTemplatesField = isTreeGrid?new TreeGridField_1('enabled', ($clinit_Enhanced() , 'Enabled?')):new ListGridField_3('enabled', ($clinit_Enhanced() , 'Enabled?'));
  enabledTemplatesField.jsObj['width'] = '150';
  $setAttribute_13(enabledTemplatesField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_13(enabledTemplatesField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  setCheck(fields.array, fields.size_0++, enabledTemplatesField);
  return fields;
}
;
_.getEditColumnTitle = function getEditColumnTitle_0(){
  return $clinit_Enhanced() , 'Change?';
}
;
_.getEditLink = function getEditLink_1(typeId){
  return null;
}
;
_.getNodeBuilderInstance = function getNodeBuilderInstance_1(platformsList, platformServicesList, serversTreeGrid){
  return new IgnoreResourceTypesView$NodeBuilder_0(platformsList, platformServicesList, serversTreeGrid);
}
;
_.getTitleBar = function getTitleBar_1(){
  return new TitleBar_1(($clinit_Enhanced() , 'Ignored Resource Types'), getResourceIcon_0(($clinit_ResourceCategory() , SERVICE), ($clinit_AvailabilityType() , UP), '16'));
}
;
var VIEW_ID_8;
function IgnoreResourceTypesView$1_0(val$type){
  this.val$type = val$type;
}

defineSeed(1733, 1, {}, IgnoreResourceTypesView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_2(permissions){
  var msg, newIgnoreFlag;
  if (!permissions.contains_0(($clinit_Permission() , MANAGE_INVENTORY))) {
    warn(($clinit_Enhanced() , 'You do not have permission to ignore or unignore resource types!'), null);
    return;
  }
  newIgnoreFlag = !this.val$type.ignored;
  msg = newIgnoreFlag?'Are you sure you want to ignore the resource type [' + ($clinit_Enhanced() , this.val$type.name_0) + ']? You will no longer be able to import resources of this type and any resources of this type that are already in inventory will be uninventoried and you can no longer manage them.':'Are you sure you want to unignore the resource type [' + ($clinit_Enhanced() , this.val$type.name_0) + ']? Any resources of this type that exist in your managed environment will be able to be discovered and inventoried.';
  ask_0(($clinit_Enhanced() , 'Are You Sure?'), msg, new IgnoreResourceTypesView$1$1_0(newIgnoreFlag, this.val$type));
}
;
_.val$type = null;
function IgnoreResourceTypesView$1$1_0(val$newIgnoreFlag, val$type){
  this.val$newIgnoreFlag = val$newIgnoreFlag;
  this.val$type = val$type;
}

defineSeed(1734, 1, {}, IgnoreResourceTypesView$1$1_0);
_.execute_3 = function execute_15(value){
  var service;
  if ($equals_2(($clinit_Boolean() , TRUE), value)) {
    if (this.val$newIgnoreFlag) {
      service = dynamicCast(secure((!instance_28 && (instance_28 = new ResourceTypeGWTService_Proxy_0) , instance_28), 300000), Q$ResourceTypeGWTServiceAsync);
      $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0(($clinit_Enhanced() , 'Request has been submitted. It might take a while to complete this request if you have a lot of resources in inventory of that resource type, so please be patient.')));
    }
     else {
      service = dynamicCast(secure((!instance_28 && (instance_28 = new ResourceTypeGWTService_Proxy_0) , instance_28), -1), Q$ResourceTypeGWTServiceAsync);
    }
    $setResourceTypeIgnoreFlag(service, this.val$type.id, this.val$newIgnoreFlag, new IgnoreResourceTypesView$1$1$1_0(this.val$type, this.val$newIgnoreFlag));
  }
}
;
_.val$newIgnoreFlag = false;
_.val$type = null;
function $onSuccess_50(this$static){
  var msg;
  $setIgnored(this$static.val$type, this$static.val$newIgnoreFlag);
  msg = this$static.val$newIgnoreFlag?'The resource type [' + ($clinit_Enhanced() , this$static.val$type.name_0) + '] is now being ignored.':'The resource type [' + ($clinit_Enhanced() , this$static.val$type.name_0) + '] is now unignored. Resources of this type can now be committed into inventory.';
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0(msg));
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function IgnoreResourceTypesView$1$1$1_0(val$type, val$newIgnoreFlag){
  this.val$type = val$type;
  this.val$newIgnoreFlag = val$newIgnoreFlag;
}

defineSeed(1735, 1, {}, IgnoreResourceTypesView$1$1$1_0);
_.onFailure = function onFailure_52(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to set the ignore flag on the selected resource type.'), caught);
}
;
_.onSuccess_0 = function onSuccess_52(result){
  $onSuccess_50(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$newIgnoreFlag = false;
_.val$type = null;
function IgnoreResourceTypesView$NodeBuilder_0(platformsList, platformServicesList, serversTreeGrid){
  $clinit_ResourceTypeTreeNodeBuilder();
  ResourceTypeTreeNodeBuilder_0.call(this, platformsList, platformServicesList, serversTreeGrid);
}

defineSeed(1736, 1721, {}, IgnoreResourceTypesView$NodeBuilder_0);
_.getGridRecordInstance = function getGridRecordInstance_1(composite){
  return new IgnoreResourceTypesView$NodeBuilder$GridRecord_0(composite);
}
;
_.getTreeNodeInstance = function getTreeNodeInstance_1(composite, plugin){
  return new IgnoreResourceTypesView$NodeBuilder$TreeNode_0(composite, plugin);
}
;
function IgnoreResourceTypesView$NodeBuilder$GridRecord_0(composite){
  ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord_0.call(this, composite);
  $setAttribute_13(this, 'enabled', getAvailabilityIcon(($clinit_Boolean() , composite.type_0.ignored?FALSE:TRUE)));
}

defineSeed(1737, 1723, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord]), IgnoreResourceTypesView$NodeBuilder$GridRecord_0);
function IgnoreResourceTypesView$NodeBuilder$TreeNode_0(composite, plugin){
  ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode_0.call(this, composite, plugin);
  $setAttribute_13(this, 'enabled', getAvailabilityIcon(($clinit_Boolean() , composite.type_0.ignored?FALSE:TRUE)));
}

defineSeed(1738, 1725, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode]), IgnoreResourceTypesView$NodeBuilder$TreeNode_0);
function $clinit_MetricTemplateTypeView(){
  $clinit_MetricTemplateTypeView = nullMethod;
  $clinit_ResourceTypeTreeView();
  VIEW_ID_9 = new ViewName_2('MetricTemplates', ($clinit_Enhanced() , 'Metric Collection Templates'), ($clinit_IconEnum() , METRIC));
}

function $getCanvas_1(this$static){
  var layout;
  if (!this$static.canvas_0) {
    layout = new EnhancedVLayout_0;
    $isCreated_1(layout)?$setProperty_3(layout, 'height', '100%'):(layout.config_0['height'] = '100%' , undefined);
    $isCreated_1(layout)?$setProperty_3(layout, 'width', '100%'):(layout.config_0['width'] = '100%' , undefined);
    $setMargin(layout, valueOf_44(5));
    this$static.canvas_0 = layout;
  }
  return this$static.canvas_0;
}

function MetricTemplateTypeView_0(){
  $clinit_MetricTemplateTypeView();
  ResourceTypeTreeView_0.call(this);
}

defineSeed(1739, 1717, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), MetricTemplateTypeView_0);
_.editTemplates_0 = function editTemplates_4(type, viewPath){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new MetricTemplateTypeView$1_0(this, type)));
}
;
_.getAdditionalListGridFields = function getAdditionalListGridFields_2(isTreeGrid){
  var disabledTemplatesField, enabledTemplatesField, fields;
  fields = new ArrayList_1(2);
  enabledTemplatesField = isTreeGrid?new TreeGridField_1('enabledTemplates', ($clinit_Enhanced() , 'Enabled Templates')):new ListGridField_3('enabledTemplates', ($clinit_Enhanced() , 'Enabled Templates'));
  enabledTemplatesField.jsObj['width'] = '150';
  $setAttribute_13(enabledTemplatesField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_13(enabledTemplatesField, 'prompt', ($clinit_Enhanced() , 'Number bf metric schedules that are enabled by default on this resource type'));
  setCheck(fields.array, fields.size_0++, enabledTemplatesField);
  disabledTemplatesField = isTreeGrid?new TreeGridField_1('disabledTemplates', 'Disabled Templates'):new ListGridField_3('disabledTemplates', 'Disabled Templates');
  disabledTemplatesField.jsObj['width'] = '150';
  $setAttribute_13(disabledTemplatesField, 'align', CENTER_0.value_0);
  disabledTemplatesField.jsObj['prompt'] = 'Number of metric schedules that are disabled by default on this resource type';
  setCheck(fields.array, fields.size_0++, disabledTemplatesField);
  return fields;
}
;
_.getEditLink = function getEditLink_2(typeId){
  if (null == typeId) {
    return '#Administration/Configuration/' + VIEW_ID_9.name_0;
  }
  return '#Administration/Configuration/' + VIEW_ID_9.name_0 + '/' + valueOf_44(__parseAndValidateInt(typeId)).value_0;
}
;
_.getNodeBuilderInstance = function getNodeBuilderInstance_2(platformsList, platformServicesList, serversTreeGrid){
  return new MetricTemplateTypeView$NodeBuilder_0(platformsList, platformServicesList, serversTreeGrid);
}
;
_.getTitleBar = function getTitleBar_2(){
  return new TitleBar_1(($clinit_Enhanced() , 'Metric Collection Templates'), 'subsystems/monitor/Edit_Metric.png');
}
;
_.canvas_0 = null;
var VIEW_ID_9;
function MetricTemplateTypeView$1_0(this$0, val$type){
  this.this$0 = this$0;
  this.val$type = val$type;
}

defineSeed(1740, 1, {}, MetricTemplateTypeView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_3(permissions){
  var metricCanvas, templateSchedulesView;
  metricCanvas = $getCanvas_1(this.this$0);
  templateSchedulesView = new TemplateSchedulesView_0(this.val$type, permissions);
  $prepareSubCanvas(this.this$0, metricCanvas, templateSchedulesView, true);
  $switchToCanvas(this.this$0, metricCanvas);
}
;
_.this$0 = null;
_.val$type = null;
function MetricTemplateTypeView$NodeBuilder_0(platformsList, platformServicesList, serversTreeGrid){
  $clinit_ResourceTypeTreeNodeBuilder();
  ResourceTypeTreeNodeBuilder_0.call(this, platformsList, platformServicesList, serversTreeGrid);
}

defineSeed(1741, 1721, {}, MetricTemplateTypeView$NodeBuilder_0);
_.getGridRecordInstance = function getGridRecordInstance_2(composite){
  return new MetricTemplateTypeView$NodeBuilder$GridRecord_0(composite);
}
;
_.getTreeNodeInstance = function getTreeNodeInstance_2(composite, plugin){
  return new MetricTemplateTypeView$NodeBuilder$TreeNode_0(composite, plugin);
}
;
function MetricTemplateTypeView$NodeBuilder$GridRecord_0(composite){
  ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord_0.call(this, composite);
  $setAttribute_4(this, 'enabledTemplates', composite.enabledMetricCount);
  $setAttribute_4(this, 'disabledTemplates', composite.disabledMetricCount);
  eq(P0_longLit, add(composite.enabledMetricCount, composite.disabledMetricCount)) && (this.jsObj['edit'] = '[SKIN]/actions/edit_Disabled.png' , undefined);
}

defineSeed(1742, 1723, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord]), MetricTemplateTypeView$NodeBuilder$GridRecord_0);
function MetricTemplateTypeView$NodeBuilder$TreeNode_0(composite, plugin){
  ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode_0.call(this, composite, plugin);
  $setAttribute_4(this, 'enabledTemplates', composite.enabledMetricCount);
  $setAttribute_4(this, 'disabledTemplates', composite.disabledMetricCount);
  eq(P0_longLit, add(composite.enabledMetricCount, composite.disabledMetricCount)) && (this.jsObj['edit'] = '[SKIN]/actions/edit_Disabled.png' , undefined);
}

defineSeed(1743, 1725, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode]), MetricTemplateTypeView$NodeBuilder$TreeNode_0);
function $onSuccess_51(this$static, result){
  var composite, composite$iterator, gotPlatform, isPlatform, isPlatformService, parentType, parentType$iterator, parentTypes, platformServicesRecords, platformsRecords, tree, treeNodeArray, treeNodes, type;
  platformsRecords = new HashSet_0;
  platformServicesRecords = new HashSet_0;
  treeNodes = new HashSet_0;
  for (composite$iterator = result.values_0().iterator(); composite$iterator.hasNext();) {
    composite = dynamicCast(composite$iterator.next_0(), Q$ResourceTypeTemplateCountComposite);
    type = composite.type_0;
    parentTypes = type.parentResourceTypes;
    if (!parentTypes || parentTypes.isEmpty_0()) {
      type.category == ($clinit_ResourceCategory() , PLATFORM)?$add_6(platformsRecords, this$static.this$0.getGridRecordInstance(composite)):$add_6(treeNodes, this$static.this$0.getTreeNodeInstance(composite, type.plugin));
    }
     else {
      isPlatformService = true;
      if (type.category == ($clinit_ResourceCategory() , SERVICE)) {
        for (parentType$iterator = parentTypes.iterator(); parentType$iterator.hasNext();) {
          parentType = dynamicCast(parentType$iterator.next_0(), Q$ResourceType);
          if (parentType.category != PLATFORM || !$isEmpty_1(parentType.parentResourceTypes)) {
            isPlatformService = false;
            break;
          }
        }
      }
       else {
        isPlatformService = false;
      }
      if (isPlatformService) {
        $add_6(platformServicesRecords, this$static.this$0.getGridRecordInstance(composite));
      }
       else {
        gotPlatform = false;
        for (parentType$iterator = type.parentResourceTypes.iterator(); parentType$iterator.hasNext();) {
          parentType = dynamicCast(parentType$iterator.next_0(), Q$ResourceType);
          isPlatform = parentType.category == PLATFORM && $isEmpty_1(parentType.parentResourceTypes);
          (!isPlatform || !gotPlatform) && $add_6(treeNodes, this$static.this$0.getTreeNodeInstance(composite, '' + parentType.id));
          isPlatform && (gotPlatform = true);
        }
      }
    }
  }
  $setData(this$static.val$platformsGrid, dynamicCast($toArray(platformsRecords, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, platformsRecords.map.size_1(), 0)), Q$ListGridRecord_$1));
  $setData(this$static.val$platformServicesGrid, dynamicCast($toArray(platformServicesRecords, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, platformServicesRecords.map.size_1(), 0)), Q$ListGridRecord_$1));
  tree = getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.val$serversGrid, 'data'));
  if (tree) {
    treeNodeArray = dynamicCast($toArray(treeNodes, initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, treeNodes.map.size_1(), 0)), Q$TreeNode_$1);
    $linkNodes(tree, treeNodeArray);
  }
}

function ResourceTypeTreeNodeBuilder$1_0(this$0, val$platformsGrid, val$platformServicesGrid, val$serversGrid){
  this.this$0 = this$0;
  this.val$platformsGrid = val$platformsGrid;
  this.val$platformServicesGrid = val$platformServicesGrid;
  this.val$serversGrid = val$serversGrid;
}

defineSeed(1744, 1, {}, ResourceTypeTreeNodeBuilder$1_0);
_.onFailure = function onFailure_53(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_ResourceTypeTreeNodeBuilder() , 'Failed to load resource types'), caught);
}
;
_.onSuccess_0 = function onSuccess_53(result){
  $onSuccess_51(this, dynamicCast(result, Q$Map));
}
;
_.this$0 = null;
_.val$platformServicesGrid = null;
_.val$platformsGrid = null;
_.val$serversGrid = null;
function ResourceTypeTreeView$1_0(this$0, val$viewPath){
  this.this$0 = this$0;
  this.val$viewPath = val$viewPath;
}

defineSeed(1745, 1, {}, ResourceTypeTreeView$1_0);
_.onTypesLoaded = function onTypesLoaded(type){
  this.this$0.editTemplates_0(type, this.val$viewPath);
}
;
_.this$0 = null;
_.val$viewPath = null;
function ResourceTypeTreeView$CustomResourceTypeListGrid_0(this$0){
  $clinit_BaseWidget();
  var editField, fields, nameField, pluginField;
  this.this$0 = this$0;
  ListGrid_0.call(this);
  $setWrapCells(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setFixedRecordHeights(this, FALSE);
  $setEmptyMessage(this, ($clinit_Enhanced() , 'Loading...'));
  $setAttribute_24(this, 'selectionType', ($clinit_SelectionStyle() , NONE_4).value_0, true);
  fields = new ArrayList_1(7);
  nameField = new ListGridField_3('name', 'Name');
  $setAttribute_8(nameField, 'showValueIconOnly', FALSE);
  setCheck(fields.array, fields.size_0++, nameField);
  pluginField = new ListGridField_3('plugin', 'Plugin');
  setCheck(fields.array, fields.size_0++, pluginField);
  pluginField.jsObj['showIf'] = 'false';
  $addAll_0(fields, this$0.getAdditionalListGridFields(false));
  editField = new ListGridField_3('edit', this$0.getEditColumnTitle());
  $setAttribute_13(editField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(editField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_8(editField, 'canGroupBy', FALSE);
  $addRecordClickHandler_0(editField, new ResourceTypeTreeView$CustomResourceTypeListGrid$1_0(this));
  setCheck(fields.array, fields.size_0++, editField);
  nameField.jsObj['width'] = '*';
  pluginField.jsObj['width'] = '20%';
  editField.jsObj['width'] = '70';
  $setFields_1(this, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
}

defineSeed(1746, 538, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers]), ResourceTypeTreeView$CustomResourceTypeListGrid_0);
_.getValueIcon_0 = function getValueIcon_0(field, value, record){
  var categoryName;
  if ($equals_6(getAttribute(field.jsObj, 'name'), 'name')) {
    categoryName = getAttribute(record.jsObj, 'category');
    return getResourceIcon_0(($clinit_ResourceCategory() , dynamicCast(valueOf(($clinit_ResourceCategory$Map() , $MAP_104), categoryName), Q$ResourceCategory)), ($clinit_AvailabilityType() , UP), '16');
  }
   else {
    return $getValueIcon(this, field, value, record);
  }
}
;
_.this$0 = null;
function ResourceTypeTreeView$CustomResourceTypeListGrid$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1747, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), ResourceTypeTreeView$CustomResourceTypeListGrid$1_0);
_.onRecordClick = function onRecordClick_0(event_0){
  var editAttr, editLink, record, type;
  record = $getRecord_0(event_0);
  editAttr = getAttribute(record.jsObj, 'edit');
  if ($equals_6('[SKIN]/actions/edit.png', editAttr)) {
    type = getAttribute(record.jsObj, 'id');
    editLink = this.this$1.this$0.getEditLink(type);
    editLink != null?($clinit_CoreGUI() , goToView(editLink, null, false)):$getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(__parseAndValidateInt(type)), this.this$1.this$0.getTypeMetadataTypes(), new ResourceTypeTreeView$CustomResourceTypeListGrid$1$1_0(this, event_0));
  }
}
;
_.this$1 = null;
function ResourceTypeTreeView$CustomResourceTypeListGrid$1$1_0(this$2, val$event){
  this.this$2 = this$2;
  this.val$event = val$event;
}

defineSeed(1748, 1, {}, ResourceTypeTreeView$CustomResourceTypeListGrid$1$1_0);
_.onTypesLoaded = function onTypesLoaded_0(type){
  this.this$2.this$1.this$0.editTemplates(type, this.val$event);
}
;
_.this$2 = null;
_.val$event = null;
function ResourceTypeTreeView$CustomResourceTypeTreeGrid_0(this$0){
  $clinit_BaseWidget();
  var editField, fields, nameField, pluginField;
  this.this$0 = this$0;
  TreeGrid_0.call(this);
  $setWrapCells(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setFixedRecordHeights(this, FALSE);
  $setEmptyMessage(this, ($clinit_Enhanced() , 'Loading...'));
  $setAttribute_24(this, 'selectionType', ($clinit_SelectionStyle() , NONE_4).value_0, true);
  $setAnimateFolders(this, FALSE);
  fields = new ArrayList_1(7);
  nameField = new TreeGridField_1('name', 'Name');
  setCheck(fields.array, fields.size_0++, nameField);
  pluginField = new TreeGridField_1('plugin', 'Plugin');
  setCheck(fields.array, fields.size_0++, pluginField);
  $addAll_0(fields, this$0.getAdditionalListGridFields(true));
  editField = new TreeGridField_1('edit', this$0.getEditColumnTitle());
  $setAttribute_13(editField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(editField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $addRecordClickHandler_0(editField, new ResourceTypeTreeView$CustomResourceTypeTreeGrid$1_0(this));
  setCheck(fields.array, fields.size_0++, editField);
  nameField.jsObj['width'] = '*';
  pluginField.jsObj['width'] = '20%';
  editField.jsObj['width'] = '70';
  $setFields_1(this, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
}

defineSeed(1749, 575, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$TreeGrid]), ResourceTypeTreeView$CustomResourceTypeTreeGrid_0);
_.getIcon_0 = function getIcon_0(record, defaultState){
  var categoryName;
  if (instanceOf(record, Q$TreeNode)) {
    if (instanceOf(record, Q$ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode)) {
      categoryName = getAttribute(record.jsObj, 'category');
      return getResourceIcon_0(($clinit_ResourceCategory() , dynamicCast(valueOf(($clinit_ResourceCategory$Map() , $MAP_104), categoryName), Q$ResourceCategory)), ($clinit_AvailabilityType() , UP), '16');
    }
  }
  return null;
}
;
_.this$0 = null;
function ResourceTypeTreeView$CustomResourceTypeTreeGrid$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1750, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), ResourceTypeTreeView$CustomResourceTypeTreeGrid$1_0);
_.onRecordClick = function onRecordClick_1(event_0){
  var editAttr, editLink, record, type;
  record = $getRecord_0(event_0);
  editAttr = getAttribute(record.jsObj, 'edit');
  if ($equals_6('[SKIN]/actions/edit.png', editAttr)) {
    type = getAttribute(record.jsObj, 'id');
    editLink = this.this$1.this$0.getEditLink(type);
    editLink != null?($clinit_CoreGUI() , goToView(editLink, null, false)):$getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(__parseAndValidateInt(type)), this.this$1.this$0.getTypeMetadataTypes(), new ResourceTypeTreeView$CustomResourceTypeTreeGrid$1$1_0(this, event_0));
  }
}
;
_.this$1 = null;
function ResourceTypeTreeView$CustomResourceTypeTreeGrid$1$1_0(this$2, val$event){
  this.this$2 = this$2;
  this.val$event = val$event;
}

defineSeed(1751, 1, {}, ResourceTypeTreeView$CustomResourceTypeTreeGrid$1$1_0);
_.onTypesLoaded = function onTypesLoaded_1(type){
  this.this$2.this$1.this$0.editTemplates(type, this.val$event);
}
;
_.this$2 = null;
_.val$event = null;
function $clinit_AbstractSchedulesView(){
  $clinit_AbstractSchedulesView = nullMethod;
  $clinit_BaseWidget();
  SORT_SPECIFIERS = initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [new SortSpecifier_0('displayName', ($clinit_SortDirection() , ASCENDING))]);
}

function $configureTable_0(this$static){
  var listGridFields;
  listGridFields = $getListGridFields_15(!this$static.dataSource && (this$static.dataSource = new SchedulesDataSource_0(this$static.entityContext)));
  $setFields_1(this$static.listGrid, dynamicCast($toArray_1(listGridFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, listGridFields.size_0, 0)), Q$ListGridField_$1));
  $setupTableInteractions(this$static, this$static.hasWriteAccess);
}

function $disableSchedules(this$static){
  var displayNames, ids;
  ids = $getMeasurementDefinitionIds(this$static);
  displayNames = $getMeasurementDefinitionDisplayNames(this$static);
  this$static.disableSchedules(ids, displayNames);
}

function $enableSchedules(this$static){
  var displayNames, ids;
  ids = $getMeasurementDefinitionIds(this$static);
  displayNames = $getMeasurementDefinitionDisplayNames(this$static);
  this$static.enableSchedules(ids, displayNames);
}

function $getMeasurementDefinitionDisplayNames(this$static){
  var displayName, displayNames, record, record$index, record$max, records;
  records = $getSelectedRecords(this$static.listGrid);
  displayNames = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    displayName = getAttribute(record.jsObj, 'displayName');
    setCheck(displayNames.array, displayNames.size_0++, displayName);
  }
  return displayNames;
}

function $getMeasurementDefinitionIds(this$static){
  var i, measurementDefinitionId, measurementDefinitionIds, record, records, selectionLength;
  records = $getSelectedRecords(this$static.listGrid);
  measurementDefinitionIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, records.length, 1);
  for (i = 0 , selectionLength = records.length; i < selectionLength; ++i) {
    record = records[i];
    measurementDefinitionId = getAttributeAsInt(record.jsObj, 'definitionId');
    measurementDefinitionIds[i] = measurementDefinitionId.value_0;
  }
  return measurementDefinitionIds;
}

function $setupTableInteractions(this$static, hasWriteAccess){
  $addTableAction(this$static, ($clinit_Enhanced() , 'Enable'), null, null, new AbstractSchedulesView$1_0(this$static, hasWriteAccess));
  $addTableAction(this$static, 'Disable', null, null, new AbstractSchedulesView$2_0(this$static, hasWriteAccess));
  $addExtraWidget(this$static, new UpdateCollectionIntervalWidget_0(this$static), true);
}

function $updateSchedules(this$static, interval){
  var displayNames, ids;
  ids = $getMeasurementDefinitionIds(this$static);
  displayNames = $getMeasurementDefinitionDisplayNames(this$static);
  this$static.updateSchedules(ids, displayNames, interval);
}

function AbstractSchedulesView_0(tableTitle, entityContext, hasWriteAccess){
  $clinit_AbstractSchedulesView();
  Table_8.call(this, tableTitle, SORT_SPECIFIERS);
  this.measurementService = dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync);
  this.entityContext = entityContext;
  this.hasWriteAccess = hasWriteAccess;
  $setDataSource(this, (!this.dataSource && (this.dataSource = new SchedulesDataSource_0(this.entityContext)) , this.dataSource));
}

defineSeed(1753, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_4(){
  $configureTable_0(this);
}
;
_.getDataSource_0 = function getDataSource_3(){
  return !this.dataSource && (this.dataSource = new SchedulesDataSource_0(this.entityContext)) , this.dataSource;
}
;
_.dataSource = null;
_.entityContext = null;
_.hasWriteAccess = false;
var SORT_SPECIFIERS;
function $setUpdateExistingSchedules(this$static, updateExistingSchedules){
  this$static.updateExistingSchedules = updateExistingSchedules;
}

function TemplateSchedulesView_0(type, globalPermissions){
  $clinit_AbstractSchedulesView();
  AbstractSchedulesView_0.call(this, ($clinit_Enhanced() , 'Metric Collection Templates') + ' [' + type.name_0 + ']', new EntityContext_0(null, null, valueOf_44(type.id)), globalPermissions.contains_0(($clinit_Permission() , MANAGE_INVENTORY)));
  this.typeId = '' + type.id;
}

defineSeed(1752, 1753, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), TemplateSchedulesView_0);
_.configureTable = function configureTable_5(){
  $configureTable_0(this);
  $addExtraWidget(this, new UpdateExistingSchedulesWidget_0(this), true);
}
;
_.disableSchedules = function disableSchedules(measurementDefinitionIds, measurementDefinitionDisplayNames){
  var s, updateExistingSchedules;
  updateExistingSchedules = this.updateExistingSchedules;
  s = measurementDefinitionIds.length > 1?'s':'';
  $disableSchedulesForResourceType(this.measurementService, measurementDefinitionIds, updateExistingSchedules, new TemplateSchedulesView$2_0(this, s, measurementDefinitionDisplayNames));
}
;
_.enableSchedules = function enableSchedules(measurementDefinitionIds, measurementDefinitionDisplayNames){
  var s, updateExistingSchedules;
  updateExistingSchedules = this.updateExistingSchedules;
  s = measurementDefinitionIds.length > 1?'s':'';
  $enableSchedulesForResourceType(this.measurementService, measurementDefinitionIds, updateExistingSchedules, new TemplateSchedulesView$1_0(this, s, measurementDefinitionDisplayNames));
}
;
_.updateSchedules = function updateSchedules(measurementDefinitionIds, measurementDefinitionDisplayNames, collectionInterval){
  var s, updateExistingSchedules;
  updateExistingSchedules = this.updateExistingSchedules;
  s = measurementDefinitionIds.length > 1?'s':'';
  $updateSchedulesForResourceType(this.measurementService, measurementDefinitionIds, collectionInterval, updateExistingSchedules, new TemplateSchedulesView$3_0(this, collectionInterval, s, measurementDefinitionDisplayNames));
}
;
_.typeId = null;
_.updateExistingSchedules = true;
function $onSuccess_52(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('Enabled collection of selected metric [' + ($clinit_Enhanced() , this$static.val$s) + '].', 'Enabled collection of metric [' + this$static.val$s + '] [' + this$static.val$measurementDefinitionDisplayNames.toString$() + '] by default for ResourceType with id [' + this$static.this$0.typeId + '].', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function TemplateSchedulesView$1_0(this$0, val$s, val$measurementDefinitionDisplayNames){
  this.this$0 = this$0;
  this.val$s = val$s;
  this.val$measurementDefinitionDisplayNames = val$measurementDefinitionDisplayNames;
}

defineSeed(1754, 1, {}, TemplateSchedulesView$1_0);
_.onFailure = function onFailure_54(throwable){
  $handleError_0(($clinit_CoreGUI() , 'Failed to enable collection of metric [' + ($clinit_Enhanced() , this.val$s) + '] [' + this.val$measurementDefinitionDisplayNames.toString$() + '] by default for ResourceType with id [' + this.this$0.typeId + '].'), throwable);
}
;
_.onSuccess_0 = function onSuccess_54(aVoid){
  $onSuccess_52(this, throwClassCastExceptionUnlessNull(aVoid));
}
;
_.this$0 = null;
_.val$measurementDefinitionDisplayNames = null;
_.val$s = null;
function $onSuccess_53(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('Disabled collection of selected metric [' + ($clinit_Enhanced() , this$static.val$s) + '].', 'Disabled collection of metric [' + this$static.val$s + '] [' + this$static.val$measurementDefinitionDisplayNames.toString$() + '] by default for ResourceType with id [' + this$static.this$0.typeId + '].', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function TemplateSchedulesView$2_0(this$0, val$s, val$measurementDefinitionDisplayNames){
  this.this$0 = this$0;
  this.val$s = val$s;
  this.val$measurementDefinitionDisplayNames = val$measurementDefinitionDisplayNames;
}

defineSeed(1755, 1, {}, TemplateSchedulesView$2_0);
_.onFailure = function onFailure_55(throwable){
  $handleError_0(($clinit_CoreGUI() , 'Failed to disable collection of metric [' + ($clinit_Enhanced() , this.val$s) + '] [' + this.val$measurementDefinitionDisplayNames.toString$() + '] by default for ResourceType with id [' + this.this$0.typeId + '].'), throwable);
}
;
_.onSuccess_0 = function onSuccess_55(aVoid){
  $onSuccess_53(this, throwClassCastExceptionUnlessNull(aVoid));
}
;
_.this$0 = null;
_.val$measurementDefinitionDisplayNames = null;
_.val$s = null;
function $onSuccess_54(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('Updated collection intervals of selected metric [' + ($clinit_Enhanced() , this$static.val$s) + '].', 'Collection interval for metric [' + this$static.val$s + '] [' + this$static.val$measurementDefinitionDisplayNames.toString$() + '] by default for ResourceType with id [' + this$static.this$0.typeId + '] set to [' + toString_8(div(this$static.val$collectionInterval, P3e8_longLit)) + '] seconds.', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function TemplateSchedulesView$3_0(this$0, val$collectionInterval, val$s, val$measurementDefinitionDisplayNames){
  this.this$0 = this$0;
  this.val$collectionInterval = val$collectionInterval;
  this.val$s = val$s;
  this.val$measurementDefinitionDisplayNames = val$measurementDefinitionDisplayNames;
}

defineSeed(1756, 1, {}, TemplateSchedulesView$3_0);
_.onFailure = function onFailure_56(throwable){
  $handleError_0(($clinit_CoreGUI() , 'Failed to set collection interval to [' + ($clinit_Enhanced() , '' + toString_8(div(this.val$collectionInterval, P3e8_longLit))) + '] seconds for metric [' + this.val$s + '] [' + this.val$measurementDefinitionDisplayNames.toString$() + '] by default for ResourceType with id [' + this.this$0.typeId + '].'), throwable);
}
;
_.onSuccess_0 = function onSuccess_56(aVoid){
  $onSuccess_54(this, throwClassCastExceptionUnlessNull(aVoid));
}
;
_.this$0 = null;
_.val$collectionInterval = P0_longLit;
_.val$measurementDefinitionDisplayNames = null;
_.val$s = null;
function UpdateExistingSchedulesWidget_0(schedulesView){
  $clinit_BaseWidget();
  EnhancedHLayout_0.call(this);
  this.schedulesView = schedulesView;
}

defineSeed(1757, 1539, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$TableWidget, Q$Enhanced, Q$EnhancedHLayout]), UpdateExistingSchedulesWidget_0);
_.onDraw_0 = function onDraw_8(){
  var checkboxItem, form, spacer;
  spacer = new VLayout_0;
  $isCreated_1(spacer)?$setProperty_0(spacer, 'width', 20):(spacer.config_0['width'] = 20 , undefined);
  $addMember(this, spacer);
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 3):(form.config_0['numCols'] = 3 , undefined);
  checkboxItem = new CheckboxItem_2('updateExistingSchedules', ($clinit_Enhanced() , 'Update Existing Schedules'));
  $setDefaultValue(checkboxItem, ($clinit_Boolean() , this.schedulesView.updateExistingSchedules?TRUE:FALSE));
  $setPrompt_1(checkboxItem, 'Check this box to update the collection schedules for the selected metrics on all existing resources of this type. If this is not checked, the template schedules will only be applied to new resources of this type that are added to inventory in the future.');
  $setHoverWidth_0(checkboxItem, valueOf_44(200));
  $addChangedHandler(checkboxItem, new UpdateExistingSchedulesWidget$1_0(this));
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [checkboxItem]));
  $addMember(this, form);
}
;
_.refresh_1 = function refresh_3(listGrid){
}
;
_.schedulesView = null;
function UpdateExistingSchedulesWidget$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1758, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), UpdateExistingSchedulesWidget$1_0);
_.onChanged = function onChanged_1(changedEvent){
  var newValue;
  newValue = dynamicCast($getValue_2(changedEvent), Q$Boolean).value_0;
  $setUpdateExistingSchedules(this.this$0.schedulesView, newValue);
}
;
_.this$0 = null;
function AbstractServerNodeDatasource_0(){
  $clinit_RPCDataSource();
  RPCDataSource_0.call(this);
}

defineSeed(1759, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractServerNodeDatasource]));
function AffinityGroupAgentsSelector_0(affinityGroupId){
  var criteria;
  AbstractSelector_1.call(this, false);
  this.affinityGroupId = affinityGroupId;
  criteria = new AgentCriteria_0;
  $addFilterAffinityGroupId(criteria, this.affinityGroupId);
  $findAgentsByCriteria(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), criteria, new AffinityGroupAgentsSelector$1_0(this, this));
}

function closeAndRefresh(parrent, fullRefresh){
  $clinit_BaseWidget();
  !!modalWindow_0 && $destroy(modalWindow_0);
  fullRefresh?$refresh(parrent, false):$refreshTableInfo(parrent);
}

function getIdList(records){
  $clinit_BaseWidget();
  var ids, record, record$index, record$max;
  if (records == null) {
    return null;
  }
  ids = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_3(ids, $getAttributeAsInt(record, ($clinit_AgentDatasourceField() , FIELD_ID_0).propertyName));
  }
  return ids;
}

function show_0(affinityGroupId, parrent){
  $clinit_BaseWidget();
  var buttonBar, cancel, save, selector;
  modalWindow_0 = new Window_1;
  $addCloseClickHandler(modalWindow_0, new AffinityGroupAgentsSelector$3_0(parrent));
  $setTitle(modalWindow_0, ($clinit_Enhanced() , 'Agents') + ': Create New');
  $setAttribute_24(modalWindow_0, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $setWidth(modalWindow_0, 800);
  $setHeight(modalWindow_0, 400);
  $setAutoCenter(modalWindow_0, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setCanDragResize_0(modalWindow_0, TRUE);
  $setCanDragReposition(modalWindow_0, TRUE);
  layout_0 = new VLayout_0;
  $setAttribute_24(layout_0, 'width', '100%', true);
  $setAttribute_24(layout_0, 'height', '100%', true);
  selector = new AffinityGroupAgentsSelector_0(affinityGroupId);
  $setMargin(selector, valueOf_44(10));
  layout_0.addMember_0(selector);
  cancel = new EnhancedIButton_1('Cancel');
  $addClickHandler(cancel, new AffinityGroupAgentsSelector$4_0(parrent));
  save = new EnhancedIButton_1('Save');
  $addClickHandler(save, new AffinityGroupAgentsSelector$5_0(selector, parrent, affinityGroupId));
  buttonBar = new ToolStrip_0;
  $setPadding(buttonBar, valueOf_44(5));
  $isCreated_1(buttonBar)?$setProperty_3(buttonBar, 'width', '100%'):(buttonBar.config_0['width'] = '100%' , undefined);
  $isCreated_1(buttonBar)?$setProperty_0(buttonBar, 'membersMargin', 15):(buttonBar.config_0['membersMargin'] = 15 , undefined);
  $addMember(buttonBar, save);
  $addMember(buttonBar, cancel);
  layout_0.addMember_0(buttonBar);
}

defineSeed(1760, 1699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), AffinityGroupAgentsSelector_0);
_.getAvailableFilterForm = function getAvailableFilterForm_2(){
  var search;
  if (!this.availableFilterForm) {
    this.availableFilterForm = new DynamicForm_0;
    $setWidth_0(this.availableFilterForm, '75%');
    search = new TextItem_3(($clinit_AgentDatasourceField() , FIELD_NAME_0).propertyName, ($clinit_Enhanced() , 'Search'));
    this.availableFilterForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [search]));
  }
  return this.availableFilterForm;
}
;
_.getDataSource_0 = function getDataSource_4(){
  return !datasource_0 && (datasource_0 = new AffinityGroupAgentsSelector$2_0) , datasource_0;
}
;
_.getItemIcon = function getItemIcon_1(){
  return ($clinit_IconEnum() , AGENT_0).icon16x16Path;
}
;
_.getItemTitle = function getItemTitle_2(){
  return $clinit_Enhanced() , 'Agents';
}
;
_.getLatestCriteria = function getLatestCriteria_2(availableFilterForm){
  return $getValuesAsCriteria(availableFilterForm);
}
;
_.getMaxAvailableRecords = function getMaxAvailableRecords_1(){
  return 3000;
}
;
_.affinityGroupId = null;
_.originallyAssignedIds = null;
var datasource_0 = null, layout_0 = null, modalWindow_0 = null, shouldBeClosed = false;
function $onSuccess_55(this$static, result){
  var records;
  records = $buildRecords((!($clinit_BaseWidget() , datasource_0) && (datasource_0 = new AffinityGroupAgentsSelector$2_0) , $clinit_BaseWidget() , datasource_0), result, true);
  this$static.this$0.originallyAssignedIds = getIdList(records);
  $setAssigned(this$static.this$0, records);
  $addItem(modalWindow_0, layout_0);
  modalWindow_0.show_0();
  $reset_1(this$static.val$selector);
}

function AffinityGroupAgentsSelector$1_0(this$0, val$selector){
  this.this$0 = this$0;
  this.val$selector = val$selector;
}

defineSeed(1761, 1, {}, AffinityGroupAgentsSelector$1_0);
_.onFailure = function onFailure_57(t){
  $handleError_0(($clinit_CoreGUI() , 'Unable to fetch agent(s) for affinity group with id ' + ($clinit_Enhanced() , '' + this.this$0.affinityGroupId) + '.'), t);
}
;
_.onSuccess_0 = function onSuccess_57(result){
  $onSuccess_55(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$selector = null;
function $clinit_AgentDatasource(){
  $clinit_AgentDatasource = nullMethod;
  $clinit_RPCDataSource();
  FILTER_ADDRESS = ($clinit_AgentDatasourceField() , FIELD_ADDRESS).propertyName;
  FILTER_PORT = FIELD_PORT.propertyName;
  FILTER_AGENTTOKEN = FIELD_AGENTTOKEN.propertyName;
}

function $copyValues_6(){
  throw new UnsupportedOperationException_1('AgentNodeDatasource.copyValues(Record from)');
}

function $copyValues_7(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, ($clinit_AgentDatasourceField() , FIELD_ID_0).propertyName, from.id);
  $setAttribute_13(record, FIELD_NAME_0.propertyName, from.name_0);
  $setAttribute_13(record, FIELD_ADDRESS.propertyName, from.address);
  $setAttribute_13(record, FIELD_REMOTE_ENDPOINT.propertyName, from.remoteEndpoint);
  $setAttribute_3(record, FIELD_PORT.propertyName, from.port);
  $setAttribute_13(record, FIELD_SERVER.propertyName, !from.server?'':from.server.name_0);
  $setAttribute_12(record, FIELD_SERVER_ID.propertyName, !from.server?'':valueOf_44(from.server.id));
  $setAttribute_12(record, FIELD_LAST_AVAILABILITY_REPORT.propertyName, from.lastAvailabilityReport);
  $setAttribute_12(record, FIELD_LAST_AVAILABILITY_PING.propertyName, from.lastAvailabilityPing);
  $setAttribute_13(record, FIELD_AFFINITY_GROUP.propertyName, !from.affinityGroup?'':from.affinityGroup.name_0);
  $setAttribute_12(record, FIELD_AFFINITY_GROUP_ID.propertyName, !from.affinityGroup?'':valueOf_44(from.affinityGroup.id));
  return record;
}

function $getListGridFields_1(this$static){
  var affinityGroupIdField, fields, idField, lastAvailabilityPingField, lastAvailabilityReportField, serverIdField;
  fields = new ArrayList_0;
  idField = $getListGridField_1(($clinit_AgentDatasourceField() , FIELD_ID_0));
  idField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, idField);
  $add_3(fields, $getListGridField_2(FIELD_NAME_0, '*'));
  $add_3(fields, $getListGridField_2(FIELD_SERVER, '120'));
  $add_3(fields, $getListGridField_2(FIELD_ADDRESS, '110'));
  serverIdField = $getListGridField_1(FIELD_SERVER_ID);
  serverIdField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, serverIdField);
  $add_3(fields, $getListGridField_2(FIELD_PORT, '90'));
  lastAvailabilityReportField = $getListGridField_2(FIELD_LAST_AVAILABILITY_REPORT, '125');
  $clinit_TimestampCellFormatter();
  prepareDateField(lastAvailabilityReportField, getAttribute(lastAvailabilityReportField.jsObj, 'name'));
  setCheck(fields.array, fields.size_0++, lastAvailabilityReportField);
  lastAvailabilityPingField = $getListGridField_2(FIELD_LAST_AVAILABILITY_PING, '125');
  prepareDateField(lastAvailabilityPingField, getAttribute(lastAvailabilityPingField.jsObj, 'name'));
  setCheck(fields.array, fields.size_0++, lastAvailabilityPingField);
  if (!this$static.isAffinityGroupId) {
    $add_3(fields, $getListGridField_2(FIELD_AFFINITY_GROUP, '100'));
    affinityGroupIdField = $getListGridField_1(FIELD_AFFINITY_GROUP_ID);
    affinityGroupIdField.jsObj['showIf'] = 'false';
    setCheck(fields.array, fields.size_0++, affinityGroupIdField);
  }
  return fields;
}

function AgentDatasource_0(id, isAffinityGroupId){
  var fields_0, idField;
  $clinit_AgentDatasource();
  var fields;
  RPCDataSource_0.call(this);
  this.id = id;
  this.isAffinityGroupId = isAffinityGroupId;
  fields = (fields_0 = new ArrayList_0 , idField = new DataSourceIntegerField_2(($clinit_AgentDatasourceField() , FIELD_ID_0).propertyName, FIELD_ID_0.title_0, 50) , $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setAttribute_8(idField, 'hidden', TRUE) , setCheck(fields_0.array, fields_0.size_0++, idField) , fields_0);
  $addFields(this, fields);
}

defineSeed(1763, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AgentDatasource]), AgentDatasource_0);
_.copyValues = function copyValues_12(from){
  return $copyValues_6();
}
;
_.copyValues_0 = function copyValues_13(from){
  return $copyValues_7(dynamicCast(from, Q$Agent));
}
;
_.executeFetch_0 = function executeFetch_4(request, response, criteria){
  this.isAffinityGroupId?$addFilterAffinityGroupId(criteria, this.id):$addFilterServerId(criteria, this.id);
  $findAgentsByCriteria(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), criteria, new AgentDatasource$1_0(this, response, request));
}
;
_.executeFetch = function executeFetch_5(request, response, criteria){
  this.executeFetch_0(request, response, dynamicCast(criteria, Q$AgentCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_4(request){
  var criteria;
  return criteria = new AgentCriteria_0 , $addFilterId(criteria, dynamicCast(getFilter_0(request, ($clinit_AgentDatasourceField() , FIELD_ID_0).propertyName, Ljava_lang_Integer_2_classLit), Q$Integer)) , $addFilterName(criteria, dynamicCast(getFilter_0(request, FIELD_NAME_0.propertyName, Ljava_lang_String_2_classLit), Q$String)) , $addFilterAddress(criteria, dynamicCast(getFilter_0(request, FILTER_ADDRESS, Ljava_lang_String_2_classLit), Q$String)) , $addFilterPort(criteria, dynamicCast(getFilter_0(request, FILTER_PORT, Ljava_lang_Integer_2_classLit), Q$Integer)) , $addFilterAgenttoken(criteria, dynamicCast(getFilter_0(request, FILTER_AGENTTOKEN, Ljava_lang_String_2_classLit), Q$String)) , $addFilterServerId(criteria, dynamicCast(($clinit_RPCDataSource() , getFilter($getCriteria(request), 'serverId', Ljava_lang_Integer_2_classLit)), Q$Integer)) , $addFilterAffinityGroupId(criteria, dynamicCast(getFilter($getCriteria(request), 'affinityGroupId', Ljava_lang_Integer_2_classLit), Q$Integer)) , debug(' *** AgentCriteria Search String: ' + dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String)) , $setSearchExpression(criteria, dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String)) , criteria;
}
;
_.id = null;
_.isAffinityGroupId = false;
var FILTER_ADDRESS, FILTER_AGENTTOKEN, FILTER_PORT;
function AffinityGroupAgentsSelector$2_0(){
  $clinit_AgentDatasource();
  AgentDatasource_0.call(this, null, false);
}

defineSeed(1762, 1763, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AgentDatasource]), AffinityGroupAgentsSelector$2_0);
_.executeFetch_0 = function executeFetch_6(request, response, criteria){
  criteria.fetchAffinityGroup = true;
  $findAgentsByCriteria(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), criteria, new AffinityGroupAgentsSelector$2$1_0(this, response, request));
}
;
function $onSuccess_56(this$static, result){
  var agent, it;
  it = new AbstractList$IteratorImpl_0(result);
  while (it.i < it.this$0_0.size_1()) {
    agent = dynamicCast($next_0(it), Q$Agent);
    !!agent.affinityGroup && $remove_7(it);
  }
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$1, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function AffinityGroupAgentsSelector$2$1_0(this$1, val$response, val$request){
  this.this$1 = this$1;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1764, 1, {}, AffinityGroupAgentsSelector$2$1_0);
_.onFailure = function onFailure_58(t){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Unable to fetch agents.'), t);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$1, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_58(result){
  $onSuccess_56(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function AffinityGroupAgentsSelector$3_0(val$parrent){
  this.val$parrent = val$parrent;
}

defineSeed(1765, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), AffinityGroupAgentsSelector$3_0);
_.onCloseClick_0 = function onCloseClick_1(event_0){
  closeAndRefresh(this.val$parrent, false);
}
;
_.val$parrent = null;
function AffinityGroupAgentsSelector$4_0(val$parrent){
  this.val$parrent = val$parrent;
}

defineSeed(1766, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AffinityGroupAgentsSelector$4_0);
_.onClick = function onClick_20(clickEvent){
  closeAndRefresh(this.val$parrent, false);
}
;
_.val$parrent = null;
function AffinityGroupAgentsSelector$5_0(val$selector, val$parrent, val$affinityGroupId){
  this.val$selector = val$selector;
  this.val$parrent = val$parrent;
  this.val$affinityGroupId = val$affinityGroupId;
}

defineSeed(1767, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AffinityGroupAgentsSelector$5_0);
_.onClick = function onClick_21(clickEvent){
  var actuallySelected, originallySelected;
  actuallySelected = getIdList(this.val$selector.assignedGrid.getRecords());
  originallySelected = new ArrayList_2(this.val$selector.originallyAssignedIds);
  $removeAll(originallySelected, actuallySelected);
  $removeAll(actuallySelected, new ArrayList_2(this.val$selector.originallyAssignedIds));
  $clinit_BaseWidget();
  shouldBeClosed = true;
  if (originallySelected.size_0 != 0) {
    shouldBeClosed = false;
    $removeAgentsFromGroup(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), dynamicCast($toArray_1(originallySelected, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, originallySelected.size_0, 0)), Q$Integer_$1), new AffinityGroupAgentsSelector$5$1_0(this.val$parrent, this.val$affinityGroupId));
  }
  if (actuallySelected.size_0 != 0) {
    shouldBeClosed = false;
    $addAgentsToGroup(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), this.val$selector.affinityGroupId.value_0, dynamicCast($toArray_1(actuallySelected, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, actuallySelected.size_0, 0)), Q$Integer_$1), new AffinityGroupAgentsSelector$5$2_0(this.val$parrent, this.val$affinityGroupId));
  }
  shouldBeClosed && closeAndRefresh(this.val$parrent, false);
}
;
_.val$affinityGroupId = null;
_.val$parrent = null;
_.val$selector = null;
function $onSuccess_57(this$static){
  closeAndRefresh(this$static.val$parrent, true);
}

function AffinityGroupAgentsSelector$5$1_0(val$parrent, val$affinityGroupId){
  this.val$parrent = val$parrent;
  this.val$affinityGroupId = val$affinityGroupId;
}

defineSeed(1768, 1, {}, AffinityGroupAgentsSelector$5$1_0);
_.onFailure = function onFailure_59(t){
  $handleError_0(($clinit_CoreGUI() , 'Unable to assign agents to the affinity group with id ' + ($clinit_Enhanced() , '' + this.val$affinityGroupId) + '.'), t);
}
;
_.onSuccess_0 = function onSuccess_59(result){
  $onSuccess_57(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$affinityGroupId = null;
_.val$parrent = null;
function $onSuccess_58(this$static){
  closeAndRefresh(this$static.val$parrent, true);
}

function AffinityGroupAgentsSelector$5$2_0(val$parrent, val$affinityGroupId){
  this.val$parrent = val$parrent;
  this.val$affinityGroupId = val$affinityGroupId;
}

defineSeed(1769, 1, {}, AffinityGroupAgentsSelector$5$2_0);
_.onFailure = function onFailure_60(t){
  $handleError_0(($clinit_CoreGUI() , 'Unable to remove agents from the affinity group with id ' + ($clinit_Enhanced() , '' + this.val$affinityGroupId) + '.'), t);
}
;
_.onSuccess_0 = function onSuccess_60(result){
  $onSuccess_58(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$affinityGroupId = null;
_.val$parrent = null;
function $prepareDetailsSection_1(this$static, affinityGroup){
  var footer, form, nameItem, saveButton, section;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 2):(form.config_0['numCols'] = 2 , undefined);
  nameItem = new TextItem_3(($clinit_AffinityGroupWithCountsDatasource$Fields() , FIELD_NAME).propertyName, FIELD_NAME.title_0);
  $setValue_7(nameItem, affinityGroup.name_0);
  footer = new EnhancedToolStrip_0;
  $setPadding(footer, valueOf_44(5));
  $isCreated_1(footer)?$setProperty_3(footer, 'width', '100%'):(footer.config_0['width'] = '100%' , undefined);
  $isCreated_1(footer)?$setProperty_0(footer, 'membersMargin', 15):(footer.config_0['membersMargin'] = 15 , undefined);
  saveButton = new IButton_0;
  $setAttribute_24(saveButton, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, true);
  $setTitle_0(saveButton, ($clinit_Enhanced() , 'Save'));
  $addClickHandler(saveButton, new AffinityGroupDetailView$3_0(this$static, affinityGroup, nameItem));
  $addMember(footer, saveButton);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [nameItem]));
  section = new SectionStackSection_1('Details');
  $setExpanded(section, FALSE);
  $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form, footer]));
  this$static.detailsSection = section;
  ++this$static.initSectionCount;
}

function AffinityGroupDetailView_0(affinityGroupId){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.affinityGroupId = affinityGroupId;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  this.sectionStack = new SectionStack_0;
  $setAttribute_24(this.sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
  $setAttribute_24(this.sectionStack, 'width', '100%', true);
  $setAttribute_24(this.sectionStack, 'height', '100%', true);
  $setMargin(this.sectionStack, valueOf_44(5));
  $setAttribute_24(this.sectionStack, 'overflow', VISIBLE.value_0, false);
}

defineSeed(1770, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), AffinityGroupDetailView_0);
_.onDraw_0 = function onDraw_9(){
  $run_3(new AffinityGroupDetailView$2_0(this));
}
;
_.onInit = function onInit_13(){
  var section, agentsTable, section_0, serverTable;
  $onInit(this);
  $onInit_Layout(this);
  $getAffinityGroupById(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), this.affinityGroupId, new AffinityGroupDetailView$1_0(this));
  section = new SectionStackSection_1(($clinit_Enhanced() , 'Agent Members'));
  $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  agentsTable = new AgentTableView_0(valueOf_44(this.affinityGroupId), true);
  $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [agentsTable]));
  this.agentSection = section;
  ++this.initSectionCount;
  section_0 = new SectionStackSection_1('Server Members');
  $setExpanded(section_0, TRUE);
  serverTable = new ServerTableView_0(valueOf_44(this.affinityGroupId), true);
  $setItems(section_0, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [serverTable]));
  this.serverSection = section_0;
  ++this.initSectionCount;
}
;
_.renderView = function renderView_5(viewPath){
  $clinit_Log();
  $fine_0(logger_0, 'AffinityGroupDetailView: ' + viewPath);
}
;
_.affinityGroupId = 0;
_.agentSection = null;
_.detailsSection = null;
_.initSectionCount = 0;
_.sectionStack = null;
_.serverSection = null;
function $onSuccess_59(this$static, affinityGroup){
  $prepareDetailsSection_1(this$static.this$0, affinityGroup);
}

function AffinityGroupDetailView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1771, 1, {}, AffinityGroupDetailView$1_0);
_.onFailure = function onFailure_61(caught){
  $handleError_0(($clinit_CoreGUI() , 'Unable to fetch affinity group details for group with id ' + ($clinit_Enhanced() , '' + this.this$0.affinityGroupId) + '.'), caught);
  this.this$0.initSectionCount = 3;
}
;
_.onSuccess_0 = function onSuccess_61(affinityGroup){
  $onSuccess_59(this, dynamicCast(affinityGroup, Q$AffinityGroup));
}
;
_.this$0 = null;
function $run_3(this$static){
  var elapsedMillis;
  if (this$static.this$0.initSectionCount >= 3) {
    !!this$static.this$0.detailsSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.detailsSection);
    !!this$static.this$0.agentSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.agentSection);
    !!this$static.this$0.serverSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.serverSection);
    $addMember(this$static.this$0, this$static.this$0.sectionStack);
    $markForRedraw(this$static.this$0);
  }
   else {
    elapsedMillis = sub(fromDouble(currentTimeMillis0()), this$static.startTime);
    gt(elapsedMillis, P4e20_longLit) && (this$static.this$0.initSectionCount = 3);
    $schedule(this$static, 100);
  }
}

function AffinityGroupDetailView$2_0(this$0){
  $clinit_Timer();
  this.this$0 = this$0;
  this.startTime = fromDouble(currentTimeMillis0());
}

defineSeed(1772, 73, makeCastMap([Q$Timer]), AffinityGroupDetailView$2_0);
_.run = function run_7(){
  $run_3(this);
}
;
_.this$0 = null;
function AffinityGroupDetailView$3_0(this$0, val$affinityGroup, val$nameItem){
  this.this$0 = this$0;
  this.val$affinityGroup = val$affinityGroup;
  this.val$nameItem = val$nameItem;
}

defineSeed(1773, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AffinityGroupDetailView$3_0);
_.onClick = function onClick_22(event_0){
  $setName_6(this.val$affinityGroup, this.val$nameItem.getValueAsString());
  $updateAffinityGroup(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), this.val$affinityGroup, new AffinityGroupDetailView$3$1_0(this, this.val$affinityGroup, this.val$nameItem));
}
;
_.this$0 = null;
_.val$affinityGroup = null;
_.val$nameItem = null;
function $onSuccess_60(this$static){
  var msg;
  msg = new Message_7('Affinity group with id ' + ($clinit_Enhanced() , '' + this$static.this$1.this$0.affinityGroupId) + ' and name ' + this$static.val$affinityGroup.name_0 + ' was renamed to ' + this$static.val$nameItem.getValueAsString() + '.', ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
}

function AffinityGroupDetailView$3$1_0(this$1, val$affinityGroup, val$nameItem){
  this.this$1 = this$1;
  this.val$affinityGroup = val$affinityGroup;
  this.val$nameItem = val$nameItem;
}

defineSeed(1774, 1, {}, AffinityGroupDetailView$3$1_0);
_.onFailure = function onFailure_62(caught){
  $handleError_0(($clinit_CoreGUI() , 'Unable to rename affinity group with id ' + ($clinit_Enhanced() , '' + this.this$1.this$0.affinityGroupId) + ' and name ' + this.val$affinityGroup.name_0 + '. ' + caught.getMessage()), caught);
}
;
_.onSuccess_0 = function onSuccess_62(result){
  $onSuccess_60(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$affinityGroup = null;
_.val$nameItem = null;
function AffinityGroupServersSelector_0(affinityGroupId){
  var criteria;
  AbstractSelector_1.call(this, false);
  this.affinityGroupId = affinityGroupId;
  criteria = new ServerCriteria_0;
  $addFilterAffinityGroupId_0(criteria, this.affinityGroupId);
  $findServersByCriteria(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), criteria, new AffinityGroupServersSelector$1_0(this, this));
}

function closeAndRefresh_0(parrent, fullRefresh){
  $clinit_BaseWidget();
  !!modalWindow_1 && $destroy(modalWindow_1);
  fullRefresh?$refresh(parrent, false):$refreshTableInfo(parrent);
}

function getIdList_0(records){
  $clinit_BaseWidget();
  var ids, record, record$index, record$max;
  if (records == null) {
    return null;
  }
  ids = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_3(ids, $getAttributeAsInt(record, ($clinit_ServerDatasourceField() , FIELD_ID_2).propertyName));
  }
  return ids;
}

function show_1(affinityGroupId, parrent){
  $clinit_BaseWidget();
  var buttonBar, cancel, save, selector;
  modalWindow_1 = new Window_1;
  $addCloseClickHandler(modalWindow_1, new AffinityGroupServersSelector$3_0(parrent));
  $setTitle(modalWindow_1, ($clinit_Enhanced() , 'Servers') + ': Create New');
  $setAttribute_24(modalWindow_1, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $setWidth(modalWindow_1, 800);
  $setHeight(modalWindow_1, 400);
  $setAutoCenter(modalWindow_1, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setCanDragResize_0(modalWindow_1, TRUE);
  $setCanDragReposition(modalWindow_1, TRUE);
  layout_1 = new VLayout_0;
  $setAttribute_24(layout_1, 'width', '100%', true);
  $setAttribute_24(layout_1, 'height', '100%', true);
  selector = new AffinityGroupServersSelector_0(affinityGroupId);
  $setMargin(selector, valueOf_44(10));
  layout_1.addMember_0(selector);
  cancel = new EnhancedIButton_1('Cancel');
  $addClickHandler(cancel, new AffinityGroupServersSelector$4_0(parrent));
  save = new EnhancedIButton_1('Save');
  $addClickHandler(save, new AffinityGroupServersSelector$5_0(selector, parrent, affinityGroupId));
  buttonBar = new ToolStrip_0;
  $setPadding(buttonBar, valueOf_44(5));
  $isCreated_1(buttonBar)?$setProperty_3(buttonBar, 'width', '100%'):(buttonBar.config_0['width'] = '100%' , undefined);
  $isCreated_1(buttonBar)?$setProperty_0(buttonBar, 'membersMargin', 15):(buttonBar.config_0['membersMargin'] = 15 , undefined);
  $addMember(buttonBar, save);
  $addMember(buttonBar, cancel);
  layout_1.addMember_0(buttonBar);
}

defineSeed(1775, 1699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), AffinityGroupServersSelector_0);
_.getAvailableFilterForm = function getAvailableFilterForm_3(){
  var operationModeSelect, search;
  if (!this.availableFilterForm) {
    this.availableFilterForm = new DynamicForm_0;
    $setNumCols(this.availableFilterForm, 4);
    $setWidth_0(this.availableFilterForm, '75%');
    search = new TextItem_3(($clinit_ServerDatasourceField() , FIELD_NAME_1).propertyName, ($clinit_Enhanced() , 'Search'));
    operationModeSelect = new EnumSelectItem_0(($clinit_ServerDatasource() , FILTER_OPERATION_MODE), 'Operation Mode', Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit, null, null);
    this.availableFilterForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [search, operationModeSelect]));
  }
  return this.availableFilterForm;
}
;
_.getDataSource_0 = function getDataSource_5(){
  return !datasource_1 && (datasource_1 = new AffinityGroupServersSelector$2_0) , datasource_1;
}
;
_.getItemIcon = function getItemIcon_2(){
  return ($clinit_IconEnum() , SERVERS).icon16x16Path;
}
;
_.getItemTitle = function getItemTitle_3(){
  return $clinit_Enhanced() , 'Servers';
}
;
_.getLatestCriteria = function getLatestCriteria_3(availableFilterForm){
  return $getValuesAsCriteria(availableFilterForm);
}
;
_.getMaxAvailableRecords = function getMaxAvailableRecords_2(){
  return 500;
}
;
_.affinityGroupId = null;
_.originallyAssignedIds = null;
var datasource_1 = null, layout_1 = null, modalWindow_1 = null, shouldBeClosed_0 = false;
function $onSuccess_61(this$static, result){
  var records;
  records = $buildRecords((!($clinit_BaseWidget() , datasource_1) && (datasource_1 = new AffinityGroupServersSelector$2_0) , $clinit_BaseWidget() , datasource_1), result, true);
  this$static.this$0.originallyAssignedIds = getIdList_0(records);
  $setAssigned(this$static.this$0, records);
  $addItem(modalWindow_1, layout_1);
  modalWindow_1.show_0();
  $reset_1(this$static.val$selector);
}

function AffinityGroupServersSelector$1_0(this$0, val$selector){
  this.this$0 = this$0;
  this.val$selector = val$selector;
}

defineSeed(1776, 1, {}, AffinityGroupServersSelector$1_0);
_.onFailure = function onFailure_63(t){
  $handleError_0(($clinit_CoreGUI() , 'Unable to fetch server(s) for affinity group with id ' + ($clinit_Enhanced() , '' + this.this$0.affinityGroupId) + '.'), t);
}
;
_.onSuccess_0 = function onSuccess_63(result){
  $onSuccess_61(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$selector = null;
function $clinit_ServerDatasource(){
  $clinit_ServerDatasource = nullMethod;
  $clinit_RPCDataSource();
  FILTER_ADDRESS_0 = ($clinit_ServerDatasourceField() , FIELD_ADDRESS_0).propertyName;
  FILTER_PORT_0 = FIELD_PORT_0.propertyName;
  FILTER_SECURE_PORT = FIELD_SECURE_PORT.propertyName;
  FILTER_OPERATION_MODE = FIELD_OPERATION_MODE.propertyName;
}

function $addDataSourceFields(){
  var fields, idField;
  fields = new ArrayList_0;
  idField = new DataSourceIntegerField_2(($clinit_ServerDatasourceField() , FIELD_ID_2).propertyName, FIELD_ID_2.title_0, 50);
  $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_8(idField, 'hidden', TRUE);
  setCheck(fields.array, fields.size_0++, idField);
  return fields;
}

function $copyValues_8(){
  throw new UnsupportedOperationException_1('ServerDatasource.copyValues(Record from)');
}

function $copyValues_9(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, ($clinit_ServerDatasourceField() , FIELD_ID_2).propertyName, from.id);
  $setAttribute_13(record, FIELD_NAME_1.propertyName, from.name_0);
  $setAttribute_12(record, FIELD_OPERATION_MODE.propertyName, from.operationMode);
  $setAttribute_13(record, FIELD_ADDRESS_0.propertyName, from.address);
  $setAttribute_3(record, FIELD_PORT_0.propertyName, from.port);
  $setAttribute_3(record, FIELD_SECURE_PORT.propertyName, from.securePort);
  $setAttribute_4(record, FIELD_MTIME.propertyName, from.mtime);
  $setAttribute_13(record, FIELD_AFFINITY_GROUP_0.propertyName, !from.affinityGroup?'':from.affinityGroup.name_0);
  $setAttribute_12(record, FIELD_AFFINITY_GROUP_ID_0.propertyName, !from.affinityGroup?'':valueOf_44(from.affinityGroup.id));
  return record;
}

function $getFetchCriteria_0(request){
  var criteria, modesFilter;
  modesFilter = dynamicCast(getArrayFilter_0(request, FILTER_OPERATION_MODE, Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit), Q$Server$OperationMode_$1);
  if (modesFilter == null || modesFilter.length == 0) {
    return null;
  }
  criteria = new ServerCriteria_0;
  $addFilterId(criteria, dynamicCast(getFilter_0(request, ($clinit_ServerDatasourceField() , FIELD_ID_2).propertyName, Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterName_3(criteria, dynamicCast(getFilter_0(request, FIELD_NAME_1.propertyName, Ljava_lang_String_2_classLit), Q$String));
  $addFilterAddress_0(criteria, dynamicCast(getFilter_0(request, FILTER_ADDRESS_0, Ljava_lang_String_2_classLit), Q$String));
  $addFilterPort_0(criteria, dynamicCast(getFilter_0(request, FILTER_PORT_0, Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterSecurePort(criteria, dynamicCast(getFilter_0(request, FILTER_SECURE_PORT, Ljava_lang_Integer_2_classLit), Q$Integer));
  modesFilter != null && modesFilter.length > 0 && (criteria.filterOperationMode = new Arrays$ArrayList_0(modesFilter));
  $addFilterComputePower(criteria, dynamicCast(($clinit_RPCDataSource() , getFilter($getCriteria(request), 'computePower', Ljava_lang_Integer_2_classLit)), Q$Integer));
  $addFilterAffinityGroupId_0(criteria, dynamicCast(getFilter($getCriteria(request), 'affinityGroupId', Ljava_lang_Integer_2_classLit), Q$Integer));
  debug(' *** ServerCriteria Search String: ' + dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String));
  $setSearchExpression(criteria, dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String));
  return criteria;
}

function $getListGridFields_2(){
  var affinityGroupIdField, fields, idField, lastUpdateTimeField;
  fields = new ArrayList_0;
  idField = $getListGridField_5(($clinit_ServerDatasourceField() , FIELD_ID_2));
  idField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, idField);
  $add_3(fields, $getListGridField_6(FIELD_NAME_1, '*'));
  $add_3(fields, $getListGridField_6(FIELD_OPERATION_MODE, '90'));
  $add_3(fields, $getListGridField_6(FIELD_ADDRESS_0, '190'));
  $add_3(fields, $getListGridField_6(FIELD_PORT_0, '90'));
  $add_3(fields, $getListGridField_6(FIELD_SECURE_PORT, '75'));
  lastUpdateTimeField = $getListGridField_6(FIELD_MTIME, '120');
  $clinit_TimestampCellFormatter();
  prepareDateField(lastUpdateTimeField, getAttribute(lastUpdateTimeField.jsObj, 'name'));
  setCheck(fields.array, fields.size_0++, lastUpdateTimeField);
  affinityGroupIdField = $getListGridField_5(FIELD_AFFINITY_GROUP_ID_0);
  affinityGroupIdField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, affinityGroupIdField);
  return fields;
}

function $getPageControl_0(this$static, request){
  var columnName, ordering, pageControl, sort, sort$index, sort$max, sortBy, sorts;
  pageControl = new PageControl_1(0, this$static.dataPageSize.value_0);
  sortBy = getAttribute(request.jsObj, 'sortBy');
  if (sortBy != null) {
    sorts = $split(sortBy, ',', 0);
    for (sort$index = 0 , sort$max = sorts.length; sort$index < sort$max; ++sort$index) {
      sort = sorts[sort$index];
      ordering = sort.indexOf('-') == 0?($clinit_PageOrdering() , DESC):($clinit_PageOrdering() , ASC);
      columnName = ordering == ($clinit_PageOrdering() , DESC)?$substring(sort, 1):sort;
      $addDefaultOrderingField(pageControl, columnName, ordering);
    }
  }
  return pageControl;
}

function ServerDatasource_0(affinityGroupId){
  $clinit_ServerDatasource();
  var fields;
  AbstractServerNodeDatasource_0.call(this);
  this.affinityGroupId = affinityGroupId;
  fields = $addDataSourceFields();
  $addFields(this, fields);
}

defineSeed(1778, 1759, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractServerNodeDatasource]), ServerDatasource_0);
_.copyValues = function copyValues_14(from){
  return $copyValues_8();
}
;
_.copyValues_0 = function copyValues_15(from){
  return $copyValues_9(dynamicCast(from, Q$Server));
}
;
_.executeFetch = function executeFetch_7(request, response, criteria){
  this.executeFetch_1(request, response, dynamicCast(criteria, Q$ServerCriteria));
}
;
_.executeFetch_1 = function executeFetch_8(request, response, criteria){
  if (!criteria) {
    $setTotalRows(response, valueOf_44(0));
    $processResponse_0(this, getAttribute(request.jsObj, 'requestId'), response);
    return;
  }
  !!this.affinityGroupId && $addFilterAffinityGroupId_0(criteria, this.affinityGroupId);
  $findServersByCriteria(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), criteria, new ServerDatasource$1_0(this, response, request));
}
;
_.getFetchCriteria = function getFetchCriteria_5(request){
  return $getFetchCriteria_0(request);
}
;
_.getListGridFields = function getListGridFields(){
  return $getListGridFields_2();
}
;
_.getPageControl = function getPageControl_0(request){
  return $getPageControl_0(this, request);
}
;
_.affinityGroupId = null;
var FILTER_ADDRESS_0, FILTER_OPERATION_MODE, FILTER_PORT_0, FILTER_SECURE_PORT;
function AffinityGroupServersSelector$2_0(){
  $clinit_ServerDatasource();
  ServerDatasource_0.call(this, null);
}

defineSeed(1777, 1778, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractServerNodeDatasource]), AffinityGroupServersSelector$2_0);
_.executeFetch_1 = function executeFetch_9(request, response, criteria){
  criteria.fetchAffinityGroup = true;
  $findServersByCriteria(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), criteria, new AffinityGroupServersSelector$2$1_0(this, response, request));
}
;
function $onSuccess_62(this$static, result){
  var agent, it;
  it = new AbstractList$IteratorImpl_0(result);
  while (it.i < it.this$0_0.size_1()) {
    agent = dynamicCast($next_0(it), Q$Server);
    !!agent.affinityGroup && $remove_7(it);
  }
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$1, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function AffinityGroupServersSelector$2$1_0(this$1, val$response, val$request){
  this.this$1 = this$1;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1779, 1, {}, AffinityGroupServersSelector$2$1_0);
_.onFailure = function onFailure_64(t){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Unable to fetch agents.'), t);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$1, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_64(result){
  $onSuccess_62(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function AffinityGroupServersSelector$3_0(val$parrent){
  this.val$parrent = val$parrent;
}

defineSeed(1780, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), AffinityGroupServersSelector$3_0);
_.onCloseClick_0 = function onCloseClick_2(event_0){
  closeAndRefresh_0(this.val$parrent, false);
}
;
_.val$parrent = null;
function AffinityGroupServersSelector$4_0(val$parrent){
  this.val$parrent = val$parrent;
}

defineSeed(1781, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AffinityGroupServersSelector$4_0);
_.onClick = function onClick_23(clickEvent){
  closeAndRefresh_0(this.val$parrent, false);
}
;
_.val$parrent = null;
function AffinityGroupServersSelector$5_0(val$selector, val$parrent, val$affinityGroupId){
  this.val$selector = val$selector;
  this.val$parrent = val$parrent;
  this.val$affinityGroupId = val$affinityGroupId;
}

defineSeed(1782, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AffinityGroupServersSelector$5_0);
_.onClick = function onClick_24(clickEvent){
  var actuallySelected, originallySelected;
  actuallySelected = getIdList_0(this.val$selector.assignedGrid.getRecords());
  originallySelected = new ArrayList_2(this.val$selector.originallyAssignedIds);
  $removeAll(originallySelected, actuallySelected);
  $removeAll(actuallySelected, new ArrayList_2(this.val$selector.originallyAssignedIds));
  $clinit_BaseWidget();
  shouldBeClosed_0 = true;
  if (originallySelected.size_0 != 0) {
    shouldBeClosed_0 = false;
    $removeServersFromGroup(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), dynamicCast($toArray_1(originallySelected, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, originallySelected.size_0, 0)), Q$Integer_$1), new AffinityGroupServersSelector$5$1_0(this.val$parrent, this.val$affinityGroupId));
  }
  if (actuallySelected.size_0 != 0) {
    shouldBeClosed_0 = false;
    $addServersToGroup(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), this.val$selector.affinityGroupId.value_0, dynamicCast($toArray_1(actuallySelected, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, actuallySelected.size_0, 0)), Q$Integer_$1), new AffinityGroupServersSelector$5$2_0(this.val$parrent, this.val$affinityGroupId));
  }
  shouldBeClosed_0 && closeAndRefresh_0(this.val$parrent, false);
}
;
_.val$affinityGroupId = null;
_.val$parrent = null;
_.val$selector = null;
function $onSuccess_63(this$static){
  closeAndRefresh_0(this$static.val$parrent, true);
}

function AffinityGroupServersSelector$5$1_0(val$parrent, val$affinityGroupId){
  this.val$parrent = val$parrent;
  this.val$affinityGroupId = val$affinityGroupId;
}

defineSeed(1783, 1, {}, AffinityGroupServersSelector$5$1_0);
_.onFailure = function onFailure_65(t){
  $handleError_0(($clinit_CoreGUI() , 'Unable to assign servers to the affinity group with id ' + ($clinit_Enhanced() , '' + this.val$affinityGroupId) + '.'), t);
}
;
_.onSuccess_0 = function onSuccess_65(result){
  $onSuccess_63(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$affinityGroupId = null;
_.val$parrent = null;
function $onSuccess_64(this$static){
  closeAndRefresh_0(this$static.val$parrent, true);
}

function AffinityGroupServersSelector$5$2_0(val$parrent, val$affinityGroupId){
  this.val$parrent = val$parrent;
  this.val$affinityGroupId = val$affinityGroupId;
}

defineSeed(1784, 1, {}, AffinityGroupServersSelector$5$2_0);
_.onFailure = function onFailure_66(t){
  $handleError_0(($clinit_CoreGUI() , 'Unable to remove servers from the affinity group with id ' + ($clinit_Enhanced() , '' + this.val$affinityGroupId) + '.'), t);
}
;
_.onSuccess_0 = function onSuccess_66(result){
  $onSuccess_64(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$affinityGroupId = null;
_.val$parrent = null;
function $clinit_AffinityGroupTableView(){
  $clinit_AffinityGroupTableView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_10 = new ViewName_2('AffinityGroups', ($clinit_Enhanced() , 'Affinity Groups'), ($clinit_IconEnum() , ALL_GROUPS));
  VIEW_PATH_0 = ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_TOPOLOGY_VIEW_ID + '/' + VIEW_ID_10;
}

function $createNewGroup(modalWindow, form){
  var affinityGroup, name_0;
  if (form.validate_0()) {
    name_0 = $getValueAsString(form, 'name');
    affinityGroup = new AffinityGroup_1(name_0);
    $createAffinityGroup(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), affinityGroup, new AffinityGroupTableView$6_0(modalWindow, form));
  }
}

function $getSelectedIds_1(selections){
  var i, ids, selection, selection$index, selection$max;
  if (selections == null) {
    return initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, 0, 1);
  }
  ids = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selections.length, 1);
  i = 0;
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    ids[i++] = getAttributeAsInt(selection.jsObj, 'id').value_0;
  }
  return ids;
}

function $getSelectedNames_1(selections){
  var ids, selection, selection$index, selection$max;
  if (selections == null) {
    return new ArrayList_1(0);
  }
  ids = new ArrayList_1(selections.length);
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    $add_3(ids, getAttribute(selection.jsObj, 'name'));
  }
  return ids;
}

function AffinityGroupTableView_0(){
  $clinit_AffinityGroupTableView();
  TableSection_0.call(this, null);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setDataSource(this, new AffinityGroupWithCountsDatasource_0);
}

defineSeed(1785, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), AffinityGroupTableView_0);
_.configureTable = function configureTable_6(){
  var fields, listGrid;
  fields = $getListGridFields_3(dynamicCast(this.dataSource_1, Q$AffinityGroupWithCountsDatasource));
  listGrid = this.listGrid;
  $setFields_1(listGrid, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $addTableAction(this, ($clinit_Enhanced() , 'Create New'), null, null, new AffinityGroupTableView$1_0(this, ($clinit_TableActionEnablement() , ALWAYS), initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , MANAGE_SETTINGS)])));
  $addTableAction(this, 'Remove Selected', null, null, new AffinityGroupTableView$2_0(this, this, ANY_1, initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [MANAGE_SETTINGS])));
  $configureTable(this);
}
;
_.getDetailsView_0 = function getDetailsView_3(id){
  return new AffinityGroupDetailView_0(id.value_0);
}
;
_.getViewName = function getViewName_0(){
  return VIEW_ID_10;
}
;
var VIEW_ID_10, VIEW_PATH_0;
function AffinityGroupTableView$1_0($anonymous0, $anonymous1, $anonymous2){
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1786, 1607, {}, AffinityGroupTableView$1_0);
_.executeAction = function executeAction_9(selections, actionValue){
  var modalWindow, layout, form, name_0, nameLengthValidator, spacer, cancel, create, buttons;
  modalWindow = new Window_1;
  $setTitle(modalWindow, ($clinit_Enhanced() , 'Affinity Groups') + ': Create New');
  $setAttribute_24(modalWindow, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $isCreated_1(modalWindow)?$setProperty_0(modalWindow, 'minWidth', 400):(modalWindow.config_0['minWidth'] = 400 , undefined);
  $isCreated_1(modalWindow)?$setProperty_0(modalWindow, 'minHeight', 400):(modalWindow.config_0['minHeight'] = 400 , undefined);
  $setAutoSize(modalWindow, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAutoCenter(modalWindow, TRUE);
  $setCanDragResize_0(modalWindow, TRUE);
  $setCanDragReposition(modalWindow, TRUE);
  layout = new VLayout_0;
  $isCreated_1(layout)?$setProperty_3(layout, 'width', '100%'):(layout.config_0['width'] = '100%' , undefined);
  $isCreated_1(layout)?$setProperty_3(layout, 'height', '100%'):(layout.config_0['height'] = '100%' , undefined);
  $setPadding(layout, valueOf_44(15));
  $setLayoutMargin(layout, valueOf_44(20));
  $setAttribute_24(layout, 'vPolicy', ($clinit_LayoutPolicy() , FILL).value_0, true);
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $setWrapItemTitles(form, FALSE);
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 2):(form.config_0['numCols'] = 2 , undefined);
  name_0 = new TextItem_3('name', 'Name');
  $setRequired(name_0, TRUE);
  nameLengthValidator = new LengthRangeValidator_0;
  $setAttribute_11(nameLengthValidator, 'min', valueOf_44(3));
  $setAttribute_11(nameLengthValidator, 'max', valueOf_44(100));
  $isCreated_2(name_0)?$setProperty_7(name_0, 'validators', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [nameLengthValidator]))):(name_0.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [nameLengthValidator])) , undefined);
  $addKeyUpHandler(name_0, new AffinityGroupTableView$3_0(modalWindow, form));
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [name_0]));
  layout.addMember_0(form);
  spacer = new VLayout_0;
  $isCreated_1(spacer)?$setProperty_0(spacer, 'height', 10):(spacer.config_0['height'] = 10 , undefined);
  layout.addMember_0(spacer);
  cancel = new EnhancedIButton_1('Cancel');
  $addClickHandler(cancel, new AffinityGroupTableView$4_0(modalWindow));
  create = new EnhancedIButton_1('Create New');
  $addClickHandler(create, new AffinityGroupTableView$5_0(modalWindow, form));
  buttons = new HLayout_1(10);
  $setAttribute_24(buttons, 'layoutAlign', ($clinit_Alignment() , CENTER_0).value_0, false);
  $addMember(buttons, create);
  $addMember(buttons, cancel);
  layout.addMember_0(buttons);
  $addItem(modalWindow, layout);
  modalWindow.show_0();
  $focusInItem(name_0);
}
;
function AffinityGroupTableView$2_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1787, 1607, {}, AffinityGroupTableView$2_0);
_.executeAction = function executeAction_10(selections, actionValue){
  var message, selectedNames;
  selectedNames = $getSelectedNames_1(selections);
  message = 'Do you really want to remove following affinity groups ' + ($clinit_Enhanced() , selectedNames.toString$()) + '?';
  ask(message, new AffinityGroupTableView$2$1_0(this, selections, selectedNames));
}
;
_.this$0 = null;
function AffinityGroupTableView$2$1_0(this$1, val$selections, val$selectedNames){
  this.this$1 = this$1;
  this.val$selections = val$selections;
  this.val$selectedNames = val$selectedNames;
}

defineSeed(1788, 1, {}, AffinityGroupTableView$2$1_0);
_.execute_3 = function execute_16(confirmed){
  var selectedIds;
  if (confirmed.value_0) {
    selectedIds = $getSelectedIds_1(this.val$selections);
    $deleteAffinityGroups(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), selectedIds, new AffinityGroupTableView$2$1$1_0(this, this.val$selectedNames));
  }
   else {
    $refreshTableInfo(this.this$1.this$0);
  }
}
;
_.this$1 = null;
_.val$selectedNames = null;
_.val$selections = null;
function $onSuccess_65(this$static, count){
  var msg;
  msg = new Message_7('Removed ' + ($clinit_Enhanced() , '' + count) + ' affinity group(s).', ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$2.this$1.this$0, false);
}

function AffinityGroupTableView$2$1$1_0(this$2, val$selectedNames){
  this.this$2 = this$2;
  this.val$selectedNames = val$selectedNames;
}

defineSeed(1789, 1, {}, AffinityGroupTableView$2$1$1_0);
_.onFailure = function onFailure_67(caught){
  $handleError_0(($clinit_CoreGUI() , 'Unable to remove following affinity groups(s) ' + ($clinit_Enhanced() , this.val$selectedNames.toString$()) + '. ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$2.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_67(count){
  $onSuccess_65(this, dynamicCast(count, Q$Integer));
}
;
_.this$2 = null;
_.val$selectedNames = null;
function AffinityGroupTableView$3_0(val$modalWindow, val$form){
  this.val$modalWindow = val$modalWindow;
  this.val$form = val$form;
}

defineSeed(1790, 1, makeCastMap([Q$EventHandler, Q$KeyUpHandler]), AffinityGroupTableView$3_0);
_.onKeyUp = function onKeyUp(event_0){
  $equals_6('Enter', $getKeyName_0(event_0)) && $createNewGroup(this.val$modalWindow, this.val$form);
}
;
_.val$form = null;
_.val$modalWindow = null;
function AffinityGroupTableView$4_0(val$modalWindow){
  this.val$modalWindow = val$modalWindow;
}

defineSeed(1791, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AffinityGroupTableView$4_0);
_.onClick = function onClick_25(clickEvent){
  $destroy(this.val$modalWindow);
}
;
_.val$modalWindow = null;
function AffinityGroupTableView$5_0(val$modalWindow, val$form){
  this.val$modalWindow = val$modalWindow;
  this.val$form = val$form;
}

defineSeed(1792, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AffinityGroupTableView$5_0);
_.onClick = function onClick_26(clickEvent){
  $createNewGroup(this.val$modalWindow, this.val$form);
}
;
_.val$form = null;
_.val$modalWindow = null;
function $onFailure_1(this$static, caught){
  var errors;
  errors = new HashMap_0;
  errors.put('name', caught.getMessage());
  $setErrors(this$static.val$form, errors, true);
}

function $onSuccess_66(this$static, affinityGroupId){
  $destroy(this$static.val$modalWindow);
  $clinit_CoreGUI();
  goToView(($clinit_AffinityGroupTableView() , VIEW_PATH_0) + '/' + affinityGroupId, null, false);
}

function AffinityGroupTableView$6_0(val$modalWindow, val$form){
  this.val$modalWindow = val$modalWindow;
  this.val$form = val$form;
}

defineSeed(1793, 1, {}, AffinityGroupTableView$6_0);
_.onFailure = function onFailure_68(caught){
  $onFailure_1(this, caught);
}
;
_.onSuccess_0 = function onSuccess_68(affinityGroupId){
  $onSuccess_66(this, dynamicCast(affinityGroupId, Q$Integer));
}
;
_.val$form = null;
_.val$modalWindow = null;
function $copyValues_10(){
  throw new UnsupportedOperationException_1('AffinityGroupWithCountsDatasource.copyValues(Record from)');
}

function $copyValues_11(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, ($clinit_AffinityGroupWithCountsDatasource$Fields() , FIELD_ID).propertyName, from.affinityGroup.id);
  $setAttribute_13(record, FIELD_NAME.propertyName, from.affinityGroup.name_0);
  $setAttribute_3(record, FIELD_AGENT_COUNT.propertyName, from.agentCount);
  $setAttribute_3(record, FIELD_SERVER_COUNT.propertyName, from.serverCount);
  return record;
}

function $executeFetch_4(this$static, request, response){
  var pc;
  pc = $getPageControl_1(this$static, request);
  $getAffinityGroupCountComposites(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), pc, new AffinityGroupWithCountsDatasource$1_0(this$static, response, request));
}

function $getListGridFields_3(){
  var fields, idField;
  fields = new ArrayList_0;
  idField = $getListGridField(($clinit_AffinityGroupWithCountsDatasource$Fields() , FIELD_ID));
  idField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, idField);
  $add_3(fields, $getListGridField_0(FIELD_NAME, '*'));
  $add_3(fields, $getListGridField_0(FIELD_AGENT_COUNT, '200'));
  $add_3(fields, $getListGridField_0(FIELD_SERVER_COUNT, '200'));
  return fields;
}

function $getPageControl_1(this$static, request){
  var columnName, ordering, pageControl, sort, sort$index, sort$max, sortBy, sorts;
  pageControl = new PageControl_1(0, this$static.dataPageSize.value_0);
  sortBy = getAttribute(request.jsObj, 'sortBy');
  if (sortBy != null) {
    sorts = $split(sortBy, ',', 0);
    for (sort$index = 0 , sort$max = sorts.length; sort$index < sort$max; ++sort$index) {
      sort = sorts[sort$index];
      ordering = sort.indexOf('-') == 0?($clinit_PageOrdering() , DESC):($clinit_PageOrdering() , ASC);
      columnName = ordering == ($clinit_PageOrdering() , DESC)?$substring(sort, 1):sort;
      $addDefaultOrderingField(pageControl, columnName, ordering);
    }
  }
  return pageControl;
}

function AffinityGroupWithCountsDatasource_0(){
  var fields_0, idField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  fields = (fields_0 = new ArrayList_0 , idField = new DataSourceIntegerField_2(($clinit_AffinityGroupWithCountsDatasource$Fields() , FIELD_ID).propertyName, FIELD_ID.title_0, 50) , $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setAttribute_8(idField, 'hidden', TRUE) , setCheck(fields_0.array, fields_0.size_0++, idField) , fields_0);
  $addFields(this, fields);
}

defineSeed(1794, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AffinityGroupWithCountsDatasource]), AffinityGroupWithCountsDatasource_0);
_.copyValues = function copyValues_16(from){
  return $copyValues_10();
}
;
_.copyValues_0 = function copyValues_17(from){
  return $copyValues_11(dynamicCast(from, Q$AffinityGroupCountComposite));
}
;
_.executeFetch = function executeFetch_10(request, response, criteria){
  $executeFetch_4(this, request, response, dynamicCast(criteria, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_6(request){
  return null;
}
;
_.getPageControl = function getPageControl_1(request){
  return $getPageControl_1(this, request);
}
;
function $onFailure_2(this$static, t){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Unable to fetch affinity group(s).'), t);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_67(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function AffinityGroupWithCountsDatasource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1795, 1, {}, AffinityGroupWithCountsDatasource$1_0);
_.onFailure = function onFailure_69(t){
  $onFailure_2(this, t);
}
;
_.onSuccess_0 = function onSuccess_69(result){
  $onSuccess_67(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $clinit_AffinityGroupWithCountsDatasource$Fields(){
  $clinit_AffinityGroupWithCountsDatasource$Fields = nullMethod;
  FIELD_ID = new AffinityGroupWithCountsDatasource$Fields_0('FIELD_ID', 0, 'id', ($clinit_CoreGUI() , 'ID'));
  FIELD_NAME = new AffinityGroupWithCountsDatasource$Fields_0('FIELD_NAME', 1, 'name', 'Name');
  FIELD_AGENT_COUNT = new AffinityGroupWithCountsDatasource$Fields_0('FIELD_AGENT_COUNT', 2, 'agentCount', 'Agent Count');
  FIELD_SERVER_COUNT = new AffinityGroupWithCountsDatasource$Fields_0('FIELD_SERVER_COUNT', 3, 'serverCount', 'Server Count');
  $VALUES_118 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupWithCountsDatasource$Fields_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$AffinityGroupWithCountsDatasource$Fields, [FIELD_ID, FIELD_NAME, FIELD_AGENT_COUNT, FIELD_SERVER_COUNT]);
}

function $getListGridField(this$static){
  return new ListGridField_3(this$static.propertyName, this$static.title_0);
}

function $getListGridField_0(this$static, width){
  var field;
  field = new ListGridField_3(this$static.propertyName, this$static.title_0);
  field.jsObj['width'] = width;
  return field;
}

function AffinityGroupWithCountsDatasource$Fields_0(enum$name, enum$ordinal, propertyName, title){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.propertyName = propertyName;
  this.title_0 = title;
}

function valueOf_127(name_0){
  $clinit_AffinityGroupWithCountsDatasource$Fields();
  return valueOf(($clinit_AffinityGroupWithCountsDatasource$Fields$Map() , $MAP_118), name_0);
}

function values_121(){
  $clinit_AffinityGroupWithCountsDatasource$Fields();
  return $VALUES_118;
}

defineSeed(1796, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$AffinityGroupWithCountsDatasource$Fields]), AffinityGroupWithCountsDatasource$Fields_0);
_.propertyName = null;
_.title_0 = null;
var $VALUES_118, FIELD_AGENT_COUNT, FIELD_ID, FIELD_NAME, FIELD_SERVER_COUNT;
function $clinit_AffinityGroupWithCountsDatasource$Fields$Map(){
  $clinit_AffinityGroupWithCountsDatasource$Fields$Map = nullMethod;
  $MAP_118 = createValueOfMap(($clinit_AffinityGroupWithCountsDatasource$Fields() , $VALUES_118));
}

var $MAP_118;
function $onSuccess_68(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function AgentDatasource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1798, 1, {}, AgentDatasource$1_0);
_.onFailure = function onFailure_70(t){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Unable to fetch agents.'), t);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_70(result){
  $onSuccess_68(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $clinit_AgentDatasourceField(){
  $clinit_AgentDatasourceField = nullMethod;
  FIELD_ID_0 = new AgentDatasourceField_0('FIELD_ID', 0, 'id', ($clinit_CoreGUI() , 'ID'));
  FIELD_NAME_0 = new AgentDatasourceField_0('FIELD_NAME', 1, 'name', 'Name');
  FIELD_SERVER = new AgentDatasourceField_0('FIELD_SERVER', 2, 'server', 'Connected Server');
  FIELD_SERVER_ID = new AgentDatasourceField_0('FIELD_SERVER_ID', 3, 'serverId', 'serverId');
  FIELD_ADDRESS = new AgentDatasourceField_0('FIELD_ADDRESS', 4, 'address', 'Agent Bind Address');
  FIELD_REMOTE_ENDPOINT = new AgentDatasourceField_0('FIELD_REMOTE_ENDPOINT', 5, 'remoteEndpoint', 'Remote Endpoint');
  FIELD_PORT = new AgentDatasourceField_0('FIELD_PORT', 6, 'port', 'Agent Bind Port');
  FIELD_AGENTTOKEN = new AgentDatasourceField_0('FIELD_AGENTTOKEN', 7, 'agenttoken', 'Token');
  FIELD_LAST_AVAILABILITY_REPORT = new AgentDatasourceField_0('FIELD_LAST_AVAILABILITY_REPORT', 8, 'lastAvailabilityReport', 'Last Availability Report');
  FIELD_LAST_AVAILABILITY_PING = new AgentDatasourceField_0('FIELD_LAST_AVAILABILITY_PING', 9, 'lastAvailabilityPing', 'Last Availability Ping');
  FIELD_AGENT_TOKEN = new AgentDatasourceField_0('FIELD_AGENT_TOKEN', 10, 'agentToken', 'Token');
  FIELD_AFFINITY_GROUP = new AgentDatasourceField_0('FIELD_AFFINITY_GROUP', 11, 'affinityGroup', 'Affinity Group');
  FIELD_AFFINITY_GROUP_ID = new AgentDatasourceField_0('FIELD_AFFINITY_GROUP_ID', 12, 'affinityGroupId', 'affinityGroupId');
  $VALUES_119 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentDatasourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$AgentDatasourceField, [FIELD_ID_0, FIELD_NAME_0, FIELD_SERVER, FIELD_SERVER_ID, FIELD_ADDRESS, FIELD_REMOTE_ENDPOINT, FIELD_PORT, FIELD_AGENTTOKEN, FIELD_LAST_AVAILABILITY_REPORT, FIELD_LAST_AVAILABILITY_PING, FIELD_AGENT_TOKEN, FIELD_AFFINITY_GROUP, FIELD_AFFINITY_GROUP_ID]);
}

function $getListGridField_1(this$static){
  return new ListGridField_3(this$static.propertyName, this$static.title_0);
}

function $getListGridField_2(this$static, width){
  var field;
  field = new ListGridField_3(this$static.propertyName, this$static.title_0);
  field.jsObj['width'] = width;
  return field;
}

function AgentDatasourceField_0(enum$name, enum$ordinal, propertyName, title){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.propertyName = propertyName;
  this.title_0 = title;
}

function valueOf_128(name_0){
  $clinit_AgentDatasourceField();
  return valueOf(($clinit_AgentDatasourceField$Map() , $MAP_119), name_0);
}

function values_122(){
  $clinit_AgentDatasourceField();
  return $VALUES_119;
}

defineSeed(1799, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$AgentDatasourceField]), AgentDatasourceField_0);
_.propertyName = null;
_.title_0 = null;
var $VALUES_119, FIELD_ADDRESS, FIELD_AFFINITY_GROUP, FIELD_AFFINITY_GROUP_ID, FIELD_AGENTTOKEN, FIELD_AGENT_TOKEN, FIELD_ID_0, FIELD_LAST_AVAILABILITY_PING, FIELD_LAST_AVAILABILITY_REPORT, FIELD_NAME_0, FIELD_PORT, FIELD_REMOTE_ENDPOINT, FIELD_SERVER, FIELD_SERVER_ID;
function $clinit_AgentDatasourceField$Map(){
  $clinit_AgentDatasourceField$Map = nullMethod;
  $MAP_119 = createValueOfMap(($clinit_AgentDatasourceField() , $VALUES_119));
}

var $MAP_119;
function $prepareDetailsSection_2(this$static, agent){
  var addressItem, affinityGroupItem, affinityGroupItemText, ag, currentServerItem, detailsUrl, form, formattedValue, lastAvailabilityPingItem, lastAvailabilityReportItem, lastPing, lastReport, nameItem, portItem, remoteEndpointItem, section, serverValue, tokenItem;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 2):(form.config_0['numCols'] = 2 , undefined);
  nameItem = new StaticTextItem_2(($clinit_AgentDatasourceField() , FIELD_NAME_0).propertyName, FIELD_NAME_0.title_0);
  $setValue_7(nameItem, '<b>' + agent.name_0 + '<\/b>');
  addressItem = new StaticTextItem_2(FIELD_ADDRESS.propertyName, FIELD_ADDRESS.title_0);
  $setValue_7(addressItem, agent.address);
  remoteEndpointItem = new StaticTextItem_2(FIELD_REMOTE_ENDPOINT.propertyName, FIELD_REMOTE_ENDPOINT.title_0);
  $setValue_7(remoteEndpointItem, agent.remoteEndpoint);
  portItem = new StaticTextItem_2(FIELD_PORT.propertyName, FIELD_PORT.title_0);
  $setValue_5(portItem, agent.port);
  tokenItem = new StaticTextItem_2(FIELD_AGENT_TOKEN.propertyName, FIELD_AGENT_TOKEN.title_0);
  $setValue_7(tokenItem, agent.agentToken);
  lastAvailabilityReportItem = new StaticTextItem_2(FIELD_LAST_AVAILABILITY_REPORT.propertyName, FIELD_LAST_AVAILABILITY_REPORT.title_0);
  lastReport = !agent.lastAvailabilityReport?'unknown':format_30(valueOf_45(agent.lastAvailabilityReport.value_0), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_LONG));
  $setValue_7(lastAvailabilityReportItem, lastReport);
  lastAvailabilityPingItem = new StaticTextItem_2(FIELD_LAST_AVAILABILITY_PING.propertyName, FIELD_LAST_AVAILABILITY_PING.title_0);
  lastPing = !agent.lastAvailabilityPing?'unknown':format_30(valueOf_45(agent.lastAvailabilityPing.value_0), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_LONG));
  $setValue_7(lastAvailabilityPingItem, lastPing);
  affinityGroupItem = new StaticTextItem_2(FIELD_AFFINITY_GROUP.propertyName, FIELD_AFFINITY_GROUP.title_0);
  affinityGroupItemText = '';
  ag = agent.affinityGroup;
  if (!!ag && ag.name_0 != null && !!ag.name_0.length) {
    detailsUrl = '#' + ($clinit_AffinityGroupTableView() , VIEW_PATH_0) + '/' + ag.id;
    formattedValue = escapeHtml(ag.name_0);
    affinityGroupItemText = getHref(detailsUrl, formattedValue);
  }
  $setValue_7(affinityGroupItem, affinityGroupItemText);
  currentServerItem = new StaticTextItem_2(FIELD_SERVER.propertyName, FIELD_SERVER.title_0);
  if (!agent.server) {
    serverValue = '';
  }
   else {
    detailsUrl = '#' + ($clinit_ServerTableView() , VIEW_PATH_3) + '/' + agent.server.id;
    formattedValue = escapeHtml(agent.server.name_0);
    serverValue = getHref(detailsUrl, formattedValue);
  }
  $setValue_7(currentServerItem, serverValue);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [nameItem, addressItem, remoteEndpointItem, portItem, tokenItem, lastAvailabilityReportItem, lastAvailabilityPingItem, affinityGroupItem, currentServerItem]));
  section = new SectionStackSection_1(($clinit_Enhanced() , 'Details'));
  $setExpanded(section, TRUE);
  $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form]));
  this$static.detailsSection = section;
  ++this$static.initSectionCount;
}

function $prepareFailoverListSection(this$static, agent){
  var agentsTable, section;
  section = new SectionStackSection_1(($clinit_Enhanced() , 'Agent Failover List'));
  $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  agentsTable = new ServerTableView_0(valueOf_44(agent.id), false);
  $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [agentsTable]));
  this$static.failoverListSection = section;
  ++this$static.initSectionCount;
  return;
}

function AgentDetailView_0(agentId){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.agentId = agentId;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  this.sectionStack = new SectionStack_0;
  $setAttribute_24(this.sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
  $setAttribute_24(this.sectionStack, 'width', '100%', true);
  $setAttribute_24(this.sectionStack, 'height', '100%', true);
  $setMargin(this.sectionStack, valueOf_44(5));
  $setAttribute_24(this.sectionStack, 'overflow', VISIBLE.value_0, false);
}

defineSeed(1801, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), AgentDetailView_0);
_.onDraw_0 = function onDraw_10(){
  $run_4(new AgentDetailView$2_0(this));
}
;
_.onInit = function onInit_14(){
  var criteria;
  $onInit(this);
  $onInit_Layout(this);
  criteria = new AgentCriteria_0;
  $addFilterId(criteria, valueOf_44(this.agentId));
  $findAgentsByCriteria(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), criteria, new AgentDetailView$1_0(this));
}
;
_.agentId = 0;
_.detailsSection = null;
_.failoverListSection = null;
_.initSectionCount = 0;
_.sectionStack = null;
function $onSuccess_69(this$static, agents){
  if (!agents || agents.size_0 == 0 || agents.size_0 != 1) {
    $handleError_0(($clinit_CoreGUI() , 'Unable to fetch agent details for agent with id ' + ($clinit_Enhanced() , '' + this$static.this$0.agentId) + '.'), null);
    this$static.this$0.initSectionCount = 2;
    return;
  }
  $prepareDetailsSection_2(this$static.this$0, dynamicCast((checkIndex(0, agents.size_0) , agents.array[0]), Q$Agent));
  $prepareFailoverListSection(this$static.this$0, dynamicCast((checkIndex(0, agents.size_0) , agents.array[0]), Q$Agent));
}

function AgentDetailView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1802, 1, {}, AgentDetailView$1_0);
_.onFailure = function onFailure_71(caught){
  $handleError_0(($clinit_CoreGUI() , 'Unable to fetch agent details for agent with id ' + ($clinit_Enhanced() , '' + this.this$0.agentId) + '. ' + caught.getMessage()), caught);
  this.this$0.initSectionCount = 2;
}
;
_.onSuccess_0 = function onSuccess_71(agents){
  $onSuccess_69(this, dynamicCast(agents, Q$PageList));
}
;
_.this$0 = null;
function $run_4(this$static){
  var elapsedMillis;
  if (this$static.this$0.initSectionCount >= 2) {
    !!this$static.this$0.detailsSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.detailsSection);
    !!this$static.this$0.failoverListSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.failoverListSection);
    $addMember(this$static.this$0, this$static.this$0.sectionStack);
    $markForRedraw(this$static.this$0);
  }
   else {
    elapsedMillis = sub(fromDouble(currentTimeMillis0()), this$static.startTime);
    gt(elapsedMillis, P4e20_longLit) && (this$static.this$0.initSectionCount = 2);
    $schedule(this$static, 100);
  }
}

function AgentDetailView$2_0(this$0){
  $clinit_Timer();
  this.this$0 = this$0;
  this.startTime = fromDouble(currentTimeMillis0());
}

defineSeed(1803, 73, makeCastMap([Q$Timer]), AgentDetailView$2_0);
_.run = function run_8(){
  $run_4(this);
}
;
_.this$0 = null;
function $clinit_AgentTableView(){
  $clinit_AgentTableView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_11 = new ViewName_2('Agents', ($clinit_Enhanced() , 'Agents'), ($clinit_IconEnum() , AGENT_0));
  VIEW_PATH_1 = ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_TOPOLOGY_VIEW_ID + '/' + VIEW_ID_11;
}

function AgentTableView_0(id, isAffinityGroupId){
  $clinit_AgentTableView();
  TableSection_0.call(this, null);
  this.isAffinityGroupId = isAffinityGroupId;
  this.id = id;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setDataSource(this, new AgentDatasource_0(id, isAffinityGroupId));
}

defineSeed(1804, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), AgentTableView_0);
_.configureTable = function configureTable_7(){
  var field, field$iterator, fields, listGrid;
  $configureTable(this);
  fields = $getListGridFields_1(dynamicCast(this.dataSource_1, Q$AgentDatasource));
  listGrid = this.listGrid;
  $setFields_1(listGrid, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $sort(listGrid, 'name', ($clinit_SortDirection() , ASCENDING));
  for (field$iterator = new AbstractList$IteratorImpl_0(fields); field$iterator.i < field$iterator.this$0_0.size_1();) {
    field = dynamicCast($next_0(field$iterator), Q$ListGridField);
    getAttribute(field.jsObj, 'name') == 'name'?$setCellFormatter_0(field, new AgentTableView$1_0(this)):getAttribute(field.jsObj, 'name') == ($clinit_AgentDatasourceField() , FIELD_SERVER).propertyName?$setCellFormatter_0(field, new AgentTableView$2_0):getAttribute(field.jsObj, 'name') == FIELD_AFFINITY_GROUP.propertyName && $setCellFormatter_0(field, new AgentTableView$3_0);
  }
  !this.id && $addTableAction(this, ($clinit_Enhanced() , 'Delete'), 'This will deregister the selected agents and uninventory their corresponding platforms and all other resources associated with them. There is no way to undo this action. Are you sure you want to do this?', null, new AgentTableView$4_0(this, this, ($clinit_TableActionEnablement() , ANY_1), initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , MANAGE_INVENTORY)])));
  this.isAffinityGroupId && $addTableAction(this, ($clinit_Enhanced() , 'Update Membership...'), null, null, new AgentTableView$5_0(this, this, ($clinit_TableActionEnablement() , ALWAYS), initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , MANAGE_SETTINGS)])));
}
;
_.getBasePath = function getBasePath_0(){
  return VIEW_PATH_1;
}
;
_.getDetailsView_0 = function getDetailsView_4(id){
  return new AgentDetailView_0(id.value_0);
}
;
_.getViewName = function getViewName_1(){
  return VIEW_ID_11;
}
;
_.id = null;
_.isAffinityGroupId = false;
var VIEW_ID_11, VIEW_PATH_1;
function AgentTableView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1805, 1, {}, AgentTableView$1_0);
_.format_1 = function format_2(value, record, rowNum, colNum){
  var detailsUrl, formattedValue;
  if (value == null) {
    return '';
  }
  detailsUrl = '#' + ($clinit_AgentTableView() , VIEW_PATH_1) + '/' + $getId(this.this$0, record);
  formattedValue = escapeHtml(toString__devirtual$(value));
  return getHref(detailsUrl, formattedValue);
}
;
_.this$0 = null;
function AgentTableView$2_0(){
}

defineSeed(1806, 1, {}, AgentTableView$2_0);
_.format_1 = function format_3(value, record, rowNum, colNum){
  var detailsUrl, formattedValue;
  if (value == null || !toString__devirtual$(value).length) {
    return '';
  }
  detailsUrl = '#' + ($clinit_ServerTableView() , VIEW_PATH_3) + '/' + $getAttributeAsString(record, ($clinit_AgentDatasourceField() , FIELD_SERVER_ID).propertyName);
  formattedValue = escapeHtml(toString__devirtual$(value));
  return getHref(detailsUrl, formattedValue);
}
;
function AgentTableView$3_0(){
}

defineSeed(1807, 1, {}, AgentTableView$3_0);
_.format_1 = function format_4(value, record, rowNum, colNum){
  var detailsUrl, formattedValue;
  if (value == null || !toString__devirtual$(value).length) {
    return '';
  }
  detailsUrl = '#' + ($clinit_AffinityGroupTableView() , VIEW_PATH_0) + '/' + $getAttributeAsString(record, ($clinit_AgentDatasourceField() , FIELD_AFFINITY_GROUP_ID).propertyName);
  formattedValue = escapeHtml(toString__devirtual$(value));
  return getHref(detailsUrl, formattedValue);
}
;
function AgentTableView$4_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1808, 1607, {}, AgentTableView$4_0);
_.executeAction = function executeAction_11(selections, actionValue){
  var agent, agentId, agentName, agents, i, resourceManager, selection, selection$index, selection$max;
  if (selections == null || selections.length == 0) {
    return;
  }
  resourceManager = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  agents = initDim(_3Lorg_rhq_core_domain_resource_Agent_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Agent, selections.length, 0);
  i = 0;
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    agentId = getAttributeAsInt(selection.jsObj, 'id').value_0;
    agentName = getAttribute(selection.jsObj, 'name');
    agent = new Agent_0;
    agent.id = agentId;
    agent.name_0 = agentName;
    agents[i++] = agent;
  }
  $uninventoryAllResourcesByAgent(resourceManager, agents, new AgentTableView$4$1_0(this, agents));
}
;
_.this$0 = null;
function $onSuccess_70(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0('Deleted [' + ($clinit_Enhanced() , '' + this$static.val$agents.length) + '] agents and all of their associated resources are uninventoried.\n'));
  $refresh(this$static.this$1.this$0, false);
}

function AgentTableView$4$1_0(this$1, val$agents){
  this.this$1 = this$1;
  this.val$agents = val$agents;
}

defineSeed(1809, 1, {}, AgentTableView$4$1_0);
_.onFailure = function onFailure_72(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'The request to delete the selected agents failed.'), caught);
  $refresh(this.this$1.this$0, false);
}
;
_.onSuccess_0 = function onSuccess_72(result){
  $onSuccess_70(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$agents = null;
function AgentTableView$5_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1810, 1607, {}, AgentTableView$5_0);
_.executeAction = function executeAction_12(selections, actionValue){
  show_0(this.this$0.id, this.this$0);
}
;
_.this$0 = null;
function $copyValues_12(){
  throw new UnsupportedOperationException_1('FailoverListItemDatasource.copyValues(Record from)');
}

function $copyValues_13(from){
  var record;
  record = new ListGridRecord_0;
  if (!from || !from.server) {
    return record;
  }
  record = $copyValues_9(from.server);
  $setAttribute_3(record, ($clinit_ServerDatasourceField() , FIELD_ORDINAL).propertyName, from.ordinal);
  return record;
}

function $executeFetch_5(this$static, request, response){
  var pc;
  pc = $getPageControl_0(this$static.serverDatasource, request);
  $getFailoverListDetailsByAgentId(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), this$static.agentId, pc, new FailoverListItemDatasource$1_0(this$static, response, request));
}

function FailoverListItemDatasource_0(agentId){
  $clinit_RPCDataSource();
  var fields;
  AbstractServerNodeDatasource_0.call(this);
  this.agentId = agentId;
  this.serverDatasource = new ServerDatasource_0(null);
  fields = $addDataSourceFields();
  $addFields(this, fields);
}

defineSeed(1811, 1759, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractServerNodeDatasource]), FailoverListItemDatasource_0);
_.copyValues = function copyValues_18(from){
  return $copyValues_12();
}
;
_.copyValues_0 = function copyValues_19(from){
  return $copyValues_13(dynamicCast(from, Q$FailoverListDetails));
}
;
_.executeFetch = function executeFetch_11(request, response, criteria){
  $executeFetch_5(this, request, response, dynamicCast(criteria, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_7(request){
  return null;
}
;
_.getListGridFields = function getListGridFields_0(){
  var affinityGroupIdField, fields, idField, lastUpdateTimeField;
  fields = new ArrayList_0;
  idField = $getListGridField_5(($clinit_ServerDatasourceField() , FIELD_ID_2));
  idField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, idField);
  $add_3(fields, $getListGridField_6(FIELD_ORDINAL, '55'));
  $add_3(fields, $getListGridField_6(FIELD_NAME_1, '*'));
  $add_3(fields, $getListGridField_6(FIELD_OPERATION_MODE, '90'));
  $add_3(fields, $getListGridField_6(FIELD_ADDRESS_0, '120'));
  $add_3(fields, $getListGridField_6(FIELD_PORT_0, '90'));
  $add_3(fields, $getListGridField_6(FIELD_SECURE_PORT, '75'));
  lastUpdateTimeField = $getListGridField_6(FIELD_MTIME, '110');
  $clinit_TimestampCellFormatter();
  prepareDateField(lastUpdateTimeField, getAttribute(lastUpdateTimeField.jsObj, 'name'));
  setCheck(fields.array, fields.size_0++, lastUpdateTimeField);
  $add_3(fields, $getListGridField_6(FIELD_AFFINITY_GROUP_0, '80'));
  affinityGroupIdField = $getListGridField_5(FIELD_AFFINITY_GROUP_ID_0);
  affinityGroupIdField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, affinityGroupIdField);
  return fields;
}
;
_.getPageControl = function getPageControl_2(request){
  return $getPageControl_0(this.serverDatasource, request);
}
;
_.agentId = 0;
_.serverDatasource = null;
function $onFailure_3(this$static, t){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Unable to fetch fail over list details.'), t);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_71(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_1()));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function FailoverListItemDatasource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1812, 1, {}, FailoverListItemDatasource$1_0);
_.onFailure = function onFailure_73(t){
  $onFailure_3(this, t);
}
;
_.onSuccess_0 = function onSuccess_73(result){
  $onSuccess_71(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $copyValues_14(){
  throw new UnsupportedOperationException_1('PartitionEventDatasource.copyValues(Record from)');
}

function $copyValues_15(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, ($clinit_PartitionEventDatasourceField() , FIELD_ID_1).propertyName, from.id);
  $setAttribute_4(record, FIELD_CTIME.propertyName, from.ctime);
  $setAttribute_12(record, FIELD_EVENT_TYPE.propertyName, !from.eventType?'':from.eventType);
  $setAttribute_13(record, FIELD_EVENT_DETAIL.propertyName, from.eventDetail == null?'':from.eventDetail);
  $setAttribute_13(record, FIELD_SUBJECT_NAME.propertyName, from.subjectName == null?'':from.subjectName);
  $setAttribute_12(record, FIELD_EXECUTION_STATUS.propertyName, !from.executionStatus?'':from.executionStatus);
  return record;
}

function $executeFetch_6(this$static, request, response, criteria){
  if (!criteria) {
    $setTotalRows(response, valueOf_44(0));
    $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
    return;
  }
  $findPartitionEventsByCriteria(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), criteria, new PartitionEventDatasource$1_0(this$static, response, request));
}

function $getFetchCriteria_1(request){
  var criteria, statusesFilter, typesFilter;
  statusesFilter = dynamicCast(getArrayFilter($getCriteria(request), 'executionStatus', Lorg_rhq_core_domain_cloud_PartitionEvent$ExecutionStatus_2_classLit), Q$PartitionEvent$ExecutionStatus_$1);
  typesFilter = dynamicCast(getArrayFilter($getCriteria(request), 'eventType', Lorg_rhq_core_domain_cloud_PartitionEventType_2_classLit), Q$PartitionEventType_$1);
  if (statusesFilter == null || statusesFilter.length == 0 || typesFilter == null || typesFilter.length == 0) {
    return null;
  }
  criteria = new PartitionEventCriteria_0;
  $addFilterId(criteria, dynamicCast(getFilter_0(request, ($clinit_PartitionEventDatasourceField() , FIELD_ID_1).propertyName, Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterEventDetail(criteria, dynamicCast(getFilter_0(request, FIELD_EVENT_DETAIL.propertyName, Ljava_lang_String_2_classLit), Q$String));
  statusesFilter != null && statusesFilter.length > 0 && (criteria.filterExecutionStatus = new Arrays$ArrayList_0(statusesFilter));
  typesFilter != null && typesFilter.length > 0 && (criteria.filterEventType = new Arrays$ArrayList_0(typesFilter));
  debug(' *** PartitionEventCriteria Search String: ' + dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String));
  $setSearchExpression(criteria, dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String));
  return criteria;
}

function $getListGridFields_4(){
  var executionTimeField, fields, idField;
  fields = new ArrayList_0;
  idField = $getListGridField_3(($clinit_PartitionEventDatasourceField() , FIELD_ID_1));
  idField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, idField);
  executionTimeField = $getListGridField_4(FIELD_CTIME, '125');
  $clinit_TimestampCellFormatter();
  prepareDateField(executionTimeField, getAttribute(executionTimeField.jsObj, 'name'));
  setCheck(fields.array, fields.size_0++, executionTimeField);
  $add_3(fields, $getListGridField_4(FIELD_EVENT_TYPE, '215'));
  $add_3(fields, $getListGridField_4(FIELD_EVENT_DETAIL, '*'));
  $add_3(fields, $getListGridField_4(FIELD_SUBJECT_NAME, '100'));
  $add_3(fields, $getListGridField_4(FIELD_EXECUTION_STATUS, '100'));
  return fields;
}

function PartitionEventDatasource_0(){
  var fields_0, idField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  fields = (fields_0 = new ArrayList_0 , idField = new DataSourceIntegerField_2(($clinit_PartitionEventDatasourceField() , FIELD_ID_1).propertyName, FIELD_ID_1.title_0, 50) , $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setAttribute_8(idField, 'hidden', TRUE) , setCheck(fields_0.array, fields_0.size_0++, idField) , fields_0);
  $addFields(this, fields);
}

defineSeed(1813, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$PartitionEventDatasource]), PartitionEventDatasource_0);
_.copyValues = function copyValues_20(from){
  return $copyValues_14();
}
;
_.copyValues_0 = function copyValues_21(from){
  return $copyValues_15(dynamicCast(from, Q$PartitionEvent));
}
;
_.executeFetch = function executeFetch_12(request, response, criteria){
  $executeFetch_6(this, request, response, dynamicCast(criteria, Q$PartitionEventCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_8(request){
  return $getFetchCriteria_1(request);
}
;
function $onSuccess_72(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function PartitionEventDatasource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1814, 1, {}, PartitionEventDatasource$1_0);
_.onFailure = function onFailure_74(t){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Unable to fetch partition events.'), t);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_74(result){
  $onSuccess_72(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $clinit_PartitionEventDatasourceField(){
  $clinit_PartitionEventDatasourceField = nullMethod;
  FIELD_ID_1 = new PartitionEventDatasourceField_0('FIELD_ID', 0, 'id', ($clinit_CoreGUI() , 'ID'));
  FIELD_CTIME = new PartitionEventDatasourceField_0('FIELD_CTIME', 1, 'ctime', 'Execution Time');
  FIELD_EVENT_TYPE = new PartitionEventDatasourceField_0('FIELD_EVENT_TYPE', 2, 'eventType', 'Type');
  FIELD_EVENT_DETAIL = new PartitionEventDatasourceField_0('FIELD_EVENT_DETAIL', 3, 'eventDetail', 'Details');
  FIELD_SUBJECT_NAME = new PartitionEventDatasourceField_0('FIELD_SUBJECT_NAME', 4, 'subjectName', 'Initiated By');
  FIELD_EXECUTION_STATUS = new PartitionEventDatasourceField_0('FIELD_EXECUTION_STATUS', 5, 'executionStatus', 'Execution Status');
  $VALUES_120 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventDatasourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$PartitionEventDatasourceField, [FIELD_ID_1, FIELD_CTIME, FIELD_EVENT_TYPE, FIELD_EVENT_DETAIL, FIELD_SUBJECT_NAME, FIELD_EXECUTION_STATUS]);
}

function $getListGridField_3(this$static){
  return new ListGridField_3(this$static.propertyName, this$static.title_0);
}

function $getListGridField_4(this$static, width){
  var field;
  field = new ListGridField_3(this$static.propertyName, this$static.title_0);
  field.jsObj['width'] = width;
  return field;
}

function PartitionEventDatasourceField_0(enum$name, enum$ordinal, propertyName, title){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.propertyName = propertyName;
  this.title_0 = title;
}

function valueOf_129(name_0){
  $clinit_PartitionEventDatasourceField();
  return valueOf(($clinit_PartitionEventDatasourceField$Map() , $MAP_120), name_0);
}

function values_123(){
  $clinit_PartitionEventDatasourceField();
  return $VALUES_120;
}

defineSeed(1815, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$PartitionEventDatasourceField]), PartitionEventDatasourceField_0);
_.propertyName = null;
_.title_0 = null;
var $VALUES_120, FIELD_CTIME, FIELD_EVENT_DETAIL, FIELD_EVENT_TYPE, FIELD_EXECUTION_STATUS, FIELD_ID_1, FIELD_SUBJECT_NAME;
function $clinit_PartitionEventDatasourceField$Map(){
  $clinit_PartitionEventDatasourceField$Map = nullMethod;
  $MAP_120 = createValueOfMap(($clinit_PartitionEventDatasourceField() , $VALUES_120));
}

var $MAP_120;
function $prepareAssignmentsSection(this$static, eventDetails){
  var agentName, assignments, i, nothing, records, section, serverName;
  section = new SectionStackSection_1(($clinit_Enhanced() , 'Agent Assignments'));
  $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  if (!eventDetails || eventDetails.size_0 == 0) {
    nothing = new Label_4('No agents were reassigned as a result of this partition event');
    $setMargin(nothing, valueOf_44(10));
    $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [nothing]));
  }
   else {
    assignments = new ListGrid_0;
    agentName = new ListGridField_3('agentName', 'Agent Name');
    serverName = new ListGridField_3('serverName', 'Server Name');
    $isCreated_1(assignments)?$setProperty_2(assignments, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [agentName, serverName]))):(assignments.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [agentName, serverName])) , undefined);
    records = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, eventDetails.size_0, 0);
    for (i = 0; i < eventDetails.size_0; ++i) {
      setCheck(records, i, new ListGridRecord_0);
      $setAttribute_13(records[i], 'agentName', dynamicCast((checkIndex(i, eventDetails.size_0) , eventDetails.array[i]), Q$PartitionEventDetails).agentName);
      $setAttribute_13(records[i], 'serverName', dynamicCast((checkIndex(i, eventDetails.size_0) , eventDetails.array[i]), Q$PartitionEventDetails).serverName);
    }
    $isCreated_1(assignments)?$setProperty_2(assignments, 'data', convertToJavaScriptArray(records)):(assignments.config_0['data'] = convertToJavaScriptArray(records) , undefined);
    $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [assignments]));
  }
  this$static.agentSection = section;
  ++this$static.initSectionCount;
}

function $prepareDetailsSection_3(this$static, partitionEvent){
  var addressItem, ctimeItem, eventDetailItem, execStatusItem, form, section, subjectPortItem;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 2):(form.config_0['numCols'] = 2 , undefined);
  ctimeItem = new StaticTextItem_2(($clinit_PartitionEventDatasourceField() , FIELD_CTIME).propertyName, ($clinit_Enhanced() , 'Event Execution Time'));
  $setValue_7(ctimeItem, format_30(valueOf_45(partitionEvent.ctime), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_LONG)));
  addressItem = new StaticTextItem_2(FIELD_EVENT_TYPE.propertyName, 'Event Type');
  $setValue_6(addressItem, partitionEvent.eventType);
  eventDetailItem = new StaticTextItem_2(FIELD_EVENT_DETAIL.propertyName, 'Event Details');
  $setValue_7(eventDetailItem, partitionEvent.eventDetail);
  subjectPortItem = new StaticTextItem_2(FIELD_SUBJECT_NAME.propertyName, FIELD_SUBJECT_NAME.title_0);
  $setValue_7(subjectPortItem, partitionEvent.subjectName);
  execStatusItem = new StaticTextItem_2(FIELD_EXECUTION_STATUS.propertyName, FIELD_EXECUTION_STATUS.title_0);
  $setValue_6(execStatusItem, partitionEvent.executionStatus);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [ctimeItem, addressItem, eventDetailItem, subjectPortItem, execStatusItem]));
  section = new SectionStackSection_1('Details');
  $setExpanded(section, TRUE);
  $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form]));
  this$static.detailsSection = section;
  ++this$static.initSectionCount;
}

function PartitionEventDetailView_0(partitionEventId){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.partitionEventId = partitionEventId;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  this.sectionStack = new SectionStack_0;
  $setAttribute_24(this.sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
  $setAttribute_24(this.sectionStack, 'width', '100%', true);
  $setAttribute_24(this.sectionStack, 'height', '100%', true);
  $setMargin(this.sectionStack, valueOf_44(5));
  $setAttribute_24(this.sectionStack, 'overflow', VISIBLE.value_0, false);
}

defineSeed(1817, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), PartitionEventDetailView_0);
_.onDraw_0 = function onDraw_11(){
  $run_5(new PartitionEventDetailView$2_0(this));
}
;
_.onInit = function onInit_15(){
  var criteria, service;
  $onInit(this);
  $onInit_Layout(this);
  criteria = new PartitionEventCriteria_0;
  $addFilterId(criteria, valueOf_44(this.partitionEventId));
  service = dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync);
  $findPartitionEventsByCriteria(service, criteria, new PartitionEventDetailView$1_0(this, service));
}
;
_.renderView = function renderView_6(viewPath){
  $clinit_Log();
  $fine_0(logger_0, 'PartitionEventDetailView: ' + viewPath);
}
;
_.agentSection = null;
_.detailsSection = null;
_.initSectionCount = 0;
_.partitionEventId = 0;
_.sectionStack = null;
function $onSuccess_73(this$static, events){
  if (!events || events.size_0 != 1) {
    $handleError_0(($clinit_CoreGUI() , 'Unable to fetch partition event details for event with id ' + ($clinit_Enhanced() , '' + this$static.this$0.partitionEventId) + '.'), null);
    this$static.this$0.initSectionCount = 2;
    return;
  }
  $prepareDetailsSection_3(this$static.this$0, dynamicCast((checkIndex(0, events.size_0) , events.array[0]), Q$PartitionEvent));
  $getPartitionEventDetails(this$static.val$service, this$static.this$0.partitionEventId, new PageControl_1(0, -1), new PartitionEventDetailView$1$1_0(this$static));
}

function PartitionEventDetailView$1_0(this$0, val$service){
  this.this$0 = this$0;
  this.val$service = val$service;
}

defineSeed(1818, 1, {}, PartitionEventDetailView$1_0);
_.onFailure = function onFailure_75(caught){
  $handleError_0(($clinit_CoreGUI() , 'Unable to fetch partition event details for event with id ' + ($clinit_Enhanced() , '' + this.this$0.partitionEventId) + '.'), null);
  this.this$0.initSectionCount = 2;
}
;
_.onSuccess_0 = function onSuccess_75(events){
  $onSuccess_73(this, dynamicCast(events, Q$PageList));
}
;
_.this$0 = null;
_.val$service = null;
function $onSuccess_74(this$static, result){
  $prepareAssignmentsSection(this$static.this$1.this$0, result);
}

function PartitionEventDetailView$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1819, 1, {}, PartitionEventDetailView$1$1_0);
_.onFailure = function onFailure_76(caught){
  $handleError_0(($clinit_CoreGUI() , 'Unable to fetch partition event details for event with id ' + ($clinit_Enhanced() , '' + this.this$1.this$0.partitionEventId) + '.'), null);
  this.this$1.this$0.initSectionCount = 2;
}
;
_.onSuccess_0 = function onSuccess_76(result){
  $onSuccess_74(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
function $run_5(this$static){
  var elapsedMillis;
  if (this$static.this$0.initSectionCount >= 2) {
    !!this$static.this$0.detailsSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.detailsSection);
    !!this$static.this$0.agentSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.agentSection);
    $addMember(this$static.this$0, this$static.this$0.sectionStack);
    $markForRedraw(this$static.this$0);
  }
   else {
    elapsedMillis = sub(fromDouble(currentTimeMillis0()), this$static.startTime);
    gt(elapsedMillis, P4e20_longLit) && (this$static.this$0.initSectionCount = 2);
    $schedule(this$static, 100);
  }
}

function PartitionEventDetailView$2_0(this$0){
  $clinit_Timer();
  this.this$0 = this$0;
  this.startTime = fromDouble(currentTimeMillis0());
}

defineSeed(1820, 73, makeCastMap([Q$Timer]), PartitionEventDetailView$2_0);
_.run = function run_9(){
  $run_5(this);
}
;
_.this$0 = null;
function $clinit_PartitionEventTableView(){
  $clinit_PartitionEventTableView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_12 = new ViewName_2('PartitionEvents', ($clinit_Enhanced() , 'Partition Events'), ($clinit_IconEnum() , EVENTS));
  VIEW_PATH_2 = ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_TOPOLOGY_VIEW_ID + '/' + VIEW_ID_12;
  INITIAL_CRITERIA = new Criteria_0;
  DEFAULT_SORT_SPECIFIER = new SortSpecifier_0('ctime', ($clinit_SortDirection() , DESCENDING));
}

function $addTableAction_0(this$static, action){
  $addTableAction(this$static, action.title_0, null, null, new PartitionEventTableView$2_0(this$static, this$static, action.enablement, initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , MANAGE_SETTINGS)]), action));
}

function $getSelectedEventTypes(selections){
  var ids, selection, selection$index, selection$max;
  if (selections == null) {
    return new ArrayList_1(0);
  }
  ids = new ArrayList_1(selections.length);
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    $add_3(ids, $getAttributeAsString(selection, ($clinit_PartitionEventDatasourceField() , FIELD_EVENT_TYPE).propertyName));
  }
  return ids;
}

function $getSelectedIds_2(selections){
  var i, ids, selection, selection$index, selection$max;
  if (selections == null) {
    return initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, 0, 1);
  }
  ids = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selections.length, 1);
  i = 0;
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    ids[i++] = getAttributeAsInt(selection.jsObj, 'id').value_0;
  }
  return ids;
}

function PartitionEventTableView_0(tableTitle){
  $clinit_PartitionEventTableView();
  TableSection_2.call(this, tableTitle, INITIAL_CRITERIA, initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [DEFAULT_SORT_SPECIFIER]));
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  this.initialCriteriaFixed = false;
  $setDataSource(this, new PartitionEventDatasource_0);
}

defineSeed(1821, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), PartitionEventTableView_0);
_.configureTable = function configureTable_8(){
  var field, field$iterator, fields, listGrid;
  $configureTable(this);
  fields = $getListGridFields_4(dynamicCast(this.dataSource_1, Q$PartitionEventDatasource));
  listGrid = this.listGrid;
  $setFields_1(listGrid, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $addTableAction_0(this, ($clinit_PartitionEventTableView$TableAction() , REMOVE_SELECTED));
  $addTableAction_0(this, PURGE_ALL);
  $addTableAction_0(this, FORCE_REPARTITION);
  for (field$iterator = new AbstractList$IteratorImpl_0(fields); field$iterator.i < field$iterator.this$0_0.size_1();) {
    field = dynamicCast($next_0(field$iterator), Q$ListGridField);
    getAttribute(field.jsObj, 'name') == ($clinit_PartitionEventDatasourceField() , FIELD_EVENT_TYPE).propertyName && $setCellFormatter_0(field, new PartitionEventTableView$1_0(this));
  }
}
;
_.configureTableFilters = function configureTableFilters_0(){
  var detail, statusFilter, typeFilter;
  statusFilter = new EnumSelectItem_0('executionStatus', ($clinit_Enhanced() , 'Execution Status Filter'), Lorg_rhq_core_domain_cloud_PartitionEvent$ExecutionStatus_2_classLit, null, null);
  typeFilter = new EnumSelectItem_0('eventType', 'Type Filter', Lorg_rhq_core_domain_cloud_PartitionEventType_2_classLit, null, null);
  detail = new TextItem_3('eventDetail', 'Details Filter');
  this.showFilterForm && $setFilterFormItems(this, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [statusFilter, detail, typeFilter]));
}
;
_.getDetailsView_0 = function getDetailsView_5(id){
  return new PartitionEventDetailView_0(id.value_0);
}
;
_.getViewName = function getViewName_2(){
  return VIEW_ID_12;
}
;
var DEFAULT_SORT_SPECIFIER, INITIAL_CRITERIA, VIEW_ID_12, VIEW_PATH_2;
function PartitionEventTableView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1822, 1, {}, PartitionEventTableView$1_0);
_.format_1 = function format_5(value, record, rowNum, colNum){
  var detailsUrl, formattedValue;
  if (value == null) {
    return '';
  }
  detailsUrl = '#' + ($clinit_PartitionEventTableView() , VIEW_PATH_2) + '/' + $getId(this.this$0, record);
  formattedValue = escapeHtml(toString__devirtual$(value));
  return getHref(detailsUrl, formattedValue);
}
;
_.this$0 = null;
function PartitionEventTableView$2_0(this$0, $anonymous0, $anonymous1, $anonymous2, val$action){
  this.this$0 = this$0;
  this.val$action = val$action;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1823, 1607, {}, PartitionEventTableView$2_0);
_.executeAction = function executeAction_13(selections, actionValue){
  var eventTypes, message;
  eventTypes = $getSelectedEventTypes(selections).toString$();
  switch (this.val$action.ordinal) {
    case 0:
      message = 'Do you really want to remove following partition events ' + ($clinit_Enhanced() , eventTypes) + '?';
      break;
    case 1:
      message = ($clinit_Enhanced() , 'Do you really want to purge all partition events?');
      break;
    case 2:
      message = ($clinit_Enhanced() , 'Do you really want to force a repartition of whole cluster? It will force all the agents to connect to its most preferred server.');
      break;
    default:throw new IllegalArgumentException_1('unknown table action type');
  }
  ask(message, new PartitionEventTableView$2$1_0(this, selections, this.val$action));
}
;
_.this$0 = null;
_.val$action = null;
function PartitionEventTableView$2$1_0(this$1, val$selections, val$action){
  this.this$1 = this$1;
  this.val$selections = val$selections;
  this.val$action = val$action;
}

defineSeed(1824, 1, {}, PartitionEventTableView$2$1_0);
_.execute_3 = function execute_17(confirmed){
  var callback, selectedIds;
  if (confirmed.value_0) {
    selectedIds = $getSelectedIds_2(this.val$selections);
    callback = new PartitionEventTableView$2$1$1_0(this, this.val$action, this.val$selections);
    switch (this.val$action.ordinal) {
      case 0:
        $deletePartitionEvents(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), selectedIds, callback);
        break;
      case 1:
        $purgeAllEvents(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), callback);
        break;
      case 2:
        $cloudPartitionEventRequest(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), callback);
    }
  }
   else {
    $refreshTableInfo(this.this$1.this$0);
  }
}
;
_.this$1 = null;
_.val$action = null;
_.val$selections = null;
function $onFailure_4(this$static, caught){
  var msgString;
  msgString = null;
  switch (this$static.val$action.ordinal) {
    case 0:
      msgString = 'Unable to remove ' + ($clinit_Enhanced() , '' + this$static.val$selections.length) + ' partition events(s).';
      break;
    case 1:
      msgString = ($clinit_Enhanced() , 'Unable to purge all partition events.');
      break;
    case 2:
      msgString = ($clinit_Enhanced() , 'Unable to run repartition.');
  }
  $handleError_0(($clinit_CoreGUI() , msgString + ' ' + caught.getMessage()), caught);
  $refreshTableInfo(this$static.this$2.this$1.this$0);
}

function $onSuccess_75(this$static){
  var msg, msgString;
  msgString = null;
  switch (this$static.val$action.ordinal) {
    case 0:
      msgString = 'Removed ' + ($clinit_Enhanced() , '' + this$static.val$selections.length) + ' partition events(s).';
      break;
    case 1:
      msgString = ($clinit_Enhanced() , 'All partition events have been purged.');
      break;
    case 2:
      msgString = ($clinit_Enhanced() , 'The cluster repartitioning was successfully invoked.');
  }
  msg = new Message_7(msgString, ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$2.this$1.this$0, false);
}

function PartitionEventTableView$2$1$1_0(this$2, val$action, val$selections){
  this.this$2 = this$2;
  this.val$action = val$action;
  this.val$selections = val$selections;
}

defineSeed(1825, 1, {}, PartitionEventTableView$2$1$1_0);
_.onFailure = function onFailure_77(caught){
  $onFailure_4(this, caught);
}
;
_.onSuccess_0 = function onSuccess_77(arg0){
  $onSuccess_75(this, throwClassCastExceptionUnlessNull(arg0));
}
;
_.this$2 = null;
_.val$action = null;
_.val$selections = null;
function $clinit_PartitionEventTableView$TableAction(){
  $clinit_PartitionEventTableView$TableAction = nullMethod;
  REMOVE_SELECTED = new PartitionEventTableView$TableAction_0('REMOVE_SELECTED', 0, ($clinit_Enhanced() , 'Remove Selected'), ($clinit_TableActionEnablement() , ANY_1));
  PURGE_ALL = new PartitionEventTableView$TableAction_0('PURGE_ALL', 1, 'Purge All', ALWAYS);
  FORCE_REPARTITION = new PartitionEventTableView$TableAction_0('FORCE_REPARTITION', 2, 'Force Repartition', ALWAYS);
  $VALUES_121 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventTableView$TableAction_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$PartitionEventTableView$TableAction, [REMOVE_SELECTED, PURGE_ALL, FORCE_REPARTITION]);
}

function PartitionEventTableView$TableAction_0(enum$name, enum$ordinal, title, enablement){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.title_0 = title;
  this.enablement = enablement;
}

function valueOf_130(name_0){
  $clinit_PartitionEventTableView$TableAction();
  return valueOf(($clinit_PartitionEventTableView$TableAction$Map() , $MAP_121), name_0);
}

function values_124(){
  $clinit_PartitionEventTableView$TableAction();
  return $VALUES_121;
}

defineSeed(1826, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$PartitionEventTableView$TableAction]), PartitionEventTableView$TableAction_0);
_.enablement = null;
_.title_0 = null;
var $VALUES_121, FORCE_REPARTITION, PURGE_ALL, REMOVE_SELECTED;
function $clinit_PartitionEventTableView$TableAction$Map(){
  $clinit_PartitionEventTableView$TableAction$Map = nullMethod;
  $MAP_121 = createValueOfMap(($clinit_PartitionEventTableView$TableAction() , $VALUES_121));
}

var $MAP_121;
function $onSuccess_76(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ServerDatasource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1828, 1, {}, ServerDatasource$1_0);
_.onFailure = function onFailure_78(t){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Unable to fetch servers.'), t);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_78(result){
  $onSuccess_76(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $clinit_ServerDatasourceField(){
  $clinit_ServerDatasourceField = nullMethod;
  FIELD_ID_2 = new ServerDatasourceField_0('FIELD_ID', 0, 'id', ($clinit_CoreGUI() , 'ID'));
  FIELD_ORDINAL = new ServerDatasourceField_0('FIELD_ORDINAL', 1, 'ordinal', 'Order');
  FIELD_NAME_1 = new ServerDatasourceField_0('FIELD_NAME', 2, 'name', 'Name');
  FIELD_OPERATION_MODE = new ServerDatasourceField_0('FIELD_OPERATION_MODE', 3, 'operationMode', 'Mode');
  FIELD_ADDRESS_0 = new ServerDatasourceField_0('FIELD_ADDRESS', 4, 'address', 'Endpoint Address');
  FIELD_PORT_0 = new ServerDatasourceField_0('FIELD_PORT', 5, 'port', 'Nonsecure Port');
  FIELD_SECURE_PORT = new ServerDatasourceField_0('FIELD_SECURE_PORT', 6, 'securePort', 'Secure Port');
  FIELD_CTIME_0 = new ServerDatasourceField_0('FIELD_CTIME', 7, 'ctime', 'Installation Date');
  FIELD_MTIME = new ServerDatasourceField_0('FIELD_MTIME', 8, 'mtime', 'Last Update Time');
  FIELD_AFFINITY_GROUP_0 = new ServerDatasourceField_0('FIELD_AFFINITY_GROUP', 9, 'affinityGroup', 'Affinity Group');
  FIELD_AFFINITY_GROUP_ID_0 = new ServerDatasourceField_0('FIELD_AFFINITY_GROUP_ID', 10, 'affinityGroupId', 'affinityGroupId');
  FIELD_AGENT_COUNT_0 = new ServerDatasourceField_0('FIELD_AGENT_COUNT', 11, 'agentCount', 'Agent Count');
  $VALUES_122 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDatasourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ServerDatasourceField, [FIELD_ID_2, FIELD_ORDINAL, FIELD_NAME_1, FIELD_OPERATION_MODE, FIELD_ADDRESS_0, FIELD_PORT_0, FIELD_SECURE_PORT, FIELD_CTIME_0, FIELD_MTIME, FIELD_AFFINITY_GROUP_0, FIELD_AFFINITY_GROUP_ID_0, FIELD_AGENT_COUNT_0]);
}

function $getListGridField_5(this$static){
  return new ListGridField_3(this$static.propertyName, this$static.title_0);
}

function $getListGridField_6(this$static, width){
  var field;
  field = new ListGridField_3(this$static.propertyName, this$static.title_0);
  field.jsObj['width'] = width;
  return field;
}

function ServerDatasourceField_0(enum$name, enum$ordinal, propertyName, title){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.propertyName = propertyName;
  this.title_0 = title;
}

function valueOf_131(name_0){
  $clinit_ServerDatasourceField();
  return valueOf(($clinit_ServerDatasourceField$Map() , $MAP_122), name_0);
}

function values_125(){
  $clinit_ServerDatasourceField();
  return $VALUES_122;
}

defineSeed(1829, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$ServerDatasourceField]), ServerDatasourceField_0);
_.propertyName = null;
_.title_0 = null;
var $VALUES_122, FIELD_ADDRESS_0, FIELD_AFFINITY_GROUP_0, FIELD_AFFINITY_GROUP_ID_0, FIELD_AGENT_COUNT_0, FIELD_CTIME_0, FIELD_ID_2, FIELD_MTIME, FIELD_NAME_1, FIELD_OPERATION_MODE, FIELD_ORDINAL, FIELD_PORT_0, FIELD_SECURE_PORT;
function $clinit_ServerDatasourceField$Map(){
  $clinit_ServerDatasourceField$Map = nullMethod;
  $MAP_122 = createValueOfMap(($clinit_ServerDatasourceField() , $VALUES_122));
}

var $MAP_122;
function $prepareAgentSection(this$static){
  var agentsTable, section;
  section = new SectionStackSection_1(($clinit_Enhanced() , 'Connected Agents'));
  $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  agentsTable = new AgentTableView_0(valueOf_44(this$static.serverId), false);
  $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [agentsTable]));
  this$static.agentSection = section;
  ++this$static.initSectionCount;
  return;
}

function $prepareDetailsSection_4(this$static, server){
  var addressItem, affinityGroupItem, affinityGroupItemText, ag, detailsUrl, footer, form, formattedValue, installationDateItem, lastUpdatetem, nameItem, operationModeItem, portItem, portValidator, saveButton, section, securePortItem;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 2):(form.config_0['numCols'] = 2 , undefined);
  nameItem = new StaticTextItem_2(($clinit_ServerDatasourceField() , FIELD_NAME_1).propertyName, FIELD_NAME_1.title_0);
  $setValue_7(nameItem, '<b>' + server.name_0 + '<\/b>');
  addressItem = new TextItem_3(FIELD_ADDRESS_0.propertyName, FIELD_ADDRESS_0.title_0);
  $setRequired(addressItem, TRUE);
  $setValue_7(addressItem, server.address);
  portValidator = new IntegerRangeValidator_0;
  portValidator.jsObj['min'] = 0;
  portValidator.jsObj['max'] = 65535;
  portItem = new TextItem_3(FIELD_PORT_0.propertyName, FIELD_PORT_0.title_0);
  $setRequired(portItem, TRUE);
  $isCreated_2(portItem)?$setProperty_7(portItem, 'validators', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [portValidator]))):(portItem.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [portValidator])) , undefined);
  $setValue_5(portItem, server.port);
  securePortItem = new TextItem_3(FIELD_SECURE_PORT.propertyName, FIELD_SECURE_PORT.title_0);
  $setRequired(securePortItem, TRUE);
  $isCreated_2(securePortItem)?$setProperty_7(securePortItem, 'validators', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [portValidator]))):(securePortItem.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [portValidator])) , undefined);
  $setValue_5(securePortItem, server.securePort);
  operationModeItem = new SelectItem_2(FIELD_OPERATION_MODE.propertyName, ($clinit_Enhanced() , 'Operation Mode'));
  operationModeItem.setValueMap_1(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['NORMAL', 'MAINTENANCE']));
  $setValue_6(operationModeItem, server.operationMode);
  affinityGroupItem = new StaticTextItem_2(($clinit_AgentDatasourceField() , FIELD_AFFINITY_GROUP).propertyName, FIELD_AFFINITY_GROUP.title_0);
  affinityGroupItemText = '';
  ag = server.affinityGroup;
  if (!!ag && ag.name_0 != null && !!ag.name_0.length) {
    detailsUrl = '#' + ($clinit_AffinityGroupTableView() , VIEW_PATH_0) + '/' + ag.id;
    formattedValue = escapeHtml(ag.name_0);
    affinityGroupItemText = getHref(detailsUrl, formattedValue);
  }
  $setValue_7(affinityGroupItem, affinityGroupItemText);
  installationDateItem = new StaticTextItem_2(FIELD_CTIME_0.propertyName, FIELD_CTIME_0.title_0);
  $setValue_7(installationDateItem, format_30(valueOf_45(server.ctime), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_LONG)));
  lastUpdatetem = new StaticTextItem_2(FIELD_MTIME.propertyName, FIELD_MTIME.title_0);
  $setValue_7(lastUpdatetem, format_30(valueOf_45(server.mtime), DATE_TIME_FORMAT_LONG));
  saveButton = new IButton_0;
  $setAttribute_24(saveButton, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, true);
  $setTitle_0(saveButton, 'Save');
  $addClickHandler(saveButton, new ServerDetailView$3_0(form, server, addressItem, portItem, securePortItem, operationModeItem));
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [nameItem, addressItem, portItem, securePortItem, operationModeItem, affinityGroupItem, installationDateItem, lastUpdatetem]));
  footer = new EnhancedToolStrip_0;
  $setPadding(footer, valueOf_44(5));
  $isCreated_1(footer)?$setProperty_3(footer, 'width', '100%'):(footer.config_0['width'] = '100%' , undefined);
  $isCreated_1(footer)?$setProperty_0(footer, 'membersMargin', 15):(footer.config_0['membersMargin'] = 15 , undefined);
  $addMember(footer, saveButton);
  section = new SectionStackSection_1('Details');
  $setExpanded(section, TRUE);
  $setItems(section, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [form, footer]));
  this$static.detailsSection = section;
  ++this$static.initSectionCount;
}

function ServerDetailView_0(serverId){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.serverId = serverId;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  this.sectionStack = new SectionStack_0;
  $setAttribute_24(this.sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
  $setAttribute_24(this.sectionStack, 'width', '100%', true);
  $setAttribute_24(this.sectionStack, 'height', '100%', true);
  $setMargin(this.sectionStack, valueOf_44(5));
  $setAttribute_24(this.sectionStack, 'overflow', VISIBLE.value_0, false);
}

defineSeed(1831, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), ServerDetailView_0);
_.onDraw_0 = function onDraw_12(){
  $run_6(new ServerDetailView$2_0(this));
}
;
_.onInit = function onInit_16(){
  var criteria;
  $onInit(this);
  $onInit_Layout(this);
  criteria = new ServerCriteria_0;
  $addFilterId(criteria, valueOf_44(this.serverId));
  $findServersByCriteria(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), criteria, new ServerDetailView$1_0(this));
}
;
_.renderView = function renderView_7(viewPath){
  $clinit_Log();
  $fine_0(logger_0, 'ServerDetailView: ' + viewPath);
}
;
_.agentSection = null;
_.detailsSection = null;
_.initSectionCount = 0;
_.sectionStack = null;
_.serverId = 0;
function $onSuccess_77(this$static, servers){
  if (!servers || servers.size_0 == 0 || servers.size_0 != 1) {
    $handleError_0(($clinit_CoreGUI() , 'Unable to fetch server details for server with id ' + ($clinit_Enhanced() , '' + this$static.this$0.serverId) + '.'), null);
    this$static.this$0.initSectionCount = 2;
    return;
  }
  $prepareDetailsSection_4(this$static.this$0, dynamicCast((checkIndex(0, servers.size_0) , servers.array[0]), Q$Server));
  $prepareAgentSection(this$static.this$0, dynamicCast((checkIndex(0, servers.size_0) , servers.array[0]), Q$Server));
}

function ServerDetailView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1832, 1, {}, ServerDetailView$1_0);
_.onFailure = function onFailure_79(caught){
  $handleError_0(($clinit_CoreGUI() , 'Unable to fetch server details for server with id ' + ($clinit_Enhanced() , '' + this.this$0.serverId) + '. ' + caught.getMessage()), caught);
  this.this$0.initSectionCount = 2;
}
;
_.onSuccess_0 = function onSuccess_79(servers){
  $onSuccess_77(this, dynamicCast(servers, Q$PageList));
}
;
_.this$0 = null;
function $run_6(this$static){
  var elapsedMillis;
  if (this$static.this$0.initSectionCount >= 2) {
    !!this$static.this$0.detailsSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.detailsSection);
    !!this$static.this$0.agentSection && $addSection(this$static.this$0.sectionStack, this$static.this$0.agentSection);
    $addMember(this$static.this$0, this$static.this$0.sectionStack);
    $markForRedraw(this$static.this$0);
  }
   else {
    elapsedMillis = sub(fromDouble(currentTimeMillis0()), this$static.startTime);
    gt(elapsedMillis, P4e20_longLit) && (this$static.this$0.initSectionCount = 2);
    $schedule(this$static, 100);
  }
}

function ServerDetailView$2_0(this$0){
  $clinit_Timer();
  this.this$0 = this$0;
  this.startTime = fromDouble(currentTimeMillis0());
}

defineSeed(1833, 73, makeCastMap([Q$Timer]), ServerDetailView$2_0);
_.run = function run_10(){
  $run_6(this);
}
;
_.this$0 = null;
function ServerDetailView$3_0(val$form, val$server, val$addressItem, val$portItem, val$securePortItem, val$operationModeItem){
  this.val$form = val$form;
  this.val$server = val$server;
  this.val$addressItem = val$addressItem;
  this.val$portItem = val$portItem;
  this.val$securePortItem = val$securePortItem;
  this.val$operationModeItem = val$operationModeItem;
}

defineSeed(1834, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ServerDetailView$3_0);
_.onClick = function onClick_27(event_0){
  if (this.val$form.validate_0()) {
    $setAddress(this.val$server, this.val$addressItem.getValueAsString());
    $setPort(this.val$server, __parseAndValidateInt(this.val$portItem.getValueAsString()));
    $setSecurePort(this.val$server, __parseAndValidateInt(this.val$securePortItem.getValueAsString()));
    $setOperationMode(this.val$server, valueOf_66($getValueAsString_4(this.val$operationModeItem)));
    $updateServer(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), this.val$server, new ServerDetailView$3$1_0(this.val$server));
  }
}
;
_.val$addressItem = null;
_.val$form = null;
_.val$operationModeItem = null;
_.val$portItem = null;
_.val$securePortItem = null;
_.val$server = null;
function $onSuccess_78(this$static){
  var msg;
  msg = new Message_7('The server ' + ($clinit_Enhanced() , this$static.val$server.name_0) + ' was successfully updated.', ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
}

function ServerDetailView$3$1_0(val$server){
  this.val$server = val$server;
}

defineSeed(1835, 1, {}, ServerDetailView$3$1_0);
_.onFailure = function onFailure_80(caught){
  $handleError_0(($clinit_CoreGUI() , 'Unable to update server ' + ($clinit_Enhanced() , this.val$server.name_0) + '. ' + caught.getMessage()), caught);
}
;
_.onSuccess_0 = function onSuccess_80(result){
  $onSuccess_78(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$server = null;
function $clinit_ServerTableView(){
  $clinit_ServerTableView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_13 = new ViewName_2('Servers', ($clinit_Enhanced() , 'Servers'), ($clinit_IconEnum() , SERVERS));
  VIEW_PATH_3 = ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_TOPOLOGY_VIEW_ID + '/' + VIEW_ID_13;
}

function $addChangeOperationModeAction(this$static, mode, label){
  $addTableAction(this$static, label, null, null, new ServerTableView$4_0(this$static, this$static, ($clinit_TableActionEnablement() , ANY_1), initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , MANAGE_SETTINGS)]), mode));
}

function $getSelectedIds_3(selections){
  var i, ids, selection, selection$index, selection$max;
  if (selections == null) {
    return initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, 0, 1);
  }
  ids = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selections.length, 1);
  i = 0;
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    ids[i++] = getAttributeAsInt(selection.jsObj, 'id').value_0;
  }
  return ids;
}

function $getSelectedNames_2(selections){
  var ids, selection, selection$index, selection$max;
  if (selections == null) {
    return new ArrayList_1(0);
  }
  ids = new ArrayList_1(selections.length);
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    $add_3(ids, getAttribute(selection.jsObj, 'name'));
  }
  return ids;
}

function ServerTableView_0(id, isAffinityGroupId){
  $clinit_ServerTableView();
  var criteria, i, modes, value, value$array, value$index, value$max;
  TableSection_0.call(this, null);
  this.showActions = !id && !isAffinityGroupId;
  this.isAffinityGroupId = isAffinityGroupId;
  this.id = id;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  if (isAffinityGroupId) {
    $setDataSource(this, new ServerDatasource_0(id));
    criteria = new Criteria_0;
    modes = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ($clinit_Server$OperationMode() , $clinit_Server$OperationMode() , $VALUES_57).length, 0);
    i = 0;
    for (value$array = $VALUES_57 , value$index = 0 , value$max = value$array.length; value$index < value$max; ++value$index) {
      value = value$array[value$index];
      modes[i++] = value.name_0;
    }
    $addCriteria_6(criteria, ($clinit_ServerDatasource() , FILTER_OPERATION_MODE), modes);
    this.initialCriteria_0 = criteria;
  }
   else {
    $setDataSource(this, this.showActions?new ServerWithAgentCountDatasource_0:new FailoverListItemDatasource_0(id.value_0));
  }
}

defineSeed(1836, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), ServerTableView_0);
_.configureTable = function configureTable_9(){
  var field, field$iterator, fields, listGrid;
  $configureTable(this);
  fields = dynamicCast(this.dataSource_1, Q$AbstractServerNodeDatasource).getListGridFields();
  listGrid = this.listGrid;
  $setFields_1(listGrid, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  if (this.showActions) {
    $sort(listGrid, 'name', ($clinit_SortDirection() , ASCENDING));
    $addChangeOperationModeAction(this, ($clinit_Server$OperationMode() , NORMAL_1), ($clinit_Enhanced() , 'Set Normal'));
    $addChangeOperationModeAction(this, MAINTENANCE, 'Set Maintenance');
    $addTableAction(this, 'Remove Selected', null, null, new ServerTableView$3_0(this, this, ($clinit_TableActionEnablement() , ANY_1), initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , MANAGE_SETTINGS)])));
  }
   else if (this.isAffinityGroupId) {
    $sort(listGrid, 'name', ($clinit_SortDirection() , ASCENDING));
    $addTableAction(this, ($clinit_Enhanced() , 'Update Membership...'), null, null, new ServerTableView$5_0(this, this, ($clinit_TableActionEnablement() , ALWAYS), initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , MANAGE_SETTINGS)])));
  }
   else {
    $sort(listGrid, ($clinit_ServerDatasourceField() , FIELD_ORDINAL).propertyName, ($clinit_SortDirection() , ASCENDING));
  }
  for (field$iterator = new AbstractList$IteratorImpl_0(fields); field$iterator.i < field$iterator.this$0_0.size_1();) {
    field = dynamicCast($next_0(field$iterator), Q$ListGridField);
    getAttribute(field.jsObj, 'name') == 'name'?$setCellFormatter_0(field, new ServerTableView$1_0(this)):getAttribute(field.jsObj, 'name') == ($clinit_ServerDatasourceField() , FIELD_AFFINITY_GROUP_0).propertyName && $setCellFormatter_0(field, new ServerTableView$2_0);
  }
}
;
_.getBasePath = function getBasePath_1(){
  return VIEW_PATH_3;
}
;
_.getDetailsView_0 = function getDetailsView_6(id){
  return new ServerDetailView_0(id.value_0);
}
;
_.getViewName = function getViewName_3(){
  return VIEW_ID_13;
}
;
_.id = null;
_.isAffinityGroupId = false;
_.showActions = false;
var VIEW_ID_13, VIEW_PATH_3;
function ServerTableView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1837, 1, {}, ServerTableView$1_0);
_.format_1 = function format_6(value, record, rowNum, colNum){
  var detailsUrl, formattedValue;
  if (value == null) {
    return '';
  }
  detailsUrl = '#' + ($clinit_ServerTableView() , VIEW_PATH_3) + '/' + $getId(this.this$0, record);
  formattedValue = escapeHtml(toString__devirtual$(value));
  return getHref(detailsUrl, formattedValue);
}
;
_.this$0 = null;
function ServerTableView$2_0(){
}

defineSeed(1838, 1, {}, ServerTableView$2_0);
_.format_1 = function format_7(value, record, rowNum, colNum){
  var detailsUrl, formattedValue;
  if (value == null || !toString__devirtual$(value).length) {
    return '';
  }
  detailsUrl = '#' + ($clinit_AffinityGroupTableView() , VIEW_PATH_0) + '/' + $getAttributeAsString(record, ($clinit_ServerDatasourceField() , FIELD_AFFINITY_GROUP_ID_0).propertyName);
  formattedValue = escapeHtml(toString__devirtual$(value));
  return getHref(detailsUrl, formattedValue);
}
;
function ServerTableView$3_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1839, 1607, {}, ServerTableView$3_0);
_.executeAction = function executeAction_14(selections, actionValue){
  var message, selectedNames;
  selectedNames = $getSelectedNames_2(selections);
  message = 'Do you really want to remove servers ' + ($clinit_Enhanced() , selectedNames.toString$()) + '?';
  ask(message, new ServerTableView$3$1_0(this, selections));
}
;
_.this$0 = null;
function ServerTableView$3$1_0(this$1, val$selections){
  this.this$1 = this$1;
  this.val$selections = val$selections;
}

defineSeed(1840, 1, {}, ServerTableView$3$1_0);
_.execute_3 = function execute_18(confirmed){
  var selectedIds;
  if (confirmed.value_0) {
    selectedIds = $getSelectedIds_3(this.val$selections);
    $deleteServers(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), selectedIds, new ServerTableView$3$1$1_0(this, this.val$selections));
  }
}
;
_.this$1 = null;
_.val$selections = null;
function $onSuccess_79(this$static){
  var msg;
  msg = new Message_7('Removed ' + ($clinit_Enhanced() , '' + this$static.val$selections.length) + ' server(s).', ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$2.this$1.this$0, false);
}

function ServerTableView$3$1$1_0(this$2, val$selections){
  this.this$2 = this$2;
  this.val$selections = val$selections;
}

defineSeed(1841, 1, {}, ServerTableView$3$1$1_0);
_.onFailure = function onFailure_81(caught){
  $handleError_0(($clinit_CoreGUI() , 'Unable to remove ' + ($clinit_Enhanced() , '' + this.val$selections.length) + ' server(s). ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$2.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_81(arg0){
  $onSuccess_79(this, throwClassCastExceptionUnlessNull(arg0));
}
;
_.this$2 = null;
_.val$selections = null;
function ServerTableView$4_0(this$0, $anonymous0, $anonymous1, $anonymous2, val$mode){
  this.this$0 = this$0;
  this.val$mode = val$mode;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1842, 1607, {}, ServerTableView$4_0);
_.executeAction = function executeAction_15(selections, actionValue){
  var message, selectedNames;
  selectedNames = $getSelectedNames_2(selections);
  message = 'Do you really want to set servers ' + ($clinit_Enhanced() , selectedNames.toString$()) + ' to ' + this.val$mode.name_0 + ' mode?';
  ask(message, new ServerTableView$4$1_0(this, selections, this.val$mode));
}
;
_.this$0 = null;
_.val$mode = null;
function ServerTableView$4$1_0(this$1, val$selections, val$mode){
  this.this$1 = this$1;
  this.val$selections = val$selections;
  this.val$mode = val$mode;
}

defineSeed(1843, 1, {}, ServerTableView$4$1_0);
_.execute_3 = function execute_19(confirmed){
  var selectedIds;
  if (confirmed.value_0) {
    selectedIds = $getSelectedIds_3(this.val$selections);
    $updateServerMode(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), selectedIds, this.val$mode, new ServerTableView$4$1$1_0(this, this.val$selections, this.val$mode));
  }
   else {
    $refreshTableInfo(this.this$1.this$0);
  }
}
;
_.this$1 = null;
_.val$mode = null;
_.val$selections = null;
function $onSuccess_80(this$static){
  var msg;
  msg = new Message_7('Set ' + ($clinit_Enhanced() , '' + this$static.val$selections.length) + ' server(s) to ' + this$static.val$mode.name_0 + ' mode.', ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh(this$static.this$2.this$1.this$0, false);
}

function ServerTableView$4$1$1_0(this$2, val$selections, val$mode){
  this.this$2 = this$2;
  this.val$selections = val$selections;
  this.val$mode = val$mode;
}

defineSeed(1844, 1, {}, ServerTableView$4$1$1_0);
_.onFailure = function onFailure_82(caught){
  $handleError_0(($clinit_CoreGUI() , 'Unable to set ' + ($clinit_Enhanced() , '' + this.val$selections.length) + ' server(s) to ' + this.val$mode.name_0 + ' mode. ' + caught.getMessage()), caught);
  $refreshTableInfo(this.this$2.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_82(result){
  $onSuccess_80(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$2 = null;
_.val$mode = null;
_.val$selections = null;
function ServerTableView$5_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(1845, 1607, {}, ServerTableView$5_0);
_.executeAction = function executeAction_16(selections, actionValue){
  show_1(this.this$0.id, this.this$0);
}
;
_.this$0 = null;
function $copyValues_16(){
  throw new UnsupportedOperationException_1('ServerWithAgentCountDatasource.copyValues(Record from)');
}

function $copyValues_17(from){
  var record;
  record = new ListGridRecord_0;
  if (!from || !from.server) {
    return record;
  }
  record = $copyValues_9(from.server);
  $setAttribute_3(record, ($clinit_ServerDatasourceField() , FIELD_AGENT_COUNT_0).propertyName, from.agentCount);
  return record;
}

function $executeFetch_7(this$static, request, response){
  var pc;
  pc = $getPageControl_0(this$static.serverDatasource, request);
  $getServers(dynamicCast(secure(getInstance_57(), -1), Q$TopologyGWTServiceAsync), pc, new ServerWithAgentCountDatasource$2_0(this$static, response, request));
}

function ServerWithAgentCountDatasource_0(){
  $clinit_RPCDataSource();
  var fields;
  AbstractServerNodeDatasource_0.call(this);
  this.serverDatasource = new ServerDatasource_0(null);
  fields = $addDataSourceFields();
  $addFields(this, fields);
}

defineSeed(1846, 1759, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractServerNodeDatasource]), ServerWithAgentCountDatasource_0);
_.copyValues = function copyValues_22(from){
  return $copyValues_16();
}
;
_.copyValues_0 = function copyValues_23(from){
  return $copyValues_17(dynamicCast(from, Q$ServerWithAgentCountComposite));
}
;
_.executeFetch = function executeFetch_13(request, response, criteria){
  $executeFetch_7(this, request, response, dynamicCast(criteria, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_9(request){
  return null;
}
;
_.getListGridFields = function getListGridFields_1(){
  var agentCountField, fields;
  fields = $getListGridFields_2();
  agentCountField = $getListGridField_6(($clinit_ServerDatasourceField() , FIELD_AGENT_COUNT_0), '75');
  $setHoverCustomizer_0(agentCountField, new ServerWithAgentCountDatasource$1_0);
  $setAttribute_8(agentCountField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  setCheck(fields.array, fields.size_0++, agentCountField);
  return fields;
}
;
_.getPageControl = function getPageControl_3(request){
  return $getPageControl_0(this.serverDatasource, request);
}
;
_.serverDatasource = null;
function ServerWithAgentCountDatasource$1_0(){
}

defineSeed(1847, 1, {}, ServerWithAgentCountDatasource$1_0);
_.hoverHTML_0 = function hoverHTML(value, record, rowNum, colNum){
  return 'There are ' + ($clinit_RPCDataSource() , $getAttributeAsString(record, ($clinit_ServerDatasourceField() , FIELD_AGENT_COUNT_0).propertyName)) + ' agents registered to this server. This number does not correspond to the number of currently connected agents.';
}
;
function $onFailure_5(this$static, t){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Unable to fetch servers.'), t);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_81(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_1()));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ServerWithAgentCountDatasource$2_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1848, 1, {}, ServerWithAgentCountDatasource$2_0);
_.onFailure = function onFailure_83(t){
  $onFailure_5(this, t);
}
;
_.onSuccess_0 = function onSuccess_83(result){
  $onSuccess_81(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function SubjectRoleSelector_0(roleRecords, isReadOnly){
  $clinit_BaseWidget();
  AbstractSelector_1.call(this, isReadOnly);
  this.initialSelection = roleRecords;
}

defineSeed(1849, 1699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), SubjectRoleSelector_0);
_.getAvailableFilterForm = function getAvailableFilterForm_4(){
  return null;
}
;
_.getDataSource_0 = function getDataSource_6(){
  return new RolesDataSource_0;
}
;
_.getItemIcon = function getItemIcon_3(){
  return 'global/Role_16.png';
}
;
_.getItemTitle = function getItemTitle_4(){
  return $clinit_Enhanced() , 'Roles';
}
;
_.getLatestCriteria = function getLatestCriteria_4(availableFilterForm){
  return null;
}
;
_.getMaxAvailableRecords = function getMaxAvailableRecords_3(){
  return 500;
}
;
function $areRolesReadOnly(this$static, record){
  var isLdapAuthenticatedUser;
  if (!this$static.loggedInUserHasManageSecurityPermission) {
    return true;
  }
  isLdapAuthenticatedUser = ($clinit_Boolean() , $equalsIgnoreCase('true', getAttribute(record.jsObj, 'ldap'))?TRUE:FALSE).value_0;
  return this$static.recordId == 2 || isLdapAuthenticatedUser && this$static.ldapAuthorizationEnabled;
}

function UserEditView_0(subjectId){
  $clinit_AbstractRecordEditor();
  AbstractRecordEditor_0.call(this, new UsersDataSource_0, subjectId, ($clinit_Enhanced() , 'user'), 'global/User_24.png');
}

defineSeed(1850, 1692, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$DetailsView, Q$Enhanced]), UserEditView_0);
_.createFormItems = function createFormItems_0(form){
  var activeItem, activeRadioGroupItem, departmentItem, emailAddressItem, firstNameItem, initialPasswordChange, isLdapAuthenticatedUser, isLdapItem, items, lastNameItem, nameItem, passwordItem, phoneNumberItem, userBeingEditedIsRhqadmin, verifyPasswordItem;
  items = new ArrayList_0;
  if (this.recordId == 0) {
    nameItem = new TextItem_2('name');
  }
   else {
    nameItem = new StaticTextItem_1('name');
    $setEscapeHTML(dynamicCast(nameItem, Q$StaticTextItem), ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  }
  setCheck(items.array, items.size_0++, nameItem);
  isLdapItem = new StaticTextItem_1('ldap');
  setCheck(items.array, items.size_0++, isLdapItem);
  isLdapAuthenticatedUser = ($clinit_Boolean() , $equalsIgnoreCase('true', $getValueAsString(form, 'ldap'))?TRUE:FALSE).value_0;
  if (!this.isReadOnly && !isLdapAuthenticatedUser) {
    passwordItem = new PasswordItem_1('password');
    $setShowTitle_0(passwordItem, TRUE);
    setCheck(items.array, items.size_0++, passwordItem);
    verifyPasswordItem = new PasswordItem_1('passwordVerify');
    $setShowTitle_0(verifyPasswordItem, TRUE);
    initialPasswordChange = initValues(_3Z_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [true]);
    $addChangedHandler(passwordItem, new UserEditView$3_0(initialPasswordChange, verifyPasswordItem));
    setCheck(items.array, items.size_0++, verifyPasswordItem);
  }
  firstNameItem = new TextItem_2('firstName');
  $setShowTitle_0(firstNameItem, TRUE);
  $isCreated_2(firstNameItem)?$setProperty_9(firstNameItem, 'outputAsHTML', true):(firstNameItem.jsObj['outputAsHTML'] = true , undefined);
  setCheck(items.array, items.size_0++, firstNameItem);
  lastNameItem = new TextItem_2('lastName');
  $setShowTitle_0(lastNameItem, TRUE);
  $isCreated_2(lastNameItem)?$setProperty_9(lastNameItem, 'outputAsHTML', true):(lastNameItem.jsObj['outputAsHTML'] = true , undefined);
  setCheck(items.array, items.size_0++, lastNameItem);
  emailAddressItem = new TextItem_2('emailAddress');
  $setShowTitle_0(emailAddressItem, TRUE);
  $isCreated_2(emailAddressItem)?$setProperty_9(emailAddressItem, 'outputAsHTML', true):(emailAddressItem.jsObj['outputAsHTML'] = true , undefined);
  setCheck(items.array, items.size_0++, emailAddressItem);
  phoneNumberItem = new TextItem_2('phoneNumber');
  $isCreated_2(phoneNumberItem)?$setProperty_9(phoneNumberItem, 'outputAsHTML', true):(phoneNumberItem.jsObj['outputAsHTML'] = true , undefined);
  setCheck(items.array, items.size_0++, phoneNumberItem);
  departmentItem = new TextItem_2('department');
  $isCreated_2(departmentItem)?$setProperty_9(departmentItem, 'outputAsHTML', true):(departmentItem.jsObj['outputAsHTML'] = true , undefined);
  setCheck(items.array, items.size_0++, departmentItem);
  userBeingEditedIsRhqadmin = this.recordId == 2;
  if (!this.loggedInUserHasManageSecurityPermission || userBeingEditedIsRhqadmin) {
    activeItem = new StaticTextItem_1('factive');
  }
   else {
    activeRadioGroupItem = new RadioGroupItem_1('factive');
    $setAttribute_29(activeRadioGroupItem, 'vertical', FALSE);
    activeItem = activeRadioGroupItem;
  }
  setCheck(items.array, items.size_0++, activeItem);
  return items;
}
;
_.createNewRecord = function createNewRecord_1(){
  var subject, userRecord;
  subject = new Subject_0;
  subject.factive = true;
  userRecord = $copyUserValues(($clinit_RPCDataSource() , !INSTANCE_1 && (INSTANCE_1 = new UsersDataSource_0) , subject), false);
  return userRecord;
}
;
_.editRecord_0 = function editRecord_1(record){
  var roleListGridRecords, roleRecords, rolesAreReadOnly, sessionSubject, userBeingEditedIsLoggedInUser;
  sessionSubject = ($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0);
  userBeingEditedIsLoggedInUser = this.recordId == sessionSubject.id;
  if (this.loggedInUserHasManageSecurityPermission || userBeingEditedIsLoggedInUser) {
    roleRecords = convertToRecordArray(getAttributeAsJavaScriptObject(record.jsObj, 'roles'));
    roleListGridRecords = toListGridRecordArray(roleRecords);
    rolesAreReadOnly = $areRolesReadOnly(this, record);
    this.roleSelector = new SubjectRoleSelector_0(roleListGridRecords, rolesAreReadOnly);
    $addAssignedItemsChangedHandler(this.roleSelector, new UserEditView$2_0(this));
    $addMember(this.contentPane, this.roleSelector);
  }
}
;
_.renderView = function renderView_8(viewPath){
  $renderView_1(this, viewPath);
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new UserEditView$1_0(this)));
}
;
_.reset_1 = function reset_2(){
  $resetValues(this.form_0);
  !!this.roleSelector && $reset_1(this.roleSelector);
}
;
_.save = function save_2(requestProperties){
  var roleRecords;
  if (this.roleSelector) {
    roleRecords = this.roleSelector.assignedGrid.getRecords();
    $setValue_2(this.form_0, 'roles', roleRecords);
  }
  $save_0(this, requestProperties);
}
;
_.ldapAuthorizationEnabled = false;
_.loggedInUserHasManageSecurityPermission = false;
_.roleSelector = null;
function UserEditView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1851, 1, {}, UserEditView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_4(permissions){
  var isEditingSelf, isReadOnly, sessionSubject;
  if (!permissions) {
    $handleError_0(($clinit_CoreGUI() , 'Failed to load global permissions for current user. Perhaps the Server is down.'), null);
    return;
  }
  this.this$0.loggedInUserHasManageSecurityPermission = permissions.contains_0(($clinit_Permission() , MANAGE_SECURITY));
  sessionSubject = ($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0);
  isEditingSelf = sessionSubject.id == this.this$0.recordId;
  isReadOnly = !this.this$0.loggedInUserHasManageSecurityPermission && !isEditingSelf;
  $isLdapAuthorizationEnabled(dynamicCast(secure(getInstance_55(), -1), Q$SystemGWTServiceAsync), new UserEditView$1$1_0(this, isReadOnly));
}
;
_.this$0 = null;
function $onSuccess_82(this$static, ldapAuthz){
  this$static.this$1.this$0.ldapAuthorizationEnabled = ldapAuthz.value_0;
  debug('LDAP authorization is ' + (this$static.this$1.this$0.ldapAuthorizationEnabled?'':'not ') + 'enabled.');
  $init_1(this$static.this$1.this$0, this$static.val$isReadOnly);
}

function UserEditView$1$1_0(this$1, val$isReadOnly){
  this.this$1 = this$1;
  this.val$isReadOnly = val$isReadOnly;
}

defineSeed(1852, 1, {}, UserEditView$1$1_0);
_.onFailure = function onFailure_84(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to determine if LDAP authorization is enabled. Perhaps the Server is down.'), caught);
}
;
_.onSuccess_0 = function onSuccess_84(ldapAuthz){
  $onSuccess_82(this, dynamicCast(ldapAuthz, Q$Boolean));
}
;
_.this$1 = null;
_.val$isReadOnly = false;
function UserEditView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1853, 1, makeCastMap([Q$EventHandler, Q$AssignedItemsChangedHandler]), UserEditView$2_0);
_.onSelectionChanged_0 = function onSelectionChanged_2(event_0){
  $onItemChanged(this.this$0);
}
;
_.this$0 = null;
function UserEditView$3_0(val$initialPasswordChange, val$verifyPasswordItem){
  this.val$initialPasswordChange = val$initialPasswordChange;
  this.val$verifyPasswordItem = val$verifyPasswordItem;
}

defineSeed(1854, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), UserEditView$3_0);
_.onChanged = function onChanged_2(event_0){
  if (this.val$initialPasswordChange[0]) {
    $clearValue_0(this.val$verifyPasswordItem);
    this.val$initialPasswordChange[0] = false;
  }
}
;
_.val$initialPasswordChange = null;
_.val$verifyPasswordItem = null;
function $onSuccess_83(this$static, fetchedSubjects){
  var failed, fetchedSubject, fetchedSubjectsSize, i, userRecordsPageList, username;
  userRecordsPageList = new PageList_2(fetchedSubjects.pageControl);
  $setTotalSize(userRecordsPageList, max_0(fetchedSubjects.size_0, fetchedSubjects.totalSize));
  $setUnbounded(userRecordsPageList, fetchedSubjects.isUnbounded);
  failed = initValues(_3Z_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [false]);
  for (i = 0 , fetchedSubjectsSize = fetchedSubjects.size_0; i < fetchedSubjectsSize; ++i) {
    if (failed[0]) {
      break;
    }
    fetchedSubject = dynamicCast((checkIndex(i, fetchedSubjects.size_0) , fetchedSubjects.array[i]), Q$Subject);
    username = fetchedSubject.name_0;
    $isUserWithPrincipal(this$static.this$0.subjectService, username, new UsersDataSource$1$1_0(this$static, failed, username, this$static.val$request, this$static.val$response, fetchedSubject, userRecordsPageList, fetchedSubjects));
  }
}

function UsersDataSource$1_0(this$0, val$request, val$response){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(1855, 1, {}, UsersDataSource$1_0);
_.onFailure = function onFailure_85(caught){
  $sendFailureResponse(this.this$0, this.val$request, this.val$response, 'Failed to fetch user(s).', caught);
}
;
_.onSuccess_0 = function onSuccess_85(fetchedSubjects){
  $onSuccess_83(this, dynamicCast(fetchedSubjects, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onFailure_6(this$static, caught){
  var message;
  this$static.val$failed[0] = true;
  message = 'Failed to check if user [' + this$static.val$username + '] is an LDAP user.';
  $sendFailureResponse(this$static.this$1.this$0, this$static.val$request, this$static.val$response, message, caught);
}

function UsersDataSource$1$1_0(this$1, val$failed, val$username, val$request, val$response, val$fetchedSubject, val$userRecordsPageList, val$fetchedSubjects){
  this.this$1 = this$1;
  this.val$failed = val$failed;
  this.val$username = val$username;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$fetchedSubject = val$fetchedSubject;
  this.val$userRecordsPageList = val$userRecordsPageList;
  this.val$fetchedSubjects = val$fetchedSubjects;
}

defineSeed(1856, 1, {}, UsersDataSource$1$1_0);
_.onFailure = function onFailure_86(caught){
  $onFailure_6(this, caught);
}
;
_.onSuccess_0 = function onSuccess_86(hasPrincipal){
  var isLdap, userRecord;
  isLdap = !dynamicCast(hasPrincipal, Q$Boolean).value_0;
  userRecord = $copyUserValues(this.val$fetchedSubject, isLdap);
  $add_3(this.val$userRecordsPageList, userRecord);
  this.val$userRecordsPageList.size_0 == this.val$fetchedSubjects.size_0 && this.this$1.this$0.sendSuccessResponseRecords(this.val$request, this.val$response, this.val$userRecordsPageList);
}
;
_.this$1 = null;
_.val$failed = null;
_.val$fetchedSubject = null;
_.val$fetchedSubjects = null;
_.val$request = null;
_.val$response = null;
_.val$userRecordsPageList = null;
_.val$username = null;
function $onFailure_7(this$static, caught){
  var errorMessages, message;
  message = caught.getMessage();
  if (message != null && message.indexOf('javax.persistence.EntityExistsException') != -1) {
    errorMessages = new HashMap_0;
    errorMessages.put('name', 'Failed to create user with existing name [' + ($clinit_RPCDataSource() , this$static.val$newSubject.name_0) + ']. Please use another name.');
    $sendValidationErrorResponse(this$static.this$0, this$static.val$request, this$static.val$response, errorMessages);
  }
   else {
    throw new RuntimeException_3(caught);
  }
}

function $onSuccess_84(this$static, createdSubject){
  var createdUserRecord;
  createdUserRecord = $copyUserValues(createdSubject, false);
  $sendSuccessResponse(this$static.this$0, this$static.val$request, this$static.val$response, createdUserRecord, null);
}

function UsersDataSource$2_0(this$0, val$newSubject, val$request, val$response){
  this.this$0 = this$0;
  this.val$newSubject = val$newSubject;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(1857, 1, {}, UsersDataSource$2_0);
_.onFailure = function onFailure_87(caught){
  $onFailure_7(this, caught);
}
;
_.onSuccess_0 = function onSuccess_87(createdSubject){
  $onSuccess_84(this, dynamicCast(createdSubject, Q$Subject));
}
;
_.this$0 = null;
_.val$newSubject = null;
_.val$request = null;
_.val$response = null;
function $onFailure_8(this$static, caught){
  var message;
  message = 'Failed to update user [' + this$static.val$username + '].';
  $sendFailureResponse(this$static.this$0, this$static.val$request, this$static.val$response, message, caught);
}

function $onSuccess_85(this$static){
  $sendSuccessResponse(this$static.this$0, this$static.val$request, this$static.val$response, this$static.val$editedUserRecord, null);
}

function UsersDataSource$3_0(this$0, val$username, val$request, val$response, val$editedUserRecord){
  this.this$0 = this$0;
  this.val$username = val$username;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$editedUserRecord = val$editedUserRecord;
}

defineSeed(1858, 1, {}, UsersDataSource$3_0);
_.onFailure = function onFailure_88(caught){
  $onFailure_8(this, caught);
}
;
_.onSuccess_0 = function onSuccess_88(updatedSubject){
  $onSuccess_85(this, dynamicCast(updatedSubject, Q$Subject));
}
;
_.this$0 = null;
_.val$editedUserRecord = null;
_.val$request = null;
_.val$response = null;
_.val$username = null;
function $clinit_UsersView(){
  $clinit_UsersView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_14 = new ViewName_2('Users', ($clinit_Enhanced() , 'Users'), ($clinit_IconEnum() , USERS));
  ($clinit_AdministrationView() , VIEW_ID) + '/' + SECTION_SECURITY_VIEW_ID + '/' + VIEW_ID_14;
}

function $refresh_0(this$static){
  $refresh(this$static, false);
  $updateSelectionStyle_0(this$static);
}

function $updateSelectionStyle_0(this$static){
  var selectionStyle;
  this$static.hasManageSecurity || $deselectAllRecords(this$static.listGrid);
  selectionStyle = this$static.hasManageSecurity?($clinit_SelectionStyle() , MULTIPLE):($clinit_SelectionStyle() , NONE_4);
  $setAttribute_24(this$static.listGrid, 'selectionType', selectionStyle.value_0, true);
}

function UsersView_0(hasManageSecurity){
  $clinit_UsersView();
  var dataSource;
  TableSection_0.call(this, null);
  dataSource = ($clinit_RPCDataSource() , !INSTANCE_1 && (INSTANCE_1 = new UsersDataSource_0) , $clinit_RPCDataSource() , INSTANCE_1);
  this.dataSource_1 = dataSource;
  this.escapeHtmlInDetailsLinkColumn = true;
  this.hasManageSecurity = hasManageSecurity;
}

defineSeed(1859, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), UsersView_0);
_.configureTable = function configureTable_10(){
  var fields, fields_0, nameField, activeField, ldapField, firstNameField, lastNameField, departmentField;
  $updateSelectionStyle_0(this);
  $addCellClickHandler(this.listGrid, new UsersView$1_0(this));
  fields = (fields_0 = new ArrayList_0 , nameField = new ListGridField_2('name', 150) , setCheck(fields_0.array, fields_0.size_0++, nameField) , activeField = new ListGridField_2('factive', 90) , setCheck(fields_0.array, fields_0.size_0++, activeField) , ldapField = new ListGridField_2('ldap', 90) , setCheck(fields_0.array, fields_0.size_0++, ldapField) , firstNameField = new ListGridField_2('firstName', 150) , $setCellFormatter_0(firstNameField, new EscapedHtmlCellFormatter_0) , setCheck(fields_0.array, fields_0.size_0++, firstNameField) , lastNameField = new ListGridField_2('lastName', 150) , $setCellFormatter_0(lastNameField, new EscapedHtmlCellFormatter_0) , setCheck(fields_0.array, fields_0.size_0++, lastNameField) , departmentField = new ListGridField_2('department', 150) , $setCellFormatter_0(departmentField, new EscapedHtmlCellFormatter_0) , setCheck(fields_0.array, fields_0.size_0++, departmentField) , fields_0);
  $setListGridFields(this, false, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $addTableAction(this, ($clinit_Enhanced() , 'New'), null, null, new UsersView$2_0(this));
  $addTableAction(this, 'Delete', 'Are you sure you want to delete the # selected users?', null, new UsersView$3_0(this));
  $configureTable(this);
}
;
_.getDetailsView_0 = function getDetailsView_7(subjectId){
  return new UserEditView_0(subjectId.value_0);
}
;
_.getViewName = function getViewName_4(){
  return VIEW_ID_14;
}
;
_.refresh_0 = function refresh_4(){
  $refresh_0(this);
}
;
_.hasManageSecurity = false;
var VIEW_ID_14;
function UsersView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1860, 1, makeCastMap([Q$EventHandler, Q$CellClickHandler]), UsersView$1_0);
_.onCellClick = function onCellClick_0(event_0){
  $updateSelectionStyle_0(this.this$0);
}
;
_.this$0 = null;
function UsersView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1861, 1, {}, UsersView$2_0);
_.executeAction = function executeAction_17(selection, actionValue){
  $newDetails(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_6(selection){
  return this.this$0.hasManageSecurity;
}
;
_.this$0 = null;
function UsersView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1862, 1, {}, UsersView$3_0);
_.executeAction = function executeAction_18(selection, actionValue){
  var doomedIds, doomedNames, i, record, record$index, record$max, subjectService;
  if (selection == null || selection.length == 0) {
    return;
  }
  doomedNames = new ArrayList_1(selection.length);
  doomedIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selection.length, 1);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    $add_3(doomedNames, getAttribute(record.jsObj, 'name'));
    doomedIds[i++] = getAttributeAsInt(record.jsObj, 'id').value_0;
  }
  subjectService = dynamicCast(secure(getInstance_54(), -1), Q$SubjectGWTServiceAsync);
  $deleteSubjects(subjectService, doomedIds, new UsersView$3$1_0(this, doomedNames));
}
;
_.isEnabled_0 = function isEnabled_7(selection){
  var count, record, record$index, record$max, subjectId;
  if (!this.this$0.hasManageSecurity) {
    return false;
  }
  count = selection.length;
  if (count == 0) {
    return false;
  }
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    subjectId = getAttributeAsInt(record.jsObj, 'id').value_0;
    $clinit_RPCDataSource();
    if (subjectId == 1 || subjectId == 2) {
      return false;
    }
  }
  return true;
}
;
_.this$0 = null;
function $onFailure_9(this$static, caught){
  var message;
  message = 'Failed to delete user [' + ($clinit_Enhanced() , this$static.val$doomedNames.toString$()) + ']';
  $handleError_0(($clinit_CoreGUI() , message), caught);
  $refresh_0(this$static.this$1.this$0);
}

function $onSuccess_86(this$static){
  var message;
  message = new Message_0('Deleted user [' + ($clinit_Enhanced() , this$static.val$doomedNames.toString$()) + ']');
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  $refresh_0(this$static.this$1.this$0);
}

function UsersView$3$1_0(this$1, val$doomedNames){
  this.this$1 = this$1;
  this.val$doomedNames = val$doomedNames;
}

defineSeed(1863, 1, {}, UsersView$3$1_0);
_.onFailure = function onFailure_89(caught){
  $onFailure_9(this, caught);
}
;
_.onSuccess_0 = function onSuccess_89(result){
  $onSuccess_86(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$doomedNames = null;
function $clinit_AlertDataSource(){
  $clinit_AlertDataSource = nullMethod;
  $clinit_RPCDataSource();
  PRIORITY_ICON_HIGH = 'subsystems/alert/Alert_' + ($clinit_AlertPriority() , HIGH).name_0 + '_16.png';
  PRIORITY_ICON_MEDIUM = 'subsystems/alert/Alert_' + MEDIUM.name_0 + '_16.png';
  PRIORITY_ICON_LOW = 'subsystems/alert/Alert_' + LOW.name_0 + '_16.png';
}

function $dataRetrieved(this$static, result, response, request){
  var alert_0, alert$iterator, ancestries, resource, typeRepo, typesSet;
  switch (this$static.entityContext.type_0.ordinal) {
    case 0:
      $setAttribute_17(response, 'data', $buildRecords(this$static, result, true));
      $setAttribute_11(response, 'totalRows', valueOf_44(this$static.getTotalRows_0(result, response, request)));
      $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
      break;
    default:typesSet = new HashSet_0;
      ancestries = new HashSet_0;
      for (alert$iterator = new AbstractList$IteratorImpl_0(result); alert$iterator.i < alert$iterator.this$0_0.size_1();) {
        alert_0 = dynamicCast($next_0(alert$iterator), Q$Alert);
        resource = alert_0.alertDefinition.resource;
        $add_6(typesSet, valueOf_44(resource.resourceType.id));
        $add_6(ancestries, resource.ancestry);
      }

      typesSet.addAll(getAncestryTypeIds(ancestries));
      typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
      $getResourceTypes_0(typeRepo, dynamicCast(typesSet.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new AlertDataSource$8_0(this$static, result, response, request));
  }
}

function $executeFetch_8(this$static, request, response, criteria){
  var start;
  if (!criteria) {
    $setAttribute_11(response, 'totalRows', valueOf_44(0));
    $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
    return;
  }
  start = fromDouble(currentTimeMillis0());
  $findAlertsByCriteria(this$static.alertService, criteria, new AlertDataSource$7_0(this$static, response, request, start));
}

function $getListGridFields_5(this$static){
  var ancestryField, conditionField, ctimeField, fields, nameField, priorityField, resourceNameField, statusField;
  fields = new ArrayList_1(7);
  ctimeField = new ListGridField_3('ctime', ($clinit_RPCDataSource() , 'Creation Time'));
  $setCellFormatter_0(ctimeField, new TimestampCellFormatter_0);
  $setAttribute_8(ctimeField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(ctimeField, ($clinit_TimestampCellFormatter() , new TimestampCellFormatter$1_0('ctime')));
  setCheck(fields.array, fields.size_0++, ctimeField);
  nameField = new ListGridField_3('name', 'Name');
  $setCellFormatter_0(nameField, new AlertDataSource$1_0);
  setCheck(fields.array, fields.size_0++, nameField);
  conditionField = new ListGridField_3('conditionText', 'Condition Text');
  $setAttribute_8(conditionField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, conditionField);
  priorityField = new ListGridField_3('priority', 'Priority');
  $setAttribute_13(priorityField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(priorityField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_8(priorityField, 'showHover', TRUE);
  $setHoverCustomizer_0(priorityField, new AlertDataSource$2_0);
  setCheck(fields.array, fields.size_0++, priorityField);
  statusField = new ListGridField_3('acknowledgingSubject', 'Acknowledged');
  $setCellFormatter_0(statusField, new AlertDataSource$3_0);
  $setAttribute_8(statusField, 'showHover', TRUE);
  $setHoverCustomizer_0(statusField, new AlertDataSource$4_0);
  setCheck(fields.array, fields.size_0++, statusField);
  if (this$static.entityContext.type_0 != ($clinit_EntityContext$Type() , Resource)) {
    resourceNameField = new ListGridField_3('resourceName', 'Resource');
    $setCellFormatter_0(resourceNameField, new AlertDataSource$5_0);
    $setAttribute_8(resourceNameField, 'showHover', TRUE);
    $setHoverCustomizer_0(resourceNameField, new AlertDataSource$6_0);
    setCheck(fields.array, fields.size_0++, resourceNameField);
    ancestryField = setupAncestryListGridField();
    setCheck(fields.array, fields.size_0++, ancestryField);
    ctimeField.jsObj['width'] = 100;
    nameField.jsObj['width'] = '15%';
    conditionField.jsObj['width'] = '35%';
    priorityField.jsObj['width'] = 50;
    statusField.jsObj['width'] = 80;
    resourceNameField.jsObj['width'] = '25%';
    ancestryField.jsObj['width'] = '25%';
  }
   else {
    ctimeField.jsObj['width'] = 200;
    nameField.jsObj['width'] = '15%';
    conditionField.jsObj['width'] = '60%';
    priorityField.jsObj['width'] = 50;
    statusField.jsObj['width'] = '25%';
  }
  return fields;
}

function AlertDataSource_0(context){
  var fields, idField;
  $clinit_AlertDataSource();
  RPCDataSource_0.call(this);
  this.alertService = dynamicCast(secure(getInstance_32(), -1), Q$AlertGWTServiceAsync);
  this.entityContext = context;
  fields = new ArrayList_0;
  idField = new DataSourceIntegerField_2('id', 'ID', 50);
  $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_8(idField, 'canEdit', FALSE);
  $setAttribute_8(idField, 'hidden', TRUE);
  setCheck(fields.array, fields.size_0++, idField);
}

function convert(from){
  $clinit_AlertDataSource();
  var $e0, alertDefinition, condition, conditionLog, conditionLogs, conditionText, conditionValue, conditions, dc, i, log, log$iterator, notifications, record, recoveryInfo, resource, value;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_14(record, 'ctime', new Date_2(from.ctime));
  !!from.acknowledgeTime && gt(from.acknowledgeTime.value_0, P0_longLit) && $setAttribute_14(record, 'acknowledgeTime', new Date_2(from.acknowledgeTime.value_0));
  $setAttribute_13(record, 'acknowledgingSubject', from.acknowledgingSubject);
  alertDefinition = from.alertDefinition;
  $setAttribute_3(record, 'definitionId', alertDefinition.id);
  resource = alertDefinition.resource;
  $setAttribute_13(record, 'name', alertDefinition.name_0);
  $setAttribute_13(record, 'description', alertDefinition.description);
  $setAttribute_13(record, 'priority', 'subsystems/alert/Alert_' + alertDefinition.priority.name_0 + '_16.png');
  $setAttribute_3(record, 'resourceId', resource.id);
  $setAttribute_13(record, 'resourceName', resource.name_0);
  $setAttribute_13(record, 'resourceAncestry', resource.ancestry);
  $setAttribute_3(record, 'resourceTypeId', resource.resourceType.id);
  conditionLogs = from.conditionLogs;
  if (conditionLogs.size_1() > 1) {
    conditionText = 'Multiple Conditions';
    conditionValue = '--';
  }
   else if (conditionLogs.size_1() == 1) {
    conditionLog = dynamicCast(conditionLogs.iterator().next_0(), Q$AlertConditionLog);
    condition = conditionLog.condition_0;
    conditionText = formatAlertConditionForDisplay(condition);
    conditionValue = conditionLog.value_0;
    if (condition.measurementDefinition) {
      try {
        conditionValue = ($clinit_MeasurementConverterClient() , format_91(new Double_0(__parseAndValidateDouble(conditionLog.value_0)), condition.measurementDefinition.units));
      }
       catch ($e0) {
        $e0 = caught_0($e0);
        if (!instanceOf($e0, Q$Exception))
          throw $e0;
      }
    }
  }
   else {
    conditionText = 'No Conditions';
    conditionValue = '--';
  }
  record.jsObj['conditionText'] = conditionText;
  record.jsObj['conditionValue'] = conditionValue;
  conditions = initDim(_3Lcom_smartgwt_client_core_DataClass_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$DataClass, from.conditionLogs.size_1(), 0);
  i = 0;
  for (log$iterator = from.conditionLogs.iterator(); log$iterator.hasNext();) {
    log = dynamicCast(log$iterator.next_0(), Q$AlertConditionLog);
    condition = log.condition_0;
    dc = new DataClass_0;
    dc.setAttribute_2('text', formatAlertConditionForDisplay(condition));
    value = log.value_0;
    if (condition.measurementDefinition) {
      try {
        value = ($clinit_MeasurementConverterClient() , format_91(new Double_0(__parseAndValidateDouble(log.value_0)), condition.measurementDefinition.units));
      }
       catch ($e0) {
        $e0 = caught_0($e0);
        if (!instanceOf($e0, Q$Exception))
          throw $e0;
      }
    }
    dc.setAttribute_2('value', value);
    setCheck(conditions, i++, dc);
  }
  record.jsObj['conditionLogs'] = convertToJavaScriptArray(conditions);
  $setAttribute_12(record, 'conditionExpression', alertDefinition.conditionExpression);
  recoveryInfo = getAlertRecoveryInfo(from);
  record.jsObj['recoveryInfo'] = recoveryInfo;
  notifications = initDim(_3Lcom_smartgwt_client_core_DataClass_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$DataClass, from.alertNotificationLogs.size_1(), 0);
  i = 0;
  for (log$iterator = from.alertNotificationLogs.iterator(); log$iterator.hasNext();) {
    log = dynamicCast(log$iterator.next_0(), Q$AlertNotificationLog);
    dc = new DataClass_0;
    dc.setAttribute_2('sender', log.sender);
    dc.setAttribute_2('status', log.resultState.name_0);
    dc.setAttribute_2('message', log.message_0);
    setCheck(notifications, i++, dc);
  }
  record.jsObj['notificationLogs'] = convertToJavaScriptArray(notifications);
  return record;
}

defineSeed(1864, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AlertDataSource]), AlertDataSource_0);
_.copyValues = function copyValues_24(from){
  return null;
}
;
_.copyValues_0 = function copyValues_25(from){
  return convert(dynamicCast(from, Q$Alert));
}
;
_.executeFetch = function executeFetch_14(request, response, criteria){
  $executeFetch_8(this, request, response, dynamicCast(criteria, Q$AlertCriteria));
}
;
_.executeRemove = function executeRemove_1(recordToRemove, request, response){
  alert_1('' + getAttributeAsInt(recordToRemove.jsObj, 'id'));
}
;
_.getFetchCriteria_0 = function getFetchCriteria_10(request){
  var criteria, endDateFilter, endOfDay, prioritiesFilter, startDateFilter, startOfDay;
  prioritiesFilter = dynamicCast(($clinit_RPCDataSource() , getArrayFilter($getCriteria(request), 'priorities', Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)), Q$AlertPriority_$1);
  if (prioritiesFilter == null || prioritiesFilter.length == 0) {
    return null;
  }
  criteria = new AlertCriteria_0;
  prioritiesFilter.length != ($clinit_AlertPriority() , $clinit_AlertPriority() , $VALUES_46).length && (criteria.filterPriorities = getListIgnoringNulls(prioritiesFilter));
  startDateFilter = dynamicCast(getFilter($getCriteria(request), 'startTime', Ljava_util_Date_2_classLit), Q$Date);
  if (startDateFilter) {
    startOfDay = getAbsoluteDate(($clinit_RelativeDate() , START_OF_TODAY), startDateFilter, ($clinit_RelativeDateRangePosition() , START));
    $addFilterStartTime_0(criteria, valueOf_45(startOfDay.getTime_0()));
  }
  endDateFilter = dynamicCast(getFilter($getCriteria(request), 'endTime', Ljava_util_Date_2_classLit), Q$Date);
  if (endDateFilter) {
    endOfDay = getAbsoluteDate(($clinit_RelativeDate() , END_OF_TODAY), endDateFilter, ($clinit_RelativeDateRangePosition() , END));
    $addFilterEndTime_0(criteria, valueOf_45(endOfDay.getTime_0()));
  }
  $addFilterEntityContext(criteria, this.entityContext);
  criteria.fetchConditionLogs = true;
  return criteria;
}
;
_.getFetchCriteria = function getFetchCriteria_11(request){
  return this.getFetchCriteria_0(request);
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_1(columnName){
  var sortField;
  $equals_6('resourceAncestry', columnName)?(sortField = 'alertDefinition.resource.ancestry'):$equals_6('status', columnName)?(sortField = 'acknowledgeTime'):(sortField = columnName);
  return sortField;
}
;
_.getTotalRows_0 = function getTotalRows(result, response, request){
  return max_0(result.size_0, result.totalSize);
}
;
_.entityContext = null;
var PRIORITY_ICON_HIGH, PRIORITY_ICON_LOW, PRIORITY_ICON_MEDIUM;
function AlertDataSource$1_0(){
}

defineSeed(1865, 1, {}, AlertDataSource$1_0);
_.format_1 = function format_8(o, listGridRecord, i, i1){
  var defId, resourceId, url;
  resourceId = getAttributeAsInt(listGridRecord.jsObj, 'resourceId');
  defId = getAttributeAsInt(listGridRecord.jsObj, 'definitionId');
  url = '#Resource/' + resourceId.value_0 + '/Alerts/Definitions/' + defId.value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function AlertDataSource$2_0(){
}

defineSeed(1866, 1, {}, AlertDataSource$2_0);
_.hoverHTML_0 = function hoverHTML_0(value, record, rowNum, colNum){
  var prio;
  prio = getAttribute(record.jsObj, 'priority');
  return $equals_6(($clinit_AlertDataSource() , PRIORITY_ICON_HIGH), prio)?'High':$equals_6(PRIORITY_ICON_MEDIUM, prio)?'Medium':$equals_6(PRIORITY_ICON_LOW, prio)?'Low':'';
}
;
function AlertDataSource$3_0(){
}

defineSeed(1867, 1, {}, AlertDataSource$3_0);
_.format_1 = function format_9(o, listGridRecord, i, i1){
  var ackSubject, checkedImg;
  ackSubject = getAttribute(listGridRecord.jsObj, 'acknowledgingSubject');
  if (ackSubject == null) {
    return '&nbsp;';
  }
   else {
    checkedImg = new Img_2('global/Check_16.png', 80, 16);
    $setAttribute_24(checkedImg, 'imageType', ($clinit_ImageStyle() , CENTER_1).value_0, true);
    return $getInnerHTML(checkedImg);
  }
}
;
function AlertDataSource$4_0(){
}

defineSeed(1868, 1, {}, AlertDataSource$4_0);
_.hoverHTML_0 = function hoverHTML_1(value, record, rowNum, colNum){
  var ackDateTime, ackDateTimeString, ackSubject, sb;
  ackSubject = getAttribute(record.jsObj, 'acknowledgingSubject');
  sb = new StringBuilder_1('<p');
  if (ackSubject == null) {
    $append_1(sb.data_0, " style='width:150px'>");
    $append_12(sb, ($clinit_RPCDataSource() , 'Not yet Acknowledged'));
  }
   else {
    $append_1(sb.data_0, " style='width:500px'>");
    ackDateTime = getAttributeAsDate(record.jsObj, 'acknowledgeTime');
    ackDateTimeString = format_30(ackDateTime, ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_FULL));
    $append_12(sb, 'Acknowledged by ' + ($clinit_RPCDataSource() , ackSubject) + ' at ' + ackDateTimeString);
  }
  $append_1(sb.data_0, '<\/p>');
  return $toString_1(sb.data_0);
}
;
function AlertDataSource$5_0(){
}

defineSeed(1869, 1, {}, AlertDataSource$5_0);
_.format_1 = function format_10(value, record, rowNum, colNum){
  var url;
  url = '#Resource/' + getAttributeAsInt(record.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(value));
}
;
function AlertDataSource$6_0(){
}

defineSeed(1870, 1, {}, AlertDataSource$6_0);
_.hoverHTML_0 = function hoverHTML_2(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function $onSuccess_87(this$static, result){
  var fetchTime;
  fetchTime = sub(fromDouble(currentTimeMillis0()), this$static.val$start);
  info_0(result.size_0 + ' alerts fetched in: ' + toString_8(fetchTime) + 'ms');
  $dataRetrieved(this$static.this$0, result, this$static.val$response, this$static.val$request);
}

function AlertDataSource$7_0(this$0, val$response, val$request, val$start){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
  this.val$start = val$start;
}

defineSeed(1871, 1, {}, AlertDataSource$7_0);
_.onFailure = function onFailure_90(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to fetch alerts data'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_90(result){
  $onSuccess_87(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$start = P0_longLit;
function AlertDataSource$8_0(this$0, val$result, val$response, val$request){
  this.this$0 = this$0;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1872, 1, {}, AlertDataSource$8_0);
_.onTypesLoaded_0 = function onTypesLoaded_2(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setAttribute_11(this.val$response, 'totalRows', valueOf_44(this.this$0.getTotalRows_0(this.val$result, this.val$response, this.val$request)));
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $clinit_AlertDetailsView(){
  $clinit_AlertDetailsView = nullMethod;
  $clinit_BaseWidget();
  INSTANCE_3 = new AlertDetailsView_0;
}

function $show_1(this$static, alertId){
  var criteria;
  criteria = new AlertCriteria_0;
  $addFilterId(criteria, valueOf_44(alertId));
  $findAlertsByCriteria(dynamicCast(secure(getInstance_32(), -1), Q$AlertGWTServiceAsync), criteria, new AlertDetailsView$1_0(this$static));
}

function $show_2(this$static, alert_0){
  var record, tabset, generalTab, form, items, nameTextItem, descriptionTextItem, prioTextItem, priorityIcons, priorityMap, createdTextItem, ackByItem, ackTimeItem, ack_time, recoveryItem, resourceItem, resourceAncestryItem, conditionsTab, mode, notificationsTab;
  destroyMembers(this$static);
  $clinit_Log();
  $info_0(logger_0, 'AlertDetailsView-Alert: ' + alert_0);
  record = convert(alert_0);
  $info_0(logger_0, 'AlertDetailsView-ListGridRecord: ' + record);
  $addMember(this$static, (tabset = new NamedTabSet_0 , generalTab = new NamedTab_0(new ViewName_1('general', ($clinit_Enhanced() , 'General Properties'))) , $setPane(generalTab, (form = new DynamicForm_0 , $isCreated_1(form)?$setProperty_0(form, 'numCols', 4):(form.config_0['numCols'] = 4 , undefined) , $isCreated_1(form)?$setProperty_3(form, 'height', '15%'):(form.config_0['height'] = '15%' , undefined) , $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , $setAttribute_24(form, 'align', ($clinit_Alignment() , LEFT_0).value_0, true) , items = new ArrayList_0 , nameTextItem = new StaticTextItem_2('name', 'Name') , $setValue_7(nameTextItem, getAttribute(record.jsObj, 'name')) , $setPrompt_1(nameTextItem, 'Id = ' + getAttribute(record.jsObj, 'id')) , setCheck(items.array, items.size_0++, nameTextItem) , descriptionTextItem = new StaticTextItem_2('description', 'Description') , $setValue_7(descriptionTextItem, getAttribute(record.jsObj, 'description')) , setCheck(items.array, items.size_0++, descriptionTextItem) , prioTextItem = new StaticTextItem_2('priority', 'Priority') , $setValue_7(prioTextItem, getAttribute(record.jsObj, 'priority')) , priorityIcons = new LinkedHashMap_1(3) , $put_1(priorityIcons, ($clinit_AlertDataSource() , PRIORITY_ICON_HIGH), PRIORITY_ICON_HIGH) , $put_1(priorityIcons, PRIORITY_ICON_MEDIUM, PRIORITY_ICON_MEDIUM) , $put_1(priorityIcons, PRIORITY_ICON_LOW, PRIORITY_ICON_LOW) , $isCreated_2(prioTextItem)?$setProperty_7(prioTextItem, 'valueIcons', convertMapToJavascriptObject(priorityIcons)):(prioTextItem.jsObj['valueIcons'] = convertMapToJavascriptObject(priorityIcons) , undefined) , priorityMap = new LinkedHashMap_1(3) , $put_1(priorityMap, PRIORITY_ICON_HIGH, 'High') , $put_1(priorityMap, PRIORITY_ICON_MEDIUM, 'Medium') , $put_1(priorityMap, PRIORITY_ICON_LOW, 'Low') , $isCreated_2(prioTextItem)?$setValueMapMethod(prioTextItem, convertMapToJavascriptObject(priorityMap)):$isCreated_2(prioTextItem)?$setProperty_7(prioTextItem, 'valueMap', convertMapToJavascriptObject(priorityMap)):(prioTextItem.jsObj['valueMap'] = convertMapToJavascriptObject(priorityMap) , undefined) , setCheck(items.array, items.size_0++, prioTextItem) , createdTextItem = new StaticTextItem_2('ctime', 'Creation Time') , $setValue_7(createdTextItem, ($clinit_TimestampCellFormatter() , format_30(getAttributeAsDate(record.jsObj, 'ctime'), DATE_TIME_FORMAT_MEDIUM))) , setCheck(items.array, items.size_0++, createdTextItem) , ackByItem = new StaticTextItem_2('acknowledgingSubject', 'Acknowledged by') , getAttribute(record.jsObj, 'acknowledgingSubject') != null?$setValue_7(ackByItem, getAttribute(record.jsObj, 'acknowledgingSubject')):$setValue_7(ackByItem, 'No Ack') , setCheck(items.array, items.size_0++, ackByItem) , ackTimeItem = new StaticTextItem_2('acknowledgeTime', 'Acknowledged at') , ack_time = getAttributeAsDate(record.jsObj, 'acknowledgeTime') , ack_time?$setValue_7(ackTimeItem, format_30(ack_time, DATE_TIME_FORMAT_MEDIUM)):$setValue_7(ackTimeItem, 'No Ack') , setCheck(items.array, items.size_0++, ackTimeItem) , recoveryItem = new StaticTextItem_2('recovery', 'Recovery Info') , $setValue_7(recoveryItem, getAttribute(record.jsObj, 'recoveryInfo')) , setCheck(items.array, items.size_0++, recoveryItem) , resourceItem = new StaticTextItem_2('resourceName', 'Watched Resource') , $setValue_7(resourceItem, getAttribute(record.jsObj, 'resourceName')) , setCheck(items.array, items.size_0++, resourceItem) , resourceAncestryItem = new StaticTextItem_2('resourceAncestry', 'Resource Ancestry') , $setValue_7(resourceAncestryItem, getAttribute(record.jsObj, 'resourceAncestry')) , setCheck(items.array, items.size_0++, resourceAncestryItem) , form.setItems(dynamicCast($toArray_1(items, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, items.size_0, 0)), Q$FormItem_$1)) , form)) , conditionsTab = new NamedTab_0(new ViewName_1('conditions', 'Conditions')) , $setPane(conditionsTab, (mode = getAttribute(record.jsObj, 'conditionExpression') , new AlertDetailsView$ConditionLogsTable_0('Conditions: match = ' + mode, record))) , notificationsTab = new NamedTab_0(new ViewName_1('notifications', 'Notifications')) , $setPane(notificationsTab, new AlertDetailsView$NotificationLogsTable_0('Notifications', record)) , $addTab(tabset, generalTab) , $addTab(tabset, conditionsTab) , $addTab(tabset, notificationsTab) , tabset));
}

function AlertDetailsView_0(){
  EnhancedVLayout_0.call(this);
}

defineSeed(1873, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), AlertDetailsView_0);
_.renderView = function renderView_9(viewPath){
  this.alertId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  $show_1(this, this.alertId);
}
;
_.alertId = 0;
var INSTANCE_3;
function $onSuccess_88(this$static, result){
  var alert_0;
  alert_0 = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Alert);
  $show_2(this$static.this$0, alert_0);
}

function AlertDetailsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1874, 1, {}, AlertDetailsView$1_0);
_.onFailure = function onFailure_91(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to fetch alert details'), caught);
}
;
_.onSuccess_0 = function onSuccess_91(result){
  $onSuccess_88(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function AlertDetailsView$ConditionLogsTable_0(tableTitle, record){
  $clinit_BaseWidget();
  Table_7.call(this, tableTitle, false);
  this.record_0 = record;
  $isCreated_1(this)?$setProperty_3(this, 'height', '35%'):(this.config_0['height'] = '35%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  this.showFooterRefresh = false;
}

defineSeed(1875, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), AlertDetailsView$ConditionLogsTable_0);
_.configureTable = function configureTable_11(){
  var condition, grid, input, value;
  input = convertToRecordArray($getAttributeAsJavaScriptObject_0(this.record_0, 'conditionLogs'));
  grid = this.listGrid;
  grid.setData(input);
  condition = new ListGridField_3('text', ($clinit_Enhanced() , 'Condition'));
  condition.jsObj['width'] = '60%';
  value = new ListGridField_3('value', 'Value');
  $isCreated_1(grid)?$setProperty_2(grid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [condition, value]))):(grid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [condition, value])) , undefined);
}
;
_.record_0 = null;
function AlertDetailsView$NotificationLogsTable_0(tableTitle, record){
  $clinit_BaseWidget();
  Table_7.call(this, tableTitle, false);
  this.record_0 = record;
  $isCreated_1(this)?$setProperty_3(this, 'height', '35%'):(this.config_0['height'] = '35%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  this.showFooterRefresh = false;
}

defineSeed(1876, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), AlertDetailsView$NotificationLogsTable_0);
_.configureTable = function configureTable_12(){
  var grid, input, message, sender, status_0;
  input = convertToRecordArray($getAttributeAsJavaScriptObject_0(this.record_0, 'notificationLogs'));
  grid = this.listGrid;
  grid.setData(input);
  sender = new ListGridField_3('sender', ($clinit_Enhanced() , 'Sender'));
  sender.jsObj['width'] = '33%';
  status_0 = new ListGridField_3('status', 'Status');
  status_0.jsObj['width'] = '50';
  $setAttribute_13(status_0, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_13(status_0, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setCellFormatter_0(status_0, new AlertDetailsView$NotificationLogsTable$1_0);
  $setAttribute_8(status_0, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(status_0, new AlertDetailsView$NotificationLogsTable$2_0);
  message = new ListGridField_3('message', 'Message');
  message.jsObj['width'] = '*';
  $isCreated_1(grid)?$setProperty_2(grid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [sender, status_0, message]))):(grid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [sender, status_0, message])) , undefined);
}
;
_.record_0 = null;
function AlertDetailsView$NotificationLogsTable$1_0(){
}

defineSeed(1877, 1, {}, AlertDetailsView$NotificationLogsTable$1_0);
_.format_1 = function format_11(value, record, rowNum, colNum){
  var statusEnum, statusStr;
  statusStr = getAttribute(record.jsObj, 'status');
  statusEnum = statusStr == null?($clinit_ResultState() , UNKNOWN):($clinit_ResultState() , dynamicCast(valueOf(($clinit_ResultState$Map() , $MAP_48), statusStr), Q$ResultState));
  return imgHTML(getAlertNotificationResultIcon(statusEnum));
}
;
function AlertDetailsView$NotificationLogsTable$2_0(){
}

defineSeed(1878, 1, {}, AlertDetailsView$NotificationLogsTable$2_0);
_.hoverHTML_0 = function hoverHTML_3(value, record, rowNum, colNum){
  var statusEnum, statusStr;
  statusStr = getAttribute(record.jsObj, 'status');
  statusEnum = statusStr == null?($clinit_ResultState() , UNKNOWN):($clinit_ResultState() , dynamicCast(valueOf(($clinit_ResultState$Map() , $MAP_48), statusStr), Q$ResultState));
  switch (statusEnum.ordinal) {
    case 0:
      return $clinit_Enhanced() , 'Success';
    case 2:
      return $clinit_Enhanced() , 'Failed';
    case 1:
      return $clinit_Enhanced() , 'Partial';
    case 3:
      return $clinit_Enhanced() , 'Deferred';
    case 4:
    default:return $clinit_Enhanced() , 'Unknown';
  }
}
;
function $clinit_AlertFormatUtility(){
  $clinit_AlertFormatUtility = nullMethod;
  $clinit_CoreGUI();
}

function formatAlertConditionForDisplay(condition){
  $clinit_AlertFormatUtility();
  var $e0, category, configNameRegex, formatted, formattedHiValue, formattedLoValue, hiValue, loValue, metricName, operator, pathNameRegex, str, units, value;
  str = new StringBuilder_0;
  category = condition.category;
  switch (category.ordinal) {
    case 0:
      {
        $append_1(str.data_0, 'Availability');
        $append_1(str.data_0, ' [');
        operator = valueOf_51(condition.name_0.toUpperCase());
        switch (operator.ordinal) {
          case 10:
            $append_1(str.data_0, 'Goes disabled');
            break;
          case 9:
            $append_1(str.data_0, 'Goes down');
            break;
          case 11:
            $append_1(str.data_0, 'Goes unknown');
            break;
          case 13:
            $append_1(str.data_0, 'Goes up');
            break;
          case 12:
            $append_1(str.data_0, 'Goes not up');
            break;
          default:$append_1(str.data_0, '*ERROR*');
        }
        $append_1(str.data_0, ']');
        break;
      }

    case 11:
      {
        $append_1(str.data_0, 'Availability Duration');
        $append_1(str.data_0, ' [');
        operator = valueOf_51(condition.name_0.toUpperCase());
        switch (operator.ordinal) {
          case 14:
            $append_1(str.data_0, 'Stays Down');
            break;
          case 15:
            $append_1(str.data_0, 'Stays Not Up');
            break;
          default:$append_1(str.data_0, '*ERROR*');
        }
        $append_1(str.data_0, ' For ');
        value = '' + ~~(valueOf_44(__parseAndValidateInt(condition.option)).value_0 / 60);
        formatted = format_92(value, ($clinit_MeasurementUnits() , MINUTES_0));
        $append_1(str.data_0, formatted);
        $append_1(str.data_0, ']');
        break;
      }

    case 1:
      {
        value = condition.threshold.value_0;
        units = condition.measurementDefinition.units;
        formatted = ($clinit_MeasurementConverterClient() , format_91(new Double_0(value), units));
        if (condition.option == null) {
          $append_1(str.data_0, 'Metric Value Threshold');
          $append_1(str.data_0, ' [');
          $append_12(str, condition.name_0);
          $append_1(str.data_0, ' ');
          $append_12(str, condition.comparator);
          $append_1(str.data_0, ' ');
          $append_1(str.data_0, formatted);
          $append_1(str.data_0, ']');
        }
         else {
          $append_1(str.data_0, 'Call Time Value Threshold');
          $append_1(str.data_0, ' [');
          if (condition.measurementDefinition) {
            $append_12(str, condition.measurementDefinition.displayName);
            $append_1(str.data_0, ' ');
          }
          $append_12(str, condition.option);
          $append_1(str.data_0, ' ');
          $append_12(str, condition.comparator);
          $append_1(str.data_0, ' ');
          $append_1(str.data_0, formatted);
          $append_1(str.data_0, ']');
          if (condition.name_0 != null && condition.name_0.length > 0) {
            $append_1(str.data_0, ' ');
            $append_1(str.data_0, 'with call destination matching');
            $append_1(str.data_0, " '");
            $append_12(str, condition.name_0);
            $append_1(str.data_0, "'");
          }
        }
        break;
      }

    case 2:
      {
        $append_1(str.data_0, 'Metric Value Baseline');
        $append_1(str.data_0, ' [');
        $append_12(str, condition.name_0);
        $append_1(str.data_0, ' ');
        $append_12(str, condition.comparator);
        $append_1(str.data_0, ' ');
        value = condition.threshold.value_0;
        units = ($clinit_MeasurementUnits() , PERCENTAGE);
        formatted = ($clinit_MeasurementConverterClient() , format_91(new Double_0(value), units));
        $append_1(str.data_0, formatted);
        $append_12($append_12(($append_1(str.data_0, ' ') , str), 'of'), ' ');
        $append_12(str, condition.option);
        $append_1(str.data_0, ']');
        break;
      }

    case 3:
      {
        if (condition.option == null) {
          $append_1(str.data_0, 'Metric Value Change');
          $append_1(str.data_0, ' [');
          $append_12(str, condition.name_0);
          $append_1(str.data_0, ']');
        }
         else {
          $append_1(str.data_0, 'Call Time Value Changes');
          $append_1(str.data_0, ' [');
          if (condition.measurementDefinition) {
            $append_12(str, condition.measurementDefinition.displayName);
            $append_1(str.data_0, ' ');
          }
          $append_12(str, condition.option);
          $append_1(str.data_0, ' ');
          $append_12(str, getCalltimeChangeComparator(condition.comparator));
          $append_1(str.data_0, ' ');
          $append_1(str.data_0, 'by at least');
          $append_1(str.data_0, ' ');
          value = condition.threshold.value_0;
          units = ($clinit_MeasurementUnits() , PERCENTAGE);
          formatted = ($clinit_MeasurementConverterClient() , format_91(new Double_0(value), units));
          $append_1(str.data_0, formatted);
          $append_1(str.data_0, ']');
          if (condition.name_0 != null && condition.name_0.length > 0) {
            $append_1(str.data_0, ' ');
            $append_1(str.data_0, 'with call destination matching');
            $append_1(str.data_0, " '");
            $append_12(str, condition.name_0);
            $append_1(str.data_0, "'");
          }
        }
        break;
      }

    case 4:
      {
        $append_1(str.data_0, 'Trait Change');
        $append_1(str.data_0, ' [');
        $append_12(str, condition.name_0);
        $append_1(str.data_0, ']');
        if (condition.option != null && condition.option.length > 0) {
          $append_1(str.data_0, ' ');
          $append_1(str.data_0, 'with trait value matching');
          $append_1(str.data_0, " '");
          $append_12(str, condition.option);
          $append_1(str.data_0, "'");
        }
        break;
      }

    case 5:
      {
        $append_1(str.data_0, 'Operation Execution');
        $append_1(str.data_0, ' [');
        $append_12(str, condition.name_0);
        $append_1(str.data_0, '] ');
        $append_1(str.data_0, 'with result status');
        $append_1(str.data_0, ' [');
        $append_12(str, condition.option);
        $append_1(str.data_0, ']');
        break;
      }

    case 7:
      {
        $append_1(str.data_0, 'Resource Configuration Change');
        break;
      }

    case 8:
      {
        $append_1(str.data_0, 'Event Detection');
        $append_1(str.data_0, ' [');
        $append_12(str, condition.name_0);
        $append_1(str.data_0, ']');
        if (condition.option != null && condition.option.length > 0) {
          $append_1(str.data_0, ' ');
          $append_1(str.data_0, 'with event source matching');
          $append_1(str.data_0, " '");
          $append_12(str, condition.option);
          $append_1(str.data_0, "'");
        }
        break;
      }

    case 9:
      {
        configNameRegex = condition.name_0;
        pathNameRegex = condition.option;
        configNameRegex == null || configNameRegex.length == 0?pathNameRegex == null || pathNameRegex.length == 0?($append_1(str.data_0, 'Drift Detection') , str):($append_1(str.data_0, 'Drift Detection for files that match "' + pathNameRegex + '"') , str):pathNameRegex == null || pathNameRegex.length == 0?($append_1(str.data_0, 'Drift Detection for drift definition [' + configNameRegex + ']') , str):($append_1(str.data_0, 'Drift Detection for files that match "' + pathNameRegex + '" and for drift definition [' + configNameRegex + ']') , str);
        break;
      }

    case 10:
      {
        metricName = condition.name_0;
        units = condition.measurementDefinition.units;
        loValue = condition.threshold.value_0;
        formattedLoValue = ($clinit_MeasurementConverterClient() , format_91(new Double_0(loValue), units));
        formattedHiValue = condition.option;
        try {
          hiValue = __parseAndValidateDouble(formattedHiValue);
          formattedHiValue = format_91(new Double_0(hiValue), units);
        }
         catch ($e0) {
          $e0 = caught_0($e0);
          if (instanceOf($e0, Q$Exception)) {
            formattedHiValue = '?[' + formattedHiValue + ']?';
          }
           else 
            throw $e0;
        }
        $equals_6(condition.comparator, '<')?($append_1(str.data_0, 'Metric Value Range: [' + metricName + '] between [' + formattedLoValue + '] and [' + formattedHiValue + '], exclusive') , str):$equals_6(condition.comparator, '>')?($append_1(str.data_0, 'Metric Value Range: [' + metricName + '] outside [' + formattedLoValue + '] and [' + formattedHiValue + '], exclusive') , str):$equals_6(condition.comparator, '<=')?($append_1(str.data_0, 'Metric Value Range: [' + metricName + '] between [' + formattedLoValue + '] and [' + formattedHiValue + '], inclusive') , str):$equals_6(condition.comparator, '>=')?($append_1(str.data_0, 'Metric Value Range: [' + metricName + '] outside [' + formattedLoValue + '] and [' + formattedHiValue + '], inclusive') , str):$append_12(str, 'BAD COMPARATOR! Report this bug: ' + condition.comparator);
        break;
      }

    default:{
        $append_12(str, 'Invalid condition category - please report this as a bug: ' + category.name_0);
        break;
      }

  }
  return $toString_1(str.data_0);
}

function getAlertRecoveryInfo(alert_0){
  $clinit_AlertFormatUtility();
  var otherAlertDef, recoveryAlertDefinition, recoveryInfo, resourceId;
  recoveryAlertDefinition = alert_0.recoveryAlertDefinition;
  if (!!recoveryAlertDefinition && recoveryAlertDefinition.id != 0) {
    resourceId = alert_0.alertDefinition.resource.id;
    otherAlertDef = '<a href="/alerts/Config.do?mode=viewRoles&id=' + resourceId + '&ad=' + recoveryAlertDefinition.id + '">' + recoveryAlertDefinition.name_0 + '<\/a>';
    recoveryInfo = "Triggered '" + otherAlertDef + "' to be re-enabled";
  }
   else 
    alert_0.willRecover?(recoveryInfo = 'This alert caused its alert definition to be disabled'):(recoveryInfo = 'N/A');
  return recoveryInfo;
}

function getCalltimeChangeComparator(comparator){
  return $equals_6('HI', comparator)?'Grows':$equals_6('LO', comparator)?'Shrinks':'Changes';
}

function $clinit_AlertHistoryView(){
  $clinit_AlertHistoryView = nullMethod;
  var i, priorityNames, priorityValues, priorityValuesLength;
  $clinit_BaseWidget();
  SUBSYSTEM_VIEW_ID = new ViewName_2('RecentAlerts', ($clinit_Enhanced() , 'Recent Alerts'), ($clinit_IconEnum() , RECENT_ALERTS));
  DEFAULT_SORT_SPECIFIER_0 = new SortSpecifier_0('ctime', ($clinit_SortDirection() , DESCENDING));
  INITIAL_CRITERIA_0 = new Criteria_0;
  priorityValues = ($clinit_AlertPriority() , $clinit_AlertPriority() , $VALUES_46);
  priorityNames = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, priorityValues.length, 0);
  for (i = 0 , priorityValuesLength = priorityValues.length; i < priorityValuesLength; ++i) {
    priorityNames[i] = priorityValues[i].name_0;
  }
  $addCriteria_6(INITIAL_CRITERIA_0, 'priorities', priorityNames);
}

function $acknowledge(this$static, records){
  var alertId, alertIds, i, record, selectionLength;
  alertIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, records.length, 1);
  for (i = 0 , selectionLength = records.length; i < selectionLength; ++i) {
    record = records[i];
    alertId = getAttributeAsInt(record.jsObj, 'id');
    alertIds[i] = alertId.value_0;
  }
  $acknowledgeAlerts(dynamicCast(secure(getInstance_32(), -1), Q$AlertGWTServiceAsync), alertIds, new AlertHistoryView$9_0(this$static, alertIds));
}

function $acknowledgeAll(this$static){
  var rpcTimeout;
  rpcTimeout = 10000 + $getTotalRows(this$static.listGrid);
  $acknowledgeAlertsByContext(dynamicCast(secure(getInstance_32(), rpcTimeout), Q$AlertGWTServiceAsync), this$static.context, new AlertHistoryView$10_0(this$static));
}

function $configureTable_1(this$static){
  var dataSourceFields;
  dataSourceFields = $getListGridFields_5(dynamicCast(this$static.getDataSource_0(), Q$AlertDataSource));
  $setFields_1(this$static.listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
  this$static.setupTableInteractions(this$static.hasWriteAccess);
  $configureTable(this$static);
}

function $delete_1(this$static, records){
  var alertId, alertIds, i, record, selectionLength;
  alertIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, records.length, 1);
  for (i = 0 , selectionLength = records.length; i < selectionLength; ++i) {
    record = records[i];
    alertId = getAttributeAsInt(record.jsObj, 'id');
    alertIds[i] = alertId.value_0;
  }
  $deleteAlerts(dynamicCast(secure(getInstance_32(), -1), Q$AlertGWTServiceAsync), alertIds, new AlertHistoryView$7_0(this$static, alertIds));
}

function $deleteAll(this$static){
  var rpcTimeout;
  rpcTimeout = 10000 + $getTotalRows(this$static.listGrid);
  $deleteAlertsByContext(dynamicCast(secure(getInstance_32(), rpcTimeout), Q$AlertGWTServiceAsync), this$static.context, new AlertHistoryView$8_0(this$static));
}

function $setupTableInteractions_0(this$static, hasWriteAccess){
  $addTableAction(this$static, ($clinit_Enhanced() , 'Delete'), 'Delete the selected alert(s)?', null, new AlertHistoryView$2_0(this$static, this$static, ($clinit_TableActionEnablement() , ANY_1), hasWriteAccess?null:($clinit_Permission() , MANAGE_ALERTS), new AlertHistoryView$1_0));
  $addTableAction(this$static, 'Acknowledge', 'Acknowledge the selected alert(s)?', null, new AlertHistoryView$4_0(this$static, this$static, ANY_1, hasWriteAccess?null:($clinit_Permission() , MANAGE_ALERTS), new AlertHistoryView$3_0));
  if (this$static.canSupportDeleteAndAcknowledgeAll()) {
    $addTableAction(this$static, 'Delete All', 'Delete all alerts from this source?', null, new AlertHistoryView$5_0(this$static, hasWriteAccess));
    $addTableAction(this$static, 'Acknowledge All', 'Acknowledge all alerts from this source?', null, new AlertHistoryView$6_0(this$static, hasWriteAccess));
  }
}

function AlertHistoryView_0(){
  $clinit_AlertHistoryView();
  AlertHistoryView_1.call(this, SUBSYSTEM_VIEW_ID.title_0, new EntityContext_0(null, null, null), false);
}

function AlertHistoryView_1(tableTitle, context, hasWriteAccess){
  TableSection_2.call(this, tableTitle, INITIAL_CRITERIA_0, initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [DEFAULT_SORT_SPECIFIER_0]));
  this.context = context;
  this.hasWriteAccess = hasWriteAccess;
  this.initialCriteriaFixed = false;
  $setDataSource(this, new AlertDataSource_0(context));
}

defineSeed(1880, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), AlertHistoryView_0);
_.canSupportDeleteAndAcknowledgeAll = function canSupportDeleteAndAcknowledgeAll(){
  return true;
}
;
_.configureTable = function configureTable_13(){
  $configureTable_1(this);
}
;
_.configureTableFilters = function configureTableFilters_1(){
  var priorities, priorityIcons, spacerItem;
  priorities = new LinkedHashMap_1(3);
  $put_1(priorities, ($clinit_AlertPriority() , HIGH).name_0, ($clinit_Enhanced() , 'High'));
  $put_1(priorities, MEDIUM.name_0, 'Medium');
  $put_1(priorities, LOW.name_0, 'Low');
  priorityIcons = new LinkedHashMap_1(3);
  $put_1(priorityIcons, HIGH.name_0, 'subsystems/alert/Alert_' + HIGH.name_0 + '_16.png');
  $put_1(priorityIcons, MEDIUM.name_0, 'subsystems/alert/Alert_' + MEDIUM.name_0 + '_16.png');
  $put_1(priorityIcons, LOW.name_0, 'subsystems/alert/Alert_' + LOW.name_0 + '_16.png');
  this.priorityFilter = new EnumSelectItem_0('priorities', 'Priority Filter', Lorg_rhq_core_domain_alert_AlertPriority_2_classLit, priorities, priorityIcons);
  this.startDateFilter = new DateFilterItem_0('startTime', 'From');
  this.endDateFilter = new DateFilterItem_0('endTime', 'To');
  spacerItem = new SpacerItem_0;
  spacerItem.setColSpan(2);
  this.showFilterForm && $setFilterFormItems(this, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.priorityFilter, this.startDateFilter, spacerItem, this.endDateFilter]));
}
;
_.getDetailsLinkColumnName = function getDetailsLinkColumnName_0(){
  return 'ctime';
}
;
_.getDetailsView_0 = function getDetailsView_8(alertId){
  return $clinit_AlertDetailsView() , $clinit_AlertDetailsView() , INSTANCE_3;
}
;
_.getViewName = function getViewName_5(){
  return SUBSYSTEM_VIEW_ID;
}
;
_.setupTableInteractions = function setupTableInteractions(hasWriteAccess){
  $setupTableInteractions_0(this, hasWriteAccess);
}
;
_.context = null;
_.endDateFilter = null;
_.hasWriteAccess = false;
_.priorityFilter = null;
_.startDateFilter = null;
var DEFAULT_SORT_SPECIFIER_0, INITIAL_CRITERIA_0, SUBSYSTEM_VIEW_ID;
function AlertHistoryView$1_0(){
}

defineSeed(1881, 1, {}, AlertHistoryView$1_0);
_.extract = function extract(records){
  var record, record$index, record$max, result;
  result = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_3(result, getAttributeAsInt(record.jsObj, 'resourceId'));
  }
  return result;
}
;
function $onSuccess_89(this$static, resultCount){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully acknowledged ' + ($clinit_Enhanced() , '' + resultCount) + ' alerts', ($clinit_Message$Severity() , Info)));
  this$static.this$0.refresh_0();
}

function AlertHistoryView$10_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1882, 1, {}, AlertHistoryView$10_0);
_.onFailure = function onFailure_92(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to acknowledge all alerts from this source'), caught);
  this.this$0.refreshTableInfo();
}
;
_.onSuccess_0 = function onSuccess_92(resultCount){
  $onSuccess_89(this, dynamicCast(resultCount, Q$Integer));
}
;
_.this$0 = null;
function $isEnabled_1(this$static, selection){
  var isNewSelection, selectedResourceIds;
  if (!$isEnabled(this$static, selection)) {
    return false;
  }
  if (!this$static.requiredPermission) {
    return true;
  }
  selectedResourceIds = this$static.extractor.extract(selection);
  isNewSelection = !$equals(selectedResourceIds, this$static.authorizedResourceIds);
  if (isNewSelection) {
    this$static.isAuthorized = ($clinit_Boolean() , $clinit_Boolean() , FALSE);
    this$static.authorizedResourceIds = selectedResourceIds;
  }
   else {
    return this$static.isAuthorized.value_0;
  }
  $hasResourcePermission(dynamicCast(secure(getInstance_34(), -1), Q$AuthorizationGWTServiceAsync), this$static.requiredPermission, selectedResourceIds, new ResourceAuthorizedTableAction$1_0(this$static, selectedResourceIds));
  return this$static.isAuthorized.value_0;
}

function ResourceAuthorizedTableAction_0(table, enablement, requiredPermission, extractor){
  this.enablement = enablement;
  this.table = table;
  this.requiredPermission = requiredPermission;
  this.extractor = extractor;
  if (!!this.requiredPermission && ($clinit_Permission$Target() , RESOURCE) != this.requiredPermission.target) {
    throw new IllegalArgumentException_1('Does not support Global permission');
  }
}

defineSeed(1884, 1608, {});
_.isEnabled_0 = function isEnabled_8(selection){
  return $isEnabled_1(this, selection);
}
;
_.authorizedResourceIds = null;
_.extractor = null;
_.isAuthorized = null;
_.requiredPermission = null;
_.table = null;
function AlertHistoryView$2_0(this$0, $anonymous0, $anonymous1, $anonymous2, $anonymous3){
  this.this$0 = this$0;
  ResourceAuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2, $anonymous3);
}

defineSeed(1883, 1884, {}, AlertHistoryView$2_0);
_.executeAction = function executeAction_19(selection, actionValue){
  $delete_1(this.this$0, selection);
}
;
_.this$0 = null;
function AlertHistoryView$3_0(){
}

defineSeed(1885, 1, {}, AlertHistoryView$3_0);
_.extract = function extract_0(records){
  var record, record$index, record$max, result;
  result = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_3(result, getAttributeAsInt(record.jsObj, 'resourceId'));
  }
  return result;
}
;
function AlertHistoryView$4_0(this$0, $anonymous0, $anonymous1, $anonymous2, $anonymous3){
  this.this$0 = this$0;
  ResourceAuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2, $anonymous3);
}

defineSeed(1886, 1884, {}, AlertHistoryView$4_0);
_.executeAction = function executeAction_20(selection, actionValue){
  $acknowledge(this.this$0, selection);
}
;
_.this$0 = null;
function AlertHistoryView$5_0(this$0, val$hasWriteAccess){
  this.this$0 = this$0;
  this.val$hasWriteAccess = val$hasWriteAccess;
}

defineSeed(1887, 1, {}, AlertHistoryView$5_0);
_.executeAction = function executeAction_21(selection, actionValue){
  $deleteAll(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_9(selection){
  var grid, resultSet;
  grid = this.this$0.listGrid;
  resultSet = grid?$getResultSet(grid):null;
  return this.val$hasWriteAccess && !!grid && !!resultSet && !$isEmpty_0(resultSet).value_0;
}
;
_.this$0 = null;
_.val$hasWriteAccess = false;
function AlertHistoryView$6_0(this$0, val$hasWriteAccess){
  this.this$0 = this$0;
  this.val$hasWriteAccess = val$hasWriteAccess;
}

defineSeed(1888, 1, {}, AlertHistoryView$6_0);
_.executeAction = function executeAction_22(selection, actionValue){
  $acknowledgeAll(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_10(selection){
  var grid, resultSet;
  grid = this.this$0.listGrid;
  resultSet = grid?$getResultSet(grid):null;
  return this.val$hasWriteAccess && !!grid && !!resultSet && !$isEmpty_0(resultSet).value_0;
}
;
_.this$0 = null;
_.val$hasWriteAccess = false;
function $onSuccess_90(this$static, resultCount){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully deleted ' + ($clinit_Enhanced() , '' + resultCount) + ' alerts', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, true);
}

function AlertHistoryView$7_0(this$0, val$alertIds){
  this.this$0 = this$0;
  this.val$alertIds = val$alertIds;
}

defineSeed(1889, 1, {}, AlertHistoryView$7_0);
_.onFailure = function onFailure_93(caught){
  $handleError_0(($clinit_CoreGUI() , "Failed to delete alerts with id's: " + ($clinit_Enhanced() , toString_30(this.val$alertIds))), caught);
  this.this$0.refreshTableInfo();
}
;
_.onSuccess_0 = function onSuccess_93(resultCount){
  $onSuccess_90(this, dynamicCast(resultCount, Q$Integer));
}
;
_.this$0 = null;
_.val$alertIds = null;
function $onSuccess_91(this$static, resultCount){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully deleted ' + ($clinit_Enhanced() , '' + resultCount) + ' alerts', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, true);
}

function AlertHistoryView$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1890, 1, {}, AlertHistoryView$8_0);
_.onFailure = function onFailure_94(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete all alerts from this source'), caught);
  this.this$0.refreshTableInfo();
}
;
_.onSuccess_0 = function onSuccess_94(resultCount){
  $onSuccess_91(this, dynamicCast(resultCount, Q$Integer));
}
;
_.this$0 = null;
function $onSuccess_92(this$static, resultCount){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully acknowledged ' + ($clinit_Enhanced() , '' + resultCount) + ' alerts', ($clinit_Message$Severity() , Info)));
  this$static.this$0.refresh_0();
}

function AlertHistoryView$9_0(this$0, val$alertIds){
  this.this$0 = this$0;
  this.val$alertIds = val$alertIds;
}

defineSeed(1891, 1, {}, AlertHistoryView$9_0);
_.onFailure = function onFailure_95(caught){
  $handleError_0(($clinit_CoreGUI() , "Failed to acknowledge alerts with id's: " + ($clinit_Enhanced() , toString_30(this.val$alertIds))), caught);
  this.this$0.refreshTableInfo();
}
;
_.onSuccess_0 = function onSuccess_95(resultCount){
  $onSuccess_92(this, dynamicCast(resultCount, Q$Integer));
}
;
_.this$0 = null;
_.val$alertIds = null;
function GroupAlertHistoryView_0(tableTitle, context, hasWriteAccess){
  AlertHistoryView_1.call(this, tableTitle, context, hasWriteAccess);
}

function get_18(composite){
  $clinit_AlertHistoryView();
  var context, hasWriteAccess;
  $clinit_Enhanced();
  context = new EntityContext_0(null, valueOf_44(composite.resourceGroup.id), null);
  hasWriteAccess = composite.resourcePermission.permissions.contains_0(($clinit_Permission() , MANAGE_ALERTS));
  return new GroupAlertHistoryView_0('Group Alert History', context, hasWriteAccess);
}

defineSeed(1892, 1880, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), GroupAlertHistoryView_0);
function ResourceAlertHistoryView_0(tableTitle, context, hasWriteAccess){
  AlertHistoryView_1.call(this, tableTitle, context, hasWriteAccess);
}

function get_19(composite){
  $clinit_AlertHistoryView();
  var context, hasWriteAccess;
  $clinit_Enhanced();
  context = new EntityContext_0(valueOf_44(composite.resource.id), null, null);
  hasWriteAccess = composite.resourcePermission.permissions.contains_0(($clinit_Permission() , MANAGE_ALERTS));
  return new ResourceAlertHistoryView_0('Resource Alert History', context, hasWriteAccess);
}

defineSeed(1893, 1880, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), ResourceAlertHistoryView_0);
defineSeed(1894, 1880, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]));
function $addDataSourceFields_0(){
  var ctimeField, descriptionField, enabledField, fields, mtimeField, nameField, priorityField;
  fields = new ArrayList_0;
  nameField = new DataSourceTextField_1('name', 'Name');
  setCheck(fields.array, fields.size_0++, nameField);
  descriptionField = new DataSourceTextField_1('description', 'Description');
  setCheck(fields.array, fields.size_0++, descriptionField);
  ctimeField = new DataSourceTextField_1('ctime', 'Creation Time');
  $setAttribute_13(ctimeField, 'type', ($clinit_FieldType() , DATETIME).value_0);
  setCheck(fields.array, fields.size_0++, ctimeField);
  mtimeField = new DataSourceTextField_1('mtime', 'Modified Time');
  $setAttribute_13(mtimeField, 'type', DATETIME.value_0);
  setCheck(fields.array, fields.size_0++, mtimeField);
  enabledField = new DataSourceImageField_1('enabled', 'Enabled');
  setCheck(fields.array, fields.size_0++, enabledField);
  priorityField = new DataSourceImageField_1('priority', 'Priority');
  setCheck(fields.array, fields.size_0++, priorityField);
  return fields;
}

function $copyValues_18(from){
  var alertDef;
  alertDef = dynamicCast(getAttributeAsObject(from.jsObj, '_object'), Q$AlertDefinition);
  return alertDef;
}

function $copyValues_19(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'name', from.name_0);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_14(record, 'ctime', new Date_2(from.ctime));
  $setAttribute_14(record, 'mtime', new Date_2(from.mtime));
  $setAttribute_13(record, 'enabled', getAvailabilityIcon(($clinit_Boolean() , from.enabled?TRUE:FALSE)));
  $setAttribute_16(record, 'deleted', from.deleted);
  $setAttribute_13(record, 'priority', 'subsystems/alert/Alert_' + from.priority.name_0 + '_16.png');
  !from?(record.jsObj['_object'] = null , undefined):(record.jsObj['_object'] = from , undefined);
  return record;
}

function $executeFetch_9(this$static, request, response, criteria){
  $findAlertDefinitionsByCriteria(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), criteria, new AbstractAlertDefinitionsDataSource$2_0(this$static, response, request));
}

function $getListGridFields_6(){
  var ctimeField, descriptionField, enabledField, fields, mtimeField, nameField, priorityField;
  fields = new ArrayList_1(6);
  nameField = new ListGridField_3('name', 'Name');
  nameField.jsObj['width'] = '20%';
  $setCellFormatter_0(nameField, new EscapedHtmlCellFormatter_0);
  setCheck(fields.array, fields.size_0++, nameField);
  descriptionField = new ListGridField_3('description', 'Description');
  descriptionField.jsObj['width'] = '20%';
  $setCellFormatter_0(descriptionField, new EscapedHtmlCellFormatter_0);
  setCheck(fields.array, fields.size_0++, descriptionField);
  ctimeField = new ListGridField_3('ctime', 'Creation Time');
  $setAttribute_13(ctimeField, 'type', ($clinit_ListGridFieldType() , DATE_0).value_0);
  $clinit_TimestampCellFormatter();
  prepareDateField(ctimeField, getAttribute(ctimeField.jsObj, 'name'));
  ctimeField.jsObj['width'] = '15%';
  setCheck(fields.array, fields.size_0++, ctimeField);
  mtimeField = new ListGridField_3('mtime', 'Modified Time');
  $setAttribute_13(mtimeField, 'type', DATE_0.value_0);
  prepareDateField(mtimeField, getAttribute(mtimeField.jsObj, 'name'));
  mtimeField.jsObj['width'] = '15%';
  setCheck(fields.array, fields.size_0++, mtimeField);
  enabledField = new ListGridField_3('enabled', 'Enabled');
  $setAttribute_13(enabledField, 'type', IMAGE_0.value_0);
  $setAttribute_13(enabledField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  enabledField.jsObj['width'] = 60;
  setCheck(fields.array, fields.size_0++, enabledField);
  priorityField = new ListGridField_3('priority', 'Priority');
  $setAttribute_13(priorityField, 'type', IMAGE_0.value_0);
  priorityField.jsObj['width'] = 60;
  $setAttribute_13(priorityField, 'align', CENTER_0.value_0);
  $setAttribute_8(priorityField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(priorityField, new AbstractAlertDefinitionsDataSource$1_0);
  setCheck(fields.array, fields.size_0++, priorityField);
  return fields;
}

function AbstractAlertDefinitionsDataSource_0(){
  var fields;
  RPCDataSource_0.call(this);
  fields = this.addDataSourceFields();
  $addFields(this, fields);
}

defineSeed(1895, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]));
_.addDataSourceFields = function addDataSourceFields(){
  return $addDataSourceFields_0();
}
;
_.copyValues = function copyValues_26(from){
  return $copyValues_18(from);
}
;
_.copyValues_0 = function copyValues_27(from){
  return this.copyValues_2(dynamicCast(from, Q$AlertDefinition));
}
;
_.copyValues_2 = function copyValues_28(from){
  return $copyValues_19(from);
}
;
_.dataRetrieved = function dataRetrieved(result, response, request){
  $setAttribute_17(response, 'data', $buildRecords(this, result, true));
  $processResponse_0(this, getAttribute(request.jsObj, 'requestId'), response);
}
;
_.executeFetch = function executeFetch_15(request, response, criteria){
  $executeFetch_9(this, request, response, dynamicCast(criteria, Q$AlertDefinitionCriteria));
}
;
_.getListGridFields_0 = function getListGridFields_2(){
  return $getListGridFields_6();
}
;
function AbstractAlertDefinitionsDataSource$1_0(){
}

defineSeed(1896, 1, {}, AbstractAlertDefinitionsDataSource$1_0);
_.hoverHTML_0 = function hoverHTML_4(value, record, rowNum, colNum){
  var alertDef;
  alertDef = dynamicCast(getAttributeAsObject(record.jsObj, '_object'), Q$AlertDefinition);
  switch (alertDef.priority.ordinal) {
    case 2:
      {
        return $clinit_RPCDataSource() , 'High';
      }

    case 1:
      {
        return $clinit_RPCDataSource() , 'Medium';
      }

    case 0:
      {
        return $clinit_RPCDataSource() , 'Low';
      }

  }
  return '';
}
;
function $onSuccess_93(this$static, result){
  this$static.this$0.dataRetrieved(result, this$static.val$response, this$static.val$request);
}

function AbstractAlertDefinitionsDataSource$2_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1897, 1, {}, AbstractAlertDefinitionsDataSource$2_0);
_.onFailure = function onFailure_96(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to fetch alert definition data'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_96(result){
  $onSuccess_93(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $getDetailsView(this$static, id){
  var criteria, newAlertDef, singleAlertDefinitionView;
  singleAlertDefinitionView = new SingleAlertDefinitionView_0(this$static);
  if (id.value_0 == 0) {
    newAlertDef = new AlertDefinition_0;
    newAlertDef.deleted = false;
    newAlertDef.enabled = true;
    $setPriority(newAlertDef, ($clinit_AlertPriority() , MEDIUM));
    $setParentId(newAlertDef, valueOf_44(0));
    $setConditionExpression(newAlertDef, ($clinit_BooleanExpression() , ANY_0));
    $setWillRecover(newAlertDef, false);
    $setRecoveryId(newAlertDef, valueOf_44(0));
    $setAlertDampening(newAlertDef, new AlertDampening_1(($clinit_AlertDampening$Category() , NONE_5)));
    newAlertDef.notifyFiltered = false;
    newAlertDef.controlFiltered = false;
    $setAlertDefinition_5(singleAlertDefinitionView, newAlertDef);
    $makeEditable_4(singleAlertDefinitionView);
  }
   else {
    criteria = this$static.getDetailCriteria();
    criteria.filterId = id;
    criteria.fetchGroupAlertDefinition = true;
    criteria.fetchConditions = true;
    criteria.fetchAlertNotifications = true;
    $findAlertDefinitionsByCriteria(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), criteria, new AbstractAlertDefinitionsView$5_0(id, singleAlertDefinitionView));
  }
  return singleAlertDefinitionView;
}

function AbstractAlertDefinitionsView_0(tableTitle, initialCriteria){
  Table_3.call(this, tableTitle, initialCriteria);
  this.escapeHtmlInDetailsLinkColumn = true;
}

defineSeed(1898, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_14(){
  var descriptionField, ds, isAuthorized, listGrid, nameField;
  listGrid = this.listGrid;
  ds = this.getAlertDefinitionDataSource();
  this.dataSource_1 = ds;
  $setAttribute_20(listGrid, 'dataSource', $getOrCreateJsObj(ds), true);
  $setFields_1(listGrid, dynamicCast($toArray_1(ds.getListGridFields_0(), initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, 0, 0)), Q$ListGridField_$1));
  $setUseAllDataSourceFields(listGrid, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setWrapCells(listGrid, TRUE);
  $setFixedRecordHeights(listGrid, FALSE);
  nameField = $getField_1(listGrid, 'name');
  $setCellFormatter_0(nameField, new EscapedHtmlCellFormatter_0);
  descriptionField = $getField_1(listGrid, 'description');
  $setCellFormatter_0(descriptionField, new EscapedHtmlCellFormatter_0);
  isAuthorized = this.isAuthorizedToModifyAlertDefinitions_0();
  $addTableAction(this, ($clinit_Enhanced() , 'New'), null, null, new AbstractAlertDefinitionsView$1_0(this, isAuthorized));
  $addTableAction(this, 'Enable', 'Enable the selected alert definition(s)?', null, new AbstractAlertDefinitionsView$2_0(this, ($clinit_TableActionEnablement() , ANY_1), isAuthorized));
  $addTableAction(this, 'Disable', 'Disable the selected alert definition(s)?', null, new AbstractAlertDefinitionsView$3_0(this, ANY_1, isAuthorized));
  $addTableAction(this, 'Delete', 'Delete the selected alert definition(s)?', null, new AbstractAlertDefinitionsView$4_0(this, ANY_1, isAuthorized));
  $configureTable(this);
}
;
_.getDetailCriteria = function getDetailCriteria(){
  return new AlertDefinitionCriteria_0;
}
;
_.getDetailsView_0 = function getDetailsView_9(id){
  return this.getDetailsView_1(id);
}
;
_.getDetailsView_1 = function getDetailsView_10(id){
  return $getDetailsView(this, id);
}
;
function AbstractAlertDefinitionsView$1_0(this$0, val$isAuthorized){
  this.this$0 = this$0;
  this.val$isAuthorized = val$isAuthorized;
  AbstractTableAction_0.call(this);
}

defineSeed(1899, 1608, {}, AbstractAlertDefinitionsView$1_0);
_.executeAction = function executeAction_23(selection, actionValue){
  this.this$0.newButtonPressed(selection);
}
;
_.isEnabled_0 = function isEnabled_11(selection){
  return $isEnabled(this, selection) && this.val$isAuthorized;
}
;
_.this$0 = null;
_.val$isAuthorized = false;
function AbstractAlertDefinitionsView$2_0(this$0, $anonymous0, val$isAuthorized){
  this.this$0 = this$0;
  this.val$isAuthorized = val$isAuthorized;
  this.enablement = $anonymous0;
}

defineSeed(1900, 1608, {}, AbstractAlertDefinitionsView$2_0);
_.executeAction = function executeAction_24(selection, actionValue){
  this.this$0.enableButtonPressed(selection);
  $refresh(this.this$0, false);
}
;
_.isEnabled_0 = function isEnabled_12(selection){
  return $isEnabled(this, selection) && this.val$isAuthorized;
}
;
_.this$0 = null;
_.val$isAuthorized = false;
function AbstractAlertDefinitionsView$3_0(this$0, $anonymous0, val$isAuthorized){
  this.this$0 = this$0;
  this.val$isAuthorized = val$isAuthorized;
  this.enablement = $anonymous0;
}

defineSeed(1901, 1608, {}, AbstractAlertDefinitionsView$3_0);
_.executeAction = function executeAction_25(selection, actionValue){
  this.this$0.disableButtonPressed(selection);
  $refresh(this.this$0, false);
}
;
_.isEnabled_0 = function isEnabled_13(selection){
  return $isEnabled(this, selection) && this.val$isAuthorized;
}
;
_.this$0 = null;
_.val$isAuthorized = false;
function AbstractAlertDefinitionsView$4_0(this$0, $anonymous0, val$isAuthorized){
  this.this$0 = this$0;
  this.val$isAuthorized = val$isAuthorized;
  this.enablement = $anonymous0;
}

defineSeed(1902, 1608, {}, AbstractAlertDefinitionsView$4_0);
_.executeAction = function executeAction_26(selection, actionValue){
  this.this$0.deleteButtonPressed(selection);
}
;
_.isEnabled_0 = function isEnabled_14(selection){
  return $isEnabled(this, selection) && this.val$isAuthorized;
}
;
_.this$0 = null;
_.val$isAuthorized = false;
function $onSuccess_94(this$static, result){
  result.size_0 > 0 && $setAlertDefinition_5(this$static.val$singleAlertDefinitionView, dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$AlertDefinition));
}

function AbstractAlertDefinitionsView$5_0(val$id, val$singleAlertDefinitionView){
  this.val$id = val$id;
  this.val$singleAlertDefinitionView = val$singleAlertDefinitionView;
}

defineSeed(1903, 1, {}, AbstractAlertDefinitionsView$5_0);
_.onFailure = function onFailure_97(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to fetch data for alert definition with id ' + ($clinit_Enhanced() , '' + this.val$id)), caught);
}
;
_.onSuccess_0 = function onSuccess_97(result){
  $onSuccess_94(this, dynamicCast(result, Q$PageList));
}
;
_.val$id = null;
_.val$singleAlertDefinitionView = null;
function AbstractNotificationSenderForm_0(notif, sender){
  var notifConfig, notifExtraConfig;
  EnhancedVLayout_0.call(this);
  this.sender = sender;
  if (notif) {
    notifConfig = notif.configuration;
    notifExtraConfig = notif.extraConfiguration;
    notifConfig?(this.configuration = $deepCopy(notifConfig, true)):(this.configuration = new Configuration_0);
    notifExtraConfig?(this.extraConfiguration = $deepCopy(notifExtraConfig, true)):(this.extraConfiguration = null);
  }
   else {
    this.configuration = new Configuration_0;
    this.extraConfiguration = null;
  }
}

defineSeed(1904, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AbstractNotificationSenderForm, Q$Enhanced]));
_.configuration = null;
_.extraConfiguration = null;
_.sender = null;
function $checkAuthenticationAndDo(this$static, action){
  var password, username;
  username = this$static.anotherUserName.getEnteredValue_0();
  password = $getEnteredValue(this$static.anotherUserPassword);
  $checkAuthentication(dynamicCast(secure(getInstance_54(), -1), Q$SubjectGWTServiceAsync), username, password, new CliNotificationSenderForm$13_0(this$static, action));
}

function $createAnotherUserForm(this$static){
  var form;
  form = new DynamicForm_0;
  $setAttribute_24(form, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0, true);
  this$static.anotherUserName = new TextItem_3('userName', ($clinit_Enhanced() , 'User Name'));
  this$static.anotherUserPassword = new PasswordItem_2('Password');
  this$static.verifyUserButton = new ButtonItem_1('verify', 'Verify');
  this$static.successIcon = new FormItemIcon_0;
  $setAttribute_13(this$static.successIcon, 'src', getAvailabilityIcon(($clinit_Boolean() , TRUE)));
  $setWidth_4(this$static.successIcon, valueOf_44(16));
  $setHeight_2(this$static.successIcon, valueOf_44(16));
  this$static.failureIcon = new FormItemIcon_0;
  $setAttribute_13(this$static.failureIcon, 'src', getAvailabilityIcon(FALSE));
  $setWidth_4(this$static.failureIcon, valueOf_44(16));
  $setHeight_2(this$static.failureIcon, valueOf_44(16));
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.anotherUserName, this$static.anotherUserPassword, this$static.verifyUserButton]));
  $addClickHandler_1(this$static.verifyUserButton, new CliNotificationSenderForm$9_0(this$static));
  return form;
}

function $createExistingPackageForm(this$static){
  var form;
  form = new DynamicForm_0;
  $setAttribute_24(form, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0, true);
  this$static.existingPackageSelector = new SortedSelectItem_2('existingPackageSelector', '');
  $setDefaultToFirstOption_0(this$static.existingPackageSelector, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setWrapTitle(this$static.existingPackageSelector, FALSE);
  $setRedrawOnChange(this$static.existingPackageSelector);
  $setWidth_1(this$static.existingPackageSelector, 300);
  $setValueMap_2(this$static.existingPackageSelector, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [($clinit_Enhanced() , 'Loading...')]));
  $setDisabled_2(this$static.existingPackageSelector, TRUE);
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.existingPackageSelector]));
  return form;
}

function $createUploadNewScriptForm(this$static){
  this$static.uploadForm = new CliNotificationSenderForm$PackageVersionFileUploadFormWithVersion_0(this$static.cliScriptPackageType.packageType.id);
  $setAttribute_24(this$static.uploadForm, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0, true);
  $setPackageTypeId(this$static.uploadForm, this$static.cliScriptPackageType.packageType.id);
  this$static.uploadSuccessHandler = new CliNotificationSenderForm$11_0(this$static);
  $addFormHandler(this$static.uploadForm, this$static.uploadSuccessHandler);
  $addItemChangeHandler(this$static.uploadForm, new CliNotificationSenderForm$12_0(this$static));
  return this$static.uploadForm;
}

function $loadConfig(this$static, handler){
  var c, config, packageId, pc, rc, repoId, sid, subjectId;
  repoId = $getSimpleValue(this$static.configuration, 'repoId', null);
  packageId = $getSimpleValue(this$static.configuration, 'packageId', null);
  subjectId = $getSimpleValue(this$static.configuration, 'userId', null);
  config = new CliNotificationSenderForm$Config_0;
  rc = new RepoCriteria_0;
  $findReposByCriteria(dynamicCast(secure(getInstance_49(), -1), Q$RepoGWTServiceAsync), rc, new CliNotificationSenderForm$6_0(config, repoId, handler));
  if (repoId != null && $trim(repoId).length > 0) {
    pc = new PackageCriteria_0;
    $addFilterRepoId(pc, valueOf_44(__parseAndValidateInt(repoId)));
    $addFilterPackageTypeId(pc, valueOf_44(this$static.cliScriptPackageType.packageType.id));
    $findPackagesWithLatestVersion(dynamicCast(secure(getInstance_38(), -1), Q$ContentGWTServiceAsync), pc, new CliNotificationSenderForm$7_0(config, packageId, handler));
  }
   else {
    config.allPackages = ($clinit_Collections() , $clinit_Collections() , EMPTY_LIST);
    --config.__handlerCounter;
  }
  if (subjectId != null && $trim(subjectId).length > 0) {
    sid = __parseAndValidateInt(subjectId);
    c = new SubjectCriteria_0;
    $addFilterId(c, valueOf_44(sid));
    $findSubjectsByCriteria(dynamicCast(secure(getInstance_54(), -1), Q$SubjectGWTServiceAsync), c, new CliNotificationSenderForm$8_0(config, handler));
  }
   else {
    --config.__handlerCounter;
  }
}

function $loadPackageType(handler){
  $findPackageType(dynamicCast(secure(getInstance_38(), -1), Q$ContentGWTServiceAsync), handler);
}

function $setFailed(this$static, item){
  $setIcons(item, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [this$static.failureIcon]));
  $isCreated_2(item)?$setProperty_9(item, 'failed', true):(item.jsObj['failed'] = true , undefined);
}

function $setOk(this$static, item){
  var lastTimeFail;
  lastTimeFail = $isCreated_2(item)?$getPropertyAsBoolean(item, 'failed'):($clinit_Boolean() , getAttributeAsBoolean(item.jsObj, 'failed')?TRUE:FALSE);
  if (!!lastTimeFail && lastTimeFail.value_0) {
    $setIcons(item, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [this$static.successIcon]));
    $isCreated_2(item)?$setProperty_9(item, 'failed', false):(item.jsObj['failed'] = false , undefined);
  }
}

function $setupPackageSelector(this$static){
  var label, map, p, p$iterator;
  map = new LinkedHashMap_0;
  for (p$iterator = this$static.config.allPackages.iterator(); p$iterator.hasNext();) {
    p = dynamicCast(p$iterator.next_0(), Q$PackageAndLatestVersionComposite);
    label = p.generalPackage.name_0 + ' (' + p.latestPackageVersion.version_0 + ')';
    $put_1(map, '' + p.generalPackage.id, label);
  }
  $setValueMap_1(this$static.existingPackageSelector, map);
  if (this$static.config.selectedPackage) {
    $setValue_5(this$static.existingPackageSelector, this$static.config.selectedPackage.generalPackage.id);
    $setSelected(this$static.packageSelector, ($clinit_Enhanced() , 'Existing Script'));
  }
   else {
    $setSelected(this$static.packageSelector, ($clinit_Enhanced() , 'Upload New Script'));
  }
  this$static.formBuilt || $addChangedHandler(this$static.existingPackageSelector, new CliNotificationSenderForm$2_0(this$static));
  $setDisabled_2(this$static.existingPackageSelector, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $markForRedraw(this$static);
}

function $setupRepoSelector(this$static){
  var map, r, r$iterator;
  map = new LinkedHashMap_0;
  for (r$iterator = new AbstractList$IteratorImpl_0(this$static.config.allRepos); r$iterator.i < r$iterator.this$0_0.size_1();) {
    r = dynamicCast($next_0(r$iterator), Q$Repo);
    $put_1(map, '' + r.id, r.name_0);
  }
  $setValueMap_1(this$static.repoSelector, map);
  if (this$static.config.selectedRepo) {
    $setValue_5(this$static.repoSelector, this$static.config.selectedRepo.id);
    $setDisabled_2(this$static.packageSelector, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setRepoId(this$static.uploadForm, valueOf_44(this$static.config.selectedRepo.id));
  }
   else {
    $setValue_7(this$static.repoSelector, '');
    $setDisabled_2(this$static.packageSelector, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $setRepoId(this$static.uploadForm, null);
  }
  this$static.formBuilt || $addChangedHandler(this$static.repoSelector, new CliNotificationSenderForm$3_0(this$static));
  $setDisabled_2(this$static.repoSelector, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $markForRedraw(this$static);
}

function $setupUserSelector(this$static){
  var anotherUserForm;
  if (!!this$static.config.selectedSubject && !$equals_10(($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0), this$static.config.selectedSubject)) {
    $setSelected(this$static.userSelector, ($clinit_Enhanced() , 'Another User'));
    anotherUserForm = dynamicCast($getSelectedComponent(this$static.userSelector), Q$DynamicForm);
    $getField_0(anotherUserForm, 'userName').setValue_4(this$static.config.selectedSubject.name_0);
  }
   else {
    $setSelected(this$static.userSelector, ($clinit_Enhanced() , 'Myself'));
  }
  $markForRedraw(this$static);
}

function $validatePackage(this$static, callback){
  var version, versionRegex;
  if (!this$static.config.selectedRepo) {
    $setFailed(this$static, this$static.repoSelector);
    return;
  }
  $setOk(this$static, this$static.repoSelector);
  if (!$isDisabled_0(this$static.existingPackageSelector).value_0) {
    if (!this$static.config.selectedPackage) {
      $setFailed(this$static, this$static.existingPackageSelector);
      return;
    }
    $setOk(this$static, this$static.existingPackageSelector);
  }
  $put_4(this$static.configuration, new PropertySimple_1('repoId', valueOf_44(this$static.config.selectedRepo.id)));
  if ($getSelectedIndex(this$static.packageSelector) == 0) {
    $put_4(this$static.configuration, new PropertySimple_1('packageId', valueOf_44(this$static.config.selectedPackage.generalPackage.id)));
    $onSuccess_110(callback);
  }
   else {
    if (this$static.cliScriptPackageType.versionFormat) {
      versionRegex = this$static.cliScriptPackageType.versionFormat.fullFormatRegex;
      if (versionRegex != null) {
        version = $getField_0(this$static.uploadForm, 'version').getValue_1();
        if (version == null || !matches(toString__devirtual$(version), versionRegex)) {
          $setIcons($getField_0(this$static.uploadForm, 'editableVersion'), initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [this$static.failureIcon]));
          return;
        }
         else {
          $setIcons($getField_0(this$static.uploadForm, 'editableVersion'), initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [this$static.successIcon]));
        }
      }
       else {
        $setIcons($getField_0(this$static.uploadForm, 'editableVersion'), initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, []));
      }
    }
    $setCallback_1(this$static.uploadSuccessHandler, new CliNotificationSenderForm$5_0(this$static, callback));
    $submitForm_2(this$static.uploadForm);
  }
}

function CliNotificationSenderForm_0(notif, sender){
  AbstractNotificationSenderForm_0.call(this, notif, sender);
}

function getOsgiVersion(version, osgiRegex, groupIdx){
  $clinit_BaseWidget();
  var re = new RegExp(osgiRegex);
  var groupRef = '$' + groupIdx;
  version = version.replace(re, groupRef);
  return version;
}

function matches(string, regex){
  $clinit_BaseWidget();
  var re = new RegExp(regex);
  return re.test(string);
}

defineSeed(1905, 1904, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AbstractNotificationSenderForm, Q$Enhanced]), CliNotificationSenderForm_0);
_.onInit = function onInit_17(){
  $onInit(this);
  $onInit_Layout(this);
  this.formBuilt || $loadPackageType(new CliNotificationSenderForm$1_0(this));
}
;
_.validate_2 = function validate_1(callback){
  if ($getSelectedIndex(this.userSelector) == 0) {
    $put_4(this.configuration, new PropertySimple_1('userId', valueOf_44(($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0).id)));
    $validatePackage(this, callback);
  }
   else {
    $checkAuthenticationAndDo(this, new CliNotificationSenderForm$4_0(this, callback));
  }
}
;
_.anotherUserName = null;
_.anotherUserPassword = null;
_.cliScriptPackageType = null;
_.config = null;
_.existingPackageSelector = null;
_.failureIcon = null;
_.formBuilt = false;
_.packageSelector = null;
_.repoSelector = null;
_.successIcon = null;
_.uploadForm = null;
_.uploadSuccessHandler = null;
_.userSelector = null;
_.verifyUserButton = null;
function $onSuccess_95(this$static, result){
  var form, packageSection, packageSelectItems, repoSection, userSection, userSelectItems;
  this$static.this$0.cliScriptPackageType = result;
  form = new DynamicForm_0;
  $setAttribute_24(form, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0, true);
  $isCreated_1(form)?$setProperty_0(form, 'width', 500):(form.config_0['width'] = 500 , undefined);
  repoSection = new SectionItem_0('repoSection');
  $setDefaultValue_1(repoSection, ($clinit_Enhanced() , 'Repository'));
  $setWidth_2(repoSection, '100%');
  packageSection = new SectionItem_0('packageSection');
  $setDefaultValue_1(packageSection, 'Script');
  userSection = new SectionItem_0('userSection');
  $setDefaultValue_1(userSection, 'User To Run The Script As');
  this$static.this$0.repoSelector = new SortedSelectItem_2('repoSelector', 'Select the repository where the script should reside');
  $setDefaultToFirstOption_0(this$static.this$0.repoSelector, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setWrapTitle(this$static.this$0.repoSelector, FALSE);
  $setWidth_1(this$static.this$0.repoSelector, 400);
  $setValueMap_2(this$static.this$0.repoSelector, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['Loading...']));
  $setDisabled_2(this$static.this$0.repoSelector, TRUE);
  packageSelectItems = new LinkedHashMap_0;
  $put_1(packageSelectItems, 'Existing Script', $createExistingPackageForm(this$static.this$0));
  $put_1(packageSelectItems, 'Upload New Script', $createUploadNewScriptForm(this$static.this$0));
  this$static.this$0.packageSelector = new RadioGroupWithComponentsItem_0('packageSelector', '', packageSelectItems, form);
  $setWidth_2(this$static.this$0.packageSelector, '100%');
  userSelectItems = new LinkedHashMap_0;
  $put_1(userSelectItems, 'Myself', null);
  $put_1(userSelectItems, 'Another User', $createAnotherUserForm(this$static.this$0));
  this$static.this$0.userSelector = new RadioGroupWithComponentsItem_0('userSelector', '', userSelectItems, form);
  $setWidth_2(this$static.this$0.userSelector, '100%');
  $setShowTitle_0(this$static.this$0.userSelector, FALSE);
  $isCreated_2(repoSection)?$setProperty_7(repoSection, 'itemIds', convertToJavaScriptArray(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['repoSelector']))):(repoSection.jsObj['itemIds'] = convertToJavaScriptArray(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['repoSelector'])) , undefined);
  $isCreated_2(packageSection)?$setProperty_7(packageSection, 'itemIds', convertToJavaScriptArray(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['packageSelector']))):(packageSection.jsObj['itemIds'] = convertToJavaScriptArray(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['packageSelector'])) , undefined);
  $isCreated_2(userSection)?$setProperty_7(userSection, 'itemIds', convertToJavaScriptArray(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['userSelector']))):(userSection.jsObj['itemIds'] = convertToJavaScriptArray(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['userSelector'])) , undefined);
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [userSection, this$static.this$0.userSelector, repoSection, this$static.this$0.repoSelector, packageSection, this$static.this$0.packageSelector]));
  $addMember(this$static.this$0, form);
  $loadConfig(this$static.this$0, new CliNotificationSenderForm$1$1_0(this$static));
}

function CliNotificationSenderForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1906, 1, {}, CliNotificationSenderForm$1_0);
_.onFailure = function onFailure_98(t){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Loading the CLI Notification Editor Failed.'), t);
}
;
_.onSuccess_0 = function onSuccess_98(result){
  $onSuccess_95(this, dynamicCast(result, Q$PackageTypeAndVersionFormatComposite));
}
;
_.this$0 = null;
function $onFailure_10(t){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Loading the CLI Notification Editor Failed.'), t);
}

function $onSuccess_96(this$static, config){
  this$static.this$1.this$0.config = config;
  $setupRepoSelector(this$static.this$1.this$0);
  $setupPackageSelector(this$static.this$1.this$0);
  $setupUserSelector(this$static.this$1.this$0);
  this$static.this$1.this$0.formBuilt = true;
  $markForRedraw(this$static.this$1.this$0);
}

function CliNotificationSenderForm$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1907, 1, {}, CliNotificationSenderForm$1$1_0);
_.onFailure = function onFailure_99(t){
  $onFailure_10(t);
}
;
_.onSuccess_0 = function onSuccess_99(config){
  $onSuccess_96(this, dynamicCast(config, Q$CliNotificationSenderForm$Config));
}
;
_.this$1 = null;
function $setCallback_1(this$static, callback){
  this$static.callback = callback;
}

defineSeed(1909, 1, makeCastMap([Q$DynamicFormHandler]));
_.callback = null;
function CliNotificationSenderForm$11_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1908, 1909, makeCastMap([Q$DynamicFormHandler]), CliNotificationSenderForm$11_0);
_.onSubmitComplete = function onSubmitComplete(event_0){
  if (this.this$0.uploadForm.packageId == 0 || this.this$0.uploadForm.packageVersionId == 0) {
    return;
  }
  !!this.callback && $onSuccess_100(this.callback);
}
;
_.this$0 = null;
function $onItemChange(this$static, event_0){
  var $e0, defaultVersion, fileName, format, group, newVersion, oldOsgiVersion, plv, plv$iterator, regex, v, version, jsObj;
  if (instanceOf((jsObj = event_0.jsObj , getOrCreateRef_6(jsObj.item)), Q$UploadItem)) {
    if ($getNewValue(event_0) == null) {
      $getField_0(this$static.this$0.uploadForm, 'editableVersion').setValue_4('');
      $getField_0(this$static.this$0.uploadForm, 'version').setValue_4('');
      return;
    }
    fileName = toString__devirtual$($getNewValue(event_0));
    if (this$static.this$0.config.allPackages) {
      for (plv$iterator = this$static.this$0.config.allPackages.iterator(); plv$iterator.hasNext();) {
        plv = dynamicCast(plv$iterator.next_0(), Q$PackageAndLatestVersionComposite);
        if ($equals_6(plv.generalPackage.name_0, fileName)) {
          try {
            version = plv.latestPackageVersion.version_0;
            format = this$static.this$0.cliScriptPackageType.versionFormat;
            if (!format) {
              return;
            }
            if (format.osgiVersionExtractionRegex == null) {
              return;
            }
            regex = format.osgiVersionExtractionRegex;
            group = format.osgiVersionGroupIndex;
            oldOsgiVersion = getOsgiVersion(version, regex, group);
            v = new OSGiVersion_0(oldOsgiVersion);
            v.micro?$setMicro(v, valueOf_44((!v.micro?0:v.micro.value_0) + 1)):v.minor?$setMinor(v, valueOf_44((!v.minor?0:v.minor.value_0) + 1)):$setMajor(v, v.major + 1);
            newVersion = $replace_1(version, oldOsgiVersion, $toString_21(v));
            $getField_0(this$static.this$0.uploadForm, 'editableVersion').setValue_4(newVersion);
            $getField_0(this$static.this$0.uploadForm, 'version').setValue_4(newVersion);
            return;
          }
           catch ($e0) {
            $e0 = caught_0($e0);
            if (instanceOf($e0, Q$Exception)) {
              return;
            }
             else 
              throw $e0;
          }
        }
      }
      defaultVersion = '';
      !!this$static.this$0.cliScriptPackageType.versionFormat && this$static.this$0.cliScriptPackageType.versionFormat.osgiVersionExtractionRegex != null && matches('1.0', this$static.this$0.cliScriptPackageType.versionFormat.fullFormatRegex) && (defaultVersion = '1.0');
      $getField_0(this$static.this$0.uploadForm, 'editableVersion').setValue_4(defaultVersion);
      $getField_0(this$static.this$0.uploadForm, 'version').setValue_4(defaultVersion);
    }
  }
}

function CliNotificationSenderForm$12_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1910, 1, makeCastMap([Q$EventHandler, Q$ItemChangeHandler]), CliNotificationSenderForm$12_0);
_.this$0 = null;
function $onFailure_11(this$static, caught){
  this$static.this$0.config.selectedSubject = null;
  $setIcons(this$static.this$0.verifyUserButton, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [this$static.this$0.failureIcon]));
  $markForRedraw(this$static.this$0);
  this$static.val$action.onFailure(caught);
}

function $onSuccess_97(this$static, result){
  this$static.this$0.config.selectedSubject = result;
  $setIcons(this$static.this$0.verifyUserButton, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [!result?this$static.this$0.failureIcon:this$static.this$0.successIcon]));
  $markForRedraw(this$static.this$0);
  !result?this$static.val$action.onFailure(null):this$static.val$action.onSuccess_0(null);
}

function CliNotificationSenderForm$13_0(this$0, val$action){
  this.this$0 = this$0;
  this.val$action = val$action;
}

defineSeed(1911, 1, {}, CliNotificationSenderForm$13_0);
_.onFailure = function onFailure_100(caught){
  $onFailure_11(this, caught);
}
;
_.onSuccess_0 = function onSuccess_100(result){
  $onSuccess_97(this, dynamicCast(result, Q$Subject));
}
;
_.this$0 = null;
_.val$action = null;
function CliNotificationSenderForm$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1912, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), CliNotificationSenderForm$2_0);
_.onChanged = function onChanged_3(event_0){
  var packageId;
  packageId = valueOf_44(__parseAndValidateInt(toString__devirtual$($getItem_0(event_0).getValue_1()))).value_0;
  $setSelectedPackage(this.this$0.config, packageId);
}
;
_.this$0 = null;
function CliNotificationSenderForm$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1913, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), CliNotificationSenderForm$3_0);
_.onChanged = function onChanged_4(event_0){
  var pc, repoId;
  repoId = valueOf_44(__parseAndValidateInt(toString__devirtual$($getItem_0(event_0).getValue_1())));
  $setSelectedRepo(this.this$0.config, repoId.value_0);
  pc = new PackageCriteria_0;
  pc.filterRepoId = repoId;
  $addFilterPackageTypeId(pc, valueOf_44(this.this$0.cliScriptPackageType.packageType.id));
  $setDisabled_2(this.this$0.packageSelector, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setDisabled_2(this.this$0.existingPackageSelector, TRUE);
  $setValueMap_2(this.this$0.existingPackageSelector, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [($clinit_Enhanced() , 'Loading...')]));
  $findPackagesWithLatestVersion(dynamicCast(secure(getInstance_38(), -1), Q$ContentGWTServiceAsync), pc, new CliNotificationSenderForm$3$1_0(this, repoId));
}
;
_.this$0 = null;
function $onSuccess_98(this$static, result){
  this$static.this$1.this$0.config.allPackages = result;
  this$static.this$1.this$0.config.selectedPackage = result.size_0 == 0?null:dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$PackageAndLatestVersionComposite);
  $setupPackageSelector(this$static.this$1.this$0);
  $setRepoId(this$static.this$1.this$0.uploadForm, this$static.val$repoId);
}

function CliNotificationSenderForm$3$1_0(this$1, val$repoId){
  this.this$1 = this$1;
  this.val$repoId = val$repoId;
}

defineSeed(1914, 1, {}, CliNotificationSenderForm$3$1_0);
_.onFailure = function onFailure_101(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Loading the CLI Notification Editor Failed.'), caught);
}
;
_.onSuccess_0 = function onSuccess_101(result){
  $onSuccess_98(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
_.val$repoId = null;
function $onSuccess_99(this$static){
  $put_4(this$static.this$0.configuration, new PropertySimple_1('userId', valueOf_44(this$static.this$0.config.selectedSubject.id)));
  $put_4(this$static.this$0.configuration, new PropertySimple_1('userName', this$static.this$0.anotherUserName.getEnteredValue_0()));
  $put_4(this$static.this$0.configuration, new PropertySimple_1('userPassword', $getEnteredValue(this$static.this$0.anotherUserPassword)));
  $validatePackage(this$static.this$0, this$static.val$callback);
}

function CliNotificationSenderForm$4_0(this$0, val$callback){
  this.this$0 = this$0;
  this.val$callback = val$callback;
}

defineSeed(1915, 1, {}, CliNotificationSenderForm$4_0);
_.onFailure = function onFailure_102(caught){
}
;
_.onSuccess_0 = function onSuccess_102(result){
  $onSuccess_99(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$callback = null;
function $onSuccess_100(this$static){
  $put_4(this$static.this$0.configuration, new PropertySimple_1('packageId', valueOf_44(this$static.this$0.uploadForm.packageId)));
  $onSuccess_110(this$static.val$callback);
}

function CliNotificationSenderForm$5_0(this$0, val$callback){
  this.this$0 = this$0;
  this.val$callback = val$callback;
}

defineSeed(1916, 1, {}, CliNotificationSenderForm$5_0);
_.onFailure = function onFailure_103(caught){
}
;
_.onSuccess_0 = function onSuccess_103(result){
  $onSuccess_100(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$callback = null;
function $onSuccess_101(this$static, result){
  var rid;
  this$static.val$config.allRepos = result;
  if (this$static.val$repoId != null && $trim(this$static.val$repoId).length > 0) {
    rid = __parseAndValidateInt(this$static.val$repoId);
    $setSelectedRepo(this$static.val$config, rid);
  }
  --this$static.val$config.__handlerCounter == 0 && $onSuccess_96(this$static.val$handler, this$static.val$config);
}

function CliNotificationSenderForm$6_0(val$config, val$repoId, val$handler){
  this.val$config = val$config;
  this.val$repoId = val$repoId;
  this.val$handler = val$handler;
}

defineSeed(1917, 1, {}, CliNotificationSenderForm$6_0);
_.onFailure = function onFailure_104(caught){
  $onFailure_10(caught);
}
;
_.onSuccess_0 = function onSuccess_104(result){
  $onSuccess_101(this, dynamicCast(result, Q$PageList));
}
;
_.val$config = null;
_.val$handler = null;
_.val$repoId = null;
function $onSuccess_102(this$static, result){
  var pid;
  this$static.val$config.allPackages = result;
  if (this$static.val$packageId != null && $trim(this$static.val$packageId).length > 0) {
    pid = __parseAndValidateInt(this$static.val$packageId);
    $setSelectedPackage(this$static.val$config, pid);
  }
  --this$static.val$config.__handlerCounter == 0 && $onSuccess_96(this$static.val$handler, this$static.val$config);
}

function CliNotificationSenderForm$7_0(val$config, val$packageId, val$handler){
  this.val$config = val$config;
  this.val$packageId = val$packageId;
  this.val$handler = val$handler;
}

defineSeed(1918, 1, {}, CliNotificationSenderForm$7_0);
_.onFailure = function onFailure_105(caught){
  $onFailure_10(caught);
}
;
_.onSuccess_0 = function onSuccess_105(result){
  $onSuccess_102(this, dynamicCast(result, Q$PageList));
}
;
_.val$config = null;
_.val$handler = null;
_.val$packageId = null;
function $onSuccess_103(this$static, result){
  result.size_0 > 0 && (this$static.val$config.selectedSubject = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Subject));
  --this$static.val$config.__handlerCounter == 0 && $onSuccess_96(this$static.val$handler, this$static.val$config);
}

function CliNotificationSenderForm$8_0(val$config, val$handler){
  this.val$config = val$config;
  this.val$handler = val$handler;
}

defineSeed(1919, 1, {}, CliNotificationSenderForm$8_0);
_.onFailure = function onFailure_106(caught){
  $onFailure_10(caught);
}
;
_.onSuccess_0 = function onSuccess_106(result){
  $onSuccess_103(this, dynamicCast(result, Q$PageList));
}
;
_.val$config = null;
_.val$handler = null;
function CliNotificationSenderForm$9_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1920, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), CliNotificationSenderForm$9_0);
_.onClick_0 = function onClick_28(event_0){
  $checkAuthenticationAndDo(this.this$0, new CliNotificationSenderForm$9$1_0);
}
;
_.this$0 = null;
function CliNotificationSenderForm$9$1_0(){
}

defineSeed(1921, 1, {}, CliNotificationSenderForm$9$1_0);
_.onFailure = function onFailure_107(caught){
}
;
_.onSuccess_0 = function onSuccess_107(result){
  throwClassCastExceptionUnlessNull(result);
}
;
function $setSelectedPackage(this$static, packageId){
  var p, p$iterator;
  if (this$static.allPackages) {
    for (p$iterator = this$static.allPackages.iterator(); p$iterator.hasNext();) {
      p = dynamicCast(p$iterator.next_0(), Q$PackageAndLatestVersionComposite);
      if (p.generalPackage.id == packageId) {
        this$static.selectedPackage = p;
        break;
      }
    }
  }
}

function $setSelectedRepo(this$static, repoId){
  var r, r$iterator;
  if (this$static.allRepos) {
    for (r$iterator = new AbstractList$IteratorImpl_0(this$static.allRepos); r$iterator.i < r$iterator.this$0_0.size_1();) {
      r = dynamicCast($next_0(r$iterator), Q$Repo);
      if (r.id == repoId) {
        this$static.selectedRepo = r;
        break;
      }
    }
  }
}

function CliNotificationSenderForm$Config_0(){
}

defineSeed(1922, 1, makeCastMap([Q$CliNotificationSenderForm$Config]), CliNotificationSenderForm$Config_0);
_.__handlerCounter = 3;
_.allPackages = null;
_.allRepos = null;
_.selectedPackage = null;
_.selectedRepo = null;
_.selectedSubject = null;
function $addFormHandler(this$static, handler){
  !this$static.formHandlers && (this$static.formHandlers = new DynamicCallbackFormHandlerCollection_0);
  $add_3(this$static.formHandlers, handler);
}

function $init_3(this$static){
  var dummy;
  if (this$static.frameName != null) {
    dummy = $createElement($doc, 'div');
    $setInnerHTML(dummy, "<iframe src=\"javascript:''\" name='" + this$static.frameName + "' style='position:absolute;width:0;height:0;border:0'>");
    this$static.synthesizedFrame = $getFirstChildElement(dummy);
    $appendChild($doc.body, this$static.synthesizedFrame);
    $hookEvents(this$static.synthesizedFrame, this$static);
  }
}

function $onFrameLoadAndCatch(this$static, handler){
  var $e0, e;
  try {
    !!this$static.formHandlers && $scheduleDeferred(($clinit_SchedulerImpl() , INSTANCE), new DynamicCallbackForm$1_0(this$static));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Throwable)) {
      e = $e0;
      handler.onUncaughtException(e);
    }
     else 
      throw $e0;
  }
}

function $submitForm_0(this$static){
  $submit_0($getAttributeAsString_0(this$static, 'action'), this$static.synthesizedFrame);
  $submitForm(this$static);
}

function DynamicCallbackForm_0(frameName){
  $clinit_BaseWidget();
  DynamicForm_0.call(this);
  $clinit_CoreGUI();
  this.frameName = frameName + frameIndex++;
  $setTarget(this, this.frameName);
  $init_3(this);
}

defineSeed(1926, 478, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), DynamicCallbackForm_0);
_.destroy_0 = function destroy_6(){
  if (this.synthesizedFrame) {
    $unhookEvents(this.synthesizedFrame);
    $removeChild($doc.body, this.synthesizedFrame);
    this.synthesizedFrame = null;
  }
  $destroy(this);
}
;
_.onAttach = function onAttach_0(){
  $onAttach(this);
}
;
_.onFrameLoad = function onFrameLoad(){
  var handler;
  handler = sUncaughtExceptionHandler;
  handler?$onFrameLoadAndCatch(this, handler):!!this.formHandlers && $scheduleDeferred(($clinit_SchedulerImpl() , INSTANCE), new DynamicCallbackForm$1_0(this));
}
;
_.formHandlers = null;
_.frameName = null;
_.synthesizedFrame = null;
var frameIndex = 0;
function $changeIcon(this$static, icon, tooltip){
  var item;
  item = this$static.showUploadButton?this$static.uploadButton:this$static.fileUploadItem;
  $isCreated_2(item)?$setProperty_7(item, 'icons', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [icon]))):(item.jsObj['icons'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [icon])) , undefined);
  $isCreated_2(item)?$setProperty_8(item, 'iconPrompt', tooltip):(item.jsObj['iconPrompt'] = tooltip , undefined);
  $markForRedraw(this$static);
}

function $getOnDrawItems(this$static){
  var nameField, onDrawItems, sessionIdField, versionField;
  onDrawItems = new ArrayList_0;
  sessionIdField = new HiddenItem_0('sessionid');
  $setDefaultValue_0(sessionIdField, valueOf_44(($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0).sessionId.value_0));
  setCheck(onDrawItems.array, onDrawItems.size_0++, sessionIdField);
  nameField = new HiddenItem_0('name');
  $setDefaultValue_1(nameField, this$static.name_0);
  setCheck(onDrawItems.array, onDrawItems.size_0++, nameField);
  versionField = new HiddenItem_0('version');
  $setDefaultValue_1(versionField, this$static.version_0);
  setCheck(onDrawItems.array, onDrawItems.size_0++, versionField);
  this$static.fileUploadItem = new UploadItem_0('fileUploadItem', this$static.name_0);
  $setShowTitle_0(this$static.fileUploadItem, ($clinit_Boolean() , this$static.showNameLabel?TRUE:FALSE));
  $setWrapTitle(this$static.fileUploadItem, FALSE);
  $setColSpan(this$static.fileUploadItem, 1);
  $add_3(onDrawItems, this$static.fileUploadItem);
  if (this$static.showUploadButton) {
    this$static.uploadButton = new FileUploadForm$1EnableInterceptingButtonItem_0(this$static);
    $setDisabled_2(this$static.uploadButton, TRUE);
    $setColSpan(this$static.uploadButton, 1);
    $setStartRow_1(this$static.uploadButton, FALSE);
    $setAutoFit_1(this$static.uploadButton, TRUE);
    $setIcon_2(this$static.uploadButton);
    $addClickHandler_1(this$static.uploadButton, new FileUploadForm$1_0(this$static));
    $setEndRow_0(this$static.fileUploadItem, FALSE);
    $addChangeHandler(this$static.fileUploadItem, new FileUploadForm$2_0(this$static));
    $add_3(onDrawItems, this$static.uploadButton);
  }
  if (this$static.uploadResult) {
    if (this$static.uploadResult.value_0) {
      $changeIcon(this$static, this$static.iconGreen, 'File has already been uploaded');
    }
     else {
      $changeIcon(this$static, this$static.iconRed, 'File upload had previously failed');
      this$static.uploadError = 'File upload had previously failed';
    }
  }
   else {
    $changeIcon(this$static, this$static.iconGrey, this$static.showUploadButton?'Select a file to upload, then click Upload or Next':'Select a file to upload, then click Next');
  }
  return onDrawItems;
}

function $onDraw_0(this$static){
  var onDrawItems, submitCompleteHandler, submitFailedHandler;
  $setNumCols(this$static, (this$static.showUploadButton?2:1) + (this$static.showNameLabel?1:0));
  onDrawItems = this$static.getOnDrawItems();
  $setFields_0(this$static, dynamicCast($toArray_1(onDrawItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, onDrawItems.size_0, 0)), Q$FormItem_$1));
  submitCompleteHandler = new FileUploadForm$3_0(this$static);
  !!submitCompleteHandler && (!this$static.formHandlers && (this$static.formHandlers = new DynamicCallbackFormHandlerCollection_0) , $add_2(this$static.formHandlers, 0, submitCompleteHandler));
  submitFailedHandler = new FileUploadForm$4_0(this$static);
  !!submitFailedHandler && ($getHandlerCount_1(this$static, (!TYPE_19 && (TYPE_19 = new GwtEvent$Type_0) , TYPE_19)) == 0 && $setupFormSubmitFailedEvent(this$static) , $doAddHandler_0(this$static, submitFailedHandler, (!TYPE_19 && (TYPE_19 = new GwtEvent$Type_0) , TYPE_19)));
}

function $parseFilePathsFromResponse(results){
  var $e0, begin, e, end, files, line;
  files = null;
  try {
    files = new ArrayList_0;
    begin = 0;
    while (null != results && -1 != (end = results.indexOf('\n'))) {
      line = results.substr(begin, end - begin);
      $endsWith(line, 'html>') || (setCheck(files.array, files.size_0++, line) , true);
      begin = end + 1;
    }
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      e = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Error uploading file, unexpected results: [' + results + ']'), e);
    }
     else 
      throw $e0;
  }
  return files;
}

function $setUploadError(this$static, uploadError){
  this$static.uploadError = uploadError;
}

function $submitForm_1(this$static){
  var message, value;
  this$static.uploadError = null;
  if (this$static.uploadInProgress) {
    this$static.uploadError = 'Can not submit, upload is currently in progress';
    return;
  }
  value = $getValue_0(this$static.fileUploadItem);
  if (value == null || toString__devirtual$(value).length == 0) {
    message = 'Please select a file to upload [' + this$static.name_0 + ']';
    $changeIcon(this$static, this$static.iconRed, message);
    this$static.uploadError = message;
  }
   else {
    $changeIcon(this$static, this$static.iconLoading, 'Loading...');
    this$static.uploadInProgress = true;
    $submit_0($getAttributeAsString_0(this$static, 'action'), this$static.synthesizedFrame);
    $submitForm(this$static);
  }
}

function FileUploadForm_0(name_0, version, showNameLabel, showUploadButton, isAlreadyUploaded){
  DynamicCallbackForm_0.call(this, name_0);
  this.name_0 = name_0;
  this.version_0 = version;
  this.showNameLabel = showNameLabel;
  this.showUploadButton = showUploadButton;
  this.uploadResult = isAlreadyUploaded;
  this.uploadInProgress = false;
  $setAttribute_24(this, 'encoding', ($clinit_Encoding() , MULTIPART).value_0, true);
  $setAction(this, getModuleBaseURL() + '/FileUploadServlet');
  this.iconLoading = new FormItemIcon_0;
  this.iconLoading.jsObj['src'] = 'ajax-loader.gif';
  $setAttribute_11(this.iconLoading, 'width', valueOf_44(16));
  $setAttribute_11(this.iconLoading, 'height', valueOf_44(16));
  this.iconGreen = new FormItemIcon_0;
  $setAttribute_13(this.iconGreen, 'src', getAvailabilityIcon(($clinit_Boolean() , TRUE)));
  $setAttribute_11(this.iconGreen, 'width', valueOf_44(16));
  $setAttribute_11(this.iconGreen, 'height', valueOf_44(16));
  this.iconRed = new FormItemIcon_0;
  $setAttribute_13(this.iconRed, 'src', getAvailabilityIcon(FALSE));
  $setAttribute_11(this.iconRed, 'width', valueOf_44(16));
  $setAttribute_11(this.iconRed, 'height', valueOf_44(16));
  this.iconGrey = new FormItemIcon_0;
  $setAttribute_13(this.iconGrey, 'src', getAvailabilityIcon(null));
  $setAttribute_11(this.iconGrey, 'width', valueOf_44(16));
  $setAttribute_11(this.iconGrey, 'height', valueOf_44(16));
}

defineSeed(1925, 1926, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]));
_.getOnDrawItems = function getOnDrawItems(){
  return $getOnDrawItems(this);
}
;
_.onDraw_0 = function onDraw_13(){
  $onDraw_0(this);
}
;
_.processSubmitCompleteResults = function processSubmitCompleteResults(submitCompleteEventResults){
  !this.uploadedFilePaths && (this.uploadedFilePaths = $parseFilePathsFromResponse(submitCompleteEventResults));
  return !(!this.uploadedFilePaths || this.uploadedFilePaths.size_0 == 0);
}
;
_.submitForm_0 = function submitForm(){
  $submitForm_1(this);
}
;
_.fileUploadItem = null;
_.iconGreen = null;
_.iconGrey = null;
_.iconLoading = null;
_.iconRed = null;
_.name_0 = null;
_.showNameLabel = false;
_.showUploadButton = false;
_.uploadButton = null;
_.uploadError = null;
_.uploadInProgress = false;
_.uploadResult = null;
_.uploadedFilePaths = null;
_.version_0 = null;
function $getOnDrawItems_0(this$static){
  var archIdField, onDrawItems, packageTypeIdField, repoIdField;
  onDrawItems = $getOnDrawItems(this$static);
  packageTypeIdField = new HiddenItem_0('packageTypeId');
  $setDefaultValue_0(packageTypeIdField, valueOf_44(this$static.packageTypeId));
  setCheck(onDrawItems.array, onDrawItems.size_0++, packageTypeIdField);
  if (this$static.archId) {
    archIdField = new HiddenItem_0('archId');
    $setDefaultValue_0(archIdField, this$static.archId);
    setCheck(onDrawItems.array, onDrawItems.size_0++, archIdField);
  }
  if (this$static.repoId) {
    repoIdField = new HiddenItem_0('repoId');
    $setDefaultValue_0(repoIdField, this$static.repoId);
    setCheck(onDrawItems.array, onDrawItems.size_0++, repoIdField);
  }
  return onDrawItems;
}

function $parseIdsFromResponse(this$static, results){
  var $e0, e, endSuccessMsgPrefix, equalsIdx, ids, packageIdString, packageVersionIdString, startSuccessMsgPostfix, startSuccessMsgPrefix;
  this$static.packageVersionId = 0;
  this$static.packageId = 0;
  startSuccessMsgPrefix = results.indexOf('success [');
  if (startSuccessMsgPrefix < 0) {
    $handleError_0(($clinit_CoreGUI() , 'Error uploading Package Version File'), null);
    return;
  }
  endSuccessMsgPrefix = startSuccessMsgPrefix + 9;
  startSuccessMsgPostfix = $indexOf_3(results, fromCodePoint(93), endSuccessMsgPrefix);
  if (startSuccessMsgPostfix < 0) {
    $handleError_0(($clinit_CoreGUI() , 'Error uploading Package Version File'), null);
    return;
  }
  ids = $split(results.substr(endSuccessMsgPrefix, startSuccessMsgPostfix - endSuccessMsgPrefix), ',', 0);
  if (ids.length != 2) {
    $handleError_0(($clinit_CoreGUI() , 'Error uploading Package Version File'), null);
    return;
  }
  packageVersionIdString = ids[0];
  packageIdString = ids[1];
  try {
    equalsIdx = $indexOf_2(packageVersionIdString, fromCodePoint(61));
    if (equalsIdx < 0) {
      $handleError_0(($clinit_CoreGUI() , 'Error uploading Package Version File'), null);
      return;
    }
    this$static.packageVersionId = __parseAndValidateInt($substring(packageVersionIdString, equalsIdx + 1));
    equalsIdx = $indexOf_2(packageIdString, fromCodePoint(61));
    if (equalsIdx < 0) {
      this$static.packageVersionId = 0;
      $handleError_0(($clinit_CoreGUI() , 'Error uploading Package Version File'), null);
      return;
    }
    this$static.packageId = __parseAndValidateInt($substring(packageIdString, equalsIdx + 1));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      e = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Error uploading Package Version File'), e);
    }
     else 
      throw $e0;
  }
}

function $setPackageTypeId(this$static, value){
  this$static.packageTypeId = value;
  $onDraw_0(this$static);
}

function $setRepoId(this$static, value){
  this$static.repoId = value;
  $onDraw_0(this$static);
}

function $submitForm_2(this$static){
  var fileUploadItem, nameItem, uploadFilePath;
  nameItem = $getField_0(this$static, 'name');
  fileUploadItem = $getField_0(this$static, 'fileUploadItem');
  uploadFilePath = dynamicCast(fileUploadItem.getValue_1(), Q$String);
  nameItem.setValue_4(uploadFilePath);
  $submitForm_1(this$static);
}

function PackageVersionFileUploadForm_0(packageTypeId, packageName, version, archId, showUploadButton, isAlreadyUploaded){
  $clinit_BaseWidget();
  FileUploadForm_0.call(this, packageName, version, true, showUploadButton, isAlreadyUploaded);
  this.packageTypeId = packageTypeId;
  this.archId = archId;
  this.repoId = null;
  $setAction(this, getModuleBaseURL() + 'PackageVersionFileUploadServlet');
}

defineSeed(1924, 1925, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), PackageVersionFileUploadForm_0);
_.getOnDrawItems = function getOnDrawItems_0(){
  return $getOnDrawItems_0(this);
}
;
_.processSubmitCompleteResults = function processSubmitCompleteResults_0(submitCompleteEventResults){
  $parseIdsFromResponse(this, submitCompleteEventResults);
  return this.packageVersionId > 0;
}
;
_.submitForm_0 = function submitForm_0(){
  $submitForm_2(this);
}
;
_.archId = null;
_.packageId = 0;
_.packageTypeId = 0;
_.packageVersionId = 0;
_.repoId = null;
function CliNotificationSenderForm$PackageVersionFileUploadFormWithVersion_0(packageTypeId){
  PackageVersionFileUploadForm_0.call(this, packageTypeId, null, null, null, false, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  this.name_0 = 'File';
  $onDraw_0(this);
}

defineSeed(1923, 1924, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), CliNotificationSenderForm$PackageVersionFileUploadFormWithVersion_0);
_.getOnDrawItems = function getOnDrawItems_1(){
  var items, version;
  items = $getOnDrawItems_0(this);
  version = new TextItem_3('editableVersion', 'Version');
  $setColSpan(version, $getAttributeAsInt_0(this, 'numCols').value_0);
  $addChangedHandler(version, new CliNotificationSenderForm$PackageVersionFileUploadFormWithVersion$1_0(this));
  setCheck(items.array, items.size_0++, version);
  return items;
}
;
function CliNotificationSenderForm$PackageVersionFileUploadFormWithVersion$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1927, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), CliNotificationSenderForm$PackageVersionFileUploadFormWithVersion$1_0);
_.onChanged = function onChanged_5(event_0){
  $getField_0(this.this$1, 'version').setValue_3($getValue_2(event_0));
}
;
_.this$1 = null;
function $buildAvailabilityChangeFormItems(this$static, editMode){
  var avails, defaultValue, formItems, helpItem, ifFunc, selection;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , AVAILABILITY));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('availabilityHelp', 'Specify the availability state change that will trigger the condition.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  selection = new SortedSelectItem_2('availability', 'Availability');
  avails = new LinkedHashMap_1(2);
  $put_1(avails, ($clinit_AlertConditionOperator() , AVAIL_GOES_DOWN).name_0, 'Goes down');
  if (this$static.resourceType.category != ($clinit_ResourceCategory() , PLATFORM)) {
    $put_1(avails, AVAIL_GOES_DISABLED.name_0, 'Goes disabled');
    $put_1(avails, AVAIL_GOES_UNKNOWN.name_0, 'Goes unknown');
  }
  $put_1(avails, AVAIL_GOES_NOT_UP.name_0, 'Goes not up');
  $put_1(avails, AVAIL_GOES_UP.name_0, 'Goes up');
  $setValueMap_1(selection, avails);
  defaultValue = AVAIL_GOES_DOWN.name_0;
  $setDefaultValue_1(selection, editMode?this$static.existingCondition.name_0:defaultValue);
  $setShowIfCondition(selection, ifFunc);
  setCheck(formItems.array, formItems.size_0++, selection);
  return formItems;
}

function $buildAvailabilityDurationFormItems(this$static, editMode){
  var avails, durationValue, formItems, helpItem, ifFunc, selection, supportedTimeUnits;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , AVAIL_DURATION));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('availabilityDurationHelp', 'Specify the availability state change and the duration that state must persist in order to trigger the condition.  The duration should be long enough (several minutes) to give the agent time to detect another  availability state change that may correct the problem.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  selection = new SortedSelectItem_2('availabilityDuration', 'Availability State');
  avails = new LinkedHashMap_1(2);
  $put_1(avails, ($clinit_AlertConditionOperator() , AVAIL_DURATION_DOWN).name_0, 'Stays Down');
  $put_1(avails, AVAIL_DURATION_NOT_UP.name_0, 'Stays Not Up');
  $setValueMap_1(selection, avails);
  $setDefaultValue_1(selection, editMode?this$static.existingCondition.name_0:AVAIL_DURATION_DOWN.name_0);
  $setShowIfCondition(selection, ifFunc);
  setCheck(formItems.array, formItems.size_0++, selection);
  supportedTimeUnits = new TreeSet_0;
  $add_8(supportedTimeUnits, ($clinit_TimeUnit() , MINUTES_1));
  $add_8(supportedTimeUnits, HOURS_1);
  durationValue = new DurationItem_1('availabilityDurationVal', 'Duration', SECONDS_0, supportedTimeUnits, false, false);
  $setWrapTitle(durationValue, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setRequired(durationValue, TRUE);
  $setPrompt_2(durationValue, 'The amount of time the resource must be at the given availability state before the condition is met.');
  $setHoverWidth_0(durationValue, valueOf_44(200));
  editMode && $setValue_14(durationValue, valueOf_44(__parseAndValidateInt(this$static.existingCondition.option)), ($clinit_UnitType() , TIME_3));
  $setShowIfCondition(durationValue, ifFunc);
  setCheck(formItems.array, formItems.size_0++, durationValue);
  return formItems;
}

function $buildCalltimeChangeFormItems(this$static, editMode){
  var formItems, helpItem, ifFunc, limits, minMaxAvgSelection, percentage, regex, comparators, comparatorSelection;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_0('calltime-change');
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('calltimeChangeHelp', 'Specify the calltime value that, when changed at least a specified amount, triggers the condition. You must specify which calltime limit to check (minimum, maximum or average calltime value) and the percentage of change that must occur.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  $add_3(formItems, $buildCalltimeMetricDropDownMenu(this$static, 'calltimeChangeMetric', ifFunc, editMode));
  minMaxAvgSelection = new SelectItem_2('calltimeChangeMinMaxAvgSelection', 'Call Time Limit');
  limits = new LinkedHashMap_1(3);
  $put_1(limits, 'MIN', 'Minimum');
  $put_1(limits, 'AVG', 'Average');
  $put_1(limits, 'MAX', 'Maximum');
  $setPrompt_1(minMaxAvgSelection, 'The calltime limit value that is to be compared with the given value');
  $setHoverWidth_0(minMaxAvgSelection, valueOf_44(200));
  minMaxAvgSelection.setValueMap_0(limits);
  $setDefaultValue_1(minMaxAvgSelection, editMode?this$static.existingCondition.option:'AVG');
  $setWrapTitle(minMaxAvgSelection, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setWidth_2(minMaxAvgSelection, '*');
  $isCreated_2(minMaxAvgSelection)?$setProperty_9(minMaxAvgSelection, 'redrawOnChange', true):(minMaxAvgSelection.jsObj['redrawOnChange'] = true , undefined);
  $setShowIfCondition(minMaxAvgSelection, ifFunc);
  setCheck(formItems.array, formItems.size_0++, minMaxAvgSelection);
  $add_3(formItems, (comparators = new LinkedHashMap_1(3) , $put_1(comparators, 'LO', 'Shrinks') , $put_1(comparators, 'CH', 'Changes') , $put_1(comparators, 'HI', 'Grows') , comparatorSelection = new SortedSelectItem_2('calltimeChangeComparator', 'Comparator') , $setValueMap_1(comparatorSelection, comparators) , $setDefaultValue_1(comparatorSelection, editMode?this$static.existingCondition.comparator:'CH') , $setPrompt_1(comparatorSelection, 'How a collected calltime value should be compared to the given calltime limit') , $setHoverWidth_0(comparatorSelection, valueOf_44(200)) , $setShowIfCondition(comparatorSelection, ifFunc) , comparatorSelection));
  percentage = new TextItem_3('calltimeChangePercentageValue', 'Percentage Change');
  $setWrapTitle(percentage, FALSE);
  $setRequired(percentage, TRUE);
  $setPrompt_1(percentage, 'A collected calltime value will trigger this condition when it differs by at least this percentage of the selected calltime limit value');
  $setHoverWidth_0(percentage, valueOf_44(200));
  $setShowIfCondition(percentage, ifFunc);
  $setValidateOnChange_0(percentage, TRUE);
  $setValidators(percentage, initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [new NumberWithUnitsValidator_1(($clinit_MeasurementUnits() , PERCENTAGE))]));
  regex = new TextItem_3('calltimeChangeRegex', 'Regular Expression');
  $setRequired(regex, FALSE);
  $setPrompt_1(regex, 'If specified, this is a regular expression that must match a call destination in order to trigger the condition.');
  $setHoverWidth_0(regex, valueOf_44(200));
  $setWrapTitle(regex, FALSE);
  $setShowIfCondition(regex, ifFunc);
  if (editMode) {
    $setDefaultValue_1(percentage, '' + this$static.existingCondition.threshold);
    $setDefaultValue_1(regex, this$static.existingCondition.name_0);
  }
  setCheck(formItems.array, formItems.size_0++, percentage);
  setCheck(formItems.array, formItems.size_0++, regex);
  return formItems;
}

function $buildCalltimeMetricDropDownMenu(this$static, itemName, ifFunc, editMode){
  var def, def$iterator, metricSelection, metricsMap;
  metricsMap = new LinkedHashMap_0;
  for (def$iterator = this$static.resourceType.metricDefinitions.iterator(); def$iterator.hasNext();) {
    def = dynamicCast(def$iterator.next_0(), Q$MeasurementDefinition);
    def.dataType == ($clinit_DataType() , CALLTIME) && $put_1(metricsMap, '' + def.id, def.displayName);
  }
  metricSelection = new SortedSelectItem_2(itemName, ($clinit_Enhanced() , 'Call Time Metric'));
  $setValueMap_1(metricSelection, metricsMap);
  $setDefaultValue_1(metricSelection, editMode?'' + this$static.existingCondition.measurementDefinition.id:dynamicCast($next_1($iterator($keySet(metricsMap))), Q$String));
  $setWidth_2(metricSelection, '*');
  $isCreated_2(metricSelection)?$setProperty_9(metricSelection, 'redrawOnChange', true):(metricSelection.jsObj['redrawOnChange'] = true , undefined);
  $setShowIfCondition(metricSelection, ifFunc);
  return metricSelection;
}

function $buildCalltimeThresholdFormItems(this$static, editMode){
  var absoluteValue, formItems, helpItem, ifFunc, limits, metricDropDownMenu, minMaxAvgSelection, regex;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_0('calltime-threshold');
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('calltimeThresholdHelp', 'Specify the calltime threshold value that, when violated, triggers the condition. The value you specify is an absolute value with an optional units specifier. You also must specify which calltime limit to compare the value with (minimum, maximum or average calltime value).', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  metricDropDownMenu = $buildCalltimeMetricDropDownMenu(this$static, 'calltimeThresholdMetric', ifFunc, editMode);
  setCheck(formItems.array, formItems.size_0++, metricDropDownMenu);
  minMaxAvgSelection = new SelectItem_2('calltimeThresholdMinMaxAvgSelection', 'Call Time Limit');
  limits = new LinkedHashMap_1(3);
  $put_1(limits, 'MIN', 'Minimum');
  $put_1(limits, 'AVG', 'Average');
  $put_1(limits, 'MAX', 'Maximum');
  $setPrompt_1(minMaxAvgSelection, 'The calltime limit value that is to be compared with the given value');
  $setHoverWidth_0(minMaxAvgSelection, valueOf_44(200));
  minMaxAvgSelection.setValueMap_0(limits);
  $setDefaultValue_1(minMaxAvgSelection, editMode?this$static.existingCondition.option:'AVG');
  $setWrapTitle(minMaxAvgSelection, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setWidth_2(minMaxAvgSelection, '*');
  $isCreated_2(minMaxAvgSelection)?$setProperty_9(minMaxAvgSelection, 'redrawOnChange', true):(minMaxAvgSelection.jsObj['redrawOnChange'] = true , undefined);
  $setShowIfCondition(minMaxAvgSelection, ifFunc);
  setCheck(formItems.array, formItems.size_0++, minMaxAvgSelection);
  $add_3(formItems, $buildComparatorDropDownMenu(this$static, 'calltimeThresholdComparator', ifFunc, editMode));
  absoluteValue = new TextItem_3('calltimeThresholdAbsoluteValue', 'Call Time Value');
  $setWrapTitle(absoluteValue, FALSE);
  $setRequired(absoluteValue, TRUE);
  $setPrompt_1(absoluteValue, 'The threshold value of the metric that will trigger the condition when compared using the selected comparator.');
  $setHoverWidth_0(absoluteValue, valueOf_44(200));
  $setShowIfCondition(absoluteValue, ifFunc);
  $setValidateOnChange_0(absoluteValue, TRUE);
  $setValidators(absoluteValue, initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [new NumberWithUnitsValidator_0(this$static.resourceType.metricDefinitions, metricDropDownMenu)]));
  regex = new TextItem_3('calltimeThresholdRegex', 'Regular Expression');
  $setRequired(regex, FALSE);
  $setPrompt_1(regex, 'If specified, this is a regular expression that must match a call destination in order to trigger the condition.');
  $setHoverWidth_0(regex, valueOf_44(200));
  $setWrapTitle(regex, FALSE);
  $setShowIfCondition(regex, ifFunc);
  if (editMode) {
    $setDefaultValue_1(absoluteValue, '' + this$static.existingCondition.threshold);
    $setDefaultValue_1(regex, this$static.existingCondition.name_0);
  }
  setCheck(formItems.array, formItems.size_0++, absoluteValue);
  setCheck(formItems.array, formItems.size_0++, regex);
  return formItems;
}

function $buildComparatorDropDownMenu(this$static, itemName, ifFunc, editMode){
  var comparatorSelection, comparators;
  comparators = new LinkedHashMap_1(3);
  $put_1(comparators, '<', '< (' + ($clinit_Enhanced() , 'Less than') + ')');
  $put_1(comparators, '=', '= (Equal to)');
  $put_1(comparators, '>', '> (Greater Than)');
  comparatorSelection = new SortedSelectItem_2(itemName, 'Comparator');
  $setValueMap_1(comparatorSelection, comparators);
  $setDefaultValue_1(comparatorSelection, editMode?this$static.existingCondition.comparator:'<');
  $setPrompt_1(comparatorSelection, 'How a collected metric value should be compared to the given threshold value');
  $setHoverWidth_0(comparatorSelection, valueOf_44(200));
  $setShowIfCondition(comparatorSelection, ifFunc);
  return comparatorSelection;
}

function $buildDriftFormItems(this$static, editMode){
  var driftDefNameRegex, driftPathNameRegex, formItems, helpItem, ifFunc;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , DRIFT));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('driftHelp', 'This condition is triggered when drift has been detected.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  driftDefNameRegex = new TextItem_3('driftDefNameRegex', 'Drift Definition Name');
  $setRequired(driftDefNameRegex, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setPrompt_1(driftDefNameRegex, 'If specified, this is the drift definition name that was responsible for the drift that was detected. This can optionally be a regular expression if you wish to match multiple drift definition names.');
  $setHoverWidth_0(driftDefNameRegex, valueOf_44(200));
  $setWrapTitle(driftDefNameRegex, FALSE);
  $setShowIfCondition(driftDefNameRegex, ifFunc);
  driftPathNameRegex = new TextItem_3('driftPathNameRegex', 'Pathname Regular Expression');
  $setRequired(driftPathNameRegex, FALSE);
  $setPrompt_1(driftPathNameRegex, 'If specified, this is a regular expression that must match the pathnames of those files that drifted.');
  $setHoverWidth_0(driftPathNameRegex, valueOf_44(200));
  $setWrapTitle(driftPathNameRegex, FALSE);
  $setShowIfCondition(driftPathNameRegex, ifFunc);
  if (editMode) {
    $setDefaultValue_1(driftDefNameRegex, this$static.existingCondition.name_0);
    $setDefaultValue_1(driftPathNameRegex, this$static.existingCondition.option);
  }
  setCheck(formItems.array, formItems.size_0++, driftDefNameRegex);
  setCheck(formItems.array, formItems.size_0++, driftPathNameRegex);
  return formItems;
}

function $buildEventFormItems(this$static, editMode){
  var eventRegex, eventSeveritySelection, formItems, helpItem, ifFunc, severities;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , EVENT));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('eventHelp', 'Specify the event severity that an event message must be reported with in order to trigger this condition. If you specify an optional regular expression, the event message must also match that regular expression in order for the condition to trigger.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  eventSeveritySelection = new SelectItem_2('eventSeverity', 'Event Severity');
  severities = new LinkedHashMap_1(5);
  $put_1(severities, ($clinit_EventSeverity() , DEBUG).name_0, 'Debug');
  $put_1(severities, INFO_1.name_0, 'Info');
  $put_1(severities, WARN_0.name_0, 'Warn');
  $put_1(severities, ERROR.name_0, 'Error');
  $put_1(severities, FATAL.name_0, 'Fatal');
  eventSeveritySelection.setValueMap_0(severities);
  $setDefaultValue_1(eventSeveritySelection, editMode?this$static.existingCondition.name_0:ERROR.name_0);
  $setWrapTitle(eventSeveritySelection, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowIfCondition(eventSeveritySelection, ifFunc);
  setCheck(formItems.array, formItems.size_0++, eventSeveritySelection);
  eventRegex = new TextItem_3('eventRegex', 'Regular Expression');
  $setRequired(eventRegex, FALSE);
  $setPrompt_1(eventRegex, 'If specified, this is a regular expression that must match a collected event message in order to trigger the condition.');
  $setHoverWidth_0(eventRegex, valueOf_44(200));
  $setWrapTitle(eventRegex, FALSE);
  $setShowIfCondition(eventRegex, ifFunc);
  editMode && $setDefaultValue_1(eventRegex, this$static.existingCondition.option);
  setCheck(formItems.array, formItems.size_0++, eventRegex);
  return formItems;
}

function $buildHelpTextItem(itemName, helpText, ifFunc){
  var help;
  help = new StaticTextItem_1(itemName);
  $setShowTitle_0(help, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_2(help)?$setProperty_6(help, 'colSpan', 2):(help.jsObj['colSpan'] = 2 , undefined);
  $isCreated_2(help)?$setProperty_6(help, 'rowSpan', 2):(help.jsObj['rowSpan'] = 2 , undefined);
  $setWrap_1(help, TRUE);
  $setValue_7(help, helpText);
  $setShowIfCondition(help, ifFunc);
  return help;
}

function $buildMetricBaselineFormItems(this$static, editMode){
  var baselinePercentage, baselineSelection, baselines, formItems, helpItem, ifFunc, metricDropDownMenu, noMetrics;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , BASELINE));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('baselineHelp', 'Specify the baseline value that must be violated to trigger the condition. The value you specify is a percentage of the given baseline value.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  metricDropDownMenu = $buildMetricDropDownMenu(this$static, 'baselineMetric', true, ifFunc, editMode);
  if (metricDropDownMenu) {
    setCheck(formItems.array, formItems.size_0++, metricDropDownMenu);
    $add_3(formItems, $buildComparatorDropDownMenu(this$static, 'baselineComparator', ifFunc, editMode));
    baselinePercentage = new TextItem_3('baselinePercentage', 'Baseline Percentage');
    $setWrapTitle(baselinePercentage, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setRequired(baselinePercentage, TRUE);
    $setPrompt_1(baselinePercentage, 'A collected metric value will trigger this condition when compared to this percentage of the selected baseline value using the selected comparator');
    $setHoverWidth_0(baselinePercentage, valueOf_44(200));
    $setShowIfCondition(baselinePercentage, ifFunc);
    $setValidateOnChange_0(baselinePercentage, TRUE);
    $setValidators(baselinePercentage, initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [new NumberWithUnitsValidator_1(($clinit_MeasurementUnits() , PERCENTAGE))]));
    editMode && $setDefaultValue_1(baselinePercentage, '' + this$static.existingCondition.threshold);
    setCheck(formItems.array, formItems.size_0++, baselinePercentage);
    baselineSelection = new SelectItem_2('baselineSelection', 'Baseline');
    baselines = new LinkedHashMap_1(3);
    $put_1(baselines, 'min', 'Minimum');
    $put_1(baselines, 'mean', 'Average');
    $put_1(baselines, 'max', 'Maximum');
    baselineSelection.setValueMap_0(baselines);
    $setDefaultValue_1(baselineSelection, editMode?this$static.existingCondition.option:'mean');
    $setWrapTitle(baselineSelection, FALSE);
    $setWidth_2(baselineSelection, '*');
    $isCreated_2(baselineSelection)?$setProperty_9(baselineSelection, 'redrawOnChange', true):(baselineSelection.jsObj['redrawOnChange'] = true , undefined);
    $setShowIfCondition(baselineSelection, ifFunc);
    setCheck(formItems.array, formItems.size_0++, baselineSelection);
  }
   else {
    noMetrics = $buildHelpTextItem('baselineNoMetrics', 'When using the ALL conjunction, you cannot use the same metric in multiple conditions and this alert uses all available metrics in currently existing conditions.', ifFunc);
    setCheck(formItems.array, formItems.size_0++, noMetrics);
  }
  return formItems;
}

function $buildMetricChangeFormItems(this$static, editMode){
  var formItems, helpItem, ifFunc, metricDropDownMenu, noMetrics;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , CHANGE));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('changeMetricHelp', 'Specify the metric whose value must change to trigger the condition.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  metricDropDownMenu = $buildMetricDropDownMenu(this$static, 'changeMetric', false, ifFunc, editMode);
  if (metricDropDownMenu) {
    setCheck(formItems.array, formItems.size_0++, metricDropDownMenu);
  }
   else {
    noMetrics = $buildHelpTextItem('changeNoMetrics', 'When using the ALL conjunction, you cannot use the same metric in multiple conditions and this alert uses all available metrics in currently existing conditions.', ifFunc);
    setCheck(formItems.array, formItems.size_0++, noMetrics);
  }
  return formItems;
}

function $buildMetricDropDownMenu(this$static, itemName, dynamicOnly, ifFunc, editMode){
  var condition, condition$iterator, def, def$iterator, idString, metricIdsToHide, metricSelection, metricsMap, sortedDefs;
  metricIdsToHide = new HashSet_0;
  if ($equals_6(($clinit_BooleanExpression() , ALL_0).name_0, toString__devirtual$($getValue_0(this$static.conditionExpression)))) {
    for (condition$iterator = $iterator($keySet(this$static.conditions.map)); condition$iterator.val$outerIter.hasNext();) {
      condition = dynamicCast($next_1(condition$iterator), Q$AlertCondition);
      !!condition.measurementDefinition && $add_6(metricIdsToHide, '' + condition.measurementDefinition.id);
    }
  }
  metricsMap = new LinkedHashMap_0;
  sortedDefs = new HashSet_2(this$static.resourceType.metricDefinitions);
  for (def$iterator = $iterator($keySet(sortedDefs.map)); def$iterator.val$outerIter.hasNext();) {
    def = dynamicCast($next_1(def$iterator), Q$MeasurementDefinition);
    if (def.dataType == ($clinit_DataType() , MEASUREMENT)) {
      if (!dynamicOnly || def.numericType == ($clinit_NumericType() , DYNAMIC)) {
        idString = '' + def.id;
        metricIdsToHide.map.containsKey(idString) || $put_1(metricsMap, idString, def.displayName);
      }
    }
  }
  if (metricsMap.map.size_1() == 0) {
    return null;
  }
  metricSelection = new SortedSelectItem_2(itemName, ($clinit_Enhanced() , 'Metric'));
  $setValueMap_1(metricSelection, metricsMap);
  $setDefaultValue_1(metricSelection, editMode?'' + this$static.existingCondition.measurementDefinition.id:dynamicCast($next_1($iterator($keySet(metricsMap))), Q$String));
  $setWidth_2(metricSelection, '*');
  $isCreated_2(metricSelection)?$setProperty_9(metricSelection, 'redrawOnChange', true):(metricSelection.jsObj['redrawOnChange'] = true , undefined);
  $setShowIfCondition(metricSelection, ifFunc);
  return metricSelection;
}

function $buildMetricRangeFormItems(this$static, editMode){
  var absoluteHighValue, absoluteLowValue, formItems, helpItem, ifFunc, metricDropDownMenu, noMetrics, comparators, comparatorSelection;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , RANGE));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('rangeHelp', 'Compares a metric value to a given low-high value range.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  metricDropDownMenu = $buildMetricDropDownMenu(this$static, 'rangeMetric', false, ifFunc, editMode);
  if (metricDropDownMenu) {
    setCheck(formItems.array, formItems.size_0++, metricDropDownMenu);
    $add_3(formItems, (comparators = new LinkedHashMap_1(2) , $put_1(comparators, '<', 'Inside, exclusive') , $put_1(comparators, '>', 'Outside, exclusive') , $put_1(comparators, '<=', 'Inside, inclusive') , $put_1(comparators, '>=', 'Outside, inclusive') , comparatorSelection = new SortedSelectItem_2('rangeComparator', 'Comparator') , $setValueMap_1(comparatorSelection, comparators) , $setDefaultValue_1(comparatorSelection, editMode?this$static.existingCondition.comparator:'<') , $setPrompt_1(comparatorSelection, 'Determines if a metric value should trigger this condition when inside the range or outside of it. If inclusive, the value is considered to be in the range if its value equals a low or high threshold value. If exclusive, the value is not considered in the range if it equals the low or high value.') , $setHoverWidth_0(comparatorSelection, valueOf_44(200)) , $setShowIfCondition(comparatorSelection, ifFunc) , comparatorSelection));
    absoluteLowValue = new TextItem_3('rangeMetricLoValue', 'Low Value');
    $setWrapTitle(absoluteLowValue, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setRequired(absoluteLowValue, TRUE);
    $setPrompt_1(absoluteLowValue, 'The low threshold value of the range.');
    $setHoverWidth_0(absoluteLowValue, valueOf_44(200));
    $setValidateOnChange_0(absoluteLowValue, TRUE);
    $setValidators(absoluteLowValue, initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [new NumberWithUnitsValidator_0(this$static.resourceType.metricDefinitions, metricDropDownMenu)]));
    $setShowIfCondition(absoluteLowValue, ifFunc);
    absoluteHighValue = new TextItem_3('rangeMetricHiValue', 'High Value');
    $setWrapTitle(absoluteHighValue, FALSE);
    $setRequired(absoluteHighValue, TRUE);
    $setPrompt_1(absoluteHighValue, 'The high threshold value of the range.');
    $setHoverWidth_0(absoluteHighValue, valueOf_44(200));
    $setValidateOnChange_0(absoluteHighValue, TRUE);
    $setValidators(absoluteHighValue, initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [new NumberWithUnitsValidator_0(this$static.resourceType.metricDefinitions, metricDropDownMenu)]));
    $setShowIfCondition(absoluteHighValue, ifFunc);
    if (editMode) {
      $setDefaultValue_1(absoluteLowValue, '' + this$static.existingCondition.threshold);
      $setDefaultValue_1(absoluteHighValue, '' + this$static.existingCondition.option);
    }
    setCheck(formItems.array, formItems.size_0++, absoluteLowValue);
    setCheck(formItems.array, formItems.size_0++, absoluteHighValue);
  }
   else {
    noMetrics = $buildHelpTextItem('rangeNoMetrics', 'When using the ALL conjunction, you cannot use the same metric in multiple conditions and this alert uses all available metrics in currently existing conditions.', ifFunc);
    setCheck(formItems.array, formItems.size_0++, noMetrics);
  }
  return formItems;
}

function $buildMetricThresholdFormItems(this$static, editMode){
  var absoluteValue, formItems, helpItem, ifFunc, metricDropDownMenu, noMetrics;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , THRESHOLD));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('thresholdHelp', 'Specify the threshold value that, when violated, triggers the condition. The value you specify is an absolute value with an optional units specifier.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  metricDropDownMenu = $buildMetricDropDownMenu(this$static, 'thresholdMetric', false, ifFunc, editMode);
  if (metricDropDownMenu) {
    setCheck(formItems.array, formItems.size_0++, metricDropDownMenu);
    $add_3(formItems, $buildComparatorDropDownMenu(this$static, 'thresholdComparator', ifFunc, editMode));
    absoluteValue = new TextItem_3('metricAbsoluteValue', 'Metric Value');
    $setWrapTitle(absoluteValue, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setRequired(absoluteValue, TRUE);
    $setPrompt_1(absoluteValue, 'The threshold value of the metric that will trigger the condition when compared using the selected comparator.');
    $setHoverWidth_0(absoluteValue, valueOf_44(200));
    $setValidateOnChange_0(absoluteValue, TRUE);
    $setValidators(absoluteValue, initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [new NumberWithUnitsValidator_0(this$static.resourceType.metricDefinitions, metricDropDownMenu)]));
    editMode && $setDefaultValue_1(absoluteValue, '' + this$static.existingCondition.threshold);
    $setShowIfCondition(absoluteValue, ifFunc);
    setCheck(formItems.array, formItems.size_0++, absoluteValue);
  }
   else {
    noMetrics = $buildHelpTextItem('thresholdNoMetrics', 'When using the ALL conjunction, you cannot use the same metric in multiple conditions and this alert uses all available metrics in currently existing conditions.', ifFunc);
    setCheck(formItems.array, formItems.size_0++, noMetrics);
  }
  return formItems;
}

function $buildOperationFormItems(this$static, editMode){
  var formItems, helpItem, ifFunc, opDef, opDef$iterator, opResultsSelection, opSelection, operationStatuses, ops;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , CONTROL));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('operationHelp', 'Specify the result that must occur when the selected operation is executed in order to trigger the condition.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  ops = new LinkedHashMap_0;
  for (opDef$iterator = this$static.resourceType.operationDefinitions.iterator(); opDef$iterator.hasNext();) {
    opDef = dynamicCast(opDef$iterator.next_0(), Q$OperationDefinition);
    $put_1(ops, opDef.name_0, opDef.displayName);
  }
  opSelection = new SortedSelectItem_2('operation', 'Value');
  $setValueMap_1(opSelection, ops);
  $setDefaultValue_1(opSelection, editMode?this$static.existingCondition.name_0:dynamicCast($next_1($iterator($keySet(ops))), Q$String));
  $setWidth_2(opSelection, '*');
  $isCreated_2(opSelection)?$setProperty_9(opSelection, 'redrawOnChange', true):(opSelection.jsObj['redrawOnChange'] = true , undefined);
  $setShowIfCondition(opSelection, ifFunc);
  setCheck(formItems.array, formItems.size_0++, opSelection);
  opResultsSelection = new SortedSelectItem_2('operationResults', 'Status');
  operationStatuses = new LinkedHashMap_1(4);
  $put_1(operationStatuses, ($clinit_OperationRequestStatus() , INPROGRESS_1).name_0, 'In Progress');
  $put_1(operationStatuses, SUCCESS_6.name_0, 'Success');
  $put_1(operationStatuses, FAILURE_6.name_0, 'Failed');
  $put_1(operationStatuses, CANCELED.name_0, 'Canceled');
  $setValueMap_1(opResultsSelection, operationStatuses);
  $setDefaultValue_1(opResultsSelection, editMode?this$static.existingCondition.option:FAILURE_6.name_0);
  $setWrapTitle(opResultsSelection, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowIfCondition(opResultsSelection, ifFunc);
  setCheck(formItems.array, formItems.size_0++, opResultsSelection);
  return formItems;
}

function $buildResourceConfigChangeFormItems(){
  var formItems, helpItem, ifFunc;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , RESOURCE_CONFIG));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('changeConfigHelp', 'This condition is triggered when the resource configuration changes.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  return formItems;
}

function $buildTraitChangeFormItems(this$static, editMode){
  var def, def$iterator, eventRegex, formItems, helpItem, ifFunc, traitSelection, traitsMap;
  formItems = new ArrayList_0;
  ifFunc = new ConditionEditor$ShowIfCategoryFunction_1(($clinit_AlertConditionCategory() , TRAIT));
  $clinit_Enhanced();
  helpItem = $buildHelpTextItem('traitHelp', 'Specify the trait whose value must change to trigger the condition.', ifFunc);
  setCheck(formItems.array, formItems.size_0++, helpItem);
  traitsMap = new LinkedHashMap_0;
  for (def$iterator = this$static.resourceType.metricDefinitions.iterator(); def$iterator.hasNext();) {
    def = dynamicCast(def$iterator.next_0(), Q$MeasurementDefinition);
    def.dataType == ($clinit_DataType() , TRAIT_0) && $put_1(traitsMap, '' + def.id, def.displayName);
  }
  traitSelection = new SortedSelectItem_2('trait', 'Trait');
  $setValueMap_1(traitSelection, traitsMap);
  $setDefaultValue_1(traitSelection, editMode?'' + this$static.existingCondition.measurementDefinition.id:dynamicCast($next_1($iterator($keySet(traitsMap))), Q$String));
  $setWidth_2(traitSelection, '*');
  $isCreated_2(traitSelection)?$setProperty_9(traitSelection, 'redrawOnChange', true):(traitSelection.jsObj['redrawOnChange'] = true , undefined);
  $setShowIfCondition(traitSelection, ifFunc);
  setCheck(formItems.array, formItems.size_0++, traitSelection);
  eventRegex = new TextItem_3('traitRegex', 'Regular Expression');
  $setRequired(eventRegex, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setPrompt_1(eventRegex, 'If specified, this is a regular expression that must match the new trait value in order to trigger the condition.');
  $setHoverWidth_0(eventRegex, valueOf_44(200));
  $setWrapTitle(eventRegex, FALSE);
  $setShowIfCondition(eventRegex, ifFunc);
  editMode && $setDefaultValue_1(eventRegex, this$static.existingCondition.option);
  setCheck(formItems.array, formItems.size_0++, eventRegex);
  return formItems;
}

function $getMeasurementDefinition(this$static, metricId){
  var def, def$iterator, id;
  id = valueOf_44(__parseAndValidateInt(metricId)).value_0;
  for (def$iterator = this$static.resourceType.metricDefinitions.iterator(); def$iterator.hasNext();) {
    def = dynamicCast(def$iterator.next_0(), Q$MeasurementDefinition);
    if (id == def.id) {
      return def;
    }
  }
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Should have found metric definition - something is wrong'), null);
  return null;
}

function $getMeasurementValue(measDef, userEnteredValue){
  return $getMeasurementValueByUnits(measDef.units, userEnteredValue);
}

function $getMeasurementValueByUnits(units, userEnteredValue){
  return parse(userEnteredValue, units).value_0;
}

function $onFormInit(this$static, form){
  var allMessages, condTypes, formItems, spacer1, spacer2;
  this$static.conditionTypeSelectItem = new SortedSelectItem_2('conditionType', ($clinit_Enhanced() , 'Condition Type'));
  condTypes = new LinkedHashMap_1(7);
  allMessages = new HashMap_1(13);
  allMessages.put(($clinit_AlertConditionCategory() , AVAILABILITY).name_0, 'Availability Change');
  allMessages.put(AVAIL_DURATION.name_0, 'Availability Duration');
  allMessages.put(THRESHOLD.name_0, 'Measurement Absolute Value Threshold');
  allMessages.put(BASELINE.name_0, 'Measurement Baseline Threshold');
  allMessages.put(CHANGE.name_0, 'Measurement Value Change');
  allMessages.put(RANGE.name_0, 'Measurement Value Range');
  allMessages.put('calltime-threshold', 'Call Time Value Threshold');
  allMessages.put('calltime-change', 'Call Time Value Change');
  allMessages.put(TRAIT.name_0, 'Trait Value Change');
  allMessages.put(CONTROL.name_0, 'Operation Execution');
  allMessages.put(RESOURCE_CONFIG.name_0, 'Resource Configuration Change');
  allMessages.put(EVENT.name_0, 'Event Detection');
  allMessages.put(DRIFT.name_0, 'Drift Detection');
  formItems = new ArrayList_0;
  $put_1(condTypes, AVAILABILITY.name_0, dynamicCast(allMessages.get_2(AVAILABILITY.name_0), Q$String));
  $put_1(condTypes, AVAIL_DURATION.name_0, dynamicCast(allMessages.get_2(AVAIL_DURATION.name_0), Q$String));
  $addAll_0(formItems, $buildAvailabilityChangeFormItems(this$static, this$static.editMode && AVAILABILITY == this$static.existingCondition.category));
  $addAll_0(formItems, $buildAvailabilityDurationFormItems(this$static, this$static.editMode && AVAIL_DURATION == this$static.existingCondition.category));
  if (this$static.supportsMetrics) {
    $put_1(condTypes, THRESHOLD.name_0, dynamicCast(allMessages.get_2(THRESHOLD.name_0), Q$String));
    $put_1(condTypes, BASELINE.name_0, dynamicCast(allMessages.get_2(BASELINE.name_0), Q$String));
    $put_1(condTypes, CHANGE.name_0, dynamicCast(allMessages.get_2(CHANGE.name_0), Q$String));
    $put_1(condTypes, RANGE.name_0, dynamicCast(allMessages.get_2(RANGE.name_0), Q$String));
    $addAll_0(formItems, $buildMetricThresholdFormItems(this$static, this$static.editMode && THRESHOLD == this$static.existingCondition.category && this$static.existingCondition.option == null));
    $addAll_0(formItems, $buildMetricRangeFormItems(this$static, this$static.editMode && BASELINE == this$static.existingCondition.category));
    $addAll_0(formItems, $buildMetricBaselineFormItems(this$static, this$static.editMode && CHANGE == this$static.existingCondition.category && this$static.existingCondition.option == null));
    $addAll_0(formItems, $buildMetricChangeFormItems(this$static, this$static.editMode && RANGE == this$static.existingCondition.category));
  }
  if (this$static.supportsCalltimeMetrics) {
    $put_1(condTypes, 'calltime-threshold', dynamicCast(allMessages.get_2('calltime-threshold'), Q$String));
    $put_1(condTypes, 'calltime-change', dynamicCast(allMessages.get_2('calltime-change'), Q$String));
    $addAll_0(formItems, $buildCalltimeThresholdFormItems(this$static, this$static.editMode && THRESHOLD == this$static.existingCondition.category && this$static.existingCondition.option != null));
    $addAll_0(formItems, $buildCalltimeChangeFormItems(this$static, this$static.editMode && CHANGE == this$static.existingCondition.category && this$static.existingCondition.option != null));
  }
  if (this$static.supportsTraits) {
    $put_1(condTypes, TRAIT.name_0, dynamicCast(allMessages.get_2(TRAIT.name_0), Q$String));
    $addAll_0(formItems, $buildTraitChangeFormItems(this$static, this$static.editMode && TRAIT == this$static.existingCondition.category));
  }
  if (this$static.supportsOperations) {
    $put_1(condTypes, CONTROL.name_0, dynamicCast(allMessages.get_2(CONTROL.name_0), Q$String));
    $addAll_0(formItems, $buildOperationFormItems(this$static, this$static.editMode && CONTROL == this$static.existingCondition.category));
  }
  if (this$static.supportsResourceConfig) {
    $put_1(condTypes, RESOURCE_CONFIG.name_0, dynamicCast(allMessages.get_2(RESOURCE_CONFIG.name_0), Q$String));
    $addAll_0(formItems, $buildResourceConfigChangeFormItems(this$static.editMode && RESOURCE_CONFIG == this$static.existingCondition.category));
  }
  if (this$static.supportsEvents) {
    $put_1(condTypes, EVENT.name_0, dynamicCast(allMessages.get_2(EVENT.name_0), Q$String));
    $addAll_0(formItems, $buildEventFormItems(this$static, this$static.editMode && EVENT == this$static.existingCondition.category));
  }
  if (this$static.supportsDrift) {
    $put_1(condTypes, DRIFT.name_0, dynamicCast(allMessages.get_2(DRIFT.name_0), Q$String));
    $addAll_0(formItems, $buildDriftFormItems(this$static, this$static.editMode && DRIFT == this$static.existingCondition.category));
  }
  $setValueMap_1(this$static.conditionTypeSelectItem, condTypes);
  $setWrapTitle(this$static.conditionTypeSelectItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setRedrawOnChange(this$static.conditionTypeSelectItem);
  $setWidth_2(this$static.conditionTypeSelectItem, '*');
  this$static.editMode?$setDefaultValue_1(this$static.conditionTypeSelectItem, this$static.existingCondition.category.name_0):$setDefaultValue_1(this$static.conditionTypeSelectItem, AVAILABILITY.name_0);
  spacer1 = new SpacerItem_0;
  spacer1.setColSpan(2);
  $isCreated_2(spacer1)?$setProperty_6(spacer1, 'height', 5):(spacer1.jsObj['height'] = 5 , undefined);
  spacer2 = new SpacerItem_0;
  spacer2.setColSpan(2);
  $isCreated_2(spacer2)?$setProperty_6(spacer2, 'height', 5):(spacer2.jsObj['height'] = 5 , undefined);
  $add_2(formItems, 0, spacer1);
  $add_2(formItems, 0, this$static.conditionTypeSelectItem);
  setCheck(formItems.array, formItems.size_0++, spacer2);
  $setFields_0(form, dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, formItems.size_0, 0)), Q$FormItem_$1));
}

function $saveCondition(this$static){
  var $e0, calltimeCategory, category, condition, condition$iterator, conditionWithoutId, duration, e, id, measDef, metricIdsUsed, msg, newCondition, selectedCategory, warning;
  try {
    if ($equals_6(($clinit_BooleanExpression() , ALL_0).name_0, toString__devirtual$($getValue_0(this$static.conditionExpression))) && this$static.supportsMetrics && !!this$static.resourceType.metricDefinitions) {
      metricIdsUsed = new HashMap_0;
      for (condition$iterator = $iterator($keySet(this$static.conditions.map)); condition$iterator.val$outerIter.hasNext();) {
        condition = dynamicCast($next_1(condition$iterator), Q$AlertCondition);
        if (condition.measurementDefinition) {
          id = valueOf_44(condition.measurementDefinition.id);
          if (metricIdsUsed.containsKey(id)) {
            msg = 'You cannot have multiple conditions that use the same metric when using the ALL conjunction. This alert definition has multiple conditions that use the metric [' + ($clinit_Enhanced() , dynamicCast(metricIdsUsed.get_2(id), Q$String)) + '].';
            warning = new Message_8(msg, ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient)));
            $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), warning);
            return false;
          }
          metricIdsUsed.put(id, condition.measurementDefinition.displayName);
        }
      }
    }
    selectedCategory = toString__devirtual$($getValue_0(this$static.conditionTypeSelectItem));
    if ($equals_6(selectedCategory, 'calltime-threshold')) {
      calltimeCategory = true;
      category = ($clinit_AlertConditionCategory() , THRESHOLD);
    }
     else if ($equals_6(selectedCategory, 'calltime-change')) {
      calltimeCategory = true;
      category = ($clinit_AlertConditionCategory() , CHANGE);
    }
     else {
      calltimeCategory = false;
      category = ($clinit_AlertConditionCategory() , dynamicCast(valueOf(($clinit_AlertConditionCategory$Map() , $MAP_41), selectedCategory), Q$AlertConditionCategory));
    }
    newCondition = new AlertCondition_0;
    newCondition.category = category;
    switch (category.ordinal) {
      case 0:
        {
          $setName_1(newCondition, $getValueAsString(this$static.form_0, 'availability'));
          newCondition.comparator = null;
          newCondition.threshold = null;
          newCondition.option = null;
          newCondition.measurementDefinition = null;
          break;
        }

      case 11:
        {
          $setName_1(newCondition, $getValueAsString(this$static.form_0, 'availabilityDuration'));
          newCondition.comparator = null;
          newCondition.threshold = null;
          duration = valueOf_44(__parseAndValidateInt($getValueAsString(this$static.form_0, 'availabilityDurationVal'))).value_0;
          newCondition.option = '' + duration;
          newCondition.measurementDefinition = null;
          break;
        }

      case 1:
        {
          if (calltimeCategory) {
            measDef = $getMeasurementDefinition(this$static, $getValueAsString(this$static.form_0, 'calltimeThresholdMetric'));
            $setName_1(newCondition, $getValueAsString(this$static.form_0, 'calltimeThresholdRegex'));
            $setThreshold(newCondition, $getMeasurementValue(measDef, $getValueAsString(this$static.form_0, 'calltimeThresholdAbsoluteValue')));
            $setComparator(newCondition, $getValueAsString(this$static.form_0, 'calltimeThresholdComparator'));
            $setOption(newCondition, $getValueAsString(this$static.form_0, 'calltimeThresholdMinMaxAvgSelection'));
            newCondition.measurementDefinition = measDef;
          }
           else {
            measDef = $getMeasurementDefinition(this$static, $getValueAsString(this$static.form_0, 'thresholdMetric'));
            $setName_1(newCondition, measDef.displayName);
            $setThreshold(newCondition, $getMeasurementValue(measDef, $getValueAsString(this$static.form_0, 'metricAbsoluteValue')));
            $setComparator(newCondition, $getValueAsString(this$static.form_0, 'thresholdComparator'));
            newCondition.option = null;
            newCondition.measurementDefinition = measDef;
          }
          break;
        }

      case 2:
        {
          measDef = $getMeasurementDefinition(this$static, $getValueAsString(this$static.form_0, 'baselineMetric'));
          $setName_1(newCondition, measDef.displayName);
          $setThreshold(newCondition, $getMeasurementValueByUnits(($clinit_MeasurementUnits() , PERCENTAGE), $getValueAsString(this$static.form_0, 'baselinePercentage')));
          $setComparator(newCondition, $getValueAsString(this$static.form_0, 'baselineComparator'));
          $setOption(newCondition, $getValueAsString(this$static.form_0, 'baselineSelection'));
          newCondition.measurementDefinition = measDef;
          break;
        }

      case 3:
        {
          if (calltimeCategory) {
            measDef = $getMeasurementDefinition(this$static, $getValueAsString(this$static.form_0, 'calltimeChangeMetric'));
            $setName_1(newCondition, $getValueAsString(this$static.form_0, 'calltimeChangeRegex'));
            $setThreshold(newCondition, $getMeasurementValueByUnits(($clinit_MeasurementUnits() , PERCENTAGE), $getValueAsString(this$static.form_0, 'calltimeChangePercentageValue')));
            $setComparator(newCondition, $getValueAsString(this$static.form_0, 'calltimeChangeComparator'));
            $setOption(newCondition, $getValueAsString(this$static.form_0, 'calltimeChangeMinMaxAvgSelection'));
            newCondition.measurementDefinition = measDef;
          }
           else {
            measDef = $getMeasurementDefinition(this$static, $getValueAsString(this$static.form_0, 'changeMetric'));
            $setName_1(newCondition, measDef.displayName);
            newCondition.comparator = null;
            newCondition.threshold = null;
            newCondition.option = null;
            newCondition.measurementDefinition = measDef;
          }
          break;
        }

      case 4:
        {
          measDef = $getMeasurementDefinition(this$static, $getValueAsString(this$static.form_0, 'trait'));
          $setName_1(newCondition, measDef.displayName);
          newCondition.comparator = null;
          newCondition.threshold = null;
          $setOption(newCondition, $getValueAsString(this$static.form_0, 'traitRegex'));
          newCondition.measurementDefinition = measDef;
          break;
        }

      case 5:
        {
          $setName_1(newCondition, $getValueAsString(this$static.form_0, 'operation'));
          newCondition.comparator = null;
          newCondition.threshold = null;
          $setOption(newCondition, $getValueAsString(this$static.form_0, 'operationResults'));
          newCondition.measurementDefinition = null;
          break;
        }

      case 8:
        {
          $setName_1(newCondition, $getValueAsString(this$static.form_0, 'eventSeverity'));
          newCondition.comparator = null;
          newCondition.threshold = null;
          $setOption(newCondition, $getValueAsString(this$static.form_0, 'eventRegex'));
          newCondition.measurementDefinition = null;
          break;
        }

      case 7:
        {
          newCondition.name_0 = null;
          newCondition.comparator = null;
          newCondition.threshold = null;
          newCondition.option = null;
          newCondition.measurementDefinition = null;
          break;
        }

      case 9:
        {
          $setName_1(newCondition, $getValueAsString(this$static.form_0, 'driftDefNameRegex'));
          newCondition.comparator = null;
          newCondition.threshold = null;
          $setOption(newCondition, $getValueAsString(this$static.form_0, 'driftPathNameRegex'));
          newCondition.measurementDefinition = null;
          break;
        }

      case 10:
        {
          measDef = $getMeasurementDefinition(this$static, $getValueAsString(this$static.form_0, 'rangeMetric'));
          $setName_1(newCondition, measDef.displayName);
          $setThreshold(newCondition, $getMeasurementValue(measDef, $getValueAsString(this$static.form_0, 'rangeMetricLoValue')));
          $setComparator(newCondition, $getValueAsString(this$static.form_0, 'rangeComparator'));
          $setOption(newCondition, '' + $getMeasurementValue(measDef, $getValueAsString(this$static.form_0, 'rangeMetricHiValue')).value_0);
          newCondition.measurementDefinition = measDef;
          break;
        }

      default:{
          $handleError_0(($clinit_CoreGUI() , 'Invalid condition category - please report this as a bug: ' + ($clinit_Enhanced() , category.name_0)), null);
          break;
        }

    }
    if (this$static.editMode) {
      if (this$static.existingCondition.id != 0) {
        conditionWithoutId = new AlertCondition_1(this$static.existingCondition);
        if (!$equals_9(conditionWithoutId, newCondition)) {
          this$static.modifiedConditions.put(valueOf_44(this$static.existingCondition.id), newCondition);
          $setMeasurementDefinition(this$static.existingCondition, newCondition.measurementDefinition);
          $setName_1(this$static.existingCondition, newCondition.name_0);
          $setComparator(this$static.existingCondition, newCondition.comparator);
          $setThreshold(this$static.existingCondition, newCondition.threshold);
          $setOption(this$static.existingCondition, newCondition.option);
          $setTriggerId(this$static.existingCondition, newCondition.triggerId);
          $setCategory(this$static.existingCondition, newCondition.category);
        }
      }
       else {
        $remove_10(this$static.conditions, this$static.existingCondition);
        $add_6(this$static.conditions, newCondition);
      }
    }
     else {
      $add_6(this$static.conditions, newCondition);
    }
    return true;
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      e = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Problem creating condition'), e);
      return false;
    }
     else 
      throw $e0;
  }
}

function ConditionEditor_0(conditions, modifiedConditions, conditionExpression, rtype, closeFunc, existingCondition){
  var ok, cancel, footer;
  $clinit_BaseWidget();
  var measurementDefinition, measurementDefinition$iterator, metricDefinitions, operationDefinitions, wrapper;
  EnhancedVLayout_0.call(this);
  this.editMode = !!existingCondition;
  this.existingCondition = existingCondition;
  this.conditions = conditions;
  this.modifiedConditions = modifiedConditions;
  this.conditionExpression = conditionExpression;
  this.closeFunction = closeFunc;
  this.resourceType = rtype;
  this.supportsEvents = !!rtype.eventDefinitions && rtype.eventDefinitions.size_1() > 0;
  this.supportsResourceConfig = !!rtype.resourceConfigurationDefinition;
  this.supportsDrift = !!rtype.driftDefinitionTemplates && rtype.driftDefinitionTemplates.size_1() > 0;
  metricDefinitions = rtype.metricDefinitions;
  if (!!metricDefinitions && metricDefinitions.size_1() > 0) {
    for (measurementDefinition$iterator = metricDefinitions.iterator(); measurementDefinition$iterator.hasNext();) {
      measurementDefinition = dynamicCast(measurementDefinition$iterator.next_0(), Q$MeasurementDefinition);
      switch (measurementDefinition.dataType.ordinal) {
        case 0:
          {
            this.supportsMetrics = true;
            break;
          }

        case 3:
          {
            this.supportsCalltimeMetrics = true;
            break;
          }

        case 1:
          {
            this.supportsTraits = true;
            break;
          }

      }
    }
  }
  operationDefinitions = rtype.operationDefinitions;
  !!operationDefinitions && operationDefinitions.size_1() > 0 && (this.supportsOperations = true);
  this.form_0 = new ConditionEditor$1_0(this);
  wrapper = new HLayout_0;
  $setLayoutMargin(wrapper, valueOf_44(20));
  $setAttribute_24(wrapper, 'align', ($clinit_Alignment() , CENTER_0).value_0, true);
  $setAttribute_24(wrapper, 'defaultLayoutAlign', CENTER_0.value_0, false);
  $isCreated_1(wrapper)?$setProperty_0(wrapper, 'membersMargin', 20):(wrapper.config_0['membersMargin'] = 20 , undefined);
  $addMember(wrapper, this.form_0);
  $addMember(this, wrapper);
  $addMember(this, (ok = new IButton_1(($clinit_Enhanced() , 'OK')) , $addClickHandler(ok, new ConditionEditor$2_0(this)) , cancel = new IButton_1('Cancel') , $addClickHandler(cancel, new ConditionEditor$3_0(this)) , footer = new ToolStrip_0 , $setPadding(footer, valueOf_44(5)) , $isCreated_1(footer)?$setProperty_3(footer, 'width', '100%'):(footer.config_0['width'] = '100%' , undefined) , $isCreated_1(footer)?$setProperty_0(footer, 'membersMargin', 15):(footer.config_0['membersMargin'] = 15 , undefined) , $addSpacer(footer, new ToolStripSpacer_0(60)) , $addMember(footer, ok) , $addMember(footer, cancel) , $addSpacer(footer, new ToolStripSpacer_0(60)) , $addMember(footer, new LayoutSpacer_0) , footer));
}

defineSeed(1928, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ConditionEditor_0);
_.closeFunction = null;
_.conditionExpression = null;
_.conditionTypeSelectItem = null;
_.conditions = null;
_.editMode = false;
_.existingCondition = null;
_.form_0 = null;
_.modifiedConditions = null;
_.resourceType = null;
_.supportsCalltimeMetrics = false;
_.supportsDrift = false;
_.supportsEvents = false;
_.supportsMetrics = false;
_.supportsOperations = false;
_.supportsResourceConfig = false;
_.supportsTraits = false;
function ConditionEditor$1_0(this$0){
  this.this$0 = this$0;
  DynamicForm_0.call(this);
}

defineSeed(1929, 478, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), ConditionEditor$1_0);
_.onInit = function onInit_18(){
  $onInit(this);
  $onInit_DynamicForm(this);
  $onFormInit(this.this$0, this);
}
;
_.this$0 = null;
function ConditionEditor$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1930, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConditionEditor$2_0);
_.onClick = function onClick_29(event_0){
  $validate_0(this.this$0.form_0, false).value_0 && $saveCondition(this.this$0) && $run_7(this.this$0.closeFunction);
}
;
_.this$0 = null;
function ConditionEditor$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1931, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConditionEditor$3_0);
_.onClick = function onClick_30(event_0){
  $run_7(this.this$0.closeFunction);
}
;
_.this$0 = null;
function ConditionEditor$ShowIfCategoryFunction_0(calltimeCategory){
  this.category = null;
  this.calltimeCategory = calltimeCategory;
}

function ConditionEditor$ShowIfCategoryFunction_1(category){
  this.category = category;
  this.calltimeCategory = null;
}

defineSeed(1932, 1, {}, ConditionEditor$ShowIfCategoryFunction_0, ConditionEditor$ShowIfCategoryFunction_1);
_.execute_6 = function execute_20(item, value, form){
  var conditionTypeString;
  conditionTypeString = toString__devirtual$($getValue(form, 'conditionType'));
  return this.category?$equals_6(this.category.name_0, conditionTypeString):$equals_6(this.calltimeCategory, conditionTypeString);
}
;
_.calltimeCategory = null;
_.category = null;
function $buildForm_0(this$static){
  var condExprs, conditionExpressionForm;
  if (!this$static.formBuilt) {
    conditionExpressionForm = new DynamicForm_0;
    this$static.conditionExpression = new SelectItem_2('conditionExpression', ($clinit_Enhanced() , 'Fire alert when'));
    condExprs = new LinkedHashMap_1(2);
    $put_1(condExprs, ($clinit_BooleanExpression() , ANY_0).name_0, ANY_0.name_0);
    $put_1(condExprs, ALL_0.name_0, ALL_0.name_0);
    this$static.conditionExpression.setValueMap_0(condExprs);
    $setDefaultValue_1(this$static.conditionExpression, ANY_0.name_0);
    $setWrapTitle(this$static.conditionExpression, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setHoverWidth_0(this$static.conditionExpression, valueOf_44(300));
    $setPrompt_1(this$static.conditionExpression, 'Determines if ANY or ALL of the conditions must evaluate to true in order for the entire condition set to be considered true.');
    this$static.conditionExpressionStatic = new StaticTextItem_2('conditionExpressionStatic', 'Fire alert when');
    $setWrapTitle(this$static.conditionExpressionStatic, FALSE);
    conditionExpressionForm.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.conditionExpression, this$static.conditionExpressionStatic]));
    this$static.conditionsEditor = new ConditionsEditor_0(this$static.conditionExpression, this$static.resourceType);
    $addChangeHandler(this$static.conditionExpression, new ConditionsAlertDefinitionForm$1_0(this$static));
    $setMembers(this$static, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [conditionExpressionForm, this$static.conditionsEditor]));
    this$static.formBuilt = true;
  }
}

function $isResetMatching(this$static){
  return this$static.updated || this$static.conditionsEditor.updated || this$static.conditionsEditor.modifiedConditions.size_1() != 0;
}

function $makeEditable(this$static){
  $show_0(this$static.conditionExpression);
  $setEditable(this$static.conditionsEditor, true);
  $hide_0(this$static.conditionExpressionStatic);
  $markForRedraw(this$static);
}

function $makeViewOnly(this$static){
  this$static.updated = false;
  $hide_0(this$static.conditionExpression);
  $setEditable(this$static.conditionsEditor, false);
  this$static.conditionsEditor.updated = false;
  $show_0(this$static.conditionExpressionStatic);
  $markForRedraw(this$static);
}

function $saveAlertDefinition(this$static){
  var condExpr, conditions;
  this$static.updated = false;
  condExpr = toString__devirtual$($getValue_0(this$static.conditionExpression));
  $setConditionExpression(this$static.alertDefinition, ($clinit_BooleanExpression() , dynamicCast(valueOf(($clinit_BooleanExpression$Map() , $MAP_47), condExpr), Q$BooleanExpression)));
  conditions = this$static.conditionsEditor.conditions;
  $setConditions(this$static.alertDefinition, conditions);
  this$static.conditionsEditor.updated = false;
}

function $setAlertDefinition_0(this$static, alertDef){
  this$static.alertDefinition = alertDef;
  $buildForm_0(this$static);
  if (!alertDef) {
    $clearValue_0(this$static.conditionExpression);
    $setConditions_0(this$static.conditionsEditor, null);
    $clearValue_0(this$static.conditionExpressionStatic);
    $markForRedraw(this$static);
  }
   else {
    $setValue_7(this$static.conditionExpression, alertDef.conditionExpression.name_0);
    $setConditions_0(this$static.conditionsEditor, alertDef.conditions);
    $setValue_7(this$static.conditionExpressionStatic, alertDef.conditionExpression.name_0);
  }
  $markForRedraw(this$static);
}

function ConditionsAlertDefinitionForm_0(resourceType){
  EnhancedVLayout_0.call(this);
  this.resourceType = resourceType;
  this.alertDefinition = null;
  this.updated = false;
}

defineSeed(1933, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ConditionsAlertDefinitionForm_0);
_.onInit = function onInit_19(){
  $onInit(this);
  $onInit_Layout(this);
  if (!this.formBuilt) {
    $buildForm_0(this);
    $setAlertDefinition_0(this, this.alertDefinition);
    $makeViewOnly(this);
  }
}
;
_.alertDefinition = null;
_.conditionExpression = null;
_.conditionExpressionStatic = null;
_.conditionsEditor = null;
_.formBuilt = false;
_.resourceType = null;
_.updated = false;
function ConditionsAlertDefinitionForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1934, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), ConditionsAlertDefinitionForm$1_0);
_.onChange = function onChange(event_0){
  var condition, condition$iterator, conditions, id, metricIdsUsed, msg, warning;
  this.this$0.updated = true;
  if ($equals_6(($clinit_BooleanExpression() , ALL_0).name_0, toString__devirtual$($getValue_1(event_0))) && !!this.this$0.resourceType && !!this.this$0.resourceType.metricDefinitions) {
    conditions = this.this$0.conditionsEditor.conditions;
    metricIdsUsed = new HashMap_0;
    for (condition$iterator = $iterator($keySet(conditions.map)); condition$iterator.val$outerIter.hasNext();) {
      condition = dynamicCast($next_1(condition$iterator), Q$AlertCondition);
      if (condition.measurementDefinition) {
        id = valueOf_44(condition.measurementDefinition.id);
        if (metricIdsUsed.containsKey(id)) {
          msg = 'You cannot have multiple conditions that use the same metric when using the ALL conjunction. This alert definition has multiple conditions that use the metric [' + ($clinit_Enhanced() , dynamicCast(metricIdsUsed.get_2(id), Q$String)) + '].';
          warning = new Message_8(msg, ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient)));
          $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), warning);
          event_0.cancel = true;
          break;
        }
        metricIdsUsed.put(id, condition.measurementDefinition.displayName);
      }
    }
  }
  return;
}
;
_.this$0 = null;
function $findMeasurementDefinition(this$static, measurementDefinitionId){
  var measDef, measDef$iterator, measDefs;
  measDefs = this$static.resourceType.metricDefinitions;
  if (measDefs) {
    for (measDef$iterator = measDefs.iterator(); measDef$iterator.hasNext();) {
      measDef = dynamicCast(measDef$iterator.next_0(), Q$MeasurementDefinition);
      if (measDef.id == measurementDefinitionId) {
        return measDef;
      }
    }
  }
  return null;
}

function $setConditions_0(this$static, set){
  var alertCondition, alertCondition$iterator, fullMeasDef, measDef;
  this$static.conditions = new HashSet_0;
  this$static.modifiedConditions = new HashMap_1(this$static.conditions.map.size_1());
  if (set) {
    for (alertCondition$iterator = set.iterator(); alertCondition$iterator.hasNext();) {
      alertCondition = dynamicCast(alertCondition$iterator.next_0(), Q$AlertCondition);
      measDef = alertCondition.measurementDefinition;
      if (measDef) {
        if (!measDef.units) {
          fullMeasDef = $findMeasurementDefinition(this$static, measDef.id);
          !!fullMeasDef && (alertCondition.measurementDefinition = fullMeasDef);
        }
      }
    }
    $addAll(this$static.conditions, set);
  }
  !!this$static.table && $refresh(this$static.table, false);
}

function $setEditable(this$static, editable){
  $setTableActionDisableOverride(this$static.table, !editable);
}

function ConditionsEditor_0(conditionExpression, resourceType){
  EnhancedVLayout_0.call(this);
  this.conditionExpression = conditionExpression;
  this.resourceType = resourceType;
  this.updated = false;
  $setConditions_0(this, null);
  this.modifiedConditions = new HashMap_0;
}

defineSeed(1935, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ConditionsEditor_0);
_.onInit = function onInit_20(){
  $onInit(this);
  $onInit_Layout(this);
  this.table = new ConditionsEditor$ConditionsTable_0(this);
  $addMember(this, this.table);
}
;
_.conditionExpression = null;
_.conditions = null;
_.modifiedConditions = null;
_.resourceType = null;
_.table = null;
_.updated = false;
function $copyValues_20(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_13(record, 'condition', formatAlertConditionForDisplay(from));
  !from?(record.jsObj['obj'] = null , undefined):(record.jsObj['obj'] = from , undefined);
  return record;
}

function $executeFetch_10(this$static, request, response){
  $setAttribute_17(response, 'data', $buildRecords(this$static, this$static.this$0.conditions, true));
  $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
}

function ConditionsEditor$ConditionDataSource_0(this$0){
  var fields_0, conditionField;
  $clinit_RPCDataSource();
  var fields;
  this.this$0 = this$0;
  RPCDataSource_0.call(this);
  fields = (fields_0 = new ArrayList_0 , conditionField = new DataSourceTextField_1('condition', 'Condition') , setCheck(fields_0.array, fields_0.size_0++, conditionField) , fields_0);
  $addFields(this, fields);
}

defineSeed(1936, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$ConditionsEditor$ConditionDataSource]), ConditionsEditor$ConditionDataSource_0);
_.copyValues = function copyValues_29(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'obj'), Q$AlertCondition);
}
;
_.copyValues_0 = function copyValues_30(from){
  return $copyValues_20(dynamicCast(from, Q$AlertCondition));
}
;
_.executeFetch = function executeFetch_16(request, response, unused){
  $executeFetch_10(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_12(request){
  return null;
}
;
_.this$0 = null;
function $showConditionEditor(this$static, existingCondition){
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(this$static.this$0.resourceType.id), of(($clinit_ResourceTypeRepository$MetadataType() , driftDefinitionTemplates_0)), new ConditionsEditor$ConditionsTable$4_0(this$static, existingCondition));
}

function ConditionsEditor$ConditionsTable_0(this$0){
  var dataSource;
  this.this$0 = this$0;
  Table_1.call(this);
  this.showHeader = false;
  dataSource = new ConditionsEditor$ConditionDataSource_0(this$0);
  this.dataSource_1 = dataSource;
}

defineSeed(1937, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ConditionsEditor$ConditionsTable_0);
_.configureTable = function configureTable_15(){
  $addTableAction(this, ($clinit_Enhanced() , 'Add'), null, null, new ConditionsEditor$ConditionsTable$1_0(this));
  $addTableAction(this.this$0.table, 'Delete', 'Delete the selected alert condition(s)?', null, new ConditionsEditor$ConditionsTable$2_0(this, ($clinit_TableActionEnablement() , ANY_1)));
  $addTableAction(this.this$0.table, 'Edit', null, null, new ConditionsEditor$ConditionsTable$3_0(this, SINGLE_0));
}
;
_.this$0 = null;
function ConditionsEditor$ConditionsTable$1_0(this$1){
  this.this$1 = this$1;
  AbstractTableAction_0.call(this);
}

defineSeed(1938, 1608, {}, ConditionsEditor$ConditionsTable$1_0);
_.executeAction = function executeAction_27(selection, actionValue){
  $showConditionEditor(this.this$1, null);
}
;
_.this$1 = null;
function ConditionsEditor$ConditionsTable$2_0(this$1, $anonymous0){
  this.this$1 = this$1;
  this.enablement = $anonymous0;
}

defineSeed(1939, 1608, {}, ConditionsEditor$ConditionsTable$2_0);
_.executeAction = function executeAction_28(selection, actionValue){
  var condition, record, record$index, record$max, ret;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    condition = dynamicCast((ret = (dynamicCast(this.this$1.dataSource_1, Q$ConditionsEditor$ConditionDataSource) , record).jsObj['obj'] , ret === undefined?null:ret), Q$AlertCondition);
    $remove_10(this.this$1.this$0.conditions, condition);
    this.this$1.this$0.modifiedConditions.remove_3(condition);
    this.this$1.this$0.updated = true;
  }
  $refresh(this.this$1, false);
}
;
_.this$1 = null;
function ConditionsEditor$ConditionsTable$3_0(this$1, $anonymous0){
  this.this$1 = this$1;
  this.enablement = $anonymous0;
}

defineSeed(1940, 1608, {}, ConditionsEditor$ConditionsTable$3_0);
_.executeAction = function executeAction_29(selection, actionValue){
  var condition, ret;
  condition = dynamicCast((ret = (dynamicCast(this.this$1.dataSource_1, Q$ConditionsEditor$ConditionDataSource) , selection[0]).jsObj['obj'] , ret === undefined?null:ret), Q$AlertCondition);
  $showConditionEditor(this.this$1, condition);
}
;
_.this$1 = null;
function ConditionsEditor$ConditionsTable$4_0(this$1, val$existingCondition){
  this.this$1 = this$1;
  this.val$existingCondition = val$existingCondition;
}

defineSeed(1941, 1, {}, ConditionsEditor$ConditionsTable$4_0);
_.onTypesLoaded = function onTypesLoaded_3(type){
  var newConditionEditor, numConditions, template, template$iterator, winModal;
  if (type != this.this$1.this$0.resourceType) {
    !!this.this$1.this$0.resourceType.driftDefinitionTemplates && this.this$1.this$0.resourceType.driftDefinitionTemplates.clear_0();
    if (type.driftDefinitionTemplates) {
      for (template$iterator = type.driftDefinitionTemplates.iterator(); template$iterator.hasNext();) {
        template = dynamicCast(template$iterator.next_0(), Q$DriftDefinitionTemplate);
        $addDriftDefinitionTemplate(this.this$1.this$0.resourceType, template);
      }
    }
  }
  winModal = new Window_1;
  $setTitle(winModal, !this.val$existingCondition?($clinit_Enhanced() , 'Add Condition'):($clinit_Enhanced() , 'Edit Condition'));
  $setAttribute_24(winModal, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $setShowMinimizeButton(winModal, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setIsModal(winModal, TRUE);
  $setShowModalMask(winModal, TRUE);
  $setAutoSize(winModal, TRUE);
  $setAutoCenter(winModal, TRUE);
  $centerInPage(winModal);
  $addCloseClickHandler(winModal, new ConditionsEditor$ConditionsTable$4$1_0(this, winModal));
  numConditions = this.this$1.this$0.conditions.map.size_1();
  newConditionEditor = new ConditionEditor_0(this.this$1.this$0.conditions, this.this$1.this$0.modifiedConditions, this.this$1.this$0.conditionExpression, this.this$1.this$0.resourceType, new ConditionsEditor$ConditionsTable$4$2_0(this, numConditions, winModal), this.val$existingCondition);
  $addItem(winModal, newConditionEditor);
  winModal.show_0();
}
;
_.this$1 = null;
_.val$existingCondition = null;
function ConditionsEditor$ConditionsTable$4$1_0(this$2, val$winModal){
  this.this$2 = this$2;
  this.val$winModal = val$winModal;
}

defineSeed(1942, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), ConditionsEditor$ConditionsTable$4$1_0);
_.onCloseClick_0 = function onCloseClick_3(event_0){
  $markForDestroy(this.val$winModal);
  $refreshTableInfo(this.this$2.this$1);
}
;
_.this$2 = null;
_.val$winModal = null;
function $run_7(this$static){
  this$static.this$2.this$1.this$0.updated = this$static.this$2.this$1.this$0.updated || this$static.val$numConditions != this$static.this$2.this$1.this$0.conditions.map.size_1() || this$static.this$2.this$1.this$0.modifiedConditions.size_1() != 0;
  $markForDestroy(this$static.val$winModal);
  $refresh(this$static.this$2.this$1, false);
}

function ConditionsEditor$ConditionsTable$4$2_0(this$2, val$numConditions, val$winModal){
  this.this$2 = this$2;
  this.val$numConditions = val$numConditions;
  this.val$winModal = val$winModal;
}

defineSeed(1943, 1, {}, ConditionsEditor$ConditionsTable$4$2_0);
_.this$2 = null;
_.val$numConditions = 0;
_.val$winModal = null;
function $buildForm_1(this$static){
  var rules, units;
  if (!this$static.formBuilt) {
    this$static.dampeningRuleSelection = new SelectItem_2('dampeningRule', 'Dampening');
    rules = new LinkedHashMap_1(4);
    $put_1(rules, ($clinit_AlertDampening$Category() , NONE_5).name_0, $getCategoryTitle(NONE_5));
    $put_1(rules, CONSECUTIVE_COUNT.name_0, $getCategoryTitle(CONSECUTIVE_COUNT));
    $put_1(rules, PARTIAL_COUNT.name_0, $getCategoryTitle(PARTIAL_COUNT));
    $put_1(rules, DURATION_COUNT.name_0, $getCategoryTitle(DURATION_COUNT));
    this$static.dampeningRuleSelection.setValueMap_0(rules);
    $setDefaultValue_1(this$static.dampeningRuleSelection, NONE_5.name_0);
    $setWrapTitle(this$static.dampeningRuleSelection, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setRedrawOnChange(this$static.dampeningRuleSelection);
    $setHoverWidth_0(this$static.dampeningRuleSelection, valueOf_44(300));
    $addItemHoverHandler(this$static.dampeningRuleSelection, new DampeningAlertDefinitionForm$1_0(this$static));
    this$static.dampeningRuleStatic = new StaticTextItem_2('dampeningRuleStatic', 'Dampening');
    $setWrapTitle(this$static.dampeningRuleStatic, FALSE);
    $setHoverWidth_0(this$static.dampeningRuleStatic, valueOf_44(300));
    this$static.consecutiveOccurrencesSpinner = new SpinnerItem_1('consecutiveOccurrencesSpinner', 'Occurrences');
    $setWrapTitle(this$static.consecutiveOccurrencesSpinner, FALSE);
    $setMin(this$static.consecutiveOccurrencesSpinner, valueOf_44(1));
    $setMax(this$static.consecutiveOccurrencesSpinner, valueOf_44(999999));
    $setStep(this$static.consecutiveOccurrencesSpinner);
    $setDefaultValue_2(this$static.consecutiveOccurrencesSpinner, valueOf_44(1));
    $setHoverWidth_0(this$static.consecutiveOccurrencesSpinner, valueOf_44(300));
    $setPrompt_1(this$static.consecutiveOccurrencesSpinner, 'The number of times the condition set must be consecutively true before the alert is triggered');
    this$static.consecutiveOccurrencesStatic = new StaticTextItem_2('consecutiveOccurrencesStatic', 'Occurrences');
    $setWrapTitle(this$static.consecutiveOccurrencesStatic, FALSE);
    $addChangedHandler(this$static.consecutiveOccurrencesSpinner, new DampeningAlertDefinitionForm$2_0(this$static));
    this$static.partialOccurrencesSpinner = new SpinnerItem_1('partialOccurrencesSpinner', 'Occurrences');
    $setWrapTitle(this$static.partialOccurrencesSpinner, FALSE);
    $setMin(this$static.partialOccurrencesSpinner, valueOf_44(1));
    $setMax(this$static.partialOccurrencesSpinner, valueOf_44(999999));
    $setStep(this$static.partialOccurrencesSpinner);
    $setDefaultValue_2(this$static.partialOccurrencesSpinner, valueOf_44(1));
    $setHoverWidth_0(this$static.partialOccurrencesSpinner, valueOf_44(300));
    $setPrompt_1(this$static.partialOccurrencesSpinner, 'The number of times the condition set must be true during the last N evaluations before the alert is triggered.');
    this$static.partialOccurrencesStatic = new StaticTextItem_2('partialOccurrencesStatic', 'Occurrences');
    $setWrapTitle(this$static.partialOccurrencesStatic, FALSE);
    $addChangedHandler(this$static.partialOccurrencesSpinner, new DampeningAlertDefinitionForm$3_0(this$static));
    this$static.partialEvaluationsSpinner = new SpinnerItem_1('partialEvaluationsSpinner', 'Evaluations');
    $setWrapTitle(this$static.partialEvaluationsSpinner, FALSE);
    $setMin(this$static.partialEvaluationsSpinner, valueOf_44(1));
    $setMax(this$static.partialEvaluationsSpinner, valueOf_44(999999));
    $setStep(this$static.partialEvaluationsSpinner);
    $setDefaultValue_2(this$static.partialEvaluationsSpinner, valueOf_44(1));
    $setHoverWidth_0(this$static.partialEvaluationsSpinner, valueOf_44(300));
    $setPrompt_1(this$static.partialEvaluationsSpinner, 'The total number of times the condition set will be tested to see if the given number of occurrences are true.');
    this$static.partialEvaluationsStatic = new StaticTextItem_2('partialEvaluationStatic', 'Evaluations');
    $setWrapTitle(this$static.partialEvaluationsStatic, FALSE);
    $addChangedHandler(this$static.partialEvaluationsSpinner, new DampeningAlertDefinitionForm$4_0(this$static));
    this$static.durationOccurrencesSpinner = new SpinnerItem_1('durationOccurrencesSpinner', 'Occurrences');
    $setWrapTitle(this$static.durationOccurrencesSpinner, FALSE);
    $setMin(this$static.durationOccurrencesSpinner, valueOf_44(1));
    $setMax(this$static.durationOccurrencesSpinner, valueOf_44(999999));
    $setStep(this$static.durationOccurrencesSpinner);
    $setDefaultValue_2(this$static.durationOccurrencesSpinner, valueOf_44(1));
    $setHoverWidth_0(this$static.durationOccurrencesSpinner, valueOf_44(300));
    $setPrompt_1(this$static.durationOccurrencesSpinner, 'The number of times the condition set must be true during the given time period before the alert is triggered.');
    this$static.durationOccurrencesStatic = new StaticTextItem_2('durationOccurrencesStatic', 'Occurrences');
    $setWrapTitle(this$static.durationOccurrencesStatic, FALSE);
    $addChangedHandler(this$static.durationOccurrencesSpinner, new DampeningAlertDefinitionForm$5_0(this$static));
    this$static.durationTimePeriodSpinner = new SpinnerItem_1('durationTimePeriodSpinner', 'Time Period');
    $setWrapTitle(this$static.durationTimePeriodSpinner, FALSE);
    $setMin(this$static.durationTimePeriodSpinner, valueOf_44(1));
    $setMax(this$static.durationTimePeriodSpinner, valueOf_44(999999));
    $setStep(this$static.durationTimePeriodSpinner);
    $setDefaultValue_2(this$static.durationTimePeriodSpinner, valueOf_44(1));
    $setHoverWidth_0(this$static.durationTimePeriodSpinner, valueOf_44(300));
    $setPrompt_1(this$static.durationTimePeriodSpinner, 'The time span in which the condition set will be tested to see if the given number of occurrences are true.');
    this$static.durationTimePeriodStatic = new StaticTextItem_2('durationTimePeriodStatic', 'Time Period');
    $setWrapTitle(this$static.durationTimePeriodStatic, FALSE);
    $addChangedHandler(this$static.durationTimePeriodSpinner, new DampeningAlertDefinitionForm$6_0(this$static));
    this$static.durationTimeUnitsSelection = new SelectItem_2('durationTimeUnits', '');
    units = new LinkedHashMap_1(4);
    $put_1(units, ($clinit_AlertDampening$TimeUnits() , MINUTES).name_0, $getTimeUnitsTitle(MINUTES));
    $put_1(units, HOURS.name_0, $getTimeUnitsTitle(HOURS));
    $put_1(units, DAYS_0.name_0, $getTimeUnitsTitle(DAYS_0));
    $put_1(units, WEEKS.name_0, $getTimeUnitsTitle(WEEKS));
    this$static.durationTimeUnitsSelection.setValueMap_0(units);
    $setDefaultValue_1(this$static.durationTimeUnitsSelection, MINUTES.name_0);
    this$static.durationTimeUnitsStatic = new StaticTextItem_2('durationTimeUnitsStatic', '');
    $addChangedHandler(this$static.durationTimeUnitsSelection, new DampeningAlertDefinitionForm$7_0(this$static));
    $addChangedHandler(this$static.dampeningRuleSelection, new DampeningAlertDefinitionForm$8_0(this$static));
    $setFields_0(this$static, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.dampeningRuleSelection, this$static.dampeningRuleStatic, this$static.consecutiveOccurrencesSpinner, this$static.consecutiveOccurrencesStatic, this$static.partialOccurrencesSpinner, this$static.partialOccurrencesStatic, this$static.partialEvaluationsSpinner, this$static.partialEvaluationsStatic, this$static.durationOccurrencesSpinner, this$static.durationOccurrencesStatic, this$static.durationTimePeriodSpinner, this$static.durationTimePeriodStatic, this$static.durationTimeUnitsSelection, this$static.durationTimeUnitsStatic]));
    this$static.formBuilt = true;
  }
}

function $clearFormValues(this$static){
  $clearValue_0(this$static.dampeningRuleSelection);
  $clearValue_0(this$static.consecutiveOccurrencesSpinner);
  $clearValue_0(this$static.partialOccurrencesSpinner);
  $clearValue_0(this$static.partialEvaluationsSpinner);
  $clearValue_0(this$static.durationOccurrencesSpinner);
  $clearValue_0(this$static.durationTimePeriodSpinner);
  $clearValue_0(this$static.durationTimeUnitsSelection);
  $clearValue_0(this$static.dampeningRuleStatic);
  $clearValue_0(this$static.consecutiveOccurrencesStatic);
  $clearValue_0(this$static.partialOccurrencesStatic);
  $clearValue_0(this$static.partialEvaluationsStatic);
  $clearValue_0(this$static.durationOccurrencesStatic);
  $clearValue_0(this$static.durationTimePeriodStatic);
  $clearValue_0(this$static.durationTimeUnitsStatic);
  $markForRedraw(this$static);
}

function $getCategoryHelp(categorySelection){
  if ($equals_6(($clinit_AlertDampening$Category() , NONE_5).name_0, categorySelection)) {
    return 'Dampening is disabled. Every time the condition set is true, an alert will be triggered.';
  }
   else if ($equals_6(CONSECUTIVE_COUNT.name_0, categorySelection)) {
    return 'An alert is triggered once every X occurrences the condition set is true consecutively.';
  }
   else if ($equals_6(PARTIAL_COUNT.name_0, categorySelection)) {
    return 'An alert is triggered once every X occurrences the condition set is true during the last N evaluations of the condition set.';
  }
   else if ($equals_6(DURATION_COUNT.name_0, categorySelection)) {
    return 'An alert is triggered once every X occurrences the condition set is true within a given time period.';
  }
  return null;
}

function $getCategoryTitle(category){
  switch (category.ordinal) {
    case 0:
      {
        return 'None';
      }

    case 1:
      {
        return 'Consecutive';
      }

    case 2:
      {
        return 'Last N Evaluations';
      }

    case 4:
      {
        return 'Time Period';
      }

    default:{
        throw new IllegalStateException_1('Invalid dampening category - please report this as a bug: ' + category.name_0);
      }

  }
}

function $getTimeUnitsTitle(units){
  switch (units.ordinal) {
    case 0:
      {
        return 'minutes';
      }

    case 1:
      {
        return 'hours';
      }

    case 2:
      {
        return 'days';
      }

    case 3:
      {
        return 'weeks';
      }

    default:{
        throw new IllegalStateException_1('Invalid time units - please report this as a bug: ' + units.name_0);
      }

  }
}

function $makeEditable_0(this$static){
  var cat;
  $show_0(this$static.dampeningRuleSelection);
  $hide_0(this$static.dampeningRuleStatic);
  cat = valueOf_52(toString__devirtual$($getValue_0(this$static.dampeningRuleSelection)));
  switch (cat.ordinal) {
    case 0:
      {
        $hide_0(this$static.consecutiveOccurrencesSpinner);
        $hide_0(this$static.consecutiveOccurrencesStatic);
        $hide_0(this$static.partialOccurrencesSpinner);
        $hide_0(this$static.partialOccurrencesStatic);
        $hide_0(this$static.partialEvaluationsSpinner);
        $hide_0(this$static.partialEvaluationsStatic);
        $hide_0(this$static.durationOccurrencesSpinner);
        $hide_0(this$static.durationOccurrencesStatic);
        $hide_0(this$static.durationTimePeriodSpinner);
        $hide_0(this$static.durationTimePeriodStatic);
        $hide_0(this$static.durationTimeUnitsSelection);
        $hide_0(this$static.durationTimeUnitsStatic);
        break;
      }

    case 1:
      {
        $show_0(this$static.consecutiveOccurrencesSpinner);
        $hide_0(this$static.consecutiveOccurrencesStatic);
        $hide_0(this$static.partialOccurrencesSpinner);
        $hide_0(this$static.partialOccurrencesStatic);
        $hide_0(this$static.partialEvaluationsSpinner);
        $hide_0(this$static.partialEvaluationsStatic);
        $hide_0(this$static.durationOccurrencesSpinner);
        $hide_0(this$static.durationOccurrencesStatic);
        $hide_0(this$static.durationTimePeriodSpinner);
        $hide_0(this$static.durationTimePeriodStatic);
        $hide_0(this$static.durationTimeUnitsSelection);
        $hide_0(this$static.durationTimeUnitsStatic);
        break;
      }

    case 2:
      {
        $show_0(this$static.partialOccurrencesSpinner);
        $hide_0(this$static.partialOccurrencesStatic);
        $show_0(this$static.partialEvaluationsSpinner);
        $hide_0(this$static.partialEvaluationsStatic);
        $hide_0(this$static.consecutiveOccurrencesSpinner);
        $hide_0(this$static.consecutiveOccurrencesStatic);
        $hide_0(this$static.durationOccurrencesSpinner);
        $hide_0(this$static.durationOccurrencesStatic);
        $hide_0(this$static.durationTimePeriodSpinner);
        $hide_0(this$static.durationTimePeriodStatic);
        $hide_0(this$static.durationTimeUnitsSelection);
        $hide_0(this$static.durationTimeUnitsStatic);
        break;
      }

    case 4:
      {
        $show_0(this$static.durationOccurrencesSpinner);
        $hide_0(this$static.durationOccurrencesStatic);
        $show_0(this$static.durationTimePeriodSpinner);
        $hide_0(this$static.durationTimePeriodStatic);
        $show_0(this$static.durationTimeUnitsSelection);
        $hide_0(this$static.durationTimeUnitsStatic);
        $hide_0(this$static.consecutiveOccurrencesSpinner);
        $hide_0(this$static.consecutiveOccurrencesStatic);
        $hide_0(this$static.partialOccurrencesSpinner);
        $hide_0(this$static.partialOccurrencesStatic);
        $hide_0(this$static.partialEvaluationsSpinner);
        $hide_0(this$static.partialEvaluationsStatic);
        break;
      }

    default:{
        throw new IllegalStateException_1('Invalid dampening category - please report this as a bug: ' + cat.name_0);
      }

  }
  $markForRedraw(this$static);
}

function $makeViewOnly_0(this$static){
  var cat;
  this$static.updated = false;
  $hide_0(this$static.dampeningRuleSelection);
  $show_0(this$static.dampeningRuleStatic);
  cat = valueOf_52(toString__devirtual$($getValue_0(this$static.dampeningRuleSelection)));
  switch (cat.ordinal) {
    case 0:
      {
        $hide_0(this$static.consecutiveOccurrencesSpinner);
        $hide_0(this$static.consecutiveOccurrencesStatic);
        $hide_0(this$static.partialOccurrencesSpinner);
        $hide_0(this$static.partialOccurrencesStatic);
        $hide_0(this$static.partialEvaluationsSpinner);
        $hide_0(this$static.partialEvaluationsStatic);
        $hide_0(this$static.durationOccurrencesSpinner);
        $hide_0(this$static.durationOccurrencesStatic);
        $hide_0(this$static.durationTimePeriodSpinner);
        $hide_0(this$static.durationTimePeriodStatic);
        $hide_0(this$static.durationTimeUnitsSelection);
        $hide_0(this$static.durationTimeUnitsStatic);
        break;
      }

    case 1:
      {
        $hide_0(this$static.consecutiveOccurrencesSpinner);
        $show_0(this$static.consecutiveOccurrencesStatic);
        $hide_0(this$static.partialOccurrencesSpinner);
        $hide_0(this$static.partialOccurrencesStatic);
        $hide_0(this$static.partialEvaluationsSpinner);
        $hide_0(this$static.partialEvaluationsStatic);
        $hide_0(this$static.durationOccurrencesSpinner);
        $hide_0(this$static.durationOccurrencesStatic);
        $hide_0(this$static.durationTimePeriodSpinner);
        $hide_0(this$static.durationTimePeriodStatic);
        $hide_0(this$static.durationTimeUnitsSelection);
        $hide_0(this$static.durationTimeUnitsStatic);
        break;
      }

    case 2:
      {
        $hide_0(this$static.partialOccurrencesSpinner);
        $show_0(this$static.partialOccurrencesStatic);
        $hide_0(this$static.partialEvaluationsSpinner);
        $show_0(this$static.partialEvaluationsStatic);
        $hide_0(this$static.consecutiveOccurrencesSpinner);
        $hide_0(this$static.consecutiveOccurrencesStatic);
        $hide_0(this$static.durationOccurrencesSpinner);
        $hide_0(this$static.durationOccurrencesStatic);
        $hide_0(this$static.durationTimePeriodSpinner);
        $hide_0(this$static.durationTimePeriodStatic);
        $hide_0(this$static.durationTimeUnitsSelection);
        $hide_0(this$static.durationTimeUnitsStatic);
        break;
      }

    case 4:
      {
        $hide_0(this$static.durationOccurrencesSpinner);
        $show_0(this$static.durationOccurrencesStatic);
        $hide_0(this$static.durationTimePeriodSpinner);
        $show_0(this$static.durationTimePeriodStatic);
        $hide_0(this$static.durationTimeUnitsSelection);
        $show_0(this$static.durationTimeUnitsStatic);
        $hide_0(this$static.consecutiveOccurrencesSpinner);
        $hide_0(this$static.consecutiveOccurrencesStatic);
        $hide_0(this$static.partialOccurrencesSpinner);
        $hide_0(this$static.partialOccurrencesStatic);
        $hide_0(this$static.partialEvaluationsSpinner);
        $hide_0(this$static.partialEvaluationsStatic);
        break;
      }

    default:{
        throw new IllegalStateException_1('Invalid dampening category - please report this as a bug: ' + cat.name_0);
      }

  }
  $markForRedraw(this$static);
}

function $saveAlertDefinition_0(this$static){
  var alertDampening, cat;
  this$static.updated = false;
  cat = valueOf_52(toString__devirtual$($getValue_0(this$static.dampeningRuleSelection)));
  alertDampening = new AlertDampening_1(cat);
  switch (cat.ordinal) {
    case 0:
      {
        alertDampening.value_0 = 0;
        alertDampening.valueUnits = null;
        alertDampening.period = 0;
        alertDampening.periodUnits = null;
        break;
      }

    case 1:
      {
        $setValue_11(alertDampening, valueOf_44(__parseAndValidateInt(toString__devirtual$($getValue_0(this$static.consecutiveOccurrencesSpinner)))).value_0);
        alertDampening.valueUnits = null;
        alertDampening.period = 0;
        alertDampening.periodUnits = null;
        break;
      }

    case 2:
      {
        $setValue_11(alertDampening, valueOf_44(__parseAndValidateInt(toString__devirtual$($getValue_0(this$static.partialOccurrencesSpinner)))).value_0);
        alertDampening.valueUnits = null;
        $setPeriod(alertDampening, valueOf_44(__parseAndValidateInt(toString__devirtual$($getValue_0(this$static.partialEvaluationsSpinner)))).value_0);
        alertDampening.periodUnits = null;
        break;
      }

    case 4:
      {
        $setValue_11(alertDampening, valueOf_44(__parseAndValidateInt(toString__devirtual$($getValue_0(this$static.durationOccurrencesSpinner)))).value_0);
        alertDampening.valueUnits = null;
        $setPeriod(alertDampening, valueOf_44(__parseAndValidateInt(toString__devirtual$($getValue_0(this$static.durationTimePeriodSpinner)))).value_0);
        $setPeriodUnits(alertDampening, valueOf_53(toString__devirtual$($getValue_0(this$static.durationTimeUnitsSelection))));
        break;
      }

    default:{
        throw new IllegalStateException_1('Invalid dampening category - please report this as a bug: ' + cat.name_0);
      }

  }
  $setAlertDampening(this$static.alertDefinition, alertDampening);
}

function $setAlertDefinition_1(this$static, alertDef){
  var alertDampening, category;
  this$static.alertDefinition = alertDef;
  $buildForm_1(this$static);
  if (!alertDef) {
    $clearFormValues(this$static);
  }
   else {
    $clearFormValues(this$static);
    alertDampening = alertDef.alertDampening;
    if (!alertDampening) {
      alertDampening = new AlertDampening_1(($clinit_AlertDampening$Category() , NONE_5));
      $setAlertDampening(this$static.alertDefinition, alertDampening);
    }
    category = alertDampening.category;
    $setValue_7(this$static.dampeningRuleSelection, category.name_0);
    $setValue_7(this$static.dampeningRuleStatic, $getCategoryTitle(category));
    $setPrompt_1(this$static.dampeningRuleStatic, $getCategoryHelp(category.name_0));
    switch (category.ordinal) {
      case 0:
        {
          break;
        }

      case 1:
        {
          $setValue_5(this$static.consecutiveOccurrencesSpinner, alertDampening.value_0);
          $setValue_5(this$static.consecutiveOccurrencesStatic, alertDampening.value_0);
          break;
        }

      case 2:
        {
          $setValue_5(this$static.partialOccurrencesSpinner, alertDampening.value_0);
          $setValue_5(this$static.partialOccurrencesStatic, alertDampening.value_0);
          $setValue_5(this$static.partialEvaluationsSpinner, alertDampening.period);
          $setValue_5(this$static.partialEvaluationsStatic, alertDampening.period);
          break;
        }

      case 4:
        {
          $setValue_5(this$static.durationOccurrencesSpinner, alertDampening.value_0);
          $setValue_5(this$static.durationOccurrencesStatic, alertDampening.value_0);
          $setValue_5(this$static.durationTimePeriodSpinner, alertDampening.period);
          $setValue_5(this$static.durationTimePeriodStatic, alertDampening.period);
          $setValue_7(this$static.durationTimeUnitsSelection, alertDampening.periodUnits.name_0);
          $setValue_7(this$static.durationTimeUnitsStatic, $getTimeUnitsTitle(alertDampening.periodUnits));
          break;
        }

      default:{
          throw new IllegalStateException_1('Invalid dampening category - please report this as a bug: ' + category.name_0);
        }

    }
  }
  $markForRedraw(this$static);
}

function DampeningAlertDefinitionForm_0(){
  DynamicForm_0.call(this);
  $clinit_CoreGUI();
  this.alertDefinition = null;
  this.updated = false;
}

defineSeed(1944, 478, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), DampeningAlertDefinitionForm_0);
_.onInit = function onInit_21(){
  $onInit(this);
  $onInit_DynamicForm(this);
  if (!this.formBuilt) {
    $buildForm_1(this);
    $setAlertDefinition_1(this, this.alertDefinition);
    $makeViewOnly_0(this);
  }
}
;
_.alertDefinition = null;
_.consecutiveOccurrencesSpinner = null;
_.consecutiveOccurrencesStatic = null;
_.dampeningRuleSelection = null;
_.dampeningRuleStatic = null;
_.durationOccurrencesSpinner = null;
_.durationOccurrencesStatic = null;
_.durationTimePeriodSpinner = null;
_.durationTimePeriodStatic = null;
_.durationTimeUnitsSelection = null;
_.durationTimeUnitsStatic = null;
_.formBuilt = false;
_.partialEvaluationsSpinner = null;
_.partialEvaluationsStatic = null;
_.partialOccurrencesSpinner = null;
_.partialOccurrencesStatic = null;
_.updated = false;
function $onItemHover(this$static){
  var selection;
  selection = toString__devirtual$($getValue_0(this$static.this$0.dampeningRuleSelection));
  $setPrompt_1(this$static.this$0.dampeningRuleSelection, $getCategoryHelp(selection));
}

function DampeningAlertDefinitionForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1945, 1, makeCastMap([Q$EventHandler, Q$ItemHoverHandler]), DampeningAlertDefinitionForm$1_0);
_.this$0 = null;
function DampeningAlertDefinitionForm$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1946, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DampeningAlertDefinitionForm$2_0);
_.onChanged = function onChanged_6(event_0){
  this.this$0.updated = true;
}
;
_.this$0 = null;
function DampeningAlertDefinitionForm$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1947, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DampeningAlertDefinitionForm$3_0);
_.onChanged = function onChanged_7(event_0){
  this.this$0.updated = true;
}
;
_.this$0 = null;
function DampeningAlertDefinitionForm$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1948, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DampeningAlertDefinitionForm$4_0);
_.onChanged = function onChanged_8(event_0){
  this.this$0.updated = true;
}
;
_.this$0 = null;
function DampeningAlertDefinitionForm$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1949, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DampeningAlertDefinitionForm$5_0);
_.onChanged = function onChanged_9(event_0){
  this.this$0.updated = true;
}
;
_.this$0 = null;
function DampeningAlertDefinitionForm$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1950, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DampeningAlertDefinitionForm$6_0);
_.onChanged = function onChanged_10(event_0){
  this.this$0.updated = true;
}
;
_.this$0 = null;
function DampeningAlertDefinitionForm$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1951, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DampeningAlertDefinitionForm$7_0);
_.onChanged = function onChanged_11(event_0){
  this.this$0.updated = true;
}
;
_.this$0 = null;
function DampeningAlertDefinitionForm$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1952, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DampeningAlertDefinitionForm$8_0);
_.onChanged = function onChanged_12(event_0){
  var cat;
  this.this$0.updated = true;
  cat = valueOf_52(toString__devirtual$($getValue_2(event_0)));
  switch (cat.ordinal) {
    case 0:
      {
        $hide_0(this.this$0.consecutiveOccurrencesSpinner);
        $hide_0(this.this$0.partialOccurrencesSpinner);
        $hide_0(this.this$0.partialEvaluationsSpinner);
        $hide_0(this.this$0.durationOccurrencesSpinner);
        $hide_0(this.this$0.durationTimePeriodSpinner);
        $hide_0(this.this$0.durationTimeUnitsSelection);
        break;
      }

    case 1:
      {
        $show_0(this.this$0.consecutiveOccurrencesSpinner);
        $hide_0(this.this$0.partialOccurrencesSpinner);
        $hide_0(this.this$0.partialEvaluationsSpinner);
        $hide_0(this.this$0.durationOccurrencesSpinner);
        $hide_0(this.this$0.durationTimePeriodSpinner);
        $hide_0(this.this$0.durationTimeUnitsSelection);
        break;
      }

    case 2:
      {
        $hide_0(this.this$0.consecutiveOccurrencesSpinner);
        $show_0(this.this$0.partialOccurrencesSpinner);
        $show_0(this.this$0.partialEvaluationsSpinner);
        $hide_0(this.this$0.durationOccurrencesSpinner);
        $hide_0(this.this$0.durationTimePeriodSpinner);
        $hide_0(this.this$0.durationTimeUnitsSelection);
        break;
      }

    case 4:
      {
        $hide_0(this.this$0.consecutiveOccurrencesSpinner);
        $hide_0(this.this$0.partialOccurrencesSpinner);
        $hide_0(this.this$0.partialEvaluationsSpinner);
        $show_0(this.this$0.durationOccurrencesSpinner);
        $show_0(this.this$0.durationTimePeriodSpinner);
        $show_0(this.this$0.durationTimeUnitsSelection);
        break;
      }

    default:{
        throw new IllegalStateException_1('Invalid dampening category - please report this as a bug: ' + cat.name_0);
      }

  }
  $markForRedraw(this.this$0);
}
;
_.this$0 = null;
function $buildForm_2(this$static){
  var enabledYesNo, notEmptyValidator, priorities, priorityIcons, readOnlyYesNo;
  if (!this$static.formBuilt) {
    this$static.nameField = new SimpleEditableFormItem_0('name', 'Name');
    $setWidth_1(this$static.nameField, 300);
    notEmptyValidator = new StringLengthValidator_0(valueOf_44(1), ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setValidators_0(this$static.nameField, initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [notEmptyValidator]));
    this$static.descriptionField = new SimpleEditableTextAreaFormItem_0;
    $setWidth_1(this$static.descriptionField, 300);
    $setDefaultValue_1(this$static.descriptionField, '');
    this$static.prioritySelection = new SelectItem_2('priority', 'Priority');
    priorities = new LinkedHashMap_1(3);
    $put_1(priorities, ($clinit_AlertPriority() , HIGH).name_0, 'High');
    $put_1(priorities, MEDIUM.name_0, 'Medium');
    $put_1(priorities, LOW.name_0, 'Low');
    priorityIcons = new LinkedHashMap_1(3);
    $put_1(priorityIcons, HIGH.name_0, 'subsystems/alert/Alert_' + HIGH.name_0 + '_16.png');
    $put_1(priorityIcons, MEDIUM.name_0, 'subsystems/alert/Alert_' + MEDIUM.name_0 + '_16.png');
    $put_1(priorityIcons, LOW.name_0, 'subsystems/alert/Alert_' + LOW.name_0 + '_16.png');
    this$static.prioritySelection.setValueMap_0(priorities);
    $setValueIcons(this$static.prioritySelection, priorityIcons);
    $setDefaultValue_1(this$static.prioritySelection, MEDIUM.name_0);
    this$static.priorityStatic = new StaticTextItem_2('priorityStatic', 'Priority');
    $setValueIcons(this$static.priorityStatic, priorityIcons);
    this$static.enabledSelection = new RadioGroupItem_2('enabled', 'Enabled');
    enabledYesNo = new LinkedHashMap_1(2);
    $put_1(enabledYesNo, 'yes', 'Yes');
    $put_1(enabledYesNo, 'no', 'No');
    $setValueMap(this$static.enabledSelection, enabledYesNo);
    $setDefaultValue_1(this$static.enabledSelection, 'yes');
    this$static.enabledStatic = new StaticTextItem_2('enabledStatic', 'Enabled');
    this$static.readOnlySelection = new RadioGroupItem_2('readOnly', 'Protected');
    readOnlyYesNo = new LinkedHashMap_1(2);
    $put_1(readOnlyYesNo, 'yes', 'Yes');
    $put_1(readOnlyYesNo, 'no', 'No');
    $setValueMap(this$static.readOnlySelection, readOnlyYesNo);
    $setDefaultValue_1(this$static.readOnlySelection, 'yes');
    $setPrompt_1(this$static.readOnlySelection, 'If true, this definition is protected from being changed by the parent definition. In other words, the parent definition settings will not override this definition.');
    this$static.readOnlyStatic = new StaticTextItem_2('readOnlyStatic', 'Protected');
    $setFields_0(this$static, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.nameField, this$static.descriptionField, this$static.prioritySelection, this$static.priorityStatic, this$static.enabledSelection, this$static.enabledStatic, this$static.readOnlySelection, this$static.readOnlyStatic]));
    this$static.formBuilt = true;
  }
}

function $makeEditable_1(this$static){
  var parentId;
  $switchToEditMode(this$static.nameField);
  $switchToEditMode(this$static.descriptionField);
  $show_0(this$static.prioritySelection);
  $hide_0(this$static.priorityStatic);
  $show_0(this$static.enabledSelection);
  $hide_0(this$static.enabledStatic);
  $show_0(this$static.readOnlySelection);
  $hide_0(this$static.readOnlyStatic);
  if (this$static.alertDefinition) {
    parentId = this$static.alertDefinition.parentId;
    (!parentId || parentId.value_0 == 0) && !this$static.alertDefinition.groupAlertDefinition?$hide_0(this$static.readOnlySelection):$show_0(this$static.readOnlySelection);
  }
   else {
    $hide_0(this$static.readOnlySelection);
  }
  $hide_0(this$static.readOnlyStatic);
  $markForRedraw(this$static);
}

function $makeViewOnly_1(this$static){
  var parentId;
  $switchToStaticMode(this$static.nameField);
  $switchToStaticMode(this$static.descriptionField);
  $hide_0(this$static.prioritySelection);
  $show_0(this$static.priorityStatic);
  $hide_0(this$static.enabledSelection);
  $show_0(this$static.enabledStatic);
  $hide_0(this$static.readOnlySelection);
  $show_0(this$static.readOnlyStatic);
  if (this$static.alertDefinition) {
    parentId = this$static.alertDefinition.parentId;
    (!parentId || parentId.value_0 == 0) && !this$static.alertDefinition.groupAlertDefinition?$hide_0(this$static.readOnlyStatic):$show_0(this$static.readOnlyStatic);
  }
   else {
    $hide_0(this$static.readOnlyStatic);
  }
  $hide_0(this$static.readOnlySelection);
  $markForRedraw(this$static);
}

function $saveAlertDefinition_1(this$static){
  var description, prioritySelected;
  $setName_2(this$static.alertDefinition, toString__devirtual$($getValue_0(this$static.nameField.staticItem)));
  description = $getValue_0(this$static.descriptionField.staticItem);
  null != description && $setDescription(this$static.alertDefinition, toString__devirtual$(description));
  prioritySelected = toString__devirtual$($getValue_0(this$static.prioritySelection));
  $setPriority(this$static.alertDefinition, ($clinit_AlertPriority() , dynamicCast(valueOf(($clinit_AlertPriority$Map() , $MAP_46), prioritySelected), Q$AlertPriority)));
  $setEnabled(this$static.alertDefinition, $equals_6('yes', $getValue_0(this$static.enabledSelection)));
  $setReadOnly(this$static.alertDefinition, $equals_6('yes', $getValue_0(this$static.readOnlySelection)));
}

function $setAlertDefinition_2(this$static, alertDef){
  this$static.alertDefinition = alertDef;
  $buildForm_2(this$static);
  if (!alertDef) {
    $clearValue_0(this$static.nameField);
    $clearValue_0(this$static.descriptionField);
    $clearValue_0(this$static.prioritySelection);
    $clearValue_0(this$static.enabledSelection);
    $clearValue_0(this$static.readOnlySelection);
    $clearValue_0(this$static.priorityStatic);
    $clearValue_0(this$static.enabledStatic);
    $clearValue_0(this$static.readOnlyStatic);
    $markForRedraw(this$static);
  }
   else {
    $setValue_13(this$static.nameField, alertDef.name_0);
    $setValue_13(this$static.descriptionField, alertDef.description);
    $setValue_7(this$static.prioritySelection, alertDef.priority.name_0);
    $setValue_7(this$static.priorityStatic, alertDef.priority.name_0);
    $setValue_7(this$static.enabledSelection, alertDef.enabled?'yes':'no');
    $setValue_7(this$static.enabledStatic, alertDef.enabled?'Yes':'No');
    $setValue_7(this$static.readOnlySelection, alertDef.readOnly?'yes':'no');
    $setValue_7(this$static.readOnlyStatic, alertDef.readOnly?'Yes':'No');
  }
  $markForRedraw(this$static);
}

function $validate_3(this$static){
  return $validate(this$static) && $validate_4(this$static.nameField).value_0;
}

function GeneralPropertiesAlertDefinitionForm_0(){
  DynamicForm_0.call(this);
  $clinit_CoreGUI();
  this.alertDefinition = null;
}

defineSeed(1953, 478, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), GeneralPropertiesAlertDefinitionForm_0);
_.onInit = function onInit_22(){
  $onInit(this);
  $onInit_DynamicForm(this);
  if (!this.formBuilt) {
    $buildForm_2(this);
    $setAlertDefinition_2(this, this.alertDefinition);
    $makeViewOnly_1(this);
  }
}
;
_.validate_0 = function validate_2(){
  return $validate_3(this);
}
;
_.alertDefinition = null;
_.descriptionField = null;
_.enabledSelection = null;
_.enabledStatic = null;
_.formBuilt = false;
_.nameField = null;
_.prioritySelection = null;
_.priorityStatic = null;
_.readOnlySelection = null;
_.readOnlyStatic = null;
function $getFetchCriteria_2(request){
  var criteria, fieldName, key, key$iterator, requestCriteria, resourceId, values;
  criteria = new AlertDefinitionCriteria_0;
  requestCriteria = $getCriteria(request);
  if (requestCriteria) {
    values = convertToMap(requestCriteria.jsObj);
    for (key$iterator = values.keySet_0().iterator(); key$iterator.hasNext();) {
      key = key$iterator.next_0();
      fieldName = dynamicCast(key, Q$String);
      if ($equals_6(fieldName, 'groupId')) {
        resourceId = dynamicCast(values.get_2(fieldName), Q$Integer);
        criteria.filterResourceGroupIds = new Arrays$ArrayList_0(initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [resourceId]));
      }
    }
  }
  return criteria;
}

function GroupAlertDefinitionsDataSource_0(group){
  $clinit_RPCDataSource();
  AbstractAlertDefinitionsDataSource_0.call(this);
  this.resourceGroup = group;
}

defineSeed(1954, 1895, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), GroupAlertDefinitionsDataSource_0);
_.getFetchCriteria = function getFetchCriteria_13(request){
  return $getFetchCriteria_2(request);
}
;
_.getSimpleCriteriaForAll = function getSimpleCriteriaForAll(){
  var criteria;
  criteria = new AlertDefinitionCriteria_0;
  $addFilterResourceGroupIds_1(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.resourceGroup.id)]));
  $setPageControl(criteria, new PageControl_1(0, -1));
  return criteria;
}
;
_.resourceGroup = null;
function GroupAlertDefinitionsView_0(groupComposite){
  var criteria;
  $clinit_BaseWidget();
  var list, metadata, rt;
  AbstractAlertDefinitionsView_0.call(this, ($clinit_Enhanced() , 'Group Alert Definitions'), (criteria = new Criteria_0 , $addCriteria_1(criteria, 'groupId', valueOf_44(groupComposite.resourceGroup.id)) , criteria));
  this.group = groupComposite.resourceGroup;
  this.permissions = groupComposite.resourcePermission;
  rt = this.group.resourceType;
  metadata = noneOf(Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit);
  !rt.eventDefinitions && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , events_0));
  !rt.metricDefinitions && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , measurements_0));
  !rt.operationDefinitions && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , operations_0));
  !rt.resourceConfigurationDefinition && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , resourceConfigurationDefinition_0));
  if (metadata.size_0 != 0) {
    list = new ArrayList_1(1);
    $add_3(list, this.group);
    $loadResourceTypes_0(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), list, metadata);
  }
}

defineSeed(1955, 1898, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), GroupAlertDefinitionsView_0);
_.commitAlertDefinition = function commitAlertDefinition(alertDefinition, purgeInternals, resultReceiver){
  alertDefinition.id == 0?$createGroupAlertDefinitions(dynamicCast(secure(getInstance_42(), -1), Q$GroupAlertDefinitionGWTServiceAsync), alertDefinition, valueOf_44(this.group.id), new GroupAlertDefinitionsView$4_0(this, alertDefinition, resultReceiver)):$updateGroupAlertDefinitions(dynamicCast(secure(getInstance_42(), -1), Q$GroupAlertDefinitionGWTServiceAsync), alertDefinition, purgeInternals, new GroupAlertDefinitionsView$5_0(this, resultReceiver));
}
;
_.deleteButtonPressed = function deleteButtonPressed(selection){
  var alertDefIds, i, id, record, record$index, record$max;
  if (selection.length == 0) {
    return;
  }
  alertDefIds = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, selection.length, 0);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    id = getAttributeAsInt(record.jsObj, 'id');
    alertDefIds[i++] = id;
  }
  $removeGroupAlertDefinitions(dynamicCast(secure(getInstance_42(), -1), Q$GroupAlertDefinitionGWTServiceAsync), alertDefIds, new GroupAlertDefinitionsView$3_0(this));
}
;
_.disableButtonPressed = function disableButtonPressed(selection){
  var alertDefIds, i, id, record, record$index, record$max;
  if (selection.length == 0) {
    return;
  }
  alertDefIds = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, selection.length, 0);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    id = getAttributeAsInt(record.jsObj, 'id');
    alertDefIds[i++] = id;
  }
  $disableGroupAlertDefinitions(dynamicCast(secure(getInstance_42(), -1), Q$GroupAlertDefinitionGWTServiceAsync), alertDefIds, new GroupAlertDefinitionsView$2_0(this));
}
;
_.enableButtonPressed = function enableButtonPressed(selection){
  var alertDefIds, i, id, record, record$index, record$max;
  if (selection.length == 0) {
    return;
  }
  alertDefIds = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, selection.length, 0);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    id = getAttributeAsInt(record.jsObj, 'id');
    alertDefIds[i++] = id;
  }
  $enableGroupAlertDefinitions(dynamicCast(secure(getInstance_42(), -1), Q$GroupAlertDefinitionGWTServiceAsync), alertDefIds, new GroupAlertDefinitionsView$1_0(this));
}
;
_.getAlertDefinitionDataSource = function getAlertDefinitionDataSource(){
  return new GroupAlertDefinitionsDataSource_0(this.group);
}
;
_.getDetailsView_1 = function getDetailsView_11(id){
  var view;
  view = $getDetailsView(this, id);
  id.value_0 == 0 && $setGroup(view.alertDefinition, this.group);
  return view;
}
;
_.getResourceType = function getResourceType(){
  return this.group.resourceType;
}
;
_.isAuthorizedToModifyAlertDefinitions_0 = function isAuthorizedToModifyAlertDefinitions(){
  return this.permissions.permissions.contains_0(($clinit_Permission() , MANAGE_ALERTS));
}
;
_.newButtonPressed = function newButtonPressed(selection){
  $clinit_CoreGUI();
  goToView(this.basePath + '/0', null, false);
}
;
_.group = null;
_.permissions = null;
function $onSuccess_104(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully enabled ' + ($clinit_Enhanced() , '' + result) + ' alert definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function GroupAlertDefinitionsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1956, 1, {}, GroupAlertDefinitionsView$1_0);
_.onFailure = function onFailure_108(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to enable the selected alert definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_108(result){
  $onSuccess_104(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
function $onSuccess_105(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully disabled ' + ($clinit_Enhanced() , '' + result) + ' alert definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function GroupAlertDefinitionsView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1957, 1, {}, GroupAlertDefinitionsView$2_0);
_.onFailure = function onFailure_109(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to disable the selected alert definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_109(result){
  $onSuccess_105(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
function $onSuccess_106(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully deleted ' + ($clinit_Enhanced() , '' + result) + ' alert definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function GroupAlertDefinitionsView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1958, 1, {}, GroupAlertDefinitionsView$3_0);
_.onFailure = function onFailure_110(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to deleted the selected alert definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_110(result){
  $onSuccess_106(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
function $onSuccess_107(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Alert definition successfully created'), ($clinit_Message$Severity() , Info)));
  $setId(this$static.val$alertDefinition, result.value_0);
  $refresh(this$static.this$0, false);
  $onSuccess_123(this$static.val$resultReceiver, this$static.val$alertDefinition);
}

function GroupAlertDefinitionsView$4_0(this$0, val$alertDefinition, val$resultReceiver){
  this.this$0 = this$0;
  this.val$alertDefinition = val$alertDefinition;
  this.val$resultReceiver = val$resultReceiver;
}

defineSeed(1959, 1, {}, GroupAlertDefinitionsView$4_0);
_.onFailure = function onFailure_111(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition creation failed'), caught);
}
;
_.onSuccess_0 = function onSuccess_111(result){
  $onSuccess_107(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
_.val$alertDefinition = null;
_.val$resultReceiver = null;
function $onSuccess_108(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Alert definition successfully updated'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
  $onSuccess_123(this$static.val$resultReceiver, result);
}

function GroupAlertDefinitionsView$5_0(this$0, val$resultReceiver){
  this.this$0 = this$0;
  this.val$resultReceiver = val$resultReceiver;
}

defineSeed(1960, 1, {}, GroupAlertDefinitionsView$5_0);
_.onFailure = function onFailure_112(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition update failed'), caught);
}
;
_.onSuccess_0 = function onSuccess_112(result){
  $onSuccess_108(this, dynamicCast(result, Q$AlertDefinition));
}
;
_.this$0 = null;
_.val$resultReceiver = null;
function $createNotificationSenderForm(this$static, sender){
  var newCanvas, res, rt;
  if ($equals_6('System Users', sender)) {
    newCanvas = new SystemUsersNotificationSenderForm_0(this$static.notificationToEdit, sender);
  }
   else if ($equals_6('System Roles', sender)) {
    newCanvas = new SystemRolesNotificationSenderForm_0(this$static.notificationToEdit, sender);
  }
   else if ($equals_6('Resource Operations', sender)) {
    res = null;
    if (this$static.alertDefinition.resourceType) {
      rt = this$static.alertDefinition.resourceType;
    }
     else if (this$static.alertDefinition.group) {
      rt = this$static.alertDefinition.group.resourceType;
    }
     else {
      res = this$static.alertDefinition.resource;
      rt = res.resourceType;
    }
    newCanvas = new ResourceOperationNotificationSenderForm_0(this$static.notificationToEdit, sender, rt, res);
  }
   else 
    $equals_6('CLI Script', sender)?(newCanvas = new CliNotificationSenderForm_0(this$static.notificationToEdit, sender)):(newCanvas = new SimpleNotificationSenderForm_0(this$static.notificationToEdit, sender));
  return newCanvas;
}

function $saveNewNotification(this$static){
  var notif, selectedSender, senderForm;
  if (!this$static.notificationToEdit) {
    selectedSender = toString__devirtual$($getValue_0(this$static.notificationSenderSelectItem));
    notif = new AlertNotification_1(selectedSender);
    $setAlertDefinition(notif, this$static.alertDefinition);
    $add_3(this$static.notifications, notif);
  }
   else {
    notif = this$static.notificationToEdit;
  }
  senderForm = dynamicCast(this$static.senderCanvasItem.getCanvas(), Q$AbstractNotificationSenderForm);
  $setConfiguration(notif, senderForm.configuration);
  $setExtraConfiguration(notif, senderForm.extraConfiguration);
}

function $switchToAlertSender(this$static, newAlertSender){
  var newCanvas, senderLayout;
  newCanvas = $createNotificationSenderForm(this$static, newAlertSender);
  if (this$static.senderCanvasInitialized) {
    senderLayout = dynamicCast(this$static.senderCanvasItem.getCanvas(), Q$Layout);
    destroyMembers(senderLayout);
    senderLayout.destroy_0();
  }
  this$static.senderCanvasInitialized = true;
  $setCanvas(this$static.senderCanvasItem, newCanvas);
  $markForRedraw(this$static);
}

function NewNotificationEditor_0(alertDefinition, notifs, notifToEdit, closeFunc){
  DynamicForm_0.call(this);
  $clinit_CoreGUI();
  this.alertDefinition = alertDefinition;
  this.notifications = notifs;
  this.notificationToEdit = notifToEdit;
  this.closeFunction = closeFunc;
}

defineSeed(1961, 478, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), NewNotificationEditor_0);
_.onInit = function onInit_23(){
  var cancel, formItems, ok, senderName, senders, spacer1, spacer2;
  $onInit(this);
  $onInit_DynamicForm(this);
  $setMargin(this, valueOf_44(20));
  this.senderCanvasItem = new CanvasItem_0;
  this.senderCanvasItem.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setColSpan(this.senderCanvasItem, 2);
  this.notificationSenderSelectItem = new SortedSelectItem_2('notificationSender', 'Notification Sender');
  $setDefaultToFirstOption_0(this.notificationSenderSelectItem, TRUE);
  $setWrapTitle(this.notificationSenderSelectItem, FALSE);
  $setRedrawOnChange(this.notificationSenderSelectItem);
  $setWidth_2(this.notificationSenderSelectItem, '*');
  if (this.notificationToEdit) {
    $setDisabled_2(this.notificationSenderSelectItem, TRUE);
    senderName = this.notificationToEdit.senderName;
    senders = new LinkedHashMap_1(1);
    $put_1(senders, senderName, senderName);
    $setValueMap_1(this.notificationSenderSelectItem, senders);
    $switchToAlertSender(this, senderName);
    $setVisible(this.senderCanvasItem, TRUE);
  }
   else {
    $setValueMap_2(this.notificationSenderSelectItem, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['Loading...']));
    $setDisabled_2(this.notificationSenderSelectItem, TRUE);
    $setVisible(this.senderCanvasItem, FALSE);
    $getAllAlertSenders(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), new NewNotificationEditor$1_0(this));
  }
  $addChangedHandler(this.notificationSenderSelectItem, new NewNotificationEditor$2_0(this));
  spacer1 = new SpacerItem_0;
  spacer1.setColSpan(2);
  $isCreated_2(spacer1)?$setProperty_6(spacer1, 'height', 5):(spacer1.jsObj['height'] = 5 , undefined);
  spacer2 = new SpacerItem_0;
  spacer2.setColSpan(2);
  $isCreated_2(spacer2)?$setProperty_6(spacer2, 'height', 5):(spacer2.jsObj['height'] = 5 , undefined);
  ok = new ButtonItem_1('okButtonItem', 'OK');
  $setEndRow_1(ok, FALSE);
  $setAttribute_30(ok, 'align', ($clinit_Alignment() , RIGHT_0).value_0);
  $addClickHandler_1(ok, new NewNotificationEditor$3_0(this));
  cancel = new ButtonItem_1('cancelButtonItem', 'Cancel');
  $setStartRow_1(cancel, FALSE);
  $setAttribute_30(cancel, 'align', LEFT_0.value_0);
  $addClickHandler_1(cancel, new NewNotificationEditor$4_0(this));
  formItems = new ArrayList_0;
  $add_3(formItems, this.notificationSenderSelectItem);
  setCheck(formItems.array, formItems.size_0++, spacer1);
  $add_3(formItems, this.senderCanvasItem);
  setCheck(formItems.array, formItems.size_0++, spacer2);
  setCheck(formItems.array, formItems.size_0++, ok);
  setCheck(formItems.array, formItems.size_0++, cancel);
  $setFields_0(this, dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, formItems.size_0, 0)), Q$FormItem_$1));
}
;
_.alertDefinition = null;
_.closeFunction = null;
_.notificationSenderSelectItem = null;
_.notificationToEdit = null;
_.notifications = null;
_.senderCanvasInitialized = false;
_.senderCanvasItem = null;
function $onSuccess_109(this$static, result){
  var senderName, senderName$index, senderName$max, senders;
  if (result != null && result.length > 0) {
    senders = new LinkedHashMap_1(result.length);
    for (senderName$index = 0 , senderName$max = result.length; senderName$index < senderName$max; ++senderName$index) {
      senderName = result[senderName$index];
      $put_1(senders, senderName, senderName);
    }
    $setValueMap_1(this$static.this$0.notificationSenderSelectItem, senders);
    $setDisabled_2(this$static.this$0.notificationSenderSelectItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $redraw_0(this$static.this$0.notificationSenderSelectItem);
    $setValue_7(this$static.this$0.notificationSenderSelectItem, result[0]);
    $switchToAlertSender(this$static.this$0, result[0]);
    $show_0(this$static.this$0.senderCanvasItem);
  }
   else {
    $handleError_0(($clinit_CoreGUI() , 'No alert senders available'), null);
  }
}

function NewNotificationEditor$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1962, 1, {}, NewNotificationEditor$1_0);
_.onFailure = function onFailure_113(caught){
  $handleError_0(($clinit_CoreGUI() , 'Cannot get alert senders'), caught);
}
;
_.onSuccess_0 = function onSuccess_113(result){
  $onSuccess_109(this, dynamicCast(result, Q$String_$1));
}
;
_.this$0 = null;
function NewNotificationEditor$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1963, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), NewNotificationEditor$2_0);
_.onChanged = function onChanged_13(event_0){
  var newAlertSender;
  newAlertSender = toString__devirtual$($getValue_2(event_0));
  $switchToAlertSender(this.this$0, newAlertSender);
}
;
_.this$0 = null;
function NewNotificationEditor$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1964, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), NewNotificationEditor$3_0);
_.onClick_0 = function onClick_31(event_0){
  var senderForm;
  if ($validate_0(this.this$0, false).value_0) {
    senderForm = dynamicCast(this.this$0.senderCanvasItem.getCanvas(), Q$AbstractNotificationSenderForm);
    senderForm.validate_2(new NewNotificationEditor$3$1_0(this));
  }
}
;
_.this$0 = null;
function $onSuccess_110(this$static){
  $saveNewNotification(this$static.this$1.this$0);
  $run_8(this$static.this$1.this$0.closeFunction);
}

function NewNotificationEditor$3$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1965, 1, {}, NewNotificationEditor$3$1_0);
_.onFailure = function onFailure_114(t){
}
;
_.onSuccess_0 = function onSuccess_114(o){
  $onSuccess_110(this, throwClassCastExceptionUnlessNull(o));
}
;
_.this$1 = null;
function NewNotificationEditor$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1966, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), NewNotificationEditor$4_0);
_.onClick_0 = function onClick_32(event_0){
  $run_8(this.this$0.closeFunction);
}
;
_.this$0 = null;
function $buildForm_3(this$static){
  if (!this$static.formBuilt) {
    this$static.table = new NotificationsAlertDefinitionForm$NotificationTable_0(this$static);
    $addMember(this$static, this$static.table);
    this$static.formBuilt = true;
  }
}

function $extractShallowCopyOfNotifications(this$static, alertDefinition){
  var notifs;
  notifs = null;
  !!alertDefinition && (notifs = alertDefinition.alertNotifications);
  notifs?(this$static.notifications = new ArrayList_2(notifs)):(this$static.notifications = new ArrayList_0);
}

function $makeEditable_2(this$static){
  $setTableActionDisableOverride(this$static.table, false);
  $markForRedraw(this$static);
}

function $makeViewOnly_2(this$static){
  $setTableActionDisableOverride(this$static.table, true);
  $markForRedraw(this$static);
}

function $saveAlertDefinition_2(this$static){
  var notif, notif$iterator;
  if (!!this$static.notifications && this$static.notifications.size_0 > 0) {
    for (notif$iterator = new AbstractList$IteratorImpl_0(this$static.notifications); notif$iterator.i < notif$iterator.this$0_0.size_1();) {
      notif = dynamicCast($next_0(notif$iterator), Q$AlertNotification);
      $setAlertDefinition(notif, this$static.alertDefinition);
    }
  }
  $setAlertNotifications(this$static.alertDefinition, this$static.notifications);
  $extractShallowCopyOfNotifications(this$static, this$static.alertDefinition);
}

function $setAlertDefinition_3(this$static, alertDef){
  this$static.alertDefinition = alertDef;
  $buildForm_3(this$static);
  if (!alertDef) {
    $clear_2(this$static.notifications);
    !!this$static.table && $refresh(this$static.table, false);
    $markForRedraw(this$static);
  }
   else {
    $extractShallowCopyOfNotifications(this$static, this$static.alertDefinition);
    !!this$static.table && $refresh(this$static.table, false);
  }
  $markForRedraw(this$static);
}

function NotificationsAlertDefinitionForm_0(){
  EnhancedVLayout_0.call(this);
  this.alertDefinition = null;
  $extractShallowCopyOfNotifications(this, this.alertDefinition);
}

defineSeed(1967, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), NotificationsAlertDefinitionForm_0);
_.onInit = function onInit_24(){
  $onInit(this);
  $onInit_Layout(this);
  if (!this.formBuilt) {
    $buildForm_3(this);
    $setAlertDefinition_3(this, this.alertDefinition);
    $setTableActionDisableOverride(this.table, true);
    $markForRedraw(this);
  }
}
;
_.alertDefinition = null;
_.formBuilt = false;
_.notifications = null;
_.table = null;
function $copyValues_21(from){
  var record;
  record = new ListGridRecord_0;
  !from?(record.jsObj['obj'] = null , undefined):(record.jsObj['obj'] = from , undefined);
  $setAttribute_13(record, 'sender', from.senderName);
  record.jsObj['configuration'] = '(Unknown)';
  return record;
}

function $executeFetch_11(this$static, request, response){
  var notifs, records;
  records = $buildRecords(this$static, this$static.this$0.notifications, true);
  notifs = dynamicCast($toArray_1(this$static.this$0.notifications, initDim(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$AlertNotification_$1]), Q$AlertNotification, this$static.this$0.notifications.size_0, 0)), Q$AlertNotification_$1);
  $getAlertNotificationConfigurationPreview(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), notifs, new NotificationsAlertDefinitionForm$NotificationDataSource$1_0(this$static, records, response, request));
}

function NotificationsAlertDefinitionForm$NotificationDataSource_0(this$0){
  var fields_0, senderField, configField;
  $clinit_RPCDataSource();
  var fields;
  this.this$0 = this$0;
  RPCDataSource_0.call(this);
  fields = (fields_0 = new ArrayList_0 , senderField = new DataSourceTextField_1('sender', 'Sender') , setCheck(fields_0.array, fields_0.size_0++, senderField) , configField = new DataSourceTextField_1('configuration', 'Configuration') , setCheck(fields_0.array, fields_0.size_0++, configField) , fields_0);
  $addFields(this, fields);
}

defineSeed(1968, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$NotificationsAlertDefinitionForm$NotificationDataSource]), NotificationsAlertDefinitionForm$NotificationDataSource_0);
_.copyValues = function copyValues_31(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'obj'), Q$AlertNotification);
}
;
_.copyValues_0 = function copyValues_32(from){
  return $copyValues_21(dynamicCast(from, Q$AlertNotification));
}
;
_.executeFetch = function executeFetch_17(request, response, unused){
  $executeFetch_11(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_14(request){
  return null;
}
;
_.this$0 = null;
function $onFailure_12(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to get notification configuration preview'), caught);
  $setAttribute_17(this$static.val$response, 'data', this$static.val$records);
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_111(this$static, result){
  var i, record, record$array, record$index, record$max;
  i = 0;
  for (record$array = this$static.val$records , record$index = 0 , record$max = record$array.length; record$index < record$max; ++record$index) {
    record = record$array[record$index];
    $setAttribute_13(record, 'configuration', result[i++]);
  }
  $setAttribute_17(this$static.val$response, 'data', this$static.val$records);
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function NotificationsAlertDefinitionForm$NotificationDataSource$1_0(this$1, val$records, val$response, val$request){
  this.this$1 = this$1;
  this.val$records = val$records;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(1969, 1, {}, NotificationsAlertDefinitionForm$NotificationDataSource$1_0);
_.onFailure = function onFailure_115(caught){
  $onFailure_12(this, caught);
}
;
_.onSuccess_0 = function onSuccess_115(result){
  $onSuccess_111(this, dynamicCast(result, Q$String_$1));
}
;
_.this$1 = null;
_.val$records = null;
_.val$request = null;
_.val$response = null;
function $popupNotificationEditor(this$static, notifToEdit){
  var newEditor, winModal;
  winModal = new Window_1;
  !notifToEdit?$setTitle(winModal, ($clinit_Enhanced() , 'Add Notification')):$setTitle(winModal, ($clinit_Enhanced() , 'Edit Notification'));
  $setAttribute_24(winModal, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $setShowMinimizeButton(winModal, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setIsModal(winModal, TRUE);
  $setShowModalMask(winModal, TRUE);
  $setAutoSize(winModal, TRUE);
  $setAutoCenter(winModal, TRUE);
  $centerInPage(winModal);
  $addCloseClickHandler(winModal, new NotificationsAlertDefinitionForm$NotificationTable$4_0(winModal));
  newEditor = new NewNotificationEditor_0(this$static.this$0.alertDefinition, this$static.this$0.notifications, notifToEdit, new NotificationsAlertDefinitionForm$NotificationTable$5_0(this$static, winModal));
  $addItem(winModal, newEditor);
  winModal.show_0();
}

function NotificationsAlertDefinitionForm$NotificationTable_0(this$0){
  var dataSource;
  this.this$0 = this$0;
  Table_1.call(this);
  this.showHeader = false;
  dataSource = new NotificationsAlertDefinitionForm$NotificationDataSource_0(this$0);
  this.dataSource_1 = dataSource;
}

defineSeed(1970, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), NotificationsAlertDefinitionForm$NotificationTable_0);
_.configureTable = function configureTable_16(){
  var configField, senderField;
  senderField = new ListGridField_3('sender', ($clinit_Enhanced() , 'Sender'));
  senderField.jsObj['width'] = '25%';
  configField = new ListGridField_3('configuration', 'Configuration');
  configField.jsObj['width'] = '75%';
  $setFields_1(this.listGrid, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [senderField, configField]));
  $setListGridDoubleClickHandler(this, new NotificationsAlertDefinitionForm$NotificationTable$1_0(this));
  $addTableAction(this, 'Add', null, null, new NotificationsAlertDefinitionForm$NotificationTable$2_0(this));
  $addTableAction(this, 'Delete', 'Are you sure you want to delete the selected alert notifications?', null, new NotificationsAlertDefinitionForm$NotificationTable$3_0(this, ($clinit_TableActionEnablement() , ANY_1)));
}
;
_.this$0 = null;
function NotificationsAlertDefinitionForm$NotificationTable$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1971, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), NotificationsAlertDefinitionForm$NotificationTable$1_0);
_.onDoubleClick = function onDoubleClick(event_0){
  var listGrid, notif, selectedRows, ret;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    notif = dynamicCast((ret = (dynamicCast(this.this$1.dataSource_1, Q$NotificationsAlertDefinitionForm$NotificationDataSource) , selectedRows[0]).jsObj['obj'] , ret === undefined?null:ret), Q$AlertNotification);
    $popupNotificationEditor(this.this$1, notif);
  }
}
;
_.this$1 = null;
function NotificationsAlertDefinitionForm$NotificationTable$2_0(this$1){
  this.this$1 = this$1;
  AbstractTableAction_0.call(this);
}

defineSeed(1972, 1608, {}, NotificationsAlertDefinitionForm$NotificationTable$2_0);
_.executeAction = function executeAction_30(selection, actionValue){
  $popupNotificationEditor(this.this$1, null);
}
;
_.this$1 = null;
function NotificationsAlertDefinitionForm$NotificationTable$3_0(this$1, $anonymous0){
  this.this$1 = this$1;
  this.enablement = $anonymous0;
}

defineSeed(1973, 1608, {}, NotificationsAlertDefinitionForm$NotificationTable$3_0);
_.executeAction = function executeAction_31(selection, actionValue){
  var notif, record, record$index, record$max, ret;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    notif = dynamicCast((ret = (dynamicCast(this.this$1.dataSource_1, Q$NotificationsAlertDefinitionForm$NotificationDataSource) , record).jsObj['obj'] , ret === undefined?null:ret), Q$AlertNotification);
    $remove_4(this.this$1.this$0.notifications, notif);
  }
  $refresh(this.this$1.this$0.table, false);
}
;
_.this$1 = null;
function NotificationsAlertDefinitionForm$NotificationTable$4_0(val$winModal){
  this.val$winModal = val$winModal;
}

defineSeed(1974, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), NotificationsAlertDefinitionForm$NotificationTable$4_0);
_.onCloseClick_0 = function onCloseClick_4(event_0){
  $destroy(this.val$winModal);
}
;
_.val$winModal = null;
function $run_8(this$static){
  $destroy(this$static.val$winModal);
  $refresh(this$static.this$1.this$0.table, false);
}

function NotificationsAlertDefinitionForm$NotificationTable$5_0(this$1, val$winModal){
  this.this$1 = this$1;
  this.val$winModal = val$winModal;
}

defineSeed(1975, 1, {}, NotificationsAlertDefinitionForm$NotificationTable$5_0);
_.this$1 = null;
_.val$winModal = null;
function $buildForm_4(this$static){
  var yesNo;
  if (!this$static.formBuilt) {
    this$static.disableWhenFiredSelection = new RadioGroupItem_2('disableWhenFired', 'Disable When Fired');
    yesNo = new LinkedHashMap_1(2);
    $put_1(yesNo, 'yes', 'Yes');
    $put_1(yesNo, 'no', 'No');
    $setValueMap(this$static.disableWhenFiredSelection, yesNo);
    $setDefaultValue_1(this$static.disableWhenFiredSelection, 'no');
    $setWrapTitle(this$static.disableWhenFiredSelection, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setWidth_1(this$static.disableWhenFiredSelection, 300);
    $setHoverWidth_0(this$static.disableWhenFiredSelection, valueOf_44(300));
    $setPrompt_1(this$static.disableWhenFiredSelection, 'Indicates if this alert will be disabled after it fires. Once disabled, the alert can be manually re-enabled or a recovery alert can be set up to automatically re-enable it. If this alert is a recovery alert itself, this setting cannot be turned on.');
    this$static.disableWhenFiredStatic = new StaticTextItem_2('disableWhenFiredStatic', 'Disable When Fired');
    $setWrapTitle(this$static.disableWhenFiredStatic, FALSE);
    this$static.recoverAlertSelection = new SortedSelectItem_2('recoveryAlert', 'Recover Alert');
    $setDefaultValue_1(this$static.recoverAlertSelection, '0');
    $setWrapTitle(this$static.recoverAlertSelection, FALSE);
    $setHoverWidth_0(this$static.recoverAlertSelection, valueOf_44(300));
    $setPrompt_1(this$static.recoverAlertSelection, 'The target alert that will be recovered (i.e. re-enabled) after this alert triggers. Do not select an alert here if you are not defining a recovery alert.');
    this$static.recoverAlertStatic = new StaticTextItem_2('recoveryAlertStatic', 'Recover Alert');
    $setDefaultValue_1(this$static.recoverAlertStatic, $getNoRecoveryMenuItemTitle());
    $setWrapTitle(this$static.recoverAlertStatic, FALSE);
    $setWidth_1(this$static.recoverAlertStatic, 300);
    $addChangedHandler(this$static.recoverAlertSelection, new RecoveryAlertDefinitionForm$1_0(this$static));
    $refreshWidgets(this$static, null);
    $loadAllAlertDefinitionsAndRefreshRecoverAlertSelection(this$static);
    $setFields_0(this$static, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.recoverAlertSelection, this$static.recoverAlertStatic, this$static.disableWhenFiredSelection, this$static.disableWhenFiredStatic]));
    this$static.formBuilt = true;
  }
}

function $getNoRecoveryMenuItemTitle(){
  var str;
  str = new StringBuilder_0;
  $append_1(str.data_0, '-- ');
  $append_1(str.data_0, 'None');
  $append_1(str.data_0, ' --');
  return $toString_1(str.data_0);
}

function $loadAllAlertDefinitionsAndRefreshRecoverAlertSelection(this$static){
  var criteria;
  if (!this$static.allAlertDefinitions) {
    criteria = this$static.alertDataSource.getSimpleCriteriaForAll();
    $findAlertDefinitionsByCriteria(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), criteria, new RecoveryAlertDefinitionForm$2_0(this$static));
  }
   else {
    $refreshWidgets(this$static, this$static.allAlertDefinitions);
  }
}

function $lookupAlertDefinition(this$static, id){
  var def, def$iterator;
  if (!!id && id.value_0 != 0) {
    if (this$static.allAlertDefinitions) {
      for (def$iterator = new AbstractList$IteratorImpl_0(this$static.allAlertDefinitions); def$iterator.i < def$iterator.this$0_0.size_1();) {
        def = dynamicCast($next_0(def$iterator), Q$AlertDefinition);
        if (def.id == id.value_0) {
          return def;
        }
      }
    }
  }
  return null;
}

function $makeEditable_3(this$static){
  $show_0(this$static.recoverAlertSelection);
  $show_0(this$static.disableWhenFiredSelection);
  $hide_0(this$static.recoverAlertStatic);
  $hide_0(this$static.disableWhenFiredStatic);
  $markForRedraw(this$static);
}

function $makeViewOnly_3(this$static){
  $hide_0(this$static.recoverAlertSelection);
  $hide_0(this$static.disableWhenFiredSelection);
  $show_0(this$static.recoverAlertStatic);
  $show_0(this$static.disableWhenFiredStatic);
  $markForRedraw(this$static);
}

function $refreshDisableWhenFiredSelection(this$static, recoveryAlertDefId){
  if ($equals_6('0', recoveryAlertDefId)) {
    $setDisabled_2(this$static.disableWhenFiredSelection, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  }
   else {
    $setValue_7(this$static.disableWhenFiredSelection, 'no');
    $setDisabled_2(this$static.disableWhenFiredSelection, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  }
  $markForRedraw(this$static);
}

function $refreshWidgets(this$static, allDefs){
  var alertMap, allDefsSize, def, def$iterator, recoveryAlert, recoveryIdStr;
  allDefsSize = allDefs?allDefs.size_0:0;
  alertMap = new LinkedHashMap_1(allDefsSize + 1);
  $put_1(alertMap, '0', $getNoRecoveryMenuItemTitle());
  if (allDefs) {
    for (def$iterator = new AbstractList$IteratorImpl_0(allDefs); def$iterator.i < def$iterator.this$0_0.size_1();) {
      def = dynamicCast($next_0(def$iterator), Q$AlertDefinition);
      (!this$static.alertDefinition || this$static.alertDefinition.id != def.id) && $put_1(alertMap, '' + def.id, def.name_0);
    }
  }
  $setValueMap_1(this$static.recoverAlertSelection, alertMap);
  if (this$static.alertDefinition) {
    recoveryAlert = $lookupAlertDefinition(this$static, this$static.alertDefinition.recoveryId);
    if (recoveryAlert) {
      recoveryIdStr = '' + recoveryAlert.id;
      $setValue_7(this$static.recoverAlertSelection, recoveryIdStr);
      $setValue_7(this$static.recoverAlertStatic, recoveryAlert.name_0);
      $refreshDisableWhenFiredSelection(this$static, recoveryIdStr);
    }
     else {
      $setValue_7(this$static.recoverAlertSelection, '0');
      $setValue_7(this$static.recoverAlertStatic, $getNoRecoveryMenuItemTitle());
      $refreshDisableWhenFiredSelection(this$static, '0');
    }
  }
  $markForRedraw(this$static);
}

function $saveAlertDefinition_3(this$static){
  $setRecoveryId(this$static.alertDefinition, valueOf_44(0));
  $setWillRecover(this$static.alertDefinition, false);
  $setRecoveryId(this$static.alertDefinition, valueOf_44(__parseAndValidateInt(toString__devirtual$($getValue_0(this$static.recoverAlertSelection)))));
  this$static.alertDefinition.recoveryId.value_0 != 0?$setWillRecover(this$static.alertDefinition, false):$setWillRecover(this$static.alertDefinition, $equals_6('yes', $getValue_0(this$static.disableWhenFiredSelection)));
}

function $setAlertDefinition_4(this$static, alertDef){
  this$static.alertDefinition = alertDef;
  $buildForm_4(this$static);
  if (!alertDef) {
    $clearValue_0(this$static.recoverAlertSelection);
    $clearValue_0(this$static.disableWhenFiredSelection);
    $clearValue_0(this$static.recoverAlertStatic);
    $clearValue_0(this$static.disableWhenFiredStatic);
    $markForRedraw(this$static);
  }
   else {
    $refreshWidgets(this$static, this$static.allAlertDefinitions);
    $setValue_7(this$static.disableWhenFiredSelection, alertDef.willRecover?'yes':'no');
    $setValue_7(this$static.disableWhenFiredStatic, alertDef.willRecover?'Yes':'No');
  }
  $markForRedraw(this$static);
}

function RecoveryAlertDefinitionForm_0(dataSource){
  DynamicForm_0.call(this);
  $clinit_CoreGUI();
  this.alertDataSource = dataSource;
  this.alertDefinition = null;
}

defineSeed(1976, 478, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), RecoveryAlertDefinitionForm_0);
_.onInit = function onInit_25(){
  $onInit(this);
  $onInit_DynamicForm(this);
  if (!this.formBuilt) {
    $setAlertDefinition_4(this, this.alertDefinition);
    $makeViewOnly_3(this);
  }
}
;
_.alertDataSource = null;
_.alertDefinition = null;
_.allAlertDefinitions = null;
_.disableWhenFiredSelection = null;
_.disableWhenFiredStatic = null;
_.formBuilt = false;
_.recoverAlertSelection = null;
_.recoverAlertStatic = null;
function RecoveryAlertDefinitionForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1977, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), RecoveryAlertDefinitionForm$1_0);
_.onChanged = function onChanged_14(event_0){
  var recoveryAlertDefId;
  recoveryAlertDefId = toString__devirtual$($getItem_0(event_0).getValue_1());
  $refreshDisableWhenFiredSelection(this.this$0, recoveryAlertDefId);
}
;
_.this$0 = null;
function $onSuccess_112(this$static, result){
  this$static.this$0.allAlertDefinitions = result;
  $refreshWidgets(this$static.this$0, this$static.this$0.allAlertDefinitions);
}

function RecoveryAlertDefinitionForm$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1978, 1, {}, RecoveryAlertDefinitionForm$2_0);
_.onFailure = function onFailure_116(caught){
  $handleError_0(($clinit_CoreGUI() , 'Cannot build recovery menu'), caught);
}
;
_.onSuccess_0 = function onSuccess_116(result){
  $onSuccess_112(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $getFetchCriteria_3(request){
  var criteria, fieldName, key, key$iterator, requestCriteria, resourceId, values;
  criteria = new AlertDefinitionCriteria_0;
  criteria.fetchGroupAlertDefinition = true;
  criteria.fetchConditions = true;
  criteria.fetchAlertNotifications = true;
  requestCriteria = $getCriteria(request);
  if (requestCriteria) {
    values = convertToMap(requestCriteria.jsObj);
    for (key$iterator = values.keySet_0().iterator(); key$iterator.hasNext();) {
      key = key$iterator.next_0();
      fieldName = dynamicCast(key, Q$String);
      if ($equals_6(fieldName, 'resourceId')) {
        resourceId = dynamicCast(values.get_2(fieldName), Q$Integer);
        criteria.filterResourceIds = new Arrays$ArrayList_0(initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [resourceId]));
      }
    }
  }
  return criteria;
}

function ResourceAlertDefinitionsDataSource_0(resource){
  $clinit_RPCDataSource();
  AbstractAlertDefinitionsDataSource_0.call(this);
  this.resource = resource;
}

defineSeed(1979, 1895, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceAlertDefinitionsDataSource_0);
_.addDataSourceFields = function addDataSourceFields_0(){
  var fields, parentIdField, readOnlyField;
  fields = $addDataSourceFields_0();
  parentIdField = new DataSourceLinkField_1;
  setCheck(fields.array, fields.size_0++, parentIdField);
  readOnlyField = new DataSourceTextField_1('readOnly', 'Protected');
  setCheck(fields.array, fields.size_0++, readOnlyField);
  return fields;
}
;
_.copyValues_2 = function copyValues_33(from){
  var groupAlertDefinition, isAutogroup, parentId, readOnly, record;
  record = $copyValues_19(from);
  parentId = from.parentId;
  groupAlertDefinition = from.groupAlertDefinition;
  readOnly = from.readOnly;
  if ((!parentId || parentId.value_0 == 0) && !groupAlertDefinition) {
    record.jsObj['parent'] = '';
    record.jsObj['linkText'] = '';
    record.jsObj['readOnly'] = 'N/A';
  }
   else {
    if (!!parentId && parentId.value_0 != 0) {
      $setAttribute_13(record, 'parent', '#Administration/Configuration/' + ($clinit_AlertDefinitionTemplateTypeView() , VIEW_ID_6).name_0 + '/' + this.resource.resourceType.id + '/' + parentId);
      record.jsObj['linkText'] = 'View Template';
    }
     else {
      isAutogroup = !!groupAlertDefinition.group.autoGroupParentResource;
      $setAttribute_13(record, 'parent', (isAutogroup?'#Resource/AutoGroup/':'#ResourceGroup/') + groupAlertDefinition.group.id + '/Alerts/Definitions/' + groupAlertDefinition.id);
      record.jsObj['linkText'] = 'View Group Definition';
    }
    record.jsObj['readOnly'] = readOnly?'Yes':'No';
  }
  return record;
}
;
_.getFetchCriteria = function getFetchCriteria_15(request){
  return $getFetchCriteria_3(request);
}
;
_.getListGridFields_0 = function getListGridFields_3(){
  var fields, parentIdField, readOnlyField;
  fields = $getListGridFields_6();
  parentIdField = new ListGridField_3('parent', 'Parent');
  $setAttribute_13(parentIdField, 'type', ($clinit_ListGridFieldType() , LINK_0).value_0);
  parentIdField.jsObj['target'] = '_self';
  parentIdField.jsObj['width'] = 100;
  setCheck(fields.array, fields.size_0++, parentIdField);
  readOnlyField = new ListGridField_3('readOnly', 'Protected');
  readOnlyField.jsObj['width'] = 60;
  $setAttribute_13(readOnlyField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  setCheck(fields.array, fields.size_0++, readOnlyField);
  return fields;
}
;
_.getSimpleCriteriaForAll = function getSimpleCriteriaForAll_0(){
  var criteria;
  criteria = new AlertDefinitionCriteria_0;
  $addFilterResourceIds_0(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.resource.id)]));
  $setPageControl(criteria, new PageControl_1(0, -1));
  return criteria;
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_2(columnName){
  if ($equals_6('resourceAncestry', columnName)) {
    return 'resource.ancestry';
  }
  if ($equals_6('parent', columnName)) {
    return 'parentId';
  }
  return columnName;
}
;
_.resource = null;
function ResourceAlertDefinitionsView_0(resourceComposite){
  var criteria;
  $clinit_BaseWidget();
  var list, metadata, rt;
  AbstractAlertDefinitionsView_0.call(this, 'Alert Definitions', (criteria = new Criteria_0 , $addCriteria_1(criteria, 'resourceId', valueOf_44(resourceComposite.resource.id)) , criteria));
  this.resource = resourceComposite.resource;
  this.permissions = resourceComposite.resourcePermission;
  rt = this.resource.resourceType;
  metadata = noneOf(Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit);
  !rt.eventDefinitions && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , events_0));
  !rt.metricDefinitions && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , measurements_0));
  !rt.operationDefinitions && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , operations_0));
  !rt.resourceConfigurationDefinition && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , resourceConfigurationDefinition_0));
  if (metadata.size_0 != 0) {
    list = new ArrayList_1(1);
    $add_3(list, this.resource);
    $loadResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), list, metadata, null);
  }
}

defineSeed(1980, 1898, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ResourceAlertDefinitionsView_0);
_.commitAlertDefinition = function commitAlertDefinition_0(alertDefinition, purgeInternals, resultReceiver){
  alertDefinition.id == 0?$createAlertDefinition(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), alertDefinition, valueOf_44(this.resource.id), new ResourceAlertDefinitionsView$4_0(this, alertDefinition, resultReceiver)):$updateAlertDefinition(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), alertDefinition.id, alertDefinition, purgeInternals, new ResourceAlertDefinitionsView$5_0(this, resultReceiver));
}
;
_.deleteButtonPressed = function deleteButtonPressed_0(selection){
  var alertDefIds, i, id, record, record$index, record$max;
  if (selection.length == 0) {
    return;
  }
  alertDefIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selection.length, 1);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    id = getAttributeAsInt(record.jsObj, 'id');
    alertDefIds[i++] = id.value_0;
  }
  $removeAlertDefinitions(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), alertDefIds, new ResourceAlertDefinitionsView$3_0(this));
}
;
_.disableButtonPressed = function disableButtonPressed_0(selection){
  var alertDefIds, i, id, record, record$index, record$max;
  if (selection.length == 0) {
    return;
  }
  alertDefIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selection.length, 1);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    id = getAttributeAsInt(record.jsObj, 'id');
    alertDefIds[i++] = id.value_0;
  }
  $disableAlertDefinitions(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), alertDefIds, new ResourceAlertDefinitionsView$2_0(this));
}
;
_.enableButtonPressed = function enableButtonPressed_0(selection){
  var alertDefIds, i, id, record, record$index, record$max;
  if (selection.length == 0) {
    return;
  }
  alertDefIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selection.length, 1);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    id = getAttributeAsInt(record.jsObj, 'id');
    alertDefIds[i++] = id.value_0;
  }
  $enableAlertDefinitions(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), alertDefIds, new ResourceAlertDefinitionsView$1_0(this));
}
;
_.getAlertDefinitionDataSource = function getAlertDefinitionDataSource_0(){
  return new ResourceAlertDefinitionsDataSource_0(this.resource);
}
;
_.getDetailsView_1 = function getDetailsView_12(id){
  var view;
  view = $getDetailsView(this, id);
  id.value_0 == 0 && $setResource(view.alertDefinition, this.resource);
  return view;
}
;
_.getResourceType = function getResourceType_0(){
  return this.resource.resourceType;
}
;
_.isAuthorizedToModifyAlertDefinitions_0 = function isAuthorizedToModifyAlertDefinitions_0(){
  return this.permissions.permissions.contains_0(($clinit_Permission() , MANAGE_ALERTS));
}
;
_.newButtonPressed = function newButtonPressed_0(selection){
  $clinit_CoreGUI();
  goToView(this.basePath + '/0', null, false);
}
;
_.permissions = null;
_.resource = null;
function $onSuccess_113(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully enabled ' + ($clinit_Enhanced() , '' + result) + ' alert definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceAlertDefinitionsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1981, 1, {}, ResourceAlertDefinitionsView$1_0);
_.onFailure = function onFailure_117(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to enable the selected alert definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_117(result){
  $onSuccess_113(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
function $onSuccess_114(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully disabled ' + ($clinit_Enhanced() , '' + result) + ' alert definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceAlertDefinitionsView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1982, 1, {}, ResourceAlertDefinitionsView$2_0);
_.onFailure = function onFailure_118(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to disable the selected alert definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_118(result){
  $onSuccess_114(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
function $onSuccess_115(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully deleted ' + ($clinit_Enhanced() , '' + result) + ' alert definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceAlertDefinitionsView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1983, 1, {}, ResourceAlertDefinitionsView$3_0);
_.onFailure = function onFailure_119(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to deleted the selected alert definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_119(result){
  $onSuccess_115(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
function $onSuccess_116(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Alert definition successfully created'), ($clinit_Message$Severity() , Info)));
  $setId(this$static.val$alertDefinition, result.value_0);
  $refresh(this$static.this$0, false);
  $onSuccess_123(this$static.val$resultReceiver, this$static.val$alertDefinition);
}

function ResourceAlertDefinitionsView$4_0(this$0, val$alertDefinition, val$resultReceiver){
  this.this$0 = this$0;
  this.val$alertDefinition = val$alertDefinition;
  this.val$resultReceiver = val$resultReceiver;
}

defineSeed(1984, 1, {}, ResourceAlertDefinitionsView$4_0);
_.onFailure = function onFailure_120(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition creation failed'), caught);
}
;
_.onSuccess_0 = function onSuccess_120(result){
  $onSuccess_116(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
_.val$alertDefinition = null;
_.val$resultReceiver = null;
function $onSuccess_117(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Alert definition successfully updated'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
  $onSuccess_123(this$static.val$resultReceiver, result);
}

function ResourceAlertDefinitionsView$5_0(this$0, val$resultReceiver){
  this.this$0 = this$0;
  this.val$resultReceiver = val$resultReceiver;
}

defineSeed(1985, 1, {}, ResourceAlertDefinitionsView$5_0);
_.onFailure = function onFailure_121(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition update failed'), caught);
}
;
_.onSuccess_0 = function onSuccess_121(result){
  $onSuccess_117(this, dynamicCast(result, Q$AlertDefinition));
}
;
_.this$0 = null;
_.val$resultReceiver = null;
function $clinit_ResourceOperationNotificationInfo(){
  $clinit_ResourceOperationNotificationInfo = nullMethod;
  $clinit_CoreGUI();
}

function $getInteger(data){
  if (data == null || $equals_6(data, '') || $equals_6(data, 'none')) {
    return null;
  }
  return valueOf_44(__parseAndValidateInt(data));
}

function ResourceOperationNotificationInfo_0(mode, resourceId, ancestorTypeId, descendantTypeId, descendantName, operationId, opArgs){
  var $e0, selectionMode;
  selectionMode = null;
  try {
    mode != null && (selectionMode = ($clinit_ResourceOperationNotificationInfo$ResourceSelectionMode() , dynamicCast(valueOf(($clinit_ResourceOperationNotificationInfo$ResourceSelectionMode$Map() , $MAP_124), mode), Q$ResourceOperationNotificationInfo$ResourceSelectionMode)));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (!instanceOf($e0, Q$Throwable))
      throw $e0;
  }
  this.mode = selectionMode;
  this.resourceId = $getInteger(resourceId);
  this.ancestorTypeId = $getInteger(ancestorTypeId);
  this.descendantTypeId = $getInteger(descendantTypeId);
  this.descendantName = descendantName;
  this.operationId = $getInteger(operationId);
  this.operationArguments = opArgs;
}

function get_20(configuration, operationInfoConstants, defaultValue){
  return $getSimpleValue(configuration, operationInfoConstants.propertyName, defaultValue);
}

function load(configuration, extraConfiguration){
  $clinit_ResourceOperationNotificationInfo();
  var ancestorTypeId, descendantName, descendantTypeId, mode, operationId, resourceId;
  mode = get_20(configuration, ($clinit_ResourceOperationNotificationInfo$Constants() , SELECTION_MODE), ($clinit_ResourceOperationNotificationInfo$ResourceSelectionMode() , SELF).name_0);
  resourceId = get_20(configuration, SPECIFIC_RESOURCE_ID, null);
  ancestorTypeId = get_20(configuration, RELATIVE_ANCESTOR_TYPE_ID, null);
  descendantTypeId = get_20(configuration, RELATIVE_DESCENDANT_TYPE_ID, null);
  descendantName = get_20(configuration, RELATIVE_DESCENDANT_NAME, null);
  operationId = get_20(configuration, OPERATION_ID, null);
  return new ResourceOperationNotificationInfo_0(mode, resourceId, ancestorTypeId, descendantTypeId, descendantName, operationId, extraConfiguration);
}

defineSeed(1986, 1, {}, ResourceOperationNotificationInfo_0);
_.ancestorTypeId = null;
_.descendantName = null;
_.descendantTypeId = null;
_.mode = null;
_.operationArguments = null;
_.operationId = null;
_.resourceId = null;
function $clinit_ResourceOperationNotificationInfo$Constants(){
  $clinit_ResourceOperationNotificationInfo$Constants = nullMethod;
  SELECTION_MODE = new ResourceOperationNotificationInfo$Constants_0('SELECTION_MODE', 0, 'selection-mode');
  SPECIFIC_RESOURCE_ID = new ResourceOperationNotificationInfo$Constants_0('SPECIFIC_RESOURCE_ID', 1, 'selection-specific-resource-id');
  RELATIVE_ANCESTOR_TYPE_ID = new ResourceOperationNotificationInfo$Constants_0('RELATIVE_ANCESTOR_TYPE_ID', 2, 'selection-relative-ancestor-type-id');
  RELATIVE_DESCENDANT_TYPE_ID = new ResourceOperationNotificationInfo$Constants_0('RELATIVE_DESCENDANT_TYPE_ID', 3, 'selection-relative-descendant-type-id');
  RELATIVE_DESCENDANT_NAME = new ResourceOperationNotificationInfo$Constants_0('RELATIVE_DESCENDANT_NAME', 4, 'selection-relative-descendant-name');
  OPERATION_ID = new ResourceOperationNotificationInfo$Constants_0('OPERATION_ID', 5, 'operation-definition-id');
  $VALUES_123 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationInfo$Constants_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceOperationNotificationInfo$Constants, [SELECTION_MODE, SPECIFIC_RESOURCE_ID, RELATIVE_ANCESTOR_TYPE_ID, RELATIVE_DESCENDANT_TYPE_ID, RELATIVE_DESCENDANT_NAME, OPERATION_ID]);
}

function ResourceOperationNotificationInfo$Constants_0(enum$name, enum$ordinal, propertyName){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.propertyName = propertyName;
}

function valueOf_132(name_0){
  $clinit_ResourceOperationNotificationInfo$Constants();
  return valueOf(($clinit_ResourceOperationNotificationInfo$Constants$Map() , $MAP_123), name_0);
}

function values_126(){
  $clinit_ResourceOperationNotificationInfo$Constants();
  return $VALUES_123;
}

defineSeed(1987, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$ResourceOperationNotificationInfo$Constants]), ResourceOperationNotificationInfo$Constants_0);
_.propertyName = null;
var $VALUES_123, OPERATION_ID, RELATIVE_ANCESTOR_TYPE_ID, RELATIVE_DESCENDANT_NAME, RELATIVE_DESCENDANT_TYPE_ID, SELECTION_MODE, SPECIFIC_RESOURCE_ID;
function $clinit_ResourceOperationNotificationInfo$Constants$Map(){
  $clinit_ResourceOperationNotificationInfo$Constants$Map = nullMethod;
  $MAP_123 = createValueOfMap(($clinit_ResourceOperationNotificationInfo$Constants() , $VALUES_123));
}

var $MAP_123;
function $clinit_ResourceOperationNotificationInfo$ResourceSelectionMode(){
  $clinit_ResourceOperationNotificationInfo$ResourceSelectionMode = nullMethod;
  SELF = new ResourceOperationNotificationInfo$ResourceSelectionMode_0('SELF', 0);
  SPECIFIC = new ResourceOperationNotificationInfo$ResourceSelectionMode_0('SPECIFIC', 1);
  RELATIVE_1 = new ResourceOperationNotificationInfo$ResourceSelectionMode_0('RELATIVE', 2);
  $VALUES_124 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationInfo$ResourceSelectionMode_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceOperationNotificationInfo$ResourceSelectionMode, [SELF, SPECIFIC, RELATIVE_1]);
}

function $getDisplayString(this$static){
  switch (this$static.ordinal) {
    case 0:
      {
        return $clinit_ResourceOperationNotificationInfo() , 'This Resource';
      }

    case 1:
      {
        return $clinit_ResourceOperationNotificationInfo() , 'Specific Resource';
      }

    case 2:
      {
        return $clinit_ResourceOperationNotificationInfo() , 'Relative Resource';
      }

    default:{
        return $clinit_ResourceOperationNotificationInfo() , 'UNKNOWN OPTION - THIS IS A BUG';
      }

  }
}

function ResourceOperationNotificationInfo$ResourceSelectionMode_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_133(name_0){
  $clinit_ResourceOperationNotificationInfo$ResourceSelectionMode();
  return valueOf(($clinit_ResourceOperationNotificationInfo$ResourceSelectionMode$Map() , $MAP_124), name_0);
}

function values_127(){
  $clinit_ResourceOperationNotificationInfo$ResourceSelectionMode();
  return $VALUES_124;
}

defineSeed(1989, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$ResourceOperationNotificationInfo$ResourceSelectionMode]), ResourceOperationNotificationInfo$ResourceSelectionMode_0);
var $VALUES_124, RELATIVE_1, SELF, SPECIFIC;
function $clinit_ResourceOperationNotificationInfo$ResourceSelectionMode$Map(){
  $clinit_ResourceOperationNotificationInfo$ResourceSelectionMode$Map = nullMethod;
  $MAP_124 = createValueOfMap(($clinit_ResourceOperationNotificationInfo$ResourceSelectionMode() , $VALUES_124));
}

var $MAP_124;
function $buildUI(this$static){
  var mode, modes, notifInfo, singleResourceButtonItem;
  this$static.dynamicForm = new DynamicForm_0;
  $setNumCols(this$static.dynamicForm, 3);
  this$static.operationArgumentsCanvasItem = new EnhancedHLayout_0;
  $setAttribute_24(this$static.operationArgumentsCanvasItem, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $setHeight(this$static.operationArgumentsCanvasItem, 400);
  $setWidth(this$static.operationArgumentsCanvasItem, 500);
  this$static.operationSelectItem = new SortedSelectItem_2('operationSelectItem', ($clinit_Enhanced() , 'Operation'));
  $setStartRow_0(this$static.operationSelectItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setEndRow_0(this$static.operationSelectItem, TRUE);
  $setWrapTitle(this$static.operationSelectItem, FALSE);
  $setRedrawOnChange(this$static.operationSelectItem);
  $setVisible(this$static.operationSelectItem, FALSE);
  $setDefaultToFirstOption_0(this$static.operationSelectItem, TRUE);
  $addChangedHandler(this$static.operationSelectItem, new ResourceOperationNotificationSenderForm$1_0(this$static));
  this$static.singleResourceTextItem = new StaticTextItem_2('singleResourceTextItem', 'Resource');
  $setStartRow_0(this$static.singleResourceTextItem, TRUE);
  $setEndRow_0(this$static.singleResourceTextItem, FALSE);
  $setValue_7(this$static.singleResourceTextItem, 'Pick a resource...');
  $setShowIfCondition(this$static.singleResourceTextItem, new ResourceOperationNotificationSenderForm$ShowIfModeFunction_0(($clinit_ResourceOperationNotificationInfo$ResourceSelectionMode() , SPECIFIC)));
  $setAttribute_27(this$static.singleResourceTextItem, 'singleResourceId', 0);
  $setValidators(this$static.singleResourceTextItem, initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [new ResourceOperationNotificationSenderForm$ResourceIdValidator_0(this$static, this$static.singleResourceTextItem)]));
  singleResourceButtonItem = new ButtonItem_1('singleResourceButtonItem', 'Pick');
  $setStartRow_1(singleResourceButtonItem, FALSE);
  $setEndRow_1(singleResourceButtonItem, TRUE);
  $setShowTitle_1(singleResourceButtonItem, FALSE);
  $setShowIfCondition(singleResourceButtonItem, new ResourceOperationNotificationSenderForm$ShowIfModeFunction_0(SPECIFIC));
  $addClickHandler_1(singleResourceButtonItem, new ResourceOperationNotificationSenderForm$2_0(this$static));
  this$static.ancestorTypeSelectItem = new SortedSelectItem_2('ancestorTypeSelectItem', 'Start Search From');
  $setStartRow_0(this$static.ancestorTypeSelectItem, TRUE);
  $setEndRow_0(this$static.ancestorTypeSelectItem, TRUE);
  $setWrapTitle(this$static.ancestorTypeSelectItem, FALSE);
  $setRedrawOnChange(this$static.ancestorTypeSelectItem);
  $setDefaultToFirstOption_0(this$static.ancestorTypeSelectItem, TRUE);
  $setHoverWidth_0(this$static.ancestorTypeSelectItem, valueOf_44(200));
  $setPrompt_1(this$static.ancestorTypeSelectItem, 'Select the top of the type hierarchy from which to search its descendant tree for the Filter By type');
  $setShowIfCondition(this$static.ancestorTypeSelectItem, new ResourceOperationNotificationSenderForm$ShowIfModeFunction_0(RELATIVE_1));
  $addChangedHandler(this$static.ancestorTypeSelectItem, new ResourceOperationNotificationSenderForm$3_0(this$static));
  this$static.descendantTypeSelectItem = new SortedSelectItem_2('descendantTypeSelectItem', 'Then Filter By');
  $setStartRow_0(this$static.descendantTypeSelectItem, TRUE);
  $setEndRow_0(this$static.descendantTypeSelectItem, FALSE);
  $setWrapTitle(this$static.descendantTypeSelectItem, FALSE);
  $setRedrawOnChange(this$static.descendantTypeSelectItem);
  $setDefaultToFirstOption_0(this$static.descendantTypeSelectItem, TRUE);
  $setHoverWidth_0(this$static.descendantTypeSelectItem, valueOf_44(200));
  $setPrompt_1(this$static.descendantTypeSelectItem, 'The resource type to search for under the root type defined in the Start Search From selection.');
  $setShowIfCondition(this$static.descendantTypeSelectItem, new ResourceOperationNotificationSenderForm$ShowIfModeFunction_0(RELATIVE_1));
  $addChangedHandler(this$static.descendantTypeSelectItem, new ResourceOperationNotificationSenderForm$4_0(this$static));
  this$static.descendantNameTextItem = new TextItem_2('descendantNameTextItem');
  $setStartRow_0(this$static.descendantNameTextItem, FALSE);
  $setEndRow_0(this$static.descendantNameTextItem, TRUE);
  $setShowTitle_0(this$static.descendantNameTextItem, FALSE);
  $setRequired(this$static.descendantNameTextItem, FALSE);
  $setPrompt_1(this$static.descendantNameTextItem, 'A specific name to uniquely identify a resource when more than one resource of the selected type might exist. This is optional if there will only ever be one resource of the resource type in the selected type hierarchy.');
  $setHoverWidth_0(this$static.descendantNameTextItem, valueOf_44(200));
  $setShowIfCondition(this$static.descendantNameTextItem, new ResourceOperationNotificationSenderForm$ShowIfModeFunction_0(RELATIVE_1));
  this$static.modeSelectItem = new SortedSelectItem_2('modeSelectItem', 'Resource Selection Mode');
  $setStartRow_0(this$static.modeSelectItem, TRUE);
  $setEndRow_0(this$static.modeSelectItem, TRUE);
  $setWrapTitle(this$static.modeSelectItem, FALSE);
  $setRedrawOnChange(this$static.modeSelectItem);
  modes = new LinkedHashMap_1(3);
  $put_1(modes, SELF.name_0, $getDisplayString(SELF));
  $put_1(modes, SPECIFIC.name_0, $getDisplayString(SPECIFIC));
  $put_1(modes, RELATIVE_1.name_0, $getDisplayString(RELATIVE_1));
  $setValueMap_1(this$static.modeSelectItem, modes);
  $addChangedHandler(this$static.modeSelectItem, new ResourceOperationNotificationSenderForm$5_0(this$static));
  this$static.dynamicForm.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.modeSelectItem, this$static.singleResourceTextItem, singleResourceButtonItem, this$static.ancestorTypeSelectItem, this$static.descendantTypeSelectItem, this$static.descendantNameTextItem, this$static.operationSelectItem]));
  $addMember(this$static, this$static.dynamicForm);
  $addMember(this$static, this$static.operationArgumentsCanvasItem);
  notifInfo = load(this$static.configuration, this$static.extraConfiguration);
  mode = notifInfo.mode;
  if (mode) {
    $setValue_7(this$static.modeSelectItem, mode.name_0);
    switch (mode.ordinal) {
      case 0:
        {
          $setOperationDropDownMenuValues(this$static, this$static.resourceType.id, notifInfo.operationId, notifInfo.operationArguments);
          break;
        }

      case 1:
        {
          $setSpecificResource(this$static, notifInfo.resourceId.value_0, notifInfo.operationId, notifInfo.operationArguments);
          break;
        }

      case 2:
        {
          $populateRelativeDropDownMenus(this$static, notifInfo.ancestorTypeId, notifInfo.descendantTypeId, notifInfo.operationId, notifInfo.operationArguments);
          notifInfo.descendantName != null && $setValue_7(this$static.descendantNameTextItem, notifInfo.descendantName);
          break;
        }

    }
  }
   else {
    $setValue_7(this$static.modeSelectItem, SELF.name_0);
    $setOperationDropDownMenuValues(this$static, this$static.resourceType.id, null, null);
  }
}

function $getConfigurationEditor(this$static){
  var canvas, canvas$index, canvas$max, canvii;
  canvii = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.operationArgumentsCanvasItem, 'members'));
  if (canvii != null) {
    for (canvas$index = 0 , canvas$max = canvii.length; canvas$index < canvas$max; ++canvas$index) {
      canvas = canvii[canvas$index];
      if (instanceOf(canvas, Q$ConfigurationEditor)) {
        return dynamicCast(canvas, Q$ConfigurationEditor);
      }
    }
  }
  return null;
}

function $hideOperationArguments(this$static){
  destroyMembers(this$static.operationArgumentsCanvasItem);
  $markForRedraw(this$static);
}

function $hideOperationDropDownMenu(this$static){
  var ops, valueMap;
  ops = new LinkedHashMap_1(0);
  valueMap = new LinkedHashMap_1(0);
  $setAttribute_12(this$static.operationSelectItem, 'operationDefinitions', new ResourceOperationNotificationSenderForm$MapWrapper_0(ops));
  $setValueMap_1(this$static.operationSelectItem, valueMap);
  $hide_0(this$static.operationSelectItem);
  destroyMembers(this$static.operationArgumentsCanvasItem);
  $markForRedraw(this$static);
  $validate_2(this$static.singleResourceTextItem);
}

function $populateRelativeDescendantsDropDownMenu(this$static, selectedDescendantResourceTypeId, selectedOpId, opArgs){
  var rootResourceTypeId, rootResourceTypeIdObj;
  rootResourceTypeIdObj = $getValue_0(this$static.ancestorTypeSelectItem);
  rootResourceTypeIdObj == null?(rootResourceTypeId = this$static.resourceType.id):(rootResourceTypeId = __parseAndValidateInt(toString__devirtual$(rootResourceTypeIdObj)));
  $getResourceTypeDescendantsWithOperations(dynamicCast(secure((!instance_28 && (instance_28 = new ResourceTypeGWTService_Proxy_0) , instance_28), -1), Q$ResourceTypeGWTServiceAsync), rootResourceTypeId, new ResourceOperationNotificationSenderForm$7_0(this$static, rootResourceTypeId, selectedDescendantResourceTypeId, selectedOpId, opArgs));
}

function $populateRelativeDropDownMenus(this$static, selectedResourceTypeId, descendantResourceTypeId, selectedOpId, opArgs){
  var callback;
  if ($getValue_0(this$static.ancestorTypeSelectItem) == null) {
    callback = new ResourceOperationNotificationSenderForm$6_0(this$static, selectedResourceTypeId, descendantResourceTypeId, selectedOpId, opArgs);
    this$static.theResource?$getResourceTypesForResourceAncestors(dynamicCast(secure((!instance_28 && (instance_28 = new ResourceTypeGWTService_Proxy_0) , instance_28), -1), Q$ResourceTypeGWTServiceAsync), this$static.theResource.id, callback):$getAllResourceTypeAncestors(dynamicCast(secure((!instance_28 && (instance_28 = new ResourceTypeGWTService_Proxy_0) , instance_28), -1), Q$ResourceTypeGWTServiceAsync), this$static.resourceType.id, callback);
  }
   else {
    $populateRelativeDescendantsDropDownMenu(this$static, descendantResourceTypeId, selectedOpId, opArgs);
  }
}

function $selectOperation(this$static, operationId){
  var def, extraConfig, ops, paramDef;
  ops = dynamicCast($getAttributeAsObject(this$static.operationSelectItem, 'operationDefinitions'), Q$ResourceOperationNotificationSenderForm$MapWrapper).map;
  if (!ops || ops.map.size_1() == 0) {
    $hideOperationDropDownMenu(this$static);
    return;
  }
  operationId <= 0 && (operationId = valueOf_44(__parseAndValidateInt(toString__devirtual$($getValue_0(this$static.operationSelectItem)))).value_0);
  def = dynamicCast($get_4(ops, valueOf_44(operationId)), Q$OperationDefinition);
  if (def) {
    paramDef = def.parametersConfigurationDefinition;
    if (paramDef) {
      extraConfig = this$static.extraConfiguration;
      if (!extraConfig) {
        extraConfig = new Configuration_0;
        this$static.extraConfiguration = extraConfig;
      }
       else {
        !!this$static.extraConfiguration && this$static.extraConfiguration.properties.clear_0();
      }
      $showOperationArguments(this$static, paramDef, extraConfig);
    }
     else {
      !!this$static.extraConfiguration && this$static.extraConfiguration.properties.clear_0();
      $showOperationArguments(this$static, null, null);
    }
  }
   else {
    $hideOperationDropDownMenu(this$static);
  }
}

function $setOperationDropDownMenuValues(this$static, resourceTypeId, selectedOpId, args){
  var criteria;
  criteria = new ResourceTypeCriteria_0;
  $addFilterId(criteria, valueOf_44(resourceTypeId));
  criteria.filterIgnored = null;
  criteria.fetchOperationDefinitions = true;
  $findResourceTypesByCriteria(dynamicCast(secure((!instance_28 && (instance_28 = new ResourceTypeGWTService_Proxy_0) , instance_28), -1), Q$ResourceTypeGWTServiceAsync), criteria, new ResourceOperationNotificationSenderForm$8_0(this$static, selectedOpId, args));
}

function $setSpecificResource(this$static, resourceId, opId, args){
  var criteria;
  $setAttribute_27(this$static.singleResourceTextItem, 'singleResourceId', resourceId);
  criteria = new ResourceCriteria_0;
  $addFilterId(criteria, valueOf_44(resourceId));
  criteria.fetchResourceType = true;
  $findResourcesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), criteria, new ResourceOperationNotificationSenderForm$9_0(this$static, opId, args, resourceId));
}

function $showOperationArguments(this$static, def, config){
  var configEditor, l_0;
  destroyMembers(this$static.operationArgumentsCanvasItem);
  if (def) {
    configEditor = new ConfigurationEditor_1(def, config);
    $addMember(this$static.operationArgumentsCanvasItem, configEditor);
  }
   else {
    l_0 = new Label_4(($clinit_Enhanced() , 'This operation does not take any parameters'));
    $setWrap_0(l_0, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addMember(this$static.operationArgumentsCanvasItem, l_0);
  }
  $markForRedraw(this$static);
}

function ResourceOperationNotificationSenderForm_0(notif, sender, resourceType, res){
  AbstractNotificationSenderForm_0.call(this, notif, sender);
  this.resourceType = resourceType;
  this.theResource = res;
  $buildUI(this);
}

defineSeed(1991, 1904, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AbstractNotificationSenderForm, Q$Enhanced]), ResourceOperationNotificationSenderForm_0);
_.validate_2 = function validate_3(callback){
  var $e0, config, configEditor, descandentNameString, e, operationId, resourceId, selectedMode, selectedModeString;
  try {
    if ($validate_0(this.dynamicForm, false).value_0) {
      configEditor = $getConfigurationEditor(this);
      if (configEditor) {
        if (!$validate_1(configEditor.topLevelPropertiesValuesManager).value_0) {
          return;
        }
      }
       else {
        this.extraConfiguration = null;
      }
      selectedModeString = toString__devirtual$($getValue_0(this.modeSelectItem));
      selectedMode = ($clinit_ResourceOperationNotificationInfo$ResourceSelectionMode() , dynamicCast(valueOf(($clinit_ResourceOperationNotificationInfo$ResourceSelectionMode$Map() , $MAP_124), selectedModeString), Q$ResourceOperationNotificationInfo$ResourceSelectionMode));
      this.configuration.properties.clear_0();
      config = this.configuration;
      $put_4(config, new PropertySimple_1(($clinit_ResourceOperationNotificationInfo$Constants() , SELECTION_MODE).propertyName, selectedMode));
      switch (selectedMode.ordinal) {
        case 1:
          {
            resourceId = $getAttributeAsInt_1(this.singleResourceTextItem).value_0;
            $put_4(config, new PropertySimple_1(SPECIFIC_RESOURCE_ID.propertyName, valueOf_44(resourceId)));
            break;
          }

        case 2:
          {
            $put_4(config, new PropertySimple_1(RELATIVE_ANCESTOR_TYPE_ID.propertyName, $getValue_0(this.ancestorTypeSelectItem)));
            $put_4(config, new PropertySimple_1(RELATIVE_DESCENDANT_TYPE_ID.propertyName, $getValue_0(this.descendantTypeSelectItem)));
            descandentNameString = $getValue_0(this.descendantNameTextItem);
            descandentNameString != null && $trim(toString__devirtual$(descandentNameString)).length > 0 && $put_4(config, new PropertySimple_1(RELATIVE_DESCENDANT_NAME.propertyName, descandentNameString));
            break;
          }

      }
      operationId = toString__devirtual$($getValue_0(this.operationSelectItem));
      $put_4(config, new PropertySimple_1(OPERATION_ID.propertyName, operationId));
      $saveNewNotification(callback.this$1.this$0);
      $run_8(callback.this$1.this$0.closeFunction);
    }
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      e = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot save the notification configuration'), e);
    }
     else 
      throw $e0;
  }
}
;
_.ancestorTypeSelectItem = null;
_.descendantNameTextItem = null;
_.descendantTypeSelectItem = null;
_.dynamicForm = null;
_.modeSelectItem = null;
_.operationArgumentsCanvasItem = null;
_.operationSelectItem = null;
_.resourceType = null;
_.singleResourceTextItem = null;
_.theResource = null;
function ResourceOperationNotificationSenderForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1992, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ResourceOperationNotificationSenderForm$1_0);
_.onChanged = function onChanged_15(event_0){
  var operationId;
  operationId = valueOf_44(__parseAndValidateInt(toString__devirtual$($getValue_2(event_0)))).value_0;
  $selectOperation(this.this$0, operationId);
}
;
_.this$0 = null;
function ResourceOperationNotificationSenderForm$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1993, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), ResourceOperationNotificationSenderForm$2_0);
_.onClick_0 = function onClick_33(event_0){
  var singleResourcePicker;
  singleResourcePicker = new SingleResourcePicker_0(new ResourceOperationNotificationSenderForm$2$1_0(this));
  $show(singleResourcePicker);
}
;
_.this$0 = null;
function $ok(this$static, resourceIdSelection){
  var resourceId;
  resourceId = dynamicCast($next_1($iterator($keySet(resourceIdSelection.map))), Q$Integer).value_0;
  $setSpecificResource(this$static.this$1.this$0, resourceId, null, null);
  return true;
}

function ResourceOperationNotificationSenderForm$2$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(1994, 1, {}, ResourceOperationNotificationSenderForm$2$1_0);
_.this$1 = null;
function ResourceOperationNotificationSenderForm$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1995, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ResourceOperationNotificationSenderForm$3_0);
_.onChanged = function onChanged_16(event_0){
  $populateRelativeDescendantsDropDownMenu(this.this$0, null, null, null);
}
;
_.this$0 = null;
function ResourceOperationNotificationSenderForm$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1996, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ResourceOperationNotificationSenderForm$4_0);
_.onChanged = function onChanged_17(event_0){
  $setOperationDropDownMenuValues(this.this$0, valueOf_44(__parseAndValidateInt(toString__devirtual$($getItem_0(event_0).getValue_1()))).value_0, null, null);
}
;
_.this$0 = null;
function ResourceOperationNotificationSenderForm$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(1997, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ResourceOperationNotificationSenderForm$5_0);
_.onChanged = function onChanged_18(event_0){
  var mode;
  mode = valueOf_133(toString__devirtual$($getValue_2(event_0)));
  switch (mode.ordinal) {
    case 0:
      {
        $setOperationDropDownMenuValues(this.this$0, this.this$0.resourceType.id, null, null);
        break;
      }

    case 1:
      {
        $setValue_7(this.this$0.singleResourceTextItem, ($clinit_Enhanced() , 'Pick a resource...'));
        $setAttribute_27(this.this$0.singleResourceTextItem, 'singleResourceId', 0);
        $hideOperationDropDownMenu(this.this$0);
        break;
      }

    case 2:
      {
        $clearValue_0(this.this$0.ancestorTypeSelectItem);
        $clearValue_0(this.this$0.descendantTypeSelectItem);
        $clearValue_0(this.this$0.descendantNameTextItem);
        $hideOperationDropDownMenu(this.this$0);
        $populateRelativeDropDownMenus(this.this$0, null, null, null, null);
        break;
      }

  }
}
;
_.this$0 = null;
function $onSuccess_118(this$static, results){
  var map, rt, rt$iterator;
  map = new LinkedHashMap_1(results.size_0);
  for (rt$iterator = new AbstractList$IteratorImpl_0(results); rt$iterator.i < rt$iterator.this$0_0.size_1();) {
    rt = dynamicCast($next_0(rt$iterator), Q$ResourceType);
    $put_1(map, '' + rt.id, rt.name_0);
  }
  $setValueMap_1(this$static.this$0.ancestorTypeSelectItem, map);
  this$static.val$selectedResourceTypeId?$setValue_7(this$static.this$0.ancestorTypeSelectItem, '' + this$static.val$selectedResourceTypeId.value_0):$setValue_7(this$static.this$0.ancestorTypeSelectItem, '' + dynamicCast((checkIndex(0, results.size_0) , results.array[0]), Q$ResourceType).id);
  $populateRelativeDescendantsDropDownMenu(this$static.this$0, this$static.val$descendantResourceTypeId, this$static.val$selectedOpId, this$static.val$opArgs);
}

function ResourceOperationNotificationSenderForm$6_0(this$0, val$selectedResourceTypeId, val$descendantResourceTypeId, val$selectedOpId, val$opArgs){
  this.this$0 = this$0;
  this.val$selectedResourceTypeId = val$selectedResourceTypeId;
  this.val$descendantResourceTypeId = val$descendantResourceTypeId;
  this.val$selectedOpId = val$selectedOpId;
  this.val$opArgs = val$opArgs;
}

defineSeed(1998, 1, {}, ResourceOperationNotificationSenderForm$6_0);
_.onFailure = function onFailure_122(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get type ancestry'), caught);
}
;
_.onSuccess_0 = function onSuccess_122(results){
  $onSuccess_118(this, dynamicCast(results, Q$ArrayList));
}
;
_.this$0 = null;
_.val$descendantResourceTypeId = null;
_.val$opArgs = null;
_.val$selectedOpId = null;
_.val$selectedResourceTypeId = null;
function $onSuccess_119(this$static, results){
  var entry, entry$iterator, map;
  map = new LinkedHashMap_1(results.size_1() + 1);
  $put_1(map, '' + this$static.val$rootResourceTypeId, ($clinit_Enhanced() , 'Root Ancestor Type'));
  for (entry$iterator = results.entrySet().iterator(); entry$iterator.hasNext();) {
    entry = dynamicCast(entry$iterator.next_0(), Q$Map$Entry);
    $put_1(map, '' + dynamicCast(entry.getKey_0(), Q$Integer).value_0, dynamicCast(entry.getValue_1(), Q$String));
  }
  $setValueMap_1(this$static.this$0.descendantTypeSelectItem, map);
  if (this$static.val$selectedDescendantResourceTypeId) {
    $setValue_7(this$static.this$0.descendantTypeSelectItem, '' + this$static.val$selectedDescendantResourceTypeId.value_0);
    $setOperationDropDownMenuValues(this$static.this$0, this$static.val$selectedDescendantResourceTypeId.value_0, this$static.val$selectedOpId, this$static.val$opArgs);
  }
   else {
    $setValue_7(this$static.this$0.descendantTypeSelectItem, '' + this$static.val$rootResourceTypeId);
    $setOperationDropDownMenuValues(this$static.this$0, this$static.val$rootResourceTypeId, this$static.val$selectedOpId, this$static.val$opArgs);
  }
}

function ResourceOperationNotificationSenderForm$7_0(this$0, val$rootResourceTypeId, val$selectedDescendantResourceTypeId, val$selectedOpId, val$opArgs){
  this.this$0 = this$0;
  this.val$rootResourceTypeId = val$rootResourceTypeId;
  this.val$selectedDescendantResourceTypeId = val$selectedDescendantResourceTypeId;
  this.val$selectedOpId = val$selectedOpId;
  this.val$opArgs = val$opArgs;
}

defineSeed(1999, 1, {}, ResourceOperationNotificationSenderForm$7_0);
_.onFailure = function onFailure_123(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get type descendants'), caught);
}
;
_.onSuccess_0 = function onSuccess_123(results){
  $onSuccess_119(this, dynamicCast(results, Q$HashMap));
}
;
_.this$0 = null;
_.val$opArgs = null;
_.val$rootResourceTypeId = 0;
_.val$selectedDescendantResourceTypeId = null;
_.val$selectedOpId = null;
function $onSuccess_120(this$static, result){
  var def, def$iterator, opDefs, set, valueMap;
  if (!result || result.size_0 != 1) {
    $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to load the list of available operations') + ': ' + result), null);
    $hideOperationDropDownMenu(this$static.this$0);
    return;
  }
  set = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceType).operationDefinitions;
  if (!!set && set.size_1() > 0) {
    opDefs = new LinkedHashMap_1(set.size_1());
    valueMap = new LinkedHashMap_1(set.size_1());
    for (def$iterator = set.iterator(); def$iterator.hasNext();) {
      def = dynamicCast(def$iterator.next_0(), Q$OperationDefinition);
      $put_1(opDefs, valueOf_44(def.id), def);
      $put_1(valueMap, '' + def.id, def.displayName);
    }
    $setAttribute_12(this$static.this$0.operationSelectItem, 'operationDefinitions', new ResourceOperationNotificationSenderForm$MapWrapper_0(opDefs));
    $setValueMap_1(this$static.this$0.operationSelectItem, valueMap);
    if (!!this$static.val$selectedOpId && this$static.val$selectedOpId.value_0 > 0 && $containsKey_1(opDefs, this$static.val$selectedOpId)) {
      $setValue_7(this$static.this$0.operationSelectItem, '' + this$static.val$selectedOpId);
      $showOperationArguments(this$static.this$0, dynamicCast($get_4(opDefs, this$static.val$selectedOpId), Q$OperationDefinition).parametersConfigurationDefinition, this$static.val$args);
    }
     else {
      $clearValue_0(this$static.this$0.operationSelectItem);
      $hideOperationArguments(this$static.this$0);
      $selectOperation(this$static.this$0, valueOf_44(__parseAndValidateInt(toString__devirtual$($getValue_0(this$static.this$0.operationSelectItem)))).value_0);
    }
    $validate_2(this$static.this$0.singleResourceTextItem);
    $show_0(this$static.this$0.operationSelectItem);
    $markForRedraw(this$static.this$0);
  }
   else {
    $hideOperationDropDownMenu(this$static.this$0);
  }
}

function ResourceOperationNotificationSenderForm$8_0(this$0, val$selectedOpId, val$args){
  this.this$0 = this$0;
  this.val$selectedOpId = val$selectedOpId;
  this.val$args = val$args;
}

defineSeed(2000, 1, {}, ResourceOperationNotificationSenderForm$8_0);
_.onFailure = function onFailure_124(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load the list of available operations'), caught);
  $hideOperationDropDownMenu(this.this$0);
}
;
_.onSuccess_0 = function onSuccess_124(result){
  $onSuccess_120(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$args = null;
_.val$selectedOpId = null;
function $onFailure_13(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load the list of available operations'), caught);
  $setValue_5(this$static.this$0.singleResourceTextItem, this$static.val$resourceId);
  $hideOperationDropDownMenu(this$static.this$0);
}

function $onSuccess_121(this$static, result){
  var resource;
  if (result.size_0 > 0) {
    resource = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Resource);
    $setValue_7(this$static.this$0.singleResourceTextItem, resource.name_0);
    $setOperationDropDownMenuValues(this$static.this$0, resource.resourceType.id, this$static.val$opId, this$static.val$args);
  }
   else {
    $onFailure_13(this$static, new Exception_1(($clinit_Enhanced() , 'Failed to load the list of available operations')));
  }
}

function ResourceOperationNotificationSenderForm$9_0(this$0, val$opId, val$args, val$resourceId){
  this.this$0 = this$0;
  this.val$opId = val$opId;
  this.val$args = val$args;
  this.val$resourceId = val$resourceId;
}

defineSeed(2001, 1, {}, ResourceOperationNotificationSenderForm$9_0);
_.onFailure = function onFailure_125(caught){
  $onFailure_13(this, caught);
}
;
_.onSuccess_0 = function onSuccess_125(result){
  $onSuccess_121(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$args = null;
_.val$opId = null;
_.val$resourceId = 0;
function ResourceOperationNotificationSenderForm$MapWrapper_0(map){
  this.map = map;
}

defineSeed(2002, 1, makeCastMap([Q$ResourceOperationNotificationSenderForm$MapWrapper]), ResourceOperationNotificationSenderForm$MapWrapper_0);
_.map = null;
function ResourceOperationNotificationSenderForm$ResourceIdValidator_0(this$0, idItem){
  this.this$0 = this$0;
  CustomValidator_0.call(this);
  this.idItem = idItem;
}

defineSeed(2003, 528, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), ResourceOperationNotificationSenderForm$ResourceIdValidator_0);
_.condition_1 = function condition_0(value){
  var id, ops, valid;
  id = valueOf_44($getAttributeAsInt_1(this.idItem).value_0);
  valid = !!id && id.value_0 != 0;
  if (valid) {
    ops = dynamicCast($getAttributeAsObject(this.this$0.operationSelectItem, 'operationDefinitions'), Q$ResourceOperationNotificationSenderForm$MapWrapper).map;
    if (!ops || ops.map.size_1() == 0) {
      valid = false;
      $setAttribute_13(this, 'errorMessage', ($clinit_Enhanced() , 'Please pick a resource that has one or more operations'));
    }
  }
   else {
    $setAttribute_13(this, 'errorMessage', ($clinit_Enhanced() , 'Please pick a resource'));
  }
  return valid;
}
;
_.idItem = null;
_.this$0 = null;
function ResourceOperationNotificationSenderForm$ShowIfModeFunction_0(mode){
  this.mode = mode;
}

defineSeed(2004, 1, {}, ResourceOperationNotificationSenderForm$ShowIfModeFunction_0);
_.execute_6 = function execute_21(item, value, form){
  var modeTypeString;
  modeTypeString = toString__devirtual$($getValue(form, 'modeSelectItem'));
  return $equals_6(this.mode.name_0, modeTypeString);
}
;
_.mode = null;
function SimpleNotificationSenderForm_0(notif, sender){
  AbstractNotificationSenderForm_0.call(this, notif, sender);
}

defineSeed(2005, 1904, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AbstractNotificationSenderForm, Q$Enhanced]), SimpleNotificationSenderForm_0);
_.onDraw_0 = function onDraw_14(){
  $getConfigurationDefinitionForSender(dynamicCast(secure(getInstance_31(), -1), Q$AlertDefinitionGWTServiceAsync), this.sender, new SimpleNotificationSenderForm$1_0(this));
}
;
_.validate_2 = function validate_4(callback){
  this.configEditor?$validate_1(this.configEditor.topLevelPropertiesValuesManager).value_0?($saveNewNotification(callback.this$1.this$0) , $run_8(callback.this$1.this$0.closeFunction)):undefined:($saveNewNotification(callback.this$1.this$0) , $run_8(callback.this$1.this$0.closeFunction));
}
;
_.configEditor = null;
function $onFailure_14(this$static, caught){
  var label;
  $clinit_Enhanced();
  $handleError_0(($clinit_CoreGUI() , 'Cannot get alert sender configuration definition'), caught);
  label = new Label_4('Cannot get alert sender configuration definition');
  $isCreated_1(label)?$setProperty_3(label, 'icon', '[SKIN]/Dialog/error.png'):(label.config_0['icon'] = '[SKIN]/Dialog/error.png' , undefined);
  $addMember(this$static.this$0, label);
  $markForRedraw(this$static.this$0);
}

function $onSuccess_122(this$static, configDef){
  this$static.this$0.configEditor = new ConfigurationEditor_1(configDef, this$static.this$0.configuration);
  $setHeight(this$static.this$0.configEditor, 400);
  $setWidth(this$static.this$0.configEditor, 600);
  $addMember(this$static.this$0, this$static.this$0.configEditor);
  $markForRedraw(this$static.this$0);
}

function SimpleNotificationSenderForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2006, 1, {}, SimpleNotificationSenderForm$1_0);
_.onFailure = function onFailure_126(caught){
  $onFailure_14(this, caught);
}
;
_.onSuccess_0 = function onSuccess_126(configDef){
  $onSuccess_122(this, dynamicCast(configDef, Q$ConfigurationDefinition));
}
;
_.this$0 = null;
function $makeEditable_4(this$static){
  $show(this$static.saveButton);
  $show(this$static.cancelButton);
  $hide(this$static.editButton);
  $makeEditable_1(this$static.generalProperties);
  $makeEditable(this$static.conditions);
  $makeEditable_2(this$static.notifications);
  $makeEditable_3(this$static.recovery);
  $makeEditable_0(this$static.dampening);
  this$static.handlerRegistration = $addVisibilityChangedHandler(this$static, new SingleAlertDefinitionView$5_0(this$static));
}

function $makeViewOnly_4(this$static){
  $hide(this$static.saveButton);
  $hide(this$static.cancelButton);
  $show(this$static.editButton);
  $makeViewOnly_1(this$static.generalProperties);
  $makeViewOnly(this$static.conditions);
  $makeViewOnly_2(this$static.notifications);
  $makeViewOnly_3(this$static.recovery);
  $makeViewOnly_0(this$static.dampening);
}

function $save_1(this$static){
  var resetMatching;
  if ($validate_3(this$static.generalProperties)) {
    resetMatching = $isResetMatching(this$static.conditions) || this$static.dampening.updated;
    $saveAlertDefinition_1(this$static.generalProperties);
    $saveAlertDefinition(this$static.conditions);
    $saveAlertDefinition_2(this$static.notifications);
    $saveAlertDefinition_3(this$static.recovery);
    $saveAlertDefinition_0(this$static.dampening);
    $setAlertDefinition_5(this$static, this$static.alertDefinition);
    $makeViewOnly_4(this$static);
    this$static.alertDefView.commitAlertDefinition(this$static.alertDefinition, resetMatching, new SingleAlertDefinitionView$6_0(this$static));
  }
   else {
    $selectTab_0(this$static.tabSet, this$static.generalPropertiesTab);
  }
}

function $setAlertDefinition_5(this$static, alertDef){
  this$static.alertDefinition = alertDef;
  $setAlertDefinition_2(this$static.generalProperties, alertDef);
  $setAlertDefinition_0(this$static.conditions, alertDef);
  $setAlertDefinition_3(this$static.notifications, alertDef);
  $setAlertDefinition_4(this$static.recovery, alertDef);
  $setAlertDefinition_1(this$static.dampening, alertDef);
  $makeViewOnly_4(this$static);
}

function SingleAlertDefinitionView_0(alertDefView){
  var conditionsTab, notificationsTab, recoveryTab, dampeningTab, buttons;
  EnhancedVLayout_0.call(this);
  this.alertDefinition = null;
  this.isAuthorizedToModifyAlertDefinitions = alertDefView.isAuthorizedToModifyAlertDefinitions_0();
  this.alertDefView = alertDefView;
  this.tabSet = new TabSet_0;
  $setAttribute_24(this.tabSet, 'height', '100%', true);
  this.generalPropertiesTab = new Tab_1(($clinit_Enhanced() , 'General Properties'));
  this.generalProperties = new GeneralPropertiesAlertDefinitionForm_0;
  $setPane(this.generalPropertiesTab, this.generalProperties);
  $addTabDeselectedHandler(this.generalPropertiesTab, new SingleAlertDefinitionView$1_0(this));
  conditionsTab = new Tab_1('Conditions');
  this.conditions = new ConditionsAlertDefinitionForm_0(alertDefView.getResourceType());
  $setPane(conditionsTab, this.conditions);
  notificationsTab = new Tab_1('Notifications');
  this.notifications = new NotificationsAlertDefinitionForm_0;
  $setPane(notificationsTab, this.notifications);
  recoveryTab = new Tab_1('Recovery');
  this.recovery = new RecoveryAlertDefinitionForm_0(alertDefView.getAlertDefinitionDataSource());
  $setPane(recoveryTab, this.recovery);
  dampeningTab = new Tab_1('Dampening');
  this.dampening = new DampeningAlertDefinitionForm_0;
  $setPane(dampeningTab, this.dampening);
  $setTabs(this.tabSet, initValues(_3Lcom_smartgwt_client_widgets_tab_Tab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Tab, [this.generalPropertiesTab, conditionsTab, notificationsTab, recoveryTab, dampeningTab]));
  buttons = new HLayout_0;
  $isCreated_1(buttons)?$setProperty_0(buttons, 'membersMargin', 20):(buttons.config_0['membersMargin'] = 20 , undefined);
  this.editButton = new Button_2('Edit');
  this.saveButton = new Button_2('Save');
  this.cancelButton = new Button_2('Cancel');
  $show(this.editButton);
  $hide(this.saveButton);
  $hide(this.cancelButton);
  $addMember(buttons, this.editButton);
  $addMember(buttons, this.saveButton);
  $addMember(buttons, this.cancelButton);
  $setDisabled_0(this.editButton, !this.isAuthorizedToModifyAlertDefinitions);
  $addClickHandler(this.editButton, new SingleAlertDefinitionView$2_0(this));
  $addClickHandler(this.saveButton, new SingleAlertDefinitionView$3_0(this));
  $addClickHandler(this.cancelButton, new SingleAlertDefinitionView$4_0(this));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 10):(this.config_0['membersMargin'] = 10 , undefined);
  $addMember(this, this.tabSet);
  $addMember(this, buttons);
}

defineSeed(2007, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), SingleAlertDefinitionView_0);
_.alertDefView = null;
_.alertDefinition = null;
_.cancelButton = null;
_.conditions = null;
_.dampening = null;
_.editButton = null;
_.generalProperties = null;
_.generalPropertiesTab = null;
_.handlerRegistration = null;
_.isAuthorizedToModifyAlertDefinitions = false;
_.notifications = null;
_.recovery = null;
_.saveButton = null;
_.tabSet = null;
function SingleAlertDefinitionView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2008, 1, makeCastMap([Q$EventHandler, Q$TabDeselectedHandler]), SingleAlertDefinitionView$1_0);
_.this$0 = null;
function SingleAlertDefinitionView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2009, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), SingleAlertDefinitionView$2_0);
_.onClick = function onClick_34(event_0){
  $makeEditable_4(this.this$0);
}
;
_.this$0 = null;
function SingleAlertDefinitionView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2010, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), SingleAlertDefinitionView$3_0);
_.onClick = function onClick_35(event_0){
  $save_1(this.this$0);
}
;
_.this$0 = null;
function SingleAlertDefinitionView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2011, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), SingleAlertDefinitionView$4_0);
_.onClick = function onClick_36(event_0){
  $removeHandler(this.this$0.handlerRegistration.real);
  $setAlertDefinition_5(this.this$0, this.this$0.alertDefinition);
  $makeViewOnly_4(this.this$0);
}
;
_.this$0 = null;
function SingleAlertDefinitionView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2012, 1, makeCastMap([Q$EventHandler, Q$VisibilityChangedHandler]), SingleAlertDefinitionView$5_0);
_.this$0 = null;
function SingleAlertDefinitionView$5$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2013, 1, {}, SingleAlertDefinitionView$5$1_0);
_.execute_3 = function execute_22(value){
  value.value_0 && $save_1(this.this$1.this$0);
  $removeHandler(this.this$1.this$0.handlerRegistration.real);
}
;
_.this$1 = null;
function $onSuccess_123(this$static, alertDef){
  $removeHandler(this$static.this$0.handlerRegistration.real);
  $setAlertDefinition_5(this$static.this$0, alertDef);
}

function SingleAlertDefinitionView$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2014, 1, {}, SingleAlertDefinitionView$6_0);
_.onFailure = function onFailure_127(caught){
}
;
_.onSuccess_0 = function onSuccess_127(alertDef){
  $onSuccess_123(this, dynamicCast(alertDef, Q$AlertDefinition));
}
;
_.this$0 = null;
function $createNewSelector(this$static, preselectedRoles){
  this$static.selector = new SystemRolesNotificationSenderForm$RoleSelector_0(preselectedRoles);
  $setWidth(this$static.selector, 400);
  $setHeight(this$static.selector, 300);
  $addMember(this$static, this$static.selector);
  $markForRedraw(this$static);
}

function $fence(elements){
  var builder, next, next$iterator;
  if (elements.map.size_1() == 0) {
    return '';
  }
  builder = new StringBuilder_0;
  $appendNonNull(builder.data_0, '|');
  for (next$iterator = $iterator($keySet(elements.map)); next$iterator.val$outerIter.hasNext();) {
    next = $next_1(next$iterator);
    $append_7(($append_1(builder.data_0, '' + next) , builder), 124);
  }
  return $toString_1(builder.data_0);
}

function $unfence(fencedData, type){
  var elements, next, next$index, next$max, results;
  elements = $split(fencedData, '\\|', 0);
  results = new ArrayList_1(elements.length);
  if (Ljava_lang_Integer_2_classLit == type) {
    for (next$index = 0 , next$max = elements.length; next$index < next$max; ++next$index) {
      next = elements[next$index];
      next.length != 0 && $add_3(results, valueOf_44(__parseAndValidateInt(next)));
    }
  }
   else if (Ljava_lang_String_2_classLit == type) {
    for (next$index = 0 , next$max = elements.length; next$index < next$max; ++next$index) {
      next = elements[next$index];
      next.length != 0 && (setCheck(results.array, results.size_0++, next) , true);
    }
  }
   else {
    throw new IllegalArgumentException_1('No support for unfencing data of type ' + type);
  }
  return results;
}

function SystemRolesNotificationSenderForm_0(notif, sender){
  AbstractNotificationSenderForm_0.call(this, notif, sender);
}

defineSeed(2015, 1904, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AbstractNotificationSenderForm, Q$Enhanced]), SystemRolesNotificationSenderForm_0);
_.onInit = function onInit_26(){
  var $e0, criteria, e, ids, roleIds;
  $onInit(this);
  $onInit_Layout(this);
  roleIds = $getSimpleValue(this.configuration, 'roleId', '');
  if (roleIds != null && roleIds.length > 0) {
    try {
      ids = $unfence(roleIds, Ljava_lang_Integer_2_classLit);
      criteria = new RoleCriteria_0;
      $addFilterIds(criteria, dynamicCast($toArray_1(ids, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, ids.size_0, 0)), Q$Integer_$1));
      $findRolesByCriteria(dynamicCast(secure(getInstance_52(), -1), Q$RoleGWTServiceAsync), criteria, new SystemRolesNotificationSenderForm$1_0(this));
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        e = $e0;
        $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot use current roles - starting empty'), e);
        $createNewSelector(this, null);
      }
       else 
        throw $e0;
    }
  }
   else {
    $createNewSelector(this, null);
  }
}
;
_.validate_2 = function validate_5(callback){
  var $e0, e, newPropValue, selectedIds;
  if (this.selector) {
    try {
      selectedIds = $getSelection(this.selector);
      newPropValue = $fence(selectedIds);
      $put_4(this.configuration, new PropertySimple_1('roleId', newPropValue));
      $saveNewNotification(callback.this$1.this$0);
      $run_8(callback.this$1.this$0.closeFunction);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        e = $e0;
        $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot save the selected roles'), e);
      }
       else 
        throw $e0;
    }
  }
   else {
    $saveNewNotification(callback.this$1.this$0);
    $run_8(callback.this$1.this$0.closeFunction);
  }
}
;
_.selector = null;
function $onSuccess_124(this$static, result){
  $createNewSelector(this$static.this$0, result);
}

function SystemRolesNotificationSenderForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2016, 1, {}, SystemRolesNotificationSenderForm$1_0);
_.onFailure = function onFailure_128(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot determine current roles - starting empty'), caught);
  $createNewSelector(this.this$0, null);
}
;
_.onSuccess_0 = function onSuccess_128(result){
  $onSuccess_124(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function SystemRolesNotificationSenderForm$RoleSelector_0(roles){
  var data;
  AbstractSelector_0.call(this);
  if (roles) {
    data = $buildRecords(new RolesDataSource_0, roles, true);
    this.initialSelection = data;
  }
}

defineSeed(2017, 1699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), SystemRolesNotificationSenderForm$RoleSelector_0);
_.getAvailableFilterForm = function getAvailableFilterForm_5(){
  return null;
}
;
_.getDataSource_0 = function getDataSource_7(){
  return new RolesDataSource_0;
}
;
_.getItemTitle = function getItemTitle_5(){
  return $clinit_Enhanced() , 'Roles';
}
;
_.getLatestCriteria = function getLatestCriteria_5(availableFilterForm){
  return null;
}
;
_.getMaxAvailableRecords = function getMaxAvailableRecords_4(){
  return 500;
}
;
function $createNewSelector_0(this$static, preselectedSubjects){
  this$static.selector = new SystemUsersNotificationSenderForm$SubjectSelector_0(preselectedSubjects);
  $setWidth(this$static.selector, 400);
  $setHeight(this$static.selector, 300);
  $addMember(this$static, this$static.selector);
  $markForRedraw(this$static);
}

function $fence_0(elements){
  var builder, next, next$iterator;
  if (elements.map.size_1() == 0) {
    return '';
  }
  builder = new StringBuilder_0;
  $appendNonNull(builder.data_0, '|');
  for (next$iterator = $iterator($keySet(elements.map)); next$iterator.val$outerIter.hasNext();) {
    next = $next_1(next$iterator);
    $append_7(($append_1(builder.data_0, '' + next) , builder), 124);
  }
  return $toString_1(builder.data_0);
}

function $unfence_0(fencedData, type){
  var elements, next, next$index, next$max, results;
  elements = $split(fencedData, '\\|', 0);
  results = new ArrayList_1(elements.length);
  if (Ljava_lang_Integer_2_classLit == type) {
    for (next$index = 0 , next$max = elements.length; next$index < next$max; ++next$index) {
      next = elements[next$index];
      next.length != 0 && $add_3(results, valueOf_44(__parseAndValidateInt(next)));
    }
  }
   else if (Ljava_lang_String_2_classLit == type) {
    for (next$index = 0 , next$max = elements.length; next$index < next$max; ++next$index) {
      next = elements[next$index];
      next.length != 0 && (setCheck(results.array, results.size_0++, next) , true);
    }
  }
   else {
    throw new IllegalArgumentException_1('No support for unfencing data of type ' + type);
  }
  return results;
}

function SystemUsersNotificationSenderForm_0(notif, sender){
  AbstractNotificationSenderForm_0.call(this, notif, sender);
}

defineSeed(2018, 1904, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AbstractNotificationSenderForm, Q$Enhanced]), SystemUsersNotificationSenderForm_0);
_.onInit = function onInit_27(){
  var $e0, criteria, e, ids, subjectIds;
  if (this.isInitialized) {
    return;
  }
  this.isInitialized = true;
  $onInit(this);
  $onInit_Layout(this);
  subjectIds = $getSimpleValue(this.configuration, 'subjectId', '');
  if (subjectIds != null && subjectIds.length > 0) {
    try {
      ids = $unfence_0(subjectIds, Ljava_lang_Integer_2_classLit);
      criteria = new SubjectCriteria_0;
      $addFilterIds(criteria, dynamicCast($toArray_1(ids, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, ids.size_0, 0)), Q$Integer_$1));
      $findSubjectsByCriteria(dynamicCast(secure(getInstance_54(), -1), Q$SubjectGWTServiceAsync), criteria, new SystemUsersNotificationSenderForm$1_0(this));
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        e = $e0;
        $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot use current users - starting empty'), e);
        $createNewSelector_0(this, null);
      }
       else 
        throw $e0;
    }
  }
   else {
    $createNewSelector_0(this, null);
  }
}
;
_.validate_2 = function validate_6(callback){
  var $e0, e, newPropValue, selectedIds;
  if (this.selector) {
    try {
      selectedIds = $getSelection(this.selector);
      newPropValue = $fence_0(selectedIds);
      $put_4(this.configuration, new PropertySimple_1('subjectId', newPropValue));
      $saveNewNotification(callback.this$1.this$0);
      $run_8(callback.this$1.this$0.closeFunction);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        e = $e0;
        $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot save the selected users'), e);
      }
       else 
        throw $e0;
    }
  }
   else {
    $saveNewNotification(callback.this$1.this$0);
    $run_8(callback.this$1.this$0.closeFunction);
  }
}
;
_.isInitialized = false;
_.selector = null;
function $onSuccess_125(this$static, result){
  $createNewSelector_0(this$static.this$0, result);
}

function SystemUsersNotificationSenderForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2019, 1, {}, SystemUsersNotificationSenderForm$1_0);
_.onFailure = function onFailure_129(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot determine current users - starting empty'), caught);
  $createNewSelector_0(this.this$0, null);
}
;
_.onSuccess_0 = function onSuccess_129(result){
  $onSuccess_125(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function SystemUsersNotificationSenderForm$SubjectSelector_0(subjects){
  var data;
  AbstractSelector_0.call(this);
  if (subjects) {
    data = $buildRecords(new UsersDataSource_0, subjects, true);
    this.initialSelection = data;
  }
}

defineSeed(2020, 1699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), SystemUsersNotificationSenderForm$SubjectSelector_0);
_.getAvailableFilterForm = function getAvailableFilterForm_6(){
  return null;
}
;
_.getDataSource_0 = function getDataSource_8(){
  return new UsersDataSource_0;
}
;
_.getItemTitle = function getItemTitle_6(){
  return $clinit_Enhanced() , 'Users';
}
;
_.getLatestCriteria = function getLatestCriteria_6(availableFilterForm){
  return null;
}
;
_.getMaxAvailableRecords = function getMaxAvailableRecords_5(){
  return 500;
}
;
function $getFetchCriteria_4(request){
  var criteria, fieldName, key, key$iterator, requestCriteria, resourceTypeId, values;
  criteria = new AlertDefinitionCriteria_0;
  requestCriteria = $getCriteria(request);
  criteria.filterAlertTemplateOnly = ($clinit_Criteria$NonBindingOverrideFilter() , ON);
  if (requestCriteria) {
    values = convertToMap(requestCriteria.jsObj);
    for (key$iterator = values.keySet_0().iterator(); key$iterator.hasNext();) {
      key = key$iterator.next_0();
      fieldName = dynamicCast(key, Q$String);
      if ($equals_6(fieldName, 'resourceTypeId')) {
        resourceTypeId = dynamicCast(values.get_2(fieldName), Q$Integer);
        criteria.filterAlertTemplateResourceTypeId = resourceTypeId;
      }
    }
  }
  return criteria;
}

function TemplateAlertDefinitionsDataSource_0(rt){
  $clinit_RPCDataSource();
  AbstractAlertDefinitionsDataSource_0.call(this);
  this.resourceType = rt;
}

defineSeed(2021, 1895, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), TemplateAlertDefinitionsDataSource_0);
_.getFetchCriteria = function getFetchCriteria_16(request){
  return $getFetchCriteria_4(request);
}
;
_.getSimpleCriteriaForAll = function getSimpleCriteriaForAll_1(){
  var criteria;
  criteria = new AlertDefinitionCriteria_0;
  $addFilterAlertTemplateResourceTypeId(criteria, valueOf_44(this.resourceType.id));
  $setPageControl(criteria, new PageControl_1(0, -1));
  return criteria;
}
;
_.resourceType = null;
function TemplateAlertDefinitionsView_0(resourceType, globalPermissions){
  var criteria;
  $clinit_BaseWidget();
  var metadata;
  AbstractAlertDefinitionsView_0.call(this, ($clinit_Enhanced() , 'Alert Definition Templates') + ' [' + resourceType.name_0 + ']', (criteria = new Criteria_0 , $addCriteria_1(criteria, 'resourceTypeId', valueOf_44(resourceType.id)) , criteria));
  this.resourceType = resourceType;
  this.globalPermissions = globalPermissions;
  metadata = noneOf(Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit);
  !resourceType.eventDefinitions && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , events_0));
  !resourceType.metricDefinitions && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , measurements_0));
  !resourceType.operationDefinitions && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , operations_0));
  !resourceType.resourceConfigurationDefinition && $add_5(metadata, ($clinit_ResourceTypeRepository$MetadataType() , resourceConfigurationDefinition_0));
  metadata.size_0 == 0 || $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(resourceType.id), metadata, new TemplateAlertDefinitionsView$1_0(this));
}

defineSeed(2022, 1898, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), TemplateAlertDefinitionsView_0);
_.commitAlertDefinition = function commitAlertDefinition_1(alertDefinition, resetMatching, resultReceiver){
  alertDefinition.id == 0?$createAlertTemplate(dynamicCast(secure(getInstance_33(), -1), Q$AlertTemplateGWTServiceAsync), alertDefinition, valueOf_44(this.resourceType.id), new TemplateAlertDefinitionsView$5_0(this, alertDefinition, resultReceiver)):$updateAlertTemplate(dynamicCast(secure(getInstance_33(), -1), Q$AlertTemplateGWTServiceAsync), alertDefinition, resetMatching, new TemplateAlertDefinitionsView$6_0(this, resultReceiver));
}
;
_.deleteButtonPressed = function deleteButtonPressed_1(selection){
  var alertDefIds, i, id, record, record$index, record$max;
  if (selection.length == 0) {
    return;
  }
  alertDefIds = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, selection.length, 0);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    id = getAttributeAsInt(record.jsObj, 'id');
    alertDefIds[i++] = id;
  }
  $removeAlertTemplates(dynamicCast(secure(getInstance_33(), -1), Q$AlertTemplateGWTServiceAsync), alertDefIds, new TemplateAlertDefinitionsView$4_0(this, alertDefIds));
}
;
_.disableButtonPressed = function disableButtonPressed_1(selection){
  var alertDefIds, i, id, record, record$index, record$max;
  if (selection.length == 0) {
    return;
  }
  alertDefIds = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, selection.length, 0);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    id = getAttributeAsInt(record.jsObj, 'id');
    alertDefIds[i++] = id;
  }
  $disableAlertTemplates(dynamicCast(secure(getInstance_33(), -1), Q$AlertTemplateGWTServiceAsync), alertDefIds, new TemplateAlertDefinitionsView$3_0(this, alertDefIds));
}
;
_.enableButtonPressed = function enableButtonPressed_1(selection){
  var alertDefIds, i, id, record, record$index, record$max;
  if (selection.length == 0) {
    return;
  }
  alertDefIds = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, selection.length, 0);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    id = getAttributeAsInt(record.jsObj, 'id');
    alertDefIds[i++] = id;
  }
  $enableAlertTemplates(dynamicCast(secure(getInstance_33(), -1), Q$AlertTemplateGWTServiceAsync), alertDefIds, new TemplateAlertDefinitionsView$2_0(this, alertDefIds));
}
;
_.getAlertDefinitionDataSource = function getAlertDefinitionDataSource_1(){
  return new TemplateAlertDefinitionsDataSource_0(this.resourceType);
}
;
_.getDetailCriteria = function getDetailCriteria_0(){
  var criteria;
  criteria = new AlertDefinitionCriteria_0;
  criteria.filterAlertTemplateOnly = ($clinit_Criteria$NonBindingOverrideFilter() , ON);
  return criteria;
}
;
_.getDetailsView_1 = function getDetailsView_13(id){
  var view;
  view = $getDetailsView(this, id);
  id.value_0 == 0 && $setResourceType(view.alertDefinition, this.resourceType);
  return view;
}
;
_.getResourceType = function getResourceType_1(){
  return this.resourceType;
}
;
_.isAuthorizedToModifyAlertDefinitions_0 = function isAuthorizedToModifyAlertDefinitions_1(){
  return this.globalPermissions.contains_0(($clinit_Permission() , MANAGE_SETTINGS));
}
;
_.newButtonPressed = function newButtonPressed_1(selection){
  $clinit_CoreGUI();
  goToView(this.basePath + '/0', null, false);
}
;
_.globalPermissions = null;
_.resourceType = null;
function TemplateAlertDefinitionsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2023, 1, {}, TemplateAlertDefinitionsView$1_0);
_.onTypesLoaded = function onTypesLoaded_4(type){
  this.this$0.resourceType = type;
}
;
_.this$0 = null;
function $onSuccess_126(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully enabled ' + ($clinit_Enhanced() , '' + this$static.val$alertDefIds.length) + ' alert definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function TemplateAlertDefinitionsView$2_0(this$0, val$alertDefIds){
  this.this$0 = this$0;
  this.val$alertDefIds = val$alertDefIds;
}

defineSeed(2024, 1, {}, TemplateAlertDefinitionsView$2_0);
_.onFailure = function onFailure_130(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to enable the selected alert definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_130(v){
  $onSuccess_126(this, throwClassCastExceptionUnlessNull(v));
}
;
_.this$0 = null;
_.val$alertDefIds = null;
function $onSuccess_127(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully disabled ' + ($clinit_Enhanced() , '' + this$static.val$alertDefIds.length) + ' alert definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function TemplateAlertDefinitionsView$3_0(this$0, val$alertDefIds){
  this.this$0 = this$0;
  this.val$alertDefIds = val$alertDefIds;
}

defineSeed(2025, 1, {}, TemplateAlertDefinitionsView$3_0);
_.onFailure = function onFailure_131(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to disable the selected alert definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_131(v){
  $onSuccess_127(this, throwClassCastExceptionUnlessNull(v));
}
;
_.this$0 = null;
_.val$alertDefIds = null;
function $onSuccess_128(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully deleted ' + ($clinit_Enhanced() , '' + this$static.val$alertDefIds.length) + ' alert definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function TemplateAlertDefinitionsView$4_0(this$0, val$alertDefIds){
  this.this$0 = this$0;
  this.val$alertDefIds = val$alertDefIds;
}

defineSeed(2026, 1, {}, TemplateAlertDefinitionsView$4_0);
_.onFailure = function onFailure_132(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to deleted the selected alert definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_132(v){
  $onSuccess_128(this, throwClassCastExceptionUnlessNull(v));
}
;
_.this$0 = null;
_.val$alertDefIds = null;
function $onSuccess_129(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Alert definition successfully created'), ($clinit_Message$Severity() , Info)));
  $setId(this$static.val$alertDefinition, result.value_0);
  $refresh(this$static.this$0, false);
  $onSuccess_123(this$static.val$resultReceiver, this$static.val$alertDefinition);
}

function TemplateAlertDefinitionsView$5_0(this$0, val$alertDefinition, val$resultReceiver){
  this.this$0 = this$0;
  this.val$alertDefinition = val$alertDefinition;
  this.val$resultReceiver = val$resultReceiver;
}

defineSeed(2027, 1, {}, TemplateAlertDefinitionsView$5_0);
_.onFailure = function onFailure_133(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition creation failed'), caught);
}
;
_.onSuccess_0 = function onSuccess_133(result){
  $onSuccess_129(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
_.val$alertDefinition = null;
_.val$resultReceiver = null;
function $onSuccess_130(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Alert definition successfully updated'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
  $onSuccess_123(this$static.val$resultReceiver, result);
}

function TemplateAlertDefinitionsView$6_0(this$0, val$resultReceiver){
  this.this$0 = this$0;
  this.val$resultReceiver = val$resultReceiver;
}

defineSeed(2028, 1, {}, TemplateAlertDefinitionsView$6_0);
_.onFailure = function onFailure_134(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition update failed'), caught);
}
;
_.onSuccess_0 = function onSuccess_134(result){
  $onSuccess_130(this, dynamicCast(result, Q$AlertDefinition));
}
;
_.this$0 = null;
_.val$resultReceiver = null;
function BundleSelector_0(){
  $clinit_BaseWidget();
  AbstractSelector_0.call(this);
  this.bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
}

defineSeed(2029, 1699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), BundleSelector_0);
_.getAvailableFilterForm = function getAvailableFilterForm_7(){
  var availableFilterForm, bundleTypeSelect, search;
  availableFilterForm = new DynamicForm_0;
  $isCreated_1(availableFilterForm)?$setProperty_0(availableFilterForm, 'numCols', 4):(availableFilterForm.config_0['numCols'] = 4 , undefined);
  search = new TextItem_3('search', ($clinit_Enhanced() , 'Search'));
  bundleTypeSelect = new SortedSelectItem_2('bundleType', 'Bundle Type');
  $getAllBundleTypes(this.bundleService, new BundleSelector$1_0(bundleTypeSelect));
  $setAllowEmptyValue(bundleTypeSelect, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  availableFilterForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [search, bundleTypeSelect]));
  return availableFilterForm;
}
;
_.getDataSource_0 = function getDataSource_9(){
  return new BundleSelector$SelectedBundlesDataSource_0;
}
;
_.getItemTitle = function getItemTitle_7(){
  return $clinit_Enhanced() , 'Bundles';
}
;
_.getLatestCriteria = function getLatestCriteria_7(availableFilterForm){
  var bundleType, latestCriteria, search;
  search = dynamicCast($getValue(availableFilterForm, 'search'), Q$String);
  bundleType = $getValueAsString(availableFilterForm, 'bundleType');
  latestCriteria = new Criteria_0;
  latestCriteria.jsObj['search'] = search;
  latestCriteria.jsObj['bundleType'] = bundleType;
  return latestCriteria;
}
;
function $onSuccess_131(this$static, result){
  var type, type$iterator, values;
  values = new LinkedHashMap_1(result.size_0);
  for (type$iterator = new AbstractList$IteratorImpl_0(result); type$iterator.i < type$iterator.this$0_0.size_1();) {
    type = dynamicCast($next_0(type$iterator), Q$BundleType);
    $put_1(values, '' + type.id, type.name_0);
  }
  $setValueMap_1(this$static.val$bundleTypeSelect, values);
}

function BundleSelector$1_0(val$bundleTypeSelect){
  this.val$bundleTypeSelect = val$bundleTypeSelect;
}

defineSeed(2030, 1, {}, BundleSelector$1_0);
_.onFailure = function onFailure_135(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load Bundle data'), caught);
}
;
_.onSuccess_0 = function onSuccess_135(result){
  $onSuccess_131(this, dynamicCast(result, Q$ArrayList));
}
;
_.val$bundleTypeSelect = null;
function $copyValues_22(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'name', from.name_0);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_13(record, 'bundleType', from.bundleType.name_0);
  $setAttribute_13(record, 'repo', from.repo.name_0);
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  return record;
}

function $executeFetch_12(this$static, request, response, criteria){
  $findBundlesByCriteria(this$static.bundleService, criteria, new BundlesDataSource$1_0(this$static, response, request));
}

function $getFetchCriteria_5(request){
  var criteria;
  criteria = new BundleCriteria_0;
  $addFilterTagNamespace(criteria, dynamicCast(getFilter($getCriteria(request), 'tagNamespace', Ljava_lang_String_2_classLit), Q$String));
  $addFilterTagSemantic(criteria, dynamicCast(getFilter($getCriteria(request), 'tagSemantic', Ljava_lang_String_2_classLit), Q$String));
  $addFilterTagName(criteria, dynamicCast(getFilter($getCriteria(request), 'tagName', Ljava_lang_String_2_classLit), Q$String));
  $addFilterBundleTypeId(criteria, dynamicCast(getFilter($getCriteria(request), 'bundleType', Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterTagSemantic(criteria, dynamicCast(getFilter($getCriteria(request), 'tagSemantic', Ljava_lang_String_2_classLit), Q$String));
  $addFilterName_0(criteria, dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String));
  return criteria;
}

defineSeed(2032, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]));
_.copyValues = function copyValues_34(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'object'), Q$Bundle);
}
;
_.copyValues_0 = function copyValues_35(from){
  return $copyValues_22(dynamicCast(from, Q$Bundle));
}
;
_.executeFetch = function executeFetch_18(request, response, criteria){
  $executeFetch_12(this, request, response, dynamicCast(criteria, Q$BundleCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_17(request){
  return this.getFetchCriteria_1(request);
}
;
_.getFetchCriteria_1 = function getFetchCriteria_18(request){
  return $getFetchCriteria_5(request);
}
;
function BundleSelector$SelectedBundlesDataSource_0(){
  var fields, fields_0, idField, nameField, descriptionField, bundleTypeDataField;
  $clinit_RPCDataSource();
  RPCDataSource_0.call(this);
  this.bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , idField = new DataSourceIntegerField_1('id', 'ID') , $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , setCheck(fields_0.array, fields_0.size_0++, idField) , nameField = new DataSourceTextField_1('name', 'Name') , setCheck(fields_0.array, fields_0.size_0++, nameField) , descriptionField = new DataSourceTextField_1('description', 'Description') , setCheck(fields_0.array, fields_0.size_0++, descriptionField) , bundleTypeDataField = new DataSourceTextField_1('bundleType', 'Bundle Type') , setCheck(fields_0.array, fields_0.size_0++, bundleTypeDataField) , fields_0);
  $addFields(this, fields);
}

defineSeed(2031, 2032, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), BundleSelector$SelectedBundlesDataSource_0);
_.getFetchCriteria_1 = function getFetchCriteria_19(request){
  var result;
  result = $getFetchCriteria_5(request);
  !!result && (result.strict = false);
  return result;
}
;
function $setContent_0(this$static, newContent){
  destroyMembers(this$static.contentCanvas);
  this$static.contentCanvas.addMember_0(newContent);
  this$static.contentCanvas.markForRedraw_0();
}

function BundleTopView_0(){
  $clinit_BundleTopView();
  EnhancedHLayout_0.call(this);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(2033, 1539, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$Enhanced, Q$EnhancedHLayout]), BundleTopView_0);
_.renderView = function renderView_10(viewPath){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new BundleTopView$1_0(this, viewPath)));
}
;
_.bundleTreeView = null;
_.bundleView = null;
_.bundlesListView = null;
_.contentCanvas = null;
_.currentNextPath = null;
function BundleTopView$1_0(this$0, val$viewPath){
  this.this$0 = this$0;
  this.val$viewPath = val$viewPath;
}

defineSeed(2034, 1, {}, BundleTopView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_5(permissions){
  var bundlesSection, canManageBundles, canManageInventory, repoTree, repositoriesSection, sectionStack;
  if (!this.this$0.bundleTreeView) {
    canManageInventory = !!permissions && permissions.contains_0(($clinit_Permission() , MANAGE_INVENTORY));
    canManageBundles = !!permissions && permissions.contains_0(($clinit_Permission() , MANAGE_BUNDLE));
    sectionStack = new SectionStack_0;
    $setShowResizeBar(sectionStack, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $setAttribute_24(sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
    $isCreated_1(sectionStack)?$setProperty_0(sectionStack, 'width', 250):(sectionStack.config_0['width'] = 250 , undefined);
    $isCreated_1(sectionStack)?$setProperty_3(sectionStack, 'height', '100%'):(sectionStack.config_0['height'] = '100%' , undefined);
    bundlesSection = new SectionStackSection_1(($clinit_Enhanced() , 'Bundles'));
    this.this$0.bundleTreeView = new BundleTreeView_0(canManageBundles);
    $addItemJS(bundlesSection, $getOrCreateJsObj_0(this.this$0.bundleTreeView));
    $addSection(sectionStack, bundlesSection);
    if (canManageInventory) {
      repositoriesSection = new SectionStackSection_1('Repositories');
      repoTree = new ContentRepositoryTreeView_0;
      $addItemJS(repositoriesSection, $getOrCreateJsObj_0(repoTree));
      $addSection(sectionStack, repositoriesSection);
    }
    $addMember(this.this$0, sectionStack);
    this.this$0.contentCanvas = new VLayout_0;
    $setAttribute_24(this.this$0.contentCanvas, 'width', '100%', true);
    $setAttribute_24(this.this$0.contentCanvas, 'height', '100%', true);
    $addMember(this.this$0, this.this$0.contentCanvas);
  }
  this.val$viewPath.refresh && $invalidateCache_0(this.this$0.bundleTreeView);
  $selectPath(this.this$0.bundleTreeView, this.val$viewPath);
  if ($isEnd(this.val$viewPath)) {
    if (!this.this$0.currentNextPath && !!this.this$0.bundlesListView) {
      $refresh(this.this$0.bundlesListView, false);
    }
     else {
      this.this$0.currentNextPath = null;
      this.this$0.bundlesListView = new BundlesListView_1(permissions);
      $setContent_0(this.this$0, this.this$0.bundlesListView);
    }
  }
   else {
    if ($equals_43($getNext(this.val$viewPath), this.this$0.currentNextPath)) {
      $renderView_4(this.this$0.bundleView, $next_6(this.val$viewPath));
    }
     else {
      this.this$0.currentNextPath = $getNext(this.val$viewPath);
      this.this$0.bundleView = new BundleView_0(permissions);
      $setContent_0(this.this$0, this.this$0.bundleView);
      $renderView_4(this.this$0.bundleView, $next_6(this.val$viewPath));
    }
  }
}
;
_.this$0 = null;
_.val$viewPath = null;
function $setSubtitle(this$static, subtitle){
  this$static.subtitle = subtitle;
  !!this$static.view && $refreshTitleLabelContents(this$static.view);
}

function $setWindowTitle(this$static, windowTitle){
  this$static.windowTitle = windowTitle;
}

function $startWizard(this$static){
  this$static.view = new WizardView_0(this$static);
  $displayDialog(this$static.view);
}

defineSeed(2036, 1, {});
_.getCustomButtons = function getCustomButtons(step){
  return $clinit_Collections() , $clinit_Collections() , EMPTY_LIST;
}
;
_.getSubtitle = function getSubtitle(){
  return this.subtitle;
}
;
_.getTitle = function getTitle_2(){
  return this.title_0;
}
;
_.getWindowTitle = function getWindowTitle(){
  return this.windowTitle;
}
;
_.steps = null;
_.subtitle = '';
_.title_0 = '';
_.view = null;
_.windowTitle = '';
function $setAllBundleFilesStatus(this$static, allBundleFilesStatus){
  this$static.allBundleFilesStatus = allBundleFilesStatus;
}

function $setBundleVersion_0(this$static, bv){
  this$static.bundleVersion = bv;
  !!bv && $setSubtitle(this$static, bv.name_0 + ' (' + bv.version_0 + ')');
}

function $setRecipe(this$static, recipe){
  this$static.recipe = recipe;
}

defineSeed(2035, 2036, {});
_.cancel_0 = function cancel_0(){
  var bundleServer, bv;
  bv = this.bundleVersion;
  if (bv) {
    bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
    $deleteBundleVersion(bundleServer, bv.id, true, new AbstractBundleCreateWizard$1_0(bv));
  }
}
;
_.allBundleFilesStatus = null;
_.bundleVersion = null;
_.recipe = null;
function $onSuccess_132(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Canceled the creation of bundle [' + ($clinit_Wizard() , this$static.val$bv.name_0) + '], version = [' + this$static.val$bv.version_0 + ']', ($clinit_Message$Severity() , Info)));
}

function AbstractBundleCreateWizard$1_0(val$bv){
  this.val$bv = val$bv;
}

defineSeed(2037, 1, {}, AbstractBundleCreateWizard$1_0);
_.onFailure = function onFailure_136(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to fully cancel the creation of bundle [' + ($clinit_Wizard() , this.val$bv.name_0) + '], version = [' + this.val$bv.version_0 + '] - the bundle may still exist in the database'), caught);
}
;
_.onSuccess_0 = function onSuccess_136(result){
  $onSuccess_132(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$bv = null;
function BundleCreateWizard_0(){
  var steps;
  $setWindowTitle(this, ($clinit_Wizard() , 'Bundle  Creation Wizard'));
  this.title_0 = 'Create Bundle';
  steps = new ArrayList_0;
  $add_3(steps, new BundleUploadDistroFileStep_0(this));
  $add_3(steps, new BundleUploadDataStep_0(this));
  $add_3(steps, new BundleSummaryStep_0(this));
  this.steps = steps;
}

defineSeed(2038, 2035, {}, BundleCreateWizard_0);
defineSeed(2040, 1, makeCastMap([Q$WizardStep]));
_.isNextButtonEnabled = function isNextButtonEnabled(){
  return true;
}
;
_.nextPage_0 = function nextPage(){
  return true;
}
;
_.previousPage = function previousPage(){
  return true;
}
;
function BundleSummaryStep_0(bundleCreationWizard){
  this.wizard = bundleCreationWizard;
}

defineSeed(2039, 2040, makeCastMap([Q$WizardStep]), BundleSummaryStep_0);
_.getCanvas = function getCanvas_1(){
  var bundleTypeLabel, descriptionLabel, filename, filename$iterator, filesLabel, filesValueStr, form, nameLabel, versionLabel;
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 2):(form.config_0['numCols'] = 2 , undefined);
  $setMargin(form, valueOf_44(20));
  bundleTypeLabel = new StaticTextItem_2('bundleType', ($clinit_WizardStep() , 'Bundle Type'));
  $setAttribute_30(bundleTypeLabel, 'titleAlign', ($clinit_Alignment() , LEFT_0).value_0);
  $setAttribute_30(bundleTypeLabel, 'align', LEFT_0.value_0);
  $setWrap_1(bundleTypeLabel, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setValue_7(bundleTypeLabel, this.wizard.bundleVersion.bundle.bundleType.name_0);
  nameLabel = new StaticTextItem_2('name', 'Name');
  $setAttribute_30(nameLabel, 'titleAlign', LEFT_0.value_0);
  $setAttribute_30(nameLabel, 'align', LEFT_0.value_0);
  $setWrap_1(nameLabel, FALSE);
  $setValue_7(nameLabel, this.wizard.bundleVersion.bundle.name_0);
  versionLabel = new StaticTextItem_2('Version', 'Version');
  $setAttribute_30(versionLabel, 'titleAlign', LEFT_0.value_0);
  $setAttribute_30(versionLabel, 'titleAlign', LEFT_0.value_0);
  $setAttribute_30(versionLabel, 'align', LEFT_0.value_0);
  $setWrap_1(versionLabel, FALSE);
  $setValue_7(versionLabel, this.wizard.bundleVersion.version_0);
  descriptionLabel = new StaticTextItem_2('Description', 'Description');
  $setAttribute_30(descriptionLabel, 'titleAlign', LEFT_0.value_0);
  $setAttribute_30(descriptionLabel, 'align', LEFT_0.value_0);
  $setWrap_1(descriptionLabel, FALSE);
  $setValue_7(descriptionLabel, this.wizard.bundleVersion.bundle.description);
  filesLabel = new StaticTextItem_2('Files', 'Files');
  $setAttribute_30(filesLabel, 'titleVAlign', ($clinit_VerticalAlignment() , TOP_2).value_0);
  $setAttribute_30(filesLabel, 'titleAlign', LEFT_0.value_0);
  $setAttribute_30(filesLabel, 'align', LEFT_0.value_0);
  $setWrap_1(filesLabel, FALSE);
  filesValueStr = new StringBuilder_0;
  for (filename$iterator = $iterator($keySet(this.wizard.allBundleFilesStatus)); filename$iterator.val$outerIter.hasNext();) {
    filename = dynamicCast($next_1(filename$iterator), Q$String);
    $append_1(filesValueStr.data_0, filename + '<br/>\n');
  }
  $setValue_7(filesLabel, $toString_1(filesValueStr.data_0));
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [bundleTypeLabel, nameLabel, versionLabel, descriptionLabel, filesLabel]));
  return form;
}
;
_.getName = function getName_9(){
  return $clinit_WizardStep() , 'Summary';
}
;
_.nextPage_0 = function nextPage_0(){
  $clinit_CoreGUI();
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
  return true;
}
;
_.wizard = null;
function $handleUploadError(this$static, errorMessage, sendToMessageCenter){
  null != errorMessage?$showMessage(this$static.wizard.view, errorMessage):(errorMessage = '');
  sendToMessageCenter && $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2(($clinit_WizardStep() , 'Failed to upload bundle distribution file'), errorMessage, ($clinit_Message$Severity() , Error_2)));
}

function $isFinished(this$static){
  var needToUpload, uploadForm, uploadForm$iterator;
  if (!!this$static.noFilesNeedToBeUploaded && this$static.noFilesNeedToBeUploaded.value_0) {
    return true;
  }
  if (!this$static.wizard.allBundleFilesStatus) {
    return false;
  }
  needToUpload = false;
  for (uploadForm$iterator = new AbstractList$IteratorImpl_0(this$static.uploadForms); uploadForm$iterator.i < uploadForm$iterator.this$0_0.size_1();) {
    uploadForm = dynamicCast($next_0(uploadForm$iterator), Q$BundleFileUploadForm);
    if (uploadForm.uploadInProgress) {
      $handleUploadError(this$static, '[' + uploadForm.name_0 + '] ' + ($clinit_WizardStep() , 'Upload is in progress... This can take several minutes for large files'), false);
      needToUpload = true;
    }
     else if (!uploadForm.uploadResult) {
      needToUpload = true;
      $submitForm_1(uploadForm);
      $handleUploadError(this$static, uploadForm.uploadError, false);
    }
  }
  if (needToUpload) {
    return false;
  }
  if (this$static.wizard.allBundleFilesStatus.containsValue(($clinit_Boolean() , FALSE))) {
    return false;
  }
  return true;
}

function $prepareForm(this$static, mainLayout){
  var allFilesStatus, entry, entry$iterator, fileToBeUploaded, indivLayout, isAlreadyUploaded, label, nameLabel, uploadForm;
  allFilesStatus = this$static.wizard.allBundleFilesStatus;
  this$static.noFilesNeedToBeUploaded = ($clinit_Boolean() , TRUE);
  if (!!allFilesStatus && allFilesStatus.size_1() != 0) {
    for (entry$iterator = allFilesStatus.entrySet().iterator(); entry$iterator.hasNext();) {
      entry = dynamicCast(entry$iterator.next_0(), Q$Map$Entry);
      if (!dynamicCast(entry.getValue_1(), Q$Boolean).value_0) {
        this$static.noFilesNeedToBeUploaded = FALSE;
        break;
      }
    }
  }
  if (this$static.noFilesNeedToBeUploaded.value_0) {
    label = new HeaderLabel_0(($clinit_WizardStep() , 'No additional files need to be uploaded for this bundle'));
    $isCreated_1(label)?$setProperty_3(label, 'width', '100%'):(label.config_0['width'] = '100%' , undefined);
    $addMember(mainLayout, label);
    this$static.uploadForms = null;
    return;
  }
  this$static.noFilesNeedToBeUploaded = FALSE;
  this$static.uploadForms = new ArrayList_0;
  for (entry$iterator = allFilesStatus.entrySet().iterator(); entry$iterator.hasNext();) {
    entry = dynamicCast(entry$iterator.next_0(), Q$Map$Entry);
    fileToBeUploaded = dynamicCast(entry.getKey_0(), Q$String);
    isAlreadyUploaded = dynamicCast(entry.getValue_1(), Q$Boolean);
    indivLayout = new HLayout_0;
    $isCreated_1(indivLayout)?$setProperty_3(indivLayout, 'width', '100%'):(indivLayout.config_0['width'] = '100%' , undefined);
    $isCreated_1(indivLayout)?$setProperty_0(indivLayout, 'height', 1):(indivLayout.config_0['height'] = 1 , undefined);
    nameLabel = new Label_4(fileToBeUploaded + ': ');
    $isCreated_1(nameLabel)?$setProperty_3(nameLabel, 'width', '*'):(nameLabel.config_0['width'] = '*' , undefined);
    $setAttribute_24(nameLabel, 'align', ($clinit_Alignment() , RIGHT_0).value_0, true);
    $setAttribute_24(nameLabel, 'layoutAlign', ($clinit_VerticalAlignment() , CENTER_2).value_0, false);
    $addMember(indivLayout, nameLabel);
    uploadForm = new BundleFileUploadForm_0(this$static.wizard.bundleVersion, fileToBeUploaded, isAlreadyUploaded.value_0?TRUE:null);
    $isCreated_1(uploadForm)?$setProperty_3(uploadForm, 'width', '75%'):(uploadForm.config_0['width'] = '75%' , undefined);
    $addMember(indivLayout, uploadForm);
    $addFormHandler(uploadForm, new BundleUploadDataStep$2_0(this$static, allFilesStatus, uploadForm));
    $addFormSubmitFailedHandler(uploadForm, new BundleUploadDataStep$3_0(allFilesStatus, uploadForm));
    $add_3(this$static.uploadForms, uploadForm);
    $addMember(mainLayout, indivLayout);
  }
  return;
}

function BundleUploadDataStep_0(bundleCreationWizard){
  this.bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.wizard = bundleCreationWizard;
}

defineSeed(2041, 2040, makeCastMap([Q$WizardStep]), BundleUploadDataStep_0);
_.getCanvas = function getCanvas_2(){
  var mainLayout;
  mainLayout = new EnhancedVLayout_0;
  $setMargin(mainLayout, valueOf_44(20));
  $isCreated_1(mainLayout)?$setProperty_3(mainLayout, 'width', '100%'):(mainLayout.config_0['width'] = '100%' , undefined);
  $isCreated_1(mainLayout)?$setProperty_0(mainLayout, 'height', 10):(mainLayout.config_0['height'] = 10 , undefined);
  $getAllBundleVersionFilenames(this.bundleServer, this.wizard.bundleVersion.id, new BundleUploadDataStep$1_0(this, mainLayout));
  return mainLayout;
}
;
_.getName = function getName_10(){
  return $clinit_WizardStep() , 'Upload Bundle Files';
}
;
_.nextPage_0 = function nextPage_1(){
  $hide(this.wizard.view.messageBar);
  return $isFinished(this);
}
;
_.previousPage = function previousPage_0(){
  var uploadForm, uploadForm$iterator;
  $hide(this.wizard.view.messageBar);
  if (this.uploadForms) {
    for (uploadForm$iterator = new AbstractList$IteratorImpl_0(this.uploadForms); uploadForm$iterator.i < uploadForm$iterator.this$0_0.size_1();) {
      uploadForm = dynamicCast($next_0(uploadForm$iterator), Q$BundleFileUploadForm);
      if (uploadForm.uploadInProgress) {
        $handleUploadError(this, '[' + uploadForm.name_0 + '] ' + ($clinit_WizardStep() , 'Upload is in progress... This can take several minutes for large files'), false);
        return false;
      }
    }
  }
  return true;
}
;
_.noFilesNeedToBeUploaded = null;
_.uploadForms = null;
_.wizard = null;
function $onSuccess_133(this$static, result){
  $setAllBundleFilesStatus(this$static.this$0.wizard, result);
  $prepareForm(this$static.this$0, this$static.val$mainLayout);
}

function BundleUploadDataStep$1_0(this$0, val$mainLayout){
  this.this$0 = this$0;
  this.val$mainLayout = val$mainLayout;
}

defineSeed(2042, 1, {}, BundleUploadDataStep$1_0);
_.onFailure = function onFailure_137(caught){
  this.this$0.wizard.allBundleFilesStatus = null;
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Cannot obtain bundle file information from server'), caught);
}
;
_.onSuccess_0 = function onSuccess_137(result){
  $onSuccess_133(this, dynamicCast(result, Q$HashMap));
}
;
_.this$0 = null;
_.val$mainLayout = null;
function BundleUploadDataStep$2_0(this$0, val$allFilesStatus, val$uploadForm){
  this.this$0 = this$0;
  this.val$allFilesStatus = val$allFilesStatus;
  this.val$uploadForm = val$uploadForm;
}

defineSeed(2043, 1, makeCastMap([Q$DynamicFormHandler]), BundleUploadDataStep$2_0);
_.onSubmitComplete = function onSubmitComplete_0(event_0){
  var errorMessage, results;
  results = event_0.resultHtml;
  if (results.indexOf('Failed to upload bundle file') != -1) {
    this.val$allFilesStatus.put(this.val$uploadForm.name_0, ($clinit_Boolean() , FALSE));
    errorMessage = this.val$uploadForm.uploadError;
    $handleUploadError(this.this$0, errorMessage, true);
  }
   else {
    this.val$allFilesStatus.put(this.val$uploadForm.name_0, ($clinit_Boolean() , TRUE));
  }
}
;
_.this$0 = null;
_.val$allFilesStatus = null;
_.val$uploadForm = null;
function BundleUploadDataStep$3_0(val$allFilesStatus, val$uploadForm){
  this.val$allFilesStatus = val$allFilesStatus;
  this.val$uploadForm = val$uploadForm;
}

defineSeed(2044, 1, makeCastMap([Q$EventHandler, Q$FormSubmitFailedHandler]), BundleUploadDataStep$3_0);
_.onFormSubmitFailed = function onFormSubmitFailed(event_0){
  this.val$allFilesStatus.put(this.val$uploadForm.name_0, ($clinit_Boolean() , FALSE));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_WizardStep() , 'Failed to upload bundle file'), ($clinit_Message$Severity() , Error_2)));
}
;
_.val$allFilesStatus = null;
_.val$uploadForm = null;
function $handleUploadError_0(this$static, errorMessage, sendToMessageCenter){
  null != errorMessage?$showMessage(this$static.wizard.view, errorMessage):(errorMessage = '');
  sendToMessageCenter && $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2(($clinit_WizardStep() , 'Failed to upload bundle distribution file'), errorMessage, ($clinit_Message$Severity() , Error_2)));
}

function $processRecipe(this$static){
  var bundleServer, recipeString;
  recipeString = dynamicCast($getField_0(this$static.recipeForm, 'recipeText').getValue_1(), Q$String);
  if (recipeString == null || $trim(recipeString).length == 0) {
    $showMessage(this$static.wizard.view, ($clinit_WizardStep() , 'Please supply a valid recipe'));
    $setBundleVersion_0(this$static.wizard, null);
    $setDisabled(this$static.wizard.view.cancelButton, false);
    $setDisabled(this$static.wizard.view.nextButton, false);
    return;
  }
  $setRecipe(this$static.wizard, recipeString);
  bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  $createBundleVersionViaRecipe(bundleServer, this$static.wizard.recipe, new BundleUploadDistroFileStep$7_0(this$static));
}

function $processUpload(this$static){
  var bundleServer, bvId, criteria, errorMessage;
  if ($equals_2(($clinit_Boolean() , TRUE), this$static.uploadDistroForm.uploadResult)) {
    bvId = this$static.uploadDistroForm.bundleVersionId;
    criteria = new BundleVersionCriteria_0;
    $addFilterId(criteria, valueOf_44(bvId));
    criteria.fetchBundle = true;
    bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
    $findBundleVersionsByCriteria(bundleServer, criteria, new BundleUploadDistroFileStep$6_0(this$static));
  }
   else {
    errorMessage = this$static.uploadDistroForm.uploadError;
    $handleUploadError_0(this$static, errorMessage, true);
    $setBundleVersion_0(this$static.wizard, null);
    $setDisabled(this$static.wizard.view.cancelButton, false);
    $setDisabled(this$static.wizard.view.nextButton, false);
  }
}

function $processUrl(this$static){
  var bundleServer, urlString;
  urlString = dynamicCast($getValue_0(this$static.urlTextItem), Q$String);
  if (urlString == null || $trim(urlString).length == 0) {
    $showMessage(this$static.wizard.view, ($clinit_WizardStep() , 'Please enter a valid URL where the bundle distribution file can be downloaded from'));
    $setBundleVersion_0(this$static.wizard, null);
    $setDisabled(this$static.wizard.view.cancelButton, false);
    $setDisabled(this$static.wizard.view.nextButton, false);
    return;
  }
  bundleServer = dynamicCast(secure(getInstance_36(), 600000), Q$BundleGWTServiceAsync);
  $createBundleVersionViaURL(bundleServer, urlString, new BundleUploadDistroFileStep$5_0(this$static));
}

function $setButtonsDisableMode(this$static){
  $setDisabled(this$static.wizard.view.cancelButton, false);
  $setDisabled(this$static.wizard.view.nextButton, false);
}

function BundleUploadDistroFileStep_0(bundleCreationWizard){
  this.URL_OPTION = ($clinit_WizardStep() , 'URL');
  this.UPLOAD_OPTION = 'Upload';
  this.RECIPE_OPTION = 'Recipe';
  this.wizard = bundleCreationWizard;
}

defineSeed(2045, 2040, makeCastMap([Q$WizardStep]), BundleUploadDistroFileStep_0);
_.getCanvas = function getCanvas_3(){
  var radioItems, urlForm, showUpload, upload, textFileRetrieverForm, recipe;
  if (!this.mainCanvasForm) {
    radioItems = new LinkedHashMap_0;
    $put_1(radioItems, this.URL_OPTION, (this.urlTextItem = new TextItem_3('url', this.URL_OPTION) , $setRequired(this.urlTextItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , $setShowTitle_0(this.urlTextItem, FALSE) , $setWidth_3(this.urlTextItem, 400) , urlForm = new DynamicForm_0 , $setPadding(urlForm, valueOf_44(20)) , $isCreated_1(urlForm)?$setProperty_3(urlForm, 'width', '100%'):(urlForm.config_0['width'] = '100%' , undefined) , urlForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.urlTextItem])) , urlForm));
    $put_1(radioItems, this.UPLOAD_OPTION, (this.uploadDistroForm = new BundleDistributionFileUploadForm_0 , $setPadding(this.uploadDistroForm, valueOf_44(20)) , $setWidth(this.uploadDistroForm, 400) , $addFormHandler(this.uploadDistroForm, new BundleUploadDistroFileStep$1_0(this)) , $addFormSubmitFailedHandler(this.uploadDistroForm, new BundleUploadDistroFileStep$2_0) , this.uploadDistroForm));
    $put_1(radioItems, this.RECIPE_OPTION, (this.recipeForm = new DynamicCallbackForm_0('recipeForm') , $setMargin(this.recipeForm, valueOf_44(20)) , $setShowInlineErrors(this.recipeForm, FALSE) , showUpload = new ButtonItem_1('recipeUploadLink', ($clinit_WizardStep() , 'Click to load a recipe file')) , $isCreated_2(showUpload)?$setProperty_8(showUpload, 'icon', 'global/upload.png'):(showUpload.jsObj['icon'] = 'global/upload.png' , undefined) , upload = new CanvasItem_1('recipeUploadCanvas') , upload.setShowTitle(FALSE) , $setVisible(upload, FALSE) , textFileRetrieverForm = new TextFileRetrieverForm_0 , $setAttribute_28(upload, 'canvas', !textFileRetrieverForm?null:$getOrCreateJsObj_0(textFileRetrieverForm)) , $addClickHandler_1(showUpload, new BundleUploadDistroFileStep$3_0(this, showUpload, upload)) , recipe = new TextAreaItem_1 , $setShowTitle_0(recipe, FALSE) , $setRequired(recipe, FALSE) , $isCreated_2(recipe)?$setProperty_6(recipe, 'colSpan', 4):(recipe.jsObj['colSpan'] = 4 , undefined) , $isCreated_2(recipe)?$setProperty_6(recipe, 'width', 400):(recipe.jsObj['width'] = 400 , undefined) , $isCreated_2(recipe)?$setProperty_6(recipe, 'height', 150):(recipe.jsObj['height'] = 150 , undefined) , $addFormHandler(textFileRetrieverForm, new BundleUploadDistroFileStep$4_0(this, recipe, textFileRetrieverForm, showUpload, upload)) , $setFields_0(this.recipeForm, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [showUpload, upload, recipe])) , this.recipeForm));
    this.mainCanvasForm = new BundleUploadDistroFileStep$RadioDynamicForm_0(this);
    this.radioGroup = new RadioGroupWithComponentsItem_0('bundleDistRadioGroup', 'Bundle Distribution', radioItems, this.mainCanvasForm);
    $setShowTitle_0(this.radioGroup, FALSE);
    $setFields_0(this.mainCanvasForm, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.radioGroup]));
  }
  !!this.wizard.bundleVersion && $setDisabled(this.mainCanvasForm, true);
  return this.mainCanvasForm;
}
;
_.getName = function getName_11(){
  return $clinit_WizardStep() , 'Provide a Bundle  Distribution';
}
;
_.nextPage_0 = function nextPage_2(){
  var selected;
  $hide(this.wizard.view.messageBar);
  if (this.uploadDistroForm.uploadInProgress) {
    $handleUploadError_0(this, ($clinit_WizardStep() , 'Upload is in progress... This can take several minutes for large files'), false);
    return false;
  }
  if (!this.wizard.bundleVersion) {
    selected = this.radioGroup.selected;
    if ($equals_6(this.URL_OPTION, selected)) {
      $processUrl(this);
    }
     else if ($equals_6(this.UPLOAD_OPTION, selected)) {
      $submitForm_1(this.uploadDistroForm);
      $handleUploadError_0(this, this.uploadDistroForm.uploadError, false);
    }
     else if ($equals_6(this.RECIPE_OPTION, selected)) {
      $processRecipe(this);
    }
     else {
      $showMessage(this.wizard.view, ($clinit_WizardStep() , 'You must choose one option in order to create a bundle!'));
      return false;
    }
    return false;
  }
   else {
    return true;
  }
}
;
_.mainCanvasForm = null;
_.radioGroup = null;
_.recipeForm = null;
_.uploadDistroForm = null;
_.urlTextItem = null;
_.wizard = null;
function BundleUploadDistroFileStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2046, 1, makeCastMap([Q$DynamicFormHandler]), BundleUploadDistroFileStep$1_0);
_.onSubmitComplete = function onSubmitComplete_1(event_0){
  $processUpload(this.this$0);
}
;
_.this$0 = null;
function BundleUploadDistroFileStep$2_0(){
}

defineSeed(2047, 1, makeCastMap([Q$EventHandler, Q$FormSubmitFailedHandler]), BundleUploadDistroFileStep$2_0);
_.onFormSubmitFailed = function onFormSubmitFailed_0(event_0){
  return;
}
;
function BundleUploadDistroFileStep$3_0(this$0, val$showUpload, val$upload){
  this.this$0 = this$0;
  this.val$showUpload = val$showUpload;
  this.val$upload = val$upload;
}

defineSeed(2048, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), BundleUploadDistroFileStep$3_0);
_.onClick_0 = function onClick_37(clickEvent){
  $hide_0(this.val$showUpload);
  $show_0(this.val$upload);
  $markForRedraw(this.this$0.recipeForm);
}
;
_.this$0 = null;
_.val$showUpload = null;
_.val$upload = null;
function $htmlUnescape(escapedHtml){
  var e;
  e = $createElement($doc, 'div');
  $setInnerHTML(e, escapedHtml);
  return e.innerText;
}

function BundleUploadDistroFileStep$4_0(this$0, val$recipe, val$textFileRetrieverForm, val$showUpload, val$upload){
  this.this$0 = this$0;
  this.val$recipe = val$recipe;
  this.val$textFileRetrieverForm = val$textFileRetrieverForm;
  this.val$showUpload = val$showUpload;
  this.val$upload = val$upload;
}

defineSeed(2049, 1, makeCastMap([Q$DynamicFormHandler]), BundleUploadDistroFileStep$4_0);
_.onSubmitComplete = function onSubmitComplete_2(event_0){
  $setRecipe(this.this$0.wizard, $htmlUnescape(event_0.resultHtml));
  $setValue_7(this.val$recipe, $htmlUnescape(event_0.resultHtml));
  $retrievalStatus(this.val$textFileRetrieverForm);
  $show_0(this.val$showUpload);
  $hide_0(this.val$upload);
  $markForRedraw(this.this$0.recipeForm);
}
;
_.this$0 = null;
_.val$recipe = null;
_.val$showUpload = null;
_.val$textFileRetrieverForm = null;
_.val$upload = null;
function $onFailure_15(this$static, caught){
  var message;
  message = escapeHtml(caught.getMessage());
  $showMessage(this$static.this$0.wizard.view, message);
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to create the bundle'), caught);
  $setBundleVersion_0(this$static.this$0.wizard, null);
  $setButtonsDisableMode(this$static.this$0);
}

function $onSuccess_134(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully created a bundle named [' + ($clinit_WizardStep() , result.name_0) + '] with a version of [' + result.version_0 + ']', ($clinit_Message$Severity() , Info)));
  $setBundleVersion_0(this$static.this$0.wizard, result);
  $setButtonsDisableMode(this$static.this$0);
  $incrementStep(this$static.this$0.wizard.view);
}

function BundleUploadDistroFileStep$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2050, 1, {}, BundleUploadDistroFileStep$5_0);
_.onFailure = function onFailure_138(caught){
  $onFailure_15(this, caught);
}
;
_.onSuccess_0 = function onSuccess_138(result){
  $onSuccess_134(this, dynamicCast(result, Q$BundleVersion));
}
;
_.this$0 = null;
function $onSuccess_135(this$static, result){
  var bv;
  bv = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$BundleVersion);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully created a bundle named [' + ($clinit_WizardStep() , bv.name_0) + '] with a version of [' + bv.version_0 + ']', ($clinit_Message$Severity() , Info)));
  $setBundleVersion_0(this$static.this$0.wizard, bv);
  $setButtonsDisableMode(this$static.this$0);
  $incrementStep(this$static.this$0.wizard.view);
}

function BundleUploadDistroFileStep$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2051, 1, {}, BundleUploadDistroFileStep$6_0);
_.onFailure = function onFailure_139(caught){
  $showMessage(this.this$0.wizard.view, caught.getMessage());
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to create the bundle'), caught);
  $setBundleVersion_0(this.this$0.wizard, null);
  $setButtonsDisableMode(this.this$0);
}
;
_.onSuccess_0 = function onSuccess_139(result){
  $onSuccess_135(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $onFailure_16(this$static, caught){
  $showMessage(this$static.this$0.wizard.view, caught.getMessage());
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to create the bundle'), caught);
  $setBundleVersion_0(this$static.this$0.wizard, null);
  this$static.this$0.wizard.recipe = '';
  $setButtonsDisableMode(this$static.this$0);
}

function $onSuccess_136(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully created a bundle named [' + ($clinit_WizardStep() , result.name_0) + '] with a version of [' + result.version_0 + ']', ($clinit_Message$Severity() , Info)));
  $setBundleVersion_0(this$static.this$0.wizard, result);
  $setButtonsDisableMode(this$static.this$0);
  $incrementStep(this$static.this$0.wizard.view);
}

function BundleUploadDistroFileStep$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2052, 1, {}, BundleUploadDistroFileStep$7_0);
_.onFailure = function onFailure_140(caught){
  $onFailure_16(this, caught);
}
;
_.onSuccess_0 = function onSuccess_140(result){
  $onSuccess_136(this, dynamicCast(result, Q$BundleVersion));
}
;
_.this$0 = null;
function BundleUploadDistroFileStep$RadioDynamicForm_0(this$0){
  $clinit_BaseWidget();
  this.this$0 = this$0;
  DynamicForm_0.call(this);
}

defineSeed(2053, 478, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), BundleUploadDistroFileStep$RadioDynamicForm_0);
_.destroy_0 = function destroy_7(){
  $destroyComponents(this.this$0.radioGroup);
  $destroy(this);
}
;
_.this$0 = null;
function $setBundleId(this$static, bundleId){
  this$static.bundleId = bundleId;
}

function $setBundleVersion_1(this$static, bundleVersion){
  this$static.bundleVersion = bundleVersion;
}

function $setCleanDeployment(this$static, isCleanDeployment){
  this$static.isCleanDeployment = isCleanDeployment;
}

function $setDestination(this$static, destination){
  this$static.destination = destination;
}

function $setLiveDeployment(this$static, liveDeployment){
  this$static.liveDeployment = liveDeployment;
}

function $setNewDeployment(this$static, newDeployment){
  this$static.newDeployment = newDeployment;
}

function $setNewDeploymentConfig(this$static, newDeploymentConfig){
  this$static.newDeploymentConfig = newDeploymentConfig;
}

function $setNewDeploymentDescription(this$static, newDeploymentDescription){
  this$static.newDeploymentDescription = newDeploymentDescription;
}

defineSeed(2054, 2036, {});
_.bundleId = null;
_.bundleVersion = null;
_.destination = null;
_.isCleanDeployment = false;
_.isNewDestination = false;
_.liveDeployment = null;
_.newDeployment = null;
_.newDeploymentConfig = null;
_.newDeploymentDescription = null;
function $deleteNewDestination(this$static){
  var bundleServer;
  if (this$static.isNewDestination && !!this$static.destination) {
    bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
    $deleteBundleDestination(bundleServer, this$static.destination.id, new BundleDeployWizard$2_0);
  }
}

function $init_4(this$static){
  var steps;
  $setWindowTitle(this$static, ($clinit_Wizard() , 'Bundle Deployment Wizard'));
  this$static.title_0 = 'Bundle Deployment';
  steps = new ArrayList_0;
  this$static.steps = steps;
  return steps;
}

function BundleDeployWizard_0(){
  var steps;
  steps = $init_4(this);
  $add_3(steps, new SelectBundleStep_0(this));
  $add_3(steps, new GetDestinationStep_0(this));
  $add_3(steps, new SelectBundleVersionStep_0(this));
  $add_3(steps, new GetDeploymentConfigStep_0(this));
  $add_3(steps, new GetDeploymentInfoStep_0(this));
  $add_3(steps, new DeployStep_0(this));
}

function BundleDeployWizard_1(bundleId){
  var steps;
  $setBundleId(this, valueOf_44(bundleId));
  steps = $init_4(this);
  $add_3(steps, new GetDestinationStep_0(this));
  $add_3(steps, new SelectBundleVersionStep_0(this));
  $add_3(steps, new GetDeploymentConfigStep_0(this));
  $add_3(steps, new GetDeploymentInfoStep_0(this));
  $add_3(steps, new DeployStep_0(this));
}

function BundleDeployWizard_2(destination){
  var steps;
  if (!destination) {
    throw new IllegalArgumentException_1('destination is null');
  }
  $setBundleId(this, valueOf_44(destination.bundle.id));
  this.destination = destination;
  steps = $init_4(this);
  $add_3(steps, new SelectBundleVersionStep_0(this));
  $add_3(steps, new GetDeploymentConfigStep_0(this));
  $add_3(steps, new GetDeploymentInfoStep_0(this));
  $add_3(steps, new DeployStep_0(this));
}

defineSeed(2055, 2054, {}, BundleDeployWizard_0, BundleDeployWizard_1, BundleDeployWizard_2);
_.cancel_0 = function cancel_1(){
  var bundleServer, c;
  if (!!this.newDeployment && 0 < this.newDeployment.id) {
    bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
    c = new BundleDeploymentCriteria_0;
    $addFilterId(c, valueOf_44(this.newDeployment.id));
    c.fetchResourceDeployments = true;
    $findBundleDeploymentsByCriteria(bundleServer, c, new BundleDeployWizard$1_0(this));
  }
   else {
    $deleteNewDestination(this);
  }
}
;
function $onSuccess_137(this$static, newDeploymentList){
  var bundleServer, hasNoResourceDeployments, isFailedToLaunch, newDeployment;
  if (newDeploymentList.size_0 != 0) {
    newDeployment = dynamicCast((checkIndex(0, newDeploymentList.size_0) , newDeploymentList.array[0]), Q$BundleDeployment);
    isFailedToLaunch = ($clinit_BundleDeploymentStatus() , FAILURE_0) == newDeployment.status_0 || PENDING == newDeployment.status_0;
    hasNoResourceDeployments = !newDeployment.resourceDeployments || newDeployment.resourceDeployments.isEmpty_0();
    if (isFailedToLaunch && hasNoResourceDeployments) {
      bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
      $deleteBundleDeployment(bundleServer, newDeployment.id, new BundleDeployWizard$1$1_0(this$static));
    }
  }
}

function BundleDeployWizard$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2056, 1, {}, BundleDeployWizard$1_0);
_.onFailure = function onFailure_141(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to delete new deployment on Cancel'), caught);
  $deleteNewDestination(this.this$0);
}
;
_.onSuccess_0 = function onSuccess_141(newDeploymentList){
  $onSuccess_137(this, dynamicCast(newDeploymentList, Q$PageList));
}
;
_.this$0 = null;
function $onSuccess_138(this$static){
  $deleteNewDestination(this$static.this$1.this$0);
}

function BundleDeployWizard$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2057, 1, {}, BundleDeployWizard$1$1_0);
_.onFailure = function onFailure_142(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to delete new deployment on Cancel'), caught);
}
;
_.onSuccess_0 = function onSuccess_142(voidReturn){
  $onSuccess_138(this, throwClassCastExceptionUnlessNull(voidReturn));
}
;
_.this$1 = null;
function BundleDeployWizard$2_0(){
}

defineSeed(2058, 1, {}, BundleDeployWizard$2_0);
_.onFailure = function onFailure_143(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to delete new destination on Cancel'), caught);
}
;
_.onSuccess_0 = function onSuccess_143(voidReturn){
  throwClassCastExceptionUnlessNull(voidReturn);
  $clinit_CoreGUI();
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}
;
function DeployStep_0(wizard){
  this.bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.wizard = wizard;
}

defineSeed(2059, 2040, makeCastMap([Q$WizardStep]), DeployStep_0);
_.getCanvas = function getCanvas_4(){
  var deployingImage, deployingMessage;
  if (!this.canvas_0) {
    this.canvas_0 = new EnhancedVLayout_0;
    $setAttribute_24(this.canvas_0, 'width', '100%', true);
    $setAttribute_24(this.canvas_0, 'height', '100%', true);
    $setAttribute_24(this.canvas_0, 'align', ($clinit_Alignment() , CENTER_0).value_0, true);
    deployingImage = new Img_1('ajax-loader.gif');
    $setAttribute_24(deployingImage, 'layoutAlign', CENTER_0.value_0, false);
    $isCreated_1(deployingImage)?$setProperty_0(deployingImage, 'width', 50):(deployingImage.config_0['width'] = 50 , undefined);
    $isCreated_1(deployingImage)?$setProperty_0(deployingImage, 'height', 15):(deployingImage.config_0['height'] = 15 , undefined);
    deployingMessage = new Label_1(($clinit_WizardStep() , 'Deploying...'));
    $setHorizontalAlignment(deployingMessage, ($clinit_HasHorizontalAlignment() , ALIGN_CENTER));
    $addMember(this.canvas_0, deployingImage);
    $addMember(this.canvas_0, new WidgetCanvas_0(deployingMessage));
    $createBundleDeployment(this.bundleServer, this.wizard.bundleVersion.id, this.wizard.destination.id, this.wizard.newDeploymentDescription, this.wizard.newDeploymentConfig, new DeployStep$1_0(this, deployingImage, deployingMessage));
  }
  return this.canvas_0;
}
;
_.getName = function getName_12(){
  return $clinit_WizardStep() , 'Deploy Bundle to Destination Platforms';
}
;
_.nextPage_0 = function nextPage_3(){
  return true;
}
;
_.canvas_0 = null;
_.wizard = null;
function $onFailure_17(this$static, caught){
  var errMsg, msg;
  this$static.val$deployingImage.setSrc('/images/status_error.gif');
  $setText(this$static.val$deployingMessage, ($clinit_WizardStep() , 'Failed to Create Deployment!'));
  errMsg = 'Failed to create deployment: ' + ($clinit_ErrorHandler() , getAllMessages(caught, false, null));
  $showMessage(this$static.this$0.wizard.view, errMsg);
  msg = new Message_2('Failed to Create Deployment!', errMsg, ($clinit_Message$Severity() , Error_2));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
}

function $onSuccess_139(this$static, result){
  this$static.val$deployingImage.setSrc('/images/status_complete.gif');
  $setText(this$static.val$deployingMessage, ($clinit_WizardStep() , 'Created Deployment...'));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('You have created the deployment [' + result.name_0 + ']', 'You have created the deployment [' + result.name_0 + '] with the description [' + result.description + ']', ($clinit_Message$Severity() , Info)));
  $setNewDeployment(this$static.this$0.wizard, result);
  $scheduleBundleDeployment(this$static.this$0.bundleServer, this$static.this$0.wizard.newDeployment.id, this$static.this$0.wizard.isCleanDeployment, new DeployStep$1$1_0(this$static, this$static.val$deployingImage, this$static.val$deployingMessage));
}

function DeployStep$1_0(this$0, val$deployingImage, val$deployingMessage){
  this.this$0 = this$0;
  this.val$deployingImage = val$deployingImage;
  this.val$deployingMessage = val$deployingMessage;
}

defineSeed(2060, 1, {}, DeployStep$1_0);
_.onFailure = function onFailure_144(caught){
  $onFailure_17(this, caught);
}
;
_.onSuccess_0 = function onSuccess_144(result){
  $onSuccess_139(this, dynamicCast(result, Q$BundleDeployment));
}
;
_.this$0 = null;
_.val$deployingImage = null;
_.val$deployingMessage = null;
function $onFailure_18(this$static, caught){
  var errMsg, msg;
  this$static.val$deployingImage.setSrc('/images/status_error.gif');
  $setText(this$static.val$deployingMessage, ($clinit_WizardStep() , 'Failed to Schedule Deployment!'));
  errMsg = 'Failed to schedule deployment: ' + ($clinit_ErrorHandler() , getAllMessages(caught, false, null));
  $showMessage(this$static.this$1.this$0.wizard.view, errMsg);
  msg = new Message_2('Failed to Schedule Deployment!', errMsg, ($clinit_Message$Severity() , Error_2));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
}

function $onSuccess_140(this$static, result){
  this$static.val$deployingImage.setSrc('/images/status_complete.gif');
  $setText(this$static.val$deployingMessage, ($clinit_WizardStep() , 'Bundle Deployment Scheduled!'));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('You have scheduled the bundle deployment', 'You have scheduled the bundle deployment [' + result.name_0 + '] to the destination group [' + result.destination.group.name_0 + ']', ($clinit_Message$Severity() , Info)));
  $hide(this$static.this$1.this$0.wizard.view.messageBar);
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
  $setNewDeployment(this$static.this$1.this$0.wizard, result);
}

function DeployStep$1$1_0(this$1, val$deployingImage, val$deployingMessage){
  this.this$1 = this$1;
  this.val$deployingImage = val$deployingImage;
  this.val$deployingMessage = val$deployingMessage;
}

defineSeed(2061, 1, {}, DeployStep$1$1_0);
_.onFailure = function onFailure_145(caught){
  $onFailure_18(this, caught);
}
;
_.onSuccess_0 = function onSuccess_145(result){
  $onSuccess_140(this, dynamicCast(result, Q$BundleDeployment));
}
;
_.this$1 = null;
_.val$deployingImage = null;
_.val$deployingMessage = null;
function $getNormalizedLiveConfig(this$static, configDef){
  var config;
  config = this$static.wizard.liveDeployment.configuration;
  if (!config) {
    config = new Configuration_0;
  }
   else {
    config = $deepCopy(config, false);
    normalizeConfiguration(config, configDef);
  }
  return config;
}

function GetDeploymentConfigStep_0(wizard){
  this.wizard = wizard;
}

defineSeed(2062, 2040, makeCastMap([Q$WizardStep]), GetDeploymentConfigStep_0);
_.getCanvas = function getCanvas_5(){
  var configDef, defaultTemplate, label, liveConfig, liveDeployment, startingConfig, useLiveConfig;
  if (!this.editor) {
    configDef = this.wizard.bundleVersion.configurationDefinition;
    if ((!configDef.propertyDefinitions && (configDef.propertyDefinitions = new LinkedHashMap_0) , configDef.propertyDefinitions).isEmpty_0()) {
      $setNewDeploymentConfig(this.wizard, new Configuration_0);
      label = new HTMLFlow_1(($clinit_WizardStep() , 'No configuration needed for this bundle version.'));
      $isCreated_1(label)?$setProperty_3(label, 'width', '100%'):(label.config_0['width'] = '100%' , undefined);
      $isCreated_1(label)?$setProperty_0(label, 'height', 50):(label.config_0['height'] = 50 , undefined);
      setStylePrimaryName($getElement(label), 'HeaderLabel');
      $isCreated_1(label)?$setProperty_3(label, 'styleName', 'HeaderLabel'):(label.config_0['styleName'] = 'HeaderLabel' , undefined);
      this.editor = new VLayout_0;
      this.editor.addMember_0(label);
    }
     else {
      liveDeployment = this.wizard.liveDeployment;
      useLiveConfig = false;
      if (liveDeployment) {
        liveConfig = liveDeployment.configuration;
        !!liveConfig && (useLiveConfig = !liveConfig.properties.isEmpty_0());
      }
      if (useLiveConfig) {
        startingConfig = $getNormalizedLiveConfig(this, configDef);
      }
       else {
        defaultTemplate = dynamicCast((!configDef.templates && (configDef.templates = new LinkedHashMap_0) , configDef.templates).get_2('default'), Q$ConfigurationTemplate);
        startingConfig = defaultTemplate?$deepCopy(defaultTemplate.configuration, false):new Configuration_0;
      }
      this.editor = new ConfigurationEditor_1(configDef, startingConfig);
    }
  }
  return this.editor;
}
;
_.getName = function getName_13(){
  return $clinit_WizardStep() , 'Set Deployment Configuration';
}
;
_.nextPage_0 = function nextPage_4(){
  !this.wizard.newDeploymentConfig && $setNewDeploymentConfig(this.wizard, dynamicCast(this.editor, Q$ConfigurationEditor).configuration);
  return true;
}
;
_.editor = null;
_.wizard = null;
function GetDeploymentInfoStep_0(wizard){
  this.bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.wizard = wizard;
}

defineSeed(2063, 2040, makeCastMap([Q$WizardStep]), GetDeploymentInfoStep_0);
_.getCanvas = function getCanvas_6(){
  if (!this.form_0) {
    this.form_0 = new DynamicForm_0;
    $setAttribute_24(this.form_0, 'width', '100%', true);
    $setNumCols(this.form_0, 2);
    $setColWidths(this.form_0, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['50%', '*']));
    $getBundleDeploymentName(this.bundleServer, this.wizard.destination.id, this.wizard.bundleVersion.id, -1, new GetDeploymentInfoStep$1_0(this));
  }
  return this.form_0;
}
;
_.getName = function getName_14(){
  return $clinit_WizardStep() , 'Provide Deployment Information';
}
;
_.nextPage_0 = function nextPage_5(){
  return this.form_0.validate_0();
}
;
_.form_0 = null;
_.wizard = null;
function $onSuccess_141(this$static, result){
  var cleanDeploymentCBItem, descriptionTextAreaItem, nameTextItem;
  nameTextItem = new StaticTextItem_2('name', ($clinit_WizardStep() , 'Deployment Name'));
  $isCreated_2(nameTextItem)?$setProperty_6(nameTextItem, 'width', 300):(nameTextItem.jsObj['width'] = 300 , undefined);
  $setSubtitle(this$static.this$0.wizard, result);
  $setValue_7(nameTextItem, result);
  descriptionTextAreaItem = new TextAreaItem_2('description', 'Deployment Description');
  $isCreated_2(descriptionTextAreaItem)?$setProperty_6(descriptionTextAreaItem, 'width', 300):(descriptionTextAreaItem.jsObj['width'] = 300 , undefined);
  $addChangedHandler(descriptionTextAreaItem, new GetDeploymentInfoStep$1$1_0(this$static));
  cleanDeploymentCBItem = new CheckboxItem_2('cleanDeployment', 'Clean Deployment? (wipe deploy directory on destination platform)');
  $setValue_9(cleanDeploymentCBItem, this$static.this$0.wizard.isCleanDeployment);
  $addChangedHandler(cleanDeploymentCBItem, new GetDeploymentInfoStep$1$2_0(this$static));
  this$static.this$0.form_0.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [nameTextItem, descriptionTextAreaItem, cleanDeploymentCBItem]));
}

function GetDeploymentInfoStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2064, 1, {}, GetDeploymentInfoStep$1_0);
_.onFailure = function onFailure_146(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to get deployment name.'), caught);
}
;
_.onSuccess_0 = function onSuccess_146(result){
  $onSuccess_141(this, dynamicCast(result, Q$String));
}
;
_.this$0 = null;
function GetDeploymentInfoStep$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2065, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GetDeploymentInfoStep$1$1_0);
_.onChanged = function onChanged_19(event_0){
  var value;
  value = $getValue_2(event_0);
  value == null && (value = '');
  $setNewDeploymentDescription(this.this$1.this$0.wizard, toString__devirtual$(value));
}
;
_.this$1 = null;
function GetDeploymentInfoStep$1$2_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2066, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GetDeploymentInfoStep$1$2_0);
_.onChanged = function onChanged_20(event_0){
  $setCleanDeployment(this.this$1.this$0.wizard, dynamicCast($getValue_2(event_0), Q$Boolean).value_0);
}
;
_.this$1 = null;
function $createDestination(this$static){
  var selectedGroup;
  selectedGroup = dynamicCast($getValue(this$static.valForm, 'group'), Q$Integer).value_0;
  $createBundleDestination(this$static.bundleServer, this$static.wizard.bundleId.value_0, this$static.destination.name_0, this$static.destination.description, this$static.destination.destinationBaseDirectoryName, this$static.destination.deployDir, selectedGroup, new GetDestinationStep$8_0(this$static));
}

function $groupSelectionChanged(this$static, selectedGroupId){
  this$static.destination.destinationBaseDirectoryName = null;
  $clearValue_0(this$static.destBaseDirItem);
  $setValueMap_0(this$static.destBaseDirItem, null);
  selectedGroupId?$getResourceTypeBundleConfiguration_0(this$static.bundleServer, selectedGroupId.value_0, new GetDestinationStep$9_0(this$static)):$setDisabled_2(this$static.destBaseDirItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
}

function GetDestinationStep_0(wizard){
  this.bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.valForm = new DynamicForm_0;
  this.destination = new BundleDestination_0;
  this.wizard = wizard;
}

defineSeed(2067, 2040, makeCastMap([Q$WizardStep]), GetDestinationStep_0);
_.getCanvas = function getCanvas_7(){
  var ci1, deployDirTextItem, descriptionTextAreaItem, nameTextItem, newGroupIcon, validator;
  if (!this.form_0) {
    this.form_0 = new EnhancedVLayout_0;
    $setAttribute_24(this.valForm, 'width', '100%', true);
    $setNumCols(this.valForm, 2);
    $setColWidths(this.valForm, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['50%', '*']));
    nameTextItem = new TextItem_3('name', ($clinit_WizardStep() , 'Destination Name'));
    $isCreated_2(nameTextItem)?$setProperty_6(nameTextItem, 'width', 300):(nameTextItem.jsObj['width'] = 300 , undefined);
    $setRequired(nameTextItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $addChangedHandler(nameTextItem, new GetDestinationStep$1_0(this));
    addContextualHelp(nameTextItem, 'The name of the destination, which will identify a particular group of resources and the destination directory on those resources for a particular bundle.', null);
    descriptionTextAreaItem = new TextAreaItem_2('description', 'Destination Description');
    $isCreated_2(descriptionTextAreaItem)?$setProperty_6(descriptionTextAreaItem, 'width', 300):(descriptionTextAreaItem.jsObj['width'] = 300 , undefined);
    $addChangedHandler(descriptionTextAreaItem, new GetDestinationStep$2_0(this));
    deployDirTextItem = new TextItem_3('deployDir', 'Deployment Directory');
    $isCreated_2(deployDirTextItem)?$setProperty_6(deployDirTextItem, 'width', 300):(deployDirTextItem.jsObj['width'] = 300 , undefined);
    $setRequired(deployDirTextItem, TRUE);
    $addChangedHandler(deployDirTextItem, new GetDestinationStep$3_0(this));
    addContextualHelp(deployDirTextItem, 'The directory where the bundle will be deployed. This directory will be the same for all deployments on all resources but it is relative to the destination base directory location. This means that the absolute directory may have a different path on the different target resources depending on where the base location is on all the different target resources.', null);
    this.destBaseDirItem = new RadioGroupItem_2('destBaseDir', 'Base Location');
    $setWidth_1(this.destBaseDirItem, 300);
    $setRequired(this.destBaseDirItem, TRUE);
    $setDisabled_2(this.destBaseDirItem, TRUE);
    $addChangedHandler(this.destBaseDirItem, new GetDestinationStep$4_0(this));
    this.selector = new SingleCompatibleResourceGroupSelector_0('Resource Group');
    $setWidth_3(this.selector, 300);
    $setRequired(this.selector, TRUE);
    validator = new IsIntegerValidator_0;
    validator.jsObj['errorMessage'] = 'You must select a valid resource group from the drop down';
    $setValidators(this.selector, initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [validator]));
    $addChangedHandler(this.selector, new GetDestinationStep$5_0(this));
    newGroupIcon = new FormItemIcon_0;
    newGroupIcon.jsObj['src'] = '[SKIN]/actions/add.png';
    $addIconClickHandler(this.selector, new GetDestinationStep$6_0(this, newGroupIcon));
    addContextualHelp(this.selector, 'The group whose members will be the destination targets for all bundle deployments. Only compatible groups that contain resources that support bundle deployments are selectable.', initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [newGroupIcon]));
    this.valForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [nameTextItem, descriptionTextAreaItem, this.selector, this.destBaseDirItem, deployDirTextItem]));
    ci1 = new CanvasItem_0;
    ci1.setShowTitle(FALSE);
    $setCanvas(ci1, this.valForm);
    $setDisabled_2(ci1, TRUE);
    $addMember(this.form_0, this.valForm);
  }
  return this.form_0;
}
;
_.getName = function getName_15(){
  return $clinit_WizardStep() , 'New Destination';
}
;
_.nextPage_0 = function nextPage_6(){
  if (!this.valForm.validate_0() || this.createInProgress) {
    return false;
  }
  this.createInProgress = true;
  this.wizard.isNewDestination && !!this.wizard.destination?$deleteBundleDestination(this.bundleServer, this.wizard.destination.id, new GetDestinationStep$7_0(this)):$createDestination(this);
  return false;
}
;
_.createInProgress = false;
_.destBaseDirItem = null;
_.form_0 = null;
_.selector = null;
_.wizard = null;
function GetDestinationStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2068, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GetDestinationStep$1_0);
_.onChanged = function onChanged_21(event_0){
  var value;
  value = $getValue_2(event_0);
  value == null && (value = '');
  $setSubtitle(this.this$0.wizard, toString__devirtual$(value));
  $setName_5(this.this$0.destination, toString__devirtual$(value));
}
;
_.this$0 = null;
function GetDestinationStep$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2069, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GetDestinationStep$2_0);
_.onChanged = function onChanged_22(event_0){
  var value;
  value = $getValue_2(event_0);
  value == null && (value = '');
  $setDescription_1(this.this$0.destination, toString__devirtual$(value));
}
;
_.this$0 = null;
function GetDestinationStep$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2070, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GetDestinationStep$3_0);
_.onChanged = function onChanged_23(event_0){
  var value;
  value = $getValue_2(event_0);
  value == null && (value = '');
  $setDeployDir(this.this$0.destination, toString__devirtual$(value));
}
;
_.this$0 = null;
function GetDestinationStep$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2071, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GetDestinationStep$4_0);
_.onChanged = function onChanged_24(event_0){
  var value;
  value = $getValue_2(event_0);
  value != null && toString__devirtual$(value).length > 0?$setDestinationBaseDirectoryName(this.this$0.destination, toString__devirtual$(value)):(this.this$0.destination.destinationBaseDirectoryName = null , undefined);
}
;
_.this$0 = null;
function GetDestinationStep$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2072, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GetDestinationStep$5_0);
_.onChanged = function onChanged_25(event_0){
  var selectedGroupId;
  selectedGroupId = null;
  instanceOf($getValue_2(event_0), Q$Integer) && (selectedGroupId = dynamicCast($getValue_2(event_0), Q$Integer));
  $groupSelectionChanged(this.this$0, selectedGroupId);
}
;
_.this$0 = null;
function GetDestinationStep$6_0(this$0, val$newGroupIcon){
  this.this$0 = this$0;
  this.val$newGroupIcon = val$newGroupIcon;
}

defineSeed(2073, 1, makeCastMap([Q$EventHandler, Q$IconClickHandler]), GetDestinationStep$6_0);
_.onIconClick = function onIconClick(event_0){
  $equals_1($getIcon_0(event_0), this.val$newGroupIcon) && $startWizard(new GetDestinationStep$QuickGroupCreateWizard_0(this.this$0, this.this$0.selector));
}
;
_.this$0 = null;
_.val$newGroupIcon = null;
function $onSuccess_142(this$static){
  $createDestination(this$static.this$0);
}

function GetDestinationStep$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2074, 1, {}, GetDestinationStep$7_0);
_.onFailure = function onFailure_147(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to delete new destination in nextPage'), caught);
  $createDestination(this.this$0);
}
;
_.onSuccess_0 = function onSuccess_147(voidReturn){
  $onSuccess_142(this, throwClassCastExceptionUnlessNull(voidReturn));
}
;
_.this$0 = null;
function $onFailure_19(this$static, caught){
  $clinit_WizardStep();
  $showMessage(this$static.this$0.wizard.view, 'Failed to create destination, it may already exist. (Note, for an existing destination deploy from the Destination view)');
  $handleError_0(($clinit_CoreGUI() , 'Failed to create destination, it may already exist. (Note, for an existing destination deploy from the Destination view)'), caught);
  this$static.this$0.createInProgress = false;
  $decrementStep(this$static.this$0.wizard.view);
}

function $onSuccess_143(this$static, result){
  $setDestination(this$static.this$0.wizard, result);
  this$static.this$0.wizard.isNewDestination = true;
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('You have created the destination [' + ($clinit_WizardStep() , result.name_0) + ']', 'You have created the destination [' + result.name_0 + '] with the description [' + result.description + ']', ($clinit_Message$Severity() , Info)));
  this$static.this$0.createInProgress = false;
  $incrementStep(this$static.this$0.wizard.view);
}

function GetDestinationStep$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2075, 1, {}, GetDestinationStep$8_0);
_.onFailure = function onFailure_148(caught){
  $onFailure_19(this, caught);
}
;
_.onSuccess_0 = function onSuccess_148(result){
  $onSuccess_143(this, dynamicCast(result, Q$BundleDestination));
}
;
_.this$0 = null;
function $onSuccess_144(this$static, result){
  var baseDir, baseDir$iterator, baseDirs, defaultSelectedItem, menuItems;
  menuItems = null;
  if (result) {
    baseDirs = $getBundleDestinationBaseDirectories(result);
    if (!!baseDirs && baseDirs.map.size_1() > 0) {
      defaultSelectedItem = null;
      menuItems = new LinkedHashMap_1(baseDirs.map.size_1());
      for (baseDir$iterator = $iterator($keySet(baseDirs.map)); baseDir$iterator.val$outerIter.hasNext();) {
        baseDir = dynamicCast($next_1(baseDir$iterator), Q$ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory);
        baseDir.description != null?$put_1(menuItems, baseDir.name_0, '<b>' + baseDir.name_0 + '<\/b>: ' + baseDir.description):$put_1(menuItems, baseDir.name_0, baseDir.name_0);
        defaultSelectedItem == null && (defaultSelectedItem = baseDir.name_0);
      }
      $setValueMap(this$static.this$0.destBaseDirItem, menuItems);
      $setValue_7(this$static.this$0.destBaseDirItem, defaultSelectedItem);
      $setDestinationBaseDirectoryName(this$static.this$0.destination, defaultSelectedItem);
    }
  }
  $setDisabled_2(this$static.this$0.destBaseDirItem, ($clinit_Boolean() , !menuItems?TRUE:FALSE));
}

function GetDestinationStep$9_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2076, 1, {}, GetDestinationStep$9_0);
_.onFailure = function onFailure_149(caught){
  $setDisabled_2(this.this$0.destBaseDirItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to obtain bundle target information. Is the group you selected a valid compatible group that can be targeted for bundle deployments?'), caught);
}
;
_.onSuccess_0 = function onSuccess_149(result){
  $onSuccess_144(this, dynamicCast(result, Q$ResourceTypeBundleConfiguration));
}
;
_.this$0 = null;
function $createGroup(this$static){
  var groupService;
  groupService = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
  $createResourceGroup(groupService, $getGroup(this$static.createStep), $getSelectedResourceIds_0(this$static.memberStep), new AbstractGroupCreateWizard$1_0(this$static));
  return true;
}

function AbstractGroupCreateWizard_0(){
  var steps;
  steps = new ArrayList_0;
  $add_3(steps, this.createStep = new GroupCreateStep_0);
  $add_3(steps, this.memberStep = new GroupMembersStep_0(this));
  this.steps = steps;
}

defineSeed(2078, 2036, {});
_.cancel_0 = function cancel_2(){
}
;
_.createGroup = function createGroup(){
  return $createGroup(this);
}
;
_.getCustomButtons = function getCustomButtons_0(step){
  return null;
}
;
_.getSubtitle = function getSubtitle_0(){
  return null;
}
;
_.getTitle = function getTitle_3(){
  return $clinit_Wizard() , 'Create Group';
}
;
_.getWindowTitle = function getWindowTitle_0(){
  return $clinit_Wizard() , 'Create Group';
}
;
_.groupCreateCallback = function groupCreateCallback(group){
  return;
}
;
_.createStep = null;
_.memberStep = null;
function GetDestinationStep$QuickGroupCreateWizard_0(this$0, theSelector){
  this.this$0 = this$0;
  AbstractGroupCreateWizard_0.call(this);
  this.groupSelector = theSelector;
}

defineSeed(2077, 2078, {}, GetDestinationStep$QuickGroupCreateWizard_0);
_.createGroup = function createGroup_0(){
  var ids, typeRepository;
  ids = $getSelecterResourceTypeIds(this.memberStep);
  if (ids == null || ids.length == 0) {
    warn(($clinit_Wizard() , 'The group was not created. Group for deployment cannot be empty.'), null);
    return false;
  }
  typeRepository = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepository, ids, of(($clinit_ResourceTypeRepository$MetadataType() , bundleConfiguration_0)), new GetDestinationStep$QuickGroupCreateWizard$1_0(this));
  return true;
}
;
_.groupCreateCallback = function groupCreateCallback_0(group){
  var self_0;
  $setValue_5(this.groupSelector, group.id);
  this.handlerRegistrar = $addDataArrivedHandler(this.groupSelector, new GetDestinationStep$QuickGroupCreateWizard$2_0(this, group));
  self_0 = this.groupSelector.getJsObj();
  self_0.fetchData();
}
;
_.groupSelector = null;
_.handlerRegistrar = null;
_.this$0 = null;
function GetDestinationStep$QuickGroupCreateWizard$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2079, 1, {}, GetDestinationStep$QuickGroupCreateWizard$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_5(types){
  var typeSet;
  typeSet = new HashSet_2($values(types));
  typeSet.map.size_1() != 1?warn(($clinit_Wizard() , 'The group was not created. Resulting group must be compatible (members of the same type).'), null):!$getResourceTypeBundleConfiguration(dynamicCast($next_1($iterator($keySet(typeSet.map))), Q$ResourceType))?warn(($clinit_Wizard() , 'The group was not created. The resource type of the resulting group does not support deployments.'), null):$createGroup(this.this$1);
}
;
_.this$1 = null;
function $onDataArrived(this$static){
  $removeHandler(this$static.this$1.handlerRegistrar.real);
  if (!$getSelectedRecord(this$static.this$1.groupSelector)) {
    $clearValue_0(this$static.this$1.groupSelector);
    $groupSelectionChanged(this$static.this$1.this$0, null);
  }
   else {
    $groupSelectionChanged(this$static.this$1.this$0, valueOf_44(this$static.val$group.id));
  }
}

function GetDestinationStep$QuickGroupCreateWizard$2_0(this$1, val$group){
  this.this$1 = this$1;
  this.val$group = val$group;
}

defineSeed(2080, 1, makeCastMap([Q$EventHandler, Q$DataArrivedHandler]), GetDestinationStep$QuickGroupCreateWizard$2_0);
_.this$1 = null;
_.val$group = null;
function SelectBundleStep_0(wizard){
  this.wizard = wizard;
}

defineSeed(2081, 2040, makeCastMap([Q$WizardStep]), SelectBundleStep_0);
_.getCanvas = function getCanvas_8(){
  this.selector = new BundleSelector_0;
  return this.selector;
}
;
_.getName = function getName_16(){
  return $clinit_WizardStep() , 'Select Deployment Bundle';
}
;
_.nextPage_0 = function nextPage_7(){
  var selection;
  selection = $getSelection(this.selector);
  if (selection.map.size_1() != 1) {
    warn(($clinit_WizardStep() , 'Select only a single bundle for deployment.'), null);
    return false;
  }
  $setBundleId(this.wizard, dynamicCast($next_1($iterator($keySet(selection.map))), Q$Integer));
  return true;
}
;
_.selector = null;
_.wizard = null;
function SelectBundleVersionStep_0(wizard){
  this.bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.radioGroupItem = new RadioGroupItem_2('options', 'Deploy Options');
  this.selectVersionItem = new SortedSelectItem_2('selectVersion', 'Deployment Version');
  this.radioGroupValues = new LinkedHashMap_0;
  this.selectVersionValues = new LinkedHashMap_0;
  this.wizard = wizard;
}

defineSeed(2082, 2040, makeCastMap([Q$WizardStep]), SelectBundleVersionStep_0);
_.getCanvas = function getCanvas_9(){
  var criteria;
  if (!this.form_0) {
    this.form_0 = new DynamicForm_0;
    $setAttribute_24(this.form_0, 'width', '100%', true);
    $setNumCols(this.form_0, 2);
    $setColWidths(this.form_0, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['50%', '*']));
    criteria = new BundleVersionCriteria_0;
    $addFilterBundleId_1(criteria, this.wizard.bundleId);
    criteria.fetchConfigurationDefinition = true;
    $findBundleVersionsByCriteria(this.bundleServer, criteria, new SelectBundleVersionStep$3_0(this));
    $setRequired(this.radioGroupItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $setDisabled_2(this.radioGroupItem, TRUE);
    $addChangedHandler(this.radioGroupItem, new SelectBundleVersionStep$1_0(this));
    $setDisabled_2(this.selectVersionItem, TRUE);
    $addChangedHandler(this.selectVersionItem, new SelectBundleVersionStep$2_0(this));
    this.form_0.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.radioGroupItem, this.selectVersionItem]));
  }
  return this.form_0;
}
;
_.getName = function getName_17(){
  return $clinit_WizardStep() , 'Select Deployment Bundle Version';
}
;
_.nextPage_0 = function nextPage_8(){
  return this.form_0.validate_0() && !!this.wizard.bundleVersion;
}
;
_.bundleVersions = null;
_.form_0 = null;
_.latestVersion = null;
_.liveVersion = null;
_.wizard = null;
function SelectBundleVersionStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2083, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), SelectBundleVersionStep$1_0);
_.onChanged = function onChanged_26(event_0){
  var isLatestVersion, isLiveVersion;
  isLatestVersion = $equals_6('latest', $getValue_2(event_0));
  isLatestVersion && $setBundleVersion_1(this.this$0.wizard, this.this$0.latestVersion);
  isLiveVersion = $equals_6('live', $getValue_2(event_0));
  isLiveVersion && $setBundleVersion_1(this.this$0.wizard, this.this$0.liveVersion);
  $setDisabled_2(this.this$0.selectVersionItem, ($clinit_Boolean() , isLatestVersion || isLiveVersion?TRUE:FALSE));
  $setRequired(this.this$0.selectVersionItem, isLatestVersion || isLiveVersion?FALSE:TRUE);
  $redraw_0(this.this$0.selectVersionItem);
  $markForRedraw(this.this$0.form_0);
}
;
_.this$0 = null;
function SelectBundleVersionStep$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2084, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), SelectBundleVersionStep$2_0);
_.onChanged = function onChanged_27(event_0){
  var bundleVersion, bundleVersion$iterator;
  for (bundleVersion$iterator = new AbstractList$IteratorImpl_0(this.this$0.bundleVersions); bundleVersion$iterator.i < bundleVersion$iterator.this$0_0.size_1();) {
    bundleVersion = dynamicCast($next_0(bundleVersion$iterator), Q$BundleVersion);
    if ($equals_6(bundleVersion.version_0, $getValue_2(event_0))) {
      $setBundleVersion_1(this.this$0.wizard, bundleVersion);
      break;
    }
  }
}
;
_.this$0 = null;
function $onFailure_20(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to find defined bundles.'), caught);
}

function $onSuccess_145(this$static, result){
  var bundleVersion, bundleVersion$iterator, criteria, highVersionOrder, versionOrder;
  this$static.this$0.bundleVersions = result;
  (!this$static.this$0.bundleVersions || this$static.this$0.bundleVersions.size_0 == 0) && $onFailure_20(new IllegalArgumentException_1('No bundle versions defined for bundle.'));
  highVersionOrder = -1;
  for (bundleVersion$iterator = new AbstractList$IteratorImpl_0(result); bundleVersion$iterator.i < bundleVersion$iterator.this$0_0.size_1();) {
    bundleVersion = dynamicCast($next_0(bundleVersion$iterator), Q$BundleVersion);
    versionOrder = bundleVersion.versionOrder;
    if (versionOrder > highVersionOrder) {
      highVersionOrder = versionOrder;
      this$static.this$0.latestVersion = bundleVersion;
    }
    $put_1(this$static.this$0.selectVersionValues, bundleVersion.version_0, bundleVersion.version_0);
  }
  criteria = new BundleDeploymentCriteria_0;
  $addFilterDestinationId(criteria, valueOf_44(this$static.this$0.wizard.destination.id));
  $addFilterIsLive(criteria, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  criteria.fetchBundleVersion = true;
  criteria.fetchConfiguration = true;
  $findBundleDeploymentsByCriteria(this$static.this$0.bundleServer, criteria, new SelectBundleVersionStep$3$1_0(this$static));
}

function SelectBundleVersionStep$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2085, 1, {}, SelectBundleVersionStep$3_0);
_.onFailure = function onFailure_150(caught){
  $onFailure_20(caught);
}
;
_.onSuccess_0 = function onSuccess_150(result){
  $onSuccess_145(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $onSuccess_146(this$static, result){
  var i, liveBundleVersion, liveDeployment;
  $put_1(this$static.this$1.this$0.radioGroupValues, 'latest', 'Latest Version  [' + ($clinit_WizardStep() , this$static.this$1.this$0.latestVersion.version_0) + ']');
  if (result.size_0 != 0) {
    liveDeployment = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$BundleDeployment);
    liveBundleVersion = liveDeployment.bundleVersion;
    i = $indexOf_0(this$static.this$1.this$0.bundleVersions, liveBundleVersion, 0);
    $setBundleVersion(liveDeployment, dynamicCast($get_0(this$static.this$1.this$0.bundleVersions, i), Q$BundleVersion));
    $setLiveDeployment(this$static.this$1.this$0.wizard, liveDeployment);
    this$static.this$1.this$0.liveVersion = liveDeployment.bundleVersion;
    $put_1(this$static.this$1.this$0.radioGroupValues, 'live', 'Live Version  [' + this$static.this$1.this$0.liveVersion.version_0 + ']');
  }
  $put_1(this$static.this$1.this$0.radioGroupValues, 'select', 'Select Version from List:');
  $setValueMap_1(this$static.this$1.this$0.selectVersionItem, this$static.this$1.this$0.selectVersionValues);
  $setValue_7(this$static.this$1.this$0.selectVersionItem, this$static.this$1.this$0.latestVersion.version_0);
  $redraw_0(this$static.this$1.this$0.selectVersionItem);
  $setValueMap(this$static.this$1.this$0.radioGroupItem, this$static.this$1.this$0.radioGroupValues);
  $setValue_7(this$static.this$1.this$0.radioGroupItem, 'latest');
  $setBundleVersion_1(this$static.this$1.this$0.wizard, this$static.this$1.this$0.latestVersion);
  $setDisabled_2(this$static.this$1.this$0.radioGroupItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $redraw_0(this$static.this$1.this$0.radioGroupItem);
  $markForRedraw(this$static.this$1.this$0.form_0);
}

function SelectBundleVersionStep$3$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2086, 1, {}, SelectBundleVersionStep$3$1_0);
_.onFailure = function onFailure_151(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to find defined deployments.'), caught);
}
;
_.onSuccess_0 = function onSuccess_151(result){
  $onSuccess_146(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
function SingleCompatibleResourceGroupSelector_0(title){
  $clinit_ComboBoxItem();
  var descriptionField, nameField;
  ComboBoxItem_2.call(this, 'group', title);
  nameField = new ListGridField_1('name');
  descriptionField = new ListGridField_1('description');
  $setOptionDataSource(this, new SingleCompatibleResourceGroupSelector$CompatibleResourceGroupsDataSource_0);
  $isCreated_2(this)?$setProperty_6(this, 'width', 240):(this.jsObj['width'] = 240 , undefined);
  $setTitle_1(this, ($clinit_CoreGUI() , 'Resource Group'));
  $isCreated_2(this)?$setProperty_8(this, 'valueField', 'id'):(this.jsObj['valueField'] = 'id' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'displayField', 'name'):(this.jsObj['displayField'] = 'name' , undefined);
  $setPickListWidth(this, valueOf_44(450));
  $isCreated_2(this)?$setProperty_7(this, 'pickListFields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [nameField, descriptionField]))):(this.jsObj['pickListFields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [nameField, descriptionField])) , undefined);
  $setAttribute_30(this, 'textMatchStyle', ($clinit_TextMatchStyle() , SUBSTRING).value_0);
}

defineSeed(2087, 491, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$ComboBoxItem, Q$FormItem, Q$TextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), SingleCompatibleResourceGroupSelector_0);
function $copyValues_23(from){
  var descriptionAttrib, idAttrib, nameAttrib, pluginNameAttrib, rg, rt, typeNameAttrib;
  idAttrib = getAttributeAsInt(from.jsObj, 'id');
  nameAttrib = $getAttribute(from, ($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName);
  descriptionAttrib = $getAttribute(from, DESCRIPTION.propertyName);
  typeNameAttrib = $getAttribute(from, TYPE_55.propertyName);
  pluginNameAttrib = $getAttribute(from, PLUGIN_1.propertyName);
  rg = new ResourceGroup_2(nameAttrib);
  $setId_7(rg, idAttrib.value_0);
  rg.description = descriptionAttrib;
  if (null != typeNameAttrib) {
    rt = new ResourceType_0;
    rt.name_0 = typeNameAttrib;
    rt.plugin = pluginNameAttrib;
    rg.resourceType = rt;
    !rt?$setGroupCategory(rg, ($clinit_GroupCategory() , MIXED_0)):$setGroupCategory(rg, ($clinit_GroupCategory() , COMPATIBLE));
  }
  return rg;
}

function $copyValues_24(from){
  var record;
  record = new ListGridRecord_0;
  !from?(record.jsObj['group'] = null , undefined):(record.jsObj['group'] = from , undefined);
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, ($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName, from.name_0);
  $setAttribute_13(record, DESCRIPTION.propertyName, from.description);
  $setAttribute_13(record, CATEGORY.propertyName, from.groupCategory.name_0);
  if (from.resourceType) {
    $setAttribute_12(record, 'resourceType', from.resourceType);
    $setAttribute_13(record, TYPE_55.propertyName, from.resourceType.name_0);
    $setAttribute_13(record, PLUGIN_1.propertyName, from.resourceType.plugin);
  }
  return record;
}

function $executeFetch_13(this$static, request, response, criteria){
  $findResourceGroupsByCriteria(this$static.groupService, criteria, new ResourceGroupsDataSource$1_0(this$static, response, request));
}

function $getFetchCriteria_6(request){
  var criteria;
  criteria = new ResourceGroupCriteria_0;
  $addFilterId(criteria, dynamicCast(getFilter($getCriteria(request), 'id', Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterName_2(criteria, dynamicCast(getFilter_0(request, ($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName, Ljava_lang_String_2_classLit), Q$String));
  $addFilterGroupCategory(criteria, dynamicCast(getFilter_0(request, CATEGORY.propertyName, Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit), Q$GroupCategory));
  $addFilterDownMemberCount(criteria, dynamicCast(getFilter($getCriteria(request), 'downMemberCount', Ljava_lang_Long_2_classLit), Q$Long));
  $addFilterExplicitResourceIds(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [dynamicCast(getFilter($getCriteria(request), 'explicitResourceId', Ljava_lang_Integer_2_classLit), Q$Integer)]));
  $addFilterGroupDefinitionId(criteria, dynamicCast(getFilter($getCriteria(request), 'groupDefinitionId', Ljava_lang_Integer_2_classLit), Q$Integer));
  $setSearchExpression(criteria, dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String));
  $addFilterIds(criteria, dynamicCast(getArrayFilter($getCriteria(request), 'resourceGroupIds', Ljava_lang_Integer_2_classLit), Q$Integer_$1));
  return criteria;
}

function ResourceGroupsDataSource_0(){
  var fields_0, idDataField, nameDataField, descriptionDataField, typeNameDataField, pluginNameDataField, categoryDataField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.groupService = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , idDataField = new DataSourceIntegerField_2('id', 'ID', 20) , $setAttribute_8(idDataField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , setCheck(fields_0.array, fields_0.size_0++, idDataField) , nameDataField = new DataSourceTextField_2(($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName, NAME_30.title_0, 200) , setCheck(fields_0.array, fields_0.size_0++, nameDataField) , descriptionDataField = new DataSourceTextField_1(DESCRIPTION.propertyName, DESCRIPTION.title_0) , setCheck(fields_0.array, fields_0.size_0++, descriptionDataField) , typeNameDataField = new DataSourceTextField_1(TYPE_55.propertyName, TYPE_55.title_0) , setCheck(fields_0.array, fields_0.size_0++, typeNameDataField) , pluginNameDataField = new DataSourceTextField_1(PLUGIN_1.propertyName, PLUGIN_1.title_0) , setCheck(fields_0.array, fields_0.size_0++, pluginNameDataField) , categoryDataField = new DataSourceTextField_1(CATEGORY.propertyName, CATEGORY.title_0) , setCheck(fields_0.array, fields_0.size_0++, categoryDataField) , fields_0);
  $addFields(this, fields);
}

defineSeed(2089, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceGroupsDataSource_0);
_.copyValues = function copyValues_36(from){
  return $copyValues_23(from);
}
;
_.copyValues_0 = function copyValues_37(from){
  return $copyValues_24(dynamicCast(from, Q$ResourceGroup));
}
;
_.executeFetch = function executeFetch_19(request, response, criteria){
  $executeFetch_13(this, request, response, dynamicCast(criteria, Q$ResourceGroupCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_20(request){
  return this.getFetchCriteria_2(request);
}
;
_.getFetchCriteria_2 = function getFetchCriteria_21(request){
  return $getFetchCriteria_6(request);
}
;
var INSTANCE_4 = null;
function SingleCompatibleResourceGroupSelector$CompatibleResourceGroupsDataSource_0(){
  $clinit_RPCDataSource();
  ResourceGroupsDataSource_0.call(this);
}

defineSeed(2088, 2089, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), SingleCompatibleResourceGroupSelector$CompatibleResourceGroupsDataSource_0);
_.getFetchCriteria_2 = function getFetchCriteria_22(request){
  var $e0, filterString, id, result;
  result = new ResourceGroupCriteria_0;
  filterString = dynamicCast(getFilter($getCriteria(request), 'id', Ljava_lang_String_2_classLit), Q$String);
  if (filterString != null) {
    try {
      id = new Integer_1(filterString);
      result.filterId = id;
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        result.filterName = filterString;
      }
       else 
        throw $e0;
    }
  }
  result.filterBundleTargetableOnly = ($clinit_Criteria$NonBindingOverrideFilter() , ON);
  return result;
}
;
function $copyValues_25(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'name', from.name_0);
  $setAttribute_13(record, 'deployDir', from.destination.deployDir);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_13(record, 'errorMessage', from.errorMessage_0);
  $setAttribute_14(record, 'ctime', new Date_2(from.ctime.value_0));
  $setAttribute_12(record, 'configuration', from.configuration);
  $setAttribute_13(record, 'status', from.status_0.name_0);
  $setAttribute_13(record, 'deployer', from.subjectName);
  if (from.bundleVersion) {
    $setAttribute_13(record, 'bundleVersionVersion', from.bundleVersion.version_0);
    $setAttribute_3(record, 'bundleVersionId', from.bundleVersion.id);
    !!from.bundleVersion.bundle && $setAttribute_3(record, 'bundleId', from.bundleVersion.bundle.id);
  }
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  return record;
}

function $executeFetch_14(this$static, request, response, criteria){
  $findBundleDeploymentsByCriteriaWithDestinationFilter(this$static.bundleService, criteria, new BundleDeploymentDataSource$1_0(this$static, response, request));
}

function BundleDeploymentDataSource_0(){
  var fields_0, id, name_0, bundleVersion, description, status_0, created;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , id = new DataSourceIntegerField_1('id', 'ID') , $setAttribute_8(id, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , setCheck(fields_0.array, fields_0.size_0++, id) , name_0 = new DataSourceTextField_1('name', 'Deployment Name') , setCheck(fields_0.array, fields_0.size_0++, name_0) , bundleVersion = new DataSourceTextField_1('bundleVersionVersion', 'Bundle Version') , setCheck(fields_0.array, fields_0.size_0++, bundleVersion) , description = new DataSourceTextField_1('description', 'Description') , setCheck(fields_0.array, fields_0.size_0++, description) , status_0 = new DataSourceTextField_1('status', 'Status') , setCheck(fields_0.array, fields_0.size_0++, status_0) , created = new DataSourceDateTimeField_0('ctime', 'Deployment Time') , setCheck(fields_0.array, fields_0.size_0++, created) , fields_0);
  $addFields(this, fields);
}

defineSeed(2090, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), BundleDeploymentDataSource_0);
_.copyValues = function copyValues_38(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'object'), Q$BundleDeployment);
}
;
_.copyValues_0 = function copyValues_39(from){
  return $copyValues_25(dynamicCast(from, Q$BundleDeployment));
}
;
_.executeFetch = function executeFetch_20(request, response, criteria){
  $executeFetch_14(this, request, response, dynamicCast(criteria, Q$BundleDeploymentCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_23(request){
  var criteria;
  return criteria = new BundleDeploymentCriteria_0 , criteria.fetchBundleVersion = true , convertToMap($getCriteria(request).jsObj).containsKey('bundleId') && $addFilterBundleId(criteria, valueOf_44(__parseAndValidateInt($getAttribute($getCriteria(request), 'bundleId')))) , convertToMap($getCriteria(request).jsObj).containsKey('bundleVersionId') && $addFilterBundleVersionId(criteria, valueOf_44(__parseAndValidateInt($getAttribute($getCriteria(request), 'bundleVersionId')))) , convertToMap($getCriteria(request).jsObj).containsKey('bundleDestinationId') && $addFilterDestinationId(criteria, valueOf_44(__parseAndValidateInt($getAttribute($getCriteria(request), 'bundleDestinationId')))) , convertToMap($getCriteria(request).jsObj).get_2('tagNamespace') != null && $addFilterTagNamespace(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagNamespace'), Q$String)) , convertToMap($getCriteria(request).jsObj).get_2('tagSemantic') != null && $addFilterTagSemantic(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagSemantic'), Q$String)) , convertToMap($getCriteria(request).jsObj).get_2('tagName') != null && $addFilterTagName(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagName'), Q$String)) , criteria;
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_3(columnName){
  if ($equals_6('bundleVersionVersion', columnName)) {
    return 'bundleVersion.version';
  }
  return columnName;
}
;
function $onSuccess_147(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function BundleDeploymentDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2091, 1, {}, BundleDeploymentDataSource$1_0);
_.onFailure = function onFailure_152(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load bundle deployments'), caught);
}
;
_.onSuccess_0 = function onSuccess_152(result){
  $onSuccess_147(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function BundleDeploymentListView_0(criteria, canManageBundles){
  $clinit_BaseWidget();
  Table_3.call(this, ($clinit_Enhanced() , 'Bundle Deployments'), criteria);
  this.canManageBundles = canManageBundles;
  $setDataSource(this, new BundleDeploymentDataSource_0);
  this.headerIcons.size_0 > 0 && $clear_2(this.headerIcons);
  $add_3(this.headerIcons, 'subsystems/bundle/BundleDeployment_24.png');
}

defineSeed(2092, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), BundleDeploymentListView_0);
_.configureTable = function configureTable_17(){
  var bundleVersionField, deployTimeField, descriptionField, idField, nameField, statusField, statusIcons;
  idField = new ListGridField_3('id', ($clinit_Enhanced() , 'ID'));
  nameField = new ListGridField_3('name', 'Deployment Name');
  descriptionField = new ListGridField_3('description', 'Description');
  bundleVersionField = new ListGridField_3('bundleVersionVersion', 'Bundle Version');
  statusField = new ListGridField_3('status', 'Status');
  deployTimeField = new ListGridField_3('ctime', 'Deployment Time');
  $clinit_TimestampCellFormatter();
  prepareDateField(deployTimeField, getAttribute(deployTimeField.jsObj, 'name'));
  $setAttribute_13(deployTimeField, 'type', ($clinit_ListGridFieldType() , DATE_0).value_0);
  this.canManageBundles?$setCellFormatter_0(nameField, new BundleDeploymentListView$1_0):$setCellFormatter_0(nameField, new EscapedHtmlCellFormatter_0);
  $setCellFormatter_0(descriptionField, new EscapedHtmlCellFormatter_0);
  $setCellFormatter_0(bundleVersionField, new BundleDeploymentListView$2_0);
  statusIcons = new HashMap_0;
  statusIcons.put(($clinit_BundleDeploymentStatus() , PENDING).name_0, 'subsystems/bundle/install-loader.gif');
  statusIcons.put(IN_PROGRESS.name_0, 'subsystems/bundle/install-loader.gif');
  statusIcons.put(FAILURE_0.name_0, 'subsystems/bundle/Error_11.png');
  statusIcons.put(MIXED.name_0, 'subsystems/bundle/Warning_11.png');
  statusIcons.put(SUCCESS_0.name_0, 'subsystems/bundle/Ok_11.png');
  setAttribute_10(statusField.jsObj, 'valueIcons', statusIcons);
  $setValueIconWidth_0(statusField, valueOf_44(11));
  $setValueIconHeight_0(statusField, valueOf_44(11));
  $setAttribute_8(statusField, 'showValueIconOnly', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $addRecordClickHandler_0(statusField, new BundleDeploymentListView$3_0);
  idField.jsObj['width'] = 50;
  nameField.jsObj['width'] = '30%';
  descriptionField.jsObj['width'] = '40%';
  bundleVersionField.jsObj['width'] = '15%';
  deployTimeField.jsObj['width'] = '15%';
  statusField.jsObj['width'] = 80;
  $setListGridFields(this, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, nameField, descriptionField, bundleVersionField, deployTimeField, statusField]));
  this.canManageBundles && $setListGridDoubleClickHandler(this, new BundleDeploymentListView$4_0);
}
;
_.createListGrid = function createListGrid_0(){
  var grid;
  grid = new ListGrid_0;
  $isCreated_1(grid)?$setProperty_3(grid, 'sortField', 'ctime'):(grid.config_0['sortField'] = 'ctime' , undefined);
  $setSortDirection(grid, ($clinit_SortDirection() , DESCENDING));
  return grid;
}
;
_.canManageBundles = false;
function BundleDeploymentListView$1_0(){
}

defineSeed(2093, 1, {}, BundleDeploymentListView$1_0);
_.format_1 = function format_12(value, record, i, i1){
  return '<a href="#Bundles/Bundle/' + getAttributeAsInt(record.jsObj, 'bundleId').value_0 + '/deployments/' + getAttributeAsInt(record.jsObj, 'id').value_0 + '">' + escapeHtml('' + value) + '<\/a>';
}
;
function BundleDeploymentListView$2_0(){
}

defineSeed(2094, 1, {}, BundleDeploymentListView$2_0);
_.format_1 = function format_13(o, record, i, i1){
  return '<a href="' + getBundleVersionLink(getAttributeAsInt(record.jsObj, 'bundleId').value_0, getAttributeAsInt(record.jsObj, 'bundleVersionId').value_0) + '">' + o + '<\/a>';
}
;
function BundleDeploymentListView$3_0(){
}

defineSeed(2095, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), BundleDeploymentListView$3_0);
_.onRecordClick = function onRecordClick_2(event_0){
  var err;
  err = $getAttribute($getRecord_0(event_0), 'errorMessage');
  if (err != null && err.length > 0) {
    err = '<pre>' + err + '<\/pre>';
    $show(new ErrorMessageWindow_1(($clinit_Enhanced() , 'Error'), err));
  }
}
;
function BundleDeploymentListView$4_0(){
}

defineSeed(2096, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), BundleDeploymentListView$4_0);
_.onDoubleClick = function onDoubleClick_0(event_0){
  var listGrid, selectedId, selectedRows, selectedVersionId;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    selectedId = getAttribute(selectedRows[0].jsObj, 'bundleId');
    selectedVersionId = getAttribute(selectedRows[0].jsObj, 'id');
    $clinit_CoreGUI();
    goToView('#Bundles/Bundle/' + valueOf_44(__parseAndValidateInt(selectedId)).value_0 + '/deployments/' + valueOf_44(__parseAndValidateInt(selectedVersionId)).value_0, null, false);
  }
}
;
function $addMemberDeploymentsTable(this$static){
  var icons, listGrid, rd, rd$iterator, record, records, resource, resourceCategory, resourceIcon, resourceVersion, rr, status_0, table, titleBar;
  table = new Table_2(($clinit_Enhanced() , 'Deployment Resource'));
  table.showFooterRefresh = false;
  titleBar = new TitleBar_0('Select a row to show installation details');
  table.titleBar_0 = titleBar;
  resourceCategory = this$static.deployment.destination.group.resourceType.category;
  resourceIcon = new ListGridField_1('resourceAvailability');
  icons = new HashMap_0;
  icons.put(($clinit_AvailabilityType() , UP).name_0, getResourceIcon_0(resourceCategory, UP, '16'));
  icons.put(DOWN_0.name_0, getResourceIcon_0(resourceCategory, DOWN_0, '16'));
  icons.put(DISABLED.name_0, getResourceIcon_0(resourceCategory, DISABLED, '16'));
  icons.put(UNKNOWN_0.name_0, getResourceIcon_0(resourceCategory, UNKNOWN_0, '16'));
  setAttribute_10(resourceIcon.jsObj, 'valueIcons', icons);
  $setValueIconSize(resourceIcon, valueOf_44(16));
  $setAttribute_13(resourceIcon, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0);
  resourceIcon.jsObj['width'] = 40;
  resource = new ListGridField_3('resource', 'Resource');
  resource.jsObj['width'] = '*';
  $setCellFormatter_0(resource, new BundleDeploymentView$6_0);
  resourceVersion = new ListGridField_3('resourceVersion', 'Version');
  $setAttribute_8(resourceVersion, 'autoFitWidth', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_13(resourceVersion, 'autoFitWidthApproach', ($clinit_AutoFitWidthApproach() , BOTH).value_0);
  status_0 = new ListGridField_3('status', 'Status');
  $setAttribute_15(status_0, 'valueIcons', this$static.statusIcons);
  $setValueIconHeight_0(status_0, valueOf_44(11));
  $setValueIconWidth_0(status_0, valueOf_44(11));
  $setAttribute_8(status_0, 'showValueIconOnly', TRUE);
  status_0.jsObj['width'] = 60;
  records = new ArrayList_0;
  for (rd$iterator = this$static.deployment.resourceDeployments.iterator(); rd$iterator.hasNext();) {
    rd = dynamicCast(rd$iterator.next_0(), Q$BundleResourceDeployment);
    record = new ListGridRecord_0;
    rr = rd.resource;
    $setAttribute_13(record, 'resource', rr.name_0);
    $setAttribute_13(record, 'resourceAvailability', rr.currentAvailability.availabilityType.name_0);
    $setAttribute_3(record, 'resourceId', rr.id);
    $setAttribute_13(record, 'resourceVersion', rr.version_0);
    $setAttribute_13(record, 'status', rd.status_0.name_0);
    $setAttribute_3(record, 'id', rd.id);
    !rd?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = rd , undefined);
    setCheck(records.array, records.size_0++, record);
  }
  $isCreated_1(table)?$setProperty_3(table, 'height', '30%'):(table.config_0['height'] = '30%' , undefined);
  $isCreated_1(table)?$setProperty_3(table, 'width', '100%'):(table.config_0['width'] = '100%' , undefined);
  $setShowResizeBar(table, TRUE);
  $isCreated_1(table)?undefined:(table.config_0['resizeBarTarget'] = 'next' , undefined);
  $addMember(this$static, table);
  listGrid = table.listGrid;
  $isCreated_1(listGrid)?$setProperty_2(listGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [resourceIcon, resource, resourceVersion, status_0]))):(listGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [resourceIcon, resource, resourceVersion, status_0])) , undefined);
  $setData(listGrid, dynamicCast($toArray_1(records, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, records.size_0, 0)), Q$ListGridRecord_$1));
  $addSelectionChangedHandler(listGrid, new BundleDeploymentView$7_0(this$static));
  return table;
}

function $createSummaryForm(this$static){
  var actionItem, bundleName, bundleVersionName, deployed, deployedBy, description, destBaseDir, destinationGroup, form, path, status_0;
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $isCreated_1(form)?$setProperty_0(form, 'height', 1):(form.config_0['height'] = 1 , undefined);
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 5):(form.config_0['numCols'] = 5 , undefined);
  $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_1(form)?undefined:(form.config_0['extraSpace'] = 10 , undefined);
  $setIsGroup(form, TRUE);
  $setGroupTitle(form, ($clinit_Enhanced() , 'Summary'));
  $setPadding(form, valueOf_44(5));
  bundleName = new StaticTextItem_1('bundle');
  $setTitle_1(bundleName, 'Bundle');
  $setValue_7(bundleName, '<a href="#Bundles/Bundle/' + this$static.bundle.id + '">' + escapeHtml(this$static.bundle.name_0) + '<\/a>');
  actionItem = new CanvasItem_1('actions');
  $isCreated_2(actionItem)?$setProperty_6(actionItem, 'colSpan', 1):(actionItem.jsObj['colSpan'] = 1 , undefined);
  $isCreated_2(actionItem)?$setProperty_6(actionItem, 'rowSpan', 4):(actionItem.jsObj['rowSpan'] = 4 , undefined);
  actionItem.setShowTitle(FALSE);
  $setCanvas(actionItem, $getActionLayout(this$static));
  bundleVersionName = new StaticTextItem_1('bundleVersion');
  $setTitle_1(bundleVersionName, 'Bundle Version');
  $setValue_7(bundleVersionName, '<a href="' + getBundleVersionLink(this$static.bundle.id, this$static.deployment.bundleVersion.id) + '">' + escapeHtml(this$static.deployment.bundleVersion.version_0) + '<\/a>');
  deployed = new StaticTextItem_2('deployed', 'Deployed');
  $setValue_7(deployed, format_30(valueOf_45(this$static.deployment.ctime.value_0), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_FULL)));
  deployedBy = new StaticTextItem_2('deployedBy', 'Deployed By');
  $setValue_7(deployedBy, this$static.deployment.subjectName);
  destinationGroup = new StaticTextItem_1('group');
  $setTitle_1(destinationGroup, 'Resource Group');
  $setValue_7(destinationGroup, '<a href="' + getResourceOrGroupLink(forGroup_0(this$static.deployment.destination.group)) + '">' + escapeHtml(this$static.deployment.destination.group.name_0) + '<\/a>');
  destBaseDir = new StaticTextItem_2('destBaseDir', 'Base Location');
  $setValue_7(destBaseDir, this$static.deployment.destination.destinationBaseDirectoryName);
  path = new StaticTextItem_2('path', 'Deploy Directory');
  $setValue_7(path, this$static.deployment.destination.deployDir);
  description = new StaticTextItem_2('description', 'Description');
  $setValue_7(description, escapeHtml(this$static.deployment.description));
  status_0 = new StaticTextItem_2('status', 'Status');
  $setValue_7(status_0, this$static.deployment.status_0.name_0);
  $setValueIcons(status_0, this$static.statusIcons);
  $setValueIconHeight(status_0, valueOf_44(11));
  $setValueIconWidth(status_0, valueOf_44(11));
  $setShowValueIconOnly(status_0, TRUE);
  if (this$static.deployment.errorMessage_0 != null) {
    $setPrompt_1(status_0, 'Click the icon for the error message');
    status_0.addClickHandler(new BundleDeploymentView$1_0(this$static));
  }
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [bundleName, bundleVersionName, actionItem, deployed, deployedBy, destinationGroup, destBaseDir, description, path, status_0]));
  return form;
}

function $getActionLayout(this$static){
  var actionLayout, deleteButton, purgeButton, revertButton;
  actionLayout = new EnhancedVLayout_1;
  if (this$static.deployment.isLive) {
    revertButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Revert'));
    $isCreated_1(revertButton)?$setProperty_3(revertButton, 'icon', 'subsystems/bundle/BundleAction_Revert_16.png'):(revertButton.config_0['icon'] = 'subsystems/bundle/BundleAction_Revert_16.png' , undefined);
    $addClickHandler(revertButton, new BundleDeploymentView$2_0(this$static));
    $addMember(actionLayout, revertButton);
    purgeButton = new EnhancedIButton_1('Purge');
    $isCreated_1(purgeButton)?$setProperty_3(purgeButton, 'icon', 'subsystems/bundle/BundleDestinationAction_Purge_16.png'):(purgeButton.config_0['icon'] = 'subsystems/bundle/BundleDestinationAction_Purge_16.png' , undefined);
    $addClickHandler(purgeButton, new BundleDeploymentView$3_0(this$static));
    $addMember(actionLayout, purgeButton);
    if (!this$static.canManageBundles) {
      $setAttribute_22(revertButton, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , TRUE), true);
      $setAttribute_22(purgeButton, 'disabled', TRUE, true);
    }
  }
  deleteButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Delete'));
  $isCreated_1(deleteButton)?$setProperty_3(deleteButton, 'icon', 'subsystems/bundle/BundleDeploymentAction_Delete_16.png'):(deleteButton.config_0['icon'] = 'subsystems/bundle/BundleDeploymentAction_Delete_16.png' , undefined);
  $addClickHandler(deleteButton, new BundleDeploymentView$4_0(this$static));
  $addMember(actionLayout, deleteButton);
  this$static.canManageBundles || $setAttribute_22(deleteButton, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , TRUE), true);
  return actionLayout;
}

function $renderView_2(this$static, viewPath){
  var bundleDeploymentId, bundleService, criteria;
  bundleDeploymentId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  criteria = new BundleDeploymentCriteria_0;
  $addFilterId(criteria, valueOf_44(bundleDeploymentId));
  criteria.fetchBundleVersion = true;
  criteria.fetchConfiguration = true;
  criteria.fetchResourceDeployments = true;
  criteria.fetchDestination = true;
  criteria.fetchTags = true;
  bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  $findBundleDeploymentsByCriteria(bundleService, criteria, new BundleDeploymentView$8_0(this$static, bundleService, viewPath));
}

function $viewBundleDeployment(this$static, bundleDeployment){
  var readOnly, tagEditor;
  destroyMembers(this$static);
  this$static.deployment = bundleDeployment;
  this$static.version_0 = bundleDeployment.bundleVersion;
  this$static.bundle = bundleDeployment.bundleVersion.bundle;
  $addMember(this$static, new BackButton_0(($clinit_Enhanced() , 'Back to Destination') + ': ' + this$static.deployment.destination.name_0, getBundleDestinationLink(this$static.version_0.bundle.id, this$static.deployment.destination.id)));
  $addMember(this$static, new HeaderLabel_1(getImgURL('subsystems/bundle/BundleDeployment_24.png'), this$static.deployment.name_0));
  ($clinit_CoreGUI() , $clinit_CoreGUI() , enableTagsForUI) && $addMember(this$static, (readOnly = !this$static.canManageBundles , tagEditor = new TagEditorView_0(this$static.version_0.tags, readOnly, new BundleDeploymentView$5_0(this$static)) , $isCreated_1(tagEditor)?$setProperty_0(tagEditor, 'height', 1):(tagEditor.config_0['height'] = 1 , undefined) , $isCreated_1(tagEditor)?undefined:(tagEditor.config_0['extraSpace'] = 10 , undefined) , tagEditor));
  $addMember(this$static, $createSummaryForm(this$static));
  $addMemberDeploymentsTable(this$static);
  this$static.detail = new VLayout_0;
  $setAutoHeight(this$static.detail);
  this$static.detail.hide_0();
  $addMember(this$static, this$static.detail);
}

function BundleDeploymentView_0(canManageBundles){
  EnhancedVLayout_0.call(this);
  this.canManageBundles = canManageBundles;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  this.statusIcons = new HashMap_0;
  this.statusIcons.put(($clinit_BundleDeploymentStatus() , PENDING).name_0, 'subsystems/bundle/install-loader.gif');
  this.statusIcons.put(IN_PROGRESS.name_0, 'subsystems/bundle/install-loader.gif');
  this.statusIcons.put(FAILURE_0.name_0, 'subsystems/bundle/Error_11.png');
  this.statusIcons.put(MIXED.name_0, 'subsystems/bundle/Warning_11.png');
  this.statusIcons.put(SUCCESS_0.name_0, 'subsystems/bundle/Ok_11.png');
}

defineSeed(2097, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), BundleDeploymentView_0);
_.renderView = function renderView_11(viewPath){
  $renderView_2(this, viewPath);
}
;
_.bundle = null;
_.canManageBundles = false;
_.deployment = null;
_.detail = null;
_.statusIcons = null;
_.version_0 = null;
function BundleDeploymentView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2098, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), BundleDeploymentView$1_0);
_.onClick_0 = function onClick_38(event_0){
  var win;
  win = new ErrorMessageWindow_1(($clinit_Enhanced() , 'Error'), '<pre>' + this.this$0.deployment.errorMessage_0 + '<\/pre>');
  $show(win);
}
;
_.this$0 = null;
function BundleDeploymentView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2099, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BundleDeploymentView$2_0);
_.onClick = function onClick_39(event_0){
  $startWizard(new BundleRevertWizard_0(this.this$0.deployment.destination));
}
;
_.this$0 = null;
function BundleDeploymentView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2100, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BundleDeploymentView$3_0);
_.onClick = function onClick_40(clickEvent){
  ask(($clinit_Enhanced() , 'This will purge the bundle content from all remote machines. Are you sure you want to do this?'), new BundleDeploymentView$3$1_0(this));
}
;
_.this$0 = null;
function BundleDeploymentView$3$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2101, 1, {}, BundleDeploymentView$3$1_0);
_.execute_3 = function execute_23(aBoolean){
  var bundleService, destinationId, destinationName;
  if (aBoolean.value_0) {
    destinationId = this.this$1.this$0.deployment.destination.id;
    destinationName = this.this$1.this$0.deployment.destination.name_0;
    bundleService = dynamicCast(secure(getInstance_36(), 600000), Q$BundleGWTServiceAsync);
    $purgeBundleDestination(bundleService, destinationId, new BundleDeploymentView$3$1$1_0(this, destinationName));
  }
}
;
_.this$1 = null;
function $onSuccess_148(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You successfully purged the bundle destination [' + ($clinit_Enhanced() , this$static.val$destinationName) + '] from all of the remote machines.', ($clinit_Message$Severity() , Info)));
  goToView('#Bundles/Bundle/' + this$static.this$2.this$1.this$0.bundle.id + '/deployments/' + this$static.this$2.this$1.this$0.deployment.id, null, true);
}

function BundleDeploymentView$3$1$1_0(this$2, val$destinationName){
  this.this$2 = this$2;
  this.val$destinationName = val$destinationName;
}

defineSeed(2102, 1, {}, BundleDeploymentView$3$1$1_0);
_.onFailure = function onFailure_153(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to purge the bundle destination [' + ($clinit_Enhanced() , this.val$destinationName) + '] from some or all of the remote machines.'), caught);
}
;
_.onSuccess_0 = function onSuccess_153(result){
  $onSuccess_148(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$2 = null;
_.val$destinationName = null;
function BundleDeploymentView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2103, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BundleDeploymentView$4_0);
_.onClick = function onClick_41(event_0){
  ask(($clinit_Enhanced() , 'Are you sure you want to delete this bundle deployment? This only deletes it from the database; all bundle content that was deployed on remote machines will remain.'), new BundleDeploymentView$4$1_0(this));
}
;
_.this$0 = null;
function BundleDeploymentView$4$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2104, 1, {}, BundleDeploymentView$4$1_0);
_.execute_3 = function execute_24(aBoolean){
  var bundleService;
  if (aBoolean.value_0) {
    bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
    $deleteBundleDeployment(bundleService, this.this$1.this$0.deployment.id, new BundleDeploymentView$4$1$1_0(this));
  }
}
;
_.this$1 = null;
function $onSuccess_149(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You successfully deleted the bundle deployment [' + ($clinit_Enhanced() , this$static.this$2.this$1.this$0.deployment.name_0) + ']', ($clinit_Message$Severity() , Info)));
  goToView(getBundleDestinationLink(this$static.this$2.this$1.this$0.bundle.id, this$static.this$2.this$1.this$0.deployment.destination.id), null, true);
}

function BundleDeploymentView$4$1$1_0(this$2){
  this.this$2 = this$2;
}

defineSeed(2105, 1, {}, BundleDeploymentView$4$1$1_0);
_.onFailure = function onFailure_154(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to delete the bundle deployment [' + ($clinit_Enhanced() , this.this$2.this$1.this$0.deployment.name_0) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_154(result){
  $onSuccess_149(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$2 = null;
function BundleDeploymentView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2106, 1, {}, BundleDeploymentView$5_0);
_.tagsChanged = function tagsChanged(tags){
  $updateBundleDeploymentTags(dynamicCast(secure(getInstance_56(), -1), Q$TagGWTServiceAsync), this.this$0.deployment.id, tags, new BundleDeploymentView$5$1_0);
}
;
_.this$0 = null;
function BundleDeploymentView$5$1_0(){
}

defineSeed(2107, 1, {}, BundleDeploymentView$5$1_0);
_.onFailure = function onFailure_155(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update bundle deployment tags'), caught);
}
;
_.onSuccess_0 = function onSuccess_155(result){
  throwClassCastExceptionUnlessNull(result);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have successfully updated the bundle deployment tags'), ($clinit_Message$Severity() , Info)));
}
;
function BundleDeploymentView$6_0(){
}

defineSeed(2108, 1, {}, BundleDeploymentView$6_0);
_.format_1 = function format_14(value, listGridRecord, i, i1){
  return '<a href="#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0 + '">' + escapeHtml('' + value) + '<\/a>';
}
;
function BundleDeploymentView$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2109, 1, makeCastMap([Q$EventHandler, Q$SelectionChangedHandler]), BundleDeploymentView$7_0);
_.onSelectionChanged = function onSelectionChanged_3(selectionEvent){
  var bundleResourceDeployment, detailView;
  if ($getState(selectionEvent)) {
    bundleResourceDeployment = dynamicCast($getAttributeAsObject($getRecord_1(selectionEvent), 'object'), Q$BundleResourceDeployment);
    detailView = new BundleResourceDeploymentHistoryListView_0(bundleResourceDeployment);
    $removeMembers(this.this$0.detail, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this.this$0.detail, 'members')));
    this.this$0.detail.addMember_0(detailView);
    $setHeight_0(this.this$0.detail, '50%');
    $animateShow(this.this$0.detail, ($clinit_AnimationEffect() , SLIDE));
  }
   else {
    $animateHide(this.this$0.detail, ($clinit_AnimationEffect() , SLIDE));
  }
}
;
_.this$0 = null;
function $onSuccess_150(this$static, result){
  var bundleCriteria, deployment;
  deployment = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$BundleDeployment);
  bundleCriteria = new BundleCriteria_0;
  $addFilterId(bundleCriteria, valueOf_44(deployment.bundleVersion.bundle.id));
  $findBundlesByCriteria(this$static.val$bundleService, bundleCriteria, new BundleDeploymentView$8$1_0(this$static, deployment, this$static.val$bundleService, this$static.val$viewPath));
}

function BundleDeploymentView$8_0(this$0, val$bundleService, val$viewPath){
  this.this$0 = this$0;
  this.val$bundleService = val$bundleService;
  this.val$viewPath = val$viewPath;
}

defineSeed(2110, 1, {}, BundleDeploymentView$8_0);
_.onFailure = function onFailure_156(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load bundle deployment'), caught);
}
;
_.onSuccess_0 = function onSuccess_156(result){
  $onSuccess_150(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$bundleService = null;
_.val$viewPath = null;
function $onSuccess_151(this$static, result){
  var bundle, criteria;
  bundle = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Bundle);
  $setBundle(this$static.val$deployment.bundleVersion, bundle);
  criteria = new BundleResourceDeploymentCriteria_0;
  $addFilterBundleDeploymentId(criteria, valueOf_44(this$static.val$deployment.id));
  criteria.fetchHistories = true;
  criteria.fetchResource = true;
  criteria.fetchBundleDeployment = true;
  $findBundleResourceDeploymentsByCriteria(this$static.val$bundleService, criteria, new BundleDeploymentView$8$1$1_0(this$static, this$static.val$deployment, this$static.val$viewPath));
}

function BundleDeploymentView$8$1_0(this$1, val$deployment, val$bundleService, val$viewPath){
  this.this$1 = this$1;
  this.val$deployment = val$deployment;
  this.val$bundleService = val$bundleService;
  this.val$viewPath = val$viewPath;
}

defineSeed(2111, 1, {}, BundleDeploymentView$8$1_0);
_.onFailure = function onFailure_157(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to find bundle'), caught);
}
;
_.onSuccess_0 = function onSuccess_157(result){
  $onSuccess_151(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
_.val$bundleService = null;
_.val$deployment = null;
_.val$viewPath = null;
function $onSuccess_152(this$static, result){
  $setResourceDeployments(this$static.val$deployment, result);
  $viewBundleDeployment(this$static.this$2.this$1.this$0, this$static.val$deployment, $getCurrent(this$static.val$viewPath));
}

function BundleDeploymentView$8$1$1_0(this$2, val$deployment, val$viewPath){
  this.this$2 = this$2;
  this.val$deployment = val$deployment;
  this.val$viewPath = val$viewPath;
}

defineSeed(2112, 1, {}, BundleDeploymentView$8$1$1_0);
_.onFailure = function onFailure_158(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load bundle deployment'), caught);
}
;
_.onSuccess_0 = function onSuccess_158(result){
  $onSuccess_152(this, dynamicCast(result, Q$PageList));
}
;
_.this$2 = null;
_.val$deployment = null;
_.val$viewPath = null;
function $buildRecords_0(this$static){
  var record, records, step, step$iterator;
  records = new ArrayList_0;
  for (step$iterator = this$static.resourceDeployment.histories.iterator(); step$iterator.hasNext();) {
    step = dynamicCast(step$iterator.next_0(), Q$BundleResourceDeploymentHistory);
    record = new ListGridRecord_0;
    $setAttribute_3(record, 'id', step.id);
    $setAttribute_13(record, 'action', step.action);
    $setAttribute_13(record, 'info', step.info_0);
    !!step.category && $setAttribute_13(record, 'category', step.category.displayName);
    $setAttribute_13(record, 'message', step.message_0);
    $setAttribute_13(record, 'attachment', step.attachment);
    $setAttribute_13(record, 'status', step.status_0.name_0);
    $setAttribute_14(record, 'timestamp', new Date_2(step.auditTime.value_0));
    $setAttribute_13(record, 'user', step.subjectName);
    setCheck(records.array, records.size_0++, record);
  }
  return dynamicCast($toArray_1(records, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, records.size_0, 0)), Q$ListGridRecord_$1);
}

function $showDetails_0(this$static, record){
  var action, category, detail, form, info, message, status_0, timestamp, user, win;
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_3(form, 'height', '100%'):(form.config_0['height'] = '100%' , undefined);
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $setPadding(form, valueOf_44(20));
  status_0 = new StaticTextItem_2('status', ($clinit_Enhanced() , 'Status'));
  $setValueIcons(status_0, this$static.statusIcons);
  $setValueIconHeight(status_0, valueOf_44(11));
  $setValueIconWidth(status_0, valueOf_44(11));
  $setShowValueIconOnly(status_0, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  user = new StaticTextItem_2('user', 'User');
  timestamp = new StaticTextItem_2('timestamp', 'Date/Time');
  $setAttribute_30(timestamp, 'dateFormatter', ($clinit_DateDisplayFormat() , TOLOCALESTRING).value_0);
  action = new StaticTextItem_2('action', 'Action');
  info = new StaticTextItem_2('info', 'Info');
  category = new StaticTextItem_2('category', 'Category');
  message = new StaticTextItem_2('message', 'Message');
  $setAttribute_30(message, 'titleVAlign', ($clinit_VerticalAlignment() , TOP_2).value_0);
  detail = new TextAreaItem_2('attachment', 'Details');
  $setAttribute_30(detail, 'titleVAlign', TOP_2.value_0);
  $isCreated_2(detail)?$setProperty_6(detail, 'minHeight', 100):(detail.jsObj['minHeight'] = 100 , undefined);
  $setHeight_1(detail, '100%');
  $setWidth_2(detail, '100%');
  $addChangeHandler(detail, new BundleResourceDeploymentHistoryListView$4_0);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [timestamp, action, category, user, status_0, info, message, detail]));
  $editRecord(form, record);
  win = new ErrorMessageWindow_0('Install Details', form);
  $isCreated_1(win)?$setProperty_0(win, 'width', 500):(win.config_0['width'] = 500 , undefined);
  $show(win);
}

function BundleResourceDeploymentHistoryListView_0(resourceDeployment){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  this.resourceDeployment = resourceDeployment;
  this.statusIcons = new HashMap_0;
  this.statusIcons.put(($clinit_BundleDeploymentStatus() , PENDING).name_0, 'subsystems/bundle/install-loader.gif');
  this.statusIcons.put(IN_PROGRESS.name_0, 'subsystems/bundle/install-loader.gif');
  this.statusIcons.put(FAILURE_0.name_0, 'subsystems/bundle/Error_11.png');
  this.statusIcons.put(MIXED.name_0, 'subsystems/bundle/Warning_11.png');
  this.statusIcons.put(SUCCESS_0.name_0, 'subsystems/bundle/Ok_11.png');
  this.statusIcons.put(($clinit_BundleResourceDeploymentHistory$Status() , WARN).name_0, 'subsystems/bundle/Warning_11.png');
  this.statusIcons.put(INFO_0.name_0, 'subsystems/bundle/Info_11.png');
}

defineSeed(2113, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), BundleResourceDeploymentHistoryListView_0);
_.onInit = function onInit_28(){
  var action, details, grid, message, status_0, timestamp, user;
  $onInit(this);
  $onInit_Layout(this);
  grid = new ListGrid_0;
  $isCreated_1(grid)?$setProperty_3(grid, 'width', '100%'):(grid.config_0['width'] = '100%' , undefined);
  $isCreated_1(grid)?$setProperty_3(grid, 'height', '100%'):(grid.config_0['height'] = '100%' , undefined);
  $setAttribute_24(grid, 'selectionType', ($clinit_SelectionStyle() , SINGLE).value_0, true);
  $setCanExpandRecords(grid, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_24(grid, 'expansionMode', ($clinit_ExpansionMode() , DETAIL_FIELD).value_0, true);
  $isCreated_1(grid)?$setProperty_3(grid, 'detailField', 'message'):(grid.config_0['detailField'] = 'message' , undefined);
  $isCreated_1(grid)?$setProperty_3(grid, 'sortField', 'timestamp'):(grid.config_0['sortField'] = 'timestamp' , undefined);
  $setSortDirection(grid, ($clinit_SortDirection() , ASCENDING));
  action = new ListGridField_3('action', ($clinit_Enhanced() , 'Action'));
  $setAttribute_8(action, 'autoFitWidth', TRUE);
  $setAttribute_13(action, 'autoFitWidthApproach', ($clinit_AutoFitWidthApproach() , BOTH).value_0);
  message = new ListGridField_3('info', 'Info');
  message.jsObj['width'] = '60%';
  user = new ListGridField_3('user', 'User');
  user.jsObj['showIf'] = 'false';
  timestamp = new ListGridField_3('timestamp', 'Date/Time');
  $clinit_TimestampCellFormatter();
  prepareDateField(timestamp, getAttribute(timestamp.jsObj, 'name'));
  timestamp.jsObj['width'] = '40%';
  status_0 = new ListGridField_3('status', 'Status');
  $setAttribute_15(status_0, 'valueIcons', this.statusIcons);
  $setValueIconHeight_0(status_0, valueOf_44(11));
  $setValueIconWidth_0(status_0, valueOf_44(11));
  $setAttribute_8(status_0, 'showValueIconOnly', TRUE);
  $setAttribute_8(status_0, 'autoFitWidth', TRUE);
  $setAttribute_13(status_0, 'autoFitWidthApproach', BOTH.value_0);
  details = new ListGridField_3('attachment', 'Details');
  details.jsObj['width'] = 50;
  $setAttribute_13(details, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_13(details, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0);
  $setIconHeight_1(details, valueOf_44(11));
  $setIconWidth_1(details, valueOf_44(11));
  $setCellFormatter_0(details, new BundleResourceDeploymentHistoryListView$1_0);
  $addRecordClickHandler_0(details, new BundleResourceDeploymentHistoryListView$2_0(this));
  $isCreated_1(grid)?$setProperty_2(grid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [action, message, timestamp, status_0, user, details]))):(grid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [action, message, timestamp, status_0, user, details])) , undefined);
  $setData(grid, $buildRecords_0(this));
  $addDoubleClickHandler(grid, new BundleResourceDeploymentHistoryListView$3_0(this, grid));
  $addMember(this, grid);
}
;
_.resourceDeployment = null;
_.statusIcons = null;
function BundleResourceDeploymentHistoryListView$1_0(){
}

defineSeed(2114, 1, {}, BundleResourceDeploymentHistoryListView$1_0);
_.format_1 = function format_15(o, listGridRecord, i, i1){
  return '<img src="images/subsystems/bundle/Details_11.png"/>';
}
;
function BundleResourceDeploymentHistoryListView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2115, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), BundleResourceDeploymentHistoryListView$2_0);
_.onRecordClick = function onRecordClick_3(recordClickEvent){
  $showDetails_0(this.this$0, dynamicCast($getRecord_0(recordClickEvent), Q$ListGridRecord));
}
;
_.this$0 = null;
function BundleResourceDeploymentHistoryListView$3_0(this$0, val$grid){
  this.this$0 = this$0;
  this.val$grid = val$grid;
}

defineSeed(2116, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), BundleResourceDeploymentHistoryListView$3_0);
_.onDoubleClick = function onDoubleClick_1(event_0){
  $showDetails_0(this.this$0, this.val$grid.getSelectedRecord_0());
}
;
_.this$0 = null;
_.val$grid = null;
function BundleResourceDeploymentHistoryListView$4_0(){
}

defineSeed(2117, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), BundleResourceDeploymentHistoryListView$4_0);
_.onChange = function onChange_0(event_0){
  event_0.cancel = true;
}
;
function $copyValues_26(from){
  var dep, dep$iterator, last, record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'name', from.name_0);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_3(record, 'bundleId', from.bundle.id);
  $setAttribute_13(record, 'bundleName', from.bundle.name_0);
  $setAttribute_3(record, 'groupId', from.group.id);
  $setAttribute_13(record, 'groupName', from.group.name_0);
  $setAttribute_13(record, 'baseDirName', from.destinationBaseDirectoryName);
  $setAttribute_13(record, 'deployDir', from.deployDir);
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  last = P0_longLit;
  for (dep$iterator = from.deployments.iterator(); dep$iterator.hasNext();) {
    dep = dynamicCast(dep$iterator.next_0(), Q$BundleDeployment);
    if (lt(last, dep.ctime.value_0)) {
      last = dep.ctime.value_0;
      !dep?(record.jsObj['latestDeployment'] = null , undefined):(record.jsObj['latestDeployment'] = dep , undefined);
      $setAttribute_13(record, 'latestDeploymentVersion', dep.bundleVersion.version_0);
      $setAttribute_14(record, 'latestDeploymentDate', new Date_2(dep.ctime.value_0));
      $setAttribute_13(record, 'latestDeploymentStatus', dep.status_0.name_0);
    }
  }
  return record;
}

function $executeFetch_15(this$static, request, response, criteria){
  $findBundleDestinationsByCriteria(dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync), criteria, new BundleDestinationDataSource$1_0(this$static, request, response));
}

function BundleDestinationDataSource_0(){
  var fields_0, idField, name_0, description, bundle, group, baseDirName, deployDir, latestDeploymentVersion, latestDeploymentDate, latestDeploymentStatus;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  fields = (fields_0 = new ArrayList_0 , idField = new DataSourceIntegerField_1('id', 'ID') , $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , setCheck(fields_0.array, fields_0.size_0++, idField) , name_0 = new DataSourceTextField_1('name', 'Name') , setCheck(fields_0.array, fields_0.size_0++, name_0) , description = new DataSourceTextField_1('description', 'Description') , setCheck(fields_0.array, fields_0.size_0++, description) , bundle = new DataSourceTextField_1('bundleName', 'Bundle') , setCheck(fields_0.array, fields_0.size_0++, bundle) , group = new DataSourceTextField_1('groupName', 'Group') , setCheck(fields_0.array, fields_0.size_0++, group) , baseDirName = new DataSourceTextField_1('baseDirName', 'Base Location') , setCheck(fields_0.array, fields_0.size_0++, baseDirName) , deployDir = new DataSourceTextField_1('deployDir', 'Deploy Directory') , setCheck(fields_0.array, fields_0.size_0++, deployDir) , latestDeploymentVersion = new DataSourceTextField_1('latestDeploymentVersion', 'Last Deployed Version') , setCheck(fields_0.array, fields_0.size_0++, latestDeploymentVersion) , latestDeploymentDate = new DataSourceTextField_1('latestDeploymentDate', 'Last Deployment Date') , setCheck(fields_0.array, fields_0.size_0++, latestDeploymentDate) , latestDeploymentStatus = new DataSourceTextField_1('latestDeploymentStatus', 'Last Deployment Status') , setCheck(fields_0.array, fields_0.size_0++, latestDeploymentStatus) , fields_0);
  $addFields(this, fields);
}

defineSeed(2118, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), BundleDestinationDataSource_0);
_.copyValues = function copyValues_40(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'object'), Q$BundleDestination);
}
;
_.copyValues_0 = function copyValues_41(from){
  return $copyValues_26(dynamicCast(from, Q$BundleDestination));
}
;
_.executeFetch = function executeFetch_21(request, response, criteria){
  $executeFetch_15(this, request, response, dynamicCast(criteria, Q$BundleDestinationCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_24(request){
  var criteria;
  return criteria = new BundleDestinationCriteria_0 , convertToMap($getCriteria(request).jsObj).containsKey('bundleId') && $addFilterBundleId_0(criteria, valueOf_44(__parseAndValidateInt($getAttributeAsString($getCriteria(request), 'bundleId')))) , convertToMap($getCriteria(request).jsObj).get_2('tagNamespace') != null && $addFilterTagNamespace(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagNamespace'), Q$String)) , convertToMap($getCriteria(request).jsObj).get_2('tagSemantic') != null && $addFilterTagSemantic(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagSemantic'), Q$String)) , convertToMap($getCriteria(request).jsObj).get_2('tagName') != null && $addFilterTagName(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagName'), Q$String)) , criteria.fetchBundle = true , criteria.fetchDeployments = true , criteria.fetchGroup = true , criteria.fetchTags = true , criteria;
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_4(columnName){
  if ($equals_6('latestDeploymentDate', columnName)) {
    return null;
  }
  if ($equals_6('latestDeploymentStatus', columnName)) {
    return null;
  }
  if ($equals_6('latestDeploymentVersion', columnName)) {
    return null;
  }
  return columnName;
}
;
function $onSuccess_153(this$static, result){
  var versionCriteria;
  versionCriteria = new BundleVersionCriteria_0;
  convertToMap($getCriteria(this$static.val$request).jsObj).containsKey('bundleId') && $addFilterBundleId_1(versionCriteria, valueOf_44(__parseAndValidateInt($getAttributeAsString($getCriteria(this$static.val$request), 'bundleId'))));
  $findBundleVersionsByCriteria(dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync), versionCriteria, new BundleDestinationDataSource$1$1_0(this$static, result, this$static.val$response, this$static.val$request));
}

function BundleDestinationDataSource$1_0(this$0, val$request, val$response){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(2119, 1, {}, BundleDestinationDataSource$1_0);
_.onFailure = function onFailure_159(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load bundle destinations'), caught);
}
;
_.onSuccess_0 = function onSuccess_159(result){
  $onSuccess_153(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_154(this$static, versions){
  var dep, dep$iterator, dest, dest$iterator, version, version$iterator;
  for (dest$iterator = new AbstractList$IteratorImpl_0(this$static.val$result); dest$iterator.i < dest$iterator.this$0_0.size_1();) {
    dest = dynamicCast($next_0(dest$iterator), Q$BundleDestination);
    for (dep$iterator = dest.deployments.iterator(); dep$iterator.hasNext();) {
      dep = dynamicCast(dep$iterator.next_0(), Q$BundleDeployment);
      for (version$iterator = new AbstractList$IteratorImpl_0(versions); version$iterator.i < version$iterator.this$0_0.size_1();) {
        version = dynamicCast($next_0(version$iterator), Q$BundleVersion);
        dep.bundleVersion.id == version.id && (dep.bundleVersion = version);
      }
    }
  }
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$1.this$0, this$static.val$result, true));
  $processResponse_0(this$static.this$1.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function BundleDestinationDataSource$1$1_0(this$1, val$result, val$response, val$request){
  this.this$1 = this$1;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2120, 1, {}, BundleDestinationDataSource$1$1_0);
_.onFailure = function onFailure_160(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load bundle destination deployed version information'), caught);
}
;
_.onSuccess_0 = function onSuccess_160(versions){
  $onSuccess_154(this, dynamicCast(versions, Q$PageList));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function BundleDestinationListView_0(criteria){
  $clinit_BaseWidget();
  Table_3.call(this, ($clinit_Enhanced() , 'Bundle Destinations'), criteria);
  this.headerIcons.size_0 > 0 && $clear_2(this.headerIcons);
  $add_3(this.headerIcons, 'subsystems/bundle/BundleDestination_24.png');
  $setDataSource(this, new BundleDestinationDataSource_0);
}

defineSeed(2121, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), BundleDestinationListView_0);
_.configureTable = function configureTable_18(){
  var baseDirNameField, bundleNameField, deployDirField, descriptionField, groupNameField, idField, latestDeploymentDateField, latestDeploymentStatusField, latestDeploymentVersionField, nameField, statusIcons;
  idField = new ListGridField_3('id', ($clinit_Enhanced() , 'ID'));
  nameField = new ListGridField_3('name', 'Name');
  descriptionField = new ListGridField_3('description', 'Description');
  bundleNameField = new ListGridField_3('bundleName', 'Bundle');
  groupNameField = new ListGridField_3('groupName', 'Group');
  baseDirNameField = new ListGridField_3('baseDirName', 'Base Location');
  deployDirField = new ListGridField_3('deployDir', 'Deploy Directory');
  latestDeploymentVersionField = new ListGridField_3('latestDeploymentVersion', 'Last Deployed Version');
  latestDeploymentDateField = new ListGridField_3('latestDeploymentDate', 'Last Deployment Date');
  latestDeploymentStatusField = new ListGridField_3('latestDeploymentStatus', 'Last Deployment Status');
  $setAttribute_13(latestDeploymentDateField, 'type', ($clinit_ListGridFieldType() , DATE_0).value_0);
  $clinit_TimestampCellFormatter();
  prepareDateField(latestDeploymentDateField, getAttribute(latestDeploymentDateField.jsObj, 'name'));
  $setCellFormatter_0(nameField, new BundleDestinationListView$1_0);
  $setCellFormatter_0(groupNameField, new BundleDestinationListView$2_0);
  $setCellFormatter_0(bundleNameField, new BundleDestinationListView$3_0);
  statusIcons = new HashMap_0;
  statusIcons.put(($clinit_BundleDeploymentStatus() , PENDING).name_0, 'subsystems/bundle/install-loader.gif');
  statusIcons.put(IN_PROGRESS.name_0, 'subsystems/bundle/install-loader.gif');
  statusIcons.put(FAILURE_0.name_0, 'subsystems/bundle/Error_11.png');
  statusIcons.put(MIXED.name_0, 'subsystems/bundle/Warning_11.png');
  statusIcons.put(SUCCESS_0.name_0, 'subsystems/bundle/Ok_11.png');
  setAttribute_10(latestDeploymentStatusField.jsObj, 'valueIcons', statusIcons);
  $setValueIconHeight_0(latestDeploymentStatusField, valueOf_44(11));
  $setValueIconWidth_0(latestDeploymentStatusField, valueOf_44(11));
  $setAttribute_8(latestDeploymentStatusField, 'showValueIconOnly', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  idField.jsObj['width'] = 50;
  nameField.jsObj['width'] = '15%';
  descriptionField.jsObj['width'] = '20%';
  bundleNameField.jsObj['showIf'] = 'false';
  groupNameField.jsObj['width'] = '15%';
  baseDirNameField.jsObj['width'] = '15%';
  deployDirField.jsObj['width'] = '15%';
  latestDeploymentVersionField.jsObj['width'] = '10%';
  latestDeploymentDateField.jsObj['width'] = '10%';
  latestDeploymentStatusField.jsObj['width'] = 80;
  $setListGridFields(this, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, nameField, descriptionField, groupNameField, baseDirNameField, deployDirField, latestDeploymentVersionField, latestDeploymentDateField, latestDeploymentStatusField]));
  $setListGridDoubleClickHandler(this, new BundleDestinationListView$4_0);
}
;
function BundleDestinationListView$1_0(){
}

defineSeed(2122, 1, {}, BundleDestinationListView$1_0);
_.format_1 = function format_16(value, listGridRecord, i, i1){
  var bundleDestId, bundleId;
  bundleId = getAttributeAsInt(listGridRecord.jsObj, 'bundleId');
  bundleDestId = getAttributeAsInt(listGridRecord.jsObj, 'id');
  return '<a href="' + getBundleDestinationLink(bundleId.value_0, bundleDestId.value_0) + '">' + escapeHtml(toString__devirtual$(value)) + '<\/a>';
}
;
function BundleDestinationListView$2_0(){
}

defineSeed(2123, 1, {}, BundleDestinationListView$2_0);
_.format_1 = function format_17(value, listGridRecord, i, i1){
  var groupId;
  groupId = getAttributeAsInt(listGridRecord.jsObj, 'groupId');
  return '<a href="#ResourceGroup/' + groupId.value_0 + '">' + escapeHtml(toString__devirtual$(value)) + '<\/a>';
}
;
function BundleDestinationListView$3_0(){
}

defineSeed(2124, 1, {}, BundleDestinationListView$3_0);
_.format_1 = function format_18(value, listGridRecord, i, i1){
  var bid;
  bid = getAttributeAsInt(listGridRecord.jsObj, 'bundleId');
  return '<a href="#Bundles/Bundle/' + bid.value_0 + '">' + escapeHtml(toString__devirtual$(value)) + '<\/a>';
}
;
function BundleDestinationListView$4_0(){
}

defineSeed(2125, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), BundleDestinationListView$4_0);
_.onDoubleClick = function onDoubleClick_2(event_0){
  var listGrid, selectedDestId, selectedId, selectedRows;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    selectedId = getAttribute(selectedRows[0].jsObj, 'bundleId');
    selectedDestId = getAttribute(selectedRows[0].jsObj, 'id');
    $clinit_CoreGUI();
    goToView(getBundleDestinationLink(valueOf_44(__parseAndValidateInt(selectedId)).value_0, valueOf_44(__parseAndValidateInt(selectedDestId)).value_0), null, false);
  }
}
;
function $getActionLayout_0(this$static){
  var actionLayout, deleteButton, deployButton, purgeButton, revertButton, bundleService, criteria;
  actionLayout = new EnhancedVLayout_1;
  deployButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Deploy'));
  $setIcon_0(deployButton, ($clinit_IconEnum() , BUNDLE_DEPLOY).icon16x16Path);
  $addClickHandler(deployButton, new BundleDestinationView$2_0(this$static));
  $addMember(actionLayout, deployButton);
  revertButton = new EnhancedIButton_1('Revert');
  $setIcon_0(revertButton, BUNDLE_REVERT.icon16x16Path);
  $addClickHandler(revertButton, new BundleDestinationView$3_0(this$static));
  $addMember(actionLayout, revertButton);
  purgeButton = new EnhancedIButton_1('Purge');
  $setIcon_0(purgeButton, BUNDLE_DESTINATION_PURGE.icon16x16Path);
  $addClickHandler(purgeButton, new BundleDestinationView$4_0(this$static));
  bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  criteria = new BundleDeploymentCriteria_0;
  $addFilterDestinationId(criteria, valueOf_44(this$static.destination.id));
  $findBundleDeploymentsByCriteria(bundleService, criteria, new BundleDestinationView$6_0(purgeButton));
  $addMember(actionLayout, purgeButton);
  deleteButton = new EnhancedIButton_1('Delete');
  $setIcon_0(deleteButton, BUNDLE_DESTINATION_DELETE.icon16x16Path);
  $addClickHandler(deleteButton, new BundleDestinationView$5_0(this$static));
  $addMember(actionLayout, deleteButton);
  if (!this$static.canManageBundles) {
    $setAttribute_22(deployButton, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , TRUE), true);
    $setAttribute_22(revertButton, 'disabled', TRUE, true);
    $setAttribute_22(purgeButton, 'disabled', TRUE, true);
    $setAttribute_22(deleteButton, 'disabled', TRUE, true);
  }
  return actionLayout;
}

function $renderView_3(this$static, viewPath){
  var bundleDestinationId, bundleService, criteria;
  bundleDestinationId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  criteria = new BundleDestinationCriteria_0;
  $addFilterId(criteria, valueOf_44(bundleDestinationId));
  criteria.fetchBundle = true;
  criteria.fetchDeployments = true;
  criteria.fetchTags = true;
  bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  $findBundleDestinationsByCriteria(bundleService, criteria, new BundleDestinationView$7_0(this$static, viewPath));
}

function $viewBundleDestination(this$static, bundleDestination){
  var backButton, header, readOnly, tagEditor, form, bundleName, actionItem, created, destinationGroup, baseDirName, path, description, criteria, deployments;
  destroyMembers(this$static);
  this$static.destination = bundleDestination;
  this$static.bundle = bundleDestination.bundle;
  backButton = new BackButton_0(($clinit_Enhanced() , 'Back to Bundle') + ': ' + escapeHtml(this$static.bundle.name_0), 'Bundles/Bundle/' + this$static.bundle.id);
  header = new HeaderLabel_1(getImgURL(($clinit_IconEnum() , BUNDLE_DESTINATION).icon24x24Path), escapeHtml(this$static.destination.name_0));
  this$static.detail = new Canvas_1;
  $setHeight_0(this$static.detail, '50%');
  this$static.detail.hide_0();
  $addMember(this$static, backButton);
  $addMember(this$static, header);
  ($clinit_CoreGUI() , $clinit_CoreGUI() , enableTagsForUI) && $addMember(this$static, (readOnly = !this$static.canManageBundles , tagEditor = new TagEditorView_0(this$static.destination.tags, readOnly, new BundleDestinationView$1_0(this$static)) , $isCreated_1(tagEditor)?$setProperty_0(tagEditor, 'height', 1):(tagEditor.config_0['height'] = 1 , undefined) , $isCreated_1(tagEditor)?undefined:(tagEditor.config_0['extraSpace'] = 10 , undefined) , tagEditor));
  $addMember(this$static, (form = new DynamicForm_0 , $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined) , $isCreated_1(form)?$setProperty_2(form, 'colWidths', convertToJavaScriptArray(initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['20%', '40%', '40%']))):(form.config_0['colWidths'] = convertToJavaScriptArray(initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['20%', '40%', '40%'])) , undefined) , $isCreated_1(form)?$setProperty_0(form, 'numCols', 3):(form.config_0['numCols'] = 3 , undefined) , $isCreated_1(form)?$setProperty_0(form, 'height', 1):(form.config_0['height'] = 1 , undefined) , $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , $isCreated_1(form)?undefined:(form.config_0['extraSpace'] = 10 , undefined) , $setIsGroup(form, TRUE) , $setGroupTitle(form, 'Summary') , $setPadding(form, valueOf_44(5)) , bundleName = new StaticTextItem_1('bundle') , $setTitle_1(bundleName, 'Bundle') , $setValue_7(bundleName, '<a href="#Bundles/Bundle/' + this$static.bundle.id + '">' + escapeHtml(this$static.bundle.name_0) + '<\/a>') , actionItem = new CanvasItem_1('actions') , $isCreated_2(actionItem)?$setProperty_6(actionItem, 'colSpan', 1):(actionItem.jsObj['colSpan'] = 1 , undefined) , $isCreated_2(actionItem)?$setProperty_6(actionItem, 'rowSpan', 5):(actionItem.jsObj['rowSpan'] = 5 , undefined) , actionItem.setShowTitle(FALSE) , $setCanvas(actionItem, $getActionLayout_0(this$static)) , created = new StaticTextItem_2('created', 'Created') , $setValue_8(created, new Date_2(this$static.destination.ctime.value_0)) , destinationGroup = new StaticTextItem_1('group') , $setTitle_1(destinationGroup, 'Group') , $setValue_7(destinationGroup, '<a href="' + getResourceOrGroupLink(forGroup_0(this$static.destination.group)) + '">' + escapeHtml(this$static.destination.group.name_0) + '<\/a>') , baseDirName = new StaticTextItem_2('baseDir', 'Base Location') , $setValue_7(baseDirName, this$static.destination.destinationBaseDirectoryName) , path = new StaticTextItem_2('path', 'Deploy Directory') , $setValue_7(path, this$static.destination.deployDir) , description = new StaticTextItem_2('description', 'Description') , $setValue_7(description, escapeHtml(this$static.destination.description)) , form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [bundleName, actionItem, created, destinationGroup, baseDirName, path, description])) , form));
  $addMember(this$static, (criteria = new Criteria_0 , $addCriteria_1(criteria, 'bundleDestinationId', valueOf_44(this$static.destination.id)) , deployments = new BundleDeploymentListView_0(criteria, this$static.canManageBundles) , $isCreated_1(deployments)?$setProperty_3(deployments, 'height', '100%'):(deployments.config_0['height'] = '100%' , undefined) , $setShowResizeBar(deployments, TRUE) , deployments));
  $addMember(this$static, this$static.detail);
}

function BundleDestinationView_0(canManageBundles){
  EnhancedVLayout_0.call(this);
  this.canManageBundles = canManageBundles;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(2126, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), BundleDestinationView_0);
_.renderView = function renderView_12(viewPath){
  $renderView_3(this, viewPath);
}
;
_.bundle = null;
_.canManageBundles = false;
_.destination = null;
_.detail = null;
function BundleDestinationView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2127, 1, {}, BundleDestinationView$1_0);
_.tagsChanged = function tagsChanged_0(tags){
  $updateBundleDestinationTags(dynamicCast(secure(getInstance_56(), -1), Q$TagGWTServiceAsync), this.this$0.destination.id, tags, new BundleDestinationView$1$1_0);
}
;
_.this$0 = null;
function BundleDestinationView$1$1_0(){
}

defineSeed(2128, 1, {}, BundleDestinationView$1$1_0);
_.onFailure = function onFailure_161(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update bundle destination tags'), caught);
}
;
_.onSuccess_0 = function onSuccess_161(result){
  throwClassCastExceptionUnlessNull(result);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have successfully updated the bundle destination tags'), ($clinit_Message$Severity() , Info)));
}
;
function BundleDestinationView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2129, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BundleDestinationView$2_0);
_.onClick = function onClick_42(clickEvent){
  $startWizard(new BundleDeployWizard_2(this.this$0.destination));
}
;
_.this$0 = null;
function BundleDestinationView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2130, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BundleDestinationView$3_0);
_.onClick = function onClick_43(clickEvent){
  ask(($clinit_Enhanced() , 'This will revert all remote machines back to the previous bundle deployment. Are you sure you want to do this?'), new BundleDestinationView$3$1_0(this));
}
;
_.this$0 = null;
function BundleDestinationView$3$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2131, 1, {}, BundleDestinationView$3$1_0);
_.execute_3 = function execute_25(aBoolean){
  aBoolean.value_0 && $startWizard(new BundleRevertWizard_0(this.this$1.this$0.destination));
}
;
_.this$1 = null;
function BundleDestinationView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2132, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BundleDestinationView$4_0);
_.onClick = function onClick_44(clickEvent){
  ask(($clinit_Enhanced() , 'This will purge the bundle content from all remote machines. Are you sure you want to do this?'), new BundleDestinationView$4$1_0(this));
}
;
_.this$0 = null;
function BundleDestinationView$4$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2133, 1, {}, BundleDestinationView$4$1_0);
_.execute_3 = function execute_26(aBoolean){
  var bundleService;
  if (aBoolean.value_0) {
    bundleService = dynamicCast(secure(getInstance_36(), 600000), Q$BundleGWTServiceAsync);
    $purgeBundleDestination(bundleService, this.this$1.this$0.destination.id, new BundleDestinationView$4$1$1_0(this));
  }
}
;
_.this$1 = null;
function $onSuccess_155(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You successfully purged the bundle destination [' + ($clinit_Enhanced() , this$static.this$2.this$1.this$0.destination.name_0) + '] from all of the remote machines.', ($clinit_Message$Severity() , Info)));
  goToView(getBundleDestinationLink(this$static.this$2.this$1.this$0.bundle.id, this$static.this$2.this$1.this$0.destination.id), null, true);
}

function BundleDestinationView$4$1$1_0(this$2){
  this.this$2 = this$2;
}

defineSeed(2134, 1, {}, BundleDestinationView$4$1$1_0);
_.onFailure = function onFailure_162(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to purge the bundle destination [' + ($clinit_Enhanced() , this.this$2.this$1.this$0.destination.name_0) + '] from some or all of the remote machines.'), caught);
}
;
_.onSuccess_0 = function onSuccess_162(result){
  $onSuccess_155(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$2 = null;
function BundleDestinationView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2135, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BundleDestinationView$5_0);
_.onClick = function onClick_45(event_0){
  ask(($clinit_Enhanced() , 'Are you sure you want to delete this bundle destination? This only deletes it from the database; all bundle content that was deployed to this destination on remote machines will remain.'), new BundleDestinationView$5$1_0(this));
}
;
_.this$0 = null;
function BundleDestinationView$5$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2136, 1, {}, BundleDestinationView$5$1_0);
_.execute_3 = function execute_27(aBoolean){
  var bundleService;
  if (aBoolean.value_0) {
    bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
    $deleteBundleDestination(bundleService, this.this$1.this$0.destination.id, new BundleDestinationView$5$1$1_0(this));
  }
}
;
_.this$1 = null;
function $onSuccess_156(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You successfully deleted the bundle destination [' + ($clinit_Enhanced() , this$static.this$2.this$1.this$0.destination.name_0) + ']', ($clinit_Message$Severity() , Info)));
  goToView(getBundleDestinationLink(this$static.this$2.this$1.this$0.bundle.id, 0), null, true);
}

function BundleDestinationView$5$1$1_0(this$2){
  this.this$2 = this$2;
}

defineSeed(2137, 1, {}, BundleDestinationView$5$1$1_0);
_.onFailure = function onFailure_163(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to delete the bundle destination [' + ($clinit_Enhanced() , this.this$2.this$1.this$0.destination.name_0) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_163(result){
  $onSuccess_156(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$2 = null;
function $onSuccess_157(this$static, result){
  var deployment, deployment$iterator;
  for (deployment$iterator = new AbstractList$IteratorImpl_0(result); deployment$iterator.i < deployment$iterator.this$0_0.size_1();) {
    deployment = dynamicCast($next_0(deployment$iterator), Q$BundleDeployment);
    if (deployment.isLive) {
      $setDisabled(this$static.val$purgeButton, false);
      return;
    }
  }
  $setDisabled(this$static.val$purgeButton, true);
}

function BundleDestinationView$6_0(val$purgeButton){
  this.val$purgeButton = val$purgeButton;
}

defineSeed(2138, 1, {}, BundleDestinationView$6_0);
_.onFailure = function onFailure_164(caught){
  $setDisabled(this.val$purgeButton, false);
}
;
_.onSuccess_0 = function onSuccess_164(result){
  $onSuccess_157(this, dynamicCast(result, Q$PageList));
}
;
_.val$purgeButton = null;
function $onSuccess_158(this$static, result){
  var destination;
  destination = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$BundleDestination);
  $viewBundleDestination(this$static.this$0, destination, $getCurrent(this$static.val$viewPath));
}

function BundleDestinationView$7_0(this$0, val$viewPath){
  this.this$0 = this$0;
  this.val$viewPath = val$viewPath;
}

defineSeed(2139, 1, {}, BundleDestinationView$7_0);
_.onFailure = function onFailure_165(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load bundle destinations'), caught);
}
;
_.onSuccess_0 = function onSuccess_165(result){
  $onSuccess_158(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$viewPath = null;
function $copyValues_27(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_3(record, 'bundleId', from.bundle.id);
  $setAttribute_13(record, 'name', from.name_0);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_13(record, 'version', from.version_0);
  $setAttribute_11(record, 'fileCount', valueOf_44(from.bundleFiles.size_1()));
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  return record;
}

function $executeFetch_16(this$static, request, response, criteria){
  $findBundleVersionsByCriteria(this$static.bundleService, criteria, new BundleVersionDataSource$1_0(this$static, response, request));
}

function BundleVersionDataSource_0(){
  var fields_0, idField, versionField, nameField, descriptionField, fileCountField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , idField = new DataSourceIntegerField_1('id', 'ID') , $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , setCheck(fields_0.array, fields_0.size_0++, idField) , versionField = new DataSourceTextField_1('version', 'Version') , setCheck(fields_0.array, fields_0.size_0++, versionField) , nameField = new DataSourceTextField_1('name', 'Name') , setCheck(fields_0.array, fields_0.size_0++, nameField) , descriptionField = new DataSourceTextField_1('description', 'Description') , setCheck(fields_0.array, fields_0.size_0++, descriptionField) , fileCountField = new DataSourceIntegerField_1('fileCount', 'Bundle Files') , setCheck(fields_0.array, fields_0.size_0++, fileCountField) , fields_0);
  $addFields(this, fields);
}

defineSeed(2140, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), BundleVersionDataSource_0);
_.copyValues = function copyValues_42(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'object'), Q$BundleVersion);
}
;
_.copyValues_0 = function copyValues_43(from){
  return $copyValues_27(dynamicCast(from, Q$BundleVersion));
}
;
_.executeFetch = function executeFetch_22(request, response, criteria){
  $executeFetch_16(this, request, response, dynamicCast(criteria, Q$BundleVersionCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_25(request){
  var criteria;
  return criteria = new BundleVersionCriteria_0 , criteria.fetchBundleFiles = true , criteria.fetchBundle = true , convertToMap($getCriteria(request).jsObj).get_2('bundleId') != null && $addFilterBundleId_1(criteria, valueOf_44(__parseAndValidateInt('' + convertToMap($getCriteria(request).jsObj).get_2('bundleId')))) , convertToMap($getCriteria(request).jsObj).get_2('tagNamespace') != null && $addFilterTagNamespace(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagNamespace'), Q$String)) , convertToMap($getCriteria(request).jsObj).get_2('tagSemantic') != null && $addFilterTagSemantic(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagSemantic'), Q$String)) , convertToMap($getCriteria(request).jsObj).get_2('tagName') != null && $addFilterTagName(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagName'), Q$String)) , criteria;
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_5(columnName){
  if ($equals_6('fileCount', columnName)) {
    return null;
  }
  return columnName;
}
;
function $onSuccess_159(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function BundleVersionDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2141, 1, {}, BundleVersionDataSource$1_0);
_.onFailure = function onFailure_166(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load bundle version data'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_166(result){
  $onSuccess_159(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $getActionCanvas(this$static){
  var deleteButton, deployButton, layout;
  layout = new EnhancedVLayout_1;
  deployButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Deploy'));
  $setIcon_0(deployButton, ($clinit_IconEnum() , BUNDLE_DEPLOY).icon16x16Path);
  $addClickHandler(deployButton, new BundleView$2_0(this$static));
  $addMember(layout, deployButton);
  deleteButton = new EnhancedIButton_1('Delete');
  $setIcon_0(deleteButton, BUNDLE_DELETE.icon16x16Path);
  $addClickHandler(deleteButton, new BundleView$3_0(this$static));
  $addMember(layout, deleteButton);
  if (!this$static.canManageBundles) {
    $setAttribute_22(deployButton, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , TRUE), true);
    $setAttribute_22(deleteButton, 'disabled', TRUE, true);
  }
  return layout;
}

function $renderView_4(this$static, viewPath){
  var bundleId, criteria, current, view;
  bundleId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  ++viewPath.index_0;
  if (viewPath.viewPath.size_0 <= viewPath.index_0 || viewPath.viewPath.size_0 <= viewPath.index_0 + 1) {
    if (this$static.bundleBeingViewed != bundleId) {
      this$static.bundleBeingViewed = bundleId;
      criteria = new BundleCriteria_0;
      $addFilterId(criteria, valueOf_44(bundleId));
      criteria.fetchBundleVersions = true;
      criteria.fetchDestinations = true;
      criteria.fetchTags = true;
      $findBundlesByCriteriaWithDestinationFilter(dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync), criteria, new BundleView$4_0(this$static, viewPath));
    }
     else if (viewPath.viewPath.size_0 > viewPath.index_0) {
      current = (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path;
      $equals_6('versions', current)?$selectTab_0(this$static.tabs_0, this$static.versionsTab):$equals_6('destinations', current) && $selectTab_0(this$static.tabs_0, this$static.destinationsTab);
      $viewBundle(this$static, this$static.bundle, viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId));
    }
  }
   else {
    this$static.bundleBeingViewed = 0;
    destroyMembers(this$static);
    if ($equals_6((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path, 'versions')) {
      if (viewPath.viewPath.size_0 > viewPath.index_0) {
        view = new BundleVersionView_0(this$static.canManageBundles);
        $addMember(this$static, view);
        $renderView_5(view, (++viewPath.index_0 , viewPath));
      }
    }
     else if ($equals_6((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path, 'deployments')) {
      if (viewPath.viewPath.size_0 <= viewPath.index_0)
      ;
      else {
        view = new BundleDeploymentView_0(this$static.canManageBundles);
        $addMember(this$static, view);
        $renderView_2(view, (++viewPath.index_0 , viewPath));
      }
    }
     else if ($equals_6((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path, 'destinations')) {
      if (viewPath.viewPath.size_0 > viewPath.index_0) {
        view = new BundleDestinationView_0(this$static.canManageBundles);
        $addMember(this$static, view);
        $renderView_3(view, (++viewPath.index_0 , viewPath));
      }
    }
  }
}

function $viewBundle(this$static, bundle, nextViewId){
  var backButton, versionsTab, criteria, destinationsTab, criteria_0, readOnly, tagEditor, actionItem, versionCountItem, destinationsCountItem, descriptionItem;
  destroyMembers(this$static);
  this$static.bundle = bundle;
  backButton = new BackButton_0(($clinit_Enhanced() , 'Back to All Bundles'), ($clinit_BundleTopView() , VIEW_ID_15).title_0);
  this$static.headerLabel = new HeaderLabel_1(($clinit_IconEnum() , BUNDLE_1).icon24x24Path, escapeHtml(bundle.name_0));
  this$static.tabs_0 = new TabSet_0;
  this$static.versionsTab = (versionsTab = new Tab_1('Versions') , criteria = new Criteria_0 , $addCriteria_1(criteria, 'bundleId', valueOf_44(this$static.bundleBeingViewed)) , this$static.bundleVersionsTable = new BundleVersionListView_0(criteria) , $setPane(versionsTab, this$static.bundleVersionsTable) , versionsTab);
  this$static.destinationsTab = (destinationsTab = new Tab_1('Destinations') , criteria_0 = new Criteria_0 , $addCriteria_1(criteria_0, 'bundleId', valueOf_44(this$static.bundle.id)) , $setPane(destinationsTab, new BundleDestinationListView_0(criteria_0)) , destinationsTab);
  $addTab(this$static.tabs_0, this$static.versionsTab);
  $addTab(this$static.tabs_0, this$static.destinationsTab);
  $addMember(this$static, backButton);
  $addMember(this$static, this$static.headerLabel);
  ($clinit_CoreGUI() , $clinit_CoreGUI() , enableTagsForUI) && $addMember(this$static, (readOnly = !this$static.canManageBundles , tagEditor = new TagEditorView_0(this$static.bundle.tags, readOnly, new BundleView$1_0(this$static)) , $isCreated_1(tagEditor)?$setProperty_0(tagEditor, 'height', 1):(tagEditor.config_0['height'] = 1 , undefined) , $isCreated_1(tagEditor)?undefined:(tagEditor.config_0['extraSpace'] = 10 , undefined) , tagEditor));
  $addMember(this$static, (this$static.form_0 = new DynamicForm_0 , $setAttribute_24(this$static.form_0, 'width', '100%', true) , $setColWidths(this$static.form_0, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['20%', '40%', '40%'])) , $setNumCols(this$static.form_0, 3) , $setAutoHeight(this$static.form_0) , $setWrapItemTitles(this$static.form_0, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , $setExtraSpace(this$static.form_0, 10) , $setIsGroup(this$static.form_0, TRUE) , $setGroupTitle(this$static.form_0, 'Summary') , $setPadding(this$static.form_0, valueOf_44(5)) , actionItem = new CanvasItem_1('actions') , $isCreated_2(actionItem)?$setProperty_6(actionItem, 'colSpan', 1):(actionItem.jsObj['colSpan'] = 1 , undefined) , $isCreated_2(actionItem)?$setProperty_6(actionItem, 'rowSpan', 3):(actionItem.jsObj['rowSpan'] = 3 , undefined) , actionItem.setShowTitle(FALSE) , $setCanvas(actionItem, $getActionCanvas(this$static)) , versionCountItem = new StaticTextItem_2('versionCount', 'Versions Count') , $setValue_5(versionCountItem, this$static.bundle.bundleVersions?this$static.bundle.bundleVersions.size_1():0) , destinationsCountItem = new StaticTextItem_2('destinationsCount', 'Destinations Count') , $setValue_5(destinationsCountItem, this$static.bundle.destinations?this$static.bundle.destinations.size_1():0) , descriptionItem = new StaticTextItem_2('description', 'Description') , $setValue_7(descriptionItem, escapeHtml(this$static.bundle.description)) , this$static.form_0.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [versionCountItem, actionItem, destinationsCountItem, descriptionItem])) , this$static.form_0));
  $addMember(this$static, this$static.tabs_0);
  !nextViewId || $equals_6(nextViewId.path, 'versions')?$selectTab_0(this$static.tabs_0, this$static.versionsTab):$equals_6(nextViewId.path, 'destinations') && $selectTab_0(this$static.tabs_0, this$static.destinationsTab);
  $markForRedraw(this$static);
}

function BundleView_0(perms){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.bundleManager = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.canManageBundles = !!perms && perms.contains_0(($clinit_Permission() , MANAGE_BUNDLE));
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $setMargin(this, valueOf_44(10));
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
}

defineSeed(2142, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), BundleView_0);
_.renderView = function renderView_13(viewPath){
  $renderView_4(this, viewPath);
}
;
_.bundle = null;
_.bundleBeingViewed = 0;
_.bundleVersionsTable = null;
_.canManageBundles = false;
_.destinationsTab = null;
_.form_0 = null;
_.headerLabel = null;
_.tabs_0 = null;
_.versionsTab = null;
function BundleView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2143, 1, {}, BundleView$1_0);
_.tagsChanged = function tagsChanged_1(tags){
  $updateBundleTags(dynamicCast(secure(getInstance_56(), -1), Q$TagGWTServiceAsync), this.this$0.bundleBeingViewed, tags, new BundleView$1$1_0);
}
;
_.this$0 = null;
function BundleView$1$1_0(){
}

defineSeed(2144, 1, {}, BundleView$1$1_0);
_.onFailure = function onFailure_167(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update bundle tags'), caught);
}
;
_.onSuccess_0 = function onSuccess_167(result){
  throwClassCastExceptionUnlessNull(result);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have successfully updated the bundle tags'), ($clinit_Message$Severity() , Info)));
}
;
function BundleView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2145, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BundleView$2_0);
_.onClick = function onClick_46(clickEvent){
  var bc, bundleManager;
  bc = new BundleCriteria_0;
  $addFilterId(bc, valueOf_44(this.this$0.bundle.id));
  bundleManager = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  $findBundlesByCriteria(bundleManager, bc, new BundleView$2$1_0(this));
}
;
_.this$0 = null;
function $onSuccess_160(this$static, result){
  if (!result || result.size_0 != 1) {
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Failed to get a single bundle to deploy [' + ($clinit_Enhanced() , this$static.this$1.this$0.bundle.name_0) + ']', ($clinit_Message$Severity() , Error_2)));
    return;
  }
  $startWizard(new BundleDeployWizard_1(dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Bundle).id));
}

function BundleView$2$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2146, 1, {}, BundleView$2$1_0);
_.onFailure = function onFailure_168(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load bundle to deploy [' + ($clinit_Enhanced() , this.this$1.this$0.bundle.name_0) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_168(result){
  $onSuccess_160(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
function BundleView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2147, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BundleView$3_0);
_.onClick = function onClick_47(clickEvent){
  ask(($clinit_Enhanced() , 'Are you sure you want to delete this bundle? All versions, destinations and deployments for this bundle will also be deleted. However, this will not remove any content from remote machines.'), new BundleView$3$1_0(this));
}
;
_.this$0 = null;
function BundleView$3$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2148, 1, {}, BundleView$3$1_0);
_.execute_3 = function execute_28(aBoolean){
  aBoolean.value_0 && $deleteBundle(this.this$1.this$0.bundleManager, this.this$1.this$0.bundleBeingViewed, new BundleView$3$1$1_0(this));
}
;
_.this$1 = null;
function $onSuccess_161(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You successfully deleted the bundle [' + ($clinit_Enhanced() , this$static.this$2.this$1.this$0.bundle.name_0) + ']', ($clinit_Message$Severity() , Info)));
  goToView('Bundles', null, true);
}

function BundleView$3$1$1_0(this$2){
  this.this$2 = this$2;
}

defineSeed(2149, 1, {}, BundleView$3$1$1_0);
_.onFailure = function onFailure_169(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to delete the bundle [' + ($clinit_Enhanced() , this.this$2.this$1.this$0.bundle.name_0) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_169(result){
  $onSuccess_161(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$2 = null;
function $onSuccess_162(this$static, result){
  var bundle;
  if (!result || result.size_0 == 0) {
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'No bundles found in this repository'), ($clinit_Message$Severity() , Error_2)));
    return;
  }
  bundle = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Bundle);
  $viewBundle(this$static.this$0, bundle, $getCurrent(this$static.val$viewPath));
}

function BundleView$4_0(this$0, val$viewPath){
  this.this$0 = this$0;
  this.val$viewPath = val$viewPath;
}

defineSeed(2150, 1, {}, BundleView$4_0);
_.onFailure = function onFailure_170(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load bundle'), caught);
}
;
_.onSuccess_0 = function onSuccess_170(result){
  $onSuccess_162(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$viewPath = null;
function $onSuccess_163(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function BundlesDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2151, 1, {}, BundlesDataSource$1_0);
_.onFailure = function onFailure_171(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load Bundle data'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_171(result){
  $onSuccess_163(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function BundlesListView_0(criteria, perms){
  $clinit_BaseWidget();
  Table_4.call(this, ($clinit_Enhanced() , 'Bundles'), criteria, ($clinit_IconEnum() , BUNDLE_1).icon24x24Path);
  this.permissions = perms;
  $setHeaderIcon(this, BUNDLE_1.icon24x24Path);
  $setDataSource(this, new BundlesWithLatestVersionDataSource_0);
}

function BundlesListView_1(perms){
  $clinit_BaseWidget();
  BundlesListView_0.call(this, null, perms);
}

defineSeed(2152, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), BundlesListView_0, BundlesListView_1);
_.configureTable = function configureTable_19(){
  var descField, hasAuth, idField, latestVersionField, nameField, versionsCountField;
  idField = new ListGridField_3('id', ($clinit_Enhanced() , 'ID'));
  $setAttribute_13(idField, 'type', ($clinit_ListGridFieldType() , INTEGER_0).value_0);
  idField.jsObj['width'] = '50';
  nameField = new ListGridField_3('name', 'Name');
  nameField.jsObj['width'] = '33%';
  $setCellFormatter_0(nameField, new BundlesListView$1_0);
  descField = new ListGridField_3('description', 'Description');
  descField.jsObj['width'] = '33%';
  $setCellFormatter_0(descField, new BundlesListView$2_0);
  latestVersionField = new ListGridField_3('latestVersion', 'Latest Version');
  latestVersionField.jsObj['width'] = '20%';
  $setAttribute_13(latestVersionField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  versionsCountField = new ListGridField_3('deploymentCount', 'Versions Count');
  $setAttribute_13(versionsCountField, 'type', INTEGER_0.value_0);
  versionsCountField.jsObj['width'] = '*';
  $setAttribute_13(versionsCountField, 'align', CENTER_0.value_0);
  $setListGridFields(this, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, nameField, descField, latestVersionField, versionsCountField]));
  $setListGridDoubleClickHandler(this, new BundlesListView$3_0);
  if (this.permissions) {
    hasAuth = this.permissions.contains_0(($clinit_Permission() , MANAGE_BUNDLE));
    $addTableAction(this, 'New', null, null, new BundlesListView$4_0(this, hasAuth?($clinit_TableActionEnablement() , ALWAYS):($clinit_TableActionEnablement() , NEVER_1)));
    $addTableAction(this, 'Delete', 'Are you sure you want to delete the selected bundles? This will delete all of their versions, destinations and deployments from the database. However, this will not remove any content from remote machines.', null, new BundlesListView$5_0(this, hasAuth?($clinit_TableActionEnablement() , ANY_1):($clinit_TableActionEnablement() , NEVER_1)));
    $addTableAction(this, 'Deploy', null, null, new BundlesListView$6_0(this, hasAuth?($clinit_TableActionEnablement() , ALWAYS):($clinit_TableActionEnablement() , NEVER_1)));
  }
}
;
_.permissions = null;
function BundlesListView$1_0(){
}

defineSeed(2153, 1, {}, BundlesListView$1_0);
_.format_1 = function format_19(value, record, i, i1){
  return '<a href="' + getAttribute(record.jsObj, 'namelink') + '">' + escapeHtml('' + value) + '<\/a>';
}
;
function BundlesListView$2_0(){
}

defineSeed(2154, 1, {}, BundlesListView$2_0);
_.format_1 = function format_20(value, record, i, i1){
  return escapeHtml('' + value);
}
;
function BundlesListView$3_0(){
}

defineSeed(2155, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), BundlesListView$3_0);
_.onDoubleClick = function onDoubleClick_3(event_0){
  var listGrid, selectedId, selectedRows;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    selectedId = getAttribute(selectedRows[0].jsObj, 'id');
    $clinit_CoreGUI();
    goToView('#Bundles/Bundle/' + valueOf_44(__parseAndValidateInt(selectedId)).value_0, null, false);
  }
}
;
function BundlesListView$4_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2156, 1608, {}, BundlesListView$4_0);
_.executeAction = function executeAction_32(selection, actionValue){
  $startWizard(new BundleCreateWizard_0);
  $refreshTableInfo(this.this$0);
}
;
_.this$0 = null;
function BundlesListView$5_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2157, 1608, {}, BundlesListView$5_0);
_.executeAction = function executeAction_33(selections, actionValue){
  var bundleManager, doomedIds, doomedNames, i, object, selection, selection$index, selection$max;
  if (selections == null || selections.length == 0) {
    return;
  }
  dynamicCast(this.this$0.dataSource_1, Q$BundlesWithLatestVersionDataSource);
  doomedNames = new ArrayList_1(selections.length);
  doomedIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selections.length, 1);
  i = 0;
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    object = dynamicCast(getAttributeAsObject(selection.jsObj, 'object'), Q$BundleWithLatestVersionComposite);
    $add_3(doomedNames, object.bundleName);
    doomedIds[i++] = object.bundleId.value_0;
  }
  bundleManager = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  $deleteBundles(bundleManager, doomedIds, new BundlesListView$5$1_0(doomedNames));
}
;
_.this$0 = null;
function $onFailure_21(this$static, caught){
  var error, m_0, names;
  names = this$static.val$doomedNames.toString$();
  error = ($clinit_ErrorHandler() , getAllMessages(caught, false, null));
  m_0 = new Message_2(($clinit_Enhanced() , 'Failed to delete the bundles'), names + '<br/>\n' + error, ($clinit_Message$Severity() , Error_2));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), m_0);
}

function $onSuccess_164(this$static){
  var m_0;
  m_0 = new Message_2(($clinit_Enhanced() , 'You successfully deleted the bundles'), this$static.val$doomedNames.toString$(), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), m_0);
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function BundlesListView$5$1_0(val$doomedNames){
  this.val$doomedNames = val$doomedNames;
}

defineSeed(2158, 1, {}, BundlesListView$5$1_0);
_.onFailure = function onFailure_172(caught){
  $onFailure_21(this, caught);
}
;
_.onSuccess_0 = function onSuccess_172(result){
  $onSuccess_164(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$doomedNames = null;
function BundlesListView$6_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2159, 1608, {}, BundlesListView$6_0);
_.executeAction = function executeAction_34(selection, actionValue){
  var bc, bundleManager, object;
  if (selection.length == 0) {
    $startWizard(new BundleDeployWizard_0);
    $refreshTableInfo(this.this$0);
    return;
  }
  dynamicCast(this.this$0.dataSource_1, Q$BundlesWithLatestVersionDataSource);
  object = dynamicCast(getAttributeAsObject(selection[0].jsObj, 'object'), Q$BundleWithLatestVersionComposite);
  bc = new BundleCriteria_0;
  $addFilterId(bc, object.bundleId);
  bundleManager = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  $findBundlesByCriteria(bundleManager, bc, new BundlesListView$6$1_0(this, object));
}
;
_.this$0 = null;
function $onSuccess_165(this$static, result){
  if (!result || result.size_0 != 1) {
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Failed to get a single bundle to be deployed [' + ($clinit_Enhanced() , this$static.val$object.bundleName) + ']', ($clinit_Message$Severity() , Error_2)));
    return;
  }
  $startWizard(new BundleDeployWizard_1(dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Bundle).id));
  $refreshTableInfo(this$static.this$1.this$0);
}

function BundlesListView$6$1_0(this$1, val$object){
  this.this$1 = this$1;
  this.val$object = val$object;
}

defineSeed(2160, 1, {}, BundlesListView$6$1_0);
_.onFailure = function onFailure_173(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load the bundle to be deployed [' + ($clinit_Enhanced() , this.val$object.bundleName) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_173(result){
  $onSuccess_165(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
_.val$object = null;
function $copyValues_28(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_11(record, 'id', from.bundleId);
  $setAttribute_13(record, 'name', from.bundleName);
  $setAttribute_13(record, 'namelink', '#Bundles/Bundle/' + from.bundleId.value_0);
  $setAttribute_13(record, 'description', from.bundleDescription);
  $setAttribute_13(record, 'latestVersion', from.latestVersion);
  $setAttribute_11(record, 'deploymentCount', valueOf_44(toInt(from.versionsCount.value_0)));
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  return record;
}

function $executeFetch_17(this$static, request, response, criteria){
  $findBundlesWithLatestVersionCompositesByCriteria(this$static.bundleService, criteria, new BundlesWithLatestVersionDataSource$1_0(this$static, response, request));
}

function BundlesWithLatestVersionDataSource_0(){
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  fields = new ArrayList_0;
  $addFields(this, fields);
}

defineSeed(2161, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$BundlesWithLatestVersionDataSource]), BundlesWithLatestVersionDataSource_0);
_.copyValues = function copyValues_44(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'object'), Q$BundleWithLatestVersionComposite);
}
;
_.copyValues_0 = function copyValues_45(from){
  return $copyValues_28(dynamicCast(from, Q$BundleWithLatestVersionComposite));
}
;
_.executeFetch = function executeFetch_23(request, response, criteria){
  $executeFetch_17(this, request, response, dynamicCast(criteria, Q$BundleCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_26(request){
  var criteria;
  return criteria = new BundleCriteria_0 , convertToMap($getCriteria(request).jsObj).get_2('tagNamespace') != null && $addFilterTagNamespace(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagNamespace'), Q$String)) , convertToMap($getCriteria(request).jsObj).get_2('tagSemantic') != null && $addFilterTagSemantic(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagSemantic'), Q$String)) , convertToMap($getCriteria(request).jsObj).get_2('tagName') != null && $addFilterTagName(criteria, dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('tagName'), Q$String)) , criteria;
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_6(columnName){
  if ($equals_6('latestVersion', columnName)) {
    return null;
  }
  if ($equals_6('deploymentCount', columnName)) {
    return null;
  }
  return columnName;
}
;
function $onFailure_22(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load bundle with the latest version data'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_166(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function BundlesWithLatestVersionDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2162, 1, {}, BundlesWithLatestVersionDataSource$1_0);
_.onFailure = function onFailure_174(caught){
  $onFailure_22(this, caught);
}
;
_.onSuccess_0 = function onSuccess_174(result){
  $onSuccess_166(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $setCleanDeployment_0(this$static, isCleanDeployment){
  this$static.isCleanDeployment = isCleanDeployment;
}

function $setDeploymentDescription(this$static, deploymentDescription){
  this$static.deploymentDescription = deploymentDescription;
}

function $setLiveDeployment_0(this$static, liveDeployment){
  this$static.liveDeployment = liveDeployment;
}

function $setPreviousDeployment(this$static, previousDeployment){
  this$static.previousDeployment = previousDeployment;
}

defineSeed(2163, 2036, {});
_.deploymentDescription = null;
_.destination = null;
_.isCleanDeployment = false;
_.liveDeployment = null;
_.previousDeployment = null;
function BundleRevertWizard_0(destination){
  var steps, steps_0;
  if (!destination) {
    throw new IllegalArgumentException_1('destination is null');
  }
  this.destination = destination;
  steps = ($setWindowTitle(this, ($clinit_Wizard() , 'Bundle Revert Wizard')) , this.title_0 = 'Bundle Revert' , steps_0 = new ArrayList_0 , this.steps = steps_0 , steps_0);
  $add_3(steps, new ConfirmationStep_0(this));
  $add_3(steps, new GetRevertInfoStep_0(this));
  $add_3(steps, new RevertStep_0(this));
}

defineSeed(2164, 2163, {}, BundleRevertWizard_0);
_.cancel_0 = function cancel_3(){
  return;
}
;
function $setLayout(this$static){
  var c, confirmation, live, liveDescItem, liveForm, liveNameItem, liveVersionItem, prev, prevDescItem, prevForm, prevNameItem, prevVersionItem;
  live = this$static.wizard.liveDeployment;
  prev = this$static.wizard.previousDeployment;
  liveForm = new DynamicForm_0;
  $isCreated_1(liveForm)?$setProperty_0(liveForm, 'numCols', 2):(liveForm.config_0['numCols'] = 2 , undefined);
  $setIsGroup(liveForm, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setGroupTitle(liveForm, '<b>' + ($clinit_WizardStep() , 'Live Deployment') + '<b>');
  liveNameItem = new StaticTextItem_2('liveName', 'Name');
  $setAttribute_30(liveNameItem, 'titleAlign', ($clinit_Alignment() , LEFT_0).value_0);
  $setAttribute_30(liveNameItem, 'align', LEFT_0.value_0);
  $setWrap_1(liveNameItem, FALSE);
  $setWrapTitle(liveNameItem, FALSE);
  $setValue_7(liveNameItem, live.name_0);
  $isCreated_2(liveNameItem)?$setProperty_6(liveNameItem, 'left', 20):(liveNameItem.jsObj['left'] = 20 , undefined);
  liveDescItem = new StaticTextItem_2('liveDesc', 'Description');
  $setAttribute_30(liveDescItem, 'titleAlign', LEFT_0.value_0);
  $setAttribute_30(liveDescItem, 'align', LEFT_0.value_0);
  $setWrap_1(liveDescItem, TRUE);
  $setWrapTitle(liveDescItem, FALSE);
  $setAttribute_30(liveDescItem, 'vAlign', ($clinit_VerticalAlignment() , TOP_2).value_0);
  $setAttribute_30(liveDescItem, 'titleVAlign', TOP_2.value_0);
  $setValue_7(liveDescItem, null != live.description?live.description:'None');
  liveVersionItem = new StaticTextItem_2('liveVersion', 'Bundle Version');
  $setAttribute_30(liveVersionItem, 'titleAlign', LEFT_0.value_0);
  $setAttribute_30(liveVersionItem, 'align', LEFT_0.value_0);
  $setWrap_1(liveVersionItem, FALSE);
  $setWrapTitle(liveVersionItem, FALSE);
  $setValue_7(liveVersionItem, live.bundleVersion.version_0);
  liveForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [liveNameItem, liveVersionItem, liveDescItem]));
  $addMember(this$static.layout, liveForm);
  if (prev) {
    prevForm = new DynamicForm_0;
    $isCreated_1(prevForm)?$setProperty_0(prevForm, 'numCols', 2):(prevForm.config_0['numCols'] = 2 , undefined);
    $setIsGroup(prevForm, TRUE);
    $setGroupTitle(prevForm, '<b>Previous Deployment<b>');
    prevNameItem = new StaticTextItem_2('prevName', 'Name');
    $setAttribute_30(prevNameItem, 'titleAlign', LEFT_0.value_0);
    $setAttribute_30(prevNameItem, 'align', LEFT_0.value_0);
    $setWrap_1(prevNameItem, FALSE);
    $setWrapTitle(prevNameItem, FALSE);
    $setValue_7(prevNameItem, prev.name_0);
    prevDescItem = new StaticTextItem_2('prevDesc', 'Description');
    $setAttribute_30(prevDescItem, 'titleAlign', LEFT_0.value_0);
    $setAttribute_30(prevDescItem, 'align', LEFT_0.value_0);
    $setWrap_1(prevDescItem, TRUE);
    $setWrapTitle(prevDescItem, FALSE);
    $setAttribute_30(prevDescItem, 'titleVAlign', TOP_2.value_0);
    $setAttribute_30(prevDescItem, 'vAlign', TOP_2.value_0);
    $setValue_7(prevDescItem, null != prev.description?prev.description:'None');
    prevVersionItem = new StaticTextItem_2('prevVersion', 'Bundle Version');
    $setAttribute_30(prevVersionItem, 'titleAlign', LEFT_0.value_0);
    $setAttribute_30(prevVersionItem, 'align', LEFT_0.value_0);
    $setWrap_1(prevVersionItem, FALSE);
    $setWrapTitle(prevVersionItem, FALSE);
    if (prev.bundleVersion.version_0 == null) {
      c = new BundleVersionCriteria_0;
      $addFilterId(c, valueOf_44(prev.bundleVersion.id));
      $findBundleVersionsByCriteria(this$static.bundleServer, c, new ConfirmationStep$2_0(prevVersionItem, prevForm));
    }
     else {
      $setValue_7(prevVersionItem, prev.bundleVersion.version_0);
    }
    prevForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [prevNameItem, prevVersionItem, prevDescItem]));
    $addMember(this$static.layout, prevForm);
  }
  confirmation = new Label_3;
  $setContents_0(confirmation, '<b>Reverting Live Deployment to Previous Deployment. Click "Next" to continue...<\/b>');
  $setMargin(confirmation, valueOf_44(20));
  $isCreated_1(confirmation)?$setProperty_3(confirmation, 'width', '100%'):(confirmation.config_0['width'] = '100%' , undefined);
  $addMember(this$static.layout, confirmation);
}

function ConfirmationStep_0(wizard){
  this.bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.wizard = wizard;
}

defineSeed(2165, 2040, makeCastMap([Q$WizardStep]), ConfirmationStep_0);
_.getCanvas = function getCanvas_10(){
  var c;
  if (!this.layout) {
    this.layout = new EnhancedVLayout_0;
    $setMembersMargin(this.layout, 15);
    c = new BundleDeploymentCriteria_0;
    $addFilterDestinationId(c, valueOf_44(this.wizard.destination.id));
    $addFilterIsLive(c, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    c.fetchBundleVersion = true;
    $findBundleDeploymentsByCriteria(this.bundleServer, c, new ConfirmationStep$1_0(this));
  }
  return this.layout;
}
;
_.getName = function getName_18(){
  return $clinit_WizardStep() , 'Revert Deployment Confirmation';
}
;
_.nextPage_0 = function nextPage_9(){
  return this.nextPage;
}
;
_.layout = null;
_.nextPage = true;
_.wizard = null;
function $onSuccess_167(this$static, liveDeployments){
  var c, message, replacedBundleDeploymentId;
  if (1 != liveDeployments.size_0) {
    this$static.this$0.nextPage = false;
    $clinit_WizardStep();
    message = 'No live deployment was found for the destination [' + $toString_9(this$static.this$0.wizard.destination) + ']';
    $showMessage(this$static.this$0.wizard.view, message);
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('No live deployment was found for the destination', message, ($clinit_Message$Severity() , Warning)));
  }
  $setLiveDeployment_0(this$static.this$0.wizard, dynamicCast((checkIndex(0, liveDeployments.size_0) , liveDeployments.array[0]), Q$BundleDeployment));
  replacedBundleDeploymentId = this$static.this$0.wizard.liveDeployment.replacedBundleDeploymentId;
  if (!replacedBundleDeploymentId) {
    this$static.this$0.nextPage = false;
    $clinit_WizardStep();
    message = 'The live deployment [' + $toString_8(this$static.this$0.wizard.liveDeployment) + '] cannot be reverted because there is no prior deployment for the destination [' + $toString_9(this$static.this$0.wizard.destination) + ']';
    $showMessage(this$static.this$0.wizard.view, message);
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('The live deployment cannot be reverted because there is no prior deployment', message, ($clinit_Message$Severity() , Warning)));
  }
  c = new BundleDeploymentCriteria_0;
  c.filterId = replacedBundleDeploymentId;
  $findBundleDeploymentsByCriteria(this$static.this$0.bundleServer, c, new ConfirmationStep$1$1_0(this$static));
}

function ConfirmationStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2166, 1, {}, ConfirmationStep$1_0);
_.onFailure = function onFailure_175(caught){
  var message;
  this.this$0.nextPage = false;
  message = ($clinit_WizardStep() , 'Failed to find live deployment; cannot revert') + ': ' + caught.getMessage();
  $showMessage(this.this$0.wizard.view, message);
  $handleError_0(($clinit_CoreGUI() , 'Failed to find live deployment; cannot revert'), caught);
}
;
_.onSuccess_0 = function onSuccess_175(liveDeployments){
  $onSuccess_167(this, dynamicCast(liveDeployments, Q$PageList));
}
;
_.this$0 = null;
function $onSuccess_168(this$static, replacedBundleDeployments){
  var message;
  if (1 != replacedBundleDeployments.size_0) {
    this$static.this$1.this$0.nextPage = false;
    $clinit_WizardStep();
    message = 'The live deployment [' + $toString_8(this$static.this$1.this$0.wizard.liveDeployment) + '] cannot be reverted because there is no prior deployment for the destination [' + $toString_9(this$static.this$1.this$0.wizard.destination) + ']';
    $showMessage(this$static.this$1.this$0.wizard.view, message);
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('The live deployment cannot be reverted because there is no prior deployment', message, ($clinit_Message$Severity() , Warning)));
  }
  $setPreviousDeployment(this$static.this$1.this$0.wizard, dynamicCast((checkIndex(0, replacedBundleDeployments.size_0) , replacedBundleDeployments.array[0]), Q$BundleDeployment));
  $setLayout(this$static.this$1.this$0);
}

function ConfirmationStep$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2167, 1, {}, ConfirmationStep$1$1_0);
_.onFailure = function onFailure_176(caught){
  var message;
  this.this$1.this$0.nextPage = false;
  $clinit_WizardStep();
  message = 'The live deployment [' + $toString_8(this.this$1.this$0.wizard.liveDeployment) + '] cannot be reverted because there is no prior deployment for the destination [' + $toString_9(this.this$1.this$0.wizard.destination) + ']';
  $showMessage(this.this$1.this$0.wizard.view, message);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('The live deployment cannot be reverted because there is no prior deployment', message, ($clinit_Message$Severity() , Warning)));
}
;
_.onSuccess_0 = function onSuccess_176(replacedBundleDeployments){
  $onSuccess_168(this, dynamicCast(replacedBundleDeployments, Q$PageList));
}
;
_.this$1 = null;
function $onSuccess_169(this$static, result){
  if (!!result && result.size_0 == 1) {
    $setValue_7(this$static.val$prevVersionItem, dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$BundleVersion).version_0);
    $markForRedraw(this$static.val$prevForm);
  }
}

function ConfirmationStep$2_0(val$prevVersionItem, val$prevForm){
  this.val$prevVersionItem = val$prevVersionItem;
  this.val$prevForm = val$prevForm;
}

defineSeed(2168, 1, {}, ConfirmationStep$2_0);
_.onFailure = function onFailure_177(caught){
  $setValue_7(this.val$prevVersionItem, '?');
  $markForRedraw(this.val$prevForm);
}
;
_.onSuccess_0 = function onSuccess_177(result){
  $onSuccess_169(this, dynamicCast(result, Q$PageList));
}
;
_.val$prevForm = null;
_.val$prevVersionItem = null;
function GetRevertInfoStep_0(wizard){
  this.bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.wizard = wizard;
}

defineSeed(2169, 2040, makeCastMap([Q$WizardStep]), GetRevertInfoStep_0);
_.getCanvas = function getCanvas_11(){
  if (!this.form_0) {
    this.form_0 = new DynamicForm_0;
    $setAttribute_24(this.form_0, 'width', '100%', true);
    $setNumCols(this.form_0, 2);
    $setColWidths(this.form_0, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['50%', '*']));
    $getBundleDeploymentName(this.bundleServer, this.wizard.destination.id, -1, this.wizard.previousDeployment.id, new GetRevertInfoStep$1_0(this));
  }
  return this.form_0;
}
;
_.getName = function getName_19(){
  return $clinit_WizardStep() , 'Provide Revert Information';
}
;
_.nextPage_0 = function nextPage_10(){
  return this.form_0.validate_0();
}
;
_.form_0 = null;
_.wizard = null;
function $onSuccess_170(this$static, bundleDeploymentName){
  var cleanDeploymentCBItem, descriptionTextAreaItem, escapedBundleDeploymentName, escapedLiveDesc, escapedPrevDesc, liveDesc, nameTextItem, prevDesc, validator;
  nameTextItem = new StaticTextItem_2('name', ($clinit_WizardStep() , 'Revert Deploy Name'));
  $isCreated_2(nameTextItem)?$setProperty_6(nameTextItem, 'width', 300):(nameTextItem.jsObj['width'] = 300 , undefined);
  escapedBundleDeploymentName = escapeHtml(bundleDeploymentName);
  $setSubtitle(this$static.this$0.wizard, escapedBundleDeploymentName);
  $setValue_7(nameTextItem, escapedBundleDeploymentName);
  descriptionTextAreaItem = new TextAreaItem_2('description', 'Revert Deploy Description');
  $isCreated_2(descriptionTextAreaItem)?$setProperty_6(descriptionTextAreaItem, 'width', 300):(descriptionTextAreaItem.jsObj['width'] = 300 , undefined);
  liveDesc = this$static.this$0.wizard.liveDeployment.description;
  liveDesc = null == liveDesc?this$static.this$0.wizard.liveDeployment.name_0:liveDesc;
  escapedLiveDesc = escapeHtml(liveDesc);
  prevDesc = this$static.this$0.wizard.previousDeployment.description;
  prevDesc = null == prevDesc?this$static.this$0.wizard.previousDeployment.name_0:prevDesc;
  escapedPrevDesc = escapeHtml(prevDesc);
  $setDeploymentDescription(this$static.this$0.wizard, '[REVERT From] ' + escapedLiveDesc + ' [REVERT To] ' + escapedPrevDesc);
  $setValue_7(descriptionTextAreaItem, escapeHtml(this$static.this$0.wizard.deploymentDescription));
  $setValidateOnChange_0(descriptionTextAreaItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setValidateOnExit_0(descriptionTextAreaItem, TRUE);
  validator = new LengthRangeValidator_0;
  $setMin_0(validator, valueOf_44(0));
  $setMax_0(validator, valueOf_44(500));
  $isCreated_2(descriptionTextAreaItem)?$setProperty_7(descriptionTextAreaItem, 'validators', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [validator]))):(descriptionTextAreaItem.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [validator])) , undefined);
  $addChangedHandler(descriptionTextAreaItem, new GetRevertInfoStep$1$1_0(this$static));
  cleanDeploymentCBItem = new CheckboxItem_2('cleanDeployment', 'Clean Deployment? (this will delete an old, existing deploy directory prior to starting the revert deployment)');
  $setValue_9(cleanDeploymentCBItem, this$static.this$0.wizard.isCleanDeployment);
  $addChangedHandler(cleanDeploymentCBItem, new GetRevertInfoStep$1$2_0(this$static));
  this$static.this$0.form_0.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [nameTextItem, descriptionTextAreaItem, cleanDeploymentCBItem]));
}

function GetRevertInfoStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2170, 1, {}, GetRevertInfoStep$1_0);
_.onFailure = function onFailure_178(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to get revert deployment name'), caught);
}
;
_.onSuccess_0 = function onSuccess_178(bundleDeploymentName){
  $onSuccess_170(this, dynamicCast(bundleDeploymentName, Q$String));
}
;
_.this$0 = null;
function GetRevertInfoStep$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2171, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GetRevertInfoStep$1$1_0);
_.onChanged = function onChanged_28(event_0){
  var value;
  value = $getValue_2(event_0);
  value == null && (value = '');
  $setDeploymentDescription(this.this$1.this$0.wizard, toString__devirtual$(value));
}
;
_.this$1 = null;
function GetRevertInfoStep$1$2_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2172, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GetRevertInfoStep$1$2_0);
_.onChanged = function onChanged_29(event_0){
  $setCleanDeployment_0(this.this$1.this$0.wizard, dynamicCast($getValue_2(event_0), Q$Boolean).value_0);
}
;
_.this$1 = null;
function RevertStep_0(wizard){
  this.bundleServer = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.wizard = wizard;
}

defineSeed(2173, 2040, makeCastMap([Q$WizardStep]), RevertStep_0);
_.getCanvas = function getCanvas_12(){
  var deployingImage, deployingMessage;
  if (!this.canvas_0) {
    this.canvas_0 = new EnhancedVLayout_0;
    $setAttribute_24(this.canvas_0, 'width', '100%', true);
    $setAttribute_24(this.canvas_0, 'height', '100%', true);
    $setAttribute_24(this.canvas_0, 'align', ($clinit_Alignment() , CENTER_0).value_0, true);
    deployingImage = new Img_1('/images/status-bar.gif');
    $setAttribute_24(deployingImage, 'layoutAlign', CENTER_0.value_0, false);
    $isCreated_1(deployingImage)?$setProperty_0(deployingImage, 'width', 50):(deployingImage.config_0['width'] = 50 , undefined);
    $isCreated_1(deployingImage)?$setProperty_0(deployingImage, 'height', 15):(deployingImage.config_0['height'] = 15 , undefined);
    deployingMessage = new Label_1(($clinit_WizardStep() , 'Reverting...'));
    $setHorizontalAlignment(deployingMessage, ($clinit_HasHorizontalAlignment() , ALIGN_CENTER));
    $addMember(this.canvas_0, deployingImage);
    $addMember(this.canvas_0, new WidgetCanvas_0(deployingMessage));
    $scheduleRevertBundleDeployment(this.bundleServer, this.wizard.destination.id, this.wizard.deploymentDescription, this.wizard.isCleanDeployment, new RevertStep$1_0(deployingImage, deployingMessage));
  }
  return this.canvas_0;
}
;
_.getName = function getName_20(){
  return $clinit_WizardStep() , 'Deploy Bundle to Destination Platforms';
}
;
_.nextPage_0 = function nextPage_11(){
  return true;
}
;
_.canvas_0 = null;
_.wizard = null;
function $onFailure_23(this$static, caught){
  this$static.val$deployingImage.setSrc('/images/status_error.gif');
  $setText(this$static.val$deployingMessage, ($clinit_WizardStep() , 'Failed to schedule revert deployment!'));
  $handleError_0(($clinit_CoreGUI() , 'Failed to schedule revert deployment!'), caught);
}

function $onSuccess_171(this$static, result){
  this$static.val$deployingImage.setSrc('/images/status_complete.gif');
  $setText(this$static.val$deployingMessage, ($clinit_WizardStep() , 'You have successfully scheduled the revert deployment!'));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully scheduled to revert the bundle deployment [' + result.name_0 + '] from resource group [' + result.destination.group.name_0 + ']', ($clinit_Message$Severity() , Info)));
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function RevertStep$1_0(val$deployingImage, val$deployingMessage){
  this.val$deployingImage = val$deployingImage;
  this.val$deployingMessage = val$deployingMessage;
}

defineSeed(2174, 1, {}, RevertStep$1_0);
_.onFailure = function onFailure_179(caught){
  $onFailure_23(this, caught);
}
;
_.onSuccess_0 = function onSuccess_179(result){
  $onSuccess_171(this, dynamicCast(result, Q$BundleDeployment));
}
;
_.val$deployingImage = null;
_.val$deployingMessage = null;
function $buildRecordsForKnownBundle(this$static, dataObjects, bundleId){
  var bundle, deploy, deploy$iterator, deploymentsNode, dest, item, item$iterator, records, versionNode;
  if (!dataObjects) {
    return null;
  }
  records = new ArrayList_0;
  for (item$iterator = new AbstractList$IteratorImpl_0(dataObjects); item$iterator.i < item$iterator.this$0_0.size_1();) {
    item = $next_0(item$iterator);
    $add_3(records, $copyValuesForKnownBundle(item, null));
    if (instanceOf(item, Q$Bundle)) {
      bundle = dynamicCast(item, Q$Bundle);
      versionNode = new TreeNode_2('Versions');
      versionNode.setID(bundle.id + '_versions');
      versionNode.setParentID('' + bundle.id);
      versionNode.setName('Versions');
      versionNode.jsObj['name'] = 'Versions';
      setCheck(records.array, records.size_0++, versionNode);
      deploymentsNode = new TreeNode_2('Destinations');
      deploymentsNode.setID(bundle.id + '_destinations');
      deploymentsNode.setParentID('' + bundle.id);
      deploymentsNode.setName('Destinations');
      setCheck(records.array, records.size_0++, deploymentsNode);
    }
     else if (instanceOf(item, Q$BundleDestination)) {
      if (this$static.canManageBundles) {
        dest = dynamicCast(item, Q$BundleDestination);
        if (dest.deployments) {
          for (deploy$iterator = dest.deployments.iterator(); deploy$iterator.hasNext();) {
            deploy = dynamicCast(deploy$iterator.next_0(), Q$BundleDeployment);
            $add_3(records, $copyValuesForKnownBundle(deploy, bundleId));
          }
        }
      }
    }
  }
  return dynamicCast($toArray_1(records, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, records.size_0, 0)), Q$ListGridRecord_$1);
}

function $copyValuesForKnownBundle(from, bundleId){
  var bundle, deployment, destination, name_0, node, parentID, version;
  node = new TreeNode_0;
  if (instanceOf(from, Q$Bundle)) {
    bundle = dynamicCast(from, Q$Bundle);
    node.jsObj['isFolder'] = true;
    node.jsObj['icon'] = 'subsystems/bundle/Bundle_16.png';
    node.setID('' + bundle.id);
    node.setName(escapeHtml(bundle.name_0));
  }
   else if (instanceOf(from, Q$BundleVersion)) {
    version = dynamicCast(from, Q$BundleVersion);
    node.jsObj['isFolder'] = false;
    node.jsObj['icon'] = 'subsystems/bundle/BundleVersion_16.png';
    parentID = version.bundle.id + '_versions';
    node.setParentID(parentID);
    node.setID(parentID + '_' + version.id);
    node.setName(version.version_0);
  }
   else if (instanceOf(from, Q$BundleDeployment)) {
    deployment = dynamicCast(from, Q$BundleDeployment);
    node.jsObj['isFolder'] = false;
    node.jsObj['icon'] = 'subsystems/bundle/BundleDeployment_16.png';
    parentID = bundleId + '_destinations_' + deployment.destination.id;
    node.setParentID(parentID);
    node.setID(bundleId + '_deployments_' + deployment.id);
    name_0 = escapeHtml(deployment.name_0);
    deployment.isLive?node.setName('<span style="color: green; font-weight: bold">(live)<\/span> ' + name_0):node.setName(name_0);
  }
   else if (instanceOf(from, Q$BundleDestination)) {
    destination = dynamicCast(from, Q$BundleDestination);
    node.jsObj['isFolder'] = true;
    node.jsObj['icon'] = 'subsystems/bundle/BundleDestination_16.png';
    parentID = destination.bundle.id + '_destinations';
    node.setParentID(parentID);
    node.setID(parentID + '_' + destination.id);
    node.setName(escapeHtml(destination.name_0));
  }
  return node;
}

function $executeFetch_18(this$static, request, response){
  var bundleId, criteria, p;
  p = $getAttribute($getCriteria(request), 'parentId');
  if (p == null) {
    criteria = new BundleCriteria_0;
    criteria.fetchDestinations = true;
    $findBundlesByCriteria(this$static.bundleService, criteria, new BundleTreeDataSource$1_0(this$static, response, request));
  }
   else {
    if ($endsWith(p, '_versions')) {
      bundleId = __parseAndValidateInt($substring_0(p, 0, p.indexOf('_')));
      criteria = new BundleVersionCriteria_0;
      $addFilterBundleId_1(criteria, valueOf_44(bundleId));
      $findBundleVersionsByCriteria(this$static.bundleService, criteria, new BundleTreeDataSource$2_0(this$static, response, request));
    }
     else if ($endsWith(p, '_deployments')) {
      bundleId = __parseAndValidateInt($substring_0(p, 0, p.indexOf('_')));
      criteria = new BundleDeploymentCriteria_0;
      criteria.fetchBundleVersion = true;
      $addFilterBundleId(criteria, valueOf_44(bundleId));
      $findBundleDeploymentsByCriteria(this$static.bundleService, criteria, new BundleTreeDataSource$3_0(this$static, response, request));
    }
     else if ($endsWith(p, '_destinations')) {
      bundleId = __parseAndValidateInt($substring_0(p, 0, p.indexOf('_')));
      criteria = new BundleDestinationCriteria_0;
      $addFilterBundleId_0(criteria, valueOf_44(bundleId));
      criteria.fetchDeployments = true;
      $findBundleDestinationsByCriteria(this$static.bundleService, criteria, new BundleTreeDataSource$4_0(this$static, response, bundleId, request));
    }
  }
}

function BundleTreeDataSource_0(canManageBundles){
  var fields_0, idDataField, nameDataField, parentIdField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.bundleService = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.canManageBundles = canManageBundles;
  fields = (fields_0 = new ArrayList_0 , idDataField = new DataSourceTextField_1('id', 'ID') , $setAttribute_8(idDataField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , setCheck(fields_0.array, fields_0.size_0++, idDataField) , nameDataField = new DataSourceTextField_1('name', 'Name') , $setAttribute_8(nameDataField, 'canEdit', FALSE) , setCheck(fields_0.array, fields_0.size_0++, nameDataField) , parentIdField = new DataSourceTextField_1('parentId', 'Parent ID') , parentIdField.jsObj['foreignKey'] = 'id' , setCheck(fields_0.array, fields_0.size_0++, parentIdField) , fields_0);
  $addFields(this, fields);
}

defineSeed(2175, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), BundleTreeDataSource_0);
_.buildRecords = function buildRecords_0(dataObjects){
  return $buildRecordsForKnownBundle(this, dataObjects, null);
}
;
_.copyValues = function copyValues_46(from){
  return null;
}
;
_.copyValues_0 = function copyValues_47(from){
  return $copyValuesForKnownBundle(from, null);
}
;
_.executeFetch = function executeFetch_24(request, response, unused){
  $executeFetch_18(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_27(request){
  return null;
}
;
_.canManageBundles = false;
function $onSuccess_172(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecordsForKnownBundle(this$static.this$0, result, null));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function BundleTreeDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2176, 1, {}, BundleTreeDataSource$1_0);
_.onFailure = function onFailure_180(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load bundle data'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_180(result){
  $onSuccess_172(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_173(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecordsForKnownBundle(this$static.this$0, result, null));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function BundleTreeDataSource$2_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2177, 1, {}, BundleTreeDataSource$2_0);
_.onFailure = function onFailure_181(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load bundle data'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_181(result){
  $onSuccess_173(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_174(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecordsForKnownBundle(this$static.this$0, result, null));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function BundleTreeDataSource$3_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2178, 1, {}, BundleTreeDataSource$3_0);
_.onFailure = function onFailure_182(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load bundle data'), caught);
}
;
_.onSuccess_0 = function onSuccess_182(result){
  $onSuccess_174(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_175(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecordsForKnownBundle(this$static.this$0, result, valueOf_44(this$static.val$bundleId)));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function BundleTreeDataSource$4_0(this$0, val$response, val$bundleId, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$bundleId = val$bundleId;
  this.val$request = val$request;
}

defineSeed(2179, 1, {}, BundleTreeDataSource$4_0);
_.onFailure = function onFailure_183(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load bundle data'), caught);
}
;
_.onSuccess_0 = function onSuccess_183(result){
  $onSuccess_175(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$bundleId = 0;
_.val$request = null;
_.val$response = null;
function $selectPath(this$static, viewPath){
  var key, node, tempKey, theTree, view, view$iterator, self_0;
  theTree = getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static, 'data'));
  if (viewPath.viewPath.size_0 - viewPath.index_0 - 1 > 0) {
    key = '';
    for (view$iterator = new AbstractList$IteratorImpl_0(new AbstractList$SubList_0(viewPath.viewPath, 2, viewPath.viewPath.size_0)); view$iterator.i < view$iterator.this$0_0.size_1();) {
      view = dynamicCast($next_0(view$iterator), Q$ViewId);
      key.length > 0 && (key += '_');
      key += view.path;
      node = $findById(theTree, key);
      if (!node) {
        if ($endsWith(key, 'deployments')) {
          tempKey = $replace_1(key, 'deployments', 'destinations');
          node = $findById(theTree, tempKey);
        }
      }
      if (node) {
        $openFolder(theTree, node);
        $endsWith(key, 'deployments') && $openFolders(theTree, $getChildren(theTree, node));
      }
       else {
        this$static.pendingPath = new ViewPath_0($toString_22(viewPath));
        return;
      }
    }
    this$static.pendingPath = null;
    runAsync(3, new BundleTreeView$3_0(this$static, key));
  }
   else {
    $deselectAllRecords(this$static);
    $getTotalRows(this$static) > 0 && (self_0 = this$static.getOrCreateJsObj() , self_0.selectRecord(0) , undefined);
  }
}

function BundleTreeView_0(canManageBundles){
  $clinit_BaseWidget();
  TreeGrid_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $setLeaveScrollbarGap(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAutoFetchData_0(this, TRUE);
  $setAnimateFolders(this, FALSE);
  $setAttribute_24(this, 'selectionType', ($clinit_SelectionStyle() , SINGLE).value_0, true);
  $setShowRollOver_2(this, FALSE);
  $isCreated_1(this)?$setProperty_3(this, 'sortField', 'name'):(this.config_0['sortField'] = 'name' , undefined);
  $setShowHeader_0(this, FALSE);
  $setAttribute_20(this, 'dataSource', $getOrCreateJsObj(new BundleTreeDataSource_0(canManageBundles)), true);
  $addNodeClickHandler(this, new BundleTreeView$1_0);
}

defineSeed(2180, 575, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$TreeGrid]), BundleTreeView_0);
_.onInit = function onInit_29(){
  $onInit(this);
  $onInit_ListGrid(this);
  $onInit_TreeGrid(this);
  $addDataArrivedHandler_0(this, new BundleTreeView$2_0(this));
}
;
_.pendingPath = null;
function BundleTreeView$1_0(){
}

defineSeed(2181, 1, makeCastMap([Q$EventHandler, Q$NodeClickHandler]), BundleTreeView$1_0);
_.onNodeClick = function onNodeClick(event_0){
  var node, path;
  node = $getNode(event_0);
  path = $replaceAll(getAttribute(node.jsObj, 'id'), '_', '/');
  $clinit_CoreGUI();
  goToView('Bundles/Bundle/' + path, null, false);
}
;
function BundleTreeView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2182, 1, makeCastMap([Q$EventHandler, Q$DataArrivedHandler_0]), BundleTreeView$2_0);
_.onDataArrived = function onDataArrived(dataArrivedEvent){
  !!this.this$0.pendingPath && $selectPath(this.this$0, this.this$0.pendingPath);
}
;
_.this$0 = null;
function BundleVersionListView_0(criteria){
  $clinit_BaseWidget();
  Table_3.call(this, ($clinit_Enhanced() , 'Bundle Versions'), criteria);
  this.headerIcons.size_0 > 0 && $clear_2(this.headerIcons);
  $add_3(this.headerIcons, 'subsystems/bundle/BundleVersion_24.png');
  $setDataSource(this, new BundleVersionDataSource_0);
}

defineSeed(2184, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), BundleVersionListView_0);
_.configureTable = function configureTable_20(){
  var descriptionField, fileCountField, idField, nameField, versionField;
  idField = new ListGridField_3('id', ($clinit_Enhanced() , 'ID'));
  versionField = new ListGridField_3('version', 'Version');
  $setCellFormatter_0(versionField, new BundleVersionListView$1_0);
  nameField = new ListGridField_3('name', 'Name');
  descriptionField = new ListGridField_3('description', 'Description');
  fileCountField = new ListGridField_3('fileCount', 'Bundle Files');
  idField.jsObj['width'] = 50;
  versionField.jsObj['width'] = '20%';
  nameField.jsObj['width'] = '25%';
  descriptionField.jsObj['width'] = '*';
  fileCountField.jsObj['width'] = '10%';
  $setListGridFields(this, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, versionField, nameField, descriptionField, fileCountField]));
  $setListGridDoubleClickHandler(this, new BundleVersionListView$2_0);
}
;
_.getDefaultSelectionStyle = function getDefaultSelectionStyle_0(){
  return $clinit_SelectionStyle() , SINGLE;
}
;
function BundleVersionListView$1_0(){
}

defineSeed(2185, 1, {}, BundleVersionListView$1_0);
_.format_1 = function format_21(o, listGridRecord, i, i1){
  var _bundleId, _bvId;
  _bundleId = getAttributeAsInt(listGridRecord.jsObj, 'bundleId');
  _bvId = getAttributeAsInt(listGridRecord.jsObj, 'id');
  return '<a href="' + getBundleVersionLink(_bundleId.value_0, _bvId.value_0) + '">' + o + '<\/a>';
}
;
function BundleVersionListView$2_0(){
}

defineSeed(2186, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), BundleVersionListView$2_0);
_.onDoubleClick = function onDoubleClick_4(event_0){
  var listGrid, selectedId, selectedRows, selectedVersionId;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    selectedId = getAttribute(selectedRows[0].jsObj, 'bundleId');
    selectedVersionId = getAttribute(selectedRows[0].jsObj, 'id');
    $clinit_CoreGUI();
    goToView(getBundleVersionLink(valueOf_44(__parseAndValidateInt(selectedId)).value_0, valueOf_44(__parseAndValidateInt(selectedVersionId)).value_0), null, false);
  }
}
;
function $renderView_5(this$static, viewPath){
  var bundleVersionId, criteria;
  bundleVersionId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  criteria = new BundleVersionCriteria_0;
  $addFilterId(criteria, valueOf_44(bundleVersionId));
  criteria.fetchBundle = true;
  criteria.fetchBundleFiles = true;
  criteria.fetchBundleDeployments = true;
  criteria.fetchConfigurationDefinition = true;
  criteria.fetchTags = true;
  $findBundleVersionsByCriteriaWithDestinationFilter(this$static.bundleManager, criteria, new BundleVersionView$4_0(this$static, viewPath));
}

function $viewBundleVersion(this$static, version, nextViewId){
  var tabs, readOnly, tagEditor, form, actionItem, actionLayout, deleteButton, versionItem, liveDeploymentsItem, filesItems, descriptionItem, tab, form_0, recipeCanvas, tab_0, criteria, tab_1, filesView;
  destroyMembers(this$static);
  this$static.version_0 = version;
  $addMember(this$static, new BackButton_0(($clinit_Enhanced() , 'Back to Bundle') + ': ' + version.bundle.name_0, '#Bundles/Bundle/' + version.bundle.id));
  $addMember(this$static, new HeaderLabel_1(getImgURL('subsystems/bundle/BundleVersion_24.png'), version.name_0 + ': ' + version.version_0));
  ($clinit_CoreGUI() , $clinit_CoreGUI() , enableTagsForUI) && $addMember(this$static, (readOnly = !this$static.canManageBundles , tagEditor = new TagEditorView_0(this$static.version_0.tags, readOnly, new BundleVersionView$2_0(this$static)) , $isCreated_1(tagEditor)?$setProperty_0(tagEditor, 'height', 1):(tagEditor.config_0['height'] = 1 , undefined) , $isCreated_1(tagEditor)?undefined:(tagEditor.config_0['extraSpace'] = 10 , undefined) , tagEditor));
  $addMember(this$static, (form = new DynamicForm_0 , $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined) , $isCreated_1(form)?$setProperty_2(form, 'colWidths', convertToJavaScriptArray(initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['20%', '40%', '40%']))):(form.config_0['colWidths'] = convertToJavaScriptArray(initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['20%', '40%', '40%'])) , undefined) , $isCreated_1(form)?$setProperty_0(form, 'numCols', 3):(form.config_0['numCols'] = 3 , undefined) , $isCreated_1(form)?$setProperty_0(form, 'height', 1):(form.config_0['height'] = 1 , undefined) , $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , $isCreated_1(form)?undefined:(form.config_0['extraSpace'] = 10 , undefined) , $setIsGroup(form, TRUE) , $setGroupTitle(form, 'Summary') , $setPadding(form, valueOf_44(5)) , actionItem = new CanvasItem_1('actions') , $isCreated_2(actionItem)?$setProperty_6(actionItem, 'colSpan', 1):(actionItem.jsObj['colSpan'] = 1 , undefined) , $isCreated_2(actionItem)?$setProperty_6(actionItem, 'rowSpan', 4):(actionItem.jsObj['rowSpan'] = 4 , undefined) , actionItem.setShowTitle(FALSE) , $setCanvas(actionItem, (actionLayout = new EnhancedVLayout_1 , deleteButton = new EnhancedIButton_1('Delete') , $isCreated_1(deleteButton)?$setProperty_3(deleteButton, 'icon', 'subsystems/bundle/BundleVersionAction_Delete_16.png'):(deleteButton.config_0['icon'] = 'subsystems/bundle/BundleVersionAction_Delete_16.png' , undefined) , $addClickHandler(deleteButton, new BundleVersionView$1_0(this$static)) , $addMember(actionLayout, deleteButton) , this$static.canManageBundles || $setAttribute_22(deleteButton, 'disabled', TRUE, true) , actionLayout)) , versionItem = new StaticTextItem_2('version', 'Version') , $setValue_7(versionItem, this$static.version_0.version_0) , liveDeploymentsItem = new StaticTextItem_2('deployments', 'Deployments') , $setValue_5(liveDeploymentsItem, this$static.version_0.bundleDeployments.size_1()) , filesItems = new StaticTextItem_2('files', 'Files') , $setValue_5(filesItems, this$static.version_0.bundleFiles.size_1()) , descriptionItem = new StaticTextItem_2('description', 'Description') , $setValue_7(descriptionItem, this$static.version_0.description) , form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [versionItem, actionItem, liveDeploymentsItem, filesItems, descriptionItem])) , form));
  tabs = new TabSet_0;
  $addTab(tabs, (tab = new Tab_1('Recipe') , form_0 = new DynamicForm_0 , recipeCanvas = new TextAreaItem_2('recipe', 'Recipe') , $setShowTitle_0(recipeCanvas, FALSE) , $isCreated_2(recipeCanvas)?$setProperty_6(recipeCanvas, 'colSpan', 2):(recipeCanvas.jsObj['colSpan'] = 2 , undefined) , $setWidth_2(recipeCanvas, '100%') , $setHeight_1(recipeCanvas, '100%') , $setValue_7(recipeCanvas, this$static.version_0.recipe) , $addChangeHandler(recipeCanvas, new BundleVersionView$3_0) , $isCreated_1(form_0)?$setProperty_3(form_0, 'height', '100%'):(form_0.config_0['height'] = '100%' , undefined) , $isCreated_1(form_0)?$setProperty_3(form_0, 'width', '100%'):(form_0.config_0['width'] = '100%' , undefined) , form_0.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [recipeCanvas])) , !tab.tabSet || !$isCreated_1(tab.tabSet)?$setAttribute_5(tab, 'pane', $getOrCreateJsObj_0(form_0)):$updateTab(tab.tabSet, tab, form_0) , tab));
  $addTab(tabs, (tab_0 = new Tab_1('Deployments') , criteria = new Criteria_0 , $setAttribute_3(criteria, 'bundleVersionId', this$static.version_0.id) , $setPane(tab_0, new BundleDeploymentListView_0(criteria, this$static.canManageBundles)) , tab_0));
  $addTab(tabs, (tab_1 = new Tab_1('Files') , filesView = new FileListView_0(this$static.version_0.id) , !tab_1.tabSet || !$isCreated_1(tab_1.tabSet)?$setAttribute_5(tab_1, 'pane', $getOrCreateJsObj_0(filesView)):$updateTab(tab_1.tabSet, tab_1, filesView) , tab_1));
  $addMember(this$static, tabs);
  !!nextViewId && ($equals_6(nextViewId.path, 'recipe')?$selectTab(tabs, 0):$equals_6(nextViewId.path, 'deployments')?$selectTab(tabs, 1):$equals_6(nextViewId.path, 'files')?$selectTab(tabs, 2):$selectTab(tabs, 0));
  $markForRedraw(this$static);
}

function BundleVersionView_0(canManageBundles){
  EnhancedVLayout_0.call(this);
  this.bundleManager = dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync);
  this.canManageBundles = canManageBundles;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(2187, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), BundleVersionView_0);
_.renderView = function renderView_14(viewPath){
  $renderView_5(this, viewPath);
}
;
_.canManageBundles = false;
_.version_0 = null;
function BundleVersionView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2188, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BundleVersionView$1_0);
_.onClick = function onClick_48(clickEvent){
  ask(($clinit_Enhanced() , 'Are you sure you want to delete this bundle version? This will not remove any content from remote machines.'), new BundleVersionView$1$1_0(this));
}
;
_.this$0 = null;
function BundleVersionView$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2189, 1, {}, BundleVersionView$1$1_0);
_.execute_3 = function execute_29(aBoolean){
  aBoolean.value_0 && $deleteBundleVersion(this.this$1.this$0.bundleManager, this.this$1.this$0.version_0.id, false, new BundleVersionView$1$1$1_0(this));
}
;
_.this$1 = null;
function $onSuccess_176(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You successfully deleted the bundle version [' + ($clinit_Enhanced() , this$static.this$2.this$1.this$0.version_0.version_0) + ']', ($clinit_Message$Severity() , Info)));
  goToView(getBundleVersionLink(this$static.this$2.this$1.this$0.version_0.bundle.id, 0), null, true);
}

function BundleVersionView$1$1$1_0(this$2){
  this.this$2 = this$2;
}

defineSeed(2190, 1, {}, BundleVersionView$1$1$1_0);
_.onFailure = function onFailure_185(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to delete the bundle version [' + ($clinit_Enhanced() , this.this$2.this$1.this$0.version_0.version_0) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_185(result){
  $onSuccess_176(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$2 = null;
function BundleVersionView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2191, 1, {}, BundleVersionView$2_0);
_.tagsChanged = function tagsChanged_2(tags){
  $updateBundleVersionTags(dynamicCast(secure(getInstance_56(), -1), Q$TagGWTServiceAsync), this.this$0.version_0.id, tags, new BundleVersionView$2$1_0);
}
;
_.this$0 = null;
function BundleVersionView$2$1_0(){
}

defineSeed(2192, 1, {}, BundleVersionView$2$1_0);
_.onFailure = function onFailure_186(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update bundle version tags'), caught);
}
;
_.onSuccess_0 = function onSuccess_186(result){
  throwClassCastExceptionUnlessNull(result);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have successfully updated the bundle version tags'), ($clinit_Message$Severity() , Info)));
}
;
function BundleVersionView$3_0(){
}

defineSeed(2193, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), BundleVersionView$3_0);
_.onChange = function onChange_1(event_0){
  event_0.cancel = true;
}
;
function $onSuccess_177(this$static, result){
  var nextPath, version;
  version = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$BundleVersion);
  nextPath = $getCurrent($next_6(this$static.val$viewPath));
  $viewBundleVersion(this$static.this$0, version, nextPath);
}

function BundleVersionView$4_0(this$0, val$viewPath){
  this.this$0 = this$0;
  this.val$viewPath = val$viewPath;
}

defineSeed(2194, 1, {}, BundleVersionView$4_0);
_.onFailure = function onFailure_187(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load bundle version'), caught);
}
;
_.onSuccess_0 = function onSuccess_187(result){
  $onSuccess_177(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$viewPath = null;
function $buildRecords_1(files){
  var file, file$iterator, i, packageVersion, record, records, size;
  records = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, files.size_0, 0);
  i = 0;
  for (file$iterator = new AbstractList$IteratorImpl_0(files); file$iterator.i < file$iterator.this$0_0.size_1();) {
    file = dynamicCast($next_0(file$iterator), Q$BundleFile);
    record = new ListGridRecord_0;
    packageVersion = file.packageVersion;
    $setAttribute_3(record, 'id', file.id);
    $setAttribute_13(record, 'name', $returnValueOrUnknown(packageVersion.fileName));
    $setAttribute_13(record, 'md5', $returnValueOrUnknown(packageVersion.md5));
    $setAttribute_13(record, 'sha256', $returnValueOrUnknown(packageVersion.sha256));
    $setAttribute_13(record, 'version', $returnValueOrUnknown(packageVersion.version_0));
    size = packageVersion.fileSize;
    size?$setAttribute_13(record, 'fileSize', ($clinit_MeasurementConverterClient() , format_91(new Double_0(toDouble(size.value_0)), ($clinit_MeasurementUnits() , BYTES)))):$setAttribute_13(record, 'fileSize', ($clinit_Enhanced() , 'N/A'));
    setCheck(records, i++, record);
  }
  return records;
}

function $returnValueOrUnknown(val){
  return val != null && val.length > 0?val:($clinit_Enhanced() , 'N/A');
}

function $viewFiles(this$static, files){
  var id, listGrid, name_0, sha256, size, table, version;
  table = new Table_2(($clinit_Enhanced() , 'Bundle Files'));
  table.showFooterRefresh = false;
  id = new ListGridField_3('id', 'ID');
  name_0 = new ListGridField_3('name', 'Name');
  size = new ListGridField_3('fileSize', 'File Size');
  sha256 = new ListGridField_3('sha256', 'SHA256');
  version = new ListGridField_3('version', 'Version');
  id.jsObj['width'] = '50';
  $setAttribute_8(name_0, 'autoFitWidth', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_13(name_0, 'autoFitWidthApproach', ($clinit_AutoFitWidthApproach() , BOTH).value_0);
  $setAttribute_8(size, 'autoFitWidth', TRUE);
  $setAttribute_13(size, 'autoFitWidthApproach', BOTH.value_0);
  $setAttribute_8(sha256, 'autoFitWidth', TRUE);
  $setAttribute_13(sha256, 'autoFitWidthApproach', BOTH.value_0);
  $setAttribute_8(version, 'autoFitWidth', TRUE);
  $setAttribute_13(version, 'autoFitWidthApproach', BOTH.value_0);
  $addMember(this$static, table);
  listGrid = table.listGrid;
  $isCreated_1(listGrid)?$setProperty_2(listGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [id, name_0, size, sha256, version]))):(listGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [id, name_0, size, sha256, version])) , undefined);
  $setData(listGrid, $buildRecords_1(files));
  table.tableActionDisableOverride = true;
  table.refreshTableInfo();
}

function FileListView_0(bundleVersionId){
  EnhancedVLayout_0.call(this);
  this.bundleVersionId = bundleVersionId;
}

defineSeed(2195, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), FileListView_0);
_.onDraw_0 = function onDraw_15(){
  var criteria;
  criteria = new BundleFileCriteria_0;
  $addFilterBundleVersionId_0(criteria, valueOf_44(this.bundleVersionId));
  criteria.fetchPackageVersion = true;
  $findBundleFilesByCriteria(dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync), criteria, new FileListView$1_0(this));
}
;
_.bundleVersionId = 0;
function $onSuccess_178(this$static, result){
  $viewFiles(this$static.this$0, result);
}

function FileListView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2196, 1, {}, FileListView$1_0);
_.onFailure = function onFailure_188(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load bundle file data'), caught);
}
;
_.onSuccess_0 = function onSuccess_188(result){
  $onSuccess_178(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function FullHTMLPane_0(url){
  $clinit_BaseWidget();
  HTMLPane_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $setAttribute_24(this, 'contentsType', ($clinit_ContentsType() , PAGE).value_0, false);
  $isCreated_1(this)?$setProperty_3(this, 'contentsURL', url):(this.config_0['contentsURL'] = url , undefined);
}

defineSeed(2199, 448, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), FullHTMLPane_0);
function HeaderLabel_0(contents){
  $clinit_BaseWidget();
  HTMLFlow_1.call(this, contents);
  $isCreated_1(this)?$setProperty_0(this, 'height', 50):(this.config_0['height'] = 50 , undefined);
  setStylePrimaryName($getElement(this), 'HeaderLabel');
  $isCreated_1(this)?$setProperty_3(this, 'styleName', 'HeaderLabel'):(this.config_0['styleName'] = 'HeaderLabel' , undefined);
}

function HeaderLabel_1(icon, contents){
  HeaderLabel_0.call(this, '<img src="' + getImgURL(icon) + '" style="vertical-align: middle;"/> ' + contents);
}

defineSeed(2200, 447, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), HeaderLabel_0, HeaderLabel_1);
function $addQueryParameter(this$static, parameterName, parameterValue){
  parameterValue != null && $append_12($append_12($append_12($append_12(this$static.queryString, parameterName), '='), parameterValue), '&');
}

function $addQueryParameter_0(this$static, parameterName, parameterValue){
  !!parameterValue && $addQueryParameter(this$static, parameterName, '' + toString_8(parameterValue.getTime_0()));
}

function $buildQueryParameters(this$static){
  var alertPriority, alertPriority$array, alertPriority$index, alertPriority$max, alertsPriorityBuffer, category, category$array, category$index, category$max, driftCategoriesBuffer, operationRequestStatus, operationRequestStatus$array, operationRequestStatus$index, operationRequestStatus$max, operationRequestStatusBuffer;
  this$static.queryString = new StringBuilder_0;
  null != this$static.resourceTypeId && !!this$static.resourceTypeId.length && $addQueryParameter(this$static, 'resourceTypeId', this$static.resourceTypeId);
  null != this$static.version_0 && !!this$static.version_0.length && $addQueryParameter(this$static, 'version', this$static.version_0);
  if (!$isEmpty_2(this$static.operationRequestStatuses)) {
    operationRequestStatusBuffer = new StringBuilder_0;
    for (operationRequestStatus$array = this$static.operationRequestStatuses , operationRequestStatus$index = 0 , operationRequestStatus$max = operationRequestStatus$array.length; operationRequestStatus$index < operationRequestStatus$max; ++operationRequestStatus$index) {
      operationRequestStatus = operationRequestStatus$array[operationRequestStatus$index];
      $append_1(operationRequestStatusBuffer.data_0, operationRequestStatus);
      $append_1(operationRequestStatusBuffer.data_0, ',');
    }
    $addQueryParameter(this$static, 'status', $substring_0($toString_1(operationRequestStatusBuffer.data_0), 0, $toString_1(operationRequestStatusBuffer.data_0).length - 1));
  }
  if (!$isEmpty_2(this$static.alertPriorityFilters)) {
    alertsPriorityBuffer = new StringBuilder_0;
    for (alertPriority$array = this$static.alertPriorityFilters , alertPriority$index = 0 , alertPriority$max = alertPriority$array.length; alertPriority$index < alertPriority$max; ++alertPriority$index) {
      alertPriority = alertPriority$array[alertPriority$index];
      $append_1(alertsPriorityBuffer.data_0, alertPriority);
      $append_1(alertsPriorityBuffer.data_0, ',');
    }
    $addQueryParameter(this$static, 'alertPriority', $substring_0($toString_1(alertsPriorityBuffer.data_0), 0, $toString_1(alertsPriorityBuffer.data_0).length - 1));
  }
  if (!$isEmpty_2(this$static.driftCategories)) {
    driftCategoriesBuffer = new StringBuilder_0;
    for (category$array = this$static.driftCategories , category$index = 0 , category$max = category$array.length; category$index < category$max; ++category$index) {
      category = category$array[category$index];
      $append_12(($append_1(driftCategoriesBuffer.data_0, category) , driftCategoriesBuffer), ',');
    }
    $addQueryParameter(this$static, 'categories', $toString_1(driftCategoriesBuffer.data_0));
  }
  $addQueryParameter(this$static, 'definition', this$static.driftDefinition);
  $addQueryParameter(this$static, 'path', this$static.driftPath);
  $addQueryParameter(this$static, 'snapshot', this$static.driftSnapshot);
  $addQueryParameter_0(this$static, 'startTime', this$static.startDate);
  $addQueryParameter_0(this$static, 'endTime', this$static.endDate);
}

function $export(this$static){
  var reportUrl, cleanQueryString, queryStringNotEndingWithQuestionMark;
  reportUrl = ($buildQueryParameters(this$static) , cleanQueryString = $endsWith($toString_1(this$static.queryString.data_0), '&')?$substring_1(this$static.queryString, $toString_1(this$static.queryString.data_0).length - 1):$toString_1(this$static.queryString.data_0) , queryStringNotEndingWithQuestionMark = $endsWith(cleanQueryString, '?')?$substring_0(cleanQueryString, 0, cleanQueryString.length - 1):cleanQueryString , encode('/coregui/reports/' + this$static.reportUrl + '.csv?' + queryStringNotEndingWithQuestionMark));
  $clinit_Log();
  $info_0(logger_0, 'Opening Export CSV report on url: ' + reportUrl);
  $wnd.open(reportUrl, 'download', null);
}

function $isEmpty_2(array){
  return array == null || array.length == 0;
}

function $setEndDate_1(this$static, endDate){
  this$static.endDate = endDate?getAbsoluteDate(($clinit_RelativeDate() , END_OF_TODAY), endDate, ($clinit_RelativeDateRangePosition() , END)):null;
}

function $setStartDate_1(this$static, startDate){
  this$static.startDate = startDate?getAbsoluteDate(($clinit_RelativeDate() , START_OF_TODAY), startDate, ($clinit_RelativeDateRangePosition() , START)):null;
}

function ReportExporter_0(reportUrl){
  this.reportUrl = reportUrl;
}

function addDateOffsetToNow(dateOffset){
  var now;
  if (!dateOffset || $equals_4(dateOffset, new Integer_0(0))) {
    return null;
  }
   else {
    now = new Date_1;
    addDaysToDate(now, dateOffset.value_0);
    return now;
  }
}

function createExporterForRecentAlerts(alertPriorityList, startDateOffset, endDateOffset){
  var newExportDialog;
  newExportDialog = new ReportExporter_0('recentAlerts');
  newExportDialog.alertPriorityFilters = alertPriorityList;
  $setStartDate_1(newExportDialog, addDateOffsetToNow(startDateOffset));
  $setEndDate_1(newExportDialog, addDateOffsetToNow(endDateOffset));
  return newExportDialog;
}

function createExporterForRecentDrift(definition, snapshot, driftCategories, path, startDateOffset, endDateOffset){
  var newExporter;
  newExporter = new ReportExporter_0('recentDrift');
  newExporter.driftCategories = driftCategories;
  newExporter.driftDefinition = definition;
  newExporter.driftPath = path;
  newExporter.driftSnapshot = snapshot;
  $setStartDate_1(newExporter, addDateOffsetToNow(startDateOffset));
  $setEndDate_1(newExporter, addDateOffsetToNow(endDateOffset));
  return newExporter;
}

function createExporterForRecentOperations(operationRequestStatuses, startDateOffset, endDateOffset){
  var newExportDialog;
  newExportDialog = new ReportExporter_0('recentOperations');
  newExportDialog.operationRequestStatuses = operationRequestStatuses;
  $setStartDate_1(newExportDialog, addDateOffsetToNow(startDateOffset));
  $setEndDate_1(newExportDialog, addDateOffsetToNow(endDateOffset));
  return newExportDialog;
}

defineSeed(2201, 1, {}, ReportExporter_0);
_.alertPriorityFilters = null;
_.driftCategories = null;
_.driftDefinition = null;
_.driftPath = null;
_.driftSnapshot = null;
_.endDate = null;
_.operationRequestStatuses = null;
_.queryString = null;
_.reportUrl = null;
_.resourceTypeId = null;
_.startDate = null;
_.version_0 = null;
function BackButton_0(title, anchor){
  $clinit_BaseWidget();
  StretchImgButton_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'src', 'buttons/back/back.png'):(this.config_0['src'] = 'buttons/back/back.png' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'title', '<b>' + title + '<\/b>'):(this.config_0['title'] = '<b>' + title + '<\/b>' , undefined);
  $addClickHandler(this, new BackButton$1_0(anchor));
  $setAutoFit(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $isCreated_1(this)?$setProperty_0(this, 'height', 22):(this.config_0['height'] = 22 , undefined);
  $setWrap(this, FALSE);
  $setShowDown(this, FALSE);
  $isCreated_1(this)?$setProperty_0(this, 'capSize', 20):(this.config_0['capSize'] = 20 , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'styleName', 'backLink'):(this.config_0['styleName'] = 'backLink' , undefined);
}

defineSeed(2204, 453, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$StatefulCanvas, Q$StretchImg, Q$StretchImgButton, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasIconClickHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), BackButton_0);
function BackButton$1_0(val$anchor){
  this.val$anchor = val$anchor;
}

defineSeed(2205, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), BackButton$1_0);
_.onClick = function onClick_50(clickEvent){
  $clinit_CoreGUI();
  goToView(this.val$anchor, null, false);
}
;
_.val$anchor = null;
function $addCarouselAction(this$static, confirmation, action){
  var info;
  info = new Carousel$CarouselActionInfo_0(confirmation, action);
  $add_3(this$static.carouselActions, info);
}

function $addCarouselMember(this$static, member){
  $setWidth_0(member, this$static.carouselUsingFixedWidths?'250px':'*');
  $addMember(this$static.carouselHolder, member);
}

function $disableAllFooterControls_0(this$static){
  var action, action$iterator, extraWidget, extraWidget$iterator;
  for (action$iterator = new AbstractList$IteratorImpl_0(this$static.carouselActions); action$iterator.i < action$iterator.this$0_0.size_1();) {
    action = dynamicCast($next_0(action$iterator), Q$Carousel$CarouselActionInfo);
    $disable(action.actionCanvas);
  }
  for (extraWidget$iterator = new AbstractList$IteratorImpl_0(this$static.extraWidgetsAboveFooter); extraWidget$iterator.i < extraWidget$iterator.this$0_0.size_1();) {
    extraWidget = dynamicCast($next_0(extraWidget$iterator), Q$Canvas);
    $disable(extraWidget);
  }
  for (extraWidget$iterator = new AbstractList$IteratorImpl_0(this$static.extraWidgetsInMainFooter); extraWidget$iterator.i < extraWidget$iterator.this$0_0.size_1();) {
    extraWidget = dynamicCast($next_0(extraWidget$iterator), Q$Canvas);
    $disable(extraWidget);
  }
  !!this$static.refreshButton && $disable(this$static.refreshButton);
}

function $drawFooter_0(this$static){
  var button, carouselAction, carouselAction$iterator, extraWidgetCanvas, extraWidgetCanvas$iterator, item, key, menu, menuButton;
  $removeMembers(this$static.footerExtraWidgets, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.footerExtraWidgets, 'members')));
  if (this$static.extraWidgetsAboveFooter.size_0 != 0) {
    for (extraWidgetCanvas$iterator = new AbstractList$IteratorImpl_0(this$static.extraWidgetsAboveFooter); extraWidgetCanvas$iterator.i < extraWidgetCanvas$iterator.this$0_0.size_1();) {
      extraWidgetCanvas = dynamicCast($next_0(extraWidgetCanvas$iterator), Q$Canvas);
      $addMember(this$static.footerExtraWidgets, extraWidgetCanvas);
    }
    $show(this$static.footerExtraWidgets);
  }
  $removeMembers(this$static.footer, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.footer, 'members')));
  for (carouselAction$iterator = new AbstractList$IteratorImpl_0(this$static.carouselActions); carouselAction$iterator.i < carouselAction$iterator.this$0_0.size_1();) {
    carouselAction = dynamicCast($next_0(carouselAction$iterator), Q$Carousel$CarouselActionInfo);
    if (null == carouselAction.valueMap) {
      button = new EnhancedIButton_1(carouselAction.title_0);
      $setAttribute_22(button, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , TRUE), true);
      $setAttribute_24(button, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, true);
      $addClickHandler(button, new Carousel$1_0(this$static, carouselAction));
      carouselAction.actionCanvas = button;
      $addMember(this$static.footer, button);
    }
     else {
      menu = new Menu_0;
      for (null.nullMethod().nullMethod(); null.nullMethod();) {
        key = null.nullMethod();
        item = new MenuItem_1(key);
        $addClickHandler_3(item, new Carousel$2_0(this$static, carouselAction));
        $addItem_0(menu, item);
      }
      menuButton = new IMenuButton_0(carouselAction.title_0);
      $setAttribute_20(menuButton, 'menu', !menu?null:$getOrCreateJsObj_0(menu), true);
      $setAttribute_22(menuButton, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , TRUE), true);
      $setAttribute_24(menuButton, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, true);
      $setShowMenuBelow(menuButton, FALSE);
      carouselAction.actionCanvas = menuButton;
      $addMember(this$static.footer, menuButton);
    }
  }
  for (extraWidgetCanvas$iterator = new AbstractList$IteratorImpl_0(this$static.extraWidgetsInMainFooter); extraWidgetCanvas$iterator.i < extraWidgetCanvas$iterator.this$0_0.size_1();) {
    extraWidgetCanvas = dynamicCast($next_0(extraWidgetCanvas$iterator), Q$Canvas);
    $addMember(this$static.footer, extraWidgetCanvas);
  }
  $addMember(this$static.footer, new LayoutSpacer_0);
  this$static.widthButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Fixed Width'));
  $addClickHandler(this$static.widthButton, new Carousel$3_0(this$static));
  $addMember(this$static.footer, this$static.widthButton);
  this$static.refreshButton = new EnhancedIButton_1('Refresh');
  $addClickHandler(this$static.refreshButton, new Carousel$4_0(this$static));
  $addMember(this$static.footer, this$static.refreshButton);
  this$static.previousButton = new EnhancedIButton_1('Previous');
  $addClickHandler(this$static.previousButton, new Carousel$5_0(this$static));
  $addMember(this$static.footer, this$static.previousButton);
  this$static.nextButton = new EnhancedIButton_1('Next');
  $addClickHandler(this$static.nextButton, new Carousel$6_0(this$static));
  $addMember(this$static.footer, this$static.nextButton);
  $addMember(this$static.footer, this$static.carouselInfo);
  $refreshCarouselInfo(this$static);
}

function $drawTitle(this$static){
  var headerIcon, headerIcon$iterator, img;
  for (headerIcon$iterator = new AbstractList$IteratorImpl_0(this$static.titleIcons); headerIcon$iterator.i < headerIcon$iterator.this$0_0.size_1();) {
    headerIcon = dynamicCast($next_0(headerIcon$iterator), Q$String);
    img = new Img_2(headerIcon, 24, 24);
    $setPadding(img, valueOf_44(4));
    $addMember(this$static.titleLayout, img);
  }
  !!this$static.titleBackButton && $addMember(this$static.titleLayout, this$static.titleBackButton);
  $addMember(this$static.titleLayout, this$static.titleCanvas);
}

function $getCurrentCriteria(this$static){
  var criteria;
  if (!!this$static.filterForm && $getFields(this$static.filterForm).length != 0) {
    criteria = $getValuesAsCriteria(this$static.filterForm);
    if (criteria)
    ;
    else {
      criteria = this$static.initialCriteria_0;
    }
  }
   else {
    criteria = this$static.initialCriteria_0;
  }
  return criteria;
}

function $next_7(this$static){
  var newStart;
  !this$static.carouselSizeFilter && (this$static.carouselSizeFilter = valueOf_44(4));
  if (this$static.carouselEndFilter) {
    newStart = this$static.carouselEndFilter.value_0 - 1;
    newStart = newStart < this$static.carouselSizeFilter.value_0?this$static.carouselSizeFilter.value_0:newStart;
    $setCarouselStartFilter(this$static, valueOf_44(newStart));
  }
  this$static.carouselEndFilter = null;
  $buildCarousel(this$static, true);
}

function $onDraw_1(this$static){
  var $e0, carouselInfo, child, child$array, child$index, child$max, e;
  try {
    for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.contents_0, 'members')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
      child = child$array[child$index];
      $removeChild_0(this$static.contents_0, child);
    }
    this$static.titleCanvas = new HTMLFlow_0;
    $setTitleString_0(this$static, this$static.titleString);
    this$static.titleLayout = new EnhancedHLayout_0;
    $setAutoHeight(this$static.titleLayout);
    $setAttribute_24(this$static.titleLayout, 'align', ($clinit_VerticalAlignment() , BOTTOM_1).value_0, true);
    $setMembersMargin(this$static.titleLayout, 4);
    $addMember_0(this$static.contents_0, this$static.titleLayout, 0);
    $getFields(this$static.filterForm).length != 0 && $addMember(this$static.contents_0, this$static.filterForm);
    $addMember(this$static.contents_0, this$static.carouselHolder);
    this$static.footerExtraWidgets = new EnhancedToolStrip_0;
    $setPadding(this$static.footerExtraWidgets, valueOf_44(5));
    $setAttribute_24(this$static.footerExtraWidgets, 'width', '100%', true);
    $setMembersMargin(this$static.footerExtraWidgets, 15);
    $hide(this$static.footerExtraWidgets);
    $addMember(this$static.contents_0, this$static.footerExtraWidgets);
    this$static.footer = new EnhancedToolStrip_0;
    $setPadding(this$static.footer, valueOf_44(5));
    $setAttribute_24(this$static.footer, 'width', '100%', true);
    $setMembersMargin(this$static.footer, 15);
    $addMember(this$static.contents_0, this$static.footer);
    $addCarouselAction(this$static, ($clinit_Enhanced() , 'Compare'), new DriftCarouselView$3_0(this$static));
    carouselInfo = new Label_3;
    $setWrap_0(carouselInfo, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    this$static.carouselInfo = carouselInfo;
    $drawTitle(this$static);
    $drawFooter_0(this$static);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      e = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to draw Table [' + ($clinit_Enhanced() , $toString_4(this$static)) + '].'), e);
    }
     else 
      throw $e0;
  }
}

function $onInit_4(this$static){
  var categories, categoryIcons, categoryFilter, pathFilter;
  $onInit(this$static);
  $onInit_Layout(this$static);
  this$static.contents_0 = new EnhancedVLayout_0;
  $setAttribute_24(this$static.contents_0, 'width', '100%', true);
  $setAttribute_24(this$static.contents_0, 'height', '100%', true);
  $addMember(this$static, this$static.contents_0);
  this$static.filterForm = new Carousel$CarouselFilter_0(this$static);
  categories = new LinkedHashMap_1(3);
  $put_1(categories, ($clinit_DriftCategory() , FILE_ADDED).name_0, ($clinit_Enhanced() , 'File Added'));
  $put_1(categories, FILE_CHANGED.name_0, 'File Changed');
  $put_1(categories, FILE_REMOVED.name_0, 'File Removed');
  categoryIcons = new LinkedHashMap_1(3);
  $put_1(categoryIcons, FILE_ADDED.name_0, getDriftCategoryIcon(FILE_ADDED));
  $put_1(categoryIcons, FILE_CHANGED.name_0, getDriftCategoryIcon(FILE_CHANGED));
  $put_1(categoryIcons, FILE_REMOVED.name_0, getDriftCategoryIcon(FILE_REMOVED));
  categoryFilter = new EnumSelectItem_0('categories', 'Category', Lorg_rhq_core_domain_drift_DriftCategory_2_classLit, categories, categoryIcons);
  pathFilter = new TextItem_3('path', 'Path');
  $setEndRow_0(pathFilter, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setFilterFormItems_0(this$static, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [categoryFilter, pathFilter]));
  this$static.carouselHolder = new EnhancedHLayout_0;
  $setAttribute_24(this$static.carouselHolder, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $setAttribute_24(this$static.carouselHolder, 'width', '100%', true);
  $addMember(this$static.contents_0, this$static.carouselHolder);
}

function $previous(this$static){
  var newEnd;
  !this$static.carouselSizeFilter && (this$static.carouselSizeFilter = valueOf_44(4));
  if (this$static.carouselStartFilter) {
    newEnd = this$static.carouselStartFilter.value_0 + 1;
    $setCarouselEndFilter(this$static, valueOf_44(newEnd));
    $setCarouselStartFilter(this$static, valueOf_44(this$static.carouselStartFilter.value_0 + this$static.carouselSizeFilter.value_0));
  }
  $buildCarousel(this$static, true);
}

function $refresh_2(this$static){
  var $e0, criteria, criteriaMap;
  criteria = $getCurrentCriteria(this$static);
  criteriaMap = criteria?convertToMap(criteria.jsObj):($clinit_Collections() , $clinit_Collections() , EMPTY_MAP);
  try {
    this$static.carouselSizeFilter = valueOf_44(__parseAndValidateInt(dynamicCast(criteriaMap.get_2('CarouselSize'), Q$String)));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      this$static.carouselSizeFilter = null;
    }
     else 
      throw $e0;
  }
  try {
    this$static.carouselStartFilter = dynamicCast(criteriaMap.get_2('CarouselStart'), Q$Integer);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      this$static.carouselStartFilter = null;
    }
     else 
      throw $e0;
  }
  this$static.carouselEndFilter = null;
  $buildCarousel(this$static, true);
  $refreshCarouselInfo(this$static);
}

function $refreshCarouselInfo(this$static){
  var carouselAction, carouselAction$iterator, enabled, extraWidget, extraWidget$iterator;
  if (this$static.carouselHolder) {
    for (carouselAction$iterator = new AbstractList$IteratorImpl_0(this$static.carouselActions); carouselAction$iterator.i < carouselAction$iterator.this$0_0.size_1();) {
      carouselAction = dynamicCast($next_0(carouselAction$iterator), Q$Carousel$CarouselActionInfo);
      if (carouselAction.actionCanvas) {
        enabled = $isEnabled_2(carouselAction.action);
        $setDisabled(carouselAction.actionCanvas, !enabled);
      }
    }
    for (extraWidget$iterator = new AbstractList$IteratorImpl_0(this$static.extraWidgetsAboveFooter); extraWidget$iterator.i < extraWidget$iterator.this$0_0.size_1();) {
      extraWidget = dynamicCast($next_0(extraWidget$iterator), Q$Canvas);
      $enable(extraWidget);
    }
    for (extraWidget$iterator = new AbstractList$IteratorImpl_0(this$static.extraWidgetsInMainFooter); extraWidget$iterator.i < extraWidget$iterator.this$0_0.size_1();) {
      extraWidget = dynamicCast($next_0(extraWidget$iterator), Q$Canvas);
      $enable(extraWidget);
    }
    !!this$static.refreshButton && $enable(this$static.refreshButton);
  }
}

function $setCarouselEndFilter(this$static, carouselEndFilter){
  this$static.carouselEndFilter = carouselEndFilter;
}

function $setCarouselSizeFilter(this$static, carouselSizeFilter){
  this$static.carouselSizeFilter = carouselSizeFilter;
  $getField_0(this$static.filterForm, 'CarouselSize').setValue_4('' + carouselSizeFilter);
  $redraw_0($getField_0(this$static.filterForm, 'CarouselSize'));
}

function $setCarouselStartFilter(this$static, carouselStartFilter){
  this$static.carouselStartFilter = carouselStartFilter;
  if (carouselStartFilter) {
    $getField_0(this$static.filterForm, 'CarouselStart').setValue_4('' + carouselStartFilter);
    $redraw_0($getField_0(this$static.filterForm, 'CarouselStart'));
  }
}

function $setCarouselStartFilterMax(this$static, startFilterMax){
  var spinner;
  spinner = dynamicCast($getField_0(this$static.filterForm, 'CarouselStart'), Q$SpinnerItem);
  $setMax(spinner, !startFilterMax || startFilterMax.value_0 < 0?null:startFilterMax);
}

function $setFilter(this$static, value){
  var item;
  item = $getField_0(this$static.filterForm, 'path');
  !!item && item.setValue_4(value);
}

function $setFilterFormItems_0(this$static, formItems){
  var carouselFormItems, i, item, item$index, item$max, numFilter, startFilter;
  carouselFormItems = initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, 2 + formItems.length, 0);
  i = 0;
  for (item$index = 0 , item$max = formItems.length; item$index < item$max; ++item$index) {
    item = formItems[item$index];
    setCheck(carouselFormItems, i++, item);
  }
  startFilter = new SpinnerItem_1('CarouselStart', ($clinit_Enhanced() , 'Snapshot Start'));
  $setMin(startFilter, valueOf_44(1));
  numFilter = new TextItem_3('CarouselSize', 'Snapshot Display Max');
  setCheck(carouselFormItems, i++, startFilter);
  setCheck(carouselFormItems, i++, numFilter);
  $setNumCols(this$static.filterForm, 4);
  $setItems_1(this$static.filterForm, carouselFormItems);
}

function $setTitleBackButton(this$static, backButton){
  this$static.titleBackButton = backButton;
}

function $setTitleString_0(this$static, titleString){
  this$static.titleString = titleString;
  !!this$static.titleCanvas && $updateTitleCanvas_0(this$static, titleString);
}

function $updateTitleCanvas_0(this$static, titleString){
  titleString == null && (titleString = '');
  if (titleString.length > 0) {
    $setAttribute_24(this$static.titleCanvas, 'width', '100%', true);
    $setHeight(this$static.titleCanvas, 35);
    $setContents(this$static.titleCanvas, titleString);
    $setPadding(this$static.titleCanvas, valueOf_44(4));
    $setStyleName(this$static.titleCanvas, 'HeaderLabel');
  }
   else {
    $setAttribute_24(this$static.titleCanvas, 'width', '100%', true);
    $setHeight(this$static.titleCanvas, 0);
    $setContents(this$static.titleCanvas, null);
    $setPadding(this$static.titleCanvas, valueOf_44(0));
    $setStyleName(this$static.titleCanvas, 'normal');
  }
  $markForRedraw(this$static.titleCanvas);
}

function addCriteria(dest, src){
  var field, i, otherKeys, otherMap, value;
  otherMap = convertToMap(src.jsObj);
  otherKeys = otherMap.keySet_0();
  for (i = otherKeys.iterator(); i.hasNext();) {
    field = dynamicCast(i.next_0(), Q$String);
    value = otherMap.get_2(field);
    instanceOf(value, Q$Integer)?$addCriteria_1(dest, field, dynamicCast(value, Q$Integer)):instanceOf(value, Q$Float)?$addCriteria_0(dest, field, dynamicCast(value, Q$Float)):instanceOf(value, Q$String)?$addCriteria_2(dest, field, dynamicCast(value, Q$String)):instanceOf(value, Q$Date)?$addCriteria_3(dest, field, dynamicCast(value, Q$Date)):instanceOf(value, Q$Boolean)?$addCriteria(dest, field, dynamicCast(value, Q$Boolean)):instanceOf(value, Q$Integer_$1)?$addCriteria_5(dest, field, dynamicCast(value, Q$Integer_$1)):instanceOf(value, Q$Double_$1)?$addCriteria_4(dest, field, dynamicCast(value, Q$Double_$1)):instanceOf(value, Q$String_$1)?$addCriteria_6(dest, field, dynamicCast(value, Q$String_$1)):$setAttribute_12(dest, field, getAttributeAsObject(src.jsObj, field));
  }
}

defineSeed(2207, 1539, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$RefreshableView, Q$Enhanced, Q$EnhancedHLayout]));
_.destroy_0 = function destroy_9(){
  destroyMembers(this.contents_0);
  destroyMembers(this);
  $destroy(this);
}
;
_.onDraw_0 = function onDraw_16(){
  $onDraw_1(this);
}
;
_.onInit = function onInit_31(){
  $onInit_4(this);
}
;
_.refresh_0 = function refresh_5(){
  $refresh_2(this);
}
;
_.carouselEndFilter = null;
_.carouselHolder = null;
_.carouselInfo = null;
_.carouselStartFilter = null;
_.carouselUsingFixedWidths = false;
_.contents_0 = null;
_.filterForm = null;
_.footer = null;
_.footerExtraWidgets = null;
_.initialCriteria_0 = null;
_.nextButton = null;
_.previousButton = null;
_.refreshButton = null;
_.titleBackButton = null;
_.titleCanvas = null;
_.titleLayout = null;
_.titleString = null;
_.widthButton = null;
function $buildDetailsView_0(this$static){
  var backButton, isEditable, verticalSpacer;
  $setAttribute_24(this$static.detailsView, 'width', '100%', true);
  $setAttribute_24(this$static.detailsView, 'height', '100%', true);
  isEditable = instanceOf(this$static.detailsView, Q$DetailsView) && dynamicCast(this$static.detailsView, Q$DetailsView).isEditable_0();
  if (!isEditable) {
    backButton = new BackButton_0(($clinit_Enhanced() , 'Back to List'), this$static.basePath);
    $addMember(this$static.detailsHolder, backButton);
    verticalSpacer = new EnhancedVLayout_0;
    $isCreated_1(verticalSpacer)?$setProperty_0(verticalSpacer, 'height', 8):(verticalSpacer.config_0['height'] = 8 , undefined);
    $addMember(this$static.detailsHolder, verticalSpacer);
  }
  $addMember(this$static.detailsHolder, this$static.detailsView);
  $animateShow(this$static.detailsHolder, ($clinit_AnimationEffect() , WIPE));
}

function $convertCurrentViewPathToID(path){
  return path.indexOf('0id_') == 0?$substring(path, 4):path;
}

function $renderView_6(this$static, viewPath){
  var id;
  ++viewPath.index_0;
  this$static.basePath = $getPathToIndex(viewPath, viewPath.index_0);
  if (viewPath.viewPath.size_0 <= viewPath.index_0) {
    $switchToCarouselView(this$static);
  }
   else {
    ++viewPath.index_0;
    id = $convertCurrentViewPathToID((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
    this$static.detailsView = $getDetailsView_0(this$static, id);
    $switchToDetailsView_0(this$static);
  }
}

function $switchToCarouselView(this$static){
  var contents;
  contents = this$static.contents_0;
  if (contents) {
    if (this$static.initialDisplay) {
      this$static.initialDisplay = false;
    }
     else {
      debug('Refreshing data for Table [' + Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselView_2_classLit.typeName + ']...');
      $refresh_2(this$static);
    }
    if (!!this$static.detailsHolder && $isVisible(this$static.detailsHolder)) {
      $animateHide_0(this$static.detailsHolder, ($clinit_AnimationEffect() , WIPE), new BookmarkableCarousel$2_0(this$static, contents));
    }
     else {
      !!this$static.detailsHolder && destroyMembers(this$static.detailsHolder);
      $animateShow(contents, ($clinit_AnimationEffect() , WIPE));
    }
  }
}

function $switchToDetailsView_0(this$static){
  var contents;
  contents = this$static.contents_0;
  if (contents) {
    if ($isVisible(contents)) {
      $animateHide_0(contents, ($clinit_AnimationEffect() , WIPE), new BookmarkableCarousel$1_0(this$static));
    }
     else {
      contents.hide_0();
      destroyMembers(this$static.detailsHolder);
      $buildDetailsView_0(this$static);
    }
  }
}

defineSeed(2206, 2207, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$RefreshableView, Q$Enhanced, Q$EnhancedHLayout]));
_.onInit = function onInit_32(){
  $onInit_4(this);
  this.initialDisplay = true;
  this.detailsHolder = new EnhancedVLayout_0;
  $setAttribute_24(this.detailsHolder, 'align', ($clinit_VerticalAlignment() , TOP_2).value_0, true);
  $setMargin(this.detailsHolder, valueOf_44(4));
  this.detailsHolder.hide_0();
  $addMember(this, this.detailsHolder);
  !!this.detailsView && $switchToDetailsView_0(this);
}
;
_.renderView = function renderView_15(viewPath){
  $renderView_6(this, viewPath);
}
;
_.basePath = null;
_.detailsHolder = null;
_.detailsView = null;
_.initialDisplay = false;
function BookmarkableCarousel$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2208, 1, {}, BookmarkableCarousel$1_0);
_.execute_5 = function execute_30(b){
  $buildDetailsView_0(this.this$0);
}
;
_.this$0 = null;
function BookmarkableCarousel$2_0(this$0, val$contents){
  this.this$0 = this$0;
  this.val$contents = val$contents;
}

defineSeed(2209, 1, {}, BookmarkableCarousel$2_0);
_.execute_5 = function execute_31(b){
  destroyMembers(this.this$0.detailsHolder);
  $animateShow(this.val$contents, ($clinit_AnimationEffect() , WIPE));
}
;
_.this$0 = null;
_.val$contents = null;
function Carousel$1_0(this$0, val$carouselAction){
  this.this$0 = this$0;
  this.val$carouselAction = val$carouselAction;
}

defineSeed(2210, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), Carousel$1_0);
_.onClick = function onClick_51(clickEvent){
  var message;
  $disableAllFooterControls_0(this.this$0);
  if (this.val$carouselAction.confirmMessage != null) {
    message = $replaceAll(this.val$carouselAction.confirmMessage, '\\#', 'TODO:');
    ask(message, new Carousel$1$1_0(this, this.val$carouselAction));
  }
   else {
    $executeAction(this.val$carouselAction.action);
  }
}
;
_.this$0 = null;
_.val$carouselAction = null;
function Carousel$1$1_0(this$1, val$carouselAction){
  this.this$1 = this$1;
  this.val$carouselAction = val$carouselAction;
}

defineSeed(2211, 1, {}, Carousel$1$1_0);
_.execute_3 = function execute_32(confirmed){
  confirmed.value_0?$executeAction(this.val$carouselAction.action):$refreshCarouselInfo(this.this$1.this$0);
}
;
_.this$1 = null;
_.val$carouselAction = null;
function Carousel$2_0(this$0, val$carouselAction){
  this.this$0 = this$0;
  this.val$carouselAction = val$carouselAction;
}

defineSeed(2212, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), Carousel$2_0);
_.onClick_1 = function onClick_52(event_0){
  $disableAllFooterControls_0(this.this$0);
  $executeAction(this.val$carouselAction.action, null.nullMethod());
}
;
_.this$0 = null;
_.val$carouselAction = null;
function Carousel$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2213, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), Carousel$3_0);
_.onClick = function onClick_53(clickEvent){
  this.this$0.carouselUsingFixedWidths = !this.this$0.carouselUsingFixedWidths;
  $setTitle_0(this.this$0.widthButton, this.this$0.carouselUsingFixedWidths?($clinit_Enhanced() , 'Scale To Fit'):($clinit_Enhanced() , 'Fixed Width'));
  $buildCarousel(this.this$0, true);
}
;
_.this$0 = null;
function Carousel$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2214, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), Carousel$4_0);
_.onClick = function onClick_54(clickEvent){
  $disableAllFooterControls_0(this.this$0);
  $refresh_2(this.this$0);
}
;
_.this$0 = null;
function Carousel$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2215, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), Carousel$5_0);
_.onClick = function onClick_55(clickEvent){
  $disableAllFooterControls_0(this.this$0);
  $previous(this.this$0);
}
;
_.this$0 = null;
function Carousel$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2216, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), Carousel$6_0);
_.onClick = function onClick_56(clickEvent){
  $disableAllFooterControls_0(this.this$0);
  $next_7(this.this$0);
}
;
_.this$0 = null;
function Carousel$CarouselActionInfo_0(confirmMessage, action){
  this.title_0 = 'Compare';
  this.confirmMessage = confirmMessage;
  this.valueMap = null;
  this.action = action;
}

defineSeed(2217, 1, makeCastMap([Q$Carousel$CarouselActionInfo]), Carousel$CarouselActionInfo_0);
_.action = null;
_.actionCanvas = null;
_.confirmMessage = null;
_.title_0 = null;
_.valueMap = null;
function $setItems_1(this$static, items){
  var name_0, nextFormItem, nextFormItem$index, nextFormItem$max, tmpItems;
  for (nextFormItem$index = 0 , nextFormItem$max = items.length; nextFormItem$index < nextFormItem$max; ++nextFormItem$index) {
    nextFormItem = items[nextFormItem$index];
    $setWrapTitle(nextFormItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    nextFormItem.setWidth(300);
    if (instanceOf(nextFormItem, Q$TextItem)) {
      $getHandlerCount_0(nextFormItem, (!TYPE_32 && (TYPE_32 = new GwtEvent$Type_0) , TYPE_32)) == 0 && $setupKeyPressEvent_0(nextFormItem);
      $doAddHandler(nextFormItem, this$static, (!TYPE_32 && (TYPE_32 = new GwtEvent$Type_0) , TYPE_32));
    }
     else if (instanceOf(nextFormItem, Q$SelectItem)) {
      $getHandlerCount_0(nextFormItem, (!TYPE_25 && (TYPE_25 = new GwtEvent$Type_0) , TYPE_25)) == 0 && $setupChangedEvent(nextFormItem);
      $doAddHandler(nextFormItem, this$static, (!TYPE_25 && (TYPE_25 = new GwtEvent$Type_0) , TYPE_25));
    }
     else if (instanceOf(nextFormItem, Q$EnhancedSearchBarItem)) {
      name_0 = null.nullMethod();
      null.nullMethod();
      this$static.hiddenItem = new HiddenItem_0(name_0);
    }
  }
  if (this$static.hiddenItem) {
    tmpItems = initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, items.length + 1, 0);
    arraycopy(items, 0, tmpItems, 0, items.length);
    setCheck(tmpItems, items.length, this$static.hiddenItem);
    items = tmpItems;
  }
  $setFields_0(this$static, items);
}

function Carousel$CarouselFilter_0(carousel){
  DynamicForm_0.call(this);
  $setIsGroup(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setGroupTitle(this, ($clinit_Enhanced() , 'Filters'));
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setPadding(this, valueOf_44(5));
  this.carousel = carousel;
}

defineSeed(2218, 478, makeCastMap([Q$HasAttachHandlers, Q$EventHandler, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm, Q$ChangedHandler, Q$KeyPressHandler_0]), Carousel$CarouselFilter_0);
_.onChanged = function onChanged_30(event_0){
  $refresh_2(this.carousel);
}
;
_.onKeyPress = function onKeyPress_1(event_0){
  if (!$equals_6($getKeyName(event_0), 'Enter')) {
    return;
  }
  $refresh_2(this.carousel);
}
;
_.setItems = function setItems_0(items){
  $setItems_1(this, items);
}
;
_.carousel = null;
_.hiddenItem = null;
function buildAggregateConfiguration(configurations, configurationDefinition){
  var aggregateConfiguration, childPropertyDefinition, childPropertyDefinition$iterator, childPropertyDefinitions;
  aggregateConfiguration = new Configuration_0;
  if (configurations.size_0 == 0) {
    return aggregateConfiguration;
  }
  childPropertyDefinitions = (!configurationDefinition.propertyDefinitions && (configurationDefinition.propertyDefinitions = new LinkedHashMap_0) , configurationDefinition.propertyDefinitions);
  for (childPropertyDefinition$iterator = childPropertyDefinitions.values_0().iterator(); childPropertyDefinition$iterator.hasNext();) {
    childPropertyDefinition = dynamicCast(childPropertyDefinition$iterator.next_0(), Q$PropertyDefinition);
    buildAggregateProperty(childPropertyDefinition, configurations, aggregateConfiguration);
  }
  return aggregateConfiguration;
}

function buildAggregateOpenPropertyMap(sourceParentPropertyMaps, targetParentPropertyMap){
  var map, map$iterator, member, memberName, memberName$iterator, memberNameValueFrequenciesMap, valueFrequencies;
  memberNameValueFrequenciesMap = createMemberNameValueFrequenciesMap(sourceParentPropertyMaps);
  for (memberName$iterator = $iterator($keySet(memberNameValueFrequenciesMap)); memberName$iterator.val$outerIter.hasNext();) {
    memberName = dynamicCast($next_1(memberName$iterator), Q$String);
    member = new PropertySimple_1(memberName, null);
    (!targetParentPropertyMap.map && (targetParentPropertyMap.map = new LinkedHashMap_0) , targetParentPropertyMap.map).put(member.name_0, member);
    member.parentMap = targetParentPropertyMap;
    for (map$iterator = new AbstractList$IteratorImpl_0(sourceParentPropertyMaps); map$iterator.i < map$iterator.this$0_0.size_1();) {
      map = dynamicCast($next_0(map$iterator), Q$AbstractPropertyMap);
      !map.get_3(memberName) && map.put_0(new PropertySimple_1(memberName, null));
    }
    valueFrequencies = dynamicCast(memberNameValueFrequenciesMap.get_2(memberName), Q$Map);
    if (valueFrequencies.size_1() == 1 && dynamicCast(valueFrequencies.values_0().iterator().next_0(), Q$Integer).value_0 == sourceParentPropertyMaps.size_0) {
      $setOverride(member, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
      $setValue_12(member, dynamicCast(valueFrequencies.keySet_0().iterator().next_0(), Q$String));
    }
  }
}

function buildAggregateProperty(propertyDefinition, sourceParentPropertyMaps, targetParentPropertyMap){
  var i, listMemberPropertyDefinition, nestedSourceParentPropertyMap, nestedSourceParentPropertyMaps, propertyDefinitionList, propertySimple, sampleValue, sourceParentPropertyMap, sourceParentPropertyMap$iterator, targetPropertyList, targetPropertyMap, value, valuesHomogeneous;
  if (instanceOf(propertyDefinition, Q$PropertyDefinitionSimple)) {
    sampleValue = getSimpleValue(dynamicCast((checkIndex(0, sourceParentPropertyMaps.size_0) , sourceParentPropertyMaps.array[0]), Q$AbstractPropertyMap), propertyDefinition.name_0);
    valuesHomogeneous = true;
    for (i = 1; i < sourceParentPropertyMaps.size_0; ++i) {
      value = getSimpleValue(dynamicCast((checkIndex(i, sourceParentPropertyMaps.size_0) , sourceParentPropertyMaps.array[i]), Q$AbstractPropertyMap), propertyDefinition.name_0);
      if (value == null && sampleValue != null || value != null && !$equals_6(value, sampleValue)) {
        valuesHomogeneous = false;
        break;
      }
    }
    propertySimple = new PropertySimple_1(propertyDefinition.name_0, valuesHomogeneous?sampleValue:null);
    targetParentPropertyMap.put_0(propertySimple);
    valuesHomogeneous && $setOverride(propertySimple, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  }
   else if (instanceOf(propertyDefinition, Q$PropertyDefinitionMap)) {
    nestedSourceParentPropertyMaps = new ArrayList_0;
    for (sourceParentPropertyMap$iterator = new AbstractList$IteratorImpl_0(sourceParentPropertyMaps); sourceParentPropertyMap$iterator.i < sourceParentPropertyMap$iterator.this$0_0.size_1();) {
      sourceParentPropertyMap = dynamicCast($next_0(sourceParentPropertyMap$iterator), Q$AbstractPropertyMap);
      nestedSourceParentPropertyMap = sourceParentPropertyMap.getMap_0(propertyDefinition.name_0);
      $add_3(nestedSourceParentPropertyMaps, nestedSourceParentPropertyMap?nestedSourceParentPropertyMap:new PropertyMap_1(propertyDefinition.name_0));
    }
    targetPropertyMap = new PropertyMap_1(propertyDefinition.name_0);
    targetParentPropertyMap.put_0(targetPropertyMap);
    buildAggregatePropertyMap(dynamicCast(propertyDefinition, Q$PropertyDefinitionMap), nestedSourceParentPropertyMaps, targetPropertyMap);
  }
   else if (instanceOf(propertyDefinition, Q$PropertyDefinitionList)) {
    propertyDefinitionList = dynamicCast(propertyDefinition, Q$PropertyDefinitionList);
    listMemberPropertyDefinition = propertyDefinitionList.memberDefinition;
    targetPropertyList = new PropertyList_1(propertyDefinition.name_0);
    targetParentPropertyMap.put_0(targetPropertyList);
    instanceOf(listMemberPropertyDefinition, Q$PropertyDefinitionMap) && dynamicCast(listMemberPropertyDefinition, Q$PropertyDefinitionMap);
  }
}

function buildAggregatePropertyMap(propertyDefinitionMap, sourceParentPropertyMaps, targetParentPropertyMap){
  var childPropertyDefinition, childPropertyDefinition$iterator, childPropertyDefinitions;
  childPropertyDefinitions = $getPropertyDefinitions(propertyDefinitionMap).values_0();
  if (childPropertyDefinitions.isEmpty_0()) {
    buildAggregateOpenPropertyMap(sourceParentPropertyMaps, targetParentPropertyMap);
  }
   else {
    for (childPropertyDefinition$iterator = childPropertyDefinitions.iterator(); childPropertyDefinition$iterator.hasNext();) {
      childPropertyDefinition = dynamicCast(childPropertyDefinition$iterator.next_0(), Q$PropertyDefinition);
      buildAggregateProperty(childPropertyDefinition, sourceParentPropertyMaps, targetParentPropertyMap);
    }
  }
}

function createMemberNameValueFrequenciesMap(sourceParentPropertyMaps){
  var map, map$iterator, nameValueFrequenciesMap, propertyName, propertyName$iterator, propertySimple, propertyValue, valueFrequencies, valueFrequency;
  nameValueFrequenciesMap = new HashMap_0;
  for (map$iterator = new AbstractList$IteratorImpl_0(sourceParentPropertyMaps); map$iterator.i < map$iterator.this$0_0.size_1();) {
    map = dynamicCast($next_0(map$iterator), Q$AbstractPropertyMap);
    for (propertyName$iterator = map.getMap().keySet_0().iterator(); propertyName$iterator.hasNext();) {
      propertyName = dynamicCast(propertyName$iterator.next_0(), Q$String);
      propertySimple = map.getSimple(propertyName);
      propertyValue = propertySimple?propertySimple.stringValue:null;
      valueFrequencies = dynamicCast(nameValueFrequenciesMap.get_2(propertyName), Q$Map);
      if (!valueFrequencies) {
        valueFrequencies = new HashMap_0;
        nameValueFrequenciesMap.put(propertyName, valueFrequencies);
      }
      valueFrequency = valueOf_44(valueFrequencies.containsKey(propertyValue)?dynamicCast(valueFrequencies.get_2(propertyValue), Q$Integer).value_0 + 1:1);
      valueFrequencies.put(propertyValue, valueFrequency);
    }
  }
  return nameValueFrequenciesMap;
}

function getSimpleValue(parentPropertyMap, propertyName){
  var samplePropertySimple;
  samplePropertySimple = parentPropertyMap.getSimple(propertyName);
  return samplePropertySimple?samplePropertySimple.stringValue:null;
}

function $clinit_ConfigurationComparisonView(){
  $clinit_ConfigurationComparisonView = nullMethod;
  $clinit_BaseWidget();
  $clinit_CoreGUI();
}

function $buildNode(this$static, parent_0, definitions, maps){
  var $e0, children, defList, defMap, definition, definition$iterator, i, innerChildren, list, listItemNode, listNode, map, map$iterator, mapNode, max, memberDef, memberDefColl, node, properties, size;
  children = new ArrayList_0;
  parent_0.jsObj['consistent'] = true;
  for (definition$iterator = definitions.iterator(); definition$iterator.hasNext();) {
    definition = dynamicCast(definition$iterator.next_0(), Q$PropertyDefinition);
    if (instanceOf(definition, Q$PropertyDefinitionSimple)) {
      properties = new ArrayList_0;
      for (map$iterator = new AbstractList$IteratorImpl_0(maps); map$iterator.i < map$iterator.this$0_0.size_1();) {
        map = dynamicCast($next_0(map$iterator), Q$AbstractPropertyMap);
        $add_3(properties, map.getSimple(definition.name_0));
      }
      node = new ConfigurationComparisonView$ComparisonTreeNode_0(dynamicCast(definition, Q$PropertyDefinitionSimple), properties, this$static.titles);
      ($clinit_Boolean() , getAttributeAsBoolean(node.jsObj, 'consistent')?TRUE:FALSE).value_0 || (parent_0.jsObj['consistent'] = false , undefined);
      setCheck(children.array, children.size_0++, node);
    }
     else if (instanceOf(definition, Q$PropertyDefinitionMap)) {
      defMap = dynamicCast(definition, Q$PropertyDefinitionMap);
      mapNode = new TreeNode_2(defMap.displayName);
      properties = new ArrayList_0;
      for (map$iterator = new AbstractList$IteratorImpl_0(maps); map$iterator.i < map$iterator.this$0_0.size_1();) {
        map = dynamicCast($next_0(map$iterator), Q$AbstractPropertyMap);
        $add_3(properties, dynamicCast(map, Q$PropertyMap));
      }
      $buildNode(this$static, mapNode, $getPropertyDefinitions(defMap).values_0(), properties);
      ($clinit_Boolean() , getAttributeAsBoolean(mapNode.jsObj, 'consistent')?TRUE:FALSE).value_0 || (parent_0.jsObj['consistent'] = false , undefined);
      setCheck(children.array, children.size_0++, mapNode);
    }
     else if (instanceOf(definition, Q$PropertyDefinitionList)) {
      defList = dynamicCast(definition, Q$PropertyDefinitionList);
      listNode = new TreeNode_2(defList.displayName);
      listNode.jsObj['consistent'] = true;
      if (instanceOf(defList.memberDefinition, Q$PropertyDefinitionMap)) {
        memberDef = defList.memberDefinition;
        memberDefColl = new ArrayList_1(1);
        setCheck(memberDefColl.array, memberDefColl.size_0++, memberDef);
        max = 0;
        for (map$iterator = new AbstractList$IteratorImpl_0(maps); map$iterator.i < map$iterator.this$0_0.size_1();) {
          map = dynamicCast($next_0(map$iterator), Q$AbstractPropertyMap);
          try {
            size = $getList_0(map.getList(defList.name_0)).size_1();
            size > max && (max = size);
          }
           catch ($e0) {
            $e0 = caught_0($e0);
            if (!instanceOf($e0, Q$Throwable))
              throw $e0;
          }
        }
        innerChildren = new ArrayList_0;
        for (i = 0; i < max; ++i) {
          listItemNode = new TreeNode_2('' + i);
          properties = new ArrayList_0;
          for (map$iterator = new AbstractList$IteratorImpl_0(maps); map$iterator.i < map$iterator.this$0_0.size_1();) {
            map = dynamicCast($next_0(map$iterator), Q$AbstractPropertyMap);
            try {
              list = $getList_0(map.getList(defList.name_0));
              list.size_1() < i + 1?$add_3(properties, new PropertyMap_0):$add_3(properties, dynamicCast(list.get_0(i), Q$PropertyMap));
            }
             catch ($e0) {
              $e0 = caught_0($e0);
              if (instanceOf($e0, Q$Throwable)) {
                $add_3(properties, new PropertyMap_0);
              }
               else 
                throw $e0;
            }
          }
          $buildNode(this$static, listItemNode, memberDefColl, properties);
          if (!($clinit_Boolean() , getAttributeAsBoolean(listItemNode.jsObj, 'consistent')?TRUE:FALSE).value_0) {
            parent_0.jsObj['consistent'] = false;
            listNode.jsObj['consistent'] = false;
          }
          setCheck(innerChildren.array, innerChildren.size_0++, listItemNode);
        }
        $setAttribute_17(listNode, 'children', dynamicCast($toArray_1(innerChildren, initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, innerChildren.size_0, 0)), Q$TreeNode_$1));
      }
      setCheck(children.array, children.size_0++, listNode);
    }
  }
  $setAttribute_17(parent_0, 'children', dynamicCast($toArray_1(children, initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, children.size_0, 0)), Q$TreeNode_$1));
}

function $buildTree(this$static){
  var children, group, group$iterator, groupNode, nonGroupDefs, root, tree;
  tree = new Tree_0;
  root = new TreeNode_2('Configuration Comparison');
  children = new ArrayList_0;
  nonGroupDefs = $getNonGroupedProperties(this$static.definition);
  if (!!nonGroupDefs && nonGroupDefs.size_0 != 0) {
    groupNode = new TreeNode_2('General Properties');
    $buildNode(this$static, groupNode, nonGroupDefs, this$static.configs);
    setCheck(children.array, children.size_0++, groupNode);
  }
  for (group$iterator = new AbstractList$IteratorImpl_0($getGroupDefinitions(this$static.definition)); group$iterator.i < group$iterator.this$0_0.size_1();) {
    group = dynamicCast($next_0(group$iterator), Q$PropertyGroupDefinition);
    groupNode = new TreeNode_2(group.displayName);
    $buildNode(this$static, groupNode, $getPropertiesInGroup(this$static.definition, group.name_0), this$static.configs);
    setCheck(children.array, children.size_0++, groupNode);
  }
  $setAttribute_17(root, 'children', dynamicCast($toArray_1(children, initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, children.size_0, 0)), Q$TreeNode_$1));
  $setAttribute(tree, root.jsObj);
  return tree;
}

function ConfigurationComparisonView_0(definition, configs, titles){
  VLayout_0.call(this);
  this.definition = definition;
  this.configs = configs;
  this.titles = titles;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
}

defineSeed(2220, 445, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), ConfigurationComparisonView_0);
_.onDraw_0 = function onDraw_17(){
  var columnField, fields, i, nameField, title, title$iterator, treeGrid, typeField;
  treeGrid = new TreeGrid_0;
  $isCreated_1(treeGrid)?$setProperty_3(treeGrid, 'width', '100%'):(treeGrid.config_0['width'] = '100%' , undefined);
  $setLoadDataOnDemand(treeGrid, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  fields = initDim(_3Lcom_smartgwt_client_widgets_tree_TreeGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeGridField, 2 + this.titles.size_0, 0);
  nameField = new TreeGridField_2('name', 'Name', 250);
  $setAttribute_8(nameField, 'frozen', TRUE);
  $setCellFormatter_0(nameField, new ConfigurationComparisonView$1_0);
  typeField = new TreeGridField_2('type', 'Type', 80);
  fields[0] = nameField;
  fields[1] = typeField;
  i = 2;
  for (title$iterator = new AbstractList$IteratorImpl_0(this.titles); title$iterator.i < title$iterator.this$0_0.size_1();) {
    title = dynamicCast($next_0(title$iterator), Q$String);
    columnField = new TreeGridField_2(title, title, 150);
    $setCellFormatter_0(columnField, new ConfigurationComparisonView$2_0);
    fields[i++] = columnField;
  }
  $isCreated_1(treeGrid)?$setProperty_2(treeGrid, 'fields', convertToJavaScriptArray(fields)):(treeGrid.config_0['fields'] = convertToJavaScriptArray(fields) , undefined);
  $setData_0(treeGrid, $buildTree(this));
  $addMember(this, treeGrid);
}
;
_.configs = null;
_.definition = null;
_.titles = null;
function ConfigurationComparisonView$1_0(){
}

defineSeed(2221, 1, {}, ConfigurationComparisonView$1_0);
_.format_1 = function format_22(o, listGridRecord, i, i1){
  return !listGridRecord || ($clinit_Boolean() , getAttributeAsBoolean(listGridRecord.jsObj, 'consistent')?TRUE:FALSE).value_0?'' + o:'<span style="color: red;">' + o + '<\/span>';
}
;
function ConfigurationComparisonView$2_0(){
}

defineSeed(2222, 1, {}, ConfigurationComparisonView$2_0);
_.format_1 = function format_23(o, listGridRecord, i, i1){
  return instanceOf(listGridRecord, Q$ConfigurationComparisonView$ComparisonTreeNode)?($clinit_Boolean() , getAttributeAsBoolean(listGridRecord.jsObj, 'consistent')?TRUE:FALSE).value_0?'' + o:'<span style="color: red;">' + o + '<\/span>':'';
}
;
function ConfigurationComparisonView$3_0(val$isResourceConfig, val$configs){
  this.val$isResourceConfig = val$isResourceConfig;
  this.val$configs = val$configs;
}

defineSeed(2223, 1, {}, ConfigurationComparisonView$3_0);
_.onTypesLoaded = function onTypesLoaded_6(type){
  var configurations, definition, titles, update, update$iterator, view, dialog;
  this.val$isResourceConfig?(definition = type.resourceConfigurationDefinition):(definition = type.pluginConfigurationDefinition);
  configurations = new ArrayList_0;
  titles = new ArrayList_0;
  for (update$iterator = new AbstractList$IteratorImpl_0(this.val$configs); update$iterator.i < update$iterator.this$0_0.size_1();) {
    update = dynamicCast($next_0(update$iterator), Q$AbstractResourceConfigurationUpdate);
    $add_3(configurations, update.configuration);
    $add_3(titles, '' + update.id);
  }
  $clinit_ConfigurationComparisonView();
  view = new ConfigurationComparisonView_0(definition, configurations, titles);
  dialog = new Window_1;
  $isCreated_1(dialog)?$setProperty_3(dialog, 'title', 'Comparing Configurations'):(dialog.config_0['title'] = 'Comparing Configurations' , undefined);
  $setShowMinimizeButton(dialog, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setShowMaximizeButton(dialog, TRUE);
  $isCreated_1(dialog)?$setProperty_0(dialog, 'width', 700):(dialog.config_0['width'] = 700 , undefined);
  $isCreated_1(dialog)?$setProperty_0(dialog, 'height', 500):(dialog.config_0['height'] = 500 , undefined);
  $setIsModal(dialog, TRUE);
  $setShowModalMask(dialog, TRUE);
  $setShowResizer(dialog, TRUE);
  $setShowFooter(dialog, TRUE);
  $setCanDragResize_0(dialog, TRUE);
  $setAutoCenter(dialog, TRUE);
  $centerInPage(dialog);
  $addItem(dialog, view);
  $addCloseClickHandler(dialog, new ConfigurationComparisonView$4_0(dialog));
  dialog.show_0();
}
;
_.val$configs = null;
_.val$isResourceConfig = false;
function ConfigurationComparisonView$4_0(val$dialog){
  this.val$dialog = val$dialog;
}

defineSeed(2224, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), ConfigurationComparisonView$4_0);
_.onCloseClick_0 = function onCloseClick_5(event_0){
  $markForDestroy(this.val$dialog);
}
;
_.val$dialog = null;
function ConfigurationComparisonView$ComparisonTreeNode_0(definition, properties, titles){
  var allTheSame, commonValue, i, prop, prop$iterator, value;
  TreeNode_2.call(this, definition.displayName);
  $setAttribute_13(this, 'type', definition.type_0.name_0);
  i = 0;
  allTheSame = true;
  commonValue = null;
  for (prop$iterator = new AbstractList$IteratorImpl_0(properties); prop$iterator.i < prop$iterator.this$0_0.size_1();) {
    prop = dynamicCast($next_0(prop$iterator), Q$PropertySimple);
    value = prop?prop.stringValue:null;
    i == 0?(commonValue = value):(allTheSame && commonValue == null && value != null || commonValue != null && !$equals_6(commonValue, value)) && (allTheSame = false);
    $setAttribute_13(this, dynamicCast($get_0(titles, i++), Q$String), value);
    this.jsObj['consistent'] = allTheSame;
  }
}

defineSeed(2225, 577, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$ConfigurationComparisonView$ComparisonTreeNode]), ConfigurationComparisonView$ComparisonTreeNode_0);
function $clinit_ConfigurationEditor(){
  $clinit_ConfigurationEditor = nullMethod;
  $clinit_BaseWidget();
  BOOLEAN_PROPERTY_ITEM_VALUE_MAP = new LinkedHashMap_0;
  $put_1(BOOLEAN_PROPERTY_ITEM_VALUE_MAP, ($clinit_Boolean() , TRUE).value_0?'true':'false', ($clinit_Enhanced() , 'Yes'));
  $put_1(BOOLEAN_PROPERTY_ITEM_VALUE_MAP, FALSE.value_0?'true':'false', 'No');
}

function $$init_17(this$static){
  this$static.configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  this$static.topLevelPropertiesValuesManager = new ValuesManager_0;
  this$static.loadingLabel = new Label_4('<b>' + ($clinit_Enhanced() , 'Loading...') + '<\/b>');
  this$static.invalidPropertyNameToDisplayNameMap = new HashMap_0;
  this$static.propertyValueChangeListeners = new HashSet_0;
}

function $addItemsForPropertiesRecursively(this$static, propertyDefinitions, propertyMap, fields){
  var odd, property, propertyDefinition, propertyDefinition$iterator, sortedPropertyDefinitions;
  odd = true;
  sortedPropertyDefinitions = new ArrayList_2(propertyDefinitions);
  sort_1(sortedPropertyDefinitions, new ConfigurationEditor$PropertyDefinitionComparator_0);
  for (propertyDefinition$iterator = new AbstractList$IteratorImpl_0(sortedPropertyDefinitions); propertyDefinition$iterator.i < propertyDefinition$iterator.this$0_0.size_1();) {
    propertyDefinition = dynamicCast($next_0(propertyDefinition$iterator), Q$PropertyDefinition);
    property = propertyMap.get_3(propertyDefinition.name_0);
    if (!property) {
      if (instanceOf(propertyDefinition, Q$PropertyDefinitionSimple)) {
        property = new PropertySimple_1(propertyDefinition.name_0, null);
        propertyMap.put_0(property);
      }
    }
    $addItemsForPropertyRecursively(this$static, propertyDefinition, property, odd, fields);
    odd = !odd;
  }
  return;
}

function $addItemsForPropertyRecursively(this$static, propertyDefinition, property, oddRow, fields){
  var field, field$iterator, fieldsForThisProperty, memberDefinition, propertyDefinitionList, propertyDefinitionMap, propertyDefinitionSimple, propertyList, propertyMap, propertySimple, fields_0, nameItem, mapField;
  if (instanceOf(propertyDefinition, Q$PropertyDefinitionSimple)) {
    propertyDefinitionSimple = dynamicCast(propertyDefinition, Q$PropertyDefinitionSimple);
    propertySimple = dynamicCast(property, Q$PropertySimple);
    fieldsForThisProperty = this$static.buildFieldsForPropertySimple(propertyDefinition, propertyDefinitionSimple, propertySimple);
  }
   else if (instanceOf(propertyDefinition, Q$PropertyDefinitionList)) {
    propertyDefinitionList = dynamicCast(propertyDefinition, Q$PropertyDefinitionList);
    memberDefinition = propertyDefinitionList.memberDefinition;
    propertyList = dynamicCast(property, Q$PropertyList);
    if (!propertyList) {
      propertyList = new PropertyList_1(propertyDefinitionList.name_0);
      $put_4(this$static.configuration, propertyList);
    }
    fieldsForThisProperty = this$static.buildFieldsForPropertyList(propertyDefinition, oddRow, propertyDefinitionList, memberDefinition, propertyList);
  }
   else if (instanceOf(propertyDefinition, Q$PropertyDefinitionMap)) {
    propertyDefinitionMap = dynamicCast(propertyDefinition, Q$PropertyDefinitionMap);
    propertyMap = dynamicCast(property, Q$PropertyMap);
    if (!propertyMap) {
      propertyMap = new PropertyMap_1(propertyDefinitionMap.name_0);
      $put_4(this$static.configuration, propertyMap);
    }
    fieldsForThisProperty = (fields_0 = new ArrayList_0 , nameItem = $buildNameItem(propertyDefinitionMap) , setCheck(fields_0.array, fields_0.size_0++, nameItem) , mapField = $buildMapField(this$static, propertyDefinitionMap, propertyMap) , setCheck(fields_0.array, fields_0.size_0++, mapField) , fields_0);
  }
   else {
    throw new IllegalStateException_1('Property definition null or of unknown type: ' + propertyDefinition);
  }
  for (field$iterator = new AbstractList$IteratorImpl_0(fieldsForThisProperty); field$iterator.i < field$iterator.this$0_0.size_1();) {
    field = dynamicCast($next_0(field$iterator), Q$FormItem);
    setCheck(fields.array, fields.size_0++, field);
    $isCreated_2(field)?$setProperty_8(field, 'cellStyle', oddRow?'OddRow':'EvenRow'):(field.jsObj['cellStyle'] = oddRow?'OddRow':'EvenRow' , undefined);
  }
}

function $addMemberPropertyDefinitionsToDynamicPropertyMap(propertyDefinitionMap, propertyMap){
  var memberPropertyDefinitionSimple, memberPropertySimple, propertyName, propertyName$iterator;
  for (propertyName$iterator = (!propertyMap.map && (propertyMap.map = new LinkedHashMap_0) , propertyMap.map).keySet_0().iterator(); propertyName$iterator.hasNext();) {
    propertyName = dynamicCast(propertyName$iterator.next_0(), Q$String);
    memberPropertySimple = dynamicCast(dynamicCast((!propertyMap.map && (propertyMap.map = new LinkedHashMap_0) , propertyMap.map).get_2(propertyName), Q$Property), Q$PropertySimple);
    if (memberPropertySimple) {
      memberPropertyDefinitionSimple = new PropertyDefinitionSimple_1(propertyName, null, false, ($clinit_PropertySimpleType() , STRING_0));
      $put_7(propertyDefinitionMap, memberPropertyDefinitionSimple);
    }
  }
}

function $addPropertyValueChangeListener(this$static, propertyValueChangeListener){
  $add_6(this$static.propertyValueChangeListeners, propertyValueChangeListener);
}

function $buildComplexPropertyField(canvas){
  var canvasItem;
  canvasItem = new CanvasItem_0;
  $setAttribute_28(canvasItem, 'canvas', !canvas?null:$getOrCreateJsObj_0(canvas));
  canvasItem.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
  return canvasItem;
}

function $buildDescriptionField(propertyDefinition){
  var descriptionItem;
  descriptionItem = new StaticTextItem_0;
  $setValue_7(descriptionItem, propertyDefinition.description);
  $setShowTitle_0(descriptionItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setEndRow_0(descriptionItem, TRUE);
  return descriptionItem;
}

function $buildFieldsForPropertySimple(this$static, propertyDefinition, propertyDefinitionSimple, propertySimple){
  var descriptionItem, fields, nameItem, unsetItem, valueItem;
  fields = new ArrayList_0;
  nameItem = $buildNameItem(propertyDefinition);
  setCheck(fields.array, fields.size_0++, nameItem);
  valueItem = this$static.buildSimpleField(propertyDefinitionSimple, propertySimple);
  unsetItem = this$static.buildUnsetItem(propertyDefinitionSimple, propertySimple, valueItem);
  setCheck(fields.array, fields.size_0++, unsetItem);
  setCheck(fields.array, fields.size_0++, valueItem);
  descriptionItem = $buildDescriptionField(propertyDefinition);
  setCheck(fields.array, fields.size_0++, descriptionItem);
  return fields;
}

function $buildGroupSection(this$static, group){
  var form, propertyDefinitions, section, title;
  if (!group) {
    section = new SectionStackSection_1(($clinit_Enhanced() , 'General Properties'));
    $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  }
   else {
    title = '<div style="float:left; font-weight: bold;">' + group.displayName + '<\/div>' + (group.description != null?"<div style='padding-left: 10px; font-weight: normal; font-size: smaller; float: left;'> - " + group.description + '<\/div>':'');
    section = new SectionStackSection_1(title);
    $setAttribute_13(section, 'name', group.name_0);
    $setExpanded(section, ($clinit_Boolean() , group.defaultHidden?FALSE:TRUE));
  }
  propertyDefinitions = new ArrayList_2(!group?$getNonGroupedProperties(this$static.configurationDefinition):$getPropertiesInGroup(this$static.configurationDefinition, group.name_0));
  form = $buildPropertiesForm(this$static, propertyDefinitions, this$static.configuration);
  form.validate_0() || $setExpanded(section, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $addItemJS(section, $getOrCreateJsObj_0(form));
  return section;
}

function $buildListOfMapsField(this$static, memberPropertyDefinitionMap, propertyDefinitionList, propertyList){
  var addRowButton, allSubDefsReadOnly, canvasItem, editField, field, fieldsList, icon, mapReadOnly, propertyDefinitions, propertyReadOnly, removeField, rows, subDef, subDef$iterator, summaryPropDef, summaryPropDef$iterator, summaryPropertyDefinitions, summaryTable, summaryTableHolder, toolStrip;
  $clinit_Log();
  $fine_0(logger_0, 'Building list-of-maps grid for ' + propertyList + '...');
  summaryTable = new ListGrid_0;
  summaryTable.setAlternateRecordStyles(($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setShowAllRecords(summaryTable, TRUE);
  $setAttribute_24(summaryTable, 'bodyOverflow', ($clinit_Overflow() , VISIBLE).value_0, true);
  $setAttribute_24(summaryTable, 'overflow', VISIBLE.value_0, true);
  $isCreated_1(summaryTable)?$setProperty_3(summaryTable, 'width', '100%'):(summaryTable.config_0['width'] = '100%' , undefined);
  $setAutoFitFieldWidths(summaryTable, TRUE);
  $setAttribute_24(summaryTable, 'autoFitWidthApproach', ($clinit_AutoFitWidthApproach() , BOTH).value_0, true);
  $isCreated_1(summaryTable)?undefined:(summaryTable.config_0['recordEnabledProperty'] = null , undefined);
  fieldsList = new ArrayList_0;
  propertyDefinitions = new ArrayList_2($getPropertyDefinitions(memberPropertyDefinitionMap).values_0());
  summaryPropertyDefinitions = new ArrayList_0;
  for (subDef$iterator = new AbstractList$IteratorImpl_0(propertyDefinitions); subDef$iterator.i < subDef$iterator.this$0_0.size_1();) {
    subDef = dynamicCast($next_0(subDef$iterator), Q$PropertyDefinition);
    subDef.summary && (setCheck(summaryPropertyDefinitions.array, summaryPropertyDefinitions.size_0++, subDef) , true);
  }
  summaryPropertyDefinitions.size_0 == 0 && $addAll_0(summaryPropertyDefinitions, propertyDefinitions);
  for (summaryPropDef$iterator = new AbstractList$IteratorImpl_0(summaryPropertyDefinitions); summaryPropDef$iterator.i < summaryPropDef$iterator.this$0_0.size_1();) {
    summaryPropDef = dynamicCast($next_0(summaryPropDef$iterator), Q$PropertyDefinition);
    field = $createListGridField(summaryPropDef);
    setCheck(fieldsList.array, fieldsList.size_0++, field);
  }
  allSubDefsReadOnly = isAllReadOnly(propertyDefinitions);
  editField = new ListGridField_2('edit', 20);
  $setAttribute_13(editField, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0);
  mapReadOnly = this$static.readOnly || allSubDefsReadOnly;
  icon = mapReadOnly?'[SKIN]/actions/view.png':'[SKIN]/actions/edit.png';
  $setAttribute_13(editField, 'cellIcon', getImgURL(icon));
  $setAttribute_8(editField, 'canEdit', FALSE);
  $setAttribute_8(editField, 'canGroupBy', FALSE);
  $setAttribute_8(editField, 'canSort', FALSE);
  $setAttribute_8(editField, 'canHide', FALSE);
  $addRecordClickHandler_0(editField, new ConfigurationEditor$10_0(this$static, summaryTable, propertyDefinitionList, propertyList, memberPropertyDefinitionMap, mapReadOnly));
  setCheck(fieldsList.array, fieldsList.size_0++, editField);
  propertyReadOnly = this$static.readOnly || !this$static.allPropertiesWritable && propertyDefinitionList.readOnly;
  if (!propertyReadOnly) {
    removeField = new ListGridField_2('remove', 20);
    $setAttribute_13(removeField, 'type', ICON_0.value_0);
    $setAttribute_13(removeField, 'cellIcon', getImgURL('[SKIN]/actions/remove.png'));
    $setAttribute_8(removeField, 'canEdit', FALSE);
    $setAttribute_8(removeField, 'canFilter', TRUE);
    $setFilterEditorType(removeField, new SpacerItem_0);
    $setAttribute_8(removeField, 'canGroupBy', FALSE);
    $setAttribute_8(removeField, 'canSort', FALSE);
    $setAttribute_8(removeField, 'canHide', FALSE);
    $addRecordClickHandler_0(removeField, new ConfigurationEditor$11_0(this$static, summaryTable, propertyDefinitionList, propertyList, propertyDefinitions));
    $setEditorType(editField, new ButtonItem_1('delete', ($clinit_Enhanced() , 'Delete')));
    setCheck(fieldsList.array, fieldsList.size_0++, removeField);
  }
  $setFields_1(summaryTable, dynamicCast($toArray_1(fieldsList, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fieldsList.size_0, 0)), Q$ListGridField_$1));
  rows = $buildSummaryRecords(propertyList, propertyDefinitions);
  $isCreated_1(summaryTable)?$setProperty_2(summaryTable, 'data', convertToJavaScriptArray(rows)):(summaryTable.config_0['data'] = convertToJavaScriptArray(rows) , undefined);
  summaryTableHolder = new EnhancedVLayout_0;
  toolStrip = new ToolStrip_0;
  $isCreated_1(toolStrip)?$setProperty_3(toolStrip, 'width', '100%'):(toolStrip.config_0['width'] = '100%' , undefined);
  if (!propertyReadOnly) {
    addRowButton = new IButton_0;
    $setIcon_0(addRowButton, getImgURL('[SKIN]/actions/add.png'));
    $addClickHandler(addRowButton, new ConfigurationEditor$12_0(this$static, summaryTable, propertyDefinitionList, propertyList, memberPropertyDefinitionMap, mapReadOnly));
    $addMember(toolStrip, addRowButton);
  }
  $setMembers(summaryTableHolder, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [summaryTable, toolStrip]));
  canvasItem = $buildComplexPropertyField(summaryTableHolder);
  $isCreated_2(canvasItem)?$setProperty_6(canvasItem, 'colSpan', 3):(canvasItem.jsObj['colSpan'] = 3 , undefined);
  canvasItem.setEndRow(TRUE);
  return canvasItem;
}

function $buildListOfSimplesField(this$static, propertyDefinitionList, propertyList){
  var deleteButton, footer, listGrid, memberValueToIndexMap, membersItem, newButton, vLayout;
  $clinit_Log();
  $fine_0(logger_0, 'Building list-of-simples field for ' + propertyList + '...');
  vLayout = new EnhancedVLayout_0;
  listGrid = new DynamicForm_0;
  $addMember(vLayout, listGrid);
  membersItem = new SelectItem_1(propertyList.name_0);
  $setShowTitle_0(membersItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setMultiple(membersItem, TRUE);
  $setAttribute_30(membersItem, 'multipleAppearance', ($clinit_MultipleAppearance() , GRID).value_0);
  $isCreated_2(membersItem)?$setProperty_6(membersItem, 'width', 220):(membersItem.jsObj['width'] = 220 , undefined);
  $isCreated_2(membersItem)?$setProperty_6(membersItem, 'height', 60):(membersItem.jsObj['height'] = 60 , undefined);
  memberValueToIndexMap = buildValueMap(propertyList);
  membersItem.setValueMap_0(memberValueToIndexMap);
  listGrid.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [membersItem]));
  if (!$isReadOnly(this$static, propertyDefinitionList, propertyList)) {
    footer = new ToolStrip_0;
    $setPadding(footer, valueOf_44(5));
    $isCreated_1(footer)?$setProperty_3(footer, 'width', '100%'):(footer.config_0['width'] = '100%' , undefined);
    $isCreated_1(footer)?$setProperty_0(footer, 'membersMargin', 15):(footer.config_0['membersMargin'] = 15 , undefined);
    $addMember(vLayout, footer);
    deleteButton = new EnhancedIButton_0;
    $setIcon_0(deleteButton, getImgURL('[SKIN]/actions/remove.png'));
    $setPrompt(deleteButton, ($clinit_Enhanced() , 'Delete the selected items from the list.'));
    $setAttribute_22(deleteButton, 'disabled', TRUE, true);
    $addClickHandler(deleteButton, new ConfigurationEditor$13_0(this$static, membersItem, propertyList, propertyDefinitionList, deleteButton));
    $addMember(footer, deleteButton);
    $addChangedHandler(membersItem, new ConfigurationEditor$14_0(membersItem, deleteButton));
    newButton = new EnhancedIButton_1('New');
    $setIcon_0(newButton, getImgURL('[SKIN]/actions/add.png'));
    $setPrompt(newButton, 'Add an item to the list.');
    $addClickHandler(newButton, new ConfigurationEditor$15_0(this$static, propertyList, propertyDefinitionList, membersItem));
    $addMember(footer, newButton);
  }
  return $buildComplexPropertyField(vLayout);
}

function $buildMapField(this$static, propertyDefinitionMap, propertyMap){
  var buttonBar, canvasItem, deleteControlsLayout, deleteForm, description, isDynamic, layout, newButton, okButton, propertyDefinitionMapClone, selectItem, spacer, valuesCanvas, memberPropertyDefinitions;
  isDynamic = (memberPropertyDefinitions = (!propertyDefinitionMap.map && (propertyDefinitionMap.map = new HashMap_0) , propertyDefinitionMap.map) , memberPropertyDefinitions.isEmpty_0());
  if (isDynamic) {
    propertyDefinitionMapClone = new PropertyDefinitionMap_1(propertyDefinitionMap.name_0, propertyDefinitionMap.description, propertyDefinitionMap.required, initValues(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PropertyDefinition, []));
    $setConfigurationDefinition(propertyDefinitionMapClone, propertyDefinitionMap.configurationDefinition);
    $setReadOnly_0(propertyDefinitionMapClone, propertyDefinitionMap.readOnly);
    $addMemberPropertyDefinitionsToDynamicPropertyMap(propertyDefinitionMapClone, propertyMap);
    propertyDefinitionMap = propertyDefinitionMapClone;
  }
  layout = new EnhancedVLayout_0;
  description = new HTMLFlow_1(propertyDefinitionMap.description);
  $addMember(layout, description);
  valuesCanvas = $buildPropertiesForm(this$static, $getPropertyDefinitions(propertyDefinitionMap).values_0(), propertyMap);
  $addMember(layout, valuesCanvas);
  if (isDynamic && !$isReadOnly(this$static, propertyDefinitionMap, propertyMap)) {
    buttonBar = new EnhancedToolStrip_0;
    $setPadding(buttonBar, valueOf_44(5));
    $isCreated_1(buttonBar)?$setProperty_0(buttonBar, 'membersMargin', 15):(buttonBar.config_0['membersMargin'] = 15 , undefined);
    newButton = new EnhancedIButton_1(($clinit_Enhanced() , 'New'));
    $setIcon_0(newButton, getImgURL('[SKIN]/actions/add.png'));
    $addClickHandler(newButton, new ConfigurationEditor$7_0(this$static, propertyMap, propertyDefinitionMap));
    $addMember(buttonBar, newButton);
    spacer = new HLayout_0;
    $isCreated_1(spacer)?$setProperty_0(spacer, 'width', 12):(spacer.config_0['width'] = 12 , undefined);
    $addMember(buttonBar, spacer);
    deleteControlsLayout = new EnhancedHLayout_0;
    $setMargin(deleteControlsLayout, valueOf_44(3));
    $isCreated_1(deleteControlsLayout)?$setProperty_0(deleteControlsLayout, 'membersMargin', 3):(deleteControlsLayout.config_0['membersMargin'] = 3 , undefined);
    $isCreated_1(deleteControlsLayout)?$setProperty_3(deleteControlsLayout, 'width', '100%'):(deleteControlsLayout.config_0['width'] = '100%' , undefined);
    deleteForm = new DynamicForm_0;
    $isCreated_1(deleteForm)?$setProperty_3(deleteForm, 'width', '100%'):(deleteForm.config_0['width'] = '100%' , undefined);
    selectItem = new SortedSelectItem_0;
    $setMultiple(selectItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $setAttribute_30(selectItem, 'multipleAppearance', ($clinit_MultipleAppearance() , GRID).value_0);
    $setTitle_1(selectItem, 'Delete');
    $setValueMap_2(selectItem, dynamicCast((!propertyDefinitionMap.map && (propertyDefinitionMap.map = new HashMap_0) , propertyDefinitionMap.map).keySet_0().toArray_0(initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, (!propertyDefinitionMap.map && (propertyDefinitionMap.map = new HashMap_0) , propertyDefinitionMap.map).size_1(), 0)), Q$String_$1));
    okButton = new EnhancedIButton_0;
    $setTitle_0(okButton, 'OK');
    $setAttribute_22(okButton, 'disabled', TRUE, true);
    $addClickHandler(okButton, new ConfigurationEditor$8_0(this$static, selectItem, propertyMap, propertyDefinitionMap));
    $addChangedHandler(selectItem, new ConfigurationEditor$9_0(okButton));
    deleteForm.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [selectItem]));
    $addMember(deleteControlsLayout, deleteForm);
    $addMember(deleteControlsLayout, okButton);
    $addMember(buttonBar, deleteControlsLayout);
    $addMember(layout, buttonBar);
  }
  canvasItem = $buildComplexPropertyField(layout);
  $isCreated_2(canvasItem)?$setProperty_6(canvasItem, 'colSpan', 3):(canvasItem.jsObj['colSpan'] = 3 , undefined);
  canvasItem.setEndRow(($clinit_Boolean() , $clinit_Boolean() , TRUE));
  return canvasItem;
}

function $buildNameItem(propertyDefinition){
  var nameItem, title;
  nameItem = new StaticTextItem_0;
  $setStartRow_0(nameItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  title = '<b>' + (propertyDefinition.displayName != null?propertyDefinition.displayName:propertyDefinition.name_0) + '<\/b>';
  $setValue_7(nameItem, title);
  $setShowTitle_0(nameItem, FALSE);
  return nameItem;
}

function $buildPropertiesForm(this$static, propertyDefinitions, propertyMap){
  var fields, form;
  form = new DynamicForm_0;
  instanceOf(propertyMap, Q$Configuration) && $addMember_1(this$static.topLevelPropertiesValuesManager, form);
  $setHiliteRequiredFields(form, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 4):(form.config_0['numCols'] = 4 , undefined);
  $isCreated_1(form)?$setProperty_0(form, 'cellPadding', 5):(form.config_0['cellPadding'] = 5 , undefined);
  $setColWidths(form, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [valueOf_44(190), valueOf_44(28), valueOf_44(210)]));
  fields = new ArrayList_0;
  $add_3(fields, $createHeaderTextItem(($clinit_Enhanced() , 'Property')));
  $add_3(fields, $createHeaderTextItem('Unset?'));
  $add_3(fields, $createHeaderTextItem('Value'));
  $add_3(fields, $createHeaderTextItem('Description'));
  $addItemsForPropertiesRecursively(this$static, propertyDefinitions, propertyMap, fields);
  form.setFields(dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, fields.size_0, 0)), Q$FormItem_$1));
  return form;
}

function $buildSimpleField(this$static, propertyDefinitionSimple, propertySimple){
  var enumeratedValues, escapedValue, option, option$iterator, propertyIsReadOnly, radioGroupItem, spinnerItem, validators, value, valueItem, valueOptions;
  value = propertySimple.stringValue;
  null == value && null != propertyDefinitionSimple.defaultValue && (value = propertyDefinitionSimple.defaultValue);
  valueItem = null;
  propertyIsReadOnly = $isReadOnly(this$static, propertyDefinitionSimple, propertySimple);
  $clinit_Log();
  $fine_0(logger_0, 'Building simple field for ' + propertySimple + '(read-only:' + propertyIsReadOnly + ')...');
  if (propertyIsReadOnly && propertyDefinitionSimple.type_0 != ($clinit_PropertySimpleType() , PASSWORD_0)) {
    valueItem = new StaticTextItem_0;
    escapedValue = escapeHtml(value);
    valueItem.setValue_4(this$static.preserveTextFormatting?'<pre>' + escapedValue + '<\/pre>':escapedValue);
  }
   else {
    enumeratedValues = propertyDefinitionSimple.enumeratedValues;
    if (!!enumeratedValues && !enumeratedValues.isEmpty_0()) {
      valueOptions = new LinkedHashMap_0;
      for (option$iterator = propertyDefinitionSimple.enumeratedValues.iterator(); option$iterator.hasNext();) {
        option = dynamicCast(option$iterator.next_0(), Q$PropertyDefinitionEnumeration);
        $put_1(valueOptions, option.value_0, option.name_0);
      }
      if (propertyDefinitionSimple.allowCustomEnumeratedValue) {
        valueItem = new ComboBoxItem_0;
        $setAttribute_29(dynamicCast(valueItem, Q$ComboBoxItem), 'addUnknownValues', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
      }
       else {
        valueOptions.map.size_1() > 5?(valueItem = new SelectItem_0):(valueItem = new RadioGroupItem_0);
      }
      valueItem.setValueMap_0(valueOptions);
    }
     else {
      switch (propertyDefinitionSimple.type_0.ordinal) {
        case 0:
        case 8:
        case 9:
        case 5:
          valueItem = new TextItem_0;
          break;
        case 1:
          valueItem = new TextAreaItem_0;
          break;
        case 2:
          valueItem = new PasswordItem_0;
          break;
        case 3:
          radioGroupItem = new RadioGroupItem_0;
          $setAttribute_29(radioGroupItem, 'vertical', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
          $setValueMap(radioGroupItem, BOOLEAN_PROPERTY_ITEM_VALUE_MAP);
          valueItem = radioGroupItem;
          break;
        case 4:
          spinnerItem = new SpinnerItem_0;
          $setAttribute_11(spinnerItem, 'min', valueOf_44(-2147483648));
          $setAttribute_11(spinnerItem, 'max', valueOf_44(2147483647));
          valueItem = spinnerItem;
          break;
        case 6:
        case 7:
          valueItem = new FloatItem_0;
      }
    }
    $setDisabled_2(valueItem, ($clinit_Boolean() , propertyIsReadOnly || !propertyDefinitionSimple.required && (!propertySimple || propertySimple.stringValue == null)?TRUE:FALSE));
    validators = $buildValidators(propertyDefinitionSimple, propertySimple);
    valueItem.setValidators(dynamicCast($toArray_1(validators, initDim(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, validators.size_0, 0)), Q$Validator_$1));
    !propertyDefinitionSimple.required && (!propertySimple || propertySimple.stringValue == null)?(valueItem.setValue_4(null) , valueItem.setDefaultValue_0(null)):valueItem.setValue_4(this$static.preserveTextFormatting?'<pre>' + value + '<\/pre>':value);
    if (!!propertySimple.configuration || !!propertySimple.parentMap || !!propertySimple.parentList) {
      $addChangedHandler(valueItem, new ConfigurationEditor$16_0(this$static, propertySimple, propertyDefinitionSimple));
      instanceOf(valueItem, Q$SpinnerItem) && $addBlurHandler(valueItem, new ConfigurationEditor$17_0(this$static, propertySimple, propertyDefinitionSimple));
    }
  }
  $setName_0(valueItem, propertySimple.name_0);
  valueItem.setTitle('none');
  valueItem.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setValueAsTooltipIfAppropriate(valueItem, this$static.preserveTextFormatting?'<pre>' + value + '<\/pre>':value);
  $setRequired(valueItem, propertyDefinitionSimple.required?TRUE:FALSE);
  valueItem.setWidth(220);
  return valueItem;
}

function $buildStructuredPane(this$static){
  var definition, definition$iterator, form, groupDefinitions, layout, propertyDefinitions, sectionStack;
  layout = new EnhancedVLayout_0;
  groupDefinitions = $getGroupDefinitions(this$static.configurationDefinition);
  if (groupDefinitions.size_0 == 0) {
    propertyDefinitions = new ArrayList_2($getNonGroupedProperties(this$static.configurationDefinition));
    form = $buildPropertiesForm(this$static, propertyDefinitions, this$static.configuration);
    $isCreated_1(form)?$setProperty_3(form, 'border', '1px solid #AAA'):(form.config_0['border'] = '1px solid #AAA' , undefined);
    form.validate_0();
    $addMember(layout, form);
  }
   else {
    sectionStack = new SectionStack_0;
    $setAttribute_24(sectionStack, 'visibilityMode', ($clinit_VisibilityMode() , MULTIPLE_0).value_0, true);
    $isCreated_1(sectionStack)?$setProperty_3(sectionStack, 'width', '100%'):(sectionStack.config_0['width'] = '100%' , undefined);
    $isCreated_1(sectionStack)?$setProperty_3(sectionStack, 'height', '100%'):(sectionStack.config_0['height'] = '100%' , undefined);
    $setScrollSectionIntoView(sectionStack, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $setAttribute_24(sectionStack, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
    $getNonGroupedProperties(this$static.configurationDefinition).size_0 == 0 || $addSection(sectionStack, $buildGroupSection(this$static, null));
    for (definition$iterator = new AbstractList$IteratorImpl_0(groupDefinitions); definition$iterator.i < definition$iterator.this$0_0.size_1();) {
      definition = dynamicCast($next_0(definition$iterator), Q$PropertyGroupDefinition);
      $addSection(sectionStack, $buildGroupSection(this$static, definition));
    }
    this$static.toolStrip = $buildToolStrip(this$static, sectionStack);
    $addMember(layout, this$static.toolStrip);
    $addMember(layout, sectionStack);
  }
  $fireInitialPropertyChangedEvent(this$static);
  return layout;
}

function $buildSummaryRecords(propertyList, definitions){
  var index, list, listSize, record, records, row, rowMap;
  records = initDim(_3Lorg_rhq_enterprise_gui_coregui_client_components_configuration_PropertyMapListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PropertyMapListGridRecord, !propertyList?0:(!propertyList.list && (propertyList.list = new ArrayList_0) , propertyList.list).size_1(), 0);
  list = (!propertyList.list && (propertyList.list = new ArrayList_0) , propertyList.list);
  for (index = 0 , listSize = list.size_1(); index < listSize; ++index) {
    row = dynamicCast(list.get_0(index), Q$Property);
    rowMap = dynamicCast(row, Q$PropertyMap);
    record = new PropertyMapListGridRecord_0(rowMap, index, definitions);
    records[index] = record;
  }
  return records;
}

function $buildToolStrip(this$static, sectionStack){
  var hideAllItem, item, menu, section, section$array, section$index, section$max, titleLabel, toolStrip;
  toolStrip = new EnhancedToolStrip_0;
  $isCreated_1(toolStrip)?$setProperty_3(toolStrip, 'backgroundImage', null):(toolStrip.config_0['backgroundImage'] = null , undefined);
  $isCreated_1(toolStrip)?$setProperty_3(toolStrip, 'width', '100%'):(toolStrip.config_0['width'] = '100%' , undefined);
  $isCreated_1(toolStrip)?$setProperty_0(toolStrip, 'membersMargin', 3):(toolStrip.config_0['membersMargin'] = 3 , undefined);
  $setPadding(toolStrip, valueOf_44(3));
  if (this$static.editorTitle != null) {
    titleLabel = new Label_4(this$static.editorTitle);
    $setWrap_0(titleLabel, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addMember(toolStrip, titleLabel);
  }
  menu = new Menu_0;
  for (section$array = $getSections(sectionStack) , section$index = 0 , section$max = section$array.length; section$index < section$max; ++section$index) {
    section = section$array[section$index];
    item = new MenuItem_1(!section.stack || !$isDrawn(section.stack).value_0?getAttribute(section.jsObj, 'title'):$getAttribute($getSection(section.stack, getAttribute(section.jsObj, 'name')), 'title'));
    $setAttribute_13(item, 'name', getAttribute(section.jsObj, 'name'));
    $addClickHandler_3(item, new ConfigurationEditor$5_0(sectionStack));
    $addItem_0(menu, item);
  }
  $addItem_0(menu, new MenuItemSeparator_0);
  hideAllItem = new MenuItem_1(($clinit_Enhanced() , 'Hide All'));
  $addClickHandler_3(hideAllItem, new ConfigurationEditor$6_0(sectionStack));
  $addItem_0(menu, hideAllItem);
  $addMember(toolStrip, new IMenuButton_1('Jump to Section', menu));
  return toolStrip;
}

function $buildUnsetItem(this$static, propertyDefinitionSimple, propertySimple, valueItem){
  var item, unset, unsetItem;
  if (propertyDefinitionSimple.required) {
    item = new SpacerItem_0;
    item.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
  }
   else {
    unsetItem = new CheckboxItem_1('unset-' + ($isCreated_2(valueItem)?$getPropertyAsString(valueItem, 'name'):getAttribute(valueItem.jsObj, 'name')));
    unset = !propertyDefinitionSimple.required && (!propertySimple || propertySimple.stringValue == null);
    $setValue_9(unsetItem, unset);
    $setDisabled_2(unsetItem, ($clinit_Boolean() , $isReadOnly(this$static, propertyDefinitionSimple, propertySimple)?TRUE:FALSE));
    $setAttribute_29(unsetItem, 'showLabel', FALSE);
    $setAttribute_29(unsetItem, 'showTitle', FALSE);
    $setAttribute_29(unsetItem, 'labelAsTitle', FALSE);
    $addChangedHandler(unsetItem, new ConfigurationEditor$18_0(this$static, valueItem, unsetItem, propertySimple, propertyDefinitionSimple));
    $addChangedHandler(valueItem, new ConfigurationEditor$19_0(unsetItem));
    $addFocusHandler(valueItem, new ConfigurationEditor$20_0(this$static, valueItem, unsetItem));
    item = unsetItem;
  }
  return item;
}

function $buildValidators(propertyDefinition, property){
  var constraint, constraint$iterator, constraints, floatConstraint, integerConstraint, lengthRangeValidator, typeValidator, validator, validators;
  validators = new ArrayList_0;
  typeValidator = null;
  switch (propertyDefinition.type_0.ordinal) {
    case 0:
    case 1:
    case 8:
    case 9:
      lengthRangeValidator = new LengthRangeValidator_0;
      $setAttribute_11(lengthRangeValidator, 'max', valueOf_44(2000));
      typeValidator = lengthRangeValidator;
      break;
    case 4:
      typeValidator = new IsIntegerValidator_0;
      break;
    case 5:
      typeValidator = new IsLongValidator_0;
      break;
    case 6:
    case 7:
      typeValidator = new IsFloatValidator_0;
  }
  !!typeValidator && (setCheck(validators.array, validators.size_0++, typeValidator) , true);
  constraints = propertyDefinition.constraints;
  if (constraints) {
    for (constraint$iterator = constraints.iterator(); constraint$iterator.hasNext();) {
      constraint = dynamicCast(constraint$iterator.next_0(), Q$Constraint);
      if (instanceOf(constraint, Q$IntegerRangeConstraint)) {
        integerConstraint = dynamicCast(constraint, Q$IntegerRangeConstraint);
        validator = new IntegerRangeValidator_0;
        integerConstraint.minimum?$setAttribute_3(validator, 'min', toInt(integerConstraint.minimum.value_0)):(validator.jsObj['min'] = -2147483648 , undefined);
        integerConstraint.maximum?$setAttribute_3(validator, 'max', toInt(integerConstraint.maximum.value_0)):(validator.jsObj['max'] = 2147483647 , undefined);
        setCheck(validators.array, validators.size_0++, validator);
      }
       else if (instanceOf(constraint, Q$FloatRangeConstraint)) {
        floatConstraint = dynamicCast(constraint, Q$FloatRangeConstraint);
        validator = new FloatRangeValidator_0;
        !!floatConstraint.minimum && $setAttribute_2(validator, 'min', floatConstraint.minimum.value_0);
        !!floatConstraint.maximum && $setAttribute_2(validator, 'max', floatConstraint.maximum.value_0);
        setCheck(validators.array, validators.size_0++, validator);
      }
       else if (instanceOf(constraint, Q$RegexConstraint)) {
        validator = new RegExpValidator_1('^' + constraint.details + '$');
        setCheck(validators.array, validators.size_0++, validator);
      }
    }
  }
  validator = new ConfigurationEditor$PluginReportedErrorValidator_0(property);
  setCheck(validators.array, validators.size_0++, validator);
  return validators;
}

function $createHeaderTextItem(value){
  var unsetHeader;
  unsetHeader = new StaticTextItem_0;
  $setValue_7(unsetHeader, value);
  $setShowTitle_0(unsetHeader, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_2(unsetHeader)?$setProperty_8(unsetHeader, 'cellStyle', 'configurationEditorHeaderCell'):(unsetHeader.jsObj['cellStyle'] = 'configurationEditorHeaderCell' , undefined);
  return unsetHeader;
}

function $createListGridField(summaryPropDef){
  var defSimple, field, propSimpleType;
  field = new ListGridField_4(summaryPropDef.name_0, summaryPropDef.displayName, 90);
  defSimple = dynamicCast(summaryPropDef, Q$PropertyDefinitionSimple);
  propSimpleType = defSimple.type_0;
  switch (propSimpleType.ordinal) {
    case 3:
      $setAttribute_13(field, 'type', ($clinit_ListGridFieldType() , BOOLEAN_1).value_0);
      break;
    case 4:
    case 5:
      $setAttribute_13(field, 'type', ($clinit_ListGridFieldType() , INTEGER_0).value_0);
      break;
    case 6:
    case 7:
      $setAttribute_13(field, 'type', ($clinit_ListGridFieldType() , FLOAT_1).value_0);
      break;
    default:$setAttribute_13(field, 'type', ($clinit_ListGridFieldType() , TEXT_0).value_0);
  }
  return field;
}

function $createPopup(title, width, height){
  var popup;
  popup = new Window_1;
  $isCreated_1(popup)?$setProperty_3(popup, 'title', title):(popup.config_0['title'] = title , undefined);
  $isCreated_1(popup)?$setProperty_0(popup, 'width', width):(popup.config_0['width'] = width , undefined);
  $isCreated_1(popup)?$setProperty_0(popup, 'height', height):(popup.config_0['height'] = height , undefined);
  $setIsModal(popup, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setShowModalMask(popup, TRUE);
  $centerInPage(popup);
  return popup;
}

function $displayMapEditor(this$static, summaryTable, existingRecord, propertyDefinitionList, propertyList, memberMapDefinition, memberMap, mapReadOnly){
  var buttonBar, cancelButton, childForm, layout, memberDefinitions, newRow, okButton, popup, title, workingMap;
  memberDefinitions = new ArrayList_2($getPropertyDefinitions(memberMapDefinition).values_0());
  newRow = !memberMap;
  workingMap = newRow?new PropertyMap_1(memberMapDefinition.name_0):$deepCopy_1(memberMap, true);
  title = mapReadOnly?($clinit_Enhanced() , 'View Row'):($clinit_Enhanced() , 'Edit Row');
  popup = $createPopup(title, 800, 600);
  layout = new EnhancedVLayout_0;
  $isCreated_1(layout)?$setProperty_3(layout, 'height', '100%'):(layout.config_0['height'] = '100%' , undefined);
  $setMargin(layout, valueOf_44(8));
  childForm = $buildPropertiesForm(this$static, memberDefinitions, workingMap);
  $isCreated_1(childForm)?$setProperty_3(childForm, 'height', '100%'):(childForm.config_0['height'] = '100%' , undefined);
  $addMember(layout, childForm);
  buttonBar = new ToolStrip_0;
  $setPadding(buttonBar, valueOf_44(5));
  $isCreated_1(buttonBar)?$setProperty_3(buttonBar, 'width', '100%'):(buttonBar.config_0['width'] = '100%' , undefined);
  $isCreated_1(buttonBar)?$setProperty_0(buttonBar, 'membersMargin', 15):(buttonBar.config_0['membersMargin'] = 15 , undefined);
  $setAttribute_24(buttonBar, 'align', ($clinit_Alignment() , CENTER_0).value_0, true);
  okButton = new IButton_1(($clinit_Enhanced() , 'OK'));
  mapReadOnly || $disable(okButton);
  $addClickHandler(okButton, new ConfigurationEditor$21_0(this$static, mapReadOnly, childForm, okButton, newRow, propertyList, workingMap, memberDefinitions, summaryTable, memberMap, existingRecord, propertyDefinitionList, layout, popup));
  $addItemChangedHandler(childForm, new ConfigurationEditor$22_0(okButton));
  $addMember(buttonBar, okButton);
  if (!mapReadOnly) {
    cancelButton = new IButton_1('Cancel');
    $addClickHandler(cancelButton, new ConfigurationEditor$23_0(layout, popup));
    $addMember(buttonBar, cancelButton);
  }
  this$static.blurUnsetItem = null;
  this$static.blurValueItem = null;
  $addMember(layout, buttonBar);
  $addItem(popup, layout);
  popup.show_0();
}

function $fireInitialPropertyChangedEvent(this$static){
  var event_0, key, key$iterator, propertyDefinition, propertyName, validationErrors;
  validationErrors = $getErrors_0(this$static.topLevelPropertiesValuesManager);
  if (validationErrors) {
    for (key$iterator = validationErrors.keySet_0().iterator(); key$iterator.hasNext();) {
      key = key$iterator.next_0();
      propertyName = dynamicCast(key, Q$String);
      propertyDefinition = $get_8(this$static.configurationDefinition, propertyName);
      this$static.invalidPropertyNameToDisplayNameMap.put(propertyName, propertyDefinition.displayName);
    }
    if (this$static.invalidPropertyNameToDisplayNameMap.size_1() != 0) {
      event_0 = new PropertyValueChangeEvent_0(true, this$static.invalidPropertyNameToDisplayNameMap);
      $firePropertyChangedEvent_0(this$static, event_0);
    }
  }
}

function $firePropertyChangedEvent(this$static, propertyDefinition, isValid){
  var event_0, invalidPropertySetChanged, topLevelPropertyDefinition;
  topLevelPropertyDefinition = getTopLevelPropertyDefinition(propertyDefinition);
  isValid?(invalidPropertySetChanged = this$static.invalidPropertyNameToDisplayNameMap.remove_3(topLevelPropertyDefinition.name_0) != null):(invalidPropertySetChanged = this$static.invalidPropertyNameToDisplayNameMap.put(topLevelPropertyDefinition.name_0, topLevelPropertyDefinition.displayName) == null);
  event_0 = new PropertyValueChangeEvent_0(invalidPropertySetChanged, this$static.invalidPropertyNameToDisplayNameMap);
  $firePropertyChangedEvent_0(this$static, event_0);
}

function $firePropertyChangedEvent_0(this$static, event_0){
  var propertyValueChangeListener, propertyValueChangeListener$iterator;
  for (propertyValueChangeListener$iterator = $iterator($keySet(this$static.propertyValueChangeListeners.map)); propertyValueChangeListener$iterator.val$outerIter.hasNext();) {
    propertyValueChangeListener = dynamicCast($next_1(propertyValueChangeListener$iterator), Q$PropertyValueChangeListener);
    propertyValueChangeListener.propertyValueChanged(event_0);
  }
}

function $handleFocusChange(this$static, valueItem, unsetItem){
  var isUnset;
  if (!(!this$static.blurValueItem || valueItem == this$static.blurValueItem)) {
    isUnset = null == this$static.blurValueItem.getValue_1();
    if (isUnset != $isDisabled_0(this$static.blurValueItem).value_0) {
      $setDisabled_2(this$static.blurValueItem, ($clinit_Boolean() , isUnset?TRUE:FALSE));
      $redraw_0(this$static.blurValueItem);
    }
    if (isUnset != $getValueAsBoolean(this$static.blurUnsetItem).value_0) {
      $setValue_9(this$static.blurUnsetItem, isUnset);
      $redraw_0(this$static.blurUnsetItem);
    }
  }
  this$static.blurValueItem = valueItem;
  this$static.blurUnsetItem = unsetItem;
}

function $isReadOnly(this$static, propertyDefinition, property){
  var errorMessage, propertySimple;
  if (this$static.readOnly) {
    return true;
  }
  if (this$static.allPropertiesWritable) {
    return false;
  }
  errorMessage = property.errorMessage_0;
  if (errorMessage != null && !$equals_6($trim(errorMessage), '')) {
    return false;
  }
  if (instanceOf(property, Q$PropertySimple)) {
    propertySimple = dynamicCast(property, Q$PropertySimple);
    if (propertyDefinition.required && propertySimple.stringValue == null || $equals_6('', propertySimple.stringValue)) {
      return false;
    }
  }
  return propertyDefinition.readOnly;
}

function $mergePropertyMap(sourceMap, targetMap, memberDefinitions){
  var existingProp, newValue, propertySimple, subDef, subDef$iterator, subDefSimple;
  for (subDef$iterator = new AbstractList$IteratorImpl_0(memberDefinitions); subDef$iterator.i < subDef$iterator.this$0_0.size_1();) {
    subDef = dynamicCast($next_0(subDef$iterator), Q$PropertyDefinition);
    subDefSimple = dynamicCast(subDef, Q$PropertyDefinitionSimple);
    propertySimple = dynamicCast($get_7(sourceMap, subDefSimple.name_0), Q$PropertySimple);
    newValue = propertySimple?propertySimple.stringValue:null;
    existingProp = $getSimple_0(targetMap, subDefSimple.name_0);
    $setValue_12(existingProp, newValue);
  }
}

function $reload(this$static){
  var childCanvas, childCanvas$array, childCanvas$index, childCanvas$max, label, msg, oobProp, structuredConfigLayout;
  if (!this$static.configurationDefinition || !this$static.configuration) {
    return;
  }
  !this$static.originalConfiguration && (this$static.originalConfiguration = $deepCopy(this$static.configuration, true));
  oobProp = $getSimpleValue(this$static.configuration, '__OOB', null);
  if (oobProp != null) {
    msg = new Message_8(oobProp, ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient)));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  }
  for (childCanvas$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'children')) , childCanvas$index = 0 , childCanvas$max = childCanvas$array.length; childCanvas$index < childCanvas$max; ++childCanvas$index) {
    childCanvas = childCanvas$array[childCanvas$index];
    childCanvas.destroy_0();
  }
  if ($getConfigurationFormat(this$static.configurationDefinition) == ($clinit_ConfigurationFormat() , STRUCTURED) || $getConfigurationFormat(this$static.configurationDefinition) == STRUCTURED_AND_RAW) {
    $clinit_Log();
    $fine_0(logger_0, 'Building structured configuration editor...');
    structuredConfigLayout = $buildStructuredPane(this$static);
    $addMember(this$static, structuredConfigLayout);
  }
   else {
    label = new Label_4('Structured configuration is not supported.');
    $addMember(this$static, label);
  }
  $markForRedraw(this$static);
}

function $removePropertyFromDynamicMap(propertySimple){
  var parentMap;
  parentMap = propertySimple.parentMap;
  (!parentMap.map && (parentMap.map = new LinkedHashMap_0) , parentMap.map).remove_3(propertySimple.name_0);
}

function $reset_2(this$static){
  this$static.configuration = this$static.originalConfiguration;
  this$static.originalConfiguration = null;
  $reload(this$static);
}

function $setEditorTitle(this$static, title){
  this$static.editorTitle = title;
}

function $setLoadHandler(this$static, handler){
  this$static.loadHandler = handler;
}

function $setReadOnly_1(this$static, readOnly){
  this$static.readOnly = readOnly;
}

function $setValueAsTooltipIfAppropriate(formItem, value){
  (instanceOf(formItem, Q$TextItem) && !instanceOf(formItem, Q$PasswordItem) || instanceOf(formItem, Q$TextAreaItem)) && formItem.setPrompt(value);
}

function $shouldFireEventOnPropertyValueChange(propertySimple){
  var parentMap;
  parentMap = propertySimple.parentMap;
  return !!propertySimple.configuration || !!parentMap && !!parentMap.configuration;
}

function $updatePropertySimpleValue(formItem, value, propertySimple){
  var stringValue;
  propertySimple.errorMessage_0 = null;
  $setValue_12(propertySimple, value);
  stringValue = value != null?toString__devirtual$(value):null;
  (instanceOf(formItem, Q$TextItem) && !instanceOf(formItem, Q$PasswordItem) || instanceOf(formItem, Q$TextAreaItem)) && formItem.setPrompt(stringValue);
}

function ConfigurationEditor_0(resourceId, resourceTypeId, configType){
  $clinit_ConfigurationEditor();
  EnhancedVLayout_0.call(this);
  $$init_17(this);
  this.resourceId = resourceId;
  this.resourceTypeId = resourceTypeId;
  this.configType = configType;
}

function ConfigurationEditor_1(configurationDefinition, configuration){
  $clinit_ConfigurationEditor();
  EnhancedVLayout_0.call(this);
  $$init_17(this);
  if (!configuration) {
    throw new IllegalArgumentException_1('Null configuration.');
  }
  if (!configurationDefinition) {
    throw new IllegalArgumentException_1('Null configurationDefinition.');
  }
  this.configuration = configuration;
  this.configurationDefinition = configurationDefinition;
}

function buildValueMap(propertyList){
  $clinit_ConfigurationEditor();
  var index, iterator, memberProperties, memberProperty, memberPropertySimple, memberValue, memberValueToIndexMap;
  memberValueToIndexMap = new LinkedHashMap_0;
  memberProperties = (!propertyList.list && (propertyList.list = new ArrayList_0) , propertyList.list);
  index = 0;
  for (iterator = memberProperties.iterator(); iterator.hasNext();) {
    memberProperty = dynamicCast(iterator.next_0(), Q$Property);
    memberPropertySimple = dynamicCast(memberProperty, Q$PropertySimple);
    memberValue = memberPropertySimple.stringValue;
    if (memberValue == null) {
      $clinit_Log();
      $severe_0(logger_0, 'List ' + propertyList + ' contains property with null value - removing and skipping...');
      iterator.remove_2();
      continue;
    }
    $put_1(memberValueToIndexMap, '' + index++, memberValue);
  }
  return memberValueToIndexMap;
}

function getTopLevelProperty(property){
  var currentProperty;
  currentProperty = property;
  while (!currentProperty.configuration) {
    if (currentProperty.parentList) {
      currentProperty = currentProperty.parentList;
    }
     else if (currentProperty.parentMap) {
      currentProperty = currentProperty.parentMap;
    }
     else {
      $clinit_Log();
      $severe_0(logger_0, 'Property ' + currentProperty + ' has no parent.');
      break;
    }
  }
  return currentProperty;
}

function getTopLevelPropertyDefinition(propertyDefinition){
  var currentPropertyDefinition;
  currentPropertyDefinition = propertyDefinition;
  while (!currentPropertyDefinition.configurationDefinition) {
    if (currentPropertyDefinition.parentPropertyListDefinition) {
      currentPropertyDefinition = currentPropertyDefinition.parentPropertyListDefinition;
    }
     else if (currentPropertyDefinition.parentPropertyMapDefinition) {
      currentPropertyDefinition = currentPropertyDefinition.parentPropertyMapDefinition;
    }
     else {
      $clinit_Log();
      $severe_0(logger_0, 'Property definition ' + currentPropertyDefinition + ' has no parent.');
      break;
    }
  }
  return currentPropertyDefinition;
}

function isAllReadOnly(propertyDefinitions){
  var allPropsDefsReadOnly, subDef, subDef$iterator;
  allPropsDefsReadOnly = true;
  for (subDef$iterator = new AbstractList$IteratorImpl_0(propertyDefinitions); subDef$iterator.i < subDef$iterator.this$0_0.size_1();) {
    subDef = dynamicCast($next_0(subDef$iterator), Q$PropertyDefinition);
    if (!subDef.readOnly) {
      debug('Found at least one non-readOnly property for: ' + subDef.name_0);
      allPropsDefsReadOnly = false;
      break;
    }
  }
  return allPropsDefsReadOnly;
}

function setValue_23(item, value){
  $clinit_ConfigurationEditor();
  value != null?item.setValue_4(value):item.setValue_4(null);
  item.setDefaultValue_0(null);
}

defineSeed(2226, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$ConfigurationEditor, Q$Enhanced]), ConfigurationEditor_0, ConfigurationEditor_1);
_.addPropertyToDynamicMap = function addPropertyToDynamicMap(memberPropertySimple, propertyMap){
  $setOverride(memberPropertySimple, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  (!propertyMap.map && (propertyMap.map = new LinkedHashMap_0) , propertyMap.map).put(memberPropertySimple.name_0, memberPropertySimple);
  memberPropertySimple.parentMap = propertyMap;
}
;
_.buildFieldsForPropertyList = function buildFieldsForPropertyList(propertyDefinition, oddRow, propertyDefinitionList, memberDefinition, propertyList){
  var canvas, canvasItem, descriptionItem, fields, listOfMapsItem, listOfSimplesItem, memberDefinitionMap, nameItem, spacerItem;
  fields = new ArrayList_0;
  nameItem = $buildNameItem(propertyDefinition);
  setCheck(fields.array, fields.size_0++, nameItem);
  if (instanceOf(memberDefinition, Q$PropertyDefinitionMap)) {
    $setPrompt_1(nameItem, propertyDefinition.description);
    memberDefinitionMap = dynamicCast(memberDefinition, Q$PropertyDefinitionMap);
    listOfMapsItem = $buildListOfMapsField(this, memberDefinitionMap, propertyDefinitionList, propertyList);
    setCheck(fields.array, fields.size_0++, listOfMapsItem);
  }
   else if (instanceOf(memberDefinition, Q$PropertyDefinitionSimple)) {
    spacerItem = new SpacerItem_0;
    setCheck(fields.array, fields.size_0++, spacerItem);
    listOfSimplesItem = $buildListOfSimplesField(this, propertyDefinitionList, propertyList);
    setCheck(fields.array, fields.size_0++, listOfSimplesItem);
    descriptionItem = $buildDescriptionField(propertyDefinition);
    setCheck(fields.array, fields.size_0++, descriptionItem);
  }
   else {
    $clinit_Log();
    $severe_0(logger_0, 'List ' + propertyList + ' has unsupported member type: ' + memberDefinition);
    canvas = new Canvas_1;
    canvasItem = $buildComplexPropertyField(canvas);
    $isCreated_2(canvasItem)?$setProperty_6(canvasItem, 'colSpan', 3):(canvasItem.jsObj['colSpan'] = 3 , undefined);
    canvasItem.setEndRow(($clinit_Boolean() , $clinit_Boolean() , TRUE));
    setCheck(fields.array, fields.size_0++, canvasItem);
  }
  return fields;
}
;
_.buildFieldsForPropertySimple = function buildFieldsForPropertySimple(propertyDefinition, propertyDefinitionSimple, propertySimple){
  return $buildFieldsForPropertySimple(this, propertyDefinition, propertyDefinitionSimple, propertySimple);
}
;
_.buildSimpleField = function buildSimpleField(propertyDefinitionSimple, propertySimple){
  return $buildSimpleField(this, propertyDefinitionSimple, propertySimple);
}
;
_.buildUnsetItem = function buildUnsetItem(propertyDefinitionSimple, propertySimple, valueItem){
  return $buildUnsetItem(this, propertyDefinitionSimple, propertySimple, valueItem);
}
;
_.onDraw_0 = function onDraw_18(){
  var start;
  $addMember(this, this.loadingLabel);
  $redraw(this);
  start = fromDouble(currentTimeMillis0());
  (!this.configurationDefinition || !this.configuration) && (this.configType == ($clinit_ConfigurationEditor$ConfigType() , resource_0)?($getResourceConfiguration(this.configurationService, this.resourceId, new ConfigurationEditor$3_0(this, start)) , $getResourceTypes_0(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.resourceTypeId)]), of(($clinit_ResourceTypeRepository$MetadataType() , resourceConfigurationDefinition_0)), new ConfigurationEditor$4_0(this, start))):this.configType == plugin_0 && ($getPluginConfiguration(this.configurationService, this.resourceId, new ConfigurationEditor$1_0(this)) , $getResourceTypes_0(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.resourceTypeId)]), of(($clinit_ResourceTypeRepository$MetadataType() , pluginConfigurationDefinition_0)), new ConfigurationEditor$2_0(this, start))));
  $reload(this);
}
;
_.removePropertyFromDynamicMap = function removePropertyFromDynamicMap(propertySimple){
  $removePropertyFromDynamicMap(propertySimple);
}
;
_.shouldFireEventOnPropertyValueChange = function shouldFireEventOnPropertyValueChange(formItem, propertyDefinitionSimple, propertySimple){
  return $shouldFireEventOnPropertyValueChange(propertySimple);
}
;
_.updatePropertySimpleValue = function updatePropertySimpleValue(formItem, value, propertySimple, propertyDefinitionSimple){
  $updatePropertySimpleValue(formItem, value, propertySimple);
}
;
_.allPropertiesWritable = false;
_.blurUnsetItem = null;
_.blurValueItem = null;
_.configType = null;
_.configuration = null;
_.configurationDefinition = null;
_.editorTitle = null;
_.loadHandler = null;
_.originalConfiguration = null;
_.preserveTextFormatting = false;
_.readOnly = false;
_.resourceId = 0;
_.resourceTypeId = 0;
_.toolStrip = null;
var BOOLEAN_PROPERTY_ITEM_VALUE_MAP;
function $onSuccess_179(this$static, result){
  this$static.this$0.configuration = result;
  $reload(this$static.this$0);
  !!this$static.this$0.loadHandler && (this$static.this$0.loadHandler.this$0.refreshingConfigDef = false);
}

function ConfigurationEditor$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2227, 1, {}, ConfigurationEditor$1_0);
_.onFailure = function onFailure_189(caught){
  $addMember(this.this$0, new Label_4(caught.getMessage()));
  !!this.this$0.loadHandler && (this.this$0.loadHandler.this$0.refreshingConfigDef = false);
}
;
_.onSuccess_0 = function onSuccess_189(result){
  $onSuccess_179(this, dynamicCast(result, Q$Configuration));
}
;
_.this$0 = null;
function ConfigurationEditor$10_0(this$0, val$summaryTable, val$propertyDefinitionList, val$propertyList, val$memberPropertyDefinitionMap, val$mapReadOnly){
  this.this$0 = this$0;
  this.val$summaryTable = val$summaryTable;
  this.val$propertyDefinitionList = val$propertyDefinitionList;
  this.val$propertyList = val$propertyList;
  this.val$memberPropertyDefinitionMap = val$memberPropertyDefinitionMap;
  this.val$mapReadOnly = val$mapReadOnly;
}

defineSeed(2228, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), ConfigurationEditor$10_0);
_.onRecordClick = function onRecordClick_4(recordClickEvent){
  var memberPropertyMap, record;
  record = dynamicCast($getRecord_0(recordClickEvent), Q$PropertyMapListGridRecord);
  memberPropertyMap = record.propertyMap;
  $clinit_Log();
  $fine_0(logger_0, 'Editing property map: ' + memberPropertyMap);
  $displayMapEditor(this.this$0, this.val$summaryTable, record, this.val$propertyDefinitionList, this.val$propertyList, this.val$memberPropertyDefinitionMap, memberPropertyMap, this.val$mapReadOnly);
}
;
_.this$0 = null;
_.val$mapReadOnly = false;
_.val$memberPropertyDefinitionMap = null;
_.val$propertyDefinitionList = null;
_.val$propertyList = null;
_.val$summaryTable = null;
function ConfigurationEditor$11_0(this$0, val$summaryTable, val$propertyDefinitionList, val$propertyList, val$propertyDefinitions){
  this.this$0 = this$0;
  this.val$summaryTable = val$summaryTable;
  this.val$propertyDefinitionList = val$propertyDefinitionList;
  this.val$propertyList = val$propertyList;
  this.val$propertyDefinitions = val$propertyDefinitions;
}

defineSeed(2229, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), ConfigurationEditor$11_0);
_.onRecordClick = function onRecordClick_5(recordClickEvent){
  var jsObj;
  debug('You want to delete: ' + (jsObj = recordClickEvent.jsObj , jsObj.recordNum));
  confirm_0(($clinit_Enhanced() , 'Are you sure you want to delete this row?'), new ConfigurationEditor$11$1_0(this, this.val$summaryTable, this.val$propertyDefinitionList, recordClickEvent, this.val$propertyList, this.val$propertyDefinitions));
}
;
_.this$0 = null;
_.val$propertyDefinitionList = null;
_.val$propertyDefinitions = null;
_.val$propertyList = null;
_.val$summaryTable = null;
function ConfigurationEditor$11$1_0(this$1, val$summaryTable, val$propertyDefinitionList, val$recordClickEvent, val$propertyList, val$propertyDefinitions){
  this.this$1 = this$1;
  this.val$summaryTable = val$summaryTable;
  this.val$propertyDefinitionList = val$propertyDefinitionList;
  this.val$recordClickEvent = val$recordClickEvent;
  this.val$propertyList = val$propertyList;
  this.val$propertyDefinitions = val$propertyDefinitions;
}

defineSeed(2230, 1, {}, ConfigurationEditor$11$1_0);
_.execute_3 = function execute_33(confirmed){
  var recordToBeDeleted, rows;
  if (confirmed.value_0) {
    if ($getRecordList(this.val$summaryTable).getLength_0() <= this.val$propertyDefinitionList.min_0) {
      say('Cannot delete this entry as the minimum has been set to: ' + ($clinit_Enhanced() , '' + this.val$propertyDefinitionList.min_0));
    }
     else {
      recordToBeDeleted = dynamicCast($getRecord_0(this.val$recordClickEvent), Q$PropertyMapListGridRecord);
      $getList_0(this.val$propertyList).remove_1(recordToBeDeleted.index_0);
      rows = $buildSummaryRecords(this.val$propertyList, this.val$propertyDefinitions);
      $setData(this.val$summaryTable, rows);
      $firePropertyChangedEvent(this.this$1.this$0, this.val$propertyDefinitionList, true);
    }
  }
}
;
_.this$1 = null;
_.val$propertyDefinitionList = null;
_.val$propertyDefinitions = null;
_.val$propertyList = null;
_.val$recordClickEvent = null;
_.val$summaryTable = null;
function ConfigurationEditor$12_0(this$0, val$summaryTable, val$propertyDefinitionList, val$propertyList, val$memberPropertyDefinitionMap, val$mapReadOnly){
  this.this$0 = this$0;
  this.val$summaryTable = val$summaryTable;
  this.val$propertyDefinitionList = val$propertyDefinitionList;
  this.val$propertyList = val$propertyList;
  this.val$memberPropertyDefinitionMap = val$memberPropertyDefinitionMap;
  this.val$mapReadOnly = val$mapReadOnly;
}

defineSeed(2231, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConfigurationEditor$12_0);
_.onClick = function onClick_57(clickEvent){
  $displayMapEditor(this.this$0, this.val$summaryTable, null, this.val$propertyDefinitionList, this.val$propertyList, this.val$memberPropertyDefinitionMap, null, this.val$mapReadOnly);
}
;
_.this$0 = null;
_.val$mapReadOnly = false;
_.val$memberPropertyDefinitionMap = null;
_.val$propertyDefinitionList = null;
_.val$propertyList = null;
_.val$summaryTable = null;
function ConfigurationEditor$13_0(this$0, val$membersItem, val$propertyList, val$propertyDefinitionList, val$deleteButton){
  this.this$0 = this$0;
  this.val$membersItem = val$membersItem;
  this.val$propertyList = val$propertyList;
  this.val$propertyDefinitionList = val$propertyDefinitionList;
  this.val$deleteButton = val$deleteButton;
}

defineSeed(2232, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConfigurationEditor$13_0);
_.onClick = function onClick_58(clickEvent){
  var message, noun, selectedValues;
  selectedValues = $getValues(this.val$membersItem);
  noun = selectedValues.length == 1?($clinit_Enhanced() , 'item'):($clinit_Enhanced() , 'items');
  message = 'Are you sure you want to delete the [' + ($clinit_Enhanced() , '' + selectedValues.length) + ']  selected [' + noun + ']?';
  $getList_0(this.val$propertyList).size_1() <= this.val$propertyDefinitionList.min_0?say('You cannot delete this entry because the minimum size bounds has been met: ' + this.val$propertyDefinitionList.min_0):ask(message, new ConfigurationEditor$13$1_0(this, selectedValues, this.val$propertyList, this.val$membersItem, this.val$deleteButton, this.val$propertyDefinitionList, noun));
}
;
_.this$0 = null;
_.val$deleteButton = null;
_.val$membersItem = null;
_.val$propertyDefinitionList = null;
_.val$propertyList = null;
function ConfigurationEditor$13$1_0(this$1, val$selectedValues, val$propertyList, val$membersItem, val$deleteButton, val$propertyDefinitionList, val$noun){
  this.this$1 = this$1;
  this.val$selectedValues = val$selectedValues;
  this.val$propertyList = val$propertyList;
  this.val$membersItem = val$membersItem;
  this.val$deleteButton = val$deleteButton;
  this.val$propertyDefinitionList = val$propertyDefinitionList;
  this.val$noun = val$noun;
}

defineSeed(2233, 1, {}, ConfigurationEditor$13$1_0);
_.execute_3 = function execute_34(confirmed){
  var i, index, memberValueToIndexMap, selectedValue;
  if (confirmed.value_0) {
    for (i = this.val$selectedValues.length - 1; i >= 0; --i) {
      selectedValue = this.val$selectedValues[i];
      index = valueOf_44(__parseAndValidateInt(selectedValue)).value_0;
      $getList_0(this.val$propertyList).remove_1(index);
      memberValueToIndexMap = buildValueMap(this.val$propertyList);
      this.val$membersItem.setValueMap_0(memberValueToIndexMap);
      $disable(this.val$deleteButton);
      $firePropertyChangedEvent(this.this$1.this$0, this.val$propertyDefinitionList, true);
      $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_6('[' + ($clinit_Enhanced() , '' + this.val$selectedValues.length) + ' ' + this.val$noun + '] deleted from list.', of(($clinit_Message$Option() , Transient))));
    }
  }
}
;
_.this$1 = null;
_.val$deleteButton = null;
_.val$membersItem = null;
_.val$noun = null;
_.val$propertyDefinitionList = null;
_.val$propertyList = null;
_.val$selectedValues = null;
function ConfigurationEditor$14_0(val$membersItem, val$deleteButton){
  this.val$membersItem = val$membersItem;
  this.val$deleteButton = val$deleteButton;
}

defineSeed(2234, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ConfigurationEditor$14_0);
_.onChanged = function onChanged_31(changedEvent){
  var count, selectedValues;
  selectedValues = $getValues(this.val$membersItem);
  count = selectedValues.length;
  $setDisabled(this.val$deleteButton, count < 1);
}
;
_.val$deleteButton = null;
_.val$membersItem = null;
function ConfigurationEditor$15_0(this$0, val$propertyList, val$propertyDefinitionList, val$membersItem){
  this.this$0 = this$0;
  this.val$propertyList = val$propertyList;
  this.val$propertyDefinitionList = val$propertyDefinitionList;
  this.val$membersItem = val$membersItem;
}

defineSeed(2235, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConfigurationEditor$15_0);
_.onClick = function onClick_59(clickEvent){
  var buttonBar, cancelButton, description, form, memberPropertyDefinitionSimple, newMemberPropertySimple, okButton, popup, propertyName, simpleField, spacer, vLayout;
  if ($getList_0(this.val$propertyList).size_1() >= this.val$propertyDefinitionList.max_0) {
    say('Cannot add another entry because the maximum size bounds has been met: ' + ($clinit_Enhanced() , '' + this.val$propertyDefinitionList.max_0));
  }
   else {
    popup = $createPopup(($clinit_Enhanced() , 'Add Item to List'), 300, 145);
    vLayout = new VLayout_0;
    $setMargin(vLayout, valueOf_44(10));
    description = new HTMLFlow_1(this.val$propertyDefinitionList.description);
    vLayout.addMember_0(description);
    form = new DynamicForm_0;
    memberPropertyDefinitionSimple = dynamicCast(this.val$propertyDefinitionList.memberDefinition, Q$PropertyDefinitionSimple);
    propertyName = memberPropertyDefinitionSimple.name_0;
    newMemberPropertySimple = new PropertySimple_1(propertyName, null);
    simpleField = this.this$0.buildSimpleField(memberPropertyDefinitionSimple, newMemberPropertySimple);
    simpleField.setTitle(memberPropertyDefinitionSimple.displayName);
    simpleField.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $setAttribute_30(simpleField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
    $setDisabled_2(simpleField, FALSE);
    $setRequired(simpleField, TRUE);
    simpleField.setEndRow(TRUE);
    spacer = new SpacerItem_0;
    $isCreated_2(spacer)?$setProperty_6(spacer, 'height', 9):(spacer.jsObj['height'] = 9 , undefined);
    form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [simpleField, spacer]));
    vLayout.addMember_0(form);
    okButton = new EnhancedIButton_1('OK');
    $disable(okButton);
    $addClickHandler(okButton, new ConfigurationEditor$15$1_0(this, this.val$propertyList, newMemberPropertySimple, this.val$membersItem, this.val$propertyDefinitionList, popup));
    $addItemChangedHandler(form, new ConfigurationEditor$15$2_0(newMemberPropertySimple, form, okButton));
    cancelButton = new EnhancedIButton_1('Cancel');
    $addClickHandler(cancelButton, new ConfigurationEditor$15$3_0(popup));
    buttonBar = new ToolStrip_0;
    $setPadding(buttonBar, valueOf_44(5));
    $isCreated_1(buttonBar)?$setProperty_3(buttonBar, 'width', '100%'):(buttonBar.config_0['width'] = '100%' , undefined);
    $isCreated_1(buttonBar)?$setProperty_0(buttonBar, 'membersMargin', 15):(buttonBar.config_0['membersMargin'] = 15 , undefined);
    $setAttribute_24(buttonBar, 'align', CENTER_0.value_0, true);
    $setMembers(buttonBar, initValues(_3Lcom_smartgwt_client_widgets_Canvas_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Canvas, [okButton, cancelButton]));
    vLayout.addMember_0(buttonBar);
    $addItem(popup, vLayout);
    popup.show_0();
    $focusInItem(simpleField);
  }
}
;
_.this$0 = null;
_.val$membersItem = null;
_.val$propertyDefinitionList = null;
_.val$propertyList = null;
function ConfigurationEditor$15$1_0(this$1, val$propertyList, val$newMemberPropertySimple, val$membersItem, val$propertyDefinitionList, val$popup){
  this.this$1 = this$1;
  this.val$propertyList = val$propertyList;
  this.val$newMemberPropertySimple = val$newMemberPropertySimple;
  this.val$membersItem = val$membersItem;
  this.val$propertyDefinitionList = val$propertyDefinitionList;
  this.val$popup = val$popup;
}

defineSeed(2236, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConfigurationEditor$15$1_0);
_.onClick = function onClick_60(clickEvent){
  var memberValueToIndexMap;
  $add_10(this.val$propertyList, this.val$newMemberPropertySimple);
  memberValueToIndexMap = buildValueMap(this.val$propertyList);
  this.val$membersItem.setValueMap_0(memberValueToIndexMap);
  $firePropertyChangedEvent(this.this$1.this$0, this.val$propertyDefinitionList, true);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_6(($clinit_Enhanced() , 'Item added to list.'), of(($clinit_Message$Option() , Transient))));
  $destroy(this.val$popup);
}
;
_.this$1 = null;
_.val$membersItem = null;
_.val$newMemberPropertySimple = null;
_.val$popup = null;
_.val$propertyDefinitionList = null;
_.val$propertyList = null;
function ConfigurationEditor$15$2_0(val$newMemberPropertySimple, val$form, val$okButton){
  this.val$newMemberPropertySimple = val$newMemberPropertySimple;
  this.val$form = val$form;
  this.val$okButton = val$okButton;
}

defineSeed(2237, 1, makeCastMap([Q$EventHandler, Q$ItemChangedHandler]), ConfigurationEditor$15$2_0);
_.onItemChanged = function onItemChanged(itemChangedEvent){
  var isValid, newValue, jsObj;
  newValue = (jsObj = itemChangedEvent.jsObj , $wnd.SmartGWT.convertToJavaType(jsObj.newValue));
  $setValue_12(this.val$newMemberPropertySimple, newValue);
  isValid = this.val$form.validate_0();
  $setDisabled(this.val$okButton, !isValid);
}
;
_.val$form = null;
_.val$newMemberPropertySimple = null;
_.val$okButton = null;
function ConfigurationEditor$15$3_0(val$popup){
  this.val$popup = val$popup;
}

defineSeed(2238, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConfigurationEditor$15$3_0);
_.onClick = function onClick_61(clickEvent){
  $destroy(this.val$popup);
}
;
_.val$popup = null;
function ConfigurationEditor$16_0(this$0, val$propertySimple, val$propertyDefinitionSimple){
  this.this$0 = this$0;
  this.val$propertySimple = val$propertySimple;
  this.val$propertyDefinitionSimple = val$propertyDefinitionSimple;
}

defineSeed(2239, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ConfigurationEditor$16_0);
_.onChanged = function onChanged_32(changedEvent){
  var isValid;
  this.this$0.updatePropertySimpleValue($getItem_0(changedEvent), $getValue_2(changedEvent), this.val$propertySimple, this.val$propertyDefinitionSimple);
  if (this.this$0.shouldFireEventOnPropertyValueChange($getItem_0(changedEvent), this.val$propertyDefinitionSimple, this.val$propertySimple)) {
    isValid = $getItem_0(changedEvent).validate_1().value_0;
    $firePropertyChangedEvent(this.this$0, this.val$propertyDefinitionSimple, isValid);
  }
}
;
_.this$0 = null;
_.val$propertyDefinitionSimple = null;
_.val$propertySimple = null;
function ConfigurationEditor$17_0(this$0, val$propertySimple, val$propertyDefinitionSimple){
  this.this$0 = this$0;
  this.val$propertySimple = val$propertySimple;
  this.val$propertyDefinitionSimple = val$propertyDefinitionSimple;
}

defineSeed(2240, 1, makeCastMap([Q$EventHandler, Q$BlurHandler]), ConfigurationEditor$17_0);
_.onBlur = function onBlur(event_0){
  var isValid;
  this.this$0.updatePropertySimpleValue($getItem(event_0), $getItem(event_0).getValue_1(), this.val$propertySimple, this.val$propertyDefinitionSimple);
  if (this.this$0.shouldFireEventOnPropertyValueChange($getItem(event_0), this.val$propertyDefinitionSimple, this.val$propertySimple)) {
    isValid = $getItem(event_0).validate_1().value_0;
    $firePropertyChangedEvent(this.this$0, this.val$propertyDefinitionSimple, isValid);
  }
}
;
_.this$0 = null;
_.val$propertyDefinitionSimple = null;
_.val$propertySimple = null;
function ConfigurationEditor$18_0(this$0, val$valueItem, val$unsetItem, val$propertySimple, val$propertyDefinitionSimple){
  this.this$0 = this$0;
  this.val$valueItem = val$valueItem;
  this.val$unsetItem = val$unsetItem;
  this.val$propertySimple = val$propertySimple;
  this.val$propertyDefinitionSimple = val$propertyDefinitionSimple;
}

defineSeed(2241, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ConfigurationEditor$18_0);
_.onChanged = function onChanged_33(changeEvent){
  var defaultValue, isUnset, isValid;
  $handleFocusChange(this.this$0, this.val$valueItem, this.val$unsetItem);
  isUnset = dynamicCast($getValue_2(changeEvent), Q$Boolean);
  isUnset != $isDisabled_0(this.val$valueItem) && $setDisabled_2(this.val$valueItem, isUnset);
  if (isUnset.value_0) {
    if (this.val$valueItem.getValue_1() != null) {
      setValue_23(this.val$valueItem, null);
      this.this$0.updatePropertySimpleValue(this.val$unsetItem, null, this.val$propertySimple, this.val$propertyDefinitionSimple);
      $firePropertyChangedEvent(this.this$0, this.val$propertyDefinitionSimple, true);
    }
  }
   else {
    defaultValue = this.val$propertyDefinitionSimple.defaultValue;
    if (defaultValue != null) {
      setValue_23(this.val$valueItem, defaultValue);
      this.this$0.updatePropertySimpleValue(this.val$unsetItem, defaultValue, this.val$propertySimple, this.val$propertyDefinitionSimple);
      isValid = this.val$valueItem.validate_1().value_0;
      $firePropertyChangedEvent(this.this$0, this.val$propertyDefinitionSimple, isValid);
    }
    $focusInItem(this.val$valueItem);
  }
  $redraw_0(this.val$valueItem);
}
;
_.this$0 = null;
_.val$propertyDefinitionSimple = null;
_.val$propertySimple = null;
_.val$unsetItem = null;
_.val$valueItem = null;
function ConfigurationEditor$19_0(val$unsetItem){
  this.val$unsetItem = val$unsetItem;
}

defineSeed(2242, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ConfigurationEditor$19_0);
_.onChanged = function onChanged_34(changedEvent){
  var isUnset, value;
  value = $getValue_2(changedEvent);
  isUnset = value == null;
  $setValue_9(this.val$unsetItem, isUnset);
}
;
_.val$unsetItem = null;
function ConfigurationEditor$2_0(this$0, val$start){
  this.this$0 = this$0;
  this.val$start = val$start;
}

defineSeed(2243, 1, {}, ConfigurationEditor$2_0);
_.onTypesLoaded_0 = function onTypesLoaded_7(types){
  debug('ConfigDef retrieved in: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this.val$start)));
  this.this$0.configurationDefinition = dynamicCast(types.get_2(valueOf_44(this.this$0.resourceTypeId)), Q$ResourceType).pluginConfigurationDefinition;
  !this.this$0.configurationDefinition && $addMember(this.this$0, new Label_4(($clinit_Enhanced() , 'Connection settings are not supported by this Resource.')));
  $reload(this.this$0);
  !!this.this$0.loadHandler && (this.this$0.loadHandler.this$0.refreshingConfig = false);
}
;
_.this$0 = null;
_.val$start = P0_longLit;
function ConfigurationEditor$20_0(this$0, val$valueItem, val$unsetItem){
  this.this$0 = this$0;
  this.val$valueItem = val$valueItem;
  this.val$unsetItem = val$unsetItem;
}

defineSeed(2244, 1, makeCastMap([Q$EventHandler, Q$FocusHandler]), ConfigurationEditor$20_0);
_.this$0 = null;
_.val$unsetItem = null;
_.val$valueItem = null;
function ConfigurationEditor$21_0(this$0, val$mapReadOnly, val$childForm, val$okButton, val$newRow, val$propertyList, val$workingMap, val$memberDefinitions, val$summaryTable, val$memberMap, val$existingRecord, val$propertyDefinitionList, val$layout, val$popup){
  this.this$0 = this$0;
  this.val$mapReadOnly = val$mapReadOnly;
  this.val$childForm = val$childForm;
  this.val$okButton = val$okButton;
  this.val$newRow = val$newRow;
  this.val$propertyList = val$propertyList;
  this.val$workingMap = val$workingMap;
  this.val$memberDefinitions = val$memberDefinitions;
  this.val$summaryTable = val$summaryTable;
  this.val$memberMap = val$memberMap;
  this.val$existingRecord = val$existingRecord;
  this.val$propertyDefinitionList = val$propertyDefinitionList;
  this.val$layout = val$layout;
  this.val$popup = val$popup;
}

defineSeed(2245, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConfigurationEditor$21_0);
_.onClick = function onClick_62(clickEvent){
  var index, record;
  if (!this.val$mapReadOnly) {
    if (!this.val$childForm.validate_0()) {
      $disable(this.val$okButton);
      return;
    }
    if (this.val$newRow) {
      $add_10(this.val$propertyList, this.val$workingMap);
      index = $getList_0(this.val$propertyList).size_1() - 1;
      record = new PropertyMapListGridRecord_0(this.val$workingMap, index, this.val$memberDefinitions);
      $addData_0(this.val$summaryTable, record);
    }
     else {
      $mergePropertyMap(this.val$workingMap, this.val$memberMap, this.val$memberDefinitions);
      $refresh_3(this.val$existingRecord);
      $updateData(this.val$summaryTable, this.val$existingRecord);
    }
    $firePropertyChangedEvent(this.this$0, this.val$propertyDefinitionList, true);
    $redraw(this.val$summaryTable);
  }
  this.this$0.blurUnsetItem = null;
  this.this$0.blurValueItem = null;
  this.val$layout.destroy_0();
  $destroy(this.val$popup);
}
;
_.this$0 = null;
_.val$childForm = null;
_.val$existingRecord = null;
_.val$layout = null;
_.val$mapReadOnly = false;
_.val$memberDefinitions = null;
_.val$memberMap = null;
_.val$newRow = false;
_.val$okButton = null;
_.val$popup = null;
_.val$propertyDefinitionList = null;
_.val$propertyList = null;
_.val$summaryTable = null;
_.val$workingMap = null;
function ConfigurationEditor$22_0(val$okButton){
  this.val$okButton = val$okButton;
}

defineSeed(2246, 1, makeCastMap([Q$EventHandler, Q$ItemChangedHandler]), ConfigurationEditor$22_0);
_.onItemChanged = function onItemChanged_0(itemChangedEvent){
  $setDisabled(this.val$okButton, false);
}
;
_.val$okButton = null;
function ConfigurationEditor$23_0(val$layout, val$popup){
  this.val$layout = val$layout;
  this.val$popup = val$popup;
}

defineSeed(2247, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConfigurationEditor$23_0);
_.onClick = function onClick_63(clickEvent){
  this.val$layout.destroy_0();
  $destroy(this.val$popup);
}
;
_.val$layout = null;
_.val$popup = null;
function $onSuccess_180(this$static, result){
  this$static.this$0.configuration = result;
  info_0('Config retrieved in: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this$static.val$start)));
  $reload(this$static.this$0);
  !!this$static.this$0.loadHandler && (this$static.this$0.loadHandler.this$0.refreshingConfigDef = false);
}

function ConfigurationEditor$3_0(this$0, val$start){
  this.this$0 = this$0;
  this.val$start = val$start;
}

defineSeed(2248, 1, {}, ConfigurationEditor$3_0);
_.onFailure = function onFailure_190(caught){
  $addMember(this.this$0, new Label_4(caught.getMessage()));
  !!this.this$0.loadHandler && (this.this$0.loadHandler.this$0.refreshingConfigDef = false);
}
;
_.onSuccess_0 = function onSuccess_190(result){
  $onSuccess_180(this, dynamicCast(result, Q$Configuration));
}
;
_.this$0 = null;
_.val$start = P0_longLit;
function ConfigurationEditor$4_0(this$0, val$start){
  this.this$0 = this$0;
  this.val$start = val$start;
}

defineSeed(2249, 1, {}, ConfigurationEditor$4_0);
_.onTypesLoaded_0 = function onTypesLoaded_8(types){
  debug('ConfigDef retrieved in: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this.val$start)));
  this.this$0.configurationDefinition = dynamicCast(types.get_2(valueOf_44(this.this$0.resourceTypeId)), Q$ResourceType).resourceConfigurationDefinition;
  if (!this.this$0.configurationDefinition) {
    $hide(this.this$0.loadingLabel);
    $addMember(this.this$0, new Label_4(($clinit_Enhanced() , 'Configuration is not supported by this Resource.')));
  }
  $reload(this.this$0);
  !!this.this$0.loadHandler && (this.this$0.loadHandler.this$0.refreshingConfig = false);
}
;
_.this$0 = null;
_.val$start = P0_longLit;
function ConfigurationEditor$5_0(val$sectionStack){
  this.val$sectionStack = val$sectionStack;
}

defineSeed(2250, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ConfigurationEditor$5_0);
_.onClick_1 = function onClick_64(event_0){
  var index, jsObj;
  index = $getItemNum((jsObj = event_0.jsObj , getOrCreateRef_10(jsObj.menu)), $getItem_2(event_0));
  $expandSection(this.val$sectionStack, index);
  $showSection(this.val$sectionStack, index);
}
;
_.val$sectionStack = null;
function ConfigurationEditor$6_0(val$sectionStack){
  this.val$sectionStack = val$sectionStack;
}

defineSeed(2251, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ConfigurationEditor$6_0);
_.onClick_1 = function onClick_65(event_0){
  var i;
  for (i = 0; i < $getSections(this.val$sectionStack).length; ++i) {
    $collapseSection(this.val$sectionStack, i);
  }
}
;
_.val$sectionStack = null;
function ConfigurationEditor$7_0(this$0, val$propertyMap, val$propertyDefinitionMapFinal){
  this.this$0 = this$0;
  this.val$propertyMap = val$propertyMap;
  this.val$propertyDefinitionMapFinal = val$propertyDefinitionMapFinal;
}

defineSeed(2252, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConfigurationEditor$7_0);
_.onClick = function onClick_66(clickEvent){
  askforValue(($clinit_Enhanced() , 'Enter the name of the property to be added.'), new ConfigurationEditor$7$1_0(this, this.val$propertyMap, this.val$propertyDefinitionMapFinal));
}
;
_.this$0 = null;
_.val$propertyDefinitionMapFinal = null;
_.val$propertyMap = null;
function ConfigurationEditor$7$1_0(this$1, val$propertyMap, val$propertyDefinitionMapFinal){
  this.this$1 = this$1;
  this.val$propertyMap = val$propertyMap;
  this.val$propertyDefinitionMapFinal = val$propertyDefinitionMapFinal;
}

defineSeed(2253, 1, {}, ConfigurationEditor$7$1_0);
_.execute_4 = function execute_35(propertyName){
  var memberPropertySimple;
  if ($get_7(this.val$propertyMap, propertyName)) {
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_8('Cannot add property named [' + ($clinit_Enhanced() , propertyName) + ']. The property name is already used in the set.', ($clinit_Message$Severity() , Error_2), of(($clinit_Message$Option() , Transient))));
  }
   else {
    memberPropertySimple = new PropertySimple_1(propertyName, null);
    this.this$1.this$0.addPropertyToDynamicMap(memberPropertySimple, this.val$propertyMap);
    $firePropertyChangedEvent(this.this$1.this$0, this.val$propertyDefinitionMapFinal, true);
    $reload(this.this$1.this$0);
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_6('Added property [' + ($clinit_Enhanced() , propertyName) + '] to the set.', of(($clinit_Message$Option() , Transient))));
  }
}
;
_.this$1 = null;
_.val$propertyDefinitionMapFinal = null;
_.val$propertyMap = null;
function ConfigurationEditor$8_0(this$0, val$selectItem, val$propertyMap, val$propertyDefinitionMapFinal){
  this.this$0 = this$0;
  this.val$selectItem = val$selectItem;
  this.val$propertyMap = val$propertyMap;
  this.val$propertyDefinitionMapFinal = val$propertyDefinitionMapFinal;
}

defineSeed(2254, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ConfigurationEditor$8_0);
_.onClick = function onClick_67(clickEvent){
  confirm_0(($clinit_Enhanced() , 'Are you sure you want to delete the selected properties from the set?'), new ConfigurationEditor$8$1_0(this, this.val$selectItem, this.val$propertyMap, this.val$propertyDefinitionMapFinal));
}
;
_.this$0 = null;
_.val$propertyDefinitionMapFinal = null;
_.val$propertyMap = null;
_.val$selectItem = null;
function ConfigurationEditor$8$1_0(this$1, val$selectItem, val$propertyMap, val$propertyDefinitionMapFinal){
  this.this$1 = this$1;
  this.val$selectItem = val$selectItem;
  this.val$propertyMap = val$propertyMap;
  this.val$propertyDefinitionMapFinal = val$propertyDefinitionMapFinal;
}

defineSeed(2255, 1, {}, ConfigurationEditor$8$1_0);
_.execute_3 = function execute_36(confirmed){
  var memberPropertyName, memberPropertyName$index, memberPropertyName$max, memberPropertyNames, memberPropertySimple, stringValue, value;
  if (confirmed.value_0) {
    value = $getValue_0(this.val$selectItem);
    if (value != null) {
      stringValue = toString__devirtual$(value);
      memberPropertyNames = $split(stringValue, ',', 0);
      for (memberPropertyName$index = 0 , memberPropertyName$max = memberPropertyNames.length; memberPropertyName$index < memberPropertyName$max; ++memberPropertyName$index) {
        memberPropertyName = memberPropertyNames[memberPropertyName$index];
        memberPropertySimple = $getSimple_0(this.val$propertyMap, memberPropertyName);
        this.this$1.this$0.removePropertyFromDynamicMap(memberPropertySimple);
        $firePropertyChangedEvent(this.this$1.this$0, this.val$propertyDefinitionMapFinal, true);
      }
    }
    $reload(this.this$1.this$0);
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_6(($clinit_Enhanced() , 'Removed properties from the set.'), of(($clinit_Message$Option() , Transient))));
  }
}
;
_.this$1 = null;
_.val$propertyDefinitionMapFinal = null;
_.val$propertyMap = null;
_.val$selectItem = null;
function ConfigurationEditor$9_0(val$okButton){
  this.val$okButton = val$okButton;
}

defineSeed(2256, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ConfigurationEditor$9_0);
_.onChanged = function onChanged_35(changedEvent){
  var memberPropertyNames, stringValue, value;
  value = $getValue_2(changedEvent);
  if (value != null) {
    stringValue = toString__devirtual$(value);
    memberPropertyNames = $split(stringValue, ',', 0);
    $setDisabled(this.val$okButton, memberPropertyNames.length == 0);
  }
}
;
_.val$okButton = null;
function $clinit_ConfigurationEditor$ConfigType(){
  $clinit_ConfigurationEditor$ConfigType = nullMethod;
  plugin_0 = new ConfigurationEditor$ConfigType_0('plugin', 0);
  resource_0 = new ConfigurationEditor$ConfigType_0('resource', 1);
  $VALUES_125 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$ConfigType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ConfigurationEditor$ConfigType, [plugin_0, resource_0]);
}

function ConfigurationEditor$ConfigType_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_134(name_0){
  $clinit_ConfigurationEditor$ConfigType();
  return valueOf(($clinit_ConfigurationEditor$ConfigType$Map() , $MAP_125), name_0);
}

function values_128(){
  $clinit_ConfigurationEditor$ConfigType();
  return $VALUES_125;
}

defineSeed(2257, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$ConfigurationEditor$ConfigType]), ConfigurationEditor$ConfigType_0);
var $VALUES_125, plugin_0, resource_0;
function $clinit_ConfigurationEditor$ConfigType$Map(){
  $clinit_ConfigurationEditor$ConfigType$Map = nullMethod;
  $MAP_125 = createValueOfMap(($clinit_ConfigurationEditor$ConfigType() , $VALUES_125));
}

var $MAP_125;
function ConfigurationEditor$PluginReportedErrorValidator_0(property){
  CustomValidator_0.call(this);
  this.property = property;
}

defineSeed(2259, 528, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), ConfigurationEditor$PluginReportedErrorValidator_0);
_.condition_1 = function condition_1(value){
  var errorMessage, valid;
  errorMessage = this.property.errorMessage_0;
  valid = errorMessage == null;
  valid || (this.jsObj['errorMessage'] = errorMessage , undefined);
  return valid;
}
;
_.property = null;
function $compare_7(o1, o2){
  return $compareTo_5(new Integer_0(o1.order), valueOf_44(o2.order));
}

function ConfigurationEditor$PropertyDefinitionComparator_0(){
}

defineSeed(2260, 1, makeCastMap([Q$Comparator]), ConfigurationEditor$PropertyDefinitionComparator_0);
_.compare = function compare_8(o1, o2){
  return $compare_7(dynamicCast(o1, Q$PropertyDefinition), dynamicCast(o2, Q$PropertyDefinition));
}
;
function $buildEditMemberValuesIcon(this$static, propertyDefinitionSimple, propertySimple, dynamicItem){
  var icon;
  icon = new FormItemIcon_0;
  icon.jsObj['src'] = '[SKIN]/actions/edit.png';
  icon.jsObj['name'] = 'Edit Member Values';
  $setAttribute_8(icon, 'neverDisable', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $addFormItemClickHandler(icon, new GroupConfigurationEditor$2_0(this$static, propertyDefinitionSimple, propertySimple, dynamicItem));
  return icon;
}

function $buildEditorFormItem(valueField, propDef){
  var editorItem, enumeratedValues, option, option$iterator, validators, valueOptions;
  editorItem = null;
  enumeratedValues = propDef.enumeratedValues;
  if (!!enumeratedValues && !enumeratedValues.isEmpty_0()) {
    valueOptions = new LinkedHashMap_0;
    for (option$iterator = enumeratedValues.iterator(); option$iterator.hasNext();) {
      option = dynamicCast(option$iterator.next_0(), Q$PropertyDefinitionEnumeration);
      $put_1(valueOptions, option.value_0, option.name_0);
    }
    if (propDef.allowCustomEnumeratedValue) {
      editorItem = new ComboBoxItem_0;
      $setAddUnknownValues(dynamicCast(editorItem, Q$ComboBoxItem), ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    }
     else {
      valueOptions.map.size_1() > 5?(editorItem = new SortedSelectItem_0):(editorItem = new SortedSelectItem_0);
    }
    editorItem.setValueMap_0(valueOptions);
  }
   else {
    switch (propDef.type_0.ordinal) {
      case 0:
      case 8:
      case 9:
        editorItem = new TextItem_0;
        break;
      case 1:
        editorItem = new TextAreaItem_0;
        break;
      case 2:
        editorItem = new PasswordItem_0;
        break;
      case 3:
        editorItem = new SelectItem_0;
        editorItem.setValueMap_0(BOOLEAN_PROPERTY_ITEM_VALUE_MAP);
        break;
      case 4:
      case 5:
        editorItem = new TextItem_0;
        break;
      case 6:
      case 7:
        editorItem = new TextItem_0;
    }
  }
  $isCreated_2(editorItem)?$setProperty_8(editorItem, 'name', 'memberValuesEditor-editor'):(editorItem.jsObj['name'] = 'memberValuesEditor-editor' , undefined);
  validators = $buildValidators(propDef, new PropertySimple_0);
  $setAttribute_17(valueField, 'validators', dynamicCast($toArray_1(validators, initDim(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, validators.size_0, 0)), Q$Validator_$1));
  return editorItem;
}

function $buildMemberEditor(this$static, propertyDefinitionSimple, aggregatePropertySimple, aggregateValueItem, popup){
  var applyButton, cancelButton, data, editorItem, footerStrip, headerStrip, idField, layout, masterPropertySimple, masterUnsetItem, masterValueItem, memberField, memberValuesGrid, okButton, propertyIsReadOnly, setAllForm, unset, unsetField, unsetItem, valueField, self_0;
  propertyIsReadOnly = $isReadOnly(this$static, propertyDefinitionSimple, aggregatePropertySimple);
  layout = new EnhancedVLayout_0;
  $isCreated_1(layout)?$setProperty_3(layout, 'height', '100%'):(layout.config_0['height'] = '100%' , undefined);
  $isCreated_1(layout)?$setProperty_3(layout, 'width', '100%'):(layout.config_0['width'] = '100%' , undefined);
  $setMargin(layout, valueOf_44(11));
  headerStrip = null;
  if (!propertyIsReadOnly) {
    headerStrip = new EnhancedToolStrip_0;
    $setAttribute_24(headerStrip, 'width', '100%', true);
    $setPadding(headerStrip, valueOf_44(5));
    $isCreated_1(headerStrip)?$setProperty_0(headerStrip, 'membersMargin', 10):(headerStrip.config_0['membersMargin'] = 10 , undefined);
    $addMember(layout, headerStrip);
  }
  data = $getMemberValuesGridData(this$static.memberConfigurations, propertyDefinitionSimple, aggregatePropertySimple);
  memberValuesGrid = new ListGrid_0;
  $isCreated_1(memberValuesGrid)?$setProperty_3(memberValuesGrid, 'height', '100%'):(memberValuesGrid.config_0['height'] = '100%' , undefined);
  $isCreated_1(memberValuesGrid)?$setProperty_3(memberValuesGrid, 'width', '100%'):(memberValuesGrid.config_0['width'] = '100%' , undefined);
  $isCreated_1(memberValuesGrid)?$setProperty_2(memberValuesGrid, 'data', convertToJavaScriptArray(data)):(memberValuesGrid.config_0['data'] = convertToJavaScriptArray(data) , undefined);
  $setAttribute_24(memberValuesGrid, 'editEvent', ($clinit_ListGridEditEvent() , CLICK).value_0, true);
  $setEditByCell(memberValuesGrid, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  idField = new ListGridField_3('memberValuesEditor-idField', ($clinit_Enhanced() , 'ID'));
  idField.jsObj['showIf'] = 'false';
  $setAttribute_8(idField, 'canEdit', FALSE);
  memberField = new ListGridField_3('memberValuesEditor-memberField', 'Member');
  $setAttribute_8(memberField, 'canEdit', FALSE);
  valueField = new ListGridField_3('memberValuesEditor-valueField', 'Value');
  $setAttribute_8(valueField, 'required', propertyDefinitionSimple.required?TRUE:FALSE);
  $setAttribute_8(valueField, 'canEdit', TRUE);
  editorItem = $buildEditorFormItem(valueField, propertyDefinitionSimple);
  $setEditorType(valueField, editorItem);
  $setCellFormatter_0(valueField, new GroupConfigurationEditor$3_0(propertyDefinitionSimple));
  unsetField = new ListGridField_3('memberValuesEditor-unsetField', 'Unset');
  $setAttribute_13(unsetField, 'type', ($clinit_ListGridFieldType() , BOOLEAN_1).value_0);
  if (propertyDefinitionSimple.required) {
    unsetField.jsObj['showIf'] = 'false';
    $setAttribute_8(unsetField, 'canEdit', FALSE);
  }
   else {
    unsetField.jsObj['showIf'] = 'true';
    $setAttribute_8(unsetField, 'canEdit', TRUE);
    $setAttribute_8(unsetField, 'canToggle', FALSE);
    $addChangedHandler_0(unsetField, new GroupConfigurationEditor$4_0(memberValuesGrid));
    $addChangeHandler_0(valueField, new GroupConfigurationEditor$5_0(memberValuesGrid));
  }
  idField.jsObj['width'] = '75';
  memberField.jsObj['width'] = '*';
  unsetField.jsObj['width'] = '50';
  valueField.jsObj['width'] = '45%';
  $isCreated_1(memberValuesGrid)?$setProperty_2(memberValuesGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, memberField, unsetField, valueField]))):(memberValuesGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, memberField, unsetField, valueField])) , undefined);
  $addMember(layout, memberValuesGrid);
  footerStrip = new EnhancedToolStrip_0;
  $isCreated_1(footerStrip)?$setProperty_3(footerStrip, 'width', '100%'):(footerStrip.config_0['width'] = '100%' , undefined);
  $setPadding(footerStrip, valueOf_44(5));
  $isCreated_1(footerStrip)?$setProperty_0(footerStrip, 'membersMargin', 10):(footerStrip.config_0['membersMargin'] = 10 , undefined);
  $addMember(layout, footerStrip);
  okButton = new IButton_1('OK');
  propertyIsReadOnly || $setAttribute_22(okButton, 'disabled', TRUE, true);
  $addClickHandler(okButton, new GroupConfigurationEditor$6_0(this$static, propertyIsReadOnly, data, memberValuesGrid, aggregatePropertySimple, aggregateValueItem, propertyDefinitionSimple, popup));
  $addMember(footerStrip, okButton);
  $addRowEditorExitHandler(memberValuesGrid, new GroupConfigurationEditor$7_0(memberValuesGrid, okButton));
  if (propertyIsReadOnly) {
    $setCanEdit(memberValuesGrid, FALSE);
  }
   else {
    cancelButton = new IButton_1('Cancel');
    self_0 = cancelButton.getOrCreateJsObj();
    self_0.focus();
    $addClickHandler(cancelButton, new GroupConfigurationEditor$8_0(popup));
    $addMember(footerStrip, cancelButton);
    setAllForm = new DynamicForm_0;
    $isCreated_1(setAllForm)?$setProperty_0(setAllForm, 'numCols', 3):(setAllForm.config_0['numCols'] = 3 , undefined);
    $isCreated_1(setAllForm)?$setProperty_0(setAllForm, 'cellPadding', 5):(setAllForm.config_0['cellPadding'] = 5 , undefined);
    $setColWidths(setAllForm, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['20%', valueOf_44(50), '*']));
    masterPropertySimple = new PropertySimple_1(propertyDefinitionSimple.name_0, null);
    masterValueItem = $buildSimpleField(this$static, propertyDefinitionSimple, masterPropertySimple);
    $setName_0(masterValueItem, 'memberValuesEditor-' + ($isCreated_2(masterValueItem)?$getPropertyAsString(masterValueItem, 'name'):getAttribute(masterValueItem.jsObj, 'name')));
    masterValueItem.setValidateOnChange(TRUE);
    $setDisabled_2(masterValueItem, FALSE);
    $setAttribute_30(masterValueItem, 'align', ($clinit_Alignment() , LEFT_0).value_0);
    masterValueItem.setStartRow(FALSE);
    masterValueItem.setEndRow(TRUE);
    if (propertyDefinitionSimple.required) {
      masterUnsetItem = new SpacerItem_0;
    }
     else {
      unsetItem = new CheckboxItem_1('memberValuesEditor-unsetall');
      unset = !masterPropertySimple || masterPropertySimple.stringValue == null;
      $setValue_9(unsetItem, unset);
      $setDisabled_2(unsetItem, $isReadOnly(this$static, propertyDefinitionSimple, masterPropertySimple)?TRUE:FALSE);
      $setShowLabel(unsetItem, FALSE);
      $setLabelAsTitle(unsetItem, FALSE);
      $addChangedHandler(unsetItem, new GroupConfigurationEditor$9_0(masterValueItem));
      $addChangeHandler(masterValueItem, new GroupConfigurationEditor$10_0(unsetItem));
      masterUnsetItem = unsetItem;
    }
    masterUnsetItem.setShowTitle(FALSE);
    masterUnsetItem.setStartRow(FALSE);
    masterUnsetItem.setEndRow(FALSE);
    $setAttribute_30(masterUnsetItem, 'align', CENTER_0.value_0);
    instanceOf(masterUnsetItem, Q$CheckboxItem)?masterUnsetItem.setValue_6(false):$setVisible(masterUnsetItem, FALSE);
    applyButton = new ButtonItem_1('apply', 'Set all values to:');
    $setDisabled_2(applyButton, TRUE);
    $setAttribute_30(applyButton, 'align', RIGHT_0.value_0);
    $setStartRow_1(applyButton, TRUE);
    $setEndRow_1(applyButton, FALSE);
    $addClickHandler_1(applyButton, new GroupConfigurationEditor$11_0(masterValueItem, data, memberValuesGrid, okButton));
    $addChangedHandler(masterValueItem, new GroupConfigurationEditor$12_0(applyButton));
    $addChangedHandler(masterUnsetItem, new GroupConfigurationEditor$13_0(applyButton, masterValueItem));
    setAllForm.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [applyButton, masterUnsetItem, masterValueItem]));
    $addMember(headerStrip, setAllForm);
  }
  return layout;
}

function $displayMemberValuesEditor(this$static, propertyDefinitionSimple, aggregatePropertySimple, aggregateValueItem){
  var layout, popup;
  popup = new PopupWindow_0(null);
  $setTitle(popup, 'Member Values for Property [' + ($clinit_Enhanced() , propertyDefinitionSimple.name_0) + ']');
  $isCreated_1(popup)?$setProperty_0(popup, 'width', 800):(popup.config_0['width'] = 800 , undefined);
  $isCreated_1(popup)?$setProperty_0(popup, 'height', 600):(popup.config_0['height'] = 600 , undefined);
  layout = $buildMemberEditor(this$static, propertyDefinitionSimple, aggregatePropertySimple, aggregateValueItem, popup);
  $addItem(popup, layout);
  $show(popup);
}

function $getMemberValuesGridData(memberConfigs, propDef, aggregateProp){
  var configuration, i, isUnset, item, item$iterator, memberProp, record, records, value;
  if (!memberConfigs || memberConfigs.size_0 == 0) {
    records = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, 0, 0);
  }
   else {
    records = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, memberConfigs.size_0, 0);
    i = 0;
    for (item$iterator = new AbstractList$IteratorImpl_0(memberConfigs); item$iterator.i < item$iterator.this$0_0.size_1();) {
      item = dynamicCast($next_0(item$iterator), Q$GroupMemberConfiguration);
      record = new ListGridRecord_0;
      $setAttribute_3(record, 'memberValuesEditor-idField', item.id);
      $setAttribute_13(record, 'memberValuesEditor-memberField', item.label);
      configuration = item.configuration;
      memberProp = dynamicCast($getProperty(configuration, aggregateProp, null), Q$PropertySimple);
      if (!propDef.required) {
        isUnset = !memberProp || memberProp.stringValue == null;
        record.jsObj['memberValuesEditor-unsetField'] = isUnset;
      }
      value = memberProp.stringValue;
      null == value && null != propDef.defaultValue && (value = propDef.defaultValue);
      propDef.readOnly || (value = escapeHtml(value));
      record.jsObj['memberValuesEditor-valueField'] = value;
      !configuration?(record.jsObj['configObject'] = null , undefined):(record.jsObj['configObject'] = configuration , undefined);
      setCheck(records, i++, record);
    }
  }
  return records;
}

function $getProperty(configuration, referenceProperty, index){
  var childPropertyName, currentProperty, i, property, propertyHierarchy, propertyHierarchySize, propertyList, propertyMap;
  propertyHierarchy = new LinkedList_0;
  currentProperty = referenceProperty;
  new LinkedList$Node_1(currentProperty, propertyHierarchy.header);
  ++propertyHierarchy.size_0;
  do {
    if (currentProperty.parentMap) {
      currentProperty = currentProperty.parentMap;
    }
     else if (currentProperty.parentList) {
      currentProperty = currentProperty.parentList;
    }
     else if (!currentProperty.configuration) {
      throw new IllegalStateException_1(currentProperty + ' has no parent.');
    }
    new LinkedList$Node_1(currentProperty, propertyHierarchy.header.next);
    ++propertyHierarchy.size_0;
  }
   while (!currentProperty.configuration);
  property = $get_6(configuration, dynamicCast($get_2(propertyHierarchy, 0), Q$Property).name_0);
  for (i = 1 , propertyHierarchySize = propertyHierarchy.size_0; i < propertyHierarchySize; ++i) {
    childPropertyName = dynamicCast($get_2(propertyHierarchy, i), Q$Property).name_0;
    if (instanceOf(property, Q$PropertyMap)) {
      propertyMap = dynamicCast(property, Q$PropertyMap);
      property = dynamicCast((!propertyMap.map && (propertyMap.map = new LinkedHashMap_0) , propertyMap.map).get_2(childPropertyName), Q$Property);
      if (!property) {
        property = new PropertySimple_1(childPropertyName, null);
        (!propertyMap.map && (propertyMap.map = new LinkedHashMap_0) , propertyMap.map).put(property.name_0, property);
        property.parentMap = propertyMap;
      }
    }
     else if (instanceOf(property, Q$PropertyList)) {
      propertyList = dynamicCast(property, Q$PropertyList);
      if (index.value_0 < (!propertyList.list && (propertyList.list = new ArrayList_0) , propertyList.list).size_1()) {
        property = dynamicCast((!propertyList.list && (propertyList.list = new ArrayList_0) , propertyList.list).get_0(index.value_0), Q$Property);
      }
       else {
        property = new PropertySimple_1(childPropertyName, null);
        $add_10(propertyList, property);
      }
    }
  }
  return property;
}

function $updateMemberProperties(this$static, propertySimple, value){
  var configuration, memberConfiguration, memberConfiguration$iterator, memberPropertySimple;
  for (memberConfiguration$iterator = new AbstractList$IteratorImpl_0(this$static.memberConfigurations); memberConfiguration$iterator.i < memberConfiguration$iterator.this$0_0.size_1();) {
    memberConfiguration = dynamicCast($next_0(memberConfiguration$iterator), Q$GroupMemberConfiguration);
    configuration = memberConfiguration.configuration;
    memberPropertySimple = dynamicCast($getProperty(configuration, propertySimple, null), Q$PropertySimple);
    $setValue_12(memberPropertySimple, value);
  }
}

function GroupConfigurationEditor_0(configurationDefinition, memberConfigurations){
  $clinit_ConfigurationEditor();
  ConfigurationEditor_1.call(this, configurationDefinition, buildAggregateConfiguration_0(memberConfigurations, configurationDefinition));
  this.memberConfigurations = memberConfigurations;
}

function buildAggregateConfiguration_0(memberConfigurations, configurationDefinition){
  var configuration, configurations, memberConfiguration, memberConfiguration$iterator;
  configurations = new ArrayList_1(memberConfigurations.size_0);
  for (memberConfiguration$iterator = new AbstractList$IteratorImpl_0(memberConfigurations); memberConfiguration$iterator.i < memberConfiguration$iterator.this$0_0.size_1();) {
    memberConfiguration = dynamicCast($next_0(memberConfiguration$iterator), Q$GroupMemberConfiguration);
    configuration = memberConfiguration.configuration;
    setCheck(configurations.array, configurations.size_0++, configuration);
  }
  return buildAggregateConfiguration(configurations, configurationDefinition);
}

function getConfiguration(property){
  var topLevelProperty;
  topLevelProperty = getTopLevelProperty(property);
  return topLevelProperty.configuration;
}

function isHomogeneous_0(propertySimple){
  var override;
  override = propertySimple.override;
  return $clinit_Boolean() , !!override && override.value_0?TRUE:FALSE;
}

defineSeed(2261, 2226, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$ConfigurationEditor, Q$Enhanced]), GroupConfigurationEditor_0);
_.addPropertyToDynamicMap = function addPropertyToDynamicMap_0(propertySimple, propertyMap){
  var configuration, memberConfiguration, memberConfiguration$iterator;
  $setOverride(propertySimple, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  (!propertyMap.map && (propertyMap.map = new LinkedHashMap_0) , propertyMap.map).put(propertySimple.name_0, propertySimple);
  propertySimple.parentMap = propertyMap;
  for (memberConfiguration$iterator = new AbstractList$IteratorImpl_0(this.memberConfigurations); memberConfiguration$iterator.i < memberConfiguration$iterator.this$0_0.size_1();) {
    memberConfiguration = dynamicCast($next_0(memberConfiguration$iterator), Q$GroupMemberConfiguration);
    configuration = memberConfiguration.configuration;
    dynamicCast($getProperty(configuration, propertySimple, null), Q$PropertySimple);
  }
}
;
_.buildFieldsForPropertyList = function buildFieldsForPropertyList_0(propertyDefinition, oddRow, propertyDefinitionList, memberDefinition, propertyList){
  var fields, nameItem, staticTextItem;
  fields = new ArrayList_0;
  nameItem = $buildNameItem(propertyDefinition);
  setCheck(fields.array, fields.size_0++, nameItem);
  staticTextItem = new StaticTextItem_0;
  $setShowTitle_0(staticTextItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setValue_7(staticTextItem, ($clinit_Enhanced() , 'List properties are not currently supported for group configurations.'));
  $isCreated_2(staticTextItem)?$setProperty_6(staticTextItem, 'colSpan', 3):(staticTextItem.jsObj['colSpan'] = 3 , undefined);
  $setEndRow_0(staticTextItem, TRUE);
  setCheck(fields.array, fields.size_0++, staticTextItem);
  return fields;
}
;
_.buildFieldsForPropertySimple = function buildFieldsForPropertySimple_0(propertyDefinition, propertyDefinitionSimple, propertySimple){
  var fields, icon, isHomogeneous, staticItem, valueItem;
  fields = $buildFieldsForPropertySimple(this, propertyDefinition, propertyDefinitionSimple, propertySimple);
  if (getConfiguration(propertySimple) == this.configuration) {
    staticItem = new StaticTextItem_1('static-' + propertySimple.name_0);
    $setValue_7(staticItem, ($clinit_Enhanced() , 'member values differ'));
    $isCreated_2(staticItem)?$setProperty_8(staticItem, 'textBoxStyle', 'InlineNote'):(staticItem.jsObj['textBoxStyle'] = 'InlineNote' , undefined);
    $setShowTitle_0(staticItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setPrompt_1(staticItem, 'Member values differ - click icon to edit them.');
    isHomogeneous = isHomogeneous_0(propertySimple);
    $setVisible(staticItem, isHomogeneous.value_0?FALSE:TRUE);
    valueItem = dynamicCast((checkIndex(2, fields.size_0) , fields.array[2]), Q$FormItem);
    icon = $buildEditMemberValuesIcon(this, propertyDefinitionSimple, propertySimple, valueItem);
    $isCreated_2(staticItem)?$setProperty_7(staticItem, 'icons', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [icon]))):(staticItem.jsObj['icons'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [icon])) , undefined);
    $setAttribute_30(valueItem, 'rhq:staticItemName', $isCreated_2(staticItem)?$getPropertyAsString(staticItem, 'name'):getAttribute(staticItem.jsObj, 'name'));
    $add_2(fields, 3, staticItem);
  }
  return fields;
}
;
_.buildSimpleField = function buildSimpleField_0(propertyDefinitionSimple, propertySimple){
  var icon, isAggregate, isHomogeneous, item;
  item = $buildSimpleField(this, propertyDefinitionSimple, propertySimple);
  isAggregate = getConfiguration(propertySimple) == this.configuration;
  if (isAggregate) {
    icon = $buildEditMemberValuesIcon(this, propertyDefinitionSimple, propertySimple, item);
    $isCreated_2(item)?$setProperty_7(item, 'icons', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [icon]))):(item.jsObj['icons'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [icon])) , undefined);
    $addChangedHandler(item, new GroupConfigurationEditor$1_0(this, propertySimple));
    isHomogeneous = isHomogeneous_0(propertySimple);
    $isCreated_2(item)?$setProperty_9(item, 'visible', isHomogeneous.value_0):setAttribute_5(item.jsObj, 'visible', isHomogeneous);
  }
  return item;
}
;
_.buildUnsetItem = function buildUnsetItem_0(propertyDefinitionSimple, propertySimple, valueItem){
  var unsetItem;
  unsetItem = $buildUnsetItem(this, propertyDefinitionSimple, propertySimple, valueItem);
  if (instanceOf(unsetItem, Q$CheckboxItem) && !isHomogeneous_0(propertySimple).value_0 && getConfiguration(propertySimple) == this.configuration) {
    unsetItem.setValue_6(false);
    $setDisabled_2(unsetItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  }
  $setAttribute_30(valueItem, 'rhq:unsetItemName', $isCreated_2(unsetItem)?$getPropertyAsString(unsetItem, 'name'):getAttribute(unsetItem.jsObj, 'name'));
  return unsetItem;
}
;
_.removePropertyFromDynamicMap = function removePropertyFromDynamicMap_0(propertySimple){
  var configuration, memberConfiguration, memberConfiguration$iterator, memberPropertySimple, parentMap;
  $removePropertyFromDynamicMap(propertySimple);
  for (memberConfiguration$iterator = new AbstractList$IteratorImpl_0(this.memberConfigurations); memberConfiguration$iterator.i < memberConfiguration$iterator.this$0_0.size_1();) {
    memberConfiguration = dynamicCast($next_0(memberConfiguration$iterator), Q$GroupMemberConfiguration);
    configuration = memberConfiguration.configuration;
    memberPropertySimple = dynamicCast($getProperty(configuration, propertySimple, null), Q$PropertySimple);
    parentMap = memberPropertySimple.parentMap;
    (!parentMap.map && (parentMap.map = new LinkedHashMap_0) , parentMap.map).remove_3(memberPropertySimple.name_0);
  }
}
;
_.shouldFireEventOnPropertyValueChange = function shouldFireEventOnPropertyValueChange_0(formItem, propertyDefinitionSimple, propertySimple){
  var isAgg;
  if (($isCreated_2(formItem)?$getPropertyAsString(formItem, 'name'):getAttribute(formItem.jsObj, 'name')).indexOf('memberValuesEditor-') == 0) {
    return false;
  }
  isAgg = getConfiguration(propertySimple) == this.configuration;
  return isAgg && $shouldFireEventOnPropertyValueChange(propertySimple);
}
;
_.updatePropertySimpleValue = function updatePropertySimpleValue_0(formItem, value, propertySimple, propertyDefinitionSimple){
  var configuration, memberConfiguration, memberConfiguration$iterator, memberPropertySimple;
  if (!!propertySimple.configuration || !!propertySimple.parentMap || !!propertySimple.parentList) {
    $updatePropertySimpleValue(formItem, value, propertySimple);
    $setOverride(propertySimple, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    if (($isCreated_2(formItem)?$getPropertyAsString(formItem, 'name'):getAttribute(formItem.jsObj, 'name')).indexOf('memberValuesEditor-') != 0) {
      for (memberConfiguration$iterator = new AbstractList$IteratorImpl_0(this.memberConfigurations); memberConfiguration$iterator.i < memberConfiguration$iterator.this$0_0.size_1();) {
        memberConfiguration = dynamicCast($next_0(memberConfiguration$iterator), Q$GroupMemberConfiguration);
        configuration = memberConfiguration.configuration;
        memberPropertySimple = dynamicCast($getProperty(configuration, propertySimple, null), Q$PropertySimple);
        memberPropertySimple.errorMessage_0 = null;
        $setValue_12(memberPropertySimple, value);
      }
    }
  }
}
;
_.memberConfigurations = null;
function GroupConfigurationEditor$1_0(this$0, val$propertySimple){
  this.this$0 = this$0;
  this.val$propertySimple = val$propertySimple;
}

defineSeed(2262, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupConfigurationEditor$1_0);
_.onChanged = function onChanged_36(changedEvent){
  var value;
  value = $getValue_2(changedEvent);
  $updateMemberProperties(this.this$0, this.val$propertySimple, value);
}
;
_.this$0 = null;
_.val$propertySimple = null;
function GroupConfigurationEditor$10_0(val$unsetItem){
  this.val$unsetItem = val$unsetItem;
}

defineSeed(2263, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), GroupConfigurationEditor$10_0);
_.onChange = function onChange_2(event_0){
  $getValue_1(event_0) == null || toString__devirtual$($getValue_1(event_0)).length == 0?$setValue_9(this.val$unsetItem, true):$setValue_9(this.val$unsetItem, false);
}
;
_.val$unsetItem = null;
function GroupConfigurationEditor$11_0(val$masterValueItem, val$data, val$memberValuesGrid, val$okButton){
  this.val$masterValueItem = val$masterValueItem;
  this.val$data = val$data;
  this.val$memberValuesGrid = val$memberValuesGrid;
  this.val$okButton = val$okButton;
}

defineSeed(2264, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), GroupConfigurationEditor$11_0);
_.onClick_0 = function onClick_68(event_0){
  var field, field$array, field$index, field$max, stringValue, value, self_0;
  if (this.val$masterValueItem.validate_1().value_0) {
    value = this.val$masterValueItem.getValue_1();
    for (field$array = this.val$data , field$index = 0 , field$max = field$array.length; field$index < field$max; ++field$index) {
      field = field$array[field$index];
      stringValue = value != null?toString__devirtual$(value):null;
      field.jsObj['memberValuesEditor-valueField'] = stringValue;
      field.jsObj['memberValuesEditor-unsetField'] = value == null;
    }
    self_0 = this.val$memberValuesGrid.getOrCreateJsObj();
    self_0.discardAllEdits();
    $enable(this.val$okButton);
    $redraw(this.val$memberValuesGrid);
  }
}
;
_.val$data = null;
_.val$masterValueItem = null;
_.val$memberValuesGrid = null;
_.val$okButton = null;
function GroupConfigurationEditor$12_0(val$applyButton){
  this.val$applyButton = val$applyButton;
}

defineSeed(2265, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupConfigurationEditor$12_0);
_.onChanged = function onChanged_37(changedEvent){
  this.val$applyButton.enable_0();
}
;
_.val$applyButton = null;
function GroupConfigurationEditor$13_0(val$applyButton, val$masterValueItem){
  this.val$applyButton = val$applyButton;
  this.val$masterValueItem = val$masterValueItem;
}

defineSeed(2266, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupConfigurationEditor$13_0);
_.onChanged = function onChanged_38(changedEvent){
  this.val$applyButton.enable_0();
  dynamicCast($getValue_2(changedEvent), Q$Boolean).value_0?$focusInItem(this.val$applyButton):$focusInItem(this.val$masterValueItem);
}
;
_.val$applyButton = null;
_.val$masterValueItem = null;
function GroupConfigurationEditor$2_0(this$0, val$propertyDefinitionSimple, val$propertySimple, val$dynamicItem){
  this.this$0 = this$0;
  this.val$propertyDefinitionSimple = val$propertyDefinitionSimple;
  this.val$propertySimple = val$propertySimple;
  this.val$dynamicItem = val$dynamicItem;
}

defineSeed(2267, 1, makeCastMap([Q$EventHandler, Q$FormItemClickHandler]), GroupConfigurationEditor$2_0);
_.onFormItemClick = function onFormItemClick_0(event_0){
  $displayMemberValuesEditor(this.this$0, this.val$propertyDefinitionSimple, this.val$propertySimple, this.val$dynamicItem);
}
;
_.this$0 = null;
_.val$dynamicItem = null;
_.val$propertyDefinitionSimple = null;
_.val$propertySimple = null;
function GroupConfigurationEditor$3_0(val$propertyDefinitionSimple){
  this.val$propertyDefinitionSimple = val$propertyDefinitionSimple;
}

defineSeed(2268, 1, {}, GroupConfigurationEditor$3_0);
_.format_1 = function format_24(value, record, rowNum, colNum){
  var enumeratedValues, option, option$iterator;
  if (value == null) {
    return '';
  }
  enumeratedValues = this.val$propertyDefinitionSimple.enumeratedValues;
  if (!!enumeratedValues && !enumeratedValues.isEmpty_0()) {
    for (option$iterator = enumeratedValues.iterator(); option$iterator.hasNext();) {
      option = dynamicCast(option$iterator.next_0(), Q$PropertyDefinitionEnumeration);
      if ($equals_6(option.value_0, toString__devirtual$(value))) {
        return option.name_0;
      }
    }
    return toString__devirtual$(value);
  }
   else {
    switch (this.val$propertyDefinitionSimple.type_0.ordinal) {
      case 3:
        {
          return dynamicCast($get_4(($clinit_ConfigurationEditor() , BOOLEAN_PROPERTY_ITEM_VALUE_MAP), toString__devirtual$(value)), Q$String);
        }

      case 2:
        {
          return '******';
        }

      default:return toString__devirtual$(value);
    }
  }
}
;
_.val$propertyDefinitionSimple = null;
function GroupConfigurationEditor$4_0(val$memberValuesGrid){
  this.val$memberValuesGrid = val$memberValuesGrid;
}

defineSeed(2269, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler_0]), GroupConfigurationEditor$4_0);
_.onChanged_0 = function onChanged_39(event_0){
  var isUnset, rowNum, valueItem, jsObj;
  isUnset = dynamicCast($getValue_4(event_0), Q$Boolean);
  valueItem = $getField_0((jsObj = event_0.jsObj , getOrCreateRef_5(jsObj.form)), 'memberValuesEditor-valueField');
  if (isUnset.value_0) {
    rowNum = $getRowNum_0(event_0);
    $setEditValue(this.val$memberValuesGrid, rowNum, 'memberValuesEditor-valueField', null);
  }
   else {
    $focusInItem(valueItem);
  }
  $redraw_0(valueItem);
}
;
_.val$memberValuesGrid = null;
function GroupConfigurationEditor$5_0(val$memberValuesGrid){
  this.val$memberValuesGrid = val$memberValuesGrid;
}

defineSeed(2270, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler_0]), GroupConfigurationEditor$5_0);
_.val$memberValuesGrid = null;
function GroupConfigurationEditor$6_0(this$0, val$propertyIsReadOnly, val$data, val$memberValuesGrid, val$aggregatePropertySimple, val$aggregateValueItem, val$propertyDefinitionSimple, val$popup){
  this.this$0 = this$0;
  this.val$propertyIsReadOnly = val$propertyIsReadOnly;
  this.val$data = val$data;
  this.val$memberValuesGrid = val$memberValuesGrid;
  this.val$aggregatePropertySimple = val$aggregatePropertySimple;
  this.val$index = null;
  this.val$aggregateValueItem = val$aggregateValueItem;
  this.val$propertyDefinitionSimple = val$propertyDefinitionSimple;
  this.val$popup = val$popup;
}

defineSeed(2271, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), GroupConfigurationEditor$6_0);
_.onClick = function onClick_69(clickEvent){
  var aggregateStaticItem, aggregateStaticItemName, aggregateUnsetItem, aggregateUnsetItemName, config, firstValue, isUnset, isValid, memberPropertySimple, value, valueItem, valueItem$array, valueItem$index, valueItem$max, valuesHomogeneous;
  if (!this.val$propertyIsReadOnly) {
    valuesHomogeneous = true;
    isValid = true;
    firstValue = $getAttribute(this.val$data[0], 'memberValuesEditor-valueField');
    for (valueItem$array = this.val$data , valueItem$index = 0 , valueItem$max = valueItem$array.length; valueItem$index < valueItem$max; ++valueItem$index) {
      valueItem = valueItem$array[valueItem$index];
      value = getAttribute(valueItem.jsObj, 'memberValuesEditor-valueField');
      valuesHomogeneous && (value != null && !$equals_6(value, firstValue) || value == null && firstValue != null) && (valuesHomogeneous = false);
      isValid = isValid && $validateRow(this.val$memberValuesGrid, 0).value_0;
      config = dynamicCast(getAttributeAsObject(valueItem.jsObj, 'configObject'), Q$Configuration);
      memberPropertySimple = dynamicCast($getProperty(config, this.val$aggregatePropertySimple, this.val$index), Q$PropertySimple);
      $setValue_12(memberPropertySimple, value);
      memberPropertySimple.errorMessage_0 = null;
    }
    aggregateStaticItemName = $getAttribute_0(this.val$aggregateValueItem, 'rhq:staticItemName');
    aggregateStaticItem = $getField_0($getForm(this.val$aggregateValueItem), aggregateStaticItemName);
    aggregateUnsetItemName = $getAttribute_0(this.val$aggregateValueItem, 'rhq:unsetItemName');
    aggregateUnsetItem = $getField_0($getForm(this.val$aggregateValueItem), aggregateUnsetItemName);
    $setDisabled_2(aggregateUnsetItem, ($clinit_Boolean() , valuesHomogeneous?FALSE:TRUE));
    if (valuesHomogeneous) {
      $setValue_12(this.val$aggregatePropertySimple, firstValue);
      $setOverride(this.val$aggregatePropertySimple, TRUE);
      isUnset = firstValue == null;
      aggregateUnsetItem.setValue_6(isUnset);
      setValue_23(this.val$aggregateValueItem, firstValue);
      $show_0(this.val$aggregateValueItem);
      $setDisabled_2(this.val$aggregateValueItem, isUnset?TRUE:FALSE);
      $hide_0(aggregateStaticItem);
    }
     else {
      $setValue_12(this.val$aggregatePropertySimple, null);
      $setOverride(this.val$aggregatePropertySimple, FALSE);
      $hide_0(this.val$aggregateValueItem);
      $show_0(aggregateStaticItem);
    }
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You changed some settings - do not forget to save those changes or they will be lost.\n'), ($clinit_Message$Severity() , Info)));
    $firePropertyChangedEvent(this.this$0, this.val$propertyDefinitionSimple, isValid);
  }
  $destroy(this.val$popup);
}
;
_.this$0 = null;
_.val$aggregatePropertySimple = null;
_.val$aggregateValueItem = null;
_.val$data = null;
_.val$index = null;
_.val$memberValuesGrid = null;
_.val$popup = null;
_.val$propertyDefinitionSimple = null;
_.val$propertyIsReadOnly = false;
function GroupConfigurationEditor$7_0(val$memberValuesGrid, val$okButton){
  this.val$memberValuesGrid = val$memberValuesGrid;
  this.val$okButton = val$okButton;
}

defineSeed(2272, 1, makeCastMap([Q$EventHandler, Q$RowEditorExitHandler]), GroupConfigurationEditor$7_0);
_.val$memberValuesGrid = null;
_.val$okButton = null;
function GroupConfigurationEditor$8_0(val$popup){
  this.val$popup = val$popup;
}

defineSeed(2273, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), GroupConfigurationEditor$8_0);
_.onClick = function onClick_70(clickEvent){
  $destroy(this.val$popup);
}
;
_.val$popup = null;
function GroupConfigurationEditor$9_0(val$masterValueItem){
  this.val$masterValueItem = val$masterValueItem;
}

defineSeed(2274, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupConfigurationEditor$9_0);
_.onChanged = function onChanged_40(changedEvent){
  var isUnset;
  isUnset = dynamicCast($getValue_2(changedEvent), Q$Boolean);
  $setDisabled_2(this.val$masterValueItem, isUnset);
  isUnset.value_0 && setValue_23(this.val$masterValueItem, null);
  $redraw_0(this.val$masterValueItem);
}
;
_.val$masterValueItem = null;
function GroupMemberConfiguration_0(id, label, configuration){
  this.id = id;
  this.label = label != null?label:'' + id;
  this.configuration = configuration;
}

defineSeed(2275, 1, makeCastMap([Q$GroupMemberConfiguration]), GroupMemberConfiguration_0);
_.equals$ = function equals_124(o){
  var that;
  if (this === o) {
    return true;
  }
  if (o == null || Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupMemberConfiguration_2_classLit != getClass__devirtual$(o)) {
    return false;
  }
  that = dynamicCast(o, Q$GroupMemberConfiguration);
  if (this.id != that.id) {
    return false;
  }
  return true;
}
;
_.hashCode$ = function hashCode_124(){
  return this.id;
}
;
_.toString$ = function toString_200(){
  return 'GroupMemberConfiguration{id=' + this.id + ", label='" + this.label + "', configuration=" + this.configuration + '}';
}
;
_.configuration = null;
_.id = 0;
_.label = null;
function $refresh_3(this$static){
  var $e0, propertyName, propertySimple, subDef, subDef$iterator, subDefSimple;
  for (subDef$iterator = new AbstractList$IteratorImpl_0(this$static.memberPropertyDefinitions); subDef$iterator.i < subDef$iterator.this$0_0.size_1();) {
    subDef = dynamicCast($next_0(subDef$iterator), Q$PropertyDefinition);
    subDefSimple = dynamicCast(subDef, Q$PropertyDefinitionSimple);
    propertyName = subDefSimple.name_0;
    propertySimple = $getSimple_0(this$static.propertyMap, propertyName);
    if (!!propertySimple && propertySimple.stringValue != null) {
      try {
        switch (dynamicCast(subDef, Q$PropertyDefinitionSimple).type_0.ordinal) {
          case 3:
            $setAttribute_8(this$static, propertyName, propertySimple.stringValue == null?null:($clinit_Boolean() , $equalsIgnoreCase('true', propertySimple.stringValue)?TRUE:FALSE));
            break;
          case 4:
            $setAttribute_11(this$static, propertyName, propertySimple.stringValue == null?null:valueOf_44(__parseAndValidateInt(propertySimple.stringValue)));
            break;
          case 5:
            $setAttribute_12(this$static, propertyName, propertySimple.stringValue == null?null:new Long_0(__parseAndValidateLong(propertySimple.stringValue)));
            break;
          case 6:
            $setAttribute_10(this$static, propertyName, propertySimple.stringValue == null?null:new Float_0(parseFloat_0(propertySimple.stringValue)));
            break;
          case 7:
            $setAttribute_9(this$static, propertyName, propertySimple.stringValue == null?null:new Double_0(__parseAndValidateDouble(propertySimple.stringValue)));
            break;
          default:$setAttribute_13(this$static, propertyName, propertySimple.stringValue);
        }
      }
       catch ($e0) {
        $e0 = caught_0($e0);
        if (instanceOf($e0, Q$Exception)) {
          $setAttribute_13(this$static, propertyName, propertySimple.stringValue);
        }
         else 
          throw $e0;
      }
    }
     else {
      this$static.jsObj[propertyName] = null;
    }
  }
}

function PropertyMapListGridRecord_0(propertyMap, index, memberPropertyDefinitions){
  ListGridRecord_0.call(this);
  this.propertyMap = propertyMap;
  this.index_0 = index;
  this.memberPropertyDefinitions = memberPropertyDefinitions;
  $refresh_3(this);
}

defineSeed(2276, 540, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$PropertyMapListGridRecord]), PropertyMapListGridRecord_0);
_.index_0 = 0;
_.memberPropertyDefinitions = null;
_.propertyMap = null;
function PropertyValueChangeEvent_0(invalidPropertySetChanged, invalidPropertyNames){
  this.invalidPropertySetChanged = invalidPropertySetChanged;
  this.invalidPropertyNames = invalidPropertyNames;
}

defineSeed(2277, 1, {}, PropertyValueChangeEvent_0);
_.invalidPropertyNames = null;
_.invalidPropertySetChanged = false;
function AbstractRecordEditor$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2278, 1, makeCastMap([Q$EventHandler, Q$ItemChangedHandler]), AbstractRecordEditor$1_0);
_.onItemChanged = function onItemChanged_1(event_0){
  $onItemChanged(this.this$0);
}
;
_.this$0 = null;
function AbstractRecordEditor$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2279, 1, {}, AbstractRecordEditor$2_0);
_.execute_2 = function execute_37(response, rawData, request){
  var cause, cause$iterator, causes, conciseMessage, data, dataObject, detailedMessage, message, name_0, operationType, record, sb;
  if (getAttributeAsInt(response.jsObj, 'status').value_0 == 0) {
    data = $getData(response);
    record = data[0];
    getAttribute(record.jsObj, 'id');
    name_0 = $getAttribute(record, this.this$0.getTitleFieldName());
    operationType = dynamicCast(getEnum(($clinit_DSOperationType() , $clinit_DSOperationType() , $VALUES_9), getAttribute(request.jsObj, 'operationType')), Q$DSOperationType);
    $clinit_Log();
    if ($isLoggable_0(logger_0, ($clinit_Level() , FINE))) {
      dataObject = this.this$0.dataSource.copyValues(record);
      operationType == ADD?$fine_0(logger_0, 'Created: ' + dataObject):$fine_0(logger_0, 'Updated: ' + dataObject);
    }
    switch (operationType.ordinal) {
      case 1:
        conciseMessage = ($clinit_Enhanced() , this.this$0.dataTypeName) + ' created.';
        detailedMessage = this.this$0.dataTypeName + ' [' + name_0 + '] created.';
        {
          $clinit_CoreGUI();
        }

        break;
      case 2:
        conciseMessage = ($clinit_Enhanced() , this.this$0.dataTypeName) + ' updated.';
        detailedMessage = this.this$0.dataTypeName + ' [' + name_0 + '] updated.';
        break;
      default:throw new IllegalStateException_1('Unsupported operation type: [' + ($clinit_Enhanced() , operationType.name_0) + ']');
    }
    message = new Message_1(conciseMessage, detailedMessage);
    goToView(this.this$0.getListViewPath(), message, true);
  }
   else if (getAttributeAsInt(response.jsObj, 'status').value_0 == -4) {
    causes = null;
    if (!!$getErrors(response) && !$getErrors(response).isEmpty_0()) {
      sb = new StringBuffer_0;
      for (cause$iterator = $getErrors(response).values_0().iterator(); cause$iterator.hasNext();) {
        cause = cause$iterator.next_0();
        $appendNonNull(sb.data_0, '' + cause);
        $appendNonNull(sb.data_0, '\n');
      }
      causes = $toString_1(sb.data_0);
    }
    message = new Message_2(($clinit_Enhanced() , 'Operation failed - one or more fields have invalid values'), causes, ($clinit_Message$Severity() , Error_2));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
   else {
    message = new Message_7(($clinit_Enhanced() , 'Operation failed. An error occurred'), ($clinit_Message$Severity() , Error_2));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
}
;
_.this$0 = null;
function AbstractRecordEditor$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2280, 1, {}, AbstractRecordEditor$3_0);
_.execute_2 = function execute_38(response, rawData, request){
  var record, records;
  if (!this.this$0.postFetchHandlerExecutedAlready) {
    this.this$0.postFetchHandlerExecutedAlready = true;
    if (getAttributeAsInt(response.jsObj, 'status').value_0 == 0) {
      records = $getData(response);
      if (records.length == 0) {
        throw new IllegalStateException_1(($clinit_Enhanced() , 'No records were returned - expected exactly one.'));
      }
      if (records.length > 1) {
        throw new IllegalStateException_1(($clinit_Enhanced() , 'Multiple records were returned - expected exactly one.'));
      }
      record = records[0];
      this.this$0.editExistingRecord(record);
      $displayForm(this.this$0);
    }
  }
}
;
_.this$0 = null;
function AbstractRecordEditor$ButtonBar_0(this$0){
  $clinit_BaseWidget();
  var hLayout, vLayout;
  this.this$0 = this$0;
  EnhancedToolStrip_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'height', 35):(this.config_0['height'] = 35 , undefined);
  vLayout = new EnhancedVLayout_0;
  $setAttribute_24(vLayout, 'align', ($clinit_VerticalAlignment() , CENTER_2).value_0, true);
  $setLayoutMargin(vLayout, valueOf_44(4));
  hLayout = new EnhancedHLayout_0;
  $isCreated_1(hLayout)?$setProperty_0(hLayout, 'membersMargin', 10):(hLayout.config_0['membersMargin'] = 10 , undefined);
  $addMember(vLayout, hLayout);
  this.saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
  $setDisabled(this.saveButton, true);
  $addClickHandler(this.saveButton, new AbstractRecordEditor$ButtonBar$1_0(this));
  $addMember(hLayout, this.saveButton);
  this.resetButton = new EnhancedIButton_1('Reset');
  $setDisabled(this.resetButton, true);
  $addClickHandler(this.resetButton, new AbstractRecordEditor$ButtonBar$2_0(this));
  $addMember(hLayout, this.resetButton);
  this.cancelButton = new EnhancedIButton_1('Cancel');
  $addClickHandler(this.cancelButton, new AbstractRecordEditor$ButtonBar$3_0(this));
  $addMember(hLayout, this.cancelButton);
  $addMember(this, vLayout);
}

defineSeed(2281, 2203, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$Enhanced]), AbstractRecordEditor$ButtonBar_0);
_.cancelButton = null;
_.resetButton = null;
_.saveButton = null;
_.this$0 = null;
function AbstractRecordEditor$ButtonBar$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2282, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AbstractRecordEditor$ButtonBar$1_0);
_.onClick = function onClick_71(clickEvent){
  this.this$1.this$0.save(new DSRequest_0);
}
;
_.this$1 = null;
function AbstractRecordEditor$ButtonBar$2_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2283, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AbstractRecordEditor$ButtonBar$2_0);
_.onClick = function onClick_72(clickEvent){
  $disable(this.this$1.resetButton);
  $disable(this.this$1.saveButton);
  this.this$1.this$0.reset_1();
}
;
_.this$1 = null;
function AbstractRecordEditor$ButtonBar$3_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2284, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AbstractRecordEditor$ButtonBar$3_0);
_.onClick = function onClick_73(clickEvent){
  $clinit_CoreGUI();
  goToView(this.this$1.this$0.getListViewPath(), null, false);
}
;
_.this$1 = null;
function $clinit_SimpleEditableFormItem(){
  $clinit_SimpleEditableFormItem = nullMethod;
  $clinit_CoreGUI();
}

function $markForRedraw_1(this$static){
  $markForRedraw($getForm(this$static));
  $markForRedraw(this$static.innerForm);
}

function $setApprovedNewValue(this$static, newValue){
  this$static.setStaticItemValue(this$static.staticItem, newValue);
  !!this$static.valueEditedHandler && this$static.valueEditedHandler.editedValue(newValue);
}

function $setReadOnly_2(this$static){
  this$static.readOnly = true;
  $setTextBoxStyle(this$static.staticItem);
  $markForRedraw($getForm(this$static));
  $markForRedraw(this$static.innerForm);
}

function $setValidators_0(this$static, validators){
  this$static.editItem.setValidators(validators);
}

function $setValue_13(this$static, value){
  !!this$static.staticItem && $setEscapeHTML(this$static.staticItem, ($clinit_Boolean() , null == value || !value.length?FALSE:TRUE));
  $setValue_7(this$static.staticItem, value);
}

function $setValueEditedHandler(this$static, handler){
  this$static.valueEditedHandler = handler;
}

function $switchToEditMode(this$static){
  if (!this$static.editing) {
    this$static.editing = true;
    this$static.setEditItemValue(this$static.editItem, $getValue_0(this$static.staticItem));
    $markForRedraw($getForm(this$static));
    $markForRedraw(this$static.innerForm);
  }
}

function $switchToStaticMode(this$static){
  if (this$static.editing) {
    this$static.editing = false;
    $markForRedraw($getForm(this$static));
    $markForRedraw(this$static.innerForm);
  }
}

function $validate_4(this$static){
  return $clinit_Boolean() , !this$static.editing || this$static.editItem.validate_1().value_0?TRUE:FALSE;
}

function SimpleEditableFormItem_0(name_0, title){
  $clinit_SimpleEditableFormItem();
  SimpleEditableFormItem_1.call(this, name_0, title);
}

function SimpleEditableFormItem_1(name_0, title){
  CanvasItem_0.call(this);
  name_0 != null && ($isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined));
  title != null && ($isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined));
  this.innerForm = new DynamicForm_0;
  this.staticItem = this.prepareStaticFormItem();
  this.editItem = this.prepareEditFormItem();
  $setCanFocus(this.innerForm, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setNumCols(this.innerForm, 1);
  this.addHandlers();
  this.innerForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.staticItem, this.editItem]));
  $setCanvas(this, this.innerForm);
  $setCanFocus_0(this, TRUE);
}

defineSeed(2287, 489, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), SimpleEditableFormItem_0);
_.addHandlers = function addHandlers(){
  $addBlurHandler(this.editItem, new SimpleEditableFormItem$1_0(this));
}
;
_.getValue_1 = function getValue_48(){
  return $getValue_0(this.staticItem);
}
;
_.instantiateEditFormItem = function instantiateEditFormItem(){
  var item;
  item = new TextItem_0;
  return item;
}
;
_.prepareEditFormItem = function prepareEditFormItem(){
  var item;
  item = this.instantiateEditFormItem();
  item.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowIfCondition(item, new SimpleEditableFormItem$3_0(this));
  return item;
}
;
_.prepareStaticFormItem = function prepareStaticFormItem(){
  var item;
  item = new StaticTextItem_0;
  $setShowTitle_0(item, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowIfCondition(item, new SimpleEditableFormItem$2_0(this));
  return item;
}
;
_.setEditItemValue = function setEditItemValue(editItem, value){
  var convertedValue;
  convertedValue = value != null?toString__devirtual$(value):null;
  editItem.setValue_4(convertedValue);
  return convertedValue;
}
;
_.setStaticItemValue = function setStaticItemValue(staticItem, value){
  var convertedValue;
  convertedValue = value != null?toString__devirtual$(value):null;
  $setValue_7(staticItem, convertedValue);
  return convertedValue;
}
;
_.setValidators = function setValidators_0(validators){
  $setValidators_0(this, validators);
}
;
_.setValue_0 = function setValue_24(value){
  $setValue_3(this.staticItem, value);
}
;
_.setValue_1 = function setValue_25(value){
  $setValue_4(this.staticItem, value);
}
;
_.setValue_2 = function setValue_26(value){
  $setValue_5(this.staticItem, value);
}
;
_.setValue_3 = function setValue_27(value){
  $setValue_6(this.staticItem, value);
}
;
_.setValue_4 = function setValue_28(value){
  $setValue_13(this, value);
}
;
_.setValue_5 = function setValue_29(value){
  $setValue_8(this.staticItem, value);
}
;
_.setValue_6 = function setValue_30(value){
  $setValue_9(this.staticItem, value);
}
;
_.validate_1 = function validate_7(){
  return $validate_4(this);
}
;
_.editItem = null;
_.editing = false;
_.innerForm = null;
_.readOnly = false;
_.staticItem = null;
_.valueEditedHandler = null;
function $createBlankIcon(){
  var blankIcon;
  blankIcon = new FormItemIcon_0;
  blankIcon.jsObj['src'] = 'blank.png';
  return blankIcon;
}

function EditableFormItem_0(){
  $clinit_SimpleEditableFormItem();
  SimpleEditableFormItem_1.call(this, null, null);
}

defineSeed(2286, 2287, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers, Q$EditableFormItem]), EditableFormItem_0);
_.addHandlers = function addHandlers_0(){
  var blankIcon, editIcon, editIcon_0;
  blankIcon = $createBlankIcon();
  editIcon = (editIcon_0 = new FormItemIcon_0 , editIcon_0.jsObj['src'] = '[SKIN]/actions/edit.png' , editIcon_0.jsObj['prompt'] = 'Edit' , $addFormItemClickHandler(editIcon_0, new EditableFormItem$6_0(this)) , editIcon_0);
  $addMouseOutHandler(this.innerForm, new EditableFormItem$1_0(this, blankIcon));
  $addMouseOverHandler(this.innerForm, new EditableFormItem$2_0(this, editIcon));
}
;
_.prepareEditFormItem = function prepareEditFormItem_0(){
  var approveIcon, cancelIcon, item, cancelIcon_0, approveIcon_0;
  cancelIcon = (cancelIcon_0 = new FormItemIcon_0 , cancelIcon_0.jsObj['src'] = '[SKIN]/actions/undo.png' , cancelIcon_0.jsObj['prompt'] = 'Cancel' , $addFormItemClickHandler(cancelIcon_0, new EditableFormItem$8_0(this)) , cancelIcon_0);
  approveIcon = (approveIcon_0 = new FormItemIcon_0 , approveIcon_0.jsObj['src'] = '[SKIN]/actions/approve.png' , approveIcon_0.jsObj['prompt'] = 'OK' , $addFormItemClickHandler(approveIcon_0, new EditableFormItem$7_0(this)) , approveIcon_0);
  item = this.instantiateEditFormItem();
  item.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_2(item)?$setProperty_7(item, 'icons', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [approveIcon, cancelIcon]))):(item.jsObj['icons'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [approveIcon, cancelIcon])) , undefined);
  item.setIconVAlign(($clinit_VerticalAlignment() , CENTER_2));
  $isCreated_2(item)?$setProperty_6(item, 'iconHeight', 16):(item.jsObj['iconHeight'] = 16 , undefined);
  $isCreated_2(item)?$setProperty_6(item, 'iconWidth', 16):(item.jsObj['iconWidth'] = 16 , undefined);
  $setShowIcons(item, TRUE);
  $setShowIfCondition(item, new EditableFormItem$4_0(this));
  $addKeyPressHandler_0(item, new EditableFormItem$5_0(this));
  return item;
}
;
_.prepareStaticFormItem = function prepareStaticFormItem_0(){
  var blankIcon, item;
  blankIcon = $createBlankIcon();
  item = new StaticTextItem_0;
  $setShowTitle_0(item, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_2(item)?$setProperty_7(item, 'icons', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [blankIcon]))):(item.jsObj['icons'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [blankIcon])) , undefined);
  $setAttribute_30(item, 'iconVAlign', ($clinit_VerticalAlignment() , CENTER_2).value_0);
  $isCreated_2(item)?$setProperty_6(item, 'iconHeight', 16):(item.jsObj['iconHeight'] = 16 , undefined);
  $isCreated_2(item)?$setProperty_6(item, 'iconWidth', 16):(item.jsObj['iconWidth'] = 16 , undefined);
  $setShowIcons(item, TRUE);
  $setShowIfCondition(item, new EditableFormItem$3_0(this));
  $isCreated_2(item)?$setProperty_8(item, 'textBoxStyle', 'editableText'):(item.jsObj['textBoxStyle'] = 'editableText' , undefined);
  return item;
}
;
function CheckboxEditableFormItem_0(title){
  $clinit_SimpleEditableFormItem();
  SimpleEditableFormItem_0.call(this, 'recursive', title);
}

defineSeed(2285, 2286, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers, Q$EditableFormItem]), CheckboxEditableFormItem_0);
_.instantiateEditFormItem = function instantiateEditFormItem_0(){
  var item;
  item = new CheckboxItem_0;
  $isCreated_2(item)?$setProperty_8(item, 'title', ' '):(item.jsObj['title'] = ' ' , undefined);
  return item;
}
;
_.setEditItemValue = function setEditItemValue_0(editItem, value){
  var convertedValue, str;
  value == null && (value = ($clinit_Boolean() , FALSE));
  if (instanceOf(value, Q$Boolean)) {
    convertedValue = dynamicCast(value, Q$Boolean).value_0;
  }
   else {
    str = toString__devirtual$(value);
    $equalsIgnoreCase(str, 'yes')?(convertedValue = true):$equalsIgnoreCase(str, 'no')?(convertedValue = false):(convertedValue = ($clinit_Boolean() , $equalsIgnoreCase('true', str)));
  }
  editItem.setValue_6(convertedValue);
  return $clinit_Boolean() , convertedValue?TRUE:FALSE;
}
;
_.setStaticItemValue = function setStaticItemValue_0(staticItem, value){
  var convertedValue;
  instanceOf(value, Q$Boolean)?dynamicCast(value, Q$Boolean).value_0?(convertedValue = 'Yes'):(convertedValue = 'No'):(convertedValue = toString__devirtual$(value));
  $setValue_7(staticItem, convertedValue);
  return convertedValue;
}
;
function $setColorSelectedHandler(this$static, handler){
  this$static.colorSelectedHandler = handler;
}

function $setCurrentColor(this$static, color){
  this$static.currentColor = color;
}

function ColorButtonItem_0(title){
  ButtonItem_1.call(this, 'colorButton', title);
  $setPrompt_2(this, ($clinit_CoreGUI() , 'Click to select a new color'));
  $addClickHandler_1(this, new ColorButtonItem$1_0(this));
}

defineSeed(2288, 488, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), ColorButtonItem_0);
_.colorSelectedHandler = null;
_.currentColor = null;
function ColorButtonItem$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2289, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), ColorButtonItem$1_0);
_.onClick_0 = function onClick_74(event_0){
  var picker;
  picker = new ColorPicker_0;
  $setAttribute_22(picker, 'allowComplexMode', ($clinit_Boolean() , $clinit_Boolean() , FALSE), false);
  this.this$0.currentColor != null && $setAttribute_24(picker, 'defaultColor', this.this$0.currentColor, false);
  $addColorSelectedHandler(picker, new ColorButtonItem$1$1_0(this));
  $show(picker);
}
;
_.this$0 = null;
function ColorButtonItem$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2290, 1, makeCastMap([Q$EventHandler, Q$ColorSelectedHandler]), ColorButtonItem$1$1_0);
_.onColorSelected = function onColorSelected(event_0){
  !!this.this$1.this$0.colorSelectedHandler && $onColorSelected(this.this$1.this$0.colorSelectedHandler, event_0);
  this.this$1.this$0.currentColor = $getColor_0(event_0);
}
;
_.this$1 = null;
function $getValueAsDays(this$static){
  return !$getValueAsDate(this$static)?null:valueOf_44(getDaysBetween(new Date_1, $getValueAsDate(this$static)));
}

function DateFilterItem_0(name_0, title){
  FormItem_0.call(this);
  $isCreated_2(this)?$setProperty_8(this, 'name', name_0):(this.jsObj['name'] = name_0 , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'title', title):(this.jsObj['title'] = title , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'editorType', 'DateItem'):(this.jsObj['editorType'] = 'DateItem' , undefined);
  $setUseTextField(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_29(this, 'enforceDate', TRUE);
  $setAttribute_31(this, 'endDate', new Date_1);
}

defineSeed(2291, 493, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers, Q$DateFilterItem]), DateFilterItem_0);
_.getValue_1 = function getValue_49(){
  return !$getValueAsDate(this)?null:valueOf_44(getDaysBetween(new Date_1, $getValueAsDate(this)));
}
;
_.toString$ = function toString_201(){
  return '' + (!$getValueAsDate(this)?null:valueOf_44(getDaysBetween(new Date_1, $getValueAsDate(this))));
}
;
function $getValue_5(this$static){
  var date;
  date = $getValueAsDate(this$static);
  if (date)
    return valueOf_45(date.getTime_0());
  return null;
}

function DateTimeFilterItem_0(name_0, title){
  DateTimeItem_1.call(this, name_0, title);
  $setUseTextField_0(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setEnforceDate(this, TRUE);
  $setEndDate_0(this, new Date_1);
}

defineSeed(2292, 495, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$DateTimeItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), DateTimeFilterItem_0);
_.getValue_1 = function getValue_50(){
  return $getValue_5(this);
}
;
_.toString$ = function toString_202(){
  return '' + $getValue_5(this);
}
;
function $clinit_DurationItem(){
  $clinit_DurationItem = nullMethod;
  $clinit_CoreGUI();
}

function $calculateValue(this$static){
  var $e0, convertedValue, integerValue, unit, value, valueItem;
  valueItem = dynamicCast($getField_0(this$static.form_0, 'value'), Q$IntegerItem);
  value = $getValue_0(valueItem);
  try {
    integerValue = toLong(value);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$NumberFormatException)) {
      return null;
    }
     else 
      throw $e0;
  }
  convertedValue = null;
  if (integerValue) {
    unit = $getInputTimeUnit(this$static);
    if (!unit) {
      this$static.unitType = ($clinit_UnitType() , ITERATIONS);
      convertedValue = integerValue;
    }
     else {
      this$static.unitType = ($clinit_UnitType() , TIME_3);
      if ($compareTo(unit, this$static.valueUnit) < 0) {
        throw new IllegalStateException_1('Input unit is less than target unit.');
      }
      switch (unit.ordinal) {
        case 0:
          this$static.valueUnit.ordinal == 0 && (convertedValue = integerValue);
          break;
        case 1:
          switch (this$static.valueUnit.ordinal) {
            case 1:
              convertedValue = integerValue;
              break;
            case 0:
              convertedValue = valueOf_45(mul(integerValue.value_0, P3e8_longLit));
          }

          break;
        case 2:
          switch (this$static.valueUnit.ordinal) {
            case 2:
              convertedValue = integerValue;
              break;
            case 1:
              convertedValue = valueOf_45(mul(integerValue.value_0, P3c_longLit));
              break;
            case 0:
              convertedValue = valueOf_45(mul(integerValue.value_0, Pea60_longLit));
          }

          break;
        case 3:
          switch (this$static.valueUnit.ordinal) {
            case 3:
              convertedValue = integerValue;
              break;
            case 2:
              convertedValue = valueOf_45(mul(integerValue.value_0, P3c_longLit));
              break;
            case 1:
              convertedValue = valueOf_45(mul(mul(integerValue.value_0, P3c_longLit), P3c_longLit));
              break;
            case 0:
              convertedValue = valueOf_45(mul(integerValue.value_0, P36ee80_longLit));
          }

          break;
        case 4:
          switch (this$static.valueUnit.ordinal) {
            case 4:
              convertedValue = integerValue;
              break;
            case 3:
              convertedValue = valueOf_45(mul(integerValue.value_0, P18_longLit));
              break;
            case 2:
              convertedValue = valueOf_45(mul(mul(integerValue.value_0, P18_longLit), P3c_longLit));
              break;
            case 1:
              convertedValue = valueOf_45(mul(mul(mul(integerValue.value_0, P18_longLit), P3c_longLit), P3c_longLit));
              break;
            case 0:
              convertedValue = valueOf_45(mul(integerValue.value_0, P5265c00_longLit));
          }

          break;
        case 5:
          switch (this$static.valueUnit.ordinal) {
            case 5:
              convertedValue = integerValue;
              break;
            case 4:
              convertedValue = valueOf_45(mul(integerValue.value_0, P7_longLit));
              break;
            case 3:
              convertedValue = valueOf_45(mul(mul(integerValue.value_0, P7_longLit), P18_longLit));
              break;
            case 2:
              convertedValue = valueOf_45(mul(mul(mul(integerValue.value_0, P7_longLit), P18_longLit), P3c_longLit));
              break;
            case 1:
              convertedValue = valueOf_45(mul(mul(mul(mul(integerValue.value_0, P7_longLit), P18_longLit), P3c_longLit), P3c_longLit));
              break;
            case 0:
              convertedValue = valueOf_45(mul(integerValue.value_0, P240c8400_longLit));
          }

          break;
        case 6:
          switch (this$static.valueUnit.ordinal) {
            case 6:
              convertedValue = integerValue;
              break;
            case 5:
              convertedValue = valueOf_45(mul(integerValue.value_0, P4_longLit));
              break;
            case 4:
              convertedValue = valueOf_45(mul(integerValue.value_0, P1e_longLit));
              break;
            case 3:
              convertedValue = valueOf_45(mul(mul(integerValue.value_0, P1e_longLit), P18_longLit));
              break;
            case 2:
              convertedValue = valueOf_45(mul(mul(mul(integerValue.value_0, P1e_longLit), P18_longLit), P3c_longLit));
              break;
            case 1:
              convertedValue = valueOf_45(mul(mul(mul(mul(integerValue.value_0, P1e_longLit), P18_longLit), P3c_longLit), P3c_longLit));
              break;
            case 0:
              convertedValue = valueOf_45(mul(integerValue.value_0, P9a7ec800_longLit));
          }

          break;
        case 7:
          switch (this$static.valueUnit.ordinal) {
            case 7:
              convertedValue = integerValue;
              break;
            case 6:
              convertedValue = valueOf_45(mul(integerValue.value_0, Pc_longLit));
              break;
            case 5:
              convertedValue = valueOf_45(mul(integerValue.value_0, P34_longLit));
              break;
            case 4:
              convertedValue = valueOf_45(mul(integerValue.value_0, P16d_longLit));
              break;
            case 3:
              convertedValue = valueOf_45(mul(mul(integerValue.value_0, P16d_longLit), P18_longLit));
              break;
            case 2:
              convertedValue = valueOf_45(mul(mul(mul(integerValue.value_0, P16d_longLit), P18_longLit), P3c_longLit));
              break;
            case 1:
              convertedValue = valueOf_45(mul(mul(mul(mul(integerValue.value_0, P16d_longLit), P18_longLit), P3c_longLit), P3c_longLit));
              break;
            case 0:
              convertedValue = valueOf_45(mul(integerValue.value_0, P757b12c00_longLit));
          }

      }
    }
  }
  return convertedValue;
}

function $formatMilliseconds(this$static, longValue){
  var formattedOutput, wholeUnits;
  if (lt(longValue, P0_longLit)) {
    throw new IllegalArgumentException_1('negative time period ' + toString_8(longValue));
  }
  if (lt(longValue, P3e8_longLit)) {
    return toString_8(longValue) + ' ' + $getDisplayName(($clinit_TimeUnit() , MILLISECONDS_0));
  }
   else if (lt(longValue, Pea60_longLit)) {
    wholeUnits = div(longValue, P3e8_longLit);
    formattedOutput = toString_8(wholeUnits) + ' ' + $getDisplayName(($clinit_TimeUnit() , SECONDS_0));
    return formattedOutput + (lt(mul(wholeUnits, P3e8_longLit), longValue)?' ' + $formatMilliseconds(this$static, sub(longValue, mul(wholeUnits, P3e8_longLit))):'');
  }
   else if (lt(longValue, P36ee80_longLit)) {
    wholeUnits = div(longValue, Pea60_longLit);
    formattedOutput = toString_8(wholeUnits) + ' ' + $getDisplayName(($clinit_TimeUnit() , MINUTES_1));
    return formattedOutput + (lt(mul(wholeUnits, Pea60_longLit), longValue)?' ' + $formatMilliseconds(this$static, sub(longValue, mul(wholeUnits, Pea60_longLit))):'');
  }
   else if (lt(longValue, P5265c00_longLit)) {
    wholeUnits = div(longValue, P36ee80_longLit);
    formattedOutput = toString_8(wholeUnits) + ' ' + $getDisplayName(($clinit_TimeUnit() , HOURS_1));
    return formattedOutput + (lt(mul(wholeUnits, P36ee80_longLit), longValue)?' ' + $formatMilliseconds(this$static, sub(longValue, mul(wholeUnits, P36ee80_longLit))):'');
  }
   else if (lt(longValue, P240c8400_longLit)) {
    wholeUnits = div(longValue, P5265c00_longLit);
    formattedOutput = toString_8(wholeUnits) + ' ' + $getDisplayName(($clinit_TimeUnit() , DAYS_2));
    return formattedOutput + (lt(mul(wholeUnits, P5265c00_longLit), longValue)?' ' + $formatMilliseconds(this$static, sub(longValue, mul(wholeUnits, P5265c00_longLit))):'');
  }
   else if (lt(longValue, P9a7ec800_longLit)) {
    wholeUnits = div(longValue, P240c8400_longLit);
    formattedOutput = toString_8(wholeUnits) + ' ' + $getDisplayName(($clinit_TimeUnit() , WEEKS_0));
    return formattedOutput + (lt(mul(wholeUnits, P240c8400_longLit), longValue)?' ' + $formatMilliseconds(this$static, sub(longValue, mul(wholeUnits, P240c8400_longLit))):'');
  }
   else if (lt(longValue, P757b12c00_longLit)) {
    wholeUnits = div(longValue, P9a7ec800_longLit);
    formattedOutput = toString_8(wholeUnits) + ' ' + $getDisplayName(($clinit_TimeUnit() , MONTHS_0));
    return formattedOutput + (lt(mul(wholeUnits, P9a7ec800_longLit), longValue)?' ' + $formatMilliseconds(this$static, sub(longValue, mul(wholeUnits, P9a7ec800_longLit))):'');
  }
   else if (gte_0(longValue, P757b12c00_longLit)) {
    wholeUnits = div(longValue, P757b12c00_longLit);
    formattedOutput = toString_8(wholeUnits) + ' ' + $getDisplayName(($clinit_TimeUnit() , YEARS));
    return formattedOutput + (lt(mul(wholeUnits, P757b12c00_longLit), longValue)?' ' + $formatMilliseconds(this$static, sub(longValue, mul(wholeUnits, P757b12c00_longLit))):'');
  }
   else {
    return '';
  }
}

function $getInputTimeUnit(this$static){
  var $e0, unit, unitString, unitsItem;
  unitsItem = dynamicCast($getField_0(this$static.form_0, 'units'), Q$ComboBoxItem);
  unitString = $getValueAsString_2(unitsItem);
  try {
    unit = valueOf_135(unitString.toUpperCase());
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$IllegalArgumentException)) {
      unit = null;
    }
     else 
      throw $e0;
  }
  return unit;
}

function $setAndFormatValue(this$static, longValue){
  var formattedOutput;
  if (lt(longValue, P0_longLit)) {
    throw new IllegalArgumentException_1('negative time period ' + toString_8(longValue));
  }
  formattedOutput = $formatMilliseconds(this$static, longValue);
  this$static.unitType = ($clinit_UnitType() , TIME_3);
  $setValue_0(this$static.form_0, 'value', formattedOutput);
  $setValue_7(this$static, formattedOutput);
}

function $setContextualHelp(this$static, contextualHelp){
  var item;
  if (contextualHelp != null) {
    this$static.isReadOnly?(item = $getField_0(this$static.form_0, 'value')):(item = $getField_0(this$static.form_0, 'units'));
    addContextualHelp(item, contextualHelp, null);
  }
}

function $setValue_14(this$static, value, unitType){
  var stringValue, unitString;
  if (!$contains_1(this$static.supportedUnitTypes, unitType)) {
    throw new IllegalArgumentException_1('Unit type [' + unitType.name_0 + '] is not supported by this DurationItem.');
  }
  this$static.unitType = unitType;
  unitString = null;
  switch (unitType.ordinal) {
    case 0:
      unitString = $getDisplayName(this$static.valueUnit);
      break;
    case 1:
      unitString = 'times';
  }
  if (this$static.isReadOnly) {
    !value?(stringValue = ''):(stringValue = value + ' ' + unitString);
    $setValue_0(this$static.form_0, 'value', stringValue);
  }
   else {
    value?$setValue(this$static.form_0, 'value', value.value_0):$setValue_0(this$static.form_0, 'value', null);
    $setValue_0(this$static.form_0, 'units', unitString);
  }
  !value?$setValue_7(this$static, null):value?$setValue_5(this$static, value.value_0):$doSetValue(this$static, null);
}

function $updateValue(this$static){
  var value;
  value = $calculateValue(this$static);
  !value?$setValue_7(this$static, null):value?$setValue_5(this$static, toInt(value.value_0)):$doSetValue(this$static, null);
}

function DurationItem_0(name_0, title, supportedUnits, supportsIterations, isReadOnly){
  $clinit_DurationItem();
  DurationItem_1.call(this, name_0, title, !!supportedUnits && supportedUnits.map.size_0 != 0?dynamicCast($next_1($iterator($keySet(supportedUnits.map))), Q$TimeUnit):null, supportedUnits, supportsIterations, isReadOnly);
}

function DurationItem_1(name_0, title, valueUnit, supportedUnits, supportsIterations, isReadOnly){
  $clinit_DurationItem();
  var integerRangeValidator, staticTextItem, unit, unit$iterator, unitsItem, valueItem, valueMap;
  CanvasItem_2.call(this, name_0, title);
  this.valueUnit = valueUnit;
  this.supportedUnitTypes = noneOf(Lorg_rhq_enterprise_gui_coregui_client_components_form_UnitType_2_classLit);
  if (!!supportedUnits && supportedUnits.map.size_0 != 0) {
    $add_5(this.supportedUnitTypes, ($clinit_UnitType() , TIME_3));
    !this.valueUnit && (this.valueUnit = dynamicCast($next_1($iterator($keySet(supportedUnits.map))), Q$TimeUnit));
  }
  supportsIterations && $add_5(this.supportedUnitTypes, ($clinit_UnitType() , ITERATIONS));
  this.isReadOnly = isReadOnly;
  this.form_0 = new EnhancedDynamicForm_2(false, false);
  if (this.isReadOnly) {
    $setNumCols(this.form_0, 2);
    $setColWidths(this.form_0, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['140', '160']));
    staticTextItem = new StaticTextItem_2('value', title);
    $setShowTitle_0(staticTextItem, $isCreated_2(this)?$getPropertyAsBoolean(this, 'showTitle'):($clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'showTitle')?TRUE:FALSE));
    $setFields_3(this.form_0, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [staticTextItem]));
  }
   else {
    $setNumCols(this.form_0, 4);
    $setColWidths(this.form_0, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['140', '90', '105', '*']));
    valueItem = new IntegerItem_1(title);
    $setShowTitle_0(valueItem, $isCreated_2(this)?$getPropertyAsBoolean(this, 'showTitle'):($clinit_Boolean() , getAttributeAsBoolean(this.jsObj, 'showTitle')?TRUE:FALSE));
    $setValue_6(valueItem, $getValue_0(this));
    integerRangeValidator = new IntegerRangeValidator_0;
    integerRangeValidator.jsObj['min'] = 1;
    integerRangeValidator.jsObj['max'] = 2147483647;
    $isCreated_2(valueItem)?$setProperty_7(valueItem, 'validators', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [integerRangeValidator]))):(valueItem.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [integerRangeValidator])) , undefined);
    $setValidateOnChange_0(valueItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $addChangedHandler(valueItem, new DurationItem$1_0(this));
    unitsItem = new ComboBoxItem_1('units');
    $setShowTitle_0(unitsItem, FALSE);
    valueMap = new LinkedHashMap_0;
    $contains_1(this.supportedUnitTypes, ($clinit_UnitType() , ITERATIONS)) && $put_1(valueMap, 'times', 'times');
    if ($contains_1(this.supportedUnitTypes, TIME_3)) {
      for (unit$iterator = $iterator($keySet(supportedUnits.map)); unit$iterator.val$outerIter.hasNext();) {
        unit = dynamicCast($next_1(unit$iterator), Q$TimeUnit);
        $put_1(valueMap, unit.name_0.toLowerCase(), $getDisplayName(unit));
      }
    }
    $isCreated_2(unitsItem)?$setValueMapMethod(unitsItem, convertMapToJavascriptObject(valueMap)):$isCreated_2(unitsItem)?$setProperty_7(unitsItem, 'valueMap', convertMapToJavascriptObject(valueMap)):(unitsItem.jsObj['valueMap'] = convertMapToJavascriptObject(valueMap) , undefined);
    $setDefaultToFirstOption(unitsItem, TRUE);
    $addChangedHandler(unitsItem, new DurationItem$2_0(this));
    $setFields_3(this.form_0, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [valueItem, unitsItem]));
    $isCreated_2(valueItem)?$setProperty_6(valueItem, 'width', 90):(valueItem.jsObj['width'] = 90 , undefined);
    $isCreated_2(unitsItem)?$setProperty_6(unitsItem, 'width', 105):(unitsItem.jsObj['width'] = 105 , undefined);
  }
  $setCanvas(this, this.form_0);
}

defineSeed(2293, 489, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers, Q$DurationItem]), DurationItem_0, DurationItem_1);
_.setValidateOnChange = function setValidateOnChange_0(validateOnChange){
  $setValidateOnChange(this.form_0, validateOnChange);
}
;
_.setValidateOnExit = function setValidateOnExit_0(validateOnExit){
  $setValidateOnChange(this.form_0, validateOnExit);
}
;
_.toString$ = function toString_203(){
  var string, timeUnit, unitString, value;
  value = $getValue(this.form_0, 'value');
  if (value != null) {
    timeUnit = $getInputTimeUnit(this);
    unitString = timeUnit?timeUnit.name_0.toLowerCase():'times';
    string = value + ' ' + unitString;
  }
   else {
    string = '';
  }
  return string;
}
;
_.validate_1 = function validate_8(){
  return $clinit_Boolean() , $validate(this.form_0)?TRUE:FALSE;
}
;
_.form_0 = null;
_.isReadOnly = false;
_.supportedUnitTypes = null;
_.unitType = null;
_.valueUnit = null;
function DurationItem$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2294, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DurationItem$1_0);
_.onChanged = function onChanged_41(event_0){
  $updateValue(this.this$0);
}
;
_.this$0 = null;
function DurationItem$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2295, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DurationItem$2_0);
_.onChanged = function onChanged_42(event_0){
  $updateValue(this.this$0);
}
;
_.this$0 = null;
function EditableFormItem$1_0(this$0, val$blankIcon){
  this.this$0 = this$0;
  this.val$blankIcon = val$blankIcon;
}

defineSeed(2296, 1, makeCastMap([Q$EventHandler, Q$MouseOutHandler]), EditableFormItem$1_0);
_.onMouseOut = function onMouseOut(event_0){
  if (!this.this$0.editing) {
    $setIcons(this.this$0.staticItem, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [this.val$blankIcon]));
    $markForRedraw_1(this.this$0);
  }
}
;
_.this$0 = null;
_.val$blankIcon = null;
function EditableFormItem$2_0(this$0, val$editIcon){
  this.this$0 = this$0;
  this.val$editIcon = val$editIcon;
}

defineSeed(2297, 1, makeCastMap([Q$EventHandler, Q$MouseOverHandler]), EditableFormItem$2_0);
_.onMouseOver = function onMouseOver(event_0){
  if (!this.this$0.editing && !this.this$0.readOnly) {
    $setIcons(this.this$0.staticItem, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [this.val$editIcon]));
    $markForRedraw_1(this.this$0);
  }
}
;
_.this$0 = null;
_.val$editIcon = null;
function EditableFormItem$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2298, 1, {}, EditableFormItem$3_0);
_.execute_6 = function execute_39(item, value, form){
  return !this.this$0.editing;
}
;
_.this$0 = null;
function EditableFormItem$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2299, 1, {}, EditableFormItem$4_0);
_.execute_6 = function execute_40(item, value, form){
  return this.this$0.editing;
}
;
_.this$0 = null;
function EditableFormItem$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2300, 1, makeCastMap([Q$EventHandler, Q$KeyPressHandler_0]), EditableFormItem$5_0);
_.onKeyPress = function onKeyPress_2(event_0){
  var newValue, jsObj;
  if (!!$getCharacterValue(event_0) && $getCharacterValue(event_0).value_0 == 13) {
    if ($validate_0(this.this$0.innerForm, false).value_0) {
      newValue = (jsObj = event_0.jsObj , getOrCreateRef_6(jsObj.item)).getValue_1();
      $setApprovedNewValue(this.this$0, newValue);
      $switchToStaticMode(this.this$0);
    }
  }
}
;
_.this$0 = null;
function EditableFormItem$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2301, 1, makeCastMap([Q$EventHandler, Q$FormItemClickHandler]), EditableFormItem$6_0);
_.onFormItemClick = function onFormItemClick_1(event_0){
  this.this$0.readOnly || $switchToEditMode(this.this$0);
}
;
_.this$0 = null;
function EditableFormItem$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2302, 1, makeCastMap([Q$EventHandler, Q$FormItemClickHandler]), EditableFormItem$7_0);
_.onFormItemClick = function onFormItemClick_2(event_0){
  var newValue, jsObj;
  if ($validate_0(this.this$0.innerForm, false).value_0) {
    newValue = (jsObj = event_0.jsObj , getOrCreateRef_6(jsObj.item)).getValue_1();
    $setApprovedNewValue(this.this$0, newValue);
    $switchToStaticMode(this.this$0);
  }
}
;
_.this$0 = null;
function EditableFormItem$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2303, 1, makeCastMap([Q$EventHandler, Q$FormItemClickHandler]), EditableFormItem$8_0);
_.onFormItemClick = function onFormItemClick_3(event_0){
  $switchToStaticMode(this.this$0);
}
;
_.this$0 = null;
function $setFields_3(this$static, items){
  var displayValue, hasIdField, idItem, item, item$index, item$iterator, item$max, itemsList, outputAsHtml, showTitle, staticItem, valueMap;
  itemsList = new ArrayList_0;
  hasIdField = false;
  for (item$index = 0 , item$max = items.length; item$index < item$max; ++item$index) {
    item = items[item$index];
    $equals_6($isCreated_2(item)?$getPropertyAsString(item, 'name'):getAttribute(item.jsObj, 'name'), 'id') && (hasIdField = true);
    if (this$static.isReadOnly) {
      if (instanceOf(item, Q$StaticTextItem) || instanceOf(item, Q$CanvasItem) || instanceOf(item, Q$SpacerItem)) {
        instanceOf(item, Q$EditableFormItem) && $setReadOnly_2(dynamicCast(item, Q$EditableFormItem));
        setCheck(itemsList.array, itemsList.size_0++, item);
      }
       else {
        staticItem = new StaticTextItem_2($isCreated_2(item)?$getPropertyAsString(item, 'name'):getAttribute(item.jsObj, 'name'), item.getTitle());
        showTitle = ($clinit_Boolean() , !item.getShowTitle() || item.getShowTitle().value_0?TRUE:FALSE);
        $isCreated_2(staticItem)?$setProperty_9(staticItem, 'showTitle', showTitle.value_0):setAttribute_5(staticItem.jsObj, 'showTitle', showTitle);
        $setPrompt_1(staticItem, item.getPrompt());
        displayValue = $getDisplayValue(item);
        $setValue_7(staticItem, displayValue);
        $setColSpan_0(staticItem, $isCreated_2(item)?$getPropertyAsString(item, 'colSpan'):getAttribute(item.jsObj, 'colSpan'));
        outputAsHtml = $isCreated_2(item)?$getPropertyAsBoolean(item, 'outputAsHTML'):getAttributeAsBoolean(item.jsObj, 'outputAsHTML')?TRUE:FALSE;
        $equals_2(TRUE, outputAsHtml) && null != displayValue && !!displayValue.length && $setEscapeHTML(staticItem, TRUE);
        if (instanceOf(item, Q$CheckboxItem)) {
          valueMap = new LinkedHashMap_0;
          $put_1(valueMap, 'true', 'Yes');
          $put_1(valueMap, 'false', 'No');
          $isCreated_2(staticItem)?$setValueMapMethod(staticItem, convertMapToJavascriptObject(valueMap)):$isCreated_2(staticItem)?$setProperty_7(staticItem, 'valueMap', convertMapToJavascriptObject(valueMap)):(staticItem.jsObj['valueMap'] = convertMapToJavascriptObject(valueMap) , undefined);
        }
        setCheck(itemsList.array, itemsList.size_0++, staticItem);
      }
    }
     else {
      setCheck(itemsList.array, itemsList.size_0++, item);
    }
  }
  if (!hasIdField && !!getOrCreateRef($getAttributeAsJavaScriptObject_1(this$static, 'dataSource')) && !!$getField(getOrCreateRef($getAttributeAsJavaScriptObject_1(this$static, 'dataSource')), 'id')) {
    !!$isNewRecord(this$static) && $isNewRecord(this$static).value_0 || ($clinit_CoreGUI() , true)?(idItem = new HiddenItem_0('id')):(idItem = new StaticTextItem_2('id', 'ID'));
    $add_2(itemsList, 0, idItem);
  }
  for (item$iterator = new AbstractList$IteratorImpl_0(itemsList); item$iterator.i < item$iterator.this$0_0.size_1();) {
    item = dynamicCast($next_0(item$iterator), Q$FormItem);
    instanceOf(item, Q$StaticTextItem)?$setRequired(item, ($clinit_Boolean() , $clinit_Boolean() , FALSE)):item.setValidateOnExit(($clinit_Boolean() , $clinit_Boolean() , TRUE));
    item.setWidth(195);
  }
  $setFields_0(this$static, dynamicCast($toArray_1(itemsList, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, itemsList.size_0, 0)), Q$FormItem_$1));
}

function EnhancedDynamicForm_0(){
  EnhancedDynamicForm_1.call(this, false);
}

function EnhancedDynamicForm_1(readOnly){
  $clinit_BaseWidget();
  EnhancedDynamicForm_2.call(this, readOnly, false);
}

function EnhancedDynamicForm_2(readOnly, isNewRecord){
  $clinit_BaseWidget();
  DynamicForm_0.call(this);
  $clinit_CoreGUI();
  this.isReadOnly = readOnly;
  isNewRecord && $setAttribute_24(this, 'saveOperationType', ($clinit_DSOperationType() , ADD).value_0, true);
  $isCreated_1(this)?$setProperty_0(this, 'cellPadding', 3):(this.config_0['cellPadding'] = 3 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'numCols', 4):(this.config_0['numCols'] = 4 , undefined);
  $setColWidths(this, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [valueOf_44(75), valueOf_44(200), valueOf_44(75), valueOf_44(200)]));
  $setWrapItemTitles(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  if (readOnly) {
    $setHiliteRequiredFields(this, FALSE);
  }
   else {
    $setHiliteRequiredFields(this, TRUE);
    $isCreated_1(this)?$setProperty_3(this, 'requiredTitleSuffix', " <span class='requiredFieldMarker'>*<\/span> :"):(this.config_0['requiredTitleSuffix'] = " <span class='requiredFieldMarker'>*<\/span> :" , undefined);
  }
  $setAttribute_22(this, 'useAllDataSourceFields', FALSE, true);
  $setAutoFetchData(this, FALSE);
  $setStopOnError(this, FALSE);
}

defineSeed(2304, 478, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), EnhancedDynamicForm_0, EnhancedDynamicForm_1, EnhancedDynamicForm_2);
_.setFields = function setFields_0(items){
  $setFields_3(this, items);
}
;
_.isReadOnly = false;
defineSeed(2305, 489, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers, Q$EnhancedSearchBarItem]));
_.getCanvas = function getCanvas_13(){
  return this.searchBar;
}
;
function $getEnumValueMap(e, valueMap){
  var map, name_0, o, o$iterator;
  map = valueMap?valueMap:new LinkedHashMap_0;
  for (o$iterator = new EnumSet$EnumSetImpl$IteratorImpl_0(allOf(e)); o$iterator.i < o$iterator.this$1.all.length;) {
    o = $next_3(o$iterator);
    name_0 = o.name_0;
    map.map.containsKey(name_0) || $put_1(map, name_0, o.toString$());
  }
  return map;
}

function $init_5(this$static, e, valueMap, valueIcons){
  var keys;
  $setMultiple(this$static, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_30(this$static, 'multipleAppearance', ($clinit_MultipleAppearance() , PICKLIST).value_0);
  valueMap = $getEnumValueMap(e, valueMap);
  keys = $keySet(valueMap);
  $isCreated_2(this$static)?$setValueMapMethod(this$static, convertMapToJavascriptObject(valueMap)):$isCreated_2(this$static)?$setProperty_7(this$static, 'valueMap', convertMapToJavascriptObject(valueMap)):(this$static.jsObj['valueMap'] = convertMapToJavascriptObject(valueMap) , undefined);
  $setValues(this$static, dynamicCast(keys.toArray_0(initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, keys.val$entrySet.size_1(), 0)), Q$String_$1));
  !!valueIcons && ($isCreated_2(this$static)?$setProperty_7(this$static, 'valueIcons', convertMapToJavascriptObject(valueIcons)):(this$static.jsObj['valueIcons'] = convertMapToJavascriptObject(valueIcons) , undefined));
}

function EnumSelectItem_0(name_0, title, e, valueMap, valueIcons){
  $clinit_SelectItem();
  SelectItem_2.call(this, name_0, title);
  $init_5(this, e, valueMap, valueIcons);
}

defineSeed(2306, 512, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$SelectItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), EnumSelectItem_0);
function IsLongValidator_0(){
  CustomValidator_0.call(this);
  this.jsObj['errorMessage'] = 'Must be an integer between -9,223,372,036,854,775,808 and 9,223,372,036,854,775,807.';
}

function stripOffNegativeSignAndLeadingZeroes(stringValue, negative){
  var charsToSkip, i;
  charsToSkip = 0;
  negative && ++charsToSkip;
  for (i = charsToSkip; i < stringValue.length - 1; ++i) {
    if (stringValue.charCodeAt(i) == 48) {
      ++charsToSkip;
    }
     else {
      break;
    }
  }
  return $substring(stringValue, charsToSkip);
}

defineSeed(2307, 528, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), IsLongValidator_0);
_.condition_1 = function condition_2(value){
  var baseStringValue, isNegative, isValid, normalizedValue, stringValue;
  if (value == null) {
    return true;
  }
  stringValue = $trim(toString__devirtual$(value));
  if (stringValue.length == 0) {
    this.formItem?this.formItem.setValue_4(stringValue):!!this.record_0 && !!this.dataSourceField && $setAttribute_13(this.record_0, $getAttributeAsString(this.dataSourceField, 'name'), stringValue);
    return true;
  }
  isNegative = stringValue.charCodeAt(0) == 45;
  if (isNegative && stringValue.length == 1) {
    return false;
  }
  baseStringValue = stripOffNegativeSignAndLeadingZeroes(stringValue, isNegative);
  isNegative?(normalizedValue = '-' + baseStringValue):(normalizedValue = baseStringValue);
  this.formItem?this.formItem.setValue_4(normalizedValue):!!this.record_0 && !!this.dataSourceField && $setAttribute_13(this.record_0, $getAttributeAsString(this.dataSourceField, 'name'), normalizedValue);
  if ($equals_6(baseStringValue, '0')) {
    return true;
  }
  if (baseStringValue.length > 19) {
    return false;
  }
  if (baseStringValue.length == 19 && baseStringValue.charCodeAt(0) == 57) {
    if (isNegative) {
      isValid = $matches(baseStringValue, '[9][0-2][0-2][0-3][0-3][0-7][0-2][0][0-3][0-6][0-8][0-5][0-4][0-7][0-7][0-5][0-8][0][0-8]');
      return isValid;
    }
     else {
      isValid = $matches(baseStringValue, '[9][0-2][0-2][0-3][0-3][0-7][0-2][0][0-3][0-6][0-8][0-5][0-4][0-7][0-7][0-5][0-8][0][0-7]');
      return isValid;
    }
  }
  isValid = $matches(baseStringValue, '[1-9]?[0-9]{0,18}');
  return isValid;
}
;
function NumberWithUnitsValidator_0(metricDefs, metricDropDownMenu){
  CustomValidator_0.call(this);
  if (!metricDefs) {
    throw new NullPointerException_1('metricDefs == null');
  }
  if (!metricDropDownMenu) {
    throw new NullPointerException_1('metricDropDownMenu == null');
  }
  this.metricDefs = metricDefs;
  this.metricDropDownMenu = metricDropDownMenu;
  this.units = null;
}

function NumberWithUnitsValidator_1(units){
  CustomValidator_0.call(this);
  if (!units) {
    throw new NullPointerException_1('units == null');
  }
  this.metricDefs = null;
  this.metricDropDownMenu = null;
  this.units = units;
}

defineSeed(2308, 528, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), NumberWithUnitsValidator_0, NumberWithUnitsValidator_1);
_.condition_1 = function condition_3(value){
  var $e0, id, idString, metricDef, metricDef$iterator, unitsToUse;
  if (value == null || $trim(toString__devirtual$(value)).length == 0) {
    return true;
  }
  unitsToUse = this.units;
  if (!unitsToUse) {
    try {
      idString = $getValueAsString_4(this.metricDropDownMenu);
      id = valueOf_44(__parseAndValidateInt(idString));
      for (metricDef$iterator = this.metricDefs.iterator(); metricDef$iterator.hasNext();) {
        metricDef = dynamicCast(metricDef$iterator.next_0(), Q$MeasurementDefinition);
        if (metricDef.id == id.value_0) {
          unitsToUse = metricDef.units;
          break;
        }
      }
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        unitsToUse = null;
      }
       else 
        throw $e0;
    }
  }
  if (unitsToUse) {
    try {
      return !!parse(toString__devirtual$(value), unitsToUse);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        return false;
      }
       else 
        throw $e0;
    }
  }
   else {
    try {
      __parseAndValidateDouble(toString__devirtual$(value));
      return true;
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        return false;
      }
       else 
        throw $e0;
    }
  }
}
;
_.metricDefs = null;
_.metricDropDownMenu = null;
_.units = null;
function $destroyComponents(this$static){
  var $e0, canvas, canvas$iterator;
  for (canvas$iterator = $iterator_0($values(this$static.valueMap)); canvas$iterator.val$outerIter.hasNext();) {
    canvas = dynamicCast($next_2(canvas$iterator), Q$Canvas);
    try {
      canvas.destroy_0();
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (!instanceOf($e0, Q$Throwable))
        throw $e0;
    }
  }
}

function $getSelectedComponent(this$static){
  if (null == this$static.selected) {
    return null;
  }
  return dynamicCast($get_4(this$static.valueMap, new RadioGroupWithComponentsItem$NameAndTitle_0(this$static.selected)), Q$Canvas);
}

function $getSelectedIndex(this$static){
  var idx, t, t$iterator;
  if (this$static.selected == null) {
    return -1;
  }
  idx = 0;
  for (t$iterator = $iterator($keySet(this$static.valueMap)); t$iterator.val$outerIter.hasNext();) {
    t = dynamicCast($next_1(t$iterator), Q$RadioGroupWithComponentsItem$NameAndTitle);
    if ($equals_6(this$static.selected, t.title_0)) {
      break;
    }
    ++idx;
  }
  return idx;
}

function $setSelected(this$static, selected){
  var radio;
  radio = dynamicCast($getField_0(this$static.canvas_0, getSafeId(selected)), Q$RadioGroupItem);
  if (radio) {
    this$static.selected = selected;
    $setValue_7(radio, selected);
    $updateEnablement(this$static.canvas_0);
    $markForRedraw(this$static.form_0);
  }
}

function RadioGroupWithComponentsItem_0(name_0, title, valueMap, form){
  var entry, entry$iterator;
  CanvasItem_2.call(this, name_0, title);
  this.valueMap = new LinkedHashMap_0;
  for (entry$iterator = new LinkedHashMap$EntrySet$EntryIterator_0(new LinkedHashMap$EntrySet_0(valueMap)); entry$iterator.next != entry$iterator.this$1.this$0.head;) {
    entry = $next_4(entry$iterator);
    $put_1(this.valueMap, new RadioGroupWithComponentsItem$NameAndTitle_0(dynamicCast(entry.key, Q$String)), dynamicCast(entry.value_0, Q$Canvas));
  }
  this.form_0 = form;
  this.canvas_0 = new RadioGroupWithComponentsItem$RGWCCanvas_0(this);
  this.selected = null;
  $setCanvas(this, this.canvas_0);
}

defineSeed(2309, 489, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), RadioGroupWithComponentsItem_0);
_.canvas_0 = null;
_.canvasItems = null;
_.form_0 = null;
_.selected = null;
_.valueMap = null;
function RadioGroupWithComponentsItem$NameAndTitle_0(title){
  this.name_0 = getSafeId(title);
  this.title_0 = title;
}

defineSeed(2310, 1, makeCastMap([Q$RadioGroupWithComponentsItem$NameAndTitle]), RadioGroupWithComponentsItem$NameAndTitle_0);
_.equals$ = function equals_125(other){
  var o;
  if (other === this) {
    return true;
  }
  if (!instanceOf(other, Q$RadioGroupWithComponentsItem$NameAndTitle)) {
    return false;
  }
  o = dynamicCast(other, Q$RadioGroupWithComponentsItem$NameAndTitle);
  return $equals_6(this.name_0, o.name_0);
}
;
_.hashCode$ = function hashCode_125(){
  return getHashCode_0(this.name_0);
}
;
_.name_0 = null;
_.title_0 = null;
function $clearValues(this$static, value){
  var item, item$array, item$index, item$max;
  if (!!value && instanceOf(value, Q$DynamicForm)) {
    for (item$array = $getFields(dynamicCast(value, Q$DynamicForm)) , item$index = 0 , item$max = item$array.length; item$index < item$max; ++item$index) {
      item = item$array[item$index];
      instanceOf(item, Q$CanvasItem)?$clearValues(this$static, dynamicCast(item, Q$CanvasItem).getCanvas()):$clearValue_0(item);
    }
  }
}

function $updateEnablement(this$static){
  var canvasItem, disabled, key, key$iterator, nestedCanvas;
  for (key$iterator = $iterator($keySet(this$static.this$0.canvasItems)); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$RadioGroupWithComponentsItem$NameAndTitle);
    canvasItem = dynamicCast($get_4(this$static.this$0.canvasItems, key), Q$CanvasItem);
    nestedCanvas = canvasItem.getCanvas();
    disabled = !$equals_6(this$static.this$0.selected, key.title_0);
    if (disabled) {
      $setDisabled_2(canvasItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
      $clearValues(this$static, nestedCanvas);
      $clearValue_0($getField_0(this$static.this$0.canvas_0, key.name_0));
      !!nestedCanvas && nestedCanvas.markForRedraw_0();
    }
     else {
      canvasItem.enable_0();
    }
  }
}

function RadioGroupWithComponentsItem$RGWCCanvas_0(this$0){
  $clinit_BaseWidget();
  this.this$0 = this$0;
  DynamicForm_0.call(this);
  $isCreated_1(this)?$setProperty_0(this, 'numCols', 3):(this.config_0['numCols'] = 3 , undefined);
}

defineSeed(2311, 478, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), RadioGroupWithComponentsItem$RGWCCanvas_0);
_.onInit = function onInit_33(){
  var button, ci, items, label, label$iterator, value;
  $onInit(this);
  $onInit_DynamicForm(this);
  this.this$0.canvasItems = new LinkedHashMap_0;
  items = new ArrayList_0;
  for (label$iterator = $iterator($keySet(this.this$0.valueMap)); label$iterator.val$outerIter.hasNext();) {
    label = dynamicCast($next_1(label$iterator), Q$RadioGroupWithComponentsItem$NameAndTitle);
    button = new RadioGroupItem_2(label.name_0, label.title_0);
    $setShowTitle_0(button, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setStartRow_0(button, TRUE);
    $setValueMap_0(button, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [label.title_0]));
    setCheck(items.array, items.size_0++, button);
    value = dynamicCast($get_4(this.this$0.valueMap, label), Q$Canvas);
    ci = new CanvasItem_0;
    ci.setShowTitle(FALSE);
    !!value && $setAttribute_28(ci, 'canvas', !value?null:$getOrCreateJsObj_0(value));
    $setDisabled_2(ci, TRUE);
    $put_1(this.this$0.canvasItems, label, ci);
    setCheck(items.array, items.size_0++, ci);
    $addChangedHandler(button, new RadioGroupWithComponentsItem$RGWCCanvas$1_0(this));
  }
  $setFields_0(this, dynamicCast($toArray_1(items, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, items.size_0, 0)), Q$FormItem_$1));
}
;
_.this$0 = null;
function RadioGroupWithComponentsItem$RGWCCanvas$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2312, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), RadioGroupWithComponentsItem$RGWCCanvas$1_0);
_.onChanged = function onChanged_43(changedEvent){
  this.this$1.this$0.selected = dynamicCast($getValue_2(changedEvent), Q$String);
  $updateEnablement(this.this$1);
  $markForRedraw(this.this$1.this$0.form_0);
}
;
_.this$1 = null;
function SimpleEditableFormItem$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2313, 1, makeCastMap([Q$EventHandler, Q$BlurHandler]), SimpleEditableFormItem$1_0);
_.onBlur = function onBlur_0(event_0){
  var newValue;
  if ($validate_0(this.this$0.innerForm, false).value_0) {
    newValue = $getItem(event_0).getValue_1();
    $setApprovedNewValue(this.this$0, newValue);
  }
}
;
_.this$0 = null;
function SimpleEditableFormItem$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2314, 1, {}, SimpleEditableFormItem$2_0);
_.execute_6 = function execute_41(item, value, form){
  return !this.this$0.editing;
}
;
_.this$0 = null;
function SimpleEditableFormItem$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2315, 1, {}, SimpleEditableFormItem$3_0);
_.execute_6 = function execute_42(item, value, form){
  return this.this$0.editing;
}
;
_.this$0 = null;
function SimpleEditableTextAreaFormItem_0(){
  $clinit_SimpleEditableFormItem();
  SimpleEditableFormItem_0.call(this, 'description', 'Description');
}

defineSeed(2316, 2287, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), SimpleEditableTextAreaFormItem_0);
_.instantiateEditFormItem = function instantiateEditFormItem_1(){
  var item;
  item = new TextAreaItem_0;
  return item;
}
;
function $setValueMap_1(this$static, valueMap){
  var entry, entry$iterator, sortedEntries, sortedValueMap;
  if (!valueMap) {
    throw new IllegalArgumentException_1('valueMap cannot be null');
  }
  sortedValueMap = new LinkedHashMap_1(valueMap.map.size_1());
  sortedEntries = new TreeSet_1(new SortedSelectItem$1_0);
  sortedEntries.addAll(new LinkedHashMap$EntrySet_0(valueMap));
  for (entry$iterator = $iterator($keySet(sortedEntries.map)); entry$iterator.val$outerIter.hasNext();) {
    entry = dynamicCast($next_1(entry$iterator), Q$Map$Entry);
    $put_1(sortedValueMap, dynamicCast(entry.getKey_0(), Q$String), dynamicCast(entry.getValue_1(), Q$String));
  }
  $isCreated_2(this$static)?$setValueMapMethod(this$static, convertMapToJavascriptObject(sortedValueMap)):$isCreated_2(this$static)?$setProperty_7(this$static, 'valueMap', convertMapToJavascriptObject(sortedValueMap)):(this$static.jsObj['valueMap'] = convertMapToJavascriptObject(sortedValueMap) , undefined);
}

function $setValueMap_2(this$static, valueMap){
  var sortedValueArray;
  if (valueMap == null) {
    throw new IllegalArgumentException_1('valueMap cannot be null');
  }
  sortedValueArray = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, valueMap.length, 0);
  arraycopy(valueMap, 0, sortedValueArray, 0, valueMap.length);
  mergeSort(sortedValueArray, 0, sortedValueArray.length, ($clinit_Comparators() , $clinit_Comparators() , NATURAL));
  $isCreated_2(this$static)?$setValueMapMethod(this$static, convertToJavaScriptArray(sortedValueArray)):$isCreated_2(this$static)?$setProperty_7(this$static, 'valueMap', convertToJavaScriptArray(sortedValueArray)):(this$static.jsObj['valueMap'] = convertToJavaScriptArray(sortedValueArray) , undefined);
}

function SortedSelectItem_0(){
  $clinit_SelectItem();
  SelectItem_0.call(this);
}

function SortedSelectItem_1(){
  $clinit_SelectItem();
  SelectItem_1.call(this, 'operationName');
}

function SortedSelectItem_2(name_0, title){
  $clinit_SelectItem();
  SelectItem_2.call(this, name_0, title);
}

defineSeed(2317, 512, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$SelectItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), SortedSelectItem_0, SortedSelectItem_1, SortedSelectItem_2);
_.setValueMap_0 = function setValueMap_1(valueMap){
  $setValueMap_1(this, valueMap);
}
;
_.setValueMap_1 = function setValueMap_2(valueMap){
  $setValueMap_2(this, valueMap);
}
;
_.setValues = function setValues_0(valueMap){
  $setValueMap_2(this, valueMap);
}
;
function $compare_8(o1, o2){
  return compareTo_11(dynamicCast(o1.getValue_1(), Q$String), dynamicCast(o2.getValue_1(), Q$String));
}

function SortedSelectItem$1_0(){
}

defineSeed(2318, 1, makeCastMap([Q$Comparator]), SortedSelectItem$1_0);
_.compare = function compare_9(o1, o2){
  return $compare_8(dynamicCast(o1, Q$Map$Entry), dynamicCast(o2, Q$Map$Entry));
}
;
function StringLengthValidator_0(min, allowForNull){
  CustomValidator_0.call(this);
  this.min_0 = min;
  this.allowForNull = allowForNull;
}

defineSeed(2319, 528, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), StringLengthValidator_0);
_.condition_1 = function condition_4(value){
  var length_0;
  if (this.allowForNull) {
    if (!this.allowForNull.value_0 && value == null) {
      return false;
    }
  }
  length_0 = value != null?toString__devirtual$(value).length:0;
  if (this.min_0) {
    if (length_0 < this.min_0.value_0) {
      return false;
    }
  }
  return true;
}
;
_.allowForNull = null;
_.min_0 = null;
function $clinit_TimeUnit(){
  $clinit_TimeUnit = nullMethod;
  MILLISECONDS_0 = new TimeUnit_0('MILLISECONDS', 0);
  SECONDS_0 = new TimeUnit_0('SECONDS', 1);
  MINUTES_1 = new TimeUnit_0('MINUTES', 2);
  HOURS_1 = new TimeUnit_0('HOURS', 3);
  DAYS_2 = new TimeUnit_0('DAYS', 4);
  WEEKS_0 = new TimeUnit_0('WEEKS', 5);
  MONTHS_0 = new TimeUnit_0('MONTHS', 6);
  YEARS = new TimeUnit_0('YEARS', 7);
  $VALUES_126 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_form_TimeUnit_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$TimeUnit, [MILLISECONDS_0, SECONDS_0, MINUTES_1, HOURS_1, DAYS_2, WEEKS_0, MONTHS_0, YEARS]);
  $clinit_CoreGUI();
}

function $getDisplayName(this$static){
  var displayName;
  switch (this$static.ordinal) {
    case 0:
      displayName = 'milliseconds';
      break;
    case 1:
      displayName = 'seconds';
      break;
    case 2:
      displayName = 'minutes';
      break;
    case 3:
      displayName = 'hours';
      break;
    case 4:
      displayName = 'days';
      break;
    case 5:
      displayName = 'weeks';
      break;
    case 6:
      displayName = 'months';
      break;
    case 7:
      displayName = 'years';
      break;
    default:throw new IllegalStateException_1('Unsupported time unit: ' + this$static);
  }
  return displayName;
}

function TimeUnit_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_135(name_0){
  $clinit_TimeUnit();
  return valueOf(($clinit_TimeUnit$Map() , $MAP_126), name_0);
}

function values_129(){
  $clinit_TimeUnit();
  return $VALUES_126;
}

defineSeed(2320, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$TimeUnit]), TimeUnit_0);
var $VALUES_126, DAYS_2, HOURS_1, MILLISECONDS_0, MINUTES_1, MONTHS_0, SECONDS_0, WEEKS_0, YEARS;
function $clinit_TimeUnit$Map(){
  $clinit_TimeUnit$Map = nullMethod;
  $MAP_126 = createValueOfMap(($clinit_TimeUnit() , $VALUES_126));
}

var $MAP_126;
function $clinit_UnitType(){
  $clinit_UnitType = nullMethod;
  TIME_3 = new UnitType_0('TIME', 0);
  ITERATIONS = new UnitType_0('ITERATIONS', 1);
  $VALUES_127 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_form_UnitType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$UnitType, [TIME_3, ITERATIONS]);
}

function UnitType_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_136(name_0){
  $clinit_UnitType();
  return valueOf(($clinit_UnitType$Map() , $MAP_127), name_0);
}

function values_130(){
  $clinit_UnitType();
  return $VALUES_127;
}

defineSeed(2322, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$UnitType]), UnitType_0);
var $VALUES_127, ITERATIONS, TIME_3;
function $clinit_UnitType$Map(){
  $clinit_UnitType$Map = nullMethod;
  $MAP_127 = createValueOfMap(($clinit_UnitType() , $VALUES_127));
}

var $MAP_127;
function $clinit_ResourceLookupComboBoxItem(){
  $clinit_ResourceLookupComboBoxItem = nullMethod;
  $clinit_ComboBoxItem();
  $clinit_CoreGUI();
}

function ResourceLookupComboBoxItem_0(title){
  $clinit_ResourceLookupComboBoxItem();
  var ancestryField, availabilityField, categoryField, descriptionField, nameField;
  ComboBoxItem_2.call(this, 'resourceId', title);
  $isCreated_2(this)?$setProperty_8(this, 'hint', 'Select a Resource'):(this.jsObj['hint'] = 'Select a Resource' , undefined);
  $setAttribute_29(this, 'showHintInField', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_6(this, new ResourceDatasource_0);
  nameField = new ListGridField_4('name', 'Name', 250);
  $setAttribute_8(nameField, 'showHover', TRUE);
  $setHoverCustomizer_0(nameField, new ResourceLookupComboBoxItem$1_0);
  ancestryField = new ListGridField_4('resourceAncestry', 'Ancestry', 300);
  $setCellFormatter_0(ancestryField, new ResourceLookupComboBoxItem$2_0);
  $clinit_AncestryUtil();
  $setAttribute_8(ancestryField, 'showHover', TRUE);
  $setHoverCustomizer_0(ancestryField, new AncestryUtil$1_0);
  descriptionField = new ListGridField_3('description', 'Description');
  categoryField = new ListGridField_4('category', 'Category', 60);
  availabilityField = new ListGridField_4('currentAvailability', 'Availability', 55);
  $setAttribute_13(availabilityField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $isCreated_2(this)?$setProperty_7(this, 'pickListFields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [nameField, ancestryField, descriptionField, categoryField, availabilityField]))):(this.jsObj['pickListFields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [nameField, ancestryField, descriptionField, categoryField, availabilityField])) , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'valueField', 'id'):(this.jsObj['valueField'] = 'id' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'displayField', 'name'):(this.jsObj['displayField'] = 'name' , undefined);
  $setAttribute_11(this, 'pickListWidth', valueOf_44(800));
  $setAttribute_30(this, 'textMatchStyle', ($clinit_TextMatchStyle() , SUBSTRING).value_0);
  $setAttribute_29(this, 'completeOnTab', TRUE);
}

defineSeed(2324, 491, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$ComboBoxItem, Q$FormItem, Q$TextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), ResourceLookupComboBoxItem_0);
function ResourceLookupComboBoxItem$1_0(){
}

defineSeed(2325, 1, {}, ResourceLookupComboBoxItem$1_0);
_.hoverHTML_0 = function hoverHTML_5(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function ResourceLookupComboBoxItem$2_0(){
}

defineSeed(2326, 1, {}, ResourceLookupComboBoxItem$2_0);
_.format_1 = function format_25(o, listGridRecord, rowNum, colNum){
  return getAncestryValue(listGridRecord, false);
}
;
function $clinit_AbstractMeasurementRangeEditor(){
  $clinit_AbstractMeasurementRangeEditor = nullMethod;
  $clinit_BaseWidget();
  $clinit_CoreGUI();
  lastUnits = new LinkedHashMap_1(3);
  $put_1(lastUnits, '2', 'minutes');
  $put_1(lastUnits, '3', 'hours');
  $put_1(lastUnits, '4', 'days');
  lastValues = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['4', '8', '12', '24', '30', '36', '48', '60', '90', '120']);
}

function $enableMeasurementRange(this$static, enableRange){
  if (enableRange) {
    $setDisabled_2(this$static.simpleLastValuesItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $setDisabled_2(this$static.simpleLastUnitsItem, TRUE);
    $setDisabled_2(this$static.advancedStartItem, TRUE);
    $setDisabled_2(this$static.advancedEndItem, TRUE);
    $setDisabled_2(this$static.advancedSimpleButton, TRUE);
  }
   else {
    $setDisabled_2(this$static.simpleLastValuesItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setDisabled_2(this$static.simpleLastUnitsItem, FALSE);
    $setDisabled_2(this$static.advancedStartItem, FALSE);
    $setDisabled_2(this$static.advancedEndItem, FALSE);
    this$static.advancedSimpleButton.enable_0();
    $markForRedraw(this$static);
  }
}

function $onInit_5(this$static){
  var metricRangePrefs, timeValidator;
  $onInit(this$static);
  $onInit_DynamicForm(this$static);
  if (this$static.displayRangeItemGrouping) {
    $setIsGroup(this$static, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $isCreated_1(this$static)?$setProperty_3(this$static, 'groupTitle', 'Filter by: Time'):(this$static.config_0['groupTitle'] = 'Filter by: Time' , undefined);
  }
  this$static.enableRangeItem = new CheckboxItem_2('ENABLE_RANGE_ITEM', '');
  $setAttribute_29(this$static.enableRangeItem, 'showTitle', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_29(this$static.enableRangeItem, 'showLabel', FALSE);
  $addChangeHandler(this$static.enableRangeItem, new AbstractMeasurementRangeEditor$1_0(this$static));
  this$static.simpleLastValuesItem = new SelectItem_2('lastValues', 'Time Range - Previous');
  this$static.simpleLastValuesItem.setValueMap_1(lastValues);
  $setAttribute_30(this$static.simpleLastValuesItem, 'titleAlign', ($clinit_Alignment() , LEFT_0).value_0);
  this$static.simpleLastUnitsItem = new SelectItem_1('lastUnits');
  this$static.simpleLastUnitsItem.setValueMap_0(lastUnits);
  $setShowTitle_0(this$static.simpleLastUnitsItem, FALSE);
  this$static.advancedStartItem = new DateTimeItem_1('start', 'Time Range - Start');
  $setAttribute_30(this$static.advancedStartItem, 'titleAlign', LEFT_0.value_0);
  $setUseMask(this$static.advancedStartItem, TRUE);
  $setAttribute_30(this$static.advancedStartItem, 'displayFormat', ($clinit_DateDisplayFormat() , TOUSSHORTDATE).value_0);
  this$static.advancedEndItem = new DateTimeItem_1('end', 'End');
  $setUseMask(this$static.advancedEndItem, TRUE);
  $setAttribute_30(this$static.advancedEndItem, 'displayFormat', TOUSSHORTDATE.value_0);
  timeValidator = new AbstractMeasurementRangeEditor$2_0(this$static);
  timeValidator.jsObj['errorMessage'] = 'Start time should be before the end time.';
  $setValidators(this$static.advancedStartItem, initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [timeValidator]));
  this$static.setButton = new ButtonItem_1('set', 'Set');
  $setStartRow_1(this$static.setButton, FALSE);
  $setEndRow_1(this$static.setButton, FALSE);
  $addClickHandler_1(this$static.setButton, new AbstractMeasurementRangeEditor$3_0(this$static));
  this$static.advancedSimpleButton = new ButtonItem_1('advanced', 'Advanced...');
  $setStartRow_1(this$static.advancedSimpleButton, FALSE);
  $setEndRow_1(this$static.advancedSimpleButton, FALSE);
  $addClickHandler_1(this$static.advancedSimpleButton, new AbstractMeasurementRangeEditor$4_0(this$static));
  this$static.space = new SpacerItem_0;
  $setWidth_5(this$static.space, 300);
  metricRangePrefs = this$static.getMetricRangePreferences();
  !!metricRangePrefs && (this$static.advanced = metricRangePrefs.explicitBeginEnd);
  this$static.displaySetButton?$setFields_0(this$static, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.simpleLastValuesItem, this$static.simpleLastUnitsItem, this$static.advancedStartItem, this$static.advancedEndItem, this$static.setButton, this$static.advancedSimpleButton, this$static.space])):this$static.displayEnableButton?$setFields_0(this$static, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.enableRangeItem, this$static.simpleLastValuesItem, this$static.simpleLastUnitsItem, this$static.advancedStartItem, this$static.advancedEndItem, this$static.advancedSimpleButton, this$static.space])):$setFields_0(this$static, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.simpleLastValuesItem, this$static.simpleLastUnitsItem, this$static.advancedStartItem, this$static.advancedEndItem, this$static.advancedSimpleButton, this$static.space]));
  $update(this$static);
}

function $refresh_4(this$static){
  $update(this$static);
}

function $update(this$static){
  var $e0, e, metricRangePrefs;
  if (this$static.advanced) {
    this$static.advancedSimpleButton.setTitle('Simple...');
    $showItem(this$static, 'start');
    $showItem(this$static, 'end');
    $hideItem(this$static, 'lastValues');
    $hideItem(this$static, 'lastUnits');
  }
   else {
    this$static.advancedSimpleButton.setTitle('Advanced...');
    $hideItem(this$static, 'start');
    $hideItem(this$static, 'end');
    $showItem(this$static, 'lastValues');
    $showItem(this$static, 'lastUnits');
  }
  $setValue_7(this$static.simpleLastValuesItem, '8');
  $setValue_7(this$static.simpleLastUnitsItem, '3');
  $setValue_8(this$static.advancedStartItem, new Date_2(sub(fromDouble(currentTimeMillis0()), P1b77400_longLit)));
  $setValue_8(this$static.advancedEndItem, new Date_1);
  try {
    metricRangePrefs = this$static.getMetricRangePreferences();
    if (metricRangePrefs.explicitBeginEnd) {
      if (!!metricRangePrefs.begin && !!metricRangePrefs.end_0) {
        $setValue_8(this$static.advancedStartItem, new Date_2(metricRangePrefs.begin.value_0));
        $setValue_8(this$static.advancedEndItem, new Date_2(metricRangePrefs.end_0.value_0));
      }
    }
     else {
      $containsKey_1(lastUnits, '' + metricRangePrefs.unit) && $setValue_7(this$static.simpleLastUnitsItem, '' + metricRangePrefs.unit);
      $indexOf(new Arrays$ArrayList_0(lastValues), '' + metricRangePrefs.lastN) != -1 && $setValue_7(this$static.simpleLastValuesItem, '' + metricRangePrefs.lastN);
    }
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      e = $e0;
      $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_4('Failed to get range user preferences, using defaults', e, ($clinit_Message$Severity() , Warning)));
      $setValue_7(this$static.simpleLastValuesItem, '8');
      $setValue_7(this$static.simpleLastUnitsItem, '3');
      $setValue_8(this$static.advancedStartItem, new Date_2(sub(fromDouble(currentTimeMillis0()), P1b77400_longLit)));
      $setValue_8(this$static.advancedEndItem, new Date_1);
    }
     else 
      throw $e0;
  }
  $markForRedraw(this$static);
}

function AbstractMeasurementRangeEditor_0(){
  $clinit_AbstractMeasurementRangeEditor();
  DynamicForm_0.call(this);
  $clinit_CoreGUI();
  $isCreated_1(this)?$setProperty_0(this, 'numCols', 10):(this.config_0['numCols'] = 10 , undefined);
  $setWrapItemTitles(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_24(this, 'align', ($clinit_Alignment() , LEFT_0).value_0, true);
}

defineSeed(2327, 478, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm, Q$TableWidget]));
_.onInit = function onInit_34(){
  $onInit_5(this);
}
;
_.refresh_1 = function refresh_6(listGrid){
  $update(this);
}
;
_.advanced = false;
_.advancedEndItem = null;
_.advancedSimpleButton = null;
_.advancedStartItem = null;
_.displayEnableButton = false;
_.displayRangeItemGrouping = false;
_.displaySetButton = true;
_.enableRangeItem = null;
_.setButton = null;
_.simpleLastUnitsItem = null;
_.simpleLastValuesItem = null;
_.space = null;
var lastUnits = null, lastValues = null;
function AbstractMeasurementRangeEditor$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2328, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), AbstractMeasurementRangeEditor$1_0);
_.onChange = function onChange_3(event_0){
  var enableRange, jsObj;
  enableRange = ($clinit_Boolean() , $equalsIgnoreCase('true', (jsObj = event_0.jsObj , getOrCreateRef_6(jsObj.item)).getValue_1() + '')?TRUE:FALSE).value_0;
  $enableMeasurementRange(this.this$0, enableRange);
}
;
_.this$0 = null;
function AbstractMeasurementRangeEditor$2_0(this$0){
  this.this$0 = this$0;
  CustomValidator_0.call(this);
}

defineSeed(2329, 528, makeCastMap([Q$DataClass, Q$JsObject, Q$Validator]), AbstractMeasurementRangeEditor$2_0);
_.condition_1 = function condition_5(value){
  return $after($getValueAsDate(this.this$0.advancedEndItem), $getValueAsDate(this.this$0.advancedStartItem));
}
;
_.this$0 = null;
function AbstractMeasurementRangeEditor$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2330, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), AbstractMeasurementRangeEditor$3_0);
_.onClick_0 = function onClick_75(event_0){
  var $e0, errors, prefs;
  prefs = new AbstractMeasurementRangeEditor$MetricRangePreferences_0;
  prefs.explicitBeginEnd = this.this$0.advanced;
  if (this.this$0.advanced) {
    try {
      if ($validate(this.this$0)) {
        prefs.begin = valueOf_45($getValueAsDate(this.this$0.advancedStartItem).getTime_0());
        prefs.end_0 = valueOf_45($getValueAsDate(this.this$0.advancedEndItem).getTime_0());
        !!prefs.begin && !!prefs.end_0 && gt(prefs.begin.value_0, prefs.end_0.value_0)?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0('Start time should be before the end time.')):this.this$0.setMetricRangeProperties(prefs);
      }
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        errors = new HashMap_0;
        errors.put(($clinit_AbstractMeasurementRangeEditor() , 'end'), 'MM/DD/YYYY HH:MM');
        errors.put('start', 'MM/DD/YYYY HH:MM');
        $setErrors(this.this$0, errors, true);
      }
       else 
        throw $e0;
    }
  }
   else {
    prefs.lastN = valueOf_44(__parseAndValidateInt($getValueAsString_4(this.this$0.simpleLastValuesItem))).value_0;
    prefs.unit = valueOf_44(__parseAndValidateInt($getValueAsString_4(this.this$0.simpleLastUnitsItem))).value_0;
    this.this$0.setMetricRangeProperties(prefs);
  }
}
;
_.this$0 = null;
function AbstractMeasurementRangeEditor$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2331, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), AbstractMeasurementRangeEditor$4_0);
_.onClick_0 = function onClick_76(clickEvent){
  this.this$0.advanced = !this.this$0.advanced;
  $update(this.this$0);
}
;
_.this$0 = null;
function $getBeginEndTimes(this$static){
  var times;
  if (this$static.explicitBeginEnd) {
    times = new ArrayList_1(2);
    $add_3(times, this$static.begin);
    $add_3(times, this$static.end_0);
    return times;
  }
   else {
    return calculateTimeFrame(this$static.lastN, this$static.unit);
  }
}

function AbstractMeasurementRangeEditor$MetricRangePreferences_0(){
}

defineSeed(2332, 1, {}, AbstractMeasurementRangeEditor$MetricRangePreferences_0);
_.toString$ = function toString_204(){
  return this.explicitBeginEnd?'[begin=' + this.begin + this.end_0 + ',end=' + this.end_0 + ']':'[lastN=' + this.lastN + ',unit=' + this.unit + ']';
}
;
_.begin = null;
_.end_0 = null;
_.explicitBeginEnd = false;
_.lastN = 0;
_.unit = 0;
function $clinit_CustomConfigMeasurementRangeEditor(){
  $clinit_CustomConfigMeasurementRangeEditor = nullMethod;
  $clinit_AbstractMeasurementRangeEditor();
  $clinit_Boolean();
  DEFAULT_VALUE_RANGE_LASTN = valueOf_44(__parseAndValidateInt(($clinit_PortletConfigurationEditorComponent$Constant() , '8')));
  DEFAULT_VALUE_RANGE_UNIT = valueOf_44(__parseAndValidateInt('3'));
}

function $getBeginEndTimes_0(this$static){
  var beginEndTimes, lastN, unit;
  beginEndTimes = new ArrayList_0;
  if (this$static.advanced) {
    $add_3(beginEndTimes, valueOf_45($getValueAsDate(this$static.advancedStartItem).getTime_0()));
    $add_3(beginEndTimes, valueOf_45($getValueAsDate(this$static.advancedEndItem).getTime_0()));
    return beginEndTimes;
  }
   else {
    lastN = valueOf_44(__parseAndValidateInt($getValueAsString_4(this$static.simpleLastValuesItem))).value_0;
    unit = $getValueAsString_4(this$static.simpleLastUnitsItem);
    this$static.measurementPrefs.metricRangePreferences.lastN = lastN;
    this$static.measurementPrefs.metricRangePreferences.unit = valueOf_44(__parseAndValidateInt(unit)).value_0;
    return calculateTimeFrame(lastN, valueOf_44(__parseAndValidateInt(unit)).value_0);
  }
}

function CustomConfigMeasurementRangeEditor_0(config){
  $clinit_CustomConfigMeasurementRangeEditor();
  AbstractMeasurementRangeEditor_0.call(this);
  this.measurementPrefs = new CustomConfigMeasurementRangeEditor$ConfigurationMeasurementPreferences_0(config);
  this.displaySetButton = false;
  this.displayEnableButton = true;
  this.displayRangeItemGrouping = true;
  $isCreated_1(this)?$setProperty_0(this, 'width', 650):(this.config_0['width'] = 650 , undefined);
}

defineSeed(2333, 2327, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm, Q$TableWidget]), CustomConfigMeasurementRangeEditor_0);
_.getMetricRangePreferences = function getMetricRangePreferences(){
  return this.measurementPrefs.metricRangePreferences;
}
;
_.onInit = function onInit_35(){
  var advanced, beginEnd;
  $onInit_5(this);
  $setWidth_1(this.enableRangeItem, 30);
  $setAttribute_29(this.advancedStartItem, 'useTextField', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_29(this.advancedEndItem, 'useTextField', FALSE);
  $setType(this.advancedStartItem, 'selection');
  $setWidth_1(this.simpleLastValuesItem, 50);
  $setWidth_1(this.simpleLastUnitsItem, 70);
  $getSimple(this.measurementPrefs.configuration, 'METRIC_RANGE_ENABLE');
  if (($equalsIgnoreCase('true', $getSimple(this.measurementPrefs.configuration, 'METRIC_RANGE_ENABLE').stringValue)?TRUE:FALSE).value_0) {
    $setValue_9(this.enableRangeItem, true);
    $enableMeasurementRange(this, false);
  }
   else {
    $setValue_9(this.enableRangeItem, false);
    $enableMeasurementRange(this, true);
  }
  advanced = this.measurementPrefs.metricRangePreferences.explicitBeginEnd;
  if (advanced) {
    beginEnd = $getBeginEndTimes(this.measurementPrefs.metricRangePreferences);
    if (!!beginEnd && beginEnd.size_0 != 0) {
      $setValue_6(this.advancedStartItem, (checkIndex(0, beginEnd.size_0) , beginEnd.array[0]));
      $setValue_6(this.advancedEndItem, (checkIndex(1, beginEnd.size_0) , beginEnd.array[1]));
    }
  }
   else {
    $containsKey_1(($clinit_AbstractMeasurementRangeEditor() , lastUnits), '' + this.measurementPrefs.metricRangePreferences.unit) && $setValue_7(this.simpleLastUnitsItem, '' + this.measurementPrefs.metricRangePreferences.unit);
    $indexOf(new Arrays$ArrayList_0(lastValues), '' + this.measurementPrefs.metricRangePreferences.lastN) != -1 && $setValue_7(this.simpleLastValuesItem, '' + this.measurementPrefs.metricRangePreferences.lastN);
  }
}
;
_.setMetricRangeProperties = function setMetricRangeProperties(prefs){
  $setMetricRangePreferences(this.measurementPrefs, prefs);
}
;
_.measurementPrefs = null;
var DEFAULT_VALUE_RANGE_LASTN, DEFAULT_VALUE_RANGE_UNIT;
function $setMetricRangePreferences(this$static, metricRangePreferences){
  this$static.metricRangePreferences = metricRangePreferences;
}

function CustomConfigMeasurementRangeEditor$ConfigurationMeasurementPreferences_0(config){
  var $e0, beginEnd, range, rangeString;
  !this.metricRangePreferences && (this.metricRangePreferences = new AbstractMeasurementRangeEditor$MetricRangePreferences_0);
  this.metricRangePreferences.explicitBeginEnd = ($clinit_Boolean() , $equalsIgnoreCase('true', dynamicCast(config.properties.get_2('METRIC_RANGE_BEGIN_END_FLAG'), Q$PropertySimple).stringValue)?TRUE:FALSE).value_0;
  if (this.metricRangePreferences.explicitBeginEnd) {
    try {
      rangeString = $getSimpleValue(config, 'METRIC_RANGE', '');
      if (rangeString != null && $trim(rangeString).length > 0) {
        rangeString.indexOf(',') != -1 && (rangeString = $replace_1(rangeString, ',', '|'));
        beginEnd = $split(rangeString, '\\|', 0);
        this.metricRangePreferences.begin = valueOf_45(__parseAndValidateLong(beginEnd[0]));
        this.metricRangePreferences.end_0 = valueOf_45(__parseAndValidateLong(beginEnd[1]));
      }
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$IllegalArgumentException)) {
        range = calculateTimeFrame(($clinit_CustomConfigMeasurementRangeEditor() , DEFAULT_VALUE_RANGE_LASTN).value_0, DEFAULT_VALUE_RANGE_UNIT.value_0);
        this.metricRangePreferences.begin = dynamicCast((checkIndex(0, range.size_0) , range.array[0]), Q$Long);
        this.metricRangePreferences.end_0 = dynamicCast((checkIndex(1, range.size_0) , range.array[1]), Q$Long);
      }
       else 
        throw $e0;
    }
  }
   else {
    this.metricRangePreferences.lastN = $getIntegerValue(dynamicCast(config.properties.get_2('METRIC_RANGE_LASTN'), Q$PropertySimple)).value_0;
    this.metricRangePreferences.unit = $getIntegerValue(dynamicCast(config.properties.get_2('METRIC_RANGE_UNIT'), Q$PropertySimple)).value_0;
    range = calculateTimeFrame(this.metricRangePreferences.lastN, this.metricRangePreferences.unit);
    this.metricRangePreferences.begin = dynamicCast((checkIndex(0, range.size_0) , range.array[0]), Q$Long);
    this.metricRangePreferences.end_0 = dynamicCast((checkIndex(1, range.size_0) , range.array[1]), Q$Long);
  }
  this.configuration = config;
}

defineSeed(2334, 1, {}, CustomConfigMeasurementRangeEditor$ConfigurationMeasurementPreferences_0);
_.configuration = null;
_.metricRangePreferences = null;
function $getEndTime(this$static){
  var beginEndTimes;
  beginEndTimes = $getBeginEndTimes($getMetricRangePreferences(this$static.measurementUserPrefs));
  return dynamicCast((checkIndex(1, beginEndTimes.size_0) , beginEndTimes.array[1]), Q$Long);
}

function $getStartTime(this$static){
  var beginEndTimes;
  beginEndTimes = $getBeginEndTimes($getMetricRangePreferences(this$static.measurementUserPrefs));
  return dynamicCast((checkIndex(0, beginEndTimes.size_0) , beginEndTimes.array[0]), Q$Long);
}

function UserPreferencesMeasurementRangeEditor_0(){
  $clinit_AbstractMeasurementRangeEditor();
  AbstractMeasurementRangeEditor_0.call(this);
  this.measurementUserPrefs = new MeasurementUserPreferences_0(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences));
}

defineSeed(2335, 2327, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm, Q$TableWidget]), UserPreferencesMeasurementRangeEditor_0);
_.getMetricRangePreferences = function getMetricRangePreferences_0(){
  return $getMetricRangePreferences(this.measurementUserPrefs);
}
;
_.setMetricRangeProperties = function setMetricRangeProperties_0(prefs){
  $setMetricRangePreferences_0(this.measurementUserPrefs, prefs);
}
;
_.measurementUserPrefs = null;
function AbstractSelector$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2336, 1, makeCastMap([Q$EventHandler, Q$ItemChangedHandler]), AbstractSelector$1_0);
_.onItemChanged = function onItemChanged_2(itemChangedEvent){
  var timer;
  this.this$0.latestCriteria = this.this$0.getLatestCriteria(this.this$0.availableFilterForm);
  timer = new AbstractSelector$1$1_0(this);
  $schedule(timer, 500);
}
;
_.this$0 = null;
function AbstractSelector$1$1_0(this$1){
  $clinit_Timer();
  this.this$1 = this$1;
}

defineSeed(2337, 73, makeCastMap([Q$Timer]), AbstractSelector$1$1_0);
_.run = function run_11(){
  var criteria;
  if (this.this$1.this$0.latestCriteria) {
    criteria = this.this$1.this$0.latestCriteria;
    this.this$1.this$0.latestCriteria = null;
    $populateAvailableGrid(this.this$1.this$0, criteria);
  }
}
;
_.this$1 = null;
function AbstractSelector$10_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2338, 1, makeCastMap([Q$EventHandler, Q$SelectionChangedHandler]), AbstractSelector$10_0);
_.onSelectionChanged = function onSelectionChanged_4(selectionEvent){
  this.this$0.updateButtonEnablement();
}
;
_.this$0 = null;
function AbstractSelector$11_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2339, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), AbstractSelector$11_0);
_.onDoubleClick = function onDoubleClick_5(event_0){
  $removeSelectedRows(this.this$0);
}
;
_.this$0 = null;
function AbstractSelector$12_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2340, 1, makeCastMap([Q$EventHandler, Q$KeyPressHandler]), AbstractSelector$12_0);
_.this$0 = null;
function AbstractSelector$13_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2341, 1, makeCastMap([Q$EventHandler, Q$RecordDropHandler]), AbstractSelector$13_0);
_.onRecordDrop_0 = function onRecordDrop(recordDropEvent){
  this.this$0.addSelectedRows();
  recordDropEvent.cancel = true;
}
;
_.this$0 = null;
function AbstractSelector$14_0(){
}

defineSeed(2342, 1, {}, AbstractSelector$14_0);
function AbstractSelector$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2343, 1, makeCastMap([Q$EventHandler, Q$SelectionChangedHandler]), AbstractSelector$2_0);
_.onSelectionChanged = function onSelectionChanged_5(selectionEvent){
  this.this$0.updateButtonEnablement();
}
;
_.this$0 = null;
function AbstractSelector$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2344, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), AbstractSelector$3_0);
_.onDoubleClick = function onDoubleClick_6(event_0){
  this.this$0.addSelectedRows();
}
;
_.this$0 = null;
function AbstractSelector$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2345, 1, makeCastMap([Q$EventHandler, Q$RecordDropHandler]), AbstractSelector$4_0);
_.onRecordDrop_0 = function onRecordDrop_0(recordDropEvent){
  $removeSelectedRows(this.this$0);
  recordDropEvent.cancel = true;
}
;
_.this$0 = null;
function AbstractSelector$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2346, 1, {}, AbstractSelector$5_0);
_.execute_2 = function execute_43(response, rawData, request){
  var allRecords, assignedRecords, id, record, record$index, record$max, selectedRecordIds, totalAvailableRecords, totalRecords;
  try {
    this.this$0.availableRecords = new ArrayList_0;
    allRecords = $getData(response);
    assignedRecords = this.this$0.assignedGrid.getRecords();
    if (assignedRecords.length != 0) {
      selectedRecordIds = new HashSet_1(assignedRecords.length);
      for (record$index = 0 , record$max = assignedRecords.length; record$index < record$max; ++record$index) {
        record = assignedRecords[record$index];
        id = $getAttribute(record, this.this$0.getSelectorKey());
        $add_6(selectedRecordIds, id);
      }
      for (record$index = 0 , record$max = allRecords.length; record$index < record$max; ++record$index) {
        record = allRecords[record$index];
        id = $getAttribute(record, this.this$0.getSelectorKey());
        selectedRecordIds.map.containsKey(id) || $add_3(this.this$0.availableRecords, record);
      }
    }
     else {
      $addAll_0(this.this$0.availableRecords, new Arrays$ArrayList_0(allRecords));
    }
    totalRecords = getAttributeAsInt(response.jsObj, 'totalRows')?getAttributeAsInt(response.jsObj, 'totalRows').value_0:allRecords.length;
    totalAvailableRecords = totalRecords - assignedRecords.length;
    this.this$0.availableRecords.size_0 < totalAvailableRecords?$setContents_0(this.this$0.messageLayout, imgHTML('subsystems/availability/availability_yellow_16.png') + ' Only ' + this.this$0.availableRecords.size_0 + ' out of ' + totalAvailableRecords + ' available ' + this.this$0.getItemTitle() + ' are listed. Use the search fields below to find the ' + this.this$0.getItemTitle() + ' you want.'):$setContents_0(this.this$0.messageLayout, '&nbsp;');
    $markForRedraw(this.this$0.messageLayout);
    this.this$0.availableGrid.setData(dynamicCast($toArray_1(this.this$0.availableRecords, initDim(_3Lcom_smartgwt_client_data_Record_2_classLit, makeCastMap([Q$Record_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Record, this.this$0.availableRecords.size_0, 0)), Q$Record_$1));
  }
   finally {
    this.this$0.updateButtonEnablement();
  }
}
;
_.this$0 = null;
function AbstractSelector$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2347, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AbstractSelector$6_0);
_.onClick = function onClick_77(clickEvent){
  this.this$0.addSelectedRows();
}
;
_.this$0 = null;
function AbstractSelector$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2348, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AbstractSelector$7_0);
_.onClick = function onClick_78(clickEvent){
  $removeSelectedRows(this.this$0);
}
;
_.this$0 = null;
function AbstractSelector$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2349, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AbstractSelector$8_0);
_.onClick = function onClick_79(clickEvent){
  $selectAllRecords(this.this$0.availableGrid);
  this.this$0.addSelectedRows();
}
;
_.this$0 = null;
function AbstractSelector$9_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2350, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), AbstractSelector$9_0);
_.onClick = function onClick_80(clickEvent){
  $selectAllRecords(this.this$0.assignedGrid);
  $removeSelectedRows(this.this$0);
}
;
_.this$0 = null;
function AssignedItemsChangedEvent_0(){
}

defineSeed(2351, 1, {}, AssignedItemsChangedEvent_0);
function SingleResourceGroupSelectorItem_0(){
  $clinit_ComboBoxItem();
  var descriptionField, nameField;
  ComboBoxItem_2.call(this, 'memberOfGroup', 'Group');
  nameField = new ListGridField_1('name');
  descriptionField = new ListGridField_1('description');
  $setOptionDataSource(this, new SingleResourceGroupSelectorItem$CompatibleResourceGroupsDataSource_0(this));
  $isCreated_2(this)?$setProperty_6(this, 'width', 240):(this.jsObj['width'] = 240 , undefined);
  $setTitle_1(this, ($clinit_CoreGUI() , 'Resource Group'));
  $isCreated_2(this)?$setProperty_8(this, 'valueField', 'id'):(this.jsObj['valueField'] = 'id' , undefined);
  $isCreated_2(this)?$setProperty_8(this, 'displayField', 'name'):(this.jsObj['displayField'] = 'name' , undefined);
  $setPickListWidth(this, valueOf_44(450));
  $isCreated_2(this)?$setProperty_7(this, 'pickListFields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [nameField, descriptionField]))):(this.jsObj['pickListFields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [nameField, descriptionField])) , undefined);
  $setAttribute_30(this, 'textMatchStyle', ($clinit_TextMatchStyle() , SUBSTRING).value_0);
  this.criteria = new ResourceGroupCriteria_0;
}

defineSeed(2352, 491, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$ComboBoxItem, Q$FormItem, Q$TextItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), SingleResourceGroupSelectorItem_0);
_.criteria = null;
function SingleResourceGroupSelectorItem$CompatibleResourceGroupsDataSource_0(this$0){
  $clinit_RPCDataSource();
  this.this$0 = this$0;
  ResourceGroupsDataSource_0.call(this);
}

defineSeed(2353, 2089, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), SingleResourceGroupSelectorItem$CompatibleResourceGroupsDataSource_0);
_.getFetchCriteria_2 = function getFetchCriteria_28(request){
  var $e0, filterString, id, result;
  result = this.this$0.criteria;
  filterString = dynamicCast(getFilter($getCriteria(request), 'id', Ljava_lang_String_2_classLit), Q$String);
  if (filterString != null) {
    try {
      id = new Integer_1(filterString);
      result.filterId = id;
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        result.filterName = filterString;
      }
       else 
        throw $e0;
    }
  }
  return result;
}
;
_.this$0 = null;
function $notifyListOrderChangedHandlers(this$static){
  var handler$iterator;
  for (handler$iterator = $iterator($keySet(this$static.listOrderChangedHandlers.map)); handler$iterator.val$outerIter.hasNext();) {
    throwClassCastExceptionUnlessNull($next_1(handler$iterator));
    null.nullMethod($getSelectedRecords(this$static.listGrid));
  }
}

function $setRecords_0(this$static, records){
  $setRecords(this$static.listGrid, records);
}

function ReorderableList_0(records, itemIcon, nameHoverCustomizer){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.nameFieldTitle = ($clinit_Enhanced() , 'Name');
  this.listOrderChangedHandlers = new HashSet_0;
  this.isReadOnly = false;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setMargin(this, valueOf_44(7));
  this.hlayout = new HLayout_0;
  this.listGrid = new ListGrid_0;
  $setRecords(this.listGrid, records);
  this.isReadOnly && $setAttribute_24(this.listGrid, 'selectionType', ($clinit_SelectionStyle() , NONE_4).value_0, true);
  this.itemIcon = itemIcon;
  this.nameHoverCustomizer = nameHoverCustomizer;
}

defineSeed(2354, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ReorderableList_0);
_.onInit = function onInit_36(){
  var fields, iconField, itemIcon, nameField;
  $onInit(this);
  $onInit_Layout(this);
  $setWidth(this.listGrid, 300);
  $setHeight(this.listGrid, 250);
  this.listGrid.setCanReorderRecords(($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setLoadingMessage(this.listGrid, ($clinit_Enhanced() , 'Loading...'));
  this.listGrid.setEmptyMessage('No items to show');
  this.listGrid.addRecordDropHandler(new ReorderableList$1_0(this));
  fields = new ArrayList_0;
  itemIcon = this.itemIcon;
  if (itemIcon != null) {
    iconField = new ListGridField_2('icon', 25);
    $setAttribute_13(iconField, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0);
    iconField.jsObj['cellIcon'] = itemIcon;
    $setAttribute_8(iconField, 'showDefaultContextMenu', FALSE);
    setCheck(fields.array, fields.size_0++, iconField);
  }
  nameField = new ListGridField_3('name', this.nameFieldTitle);
  if (this.nameHoverCustomizer) {
    $setAttribute_8(nameField, 'showHover', TRUE);
    $setHoverCustomizer_0(nameField, this.nameHoverCustomizer);
  }
  setCheck(fields.array, fields.size_0++, nameField);
  $setFields_1(this.listGrid, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $addMember(this.hlayout, this.listGrid);
  $addMember(this, this.hlayout);
}
;
_.hlayout = null;
_.isReadOnly = false;
_.itemIcon = null;
_.listGrid = null;
_.nameHoverCustomizer = null;
function ReorderableList$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2355, 1, makeCastMap([Q$EventHandler, Q$RecordDropHandler]), ReorderableList$1_0);
_.onRecordDrop_0 = function onRecordDrop_1(event_0){
  $notifyListOrderChangedHandlers(this.this$0);
}
;
_.this$0 = null;
function NamedTab_0(viewName){
  Tab_1.call(this, viewName.title_0);
  this.viewName = viewName;
}

function NamedTab_1(viewName, icon){
  Tab_2.call(this, viewName.title_0, icon);
  this.viewName = viewName;
}

defineSeed(2356, 566, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Tab, Q$HasTabDeselectedHandlers, Q$HasTabSelectedHandlers, Q$NamedTab]), NamedTab_0, NamedTab_1);
_.getTitle = function getTitle_4(){
  return this.viewName.title_0;
}
;
_.viewName = null;
function $destroy_3(this$static){
  var tab, tab$array, tab$index, tab$max, pane;
  for (tab$array = this$static.getTabs() , tab$index = 0 , tab$max = tab$array.length; tab$index < tab$max; ++tab$index) {
    tab = tab$array[tab$index];
    pane = tab.getPane();
    !!pane && pane.destroy_0();
  }
  $destroy(this$static);
}

function $getTabByName(this$static, name_0){
  var tab, tab$index, tab$max, tabs;
  tabs = $getTabs_0(this$static);
  for (tab$index = 0 , tab$max = tabs.length; tab$index < tab$max; ++tab$index) {
    tab = tabs[tab$index];
    if ($equals_6(tab.viewName.name_0, name_0)) {
      return tab;
    }
  }
  return null;
}

function $getTabByTitle(this$static, title){
  var tab, tab$index, tab$max, tabs;
  tabs = this$static.getTabs();
  for (tab$index = 0 , tab$max = tabs.length; tab$index < tab$max; ++tab$index) {
    tab = tabs[tab$index];
    if ($equals_6(tab.viewName.title_0, title)) {
      return tab;
    }
  }
  return null;
}

function $getTabs(this$static){
  var i, namedTabs, tab, tabs, tabsLength;
  tabs = convertToTabArray($getAttributeAsJavaScriptObject_1(this$static, 'tabs'));
  namedTabs = initDim(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_NamedTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$NamedTab, tabs.length, 0);
  for (i = 0 , tabsLength = tabs.length; i < tabsLength; ++i) {
    tab = tabs[i];
    if (!instanceOf(tab, Q$NamedTab)) {
      throw new IllegalStateException_1('NamedTabSet contains a Tab that is not a NamedTab.');
    }
    setCheck(namedTabs, i, dynamicCast(tab, Q$NamedTab));
  }
  return namedTabs;
}

function NamedTabSet_0(){
  $clinit_BaseWidget();
  TabSet_0.call(this);
}

defineSeed(2357, 567, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$HasTabDeselectedHandlers, Q$HasTabSelectedHandlers]), NamedTabSet_0);
_.destroy_0 = function destroy_10(){
  $destroy_3(this);
}
;
_.getTabByTitle = function getTabByTitle(title){
  return $getTabByTitle(this, title);
}
;
_.getTabs = function getTabs(){
  return $getTabs(this);
}
;
function $destroyButton(this$static){
  if (this$static.button) {
    $removeFromParent(this$static.button);
    $destroy(this$static.button);
    this$static.button = null;
  }
}

function $destroyCanvas(this$static){
  if (this$static.canvas_0) {
    $removeFromParent(this$static.canvas_0);
    this$static.canvas_0.destroy_0();
    this$static.canvas_0 = null;
  }
}

function $getCanvas_2(this$static){
  !this$static.canvas_0 && !!this$static.viewFactory && (this$static.canvas_0 = this$static.viewFactory.createView());
  return this$static.canvas_0;
}

function $setVisibleNext(this$static, visibleNext){
  this$static.visibleNext = visibleNext;
}

function SubTab_0(parent_0, viewName){
  this.parent_0 = parent_0;
  this.viewName = viewName;
  this.canvas_0 = null;
  this.viewFactory = null;
  this.button = null;
  this.id = parent_0.viewName.name_0 + '_:_' + viewName.name_0;
}

defineSeed(2358, 1, makeCastMap([Q$SubTab, Q$Enhanced]), SubTab_0);
_.toString$ = function toString_205(){
  return 'SubTab[parent=' + this.parent_0.viewName.name_0 + ', title=' + this.viewName.title_0 + ', name=' + this.viewName + ']';
}
;
_.actualNext = null;
_.button = null;
_.canvas_0 = null;
_.id = null;
_.parent_0 = null;
_.viewFactory = null;
_.viewName = null;
_.visibleNext = null;
function $addTwoLevelTabSelectedHandler(this$static, handler){
  return $addHandler(this$static.hm, ($clinit_TwoLevelTabSelectedEvent() , TYPE_54), handler);
}

function $buildSubTabList(tabs){
  var current, i;
  current = tabs[0];
  for (i = 1; i < tabs.length; ++i) {
    current.actualNext = tabs[i];
    current = tabs[i];
  }
}

function $destroyViews(this$static){
  var subTab, subTab$iterator;
  for (subTab$iterator = $iterator_0($values(this$static.subTabs)); subTab$iterator.val$outerIter.hasNext();) {
    subTab = dynamicCast($next_2(subTab$iterator), Q$SubTab);
    $destroyCanvas(subTab);
  }
}

function $disableSubTab(this$static, subTab){
  if (!!subTab && !!subTab.button) {
    $add_6(this$static.disabledSubTabs, subTab.id);
    $disable(subTab.button);
    $show(subTab.button);
  }
}

function $enableSubTab(this$static, subTab){
  if (!!subTab && !!subTab.button) {
    $remove_10(this$static.disabledSubTabs, subTab.id);
    $enable(subTab.button);
    $show(subTab.button);
  }
}

function $findClosestVisiblePredecessor(this$static, tab){
  var current;
  if (tab == this$static.head || !this$static.head) {
    return null;
  }
  current = this$static.head;
  while (current != tab) {
    if (!current.visibleNext || current.visibleNext == tab) {
      return current;
    }
    current = current.visibleNext;
  }
  return null;
}

function $findClosestVisibleSuccessor(this$static, tab){
  var current;
  current = tab;
  while (current) {
    if (!current.visibleNext && current != this$static.tail) {
      current = current.actualNext;
    }
     else {
      return current;
    }
  }
  return null;
}

function $fireSubTabSelection(this$static){
  var event_0;
  event_0 = new TwoLevelTabSelectedEvent_0('?', $getCurrentSubTab(this$static).viewName.name_0, (this$static.currentlyDisplayed?$getCanvas_2(this$static.currentlyDisplayed):$getCanvas_2(dynamicCast($get_4(this$static.subTabs, this$static.currentlySelected), Q$SubTab)) , $clinit_History() , impl_0?token_1 == null?'':token_1:''));
  $fireEvent(this$static.hm, event_0);
}

function $getCurrentCanvas(this$static){
  return this$static.currentlyDisplayed?$getCanvas_2(this$static.currentlyDisplayed):$getCanvas_2(dynamicCast($get_4(this$static.subTabs, this$static.currentlySelected), Q$SubTab));
}

function $getCurrentSubTab(this$static){
  var current;
  if (null == this$static.currentlySelected) {
    current = $getDefaultSubTab(this$static);
    !!current && (this$static.currentlySelected = current.id);
    return current;
  }
  return dynamicCast($get_4(this$static.subTabs, this$static.currentlySelected), Q$SubTab);
}

function $getDefaultSubTab(this$static){
  var subTab, subTab$iterator;
  for (subTab$iterator = $iterator_0($values(this$static.subTabs)); subTab$iterator.val$outerIter.hasNext();) {
    subTab = dynamicCast($next_2(subTab$iterator), Q$SubTab);
    if (!(!(!!subTab && !!subTab.button) || $getDisabled(subTab.button))) {
      return subTab;
    }
  }
  return null;
}

function $getSubTabByName(this$static, name_0){
  var subTab, subTabId, subTabId$iterator;
  for (subTabId$iterator = $iterator($keySet(this$static.subTabs)); subTabId$iterator.val$outerIter.hasNext();) {
    subTabId = dynamicCast($next_1(subTabId$iterator), Q$String);
    subTab = dynamicCast($get_4(this$static.subTabs, subTabId), Q$SubTab);
    if ($equals_6(subTab.viewName.name_0, name_0)) {
      return subTab;
    }
  }
  return null;
}

function $hideSubTab(this$static, subTab){
  var previous;
  previous = $findClosestVisiblePredecessor(this$static, subTab);
  if (!previous) {
    this$static.head = subTab.visibleNext;
  }
   else {
    $setVisibleNext(previous, subTab.visibleNext);
    !previous.visibleNext && (this$static.tail = previous);
  }
  subTab.visibleNext = null;
  $destroyButton(subTab);
}

function $isSubTabDisabled(subTab){
  return !(!!subTab && !!subTab.button) || $getDisabled(subTab.button);
}

function $registerSubTabs(this$static, tabs){
  var id, subTab, subTab$index, subTab$max;
  for (subTab$index = 0 , subTab$max = tabs.length; subTab$index < subTab$max; ++subTab$index) {
    subTab = tabs[subTab$index];
    id = subTab.id;
    $put_1(this$static.subTabs, id, subTab);
  }
  $buildSubTabList(tabs);
}

function $selectSubTab(this$static, subTab, showCanvas){
  if (!subTab) {
    throw new IllegalArgumentException_1('subTab is null.');
  }
  return $selectSubTabById(this$static, subTab.id, showCanvas);
}

function $selectSubTabById(this$static, id, showCanvas){
  var foundTab, subTab, subTabId, subTabId$iterator;
  foundTab = false;
  for (subTabId$iterator = $iterator($keySet(this$static.subTabs)); subTabId$iterator.val$outerIter.hasNext();) {
    subTabId = dynamicCast($next_1(subTabId$iterator), Q$String);
    if ($equals_6(subTabId, id)) {
      if ($contains_2(this$static.disabledSubTabs, subTabId)) {
        subTab = dynamicCast($get_4(this$static.subTabs, subTabId), Q$SubTab);
        $handleError_0(($clinit_CoreGUI() , 'Cannot select disabled subTab [' + ($clinit_Enhanced() , subTab.viewName.title_0) + '].'), null);
      }
       else {
        this$static.currentlySelected = subTabId;
        foundTab = true;
      }
      break;
    }
  }
  foundTab && $setCurrentlySelected(this$static, showCanvas);
  return foundTab;
}

function $setCurrentlySelected(this$static, showCanvas){
  var $e0, button, canvas, currentSubTab, self_0;
  if (null != this$static.currentlySelected) {
    button = dynamicCast($get_4(this$static.subTabs, this$static.currentlySelected), Q$SubTab).button;
    self_0 = button.getOrCreateJsObj();
    self_0.select();
    currentSubTab = dynamicCast($get_4(this$static.subTabs, this$static.currentlySelected), Q$SubTab);
    if (!!this$static.currentlyDisplayed && $getCanvas_2(this$static.currentlyDisplayed) != (!currentSubTab.canvas_0 && !!currentSubTab.viewFactory && (currentSubTab.canvas_0 = currentSubTab.viewFactory.createView()) , currentSubTab.canvas_0)) {
      try {
        $getCanvas_2(this$static.currentlyDisplayed).hide_0();
      }
       catch ($e0) {
        $e0 = caught_0($e0);
        if (!instanceOf($e0, Q$Exception))
          throw $e0;
      }
    }
    canvas = (!currentSubTab.canvas_0 && !!currentSubTab.viewFactory && (currentSubTab.canvas_0 = currentSubTab.viewFactory.createView()) , currentSubTab.canvas_0);
    if (canvas) {
      if ($hasMember(this$static, canvas).value_0) {
        !$isVisible(canvas) && showCanvas && canvas.show_0();
      }
       else {
        $isCreated_1(canvas) || canvas.setOverflow(($clinit_Overflow() , SCROLL));
        $addMember(this$static, canvas);
        !$isVisible(canvas) && showCanvas && canvas.show_0();
      }
      $markForRedraw(this$static);
      this$static.currentlyDisplayed = currentSubTab;
    }
  }
}

function $showSubTab(this$static, subTab){
  var button, previous, successor, button_0;
  button = subTab.button;
  if (!button) {
    button = (button_0 = new Button_2(subTab.viewName.title_0) , $setShowRollOver_0(button_0, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , $setAttribute_24(button_0, 'actionType', ($clinit_SelectionType() , RADIO).value_0, true) , $isCreated_1(button_0)?$setProperty_3(button_0, 'radioGroup', 'subTabs'):(button_0.config_0['radioGroup'] = 'subTabs' , undefined) , $isCreated_1(button_0)?$setProperty_3(button_0, 'border', null):(button_0.config_0['border'] = null , undefined) , button_0.setAutoFit(TRUE) , $isCreated_1(button_0)?$setProperty_3(button_0, 'baseStyle', 'SubTabButton'):(button_0.config_0['baseStyle'] = 'SubTabButton' , undefined) , $addClickHandler(button_0, new SubTabLayout$1_0(this$static, subTab)) , button_0);
    if (!this$static.head && !this$static.tail) {
      this$static.head = subTab;
      this$static.tail = subTab;
      $addMember(this$static.buttonBar, button);
    }
     else {
      successor = $findClosestVisibleSuccessor(this$static, subTab);
      if (!successor) {
        $setVisibleNext(this$static.tail, subTab);
        subTab.visibleNext = null;
        this$static.tail = subTab;
        $addMember(this$static.buttonBar, button);
      }
       else {
        previous = $findClosestVisiblePredecessor(this$static, successor);
        if (!previous) {
          $setVisibleNext(subTab, this$static.head);
          this$static.head = subTab;
          $addMember_0(this$static.buttonBar, button, 0);
        }
         else {
          $setVisibleNext(subTab, previous.visibleNext);
          previous.visibleNext = subTab;
          $addMember_0(this$static.buttonBar, button, $getMemberNumber(this$static.buttonBar, previous.button.id_0) + 1);
        }
      }
    }
    subTab.button = button;
  }
  $show(button);
}

function SubTabLayout_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.subTabs = new LinkedHashMap_0;
  this.disabledSubTabs = new HashSet_0;
  this.hm = new HandlerManager_0(this);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
}

defineSeed(2359, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), SubTabLayout_0);
_.onDraw_0 = function onDraw_19(){
  var initial;
  if (null == this.currentlySelected) {
    initial = $getDefaultSubTab(this);
    !!initial && (this.currentlySelected = initial.id);
  }
  null != this.currentlySelected && $selectSubTabById(this, this.currentlySelected, true);
}
;
_.onInit = function onInit_37(){
  $onInit(this);
  $onInit_Layout(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $setMargin(this, valueOf_44(0));
  $setPadding(this, valueOf_44(0));
  this.buttonBar = new EnhancedToolStrip_0;
  $setBackgroundColor(this.buttonBar, 'grey');
  $setAttribute_24(this.buttonBar, 'width', '100%', true);
  $setBorder(this.buttonBar);
  $setMembersMargin(this.buttonBar, 30);
  $addMember(this, this.buttonBar);
}
;
_.buttonBar = null;
_.currentlyDisplayed = null;
_.currentlySelected = null;
_.head = null;
_.tail = null;
function SubTabLayout$1_0(this$0, val$subTab){
  this.this$0 = this$0;
  this.val$subTab = val$subTab;
}

defineSeed(2360, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), SubTabLayout$1_0);
_.onClick = function onClick_81(clickEvent){
  this.this$0.currentlySelected = this.val$subTab.id;
  $fireSubTabSelection(this.this$0);
  $markForRedraw(this.this$0);
}
;
_.this$0 = null;
_.val$subTab = null;
function $registerSubTabs_0(this$static, subTabs){
  $registerSubTabs(this$static.layout, subTabs);
}

function $setVisibleNext_0(this$static, visibleNext){
  this$static.visibleNext = visibleNext;
}

function TwoLevelTab_0(viewName, icon){
  NamedTab_1.call(this, viewName, icon);
  this.layout = new SubTabLayout_0;
}

function TwoLevelTab_1(viewName, iconEnum){
  NamedTab_1.call(this, viewName, iconEnum.icon16x16DisabledPath);
  this.layout = new SubTabLayout_0;
}

defineSeed(2361, 2356, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Tab, Q$HasTabDeselectedHandlers, Q$HasTabSelectedHandlers, Q$NamedTab, Q$TwoLevelTab]), TwoLevelTab_0, TwoLevelTab_1);
_.getPane = function getPane_0(){
  return this.layout;
}
;
_.toString$ = function toString_206(){
  return 'TwoLevelTab[title=' + this.viewName.title_0 + ', viewName=' + this.viewName + ']';
}
;
_.actualNext = null;
_.layout = null;
_.visibleNext = null;
function $clinit_TwoLevelTabSelectedEvent(){
  $clinit_TwoLevelTabSelectedEvent = nullMethod;
  TYPE_54 = new GwtEvent$Type_0;
}

function $setId_8(this$static, id){
  this$static.id = id;
}

function TwoLevelTabSelectedEvent_0(id, subTabId, historyToken){
  $clinit_TwoLevelTabSelectedEvent();
  this.id = id;
  this.subTabId = subTabId;
  this.historyToken = historyToken;
}

defineSeed(2362, 55, {}, TwoLevelTabSelectedEvent_0);
_.dispatch = function dispatch_54(handler){
  dynamicCast(handler, Q$TwoLevelTabSelectedHandler).onTabSelected_0(this);
}
;
_.getAssociatedType = function getAssociatedType_54(){
  return TYPE_54;
}
;
_.historyToken = null;
_.id = null;
_.subTabId = null;
var TYPE_54;
function $addTwoLevelTabSelectedHandler_0(this$static, handler){
  return $addHandler(this$static.m_0, ($clinit_TwoLevelTabSelectedEvent() , TYPE_54), handler);
}

function $buildTabList(this$static){
  var current, i, tabs;
  tabs = $getTabs_0(this$static);
  this$static.head = tabs[0];
  this$static.tail = tabs[tabs.length - 1];
  current = this$static.head;
  for (i = 1; i < tabs.length; ++i) {
    current.actualNext = tabs[i];
    current.visibleNext = tabs[i];
    current = tabs[i];
  }
}

function $destroy_4(this$static){
  var tab, tab$array, tab$index, tab$iterator, tab$max;
  for (tab$iterator = $iterator_0($values(this$static.hiddenTabs)); tab$iterator.val$outerIter.hasNext();) {
    tab = dynamicCast($next_2(tab$iterator), Q$TwoLevelTab);
    $addTab(this$static, tab);
  }
  for (tab$array = $getTabs_0(this$static) , tab$index = 0 , tab$max = tab$array.length; tab$index < tab$max; ++tab$index) {
    tab = tab$array[tab$index];
    $destroyViews(tab.layout);
  }
  $destroy_3(this$static);
}

function $destroyViews_0(this$static){
  var tab, tab$array, tab$index, tab$max;
  for (tab$array = $getTabs_0(this$static) , tab$index = 0 , tab$max = tab$array.length; tab$index < tab$max; ++tab$index) {
    tab = tab$array[tab$index];
    $destroyViews(tab.layout);
  }
}

function $findClosestVisiblePredecessor_0(this$static, tab){
  var current;
  if (tab == this$static.head) {
    return null;
  }
  current = this$static.head;
  while (current != tab) {
    if (!current.visibleNext || current.visibleNext == tab) {
      return current;
    }
    current = current.visibleNext;
  }
  return null;
}

function $findClosestVisibleSuccessor_0(this$static, tab){
  var current;
  current = tab;
  while (current) {
    if (!current.visibleNext && current != this$static.tail) {
      current = current.actualNext;
    }
     else {
      return current;
    }
  }
  return null;
}

function $getDefaultTab(this$static){
  var tab, tab$index, tab$max, tabs;
  tabs = $getTabs_0(this$static);
  for (tab$index = 0 , tab$max = tabs.length; tab$index < tab$max; ++tab$index) {
    tab = tabs[tab$index];
    if (!(!tab.tabSet || !$isDrawn(tab.tabSet).value_0?$getAttributeAsBoolean_0(tab, 'disabled'):$getAttributeAsBoolean_0($getTab(tab.tabSet, getAttribute(tab.jsObj, 'ID')), 'disabled')).value_0) {
      return tab;
    }
  }
  return null;
}

function $getTabs_0(this$static){
  var i, tab, tabs, tabsLength, twoLevelTabs;
  tabs = $getTabs(this$static);
  twoLevelTabs = initDim(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_TwoLevelTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$TwoLevelTab_$1]), Q$TwoLevelTab, tabs.length, 0);
  for (i = 0 , tabsLength = tabs.length; i < tabsLength; ++i) {
    tab = tabs[i];
    if (!instanceOf(tab, Q$TwoLevelTab)) {
      throw new IllegalStateException_1('TwoLevelTabSet contains a Tab that is not a TwoLevelTab.');
    }
    twoLevelTabs[i] = dynamicCast(tab, Q$TwoLevelTab);
  }
  return twoLevelTabs;
}

function $setTabEnabled(this$static, tab, enabled){
  var self_0, tabJS, self_1, tabJS_0;
  enabled?(self_0 = this$static.getOrCreateJsObj() , tabJS = tab.getJsObj() , self_0.enableTab(tabJS) , undefined):(self_1 = this$static.getOrCreateJsObj() , tabJS_0 = tab.getJsObj() , self_1.disableTab(tabJS_0) , undefined);
}

function $setTabHidden(this$static, tab, hidden){
  var successor, visiblePrevious;
  if (hidden) {
    if ($containsKey_1(this$static.hiddenTabs, tab.viewName.name_0)) {
      return;
    }
    visiblePrevious = $findClosestVisiblePredecessor_0(this$static, tab);
    if (!visiblePrevious) {
      this$static.head = tab.visibleNext;
    }
     else {
      $setVisibleNext_0(visiblePrevious, tab.visibleNext);
      !visiblePrevious.visibleNext && (this$static.tail = visiblePrevious);
    }
    tab.visibleNext = null;
    $removeTab(this$static, tab);
    $put_1(this$static.hiddenTabs, tab.viewName.name_0, tab);
  }
   else {
    if (!$containsKey_1(this$static.hiddenTabs, tab.viewName.name_0)) {
      return;
    }
    $remove_11(this$static.hiddenTabs, tab.viewName.name_0);
    successor = $findClosestVisibleSuccessor_0(this$static, tab);
    if (!successor) {
      $setVisibleNext_0(this$static.tail, tab);
      this$static.tail = tab;
      $addTab(this$static, tab);
    }
     else {
      visiblePrevious = $findClosestVisiblePredecessor_0(this$static, successor);
      $setVisibleNext_0(tab, visiblePrevious.visibleNext);
      visiblePrevious.visibleNext = tab;
      $addTab_0(this$static, tab, $getTabNumber(this$static, getAttribute(visiblePrevious.jsObj, 'ID')) + 1);
    }
  }
}

function $setTabs_0(this$static, tabs){
  var tab, tab$index, tab$max;
  $setTabs(this$static, tabs);
  for (tab$index = 0 , tab$max = tabs.length; tab$index < tab$max; ++tab$index) {
    tab = tabs[tab$index];
    $addTwoLevelTabSelectedHandler(tab.layout, this$static);
    $updateTab(this$static, tab, tab.layout);
  }
  $buildTabList(this$static);
  $getHandlerCount_1(this$static, (!TYPE_50 && (TYPE_50 = new GwtEvent$Type_0) , TYPE_50)) == 0 && $setupTabSelectedEvent(this$static);
  $doAddHandler_0(this$static, this$static, (!TYPE_50 && (TYPE_50 = new GwtEvent$Type_0) , TYPE_50));
}

function TwoLevelTabSet_0(){
  NamedTabSet_0.call(this);
  this.hiddenTabs = new LinkedHashMap_0;
  this.m_0 = new HandlerManager_0(this);
  $setDestroyPanes(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
}

defineSeed(2363, 2357, makeCastMap([Q$HasAttachHandlers, Q$EventHandler, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$HasTabDeselectedHandlers, Q$HasTabSelectedHandlers, Q$TabSelectedHandler, Q$TwoLevelTabSelectedHandler]), TwoLevelTabSet_0);
_.destroy_0 = function destroy_11(){
  $destroy_4(this);
}
;
_.getTabByTitle = function getTabByTitle_0(title){
  return dynamicCast($getTabByTitle(this, title), Q$TwoLevelTab);
}
;
_.getTabs = function getTabs_0(){
  return $getTabs_0(this);
}
;
_.onTabSelected = function onTabSelected(tabSelectedEvent){
  var currentSubTab, event_0, tab;
  if (this.ignoreSelectEvents) {
    return;
  }
  tab = dynamicCast($getSelectedTab(this), Q$TwoLevelTab);
  currentSubTab = $getCurrentSubTab(tab.layout);
  if (currentSubTab) {
    event_0 = new TwoLevelTabSelectedEvent_0(tab.viewName.name_0, $getCurrentSubTab(tab.layout).viewName.name_0, ($getTabNum(tabSelectedEvent) , $getCurrentCanvas(tab.layout) , $clinit_History() , impl_0?token_1 == null?'':token_1:''));
    $fireEvent(this.m_0, event_0);
  }
}
;
_.onTabSelected_0 = function onTabSelected_0(tabSelectedEvent){
  var tab, self_0;
  if (this.ignoreSelectEvents) {
    return;
  }
  self_0 = this.getOrCreateJsObj();
  self_0.getSelectedTabNumber();
  tab = $getSelectedTab(this);
  $setId_8(tabSelectedEvent, dynamicCast($getTabByTitle(this, tab.getTitle()), Q$TwoLevelTab).viewName.name_0);
  $fireEvent(this.m_0, tabSelectedEvent);
}
;
_.head = null;
_.ignoreSelectEvents = false;
_.tail = null;
function AbstractTableSection$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2364, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), AbstractTableSection$1_0);
_.onDoubleClick = function onDoubleClick_7(event_0){
  var listGrid, selectedRows;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  selectedRows != null && selectedRows.length == 1 && this.this$0.showDetails(selectedRows[0]);
}
;
_.this$0 = null;
function AbstractTableSection$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2365, 1, {}, AbstractTableSection$2_0);
_.format_1 = function format_26(value, record, i, i1){
  var detailsUrl, formattedValue, recordId;
  if (value == null) {
    return '';
  }
  recordId = this.this$0.getId_0(record);
  detailsUrl = '#' + this.this$0.getBasePath() + '/' + this.this$0.convertIDToCurrentViewPath(recordId);
  formattedValue = this.this$0.escapeHtmlInDetailsLinkColumn?escapeHtml(toString__devirtual$(value)):toString__devirtual$(value);
  return getHref(detailsUrl, formattedValue);
}
;
_.this$0 = null;
function AbstractTableSection$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2366, 1, {}, AbstractTableSection$3_0);
_.execute_5 = function execute_44(b){
  $buildDetailsView(this.this$0);
}
;
_.this$0 = null;
function AbstractTableSection$4_0(this$0, val$contents){
  this.this$0 = this$0;
  this.val$contents = val$contents;
}

defineSeed(2367, 1, {}, AbstractTableSection$4_0);
_.execute_5 = function execute_45(b){
  destroyMembers(this.this$0.detailsHolder);
  $animateShow(this.val$contents, ($clinit_AnimationEffect() , WIPE));
}
;
_.this$0 = null;
_.val$contents = null;
function AuthorizedTableAction$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2368, 1, {}, AuthorizedTableAction$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_6(grantedPermissions){
  var requiredPermission, requiredPermission$iterator;
  if (!grantedPermissions) {
    return;
  }
  for (requiredPermission$iterator = $iterator($keySet(this.this$0.globalPermissions.map)); requiredPermission$iterator.val$outerIter.hasNext();) {
    requiredPermission = dynamicCast($next_1(requiredPermission$iterator), Q$Permission);
    if (!grantedPermissions.contains_0(requiredPermission)) {
      return;
    }
  }
  this.this$0.isGlobalAuthorized = ($clinit_Boolean() , $clinit_Boolean() , TRUE);
  this.this$0.table.refreshTableInfo();
}
;
_.this$0 = null;
function $format_1(value){
  var imageUrl, result;
  if (value == null) {
    imageUrl = 'images/subsystems/availability/availability_grey_16.png';
  }
   else if (instanceOf(value, Q$Boolean)) {
    imageUrl = dynamicCast(value, Q$Boolean).value_0?'images/global/permission_enabled_11.png':'images/global/permission_disabled_11.png';
  }
   else {
    throw new IllegalArgumentException_1('value parameter is not a Boolean.');
  }
  result = '<img src="' + imageUrl + '" width="11" height="11"/>';
  return result;
}

defineSeed(2369, 1, {});
_.format_1 = function format_27(value, record, rowNum, colNum){
  return $format_1(value);
}
;
function EscapedHtmlCellFormatter_0(){
}

defineSeed(2370, 1, {}, EscapedHtmlCellFormatter_0);
_.format_1 = function format_28(value, record, rowNum, colNum){
  return value != null?escapeHtml(toString__devirtual$(value)):'';
}
;
function $init_6(this$static){
  $setAttribute_13(this$static, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(this$static, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_8(this$static, 'showDefaultContextMenu', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $equals_6('&nbsp;', getAttribute(this$static.jsObj, 'title')) && $setAttribute_8(this$static, 'canHide', FALSE);
}

function IconField_0(){
  ListGridField_4.call(this, 'icon', '&nbsp;', 25);
  $init_6(this);
}

function IconField_1(name_0){
  ListGridField_4.call(this, name_0, '&nbsp;', 25);
  $init_6(this);
}

function IconField_2(name_0, title, width){
  ListGridField_4.call(this, name_0, title, width);
  $init_6(this);
}

defineSeed(2371, 539, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$ListGridField, Q$HasCellSavedHandlers, Q$HasChangeHandlers_0, Q$HasChangedHandlers_0, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers]), IconField_0, IconField_1, IconField_2);
function $onSuccess_181(this$static, result){
  var isStale;
  isStale = !$equals(this$static.val$selectedResourceIds, this$static.this$0.authorizedResourceIds);
  if (isStale) {
    return;
  }
  this$static.this$0.isAuthorized = result;
  this$static.this$0.table.refreshTableInfo();
}

function ResourceAuthorizedTableAction$1_0(this$0, val$selectedResourceIds){
  this.this$0 = this$0;
  this.val$selectedResourceIds = val$selectedResourceIds;
}

defineSeed(2372, 1, {}, ResourceAuthorizedTableAction$1_0);
_.onFailure = function onFailure_191(caught){
  $handleError_0(($clinit_CoreGUI() , ''), caught);
}
;
_.onSuccess_0 = function onSuccess_191(result){
  $onSuccess_181(this, dynamicCast(result, Q$Boolean));
}
;
_.this$0 = null;
_.val$selectedResourceIds = null;
function $clinit_ResourceCategoryCellFormatter(){
  $clinit_ResourceCategoryCellFormatter = nullMethod;
  $clinit_CoreGUI();
}

function $getDisplayName_0(resourceCategory){
  var displayName;
  displayName = '';
  switch (resourceCategory.ordinal) {
    case 0:
      displayName = 'Platform';
      break;
    case 1:
      displayName = 'Server';
      break;
    case 2:
      displayName = 'Service';
  }
  return displayName;
}

function ResourceCategoryCellFormatter_0(){
  $clinit_ResourceCategoryCellFormatter();
}

defineSeed(2373, 1, {}, ResourceCategoryCellFormatter_0);
_.format_1 = function format_29(value, record, rowNum, colNum){
  var categoryName, resourceCategory;
  if (value == null) {
    return 'null';
  }
  if (instanceOf(value, Q$ResourceCategory)) {
    resourceCategory = dynamicCast(value, Q$ResourceCategory);
  }
   else if (instanceOf(value, Q$String)) {
    categoryName = dynamicCast(value, Q$String);
    resourceCategory = ($clinit_ResourceCategory() , dynamicCast(valueOf(($clinit_ResourceCategory$Map() , $MAP_104), categoryName), Q$ResourceCategory));
  }
   else {
    throw new IllegalArgumentException_1('This cell formatter does not support values of type ' + getClass__devirtual$(value).typeName);
  }
  return $getDisplayName_0(resourceCategory);
}
;
function $convertCurrentViewPathToID_0(path){
  if (path.indexOf('0id_') != 0) {
    return path;
  }
  return $substring(path, 4);
}

function $convertIDToCurrentViewPath_0(id){
  if (id.indexOf('0id_') == 0) {
    return id;
  }
  return '0id_' + id;
}

function $getId_0(this$static, record){
  var id, msg;
  id = null;
  !!record && (id = getAttribute(record.jsObj, 'id'));
  if (id == null || id.length == 0) {
    msg = 'Table [' + ($clinit_Enhanced() , $toString_5(this$static.___clazz$)) + '] record is missing id attribute - please report this bug.';
    $handleError_0(($clinit_CoreGUI() , msg), null);
    throw new IllegalStateException_1(msg);
  }
  return id;
}

function $showDetails_1(this$static, id){
  var msg;
  if (id != null && id.length > 0) {
    $clinit_CoreGUI();
    goToView(this$static.basePath + '/' + $convertIDToCurrentViewPath_0(id), null, false);
  }
   else {
    msg = 'Can not show detail for [' + ($clinit_Enhanced() , $toString_5(this$static.___clazz$)) + ']. Illegal id: [' + (id == null?'null':id) + ']. Please report this bug';
    $handleError_0(($clinit_CoreGUI() , msg), null);
    throw new IllegalArgumentException_1(msg);
  }
}

function StringIDTableSection_0(tableTitle, criteria, sortSpecifiers){
  $clinit_BaseWidget();
  AbstractTableSection_0.call(this, tableTitle, criteria, sortSpecifiers);
}

defineSeed(2374, 1604, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.convertCurrentViewPathToID = function convertCurrentViewPathToID_0(path){
  return $convertCurrentViewPathToID_0(path);
}
;
_.convertIDToCurrentViewPath = function convertIDToCurrentViewPath_0(id){
  return $convertIDToCurrentViewPath_0(dynamicCast(id, Q$String));
}
;
_.getDetailsView = function getDetailsView_14(id){
  return this.getDetailsView_2(dynamicCast(id, Q$String));
}
;
_.getId_0 = function getId_4(record){
  return $getId_0(this, record);
}
;
_.showDetails_0 = function showDetails_1(id){
  $showDetails_1(this, dynamicCast(id, Q$String));
}
;
function Table$8_0(this$0, val$deletedRecordNames, val$selectedRecordCount){
  this.this$0 = this$0;
  this.val$deletedRecordNames = val$deletedRecordNames;
  this.val$selectedRecordCount = val$selectedRecordCount;
}

defineSeed(2383, 1, {}, Table$8_0);
_.execute_2 = function execute_47(response, rawData, request){
  var deletedMessage, deletedMessageDetail, deletedRecord, deletedRecord$index, deletedRecord$max, deletedRecords, message, name_0;
  if (getAttributeAsInt(response.jsObj, 'status').value_0 == 0) {
    deletedRecords = $getData(response);
    for (deletedRecord$index = 0 , deletedRecord$max = deletedRecords.length; deletedRecord$index < deletedRecord$max; ++deletedRecord$index) {
      deletedRecord = deletedRecords[deletedRecord$index];
      name_0 = $getAttribute(deletedRecord, this.this$0.getTitleFieldName());
      $add_3(this.val$deletedRecordNames, name_0);
    }
    if (this.val$deletedRecordNames.size_0 == this.val$selectedRecordCount) {
      deletedMessage = $getDeletedMessage(this.val$deletedRecordNames.size_0);
      deletedMessageDetail = deletedMessage + ': [' + this.val$deletedRecordNames.toString$() + ']';
      message = new Message_1(deletedMessage, deletedMessageDetail);
      $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
      this.this$0.refresh_0();
    }
  }
}
;
_.this$0 = null;
_.val$deletedRecordNames = null;
_.val$selectedRecordCount = 0;
defineSeed(2391, 446, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$Enhanced]));
_.destroy_0 = function destroy_12(){
  destroyMembers(this);
  $destroy(this);
}
;
function $createTagLayouts(this$static){
  var remove, spacer, tag, tag$iterator, tagLayout, tagLayouts, tagString;
  tagLayouts = new ArrayList_1(this$static.tags.map.size_1());
  for (tag$iterator = $iterator($keySet(this$static.tags.map)); tag$iterator.val$outerIter.hasNext();) {
    tag = dynamicCast($next_1(tag$iterator), Q$Tag);
    tagLayout = new EnhancedHLayout_0;
    $isCreated_1(tagLayout)?$setProperty_0(tagLayout, 'height', 18):(tagLayout.config_0['height'] = 18 , undefined);
    $isCreated_1(tagLayout)?$setProperty_0(tagLayout, 'height', 16):(tagLayout.config_0['height'] = 16 , undefined);
    tagString = new HTMLFlow_1('<nobr><a href="' + getTagLink((tag.namespace != null?tag.namespace + ':':'') + (tag.semantic != null?tag.semantic + '=':'') + tag.name_0) + '">' + ((tag.namespace != null?tag.namespace + ':':'') + (tag.semantic != null?tag.semantic + '=':'') + tag.name_0) + '<\/a><\/nobr>');
    $isCreated_1(tagString)?$setProperty_0(tagString, 'width', 1):(tagString.config_0['width'] = 1 , undefined);
    $addMember(tagLayout, tagString);
    if (!this$static.readOnly) {
      spacer = new LayoutSpacer_0;
      $isCreated_1(spacer)?$setProperty_0(spacer, 'height', 16):(spacer.config_0['height'] = 16 , undefined);
      $isCreated_1(spacer)?$setProperty_0(spacer, 'width', 16):(spacer.config_0['width'] = 16 , undefined);
      remove = new Img_2('[skin]/images/actions/remove.png', 16, 16);
      $setPrompt_0(remove, ($clinit_Enhanced() , 'Click to remove this Tag'));
      $addClickHandler(remove, new TagEditorView$2_0(this$static, tag));
      $addMember(tagLayout, remove);
      $addMember(tagLayout, spacer);
      $hide(remove);
      $addMouseOverHandler(tagLayout, new TagEditorView$3_0(remove, spacer));
      $addMouseOutHandler(tagLayout, new TagEditorView$4_0(spacer, remove));
    }
    setCheck(tagLayouts.array, tagLayouts.size_0++, tagLayout);
  }
  return tagLayouts;
}

function $save_2(this$static){
  this$static.callback.tagsChanged(this$static.tags);
  $setup_0(this$static);
}

function $setTags_1(this$static, tags){
  this$static.tags.map.clear_0();
  !!tags && $addAll(this$static.tags, tags);
  $setup_0(this$static);
}

function $setup_0(this$static){
  var canvas, canvas$array, canvas$index, canvas$max, tagLayout, tagLayout$iterator;
  if (this$static.tagLayouts) {
    for (tagLayout$iterator = new AbstractList$IteratorImpl_0(this$static.tagLayouts); tagLayout$iterator.i < tagLayout$iterator.this$0_0.size_1();) {
      tagLayout = dynamicCast($next_0(tagLayout$iterator), Q$EnhancedHLayout);
      $removeMember(this$static, tagLayout);
      tagLayout.destroy_0();
    }
  }
  for (canvas$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members')) , canvas$index = 0 , canvas$max = canvas$array.length; canvas$index < canvas$max; ++canvas$index) {
    canvas = canvas$array[canvas$index];
    $removeMember(this$static, canvas);
  }
  $addMember(this$static, this$static.tagTitleLabel);
  this$static.tagLayouts = $createTagLayouts(this$static);
  for (tagLayout$iterator = new AbstractList$IteratorImpl_0(this$static.tagLayouts); tagLayout$iterator.i < tagLayout$iterator.this$0_0.size_1();) {
    tagLayout = dynamicCast($next_0(tagLayout$iterator), Q$EnhancedHLayout);
    $addMember(this$static, tagLayout);
  }
  if (!this$static.readOnly) {
    $addMember(this$static, this$static.addImg);
    $place(this$static.tagInputDialog, this$static.addImg);
  }
  $markForRedraw(this$static);
}

function $showTagInput(this$static){
  var criteria;
  criteria = new TagCriteria_0;
  $addSortNamespace(criteria, ($clinit_PageOrdering() , ASC));
  $addSortSemantic(criteria, ASC);
  $addSortName_2(criteria, ASC);
  $findTagsByCriteria(dynamicCast(secure(getInstance_56(), -1), Q$TagGWTServiceAsync), criteria, new TagEditorView$5_0(this$static));
  $show_3(this$static.tagInputDialog);
  $place(this$static.tagInputDialog, this$static.addImg);
  $markForRedraw(this$static);
}

function TagEditorView_0(tags, readOnly, callback){
  $clinit_BaseWidget();
  TagEditorView_1.call(this, tags, readOnly, callback);
}

function TagEditorView_1(tags, readOnly, callback){
  Layout_0.call(this);
  this.tags = new LinkedHashSet_0;
  $setVertical(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_1(this)?$setProperty_0(this, 'width', 1):(this.config_0['width'] = 1 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 8):(this.config_0['membersMargin'] = 8 , undefined);
  !!tags && $addAll(this.tags, tags);
  this.readOnly = readOnly;
  this.callback = callback;
  this.tagTitleLabel = new HTMLFlow_1('<nobr><b>' + ($clinit_Enhanced() , 'Tags') + ':<\/b><\/nobr>');
  $setAutoWidth(this.tagTitleLabel);
  if (!this.readOnly) {
    this.tagInputDialog = new TagEditorView$TagInputDialog_0(this);
    this.addImg = new Img_2('[skin]/images/actions/add.png', 16, 16);
    $setPrompt_0(this.addImg, 'Click to edit Tags');
    $addClickHandler(this.addImg, new TagEditorView$1_0(this));
  }
}

defineSeed(2390, 2391, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$Enhanced]), TagEditorView_0);
_.onDraw_0 = function onDraw_20(){
  $setup_0(this);
}
;
_.addImg = null;
_.callback = null;
_.readOnly = false;
_.tagInputDialog = null;
_.tagLayouts = null;
_.tagTitleLabel = null;
function TagEditorView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2392, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), TagEditorView$1_0);
_.onClick = function onClick_85(clickEvent){
  $showTagInput(this.this$0);
}
;
_.this$0 = null;
function TagEditorView$2_0(this$0, val$tag){
  this.this$0 = this$0;
  this.val$tag = val$tag;
}

defineSeed(2393, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), TagEditorView$2_0);
_.onClick = function onClick_86(clickEvent){
  $remove_10(this.this$0.tags, this.val$tag);
  $save_2(this.this$0);
}
;
_.this$0 = null;
_.val$tag = null;
function TagEditorView$3_0(val$remove, val$spacer){
  this.val$remove = val$remove;
  this.val$spacer = val$spacer;
}

defineSeed(2394, 1, makeCastMap([Q$EventHandler, Q$MouseOverHandler]), TagEditorView$3_0);
_.onMouseOver = function onMouseOver_0(mouseOverEvent){
  $show(this.val$remove);
  $hide(this.val$spacer);
}
;
_.val$remove = null;
_.val$spacer = null;
function TagEditorView$4_0(val$spacer, val$remove){
  this.val$spacer = val$spacer;
  this.val$remove = val$remove;
}

defineSeed(2395, 1, makeCastMap([Q$EventHandler, Q$MouseOutHandler]), TagEditorView$4_0);
_.onMouseOut = function onMouseOut_0(mouseOutEvent){
  $show(this.val$spacer);
  $hide(this.val$remove);
}
;
_.val$remove = null;
_.val$spacer = null;
function $onSuccess_182(this$static, result){
  var i, tag, tag$iterator, values;
  values = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, result.size_0, 0);
  i = 0;
  for (tag$iterator = new AbstractList$IteratorImpl_0(result); tag$iterator.i < tag$iterator.this$0_0.size_1();) {
    tag = dynamicCast($next_0(tag$iterator), Q$Tag);
    values[i++] = (tag.namespace != null?tag.namespace + ':':'') + (tag.semantic != null?tag.semantic + '=':'') + tag.name_0;
  }
  $setTagSuggestions(this$static.this$0.tagInputDialog, values);
}

function TagEditorView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2396, 1, {}, TagEditorView$5_0);
_.onFailure = function onFailure_192(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load Tags'), caught);
}
;
_.onSuccess_0 = function onSuccess_192(result){
  $onSuccess_182(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $place(this$static, canvas){
  $moveTo(this$static, $getPageLeft(canvas) - 8, $getPageTop(canvas) - 4);
}

function $setTagSuggestions(this$static, suggestions){
  $setValueMap_0(this$static.tagInputItem, suggestions);
}

function $show_3(this$static){
  $show(this$static);
  $clearValue_0(this$static.tagInputItem);
  $focusInItem(this$static.tagInputItem);
}

function TagEditorView$TagInputDialog_0(this$0){
  $clinit_Dialog();
  var bodyDefaults, form;
  this.this$0 = this$0;
  Window_1.call(this);
  this.scClassName = 'Dialog';
  $setIsModal(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setShowHeader(this, FALSE);
  $setShowEdges(this, FALSE);
  $isCreated_1(this)?undefined:(this.config_0['edgeSize'] = 10 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'width', 200):(this.config_0['width'] = 200 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'height', 30):(this.config_0['height'] = 30 , undefined);
  $setAttribute_22(this, 'showToolbar', FALSE, true);
  $setDismissOnEscape(this, TRUE);
  $setDismissOnOutsideClick(this, TRUE);
  bodyDefaults = new HashMap_1(2);
  bodyDefaults.put('layoutLeftMargin', valueOf_44(5));
  bodyDefaults.put('membersMargin', valueOf_44(10));
  $isCreated_1(this)?$setProperty_2(this, 'bodyDefaults', convertMapToJavascriptObject(bodyDefaults)):setAttribute_10(this.config_0, 'bodyDefaults', bodyDefaults);
  form = new DynamicForm_0;
  $addItem(this, form);
  this.tagInputItem = new ComboBoxItem_1('tag');
  $setShowTitle_0(this.tagInputItem, FALSE);
  $setAttribute_29(this.tagInputItem, 'hideEmptyPickList', TRUE);
  $setAttribute_30(this.tagInputItem, 'valueField', 'tag');
  $setAttribute_30(this.tagInputItem, 'displayField', 'tag');
  $setType(this.tagInputItem, 'comboBox');
  $setAttribute_30(this.tagInputItem, 'textMatchStyle', ($clinit_TextMatchStyle() , SUBSTRING).value_0);
  $setPrompt_1(this.tagInputItem, ($clinit_Enhanced() , 'Enter a Tag in the format: (namespace:)(semantic=)tagname (e.g. it:env=QA, or owner=John)'));
  $addKeyPressHandler_0(this.tagInputItem, new TagEditorView$TagInputDialog$1_0(this));
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.tagInputItem]));
}

defineSeed(2397, 443, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), TagEditorView$TagInputDialog_0);
_.show_0 = function show_2(){
  $show_3(this);
}
;
_.tagInputItem = null;
_.this$0 = null;
function TagEditorView$TagInputDialog$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2398, 1, makeCastMap([Q$EventHandler, Q$KeyPressHandler_0]), TagEditorView$TagInputDialog$1_0);
_.onKeyPress = function onKeyPress_4(event_0){
  var newTag, tag;
  if (!!$getCharacterValue(event_0) && $getCharacterValue(event_0).value_0 == 13) {
    tag = $getEnteredValue_0(this.this$1.tagInputItem);
    if (tag != null) {
      newTag = new Tag_1(tag);
      $add_6(this.this$1.this$0.tags, newTag);
      $save_2(this.this$1.this$0);
      $hide(this.this$1);
    }
  }
}
;
_.this$1 = null;
function $isFolderNode(this$static){
  var children, isFolder;
  isFolder = ($clinit_Boolean() , getAttributeAsBoolean(this$static.jsObj, 'isFolder')?TRUE:FALSE);
  if (!isFolder) {
    children = getAttributeAsBoolean(this$static.jsObj, 'children')?TRUE:FALSE;
    isFolder = children?TRUE:FALSE;
  }
  return isFolder.value_0;
}

function EnhancedTreeNode_0(){
  TreeNode_0.call(this);
}

function EnhancedTreeNode_1(name_0, title, children){
  ListGridRecord_0.call(this);
  this.setName(name_0);
  this.jsObj['children'] = convertToJavaScriptArray(children);
  null == title || $equals_6('', $trim(title))?name_0 != null && (this.jsObj['title'] = name_0 , undefined):(this.jsObj['title'] = title , undefined);
}

defineSeed(2399, 577, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$EnhancedTreeNode]), EnhancedTreeNode_1);
_.setName = function setName_50(name_0){
  this.jsObj['name'] = name_0;
  name_0 != null && getAttribute(this.jsObj, 'title') == null && (this.jsObj['title'] = name_0 , undefined);
}
;
_.toString$ = function toString_207(){
  var $e0, buffer, className, id, innerClassName, name_0, parentId, simpleClassName;
  buffer = new StringBuilder_0;
  try {
    className = this.___clazz$.typeName;
    simpleClassName = $substring(className, className.lastIndexOf('.') + 1);
    innerClassName = $substring(simpleClassName, simpleClassName.lastIndexOf('$') + 1);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$RuntimeException)) {
      innerClassName = 'EnhancedTreeNode';
    }
     else 
      throw $e0;
  }
  $append_12(($append_1(buffer.data_0, innerClassName) , buffer), '[');
  id = getAttribute(this.jsObj, 'id');
  $append_12(($append_1(buffer.data_0, 'id=') , buffer), id);
  parentId = getAttribute(this.jsObj, 'parentId');
  $append_12(($append_1(buffer.data_0, ', parentId=') , buffer), parentId);
  name_0 = getAttribute(this.jsObj, 'name');
  $append_12(($append_1(buffer.data_0, ', name=') , buffer), name_0);
  $append_1(buffer.data_0, ']');
  return $toString_1(buffer.data_0);
}
;
function $changeCalendarType(this$static, calendarType){
  var repeatIntervalItem;
  if ($equals_6(calendarType, 'now')) {
    this$static.isStartLater = false;
    this$static.isRecurring = false;
  }
   else if ($equals_6(calendarType, 'nowAndRepeat')) {
    this$static.isStartLater = false;
    this$static.isRecurring = true;
    repeatIntervalItem = $getField_0(this$static.repeatForm, 'repeatInterval');
    repeatIntervalItem.setTitle(($clinit_Enhanced() , 'Run now and every'));
    $redraw_0(repeatIntervalItem);
  }
   else if ($equals_6(calendarType, 'later')) {
    this$static.isStartLater = true;
    this$static.isRecurring = false;
  }
   else {
    this$static.isStartLater = true;
    this$static.isRecurring = true;
    repeatIntervalItem = $getField_0(this$static.repeatForm, 'repeatInterval');
    repeatIntervalItem.setTitle(($clinit_Enhanced() , 'Repeat every'));
    $redraw_0(repeatIntervalItem);
  }
  this$static.isStartLater?$show(this$static.laterForm):$hide(this$static.laterForm);
  this$static.isRecurring?$show(this$static.repeatForm):$hide(this$static.repeatForm);
}

function $changeMode(this$static, mode){
  if ($equals_6(mode, 'calendar')) {
    $show(this$static.calendarModeLayout);
    this$static.cronModeLayout.hide_0();
  }
   else {
    this$static.calendarModeLayout.hide_0();
    $show(this$static.cronModeLayout);
  }
}

function $changeRecurrenceType(this$static, recurrenceType, endTimeItem, repeatDurationItem){
  if ($equals_6(recurrenceType, 'for')) {
    this$static.isEndTime = false;
    this$static.isRepeatDuration = true;
  }
   else if ($equals_6(recurrenceType, 'until')) {
    this$static.isEndTime = true;
    this$static.isRepeatDuration = false;
  }
   else {
    this$static.isEndTime = false;
    this$static.isRepeatDuration = false;
  }
  $setRequired(endTimeItem, ($clinit_Boolean() , this$static.isEndTime?TRUE:FALSE));
  this$static.isEndTime?$show_0(endTimeItem):$hide_0(endTimeItem);
  $setRequired(repeatDurationItem, this$static.isRepeatDuration?TRUE:FALSE);
  this$static.isRepeatDuration?$show_0(repeatDurationItem):$hide_0(repeatDurationItem);
}

function $changeStartType(this$static, startType, startDelayItem, startTimeItem){
  if ($equals_6(startType, 'on')) {
    this$static.isStartDelay = false;
    this$static.isStartTime = true;
  }
   else {
    this$static.isStartDelay = true;
    this$static.isStartTime = false;
  }
  $setRequired(startDelayItem, ($clinit_Boolean() , this$static.isStartDelay?TRUE:FALSE));
  this$static.isStartDelay?$show_0(startDelayItem):$hide_0(startDelayItem);
  $setRequired(startTimeItem, this$static.isStartTime?TRUE:FALSE);
  this$static.isStartTime?$show_0(startTimeItem):$hide_0(startTimeItem);
}

function $getEndTime_0(this$static){
  var delay, endTime, endTimeItem, endTimestamp, repeatDurationItem;
  if (this$static.isRecurring) {
    if (this$static.isRepeatDuration) {
      repeatDurationItem = dynamicCast($getField_0(this$static.repeatForm, 'repeatDuration'), Q$DurationItem);
      if (repeatDurationItem.unitType == ($clinit_UnitType() , ITERATIONS)) {
        endTime = null;
      }
       else {
        delay = mul(toLong($getValue_0(repeatDurationItem)).value_0, P3e8_longLit);
        endTimestamp = add(fromDouble(currentTimeMillis0()), delay);
        endTime = new Date_2(endTimestamp);
      }
    }
     else if (this$static.isEndTime) {
      endTimeItem = dynamicCast($getField_0(this$static.repeatForm, 'endTime'), Q$DateTimeItem);
      endTime = $getValueAsDate(endTimeItem);
    }
     else {
      endTime = null;
    }
  }
   else {
    endTime = null;
  }
  return endTime;
}

function $getRepeatCount(this$static){
  var repeatDurationItem, repetitions;
  if (this$static.isRecurring) {
    if (this$static.isRepeatDuration) {
      repeatDurationItem = dynamicCast($getField_0(this$static.repeatForm, 'repeatDuration'), Q$DurationItem);
      repeatDurationItem.unitType == ($clinit_UnitType() , ITERATIONS)?(repetitions = toInteger($getValue_0(repeatDurationItem))):(repetitions = null);
    }
     else {
      repetitions = null;
    }
  }
   else {
    repetitions = null;
  }
  return repetitions;
}

function $getRepeatInterval(this$static){
  var intervalMillis, repeatInterval;
  if (this$static.isRecurring) {
    repeatInterval = dynamicCast($getField_0(this$static.repeatForm, 'repeatInterval'), Q$DurationItem);
    intervalMillis = valueOf_45(mul(toLong($getValue_0(repeatInterval)).value_0, P3e8_longLit));
  }
   else {
    intervalMillis = null;
  }
  return intervalMillis;
}

function $getStartTime_0(this$static){
  var delay, startDelayItem, startTime, startTimeItem, startTimestamp;
  if (!this$static.isStartLater) {
    return null;
  }
  if (this$static.isStartDelay) {
    startDelayItem = dynamicCast($getField_0(this$static.laterForm, 'startDelay'), Q$DurationItem);
    delay = mul(toLong($getValue_0(startDelayItem)).value_0, P3e8_longLit);
    startTimestamp = add(fromDouble(currentTimeMillis0()), delay);
    startTime = new Date_2(startTimestamp);
  }
   else {
    startTimeItem = dynamicCast($getField_0(this$static.laterForm, 'startTime'), Q$DateTimeItem);
    startTime = $getValueAsDate(startTimeItem);
  }
  return startTime;
}

function $refresh_5(this$static){
  var calendarTypeItem, endTimeItem, modeItem, recurrenceTypeItem, repeatDurationItem, repeatIntervalItem, startDelayItem, startTimeItem, startTypeItem;
  if (this$static.jobTrigger) {
    modeItem = $getField_0(this$static.modeForm, 'mode');
    if (this$static.jobTrigger.recurrenceType == ($clinit_JobTrigger$RecurrenceType() , CRON_EXPRESSION)) {
      modeItem.setValue_4('cron');
      $changeMode(this$static, 'cron');
      $setValue_0(this$static.cronForm, 'cronExpression', this$static.jobTrigger.cronExpression);
    }
     else {
      modeItem.setValue_4('calendar');
      $hide(this$static.calendarTypeForm);
      $changeMode(this$static, 'calendar');
      startTypeItem = $getField_0(this$static.laterForm, 'startType');
      startTypeItem.setValue_4('on');
      startDelayItem = dynamicCast($getField_0(this$static.laterForm, 'startDelay'), Q$DurationItem);
      startTimeItem = $getField_0(this$static.laterForm, 'startTime');
      $changeStartType(this$static, 'on', startDelayItem, startTimeItem);
      startTimeItem.setValue_5(this$static.jobTrigger.startDate);
      calendarTypeItem = $getField_0(this$static.calendarTypeForm, 'calendarType');
      if (this$static.jobTrigger.recurrenceType == REPEAT_INTERVAL) {
        calendarTypeItem.setValue_4('laterAndRepeat');
        $changeCalendarType(this$static, 'laterAndRepeat');
        repeatIntervalItem = dynamicCast($getField_0(this$static.repeatForm, 'repeatInterval'), Q$DurationItem);
        $setAndFormatValue(repeatIntervalItem, this$static.jobTrigger.repeatInterval.value_0);
        endTimeItem = $getField_0(this$static.repeatForm, 'endTime');
        repeatDurationItem = dynamicCast($getField_0(this$static.repeatForm, 'repeatDuration'), Q$DurationItem);
        recurrenceTypeItem = $getField_0(this$static.repeatForm, 'recurrenceType');
        if (this$static.jobTrigger.repeatCount) {
          recurrenceTypeItem.setValue_4('for');
          $changeRecurrenceType(this$static, 'for', endTimeItem, repeatDurationItem);
          $setValue_14(repeatDurationItem, this$static.jobTrigger.repeatCount, ($clinit_UnitType() , ITERATIONS));
        }
         else if (this$static.jobTrigger.endDate) {
          recurrenceTypeItem.setValue_4('until');
          $changeRecurrenceType(this$static, 'until', endTimeItem, repeatDurationItem);
          endTimeItem.setValue_5(this$static.jobTrigger.endDate);
        }
         else {
          recurrenceTypeItem.setValue_4('indefinitely');
          $changeRecurrenceType(this$static, 'indefinitely', endTimeItem, repeatDurationItem);
        }
      }
       else {
        calendarTypeItem.setValue_4('later');
        $changeCalendarType(this$static, 'later');
      }
    }
  }
}

function $setJobTrigger_0(this$static, jobTrigger){
  this$static.jobTrigger = jobTrigger;
  this$static.isReadOnly = true;
  $isDrawn(this$static).value_0 && $refresh_5(this$static);
}

function $validate_5(this$static){
  var currentTime, endTime, isValid, message, startTime;
  isValid = true;
  currentTime = new Date_1;
  startTime = $getStartTime_0(this$static);
  endTime = $getEndTime_0(this$static);
  if (this$static.isStartLater) {
    isValid = $validate(this$static.laterForm);
    if (startTime) {
      if (lt(startTime.getTime_0(), currentTime.getTime_0())) {
        message = new Message_8(($clinit_Enhanced() , 'Start time must be in the future.'), ($clinit_Message$Severity() , Error_2), of(($clinit_Message$Option() , Transient)));
        $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
        isValid = false;
      }
      if (this$static.isRecurring && !!endTime) {
        if (lt(endTime.getTime_0(), startTime.getTime_0())) {
          message = new Message_8(($clinit_Enhanced() , 'End time must be after start time.'), ($clinit_Message$Severity() , Error_2), of(($clinit_Message$Option() , Transient)));
          $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
          isValid = false;
        }
      }
    }
  }
  if (this$static.isRecurring) {
    isValid = isValid && $validate(this$static.repeatForm);
    if (endTime) {
      if (lt(endTime.getTime_0(), currentTime.getTime_0())) {
        message = new Message_8(($clinit_Enhanced() , 'End time must be after start time.'), ($clinit_Message$Severity() , Error_2), of(($clinit_Message$Option() , Transient)));
        $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
        isValid = false;
      }
    }
  }
  return isValid;
}

function JobTriggerEditor_0(isReadOnly){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.isReadOnly = isReadOnly;
}

function createDateTimeItem(name_0){
  var dateTimeItem;
  dateTimeItem = new DateTimeItem_0(name_0);
  $setEnforceDate(dateTimeItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $isCreated_2(dateTimeItem)?$setProperty_6(dateTimeItem, 'centuryThreshold', 99):(dateTimeItem.jsObj['centuryThreshold'] = 99 , undefined);
  $setShowTitle_0(dateTimeItem, FALSE);
  $setVisible(dateTimeItem, FALSE);
  $setStartDate_0(dateTimeItem, new Date_1);
  $setUseMask(dateTimeItem, TRUE);
  $setShowHint(dateTimeItem, TRUE);
  return dateTimeItem;
}

defineSeed(2400, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), JobTriggerEditor_0);
_.onDraw_0 = function onDraw_21(){
  var calendarTypeItem, calendarTypeValueMap, closeIcon, cronExpressionItem, cronHelpTabSet, examplesPane, examplesTab, formatPane, formatTab, helpIcon, modeItem, modeValueMap, laterForm, startTypeItem, startTypeValueMap, startTimeItem, supportedUnits, startDelayItem, spacerItem, repeatForm, supportedUnits_0, repeatIntervalItem, recurrenceTypeItem, recurrenceTypeValueMap, repeatDurationItem, endTimeItem, spacerItem_0;
  this.modeForm = new EnhancedDynamicForm_1(this.isReadOnly);
  $setNumCols(this.modeForm, 3);
  $setColWidths(this.modeForm, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['140', '220', '*']));
  modeItem = new RadioGroupItem_2('mode', ($clinit_Enhanced() , 'Schedule using'));
  modeValueMap = new LinkedHashMap_0;
  $put_1(modeValueMap, 'calendar', 'Calendar');
  $put_1(modeValueMap, 'cron', 'Cron Expression');
  $isCreated_2(modeItem)?$setValueMapMethod(modeItem, convertMapToJavascriptObject(modeValueMap)):$isCreated_2(modeItem)?$setProperty_7(modeItem, 'valueMap', convertMapToJavascriptObject(modeValueMap)):(modeItem.jsObj['valueMap'] = convertMapToJavascriptObject(modeValueMap) , undefined);
  $setVertical_0(modeItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowTitle_0(modeItem, TRUE);
  $setValue_7(modeItem, 'calendar');
  $setFields_3(this.modeForm, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [modeItem]));
  $addMember(this, this.modeForm);
  this.calendarModeLayout = new EnhancedVLayout_0;
  this.calendarTypeForm = new EnhancedDynamicForm_1(this.isReadOnly);
  calendarTypeItem = new RadioGroupItem_1('calendarType');
  $isCreated_2(calendarTypeItem)?$setProperty_6(calendarTypeItem, 'width', 440):(calendarTypeItem.jsObj['width'] = 440 , undefined);
  $setShowTitle_0(calendarTypeItem, FALSE);
  calendarTypeValueMap = new LinkedHashMap_0;
  $put_1(calendarTypeValueMap, 'now', 'Now');
  $put_1(calendarTypeValueMap, 'nowAndRepeat', 'Now &amp; Repeat');
  $put_1(calendarTypeValueMap, 'later', 'Later');
  $put_1(calendarTypeValueMap, 'laterAndRepeat', 'Later &amp; Repeat');
  $isCreated_2(calendarTypeItem)?$setValueMapMethod(calendarTypeItem, convertMapToJavascriptObject(calendarTypeValueMap)):$isCreated_2(calendarTypeItem)?$setProperty_7(calendarTypeItem, 'valueMap', convertMapToJavascriptObject(calendarTypeValueMap)):(calendarTypeItem.jsObj['valueMap'] = convertMapToJavascriptObject(calendarTypeValueMap) , undefined);
  $setVertical_0(calendarTypeItem, FALSE);
  $setValue_7(calendarTypeItem, 'now');
  $setFields_3(this.calendarTypeForm, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [calendarTypeItem]));
  $addMember(this.calendarModeLayout, this.calendarTypeForm);
  $addMember(this, this.calendarModeLayout);
  this.cronModeLayout = new EnhancedVLayout_0;
  $setAttribute_24(this.cronModeLayout, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  this.cronForm = new DynamicForm_0;
  cronExpressionItem = new TextItem_3('cronExpression', 'Cron Expression');
  $setRequired(cronExpressionItem, TRUE);
  $isCreated_2(cronExpressionItem)?$setProperty_6(cronExpressionItem, 'width', 340):(cronExpressionItem.jsObj['width'] = 340 , undefined);
  this.cronForm.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [cronExpressionItem]));
  $addMember(this.cronModeLayout, this.cronForm);
  cronHelpTabSet = new TabSet_0;
  $isCreated_1(cronHelpTabSet)?$setProperty_3(cronHelpTabSet, 'width', '100%'):(cronHelpTabSet.config_0['width'] = '100%' , undefined);
  $isCreated_1(cronHelpTabSet)?$setProperty_0(cronHelpTabSet, 'height', 200):(cronHelpTabSet.config_0['height'] = 200 , undefined);
  closeIcon = new Img_2('[SKIN]/headerIcons/close.png', 16, 16);
  $addClickHandler(closeIcon, new JobTriggerEditor$1_0(cronHelpTabSet));
  $isCreated_1(cronHelpTabSet)?undefined:(cronHelpTabSet.config_0['tabBarControls'] = convertToJavaScriptArray(initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [closeIcon])) , undefined);
  formatTab = new Tab_1('Format');
  formatPane = new HTMLFlow_0;
  $isCreated_1(formatPane)?$setProperty_3(formatPane, 'width', '100%'):(formatPane.config_0['width'] = '100%' , undefined);
  $isCreated_1(formatPane)?$setProperty_3(formatPane, 'contents', '<p>A cron expression is a string comprised of 6 or 7 fields separated by white space. Fields can contain any of the\nallowed values, along with various combinations of the allowed special characters for that field. The fields are as\nfollows:<\/p>\n<table cellpadding="3" cellspacing="1">\n    <tbody>\n\n        <tr>\n            <th>Field Name<\/th>\n            <th>Mandatory<\/th>\n            <th>Allowed Values<\/th>\n            <th>Allowed Special Characters<\/th>\n        <\/tr>\n        <tr>\n\n            <td>Seconds<\/td>\n            <td>YES<\/td>\n\n            <td>0-59<\/td>\n            <td>, - * /<\/td>\n        <\/tr>\n        <tr>\n\n            <td>Minutes<\/td>\n            <td>YES<\/td>\n            <td>0-59<\/td>\n\n            <td>, - * /<\/td>\n        <\/tr>\n        <tr>\n\n            <td>Hours<\/td>\n            <td>YES<\/td>\n            <td>0-23<\/td>\n            <td>, - * /<\/td>\n\n        <\/tr>\n        <tr>\n\n            <td>Day of month<\/td>\n            <td>YES<\/td>\n            <td>1-31<\/td>\n            <td>, - * ? / L W<br clear="all" />\n            <\/td>\n        <\/tr>\n        <tr>\n\n            <td>Month<\/td>\n            <td>YES<\/td>\n            <td>1-12 or JAN-DEC<\/td>\n            <td>, - * /<\/td>\n        <\/tr>\n        <tr>\n\n            <td>Day of week<\/td>\n\n            <td>YES<\/td>\n            <td>1-7 or SUN-SAT<\/td>\n            <td>, - * ? / L #<\/td>\n        <\/tr>\n        <tr>\n\n            <td>Year<\/td>\n            <td>NO<\/td>\n\n            <td>empty, 1970-2099<\/td>\n            <td>, - * /<\/td>\n        <\/tr>\n    <\/tbody>\n\n<\/table>\n<p>So cron expressions can be as simple as this: <tt>&#42; * * * ? *<\/tt><br />\nor more complex, like this: <tt>0/5 14,18,3-39,52 * ? JAN,MAR,SEP MON-FRI 2002-2010<\/tt><\/p>\n\n<h2><a name="CronTriggersTutorial-Specialcharacters"><\/a>Special Characters<\/h2>\n\n<ul>\n    <li><tt><b>&#42;<\/b><\/tt> (<em>"all values"<\/em>) - used to select all values within a field. For example, "*"\n    in the minute field means <em>"every minute"<\/em>.<\/li>\n\n<\/ul>\n\n\n<ul>\n    <li><tt><b>?<\/b><\/tt> (<em>"no specific value"<\/em>) - useful when you need to specify something in one of the\n    two fields in which the character is allowed, but not the other. For example, if I want my trigger to fire on a\n    particular day of the month (say, the 10th), but don\'t care what day of the week that happens to be, I would put\n    "10" in the day-of-month field, and "?" in the day-of-week field. See the examples below for clarification.<\/li>\n\n<\/ul>\n\n\n<ul>\n    <li><tt><b>&#45;<\/b><\/tt> &#45; used to specify ranges. For example, "10-12" in the hour field means <em>"the\n    hours 10, 11 and 12"<\/em>.<\/li>\n\n<\/ul>\n\n\n<ul>\n    <li><tt><b>,<\/b><\/tt> &#45; used to specify additional values. For example, "MON,WED,FRI" in the day-of-week\n    field means <em>"the days Monday, Wednesday, and Friday"<\/em>.<\/li>\n\n<\/ul>\n\n\n<ul>\n\n    <li><tt><b>/<\/b><\/tt> &#45; used to specify increments. For example, "0/15" in the seconds field means <em>"the\n    seconds 0, 15, 30, and 45"<\/em>. And "5/15" in the seconds field means <em>"the seconds 5, 20, 35, and 50"<\/em>. You can\n    also specify \'/\' after the \'<b>\' character - in this case \'<\/b>\' is equivalent to having \'0\' before the \'/\'. \'1/3\'\n    in the day-of-month field means <em>"fire every 3 days starting on the first day of the month"<\/em>.<\/li>\n\n<\/ul>\n\n<ul>\n    <li><tt><b>L<\/b><\/tt> (<em>"last"<\/em>) - has different meaning in each of the two fields in which it is\n    allowed. For example, the value "L" in the day-of-month field means <em>"the last day of the month"<\/em> &#45; day\n    31 for January, day 28 for February on non-leap years. If used in the day-of-week field by itself, it simply means\n    "7" or "SAT". But if used in the day-of-week field after another value, it means <em>"the last xxx day of the\n    month"<\/em> &#45; for example "6L" means <em>"the last friday of the month"<\/em>. When using the \'L\' option, it is\n    important not to specify lists, or ranges of values, as you\'ll get confusing results.<\/li>\n\n<\/ul>\n\n\n<ul>\n    <li><tt><b>W<\/b><\/tt> (<em>"weekday"<\/em>) - used to specify the weekday (Monday-Friday) nearest the given day.\n    As an example, if you were to specify "15W" as the value for the day-of-month field, the meaning is: <em>"the\n    nearest weekday to the 15th of the month"<\/em>. So if the 15th is a Saturday, the trigger will fire on Friday the 14th.\n    If the 15th is a Sunday, the trigger will fire on Monday the 16th. If the 15th is a Tuesday, then it will fire on\n    Tuesday the 15th. However if you specify "1W" as the value for day-of-month, and the 1st is a Saturday, the trigger\n    will fire on Monday the 3rd, as it will not \'jump\' over the boundary of a month\'s days. The \'W\' character can only\n    be specified when the day-of-month is a single day, not a range or list of days.\n        <div class="tip">\n            The \'L\' and \'W\' characters can also be combined in the day-of-month field to yield \'LW\', which\n            translates to <em>"last weekday of the month"<\/em>.\n        <\/div>\n\n    <\/li>\n\n    <li><tt><b>&#35;<\/b><\/tt> &#45; used to specify "the nth" XXX day of the month. For example, the value of "6#3"\n    in the day-of-week field means <em>"the third Friday of the month"<\/em> (day 6 = Friday and "#3" = the 3rd one in\n    the month). Other examples: "2#1" = the first Monday of the month and "4#5" = the fifth Wednesday of the month. Note\n    that if you specify "#5" and there is not 5 of the given day-of-week in the month, then no firing will occur that\n    month.\n        <div class="tip">\n            The legal characters and the names of months and days of the week are not case sensitive. <tt>MON<\/tt>\n            is the same as <tt>mon<\/tt>.\n        <\/div>\n\n    <\/li>\n<\/ul><h2><a name="CronTriggersTutorial-Notes"><\/a>Notes<\/h2>\n\n<ul>\n    <li>Support for specifying both a day-of-week and a day-of-month value is not complete (you must currently use\n    the \'?\' character in one of these fields).<\/li>\n    <li>Be careful when setting fire times between mid-night and 1:00 AM - "daylight savings" can cause a skip or a\n    repeat depending on whether the time moves back or jumps forward.<\/li>\n\n<\/ul>'):(formatPane.config_0['contents'] = '<p>A cron expression is a string comprised of 6 or 7 fields separated by white space. Fields can contain any of the\nallowed values, along with various combinations of the allowed special characters for that field. The fields are as\nfollows:<\/p>\n<table cellpadding="3" cellspacing="1">\n    <tbody>\n\n        <tr>\n            <th>Field Name<\/th>\n            <th>Mandatory<\/th>\n            <th>Allowed Values<\/th>\n            <th>Allowed Special Characters<\/th>\n        <\/tr>\n        <tr>\n\n            <td>Seconds<\/td>\n            <td>YES<\/td>\n\n            <td>0-59<\/td>\n            <td>, - * /<\/td>\n        <\/tr>\n        <tr>\n\n            <td>Minutes<\/td>\n            <td>YES<\/td>\n            <td>0-59<\/td>\n\n            <td>, - * /<\/td>\n        <\/tr>\n        <tr>\n\n            <td>Hours<\/td>\n            <td>YES<\/td>\n            <td>0-23<\/td>\n            <td>, - * /<\/td>\n\n        <\/tr>\n        <tr>\n\n            <td>Day of month<\/td>\n            <td>YES<\/td>\n            <td>1-31<\/td>\n            <td>, - * ? / L W<br clear="all" />\n            <\/td>\n        <\/tr>\n        <tr>\n\n            <td>Month<\/td>\n            <td>YES<\/td>\n            <td>1-12 or JAN-DEC<\/td>\n            <td>, - * /<\/td>\n        <\/tr>\n        <tr>\n\n            <td>Day of week<\/td>\n\n            <td>YES<\/td>\n            <td>1-7 or SUN-SAT<\/td>\n            <td>, - * ? / L #<\/td>\n        <\/tr>\n        <tr>\n\n            <td>Year<\/td>\n            <td>NO<\/td>\n\n            <td>empty, 1970-2099<\/td>\n            <td>, - * /<\/td>\n        <\/tr>\n    <\/tbody>\n\n<\/table>\n<p>So cron expressions can be as simple as this: <tt>&#42; * * * ? *<\/tt><br />\nor more complex, like this: <tt>0/5 14,18,3-39,52 * ? JAN,MAR,SEP MON-FRI 2002-2010<\/tt><\/p>\n\n<h2><a name="CronTriggersTutorial-Specialcharacters"><\/a>Special Characters<\/h2>\n\n<ul>\n    <li><tt><b>&#42;<\/b><\/tt> (<em>"all values"<\/em>) - used to select all values within a field. For example, "*"\n    in the minute field means <em>"every minute"<\/em>.<\/li>\n\n<\/ul>\n\n\n<ul>\n    <li><tt><b>?<\/b><\/tt> (<em>"no specific value"<\/em>) - useful when you need to specify something in one of the\n    two fields in which the character is allowed, but not the other. For example, if I want my trigger to fire on a\n    particular day of the month (say, the 10th), but don\'t care what day of the week that happens to be, I would put\n    "10" in the day-of-month field, and "?" in the day-of-week field. See the examples below for clarification.<\/li>\n\n<\/ul>\n\n\n<ul>\n    <li><tt><b>&#45;<\/b><\/tt> &#45; used to specify ranges. For example, "10-12" in the hour field means <em>"the\n    hours 10, 11 and 12"<\/em>.<\/li>\n\n<\/ul>\n\n\n<ul>\n    <li><tt><b>,<\/b><\/tt> &#45; used to specify additional values. For example, "MON,WED,FRI" in the day-of-week\n    field means <em>"the days Monday, Wednesday, and Friday"<\/em>.<\/li>\n\n<\/ul>\n\n\n<ul>\n\n    <li><tt><b>/<\/b><\/tt> &#45; used to specify increments. For example, "0/15" in the seconds field means <em>"the\n    seconds 0, 15, 30, and 45"<\/em>. And "5/15" in the seconds field means <em>"the seconds 5, 20, 35, and 50"<\/em>. You can\n    also specify \'/\' after the \'<b>\' character - in this case \'<\/b>\' is equivalent to having \'0\' before the \'/\'. \'1/3\'\n    in the day-of-month field means <em>"fire every 3 days starting on the first day of the month"<\/em>.<\/li>\n\n<\/ul>\n\n<ul>\n    <li><tt><b>L<\/b><\/tt> (<em>"last"<\/em>) - has different meaning in each of the two fields in which it is\n    allowed. For example, the value "L" in the day-of-month field means <em>"the last day of the month"<\/em> &#45; day\n    31 for January, day 28 for February on non-leap years. If used in the day-of-week field by itself, it simply means\n    "7" or "SAT". But if used in the day-of-week field after another value, it means <em>"the last xxx day of the\n    month"<\/em> &#45; for example "6L" means <em>"the last friday of the month"<\/em>. When using the \'L\' option, it is\n    important not to specify lists, or ranges of values, as you\'ll get confusing results.<\/li>\n\n<\/ul>\n\n\n<ul>\n    <li><tt><b>W<\/b><\/tt> (<em>"weekday"<\/em>) - used to specify the weekday (Monday-Friday) nearest the given day.\n    As an example, if you were to specify "15W" as the value for the day-of-month field, the meaning is: <em>"the\n    nearest weekday to the 15th of the month"<\/em>. So if the 15th is a Saturday, the trigger will fire on Friday the 14th.\n    If the 15th is a Sunday, the trigger will fire on Monday the 16th. If the 15th is a Tuesday, then it will fire on\n    Tuesday the 15th. However if you specify "1W" as the value for day-of-month, and the 1st is a Saturday, the trigger\n    will fire on Monday the 3rd, as it will not \'jump\' over the boundary of a month\'s days. The \'W\' character can only\n    be specified when the day-of-month is a single day, not a range or list of days.\n        <div class="tip">\n            The \'L\' and \'W\' characters can also be combined in the day-of-month field to yield \'LW\', which\n            translates to <em>"last weekday of the month"<\/em>.\n        <\/div>\n\n    <\/li>\n\n    <li><tt><b>&#35;<\/b><\/tt> &#45; used to specify "the nth" XXX day of the month. For example, the value of "6#3"\n    in the day-of-week field means <em>"the third Friday of the month"<\/em> (day 6 = Friday and "#3" = the 3rd one in\n    the month). Other examples: "2#1" = the first Monday of the month and "4#5" = the fifth Wednesday of the month. Note\n    that if you specify "#5" and there is not 5 of the given day-of-week in the month, then no firing will occur that\n    month.\n        <div class="tip">\n            The legal characters and the names of months and days of the week are not case sensitive. <tt>MON<\/tt>\n            is the same as <tt>mon<\/tt>.\n        <\/div>\n\n    <\/li>\n<\/ul><h2><a name="CronTriggersTutorial-Notes"><\/a>Notes<\/h2>\n\n<ul>\n    <li>Support for specifying both a day-of-week and a day-of-month value is not complete (you must currently use\n    the \'?\' character in one of these fields).<\/li>\n    <li>Be careful when setting fire times between mid-night and 1:00 AM - "daylight savings" can cause a skip or a\n    repeat depending on whether the time moves back or jumps forward.<\/li>\n\n<\/ul>' , undefined);
  !formatTab.tabSet || !$isCreated_1(formatTab.tabSet)?$setAttribute_5(formatTab, 'pane', $getOrCreateJsObj_0(formatPane)):$updateTab(formatTab.tabSet, formatTab, formatPane);
  examplesTab = new Tab_1('Examples');
  examplesPane = new HTMLFlow_0;
  $isCreated_1(examplesPane)?$setProperty_3(examplesPane, 'width', '100%'):(examplesPane.config_0['width'] = '100%' , undefined);
  $isCreated_1(examplesPane)?$setProperty_3(examplesPane, 'contents', '<table cellpadding="3" cellspacing="1">\n    <tbody>\n        <tr>\n            <th>Expression<\/th>\n\n            <th>Meaning<\/th>\n        <\/tr>\n        <tr>\n            <td><tt>0 0 12 * * ?<\/tt><\/td>\n\n            <td>Fire at 12pm (noon) every day<\/td>\n        <\/tr>\n        <tr>\n\n            <td><tt>0 15 10 ? * *<\/tt><\/td>\n            <td>Fire at 10:15am every day<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 * * ?<\/tt><\/td>\n\n            <td>Fire at 10:15am every day<\/td>\n\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 * * ? *<\/tt><\/td>\n            <td>Fire at 10:15am every day<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 * * ? 2005<\/tt><\/td>\n\n            <td>Fire at 10:15am every day during the year 2005<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 * 14 * * ?<\/tt><\/td>\n            <td>Fire every minute starting at 2pm and ending at 2:59pm, every day<\/td>\n        <\/tr>\n        <tr>\n\n            <td><tt>0 0/5 14 * * ?<\/tt><\/td>\n\n            <td>Fire every 5 minutes starting at 2pm and ending at 2:55pm, every day<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 0/5 14,18 * * ?<\/tt><\/td>\n            <td>Fire every 5 minutes starting at 2pm and ending at 2:55pm, AND fire every 5\n            minutes starting at 6pm and ending at 6:55pm, every day<\/td>\n\n        <\/tr>\n        <tr>\n            <td><tt>0 0-5 14 * * ?<\/tt><\/td>\n\n            <td>Fire every minute starting at 2pm and ending at 2:05pm, every day<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 10,44 14 ? 3 WED<\/tt><\/td>\n\n            <td>Fire at 2:10pm and at 2:44pm every Wednesday in the month of March.<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 ? * MON-FRI<\/tt><\/td>\n\n            <td>Fire at 10:15am every Monday, Tuesday, Wednesday, Thursday and Friday<\/td>\n        <\/tr>\n        <tr>\n\n            <td><tt>0 15 10 15 * ?<\/tt><\/td>\n            <td>Fire at 10:15am on the 15th day of every month<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 L * ?<\/tt><\/td>\n\n            <td>Fire at 10:15am on the last day of every month<\/td>\n\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 ? * 6L<\/tt><\/td>\n            <td>Fire at 10:15am on the last Friday of every month<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 ? * 6L<\/tt><\/td>\n\n            <td>Fire at 10:15am on the last Friday of every month<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 ? * 6L 2002-2005<\/tt><\/td>\n            <td>Fire at 10:15am on every last friday of every month during the years 2002,\n            2003, 2004 and 2005<\/td>\n        <\/tr>\n        <tr>\n\n            <td><tt>0 15 10 ? * 6#3<\/tt><\/td>\n\n            <td>Fire at 10:15am on the third Friday of every month<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 0 12 1/5 * ?<\/tt><\/td>\n            <td>Fire at 12pm (noon) every 5 days every month, starting on the first day of the\n            month.<\/td>\n\n        <\/tr>\n        <tr>\n            <td><tt>0 11 11 11 11 ?<\/tt><\/td>\n\n            <td>Fire every November 11th at 11:11am.<\/td>\n        <\/tr>\n    <\/tbody>\n<\/table>'):(examplesPane.config_0['contents'] = '<table cellpadding="3" cellspacing="1">\n    <tbody>\n        <tr>\n            <th>Expression<\/th>\n\n            <th>Meaning<\/th>\n        <\/tr>\n        <tr>\n            <td><tt>0 0 12 * * ?<\/tt><\/td>\n\n            <td>Fire at 12pm (noon) every day<\/td>\n        <\/tr>\n        <tr>\n\n            <td><tt>0 15 10 ? * *<\/tt><\/td>\n            <td>Fire at 10:15am every day<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 * * ?<\/tt><\/td>\n\n            <td>Fire at 10:15am every day<\/td>\n\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 * * ? *<\/tt><\/td>\n            <td>Fire at 10:15am every day<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 * * ? 2005<\/tt><\/td>\n\n            <td>Fire at 10:15am every day during the year 2005<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 * 14 * * ?<\/tt><\/td>\n            <td>Fire every minute starting at 2pm and ending at 2:59pm, every day<\/td>\n        <\/tr>\n        <tr>\n\n            <td><tt>0 0/5 14 * * ?<\/tt><\/td>\n\n            <td>Fire every 5 minutes starting at 2pm and ending at 2:55pm, every day<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 0/5 14,18 * * ?<\/tt><\/td>\n            <td>Fire every 5 minutes starting at 2pm and ending at 2:55pm, AND fire every 5\n            minutes starting at 6pm and ending at 6:55pm, every day<\/td>\n\n        <\/tr>\n        <tr>\n            <td><tt>0 0-5 14 * * ?<\/tt><\/td>\n\n            <td>Fire every minute starting at 2pm and ending at 2:05pm, every day<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 10,44 14 ? 3 WED<\/tt><\/td>\n\n            <td>Fire at 2:10pm and at 2:44pm every Wednesday in the month of March.<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 ? * MON-FRI<\/tt><\/td>\n\n            <td>Fire at 10:15am every Monday, Tuesday, Wednesday, Thursday and Friday<\/td>\n        <\/tr>\n        <tr>\n\n            <td><tt>0 15 10 15 * ?<\/tt><\/td>\n            <td>Fire at 10:15am on the 15th day of every month<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 L * ?<\/tt><\/td>\n\n            <td>Fire at 10:15am on the last day of every month<\/td>\n\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 ? * 6L<\/tt><\/td>\n            <td>Fire at 10:15am on the last Friday of every month<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 ? * 6L<\/tt><\/td>\n\n            <td>Fire at 10:15am on the last Friday of every month<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 15 10 ? * 6L 2002-2005<\/tt><\/td>\n            <td>Fire at 10:15am on every last friday of every month during the years 2002,\n            2003, 2004 and 2005<\/td>\n        <\/tr>\n        <tr>\n\n            <td><tt>0 15 10 ? * 6#3<\/tt><\/td>\n\n            <td>Fire at 10:15am on the third Friday of every month<\/td>\n        <\/tr>\n        <tr>\n            <td><tt>0 0 12 1/5 * ?<\/tt><\/td>\n            <td>Fire at 12pm (noon) every 5 days every month, starting on the first day of the\n            month.<\/td>\n\n        <\/tr>\n        <tr>\n            <td><tt>0 11 11 11 11 ?<\/tt><\/td>\n\n            <td>Fire every November 11th at 11:11am.<\/td>\n        <\/tr>\n    <\/tbody>\n<\/table>' , undefined);
  !examplesTab.tabSet || !$isCreated_1(examplesTab.tabSet)?$setAttribute_5(examplesTab, 'pane', $getOrCreateJsObj_0(examplesPane)):$updateTab(examplesTab.tabSet, examplesTab, examplesPane);
  $addTab(cronHelpTabSet, formatTab);
  $addTab(cronHelpTabSet, examplesTab);
  $setAttribute_24(cronHelpTabSet, 'visibility', HIDDEN_0.value_0, true);
  helpIcon = new FormItemIcon_0;
  helpIcon.jsObj['src'] = '[SKIN]/actions/help.png';
  $isCreated_2(cronExpressionItem)?$setProperty_7(cronExpressionItem, 'icons', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [helpIcon]))):(cronExpressionItem.jsObj['icons'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [helpIcon])) , undefined);
  $addIconClickHandler(cronExpressionItem, new JobTriggerEditor$2_0(cronHelpTabSet));
  $addMember(this.cronModeLayout, cronHelpTabSet);
  $addMember(this, this.cronModeLayout);
  $addChangedHandler(modeItem, new JobTriggerEditor$3_0(this));
  this.laterForm = (laterForm = new EnhancedDynamicForm_1(this.isReadOnly) , $isCreated_1(laterForm)?$setProperty_0(laterForm, 'numCols', 4):(laterForm.config_0['numCols'] = 4 , undefined) , $setColWidths(laterForm, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [valueOf_44(140), valueOf_44(130), valueOf_44(130)])) , startTypeItem = new RadioGroupItem_2('startType', 'Run') , startTypeValueMap = new LinkedHashMap_0 , $put_1(startTypeValueMap, 'on', 'on') , $put_1(startTypeValueMap, 'in', 'in') , $isCreated_2(startTypeItem)?$setValueMapMethod(startTypeItem, convertMapToJavascriptObject(startTypeValueMap)):$isCreated_2(startTypeItem)?$setProperty_7(startTypeItem, 'valueMap', convertMapToJavascriptObject(startTypeValueMap)):(startTypeItem.jsObj['valueMap'] = convertMapToJavascriptObject(startTypeValueMap) , undefined) , $setShowTitle_0(startTypeItem, TRUE) , startTimeItem = createDateTimeItem('startTime') , supportedUnits = new TreeSet_0 , $add_8(supportedUnits, ($clinit_TimeUnit() , SECONDS_0)) , $add_8(supportedUnits, MINUTES_1) , $add_8(supportedUnits, HOURS_1) , $add_8(supportedUnits, DAYS_2) , $add_8(supportedUnits, WEEKS_0) , $add_8(supportedUnits, MONTHS_0) , $add_8(supportedUnits, YEARS) , startDelayItem = new DurationItem_0('startDelay', null, supportedUnits, false, this.isReadOnly) , $setShowTitle_0(startDelayItem, FALSE) , $setVisible(startDelayItem, FALSE) , $setContextualHelp(startDelayItem, 'start executing the operation after this amount of time has elapsed') , spacerItem = new SpacerItem_0 , $addChangedHandler(startTypeItem, new JobTriggerEditor$6_0(this, startDelayItem, startTimeItem)) , $setFields_3(laterForm, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [startTypeItem, startTimeItem, startDelayItem, spacerItem])) , $setAttribute_24(laterForm, 'visibility', HIDDEN_0.value_0, true) , laterForm);
  $addMember(this.calendarModeLayout, this.laterForm);
  this.repeatForm = (repeatForm = new EnhancedDynamicForm_1(this.isReadOnly) , $isCreated_1(repeatForm)?$setProperty_0(repeatForm, 'numCols', 6):(repeatForm.config_0['numCols'] = 6 , undefined) , $setColWidths(repeatForm, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [valueOf_44(140), valueOf_44(130), valueOf_44(130), valueOf_44(130), valueOf_44(130)])) , supportedUnits_0 = new TreeSet_0 , $add_8(supportedUnits_0, SECONDS_0) , $add_8(supportedUnits_0, MINUTES_1) , $add_8(supportedUnits_0, HOURS_1) , $add_8(supportedUnits_0, DAYS_2) , $add_8(supportedUnits_0, WEEKS_0) , $add_8(supportedUnits_0, MONTHS_0) , $add_8(supportedUnits_0, YEARS) , repeatIntervalItem = new DurationItem_0('repeatInterval', 'Run now and every', supportedUnits_0, false, this.isReadOnly) , $setRequired(repeatIntervalItem, TRUE) , $setContextualHelp(repeatIntervalItem, 'how often the operation should be executed') , recurrenceTypeItem = new RadioGroupItem_1('recurrenceType') , $setRequired(recurrenceTypeItem, TRUE) , $setShowTitle_0(recurrenceTypeItem, FALSE) , recurrenceTypeValueMap = new LinkedHashMap_0 , $put_1(recurrenceTypeValueMap, 'for', 'For') , $put_1(recurrenceTypeValueMap, 'until', 'Until') , $put_1(recurrenceTypeValueMap, 'indefinitely', 'Indefinitely') , $isCreated_2(recurrenceTypeItem)?$setValueMapMethod(recurrenceTypeItem, convertMapToJavascriptObject(recurrenceTypeValueMap)):$isCreated_2(recurrenceTypeItem)?$setProperty_7(recurrenceTypeItem, 'valueMap', convertMapToJavascriptObject(recurrenceTypeValueMap)):(recurrenceTypeItem.jsObj['valueMap'] = convertMapToJavascriptObject(recurrenceTypeValueMap) , undefined) , supportedUnits_0 = new TreeSet_0 , $add_8(supportedUnits_0, SECONDS_0) , $add_8(supportedUnits_0, MINUTES_1) , $add_8(supportedUnits_0, HOURS_1) , $add_8(supportedUnits_0, DAYS_2) , $add_8(supportedUnits_0, WEEKS_0) , $add_8(supportedUnits_0, MONTHS_0) , $add_8(supportedUnits_0, YEARS) , repeatDurationItem = new DurationItem_0('repeatDuration', null, supportedUnits_0, true, this.isReadOnly) , $setShowTitle_0(repeatDurationItem, FALSE) , $setVisible(repeatDurationItem, FALSE) , $setContextualHelp(repeatDurationItem, 'keep running this operation this many times or until this amount of time has elapsed') , endTimeItem = createDateTimeItem('endTime') , $setShowTitle_0(endTimeItem, FALSE) , $setVisible(endTimeItem, FALSE) , spacerItem_0 = new SpacerItem_0 , $addChangedHandler(recurrenceTypeItem, new JobTriggerEditor$5_0(this, endTimeItem, repeatDurationItem)) , $setFields_3(repeatForm, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [repeatIntervalItem, recurrenceTypeItem, repeatDurationItem, endTimeItem, spacerItem_0])) , $setAttribute_24(repeatForm, 'visibility', HIDDEN_0.value_0, true) , repeatForm);
  $addMember(this.calendarModeLayout, this.repeatForm);
  $addChangedHandler(calendarTypeItem, new JobTriggerEditor$4_0(this));
  $refresh_5(this);
}
;
_.calendarModeLayout = null;
_.calendarTypeForm = null;
_.cronForm = null;
_.cronModeLayout = null;
_.isEndTime = false;
_.isReadOnly = false;
_.isRecurring = false;
_.isRepeatDuration = false;
_.isStartDelay = false;
_.isStartLater = false;
_.isStartTime = false;
_.jobTrigger = null;
_.laterForm = null;
_.modeForm = null;
_.repeatForm = null;
function JobTriggerEditor$1_0(val$cronHelpTabSet){
  this.val$cronHelpTabSet = val$cronHelpTabSet;
}

defineSeed(2401, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), JobTriggerEditor$1_0);
_.onClick = function onClick_87(event_0){
  $hide(this.val$cronHelpTabSet);
}
;
_.val$cronHelpTabSet = null;
function JobTriggerEditor$2_0(val$cronHelpTabSet){
  this.val$cronHelpTabSet = val$cronHelpTabSet;
}

defineSeed(2402, 1, makeCastMap([Q$EventHandler, Q$IconClickHandler]), JobTriggerEditor$2_0);
_.onIconClick = function onIconClick_0(event_0){
  $show(this.val$cronHelpTabSet);
}
;
_.val$cronHelpTabSet = null;
function JobTriggerEditor$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2403, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), JobTriggerEditor$3_0);
_.onChanged = function onChanged_45(event_0){
  var mode;
  mode = dynamicCast($getValue_2(event_0), Q$String);
  $changeMode(this.this$0, mode);
}
;
_.this$0 = null;
function JobTriggerEditor$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2404, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), JobTriggerEditor$4_0);
_.onChanged = function onChanged_46(event_0){
  var calendarType;
  calendarType = dynamicCast($getValue_2(event_0), Q$String);
  $changeCalendarType(this.this$0, calendarType);
}
;
_.this$0 = null;
function JobTriggerEditor$5_0(this$0, val$endTimeItem, val$repeatDurationItem){
  this.this$0 = this$0;
  this.val$endTimeItem = val$endTimeItem;
  this.val$repeatDurationItem = val$repeatDurationItem;
}

defineSeed(2405, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), JobTriggerEditor$5_0);
_.onChanged = function onChanged_47(event_0){
  var recurrenceType;
  recurrenceType = dynamicCast($getValue_2(event_0), Q$String);
  $changeRecurrenceType(this.this$0, recurrenceType, this.val$endTimeItem, this.val$repeatDurationItem);
}
;
_.this$0 = null;
_.val$endTimeItem = null;
_.val$repeatDurationItem = null;
function JobTriggerEditor$6_0(this$0, val$startDelayItem, val$startTimeItem){
  this.this$0 = this$0;
  this.val$startDelayItem = val$startDelayItem;
  this.val$startTimeItem = val$startTimeItem;
}

defineSeed(2406, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), JobTriggerEditor$6_0);
_.onChanged = function onChanged_48(event_0){
  var startType;
  startType = dynamicCast($getValue_2(event_0), Q$String);
  $changeStartType(this.this$0, startType, this.val$startDelayItem, this.val$startTimeItem);
}
;
_.this$0 = null;
_.val$startDelayItem = null;
_.val$startTimeItem = null;
function $parseIdFromResponse(results){
  var $e0, bundleVersionIdString, e, endSuccessMsgPrefix, id, startSuccessMsgPostfix, startSuccessMsgPrefix;
  startSuccessMsgPrefix = results.indexOf('success [');
  if (startSuccessMsgPrefix < 0) {
    return 0;
  }
  endSuccessMsgPrefix = startSuccessMsgPrefix + 9;
  startSuccessMsgPostfix = $indexOf_3(results, fromCodePoint(93), endSuccessMsgPrefix);
  if (startSuccessMsgPostfix < 0) {
    return 0;
  }
  bundleVersionIdString = results.substr(endSuccessMsgPrefix, startSuccessMsgPostfix - endSuccessMsgPrefix);
  id = 0;
  try {
    id = __parseAndValidateInt(bundleVersionIdString);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      e = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Error uploading Bundle Distribution File'), e);
    }
     else 
      throw $e0;
  }
  return id;
}

function BundleDistributionFileUploadForm_0(){
  $clinit_BaseWidget();
  FileUploadForm_0.call(this, ($clinit_CoreGUI() , 'Distribution File'), '0', true, false, null);
  $setAction(this, getModuleBaseURL() + 'BundleDistributionFileUploadServlet');
}

defineSeed(2407, 1925, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), BundleDistributionFileUploadForm_0);
_.processSubmitCompleteResults = function processSubmitCompleteResults_1(submitCompleteEventResults){
  this.bundleVersionId = $parseIdFromResponse(submitCompleteEventResults);
  return this.bundleVersionId > 0;
}
;
_.bundleVersionId = 0;
function BundleFileUploadForm_0(bundleVersion, name_0, isAlreadyUploaded){
  $clinit_BaseWidget();
  FileUploadForm_0.call(this, name_0, bundleVersion.version_0, false, true, isAlreadyUploaded);
  this.bundleVersion = bundleVersion;
  $setAction(this, getModuleBaseURL() + 'BundleFileUploadServlet');
}

defineSeed(2408, 1925, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm, Q$BundleFileUploadForm]), BundleFileUploadForm_0);
_.getOnDrawItems = function getOnDrawItems_2(){
  var bundleVersionIdField, onDrawItems;
  onDrawItems = $getOnDrawItems(this);
  bundleVersionIdField = new HiddenItem_0('bundleVersionId');
  $setDefaultValue_0(bundleVersionIdField, valueOf_44(this.bundleVersion.id));
  setCheck(onDrawItems.array, onDrawItems.size_0++, bundleVersionIdField);
  return onDrawItems;
}
;
_.processSubmitCompleteResults = function processSubmitCompleteResults_2(submitCompleteEventResults){
  return submitCompleteEventResults.indexOf('Error uploading file') == -1;
}
;
_.bundleVersion = null;
function DynamicCallbackForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2409, 1, {}, DynamicCallbackForm$1_0);
_.execute_1 = function execute_48(){
  $fireOnComplete(this.this$0.formHandlers, $getContents(($clinit_BaseWidget() , this.this$0.synthesizedFrame)));
}
;
_.this$0 = null;
function $fireOnComplete(this$static, results){
  var event_0, handler, handler$iterator;
  event_0 = new DynamicFormSubmitCompleteEvent_0(results);
  for (handler$iterator = new AbstractList$IteratorImpl_0(this$static); handler$iterator.i < handler$iterator.this$0_0.size_1();) {
    handler = dynamicCast($next_0(handler$iterator), Q$DynamicFormHandler);
    handler.onSubmitComplete(event_0);
  }
}

function DynamicCallbackFormHandlerCollection_0(){
  $$init(this);
}

defineSeed(2410, 289, makeCastMap([Q$Serializable, Q$Cloneable, Q$Iterable, Q$AbstractCollection, Q$AbstractList, Q$ArrayList, Q$Collection, Q$List, Q$RandomAccess]), DynamicCallbackFormHandlerCollection_0);
function $getContents(iframe){
  try {
    if (!iframe.contentWindow || !iframe.contentWindow.document)
      return null;
    return iframe.contentWindow.document.body.innerHTML;
  }
   catch (e) {
    return null;
  }
}

function $submit_0(action, iframe){
  iframe && (iframe.__formAction = action);
}

function $hookEvents(iframe, listener){
  iframe && (iframe.onreadystatechange = function(){
    if (!iframe.__formAction)
      return;
    iframe.readyState == 'complete' && listener.onFrameLoad();
  }
  );
}

function $unhookEvents(iframe){
  iframe && (iframe.onreadystatechange = null);
}

function DynamicFormSubmitCompleteEvent_0(resultHtml){
  this.resultHtml = resultHtml;
}

defineSeed(2413, 665, {}, DynamicFormSubmitCompleteEvent_0);
_.resultHtml = null;
function FileUploadForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2414, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), FileUploadForm$1_0);
_.onClick_0 = function onClick_88(clickEvent){
  this.this$0.submitForm_0();
}
;
_.this$0 = null;
function FileUploadForm$1EnableInterceptingButtonItem_0(this$0){
  this.this$0 = this$0;
  ButtonItem_0.call(this);
}

defineSeed(2415, 488, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), FileUploadForm$1EnableInterceptingButtonItem_0);
_.enable_0 = function enable_0(){
  var selectedFile;
  selectedFile = $getValueAsString_1(this.this$0.fileUploadItem);
  selectedFile != null && selectedFile.length > 0 && $setDisabled_2(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
}
;
_.this$0 = null;
function FileUploadForm$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2416, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), FileUploadForm$2_0);
_.onChange = function onChange_4(changeEvent){
  $setDisabled_2(this.this$0.uploadButton, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
}
;
_.this$0 = null;
function FileUploadForm$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2417, 1, makeCastMap([Q$DynamicFormHandler]), FileUploadForm$3_0);
_.onSubmitComplete = function onSubmitComplete_3(event_0){
  var cause, results, i;
  this.this$0.uploadInProgress = false;
  results = event_0.resultHtml;
  if (this.this$0.processSubmitCompleteResults(results)) {
    this.this$0.uploadResult = ($clinit_Boolean() , TRUE);
    $changeIcon(this.this$0, this.this$0.iconGreen, 'File successfully uploaded');
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('File successfully uploaded', results, ($clinit_Message$Severity() , Info)));
  }
   else {
    this.this$0.uploadResult = ($clinit_Boolean() , FALSE);
    cause = '[' + this.this$0.name_0 + '] ' + (i = null == results?-1:results.indexOf('\tat ') , -1 == i?results:results.substr(0, i - 0));
    $changeIcon(this.this$0, this.this$0.iconRed, cause);
    $setUploadError(this.this$0, cause);
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('Error uploading file [' + this.this$0.name_0 + ']', results, ($clinit_Message$Severity() , Error_2)));
  }
}
;
_.this$0 = null;
function FileUploadForm$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2418, 1, makeCastMap([Q$EventHandler, Q$FormSubmitFailedHandler]), FileUploadForm$4_0);
_.onFormSubmitFailed = function onFormSubmitFailed_1(event_0){
  var cause;
  this.this$0.uploadInProgress = false;
  this.this$0.uploadResult = ($clinit_Boolean() , FALSE);
  cause = 'Error uploading file [' + this.this$0.name_0 + '], check for invalid file path.';
  $changeIcon(this.this$0, this.this$0.iconRed, cause);
  $setUploadError(this.this$0, cause);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(cause, ($clinit_Message$Severity() , Error_2)));
}
;
_.this$0 = null;
function PluginFileUploadForm_0(name_0){
  $clinit_BaseWidget();
  FileUploadForm_0.call(this, name_0, '0', true, true, null);
  $setAction(this, getModuleBaseURL() + 'PluginFileUploadServlet');
}

defineSeed(2419, 1925, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), PluginFileUploadForm_0);
_.processSubmitCompleteResults = function processSubmitCompleteResults_3(submitCompleteEventResults){
  return submitCompleteEventResults.indexOf('Error uploading file') == -1;
}
;
function $retrievalStatus(this$static){
  var iconSrc, loadedIcon, msg;
  if (this$static.uploadButton) {
    iconSrc = getAvailabilityIcon(($clinit_Boolean() , TRUE));
    msg = new Message_7('File successfully uploaded', ($clinit_Message$Severity() , Info));
    loadedIcon = new FormItemIcon_0;
    loadedIcon.jsObj['src'] = iconSrc;
    $setWidth_4(loadedIcon, valueOf_44(16));
    $setHeight_2(loadedIcon, valueOf_44(16));
    $setIcons(this$static.uploadButton, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [loadedIcon]));
    $setShowIcons(this$static.uploadButton, TRUE);
    $markForRedraw(this$static);
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  }
}

function TextFileRetrieverForm_0(){
  $clinit_BaseWidget();
  DynamicCallbackForm_0.call(this, 'textFileRetriever');
  $isCreated_1(this)?$setProperty_0(this, 'numCols', 8):(this.config_0['numCols'] = 8 , undefined);
  $setAttribute_24(this, 'encoding', ($clinit_Encoding() , MULTIPART).value_0, true);
  $setAction(this, getModuleBaseURL() + '/FileUploadServlet');
}

defineSeed(2420, 1926, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), TextFileRetrieverForm_0);
_.onDraw_0 = function onDraw_22(){
  var loadingIcon, retrieveField, sessionIdField;
  retrieveField = new HiddenItem_0('retrieve');
  $setDefaultValue(retrieveField, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  sessionIdField = new HiddenItem_0('sessionid');
  $setDefaultValue_0(sessionIdField, valueOf_44(($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0).sessionId.value_0));
  $isCreated_1(this)?$setProperty_0(this, 'numCols', 4):(this.config_0['numCols'] = 4 , undefined);
  this.textFile = new UploadItem_0('textFile', 'File to Upload');
  $setColSpan(this.textFile, 1);
  $setEndRow_0(this.textFile, FALSE);
  $setWrapTitle(this.textFile, FALSE);
  this.uploadButton = new TextFileRetrieverForm$1EnableInterceptingButtonItem_0(this);
  $setIcon_2(this.uploadButton);
  $setStartRow_1(this.uploadButton, FALSE);
  $setDisabled_2(this.uploadButton, TRUE);
  $addChangeHandler(this.textFile, new TextFileRetrieverForm$1_0(this));
  $addClickHandler_1(this.uploadButton, new TextFileRetrieverForm$2_0(this));
  loadingIcon = new FormItemIcon_0;
  loadingIcon.jsObj['src'] = 'ajax-loader.gif';
  $setWidth_4(loadingIcon, valueOf_44(16));
  $setHeight_2(loadingIcon, valueOf_44(16));
  $setIcons(this.uploadButton, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [loadingIcon]));
  $setShowIcons(this.uploadButton, FALSE);
  $setFields_0(this, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [retrieveField, sessionIdField, this.textFile, this.uploadButton]));
}
;
_.textFile = null;
_.uploadButton = null;
function TextFileRetrieverForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2421, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), TextFileRetrieverForm$1_0);
_.onChange = function onChange_5(changeEvent){
  $setDisabled_2(this.this$0.uploadButton, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowIcons(this.this$0.uploadButton, FALSE);
}
;
_.this$0 = null;
function TextFileRetrieverForm$1EnableInterceptingButtonItem_0(this$0){
  this.this$0 = this$0;
  ButtonItem_0.call(this);
}

defineSeed(2422, 488, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$CanvasItem, Q$FormItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), TextFileRetrieverForm$1EnableInterceptingButtonItem_0);
_.enable_0 = function enable_1(){
  var selectedFile;
  selectedFile = $getValueAsString_1(this.this$0.textFile);
  selectedFile != null && selectedFile.length > 0 && $setDisabled_2(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
}
;
_.this$0 = null;
function TextFileRetrieverForm$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2423, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), TextFileRetrieverForm$2_0);
_.onClick_0 = function onClick_89(clickEvent){
  var selectedFile;
  selectedFile = $getValueAsString_1(this.this$0.textFile);
  if (selectedFile != null && selectedFile.length > 0) {
    $setShowIcons(this.this$0.uploadButton, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $markForRedraw(this.this$0);
    $submitForm_0(this.this$0);
  }
   else {
    $setDisabled_2(this.this$0.uploadButton, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $setShowIcons(this.this$0.uploadButton, FALSE);
  }
}
;
_.this$0 = null;
function AbstractSectionedLeftNavigationView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2424, 1, {}, AbstractSectionedLeftNavigationView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_7(permissions){
  var section, section$iterator, sections, treeGrid, self_0;
  this.this$0.globalPermissions_0 = permissions?permissions:noneOf(Lorg_rhq_core_domain_authz_Permission_2_classLit);
  sections = this.this$0.getNavigationSections();
  this.this$0.sectionsByName = new HashMap_1(sections.size_0);
  for (section$iterator = new AbstractList$IteratorImpl_0(sections); section$iterator.i < section$iterator.this$0_0.size_1();) {
    section = dynamicCast($next_0(section$iterator), Q$NavigationSection);
    treeGrid = $buildTreeGridForSection(section);
    $addSection_0(this.this$0, treeGrid);
    self_0 = getOrCreateRef_13($getAttributeAsJavaScriptObject_1(treeGrid, 'data')).getOrCreateJsObj();
    self_0.openAll();
    this.this$0.sectionsByName.put(section.viewName.name_0, section);
  }
  $addMember(this.this$0, this.this$0.sectionStack);
  $addMember(this.this$0, this.this$0.contentCanvas);
  this.this$0.initialized = true;
}
;
_.this$0 = null;
function AbstractSectionedLeftNavigationView$2_0(this$0, val$treeGrid, val$sectionName){
  this.this$0 = this$0;
  this.val$treeGrid = val$treeGrid;
  this.val$sectionName = val$sectionName;
}

defineSeed(2425, 1, makeCastMap([Q$EventHandler, Q$CellClickHandler]), AbstractSectionedLeftNavigationView$2_0);
_.onCellClick = function onCellClick_1(event_0){
  var pageName, selectedRecord, viewPath;
  selectedRecord = dynamicCast($getSelectedRecord_0(this.val$treeGrid), Q$TreeNode);
  if (selectedRecord) {
    pageName = getAttribute(selectedRecord.jsObj, 'name');
    viewPath = this.this$0.viewId + '/' + this.val$sectionName + '/' + pageName;
    $clinit_CoreGUI();
    goToView(viewPath, null, false);
  }
}
;
_.this$0 = null;
_.val$sectionName = null;
_.val$treeGrid = null;
function NavigationItem_0(name_0, icon, viewFactory){
  NavigationItem_1.call(this, name_0, icon, viewFactory);
}

function NavigationItem_1(name_0, icon, viewFactory){
  this.icon_0 = icon;
  this.viewName = name_0;
  this.viewFactory = viewFactory;
  this.enabled = true;
}

function NavigationItem_2(name_0, viewFactory){
  NavigationItem_1.call(this, name_0, name_0.icon_0.icon16x16Path, viewFactory);
}

function NavigationItem_3(name_0, viewFactory, enabled){
  this.icon_0 = name_0.icon_0.icon16x16Path;
  this.viewName = name_0;
  this.viewFactory = viewFactory;
  this.enabled = enabled;
}

defineSeed(2426, 1, makeCastMap([Q$NavigationItem]), NavigationItem_0, NavigationItem_2, NavigationItem_3);
_.enabled = false;
_.icon_0 = null;
_.refreshRequired = false;
_.viewFactory = null;
_.viewName = null;
function NavigationSection_0(name_0, navigationItems){
  var navigationItem, navigationItem$index, navigationItem$max;
  this.viewName = name_0;
  this.navigationItems = new Arrays$ArrayList_0(navigationItems);
  this.navigationItemsByName = new LinkedHashMap_1(navigationItems.length);
  for (navigationItem$index = 0 , navigationItem$max = navigationItems.length; navigationItem$index < navigationItem$max; ++navigationItem$index) {
    navigationItem = navigationItems[navigationItem$index];
    $put_1(this.navigationItemsByName, navigationItem.viewName.name_0, navigationItem);
  }
}

defineSeed(2427, 1, makeCastMap([Q$NavigationSection]), NavigationSection_0);
_.navigationItems = null;
_.navigationItemsByName = null;
_.viewName = null;
function ViewName_0(name_0){
  ViewName_1.call(this, name_0, null);
}

defineSeed(2428, 1, makeCastMap([Q$ViewName]), ViewName_0);
function $clinit_Wizard(){
  $clinit_Wizard = nullMethod;
  $clinit_CoreGUI();
}

function $clinit_WizardStep(){
  $clinit_WizardStep = nullMethod;
  $clinit_CoreGUI();
}

function $clinit_WizardView(){
  $clinit_WizardView = nullMethod;
  $clinit_BaseWidget();
  $clinit_CoreGUI();
}

function $closeDialog(this$static){
  var canvas, canvas$iterator;
  for (canvas$iterator = $iterator($keySet(this$static.createdCanvases.map)); canvas$iterator.val$outerIter.hasNext();) {
    canvas = dynamicCast($next_1(canvas$iterator), Q$Canvas);
    canvas.destroy_0();
  }
  $destroy(this$static.wizardWindow);
}

function $decrementStep(this$static){
  $setStep_0(this$static, this$static.currentStep - 1);
}

function $displayDialog(this$static){
  this$static.wizardWindow = new Window_1;
  $setTitle(this$static.wizardWindow, this$static.wizard.getWindowTitle());
  $setWidth(this$static.wizardWindow, 800);
  $setHeight(this$static.wizardWindow, 600);
  $setIsModal(this$static.wizardWindow, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setShowModalMask(this$static.wizardWindow, TRUE);
  $setCanDragResize_0(this$static.wizardWindow, TRUE);
  $setShowResizer(this$static.wizardWindow, TRUE);
  $centerInPage(this$static.wizardWindow);
  $addCloseClickHandler(this$static.wizardWindow, new WizardView$5_0(this$static));
  $addItem(this$static.wizardWindow, this$static);
  this$static.wizardWindow.show_0();
}

function $incrementStep(this$static){
  $setStep_0(this$static, this$static.currentStep + 1);
}

function $refreshTitleLabelContents(this$static){
  $setContents(this$static.titleLabel, '<span class="HeaderLabel">' + this$static.wizard.getTitle() + '<\/span><br/>' + (this$static.wizard.getSubtitle() != null?this$static.wizard.getSubtitle():''));
}

function $setStep_0(this$static, stepIndex){
  var button, button$iterator, newCustomButtons, step, wizardSteps;
  $setAttribute_24(this$static.previousButton, 'visibility', (stepIndex >= 1?($clinit_Visibility() , INHERIT):($clinit_Visibility() , HIDDEN_0)).value_0, true);
  if (stepIndex < 0) {
    $setDisabled(this$static.previousButton, true);
    return;
  }
  wizardSteps = this$static.wizard.steps;
  if (stepIndex >= wizardSteps.size_0) {
    $closeDialog(this$static);
    return;
  }
  this$static.currentStep = stepIndex;
  $setContents_0(this$static.stepLabel, 'Step ' + (stepIndex + 1) + ' of ' + wizardSteps.size_0);
  $setWrap_0(this$static.stepLabel, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  step = dynamicCast($get_0(wizardSteps, this$static.currentStep), Q$WizardStep);
  $setContents_0(this$static.stepTitleLabel, step.getName());
  $setDisabled(this$static.cancelButton, true);
  $setDisabled(this$static.previousButton, true);
  $setDisabled(this$static.nextButton, true);
  for (button$iterator = new AbstractList$IteratorImpl_0(this$static.customButtons); button$iterator.i < button$iterator.this$0_0.size_1();) {
    button = dynamicCast($next_0(button$iterator), Q$IButton);
    $removeMember(this$static.buttonBar, button);
  }
  $clear_2(this$static.customButtons);
  newCustomButtons = this$static.wizard.getCustomButtons(this$static.currentStep);
  if (newCustomButtons) {
    for (button$iterator = new AbstractList$IteratorImpl_0(newCustomButtons); button$iterator.i < button$iterator.this$0_0.size_1();) {
      button = dynamicCast($next_0(button$iterator), Q$IButton);
      $setAttribute_22(button, 'disabled', TRUE, true);
      $addMember(this$static.buttonBar, button);
      $add_3(this$static.customButtons, button);
    }
  }
  !!this$static.currentCanvas && $removeMember(this$static.contentLayout, this$static.currentCanvas);
  this$static.currentCanvas = dynamicCast($get_0(wizardSteps, this$static.currentStep), Q$WizardStep).getCanvas();
  if (!this$static.currentCanvas) {
    step.nextPage_0() && dynamicCast($get_0(wizardSteps, this$static.currentStep), Q$WizardStep).nextPage_0();
    $setDisabled(this$static.cancelButton, false);
    $setDisabled(this$static.previousButton, stepIndex == 0);
    $setDisabled(this$static.nextButton, false);
  }
   else {
    $doAddHandler_0(this$static.currentCanvas, new WizardView$4_0(this$static, stepIndex, wizardSteps, step), TYPE_8?TYPE_8:(TYPE_8 = new GwtEvent$Type_0));
    $add_6(this$static.createdCanvases, this$static.currentCanvas);
    $addMember(this$static.contentLayout, this$static.currentCanvas);
    $hide(this$static.messageBar);
  }
  $markForRedraw(this$static);
}

function $showMessage(this$static, message){
  if (null == message) {
    $hide(this$static.messageBar);
  }
   else {
    $setContents(this$static.messageLabel, "<span style='color:red'>" + message + '<\/span>');
    $show(this$static.messageBar);
  }
}

function $updateButtonEnablement(this$static){
  var step;
  step = dynamicCast($get_0(this$static.wizard.steps, this$static.currentStep), Q$WizardStep);
  $setDisabled(this$static.nextButton, !step.isNextButtonEnabled());
}

function WizardView_0(wizard){
  $clinit_WizardView();
  EnhancedVLayout_1.call(this);
  this.customButtons = new ArrayList_0;
  this.createdCanvases = new HashSet_0;
  this.wizard = wizard;
}

defineSeed(2429, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), WizardView_0);
_.onDraw_0 = function onDraw_23(){
  this.titleBar = new HLayout_1(30);
  $setHeight(this.titleBar, 50);
  $setPadding(this.titleBar, valueOf_44(10));
  $setBackgroundColor(this.titleBar, '#F0F0F0');
  this.titleLabel = new HTMLFlow_0;
  $setContents(this.titleLabel, '<span class="HeaderLabel">' + this.wizard.getTitle() + '<\/span><br/>' + (this.wizard.getSubtitle() != null?this.wizard.getSubtitle():''));
  $setWidth_0(this.titleLabel, '*');
  this.stepLabel = new Label_3;
  $setWidth(this.stepLabel, 60);
  $addMember(this.titleBar, this.titleLabel);
  $addMember(this.titleBar, this.stepLabel);
  $addMember(this, this.titleBar);
  this.stepTitleLabel = new Label_3;
  $setAttribute_24(this.stepTitleLabel, 'width', '100%', true);
  $setHeight(this.stepTitleLabel, 40);
  $setPadding(this.stepTitleLabel, valueOf_44(20));
  $setStyleName_0(this.stepTitleLabel, 'HeaderLabel');
  $addMember(this, this.stepTitleLabel);
  this.contentLayout = new HLayout_0;
  $setHeight_0(this.contentLayout, '*');
  $setAttribute_24(this.contentLayout, 'width', '100%', true);
  $setPadding(this.contentLayout, valueOf_44(10));
  $addMember(this, this.contentLayout);
  this.messageBar = new HLayout_0;
  $setHeight(this.messageBar, 20);
  $setPadding(this.messageBar, valueOf_44(2));
  $setBackgroundColor(this.messageBar, '#F0F0F0');
  this.messageLabel = new HTMLFlow_0;
  $setWidth_0(this.messageLabel, '*');
  $setLeft(this.messageLabel, 20);
  $addMember(this.messageBar, this.messageLabel);
  $setAttribute_24(this.messageBar, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  $addMember(this, this.messageBar);
  this.buttonBar = new ToolStrip_0;
  $setPadding(this.buttonBar, valueOf_44(5));
  $setAttribute_24(this.buttonBar, 'width', '100%', true);
  $setMembersMargin(this.buttonBar, 15);
  this.cancelButton = new EnhancedIButton_1('Cancel');
  $setDisabled(this.cancelButton, false);
  $addClickHandler(this.cancelButton, new WizardView$1_0(this));
  $addMember(this.buttonBar, this.cancelButton);
  $addMember(this.buttonBar, new LayoutSpacer_0);
  this.previousButton = new EnhancedIButton_1('Previous');
  $setDisabled(this.previousButton, true);
  $addClickHandler(this.previousButton, new WizardView$2_0(this));
  this.wizard.steps.size_0 <= 1 && $setAttribute_24(this.previousButton, 'visibility', HIDDEN_0.value_0, true);
  $addMember(this.buttonBar, this.previousButton);
  this.nextButton = new EnhancedIButton_1('Next');
  $addClickHandler(this.nextButton, new WizardView$3_0(this));
  $addMember(this.buttonBar, this.nextButton);
  $addMember(this, this.buttonBar);
  $setStep_0(this, 0);
}
;
_.buttonBar = null;
_.cancelButton = null;
_.contentLayout = null;
_.currentCanvas = null;
_.currentStep = 0;
_.messageBar = null;
_.messageLabel = null;
_.nextButton = null;
_.previousButton = null;
_.stepLabel = null;
_.stepTitleLabel = null;
_.titleBar = null;
_.titleLabel = null;
_.wizard = null;
_.wizardWindow = null;
function WizardView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2430, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), WizardView$1_0);
_.onClick = function onClick_90(clickEvent){
  this.this$0.wizard.cancel_0();
  $closeDialog(this.this$0);
}
;
_.this$0 = null;
function WizardView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2431, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), WizardView$2_0);
_.onClick = function onClick_91(clickEvent){
  var step;
  step = dynamicCast($get_0(this.this$0.wizard.steps, this.this$0.currentStep), Q$WizardStep);
  step.previousPage() && $decrementStep(this.this$0);
}
;
_.this$0 = null;
function WizardView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2432, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), WizardView$3_0);
_.onClick = function onClick_92(clickEvent){
  var step;
  step = dynamicCast($get_0(this.this$0.wizard.steps, this.this$0.currentStep), Q$WizardStep);
  step.nextPage_0() && $incrementStep(this.this$0);
}
;
_.this$0 = null;
function $onDraw_2(this$static){
  var button, button$iterator, last;
  last = this$static.val$stepIndex == this$static.val$wizardSteps.size_0 - 1;
  last?$setTitle_0(this$static.this$0.nextButton, ($clinit_WizardView() , 'Finish')):$setTitle_0(this$static.this$0.nextButton, ($clinit_WizardView() , 'Next'));
  $setDisabled(this$static.this$0.cancelButton, false);
  $setDisabled(this$static.this$0.previousButton, this$static.val$stepIndex == 0);
  $setDisabled(this$static.this$0.nextButton, !this$static.val$step.isNextButtonEnabled());
  for (button$iterator = new AbstractList$IteratorImpl_0(this$static.this$0.customButtons); button$iterator.i < button$iterator.this$0_0.size_1();) {
    button = dynamicCast($next_0(button$iterator), Q$IButton);
    $setAttribute_22(button, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , FALSE), true);
  }
  $markForRedraw(this$static.this$0);
}

function WizardView$4_0(this$0, val$stepIndex, val$wizardSteps, val$step){
  this.this$0 = this$0;
  this.val$stepIndex = val$stepIndex;
  this.val$wizardSteps = val$wizardSteps;
  this.val$step = val$step;
}

defineSeed(2433, 1, makeCastMap([Q$EventHandler, Q$DrawHandler]), WizardView$4_0);
_.onDraw_1 = function onDraw_24(event_0){
  $onDraw_2(this);
}
;
_.this$0 = null;
_.val$step = null;
_.val$stepIndex = 0;
_.val$wizardSteps = null;
function WizardView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2434, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), WizardView$5_0);
_.onCloseClick_0 = function onCloseClick_6(closeClickEvent){
  this.this$0.wizard.cancel_0();
  $closeDialog(this.this$0);
}
;
_.this$0 = null;
function $copyValues_29(from){
  var record;
  record = new TreeNode_0;
  record.setID('' + from.id);
  record.setName(from.name_0);
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'name', from.name_0);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_13(record, 'syncSchedule', from.syncSchedule);
  $setAttribute_13(record, 'syncStatus', from.syncStatus);
  record.jsObj['isFolder'] = false;
  return record;
}

function $executeFetch_19(this$static, request, response, criteria){
  $findReposByCriteria(this$static.repoService, criteria, new ContentRepositoryTreeDataSource$1_0(this$static, response, request));
}

function ContentRepositoryTreeDataSource_0(){
  var fields_0, idDataField, nameDataField, parentIdField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.repoService = dynamicCast(secure(getInstance_49(), -1), Q$RepoGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , idDataField = new DataSourceTextField_1('id', 'ID') , $setAttribute_8(idDataField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , setCheck(fields_0.array, fields_0.size_0++, idDataField) , nameDataField = new DataSourceTextField_1('name', 'Name') , $setAttribute_8(nameDataField, 'canEdit', FALSE) , setCheck(fields_0.array, fields_0.size_0++, nameDataField) , parentIdField = new DataSourceTextField_1('parentId', 'Parent ID') , parentIdField.jsObj['foreignKey'] = 'id' , setCheck(fields_0.array, fields_0.size_0++, parentIdField) , fields_0);
  $addFields(this, fields);
}

defineSeed(2435, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ContentRepositoryTreeDataSource_0);
_.copyValues = function copyValues_48(from){
  return null;
}
;
_.copyValues_0 = function copyValues_49(from){
  return $copyValues_29(dynamicCast(from, Q$Repo));
}
;
_.executeFetch = function executeFetch_25(request, response, criteria){
  $executeFetch_19(this, request, response, dynamicCast(criteria, Q$RepoCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_29(request){
  return new RepoCriteria_0;
}
;
function $onSuccess_183(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ContentRepositoryTreeDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2436, 1, {}, ContentRepositoryTreeDataSource$1_0);
_.onFailure = function onFailure_193(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Error loading repositories'), caught);
}
;
_.onSuccess_0 = function onSuccess_193(result){
  $onSuccess_183(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function ContentRepositoryTreeView_0(){
  $clinit_BaseWidget();
  TreeGrid_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $setShowRoot(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAutoFetchData_0(this, TRUE);
  $setAnimateFolders(this, FALSE);
  $setAttribute_24(this, 'selectionType', ($clinit_SelectionStyle() , SINGLE).value_0, true);
  $setShowRollOver_2(this, FALSE);
  $isCreated_1(this)?$setProperty_3(this, 'sortField', 'name'):(this.config_0['sortField'] = 'name' , undefined);
  $setShowHeader_0(this, FALSE);
  $setAttribute_20(this, 'dataSource', $getOrCreateJsObj(new ContentRepositoryTreeDataSource_0), true);
  $addNodeClickHandler(this, new ContentRepositoryTreeView$1_0);
}

defineSeed(2437, 575, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$TreeGrid]), ContentRepositoryTreeView_0);
function ContentRepositoryTreeView$1_0(){
}

defineSeed(2438, 1, makeCastMap([Q$EventHandler, Q$NodeClickHandler]), ContentRepositoryTreeView$1_0);
_.onNodeClick = function onNodeClick_0(event_0){
  var id, path;
  id = $getAttribute($getNode(event_0), 'id');
  if (id != null) {
    path = $replaceAll(id, ':', '/');
    $clinit_CoreGUI();
    goToView('Bundles/Repository/' + path, null, false);
  }
}
;
function onDestroy_0(refreshTimer){
  !!refreshTimer && (refreshTimer.isRepeating?clearInterval_0(refreshTimer.timerId):clearTimeout_0(refreshTimer.timerId) , $remove_4(($clinit_Timer() , timers), refreshTimer));
}

function startRefreshCycle(autoRefresh, autoRefreshCanvas, refreshTimer){
  var refreshInterval;
  refreshInterval = $getPageRefreshInterval(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences));
  if (refreshTimer) {
    refreshTimer.isRepeating?clearInterval_0(refreshTimer.timerId):clearTimeout_0(refreshTimer.timerId);
    $remove_4(($clinit_Timer() , timers), refreshTimer);
    refreshTimer = null;
  }
  if (gte_0(fromInt(refreshInterval), Pea60_longLit)) {
    refreshTimer = new AutoRefreshUtil$1_0(autoRefresh, autoRefreshCanvas);
    $scheduleRepeating(refreshTimer, refreshInterval);
  }
  return refreshTimer;
}

function AutoRefreshUtil$1_0(val$autoRefresh, val$autoRefreshCanvas){
  $clinit_Timer();
  this.val$autoRefresh = val$autoRefresh;
  this.val$autoRefreshCanvas = val$autoRefreshCanvas;
}

defineSeed(2441, 73, makeCastMap([Q$Timer]), AutoRefreshUtil$1_0);
_.run = function run_13(){
  !this.val$autoRefresh.isRefreshing() && $isDrawn(this.val$autoRefreshCanvas).value_0 && $isVisible(this.val$autoRefreshCanvas) && this.val$autoRefresh.refresh_0();
}
;
_.val$autoRefresh = null;
_.val$autoRefreshCanvas = null;
function $clinit_DashboardView(){
  $clinit_DashboardView = nullMethod;
  $clinit_BaseWidget();
  STOP = ($clinit_Enhanced() , 'No Refresh');
  REFRESH1 = '1 minute';
  REFRESH5 = '5 minutes';
  REFRESH10 = '10 minutes';
  STOP_VALUE = valueOf_44(0);
  REFRESH1_VALUE = valueOf_44(60000);
  REFRESH5_VALUE = valueOf_44(300000);
  REFRESH10_VALUE = valueOf_44(600000);
}

function $addPortlet_1(this$static, portletKey, portletName){
  var newPortletWindow, outline, placeHolder, portalColumn, storedPortlet, self_0, self_1, self_2;
  storedPortlet = new DashboardPortlet_1(portletName, portletKey, 250);
  $addPortlet(this$static.storedDashboard, storedPortlet);
  newPortletWindow = new PortletWindow_0(this$static, storedPortlet, this$static.context);
  $isCreated_1(newPortletWindow)?$setProperty_3(newPortletWindow, 'title', portletName):(newPortletWindow.config_0['title'] = portletName , undefined);
  $isCreated_1(newPortletWindow)?$setProperty_0(newPortletWindow, 'height', 350):(newPortletWindow.config_0['height'] = 350 , undefined);
  $setAttribute_24(newPortletWindow, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  $add_6(this$static.portletWindows, newPortletWindow);
  $addPortletWindow(this$static.portalLayout, newPortletWindow, storedPortlet.column);
  portalColumn = dynamicCast($getMember(this$static.portalLayout, storedPortlet.column), Q$PortalColumn);
  placeHolder = new LayoutSpacer_0;
  $addMember(portalColumn, placeHolder);
  outline = new Canvas_1;
  $setLeft(outline, $getPageLeft(this$static.editForm) + $getAttributeAsInt_0(this$static.addPortlet, 'left').value_0);
  $setTop(outline, $getPageTop(this$static.editForm));
  $setWidth(outline, $getAttributeAsInt_0(this$static.addPortlet, 'width').value_0);
  $setHeight(outline, $getAttributeAsInt_0(this$static.addPortlet, 'height').value_0);
  $isCreated_1(outline)?$setProperty_3(outline, 'border', '2px solid 8289A6'):(outline.config_0['border'] = '2px solid 8289A6' , undefined);
  $draw(outline);
  self_0 = outline.getOrCreateJsObj();
  self_0.bringToFront();
  $animateRect(outline, valueOf_44($getPageLeft(newPortletWindow)), valueOf_44($getPageTop(newPortletWindow)), valueOf_44((self_1 = newPortletWindow.getOrCreateJsObj() , self_1.getVisibleWidth())), valueOf_44((self_2 = newPortletWindow.getOrCreateJsObj() , self_2.getViewportHeight())), new DashboardView$7_0(placeHolder, outline, newPortletWindow), 750);
  $save_3(this$static);
}

function $buildEditForm(this$static){
  var addCanvas, addColumn, addPortletMenu, i, item, menuClick, menuItem, nameItem, numColItem, picker, portletKey, portletName, refreshCanvas, refreshIntervals, refreshMenu, refreshValues, removeColumn, retrievedRefreshInterval, valueMap;
  this$static.editForm = new DynamicForm_0;
  $setMargin(this$static.editForm, valueOf_44(5));
  $setAutoWidth(this$static.editForm);
  $setNumCols(this$static.editForm, 12);
  nameItem = null;
  if (this$static.dashboardContainer.supportsDashboardNameEdit()) {
    nameItem = new TextItem_3('name', ($clinit_Enhanced() , 'Dashboard Name'));
    $setValue_7(nameItem, this$static.storedDashboard.name_0);
    $setLength_0(nameItem, valueOf_44(200));
    $setWrapTitle(nameItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addBlurHandler(nameItem, new DashboardView$1_0(this$static));
  }
  numColItem = new StaticTextItem_0;
  $setTitle_1(numColItem, ($clinit_Enhanced() , 'Columns'));
  $setValue_5(numColItem, valueOf_44(__parseAndValidateInt($getSimpleValue(this$static.storedDashboard.configuration, 'columns', '1'))).value_0);
  $setWrapTitle(numColItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  addColumn = new ButtonItem_1('addColumn', 'Add Column');
  $setAutoFit_1(addColumn, TRUE);
  $setStartRow_1(addColumn, FALSE);
  $setEndRow_1(addColumn, FALSE);
  removeColumn = new ButtonItem_1('removeColumn', 'Remove Column');
  $setAutoFit_1(removeColumn, TRUE);
  $setStartRow_1(removeColumn, FALSE);
  $setEndRow_1(removeColumn, FALSE);
  $setDisabled_2(removeColumn, valueOf_44(__parseAndValidateInt($getSimpleValue(this$static.storedDashboard.configuration, 'columns', '1'))).value_0 == 1?TRUE:FALSE);
  $addClickHandler_1(addColumn, new DashboardView$2_0(this$static, numColItem, removeColumn));
  $addClickHandler_1(removeColumn, new DashboardView$3_0(this$static, numColItem, removeColumn));
  addPortletMenu = new Menu_0;
  switch (this$static.context.type_0.ordinal) {
    case 4:
      valueMap = ($clinit_PortletFactory() , $clinit_PortletFactory() , globalPortletMenuMap);
      break;
    case 2:
      valueMap = processPortletNameMapForGroup(this$static.groupComposite);
      $putAll(valueMap, ($clinit_PortletFactory() , $clinit_PortletFactory() , globalPortletMenuMap));
      break;
    case 0:
      valueMap = processPortletNameMapForResource(this$static.resourceComposite);
      $putAll(valueMap, ($clinit_PortletFactory() , $clinit_PortletFactory() , globalPortletMenuMap));
      break;
    default:throw new IllegalStateException_1('Unsupported context [' + this$static.context + ']');
  }
  for (i = $iterator($keySet(valueMap)); i.val$outerIter.hasNext();) {
    portletKey = dynamicCast($next_1(i), Q$String);
    portletName = dynamicCast($get_4(valueMap, portletKey), Q$String);
    menuItem = new MenuItem_1(portletName);
    menuItem.jsObj['portletKey'] = portletKey;
    $addItem_0(addPortletMenu, menuItem);
  }
  this$static.addPortlet = new IMenuButton_1('Add Portlet', addPortletMenu);
  $setIcon_0(this$static.addPortlet, '[skin]/images/actions/add.png');
  $setAutoFit(this$static.addPortlet, TRUE);
  $addItemClickHandler(addPortletMenu, new DashboardView$4_0(this$static));
  addCanvas = new CanvasItem_0;
  addCanvas.setShowTitle(FALSE);
  $setCanvas(addCanvas, this$static.addPortlet);
  addCanvas.setStartRow(FALSE);
  addCanvas.setEndRow(FALSE);
  picker = new ColorButtonItem_0('Background');
  $setStartRow_1(picker, FALSE);
  $setEndRow_1(picker, FALSE);
  $setCurrentColor(picker, $getSimpleValue(this$static.storedDashboard.configuration, 'background', 'white'));
  $setColorSelectedHandler(picker, new DashboardView$5_0(this$static));
  refreshMenu = new Menu_0;
  $setShowShadow(refreshMenu, TRUE);
  $isCreated_1(refreshMenu)?undefined:(refreshMenu.config_0['shadowDepth'] = 10 , undefined);
  $isCreated_1(refreshMenu)?$setProperty_0(refreshMenu, 'width', 1):(refreshMenu.config_0['width'] = 1 , undefined);
  $isCreated_1(refreshMenu)?$setProperty_0(refreshMenu, 'height', 15):(refreshMenu.config_0['height'] = 15 , undefined);
  menuClick = new DashboardView$6_0(this$static);
  refreshIntervals = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [STOP, REFRESH1, REFRESH5, REFRESH10]);
  refreshValues = initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [STOP_VALUE, REFRESH1_VALUE, REFRESH5_VALUE, REFRESH10_VALUE]);
  this$static.refreshMenuMappings = new HashMap_0;
  this$static.refreshMenuItems = initDim(_3Lcom_smartgwt_client_widgets_menu_MenuItem_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$MenuItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$MenuItem, refreshIntervals.length, 0);
  retrievedRefreshInterval = REFRESH1_VALUE.value_0;
  !!($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences) && (retrievedRefreshInterval = $getPageRefreshInterval(userPreferences));
  for (i = 0; i < refreshIntervals.length; ++i) {
    item = new MenuItem_2(refreshIntervals[i], '');
    $getHandlerCount_0(item, (!TYPE_47 && (TYPE_47 = new GwtEvent$Type_0) , TYPE_47)) == 0 && $setupClickEvent_2(item);
    $doAddHandler(item, menuClick, (!TYPE_47 && (TYPE_47 = new GwtEvent$Type_0) , TYPE_47));
    this$static.refreshMenuMappings.put(refreshValues[i], refreshIntervals[i]);
    retrievedRefreshInterval == refreshValues[i].value_0 && $setAttribute_13(item, 'icon', getAvailabilityIcon(TRUE));
    setCheck(this$static.refreshMenuItems, i, item);
  }
  $setItems_0(refreshMenu, this$static.refreshMenuItems);
  this$static.refreshMenuButton = new IMenuButton_1('Refresh Interval', refreshMenu);
  $isCreated_1(refreshMenu)?$setProperty_0(refreshMenu, 'height', 1):(refreshMenu.config_0['height'] = 1 , undefined);
  $setItems_0(getOrCreateRef_10($getAttributeAsJavaScriptObject_1(this$static.refreshMenuButton, 'menu')), this$static.refreshMenuItems);
  $setWidth(this$static.refreshMenuButton, 140);
  $setShowTitle(this$static.refreshMenuButton, TRUE);
  $setTop(this$static.refreshMenuButton, 0);
  $setIconOrientation(this$static.refreshMenuButton);
  refreshCanvas = new CanvasItem_0;
  refreshCanvas.setShowTitle(FALSE);
  $setCanvas(refreshCanvas, this$static.refreshMenuButton);
  refreshCanvas.setStartRow(FALSE);
  refreshCanvas.setEndRow(FALSE);
  nameItem?this$static.editForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [nameItem, addCanvas, numColItem, addColumn, removeColumn, picker, refreshCanvas])):this$static.editForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [addCanvas, numColItem, addColumn, removeColumn, picker, refreshCanvas]));
  $updateRefreshMenu(this$static);
  $markForRedraw(this$static.refreshMenuButton);
  $markForRedraw(this$static);
  $markForRedraw(this$static.editForm);
  $markForRedraw(this$static);
  return this$static.editForm;
}

function $buildPortlets(this$static){
  $setBackgroundColor(this$static, $getSimpleValue(this$static.storedDashboard.configuration, 'background', 'white'));
  this$static.portalLayout = new PortalLayout_0(this$static, valueOf_44(__parseAndValidateInt($getSimpleValue(this$static.storedDashboard.configuration, 'columns', '1'))).value_0, $split($getSimpleValue(this$static.storedDashboard.configuration, 'widths', ''), ',', 0));
  $setAttribute_24(this$static.portalLayout, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $setAttribute_24(this$static.portalLayout, 'width', '100%', true);
  $setAttribute_24(this$static.portalLayout, 'height', '100%', true);
  $loadPortletWindows(this$static);
  $addMember(this$static, this$static.portalLayout);
}

function $delete_2(this$static){
  !!this$static.storedDashboard && this$static.storedDashboard.id > 0 && $removeDashboard(dynamicCast(secure(getInstance_39(), -1), Q$DashboardGWTServiceAsync), this$static.storedDashboard.id, new DashboardView$9_0(this$static));
}

function $equalsDashboardPortlet(storedPortlet, updatedPortlet){
  var dashMatchId, dashMatchName, unpersistedDash;
  if ($equals_31(storedPortlet, updatedPortlet)) {
    return true;
  }
  if (storedPortlet.id > 0 && updatedPortlet.id > 0) {
    return false;
  }
  if (storedPortlet.column != updatedPortlet.column) {
    return false;
  }
  if (storedPortlet.index_0 != updatedPortlet.index_0) {
    return false;
  }
  unpersistedDash = storedPortlet.dashboard.id == 0 || updatedPortlet.dashboard.id == 0;
  dashMatchId = !unpersistedDash && storedPortlet.dashboard.id == updatedPortlet.dashboard.id;
  dashMatchName = unpersistedDash && $equals_6(storedPortlet.dashboard.name_0, updatedPortlet.dashboard.name_0);
  if (!(dashMatchId || dashMatchName)) {
    return false;
  }
  return true;
}

function $loadPortletWindows(this$static){
  var i, portletWindow, storedPortlet, storedPortlet$iterator;
  for (i = 0; i < valueOf_44(__parseAndValidateInt($getSimpleValue(this$static.storedDashboard.configuration, 'columns', '1'))).value_0; ++i) {
    for (storedPortlet$iterator = new AbstractList$IteratorImpl_0($getPortlets(this$static.storedDashboard, i)); storedPortlet$iterator.i < storedPortlet$iterator.this$0_0.size_1();) {
      storedPortlet = dynamicCast($next_0(storedPortlet$iterator), Q$DashboardPortlet);
      portletWindow = new PortletWindow_0(this$static, storedPortlet, this$static.context);
      $setTitle(portletWindow, storedPortlet.name_0);
      $setHeight(portletWindow, storedPortlet.height);
      $setAttribute_24(portletWindow, 'visibility', ($clinit_Visibility() , INHERIT).value_0, true);
      $add_6(this$static.portletWindows, portletWindow);
      $addPortletWindow(this$static.portalLayout, portletWindow, i);
    }
  }
}

function $maximizePortlet(this$static, portletWindow){
  var col, i, member, member$array, member$index, member$max, numColumns, portlet;
  if (this$static.maximizedPortlet) {
    return;
  }
  this$static.maximizedPortlet = portletWindow;
  numColumns = valueOf_44(__parseAndValidateInt($getSimpleValue(this$static.storedDashboard.configuration, 'columns', '1'))).value_0;
  for (i = 0; i < numColumns; ++i) {
    col = dynamicCast($getMember(this$static.portalLayout, i), Q$PortalColumn);
    portlet = $getMember_0(col, portletWindow.id_0);
    if (!portlet) {
      $hide(col);
    }
     else {
      for (member$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(col, 'members')) , member$index = 0 , member$max = member$array.length; member$index < member$max; ++member$index) {
        member = member$array[member$index];
        if ($equals_0(member, portlet)) {
          $hideSizingHeaderControls(dynamicCast(member, Q$PortletWindow), true);
          $setAttribute_24(member, 'height', '100%', true);
        }
         else {
          member.hide_0();
        }
      }
    }
  }
  $markForRedraw(this$static.portalLayout);
}

function $rebuild(this$static){
  $removeFromParent(this$static.portalLayout);
  $destroy_0(this$static.portalLayout);
  this$static.portalLayout = null;
  this$static.portletWindows.map.clear_0();
  $buildPortlets(this$static);
}

function $redraw_2(this$static){
  var pw, pw$iterator;
  $redraw(this$static);
  for (pw$iterator = $iterator($keySet(this$static.portletWindows.map)); pw$iterator.val$outerIter.hasNext();) {
    pw = dynamicCast($next_1(pw$iterator), Q$PortletWindow);
    dynamicCast(pw.view, Q$Canvas).redraw_0();
  }
}

function $removePortlet_0(this$static, portletWindow){
  $removePortlet(this$static.storedDashboard, portletWindow.storedPortlet);
  $remove_10(this$static.portletWindows, portletWindow);
  $save_3(this$static);
}

function $restorePortlet(this$static){
  var col, i, member, member$array, member$index, member$max, numColumns;
  if (!this$static.maximizedPortlet) {
    return;
  }
  numColumns = valueOf_44(__parseAndValidateInt($getSimpleValue(this$static.storedDashboard.configuration, 'columns', '1'))).value_0;
  for (i = 0; i < numColumns; ++i) {
    col = dynamicCast($getMember(this$static.portalLayout, i), Q$PortalColumn);
    if ($isVisible(col)) {
      for (member$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(col, 'members')) , member$index = 0 , member$max = member$array.length; member$index < member$max; ++member$index) {
        member = member$array[member$index];
        if ($isVisible(member)) {
          $hideSizingHeaderControls(dynamicCast(member, Q$PortletWindow), false);
          $setHeight(member, this$static.maximizedPortlet.storedPortlet.height);
        }
         else {
          member.show_0();
        }
      }
    }
     else {
      $show(col);
    }
  }
  this$static.maximizedPortlet = null;
  $markForRedraw(this$static.portalLayout);
}

function $save_3(this$static){
  $updatePortalColumnWidths(this$static);
  $disable(this$static);
  $storeDashboard(dynamicCast(secure(getInstance_39(), -1), Q$DashboardGWTServiceAsync), this$static.storedDashboard, new DashboardView$8_0(this$static));
}

function $setEditMode(this$static, editMode){
  var portletWindow, portletWindow$iterator;
  this$static.editMode = editMode;
  for (portletWindow$iterator = $iterator($keySet(this$static.portletWindows.map)); portletWindow$iterator.val$outerIter.hasNext();) {
    portletWindow = dynamicCast($next_1(portletWindow$iterator), Q$PortletWindow);
    $hideSizingHeaderControls(portletWindow, editMode);
  }
  editMode?$show(this$static.editForm):$hide(this$static.editForm);
  $markForRedraw(this$static.editForm);
  $show(this$static.portalLayout);
  $markForRedraw(this$static.portalLayout);
}

function $updatePortalColumnWidths(this$static){
  var col, columnPixelWidths, columnWidths, i, numColumns, totalPixelWidth;
  numColumns = valueOf_44(__parseAndValidateInt($getSimpleValue(this$static.storedDashboard.configuration, 'columns', '1'))).value_0;
  totalPixelWidth = 0;
  columnPixelWidths = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, numColumns, 1);
  for (i = 0; i < numColumns; ++i) {
    col = dynamicCast($getMember(this$static.portalLayout, i), Q$PortalColumn);
    totalPixelWidth += $getAttributeAsInt_0(col, 'width').value_0;
    columnPixelWidths[i] = $getAttributeAsInt_0(col, 'width').value_0;
  }
  columnWidths = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, numColumns, 0);
  columnWidths[numColumns - 1] = '*';
  for (i = 0; i < numColumns - 1; ++i) {
    columnWidths[i] = '' + ~~(columnPixelWidths[i] * 100 / totalPixelWidth) + '%';
  }
  $setColumnWidths(this$static.storedDashboard, columnWidths);
  return columnWidths;
}

function $updatePortletWindows(this$static, result){
  var portletWindow, portletWindow$iterator, updatedPortlet, updatedPortlet$iterator, view;
  if (result) {
    for (portletWindow$iterator = $iterator($keySet(this$static.portletWindows.map)); portletWindow$iterator.val$outerIter.hasNext();) {
      portletWindow = dynamicCast($next_1(portletWindow$iterator), Q$PortletWindow);
      for (updatedPortlet$iterator = result.portlets.iterator(); updatedPortlet$iterator.hasNext();) {
        updatedPortlet = dynamicCast(updatedPortlet$iterator.next_0(), Q$DashboardPortlet);
        if ($equalsDashboardPortlet(portletWindow.storedPortlet, updatedPortlet)) {
          portletWindow.storedPortlet = updatedPortlet;
          view = portletWindow.view;
          instanceOf(view, Q$AutoRefreshPortlet) && dynamicCast(view, Q$AutoRefreshPortlet).startRefreshCycle();
          break;
        }
      }
    }
  }
}

function $updateRefreshMenu(this$static){
  var currentSelection, i, menu, retrievedRefreshInterval;
  if (this$static.refreshMenuItems != null) {
    retrievedRefreshInterval = REFRESH1_VALUE.value_0;
    !!($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences) && (retrievedRefreshInterval = $getPageRefreshInterval(userPreferences));
    currentSelection = dynamicCast(this$static.refreshMenuMappings.get_2(valueOf_44(retrievedRefreshInterval)), Q$String);
    if (currentSelection != null) {
      for (i = 0; i < this$static.refreshMenuItems.length; ++i) {
        menu = this$static.refreshMenuItems[i];
        $equals_6(currentSelection, getAttribute(menu.jsObj, 'title'))?$setAttribute_13(menu, 'icon', getAvailabilityIcon(($clinit_Boolean() , $clinit_Boolean() , TRUE))):(menu.jsObj['icon'] = '' , undefined);
        setCheck(this$static.refreshMenuItems, i, menu);
      }
      $setItems_0(getOrCreateRef_10($getAttributeAsJavaScriptObject_1(this$static.refreshMenuButton, 'menu')), this$static.refreshMenuItems);
    }
  }
  !!this$static.refreshMenuButton && $markForRedraw(this$static.refreshMenuButton);
}

function DashboardView_0(dashboardContainer, storedDashboard){
  $clinit_DashboardView();
  DashboardView_1.call(this, dashboardContainer, storedDashboard, new EntityContext_0(null, null, null), null);
}

function DashboardView_1(dashboardContainer, storedDashboard, context, composite){
  $clinit_DashboardView();
  EnhancedVLayout_0.call(this);
  this.portletWindows = new HashSet_0;
  this.dashboardContainer = dashboardContainer;
  this.storedDashboard = storedDashboard;
  valueOf_44(__parseAndValidateInt($getSimpleValue(this.storedDashboard.configuration, 'columns', '1'))).value_0 == 0 && $setColumns(this.storedDashboard, 1);
  this.context = context;
  switch (this.context.type_0.ordinal) {
    case 0:
      {
        if (null == composite) {
          throw new IllegalArgumentException_1('null composite for resource context');
        }
        this.resourceComposite = dynamicCast(composite, Q$ResourceComposite);
        break;
      }

    case 2:
      {
        if (null == composite) {
          throw new IllegalArgumentException_1('null composite for group context');
        }
        this.groupComposite = dynamicCast(composite, Q$ResourceGroupComposite);
        break;
      }

  }
}

function processPortletNameMapForGroup(composite){
  $clinit_DashboardView();
  var facets, groupCategory, groupMenuMap;
  groupMenuMap = ($clinit_PortletFactory() , $clinit_PortletFactory() , groupPortletMenuMap);
  if (!!composite && !!composite.resourceGroup) {
    groupMenuMap = new LinkedHashMap_4(groupMenuMap);
    facets = composite.resourceFacets.facets;
    groupCategory = composite.resourceGroup.groupCategory;
    if (groupCategory != ($clinit_GroupCategory() , COMPATIBLE)) {
      $remove_11(groupMenuMap, 'GroupOperations');
      $remove_11(groupMenuMap, 'GroupMetrics');
      $remove_11(groupMenuMap, 'GroupOobs');
      $remove_11(groupMenuMap, 'GroupPackageHistory');
      $remove_11(groupMenuMap, 'GroupConfigurationUpdates');
      $remove_11(groupMenuMap, 'GroupBundleDeployments');
    }
     else {
      if (!facets.isEmpty_0()) {
        facets.contains_0(($clinit_ResourceTypeFacet() , OPERATION)) || $remove_11(groupMenuMap, 'GroupOperations');
        if (!facets.contains_0(MEASUREMENT_0)) {
          $remove_11(groupMenuMap, 'GroupMetrics');
          $remove_11(groupMenuMap, 'GroupOobs');
        }
        facets.contains_0(CONTENT_0) || $remove_11(groupMenuMap, 'GroupPackageHistory');
        facets.contains_0(CONFIGURATION_2) || $remove_11(groupMenuMap, 'GroupConfigurationUpdates');
        facets.contains_0(BUNDLE_0) || $remove_11(groupMenuMap, 'GroupBundleDeployments');
      }
    }
  }
  return groupMenuMap;
}

function processPortletNameMapForResource(composite){
  $clinit_DashboardView();
  var facets, resourceMenuMap;
  resourceMenuMap = ($clinit_PortletFactory() , $clinit_PortletFactory() , resourcePortletMenuMap);
  if (!!composite && !!composite.resource) {
    resourceMenuMap = new LinkedHashMap_4(resourceMenuMap);
    facets = composite.resourceFacets.facets;
    if (!facets.isEmpty_0()) {
      facets.contains_0(($clinit_ResourceTypeFacet() , OPERATION)) || $remove_11(resourceMenuMap, 'ResourceOperations');
      if (!facets.contains_0(MEASUREMENT_0)) {
        $remove_11(resourceMenuMap, 'ResourceMetrics');
        $remove_11(resourceMenuMap, 'ResourceMetrics');
      }
      facets.contains_0(CONTENT_0) || $remove_11(resourceMenuMap, 'ResourcePackageHistory');
      facets.contains_0(EVENT_0) || $remove_11(resourceMenuMap, 'ResourceEvents');
      facets.contains_0(CONFIGURATION_2) || $remove_11(resourceMenuMap, 'ResourceConfigurationUpdates');
      facets.contains_0(BUNDLE_0) || $remove_11(resourceMenuMap, 'ResourceBundleDeployments');
    }
  }
  return resourceMenuMap;
}

defineSeed(2442, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$DashboardView, Q$Enhanced]), DashboardView_0, DashboardView_1);
_.onDraw_0 = function onDraw_25(){
  $setEditMode(this, this.editMode);
}
;
_.onInit = function onInit_38(){
  if (!this.isInitialized) {
    $onInit(this);
    $onInit_Layout(this);
    $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
    $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
    $addMember(this, $buildEditForm(this));
    $buildPortlets(this);
    this.isInitialized = true;
  }
}
;
_.redraw_0 = function redraw_1(){
  $redraw_2(this);
}
;
_.addPortlet = null;
_.context = null;
_.dashboardContainer = null;
_.editForm = null;
_.editMode = false;
_.groupComposite = null;
_.isInitialized = false;
_.maximizedPortlet = null;
_.portalLayout = null;
_.refreshInterval = 0;
_.refreshMenuButton = null;
_.refreshMenuItems = null;
_.refreshMenuMappings = null;
_.resourceComposite = null;
_.storedDashboard = null;
var REFRESH1, REFRESH10, REFRESH10_VALUE, REFRESH1_VALUE, REFRESH5, REFRESH5_VALUE, STOP, STOP_VALUE;
function DashboardView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2443, 1, makeCastMap([Q$EventHandler, Q$BlurHandler]), DashboardView$1_0);
_.onBlur = function onBlur_1(blurEvent){
  var message, name_0, nameItem, trimmedName;
  nameItem = $getItem(blurEvent);
  name_0 = dynamicCast(nameItem.getValue_1(), Q$String);
  trimmedName = name_0 == null?'':$trim(name_0);
  if (this.this$0.dashboardContainer.isValidDashboardName(trimmedName)) {
    $setName_7(this.this$0.storedDashboard, trimmedName);
    $save_3(this.this$0);
    this.this$0.dashboardContainer.updateDashboardNames();
  }
   else {
    message = new Message_8("There is already a dashboard named '" + trimmedName + "'. Please specify a name that is not already in use.", ($clinit_Message$Severity() , Error_2), of(($clinit_Message$Option() , Transient)));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
    nameItem.setValue_4(this.this$0.storedDashboard.name_0);
  }
}
;
_.this$0 = null;
function DashboardView$2_0(this$0, val$numColItem, val$removeColumn){
  this.this$0 = this$0;
  this.val$numColItem = val$numColItem;
  this.val$removeColumn = val$removeColumn;
}

defineSeed(2444, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), DashboardView$2_0);
_.onClick_0 = function onClick_93(event_0){
  $addMember(this.this$0.portalLayout, new PortalColumn_0);
  $setValue_5(this.val$numColItem, valueOf_44(__parseAndValidateInt($getSimpleValue(this.this$0.storedDashboard.configuration, 'columns', '1'))).value_0 + 1);
  $setColumns(this.this$0.storedDashboard, valueOf_44(__parseAndValidateInt($getSimpleValue(this.this$0.storedDashboard.configuration, 'columns', '1'))).value_0 + 1);
  $setDisabled_2(this.val$removeColumn, ($clinit_Boolean() , valueOf_44(__parseAndValidateInt($getSimpleValue(this.this$0.storedDashboard.configuration, 'columns', '1'))).value_0 == 1?TRUE:FALSE));
  $save_3(this.this$0);
}
;
_.this$0 = null;
_.val$numColItem = null;
_.val$removeColumn = null;
function DashboardView$3_0(this$0, val$numColItem, val$removeColumn){
  this.this$0 = this$0;
  this.val$numColItem = val$numColItem;
  this.val$removeColumn = val$removeColumn;
}

defineSeed(2445, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), DashboardView$3_0);
_.onClick_0 = function onClick_94(event_0){
  var columns, lastColumn, numColumns, portletWindow, portletWindow$array, portletWindow$index, portletWindow$max;
  columns = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this.this$0.portalLayout, 'members'));
  numColumns = columns.length;
  if (numColumns > 0) {
    lastColumn = dynamicCast(columns[numColumns - 1], Q$PortalColumn);
    for (portletWindow$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(lastColumn, 'members')) , portletWindow$index = 0 , portletWindow$max = portletWindow$array.length; portletWindow$index < portletWindow$max; ++portletWindow$index) {
      portletWindow = portletWindow$array[portletWindow$index];
      $removePortlet(this.this$0.storedDashboard, dynamicCast(portletWindow, Q$PortletWindow).storedPortlet);
    }
    $removeMember(this.this$0.portalLayout, lastColumn);
    $setValue_5(this.val$numColItem, numColumns - 1);
    $setColumns(this.this$0.storedDashboard, valueOf_44(__parseAndValidateInt($getSimpleValue(this.this$0.storedDashboard.configuration, 'columns', '1'))).value_0 - 1);
    $setDisabled_2(this.val$removeColumn, ($clinit_Boolean() , valueOf_44(__parseAndValidateInt($getSimpleValue(this.this$0.storedDashboard.configuration, 'columns', '1'))).value_0 == 1?TRUE:FALSE));
    $save_3(this.this$0);
  }
}
;
_.this$0 = null;
_.val$numColItem = null;
_.val$removeColumn = null;
function DashboardView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2446, 1, makeCastMap([Q$EventHandler, Q$ItemClickHandler]), DashboardView$4_0);
_.this$0 = null;
function $onColorSelected(this$static, event_0){
  var selectedColor;
  selectedColor = $getColor_0(event_0);
  if (selectedColor != null) {
    $setBackgroundColor(this$static.this$0, selectedColor);
    $put_4(this$static.this$0.storedDashboard.configuration, new PropertySimple_1('background', selectedColor));
    $save_3(this$static.this$0);
  }
}

function DashboardView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2447, 1, makeCastMap([Q$EventHandler, Q$ColorSelectedHandler]), DashboardView$5_0);
_.onColorSelected = function onColorSelected_0(event_0){
  $onColorSelected(this, event_0);
}
;
_.this$0 = null;
function DashboardView$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2448, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), DashboardView$6_0);
_.onClick_1 = function onClick_95(event_0){
  var selection;
  selection = $getAttributeAsString($getItem_2(event_0), 'title');
  this.this$0.refreshInterval = 0;
  if (selection != null) {
    $equals_6(selection, ($clinit_DashboardView() , STOP))?(this.this$0.refreshInterval = STOP_VALUE.value_0):$equals_6(selection, REFRESH1)?(this.this$0.refreshInterval = REFRESH1_VALUE.value_0):$equals_6(selection, REFRESH5)?(this.this$0.refreshInterval = REFRESH5_VALUE.value_0):$equals_6(selection, REFRESH10)?(this.this$0.refreshInterval = REFRESH10_VALUE.value_0):(this.this$0.refreshInterval = STOP_VALUE.value_0);
    $setPageRefreshInterval(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), this.this$0.refreshInterval, new DashboardView$UpdatePortletRefreshCallback_0(this.this$0));
  }
}
;
_.this$0 = null;
function DashboardView$7_0(val$placeHolder, val$outline, val$newPortletWindow){
  this.val$placeHolder = val$placeHolder;
  this.val$outline = val$outline;
  this.val$newPortletWindow = val$newPortletWindow;
}

defineSeed(2449, 1, {}, DashboardView$7_0);
_.execute_5 = function execute_49(earlyFinish){
  $destroy(this.val$placeHolder);
  this.val$outline.destroy_0();
  $show(this.val$newPortletWindow);
}
;
_.val$newPortletWindow = null;
_.val$outline = null;
_.val$placeHolder = null;
function $onSuccess_184(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Saved dashboard ' + ($clinit_Enhanced() , result.name_0) + ' to server', ($clinit_Message$Severity() , Info)));
  $updatePortletWindows(this$static.this$0, result);
  this$static.this$0.storedDashboard = result;
  $enable(this$static.this$0);
}

function DashboardView$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2450, 1, {}, DashboardView$8_0);
_.onFailure = function onFailure_195(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to save dashboard to server'), caught);
  $enable(this.this$0);
}
;
_.onSuccess_0 = function onSuccess_195(result){
  $onSuccess_184(this, dynamicCast(result, Q$Dashboard));
}
;
_.this$0 = null;
function $onSuccess_185(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully deleted dashboard ' + ($clinit_Enhanced() , this$static.this$0.storedDashboard.name_0), ($clinit_Message$Severity() , Info)));
}

function DashboardView$9_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2451, 1, {}, DashboardView$9_0);
_.onFailure = function onFailure_196(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete dashboard.'), caught);
}
;
_.onSuccess_0 = function onSuccess_196(result){
  $onSuccess_185(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $onSuccess_186(this$static){
  var m_0;
  this$static.this$0.refreshInterval > 0?(m_0 = ($clinit_Enhanced() , 'Updated interval for portlets that auto-refresh')):(m_0 = ($clinit_Enhanced() , 'Stopping reload for portlets that auto-refresh'));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(m_0, ($clinit_Message$Severity() , Info)));
  $updateRefreshMenu(this$static.this$0);
  $save_3(this$static.this$0);
}

function DashboardView$UpdatePortletRefreshCallback_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2452, 1, {}, DashboardView$UpdatePortletRefreshCallback_0);
_.onFailure = function onFailure_197(throwable){
  var m_0;
  this.this$0.refreshInterval > 0?(m_0 = ($clinit_Enhanced() , 'Failed to update interval for portlets that auto-refresh')):(m_0 = ($clinit_Enhanced() , 'Failed to disable reload for portlets that auto-refresh'));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(m_0, ($clinit_Message$Severity() , Error_2)));
  $updateRefreshMenu(this.this$0);
}
;
_.onSuccess_0 = function onSuccess_197(subject){
  $onSuccess_186(this, dynamicCast(subject, Q$Subject));
}
;
_.this$0 = null;
function $addDefaultDashboard(this$static){
  $storeDashboard(this$static.dashboardService, $getDefaultDashboard(), new DashboardsView$2_0(this$static));
}

function $addNewDashboard(this$static){
  var availableDashboardName, candidateDashboardName, dashboard, i;
  i = 0;
  availableDashboardName = null;
  while (availableDashboardName == null) {
    candidateDashboardName = ($clinit_Enhanced() , 'Custom') + i++;
    this$static.dashboardsByName.containsKey(candidateDashboardName) || (availableDashboardName = candidateDashboardName);
  }
  dashboard = new Dashboard_0;
  $setCategory_0(dashboard, ($clinit_DashboardCategory() , INVENTORY));
  dashboard.name_0 = availableDashboardName;
  $put_4(dashboard.configuration, new PropertySimple_1('columns', valueOf_44(2)));
  $setColumnWidths(dashboard, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['32%']));
  $storeDashboard(this$static.dashboardService, dashboard, new DashboardsView$7_0(this$static));
}

function $getDefaultDashboard(){
  var dashboard, isRHQ, news, operations, problemResources, productInfo, recentAlerts, rowIndex, summary, welcome;
  dashboard = new Dashboard_0;
  $setName_7(dashboard, ($clinit_Enhanced() , 'Default'));
  $setCategory_0(dashboard, ($clinit_DashboardCategory() , INVENTORY));
  $put_4(dashboard.configuration, new PropertySimple_1('columns', valueOf_44(2)));
  $setColumnWidths(dashboard, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['32%']));
  $put_4(dashboard.configuration, new PropertySimple_1('background', '#F1F2F3'));
  productInfo = ($clinit_CoreGUI() , $clinit_CoreGUI() , coreGUI).productInfo;
  isRHQ = !!productInfo && $equals_6('RHQ', productInfo.shortName);
  rowIndex = 0;
  if (isRHQ) {
    welcome = new DashboardPortlet_1(($clinit_MessagePortlet() , NAME_29), 'Message', 250);
    $addPortlet_0(dashboard, welcome, 0, rowIndex++);
  }
  summary = new DashboardPortlet_1(($clinit_InventorySummaryPortlet() , NAME_26), 'InventorySummary', 250);
  $addPortlet_0(dashboard, summary, 0, rowIndex++);
  news = new DashboardPortlet_1(($clinit_MashupPortlet() , NAME_28), 'Mashup', 300);
  isRHQ?$put_4(news.configuration, new PropertySimple_1('address', 'https://docs.jboss.org/author/display/RHQ/User+Documentation')):$put_4(news.configuration, new PropertySimple_1('address', 'https://access.redhat.com/ext/software/JBoss_Operations_Network/portlet?jonVersion=3.0'));
  $addPortlet_0(dashboard, news, 0, rowIndex++);
  rowIndex = 0;
  recentAlerts = new DashboardPortlet_1(($clinit_RecentAlertsPortlet() , NAME_13), 'RecentAlerts', 250);
  $addPortlet_0(dashboard, recentAlerts, 1, rowIndex++);
  problemResources = new DashboardPortlet_1(($clinit_ProblemResourcesPortlet() , NAME_17), 'ProblemResources', 250);
  $put_4(problemResources.configuration, new PropertySimple_1('max-problems-shown', '20'));
  $put_4(problemResources.configuration, new PropertySimple_1('max-problems-query-span', '24'));
  $addPortlet_0(dashboard, problemResources, 1, rowIndex++);
  operations = new DashboardPortlet_1(($clinit_OperationHistoryPortlet() , NAME_15), 'Operations', 200);
  $addPortlet_0(dashboard, operations, 1, rowIndex++);
  return dashboard;
}

function $updateDashboards(this$static, dashboards){
  var buttons, dashboard, dashboard$iterator, dashboardName, dashboardTitle, dashboardView, members, newDashboardButton, tab;
  members = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members'));
  $removeMembers(this$static, members);
  !!this$static.tabSet && this$static.tabSet.destroy_0();
  this$static.dashboardsByName = new HashMap_1(dashboards.size_0);
  for (dashboard$iterator = new AbstractList$IteratorImpl_0(dashboards); dashboard$iterator.i < dashboard$iterator.this$0_0.size_1();) {
    dashboard = dynamicCast($next_0(dashboard$iterator), Q$Dashboard);
    this$static.dashboardsByName.put(dashboard.name_0, dashboard);
  }
  this$static.tabSet = new NamedTabSet_0;
  $setAttribute_24(this$static.tabSet, 'width', '100%', true);
  $setAttribute_24(this$static.tabSet, 'height', '100%', true);
  this$static.editButton = new EnhancedIButton_1(this$static.editMode?($clinit_Enhanced() , 'View Mode'):($clinit_Enhanced() , 'Edit Mode'));
  $setAttribute_22(this$static.editButton, 'autoFit', ($clinit_Boolean() , $clinit_Boolean() , TRUE), true);
  $addClickHandler(this$static.editButton, new DashboardsView$3_0(this$static));
  newDashboardButton = new EnhancedIButton_1(($clinit_Enhanced() , 'New Dashboard'));
  $setAttribute_22(newDashboardButton, 'autoFit', TRUE, true);
  $addClickHandler(newDashboardButton, new DashboardsView$4_0(this$static));
  buttons = new HLayout_1(5);
  $addMember(buttons, this$static.editButton);
  $addMember(buttons, newDashboardButton);
  $setAttribute_26(this$static.tabSet, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [buttons]));
  $addTabSelectedHandler(this$static.tabSet, new DashboardsView$5_0(this$static));
  for (dashboard$iterator = new AbstractList$IteratorImpl_0(dashboards); dashboard$iterator.i < dashboard$iterator.this$0_0.size_1();) {
    dashboard = dynamicCast($next_0(dashboard$iterator), Q$Dashboard);
    dashboardName = '' + dashboard.id;
    dashboardTitle = dashboard.name_0;
    dashboardView = new DashboardView_0(this$static, dashboard);
    tab = new NamedTab_1(new ViewName_1(dashboardName, dashboardTitle), null);
    !tab.tabSet || !$isCreated_1(tab.tabSet)?$setAttribute_5(tab, 'pane', $getOrCreateJsObj_0(dashboardView)):$updateTab(tab.tabSet, tab, dashboardView);
    tab.jsObj['canClose'] = true;
    $addTab(this$static.tabSet, tab);
    $equals_6(dashboard.name_0, this$static.selectedTabName) && $selectTab_0(this$static.tabSet, tab);
  }
  $addCloseClickHandler_0(this$static.tabSet, new DashboardsView$6_0(this$static));
  $addMember(this$static, this$static.tabSet);
}

function DashboardsView_0(){
  $clinit_DashboardsView();
  EnhancedVLayout_0.call(this);
  this.dashboardService = dynamicCast(secure(getInstance_39(), -1), Q$DashboardGWTServiceAsync);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $setPadding(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(2453, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Enhanced]), DashboardsView_0);
_.getGlobalPermissions = function getGlobalPermissions(){
  return this.globalPermissions;
}
;
_.isInitialized_0 = function isInitialized_2(){
  return this.initialized;
}
;
_.isValidDashboardName = function isValidDashboardName(name_0){
  if (name_0 == null || $equals_6(name_0, '')) {
    return false;
  }
  return !this.dashboardsByName.containsKey(name_0);
}
;
_.onInit = function onInit_39(){
  var criteria;
  $onInit(this);
  $onInit_Layout(this);
  criteria = new DashboardCriteria_0;
  $addSortName(criteria, ($clinit_PageOrdering() , ASC));
  $findDashboardsByCriteria(this.dashboardService, criteria, new DashboardsView$1_0(this));
}
;
_.refresh_0 = function refresh_7(){
  this.initialized && !!this.selectedDashboardView && $isDrawn(this.selectedDashboardView).value_0 && $rebuild(this.selectedDashboardView);
}
;
_.renderView = function renderView_16(viewPath){
  var pathTabName, selectedTab, tab, tab$array, tab$index, tab$max, tabs;
  if (!this.tabSet || 0 == this.tabSet.getTabs().length) {
    return;
  }
  tabs = this.tabSet.getTabs();
  selectedTab = tabs[0];
  this.selectedTabName = selectedTab.viewName.name_0;
  if (viewPath.viewPath.size_0 > viewPath.index_0) {
    pathTabName = (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path;
    for (tab$array = this.tabSet.getTabs() , tab$index = 0 , tab$max = tab$array.length; tab$index < tab$max; ++tab$index) {
      tab = tab$array[tab$index];
      if ($equals_6(tab.viewName.name_0, pathTabName)) {
        selectedTab = tab;
        this.selectedTabName = pathTabName;
        break;
      }
    }
  }
  selectedTab == $getSelectedTab(this.tabSet)?viewPath.refresh && this.initialized && !!this.selectedDashboardView && $isDrawn(this.selectedDashboardView).value_0 && $rebuild(this.selectedDashboardView):$selectTab_0(this.tabSet, selectedTab);
}
;
_.supportsDashboardNameEdit = function supportsDashboardNameEdit(){
  return true;
}
;
_.updateDashboardNames = function updateDashboardNames(){
  var t, t$array, t$index, t$max, view;
  for (t$array = this.tabSet.getTabs() , t$index = 0 , t$max = t$array.length; t$index < t$max; ++t$index) {
    t = t$array[t$index];
    view = dynamicCast(t.getPane(), Q$DashboardView);
    $setTitle_2(t, view.storedDashboard.name_0);
  }
}
;
_.dashboardsByName = null;
_.editButton = null;
_.editMode = false;
_.globalPermissions = null;
_.initialized = false;
_.selectedDashboardView = null;
_.selectedTabName = null;
_.tabSet = null;
function $onSuccess_187(this$static, result){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new DashboardsView$1$1_0(this$static, result)));
}

function DashboardsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2454, 1, {}, DashboardsView$1_0);
_.onFailure = function onFailure_198(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to add new dashboard'), caught);
}
;
_.onSuccess_0 = function onSuccess_198(result){
  $onSuccess_187(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function DashboardsView$1$1_0(this$1, val$result){
  this.this$1 = this$1;
  this.val$result = val$result;
}

defineSeed(2455, 1, {}, DashboardsView$1$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_8(permissions){
  this.this$1.this$0.globalPermissions = new HashSet_2(permissions);
  this.val$result.size_0 == 0?$addDefaultDashboard(this.this$1.this$0):$updateDashboards(this.this$1.this$0, this.val$result);
  this.this$1.this$0.initialized = true;
}
;
_.this$1 = null;
_.val$result = null;
function $onSuccess_188(this$static, defaultDashboard){
  var dashboards;
  dashboards = new ArrayList_1(1);
  setCheck(dashboards.array, dashboards.size_0++, defaultDashboard);
  $updateDashboards(this$static.this$0, dashboards);
}

function DashboardsView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2456, 1, {}, DashboardsView$2_0);
_.onFailure = function onFailure_199(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to add new dashboard'), caught);
}
;
_.onSuccess_0 = function onSuccess_199(defaultDashboard){
  $onSuccess_188(this, dynamicCast(defaultDashboard, Q$Dashboard));
}
;
_.this$0 = null;
function DashboardsView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2457, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), DashboardsView$3_0);
_.onClick = function onClick_96(clickEvent){
  this.this$0.editMode = !this.this$0.editMode;
  $setTitle_0(this.this$0.editButton, this.this$0.editMode?($clinit_Enhanced() , 'View Mode'):($clinit_Enhanced() , 'Edit Mode'));
  !!this.this$0.selectedDashboardView.maximizedPortlet && $restorePortlet(this.this$0.selectedDashboardView);
  $setEditMode(this.this$0.selectedDashboardView, this.this$0.editMode);
}
;
_.this$0 = null;
function DashboardsView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2458, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), DashboardsView$4_0);
_.onClick = function onClick_97(clickEvent){
  $addNewDashboard(this.this$0);
}
;
_.this$0 = null;
function DashboardsView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2459, 1, makeCastMap([Q$EventHandler, Q$TabSelectedHandler]), DashboardsView$5_0);
_.onTabSelected = function onTabSelected_1(tabSelectedEvent){
  var selectedTab, jsObj;
  selectedTab = this.this$0.tabSet.getTabByTitle((jsObj = tabSelectedEvent.jsObj , getOrCreateRef_12(jsObj.tab)).getTitle());
  if (this.this$0.selectedDashboardView) {
    debug(' ***** selectedTab: ' + selectedTab.viewName.name_0 + ', ' + selectedTab.viewName.title_0);
    $clinit_CoreGUI();
    goToView('#Dashboards/' + valueOf_44(__parseAndValidateInt(selectedTab.viewName.name_0)).value_0, null, true);
  }
  this.this$0.selectedDashboardView = dynamicCast(selectedTab.getPane(), Q$DashboardView);
  $setTitle_0(this.this$0.editButton, this.this$0.editMode?($clinit_Enhanced() , 'View Mode'):($clinit_Enhanced() , 'Edit Mode'));
  $setEditMode(this.this$0.selectedDashboardView, this.this$0.editMode);
  $isDrawn(this.this$0.selectedDashboardView).value_0 && $redraw_2(this.this$0.selectedDashboardView);
}
;
_.this$0 = null;
function DashboardsView$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2460, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler_0]), DashboardsView$6_0);
_.this$0 = null;
function DashboardsView$6$1_0(this$1, val$tabCloseClickEvent, val$dashboardView){
  this.this$1 = this$1;
  this.val$tabCloseClickEvent = val$tabCloseClickEvent;
  this.val$dashboardView = val$dashboardView;
}

defineSeed(2461, 1, {}, DashboardsView$6$1_0);
_.execute_3 = function execute_50(confirmed){
  if (confirmed.value_0) {
    this.this$1.this$0.dashboardsByName.remove_3($getTab_0(this.val$tabCloseClickEvent).getTitle());
    $removeTab(this.this$1.this$0.tabSet, $getTab_0(this.val$tabCloseClickEvent));
    $delete_2(this.val$dashboardView);
    0 == this.this$1.this$0.tabSet.getTabs().length && $addDefaultDashboard(this.this$1.this$0);
  }
}
;
_.this$1 = null;
_.val$dashboardView = null;
_.val$tabCloseClickEvent = null;
function $onSuccess_189(this$static, result){
  var dashboardName, dashboardTitle, dashboardView, tab;
  dashboardName = '' + result.id;
  dashboardTitle = result.name_0;
  this$static.this$0.dashboardsByName.put(dashboardTitle, result);
  dashboardView = new DashboardView_0(this$static.this$0, result);
  tab = new NamedTab_1(new ViewName_1(dashboardName, dashboardTitle), null);
  !tab.tabSet || !$isCreated_1(tab.tabSet)?$setAttribute_5(tab, 'pane', $getOrCreateJsObj_0(dashboardView)):$updateTab(tab.tabSet, tab, dashboardView);
  tab.jsObj['canClose'] = true;
  this$static.this$0.editMode = true;
  $addTab(this$static.this$0.tabSet, tab);
  $selectTab_0(this$static.this$0.tabSet, tab);
}

function DashboardsView$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2462, 1, {}, DashboardsView$7_0);
_.onFailure = function onFailure_200(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to add new dashboard'), caught);
}
;
_.onSuccess_0 = function onSuccess_200(result){
  $onSuccess_189(this, dynamicCast(result, Q$Dashboard));
}
;
_.this$0 = null;
function PortalColumn_0(){
  $clinit_BaseWidget();
  var dropLineProperties, placeHolderProperties;
  VStack_0.call(this);
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 4):(this.config_0['membersMargin'] = 4 , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'border', '2px solid #999999'):(this.config_0['border'] = '2px solid #999999' , undefined);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $setAnimateMembers(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAnimateMemberTime(this, valueOf_44(300));
  $setCanAcceptDrop(this, TRUE);
  $isCreated_1(this)?undefined:(this.config_0['dropLineThickness'] = 4 , undefined);
  dropLineProperties = new Canvas_1;
  $isCreated_1(dropLineProperties)?$setProperty_3(dropLineProperties, 'backgroundColor', '#4A5D75'):(dropLineProperties.config_0['backgroundColor'] = '#4A5D75' , undefined);
  dropLineProperties.configOnly = true;
  $setAttribute_21(this, 'dropLineProperties', dropLineProperties);
  $setShowDragPlaceHolder(this, TRUE);
  placeHolderProperties = new Canvas_1;
  $isCreated_1(placeHolderProperties)?$setProperty_3(placeHolderProperties, 'border', '2px solid #4A5D75'):(placeHolderProperties.config_0['border'] = '2px solid #4A5D75' , undefined);
  placeHolderProperties.configOnly = true;
  $setAttribute_21(this, 'placeHolderProperties', placeHolderProperties);
  $setCanDragResize(this, TRUE);
  $isCreated_1(this)?$setProperty_2(this, 'resizeFrom', convertToJavaScriptArray(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['L']))):(this.config_0['resizeFrom'] = convertToJavaScriptArray(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['L'])) , undefined);
}

defineSeed(2463, 559, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$PortalColumn]), PortalColumn_0);
_.destroy_0 = function destroy_13(){
  $removeFromParent(this);
  destroyMembers(this);
  $destroy(this);
}
;
function $addPortletWindow(this$static, portletWindow, column){
  var portalColumn;
  portalColumn = dynamicCast($getMember(this$static, column), Q$PortalColumn);
  $addMember(portalColumn, portletWindow);
  return portalColumn;
}

function $resize(this$static){
  var c, c$array, c$index, c$max, column, p, p$array, p$index, p$max, portlet;
  for (c$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members')) , c$index = 0 , c$max = c$array.length; c$index < c$max; ++c$index) {
    c = c$array[c$index];
    column = dynamicCast(c, Q$PortalColumn);
    for (p$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(column, 'members')) , p$index = 0 , p$max = p$array.length; p$index < p$max; ++p$index) {
      p = p$array[p$index];
      if (instanceOf(p, Q$PortletWindow)) {
        portlet = dynamicCast(p, Q$PortletWindow);
        $setWidth(portlet, $getAttributeAsInt_0(column, 'width').value_0);
      }
    }
  }
}

function PortalLayout_0(dashboardView, numColumns, columnWidths){
  $clinit_BaseWidget();
  var column, i;
  EnhancedHLayout_0.call(this);
  if (numColumns < 1) {
    throw new IllegalArgumentException_1('Invalid number of columns [' + numColumns + ']');
  }
  if (null != columnWidths && columnWidths.length > numColumns) {
    throw new IllegalArgumentException_1('Invalid column widths (more widths than columns) ' + toString_31(columnWidths));
  }
  this.dashboardView = dashboardView;
  $setMargin(this, valueOf_44(4));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 4):(this.config_0['membersMargin'] = 4 , undefined);
  for (i = 0; i < numColumns; ++i) {
    column = new PortalColumn_0;
    null != columnWidths && i < columnWidths.length?$setWidth_0(column, columnWidths[i]):$isCreated_1(column)?$setProperty_3(column, 'width', '*'):(column.config_0['width'] = '*' , undefined);
    $addDropHandler(column, new PortalLayout$1_0(this, column, i));
    $addDragResizeStartHandler(column, new PortalLayout$2_0(this));
    $addResizedHandler(column, new PortalLayout$3_0(this));
    $addMember(this, column);
  }
}

defineSeed(2464, 1539, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$Enhanced, Q$EnhancedHLayout]), PortalLayout_0);
_.dashboardView = null;
_.dragResizeColumnCount = null;
function $onDrop(this$static){
  var c, c$array, c$index, c$max, colNum, dp, dropColumn, dropPosition, i, pc, pcc, pcc$array, pcc$index, pcc$max, target, self_0;
  dropPosition = (self_0 = this$static.val$column.getOrCreateJsObj() , self_0.getDropPosition());
  dropColumn = this$static.val$columnNumber;
  target = dynamicCast(getDragTarget(), Q$PortletWindow);
  $setIndex(target.storedPortlet, dropPosition);
  $setColumn(target.storedPortlet, dropColumn);
  colNum = 0;
  for (pcc$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0, 'members')) , pcc$index = 0 , pcc$max = pcc$array.length; pcc$index < pcc$max; ++pcc$index) {
    pcc = pcc$array[pcc$index];
    pc = dynamicCast(pcc, Q$PortalColumn);
    i = 0;
    for (c$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(pc, 'members')) , c$index = 0 , c$max = c$array.length; c$index < c$max; ++c$index) {
      c = c$array[c$index];
      colNum == dropColumn && i == dropPosition && ++i;
      if (instanceOf(c, Q$PortletWindow)) {
        dp = dynamicCast(c, Q$PortletWindow).storedPortlet;
        $setIndex(dp, i++);
      }
    }
    ++colNum;
  }
  $save_3(this$static.this$0.dashboardView);
  $clinit_Log();
  $info_0(logger_0, 'Rearranged column indexes');
}

function PortalLayout$1_0(this$0, val$column, val$columnNumber){
  this.this$0 = this$0;
  this.val$column = val$column;
  this.val$columnNumber = val$columnNumber;
}

defineSeed(2465, 1, makeCastMap([Q$EventHandler, Q$DropHandler]), PortalLayout$1_0);
_.this$0 = null;
_.val$column = null;
_.val$columnNumber = 0;
function PortalLayout$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2466, 1, makeCastMap([Q$EventHandler, Q$DragResizeStartHandler, Q$PortalLayout$2]), PortalLayout$2_0);
_.this$0 = null;
function $onResized(this$static){
  var members;
  if (!this$static.this$0.dragResizeColumnCount) {
    return;
  }
  this$static.this$0.dragResizeColumnCount = valueOf_44(this$static.this$0.dragResizeColumnCount.value_0 + 1);
  members = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0, 'members'));
  if (this$static.this$0.dragResizeColumnCount.value_0 != members.length) {
    return;
  }
  $save_3(this$static.this$0.dashboardView);
  this$static.this$0.dragResizeColumnCount = null;
}

function PortalLayout$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2467, 1, makeCastMap([Q$EventHandler, Q$ResizedHandler]), PortalLayout$3_0);
_.this$0 = null;
function $clinit_PortletFactory(){
  $clinit_PortletFactory = nullMethod;
  var portletName, portletName$iterator;
  globalPortletFactoryMap = new HashMap_0;
  globalPortletFactoryMap.put('InventorySummary', ($clinit_InventorySummaryPortlet$Factory() , INSTANCE_32));
  globalPortletFactoryMap.put('RecentlyAddedResources', ($clinit_RecentlyAddedResourcesPortlet$Factory() , INSTANCE_20));
  globalPortletFactoryMap.put('PlatformSummary', ($clinit_PlatformSummaryPortlet$Factory() , INSTANCE_18));
  globalPortletFactoryMap.put('Autodiscovery', ($clinit_AutodiscoveryPortlet$Factory() , INSTANCE_15));
  globalPortletFactoryMap.put('RecentAlerts', ($clinit_RecentAlertsPortlet$Factory() , INSTANCE_19));
  globalPortletFactoryMap.put('ResourceMetricD3', ($clinit_ResourceD3GraphPortlet$Factory() , INSTANCE_17));
  globalPortletFactoryMap.put('ResourceGroupMetricD3', ($clinit_ResourceGroupD3GraphPortlet$Factory() , INSTANCE_14));
  ($clinit_CoreGUI() , $clinit_CoreGUI() , enableTagsForUI) && globalPortletFactoryMap.put('TagCloud', ($clinit_TagCloudPortlet$Factory() , INSTANCE_33));
  globalPortletFactoryMap.put('FavoriteResources', ($clinit_FavoriteResourcesPortlet$Factory() , INSTANCE_16));
  globalPortletFactoryMap.put('FavoriteGroups', ($clinit_FavoriteGroupsPortlet$Factory() , INSTANCE_5));
  globalPortletFactoryMap.put('Mashup', ($clinit_MashupPortlet$Factory() , INSTANCE_34));
  globalPortletFactoryMap.put('Message', ($clinit_MessagePortlet$Factory() , INSTANCE_35));
  globalPortletFactoryMap.put('ProblemResources', ($clinit_ProblemResourcesPortlet$Factory() , INSTANCE_23));
  globalPortletFactoryMap.put('Operations', ($clinit_OperationHistoryPortlet$Factory() , INSTANCE_21));
  globalPortletFactoryMap.put('OperationSchedule', ($clinit_OperationSchedulePortlet$Factory() , INSTANCE_22));
  globalPortletNameMap = new TreeMap_0;
  $put_2(globalPortletNameMap, ($clinit_InventorySummaryPortlet() , NAME_26), 'InventorySummary');
  $put_2(globalPortletNameMap, ($clinit_RecentlyAddedResourcesPortlet() , NAME_14), 'RecentlyAddedResources');
  $put_2(globalPortletNameMap, ($clinit_PlatformSummaryPortlet() , NAME_12), 'PlatformSummary');
  $put_2(globalPortletNameMap, ($clinit_AutodiscoveryPortlet() , NAME_9), 'Autodiscovery');
  $put_2(globalPortletNameMap, ($clinit_RecentAlertsPortlet() , NAME_13), 'RecentAlerts');
  $put_2(globalPortletNameMap, ($clinit_ResourceD3GraphPortlet() , NAME_11), 'ResourceMetricD3');
  $put_2(globalPortletNameMap, ($clinit_ResourceGroupD3GraphPortlet() , NAME_8), 'ResourceGroupMetricD3');
  enableTagsForUI && $put_2(globalPortletNameMap, ($clinit_TagCloudPortlet() , NAME_27), 'TagCloud');
  $put_2(globalPortletNameMap, ($clinit_FavoriteResourcesPortlet() , NAME_10), 'FavoriteResources');
  $put_2(globalPortletNameMap, ($clinit_FavoriteGroupsPortlet() , NAME), 'FavoriteGroups');
  $put_2(globalPortletNameMap, ($clinit_MashupPortlet() , NAME_28), 'Mashup');
  $put_2(globalPortletNameMap, ($clinit_MessagePortlet() , NAME_29), 'Message');
  $put_2(globalPortletNameMap, ($clinit_ProblemResourcesPortlet() , NAME_17), 'ProblemResources');
  $put_2(globalPortletNameMap, ($clinit_OperationHistoryPortlet() , NAME_15), 'Operations');
  $put_2(globalPortletNameMap, ($clinit_OperationSchedulePortlet() , NAME_16), 'OperationSchedule');
  globalPortletMenuMap = new LinkedHashMap_1(globalPortletNameMap.size_0);
  for (portletName$iterator = $iterator($keySet(globalPortletNameMap)); portletName$iterator.val$outerIter.hasNext();) {
    portletName = dynamicCast($next_1(portletName$iterator), Q$String);
    $put_1(globalPortletMenuMap, dynamicCast($get_5(globalPortletNameMap, portletName), Q$String), portletName);
  }
  groupPortletFactoryMap = new HashMap_0;
  groupPortletFactoryMap.put('GroupAlerts', ($clinit_GroupAlertsPortlet$Factory() , INSTANCE_6));
  groupPortletFactoryMap.put('GroupMetrics', ($clinit_GroupMetricsPortlet$Factory() , INSTANCE_10));
  groupPortletFactoryMap.put('GroupOobs', ($clinit_GroupOobsPortlet$Factory() , INSTANCE_11));
  groupPortletFactoryMap.put('GroupEvents', ($clinit_GroupEventsPortlet$Factory() , INSTANCE_9));
  groupPortletFactoryMap.put('GroupOperations', ($clinit_GroupOperationsPortlet$Factory() , INSTANCE_12));
  groupPortletFactoryMap.put('GroupPackageHistory', ($clinit_GroupPkgHistoryPortlet$Factory() , INSTANCE_13));
  groupPortletFactoryMap.put('GroupBundleDeployments', ($clinit_GroupBundleDeploymentsPortlet$Factory() , INSTANCE_7));
  groupPortletFactoryMap.put('GroupConfigurationUpdates', ($clinit_GroupConfigurationUpdatesPortlet$Factory() , INSTANCE_8));
  groupPortletNameMap = new TreeMap_0;
  $put_2(groupPortletNameMap, ($clinit_GroupAlertsPortlet() , NAME_0), 'GroupAlerts');
  $put_2(groupPortletNameMap, ($clinit_GroupMetricsPortlet() , NAME_4), 'GroupMetrics');
  $put_2(groupPortletNameMap, ($clinit_GroupOobsPortlet() , NAME_5), 'GroupOobs');
  $put_2(groupPortletNameMap, ($clinit_GroupEventsPortlet() , NAME_3), 'GroupEvents');
  $put_2(groupPortletNameMap, ($clinit_GroupOperationsPortlet() , NAME_6), 'GroupOperations');
  $put_2(groupPortletNameMap, ($clinit_GroupPkgHistoryPortlet() , NAME_7), 'GroupPackageHistory');
  $put_2(groupPortletNameMap, ($clinit_GroupBundleDeploymentsPortlet() , NAME_1), 'GroupBundleDeployments');
  $put_2(groupPortletNameMap, ($clinit_GroupConfigurationUpdatesPortlet() , NAME_2), 'GroupConfigurationUpdates');
  groupPortletMenuMap = new LinkedHashMap_1(groupPortletNameMap.size_0);
  for (portletName$iterator = $iterator($keySet(groupPortletNameMap)); portletName$iterator.val$outerIter.hasNext();) {
    portletName = dynamicCast($next_1(portletName$iterator), Q$String);
    $put_1(groupPortletMenuMap, dynamicCast($get_5(groupPortletNameMap, portletName), Q$String), portletName);
  }
  resourcePortletFactoryMap = new HashMap_0;
  resourcePortletFactoryMap.put('ResourceMetrics', ($clinit_ResourceMetricsPortlet$Factory() , INSTANCE_28));
  resourcePortletFactoryMap.put('ResourceEvents', ($clinit_ResourceEventsPortlet$Factory() , INSTANCE_27));
  resourcePortletFactoryMap.put('ResourceOobs', ($clinit_ResourceOobsPortlet$Factory() , INSTANCE_29));
  resourcePortletFactoryMap.put('ResourceAlerts', ($clinit_ResourceAlertsPortlet$Factory() , INSTANCE_24));
  resourcePortletFactoryMap.put('ResourceOperations', ($clinit_ResourceOperationsPortlet$Factory() , INSTANCE_30));
  resourcePortletFactoryMap.put('ResourcePackageHistory', ($clinit_ResourcePkgHistoryPortlet$Factory() , INSTANCE_31));
  resourcePortletFactoryMap.put('ResourceBundleDeployments', ($clinit_ResourceBundleDeploymentsPortlet$Factory() , INSTANCE_25));
  resourcePortletFactoryMap.put('ResourceConfigurationUpdates', ($clinit_ResourceConfigurationUpdatesPortlet$Factory() , INSTANCE_26));
  resourcePortletNameMap = new TreeMap_0;
  $put_2(resourcePortletNameMap, ($clinit_ResourceMetricsPortlet() , NAME_22), 'ResourceMetrics');
  $put_2(resourcePortletNameMap, ($clinit_ResourceEventsPortlet() , NAME_21), 'ResourceEvents');
  $put_2(resourcePortletNameMap, ($clinit_ResourceOobsPortlet() , NAME_23), 'ResourceOobs');
  $put_2(resourcePortletNameMap, ($clinit_ResourceOperationsPortlet() , NAME_24), 'ResourceOperations');
  $put_2(resourcePortletNameMap, ($clinit_ResourcePkgHistoryPortlet() , NAME_25), 'ResourcePackageHistory');
  $put_2(resourcePortletNameMap, ($clinit_ResourceAlertsPortlet() , NAME_18), 'ResourceAlerts');
  $put_2(resourcePortletNameMap, ($clinit_ResourceBundleDeploymentsPortlet() , NAME_19), 'ResourceBundleDeployments');
  $put_2(resourcePortletNameMap, ($clinit_ResourceConfigurationUpdatesPortlet() , NAME_20), 'ResourceConfigurationUpdates');
  resourcePortletMenuMap = new LinkedHashMap_1(resourcePortletNameMap.size_0);
  for (portletName$iterator = $iterator($keySet(resourcePortletNameMap)); portletName$iterator.val$outerIter.hasNext();) {
    portletName = dynamicCast($next_1(portletName$iterator), Q$String);
    $put_1(resourcePortletMenuMap, dynamicCast($get_5(resourcePortletNameMap, portletName), Q$String), portletName);
  }
  portletIconMap = new HashMap_1(globalPortletFactoryMap.size_1());
  portletIconMap.put('GroupAlerts', 'subsystems/alert/Flag_blue_16.png');
  portletIconMap.put('ResourceAlerts', 'subsystems/alert/Flag_blue_16.png');
  portletIconMap.put('GroupMetrics', 'subsystems/monitor/Monitor_16.png');
  portletIconMap.put('ResourceMetrics', 'subsystems/monitor/Monitor_16.png');
  portletIconMap.put('GroupOobs', 'subsystems/monitor/Monitor_failed_16.png');
  portletIconMap.put('ResourceOobs', 'subsystems/monitor/Monitor_failed_16.png');
  portletIconMap.put('GroupEvents', 'subsystems/event/Events_16.png');
  portletIconMap.put('ResourceEvents', 'subsystems/event/Events_16.png');
  portletIconMap.put('GroupOperations', 'subsystems/control/Operation_16.png');
  portletIconMap.put('ResourceOperations', 'subsystems/control/Operation_16.png');
  portletIconMap.put('GroupPackageHistory', 'subsystems/content/Package_16.png');
  portletIconMap.put('ResourcePackageHistory', 'subsystems/content/Package_16.png');
  portletIconMap.put('GroupBundleDeployments', 'subsystems/content/Content_16.png');
  portletIconMap.put('ResourceBundleDeployments', 'subsystems/content/Content_16.png');
  portletIconMap.put('GroupConfigurationUpdates', 'subsystems/configure/Configure_16.png');
  portletIconMap.put('ResourceConfigurationUpdates', 'subsystems/configure/Configure_16.png');
}

function buildPortlet(portletWindow, storedPortlet, context){
  $clinit_PortletFactory();
  var msg, view, viewFactory;
  viewFactory = dynamicCast(globalPortletFactoryMap.get_2(storedPortlet.portletKey), Q$PortletViewFactory);
  if (!viewFactory) {
    viewFactory = dynamicCast(groupPortletFactoryMap.get_2(storedPortlet.portletKey), Q$PortletViewFactory);
    if (!viewFactory) {
      viewFactory = dynamicCast(resourcePortletFactoryMap.get_2(storedPortlet.portletKey), Q$PortletViewFactory);
      if (!viewFactory) {
        msg = new Message_7('Bad portlet: ' + storedPortlet, ($clinit_Message$Severity() , Warning));
        $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
        return new PortletFactory$1InvalidPortlet_0;
      }
    }
  }
  view = viewFactory.getInstance(context);
  view.configure(portletWindow, storedPortlet);
  instanceOf(view, Q$AutoRefreshPortlet) && dynamicCast(view, Q$AutoRefreshPortlet).startRefreshCycle();
  return view;
}

var globalPortletFactoryMap = null, globalPortletMenuMap = null, globalPortletNameMap = null, groupPortletFactoryMap = null, groupPortletMenuMap = null, groupPortletNameMap = null, portletIconMap = null, resourcePortletFactoryMap = null, resourcePortletMenuMap = null, resourcePortletNameMap = null;
function PortletFactory$1InvalidPortlet_0(){
  $clinit_BaseWidget();
  Label_4.call(this, ($clinit_CoreGUI() , 'This is an obsolete portlet that is no longer valid. Please delete it.'));
}

defineSeed(2469, 457, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Button, Q$Canvas, Q$StatefulCanvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasIconClickHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), PortletFactory$1InvalidPortlet_0);
_.configure = function configure(portletWindow, storedPortlet){
}
;
_.getHelpCanvas = function getHelpCanvas(){
  return new Label_4($getAttributeAsString_0(this, 'contents'));
}
;
function $clinit_PortletHelpWindow(){
  $clinit_PortletHelpWindow = nullMethod;
  $clinit_BaseWidget();
  $clinit_CoreGUI();
}

function PortletHelpWindow_0(storedPortlet, view){
  $clinit_PortletHelpWindow();
  Window_1.call(this);
  this.view = view;
  $setTitle(this, storedPortlet.name_0 + ' Help');
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $isCreated_1(this)?$setProperty_0(this, 'height', 400):(this.config_0['height'] = 400 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'width', 400):(this.config_0['width'] = 400 , undefined);
  $setAutoCenter(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setCanDragResize_0(this, TRUE);
  $setCanDragReposition(this, TRUE);
  $setDismissOnEscape(this, TRUE);
  $setDismissOnOutsideClick(this, TRUE);
}

defineSeed(2470, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), PortletHelpWindow_0);
_.onInit = function onInit_40(){
  var c, layout;
  $onInit(this);
  $onInit_Layout(this);
  c = this.view.getHelpCanvas();
  layout = new VLayout_0;
  $isCreated_1(layout)?$setProperty_3(layout, 'width', '100%'):(layout.config_0['width'] = '100%' , undefined);
  $isCreated_1(layout)?$setProperty_3(layout, 'height', '100%'):(layout.config_0['height'] = '100%' , undefined);
  $setPadding(layout, valueOf_44(15));
  $setLayoutMargin(layout, valueOf_44(20));
  $setAttribute_24(layout, 'vPolicy', ($clinit_LayoutPolicy() , FILL).value_0, true);
  c?layout.addMember_0(c):layout.addMember_0(new Label_4('There is no help available for this portlet.'));
  $addItem(this, layout);
}
;
_.view = null;
function PortletSettingsWindow_0(parentWindow, storedPortlet, view){
  $clinit_BaseWidget();
  Window_1.call(this);
  $clinit_CoreGUI();
  this.parentWindow = parentWindow;
  this.storedPortlet = storedPortlet;
  this.view = view;
  $setTitle(this, storedPortlet.name_0 + ' Settings');
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $isCreated_1(this)?$setProperty_0(this, 'minWidth', 400):(this.config_0['minWidth'] = 400 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'minHeight', 400):(this.config_0['minHeight'] = 400 , undefined);
  $setAutoSize(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAutoCenter(this, TRUE);
  $setCanDragResize_0(this, TRUE);
  $setCanDragReposition(this, TRUE);
}

defineSeed(2471, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), PortletSettingsWindow_0);
_.onInit = function onInit_41(){
  var buttons, cancel, configuration, definition, editor, form, layout, save, spacer;
  $onInit(this);
  $onInit_Layout(this);
  layout = new VLayout_0;
  $isCreated_1(layout)?$setProperty_3(layout, 'width', '100%'):(layout.config_0['width'] = '100%' , undefined);
  $isCreated_1(layout)?$setProperty_3(layout, 'height', '100%'):(layout.config_0['height'] = '100%' , undefined);
  $setPadding(layout, valueOf_44(15));
  $setLayoutMargin(layout, valueOf_44(20));
  $setAttribute_24(layout, 'vPolicy', ($clinit_LayoutPolicy() , FILL).value_0, true);
  if (instanceOf(this.view, Q$CustomSettingsPortlet)) {
    form = dynamicCast(this.view, Q$CustomSettingsPortlet).getCustomSettingsForm();
    layout.addMember_0(form);
    spacer = new VLayout_0;
    $isCreated_1(spacer)?$setProperty_0(spacer, 'height', 10):(spacer.config_0['height'] = 10 , undefined);
    layout.addMember_0(spacer);
    cancel = new EnhancedIButton_1('Cancel');
    $addClickHandler(cancel, new PortletSettingsWindow$1_0(this));
    save = new EnhancedIButton_1('Save');
    $addClickHandler(save, new PortletSettingsWindow$2_0(this, form));
    buttons = new HLayout_1(10);
    $setAttribute_24(buttons, 'layoutAlign', ($clinit_Alignment() , CENTER_0).value_0, false);
    $addMember(buttons, cancel);
    $addMember(buttons, save);
    layout.addMember_0(buttons);
  }
   else if (instanceOf(this.view, Q$ConfigurablePortlet)) {
    definition = dynamicCast(this.view, Q$ConfigurablePortlet).getConfigurationDefinition();
    configuration = this.storedPortlet.configuration;
    editor = new ConfigurationEditor_1(definition, configuration);
    $isCreated_1(editor)?$setProperty_0(editor, 'width', 400):(editor.config_0['width'] = 400 , undefined);
    $isCreated_1(editor)?$setProperty_0(editor, 'height', 400):(editor.config_0['height'] = 400 , undefined);
    layout.addMember_0(editor);
    cancel = new EnhancedIButton_1('Cancel');
    $addClickHandler(cancel, new PortletSettingsWindow$3_0(this));
    save = new EnhancedIButton_1('Save');
    $addClickHandler(save, new PortletSettingsWindow$4_0(this, editor));
    buttons = new HLayout_1(10);
    $setAttribute_24(buttons, 'layoutAlign', ($clinit_Alignment() , CENTER_0).value_0, false);
    $addMember(buttons, cancel);
    $addMember(buttons, save);
    layout.addMember_0(buttons);
  }
   else {
    layout.addMember_0(new Label_4('Configuration is not necessary for this portlet.'));
  }
  $addItem(this, layout);
}
;
_.parentWindow = null;
_.storedPortlet = null;
_.view = null;
function PortletSettingsWindow$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2472, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletSettingsWindow$1_0);
_.onClick = function onClick_98(clickEvent){
  $destroy(this.this$0);
}
;
_.this$0 = null;
function PortletSettingsWindow$2_0(this$0, val$form){
  this.this$0 = this$0;
  this.val$form = val$form;
}

defineSeed(2473, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletSettingsWindow$2_0);
_.onClick = function onClick_99(clickEvent){
  if (this.val$form.validate_0()) {
    $submit(this.val$form);
    $save_3(this.this$0.parentWindow.dashboardView);
    $destroy(this.this$0);
  }
}
;
_.this$0 = null;
_.val$form = null;
function PortletSettingsWindow$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2474, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletSettingsWindow$3_0);
_.onClick = function onClick_100(clickEvent){
  $destroy(this.this$0);
}
;
_.this$0 = null;
function PortletSettingsWindow$4_0(this$0, val$editor){
  this.this$0 = this$0;
  this.val$editor = val$editor;
}

defineSeed(2475, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletSettingsWindow$4_0);
_.onClick = function onClick_101(clickEvent){
  var configuration;
  if ($validate_1(this.val$editor.topLevelPropertiesValuesManager).value_0) {
    configuration = this.val$editor.configuration;
    $setConfiguration_0(this.this$0.storedPortlet, configuration);
    $destroy(this.this$0);
    this.this$0.view.configure(this.this$0.parentWindow, this.this$0.storedPortlet);
    $markForRedraw(this.this$0.parentWindow);
    $save_3(this.this$0.parentWindow.dashboardView);
  }
}
;
_.this$0 = null;
_.val$editor = null;
function $clinit_PortletWindow(){
  $clinit_PortletWindow = nullMethod;
  $clinit_BaseWidget();
  NO_OP_HANDLER = new PortletWindow$1_0;
}

function $getResourcePermissions(this$static){
  var result;
  result = null;
  this$static.dashboardView.resourceComposite?(result = this$static.dashboardView.resourceComposite.resourcePermission):!!this$static.dashboardView.groupComposite && (result = this$static.dashboardView.groupComposite.resourcePermission);
  return result;
}

function $hideSizingHeaderControls(this$static, hideControls){
  if (hideControls) {
    $setShowMinimizeButton(this$static, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $hide(this$static.maximizeHeaderControl);
  }
   else {
    $setShowMinimizeButton(this$static, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $show(this$static.maximizeHeaderControl);
  }
}

function $setHelpClickHandler(this$static, handler){
  this$static.helpHandlerDelegate = handler;
}

function $setSettingsClickHandler(this$static, handler){
  this$static.settingsHandlerDelegate = handler;
}

function PortletWindow_0(dashboardView, dashboardPortlet, context){
  var headerControls;
  $clinit_PortletWindow();
  var RssHeader, icon, iconUrl, portletKey;
  Window_1.call(this);
  this.settingsHandlerDelegate = NO_OP_HANDLER;
  this.helpHandlerDelegate = NO_OP_HANDLER;
  this.settingsHandler = new PortletWindow$2_0(this);
  this.helpHandler = new PortletWindow$3_0(this);
  this.rssHandler = new PortletWindow$4_0;
  this.refreshHandler = new PortletWindow$5_0(this);
  this.maximizeHeaderControl = new HeaderControl_1(($clinit_HeaderControl() , MAXIMIZE), new PortletWindow$6_0(this));
  this.dashboardView = dashboardView;
  this.storedPortlet = dashboardPortlet;
  this.context = context;
  $isCreated_1(this)?undefined:(this.config_0['edgeSize'] = 2 , undefined);
  RssHeader = new HeaderControl_1(new HeaderControl$HeaderIcon_0('[SKIN]/headerIcons/clipboard.png'), this.rssHandler);
  $isCreated_1(RssHeader)?$setProperty_3(RssHeader, 'prompt', 'Rss'):(RssHeader.config_0['prompt'] = 'Rss' , undefined);
  this.headerIcon = null;
  portletKey = this.storedPortlet.portletKey;
  iconUrl = ($clinit_PortletFactory() , dynamicCast(portletIconMap.get_2(portletKey), Q$String));
  if (iconUrl != null && !!$trim(iconUrl).length) {
    icon = new HeaderControl$HeaderIcon_0(iconUrl);
    this.headerIcon = new HeaderControl_0(icon);
    $addMouseOverHandler(this.headerIcon, new PortletWindow$7_0(this, iconUrl));
  }
  headerControls = new ArrayList_0;
  $add_3(headerControls, ($clinit_HeaderControls() , MINIMIZE_BUTTON));
  $addMinimizeClickHandler(this, new PortletWindow$10_0(this));
  $addRestoreClickHandler(this, new PortletWindow$11_0(this));
  $add_3(headerControls, this.maximizeHeaderControl);
  !!this.headerIcon && $add_3(headerControls, this.headerIcon);
  $add_3(headerControls, HEADER_LABEL);
  $add_3(headerControls, new HeaderControl_1(REFRESH, this.refreshHandler));
  $add_3(headerControls, new HeaderControl_1(SETTINGS, this.settingsHandler));
  $add_3(headerControls, new HeaderControl_1(HELP, this.helpHandler));
  $add_3(headerControls, CLOSE_BUTTON);
  $setHeaderControls(this, $toArray_1(headerControls, initDim(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, headerControls.size_0, 0)));
  $setAnimateMinimize(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setCanDrag(this, TRUE);
  $setAttribute_24(this, 'dragAppearance', ($clinit_DragAppearance() , TARGET).value_0, true);
  $setDragOpacity(this, valueOf_44(30));
  $setCanDrop(this, TRUE);
  $setCanDragResize_0(this, TRUE);
  $isCreated_1(this)?$setProperty_2(this, 'resizeFrom', convertToJavaScriptArray(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['T', 'B']))):(this.config_0['resizeFrom'] = convertToJavaScriptArray(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['T', 'B'])) , undefined);
  $setShowShadow(this, FALSE);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $addDragResizeStopHandler(this, new PortletWindow$8_0(this));
  $addCloseClickHandler(this, new PortletWindow$9_0(this));
  $setSettingsClickHandler(this, this.settingsHandler);
  $setHelpClickHandler(this, this.helpHandler);
}

defineSeed(2476, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$PortletWindow]), PortletWindow_0);
_.onInit = function onInit_42(){
  var canvas;
  $onInit(this);
  $onInit_Layout(this);
  this.view = buildPortlet(this, this.storedPortlet, this.context);
  canvas = dynamicCast(this.view, Q$Canvas);
  $addItem(this, canvas);
  this.settingsHandlerDelegate = new PortletWindow$12_0(this);
  this.helpHandlerDelegate = new PortletWindow$13_0(this);
}
;
_.context = null;
_.dashboardView = null;
_.headerIcon = null;
_.storedPortlet = null;
_.view = null;
var NO_OP_HANDLER;
function PortletWindow$1_0(){
}

defineSeed(2477, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletWindow$1_0);
_.onClick = function onClick_102(clickEvent){
}
;
function PortletWindow$10_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2478, 1, makeCastMap([Q$EventHandler, Q$MinimizeClickHandler, Q$PortletWindow$10]), PortletWindow$10_0);
_.this$0 = null;
function PortletWindow$11_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2479, 1, makeCastMap([Q$EventHandler, Q$RestoreClickHandler, Q$PortletWindow$11]), PortletWindow$11_0);
_.this$0 = null;
function PortletWindow$12_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2480, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletWindow$12_0);
_.onClick = function onClick_103(clickEvent){
  var self_0;
  self_0 = (new PortletSettingsWindow_0(this.this$0, this.this$0.storedPortlet, this.this$0.view)).getOrCreateJsObj();
  self_0.show();
}
;
_.this$0 = null;
function PortletWindow$13_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2481, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletWindow$13_0);
_.onClick = function onClick_104(clickEvent){
  $show(new PortletHelpWindow_0(this.this$0.storedPortlet, this.this$0.view));
}
;
_.this$0 = null;
function PortletWindow$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2482, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletWindow$2_0);
_.onClick = function onClick_105(clickEvent){
  this.this$0.settingsHandlerDelegate.onClick(clickEvent);
}
;
_.this$0 = null;
function PortletWindow$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2483, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletWindow$3_0);
_.onClick = function onClick_106(clickEvent){
  this.this$0.helpHandlerDelegate.onClick(clickEvent);
}
;
_.this$0 = null;
function PortletWindow$4_0(){
}

defineSeed(2484, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletWindow$4_0);
_.onClick = function onClick_107(clickEvent){
}
;
function PortletWindow$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2485, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletWindow$5_0);
_.onClick = function onClick_108(clickEvent){
  instanceOf(this.this$0.view, Q$AutoRefreshPortlet)?dynamicCast(this.this$0.view, Q$AutoRefreshPortlet).refresh_0():instanceOf(this.this$0.view, Q$Table)?dynamicCast(this.this$0.view, Q$Table).refresh_0():dynamicCast(this.this$0.view, Q$Canvas).redraw_0();
}
;
_.this$0 = null;
function PortletWindow$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2486, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PortletWindow$6_0);
_.onClick = function onClick_109(event_0){
  $maximizePortlet(this.this$0.dashboardView, this.this$0);
}
;
_.this$0 = null;
function PortletWindow$7_0(this$0, val$iconUrl){
  this.this$0 = this$0;
  this.val$iconUrl = val$iconUrl;
}

defineSeed(2487, 1, makeCastMap([Q$EventHandler, Q$MouseOverHandler]), PortletWindow$7_0);
_.onMouseOver = function onMouseOver_1(event_0){
  $setIcon(this.this$0.headerIcon, this.val$iconUrl);
}
;
_.this$0 = null;
_.val$iconUrl = null;
function PortletWindow$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2488, 1, makeCastMap([Q$EventHandler, Q$DragResizeStopHandler]), PortletWindow$8_0);
_.this$0 = null;
function PortletWindow$9_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2489, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), PortletWindow$9_0);
_.onCloseClick_0 = function onCloseClick_7(closeClientEvent){
  if (this.this$0.dashboardView.maximizedPortlet) {
    $restorePortlet(this.this$0.dashboardView);
  }
   else {
    $removePortlet_0(this.this$0.dashboardView, this.this$0);
    $destroy(this.this$0);
  }
}
;
_.this$0 = null;
function $clinit_PortletConfigurationEditorComponent(){
  $clinit_PortletConfigurationEditorComponent = nullMethod;
  $clinit_CoreGUI();
  CONFIG_PROPERTY_INITIALIZATION = new HashMap_0;
  CONFIG_PROPERTY_INITIALIZATION.put('ALERT_PRIORITY', '');
  CONFIG_PROPERTY_INITIALIZATION.put('RESULT_SORT_ORDER', ($clinit_PortletConfigurationEditorComponent$Constant() , RESULT_SORT_ORDER_DEFAULT));
  CONFIG_PROPERTY_INITIALIZATION.put('RESULT_COUNT', '5');
  CONFIG_PROPERTY_INITIALIZATION.put('METRIC_RANGE_ENABLE', 'false');
  CONFIG_PROPERTY_INITIALIZATION.put('METRIC_RANGE_BEGIN_END_FLAG', 'false');
  CONFIG_PROPERTY_INITIALIZATION.put('METRIC_RANGE_LASTN', '8');
  CONFIG_PROPERTY_INITIALIZATION.put('METRIC_RANGE_UNIT', '3');
  CONFIG_PROPERTY_INITIALIZATION.put('OPERATION_STATUS', '');
  CONFIG_PROPERTY_INITIALIZATION.put('CONFIG_UPDATE_STATUS', '');
}

function getOperationStatusEditor(portletConfig){
  $clinit_PortletConfigurationEditorComponent();
  var currentValue, priorityFilter, stati, statusIcons;
  priorityFilter = new SelectItem_2('OPERATION_STATUS', 'Operation Status');
  $setWrapTitle(priorityFilter, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_2(priorityFilter)?$setProperty_6(priorityFilter, 'width', 325):(priorityFilter.jsObj['width'] = 325 , undefined);
  $setMultiple(priorityFilter, TRUE);
  $setAttribute_30(priorityFilter, 'multipleAppearance', ($clinit_MultipleAppearance() , PICKLIST).value_0);
  stati = new LinkedHashMap_1(4);
  $put_1(stati, ($clinit_OperationRequestStatus() , SUCCESS_6).name_0, 'Success');
  $put_1(stati, INPROGRESS_1.name_0, 'In Progress');
  $put_1(stati, CANCELED.name_0, 'Canceled');
  $put_1(stati, FAILURE_6.name_0, 'Failed');
  statusIcons = new LinkedHashMap_1(3);
  $put_1(statusIcons, SUCCESS_6.name_0, getOperationResultsIcon(SUCCESS_6));
  $put_1(statusIcons, INPROGRESS_1.name_0, getOperationResultsIcon(INPROGRESS_1));
  $put_1(statusIcons, CANCELED.name_0, getOperationResultsIcon(CANCELED));
  $put_1(statusIcons, FAILURE_6.name_0, getOperationResultsIcon(FAILURE_6));
  priorityFilter.setValueMap_0(stati);
  $isCreated_2(priorityFilter)?$setProperty_7(priorityFilter, 'valueIcons', convertMapToJavascriptObject(statusIcons)):(priorityFilter.jsObj['valueIcons'] = convertMapToJavascriptObject(statusIcons) , undefined);
  currentValue = $getSimpleValue(portletConfig, 'OPERATION_STATUS', '');
  !currentValue.length || $split(currentValue, ',', 0).length == $VALUES_96.length?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_6.name_0, INPROGRESS_1.name_0, CANCELED.name_0, FAILURE_6.name_0])):$equalsIgnoreCase(currentValue, SUCCESS_6.name_0)?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_6.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,INPROGRESS,CANCELED,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_6.name_0, INPROGRESS_1.name_0, CANCELED.name_0, FAILURE_6.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,INPROGRESS,CANCELED')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_6.name_0, INPROGRESS_1.name_0, CANCELED.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,INPROGRESS,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_6.name_0, INPROGRESS_1.name_0, FAILURE_6.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,INPROGRESS')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_6.name_0, INPROGRESS_1.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,CANCELED,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_6.name_0, CANCELED.name_0, FAILURE_6.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,CANCELED')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_6.name_0, CANCELED.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_6.name_0, FAILURE_6.name_0])):$equalsIgnoreCase(currentValue, 'INPROGRESS')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [INPROGRESS_1.name_0])):$equalsIgnoreCase(currentValue, 'INPROGRESS,CANCELED,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [INPROGRESS_1.name_0, CANCELED.name_0, FAILURE_6.name_0])):$equalsIgnoreCase(currentValue, 'INPROGRESS,CANCELED')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [INPROGRESS_1.name_0, CANCELED.name_0])):$equalsIgnoreCase(currentValue, 'INPROGRESS,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [INPROGRESS_1.name_0, FAILURE_6.name_0])):$equalsIgnoreCase(currentValue, 'CANCELED')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [CANCELED.name_0])):$equalsIgnoreCase(currentValue, 'CANCELED,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [CANCELED.name_0, FAILURE_6.name_0])):$equalsIgnoreCase(currentValue, 'FAILURE') && priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [FAILURE_6.name_0]));
  return priorityFilter;
}

function getResultCountEditor(portletConfig){
  $clinit_PortletConfigurationEditorComponent();
  var currentValue, displayValues, i, maximumResultsComboBox, selection, selection$index, selection$max, selectionValues;
  maximumResultsComboBox = new SelectItem_1('RESULT_COUNT');
  $isCreated_2(maximumResultsComboBox)?$setProperty_8(maximumResultsComboBox, 'title', 'Results Count'):(maximumResultsComboBox.jsObj['title'] = 'Results Count' , undefined);
  $setWrapTitle(maximumResultsComboBox, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_2(maximumResultsComboBox)?$setProperty_8(maximumResultsComboBox, 'prompt', '<nobr><b> Displays this number of results<\/b><\/nobr>'):(maximumResultsComboBox.jsObj['prompt'] = '<nobr><b> Displays this number of results<\/b><\/nobr>' , undefined);
  $isCreated_2(maximumResultsComboBox)?$setProperty_8(maximumResultsComboBox, 'type', 'selection'):(maximumResultsComboBox.jsObj['type'] = 'selection' , undefined);
  $isCreated_2(maximumResultsComboBox)?$setProperty_6(maximumResultsComboBox, 'width', 100):(maximumResultsComboBox.jsObj['width'] = 100 , undefined);
  selectionValues = initValues(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [5, 10, 30, 100]);
  displayValues = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, selectionValues.length, 0);
  i = 0;
  for (selection$index = 0 , selection$max = selectionValues.length; selection$index < selection$max; ++selection$index) {
    selection = selectionValues[selection$index];
    displayValues[i++] = '' + selection;
  }
  maximumResultsComboBox.setValueMap_1(displayValues);
  currentValue = $getSimpleValue(portletConfig, 'RESULT_COUNT', '5');
  !currentValue.length?$setValue_7(maximumResultsComboBox, '5'):$setValue_7(maximumResultsComboBox, currentValue);
  return maximumResultsComboBox;
}

var CONFIG_PROPERTY_INITIALIZATION;
function $clinit_PortletConfigurationEditorComponent$Constant(){
  $clinit_PortletConfigurationEditorComponent$Constant = nullMethod;
  RESULT_SORT_ORDER_DEFAULT = ($clinit_PageOrdering() , DESC).name_0;
}

var RESULT_SORT_ORDER_DEFAULT;
function $clinit_ResourceGroupListView(){
  $clinit_ResourceGroupListView = nullMethod;
  $clinit_BaseWidget();
  DEFAULT_TITLE = ($clinit_Enhanced() , 'Resource Groups');
}

function $configureTable_2(this$static){
  var availabilityChildrenField, availabilityDescendantsField, categoryField, descriptionField, idField, nameField, pluginNameField, typeNameField;
  idField = new ListGridField_3('id', ($clinit_Enhanced() , 'ID'));
  idField.jsObj['width'] = 50;
  categoryField = new IconField_1(($clinit_ResourceGroupDataSourceField() , CATEGORY).propertyName);
  $setCellFormatter_0(categoryField, new ResourceGroupListView$1_0);
  $setAttribute_8(categoryField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(categoryField, new ResourceGroupListView$2_0);
  nameField = new ListGridField_3(NAME_30.propertyName, NAME_30.title_0);
  nameField.jsObj['width'] = '40%';
  $setCellFormatter_0(nameField, new ResourceGroupListView$3_0);
  descriptionField = new ListGridField_3(DESCRIPTION.propertyName, DESCRIPTION.title_0);
  descriptionField.jsObj['width'] = '28%';
  typeNameField = new ListGridField_3(TYPE_55.propertyName, TYPE_55.title_0);
  typeNameField.jsObj['width'] = '14%';
  pluginNameField = new ListGridField_3(PLUGIN_1.propertyName, PLUGIN_1.title_0);
  pluginNameField.jsObj['width'] = '8%';
  availabilityChildrenField = new ListGridField_4(AVAIL_CHILDREN.propertyName, AVAIL_CHILDREN.title_0, 185);
  $setAttribute_8(availabilityChildrenField, 'canSortClientOnly', TRUE);
  $setAttribute_8(availabilityChildrenField, 'canGroupBy', FALSE);
  availabilityChildrenField.jsObj['wrap'] = false;
  $setAttribute_13(availabilityChildrenField, 'align', ($clinit_Alignment() , LEFT_0).value_0);
  availabilityDescendantsField = new ListGridField_4(AVAIL_DESCENDANTS.propertyName, AVAIL_DESCENDANTS.title_0, 185);
  $setAttribute_8(availabilityDescendantsField, 'canSortClientOnly', TRUE);
  $setAttribute_8(availabilityDescendantsField, 'canGroupBy', FALSE);
  availabilityDescendantsField.jsObj['wrap'] = false;
  $setAttribute_13(availabilityDescendantsField, 'align', LEFT_0.value_0);
  $setListGridFields(this$static, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, categoryField, nameField, descriptionField, typeNameField, pluginNameField, availabilityChildrenField, availabilityDescendantsField]));
  $addTableAction(this$static, 'Delete', 'Are You Sure?', null, new ResourceGroupListView$4_0(this$static, this$static, ($clinit_TableActionEnablement() , ANY_1), initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [($clinit_Permission() , MANAGE_INVENTORY)])));
  this$static.showNewButton && $addTableAction(this$static, 'New', null, null, new ResourceGroupListView$5_0(this$static, this$static, initValues(_3Lorg_rhq_core_domain_authz_Permission_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Permission, [MANAGE_INVENTORY])));
  !!this$static.resourceIdToModify && $addTableAction(this$static, 'Group Membership...', null, null, new ResourceGroupListView$6_0(this$static, ALWAYS));
  $setListGridDoubleClickHandler(this$static, new ResourceGroupListView$7_0);
}

function ResourceGroupListView_0(){
  $clinit_ResourceGroupListView();
  ResourceGroupListView_3.call(this, DEFAULT_TITLE);
}

function ResourceGroupListView_1(criteria){
  $clinit_ResourceGroupListView();
  var datasource;
  Table_3.call(this, null, criteria);
  datasource = ($clinit_ResourceGroupCompositeDataSource() , !INSTANCE_37 && (INSTANCE_37 = new ResourceGroupCompositeDataSource_0) , $clinit_ResourceGroupCompositeDataSource() , INSTANCE_37);
  this.dataSource_1 = datasource;
}

function ResourceGroupListView_2(criteria, title, headerIcons){
  $clinit_ResourceGroupListView();
  var datasource, headerIcon, headerIcon$index, headerIcon$max;
  Table_3.call(this, title, criteria);
  for (headerIcon$index = 0 , headerIcon$max = headerIcons.length; headerIcon$index < headerIcon$max; ++headerIcon$index) {
    headerIcon = headerIcons[headerIcon$index];
    $add_3(this.headerIcons, headerIcon);
  }
  datasource = ($clinit_ResourceGroupCompositeDataSource() , !INSTANCE_37 && (INSTANCE_37 = new ResourceGroupCompositeDataSource_0) , $clinit_ResourceGroupCompositeDataSource() , INSTANCE_37);
  this.dataSource_1 = datasource;
}

function ResourceGroupListView_3(title){
  ResourceGroupListView_2.call(this, null, title, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, []));
}

function getGroupsOf(explicitResourceId, canModifyMembership){
  $clinit_ResourceGroupListView();
  var view;
  view = new ResourceGroupListView_2(new Criteria_2('explicitResourceId', '' + explicitResourceId), ($clinit_Enhanced() , 'Resource Groups'), initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, []));
  canModifyMembership && (view.resourceIdToModify = valueOf_44(explicitResourceId));
  return view;
}

defineSeed(2492, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ResourceGroupListView_0, ResourceGroupListView_1, ResourceGroupListView_2);
_.configureTable = function configureTable_21(){
  $configureTable_2(this);
}
;
_.getSearchSubsystem = function getSearchSubsystem_0(){
  return $clinit_SearchSubsystem() , GROUP_1;
}
;
_.resourceIdToModify = null;
_.showNewButton = true;
var DEFAULT_TITLE;
function $clinit_FavoriteGroupsPortlet(){
  $clinit_FavoriteGroupsPortlet = nullMethod;
  $clinit_ResourceGroupListView();
  NAME = ($clinit_Enhanced() , 'Favorite Groups');
}

function FavoriteGroupsPortlet_0(){
  var favoriteIds, favArray, criteria;
  $clinit_FavoriteGroupsPortlet();
  ResourceGroupListView_2.call(this, (favoriteIds = $getPreferenceAsIntegerSet(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), '.dashContent.grouphealth.groups') , favArray = dynamicCast(favoriteIds.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, favoriteIds.size_1(), 0)), Q$Integer_$1) , criteria = new Criteria_0 , favoriteIds.isEmpty_0()?$addCriteria_1(criteria, 'id', valueOf_44(-1)):(criteria.jsObj['resourceGroupIds'] = convertToJavaScriptArray(favArray) , undefined) , criteria), NAME, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, []));
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  this.showHeader = false;
  this.showFooter = false;
}

defineSeed(2491, 2492, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$AutoRefreshPortlet, Q$Enhanced, Q$EnhancedHLayout]), FavoriteGroupsPortlet_0);
_.configure = function configure_0(portletWindow, storedPortlet){
  !this.portletWindow && !!portletWindow && (this.portletWindow = portletWindow);
}
;
_.configureTable = function configureTable_22(){
  var listGrid, state, storedPortlet, tablePrefs;
  $configureTable_2(this);
  $addFieldStateChangedHandler(this.listGrid, new FavoriteGroupsPortlet$1_0(this));
  storedPortlet = this.portletWindow.storedPortlet;
  if (!!storedPortlet && !!storedPortlet.configuration) {
    tablePrefs = $getSimple(storedPortlet.configuration, 'tablePreferences');
    listGrid = this.listGrid;
    if (!!tablePrefs && !!listGrid) {
      state = tablePrefs.stringValue;
      $setViewState(listGrid, state);
    }
  }
}
;
_.getHelpCanvas = function getHelpCanvas_0(){
  return new HTMLFlow_1(($clinit_Enhanced() , "This portlet displays the current user's  favorite resources."));
}
;
_.isRefreshing = function isRefreshing(){
  return false;
}
;
_.onDestroy = function onDestroy_1(){
  onDestroy_0(this.refreshTimer);
}
;
_.refresh_0 = function refresh_8(){
  $refresh(this, false);
}
;
_.startRefreshCycle = function startRefreshCycle_0(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.portletWindow = null;
_.refreshTimer = null;
var NAME;
function FavoriteGroupsPortlet$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2493, 1, makeCastMap([Q$EventHandler, Q$FieldStateChangedHandler]), FavoriteGroupsPortlet$1_0);
_.onFieldStateChanged = function onFieldStateChanged(fieldStateChangedEvent){
  var state;
  state = $getViewState(this.this$0.listGrid);
  $put_4(this.this$0.portletWindow.storedPortlet.configuration, new PropertySimple_1('tablePreferences', state));
  $save_3(this.this$0.portletWindow.dashboardView);
}
;
_.this$0 = null;
function $clinit_FavoriteGroupsPortlet$Factory(){
  $clinit_FavoriteGroupsPortlet$Factory = nullMethod;
  INSTANCE_5 = new FavoriteGroupsPortlet$Factory_0;
}

function FavoriteGroupsPortlet$Factory_0(){
}

defineSeed(2494, 1, makeCastMap([Q$PortletViewFactory]), FavoriteGroupsPortlet$Factory_0);
_.getInstance = function getInstance(context){
  return new FavoriteGroupsPortlet_0;
}
;
var INSTANCE_5;
function $configure(this$static, portletWindow, storedPortlet){
  var config, key, key$iterator;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  config = storedPortlet.configuration;
  for (key$iterator = $iterator($keySet(($clinit_PortletConfigurationEditorComponent() , CONFIG_PROPERTY_INITIALIZATION))); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$String);
    !dynamicCast(config.properties.get_2(key), Q$PropertySimple) && $put_4(config, new PropertySimple_1(key, CONFIG_PROPERTY_INITIALIZATION.get_2(key)));
  }
  $setConfiguration_1((!this$static.dataSource && (this$static.dataSource = new AbstractRecentAlertsPortlet$AlertsPortletDataSource_0(this$static.context)) , this$static.dataSource), config);
}

function $getAlertDetailLink(this$static, record){
  var alertId;
  alertId = $getId(this$static, record);
  return getAlertDetailLink(this$static.context, alertId.value_0);
}

function $saveMeasurementRangeEditorSettings(measurementRangeEditor, portletConfig){
  var begEnd, isAdvanceTimeSetting, item, itemC, persistTimeRangeSettings, rangeArray, selectedValue;
  if (!!measurementRangeEditor && !!portletConfig) {
    item = $getField_0(measurementRangeEditor, ($clinit_AbstractMeasurementRangeEditor() , 'ENABLE_RANGE_ITEM'));
    itemC = dynamicCast(item, Q$CheckboxItem);
    persistTimeRangeSettings = $getValueAsBoolean(itemC).value_0;
    if (persistTimeRangeSettings) {
      selectedValue = '' + $getValueAsBoolean(itemC);
      !$trim(selectedValue).length || $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_ENABLE', selectedValue));
      isAdvanceTimeSetting = false;
      selectedValue = '' + measurementRangeEditor.advanced;
      if (selectedValue != null && !!$trim(selectedValue).length) {
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_BEGIN_END_FLAG', selectedValue));
        isAdvanceTimeSetting = ($clinit_Boolean() , $equalsIgnoreCase('true', selectedValue)?TRUE:FALSE).value_0;
      }
      begEnd = $getBeginEndTimes_0(measurementRangeEditor);
      if (isAdvanceTimeSetting) {
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE', (checkIndex(0, begEnd.size_0) , begEnd.array[0]) + ',' + (checkIndex(1, begEnd.size_0) , begEnd.array[1])));
      }
       else {
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_LASTN', valueOf_44(measurementRangeEditor.measurementPrefs.metricRangePreferences.lastN)));
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_UNIT', valueOf_44(measurementRangeEditor.measurementPrefs.metricRangePreferences.unit)));
      }
    }
     else {
      $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_ENABLE', ($clinit_Boolean() , $clinit_Boolean() , FALSE)));
      $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_BEGIN_END_FLAG', FALSE));
      rangeArray = calculateTimeFrame(valueOf_44(__parseAndValidateInt(($clinit_PortletConfigurationEditorComponent$Constant() , '8'))).value_0, valueOf_44(__parseAndValidateInt('3')).value_0);
      $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE', '' + (checkIndex(0, rangeArray.size_0) , rangeArray.array[0]) + ',' + (checkIndex(1, rangeArray.size_0) , rangeArray.array[1])));
    }
  }
}

function AbstractRecentAlertsPortlet_0(entityContext){
  $clinit_AlertHistoryView();
  AlertHistoryView_1.call(this, null, entityContext, false);
  this.baseViewPath = getEntityTabLink(this.context, 'Alerts', 'History');
  this.showFilterForm = false;
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  this.showFooterRefresh = false;
  this.showHeader = false;
}

defineSeed(2496, 1880, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced, Q$EnhancedHLayout]));
_.canSupportDeleteAndAcknowledgeAll = function canSupportDeleteAndAcknowledgeAll_0(){
  return false;
}
;
_.configure = function configure_1(portletWindow, storedPortlet){
  $configure(this, portletWindow, storedPortlet);
}
;
_.getBasePath = function getBasePath_2(){
  return this.baseViewPath;
}
;
_.getCustomSettingsForm = function getCustomSettingsForm(){
  var alertPrioritySelector, customSettingsForm, filterForm, measurementRangeEditor, page, portletConfig, resultCountSelector, storedPortlet, priorityFilter, priorities, priorityIcons, currentValue;
  customSettingsForm = new DynamicForm_0;
  page = new EnhancedVLayout_0;
  filterForm = new DynamicForm_0;
  $setMargin(filterForm, valueOf_44(5));
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  alertPrioritySelector = ($clinit_PortletConfigurationEditorComponent() , priorityFilter = new SelectItem_2('ALERT_PRIORITY', 'Priority Filter') , $setWrapTitle(priorityFilter, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , $isCreated_2(priorityFilter)?$setProperty_6(priorityFilter, 'width', 200):(priorityFilter.jsObj['width'] = 200 , undefined) , $setMultiple(priorityFilter, TRUE) , $setAttribute_30(priorityFilter, 'multipleAppearance', ($clinit_MultipleAppearance() , PICKLIST).value_0) , priorities = new LinkedHashMap_1(3) , $put_1(priorities, ($clinit_AlertPriority() , HIGH).name_0, 'High') , $put_1(priorities, MEDIUM.name_0, 'Medium') , $put_1(priorities, LOW.name_0, 'Low') , priorityIcons = new LinkedHashMap_1(3) , $put_1(priorityIcons, HIGH.name_0, 'subsystems/alert/Alert_' + HIGH.name_0 + '_16.png') , $put_1(priorityIcons, MEDIUM.name_0, 'subsystems/alert/Alert_' + MEDIUM.name_0 + '_16.png') , $put_1(priorityIcons, LOW.name_0, 'subsystems/alert/Alert_' + LOW.name_0 + '_16.png') , priorityFilter.setValueMap_0(priorities) , $isCreated_2(priorityFilter)?$setProperty_7(priorityFilter, 'valueIcons', convertMapToJavascriptObject(priorityIcons)):(priorityFilter.jsObj['valueIcons'] = convertMapToJavascriptObject(priorityIcons) , undefined) , currentValue = $getSimpleValue(portletConfig, 'ALERT_PRIORITY', '') , !$trim(currentValue).length || $split(currentValue, ',', 0).length == $VALUES_46.length?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [HIGH.name_0, MEDIUM.name_0, LOW.name_0])):$equalsIgnoreCase(currentValue, 'HIGH')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [HIGH.name_0])):$equalsIgnoreCase(currentValue, 'HIGH,MEDIUM')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [HIGH.name_0, MEDIUM.name_0])):$equalsIgnoreCase(currentValue, 'HIGH,LOW')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [HIGH.name_0, LOW.name_0])):$equalsIgnoreCase(currentValue, 'MEDIUM')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [MEDIUM.name_0])):$equalsIgnoreCase(currentValue, 'MEDIUM,LOW')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [MEDIUM.name_0, LOW.name_0])):priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [LOW.name_0])) , priorityFilter);
  resultCountSelector = getResultCountEditor(portletConfig);
  measurementRangeEditor = new CustomConfigMeasurementRangeEditor_0(portletConfig);
  filterForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [alertPrioritySelector, resultCountSelector]));
  $addSubmitValuesHandler(customSettingsForm, new AbstractRecentAlertsPortlet$2_0(this, alertPrioritySelector, portletConfig, resultCountSelector, measurementRangeEditor, storedPortlet));
  $addMember(page, measurementRangeEditor);
  $addMember(page, filterForm);
  $addChild(customSettingsForm, page);
  return customSettingsForm;
}
;
_.getDataSource_0 = function getDataSource_10(){
  return !this.dataSource && (this.dataSource = new AbstractRecentAlertsPortlet$AlertsPortletDataSource_0(this.context)) , this.dataSource;
}
;
_.getDetailsLinkColumnCellFormatter = function getDetailsLinkColumnCellFormatter_0(){
  return new AbstractRecentAlertsPortlet$1_0(this);
}
;
_.getHelpCanvas = function getHelpCanvas_1(){
  return new HTMLFlow_1(($clinit_Enhanced() , "This portlet displays alerts recently fired on the current user's viewable inventory."));
}
;
_.isRefreshing = function isRefreshing_0(){
  return false;
}
;
_.onDestroy = function onDestroy_2(){
  onDestroy_0(this.refreshTimer);
}
;
_.onInit = function onInit_43(){
  $onInit_2(this);
  this.listGrid.setEmptyMessage(($clinit_Enhanced() , 'No results found using specified criteria.'));
}
;
_.refresh_0 = function refresh_9(){
  $refresh(this, false);
}
;
_.refreshTableInfo = function refreshTableInfo_0(){
  var count;
  $refreshTableInfo(this);
  if (this.tableInfo) {
    count = $getSelectedRecords(this.listGrid).length;
    $setContents_0(this.tableInfo, 'Matching Rows: ' + ($clinit_Enhanced() , '' + $getTotalRows(this.listGrid)) + ' (selected: ' + count + ')');
  }
}
;
_.setupTableInteractions = function setupTableInteractions_0(hasWriteAccess){
  var globalPerm, resPerm;
  if (!hasWriteAccess) {
    globalPerm = this.portletWindow.dashboardView.dashboardContainer.getGlobalPermissions();
    resPerm = $getResourcePermissions(this.portletWindow);
    hasWriteAccess = globalPerm.contains_0(($clinit_Permission() , MANAGE_INVENTORY)) || !!resPerm && resPerm.permissions.contains_0(MANAGE_ALERTS);
  }
  $setupTableInteractions_0(this, hasWriteAccess);
}
;
_.showDetails = function showDetails_2(record){
  var url;
  url = $getAlertDetailLink(this, record);
  $clinit_CoreGUI();
  goToView(url, null, false);
}
;
_.startRefreshCycle = function startRefreshCycle_1(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.baseViewPath = null;
_.dataSource = null;
_.portletWindow = null;
_.refreshTimer = null;
function $clinit_GroupAlertsPortlet(){
  $clinit_GroupAlertsPortlet = nullMethod;
  $clinit_AlertHistoryView();
  NAME_0 = ($clinit_Enhanced() , 'Group: Alerts');
}

function GroupAlertsPortlet_0(context){
  $clinit_GroupAlertsPortlet();
  AbstractRecentAlertsPortlet_0.call(this, context);
  this.groupId = context.groupId;
  this.isAutogroup = ($clinit_EntityContext$Type() , ResourceGroup) == context.type_0 && context.isAutoGroup;
}

defineSeed(2495, 2496, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced, Q$EnhancedHLayout]), GroupAlertsPortlet_0);
_.getBasePath = function getBasePath_3(){
  return (this.isAutogroup?'Resource/AutoGroup/':'ResourceGroup/') + this.groupId + '/Alerts/History';
}
;
_.groupId = 0;
_.isAutogroup = false;
var NAME_0;
function $clinit_GroupAlertsPortlet$Factory(){
  $clinit_GroupAlertsPortlet$Factory = nullMethod;
  INSTANCE_6 = new GroupAlertsPortlet$Factory_0;
}

function GroupAlertsPortlet$Factory_0(){
}

defineSeed(2497, 1, makeCastMap([Q$PortletViewFactory]), GroupAlertsPortlet$Factory_0);
_.getInstance = function getInstance_0(context){
  if (($clinit_EntityContext$Type() , ResourceGroup) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new GroupAlertsPortlet_0(context);
}
;
var INSTANCE_6;
function $clinit_GroupBundleDeploymentsPortlet(){
  $clinit_GroupBundleDeploymentsPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_1 = ($clinit_Enhanced() , 'Group: Bundle Deployments');
  CONFIG_INCLUDE = new ArrayList_0;
  $add_3(CONFIG_INCLUDE, 'RESULT_COUNT');
}

function $configure_0(this$static, portletWindow, storedPortlet){
  var key, key$iterator, portletConfig;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  portletConfig = storedPortlet.configuration;
  for (key$iterator = $iterator($keySet(($clinit_PortletConfigurationEditorComponent() , CONFIG_PROPERTY_INITIALIZATION))); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$String);
    !dynamicCast(portletConfig.properties.get_2(key), Q$PropertySimple) && $indexOf_0(CONFIG_INCLUDE, key, 0) != -1 && $put_4(portletConfig, new PropertySimple_1(key, CONFIG_PROPERTY_INITIALIZATION.get_2(key)));
  }
}

function $refresh_6(this$static){
  this$static.currentlyLoading || (this$static.currentlyLoading = true , this$static.getRecentBundleDeployments());
}

function GroupBundleDeploymentsPortlet_0(groupId){
  $clinit_GroupBundleDeploymentsPortlet();
  EnhancedVLayout_0.call(this);
  this.recentBundleDeployContent = new Canvas_1;
  this.groupId = groupId;
}

defineSeed(2498, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), GroupBundleDeploymentsPortlet_0);
_.configure = function configure_2(portletWindow, storedPortlet){
  $configure_0(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_0(){
  var customSettings, form, page, portletConfig, resultCountSelector, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  customSettings = new DynamicForm_0;
  page = new EnhancedVLayout_0;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(5));
  resultCountSelector = getResultCountEditor(portletConfig);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [resultCountSelector]));
  $addSubmitValuesHandler(customSettings, new GroupBundleDeploymentsPortlet$1_0(this, resultCountSelector, portletConfig, storedPortlet));
  $addMember(page, form);
  $addChild(customSettings, page);
  return customSettings;
}
;
_.getHelpCanvas = function getHelpCanvas_2(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet shows relevant bundle deployments based on display criteria configured.'));
}
;
_.getRecentBundleDeployments = function getRecentBundleDeployments(){
  var criteria, currentSetting, groupId, pc, portletConfig, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  groupId = this.groupId;
  criteria = new GroupBundleDeploymentCriteria_0;
  pc = new PageControl_0;
  currentSetting = $getSimpleValue(portletConfig, 'RESULT_COUNT', '5');
  !$trim(currentSetting).length?pc.setPageSize(valueOf_44(__parseAndValidateInt('5')).value_0):pc.setPageSize(valueOf_44(__parseAndValidateInt(currentSetting)).value_0);
  criteria.pageControlOverrides = pc;
  $addFilterResourceGroupIds_2(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(groupId)]));
  $addSortStatus_0(criteria, ($clinit_PageOrdering() , DESC));
  criteria.fetchDestination = true;
  criteria.fetchBundleVersion = true;
  $findBundleDeploymentsByCriteria(dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync), criteria, new GroupBundleDeploymentsPortlet$2_0(this, groupId));
}
;
_.isRefreshing = function isRefreshing_1(){
  return this.currentlyLoading;
}
;
_.onDestroy = function onDestroy_3(){
  onDestroy_0(this.refreshTimer);
}
;
_.onInit = function onInit_44(){
  $setPadding(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
  $addMember(this, this.recentBundleDeployContent);
  this.currentlyLoading = true;
  this.getRecentBundleDeployments();
}
;
_.refresh_0 = function refresh_10(){
  $refresh_6(this);
}
;
_.startRefreshCycle = function startRefreshCycle_2(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.currentlyLoading = false;
_.groupId = -1;
_.portletWindow = null;
_.refreshTimer = null;
var CONFIG_INCLUDE, NAME_1;
function GroupBundleDeploymentsPortlet$1_0(this$0, val$resultCountSelector, val$portletConfig, val$storedPortlet){
  this.this$0 = this$0;
  this.val$resultCountSelector = val$resultCountSelector;
  this.val$portletConfig = val$portletConfig;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2499, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), GroupBundleDeploymentsPortlet$1_0);
_.onSubmitValues = function onSubmitValues_0(event_0){
  var updatedConfig;
  updatedConfig = saveResultCounterSettings(this.val$resultCountSelector, this.val$portletConfig);
  $setConfiguration_0(this.val$storedPortlet, updatedConfig);
  $configure_0(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $refresh_6(this.this$0);
}
;
_.this$0 = null;
_.val$portletConfig = null;
_.val$resultCountSelector = null;
_.val$storedPortlet = null;
function $onSuccess_190(this$static, result){
  var child, child$array, child$index, child$max, column, deployment, deployment$iterator, destination, iconItem, link, row, time, title;
  column = new VLayout_0;
  $isCreated_1(column)?$setProperty_0(column, 'height', 10):(column.config_0['height'] = 10 , undefined);
  if (result.size_0 == 0) {
    row = createEmptyDisplayRow(($clinit_Enhanced() , 'No results found using specified criteria.'));
    column.addMember_0(row);
  }
   else {
    for (deployment$iterator = new AbstractList$IteratorImpl_0(result); deployment$iterator.i < deployment$iterator.this$0_0.size_1();) {
      deployment = dynamicCast($next_0(deployment$iterator), Q$BundleDeployment);
      row = new DynamicForm_0;
      $isCreated_1(row)?$setProperty_0(row, 'numCols', 3):(row.config_0['numCols'] = 3 , undefined);
      iconItem = newTextItemIcon('subsystems/content/Content_16.png', null);
      title = deployment.bundleVersion.name_0 + '[' + deployment.bundleVersion.version_0 + ']:';
      destination = getBundleDestinationLink(deployment.bundleVersion.bundle.id, deployment.destination.id);
      link = newLinkItem(title, destination);
      time = newTextItem(format_90(deployment.ctime.value_0));
      row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [iconItem, link, time]));
      column.addMember_0(row);
    }
  }
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentBundleDeployContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.this$0.recentBundleDeployContent, column);
  this$static.this$0.recentBundleDeployContent.markForRedraw_0();
  this$static.this$0.currentlyLoading = false;
  $markForRedraw(this$static.this$0);
}

function GroupBundleDeploymentsPortlet$2_0(this$0, val$groupId){
  this.this$0 = this$0;
  this.val$groupId = val$groupId;
}

defineSeed(2500, 1, {}, GroupBundleDeploymentsPortlet$2_0);
_.onFailure = function onFailure_201(caught){
  debug('Error retrieving installed bundle deployments for group [' + this.val$groupId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_201(result){
  $onSuccess_190(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$groupId = 0;
function $clinit_GroupBundleDeploymentsPortlet$Factory(){
  $clinit_GroupBundleDeploymentsPortlet$Factory = nullMethod;
  INSTANCE_7 = new GroupBundleDeploymentsPortlet$Factory_0;
}

function GroupBundleDeploymentsPortlet$Factory_0(){
}

defineSeed(2501, 1, makeCastMap([Q$PortletViewFactory]), GroupBundleDeploymentsPortlet$Factory_0);
_.getInstance = function getInstance_1(context){
  if (($clinit_EntityContext$Type() , ResourceGroup) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new GroupBundleDeploymentsPortlet_0(context.groupId);
}
;
var INSTANCE_7;
function $clinit_GroupConfigurationUpdatesPortlet(){
  $clinit_GroupConfigurationUpdatesPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_2 = ($clinit_Enhanced() , 'Group: Configuration Updates');
  CONFIG_INCLUDE_0 = new ArrayList_0;
  $add_3(CONFIG_INCLUDE_0, 'METRIC_RANGE');
  $add_3(CONFIG_INCLUDE_0, 'METRIC_RANGE_BEGIN_END_FLAG');
  $add_3(CONFIG_INCLUDE_0, 'METRIC_RANGE_ENABLE');
  $add_3(CONFIG_INCLUDE_0, 'METRIC_RANGE_LASTN');
  $add_3(CONFIG_INCLUDE_0, 'METRIC_RANGE_UNIT');
  $add_3(CONFIG_INCLUDE_0, 'RESULT_COUNT');
  $add_3(CONFIG_INCLUDE_0, 'CONFIG_UPDATE_STATUS');
  updatedMapping = new HashMap_0;
  updatedMapping.putAll(($clinit_PortletConfigurationEditorComponent() , CONFIG_PROPERTY_INITIALIZATION));
}

function $configure_1(this$static, portletWindow, storedPortlet){
  var key, key$iterator, portletConfig;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  portletConfig = storedPortlet.configuration;
  for (key$iterator = $iterator($keySet(($clinit_PortletConfigurationEditorComponent() , CONFIG_PROPERTY_INITIALIZATION))); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$String);
    !dynamicCast(portletConfig.properties.get_2(key), Q$PropertySimple) && $indexOf_0(CONFIG_INCLUDE_0, key, 0) != -1 && $put_4(portletConfig, new PropertySimple_1(key, CONFIG_PROPERTY_INITIALIZATION.get_2(key)));
  }
}

function $refresh_7(this$static){
  this$static.currentlyLoading || this$static.loadData();
}

function GroupConfigurationUpdatesPortlet_0(context){
  $clinit_GroupConfigurationUpdatesPortlet();
  EnhancedVLayout_0.call(this);
  this.recentConfigurationContent = new Canvas_1;
  this.context = context;
}

defineSeed(2502, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), GroupConfigurationUpdatesPortlet_0);
_.configure = function configure_3(portletWindow, storedPortlet){
  $configure_1(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_1(){
  var customSettings, form, measurementRangeEditor, page, portletConfig, resultCountSelector, resultStatusSelector, storedPortlet, priorityFilter, stati, statusIcons, currentValue;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  customSettings = new DynamicForm_0;
  page = new EnhancedVLayout_0;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(5));
  resultStatusSelector = ($clinit_PortletConfigurationEditorComponent() , priorityFilter = new SelectItem_2('CONFIG_UPDATE_STATUS', 'Update Status') , $setWrapTitle(priorityFilter, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , $isCreated_2(priorityFilter)?$setProperty_6(priorityFilter, 'width', 335):(priorityFilter.jsObj['width'] = 335 , undefined) , $setMultiple(priorityFilter, TRUE) , $setAttribute_30(priorityFilter, 'multipleAppearance', ($clinit_MultipleAppearance() , PICKLIST).value_0) , stati = new LinkedHashMap_1(4) , $put_1(stati, ($clinit_ConfigurationUpdateStatus() , SUCCESS_2).name_0, 'Success') , $put_1(stati, INPROGRESS.name_0, 'In Progress') , $put_1(stati, NOCHANGE.name_0, 'No Change') , $put_1(stati, FAILURE_2.name_0, 'Failed') , statusIcons = new LinkedHashMap_1(3) , $put_1(statusIcons, SUCCESS_2.name_0, getResourceConfigurationIcon(SUCCESS_2)) , $put_1(statusIcons, INPROGRESS.name_0, getResourceConfigurationIcon(INPROGRESS)) , $put_1(statusIcons, NOCHANGE.name_0, getResourceConfigurationIcon(NOCHANGE)) , $put_1(statusIcons, FAILURE_2.name_0, getResourceConfigurationIcon(FAILURE_2)) , priorityFilter.setValueMap_0(stati) , $isCreated_2(priorityFilter)?$setProperty_7(priorityFilter, 'valueIcons', convertMapToJavascriptObject(statusIcons)):(priorityFilter.jsObj['valueIcons'] = convertMapToJavascriptObject(statusIcons) , undefined) , currentValue = $getSimpleValue(portletConfig, 'CONFIG_UPDATE_STATUS', '') , !currentValue.length || $split(currentValue, ',', 0).length == $VALUES_64.length?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_2.name_0, INPROGRESS.name_0, NOCHANGE.name_0, FAILURE_2.name_0])):$equalsIgnoreCase(currentValue, SUCCESS_2.name_0)?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_2.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,INPROGRESS,NOCHANGE,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_2.name_0, INPROGRESS.name_0, NOCHANGE.name_0, FAILURE_2.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,INPROGRESS,NOCHANGE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_2.name_0, INPROGRESS.name_0, NOCHANGE.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,INPROGRESS,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_2.name_0, INPROGRESS.name_0, FAILURE_2.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,INPROGRESS')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_2.name_0, INPROGRESS.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,NOCHANGE,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_2.name_0, NOCHANGE.name_0, FAILURE_2.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,NOCHANGE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_2.name_0, NOCHANGE.name_0])):$equalsIgnoreCase(currentValue, 'SUCCESS,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [SUCCESS_2.name_0, FAILURE_2.name_0])):$equalsIgnoreCase(currentValue, 'INPROGRESS')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [INPROGRESS.name_0])):$equalsIgnoreCase(currentValue, 'INPROGRESS,NOCHANGE,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [INPROGRESS.name_0, NOCHANGE.name_0, FAILURE_2.name_0])):$equalsIgnoreCase(currentValue, 'INPROGRESS,NOCHANGE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [INPROGRESS.name_0, NOCHANGE.name_0])):$equalsIgnoreCase(currentValue, 'INPROGRESS,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [INPROGRESS.name_0, FAILURE_2.name_0])):$equalsIgnoreCase(currentValue, 'NOCHANGE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [NOCHANGE.name_0])):$equalsIgnoreCase(currentValue, 'NOCHANGE,FAILURE')?priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [NOCHANGE.name_0, FAILURE_2.name_0])):$equalsIgnoreCase(currentValue, 'FAILURE') && priorityFilter.setValues(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [FAILURE_2.name_0])) , priorityFilter);
  resultCountSelector = getResultCountEditor(portletConfig);
  measurementRangeEditor = new CustomConfigMeasurementRangeEditor_0(portletConfig);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [resultStatusSelector, resultCountSelector]));
  $addSubmitValuesHandler(customSettings, new GroupConfigurationUpdatesPortlet$1_0(this, resultStatusSelector, portletConfig, resultCountSelector, measurementRangeEditor, storedPortlet));
  $markForRedraw(form);
  $addMember(page, measurementRangeEditor);
  $addMember(page, form);
  $addChild(customSettings, page);
  return customSettings;
}
;
_.getHelpCanvas = function getHelpCanvas_3(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet displays recent configuration changes consistent with configuration settings.'));
}
;
_.isRefreshing = function isRefreshing_2(){
  return this.currentlyLoading;
}
;
_.loadData = function loadData(){
  var criteria, portletConfig, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  criteria = new ResourceGroupCriteria_0;
  $addFilterId(criteria, valueOf_44(this.context.groupId));
  criteria.fetchConfigurationUpdates = false;
  criteria.fetchExplicitResources = false;
  criteria.fetchGroupDefinition = false;
  criteria.fetchOperationHistories = false;
  if ($isAutoCluster(this.context)) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  }
   else if ($isAutoGroup(this.context)) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addFilterPrivate(criteria, TRUE);
  }
  $findResourceGroupCompositesByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), criteria, new GroupConfigurationUpdatesPortlet$2_0(this, portletConfig));
}
;
_.onDestroy = function onDestroy_4(){
  onDestroy_0(this.refreshTimer);
}
;
_.onInit = function onInit_45(){
  this.currentlyLoading = true;
  $isCreated_1(this)?$setProperty_3(this, 'height', '*'):(this.config_0['height'] = '*' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setAttribute_24(this.recentConfigurationContent, 'height', '100%', true);
  $addMember(this, this.recentConfigurationContent);
  $markForRedraw(this);
  this.loadData();
}
;
_.refresh_0 = function refresh_11(){
  $refresh_7(this);
}
;
_.startRefreshCycle = function startRefreshCycle_3(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.context = null;
_.currentlyLoading = false;
_.groupComposite = null;
_.groupHistoryTable = null;
_.portletWindow = null;
_.refreshTimer = null;
var CONFIG_INCLUDE_0, NAME_2, updatedMapping;
function GroupConfigurationUpdatesPortlet$1_0(this$0, val$resultStatusSelector, val$portletConfig, val$resultCountSelector, val$measurementRangeEditor, val$storedPortlet){
  this.this$0 = this$0;
  this.val$resultStatusSelector = val$resultStatusSelector;
  this.val$portletConfig = val$portletConfig;
  this.val$resultCountSelector = val$resultCountSelector;
  this.val$measurementRangeEditor = val$measurementRangeEditor;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2503, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), GroupConfigurationUpdatesPortlet$1_0);
_.onSubmitValues = function onSubmitValues_1(event_0){
  var updatedConfig;
  updatedConfig = saveConfigUpdateStatusSelectorSettings(this.val$resultStatusSelector, this.val$portletConfig);
  updatedConfig = saveResultCounterSettings(this.val$resultCountSelector, updatedConfig);
  updatedConfig = saveMeasurementRangeEditorSettings(this.val$measurementRangeEditor, updatedConfig);
  $setConfiguration_0(this.val$storedPortlet, updatedConfig);
  $configure_1(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $refresh_7(this.this$0);
}
;
_.this$0 = null;
_.val$measurementRangeEditor = null;
_.val$portletConfig = null;
_.val$resultCountSelector = null;
_.val$resultStatusSelector = null;
_.val$storedPortlet = null;
function $onSuccess_191(this$static, results){
  var child, child$array, child$index, child$max, criteria, emptyGroup, filterResourceGroupIds, lastFive, zero;
  if (results.size_0 == 0) {
    emptyGroup = new ResourceGroup_2('');
    emptyGroup.id = -1;
    zero = new Long_0(P0_longLit);
    this$static.this$0.groupComposite = new ResourceGroupComposite_1(zero, zero, zero, zero, zero, zero, zero, zero, emptyGroup);
    this$static.this$0.groupHistoryTable = new GroupConfigurationUpdatesPortlet$GroupConfigurationHistoryCriteriaTable_0(this$static.this$0.groupComposite);
  }
   else {
    this$static.this$0.groupComposite = dynamicCast((checkIndex(0, results.size_0) , results.array[0]), Q$ResourceGroupComposite);
    lastFive = new PageControl_1(0, 5);
    criteria = new GroupResourceConfigurationUpdateCriteria_0;
    criteria.pageControlOverrides = lastFive;
    $addSortStatus(criteria, ($clinit_PageOrdering() , DESC));
    filterResourceGroupIds = new ArrayList_0;
    $add_3(filterResourceGroupIds, valueOf_44(this$static.this$0.context.groupId));
    criteria.filterResourceGroupIds = filterResourceGroupIds;
    this$static.this$0.groupHistoryTable = new GroupConfigurationUpdatesPortlet$GroupConfigurationHistoryCriteriaTable_0(this$static.this$0.groupComposite);
  }
  $setDataSource(this$static.this$0.groupHistoryTable, new GroupConfigurationUpdatesPortlet$GroupConfigurationUdpatesCriteriaDataSource_0(this$static.val$portletConfig, this$static.this$0.context.groupId));
  this$static.this$0.groupHistoryTable.showHeader = false;
  this$static.this$0.groupHistoryTable.showFooterRefresh = false;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentConfigurationContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.this$0.recentConfigurationContent, this$static.this$0.groupHistoryTable);
  this$static.this$0.recentConfigurationContent.markForRedraw_0();
  this$static.this$0.currentlyLoading = false;
}

function GroupConfigurationUpdatesPortlet$2_0(this$0, val$portletConfig){
  this.this$0 = this$0;
  this.val$portletConfig = val$portletConfig;
}

defineSeed(2504, 1, {}, GroupConfigurationUpdatesPortlet$2_0);
_.onFailure = function onFailure_202(caught){
  debug('Error retrieving resource group composite for group [' + this.this$0.context.groupId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_202(results){
  $onSuccess_191(this, dynamicCast(results, Q$PageList));
}
;
_.this$0 = null;
_.val$portletConfig = null;
function $clinit_GroupConfigurationUpdatesPortlet$Factory(){
  $clinit_GroupConfigurationUpdatesPortlet$Factory = nullMethod;
  INSTANCE_8 = new GroupConfigurationUpdatesPortlet$Factory_0;
}

function GroupConfigurationUpdatesPortlet$Factory_0(){
}

defineSeed(2505, 1, makeCastMap([Q$PortletViewFactory]), GroupConfigurationUpdatesPortlet$Factory_0);
_.getInstance = function getInstance_2(context){
  if (($clinit_EntityContext$Type() , ResourceGroup) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new GroupConfigurationUpdatesPortlet_0(context);
}
;
var INSTANCE_8;
function $getStatusHtmlString(record){
  var html, obj_0;
  html = null;
  obj_0 = dynamicCast(getAttributeAsObject(record.jsObj, 'object'), Q$AbstractConfigurationUpdate);
  switch (obj_0.status_0.ordinal) {
    case 1:
      {
        html = ($clinit_Enhanced() , 'This group configuration update was successful');
        break;
      }

    case 0:
      {
        html = '<p>' + ($clinit_Enhanced() , 'This group configuration update is still in progress') + '<\/p><p>View Member History for status of each individual resource<\/p>';
        break;
      }

    case 3:
      {
        html = ($clinit_Enhanced() , 'No changes were made to this group configuration');
        break;
      }

    case 2:
      {
        html = obj_0.errorMessage_0;
        if (html == null) {
          html = '<p>' + ($clinit_Enhanced() , 'This group configuration update failed') + '<\/p><p>View Member History for status of each individual resource<\/p>';
        }
         else {
          html.length > 80?(html = '<pre>' + html.substr(0, 80 - 0) + '...<\/pre><p>' + ($clinit_Enhanced() , 'Click the status icon for full details') + '<\/p>'):(html = '<pre>' + html + '<\/pre>');
          html = html + '<p>' + ($clinit_Enhanced() , 'View Member History for status of each individual resource') + '<\/p>';
        }
        break;
      }

  }
  return html;
}

function HistoryGroupResourceConfigurationTable_0(groupComposite){
  Table_2.call(this, ($clinit_Enhanced() , 'Group Resource Configuration History'));
  this.group = groupComposite.resourceGroup;
  this.groupPerms = groupComposite.resourcePermission;
  $setDataSource(this, new GroupResourceConfigurationDataSource_0(this.group.id));
}

defineSeed(2507, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), HistoryGroupResourceConfigurationTable_0);
_.configureTable = function configureTable_23(){
  var fieldDateCreated, fieldId, fieldLastUpdated, fieldStatus, fieldUser, listGrid, statusIcons;
  fieldId = new ListGridField_3('id', ($clinit_Enhanced() , 'Version'));
  fieldDateCreated = new ListGridField_3('createdTime', 'Date Created');
  fieldLastUpdated = new ListGridField_3('modifiedTime', 'Last Updated');
  fieldStatus = new ListGridField_3('status', 'Status');
  fieldUser = new ListGridField_3('subjectName', 'User');
  $clinit_TimestampCellFormatter();
  prepareDateField(fieldDateCreated, getAttribute(fieldDateCreated.jsObj, 'name'));
  prepareDateField(fieldLastUpdated, getAttribute(fieldLastUpdated.jsObj, 'name'));
  fieldId.jsObj['width'] = '10%';
  fieldDateCreated.jsObj['width'] = '35%';
  fieldLastUpdated.jsObj['width'] = '35%';
  fieldStatus.jsObj['width'] = '10%';
  fieldUser.jsObj['width'] = '*';
  $setAttribute_13(fieldStatus, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0);
  statusIcons = new HashMap_1(4);
  statusIcons.put(($clinit_ConfigurationUpdateStatus() , SUCCESS_2).name_0, getResourceConfigurationIcon(SUCCESS_2));
  statusIcons.put(FAILURE_2.name_0, getResourceConfigurationIcon(FAILURE_2));
  statusIcons.put(INPROGRESS.name_0, getResourceConfigurationIcon(INPROGRESS));
  statusIcons.put(NOCHANGE.name_0, getResourceConfigurationIcon(NOCHANGE));
  setAttribute_10(fieldStatus.jsObj, 'valueIcons', statusIcons);
  $addRecordClickHandler_0(fieldStatus, new HistoryGroupResourceConfigurationTable$1_0);
  $setAttribute_8(fieldStatus, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(fieldStatus, new HistoryGroupResourceConfigurationTable$2_0);
  listGrid = this.listGrid;
  $isCreated_1(listGrid)?$setProperty_2(listGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [fieldId, fieldDateCreated, fieldLastUpdated, fieldStatus, fieldUser]))):(listGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [fieldId, fieldDateCreated, fieldLastUpdated, fieldStatus, fieldUser])) , undefined);
  $addTableAction(this, 'Delete', 'Are You Sure?', null, new HistoryGroupResourceConfigurationTable$3_0(this, this.groupPerms.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE))?($clinit_TableActionEnablement() , ANY_1):($clinit_TableActionEnablement() , NEVER_1)));
  $addTableAction(this, 'View Settings', null, null, new HistoryGroupResourceConfigurationTable$4_0(this, ($clinit_TableActionEnablement() , SINGLE_0)));
  $addTableAction(this, 'View Member History', null, null, new HistoryGroupResourceConfigurationTable$5_0(this, SINGLE_0));
}
;
_.group = null;
_.groupPerms = null;
function GroupConfigurationUpdatesPortlet$GroupConfigurationHistoryCriteriaTable_0(groupComposite){
  $clinit_BaseWidget();
  HistoryGroupResourceConfigurationTable_0.call(this, groupComposite);
}

defineSeed(2506, 2507, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), GroupConfigurationUpdatesPortlet$GroupConfigurationHistoryCriteriaTable_0);
_.onInit = function onInit_46(){
  $onInit_1(this);
  this.listGrid.setEmptyMessage(($clinit_Enhanced() , 'No results found using specified criteria.'));
}
;
_.refreshTableInfo = function refreshTableInfo_1(){
  var count;
  $refreshTableInfo(this);
  if (this.tableInfo) {
    count = $getSelectedRecords(this.listGrid).length;
    $setContents_0(this.tableInfo, 'Matching Rows: ' + ($clinit_Enhanced() , '' + $getTotalRows(this.listGrid)) + ' (selected: ' + count + ')');
  }
}
;
function $copyValues_30(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_14(record, 'createdTime', new Date_2(from.createdTime));
  $setAttribute_14(record, 'modifiedTime', new Date_2(from.modifiedTime));
  $setAttribute_13(record, 'status', from.status_0.name_0);
  $setAttribute_13(record, 'subjectName', from.subjectName);
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  return record;
}

function GroupResourceConfigurationDataSource_0(groupId){
  $clinit_RPCDataSource();
  RPCDataSource_0.call(this);
  this.groupId_0 = groupId;
}

defineSeed(2509, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), GroupResourceConfigurationDataSource_0);
_.copyValues = function copyValues_50(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'object'), Q$GroupResourceConfigurationUpdate);
}
;
_.copyValues_0 = function copyValues_51(from){
  return $copyValues_30(dynamicCast(from, Q$GroupResourceConfigurationUpdate));
}
;
_.executeFetch = function executeFetch_26(request, response, criteria){
  this.executeFetch_2(request, response, dynamicCast(criteria, Q$GroupResourceConfigurationUpdateCriteria));
}
;
_.executeFetch_2 = function executeFetch_27(request, response, criteria){
  var configurationService;
  configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  $findGroupResourceConfigurationUpdatesByCriteria(configurationService, criteria, new GroupResourceConfigurationDataSource$1_0(this, response, request));
}
;
_.getFetchCriteria = function getFetchCriteria_30(request){
  return this.getFetchCriteria_3(request);
}
;
_.getFetchCriteria_3 = function getFetchCriteria_31(request){
  var criteria, groupIds, pageControl;
  criteria = new GroupResourceConfigurationUpdateCriteria_0;
  groupIds = new ArrayList_1(1);
  $add_3(groupIds, valueOf_44(this.groupId_0));
  criteria.filterResourceGroupIds = groupIds;
  pageControl = $getPageControl(this, request);
  $addDefaultOrderingField(pageControl, 'id', ($clinit_PageOrdering() , DESC));
  criteria.pageControlOverrides = pageControl;
  return criteria;
}
;
_.groupId_0 = 0;
function GroupConfigurationUpdatesPortlet$GroupConfigurationUdpatesCriteriaDataSource_0(portletConfig, groupId){
  $clinit_RPCDataSource();
  GroupResourceConfigurationDataSource_0.call(this, groupId);
  this.portletConfig = portletConfig;
  this.groupId = groupId;
}

defineSeed(2508, 2509, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), GroupConfigurationUpdatesPortlet$GroupConfigurationUdpatesCriteriaDataSource_0);
_.executeFetch_2 = function executeFetch_28(request, response, criteria){
  var configurationService;
  configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  $findGroupResourceConfigurationUpdatesByCriteria(configurationService, criteria, new GroupConfigurationUpdatesPortlet$GroupConfigurationUdpatesCriteriaDataSource$1_0(this, response, request));
}
;
_.getFetchCriteria_3 = function getFetchCriteria_32(request){
  var beginEnd, criteria, currentSetting, indx, isAdvanced, lastN, pageControl, parsedValues, priority, priority$index, priority$max, property, range, s, units, updateStatus;
  criteria = new GroupResourceConfigurationUpdateCriteria_0;
  $addFilterResourceGroupIds(criteria, new Arrays$ArrayList_0(initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.groupId)])));
  pageControl = new PageControl_1(0, valueOf_44(__parseAndValidateInt('5')).value_0);
  if (this.portletConfig) {
    property = $getSimple(this.portletConfig, 'METRIC_RANGE_ENABLE');
    if (!!property && ($clinit_Boolean() , (property.stringValue == null?null:$equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE).value_0?TRUE:FALSE).value_0) {
      isAdvanced = ($clinit_Boolean() , $equalsIgnoreCase('true', $getSimpleValue(this.portletConfig, 'METRIC_RANGE_BEGIN_END_FLAG', ($clinit_PortletConfigurationEditorComponent$Constant() , 'false')))?TRUE:FALSE).value_0;
      if (isAdvanced) {
        currentSetting = $getSimpleValue(this.portletConfig, 'METRIC_RANGE', '');
        range = $split(currentSetting, ',', 0);
        if (range.length == 2) {
          $addFilterStartTime(criteria, new Long_0(__parseAndValidateLong(range[0])));
          $addFilterEndTime(criteria, new Long_0(__parseAndValidateLong(range[1])));
        }
      }
       else {
        property = $getSimple(this.portletConfig, 'METRIC_RANGE_LASTN');
        if (property) {
          lastN = valueOf_44(__parseAndValidateInt($getSimpleValue(this.portletConfig, 'METRIC_RANGE_LASTN', '8'))).value_0;
          units = valueOf_44(__parseAndValidateInt($getSimpleValue(this.portletConfig, 'METRIC_RANGE_UNIT', '3'))).value_0;
          beginEnd = calculateTimeFrame(lastN, units);
          $addFilterStartTime(criteria, valueOf_45(dynamicCast((checkIndex(0, beginEnd.size_0) , beginEnd.array[0]), Q$Long).value_0));
          $addFilterEndTime(criteria, valueOf_45(dynamicCast((checkIndex(1, beginEnd.size_0) , beginEnd.array[1]), Q$Long).value_0));
        }
      }
    }
    currentSetting = $getSimpleValue(this.portletConfig, 'RESULT_COUNT', '5');
    !$trim(currentSetting).length?pageControl.setPageSize(valueOf_44(__parseAndValidateInt('5')).value_0):pageControl.setPageSize(valueOf_44(__parseAndValidateInt(currentSetting)).value_0);
    criteria.pageControlOverrides = pageControl;
    property = $getSimple(this.portletConfig, 'CONFIG_UPDATE_STATUS');
    if (property) {
      currentSetting = $getSimpleValue(this.portletConfig, 'CONFIG_UPDATE_STATUS', '');
      parsedValues = $split($trim(currentSetting), ',', 0);
      if (!$trim(currentSetting).length || parsedValues.length == ($clinit_ConfigurationUpdateStatus() , $clinit_ConfigurationUpdateStatus() , $VALUES_64).length)
      ;
      else {
        updateStatus = initDim(_3Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ConfigurationUpdateStatus, parsedValues.length, 0);
        indx = 0;
        for (priority$index = 0 , priority$max = parsedValues.length; priority$index < priority$max; ++priority$index) {
          priority = parsedValues[priority$index];
          s = ($clinit_ConfigurationUpdateStatus() , dynamicCast(valueOf(($clinit_ConfigurationUpdateStatus$Map() , $MAP_64), priority), Q$ConfigurationUpdateStatus));
          updateStatus[indx++] = s;
        }
        criteria.filterStatuses = getListIgnoringNulls(updateStatus);
      }
    }
  }
  return criteria;
}
;
_.groupId = 0;
_.portletConfig = null;
function $onSuccess_192(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$1, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function GroupConfigurationUpdatesPortlet$GroupConfigurationUdpatesCriteriaDataSource$1_0(this$1, val$response, val$request){
  this.this$1 = this$1;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2510, 1, {}, GroupConfigurationUpdatesPortlet$GroupConfigurationUdpatesCriteriaDataSource$1_0);
_.onFailure = function onFailure_203(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to get group resource config history'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$1, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_203(result){
  $onSuccess_192(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function $clinit_GroupEventsPortlet(){
  $clinit_GroupEventsPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_3 = ($clinit_Enhanced() , 'Group: Event Counts');
  CONFIG_INCLUDE_1 = new ArrayList_0;
  $add_3(CONFIG_INCLUDE_1, 'RESULT_COUNT');
  $add_3(CONFIG_INCLUDE_1, 'METRIC_RANGE');
  $add_3(CONFIG_INCLUDE_1, 'METRIC_RANGE_BEGIN_END_FLAG');
  $add_3(CONFIG_INCLUDE_1, 'METRIC_RANGE_ENABLE');
  $add_3(CONFIG_INCLUDE_1, 'METRIC_RANGE_LASTN');
  $add_3(CONFIG_INCLUDE_1, 'METRIC_RANGE_UNIT');
}

function $configure_2(this$static, portletWindow, storedPortlet){
  var key, key$iterator, portletConfig;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  portletConfig = storedPortlet.configuration;
  for (key$iterator = $iterator($keySet(($clinit_PortletConfigurationEditorComponent() , CONFIG_PROPERTY_INITIALIZATION))); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$String);
    !dynamicCast(portletConfig.properties.get_2(key), Q$PropertySimple) && $indexOf_0(CONFIG_INCLUDE_1, key, 0) != -1 && $put_4(portletConfig, new PropertySimple_1(key, CONFIG_PROPERTY_INITIALIZATION.get_2(key)));
  }
}

function $refresh_8(this$static){
  this$static.currentlyLoading || this$static.getRecentEventUpdates();
}

function GroupEventsPortlet_0(context){
  $clinit_GroupEventsPortlet();
  EnhancedVLayout_0.call(this);
  this.recentEventsContent = new Canvas_1;
  this.context = context;
  this.groupId = !context?-1:context.groupId;
}

defineSeed(2511, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), GroupEventsPortlet_0);
_.configure = function configure_4(portletWindow, storedPortlet){
  $configure_2(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_2(){
  var customSettings, measurementRangeEditor, page, portletConfig, storedPortlet;
  customSettings = new DynamicForm_0;
  page = new EnhancedVLayout_0;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  measurementRangeEditor = ($clinit_PortletConfigurationEditorComponent() , new CustomConfigMeasurementRangeEditor_0(portletConfig));
  $addSubmitValuesHandler(customSettings, new GroupEventsPortlet$1_0(this, measurementRangeEditor, portletConfig, storedPortlet));
  $addMember(page, measurementRangeEditor);
  $addChild(customSettings, page);
  return customSettings;
}
;
_.getHelpCanvas = function getHelpCanvas_4(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet displays Event counts consistent with display criteria configured.'));
}
;
_.getRecentEventUpdates = function getRecentEventUpdates(){
  var beginEnd, currentSetting, end, groupId, isAdvanced, lastN, portletConfig, property, range, start, storedPortlet, units;
  groupId = this.groupId;
  end = fromDouble(currentTimeMillis0());
  start = sub(end, P5265c00_longLit);
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  property = dynamicCast(portletConfig.properties.get_2('METRIC_RANGE_ENABLE'), Q$PropertySimple);
  if (!!property && ($clinit_Boolean() , (property.stringValue == null?null:$equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE).value_0?TRUE:FALSE).value_0) {
    isAdvanced = ($clinit_Boolean() , $equalsIgnoreCase('true', $getSimpleValue(portletConfig, 'METRIC_RANGE_BEGIN_END_FLAG', ($clinit_PortletConfigurationEditorComponent$Constant() , 'false')))?TRUE:FALSE).value_0;
    if (isAdvanced) {
      currentSetting = $getSimpleValue(portletConfig, 'METRIC_RANGE', '');
      range = $split(currentSetting, ',', 0);
      if (range.length == 2) {
        start = (new Long_0(__parseAndValidateLong(range[0]))).value_0;
        end = (new Long_0(__parseAndValidateLong(range[1]))).value_0;
      }
    }
     else {
      property = dynamicCast(portletConfig.properties.get_2('METRIC_RANGE_LASTN'), Q$PropertySimple);
      if (property) {
        lastN = valueOf_44(__parseAndValidateInt($getSimpleValue(portletConfig, 'METRIC_RANGE_LASTN', '8'))).value_0;
        units = valueOf_44(__parseAndValidateInt($getSimpleValue(portletConfig, 'METRIC_RANGE_UNIT', '3'))).value_0;
        beginEnd = calculateTimeFrame(lastN, units);
        start = valueOf_45(dynamicCast((checkIndex(0, beginEnd.size_0) , beginEnd.array[0]), Q$Long).value_0).value_0;
        end = valueOf_45(dynamicCast((checkIndex(1, beginEnd.size_0) , beginEnd.array[1]), Q$Long).value_0).value_0;
      }
    }
  }
  $getEventCountsBySeverityForGroup(dynamicCast(secure(getInstance_41(), -1), Q$EventGWTServiceAsync), groupId, start, end, new GroupEventsPortlet$2_0(this, groupId));
}
;
_.isRefreshing = function isRefreshing_3(){
  return this.currentlyLoading;
}
;
_.onDestroy = function onDestroy_5(){
  onDestroy_0(this.refreshTimer);
}
;
_.onInit = function onInit_47(){
  this.currentlyLoading = true;
  $setPadding(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
  $addMember(this, this.recentEventsContent);
  this.getRecentEventUpdates();
}
;
_.refresh_0 = function refresh_12(){
  $refresh_8(this);
}
;
_.startRefreshCycle = function startRefreshCycle_4(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.context = null;
_.currentlyLoading = false;
_.groupId = -1;
_.portletWindow = null;
_.refreshTimer = null;
var CONFIG_INCLUDE_1, NAME_3;
function GroupEventsPortlet$1_0(this$0, val$measurementRangeEditor, val$portletConfig, val$storedPortlet){
  this.this$0 = this$0;
  this.val$measurementRangeEditor = val$measurementRangeEditor;
  this.val$portletConfig = val$portletConfig;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2512, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), GroupEventsPortlet$1_0);
_.onSubmitValues = function onSubmitValues_2(event_0){
  var updatedConfig;
  updatedConfig = saveMeasurementRangeEditorSettings(this.val$measurementRangeEditor, this.val$portletConfig);
  $setConfiguration_0(this.val$storedPortlet, updatedConfig);
  $configure_2(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $refresh_8(this.this$0);
}
;
_.this$0 = null;
_.val$measurementRangeEditor = null;
_.val$portletConfig = null;
_.val$storedPortlet = null;
function $onSuccess_193(this$static, eventCounts){
  var child, child$array, child$index, child$max, column, count, iconItem, link, results, row, severity, severity$iterator, tuple, tuple$iterator;
  results = new ArrayList_0;
  for (severity$iterator = eventCounts.keySet_0().iterator(); severity$iterator.hasNext();) {
    severity = dynamicCast(severity$iterator.next_0(), Q$EventSeverity);
    count = dynamicCast(eventCounts.get_2(severity), Q$Integer).value_0;
    count > 0 && $add_3(results, new GwtTuple_0(severity, valueOf_44(count)));
  }
  column = new EnhancedVLayout_0;
  $isCreated_1(column)?$setProperty_0(column, 'height', 10):(column.config_0['height'] = 10 , undefined);
  if (results.size_0 == 0) {
    row = createEmptyDisplayRow(($clinit_AbstractActivityView() , RECENT_CRITERIA_EVENTS_NONE));
    $addMember(column, row);
  }
   else {
    for (tuple$iterator = new AbstractList$IteratorImpl_0(results); tuple$iterator.i < tuple$iterator.this$0_0.size_1();) {
      tuple = dynamicCast($next_0(tuple$iterator), Q$GwtTuple);
      row = new DynamicForm_0;
      $isCreated_1(row)?$setProperty_0(row, 'numCols', 2):(row.config_0['numCols'] = 2 , undefined);
      $isCreated_1(row)?$setProperty_0(row, 'width', 10):(row.config_0['width'] = 10 , undefined);
      iconItem = newTextItemIcon(getEventSeverityIcon(tuple.lefty), tuple.lefty.name_0);
      count = newTextItem('' + tuple.righty);
      row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [iconItem, count]));
      $addMember(column, row);
    }
    column.markForRedraw_0();
    row = new DynamicForm_0;
    link = getEntityTabLink(this$static.this$0.context, 'Events', 'History');
    addSeeMoreLink(row, link, column);
  }
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentEventsContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.this$0.recentEventsContent, column);
  this$static.this$0.recentEventsContent.markForRedraw_0();
  this$static.this$0.currentlyLoading = false;
  $markForRedraw(this$static.this$0);
}

function GroupEventsPortlet$2_0(this$0, val$groupId){
  this.this$0 = this$0;
  this.val$groupId = val$groupId;
}

defineSeed(2513, 1, {}, GroupEventsPortlet$2_0);
_.onFailure = function onFailure_204(caught){
  debug('Error retrieving recent event counts for group [' + this.val$groupId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_204(eventCounts){
  $onSuccess_193(this, dynamicCast(eventCounts, Q$Map));
}
;
_.this$0 = null;
_.val$groupId = 0;
function $clinit_GroupEventsPortlet$Factory(){
  $clinit_GroupEventsPortlet$Factory = nullMethod;
  INSTANCE_9 = new GroupEventsPortlet$Factory_0;
}

function GroupEventsPortlet$Factory_0(){
}

defineSeed(2514, 1, makeCastMap([Q$PortletViewFactory]), GroupEventsPortlet$Factory_0);
_.getInstance = function getInstance_3(context){
  if (($clinit_EntityContext$Type() , ResourceGroup) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new GroupEventsPortlet_0(context);
}
;
var INSTANCE_9;
function $clinit_GroupMetricsPortlet(){
  $clinit_GroupMetricsPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_4 = ($clinit_Enhanced() , 'Group: Metrics');
  CONFIG_INCLUDE_2 = new ArrayList_0;
  $add_3(CONFIG_INCLUDE_2, 'METRIC_RANGE');
  $add_3(CONFIG_INCLUDE_2, 'METRIC_RANGE_BEGIN_END_FLAG');
  $add_3(CONFIG_INCLUDE_2, 'METRIC_RANGE_ENABLE');
  $add_3(CONFIG_INCLUDE_2, 'METRIC_RANGE_LASTN');
  $add_3(CONFIG_INCLUDE_2, 'METRIC_RANGE_UNIT');
}

function $configure_3(this$static, portletWindow, storedPortlet){
  var key, key$iterator, portletConfig;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  portletConfig = storedPortlet.configuration;
  for (key$iterator = $iterator($keySet(($clinit_PortletConfigurationEditorComponent() , CONFIG_PROPERTY_INITIALIZATION))); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$String);
    !dynamicCast(portletConfig.properties.get_2(key), Q$PropertySimple) && $indexOf_0(CONFIG_INCLUDE_2, key, 0) != -1 && $put_4(portletConfig, new PropertySimple_1(key, CONFIG_PROPERTY_INITIALIZATION.get_2(key)));
  }
}

function $refresh_9(this$static){
  this$static.currentlyLoading || (this$static.currentlyLoading = true , this$static.getRecentMetrics());
}

function GroupMetricsPortlet_0(context){
  $clinit_GroupMetricsPortlet();
  EnhancedVLayout_0.call(this);
  this.recentMeasurementsContent = new Canvas_1;
  this.groupId = context.groupId;
  this.context = context;
}

defineSeed(2515, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), GroupMetricsPortlet_0);
_.configure = function configure_5(portletWindow, storedPortlet){
  $configure_3(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_3(){
  var customSettings, measurementRangeEditor, page, portletConfig, storedPortlet;
  customSettings = new DynamicForm_0;
  page = new EnhancedVLayout_0;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  measurementRangeEditor = ($clinit_PortletConfigurationEditorComponent() , new CustomConfigMeasurementRangeEditor_0(portletConfig));
  $addSubmitValuesHandler(customSettings, new GroupMetricsPortlet$1_0(this, measurementRangeEditor, portletConfig, storedPortlet));
  $addMember(page, measurementRangeEditor);
  $addChild(customSettings, page);
  return customSettings;
}
;
_.getHelpCanvas = function getHelpCanvas_5(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet graphs relevant recent metric data based on display criteria configured.'));
}
;
_.getRecentMetrics = function getRecentMetrics(){
  var child, child$array, child$index, child$max, column, criteria, currentSetting, isAdvanced, isAutoCluster, isAutoGroup, portletConfig, property, range, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  column = new VLayout_0;
  $isCreated_1(column)?$setProperty_0(column, 'height', 10):(column.config_0['height'] = 10 , undefined);
  this.end_0 = N1_longLit;
  this.start_0 = N1_longLit;
  this.lastN = -1;
  this.units = -1;
  property = dynamicCast(portletConfig.properties.get_2('METRIC_RANGE_ENABLE'), Q$PropertySimple);
  if (!!property && ($clinit_Boolean() , (property.stringValue == null?null:$equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE).value_0?TRUE:FALSE).value_0) {
    isAdvanced = ($clinit_Boolean() , $equalsIgnoreCase('true', $getSimpleValue(portletConfig, 'METRIC_RANGE_BEGIN_END_FLAG', ($clinit_PortletConfigurationEditorComponent$Constant() , 'false')))?TRUE:FALSE).value_0;
    if (isAdvanced) {
      currentSetting = $getSimpleValue(portletConfig, 'METRIC_RANGE', '');
      range = $split(currentSetting, ',', 0);
      if (range.length == 2) {
        this.start_0 = (new Long_0(__parseAndValidateLong(range[0]))).value_0;
        this.end_0 = (new Long_0(__parseAndValidateLong(range[1]))).value_0;
      }
    }
     else {
      property = dynamicCast(portletConfig.properties.get_2('METRIC_RANGE_LASTN'), Q$PropertySimple);
      if (property) {
        this.lastN = valueOf_44(__parseAndValidateInt($getSimpleValue(portletConfig, 'METRIC_RANGE_LASTN', '8'))).value_0;
        this.units = valueOf_44(__parseAndValidateInt($getSimpleValue(portletConfig, 'METRIC_RANGE_UNIT', '3'))).value_0;
      }
    }
  }
  criteria = new ResourceGroupCriteria_0;
  $addFilterId(criteria, valueOf_44(this.groupId));
  criteria.fetchConfigurationUpdates = false;
  criteria.fetchExplicitResources = false;
  criteria.fetchGroupDefinition = false;
  criteria.fetchOperationHistories = false;
  isAutoCluster = $isAutoCluster(this.context);
  isAutoGroup = $isAutoGroup(this.context);
  if (isAutoCluster) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  }
   else if (isAutoGroup) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addFilterPrivate(criteria, TRUE);
  }
  $findResourceGroupCompositesByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), criteria, new GroupMetricsPortlet$2_0(this, column, isAutoGroup));
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this.recentMeasurementsContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this.recentMeasurementsContent, column);
  this.recentMeasurementsContent.markForRedraw_0();
}
;
_.isRefreshing = function isRefreshing_4(){
  return this.currentlyLoading;
}
;
_.onDestroy = function onDestroy_6(){
  onDestroy_0(this.refreshTimer);
}
;
_.onInit = function onInit_48(){
  this.currentlyLoading = true;
  $setPadding(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
  $addMember(this, this.recentMeasurementsContent);
  this.currentlyLoading = true;
  this.getRecentMetrics();
}
;
_.refresh_0 = function refresh_13(){
  $refresh_9(this);
}
;
_.startRefreshCycle = function startRefreshCycle_5(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
  graphSparkLines();
  this.recentMeasurementsContent.markForRedraw_0();
}
;
_.context = null;
_.currentlyLoading = false;
_.end_0 = N1_longLit;
_.groupId = -1;
_.lastN = -1;
_.portletWindow = null;
_.refreshTimer = null;
_.start_0 = N1_longLit;
_.units = -1;
var CONFIG_INCLUDE_2, NAME_4;
function GroupMetricsPortlet$1_0(this$0, val$measurementRangeEditor, val$portletConfig, val$storedPortlet){
  this.this$0 = this$0;
  this.val$measurementRangeEditor = val$measurementRangeEditor;
  this.val$portletConfig = val$portletConfig;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2516, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), GroupMetricsPortlet$1_0);
_.onSubmitValues = function onSubmitValues_3(event_0){
  var updatedConfig;
  updatedConfig = saveMeasurementRangeEditorSettings(this.val$measurementRangeEditor, this.val$portletConfig);
  $setConfiguration_0(this.val$storedPortlet, updatedConfig);
  $configure_3(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $refresh_9(this.this$0);
}
;
_.this$0 = null;
_.val$measurementRangeEditor = null;
_.val$portletConfig = null;
_.val$storedPortlet = null;
function $onSuccess_194(this$static, results){
  var group, groupComposite, groupType, row;
  if (results.size_0 == 0) {
    row = createEmptyDisplayRow(($clinit_AbstractActivityView() , RECENT_MEASUREMENTS_GROUP_NONE));
    this$static.val$column.addMember_0(row);
    this$static.this$0.currentlyLoading = false;
  }
   else {
    groupComposite = dynamicCast((checkIndex(0, results.size_0) , results.array[0]), Q$ResourceGroupComposite);
    group = groupComposite.resourceGroup;
    if (group.groupCategory == ($clinit_GroupCategory() , COMPATIBLE)) {
      groupType = group.resourceType;
      $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(groupType.id), of_0(($clinit_ResourceTypeRepository$MetadataType() , content_1), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceTypeRepository$MetadataType, [operations_0, measurements_0, events_0, resourceConfigurationDefinition_0])), new GroupMetricsPortlet$2$1_0(this$static, group, this$static.val$column, this$static.val$isAutoGroup));
    }
  }
}

function GroupMetricsPortlet$2_0(this$0, val$column, val$isAutoGroup){
  this.this$0 = this$0;
  this.val$column = val$column;
  this.val$isAutoGroup = val$isAutoGroup;
}

defineSeed(2517, 1, {}, GroupMetricsPortlet$2_0);
_.onFailure = function onFailure_205(caught){
  debug('Error retrieving resource group composite for group [' + this.this$0.groupId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_205(results){
  $onSuccess_194(this, dynamicCast(results, Q$PageList));
}
;
_.this$0 = null;
_.val$column = null;
_.val$isAutoGroup = false;
function GroupMetricsPortlet$2$1_0(this$1, val$group, val$column, val$isAutoGroup){
  this.this$1 = this$1;
  this.val$group = val$group;
  this.val$column = val$column;
  this.val$isAutoGroup = val$isAutoGroup;
}

defineSeed(2518, 1, {}, GroupMetricsPortlet$2$1_0);
_.onTypesLoaded = function onTypesLoaded_9(type){
  var callback, definition, definition$iterator, definitionArrayIds, definitionToDisplay, definitionToDisplay$index, definitionToDisplay$max, definitions, displayOrder, index, measurementDefMap;
  $setResourceType_1(this.val$group, type);
  definitions = type.metricDefinitions;
  measurementDefMap = new HashMap_0;
  for (definition$iterator = definitions.iterator(); definition$iterator.hasNext();) {
    definition = dynamicCast(definition$iterator.next_0(), Q$MeasurementDefinition);
    measurementDefMap.put(definition.displayName, definition);
  }
  definitionArrayIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, definitions.size_1(), 1);
  displayOrder = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, definitions.size_1(), 0);
  $keySet(measurementDefMap).toArray_0(displayOrder);
  mergeSort(displayOrder, 0, displayOrder.length, ($clinit_Comparators() , $clinit_Comparators() , NATURAL));
  index = 0;
  for (definitionToDisplay$index = 0 , definitionToDisplay$max = displayOrder.length; definitionToDisplay$index < definitionToDisplay$max; ++definitionToDisplay$index) {
    definitionToDisplay = displayOrder[definitionToDisplay$index];
    definitionArrayIds[index++] = dynamicCast(measurementDefMap.get_2(definitionToDisplay), Q$MeasurementDefinition).id;
  }
  callback = new GroupMetricsPortlet$2$1$1_0(this, displayOrder, measurementDefMap, this.val$column, this.val$isAutoGroup);
  neq(this.this$1.this$0.end_0, N1_longLit) && neq(this.this$1.this$0.start_0, N1_longLit)?$findDataForCompatibleGroup(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this.this$1.this$0.groupId, definitionArrayIds, this.this$1.this$0.start_0, this.this$1.this$0.end_0, callback):this.this$1.this$0.lastN != -1 && this.this$1.this$0.units != -1?$findDataForCompatibleGroupForLast(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this.this$1.this$0.groupId, definitionArrayIds, this.this$1.this$0.lastN, this.this$1.this$0.units, callback):$findDataForCompatibleGroupForLast(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this.this$1.this$0.groupId, definitionArrayIds, 8, 3, callback);
}
;
_.this$1 = null;
_.val$column = null;
_.val$group = null;
_.val$isAutoGroup = false;
function $onSuccess_195(this$static, results){
  var commaDelimitedList, contents, convertedValue, d, d$iterator, data, graph, graphContainer, index, lastValue, link, md, minValue, row, someChartedData, title, value;
  if (results.isEmpty_0()) {
    row = createEmptyDisplayRow(($clinit_AbstractActivityView() , RECENT_MEASUREMENTS_GROUP_NONE));
    this$static.val$column.addMember_0(row);
  }
   else {
    someChartedData = false;
    for (index = 0; index < this$static.val$displayOrder.length; ++index) {
      md = dynamicCast(this$static.val$measurementDefMap.get_2(this$static.val$displayOrder[index]), Q$MeasurementDefinition);
      data = dynamicCast(results.get_0(index), Q$List);
      lastValue = -1;
      minValue = 1.7976931348623157E308;
      for (d$iterator = data.iterator(); d$iterator.hasNext();) {
        d = dynamicCast(d$iterator.next_0(), Q$MeasurementDataNumericHighLowComposite);
        if (!isNaN_0(d.value_0) && ('' + d.value_0).indexOf('NaN') == -1) {
          d.value_0 < minValue && (minValue = d.value_0);
          lastValue = d.value_0;
        }
      }
      commaDelimitedList = '';
      for (d$iterator = data.iterator(); d$iterator.hasNext();) {
        d = dynamicCast(d$iterator.next_0(), Q$MeasurementDataNumericHighLowComposite);
        !isNaN_0(d.value_0) && ('' + d.value_0).indexOf('NaN') == -1 && (commaDelimitedList += d.value_0 + ',');
      }
      row = new DynamicForm_0;
      $isCreated_1(row)?$setProperty_0(row, 'numCols', 3):(row.config_0['numCols'] = 3 , undefined);
      $setColWidths(row, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [valueOf_44(65), '*', valueOf_44(100)]));
      $isCreated_1(row)?$setProperty_3(row, 'width', '100%'):(row.config_0['width'] = '100%' , undefined);
      $isCreated_1(row)?$setProperty_0(row, 'height', 1):(row.config_0['height'] = 1 , undefined);
      $setAttribute_24(row, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, true);
      graph = new HTMLFlow_0;
      contents = "<span id='sparkline_" + index + "' class='dynamicsparkline' width='0' values='" + commaDelimitedList + "'>...<\/span>";
      $isCreated_1(graph)?$setProperty_3(graph, 'contents', contents):(graph.config_0['contents'] = contents , undefined);
      $setAttribute_24(graph, 'contentsType', ($clinit_ContentsType() , PAGE).value_0, false);
      $isCreated_1(graph)?$setProperty_0(graph, 'scrollbarSize', 0):(graph.config_0['scrollbarSize'] = 0 , undefined);
      graphContainer = new CanvasItem_0;
      graphContainer.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
      $isCreated_2(graphContainer)?$setProperty_6(graphContainer, 'height', 16):(graphContainer.jsObj['height'] = 16 , undefined);
      $isCreated_2(graphContainer)?$setProperty_6(graphContainer, 'width', 60):(graphContainer.jsObj['width'] = 60 , undefined);
      $setAttribute_28(graphContainer, 'canvas', !graph?null:$getOrCreateJsObj_0(graph));
      title = md.displayName;
      link = newLinkItem(title, null);
      $isCreated_2(link)?$setProperty_8(link, 'prompt', title):(link.jsObj['prompt'] = title , undefined);
      $setAttribute_30(link, 'titleVAlign', ($clinit_VerticalAlignment() , TOP_2).value_0);
      $setAttribute_30(link, 'align', ($clinit_Alignment() , LEFT_0).value_0);
      $setAttribute_29(link, 'clipValue', TRUE);
      $setAttribute_29(link, 'wrap', TRUE);
      $isCreated_2(link)?$setProperty_6(link, 'height', 26):(link.jsObj['height'] = 26 , undefined);
      isBrowserPreIE9()?$setDisabled_2(link, TRUE):$addClickHandler_2(link, new GroupMetricsPortlet$2$1$1$1_0(this$static, title, md, this$static.val$isAutoGroup));
      convertedValue = convertLastValueForDisplay(lastValue, md);
      value = newTextItem(convertedValue);
      $setAttribute_30(value, 'vAlign', TOP_2.value_0);
      $setAttribute_30(value, 'align', RIGHT_0.value_0);
      $setWidth_2(value, '100%');
      row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [graphContainer, link, value]));
      $isCreated_1(row)?$setProperty_3(row, 'width', '100%'):(row.config_0['width'] = '100%' , undefined);
      if ($trim(md.name_0).indexOf('Trait.') == -1 && lastValue != -1) {
        this$static.val$column.addMember_0(row);
        someChartedData = true;
      }
    }
    if (someChartedData) {
      row = new DynamicForm_0;
      link = getEntityTabLink(this$static.this$2.this$1.this$0.context, 'Monitoring', 'Graphs');
      addSeeMoreLink(row, link, this$static.val$column);
    }
     else {
      row = createEmptyDisplayRow(($clinit_AbstractActivityView() , RECENT_MEASUREMENTS_GROUP_NONE));
      this$static.val$column.addMember_0(row);
    }
    graphSparkLines();
  }
  this$static.this$2.this$1.this$0.currentlyLoading = false;
}

function GroupMetricsPortlet$2$1$1_0(this$2, val$displayOrder, val$measurementDefMap, val$column, val$isAutoGroup){
  this.this$2 = this$2;
  this.val$displayOrder = val$displayOrder;
  this.val$measurementDefMap = val$measurementDefMap;
  this.val$column = val$column;
  this.val$isAutoGroup = val$isAutoGroup;
}

defineSeed(2519, 1, {}, GroupMetricsPortlet$2$1$1_0);
_.onFailure = function onFailure_206(caught){
  debug('Error retrieving recent metrics charting data for group [' + this.this$2.this$1.this$0.groupId + ']:' + caught.getMessage());
  this.this$2.this$1.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_206(results){
  $onSuccess_195(this, dynamicCast(results, Q$List));
}
;
_.this$2 = null;
_.val$column = null;
_.val$displayOrder = null;
_.val$isAutoGroup = false;
_.val$measurementDefMap = null;
function GroupMetricsPortlet$2$1$1$1_0(this$3, val$title, val$md, val$isAutoGroup){
  this.this$3 = this$3;
  this.val$title = val$title;
  this.val$md = val$md;
  this.val$isAutoGroup = val$isAutoGroup;
}

defineSeed(2520, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), GroupMetricsPortlet$2$1$1$1_0);
_.onClick_0 = function onClick_110(event_0){
  var graph, window_0;
  window_0 = new AbstractActivityView$ChartViewWindow_0(this.val$title);
  graph = new CompositeGroupMultiLineGraphListView_0(this.this$3.this$2.this$1.this$0.groupId, this.val$md.id, this.val$isAutoGroup);
  $addItem(window_0, graph);
  $populateData(graph);
  $show(window_0);
}
;
_.this$3 = null;
_.val$isAutoGroup = false;
_.val$md = null;
_.val$title = null;
function $clinit_GroupMetricsPortlet$Factory(){
  $clinit_GroupMetricsPortlet$Factory = nullMethod;
  INSTANCE_10 = new GroupMetricsPortlet$Factory_0;
}

function GroupMetricsPortlet$Factory_0(){
}

defineSeed(2521, 1, makeCastMap([Q$PortletViewFactory]), GroupMetricsPortlet$Factory_0);
_.getInstance = function getInstance_4(context){
  if (($clinit_EntityContext$Type() , ResourceGroup) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new GroupMetricsPortlet_0(context);
}
;
var INSTANCE_10;
function $clinit_GroupOobsPortlet(){
  $clinit_GroupOobsPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_5 = ($clinit_Enhanced() , 'Group: OOB Conditions');
  CONFIG_INCLUDE_3 = new ArrayList_0;
  $add_3(CONFIG_INCLUDE_3, 'RESULT_COUNT');
}

function $configure_4(this$static, portletWindow, storedPortlet){
  var key, key$iterator, portletConfig;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  portletConfig = storedPortlet.configuration;
  for (key$iterator = $iterator($keySet(($clinit_PortletConfigurationEditorComponent() , CONFIG_PROPERTY_INITIALIZATION))); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$String);
    !dynamicCast(portletConfig.properties.get_2(key), Q$PropertySimple) && $indexOf_0(CONFIG_INCLUDE_3, key, 0) != -1 && $put_4(portletConfig, new PropertySimple_1(key, CONFIG_PROPERTY_INITIALIZATION.get_2(key)));
  }
}

function $refresh_10(this$static){
  this$static.currentlyLoading || (this$static.currentlyLoading = true , this$static.getRecentOobs());
}

function GroupOobsPortlet_0(groupId){
  $clinit_GroupOobsPortlet();
  EnhancedVLayout_0.call(this);
  this.recentOobContent = new Canvas_1;
  this.groupId = groupId;
}

defineSeed(2522, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), GroupOobsPortlet_0);
_.configure = function configure_6(portletWindow, storedPortlet){
  $configure_4(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_4(){
  var customSettings, form, page, portletConfig, resultCountSelector, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  customSettings = new DynamicForm_0;
  page = new EnhancedVLayout_0;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(5));
  resultCountSelector = getResultCountEditor(portletConfig);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [resultCountSelector]));
  $addSubmitValuesHandler(customSettings, new GroupOobsPortlet$1_0(this, resultCountSelector, portletConfig, storedPortlet));
  $addMember(page, form);
  $addChild(customSettings, page);
  return customSettings;
}
;
_.getHelpCanvas = function getHelpCanvas_6(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet displays OOB(Out of Bound) metric conditions.'));
}
;
_.getRecentOobs = function getRecentOobs(){
  var currentSetting, groupId, portletConfig, property, resultCount, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  groupId = this.groupId;
  resultCount = 5;
  property = dynamicCast(portletConfig.properties.get_2('RESULT_COUNT'), Q$PropertySimple);
  if (property) {
    currentSetting = property.stringValue;
    !$trim(currentSetting).length || $equalsIgnoreCase(currentSetting, '5')?(resultCount = 5):(resultCount = valueOf_44(__parseAndValidateInt(currentSetting)).value_0);
  }
  $getHighestNOOBsForGroup(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), groupId, resultCount, new GroupOobsPortlet$2_0(this, groupId));
}
;
_.isRefreshing = function isRefreshing_5(){
  return this.currentlyLoading;
}
;
_.onDestroy = function onDestroy_7(){
  onDestroy_0(this.refreshTimer);
}
;
_.onInit = function onInit_49(){
  $setPadding(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
  $addMember(this, this.recentOobContent);
  this.currentlyLoading = true;
  this.getRecentOobs();
}
;
_.refresh_0 = function refresh_14(){
  $refresh_10(this);
}
;
_.startRefreshCycle = function startRefreshCycle_6(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
  this.recentOobContent.markForRedraw_0();
  $markForRedraw(this);
}
;
_.currentlyLoading = false;
_.groupId = -1;
_.portletWindow = null;
_.refreshTimer = null;
var CONFIG_INCLUDE_3, NAME_5;
function GroupOobsPortlet$1_0(this$0, val$resultCountSelector, val$portletConfig, val$storedPortlet){
  this.this$0 = this$0;
  this.val$resultCountSelector = val$resultCountSelector;
  this.val$portletConfig = val$portletConfig;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2523, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), GroupOobsPortlet$1_0);
_.onSubmitValues = function onSubmitValues_4(event_0){
  var updatedConfig;
  updatedConfig = saveResultCounterSettings(this.val$resultCountSelector, this.val$portletConfig);
  $setConfiguration_0(this.val$storedPortlet, updatedConfig);
  $configure_4(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $refresh_10(this.this$0);
}
;
_.this$0 = null;
_.val$portletConfig = null;
_.val$resultCountSelector = null;
_.val$storedPortlet = null;
function $onSuccess_196(this$static, result){
  var child, child$array, child$index, child$max, column, destination, link, oob, oob$iterator, row, time, title;
  column = new VLayout_0;
  $isCreated_1(column)?$setProperty_0(column, 'height', 10):(column.config_0['height'] = 10 , undefined);
  if (result.size_0 == 0) {
    row = createEmptyDisplayRow(($clinit_AbstractActivityView() , RECENT_OOB_NONE));
    column.addMember_0(row);
  }
   else {
    for (oob$iterator = new AbstractList$IteratorImpl_0(result); oob$iterator.i < oob$iterator.this$0_0.size_1();) {
      oob = dynamicCast($next_0(oob$iterator), Q$MeasurementOOBComposite);
      row = new DynamicForm_0;
      $isCreated_1(row)?$setProperty_0(row, 'numCols', 2):(row.config_0['numCols'] = 2 , undefined);
      title = oob.scheduleName;
      destination = '/resource/common/monitor/Visibility.do?m=' + oob.definitionId + '&groupId=' + this$static.val$groupId + '&mode=chartSingleMetricSingleResource';
      link = newLinkItem(title, destination);
      $addClickHandler_2(link, new GroupOobsPortlet$2$1_0(title, destination));
      time = newTextItem(format_90(oob.timestamp));
      row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [link, time]));
      column.addMember_0(row);
    }
  }
  this$static.this$0.recentOobContent.setContents('');
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentOobContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.this$0.recentOobContent, column);
  this$static.this$0.recentOobContent.markForRedraw_0();
  this$static.this$0.currentlyLoading = false;
  $markForRedraw(this$static.this$0);
}

function GroupOobsPortlet$2_0(this$0, val$groupId){
  this.this$0 = this$0;
  this.val$groupId = val$groupId;
}

defineSeed(2524, 1, {}, GroupOobsPortlet$2_0);
_.onFailure = function onFailure_207(caught){
  debug('Error retrieving recent out of bound metrics for group [' + this.val$groupId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_207(result){
  $onSuccess_196(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$groupId = 0;
function GroupOobsPortlet$2$1_0(val$title, val$destination){
  this.val$title = val$title;
  this.val$destination = val$destination;
}

defineSeed(2525, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), GroupOobsPortlet$2$1_0);
_.onClick_0 = function onClick_111(event_0){
  var iframe, window_0;
  window_0 = new AbstractActivityView$ChartViewWindow_0(this.val$title);
  iframe = new FullHTMLPane_0(this.val$destination);
  $addItem(window_0, iframe);
  $show(window_0);
}
;
_.val$destination = null;
_.val$title = null;
function $clinit_GroupOobsPortlet$Factory(){
  $clinit_GroupOobsPortlet$Factory = nullMethod;
  INSTANCE_11 = new GroupOobsPortlet$Factory_0;
}

function GroupOobsPortlet$Factory_0(){
}

defineSeed(2526, 1, makeCastMap([Q$PortletViewFactory]), GroupOobsPortlet$Factory_0);
_.getInstance = function getInstance_5(context){
  if (($clinit_EntityContext$Type() , ResourceGroup) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new GroupOobsPortlet_0(context.groupId);
}
;
var INSTANCE_11;
function $addDataSourceFields_1(){
  var createdTimeField, fields, idField, nameField, startedTimeField, statusField, subjectField;
  fields = new ArrayList_0;
  idField = new DataSourceIntegerField_1('id', 'ID');
  $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  setCheck(fields.array, fields.size_0++, idField);
  nameField = new DataSourceTextField_1('operationName', 'Operation Name');
  setCheck(fields.array, fields.size_0++, nameField);
  statusField = new DataSourceTextField_1('status', 'Status');
  setCheck(fields.array, fields.size_0++, statusField);
  createdTimeField = new DataSourceDateTimeField_0('createdTime', 'Created Time');
  setCheck(fields.array, fields.size_0++, createdTimeField);
  startedTimeField = new DataSourceDateTimeField_0('startedTime', 'Started Time');
  setCheck(fields.array, fields.size_0++, startedTimeField);
  subjectField = new DataSourceTextField_1('subjectName', 'Requester');
  setCheck(fields.array, fields.size_0++, subjectField);
  return fields;
}

function $copyValues_31(this$static, from){
  var operationHistory;
  operationHistory = this$static.createOperationHistory();
  $setId_2(operationHistory, getAttributeAsInt(from.jsObj, 'id').value_0);
  return operationHistory;
}

function $copyValues_32(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_14(record, 'createdTime', convertTimestampToDate(valueOf_45(from.createdTime)));
  $setAttribute_14(record, 'startedTime', convertTimestampToDate(valueOf_45(from.startedTime)));
  $setAttribute_4(record, 'duration', $getDuration(from));
  $setAttribute_13(record, 'subjectName', from.subjectName);
  $setAttribute_12(record, 'operationDefinition', from.operationDefinition);
  $setAttribute_13(record, 'operationName', from.operationDefinition.displayName);
  $setAttribute_13(record, 'errorMessage', from.errorMessage_0);
  $setAttribute_13(record, 'status', from.status_0.name_0);
  $setAttribute_12(record, 'parameters', from.parameters);
  return record;
}

function AbstractOperationHistoryDataSource_0(){
  var fields;
  RPCDataSource_0.call(this);
  this.operationService = dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync);
  fields = this.addDataSourceFields();
  $addFields(this, fields);
}

defineSeed(2529, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractOperationHistoryDataSource]));
_.addDataSourceFields = function addDataSourceFields_1(){
  return $addDataSourceFields_1();
}
;
_.copyValues = function copyValues_52(from){
  return $copyValues_31(this, from);
}
;
_.copyValues_0 = function copyValues_53(from){
  return this.copyValues_3(dynamicCast(from, Q$OperationHistory));
}
;
_.copyValues_3 = function copyValues_54(from){
  return $copyValues_32(from);
}
;
_.executeRemove = function executeRemove_2(recordToRemove, request, response){
  var force, forceValue, operationHistoryToRemove;
  operationHistoryToRemove = $copyValues_31(this, recordToRemove);
  forceValue = ($clinit_Boolean() , getAttributeAsBoolean(request.jsObj, 'force')?TRUE:FALSE);
  force = !!forceValue && forceValue.value_0;
  $deleteOperationHistory(this.operationService, operationHistoryToRemove.id, force, new AbstractOperationHistoryDataSource$1_0(this, request, response, operationHistoryToRemove));
}
;
function $copyValues_33(this$static, from){
  var record;
  record = $copyValues_32(from);
  $setAttribute_12(record, 'group', from.group);
  return record;
}

function GroupOperationHistoryDataSource_0(){
  $clinit_RPCDataSource();
  AbstractOperationHistoryDataSource_0.call(this);
}

defineSeed(2528, 2529, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractOperationHistoryDataSource]), GroupOperationHistoryDataSource_0);
_.copyValues_3 = function copyValues_55(from){
  return $copyValues_33(this, dynamicCast(from, Q$GroupOperationHistory));
}
;
_.createOperationHistory = function createOperationHistory(){
  return new GroupOperationHistory_1;
}
;
_.executeFetch = function executeFetch_29(request, response, criteria){
  this.executeFetch_3(request, response, dynamicCast(criteria, Q$GroupOperationHistoryCriteria));
}
;
_.executeFetch_3 = function executeFetch_30(request, response, criteria){
  $findGroupOperationHistoriesByCriteria(this.operationService, criteria, new GroupOperationHistoryDataSource$1_0(this, response, request));
}
;
_.getFetchCriteria = function getFetchCriteria_33(request){
  return this.getFetchCriteria_4(request);
}
;
_.getFetchCriteria_4 = function getFetchCriteria_34(request){
  var criteria, groupId;
  criteria = new GroupOperationHistoryCriteria_0;
  if (convertToMap($getCriteria(request).jsObj).containsKey('groupId')) {
    groupId = __parseAndValidateInt(dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('groupId'), Q$String));
    $addFilterResourceGroupIds_3(criteria, new Arrays$ArrayList_0(initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(groupId)])));
  }
  return criteria;
}
;
function $setPortletConfig(this$static, portletConfig){
  this$static.portletConfig = portletConfig;
}

function GroupOperationsCriteriaDataSource_0(portletConfig){
  $clinit_RPCDataSource();
  GroupOperationHistoryDataSource_0.call(this);
  this.portletConfig = portletConfig;
}

defineSeed(2527, 2528, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$GroupOperationsCriteriaDataSource, Q$AbstractOperationHistoryDataSource]), GroupOperationsCriteriaDataSource_0);
_.executeFetch_3 = function executeFetch_31(request, response, criteria){
  $findGroupOperationHistoriesByCriteria(this.operationService, criteria, new GroupOperationsCriteriaDataSource$1_0(this, response, request));
}
;
_.getFetchCriteria_4 = function getFetchCriteria_35(request){
  var beginEnd, criteria, currentSetting, groupId, indx, isAdvanced, lastN, operationStati, pageControl, parsedValues, priority, priority$index, priority$max, property, range, s, units;
  criteria = new GroupOperationHistoryCriteria_0;
  if (convertToMap($getCriteria(request).jsObj).containsKey('groupId')) {
    groupId = __parseAndValidateInt(dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('groupId'), Q$String));
    $addFilterResourceGroupIds_3(criteria, new Arrays$ArrayList_0(initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(groupId)])));
  }
  pageControl = new PageControl_1(0, valueOf_44(__parseAndValidateInt('5')).value_0);
  if (this.portletConfig) {
    property = $getSimple(this.portletConfig, 'METRIC_RANGE_ENABLE');
    if (!!property && ($clinit_Boolean() , (property.stringValue == null?null:$equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE).value_0?TRUE:FALSE).value_0) {
      isAdvanced = ($clinit_Boolean() , $equalsIgnoreCase('true', $getSimpleValue(this.portletConfig, 'METRIC_RANGE_BEGIN_END_FLAG', ($clinit_PortletConfigurationEditorComponent$Constant() , 'false')))?TRUE:FALSE).value_0;
      if (isAdvanced) {
        currentSetting = $getSimpleValue(this.portletConfig, 'METRIC_RANGE', '');
        range = $split(currentSetting, ',', 0);
        if (range.length == 2) {
          $addFilterStartTime_3(criteria, new Long_0(__parseAndValidateLong(range[0])));
          $addFilterEndTime_4(criteria, new Long_0(__parseAndValidateLong(range[1])));
        }
      }
       else {
        property = $getSimple(this.portletConfig, 'METRIC_RANGE_LASTN');
        if (property) {
          lastN = valueOf_44(__parseAndValidateInt($getSimpleValue(this.portletConfig, 'METRIC_RANGE_LASTN', '8')));
          units = valueOf_44(__parseAndValidateInt($getSimpleValue(this.portletConfig, 'METRIC_RANGE_UNIT', '3')));
          beginEnd = calculateTimeFrame(lastN.value_0, units.value_0);
          $addFilterStartTime_3(criteria, valueOf_45(dynamicCast((checkIndex(0, beginEnd.size_0) , beginEnd.array[0]), Q$Long).value_0));
          $addFilterEndTime_4(criteria, valueOf_45(dynamicCast((checkIndex(1, beginEnd.size_0) , beginEnd.array[1]), Q$Long).value_0));
        }
      }
    }
    currentSetting = $getSimpleValue(this.portletConfig, 'RESULT_COUNT', '5');
    !$trim(currentSetting).length?pageControl.setPageSize(valueOf_44(__parseAndValidateInt('5')).value_0):pageControl.setPageSize(valueOf_44(__parseAndValidateInt(currentSetting)).value_0);
    criteria.pageControlOverrides = pageControl;
    property = $getSimple(this.portletConfig, 'OPERATION_STATUS');
    if (property) {
      currentSetting = $getSimpleValue(this.portletConfig, 'OPERATION_STATUS', '');
      parsedValues = $split($trim(currentSetting), ',', 0);
      if (!$trim(currentSetting).length || parsedValues.length == ($clinit_OperationRequestStatus() , $clinit_OperationRequestStatus() , $VALUES_96).length)
      ;
      else {
        operationStati = initDim(_3Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$OperationRequestStatus_$1]), Q$OperationRequestStatus, parsedValues.length, 0);
        indx = 0;
        for (priority$index = 0 , priority$max = parsedValues.length; priority$index < priority$max; ++priority$index) {
          priority = parsedValues[priority$index];
          s = ($clinit_OperationRequestStatus() , dynamicCast(valueOf(($clinit_OperationRequestStatus$Map() , $MAP_96), priority), Q$OperationRequestStatus));
          operationStati[indx++] = s;
        }
        criteria.filterStatuses = getListIgnoringNulls(operationStati);
      }
    }
  }
  return criteria;
}
;
_.portletConfig = null;
function $onSuccess_197(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function GroupOperationsCriteriaDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2530, 1, {}, GroupOperationsCriteriaDataSource$1_0);
_.onFailure = function onFailure_208(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failure loading operation histories.'), caught);
}
;
_.onSuccess_0 = function onSuccess_208(result){
  $onSuccess_197(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $createStartedTimeField(){
  var startedTimeField;
  startedTimeField = new ListGridField_1('startedTime');
  $setAttribute_13(startedTimeField, 'align', ($clinit_Alignment() , LEFT_0).value_0);
  $setAttribute_13(startedTimeField, 'cellAlign', LEFT_0.value_0);
  $setCellFormatter_0(startedTimeField, new AbstractOperationHistoryListView$4_0);
  $setAttribute_8(startedTimeField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(startedTimeField, ($clinit_TimestampCellFormatter() , new TimestampCellFormatter$1_0('startedTime')));
  return startedTimeField;
}

function $createStatusField(){
  var statusField;
  statusField = new ListGridField_1('status');
  $setAttribute_13(statusField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_13(statusField, 'cellAlign', CENTER_0.value_0);
  $setAttribute_8(statusField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(statusField, new AbstractOperationHistoryListView$5_0);
  $setCellFormatter_0(statusField, new AbstractOperationHistoryListView$6_0);
  $addRecordClickHandler_0(statusField, new AbstractOperationHistoryListView$7_0);
  statusField.jsObj['width'] = 44;
  return statusField;
}

function $deleteSelectedRecords_0(this$static, requestProperties){
  var failureIds, force, forceValue, numberOfRecordsToBeDeleted, operationHistoryToRemove, record, record$index, record$max, recordsToBeDeleted, successIds;
  recordsToBeDeleted = $getSelectedRecords(this$static.listGrid);
  numberOfRecordsToBeDeleted = recordsToBeDeleted.length;
  forceValue = ($clinit_Boolean() , !!requestProperties && (getAttributeAsBoolean(requestProperties.jsObj, 'force')?TRUE:FALSE).value_0?TRUE:FALSE);
  force = !!forceValue && forceValue.value_0;
  successIds = new ArrayList_0;
  failureIds = new ArrayList_0;
  for (record$index = 0 , record$max = recordsToBeDeleted.length; record$index < record$max; ++record$index) {
    record = recordsToBeDeleted[record$index];
    operationHistoryToRemove = $copyValues_31(dynamicCast(this$static.dataSource_1, Q$AbstractOperationHistoryDataSource), record);
    $deleteOperationHistory(dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync), operationHistoryToRemove.id, force, new AbstractOperationHistoryListView$10_0(this$static, successIds, operationHistoryToRemove, failureIds, numberOfRecordsToBeDeleted));
  }
}

function $handleCompletion(this$static, successIds, failureIds, numberOfRecordsToBeDeleted){
  if (successIds.size_0 + failureIds.size_0 == numberOfRecordsToBeDeleted) {
    successIds.size_0 == numberOfRecordsToBeDeleted?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0('Deleted ' + numberOfRecordsToBeDeleted + ' operation history items.')):$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0('Deleted ' + successIds.size_0 + ' operation history items, but failed to delete the items with the following IDs: ' + failureIds));
    $refresh(this$static, false);
  }
}

function AbstractOperationHistoryListView_0(dataSource, criteria){
  Table_3.call(this, null, criteria);
  this.dataSource_1 = dataSource;
}

defineSeed(2533, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_24(){
  var fields, sortSpec;
  fields = this.createFields();
  $setListGridFields(this, false, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  sortSpec = new SortSpecifier_0('startedTime', ($clinit_SortDirection() , DESCENDING));
  $setSort(this.listGrid, initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [sortSpec]));
  $addTableAction(this, ($clinit_Enhanced() , 'Cancel'), 'Are you sure you want to cancel the selected operations? NOTE: Only those selected operations that are currently "in progress" will be attempted to be canceled.', null, new AbstractOperationHistoryListView$1_0(this));
  $addTableAction(this, 'Delete', 'Are you sure you want to delete the # selected items?', null, new AbstractOperationHistoryListView$2_0(this));
  $addTableAction(this, 'Force Delete', 'Are you sure you want to delete the # selected items?', null, new AbstractOperationHistoryListView$3_0(this));
  $configureTable(this);
}
;
_.createFields = function createFields(){
  var fields, idField, opNameField, startedTimeField, statusField, subjectField;
  fields = new ArrayList_0;
  idField = new ListGridField_1('id');
  idField.jsObj['width'] = 38;
  setCheck(fields.array, fields.size_0++, idField);
  opNameField = new ListGridField_1('operationName');
  opNameField.jsObj['width'] = '34%';
  setCheck(fields.array, fields.size_0++, opNameField);
  subjectField = new ListGridField_1('subjectName');
  subjectField.jsObj['width'] = '33%';
  setCheck(fields.array, fields.size_0++, subjectField);
  statusField = $createStatusField();
  setCheck(fields.array, fields.size_0++, statusField);
  startedTimeField = $createStartedTimeField();
  startedTimeField.jsObj['width'] = '33%';
  setCheck(fields.array, fields.size_0++, startedTimeField);
  return fields;
}
;
_.getDetailsLinkColumnName = function getDetailsLinkColumnName_1(){
  return 'operationName';
}
;
function GroupOperationHistoryListView_0(groupComposite){
  $clinit_BaseWidget();
  AbstractOperationHistoryListView_0.call(this, new GroupOperationHistoryDataSource_0, new Criteria_2('groupId', '' + groupComposite.resourceGroup.id));
  this.groupComposite = groupComposite;
}

defineSeed(2532, 2533, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), GroupOperationHistoryListView_0);
_.getDetailsView_0 = function getDetailsView_15(id){
  return new GroupOperationHistoryDetailsView_0(this.groupComposite);
}
;
_.hasControlPermission_1 = function hasControlPermission_0(){
  return this.groupComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONTROL_0));
}
;
_.groupComposite = null;
function GroupOperationsCriteriaHistoryListView_0(dataSource, composite, isAutogroup){
  $clinit_BaseWidget();
  GroupOperationHistoryListView_0.call(this, composite);
  this.dataSource_1 = dataSource;
  this.composite = composite;
  this.isAutogroup = isAutogroup;
  this.showFooterRefresh = false;
}

defineSeed(2531, 2532, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), GroupOperationsCriteriaHistoryListView_0);
_.getBasePath = function getBasePath_4(){
  return (this.isAutogroup?'Resource/AutoGroup/':'ResourceGroup/') + this.composite.resourceGroup.id + '/Operations/History';
}
;
_.onInit = function onInit_50(){
  $onInit_2(this);
  this.listGrid.setEmptyMessage(($clinit_Enhanced() , 'No results found using specified criteria.'));
}
;
_.refreshTableInfo = function refreshTableInfo_2(){
  var count;
  $refreshTableInfo(this);
  if (this.tableInfo) {
    count = $getSelectedRecords(this.listGrid).length;
    $setContents_0(this.tableInfo, 'Matching Rows: ' + ($clinit_Enhanced() , '' + $getTotalRows(this.listGrid)) + ' (selected: ' + count + ')');
  }
}
;
_.composite = null;
_.isAutogroup = false;
function $clinit_GroupOperationsPortlet(){
  $clinit_GroupOperationsPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_6 = ($clinit_Enhanced() , 'Group: Operations');
  CONFIG_INCLUDE_4 = new ArrayList_0;
  $add_3(CONFIG_INCLUDE_4, 'METRIC_RANGE');
  $add_3(CONFIG_INCLUDE_4, 'METRIC_RANGE_BEGIN_END_FLAG');
  $add_3(CONFIG_INCLUDE_4, 'METRIC_RANGE_ENABLE');
  $add_3(CONFIG_INCLUDE_4, 'METRIC_RANGE_LASTN');
  $add_3(CONFIG_INCLUDE_4, 'METRIC_RANGE_UNIT');
  $add_3(CONFIG_INCLUDE_4, 'RESULT_COUNT');
  $add_3(CONFIG_INCLUDE_4, 'OPERATION_STATUS');
}

function $configure_5(this$static, portletWindow, storedPortlet){
  var key, key$iterator, portletConfig;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  portletConfig = storedPortlet.configuration;
  for (key$iterator = $iterator($keySet(($clinit_PortletConfigurationEditorComponent() , CONFIG_PROPERTY_INITIALIZATION))); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$String);
    !dynamicCast(portletConfig.properties.get_2(key), Q$PropertySimple) && $indexOf_0(CONFIG_INCLUDE_4, key, 0) != -1 && $put_4(portletConfig, new PropertySimple_1(key, CONFIG_PROPERTY_INITIALIZATION.get_2(key)));
  }
}

function $loadData(this$static){
  var criteria, isAutoCluster, isAutoGroup, portletConfig, storedPortlet;
  storedPortlet = this$static.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  criteria = new ResourceGroupCriteria_0;
  $addFilterId(criteria, valueOf_44(this$static.groupId));
  criteria.fetchConfigurationUpdates = false;
  criteria.fetchExplicitResources = false;
  criteria.fetchGroupDefinition = false;
  criteria.fetchOperationHistories = false;
  isAutoCluster = this$static.isAutoCluster;
  isAutoGroup = this$static.isAutoGroup;
  if (isAutoCluster) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  }
   else if (isAutoGroup) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addFilterPrivate(criteria, TRUE);
  }
  $findResourceGroupCompositesByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), criteria, new GroupOperationsPortlet$1_0(this$static, portletConfig, isAutoGroup));
}

function $refresh_11(this$static){
  this$static.currentlyRefreshing || !!this$static.groupOperations && $refresh(this$static.groupOperations, false);
}

function GroupOperationsPortlet_0(context){
  $clinit_GroupOperationsPortlet();
  EnhancedVLayout_0.call(this);
  this.recentOperationsContent = new Canvas_1;
  this.groupId = context.groupId;
  this.isAutoGroup = ($clinit_EntityContext$Type() , ResourceGroup) == context.type_0 && context.isAutoGroup;
  this.isAutoCluster = ResourceGroup == context.type_0 && context.isAutoCluster;
}

defineSeed(2534, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), GroupOperationsPortlet_0);
_.configure = function configure_7(portletWindow, storedPortlet){
  $configure_5(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_5(){
  var customSettings, form, measurementRangeEditor, operationStatusSelector, page, portletConfig, resultCountSelector, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  customSettings = new DynamicForm_0;
  page = new EnhancedVLayout_0;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(5));
  operationStatusSelector = getOperationStatusEditor(portletConfig);
  resultCountSelector = getResultCountEditor(portletConfig);
  measurementRangeEditor = ($clinit_PortletConfigurationEditorComponent() , new CustomConfigMeasurementRangeEditor_0(portletConfig));
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [operationStatusSelector, resultCountSelector]));
  $addSubmitValuesHandler(customSettings, new GroupOperationsPortlet$2_0(this, resultCountSelector, portletConfig, measurementRangeEditor, operationStatusSelector, storedPortlet));
  $markForRedraw(form);
  $addMember(page, measurementRangeEditor);
  $addMember(page, form);
  $addChild(customSettings, page);
  return customSettings;
}
;
_.getHelpCanvas = function getHelpCanvas_7(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet displays Operations consistent with display criteria configured.'));
}
;
_.isRefreshing = function isRefreshing_6(){
  return this.currentlyRefreshing;
}
;
_.onDestroy = function onDestroy_8(){
  onDestroy_0(this.refreshTimer);
}
;
_.onInit = function onInit_51(){
  $onInit(this);
  $onInit_Layout(this);
  this.currentlyRefreshing = true;
  $isCreated_1(this)?$setProperty_3(this, 'height', '*'):(this.config_0['height'] = '*' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setAttribute_24(this.recentOperationsContent, 'height', '100%', true);
  $addMember(this, this.recentOperationsContent);
  $markForRedraw(this);
  $loadData(this);
}
;
_.refresh_0 = function refresh_15(){
  $refresh_11(this);
}
;
_.startRefreshCycle = function startRefreshCycle_7(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.currentlyRefreshing = false;
_.groupComposite = null;
_.groupId = 0;
_.groupOperations = null;
_.isAutoCluster = false;
_.isAutoGroup = false;
_.portletWindow = null;
_.refreshTimer = null;
var CONFIG_INCLUDE_4, NAME_6;
function $onSuccess_198(this$static, results){
  var child, child$array, child$index, child$max, emptyGroup, zero;
  if (results.size_0 == 0) {
    new Criteria_0;
    emptyGroup = new ResourceGroup_2('');
    emptyGroup.id = -1;
    zero = new Long_0(P0_longLit);
    this$static.this$0.groupComposite = new ResourceGroupComposite_1(zero, zero, zero, zero, zero, zero, zero, zero, emptyGroup);
    this$static.this$0.groupOperations = new GroupOperationsCriteriaHistoryListView_0(new GroupOperationsCriteriaDataSource_0(this$static.val$portletConfig), this$static.this$0.groupComposite, this$static.val$isAutoGroup);
  }
   else {
    this$static.this$0.groupComposite = dynamicCast((checkIndex(0, results.size_0) , results.array[0]), Q$ResourceGroupComposite);
    new Criteria_2('groupId', '' + this$static.this$0.groupComposite.resourceGroup.id);
    this$static.this$0.groupOperations = new GroupOperationsCriteriaHistoryListView_0(new GroupOperationsCriteriaDataSource_0(this$static.val$portletConfig), this$static.this$0.groupComposite, this$static.val$isAutoGroup);
  }
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentOperationsContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.this$0.recentOperationsContent, this$static.this$0.groupOperations);
  this$static.this$0.currentlyRefreshing = false;
  this$static.this$0.recentOperationsContent.markForRedraw_0();
}

function GroupOperationsPortlet$1_0(this$0, val$portletConfig, val$isAutoGroup){
  this.this$0 = this$0;
  this.val$portletConfig = val$portletConfig;
  this.val$isAutoGroup = val$isAutoGroup;
}

defineSeed(2535, 1, {}, GroupOperationsPortlet$1_0);
_.onFailure = function onFailure_209(caught){
  debug('Error retrieving resource group composite for group [' + this.this$0.groupId + ']:' + caught.getMessage());
  this.this$0.currentlyRefreshing = false;
}
;
_.onSuccess_0 = function onSuccess_209(results){
  $onSuccess_198(this, dynamicCast(results, Q$PageList));
}
;
_.this$0 = null;
_.val$isAutoGroup = false;
_.val$portletConfig = null;
function GroupOperationsPortlet$2_0(this$0, val$resultCountSelector, val$portletConfig, val$measurementRangeEditor, val$operationStatusSelector, val$storedPortlet){
  this.this$0 = this$0;
  this.val$resultCountSelector = val$resultCountSelector;
  this.val$portletConfig = val$portletConfig;
  this.val$measurementRangeEditor = val$measurementRangeEditor;
  this.val$operationStatusSelector = val$operationStatusSelector;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2536, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), GroupOperationsPortlet$2_0);
_.onSubmitValues = function onSubmitValues_5(event_0){
  var updatedConfig;
  saveResultCounterSettings(this.val$resultCountSelector, this.val$portletConfig);
  saveMeasurementRangeEditorSettings(this.val$measurementRangeEditor, this.val$portletConfig);
  updatedConfig = saveOperationStatusSelectorSettings(this.val$operationStatusSelector, this.val$portletConfig);
  $setConfiguration_0(this.val$storedPortlet, updatedConfig);
  $configure_5(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $setPortletConfig(dynamicCast(this.this$0.groupOperations.dataSource_1, Q$GroupOperationsCriteriaDataSource), updatedConfig);
  $refresh_11(this.this$0);
}
;
_.this$0 = null;
_.val$measurementRangeEditor = null;
_.val$operationStatusSelector = null;
_.val$portletConfig = null;
_.val$resultCountSelector = null;
_.val$storedPortlet = null;
function $clinit_GroupOperationsPortlet$Factory(){
  $clinit_GroupOperationsPortlet$Factory = nullMethod;
  INSTANCE_12 = new GroupOperationsPortlet$Factory_0;
}

function GroupOperationsPortlet$Factory_0(){
}

defineSeed(2537, 1, makeCastMap([Q$PortletViewFactory]), GroupOperationsPortlet$Factory_0);
_.getInstance = function getInstance_6(context){
  if (($clinit_EntityContext$Type() , ResourceGroup) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new GroupOperationsPortlet_0(context);
}
;
var INSTANCE_12;
function $clinit_GroupPkgHistoryPortlet(){
  $clinit_GroupPkgHistoryPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_7 = ($clinit_Enhanced() , 'Group: Package History');
  CONFIG_INCLUDE_5 = new ArrayList_0;
  $add_3(CONFIG_INCLUDE_5, 'RESULT_COUNT');
}

function $configure_6(this$static, portletWindow, storedPortlet){
  var key, key$iterator, portletConfig;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  portletConfig = storedPortlet.configuration;
  for (key$iterator = $iterator($keySet(($clinit_PortletConfigurationEditorComponent() , CONFIG_PROPERTY_INITIALIZATION))); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$String);
    !dynamicCast(portletConfig.properties.get_2(key), Q$PropertySimple) && $indexOf_0(CONFIG_INCLUDE_5, key, 0) != -1 && $put_4(portletConfig, new PropertySimple_1(key, CONFIG_PROPERTY_INITIALIZATION.get_2(key)));
  }
}

function $refresh_12(this$static){
  this$static.currentlyLoading || (this$static.currentlyLoading = true , this$static.getRecentPkgHistory());
}

function GroupPkgHistoryPortlet_0(groupId){
  $clinit_GroupPkgHistoryPortlet();
  EnhancedVLayout_0.call(this);
  this.recentPkgHistoryContent = new Canvas_1;
  this.groupId = groupId;
}

defineSeed(2538, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), GroupPkgHistoryPortlet_0);
_.configure = function configure_8(portletWindow, storedPortlet){
  $configure_6(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_6(){
  var customSettings, form, page, portletConfig, resultCountSelector, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  customSettings = new DynamicForm_0;
  page = new EnhancedVLayout_0;
  form = new DynamicForm_0;
  $setMargin(form, valueOf_44(5));
  resultCountSelector = getResultCountEditor(portletConfig);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [resultCountSelector]));
  $addSubmitValuesHandler(customSettings, new GroupPkgHistoryPortlet$1_0(this, resultCountSelector, portletConfig, storedPortlet));
  $addMember(page, form);
  $addChild(customSettings, page);
  return customSettings;
}
;
_.getHelpCanvas = function getHelpCanvas_8(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet shows relevant package history based on display criteria configured.'));
}
;
_.getRecentPkgHistory = function getRecentPkgHistory(){
  var criteria, currentSetting, groupId, pc, portletConfig, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  groupId = this.groupId;
  criteria = new InstalledPackageHistoryCriteria_0;
  pc = new PageControl_0;
  currentSetting = $getSimpleValue(portletConfig, 'RESULT_COUNT', '5');
  !$trim(currentSetting).length?pc.setPageSize(valueOf_44(__parseAndValidateInt('5')).value_0):pc.setPageSize(valueOf_44(__parseAndValidateInt(currentSetting)).value_0);
  criteria.pageControlOverrides = pc;
  $addFilterResourceGroupIds_4(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(groupId)]));
  $addSortStatus_1(criteria, ($clinit_PageOrdering() , DESC));
  $findInstalledPackageHistoryByCriteria(dynamicCast(secure(getInstance_38(), -1), Q$ContentGWTServiceAsync), criteria, new GroupPkgHistoryPortlet$2_0(this, groupId));
}
;
_.isRefreshing = function isRefreshing_7(){
  return this.currentlyLoading;
}
;
_.onDestroy = function onDestroy_9(){
  onDestroy_0(this.refreshTimer);
}
;
_.onInit = function onInit_52(){
  $setPadding(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
  $addMember(this, this.recentPkgHistoryContent);
  this.currentlyLoading = true;
  this.getRecentPkgHistory();
}
;
_.refresh_0 = function refresh_16(){
  $refresh_12(this);
}
;
_.startRefreshCycle = function startRefreshCycle_8(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.currentlyLoading = false;
_.groupId = -1;
_.portletWindow = null;
_.refreshTimer = null;
var CONFIG_INCLUDE_5, NAME_7;
function GroupPkgHistoryPortlet$1_0(this$0, val$resultCountSelector, val$portletConfig, val$storedPortlet){
  this.this$0 = this$0;
  this.val$resultCountSelector = val$resultCountSelector;
  this.val$portletConfig = val$portletConfig;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2539, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), GroupPkgHistoryPortlet$1_0);
_.onSubmitValues = function onSubmitValues_6(event_0){
  var updatedConfig;
  updatedConfig = saveResultCounterSettings(this.val$resultCountSelector, this.val$portletConfig);
  $setConfiguration_0(this.val$storedPortlet, updatedConfig);
  $configure_6(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $refresh_12(this.this$0);
}
;
_.this$0 = null;
_.val$portletConfig = null;
_.val$resultCountSelector = null;
_.val$storedPortlet = null;
function $onSuccess_199(this$static, result){
  var child, child$array, child$index, child$max, column, history_0, history$iterator, iconItem, link, row, time, title;
  column = new VLayout_0;
  $isCreated_1(column)?$setProperty_0(column, 'height', 10):(column.config_0['height'] = 10 , undefined);
  if (result.size_0 == 0) {
    row = createEmptyDisplayRow(($clinit_Enhanced() , 'No results found using specified criteria.'));
    column.addMember_0(row);
  }
   else {
    for (history$iterator = new AbstractList$IteratorImpl_0(result); history$iterator.i < history$iterator.this$0_0.size_1();) {
      history_0 = dynamicCast($next_0(history$iterator), Q$InstalledPackageHistory);
      row = new DynamicForm_0;
      $isCreated_1(row)?$setProperty_0(row, 'numCols', 3):(row.config_0['numCols'] = 3 , undefined);
      iconItem = newTextItemIcon('subsystems/content/Package_16.png', null);
      title = history_0.packageVersion.fileName + ':';
      link = newTextItem(title);
      time = newTextItem(format_90(history_0.timestamp.value_0));
      row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [iconItem, link, time]));
      column.addMember_0(row);
    }
  }
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentPkgHistoryContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.this$0.recentPkgHistoryContent, column);
  this$static.this$0.recentPkgHistoryContent.markForRedraw_0();
  this$static.this$0.currentlyLoading = false;
  $markForRedraw(this$static.this$0);
}

function GroupPkgHistoryPortlet$2_0(this$0, val$groupId){
  this.this$0 = this$0;
  this.val$groupId = val$groupId;
}

defineSeed(2540, 1, {}, GroupPkgHistoryPortlet$2_0);
_.onFailure = function onFailure_210(caught){
  debug('Error retrieving installed package history for group [' + this.val$groupId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_210(result){
  $onSuccess_199(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$groupId = 0;
function $clinit_GroupPkgHistoryPortlet$Factory(){
  $clinit_GroupPkgHistoryPortlet$Factory = nullMethod;
  INSTANCE_13 = new GroupPkgHistoryPortlet$Factory_0;
}

function GroupPkgHistoryPortlet$Factory_0(){
}

defineSeed(2541, 1, makeCastMap([Q$PortletViewFactory]), GroupPkgHistoryPortlet$Factory_0);
_.getInstance = function getInstance_7(context){
  if (($clinit_EntityContext$Type() , ResourceGroup) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new GroupPkgHistoryPortlet_0(context.groupId);
}
;
var INSTANCE_13;
function $drawGraph(this$static){
  var divAndSvgDefs;
  debug('drawGraph marker in MetricD3Graph for: ' + this$static.getFullChartId() + ' ' + $getChartTitle(this$static.graph));
  divAndSvgDefs = new StringBuilder_0;
  $append_12(divAndSvgDefs, '<div id="' + this$static.getFullChartId() + '" ><svg xmlns="http://www.w3.org/2000/svg" version="1.1" xmlns:xlink="http://www.w3.org/1999/xlink" style="height:' + ($clinit_MetricGraphData() , DEFAULT_CHART_HEIGHT) + 'px;">');
  $append_1(divAndSvgDefs.data_0, ' <defs>               <linearGradient id="headerGrad" x1="0%" y1="0%" x2="0%" y2="100%">                   <stop offset="0%" style="stop-color:#E6E6E6;stop-opacity:1"/>                   <stop offset="100%" style="stop-color:#F0F0F0;stop-opacity:1"/>               <\/linearGradient>               <pattern id="noDataStripes" patternUnits="userSpaceOnUse" x="0" y="0"                        width="6" height="3">                   <path d="M 0 0 6 0" style="stroke:#CCCCCC; fill:none;"/>               <\/pattern>               <pattern id="unknownStripes" patternUnits="userSpaceOnUse" x="0" y="0"                        width="6" height="3">                   <path d="M 0 0 6 0" style="stroke:#2E9EC2; fill:none;"/>               <\/pattern>               <pattern id="downStripes" patternUnits="userSpaceOnUse" x="0" y="0"                        width="6" height="3">                   <path d="M 0 0 6 0" style="stroke:#ff8a9a; fill:none;"/>               <\/pattern><\/defs>');
  $append_1(divAndSvgDefs.data_0, '<\/svg><\/div>');
  !!this$static.graphDiv && $removeMember(this$static, this$static.graphDiv);
  this$static.graphDiv = new HTMLFlow_1($toString_1(divAndSvgDefs.data_0));
  $setAttribute_24(this$static.graphDiv, 'width', '100%', true);
  $setAttribute_24(this$static.graphDiv, 'height', '100%', true);
  $addMember(this$static, this$static.graphDiv);
  $schedule(new MetricD3GraphView$1_0(this$static), 200);
}

function MetricD3GraphView_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
}

function MetricD3GraphView_1(graph){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.graph = graph;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
}

defineSeed(2543, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), MetricD3GraphView_1);
_.destroy_0 = function destroy_14(){
  destroyMembers(this);
  $destroy(this);
}
;
_.getFullChartId = function getFullChartId(){
  return 'rChart-' + $getChartId(this.graph.metricGraphData);
}
;
_.hide_0 = function hide_0(){
  $hide(this);
}
;
_.onDraw_0 = function onDraw_26(){
  !!this.graph.metricGraphData.definition && $drawGraph(this);
}
;
_.parentResized_0 = function parentResized_0(){
  $parentResized(this);
  $removeMembers(this, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')));
  $drawGraph(this);
}
;
_.graph = null;
_.graphDiv = null;
_.refreshTimer = null;
function $clinit_ResourceGroupD3GraphPortlet(){
  $clinit_ResourceGroupD3GraphPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_8 = ($clinit_Enhanced() , 'Resource Group Metric Graph');
}

function $configure_7(this$static, portletWindow, storedPortlet){
  var entityId, measurementDefId, measurementDefIdProperty, resourceIdProperty, resourceService, resourceCriteria;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  destroyMembers(this$static);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
   else if (isBrowserPreIE9()) {
    $addMember(this$static, new Label_4('<i>' + ($clinit_Enhanced() , 'Charting is not available for this browser.') + '<\/i>'));
    return;
  }
  this$static.graph = new StackedBarMetricGraphIE8Impl_0;
  $setMetricGraphData(this$static.graph, ($clinit_MetricGraphData() , new MetricGraphData_0(portletWindow.storedPortlet)));
  if ($getSimple(storedPortlet.configuration, 'resourceGroupId')) {
    resourceIdProperty = $getSimple(storedPortlet.configuration, 'resourceGroupId');
    measurementDefIdProperty = $getSimple(storedPortlet.configuration, 'definitionId');
    if (!!resourceIdProperty && !!measurementDefIdProperty) {
      entityId = resourceIdProperty.stringValue == null?null:valueOf_44(__parseAndValidateInt(resourceIdProperty.stringValue));
      measurementDefId = measurementDefIdProperty.stringValue == null?null:valueOf_44(__parseAndValidateInt(measurementDefIdProperty.stringValue));
      !!entityId && !!measurementDefId && (resourceService = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync) , resourceCriteria = new ResourceGroupCriteria_0 , resourceCriteria.filterId = entityId , $findResourceGroupsByCriteria(resourceService, resourceCriteria, new ResourceGroupD3GraphPortlet$1_0(this$static, measurementDefId)) , undefined);
    }
  }
}

function $redraw_3(this$static){
  var simple, storedPortlet;
  $redraw(this$static);
  $removeMembers(this$static, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members')));
  storedPortlet = this$static.portletWindow.storedPortlet;
  simple = $getSimple(storedPortlet.configuration, 'resourceGroupId');
  isBrowserPreIE9()?$addMember(this$static, new Label_4('<i>' + ($clinit_Enhanced() , 'Charting is not available for this browser.') + '<\/i>')):!simple || !(simple.stringValue == null?null:valueOf_44(__parseAndValidateInt(simple.stringValue)))?$addMember(this$static, new Label_4('<i>' + ($clinit_Enhanced() , 'Click the Settings button to configure this portlet.') + '<\/i>')):$drawGraph(this$static);
}

function ResourceGroupD3GraphPortlet_0(){
  $clinit_ResourceGroupD3GraphPortlet();
  MetricD3GraphView_0.call(this);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , HIDDEN).value_0, false);
}

defineSeed(2542, 2543, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), ResourceGroupD3GraphPortlet_0);
_.configure = function configure_9(portletWindow, storedPortlet){
  $configure_7(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_7(){
  var form, integerValue, metric, propertySimple, resourceGroupSelector, selectorItem, storedPortlet;
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_0(form, 'width', 750):(form.config_0['width'] = 750 , undefined);
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 1):(form.config_0['numCols'] = 1 , undefined);
  selectorItem = new CanvasItem_0;
  $setAttribute_30(selectorItem, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0);
  selectorItem.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
  resourceGroupSelector = new SingleResourceGroupSelector_0(($clinit_GroupCategory() , COMPATIBLE));
  $isCreated_1(resourceGroupSelector)?$setProperty_0(resourceGroupSelector, 'width', 700):(resourceGroupSelector.config_0['width'] = 700 , undefined);
  $isCreated_1(resourceGroupSelector)?$setProperty_0(resourceGroupSelector, 'height', 300):(resourceGroupSelector.config_0['height'] = 300 , undefined);
  metric = new ResourceGroupD3GraphPortlet$2_0(($clinit_Enhanced() , 'Metric'), resourceGroupSelector, form);
  $isCreated_2(metric)?$setProperty_6(metric, 'width', 300):(metric.jsObj['width'] = 300 , undefined);
  $setAttribute_30(metric, 'titleOrientation', TOP_1.value_0);
  $isCreated_2(metric)?$setProperty_8(metric, 'valueField', 'id'):(metric.jsObj['valueField'] = 'id' , undefined);
  $isCreated_2(metric)?$setProperty_8(metric, 'displayField', 'displayName'):(metric.jsObj['displayField'] = 'displayName' , undefined);
  $setOptionDataSource_0(metric, new ResourceScheduledMetricDatasource_0);
  $addAssignedItemsChangedHandler(resourceGroupSelector, new ResourceGroupD3GraphPortlet$3_0(resourceGroupSelector, metric, form));
  storedPortlet = this.portletWindow.storedPortlet;
  if ($getSimple(storedPortlet.configuration, 'resourceGroupId')) {
    integerValue = $getIntegerValue($getSimple(storedPortlet.configuration, 'resourceGroupId'));
    !!integerValue && $setValue(form, 'resourceGroupId', integerValue.value_0);
    propertySimple = $getSimple(storedPortlet.configuration, 'definitionId');
    !!propertySimple && !!(propertySimple.stringValue == null?null:valueOf_44(__parseAndValidateInt(propertySimple.stringValue))) && $setValue(form, 'definitionId', (propertySimple.stringValue == null?null:valueOf_44(__parseAndValidateInt(propertySimple.stringValue))).value_0);
  }
  $setAttribute_28(selectorItem, 'canvas', !resourceGroupSelector?null:$getOrCreateJsObj_0(resourceGroupSelector));
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [selectorItem, metric, new SpacerItem_0]));
  $addSubmitValuesHandler(form, new ResourceGroupD3GraphPortlet$4_0(this, storedPortlet, form));
  return form;
}
;
_.getFullChartId = function getFullChartId_0(){
  return !!this.portletWindow && !!this.graph && !!this.graph.metricGraphData?'rChart-' + $getChartId(this.graph.metricGraphData) + '-' + this.portletWindow.storedPortlet.id:'';
}
;
_.getHelpCanvas = function getHelpCanvas_9(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet displays the resource metric graph.'));
}
;
_.isRefreshing = function isRefreshing_8(){
  return false;
}
;
_.onDestroy = function onDestroy_10(){
  onDestroy_0(this.refreshTimer);
}
;
_.onDraw_0 = function onDraw_27(){
  var simple, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  if (isBrowserPreIE9()) {
    $removeMembers(this, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')));
    $addMember(this, new Label_4('<i>' + ($clinit_Enhanced() , 'Charting is not available for this browser.') + '<\/i>'));
  }
   else {
    simple = $getSimple(storedPortlet.configuration, 'resourceGroupId');
    if (!simple || !(simple.stringValue == null?null:valueOf_44(__parseAndValidateInt(simple.stringValue)))) {
      $removeMembers(this, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')));
      $addMember(this, new Label_4('<i>' + ($clinit_Enhanced() , 'Click the Settings button to configure this portlet.') + '<\/i>'));
    }
     else {
      !!this.graph.metricGraphData.definition && $drawGraph(this);
    }
  }
}
;
_.redraw_0 = function redraw_2(){
  $redraw_3(this);
}
;
_.refresh_0 = function refresh_17(){
  $isVisible(this) && $redraw_3(this);
}
;
_.startRefreshCycle = function startRefreshCycle_9(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.portletWindow = null;
var NAME_8;
function $onSuccess_200(this$static, result){
  var resource, typesSet;
  if (result.size_0 == 0) {
    return;
  }
  resource = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroup);
  typesSet = new HashSet_0;
  $add_6(typesSet, valueOf_44(resource.resourceType.id));
  $getResourceTypes_0(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), of(($clinit_ResourceTypeRepository$MetadataType() , measurements_0)), new ResourceGroupD3GraphPortlet$1$1_0(this$static, resource, this$static.val$measurementDefId));
}

function ResourceGroupD3GraphPortlet$1_0(this$0, val$measurementDefId){
  this.this$0 = this$0;
  this.val$measurementDefId = val$measurementDefId;
}

defineSeed(2544, 1, {}, ResourceGroupD3GraphPortlet$1_0);
_.onFailure = function onFailure_211(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to find resource for graph'), caught);
}
;
_.onSuccess_0 = function onSuccess_211(result){
  $onSuccess_200(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$measurementDefId = null;
function ResourceGroupD3GraphPortlet$1$1_0(this$1, val$resource, val$measurementDefId){
  this.this$1 = this$1;
  this.val$resource = val$resource;
  this.val$measurementDefId = val$measurementDefId;
}

defineSeed(2545, 1, {}, ResourceGroupD3GraphPortlet$1$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_10(types){
  var def, def$iterator, startTime, type;
  type = dynamicCast(types.get_2(valueOf_44(this.val$resource.resourceType.id)), Q$ResourceType);
  for (def$iterator = type.metricDefinitions.iterator(); def$iterator.hasNext();) {
    def = dynamicCast(def$iterator.next_0(), Q$MeasurementDefinition);
    if (def.id == this.val$measurementDefId.value_0) {
      $clinit_Log();
      $fine_0(logger_0, 'Found portlet measurement definition !' + def);
      $setEntityId(this.this$1.this$0.graph, this.val$resource.id);
      $setEntityName(this.this$1.this$0.graph, this.val$resource.name_0);
      $setDefinition(this.this$1.this$0.graph, def);
      startTime = fromDouble(currentTimeMillis0());
      $findDataForCompatibleGroupForLast(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this.val$resource.id, initValues(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [def.id]), 8, 3, new ResourceGroupD3GraphPortlet$1$1$1_0(this, startTime));
      break;
    }
  }
}
;
_.this$1 = null;
_.val$measurementDefId = null;
_.val$resource = null;
function $onSuccess_201(this$static, measurementData){
  debug('Dashboard Metric data in: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this$static.val$startTime)) + ' ms.');
  dynamicCast(measurementData.get_0(0), Q$List);
  $drawGraph(this$static.this$2.this$1.this$0);
}

function ResourceGroupD3GraphPortlet$1$1$1_0(this$2, val$startTime){
  this.this$2 = this$2;
  this.val$startTime = val$startTime;
}

defineSeed(2546, 1, {}, ResourceGroupD3GraphPortlet$1$1$1_0);
_.onFailure = function onFailure_212(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load graph data'), caught);
}
;
_.onSuccess_0 = function onSuccess_212(measurementData){
  $onSuccess_201(this, dynamicCast(measurementData, Q$List));
}
;
_.this$2 = null;
_.val$startTime = P0_longLit;
function ResourceGroupD3GraphPortlet$2_0($anonymous1, val$resourceGroupSelector, val$form){
  $clinit_SelectItem();
  this.val$resourceGroupSelector = val$resourceGroupSelector;
  this.val$form = val$form;
  SortedSelectItem_2.call(this, 'definitionId', $anonymous1);
}

defineSeed(2547, 2317, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$SelectItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), ResourceGroupD3GraphPortlet$2_0);
_.getPickListFilterCriteria_0 = function getPickListFilterCriteria_1(){
  var criteria, groupId;
  criteria = new Criteria_0;
  if ($getSelectedItems(this.val$resourceGroupSelector).map.size_1() == 1) {
    groupId = dynamicCast($next_1($iterator($keySet($getSelectedItems(this.val$resourceGroupSelector).map))), Q$ResourceGroup).id;
    $addCriteria_1(criteria, 'resourceGroupId', valueOf_44(groupId));
    $setValue(this.val$form, 'resourceGroupId', groupId);
  }
  return criteria;
}
;
_.val$form = null;
_.val$resourceGroupSelector = null;
function ResourceGroupD3GraphPortlet$3_0(val$resourceGroupSelector, val$metric, val$form){
  this.val$resourceGroupSelector = val$resourceGroupSelector;
  this.val$metric = val$metric;
  this.val$form = val$form;
}

defineSeed(2548, 1, makeCastMap([Q$EventHandler, Q$AssignedItemsChangedHandler]), ResourceGroupD3GraphPortlet$3_0);
_.onSelectionChanged_0 = function onSelectionChanged_7(event_0){
  if ($getSelectedItems(this.val$resourceGroupSelector).map.size_1() == 1) {
    $fetchData_2(this.val$metric);
    $clearValue(this.val$form, 'definitionId');
  }
}
;
_.val$form = null;
_.val$metric = null;
_.val$resourceGroupSelector = null;
function ResourceGroupD3GraphPortlet$4_0(this$0, val$storedPortlet, val$form){
  this.this$0 = this$0;
  this.val$storedPortlet = val$storedPortlet;
  this.val$form = val$form;
}

defineSeed(2549, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), ResourceGroupD3GraphPortlet$4_0);
_.onSubmitValues = function onSubmitValues_7(submitValuesEvent){
  $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('resourceGroupId', $getValue(this.val$form, 'resourceGroupId')));
  $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('definitionId', $getValue(this.val$form, 'definitionId')));
  $configure_7(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $redraw_3(this.this$0);
}
;
_.this$0 = null;
_.val$form = null;
_.val$storedPortlet = null;
function $clinit_ResourceGroupD3GraphPortlet$Factory(){
  $clinit_ResourceGroupD3GraphPortlet$Factory = nullMethod;
  INSTANCE_14 = new ResourceGroupD3GraphPortlet$Factory_0;
}

function ResourceGroupD3GraphPortlet$Factory_0(){
}

defineSeed(2550, 1, makeCastMap([Q$PortletViewFactory]), ResourceGroupD3GraphPortlet$Factory_0);
_.getInstance = function getInstance_8(context){
  return new ResourceGroupD3GraphPortlet_0;
}
;
var INSTANCE_14;
function $clinit_ResourceAutodiscoveryView(){
  $clinit_ResourceAutodiscoveryView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_17 = new ViewName_2('AutodiscoveryQueue', ($clinit_Enhanced() , 'Discovery Queue'), ($clinit_IconEnum() , DISCOVERY_QUEUE));
}

function $disableButtons_0(buttons){
  var button, button$index, button$max;
  for (button$index = 0 , button$max = buttons.length; button$index < button$max; ++button$index) {
    button = buttons[button$index];
    $setAttribute_22(button, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , TRUE), true);
  }
}

function $getSelectedIds_4(this$static){
  var node, node$array, node$index, node$max, selected;
  selected = new ArrayList_0;
  for (node$array = $getSelectedRecords(this$static.treeGrid) , node$index = 0 , node$max = node$array.length; node$index < node$max; ++node$index) {
    node = node$array[node$index];
    $equals_6(($clinit_InventoryStatus() , COMMITTED).name_0, getAttribute(node.jsObj, 'status')) || $add_3(selected, valueOf_44(__parseAndValidateInt(getAttribute(node.jsObj, 'id'))));
  }
  return getIds(selected);
}

function $refresh_13(this$static){
  if (this$static.treeGrid) {
    $invalidateCache_0(this$static.treeGrid);
    $markForRedraw_0(this$static.treeGrid);
  }
}

function $updateButtonEnablement_0(this$static, selectAllButton, deselectAllButton, importButton, ignoreButton, unignoreButton){
  var allSelected, ignoreOk, importOk, isPlatform, listGridRecord, listGridRecord$array, listGridRecord$index, listGridRecord$max, node, parentNode, parentStatus, status_0, unignoreOk;
  if ($getSelectedRecords(this$static.treeGrid).length == 0) {
    $setDisabled(selectAllButton, $getRecords(this$static.treeGrid).length == 0);
    $setAttribute_22(deselectAllButton, 'disabled', ($clinit_Boolean() , $clinit_Boolean() , TRUE), true);
    $setAttribute_22(importButton, 'disabled', TRUE, true);
    $setAttribute_22(ignoreButton, 'disabled', TRUE, true);
    $setAttribute_22(unignoreButton, 'disabled', TRUE, true);
    $markForRedraw(this$static);
    return;
  }
  allSelected = $getSelectedRecords(this$static.treeGrid).length == $getRecords(this$static.treeGrid).length;
  $setAttribute_22(selectAllButton, 'disabled', ($clinit_Boolean() , allSelected?TRUE:FALSE), true);
  $setAttribute_22(deselectAllButton, 'disabled', FALSE, true);
  importOk = false;
  ignoreOk = false;
  unignoreOk = false;
  for (listGridRecord$array = $getSelectedRecords(this$static.treeGrid) , listGridRecord$index = 0 , listGridRecord$max = listGridRecord$array.length; listGridRecord$index < listGridRecord$max; ++listGridRecord$index) {
    listGridRecord = listGridRecord$array[listGridRecord$index];
    node = $findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), getAttribute(listGridRecord.jsObj, 'id'));
    status_0 = getAttribute(node.jsObj, 'status');
    parentNode = $getParent(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), node);
    isPlatform = $isRoot(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), parentNode).value_0;
    importOk = importOk | $equals_6(($clinit_InventoryStatus() , NEW).name_0, status_0);
    unignoreOk = unignoreOk | $equals_6(IGNORED.name_0, status_0);
    if (!isPlatform) {
      parentStatus = getAttribute(parentNode.jsObj, 'status');
      $equals_6(COMMITTED.name_0, parentStatus) && (ignoreOk = ignoreOk | $equals_6(NEW.name_0, status_0));
    }
  }
  $setAttribute_22(importButton, 'disabled', !importOk || unignoreOk?TRUE:FALSE, true);
  $setAttribute_22(ignoreButton, 'disabled', !ignoreOk || unignoreOk?TRUE:FALSE, true);
  $setAttribute_22(unignoreButton, 'disabled', !unignoreOk || importOk || ignoreOk?TRUE:FALSE, true);
  $markForRedraw(this$static);
}

function ResourceAutodiscoveryView_0(){
  $clinit_ResourceAutodiscoveryView();
  ResourceAutodiscoveryView_1.call(this, false);
}

function ResourceAutodiscoveryView_1(simple){
  $clinit_ResourceAutodiscoveryView();
  EnhancedVLayout_0.call(this);
  this.resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  this.importResourceService = dynamicCast(secure(getInstance_51(), 180000), Q$ResourceGWTServiceAsync);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  this.simple = simple;
}

defineSeed(2552, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$HasViewName, Q$Enhanced]), ResourceAutodiscoveryView_0);
_.getViewName = function getViewName_6(){
  return VIEW_ID_17;
}
;
_.onInit = function onInit_53(){
  var ctime, description, deselectAllButton, form, ignoreButton, importButton, key, name_0, refreshButton, selectAllButton, status_0, statusSelectItem, type, unignoreButton;
  $onInit(this);
  $onInit_Layout(this);
  this.treeGrid = new TreeGrid_0;
  $setAttribute_24(this.treeGrid, 'height', '100%', true);
  this.dataSource_0 = new AutodiscoveryQueueDataSource_0(this.treeGrid);
  $setAttribute_20(this.treeGrid, 'dataSource', $getOrCreateJsObj(this.dataSource_0), true);
  $setAutoFetchData_0(this.treeGrid, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setResizeFieldsInRealTime(this.treeGrid, TRUE);
  $setAttribute_24(this.treeGrid, 'autoFitData', ($clinit_Autofit() , HORIZONTAL).value_0, true);
  $setWrapCells(this.treeGrid, TRUE);
  $setFixedRecordHeights(this.treeGrid, FALSE);
  $setFolderIcon(this.treeGrid);
  $setNodeIcon(this.treeGrid, getResourceIcon_0(($clinit_ResourceCategory() , SERVER_0), ($clinit_AvailabilityType() , UP), '16'));
  name_0 = new TreeGridField_0('name');
  key = new TreeGridField_0('resourceKey');
  type = new TreeGridField_0('typeName');
  description = new TreeGridField_0('description');
  status_0 = new TreeGridField_0('statusLabel');
  ctime = new TreeGridField_0('ctime');
  $clinit_TimestampCellFormatter();
  prepareDateField(ctime, getAttribute(ctime.jsObj, 'name'));
  this.simple?$setFields_2(this.treeGrid, initValues(_3Lcom_smartgwt_client_widgets_tree_TreeGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeGridField, [name_0, key, type, status_0])):$setFields_2(this.treeGrid, initValues(_3Lcom_smartgwt_client_widgets_tree_TreeGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeGridField, [name_0, key, type, description, status_0, ctime]));
  $setAttribute_24(this.treeGrid, 'selectionAppearance', ($clinit_SelectionAppearance() , CHECKBOX).value_0, true);
  $deselectAllRecords(this.treeGrid);
  $addMember(this, this.treeGrid);
  this.footer = new ToolStrip_0;
  $setPadding(this.footer, valueOf_44(5));
  $setAttribute_24(this.footer, 'width', '100%', true);
  $setMembersMargin(this.footer, 15);
  $addMember(this, this.footer);
  importButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Import'));
  ignoreButton = new EnhancedIButton_1('Ignore');
  unignoreButton = new EnhancedIButton_1('Unignore');
  $addMember(this.footer, importButton);
  $addMember(this.footer, ignoreButton);
  $addMember(this.footer, unignoreButton);
  $disableButtons_0(initValues(_3Lcom_smartgwt_client_widgets_IButton_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$IButton, [importButton, ignoreButton, unignoreButton]));
  $addMember(this.footer, new LayoutSpacer_0);
  form = new DynamicForm_0;
  statusSelectItem = new SelectItem_2('status', 'Show');
  statusSelectItem.setValueMap_1(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [($clinit_AutodiscoveryQueueDataSource() , 'New'), 'Ignored', 'New and Ignored']));
  $setValue_7(statusSelectItem, 'New');
  $setWrapTitle(statusSelectItem, FALSE);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [statusSelectItem]));
  $addChangedHandler(statusSelectItem, new ResourceAutodiscoveryView$1_0(this, statusSelectItem));
  $addMember(this.footer, form);
  selectAllButton = new EnhancedIButton_1('Select All');
  $addMember(this.footer, selectAllButton);
  deselectAllButton = new EnhancedIButton_1('Deselect All');
  $setAttribute_22(deselectAllButton, 'disabled', TRUE, true);
  $addMember(this.footer, deselectAllButton);
  refreshButton = new EnhancedIButton_1('Refresh');
  $addClickHandler(refreshButton, new ResourceAutodiscoveryView$2_0(this));
  $addMember(this.footer, refreshButton);
  $addSelectionChangedHandler(this.treeGrid, new ResourceAutodiscoveryView$3_0(this, selectAllButton, deselectAllButton, importButton, ignoreButton, unignoreButton));
  $addDataArrivedHandler_0(this.treeGrid, new ResourceAutodiscoveryView$4_0(this, selectAllButton, deselectAllButton, importButton, ignoreButton, unignoreButton));
  $addClickHandler(selectAllButton, new ResourceAutodiscoveryView$5_0(this, selectAllButton, deselectAllButton, importButton, ignoreButton, unignoreButton));
  $addClickHandler(deselectAllButton, new ResourceAutodiscoveryView$6_0(this, selectAllButton, deselectAllButton, importButton, ignoreButton, unignoreButton));
  $addClickHandler(importButton, new ResourceAutodiscoveryView$7_0(this, selectAllButton, deselectAllButton, importButton, ignoreButton, unignoreButton));
  $addClickHandler(ignoreButton, new ResourceAutodiscoveryView$8_0(this, selectAllButton, deselectAllButton, importButton, ignoreButton, unignoreButton));
  $addClickHandler(unignoreButton, new ResourceAutodiscoveryView$9_0(this, selectAllButton, deselectAllButton, importButton, ignoreButton, unignoreButton));
}
;
_.refresh_0 = function refresh_18(){
  $refresh_13(this);
}
;
_.dataSource_0 = null;
_.footer = null;
_.selectionChangedHandlerDisabled = false;
_.simple = false;
_.treeGrid = null;
var VIEW_ID_17;
function $clinit_AutodiscoveryPortlet(){
  $clinit_AutodiscoveryPortlet = nullMethod;
  $clinit_ResourceAutodiscoveryView();
  NAME_9 = ($clinit_Enhanced() , 'Discovery Queue');
}

function $configure_8(this$static, portletWindow, storedPortlet){
  var $e0, property, retrieved;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  retrieved = '-1';
  property = $getSimple(storedPortlet.configuration, 'auto-discovery-platform-max');
  if (!!property && property.stringValue != null) {
    retrieved = property.stringValue;
    try {
      __parseAndValidateInt(retrieved);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$NumberFormatException)) {
        retrieved = '-1';
      }
       else 
        throw $e0;
    }
  }
   else {
    $put_4(storedPortlet.configuration, new PropertySimple_1('auto-discovery-platform-max', '-1'));
  }
  $setMaximumPlatformsToDisplay(this$static.dataSource, __parseAndValidateInt(retrieved));
}

function AutodiscoveryPortlet_0(){
  $clinit_AutodiscoveryPortlet();
  ResourceAutodiscoveryView_1.call(this, true);
  this.unlimitedString = ($clinit_Enhanced() , 'unlimited');
  this.dataSource = new AutodiscoveryQueueDataSource_0(this.treeGrid);
  !!this.treeGrid && $setAttribute_20(this.treeGrid, 'dataSource', $getOrCreateJsObj(this.dataSource), true);
}

defineSeed(2551, 2552, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$HasViewName, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), AutodiscoveryPortlet_0);
_.configure = function configure_10(portletWindow, storedPortlet){
  $configure_8(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_8(){
  var $e0, displayValues, form, item, maximumPlatformsComboBox, retrieved, row, selectedValue, simpleProperty, storedPortlet;
  form = new DynamicForm_0;
  $setAttribute_24(form, 'layoutAlign', ($clinit_VerticalAlignment() , CENTER_2).value_0, false);
  storedPortlet = this.portletWindow.storedPortlet;
  row = new EnhancedHLayout_0;
  maximumPlatformsComboBox = new SelectItem_1('auto-discovery-platform-max');
  $setTitle_1(maximumPlatformsComboBox, ($clinit_Enhanced() , 'Show'));
  $setHint(maximumPlatformsComboBox, '<nobr><b> discovered platforms<\/b><\/nobr>');
  $isCreated_2(maximumPlatformsComboBox)?$setProperty_8(maximumPlatformsComboBox, 'type', 'selection'):(maximumPlatformsComboBox.jsObj['type'] = 'selection' , undefined);
  displayValues = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['1', '2', '5', '10', this.unlimitedString]);
  maximumPlatformsComboBox.setValueMap_1(displayValues);
  $isCreated_2(maximumPlatformsComboBox)?$setProperty_6(maximumPlatformsComboBox, 'width', 100):(maximumPlatformsComboBox.jsObj['width'] = 100 , undefined);
  $addChangeHandler(maximumPlatformsComboBox, new AutodiscoveryPortlet$1_0(form));
  item = new DynamicForm_0;
  item.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [maximumPlatformsComboBox]));
  $addMember(row, item);
  retrieved = '-1';
  if (simpleProperty = $getSimple(storedPortlet.configuration, 'auto-discovery-platform-max')) {
    retrieved = simpleProperty.stringValue;
    try {
      __parseAndValidateInt(retrieved);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$NumberFormatException)) {
        retrieved = '-1';
      }
       else 
        throw $e0;
    }
  }
  selectedValue = $equals_6(retrieved, '-1')?this.unlimitedString:retrieved;
  $isCreated_2(maximumPlatformsComboBox)?$setProperty_8(maximumPlatformsComboBox, 'defaultValue', selectedValue):(maximumPlatformsComboBox.jsObj['defaultValue'] = selectedValue , undefined);
  $addChild(form, row);
  $addSubmitValuesHandler(form, new AutodiscoveryPortlet$2_0(this, form, storedPortlet));
  return form;
}
;
_.getHelpCanvas = function getHelpCanvas_10(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet allows import or ignore of newly discovered resources.  Imported resources are added to inventory for monitoring and management. Ignored resources are not imported and are hidden from view unless explicitly unignored.'));
}
;
_.isRefreshing = function isRefreshing_9(){
  return false;
}
;
_.onDestroy = function onDestroy_11(){
  onDestroy_0(this.refreshTimer);
}
;
_.refresh_0 = function refresh_19(){
  $refresh_13(this);
}
;
_.startRefreshCycle = function startRefreshCycle_10(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.dataSource = null;
_.portletWindow = null;
_.refreshTimer = null;
var NAME_9;
function AutodiscoveryPortlet$1_0(val$form){
  this.val$form = val$form;
}

defineSeed(2553, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), AutodiscoveryPortlet$1_0);
_.onChange = function onChange_6(event_0){
  var selectedItem;
  selectedItem = '' + $getValue_1(event_0);
  $setValue_0(this.val$form, 'auto-discovery-platform-max', selectedItem);
}
;
_.val$form = null;
function AutodiscoveryPortlet$2_0(this$0, val$form, val$storedPortlet){
  this.this$0 = this$0;
  this.val$form = val$form;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2554, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), AutodiscoveryPortlet$2_0);
_.onSubmitValues = function onSubmitValues_8(event_0){
  var value;
  value = dynamicCast($getValue(this.val$form, 'auto-discovery-platform-max'), Q$String);
  if (value != null) {
    value = $equals_6(this.this$0.unlimitedString, value)?'-1':value;
    $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('auto-discovery-platform-max', value));
    $configure_8(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
    $markForRedraw(this.this$0);
  }
}
;
_.this$0 = null;
_.val$form = null;
_.val$storedPortlet = null;
function $clinit_AutodiscoveryPortlet$Factory(){
  $clinit_AutodiscoveryPortlet$Factory = nullMethod;
  INSTANCE_15 = new AutodiscoveryPortlet$Factory_0;
}

function AutodiscoveryPortlet$Factory_0(){
}

defineSeed(2555, 1, makeCastMap([Q$PortletViewFactory]), AutodiscoveryPortlet$Factory_0);
_.getInstance = function getInstance_9(context){
  return new AutodiscoveryPortlet_0;
}
;
var INSTANCE_15;
function $clinit_ResourceSearchView(){
  $clinit_ResourceSearchView = nullMethod;
  $clinit_BaseWidget();
  DEFAULT_TITLE_0 = ($clinit_Enhanced() , 'Resources');
  DEFAULT_SORT_SPECIFIER_1 = initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [new SortSpecifier_0('name', ($clinit_SortDirection() , ASCENDING))]);
}

function $configureTable_3(this$static){
  var fields;
  fields = this$static.createFields();
  $setListGridFields(this$static, false, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $addTableAction(this$static, ($clinit_Enhanced() , 'Uninventory'), "Are you sure you want to uninventory the selected resources? Note that if a selected resource still exists, then it will get rediscovered during its agent's next discovery scan.", null, new ResourceSearchView$2_0(this$static, this$static, ($clinit_TableActionEnablement() , ANY_1), ($clinit_Permission() , DELETE_RESOURCE), new ResourceSearchView$1_0));
  $addTableAction(this$static, 'Disable', 'Are you sure you want to disable the selected resources? While disabled availabilities reported from the agent will be ignored. Disabling can be useful for resources that are expected to be down as part of normal operations or maintenance.', null, new ResourceSearchView$5_0(this$static, this$static, ANY_1, complementOf(of(($clinit_AvailabilityType() , DISABLED))), DELETE_RESOURCE, new ResourceSearchView$3_0, new ResourceSearchView$4_0));
  $addTableAction(this$static, 'Enable', 'Are you sure you want to enable the selected resources? When enabled the availability will be set to UNKNOWN until the agents next report availability for the resources.  The agents will be requested to report the current availabilities at their earliest convenience.', null, new ResourceSearchView$8_0(this$static, this$static, ANY_1, of(DISABLED), DELETE_RESOURCE, new ResourceSearchView$6_0, new ResourceSearchView$7_0));
  this$static.shouldShowIgnoreButton() && $addTableAction(this$static, 'Ignore', 'Are you sure you want the selected resources to be ignored? They will no longer show up in inventory.', null, new ResourceSearchView$11_0(this$static, this$static, ANY_1, DELETE_RESOURCE, new ResourceSearchView$10_0));
  this$static.shouldShowUnignoreButton() && $addTableAction(this$static, 'Unignore', 'Are you sure you want the selected resources to be unignored? This will bring them back into inventory and you will see them again.', null, new ResourceSearchView$13_0(this$static, this$static, ANY_1, DELETE_RESOURCE, new ResourceSearchView$12_0));
  this$static.exportable && $addTableAction(this$static, 'Export', 'Export', null, new ResourceSearchView$14_0(this$static));
  $setListGridDoubleClickHandler(this$static, new ResourceSearchView$9_0);
}

function $createFields(){
  var ancestryField, availabilityField, categoryField, ctimeField, descriptionField, fields, iconField, inventoryStatusField, itimeField, keyField, locationField, modifiedByField, mtimeField, nameField, pluginNameField, typeNameField, versionField;
  fields = new ArrayList_0;
  iconField = new IconField_0;
  $setAttribute_8(iconField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(iconField, new ResourceSearchView$15_0);
  setCheck(fields.array, fields.size_0++, iconField);
  nameField = new ListGridField_4(($clinit_ResourceDataSourceField() , NAME_31).propertyName, NAME_31.title_0, 250);
  $setCellFormatter_0(nameField, new ResourceSearchView$16_0);
  $setAttribute_8(nameField, 'showHover', TRUE);
  $setHoverCustomizer_0(nameField, new ResourceSearchView$17_0);
  setCheck(fields.array, fields.size_0++, nameField);
  keyField = new ListGridField_4(KEY.propertyName, KEY.title_0, 170);
  $setCellFormatter_0(keyField, new EscapedHtmlCellFormatter_0);
  setCheck(fields.array, fields.size_0++, keyField);
  ancestryField = setupAncestryListGridField();
  setCheck(fields.array, fields.size_0++, ancestryField);
  descriptionField = new ListGridField_3(DESCRIPTION_0.propertyName, DESCRIPTION_0.title_0);
  $setCellFormatter_0(descriptionField, new EscapedHtmlCellFormatter_0);
  setCheck(fields.array, fields.size_0++, descriptionField);
  locationField = new ListGridField_4(LOCATION.propertyName, LOCATION.title_0, 180);
  $setCellFormatter_0(locationField, new EscapedHtmlCellFormatter_0);
  setCheck(fields.array, fields.size_0++, locationField);
  typeNameField = new ListGridField_4(TYPE_56.propertyName, TYPE_56.title_0, 130);
  setCheck(fields.array, fields.size_0++, typeNameField);
  pluginNameField = new ListGridField_4(PLUGIN_2.propertyName, PLUGIN_2.title_0, 100);
  setCheck(fields.array, fields.size_0++, pluginNameField);
  versionField = new ListGridField_4(VERSION.propertyName, VERSION.title_0, 60);
  setCheck(fields.array, fields.size_0++, versionField);
  categoryField = new ListGridField_4(CATEGORY_0.propertyName, CATEGORY_0.title_0, 60);
  $setCellFormatter_0(categoryField, new ResourceCategoryCellFormatter_0);
  setCheck(fields.array, fields.size_0++, categoryField);
  availabilityField = new IconField_2(AVAILABILITY_2.propertyName, AVAILABILITY_2.title_0, 70);
  setCheck(fields.array, fields.size_0++, availabilityField);
  ctimeField = new ListGridField_4(CTIME.propertyName, CTIME.title_0, 120);
  $setCellFormatter_0(ctimeField, new TimestampCellFormatter_0);
  setCheck(fields.array, fields.size_0++, ctimeField);
  itimeField = new ListGridField_4(ITIME.propertyName, ITIME.title_0, 120);
  $setCellFormatter_0(itimeField, new TimestampCellFormatter_0);
  setCheck(fields.array, fields.size_0++, itimeField);
  mtimeField = new ListGridField_4(MTIME.propertyName, MTIME.title_0, 120);
  $setCellFormatter_0(mtimeField, new TimestampCellFormatter_0);
  setCheck(fields.array, fields.size_0++, mtimeField);
  modifiedByField = new ListGridField_4(MODIFIER_0.propertyName, MODIFIER_0.title_0, 100);
  setCheck(fields.array, fields.size_0++, modifiedByField);
  inventoryStatusField = new ListGridField_4(INVENTORY_STATUS.propertyName, INVENTORY_STATUS.title_0, 100);
  setCheck(fields.array, fields.size_0++, inventoryStatusField);
  return fields;
}

function ResourceSearchView_0(criteria){
  $clinit_ResourceSearchView();
  ResourceSearchView_1.call(this, criteria, null, false, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, []));
}

function ResourceSearchView_1(criteria, title, exportable, headerIcons){
  var datasource, headerIcon, headerIcon$index, headerIcon$max;
  Table_5.call(this, null == title?DEFAULT_TITLE_0:title, criteria, DEFAULT_SORT_SPECIFIER_1, null);
  new ArrayList_0;
  this.exportable = exportable;
  for (headerIcon$index = 0 , headerIcon$max = headerIcons.length; headerIcon$index < headerIcon$max; ++headerIcon$index) {
    headerIcon = headerIcons[headerIcon$index];
    $add_3(this.headerIcons, headerIcon);
  }
  datasource = this.getDataSourceInstance();
  this.dataSource_1 = datasource;
}

function ResourceSearchView_2(criteria, title, headerIcons){
  $clinit_ResourceSearchView();
  ResourceSearchView_1.call(this, criteria, title, false, headerIcons);
}

function ResourceSearchView_3(criteria){
  $clinit_ResourceSearchView();
  ResourceSearchView_1.call(this, criteria, null, true, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, []));
}

defineSeed(2557, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ResourceSearchView_2, ResourceSearchView_3);
_.configureTable = function configureTable_25(){
  $configureTable_3(this);
}
;
_.createFields = function createFields_0(){
  return $createFields();
}
;
_.getDataSourceInstance = function getDataSourceInstance(){
  return $clinit_RPCDataSource() , !INSTANCE_40 && (INSTANCE_40 = new ResourceDatasource_0) , $clinit_RPCDataSource() , INSTANCE_40;
}
;
_.getSearchSubsystem = function getSearchSubsystem_1(){
  return $clinit_SearchSubsystem() , RESOURCE_2;
}
;
_.shouldShowIgnoreButton = function shouldShowIgnoreButton(){
  return true;
}
;
_.shouldShowUnignoreButton = function shouldShowUnignoreButton(){
  return false;
}
;
_.exportable = false;
var DEFAULT_SORT_SPECIFIER_1, DEFAULT_TITLE_0;
function $clinit_FavoriteResourcesPortlet(){
  $clinit_FavoriteResourcesPortlet = nullMethod;
  $clinit_ResourceSearchView();
  NAME_10 = ($clinit_Enhanced() , 'Favorite Resources');
}

function FavoriteResourcesPortlet_0(){
  var favoriteIds, favArray, criteria;
  $clinit_FavoriteResourcesPortlet();
  ResourceSearchView_0.call(this, (favoriteIds = $getPreferenceAsIntegerSet(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), '.dashContent.resourcehealth.resources') , favArray = dynamicCast(favoriteIds.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, favoriteIds.size_1(), 0)), Q$Integer_$1) , criteria = new Criteria_0 , favoriteIds.isEmpty_0()?$addCriteria_1(criteria, 'id', valueOf_44(-1)):(criteria.jsObj['resourceIds'] = convertToJavaScriptArray(favArray) , undefined) , criteria));
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  this.showHeader = false;
  this.showFooter = false;
}

defineSeed(2556, 2557, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$AutoRefreshPortlet, Q$Enhanced, Q$EnhancedHLayout]), FavoriteResourcesPortlet_0);
_.configure = function configure_11(portletWindow, storedPortlet){
  !this.portletWindow && !!portletWindow && (this.portletWindow = portletWindow);
}
;
_.configureTable = function configureTable_26(){
  var listGrid, state, storedPortlet, tablePrefs;
  $configureTable_3(this);
  $addFieldStateChangedHandler(this.listGrid, new FavoriteResourcesPortlet$1_0(this));
  storedPortlet = this.portletWindow.storedPortlet;
  if (!!storedPortlet && !!storedPortlet.configuration) {
    tablePrefs = $getSimple(storedPortlet.configuration, 'tablePreferences');
    listGrid = this.listGrid;
    if (!!tablePrefs && !!listGrid) {
      state = tablePrefs.stringValue;
      $setViewState(listGrid, state);
    }
  }
}
;
_.getHelpCanvas = function getHelpCanvas_11(){
  return new HTMLFlow_1(($clinit_Enhanced() , "This portlet displays the current user's  favorite resources."));
}
;
_.isRefreshing = function isRefreshing_10(){
  return false;
}
;
_.onDestroy = function onDestroy_12(){
  onDestroy_0(this.refreshTimer);
}
;
_.refresh_0 = function refresh_20(){
  $refresh(this, false);
}
;
_.startRefreshCycle = function startRefreshCycle_11(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.portletWindow = null;
_.refreshTimer = null;
var NAME_10;
function FavoriteResourcesPortlet$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2558, 1, makeCastMap([Q$EventHandler, Q$FieldStateChangedHandler]), FavoriteResourcesPortlet$1_0);
_.onFieldStateChanged = function onFieldStateChanged_0(fieldStateChangedEvent){
  var state;
  state = $getViewState(this.this$0.listGrid);
  $put_4(this.this$0.portletWindow.storedPortlet.configuration, new PropertySimple_1('tablePreferences', state));
  $save_3(this.this$0.portletWindow.dashboardView);
}
;
_.this$0 = null;
function $clinit_FavoriteResourcesPortlet$Factory(){
  $clinit_FavoriteResourcesPortlet$Factory = nullMethod;
  INSTANCE_16 = new FavoriteResourcesPortlet$Factory_0;
}

function FavoriteResourcesPortlet$Factory_0(){
}

defineSeed(2559, 1, makeCastMap([Q$PortletViewFactory]), FavoriteResourcesPortlet$Factory_0);
_.getInstance = function getInstance_10(context){
  return new FavoriteResourcesPortlet_0;
}
;
var INSTANCE_16;
function $clinit_ResourceD3GraphPortlet(){
  $clinit_ResourceD3GraphPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_11 = ($clinit_Enhanced() , 'Resource Metric Graph');
}

function $configure_9(this$static, portletWindow, storedPortlet){
  var entityId, measurementDefId, measurementDefIdProperty, resourceIdProperty, resourceService, resourceCriteria;
  $clinit_Log();
  $fine_0(logger_0, 'ResourceD3GraphPortlet Configure');
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  destroyMembers(this$static);
  this$static.graph = new StackedBarMetricGraphIE8Impl_0;
  $setMetricGraphData(this$static.graph, ($clinit_MetricGraphData() , new MetricGraphData_0(portletWindow.storedPortlet)));
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  if ($getSimple(storedPortlet.configuration, 'resourceId')) {
    resourceIdProperty = $getSimple(storedPortlet.configuration, 'resourceId');
    measurementDefIdProperty = $getSimple(storedPortlet.configuration, 'definitionId');
    if (!!resourceIdProperty && !!measurementDefIdProperty) {
      entityId = resourceIdProperty.stringValue == null?null:valueOf_44(__parseAndValidateInt(resourceIdProperty.stringValue));
      measurementDefId = measurementDefIdProperty.stringValue == null?null:valueOf_44(__parseAndValidateInt(measurementDefIdProperty.stringValue));
      !!entityId && !!measurementDefId && (resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync) , resourceCriteria = new ResourceCriteria_0 , resourceCriteria.filterId = entityId , $findResourcesByCriteria(resourceService, resourceCriteria, new ResourceD3GraphPortlet$1_0(this$static, measurementDefId)) , undefined);
    }
  }
}

function ResourceD3GraphPortlet_0(){
  $clinit_ResourceD3GraphPortlet();
  MetricD3GraphView_0.call(this);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , HIDDEN).value_0, false);
}

defineSeed(2560, 2543, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), ResourceD3GraphPortlet_0);
_.configure = function configure_12(portletWindow, storedPortlet){
  $configure_9(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_9(){
  var form, integerValue, metric, propertySimple, resourceLookupComboBoxItem, storedPortlet;
  form = new DynamicForm_0;
  resourceLookupComboBoxItem = new ResourceLookupComboBoxItem_0(($clinit_Enhanced() , 'Resource'));
  $isCreated_2(resourceLookupComboBoxItem)?$setProperty_6(resourceLookupComboBoxItem, 'width', 300):(resourceLookupComboBoxItem.jsObj['width'] = 300 , undefined);
  metric = new ResourceD3GraphPortlet$2_0('Metric', resourceLookupComboBoxItem);
  storedPortlet = this.portletWindow.storedPortlet;
  $isCreated_2(metric)?$setProperty_6(metric, 'width', 300):(metric.jsObj['width'] = 300 , undefined);
  $isCreated_2(metric)?$setProperty_8(metric, 'valueField', 'id'):(metric.jsObj['valueField'] = 'id' , undefined);
  $isCreated_2(metric)?$setProperty_8(metric, 'displayField', 'displayName'):(metric.jsObj['displayField'] = 'displayName' , undefined);
  $setOptionDataSource_0(metric, new ResourceScheduledMetricDatasource_0);
  $addChangedHandler(resourceLookupComboBoxItem, new ResourceD3GraphPortlet$3_0(form, metric));
  if ($getSimple(storedPortlet.configuration, 'resourceId')) {
    integerValue = $getIntegerValue($getSimple(storedPortlet.configuration, 'resourceId'));
    !!integerValue && $setValue(form, 'resourceId', integerValue.value_0);
    propertySimple = $getSimple(storedPortlet.configuration, 'definitionId');
    !!propertySimple && !!(propertySimple.stringValue == null?null:valueOf_44(__parseAndValidateInt(propertySimple.stringValue))) && $setValue(form, 'definitionId', (propertySimple.stringValue == null?null:valueOf_44(__parseAndValidateInt(propertySimple.stringValue))).value_0);
  }
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [resourceLookupComboBoxItem, metric]));
  $addSubmitValuesHandler(form, new ResourceD3GraphPortlet$4_0(this, storedPortlet, form));
  return form;
}
;
_.getFullChartId = function getFullChartId_1(){
  return !!this.portletWindow && !!this.graph && !!this.graph.metricGraphData?'rChart-' + $getChartId(this.graph.metricGraphData) + '-' + this.portletWindow.storedPortlet.id:'';
}
;
_.getHelpCanvas = function getHelpCanvas_12(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet displays the resource metric graph.'));
}
;
_.isRefreshing = function isRefreshing_11(){
  return false;
}
;
_.onDestroy = function onDestroy_13(){
  onDestroy_0(this.refreshTimer);
}
;
_.onDraw_0 = function onDraw_28(){
  var simple, storedPortlet;
  $clinit_Log();
  $fine_0(logger_0, 'ResourceD3GraphPortlet.onDraw()');
  storedPortlet = this.portletWindow.storedPortlet;
  if (isBrowserPreIE9()) {
    $removeMembers(this, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')));
    $addMember(this, new Label_4('<i>' + ($clinit_Enhanced() , 'Charting is not available for this browser.') + '<\/i>'));
  }
   else {
    simple = $getSimple(storedPortlet.configuration, 'resourceId');
    if (!simple || !(simple.stringValue == null?null:valueOf_44(__parseAndValidateInt(simple.stringValue)))) {
      $removeMembers(this, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')));
      $addMember(this, new Label_4('<i>' + ($clinit_Enhanced() , 'Click the Settings button to configure this portlet.') + '<\/i>'));
    }
     else {
      !!this.graph.metricGraphData.definition && $drawGraph(this);
    }
  }
}
;
_.redraw_0 = function redraw_3(){
  var simple, simpleDefId, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  simple = $getSimple(storedPortlet.configuration, 'resourceId');
  if (!simple || !(simple.stringValue == null?null:valueOf_44(__parseAndValidateInt(simple.stringValue)))) {
    $removeMembers(this, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')));
    $addMember(this, new Label_4('<i>' + ($clinit_Enhanced() , 'Click the Settings button to configure this portlet.') + '<\/i>'));
  }
   else {
    $setEntityId_0(this.graph.metricGraphData, (simple.stringValue == null?null:valueOf_44(__parseAndValidateInt(simple.stringValue))).value_0);
    simpleDefId = $getSimple(storedPortlet.configuration, 'definitionId');
    $setDefinitionId(this.graph.metricGraphData, (simpleDefId.stringValue == null?null:valueOf_44(__parseAndValidateInt(simpleDefId.stringValue))).value_0);
    debug('Redraw Portlet for entityId: ' + (simple.stringValue == null?null:valueOf_44(__parseAndValidateInt(simple.stringValue))) + '-' + (simpleDefId.stringValue == null?null:valueOf_44(__parseAndValidateInt(simpleDefId.stringValue))));
    isBrowserPreIE9() || $drawGraph(this);
  }
  $redraw(this);
}
;
_.refresh_0 = function refresh_21(){
  $isVisible(this) && $drawGraph(this);
}
;
_.startRefreshCycle = function startRefreshCycle_12(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.portletWindow = null;
var NAME_11;
function $onSuccess_202(this$static, result){
  var ancestries, resource, typesSet;
  if (result.size_0 == 0) {
    return;
  }
  resource = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Resource);
  typesSet = new HashSet_0;
  $add_6(typesSet, valueOf_44(resource.resourceType.id));
  ancestries = new HashSet_0;
  $add_6(ancestries, resource.ancestry);
  $addAll(typesSet, getAncestryTypeIds(ancestries));
  $getResourceTypes_0(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), of(($clinit_ResourceTypeRepository$MetadataType() , measurements_0)), new ResourceD3GraphPortlet$1$1_0(this$static, resource, this$static.val$measurementDefId));
}

function ResourceD3GraphPortlet$1_0(this$0, val$measurementDefId){
  this.this$0 = this$0;
  this.val$measurementDefId = val$measurementDefId;
}

defineSeed(2561, 1, {}, ResourceD3GraphPortlet$1_0);
_.onFailure = function onFailure_213(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to find resource for graph'), caught);
}
;
_.onSuccess_0 = function onSuccess_213(result){
  $onSuccess_202(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$measurementDefId = null;
function ResourceD3GraphPortlet$1$1_0(this$1, val$resource, val$measurementDefId){
  this.this$1 = this$1;
  this.val$resource = val$resource;
  this.val$measurementDefId = val$measurementDefId;
}

defineSeed(2562, 1, {}, ResourceD3GraphPortlet$1$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_11(types){
  var def, def$iterator, startTime, type;
  type = dynamicCast(types.get_2(valueOf_44(this.val$resource.resourceType.id)), Q$ResourceType);
  for (def$iterator = type.metricDefinitions.iterator(); def$iterator.hasNext();) {
    def = dynamicCast(def$iterator.next_0(), Q$MeasurementDefinition);
    if (def.id == this.val$measurementDefId.value_0) {
      $clinit_Log();
      $fine_0(logger_0, 'Found portlet measurement definition !' + def);
      $setEntityId(this.this$1.this$0.graph, this.val$resource.id);
      $setEntityName(this.this$1.this$0.graph, this.val$resource.name_0);
      $setDefinition(this.this$1.this$0.graph, def);
      startTime = fromDouble(currentTimeMillis0());
      $findDataForResourceForLast(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this.val$resource.id, initValues(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [def.id]), 8, 3, new ResourceD3GraphPortlet$1$1$1_0(this, startTime));
      break;
    }
  }
}
;
_.this$1 = null;
_.val$measurementDefId = null;
_.val$resource = null;
function $onSuccess_203(this$static, measurementData){
  debug('Dashboard Metric data in: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this$static.val$startTime)) + ' ms.');
  dynamicCast(measurementData.get_0(0), Q$List);
  isBrowserPreIE9() || $drawGraph(this$static.this$2.this$1.this$0);
}

function ResourceD3GraphPortlet$1$1$1_0(this$2, val$startTime){
  this.this$2 = this$2;
  this.val$startTime = val$startTime;
}

defineSeed(2563, 1, {}, ResourceD3GraphPortlet$1$1$1_0);
_.onFailure = function onFailure_214(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load graph data'), caught);
}
;
_.onSuccess_0 = function onSuccess_214(measurementData){
  $onSuccess_203(this, dynamicCast(measurementData, Q$List));
}
;
_.this$2 = null;
_.val$startTime = P0_longLit;
function ResourceD3GraphPortlet$2_0($anonymous1, val$resourceLookupComboBoxItem){
  $clinit_SelectItem();
  this.val$resourceLookupComboBoxItem = val$resourceLookupComboBoxItem;
  SelectItem_2.call(this, 'definitionId', $anonymous1);
}

defineSeed(2564, 512, makeCastMap([Q$HasHandlers, Q$DataClass, Q$JsObject, Q$RefDataClass, Q$FormItem, Q$SelectItem, Q$HasBlurHandlers, Q$HasChangeHandlers, Q$HasChangedHandlers, Q$HasClickHandlers_0, Q$HasDoubleClickHandlers_0, Q$HasFocusHandlers, Q$HasIconClickHandlers_0, Q$HasIconKeyPressHandlers, Q$HasItemHoverHandlers, Q$HasKeyDownHandlers_0, Q$HasKeyPressHandlers_0, Q$HasKeyUpHandlers, Q$HasTitleClickHandlers, Q$HasTitleDoubleClickHandlers, Q$HasTitleHoverHandlers]), ResourceD3GraphPortlet$2_0);
_.getPickListFilterCriteria_0 = function getPickListFilterCriteria_2(){
  var criteria, resourceId;
  criteria = new Criteria_0;
  if ($getValue_0(this.val$resourceLookupComboBoxItem) != null) {
    resourceId = dynamicCast($getValue_0(this.val$resourceLookupComboBoxItem), Q$Integer).value_0;
    $addCriteria_1(criteria, 'resourceId', valueOf_44(resourceId));
  }
  return criteria;
}
;
_.val$resourceLookupComboBoxItem = null;
function ResourceD3GraphPortlet$3_0(val$form, val$metric){
  this.val$form = val$form;
  this.val$metric = val$metric;
}

defineSeed(2565, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ResourceD3GraphPortlet$3_0);
_.onChanged = function onChanged_49(event_0){
  if (instanceOf($getValue(this.val$form, 'resourceId'), Q$Integer)) {
    $fetchData_2(this.val$metric);
    $clearValue(this.val$form, 'definitionId');
  }
}
;
_.val$form = null;
_.val$metric = null;
function ResourceD3GraphPortlet$4_0(this$0, val$storedPortlet, val$form){
  this.this$0 = this$0;
  this.val$storedPortlet = val$storedPortlet;
  this.val$form = val$form;
}

defineSeed(2566, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), ResourceD3GraphPortlet$4_0);
_.onSubmitValues = function onSubmitValues_9(submitValuesEvent){
  $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('resourceId', $getValue(this.val$form, 'resourceId')));
  $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('definitionId', $getValue(this.val$form, 'definitionId')));
  $configure_9(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
}
;
_.this$0 = null;
_.val$form = null;
_.val$storedPortlet = null;
function $clinit_ResourceD3GraphPortlet$Factory(){
  $clinit_ResourceD3GraphPortlet$Factory = nullMethod;
  INSTANCE_17 = new ResourceD3GraphPortlet$Factory_0;
}

function ResourceD3GraphPortlet$Factory_0(){
}

defineSeed(2567, 1, makeCastMap([Q$PortletViewFactory]), ResourceD3GraphPortlet$Factory_0);
_.getInstance = function getInstance_11(context){
  return new ResourceD3GraphPortlet_0;
}
;
var INSTANCE_17;
function $copyValues_34(summary){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', summary.resource.id);
  $setAttribute_13(record, 'name', summary.resource.name_0);
  $setAttribute_13(record, 'version', summary.resource.version_0);
  $setAttribute_13(record, ($clinit_ResourceDataSourceField() , AVAILABILITY_2).propertyName, getAvailabilityIconFromAvailTypeAndSize(summary.resource.currentAvailability.availabilityType, false));
  if (summary.metricsAvailable) {
    $setAttribute_12(record, ($clinit_PlatformMetricsSummary$CPUMetric() , Idle).property, summary.idleCPU.getValue_1());
    $setAttribute_12(record, ($clinit_PlatformMetricsSummary$MemoryMetric() , Total).property, summary.totalMemory.getValue_1());
    $setAttribute_12(record, ActualUsed.property, summary.actualUsedMemory.getValue_1());
    $setAttribute_12(record, ($clinit_PlatformMetricsSummary$SwapMetric() , Total_0).property, summary.totalSwap.getValue_1());
    $setAttribute_12(record, Used_0.property, summary.usedSwap.getValue_1());
  }
   else {
    record.jsObj['cpu'] = 'N/A';
    record.jsObj['memory'] = 'N/A';
    record.jsObj['swap'] = 'N/A';
  }
  return record;
}

function $executeFetch_20(this$static, request, response){
  $loadPlatformMetrics(dynamicCast(secure(getInstance_46(), 0), Q$PlatformUtilizationGWTServiceAsync), new PlatformMetricDataSource$1_0(this$static, response, request));
}

function PlatformMetricDataSource_0(){
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  fields = new ArrayList_0;
  $addFields(this, fields);
}

defineSeed(2568, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), PlatformMetricDataSource_0);
_.copyValues = function copyValues_56(from){
  return null;
}
;
_.copyValues_0 = function copyValues_57(summary){
  return $copyValues_34(dynamicCast(summary, Q$PlatformMetricsSummary));
}
;
_.executeFetch = function executeFetch_32(request, response, criteria){
  $executeFetch_20(this, request, response, dynamicCast(criteria, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_36(request){
  return null;
}
;
function $onFailure_24(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load platform utilization data'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_204(this$static, result){
  var records;
  records = $buildRecords(this$static.this$0, result, true);
  $setAttribute_17(this$static.val$response, 'data', records);
  $setTotalRows(this$static.val$response, valueOf_44(records.length));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function PlatformMetricDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2569, 1, {}, PlatformMetricDataSource$1_0);
_.onFailure = function onFailure_215(caught){
  $onFailure_24(this, caught);
}
;
_.onSuccess_0 = function onSuccess_215(result){
  $onSuccess_204(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $clinit_PlatformSummaryPortlet(){
  $clinit_PlatformSummaryPortlet = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_18 = new ViewName_2('PlatformUtilization', ($clinit_Enhanced() , 'Platform Utilization'), ($clinit_IconEnum() , PLATFORM_UTILIZATION));
  NAME_12 = 'Platform Utilization';
}

function PlatformSummaryPortlet_0(){
  $clinit_PlatformSummaryPortlet();
  PlatformSummaryPortlet_1.call(this, false);
}

function PlatformSummaryPortlet_1(isExportable){
  $clinit_PlatformSummaryPortlet();
  Table_1.call(this);
  $setDataSource(this, new PlatformMetricDataSource_0);
  this.exportable = isExportable;
}

defineSeed(2570, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), PlatformSummaryPortlet_0, PlatformSummaryPortlet_1);
_.configure = function configure_13(portletWindow, storedPortlet){
}
;
_.configureTable = function configureTable_27(){
  var availabilityField, cpuField, memoryField, nameField, swapField, versionField;
  nameField = new ListGridField_3(($clinit_ResourceDataSourceField() , NAME_31).propertyName, ($clinit_Enhanced() , 'Name'));
  $setCellFormatter_0(nameField, new PlatformSummaryPortlet$1_0);
  availabilityField = new IconField_2(AVAILABILITY_2.propertyName, 'Availability', 70);
  versionField = new ListGridField_3(VERSION.propertyName, 'Version');
  cpuField = new ListGridField_3('cpu', 'CPU');
  memoryField = new ListGridField_3('memory', 'Memory');
  swapField = new ListGridField_3('swap', 'Swap');
  nameField.jsObj['width'] = '20%';
  availabilityField.jsObj['width'] = 70;
  versionField.jsObj['width'] = '20%';
  cpuField.jsObj['width'] = '20%';
  memoryField.jsObj['width'] = '20%';
  swapField.jsObj['width'] = '20%';
  $setAttribute_8(cpuField, 'canSort', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_8(memoryField, 'canSort', FALSE);
  $setAttribute_8(swapField, 'canSort', FALSE);
  $setListGridFields(this, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [nameField, availabilityField, versionField, cpuField, memoryField, swapField]));
  this.exportable && $addTableAction(this, 'Export', 'Export', null, new PlatformSummaryPortlet$2_0(this));
}
;
_.createListGrid = function createListGrid_1(){
  return new PlatformSummaryPortlet$3_0;
}
;
_.getHelpCanvas = function getHelpCanvas_13(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet displays utilization data (such as current CPU and memory usage) for platform resources that are accessible by the current user.'));
}
;
_.getViewName = function getViewName_7(){
  return VIEW_ID_18;
}
;
_.exportable = false;
var NAME_12, VIEW_ID_18;
function PlatformSummaryPortlet$1_0(){
}

defineSeed(2571, 1, {}, PlatformSummaryPortlet$1_0);
_.format_1 = function format_32(o, listGridRecord, i, i1){
  return '<a href="#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'id').value_0 + '">' + o + '<\/a>';
}
;
function PlatformSummaryPortlet$2_0(this$0){
  this.this$0 = this$0;
  AbstractTableAction_0.call(this);
}

defineSeed(2572, 1608, {}, PlatformSummaryPortlet$2_0);
_.executeAction = function executeAction_35(selection, actionValue){
  var exporter;
  exporter = new ReportExporter_0('platformUtilization');
  $export(exporter);
  $refreshTableInfo(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_15(selection){
  return $enableIfRecordsExist(this.this$0.listGrid);
}
;
_.this$0 = null;
function PlatformSummaryPortlet$3_0(){
  $clinit_BaseWidget();
  ListGrid_0.call(this);
  $setShowRecordComponents(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setShowRecordComponentsByCell(this, TRUE);
  $setAttribute_24(this, 'autoFitData', ($clinit_Autofit() , VERTICAL).value_0, true);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, true);
  $setShowEmptyMessage(this, FALSE);
}

defineSeed(2573, 538, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers]), PlatformSummaryPortlet$3_0);
_.createRecordComponent_0 = function createRecordComponent_0(listGridRecord, colNum){
  var $e0, bar, fieldName, first, percent, second, text, total, used, value;
  fieldName = $getFieldName(this, colNum.value_0);
  try {
    if ($equals_6(fieldName, 'cpu')) {
      if ($getAttribute(listGridRecord, ($clinit_PlatformMetricsSummary$CPUMetric() , Idle).property) != null) {
        bar = new HLayout_0;
        $isCreated_1(bar)?$setProperty_0(bar, 'height', 18):(bar.config_0['height'] = 18 , undefined);
        $isCreated_1(bar)?$setProperty_3(bar, 'width', '100%'):(bar.config_0['width'] = '100%' , undefined);
        value = $getAttributeAsDouble(listGridRecord, Idle.property).value_0;
        value = 1 - value;
        text = new Label_3;
        $setWrap_0(text, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
        $setAutoFit_0(text, TRUE);
        $setContents_0(text, ($clinit_MeasurementConverterClient() , format_91(new Double_0(value), ($clinit_MeasurementUnits() , PERCENTAGE))));
        $addMember(bar, text);
        first = new Img_1('availBar/up.png');
        $isCreated_1(first)?$setProperty_0(first, 'height', 18):(first.config_0['height'] = 18 , undefined);
        $isCreated_1(first)?$setProperty_3(first, 'width', value * 100 + '%'):(first.config_0['width'] = value * 100 + '%' , undefined);
        $addMember(bar, first);
        second = new Img_1('availBar/unknown.png');
        $isCreated_1(second)?$setProperty_0(second, 'height', 18):(second.config_0['height'] = 18 , undefined);
        $isCreated_1(second)?$setProperty_3(second, 'width', 100 - value * 100 + '%'):(second.config_0['width'] = 100 - value * 100 + '%' , undefined);
        $addMember(bar, second);
        return bar;
      }
    }
     else if ($equals_6(fieldName, 'memory')) {
      if ($getAttribute(listGridRecord, ($clinit_PlatformMetricsSummary$MemoryMetric() , Total).property) != null) {
        bar = new HLayout_0;
        $isCreated_1(bar)?$setProperty_0(bar, 'height', 18):(bar.config_0['height'] = 18 , undefined);
        $isCreated_1(bar)?$setProperty_3(bar, 'width', '100%'):(bar.config_0['width'] = '100%' , undefined);
        total = $getAttributeAsDouble(listGridRecord, Total.property).value_0;
        used = $getAttributeAsDouble(listGridRecord, ActualUsed.property).value_0;
        percent = used / total;
        text = new Label_3;
        $setWrap_0(text, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
        $setAutoFit_0(text, TRUE);
        $setContents_0(text, ($clinit_MeasurementConverterClient() , format_91(new Double_0(percent), ($clinit_MeasurementUnits() , PERCENTAGE))));
        $addMember(bar, text);
        first = new Img_1('availBar/up.png');
        $isCreated_1(first)?$setProperty_0(first, 'height', 18):(first.config_0['height'] = 18 , undefined);
        $isCreated_1(first)?$setProperty_3(first, 'width', percent * 100 + '%'):(first.config_0['width'] = percent * 100 + '%' , undefined);
        $addMember(bar, first);
        second = new Img_1('availBar/unknown.png');
        $isCreated_1(second)?$setProperty_0(second, 'height', 18):(second.config_0['height'] = 18 , undefined);
        $isCreated_1(second)?$setProperty_3(second, 'width', 100 - percent * 100 + '%'):(second.config_0['width'] = 100 - percent * 100 + '%' , undefined);
        $addMember(bar, second);
        return bar;
      }
    }
     else if ($equals_6(fieldName, 'swap')) {
      if ($getAttribute(listGridRecord, ($clinit_PlatformMetricsSummary$SwapMetric() , Total_0).property) != null) {
        bar = new HLayout_0;
        $isCreated_1(bar)?$setProperty_0(bar, 'height', 18):(bar.config_0['height'] = 18 , undefined);
        $isCreated_1(bar)?$setProperty_3(bar, 'width', '100%'):(bar.config_0['width'] = '100%' , undefined);
        total = $getAttributeAsDouble(listGridRecord, Total_0.property).value_0;
        value = $getAttributeAsDouble(listGridRecord, Used_0.property).value_0;
        percent = value / total;
        text = new Label_3;
        $setWrap_0(text, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
        $setAutoFit_0(text, TRUE);
        $setContents_0(text, ($clinit_MeasurementConverterClient() , format_91(new Double_0(percent), ($clinit_MeasurementUnits() , PERCENTAGE))));
        $addMember(bar, text);
        first = new Img_1('availBar/up.png');
        $isCreated_1(first)?$setProperty_0(first, 'height', 18):(first.config_0['height'] = 18 , undefined);
        $isCreated_1(first)?$setProperty_3(first, 'width', percent * 100 + '%'):(first.config_0['width'] = percent * 100 + '%' , undefined);
        $addMember(bar, first);
        second = new Img_1('availBar/unknown.png');
        $isCreated_1(second)?$setProperty_0(second, 'height', 18):(second.config_0['height'] = 18 , undefined);
        $isCreated_1(second)?$setProperty_3(second, 'width', 100 - percent * 100 + '%'):(second.config_0['width'] = 100 - percent * 100 + '%' , undefined);
        $addMember(bar, second);
        return bar;
      }
    }
    return null;
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      return null;
    }
     else 
      throw $e0;
  }
}
;
function $clinit_PlatformSummaryPortlet$Factory(){
  $clinit_PlatformSummaryPortlet$Factory = nullMethod;
  INSTANCE_18 = new PlatformSummaryPortlet$Factory_0;
}

function PlatformSummaryPortlet$Factory_0(){
}

defineSeed(2574, 1, makeCastMap([Q$PortletViewFactory]), PlatformSummaryPortlet$Factory_0);
_.getInstance = function getInstance_12(context){
  return new PlatformSummaryPortlet_0;
}
;
var INSTANCE_18;
function AbstractRecentAlertsPortlet$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2575, 1, {}, AbstractRecentAlertsPortlet$1_0);
_.format_1 = function format_33(value, record, i, i1){
  var formattedValue, url;
  url = $getAlertDetailLink(this.this$0, record);
  formattedValue = ($clinit_TimestampCellFormatter() , format_30(value, DATE_TIME_FORMAT_MEDIUM));
  return getHref(url, formattedValue);
}
;
_.this$0 = null;
function AbstractRecentAlertsPortlet$2_0(this$0, val$alertPrioritySelector, val$portletConfig, val$resultCountSelector, val$measurementRangeEditor, val$storedPortlet){
  this.this$0 = this$0;
  this.val$alertPrioritySelector = val$alertPrioritySelector;
  this.val$portletConfig = val$portletConfig;
  this.val$resultCountSelector = val$resultCountSelector;
  this.val$measurementRangeEditor = val$measurementRangeEditor;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2576, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), AbstractRecentAlertsPortlet$2_0);
_.onSubmitValues = function onSubmitValues_10(event_0){
  var selectedValue;
  selectedValue = null == $getValue_0(this.val$alertPrioritySelector)?'':toString__devirtual$($getValue_0(this.val$alertPrioritySelector));
  (!$trim(selectedValue).length || $split(selectedValue, ',', 0).length == ($clinit_AlertPriority() , $clinit_AlertPriority() , $VALUES_46).length) && (selectedValue = '');
  $put_4(this.val$portletConfig, new PropertySimple_1('ALERT_PRIORITY', selectedValue));
  selectedValue = toString__devirtual$($getValue_0(this.val$resultCountSelector));
  !$trim(selectedValue).length && (selectedValue = '5');
  $put_4(this.val$portletConfig, new PropertySimple_1('RESULT_COUNT', selectedValue));
  $saveMeasurementRangeEditorSettings(this.val$measurementRangeEditor, this.val$portletConfig);
  $setConfiguration_0(this.val$storedPortlet, this.val$portletConfig);
  $configure(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $refresh(this.this$0, false);
}
;
_.this$0 = null;
_.val$alertPrioritySelector = null;
_.val$measurementRangeEditor = null;
_.val$portletConfig = null;
_.val$resultCountSelector = null;
_.val$storedPortlet = null;
function $setConfiguration_1(this$static, configuration){
  this$static.configuration = configuration;
}

function AbstractRecentAlertsPortlet$AlertsPortletDataSource_0(entityContext){
  $clinit_AlertDataSource();
  AlertDataSource_0.call(this, entityContext);
  this.configuration = null;
}

defineSeed(2577, 1864, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AlertDataSource]), AbstractRecentAlertsPortlet$AlertsPortletDataSource_0);
_.getFetchCriteria_0 = function getFetchCriteria_37(request){
  var beginEnd, criteria, currentSetting, filterPriorities, indx, isAdvanced, lastN, orderingField, p, pageSize, parsedValues, priority, priority$index, priority$max, property, range, units;
  criteria = new AlertCriteria_0;
  currentSetting = $getSimpleValue(this.configuration, 'RESULT_COUNT', '5');
  pageSize = valueOf_44(__parseAndValidateInt(currentSetting)).value_0;
  orderingField = new OrderingField_1('ctime', ($clinit_PageOrdering() , DESC));
  $setPageControl(criteria, new PageControl_2(pageSize, initValues(_3Lorg_rhq_core_domain_util_OrderingField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$OrderingField, [orderingField])));
  currentSetting = $getSimpleValue(this.configuration, 'ALERT_PRIORITY', '');
  parsedValues = $split($trim(currentSetting), ',', 0);
  if (!(!$trim(currentSetting).length || parsedValues.length == ($clinit_AlertPriority() , $clinit_AlertPriority() , $VALUES_46).length)) {
    filterPriorities = initDim(_3Lorg_rhq_core_domain_alert_AlertPriority_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$AlertPriority_$1]), Q$AlertPriority, parsedValues.length, 0);
    indx = 0;
    for (priority$index = 0 , priority$max = parsedValues.length; priority$index < priority$max; ++priority$index) {
      priority = parsedValues[priority$index];
      p = ($clinit_AlertPriority() , dynamicCast(valueOf(($clinit_AlertPriority$Map() , $MAP_46), priority), Q$AlertPriority));
      filterPriorities[indx++] = p;
    }
    criteria.filterPriorities = getListIgnoringNulls(filterPriorities);
  }
  property = $getSimple(this.configuration, 'METRIC_RANGE_ENABLE');
  if (!!property && ($clinit_Boolean() , (property.stringValue == null?null:$equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE).value_0?TRUE:FALSE).value_0) {
    isAdvanced = ($clinit_Boolean() , $equalsIgnoreCase('true', $getSimpleValue(this.configuration, 'METRIC_RANGE_BEGIN_END_FLAG', ($clinit_PortletConfigurationEditorComponent$Constant() , 'false')))?TRUE:FALSE).value_0;
    if (isAdvanced) {
      currentSetting = $getSimpleValue(this.configuration, 'METRIC_RANGE', '');
      range = $split(currentSetting, ',', 0);
      if (range.length == 2) {
        $addFilterStartTime_0(criteria, new Long_0(__parseAndValidateLong(range[0])));
        $addFilterEndTime_0(criteria, new Long_0(__parseAndValidateLong(range[1])));
      }
    }
     else {
      property = $getSimple(this.configuration, 'METRIC_RANGE_LASTN');
      if (property) {
        lastN = valueOf_44(__parseAndValidateInt($getSimpleValue(this.configuration, 'METRIC_RANGE_LASTN', '8')));
        units = valueOf_44(__parseAndValidateInt($getSimpleValue(this.configuration, 'METRIC_RANGE_UNIT', '3')));
        beginEnd = calculateTimeFrame(lastN.value_0, units.value_0);
        $addFilterStartTime_0(criteria, valueOf_45(dynamicCast((checkIndex(0, beginEnd.size_0) , beginEnd.array[0]), Q$Long).value_0));
        $addFilterEndTime_0(criteria, valueOf_45(dynamicCast((checkIndex(1, beginEnd.size_0) , beginEnd.array[1]), Q$Long).value_0));
      }
    }
  }
  switch (this.entityContext.type_0.ordinal) {
    case 0:
      $addFilterResourceIds(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.entityContext.resourceId)]));
      break;
    case 2:
      $addFilterResourceGroupIds_0(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.entityContext.groupId)]));
  }
  criteria.fetchAlertDefinition = true;
  criteria.fetchRecoveryAlertDefinition = true;
  return criteria;
}
;
_.getTotalRows_0 = function getTotalRows_0(result, response, request){
  return result.size_0;
}
;
_.configuration = null;
function $clinit_RecentAlertsPortlet(){
  $clinit_RecentAlertsPortlet = nullMethod;
  $clinit_AlertHistoryView();
  NAME_13 = ($clinit_Enhanced() , 'Recent Alerts');
}

function RecentAlertsPortlet_0(){
  $clinit_RecentAlertsPortlet();
  AbstractRecentAlertsPortlet_0.call(this, new EntityContext_0(null, null, null));
}

defineSeed(2578, 2496, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced, Q$EnhancedHLayout]), RecentAlertsPortlet_0);
var NAME_13;
function $clinit_RecentAlertsPortlet$Factory(){
  $clinit_RecentAlertsPortlet$Factory = nullMethod;
  INSTANCE_19 = new RecentAlertsPortlet$Factory_0;
}

function RecentAlertsPortlet$Factory_0(){
}

defineSeed(2579, 1, makeCastMap([Q$PortletViewFactory]), RecentAlertsPortlet$Factory_0);
_.getInstance = function getInstance_13(context){
  return new RecentAlertsPortlet_0;
}
;
var INSTANCE_19;
function $clinit_RecentlyAddedResourceDS(){
  $clinit_RecentlyAddedResourceDS = nullMethod;
  $clinit_CoreGUI();
}

function $buildNodes(list){
  var i, treeNodes;
  treeNodes = initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, list.size_0, 0);
  for (i = 0; i < list.size_0; ++i) {
    setCheck(treeNodes, i, new RecentlyAddedResourceDS$RecentlyAddedTreeNode_0(dynamicCast((checkIndex(i, list.size_0) , list.array[i]), Q$RecentlyAddedResourceComposite)));
  }
  return treeNodes;
}

function $executeFetch_21(this$static, request, response){
  var ctime, maxItems, recentAdditionsPortlet;
  ctime = N1_longLit;
  maxItems = -1;
  if (!!this$static.portlet && !!this$static.portlet) {
    recentAdditionsPortlet = this$static.portlet;
    if (recentAdditionsPortlet) {
      this$static.maximumRecentlyAddedToDisplay > 0 && (maxItems = this$static.maximumRecentlyAddedToDisplay);
      this$static.maximumRecentlyAddedWithinHours > 0 && (ctime = sub(fromDouble(currentTimeMillis0()), mul(fromInt(this$static.maximumRecentlyAddedWithinHours), P36ee80_longLit)));
    }
  }
  $clinit_UserSessionManager();
  ($clinit_Log() , $isLoggable_0(logger_0, ($clinit_Level() , FINEST))) && trace('isLoggedIn = ' + sessionState);
  if (sessionState == ($clinit_UserSessionManager$State() , IS_LOGGED_IN)) {
    $findRecentlyAddedResources(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), ctime, maxItems, new RecentlyAddedResourceDS$1_0(this$static, response, request));
  }
   else {
    $fine_0(logger_0, 'user is not logged in. Not fetching recently added resource now.');
    $setTotalRows(response, valueOf_44(0));
    $processResponse(this$static, getAttribute(request.jsObj, 'requestId'), response);
  }
}

function $setMaximumRecentlyAddedToDisplay(this$static, maximumRecentlyAddedToDisplay){
  this$static.maximumRecentlyAddedToDisplay = maximumRecentlyAddedToDisplay;
}

function $setMaximumRecentlyAddedWithinHours(this$static, maximumRecentlyAddedWithinHours){
  this$static.maximumRecentlyAddedWithinHours = maximumRecentlyAddedWithinHours;
}

function RecentlyAddedResourceDS_0(recentlyAddedPortlet){
  $clinit_RecentlyAddedResourceDS();
  var idField, parentIdField, resourceNameField, timestampField;
  DataSource_0.call(this);
  this.portlet = recentlyAddedPortlet;
  $setClientOnly(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_1(this, 'dataProtocol', ($clinit_DSProtocol() , CLIENTCUSTOM).value_0);
  $setAttribute_1(this, 'dataFormat', ($clinit_DSDataFormat() , CUSTOM).value_0);
  idField = new DataSourceTextField_1('id', 'ID');
  $setAttribute_8(idField, 'primaryKey', TRUE);
  parentIdField = new DataSourceTextField_1('parentId', 'Parent ID');
  parentIdField.jsObj['foreignKey'] = 'id';
  resourceNameField = new DataSourceTextField_1('name', 'Resource Name');
  $setAttribute_8(resourceNameField, 'primaryKey', TRUE);
  timestampField = new DataSourceTextField_1('timestamp', 'Date/Time');
  $setFields(this, initValues(_3Lcom_smartgwt_client_data_DataSourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$DataSourceField, [idField, parentIdField, resourceNameField, timestampField]));
}

defineSeed(2580, 337, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), RecentlyAddedResourceDS_0);
_.transformRequest_0 = function transformRequest_1(request){
  var response;
  response = new DSResponse_0;
  $setAttribute_12(response, 'clientContext', getAttributeAsObject(request.jsObj, 'clientContext'));
  response.jsObj['status'] = 0;
  dynamicCast(getEnum(($clinit_DSOperationType() , $clinit_DSOperationType() , $VALUES_9), getAttribute(request.jsObj, 'operationType')), Q$DSOperationType).ordinal == 0 && $executeFetch_21(this, request, response);
  return getAttributeAsJavaScriptObject(request.jsObj, 'data');
}
;
_.maximumRecentlyAddedToDisplay = 0;
_.maximumRecentlyAddedWithinHours = 0;
_.portlet = null;
function $onSuccess_205(this$static, recentlyAddedList){
  var list, recentlyAdded, recentlyAdded$iterator;
  list = new ArrayList_0;
  for (recentlyAdded$iterator = recentlyAddedList.iterator(); recentlyAdded$iterator.hasNext();) {
    recentlyAdded = dynamicCast(recentlyAdded$iterator.next_0(), Q$RecentlyAddedResourceComposite);
    setCheck(list.array, list.size_0++, recentlyAdded);
    $addAll_0(list, recentlyAdded.children_0?recentlyAdded.children_0:new ArrayList_0);
  }
  $setAttribute_17(this$static.val$response, 'data', $buildNodes(list));
  $setTotalRows(this$static.val$response, valueOf_44(list.size_0));
  $processResponse(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function RecentlyAddedResourceDS$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2581, 1, {}, RecentlyAddedResourceDS$1_0);
_.onFailure = function onFailure_216(throwable){
  $handleError_0(($clinit_CoreGUI() , $clinit_RecentlyAddedResourceDS() , 'Failed to load recently added resources'), throwable);
}
;
_.onSuccess_0 = function onSuccess_216(recentlyAddedList){
  $onSuccess_205(this, dynamicCast(recentlyAddedList, Q$List));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function RecentlyAddedResourceDS$RecentlyAddedTreeNode_0(c){
  var dateAdded, id, parentId;
  TreeNode_0.call(this);
  this.recentlyAdded = c;
  dateAdded = new Date_2(this.recentlyAdded.ctime);
  id = '' + this.recentlyAdded.id;
  parentId = this.recentlyAdded.parentId == 0?null:'' + this.recentlyAdded.parentId;
  this.jsObj['id'] = id;
  this.jsObj['parentId'] = parentId;
  this.jsObj['id'] = id;
  this.jsObj['parentId'] = parentId;
  $setAttribute_13(this, 'name', this.recentlyAdded.name_0);
  setAttribute_9(this.jsObj, 'timestamp', dateAdded);
  $setAttribute_16(this, 'isFolder', this.recentlyAdded.parentId == 0);
}

defineSeed(2582, 577, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode]), RecentlyAddedResourceDS$RecentlyAddedTreeNode_0);
_.recentlyAdded = null;
function $clinit_RecentlyAddedResourcesPortlet(){
  $clinit_RecentlyAddedResourcesPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_14 = ($clinit_Enhanced() , 'Recently Added Resources');
  unlimitedString = 'unlimited';
}

function $configure_10(this$static, portletWindow, storedPortlet){
  var configuredValue;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  configuredValue = $populateConfigurationValue(storedPortlet, 'recently-added-show-amount');
  $setMaximumRecentlyAddedToDisplay(this$static.dataSource, configuredValue);
  configuredValue = $populateConfigurationValue(storedPortlet, 'recently-added-time-range');
  $setMaximumRecentlyAddedWithinHours(this$static.dataSource, configuredValue);
}

function $populateConfigurationValue(storedPortlet, propertyKey){
  var $e0, configuredValue, retrieved;
  configuredValue = valueOf_44(__parseAndValidateInt('-1')).value_0;
  if (!storedPortlet || !storedPortlet.configuration) {
    return configuredValue;
  }
  if ($getSimple(storedPortlet.configuration, propertyKey)) {
    retrieved = $getSimple(storedPortlet.configuration, propertyKey).stringValue;
    try {
      configuredValue = __parseAndValidateInt(retrieved);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$NumberFormatException)) {
        configuredValue = -1;
      }
       else 
        throw $e0;
    }
  }
   else {
    $put_4(storedPortlet.configuration, new PropertySimple_1(propertyKey, '-1'));
  }
  return configuredValue;
}

function RecentlyAddedResourcesPortlet_0(){
  $clinit_RecentlyAddedResourcesPortlet();
  EnhancedVLayout_0.call(this);
  this.dataSource = new RecentlyAddedResourceDS_0(this);
}

defineSeed(2583, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), RecentlyAddedResourcesPortlet_0);
_.configure = function configure_14(portletWindow, storedPortlet){
  $configure_10(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_10(){
  var acceptableDisplayValues, acceptableTimeValues, configuredValue, form, maximumRecentlyAddedComboBox, maximumTimeRecentlyAddedComboBox, selectedValue, storedPortlet;
  form = new DynamicForm_0;
  storedPortlet = this.portletWindow.storedPortlet;
  maximumRecentlyAddedComboBox = new SelectItem_1('recently-added-show-amount');
  $setTitle_1(maximumRecentlyAddedComboBox, ($clinit_Enhanced() , 'Show'));
  $setHint(maximumRecentlyAddedComboBox, '<nobr><b> recently added platforms<\/b><\/nobr>');
  $isCreated_2(maximumRecentlyAddedComboBox)?$setProperty_8(maximumRecentlyAddedComboBox, 'type', 'selection'):(maximumRecentlyAddedComboBox.jsObj['type'] = 'selection' , undefined);
  acceptableDisplayValues = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['5', '10', '15', '20', '30', unlimitedString]);
  maximumRecentlyAddedComboBox.setValueMap_1(acceptableDisplayValues);
  $isCreated_2(maximumRecentlyAddedComboBox)?$setProperty_6(maximumRecentlyAddedComboBox, 'width', 100):(maximumRecentlyAddedComboBox.jsObj['width'] = 100 , undefined);
  configuredValue = $populateConfigurationValue(storedPortlet, 'recently-added-show-amount');
  selectedValue = configuredValue == -1?unlimitedString:'' + configuredValue;
  $isCreated_2(maximumRecentlyAddedComboBox)?$setProperty_8(maximumRecentlyAddedComboBox, 'defaultValue', selectedValue):(maximumRecentlyAddedComboBox.jsObj['defaultValue'] = selectedValue , undefined);
  maximumTimeRecentlyAddedComboBox = new SelectItem_1('recently-added-time-range');
  $isCreated_2(maximumTimeRecentlyAddedComboBox)?$setProperty_8(maximumTimeRecentlyAddedComboBox, 'title', 'Over '):(maximumTimeRecentlyAddedComboBox.jsObj['title'] = 'Over ' , undefined);
  $setHint(maximumTimeRecentlyAddedComboBox, '<nobr><b> hours <\/b><\/nobr>');
  $isCreated_2(maximumTimeRecentlyAddedComboBox)?$setProperty_8(maximumTimeRecentlyAddedComboBox, 'type', 'selection'):(maximumTimeRecentlyAddedComboBox.jsObj['type'] = 'selection' , undefined);
  acceptableTimeValues = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['1', '4', '8', '24', '48', unlimitedString]);
  maximumTimeRecentlyAddedComboBox.setValueMap_1(acceptableTimeValues);
  $isCreated_2(maximumTimeRecentlyAddedComboBox)?$setProperty_6(maximumTimeRecentlyAddedComboBox, 'width', 100):(maximumTimeRecentlyAddedComboBox.jsObj['width'] = 100 , undefined);
  configuredValue = $populateConfigurationValue(storedPortlet, 'recently-added-time-range');
  selectedValue = configuredValue == -1?unlimitedString:'' + configuredValue;
  $isCreated_2(maximumTimeRecentlyAddedComboBox)?$setProperty_8(maximumTimeRecentlyAddedComboBox, 'defaultValue', selectedValue):(maximumTimeRecentlyAddedComboBox.jsObj['defaultValue'] = selectedValue , undefined);
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [maximumRecentlyAddedComboBox, maximumTimeRecentlyAddedComboBox]));
  $addSubmitValuesHandler(form, new RecentlyAddedResourcesPortlet$2_0(this, form, storedPortlet));
  return form;
}
;
_.getHelpCanvas = function getHelpCanvas_14(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet displays resources that have recently been imported into inventory.'));
}
;
_.isRefreshing = function isRefreshing_12(){
  return false;
}
;
_.onDestroy = function onDestroy_14(){
  onDestroy_0(this.refreshTimer);
}
;
_.onInit = function onInit_54(){
  var resourceNameField, timestampField;
  $onInit(this);
  $onInit_Layout(this);
  this.treeGrid = new TreeGrid_0;
  $setAttribute_20(this.treeGrid, 'dataSource', $getOrCreateJsObj(this.dataSource), true);
  $setAutoFetchData_0(this.treeGrid, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setPrompt(this.treeGrid, ($clinit_Enhanced() , 'Recently Added Resources'));
  $setResizeFieldsInRealTime(this.treeGrid, TRUE);
  $setTreeFieldTitle(this.treeGrid);
  resourceNameField = new ListGridField_3('name', 'Resource Name');
  $setCellFormatter_0(resourceNameField, new RecentlyAddedResourcesPortlet$1_0);
  timestampField = new ListGridField_3('timestamp', 'Date/Time');
  $clinit_TimestampCellFormatter();
  prepareDateField(timestampField, getAttribute(timestampField.jsObj, 'name'));
  $setFields_1(this.treeGrid, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [resourceNameField, timestampField]));
  $addMember(this, this.treeGrid);
}
;
_.refresh_0 = function refresh_22(){
  !!this.treeGrid && $invalidateCache_0(this.treeGrid);
  $markForRedraw(this);
}
;
_.startRefreshCycle = function startRefreshCycle_13(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.dataSource = null;
_.portletWindow = null;
_.refreshTimer = null;
_.treeGrid = null;
var NAME_14, unlimitedString;
function RecentlyAddedResourcesPortlet$1_0(){
}

defineSeed(2584, 1, {}, RecentlyAddedResourcesPortlet$1_0);
_.format_1 = function format_34(o, listGridRecord, i, i1){
  return '<a href="#Resource/' + getAttribute(listGridRecord.jsObj, 'id') + '">' + o + '<\/a>';
}
;
function RecentlyAddedResourcesPortlet$2_0(this$0, val$form, val$storedPortlet){
  this.this$0 = this$0;
  this.val$form = val$form;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2585, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), RecentlyAddedResourcesPortlet$2_0);
_.onSubmitValues = function onSubmitValues_11(event_0){
  var value;
  value = dynamicCast($getValue(this.val$form, 'recently-added-show-amount'), Q$String);
  if (value != null) {
    value = $equals_6(($clinit_RecentlyAddedResourcesPortlet() , unlimitedString), value)?'-1':value;
    $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('recently-added-show-amount', value));
  }
  value = dynamicCast($getValue(this.val$form, 'recently-added-time-range'), Q$String);
  if (value != null) {
    value = $equals_6(($clinit_RecentlyAddedResourcesPortlet() , unlimitedString), value)?'-1':value;
    $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('recently-added-time-range', value));
  }
  $configure_10(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $redraw(this.this$0);
}
;
_.this$0 = null;
_.val$form = null;
_.val$storedPortlet = null;
function $clinit_RecentlyAddedResourcesPortlet$Factory(){
  $clinit_RecentlyAddedResourcesPortlet$Factory = nullMethod;
  INSTANCE_20 = new RecentlyAddedResourcesPortlet$Factory_0;
}

function RecentlyAddedResourcesPortlet$Factory_0(){
}

defineSeed(2586, 1, makeCastMap([Q$PortletViewFactory]), RecentlyAddedResourcesPortlet$Factory_0);
_.getInstance = function getInstance_14(context){
  return new RecentlyAddedResourcesPortlet_0;
}
;
var INSTANCE_20;
function $clinit_OperationHistoryView(){
  $clinit_OperationHistoryView = nullMethod;
  var i, s, s$index, s$max, statusNames, statusValues;
  $clinit_BaseWidget();
  SUBSYSTEM_VIEW_ID_0 = new ViewName_2('RecentOperations', ($clinit_Enhanced() , 'Recent Operations'), ($clinit_IconEnum() , RECENT_OPERATIONS));
  INITIAL_CRITERIA_1 = new Criteria_0;
  DEFAULT_SORT_SPECIFIER_2 = new SortSpecifier_0('createdTime', ($clinit_SortDirection() , DESCENDING));
  statusValues = ($clinit_OperationRequestStatus() , $clinit_OperationRequestStatus() , $VALUES_96);
  statusNames = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, statusValues.length, 0);
  i = 0;
  for (s$index = 0 , s$max = statusValues.length; s$index < s$max; ++s$index) {
    s = statusValues[s$index];
    statusNames[i++] = s.name_0;
  }
  $addCriteria_6(INITIAL_CRITERIA_1, 'status', statusNames);
}

function $configureTable_4(this$static){
  var dataSourceFields;
  dataSourceFields = $getListGridFields_7(this$static.getDataSource_1());
  $setFields_1(this$static.listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
  $addTableAction(this$static, ($clinit_Enhanced() , 'Cancel'), 'Are you sure you want to cancel the selected operations? NOTE: Only those selected operations that are currently "in progress" will be attempted to be canceled.', null, new OperationHistoryView$1_0(this$static));
  $addTableAction(this$static, 'Delete', 'Are you sure you want to delete the # selected items?', null, new OperationHistoryView$2_0(this$static));
  $addTableAction(this$static, 'Force Delete', 'Are you sure you want to delete the # selected items?', null, new OperationHistoryView$3_0(this$static));
  $configureTable(this$static);
}

function $deleteSelectedRecords_1(this$static, requestProperties){
  var failureIds, force, forceValue, numberOfRecordsToBeDeleted, operationHistoryToRemove, record, record$index, record$max, recordsToBeDeleted, successIds;
  recordsToBeDeleted = $getSelectedRecords(this$static.listGrid);
  numberOfRecordsToBeDeleted = recordsToBeDeleted.length;
  forceValue = ($clinit_Boolean() , !!requestProperties && (getAttributeAsBoolean(requestProperties.jsObj, 'force')?TRUE:FALSE).value_0?TRUE:FALSE);
  force = !!forceValue && forceValue.value_0;
  successIds = new ArrayList_0;
  failureIds = new ArrayList_0;
  for (record$index = 0 , record$max = recordsToBeDeleted.length; record$index < record$max; ++record$index) {
    record = recordsToBeDeleted[record$index];
    operationHistoryToRemove = $copyValues_35((new OperationHistoryDataSource_0 , record));
    $deleteOperationHistory(dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync), operationHistoryToRemove.id, force, new OperationHistoryView$4_0(this$static, successIds, operationHistoryToRemove, failureIds, numberOfRecordsToBeDeleted));
  }
}

function $handleCompletion_0(this$static, successIds, failureIds, numberOfRecordsToBeDeleted){
  if (successIds.size_0 + failureIds.size_0 == numberOfRecordsToBeDeleted) {
    successIds.size_0 == numberOfRecordsToBeDeleted?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0('Deleted [' + ($clinit_Enhanced() , '' + numberOfRecordsToBeDeleted) + '] operation history items.')):$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0('Deleted [' + ($clinit_Enhanced() , '' + successIds.size_0) + '] operation history items, but failed to delete the items with the following IDs: ' + failureIds.toString$()));
    this$static.refresh_0();
  }
}

function OperationHistoryView_0(entityContext){
  OperationHistoryView_1.call(this, null, entityContext, false);
}

function OperationHistoryView_1(tableTitle, context, hasControlPermission){
  TableSection_2.call(this, tableTitle, INITIAL_CRITERIA_1, initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [DEFAULT_SORT_SPECIFIER_2]));
  this.context = context;
  this.hasControlPermission_0 = hasControlPermission;
  this.initialCriteriaFixed = false;
  $setDataSource(this, this.getDataSource_1());
}

defineSeed(2588, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_28(){
  $configureTable_4(this);
}
;
_.configureTableFilters = function configureTableFilters_2(){
  var spacerItem, statusIcons, statusValues;
  statusValues = new LinkedHashMap_1(4);
  $put_1(statusValues, ($clinit_OperationRequestStatus() , SUCCESS_6).name_0, ($clinit_Enhanced() , 'Success'));
  $put_1(statusValues, INPROGRESS_1.name_0, 'In Progress');
  $put_1(statusValues, CANCELED.name_0, 'Canceled');
  $put_1(statusValues, FAILURE_6.name_0, 'Failed');
  statusIcons = new LinkedHashMap_1(3);
  $put_1(statusIcons, SUCCESS_6.name_0, getOperationResultsIcon(SUCCESS_6));
  $put_1(statusIcons, INPROGRESS_1.name_0, getOperationResultsIcon(INPROGRESS_1));
  $put_1(statusIcons, CANCELED.name_0, getOperationResultsIcon(CANCELED));
  $put_1(statusIcons, FAILURE_6.name_0, getOperationResultsIcon(FAILURE_6));
  this.statusFilter = new EnumSelectItem_0('status', 'Operation Status', Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit, statusValues, statusIcons);
  this.startDateFilter = new DateFilterItem_0('startTime', 'From');
  this.endDateFilter = new DateFilterItem_0('endTime', 'To');
  spacerItem = new SpacerItem_0;
  spacerItem.setColSpan(2);
  this.showFilterForm && $setFilterFormItems(this, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.statusFilter, this.startDateFilter, spacerItem, this.endDateFilter]));
}
;
_.getDataSource_1 = function getDataSource_11(){
  !this.dataSource_0 && (this.dataSource_0 = new OperationHistoryDataSource_1(this.context));
  return this.dataSource_0;
}
;
_.getDataSource_0 = function getDataSource_12(){
  return this.getDataSource_1();
}
;
_.getDetailsView_0 = function getDetailsView_16(id){
  return new ResourceOperationHistoryDetailsView_0;
}
;
_.getTitleFieldName = function getTitleFieldName_1(){
  return 'operationName';
}
;
_.getViewName = function getViewName_8(){
  return SUBSYSTEM_VIEW_ID_0;
}
;
_.hasControlPermission_1 = function hasControlPermission_1(){
  return this.hasControlPermission_0;
}
;
_.context = null;
_.dataSource_0 = null;
_.endDateFilter = null;
_.hasControlPermission_0 = false;
_.startDateFilter = null;
_.statusFilter = null;
var DEFAULT_SORT_SPECIFIER_2, INITIAL_CRITERIA_1, SUBSYSTEM_VIEW_ID_0;
function $configure_11(this$static, portletWindow, storedPortlet){
  var config, key, key$iterator;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  config = storedPortlet.configuration;
  for (key$iterator = $iterator($keySet(($clinit_PortletConfigurationEditorComponent() , CONFIG_PROPERTY_INITIALIZATION))); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$String);
    !dynamicCast(config.properties.get_2(key), Q$PropertySimple) && $put_4(config, new PropertySimple_1(key, CONFIG_PROPERTY_INITIALIZATION.get_2(key)));
  }
  $setConfiguration_2((!this$static.dataSource && (this$static.dataSource = new AbstractOperationHistoryPortlet$OperationHistoryPortletDataSource_0(this$static.context)) , this$static.dataSource), config);
}

function $saveMeasurementRangeEditorSettings_0(measurementRangeEditor, portletConfig){
  var begEnd, isAdvanceTimeSetting, item, itemC, persistTimeRangeSettings, rangeArray, selectedValue;
  if (!!measurementRangeEditor && !!portletConfig) {
    item = $getField_0(measurementRangeEditor, ($clinit_AbstractMeasurementRangeEditor() , 'ENABLE_RANGE_ITEM'));
    itemC = dynamicCast(item, Q$CheckboxItem);
    persistTimeRangeSettings = $getValueAsBoolean(itemC).value_0;
    if (persistTimeRangeSettings) {
      selectedValue = '' + $getValueAsBoolean(itemC);
      !$trim(selectedValue).length || $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_ENABLE', selectedValue));
      isAdvanceTimeSetting = false;
      selectedValue = '' + measurementRangeEditor.advanced;
      if (selectedValue != null && !!$trim(selectedValue).length) {
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_BEGIN_END_FLAG', selectedValue));
        isAdvanceTimeSetting = ($clinit_Boolean() , $equalsIgnoreCase('true', selectedValue)?TRUE:FALSE).value_0;
      }
      begEnd = $getBeginEndTimes_0(measurementRangeEditor);
      if (isAdvanceTimeSetting) {
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE', (checkIndex(0, begEnd.size_0) , begEnd.array[0]) + ',' + (checkIndex(1, begEnd.size_0) , begEnd.array[1])));
      }
       else {
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_LASTN', valueOf_44(measurementRangeEditor.measurementPrefs.metricRangePreferences.lastN)));
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_UNIT', valueOf_44(measurementRangeEditor.measurementPrefs.metricRangePreferences.unit)));
      }
    }
     else {
      $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_ENABLE', ($clinit_Boolean() , $clinit_Boolean() , FALSE)));
      $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_BEGIN_END_FLAG', FALSE));
      rangeArray = calculateTimeFrame(valueOf_44(__parseAndValidateInt(($clinit_PortletConfigurationEditorComponent$Constant() , '8'))).value_0, valueOf_44(__parseAndValidateInt('3')).value_0);
      $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE', '' + (checkIndex(0, rangeArray.size_0) , rangeArray.array[0]) + ',' + (checkIndex(1, rangeArray.size_0) , rangeArray.array[1])));
    }
  }
}

function AbstractOperationHistoryPortlet_0(entityContext){
  $clinit_OperationHistoryView();
  OperationHistoryView_0.call(this, entityContext);
  this.baseViewPath = getEntityTabLink(this.context, 'Operations', 'History');
  this.showFilterForm = false;
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  this.showFooterRefresh = false;
  this.showHeader = false;
}

defineSeed(2587, 2588, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced, Q$EnhancedHLayout]));
_.configure = function configure_15(portletWindow, storedPortlet){
  $configure_11(this, portletWindow, storedPortlet);
}
;
_.getBasePath = function getBasePath_5(){
  return this.baseViewPath;
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_11(){
  var customSettingsForm, filterForm, measurementRangeEditor, operationStatusSelector, page, portletConfig, resultCountSelector, storedPortlet;
  customSettingsForm = new DynamicForm_0;
  page = new EnhancedVLayout_0;
  filterForm = new DynamicForm_0;
  $setMargin(filterForm, valueOf_44(5));
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  operationStatusSelector = getOperationStatusEditor(portletConfig);
  resultCountSelector = getResultCountEditor(portletConfig);
  measurementRangeEditor = ($clinit_PortletConfigurationEditorComponent() , new CustomConfigMeasurementRangeEditor_0(portletConfig));
  filterForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [operationStatusSelector, resultCountSelector]));
  $addSubmitValuesHandler(customSettingsForm, new AbstractOperationHistoryPortlet$1_0(this, operationStatusSelector, portletConfig, resultCountSelector, measurementRangeEditor, storedPortlet));
  $addMember(page, measurementRangeEditor);
  $addMember(page, filterForm);
  $addChild(customSettingsForm, page);
  return customSettingsForm;
}
;
_.getDataSource_1 = function getDataSource_13(){
  return !this.dataSource && (this.dataSource = new AbstractOperationHistoryPortlet$OperationHistoryPortletDataSource_0(this.context)) , this.dataSource;
}
;
_.getHelpCanvas = function getHelpCanvas_15(){
  return new HTMLFlow_1(($clinit_Enhanced() , 'This portlet displays Operations consistent with display criteria configured.'));
}
;
_.hasControlPermission_1 = function hasControlPermission_2(){
  var globalPerm, resPerm;
  if (!this.hasControlPermission) {
    globalPerm = this.portletWindow.dashboardView.dashboardContainer.getGlobalPermissions();
    resPerm = $getResourcePermissions(this.portletWindow);
    this.hasControlPermission = ($clinit_Boolean() , globalPerm.contains_0(($clinit_Permission() , MANAGE_INVENTORY)) || !!resPerm && resPerm.permissions.contains_0(CONTROL_0)?TRUE:FALSE);
  }
  return this.hasControlPermission.value_0;
}
;
_.isRefreshing = function isRefreshing_13(){
  return false;
}
;
_.onDestroy = function onDestroy_15(){
  onDestroy_0(this.refreshTimer);
}
;
_.refresh_0 = function refresh_23(){
  $refresh(this, false);
}
;
_.refreshTableInfo = function refreshTableInfo_3(){
  var count;
  $refreshTableInfo(this);
  if (this.tableInfo) {
    count = $getSelectedRecords(this.listGrid).length;
    $setContents_0(this.tableInfo, 'Matching Rows: ' + ($clinit_Enhanced() , '' + $getTotalRows(this.listGrid)) + ' (selected: ' + count + ')');
  }
}
;
_.startRefreshCycle = function startRefreshCycle_14(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.baseViewPath = null;
_.dataSource = null;
_.hasControlPermission = null;
_.portletWindow = null;
_.refreshTimer = null;
function AbstractOperationHistoryPortlet$1_0(this$0, val$operationStatusSelector, val$portletConfig, val$resultCountSelector, val$measurementRangeEditor, val$storedPortlet){
  this.this$0 = this$0;
  this.val$operationStatusSelector = val$operationStatusSelector;
  this.val$portletConfig = val$portletConfig;
  this.val$resultCountSelector = val$resultCountSelector;
  this.val$measurementRangeEditor = val$measurementRangeEditor;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2589, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), AbstractOperationHistoryPortlet$1_0);
_.onSubmitValues = function onSubmitValues_12(event_0){
  var selectedValue;
  selectedValue = null == $getValue_0(this.val$operationStatusSelector)?'':toString__devirtual$($getValue_0(this.val$operationStatusSelector));
  (!$trim(selectedValue).length || $split(selectedValue, ',', 0).length == ($clinit_OperationRequestStatus() , $clinit_OperationRequestStatus() , $VALUES_96).length) && (selectedValue = '');
  $put_4(this.val$portletConfig, new PropertySimple_1('OPERATION_STATUS', selectedValue));
  selectedValue = toString__devirtual$($getValue_0(this.val$resultCountSelector));
  !$trim(selectedValue).length && (selectedValue = '5');
  $put_4(this.val$portletConfig, new PropertySimple_1('RESULT_COUNT', selectedValue));
  $saveMeasurementRangeEditorSettings_0(this.val$measurementRangeEditor, this.val$portletConfig);
  $setConfiguration_0(this.val$storedPortlet, this.val$portletConfig);
  $configure_11(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $refresh(this.this$0, false);
}
;
_.this$0 = null;
_.val$measurementRangeEditor = null;
_.val$operationStatusSelector = null;
_.val$portletConfig = null;
_.val$resultCountSelector = null;
_.val$storedPortlet = null;
function $copyValues_35(from){
  var resource, resourceOperationHistory;
  resource = new Resource_1;
  $setId_4(resource, getAttributeAsInt(from.jsObj, 'resourceId').value_0);
  resourceOperationHistory = new ResourceOperationHistory_1(getAttribute(from.jsObj, 'subjectName'), dynamicCast(getAttributeAsObject(from.jsObj, 'operationDefinition'), Q$OperationDefinition), dynamicCast(getAttributeAsObject(from.jsObj, 'parameters'), Q$Configuration), resource);
  $setId_2(resourceOperationHistory, getAttributeAsInt(from.jsObj, 'id').value_0);
  return resourceOperationHistory;
}

function $copyValues_36(from){
  var record, resource;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_14(record, 'createdTime', convertTimestampToDate(valueOf_45(from.createdTime)));
  $setAttribute_14(record, 'startedTime', convertTimestampToDate(valueOf_45(from.startedTime)));
  $setAttribute_4(record, 'duration', $getDuration(from));
  $setAttribute_13(record, 'subjectName', from.subjectName);
  $setAttribute_12(record, 'operationDefinition', from.operationDefinition);
  $setAttribute_13(record, 'operationName', from.operationDefinition.displayName);
  $setAttribute_13(record, 'errorMessage', from.errorMessage_0);
  $setAttribute_13(record, 'status', from.status_0.name_0);
  $setAttribute_12(record, 'parameters', from.parameters);
  resource = from.resource;
  $setAttribute_3(record, 'resourceId', resource.id);
  $setAttribute_13(record, 'resourceName', resource.name_0);
  $setAttribute_13(record, 'resourceAncestry', resource.ancestry);
  $setAttribute_3(record, 'resourceTypeId', resource.resourceType.id);
  return record;
}

function $dataRetrieved_0(this$static, result, response, request){
  var ancestries, history_0, history$iterator, resource, typeRepo, typesSet;
  switch (this$static.entityContext.type_0.ordinal) {
    case 0:
      $setAttribute_17(response, 'data', $buildRecords(this$static, result, true));
      $setTotalRows(response, valueOf_44(this$static.getTotalRows_0(result, response, request)));
      $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
      break;
    default:typesSet = new HashSet_0;
      ancestries = new HashSet_0;
      for (history$iterator = new AbstractList$IteratorImpl_0(result); history$iterator.i < history$iterator.this$0_0.size_1();) {
        history_0 = dynamicCast($next_0(history$iterator), Q$ResourceOperationHistory);
        resource = history_0.resource;
        $add_6(typesSet, valueOf_44(resource.resourceType.id));
        $add_6(ancestries, resource.ancestry);
      }

      $addAll(typesSet, getAncestryTypeIds(ancestries));
      typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
      $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new OperationHistoryDataSource$8_0(this$static, result, response, request));
  }
}

function $executeFetch_22(this$static, request, response, criteria){
  var start;
  if (!criteria) {
    $setTotalRows(response, valueOf_44(0));
    $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
    return;
  }
  start = fromDouble(currentTimeMillis0());
  $findResourceOperationHistoriesByCriteria(this$static.operationService, criteria, new OperationHistoryDataSource$7_0(this$static, response, request, start));
}

function $getListGridFields_7(this$static){
  var ancestryField, fields, opNameField, resourceNameField, startTimeField, statusField, subjectField, startedTimeField, statusField_0;
  fields = new ArrayList_1(7);
  startTimeField = (startedTimeField = new ListGridField_3('startedTime', 'Date Submitted') , $setAttribute_13(startedTimeField, 'align', ($clinit_Alignment() , LEFT_0).value_0) , $setAttribute_13(startedTimeField, 'cellAlign', LEFT_0.value_0) , $setCellFormatter_0(startedTimeField, new OperationHistoryDataSource$3_0(this$static)) , $setAttribute_8(startedTimeField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setHoverCustomizer_0(startedTimeField, ($clinit_TimestampCellFormatter() , new TimestampCellFormatter$1_0('startedTime'))) , startedTimeField);
  setCheck(fields.array, fields.size_0++, startTimeField);
  opNameField = new ListGridField_3('operationName', 'Operation');
  setCheck(fields.array, fields.size_0++, opNameField);
  subjectField = new ListGridField_3('subjectName', 'Requestor');
  setCheck(fields.array, fields.size_0++, subjectField);
  statusField = (statusField_0 = new ListGridField_3('status', 'Status') , $setAttribute_13(statusField_0, 'align', CENTER_0.value_0) , $setAttribute_13(statusField_0, 'cellAlign', CENTER_0.value_0) , $setAttribute_8(statusField_0, 'showHover', TRUE) , $setHoverCustomizer_0(statusField_0, new OperationHistoryDataSource$4_0) , $setCellFormatter_0(statusField_0, new OperationHistoryDataSource$5_0) , $addRecordClickHandler_0(statusField_0, new OperationHistoryDataSource$6_0) , statusField_0);
  setCheck(fields.array, fields.size_0++, statusField);
  if (this$static.entityContext.type_0 != ($clinit_EntityContext$Type() , Resource)) {
    resourceNameField = new ListGridField_3('resourceName', 'Resource');
    $setCellFormatter_0(resourceNameField, new OperationHistoryDataSource$1_0);
    $setAttribute_8(resourceNameField, 'showHover', TRUE);
    $setHoverCustomizer_0(resourceNameField, new OperationHistoryDataSource$2_0);
    setCheck(fields.array, fields.size_0++, resourceNameField);
    ancestryField = setupAncestryListGridField();
    setCheck(fields.array, fields.size_0++, ancestryField);
    startTimeField.jsObj['width'] = 200;
    opNameField.jsObj['width'] = '25%';
    subjectField.jsObj['width'] = '15%';
    statusField.jsObj['width'] = 100;
    resourceNameField.jsObj['width'] = '25%';
    ancestryField.jsObj['width'] = '35%';
  }
   else {
    startTimeField.jsObj['width'] = 200;
    opNameField.jsObj['width'] = '*';
    subjectField.jsObj['width'] = '*';
    statusField.jsObj['width'] = 100;
  }
  return fields;
}

function OperationHistoryDataSource_0(){
  $clinit_RPCDataSource();
  OperationHistoryDataSource_1.call(this, new EntityContext_0(null, null, null));
}

function OperationHistoryDataSource_1(context){
  $clinit_RPCDataSource();
  RPCDataSource_0.call(this);
  this.operationService = dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync);
  this.entityContext = context;
  new ArrayList_0;
}

defineSeed(2591, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), OperationHistoryDataSource_0, OperationHistoryDataSource_1);
_.copyValues = function copyValues_58(from){
  return $copyValues_35(from);
}
;
_.copyValues_0 = function copyValues_59(from){
  return $copyValues_36(dynamicCast(from, Q$ResourceOperationHistory));
}
;
_.executeFetch = function executeFetch_33(request, response, criteria){
  $executeFetch_22(this, request, response, dynamicCast(criteria, Q$ResourceOperationHistoryCriteria));
}
;
_.executeRemove = function executeRemove_3(recordToRemove, request, response){
  var force, forceValue, operationHistoryToRemove;
  operationHistoryToRemove = $copyValues_35(recordToRemove);
  forceValue = ($clinit_Boolean() , getAttributeAsBoolean(request.jsObj, 'force')?TRUE:FALSE);
  force = !!forceValue && forceValue.value_0;
  $deleteOperationHistory(this.operationService, operationHistoryToRemove.id, force, new OperationHistoryDataSource$9_0(this, request, response, operationHistoryToRemove));
}
;
_.getFetchCriteria = function getFetchCriteria_38(request){
  return this.getFetchCriteria_5(request);
}
;
_.getFetchCriteria_5 = function getFetchCriteria_39(request){
  var criteria, endDateFilter, endOfDay, startDateFilter, startOfDay, statusFilter;
  statusFilter = dynamicCast(getArrayFilter($getCriteria(request), 'status', Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit), Q$OperationRequestStatus_$1);
  if (statusFilter == null || statusFilter.length == 0) {
    return null;
  }
  criteria = new ResourceOperationHistoryCriteria_0;
  criteria.filterStatuses = getListIgnoringNulls(statusFilter);
  startDateFilter = dynamicCast(getFilter($getCriteria(request), 'startTime', Ljava_util_Date_2_classLit), Q$Date);
  if (startDateFilter) {
    startOfDay = getAbsoluteDate(($clinit_RelativeDate() , START_OF_TODAY), startDateFilter, ($clinit_RelativeDateRangePosition() , START));
    $addFilterStartTime_3(criteria, valueOf_45(startOfDay.getTime_0()));
  }
  endDateFilter = dynamicCast(getFilter($getCriteria(request), 'endTime', Ljava_util_Date_2_classLit), Q$Date);
  if (endDateFilter) {
    endOfDay = getAbsoluteDate(($clinit_RelativeDate() , END_OF_TODAY), endDateFilter, ($clinit_RelativeDateRangePosition() , END));
    $addFilterEndTime_4(criteria, valueOf_45(endOfDay.getTime_0()));
  }
  switch (this.entityContext.type_0.ordinal) {
    case 0:
      $addFilterResourceIds_5(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.entityContext.resourceId)]));
      break;
    case 2:
      $addFilterGroupOperationHistoryId(criteria, valueOf_44(this.entityContext.groupId));
  }
  return criteria;
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_7(columnName){
  if ($equals_6('resourceAncestry', columnName)) {
    return 'resource.ancestry';
  }
  return columnName;
}
;
_.getTotalRows_0 = function getTotalRows_1(result, response, request){
  return max_0(result.size_0, result.totalSize);
}
;
_.entityContext = null;
function $setConfiguration_2(this$static, configuration){
  this$static.configuration = configuration;
}

function AbstractOperationHistoryPortlet$OperationHistoryPortletDataSource_0(entityContext){
  $clinit_RPCDataSource();
  OperationHistoryDataSource_1.call(this, entityContext);
  this.configuration = null;
}

defineSeed(2590, 2591, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), AbstractOperationHistoryPortlet$OperationHistoryPortletDataSource_0);
_.getFetchCriteria_5 = function getFetchCriteria_40(request){
  var beginEnd, criteria, currentSetting, indx, isAdvanced, lastN, operationStatuses, orderingField, pageSize, parsedValues, priority, priority$index, priority$max, property, range, s, units;
  criteria = new ResourceOperationHistoryCriteria_0;
  currentSetting = $getSimpleValue(this.configuration, 'RESULT_COUNT', '5');
  pageSize = valueOf_44(__parseAndValidateInt(currentSetting)).value_0;
  orderingField = new OrderingField_1('createdTime', ($clinit_PageOrdering() , DESC));
  $setPageControl(criteria, new PageControl_2(pageSize, initValues(_3Lorg_rhq_core_domain_util_OrderingField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$OrderingField, [orderingField])));
  currentSetting = $getSimpleValue(this.configuration, 'OPERATION_STATUS', '');
  parsedValues = $split($trim(currentSetting), ',', 0);
  if (!(!$trim(currentSetting).length || parsedValues.length == ($clinit_OperationRequestStatus() , $clinit_OperationRequestStatus() , $VALUES_96).length)) {
    operationStatuses = initDim(_3Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1, Q$OperationRequestStatus_$1]), Q$OperationRequestStatus, parsedValues.length, 0);
    indx = 0;
    for (priority$index = 0 , priority$max = parsedValues.length; priority$index < priority$max; ++priority$index) {
      priority = parsedValues[priority$index];
      s = ($clinit_OperationRequestStatus() , dynamicCast(valueOf(($clinit_OperationRequestStatus$Map() , $MAP_96), priority), Q$OperationRequestStatus));
      operationStatuses[indx++] = s;
    }
    criteria.filterStatuses = getListIgnoringNulls(operationStatuses);
  }
  property = $getSimple(this.configuration, 'METRIC_RANGE_ENABLE');
  if (!!property && ($clinit_Boolean() , (property.stringValue == null?null:$equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE).value_0?TRUE:FALSE).value_0) {
    isAdvanced = ($clinit_Boolean() , $equalsIgnoreCase('true', $getSimpleValue(this.configuration, 'METRIC_RANGE_BEGIN_END_FLAG', ($clinit_PortletConfigurationEditorComponent$Constant() , 'false')))?TRUE:FALSE).value_0;
    if (isAdvanced) {
      currentSetting = $getSimpleValue(this.configuration, 'METRIC_RANGE', '');
      range = $split(currentSetting, ',', 0);
      if (range.length == 2) {
        $addFilterStartTime_3(criteria, new Long_0(__parseAndValidateLong(range[0])));
        $addFilterEndTime_4(criteria, new Long_0(__parseAndValidateLong(range[1])));
      }
    }
     else {
      property = $getSimple(this.configuration, 'METRIC_RANGE_LASTN');
      if (property) {
        lastN = valueOf_44(__parseAndValidateInt($getSimpleValue(this.configuration, 'METRIC_RANGE_LASTN', '8')));
        units = valueOf_44(__parseAndValidateInt($getSimpleValue(this.configuration, 'METRIC_RANGE_UNIT', '3')));
        beginEnd = calculateTimeFrame(lastN.value_0, units.value_0);
        $addFilterStartTime_3(criteria, valueOf_45(dynamicCast((checkIndex(0, beginEnd.size_0) , beginEnd.array[0]), Q$Long).value_0));
        $addFilterEndTime_4(criteria, valueOf_45(dynamicCast((checkIndex(1, beginEnd.size_0) , beginEnd.array[1]), Q$Long).value_0));
      }
    }
  }
  switch (this.entityContext.type_0.ordinal) {
    case 0:
      $addFilterResourceIds_5(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.entityContext.resourceId)]));
      break;
    case 2:
      $addFilterGroupOperationHistoryId(criteria, valueOf_44(this.entityContext.groupId));
  }
  return criteria;
}
;
_.getTotalRows_0 = function getTotalRows_2(result, response, request){
  return result.size_0;
}
;
_.configuration = null;
function $clinit_OperationHistoryPortlet(){
  $clinit_OperationHistoryPortlet = nullMethod;
  $clinit_OperationHistoryView();
  NAME_15 = ($clinit_Enhanced() , 'Recent Operations');
}

function OperationHistoryPortlet_0(){
  $clinit_OperationHistoryPortlet();
  AbstractOperationHistoryPortlet_0.call(this, new EntityContext_0(null, null, null));
}

defineSeed(2592, 2587, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced, Q$EnhancedHLayout]), OperationHistoryPortlet_0);
var NAME_15;
function $clinit_OperationHistoryPortlet$Factory(){
  $clinit_OperationHistoryPortlet$Factory = nullMethod;
  INSTANCE_21 = new OperationHistoryPortlet$Factory_0;
}

function OperationHistoryPortlet$Factory_0(){
}

defineSeed(2593, 1, makeCastMap([Q$PortletViewFactory]), OperationHistoryPortlet$Factory_0);
_.getInstance = function getInstance_15(context){
  return new OperationHistoryPortlet_0;
}
;
var INSTANCE_21;
function $clinit_OperationSchedulePortlet(){
  $clinit_OperationSchedulePortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_16 = ($clinit_Enhanced() , 'Scheduled Operations');
  RANGE_DISABLED_MESSAGE = '(Results currently disabled. Change settings to enable results.';
  RANGE_DISABLED_MESSAGE_DEFAULT = 'No items to show';
  unlimitedString_0 = 'unlimited';
}

function $configure_12(this$static, portletWindow, storedPortlet){
  var $e0, property, retrieved;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  retrieved = '5';
  property = $getSimple(storedPortlet.configuration, 'operations-range-scheduled');
  if (!!property && property.stringValue != null) {
    retrieved = property.stringValue;
    try {
      __parseAndValidateInt(retrieved);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$NumberFormatException)) {
        retrieved = '-1';
      }
       else 
        throw $e0;
    }
  }
   else {
    $put_4(storedPortlet.configuration, new PropertySimple_1('operations-range-scheduled', '5'));
  }
  $setOperationsRangeScheduled(this$static.dataSourceScheduled, __parseAndValidateInt(retrieved));
  property = $getSimple(storedPortlet.configuration, 'operations-scheduled-enabled');
  if (!!property && !!(property.stringValue == null?null:($clinit_Boolean() , $equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE))) {
    $setOperationsRangeScheduleEnabled(this$static.dataSourceScheduled, (property.stringValue == null?null:($clinit_Boolean() , $equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE)).value_0);
  }
   else {
    $put_4(storedPortlet.configuration, new PropertySimple_1('operations-scheduled-enabled', ($clinit_Boolean() , $clinit_Boolean() , TRUE)));
    this$static.dataSourceScheduled.operationsRangeNextEnabled = true;
  }
}

function $refresh_14(this$static){
  !!this$static.scheduledOperationsGrid && $invalidateCache_0(this$static.scheduledOperationsGrid);
  $markForRedraw(this$static);
}

function OperationSchedulePortlet_0(){
  $clinit_OperationSchedulePortlet();
  EnhancedVLayout_0.call(this);
  this.dataSourceScheduled = new ScheduledOperationsDataSource_0(this);
}

defineSeed(2594, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), OperationSchedulePortlet_0);
_.configure = function configure_16(portletWindow, storedPortlet){
  $configure_12(this, portletWindow, storedPortlet);
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_12(){
  var $e0, acceptableDisplayValues, column, enableScheduledOperationsGrouping, fieldWrapper, fieldWrapper2, form, maximumScheduledOperationsComboBox, property, retrieved, selectedValue, sheduledOperationsLayout, storedPortlet;
  form = new DynamicForm_0;
  storedPortlet = this.portletWindow.storedPortlet;
  column = new VStack_0;
  sheduledOperationsLayout = new EnhancedHLayout_0;
  enableScheduledOperationsGrouping = new CheckboxItem_0;
  $isCreated_2(enableScheduledOperationsGrouping)?$setProperty_8(enableScheduledOperationsGrouping, 'name', 'operations-scheduled-enabled'):(enableScheduledOperationsGrouping.jsObj['name'] = 'operations-scheduled-enabled' , undefined);
  $setTitle_1(enableScheduledOperationsGrouping, ' ' + ($clinit_Enhanced() , 'show Next') + ' ');
  $addChangeHandler(enableScheduledOperationsGrouping, new OperationSchedulePortlet$5_0(form));
  fieldWrapper = new DynamicForm_0;
  fieldWrapper.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [enableScheduledOperationsGrouping]));
  $addMember(sheduledOperationsLayout, fieldWrapper);
  property = $getSimple(storedPortlet.configuration, 'operations-scheduled-enabled');
  property?$setValue_6(enableScheduledOperationsGrouping, property.stringValue == null?null:($clinit_Boolean() , $equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE)):$setValue_9(enableScheduledOperationsGrouping, true);
  maximumScheduledOperationsComboBox = new SelectItem_1('operations-range-scheduled');
  $isCreated_2(maximumScheduledOperationsComboBox)?$setProperty_8(maximumScheduledOperationsComboBox, 'title', ''):(maximumScheduledOperationsComboBox.jsObj['title'] = '' , undefined);
  $setHint(maximumScheduledOperationsComboBox, '<nobr><b> scheduled operations.<\/b><\/nobr>');
  $isCreated_2(maximumScheduledOperationsComboBox)?$setProperty_8(maximumScheduledOperationsComboBox, 'type', 'selection'):(maximumScheduledOperationsComboBox.jsObj['type'] = 'selection' , undefined);
  acceptableDisplayValues = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['1', '5', '10', '15', unlimitedString_0]);
  maximumScheduledOperationsComboBox.setValueMap_1(acceptableDisplayValues);
  $isCreated_2(maximumScheduledOperationsComboBox)?$setProperty_6(maximumScheduledOperationsComboBox, 'width', 100):(maximumScheduledOperationsComboBox.jsObj['width'] = 100 , undefined);
  $addChangeHandler(maximumScheduledOperationsComboBox, new OperationSchedulePortlet$6_0(form));
  retrieved = '5';
  if (property = $getSimple(storedPortlet.configuration, 'operations-range-scheduled')) {
    retrieved = property.stringValue;
    try {
      __parseAndValidateInt(retrieved);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$NumberFormatException)) {
        retrieved = '-1';
      }
       else 
        throw $e0;
    }
  }
  selectedValue = $equals_6(retrieved, '-1')?unlimitedString_0:retrieved;
  $isCreated_2(maximumScheduledOperationsComboBox)?$setProperty_8(maximumScheduledOperationsComboBox, 'defaultValue', selectedValue):(maximumScheduledOperationsComboBox.jsObj['defaultValue'] = selectedValue , undefined);
  fieldWrapper2 = new DynamicForm_0;
  fieldWrapper2.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [maximumScheduledOperationsComboBox]));
  $addMember(sheduledOperationsLayout, fieldWrapper2);
  $addMember(column, sheduledOperationsLayout);
  $addChild(form, column);
  $addSubmitValuesHandler(form, new OperationSchedulePortlet$7_0(this, form, storedPortlet));
  return form;
}
;
_.getHelpCanvas = function getHelpCanvas_16(){
  return new HTMLFlow_1(($clinit_Enhanced() , "This portlet displays the next scheduled operations for the current user's inventory."));
}
;
_.isRefreshing = function isRefreshing_14(){
  return false;
}
;
_.onDestroy = function onDestroy_16(){
  onDestroy_0(this.refreshTimer);
}
;
_.onDraw_0 = function onDraw_29(){
  var ancestryNext, operationNext, resourceNext, timeNext;
  timeNext = new ListGridField_4(($clinit_ScheduledOperationsDataSource$Field() , TIME_4).propertyName, TIME_4.title_0, 200);
  $setCellFormatter_0(timeNext, new OperationSchedulePortlet$1_0);
  $setAttribute_8(timeNext, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(timeNext, ($clinit_TimestampCellFormatter() , new TimestampCellFormatter$1_0(TIME_4.propertyName)));
  operationNext = new ListGridField_3(OPERATION_0.propertyName, OPERATION_0.title_0);
  resourceNext = new ListGridField_3(RESOURCE_OR_GROUP.propertyName, RESOURCE_OR_GROUP.title_0);
  $setCellFormatter_0(resourceNext, new OperationSchedulePortlet$2_0);
  $setAttribute_8(resourceNext, 'showHover', TRUE);
  $setHoverCustomizer_0(resourceNext, new OperationSchedulePortlet$3_0);
  ancestryNext = new ListGridField_3('resourceAncestry', ($clinit_CoreGUI() , 'Ancestry'));
  $setAttribute_13(ancestryNext, 'align', ($clinit_Alignment() , LEFT_0).value_0);
  $setAttribute_13(ancestryNext, 'cellAlign', LEFT_0.value_0);
  $clinit_AncestryUtil();
  $setCellFormatter_0(ancestryNext, new AncestryUtil$2_0);
  $setAttribute_8(ancestryNext, 'showHover', TRUE);
  $setHoverCustomizer_0(ancestryNext, new OperationSchedulePortlet$4_0);
  $setFields_1(this.scheduledOperationsGrid, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [timeNext, operationNext, resourceNext, ancestryNext]));
}
;
_.onInit = function onInit_55(){
  $onInit(this);
  $onInit_Layout(this);
  this.scheduledOperationsGrid = new ListGrid_0;
  $setAttribute_20(this.scheduledOperationsGrid, 'dataSource', $getOrCreateJsObj(this.dataSourceScheduled), true);
  $setAutoFetchData_0(this.scheduledOperationsGrid, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_24(this.scheduledOperationsGrid, 'width', '100%', true);
  $setWrapCells(this.scheduledOperationsGrid, TRUE);
  $addMember(this, this.scheduledOperationsGrid);
}
;
_.refresh_0 = function refresh_24(){
  $refresh_14(this);
}
;
_.startRefreshCycle = function startRefreshCycle_15(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.dataSourceScheduled = null;
_.portletWindow = null;
_.refreshTimer = null;
_.scheduledOperationsGrid = null;
var NAME_16, RANGE_DISABLED_MESSAGE, RANGE_DISABLED_MESSAGE_DEFAULT, unlimitedString_0;
function OperationSchedulePortlet$1_0(){
  $clinit_TimestampCellFormatter();
  TimestampCellFormatter_0.call(this);
}

defineSeed(2595, 2388, {}, OperationSchedulePortlet$1_0);
_.format_1 = function format_35(value, record, rowNum, colNum){
  var id, opScheduleId, timestamp, url;
  if (value != null) {
    timestamp = format_30(value, this.dateTimeFormat);
    id = getAttributeAsInt(record.jsObj, 'resourceId');
    opScheduleId = getAttributeAsInt(record.jsObj, 'id');
    if (!id) {
      id = $getAttributeAsInt(record, ($clinit_ScheduledOperationsDataSource$Field() , GROUP_ID).propertyName);
      url = '#ResourceGroup/' + id.value_0 + '/Operations/Schedules/' + opScheduleId.value_0;
    }
     else {
      url = '#Resource/' + id.value_0 + '/Operations/Schedules/' + opScheduleId.value_0;
    }
    return getHref(url, timestamp);
  }
   else {
    return '<i>' + ($clinit_Enhanced() , 'none') + '<\/i>';
  }
}
;
function OperationSchedulePortlet$2_0(){
}

defineSeed(2596, 1, {}, OperationSchedulePortlet$2_0);
_.format_1 = function format_36(o, listGridRecord, i, i1){
  var id, url;
  id = getAttributeAsInt(listGridRecord.jsObj, 'resourceId');
  if (!id) {
    id = $getAttributeAsInt(listGridRecord, ($clinit_ScheduledOperationsDataSource$Field() , GROUP_ID).propertyName);
    url = '#ResourceGroup/' + id.value_0;
  }
   else {
    url = '#Resource/' + id.value_0;
  }
  return getHref(url, toString__devirtual$(o));
}
;
function OperationSchedulePortlet$3_0(){
}

defineSeed(2597, 1, {}, OperationSchedulePortlet$3_0);
_.hoverHTML_0 = function hoverHTML_7(value, listGridRecord, rowNum, colNum){
  var id, name_0, type;
  id = getAttributeAsInt(listGridRecord.jsObj, 'resourceId');
  if (id) {
    return ($clinit_Enhanced() , 'Resource') + ': ' + getResourceHoverHTML(listGridRecord);
  }
   else {
    type = $getAttributeAsString(listGridRecord, ($clinit_ScheduledOperationsDataSource$Field() , GROUP_TYPE).propertyName);
    name_0 = $getAttributeAsString(listGridRecord, RESOURCE_OR_GROUP.propertyName);
    return '<p>' + ($clinit_Enhanced() , 'Group') + ' (' + type + '):<br/><br/>' + name_0 + '<\/p>';
  }
}
;
function OperationSchedulePortlet$4_0(){
}

defineSeed(2598, 1, {}, OperationSchedulePortlet$4_0);
_.hoverHTML_0 = function hoverHTML_8(value, listGridRecord, rowNum, colNum){
  var id;
  id = getAttributeAsInt(listGridRecord.jsObj, 'resourceId');
  return id?getAncestryHoverHTML(listGridRecord, 0):($clinit_Enhanced() , 'Group');
}
;
function OperationSchedulePortlet$5_0(val$form){
  this.val$form = val$form;
}

defineSeed(2599, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), OperationSchedulePortlet$5_0);
_.onChange = function onChange_7(event_0){
  var selectedItem;
  selectedItem = '' + $getValue_1(event_0);
  $setValue_0(this.val$form, 'operations-scheduled-enabled', selectedItem);
}
;
_.val$form = null;
function OperationSchedulePortlet$6_0(val$form){
  this.val$form = val$form;
}

defineSeed(2600, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), OperationSchedulePortlet$6_0);
_.onChange = function onChange_8(event_0){
  var selectedItem;
  selectedItem = '' + $getValue_1(event_0);
  $setValue_0(this.val$form, 'operations-range-scheduled', selectedItem);
}
;
_.val$form = null;
function OperationSchedulePortlet$7_0(this$0, val$form, val$storedPortlet){
  this.this$0 = this$0;
  this.val$form = val$form;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2601, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), OperationSchedulePortlet$7_0);
_.onSubmitValues = function onSubmitValues_13(event_0){
  var value;
  value = dynamicCast($getValue(this.val$form, 'operations-range-scheduled'), Q$String);
  if (value != null) {
    value = $equals_6(($clinit_OperationSchedulePortlet() , unlimitedString_0), value)?'-1':value;
    $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('operations-range-scheduled', value));
  }
  $getValue(this.val$form, 'operations-scheduled-enabled') != null && $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('operations-scheduled-enabled', $getValue(this.val$form, 'operations-scheduled-enabled')));
  $setConfiguration_0(this.val$storedPortlet, this.val$storedPortlet.configuration);
  $configure_12(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $refresh_14(this.this$0);
}
;
_.this$0 = null;
_.val$form = null;
_.val$storedPortlet = null;
function $clinit_OperationSchedulePortlet$Factory(){
  $clinit_OperationSchedulePortlet$Factory = nullMethod;
  INSTANCE_22 = new OperationSchedulePortlet$Factory_0;
}

function OperationSchedulePortlet$Factory_0(){
}

defineSeed(2602, 1, makeCastMap([Q$PortletViewFactory]), OperationSchedulePortlet$Factory_0);
_.getInstance = function getInstance_16(context){
  return new OperationSchedulePortlet_0;
}
;
var INSTANCE_22;
function $clinit_ProblemResourcesPortlet(){
  $clinit_ProblemResourcesPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_17 = ($clinit_Enhanced() , 'Alerted or Unavailable Resources');
  unlimitedString_1 = 'unlimited';
}

function $configure_13(this$static, portletWindow, storedPortlet){
  var configuredValue;
  !this$static.portletWindow && !!portletWindow && (this$static.portletWindow = portletWindow);
  if (!storedPortlet || !storedPortlet.configuration) {
    return;
  }
  configuredValue = $populateConfigurationValue_0(storedPortlet, 'max-problems-shown', '20');
  $setMaximumProblemResourcesToDisplay(dynamicCast(this$static.dataSource_1, Q$ProblemResourcesDataSource), configuredValue);
  configuredValue = $populateConfigurationValue_0(storedPortlet, 'max-problems-query-span', '24');
  $setMaximumProblemResourcesWithinHours(dynamicCast(this$static.dataSource_1, Q$ProblemResourcesDataSource), configuredValue);
}

function $populateConfigurationValue_0(storedPortlet, propertyKey, defaultKeyValue){
  var $e0, configuredValue, retrieved;
  configuredValue = valueOf_44(__parseAndValidateInt(defaultKeyValue)).value_0;
  if (!storedPortlet || !storedPortlet.configuration) {
    return configuredValue;
  }
  if ($getSimple(storedPortlet.configuration, propertyKey)) {
    retrieved = $getSimple(storedPortlet.configuration, propertyKey).stringValue;
    try {
      configuredValue = __parseAndValidateInt(retrieved);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$NumberFormatException)) {
        configuredValue = -1;
      }
       else 
        throw $e0;
    }
  }
   else {
    $put_4(storedPortlet.configuration, new PropertySimple_1(propertyKey, defaultKeyValue));
  }
  return configuredValue;
}

function ProblemResourcesPortlet_0(){
  $clinit_ProblemResourcesPortlet();
  Table_7.call(this, NAME_17, true);
  this.showHeader = false;
  this.showFooter = true;
  this.showFooterRefresh = false;
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  this.dataSource = new ProblemResourcesDataSource_0(this);
  $setDataSource(this, this.dataSource);
}

defineSeed(2603, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced, Q$EnhancedHLayout]), ProblemResourcesPortlet_0);
_.configure = function configure_17(portletWindow, storedPortlet){
  $configure_13(this, portletWindow, storedPortlet);
}
;
_.configureTable = function configureTable_29(){
  var alertsField, ancestryField, availabilityField, listGrid, resourceField;
  listGrid = this.listGrid;
  !!listGrid && $addExtraWidget(this, new TimeRange_0(this), false);
  resourceField = new ListGridField_3(($clinit_ProblemResourcesDataSource$Field() , RESOURCE_3).propertyName, RESOURCE_3.title_0);
  $setCellFormatter_0(resourceField, new ProblemResourcesPortlet$1_0);
  $setAttribute_8(resourceField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(resourceField, new ProblemResourcesPortlet$2_0);
  ancestryField = setupAncestryListGridField();
  alertsField = new ListGridField_4(ALERTS.propertyName, ALERTS.title_0, 70);
  availabilityField = new IconField_2(AVAILABILITY_3.propertyName, AVAILABILITY_3.title_0, 70);
  $setListGridFields(this, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [resourceField, ancestryField, alertsField, availabilityField]));
}
;
_.getCustomSettingsForm = function getCustomSettingsForm_13(){
  var acceptableDisplayValues, acceptableTimeValues, configuredValue, form, maximumProblemResourcesComboBox, maximumTimeProblemResourcesComboBox, selectedValue, storedPortlet;
  form = new DynamicForm_0;
  storedPortlet = this.portletWindow.storedPortlet;
  maximumProblemResourcesComboBox = new SelectItem_1('max-problems-shown');
  $setTitle_1(maximumProblemResourcesComboBox, ($clinit_Enhanced() , 'Display'));
  $setHint(maximumProblemResourcesComboBox, '<nobr><b> maximum resources.<\/b><\/nobr>');
  $isCreated_2(maximumProblemResourcesComboBox)?$setProperty_8(maximumProblemResourcesComboBox, 'type', 'selection'):(maximumProblemResourcesComboBox.jsObj['type'] = 'selection' , undefined);
  acceptableDisplayValues = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['5', '10', '15', '20', '30', unlimitedString_1]);
  maximumProblemResourcesComboBox.setValueMap_1(acceptableDisplayValues);
  $isCreated_2(maximumProblemResourcesComboBox)?$setProperty_6(maximumProblemResourcesComboBox, 'width', 100):(maximumProblemResourcesComboBox.jsObj['width'] = 100 , undefined);
  configuredValue = $populateConfigurationValue_0(storedPortlet, 'max-problems-shown', '20');
  selectedValue = configuredValue == -1?unlimitedString_1:'' + configuredValue;
  $isCreated_2(maximumProblemResourcesComboBox)?$setProperty_8(maximumProblemResourcesComboBox, 'defaultValue', selectedValue):(maximumProblemResourcesComboBox.jsObj['defaultValue'] = selectedValue , undefined);
  maximumTimeProblemResourcesComboBox = new SelectItem_1('max-problems-query-span');
  $setTitle_1(maximumTimeProblemResourcesComboBox, 'Over ');
  $setHint(maximumTimeProblemResourcesComboBox, '<nobr><b> hours <\/b><\/nobr>');
  $isCreated_2(maximumTimeProblemResourcesComboBox)?$setProperty_8(maximumTimeProblemResourcesComboBox, 'type', 'selection'):(maximumTimeProblemResourcesComboBox.jsObj['type'] = 'selection' , undefined);
  acceptableTimeValues = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['1', '4', '8', '24', '48', unlimitedString_1]);
  maximumTimeProblemResourcesComboBox.setValueMap_1(acceptableTimeValues);
  $isCreated_2(maximumTimeProblemResourcesComboBox)?$setProperty_6(maximumTimeProblemResourcesComboBox, 'width', 100):(maximumTimeProblemResourcesComboBox.jsObj['width'] = 100 , undefined);
  configuredValue = $populateConfigurationValue_0(storedPortlet, 'max-problems-query-span', '24');
  selectedValue = configuredValue == -1?unlimitedString_1:'' + configuredValue;
  $isCreated_2(maximumTimeProblemResourcesComboBox)?$setProperty_8(maximumTimeProblemResourcesComboBox, 'defaultValue', selectedValue):(maximumTimeProblemResourcesComboBox.jsObj['defaultValue'] = selectedValue , undefined);
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [maximumProblemResourcesComboBox, maximumTimeProblemResourcesComboBox]));
  $addSubmitValuesHandler(form, new ProblemResourcesPortlet$3_0(this, form, storedPortlet));
  return form;
}
;
_.getDataSource_0 = function getDataSource_14(){
  return dynamicCast(this.dataSource_1, Q$ProblemResourcesDataSource);
}
;
_.getHelpCanvas = function getHelpCanvas_17(){
  return new HTMLFlow_1(($clinit_Enhanced() , "This portlet displays the current user's alerted or unavailable resources."));
}
;
_.isRefreshing = function isRefreshing_15(){
  return false;
}
;
_.onDestroy = function onDestroy_17(){
  onDestroy_0(this.refreshTimer);
}
;
_.refresh_0 = function refresh_25(){
  $refresh(this, false);
}
;
_.refreshTableInfo = function refreshTableInfo_4(){
  var begin, bounds, end;
  if (this.showFooter) {
    bounds = calculateTimeFrame(dynamicCast(this.dataSource_1, Q$ProblemResourcesDataSource).maximumProblemResourcesWithinHours, 3);
    begin = dynamicCast((checkIndex(0, bounds.size_0) , bounds.array[0]), Q$Long).value_0;
    end = dynamicCast((checkIndex(1, bounds.size_0) , bounds.array[1]), Q$Long).value_0;
    gt(sub(end, begin), P7528ad000_longLit)?(this.timeRange = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [$format(($clinit_MeasurementUtility() , $clinit_MeasurementUtility() , FORMATTER_YEAR), new Date_2(begin), null), $format(FORMATTER_YEAR, new Date_2(end), null)])):(this.timeRange = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [$format(($clinit_MeasurementUtility() , $clinit_MeasurementUtility() , FORMATTER), new Date_2(begin), null), $format(FORMATTER, new Date_2(end), null)]));
    $setContents_0(this.tableInfo, ($clinit_Enhanced() , 'Total') + ': ' + $getTotalRows(this.listGrid));
  }
}
;
_.startRefreshCycle = function startRefreshCycle_16(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.dataSource = null;
_.portletWindow = null;
_.refreshTimer = null;
_.timeRange = null;
var NAME_17, unlimitedString_1;
function ProblemResourcesPortlet$1_0(){
}

defineSeed(2604, 1, {}, ProblemResourcesPortlet$1_0);
_.format_1 = function format_37(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'id').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function ProblemResourcesPortlet$2_0(){
}

defineSeed(2605, 1, {}, ProblemResourcesPortlet$2_0);
_.hoverHTML_0 = function hoverHTML_9(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function ProblemResourcesPortlet$3_0(this$0, val$form, val$storedPortlet){
  this.this$0 = this$0;
  this.val$form = val$form;
  this.val$storedPortlet = val$storedPortlet;
}

defineSeed(2606, 1, makeCastMap([Q$EventHandler, Q$SubmitValuesHandler]), ProblemResourcesPortlet$3_0);
_.onSubmitValues = function onSubmitValues_14(event_0){
  var value;
  value = dynamicCast($getValue(this.val$form, 'max-problems-shown'), Q$String);
  if (value != null) {
    value = $equals_6(($clinit_ProblemResourcesPortlet() , unlimitedString_1), value)?'-1':value;
    $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('max-problems-shown', value));
  }
  value = dynamicCast($getValue(this.val$form, 'max-problems-query-span'), Q$String);
  if (value != null) {
    value = $equals_6(($clinit_ProblemResourcesPortlet() , unlimitedString_1), value)?'-1':value;
    $put_4(this.val$storedPortlet.configuration, new PropertySimple_1('max-problems-query-span', value));
  }
  $configure_13(this.this$0, this.this$0.portletWindow, this.val$storedPortlet);
  $refresh(this.this$0, false);
}
;
_.this$0 = null;
_.val$form = null;
_.val$storedPortlet = null;
function $clinit_ProblemResourcesPortlet$Factory(){
  $clinit_ProblemResourcesPortlet$Factory = nullMethod;
  INSTANCE_23 = new ProblemResourcesPortlet$Factory_0;
}

function ProblemResourcesPortlet$Factory_0(){
}

defineSeed(2607, 1, makeCastMap([Q$PortletViewFactory]), ProblemResourcesPortlet$Factory_0);
_.getInstance = function getInstance_17(context){
  return new ProblemResourcesPortlet_0;
}
;
var INSTANCE_23;
function TimeRange_0(problemResourcesPortlet){
  $clinit_BaseWidget();
  EnhancedHLayout_0.call(this);
  this.label = new Label_3;
  this.portlet = problemResourcesPortlet;
}

defineSeed(2608, 1539, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$TableWidget, Q$Enhanced, Q$EnhancedHLayout]), TimeRange_0);
_.onDraw_0 = function onDraw_30(){
  $addMember(this, this.label);
}
;
_.refresh_1 = function refresh_26(listGrid){
  $setWidth(this.label, 400);
  $setContents_0(this.label, 'From ' + ($clinit_Enhanced() , this.portlet.timeRange[0]) + ' to ' + this.portlet.timeRange[1]);
}
;
_.portlet = null;
function $clinit_ResourceAlertsPortlet(){
  $clinit_ResourceAlertsPortlet = nullMethod;
  $clinit_AlertHistoryView();
  NAME_18 = ($clinit_Enhanced() , 'Resource: Alerts');
}

function ResourceAlertsPortlet_0(resourceId){
  $clinit_ResourceAlertsPortlet();
  AbstractRecentAlertsPortlet_0.call(this, new EntityContext_0(valueOf_44(resourceId), null, null));
}

defineSeed(2609, 2496, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced, Q$EnhancedHLayout]), ResourceAlertsPortlet_0);
var NAME_18;
function $clinit_ResourceAlertsPortlet$Factory(){
  $clinit_ResourceAlertsPortlet$Factory = nullMethod;
  INSTANCE_24 = new ResourceAlertsPortlet$Factory_0;
}

function ResourceAlertsPortlet$Factory_0(){
}

defineSeed(2610, 1, makeCastMap([Q$PortletViewFactory]), ResourceAlertsPortlet$Factory_0);
_.getInstance = function getInstance_18(context){
  if (($clinit_EntityContext$Type() , Resource) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new ResourceAlertsPortlet_0(context.resourceId);
}
;
var INSTANCE_24;
function $clinit_ResourceBundleDeploymentsPortlet(){
  $clinit_ResourceBundleDeploymentsPortlet = nullMethod;
  $clinit_GroupBundleDeploymentsPortlet();
  NAME_19 = ($clinit_Enhanced() , 'Resource: Bundle Deployments');
}

function ResourceBundleDeploymentsPortlet_0(resourceId){
  $clinit_ResourceBundleDeploymentsPortlet();
  GroupBundleDeploymentsPortlet_0.call(this, -1);
  this.resourceId = resourceId;
}

defineSeed(2611, 2498, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), ResourceBundleDeploymentsPortlet_0);
_.getRecentBundleDeployments = function getRecentBundleDeployments_0(){
  var criteria, currentSetting, pc, portletConfig, resourceId, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  resourceId = this.resourceId;
  criteria = new ResourceBundleDeploymentCriteria_0;
  pc = new PageControl_0;
  currentSetting = $getSimpleValue(portletConfig, 'RESULT_COUNT', '5');
  !$trim(currentSetting).length?pc.setPageSize(valueOf_44(__parseAndValidateInt('5')).value_0):pc.setPageSize(valueOf_44(__parseAndValidateInt(currentSetting)).value_0);
  criteria.pageControlOverrides = pc;
  $addFilterResourceIds_3(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(resourceId)]));
  $addSortStatus_0(criteria, ($clinit_PageOrdering() , DESC));
  criteria.fetchDestination = true;
  criteria.fetchBundleVersion = true;
  criteria.fetchResourceDeployments = true;
  $findBundleDeploymentsByCriteria(dynamicCast(secure(getInstance_36(), -1), Q$BundleGWTServiceAsync), criteria, new ResourceBundleDeploymentsPortlet$1_0(this, resourceId));
}
;
_.resourceId = -1;
var NAME_19;
function $onSuccess_206(this$static, result){
  var child, child$array, child$index, child$max, column, deployment, deployment$iterator, destination, iconItem, link, row, time, title;
  column = new VLayout_0;
  $isCreated_1(column)?$setProperty_0(column, 'height', 10):(column.config_0['height'] = 10 , undefined);
  if (result.size_0 == 0) {
    row = createEmptyDisplayRow(($clinit_Enhanced() , 'No results found using specified criteria.'));
    column.addMember_0(row);
  }
   else {
    for (deployment$iterator = new AbstractList$IteratorImpl_0(result); deployment$iterator.i < deployment$iterator.this$0_0.size_1();) {
      deployment = dynamicCast($next_0(deployment$iterator), Q$BundleDeployment);
      row = new DynamicForm_0;
      $isCreated_1(row)?$setProperty_0(row, 'numCols', 3):(row.config_0['numCols'] = 3 , undefined);
      iconItem = newTextItemIcon('subsystems/content/Content_16.png', null);
      title = deployment.bundleVersion.name_0 + '[' + deployment.bundleVersion.version_0 + ']:';
      destination = getBundleDestinationLink(deployment.bundleVersion.bundle.id, deployment.destination.id);
      link = newLinkItem(title, destination);
      time = newTextItem(format_90(deployment.ctime.value_0));
      row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [iconItem, link, time]));
      column.addMember_0(row);
    }
  }
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentBundleDeployContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  column.markForRedraw_0();
  $addChild(this$static.this$0.recentBundleDeployContent, column);
  this$static.this$0.recentBundleDeployContent.markForRedraw_0();
  this$static.this$0.currentlyLoading = false;
  $markForRedraw(this$static.this$0);
}

function ResourceBundleDeploymentsPortlet$1_0(this$0, val$resourceId){
  this.this$0 = this$0;
  this.val$resourceId = val$resourceId;
}

defineSeed(2612, 1, {}, ResourceBundleDeploymentsPortlet$1_0);
_.onFailure = function onFailure_217(caught){
  debug('Error retrieving installed bundle deployments for resource [' + this.val$resourceId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_217(result){
  $onSuccess_206(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$resourceId = 0;
function $clinit_ResourceBundleDeploymentsPortlet$Factory(){
  $clinit_ResourceBundleDeploymentsPortlet$Factory = nullMethod;
  INSTANCE_25 = new ResourceBundleDeploymentsPortlet$Factory_0;
}

function ResourceBundleDeploymentsPortlet$Factory_0(){
}

defineSeed(2613, 1, makeCastMap([Q$PortletViewFactory]), ResourceBundleDeploymentsPortlet$Factory_0);
_.getInstance = function getInstance_19(context){
  if (($clinit_EntityContext$Type() , Resource) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new ResourceBundleDeploymentsPortlet_0(context.resourceId);
}
;
var INSTANCE_25;
function $clinit_ResourceConfigurationUpdatesPortlet(){
  $clinit_ResourceConfigurationUpdatesPortlet = nullMethod;
  $clinit_GroupConfigurationUpdatesPortlet();
  NAME_20 = ($clinit_Enhanced() , 'Resource: Configuration Updates');
}

function ResourceConfigurationUpdatesPortlet_0(resourceId){
  $clinit_ResourceConfigurationUpdatesPortlet();
  GroupConfigurationUpdatesPortlet_0.call(this, null);
  this.resourceId = resourceId;
}

defineSeed(2614, 2502, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), ResourceConfigurationUpdatesPortlet_0);
_.loadData = function loadData_0(){
  var criteria, portletConfig, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  criteria = new ResourceCriteria_0;
  $addFilterId(criteria, valueOf_44(this.resourceId));
  criteria.fetchResourceConfigurationUpdates = false;
  criteria.fetchOperationHistories = false;
  $findResourceCompositesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), criteria, new ResourceConfigurationUpdatesPortlet$1_0(this, portletConfig));
}
;
_.resourceComposite = null;
_.resourceHistoryTable = null;
_.resourceId = -1;
var NAME_20;
function $onSuccess_207(this$static, results){
  var child, child$array, child$index, child$max, criteria, lastFive;
  if (results.size_0 == 0) {
    this$static.this$0.resourceHistoryTable = new ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView_0(this$static.this$0, this$static.this$0.resourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONFIGURE_WRITE)), -1);
  }
   else {
    this$static.this$0.resourceComposite = dynamicCast((checkIndex(0, results.size_0) , results.array[0]), Q$ResourceComposite);
    lastFive = new PageControl_1(0, 5);
    criteria = new ResourceConfigurationUpdateCriteria_0;
    criteria.pageControlOverrides = lastFive;
    $addSortStatus(criteria, ($clinit_PageOrdering() , DESC));
    $addFilterResourceIds_4(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this$static.this$0.resourceId)]));
    this$static.this$0.resourceHistoryTable = new ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView_0(this$static.this$0, this$static.this$0.resourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONFIGURE_WRITE)), this$static.this$0.resourceId);
  }
  $setDataSource(this$static.this$0.resourceHistoryTable, new ResourceConfigurationUpdatesPortlet$ConfigurationUdpatesCriteriaDataSource_0(this$static.this$0, this$static.val$portletConfig));
  this$static.this$0.resourceHistoryTable.showHeader = false;
  this$static.this$0.resourceHistoryTable.showFooterRefresh = false;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentConfigurationContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.this$0.recentConfigurationContent, this$static.this$0.resourceHistoryTable);
  this$static.this$0.recentConfigurationContent.markForRedraw_0();
  this$static.this$0.currentlyLoading = false;
}

function ResourceConfigurationUpdatesPortlet$1_0(this$0, val$portletConfig){
  this.this$0 = this$0;
  this.val$portletConfig = val$portletConfig;
}

defineSeed(2615, 1, {}, ResourceConfigurationUpdatesPortlet$1_0);
_.onFailure = function onFailure_218(caught){
  debug('Error retrieving resource composite for resource [' + this.this$0.resourceId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_218(results){
  $onSuccess_207(this, dynamicCast(results, Q$PageList));
}
;
_.this$0 = null;
_.val$portletConfig = null;
function $copyValues_37(from){
  var record, resource, start, end;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'subjectName', from.subjectName);
  $setAttribute_13(record, 'status', from.status_0.name_0);
  $setAttribute_12(record, 'configuration', from.configuration);
  $setAttribute_4(record, 'duration', (start = from.createdTime , !from.status_0 || from.status_0 == ($clinit_ConfigurationUpdateStatus() , INPROGRESS)?(end = fromDouble(currentTimeMillis0())):(end = from.modifiedTime) , sub(end, start)));
  $setAttribute_13(record, 'errorMessage', from.errorMessage_0);
  $setAttribute_14(record, 'createdTime', new Date_2(from.createdTime));
  from.status_0 != ($clinit_ConfigurationUpdateStatus() , INPROGRESS) && $setAttribute_14(record, 'modifiedTime', new Date_2(from.modifiedTime));
  if (from.getAbstractGroupConfigurationUpdate()) {
    $setAttribute_3(record, 'groupConfigUpdateId', from.getAbstractGroupConfigurationUpdate().id);
    $setAttribute_3(record, 'groupId', from.getAbstractGroupConfigurationUpdate().group.id);
  }
  resource = from.getResource();
  $setAttribute_3(record, 'resourceId', resource.id);
  $setAttribute_13(record, 'resourceName', resource.name_0);
  $setAttribute_13(record, 'resourceAncestry', resource.ancestry);
  $setAttribute_3(record, 'resourceTypeId', resource.resourceType.id);
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  return record;
}

function $getFetchCriteria_7(this$static, request){
  var criteria, fetchConfiguration, ids, pageControl;
  criteria = this$static.createFetchCriteria();
  pageControl = $getPageControl(this$static, request);
  $addDefaultOrderingField(pageControl, 'id', ($clinit_PageOrdering() , DESC));
  criteria.pageControlOverrides = pageControl;
  ids = dynamicCast(getFilter($getCriteria(request), 'ids', Ljava_util_List_2_classLit), Q$List);
  !!ids && $addFilterIds(criteria, dynamicCast(ids.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, 0, 0)), Q$Integer_$1));
  fetchConfiguration = ($clinit_Boolean() , getAttributeAsBoolean(request.jsObj, 'fetchConfiguration')?TRUE:FALSE);
  !!fetchConfiguration && fetchConfiguration.value_0 && (criteria.fetchConfiguration = true);
  return criteria;
}

function $getListGridFields_8(this$static, includeResourceFields){
  var ancestryField, completedTimeField, fields, idField, resourceNameField, statusField, subjectField, submittedTimeField, updateTypeField;
  fields = new ArrayList_0;
  idField = new ListGridField_3('id', 'Version');
  $setAttribute_8(idField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(idField, new AbstractConfigurationHistoryDataSource$1_0);
  setCheck(fields.array, fields.size_0++, idField);
  submittedTimeField = new ListGridField_3('createdTime', 'Date Submitted');
  $setAttribute_13(submittedTimeField, 'type', ($clinit_ListGridFieldType() , DATE_0).value_0);
  $clinit_TimestampCellFormatter();
  prepareDateField(submittedTimeField, getAttribute(submittedTimeField.jsObj, 'name'));
  setCheck(fields.array, fields.size_0++, submittedTimeField);
  completedTimeField = new ListGridField_3('modifiedTime', 'Date Completed');
  $setAttribute_13(completedTimeField, 'type', DATE_0.value_0);
  prepareDateField(completedTimeField, getAttribute(completedTimeField.jsObj, 'name'));
  setCheck(fields.array, fields.size_0++, completedTimeField);
  statusField = new ListGridField_3('status', 'Status');
  $setAttribute_13(statusField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setCellFormatter_0(statusField, new AbstractConfigurationHistoryDataSource$2_0(this$static));
  $setAttribute_8(statusField, 'showHover', TRUE);
  $setHoverCustomizer_0(statusField, new AbstractConfigurationHistoryDataSource$3_0);
  $addRecordClickHandler_0(statusField, new AbstractConfigurationHistoryDataSource$4_0);
  setCheck(fields.array, fields.size_0++, statusField);
  subjectField = new ListGridField_3('subjectName', 'User');
  setCheck(fields.array, fields.size_0++, subjectField);
  updateTypeField = new ListGridField_3('groupConfigUpdateId', 'Update Type');
  $setCellFormatter_0(updateTypeField, new AbstractConfigurationHistoryDataSource$5_0(this$static));
  setCheck(fields.array, fields.size_0++, updateTypeField);
  if (includeResourceFields) {
    resourceNameField = new ListGridField_3('resourceName', 'Resource');
    $setCellFormatter_0(resourceNameField, new AbstractConfigurationHistoryDataSource$6_0);
    $setAttribute_8(resourceNameField, 'showHover', TRUE);
    $setHoverCustomizer_0(resourceNameField, new AbstractConfigurationHistoryDataSource$7_0);
    setCheck(fields.array, fields.size_0++, resourceNameField);
    ancestryField = setupAncestryListGridField();
    setCheck(fields.array, fields.size_0++, ancestryField);
    idField.jsObj['width'] = '10%';
    submittedTimeField.jsObj['width'] = 150;
    completedTimeField.jsObj['width'] = 150;
    statusField.jsObj['width'] = '10%';
    subjectField.jsObj['width'] = '10%';
    updateTypeField.jsObj['width'] = '10%';
    resourceNameField.jsObj['width'] = '30%';
    ancestryField.jsObj['width'] = '*';
  }
   else {
    idField.jsObj['width'] = '10%';
    submittedTimeField.jsObj['width'] = '20%';
    completedTimeField.jsObj['width'] = '20%';
    statusField.jsObj['width'] = '10%';
    subjectField.jsObj['width'] = '10%';
    updateTypeField.jsObj['width'] = '*';
  }
  return fields;
}

function $getStatusHtmlString_0(record){
  var html, obj_0;
  html = null;
  obj_0 = dynamicCast(getAttributeAsObject(record.jsObj, 'object'), Q$AbstractConfigurationUpdate);
  switch (obj_0.status_0.ordinal) {
    case 1:
      {
        html = 'This configuration update was successful';
        break;
      }

    case 0:
      {
        html = '<p>This configuration update is still in progress<\/p>';
        break;
      }

    case 3:
      {
        html = 'No changes were made to this configuration';
        break;
      }

    case 2:
      {
        html = obj_0.errorMessage_0;
        html == null?(html = '<p>This configuration update failed<\/p>'):html.length > 80?(html = '<pre>' + html.substr(0, 80 - 0) + '...<\/pre><p>Click the status icon for full details<\/p>'):(html = '<pre>' + html + '<\/pre>');
        break;
      }

  }
  return html;
}

function AbstractConfigurationHistoryDataSource_0(){
  var fields, fields_0, idField;
  RPCDataSource_0.call(this);
  this.configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), 60000), Q$ConfigurationGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , idField = new DataSourceIntegerField_1('id', 'Version') , $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , setCheck(fields_0.array, fields_0.size_0++, idField) , fields_0);
  $addFields(this, fields);
}

defineSeed(2618, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractConfigurationHistoryDataSource]));
_.copyValues = function copyValues_60(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'object'), Q$AbstractResourceConfigurationUpdate);
}
;
_.copyValues_0 = function copyValues_61(from){
  return $copyValues_37(dynamicCast(from, Q$AbstractResourceConfigurationUpdate));
}
;
_.getFetchCriteria_6 = function getFetchCriteria_41(request){
  return $getFetchCriteria_7(this, request);
}
;
_.getFetchCriteria = function getFetchCriteria_42(request){
  return this.getFetchCriteria_6(request);
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_8(columnName){
  if ($equals_6('groupConfigUpdateId', columnName)) {
    return 'groupConfigurationUpdate.id';
  }
  if ($equals_6('resourceAncestry', columnName)) {
    return 'resource.ancestry';
  }
  return columnName;
}
;
function ResourceConfigurationHistoryDataSource_0(){
  $clinit_RPCDataSource();
  AbstractConfigurationHistoryDataSource_0.call(this);
}

defineSeed(2617, 2618, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractConfigurationHistoryDataSource]), ResourceConfigurationHistoryDataSource_0);
_.createFetchCriteria = function createFetchCriteria(){
  return new ResourceConfigurationUpdateCriteria_0;
}
;
_.executeFetch = function executeFetch_34(request, response, criteria){
  this.executeFetch_4(request, response, dynamicCast(criteria, Q$ResourceConfigurationUpdateCriteria));
}
;
_.executeFetch_4 = function executeFetch_35(request, response, criteria){
  var resourceId;
  resourceId = dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('resourceId'), Q$Integer);
  $findResourceConfigurationUpdatesByCriteria(this.configurationService, criteria, new ResourceConfigurationHistoryDataSource$1_0(this, response, request, resourceId));
}
;
_.getConfigurationUpdateStatusIcon = function getConfigurationUpdateStatusIcon(status_0){
  return getResourceConfigurationIcon(status_0);
}
;
_.getFetchCriteria_6 = function getFetchCriteria_43(request){
  return this.getFetchCriteria_7(request);
}
;
_.getFetchCriteria_7 = function getFetchCriteria_44(request){
  var criteria, resourceId;
  criteria = dynamicCast($getFetchCriteria_7(this, request), Q$ResourceConfigurationUpdateCriteria);
  criteria.fetchResource = true;
  criteria.fetchGroupConfigurationUpdate = true;
  resourceId = dynamicCast(getFilter($getCriteria(request), 'resourceId', Ljava_lang_Integer_2_classLit), Q$Integer);
  !!resourceId && (criteria.filterResourceIds = new Arrays$ArrayList_0(initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [resourceId])));
  return criteria;
}
;
_.getGroupConfigurationUpdateHistoryLink = function getGroupConfigurationUpdateHistoryLink(groupId, value){
  return getGroupResourceConfigurationUpdateHistoryLink(new EntityContext_0(null, valueOf_44(groupId.value_0), null), valueOf_44(value.intValue()));
}
;
function ResourceConfigurationUpdatesPortlet$ConfigurationUdpatesCriteriaDataSource_0(this$0, portletConfig){
  $clinit_RPCDataSource();
  this.this$0 = this$0;
  ResourceConfigurationHistoryDataSource_0.call(this);
  this.portletConfig = portletConfig;
}

defineSeed(2616, 2617, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractConfigurationHistoryDataSource]), ResourceConfigurationUpdatesPortlet$ConfigurationUdpatesCriteriaDataSource_0);
_.executeFetch_4 = function executeFetch_36(request, response, criteria){
  var configurationService;
  configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  $findResourceConfigurationUpdatesByCriteria(configurationService, criteria, new ResourceConfigurationUpdatesPortlet$ConfigurationUdpatesCriteriaDataSource$1_0(this, response, request));
}
;
_.getFetchCriteria_7 = function getFetchCriteria_45(request){
  var beginEnd, configUpdateStatus, criteria, currentSetting, indx, isAdvanced, lastN, pageControl, parsedValues, priority, priority$index, priority$max, property, range, s, units, updateStatus;
  criteria = new ResourceConfigurationUpdateCriteria_0;
  $addFilterResourceIds_4(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.this$0.resourceId)]));
  pageControl = new PageControl_1(0, valueOf_44(__parseAndValidateInt('5')).value_0);
  if (this.portletConfig) {
    property = $getSimple(this.portletConfig, 'METRIC_RANGE_ENABLE');
    if (!!property && ($clinit_Boolean() , (property.stringValue == null?null:$equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE).value_0?TRUE:FALSE).value_0) {
      isAdvanced = ($clinit_Boolean() , $equalsIgnoreCase('true', $getSimpleValue(this.portletConfig, 'METRIC_RANGE_BEGIN_END_FLAG', ($clinit_PortletConfigurationEditorComponent$Constant() , 'false')))?TRUE:FALSE).value_0;
      if (isAdvanced) {
        currentSetting = $getSimpleValue(this.portletConfig, 'METRIC_RANGE', '');
        range = $split(currentSetting, ',', 0);
        if (range.length == 2) {
          $addFilterStartTime(criteria, new Long_0(__parseAndValidateLong(range[0])));
          $addFilterEndTime(criteria, new Long_0(__parseAndValidateLong(range[1])));
        }
      }
       else {
        property = $getSimple(this.portletConfig, 'METRIC_RANGE_LASTN');
        if (property) {
          lastN = valueOf_44(__parseAndValidateInt($getSimpleValue(this.portletConfig, 'METRIC_RANGE_LASTN', '8')));
          units = valueOf_44(__parseAndValidateInt($getSimpleValue(this.portletConfig, 'METRIC_RANGE_UNIT', '3')));
          beginEnd = calculateTimeFrame(lastN.value_0, units.value_0);
          $addFilterStartTime(criteria, valueOf_45(dynamicCast((checkIndex(0, beginEnd.size_0) , beginEnd.array[0]), Q$Long).value_0));
          $addFilterEndTime(criteria, valueOf_45(dynamicCast((checkIndex(1, beginEnd.size_0) , beginEnd.array[1]), Q$Long).value_0));
        }
      }
    }
    currentSetting = $getSimpleValue(this.portletConfig, 'RESULT_COUNT', '5');
    !$trim(currentSetting).length?pageControl.setPageSize(valueOf_44(__parseAndValidateInt('5')).value_0):pageControl.setPageSize(valueOf_44(__parseAndValidateInt(currentSetting)).value_0);
    criteria.pageControlOverrides = pageControl;
    configUpdateStatus = $getSimpleValue(this.portletConfig, 'CONFIG_UPDATE_STATUS', '');
    parsedValues = $split($trim(configUpdateStatus), ',', 0);
    if (!$trim(configUpdateStatus).length || parsedValues.length == ($clinit_ConfigurationUpdateStatus() , $clinit_ConfigurationUpdateStatus() , $VALUES_64).length)
    ;
    else {
      updateStatus = initDim(_3Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ConfigurationUpdateStatus, parsedValues.length, 0);
      indx = 0;
      for (priority$index = 0 , priority$max = parsedValues.length; priority$index < priority$max; ++priority$index) {
        priority = parsedValues[priority$index];
        s = ($clinit_ConfigurationUpdateStatus() , dynamicCast(valueOf(($clinit_ConfigurationUpdateStatus$Map() , $MAP_64), priority), Q$ConfigurationUpdateStatus));
        updateStatus[indx++] = s;
      }
      criteria.filterStatuses = getListIgnoringNulls(updateStatus);
    }
  }
  return criteria;
}
;
_.portletConfig = null;
_.this$0 = null;
function $onSuccess_208(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$1, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ResourceConfigurationUpdatesPortlet$ConfigurationUdpatesCriteriaDataSource$1_0(this$1, val$response, val$request){
  this.this$1 = this$1;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2619, 1, {}, ResourceConfigurationUpdatesPortlet$ConfigurationUdpatesCriteriaDataSource$1_0);
_.onFailure = function onFailure_219(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to get group resource config history'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$1, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_219(result){
  $onSuccess_208(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function $clinit_ResourceConfigurationUpdatesPortlet$Factory(){
  $clinit_ResourceConfigurationUpdatesPortlet$Factory = nullMethod;
  INSTANCE_26 = new ResourceConfigurationUpdatesPortlet$Factory_0;
}

function ResourceConfigurationUpdatesPortlet$Factory_0(){
}

defineSeed(2620, 1, makeCastMap([Q$PortletViewFactory]), ResourceConfigurationUpdatesPortlet$Factory_0);
_.getInstance = function getInstance_20(context){
  if (($clinit_EntityContext$Type() , Resource) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new ResourceConfigurationUpdatesPortlet_0(context.resourceId);
}
;
var INSTANCE_26;
function $configureTable_5(this$static){
  var fields;
  fields = $getListGridFields_8(dynamicCast(this$static.dataSource_1, Q$AbstractConfigurationHistoryDataSource), !this$static.resourceId);
  $setListGridFields(this$static, true, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $addTableAction(this$static, ($clinit_Enhanced() , 'Delete'), 'Are You Sure?', null, new AbstractConfigurationHistoryListView$1_0(this$static, this$static.hasWritePerm?($clinit_TableActionEnablement() , ANY_1):($clinit_TableActionEnablement() , NEVER_1)));
  $addTableAction(this$static, 'Compare', null, null, new AbstractConfigurationHistoryListView$2_0(this$static, ($clinit_TableActionEnablement() , MULTIPLE_1)));
  !!this$static.resourceId && $addTableAction(this$static, 'Rollback', 'Are You Sure?', null, new AbstractConfigurationHistoryListView$3_0(this$static, this$static.hasWritePerm?SINGLE_0:NEVER_1));
  $configureTable(this$static);
}

function AbstractConfigurationHistoryListView_0(title, hasWritePerm, resourceId){
  var criteria;
  $clinit_BaseWidget();
  TableSection_1.call(this, title, (criteria = new Criteria_0 , $addCriteria_1(criteria, 'resourceId', valueOf_44(resourceId)) , criteria));
  this.hasWritePerm = hasWritePerm;
  this.resourceId = valueOf_44(resourceId);
}

defineSeed(2623, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_30(){
  $configureTable_5(this);
}
;
_.getDetailsLinkColumnCellFormatter = function getDetailsLinkColumnCellFormatter_1(){
  return new AbstractConfigurationHistoryListView$4_0(this);
}
;
_.getDetailsLinkColumnName = function getDetailsLinkColumnName_2(){
  return 'id';
}
;
_.hasWritePerm = false;
_.resourceId = null;
function $clinit_ResourceConfigurationHistoryListView(){
  $clinit_ResourceConfigurationHistoryListView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_19 = new ViewName_2('ConfigurationHistoryView', ($clinit_Enhanced() , 'Configuration History'), ($clinit_IconEnum() , CONFIGURATION_HISTORY));
}

function ResourceConfigurationHistoryListView_0(hasWritePerm, resourceId){
  $clinit_ResourceConfigurationHistoryListView();
  var datasource;
  AbstractConfigurationHistoryListView_0.call(this, VIEW_ID_19.title_0, hasWritePerm, resourceId);
  datasource = new ResourceConfigurationHistoryDataSource_0;
  this.dataSource_1 = datasource;
}

defineSeed(2622, 2623, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), ResourceConfigurationHistoryListView_0);
_.delete_$ = function delete_$(doomedIds){
  $purgeResourceConfigurationUpdates(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), doomedIds, new ResourceConfigurationHistoryListView$2_0(this));
}
;
_.getDetailsView_0 = function getDetailsView_17(id){
  var detailView;
  detailView = new ConfigurationHistoryDetailView_0;
  return detailView;
}
;
_.getViewName = function getViewName_9(){
  return VIEW_ID_19;
}
;
_.rollback = function rollback(configHistoryIdToRollbackTo){
  $rollbackResourceConfiguration(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), this.resourceId.value_0, configHistoryIdToRollbackTo, new ResourceConfigurationHistoryListView$1_0(this));
}
;
var VIEW_ID_19;
function ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView_0(this$0, hasWritePerm, resourceId){
  $clinit_ResourceConfigurationHistoryListView();
  this.this$0 = this$0;
  ResourceConfigurationHistoryListView_0.call(this, hasWritePerm, resourceId);
}

defineSeed(2621, 2622, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView_0);
_.getBasePath = function getBasePath_6(){
  return 'Resource/' + this.this$0.resourceComposite.resource.id + '/Configuration/History';
}
;
_.getDetailsLinkColumnCellFormatter = function getDetailsLinkColumnCellFormatter_2(){
  return new ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView$1_0(this);
}
;
_.onInit = function onInit_56(){
  $onInit_2(this);
  this.listGrid.setEmptyMessage(($clinit_Enhanced() , 'No results found using specified criteria.'));
}
;
_.refreshTableInfo = function refreshTableInfo_5(){
  var count;
  $refreshTableInfo(this);
  if (this.tableInfo) {
    count = $getSelectedRecords(this.listGrid).length;
    $setContents_0(this.tableInfo, 'Matching Rows: ' + ($clinit_Enhanced() , '' + $getTotalRows(this.listGrid)) + ' (selected: ' + count + ')');
  }
}
;
_.this$0 = null;
function ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2624, 1, {}, ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView$1_0);
_.format_1 = function format_38(value, record, i, i1){
  var detailsUrl, recordId;
  recordId = $getId(this.this$1, record);
  detailsUrl = '#Resource/' + this.this$1.this$0.resourceComposite.resource.id + '/Configuration/History/' + recordId;
  return getHref(detailsUrl, toString__devirtual$(value));
}
;
_.this$1 = null;
function $clinit_ResourceEventsPortlet(){
  $clinit_ResourceEventsPortlet = nullMethod;
  $clinit_GroupEventsPortlet();
  NAME_21 = ($clinit_Enhanced() , 'Resource: Event Counts');
}

function ResourceEventsPortlet_0(resourceId){
  $clinit_ResourceEventsPortlet();
  GroupEventsPortlet_0.call(this, null);
  this.resourceId = resourceId;
}

defineSeed(2625, 2511, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), ResourceEventsPortlet_0);
_.getRecentEventUpdates = function getRecentEventUpdates_0(){
  var beginEnd, currentSetting, end, isAdvanced, lastN, portletConfig, property, range, resourceId, start, storedPortlet, units;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  resourceId = this.resourceId;
  end = fromDouble(currentTimeMillis0());
  start = sub(end, P5265c00_longLit);
  property = dynamicCast(portletConfig.properties.get_2('METRIC_RANGE_ENABLE'), Q$PropertySimple);
  if (!!property && ($clinit_Boolean() , (property.stringValue == null?null:$equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE).value_0?TRUE:FALSE).value_0) {
    isAdvanced = ($clinit_Boolean() , $equalsIgnoreCase('true', $getSimpleValue(portletConfig, 'METRIC_RANGE_BEGIN_END_FLAG', ($clinit_PortletConfigurationEditorComponent$Constant() , 'false')))?TRUE:FALSE).value_0;
    if (isAdvanced) {
      currentSetting = $getSimpleValue(portletConfig, 'METRIC_RANGE', '');
      range = $split(currentSetting, ',', 0);
      if (range.length == 2) {
        start = (new Long_0(__parseAndValidateLong(range[0]))).value_0;
        end = (new Long_0(__parseAndValidateLong(range[1]))).value_0;
      }
    }
     else {
      property = dynamicCast(portletConfig.properties.get_2('METRIC_RANGE_LASTN'), Q$PropertySimple);
      if (property) {
        lastN = valueOf_44(__parseAndValidateInt($getSimpleValue(portletConfig, 'METRIC_RANGE_LASTN', '8'))).value_0;
        units = valueOf_44(__parseAndValidateInt($getSimpleValue(portletConfig, 'METRIC_RANGE_UNIT', '3'))).value_0;
        beginEnd = calculateTimeFrame(lastN, units);
        start = valueOf_45(dynamicCast((checkIndex(0, beginEnd.size_0) , beginEnd.array[0]), Q$Long).value_0).value_0;
        end = valueOf_45(dynamicCast((checkIndex(1, beginEnd.size_0) , beginEnd.array[1]), Q$Long).value_0).value_0;
      }
    }
  }
  $getEventCountsBySeverity(dynamicCast(secure(getInstance_41(), -1), Q$EventGWTServiceAsync), resourceId, start, end, new ResourceEventsPortlet$1_0(this, resourceId));
}
;
_.resourceId = -1;
var NAME_21;
function $onSuccess_209(this$static, eventCounts){
  var child, child$array, child$index, child$max, column, count, iconItem, link, results, row, severity, severity$iterator, tuple, tuple$iterator;
  results = new ArrayList_0;
  for (severity$iterator = eventCounts.keySet_0().iterator(); severity$iterator.hasNext();) {
    severity = dynamicCast(severity$iterator.next_0(), Q$EventSeverity);
    count = dynamicCast(eventCounts.get_2(severity), Q$Integer).value_0;
    count > 0 && $add_3(results, new GwtTuple_0(severity, valueOf_44(count)));
  }
  column = new EnhancedVLayout_0;
  $isCreated_1(column)?$setProperty_0(column, 'height', 10):(column.config_0['height'] = 10 , undefined);
  if (results.size_0 == 0) {
    row = createEmptyDisplayRow(($clinit_AbstractActivityView() , RECENT_CRITERIA_EVENTS_NONE));
    $addMember(column, row);
  }
   else {
    for (tuple$iterator = new AbstractList$IteratorImpl_0(results); tuple$iterator.i < tuple$iterator.this$0_0.size_1();) {
      tuple = dynamicCast($next_0(tuple$iterator), Q$GwtTuple);
      row = new DynamicForm_0;
      $isCreated_1(row)?$setProperty_0(row, 'numCols', 2):(row.config_0['numCols'] = 2 , undefined);
      $isCreated_1(row)?$setProperty_0(row, 'width', 10):(row.config_0['width'] = 10 , undefined);
      iconItem = newTextItemIcon(getEventSeverityIcon(tuple.lefty), tuple.lefty.name_0);
      count = newTextItem('' + tuple.righty);
      row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [iconItem, count]));
      $addMember(column, row);
    }
    row = new DynamicForm_0;
    link = '#Resource/' + this$static.val$resourceId + '/Events/History/';
    addSeeMoreLink(row, link, column);
  }
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentEventsContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.this$0.recentEventsContent, column);
  this$static.this$0.currentlyLoading = false;
  this$static.this$0.recentEventsContent.markForRedraw_0();
}

function ResourceEventsPortlet$1_0(this$0, val$resourceId){
  this.this$0 = this$0;
  this.val$resourceId = val$resourceId;
}

defineSeed(2626, 1, {}, ResourceEventsPortlet$1_0);
_.onFailure = function onFailure_220(caught){
  debug('Error retrieving event counts for resource [' + this.val$resourceId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_220(eventCounts){
  $onSuccess_209(this, dynamicCast(eventCounts, Q$Map));
}
;
_.this$0 = null;
_.val$resourceId = 0;
function $clinit_ResourceEventsPortlet$Factory(){
  $clinit_ResourceEventsPortlet$Factory = nullMethod;
  INSTANCE_27 = new ResourceEventsPortlet$Factory_0;
}

function ResourceEventsPortlet$Factory_0(){
}

defineSeed(2627, 1, makeCastMap([Q$PortletViewFactory]), ResourceEventsPortlet$Factory_0);
_.getInstance = function getInstance_21(context){
  if (($clinit_EntityContext$Type() , Resource) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new ResourceEventsPortlet_0(context.resourceId);
}
;
var INSTANCE_27;
function $clinit_ResourceMetricsPortlet(){
  $clinit_ResourceMetricsPortlet = nullMethod;
  $clinit_GroupMetricsPortlet();
  NAME_22 = ($clinit_Enhanced() , 'Resource: Measurements');
}

function ResourceMetricsPortlet_0(resourceId){
  $clinit_ResourceMetricsPortlet();
  GroupMetricsPortlet_0.call(this, new EntityContext_0(valueOf_44(-1), null, null));
  this.resourceId = resourceId;
}

defineSeed(2628, 2515, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), ResourceMetricsPortlet_0);
_.getRecentMetrics = function getRecentMetrics_0(){
  var child, child$array, child$index, child$max, column, criteria, currentSetting, isAdvanced, portletConfig, property, range, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  column = new VLayout_0;
  $isCreated_1(column)?$setProperty_0(column, 'height', 10):(column.config_0['height'] = 10 , undefined);
  $isCreated_1(column)?$setProperty_3(column, 'width', '100%'):(column.config_0['width'] = '100%' , undefined);
  this.end_0 = N1_longLit;
  this.start_0 = N1_longLit;
  this.lastN = -1;
  this.units = -1;
  property = dynamicCast(portletConfig.properties.get_2('METRIC_RANGE_ENABLE'), Q$PropertySimple);
  if (!!property && ($clinit_Boolean() , (property.stringValue == null?null:$equalsIgnoreCase('true', property.stringValue)?TRUE:FALSE).value_0?TRUE:FALSE).value_0) {
    isAdvanced = ($clinit_Boolean() , $equalsIgnoreCase('true', $getSimpleValue(portletConfig, 'METRIC_RANGE_BEGIN_END_FLAG', ($clinit_PortletConfigurationEditorComponent$Constant() , 'false')))?TRUE:FALSE).value_0;
    if (isAdvanced) {
      currentSetting = $getSimpleValue(portletConfig, 'METRIC_RANGE', '');
      range = $split(currentSetting, ',', 0);
      if (range.length == 2) {
        this.start_0 = (new Long_0(__parseAndValidateLong(range[0]))).value_0;
        this.end_0 = (new Long_0(__parseAndValidateLong(range[1]))).value_0;
      }
    }
     else {
      property = dynamicCast(portletConfig.properties.get_2('METRIC_RANGE_LASTN'), Q$PropertySimple);
      if (property) {
        this.lastN = valueOf_44(__parseAndValidateInt($getSimpleValue(portletConfig, 'METRIC_RANGE_LASTN', '8'))).value_0;
        this.units = valueOf_44(__parseAndValidateInt($getSimpleValue(portletConfig, 'METRIC_RANGE_UNIT', '3'))).value_0;
      }
    }
  }
  criteria = new ResourceCriteria_0;
  $addFilterId(criteria, valueOf_44(this.resourceId));
  $findResourceCompositesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), criteria, new ResourceMetricsPortlet$1_0(this, column));
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this.recentMeasurementsContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this.recentMeasurementsContent, column);
  this.recentMeasurementsContent.markForRedraw_0();
}
;
_.graphView = null;
_.resourceId = -1;
_.window_0 = null;
var NAME_22;
function $onSuccess_210(this$static, results){
  var resource, resourceComposite, resourceType;
  if (results.size_0 != 0) {
    resourceComposite = dynamicCast((checkIndex(0, results.size_0) , results.array[0]), Q$ResourceComposite);
    resource = resourceComposite.resource;
    resourceType = resource.resourceType;
    $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(resourceType.id), of_0(($clinit_ResourceTypeRepository$MetadataType() , content_1), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceTypeRepository$MetadataType, [operations_0, measurements_0, events_0, resourceConfigurationDefinition_0])), new ResourceMetricsPortlet$1$1_0(this$static, resource, this$static.val$column, resourceComposite));
  }
}

function ResourceMetricsPortlet$1_0(this$0, val$column){
  this.this$0 = this$0;
  this.val$column = val$column;
}

defineSeed(2629, 1, {}, ResourceMetricsPortlet$1_0);
_.onFailure = function onFailure_221(caught){
  debug('Error retrieving resource resource composite for resource [' + this.this$0.resourceId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_221(results){
  $onSuccess_210(this, dynamicCast(results, Q$PageList));
}
;
_.this$0 = null;
_.val$column = null;
function ResourceMetricsPortlet$1$1_0(this$1, val$resource, val$column, val$resourceComposite){
  this.this$1 = this$1;
  this.val$resource = val$resource;
  this.val$column = val$column;
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(2630, 1, {}, ResourceMetricsPortlet$1$1_0);
_.onTypesLoaded = function onTypesLoaded_12(type){
  var callback, definition, definition$iterator, definitionArrayIds, definitionToDisplay, definitionToDisplay$index, definitionToDisplay$max, definitions, displayOrder, index, measurementDefMap;
  $setResourceType_0(this.val$resource, type);
  definitions = type.metricDefinitions;
  measurementDefMap = new HashMap_0;
  for (definition$iterator = definitions.iterator(); definition$iterator.hasNext();) {
    definition = dynamicCast(definition$iterator.next_0(), Q$MeasurementDefinition);
    measurementDefMap.put(definition.displayName, definition);
  }
  definitionArrayIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, definitions.size_1(), 1);
  displayOrder = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, definitions.size_1(), 0);
  $keySet(measurementDefMap).toArray_0(displayOrder);
  mergeSort(displayOrder, 0, displayOrder.length, ($clinit_Comparators() , $clinit_Comparators() , NATURAL));
  index = 0;
  for (definitionToDisplay$index = 0 , definitionToDisplay$max = displayOrder.length; definitionToDisplay$index < definitionToDisplay$max; ++definitionToDisplay$index) {
    definitionToDisplay = displayOrder[definitionToDisplay$index];
    definitionArrayIds[index++] = dynamicCast(measurementDefMap.get_2(definitionToDisplay), Q$MeasurementDefinition).id;
  }
  callback = new ResourceMetricsPortlet$1$1$1_0(this, displayOrder, measurementDefMap, this.val$column, this.val$resourceComposite);
  neq(this.this$1.this$0.end_0, N1_longLit) && neq(this.this$1.this$0.start_0, N1_longLit)?$findDataForResource(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this.this$1.this$0.resourceId, definitionArrayIds, this.this$1.this$0.start_0, this.this$1.this$0.end_0, callback):this.this$1.this$0.lastN != -1 && this.this$1.this$0.units != -1?$findDataForResourceForLast(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this.this$1.this$0.resourceId, definitionArrayIds, this.this$1.this$0.lastN, this.this$1.this$0.units, callback):$findDataForResourceForLast(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this.this$1.this$0.resourceId, definitionArrayIds, 8, 3, callback);
}
;
_.this$1 = null;
_.val$column = null;
_.val$resource = null;
_.val$resourceComposite = null;
function $onSuccess_211(this$static, results){
  var commaDelimitedList, contents, convertedValue, d, d$iterator, data, index, lastValue, link, md, minValue, row, someChartedData, sparklineContainer, sparklineGraph, title, value;
  if (results.isEmpty_0()) {
    row = createEmptyDisplayRow(($clinit_AbstractActivityView() , RECENT_MEASUREMENTS_NONE));
    this$static.val$column.addMember_0(row);
  }
   else {
    someChartedData = false;
    for (index = 0; index < this$static.val$displayOrder.length; ++index) {
      md = dynamicCast(this$static.val$measurementDefMap.get_2(this$static.val$displayOrder[index]), Q$MeasurementDefinition);
      data = dynamicCast(results.get_0(index), Q$List);
      lastValue = -1;
      minValue = 1.7976931348623157E308;
      for (d$iterator = data.iterator(); d$iterator.hasNext();) {
        d = dynamicCast(d$iterator.next_0(), Q$MeasurementDataNumericHighLowComposite);
        if (!isNaN_0(d.value_0) && ('' + d.value_0).indexOf('NaN') == -1) {
          d.value_0 < minValue && (minValue = d.value_0);
          lastValue = d.value_0;
        }
      }
      commaDelimitedList = '';
      for (d$iterator = data.iterator(); d$iterator.hasNext();) {
        d = dynamicCast(d$iterator.next_0(), Q$MeasurementDataNumericHighLowComposite);
        !isNaN_0(d.value_0) && ('' + d.value_0).indexOf('NaN') == -1 && (commaDelimitedList += d.value_0 + ',');
      }
      row = new DynamicForm_0;
      $isCreated_1(row)?$setProperty_0(row, 'numCols', 3):(row.config_0['numCols'] = 3 , undefined);
      $setColWidths(row, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [valueOf_44(65), '*', valueOf_44(100)]));
      $isCreated_1(row)?$setProperty_3(row, 'width', '100%'):(row.config_0['width'] = '100%' , undefined);
      $isCreated_1(row)?$setProperty_0(row, 'height', 1):(row.config_0['height'] = 1 , undefined);
      $setAttribute_24(row, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, true);
      sparklineGraph = new HTMLFlow_0;
      contents = "<span id='sparkline_" + index + "' class='dynamicsparkline' width='0' values='" + commaDelimitedList + "'>...<\/span>";
      $isCreated_1(sparklineGraph)?$setProperty_3(sparklineGraph, 'contents', contents):(sparklineGraph.config_0['contents'] = contents , undefined);
      $setAttribute_24(sparklineGraph, 'contentsType', ($clinit_ContentsType() , PAGE).value_0, false);
      $isCreated_1(sparklineGraph)?$setProperty_0(sparklineGraph, 'scrollbarSize', 0):(sparklineGraph.config_0['scrollbarSize'] = 0 , undefined);
      sparklineContainer = new CanvasItem_0;
      sparklineContainer.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
      $isCreated_2(sparklineContainer)?$setProperty_6(sparklineContainer, 'height', 16):(sparklineContainer.jsObj['height'] = 16 , undefined);
      $isCreated_2(sparklineContainer)?$setProperty_6(sparklineContainer, 'width', 60):(sparklineContainer.jsObj['width'] = 60 , undefined);
      $setAttribute_28(sparklineContainer, 'canvas', !sparklineGraph?null:$getOrCreateJsObj_0(sparklineGraph));
      title = md.displayName;
      link = newLinkItem(title, null);
      $isCreated_2(link)?$setProperty_8(link, 'prompt', title):(link.jsObj['prompt'] = title , undefined);
      $setAttribute_30(link, 'titleVAlign', ($clinit_VerticalAlignment() , TOP_2).value_0);
      $setAttribute_30(link, 'align', ($clinit_Alignment() , LEFT_0).value_0);
      $setAttribute_29(link, 'clipValue', TRUE);
      $setAttribute_29(link, 'wrap', TRUE);
      $isCreated_2(link)?$setProperty_6(link, 'height', 26):(link.jsObj['height'] = 26 , undefined);
      $setWidth_2(link, '100%');
      isBrowserPreIE9()?$setDisabled_2(link, TRUE):$addClickHandler_2(link, new ResourceMetricsPortlet$1$1$1$1_0(this$static, title, this$static.val$resourceComposite, md));
      convertedValue = convertLastValueForDisplay(lastValue, md);
      value = newTextItem(convertedValue);
      $setAttribute_30(value, 'vAlign', TOP_2.value_0);
      $setAttribute_30(value, 'align', RIGHT_0.value_0);
      row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [sparklineContainer, link, value]));
      $isCreated_1(row)?$setProperty_3(row, 'width', '100%'):(row.config_0['width'] = '100%' , undefined);
      if ($trim(md.name_0).indexOf('Trait.') == -1 && lastValue != -1) {
        this$static.val$column.addMember_0(row);
        someChartedData = true;
      }
    }
    if (someChartedData) {
      row = new DynamicForm_0;
      link = '#Resource/' + this$static.this$2.this$1.this$0.resourceId + '/Monitoring/Graphs/';
      addSeeMoreLink(row, link, this$static.val$column);
    }
     else {
      row = createEmptyDisplayRow(($clinit_AbstractActivityView() , RECENT_MEASUREMENTS_NONE));
      this$static.val$column.addMember_0(row);
    }
    graphSparkLines();
  }
  this$static.this$2.this$1.this$0.currentlyLoading = false;
}

function ResourceMetricsPortlet$1$1$1_0(this$2, val$displayOrder, val$measurementDefMap, val$column, val$resourceComposite){
  this.this$2 = this$2;
  this.val$displayOrder = val$displayOrder;
  this.val$measurementDefMap = val$measurementDefMap;
  this.val$column = val$column;
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(2631, 1, {}, ResourceMetricsPortlet$1$1$1_0);
_.onFailure = function onFailure_222(caught){
  debug('Error retrieving recent metrics charting data for resource [' + this.this$2.this$1.this$0.resourceId + ']:' + caught.getMessage());
  this.this$2.this$1.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_222(results){
  $onSuccess_211(this, dynamicCast(results, Q$List));
}
;
_.this$2 = null;
_.val$column = null;
_.val$displayOrder = null;
_.val$measurementDefMap = null;
_.val$resourceComposite = null;
function ResourceMetricsPortlet$1$1$1$1_0(this$3, val$title, val$resourceComposite, val$md){
  this.this$3 = this$3;
  this.val$title = val$title;
  this.val$resourceComposite = val$resourceComposite;
  this.val$md = val$md;
}

defineSeed(2632, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), ResourceMetricsPortlet$1$1$1$1_0);
_.onClick_0 = function onClick_112(event_0){
  this.this$3.this$2.this$1.this$0.window_0 = new AbstractActivityView$ChartViewWindow_0(this.val$title);
  this.this$3.this$2.this$1.this$0.graphView = createSingleGraph(this.val$resourceComposite.resource, valueOf_44(this.val$md.id));
  $addSetButtonClickHandler(this.this$3.this$2.this$1.this$0.graphView, new ResourceMetricsPortlet$1$1$1$1$1_0(this));
  $addItem(this.this$3.this$2.this$1.this$0.window_0, this.this$3.this$2.this$1.this$0.graphView);
  $show(this.this$3.this$2.this$1.this$0.window_0);
}
;
_.this$3 = null;
_.val$md = null;
_.val$resourceComposite = null;
_.val$title = null;
function ResourceMetricsPortlet$1$1$1$1$1_0(this$4){
  this.this$4 = this$4;
}

defineSeed(2633, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), ResourceMetricsPortlet$1$1$1$1$1_0);
_.onClick_0 = function onClick_113(event_0){
  $redrawGraphs_0(this.this$4.this$3.this$2.this$1.this$0.graphView);
}
;
_.this$4 = null;
function $clinit_ResourceMetricsPortlet$Factory(){
  $clinit_ResourceMetricsPortlet$Factory = nullMethod;
  INSTANCE_28 = new ResourceMetricsPortlet$Factory_0;
}

function ResourceMetricsPortlet$Factory_0(){
}

defineSeed(2634, 1, makeCastMap([Q$PortletViewFactory]), ResourceMetricsPortlet$Factory_0);
_.getInstance = function getInstance_22(context){
  if (($clinit_EntityContext$Type() , Resource) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new ResourceMetricsPortlet_0(context.resourceId);
}
;
var INSTANCE_28;
function $clinit_ResourceOobsPortlet(){
  $clinit_ResourceOobsPortlet = nullMethod;
  $clinit_GroupOobsPortlet();
  NAME_23 = ($clinit_Enhanced() , 'Resource: OOB Metrics');
}

function ResourceOobsPortlet_0(resourceId){
  $clinit_ResourceOobsPortlet();
  GroupOobsPortlet_0.call(this, -1);
  this.resourceId = resourceId;
}

defineSeed(2635, 2522, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), ResourceOobsPortlet_0);
_.getRecentOobs = function getRecentOobs_0(){
  var portletConfig, resourceId, resultCount, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  resourceId = this.resourceId;
  resultCount = $getSimpleValue(portletConfig, 'RESULT_COUNT', '5');
  !$trim(resultCount).length && (resultCount = '5');
  $getHighestNOOBsForResource(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), resourceId, valueOf_44(__parseAndValidateInt(resultCount)).value_0, new ResourceOobsPortlet$1_0(this, resourceId));
}
;
_.resourceId = -1;
var NAME_23;
function $onSuccess_212(this$static, result){
  var child, child$array, child$index, child$max, column, destination, link, oob, oob$iterator, row, time, title;
  column = new VLayout_0;
  $isCreated_1(column)?$setProperty_0(column, 'height', 10):(column.config_0['height'] = 10 , undefined);
  if (result.size_0 == 0) {
    row = createEmptyDisplayRow(($clinit_AbstractActivityView() , RECENT_OOB_NONE));
    column.addMember_0(row);
  }
   else {
    for (oob$iterator = new AbstractList$IteratorImpl_0(result); oob$iterator.i < oob$iterator.this$0_0.size_1();) {
      oob = dynamicCast($next_0(oob$iterator), Q$MeasurementOOBComposite);
      row = new DynamicForm_0;
      $isCreated_1(row)?$setProperty_0(row, 'numCols', 2):(row.config_0['numCols'] = 2 , undefined);
      title = oob.scheduleName;
      destination = '/resource/common/monitor/Visibility.do?m=' + oob.definitionId + '&id=' + this$static.val$resourceId + '&mode=chartSingleMetricSingleResource';
      link = newLinkItem(title, destination);
      $addClickHandler_2(link, new ResourceOobsPortlet$1$1_0(title, destination));
      time = newTextItem(format_90(oob.timestamp));
      row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [link, time]));
      column.addMember_0(row);
    }
  }
  this$static.this$0.recentOobContent.setContents('');
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentOobContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.this$0.recentOobContent, column);
  this$static.this$0.currentlyLoading = false;
  this$static.this$0.recentOobContent.markForRedraw_0();
}

function ResourceOobsPortlet$1_0(this$0, val$resourceId){
  this.this$0 = this$0;
  this.val$resourceId = val$resourceId;
}

defineSeed(2636, 1, {}, ResourceOobsPortlet$1_0);
_.onFailure = function onFailure_223(caught){
  debug('Error retrieving out of bound metrics for resource [' + this.val$resourceId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_223(result){
  $onSuccess_212(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$resourceId = 0;
function ResourceOobsPortlet$1$1_0(val$title, val$destination){
  this.val$title = val$title;
  this.val$destination = val$destination;
}

defineSeed(2637, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), ResourceOobsPortlet$1$1_0);
_.onClick_0 = function onClick_114(event_0){
  var iframe, window_0;
  window_0 = new AbstractActivityView$ChartViewWindow_0(this.val$title);
  iframe = new FullHTMLPane_0(this.val$destination);
  $addItem(window_0, iframe);
  $show(window_0);
}
;
_.val$destination = null;
_.val$title = null;
function $clinit_ResourceOobsPortlet$Factory(){
  $clinit_ResourceOobsPortlet$Factory = nullMethod;
  INSTANCE_29 = new ResourceOobsPortlet$Factory_0;
}

function ResourceOobsPortlet$Factory_0(){
}

defineSeed(2638, 1, makeCastMap([Q$PortletViewFactory]), ResourceOobsPortlet$Factory_0);
_.getInstance = function getInstance_23(context){
  if (($clinit_EntityContext$Type() , Resource) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new ResourceOobsPortlet_0(context.resourceId);
}
;
var INSTANCE_29;
function $clinit_ResourceOperationsPortlet(){
  $clinit_ResourceOperationsPortlet = nullMethod;
  $clinit_OperationHistoryView();
  NAME_24 = ($clinit_Enhanced() , 'Resource: Operations');
}

function ResourceOperationsPortlet_0(context){
  $clinit_ResourceOperationsPortlet();
  AbstractOperationHistoryPortlet_0.call(this, context);
}

defineSeed(2639, 2587, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced, Q$EnhancedHLayout]), ResourceOperationsPortlet_0);
var NAME_24;
function $clinit_ResourceOperationsPortlet$Factory(){
  $clinit_ResourceOperationsPortlet$Factory = nullMethod;
  INSTANCE_30 = new ResourceOperationsPortlet$Factory_0;
}

function ResourceOperationsPortlet$Factory_0(){
}

defineSeed(2640, 1, makeCastMap([Q$PortletViewFactory]), ResourceOperationsPortlet$Factory_0);
_.getInstance = function getInstance_24(context){
  if (($clinit_EntityContext$Type() , Resource) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new ResourceOperationsPortlet_0(context);
}
;
var INSTANCE_30;
function $clinit_ResourcePkgHistoryPortlet(){
  $clinit_ResourcePkgHistoryPortlet = nullMethod;
  $clinit_GroupPkgHistoryPortlet();
  NAME_25 = ($clinit_Enhanced() , 'Resource: Package History');
}

function ResourcePkgHistoryPortlet_0(resourceId){
  $clinit_ResourcePkgHistoryPortlet();
  GroupPkgHistoryPortlet_0.call(this, -1);
  this.resourceId = resourceId;
}

defineSeed(2641, 2538, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$CustomSettingsPortlet, Q$Enhanced]), ResourcePkgHistoryPortlet_0);
_.getRecentPkgHistory = function getRecentPkgHistory_0(){
  var criteria, currentSetting, pc, portletConfig, resourceId, storedPortlet;
  storedPortlet = this.portletWindow.storedPortlet;
  portletConfig = storedPortlet.configuration;
  resourceId = this.resourceId;
  criteria = new InstalledPackageHistoryCriteria_0;
  pc = new PageControl_0;
  currentSetting = $getSimpleValue(portletConfig, 'RESULT_COUNT', '5');
  !$trim(currentSetting).length?pc.setPageSize(valueOf_44(__parseAndValidateInt('5')).value_0):pc.setPageSize(valueOf_44(__parseAndValidateInt(currentSetting)).value_0);
  criteria.pageControlOverrides = pc;
  $addFilterResourceId_2(criteria, valueOf_44(resourceId));
  $addSortStatus_1(criteria, ($clinit_PageOrdering() , DESC));
  $findInstalledPackageHistoryByCriteria(dynamicCast(secure(getInstance_38(), -1), Q$ContentGWTServiceAsync), criteria, new ResourcePkgHistoryPortlet$1_0(this, resourceId));
}
;
_.resourceId = -1;
var NAME_25;
function $onSuccess_213(this$static, result){
  var child, child$array, child$index, child$max, column, history_0, history$iterator, iconItem, link, row, time, title;
  column = new VLayout_0;
  $isCreated_1(column)?$setProperty_0(column, 'height', 10):(column.config_0['height'] = 10 , undefined);
  if (result.size_0 == 0) {
    row = createEmptyDisplayRow(($clinit_Enhanced() , 'No results found using specified criteria.'));
    column.addMember_0(row);
  }
   else {
    for (history$iterator = new AbstractList$IteratorImpl_0(result); history$iterator.i < history$iterator.this$0_0.size_1();) {
      history_0 = dynamicCast($next_0(history$iterator), Q$InstalledPackageHistory);
      row = new DynamicForm_0;
      $isCreated_1(row)?$setProperty_0(row, 'numCols', 3):(row.config_0['numCols'] = 3 , undefined);
      iconItem = newTextItemIcon('subsystems/content/Package_16.png', null);
      title = history_0.packageVersion.fileName + ':';
      '/rhq/resource/content/audit-trail-item.xhtml?id=' + this$static.val$resourceId + '&selectedHistoryId=' + history_0.id;
      link = newTextItem(title);
      time = newTextItem(format_90(history_0.timestamp.value_0));
      row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [iconItem, link, time]));
      column.addMember_0(row);
    }
  }
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.recentPkgHistoryContent, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.this$0.recentPkgHistoryContent, column);
  this$static.this$0.recentPkgHistoryContent.markForRedraw_0();
  this$static.this$0.currentlyLoading = false;
  $markForRedraw(this$static.this$0);
}

function ResourcePkgHistoryPortlet$1_0(this$0, val$resourceId){
  this.this$0 = this$0;
  this.val$resourceId = val$resourceId;
}

defineSeed(2642, 1, {}, ResourcePkgHistoryPortlet$1_0);
_.onFailure = function onFailure_224(caught){
  debug('Error retrieving installed package history for group [' + this.val$resourceId + ']:' + caught.getMessage());
  this.this$0.currentlyLoading = false;
}
;
_.onSuccess_0 = function onSuccess_224(result){
  $onSuccess_213(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$resourceId = 0;
function $clinit_ResourcePkgHistoryPortlet$Factory(){
  $clinit_ResourcePkgHistoryPortlet$Factory = nullMethod;
  INSTANCE_31 = new ResourcePkgHistoryPortlet$Factory_0;
}

function ResourcePkgHistoryPortlet$Factory_0(){
}

defineSeed(2643, 1, makeCastMap([Q$PortletViewFactory]), ResourcePkgHistoryPortlet$Factory_0);
_.getInstance = function getInstance_25(context){
  if (($clinit_EntityContext$Type() , Resource) != context.type_0) {
    throw new IllegalArgumentException_1('Context [' + context + '] not supported by portlet');
  }
  return new ResourcePkgHistoryPortlet_0(context.resourceId);
}
;
var INSTANCE_31;
function $clinit_InventorySummaryPortlet(){
  $clinit_InventorySummaryPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_26 = ($clinit_Enhanced() , 'Inventory Summary');
}

function $createSummaryRow(name_0, label, value, viewPath){
  var item;
  if (viewPath != null) {
    item = new LinkItem_1(name_0);
    $setAttribute_30(item, 'titleVAlign', ($clinit_VerticalAlignment() , TOP_2).value_0);
    item.addClickHandler(new InventorySummaryPortlet$2_0(viewPath));
  }
   else {
    item = new StaticTextItem_1(name_0);
  }
  $isCreated_2(item)?$setProperty_8(item, 'title', label):(item.jsObj['title'] = label , undefined);
  $setDefaultValue_0(item, valueOf_44(value));
  $setAttribute_30(item, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  return item;
}

function $loadInventoryViewData(this$static){
  var child, child$array, child$index, child$max;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  !!this$static.form_0 && this$static.form_0.destroy_0();
  $getInventorySummary(this$static.resourceBossService, new InventorySummaryPortlet$1_0(this$static));
}

function InventorySummaryPortlet_0(){
  $clinit_InventorySummaryPortlet();
  EnhancedVLayout_0.call(this);
  this.resourceBossService = dynamicCast(secure(getInstance_50(), -1), Q$ResourceBossGWTServiceAsync);
  $loadInventoryViewData(this);
}

defineSeed(2644, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$AutoRefreshPortlet, Q$Enhanced]), InventorySummaryPortlet_0);
_.configure = function configure_18(portletWindow, storedPortlet){
}
;
_.getHelpCanvas = function getHelpCanvas_18(){
  return new HTMLFlow_1(($clinit_Enhanced() , "This portlet displays a short summary of the current user's viewable inventory and metric collection rate."));
}
;
_.isRefreshing = function isRefreshing_16(){
  return false;
}
;
_.onDestroy = function onDestroy_18(){
  onDestroy_0(this.refreshTimer);
}
;
_.refresh_0 = function refresh_27(){
  $loadInventoryViewData(this);
}
;
_.startRefreshCycle = function startRefreshCycle_17(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.form_0 = null;
_.refreshTimer = null;
var NAME_26;
function $onSuccess_214(this$static, summary){
  var avergeMetricsTotal, compatibleGroupTotal, formItems, groupDefinitionTotal, mixedGroupTotal, platformTotal, serverTotal, serviceTotal;
  this$static.this$0.form_0 = new DynamicForm_0;
  $setPadding(this$static.this$0.form_0, valueOf_44(5));
  formItems = new ArrayList_0;
  platformTotal = $createSummaryRow('platformTotal', ($clinit_Enhanced() , 'Platform Total'), summary.platformCount, 'Inventory/Resources/Platforms');
  setCheck(formItems.array, formItems.size_0++, platformTotal);
  serverTotal = $createSummaryRow('serverTotal', 'Server Total', summary.serverCount, 'Inventory/Resources/Servers');
  setCheck(formItems.array, formItems.size_0++, serverTotal);
  serviceTotal = $createSummaryRow('serviceTotal', 'Service Total', summary.serviceCount, 'Inventory/Resources/Services');
  setCheck(formItems.array, formItems.size_0++, serviceTotal);
  compatibleGroupTotal = $createSummaryRow('compatibleGroupTotal', 'Compatible Group Total', summary.compatibleGroupCount, 'Inventory/Groups/CompatibleGroups');
  setCheck(formItems.array, formItems.size_0++, compatibleGroupTotal);
  mixedGroupTotal = $createSummaryRow('mixedGroupTotal', 'Mixed Group Total', summary.mixedGroupCount, 'Inventory/Groups/MixedGroups');
  setCheck(formItems.array, formItems.size_0++, mixedGroupTotal);
  groupDefinitionTotal = $createSummaryRow('groupDefinitionTotal', 'Group Definition Total', summary.groupDefinitionCount, 'Inventory/Groups/DynagroupDefinitions');
  setCheck(formItems.array, formItems.size_0++, groupDefinitionTotal);
  avergeMetricsTotal = $createSummaryRow('averageMetricsTotal', 'Average Metrics per Minute', summary.scheduledMeasurementsPerMinute, null);
  setCheck(formItems.array, formItems.size_0++, avergeMetricsTotal);
  this$static.this$0.form_0.setItems(dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, formItems.size_0, 0)), Q$FormItem_$1));
  $setWrapItemTitles(this$static.this$0.form_0, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setCellPadding(this$static.this$0.form_0);
  $addMember(this$static.this$0, this$static.this$0.form_0);
}

function InventorySummaryPortlet$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2645, 1, {}, InventorySummaryPortlet$1_0);
_.onFailure = function onFailure_225(throwable){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to retrieve inventory summary'), throwable);
}
;
_.onSuccess_0 = function onSuccess_225(summary){
  $onSuccess_214(this, dynamicCast(summary, Q$InventorySummary));
}
;
_.this$0 = null;
function InventorySummaryPortlet$2_0(val$viewPath){
  this.val$viewPath = val$viewPath;
}

defineSeed(2646, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), InventorySummaryPortlet$2_0);
_.onClick_0 = function onClick_115(clickEvent){
  $clinit_CoreGUI();
  goToView(this.val$viewPath, null, false);
}
;
_.val$viewPath = null;
function $clinit_InventorySummaryPortlet$Factory(){
  $clinit_InventorySummaryPortlet$Factory = nullMethod;
  INSTANCE_32 = new InventorySummaryPortlet$Factory_0;
}

function InventorySummaryPortlet$Factory_0(){
}

defineSeed(2647, 1, makeCastMap([Q$PortletViewFactory]), InventorySummaryPortlet$Factory_0);
_.getInstance = function getInstance_26(context){
  return new InventorySummaryPortlet_0;
}
;
var INSTANCE_32;
function $drawTags(this$static, tags){
  var buf, flow, font, max, tag, tag$iterator;
  if (!tags) {
    return;
  }
  this$static.tags = tags;
  max = P0_longLit;
  for (tag$iterator = new AbstractList$IteratorImpl_0(tags); tag$iterator.i < tag$iterator.this$0_0.size_1();) {
    tag = dynamicCast($next_0(tag$iterator), Q$TagReportComposite);
    gt(tag.total, max) && (max = tag.total);
  }
  sort_1(tags, new TagCloudView$2_0);
  buf = new StringBuilder_0;
  for (tag$iterator = new AbstractList$IteratorImpl_0(tags); tag$iterator.i < tag$iterator.this$0_0.size_1();) {
    tag = dynamicCast($next_0(tag$iterator), Q$TagReportComposite);
    font = round_int(toDouble(tag.total) / toDouble(max) * 14) + 8;
    $append_12($append_9($append_12($append_12(($append_1(buf.data_0, '<a href="') , buf), getTagLink($toString_20(tag))), '" style="font-size: '), font), 'pt; margin: 8px;"');
    $append_12($append_12(($append_1(buf.data_0, ' title="') , buf), 'Tag used ' + ($clinit_Enhanced() , '' + toString_8(tag.total)) + ' times.'), '"');
    $equals_6($toString_20(tag), this$static.selectedTag) && ($append_1(buf.data_0, ' class="selectedTag"') , buf);
    $append_12($append_11(($append_1(buf.data_0, '>') , buf), tag), '<\/a> ');
  }
  flow = new HTMLFlow_1($toString_1(buf.data_0));
  $addMember(this$static, flow);
}

function $getDeleteButton(this$static){
  var button;
  if (!this$static.deleteButton) {
    button = new TagCloudView$DeleteButton_0(this$static);
    $isCreated_1(button)?$setProperty_3(button, 'icon', '[skin]/images/actions/remove.png'):(button.config_0['icon'] = '[skin]/images/actions/remove.png' , undefined);
    $setIconWidth(button, valueOf_44(16));
    $setIconHeight(button, valueOf_44(16));
    $setTitle_0(button, ($clinit_Enhanced() , 'Delete Tag'));
    $setAutoFit(button, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $addClickHandler(button, new TagCloudView$3_0(this$static));
    this$static.deleteButton = button;
  }
  return this$static.deleteButton;
}

function $getSelectedTagReportComposite(this$static){
  var tag, tag$iterator;
  if (this$static.selectedTag != null && !!this$static.tags) {
    for (tag$iterator = new AbstractList$IteratorImpl_0(this$static.tags); tag$iterator.i < tag$iterator.this$0_0.size_1();) {
      tag = dynamicCast($next_0(tag$iterator), Q$TagReportComposite);
      if ($equals_6($toString_20(tag), this$static.selectedTag)) {
        return tag;
      }
    }
  }
  return null;
}

function $setSelectedTag(this$static, selectedTag){
  var selected;
  this$static.selectedTag = selectedTag;
  selected = $getSelectedTagReportComposite(this$static);
  $setDisabled($getDeleteButton(this$static), !selected || gt(selected.total, P0_longLit));
  $removeMembers(this$static, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members')));
  $drawTags(this$static, this$static.tags);
}

function TagCloudView_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
}

defineSeed(2649, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), TagCloudView_0);
_.onDraw_0 = function onDraw_31(){
  var tagCriteria;
  $removeMembers(this, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')));
  tagCriteria = new TagCriteria_0;
  $setPageControl(tagCriteria, new PageControl_1(0, -1));
  $findTagReportCompositesByCriteria(dynamicCast(secure(getInstance_56(), -1), Q$TagGWTServiceAsync), tagCriteria, new TagCloudView$1_0(this));
}
;
_.deleteButton = null;
_.selectedTag = null;
_.tags = null;
function $clinit_TagCloudPortlet(){
  $clinit_TagCloudPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_27 = ($clinit_Enhanced() , 'Tag Cloud');
}

function TagCloudPortlet_0(){
  $clinit_TagCloudPortlet();
  TagCloudView_0.call(this);
}

defineSeed(2648, 2649, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), TagCloudPortlet_0);
_.configure = function configure_19(portletWindow, storedPortlet){
}
;
_.getHelpCanvas = function getHelpCanvas_19(){
  return new HTMLFlow_1(($clinit_Enhanced() , "This portlet displays the relative tag counts for the current user's inventory."));
}
;
var NAME_27;
function $clinit_TagCloudPortlet$Factory(){
  $clinit_TagCloudPortlet$Factory = nullMethod;
  INSTANCE_33 = new TagCloudPortlet$Factory_0;
}

function TagCloudPortlet$Factory_0(){
}

defineSeed(2650, 1, makeCastMap([Q$PortletViewFactory]), TagCloudPortlet$Factory_0);
_.getInstance = function getInstance_27(context){
  return new TagCloudPortlet_0;
}
;
var INSTANCE_33;
function $clinit_MashupPortlet(){
  $clinit_MashupPortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_28 = ($clinit_CoreGUI() , 'Mashup');
}

function MashupPortlet_0(){
  $clinit_MashupPortlet();
  HTMLPane_0.call(this);
  $clinit_CoreGUI();
  $setAttribute_24(this, 'contentsType', ($clinit_ContentsType() , PAGE).value_0, false);
}

defineSeed(2651, 448, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ConfigurablePortlet]), MashupPortlet_0);
_.configure = function configure_20(portletWindow, storedPortlet){
  var url;
  url = $getSimpleValue(storedPortlet.configuration, 'address', null);
  url != null?$isCreated_1(this)?$setProperty_3(this, 'contentsURL', url):(this.config_0['contentsURL'] = url , undefined):$isCreated_1(this)?$setProperty_3(this, 'contents', '<br/><i>Click the Settings button to configure this portlet.<\/i>'):(this.config_0['contents'] = '<br/><i>Click the Settings button to configure this portlet.<\/i>' , undefined);
}
;
_.getConfigurationDefinition = function getConfigurationDefinition(){
  var definition;
  definition = new ConfigurationDefinition_1('Portlet Configuration', 'The configuration settings for the portlet.');
  $put_6(definition, new PropertyDefinitionSimple_1('address', 'Web Address', true, ($clinit_PropertySimpleType() , STRING_0)));
  return definition;
}
;
_.getHelpCanvas = function getHelpCanvas_20(){
  return new HTMLFlow_1('This portlet displays the returned content of a remote HTTP request (via an iframe).');
}
;
var NAME_28;
function $clinit_MashupPortlet$Factory(){
  $clinit_MashupPortlet$Factory = nullMethod;
  INSTANCE_34 = new MashupPortlet$Factory_0;
}

function MashupPortlet$Factory_0(){
}

defineSeed(2652, 1, makeCastMap([Q$PortletViewFactory]), MashupPortlet$Factory_0);
_.getInstance = function getInstance_28(context){
  return new MashupPortlet_0;
}
;
var INSTANCE_34;
function $clinit_MessagePortlet(){
  $clinit_MessagePortlet = nullMethod;
  $clinit_BaseWidget();
  NAME_29 = ($clinit_CoreGUI() , 'Message');
}

function MessagePortlet_0(){
  var productInfo;
  $clinit_MessagePortlet();
  HTMLPane_0.call(this);
  $clinit_CoreGUI();
  productInfo = coreGUI.productInfo;
  DEFAULT_MESSAGE = '<h1>Welcome to ' + productInfo.shortName + '<\/h1>\n<p>This dashboard can be edited by clicking the (Edit Mode) button above.<\/p>\n<p>What would you like to do?<\/p>\n<p>&nbsp;&nbsp;<a href="#Inventory/Resources/AutodiscoveryQueue">Import newly discovered resources.<\/a><\/p>\n<p>&nbsp;&nbsp;<a href="#Inventory/Resources/AllResources">Search for resources.<\/a><\/p>\n<p>&nbsp;&nbsp;<a href="#Help">See help and documentation.<\/a><\/p>';
  $setAttribute_24(this, 'contentsType', ($clinit_ContentsType() , PAGE).value_0, false);
}

defineSeed(2653, 448, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ConfigurablePortlet]), MessagePortlet_0);
_.configure = function configure_21(portletWindow, storedPortlet){
  var contents;
  contents = $getSimpleValue(storedPortlet.configuration, 'message', null);
  if (contents != null) {
    ($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0).id != 2 && !$equals_6(contents, DEFAULT_MESSAGE) && (contents = escapeHtml(contents));
    $isCreated_1(this)?$setProperty_3(this, 'contents', contents):(this.config_0['contents'] = contents , undefined);
  }
   else {
    $setContents(this, DEFAULT_MESSAGE);
  }
}
;
_.getConfigurationDefinition = function getConfigurationDefinition_0(){
  var definition;
  definition = new ConfigurationDefinition_1('Portlet Configuration', 'The configuration settings for the portlet.');
  $put_6(definition, new PropertyDefinitionSimple_1('message', 'The message to display.', true, ($clinit_PropertySimpleType() , LONG_STRING)));
  return definition;
}
;
_.getHelpCanvas = function getHelpCanvas_21(){
  return new HTMLFlow_1('This portlet displays a static HTML message. The <i>message<\/i> property must be configured.');
}
;
var DEFAULT_MESSAGE = null, NAME_29;
function $clinit_MessagePortlet$Factory(){
  $clinit_MessagePortlet$Factory = nullMethod;
  INSTANCE_35 = new MessagePortlet$Factory_0;
}

function MessagePortlet$Factory_0(){
}

defineSeed(2654, 1, makeCastMap([Q$PortletViewFactory]), MessagePortlet$Factory_0);
_.getInstance = function getInstance_29(context){
  return new MessagePortlet_0;
}
;
var INSTANCE_35;
function $clinit_DriftHistoryView(){
  $clinit_DriftHistoryView = nullMethod;
  var c, c$index, c$max, categoryNames, categoryValues, i;
  $clinit_BaseWidget();
  SUBSYSTEM_VIEW_ID_1 = new ViewName_2('RecentDrifts', ($clinit_Enhanced() , 'Recent Drift'), ($clinit_IconEnum() , RECENT_DRIFT));
  DEFAULT_SORT_SPECIFIER_3 = new SortSpecifier_0('ctime', ($clinit_SortDirection() , DESCENDING));
  INITIAL_CRITERIA_2 = new Criteria_0;
  categoryValues = ($clinit_DriftCategory() , $clinit_DriftCategory() , $VALUES_80);
  categoryNames = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, categoryValues.length, 0);
  i = 0;
  for (c$index = 0 , c$max = categoryValues.length; c$index < c$max; ++c$index) {
    c = categoryValues[c$index];
    categoryNames[i++] = c.name_0;
  }
  $addCriteria_6(INITIAL_CRITERIA_2, 'categories', categoryNames);
}

function $configureTable_6(this$static){
  var dataSourceFields;
  dataSourceFields = this$static.getDataSource_2().getListGridFields_0();
  $setFields_1(this$static.listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
  $configureTable(this$static);
}

function DriftHistoryView_0(tableTitle, entityContext){
  DriftHistoryView_1.call(this, tableTitle, entityContext, INITIAL_CRITERIA_2);
}

function DriftHistoryView_1(tableTitle, context, initialCriteria){
  StringIDTableSection_0.call(this, tableTitle, initialCriteria, initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [DEFAULT_SORT_SPECIFIER_3]));
  this.context = context;
  this.initialCriteriaFixed = false;
  $setDataSource(this, this.getDataSource_2());
}

defineSeed(2656, 2374, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_31(){
  $configureTable_6(this);
}
;
_.configureTableFilters = function configureTableFilters_3(){
  var categories, categoryIcons;
  categories = new LinkedHashMap_1(3);
  $put_1(categories, ($clinit_DriftCategory() , FILE_ADDED).name_0, ($clinit_Enhanced() , 'File Added'));
  $put_1(categories, FILE_CHANGED.name_0, 'File Changed');
  $put_1(categories, FILE_REMOVED.name_0, 'File Removed');
  categoryIcons = new LinkedHashMap_1(3);
  $put_1(categoryIcons, FILE_ADDED.name_0, getDriftCategoryIcon(FILE_ADDED));
  $put_1(categoryIcons, FILE_CHANGED.name_0, getDriftCategoryIcon(FILE_CHANGED));
  $put_1(categoryIcons, FILE_REMOVED.name_0, getDriftCategoryIcon(FILE_REMOVED));
  this.categoryFilter = new EnumSelectItem_0('categories', 'Category', Lorg_rhq_core_domain_drift_DriftCategory_2_classLit, categories, categoryIcons);
  this.definitionFilter = new TextItem_3('definition', 'Definition');
  this.changeSetFilter = new TextItem_3('snapshot', 'Snapshot');
  this.pathFilter = new TextItem_3('path', 'Path');
  this.startDateFilter = new DateFilterItem_0('startTime', 'From');
  this.endDateFilter = new DateFilterItem_0('endTime', 'To');
  this.showFilterForm && $setFilterFormItems(this, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.definitionFilter, this.changeSetFilter, this.categoryFilter, this.startDateFilter, this.pathFilter, this.endDateFilter]));
}
;
_.getDataSource_2 = function getDataSource_15(){
  !this.dataSource && (this.dataSource = new DriftDataSource_0(this.context));
  return this.dataSource;
}
;
_.getDataSource_0 = function getDataSource_16(){
  return this.getDataSource_2();
}
;
_.getDetailsLinkColumnCellFormatter = function getDetailsLinkColumnCellFormatter_3(){
  return new DriftHistoryView$1_0(this);
}
;
_.getDetailsLinkColumnName = function getDetailsLinkColumnName_3(){
  return 'ctime';
}
;
_.getDetailsView_2 = function getDetailsView_18(driftId){
  return new DriftDetailsView_0(driftId);
}
;
_.categoryFilter = null;
_.changeSetFilter = null;
_.context = null;
_.dataSource = null;
_.definitionFilter = null;
_.endDateFilter = null;
_.pathFilter = null;
_.startDateFilter = null;
var DEFAULT_SORT_SPECIFIER_3, INITIAL_CRITERIA_2, SUBSYSTEM_VIEW_ID_1;
function $addDriftSelectionListener(this$static, listener){
  $add_3(this$static.driftSelectionListeners, listener);
}

function DriftCarouselMemberView_0(context, driftChangeSet, initialCriteria){
  $clinit_DriftHistoryView();
  DriftHistoryView_1.call(this, null, context, initialCriteria);
  this.driftSelectionListeners = new ArrayList_0;
  this.carouselCriteria = initialCriteria;
  this.changeSet = driftChangeSet;
  $setChangeSetId(dynamicCast((!this.dataSource && (this.dataSource = new DriftCarouselMemberView$DriftCarouselDataSource_0(this.context)) , this.dataSource), Q$DriftCarouselMemberView$DriftCarouselDataSource), this.changeSet.getId());
  this.showFooterRefresh = false;
}

defineSeed(2655, 2656, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), DriftCarouselMemberView_0);
_.configureTable = function configureTable_32(){
  $configureTable_6(this);
  $setListGridDoubleClickHandler(this, new DriftCarouselMemberView$1_0(this));
  $addSelectionChangedHandler(this.listGrid, new DriftCarouselMemberView$2_0(this));
}
;
_.configureTableFilters = function configureTableFilters_4(){
}
;
_.getCurrentCriteria = function getCurrentCriteria_0(){
  return this.carouselCriteria;
}
;
_.getDataSource_2 = function getDataSource_17(){
  return !this.dataSource && (this.dataSource = new DriftCarouselMemberView$DriftCarouselDataSource_0(this.context)) , this.dataSource;
}
;
_.updateTitleCanvas = function updateTitleCanvas_0(titleString){
  var imageHtml, link, resourceId, sb, titleCanvas;
  resourceId = this.context.resourceId;
  imageHtml = imgHTML('[SKIN]/actions/view.png');
  link = '#Resource/' + resourceId + '/Drift/Definitions/' + this.changeSet.getDriftDefinitionId() + '/Snapshot/' + this.changeSet.getVersion();
  sb = new StringBuilder_0;
  $append_12($append_12(($append_1(sb.data_0, '<a href="') , sb), link), '">');
  $append_1(sb.data_0, imageHtml);
  $append_1(sb.data_0, '<\/a>');
  $append_1(sb.data_0, '<span class="HeaderLabel">');
  $append_12(sb, ($clinit_Enhanced() , 'Snapshot'));
  $append_1(sb.data_0, ' ');
  $append_9(sb, this.changeSet.getVersion());
  $append_1(sb.data_0, '<\/span>');
  $append_1(sb.data_0, '<br/>');
  $append_12(sb, $format(($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_MEDIUM), new Date_2(this.changeSet.getCtime().value_0), null));
  titleCanvas = this.titleCanvas;
  $setAttribute_24(titleCanvas, 'width', '100%', true);
  $isCreated_1(titleCanvas)?$setProperty_0(titleCanvas, 'height', 35):(titleCanvas.config_0['height'] = 35 , undefined);
  $setContents(titleCanvas, $toString_1(sb.data_0));
  $setPadding(titleCanvas, valueOf_44(4));
  $markForRedraw(titleCanvas);
}
;
_.carouselCriteria = null;
_.changeSet = null;
function DriftCarouselMemberView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2657, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), DriftCarouselMemberView$1_0);
_.onDoubleClick = function onDoubleClick_9(event_0){
  var driftDefId, driftId, listGrid, record, resourceId, selectedRows, url;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    record = selectedRows[0];
    resourceId = getAttributeAsInt(record.jsObj, 'resourceId');
    driftDefId = getAttributeAsInt(record.jsObj, 'changSetDefId');
    driftId = $getId_0(this.this$0, record);
    url = getDriftCarouselDriftLink(resourceId.value_0, driftDefId.value_0, driftId);
    $clinit_CoreGUI();
    goToView(url, null, false);
  }
}
;
_.this$0 = null;
function DriftCarouselMemberView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2658, 1, makeCastMap([Q$EventHandler, Q$SelectionChangedHandler]), DriftCarouselMemberView$2_0);
_.onSelectionChanged = function onSelectionChanged_8(event_0){
  var isSelected, listener, listener$iterator, record;
  record = $getRecord_1(event_0);
  isSelected = $getState(event_0);
  for (listener$iterator = new AbstractList$IteratorImpl_0(this.this$0.driftSelectionListeners); listener$iterator.i < listener$iterator.this$0_0.size_1();) {
    listener = dynamicCast($next_0(listener$iterator), Q$DriftCarouselMemberView$DriftSelectionListener);
    isSelected?$add_3(listener.this$1.this$0.selectedRecords, record):$remove_4(listener.this$1.this$0.selectedRecords, record);
    $refreshCarouselInfo(listener.this$1.this$0);
    $setFilter(listener.this$1.this$0, getAttribute(record.jsObj, 'path'));
  }
}
;
_.this$0 = null;
function $clinit_DriftDataSource(){
  $clinit_DriftDataSource = nullMethod;
  $clinit_RPCDataSource();
  CATEGORY_ICON_NEW = getDriftCategoryIcon(null);
  CATEGORY_ICON_ADD = getDriftCategoryIcon(($clinit_DriftCategory() , FILE_ADDED));
  CATEGORY_ICON_CHANGE = getDriftCategoryIcon(FILE_CHANGED);
  CATEGORY_ICON_REMOVE = getDriftCategoryIcon(FILE_REMOVED);
}

function $dataRetrieved_1(this$static, result, response, request){
  var ancestries, driftComposite, driftComposite$iterator, resource, typeRepo, typesSet;
  switch (this$static.entityContext.type_0.ordinal) {
    case 0:
      $setAttribute_17(response, 'data', $buildRecords(this$static, result, true));
      $setTotalRows(response, valueOf_44(max_0(result.size_0, result.totalSize)));
      $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
      break;
    default:typesSet = new HashSet_0;
      ancestries = new HashSet_0;
      for (driftComposite$iterator = new AbstractList$IteratorImpl_0(result); driftComposite$iterator.i < driftComposite$iterator.this$0_0.size_1();) {
        driftComposite = dynamicCast($next_0(driftComposite$iterator), Q$DriftComposite);
        resource = driftComposite.resource;
        $add_6(typesSet, valueOf_44(resource.resourceType.id));
        $add_6(ancestries, resource.ancestry);
      }

      typesSet.addAll(getAncestryTypeIds(ancestries));
      typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
      $getResourceTypes_0(typeRepo, dynamicCast(typesSet.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new DriftDataSource$5_0(this$static, result, response, request));
  }
}

function $executeFetch_23(this$static, request, response, criteria){
  if (!criteria) {
    $setTotalRows(response, valueOf_44(0));
    $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
    return;
  }
  $findDriftCompositesByCriteria(this$static.driftService, criteria, new DriftDataSource$4_0(this$static, response, request));
}

function $getFetchCriteria_8(this$static, request){
  var $e0, categoriesFilter, changeSetFilter, criteria, endDateFilter, endOfDay, pathFilter, startDateFilter, startOfDay, version;
  categoriesFilter = dynamicCast(($clinit_RPCDataSource() , getArrayFilter($getCriteria(request), 'categories', Lorg_rhq_core_domain_drift_DriftCategory_2_classLit)), Q$DriftCategory_$1);
  if (categoriesFilter == null || categoriesFilter.length == 0) {
    return null;
  }
  changeSetFilter = dynamicCast(getFilter($getCriteria(request), 'snapshot', Ljava_lang_String_2_classLit), Q$String);
  pathFilter = dynamicCast(getFilter($getCriteria(request), 'path', Ljava_lang_String_2_classLit), Q$String);
  criteria = new GenericDriftCriteria_0;
  criteria.fetchChangeSet = true;
  criteria.filterCategories = getListIgnoringNulls(categoriesFilter);
  if (null != changeSetFilter && !!changeSetFilter.length) {
    try {
      version = valueOf_44(__parseAndValidateInt(changeSetFilter));
      criteria.filterChangeSetStartVersion = version;
      criteria.filterChangeSetEndVersion = version;
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$Exception)) {
        $addFilterChangeSetStartVersion(criteria, valueOf_44(1));
      }
       else 
        throw $e0;
    }
  }
   else {
    $addFilterChangeSetStartVersion(criteria, valueOf_44(1));
  }
  null != pathFilter && !!pathFilter.length && (criteria.filterPath = pathFilter);
  $addFilterDriftHandlingModes(criteria, initValues(_3Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DriftConfigurationDefinition$DriftHandlingMode, [($clinit_DriftConfigurationDefinition$DriftHandlingMode() , normal)]));
  startDateFilter = dynamicCast(getFilter($getCriteria(request), 'startTime', Ljava_util_Date_2_classLit), Q$Date);
  if (startDateFilter) {
    startOfDay = getAbsoluteDate(($clinit_RelativeDate() , START_OF_TODAY), startDateFilter, ($clinit_RelativeDateRangePosition() , START));
    $addFilterStartTime_2(criteria, valueOf_45(startOfDay.getTime_0()));
  }
  endDateFilter = dynamicCast(getFilter($getCriteria(request), 'endTime', Ljava_util_Date_2_classLit), Q$Date);
  if (endDateFilter) {
    endOfDay = getAbsoluteDate(($clinit_RelativeDate() , END_OF_TODAY), endDateFilter, ($clinit_RelativeDateRangePosition() , END));
    $addFilterEndTime_3(criteria, valueOf_45(endOfDay.getTime_0()));
  }
  this$static.entityContext.type_0.ordinal == 0 && $addFilterResourceIds_2(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this$static.entityContext.resourceId)]));
  return criteria;
}

function $getTotalRows_0(result){
  return max_0(result.size_0, result.totalSize);
}

function DriftDataSource_0(context){
  $clinit_DriftDataSource();
  RPCDataSource_0.call(this);
  this.driftService = dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync);
  this.entityContext = context;
  new ArrayList_0;
}

function convert_0(from){
  var drift, record, resource;
  record = new ListGridRecord_0;
  drift = from.drift;
  $setAttribute_13(record, 'id', drift.getId());
  $setAttribute_14(record, 'ctime', new Date_2(drift.getCtime().value_0));
  switch (drift.getChangeSet().getCategory_0().ordinal) {
    case 0:
      $setAttribute_13(record, 'category', getDriftCategoryIcon(null));
      break;
    case 1:
      $setAttribute_13(record, 'category', getDriftCategoryIcon(drift.getCategory()));
  }
  $setAttribute_13(record, 'path', drift.getPath());
  $setAttribute_13(record, 'changSetDef', from.driftDefName);
  $setAttribute_3(record, 'changeSetVersion', drift.getChangeSet().getVersion());
  $setAttribute_3(record, 'changSetDefId', drift.getChangeSet().getDriftDefinitionId());
  resource = from.resource;
  if (resource) {
    $setAttribute_3(record, 'resourceId', resource.id);
    $setAttribute_13(record, 'resourceName', resource.name_0);
    $setAttribute_13(record, 'resourceAncestry', resource.ancestry);
    $setAttribute_3(record, 'resourceTypeId', resource.resourceType.id);
  }
  return record;
}

defineSeed(2660, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), DriftDataSource_0);
_.copyValues = function copyValues_62(from){
  return null;
}
;
_.copyValues_0 = function copyValues_63(from){
  return convert_0(dynamicCast(from, Q$DriftComposite));
}
;
_.executeFetch = function executeFetch_37(request, response, criteria){
  $executeFetch_23(this, request, response, dynamicCast(criteria, Q$GenericDriftCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_46(request){
  return this.getFetchCriteria_8(request);
}
;
_.getFetchCriteria_8 = function getFetchCriteria_47(request){
  return $getFetchCriteria_8(this, request);
}
;
_.getListGridFields_0 = function getListGridFields_4(){
  var ancestryField, categoryField, changeSetDefField, changeSetVersionField, ctimeField, fields, pathField, resourceNameField;
  fields = new ArrayList_1(7);
  ctimeField = new ListGridField_3('ctime', ($clinit_RPCDataSource() , 'Creation Time'));
  $setCellFormatter_0(ctimeField, new TimestampCellFormatter_0);
  $setAttribute_8(ctimeField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(ctimeField, ($clinit_TimestampCellFormatter() , new TimestampCellFormatter$1_0('ctime')));
  setCheck(fields.array, fields.size_0++, ctimeField);
  changeSetDefField = new ListGridField_3('changSetDef', 'Definition');
  setCheck(fields.array, fields.size_0++, changeSetDefField);
  changeSetVersionField = new ListGridField_3('changeSetVersion', 'Snapshot');
  setCheck(fields.array, fields.size_0++, changeSetVersionField);
  categoryField = new ListGridField_3('category', 'Category');
  $setAttribute_13(categoryField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(categoryField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_8(categoryField, 'showHover', TRUE);
  $setHoverCustomizer_0(categoryField, new DriftDataSource$1_0);
  setCheck(fields.array, fields.size_0++, categoryField);
  pathField = new ListGridField_3('path', 'Path');
  setCheck(fields.array, fields.size_0++, pathField);
  if (this.entityContext.type_0 != ($clinit_EntityContext$Type() , Resource)) {
    resourceNameField = new ListGridField_3('resourceName', 'Resource');
    $setCellFormatter_0(resourceNameField, new DriftDataSource$2_0);
    $setAttribute_8(resourceNameField, 'showHover', TRUE);
    $setHoverCustomizer_0(resourceNameField, new DriftDataSource$3_0);
    setCheck(fields.array, fields.size_0++, resourceNameField);
    ancestryField = setupAncestryListGridField();
    setCheck(fields.array, fields.size_0++, ancestryField);
    ctimeField.jsObj['width'] = 100;
    changeSetVersionField.jsObj['width'] = 100;
    categoryField.jsObj['width'] = 100;
    pathField.jsObj['width'] = '*';
    resourceNameField.jsObj['width'] = '25%';
    ancestryField.jsObj['width'] = '40%';
  }
   else {
    ctimeField.jsObj['width'] = 200;
    changeSetVersionField.jsObj['width'] = 100;
    categoryField.jsObj['width'] = 100;
    pathField.jsObj['width'] = '*';
  }
  return fields;
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_9(columnName){
  if ($equals_6('resourceAncestry', columnName)) {
    return 'changeSet.resource.ancestry';
  }
  return columnName;
}
;
_.entityContext = null;
var CATEGORY_ICON_ADD, CATEGORY_ICON_CHANGE, CATEGORY_ICON_NEW, CATEGORY_ICON_REMOVE;
function $setChangeSetId(this$static, changeSetId){
  this$static.changeSetId = changeSetId;
}

function DriftCarouselMemberView$DriftCarouselDataSource_0(context){
  $clinit_DriftDataSource();
  DriftDataSource_0.call(this, context);
}

defineSeed(2659, 2660, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$DriftCarouselMemberView$DriftCarouselDataSource]), DriftCarouselMemberView$DriftCarouselDataSource_0);
_.getFetchCriteria_8 = function getFetchCriteria_48(request){
  var criteria;
  criteria = $getFetchCriteria_8(this, request);
  !criteria && (criteria = new GenericDriftCriteria_0);
  $addFilterChangeSetId(criteria, this.changeSetId);
  return criteria;
}
;
_.getListGridFields_0 = function getListGridFields_5(){
  var categoryField, fields, pathField;
  fields = new ArrayList_1(7);
  categoryField = new ListGridField_3('category', ($clinit_RPCDataSource() , 'Category'));
  $setAttribute_13(categoryField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(categoryField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_8(categoryField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(categoryField, new DriftCarouselMemberView$DriftCarouselDataSource$1_0);
  setCheck(fields.array, fields.size_0++, categoryField);
  pathField = new ListGridField_3('path', 'Path');
  setCheck(fields.array, fields.size_0++, pathField);
  categoryField.jsObj['width'] = 80;
  pathField.jsObj['width'] = '*';
  return fields;
}
;
_.changeSetId = null;
function DriftCarouselMemberView$DriftCarouselDataSource$1_0(){
}

defineSeed(2661, 1, {}, DriftCarouselMemberView$DriftCarouselDataSource$1_0);
_.hoverHTML_0 = function hoverHTML_10(value, record, rowNum, colNum){
  var cat;
  cat = getAttribute(record.jsObj, 'category');
  return $equals_6(($clinit_DriftDataSource() , CATEGORY_ICON_ADD), cat)?'File Added':$equals_6(CATEGORY_ICON_CHANGE, cat)?'File Changed':$equals_6(CATEGORY_ICON_REMOVE, cat)?'File Removed':$equals_6(CATEGORY_ICON_NEW, cat)?'Newly Detected':'';
}
;
function $buildCarousel(this$static, isRefresh){
  var changeSetCriteria, endVersion, startVersion, criteria, driftCategoriesFilter, driftPathFilter;
  !!this$static.carouselHolder && destroyMembers(this$static.carouselHolder);
  $clear_2(this$static.selectedRecords);
  changeSetCriteria = new GenericDriftChangeSetCriteria_0;
  $addFilterDriftDefinitionId(changeSetCriteria, valueOf_44(this$static.driftDefId));
  changeSetCriteria.filterStartVersion = '1';
  isRefresh && (endVersion = this$static.carouselStartFilter , !!endVersion && (changeSetCriteria.filterEndVersion = '' + endVersion) , startVersion = this$static.carouselEndFilter , !startVersion || 1 > startVersion.value_0?(startVersion = valueOf_44(1)):!!endVersion && startVersion.value_0 > endVersion.value_0 && (startVersion = endVersion) , !!this$static.maxSnapshotVersion && startVersion.value_0 > this$static.maxSnapshotVersion.value_0 && (startVersion = this$static.maxSnapshotVersion) , changeSetCriteria.filterStartVersion = '' + startVersion , criteria = $getCurrentCriteria(this$static) , driftCategoriesFilter = dynamicCast(getArrayFilter(criteria, 'categories', Lorg_rhq_core_domain_drift_DriftCategory_2_classLit), Q$DriftCategory_$1) , changeSetCriteria.filterDriftCategories = getListIgnoringNulls(driftCategoriesFilter) , driftPathFilter = dynamicCast(getFilter(criteria, 'path', Ljava_lang_String_2_classLit), Q$String) , null != driftPathFilter && !!driftPathFilter.length && (changeSetCriteria.filterDriftPath = driftPathFilter) , undefined);
  $addSortVersion(changeSetCriteria, ($clinit_PageOrdering() , DESC));
  $findDriftChangeSetsByCriteria(this$static.driftService, changeSetCriteria, new DriftCarouselView$2_0(this$static, isRefresh));
}

function $buildTitle(this$static, driftDef){
  $setTitleString_0(this$static, driftDef.name_0);
  $setTitleBackButton(this$static, new BackButton_0(($clinit_Enhanced() , 'Back to List'), '#Resource/' + this$static.context.resourceId + '/Drift/Definitions'));
}

function $getDetailsView_0(this$static, id){
  if (this$static.useDriftDetailsView) {
    return new DriftDetailsView_0(id);
  }
  return new DriftSnapshotView_0(this$static.context.resourceId, this$static.driftDefId, valueOf_44(__parseAndValidateInt(id)).value_0, this$static.hasWriteAccess);
}

function DriftCarouselView_0(entityContext, driftDefId, hasWriteAccess){
  $clinit_BaseWidget();
  EnhancedHLayout_0.call(this);
  this.titleIcons = new ArrayList_0;
  this.carouselActions = new ArrayList_0;
  this.extraWidgetsAboveFooter = new ArrayList_0;
  this.extraWidgetsInMainFooter = new ArrayList_0;
  this.carouselSizeFilter = valueOf_44(4);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , HIDDEN).value_0, false);
  this.titleString = null;
  this.initialCriteria_0 = null;
  this.selectedRecords = new ArrayList_0;
  this.driftService = dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync);
  this.context = entityContext;
  this.driftDefId = driftDefId;
  this.hasWriteAccess = hasWriteAccess;
}

function getInitialMemberCriteria(additionalCriteria){
  $clinit_BaseWidget();
  var initialCriteria;
  if (!additionalCriteria) {
    return $clinit_DriftHistoryView() , INITIAL_CRITERIA_2;
  }
  initialCriteria = new Criteria_0;
  addCriteria(initialCriteria, ($clinit_DriftHistoryView() , INITIAL_CRITERIA_2));
  addCriteria(initialCriteria, additionalCriteria);
  return initialCriteria;
}

defineSeed(2662, 2206, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$DetailsView, Q$RefreshableView, Q$Enhanced, Q$EnhancedHLayout]), DriftCarouselView_0);
_.isEditable_0 = function isEditable_1(){
  return true;
}
;
_.onDraw_0 = function onDraw_32(){
  var defCriteria;
  defCriteria = new DriftDefinitionCriteria_0;
  $addFilterId(defCriteria, valueOf_44(this.driftDefId));
  $fetchConfiguration(defCriteria, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $findDriftDefinitionsByCriteria(this.driftService, defCriteria, new DriftCarouselView$1_0(this));
}
;
_.renderView = function renderView_17(viewPath){
  var detail;
  if (viewPath.viewPath.size_0 > viewPath.index_0 && viewPath.viewPath.size_0 > viewPath.index_0 + 1) {
    detail = dynamicCast($get_0(viewPath.viewPath, viewPath.index_0 + 1), Q$ViewId).path;
    if ($equals_6('Drift', detail) || $equals_6('Snapshot', detail)) {
      this.useDriftDetailsView = viewPath.viewPath.size_0 > viewPath.index_0 + 1 && $equals_6('Drift', dynamicCast($get_0(viewPath.viewPath, viewPath.index_0 + 1), Q$ViewId).path);
      $renderView_6(this, viewPath);
    }
  }
}
;
_.context = null;
_.driftDefId = 0;
_.hasWriteAccess = false;
_.maxSnapshotVersion = null;
_.useDriftDetailsView = false;
function $onSuccess_215(this$static, result){
  $buildTitle(this$static.this$0, dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$DriftDefinition));
  $buildCarousel(this$static.this$0, false);
}

function DriftCarouselView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2663, 1, {}, DriftCarouselView$1_0);
_.onFailure = function onFailure_226(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to fetch drift instances'), caught);
}
;
_.onSuccess_0 = function onSuccess_226(result){
  $onSuccess_215(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $onSuccess_216(this$static, result){
  var carouselEnd, carouselSize, carouselStart, changeSet, changeSet$iterator, initialCriteria, size, view;
  carouselSize = this$static.this$0.carouselSizeFilter;
  carouselSize = valueOf_44(!carouselSize || carouselSize.value_0 < 1?4:carouselSize.value_0);
  size = carouselSize.value_0;
  carouselStart = null;
  carouselEnd = null;
  initialCriteria = getInitialMemberCriteria(this$static.val$isRefresh?$getCurrentCriteria(this$static.this$0):null);
  for (changeSet$iterator = new AbstractList$IteratorImpl_0(result); changeSet$iterator.i < changeSet$iterator.this$0_0.size_1();) {
    changeSet = dynamicCast($next_0(changeSet$iterator), Q$DriftChangeSet);
    view = new DriftCarouselMemberView_0(this$static.this$0.context, changeSet, initialCriteria);
    $addCarouselMember(this$static.this$0, view);
    $addDriftSelectionListener(view, new DriftCarouselView$2$1_0(this$static));
    !carouselStart && (carouselStart = valueOf_44(changeSet.getVersion()));
    carouselEnd = valueOf_44(changeSet.getVersion());
    if (--size == 0) {
      break;
    }
  }
  if (!this$static.this$0.maxSnapshotVersion || !carouselStart || this$static.this$0.maxSnapshotVersion.value_0 < carouselStart.value_0) {
    this$static.this$0.maxSnapshotVersion = carouselStart;
    $setCarouselStartFilterMax(this$static.this$0, this$static.this$0.maxSnapshotVersion);
  }
  $setCarouselStartFilter(this$static.this$0, carouselStart);
  $setCarouselEndFilter(this$static.this$0, carouselEnd);
  $setCarouselSizeFilter(this$static.this$0, carouselSize);
  this$static.val$isRefresh?$refreshCarouselInfo(this$static.this$0):$onDraw_1(this$static.this$0);
}

function DriftCarouselView$2_0(this$0, val$isRefresh){
  this.this$0 = this$0;
  this.val$isRefresh = val$isRefresh;
}

defineSeed(2664, 1, {}, DriftCarouselView$2_0);
_.onFailure = function onFailure_227(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to fetch drift instances'), caught);
}
;
_.onSuccess_0 = function onSuccess_227(result){
  $onSuccess_216(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$isRefresh = false;
function DriftCarouselView$2$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2665, 1, makeCastMap([Q$DriftCarouselMemberView$DriftSelectionListener]), DriftCarouselView$2$1_0);
_.this$1 = null;
function $executeAction(this$static){
  var diffNewId, diffOldId, id1, id2, path, record1, record2, version1, version2;
  record1 = dynamicCast($get_0(this$static.this$0.selectedRecords, 0), Q$Record);
  record2 = dynamicCast($get_0(this$static.this$0.selectedRecords, 1), Q$Record);
  path = getAttribute(record1.jsObj, 'path');
  id1 = getAttribute(record1.jsObj, 'id');
  id2 = getAttribute(record2.jsObj, 'id');
  version1 = getAttributeAsInt(record1.jsObj, 'changeSetVersion').value_0;
  version2 = getAttributeAsInt(record2.jsObj, 'changeSetVersion').value_0;
  diffOldId = version1 < version2?id1:id2;
  diffNewId = version1 < version2?id2:id1;
  $generateUnifiedDiffByIds(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), diffOldId, diffNewId, new DriftCarouselView$3$1_0(path));
}

function $isEnabled_2(this$static){
  var path1, path2;
  if (this$static.this$0.selectedRecords.size_0 == 2) {
    path1 = $getAttribute(dynamicCast($get_0(this$static.this$0.selectedRecords, 0), Q$Record), 'path');
    path2 = $getAttribute(dynamicCast($get_0(this$static.this$0.selectedRecords, 1), Q$Record), 'path');
    return null != path1 && $equals_6(path1, path2);
  }
  return false;
}

function DriftCarouselView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2666, 1, {}, DriftCarouselView$3_0);
_.this$0 = null;
function $onSuccess_217(this$static, diffReport){
  var diffContents, window_0;
  diffContents = formatAsHtml(diffReport.diff, 1, 2);
  window_0 = createDiffViewerWindow(diffContents, this$static.val$path, 1, 2);
  $show(window_0);
}

function DriftCarouselView$3$1_0(val$path){
  this.val$path = val$path;
}

defineSeed(2667, 1, {}, DriftCarouselView$3$1_0);
_.onFailure = function onFailure_228(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to generate diff.'), caught);
}
;
_.onSuccess_0 = function onSuccess_228(diffReport){
  $onSuccess_217(this, dynamicCast(diffReport, Q$FileDiffReport));
}
;
_.val$path = null;
function DriftDataSource$1_0(){
}

defineSeed(2668, 1, {}, DriftDataSource$1_0);
_.hoverHTML_0 = function hoverHTML_11(value, record, rowNum, colNum){
  var cat;
  cat = getAttribute(record.jsObj, 'category');
  return $equals_6(($clinit_DriftDataSource() , CATEGORY_ICON_ADD), cat)?'File Added':$equals_6(CATEGORY_ICON_CHANGE, cat)?'File Changed':$equals_6(CATEGORY_ICON_REMOVE, cat)?'File Removed':$equals_6(CATEGORY_ICON_NEW, cat)?'Newly Detected':'';
}
;
function DriftDataSource$2_0(){
}

defineSeed(2669, 1, {}, DriftDataSource$2_0);
_.format_1 = function format_39(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function DriftDataSource$3_0(){
}

defineSeed(2670, 1, {}, DriftDataSource$3_0);
_.hoverHTML_0 = function hoverHTML_12(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function $onFailure_25(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to fetch drift instances'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_218(this$static, result){
  var composite, defFilter, i;
  defFilter = dynamicCast(getFilter_0(this$static.val$request, 'definition', Ljava_lang_String_2_classLit), Q$String);
  if (null != defFilter && !!defFilter.length) {
    defFilter = defFilter.toLowerCase();
    for (i = new AbstractList$IteratorImpl_0(result); i.i < i.this$0_0.size_1();) {
      composite = dynamicCast($next_0(i), Q$DriftComposite);
      $indexOf_2(composite.driftDefName.toLowerCase(), defFilter) != -1 || $remove_7(i);
    }
  }
  $dataRetrieved_1(this$static.this$0, result, this$static.val$response, this$static.val$request);
}

function DriftDataSource$4_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2671, 1, {}, DriftDataSource$4_0);
_.onFailure = function onFailure_229(caught){
  $onFailure_25(this, caught);
}
;
_.onSuccess_0 = function onSuccess_229(result){
  $onSuccess_218(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function DriftDataSource$5_0(this$0, val$result, val$response, val$request){
  this.this$0 = this$0;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2672, 1, {}, DriftDataSource$5_0);
_.onTypesLoaded_0 = function onTypesLoaded_13(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44($getTotalRows_0(this.val$result)));
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $clinit_DriftDefinitionDataSource(){
  $clinit_DriftDefinitionDataSource = nullMethod;
  $clinit_RPCDataSource();
  DRIFT_HANDLING_MODE_NORMAL = 'normal';
  DRIFT_HANDLING_MODE_PLANNED = 'planned changes';
}

function $convert(this$static, from){
  var changeSet, def, record;
  def = from.driftDefinition;
  changeSet = from.mostRecentChangeset;
  record = new ListGridRecord_0;
  !def?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = def , undefined);
  $setAttribute_3(record, 'id', def.id);
  $setAttribute_13(record, 'name', def.name_0);
  $setAttribute_13(record, 'driftHandlingMode', getDriftHandlingModeDisplayName(def.driftHandlingMode));
  $setAttribute_13(record, 'interval', '' + toString_8(def.interval));
  $setAttribute_13(record, 'baseDirString', getBaseDirString($getBasedir(def)));
  $setAttribute_13(record, 'isEnabled', '' + def.isEnabled);
  $setAttribute_13(record, 'isEnabledIcon', getAvailabilityIcon(($clinit_Boolean() , def.isEnabled?TRUE:FALSE)));
  $setAttribute_3(record, 'compliance', def.complianceStatus.ordinal);
  $setAttribute_13(record, 'complianceIcon', getAvailabilityIcon(def.complianceStatus == ($clinit_DriftComplianceStatus() , IN_COMPLIANCE)?TRUE:FALSE));
  $setAttribute_13(record, 'edit', this$static.hasWriteAccess?'[SKIN]/actions/edit.png':'[SKIN]/actions/view.png');
  $setAttribute_13(record, 'isPinned', def.isPinned?'subsystems/drift/Pinned_active.png':'[SKIN]/headerIcons/pin_left.png');
  $setAttribute_13(record, 'attached', def.attached?($clinit_RPCDataSource() , 'Yes'):($clinit_RPCDataSource() , 'No'));
  def.template?$setAttribute_13(record, 'template', def.template.name_0):$setAttribute_13(record, 'template', ($clinit_RPCDataSource() , 'None'));
  $setAttribute_13(record, 'changesetVersion', changeSet?'' + changeSet.getVersion():($clinit_RPCDataSource() , 'none'));
  $setAttribute_14(record, 'changesetTime', changeSet?new Date_2(changeSet.getCtime().value_0):null);
  return record;
}

function $dataRetrieved_2(this$static, result, response, request){
  switch (this$static.entityContext.type_0.ordinal) {
    case 0:
      $setAttribute_17(response, 'data', $buildRecords(this$static, result, true));
      $setTotalRows(response, valueOf_44(result.size_0));
      $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
      break;
    case 2:
    default:throw new IllegalArgumentException_1('Unsupported Context Type: ' + this$static.entityContext);
  }
}

function $executeFetch_24(this$static, request, response, criteria){
  $findDriftDefinitionCompositesByCriteria(this$static.driftService, criteria, new DriftDefinitionDataSource$9_0(this$static, response, request));
}

function $getListGridFields_9(this$static, hasWriteAccess){
  var ancestryField, attachedField, baseDirField, changeSetField, changeSetTimeField, editField, enabledField, fields, inComplianceField, nameField, pinnedField, resourceNameField, templateField;
  this$static.hasWriteAccess = hasWriteAccess;
  fields = new ArrayList_1(6);
  nameField = new ListGridField_3('name', ($clinit_RPCDataSource() , 'Name'));
  setCheck(fields.array, fields.size_0++, nameField);
  pinnedField = new ListGridField_3('isPinned', 'Pinned?');
  $setAttribute_13(pinnedField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(pinnedField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $addRecordClickHandler_0(pinnedField, new DriftDefinitionDataSource$1_0(this$static));
  $setAttribute_8(pinnedField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(pinnedField, new DriftDefinitionDataSource$2_0);
  setCheck(fields.array, fields.size_0++, pinnedField);
  changeSetField = new ListGridField_3('changesetVersion', 'Snapshot');
  $setAttribute_8(changeSetField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, changeSetField);
  changeSetTimeField = new ListGridField_3('changesetTime', 'Snapshot Time');
  $setCellFormatter_0(changeSetTimeField, new TimestampCellFormatter_0);
  $setAttribute_8(changeSetTimeField, 'showHover', TRUE);
  $setHoverCustomizer_0(changeSetTimeField, ($clinit_TimestampCellFormatter() , new TimestampCellFormatter$1_0('changesetTime')));
  $setAttribute_8(changeSetTimeField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, changeSetTimeField);
  enabledField = new ListGridField_3('isEnabledIcon', 'Enabled?');
  $setAttribute_13(enabledField, 'type', IMAGE_0.value_0);
  $setAttribute_13(enabledField, 'align', CENTER_0.value_0);
  setCheck(fields.array, fields.size_0++, enabledField);
  inComplianceField = new ListGridField_3('complianceIcon', 'In Compliance?');
  $setAttribute_13(inComplianceField, 'type', IMAGE_0.value_0);
  $setAttribute_13(inComplianceField, 'align', CENTER_0.value_0);
  $setAttribute_8(inComplianceField, 'showHover', TRUE);
  $setHoverCustomizer_0(inComplianceField, new DriftDefinitionDataSource$3_0);
  setCheck(fields.array, fields.size_0++, inComplianceField);
  baseDirField = new ListGridField_3('baseDirString', 'Base Directory');
  $setAttribute_8(changeSetTimeField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, baseDirField);
  attachedField = new ListGridField_3('attached', 'Attached?');
  setCheck(fields.array, fields.size_0++, attachedField);
  templateField = new ListGridField_3('template', 'Template');
  $setCellFormatter_0(templateField, new DriftDefinitionDataSource$4_0(this$static));
  $setAttribute_8(templateField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, templateField);
  editField = new ListGridField_3('edit', hasWriteAccess?'Edit?':'View Mode');
  $setAttribute_13(editField, 'type', IMAGE_0.value_0);
  $setAttribute_13(editField, 'align', CENTER_0.value_0);
  $setAttribute_8(editField, 'showHover', TRUE);
  $setAttribute_8(editField, 'canSort', FALSE);
  $addRecordClickHandler_0(editField, new DriftDefinitionDataSource$5_0(this$static));
  $setHoverCustomizer_0(editField, new DriftDefinitionDataSource$6_0);
  setCheck(fields.array, fields.size_0++, editField);
  if (this$static.entityContext.type_0 != ($clinit_EntityContext$Type() , Resource)) {
    resourceNameField = new ListGridField_3('resourceName', 'Resource');
    $setCellFormatter_0(resourceNameField, new DriftDefinitionDataSource$7_0);
    $setAttribute_8(resourceNameField, 'showHover', TRUE);
    $setHoverCustomizer_0(resourceNameField, new DriftDefinitionDataSource$8_0);
    setCheck(fields.array, fields.size_0++, resourceNameField);
    ancestryField = setupAncestryListGridField();
    setCheck(fields.array, fields.size_0++, ancestryField);
    nameField.jsObj['width'] = '20%';
    enabledField.jsObj['width'] = 60;
    inComplianceField.jsObj['width'] = 100;
    baseDirField.jsObj['width'] = '*';
    attachedField.jsObj['width'] = 70;
    templateField.jsObj['width'] = '25%';
    pinnedField.jsObj['width'] = 70;
    changeSetField.jsObj['width'] = 70;
    changeSetTimeField.jsObj['width'] = 100;
    editField.jsObj['width'] = 70;
    resourceNameField.jsObj['width'] = '20%';
    ancestryField.jsObj['width'] = '40%';
  }
   else {
    nameField.jsObj['width'] = '20%';
    changeSetField.jsObj['width'] = 70;
    changeSetTimeField.jsObj['width'] = 100;
    enabledField.jsObj['width'] = 60;
    inComplianceField.jsObj['width'] = 100;
    baseDirField.jsObj['width'] = '*';
    attachedField.jsObj['width'] = 70;
    templateField.jsObj['width'] = '25%';
    pinnedField.jsObj['width'] = 70;
    editField.jsObj['width'] = 70;
  }
  return fields;
}

function DriftDefinitionDataSource_0(context){
  $clinit_DriftDefinitionDataSource();
  RPCDataSource_0.call(this);
  this.driftService = dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync);
  this.entityContext = context;
  new ArrayList_0;
}

function getBaseDirString(basedir){
  return basedir.context + ':' + basedir.name_0;
}

function getDriftHandlingModeDisplayName(driftHandlingMode){
  $clinit_DriftDefinitionDataSource();
  switch (driftHandlingMode.ordinal) {
    case 1:
      return DRIFT_HANDLING_MODE_PLANNED;
    default:return DRIFT_HANDLING_MODE_NORMAL;
  }
}

defineSeed(2673, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), DriftDefinitionDataSource_0);
_.copyValues = function copyValues_64(from){
  return null;
}
;
_.copyValues_0 = function copyValues_65(from){
  return $convert(this, dynamicCast(from, Q$DriftDefinitionComposite));
}
;
_.executeFetch = function executeFetch_38(request, response, criteria){
  $executeFetch_24(this, request, response, dynamicCast(criteria, Q$DriftDefinitionCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_49(request){
  var criteria, pageControl;
  return criteria = new DriftDefinitionCriteria_0 , this.entityContext.type_0.ordinal == 0 && $addFilterResourceIds_1(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(this.entityContext.resourceId)])) , $fetchConfiguration(criteria, ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $fetchTemplate(criteria, TRUE) , pageControl = $getPageControl(this, request) , $removeOrderingField(pageControl, 'baseDirString') , $removeOrderingField(pageControl, 'changesetTime') , $removeOrderingField(pageControl, 'changesetVersion') , $removeOrderingField(pageControl, 'template') , criteria.pageControlOverrides = pageControl , criteria;
}
;
_.entityContext = null;
_.globalPermissions = null;
_.hasWriteAccess = false;
var DRIFT_HANDLING_MODE_NORMAL, DRIFT_HANDLING_MODE_PLANNED;
function DriftDefinitionDataSource$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2674, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), DriftDefinitionDataSource$1_0);
_.onRecordClick = function onRecordClick_6(event_0){
  switch (this.this$0.entityContext.type_0.ordinal) {
    case 0:
      $clinit_CoreGUI();
      goToView('#Resource/' + this.this$0.entityContext.resourceId + '/Drift/Definitions/' + $getAttributeAsInt($getRecord_0(event_0), 'id').value_0 + '/' + ($clinit_DriftDefinitionsView$DetailView() , InitialSnapshot).name_0, null, false);
      break;
    default:throw new IllegalArgumentException_1('Entity Type not supported');
  }
}
;
_.this$0 = null;
function DriftDefinitionDataSource$2_0(){
}

defineSeed(2675, 1, {}, DriftDefinitionDataSource$2_0);
_.hoverHTML_0 = function hoverHTML_13(value, record, rowNum, colNum){
  return $equals_6('subsystems/drift/Pinned_active.png', getAttribute(record.jsObj, 'isPinned'))?($clinit_RPCDataSource() , 'The drift definition is pinned to its initial snapshot.  Click to view the initial snapshot.'):($clinit_RPCDataSource() , 'The drift definition is not pinned  Click to view the initial snapshot.');
}
;
function DriftDefinitionDataSource$3_0(){
}

defineSeed(2676, 1, {}, DriftDefinitionDataSource$3_0);
_.hoverHTML_0 = function hoverHTML_14(o, record, row, column){
  var complianceCode, complianceStatus;
  complianceCode = getAttributeAsInt(record.jsObj, 'compliance').value_0;
  complianceStatus = fromCode(complianceCode);
  switch (complianceStatus.ordinal) {
    case 1:
      return $clinit_RPCDataSource() , 'The base directory does not exist';
    case 2:
      return $clinit_RPCDataSource() , 'There is drift';
    default:return '';
  }
}
;
function DriftDefinitionDataSource$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2677, 1, {}, DriftDefinitionDataSource$4_0);
_.format_1 = function format_40(o, listGridRecord, i, i1){
  var def, link, templateId, typeId, result;
  def = dynamicCast(getAttributeAsObject(listGridRecord.jsObj, 'object'), Q$DriftDefinition);
  if (!def.template) {
    return $clinit_RPCDataSource() , 'None';
  }
  if (!!this.this$0.globalPermissions && this.this$0.globalPermissions.contains_0(($clinit_Permission() , MANAGE_SETTINGS))) {
    typeId = def.resource.resourceType.id;
    templateId = def.template.id;
    link = (result = '#Administration/Configuration/' + ($clinit_DriftDefinitionTemplateTypeView() , VIEW_ID_7).name_0 + '/' + typeId , result + '/' + templateId);
    return getHref(link, toString__devirtual$(o));
  }
   else {
    return toString__devirtual$(o);
  }
}
;
_.this$0 = null;
function DriftDefinitionDataSource$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2678, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), DriftDefinitionDataSource$5_0);
_.onRecordClick = function onRecordClick_7(event_0){
  switch (this.this$0.entityContext.type_0.ordinal) {
    case 0:
      $clinit_CoreGUI();
      goToView('#Resource/' + this.this$0.entityContext.resourceId + '/Drift/Definitions/' + $getAttributeAsInt($getRecord_0(event_0), 'id').value_0 + '/' + ($clinit_DriftDefinitionsView$DetailView() , Edit).name_0, null, false);
      break;
    default:throw new IllegalArgumentException_1('Entity Type not supported');
  }
}
;
_.this$0 = null;
function DriftDefinitionDataSource$6_0(){
}

defineSeed(2679, 1, {}, DriftDefinitionDataSource$6_0);
_.hoverHTML_0 = function hoverHTML_15(value, record, rowNum, colNum){
  return $clinit_RPCDataSource() , 'Click to view or edit the drift definition or template properties.';
}
;
function DriftDefinitionDataSource$7_0(){
}

defineSeed(2680, 1, {}, DriftDefinitionDataSource$7_0);
_.format_1 = function format_41(o, listGridRecord, i, i1){
  var resourceId, url;
  resourceId = getAttributeAsInt(listGridRecord.jsObj, 'resourceId');
  url = '#Resource/' + resourceId.value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function DriftDefinitionDataSource$8_0(){
}

defineSeed(2681, 1, {}, DriftDefinitionDataSource$8_0);
_.hoverHTML_0 = function hoverHTML_16(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function $onFailure_26(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to fetch drift instances'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_219(this$static, result){
  !this$static.this$0.globalPermissions?$loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new DriftDefinitionDataSource$9$1_0(this$static, result, this$static.val$response, this$static.val$request))):$dataRetrieved_2(this$static.this$0, result, this$static.val$response, this$static.val$request);
}

function DriftDefinitionDataSource$9_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2682, 1, {}, DriftDefinitionDataSource$9_0);
_.onFailure = function onFailure_230(caught){
  $onFailure_26(this, caught);
}
;
_.onSuccess_0 = function onSuccess_230(result){
  $onSuccess_219(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function DriftDefinitionDataSource$9$1_0(this$1, val$result, val$response, val$request){
  this.this$1 = this$1;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2683, 1, {}, DriftDefinitionDataSource$9$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_9(permissions){
  this.this$1.this$0.globalPermissions = permissions?permissions:new HashSet_0;
  $dataRetrieved_2(this.this$1.this$0, this.val$result, this.val$response, this.val$request);
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $refresh_15(this$static){
  if (this$static.refreshing) {
    return;
  }
  this$static.refreshing = true;
  $setAttribute_24(this$static.buttonbar, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  if (this$static.editor) {
    $destroy_1(this$static.editor);
    $removeMember(this$static, this$static.editor);
  }
  $getDriftDefinition(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this$static.driftDefId, new DriftDefinitionEditView$2_0(this$static));
}

function $save_4(this$static){
  var updatedConfiguration;
  updatedConfiguration = this$static.editor.configuration;
  $updateDriftDefinition(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this$static.context, new DriftDefinition_1(updatedConfiguration), new DriftDefinitionEditView$3_0(this$static));
}

function DriftDefinitionEditView_0(context, driftDefId, hasWriteAccess){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.context = context;
  this.driftDefId = driftDefId;
  this.hasWriteAccess = hasWriteAccess;
}

defineSeed(2684, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$PropertyValueChangeListener, Q$Enhanced]), DriftDefinitionEditView_0);
_.onDraw_0 = function onDraw_33(){
  var message;
  this.buttonbar = new ToolStrip_0;
  $setAttribute_24(this.buttonbar, 'width', '100%', true);
  $setExtraSpace(this.buttonbar, 10);
  $setMembersMargin(this.buttonbar, 5);
  $setLayoutMargin(this.buttonbar, valueOf_44(5));
  this.saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
  $addClickHandler(this.saveButton, new DriftDefinitionEditView$1_0(this));
  $addMember(this.buttonbar, this.saveButton);
  $setAttribute_24(this.buttonbar, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  $addMember(this, this.buttonbar);
  $refresh_15(this);
  if (!this.hasWriteAccess) {
    message = new Message_8("You do not have permission to edit this Resource's configuration.", ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
}
;
_.propertyValueChanged = function propertyValueChanged_2(event_0){
  var invalidPropertyNames, message, messageCenter;
  messageCenter = ($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0);
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    if (invalidPropertyNames.size_1() == 0) {
      $enable(this.saveButton);
      message = new Message_8(($clinit_Enhanced() , 'All configuration properties have valid values, so the configuration can now be saved.'), ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
     else {
      $disable(this.saveButton);
      message = new Message_8('The following configuration properties have invalid values: ' + ($clinit_Enhanced() , $toString_3($values(invalidPropertyNames))) + '. The values must be corrected before the configuration can be saved.', ($clinit_Message$Severity() , Error_2), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
    $notify(messageCenter, message);
  }
   else {
    $enable(this.saveButton);
  }
}
;
_.refresh_0 = function refresh_28(){
  $refresh_15(this);
}
;
_.buttonbar = null;
_.context = null;
_.driftDefId = 0;
_.editor = null;
_.hasWriteAccess = false;
_.refreshing = false;
_.saveButton = null;
function DriftDefinitionEditView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2685, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), DriftDefinitionEditView$1_0);
_.onClick = function onClick_116(clickEvent){
  $save_4(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_220(this$static, result){
  var configDef;
  !!result.template && result.template.changeSetId != null?(configDef = ($clinit_DriftConfigurationDefinition() , $clinit_DriftConfigurationDefinition() , EXISTING_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE)):(configDef = ($clinit_DriftConfigurationDefinition() , $clinit_DriftConfigurationDefinition() , INSTANCE_FOR_EXISTING_CONFIGS));
  this$static.this$0.editor = new ConfigurationEditor_1(configDef, result.configuration);
  $setAttribute_24(this$static.this$0.editor, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $addPropertyValueChangeListener(this$static.this$0.editor, this$static.this$0);
  $setReadOnly_1(this$static.this$0.editor, !this$static.this$0.hasWriteAccess);
  $addMember(this$static.this$0, this$static.this$0.editor);
  $disable(this$static.this$0.saveButton);
  $setAttribute_24(this$static.this$0.buttonbar, 'visibility', ($clinit_Visibility() , INHERIT).value_0, true);
  $markForRedraw(this$static.this$0);
  this$static.this$0.refreshing = false;
}

function DriftDefinitionEditView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2686, 1, {}, DriftDefinitionEditView$2_0);
_.onFailure = function onFailure_231(caught){
  this.this$0.refreshing = false;
  $handleError_0(($clinit_CoreGUI() , 'Failed to load definition.'), caught);
}
;
_.onSuccess_0 = function onSuccess_231(result){
  $onSuccess_220(this, dynamicCast(result, Q$DriftDefinition));
}
;
_.this$0 = null;
function $onSuccess_221(this$static){
  var driftHistoryUrl, message, resourceId;
  message = new Message_7(($clinit_Enhanced() , 'Drift detection definition updated and will affect the next detection run as applicable.'), ($clinit_Message$Severity() , Info));
  switch (this$static.this$0.context.type_0.ordinal) {
    case 0:
      resourceId = this$static.this$0.context.resourceId;
      driftHistoryUrl = '#Resource/' + resourceId + '/Drift/History';
      driftHistoryUrl = $substring(driftHistoryUrl, 1);
      $clinit_CoreGUI();
      goToView(driftHistoryUrl, message, false);
      break;
    default:throw new IllegalArgumentException_1('Entity Context Type not supported [' + this$static.this$0.context + ']');
  }
}

function DriftDefinitionEditView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2687, 1, {}, DriftDefinitionEditView$3_0);
_.onFailure = function onFailure_232(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update configuration.'), caught);
}
;
_.onSuccess_0 = function onSuccess_232(result){
  $onSuccess_221(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $clinit_DriftDefinitionTemplateDataSource(){
  $clinit_DriftDefinitionTemplateDataSource = nullMethod;
  $clinit_RPCDataSource();
  DRIFT_HANDLING_MODE_NORMAL_0 = 'normal';
  DRIFT_HANDLING_MODE_PLANNED_0 = 'planned changes';
}

function $dataRetrieved_3(this$static, result, response, request){
  $setAttribute_17(response, 'data', $buildRecords(this$static, result, true));
  $setTotalRows(response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
}

function $executeFetch_25(this$static, request, response, criteria){
  $findDriftDefinitionTemplatesByCriteria(this$static.driftService, criteria, new DriftDefinitionTemplateDataSource$5_0(this$static, response, request));
}

function $getListGridFields_10(this$static){
  var baseDirField, definedByField, driftHandlingModeField, editField, enabledField, fields, intervalField, nameField, numDefinitionsField, pinnedField;
  fields = new ArrayList_1(6);
  nameField = new ListGridField_3('name', ($clinit_RPCDataSource() , 'Name'));
  setCheck(fields.array, fields.size_0++, nameField);
  definedByField = new ListGridField_3('definedBy', 'Defined By');
  $setAttribute_8(definedByField, 'canSortClientOnly', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  setCheck(fields.array, fields.size_0++, definedByField);
  numDefinitionsField = new ListGridField_3('numDefinitions', 'Definitions');
  $setAttribute_8(numDefinitionsField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, numDefinitionsField);
  pinnedField = new ListGridField_3('pinned', 'Pinned?');
  $setAttribute_13(pinnedField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(pinnedField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_8(pinnedField, 'canSortClientOnly', TRUE);
  $addRecordClickHandler_0(pinnedField, new DriftDefinitionTemplateDataSource$1_0(this$static));
  $setAttribute_8(pinnedField, 'showHover', TRUE);
  $setHoverCustomizer_0(pinnedField, new DriftDefinitionTemplateDataSource$2_0);
  setCheck(fields.array, fields.size_0++, pinnedField);
  enabledField = new ListGridField_3('isEnabled', 'Enabled?');
  $setAttribute_13(enabledField, 'type', IMAGE_0.value_0);
  $setAttribute_13(enabledField, 'align', CENTER_0.value_0);
  $setAttribute_8(definedByField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, enabledField);
  driftHandlingModeField = new ListGridField_3('driftHandlingMode', 'Drift Handling');
  $setAttribute_8(driftHandlingModeField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, driftHandlingModeField);
  intervalField = new ListGridField_3('interval', 'Interval');
  $setAttribute_8(intervalField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, intervalField);
  baseDirField = new ListGridField_3('baseDirString', 'Base Directory');
  $setAttribute_8(baseDirField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, baseDirField);
  editField = new ListGridField_3('edit', 'Edit?');
  $setAttribute_13(editField, 'type', IMAGE_0.value_0);
  $setAttribute_13(editField, 'align', CENTER_0.value_0);
  $setAttribute_8(editField, 'canSort', FALSE);
  $addRecordClickHandler_0(editField, new DriftDefinitionTemplateDataSource$3_0(this$static));
  $setAttribute_8(editField, 'showHover', TRUE);
  $setHoverCustomizer_0(editField, new DriftDefinitionTemplateDataSource$4_0);
  setCheck(fields.array, fields.size_0++, editField);
  nameField.jsObj['width'] = '20%';
  definedByField.jsObj['width'] = '10%';
  numDefinitionsField.jsObj['width'] = 70;
  pinnedField.jsObj['width'] = 70;
  enabledField.jsObj['width'] = 60;
  driftHandlingModeField.jsObj['width'] = '10%';
  intervalField.jsObj['width'] = 70;
  baseDirField.jsObj['width'] = '*';
  editField.jsObj['width'] = 70;
  return fields;
}

function DriftDefinitionTemplateDataSource_0(resourceTypeId){
  $clinit_DriftDefinitionTemplateDataSource();
  RPCDataSource_0.call(this);
  this.driftService = dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync);
  this.resourceTypeId = resourceTypeId;
  new ArrayList_0;
}

function convert_1(from){
  var record, templateDef;
  record = new ListGridRecord_0;
  templateDef = new DriftDefinition_1(from.configuration);
  $setAttribute_13(record, 'name', from.name_0);
  $setAttribute_13(record, 'definedBy', from.isUserDefined?($clinit_RPCDataSource() , 'User'):($clinit_RPCDataSource() , 'Plugin'));
  $setAttribute_13(record, 'numDefinitions', '' + from.driftDefinitions.size_1());
  $setAttribute_13(record, 'pinned', from.changeSetId != null?'subsystems/drift/Pinned_active.png':'[SKIN]/headerIcons/pin_left.png');
  $setAttribute_13(record, 'isEnabled', getAvailabilityIcon(($clinit_Boolean() , templateDef.isEnabled?TRUE:FALSE)));
  $setAttribute_13(record, 'driftHandlingMode', getDriftHandlingModeDisplayName_0(templateDef.driftHandlingMode));
  $setAttribute_13(record, 'interval', '' + toString_8(templateDef.interval));
  $setAttribute_13(record, 'baseDirString', getBaseDirString_0($getBasedir(templateDef)));
  record.jsObj['edit'] = '[SKIN]/actions/edit.png';
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_16(record, 'isPinned', from.changeSetId != null);
  $setAttribute_16(record, 'isUserDefined', from.isUserDefined);
  return record;
}

function getBaseDirString_0(basedir){
  return basedir.context + ':' + basedir.name_0;
}

function getDriftHandlingModeDisplayName_0(driftHandlingMode){
  switch (driftHandlingMode.ordinal) {
    case 1:
      return DRIFT_HANDLING_MODE_PLANNED_0;
    default:return DRIFT_HANDLING_MODE_NORMAL_0;
  }
}

defineSeed(2688, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), DriftDefinitionTemplateDataSource_0);
_.copyValues = function copyValues_66(from){
  return null;
}
;
_.copyValues_0 = function copyValues_67(from){
  return convert_1(dynamicCast(from, Q$DriftDefinitionTemplate));
}
;
_.executeFetch = function executeFetch_39(request, response, criteria){
  $executeFetch_25(this, request, response, dynamicCast(criteria, Q$DriftDefinitionTemplateCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_50(request){
  var criteria, pageControl;
  return criteria = new DriftDefinitionTemplateCriteria_0 , $addFilterResourceTypeId(criteria, valueOf_44(this.resourceTypeId)) , criteria.fetchDriftDefinitions = true , pageControl = $getPageControl(this, request) , $removeOrderingField(pageControl, 'definedBy') , $removeOrderingField(pageControl, 'pinned') , $removeOrderingField(pageControl, 'numDefinitions') , $removeOrderingField(pageControl, 'isEnabled') , $removeOrderingField(pageControl, 'driftHandlingMode') , $removeOrderingField(pageControl, 'interval') , $removeOrderingField(pageControl, 'baseDirString') , criteria.pageControlOverrides = pageControl , criteria;
}
;
_.resourceTypeId = 0;
var DRIFT_HANDLING_MODE_NORMAL_0, DRIFT_HANDLING_MODE_PLANNED_0;
function DriftDefinitionTemplateDataSource$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2689, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), DriftDefinitionTemplateDataSource$1_0);
_.onRecordClick = function onRecordClick_8(event_0){
  $getAttributeAsBoolean_0($getRecord_0(event_0), 'isPinned').value_0 && ($clinit_CoreGUI() , goToView('#Administration/Configuration/' + ($clinit_DriftDefinitionTemplateTypeView() , VIEW_ID_7).name_0 + '/' + this.this$0.resourceTypeId + '/' + $getAttribute($getRecord_0(event_0), 'id') + '/Snapshot', null, false));
}
;
_.this$0 = null;
function DriftDefinitionTemplateDataSource$2_0(){
}

defineSeed(2690, 1, {}, DriftDefinitionTemplateDataSource$2_0);
_.hoverHTML_0 = function hoverHTML_17(value, record, rowNum, colNum){
  return ($clinit_Boolean() , getAttributeAsBoolean(record.jsObj, 'isPinned')?TRUE:FALSE).value_0?($clinit_RPCDataSource() , 'The drift template is pinned to a snapshot.  Click to view the pinned snapshot.'):($clinit_RPCDataSource() , 'The drift template is not pinned to a snapshot.');
}
;
function DriftDefinitionTemplateDataSource$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2691, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), DriftDefinitionTemplateDataSource$3_0);
_.onRecordClick = function onRecordClick_9(event_0){
  $clinit_CoreGUI();
  goToView('#Administration/Configuration/' + ($clinit_DriftDefinitionTemplateTypeView() , VIEW_ID_7).name_0 + '/' + this.this$0.resourceTypeId + '/' + $getAttribute($getRecord_0(event_0), 'id') + '/Edit', null, false);
}
;
_.this$0 = null;
function DriftDefinitionTemplateDataSource$4_0(){
}

defineSeed(2692, 1, {}, DriftDefinitionTemplateDataSource$4_0);
_.hoverHTML_0 = function hoverHTML_18(value, record, rowNum, colNum){
  return $clinit_RPCDataSource() , 'Click to view or edit the drift definition or template properties.';
}
;
function $onSuccess_222(this$static, result){
  $dataRetrieved_3(this$static.this$0, result, this$static.val$response, this$static.val$request);
}

function DriftDefinitionTemplateDataSource$5_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2693, 1, {}, DriftDefinitionTemplateDataSource$5_0);
_.onFailure = function onFailure_233(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to fetch drift instances'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_233(result){
  $onSuccess_222(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $refresh_16(this$static){
  var criteria;
  if (this$static.refreshing) {
    return;
  }
  this$static.refreshing = true;
  $setAttribute_24(this$static.buttonbar, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  if (this$static.editor) {
    $destroy_1(this$static.editor);
    $removeMember(this$static, this$static.editor);
  }
  criteria = new DriftDefinitionTemplateCriteria_0;
  $addFilterId(criteria, valueOf_44(this$static.driftTemplateId));
  $findDriftDefinitionTemplatesByCriteria(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), criteria, new DriftDefinitionTemplateEditView$2_0(this$static));
}

function $save_5(this$static){
  var updatedConfiguration, updatedDefinition;
  updatedConfiguration = this$static.editor.configuration;
  updatedDefinition = new DriftDefinition_1(updatedConfiguration);
  $setTemplateDefinition(this$static.driftTemplate, updatedDefinition);
  $updateTemplate(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this$static.driftTemplate, new DriftDefinitionTemplateEditView$3_0);
}

function DriftDefinitionTemplateEditView_0(driftTemplateId, hasWriteAccess){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.driftTemplateId = driftTemplateId;
  this.hasWriteAccess = hasWriteAccess;
}

defineSeed(2694, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$PropertyValueChangeListener, Q$Enhanced]), DriftDefinitionTemplateEditView_0);
_.onDraw_0 = function onDraw_34(){
  var message;
  this.buttonbar = new ToolStrip_0;
  $setAttribute_24(this.buttonbar, 'width', '100%', true);
  $setExtraSpace(this.buttonbar, 10);
  $setMembersMargin(this.buttonbar, 5);
  $setLayoutMargin(this.buttonbar, valueOf_44(5));
  this.saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
  $addClickHandler(this.saveButton, new DriftDefinitionTemplateEditView$1_0(this));
  $addMember(this.buttonbar, this.saveButton);
  $setAttribute_24(this.buttonbar, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  $addMember(this, this.buttonbar);
  $refresh_16(this);
  if (!this.hasWriteAccess) {
    message = new Message_8("You do not have permission to edit this Resource's configuration.", ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
}
;
_.propertyValueChanged = function propertyValueChanged_3(event_0){
  var invalidPropertyNames, message, messageCenter;
  messageCenter = ($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0);
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    if (invalidPropertyNames.size_1() == 0) {
      $enable(this.saveButton);
      message = new Message_8(($clinit_Enhanced() , 'All configuration properties have valid values, so the configuration can now be saved.'), ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
     else {
      $disable(this.saveButton);
      message = new Message_8('The following configuration properties have invalid values: ' + ($clinit_Enhanced() , $toString_3($values(invalidPropertyNames))) + '. The values must be corrected before the configuration can be saved.', ($clinit_Message$Severity() , Error_2), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
    $notify(messageCenter, message);
  }
   else {
    $enable(this.saveButton);
  }
}
;
_.refresh_0 = function refresh_29(){
  $refresh_16(this);
}
;
_.buttonbar = null;
_.driftTemplate = null;
_.driftTemplateId = 0;
_.editor = null;
_.hasWriteAccess = false;
_.refreshing = false;
_.saveButton = null;
function DriftDefinitionTemplateEditView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2695, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), DriftDefinitionTemplateEditView$1_0);
_.onClick = function onClick_117(clickEvent){
  $save_5(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_223(this$static, result){
  this$static.this$0.driftTemplate = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$DriftDefinitionTemplate);
  this$static.this$0.editor = new ConfigurationEditor_1(($clinit_DriftConfigurationDefinition() , $clinit_DriftConfigurationDefinition() , EXISTING_TEMPLATE_INSTANCE), this$static.this$0.driftTemplate.configuration);
  $setAttribute_24(this$static.this$0.editor, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $addPropertyValueChangeListener(this$static.this$0.editor, this$static.this$0);
  $setReadOnly_1(this$static.this$0.editor, !this$static.this$0.hasWriteAccess || !this$static.this$0.driftTemplate.isUserDefined);
  $addMember(this$static.this$0, this$static.this$0.editor);
  $disable(this$static.this$0.saveButton);
  $setAttribute_24(this$static.this$0.buttonbar, 'visibility', ($clinit_Visibility() , INHERIT).value_0, true);
  $markForRedraw(this$static.this$0);
  this$static.this$0.refreshing = false;
}

function DriftDefinitionTemplateEditView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2696, 1, {}, DriftDefinitionTemplateEditView$2_0);
_.onFailure = function onFailure_234(caught){
  this.this$0.refreshing = false;
  $handleError_0(($clinit_CoreGUI() , 'Failed to load definition.'), caught);
}
;
_.onSuccess_0 = function onSuccess_234(result){
  $onSuccess_223(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $onSuccess_224(){
  var message;
  message = new Message_7(($clinit_Enhanced() , 'Drift template updated and changes pushed to attached definitions.'), ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
}

function DriftDefinitionTemplateEditView$3_0(){
}

defineSeed(2697, 1, {}, DriftDefinitionTemplateEditView$3_0);
_.onFailure = function onFailure_235(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update configuration.'), caught);
}
;
_.onSuccess_0 = function onSuccess_235(result){
  $onSuccess_224(throwClassCastExceptionUnlessNull(result));
}
;
function $clinit_DriftSnapshotView(){
  $clinit_DriftSnapshotView = nullMethod;
  $clinit_BaseWidget();
  DEFAULT_TITLE_1 = ($clinit_Enhanced() , 'Snapshot');
}

function $pinToDefinition(this$static){
  $pinSnapshot(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this$static.driftDefId.value_0, this$static.version_0.value_0, new DriftSnapshotView$5_0(this$static));
}

function $pinToTemplate(this$static){
  showWizard_1(this$static.driftDefId.value_0, this$static.version_0.value_0);
  $refreshTableInfo(this$static);
}

function DriftSnapshotView_0(resourceId, driftDefId, version, hasWriteAccess){
  $clinit_DriftSnapshotView();
  DriftSnapshotView_1.call(this, DEFAULT_TITLE_1, null, valueOf_44(resourceId), valueOf_44(driftDefId), valueOf_44(version), hasWriteAccess);
}

function DriftSnapshotView_1(tableTitle, templateId, resourceId, driftDefId, version, hasWriteAccess){
  Table_2.call(this, tableTitle);
  this.templateId = templateId;
  this.resourceId = resourceId;
  this.driftDefId = driftDefId;
  this.version_0 = valueOf_44(!version?0:version.value_0);
  this.hasWriteAccess = hasWriteAccess;
  $setDataSource(this, (!this.dataSource && (this.templateId?(this.dataSource = new DriftSnapshotDataSource_0(this.templateId.value_0)):(this.dataSource = new DriftSnapshotDataSource_1(this.driftDefId.value_0, this.version_0.value_0))) , this.dataSource));
}

function getFileName(path){
  $clinit_DriftSnapshotView();
  var i;
  if (null == path) {
    return null;
  }
  i = path.lastIndexOf('/');
  return i < 0?$trim(path):$trim($substring(path, ++i));
}

defineSeed(2699, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), DriftSnapshotView_0);
_.configureTable = function configureTable_33(){
  var dataSourceFields, grid;
  grid = this.listGrid;
  dataSourceFields = $getListGridFields_12(!this.dataSource && (this.templateId?(this.dataSource = new DriftSnapshotDataSource_0(this.templateId.value_0)):(this.dataSource = new DriftSnapshotDataSource_1(this.driftDefId.value_0, this.version_0.value_0))));
  $setFields_1(grid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
  this.setupTableInteractions(this.hasWriteAccess);
}
;
_.createListGrid = function createListGrid_2(){
  return new DriftSnapshotView$DriftSnapshotListGrid_0(this);
}
;
_.getDataSource_0 = function getDataSource_18(){
  return !this.dataSource && (this.templateId?(this.dataSource = new DriftSnapshotDataSource_0(this.templateId.value_0)):(this.dataSource = new DriftSnapshotDataSource_1(this.driftDefId.value_0, this.version_0.value_0))) , this.dataSource;
}
;
_.onDraw_0 = function onDraw_35(){
  var defCriteria, driftService, templateCriteria;
  if (this.driftDefId) {
    defCriteria = new DriftDefinitionCriteria_0;
    $addFilterId(defCriteria, this.driftDefId);
    $fetchConfiguration(defCriteria, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $fetchTemplate(defCriteria, TRUE);
    driftService = dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync);
    $findDriftDefinitionsByCriteria(driftService, defCriteria, new DriftSnapshotView$1_0(this));
  }
   else {
    templateCriteria = new DriftDefinitionTemplateCriteria_0;
    $addFilterId(templateCriteria, this.templateId);
    templateCriteria.fetchResourceType = true;
    driftService = dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync);
    $findDriftDefinitionTemplatesByCriteria(driftService, templateCriteria, new DriftSnapshotView$2_0(this));
  }
}
;
_.setupTableInteractions = function setupTableInteractions_1(hasWriteAccess){
  var pinEnablement;
  pinEnablement = hasWriteAccess?($clinit_TableActionEnablement() , ALWAYS):($clinit_TableActionEnablement() , NEVER_1);
  $addTableAction(this, ($clinit_Enhanced() , 'Pin to Definition'), 'Pinning will set this snapshot as snapshot 0 for the definition.  All other existing snapshots will be removed from the definition.  The definition will be be marked as pinned and subsequent drift will always be reported against the pinned snapshot.  Pin this snapshot to the definition?', null, new DriftSnapshotView$3_0(this, pinEnablement));
  $addTableAction(this, 'Pin to Template', "After pinning, this snapshot will be set to the initial snapshot for all definitions created using the template.  If pinned to an existing template then the template's existing definitions will be pinned to the new initial snapshot and their existing snapshots will be removed. Continue to template selection?", null, new DriftSnapshotView$4_0(this, pinEnablement));
}
;
_.dataSource = null;
_.driftDefId = null;
_.hasWriteAccess = false;
_.pinnedToTemplate = false;
_.resourceId = null;
_.templateChangeSetId = null;
_.templateId = null;
_.version_0 = null;
var DEFAULT_TITLE_1;
function DriftDefinitionTemplateSnapshotView_0(templateId){
  $clinit_DriftSnapshotView();
  DriftSnapshotView_1.call(this, DEFAULT_TITLE_1, valueOf_44(templateId), null, null, null, false);
}

defineSeed(2698, 2699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), DriftDefinitionTemplateSnapshotView_0);
_.setupTableInteractions = function setupTableInteractions_2(hasWriteAccess){
}
;
function $clinit_DriftDefinitionTemplatesView(){
  $clinit_DriftDefinitionTemplatesView = nullMethod;
  var c, c$index, c$max, categoryNames, categoryValues, i;
  $clinit_BaseWidget();
  DEFAULT_SORT_SPECIFIER_4 = new SortSpecifier_0('name', ($clinit_SortDirection() , ASCENDING));
  categoryValues = ($clinit_DriftCategory() , $clinit_DriftCategory() , $VALUES_80);
  categoryNames = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, categoryValues.length, 0);
  i = 0;
  for (c$index = 0 , c$max = categoryValues.length; c$index < c$max; ++c$index) {
    c = categoryValues[c$index];
    categoryNames[i++] = c.name_0;
  }
}

function $add_11(this$static){
  showWizard_0(new EntityContext_0(null, null, valueOf_44(this$static.type_0.id)), this$static);
  $refreshTableInfo(this$static);
}

function $delete_3(this$static, records){
  var i, templateIds;
  templateIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, records.length, 1);
  for (i = 0; i < records.length; ++i) {
    templateIds[i] = __parseAndValidateInt(getAttribute(records[i].jsObj, 'id'));
  }
  $deleteDriftDefinitionTemplates(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), templateIds, new DriftDefinitionTemplatesView$3_0(this$static, records));
}

function $renderView_7(this$static, viewPath){
  if (viewPath.viewPath.size_0 > viewPath.index_0) {
    this$static.useSnapshotDetailsView = viewPath.viewPath.size_0 > viewPath.index_0 + 1 && $equals_6('Snapshot', dynamicCast($get_0(viewPath.viewPath, viewPath.index_0 + 1), Q$ViewId).path);
    this$static.snapshotDriftDetailsId = null;
    viewPath.viewPath.size_0 - viewPath.index_0 - 1 > 1 && (this$static.snapshotDriftDetailsId = $substring($getViewForIndex(viewPath, viewPath.index_0 + 2).path, 4));
  }
  $renderView_0(this$static, viewPath);
}

function $setupTableInteractions_1(this$static, hasWriteAccess){
  var addEnablement, deleteEnablement;
  addEnablement = hasWriteAccess?($clinit_TableActionEnablement() , ALWAYS):($clinit_TableActionEnablement() , NEVER_1);
  deleteEnablement = hasWriteAccess?($clinit_TableActionEnablement() , ANY_1):($clinit_TableActionEnablement() , NEVER_1);
  $addTableAction(this$static, ($clinit_Enhanced() , 'New'), null, null, new DriftDefinitionTemplatesView$1_0(this$static, addEnablement));
  $addTableAction(this$static, 'Delete', 'Warning! Deleting this template will also cause all attached drift definitions to be deleted as well. Those attached definitions along with all of their snapshots will be permanently removed from the system. Detached definitions will not be removed. Are you sure you want to continue?', null, new DriftDefinitionTemplatesView$2_0(this$static, deleteEnablement));
}

function DriftDefinitionTemplatesView_0(tableTitle, type, hasWriteAccess){
  TableSection_2.call(this, tableTitle, null, initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [DEFAULT_SORT_SPECIFIER_4]));
  this.type_0 = type;
  this.hasWriteAccess = hasWriteAccess;
  $setDataSource(this, (!this.dataSource && (this.dataSource = new DriftDefinitionTemplateDataSource_0(this.type_0.id)) , this.dataSource));
}

function DriftDefinitionTemplatesView_1(type, hasWriteAccess){
  $clinit_DriftDefinitionTemplatesView();
  DriftDefinitionTemplatesView_0.call(this, ($clinit_DriftDefinitionTemplateTypeView() , VIEW_ID_7).title_0 + ' [' + type.name_0 + ']', type, hasWriteAccess);
}

defineSeed(2700, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), DriftDefinitionTemplatesView_1);
_.configureTable = function configureTable_34(){
  var dataSourceFields;
  dataSourceFields = $getListGridFields_10((!this.dataSource && (this.dataSource = new DriftDefinitionTemplateDataSource_0(this.type_0.id)) , this.dataSource));
  $setFields_1(this.listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
  $setupTableInteractions_1(this, this.hasWriteAccess);
  $configureTable(this);
}
;
_.configureTableFilters = function configureTableFilters_5(){
}
;
_.createListGrid = function createListGrid_3(){
  return new DriftDefinitionTemplatesView$DriftDefinitionTemplatesListGrid_0;
}
;
_.getDataSource_0 = function getDataSource_19(){
  return !this.dataSource && (this.dataSource = new DriftDefinitionTemplateDataSource_0(this.type_0.id)) , this.dataSource;
}
;
_.getDetailsView_0 = function getDetailsView_19(driftTemplateId){
  if (this.useSnapshotDetailsView) {
    if (null == this.snapshotDriftDetailsId) {
      return new DriftDefinitionTemplateSnapshotView_0(driftTemplateId.value_0);
    }
    return new DriftDetailsView_0(this.snapshotDriftDetailsId);
  }
  return new DriftDefinitionTemplateEditView_0(driftTemplateId.value_0, this.hasWriteAccess);
}
;
_.renderView = function renderView_18(viewPath){
  $renderView_7(this, viewPath);
}
;
_.dataSource = null;
_.hasWriteAccess = false;
_.snapshotDriftDetailsId = null;
_.type_0 = null;
_.useSnapshotDetailsView = false;
var DEFAULT_SORT_SPECIFIER_4;
function DriftDefinitionTemplatesView$1_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2701, 1608, {}, DriftDefinitionTemplatesView$1_0);
_.executeAction = function executeAction_36(selection, actionValue){
  $add_11(this.this$0);
}
;
_.this$0 = null;
function DriftDefinitionTemplatesView$2_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2702, 1608, {}, DriftDefinitionTemplatesView$2_0);
_.executeAction = function executeAction_37(selection, actionValue){
  $delete_3(this.this$0, selection);
}
;
_.isEnabled_0 = function isEnabled_16(selection){
  var record, record$index, record$max;
  if ($isEnabled(this, selection)) {
    for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
      record = selection[record$index];
      if (!($clinit_Boolean() , getAttributeAsBoolean(record.jsObj, 'isUserDefined')?TRUE:FALSE).value_0) {
        return false;
      }
    }
    this.result = true;
  }
  return this.result;
}
;
_.result = false;
_.this$0 = null;
function $onSuccess_225(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully deleted ' + ($clinit_Enhanced() , '' + this$static.val$records.length) + ' drift templates', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function DriftDefinitionTemplatesView$3_0(this$0, val$records){
  this.this$0 = this$0;
  this.val$records = val$records;
}

defineSeed(2703, 1, {}, DriftDefinitionTemplatesView$3_0);
_.onFailure = function onFailure_236(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete some or all of the drift templates'), caught);
  $refresh(this.this$0, false);
}
;
_.onSuccess_0 = function onSuccess_236(result){
  $onSuccess_225(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$records = null;
function DriftDefinitionTemplatesView$DriftDefinitionTemplatesListGrid_0(){
  $clinit_BaseWidget();
  ListGrid_0.call(this);
  $setCanExpandRecords(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setCanExpandMultipleRecords(this, TRUE);
  $setAttribute_24(this, 'expansionMode', ($clinit_ExpansionMode() , RELATED).value_0, true);
}

defineSeed(2704, 538, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers]), DriftDefinitionTemplatesView$DriftDefinitionTemplatesListGrid_0);
_.getExpansionComponent_0 = function getExpansionComponent_1(record){
  var templateId;
  templateId = getAttributeAsInt(record.jsObj, 'id').value_0;
  getAttribute(record.jsObj, 'name');
  return new DriftDefinitionTemplatesView$TemplateDefinitionsView_0(templateId);
}
;
function DriftDefinitionTemplatesView$TemplateDefinitionsView_0(templateId){
  Table_7.call(this, null, true);
  this.templateId = templateId;
  this.showFilterForm = false;
  this.showHeader = false;
  this.showFooter = false;
  $setDataSource(this, (!this.dataSource && (this.dataSource = new DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource_0(this)) , this.dataSource));
}

defineSeed(2705, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), DriftDefinitionTemplatesView$TemplateDefinitionsView_0);
_.configureListGrid = function configureListGrid_0(grid){
  $isCreated_1(grid)?$setProperty_0(grid, 'defaultHeight', 1):(grid.config_0['defaultHeight'] = 1 , undefined);
  $setAttribute_24(grid, 'autoFitData', ($clinit_Autofit() , VERTICAL).value_0, true);
}
;
_.configureTable = function configureTable_35(){
  var dataSourceFields;
  dataSourceFields = $getListGridFields_11(!this.dataSource && (this.dataSource = new DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource_0(this)));
  $setFields_1(this.listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
}
;
_.configureTableContents = function configureTableContents_0(contents){
  $setAttribute_24(contents, 'width', '100%', true);
  $setAttribute_24(contents, 'height', '100%', true);
  $setAttribute_24(contents, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
}
;
_.createListGrid = function createListGrid_4(){
  return new DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsListGrid_0;
}
;
_.getDataSource_0 = function getDataSource_20(){
  return !this.dataSource && (this.dataSource = new DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource_0(this)) , this.dataSource;
}
;
_.dataSource = null;
_.templateId = 0;
function $copyValues_38(from){
  var record, resource;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'name', from.name_0);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_13(record, 'isEnabled', '' + from.isEnabled);
  $setAttribute_13(record, 'isEnabledIcon', getAvailabilityIcon(($clinit_Boolean() , from.isEnabled?TRUE:FALSE)));
  $setAttribute_3(record, 'compliance', from.complianceStatus.ordinal);
  $setAttribute_13(record, 'complianceIcon', getAvailabilityIcon(from.complianceStatus == ($clinit_DriftComplianceStatus() , IN_COMPLIANCE)?TRUE:FALSE));
  $setAttribute_13(record, 'attached', from.attached?'Yes':'No');
  resource = from.resource;
  $setAttribute_3(record, 'resourceId', resource.id);
  $setAttribute_13(record, 'resourceName', resource.name_0);
  $setAttribute_13(record, 'resourceAncestry', resource.ancestry);
  $setAttribute_3(record, 'resourceTypeId', resource.resourceType.id);
  return record;
}

function $executeFetch_26(this$static, request, response, criteria){
  $findDriftDefinitionsByCriteria(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), criteria, new DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$5_0(this$static, response, request));
}

function $getListGridFields_11(){
  var ancestryField, attachedField, descriptionField, enabledField, fields, inComplianceField, nameField, resourceNameField;
  fields = new ArrayList_1(6);
  nameField = new ListGridField_3('name', 'Name');
  $setCellFormatter_0(nameField, new DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$1_0);
  setCheck(fields.array, fields.size_0++, nameField);
  descriptionField = new ListGridField_3('description', 'Description');
  setCheck(fields.array, fields.size_0++, descriptionField);
  attachedField = new ListGridField_3('attached', 'Attached?');
  setCheck(fields.array, fields.size_0++, attachedField);
  enabledField = new ListGridField_3('isEnabledIcon', 'Enabled?');
  $setAttribute_13(enabledField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(enabledField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  setCheck(fields.array, fields.size_0++, enabledField);
  inComplianceField = new ListGridField_3('complianceIcon', 'In Compliance?');
  $setAttribute_13(inComplianceField, 'type', IMAGE_0.value_0);
  $setAttribute_13(inComplianceField, 'align', CENTER_0.value_0);
  $setAttribute_8(inComplianceField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(inComplianceField, new DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$2_0);
  setCheck(fields.array, fields.size_0++, inComplianceField);
  resourceNameField = new ListGridField_3('resourceName', 'Resource');
  $setCellFormatter_0(resourceNameField, new DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$3_0);
  $setAttribute_8(resourceNameField, 'showHover', TRUE);
  $setHoverCustomizer_0(resourceNameField, new DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$4_0);
  setCheck(fields.array, fields.size_0++, resourceNameField);
  ancestryField = setupAncestryListGridField();
  setCheck(fields.array, fields.size_0++, ancestryField);
  nameField.jsObj['width'] = '15%';
  descriptionField.jsObj['width'] = '25%';
  attachedField.jsObj['width'] = 70;
  enabledField.jsObj['width'] = 60;
  inComplianceField.jsObj['width'] = 100;
  resourceNameField.jsObj['width'] = '20%';
  ancestryField.jsObj['width'] = '*';
  return fields;
}

function DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource_0(this$1){
  $clinit_RPCDataSource();
  this.this$1 = this$1;
  RPCDataSource_0.call(this);
  new ArrayList_0;
}

defineSeed(2706, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource_0);
_.copyValues = function copyValues_68(from){
  return null;
}
;
_.copyValues_0 = function copyValues_69(from){
  return $copyValues_38(dynamicCast(from, Q$DriftDefinition));
}
;
_.executeFetch = function executeFetch_40(request, response, criteria){
  $executeFetch_26(this, request, response, dynamicCast(criteria, Q$DriftDefinitionCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_51(request){
  var criteria;
  return criteria = new DriftDefinitionCriteria_0 , $addFilterTemplateId(criteria, valueOf_44(this.this$1.templateId)) , $fetchResource(criteria, ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , criteria;
}
;
_.this$1 = null;
function DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$1_0(){
}

defineSeed(2707, 1, {}, DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$1_0);
_.format_1 = function format_42(o, listGridRecord, i, i1){
  var driftDefId, resourceId, url;
  resourceId = getAttributeAsInt(listGridRecord.jsObj, 'resourceId');
  driftDefId = getAttributeAsInt(listGridRecord.jsObj, 'id');
  url = '#Resource/' + resourceId.value_0 + '/Drift/Definitions/' + driftDefId.value_0 + '/' + ($clinit_DriftDefinitionsView$DetailView() , Carousel_0).name_0;
  return getHref(url, toString__devirtual$(o));
}
;
function DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$2_0(){
}

defineSeed(2708, 1, {}, DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$2_0);
_.hoverHTML_0 = function hoverHTML_19(o, record, row, column){
  var complianceCode, complianceStatus;
  complianceCode = getAttributeAsInt(record.jsObj, 'compliance').value_0;
  complianceStatus = fromCode(complianceCode);
  switch (complianceStatus.ordinal) {
    case 1:
      return $clinit_RPCDataSource() , 'The base directory does not exist';
    case 2:
      return $clinit_RPCDataSource() , 'There is drift';
    default:return '';
  }
}
;
function DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$3_0(){
}

defineSeed(2709, 1, {}, DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$3_0);
_.format_1 = function format_43(o, listGridRecord, i, i1){
  var resourceId, url;
  resourceId = getAttributeAsInt(listGridRecord.jsObj, 'resourceId');
  url = '#Resource/' + resourceId.value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$4_0(){
}

defineSeed(2710, 1, {}, DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$4_0);
_.hoverHTML_0 = function hoverHTML_20(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function $onSuccess_226(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$2, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static.this$2, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$5_0(this$2, val$response, val$request){
  this.this$2 = this$2;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2711, 1, {}, DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$5_0);
_.onFailure = function onFailure_237(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to fetch drift instances'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$2, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_237(result){
  $onSuccess_226(this, dynamicCast(result, Q$PageList));
}
;
_.this$2 = null;
_.val$request = null;
_.val$response = null;
function DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsListGrid_0(){
  ListGrid_0.call(this);
}

defineSeed(2712, 538, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers]), DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsListGrid_0);
function $clinit_DriftDefinitionsView(){
  $clinit_DriftDefinitionsView = nullMethod;
  var c, c$index, c$max, categoryNames, categoryValues, i;
  $clinit_BaseWidget();
  new ViewName_1('DriftDefs', ($clinit_Enhanced() , 'Definitions'));
  DEFAULT_SORT_SPECIFIER_5 = new SortSpecifier_0('name', ($clinit_SortDirection() , ASCENDING));
  INITIAL_CRITERIA_3 = new Criteria_0;
  categoryValues = ($clinit_DriftCategory() , $clinit_DriftCategory() , $VALUES_80);
  categoryNames = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, categoryValues.length, 0);
  i = 0;
  for (c$index = 0 , c$max = categoryValues.length; c$index < c$max; ++c$index) {
    c = categoryValues[c$index];
    categoryNames[i++] = c.name_0;
  }
}

function $add_12(this$static){
  showWizard_0(this$static.context, this$static);
  $refreshTableInfo(this$static);
}

function $delete_4(this$static, records){
  var driftDefName, driftDefNames, i, record, selectionLength;
  driftDefNames = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, records.length, 0);
  for (i = 0 , selectionLength = records.length; i < selectionLength; ++i) {
    record = records[i];
    driftDefName = getAttribute(record.jsObj, 'name');
    driftDefNames[i] = driftDefName;
  }
  $deleteDriftDefinitionsByContext(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this$static.context, driftDefNames, new DriftDefinitionsView$5_0(this$static));
}

function $deleteAll_0(this$static){
  var driftDefName, driftDefNames, i, numRecords, record, records;
  records = $getRecordList(this$static.listGrid);
  numRecords = records.getLength_0();
  driftDefNames = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, numRecords, 0);
  for (i = 0; i < numRecords; ++i) {
    record = records.get_1(i);
    driftDefName = getAttribute(record.jsObj, 'name');
    driftDefNames[i] = driftDefName;
  }
  $deleteDriftDefinitionsByContext(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this$static.context, driftDefNames, new DriftDefinitionsView$5_0(this$static));
}

function $detectDrift(this$static, records){
  var driftDef;
  driftDef = dynamicCast(getAttributeAsObject(records[0].jsObj, 'object'), Q$DriftDefinition);
  $detectDrift_0(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this$static.context, driftDef, new DriftDefinitionsView$6_0(this$static));
}

function $setupTableInteractions_2(this$static, hasWriteAccess){
  var deleteEnablement, detectNowEnablement;
  deleteEnablement = hasWriteAccess?($clinit_TableActionEnablement() , ANY_1):($clinit_TableActionEnablement() , NEVER_1);
  detectNowEnablement = hasWriteAccess?($clinit_TableActionEnablement() , SINGLE_0):($clinit_TableActionEnablement() , NEVER_1);
  $addTableAction(this$static, 'New', ($clinit_Enhanced() , 'New'), null, new DriftDefinitionsView$1_0(this$static, hasWriteAccess));
  $addTableAction(this$static, 'Delete', 'Delete the selected drift detection definition(s)?', null, new DriftDefinitionsView$2_0(this$static, deleteEnablement));
  $addTableAction(this$static, 'Delete All', 'Delete all drift detection definitions?', null, new DriftDefinitionsView$3_0(this$static, hasWriteAccess));
  $addTableAction(this$static, 'DetectNow', 'Detect Now', null, new DriftDefinitionsView$4_0(this$static, detectNowEnablement, hasWriteAccess));
}

defineSeed(2713, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_36(){
  var dataSourceFields;
  dataSourceFields = $getListGridFields_9((!this.dataSource && (this.dataSource = new DriftDefinitionDataSource_0(this.context)) , this.dataSource), this.hasWriteAccess);
  $setFields_1(this.listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
  $setupTableInteractions_2(this, this.hasWriteAccess);
  $configureTable(this);
}
;
_.configureTableFilters = function configureTableFilters_6(){
}
;
_.getDataSource_0 = function getDataSource_21(){
  return !this.dataSource && (this.dataSource = new DriftDefinitionDataSource_0(this.context)) , this.dataSource;
}
;
_.getDetailsView_0 = function getDetailsView_20(driftDefId){
  switch (this.detailsView.ordinal) {
    case 1:
      return new DriftDefinitionEditView_0(this.context, driftDefId.value_0, this.hasWriteAccess);
    case 2:
      return new DriftSnapshotView_0(this.context.resourceId, driftDefId.value_0, 0, this.hasWriteAccess);
    default:return new DriftCarouselView_0(this.context, driftDefId.value_0, this.hasWriteAccess);
  }
}
;
_.renderView = function renderView_19(viewPath){
  this.detailsView = ($clinit_DriftDefinitionsView$DetailView() , Carousel_0);
  viewPath.viewPath.size_0 > viewPath.index_0 && viewPath.viewPath.size_0 > viewPath.index_0 + 1 && ($equals_6(Edit.name_0, dynamicCast($get_0(viewPath.viewPath, viewPath.index_0 + 1), Q$ViewId).path)?(this.detailsView = Edit):$equals_6(InitialSnapshot.name_0, dynamicCast($get_0(viewPath.viewPath, viewPath.index_0 + 1), Q$ViewId).path) && (this.detailsView = InitialSnapshot));
  $renderView_0(this, viewPath);
}
;
_.context = null;
_.dataSource = null;
_.hasWriteAccess = false;
var DEFAULT_SORT_SPECIFIER_5, INITIAL_CRITERIA_3;
function DriftDefinitionsView$1_0(this$0, val$hasWriteAccess){
  this.this$0 = this$0;
  this.val$hasWriteAccess = val$hasWriteAccess;
}

defineSeed(2714, 1, {}, DriftDefinitionsView$1_0);
_.executeAction = function executeAction_38(selection, actionValue){
  $add_12(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_17(selection){
  return this.val$hasWriteAccess;
}
;
_.this$0 = null;
_.val$hasWriteAccess = false;
function DriftDefinitionsView$2_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2715, 1608, {}, DriftDefinitionsView$2_0);
_.executeAction = function executeAction_39(selection, actionValue){
  $delete_4(this.this$0, selection);
}
;
_.this$0 = null;
function DriftDefinitionsView$3_0(this$0, val$hasWriteAccess){
  this.this$0 = this$0;
  this.val$hasWriteAccess = val$hasWriteAccess;
}

defineSeed(2716, 1, {}, DriftDefinitionsView$3_0);
_.executeAction = function executeAction_40(selection, actionValue){
  $deleteAll_0(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_18(selection){
  var grid, resultSet;
  grid = this.this$0.listGrid;
  resultSet = grid?$getResultSet(grid):null;
  return this.val$hasWriteAccess && !!grid && !!resultSet && !$isEmpty_0(resultSet).value_0;
}
;
_.this$0 = null;
_.val$hasWriteAccess = false;
function DriftDefinitionsView$4_0(this$0, $anonymous0, val$hasWriteAccess){
  this.this$0 = this$0;
  this.val$hasWriteAccess = val$hasWriteAccess;
  this.enablement = $anonymous0;
}

defineSeed(2717, 1608, {}, DriftDefinitionsView$4_0);
_.executeAction = function executeAction_41(selection, actionValue){
  $detectDrift(this.this$0, selection);
}
;
_.isEnabled_0 = function isEnabled_19(selection){
  if (selection.length == 0 || !this.val$hasWriteAccess) {
    return false;
  }
  return ($clinit_Boolean() , $equalsIgnoreCase('true', getAttribute(selection[0].jsObj, 'isEnabled'))?TRUE:FALSE).value_0;
}
;
_.this$0 = null;
_.val$hasWriteAccess = false;
function $onSuccess_227(this$static, resultCount){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully deleted ' + ($clinit_Enhanced() , '' + resultCount) + ' drift detection definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function DriftDefinitionsView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2718, 1, {}, DriftDefinitionsView$5_0);
_.onFailure = function onFailure_238(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete some or all drift detection definitions.'), caught);
}
;
_.onSuccess_0 = function onSuccess_238(resultCount){
  $onSuccess_227(this, dynamicCast(resultCount, Q$Integer));
}
;
_.this$0 = null;
function $onSuccess_228(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Successfully submitted drift detection run request'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function DriftDefinitionsView$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2719, 1, {}, DriftDefinitionsView$6_0);
_.onFailure = function onFailure_239(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to submit drift detection run request'), caught);
}
;
_.onSuccess_0 = function onSuccess_239(result){
  $onSuccess_228(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $clinit_DriftDefinitionsView$DetailView(){
  $clinit_DriftDefinitionsView$DetailView = nullMethod;
  Carousel_0 = new DriftDefinitionsView$DetailView_0('Carousel', 0);
  Edit = new DriftDefinitionsView$DetailView_0('Edit', 1);
  InitialSnapshot = new DriftDefinitionsView$DetailView_0('InitialSnapshot', 2);
  $VALUES_129 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView$DetailView_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$DriftDefinitionsView$DetailView, [Carousel_0, Edit, InitialSnapshot]);
}

function DriftDefinitionsView$DetailView_0(enum$name, enum$ordinal){
  Enum_0.call(this, enum$name, enum$ordinal);
}

function valueOf_138(name_0){
  $clinit_DriftDefinitionsView$DetailView();
  return valueOf(($clinit_DriftDefinitionsView$DetailView$Map() , $MAP_129), name_0);
}

function values_132(){
  $clinit_DriftDefinitionsView$DetailView();
  return $VALUES_129;
}

defineSeed(2720, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$DriftDefinitionsView$DetailView]), DriftDefinitionsView$DetailView_0);
var $VALUES_129, Carousel_0, Edit, InitialSnapshot;
function $clinit_DriftDefinitionsView$DetailView$Map(){
  $clinit_DriftDefinitionsView$DetailView$Map = nullMethod;
  $MAP_129 = createValueOfMap(($clinit_DriftDefinitionsView$DetailView() , $VALUES_129));
}

var $MAP_129;
function $createChangeSetForm(drift){
  var changeSet, changeSetCategory, changeSetDriftHandling, changeSetForm, changeSetId, changeSetVersion;
  changeSetForm = new DynamicForm_0;
  $setIsGroup(changeSetForm, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setGroupTitle(changeSetForm, ($clinit_Enhanced() , 'Snapshot'));
  $setWrapItemTitles(changeSetForm, FALSE);
  changeSet = drift.getChangeSet();
  changeSetId = new StaticTextItem_2('changeSetId', 'ID');
  $setValue_7(changeSetId, changeSet.getId());
  changeSetCategory = new StaticTextItem_2('changeSetCategory', 'Category');
  $setValue_7(changeSetCategory, changeSet.getCategory_0().name_0);
  changeSetVersion = new StaticTextItem_2('changeSetVersion', 'Version');
  $setValue_5(changeSetVersion, changeSet.getVersion());
  changeSetDriftHandling = new StaticTextItem_2('changeSetDriftHandling', 'Drift Handling');
  $setValue_7(changeSetDriftHandling, getDriftHandlingModeDisplayName(changeSet.getDriftHandlingMode()));
  changeSetForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [changeSetId, changeSetCategory, changeSetVersion, changeSetDriftHandling]));
  return changeSetForm;
}

function $createFileViewer(contents, path, version){
  var form, layout, textArea, window_0;
  layout = new VLayout_0;
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $isCreated_1(form)?$setProperty_3(form, 'height', '100%'):(form.config_0['height'] = '100%' , undefined);
  textArea = new TextAreaItem_0;
  $setShowTitle_0(textArea, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_2(textArea)?$setProperty_6(textArea, 'colSpan', 2):(textArea.jsObj['colSpan'] = 2 , undefined);
  $setValue_7(textArea, contents);
  $setWidth_2(textArea, '*');
  $setHeight_1(textArea, '*');
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [textArea]));
  layout.addMember_0(form);
  window_0 = new PopupWindow_0(layout);
  $setIsModal(window_0, FALSE);
  $isCreated_1(window_0)?$setProperty_3(window_0, 'title', path + ':' + version):(window_0.config_0['title'] = path + ':' + version , undefined);
  return window_0;
}

function $createViewDiffLink(drift, oldVersion){
  var viewDiffLink;
  viewDiffLink = new LinkItem_1('viewDiff');
  $isCreated_2(viewDiffLink)?$setProperty_8(viewDiffLink, 'linkTitle', '(view diff)'):(viewDiffLink.jsObj['linkTitle'] = '(view diff)' , undefined);
  $setShowTitle_0(viewDiffLink, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $addClickHandler_2(viewDiffLink, new DriftDetailsView$3_0(drift, oldVersion));
  return viewDiffLink;
}

function $createViewFileLink(hash, path, version, status_0){
  var item, link;
  if (status_0 == ($clinit_DriftFileStatus() , LOADED)) {
    return link = new LinkItem_1(hash + '_fileLink') , $setShowTitle_0(link, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , $isCreated_2(link)?$setProperty_8(link, 'linkTitle', '(view)'):(link.jsObj['linkTitle'] = '(view)' , undefined) , $addClickHandler_2(link, new DriftDetailsView$2_0(hash, path, version)) , link;
  }
  item = new StaticTextItem_1(hash + '_fileLink');
  $setShowTitle_0(item, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setValue_7(item, '(file not ready for viewing)');
  return item;
}

function $show_4(this$static, driftId){
  var driftService;
  driftService = dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync);
  $getDriftDetails(driftService, driftId, new DriftDetailsView$1_0(this$static, driftId));
}

function DriftDetailsView_0(driftId){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.driftId = driftId;
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 10):(this.config_0['membersMargin'] = 10 , undefined);
}

defineSeed(2722, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), DriftDetailsView_0);
_.onDraw_0 = function onDraw_36(){
  $show_4(this, this.driftId);
}
;
_.show_1 = function show_3(driftDetails){
  var catIconsMap, catValueMap, category, child, child$array, child$index, child$max, driftForm, id, newFile, newFileLink, oldFile, oldFileLink, path, spacer, timestamp, viewDiffLink;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    $removeMember(this, child);
    child.destroy_0();
  }
  $addMember(this, $createChangeSetForm(driftDetails.drift));
  driftForm = new DynamicForm_0;
  $setIsGroup(driftForm, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setGroupTitle(driftForm, ($clinit_Enhanced() , 'Drift'));
  $setWrapItemTitles(driftForm, FALSE);
  $isCreated_1(driftForm)?$setProperty_0(driftForm, 'numCols', 4):(driftForm.config_0['numCols'] = 4 , undefined);
  spacer = new SpacerItem_0;
  id = new StaticTextItem_2('id', 'ID');
  $setValue_7(id, driftDetails.drift.getId());
  path = new StaticTextItem_2('path', 'Path');
  $setValue_7(path, driftDetails.drift.getPath());
  timestamp = new StaticTextItem_2('timestamp', 'Date/Time');
  $setValue_7(timestamp, format_30(driftDetails.drift.getCtime(), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_FULL)));
  category = new StaticTextItem_2('category', 'Category');
  catIconsMap = new LinkedHashMap_1(3);
  $put_1(catIconsMap, ($clinit_DriftDataSource() , CATEGORY_ICON_ADD), CATEGORY_ICON_ADD);
  $put_1(catIconsMap, CATEGORY_ICON_CHANGE, CATEGORY_ICON_CHANGE);
  $put_1(catIconsMap, CATEGORY_ICON_REMOVE, CATEGORY_ICON_REMOVE);
  catValueMap = new LinkedHashMap_1(3);
  $put_1(catValueMap, CATEGORY_ICON_ADD, 'File Added');
  $put_1(catValueMap, CATEGORY_ICON_CHANGE, 'File Changed');
  $put_1(catValueMap, CATEGORY_ICON_REMOVE, 'File Removed');
  $isCreated_2(category)?$setValueMapMethod(category, convertMapToJavascriptObject(catValueMap)):$isCreated_2(category)?$setProperty_7(category, 'valueMap', convertMapToJavascriptObject(catValueMap)):(category.jsObj['valueMap'] = convertMapToJavascriptObject(catValueMap) , undefined);
  $isCreated_2(category)?$setProperty_7(category, 'valueIcons', convertMapToJavascriptObject(catIconsMap)):(category.jsObj['valueIcons'] = convertMapToJavascriptObject(catIconsMap) , undefined);
  $setShowIcons(category, TRUE);
  oldFile = new StaticTextItem_2('oldFile', 'Old File');
  oldFileLink = null;
  newFile = new StaticTextItem_2('newFile', 'New File');
  newFileLink = null;
  if (driftDetails.isBinary) {
    switch (driftDetails.drift.getCategory().ordinal) {
      case 0:
        $setValue_7(category, CATEGORY_ICON_ADD);
        $setValue_7(oldFile, 'none');
        oldFileLink = spacer;
        $setValue_7(newFile, driftDetails.drift.getNewDriftFile().getHashId());
        newFileLink = spacer;
        break;
      case 1:
        $setValue_7(category, CATEGORY_ICON_CHANGE);
        $setValue_7(oldFile, driftDetails.drift.getOldDriftFile().getHashId());
        oldFileLink = spacer;
        $setValue_7(newFile, driftDetails.drift.getNewDriftFile().getHashId());
        newFileLink = spacer;
        break;
      case 2:
        $setValue_7(category, CATEGORY_ICON_REMOVE);
        $setValue_7(oldFile, driftDetails.drift.getOldDriftFile().getHashId());
        oldFileLink = spacer;
        $setValue_7(newFile, 'none');
        newFileLink = spacer;
    }
    driftForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [id, spacer, path, spacer, category, spacer, timestamp, spacer, oldFile, oldFileLink, newFile, newFileLink]));
  }
   else {
    viewDiffLink = spacer;
    switch (driftDetails.drift.getCategory().ordinal) {
      case 0:
        $setValue_7(category, CATEGORY_ICON_ADD);
        $setValue_7(oldFile, 'none');
        oldFileLink = spacer;
        $setValue_7(newFile, driftDetails.drift.getNewDriftFile().getHashId());
        newFileLink = $createViewFileLink(driftDetails.drift.getNewDriftFile().getHashId(), driftDetails.drift.getPath(), driftDetails.drift.getChangeSet().getVersion(), driftDetails.newFileStatus);
        break;
      case 1:
        $setValue_7(category, CATEGORY_ICON_CHANGE);
        $setValue_7(oldFile, driftDetails.drift.getOldDriftFile().getHashId());
        oldFileLink = $createViewFileLink(driftDetails.drift.getOldDriftFile().getHashId(), driftDetails.drift.getPath(), driftDetails.previousChangeSet.getVersion(), driftDetails.oldFileStatus);
        $setValue_7(newFile, driftDetails.drift.getNewDriftFile().getHashId());
        newFileLink = $createViewFileLink(driftDetails.drift.getNewDriftFile().getHashId(), driftDetails.drift.getPath(), driftDetails.drift.getChangeSet().getVersion(), driftDetails.newFileStatus);
        driftDetails.newFileStatus == ($clinit_DriftFileStatus() , LOADED) && driftDetails.oldFileStatus == LOADED && (viewDiffLink = $createViewDiffLink(driftDetails.drift, driftDetails.previousChangeSet.getVersion()));
        break;
      case 2:
        $setValue_7(category, CATEGORY_ICON_REMOVE);
        $setValue_7(oldFile, driftDetails.drift.getOldDriftFile().getHashId());
        oldFileLink = $createViewFileLink(driftDetails.drift.getOldDriftFile().getHashId(), driftDetails.drift.getPath(), driftDetails.drift.getChangeSet().getVersion(), driftDetails.oldFileStatus);
        $setValue_7(newFile, 'none');
        newFileLink = spacer;
    }
    driftForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [id, spacer, path, spacer, category, spacer, timestamp, spacer, oldFile, oldFileLink, newFile, newFileLink, spacer, spacer, spacer, viewDiffLink]));
  }
  $addMember(this, driftForm);
}
;
_.driftId = null;
function $onSuccess_229(this$static, details){
  this$static.this$0.show_1(details);
}

function DriftDetailsView$1_0(this$0, val$driftId){
  this.this$0 = this$0;
  this.val$driftId = val$driftId;
}

defineSeed(2723, 1, {}, DriftDetailsView$1_0);
_.onFailure = function onFailure_240(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load drift details for drift id: ' + this.val$driftId), caught);
}
;
_.onSuccess_0 = function onSuccess_240(details){
  $onSuccess_229(this, dynamicCast(details, Q$DriftDetails));
}
;
_.this$0 = null;
_.val$driftId = null;
function DriftDetailsView$2_0(val$hash, val$path, val$version){
  this.val$hash = val$hash;
  this.val$path = val$path;
  this.val$version = val$version;
}

defineSeed(2724, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), DriftDetailsView$2_0);
_.onClick_0 = function onClick_118(clickEvent){
  $getDriftFileBits(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this.val$hash, new DriftDetailsView$2$1_0(this.val$path, this.val$version));
}
;
_.val$hash = null;
_.val$path = null;
_.val$version = 0;
function $onFailure_27(caught){
  var $e0, r;
  try {
    throw caught;
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Throwable)) {
      r = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to load file'), r);
    }
     else 
      throw $e0;
  }
}

function $onSuccess_230(this$static, contents){
  var fileViewer;
  fileViewer = $createFileViewer(contents, this$static.val$path, this$static.val$version);
  $show(fileViewer);
}

function DriftDetailsView$2$1_0(val$path, val$version){
  this.val$path = val$path;
  this.val$version = val$version;
}

defineSeed(2725, 1, {}, DriftDetailsView$2$1_0);
_.onFailure = function onFailure_241(caught){
  $onFailure_27(caught);
}
;
_.onSuccess_0 = function onSuccess_241(contents){
  $onSuccess_230(this, dynamicCast(contents, Q$String));
}
;
_.val$path = null;
_.val$version = 0;
function DriftDetailsView$3_0(val$drift, val$oldVersion){
  this.val$drift = val$drift;
  this.val$oldVersion = val$oldVersion;
}

defineSeed(2726, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), DriftDetailsView$3_0);
_.onClick_0 = function onClick_119(clickEvent){
  $generateUnifiedDiff(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this.val$drift, new DriftDetailsView$3$1_0(this.val$drift, this.val$oldVersion));
}
;
_.val$drift = null;
_.val$oldVersion = 0;
function $onSuccess_231(this$static, diffReport){
  var diffContents, newVersion, window_0;
  newVersion = this$static.val$drift.getChangeSet().getVersion();
  diffContents = formatAsHtml(diffReport.diff, this$static.val$oldVersion, newVersion);
  window_0 = createDiffViewerWindow(diffContents, this$static.val$drift.getPath(), this$static.val$oldVersion, newVersion);
  $show(window_0);
}

function DriftDetailsView$3$1_0(val$drift, val$oldVersion){
  this.val$drift = val$drift;
  this.val$oldVersion = val$oldVersion;
}

defineSeed(2727, 1, {}, DriftDetailsView$3$1_0);
_.onFailure = function onFailure_242(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to generate diff.'), caught);
}
;
_.onSuccess_0 = function onSuccess_242(diffReport){
  $onSuccess_231(this, dynamicCast(diffReport, Q$FileDiffReport));
}
;
_.val$drift = null;
_.val$oldVersion = 0;
function DriftHistoryView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2728, 1, {}, DriftHistoryView$1_0);
_.format_1 = function format_44(value, record, i, i1){
  var driftDefId, driftId, formattedValue, resourceId, url;
  resourceId = getAttributeAsInt(record.jsObj, 'resourceId');
  driftDefId = getAttributeAsInt(record.jsObj, 'changSetDefId');
  driftId = $getId_0(this.this$0, record);
  url = getDriftCarouselDriftLink(resourceId.value_0, driftDefId.value_0, driftId);
  formattedValue = ($clinit_TimestampCellFormatter() , format_30(value, DATE_TIME_FORMAT_MEDIUM));
  return getHref(url, formattedValue);
}
;
_.this$0 = null;
function $copyValues_39(from){
  var dirPath, record;
  record = new ListGridRecord_0;
  dirPath = from.directoryPath;
  $setAttribute_13(record, 'dirPath', null == dirPath || $equals_6('', $trim(dirPath))?'./':dirPath);
  $setAttribute_3(record, 'files', from.files);
  $setAttribute_3(record, 'added', from.added);
  $setAttribute_3(record, 'changed', from.changed_0);
  $setAttribute_3(record, 'removed', from.removed);
  return record;
}

function $executeFetch_27(this$static, request, response){
  var snapshotRequest, templateCriteria;
  if (!this$static.templateId) {
    snapshotRequest = new DriftSnapshotRequest_1(this$static.driftDefId.value_0, this$static.version_0, null, true, false);
    $executeGetSnapshot(this$static, request, response, snapshotRequest);
  }
   else {
    if (null == this$static.templateChangeSetId) {
      templateCriteria = new DriftDefinitionTemplateCriteria_0;
      $addFilterId(templateCriteria, this$static.templateId);
      $findDriftDefinitionTemplatesByCriteria(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), templateCriteria, new DriftSnapshotDataSource$1_0(this$static, request, response));
    }
     else {
      snapshotRequest = new DriftSnapshotRequest_2(this$static.templateChangeSetId, null, true, false);
      $executeGetSnapshot(this$static, request, response, snapshotRequest);
    }
  }
}

function $executeGetSnapshot(this$static, request, response, snapshotRequest){
  var driftService;
  driftService = dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync);
  $getSnapshot(driftService, snapshotRequest, new DriftSnapshotDataSource$2_0(this$static, response, request));
}

function $getListGridFields_12(){
  var addedField, changedField, dirPathField, fields, filesField, removedField;
  fields = new ArrayList_1(7);
  dirPathField = new ListGridField_3('dirPath', 'Directory');
  setCheck(fields.array, fields.size_0++, dirPathField);
  filesField = new ListGridField_3('files', 'Files');
  setCheck(fields.array, fields.size_0++, filesField);
  addedField = new ListGridField_3('added', 'Added');
  setCheck(fields.array, fields.size_0++, addedField);
  changedField = new ListGridField_3('changed', 'Changed');
  setCheck(fields.array, fields.size_0++, changedField);
  removedField = new ListGridField_3('removed', 'Removed');
  setCheck(fields.array, fields.size_0++, removedField);
  dirPathField.jsObj['width'] = '*';
  filesField.jsObj['width'] = '10%';
  addedField.jsObj['width'] = '10%';
  changedField.jsObj['width'] = '10%';
  removedField.jsObj['width'] = '10%';
  return fields;
}

function DriftSnapshotDataSource_0(templateId){
  $clinit_RPCDataSource();
  DriftSnapshotDataSource_2.call(this, valueOf_44(templateId), null, null);
}

function DriftSnapshotDataSource_1(driftDefId, version){
  $clinit_RPCDataSource();
  DriftSnapshotDataSource_2.call(this, null, valueOf_44(driftDefId), valueOf_44(version));
}

function DriftSnapshotDataSource_2(templateId, driftDefId, version){
  RPCDataSource_0.call(this);
  this.templateId = templateId;
  this.driftDefId = driftDefId;
  this.version_0 = version;
  $setCacheAllData(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
}

defineSeed(2729, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), DriftSnapshotDataSource_0, DriftSnapshotDataSource_1);
_.copyValues = function copyValues_70(from){
  return null;
}
;
_.copyValues_0 = function copyValues_71(from){
  return $copyValues_39(dynamicCast(from, Q$DriftSnapshot$DriftSnapshotDirectory));
}
;
_.executeFetch = function executeFetch_41(request, response, criteria){
  $executeFetch_27(this, request, response, dynamicCast(criteria, Q$GenericDriftChangeSetCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_52(request){
  return null;
}
;
_.driftDefId = null;
_.templateChangeSetId = null;
_.templateId = null;
_.version_0 = null;
function $onSuccess_232(this$static, result){
  var snapshotRequest;
  this$static.this$0.templateChangeSetId = '' + dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$DriftDefinitionTemplate).changeSetId;
  snapshotRequest = new DriftSnapshotRequest_2(this$static.this$0.templateChangeSetId, null, true, false);
  $executeGetSnapshot(this$static.this$0, this$static.val$request, this$static.val$response, snapshotRequest);
}

function DriftSnapshotDataSource$1_0(this$0, val$request, val$response){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(2730, 1, {}, DriftSnapshotDataSource$1_0);
_.onFailure = function onFailure_243(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load definition.'), caught);
}
;
_.onSuccess_0 = function onSuccess_243(result){
  $onSuccess_232(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_233(this$static, result){
  var dirs, record, record$index, record$max, records;
  dirs = $getDriftDirectories(result);
  records = $buildRecords(this$static.this$0, dirs, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $setAttribute_11(record, 'defId', result.request.driftDefinitionId);
  }
  $setAttribute_17(this$static.val$response, 'data', records);
  $setTotalRows(this$static.val$response, valueOf_44(dirs.size_1()));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function DriftSnapshotDataSource$2_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2731, 1, {}, DriftSnapshotDataSource$2_0);
_.onFailure = function onFailure_244(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to fetch drift instances'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_244(result){
  $onSuccess_233(this, dynamicCast(result, Q$DriftSnapshot));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function DriftSnapshotDriftDetailsView_0(driftId){
  DriftDetailsView_0.call(this, driftId);
}

defineSeed(2732, 2722, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), DriftSnapshotDriftDetailsView_0);
_.show_1 = function show_4(driftDetails){
  var child, child$array, child$index, child$max, driftForm, file, fileLink, path, spacer;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    $removeMember(this, child);
    child.destroy_0();
  }
  driftForm = new DynamicForm_0;
  $setWrapItemTitles(driftForm, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_1(driftForm)?$setProperty_0(driftForm, 'numCols', 4):(driftForm.config_0['numCols'] = 4 , undefined);
  spacer = new SpacerItem_0;
  path = new StaticTextItem_2('path', ($clinit_Enhanced() , 'Path'));
  $setValue_7(path, driftDetails.drift.getPath());
  file = new StaticTextItem_2('File', 'Content');
  if (driftDetails.isBinary) {
    $setValue_7(file, driftDetails.drift.getNewDriftFile().getHashId());
    fileLink = spacer;
    driftForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [path, spacer, file, fileLink]));
  }
   else {
    $setValue_7(file, driftDetails.drift.getNewDriftFile().getHashId());
    fileLink = $createViewFileLink(driftDetails.drift.getNewDriftFile().getHashId(), driftDetails.drift.getPath(), driftDetails.drift.getChangeSet().getVersion(), driftDetails.newFileStatus);
    driftForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [path, spacer, file, fileLink]));
  }
  $addMember(this, driftForm);
}
;
function $onSuccess_234(this$static, result){
  var defName, driftDef, isPinned, title;
  driftDef = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$DriftDefinition);
  defName = driftDef.name_0;
  if (0 == this$static.this$0.version_0.value_0) {
    isPinned = '' + driftDef.isPinned;
    title = 'Initial Snapshot for Definition [' + ($clinit_Enhanced() , defName) + '] : Pinned = [' + isPinned + ']';
  }
   else {
    title = 'Snapshot [' + ($clinit_Enhanced() , '' + this$static.this$0.version_0) + '] for Definition [' + defName + ']';
  }
  $setTitleString(this$static.this$0, title);
  this$static.this$0.pinnedToTemplate = !!driftDef.template && driftDef.template.changeSetId != null;
  $onDraw(this$static.this$0);
}

function DriftSnapshotView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2733, 1, {}, DriftSnapshotView$1_0);
_.onFailure = function onFailure_245(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to fetch drift instances'), caught);
}
;
_.onSuccess_0 = function onSuccess_245(result){
  $onSuccess_234(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $onSuccess_235(this$static, result){
  var template, templateName, title;
  template = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$DriftDefinitionTemplate);
  templateName = template.name_0;
  title = 'Pinned Snapshot for Template [' + ($clinit_Enhanced() , templateName) + ']';
  $setTitleString(this$static.this$0, title);
  $onDraw(this$static.this$0);
}

function DriftSnapshotView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2734, 1, {}, DriftSnapshotView$2_0);
_.onFailure = function onFailure_246(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to fetch drift instances'), caught);
}
;
_.onSuccess_0 = function onSuccess_246(result){
  $onSuccess_235(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function DriftSnapshotView$3_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2735, 1608, {}, DriftSnapshotView$3_0);
_.executeAction = function executeAction_42(selection, actionValue){
  $pinToDefinition(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_20(selection){
  return !this.this$0.pinnedToTemplate && $isEnabled(this, selection);
}
;
_.this$0 = null;
function DriftSnapshotView$4_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2736, 1608, {}, DriftSnapshotView$4_0);
_.executeAction = function executeAction_43(selection, actionValue){
  $pinToTemplate(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_236(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully pinned snapshot ' + ($clinit_Enhanced() , '' + this$static.this$0.version_0) + ' to drift definition.', ($clinit_Message$Severity() , Info)));
  goToView('#Resource/' + this$static.this$0.resourceId.value_0 + '/Drift/Definitions', null, false);
}

function DriftSnapshotView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2737, 1, {}, DriftSnapshotView$5_0);
_.onFailure = function onFailure_247(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to pin snapshot to definition'), caught);
}
;
_.onSuccess_0 = function onSuccess_247(x){
  $onSuccess_236(this, throwClassCastExceptionUnlessNull(x));
}
;
_.this$0 = null;
function DriftSnapshotView$DirectoryView_0(this$0, directory){
  this.this$0 = this$0;
  Table_7.call(this, null, true);
  this.directory = directory;
  this.showFilterForm = false;
  this.showHeader = false;
  this.showFooter = false;
  $setDataSource(this, (!this.dataSource && (this.dataSource = new DriftSnapshotView$DirectoryView$DirectoryViewDataSource_0(this)) , this.dataSource));
}

defineSeed(2738, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), DriftSnapshotView$DirectoryView_0);
_.configureListGrid = function configureListGrid_1(grid){
  $isCreated_1(grid)?$setProperty_0(grid, 'defaultHeight', 1):(grid.config_0['defaultHeight'] = 1 , undefined);
  $setAttribute_24(grid, 'autoFitData', ($clinit_Autofit() , VERTICAL).value_0, true);
}
;
_.configureTable = function configureTable_37(){
  var dataSourceFields;
  dataSourceFields = $getListGridFields_13(!this.dataSource && (this.dataSource = new DriftSnapshotView$DirectoryView$DirectoryViewDataSource_0(this)));
  $setFields_1(this.listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
}
;
_.configureTableContents = function configureTableContents_1(contents){
  $setAttribute_24(contents, 'width', '100%', true);
  $setAttribute_24(contents, 'height', '100%', true);
  $setAttribute_24(contents, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
}
;
_.createListGrid = function createListGrid_5(){
  return new DriftSnapshotView$DirectoryView$DirectoryViewListGrid_0;
}
;
_.getDataSource_0 = function getDataSource_22(){
  return !this.dataSource && (this.dataSource = new DriftSnapshotView$DirectoryView$DirectoryViewDataSource_0(this)) , this.dataSource;
}
;
_.dataSource = null;
_.directory = null;
_.this$0 = null;
function $copyValues_40(this$static, from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_13(record, 'id', from.getId());
  $setAttribute_14(record, 'ctime', new Date_2(from.getCtime().value_0));
  $setAttribute_13(record, 'category', getDriftCategoryIcon(0 == this$static.this$1.this$0.version_0.value_0?null:from.getCategory()));
  $setAttribute_12(record, 'changeSetVersion', !from.getChangeSet()?'0':valueOf_44(from.getChangeSet().getVersion()));
  $setAttribute_13(record, 'path', getFileName(from.getPath()));
  return record;
}

function $executeFetch_28(this$static, request, response){
  var snapshotRequest, templateCriteria;
  if (!this$static.this$1.this$0.templateId) {
    snapshotRequest = new DriftSnapshotRequest_1(this$static.this$1.this$0.driftDefId.value_0, this$static.this$1.this$0.version_0, this$static.this$1.directory, false, true);
    $executeGetSnapshot_0(this$static, request, response, snapshotRequest);
  }
   else {
    if (null == this$static.this$1.this$0.templateChangeSetId) {
      templateCriteria = new DriftDefinitionTemplateCriteria_0;
      $addFilterId(templateCriteria, this$static.this$1.this$0.templateId);
      $findDriftDefinitionTemplatesByCriteria(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), templateCriteria, new DriftSnapshotView$DirectoryView$DirectoryViewDataSource$2_0(this$static, request, response));
    }
     else {
      snapshotRequest = new DriftSnapshotRequest_2(this$static.this$1.this$0.templateChangeSetId, this$static.this$1.directory, false, true);
      $executeGetSnapshot_0(this$static, request, response, snapshotRequest);
    }
  }
}

function $executeGetSnapshot_0(this$static, request, response, snapshotRequest){
  var driftService;
  driftService = dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync);
  $getSnapshot(driftService, snapshotRequest, new DriftSnapshotView$DirectoryView$DirectoryViewDataSource$3_0(this$static, response, request));
}

function $getListGridFields_13(){
  var categoryField, changeSetVersionField, ctimeField, fields, pathField;
  fields = new ArrayList_1(7);
  ctimeField = new ListGridField_3('ctime', 'Creation Time');
  $setCellFormatter_0(ctimeField, new TimestampCellFormatter_0);
  $setAttribute_8(ctimeField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(ctimeField, ($clinit_TimestampCellFormatter() , new TimestampCellFormatter$1_0('ctime')));
  setCheck(fields.array, fields.size_0++, ctimeField);
  categoryField = new ListGridField_3('category', 'Category');
  $setAttribute_13(categoryField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(categoryField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_8(categoryField, 'showHover', TRUE);
  $setHoverCustomizer_0(categoryField, new DriftSnapshotView$DirectoryView$DirectoryViewDataSource$1_0);
  setCheck(fields.array, fields.size_0++, categoryField);
  changeSetVersionField = new ListGridField_3('changeSetVersion', 'Snapshot');
  setCheck(fields.array, fields.size_0++, changeSetVersionField);
  pathField = new ListGridField_3('path', 'Name');
  setCheck(fields.array, fields.size_0++, pathField);
  ctimeField.jsObj['width'] = 200;
  categoryField.jsObj['width'] = 100;
  changeSetVersionField.jsObj['width'] = 100;
  pathField.jsObj['width'] = '*';
  return fields;
}

function DriftSnapshotView$DirectoryView$DirectoryViewDataSource_0(this$1){
  $clinit_RPCDataSource();
  this.this$1 = this$1;
  RPCDataSource_0.call(this);
  new ArrayList_0;
}

defineSeed(2739, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), DriftSnapshotView$DirectoryView$DirectoryViewDataSource_0);
_.copyValues = function copyValues_72(from){
  return null;
}
;
_.copyValues_0 = function copyValues_73(from){
  return $copyValues_40(this, dynamicCast(from, Q$Drift));
}
;
_.executeFetch = function executeFetch_42(request, response, criteria){
  $executeFetch_28(this, request, response, dynamicCast(criteria, Q$GenericDriftChangeSetCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_53(request){
  return null;
}
;
_.this$1 = null;
function DriftSnapshotView$DirectoryView$DirectoryViewDataSource$1_0(){
}

defineSeed(2740, 1, {}, DriftSnapshotView$DirectoryView$DirectoryViewDataSource$1_0);
_.hoverHTML_0 = function hoverHTML_21(value, record, rowNum, colNum){
  var cat;
  cat = getAttribute(record.jsObj, 'category');
  return $equals_6(($clinit_DriftDataSource() , CATEGORY_ICON_ADD), cat)?'File Added':$equals_6(CATEGORY_ICON_CHANGE, cat)?'File Changed':$equals_6(CATEGORY_ICON_REMOVE, cat)?'File Removed':$equals_6(CATEGORY_ICON_NEW, cat)?'Newly Detected':'';
}
;
function $onSuccess_237(this$static, result){
  var snapshotRequest;
  this$static.this$2.this$1.this$0.templateChangeSetId = '' + dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$DriftDefinitionTemplate).changeSetId;
  snapshotRequest = new DriftSnapshotRequest_2(this$static.this$2.this$1.this$0.templateChangeSetId, this$static.this$2.this$1.directory, false, true);
  $executeGetSnapshot_0(this$static.this$2, this$static.val$request, this$static.val$response, snapshotRequest);
}

function DriftSnapshotView$DirectoryView$DirectoryViewDataSource$2_0(this$2, val$request, val$response){
  this.this$2 = this$2;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(2741, 1, {}, DriftSnapshotView$DirectoryView$DirectoryViewDataSource$2_0);
_.onFailure = function onFailure_248(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load definition.'), caught);
}
;
_.onSuccess_0 = function onSuccess_248(result){
  $onSuccess_237(this, dynamicCast(result, Q$PageList));
}
;
_.this$2 = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_238(this$static, result){
  var drifts, records;
  drifts = $getDriftInstances(result);
  records = $buildRecords(this$static.this$2, drifts, true);
  $setAttribute_17(this$static.val$response, 'data', records);
  $setTotalRows(this$static.val$response, valueOf_44(drifts.size_1()));
  $processResponse_0(this$static.this$2, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function DriftSnapshotView$DirectoryView$DirectoryViewDataSource$3_0(this$2, val$response, val$request){
  this.this$2 = this$2;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2742, 1, {}, DriftSnapshotView$DirectoryView$DirectoryViewDataSource$3_0);
_.onFailure = function onFailure_249(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to fetch drift instances'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$2, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_249(result){
  $onSuccess_238(this, dynamicCast(result, Q$DriftSnapshot));
}
;
_.this$2 = null;
_.val$request = null;
_.val$response = null;
function DriftSnapshotView$DirectoryView$DirectoryViewListGrid_0(){
  ListGrid_0.call(this);
  $setCanExpandRecords(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setCanExpandMultipleRecords(this, TRUE);
  $setAttribute_24(this, 'expansionMode', ($clinit_ExpansionMode() , RELATED).value_0, true);
  $addRecordExpandHandler(this, new DriftSnapshotView$DirectoryView$DirectoryViewListGrid$1_0);
  $addRecordCollapseHandler(this, new DriftSnapshotView$DirectoryView$DirectoryViewListGrid$2_0);
}

defineSeed(2743, 538, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers]), DriftSnapshotView$DirectoryView$DirectoryViewListGrid_0);
_.getCellCSSText_0 = function getCellCSSText_0(record, rowNum, colNum){
  if ($equals_2(($clinit_Boolean() , TRUE), getAttributeAsBoolean(record.jsObj, 'Expanded')?TRUE:FALSE)) {
    return 'background-color:#ffffcc;';
  }
  return $getCellCSSText(this, record, rowNum, colNum);
}
;
_.getExpansionComponent_0 = function getExpansionComponent_2(record){
  var driftId;
  driftId = getAttribute(record.jsObj, 'id');
  return new DriftSnapshotDriftDetailsView_0(driftId);
}
;
function DriftSnapshotView$DirectoryView$DirectoryViewListGrid$1_0(){
}

defineSeed(2744, 1, makeCastMap([Q$EventHandler, Q$RecordExpandHandler]), DriftSnapshotView$DirectoryView$DirectoryViewListGrid$1_0);
function DriftSnapshotView$DirectoryView$DirectoryViewListGrid$2_0(){
}

defineSeed(2745, 1, makeCastMap([Q$EventHandler, Q$RecordCollapseHandler]), DriftSnapshotView$DirectoryView$DirectoryViewListGrid$2_0);
function DriftSnapshotView$DriftSnapshotListGrid_0(this$0){
  $clinit_BaseWidget();
  this.this$0 = this$0;
  ListGrid_0.call(this);
  $setCanExpandRecords(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setCanExpandMultipleRecords(this, TRUE);
  $setAttribute_24(this, 'expansionMode', ($clinit_ExpansionMode() , RELATED).value_0, true);
}

defineSeed(2746, 538, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers]), DriftSnapshotView$DriftSnapshotListGrid_0);
_.getExpansionComponent_0 = function getExpansionComponent_3(record){
  var dirPath;
  dirPath = getAttribute(record.jsObj, 'dirPath');
  return new DriftSnapshotView$DirectoryView_0(this.this$0, dirPath);
}
;
_.this$0 = null;
function ResourceDriftDefinitionsView_0(tableTitle, context, hasWriteAccess){
  TableSection_2.call(this, tableTitle, INITIAL_CRITERIA_3, initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [DEFAULT_SORT_SPECIFIER_5]));
  this.detailsView = ($clinit_DriftDefinitionsView$DetailView() , Carousel_0);
  this.context = context;
  this.hasWriteAccess = hasWriteAccess;
  this.initialCriteriaFixed = false;
  $setDataSource(this, (!this.dataSource && (this.dataSource = new DriftDefinitionDataSource_0(this.context)) , this.dataSource));
}

function get_21(composite){
  $clinit_DriftDefinitionsView();
  var context, hasWriteAccess;
  $clinit_Enhanced();
  context = new EntityContext_0(valueOf_44(composite.resource.id), null, null);
  hasWriteAccess = composite.resourcePermission.permissions.contains_0(($clinit_Permission() , MANAGE_DRIFT));
  return new ResourceDriftDefinitionsView_0('Resource Drift Detection Definition', context, hasWriteAccess);
}

defineSeed(2747, 2713, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ResourceDriftDefinitionsView_0);
function SubsystemResourceDriftView_0(){
  $clinit_DriftHistoryView();
  DriftHistoryView_0.call(this, ($clinit_Enhanced() , 'Recent Drift'), new EntityContext_0(null, null, null));
}

defineSeed(2748, 2656, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), SubsystemResourceDriftView_0);
_.configureTable = function configureTable_38(){
  $configureTable_6(this);
  $addTableAction(this, 'Export', ($clinit_Enhanced() , 'Export'), null, new SubsystemResourceDriftView$1_0(this));
}
;
function SubsystemResourceDriftView$1_0(this$0){
  this.this$0 = this$0;
  AbstractTableAction_0.call(this);
}

defineSeed(2749, 1608, {}, SubsystemResourceDriftView$1_0);
_.executeAction = function executeAction_44(selection, actionValue){
  var exporter;
  exporter = createExporterForRecentDrift(this.this$0.definitionFilter.getValueAsString(), this.this$0.changeSetFilter.getValueAsString(), $getValues(this.this$0.categoryFilter), this.this$0.pathFilter.getValueAsString(), $getValueAsDays(this.this$0.startDateFilter), $getValueAsDays(this.this$0.startDateFilter));
  $export(exporter);
  $refreshTableInfo(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_21(selection){
  return $enableIfRecordsExist(this.this$0.listGrid);
}
;
_.this$0 = null;
function createDiffViewerWindow(contents, path, oldVersion, newVersion){
  var canvas, canvasItem, form, layout, window_0, widget;
  layout = new VLayout_0;
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $isCreated_1(form)?$setProperty_3(form, 'height', '100%'):(form.config_0['height'] = '100%' , undefined);
  canvasItem = new CanvasItem_0;
  $isCreated_2(canvasItem)?$setProperty_6(canvasItem, 'colSpan', 2):(canvasItem.jsObj['colSpan'] = 2 , undefined);
  canvasItem.setShowTitle(($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setWidth_2(canvasItem, '*');
  $setHeight_1(canvasItem, '*');
  canvas = new Canvas_1;
  canvas.setContents(contents);
  $setAttribute_28(canvasItem, 'canvas', !canvas?null:$getOrCreateJsObj_0(canvas));
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [canvasItem]));
  layout.addMember_0(form);
  window_0 = new PopupWindow_0(layout);
  $isCreated_1(window_0)?(widget = window_0.getJsObj() , widget.setProperty('title', path + ':' + oldVersion + ':' + newVersion) , undefined):(window_0.config_0['title'] = path + ':' + oldVersion + ':' + newVersion , undefined);
  $setIsModal(window_0, FALSE);
  return window_0;
}

function formatAsHtml(deltas, oldVersion, newVersion){
  var escapedLine, html, line, line$iterator, lines, originalFilename, revisedFilename;
  html = new StringBuilder_0;
  originalFilename = dynamicCast(deltas.get_0(0), Q$String);
  $append_12($append_9($append_12($append_12(($append_1(html.data_0, '<b>') , html), escapeHtml(originalFilename)), ':'), oldVersion), '<\/b><br/>');
  revisedFilename = dynamicCast(deltas.get_0(1), Q$String);
  $append_12($append_9($append_12($append_12(($append_1(html.data_0, '<b>') , html), escapeHtml(revisedFilename)), ':'), newVersion), '<\/b><br/>');
  lines = deltas.subList(2, deltas.size_1());
  for (line$iterator = new AbstractList$IteratorImpl_0(lines); line$iterator.i < line$iterator.this$0_0.size_1();) {
    line = dynamicCast($next_0(line$iterator), Q$String);
    escapedLine = escapeHtml(line);
    line.indexOf('@@') == 0?$append_12($append_12(($append_1(html.data_0, '<font color="blue">') , html), escapedLine), '<\/font>'):line.indexOf('-') == 0?$append_12($append_12(($append_1(html.data_0, '<font color="red">') , html), escapedLine), '<\/font>'):line.indexOf('+') == 0?$append_12($append_12(($append_1(html.data_0, '<font color="green">') , html), escapedLine), '<\/font>'):($append_1(html.data_0, escapedLine) , html);
    $append_1(html.data_0, '<br/>');
  }
  return $toString_1(html.data_0);
}

function $setNewConfiguration(this$static, newDriftDefinitionConfig){
  this$static.newDriftDefinition = new DriftDefinition_1(newDriftDefinitionConfig);
  $setTemplate(this$static.newDriftDefinition, this$static.selectedTemplate);
}

function $setNewStartingConfiguration(this$static, newStartingConfiguration){
  this$static.newStartingConfiguration = newStartingConfiguration;
}

function $setSelectedTemplate(this$static, template){
  this$static.selectedTemplate = template;
}

function AbstractDriftAddDefinitionWizard_0(context, type){
  if (!context) {
    throw new NullPointerException_1('context == null');
  }
  if (!type) {
    throw new NullPointerException_1('type == null');
  }
  this.context = context;
  this.type_0 = type;
}

defineSeed(2751, 2036, {});
_.cancel_0 = function cancel_4(){
}
;
_.getSubtitle = function getSubtitle_1(){
  return null;
}
;
_.context = null;
_.newDriftDefinition = null;
_.newStartingConfiguration = null;
_.selectedTemplate = null;
_.type_0 = null;
function $setCreateTemplate(this$static, createTemplate){
  this$static.createTemplate = createTemplate;
}

function $setNewConfiguration_0(this$static, newDriftDefinitionConfig){
  this$static.newDriftDefinition = new DriftDefinition_1(newDriftDefinitionConfig);
}

function $setSelectedTemplate_0(this$static, template){
  this$static.selectedTemplate = template;
}

defineSeed(2752, 2036, {});
_.cancel_0 = function cancel_5(){
}
;
_.getSubtitle = function getSubtitle_2(){
  return null;
}
;
_.createTemplate = false;
_.newDriftDefinition = null;
_.resourceType = null;
_.selectedTemplate = null;
_.snapshotDriftDef = null;
_.snapshotVersion = 0;
function $execute(this$static){
  var context, rc;
  context = this$static.context;
  switch (context.type_0.ordinal) {
    case 0:
      rc = new ResourceCriteria_0;
      $addFilterId(rc, valueOf_44(context.resourceId));
      rc.fetchResourceType = true;
      $updateDriftDefinition(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), context, this$static.newDriftDefinition, new DriftAddDefinitionWizard$1_0(this$static));
      break;
    case 1:
      $createTemplate(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this$static.type_0.id, this$static.newDriftDefinition, new DriftAddDefinitionWizard$2_0(this$static));
      break;
    default:throw new IllegalArgumentException_1('Entity Context Type not supported [' + context + ']');
  }
}

function DriftAddDefinitionWizard_0(context, type, table){
  var steps;
  AbstractDriftAddDefinitionWizard_0.call(this, context, type);
  this.table = table;
  steps = new ArrayList_0;
  $add_3(steps, new DriftAddDefinitionWizardInfoStep_0(this));
  $add_3(steps, new DriftAddDefinitionWizardConfigStep_0(this));
  this.steps = steps;
}

function showWizard(context, resourceTypeId, table){
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(resourceTypeId), of(($clinit_ResourceTypeRepository$MetadataType() , driftDefinitionTemplates_0)), new DriftAddDefinitionWizard$4_0(context, table));
}

function showWizard_0(context, table){
  var rc;
  switch (context.type_0.ordinal) {
    case 0:
      rc = new ResourceCriteria_0;
      $addFilterId(rc, valueOf_44(context.resourceId));
      rc.fetchResourceType = true;
      $findResourcesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), rc, new DriftAddDefinitionWizard$3_0(context, table));
      break;
    case 1:
      showWizard(context, context.resourceTypeId, table);
      break;
    default:throw new IllegalArgumentException_1('Entity Context Type not supported [' + context + ']');
  }
}

defineSeed(2753, 2751, {}, DriftAddDefinitionWizard_0);
_.cancel_0 = function cancel_6(){
}
;
_.getSubtitle = function getSubtitle_3(){
  return null;
}
;
_.getTitle = function getTitle_5(){
  switch (this.context.type_0.ordinal) {
    case 4:
      return 'Add Drift Definition Template for Type  [' + ($clinit_Wizard() , this.type_0.name_0) + ']';
    default:return 'Add Drift Detection Definition for Resource of Type  [' + ($clinit_Wizard() , this.type_0.name_0) + ']';
  }
}
;
_.getWindowTitle = function getWindowTitle_1(){
  switch (this.context.type_0.ordinal) {
    case 4:
      return $clinit_Wizard() , 'Add Drift Definition Template Wizard';
    default:return $clinit_Wizard() , 'Add Drift Detection Definition Wizard';
  }
}
;
_.table = null;
function $onSuccess_239(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully added new drift detection definition  [' + ($clinit_Wizard() , this$static.this$0.newDriftDefinition.name_0) + '].  Agent(s) will be updated.', ($clinit_Message$Severity() , Info)));
  $closeDialog(this$static.this$0.view);
  this$static.this$0.table.refresh_0();
}

function DriftAddDefinitionWizard$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2754, 1, {}, DriftAddDefinitionWizard$1_0);
_.onFailure = function onFailure_250(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to add new drift detection definition  [' + ($clinit_Wizard() , this.this$0.newDriftDefinition.name_0) + ']'), caught);
  $closeDialog(this.this$0.view);
}
;
_.onSuccess_0 = function onSuccess_250(result){
  $onSuccess_239(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $onSuccess_240(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully added new drift template  [' + ($clinit_Wizard() , this$static.this$0.newDriftDefinition.name_0) + '].', ($clinit_Message$Severity() , Info)));
  $closeDialog(this$static.this$0.view);
  this$static.this$0.table.refresh_0();
}

function DriftAddDefinitionWizard$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2755, 1, {}, DriftAddDefinitionWizard$2_0);
_.onFailure = function onFailure_251(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to add new drift template  [' + ($clinit_Wizard() , this.this$0.newDriftDefinition.name_0) + ']'), caught);
  $closeDialog(this.this$0.view);
}
;
_.onSuccess_0 = function onSuccess_251(result){
  $onSuccess_240(this, dynamicCast(result, Q$DriftDefinitionTemplate));
}
;
_.this$0 = null;
function $onSuccess_241(this$static, result){
  var resource;
  if (result.size_0 == 0) {
    throw new IllegalArgumentException_1('Entity not found [' + this$static.val$context + ']');
  }
  resource = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Resource);
  showWizard(this$static.val$context, resource.resourceType.id, this$static.val$table);
}

function DriftAddDefinitionWizard$3_0(val$context, val$table){
  this.val$context = val$context;
  this.val$table = val$table;
}

defineSeed(2756, 1, {}, DriftAddDefinitionWizard$3_0);
_.onFailure = function onFailure_252(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to load resource composite data'), caught);
}
;
_.onSuccess_0 = function onSuccess_252(result){
  $onSuccess_241(this, dynamicCast(result, Q$PageList));
}
;
_.val$context = null;
_.val$table = null;
function DriftAddDefinitionWizard$4_0(val$context, val$table){
  this.val$context = val$context;
  this.val$table = val$table;
}

defineSeed(2757, 1, {}, DriftAddDefinitionWizard$4_0);
_.onTypesLoaded = function onTypesLoaded_14(type){
  var wizard;
  wizard = new DriftAddDefinitionWizard_0(this.val$context, type, this.val$table);
  wizard.view = new WizardView_0(wizard);
  $displayDialog(wizard.view);
}
;
_.val$context = null;
_.val$table = null;
function $getDriftConfigDef(this$static){
  if (this$static.wizard.context.type_0 == ($clinit_EntityContext$Type() , ResourceTemplate)) {
    return $clinit_DriftConfigurationDefinition() , $clinit_DriftConfigurationDefinition() , NEW_TEMPLATE_INSTANCE;
  }
  if (this$static.wizard.selectedTemplate.changeSetId != null) {
    return $clinit_DriftConfigurationDefinition() , $clinit_DriftConfigurationDefinition() , NEW_RESOURCE_INSTANCE_BY_PINNED_TEMPLATE;
  }
  return $clinit_DriftConfigurationDefinition() , $clinit_DriftConfigurationDefinition() , INSTANCE_0;
}

function $isTemplateNameUnique(this$static, templateName){
  var template, template$iterator;
  for (template$iterator = this$static.wizard.type_0.driftDefinitionTemplates.iterator(); template$iterator.hasNext();) {
    template = dynamicCast(template$iterator.next_0(), Q$DriftDefinitionTemplate);
    if ($equals_6(template.name_0, templateName)) {
      return false;
    }
  }
  return true;
}

function DriftAddDefinitionWizardConfigStep_0(wizard){
  this.wizard = wizard;
}

defineSeed(2758, 2040, makeCastMap([Q$WizardStep]), DriftAddDefinitionWizardConfigStep_0);
_.getCanvas = function getCanvas_14(){
  var def;
  if (!this.vLayout || !$equals_18(this.wizard.newStartingConfiguration, this.startingConfig)) {
    this.vLayout = new EnhancedVLayout_0;
    $setAttribute_24(this.vLayout, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
    this.startingConfig = this.wizard.newStartingConfiguration;
    def = $getDriftConfigDef(this);
    this.editor = new ConfigurationEditor_1(def, this.startingConfig);
    $addMember(this.vLayout, this.editor);
  }
  return this.vLayout;
}
;
_.getName = function getName_21(){
  return '';
}
;
_.nextPage_0 = function nextPage_12(){
  var templateConfig, templateNameProp;
  if (this.wizard.context.type_0 == ($clinit_EntityContext$Type() , ResourceTemplate)) {
    templateConfig = this.editor.configuration;
    templateNameProp = dynamicCast(templateConfig.properties.get_2('name'), Q$PropertySimple);
    $isTemplateNameUnique(this, templateNameProp.stringValue) || $setErrorMessage(templateNameProp, ($clinit_WizardStep() , 'Template name must be unique'));
  }
  if (!!this.editor && $validate_1(this.editor.topLevelPropertiesValuesManager).value_0) {
    $setNewConfiguration(this.wizard, this.editor.configuration);
    $execute(this.wizard);
    return true;
  }
  return false;
}
;
_.editor = null;
_.startingConfig = null;
_.vLayout = null;
_.wizard = null;
function $setSelectedTemplate_1(this$static, key, templatesMap){
  var description, selectedTemplate, startingConfig, definition;
  selectedTemplate = dynamicCast(templatesMap.get_2(key), Q$DriftDefinitionTemplate);
  $setSelectedTemplate(this$static.wizard, selectedTemplate);
  startingConfig = (definition = new DriftDefinition_1($deepCopyWithoutProxies(selectedTemplate.configuration)) , $setAttached(definition, ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setPinned(definition, selectedTemplate.changeSetId != null) , definition.template = selectedTemplate , definition).configuration;
  dynamicCast(startingConfig.properties.remove_3('name'), Q$Property);
  dynamicCast(startingConfig.properties.remove_3('description'), Q$Property);
  $setNewStartingConfiguration(this$static.wizard, startingConfig);
  description = selectedTemplate.description;
  description = null == description?($clinit_WizardStep() , 'None'):description;
  $getField_0(this$static.form_0, 'Description').setValue_4(description);
}

function DriftAddDefinitionWizardInfoStep_0(wizard){
  this.wizard = wizard;
}

defineSeed(2759, 2040, makeCastMap([Q$WizardStep]), DriftAddDefinitionWizardInfoStep_0);
_.getCanvas = function getCanvas_15(){
  var descriptionItem, formItems, spacerItem, template, template$iterator, templateSelectItem, templates, templatesMap, templatesMapKeySet, templatesMapKeySetArray;
  if (!this.form_0) {
    this.form_0 = new DynamicForm_0;
    $setNumCols(this.form_0, 1);
    formItems = new ArrayList_1(2);
    descriptionItem = new StaticTextItem_2('Description', ($clinit_WizardStep() , 'Description'));
    $setAttribute_30(descriptionItem, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0);
    $setAttribute_30(descriptionItem, 'align', ($clinit_Alignment() , LEFT_0).value_0);
    $isCreated_2(descriptionItem)?$setProperty_6(descriptionItem, 'width', 300):(descriptionItem.jsObj['width'] = 300 , undefined);
    setCheck(formItems.array, formItems.size_0++, descriptionItem);
    spacerItem = new SpacerItem_1('Spacer');
    setCheck(formItems.array, formItems.size_0++, spacerItem);
    templateSelectItem = new SortedSelectItem_2('Template', 'Drift Definition Templates');
    $setAttribute_30(templateSelectItem, 'titleOrientation', TOP_1.value_0);
    $setAttribute_30(templateSelectItem, 'align', LEFT_0.value_0);
    $isCreated_2(templateSelectItem)?$setProperty_6(templateSelectItem, 'width', 300):(templateSelectItem.jsObj['width'] = 300 , undefined);
    $setRequired(templateSelectItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    switch (this.wizard.context.type_0.ordinal) {
      case 4:
        addContextualHelp(templateSelectItem, 'Each drift template is derived from an existing template.  This provides a quick way to build new templates that are similar to existing templates, or originate with plugin defined templates.  Like a drift definition, the template describes a set of files for which drift monitoring will be performed.  Depending on the situation a definition derived from the template may or may not be allowed to alter the file set, or change other settings.  Template names must be unique within a resource type.', null);
        break;
      default:addContextualHelp(templateSelectItem, 'Each drift detection definition describes a set of files for which drift monitoring will be performed.  The definition can be enabled and disabled, defines the detection run interval, and specifies a base directory and optional file filters.  For each resource type offering drift detection there will be one or more predefined templates to use as a starting definition, which can then be edited.', null);
    }
    templates = this.wizard.type_0.driftDefinitionTemplates;
    templatesMap = new HashMap_1(templates.size_1());
    if (templates.isEmpty_0()) {
      throw new IllegalStateException_1('At least one drift definition template should exist for the resource type');
    }
     else {
      for (template$iterator = templates.iterator(); template$iterator.hasNext();) {
        template = dynamicCast(template$iterator.next_0(), Q$DriftDefinitionTemplate);
        templatesMap.put(template.name_0, template);
      }
    }
    templatesMapKeySet = $keySet(templatesMap);
    templatesMapKeySetArray = dynamicCast(templatesMapKeySet.toArray_0(initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, templatesMap.size_1(), 0)), Q$String_$1);
    $setValueMap_2(templateSelectItem, templatesMapKeySetArray);
    $addChangedHandler(templateSelectItem, new DriftAddDefinitionWizardInfoStep$1_0(this, templatesMap));
    setCheck(formItems.array, formItems.size_0++, templateSelectItem);
    this.form_0.setItems(dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, formItems.size_0, 0)), Q$FormItem_$1));
    $setValue_7(templateSelectItem, templatesMapKeySetArray[0]);
    $setSelectedTemplate_1(this, templatesMapKeySetArray[0], templatesMap);
  }
  return this.form_0;
}
;
_.getName = function getName_22(){
  switch (this.wizard.context.type_0.ordinal) {
    case 4:
      return $clinit_WizardStep() , 'Select the Starting Template';
    default:return $clinit_WizardStep() , 'Select the Template for the new Drift Detection Definition';
  }
}
;
_.nextPage_0 = function nextPage_13(){
  return this.form_0.validate_0();
}
;
_.form_0 = null;
_.wizard = null;
function DriftAddDefinitionWizardInfoStep$1_0(this$0, val$templatesMap){
  this.this$0 = this$0;
  this.val$templatesMap = val$templatesMap;
}

defineSeed(2760, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DriftAddDefinitionWizardInfoStep$1_0);
_.onChanged = function onChanged_50(event_0){
  if (!event_0 || $equals_6('', $getValue_2(event_0))) {
    return;
  }
  $setSelectedTemplate_1(this.this$0, dynamicCast($getValue_2(event_0), Q$String), this.val$templatesMap);
}
;
_.this$0 = null;
_.val$templatesMap = null;
function $execute_0(this$static){
  this$static.createTemplate?$createTemplate(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), this$static.resourceType.id, this$static.newDriftDefinition, new DriftPinTemplateWizard$1_0(this$static)):$pinTemplate(this$static, this$static.selectedTemplate);
}

function $pinTemplate(this$static, template){
  $pinTemplate_0(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), template.id, this$static.snapshotDriftDef.id, this$static.snapshotVersion, new DriftPinTemplateWizard$2_0(this$static, template));
}

function DriftPinTemplateWizard_0(resourceType, driftDef, snapshotVersion){
  var steps;
  this.resourceType = resourceType;
  this.snapshotDriftDef = driftDef;
  this.snapshotVersion = snapshotVersion;
  steps = new ArrayList_0;
  $add_3(steps, new DriftPinTemplateWizardInfoStep_0(this));
  $add_3(steps, new DriftPinTemplateWizardConfigStep_0(this));
  this.steps = steps;
}

function showWizard_1(snapshpotDriftDefId, snapshotVersion){
  var ddc;
  ddc = new DriftDefinitionCriteria_0;
  $addFilterId(ddc, valueOf_44(snapshpotDriftDefId));
  $fetchResource(ddc, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $fetchConfiguration(ddc, TRUE);
  $findDriftDefinitionsByCriteria(dynamicCast(secure(getInstance_40(), -1), Q$DriftGWTServiceAsync), ddc, new DriftPinTemplateWizard$3_0(snapshotVersion));
}

defineSeed(2761, 2752, {}, DriftPinTemplateWizard_0);
_.cancel_0 = function cancel_7(){
}
;
_.getSubtitle = function getSubtitle_4(){
  return null;
}
;
_.getTitle = function getTitle_6(){
  return 'Pin Snapshot [' + ($clinit_Wizard() , '' + this.snapshotVersion) + '] of Definition [' + this.snapshotDriftDef.name_0 + '] to a Drift Template for type [' + this.resourceType.name_0 + ']';
}
;
_.getWindowTitle = function getWindowTitle_2(){
  return $clinit_Wizard() , 'Pin Drift Definition Template Wizard';
}
;
function $onSuccess_242(this$static, result){
  $pinTemplate(this$static.this$0, result);
}

function DriftPinTemplateWizard$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2762, 1, {}, DriftPinTemplateWizard$1_0);
_.onFailure = function onFailure_253(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to add new drift detection definition  [' + ($clinit_Wizard() , this.this$0.selectedTemplate.name_0) + ']'), caught);
  $closeDialog(this.this$0.view);
}
;
_.onSuccess_0 = function onSuccess_253(result){
  $onSuccess_242(this, dynamicCast(result, Q$DriftDefinitionTemplate));
}
;
_.this$0 = null;
function $onSuccess_243(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Successfully pinned the drift template  [' + ($clinit_Wizard() , this$static.val$template.name_0) + '].', ($clinit_Message$Severity() , Info)));
  $closeDialog(this$static.this$0.view);
  goToView('#Resource/' + this$static.this$0.snapshotDriftDef.resource.id + '/Drift/Definitions', null, true);
}

function DriftPinTemplateWizard$2_0(this$0, val$template){
  this.this$0 = this$0;
  this.val$template = val$template;
}

defineSeed(2763, 1, {}, DriftPinTemplateWizard$2_0);
_.onFailure = function onFailure_254(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to pin snapshot to drift template [' + ($clinit_Wizard() , this.val$template.name_0) + ']'), caught);
  $closeDialog(this.this$0.view);
}
;
_.onSuccess_0 = function onSuccess_254(result){
  $onSuccess_243(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$template = null;
function $onSuccess_244(this$static, result){
  var driftDef, resource;
  result.size_0 == 0 && $handleError_0(($clinit_CoreGUI() , 'Failed to pin snapshot to drift template [' + ($clinit_Wizard() , 'Invalid Snapshot') + ']'), null);
  driftDef = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$DriftDefinition);
  resource = driftDef.resource;
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(resource.resourceType.id), of(($clinit_ResourceTypeRepository$MetadataType() , driftDefinitionTemplates_0)), new DriftPinTemplateWizard$3$1_0(driftDef, this$static.val$snapshotVersion));
}

function DriftPinTemplateWizard$3_0(val$snapshotVersion){
  this.val$snapshotVersion = val$snapshotVersion;
}

defineSeed(2764, 1, {}, DriftPinTemplateWizard$3_0);
_.onFailure = function onFailure_255(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to pin snapshot to drift template [' + ($clinit_Wizard() , 'Invalid Snapshot') + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_255(result){
  $onSuccess_244(this, dynamicCast(result, Q$PageList));
}
;
_.val$snapshotVersion = 0;
function DriftPinTemplateWizard$3$1_0(val$driftDef, val$snapshotVersion){
  this.val$driftDef = val$driftDef;
  this.val$snapshotVersion = val$snapshotVersion;
}

defineSeed(2765, 1, {}, DriftPinTemplateWizard$3$1_0);
_.onTypesLoaded = function onTypesLoaded_15(type){
  var wizard;
  wizard = new DriftPinTemplateWizard_0(type, this.val$driftDef, this.val$snapshotVersion);
  wizard.view = new WizardView_0(wizard);
  $displayDialog(wizard.view);
}
;
_.val$driftDef = null;
_.val$snapshotVersion = 0;
function $isTemplateNameUnique_0(this$static, templateName){
  var template, template$iterator;
  for (template$iterator = this$static.wizard.resourceType.driftDefinitionTemplates.iterator(); template$iterator.hasNext();) {
    template = dynamicCast(template$iterator.next_0(), Q$DriftDefinitionTemplate);
    if ($equals_6(template.name_0, templateName)) {
      return false;
    }
  }
  return true;
}

function $nextPage(this$static){
  var message, templateConfig, templateNameProp;
  if (this$static.wizard.createTemplate) {
    templateConfig = this$static.editor.configuration;
    templateNameProp = dynamicCast(templateConfig.properties.get_2('name'), Q$PropertySimple);
    $isTemplateNameUnique_0(this$static, templateNameProp.stringValue) || $setErrorMessage(templateNameProp, ($clinit_WizardStep() , 'Template name must be unique'));
  }
  if (this$static.wizard.createTemplate && (!this$static.editor || !$validate_1(this$static.editor.topLevelPropertiesValuesManager).value_0)) {
    return false;
  }
  if (this$static.isConfirmed) {
    this$static.wizard.createTemplate && $setNewConfiguration_0(this$static.wizard, this$static.editor.configuration);
    $execute_0(this$static.wizard);
    return true;
  }
  message = !this$static.wizard.createTemplate && this$static.wizard.selectedTemplate.changeSetId != null?($clinit_WizardStep() , "Warning! This template is already pinned.  The template can be re-pinned to this new snapshot.  Once re-pinned each current and future drift definition for the template will have its initial snapshot set to the template's pinned snapshot. Existing definitions for this template will be reset to the new initial snapshot, and all exsiting snapshots will be removed. Continue re-pinning the template with this new snapshot?"):($clinit_WizardStep() , "Once pinned each current and future drift definition for the template will have its initial snapshot set to the template's pinned snapshot. Existing definitions for this template will be reset to the new initial snapshot, and all exsiting snapshots will be removed. Continue pinning the template to the snapshot?");
  ask(message, new DriftPinTemplateWizardConfigStep$1_0(this$static));
  return false;
}

function DriftPinTemplateWizardConfigStep_0(wizard){
  this.wizard = wizard;
}

defineSeed(2766, 2040, makeCastMap([Q$WizardStep]), DriftPinTemplateWizardConfigStep_0);
_.getCanvas = function getCanvas_16(){
  var def, startingConfig;
  if (!this.wizard.createTemplate) {
    return null;
  }
  if (!this.vLayout) {
    this.vLayout = new EnhancedVLayout_0;
    $setAttribute_24(this.vLayout, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
    startingConfig = this.wizard.snapshotDriftDef.configuration;
    def = ($clinit_DriftConfigurationDefinition() , $clinit_DriftConfigurationDefinition() , NEW_PINNED_TEMPLATE_INSTANCE);
    this.editor = new ConfigurationEditor_1(def, startingConfig);
    $addMember(this.vLayout, this.editor);
  }
  return this.vLayout;
}
;
_.getName = function getName_23(){
  return '';
}
;
_.nextPage_0 = function nextPage_14(){
  return $nextPage(this);
}
;
_.editor = null;
_.isConfirmed = false;
_.vLayout = null;
_.wizard = null;
function DriftPinTemplateWizardConfigStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2767, 1, {}, DriftPinTemplateWizardConfigStep$1_0);
_.execute_3 = function execute_51(confirmed){
  if (confirmed.value_0) {
    this.this$0.isConfirmed = true;
    $nextPage(this.this$0);
  }
   else {
    $closeDialog(this.this$0.wizard.view);
  }
}
;
_.this$0 = null;
function $setSelectedTemplate_2(this$static, key, templatesMap){
  var description, selectedTemplate;
  selectedTemplate = dynamicCast(templatesMap.get_2(key), Q$DriftDefinitionTemplate);
  $setSelectedTemplate_0(this$static.wizard, selectedTemplate);
  description = selectedTemplate.description;
  description = null == description?($clinit_WizardStep() , 'None'):description;
  $getField_0(this$static.selectTemplateForm, 'Description').setValue_4(description);
}

function DriftPinTemplateWizardInfoStep_0(wizard){
  this.selectTemplateItem = new SortedSelectItem_2('Template', ($clinit_WizardStep() , 'Drift Definition Templates'));
  this.wizard = wizard;
}

defineSeed(2768, 2040, makeCastMap([Q$WizardStep]), DriftPinTemplateWizardInfoStep_0);
_.getCanvas = function getCanvas_17(){
  var ddc, formItems, radioGroupItem, radioGroupValues, radioTitleItem, selectTemplateDescriptionItem, spacerItem, template, template$iterator, templates, templatesMap, templatesMapKeySet, templatesMapKeySetArray;
  if (!this.canvas_0) {
    this.canvas_0 = new EnhancedVLayout_0;
    $setAttribute_24(this.canvas_0, 'width', '100%', true);
    this.radioForm = new DynamicForm_0;
    $setNumCols(this.radioForm, 1);
    $setAutoWidth(this.radioForm);
    $setAttribute_24(this.radioForm, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, true);
    formItems = new ArrayList_0;
    radioTitleItem = new StaticTextItem_1('RadioTitle');
    $setShowTitle_0(radioTitleItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setAttribute_30(radioTitleItem, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0);
    $setAttribute_30(radioTitleItem, 'align', ($clinit_Alignment() , LEFT_0).value_0);
    $setValue_7(radioTitleItem, '<span style="font-weight: bold; color: #003168">' + ($clinit_WizardStep() , 'Template Selection') + ' :<\/span>');
    addContextualHelp(radioTitleItem, 'The snapshot can be pinned to a new or existing drift template. The \'New Template" option allows the user to promote a trusted definition and snapshot, at the resource level, to the type level.  The new template can then be applied to members of the type.  The new template is initially a copy of the snapshot\'s drift definition but can then be edited in the next step.  The name should be changed and must be a unique drift template name for the type. The "Existing Template" option allows the user to pin, or re-pin, an existing template with the selected snapshot.  To be valid, the existing template must monitor the same directories as the snapshot\'s definition.   The selection box displays only valid existing templates.  If there are no valid existing templates this option can not be selected.', null);
    setCheck(formItems.array, formItems.size_0++, radioTitleItem);
    radioGroupValues = new LinkedHashMap_0;
    $put_1(radioGroupValues, 'create', "Pin to New Template (derived from the snapshot's Drift Definition)");
    $put_1(radioGroupValues, 'select', 'Pin to ExistingTemplate');
    radioGroupItem = new RadioGroupItem_1('RadioOptions');
    $setShowTitle_0(radioGroupItem, FALSE);
    $setWrap_2(radioGroupItem, FALSE);
    $setRequired(radioGroupItem, TRUE);
    $setAttribute_30(radioGroupItem, 'align', LEFT_0.value_0);
    $isCreated_2(radioGroupItem)?$setValueMapMethod(radioGroupItem, convertMapToJavascriptObject(radioGroupValues)):$isCreated_2(radioGroupItem)?$setProperty_7(radioGroupItem, 'valueMap', convertMapToJavascriptObject(radioGroupValues)):(radioGroupItem.jsObj['valueMap'] = convertMapToJavascriptObject(radioGroupValues) , undefined);
    $setValue_7(radioGroupItem, 'create');
    this.wizard.createTemplate = true;
    $addChangedHandler(radioGroupItem, new DriftPinTemplateWizardInfoStep$1_0(this));
    setCheck(formItems.array, formItems.size_0++, radioGroupItem);
    $add_3(formItems, new SpacerItem_0);
    this.radioForm.setItems(dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, formItems.size_0, 0)), Q$FormItem_$1));
    $addMember(this.canvas_0, this.radioForm);
    this.selectTemplateForm = new DynamicForm_0;
    $setNumCols(this.selectTemplateForm, 1);
    $setIsGroup(this.selectTemplateForm, TRUE);
    $setGroupTitle(this.selectTemplateForm, 'Existing Templates');
    $setPadding(this.selectTemplateForm, valueOf_44(10));
    $hide(this.selectTemplateForm);
    formItems.array = initDim(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, 0, 0);
    formItems.size_0 = 0;
    selectTemplateDescriptionItem = new StaticTextItem_2('Description', 'Description');
    $setAttribute_30(selectTemplateDescriptionItem, 'titleOrientation', TOP_1.value_0);
    $setAttribute_30(selectTemplateDescriptionItem, 'align', LEFT_0.value_0);
    $isCreated_2(selectTemplateDescriptionItem)?$setProperty_6(selectTemplateDescriptionItem, 'width', 300):(selectTemplateDescriptionItem.jsObj['width'] = 300 , undefined);
    setCheck(formItems.array, formItems.size_0++, selectTemplateDescriptionItem);
    spacerItem = new SpacerItem_0;
    $isCreated_2(spacerItem)?$setProperty_6(spacerItem, 'height', 10):(spacerItem.jsObj['height'] = 10 , undefined);
    setCheck(formItems.array, formItems.size_0++, spacerItem);
    $setAttribute_30(this.selectTemplateItem, 'titleOrientation', TOP_1.value_0);
    $setAttribute_30(this.selectTemplateItem, 'align', LEFT_0.value_0);
    $setWidth_1(this.selectTemplateItem, 300);
    $setRequired(this.selectTemplateItem, TRUE);
    addContextualHelp(this.selectTemplateItem, "Once pinned each current and future drift definition for that template will have its initial snapshot set to the template's pinned snapshot. And the definition itself will be marked as pinned.  This is used to detect drift from an expected file set. Note that existing definitions for this template will be reset to the new initial snapshot, and all exsiting snapshots will be removed.", null);
    templates = this.wizard.resourceType.driftDefinitionTemplates;
    if (!templates || templates.isEmpty_0()) {
      throw new IllegalStateException_1('At least one drift definition template should exist for the resource type');
    }
    templatesMap = new HashMap_1(templates.size_1());
    ddc = new DriftDefinitionComparator_0;
    for (template$iterator = templates.iterator(); template$iterator.hasNext();) {
      template = dynamicCast(template$iterator.next_0(), Q$DriftDefinitionTemplate);
      0 == $compare_5(ddc, new DriftDefinition_1(template.configuration), this.wizard.snapshotDriftDef) && templatesMap.put(template.name_0, template);
    }
    templatesMapKeySet = $keySet(templatesMap);
    templatesMapKeySetArray = dynamicCast(templatesMapKeySet.toArray_0(initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, templatesMap.size_1(), 0)), Q$String_$1);
    $setValueMap_2(this.selectTemplateItem, templatesMapKeySetArray);
    $addChangedHandler(this.selectTemplateItem, new DriftPinTemplateWizardInfoStep$2_0(this, templatesMap));
    $add_3(formItems, this.selectTemplateItem);
    this.selectTemplateForm.setItems(dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, formItems.size_0, 0)), Q$FormItem_$1));
    $addMember(this.canvas_0, this.selectTemplateForm);
    if (templatesMapKeySetArray.length > 0) {
      $setValue_7(this.selectTemplateItem, templatesMapKeySetArray[0]);
      $setSelectedTemplate_2(this, templatesMapKeySetArray[0], templatesMap);
    }
  }
  return this.canvas_0;
}
;
_.getName = function getName_24(){
  return $clinit_WizardStep() , 'Select the Template to be Pinned';
}
;
_.nextPage_0 = function nextPage_15(){
  if (!this.radioForm.validate_0()) {
    return false;
  }
  return true;
}
;
_.canvas_0 = null;
_.radioForm = null;
_.selectTemplateForm = null;
_.wizard = null;
function DriftPinTemplateWizardInfoStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2769, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DriftPinTemplateWizardInfoStep$1_0);
_.onChanged = function onChanged_51(event_0){
  if ($equals_6('select', $getValue_2(event_0)) && null == $getValue_0(this.this$0.selectTemplateItem)) {
    say(($clinit_WizardStep() , 'There are no existing templates that monitor the same directories as the snapshot\'s definition.  Select the "New Template" option to continue.'));
    $getItem_0(event_0).setValue_4('create');
    return;
  }
  $setCreateTemplate(this.this$0.wizard, $equals_6('create', $getValue_2(event_0)));
  if (this.this$0.wizard.createTemplate) {
    $hide(this.this$0.selectTemplateForm);
    $setTitle_0(this.this$0.wizard.view.nextButton, ($clinit_WizardStep() , 'Next'));
  }
   else {
    $show(this.this$0.selectTemplateForm);
    $setTitle_0(this.this$0.wizard.view.nextButton, ($clinit_WizardStep() , 'Finish'));
  }
  $markForRedraw(this.this$0.radioForm);
}
;
_.this$0 = null;
function DriftPinTemplateWizardInfoStep$2_0(this$0, val$templatesMap){
  this.this$0 = this$0;
  this.val$templatesMap = val$templatesMap;
}

defineSeed(2770, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), DriftPinTemplateWizardInfoStep$2_0);
_.onChanged = function onChanged_52(event_0){
  if (!event_0 || $equals_6('', $getValue_2(event_0))) {
    return;
  }
  $setSelectedTemplate_2(this.this$0, dynamicCast($getValue_2(event_0), Q$String), this.val$templatesMap);
}
;
_.this$0 = null;
_.val$templatesMap = null;
function getInstance_30(){
  var target;
  if (!instance_1) {
    instance_1 = new AgentGWTService_Proxy_0;
    target = instance_1;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'AgentGWTService');
  }
  return instance_1;
}

var instance_1 = null;
function $clinit_AgentGWTService_Proxy(){
  $clinit_AgentGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER = new AgentGWTService_TypeSerializer_0;
}

function $getAgentForResource(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AgentGWTService_Proxy', 'getAgentForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AgentGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_44(callback);
    }
     else 
      throw $e0;
  }
}

function $pingAgentForResource(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AgentGWTService_Proxy', 'pingAgentForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AgentGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_45(callback, ex);
    }
     else 
      throw $e0;
  }
}

function AgentGWTService_Proxy_0(){
  $clinit_AgentGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, 'C5F35D2177EAE8A826CDAD86702F166A', SERIALIZER);
}

defineSeed(2783, 2784, makeCastMap([Q$AgentGWTServiceAsync]), AgentGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_0(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER;
function $clinit_AgentGWTService_TypeSerializer(){
  $clinit_AgentGWTService_TypeSerializer = nullMethod;
  methodMapNative_0 = loadMethodsNative();
  signatureMapNative_0 = loadSignaturesNative();
}

function AgentGWTService_TypeSerializer_0(){
  $clinit_AgentGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_0, signatureMapNative_0);
}

function loadMethodsNative(){
  var result = {};
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative(){
  var result = [];
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2785, 278, {}, AgentGWTService_TypeSerializer_0);
var methodMapNative_0 = null, signatureMapNative_0 = null;
function getInstance_31(){
  var target;
  if (!instance_2) {
    instance_2 = new AlertDefinitionGWTService_Proxy_0;
    target = instance_2;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'AlertDefinitionGWTService');
  }
  return instance_2;
}

var instance_2 = null;
function $clinit_AlertDefinitionGWTService_Proxy(){
  $clinit_AlertDefinitionGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_0 = new AlertDefinitionGWTService_TypeSerializer_0;
}

function $createAlertDefinition(this$static, alertDefinition, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertDefinitionGWTService_Proxy', 'createAlertDefinition');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertDefinitionGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.alert.AlertDefinition/2987034427'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Integer/3438268394'));
    $writeObject(streamWriter, alertDefinition);
    $writeObject(streamWriter, resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition creation failed'), ex);
    }
     else 
      throw $e0;
  }
}

function $disableAlertDefinitions(this$static, alertDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertDefinitionGWTService_Proxy', 'disableAlertDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertDefinitionGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, alertDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to disable the selected alert definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $enableAlertDefinitions(this$static, alertDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertDefinitionGWTService_Proxy', 'enableAlertDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertDefinitionGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, alertDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to enable the selected alert definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $findAlertDefinitionsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertDefinitionGWTService_Proxy', 'findAlertDefinitionsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertDefinitionGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.AlertDefinitionCriteria/590256504'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getAlertNotificationConfigurationPreview(this$static, notifs, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertDefinitionGWTService_Proxy', 'getAlertNotificationConfigurationPreview');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertDefinitionGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'));
    $writeObject(streamWriter, notifs);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_12(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getAllAlertSenders(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertDefinitionGWTService_Proxy', 'getAllAlertSenders');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertDefinitionGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Cannot get alert senders'), ex);
    }
     else 
      throw $e0;
  }
}

function $getConfigurationDefinitionForSender(this$static, sender, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertDefinitionGWTService_Proxy', 'getConfigurationDefinitionForSender');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertDefinitionGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, sender));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_14(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $removeAlertDefinitions(this$static, alertDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertDefinitionGWTService_Proxy', 'removeAlertDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertDefinitionGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, alertDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to deleted the selected alert definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateAlertDefinition(this$static, alertDefinitionId, alertDefinition, purgeInternals, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertDefinitionGWTService_Proxy', 'updateAlertDefinition');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertDefinitionGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.alert.AlertDefinition/2987034427'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + alertDefinitionId);
    $writeObject(streamWriter, alertDefinition);
    append(streamWriter.encodeBuffer, purgeInternals?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition update failed'), ex);
    }
     else 
      throw $e0;
  }
}

function AlertDefinitionGWTService_Proxy_0(){
  $clinit_AlertDefinitionGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '58D930186FB178735B81AE3373643055', SERIALIZER_0);
}

defineSeed(2787, 2784, makeCastMap([Q$AlertDefinitionGWTServiceAsync]), AlertDefinitionGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_1(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_0;
function $clinit_AlertDefinitionGWTService_TypeSerializer(){
  $clinit_AlertDefinitionGWTService_TypeSerializer = nullMethod;
  methodMapNative_1 = loadMethodsNative_0();
  signatureMapNative_1 = loadSignaturesNative_0();
}

function AlertDefinitionGWTService_TypeSerializer_0(){
  $clinit_AlertDefinitionGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_1, signatureMapNative_1);
}

function loadMethodsNative_0(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10, serialize_2];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['[I/2970817851'] = [undefined, undefined, serialize_3];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [instantiate_34, deserialize_35, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101, serialize_49];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93, serialize_40];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90, serialize_37];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91, serialize_38];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92, serialize_39];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97, serialize_44];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96, serialize_43];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98, serialize_45];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94, serialize_41];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95, serialize_42];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99, serialize_46];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100, serialize_48];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102, serialize_50];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106, serialize_54];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104, serialize_52];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103, serialize_51];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105, serialize_53];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107, serialize_55];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108, serialize_56];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110, serialize_59];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127, serialize_76];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113, serialize_62];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111, serialize_60];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112, serialize_61];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115, serialize_64];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114, serialize_63];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117, serialize_66];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116, serialize_65];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123, serialize_72];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120, serialize_69];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119, serialize_68];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121, serialize_70];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118, serialize_67];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122, serialize_71];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124, serialize_73];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126, serialize_75];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125, serialize_74];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130, serialize_77];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141, serialize_83];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142, serialize_85];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140, serialize_82];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157, serialize_97];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162, serialize_102];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161, serialize_101];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163, serialize_103];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164, serialize_104];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173, serialize_113];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172, serialize_112];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174, serialize_116];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175, serialize_117];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176, serialize_118];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177, serialize_119];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183, serialize_125];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179, serialize_121];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178, serialize_120];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180, serialize_122];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181, serialize_123];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182, serialize_124];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184, serialize_126];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186, serialize_128];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187, serialize_129];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185, serialize_127];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188, serialize_130];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190, serialize_132];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191, serialize_133];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192, serialize_134];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193, serialize_135];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196, serialize_138];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195, serialize_137];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198, serialize_140];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197, serialize_139];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201, serialize_143];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199, serialize_141];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200, serialize_142];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203, serialize_144];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204, serialize_145];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205, serialize_146];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207, serialize_148];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206, serialize_147];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211, serialize_152];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209, serialize_150];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208, serialize_149];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210, serialize_151];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212, serialize_153];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214, serialize_155];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213, serialize_154];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215, serialize_156];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219, serialize_160];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218, serialize_159];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216, serialize_157];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217, serialize_158];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230, serialize_170];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221, serialize_162];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220, serialize_161];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222, serialize_163];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224, serialize_165];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223, serialize_164];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225, serialize_166];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229, serialize_169];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227, serialize_167];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231, serialize_171];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244, serialize_184];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232, serialize_172];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233, serialize_173];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234, serialize_174];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236, serialize_176];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235, serialize_175];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237, serialize_177];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239, serialize_179];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238, serialize_178];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240, serialize_180];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241, serialize_181];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243, serialize_183];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242, serialize_182];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245, serialize_185];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248, serialize_186];
  result['org.rhq.core.domain.criteria.AlertDefinitionCriteria/590256504'] = [undefined, undefined, serialize_191];
  result['org.rhq.core.domain.criteria.Criteria$NonBindingOverrideFilter/3450683450'] = [undefined, undefined, serialize_201];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252, serialize_239];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249, serialize_236];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250, serialize_237];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251, serialize_238];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255, serialize_243];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257, serialize_245];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260, serialize_247];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259, serialize_246];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278, serialize_261];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274, serialize_257];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276, serialize_259];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277, serialize_260];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285, serialize_266];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283, serialize_264];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284, serialize_265];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288, serialize_269];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289, serialize_270];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298, serialize_271];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300, serialize_273];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299, serialize_272];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302, serialize_275];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303, serialize_276];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312, serialize_278];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311, serialize_277];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314, serialize_279];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316, serialize_282];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318, serialize_284];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317, serialize_283];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337, serialize_291];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336, serialize_290];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339, serialize_292];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341, serialize_294];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340, serialize_293];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342, serialize_295];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344, serialize_297];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343, serialize_296];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345, serialize_298];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346, serialize_300];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348, serialize_301];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349, serialize_302];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360, serialize_314];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350, serialize_305];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351, serialize_306];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354, serialize_309];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352, serialize_307];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353, serialize_308];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356, serialize_311];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355, serialize_310];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358, serialize_312];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359, serialize_313];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375, serialize_318];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376, serialize_319];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378, serialize_320];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380, serialize_322];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379, serialize_321];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394, serialize_325];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395, serialize_326];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_0(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(_3I_classLit)] = '[I/2970817851';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_AlertDefinitionCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.AlertDefinitionCriteria/590256504';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$NonBindingOverrideFilter_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$NonBindingOverrideFilter/3450683450';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2788, 278, {}, AlertDefinitionGWTService_TypeSerializer_0);
var methodMapNative_1 = null, signatureMapNative_1 = null;
function getInstance_32(){
  var target;
  if (!instance_3) {
    instance_3 = new AlertGWTService_Proxy_0;
    target = instance_3;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'AlertGWTService');
  }
  return instance_3;
}

var instance_3 = null;
function $clinit_AlertGWTService_Proxy(){
  $clinit_AlertGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_1 = new AlertGWTService_TypeSerializer_0;
}

function $acknowledgeAlerts(this$static, alertIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertGWTService_Proxy', 'acknowledgeAlerts');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, alertIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , "Failed to acknowledge alerts with id's: " + ($clinit_Enhanced() , toString_30(callback.val$alertIds))), ex);
      callback.this$0.refreshTableInfo();
    }
     else 
      throw $e0;
  }
}

function $acknowledgeAlertsByContext(this$static, context, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertGWTService_Proxy', 'acknowledgeAlertsByContext');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.common.EntityContext/926996548'));
    $writeObject(streamWriter, context);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to acknowledge all alerts from this source'), ex);
      callback.this$0.refreshTableInfo();
    }
     else 
      throw $e0;
  }
}

function $deleteAlerts(this$static, alertIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertGWTService_Proxy', 'deleteAlerts');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, alertIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , "Failed to delete alerts with id's: " + ($clinit_Enhanced() , toString_30(callback.val$alertIds))), ex);
      callback.this$0.refreshTableInfo();
    }
     else 
      throw $e0;
  }
}

function $deleteAlertsByContext(this$static, context, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertGWTService_Proxy', 'deleteAlertsByContext');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.common.EntityContext/926996548'));
    $writeObject(streamWriter, context);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete all alerts from this source'), ex);
      callback.this$0.refreshTableInfo();
    }
     else 
      throw $e0;
  }
}

function $findAlertsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertGWTService_Proxy', 'findAlertsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.AlertCriteria/3601819566'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function AlertGWTService_Proxy_0(){
  $clinit_AlertGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, 'CAE5DBD9434255B179C976D7C0F723F1', SERIALIZER_1);
}

defineSeed(2790, 2784, makeCastMap([Q$AlertGWTServiceAsync]), AlertGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_2(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_1;
function $clinit_AlertGWTService_TypeSerializer(){
  $clinit_AlertGWTService_TypeSerializer = nullMethod;
  methodMapNative_2 = loadMethodsNative_1();
  signatureMapNative_2 = loadSignaturesNative_1();
}

function AlertGWTService_TypeSerializer_0(){
  $clinit_AlertGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_2, signatureMapNative_2);
}

function loadMethodsNative_1(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['[I/2970817851'] = [undefined, undefined, serialize_3];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100, serialize_48];
  result['[Lorg.rhq.core.domain.alert.AlertPriority;/2801426646'] = [undefined, undefined, serialize_47];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.common.EntityContext/926996548'] = [undefined, undefined, serialize_86];
  result['org.rhq.core.domain.common.EntityContext$Type/3658574791'] = [undefined, undefined, serialize_87];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.criteria.AlertCriteria/3601819566'] = [undefined, undefined, serialize_190];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_1(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(_3I_classLit)] = '[I/2970817851';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertPriority;/2801426646';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_common_EntityContext_2_classLit)] = 'org.rhq.core.domain.common.EntityContext/926996548';
  result[getHashCode(Lorg_rhq_core_domain_common_EntityContext$Type_2_classLit)] = 'org.rhq.core.domain.common.EntityContext$Type/3658574791';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_AlertCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.AlertCriteria/3601819566';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2791, 278, {}, AlertGWTService_TypeSerializer_0);
var methodMapNative_2 = null, signatureMapNative_2 = null;
function getInstance_33(){
  var target;
  if (!instance_4) {
    instance_4 = new AlertTemplateGWTService_Proxy_0;
    target = instance_4;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'AlertTemplateGWTService');
  }
  return instance_4;
}

var instance_4 = null;
function $clinit_AlertTemplateGWTService_Proxy(){
  $clinit_AlertTemplateGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_2 = new AlertTemplateGWTService_TypeSerializer_0;
}

function $createAlertTemplate(this$static, alertDefinition, resourceTypeId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertTemplateGWTService_Proxy', 'createAlertTemplate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertTemplateGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.alert.AlertDefinition/2987034427'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Integer/3438268394'));
    $writeObject(streamWriter, alertDefinition);
    $writeObject(streamWriter, resourceTypeId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition creation failed'), ex);
    }
     else 
      throw $e0;
  }
}

function $disableAlertTemplates(this$static, alertDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertTemplateGWTService_Proxy', 'disableAlertTemplates');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertTemplateGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeObject(streamWriter, alertDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to disable the selected alert definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $enableAlertTemplates(this$static, alertDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertTemplateGWTService_Proxy', 'enableAlertTemplates');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertTemplateGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeObject(streamWriter, alertDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to enable the selected alert definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $removeAlertTemplates(this$static, alertDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertTemplateGWTService_Proxy', 'removeAlertTemplates');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertTemplateGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeObject(streamWriter, alertDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to deleted the selected alert definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateAlertTemplate(this$static, alertDefinition, resetMatching, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AlertTemplateGWTService_Proxy', 'updateAlertTemplate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AlertTemplateGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.alert.AlertDefinition/2987034427'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    $writeObject(streamWriter, alertDefinition);
    append(streamWriter.encodeBuffer, resetMatching?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition update failed'), ex);
    }
     else 
      throw $e0;
  }
}

function AlertTemplateGWTService_Proxy_0(){
  $clinit_AlertTemplateGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, 'AED25926D189D649ED3D0937FB58F44E', SERIALIZER_2);
}

defineSeed(2793, 2784, makeCastMap([Q$AlertTemplateGWTServiceAsync]), AlertTemplateGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_3(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_2;
function $clinit_AlertTemplateGWTService_TypeSerializer(){
  $clinit_AlertTemplateGWTService_TypeSerializer = nullMethod;
  methodMapNative_3 = loadMethodsNative_2();
  signatureMapNative_3 = loadSignaturesNative_2();
}

function AlertTemplateGWTService_TypeSerializer_0(){
  $clinit_AlertTemplateGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_3, signatureMapNative_3);
}

function loadMethodsNative_2(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10, serialize_2];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101, serialize_49];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93, serialize_40];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90, serialize_37];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91, serialize_38];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92, serialize_39];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97, serialize_44];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96, serialize_43];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98, serialize_45];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94, serialize_41];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95, serialize_42];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99, serialize_46];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100, serialize_48];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102, serialize_50];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106, serialize_54];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104, serialize_52];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103, serialize_51];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105, serialize_53];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107, serialize_55];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108, serialize_56];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110, serialize_59];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127, serialize_76];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113, serialize_62];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111, serialize_60];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112, serialize_61];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115, serialize_64];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114, serialize_63];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117, serialize_66];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116, serialize_65];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123, serialize_72];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120, serialize_69];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119, serialize_68];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121, serialize_70];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118, serialize_67];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122, serialize_71];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124, serialize_73];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126, serialize_75];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125, serialize_74];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130, serialize_77];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141, serialize_83];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142, serialize_85];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140, serialize_82];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157, serialize_97];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162, serialize_102];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161, serialize_101];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163, serialize_103];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164, serialize_104];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173, serialize_113];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172, serialize_112];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174, serialize_116];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175, serialize_117];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176, serialize_118];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177, serialize_119];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183, serialize_125];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179, serialize_121];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178, serialize_120];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180, serialize_122];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181, serialize_123];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182, serialize_124];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184, serialize_126];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186, serialize_128];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187, serialize_129];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185, serialize_127];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188, serialize_130];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190, serialize_132];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191, serialize_133];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192, serialize_134];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193, serialize_135];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196, serialize_138];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195, serialize_137];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198, serialize_140];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197, serialize_139];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201, serialize_143];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199, serialize_141];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200, serialize_142];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203, serialize_144];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204, serialize_145];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205, serialize_146];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207, serialize_148];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206, serialize_147];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211, serialize_152];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209, serialize_150];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208, serialize_149];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210, serialize_151];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212, serialize_153];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214, serialize_155];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213, serialize_154];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215, serialize_156];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219, serialize_160];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218, serialize_159];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216, serialize_157];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217, serialize_158];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230, serialize_170];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221, serialize_162];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220, serialize_161];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222, serialize_163];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224, serialize_165];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223, serialize_164];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225, serialize_166];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229, serialize_169];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227, serialize_167];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231, serialize_171];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244, serialize_184];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232, serialize_172];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233, serialize_173];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234, serialize_174];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236, serialize_176];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235, serialize_175];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237, serialize_177];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239, serialize_179];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238, serialize_178];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240, serialize_180];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241, serialize_181];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243, serialize_183];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242, serialize_182];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245, serialize_185];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248, serialize_186];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252, serialize_239];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249, serialize_236];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250, serialize_237];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251, serialize_238];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255, serialize_243];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257, serialize_245];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260, serialize_247];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259, serialize_246];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278, serialize_261];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274, serialize_257];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276, serialize_259];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277, serialize_260];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285, serialize_266];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283, serialize_264];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284, serialize_265];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288, serialize_269];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289, serialize_270];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298, serialize_271];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300, serialize_273];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299, serialize_272];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302, serialize_275];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303, serialize_276];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312, serialize_278];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311, serialize_277];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314, serialize_279];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316, serialize_282];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318, serialize_284];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317, serialize_283];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337, serialize_291];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336, serialize_290];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339, serialize_292];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341, serialize_294];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340, serialize_293];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342, serialize_295];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344, serialize_297];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343, serialize_296];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345, serialize_298];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346, serialize_300];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348, serialize_301];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349, serialize_302];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360, serialize_314];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350, serialize_305];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351, serialize_306];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354, serialize_309];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352, serialize_307];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353, serialize_308];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356, serialize_311];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355, serialize_310];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358, serialize_312];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359, serialize_313];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375, serialize_318];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376, serialize_319];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378, serialize_320];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380, serialize_322];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379, serialize_321];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394, serialize_325];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395, serialize_326];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_2(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2794, 278, {}, AlertTemplateGWTService_TypeSerializer_0);
var methodMapNative_3 = null, signatureMapNative_3 = null;
function getInstance_34(){
  var target;
  if (!instance_5) {
    instance_5 = new AuthorizationGWTService_Proxy_0;
    target = instance_5;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'AuthorizationGWTService');
  }
  return instance_5;
}

var instance_5 = null;
function $clinit_AuthorizationGWTService_Proxy(){
  $clinit_AuthorizationGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_3 = new AuthorizationGWTService_TypeSerializer_0;
}

function $getExplicitGlobalPermissions(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AuthorizationGWTService_Proxy', 'getExplicitGlobalPermissions');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AuthorizationGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $processFailure(($clinit_PermissionsLoader() , 'Failed to load your global permissions - none granted.'), ex);
      callback.val$callback.onPermissionsLoaded(null);
    }
     else 
      throw $e0;
  }
}

function $hasResourcePermission(this$static, permission, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AuthorizationGWTService_Proxy', 'hasResourcePermission');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AuthorizationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.authz.Permission/1442357263'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.Collection'));
    $writeObject(streamWriter, permission);
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , BOOLEAN));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , ''), ex);
    }
     else 
      throw $e0;
  }
}

function AuthorizationGWTService_Proxy_0(){
  $clinit_AuthorizationGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '97DAA63222BEEB70E9E66CA000F01A8D', SERIALIZER_3);
}

defineSeed(2796, 2784, makeCastMap([Q$AuthorizationGWTServiceAsync]), AuthorizationGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_4(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_3;
function $clinit_AuthorizationGWTService_TypeSerializer(){
  $clinit_AuthorizationGWTService_TypeSerializer = nullMethod;
  methodMapNative_4 = loadMethodsNative_3();
  signatureMapNative_4 = loadSignaturesNative_3();
}

function AuthorizationGWTService_TypeSerializer_0(){
  $clinit_AuthorizationGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_4, signatureMapNative_4);
}

function loadMethodsNative_3(){
  var result = {};
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [undefined, undefined, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [undefined, undefined, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [undefined, undefined, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [undefined, undefined, serialize_21];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [undefined, undefined, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [undefined, undefined, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [undefined, undefined, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [undefined, undefined, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [undefined, undefined, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [undefined, undefined, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [undefined, undefined, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [undefined, undefined, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [undefined, undefined, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_3(){
  var result = [];
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2797, 278, {}, AuthorizationGWTService_TypeSerializer_0);
var methodMapNative_4 = null, signatureMapNative_4 = null;
function getInstance_35(){
  var target;
  if (!instance_6) {
    instance_6 = new AvailabilityGWTService_Proxy_0;
    target = instance_6;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'AvailabilityGWTService');
  }
  return instance_6;
}

var instance_6 = null;
function $clinit_AvailabilityGWTService_Proxy(){
  $clinit_AvailabilityGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_4 = new AvailabilityGWTService_TypeSerializer_0;
}

function $findAvailabilityByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AvailabilityGWTService_Proxy', 'findAvailabilityByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AvailabilityGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.AvailabilityCriteria/3345646773'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_46(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getAvailabilitiesForResource(this$static, resourceId, startTime, endTime, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AvailabilityGWTService_Proxy', 'getAvailabilitiesForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AvailabilityGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $append_3(streamWriter, toBase64(startTime));
    $append_3(streamWriter, toBase64(endTime));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load availability history'), ex);
    }
     else 
      throw $e0;
  }
}

function $getAvailabilitiesForResourceGroup(this$static, groupId, startTime, endTime, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'AvailabilityGWTService_Proxy', 'getAvailabilitiesForResourceGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.AvailabilityGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $append_3(streamWriter, toBase64(startTime));
    $append_3(streamWriter, toBase64(endTime));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load availability history'), ex);
    }
     else 
      throw $e0;
  }
}

function AvailabilityGWTService_Proxy_0(){
  $clinit_AvailabilityGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '14EF251A2F9C99E092A2701F01C3BA83', SERIALIZER_4);
}

defineSeed(2799, 2784, makeCastMap([Q$AvailabilityGWTServiceAsync]), AvailabilityGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_5(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_4;
function $clinit_AvailabilityGWTService_TypeSerializer(){
  $clinit_AvailabilityGWTService_TypeSerializer = nullMethod;
  methodMapNative_5 = loadMethodsNative_4();
  signatureMapNative_5 = loadSignaturesNative_4();
}

function AvailabilityGWTService_TypeSerializer_0(){
  $clinit_AvailabilityGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_5, signatureMapNative_5);
}

function loadMethodsNative_4(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.criteria.AvailabilityCriteria/3345646773'] = [undefined, undefined, serialize_192];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283, serialize_264];
  result['[Lorg.rhq.core.domain.measurement.AvailabilityType;/1336689976'] = [undefined, undefined, serialize_263];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.resource.group.composite.ResourceGroupAvailability/125016842'] = [instantiate_373, deserialize_385];
  result['[Lorg.rhq.core.domain.resource.group.composite.ResourceGroupAvailability;/699761013'] = [instantiate_372, deserialize_384];
  result['org.rhq.core.domain.resource.group.composite.ResourceGroupComposite$GroupAvailabilityType/2251015136'] = [instantiate_375, deserialize_387];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_4(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_AvailabilityCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.AvailabilityCriteria/3345646773';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = '[Lorg.rhq.core.domain.measurement.AvailabilityType;/1336689976';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_composite_ResourceGroupAvailability_2_classLit)] = 'org.rhq.core.domain.resource.group.composite.ResourceGroupAvailability/125016842';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_composite_ResourceGroupAvailability_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.composite.ResourceGroupAvailability;/699761013';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_composite_ResourceGroupComposite$GroupAvailabilityType_2_classLit)] = 'org.rhq.core.domain.resource.group.composite.ResourceGroupComposite$GroupAvailabilityType/2251015136';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2800, 278, {}, AvailabilityGWTService_TypeSerializer_0);
var methodMapNative_5 = null, signatureMapNative_5 = null;
function getInstance_36(){
  var target;
  if (!instance_7) {
    instance_7 = new BundleGWTService_Proxy_0;
    target = instance_7;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'BundleGWTService');
  }
  return instance_7;
}

var instance_7 = null;
function $clinit_BundleGWTService_Proxy(){
  $clinit_BundleGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_5 = new BundleGWTService_TypeSerializer_0;
}

function $createBundleDeployment(this$static, bundleVersionId, bundleDestinationId, description, configuration, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'createBundleDeployment');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 7);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.configuration.Configuration/25349161'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + bundleVersionId);
    append(streamWriter.encodeBuffer, '' + bundleDestinationId);
    $writeInt(streamWriter, $addString(streamWriter, description));
    $writeObject(streamWriter, configuration);
    append(streamWriter.encodeBuffer, '0');
    append(streamWriter.encodeBuffer, '-1');
    append(streamWriter.encodeBuffer, '0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_17(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $createBundleDestination(this$static, bundleId, name_0, description, destBaseDirName, deployDir, groupId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'createBundleDestination');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 6);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + bundleId);
    $writeInt(streamWriter, $addString(streamWriter, name_0));
    $writeInt(streamWriter, $addString(streamWriter, description));
    $writeInt(streamWriter, $addString(streamWriter, destBaseDirName));
    $writeInt(streamWriter, $addString(streamWriter, deployDir));
    append(streamWriter.encodeBuffer, '' + groupId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_19(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $createBundleVersionViaRecipe(this$static, recipe, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'createBundleVersionViaRecipe');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, recipe));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_16(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $createBundleVersionViaURL(this$static, url, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'createBundleVersionViaURL');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, url));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_15(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $deleteBundle(this$static, bundleId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'deleteBundle');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + bundleId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to delete the bundle [' + ($clinit_Enhanced() , callback.this$2.this$1.this$0.bundle.name_0) + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function $deleteBundleDeployment(this$static, bundleDeploymentId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'deleteBundleDeployment');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + bundleDeploymentId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $deleteBundleDestination(this$static, bundleDestinationId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'deleteBundleDestination');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + bundleDestinationId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $deleteBundleVersion(this$static, bundleVersionId, deleteBundleIfEmpty, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'deleteBundleVersion');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + bundleVersionId);
    append(streamWriter.encodeBuffer, deleteBundleIfEmpty?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $deleteBundles(this$static, bundleIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'deleteBundles');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, bundleIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_21(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $findBundleDeploymentsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'findBundleDeploymentsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.BundleDeploymentCriteria/649832797'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findBundleDeploymentsByCriteriaWithDestinationFilter(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'findBundleDeploymentsByCriteriaWithDestinationFilter');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.BundleDeploymentCriteria/649832797'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load bundle deployments'), ex);
    }
     else 
      throw $e0;
  }
}

function $findBundleDestinationsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'findBundleDestinationsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.BundleDestinationCriteria/2879473287'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findBundleFilesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'findBundleFilesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.BundleFileCriteria/358841356'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load bundle file data'), ex);
    }
     else 
      throw $e0;
  }
}

function $findBundleResourceDeploymentsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'findBundleResourceDeploymentsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.BundleResourceDeploymentCriteria/2936126416'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load bundle deployment'), ex);
    }
     else 
      throw $e0;
  }
}

function $findBundleVersionsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'findBundleVersionsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.BundleVersionCriteria/1757362460'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findBundleVersionsByCriteriaWithDestinationFilter(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'findBundleVersionsByCriteriaWithDestinationFilter');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.BundleVersionCriteria/1757362460'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load bundle version'), ex);
    }
     else 
      throw $e0;
  }
}

function $findBundlesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'findBundlesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.BundleCriteria/654282689'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findBundlesByCriteriaWithDestinationFilter(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'findBundlesByCriteriaWithDestinationFilter');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.BundleCriteria/654282689'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load bundle'), ex);
    }
     else 
      throw $e0;
  }
}

function $findBundlesWithLatestVersionCompositesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'findBundlesWithLatestVersionCompositesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.BundleCriteria/654282689'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_22(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getAllBundleTypes(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'getAllBundleTypes');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load Bundle data'), ex);
    }
     else 
      throw $e0;
  }
}

function $getAllBundleVersionFilenames(this$static, bundleVersionId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'getAllBundleVersionFilenames');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + bundleVersionId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.this$0.wizard.allBundleFilesStatus = null;
      $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Cannot obtain bundle file information from server'), ex);
    }
     else 
      throw $e0;
  }
}

function $getBundleDeploymentName(this$static, bundleDestinationId, bundleVersionId, prevDeploymentId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'getBundleDeploymentName');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + bundleDestinationId);
    append(streamWriter.encodeBuffer, '' + bundleVersionId);
    append(streamWriter.encodeBuffer, '' + prevDeploymentId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , STRING));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getResourceTypeBundleConfiguration_0(this$static, compatGroupId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'getResourceTypeBundleConfiguration');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + compatGroupId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $setDisabled_2(callback.this$0.destBaseDirItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
      $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to obtain bundle target information. Is the group you selected a valid compatible group that can be targeted for bundle deployments?'), ex);
    }
     else 
      throw $e0;
  }
}

function $purgeBundleDestination(this$static, bundleDestinationId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'purgeBundleDestination');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + bundleDestinationId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $scheduleBundleDeployment(this$static, bundleDeploymentId, isCleanDeployment, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'scheduleBundleDeployment');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + bundleDeploymentId);
    append(streamWriter.encodeBuffer, isCleanDeployment?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_18(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $scheduleRevertBundleDeployment(this$static, bundleDestinationId, deploymentDescription, isCleanDeployment, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'BundleGWTService_Proxy', 'scheduleRevertBundleDeployment');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + bundleDestinationId);
    $writeInt(streamWriter, $addString(streamWriter, deploymentDescription));
    append(streamWriter.encodeBuffer, isCleanDeployment?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_23(callback, ex);
    }
     else 
      throw $e0;
  }
}

function BundleGWTService_Proxy_0(){
  $clinit_BundleGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, 'F24CDFE1AB3532566ACC8405344503E8', SERIALIZER_5);
}

defineSeed(2802, 2784, makeCastMap([Q$BundleGWTServiceAsync]), BundleGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_6(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_5;
function $clinit_BundleGWTService_TypeSerializer(){
  $clinit_BundleGWTService_TypeSerializer = nullMethod;
  methodMapNative_6 = loadMethodsNative_5();
  signatureMapNative_6 = loadSignaturesNative_5();
}

function BundleGWTService_TypeSerializer_0(){
  $clinit_BundleGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_6, signatureMapNative_6);
}

function loadMethodsNative_5(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10, serialize_2];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['[I/2970817851'] = [undefined, undefined, serialize_3];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101, serialize_49];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93, serialize_40];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90, serialize_37];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91, serialize_38];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92, serialize_39];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97, serialize_44];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96, serialize_43];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98, serialize_45];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94, serialize_41];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95, serialize_42];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99, serialize_46];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100, serialize_48];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102, serialize_50];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106, serialize_54];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104, serialize_52];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103, serialize_51];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105, serialize_53];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107, serialize_55];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108, serialize_56];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110, serialize_59];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127, serialize_76];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113, serialize_62];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111, serialize_60];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112, serialize_61];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115, serialize_64];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114, serialize_63];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117, serialize_66];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116, serialize_65];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123, serialize_72];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120, serialize_69];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119, serialize_68];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121, serialize_70];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118, serialize_67];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122, serialize_71];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124, serialize_73];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126, serialize_75];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125, serialize_74];
  result['org.rhq.core.domain.bundle.ResourceTypeBundleConfiguration/527804968'] = [instantiate_125, deserialize_128];
  result['org.rhq.core.domain.bundle.composite.BundleWithLatestVersionComposite/2023741480'] = [instantiate_126, deserialize_129];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130, serialize_77];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141, serialize_83];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142, serialize_85];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140, serialize_82];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157, serialize_97];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162, serialize_102];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161, serialize_101];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163, serialize_103];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164, serialize_104];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173, serialize_113];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172, serialize_112];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174, serialize_116];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175, serialize_117];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176, serialize_118];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177, serialize_119];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183, serialize_125];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179, serialize_121];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178, serialize_120];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180, serialize_122];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181, serialize_123];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182, serialize_124];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184, serialize_126];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186, serialize_128];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187, serialize_129];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185, serialize_127];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188, serialize_130];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190, serialize_132];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191, serialize_133];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192, serialize_134];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193, serialize_135];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196, serialize_138];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195, serialize_137];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198, serialize_140];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197, serialize_139];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201, serialize_143];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199, serialize_141];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200, serialize_142];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203, serialize_144];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204, serialize_145];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205, serialize_146];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207, serialize_148];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206, serialize_147];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211, serialize_152];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209, serialize_150];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208, serialize_149];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210, serialize_151];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212, serialize_153];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214, serialize_155];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213, serialize_154];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215, serialize_156];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219, serialize_160];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218, serialize_159];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216, serialize_157];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217, serialize_158];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230, serialize_170];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221, serialize_162];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220, serialize_161];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222, serialize_163];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224, serialize_165];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223, serialize_164];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225, serialize_166];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229, serialize_169];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227, serialize_167];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231, serialize_171];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244, serialize_184];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232, serialize_172];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233, serialize_173];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234, serialize_174];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236, serialize_176];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235, serialize_175];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237, serialize_177];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239, serialize_179];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238, serialize_178];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240, serialize_180];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241, serialize_181];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243, serialize_183];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242, serialize_182];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245, serialize_185];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248, serialize_186];
  result['org.rhq.core.domain.criteria.BundleCriteria/654282689'] = [undefined, undefined, serialize_193];
  result['org.rhq.core.domain.criteria.BundleDeploymentCriteria/649832797'] = [undefined, undefined, serialize_194];
  result['org.rhq.core.domain.criteria.BundleDestinationCriteria/2879473287'] = [undefined, undefined, serialize_195];
  result['org.rhq.core.domain.criteria.BundleFileCriteria/358841356'] = [undefined, undefined, serialize_196];
  result['org.rhq.core.domain.criteria.BundleResourceDeploymentCriteria/2936126416'] = [undefined, undefined, serialize_197];
  result['org.rhq.core.domain.criteria.BundleVersionCriteria/1757362460'] = [undefined, undefined, serialize_198];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.GroupBundleDeploymentCriteria/901038520'] = [undefined, undefined, serialize_209];
  result['org.rhq.core.domain.criteria.ResourceBundleDeploymentCriteria/2286554824'] = [undefined, undefined, serialize_223];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252, serialize_239];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249, serialize_236];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250, serialize_237];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251, serialize_238];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255, serialize_243];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257, serialize_245];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260, serialize_247];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259, serialize_246];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278, serialize_261];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274, serialize_257];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276, serialize_259];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277, serialize_260];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285, serialize_266];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283, serialize_264];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284, serialize_265];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288, serialize_269];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289, serialize_270];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298, serialize_271];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300, serialize_273];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299, serialize_272];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302, serialize_275];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303, serialize_276];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312, serialize_278];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311, serialize_277];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314, serialize_279];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316, serialize_282];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318, serialize_284];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317, serialize_283];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337, serialize_291];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336, serialize_290];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339, serialize_292];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341, serialize_294];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340, serialize_293];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342, serialize_295];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344, serialize_297];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343, serialize_296];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345, serialize_298];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346, serialize_300];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348, serialize_301];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349, serialize_302];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360, serialize_314];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350, serialize_305];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351, serialize_306];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354, serialize_309];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352, serialize_307];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353, serialize_308];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356, serialize_311];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355, serialize_310];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358, serialize_312];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359, serialize_313];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375, serialize_318];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376, serialize_319];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378, serialize_320];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380, serialize_322];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379, serialize_321];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394, serialize_325];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395, serialize_326];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_5(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(_3I_classLit)] = '[I/2970817851';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_bundle_ResourceTypeBundleConfiguration_2_classLit)] = 'org.rhq.core.domain.bundle.ResourceTypeBundleConfiguration/527804968';
  result[getHashCode(Lorg_rhq_core_domain_bundle_composite_BundleWithLatestVersionComposite_2_classLit)] = 'org.rhq.core.domain.bundle.composite.BundleWithLatestVersionComposite/2023741480';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_BundleCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.BundleCriteria/654282689';
  result[getHashCode(Lorg_rhq_core_domain_criteria_BundleDeploymentCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.BundleDeploymentCriteria/649832797';
  result[getHashCode(Lorg_rhq_core_domain_criteria_BundleDestinationCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.BundleDestinationCriteria/2879473287';
  result[getHashCode(Lorg_rhq_core_domain_criteria_BundleFileCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.BundleFileCriteria/358841356';
  result[getHashCode(Lorg_rhq_core_domain_criteria_BundleResourceDeploymentCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.BundleResourceDeploymentCriteria/2936126416';
  result[getHashCode(Lorg_rhq_core_domain_criteria_BundleVersionCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.BundleVersionCriteria/1757362460';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_GroupBundleDeploymentCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.GroupBundleDeploymentCriteria/901038520';
  result[getHashCode(Lorg_rhq_core_domain_criteria_ResourceBundleDeploymentCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.ResourceBundleDeploymentCriteria/2286554824';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2803, 278, {}, BundleGWTService_TypeSerializer_0);
var methodMapNative_6 = null, signatureMapNative_6 = null;
function getInstance_37(){
  var target;
  if (!instance_8) {
    instance_8 = new ClusterGWTService_Proxy_0;
    target = instance_8;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'ClusterGWTService');
  }
  return instance_8;
}

var instance_8 = null;
function $clinit_ClusterGWTService_Proxy(){
  $clinit_ClusterGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_6 = new ClusterGWTService_TypeSerializer_0;
}

function $createAutoClusterBackingGroup(this$static, clusterKey, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ClusterGWTService_Proxy', 'createAutoClusterBackingGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ClusterGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.resource.group.ClusterKey/284855043'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    $writeObject(streamWriter, clusterKey);
    append(streamWriter.encodeBuffer, '1');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getClusterTree(this$static, groupId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ClusterGWTService_Proxy', 'getClusterTree');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ClusterGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load group tree'), ex);
    }
     else 
      throw $e0;
  }
}

function ClusterGWTService_Proxy_0(){
  $clinit_ClusterGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, 'A069EFC2247A2EAA009973FF58EF3D22', SERIALIZER_6);
}

defineSeed(2805, 2784, makeCastMap([Q$ClusterGWTServiceAsync]), ClusterGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_7(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_6;
function $clinit_ClusterGWTService_TypeSerializer(){
  $clinit_ClusterGWTService_TypeSerializer = nullMethod;
  methodMapNative_7 = loadMethodsNative_6();
  signatureMapNative_7 = loadSignaturesNative_6();
}

function ClusterGWTService_TypeSerializer_0(){
  $clinit_ClusterGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_7, signatureMapNative_7);
}

function loadMethodsNative_6(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.ClusterKey/284855043'] = [undefined, undefined, serialize_315];
  result['org.rhq.core.domain.resource.group.ClusterKey$Node/527960403'] = [undefined, undefined, serialize_317];
  result['[Lorg.rhq.core.domain.resource.group.ClusterKey$Node;/735975270'] = [undefined, undefined, serialize_316];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.resource.group.composite.ClusterFlyweight/3409214704'] = [instantiate_370, deserialize_382];
  result['[Lorg.rhq.core.domain.resource.group.composite.ClusterFlyweight;/223855301'] = [instantiate_369, deserialize_381];
  result['org.rhq.core.domain.resource.group.composite.ClusterKeyFlyweight/4120940818'] = [instantiate_371, deserialize_383];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_6(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ClusterKey_2_classLit)] = 'org.rhq.core.domain.resource.group.ClusterKey/284855043';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ClusterKey$Node_2_classLit)] = 'org.rhq.core.domain.resource.group.ClusterKey$Node/527960403';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ClusterKey$Node_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ClusterKey$Node;/735975270';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_composite_ClusterFlyweight_2_classLit)] = 'org.rhq.core.domain.resource.group.composite.ClusterFlyweight/3409214704';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_composite_ClusterFlyweight_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.composite.ClusterFlyweight;/223855301';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_composite_ClusterKeyFlyweight_2_classLit)] = 'org.rhq.core.domain.resource.group.composite.ClusterKeyFlyweight/4120940818';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2806, 278, {}, ClusterGWTService_TypeSerializer_0);
var methodMapNative_7 = null, signatureMapNative_7 = null;
var instance_9 = null;
function $clinit_ConfigurationGWTService_Proxy(){
  $clinit_ConfigurationGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_7 = new ConfigurationGWTService_TypeSerializer_0;
}

function $deleteGroupPluginConfigurationUpdate(this$static, groupId, groupPluginConfigUpdateIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'deleteGroupPluginConfigurationUpdate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Integer/3438268394'));
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeObject(streamWriter, groupId);
    $writeObject(streamWriter, groupPluginConfigUpdateIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $refreshTableInfo(callback.this$1.this$0);
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete group plugin config history'), ex);
    }
     else 
      throw $e0;
  }
}

function $deleteGroupResourceConfigurationUpdate(this$static, groupId, groupResourceConfigUpdateIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'deleteGroupResourceConfigurationUpdate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Integer/3438268394'));
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeObject(streamWriter, groupId);
    $writeObject(streamWriter, groupResourceConfigUpdateIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.this$1.this$0.refreshTableInfo();
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete group resource config history'), ex);
    }
     else 
      throw $e0;
  }
}

function $findGroupPluginConfigurationUpdatesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'findGroupPluginConfigurationUpdatesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.GroupPluginConfigurationUpdateCriteria/3204412634'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_34(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $findGroupResourceConfigurationUpdatesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'findGroupResourceConfigurationUpdatesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.GroupResourceConfigurationUpdateCriteria/3535256'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findPluginConfigurationUpdatesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'findPluginConfigurationUpdatesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.PluginConfigurationUpdateCriteria/3296821840'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findPluginConfigurationsForGroup(this$static, groupId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'findPluginConfigurationsForGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleLoadFailure_1(callback.this$0, ex);
    }
     else 
      throw $e0;
  }
}

function $findPluginConfigurationsForGroupUpdate(this$static, groupUpdateId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'findPluginConfigurationsForGroupUpdate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + groupUpdateId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleLoadFailure_2(callback.this$0, ex);
    }
     else 
      throw $e0;
  }
}

function $findResourceConfigurationUpdatesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'findResourceConfigurationUpdatesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.ResourceConfigurationUpdateCriteria/582950918'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findResourceConfigurationsForGroup(this$static, groupId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'findResourceConfigurationsForGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleLoadFailure(callback.this$0, ex);
    }
     else 
      throw $e0;
  }
}

function $findResourceConfigurationsForGroupUpdate(this$static, groupUpdateId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'findResourceConfigurationsForGroupUpdate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + groupUpdateId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleLoadFailure_0(callback.this$0, ex);
    }
     else 
      throw $e0;
  }
}

function $getLatestPluginConfigurationUpdate(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'getLatestPluginConfigurationUpdate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_43(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getLatestResourceConfigurationUpdate(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'getLatestResourceConfigurationUpdate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getOptionValuesForConfigDefinition(this$static, resourceId, definition, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'getOptionValuesForConfigDefinition');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, definition);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getPluginConfiguration(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'getPluginConfiguration');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $addMember(callback.this$0, new Label_4(ex.detailMessage));
      !!callback.this$0.loadHandler && (callback.this$0.loadHandler.this$0.refreshingConfigDef = false);
    }
     else 
      throw $e0;
  }
}

function $getResourceConfiguration(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'getResourceConfiguration');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $addMember(callback.this$0, new Label_4(ex.detailMessage));
      !!callback.this$0.loadHandler && (callback.this$0.loadHandler.this$0.refreshingConfigDef = false);
    }
     else 
      throw $e0;
  }
}

function $purgePluginConfigurationUpdates(this$static, configUpdateIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'purgePluginConfigurationUpdates');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    $writeObject(streamWriter, configUpdateIds);
    append(streamWriter.encodeBuffer, '1');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete the configuration history items.'), ex);
    }
     else 
      throw $e0;
  }
}

function $purgeResourceConfigurationUpdates(this$static, configUpdateIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'purgeResourceConfigurationUpdates');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    $writeObject(streamWriter, configUpdateIds);
    append(streamWriter.encodeBuffer, '1');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete the configuration history items.'), ex);
    }
     else 
      throw $e0;
  }
}

function $rollbackPluginConfiguration(this$static, resourceId, configHistoryId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'rollbackPluginConfiguration');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    append(streamWriter.encodeBuffer, '' + configHistoryId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to rollback the configuration. The original configuration is still in effect.'), ex);
    }
     else 
      throw $e0;
  }
}

function $rollbackResourceConfiguration(this$static, resourceId, configHistoryId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'rollbackResourceConfiguration');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    append(streamWriter.encodeBuffer, '' + configHistoryId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to rollback the configuration. The original configuration is still in effect.'), ex);
    }
     else 
      throw $e0;
  }
}

function $updatePluginConfiguration(this$static, resourceId, configuration, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'updatePluginConfiguration');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.configuration.Configuration/25349161'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, configuration);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update connection settings.'), ex);
    }
     else 
      throw $e0;
  }
}

function $updatePluginConfigurationsForGroup(this$static, groupId, pluginConfigurations, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'updatePluginConfigurationsForGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.List'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $writeObject(streamWriter, pluginConfigurations);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_33(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $updateResourceConfiguration(this$static, resourceId, configuration, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'updateResourceConfiguration');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.configuration.Configuration/25349161'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, configuration);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update configuration.'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateResourceConfigurationsForGroup(this$static, groupId, resourceConfigurations, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ConfigurationGWTService_Proxy', 'updateResourceConfigurationsForGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.List'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $writeObject(streamWriter, resourceConfigurations);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to initiate group configuration update for [' + ($clinit_Enhanced() , callback.this$0.group.resourceType.name_0) + '] compatible group named [' + callback.this$0.group.name_0 + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function ConfigurationGWTService_Proxy_0(){
  $clinit_ConfigurationGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), 'ConfigurationGWTService', '30B27910B5BBD26EF71D6E734CD3BA80', SERIALIZER_7);
}

defineSeed(2808, 2784, makeCastMap([Q$ConfigurationGWTServiceAsync]), ConfigurationGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_8(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_7;
function $clinit_ConfigurationGWTService_TypeSerializer(){
  $clinit_ConfigurationGWTService_TypeSerializer = nullMethod;
  methodMapNative_8 = loadMethodsNative_7();
  signatureMapNative_8 = loadSignaturesNative_7();
}

function ConfigurationGWTService_TypeSerializer_0(){
  $clinit_ConfigurationGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_8, signatureMapNative_8);
}

function loadMethodsNative_7(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['[I/2970817851'] = [undefined, undefined, serialize_3];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157, serialize_97];
  result['[Lorg.rhq.core.domain.configuration.ConfigurationUpdateStatus;/3363230809'] = [undefined, undefined, serialize_96];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163, serialize_103];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164, serialize_104];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.composite.ResourceConfigurationComposite/1131775248'] = [undefined, undefined, serialize_115];
  result['[Lorg.rhq.core.domain.configuration.composite.ResourceConfigurationComposite;/3718551307'] = [undefined, undefined, serialize_114];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174, serialize_116];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175, serialize_117];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176, serialize_118];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177, serialize_119];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183, serialize_125];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179, serialize_121];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178, serialize_120];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180, serialize_122];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181, serialize_123];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182, serialize_124];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184, serialize_126];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186, serialize_128];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187, serialize_129];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185, serialize_127];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188, serialize_130];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190, serialize_132];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191, serialize_133];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192, serialize_134];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.GroupPluginConfigurationUpdateCriteria/3204412634'] = [undefined, undefined, serialize_211];
  result['org.rhq.core.domain.criteria.GroupResourceConfigurationUpdateCriteria/3535256'] = [undefined, undefined, serialize_212];
  result['org.rhq.core.domain.criteria.PluginConfigurationUpdateCriteria/3296821840'] = [undefined, undefined, serialize_221];
  result['org.rhq.core.domain.criteria.ResourceConfigurationUpdateCriteria/582950918'] = [undefined, undefined, serialize_224];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_7(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(_3I_classLit)] = '[I/2970817851';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ConfigurationUpdateStatus;/3363230809';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_composite_ResourceConfigurationComposite_2_classLit)] = 'org.rhq.core.domain.configuration.composite.ResourceConfigurationComposite/1131775248';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_composite_ResourceConfigurationComposite_2_classLit)] = '[Lorg.rhq.core.domain.configuration.composite.ResourceConfigurationComposite;/3718551307';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_GroupPluginConfigurationUpdateCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.GroupPluginConfigurationUpdateCriteria/3204412634';
  result[getHashCode(Lorg_rhq_core_domain_criteria_GroupResourceConfigurationUpdateCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.GroupResourceConfigurationUpdateCriteria/3535256';
  result[getHashCode(Lorg_rhq_core_domain_criteria_PluginConfigurationUpdateCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.PluginConfigurationUpdateCriteria/3296821840';
  result[getHashCode(Lorg_rhq_core_domain_criteria_ResourceConfigurationUpdateCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.ResourceConfigurationUpdateCriteria/582950918';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2809, 278, {}, ConfigurationGWTService_TypeSerializer_0);
var methodMapNative_8 = null, signatureMapNative_8 = null;
function getInstance_38(){
  var target;
  if (!instance_10) {
    instance_10 = new ContentGWTService_Proxy_0;
    target = instance_10;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'ContentGWTService');
  }
  return instance_10;
}

var instance_10 = null;
function $clinit_ContentGWTService_Proxy(){
  $clinit_ContentGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_8 = new ContentGWTService_TypeSerializer_0;
}

function $deletePackageVersion(this$static, packageVersionId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ContentGWTService_Proxy', 'deletePackageVersion');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + packageVersionId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to delete package version while canceling a resource create'), ex);
    }
     else 
      throw $e0;
  }
}

function $findInstalledPackageHistoryByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ContentGWTService_Proxy', 'findInstalledPackageHistoryByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.InstalledPackageHistoryCriteria/3879851239'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findPackageType(this$static, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ContentGWTService_Proxy', 'findPackageType');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Integer/3438268394'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeObject(streamWriter, null);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.enterprise.server.plugins.packagetypeCli.SERVER_SIDE_CLI_SCRIPT'));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Loading the CLI Notification Editor Failed.'), ex);
    }
     else 
      throw $e0;
  }
}

function $findPackagesWithLatestVersion(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ContentGWTService_Proxy', 'findPackagesWithLatestVersion');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.PackageCriteria/1038117323'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getArchitectures(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ContentGWTService_Proxy', 'getArchitectures');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to get available Architectures'), ex);
    }
     else 
      throw $e0;
  }
}

function $getResourceCreationPackageType(this$static, resourceTypeId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ContentGWTService_Proxy', 'getResourceCreationPackageType');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceTypeId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to get backing package type for new resource'), ex);
    }
     else 
      throw $e0;
  }
}

function ContentGWTService_Proxy_0(){
  $clinit_ContentGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '70800FC01319BF43D31E0FBF0BCDA5A6', SERIALIZER_8);
}

defineSeed(2811, 2784, makeCastMap([Q$ContentGWTServiceAsync]), ContentGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_9(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_8;
function $clinit_ContentGWTService_TypeSerializer(){
  $clinit_ContentGWTService_TypeSerializer = nullMethod;
  methodMapNative_9 = loadMethodsNative_8();
  signatureMapNative_9 = loadSignaturesNative_8();
}

function ContentGWTService_TypeSerializer_0(){
  $clinit_ContentGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_9, signatureMapNative_9);
}

function loadMethodsNative_8(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['[Lorg.rhq.core.domain.content.Architecture;/569585905'] = [instantiate_195, deserialize_202];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['org.rhq.core.domain.content.PackageVersionFormatDescription/564445988'] = [instantiate_219, deserialize_226];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.composite.PackageAndLatestVersionComposite/3483568952'] = [instantiate_239, deserialize_246];
  result['org.rhq.core.domain.content.composite.PackageTypeAndVersionFormatComposite/1820132875'] = [instantiate_240, deserialize_247];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.InstalledPackageHistoryCriteria/3879851239'] = [undefined, undefined, serialize_213];
  result['org.rhq.core.domain.criteria.PackageCriteria/1038117323'] = [undefined, undefined, serialize_218];
  result['org.rhq.core.domain.criteria.PackageVersionCriteria/1522997568'] = [undefined, undefined, serialize_219];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_8(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(_3Lorg_rhq_core_domain_content_Architecture_2_classLit)] = '[Lorg.rhq.core.domain.content.Architecture;/569585905';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersionFormatDescription_2_classLit)] = 'org.rhq.core.domain.content.PackageVersionFormatDescription/564445988';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_composite_PackageAndLatestVersionComposite_2_classLit)] = 'org.rhq.core.domain.content.composite.PackageAndLatestVersionComposite/3483568952';
  result[getHashCode(Lorg_rhq_core_domain_content_composite_PackageTypeAndVersionFormatComposite_2_classLit)] = 'org.rhq.core.domain.content.composite.PackageTypeAndVersionFormatComposite/1820132875';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_InstalledPackageHistoryCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.InstalledPackageHistoryCriteria/3879851239';
  result[getHashCode(Lorg_rhq_core_domain_criteria_PackageCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.PackageCriteria/1038117323';
  result[getHashCode(Lorg_rhq_core_domain_criteria_PackageVersionCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.PackageVersionCriteria/1522997568';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2812, 278, {}, ContentGWTService_TypeSerializer_0);
var methodMapNative_9 = null, signatureMapNative_9 = null;
function getInstance_39(){
  var target;
  if (!instance_11) {
    instance_11 = new DashboardGWTService_Proxy_0;
    target = instance_11;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'DashboardGWTService');
  }
  return instance_11;
}

var instance_11 = null;
function $clinit_DashboardGWTService_Proxy(){
  $clinit_DashboardGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_9 = new DashboardGWTService_TypeSerializer_0;
}

function $findDashboardsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DashboardGWTService_Proxy', 'findDashboardsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DashboardGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.DashboardCriteria/3886298650'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $removeDashboard(this$static, dashboardId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DashboardGWTService_Proxy', 'removeDashboard');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DashboardGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + dashboardId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete dashboard.'), ex);
    }
     else 
      throw $e0;
  }
}

function $storeDashboard(this$static, dashboard, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DashboardGWTService_Proxy', 'storeDashboard');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DashboardGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.dashboard.Dashboard/3980701481'));
    $writeObject(streamWriter, dashboard);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function DashboardGWTService_Proxy_0(){
  $clinit_DashboardGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '336A04BC279AF8A1E7FC76783C0D5359', SERIALIZER_9);
}

defineSeed(2814, 2784, makeCastMap([Q$DashboardGWTServiceAsync]), DashboardGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_10(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_9;
function $clinit_DashboardGWTService_TypeSerializer(){
  $clinit_DashboardGWTService_TypeSerializer = nullMethod;
  methodMapNative_10 = loadMethodsNative_9();
  signatureMapNative_10 = loadSignaturesNative_9();
}

function DashboardGWTService_TypeSerializer_0(){
  $clinit_DashboardGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_10, signatureMapNative_10);
}

function loadMethodsNative_9(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10, serialize_2];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101, serialize_49];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93, serialize_40];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90, serialize_37];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91, serialize_38];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92, serialize_39];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97, serialize_44];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96, serialize_43];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98, serialize_45];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94, serialize_41];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95, serialize_42];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99, serialize_46];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100, serialize_48];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102, serialize_50];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106, serialize_54];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104, serialize_52];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103, serialize_51];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105, serialize_53];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107, serialize_55];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108, serialize_56];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110, serialize_59];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127, serialize_76];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113, serialize_62];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111, serialize_60];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112, serialize_61];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115, serialize_64];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114, serialize_63];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117, serialize_66];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116, serialize_65];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123, serialize_72];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120, serialize_69];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119, serialize_68];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121, serialize_70];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118, serialize_67];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122, serialize_71];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124, serialize_73];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126, serialize_75];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125, serialize_74];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130, serialize_77];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141, serialize_83];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142, serialize_85];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140, serialize_82];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157, serialize_97];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162, serialize_102];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161, serialize_101];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163, serialize_103];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164, serialize_104];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173, serialize_113];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172, serialize_112];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174, serialize_116];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175, serialize_117];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176, serialize_118];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177, serialize_119];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183, serialize_125];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179, serialize_121];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178, serialize_120];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180, serialize_122];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181, serialize_123];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182, serialize_124];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184, serialize_126];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186, serialize_128];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187, serialize_129];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185, serialize_127];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188, serialize_130];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190, serialize_132];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191, serialize_133];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192, serialize_134];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193, serialize_135];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196, serialize_138];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195, serialize_137];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198, serialize_140];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197, serialize_139];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201, serialize_143];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199, serialize_141];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200, serialize_142];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203, serialize_144];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204, serialize_145];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205, serialize_146];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207, serialize_148];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206, serialize_147];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211, serialize_152];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209, serialize_150];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208, serialize_149];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210, serialize_151];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212, serialize_153];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214, serialize_155];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213, serialize_154];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215, serialize_156];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219, serialize_160];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218, serialize_159];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216, serialize_157];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217, serialize_158];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230, serialize_170];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221, serialize_162];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220, serialize_161];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222, serialize_163];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224, serialize_165];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223, serialize_164];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225, serialize_166];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229, serialize_169];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227, serialize_167];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231, serialize_171];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244, serialize_184];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232, serialize_172];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233, serialize_173];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234, serialize_174];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236, serialize_176];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235, serialize_175];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237, serialize_177];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239, serialize_179];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238, serialize_178];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240, serialize_180];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241, serialize_181];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243, serialize_183];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242, serialize_182];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245, serialize_185];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248, serialize_186];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.DashboardCriteria/3886298650'] = [undefined, undefined, serialize_203];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252, serialize_239];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249, serialize_236];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250, serialize_237];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251, serialize_238];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255, serialize_243];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257, serialize_245];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260, serialize_247];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259, serialize_246];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278, serialize_261];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274, serialize_257];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276, serialize_259];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277, serialize_260];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285, serialize_266];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283, serialize_264];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284, serialize_265];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288, serialize_269];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289, serialize_270];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298, serialize_271];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300, serialize_273];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299, serialize_272];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302, serialize_275];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303, serialize_276];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312, serialize_278];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311, serialize_277];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314, serialize_279];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316, serialize_282];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318, serialize_284];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317, serialize_283];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337, serialize_291];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336, serialize_290];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339, serialize_292];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341, serialize_294];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340, serialize_293];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342, serialize_295];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344, serialize_297];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343, serialize_296];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345, serialize_298];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346, serialize_300];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348, serialize_301];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349, serialize_302];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360, serialize_314];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350, serialize_305];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351, serialize_306];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354, serialize_309];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352, serialize_307];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353, serialize_308];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356, serialize_311];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355, serialize_310];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358, serialize_312];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359, serialize_313];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375, serialize_318];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376, serialize_319];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378, serialize_320];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380, serialize_322];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379, serialize_321];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394, serialize_325];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395, serialize_326];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_9(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_DashboardCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.DashboardCriteria/3886298650';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2815, 278, {}, DashboardGWTService_TypeSerializer_0);
var methodMapNative_10 = null, signatureMapNative_10 = null;
function getInstance_40(){
  var target;
  if (!instance_12) {
    instance_12 = new DriftGWTService_Proxy_0;
    target = instance_12;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'DriftGWTService');
  }
  return instance_12;
}

var instance_12 = null;
function $clinit_DriftGWTService_Proxy(){
  $clinit_DriftGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_10 = new DriftGWTService_TypeSerializer_0;
}

function $createTemplate(this$static, resourceTypeId, definition, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'createTemplate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.drift.DriftDefinition/1887203450'));
    append(streamWriter.encodeBuffer, '' + resourceTypeId);
    $writeObject(streamWriter, definition);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $deleteDriftDefinitionTemplates(this$static, templateIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'deleteDriftDefinitionTemplates');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, templateIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete some or all of the drift templates'), ex);
      $refresh(callback.this$0, false);
    }
     else 
      throw $e0;
  }
}

function $deleteDriftDefinitionsByContext(this$static, entityContext, driftDefNames, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'deleteDriftDefinitionsByContext');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.common.EntityContext/926996548'));
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.String;/2600011424'));
    $writeObject(streamWriter, entityContext);
    $writeObject(streamWriter, driftDefNames);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete some or all drift detection definitions.'), ex);
    }
     else 
      throw $e0;
  }
}

function $detectDrift_0(this$static, entityContext, driftDef, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'detectDrift');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.common.EntityContext/926996548'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.drift.DriftDefinition/1887203450'));
    $writeObject(streamWriter, entityContext);
    $writeObject(streamWriter, driftDef);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to submit drift detection run request'), ex);
    }
     else 
      throw $e0;
  }
}

function $findDriftChangeSetsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'findDriftChangeSetsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.GenericDriftChangeSetCriteria/3575268834'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to fetch drift instances'), ex);
    }
     else 
      throw $e0;
  }
}

function $findDriftCompositesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'findDriftCompositesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.GenericDriftCriteria/446789380'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_25(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $findDriftDefinitionCompositesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'findDriftDefinitionCompositesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.DriftDefinitionCriteria/3248977610'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_26(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $findDriftDefinitionTemplatesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'findDriftDefinitionTemplatesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.DriftDefinitionTemplateCriteria/845498263'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findDriftDefinitionsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'findDriftDefinitionsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.DriftDefinitionCriteria/3248977610'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $generateUnifiedDiff(this$static, drift, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'generateUnifiedDiff');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.drift.Drift'));
    $writeObject(streamWriter, drift);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to generate diff.'), ex);
    }
     else 
      throw $e0;
  }
}

function $generateUnifiedDiffByIds(this$static, driftId1, driftId2, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'generateUnifiedDiffByIds');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, driftId1));
    $writeInt(streamWriter, $addString(streamWriter, driftId2));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to generate diff.'), ex);
    }
     else 
      throw $e0;
  }
}

function $getDriftDefinition(this$static, driftDefId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'getDriftDefinition');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + driftDefId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.this$0.refreshing = false;
      $handleError_0(($clinit_CoreGUI() , 'Failed to load definition.'), ex);
    }
     else 
      throw $e0;
  }
}

function $getDriftDetails(this$static, driftId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'getDriftDetails');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, driftId));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to load drift details for drift id: ' + callback.val$driftId), ex);
    }
     else 
      throw $e0;
  }
}

function $getDriftFileBits(this$static, hash, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'getDriftFileBits');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, hash));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , STRING));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_27(ex);
    }
     else 
      throw $e0;
  }
}

function $getSnapshot(this$static, request, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'getSnapshot');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.drift.DriftSnapshotRequest/168171479'));
    $writeObject(streamWriter, request);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $pinSnapshot(this$static, driftDefId, version, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'pinSnapshot');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + driftDefId);
    append(streamWriter.encodeBuffer, '' + version);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to pin snapshot to definition'), ex);
    }
     else 
      throw $e0;
  }
}

function $pinTemplate_0(this$static, templateId, snapshotDriftDefId, snapshotVersion, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'pinTemplate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + templateId);
    append(streamWriter.encodeBuffer, '' + snapshotDriftDefId);
    append(streamWriter.encodeBuffer, '' + snapshotVersion);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to pin snapshot to drift template [' + ($clinit_Wizard() , callback.val$template.name_0) + ']'), ex);
      $closeDialog(callback.this$0.view);
    }
     else 
      throw $e0;
  }
}

function $updateDriftDefinition(this$static, entityContext, driftDef, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'updateDriftDefinition');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.common.EntityContext/926996548'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.drift.DriftDefinition/1887203450'));
    $writeObject(streamWriter, entityContext);
    $writeObject(streamWriter, driftDef);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $updateTemplate(this$static, template, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'DriftGWTService_Proxy', 'updateTemplate');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'));
    $writeObject(streamWriter, template);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update configuration.'), ex);
    }
     else 
      throw $e0;
  }
}

function DriftGWTService_Proxy_0(){
  $clinit_DriftGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, 'B03CE019DD862D8007F4241024845C00', SERIALIZER_10);
}

defineSeed(2817, 2784, makeCastMap([Q$DriftGWTServiceAsync]), DriftGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_11(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_10;
function $clinit_DriftGWTService_TypeSerializer(){
  $clinit_DriftGWTService_TypeSerializer = nullMethod;
  methodMapNative_11 = loadMethodsNative_10();
  signatureMapNative_11 = loadSignaturesNative_10();
}

function DriftGWTService_TypeSerializer_0(){
  $clinit_DriftGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_11, signatureMapNative_11);
}

function loadMethodsNative_10(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10, serialize_2];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['[I/2970817851'] = [undefined, undefined, serialize_3];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [instantiate_34, deserialize_35, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101, serialize_49];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93, serialize_40];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90, serialize_37];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91, serialize_38];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92, serialize_39];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97, serialize_44];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96, serialize_43];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98, serialize_45];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94, serialize_41];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95, serialize_42];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99, serialize_46];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100, serialize_48];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102, serialize_50];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106, serialize_54];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104, serialize_52];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103, serialize_51];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105, serialize_53];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107, serialize_55];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108, serialize_56];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110, serialize_59];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127, serialize_76];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113, serialize_62];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111, serialize_60];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112, serialize_61];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115, serialize_64];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114, serialize_63];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117, serialize_66];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116, serialize_65];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123, serialize_72];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120, serialize_69];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119, serialize_68];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121, serialize_70];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118, serialize_67];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122, serialize_71];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124, serialize_73];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126, serialize_75];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125, serialize_74];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130, serialize_77];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141, serialize_83];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142, serialize_85];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140, serialize_82];
  result['org.rhq.core.domain.common.EntityContext/926996548'] = [undefined, undefined, serialize_86];
  result['org.rhq.core.domain.common.EntityContext$Type/3658574791'] = [undefined, undefined, serialize_87];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157, serialize_97];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162, serialize_102];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161, serialize_101];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163, serialize_103];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164, serialize_104];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173, serialize_113];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172, serialize_112];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174, serialize_116];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175, serialize_117];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176, serialize_118];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177, serialize_119];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183, serialize_125];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179, serialize_121];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178, serialize_120];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180, serialize_122];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181, serialize_123];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182, serialize_124];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184, serialize_126];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186, serialize_128];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187, serialize_129];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185, serialize_127];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188, serialize_130];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190, serialize_132];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191, serialize_133];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192, serialize_134];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193, serialize_135];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196, serialize_138];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195, serialize_137];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198, serialize_140];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197, serialize_139];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201, serialize_143];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199, serialize_141];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200, serialize_142];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203, serialize_144];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204, serialize_145];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205, serialize_146];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207, serialize_148];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206, serialize_147];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211, serialize_152];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209, serialize_150];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208, serialize_149];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210, serialize_151];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212, serialize_153];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214, serialize_155];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213, serialize_154];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215, serialize_156];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219, serialize_160];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218, serialize_159];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216, serialize_157];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217, serialize_158];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230, serialize_170];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221, serialize_162];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220, serialize_161];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222, serialize_163];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224, serialize_165];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223, serialize_164];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225, serialize_166];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229, serialize_169];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227, serialize_167];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231, serialize_171];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244, serialize_184];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232, serialize_172];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233, serialize_173];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234, serialize_174];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236, serialize_176];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235, serialize_175];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237, serialize_177];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239, serialize_179];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238, serialize_178];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240, serialize_180];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241, serialize_181];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243, serialize_183];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242, serialize_182];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245, serialize_185];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248, serialize_186];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.DriftDefinitionCriteria/3248977610'] = [undefined, undefined, serialize_204];
  result['org.rhq.core.domain.criteria.DriftDefinitionTemplateCriteria/845498263'] = [undefined, undefined, serialize_205];
  result['org.rhq.core.domain.criteria.GenericDriftChangeSetCriteria/3575268834'] = [undefined, undefined, serialize_207];
  result['org.rhq.core.domain.criteria.GenericDriftCriteria/446789380'] = [undefined, undefined, serialize_208];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252, serialize_239];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249, serialize_236];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250, serialize_237];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251, serialize_238];
  result['org.rhq.core.domain.drift.DriftCategory/3526084878'] = [instantiate_246, deserialize_253, serialize_241];
  result['[Lorg.rhq.core.domain.drift.DriftCategory;/464327993'] = [undefined, undefined, serialize_240];
  result['org.rhq.core.domain.drift.DriftChangeSetCategory/3856895208'] = [instantiate_247, deserialize_254, serialize_242];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255, serialize_243];
  result['org.rhq.core.domain.drift.DriftComposite/2372331912'] = [instantiate_249, deserialize_256];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257, serialize_245];
  result['[Lorg.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode;/129680908'] = [undefined, undefined, serialize_244];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260, serialize_247];
  result['org.rhq.core.domain.drift.DriftDefinitionComposite/3963010211'] = [instantiate_251, deserialize_258];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259, serialize_246];
  result['org.rhq.core.domain.drift.DriftDetails/21996674'] = [instantiate_254, deserialize_261];
  result['org.rhq.core.domain.drift.DriftFileStatus/547019127'] = [instantiate_255, deserialize_262, serialize_248];
  result['org.rhq.core.domain.drift.DriftSnapshot/1177612124'] = [instantiate_258, deserialize_265];
  result['org.rhq.core.domain.drift.DriftSnapshot$DriftSnapshotDirectory/788385483'] = [instantiate_257, deserialize_264];
  result['org.rhq.core.domain.drift.DriftSnapshotRequest/168171479'] = [instantiate_256, deserialize_263, serialize_249];
  result['org.rhq.core.domain.drift.FileDiffReport/2759842798'] = [instantiate_259, deserialize_266];
  result['org.rhq.core.domain.drift.JPADrift/3446820390'] = [instantiate_263, deserialize_270, serialize_253];
  result['org.rhq.core.domain.drift.JPADriftChangeSet/888530665'] = [instantiate_260, deserialize_267, serialize_250];
  result['org.rhq.core.domain.drift.JPADriftFile/2316786439'] = [instantiate_261, deserialize_268, serialize_251];
  result['org.rhq.core.domain.drift.JPADriftSet/1219785512'] = [instantiate_262, deserialize_269, serialize_252];
  result['org.rhq.core.domain.drift.dto.DriftChangeSetDTO/2697966831'] = [instantiate_264, deserialize_271, serialize_254];
  result['org.rhq.core.domain.drift.dto.DriftDTO/2282150828'] = [instantiate_265, deserialize_272, serialize_255];
  result['org.rhq.core.domain.drift.dto.DriftFileDTO/2782298116'] = [instantiate_266, deserialize_273, serialize_256];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278, serialize_261];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274, serialize_257];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276, serialize_259];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277, serialize_260];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285, serialize_266];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283, serialize_264];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284, serialize_265];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288, serialize_269];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289, serialize_270];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298, serialize_271];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300, serialize_273];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299, serialize_272];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302, serialize_275];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303, serialize_276];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312, serialize_278];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311, serialize_277];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314, serialize_279];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316, serialize_282];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318, serialize_284];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317, serialize_283];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337, serialize_291];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336, serialize_290];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339, serialize_292];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341, serialize_294];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340, serialize_293];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342, serialize_295];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344, serialize_297];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343, serialize_296];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345, serialize_298];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346, serialize_300];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348, serialize_301];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349, serialize_302];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360, serialize_314];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350, serialize_305];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351, serialize_306];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354, serialize_309];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352, serialize_307];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353, serialize_308];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356, serialize_311];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355, serialize_310];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358, serialize_312];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359, serialize_313];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375, serialize_318];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376, serialize_319];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378, serialize_320];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380, serialize_322];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379, serialize_321];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394, serialize_325];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395, serialize_326];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_10(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(_3I_classLit)] = '[I/2970817851';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_common_EntityContext_2_classLit)] = 'org.rhq.core.domain.common.EntityContext/926996548';
  result[getHashCode(Lorg_rhq_core_domain_common_EntityContext$Type_2_classLit)] = 'org.rhq.core.domain.common.EntityContext$Type/3658574791';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_DriftDefinitionCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.DriftDefinitionCriteria/3248977610';
  result[getHashCode(Lorg_rhq_core_domain_criteria_DriftDefinitionTemplateCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.DriftDefinitionTemplateCriteria/845498263';
  result[getHashCode(Lorg_rhq_core_domain_criteria_GenericDriftChangeSetCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.GenericDriftChangeSetCriteria/3575268834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_GenericDriftCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.GenericDriftCriteria/446789380';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftCategory_2_classLit)] = 'org.rhq.core.domain.drift.DriftCategory/3526084878';
  result[getHashCode(_3Lorg_rhq_core_domain_drift_DriftCategory_2_classLit)] = '[Lorg.rhq.core.domain.drift.DriftCategory;/464327993';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftChangeSetCategory_2_classLit)] = 'org.rhq.core.domain.drift.DriftChangeSetCategory/3856895208';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComposite_2_classLit)] = 'org.rhq.core.domain.drift.DriftComposite/2372331912';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(_3Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = '[Lorg.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode;/129680908';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionComposite_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionComposite/3963010211';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDetails_2_classLit)] = 'org.rhq.core.domain.drift.DriftDetails/21996674';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftFileStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftFileStatus/547019127';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftSnapshot_2_classLit)] = 'org.rhq.core.domain.drift.DriftSnapshot/1177612124';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftSnapshot$DriftSnapshotDirectory_2_classLit)] = 'org.rhq.core.domain.drift.DriftSnapshot$DriftSnapshotDirectory/788385483';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftSnapshotRequest_2_classLit)] = 'org.rhq.core.domain.drift.DriftSnapshotRequest/168171479';
  result[getHashCode(Lorg_rhq_core_domain_drift_FileDiffReport_2_classLit)] = 'org.rhq.core.domain.drift.FileDiffReport/2759842798';
  result[getHashCode(Lorg_rhq_core_domain_drift_JPADrift_2_classLit)] = 'org.rhq.core.domain.drift.JPADrift/3446820390';
  result[getHashCode(Lorg_rhq_core_domain_drift_JPADriftChangeSet_2_classLit)] = 'org.rhq.core.domain.drift.JPADriftChangeSet/888530665';
  result[getHashCode(Lorg_rhq_core_domain_drift_JPADriftFile_2_classLit)] = 'org.rhq.core.domain.drift.JPADriftFile/2316786439';
  result[getHashCode(Lorg_rhq_core_domain_drift_JPADriftSet_2_classLit)] = 'org.rhq.core.domain.drift.JPADriftSet/1219785512';
  result[getHashCode(Lorg_rhq_core_domain_drift_dto_DriftChangeSetDTO_2_classLit)] = 'org.rhq.core.domain.drift.dto.DriftChangeSetDTO/2697966831';
  result[getHashCode(Lorg_rhq_core_domain_drift_dto_DriftDTO_2_classLit)] = 'org.rhq.core.domain.drift.dto.DriftDTO/2282150828';
  result[getHashCode(Lorg_rhq_core_domain_drift_dto_DriftFileDTO_2_classLit)] = 'org.rhq.core.domain.drift.dto.DriftFileDTO/2782298116';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2818, 278, {}, DriftGWTService_TypeSerializer_0);
var methodMapNative_11 = null, signatureMapNative_11 = null;
function getInstance_41(){
  var target;
  if (!instance_13) {
    instance_13 = new EventGWTService_Proxy_0;
    target = instance_13;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'EventGWTService');
  }
  return instance_13;
}

var instance_13 = null;
function $clinit_EventGWTService_Proxy(){
  $clinit_EventGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_11 = new EventGWTService_TypeSerializer_0;
}

function $deleteEventsForContext(this$static, context, eventIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'EventGWTService_Proxy', 'deleteEventsForContext');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.common.EntityContext/926996548'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.List'));
    $writeObject(streamWriter, context);
    $writeObject(streamWriter, eventIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to deleted selected events for [' + ($clinit_Enhanced() , $toShortString(callback.this$0.context)) + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function $findEventCompositesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'EventGWTService_Proxy', 'findEventCompositesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.EventCriteria/60598809'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getEventCountsBySeverity(this$static, resourceId, startDate, endDate, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'EventGWTService_Proxy', 'getEventCountsBySeverity');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $append_3(streamWriter, toBase64(startDate));
    $append_3(streamWriter, toBase64(endDate));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      debug('Error retrieving event counts for resource [' + callback.val$resourceId + ']:' + ex.detailMessage);
      callback.this$0.currentlyLoading = false;
    }
     else 
      throw $e0;
  }
}

function $getEventCountsBySeverityForGroup(this$static, groupId, startDate, endDate, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'EventGWTService_Proxy', 'getEventCountsBySeverityForGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $append_3(streamWriter, toBase64(startDate));
    $append_3(streamWriter, toBase64(endDate));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      debug('Error retrieving recent event counts for group [' + callback.val$groupId + ']:' + ex.detailMessage);
      callback.this$0.currentlyLoading = false;
    }
     else 
      throw $e0;
  }
}

function $purgeEventsForContext(this$static, context, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'EventGWTService_Proxy', 'purgeEventsForContext');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.common.EntityContext/926996548'));
    $writeObject(streamWriter, context);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to purge events for [' + ($clinit_Enhanced() , $toShortString(callback.this$0.context)) + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function EventGWTService_Proxy_0(){
  $clinit_EventGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '81CCFEEE63C4B42A01382EC2B12EFD3D', SERIALIZER_11);
}

defineSeed(2820, 2784, makeCastMap([Q$EventGWTServiceAsync]), EventGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_12(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_11;
function $clinit_EventGWTService_TypeSerializer(){
  $clinit_EventGWTService_TypeSerializer = nullMethod;
  methodMapNative_12 = loadMethodsNative_11();
  signatureMapNative_12 = loadSignaturesNative_11();
}

function EventGWTService_TypeSerializer_0(){
  $clinit_EventGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_12, signatureMapNative_12);
}

function loadMethodsNative_11(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [instantiate_25, deserialize_25, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.EnumMap/1826390227'] = [instantiate_58, deserialize_60];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.common.EntityContext/926996548'] = [undefined, undefined, serialize_86];
  result['org.rhq.core.domain.common.EntityContext$Type/3658574791'] = [undefined, undefined, serialize_87];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.EventCriteria/60598809'] = [undefined, undefined, serialize_206];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276, serialize_259];
  result['[Lorg.rhq.core.domain.event.EventSeverity;/1526761261'] = [instantiate_268, deserialize_275, serialize_258];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.event.composite.EventComposite/3910050309'] = [instantiate_272, deserialize_279];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_11(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_EnumMap_2_classLit)] = 'java.util.EnumMap/1826390227';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_common_EntityContext_2_classLit)] = 'org.rhq.core.domain.common.EntityContext/926996548';
  result[getHashCode(Lorg_rhq_core_domain_common_EntityContext$Type_2_classLit)] = 'org.rhq.core.domain.common.EntityContext$Type/3658574791';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_EventCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.EventCriteria/60598809';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(_3Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = '[Lorg.rhq.core.domain.event.EventSeverity;/1526761261';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_event_composite_EventComposite_2_classLit)] = 'org.rhq.core.domain.event.composite.EventComposite/3910050309';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2821, 278, {}, EventGWTService_TypeSerializer_0);
var methodMapNative_12 = null, signatureMapNative_12 = null;
function getInstance_42(){
  var target;
  if (!instance_14) {
    instance_14 = new GroupAlertDefinitionGWTService_Proxy_0;
    target = instance_14;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'GroupAlertDefinitionGWTService');
  }
  return instance_14;
}

var instance_14 = null;
function $clinit_GroupAlertDefinitionGWTService_Proxy(){
  $clinit_GroupAlertDefinitionGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_12 = new GroupAlertDefinitionGWTService_TypeSerializer_0;
}

function $createGroupAlertDefinitions(this$static, groupAlertDefinition, resourceGroupId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'GroupAlertDefinitionGWTService_Proxy', 'createGroupAlertDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.GroupAlertDefinitionGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.alert.AlertDefinition/2987034427'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Integer/3438268394'));
    $writeObject(streamWriter, groupAlertDefinition);
    $writeObject(streamWriter, resourceGroupId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition creation failed'), ex);
    }
     else 
      throw $e0;
  }
}

function $disableGroupAlertDefinitions(this$static, groupAlertDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'GroupAlertDefinitionGWTService_Proxy', 'disableGroupAlertDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.GroupAlertDefinitionGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeObject(streamWriter, groupAlertDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to disable the selected alert definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $enableGroupAlertDefinitions(this$static, groupAlertDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'GroupAlertDefinitionGWTService_Proxy', 'enableGroupAlertDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.GroupAlertDefinitionGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeObject(streamWriter, groupAlertDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to enable the selected alert definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $removeGroupAlertDefinitions(this$static, groupAlertDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'GroupAlertDefinitionGWTService_Proxy', 'removeGroupAlertDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.GroupAlertDefinitionGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeObject(streamWriter, groupAlertDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to deleted the selected alert definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateGroupAlertDefinitions(this$static, groupAlertDefinition, purgeInternals, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'GroupAlertDefinitionGWTService_Proxy', 'updateGroupAlertDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.GroupAlertDefinitionGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.alert.AlertDefinition/2987034427'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    $writeObject(streamWriter, groupAlertDefinition);
    append(streamWriter.encodeBuffer, purgeInternals?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Alert definition update failed'), ex);
    }
     else 
      throw $e0;
  }
}

function GroupAlertDefinitionGWTService_Proxy_0(){
  $clinit_GroupAlertDefinitionGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '1914048DE855A45370AD007992A07B8E', SERIALIZER_12);
}

defineSeed(2825, 2784, makeCastMap([Q$GroupAlertDefinitionGWTServiceAsync]), GroupAlertDefinitionGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_13(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_12;
function $clinit_GroupAlertDefinitionGWTService_TypeSerializer(){
  $clinit_GroupAlertDefinitionGWTService_TypeSerializer = nullMethod;
  methodMapNative_13 = loadMethodsNative_12();
  signatureMapNative_13 = loadSignaturesNative_12();
}

function GroupAlertDefinitionGWTService_TypeSerializer_0(){
  $clinit_GroupAlertDefinitionGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_13, signatureMapNative_13);
}

function loadMethodsNative_12(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10, serialize_2];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101, serialize_49];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93, serialize_40];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90, serialize_37];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91, serialize_38];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92, serialize_39];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97, serialize_44];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96, serialize_43];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98, serialize_45];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94, serialize_41];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95, serialize_42];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99, serialize_46];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100, serialize_48];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102, serialize_50];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106, serialize_54];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104, serialize_52];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103, serialize_51];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105, serialize_53];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107, serialize_55];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108, serialize_56];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110, serialize_59];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127, serialize_76];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113, serialize_62];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111, serialize_60];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112, serialize_61];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115, serialize_64];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114, serialize_63];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117, serialize_66];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116, serialize_65];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123, serialize_72];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120, serialize_69];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119, serialize_68];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121, serialize_70];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118, serialize_67];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122, serialize_71];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124, serialize_73];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126, serialize_75];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125, serialize_74];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130, serialize_77];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141, serialize_83];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142, serialize_85];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140, serialize_82];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157, serialize_97];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162, serialize_102];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161, serialize_101];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163, serialize_103];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164, serialize_104];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173, serialize_113];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172, serialize_112];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174, serialize_116];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175, serialize_117];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176, serialize_118];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177, serialize_119];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183, serialize_125];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179, serialize_121];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178, serialize_120];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180, serialize_122];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181, serialize_123];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182, serialize_124];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184, serialize_126];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186, serialize_128];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187, serialize_129];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185, serialize_127];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188, serialize_130];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190, serialize_132];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191, serialize_133];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192, serialize_134];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193, serialize_135];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196, serialize_138];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195, serialize_137];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198, serialize_140];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197, serialize_139];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201, serialize_143];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199, serialize_141];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200, serialize_142];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203, serialize_144];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204, serialize_145];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205, serialize_146];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207, serialize_148];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206, serialize_147];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211, serialize_152];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209, serialize_150];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208, serialize_149];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210, serialize_151];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212, serialize_153];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214, serialize_155];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213, serialize_154];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215, serialize_156];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219, serialize_160];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218, serialize_159];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216, serialize_157];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217, serialize_158];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230, serialize_170];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221, serialize_162];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220, serialize_161];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222, serialize_163];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224, serialize_165];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223, serialize_164];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225, serialize_166];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229, serialize_169];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227, serialize_167];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231, serialize_171];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244, serialize_184];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232, serialize_172];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233, serialize_173];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234, serialize_174];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236, serialize_176];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235, serialize_175];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237, serialize_177];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239, serialize_179];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238, serialize_178];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240, serialize_180];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241, serialize_181];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243, serialize_183];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242, serialize_182];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245, serialize_185];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248, serialize_186];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252, serialize_239];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249, serialize_236];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250, serialize_237];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251, serialize_238];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255, serialize_243];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257, serialize_245];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260, serialize_247];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259, serialize_246];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278, serialize_261];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274, serialize_257];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276, serialize_259];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277, serialize_260];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285, serialize_266];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283, serialize_264];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284, serialize_265];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288, serialize_269];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289, serialize_270];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298, serialize_271];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300, serialize_273];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299, serialize_272];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302, serialize_275];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303, serialize_276];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312, serialize_278];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311, serialize_277];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314, serialize_279];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316, serialize_282];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318, serialize_284];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317, serialize_283];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337, serialize_291];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336, serialize_290];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339, serialize_292];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341, serialize_294];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340, serialize_293];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342, serialize_295];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344, serialize_297];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343, serialize_296];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345, serialize_298];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346, serialize_300];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348, serialize_301];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349, serialize_302];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360, serialize_314];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350, serialize_305];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351, serialize_306];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354, serialize_309];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352, serialize_307];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353, serialize_308];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356, serialize_311];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355, serialize_310];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358, serialize_312];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359, serialize_313];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375, serialize_318];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376, serialize_319];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378, serialize_320];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380, serialize_322];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379, serialize_321];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394, serialize_325];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395, serialize_326];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_12(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2826, 278, {}, GroupAlertDefinitionGWTService_TypeSerializer_0);
var methodMapNative_13 = null, signatureMapNative_13 = null;
function getInstance_43(){
  var target;
  if (!instance_15) {
    instance_15 = new GroupDefinitionExpressionBuilderGWTService_Proxy_0;
    target = instance_15;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'GroupDefinitionExpressionBuilderGWTService');
  }
  return instance_15;
}

var instance_15 = null;
function $clinit_GroupDefinitionExpressionBuilderGWTService_Proxy(){
  $clinit_GroupDefinitionExpressionBuilderGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_13 = new GroupDefinitionExpressionBuilderGWTService_TypeSerializer_0;
}

function $getPluginConfigurationPropertyNames(this$static, resourceTypeId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'GroupDefinitionExpressionBuilderGWTService_Proxy', 'getPluginConfigurationPropertyNames');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.GroupDefinitionExpressionBuilderGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceTypeId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Cannot get list of properties'), ex);
    }
     else 
      throw $e0;
  }
}

function $getResourceConfigurationPropertyNames(this$static, resourceTypeId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'GroupDefinitionExpressionBuilderGWTService_Proxy', 'getResourceConfigurationPropertyNames');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.GroupDefinitionExpressionBuilderGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceTypeId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Cannot get list of properties'), ex);
    }
     else 
      throw $e0;
  }
}

function $getTraitPropertyNames(this$static, resourceTypeId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'GroupDefinitionExpressionBuilderGWTService_Proxy', 'getTraitPropertyNames');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.GroupDefinitionExpressionBuilderGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceTypeId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Cannot get list of properties'), ex);
    }
     else 
      throw $e0;
  }
}

function GroupDefinitionExpressionBuilderGWTService_Proxy_0(){
  $clinit_GroupDefinitionExpressionBuilderGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '4EC15680293DE96AED32D6C18CF70639', SERIALIZER_13);
}

defineSeed(2828, 2784, makeCastMap([Q$GroupDefinitionExpressionBuilderGWTServiceAsync]), GroupDefinitionExpressionBuilderGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_14(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_13;
function $clinit_GroupDefinitionExpressionBuilderGWTService_TypeSerializer(){
  $clinit_GroupDefinitionExpressionBuilderGWTService_TypeSerializer = nullMethod;
  methodMapNative_14 = loadMethodsNative_13();
  signatureMapNative_14 = loadSignaturesNative_13();
}

function GroupDefinitionExpressionBuilderGWTService_TypeSerializer_0(){
  $clinit_GroupDefinitionExpressionBuilderGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_14, signatureMapNative_14);
}

function loadMethodsNative_13(){
  var result = {};
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_13(){
  var result = [];
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2829, 278, {}, GroupDefinitionExpressionBuilderGWTService_TypeSerializer_0);
var methodMapNative_14 = null, signatureMapNative_14 = null;
function getInstance_44(){
  var target;
  if (!instance_16) {
    instance_16 = new LdapGWTService_Proxy_0;
    target = instance_16;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'LdapGWTService');
  }
  return instance_16;
}

var instance_16 = null;
function $clinit_LdapGWTService_Proxy(){
  $clinit_LdapGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_14 = new LdapGWTService_TypeSerializer_0;
}

function $checkLdapConfiguredStatus(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'LdapGWTService_Proxy', 'checkLdapConfiguredStatus');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.LdapGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to determine if LDAP configured - assuming no LDAP.'), ex);
    }
     else 
      throw $e0;
  }
}

function $findAvailableGroups(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'LdapGWTService_Proxy', 'findAvailableGroups');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.LdapGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load LDAP groups available for role.'), ex);
    }
     else 
      throw $e0;
  }
}

function LdapGWTService_Proxy_0(){
  $clinit_LdapGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, 'CFFC11A14DB49836E64E1CE36852F75B', SERIALIZER_14);
}

defineSeed(2831, 2784, makeCastMap([Q$LdapGWTServiceAsync]), LdapGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_15(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_14;
function $clinit_LdapGWTService_TypeSerializer(){
  $clinit_LdapGWTService_TypeSerializer = nullMethod;
  methodMapNative_15 = loadMethodsNative_14();
  signatureMapNative_15 = loadSignaturesNative_14();
}

function LdapGWTService_TypeSerializer_0(){
  $clinit_LdapGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_15, signatureMapNative_15);
}

function loadMethodsNative_14(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_14(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2832, 278, {}, LdapGWTService_TypeSerializer_0);
var methodMapNative_15 = null, signatureMapNative_15 = null;
var instance_17 = null;
function $clinit_MeasurementChartsGWTService_Proxy(){
  $clinit_MeasurementChartsGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_15 = new MeasurementChartsGWTService_TypeSerializer_0;
}

function $getMetricDisplaySummariesForCompatibleGroup(this$static, groupId, measurementDefinitionIds, begin, end, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementChartsGWTService_Proxy', 'getMetricDisplaySummariesForCompatibleGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementChartsGWTService', 5);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $writeObject(streamWriter, measurementDefinitionIds);
    $append_3(streamWriter, toBase64(begin));
    $append_3(streamWriter, toBase64(end));
    append(streamWriter.encodeBuffer, '0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Cannot load metrics'), ex);
    }
     else 
      throw $e0;
  }
}

function $getMetricDisplaySummariesForResource(this$static, resourceId, measurementScheduleIds, begin, end, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementChartsGWTService_Proxy', 'getMetricDisplaySummariesForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementChartsGWTService', 4);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, measurementScheduleIds);
    $append_3(streamWriter, toBase64(begin));
    $append_3(streamWriter, toBase64(end));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Cannot load metrics'), ex);
    }
     else 
      throw $e0;
  }
}

function MeasurementChartsGWTService_Proxy_0(){
  $clinit_MeasurementChartsGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), 'MeasurementChartsGWTService', '3D60DCDEB92EB72F0A013B89A9E3DF6B', SERIALIZER_15);
}

defineSeed(2834, 2784, makeCastMap([Q$MeasurementChartsGWTServiceAsync]), MeasurementChartsGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_16(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_15;
function $clinit_MeasurementChartsGWTService_TypeSerializer(){
  $clinit_MeasurementChartsGWTService_TypeSerializer = nullMethod;
  methodMapNative_16 = loadMethodsNative_15();
  signatureMapNative_16 = loadSignaturesNative_15();
}

function MeasurementChartsGWTService_TypeSerializer_0(){
  $clinit_MeasurementChartsGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_16, signatureMapNative_16);
}

function loadMethodsNative_15(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['[I/2970817851'] = [undefined, undefined, serialize_3];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.measurement.ui.MetricDisplaySummary/2120698575'] = [instantiate_301, deserialize_309];
  result['org.rhq.core.domain.measurement.ui.MetricDisplayValue/3576642425'] = [instantiate_302, deserialize_310];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_15(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(_3I_classLit)] = '[I/2970817851';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ui_MetricDisplaySummary_2_classLit)] = 'org.rhq.core.domain.measurement.ui.MetricDisplaySummary/2120698575';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ui_MetricDisplayValue_2_classLit)] = 'org.rhq.core.domain.measurement.ui.MetricDisplayValue/3576642425';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2835, 278, {}, MeasurementChartsGWTService_TypeSerializer_0);
var methodMapNative_16 = null, signatureMapNative_16 = null;
var instance_18 = null;
function $clinit_MeasurementDataGWTService_Proxy(){
  $clinit_MeasurementDataGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_16 = new MeasurementDataGWTService_TypeSerializer_0;
}

function $disableSchedulesForCompatibleGroup(this$static, resourceGroupId, measurementDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'disableSchedulesForCompatibleGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    append(streamWriter.encodeBuffer, '' + resourceGroupId);
    $writeObject(streamWriter, measurementDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to disable the collection of [' + ($clinit_Enhanced() , '' + callback.val$measurementDefinitionIds.length) + '] metrics for resource group with ID [' + callback.this$0.groupId + ']. The metrics were: [' + callback.val$measurementDefinitionDisplayNames.toString$() + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function $disableSchedulesForResource(this$static, resourceId, measurementDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'disableSchedulesForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, measurementDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to disable the collection of [' + ($clinit_Enhanced() , '' + callback.val$measurementDefinitionIds.length) + '] metrics for resource with ID [' + callback.this$0.resourceId + ']. The metrics were: [' + callback.val$measurementDefinitionDisplayNames.toString$() + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function $disableSchedulesForResourceType(this$static, measurementDefinitionIds, updateExistingSchedules, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'disableSchedulesForResourceType');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    $writeObject(streamWriter, measurementDefinitionIds);
    append(streamWriter.encodeBuffer, updateExistingSchedules?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to disable collection of metric [' + ($clinit_Enhanced() , callback.val$s) + '] [' + callback.val$measurementDefinitionDisplayNames.toString$() + '] by default for ResourceType with id [' + callback.this$0.typeId + '].'), ex);
    }
     else 
      throw $e0;
  }
}

function $enableSchedulesForCompatibleGroup(this$static, resourceGroupId, measurementDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'enableSchedulesForCompatibleGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    append(streamWriter.encodeBuffer, '' + resourceGroupId);
    $writeObject(streamWriter, measurementDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to enable the collection of [' + ($clinit_Enhanced() , '' + callback.val$measurementDefinitionIds.length) + '] metrics for group with ID [' + callback.this$0.groupId + ']. The metrics were: [' + callback.val$measurementDefinitionDisplayNames.toString$() + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function $enableSchedulesForResource(this$static, resourceId, measurementDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'enableSchedulesForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, measurementDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to enable the collection of [' + ($clinit_Enhanced() , '' + callback.val$measurementDefinitionIds.length) + '] metrics for resource with ID [' + callback.this$0.resourceId + ']. The metrics were: [' + callback.val$measurementDefinitionDisplayNames.toString$() + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function $enableSchedulesForResourceType(this$static, measurementDefinitionIds, updateExistingSchedules, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'enableSchedulesForResourceType');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    $writeObject(streamWriter, measurementDefinitionIds);
    append(streamWriter.encodeBuffer, updateExistingSchedules?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to enable collection of metric [' + ($clinit_Enhanced() , callback.val$s) + '] [' + callback.val$measurementDefinitionDisplayNames.toString$() + '] by default for ResourceType with id [' + callback.this$0.typeId + '].'), ex);
    }
     else 
      throw $e0;
  }
}

function $findCallTimeDataForContext(this$static, context, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findCallTimeDataForContext');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.common.EntityContext/926996548'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.CallTimeDataCriteria/1287561467'));
    $writeObject(streamWriter, context);
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Could not load call time data'), ex);
    }
     else 
      throw $e0;
  }
}

function $findCurrentTraitsForResource(this$static, resourceId, displayType, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findCurrentTraitsForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.measurement.DisplayType/4072059336'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, displayType);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to load traits for ' + $toString_18(callback.val$resource) + '.'), ex);
    }
     else 
      throw $e0;
  }
}

function $findDataForCompatibleGroup(this$static, groupId, definitionIds, beginTime, endTime, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findDataForCompatibleGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 5);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $writeObject(streamWriter, definitionIds);
    $append_3(streamWriter, toBase64(beginTime));
    $append_3(streamWriter, toBase64(endTime));
    append(streamWriter.encodeBuffer, '60');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findDataForCompatibleGroupForLast(this$static, groupId, definitionIds, lastN, unit, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findDataForCompatibleGroupForLast');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 5);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $writeObject(streamWriter, definitionIds);
    append(streamWriter.encodeBuffer, '' + lastN);
    append(streamWriter.encodeBuffer, '' + unit);
    append(streamWriter.encodeBuffer, '60');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findDataForResource(this$static, resourceId, definitionIds, beginTime, endTime, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findDataForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 5);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, definitionIds);
    $append_3(streamWriter, toBase64(beginTime));
    $append_3(streamWriter, toBase64(endTime));
    append(streamWriter.encodeBuffer, '60');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findDataForResourceForLast(this$static, resourceId, definitionIds, lastN, unit, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findDataForResourceForLast');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 5);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, definitionIds);
    append(streamWriter.encodeBuffer, '' + lastN);
    append(streamWriter.encodeBuffer, '' + unit);
    append(streamWriter.encodeBuffer, '60');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findLiveData(this$static, resourceId, definitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findLiveData');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, definitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findLiveDataForGroup(this$static, groupId, resourceId, definitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findLiveDataForGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $writeObject(streamWriter, resourceId);
    $writeObject(streamWriter, definitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get live values for those metrics. Make sure the agent is running and the managed resource is up.'), ex);
    }
     else 
      throw $e0;
  }
}

function $findMeasurementDefinitionsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findMeasurementDefinitionsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.MeasurementDefinitionCriteria/1373804870'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load metric definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $findMeasurementSchedulesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findMeasurementSchedulesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.MeasurementScheduleCriteria/2828658245'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findTraitsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'findTraitsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.MeasurementDataTraitCriteria/1598419853'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_29(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getHighestNOOBsForGroup(this$static, groupId, n, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'getHighestNOOBsForGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + groupId);
    append(streamWriter.encodeBuffer, '' + n);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      debug('Error retrieving recent out of bound metrics for group [' + callback.val$groupId + ']:' + ex.detailMessage);
      callback.this$0.currentlyLoading = false;
    }
     else 
      throw $e0;
  }
}

function $getHighestNOOBsForResource(this$static, resourceId, n, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'getHighestNOOBsForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    append(streamWriter.encodeBuffer, '' + n);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getMeasurementScheduleCompositesByContext(this$static, context, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'getMeasurementScheduleCompositesByContext');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.common.EntityContext/926996548'));
    $writeObject(streamWriter, context);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_30(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getSchedulesWithOOBs(this$static, pc, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'getSchedulesWithOOBs');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 4);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.util.PageControl/1930924326'));
    $writeInt(streamWriter, $addString(streamWriter, null));
    $writeInt(streamWriter, $addString(streamWriter, null));
    $writeInt(streamWriter, $addString(streamWriter, null));
    $writeObject(streamWriter, pc);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load measurement OOB information'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateSchedulesForCompatibleGroup(this$static, resourceGroupId, measurementDefinitionIds, collectionInterval, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'updateSchedulesForCompatibleGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    append(streamWriter.encodeBuffer, '' + resourceGroupId);
    $writeObject(streamWriter, measurementDefinitionIds);
    $append_3(streamWriter, toBase64(collectionInterval));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to set the collection interval of [' + ($clinit_Enhanced() , '' + callback.val$measurementDefinitionIds.length) + '] metrics for resource group with ID [' + callback.this$0.groupId + ']. The metrics were: [' + callback.val$measurementDefinitionDisplayNames.toString$() + ']. The collection interval was to be [' + toString_8(div(callback.val$collectionInterval, P3e8_longLit)) + '] seconds.'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateSchedulesForResource(this$static, resourceId, measurementDefinitionIds, collectionInterval, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'updateSchedulesForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, measurementDefinitionIds);
    $append_3(streamWriter, toBase64(collectionInterval));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to set the collection interval of [' + ($clinit_Enhanced() , '' + callback.val$measurementDefinitionIds.length) + '] metrics for resource with ID [' + callback.this$0.resourceId + ']. The metrics were: [' + callback.val$measurementDefinitionDisplayNames.toString$() + ']. The collection interval was to be [' + toString_8(div(callback.val$collectionInterval, P3e8_longLit)) + '] seconds.'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateSchedulesForResourceType(this$static, measurementDefinitionIds, collectionInterval, updateExistingSchedules, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementDataGWTService_Proxy', 'updateSchedulesForResourceType');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    $writeObject(streamWriter, measurementDefinitionIds);
    $append_3(streamWriter, toBase64(collectionInterval));
    append(streamWriter.encodeBuffer, updateExistingSchedules?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to set collection interval to [' + ($clinit_Enhanced() , '' + toString_8(div(callback.val$collectionInterval, P3e8_longLit))) + '] seconds for metric [' + callback.val$s + '] [' + callback.val$measurementDefinitionDisplayNames.toString$() + '] by default for ResourceType with id [' + callback.this$0.typeId + '].'), ex);
    }
     else 
      throw $e0;
  }
}

function MeasurementDataGWTService_Proxy_0(){
  $clinit_MeasurementDataGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), 'MeasurementDataGWTService', '54BD6C24E70E14981D4AEB4611994E33', SERIALIZER_16);
}

defineSeed(2837, 2784, makeCastMap([Q$MeasurementDataGWTServiceAsync]), MeasurementDataGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_17(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_16;
function $clinit_MeasurementDataGWTService_TypeSerializer(){
  $clinit_MeasurementDataGWTService_TypeSerializer = nullMethod;
  methodMapNative_17 = loadMethodsNative_16();
  signatureMapNative_17 = loadSignaturesNative_16();
}

function MeasurementDataGWTService_TypeSerializer_0(){
  $clinit_MeasurementDataGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_17, signatureMapNative_17);
}

function loadMethodsNative_16(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.user.client.ui.ChangeListenerCollection/287642957'] = [instantiate_80, deserialize_83];
  result['com.google.gwt.user.client.ui.ClickListenerCollection/2152455986'] = [instantiate_81, deserialize_84];
  result['com.google.gwt.user.client.ui.FocusListenerCollection/119490835'] = [instantiate_82, deserialize_85];
  result['com.google.gwt.user.client.ui.KeyboardListenerCollection/1040442242'] = [instantiate_83, deserialize_86];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['[I/2970817851'] = [undefined, undefined, serialize_3];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['[Ljava.util.AbstractList;/727920111'] = [instantiate_46, deserialize_47];
  result['[Ljava.util.AbstractSequentialList;/3144020509'] = [instantiate_47, deserialize_48];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['[Ljava.util.ArrayList;/2683379088'] = [instantiate_48, deserialize_49];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['[Ljava.util.LinkedList;/1037437294'] = [instantiate_64, deserialize_66];
  result['[Ljava.util.List;/2827171268'] = [instantiate_66, deserialize_68];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['[Ljava.util.Stack;/675459124'] = [instantiate_68, deserialize_71];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['[Ljava.util.Vector;/3889776585'] = [instantiate_73, deserialize_76];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.common.EntityContext/926996548'] = [undefined, undefined, serialize_86];
  result['org.rhq.core.domain.common.EntityContext$Type/3658574791'] = [undefined, undefined, serialize_87];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.criteria.CallTimeDataCriteria/1287561467'] = [undefined, undefined, serialize_199];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.MeasurementDataTraitCriteria/1598419853'] = [undefined, undefined, serialize_214];
  result['org.rhq.core.domain.criteria.MeasurementDefinitionCriteria/1373804870'] = [undefined, undefined, serialize_215];
  result['org.rhq.core.domain.criteria.MeasurementScheduleCriteria/2828658245'] = [undefined, undefined, serialize_216];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289, serialize_270];
  result['org.rhq.core.domain.measurement.MeasurementDataNumeric/1460426030'] = [instantiate_286, deserialize_293];
  result['org.rhq.core.domain.measurement.MeasurementDataNumeric1D/2128376268'] = [instantiate_283, deserialize_290];
  result['org.rhq.core.domain.measurement.MeasurementDataNumeric1H/2309885619'] = [instantiate_284, deserialize_291];
  result['org.rhq.core.domain.measurement.MeasurementDataNumeric6H/339656809'] = [instantiate_285, deserialize_292];
  result['org.rhq.core.domain.measurement.MeasurementDataPK/263663673'] = [instantiate_287, deserialize_294];
  result['org.rhq.core.domain.measurement.MeasurementDataTrait/1915305309'] = [instantiate_289, deserialize_296];
  result['[Lorg.rhq.core.domain.measurement.MeasurementDataTrait;/2889619473'] = [instantiate_288, deserialize_295];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302, serialize_275];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.measurement.calltime.CallTimeDataComposite/4282170865'] = [instantiate_296, deserialize_304];
  result['org.rhq.core.domain.measurement.composite.MeasurementDataNumericHighLowComposite/1811899222'] = [instantiate_298, deserialize_306];
  result['[Lorg.rhq.core.domain.measurement.composite.MeasurementDataNumericHighLowComposite;/3399925484'] = [instantiate_297, deserialize_305];
  result['org.rhq.core.domain.measurement.composite.MeasurementOOBComposite/112358374'] = [instantiate_299, deserialize_307];
  result['org.rhq.core.domain.measurement.composite.MeasurementScheduleComposite/2224313707'] = [instantiate_300, deserialize_308];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346, serialize_300];
  result['[Lorg.rhq.core.domain.resource.InventoryStatus;/1104631704'] = [undefined, undefined, serialize_299];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['[Lorg.rhq.core.domain.util.PageList;/2418082607'] = [instantiate_386, deserialize_398];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_16(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_user_client_ui_ChangeListenerCollection_2_classLit)] = 'com.google.gwt.user.client.ui.ChangeListenerCollection/287642957';
  result[getHashCode(Lcom_google_gwt_user_client_ui_ClickListenerCollection_2_classLit)] = 'com.google.gwt.user.client.ui.ClickListenerCollection/2152455986';
  result[getHashCode(Lcom_google_gwt_user_client_ui_FocusListenerCollection_2_classLit)] = 'com.google.gwt.user.client.ui.FocusListenerCollection/119490835';
  result[getHashCode(Lcom_google_gwt_user_client_ui_KeyboardListenerCollection_2_classLit)] = 'com.google.gwt.user.client.ui.KeyboardListenerCollection/1040442242';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(_3I_classLit)] = '[I/2970817851';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(_3Ljava_util_AbstractList_2_classLit)] = '[Ljava.util.AbstractList;/727920111';
  result[getHashCode(_3Ljava_util_AbstractSequentialList_2_classLit)] = '[Ljava.util.AbstractSequentialList;/3144020509';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(_3Ljava_util_ArrayList_2_classLit)] = '[Ljava.util.ArrayList;/2683379088';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(_3Ljava_util_LinkedList_2_classLit)] = '[Ljava.util.LinkedList;/1037437294';
  result[getHashCode(_3Ljava_util_List_2_classLit)] = '[Ljava.util.List;/2827171268';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(_3Ljava_util_Stack_2_classLit)] = '[Ljava.util.Stack;/675459124';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(_3Ljava_util_Vector_2_classLit)] = '[Ljava.util.Vector;/3889776585';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_common_EntityContext_2_classLit)] = 'org.rhq.core.domain.common.EntityContext/926996548';
  result[getHashCode(Lorg_rhq_core_domain_common_EntityContext$Type_2_classLit)] = 'org.rhq.core.domain.common.EntityContext$Type/3658574791';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_CallTimeDataCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.CallTimeDataCriteria/1287561467';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_MeasurementDataTraitCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.MeasurementDataTraitCriteria/1598419853';
  result[getHashCode(Lorg_rhq_core_domain_criteria_MeasurementDefinitionCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.MeasurementDefinitionCriteria/1373804870';
  result[getHashCode(Lorg_rhq_core_domain_criteria_MeasurementScheduleCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.MeasurementScheduleCriteria/2828658245';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataNumeric_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataNumeric/1460426030';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataNumeric1D_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataNumeric1D/2128376268';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataNumeric1H_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataNumeric1H/2309885619';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataNumeric6H_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataNumeric6H/339656809';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataPK_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataPK/263663673';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataTrait_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataTrait/1915305309';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementDataTrait_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementDataTrait;/2889619473';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_measurement_calltime_CallTimeDataComposite_2_classLit)] = 'org.rhq.core.domain.measurement.calltime.CallTimeDataComposite/4282170865';
  result[getHashCode(Lorg_rhq_core_domain_measurement_composite_MeasurementDataNumericHighLowComposite_2_classLit)] = 'org.rhq.core.domain.measurement.composite.MeasurementDataNumericHighLowComposite/1811899222';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_composite_MeasurementDataNumericHighLowComposite_2_classLit)] = '[Lorg.rhq.core.domain.measurement.composite.MeasurementDataNumericHighLowComposite;/3399925484';
  result[getHashCode(Lorg_rhq_core_domain_measurement_composite_MeasurementOOBComposite_2_classLit)] = 'org.rhq.core.domain.measurement.composite.MeasurementOOBComposite/112358374';
  result[getHashCode(Lorg_rhq_core_domain_measurement_composite_MeasurementScheduleComposite_2_classLit)] = 'org.rhq.core.domain.measurement.composite.MeasurementScheduleComposite/2224313707';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = '[Lorg.rhq.core.domain.resource.InventoryStatus;/1104631704';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(_3Lorg_rhq_core_domain_util_PageList_2_classLit)] = '[Lorg.rhq.core.domain.util.PageList;/2418082607';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2838, 278, {}, MeasurementDataGWTService_TypeSerializer_0);
var methodMapNative_17 = null, signatureMapNative_17 = null;
var instance_19 = null;
function $clinit_MeasurementScheduleGWTService_Proxy(){
  $clinit_MeasurementScheduleGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_17 = new MeasurementScheduleGWTService_TypeSerializer_0;
}

function $findSchedulesForResourceAndType(this$static, resourceId, dataType, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'MeasurementScheduleGWTService_Proxy', 'findSchedulesForResourceAndType');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.MeasurementScheduleGWTService', 4);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.measurement.DataType/1753764592'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.measurement.DisplayType/4072059336'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, dataType);
    $writeObject(streamWriter, null);
    append(streamWriter.encodeBuffer, '1');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Cannot load schedules'), ex);
    }
     else 
      throw $e0;
  }
}

function MeasurementScheduleGWTService_Proxy_0(){
  $clinit_MeasurementScheduleGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), 'MeasurementScheduleGWTService', 'DF45444B23CC8CC5487B20DCAD1407CF', SERIALIZER_17);
}

defineSeed(2840, 2784, makeCastMap([Q$MeasurementScheduleGWTServiceAsync]), MeasurementScheduleGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_18(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_17;
function $clinit_MeasurementScheduleGWTService_TypeSerializer(){
  $clinit_MeasurementScheduleGWTService_TypeSerializer = nullMethod;
  methodMapNative_18 = loadMethodsNative_17();
  signatureMapNative_18 = loadSignaturesNative_17();
}

function MeasurementScheduleGWTService_TypeSerializer_0(){
  $clinit_MeasurementScheduleGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_18, signatureMapNative_18);
}

function loadMethodsNative_17(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_17(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2841, 278, {}, MeasurementScheduleGWTService_TypeSerializer_0);
var methodMapNative_18 = null, signatureMapNative_18 = null;
function getInstance_45(){
  var target;
  if (!instance_20) {
    instance_20 = new OperationGWTService_Proxy_0;
    target = instance_20;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'OperationGWTService');
  }
  return instance_20;
}

var instance_20 = null;
function $clinit_OperationGWTService_Proxy(){
  $clinit_OperationGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_18 = new OperationGWTService_TypeSerializer_0;
}

function $cancelOperationHistory(this$static, historyId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'cancelOperationHistory');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + historyId);
    append(streamWriter.encodeBuffer, '0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $deleteOperationHistory(this$static, operationHistoryId, deleteEvenIfInProgress, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'deleteOperationHistory');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + operationHistoryId);
    append(streamWriter.encodeBuffer, deleteEvenIfInProgress?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findCurrentlyScheduledGroupOperations(this$static, pageSize, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'findCurrentlyScheduledGroupOperations');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + pageSize);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load scheduled operations.'), ex);
    }
     else 
      throw $e0;
  }
}

function $findCurrentlyScheduledResourceOperations(this$static, pageSize, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'findCurrentlyScheduledResourceOperations');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + pageSize);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load scheduled operations.'), ex);
    }
     else 
      throw $e0;
  }
}

function $findGroupOperationHistoriesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'findGroupOperationHistoriesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.GroupOperationHistoryCriteria/4157269672'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findResourceOperationHistoriesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'findResourceOperationHistoriesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.ResourceOperationHistoryCriteria/1415874921'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findScheduledGroupOperations(this$static, groupId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'findScheduledGroupOperations');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_35(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $findScheduledResourceOperations(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'findScheduledResourceOperations');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_48(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getGroupOperationSchedule(this$static, scheduleId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'getGroupOperationSchedule');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + scheduleId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $sendFailureResponse(callback.this$0, callback.val$request, callback.val$response, 'Failed to fetch GroupOperationSchedule with id ' + callback.val$scheduleId + '.', ex);
    }
     else 
      throw $e0;
  }
}

function $getResourceOperationSchedule(this$static, scheduleId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'getResourceOperationSchedule');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + scheduleId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $sendFailureResponse(callback.this$0, callback.val$request, callback.val$response, 'Failed to fetch ResourceOperationSchedule with id ' + callback.val$scheduleId + '.', ex);
    }
     else 
      throw $e0;
  }
}

function $scheduleGroupOperation(this$static, groupOperationSchedule, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'scheduleGroupOperation');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.operation.bean.GroupOperationSchedule/734154988'));
    $writeObject(streamWriter, groupOperationSchedule);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_36(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $scheduleResourceOperation(this$static, resourceOperationSchedule, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'scheduleResourceOperation');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.operation.bean.ResourceOperationSchedule/1896965524'));
    $writeObject(streamWriter, resourceOperationSchedule);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_49(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $unscheduleGroupOperation(this$static, groupOperationSchedule, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'unscheduleGroupOperation');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.operation.bean.GroupOperationSchedule/734154988'));
    $writeObject(streamWriter, groupOperationSchedule);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_37(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $unscheduleResourceOperation(this$static, resourceOperationSchedule, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'OperationGWTService_Proxy', 'unscheduleResourceOperation');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.operation.bean.ResourceOperationSchedule/1896965524'));
    $writeObject(streamWriter, resourceOperationSchedule);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_50(ex);
    }
     else 
      throw $e0;
  }
}

function OperationGWTService_Proxy_0(){
  $clinit_OperationGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '545C183AF6BBC4815ED4DDA6572EE064', SERIALIZER_18);
}

defineSeed(2843, 2784, makeCastMap([Q$OperationGWTServiceAsync]), OperationGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_19(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_18;
function $clinit_OperationGWTService_TypeSerializer(){
  $clinit_OperationGWTService_TypeSerializer = nullMethod;
  methodMapNative_19 = loadMethodsNative_18();
  signatureMapNative_19 = loadSignaturesNative_18();
}

function OperationGWTService_TypeSerializer_0(){
  $clinit_OperationGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_19, signatureMapNative_19);
}

function loadMethodsNative_18(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10, serialize_2];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.i18n.shared.impl.DateRecord/3375188634'] = [instantiate_1, deserialize_1, serialize];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.sql.Date/730999118'] = [instantiate_43, deserialize_44, serialize_15];
  result['java.sql.Time/1816797103'] = [instantiate_44, deserialize_45, serialize_16];
  result['java.sql.Timestamp/3040052672'] = [instantiate_45, deserialize_46, serialize_17];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.Date/3385151746'] = [instantiate_56, deserialize_58, serialize_25];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101, serialize_49];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93, serialize_40];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90, serialize_37];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91, serialize_38];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92, serialize_39];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97, serialize_44];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96, serialize_43];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98, serialize_45];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94, serialize_41];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95, serialize_42];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99, serialize_46];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100, serialize_48];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102, serialize_50];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106, serialize_54];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104, serialize_52];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103, serialize_51];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105, serialize_53];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107, serialize_55];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108, serialize_56];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110, serialize_59];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127, serialize_76];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113, serialize_62];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111, serialize_60];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112, serialize_61];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115, serialize_64];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114, serialize_63];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117, serialize_66];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116, serialize_65];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123, serialize_72];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120, serialize_69];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119, serialize_68];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121, serialize_70];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118, serialize_67];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122, serialize_71];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124, serialize_73];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126, serialize_75];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125, serialize_74];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130, serialize_77];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141, serialize_83];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142, serialize_85];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140, serialize_82];
  result['org.rhq.core.domain.common.JobTrigger/3397308234'] = [instantiate_144, deserialize_147, serialize_89];
  result['org.rhq.core.domain.common.JobTrigger$EndType/3616318507'] = [instantiate_143, deserialize_146, serialize_88];
  result['org.rhq.core.domain.common.JobTrigger$RecurrenceType/1092053026'] = [instantiate_145, deserialize_148, serialize_90];
  result['org.rhq.core.domain.common.JobTrigger$StartType/1504224794'] = [instantiate_146, deserialize_149, serialize_91];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157, serialize_97];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162, serialize_102];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161, serialize_101];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163, serialize_103];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164, serialize_104];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173, serialize_113];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172, serialize_112];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174, serialize_116];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175, serialize_117];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176, serialize_118];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177, serialize_119];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183, serialize_125];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179, serialize_121];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178, serialize_120];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180, serialize_122];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181, serialize_123];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182, serialize_124];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184, serialize_126];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186, serialize_128];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187, serialize_129];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185, serialize_127];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188, serialize_130];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190, serialize_132];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191, serialize_133];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192, serialize_134];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193, serialize_135];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196, serialize_138];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195, serialize_137];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198, serialize_140];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197, serialize_139];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201, serialize_143];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199, serialize_141];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200, serialize_142];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203, serialize_144];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204, serialize_145];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205, serialize_146];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207, serialize_148];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206, serialize_147];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211, serialize_152];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209, serialize_150];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208, serialize_149];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210, serialize_151];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212, serialize_153];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214, serialize_155];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213, serialize_154];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215, serialize_156];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219, serialize_160];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218, serialize_159];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216, serialize_157];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217, serialize_158];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230, serialize_170];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221, serialize_162];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220, serialize_161];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222, serialize_163];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224, serialize_165];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223, serialize_164];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225, serialize_166];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229, serialize_169];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227, serialize_167];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231, serialize_171];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244, serialize_184];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232, serialize_172];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233, serialize_173];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234, serialize_174];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236, serialize_176];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235, serialize_175];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237, serialize_177];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239, serialize_179];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238, serialize_178];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240, serialize_180];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241, serialize_181];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243, serialize_183];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242, serialize_182];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245, serialize_185];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248, serialize_186];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.GroupOperationHistoryCriteria/4157269672'] = [undefined, undefined, serialize_210];
  result['org.rhq.core.domain.criteria.ResourceOperationHistoryCriteria/1415874921'] = [undefined, undefined, serialize_228];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252, serialize_239];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249, serialize_236];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250, serialize_237];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251, serialize_238];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255, serialize_243];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257, serialize_245];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260, serialize_247];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259, serialize_246];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278, serialize_261];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274, serialize_257];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276, serialize_259];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277, serialize_260];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285, serialize_266];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283, serialize_264];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284, serialize_265];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288, serialize_269];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289, serialize_270];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298, serialize_271];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300, serialize_273];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299, serialize_272];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302, serialize_275];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303, serialize_276];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312, serialize_278];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311, serialize_277];
  result['org.rhq.core.domain.operation.JobId/1069864444'] = [instantiate_305, deserialize_313];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314, serialize_279];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316, serialize_282];
  result['[Lorg.rhq.core.domain.operation.OperationRequestStatus;/22719497'] = [undefined, undefined, serialize_281];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318, serialize_284];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317, serialize_283];
  result['org.rhq.core.domain.operation.ScheduleJobId/309311729'] = [instantiate_310, deserialize_319];
  result['org.rhq.core.domain.operation.bean.GroupOperationSchedule/734154988'] = [instantiate_312, deserialize_321, serialize_285];
  result['[Lorg.rhq.core.domain.operation.bean.GroupOperationSchedule;/2020015951'] = [instantiate_311, deserialize_320];
  result['org.rhq.core.domain.operation.bean.ResourceOperationSchedule/1896965524'] = [instantiate_314, deserialize_324, serialize_287];
  result['[Lorg.rhq.core.domain.operation.bean.ResourceOperationSchedule;/3884838130'] = [instantiate_313, deserialize_323];
  result['org.rhq.core.domain.operation.composite.GroupOperationScheduleComposite/1173467010'] = [instantiate_315, deserialize_325];
  result['org.rhq.core.domain.operation.composite.ResourceOperationLastCompletedComposite/1722506222'] = [instantiate_316, deserialize_327];
  result['org.rhq.core.domain.operation.composite.ResourceOperationScheduleComposite/1527565999'] = [instantiate_317, deserialize_328];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337, serialize_291];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336, serialize_290];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339, serialize_292];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341, serialize_294];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340, serialize_293];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342, serialize_295];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344, serialize_297];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343, serialize_296];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345, serialize_298];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346, serialize_300];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348, serialize_301];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349, serialize_302];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360, serialize_314];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350, serialize_305];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351, serialize_306];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354, serialize_309];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352, serialize_307];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353, serialize_308];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356, serialize_311];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355, serialize_310];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358, serialize_312];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359, serialize_313];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375, serialize_318];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376, serialize_319];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378, serialize_320];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380, serialize_322];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379, serialize_321];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394, serialize_325];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395, serialize_326];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_18(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_i18n_shared_impl_DateRecord_2_classLit)] = 'com.google.gwt.i18n.shared.impl.DateRecord/3375188634';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_sql_Date_2_classLit)] = 'java.sql.Date/730999118';
  result[getHashCode(Ljava_sql_Time_2_classLit)] = 'java.sql.Time/1816797103';
  result[getHashCode(Ljava_sql_Timestamp_2_classLit)] = 'java.sql.Timestamp/3040052672';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_Date_2_classLit)] = 'java.util.Date/3385151746';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_common_JobTrigger_2_classLit)] = 'org.rhq.core.domain.common.JobTrigger/3397308234';
  result[getHashCode(Lorg_rhq_core_domain_common_JobTrigger$EndType_2_classLit)] = 'org.rhq.core.domain.common.JobTrigger$EndType/3616318507';
  result[getHashCode(Lorg_rhq_core_domain_common_JobTrigger$RecurrenceType_2_classLit)] = 'org.rhq.core.domain.common.JobTrigger$RecurrenceType/1092053026';
  result[getHashCode(Lorg_rhq_core_domain_common_JobTrigger$StartType_2_classLit)] = 'org.rhq.core.domain.common.JobTrigger$StartType/1504224794';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_GroupOperationHistoryCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.GroupOperationHistoryCriteria/4157269672';
  result[getHashCode(Lorg_rhq_core_domain_criteria_ResourceOperationHistoryCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.ResourceOperationHistoryCriteria/1415874921';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_JobId_2_classLit)] = 'org.rhq.core.domain.operation.JobId/1069864444';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = '[Lorg.rhq.core.domain.operation.OperationRequestStatus;/22719497';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_operation_ScheduleJobId_2_classLit)] = 'org.rhq.core.domain.operation.ScheduleJobId/309311729';
  result[getHashCode(Lorg_rhq_core_domain_operation_bean_GroupOperationSchedule_2_classLit)] = 'org.rhq.core.domain.operation.bean.GroupOperationSchedule/734154988';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_bean_GroupOperationSchedule_2_classLit)] = '[Lorg.rhq.core.domain.operation.bean.GroupOperationSchedule;/2020015951';
  result[getHashCode(Lorg_rhq_core_domain_operation_bean_ResourceOperationSchedule_2_classLit)] = 'org.rhq.core.domain.operation.bean.ResourceOperationSchedule/1896965524';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_bean_ResourceOperationSchedule_2_classLit)] = '[Lorg.rhq.core.domain.operation.bean.ResourceOperationSchedule;/3884838130';
  result[getHashCode(Lorg_rhq_core_domain_operation_composite_GroupOperationScheduleComposite_2_classLit)] = 'org.rhq.core.domain.operation.composite.GroupOperationScheduleComposite/1173467010';
  result[getHashCode(Lorg_rhq_core_domain_operation_composite_ResourceOperationLastCompletedComposite_2_classLit)] = 'org.rhq.core.domain.operation.composite.ResourceOperationLastCompletedComposite/1722506222';
  result[getHashCode(Lorg_rhq_core_domain_operation_composite_ResourceOperationScheduleComposite_2_classLit)] = 'org.rhq.core.domain.operation.composite.ResourceOperationScheduleComposite/1527565999';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2844, 278, {}, OperationGWTService_TypeSerializer_0);
var methodMapNative_19 = null, signatureMapNative_19 = null;
function getInstance_46(){
  var target;
  if (!instance_21) {
    instance_21 = new PlatformUtilizationGWTService_Proxy_0;
    target = instance_21;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'PlatformUtilizationGWTService');
  }
  return instance_21;
}

var instance_21 = null;
function $clinit_PlatformUtilizationGWTService_Proxy(){
  $clinit_PlatformUtilizationGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_19 = new PlatformUtilizationGWTService_TypeSerializer_0;
}

function $loadPlatformMetrics(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PlatformUtilizationGWTService_Proxy', 'loadPlatformMetrics');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PlatformUtilizationGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_24(callback, ex);
    }
     else 
      throw $e0;
  }
}

function PlatformUtilizationGWTService_Proxy_0(){
  $clinit_PlatformUtilizationGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '1B06A061D2886AA7BDB7BE675C1F882E', SERIALIZER_19);
}

defineSeed(2846, 2784, makeCastMap([Q$PlatformUtilizationGWTServiceAsync]), PlatformUtilizationGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_20(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_19;
function $clinit_PlatformUtilizationGWTService_TypeSerializer(){
  $clinit_PlatformUtilizationGWTService_TypeSerializer = nullMethod;
  methodMapNative_20 = loadMethodsNative_19();
  signatureMapNative_20 = loadSignaturesNative_19();
}

function PlatformUtilizationGWTService_TypeSerializer_0(){
  $clinit_PlatformUtilizationGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_20, signatureMapNative_20);
}

function loadMethodsNative_19(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDataNumeric/1460426030'] = [instantiate_286, deserialize_293];
  result['org.rhq.core.domain.measurement.MeasurementDataNumeric1D/2128376268'] = [instantiate_283, deserialize_290];
  result['org.rhq.core.domain.measurement.MeasurementDataNumeric1H/2309885619'] = [instantiate_284, deserialize_291];
  result['org.rhq.core.domain.measurement.MeasurementDataNumeric6H/339656809'] = [instantiate_285, deserialize_292];
  result['org.rhq.core.domain.measurement.MeasurementDataPK/263663673'] = [instantiate_287, deserialize_294];
  result['org.rhq.core.domain.measurement.MeasurementDataTrait/1915305309'] = [instantiate_289, deserialize_296];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.composite.PlatformMetricsSummary/2154637062'] = [instantiate_349, deserialize_361];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_19(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataNumeric_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataNumeric/1460426030';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataNumeric1D_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataNumeric1D/2128376268';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataNumeric1H_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataNumeric1H/2309885619';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataNumeric6H_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataNumeric6H/339656809';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataPK_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataPK/263663673';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDataTrait_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDataTrait/1915305309';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary_2_classLit)] = 'org.rhq.core.domain.resource.composite.PlatformMetricsSummary/2154637062';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2847, 278, {}, PlatformUtilizationGWTService_TypeSerializer_0);
var methodMapNative_20 = null, signatureMapNative_20 = null;
function getInstance_47(){
  var target;
  if (!instance_22) {
    instance_22 = new PluginGWTService_Proxy_0;
    target = instance_22;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'PluginGWTService');
  }
  return instance_22;
}

var instance_22 = null;
function $clinit_PluginGWTService_Proxy(){
  $clinit_PluginGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_20 = new PluginGWTService_TypeSerializer_0;
}

function $deleteAgentPlugins(this$static, selectedPluginIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'deleteAgentPlugins');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, selectedPluginIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to delete agent plugins.') + ' ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$2.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $disableAgentPlugins(this$static, selectedPluginIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'disableAgentPlugins');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, selectedPluginIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to disable agent plugins.') + ' ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$2.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $disableServerPlugins(this$static, selectedPluginIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'disableServerPlugins');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, selectedPluginIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to disable server plugins.') + ' ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$2.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $enableAgentPlugins(this$static, selectedPluginIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'enableAgentPlugins');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, selectedPluginIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to enable agent plugins.') + ' ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $enableServerPlugins(this$static, selectedPluginIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'enableServerPlugins');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, selectedPluginIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to enable server plugins.') + ' ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $getAgentPlugin(this$static, pluginId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'getAgentPlugin');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + pluginId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load plugin data'), ex);
    }
     else 
      throw $e0;
  }
}

function $getAgentPlugins(this$static, includeDeletedPlugins, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'getAgentPlugins');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, includeDeletedPlugins?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getServerPlugin(this$static, pluginId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'getServerPlugin');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + pluginId);
    append(streamWriter.encodeBuffer, '1');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load plugin data'), ex);
    }
     else 
      throw $e0;
  }
}

function $getServerPluginConfigurationDefinition(this$static, pluginKey, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'getServerPluginConfigurationDefinition');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.plugin.PluginKey/239492172'));
    $writeObject(streamWriter, pluginKey);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load plugin data'), ex);
    }
     else 
      throw $e0;
  }
}

function $getServerPluginControlDefinitions(this$static, serverPluginKey, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'getServerPluginControlDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.plugin.PluginKey/239492172'));
    $writeObject(streamWriter, serverPluginKey);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load plugin data'), ex);
    }
     else 
      throw $e0;
  }
}

function $getServerPluginScheduledJobsDefinition(this$static, pluginKey, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'getServerPluginScheduledJobsDefinition');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.plugin.PluginKey/239492172'));
    $writeObject(streamWriter, pluginKey);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load plugin data'), ex);
    }
     else 
      throw $e0;
  }
}

function $getServerPlugins(this$static, includeDeletedPlugins, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'getServerPlugins');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, includeDeletedPlugins?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $invokeServerPluginControl(this$static, serverPluginKey, controlName, params, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'invokeServerPluginControl');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.plugin.PluginKey/239492172'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.configuration.Configuration/25349161'));
    $writeObject(streamWriter, serverPluginKey);
    $writeInt(streamWriter, $addString(streamWriter, controlName));
    $writeObject(streamWriter, params);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to invoke the control'), ex);
    }
     else 
      throw $e0;
  }
}

function $purgeAgentPlugins(this$static, selectedPluginIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'purgeAgentPlugins');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, selectedPluginIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to purge agent plugins.') + ' ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $purgeServerPlugins(this$static, selectedPluginIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'purgeServerPlugins');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, selectedPluginIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to purge server plugins.') + ' ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $restartMasterPluginContainer(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'restartMasterPluginContainer');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to restart the master plugin container') + ' ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $scanAndRegister(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'scanAndRegister');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $undeployServerPlugins(this$static, selectedPluginIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'undeployServerPlugins');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, selectedPluginIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to undeploy server plugins.') + ' ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$2.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $updateServerPluginConfiguration(this$static, serverPluginKey, config, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'updateServerPluginConfiguration');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.plugin.PluginKey/239492172'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.configuration.Configuration/25349161'));
    $writeObject(streamWriter, serverPluginKey);
    $writeObject(streamWriter, config);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to save the settings'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateServerPluginScheduledJobs(this$static, serverPluginKey, jobsConfig, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'PluginGWTService_Proxy', 'updateServerPluginScheduledJobs');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.plugin.PluginKey/239492172'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.configuration.Configuration/25349161'));
    $writeObject(streamWriter, serverPluginKey);
    $writeObject(streamWriter, jobsConfig);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to save the settings'), ex);
    }
     else 
      throw $e0;
  }
}

function PluginGWTService_Proxy_0(){
  $clinit_PluginGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '7926DA39334E2C3275DE29027AA8D27B', SERIALIZER_20);
}

defineSeed(2849, 2784, makeCastMap([Q$PluginGWTServiceAsync]), PluginGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_21(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_20;
function $clinit_PluginGWTService_TypeSerializer(){
  $clinit_PluginGWTService_TypeSerializer = nullMethod;
  methodMapNative_21 = loadMethodsNative_20();
  signatureMapNative_21 = loadSignaturesNative_20();
}

function PluginGWTService_TypeSerializer_0(){
  $clinit_PluginGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_21, signatureMapNative_21);
}

function loadMethodsNative_20(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['[I/2970817851'] = [undefined, undefined, serialize_3];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.plugin.Plugin/838025370'] = [instantiate_320, deserialize_332];
  result['org.rhq.core.domain.plugin.PluginDeploymentType/2234244334'] = [instantiate_318, deserialize_330, serialize_288];
  result['org.rhq.core.domain.plugin.PluginKey/239492172'] = [undefined, undefined, serialize_289];
  result['org.rhq.core.domain.plugin.PluginStatusType/1808161304'] = [instantiate_319, deserialize_331];
  result['org.rhq.core.domain.plugin.ServerPlugin/4285322598'] = [instantiate_323, deserialize_335];
  result['org.rhq.core.domain.plugin.ServerPluginControlDefinition/2313226779'] = [instantiate_321, deserialize_333];
  result['org.rhq.core.domain.plugin.ServerPluginControlResults/1185280056'] = [instantiate_322, deserialize_334];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_20(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(_3I_classLit)] = '[I/2970817851';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_plugin_Plugin_2_classLit)] = 'org.rhq.core.domain.plugin.Plugin/838025370';
  result[getHashCode(Lorg_rhq_core_domain_plugin_PluginDeploymentType_2_classLit)] = 'org.rhq.core.domain.plugin.PluginDeploymentType/2234244334';
  result[getHashCode(Lorg_rhq_core_domain_plugin_PluginKey_2_classLit)] = 'org.rhq.core.domain.plugin.PluginKey/239492172';
  result[getHashCode(Lorg_rhq_core_domain_plugin_PluginStatusType_2_classLit)] = 'org.rhq.core.domain.plugin.PluginStatusType/1808161304';
  result[getHashCode(Lorg_rhq_core_domain_plugin_ServerPlugin_2_classLit)] = 'org.rhq.core.domain.plugin.ServerPlugin/4285322598';
  result[getHashCode(Lorg_rhq_core_domain_plugin_ServerPluginControlDefinition_2_classLit)] = 'org.rhq.core.domain.plugin.ServerPluginControlDefinition/2313226779';
  result[getHashCode(Lorg_rhq_core_domain_plugin_ServerPluginControlResults_2_classLit)] = 'org.rhq.core.domain.plugin.ServerPluginControlResults/1185280056';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2850, 278, {}, PluginGWTService_TypeSerializer_0);
var methodMapNative_21 = null, signatureMapNative_21 = null;
function getInstance_48(){
  var target;
  if (!instance_23) {
    instance_23 = new RemoteInstallGWTService_Proxy_0;
    target = instance_23;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'RemoteInstallGWTService');
  }
  return instance_23;
}

var instance_23 = null;
function $clinit_RemoteInstallGWTService_Proxy(){
  $clinit_RemoteInstallGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_21 = new RemoteInstallGWTService_TypeSerializer_0;
}

function $agentStatus(this$static, remoteAccessInfo, agentInstallPath, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'RemoteInstallGWTService_Proxy', 'agentStatus');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.install.remote.RemoteAccessInfo/2029460166'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeObject(streamWriter, remoteAccessInfo);
    $writeInt(streamWriter, $addString(streamWriter, agentInstallPath));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , STRING));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $disableButtons(callback.this$0, false);
      $setValue_0(callback.this$0.connectionForm, 'agentStatus', ex.detailMessage);
    }
     else 
      throw $e0;
  }
}

function $findAgentInstallPath_0(this$static, remoteAccessInfo, parentPath, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'RemoteInstallGWTService_Proxy', 'findAgentInstallPath');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.install.remote.RemoteAccessInfo/2029460166'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeObject(streamWriter, remoteAccessInfo);
    $writeInt(streamWriter, $addString(streamWriter, parentPath));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , STRING));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $disableButtons(callback.this$0, false);
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Error occurred while trying to find agent install path'), ex);
    }
     else 
      throw $e0;
  }
}

function $installAgent_0(this$static, remoteAccessInfo, parentPath, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'RemoteInstallGWTService_Proxy', 'installAgent');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.install.remote.RemoteAccessInfo/2029460166'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeObject(streamWriter, remoteAccessInfo);
    $writeInt(streamWriter, $addString(streamWriter, parentPath));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $disableButtons(callback.this$0, false);
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to install agent'), ex);
    }
     else 
      throw $e0;
  }
}

function $startAgent_0(this$static, remoteAccessInfo, agentInstallPath, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'RemoteInstallGWTService_Proxy', 'startAgent');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.install.remote.RemoteAccessInfo/2029460166'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeObject(streamWriter, remoteAccessInfo);
    $writeInt(streamWriter, $addString(streamWriter, agentInstallPath));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , STRING));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $disableButtons(callback.this$0, false);
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to start agent'), ex);
    }
     else 
      throw $e0;
  }
}

function $stopAgent_0(this$static, remoteAccessInfo, agentInstallPath, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'RemoteInstallGWTService_Proxy', 'stopAgent');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.install.remote.RemoteAccessInfo/2029460166'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeObject(streamWriter, remoteAccessInfo);
    $writeInt(streamWriter, $addString(streamWriter, agentInstallPath));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , STRING));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $disableButtons(callback.this$0, false);
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to stop agent'), ex);
    }
     else 
      throw $e0;
  }
}

function RemoteInstallGWTService_Proxy_0(){
  $clinit_RemoteInstallGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '36DE90229A321E067D898380F44C9E18', SERIALIZER_21);
}

defineSeed(2852, 2784, makeCastMap([Q$RemoteInstallGWTServiceAsync]), RemoteInstallGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_22(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_21;
function $clinit_RemoteInstallGWTService_TypeSerializer(){
  $clinit_RemoteInstallGWTService_TypeSerializer = nullMethod;
  methodMapNative_22 = loadMethodsNative_21();
  signatureMapNative_22 = loadSignaturesNative_21();
}

function RemoteInstallGWTService_TypeSerializer_0(){
  $clinit_RemoteInstallGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_22, signatureMapNative_22);
}

function loadMethodsNative_21(){
  var result = {};
  result['[B/3308590456'] = [undefined, undefined, serialize_2];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [instantiate_34, deserialize_35];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228];
  result['org.rhq.core.domain.install.remote.AgentInstallInfo/1078687736'] = [instantiate_273, deserialize_280];
  result['org.rhq.core.domain.install.remote.AgentInstallStep/3886044234'] = [instantiate_275, deserialize_282];
  result['[Lorg.rhq.core.domain.install.remote.AgentInstallStep;/1190601235'] = [instantiate_274, deserialize_281];
  result['org.rhq.core.domain.install.remote.RemoteAccessInfo/2029460166'] = [undefined, undefined, serialize_262];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_21(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(Lorg_rhq_core_domain_install_remote_AgentInstallInfo_2_classLit)] = 'org.rhq.core.domain.install.remote.AgentInstallInfo/1078687736';
  result[getHashCode(Lorg_rhq_core_domain_install_remote_AgentInstallStep_2_classLit)] = 'org.rhq.core.domain.install.remote.AgentInstallStep/3886044234';
  result[getHashCode(_3Lorg_rhq_core_domain_install_remote_AgentInstallStep_2_classLit)] = '[Lorg.rhq.core.domain.install.remote.AgentInstallStep;/1190601235';
  result[getHashCode(Lorg_rhq_core_domain_install_remote_RemoteAccessInfo_2_classLit)] = 'org.rhq.core.domain.install.remote.RemoteAccessInfo/2029460166';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2853, 278, {}, RemoteInstallGWTService_TypeSerializer_0);
var methodMapNative_22 = null, signatureMapNative_22 = null;
function getInstance_49(){
  var target;
  if (!instance_24) {
    instance_24 = new RepoGWTService_Proxy_0;
    target = instance_24;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'RepoGWTService');
  }
  return instance_24;
}

var instance_24 = null;
function $clinit_RepoGWTService_Proxy(){
  $clinit_RepoGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_22 = new RepoGWTService_TypeSerializer_0;
}

function $findReposByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'RepoGWTService_Proxy', 'findReposByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.RepoGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.RepoCriteria/1855951755'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function RepoGWTService_Proxy_0(){
  $clinit_RepoGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '591D3D4FF544FB3F018D0EE8280D55CD', SERIALIZER_22);
}

defineSeed(2855, 2784, makeCastMap([Q$RepoGWTServiceAsync]), RepoGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_23(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_22;
function $clinit_RepoGWTService_TypeSerializer(){
  $clinit_RepoGWTService_TypeSerializer = nullMethod;
  methodMapNative_23 = loadMethodsNative_22();
  signatureMapNative_23 = loadSignaturesNative_22();
}

function RepoGWTService_TypeSerializer_0(){
  $clinit_RepoGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_23, signatureMapNative_23);
}

function loadMethodsNative_22(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.RepoCriteria/1855951755'] = [undefined, undefined, serialize_222];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_22(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_RepoCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.RepoCriteria/1855951755';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2856, 278, {}, RepoGWTService_TypeSerializer_0);
var methodMapNative_23 = null, signatureMapNative_23 = null;
function getInstance_50(){
  var target;
  if (!instance_25) {
    instance_25 = new ResourceBossGWTService_Proxy_0;
    target = instance_25;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'ResourceBossGWTService');
  }
  return instance_25;
}

var instance_25 = null;
function $clinit_ResourceBossGWTService_Proxy(){
  $clinit_ResourceBossGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_23 = new ResourceBossGWTService_TypeSerializer_0;
}

function $getInventorySummary(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceBossGWTService_Proxy', 'getInventorySummary');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceBossGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to retrieve inventory summary'), ex);
    }
     else 
      throw $e0;
  }
}

function ResourceBossGWTService_Proxy_0(){
  $clinit_ResourceBossGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, 'EC77299E5BE5DD86870D8661E0147257', SERIALIZER_23);
}

defineSeed(2858, 2784, makeCastMap([Q$ResourceBossGWTServiceAsync]), ResourceBossGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_24(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_23;
function $clinit_ResourceBossGWTService_TypeSerializer(){
  $clinit_ResourceBossGWTService_TypeSerializer = nullMethod;
  methodMapNative_24 = loadMethodsNative_23();
  signatureMapNative_24 = loadSignaturesNative_23();
}

function ResourceBossGWTService_TypeSerializer_0(){
  $clinit_ResourceBossGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_24, signatureMapNative_24);
}

function loadMethodsNative_23(){
  var result = {};
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.InventorySummary/3306267764'] = [instantiate_335, deserialize_347];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_23(){
  var result = [];
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventorySummary_2_classLit)] = 'org.rhq.core.domain.resource.InventorySummary/3306267764';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2859, 278, {}, ResourceBossGWTService_TypeSerializer_0);
var methodMapNative_24 = null, signatureMapNative_24 = null;
function $createResource(this$static, parentResourceId, newResourceTypeId, deploymentTimeConfiguration, packageVersionId, timeout, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'createResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 6);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.configuration.Configuration/25349161'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Integer/3438268394'));
    append(streamWriter.encodeBuffer, '' + parentResourceId);
    append(streamWriter.encodeBuffer, '' + newResourceTypeId);
    $writeInt(streamWriter, $addString(streamWriter, null));
    $writeObject(streamWriter, deploymentTimeConfiguration);
    append(streamWriter.encodeBuffer, '' + packageVersionId);
    $writeObject(streamWriter, timeout);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to create a new resource'), ex);
      $closeDialog(callback.this$0.view);
    }
     else 
      throw $e0;
  }
}

function $createResource_0(this$static, parentResourceId, newResourceTypeId, newResourceName, newResourceConfiguration, timeout, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'createResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 5);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.configuration.Configuration/25349161'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Integer/3438268394'));
    append(streamWriter.encodeBuffer, '' + parentResourceId);
    append(streamWriter.encodeBuffer, '' + newResourceTypeId);
    $writeInt(streamWriter, $addString(streamWriter, newResourceName));
    $writeObject(streamWriter, newResourceConfiguration);
    $writeObject(streamWriter, timeout);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to create a new resource. Cannot connect to the agent. This may indicate that the agent is down.'), ex);
      $closeDialog(callback.this$0.view);
    }
     else 
      throw $e0;
  }
}

function $deleteResourceErrors(this$static, resourceErrorIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'deleteResourceErrors');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, resourceErrorIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete resource errors'), ex);
    }
     else 
      throw $e0;
  }
}

function $deleteResources(this$static, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'deleteResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete the selected resources.'), ex);
    }
     else 
      throw $e0;
  }
}

function $disableResources(this$static, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'disableResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to disable the selected resources.'), ex);
      $refreshTableInfo(callback.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $enableResources(this$static, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'enableResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to enable the selected resources.'), ex);
      $refreshTableInfo(callback.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $findCreateChildResourceHistory(this$static, parentId, beginDate, endDate, pc, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'findCreateChildResourceHistory');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 4);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Long/4227064769'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Long/4227064769'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.util.PageControl/1930924326'));
    append(streamWriter.encodeBuffer, '' + parentId);
    $writeObject(streamWriter, beginDate);
    $writeObject(streamWriter, endDate);
    $writeObject(streamWriter, pc);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to load child create history'), ex);
    }
     else 
      throw $e0;
  }
}

function $findDeleteChildResourceHistory(this$static, parentId, beginDate, endDate, pc, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'findDeleteChildResourceHistory');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 4);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Long/4227064769'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.Long/4227064769'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.util.PageControl/1930924326'));
    append(streamWriter.encodeBuffer, '' + parentId);
    $writeObject(streamWriter, beginDate);
    $writeObject(streamWriter, endDate);
    $writeObject(streamWriter, pc);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to load child delete history'), ex);
    }
     else 
      throw $e0;
  }
}

function $findProblemResources(this$static, ctime, maxItems, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'findProblemResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $append_3(streamWriter, toBase64(ctime));
    append(streamWriter.encodeBuffer, '' + maxItems);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_53(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $findRecentlyAddedResources(this$static, ctime, maxItems, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'findRecentlyAddedResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'J'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $append_3(streamWriter, toBase64(ctime));
    append(streamWriter.encodeBuffer, '' + maxItems);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_RecentlyAddedResourceDS() , 'Failed to load recently added resources'), ex);
    }
     else 
      throw $e0;
  }
}

function $findResourceComplianceCounts(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'findResourceComplianceCounts');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_51(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $findResourceCompositesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'findResourceCompositesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.ResourceCriteria/696615903'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findResourceErrors(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'findResourceErrors');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findResourceInstallCounts(this$static, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'findResourceInstallCounts');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '1');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_52(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $findResourcesByCriteriaBounded(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'findResourcesByCriteriaBounded');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.ResourceCriteria/696615903'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeObject(streamWriter, criteria);
    append(streamWriter.encodeBuffer, '-1');
    append(streamWriter.encodeBuffer, '-1');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_40(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getQueuedPlatformsAndServers(this$static, statuses, pc, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'getQueuedPlatformsAndServers');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.HashSet/3273092938'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.util.PageControl/1930924326'));
    $writeObject(streamWriter, statuses);
    $writeObject(streamWriter, pc);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_AutodiscoveryQueueDataSource() , 'Failed to load the inventory discovery queue'), ex);
    }
     else 
      throw $e0;
  }
}

function $getResourceAvailabilitySummary(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'getResourceAvailabilitySummary');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $setValue_7(callback.this$0.currentField, ($clinit_Enhanced() , 'Error'));
      $handleError_0(($clinit_CoreGUI() , 'Failed to load resource availability summary'), ex);
    }
     else 
      throw $e0;
  }
}

function $getResourceLineageAndSiblings(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'getResourceLineageAndSiblings');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_41(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getResourcesAncestry(this$static, resourceIds, format, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'getResourcesAncestry');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.resource.ResourceAncestryFormat/2070313567'));
    $writeObject(streamWriter, resourceIds);
    $writeObject(streamWriter, format);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $ignoreResources(this$static, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'ignoreResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $importResources(this$static, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'importResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to import Resources'), ex);
    }
     else 
      throw $e0;
  }
}

function $manuallyAddResource(this$static, resourceTypeId, parentResourceId, pluginConfiguration, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'manuallyAddResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.configuration.Configuration/25349161'));
    append(streamWriter.encodeBuffer, '' + resourceTypeId);
    append(streamWriter.encodeBuffer, '' + parentResourceId);
    $writeObject(streamWriter, pluginConfiguration);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to manually import resource'), ex);
      $closeDialog(callback.this$0.view);
    }
     else 
      throw $e0;
  }
}

function $unignoreAndImportResources(this$static, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'unignoreAndImportResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to unignore resources'), ex);
      $refreshTableInfo(callback.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $unignoreResources(this$static, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'unignoreResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to unignore Resources'), ex);
    }
     else 
      throw $e0;
  }
}

function $uninventoryAllResourcesByAgent(this$static, agents, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'uninventoryAllResourcesByAgent');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[Lorg.rhq.core.domain.resource.Agent;/3064062917'));
    $writeObject(streamWriter, agents);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'The request to delete the selected agents failed.'), ex);
      $refresh(callback.this$1.this$0, false);
    }
     else 
      throw $e0;
  }
}

function $uninventoryResources(this$static, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'uninventoryResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to uninventory the selected resources'), ex);
      $refreshTableInfo(callback.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $updateResource(this$static, resource, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGWTService_Proxy', 'updateResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.resource.Resource/3079242432'));
    $writeObject(streamWriter, resource);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $createGroupDefinition(this$static, groupDefinition, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'createGroupDefinition');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.resource.group.GroupDefinition/46110691'));
    $writeObject(streamWriter, groupDefinition);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_31(callback);
    }
     else 
      throw $e0;
  }
}

function $createPrivateResourceGroup(this$static, group, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'createPrivateResourceGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, group);
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $hide(callback.this$1.this$0.loadingLabel);
      callback.val$callback.onFailure(new RuntimeException_2(($clinit_Enhanced() , 'Failed to create view for this node'), ex));
    }
     else 
      throw $e0;
  }
}

function $createResourceGroup(this$static, group, resourceIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'createResourceGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, group);
    $writeObject(streamWriter, resourceIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_38(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $deleteGroupDefinitions(this$static, groupDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'deleteGroupDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, groupDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete the selected group definitions'), ex);
    }
     else 
      throw $e0;
  }
}

function $deleteResourceGroups(this$static, groupIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'deleteResourceGroups');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, groupIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete the selected resource groups'), ex);
      $refreshTableInfo(callback.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $findGroupDefinitionsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'findGroupDefinitionsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.ResourceGroupDefinitionCriteria/3833360384'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findResourceGroupsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'findResourceGroupsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.ResourceGroupCriteria/2939331650'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $recalculateGroupDefinitions(this$static, groupDefinitionIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'recalculateGroupDefinitions');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, groupDefinitionIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $setAssignedResourceGroupsForResource(this$static, resourceId, resourceGroupIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'setAssignedResourceGroupsForResource');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, resourceGroupIds);
    append(streamWriter.encodeBuffer, '1');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update assigned Resource groups.'), ex);
    }
     else 
      throw $e0;
  }
}

function $setAssignedResources(this$static, groupId, resourceIds, setType, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'setAssignedResources');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 3);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + groupId);
    $writeObject(streamWriter, resourceIds);
    append(streamWriter.encodeBuffer, setType?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $setRecursive_1(this$static, groupId, isRecursive, callback){
  var $e0, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'setRecursive');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + groupId);
    append(streamWriter.encodeBuffer, isRecursive?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      $handleError_0(($clinit_CoreGUI() , 'Failed to update the recursive setting for group [' + ($clinit_Enhanced() , '' + callback.val$group.name_0) + ']'), null);
    }
     else 
      throw $e0;
  }
}

function $updateGroupDefinition(this$static, groupDefinition, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'updateGroupDefinition');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.resource.group.GroupDefinition/46110691'));
    $writeObject(streamWriter, groupDefinition);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to save the group definition named [' + ($clinit_RPCDataSource() , callback.val$name) + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateResourceGroup(this$static, group, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceGroupGWTService_Proxy', 'updateResourceGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    $writeObject(streamWriter, group);
    append(streamWriter.encodeBuffer, '0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getAllResourceTypeAncestors(this$static, resourceTypeId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceTypeGWTService_Proxy', 'getAllResourceTypeAncestors');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceTypeGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceTypeId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get type ancestry'), ex);
    }
     else 
      throw $e0;
  }
}

function $getResourceTypeDescendantsWithOperations(this$static, resourceTypeId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceTypeGWTService_Proxy', 'getResourceTypeDescendantsWithOperations');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceTypeGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceTypeId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get type descendants'), ex);
    }
     else 
      throw $e0;
  }
}

function $getResourceTypesForResourceAncestors(this$static, resourceId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceTypeGWTService_Proxy', 'getResourceTypesForResourceAncestors');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceTypeGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get type ancestry'), ex);
    }
     else 
      throw $e0;
  }
}

function $getTemplateCountCompositeMap(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceTypeGWTService_Proxy', 'getTemplateCountCompositeMap');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceTypeGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_ResourceTypeTreeNodeBuilder() , 'Failed to load resource types'), ex);
    }
     else 
      throw $e0;
  }
}

function $setResourceTypeIgnoreFlag(this$static, resourceTypeId, ignoreFlag, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'ResourceTypeGWTService_Proxy', 'setResourceTypeIgnoreFlag');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.ResourceTypeGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'Z'));
    append(streamWriter.encodeBuffer, '' + resourceTypeId);
    append(streamWriter.encodeBuffer, ignoreFlag?'1':'0');
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to set the ignore flag on the selected resource type.'), ex);
    }
     else 
      throw $e0;
  }
}

function getInstance_52(){
  var target;
  if (!instance_29) {
    instance_29 = new RoleGWTService_Proxy_0;
    target = instance_29;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'RoleGWTService');
  }
  return instance_29;
}

var instance_29 = null;
function $clinit_RoleGWTService_Proxy(){
  $clinit_RoleGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_27 = new RoleGWTService_TypeSerializer_0;
}

function $createRole(this$static, role, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'RoleGWTService_Proxy', 'createRole');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.authz.Role/778387136'));
    $writeObject(streamWriter, role);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_0(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $findRolesByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'RoleGWTService_Proxy', 'findRolesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.RoleCriteria/3901094133'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $removeRoles(this$static, roleIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'RoleGWTService_Proxy', 'removeRoles');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, roleIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $sendFailureResponse(callback.this$0, callback.val$request, callback.val$response, 'Failed to delete role [' + ($clinit_RPCDataSource() , callback.val$rolename) + '].', ex);
    }
     else 
      throw $e0;
  }
}

function $updateRole(this$static, role, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'RoleGWTService_Proxy', 'updateRole');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.RoleGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.authz.Role/778387136'));
    $writeObject(streamWriter, role);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $sendFailureResponse(callback.this$0, callback.val$request, callback.val$response, 'Failed to update role [' + ($clinit_RPCDataSource() , callback.val$rolename) + '].', ex);
    }
     else 
      throw $e0;
  }
}

function RoleGWTService_Proxy_0(){
  $clinit_RoleGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, 'A08CFA215A6A962E10C7C1AC6E6A2256', SERIALIZER_27);
}

defineSeed(2870, 2784, makeCastMap([Q$RoleGWTServiceAsync]), RoleGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_28(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_27;
function $clinit_RoleGWTService_TypeSerializer(){
  $clinit_RoleGWTService_TypeSerializer = nullMethod;
  methodMapNative_28 = loadMethodsNative_27();
  signatureMapNative_28 = loadSignaturesNative_27();
}

function RoleGWTService_TypeSerializer_0(){
  $clinit_RoleGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_28, signatureMapNative_28);
}

function loadMethodsNative_27(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10, serialize_2];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['[I/2970817851'] = [undefined, undefined, serialize_3];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101, serialize_49];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93, serialize_40];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90, serialize_37];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91, serialize_38];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92, serialize_39];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97, serialize_44];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96, serialize_43];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98, serialize_45];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94, serialize_41];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95, serialize_42];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99, serialize_46];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100, serialize_48];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102, serialize_50];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106, serialize_54];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104, serialize_52];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103, serialize_51];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105, serialize_53];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107, serialize_55];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108, serialize_56];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110, serialize_59];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127, serialize_76];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113, serialize_62];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111, serialize_60];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112, serialize_61];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115, serialize_64];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114, serialize_63];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117, serialize_66];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116, serialize_65];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123, serialize_72];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120, serialize_69];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119, serialize_68];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121, serialize_70];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118, serialize_67];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122, serialize_71];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124, serialize_73];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126, serialize_75];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125, serialize_74];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130, serialize_77];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141, serialize_83];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142, serialize_85];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140, serialize_82];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157, serialize_97];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162, serialize_102];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161, serialize_101];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163, serialize_103];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164, serialize_104];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173, serialize_113];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172, serialize_112];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174, serialize_116];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175, serialize_117];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176, serialize_118];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177, serialize_119];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183, serialize_125];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179, serialize_121];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178, serialize_120];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180, serialize_122];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181, serialize_123];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182, serialize_124];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184, serialize_126];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186, serialize_128];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187, serialize_129];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185, serialize_127];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188, serialize_130];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190, serialize_132];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191, serialize_133];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192, serialize_134];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193, serialize_135];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196, serialize_138];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195, serialize_137];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198, serialize_140];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197, serialize_139];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201, serialize_143];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199, serialize_141];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200, serialize_142];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203, serialize_144];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204, serialize_145];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205, serialize_146];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207, serialize_148];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206, serialize_147];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211, serialize_152];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209, serialize_150];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208, serialize_149];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210, serialize_151];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212, serialize_153];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214, serialize_155];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213, serialize_154];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215, serialize_156];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219, serialize_160];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218, serialize_159];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216, serialize_157];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217, serialize_158];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230, serialize_170];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221, serialize_162];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220, serialize_161];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222, serialize_163];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224, serialize_165];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223, serialize_164];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225, serialize_166];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229, serialize_169];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227, serialize_167];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231, serialize_171];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244, serialize_184];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232, serialize_172];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233, serialize_173];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234, serialize_174];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236, serialize_176];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235, serialize_175];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237, serialize_177];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239, serialize_179];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238, serialize_178];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240, serialize_180];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241, serialize_181];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243, serialize_183];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242, serialize_182];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245, serialize_185];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248, serialize_186];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.RoleCriteria/3901094133'] = [undefined, undefined, serialize_230];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252, serialize_239];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249, serialize_236];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250, serialize_237];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251, serialize_238];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255, serialize_243];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257, serialize_245];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260, serialize_247];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259, serialize_246];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278, serialize_261];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274, serialize_257];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276, serialize_259];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277, serialize_260];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285, serialize_266];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283, serialize_264];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284, serialize_265];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288, serialize_269];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289, serialize_270];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298, serialize_271];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300, serialize_273];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299, serialize_272];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302, serialize_275];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303, serialize_276];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312, serialize_278];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311, serialize_277];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314, serialize_279];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316, serialize_282];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318, serialize_284];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317, serialize_283];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337, serialize_291];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336, serialize_290];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339, serialize_292];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341, serialize_294];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340, serialize_293];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342, serialize_295];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344, serialize_297];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343, serialize_296];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345, serialize_298];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346, serialize_300];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348, serialize_301];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349, serialize_302];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360, serialize_314];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350, serialize_305];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351, serialize_306];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354, serialize_309];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352, serialize_307];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353, serialize_308];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356, serialize_311];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355, serialize_310];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358, serialize_312];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359, serialize_313];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375, serialize_318];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376, serialize_319];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378, serialize_320];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380, serialize_322];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379, serialize_321];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394, serialize_325];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395, serialize_326];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_27(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(_3I_classLit)] = '[I/2970817851';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_RoleCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.RoleCriteria/3901094133';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2871, 278, {}, RoleGWTService_TypeSerializer_0);
var methodMapNative_28 = null, signatureMapNative_28 = null;
function $checkAuthentication(this$static, username, password, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SubjectGWTService_Proxy', 'checkAuthentication');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, username));
    $writeInt(streamWriter, $addString(streamWriter, password));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_11(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $createSubject(this$static, subjectToCreate, password, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SubjectGWTService_Proxy', 'createSubject');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.auth.Subject/2142285947'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeObject(streamWriter, subjectToCreate);
    $writeInt(streamWriter, $addString(streamWriter, password));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_7(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $deleteSubjects(this$static, subjectIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SubjectGWTService_Proxy', 'deleteSubjects');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, subjectIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_9(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $isUserWithPrincipal(this$static, username, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SubjectGWTService_Proxy', 'isUserWithPrincipal');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeInt(streamWriter, $addString(streamWriter, username));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , BOOLEAN));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_6(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $updateSubject(this$static, subjectToModify, newPassword, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SubjectGWTService_Proxy', 'updateSubject');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.auth.Subject/2142285947'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.lang.String/2004016611'));
    $writeObject(streamWriter, subjectToModify);
    $writeInt(streamWriter, $addString(streamWriter, newPassword));
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_8(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $updateSubjectPreferences(this$static, subjectToModify, changedPrefs, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SubjectGWTService_Proxy', 'updateSubjectPreferences');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.auth.Subject/2142285947'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.Set'));
    $writeObject(streamWriter, subjectToModify);
    $writeObject(streamWriter, changedPrefs);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $dumpToLog(this$static, callback){
  var $e0, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SystemGWTService_Proxy', 'dumpToLog');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Writing of system info to server log file failed'), ($clinit_Message$Severity() , Warning)));
    }
     else 
      throw $e0;
  }
}

function $getAgentVersionProperties(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SystemGWTService_Proxy', 'getAgentVersionProperties');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get agent version info'), ex);
    }
     else 
      throw $e0;
  }
}

function $getBundleDeployerDownload(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SystemGWTService_Proxy', 'getBundleDeployerDownload');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get bundle deployer info'), ex);
    }
     else 
      throw $e0;
  }
}

function $getCliAlertScriptDownloads(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SystemGWTService_Proxy', 'getCliAlertScriptDownloads');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get info on available CLI alert scripts for download'), ex);
    }
     else 
      throw $e0;
  }
}

function $getClientVersionProperties(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SystemGWTService_Proxy', 'getClientVersionProperties');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get CLI version info'), ex);
    }
     else 
      throw $e0;
  }
}

function $getConnectorDownloads(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SystemGWTService_Proxy', 'getConnectorDownloads');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get connectors info'), ex);
    }
     else 
      throw $e0;
  }
}

function $getScriptModulesDownloads(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SystemGWTService_Proxy', 'getScriptModulesDownloads');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot load the list of available script modules'), ex);
    }
     else 
      throw $e0;
  }
}

function $getServerDetails(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SystemGWTService_Proxy', 'getServerDetails');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot load server details'), ex);
    }
     else 
      throw $e0;
  }
}

function $isLdapAuthorizationEnabled(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SystemGWTService_Proxy', 'isLdapAuthorizationEnabled');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to determine if LDAP authorization is enabled. Perhaps the Server is down.'), ex);
    }
     else 
      throw $e0;
  }
}

function $setSystemSettings(this$static, settings, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'SystemGWTService_Proxy', 'setSystemSettings');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.SystemGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.common.composite.SystemSettings/3959179377'));
    $writeObject(streamWriter, settings);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to save the system settings'), ex);
    }
     else 
      throw $e0;
  }
}

function getInstance_56(){
  var target;
  if (!instance_33) {
    instance_33 = new TagGWTService_Proxy_0;
    target = instance_33;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'TagGWTService');
  }
  return instance_33;
}

var instance_33 = null;
function $clinit_TagGWTService_Proxy(){
  $clinit_TagGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_31 = new TagGWTService_TypeSerializer_0;
}

function $findTagReportCompositesByCriteria(this$static, tagCriteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TagGWTService_Proxy', 'findTagReportCompositesByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.TagCriteria/2681617711'));
    $writeObject(streamWriter, tagCriteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load tags.'), ex);
    }
     else 
      throw $e0;
  }
}

function $findTagsByCriteria(this$static, tagCriteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TagGWTService_Proxy', 'findTagsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.TagCriteria/2681617711'));
    $writeObject(streamWriter, tagCriteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load Tags'), ex);
    }
     else 
      throw $e0;
  }
}

function $removeTags(this$static, tags, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TagGWTService_Proxy', 'removeTags');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.Set'));
    $writeObject(streamWriter, tags);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to delete the tag [' + ($clinit_Enhanced() , $toString_20(callback.val$selected)) + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateBundleDeploymentTags(this$static, bundleDeploymentId, tags, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TagGWTService_Proxy', 'updateBundleDeploymentTags');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.Set'));
    append(streamWriter.encodeBuffer, '' + bundleDeploymentId);
    $writeObject(streamWriter, tags);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update bundle deployment tags'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateBundleDestinationTags(this$static, bundleDestinationId, tags, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TagGWTService_Proxy', 'updateBundleDestinationTags');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.Set'));
    append(streamWriter.encodeBuffer, '' + bundleDestinationId);
    $writeObject(streamWriter, tags);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update bundle destination tags'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateBundleTags(this$static, bundleId, tags, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TagGWTService_Proxy', 'updateBundleTags');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.Set'));
    append(streamWriter.encodeBuffer, '' + bundleId);
    $writeObject(streamWriter, tags);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update bundle tags'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateBundleVersionTags(this$static, bundleVersionId, tags, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TagGWTService_Proxy', 'updateBundleVersionTags');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.Set'));
    append(streamWriter.encodeBuffer, '' + bundleVersionId);
    $writeObject(streamWriter, tags);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update bundle version tags'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateResourceGroupTags(this$static, resourceGroupId, tags, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TagGWTService_Proxy', 'updateResourceGroupTags');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.Set'));
    append(streamWriter.encodeBuffer, '' + resourceGroupId);
    $writeObject(streamWriter, tags);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to update the tags for [' + ($clinit_Enhanced() , callback.this$1.this$0.group.name_0) + ']'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateResourceTags(this$static, resourceId, tags, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TagGWTService_Proxy', 'updateResourceTags');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TagGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'java.util.Set'));
    append(streamWriter.encodeBuffer, '' + resourceId);
    $writeObject(streamWriter, tags);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update resource tags'), ex);
    }
     else 
      throw $e0;
  }
}

function TagGWTService_Proxy_0(){
  $clinit_TagGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '1C9D269321E1D93E2BD9C45F549169CB', SERIALIZER_31);
}

defineSeed(2882, 2784, makeCastMap([Q$TagGWTServiceAsync]), TagGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_32(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_31;
function $clinit_TagGWTService_TypeSerializer(){
  $clinit_TagGWTService_TypeSerializer = nullMethod;
  methodMapNative_32 = loadMethodsNative_31();
  signatureMapNative_32 = loadSignaturesNative_31();
}

function TagGWTService_TypeSerializer_0(){
  $clinit_TagGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_32, signatureMapNative_32);
}

function loadMethodsNative_31(){
  var result = {};
  result['[B/3308590456'] = [instantiate_10, deserialize_10, serialize_2];
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17, serialize_4];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Double/858496421'] = [instantiate_19, deserialize_19, serialize_5];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [instantiate_52, deserialize_54, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55, serialize_23];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [instantiate_59, deserialize_61, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62, serialize_27];
  result['java.util.IdentityHashMap/1839153020'] = [instantiate_61, deserialize_63, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [instantiate_62, deserialize_64, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65, serialize_30];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75, serialize_35];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.alert.Alert/3680804385'] = [instantiate_98, deserialize_101, serialize_49];
  result['org.rhq.core.domain.alert.AlertCondition/3582060383'] = [instantiate_90, deserialize_93, serialize_40];
  result['org.rhq.core.domain.alert.AlertConditionCategory/732929936'] = [instantiate_87, deserialize_90, serialize_37];
  result['org.rhq.core.domain.alert.AlertConditionLog/188964283'] = [instantiate_88, deserialize_91, serialize_38];
  result['[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691'] = [instantiate_89, deserialize_92, serialize_39];
  result['org.rhq.core.domain.alert.AlertDampening/2543338577'] = [instantiate_94, deserialize_97, serialize_44];
  result['org.rhq.core.domain.alert.AlertDampening$Category/3078582666'] = [instantiate_93, deserialize_96, serialize_43];
  result['org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756'] = [instantiate_95, deserialize_98, serialize_45];
  result['org.rhq.core.domain.alert.AlertDampeningEvent/3793738558'] = [instantiate_91, deserialize_94, serialize_41];
  result['org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271'] = [instantiate_92, deserialize_95, serialize_42];
  result['org.rhq.core.domain.alert.AlertDefinition/2987034427'] = [instantiate_96, deserialize_99, serialize_46];
  result['org.rhq.core.domain.alert.AlertPriority/3133369790'] = [instantiate_97, deserialize_100, serialize_48];
  result['org.rhq.core.domain.alert.BooleanExpression/2969111079'] = [instantiate_99, deserialize_102, serialize_50];
  result['org.rhq.core.domain.alert.notification.AlertNotification/3298883744'] = [instantiate_103, deserialize_106, serialize_54];
  result['org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847'] = [instantiate_101, deserialize_104, serialize_52];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866'] = [instantiate_100, deserialize_103, serialize_51];
  result['[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142'] = [instantiate_102, deserialize_105, serialize_53];
  result['org.rhq.core.domain.alert.notification.ResultState/3934021431'] = [instantiate_104, deserialize_107, serialize_55];
  result['org.rhq.core.domain.auth.Subject/2142285947'] = [instantiate_105, deserialize_108, serialize_56];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [instantiate_106, deserialize_109, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.authz.Role/778387136'] = [instantiate_107, deserialize_110, serialize_59];
  result['org.rhq.core.domain.bundle.Bundle/3198028616'] = [instantiate_124, deserialize_127, serialize_76];
  result['org.rhq.core.domain.bundle.BundleDeployment/2937857671'] = [instantiate_110, deserialize_113, serialize_62];
  result['org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947'] = [instantiate_108, deserialize_111, serialize_60];
  result['[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371'] = [instantiate_109, deserialize_112, serialize_61];
  result['org.rhq.core.domain.bundle.BundleDestination/636493047'] = [instantiate_112, deserialize_115, serialize_64];
  result['[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180'] = [instantiate_111, deserialize_114, serialize_63];
  result['org.rhq.core.domain.bundle.BundleFile/2382460540'] = [instantiate_114, deserialize_117, serialize_66];
  result['[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154'] = [instantiate_113, deserialize_116, serialize_65];
  result['org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293'] = [instantiate_120, deserialize_123, serialize_72];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292'] = [instantiate_117, deserialize_120, serialize_69];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863'] = [instantiate_116, deserialize_119, serialize_68];
  result['org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814'] = [instantiate_118, deserialize_121, serialize_70];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269'] = [instantiate_115, deserialize_118, serialize_67];
  result['[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760'] = [instantiate_119, deserialize_122, serialize_71];
  result['org.rhq.core.domain.bundle.BundleType/1514209875'] = [instantiate_121, deserialize_124, serialize_73];
  result['org.rhq.core.domain.bundle.BundleVersion/1487029442'] = [instantiate_123, deserialize_126, serialize_75];
  result['[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943'] = [instantiate_122, deserialize_125, serialize_74];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130, serialize_77];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141, serialize_83];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142, serialize_85];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140, serialize_82];
  result['org.rhq.core.domain.configuration.Configuration/25349161'] = [instantiate_153, deserialize_158, serialize_98];
  result['org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723'] = [instantiate_152, deserialize_157, serialize_97];
  result['org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711'] = [instantiate_155, deserialize_160, serialize_100];
  result['[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049'] = [instantiate_154, deserialize_159, serialize_99];
  result['org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757'] = [instantiate_157, deserialize_162, serialize_102];
  result['[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913'] = [instantiate_156, deserialize_161, serialize_101];
  result['org.rhq.core.domain.configuration.Property/1616546008'] = [instantiate_165, deserialize_170, serialize_110];
  result['org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424'] = [instantiate_158, deserialize_163, serialize_103];
  result['org.rhq.core.domain.configuration.PropertyDynamicType/1531466778'] = [instantiate_159, deserialize_164, serialize_104];
  result['org.rhq.core.domain.configuration.PropertyList/3894047256'] = [instantiate_160, deserialize_165, serialize_105];
  result['org.rhq.core.domain.configuration.PropertyMap/2096336716'] = [instantiate_161, deserialize_166, serialize_106];
  result['org.rhq.core.domain.configuration.PropertySimple/4089167759'] = [instantiate_163, deserialize_168, serialize_108];
  result['[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955'] = [instantiate_162, deserialize_167, serialize_107];
  result['[Lorg.rhq.core.domain.configuration.Property;/2281104159'] = [instantiate_164, deserialize_169, serialize_109];
  result['org.rhq.core.domain.configuration.RawConfiguration/2708391084'] = [instantiate_166, deserialize_171, serialize_111];
  result['org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670'] = [instantiate_168, deserialize_173, serialize_113];
  result['[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323'] = [instantiate_167, deserialize_172, serialize_112];
  result['org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381'] = [instantiate_169, deserialize_174, serialize_116];
  result['org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246'] = [instantiate_170, deserialize_175, serialize_117];
  result['org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628'] = [instantiate_171, deserialize_176, serialize_118];
  result['org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370'] = [instantiate_172, deserialize_177, serialize_119];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407'] = [instantiate_178, deserialize_183, serialize_125];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519'] = [instantiate_174, deserialize_179, serialize_121];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712'] = [instantiate_173, deserialize_178, serialize_120];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192'] = [instantiate_175, deserialize_180, serialize_122];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759'] = [instantiate_176, deserialize_181, serialize_123];
  result['org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070'] = [instantiate_177, deserialize_182, serialize_124];
  result['org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662'] = [instantiate_179, deserialize_184, serialize_126];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542'] = [instantiate_181, deserialize_186, serialize_128];
  result['org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520'] = [instantiate_182, deserialize_187, serialize_129];
  result['[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324'] = [instantiate_180, deserialize_185, serialize_127];
  result['org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854'] = [instantiate_183, deserialize_188, serialize_130];
  result['org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999'] = [instantiate_184, deserialize_190, serialize_132];
  result['org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727'] = [instantiate_185, deserialize_191, serialize_133];
  result['org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199'] = [instantiate_186, deserialize_192, serialize_134];
  result['[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491'] = [instantiate_187, deserialize_193, serialize_135];
  result['org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182'] = [instantiate_189, deserialize_196, serialize_138];
  result['[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257'] = [instantiate_188, deserialize_195, serialize_137];
  result['org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133'] = [instantiate_191, deserialize_198, serialize_140];
  result['[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097'] = [instantiate_190, deserialize_197, serialize_139];
  result['org.rhq.core.domain.content.Advisory/31828033'] = [instantiate_194, deserialize_201, serialize_143];
  result['org.rhq.core.domain.content.AdvisoryBuglist/859134265'] = [instantiate_192, deserialize_199, serialize_141];
  result['org.rhq.core.domain.content.AdvisoryPackage/634549372'] = [instantiate_193, deserialize_200, serialize_142];
  result['org.rhq.core.domain.content.Architecture/3628471854'] = [instantiate_196, deserialize_203, serialize_144];
  result['org.rhq.core.domain.content.ContentRequestStatus/3251318814'] = [instantiate_197, deserialize_204, serialize_145];
  result['org.rhq.core.domain.content.ContentRequestType/2359775833'] = [instantiate_198, deserialize_205, serialize_146];
  result['org.rhq.core.domain.content.ContentServiceRequest/2472282631'] = [instantiate_200, deserialize_207, serialize_148];
  result['[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562'] = [instantiate_199, deserialize_206, serialize_147];
  result['org.rhq.core.domain.content.ContentSource/3026819646'] = [instantiate_204, deserialize_211, serialize_152];
  result['org.rhq.core.domain.content.ContentSourceSyncResults/4202887317'] = [instantiate_202, deserialize_209, serialize_150];
  result['[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198'] = [instantiate_201, deserialize_208, serialize_149];
  result['org.rhq.core.domain.content.ContentSourceType/2533543398'] = [instantiate_203, deserialize_210, serialize_151];
  result['org.rhq.core.domain.content.ContentSyncStatus/211493742'] = [instantiate_205, deserialize_212, serialize_153];
  result['org.rhq.core.domain.content.Distribution/2004966069'] = [instantiate_207, deserialize_214, serialize_155];
  result['org.rhq.core.domain.content.DistributionType/3880076577'] = [instantiate_206, deserialize_213, serialize_154];
  result['org.rhq.core.domain.content.DownloadMode/3083336366'] = [instantiate_208, deserialize_215, serialize_156];
  result['org.rhq.core.domain.content.InstalledPackage/1874072558'] = [instantiate_212, deserialize_219, serialize_160];
  result['org.rhq.core.domain.content.InstalledPackageHistory/3116883777'] = [instantiate_211, deserialize_218, serialize_159];
  result['org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969'] = [instantiate_209, deserialize_216, serialize_157];
  result['[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719'] = [instantiate_210, deserialize_217, serialize_158];
  result['org.rhq.core.domain.content.Package/1468621874'] = [instantiate_223, deserialize_230, serialize_170];
  result['org.rhq.core.domain.content.PackageBits/1223693023'] = [instantiate_214, deserialize_221, serialize_162];
  result['org.rhq.core.domain.content.PackageBitsBlob/460726052'] = [instantiate_213, deserialize_220, serialize_161];
  result['org.rhq.core.domain.content.PackageCategory/1473445532'] = [instantiate_215, deserialize_222, serialize_163];
  result['org.rhq.core.domain.content.PackageInstallationStep/921229985'] = [instantiate_217, deserialize_224, serialize_165];
  result['[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897'] = [instantiate_216, deserialize_223, serialize_164];
  result['org.rhq.core.domain.content.PackageType/1332663421'] = [instantiate_218, deserialize_225, serialize_166];
  result['org.rhq.core.domain.content.PackageVersion/3029199578'] = [instantiate_222, deserialize_229, serialize_169];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['[Lorg.rhq.core.domain.content.PackageVersion;/2263270277'] = [instantiate_220, deserialize_227, serialize_167];
  result['org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258'] = [instantiate_224, deserialize_231, serialize_171];
  result['org.rhq.core.domain.content.Repo/3189790231'] = [instantiate_237, deserialize_244, serialize_184];
  result['org.rhq.core.domain.content.RepoAdvisory/2143705960'] = [instantiate_225, deserialize_232, serialize_172];
  result['org.rhq.core.domain.content.RepoContentSource/1841647696'] = [instantiate_226, deserialize_233, serialize_173];
  result['org.rhq.core.domain.content.RepoDistribution/525647308'] = [instantiate_227, deserialize_234, serialize_174];
  result['org.rhq.core.domain.content.RepoGroup/991170282'] = [instantiate_229, deserialize_236, serialize_176];
  result['org.rhq.core.domain.content.RepoGroupType/329159940'] = [instantiate_228, deserialize_235, serialize_175];
  result['org.rhq.core.domain.content.RepoPackageVersion/1706074502'] = [instantiate_230, deserialize_237, serialize_177];
  result['org.rhq.core.domain.content.RepoRelationship/2475149249'] = [instantiate_232, deserialize_239, serialize_179];
  result['org.rhq.core.domain.content.RepoRelationshipType/3548564992'] = [instantiate_231, deserialize_238, serialize_178];
  result['org.rhq.core.domain.content.RepoRepoGroup/4061618357'] = [instantiate_233, deserialize_240, serialize_180];
  result['org.rhq.core.domain.content.RepoRepoRelationship/396059845'] = [instantiate_234, deserialize_241, serialize_181];
  result['org.rhq.core.domain.content.RepoSyncResults/3157485661'] = [instantiate_236, deserialize_243, serialize_183];
  result['[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280'] = [instantiate_235, deserialize_242, serialize_182];
  result['org.rhq.core.domain.content.ResourceRepo/668649902'] = [instantiate_238, deserialize_245, serialize_185];
  result['org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206'] = [instantiate_241, deserialize_248, serialize_186];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.TagCriteria/2681617711'] = [undefined, undefined, serialize_234];
  result['org.rhq.core.domain.dashboard.Dashboard/3980701481'] = [instantiate_245, deserialize_252, serialize_239];
  result['org.rhq.core.domain.dashboard.DashboardCategory/2683189525'] = [instantiate_242, deserialize_249, serialize_236];
  result['org.rhq.core.domain.dashboard.DashboardPortlet/1955200619'] = [instantiate_243, deserialize_250, serialize_237];
  result['[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909'] = [instantiate_244, deserialize_251, serialize_238];
  result['org.rhq.core.domain.drift.DriftComplianceStatus/33029538'] = [instantiate_248, deserialize_255, serialize_243];
  result['org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172'] = [instantiate_250, deserialize_257, serialize_245];
  result['org.rhq.core.domain.drift.DriftDefinition/1887203450'] = [instantiate_253, deserialize_260, serialize_247];
  result['org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346'] = [instantiate_252, deserialize_259, serialize_246];
  result['org.rhq.core.domain.event.Event/2811013572'] = [instantiate_271, deserialize_278, serialize_261];
  result['org.rhq.core.domain.event.EventDefinition/2699359109'] = [instantiate_267, deserialize_274, serialize_257];
  result['org.rhq.core.domain.event.EventSeverity/3378001564'] = [instantiate_269, deserialize_276, serialize_259];
  result['org.rhq.core.domain.event.EventSource/216722179'] = [instantiate_270, deserialize_277, serialize_260];
  result['org.rhq.core.domain.measurement.Availability/1103866409'] = [instantiate_278, deserialize_285, serialize_266];
  result['org.rhq.core.domain.measurement.AvailabilityType/3089675678'] = [instantiate_276, deserialize_283, serialize_264];
  result['[Lorg.rhq.core.domain.measurement.Availability;/2605243487'] = [instantiate_277, deserialize_284, serialize_265];
  result['org.rhq.core.domain.measurement.DataType/1753764592'] = [instantiate_279, deserialize_286, serialize_267];
  result['org.rhq.core.domain.measurement.DisplayType/4072059336'] = [instantiate_280, deserialize_287, serialize_268];
  result['org.rhq.core.domain.measurement.MeasurementBaseline/328698208'] = [instantiate_281, deserialize_288, serialize_269];
  result['org.rhq.core.domain.measurement.MeasurementCategory/3816227206'] = [instantiate_282, deserialize_289, serialize_270];
  result['org.rhq.core.domain.measurement.MeasurementDefinition/1210383336'] = [instantiate_290, deserialize_298, serialize_271];
  result['org.rhq.core.domain.measurement.MeasurementSchedule/1451131086'] = [instantiate_292, deserialize_300, serialize_273];
  result['[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348'] = [instantiate_291, deserialize_299, serialize_272];
  result['org.rhq.core.domain.measurement.MeasurementUnits/2898768038'] = [instantiate_293, deserialize_301, serialize_274];
  result['org.rhq.core.domain.measurement.NumericType/70192453'] = [instantiate_294, deserialize_302, serialize_275];
  result['org.rhq.core.domain.measurement.ResourceAvailability/598361861'] = [instantiate_295, deserialize_303, serialize_276];
  result['org.rhq.core.domain.operation.GroupOperationHistory/661799499'] = [instantiate_304, deserialize_312, serialize_278];
  result['[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331'] = [instantiate_303, deserialize_311, serialize_277];
  result['org.rhq.core.domain.operation.OperationDefinition/1431999465'] = [instantiate_306, deserialize_314, serialize_279];
  result['org.rhq.core.domain.operation.OperationRequestStatus/3544011188'] = [instantiate_307, deserialize_316, serialize_282];
  result['org.rhq.core.domain.operation.ResourceOperationHistory/2582746475'] = [instantiate_309, deserialize_318, serialize_284];
  result['[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395'] = [instantiate_308, deserialize_317, serialize_283];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337, serialize_291];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336, serialize_290];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.CreateDeletePolicy/1112938493'] = [instantiate_327, deserialize_339, serialize_292];
  result['org.rhq.core.domain.resource.CreateResourceHistory/548079365'] = [instantiate_329, deserialize_341, serialize_294];
  result['[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869'] = [instantiate_328, deserialize_340, serialize_293];
  result['org.rhq.core.domain.resource.CreateResourceStatus/2468970641'] = [instantiate_330, deserialize_342, serialize_295];
  result['org.rhq.core.domain.resource.DeleteResourceHistory/3534742503'] = [instantiate_332, deserialize_344, serialize_297];
  result['[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350'] = [instantiate_331, deserialize_343, serialize_296];
  result['org.rhq.core.domain.resource.DeleteResourceStatus/2008963358'] = [instantiate_333, deserialize_345, serialize_298];
  result['org.rhq.core.domain.resource.InventoryStatus/2314299133'] = [instantiate_334, deserialize_346, serialize_300];
  result['org.rhq.core.domain.resource.ProcessScan/2530486950'] = [instantiate_336, deserialize_348, serialize_301];
  result['org.rhq.core.domain.resource.ProductVersion/1267528663'] = [instantiate_337, deserialize_349, serialize_302];
  result['org.rhq.core.domain.resource.Resource/3079242432'] = [instantiate_348, deserialize_360, serialize_314];
  result['org.rhq.core.domain.resource.ResourceCategory/3688433171'] = [instantiate_338, deserialize_350, serialize_305];
  result['org.rhq.core.domain.resource.ResourceCreationDataType/720129671'] = [instantiate_339, deserialize_351, serialize_306];
  result['org.rhq.core.domain.resource.ResourceError/2684856881'] = [instantiate_342, deserialize_354, serialize_309];
  result['org.rhq.core.domain.resource.ResourceErrorType/249899197'] = [instantiate_340, deserialize_352, serialize_307];
  result['[Lorg.rhq.core.domain.resource.ResourceError;/1406667693'] = [instantiate_341, deserialize_353, serialize_308];
  result['org.rhq.core.domain.resource.ResourceSubCategory/425597984'] = [instantiate_344, deserialize_356, serialize_311];
  result['[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699'] = [instantiate_343, deserialize_355, serialize_310];
  result['org.rhq.core.domain.resource.ResourceType/1271544773'] = [instantiate_346, deserialize_358, serialize_312];
  result['[Lorg.rhq.core.domain.resource.Resource;/1593029016'] = [instantiate_347, deserialize_359, serialize_313];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.GroupCategory/2405008552'] = [instantiate_363, deserialize_375, serialize_318];
  result['org.rhq.core.domain.resource.group.GroupDefinition/46110691'] = [instantiate_364, deserialize_376, serialize_319];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.resource.group.LdapGroup/3712207452'] = [instantiate_366, deserialize_378, serialize_320];
  result['org.rhq.core.domain.resource.group.ResourceGroup/3781525022'] = [instantiate_368, deserialize_380, serialize_322];
  result['[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817'] = [instantiate_367, deserialize_379, serialize_321];
  result['org.rhq.core.domain.tagging.Tag/2115083344'] = [instantiate_382, deserialize_394, serialize_325];
  result['org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882'] = [instantiate_383, deserialize_395, serialize_326];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_31(){
  var result = [];
  result[getHashCode(_3B_classLit)] = '[B/3308590456';
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Double_2_classLit)] = 'java.lang.Double/858496421';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_alert_Alert_2_classLit)] = 'org.rhq.core.domain.alert.Alert/3680804385';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = 'org.rhq.core.domain.alert.AlertCondition/3582060383';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionCategory_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionCategory/732929936';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertConditionLog_2_classLit)] = 'org.rhq.core.domain.alert.AlertConditionLog/188964283';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_AlertCondition_2_classLit)] = '[Lorg.rhq.core.domain.alert.AlertCondition;/2167631691';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening/2543338577';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$Category_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$Category/3078582666';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampening$TimeUnits_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampening$TimeUnits/3289809756';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent/3793738558';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDampeningEvent$Type_2_classLit)] = 'org.rhq.core.domain.alert.AlertDampeningEvent$Type/420016271';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertDefinition_2_classLit)] = 'org.rhq.core.domain.alert.AlertDefinition/2987034427';
  result[getHashCode(Lorg_rhq_core_domain_alert_AlertPriority_2_classLit)] = 'org.rhq.core.domain.alert.AlertPriority/3133369790';
  result[getHashCode(Lorg_rhq_core_domain_alert_BooleanExpression_2_classLit)] = 'org.rhq.core.domain.alert.BooleanExpression/2969111079';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotification/3298883744';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = 'org.rhq.core.domain.alert.notification.AlertNotificationLog/2543935847';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotificationLog_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotificationLog;/350427866';
  result[getHashCode(_3Lorg_rhq_core_domain_alert_notification_AlertNotification_2_classLit)] = '[Lorg.rhq.core.domain.alert.notification.AlertNotification;/3072461142';
  result[getHashCode(Lorg_rhq_core_domain_alert_notification_ResultState_2_classLit)] = 'org.rhq.core.domain.alert.notification.ResultState/3934021431';
  result[getHashCode(Lorg_rhq_core_domain_auth_Subject_2_classLit)] = 'org.rhq.core.domain.auth.Subject/2142285947';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_authz_Role_2_classLit)] = 'org.rhq.core.domain.authz.Role/778387136';
  result[getHashCode(Lorg_rhq_core_domain_bundle_Bundle_2_classLit)] = 'org.rhq.core.domain.bundle.Bundle/3198028616';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeployment/2937857671';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDeploymentStatus_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDeploymentStatus/3085291947';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDeployment;/2643992371';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = 'org.rhq.core.domain.bundle.BundleDestination/636493047';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleDestination_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleDestination;/1725390180';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = 'org.rhq.core.domain.bundle.BundleFile/2382460540';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleFile_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleFile;/1933448154';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeployment/2578322293';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory/338379292';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Category_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Category/4055645863';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory$Status_2_classLit)] = 'org.rhq.core.domain.bundle.BundleResourceDeploymentHistory$Status/2628613814';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeploymentHistory_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeploymentHistory;/96954269';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleResourceDeployment_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleResourceDeployment;/2612215760';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleType_2_classLit)] = 'org.rhq.core.domain.bundle.BundleType/1514209875';
  result[getHashCode(Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = 'org.rhq.core.domain.bundle.BundleVersion/1487029442';
  result[getHashCode(_3Lorg_rhq_core_domain_bundle_BundleVersion_2_classLit)] = '[Lorg.rhq.core.domain.bundle.BundleVersion;/2627914943';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Configuration_2_classLit)] = 'org.rhq.core.domain.configuration.Configuration/25349161';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ConfigurationUpdateStatus_2_classLit)] = 'org.rhq.core.domain.configuration.ConfigurationUpdateStatus/23684723';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.ObfuscatedPropertySimple/1470168711';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ObfuscatedPropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ObfuscatedPropertySimple;/3504683049';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.PluginConfigurationUpdate/4042217757';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PluginConfigurationUpdate;/2325625913';
  result[getHashCode(Lorg_rhq_core_domain_configuration_Property_2_classLit)] = 'org.rhq.core.domain.configuration.Property/1616546008';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDefinitionDynamic_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDefinitionDynamic/1814887424';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyDynamicType_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyDynamicType/1531466778';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyList_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyList/3894047256';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertyMap_2_classLit)] = 'org.rhq.core.domain.configuration.PropertyMap/2096336716';
  result[getHashCode(Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = 'org.rhq.core.domain.configuration.PropertySimple/4089167759';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_PropertySimple_2_classLit)] = '[Lorg.rhq.core.domain.configuration.PropertySimple;/1023405955';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_Property_2_classLit)] = '[Lorg.rhq.core.domain.configuration.Property;/2281104159';
  result[getHashCode(Lorg_rhq_core_domain_configuration_RawConfiguration_2_classLit)] = 'org.rhq.core.domain.configuration.RawConfiguration/2708391084';
  result[getHashCode(Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.ResourceConfigurationUpdate/873538670';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_ResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.ResourceConfigurationUpdate;/1414041323';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ActivationPolicy_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ActivationPolicy/965726381';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationDefinition/2343178246';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationFormat_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationFormat/3666220628';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_ConfigurationTemplate_2_classLit)] = 'org.rhq.core.domain.configuration.definition.ConfigurationTemplate/2266193370';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinition/1743186407';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration/2392068519';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionEnumeration_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyDefinitionEnumeration;/3268069712';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionList_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionList/4150884192';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionMap/2538219759';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionSimple_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyDefinitionSimple/1422701070';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyGroupDefinition_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyGroupDefinition/4145857662';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource/2788574542';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource$TargetType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertyOptionsSource$TargetType/1692675520';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_definition_PropertyOptionsSource_2_classLit)] = '[Lorg.rhq.core.domain.configuration.definition.PropertyOptionsSource;/1680648324';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_PropertySimpleType_2_classLit)] = 'org.rhq.core.domain.configuration.definition.PropertySimpleType/2990894854';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_FloatRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.FloatRangeConstraint/3889191999';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_IntegerRangeConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.IntegerRangeConstraint/2783245727';
  result[getHashCode(Lorg_rhq_core_domain_configuration_definition_constraint_RegexConstraint_2_classLit)] = 'org.rhq.core.domain.configuration.definition.constraint.RegexConstraint/437362199';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_AbstractGroupConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.AbstractGroupConfigurationUpdate;/902172491';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate/2456576182';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupPluginConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;/3693785257';
  result[getHashCode(Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = 'org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate/514292133';
  result[getHashCode(_3Lorg_rhq_core_domain_configuration_group_GroupResourceConfigurationUpdate_2_classLit)] = '[Lorg.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;/771791097';
  result[getHashCode(Lorg_rhq_core_domain_content_Advisory_2_classLit)] = 'org.rhq.core.domain.content.Advisory/31828033';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryBuglist_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryBuglist/859134265';
  result[getHashCode(Lorg_rhq_core_domain_content_AdvisoryPackage_2_classLit)] = 'org.rhq.core.domain.content.AdvisoryPackage/634549372';
  result[getHashCode(Lorg_rhq_core_domain_content_Architecture_2_classLit)] = 'org.rhq.core.domain.content.Architecture/3628471854';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestStatus/3251318814';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentRequestType_2_classLit)] = 'org.rhq.core.domain.content.ContentRequestType/2359775833';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = 'org.rhq.core.domain.content.ContentServiceRequest/2472282631';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentServiceRequest_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentServiceRequest;/2820129562';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSource_2_classLit)] = 'org.rhq.core.domain.content.ContentSource/3026819646';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceSyncResults/4202887317';
  result[getHashCode(_3Lorg_rhq_core_domain_content_ContentSourceSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.ContentSourceSyncResults;/3088417198';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSourceType_2_classLit)] = 'org.rhq.core.domain.content.ContentSourceType/2533543398';
  result[getHashCode(Lorg_rhq_core_domain_content_ContentSyncStatus_2_classLit)] = 'org.rhq.core.domain.content.ContentSyncStatus/211493742';
  result[getHashCode(Lorg_rhq_core_domain_content_Distribution_2_classLit)] = 'org.rhq.core.domain.content.Distribution/2004966069';
  result[getHashCode(Lorg_rhq_core_domain_content_DistributionType_2_classLit)] = 'org.rhq.core.domain.content.DistributionType/3880076577';
  result[getHashCode(Lorg_rhq_core_domain_content_DownloadMode_2_classLit)] = 'org.rhq.core.domain.content.DownloadMode/3083336366';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackage_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackage/1874072558';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistory/3116883777';
  result[getHashCode(Lorg_rhq_core_domain_content_InstalledPackageHistoryStatus_2_classLit)] = 'org.rhq.core.domain.content.InstalledPackageHistoryStatus/1998064969';
  result[getHashCode(_3Lorg_rhq_core_domain_content_InstalledPackageHistory_2_classLit)] = '[Lorg.rhq.core.domain.content.InstalledPackageHistory;/3117915719';
  result[getHashCode(Lorg_rhq_core_domain_content_Package_2_classLit)] = 'org.rhq.core.domain.content.Package/1468621874';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBits_2_classLit)] = 'org.rhq.core.domain.content.PackageBits/1223693023';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageBitsBlob_2_classLit)] = 'org.rhq.core.domain.content.PackageBitsBlob/460726052';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageCategory_2_classLit)] = 'org.rhq.core.domain.content.PackageCategory/1473445532';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = 'org.rhq.core.domain.content.PackageInstallationStep/921229985';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageInstallationStep_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageInstallationStep;/1590296897';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageType_2_classLit)] = 'org.rhq.core.domain.content.PackageType/1332663421';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion/3029199578';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(_3Lorg_rhq_core_domain_content_PackageVersion_2_classLit)] = '[Lorg.rhq.core.domain.content.PackageVersion;/2263270277';
  result[getHashCode(Lorg_rhq_core_domain_content_ProductVersionPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.ProductVersionPackageVersion/2448417258';
  result[getHashCode(Lorg_rhq_core_domain_content_Repo_2_classLit)] = 'org.rhq.core.domain.content.Repo/3189790231';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoAdvisory_2_classLit)] = 'org.rhq.core.domain.content.RepoAdvisory/2143705960';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoContentSource_2_classLit)] = 'org.rhq.core.domain.content.RepoContentSource/1841647696';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoDistribution_2_classLit)] = 'org.rhq.core.domain.content.RepoDistribution/525647308';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoGroup/991170282';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoGroupType_2_classLit)] = 'org.rhq.core.domain.content.RepoGroupType/329159940';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoPackageVersion_2_classLit)] = 'org.rhq.core.domain.content.RepoPackageVersion/1706074502';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationship/2475149249';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRelationshipType_2_classLit)] = 'org.rhq.core.domain.content.RepoRelationshipType/3548564992';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoGroup_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoGroup/4061618357';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoRepoRelationship_2_classLit)] = 'org.rhq.core.domain.content.RepoRepoRelationship/396059845';
  result[getHashCode(Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = 'org.rhq.core.domain.content.RepoSyncResults/3157485661';
  result[getHashCode(_3Lorg_rhq_core_domain_content_RepoSyncResults_2_classLit)] = '[Lorg.rhq.core.domain.content.RepoSyncResults;/4203083280';
  result[getHashCode(Lorg_rhq_core_domain_content_ResourceRepo_2_classLit)] = 'org.rhq.core.domain.content.ResourceRepo/668649902';
  result[getHashCode(Lorg_rhq_core_domain_content_transfer_ContentResponseResult_2_classLit)] = 'org.rhq.core.domain.content.transfer.ContentResponseResult/3068163206';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_TagCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.TagCriteria/2681617711';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = 'org.rhq.core.domain.dashboard.Dashboard/3980701481';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardCategory_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardCategory/2683189525';
  result[getHashCode(Lorg_rhq_core_domain_dashboard_DashboardPortlet_2_classLit)] = 'org.rhq.core.domain.dashboard.DashboardPortlet/1955200619';
  result[getHashCode(_3Lorg_rhq_core_domain_dashboard_Dashboard_2_classLit)] = '[Lorg.rhq.core.domain.dashboard.Dashboard;/1759447909';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftComplianceStatus_2_classLit)] = 'org.rhq.core.domain.drift.DriftComplianceStatus/33029538';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftConfigurationDefinition$DriftHandlingMode_2_classLit)] = 'org.rhq.core.domain.drift.DriftConfigurationDefinition$DriftHandlingMode/864301172';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinition_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinition/1887203450';
  result[getHashCode(Lorg_rhq_core_domain_drift_DriftDefinitionTemplate_2_classLit)] = 'org.rhq.core.domain.drift.DriftDefinitionTemplate/2863694346';
  result[getHashCode(Lorg_rhq_core_domain_event_Event_2_classLit)] = 'org.rhq.core.domain.event.Event/2811013572';
  result[getHashCode(Lorg_rhq_core_domain_event_EventDefinition_2_classLit)] = 'org.rhq.core.domain.event.EventDefinition/2699359109';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSeverity_2_classLit)] = 'org.rhq.core.domain.event.EventSeverity/3378001564';
  result[getHashCode(Lorg_rhq_core_domain_event_EventSource_2_classLit)] = 'org.rhq.core.domain.event.EventSource/216722179';
  result[getHashCode(Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = 'org.rhq.core.domain.measurement.Availability/1103866409';
  result[getHashCode(Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit)] = 'org.rhq.core.domain.measurement.AvailabilityType/3089675678';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_Availability_2_classLit)] = '[Lorg.rhq.core.domain.measurement.Availability;/2605243487';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DataType_2_classLit)] = 'org.rhq.core.domain.measurement.DataType/1753764592';
  result[getHashCode(Lorg_rhq_core_domain_measurement_DisplayType_2_classLit)] = 'org.rhq.core.domain.measurement.DisplayType/4072059336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementBaseline_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementBaseline/328698208';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementCategory_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementCategory/3816227206';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementDefinition_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementDefinition/1210383336';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementSchedule/1451131086';
  result[getHashCode(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit)] = '[Lorg.rhq.core.domain.measurement.MeasurementSchedule;/1665177348';
  result[getHashCode(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)] = 'org.rhq.core.domain.measurement.MeasurementUnits/2898768038';
  result[getHashCode(Lorg_rhq_core_domain_measurement_NumericType_2_classLit)] = 'org.rhq.core.domain.measurement.NumericType/70192453';
  result[getHashCode(Lorg_rhq_core_domain_measurement_ResourceAvailability_2_classLit)] = 'org.rhq.core.domain.measurement.ResourceAvailability/598361861';
  result[getHashCode(Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.GroupOperationHistory/661799499';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_GroupOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.GroupOperationHistory;/2198102331';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationDefinition_2_classLit)] = 'org.rhq.core.domain.operation.OperationDefinition/1431999465';
  result[getHashCode(Lorg_rhq_core_domain_operation_OperationRequestStatus_2_classLit)] = 'org.rhq.core.domain.operation.OperationRequestStatus/3544011188';
  result[getHashCode(Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = 'org.rhq.core.domain.operation.ResourceOperationHistory/2582746475';
  result[getHashCode(_3Lorg_rhq_core_domain_operation_ResourceOperationHistory_2_classLit)] = '[Lorg.rhq.core.domain.operation.ResourceOperationHistory;/3436216395';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateDeletePolicy_2_classLit)] = 'org.rhq.core.domain.resource.CreateDeletePolicy/1112938493';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceHistory/548079365';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_CreateResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.CreateResourceHistory;/2893182869';
  result[getHashCode(Lorg_rhq_core_domain_resource_CreateResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.CreateResourceStatus/2468970641';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceHistory/3534742503';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_DeleteResourceHistory_2_classLit)] = '[Lorg.rhq.core.domain.resource.DeleteResourceHistory;/2073965350';
  result[getHashCode(Lorg_rhq_core_domain_resource_DeleteResourceStatus_2_classLit)] = 'org.rhq.core.domain.resource.DeleteResourceStatus/2008963358';
  result[getHashCode(Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit)] = 'org.rhq.core.domain.resource.InventoryStatus/2314299133';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProcessScan_2_classLit)] = 'org.rhq.core.domain.resource.ProcessScan/2530486950';
  result[getHashCode(Lorg_rhq_core_domain_resource_ProductVersion_2_classLit)] = 'org.rhq.core.domain.resource.ProductVersion/1267528663';
  result[getHashCode(Lorg_rhq_core_domain_resource_Resource_2_classLit)] = 'org.rhq.core.domain.resource.Resource/3079242432';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCategory/3688433171';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceCreationDataType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceCreationDataType/720129671';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = 'org.rhq.core.domain.resource.ResourceError/2684856881';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceErrorType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceErrorType/249899197';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceError_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceError;/1406667693';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = 'org.rhq.core.domain.resource.ResourceSubCategory/425597984';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_ResourceSubCategory_2_classLit)] = '[Lorg.rhq.core.domain.resource.ResourceSubCategory;/3691364699';
  result[getHashCode(Lorg_rhq_core_domain_resource_ResourceType_2_classLit)] = 'org.rhq.core.domain.resource.ResourceType/1271544773';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Resource_2_classLit)] = '[Lorg.rhq.core.domain.resource.Resource;/1593029016';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupCategory/2405008552';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_GroupDefinition_2_classLit)] = 'org.rhq.core.domain.resource.group.GroupDefinition/46110691';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_LdapGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.LdapGroup/3712207452';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = 'org.rhq.core.domain.resource.group.ResourceGroup/3781525022';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_group_ResourceGroup_2_classLit)] = '[Lorg.rhq.core.domain.resource.group.ResourceGroup;/911875817';
  result[getHashCode(Lorg_rhq_core_domain_tagging_Tag_2_classLit)] = 'org.rhq.core.domain.tagging.Tag/2115083344';
  result[getHashCode(Lorg_rhq_core_domain_tagging_compsite_TagReportComposite_2_classLit)] = 'org.rhq.core.domain.tagging.compsite.TagReportComposite/1865628882';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2883, 278, {}, TagGWTService_TypeSerializer_0);
var methodMapNative_32 = null, signatureMapNative_32 = null;
function getInstance_57(){
  var target;
  if (!instance_34) {
    instance_34 = new TopologyGWTService_Proxy_0;
    target = instance_34;
    $setServiceEntryPoint(target, getModuleBaseURL() + 'TopologyGWTService');
  }
  return instance_34;
}

var instance_34 = null;
function $clinit_TopologyGWTService_Proxy(){
  $clinit_TopologyGWTService_Proxy = nullMethod;
  $clinit_TrackingRemoteServiceProxy();
  SERIALIZER_32 = new TopologyGWTService_TypeSerializer_0;
}

function $addAgentsToGroup(this$static, affinityGroupId, agentIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'addAgentsToGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    append(streamWriter.encodeBuffer, '' + affinityGroupId);
    $writeObject(streamWriter, agentIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Unable to remove agents from the affinity group with id ' + ($clinit_Enhanced() , '' + callback.val$affinityGroupId) + '.'), ex);
    }
     else 
      throw $e0;
  }
}

function $addServersToGroup(this$static, affinityGroupId, serverIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'addServersToGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    append(streamWriter.encodeBuffer, '' + affinityGroupId);
    $writeObject(streamWriter, serverIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Unable to remove servers from the affinity group with id ' + ($clinit_Enhanced() , '' + callback.val$affinityGroupId) + '.'), ex);
    }
     else 
      throw $e0;
  }
}

function $cloudPartitionEventRequest(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'cloudPartitionEventRequest');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_4(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $createAffinityGroup(this$static, affinityGroup, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'createAffinityGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.cloud.AffinityGroup/2535509485'));
    $writeObject(streamWriter, affinityGroup);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_1(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $deleteAffinityGroups(this$static, affinityGroupIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'deleteAffinityGroups');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, affinityGroupIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , INT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Unable to remove following affinity groups(s) ' + ($clinit_Enhanced() , callback.val$selectedNames.toString$()) + '. ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$2.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $deletePartitionEvents(this$static, eventIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'deletePartitionEvents');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, eventIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_4(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $deleteServers(this$static, serverIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'deleteServers');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeObject(streamWriter, serverIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Unable to remove ' + ($clinit_Enhanced() , '' + callback.val$selections.length) + ' server(s). ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$2.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function $findAgentsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'findAgentsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.AgentCriteria/2669284604'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findPartitionEventsByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'findPartitionEventsByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.PartitionEventCriteria/2245581677'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $findServersByCriteria(this$static, criteria, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'findServersByCriteria');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.criteria.ServerCriteria/859500744'));
    $writeObject(streamWriter, criteria);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      callback.onFailure(ex);
    }
     else 
      throw $e0;
  }
}

function $getAffinityGroupById(this$static, affinityGroupId, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'getAffinityGroupById');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    append(streamWriter.encodeBuffer, '' + affinityGroupId);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Unable to fetch affinity group details for group with id ' + ($clinit_Enhanced() , '' + callback.this$0.affinityGroupId) + '.'), ex);
      callback.this$0.initSectionCount = 3;
    }
     else 
      throw $e0;
  }
}

function $getAffinityGroupCountComposites(this$static, pageControl, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'getAffinityGroupCountComposites');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.util.PageControl/1930924326'));
    $writeObject(streamWriter, pageControl);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_2(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getFailoverListDetailsByAgentId(this$static, agentId, pageControl, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'getFailoverListDetailsByAgentId');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.util.PageControl/1930924326'));
    append(streamWriter.encodeBuffer, '' + agentId);
    $writeObject(streamWriter, pageControl);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_3(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $getPartitionEventDetails(this$static, partitionEventId, pageControl, callback){
  var $e0, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'getPartitionEventDetails');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, 'I'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.util.PageControl/1930924326'));
    append(streamWriter.encodeBuffer, '' + partitionEventId);
    $writeObject(streamWriter, pageControl);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      $handleError_0(($clinit_CoreGUI() , 'Unable to fetch partition event details for event with id ' + ($clinit_Enhanced() , '' + callback.this$1.this$0.partitionEventId) + '.'), null);
      callback.this$1.this$0.initSectionCount = 2;
    }
     else 
      throw $e0;
  }
}

function $getServers(this$static, pageControl, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'getServers');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.util.PageControl/1930924326'));
    $writeObject(streamWriter, pageControl);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , OBJECT));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_5(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $purgeAllEvents(this$static, callback){
  var $e0, ex, helper;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'purgeAllEvents');
  try {
    $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 0);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $onFailure_4(callback, ex);
    }
     else 
      throw $e0;
  }
}

function $removeAgentsFromGroup(this$static, agentIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'removeAgentsFromGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeObject(streamWriter, agentIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Unable to assign agents to the affinity group with id ' + ($clinit_Enhanced() , '' + callback.val$affinityGroupId) + '.'), ex);
    }
     else 
      throw $e0;
  }
}

function $removeServersFromGroup(this$static, serverIds, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'removeServersFromGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, '[Ljava.lang.Integer;/1574882222'));
    $writeObject(streamWriter, serverIds);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Unable to assign servers to the affinity group with id ' + ($clinit_Enhanced() , '' + callback.val$affinityGroupId) + '.'), ex);
    }
     else 
      throw $e0;
  }
}

function $updateAffinityGroup(this$static, affinityGroup, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'updateAffinityGroup');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.cloud.AffinityGroup/2535509485'));
    $writeObject(streamWriter, affinityGroup);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Unable to rename affinity group with id ' + ($clinit_Enhanced() , '' + callback.this$1.this$0.affinityGroupId) + ' and name ' + callback.val$affinityGroup.name_0 + '. ' + ex.detailMessage), ex);
    }
     else 
      throw $e0;
  }
}

function $updateServer(this$static, server, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'updateServer');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 1);
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.cloud.Server/2668048662'));
    $writeObject(streamWriter, server);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Unable to update server ' + ($clinit_Enhanced() , callback.val$server.name_0) + '. ' + ex.detailMessage), ex);
    }
     else 
      throw $e0;
  }
}

function $updateServerMode(this$static, serverIds, mode, callback){
  var $e0, ex, helper, streamWriter;
  helper = new RemoteServiceProxy$ServiceHelper_0(this$static, 'TopologyGWTService_Proxy', 'updateServerMode');
  try {
    streamWriter = $start(helper, 'org.rhq.enterprise.gui.coregui.client.gwt.TopologyGWTService', 2);
    $writeInt(streamWriter, $addString(streamWriter, '[I/2970817851'));
    $writeInt(streamWriter, $addString(streamWriter, 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077'));
    $writeObject(streamWriter, serverIds);
    $writeObject(streamWriter, mode);
    $finish_0(helper, callback, ($clinit_RequestCallbackAdapter$ResponseReader() , VOID));
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$SerializationException)) {
      ex = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Unable to set ' + ($clinit_Enhanced() , '' + callback.val$selections.length) + ' server(s) to ' + callback.val$mode.name_0 + ' mode. ' + ex.detailMessage), ex);
      $refreshTableInfo(callback.this$2.this$1.this$0);
    }
     else 
      throw $e0;
  }
}

function TopologyGWTService_Proxy_0(){
  $clinit_TopologyGWTService_Proxy();
  TrackingRemoteServiceProxy_0.call(this, getModuleBaseURL(), null, '8384D82CF2497050A7866243F5D445EB', SERIALIZER_32);
}

defineSeed(2885, 2784, makeCastMap([Q$TopologyGWTServiceAsync]), TopologyGWTService_Proxy_0);
_.createStreamWriter = function createStreamWriter_33(){
  var toReturn;
  toReturn = $createStreamWriter(this);
  return toReturn;
}
;
var SERIALIZER_32;
function $clinit_TopologyGWTService_TypeSerializer(){
  $clinit_TopologyGWTService_TypeSerializer = nullMethod;
  methodMapNative_33 = loadMethodsNative_32();
  signatureMapNative_33 = loadSignaturesNative_32();
}

function TopologyGWTService_TypeSerializer_0(){
  $clinit_TopologyGWTService_TypeSerializer();
  SerializerBase_0.call(this, methodMapNative_33, signatureMapNative_33);
}

function loadMethodsNative_32(){
  var result = {};
  result['com.google.gwt.event.shared.UmbrellaException/3104463596'] = [instantiate, deserialize];
  result['com.google.gwt.http.client.RequestException/190587325'] = [instantiate_0, deserialize_0];
  result['com.google.gwt.json.client.JSONException/2941795468'] = [instantiate_2, deserialize_2];
  result['com.google.gwt.jsonp.client.TimeoutException/1112787596'] = [instantiate_3, deserialize_3];
  result['com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533'] = [instantiate_4, deserialize_4, serialize_0];
  result['com.google.gwt.user.client.rpc.RpcTokenException/2345075298'] = [instantiate_5, deserialize_5];
  result['com.google.gwt.user.client.rpc.SerializableException/3047383460'] = [instantiate_6, deserialize_6];
  result['com.google.gwt.user.client.rpc.SerializationException/2836333220'] = [instantiate_7, deserialize_7];
  result['com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580'] = [instantiate_8, deserialize_8];
  result['com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447'] = [instantiate_9, deserialize_9];
  result['com.google.gwt.user.client.rpc.XsrfToken/4254043109'] = [undefined, undefined, serialize_1];
  result['com.google.gwt.xml.client.impl.DOMParseException/3799120635'] = [instantiate_84, deserialize_87];
  result['com.google.web.bindery.event.shared.UmbrellaException/1025846929'] = [instantiate_85, deserialize_88];
  result['[I/2970817851'] = [undefined, undefined, serialize_3];
  result['java.io.IOException/1159940531'] = [instantiate_11, deserialize_11];
  result['java.io.UnsupportedEncodingException/1526756933'] = [instantiate_12, deserialize_12];
  result['java.lang.ArithmeticException/1539622151'] = [instantiate_13, deserialize_13];
  result['java.lang.ArrayIndexOutOfBoundsException/600550433'] = [instantiate_14, deserialize_14];
  result['java.lang.ArrayStoreException/3540507190'] = [instantiate_15, deserialize_15];
  result['java.lang.AssertionError/3490171458'] = [instantiate_16, deserialize_16];
  result['java.lang.Boolean/476441737'] = [instantiate_17, deserialize_17];
  result['java.lang.ClassCastException/702295179'] = [instantiate_18, deserialize_18];
  result['java.lang.Error/1331973429'] = [instantiate_20, deserialize_20];
  result['java.lang.Exception/1920171873'] = [instantiate_21, deserialize_21, serialize_6];
  result['java.lang.IllegalArgumentException/1755012560'] = [instantiate_22, deserialize_22];
  result['java.lang.IllegalStateException/1972187323'] = [instantiate_23, deserialize_23];
  result['java.lang.IndexOutOfBoundsException/2489527753'] = [instantiate_24, deserialize_24];
  result['java.lang.Integer/3438268394'] = [instantiate_26, deserialize_26, serialize_8];
  result['[Ljava.lang.Integer;/1574882222'] = [undefined, undefined, serialize_7];
  result['java.lang.Long/4227064769'] = [instantiate_27, deserialize_27, serialize_9];
  result['java.lang.NegativeArraySizeException/3846860241'] = [instantiate_28, deserialize_28];
  result['java.lang.NoSuchMethodException/260969707'] = [instantiate_29, deserialize_29];
  result['java.lang.NullPointerException/1463492344'] = [instantiate_30, deserialize_30];
  result['java.lang.NumberFormatException/3305228476'] = [instantiate_31, deserialize_31];
  result['java.lang.RuntimeException/515124647'] = [instantiate_32, deserialize_33, serialize_11];
  result['java.lang.String/2004016611'] = [instantiate_35, deserialize_36, serialize_13];
  result['java.lang.StringIndexOutOfBoundsException/500777603'] = [instantiate_33, deserialize_34];
  result['[Ljava.lang.String;/2600011424'] = [undefined, undefined, serialize_12];
  result['java.lang.Throwable/2953622131'] = [instantiate_36, deserialize_37, serialize_14];
  result['java.lang.UnsupportedOperationException/3744010015'] = [instantiate_37, deserialize_38];
  result['java.lang.annotation.AnnotationFormatError/2257184627'] = [instantiate_38, deserialize_39];
  result['java.lang.annotation.AnnotationTypeMismatchException/976205828'] = [instantiate_39, deserialize_40];
  result['java.security.DigestException/629316798'] = [instantiate_40, deserialize_41];
  result['java.security.GeneralSecurityException/2669239907'] = [instantiate_41, deserialize_42];
  result['java.security.NoSuchAlgorithmException/2892037213'] = [instantiate_42, deserialize_43];
  result['java.util.ArrayList/4159755760'] = [instantiate_49, deserialize_50, serialize_18];
  result['java.util.Arrays$ArrayList/2507071751'] = [instantiate_50, deserialize_51, serialize_19];
  result['java.util.Collections$EmptyList/4157118744'] = [instantiate_51, deserialize_53, serialize_21];
  result['java.util.Collections$EmptyMap/4174664486'] = [undefined, undefined, serialize_22];
  result['java.util.Collections$EmptySet/3523698179'] = [instantiate_53, deserialize_55];
  result['java.util.Collections$SingletonList/1586180994'] = [instantiate_54, deserialize_56, serialize_24];
  result['java.util.ConcurrentModificationException/2717383897'] = [instantiate_55, deserialize_57];
  result['java.util.EmptyStackException/89438517'] = [instantiate_57, deserialize_59];
  result['java.util.HashMap/1797211028'] = [undefined, undefined, serialize_26];
  result['java.util.HashSet/3273092938'] = [instantiate_60, deserialize_62];
  result['java.util.IdentityHashMap/1839153020'] = [undefined, undefined, serialize_28];
  result['java.util.LinkedHashMap/3008245022'] = [undefined, undefined, serialize_29];
  result['java.util.LinkedHashSet/1826081506'] = [instantiate_63, deserialize_65];
  result['java.util.LinkedList/3953877921'] = [instantiate_65, deserialize_67, serialize_31];
  result['java.util.NoSuchElementException/1559248883'] = [instantiate_67, deserialize_70];
  result['java.util.Stack/1346942793'] = [instantiate_69, deserialize_72, serialize_33];
  result['java.util.TooManyListenersException/2023078032'] = [instantiate_70, deserialize_73];
  result['java.util.TreeMap/1493889780'] = [instantiate_71, deserialize_74, serialize_34];
  result['java.util.TreeSet/4043497002'] = [instantiate_72, deserialize_75];
  result['java.util.Vector/3057315478'] = [instantiate_74, deserialize_77, serialize_36];
  result['javax.validation.ConstraintDeclarationException/3610544007'] = [instantiate_75, deserialize_78];
  result['javax.validation.ConstraintDefinitionException/3732439488'] = [instantiate_76, deserialize_79];
  result['javax.validation.ConstraintViolationException/1185386591'] = [instantiate_86, deserialize_89];
  result['javax.validation.GroupDefinitionException/4024780846'] = [instantiate_77, deserialize_80];
  result['javax.validation.UnexpectedTypeException/593026390'] = [instantiate_78, deserialize_81];
  result['javax.validation.ValidationException/1570221831'] = [instantiate_79, deserialize_82];
  result['org.rhq.core.domain.authz.Permission/1442357263'] = [undefined, undefined, serialize_58];
  result['[Lorg.rhq.core.domain.authz.Permission;/4248477598'] = [undefined, undefined, serialize_57];
  result['org.rhq.core.domain.cloud.AffinityGroup/2535509485'] = [instantiate_127, deserialize_130, serialize_77];
  result['org.rhq.core.domain.cloud.FailoverList/1011507657'] = [instantiate_131, deserialize_134];
  result['org.rhq.core.domain.cloud.FailoverListDetails/3728031575'] = [instantiate_129, deserialize_132];
  result['[Lorg.rhq.core.domain.cloud.FailoverListDetails;/2314641079'] = [instantiate_128, deserialize_131];
  result['[Lorg.rhq.core.domain.cloud.FailoverList;/2293397377'] = [instantiate_130, deserialize_133];
  result['org.rhq.core.domain.cloud.PartitionEvent/2698797229'] = [instantiate_136, deserialize_139];
  result['org.rhq.core.domain.cloud.PartitionEvent$ExecutionStatus/2309869088'] = [instantiate_135, deserialize_138, serialize_81];
  result['[Lorg.rhq.core.domain.cloud.PartitionEvent$ExecutionStatus;/3115597478'] = [undefined, undefined, serialize_80];
  result['org.rhq.core.domain.cloud.PartitionEventDetails/3716060296'] = [instantiate_133, deserialize_136];
  result['[Lorg.rhq.core.domain.cloud.PartitionEventDetails;/1076659955'] = [instantiate_132, deserialize_135];
  result['org.rhq.core.domain.cloud.PartitionEventType/968290042'] = [instantiate_134, deserialize_137, serialize_79];
  result['[Lorg.rhq.core.domain.cloud.PartitionEventType;/243557260'] = [undefined, undefined, serialize_78];
  result['org.rhq.core.domain.cloud.Server/2668048662'] = [instantiate_138, deserialize_141, serialize_83];
  result['org.rhq.core.domain.cloud.Server$OperationMode/2202107077'] = [instantiate_139, deserialize_142, serialize_85];
  result['[Lorg.rhq.core.domain.cloud.Server$OperationMode;/3682549083'] = [undefined, undefined, serialize_84];
  result['[Lorg.rhq.core.domain.cloud.Server;/2885472760'] = [instantiate_137, deserialize_140, serialize_82];
  result['org.rhq.core.domain.cloud.composite.AffinityGroupCountComposite/2319289293'] = [instantiate_140, deserialize_143];
  result['org.rhq.core.domain.cloud.composite.ServerWithAgentCountComposite/306400102'] = [instantiate_142, deserialize_145];
  result['[Lorg.rhq.core.domain.cloud.composite.ServerWithAgentCountComposite;/701270134'] = [instantiate_141, deserialize_144];
  result['org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431'] = [instantiate_221, deserialize_228, serialize_168];
  result['org.rhq.core.domain.criteria.AgentCriteria/2669284604'] = [undefined, undefined, serialize_189];
  result['org.rhq.core.domain.criteria.Criteria$Restriction/577703834'] = [undefined, undefined, serialize_202];
  result['org.rhq.core.domain.criteria.PartitionEventCriteria/2245581677'] = [undefined, undefined, serialize_220];
  result['org.rhq.core.domain.criteria.ServerCriteria/859500744'] = [undefined, undefined, serialize_232];
  result['org.rhq.core.domain.resource.Agent/3054333226'] = [instantiate_325, deserialize_337, serialize_291];
  result['[Lorg.rhq.core.domain.resource.Agent;/3064062917'] = [instantiate_324, deserialize_336, serialize_290];
  result['org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350'] = [instantiate_326, deserialize_338];
  result['org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434'] = [instantiate_362, deserialize_374];
  result['org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935'] = [instantiate_365, deserialize_377];
  result['org.rhq.core.domain.util.OrderingField/1965492345'] = [instantiate_384, deserialize_396, serialize_327];
  result['org.rhq.core.domain.util.PageControl/1930924326'] = [instantiate_385, deserialize_397, serialize_328];
  result['org.rhq.core.domain.util.PageList/1647180190'] = [instantiate_387, deserialize_399, serialize_329];
  result['org.rhq.core.domain.util.PageOrdering/3977130006'] = [instantiate_388, deserialize_400, serialize_330];
  result['org.rhq.core.domain.util.UnlimitedPageControl/1477238873'] = [instantiate_389, deserialize_401, serialize_331];
  result['org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669'] = [instantiate_390, deserialize_402];
  return result;
}

function loadSignaturesNative_32(){
  var result = [];
  result[getHashCode(Lcom_google_gwt_event_shared_UmbrellaException_2_classLit)] = 'com.google.gwt.event.shared.UmbrellaException/3104463596';
  result[getHashCode(Lcom_google_gwt_http_client_RequestException_2_classLit)] = 'com.google.gwt.http.client.RequestException/190587325';
  result[getHashCode(Lcom_google_gwt_json_client_JSONException_2_classLit)] = 'com.google.gwt.json.client.JSONException/2941795468';
  result[getHashCode(Lcom_google_gwt_jsonp_client_TimeoutException_2_classLit)] = 'com.google.gwt.jsonp.client.TimeoutException/1112787596';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_IncompatibleRemoteServiceException_2_classLit)] = 'com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException/3936916533';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_RpcTokenException_2_classLit)] = 'com.google.gwt.user.client.rpc.RpcTokenException/2345075298';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializableException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializableException/3047383460';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializationException/2836333220';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_SerializedTypeViolationException_2_classLit)] = 'com.google.gwt.user.client.rpc.SerializedTypeViolationException/914601580';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_ServiceDefTarget$NoServiceEntryPointSpecifiedException_2_classLit)] = 'com.google.gwt.user.client.rpc.ServiceDefTarget$NoServiceEntryPointSpecifiedException/3408313447';
  result[getHashCode(Lcom_google_gwt_user_client_rpc_XsrfToken_2_classLit)] = 'com.google.gwt.user.client.rpc.XsrfToken/4254043109';
  result[getHashCode(Lcom_google_gwt_xml_client_impl_DOMParseException_2_classLit)] = 'com.google.gwt.xml.client.impl.DOMParseException/3799120635';
  result[getHashCode(Lcom_google_web_bindery_event_shared_UmbrellaException_2_classLit)] = 'com.google.web.bindery.event.shared.UmbrellaException/1025846929';
  result[getHashCode(_3I_classLit)] = '[I/2970817851';
  result[getHashCode(Ljava_io_IOException_2_classLit)] = 'java.io.IOException/1159940531';
  result[getHashCode(Ljava_io_UnsupportedEncodingException_2_classLit)] = 'java.io.UnsupportedEncodingException/1526756933';
  result[getHashCode(Ljava_lang_ArithmeticException_2_classLit)] = 'java.lang.ArithmeticException/1539622151';
  result[getHashCode(Ljava_lang_ArrayIndexOutOfBoundsException_2_classLit)] = 'java.lang.ArrayIndexOutOfBoundsException/600550433';
  result[getHashCode(Ljava_lang_ArrayStoreException_2_classLit)] = 'java.lang.ArrayStoreException/3540507190';
  result[getHashCode(Ljava_lang_AssertionError_2_classLit)] = 'java.lang.AssertionError/3490171458';
  result[getHashCode(Ljava_lang_Boolean_2_classLit)] = 'java.lang.Boolean/476441737';
  result[getHashCode(Ljava_lang_ClassCastException_2_classLit)] = 'java.lang.ClassCastException/702295179';
  result[getHashCode(Ljava_lang_Error_2_classLit)] = 'java.lang.Error/1331973429';
  result[getHashCode(Ljava_lang_Exception_2_classLit)] = 'java.lang.Exception/1920171873';
  result[getHashCode(Ljava_lang_IllegalArgumentException_2_classLit)] = 'java.lang.IllegalArgumentException/1755012560';
  result[getHashCode(Ljava_lang_IllegalStateException_2_classLit)] = 'java.lang.IllegalStateException/1972187323';
  result[getHashCode(Ljava_lang_IndexOutOfBoundsException_2_classLit)] = 'java.lang.IndexOutOfBoundsException/2489527753';
  result[getHashCode(Ljava_lang_Integer_2_classLit)] = 'java.lang.Integer/3438268394';
  result[getHashCode(_3Ljava_lang_Integer_2_classLit)] = '[Ljava.lang.Integer;/1574882222';
  result[getHashCode(Ljava_lang_Long_2_classLit)] = 'java.lang.Long/4227064769';
  result[getHashCode(Ljava_lang_NegativeArraySizeException_2_classLit)] = 'java.lang.NegativeArraySizeException/3846860241';
  result[getHashCode(Ljava_lang_NoSuchMethodException_2_classLit)] = 'java.lang.NoSuchMethodException/260969707';
  result[getHashCode(Ljava_lang_NullPointerException_2_classLit)] = 'java.lang.NullPointerException/1463492344';
  result[getHashCode(Ljava_lang_NumberFormatException_2_classLit)] = 'java.lang.NumberFormatException/3305228476';
  result[getHashCode(Ljava_lang_RuntimeException_2_classLit)] = 'java.lang.RuntimeException/515124647';
  result[getHashCode(Ljava_lang_String_2_classLit)] = 'java.lang.String/2004016611';
  result[getHashCode(Ljava_lang_StringIndexOutOfBoundsException_2_classLit)] = 'java.lang.StringIndexOutOfBoundsException/500777603';
  result[getHashCode(_3Ljava_lang_String_2_classLit)] = '[Ljava.lang.String;/2600011424';
  result[getHashCode(Ljava_lang_Throwable_2_classLit)] = 'java.lang.Throwable/2953622131';
  result[getHashCode(Ljava_lang_UnsupportedOperationException_2_classLit)] = 'java.lang.UnsupportedOperationException/3744010015';
  result[getHashCode(Ljava_lang_annotation_AnnotationFormatError_2_classLit)] = 'java.lang.annotation.AnnotationFormatError/2257184627';
  result[getHashCode(Ljava_lang_annotation_AnnotationTypeMismatchException_2_classLit)] = 'java.lang.annotation.AnnotationTypeMismatchException/976205828';
  result[getHashCode(Ljava_security_DigestException_2_classLit)] = 'java.security.DigestException/629316798';
  result[getHashCode(Ljava_security_GeneralSecurityException_2_classLit)] = 'java.security.GeneralSecurityException/2669239907';
  result[getHashCode(Ljava_security_NoSuchAlgorithmException_2_classLit)] = 'java.security.NoSuchAlgorithmException/2892037213';
  result[getHashCode(Ljava_util_ArrayList_2_classLit)] = 'java.util.ArrayList/4159755760';
  result[getHashCode(Ljava_util_Arrays$ArrayList_2_classLit)] = 'java.util.Arrays$ArrayList/2507071751';
  result[getHashCode(Ljava_util_Collections$EmptyList_2_classLit)] = 'java.util.Collections$EmptyList/4157118744';
  result[getHashCode(Ljava_util_Collections$EmptyMap_2_classLit)] = 'java.util.Collections$EmptyMap/4174664486';
  result[getHashCode(Ljava_util_Collections$EmptySet_2_classLit)] = 'java.util.Collections$EmptySet/3523698179';
  result[getHashCode(Ljava_util_Collections$SingletonList_2_classLit)] = 'java.util.Collections$SingletonList/1586180994';
  result[getHashCode(Ljava_util_ConcurrentModificationException_2_classLit)] = 'java.util.ConcurrentModificationException/2717383897';
  result[getHashCode(Ljava_util_EmptyStackException_2_classLit)] = 'java.util.EmptyStackException/89438517';
  result[getHashCode(Ljava_util_HashMap_2_classLit)] = 'java.util.HashMap/1797211028';
  result[getHashCode(Ljava_util_HashSet_2_classLit)] = 'java.util.HashSet/3273092938';
  result[getHashCode(Ljava_util_IdentityHashMap_2_classLit)] = 'java.util.IdentityHashMap/1839153020';
  result[getHashCode(Ljava_util_LinkedHashMap_2_classLit)] = 'java.util.LinkedHashMap/3008245022';
  result[getHashCode(Ljava_util_LinkedHashSet_2_classLit)] = 'java.util.LinkedHashSet/1826081506';
  result[getHashCode(Ljava_util_LinkedList_2_classLit)] = 'java.util.LinkedList/3953877921';
  result[getHashCode(Ljava_util_NoSuchElementException_2_classLit)] = 'java.util.NoSuchElementException/1559248883';
  result[getHashCode(Ljava_util_Stack_2_classLit)] = 'java.util.Stack/1346942793';
  result[getHashCode(Ljava_util_TooManyListenersException_2_classLit)] = 'java.util.TooManyListenersException/2023078032';
  result[getHashCode(Ljava_util_TreeMap_2_classLit)] = 'java.util.TreeMap/1493889780';
  result[getHashCode(Ljava_util_TreeSet_2_classLit)] = 'java.util.TreeSet/4043497002';
  result[getHashCode(Ljava_util_Vector_2_classLit)] = 'java.util.Vector/3057315478';
  result[getHashCode(Ljavax_validation_ConstraintDeclarationException_2_classLit)] = 'javax.validation.ConstraintDeclarationException/3610544007';
  result[getHashCode(Ljavax_validation_ConstraintDefinitionException_2_classLit)] = 'javax.validation.ConstraintDefinitionException/3732439488';
  result[getHashCode(Ljavax_validation_ConstraintViolationException_2_classLit)] = 'javax.validation.ConstraintViolationException/1185386591';
  result[getHashCode(Ljavax_validation_GroupDefinitionException_2_classLit)] = 'javax.validation.GroupDefinitionException/4024780846';
  result[getHashCode(Ljavax_validation_UnexpectedTypeException_2_classLit)] = 'javax.validation.UnexpectedTypeException/593026390';
  result[getHashCode(Ljavax_validation_ValidationException_2_classLit)] = 'javax.validation.ValidationException/1570221831';
  result[getHashCode(Lorg_rhq_core_domain_authz_Permission_2_classLit)] = 'org.rhq.core.domain.authz.Permission/1442357263';
  result[getHashCode(_3Lorg_rhq_core_domain_authz_Permission_2_classLit)] = '[Lorg.rhq.core.domain.authz.Permission;/4248477598';
  result[getHashCode(Lorg_rhq_core_domain_cloud_AffinityGroup_2_classLit)] = 'org.rhq.core.domain.cloud.AffinityGroup/2535509485';
  result[getHashCode(Lorg_rhq_core_domain_cloud_FailoverList_2_classLit)] = 'org.rhq.core.domain.cloud.FailoverList/1011507657';
  result[getHashCode(Lorg_rhq_core_domain_cloud_FailoverListDetails_2_classLit)] = 'org.rhq.core.domain.cloud.FailoverListDetails/3728031575';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_FailoverListDetails_2_classLit)] = '[Lorg.rhq.core.domain.cloud.FailoverListDetails;/2314641079';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_FailoverList_2_classLit)] = '[Lorg.rhq.core.domain.cloud.FailoverList;/2293397377';
  result[getHashCode(Lorg_rhq_core_domain_cloud_PartitionEvent_2_classLit)] = 'org.rhq.core.domain.cloud.PartitionEvent/2698797229';
  result[getHashCode(Lorg_rhq_core_domain_cloud_PartitionEvent$ExecutionStatus_2_classLit)] = 'org.rhq.core.domain.cloud.PartitionEvent$ExecutionStatus/2309869088';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_PartitionEvent$ExecutionStatus_2_classLit)] = '[Lorg.rhq.core.domain.cloud.PartitionEvent$ExecutionStatus;/3115597478';
  result[getHashCode(Lorg_rhq_core_domain_cloud_PartitionEventDetails_2_classLit)] = 'org.rhq.core.domain.cloud.PartitionEventDetails/3716060296';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_PartitionEventDetails_2_classLit)] = '[Lorg.rhq.core.domain.cloud.PartitionEventDetails;/1076659955';
  result[getHashCode(Lorg_rhq_core_domain_cloud_PartitionEventType_2_classLit)] = 'org.rhq.core.domain.cloud.PartitionEventType/968290042';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_PartitionEventType_2_classLit)] = '[Lorg.rhq.core.domain.cloud.PartitionEventType;/243557260';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server_2_classLit)] = 'org.rhq.core.domain.cloud.Server/2668048662';
  result[getHashCode(Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = 'org.rhq.core.domain.cloud.Server$OperationMode/2202107077';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server$OperationMode_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server$OperationMode;/3682549083';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_Server_2_classLit)] = '[Lorg.rhq.core.domain.cloud.Server;/2885472760';
  result[getHashCode(Lorg_rhq_core_domain_cloud_composite_AffinityGroupCountComposite_2_classLit)] = 'org.rhq.core.domain.cloud.composite.AffinityGroupCountComposite/2319289293';
  result[getHashCode(Lorg_rhq_core_domain_cloud_composite_ServerWithAgentCountComposite_2_classLit)] = 'org.rhq.core.domain.cloud.composite.ServerWithAgentCountComposite/306400102';
  result[getHashCode(_3Lorg_rhq_core_domain_cloud_composite_ServerWithAgentCountComposite_2_classLit)] = '[Lorg.rhq.core.domain.cloud.composite.ServerWithAgentCountComposite;/701270134';
  result[getHashCode(Lorg_rhq_core_domain_content_PackageVersion$DefaultPackageVersionComparator_2_classLit)] = 'org.rhq.core.domain.content.PackageVersion$DefaultPackageVersionComparator/1813820431';
  result[getHashCode(Lorg_rhq_core_domain_criteria_AgentCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.AgentCriteria/2669284604';
  result[getHashCode(Lorg_rhq_core_domain_criteria_Criteria$Restriction_2_classLit)] = 'org.rhq.core.domain.criteria.Criteria$Restriction/577703834';
  result[getHashCode(Lorg_rhq_core_domain_criteria_PartitionEventCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.PartitionEventCriteria/2245581677';
  result[getHashCode(Lorg_rhq_core_domain_criteria_ServerCriteria_2_classLit)] = 'org.rhq.core.domain.criteria.ServerCriteria/859500744';
  result[getHashCode(Lorg_rhq_core_domain_resource_Agent_2_classLit)] = 'org.rhq.core.domain.resource.Agent/3054333226';
  result[getHashCode(_3Lorg_rhq_core_domain_resource_Agent_2_classLit)] = '[Lorg.rhq.core.domain.resource.Agent;/3064062917';
  result[getHashCode(Lorg_rhq_core_domain_resource_CannotConnectToAgentException_2_classLit)] = 'org.rhq.core.domain.resource.CannotConnectToAgentException/2053006350';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_DuplicateExpressionTypeException_2_classLit)] = 'org.rhq.core.domain.resource.group.DuplicateExpressionTypeException/353212434';
  result[getHashCode(Lorg_rhq_core_domain_resource_group_InvalidExpressionException_2_classLit)] = 'org.rhq.core.domain.resource.group.InvalidExpressionException/2023959935';
  result[getHashCode(Lorg_rhq_core_domain_util_OrderingField_2_classLit)] = 'org.rhq.core.domain.util.OrderingField/1965492345';
  result[getHashCode(Lorg_rhq_core_domain_util_PageControl_2_classLit)] = 'org.rhq.core.domain.util.PageControl/1930924326';
  result[getHashCode(Lorg_rhq_core_domain_util_PageList_2_classLit)] = 'org.rhq.core.domain.util.PageList/1647180190';
  result[getHashCode(Lorg_rhq_core_domain_util_PageOrdering_2_classLit)] = 'org.rhq.core.domain.util.PageOrdering/3977130006';
  result[getHashCode(Lorg_rhq_core_domain_util_UnlimitedPageControl_2_classLit)] = 'org.rhq.core.domain.util.UnlimitedPageControl/1477238873';
  result[getHashCode(Lorg_rhq_enterprise_gui_coregui_client_ViewChangedException_2_classLit)] = 'org.rhq.enterprise.gui.coregui.client.ViewChangedException/3412077669';
  return result;
}

defineSeed(2886, 278, {}, TopologyGWTService_TypeSerializer_0);
var methodMapNative_33 = null, signatureMapNative_33 = null;
function $addUrlSections(this$static, sections){
  var $e0, i, icon, item, itemName, items, j, numItems, numSections, section, sectionTitle, title, url;
  this$static.productInfo.helpViewContent.containsKey('view_help_section_count')?(this$static.contentFromProductInfo = true):(this$static.contentFromProductInfo = false);
  numSections = valueOf_44(__parseAndValidateInt(this$static.contentFromProductInfo?dynamicCast(this$static.productInfo.helpViewContent.get_2('view_help_section_count'), Q$String):$getString_0(this$static.messageConstants, 'view_help_section_count'))).value_0;
  for (i = 1; i <= numSections; ++i) {
    numItems = valueOf_44(__parseAndValidateInt(this$static.contentFromProductInfo?dynamicCast(this$static.productInfo.helpViewContent.get_2('view_help_section_' + i + '_item_count'), Q$String):$getString_0(this$static.messageConstants, 'view_help_section_' + i + '_item_count'))).value_0;
    items = initDim(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, numItems, 0);
    sectionTitle = this$static.contentFromProductInfo?dynamicCast(this$static.productInfo.helpViewContent.get_2('view_help_section_' + i + '_title'), Q$String):$getString_0(this$static.messageConstants, 'view_help_section_' + i + '_title');
    for (j = 1; j <= numItems; ++j) {
      title = this$static.contentFromProductInfo?dynamicCast(this$static.productInfo.helpViewContent.get_2('view_help_section_' + i + '_propTitle_' + j), Q$String):$getString_0(this$static.messageConstants, 'view_help_section_' + i + '_propTitle_' + j);
      url = this$static.contentFromProductInfo?dynamicCast(this$static.productInfo.helpViewContent.get_2('view_help_section_' + i + '_propUrl_' + j), Q$String):$getString_0(this$static.messageConstants, 'view_help_section_' + i + '_propUrl_' + j);
      try {
        icon = this$static.contentFromProductInfo?dynamicCast(this$static.productInfo.helpViewContent.get_2('view_help_section_' + i + '_propIcon_' + j), Q$String):$getString_0(this$static.messageConstants, 'view_help_section_' + i + '_propIcon_' + j);
        icon == null && (icon = '[SKIN]/../headerIcons/document.png');
      }
       catch ($e0) {
        $e0 = caught_0($e0);
        if (instanceOf($e0, Q$MissingResourceException)) {
          icon = '[SKIN]/../headerIcons/document.png';
        }
         else 
          throw $e0;
      }
      itemName = 'Section' + i + 'Item' + j;
      item = new NavigationItem_0(new ViewName_1(itemName, title), icon, new HelpView$2_0(url));
      items[j - 1] = item;
    }
    section = new NavigationSection_0(new ViewName_1('Section' + i, sectionTitle), items);
    setCheck(sections.array, sections.size_0++, section);
  }
}

function HelpView_0(){
  $clinit_HelpView();
  AbstractSectionedLeftNavigationView_0.call(this, VIEW_ID_20.name_0);
  this.productInfo = ($clinit_CoreGUI() , $clinit_CoreGUI() , coreGUI).productInfo;
  this.messageConstants = MSGCONST;
}

defineSeed(2887, 1581, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$Enhanced, Q$EnhancedHLayout]), HelpView_0);
_.defaultView = function defaultView_0(){
  var vLayout, titleBar, label;
  return vLayout = new EnhancedVLayout_0 , $isCreated_1(vLayout)?$setProperty_3(vLayout, 'width', '100%'):(vLayout.config_0['width'] = '100%' , undefined) , titleBar = new TitleBar_1(($clinit_Enhanced() , 'Help'), VIEW_ID_20.icon_0.icon24x24Path) , $addMember(vLayout, titleBar) , label = new Label_4('This section provides access to documentation, tutorials, version, and other helpful information.') , $setPadding(label, valueOf_44(10)) , $addMember(vLayout, label) , vLayout;
}
;
_.getNavigationSections = function getNavigationSections_0(){
  var docSection, sections, aboutItem;
  sections = new ArrayList_0;
  docSection = (aboutItem = new NavigationItem_0(new ViewName_1('AboutBox', ($clinit_Enhanced() , 'About')), '[SKIN]/../actions/help.png', new HelpView$1_0(this)) , aboutItem.refreshRequired = true , new NavigationSection_0(SECTION_PRODUCT_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [aboutItem])));
  setCheck(sections.array, sections.size_0++, docSection);
  $addUrlSections(this, sections);
  return sections;
}
;
_.contentFromProductInfo = false;
function HelpView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2888, 1, {}, HelpView$1_0);
_.createView = function createView_16(){
  var aboutModalWindow;
  aboutModalWindow = new AboutModalWindow_0;
  $setTitle(aboutModalWindow, 'About ' + ($clinit_Enhanced() , this.this$0.productInfo.fullName));
  $show(aboutModalWindow);
  return aboutModalWindow;
}
;
_.this$0 = null;
function HelpView$2_0(val$url){
  this.val$url = val$url;
}

defineSeed(2889, 1, {}, HelpView$2_0);
_.createView = function createView_17(){
  return new FullHTMLPane_0(this.val$url);
}
;
_.val$url = null;
function $createIgnoredResourceSearchView(viewName, initialCriteria){
  return new InventoryView$ResourceSearchViewWrapper_1(false, true, viewName, initialCriteria, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [viewName.icon_0.icon24x24Path]));
}

function $createResourceSearchView(viewName, initialCriteria){
  return new InventoryView$ResourceSearchViewWrapper_0(viewName, initialCriteria, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [viewName.icon_0.icon24x24Path]));
}

function InventoryView_0(){
  $clinit_InventoryView();
  AbstractSectionedLeftNavigationView_0.call(this, VIEW_ID_21.name_0);
}

defineSeed(2890, 1581, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$Enhanced, Q$EnhancedHLayout]), InventoryView_0);
_.defaultView = function defaultView_1(){
  var label, titleBar, vLayout;
  vLayout = new EnhancedVLayout_0;
  $isCreated_1(vLayout)?$setProperty_3(vLayout, 'width', '100%'):(vLayout.config_0['width'] = '100%' , undefined);
  titleBar = new TitleBar_1(($clinit_Enhanced() , 'Inventory'), ($clinit_IconEnum() , INVENTORY_0).icon24x24Path);
  $addMember(vLayout, titleBar);
  label = new Label_4('From this section, newly discovered Resources, inventoried Resources, and Groups can be viewed and managed.');
  $setPadding(label, valueOf_44(10));
  $addMember(vLayout, label);
  return vLayout;
}
;
_.getNavigationSections = function getNavigationSections_1(){
  var groupsSection, resourcesSection, sections, autodiscoveryQueueItem, allResourcesItem, platformsItem, topLevelServersItem, serversItem, servicesItem, ignoredResourcesItem, downServersItem, dynagroupDefinitionsItem, allGroupsItem, compatibleGroupsItem, mixedGroupsItem, problemGroupsItem;
  sections = new ArrayList_0;
  resourcesSection = (autodiscoveryQueueItem = new NavigationItem_3(($clinit_ResourceAutodiscoveryView() , VIEW_ID_17), new InventoryView$2_0, this.globalPermissions.contains_0(($clinit_Permission() , MANAGE_INVENTORY))) , autodiscoveryQueueItem.refreshRequired = true , allResourcesItem = new NavigationItem_2(PAGE_ALL_RESOURCES, new InventoryView$3_0) , platformsItem = new NavigationItem_2(PAGE_PLATFORMS, new InventoryView$4_0) , topLevelServersItem = new NavigationItem_2(PAGE_SERVERS_TOP, new InventoryView$5_0) , serversItem = new NavigationItem_2(PAGE_SERVERS, new InventoryView$6_0) , servicesItem = new NavigationItem_2(PAGE_SERVICES, new InventoryView$7_0) , ignoredResourcesItem = new NavigationItem_2(PAGE_IGNORED_RESOURCES, new InventoryView$8_0) , downServersItem = new NavigationItem_2(PAGE_UNAVAIL_SERVERS, new InventoryView$9_0) , new NavigationSection_0(RESOURCES_SECTION_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [autodiscoveryQueueItem, allResourcesItem, platformsItem, topLevelServersItem, serversItem, servicesItem, ignoredResourcesItem, downServersItem])));
  setCheck(sections.array, sections.size_0++, resourcesSection);
  groupsSection = (dynagroupDefinitionsItem = new NavigationItem_3(PAGE_DYNAGROUP_DEFINITIONS, new InventoryView$10_0, this.globalPermissions.contains_0(MANAGE_INVENTORY)) , allGroupsItem = new NavigationItem_2(PAGE_ALL_GROUPS, new InventoryView$11_0) , compatibleGroupsItem = new NavigationItem_2(PAGE_COMPATIBLE_GROUPS, new InventoryView$12_0) , mixedGroupsItem = new NavigationItem_2(PAGE_MIXED_GROUPS, new InventoryView$13_0) , problemGroupsItem = new NavigationItem_2(PAGE_PROBLEM_GROUPS, new InventoryView$14_0) , new NavigationSection_0(GROUPS_SECTION_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [allGroupsItem, dynagroupDefinitionsItem, compatibleGroupsItem, mixedGroupsItem, problemGroupsItem])));
  setCheck(sections.array, sections.size_0++, groupsSection);
  return sections;
}
;
_.onInit = function onInit_57(){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new InventoryView$1_0(this)));
}
;
_.globalPermissions = null;
function InventoryView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2891, 1, {}, InventoryView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_10(permissions){
  this.this$0.globalPermissions = permissions?permissions:noneOf(Lorg_rhq_core_domain_authz_Permission_2_classLit);
  $onInit_0(this.this$0);
}
;
_.this$0 = null;
function InventoryView$10_0(){
}

defineSeed(2892, 1, {}, InventoryView$10_0);
_.createView = function createView_18(){
  return new GroupDefinitionListView_0;
}
;
function InventoryView$11_0(){
}

defineSeed(2893, 1, {}, InventoryView$11_0);
_.createView = function createView_19(){
  return new ResourceGroupListView_0;
}
;
function InventoryView$12_0(){
}

defineSeed(2894, 1, {}, InventoryView$12_0);
_.createView = function createView_20(){
  var view;
  view = new ResourceGroupListView_1(new Criteria_2(($clinit_ResourceGroupDataSourceField() , CATEGORY).propertyName, ($clinit_GroupCategory() , COMPATIBLE).name_0));
  return view;
}
;
function InventoryView$13_0(){
}

defineSeed(2895, 1, {}, InventoryView$13_0);
_.createView = function createView_21(){
  var view;
  view = new ResourceGroupListView_1(new Criteria_2(($clinit_ResourceGroupDataSourceField() , CATEGORY).propertyName, ($clinit_GroupCategory() , MIXED_0).name_0));
  return view;
}
;
function InventoryView$14_0(){
}

defineSeed(2896, 1, {}, InventoryView$14_0);
_.createView = function createView_22(){
  var view;
  view = new ResourceGroupListView_1(new Criteria_2('downMemberCount', '1'));
  view.showNewButton = false;
  return view;
}
;
function InventoryView$2_0(){
}

defineSeed(2897, 1, {}, InventoryView$2_0);
_.createView = function createView_23(){
  return new ResourceAutodiscoveryView_0;
}
;
function InventoryView$3_0(){
}

defineSeed(2898, 1, {}, InventoryView$3_0);
_.createView = function createView_24(){
  return new InventoryView$ResourceSearchViewWrapper_0(($clinit_InventoryView() , PAGE_ALL_RESOURCES), null, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [getResourceIcon_0(($clinit_ResourceCategory() , PLATFORM), ($clinit_AvailabilityType() , UP), '24'), getResourceIcon_0(SERVER_0, UP, '24'), getResourceIcon_0(SERVICE, UP, '24')]));
}
;
function InventoryView$4_0(){
}

defineSeed(2899, 1, {}, InventoryView$4_0);
_.createView = function createView_25(){
  var initialCriteria;
  initialCriteria = new Criteria_2(($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName, ($clinit_ResourceCategory() , PLATFORM).name_0);
  return $createResourceSearchView(($clinit_InventoryView() , PAGE_PLATFORMS), initialCriteria);
}
;
function InventoryView$5_0(){
}

defineSeed(2900, 1, {}, InventoryView$5_0);
_.createView = function createView_26(){
  var initialCriteria;
  initialCriteria = new Criteria_2(($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName, ($clinit_ResourceCategory() , SERVER_0).name_0);
  $addCriteria_2(initialCriteria, 'parentCategory', PLATFORM.name_0);
  return $createResourceSearchView(($clinit_InventoryView() , PAGE_SERVERS_TOP), initialCriteria);
}
;
function InventoryView$6_0(){
}

defineSeed(2901, 1, {}, InventoryView$6_0);
_.createView = function createView_27(){
  var initialCriteria;
  initialCriteria = new Criteria_2(($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName, ($clinit_ResourceCategory() , SERVER_0).name_0);
  return $createResourceSearchView(($clinit_InventoryView() , PAGE_SERVERS), initialCriteria);
}
;
function InventoryView$7_0(){
}

defineSeed(2902, 1, {}, InventoryView$7_0);
_.createView = function createView_28(){
  var initialCriteria;
  initialCriteria = new Criteria_2(($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName, ($clinit_ResourceCategory() , SERVICE).name_0);
  return $createResourceSearchView(($clinit_InventoryView() , PAGE_SERVICES), initialCriteria);
}
;
function InventoryView$8_0(){
}

defineSeed(2903, 1, {}, InventoryView$8_0);
_.createView = function createView_29(){
  var initialCriteria;
  initialCriteria = new Criteria_2(($clinit_ResourceDataSourceField() , INVENTORY_STATUS).propertyName, ($clinit_InventoryStatus() , IGNORED).name_0);
  $addCriteria_2(initialCriteria, PARENT_INVENTORY_STATUS.propertyName, COMMITTED.name_0);
  return $createIgnoredResourceSearchView(($clinit_InventoryView() , PAGE_IGNORED_RESOURCES), initialCriteria);
}
;
function InventoryView$9_0(){
}

defineSeed(2904, 1, {}, InventoryView$9_0);
_.createView = function createView_30(){
  var initialCriteria;
  initialCriteria = new Criteria_2(($clinit_ResourceDataSourceField() , AVAILABILITY_2).propertyName, ($clinit_AvailabilityType() , DOWN_0).name_0);
  $addCriteria_2(initialCriteria, CATEGORY_0.propertyName, ($clinit_ResourceCategory() , SERVER_0).name_0);
  return $createResourceSearchView(($clinit_InventoryView() , PAGE_UNAVAIL_SERVERS), initialCriteria);
}
;
function InventoryView$ResourceSearchViewWrapper_0(viewName, criteria, headerIcons){
  $clinit_ResourceSearchView();
  InventoryView$ResourceSearchViewWrapper_1.call(this, true, false, viewName, criteria, headerIcons);
}

function InventoryView$ResourceSearchViewWrapper_1(showIgnoredButton, showUnignoreButton, viewName, criteria, headerIcons){
  $clinit_ResourceSearchView();
  ResourceSearchView_2.call(this, criteria, viewName.title_0, headerIcons);
  this.viewName = viewName;
  this.showIgnoreButton = showIgnoredButton;
  this.showUnignoreButton = showUnignoreButton;
}

defineSeed(2905, 2557, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), InventoryView$ResourceSearchViewWrapper_0, InventoryView$ResourceSearchViewWrapper_1);
_.getViewName = function getViewName_10(){
  return this.viewName;
}
;
_.shouldShowIgnoreButton = function shouldShowIgnoreButton_0(){
  return this.showIgnoreButton;
}
;
_.shouldShowUnignoreButton = function shouldShowUnignoreButton_0(){
  return this.showUnignoreButton;
}
;
_.showIgnoreButton = false;
_.showUnignoreButton = false;
_.viewName = null;
function $clinit_AbstractD3GraphListView(){
  $clinit_AbstractD3GraphListView = nullMethod;
  $clinit_BaseWidget();
  loadingLabel_0 = new Label_4(($clinit_Enhanced() , 'Loading...'));
}

function AbstractD3GraphListView_0(){
  EnhancedVLayout_0.call(this);
  this.measurementRangeEditor = new UserPreferencesMeasurementRangeEditor_0;
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}

defineSeed(2906, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]));
_.isRefreshing = function isRefreshing_17(){
  return false;
}
;
_.onDestroy = function onDestroy_19(){
  onDestroy_0(this.refreshTimer);
}
;
_.refresh_0 = function refresh_30(){
  $isVisible(this) && this.redrawGraphs();
}
;
_.startRefreshCycle = function startRefreshCycle_18(){
  this.refreshTimer = startRefreshCycle(this, this, this.refreshTimer);
}
;
_.availabilityGraph = null;
_.availabilityList = null;
_.groupAvailabilityList = null;
_.measurementRangeEditor = null;
_.refreshTimer = null;
_.showAvailabilityGraph = false;
var loadingLabel_0;
function $addDataSourceFields_2(){
  var fields, idField, nameField, primaryKeyField;
  fields = new ArrayList_0;
  primaryKeyField = new DataSourceTextField_1('primaryKey', 'Primary Key');
  $setAttribute_8(primaryKeyField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_8(primaryKeyField, 'hidden', TRUE);
  setCheck(fields.array, fields.size_0++, primaryKeyField);
  idField = new DataSourceIntegerField_1('id', 'Definition ID');
  $setAttribute_8(idField, 'hidden', TRUE);
  setCheck(fields.array, fields.size_0++, idField);
  nameField = new DataSourceIntegerField_1('name', 'Name');
  $setAttribute_8(nameField, 'hidden', TRUE);
  setCheck(fields.array, fields.size_0++, nameField);
  return fields;
}

function $copyValues_41(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_13(record, 'primaryKey', from.id.scheduleId + ':' + toString_8(from.id.timestamp));
  $setAttribute_3(record, 'id', from.schedule.definition.id);
  $setAttribute_14(record, 'timestamp', new Date_2(from.id.timestamp));
  $setAttribute_13(record, 'displayName', from.schedule.definition.displayName);
  $setAttribute_13(record, 'value', from.value_0);
  $setAttribute_13(record, 'name', from.schedule.definition.name_0);
  $setAttribute_3(record, 'resourceId', from.schedule.resource.id);
  return record;
}

function $executeFetch_29(this$static, request, response, criteria){
  var startTime;
  startTime = fromDouble(currentTimeMillis0());
  $findTraitsByCriteria(this$static.measurementService, criteria, new AbstractMeasurementDataTraitDataSource$1_0(this$static, criteria, response, request, startTime));
}

function $getFetchCriteria_9(request){
  var criteria, definitionId, fieldName, groupId, key, key$iterator, requestCriteria, resourceId, values;
  criteria = new MeasurementDataTraitCriteria_0;
  requestCriteria = $getCriteria(request);
  if (requestCriteria) {
    values = convertToMap(requestCriteria.jsObj);
    for (key$iterator = values.keySet_0().iterator(); key$iterator.hasNext();) {
      key = key$iterator.next_0();
      fieldName = dynamicCast(key, Q$String);
      if ($equals_6(fieldName, 'resourceId')) {
        resourceId = dynamicCast(values.get_2(fieldName), Q$Integer);
        $addFilterResourceId_3(criteria, resourceId);
      }
       else if ($equals_6(fieldName, 'groupId')) {
        groupId = dynamicCast(values.get_2(fieldName), Q$Integer);
        $addFilterGroupId_0(criteria, groupId);
      }
       else if ($equals_6(fieldName, 'definitionId')) {
        definitionId = dynamicCast(values.get_2(fieldName), Q$Integer);
        criteria.filterDefinitionId = definitionId;
      }
       else 
        $equals_6(fieldName, 'maxTimestamp') && (criteria.filterMaxTimestamp = valueOf_44(1));
    }
  }
  return criteria;
}

function $getListGridFields_14(){
  var fields, nameField, timestampField, valueField;
  fields = new ArrayList_1(3);
  nameField = new ListGridField_3('displayName', 'Trait');
  setCheck(fields.array, fields.size_0++, nameField);
  valueField = new ListGridField_3('value', 'Value');
  setCheck(fields.array, fields.size_0++, valueField);
  timestampField = new ListGridField_3('timestamp', 'Last Changed');
  $setCellFormatter_0(timestampField, new TimestampCellFormatter_0);
  $setAttribute_8(timestampField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(timestampField, ($clinit_TimestampCellFormatter() , new TimestampCellFormatter$1_0('timestamp')));
  timestampField.jsObj['width'] = '20%';
  setCheck(fields.array, fields.size_0++, timestampField);
  return fields;
}

function AbstractMeasurementDataTraitDataSource_0(){
  var fields;
  RPCDataSource_0.call(this);
  this.measurementService = dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync);
  $setCanMultiSort(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  fields = this.addDataSourceFields();
  $addFields(this, fields);
}

defineSeed(2907, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractMeasurementDataTraitDataSource]));
_.addDataSourceFields = function addDataSourceFields_2(){
  return $addDataSourceFields_2();
}
;
_.copyValues = function copyValues_74(from){
  return null;
}
;
_.copyValues_0 = function copyValues_75(from){
  return this.copyValues_4(dynamicCast(from, Q$MeasurementDataTrait));
}
;
_.copyValues_4 = function copyValues_76(from){
  return $copyValues_41(from);
}
;
_.dataRetrieved = function dataRetrieved_0(result, response, request){
  $setAttribute_17(response, 'data', $buildRecords(this, result, true));
  $setTotalRows(response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this, getAttribute(request.jsObj, 'requestId'), response);
}
;
_.executeFetch = function executeFetch_43(request, response, criteria){
  $executeFetch_29(this, request, response, dynamicCast(criteria, Q$MeasurementDataTraitCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_54(request){
  return $getFetchCriteria_9(request);
}
;
_.getListGridFields_0 = function getListGridFields_6(){
  return $getListGridFields_14();
}
;
function $onFailure_29(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to fetch traits for criteria [' + ($clinit_RPCDataSource() , $toString(this$static.val$criteria)) + '].'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_248(this$static, result){
  var fetchDuration;
  fetchDuration = sub(fromDouble(currentTimeMillis0()), this$static.val$startTime);
  info_0(result.size_0 + ' traits fetched in: ' + toString_8(fetchDuration) + 'ms');
  this$static.this$0.dataRetrieved(result, this$static.val$response, this$static.val$request);
}

function AbstractMeasurementDataTraitDataSource$1_0(this$0, val$criteria, val$response, val$request, val$startTime){
  this.this$0 = this$0;
  this.val$criteria = val$criteria;
  this.val$response = val$response;
  this.val$request = val$request;
  this.val$startTime = val$startTime;
}

defineSeed(2908, 1, {}, AbstractMeasurementDataTraitDataSource$1_0);
_.onFailure = function onFailure_259(caught){
  $onFailure_29(this, caught);
}
;
_.onSuccess_0 = function onSuccess_259(result){
  $onSuccess_248(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$criteria = null;
_.val$request = null;
_.val$response = null;
_.val$startTime = P0_longLit;
function $clinit_AbstractMeasurementDataTraitListDetailView(){
  $clinit_AbstractMeasurementDataTraitListDetailView = nullMethod;
  $clinit_BaseWidget();
  EXCLUDED_FIELD_NAMES = initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['displayName']);
  SORT_SPECIFIERS_0 = initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, []);
}

function $configureTable_7(this$static){
  var dataSourceFields, listGrid;
  listGrid = this$static.listGrid;
  dataSourceFields = dynamicCast(this$static.dataSource_1, Q$AbstractMeasurementDataTraitDataSource).getListGridFields_0();
  $setFields_1(listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
  $setAttribute_24(listGrid, 'selectionType', ($clinit_SelectionStyle() , NONE_4).value_0, true);
  $addDataArrivedHandler_0(listGrid, new AbstractMeasurementDataTraitListDetailView$1_0(this$static));
}

function $initTitle(this$static){
  var displayName, record, title;
  if ($getAttributeAsString_0(this$static, 'prompt') == null) {
    record = this$static.listGrid.getRecord_0(0);
    displayName = getAttribute(record.jsObj, 'displayName');
    title = 'Value History for Trait [' + ($clinit_Enhanced() , displayName) + ']';
    $isCreated_1(this$static)?$setProperty_3(this$static, 'prompt', title):(this$static.config_0['prompt'] = title , undefined);
  }
}

function AbstractMeasurementDataTraitListDetailView_0(dataSource, criteria){
  Table_5.call(this, null, criteria, SORT_SPECIFIERS_0, EXCLUDED_FIELD_NAMES);
  this.dataSource_1 = dataSource;
}

defineSeed(2909, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_39(){
  $configureTable_7(this);
}
;
_.getDataSource_0 = function getDataSource_23(){
  return dynamicCast(this.dataSource_1, Q$AbstractMeasurementDataTraitDataSource);
}
;
var EXCLUDED_FIELD_NAMES, SORT_SPECIFIERS_0;
function AbstractMeasurementDataTraitListDetailView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2910, 1, makeCastMap([Q$EventHandler, Q$DataArrivedHandler_0]), AbstractMeasurementDataTraitListDetailView$1_0);
_.onDataArrived = function onDataArrived_1(dataArrivedEvent){
  $initTitle(this.this$0);
}
;
_.this$0 = null;
function $clinit_AbstractMeasurementDataTraitListView(){
  $clinit_AbstractMeasurementDataTraitListView = nullMethod;
  $clinit_BaseWidget();
  TITLE_1 = ($clinit_Enhanced() , 'Traits');
  EXCLUDED_FIELD_NAMES_0 = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, 0, 0);
  SORT_SPECIFIERS_1 = initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [new SortSpecifier_0('displayName', ($clinit_SortDirection() , ASCENDING))]);
}

function $configureTable_8(this$static){
  var dataSourceFields, displayNameField, listGrid;
  $configureTable(this$static);
  listGrid = this$static.listGrid;
  dataSourceFields = dynamicCast(this$static.dataSource_1, Q$AbstractMeasurementDataTraitDataSource).getListGridFields_0();
  $setFields_1(listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
  $setAttribute_24(listGrid, 'selectionType', ($clinit_SelectionStyle() , SINGLE).value_0, true);
  displayNameField = $getField_1(listGrid, 'displayName');
  displayNameField.jsObj['width'] = '20%';
  $addTableAction(this$static, ($clinit_Enhanced() , 'Get Live Value'), null, null, this$static.getLiveValueAction());
}

function $showLiveData(this$static, records){
  var liveDataGrid, liveDataWindow;
  liveDataWindow = new Window_1;
  $setTitle(liveDataWindow, ($clinit_Enhanced() , 'Live Data'));
  $setShowModalMask(liveDataWindow, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setShowMinimizeButton(liveDataWindow, FALSE);
  $setShowMaximizeButton(liveDataWindow, TRUE);
  $setShowCloseButton(liveDataWindow, TRUE);
  $setShowResizer(liveDataWindow, TRUE);
  $setCanDragResize_0(liveDataWindow, TRUE);
  $setDismissOnEscape(liveDataWindow, TRUE);
  $setIsModal(liveDataWindow, TRUE);
  $isCreated_1(liveDataWindow)?$setProperty_0(liveDataWindow, 'width', 700):(liveDataWindow.config_0['width'] = 700 , undefined);
  $isCreated_1(liveDataWindow)?$setProperty_0(liveDataWindow, 'height', 425):(liveDataWindow.config_0['height'] = 425 , undefined);
  $setAutoCenter(liveDataWindow, TRUE);
  $centerInPage(liveDataWindow);
  $addCloseClickHandler(liveDataWindow, new AbstractMeasurementDataTraitListView$1_0(this$static, liveDataWindow));
  liveDataGrid = this$static.decorateLiveDataGrid(records);
  $addItem(liveDataWindow, liveDataGrid);
  liveDataWindow.show_0();
}

function AbstractMeasurementDataTraitListView_0(dataSource, criteria){
  TableSection_3.call(this, TITLE_1, criteria, SORT_SPECIFIERS_1, EXCLUDED_FIELD_NAMES_0);
  this.dataSource_1 = dataSource;
}

defineSeed(2911, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_40(){
  $configureTable_8(this);
}
;
_.getDataSource_0 = function getDataSource_24(){
  return dynamicCast(this.dataSource_1, Q$AbstractMeasurementDataTraitDataSource);
}
;
_.getDetailsLinkColumnName = function getDetailsLinkColumnName_4(){
  return 'displayName';
}
;
var EXCLUDED_FIELD_NAMES_0, SORT_SPECIFIERS_1, TITLE_1;
function AbstractMeasurementDataTraitListView$1_0(this$0, val$liveDataWindow){
  this.this$0 = this$0;
  this.val$liveDataWindow = val$liveDataWindow;
}

defineSeed(2912, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), AbstractMeasurementDataTraitListView$1_0);
_.onCloseClick_0 = function onCloseClick_8(event_0){
  $destroy(this.val$liveDataWindow);
  $refreshTableInfo(this.this$0);
}
;
_.this$0 = null;
_.val$liveDataWindow = null;
function AbstractSchedulesView$1_0(this$0, val$hasWriteAccess){
  this.this$0 = this$0;
  this.val$hasWriteAccess = val$hasWriteAccess;
}

defineSeed(2913, 1, {}, AbstractSchedulesView$1_0);
_.executeAction = function executeAction_45(selection, actionValue){
  $enableSchedules(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_22(selection){
  return selection.length >= 1 && this.val$hasWriteAccess;
}
;
_.this$0 = null;
_.val$hasWriteAccess = false;
function AbstractSchedulesView$2_0(this$0, val$hasWriteAccess){
  this.this$0 = this$0;
  this.val$hasWriteAccess = val$hasWriteAccess;
}

defineSeed(2914, 1, {}, AbstractSchedulesView$2_0);
_.executeAction = function executeAction_46(selection, actionValue){
  $disableSchedules(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_23(selection){
  return selection.length >= 1 && this.val$hasWriteAccess;
}
;
_.this$0 = null;
_.val$hasWriteAccess = false;
function $copyValues_42(from){
  var measurementDefinition, record;
  record = new ListGridRecord_0;
  measurementDefinition = from.measurementDefinition;
  $setAttribute_3(record, 'definitionId', measurementDefinition.id);
  $setAttribute_13(record, 'displayName', measurementDefinition.displayName);
  $setAttribute_13(record, 'description', measurementDefinition.description);
  $setAttribute_13(record, 'dataType', measurementDefinition.dataType.name_0.toLowerCase());
  $setAttribute_8(record, 'enabled', from.collectionEnabled);
  $setAttribute_4(record, 'interval', from.collectionInterval);
  return record;
}

function $executeFetch_30(this$static, request, response){
  $getMeasurementScheduleCompositesByContext(this$static.measurementService, this$static.entityContext, new SchedulesDataSource$1_0(this$static, response, request));
}

function $getListGridFields_15(){
  var descriptionField, displayNameField, enabledField, fields, intervalField, scheduleIdField, typeField;
  fields = new ArrayList_0;
  scheduleIdField = new ListGridField_3('definitionId', 'Schedule ID');
  scheduleIdField.jsObj['showIf'] = 'false';
  setCheck(fields.array, fields.size_0++, scheduleIdField);
  displayNameField = new ListGridField_3('displayName', 'Metric');
  setCheck(fields.array, fields.size_0++, displayNameField);
  descriptionField = new ListGridField_3('description', 'Description');
  setCheck(fields.array, fields.size_0++, descriptionField);
  typeField = new ListGridField_3('dataType', 'Type');
  setCheck(fields.array, fields.size_0++, typeField);
  enabledField = new ListGridField_3('enabled', 'Enabled?');
  $setCellFormatter_0(enabledField, new SchedulesDataSource$CollectionEnabledCellFormatter_0);
  setCheck(fields.array, fields.size_0++, enabledField);
  intervalField = new ListGridField_3('interval', 'Collection Interval');
  $setCellFormatter_0(intervalField, new SchedulesDataSource$CollectionIntervalCellFormatter_0);
  setCheck(fields.array, fields.size_0++, intervalField);
  displayNameField.jsObj['width'] = '20%';
  descriptionField.jsObj['width'] = '40%';
  typeField.jsObj['width'] = '10%';
  enabledField.jsObj['width'] = '10%';
  intervalField.jsObj['width'] = '*';
  return fields;
}

function SchedulesDataSource_0(entityContext){
  $clinit_RPCDataSource();
  RPCDataSource_0.call(this);
  this.measurementService = dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync);
  this.entityContext = entityContext;
  new ArrayList_0;
}

defineSeed(2915, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), SchedulesDataSource_0);
_.copyValues = function copyValues_77(from){
  return null;
}
;
_.copyValues_0 = function copyValues_78(from){
  return $copyValues_42(dynamicCast(from, Q$MeasurementScheduleComposite));
}
;
_.executeFetch = function executeFetch_44(request, response, unused){
  $executeFetch_30(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_55(request){
  return null;
}
;
_.entityContext = null;
function $onFailure_30(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load metric schedules for context [' + ($clinit_RPCDataSource() , $toString_10(this$static.this$0.entityContext)) + ']'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_249(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function SchedulesDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2916, 1, {}, SchedulesDataSource$1_0);
_.onFailure = function onFailure_260(caught){
  $onFailure_30(this, caught);
}
;
_.onSuccess_0 = function onSuccess_260(result){
  $onSuccess_249(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function SchedulesDataSource$CollectionEnabledCellFormatter_0(){
}

defineSeed(2917, 2369, {}, SchedulesDataSource$CollectionEnabledCellFormatter_0);
_.format_1 = function format_45(value, record, rowNum, colNum){
  var result;
  result = $format_1(value);
  return $equals_6('', result)?($clinit_RPCDataSource() , 'mixed'):result;
}
;
function SchedulesDataSource$CollectionIntervalCellFormatter_0(){
}

defineSeed(2918, 1, {}, SchedulesDataSource$CollectionIntervalCellFormatter_0);
_.format_1 = function format_46(value, record, rowNum, colNum){
  var hours, milliseconds, minutes, result, seconds;
  if (value == null) {
    return $clinit_RPCDataSource() , 'mixed';
  }
  milliseconds = dynamicCast(value, Q$Number).longValue();
  if (eq(milliseconds, P0_longLit)) {
    return $clinit_RPCDataSource() , 'mixed';
  }
  result = new StringBuilder_0;
  if (gt(milliseconds, P3e8_longLit)) {
    seconds = div(milliseconds, P3e8_longLit);
    milliseconds = mod(milliseconds, P3e8_longLit);
    if (gte_0(seconds, P3c_longLit)) {
      minutes = div(seconds, P3c_longLit);
      seconds = mod(seconds, P3c_longLit);
      if (gt(minutes, P3c_longLit)) {
        hours = div(minutes, P3c_longLit);
        minutes = mod(minutes, P3c_longLit);
        $append_12($append_12(($appendNonNull(result.data_0, '' + toString_8(hours)) , result), ' '), ($clinit_RPCDataSource() , 'hours'));
      }
      if (neq(minutes, P0_longLit)) {
        $toString_1(result.data_0).length != 0 && ($append_1(result.data_0, ', ') , result);
        $append_12($append_12(($appendNonNull(result.data_0, '' + toString_8(minutes)) , result), ' '), ($clinit_RPCDataSource() , 'minutes'));
      }
    }
    if (neq(seconds, P0_longLit)) {
      $toString_1(result.data_0).length != 0 && ($append_1(result.data_0, ', ') , result);
      $append_12($append_12(($appendNonNull(result.data_0, '' + toString_8(seconds)) , result), ' '), ($clinit_RPCDataSource() , 'seconds'));
    }
  }
  if (neq(milliseconds, P0_longLit)) {
    $toString_1(result.data_0).length != 0 && ($append_1(result.data_0, ', ') , result);
    $append_12($append_12(($appendNonNull(result.data_0, '' + toString_8(milliseconds)) , result), ' '), ($clinit_RPCDataSource() , 'milliseconds'));
  }
  return $toString_1(result.data_0);
}
;
function $clinit_UpdateCollectionIntervalWidget(){
  $clinit_UpdateCollectionIntervalWidget = nullMethod;
  $clinit_BaseWidget();
  VALUE_MAP = new LinkedHashMap_0;
  $put_1(VALUE_MAP, 's', ($clinit_Enhanced() , 'seconds'));
  $put_1(VALUE_MAP, 'm', 'minutes');
  $put_1(VALUE_MAP, 'h', 'hours');
}

function $getInterval(this$static){
  var item, longValue, stringValue, units;
  item = dynamicCast($getField_0(this$static.form_0, 'interval'), Q$IntegerItem);
  if ($getValue_0(item) == null || !$validate_2(item).value_0) {
    return null;
  }
  stringValue = $getValueAsString(this$static.form_0, 'interval');
  longValue = (new Long_0(__parseAndValidateLong(stringValue))).value_0;
  units = $getValueAsString(this$static.form_0, 'units');
  longValue = mul(longValue, P3e8_longLit);
  $equals_6(units, 'm')?(longValue = mul(longValue, P3c_longLit)):$equals_6(units, 'h') && (longValue = mul(longValue, Pe10_longLit));
  return valueOf_45(longValue);
}

function $refresh_17(this$static, listGrid){
  var count, interval, isValid;
  if ($isDrawn(this$static).value_0) {
    isValid = this$static.form_0.validate_0();
    count = $getSelectedRecords(listGrid).length;
    interval = $getInterval(this$static);
    $setDisabled_0(this$static.setButton, !isValid || count == 0 || !interval);
  }
   else {
    $markForRedraw(this$static);
  }
}

function UpdateCollectionIntervalWidget_0(schedulesView){
  $clinit_UpdateCollectionIntervalWidget();
  EnhancedHLayout_0.call(this);
  this.schedulesView = schedulesView;
}

defineSeed(2919, 1539, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$TableWidget, Q$Enhanced, Q$EnhancedHLayout]), UpdateCollectionIntervalWidget_0);
_.onDraw_0 = function onDraw_37(){
  var integerRangeValidator, intervalItem, unitsItem;
  this.form_0 = new DynamicForm_0;
  $setNumCols(this.form_0, 3);
  intervalItem = new IntegerItem_0;
  $setWrapTitle(intervalItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_2(intervalItem)?$setProperty_6(intervalItem, 'width', 75):(intervalItem.jsObj['width'] = 75 , undefined);
  $isCreated_2(intervalItem)?$setProperty_8(intervalItem, 'name', 'interval'):(intervalItem.jsObj['name'] = 'interval' , undefined);
  $setTitle_1(intervalItem, ($clinit_Enhanced() , 'Collection Interval'));
  integerRangeValidator = new IntegerRangeValidator_0;
  integerRangeValidator.jsObj['min'] = 1;
  integerRangeValidator.jsObj['max'] = 10000000;
  $isCreated_2(intervalItem)?$setProperty_7(intervalItem, 'validators', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [integerRangeValidator]))):(intervalItem.jsObj['validators'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [integerRangeValidator])) , undefined);
  $addChangedHandler(intervalItem, new UpdateCollectionIntervalWidget$1_0(this));
  unitsItem = new SelectItem_2('units', null);
  unitsItem.setValueMap_0(VALUE_MAP);
  $isCreated_2(unitsItem)?$setProperty_8(unitsItem, 'defaultValue', 'm'):(unitsItem.jsObj['defaultValue'] = 'm' , undefined);
  $setShowTitle_0(unitsItem, FALSE);
  $isCreated_2(unitsItem)?$setProperty_6(unitsItem, 'width', 125):(unitsItem.jsObj['width'] = 125 , undefined);
  $addChangedHandler(unitsItem, new UpdateCollectionIntervalWidget$2_0(this, integerRangeValidator));
  if (!this.schedulesView.hasWriteAccess) {
    $setDisabled_2(intervalItem, TRUE);
    $setDisabled_2(unitsItem, TRUE);
  }
  this.form_0.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [intervalItem, unitsItem]));
  $addMember(this, this.form_0);
  this.setButton = new Button_2('Set');
  $setDisabled_0(this.setButton, true);
  $addClickHandler(this.setButton, new UpdateCollectionIntervalWidget$3_0(this));
  $setAttribute_24(this.setButton, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, true);
  $setMargin(this.setButton, valueOf_44(3));
  $addMember(this, this.setButton);
}
;
_.refresh_1 = function refresh_31(listGrid){
  $refresh_17(this, listGrid);
}
;
_.form_0 = null;
_.schedulesView = null;
_.setButton = null;
var VALUE_MAP;
function UpdateCollectionIntervalWidget$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2920, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), UpdateCollectionIntervalWidget$1_0);
_.onChanged = function onChanged_53(changedEvent){
  $refresh_17(this.this$0, this.this$0.schedulesView.listGrid);
}
;
_.this$0 = null;
function UpdateCollectionIntervalWidget$2_0(this$0, val$integerRangeValidator){
  this.this$0 = this$0;
  this.val$integerRangeValidator = val$integerRangeValidator;
}

defineSeed(2921, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), UpdateCollectionIntervalWidget$2_0);
_.onChanged = function onChanged_54(event_0){
  var value;
  value = dynamicCast($getValue_2(event_0), Q$String);
  $equals_6(value, 's')?(this.val$integerRangeValidator.jsObj['min'] = 30 , undefined):(this.val$integerRangeValidator.jsObj['min'] = 1 , undefined);
  $refresh_17(this.this$0, this.this$0.schedulesView.listGrid);
}
;
_.this$0 = null;
_.val$integerRangeValidator = null;
function UpdateCollectionIntervalWidget$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2922, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), UpdateCollectionIntervalWidget$3_0);
_.onClick = function onClick_125(clickEvent){
  if (this.this$0.form_0.validate_0()) {
    $disableAllFooterControls(this.this$0.schedulesView);
    $updateSchedules(this.this$0.schedulesView, $getInterval(this.this$0).value_0);
  }
}
;
_.this$0 = null;
function $getChartTitle(this$static){
  return this$static.metricGraphData?$getChartTitle_0(this$static.metricGraphData):'';
}

function $setDefinition(this$static, definition){
  $setDefinition_0(this$static.metricGraphData, definition);
}

function $setEntityId(this$static, entityId){
  $setEntityId_0(this$static.metricGraphData, entityId);
}

function $setEntityName(this$static, entityName){
  $setEntityName_0(this$static.metricGraphData, entityName);
}

function $setMetricGraphData(this$static, metricGraphData){
  this$static.metricGraphData = metricGraphData;
}

defineSeed(2923, 445, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]));
_.metricGraphData = null;
function $clinit_AvailabilityLineGraphType(){
  $clinit_AvailabilityLineGraphType = nullMethod;
  $clinit_CoreGUI();
}

function $drawJsniChart(this$static){
  console.log('Draw Availability chart');
  var global = this$static, availChartContext_0 = new $wnd.AvailChartContext(global.getChartId(), global.getAvailabilityJson(), global.getChartDateLabel(), global.getChartTimeLabel(), global.getChartHoverStartLabel(), global.getChartHoverEndLabel(), global.getChartHoverBarLabel(), global.getChartHoverAvailabilityLabel(), global.getChartHoverTimeFormat(), global.getChartHoverDateFormat());
  var availabilityGraph = function(){
    var margin = {top:5, right:5, bottom:5, left:40}, barOffset = 10, width = 750 - margin.left - margin.right + barOffset, height = 20 - margin.top - margin.bottom, pixelsOffHeight = 0, svg_0;
    function drawBars(availChartContext){
      var xAxisMin = $wnd.d3.min(availChartContext.data, function(d){
        return d.availStart;
      }
      ), xAxisMax = $wnd.d3.max(availChartContext.data, function(d){
        return d.availEnd;
      }
      ), timeScale = $wnd.d3.time.scale().range([0, width]).domain([xAxisMin, xAxisMax]), yScale = $wnd.d3.scale.linear().clamp(true).rangeRound([height, 0]).domain([0, 4]), svg = $wnd.d3.select(availChartContext.chartSelection).append('g').attr('width', width + margin.left + margin.right).attr('height', height + margin.top + margin.bottom).attr('transform', 'translate(' + margin.left + ',' + margin.top + ')');
      svg.selectAll('rect.availBars').data(availChartContext.data).enter().append('rect').attr('class', 'availBars').attr('x', function(d){
        return timeScale(d.availStart);
      }
      ).attr('y', function(d){
        return yScale(0);
      }
      ).attr('height', function(d){
        return height - yScale(4) - pixelsOffHeight;
      }
      ).attr('width', function(d){
        return timeScale(d.availEnd) - timeScale(d.availStart);
      }
      ).attr('opacity', '.9').attr('fill', function(d){
        if (d.availType === 'DOWN') {
          return '#FF1919';
        }
         else if (d.availType === 'DISABLED') {
          return '#FF9933';
        }
         else if (d.availType === 'UNKNOWN') {
          return '#CCC';
        }
         else if (d.availType === 'UP') {
          return '#198C19';
        }
         else if (d.availType === 'WARN') {
          return '#FFFF00';
        }
         else if (d.availType === 'EMPTY') {
          return '#CCC';
        }
         else {
          console.warn('AvailabilityType not valid.');
          return '#000';
        }
      }
      );
    }

    function createHovers(){
      $wnd.jQuery('svg rect.availBars').tipsy({gravity:'n', html:true, trigger:'hover', title:function(){
        var d = this.__data__;
        return formatHovers(d);
      }
      , show:function(e, el){
        el.css({'z-index':'990000'});
      }
      });
    }

    function formatHovers(d){
      var hoverString, timeFormatter = $wnd.d3.time.format(availChartContext_0.chartHoverTimeFormat), dateFormatter = $wnd.d3.time.format(availChartContext_0.chartHoverDateFormat), availStart = new Date(d.availStart), availEnd = new Date(d.availEnd);
      hoverString = '<div class="chartHoverEnclosingDiv"><div class="chartHoverAlignRight"><span >' + availChartContext_0.hoverBarAvailabilityLabel + ': <\/span><span style="width:50px;">' + d.availTypeMessage + '<\/span><\/div><div class="chartHoverAlignRight"><span >' + availChartContext_0.hoverStartLabel + ': <\/span><span style="width:50px;">' + timeFormatter(availStart) + '<\/span><\/div><div class="chartHoverAlignRight"><span > <\/span><span style="width:50px;">' + dateFormatter(availStart) + '<\/span><\/div><div class="chartHoverAlignRight"><span >' + availChartContext_0.hoverEndLabel + ': <\/span><span style="width:50px;">' + timeFormatter(availEnd) + '<\/span><\/div><div class="chartHoverAlignRight"><span > <\/span><span style="width:50px;">' + dateFormatter(availEnd) + '<\/span><\/div><div class="chartHoverAlignRight"><span >' + availChartContext_0.hoverBarLabel + ': <\/span><span style="width:50px;">' + d.availDuration + '<\/span><\/div><\/div>';
      return hoverString;
    }

    return {draw:function(chartContext){
      console.info('AvailabilityChart');
      drawBars(availChartContext_0);
      createHovers();
    }
    };
  }
  ();
  availChartContext_0.data !== undefined && availChartContext_0.data.length > 0 && availabilityGraph.draw(availChartContext_0);
}

function $setAvailabilityList(this$static, availabilityList){
  this$static.availabilityList = availabilityList;
}

function $setGroupAvailabilityList(this$static, groupAvailabilityList){
  this$static.groupAvailabilityList = groupAvailabilityList;
}

function AvailabilityLineGraphType_0(entityId){
  $clinit_AvailabilityLineGraphType();
  this.entityId = entityId;
}

defineSeed(2924, 1, {}, AvailabilityLineGraphType_0);
_.getAvailabilityJson = function getAvailabilityJson(){
  var availDuration, availDurationString, availability, availability$iterator, availabilityTypeMessage, endTime, groupAvailability, groupAvailability$iterator, sb;
  sb = new StringBuilder_1('[');
  if (this.availabilityList) {
    for (availability$iterator = this.availabilityList.iterator(); availability$iterator.hasNext();) {
      availability = dynamicCast(availability$iterator.next_0(), Q$Availability);
      $append_12(sb, '{ "availType":"' + availability.availabilityType + '", ');
      $append_12(sb, ' "availTypeMessage":"' + availability.availabilityType + '", ');
      $append_12(sb, ' "availStart":' + availability.startTime + ', ');
      endTime = availability.endTime?availability.endTime.value_0:(new Date_1).getTime_0();
      $append_1(sb.data_0, ' "availEnd":' + toString_8(endTime) + ', ');
      availDuration = sub(endTime, availability.startTime.value_0);
      availDurationString = ($clinit_MeasurementConverterClient() , format_91(new Double_0(toDouble(availDuration)), ($clinit_MeasurementUnits() , MILLISECONDS)));
      $append_1(sb.data_0, ' "availDuration": "' + availDurationString + '" },');
    }
    $setLength_1(sb, $toString_1(sb.data_0).length - 1);
  }
   else if (this.groupAvailabilityList) {
    for (groupAvailability$iterator = this.groupAvailabilityList.iterator(); groupAvailability$iterator.hasNext();) {
      groupAvailability = dynamicCast(groupAvailability$iterator.next_0(), Q$ResourceGroupAvailability);
      availabilityTypeMessage = groupAvailability.groupAvailabilityType == ($clinit_ResourceGroupComposite$GroupAvailabilityType() , WARN_1)?'MIXED':groupAvailability.groupAvailabilityType.name_0;
      $append_12(sb, '{ "availType":"' + groupAvailability.groupAvailabilityType + '", ');
      $append_1(sb.data_0, ' "availTypeMessage":"' + availabilityTypeMessage + '", ');
      $append_12(sb, ' "availStart":' + groupAvailability.startTime + ', ');
      endTime = groupAvailability.endTime?groupAvailability.endTime.value_0:(new Date_1).getTime_0();
      $append_1(sb.data_0, ' "availEnd":' + toString_8(endTime) + ', ');
      availDuration = sub(endTime, groupAvailability.startTime.value_0);
      availDurationString = ($clinit_MeasurementConverterClient() , format_91(new Double_0(toDouble(availDuration)), ($clinit_MeasurementUnits() , MILLISECONDS)));
      $append_1(sb.data_0, ' "availDuration": "' + availDurationString + '" },');
    }
    $setLength_1(sb, $toString_1(sb.data_0).length - 1);
  }
  $append_1(sb.data_0, ']');
  debug($toString_1(sb.data_0));
  return $toString_1(sb.data_0);
}
;
_.getChartDateLabel = function getChartDateLabel(){
  return 'Date';
}
;
_.getChartHoverAvailabilityLabel = function getChartHoverAvailabilityLabel(){
  return 'Availability';
}
;
_.getChartHoverBarLabel = function getChartHoverBarLabel(){
  return 'Duration';
}
;
_.getChartHoverDateFormat = function getChartHoverDateFormat(){
  return '%m/%d/%y';
}
;
_.getChartHoverEndLabel = function getChartHoverEndLabel(){
  return 'End';
}
;
_.getChartHoverStartLabel = function getChartHoverStartLabel(){
  return 'Start';
}
;
_.getChartHoverTimeFormat = function getChartHoverTimeFormat(){
  return '%I:%M:%S %p';
}
;
_.getChartId = function getChartId(){
  return '' + this.entityId;
}
;
_.getChartTimeLabel = function getChartTimeLabel(){
  return 'Start';
}
;
_.availabilityList = null;
_.entityId = null;
_.groupAvailabilityList = null;
function $clinit_MetricGraphData(){
  $clinit_MetricGraphData = nullMethod;
  DEFAULT_CHART_HEIGHT = valueOf_44(200);
}

function $getChartId(this$static){
  return this$static.isPortalGraph?this$static.definition?this$static.entityId + '-' + this$static.definition.id:'':this$static.entityId + '-' + this$static.definitionId;
}

function $getChartTitle_0(this$static){
  return this$static.definition?this$static.entityName == null?this$static.definition.displayName:this$static.entityName + ' - ' + this$static.definition.displayName:'';
}

function $setDefinition_0(this$static, definition){
  this$static.definition = definition;
}

function $setDefinitionId(this$static, definitionId){
  this$static.definitionId = definitionId;
}

function $setEntityId_0(this$static, entityId){
  this$static.entityId = entityId;
}

function $setEntityName_0(this$static, entityName){
  this$static.entityName = entityName;
}

function MetricGraphData_0(){
  $clinit_MetricGraphData();
  $clinit_CoreGUI();
  this.isPortalGraph = true;
}

function MetricGraphData_1(entityId, entityName, def){
  $clinit_MetricGraphData();
  $clinit_CoreGUI();
  this.entityName = entityName;
  this.entityId = entityId;
  $setDefinitionId(this, def.id);
  this.definition = def;
  this.isPortalGraph = false;
}

function MetricGraphData_2(entityId, entityName, measurementDef){
  $clinit_MetricGraphData();
  $clinit_CoreGUI();
  this.entityName = entityName;
  this.entityId = entityId;
  $setDefinitionId(this, measurementDef.id);
  this.definition = measurementDef;
  this.isPortalGraph = false;
}

defineSeed(2925, 1, {}, MetricGraphData_0, MetricGraphData_1, MetricGraphData_2);
_.toString$ = function toString_209(){
  var sb;
  sb = new StringBuilder_0;
  $append_1(sb.data_0, 'MetricGraphData');
  $append_7($append_12(($append_1(sb.data_0, "{chartTitleMinLabel='") , sb), 'Min'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartTitleAvgLabel='") , sb), 'Avg'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartTitlePeakLabel='") , sb), 'Max'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartDateLabel='") , sb), 'Date'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartTimeLabel='") , sb), 'Start'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartDownLabel='") , sb), 'Down'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartUnknownLabel='") , sb), 'Unknown'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartNoDataLabel='") , sb), 'No Data'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartHoverStartLabel='") , sb), 'Start'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartHoverEndLabel='") , sb), 'End'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartHoverPeriodLabel='") , sb), 'Period'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartHoverBarLabel='") , sb), 'Duration'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartHoverTimeFormat='") , sb), '%I:%M:%S %p'), 39);
  $append_7($append_12(($append_1(sb.data_0, ", chartHoverDateFormat='") , sb), '%m/%d/%y'), 39);
  $append_9(($append_1(sb.data_0, ', entityId=') , sb), this.entityId);
  $append_7($append_12(($append_1(sb.data_0, ", entityName='") , sb), this.entityName), 39);
  $append_9(($append_1(sb.data_0, ', definitionId=') , sb), this.definitionId);
  $append_13(($append_1(sb.data_0, ', isPortalGraph=') , sb), this.isPortalGraph);
  $appendNonNull(sb.data_0, '}');
  return $toString_1(sb.data_0);
}
;
_.definition = null;
_.definitionId = 0;
_.entityId = 0;
_.entityName = null;
_.isPortalGraph = false;
var DEFAULT_CHART_HEIGHT;
defineSeed(2927, 2923, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]));
function $drawJsniChart_0(){
}

function StackedBarMetricGraphIE8Impl_0(){
  $clinit_BaseWidget();
  VLayout_0.call(this);
}

defineSeed(2926, 2927, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), StackedBarMetricGraphIE8Impl_0);
function $addViewRenderedListener(this$static, listener){
  $add_3(this$static.viewRenderedListeners, listener);
}

function $notifyViewRenderedListeners(this$static){
  var listener, listener$iterator;
  for (listener$iterator = new AbstractList$IteratorImpl_0(this$static.viewRenderedListeners); listener$iterator.i < listener$iterator.this$0_0.size_1();) {
    listener = dynamicCast($next_0(listener$iterator), Q$AbstractTwoLevelTabSetView$ViewRenderedListener);
    listener.onViewRendered();
  }
}

function $onTabSelected(this$static, tabSelectedEvent){
  var historyToken, path, subTabId, tabId, tabPath;
  historyToken = tabSelectedEvent.historyToken;
  if (!this$static.getSelectedItemId()) {
    $disable(this$static.tabSet);
    $clinit_CoreGUI();
    goToView(historyToken, null, false);
  }
   else {
    tabId = tabSelectedEvent.id;
    subTabId = tabSelectedEvent.subTabId;
    tabPath = '/' + tabId + '/' + subTabId;
    path = this$static.baseViewPath + '/' + this$static.getSelectedItemId() + tabPath;
    if ($equals_6(historyToken, path) || historyToken.indexOf(path + '/') == 0) {
      $enable(this$static.tabSet);
    }
     else {
      $disable(this$static.tabSet);
      $clinit_CoreGUI();
      goToView(path, null, false);
    }
  }
}

function $renderTabs(this$static, viewPath){
  var id;
  id = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  ++viewPath.index_0;
  if (viewPath.viewPath.size_0 <= viewPath.index_0) {
    this$static.tabName = null;
  }
   else {
    this$static.tabName = (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path;
    ++viewPath.index_0;
    if (viewPath.viewPath.size_0 <= viewPath.index_0) {
      this$static.subTabName = null;
    }
     else {
      this$static.subTabName = (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path;
      ++viewPath.index_0;
    }
  }
  this$static.tabSet.ignoreSelectEvents = true;
  if (!this$static.getSelectedItemId() || this$static.getSelectedItemId().value_0 != id || viewPath.refresh) {
    this$static.loadSelectedItem(id, viewPath);
  }
   else {
    try {
      this$static.selectTab_0(this$static.tabName, this$static.subTabName, viewPath);
      !!this$static.graphListView && this$static.graphListView.redrawGraphs();
    }
     finally {
      $notifyViewRenderedListeners(this$static);
    }
  }
}

function $renderView_8(this$static, viewPath){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new AbstractTwoLevelTabSetView$1_0(this$static, viewPath)));
}

function $selectDefaultSubTab(this$static, tab){
  var subTab;
  subTab = $getDefaultSubTab(tab.layout);
  if (!subTab || $isSubTabDisabled(subTab)) {
    $handleError_0(($clinit_CoreGUI() , 'Invalid subtab: ' + ($clinit_Enhanced() , subTab?subTab.viewName.name_0:'null')), null);
    subTab = $getDefaultSubTab(tab.layout);
  }
  $selectSubTab(tab.layout, subTab, true);
  $selectTab_0(this$static.tabSet, tab);
  return subTab;
}

function $selectDefaultTabAndSubTab(this$static){
  var tab;
  tab = $getDefaultTab(this$static.tabSet);
  if (!tab) {
    throw new IllegalStateException_1('No default tab is defined.');
  }
  return $selectDefaultSubTab(this$static, tab);
}

function $selectTab_1(this$static, tabName, subtabName, viewPath){
  var $e0, e, subView, subtab, tab;
  try {
    tab = tabName != null?$getTabByName(this$static.tabSet, tabName):null;
    if (!tab || (!tab.tabSet || !$isDrawn(tab.tabSet).value_0?$getAttributeAsBoolean_0(tab, 'disabled'):$getAttributeAsBoolean_0($getTab(tab.tabSet, getAttribute(tab.jsObj, 'ID')), 'disabled')).value_0) {
      this$static.tabSet.ignoreSelectEvents = false;
      $selectDefaultTabAndSubTab(this$static);
      return;
    }
    subtab = subtabName != null?$getSubTabByName(tab.layout, subtabName):$getDefaultSubTab(tab.layout);
    if (!subtab || $isSubTabDisabled(subtab)) {
      this$static.tabSet.ignoreSelectEvents = false;
      $selectDefaultSubTab(this$static, tab);
      return;
    }
    $selectTab_0(this$static.tabSet, tab);
    $selectSubTab(tab.layout, subtab, false);
    subView = (!subtab.canvas_0 && !!subtab.viewFactory && (subtab.canvas_0 = subtab.viewFactory.createView()) , subtab.canvas_0);
    if (instanceOf(subView, Q$BookmarkableView)) {
      dynamicCast(subView, Q$BookmarkableView).renderView(viewPath);
    }
     else if (instanceOf(subView, Q$RefreshableView) && $isDrawn(subView).value_0) {
      debug('Refreshing data for [' + subView.___clazz$.typeName + ']...');
      dynamicCast(subView, Q$RefreshableView).refresh_0();
    }
    $setAttribute_24(subView, 'visibility', ($clinit_Visibility() , INHERIT).value_0, true);
    this$static.tabSet.ignoreSelectEvents = false;
    $enable(this$static.tabSet);
    $markForRedraw(this$static.tabSet);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      e = $e0;
      $enable(this$static.tabSet);
      $clinit_Log();
      $log_1(logger_0, ($clinit_Level() , WARNING), 'Failed to select tab ' + tabName + '/' + subtabName + '.', e);
    }
     else 
      throw $e0;
  }
}

function $updateSubTab(tab, subTab, visible, enabled, viewFactory){
  visible?$showSubTab(tab.layout, subTab):$hideSubTab(tab.layout, subTab);
  if (visible) {
    enabled?$enableSubTab(tab.layout, subTab):$disableSubTab(tab.layout, subTab);
    if (enabled) {
      subTab.canvas_0 = null;
      subTab.viewFactory = viewFactory;
    }
  }
}

function $updateTab_0(this$static, tab, visible, enabled){
  if (visible) {
    $setTabHidden(this$static.tabSet, tab, false);
    $setTabEnabled(this$static.tabSet, tab, enabled);
  }
   else {
    $setTabHidden(this$static.tabSet, tab, true);
  }
  return visible && enabled;
}

function $updateTabContent(this$static){
  var currentViewPath;
  currentViewPath = ($clinit_History() , impl_0?token_1 == null?'':token_1:'');
  if ($indexOf_2(currentViewPath, this$static.baseViewPath) != 0) {
    throw new ViewChangedException_1(this$static.baseViewPath + '/' + this$static.getSelectedItemId());
  }
}

function AbstractTwoLevelTabSetView_0(baseViewPath){
  var tabsList;
  EnhancedVLayout_0.call(this);
  this.viewRenderedListeners = new ArrayList_0;
  this.baseViewPath = baseViewPath;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  this.titleBar = this.createTitleBar();
  $addMember(this, this.titleBar);
  this.tabSet = new TwoLevelTabSet_0;
  $setAttribute_24(this.tabSet, 'tabBarPosition', ($clinit_Side() , TOP_0).value_0, false);
  $setAttribute_24(this.tabSet, 'width', '100%', true);
  $setAttribute_24(this.tabSet, 'height', '100%', true);
  $setEdgeMarginSize(this.tabSet);
  $setEdgeSize(this.tabSet);
  tabsList = this.createTabs();
  $setTabs_0(this.tabSet, dynamicCast($toArray_1(tabsList, initDim(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_TwoLevelTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$TwoLevelTab_$1]), Q$TwoLevelTab, tabsList.size_0, 0)), Q$TwoLevelTab_$1));
  $addTwoLevelTabSelectedHandler_0(this.tabSet, this);
  $addMember(this, this.tabSet);
}

defineSeed(2928, 1600, makeCastMap([Q$HasAttachHandlers, Q$EventHandler, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$TwoLevelTabSelectedHandler, Q$Enhanced]));
_.destroy_0 = function destroy_15(){
  $destroy_4(this.tabSet);
  destroyMembers(this);
  $destroy(this);
}
;
_.onTabSelected_0 = function onTabSelected_2(tabSelectedEvent){
  $onTabSelected(this, tabSelectedEvent);
}
;
_.renderView = function renderView_20(viewPath){
  $renderView_8(this, viewPath);
}
;
_.selectTab_0 = function selectTab(tabName, subtabName, viewPath){
  $selectTab_1(this, tabName, subtabName, viewPath);
}
;
_.baseViewPath = null;
_.globalPermissions = null;
_.graphListView = null;
_.subTabName = null;
_.tabName = null;
_.tabSet = null;
_.titleBar = null;
function AbstractTwoLevelTabSetView$1_0(this$0, val$viewPath){
  this.this$0 = this$0;
  this.val$viewPath = val$viewPath;
}

defineSeed(2929, 1, {}, AbstractTwoLevelTabSetView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_11(permissions){
  this.this$0.globalPermissions = permissions?permissions:new HashSet_0;
  $renderTabs(this.this$0, this.val$viewPath);
}
;
_.this$0 = null;
_.val$viewPath = null;
function IFrameWithMeasurementRangeEditorView_0(url){
  $clinit_BaseWidget();
  var footer;
  EnhancedVLayout_0.call(this);
  this.iframe = new HTMLPane_0;
  $setContentsURL(this.iframe, url);
  $setAttribute_24(this.iframe, 'contentsType', ($clinit_ContentsType() , PAGE).value_0, false);
  $setAttribute_24(this.iframe, 'width', '100%', true);
  $addMember(this, this.iframe);
  footer = new EnhancedToolStrip_0;
  $isCreated_1(footer)?$setProperty_3(footer, 'width', '100%'):(footer.config_0['width'] = '100%' , undefined);
  $addMember(this, footer);
  this.editor = new IFrameWithMeasurementRangeEditorView$1_0(this, url);
  $addMember(footer, this.editor);
}

defineSeed(2930, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$Enhanced]), IFrameWithMeasurementRangeEditorView_0);
_.refresh_0 = function refresh_32(){
  $refresh_4(this.editor);
}
;
_.editor = null;
_.iframe = null;
function IFrameWithMeasurementRangeEditorView$1_0(this$0, val$url){
  $clinit_AbstractMeasurementRangeEditor();
  this.this$0 = this$0;
  this.val$url = val$url;
  UserPreferencesMeasurementRangeEditor_0.call(this);
}

defineSeed(2931, 2335, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm, Q$TableWidget]), IFrameWithMeasurementRangeEditorView$1_0);
_.setMetricRangeProperties = function setMetricRangeProperties_1(prefs){
  $setMetricRangePreferences_0(this.measurementUserPrefs, prefs);
  $setContentsURL(this.this$0.iframe, this.val$url);
}
;
_.this$0 = null;
_.val$url = null;
function $onSuccess_250(this$static){
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, this$static.val$operationHistoryToRemove, new Message_0('success'));
}

function AbstractOperationHistoryDataSource$1_0(this$0, val$request, val$response, val$operationHistoryToRemove){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$operationHistoryToRemove = val$operationHistoryToRemove;
}

defineSeed(2932, 1, {}, AbstractOperationHistoryDataSource$1_0);
_.onFailure = function onFailure_261(caught){
  throw new RuntimeException_2('Failed to delete ' + this.val$operationHistoryToRemove + '.', caught);
}
;
_.onSuccess_0 = function onSuccess_261(result){
  $onSuccess_250(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$operationHistoryToRemove = null;
_.val$request = null;
_.val$response = null;
function $createFields_0(operationHistory){
  var completedItem, errorLinkItem, icon, idItem, items, operationDefinition, operationItem, requesterItem, status_0, statusItem, submittedItem, errMsg;
  items = new ArrayList_0;
  status_0 = operationHistory.status_0;
  idItem = new StaticTextItem_2('id', 'Execution ID');
  $setValue_5(idItem, operationHistory.id);
  setCheck(items.array, items.size_0++, idItem);
  operationItem = new StaticTextItem_2('operationName', ($clinit_Enhanced() , 'Operation'));
  operationDefinition = operationHistory.operationDefinition;
  $setValue_7(operationItem, operationDefinition.displayName);
  setCheck(items.array, items.size_0++, operationItem);
  submittedItem = new StaticTextItem_2('startedTime', 'Date Submitted');
  eq(operationHistory.startedTime, P0_longLit)?$setValue_7(submittedItem, 'Never'):$setValue_7(submittedItem, ($clinit_TimestampCellFormatter() , format_30(valueOf_45(operationHistory.startedTime), DATE_TIME_FORMAT_MEDIUM)));
  setCheck(items.array, items.size_0++, submittedItem);
  completedItem = new StaticTextItem_2('completed', 'Date Completed');
  status_0 == ($clinit_OperationRequestStatus() , INPROGRESS_1)?$setValue_7(completedItem, 'N/A'):status_0 == CANCELED?$setValue_7(completedItem, 'Never'):$setValue_7(completedItem, ($clinit_TimestampCellFormatter() , format_30(new Date_2(add(operationHistory.startedTime, $getDuration(operationHistory))), DATE_TIME_FORMAT_MEDIUM)));
  setCheck(items.array, items.size_0++, completedItem);
  requesterItem = new StaticTextItem_2('subjectName', 'Requestor');
  $setEscapeHTML(requesterItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setValue_7(requesterItem, operationHistory.subjectName);
  setCheck(items.array, items.size_0++, requesterItem);
  statusItem = new StaticTextItem_2('status', 'Status');
  icon = 'images/' + getOperationResultsIcon(status_0);
  $setValue_7(statusItem, "<img src='" + icon + "'/>");
  setCheck(items.array, items.size_0++, statusItem);
  switch (status_0.ordinal) {
    case 1:
      $setPrompt_1(statusItem, 'Success');
      break;
    case 3:
    case 2:
      status_0 == CANCELED?$setPrompt_1(statusItem, 'Canceled'):$setPrompt_1(statusItem, 'Failed');
      errorLinkItem = new StaticTextItem_1('errorLink');
      $setAttribute_30(errorLinkItem, 'textAlign', ($clinit_Alignment() , LEFT_0).value_0);
      $setAttribute_30(errorLinkItem, 'align', LEFT_0.value_0);
      $setAttribute_30(errorLinkItem, 'vAlign', ($clinit_VerticalAlignment() , BOTTOM_1).value_0);
      $setErrorOrientation_0(errorLinkItem, ($clinit_FormErrorOrientation() , LEFT_1));
      $setTitle_1(errorLinkItem, 'Error');
      $setValue_7(errorLinkItem, '<span style="text-decoration:underline;">' + (errMsg = operationHistory.errorMessage_0 , errMsg == null?(errMsg = 'Failed'):errMsg.length > 80 && (errMsg = errMsg.substr(0, 80 - 0) + '...') , errMsg) + '<span>');
      errorLinkItem.addClickHandler(new AbstractOperationHistoryDetailsView$1_0(operationHistory));
      setCheck(items.array, items.size_0++, errorLinkItem);
      break;
    case 0:
      $setPrompt_1(statusItem, 'In Progress');
  }
  return items;
}

function $displayDetails(this$static, operationHistory){
  var child, child$array, child$index, child$max, editor, items, noParametersLabel, operationDefinition, parametersConfigurationDefinition, parametersSection, resultsSection, title;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    $removeChild_0(this$static, child);
  }
  this$static.operationHistory = operationHistory;
  this$static.form_0 = new DynamicForm_0;
  $setAttribute_24(this$static.form_0, 'width', '100%', true);
  $setWrapItemTitles(this$static.form_0, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  items = this$static.createFields_0(operationHistory);
  this$static.form_0.setFields(dynamicCast($toArray_1(items, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, items.size_0, 0)), Q$FormItem_$1));
  $addMember(this$static, this$static.form_0);
  if (operationHistory.parameters) {
    parametersSection = new EnhancedVLayout_0;
    title = new Label_4('<h4>' + ($clinit_Enhanced() , 'Parameters') + '<\/h4>');
    $isCreated_1(title)?$setProperty_0(title, 'height', 27):(title.config_0['height'] = 27 , undefined);
    $addMember(parametersSection, title);
    operationDefinition = operationHistory.operationDefinition;
    parametersConfigurationDefinition = operationDefinition.parametersConfigurationDefinition;
    if (!!parametersConfigurationDefinition && !(!parametersConfigurationDefinition.propertyDefinitions && (parametersConfigurationDefinition.propertyDefinitions = new LinkedHashMap_0) , parametersConfigurationDefinition.propertyDefinitions).isEmpty_0()) {
      editor = new ConfigurationEditor_1(parametersConfigurationDefinition, operationHistory.parameters);
      editor.readOnly = true;
      $addMember(parametersSection, editor);
    }
     else {
      noParametersLabel = new Label_4('This operation does not take any parameters.');
      $isCreated_1(noParametersLabel)?$setProperty_0(noParametersLabel, 'height', 17):(noParametersLabel.config_0['height'] = 17 , undefined);
      $addMember(parametersSection, noParametersLabel);
    }
    $addMember(this$static, parametersSection);
  }
  resultsSection = this$static.buildResultsSection(operationHistory);
  !!resultsSection && $addMember(this$static, resultsSection);
}

function AbstractOperationHistoryDetailsView_0(){
  EnhancedVStack_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $setLayoutMargin(this, valueOf_44(0));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 16):(this.config_0['membersMargin'] = 16 , undefined);
}

defineSeed(2933, 1632, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$Enhanced]));
_.createFields_0 = function createFields_1(operationHistory){
  return $createFields_0(operationHistory);
}
;
_.onDraw_0 = function onDraw_38(){
  destroyMembers(this);
  !!this.operationHistory && $displayDetails(this, this.operationHistory);
}
;
_.renderView = function renderView_21(viewPath){
  var historyId;
  historyId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  this.lookupDetails(historyId);
}
;
_.form_0 = null;
_.operationHistory = null;
function AbstractOperationHistoryDetailsView$1_0(val$operationHistory){
  this.val$operationHistory = val$operationHistory;
}

defineSeed(2934, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), AbstractOperationHistoryDetailsView$1_0);
_.onClick_0 = function onClick_126(event_0){
  var errorMsg, htmlPane, winModal;
  winModal = new Window_1;
  $setTitle(winModal, ($clinit_Enhanced() , 'Details'));
  $setAttribute_24(winModal, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $setShowMinimizeButton(winModal, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowMaximizeButton(winModal, TRUE);
  $setIsModal(winModal, TRUE);
  $setShowModalMask(winModal, TRUE);
  $setAutoSize(winModal, TRUE);
  $setAutoCenter(winModal, TRUE);
  $setShowResizer(winModal, TRUE);
  $setCanDragResize_0(winModal, TRUE);
  $centerInPage(winModal);
  $addCloseClickHandler(winModal, new AbstractOperationHistoryDetailsView$1$1_0(winModal));
  htmlPane = new HTMLPane_0;
  $setMargin(htmlPane, valueOf_44(10));
  $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultWidth', 500):(htmlPane.config_0['defaultWidth'] = 500 , undefined);
  $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultHeight', 400):(htmlPane.config_0['defaultHeight'] = 400 , undefined);
  errorMsg = this.val$operationHistory.errorMessage_0;
  errorMsg == null && (errorMsg = 'Failed');
  $isCreated_1(htmlPane)?$setProperty_3(htmlPane, 'contents', '<pre>' + errorMsg + '<\/pre>'):(htmlPane.config_0['contents'] = '<pre>' + errorMsg + '<\/pre>' , undefined);
  $addItem(winModal, htmlPane);
  winModal.show_0();
}
;
_.val$operationHistory = null;
function AbstractOperationHistoryDetailsView$1$1_0(val$winModal){
  this.val$winModal = val$winModal;
}

defineSeed(2935, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), AbstractOperationHistoryDetailsView$1$1_0);
_.onCloseClick_0 = function onCloseClick_9(event_0){
  $markForDestroy(this.val$winModal);
}
;
_.val$winModal = null;
function AbstractOperationHistoryListView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2936, 1, {}, AbstractOperationHistoryListView$1_0);
_.executeAction = function executeAction_47(selection, actionValue){
  var historyId, numCancelRequestsSubmitted, opService, toBeCanceled, toBeCanceled$index, toBeCanceled$max;
  numCancelRequestsSubmitted = 0;
  opService = dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync);
  for (toBeCanceled$index = 0 , toBeCanceled$max = selection.length; toBeCanceled$index < toBeCanceled$max; ++toBeCanceled$index) {
    toBeCanceled = selection[toBeCanceled$index];
    if ($equals_6(($clinit_OperationRequestStatus() , INPROGRESS_1).name_0, getAttribute(toBeCanceled.jsObj, 'status'))) {
      ++numCancelRequestsSubmitted;
      historyId = getAttributeAsInt(toBeCanceled.jsObj, 'id').value_0;
      $cancelOperationHistory(opService, historyId, new AbstractOperationHistoryListView$1$1_0(historyId));
    }
  }
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Requests to cancel [' + ($clinit_Enhanced() , '' + numCancelRequestsSubmitted) + '] "in progress" operations have been submitted.', ($clinit_Message$Severity() , Info)));
  this.this$0.refreshTableInfo();
}
;
_.isEnabled_0 = function isEnabled_24(selection){
  var count, item, item$index, item$max;
  count = selection.length;
  for (item$index = 0 , item$max = selection.length; item$index < item$max; ++item$index) {
    item = selection[item$index];
    $equals_6(($clinit_OperationRequestStatus() , INPROGRESS_1).name_0, getAttribute(item.jsObj, 'status')) || --count;
  }
  return count >= 1 && this.this$0.hasControlPermission_1();
}
;
_.this$0 = null;
function $onSuccess_251(this$static){
  var msg;
  msg = new Message_8('The cancel request has been successfully submitted for the operation with the history ID of [' + ($clinit_Enhanced() , '' + this$static.val$historyId) + '].', ($clinit_Message$Severity() , Info), of(($clinit_Message$Option() , BackgroundJobResult)));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
}

function AbstractOperationHistoryListView$1$1_0(val$historyId){
  this.val$historyId = val$historyId;
}

defineSeed(2937, 1, {}, AbstractOperationHistoryListView$1$1_0);
_.onFailure = function onFailure_262(caught){
  var msg;
  msg = new Message_5('The cancel request failed for the operation with the history ID of [' + ($clinit_Enhanced() , '' + this.val$historyId) + '].', caught, ($clinit_Message$Severity() , Error_2), of(($clinit_Message$Option() , BackgroundJobResult)));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
}
;
_.onSuccess_0 = function onSuccess_262(result){
  $onSuccess_251(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$historyId = 0;
function $onSuccess_252(this$static){
  $add_3(this$static.val$successIds, valueOf_44(this$static.val$operationHistoryToRemove.id));
  $handleCompletion(this$static.this$0, this$static.val$successIds, this$static.val$failureIds, this$static.val$numberOfRecordsToBeDeleted);
}

function AbstractOperationHistoryListView$10_0(this$0, val$successIds, val$operationHistoryToRemove, val$failureIds, val$numberOfRecordsToBeDeleted){
  this.this$0 = this$0;
  this.val$successIds = val$successIds;
  this.val$operationHistoryToRemove = val$operationHistoryToRemove;
  this.val$failureIds = val$failureIds;
  this.val$numberOfRecordsToBeDeleted = val$numberOfRecordsToBeDeleted;
}

defineSeed(2938, 1, {}, AbstractOperationHistoryListView$10_0);
_.onFailure = function onFailure_263(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to delete ' + this.val$operationHistoryToRemove + '.'), caught);
  $add_3(this.val$failureIds, valueOf_44(this.val$operationHistoryToRemove.id));
  $handleCompletion(this.this$0, this.val$successIds, this.val$failureIds, this.val$numberOfRecordsToBeDeleted);
}
;
_.onSuccess_0 = function onSuccess_263(result){
  $onSuccess_252(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$failureIds = null;
_.val$numberOfRecordsToBeDeleted = 0;
_.val$operationHistoryToRemove = null;
_.val$successIds = null;
function AbstractOperationHistoryListView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2939, 1, {}, AbstractOperationHistoryListView$2_0);
_.executeAction = function executeAction_48(selection, actionValue){
  $deleteSelectedRecords_0(this.this$0, null);
}
;
_.isEnabled_0 = function isEnabled_25(selection){
  var count;
  count = selection.length;
  return count >= 1 && this.this$0.hasControlPermission_1();
}
;
_.this$0 = null;
function AbstractOperationHistoryListView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2940, 1, {}, AbstractOperationHistoryListView$3_0);
_.executeAction = function executeAction_49(selection, actionValue){
  var requestProperties;
  requestProperties = new DSRequest_0;
  requestProperties.jsObj['force'] = true;
  $deleteSelectedRecords_0(this.this$0, requestProperties);
}
;
_.isEnabled_0 = function isEnabled_26(selection){
  var count;
  count = selection.length;
  return count >= 1 && this.this$0.hasControlPermission_1();
}
;
_.this$0 = null;
function AbstractOperationHistoryListView$4_0(){
  $clinit_TimestampCellFormatter();
  TimestampCellFormatter_0.call(this);
}

defineSeed(2941, 2388, {}, AbstractOperationHistoryListView$4_0);
_.format_1 = function format_47(value, record, rowNum, colNum){
  return value != null?format_30(value, this.dateTimeFormat):'<i>' + ($clinit_Enhanced() , 'not yet started') + '<\/i>';
}
;
function AbstractOperationHistoryListView$5_0(){
}

defineSeed(2942, 1, {}, AbstractOperationHistoryListView$5_0);
_.hoverHTML_0 = function hoverHTML_22(value, record, rowNum, colNum){
  var status_0, statusStr;
  statusStr = getAttribute(record.jsObj, 'status');
  status_0 = ($clinit_OperationRequestStatus() , dynamicCast(valueOf(($clinit_OperationRequestStatus$Map() , $MAP_96), statusStr), Q$OperationRequestStatus));
  switch (status_0.ordinal) {
    case 1:
      {
        return $clinit_Enhanced() , 'Success';
      }

    case 2:
      {
        return $clinit_Enhanced() , 'Failed';
      }

    case 0:
      {
        return $clinit_Enhanced() , 'In Progress';
      }

    case 3:
      {
        return $clinit_Enhanced() , 'Canceled';
      }

  }
  return $clinit_Enhanced() , 'Unknown';
}
;
function AbstractOperationHistoryListView$6_0(){
}

defineSeed(2943, 1, {}, AbstractOperationHistoryListView$6_0);
_.format_1 = function format_48(o, listGridRecord, i, i1){
  var icon, status_0;
  status_0 = valueOf_105(dynamicCast(o, Q$String));
  icon = getOperationResultsIcon(status_0);
  return imgHTML_0(icon, 16, 16);
}
;
function AbstractOperationHistoryListView$7_0(){
}

defineSeed(2944, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), AbstractOperationHistoryListView$7_0);
_.onRecordClick = function onRecordClick_10(event_0){
  var errorMsg, htmlPane, record, status_0, statusStr, winModal;
  record = $getRecord_0(event_0);
  statusStr = getAttribute(record.jsObj, 'status');
  status_0 = ($clinit_OperationRequestStatus() , dynamicCast(valueOf(($clinit_OperationRequestStatus$Map() , $MAP_96), statusStr), Q$OperationRequestStatus));
  if (status_0 == FAILURE_6) {
    winModal = new Window_1;
    $setTitle(winModal, ($clinit_Enhanced() , 'Details'));
    $setAttribute_24(winModal, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
    $setShowMinimizeButton(winModal, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setShowMaximizeButton(winModal, TRUE);
    $setIsModal(winModal, TRUE);
    $setShowModalMask(winModal, TRUE);
    $setAutoSize(winModal, TRUE);
    $setAutoCenter(winModal, TRUE);
    $setShowResizer(winModal, TRUE);
    $setCanDragResize_0(winModal, TRUE);
    $centerInPage(winModal);
    $addCloseClickHandler(winModal, new AbstractOperationHistoryListView$7$1_0(winModal));
    htmlPane = new HTMLPane_0;
    $setMargin(htmlPane, valueOf_44(10));
    $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultWidth', 500):(htmlPane.config_0['defaultWidth'] = 500 , undefined);
    $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultHeight', 400):(htmlPane.config_0['defaultHeight'] = 400 , undefined);
    errorMsg = getAttribute(record.jsObj, 'errorMessage');
    errorMsg == null && (errorMsg = 'Failed');
    $isCreated_1(htmlPane)?$setProperty_3(htmlPane, 'contents', '<pre>' + errorMsg + '<\/pre>'):(htmlPane.config_0['contents'] = '<pre>' + errorMsg + '<\/pre>' , undefined);
    $addItem(winModal, htmlPane);
    winModal.show_0();
  }
}
;
function AbstractOperationHistoryListView$7$1_0(val$winModal){
  this.val$winModal = val$winModal;
}

defineSeed(2945, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), AbstractOperationHistoryListView$7$1_0);
_.onCloseClick_0 = function onCloseClick_10(event_0){
  $markForDestroy(this.val$winModal);
}
;
_.val$winModal = null;
function AbstractOperationHistoryListView$8_0(){
}

defineSeed(2946, 1, {}, AbstractOperationHistoryListView$8_0);
_.format_1 = function format_49(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function AbstractOperationHistoryListView$9_0(){
}

defineSeed(2947, 1, {}, AbstractOperationHistoryListView$9_0);
_.hoverHTML_0 = function hoverHTML_23(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function $addDataSourceFields_3(this$static){
  var descriptionField, fields, idField, nextFireTimeField, operationDefinition, operationDefinition$iterator, operationDefinitions, operationDisplayNameField, operationNameField, subjectField, timeoutField, valueMap;
  fields = new ArrayList_0;
  idField = new DataSourceIntegerField_1('id', 'Schedule ID');
  $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_8(idField, 'canEdit', FALSE);
  setCheck(fields.array, fields.size_0++, idField);
  operationNameField = createTextField('operationName', 'Operation', null, valueOf_44(100), TRUE);
  operationDefinitions = new TreeSet_1(new AbstractOperationScheduleDataSource$1_0);
  $addAll(operationDefinitions, this$static.resourceType.operationDefinitions);
  valueMap = new LinkedHashMap_0;
  for (operationDefinition$iterator = $iterator($keySet(operationDefinitions.map)); operationDefinition$iterator.val$outerIter.hasNext();) {
    operationDefinition = dynamicCast($next_1(operationDefinition$iterator), Q$OperationDefinition);
    $put_1(valueMap, operationDefinition.name_0, operationDefinition.displayName);
  }
  setAttribute_10(operationNameField.jsObj, 'valueMap', valueMap);
  setCheck(fields.array, fields.size_0++, operationNameField);
  operationDisplayNameField = createTextField('operationDisplayName', 'Operation', null, valueOf_44(100), TRUE);
  setCheck(fields.array, fields.size_0++, operationDisplayNameField);
  subjectField = new DataSourceField_2('subject', ($clinit_FieldType() , ANY), 'Owner');
  $setAttribute_8(subjectField, 'canEdit', FALSE);
  setCheck(fields.array, fields.size_0++, subjectField);
  descriptionField = createTextField('description', 'Notes', null, valueOf_44(100), FALSE);
  setCheck(fields.array, fields.size_0++, descriptionField);
  nextFireTimeField = new DataSourceDateTimeField_0('nextFireTime', 'Next Execution');
  $setAttribute_8(nextFireTimeField, 'canEdit', FALSE);
  setCheck(fields.array, fields.size_0++, nextFireTimeField);
  timeoutField = createIntegerField(valueOf_44(30), FALSE);
  setCheck(fields.array, fields.size_0++, timeoutField);
  return fields;
}

function $addRequestPropertiesToRecord(request, record){
  var parameters;
  parameters = dynamicCast(getAttributeAsObject(request.jsObj, 'parameters'), Q$Configuration);
  !parameters?(record.jsObj['parameters'] = null , undefined):(record.jsObj['parameters'] = parameters , undefined);
}

function $copyValues_43(this$static, from){
  var parameters, subject, timeout, to;
  to = this$static.createOperationSchedule();
  $setId_3(to, getAttributeAsInt(from.jsObj, 'id').value_0);
  $setJobName(to, getAttribute(from.jsObj, 'jobName'));
  $setJobGroup(to, getAttribute(from.jsObj, 'jobGroup'));
  subject = new Subject_0;
  $setName_3(subject, getAttribute(from.jsObj, 'subject'));
  $setId_0(subject, getAttributeAsInt(from.jsObj, 'subjectId').value_0);
  $setSubject(to, subject);
  parameters = dynamicCast(getAttributeAsObject(from.jsObj, 'parameters'), Q$Configuration);
  timeout = getAttributeAsInteger(from);
  if (timeout) {
    !parameters && (parameters = new Configuration_0);
    $put_4(parameters, new PropertySimple_1('rhq.timeout', timeout));
  }
  to.parameters = parameters;
  $setOperationName(to, getAttribute(from.jsObj, 'operationName'));
  $setOperationDisplayName(to, getAttribute(from.jsObj, 'operationDisplayName'));
  $setDescription_2(to, getAttribute(from.jsObj, 'description'));
  $setNextFireTime(to, getAttributeAsDate(from.jsObj, 'nextFireTime'));
  $setJobTrigger(to, $createJobTrigger(getOrCreateRef_1(getAttributeAsJavaScriptObject(from.jsObj, 'jobTrigger'))));
  return to;
}

function $copyValues_44(from){
  var jobTrigger, jobTriggerRecord, parameters, to;
  to = new ListGridRecord_0;
  $setAttribute_3(to, 'id', from.id);
  $setAttribute_13(to, 'jobName', from.jobName);
  $setAttribute_13(to, 'jobGroup', from.jobGroup);
  $setAttribute_13(to, 'subject', from.subject.name_0);
  $setAttribute_3(to, 'subjectId', from.subject.id);
  parameters = from.parameters;
  !parameters?(to.jsObj['parameters'] = null , undefined):(to.jsObj['parameters'] = parameters , undefined);
  $setAttribute_13(to, 'operationName', from.operationName);
  $setAttribute_13(to, 'operationDisplayName', $getOperationDisplayName(from));
  $setAttribute_13(to, 'description', from.description);
  $setAttribute_14(to, 'nextFireTime', from.nextFireTime);
  $setAttribute_13(to, 'timeout', parameters?$getSimpleValue(parameters, 'rhq.timeout', null):null);
  jobTrigger = from.jobTrigger;
  jobTriggerRecord = new ListGridRecord_0;
  $setAttribute_14(jobTriggerRecord, 'startTime', jobTrigger.startDate);
  $setAttribute_12(jobTriggerRecord, 'repeatInterval', jobTrigger.repeatInterval);
  $setAttribute_11(jobTriggerRecord, 'repeatCount', jobTrigger.repeatCount);
  $setAttribute_14(jobTriggerRecord, 'endTime', jobTrigger.endDate);
  $setAttribute_13(jobTriggerRecord, 'cronExpression', jobTrigger.cronExpression);
  to.jsObj['jobTrigger'] = !jobTriggerRecord?null:jobTriggerRecord.jsObj;
  return to;
}

function $createJobTrigger(jobTriggerRecord){
  var cronExpression, endTime, jobTrigger, repeatCount, repeatInterval, startTime, dVal;
  cronExpression = getAttribute(jobTriggerRecord.jsObj, 'cronExpression');
  if (cronExpression != null) {
    jobTrigger = new JobTrigger_3(cronExpression);
  }
   else {
    startTime = getAttributeAsDate(jobTriggerRecord.jsObj, 'startTime');
    repeatInterval = (dVal = getAttributeAsDouble(jobTriggerRecord.jsObj, 'repeatInterval') , !dVal?null:valueOf_45(fromDouble(dVal.value_0)));
    repeatCount = getAttributeAsInt(jobTriggerRecord.jsObj, 'repeatCount');
    endTime = getAttributeAsDate(jobTriggerRecord.jsObj, 'endTime');
    startTime?repeatInterval?repeatCount?(jobTrigger = new JobTrigger_5(startTime, repeatInterval.value_0, repeatCount.value_0)):(jobTrigger = new JobTrigger_6(startTime, repeatInterval.value_0, endTime)):(jobTrigger = new JobTrigger_4(startTime)):repeatInterval?repeatCount?(jobTrigger = new JobTrigger_1(repeatInterval.value_0, repeatCount.value_0)):(jobTrigger = new JobTrigger_2(repeatInterval.value_0, endTime)):(jobTrigger = new JobTrigger_0);
  }
  return jobTrigger;
}

function AbstractOperationScheduleDataSource_0(resourceType){
  var fields;
  RPCDataSource_0.call(this);
  this.operationService = dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync);
  this.resourceType = resourceType;
  fields = $addDataSourceFields_3(this);
  $addFields(this, fields);
}

defineSeed(2948, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractOperationScheduleDataSource]));
_.copyValues = function copyValues_79(from){
  return this.copyValues_5(from);
}
;
_.copyValues_5 = function copyValues_80(from){
  return $copyValues_43(this, from);
}
;
_.copyValues_0 = function copyValues_81(from){
  return this.copyValues_6(dynamicCast(from, Q$OperationSchedule));
}
;
_.copyValues_6 = function copyValues_82(from){
  return $copyValues_44(from);
}
;
_.getFetchCriteria = function getFetchCriteria_56(request){
  return null;
}
;
_.resourceType = null;
function $compare_9(o1, o2){
  return compareTo_11(o1.displayName, o2.displayName);
}

function AbstractOperationScheduleDataSource$1_0(){
}

defineSeed(2949, 1, makeCastMap([Q$Comparator]), AbstractOperationScheduleDataSource$1_0);
_.compare = function compare_10(o1, o2){
  return $compare_9(dynamicCast(o1, Q$OperationDefinition), dynamicCast(o2, Q$OperationDefinition));
}
;
function $buildContentPane_0(this$static){
  var contentPane, hr, nextFireTimeItem, notesFields, notesItem, productInfo, supportedUnits, timeoutItem;
  contentPane = $buildContentPane(this$static);
  this$static.operationParametersConfigurationHolder = new EnhancedHLayout_0;
  $setAttribute_24(this$static.operationParametersConfigurationHolder, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  $addMember(contentPane, this$static.operationParametersConfigurationHolder);
  hr = new HTMLFlow_1('<hr/>');
  $addMember(contentPane, hr);
  this$static.triggerEditor = new JobTriggerEditor_0(this$static.isReadOnly);
  $addMember(contentPane, this$static.triggerEditor);
  hr = new HTMLFlow_1('<hr/>');
  $addMember(contentPane, hr);
  this$static.notesForm = new EnhancedDynamicForm_2(this$static.isReadOnly, this$static.recordId == 0);
  $setColWidths(this$static.notesForm, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [valueOf_44(140), '50%', '140', '50%']));
  $addItemChangedHandler(this$static.notesForm, new AbstractOperationScheduleDetailsView$2_0(this$static));
  notesFields = new ArrayList_0;
  supportedUnits = new TreeSet_0;
  $add_8(supportedUnits, ($clinit_TimeUnit() , SECONDS_0));
  $add_8(supportedUnits, MINUTES_1);
  $add_8(supportedUnits, HOURS_1);
  timeoutItem = new DurationItem_0('timeout', ($clinit_Enhanced() , 'Timeout'), supportedUnits, false, this$static.isReadOnly);
  productInfo = ($clinit_CoreGUI() , $clinit_CoreGUI() , coreGUI).productInfo;
  $setContextualHelp(timeoutItem, 'a time duration - if specified, if the duration elapses before a scheduled operation execution has completed, the ' + productInfo.shortName + ' Server will timeout the operation and consider it to have failed; note, it is usually not possible to abort the underlying managed resource operation if it was already initiated');
  setCheck(notesFields.array, notesFields.size_0++, timeoutItem);
  if (this$static.recordId != 0) {
    nextFireTimeItem = new StaticTextItem_2('nextFireTime', 'Next Execution');
    setCheck(notesFields.array, notesFields.size_0++, nextFireTimeItem);
  }
  notesItem = new TextAreaItem_2('description', 'Notes');
  $isCreated_2(notesItem)?$setProperty_6(notesItem, 'width', 450):(notesItem.jsObj['width'] = 450 , undefined);
  $isCreated_2(notesItem)?$setProperty_6(notesItem, 'height', 60):(notesItem.jsObj['height'] = 60 , undefined);
  $setShowTitle_0(notesItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  addContextualHelp(notesItem, 'an optional description of this scheduled operation (e.g. nightly maintenance app server restart)', null);
  setCheck(notesFields.array, notesFields.size_0++, notesItem);
  $setFields_3(this$static.notesForm, dynamicCast($toArray_1(notesFields, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, notesFields.size_0, 0)), Q$FormItem_$1));
  $addMember(contentPane, this$static.notesForm);
  return contentPane;
}

function $editExistingRecord_0(this$static, record){
  var integerValue, jobTrigger, jobTriggerJavaScriptObject, jobTriggerRecord, nextFireTimeItem, notesItem, notesValue, timeoutItem, value;
  jobTriggerJavaScriptObject = dynamicCastJso($getValue(this$static.form_0, 'jobTrigger'));
  jobTriggerRecord = new ListGridRecord_1(jobTriggerJavaScriptObject);
  jobTrigger = $createJobTrigger((dynamicCast(this$static.dataSource, Q$AbstractOperationScheduleDataSource) , jobTriggerRecord));
  $setJobTrigger_0(this$static.triggerEditor, jobTrigger);
  nextFireTimeItem = $getField_0(this$static.notesForm, 'nextFireTime');
  nextFireTimeItem.setValue_3($getValue(this$static.form_0, 'nextFireTime'));
  timeoutItem = dynamicCast($getField_0(this$static.notesForm, 'timeout'), Q$DurationItem);
  value = $getValue(this$static.form_0, 'timeout');
  integerValue = toInteger(value);
  $setValue_14(timeoutItem, integerValue, ($clinit_UnitType() , TIME_3));
  notesItem = dynamicCast($getField_0(this$static.notesForm, 'description'), Q$StaticTextItem);
  notesValue = $getValueAsString(this$static.form_0, 'description');
  null != notesValue && !!notesValue.length && $setEscapeHTML(notesItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setValue_7(notesItem, notesValue);
  this$static.operationParameters = dynamicCast(getAttributeAsObject(record.jsObj, 'parameters'), Q$Configuration);
  $editExistingRecord(this$static, record);
}

function $getSelectedOperationName(this$static){
  var operationNameItem;
  operationNameItem = $getField_0(this$static.form_0, 'operationName');
  return dynamicCast(operationNameItem.getValue_1(), Q$String);
}

function $handleOperationNameChange(this$static){
  $refreshOperationDescriptionItem(this$static);
  $refreshOperationParametersItem(this$static);
  null != $getSelectedOperationName(this$static) && $onItemChanged(this$static);
}

function $init_7(this$static, isReadOnly){
  var nameField, self_0;
  $init_1(this$static, isReadOnly);
  if (this$static.operationDefinitionId) {
    nameField = $getField_0(this$static.form_0, 'operationName');
    nameField.setValue_4(dynamicCast(this$static.operationIdToNameMap.get_2(this$static.operationDefinitionId), Q$String));
    $handleOperationNameChange(this$static);
    self_0 = this$static.form_0.getOrCreateJsObj();
    self_0.rememberValues();
  }
}

function $refreshOperationDescriptionItem(this$static){
  var operationName, value;
  operationName = $getSelectedOperationName(this$static);
  operationName == null?(value = '<i>' + ($clinit_Enhanced() , 'Select an operation to see its description.') + '<\/i>'):(value = dynamicCast(this$static.operationNameToDescriptionMap.get_2(operationName), Q$String));
  $setValue_7(this$static.operationDescriptionItem, value);
}

function $refreshOperationParametersItem(this$static){
  var child, child$array, child$index, child$max, configurationService, defaultTemplate, horizontalSpacer, operationName, parametersDefinition, value;
  operationName = $getSelectedOperationName(this$static);
  if (this$static.recordId == 0) {
    this$static.operationParameters = null;
    for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.operationParametersConfigurationHolder, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
      child = child$array[child$index];
      child.destroy_0();
    }
  }
  if (operationName == null) {
    value = '<i>' + ($clinit_Enhanced() , 'Select an operation to see its parameters.') + '<\/i>';
    $hide(this$static.operationParametersConfigurationHolder);
  }
   else {
    parametersDefinition = dynamicCast(this$static.operationNameToParametersDefinitionMap.get_2(operationName), Q$ConfigurationDefinition);
    if (!parametersDefinition || (!parametersDefinition.propertyDefinitions && (parametersDefinition.propertyDefinitions = new LinkedHashMap_0) , parametersDefinition.propertyDefinitions).isEmpty_0()) {
      value = '<i>' + ($clinit_Enhanced() , 'This operation does not take any parameters.') + '<\/i>';
      $hide(this$static.operationParametersConfigurationHolder);
    }
     else {
      value = this$static.recordId == 0?'<i>' + ($clinit_Enhanced() , 'Enter parameters below...') + '<\/i>':'';
      horizontalSpacer = new VLayout_0;
      $isCreated_1(horizontalSpacer)?$setProperty_0(horizontalSpacer, 'width', 140):(horizontalSpacer.config_0['width'] = 140 , undefined);
      $addMember(this$static.operationParametersConfigurationHolder, horizontalSpacer);
      if (this$static.recordId == 0) {
        defaultTemplate = dynamicCast((!parametersDefinition.templates && (parametersDefinition.templates = new LinkedHashMap_0) , parametersDefinition.templates).get_2('default'), Q$ConfigurationTemplate);
        this$static.operationParameters = defaultTemplate?$deepCopy(defaultTemplate.configuration, false):new Configuration_0;
      }
      configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
      $getOptionValuesForConfigDefinition(configurationService, this$static.getResourceId(), parametersDefinition, new AbstractOperationScheduleDetailsView$3_0(this$static, parametersDefinition));
    }
  }
  $setValue_7(this$static.operationParametersItem, value);
}

function $save_6(this$static, requestProperties){
  var cronExpression, endTime, form, jobTriggerRecord, message, notesItem, repeatCount, repeatInterval, startTime, timeout, timeoutItem, self_0, valueJS;
  if (!!this$static.operationParametersConfigurationEditor && $hasErrors(this$static.operationParametersConfigurationEditor.topLevelPropertiesValuesManager).value_0 || !$validate_5(this$static.triggerEditor)) {
    message = new Message_8('One or more fields have invalid values. This [' + ($clinit_Enhanced() , this$static.dataTypeName) + '] cannot be saved until these values are corrected', ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient)));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
    return;
  }
  $setAttribute_18(requestProperties, this$static.operationParameters);
  form = this$static.form_0;
  jobTriggerRecord = new ListGridRecord_0;
  startTime = $getStartTime_0(this$static.triggerEditor);
  this$static.isImmediateExecution = !startTime;
  setAttribute_9(jobTriggerRecord.jsObj, 'startTime', startTime);
  endTime = $getEndTime_0(this$static.triggerEditor);
  setAttribute_9(jobTriggerRecord.jsObj, 'endTime', endTime);
  repeatCount = $getRepeatCount(this$static.triggerEditor);
  setAttribute_8(jobTriggerRecord.jsObj, 'repeatCount', repeatCount);
  repeatInterval = $getRepeatInterval(this$static.triggerEditor);
  !repeatInterval?(jobTriggerRecord.jsObj['repeatInterval'] = null , undefined):repeatInterval?$setAttribute_4(jobTriggerRecord, 'repeatInterval', repeatInterval.value_0):(jobTriggerRecord.jsObj['repeatInterval'] = null , undefined);
  cronExpression = $getValueAsString(this$static.triggerEditor.cronForm, 'cronExpression');
  jobTriggerRecord.jsObj['cronExpression'] = cronExpression;
  self_0 = form.getOrCreateJsObj();
  valueJS = jobTriggerRecord.getJsObj();
  self_0.setValue('jobTrigger', valueJS);
  timeoutItem = dynamicCast($getField_0(this$static.notesForm, 'timeout'), Q$DurationItem);
  timeout = toLong($getValue_0(timeoutItem));
  timeout?$setValue(form, 'timeout', toDouble(timeout.value_0)):$setValue_0(form, 'timeout', null);
  notesItem = $getField_0(this$static.notesForm, 'description');
  $setValue_0(form, 'description', dynamicCast(notesItem.getValue_1(), Q$String));
  $save_0(this$static, requestProperties);
}

function AbstractOperationScheduleDetailsView_0(dataSource, resourceType, scheduleId){
  var operationDefinition, operationDefinition$iterator, operationDefinitions;
  AbstractRecordEditor_0.call(this, dataSource, scheduleId, ($clinit_Enhanced() , 'Operation Schedule'), null);
  this.operationIdToNameMap = new HashMap_0;
  this.operationNameToDescriptionMap = new HashMap_0;
  this.operationNameToParametersDefinitionMap = new HashMap_0;
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
  operationDefinitions = resourceType.operationDefinitions;
  for (operationDefinition$iterator = operationDefinitions.iterator(); operationDefinition$iterator.hasNext();) {
    operationDefinition = dynamicCast(operationDefinition$iterator.next_0(), Q$OperationDefinition);
    this.operationIdToNameMap.put(valueOf_44(operationDefinition.id), operationDefinition.name_0);
    this.operationNameToDescriptionMap.put(operationDefinition.name_0, operationDefinition.description);
    this.operationNameToParametersDefinitionMap.put(operationDefinition.name_0, operationDefinition.parametersConfigurationDefinition);
  }
}

defineSeed(2950, 1692, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$DetailsView, Q$Enhanced]));
_.buildButtonBar = function buildButtonBar_0(){
  var buttonBar;
  buttonBar = $buildButtonBar(this);
  !!buttonBar && $setTitle_0(buttonBar.saveButton, ($clinit_Enhanced() , 'Schedule'));
  return buttonBar;
}
;
_.buildContentPane = function buildContentPane_1(){
  return $buildContentPane_0(this);
}
;
_.buildForm = function buildForm_0(){
  var form;
  form = $buildForm(this);
  $isCreated_1(form)?$setProperty_0(form, 'numCols', 3):(form.config_0['numCols'] = 3 , undefined);
  $setColWidths(form, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [valueOf_44(140), '140', '*']));
  return form;
}
;
_.createFormItems = function createFormItems_1(form){
  var idItem, items, operationNameItem;
  items = new ArrayList_0;
  if (this.recordId != 0) {
    idItem = new StaticTextItem_1('id');
    setCheck(items.array, items.size_0++, idItem);
  }
  operationNameItem = new SortedSelectItem_1;
  $setShowTitle_0(operationNameItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  setCheck(items.array, items.size_0++, operationNameItem);
  $addChangedHandler(operationNameItem, new AbstractOperationScheduleDetailsView$1_0(this));
  this.operationDescriptionItem = new StaticTextItem_2('operationDescription', ($clinit_Enhanced() , 'Description'));
  $setShowTitle_0(this.operationDescriptionItem, FALSE);
  $add_3(items, this.operationDescriptionItem);
  this.operationParametersItem = new StaticTextItem_2('operationParameters', 'Parameters');
  $setColSpan(this.operationParametersItem, 2);
  $add_3(items, this.operationParametersItem);
  return items;
}
;
_.createNewRecord = function createNewRecord_2(){
  var record, sessionSubject;
  record = new ListGridRecord_0;
  sessionSubject = ($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0);
  $setAttribute_13(record, 'subject', sessionSubject.name_0);
  $setAttribute_3(record, 'subjectId', sessionSubject.id);
  return record;
}
;
_.editExistingRecord = function editExistingRecord_0(record){
  $editExistingRecord_0(this, record);
}
;
_.editRecord_0 = function editRecord_2(record){
  $refreshOperationDescriptionItem(this);
  $refreshOperationParametersItem(this);
}
;
_.getListViewPath = function getListViewPath_0(){
  var isAutogroup;
  if (this.isImmediateExecution) {
    isAutogroup = $getParentViewPath(this.viewPath).indexOf('Resource/AutoGroup') != -1;
    if (!isAutogroup && this.viewPath.index_0 == 6 || isAutogroup && this.viewPath.index_0 == 7) {
      return $getPathToIndex(this.viewPath, this.viewPath.index_0 - 3) + '/History';
    }
    return $getPathToIndex(this.viewPath, this.viewPath.index_0 - 2) + '/History';
  }
  return this.listViewPath;
}
;
_.getTitleFieldName = function getTitleFieldName_2(){
  return 'operationDisplayName';
}
;
_.init = function init_4(isReadOnly){
  $init_7(this, isReadOnly);
}
;
_.renderView = function renderView_22(viewPath){
  var isReadOnly;
  this.viewPath = viewPath;
  $renderView_1(this, viewPath);
  this.operationDefinitionId = valueOf_44(0);
  if (viewPath.viewPath.size_0 > viewPath.index_0) {
    this.operationDefinitionId = valueOf_44(__parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path));
    ++viewPath.index_0;
  }
  isReadOnly = !this.hasControlPermission_1() || this.recordId != 0;
  this.init(isReadOnly);
}
;
_.reset_1 = function reset_3(){
  $resetValues(this.form_0);
  $handleOperationNameChange(this);
}
;
_.save = function save_3(requestProperties){
  $save_6(this, requestProperties);
}
;
_.isImmediateExecution = false;
_.notesForm = null;
_.operationDefinitionId = null;
_.operationDescriptionItem = null;
_.operationParameters = null;
_.operationParametersConfigurationEditor = null;
_.operationParametersConfigurationHolder = null;
_.operationParametersItem = null;
_.triggerEditor = null;
_.viewPath = null;
function AbstractOperationScheduleDetailsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2951, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), AbstractOperationScheduleDetailsView$1_0);
_.onChanged = function onChanged_55(event_0){
  $handleOperationNameChange(this.this$0);
}
;
_.this$0 = null;
function AbstractOperationScheduleDetailsView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2952, 1, makeCastMap([Q$EventHandler, Q$ItemChangedHandler]), AbstractOperationScheduleDetailsView$2_0);
_.onItemChanged = function onItemChanged_3(event_0){
  $onItemChanged(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_253(this$static, result){
  this$static.this$0.operationParametersConfigurationEditor = new ConfigurationEditor_1(result, this$static.this$0.operationParameters);
  $setReadOnly_1(this$static.this$0.operationParametersConfigurationEditor, this$static.this$0.isReadOnly);
  $addMember(this$static.this$0.operationParametersConfigurationHolder, this$static.this$0.operationParametersConfigurationEditor);
  $show(this$static.this$0.operationParametersConfigurationHolder);
}

function AbstractOperationScheduleDetailsView$3_0(this$0, val$parametersDefinition){
  this.this$0 = this$0;
  this.val$parametersDefinition = val$parametersDefinition;
}

defineSeed(2953, 1, {}, AbstractOperationScheduleDetailsView$3_0);
_.onFailure = function onFailure_264(throwable){
  this.this$0.operationParametersConfigurationEditor = new ConfigurationEditor_1(this.val$parametersDefinition, this.this$0.operationParameters);
  $setReadOnly_1(this.this$0.operationParametersConfigurationEditor, this.this$0.isReadOnly);
  $addMember(this.this$0.operationParametersConfigurationHolder, this.this$0.operationParametersConfigurationEditor);
  $show(this.this$0.operationParametersConfigurationHolder);
}
;
_.onSuccess_0 = function onSuccess_264(result){
  $onSuccess_253(this, dynamicCast(result, Q$ConfigurationDefinition));
}
;
_.this$0 = null;
_.val$parametersDefinition = null;
function AbstractOperationScheduleListView_0(dataSource){
  TableSection_0.call(this, null);
  this.dataSource_1 = dataSource;
}

defineSeed(2954, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]));
_.configureTable = function configureTable_41(){
  var descriptionField, idField, nextFireTimeField, operationField, subjectField;
  idField = new ListGridField_2('id', 70);
  operationField = new ListGridField_2('operationDisplayName', 180);
  subjectField = new ListGridField_2('subject', 110);
  nextFireTimeField = new ListGridField_2('nextFireTime', 190);
  $clinit_TimestampCellFormatter();
  prepareDateField(nextFireTimeField, getAttribute(nextFireTimeField.jsObj, 'name'));
  descriptionField = new ListGridField_1('description');
  $setCellFormatter_0(descriptionField, new EscapedHtmlCellFormatter_0);
  $setListGridFields(this, true, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, operationField, subjectField, nextFireTimeField, descriptionField]));
  $addTableAction(this, ($clinit_Enhanced() , 'New'), null, null, new AbstractOperationScheduleListView$1_0(this));
  $addTableAction(this, 'Delete', 'Are you sure you want to delete the # selected items?', null, new AbstractOperationScheduleListView$2_0(this));
  $configureTable(this);
}
;
_.getDetailsLinkColumnName = function getDetailsLinkColumnName_5(){
  return 'operationDisplayName';
}
;
function AbstractOperationScheduleListView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2955, 1, {}, AbstractOperationScheduleListView$1_0);
_.executeAction = function executeAction_50(selection, actionValue){
  $newDetails(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_27(selection){
  return this.this$0.hasControlPermission_1();
}
;
_.this$0 = null;
function AbstractOperationScheduleListView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2956, 1, {}, AbstractOperationScheduleListView$2_0);
_.executeAction = function executeAction_51(selection, actionValue){
  $deleteSelectedRecords(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_28(selection){
  var count;
  count = selection.length;
  return count >= 1 && this.this$0.hasControlPermission_1();
}
;
_.this$0 = null;
function $clinit_AbstractActivityView(){
  $clinit_AbstractActivityView = nullMethod;
  $clinit_BaseWidget();
  $clinit_Enhanced();
  RECENT_MEASUREMENTS_NONE = 'This resource has no recent metrics';
  RECENT_MEASUREMENTS_GROUP_NONE = 'This group has no recent metrics';
  RECENT_OOB_NONE = 'No OOB conditions found';
  SEE_MORE = 'see more...';
  RECENT_CRITERIA_EVENTS_NONE = 'No event counts based off display criteria.';
  CHART_TITLE = 'Metric Chart';
}

function addSeeMoreLink(form, linkDestination, column){
  $clinit_AbstractActivityView();
  var link;
  if (!!form && !!column) {
    $isCreated_1(form)?$setProperty_0(form, 'numCols', 1):(form.config_0['numCols'] = 1 , undefined);
    link = newLinkItem(SEE_MORE, linkDestination);
    form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [link]));
    column.addMember_0(form);
  }
}

function convertLastValueForDisplay(lastValue, md){
  $clinit_AbstractActivityView();
  var convertedValue, convertedValues;
  convertedValues = formatSimpleMetrics_0(initValues(_3D_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [lastValue]), md);
  convertedValue = convertedValues[0];
  return convertedValue;
}

function createEmptyDisplayRow(emptyMessage){
  $clinit_AbstractActivityView();
  var none, row;
  row = new DynamicForm_0;
  $isCreated_1(row)?$setProperty_0(row, 'numCols', 3):(row.config_0['numCols'] = 3 , undefined);
  none = new StaticTextItem_0;
  $setShowTitle_0(none, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $isCreated_2(none)?$setProperty_8(none, 'defaultValue', emptyMessage):(none.jsObj['defaultValue'] = emptyMessage , undefined);
  $setWrap_1(none, FALSE);
  row.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [none]));
  return row;
}

function newLinkItem(title, destination){
  $clinit_AbstractActivityView();
  var link;
  link = new LinkItem_0;
  $isCreated_2(link)?$setProperty_8(link, 'linkTitle', title):(link.jsObj['linkTitle'] = title , undefined);
  $isCreated_2(link)?$setProperty_8(link, 'title', title):(link.jsObj['title'] = title , undefined);
  $setValue_7(link, destination);
  $isCreated_2(link)?$setProperty_8(link, 'target', '_self'):(link.jsObj['target'] = '_self' , undefined);
  $setShowTitle_0(link, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  return link;
}

function newTextItem(contents){
  $clinit_AbstractActivityView();
  var item;
  item = new StaticTextItem_0;
  $isCreated_2(item)?$setProperty_8(item, 'defaultValue', contents):(item.jsObj['defaultValue'] = contents , undefined);
  $setShowTitle_0(item, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowPickerIcon(item, FALSE);
  $setWrap_1(item, FALSE);
  return item;
}

function newTextItemIcon(imageSrc, mouseOver){
  $clinit_AbstractActivityView();
  var iconItem, img;
  iconItem = new StaticTextItem_0;
  img = new FormItemIcon_0;
  img.jsObj['src'] = imageSrc;
  $setWidth_4(img, valueOf_44(16));
  $setHeight_2(img, valueOf_44(16));
  mouseOver != null && (img.jsObj['prompt'] = mouseOver , undefined);
  $isCreated_2(iconItem)?$setProperty_7(iconItem, 'icons', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [img]))):(iconItem.jsObj['icons'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [img])) , undefined);
  $setShowTitle_0(iconItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  return iconItem;
}

function saveConfigUpdateStatusSelectorSettings(configStatusSelector, portletConfig){
  $clinit_AbstractActivityView();
  var selectedValue;
  selectedValue = null == $getValue_0(configStatusSelector)?'':toString__devirtual$($getValue_0(configStatusSelector));
  !$trim(selectedValue).length || $split(selectedValue, ',', 0).length == ($clinit_ConfigurationUpdateStatus() , $clinit_ConfigurationUpdateStatus() , $VALUES_64).length?$put_4(portletConfig, new PropertySimple_1('CONFIG_UPDATE_STATUS', '')):$put_4(portletConfig, new PropertySimple_1('CONFIG_UPDATE_STATUS', selectedValue));
  return portletConfig;
}

function saveMeasurementRangeEditorSettings(measurementRangeEditor, portletConfig){
  $clinit_AbstractActivityView();
  var begEnd, isAdvanceTimeSetting, item, itemC, persistTimeRangeSettings, rangeArray, selectedValue;
  if (!!measurementRangeEditor && !!portletConfig) {
    item = $getField_0(measurementRangeEditor, ($clinit_AbstractMeasurementRangeEditor() , 'ENABLE_RANGE_ITEM'));
    itemC = dynamicCast(item, Q$CheckboxItem);
    persistTimeRangeSettings = $getValueAsBoolean(itemC).value_0;
    if (persistTimeRangeSettings) {
      selectedValue = '' + $getValueAsBoolean(itemC);
      !$trim(selectedValue).length || $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_ENABLE', selectedValue));
      isAdvanceTimeSetting = false;
      selectedValue = '' + measurementRangeEditor.advanced;
      if (selectedValue != null && !!$trim(selectedValue).length) {
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_BEGIN_END_FLAG', selectedValue));
        isAdvanceTimeSetting = ($clinit_Boolean() , $equalsIgnoreCase('true', selectedValue)?TRUE:FALSE).value_0;
      }
      begEnd = $getBeginEndTimes_0(measurementRangeEditor);
      if (isAdvanceTimeSetting) {
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE', (checkIndex(0, begEnd.size_0) , begEnd.array[0]) + ',' + (checkIndex(1, begEnd.size_0) , begEnd.array[1])));
      }
       else {
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_LASTN', valueOf_44(measurementRangeEditor.measurementPrefs.metricRangePreferences.lastN)));
        $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_UNIT', valueOf_44(measurementRangeEditor.measurementPrefs.metricRangePreferences.unit)));
      }
    }
     else {
      $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_ENABLE', ($clinit_Boolean() , $clinit_Boolean() , FALSE)));
      $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE_BEGIN_END_FLAG', FALSE));
      rangeArray = calculateTimeFrame(valueOf_44(__parseAndValidateInt(($clinit_PortletConfigurationEditorComponent$Constant() , '8'))).value_0, valueOf_44(__parseAndValidateInt('3')).value_0);
      $put_4(portletConfig, new PropertySimple_1('METRIC_RANGE', '' + (checkIndex(0, rangeArray.size_0) , rangeArray.array[0]) + ',' + (checkIndex(1, rangeArray.size_0) , rangeArray.array[1])));
    }
  }
  return portletConfig;
}

function saveOperationStatusSelectorSettings(operationStatusSelector, portletConfig){
  $clinit_AbstractActivityView();
  var selectedValue;
  selectedValue = null == $getValue_0(operationStatusSelector)?'':toString__devirtual$($getValue_0(operationStatusSelector));
  !$trim(selectedValue).length || $split(selectedValue, ',', 0).length == ($clinit_OperationRequestStatus() , $clinit_OperationRequestStatus() , $VALUES_96).length?$put_4(portletConfig, new PropertySimple_1('OPERATION_STATUS', '')):$put_4(portletConfig, new PropertySimple_1('OPERATION_STATUS', selectedValue));
  return portletConfig;
}

function saveResultCounterSettings(resultCountSelector, portletConfig){
  $clinit_AbstractActivityView();
  var selectedValue;
  if (!!resultCountSelector && !!portletConfig) {
    selectedValue = null == $getValue_0(resultCountSelector)?'':toString__devirtual$($getValue_0(resultCountSelector));
    !$trim(selectedValue).length?$put_4(portletConfig, new PropertySimple_1('RESULT_COUNT', '5')):$put_4(portletConfig, new PropertySimple_1('RESULT_COUNT', selectedValue));
  }
  return portletConfig;
}

var CHART_TITLE, RECENT_CRITERIA_EVENTS_NONE, RECENT_MEASUREMENTS_GROUP_NONE, RECENT_MEASUREMENTS_NONE, RECENT_OOB_NONE, SEE_MORE;
function AbstractActivityView$ChartViewWindow_0(title){
  $clinit_BaseWidget();
  AbstractActivityView$ChartViewWindow_1.call(this, title, null);
}

function AbstractActivityView$ChartViewWindow_1(title, windowTitle){
  $clinit_BaseWidget();
  Window_1.call(this);
  windowTitle != null && !!$trim(windowTitle).length?$isCreated_1(this)?$setProperty_3(this, 'title', windowTitle + ': ' + title):(this.config_0['title'] = windowTitle + ': ' + title , undefined):$setTitle(this, ($clinit_AbstractActivityView() , CHART_TITLE) + ': ' + title);
  $setShowMinimizeButton(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowMaximizeButton(this, FALSE);
  $setShowCloseButton(this, TRUE);
  $setIsModal(this, TRUE);
  $setShowModalMask(this, TRUE);
  $isCreated_1(this)?$setProperty_0(this, 'width', 950):(this.config_0['width'] = 950 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'height', 350):(this.config_0['height'] = 350 , undefined);
  $setShowResizer(this, TRUE);
  $setCanDragResize_0(this, TRUE);
  $centerInPage(this);
  $addCloseClickHandler(this, new AbstractActivityView$ChartViewWindow$1_0(this));
}

defineSeed(2958, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), AbstractActivityView$ChartViewWindow_0, AbstractActivityView$ChartViewWindow_1);
function AbstractActivityView$ChartViewWindow$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2959, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), AbstractActivityView$ChartViewWindow$1_0);
_.onCloseClick_0 = function onCloseClick_11(event_0){
  var $e0, e;
  try {
    $destroy(this.this$1);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Throwable)) {
      e = $e0;
      $clinit_Log();
      $log_1(logger_0, ($clinit_Level() , WARNING), 'Cannot destroy chart display window.', e);
    }
     else 
      throw $e0;
  }
}
;
_.this$1 = null;
function $copyValues_45(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.eventId);
  $setAttribute_14(record, 'timestamp', new Date_2(from.timestamp));
  $setAttribute_13(record, 'detail', from.eventDetail);
  $setAttribute_13(record, 'severity', from.severity.name_0);
  $setAttribute_13(record, 'source', from.sourceLocation);
  $setAttribute_3(record, 'resourceId', from.resourceId);
  $setAttribute_13(record, 'resourceName', from.resourceName);
  $setAttribute_13(record, 'resourceAncestry', from.resourceAncestry);
  $setAttribute_3(record, 'resourceTypeId', from.resourceTypeId);
  return record;
}

function $dataRetrieved_4(this$static, result, response, request){
  var ancestries, composite, composite$iterator, records, typeRepo, typesSet;
  switch (this$static.entityContext.type_0.ordinal) {
    case 0:
      records = $buildRecords(this$static, result, true);
      $highlightFilterMatches(this$static, request, records);
      $setAttribute_17(response, 'data', records);
      $setTotalRows(response, valueOf_44(max_0(result.size_0, result.totalSize)));
      $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
      break;
    default:typesSet = new HashSet_0;
      ancestries = new HashSet_0;
      for (composite$iterator = new AbstractList$IteratorImpl_0(result); composite$iterator.i < composite$iterator.this$0_0.size_1();) {
        composite = dynamicCast($next_0(composite$iterator), Q$EventComposite);
        $add_6(typesSet, valueOf_44(composite.resourceTypeId));
        $add_6(ancestries, composite.resourceAncestry);
      }

      typesSet.addAll(getAncestryTypeIds(ancestries));
      typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
      $getResourceTypes_0(typeRepo, dynamicCast(typesSet.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new EventCompositeDatasource$9_0(this$static, result, request, response));
  }
}

function $executeFetch_31(this$static, request, response, criteria){
  if (!criteria) {
    $setTotalRows(response, valueOf_44(0));
    $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
    return;
  }
  $findEventCompositesByCriteria(dynamicCast(secure(getInstance_41(), -1), Q$EventGWTServiceAsync), criteria, new EventCompositeDatasource$8_0(this$static, response, request));
}

function $getFetchCriteria_10(this$static, request){
  var criteria, criteriaMap, pageControl, severities, tmp;
  severities = dynamicCast(getArrayFilter($getCriteria(request), 'severities', Lorg_rhq_core_domain_event_EventSeverity_2_classLit), Q$EventSeverity_$1);
  if (severities == null || severities.length == 0) {
    return null;
  }
  criteria = new EventCriteria_0;
  pageControl = $getPageControl(this$static, request);
  pageControl.orderingFields.size_0 == 0 && $initDefaultOrderingField(pageControl, 'timestamp', ($clinit_PageOrdering() , DESC));
  criteriaMap = convertToMap($getCriteria(request).jsObj);
  $addFilterSourceName(criteria, dynamicCast(criteriaMap.get_2('source'), Q$String));
  $addFilterDetail(criteria, dynamicCast(criteriaMap.get_2('detail'), Q$String));
  if (criteriaMap.get_2('startTime') != null) {
    tmp = dynamicCast(criteriaMap.get_2('startTime'), Q$Date);
    $addFilterStartTime_1(criteria, valueOf_45(tmp.getTime_0()));
  }
  if (criteriaMap.get_2('endTime') != null) {
    tmp = dynamicCast(criteriaMap.get_2('endTime'), Q$Date);
    $addFilterEndTime_2(criteria, valueOf_45(tmp.getTime_0()));
  }
  severities.length != ($clinit_EventSeverity() , $clinit_EventSeverity() , $VALUES_86).length && severities != null && severities.length > 0 && (criteria.filterSeverities = new Arrays$ArrayList_0(severities));
  $addFilterEntityContext_0(criteria, this$static.entityContext);
  return criteria;
}

function $getListGridFields_16(this$static){
  var ancestryField, detailField, fields, resourceNameField, severityField, sourceField, timestampField;
  fields = new ArrayList_1(6);
  timestampField = new ListGridField_3('timestamp', 'Timestamp');
  $clinit_TimestampCellFormatter();
  prepareDateField(timestampField, getAttribute(timestampField.jsObj, 'name'));
  setCheck(fields.array, fields.size_0++, timestampField);
  severityField = new ListGridField_3('severity', 'Severity');
  $setAttribute_13(severityField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setCellFormatter_0(severityField, new EventCompositeDatasource$1_0);
  $setAttribute_8(severityField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(severityField, new EventCompositeDatasource$2_0);
  setCheck(fields.array, fields.size_0++, severityField);
  detailField = new ListGridField_3('detail', 'Details');
  $setCellFormatter_0(detailField, new EventCompositeDatasource$3_0);
  setCheck(fields.array, fields.size_0++, detailField);
  sourceField = new ListGridField_3('source', 'Source Location');
  $setCellFormatter_0(sourceField, new EventCompositeDatasource$4_0);
  $setAttribute_8(sourceField, 'showHover', TRUE);
  $setHoverCustomizer_0(sourceField, new EventCompositeDatasource$5_0);
  setCheck(fields.array, fields.size_0++, sourceField);
  if (this$static.entityContext.type_0 != ($clinit_EntityContext$Type() , Resource)) {
    resourceNameField = new ListGridField_3('resourceName', 'Resource');
    $setCellFormatter_0(resourceNameField, new EventCompositeDatasource$6_0);
    $setAttribute_8(resourceNameField, 'showHover', TRUE);
    $setHoverCustomizer_0(resourceNameField, new EventCompositeDatasource$7_0);
    setCheck(fields.array, fields.size_0++, resourceNameField);
    ancestryField = setupAncestryListGridField();
    setCheck(fields.array, fields.size_0++, ancestryField);
    timestampField.jsObj['width'] = 155;
    severityField.jsObj['width'] = 55;
    detailField.jsObj['width'] = '*';
    sourceField.jsObj['width'] = 180;
    resourceNameField.jsObj['width'] = '20%';
    ancestryField.jsObj['width'] = '25%';
  }
   else {
    timestampField.jsObj['width'] = 155;
    severityField.jsObj['width'] = 55;
    detailField.jsObj['width'] = '*';
    sourceField.jsObj['width'] = 220;
  }
  return fields;
}

function EventCompositeDatasource_0(context){
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.entityContext = context;
  fields = new ArrayList_0;
  $addFields(this, fields);
}

defineSeed(2960, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$EventCompositeDatasource]), EventCompositeDatasource_0);
_.copyValues = function copyValues_83(from){
  return null;
}
;
_.copyValues_0 = function copyValues_84(from){
  return $copyValues_45(dynamicCast(from, Q$EventComposite));
}
;
_.executeFetch = function executeFetch_45(request, response, criteria){
  $executeFetch_31(this, request, response, dynamicCast(criteria, Q$EventCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_57(request){
  return $getFetchCriteria_10(this, request);
}
;
_.entityContext = null;
function EventCompositeDatasource$1_0(){
}

defineSeed(2961, 1, {}, EventCompositeDatasource$1_0);
_.format_1 = function format_50(o, listGridRecord, i, i1){
  var icon;
  icon = 'subsystems/event/' + valueOf_95(toString__devirtual$(o)).name_0 + '_16.png';
  return imgHTML(icon);
}
;
function EventCompositeDatasource$2_0(){
}

defineSeed(2962, 1, {}, EventCompositeDatasource$2_0);
_.hoverHTML_0 = function hoverHTML_24(value, record, rowNum, colNum){
  var sevEnumName, severity;
  sevEnumName = getAttribute(record.jsObj, 'severity');
  if (sevEnumName == null) {
    return null;
  }
  severity = ($clinit_EventSeverity() , dynamicCast(valueOf(($clinit_EventSeverity$Map() , $MAP_86), sevEnumName), Q$EventSeverity));
  switch (severity.ordinal) {
    case 0:
      return $clinit_RPCDataSource() , 'Debug';
    case 1:
      return $clinit_RPCDataSource() , 'Info';
    case 2:
      return $clinit_RPCDataSource() , 'Warn';
    case 3:
      return $clinit_RPCDataSource() , 'Error';
    case 4:
      return $clinit_RPCDataSource() , 'Fatal';
    default:return null;
  }
}
;
function EventCompositeDatasource$3_0(){
}

defineSeed(2963, 1, {}, EventCompositeDatasource$3_0);
_.format_1 = function format_51(value, record, rowNum, colNum){
  return null == value?'':dynamicCast(value, Q$String).length <= 200?dynamicCast(value, Q$String):dynamicCast(value, Q$String).substr(0, 200 - 0);
}
;
function EventCompositeDatasource$4_0(){
}

defineSeed(2964, 1, {}, EventCompositeDatasource$4_0);
_.format_1 = function format_52(o, listGridRecord, i, i1){
  var length_0, sourceLocation;
  sourceLocation = getAttribute(listGridRecord.jsObj, 'source');
  length_0 = sourceLocation.length;
  if (length_0 > 40) {
    return '...' + $substring(sourceLocation, length_0 - 40);
  }
  return sourceLocation;
}
;
function EventCompositeDatasource$5_0(){
}

defineSeed(2965, 1, {}, EventCompositeDatasource$5_0);
_.hoverHTML_0 = function hoverHTML_25(value, record, rowNum, colNum){
  var sourceLocation;
  if (value == null) {
    return null;
  }
  sourceLocation = dynamicCast(value, Q$String);
  return sourceLocation.length > 40?sourceLocation:null;
}
;
function EventCompositeDatasource$6_0(){
}

defineSeed(2966, 1, {}, EventCompositeDatasource$6_0);
_.format_1 = function format_53(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function EventCompositeDatasource$7_0(){
}

defineSeed(2967, 1, {}, EventCompositeDatasource$7_0);
_.hoverHTML_0 = function hoverHTML_26(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function $onSuccess_254(this$static, result){
  $dataRetrieved_4(this$static.this$0, result, this$static.val$response, this$static.val$request);
}

function EventCompositeDatasource$8_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2968, 1, {}, EventCompositeDatasource$8_0);
_.onFailure = function onFailure_265(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'An error occurred loading the event details'), caught);
  this.val$response.jsObj['status'] = -1;
}
;
_.onSuccess_0 = function onSuccess_265(result){
  $onSuccess_254(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function EventCompositeDatasource$9_0(this$0, val$result, val$request, val$response){
  this.this$0 = this$0;
  this.val$result = val$result;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(2969, 1, {}, EventCompositeDatasource$9_0);
_.onTypesLoaded_0 = function onTypesLoaded_17(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$0, this.val$result, true);
  $highlightFilterMatches(this.this$0, this.val$request, records);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44($getTotalSize(this.val$result)));
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $clinit_EventCompositeDetailsView(){
  $clinit_EventCompositeDetailsView = nullMethod;
  $clinit_BaseWidget();
  INSTANCE_36 = new EventCompositeDetailsView_0;
}

function $show_5(this$static, eventId){
  var criteria;
  criteria = new EventCriteria_0;
  $addFilterId(criteria, valueOf_44(eventId));
  $findEventCompositesByCriteria(dynamicCast(secure(getInstance_41(), -1), Q$EventGWTServiceAsync), criteria, new EventCompositeDetailsView$1_0(this$static));
}

function $show_6(this$static, composite){
  var child, child$array, child$index, child$max, detail, form, id, severity, severityValue, source, timestamp;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    $removeChild_0(this$static, child);
  }
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $isCreated_1(form)?$setProperty_3(form, 'height', '100%'):(form.config_0['height'] = '100%' , undefined);
  $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  id = new StaticTextItem_2('id', ($clinit_Enhanced() , 'ID'));
  $setValue_5(id, composite.eventId);
  severity = new StaticTextItem_2('severity', 'Severity');
  severityValue = imgHTML('subsystems/event/' + composite.severity.name_0 + '_16.png');
  switch (composite.severity.ordinal) {
    case 0:
      severityValue += 'Debug';
      break;
    case 1:
      severityValue += 'Info';
      break;
    case 2:
      severityValue += 'Warn';
      break;
    case 3:
      severityValue += 'Error';
      break;
    case 4:
      severityValue += 'Fatal';
  }
  $setValue_7(severity, severityValue);
  source = new StaticTextItem_2('source', 'Source Location');
  $setValue_7(source, composite.sourceLocation);
  timestamp = new StaticTextItem_2('timestamp', 'Timestamp');
  $setValue_7(timestamp, format_30(new Date_2(composite.timestamp), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_FULL)));
  detail = new TextAreaItem_2('details', 'Details');
  $setValue_7(detail, composite.eventDetail);
  $setAttribute_30(detail, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0);
  $isCreated_2(detail)?$setProperty_6(detail, 'colSpan', 2):(detail.jsObj['colSpan'] = 2 , undefined);
  $setWidth_2(detail, '100%');
  $setHeight_1(detail, '100%');
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [id, severity, source, timestamp, detail]));
  $addMember(this$static, form);
}

function EventCompositeDetailsView_0(){
  EnhancedVLayout_0.call(this);
}

defineSeed(2970, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), EventCompositeDetailsView_0);
_.renderView = function renderView_23(viewPath){
  this.eventId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  $show_5(this, this.eventId);
}
;
_.eventId = 0;
var INSTANCE_36;
function $onSuccess_255(this$static, result){
  var composite;
  composite = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$EventComposite);
  $show_6(this$static.this$0, composite);
}

function EventCompositeDetailsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2971, 1, {}, EventCompositeDetailsView$1_0);
_.onFailure = function onFailure_266(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'An error occurred loading the event details'), caught);
}
;
_.onSuccess_0 = function onSuccess_266(result){
  $onSuccess_255(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $clinit_EventCompositeHistoryView(){
  $clinit_EventCompositeHistoryView = nullMethod;
  var i, s, s$index, s$max, severityNames, severityValues;
  $clinit_BaseWidget();
  DEFAULT_SORT_SPECIFIER_6 = new SortSpecifier_0('timestamp', ($clinit_SortDirection() , DESCENDING));
  INITIAL_CRITERIA_4 = new Criteria_0;
  severityValues = ($clinit_EventSeverity() , $clinit_EventSeverity() , $VALUES_86);
  severityNames = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, severityValues.length, 0);
  i = 0;
  for (s$index = 0 , s$max = severityValues.length; s$index < s$max; ++s$index) {
    s = severityValues[s$index];
    severityNames[i++] = s.name_0;
  }
  $addCriteria_6(INITIAL_CRITERIA_4, 'severities', severityNames);
}

function $deleteButtonPressed(this$static, selection){
  var eventIds, nextRecord, nextRecord$index, nextRecord$max;
  eventIds = new ArrayList_0;
  for (nextRecord$index = 0 , nextRecord$max = selection.length; nextRecord$index < nextRecord$max; ++nextRecord$index) {
    nextRecord = selection[nextRecord$index];
    $add_3(eventIds, getAttributeAsInt(nextRecord.jsObj, 'id'));
  }
  $deleteEventsForContext(dynamicCast(secure(getInstance_41(), -1), Q$EventGWTServiceAsync), this$static.context, eventIds, new EventCompositeHistoryView$4_0(this$static));
}

function $purgeButtonPressed(this$static){
  $purgeEventsForContext(dynamicCast(secure(getInstance_41(), -1), Q$EventGWTServiceAsync), this$static.context, new EventCompositeHistoryView$5_0(this$static));
}

function EventCompositeHistoryView_0(tableTitle, context, hasWriteAccess){
  TableSection_2.call(this, tableTitle, INITIAL_CRITERIA_4, initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [DEFAULT_SORT_SPECIFIER_6]));
  this.context = context;
  this.hasWriteAccess = hasWriteAccess;
  this.initialCriteriaFixed = false;
  $setDataSource(this, new EventCompositeDatasource_0(this.context));
}

function get_22(composite){
  $clinit_EventCompositeHistoryView();
  var context, hasWriteAccess;
  $clinit_Enhanced();
  context = new EntityContext_0(valueOf_44(composite.resource.id), null, null);
  hasWriteAccess = composite.resourcePermission.permissions.contains_0(($clinit_Permission() , MANAGE_EVENTS));
  return new EventCompositeHistoryView_0('Resource Event History', context, hasWriteAccess);
}

function get_23(composite){
  $clinit_EventCompositeHistoryView();
  var context, hasWriteAccess;
  $clinit_Enhanced();
  context = new EntityContext_0(null, valueOf_44(composite.resourceGroup.id), null);
  hasWriteAccess = composite.resourcePermission.permissions.contains_0(($clinit_Permission() , MANAGE_EVENTS));
  return new EventCompositeHistoryView_0('Group Event History', context, hasWriteAccess);
}

defineSeed(2972, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), EventCompositeHistoryView_0);
_.configureTable = function configureTable_42(){
  var dataSourceFields, singleTargetEnablement, multipleTargetEnablement;
  dataSourceFields = $getListGridFields_16(dynamicCast(this.dataSource_1, Q$EventCompositeDatasource));
  $setFields_1(this.listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
  singleTargetEnablement = this.hasWriteAccess?($clinit_TableActionEnablement() , ANY_1):($clinit_TableActionEnablement() , NEVER_1);
  $addTableAction(this, ($clinit_Enhanced() , 'Delete'), 'Are You Sure?', null, new EventCompositeHistoryView$2_0(this, singleTargetEnablement));
  multipleTargetEnablement = this.hasWriteAccess?($clinit_TableActionEnablement() , ALWAYS):($clinit_TableActionEnablement() , NEVER_1);
  $addTableAction(this, 'Purge All', 'Are You Sure?', null, new EventCompositeHistoryView$3_0(this, multipleTargetEnablement));
  $configureTable(this);
}
;
_.configureTableFilters = function configureTableFilters_7(){
  var detailsFilter, severities, severityFilter, severityIcons, sourceFilter, spacerItem;
  sourceFilter = new TextItem_3('source', ($clinit_Enhanced() , 'Source Filter'));
  detailsFilter = new TextItem_3('detail', 'Details Filter');
  severities = new LinkedHashMap_1(5);
  $put_1(severities, ($clinit_EventSeverity() , DEBUG).name_0, 'Debug');
  $put_1(severities, INFO_1.name_0, 'Info');
  $put_1(severities, WARN_0.name_0, 'Warn');
  $put_1(severities, ERROR.name_0, 'Error');
  $put_1(severities, FATAL.name_0, 'Fatal');
  severityIcons = new LinkedHashMap_1(5);
  $put_1(severityIcons, DEBUG.name_0, 'subsystems/event/' + DEBUG.name_0 + '_16.png');
  $put_1(severityIcons, INFO_1.name_0, 'subsystems/event/' + INFO_1.name_0 + '_16.png');
  $put_1(severityIcons, WARN_0.name_0, 'subsystems/event/' + WARN_0.name_0 + '_16.png');
  $put_1(severityIcons, ERROR.name_0, 'subsystems/event/' + ERROR.name_0 + '_16.png');
  $put_1(severityIcons, FATAL.name_0, 'subsystems/event/' + FATAL.name_0 + '_16.png');
  severityFilter = new EnumSelectItem_0('severities', 'Severity Filter', Lorg_rhq_core_domain_event_EventSeverity_2_classLit, severities, severityIcons);
  this.startDateFilter = new DateTimeFilterItem_0('startTime', 'From');
  this.endDateFilter = new DateTimeFilterItem_0('endTime', 'To');
  spacerItem = new SpacerItem_0;
  spacerItem.setColSpan(2);
  $setFilterFormItems(this, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [sourceFilter, detailsFilter, severityFilter, this.startDateFilter, spacerItem, this.endDateFilter]));
}
;
_.getDetailsLinkColumnCellFormatter = function getDetailsLinkColumnCellFormatter_4(){
  return new EventCompositeHistoryView$1_0(this);
}
;
_.getDetailsLinkColumnName = function getDetailsLinkColumnName_6(){
  return 'timestamp';
}
;
_.getDetailsView_0 = function getDetailsView_21(eventId){
  return $clinit_EventCompositeDetailsView() , $clinit_EventCompositeDetailsView() , INSTANCE_36;
}
;
_.onInit = function onInit_58(){
  this.flexRowDisplay = false;
  $onInit_2(this);
}
;
_.context = null;
_.endDateFilter = null;
_.hasWriteAccess = false;
_.startDateFilter = null;
var DEFAULT_SORT_SPECIFIER_6, INITIAL_CRITERIA_4;
function EventCompositeHistoryView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2973, 1, {}, EventCompositeHistoryView$1_0);
_.format_1 = function format_54(value, record, rowNum, colNum){
  var detailsUrl, recordId;
  recordId = $getId(this.this$0, record);
  detailsUrl = '#' + this.this$0.basePath + '/' + recordId;
  return '<a href="' + detailsUrl + '">' + ($clinit_TimestampCellFormatter() , format_30(value, DATE_TIME_FORMAT_MEDIUM)) + '<\/a>';
}
;
_.this$0 = null;
function EventCompositeHistoryView$2_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2974, 1608, {}, EventCompositeHistoryView$2_0);
_.executeAction = function executeAction_52(selection, actionValue){
  $deleteButtonPressed(this.this$0, selection);
}
;
_.this$0 = null;
function EventCompositeHistoryView$3_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2975, 1608, {}, EventCompositeHistoryView$3_0);
_.executeAction = function executeAction_53(selection, actionValue){
  $purgeButtonPressed(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_256(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully deleted [' + ($clinit_Enhanced() , '' + result.value_0) + '] events for [' + $toShortString(this$static.this$0.context) + ']', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function EventCompositeHistoryView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2976, 1, {}, EventCompositeHistoryView$4_0);
_.onFailure = function onFailure_267(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to deleted selected events for [' + ($clinit_Enhanced() , $toShortString(this.this$0.context)) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_267(result){
  $onSuccess_256(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
function $onSuccess_257(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully purged [' + ($clinit_Enhanced() , '' + result.value_0) + '] events for [' + $toShortString(this$static.this$0.context) + ']', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function EventCompositeHistoryView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2977, 1, {}, EventCompositeHistoryView$5_0);
_.onFailure = function onFailure_268(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to purge events for [' + ($clinit_Enhanced() , $toShortString(this.this$0.context)) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_268(result){
  $onSuccess_257(this, dynamicCast(result, Q$Integer));
}
;
_.this$0 = null;
function $clinit_ResourceGroupCompositeDataSource(){
  $clinit_ResourceGroupCompositeDataSource = nullMethod;
  $clinit_RPCDataSource();
  $clinit_CoreGUI();
}

function $copyValues_46(from){
  var composite, descriptionAttrib, explicitCount, explicitDisabled, explicitDown, explicitUnknown, idAttrib, implicitCount, implicitDisabled, implicitDown, implicitUnknown, nameAttrib, pluginNameAttrib, rg, rt, typeNameAttrib;
  idAttrib = getAttributeAsInt(from.jsObj, 'id');
  nameAttrib = $getAttribute(from, ($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName);
  descriptionAttrib = $getAttribute(from, DESCRIPTION.propertyName);
  typeNameAttrib = $getAttribute(from, TYPE_55.propertyName);
  rg = new ResourceGroup_2(nameAttrib);
  $setId_7(rg, idAttrib.value_0);
  rg.description = descriptionAttrib;
  if (typeNameAttrib != null) {
    rt = new ResourceType_0;
    rt.name_0 = typeNameAttrib;
    pluginNameAttrib = $getAttribute(from, PLUGIN_1.propertyName);
    rt.plugin = pluginNameAttrib;
    rg.resourceType = rt;
    !rt?$setGroupCategory(rg, ($clinit_GroupCategory() , MIXED_0)):$setGroupCategory(rg, ($clinit_GroupCategory() , COMPATIBLE));
  }
  explicitCount = new Long_0(__parseAndValidateLong(getAttribute(from.jsObj, 'explicitCount')));
  explicitDown = new Long_0(__parseAndValidateLong(getAttribute(from.jsObj, 'explicitDown')));
  explicitUnknown = new Long_0(__parseAndValidateLong(getAttribute(from.jsObj, 'explicitUnknown')));
  explicitDisabled = new Long_0(__parseAndValidateLong(getAttribute(from.jsObj, 'explicitDisabled')));
  implicitCount = new Long_0(__parseAndValidateLong(getAttribute(from.jsObj, 'implicitCount')));
  implicitDown = new Long_0(__parseAndValidateLong(getAttribute(from.jsObj, 'implicitDown')));
  implicitUnknown = new Long_0(__parseAndValidateLong(getAttribute(from.jsObj, 'implicitUnknown')));
  implicitDisabled = new Long_0(__parseAndValidateLong(getAttribute(from.jsObj, 'implicitDisabled')));
  composite = new ResourceGroupComposite_1(explicitCount, explicitDown, explicitUnknown, explicitDisabled, implicitCount, implicitDown, implicitUnknown, implicitDisabled, rg);
  return composite;
}

function $copyValues_47(from){
  var record;
  record = new ListGridRecord_0;
  !from?(record.jsObj['group'] = null , undefined):(record.jsObj['group'] = from , undefined);
  $setAttribute_3(record, 'id', from.resourceGroup.id);
  $setAttribute_13(record, ($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName, from.resourceGroup.name_0);
  $setAttribute_13(record, DESCRIPTION.propertyName, from.resourceGroup.description);
  $setAttribute_13(record, CATEGORY.propertyName, from.resourceGroup.groupCategory.name_0);
  $setAttribute_13(record, 'explicitCount', '' + toString_8(from.explicitCount));
  $setAttribute_13(record, 'explicitDown', '' + toString_8(from.explicitDown));
  $setAttribute_13(record, 'explicitDisabled', '' + toString_8(from.explicitDisabled));
  $setAttribute_13(record, 'implicitCount', '' + toString_8(from.implicitCount));
  $setAttribute_13(record, 'implicitDown', '' + toString_8(from.implicitDown));
  $setAttribute_13(record, 'implicitDisabled', '' + toString_8(from.implicitDisabled));
  $setAttribute_13(record, AVAIL_CHILDREN.propertyName, $getAlignedAvailabilityResults(from.explicitCount, sub(sub(sub(from.explicitCount, from.explicitDown), from.explicitDisabled), from.explicitUnknown), from.explicitDown, from.explicitUnknown, from.explicitDisabled));
  $setAttribute_13(record, AVAIL_DESCENDANTS.propertyName, $getAlignedAvailabilityResults(from.implicitCount, sub(sub(sub(from.implicitCount, from.implicitDown), from.implicitDisabled), from.implicitUnknown), from.implicitDown, from.implicitUnknown, from.implicitDisabled));
  if (from.resourceGroup.resourceType) {
    $setAttribute_12(record, 'resourceType', from.resourceGroup.resourceType);
    $setAttribute_13(record, TYPE_55.propertyName, from.resourceGroup.resourceType.name_0);
    $setAttribute_13(record, PLUGIN_1.propertyName, from.resourceGroup.resourceType.plugin);
  }
  return record;
}

function $executeFetch_32(this$static, request, response, criteria){
  $findResourceGroupCompositesByCriteria(this$static.groupService, criteria, new ResourceGroupCompositeDataSource$1_0(this$static, response, request, criteria));
}

function $getAlignedAvailabilityResults(total, up, down, unknown, disabled){
  var imagePath, results;
  results = new StringBuilder_0;
  $append_1(results.data_0, '<table><tr>');
  if (eq(P0_longLit, total)) {
    $append_12(results, $getColumn(false, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['<img src="images/' + getAvailabilityIcon(null) + '" /> 0'])));
    $append_12(results, $getColumn(true, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [])));
    $append_12(results, $getColumn(false, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [])));
  }
   else {
    if (gt(up, P0_longLit)) {
      imagePath = 'images/' + getAvailabilityIconFromAvailTypeAndSize(($clinit_AvailabilityType() , UP), false);
      $append_12(results, $getColumn(false, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [' <img height="12" width="12" src="' + imagePath + '" />', valueOf_45(up)])));
    }
     else {
      $append_12(results, $getColumn(false, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['&nbsp;<img src="/images/blank.png" width="12px" height="12px" />'])));
    }
    if (gt(down, P0_longLit)) {
      imagePath = 'images/' + getAvailabilityIconFromAvailTypeAndSize(($clinit_AvailabilityType() , DOWN_0), false);
      $append_12(results, $getColumn(false, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [' <img height="12" width="12" src="' + imagePath + '" />', valueOf_45(down)])));
    }
     else {
      $append_12(results, $getColumn(false, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['&nbsp;<img src="/images/blank.png" width="12px" height="12px" />'])));
    }
    if (gt(disabled, P0_longLit)) {
      imagePath = 'images/' + getAvailabilityIconFromAvailTypeAndSize(($clinit_AvailabilityType() , DISABLED), false);
      $append_12(results, $getColumn(false, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [' <img height="12" width="12" src="' + imagePath + '" />', valueOf_45(disabled)])));
    }
     else {
      $append_12(results, $getColumn(false, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['&nbsp;<img src="/images/blank.png" width="12px" height="12px" />'])));
    }
    if (gt(unknown, P0_longLit)) {
      imagePath = 'images/' + getAvailabilityIconFromAvailTypeAndSize(($clinit_AvailabilityType() , UNKNOWN_0), false);
      $append_12(results, $getColumn(false, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [' <img height="12" width="12" src="' + imagePath + '" />', valueOf_45(unknown)])));
    }
     else {
      $append_12(results, $getColumn(false, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, ['&nbsp;<img src="/images/blank.png" width="1px" height="1px" />'])));
    }
  }
  $append_1(results.data_0, '<\/tr><\/table>');
  return $toString_1(results.data_0);
}

function $getColumn(isSpacerColumn, data){
  var datum, datum$index, datum$max, results;
  results = new StringBuilder_0;
  isSpacerColumn?($append_1(results.data_0, '<td nowrap="nowrap" style="white-space:nowrap;" width="10px" align="left" >') , results):($append_1(results.data_0, '<td nowrap="nowrap" style="white-space:nowrap;" width="45px" align="left" >') , results);
  if (data == null) {
    $append_1(results.data_0, '&nbsp;');
  }
   else {
    for (datum$index = 0 , datum$max = data.length; datum$index < datum$max; ++datum$index) {
      datum = data[datum$index];
      $appendNonNull(results.data_0, '' + (datum == null?'&nbsp;':datum));
    }
  }
  $append_1(results.data_0, '<\/td>');
  return $toString_1(results.data_0);
}

function $isAvailabilitySearch(criteria){
  return criteria.searchExpression != null && criteria.searchExpression.indexOf('availability') == 0;
}

function ResourceGroupCompositeDataSource_0(){
  var fields_0, idDataField, nameDataField, descriptionDataField, typeNameDataField, pluginNameDataField, categoryDataField;
  $clinit_ResourceGroupCompositeDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.groupService = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , idDataField = new DataSourceIntegerField_2('id', 'ID', 50) , $setAttribute_8(idDataField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setAttribute_8(idDataField, 'canEdit', FALSE) , setCheck(fields_0.array, fields_0.size_0++, idDataField) , nameDataField = new DataSourceTextField_2(($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName, NAME_30.title_0, 200) , $setAttribute_8(nameDataField, 'canEdit', FALSE) , setCheck(fields_0.array, fields_0.size_0++, nameDataField) , descriptionDataField = new DataSourceTextField_1(DESCRIPTION.propertyName, DESCRIPTION.title_0) , $setAttribute_8(descriptionDataField, 'canEdit', FALSE) , setCheck(fields_0.array, fields_0.size_0++, descriptionDataField) , typeNameDataField = new DataSourceTextField_1(TYPE_55.propertyName, TYPE_55.title_0) , setCheck(fields_0.array, fields_0.size_0++, typeNameDataField) , pluginNameDataField = new DataSourceTextField_1(PLUGIN_1.propertyName, PLUGIN_1.title_0) , setCheck(fields_0.array, fields_0.size_0++, pluginNameDataField) , categoryDataField = new DataSourceTextField_1(CATEGORY.propertyName, CATEGORY.title_0) , setCheck(fields_0.array, fields_0.size_0++, categoryDataField) , fields_0);
  $addFields(this, fields);
}

defineSeed(2978, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceGroupCompositeDataSource_0);
_.copyValues = function copyValues_85(from){
  return $copyValues_46(from);
}
;
_.copyValues_0 = function copyValues_86(from){
  return $copyValues_47(dynamicCast(from, Q$ResourceGroupComposite));
}
;
_.executeFetch = function executeFetch_46(request, response, criteria){
  $executeFetch_32(this, request, response, dynamicCast(criteria, Q$ResourceGroupCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_58(request){
  var criteria;
  return criteria = new ResourceGroupCriteria_0 , $addFilterId(criteria, dynamicCast(($clinit_RPCDataSource() , getFilter($getCriteria(request), 'id', Ljava_lang_Integer_2_classLit)), Q$Integer)) , $addFilterName_2(criteria, dynamicCast(getFilter_0(request, ($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName, Ljava_lang_String_2_classLit), Q$String)) , $addFilterGroupCategory(criteria, dynamicCast(getFilter_0(request, CATEGORY.propertyName, Lorg_rhq_core_domain_resource_group_GroupCategory_2_classLit), Q$GroupCategory)) , $addFilterDownMemberCount(criteria, dynamicCast(getFilter($getCriteria(request), 'downMemberCount', Ljava_lang_Long_2_classLit), Q$Long)) , $addFilterExplicitResourceIds(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [dynamicCast(getFilter($getCriteria(request), 'explicitResourceId', Ljava_lang_Integer_2_classLit), Q$Integer)])) , $addFilterGroupDefinitionId(criteria, dynamicCast(getFilter($getCriteria(request), 'groupDefinitionId', Ljava_lang_Integer_2_classLit), Q$Integer)) , $setSearchExpression(criteria, dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String)) , $addFilterIds(criteria, dynamicCast(getArrayFilter($getCriteria(request), 'resourceGroupIds', Ljava_lang_Integer_2_classLit), Q$Integer_$1)) , criteria;
}
;
var INSTANCE_37 = null;
function $applyAvailabilitySearchFilter(this$static, result){
  var pageList, rgc, rgc$iterator;
  if (!$isAvailabilitySearch(this$static.val$criteria)) {
    return result;
  }
  pageList = new PageList_2(result.pageControl);
  for (rgc$iterator = new AbstractList$IteratorImpl_0(result); rgc$iterator.i < rgc$iterator.this$0_0.size_1();) {
    rgc = dynamicCast($next_0(rgc$iterator), Q$ResourceGroupComposite);
    gt(rgc.explicitCount, P0_longLit) && (setCheck(pageList.array, pageList.size_0++, rgc) , true);
  }
  return pageList;
}

function $onSuccess_258(this$static, result){
  var filteredResult;
  filteredResult = $applyAvailabilitySearchFilter(this$static, result);
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, filteredResult, true));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(filteredResult.size_0, filteredResult.totalSize)));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ResourceGroupCompositeDataSource$1_0(this$0, val$response, val$request, val$criteria){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
  this.val$criteria = val$criteria;
}

defineSeed(2979, 1, {}, ResourceGroupCompositeDataSource$1_0);
_.onFailure = function onFailure_269(caught){
  var message;
  if (caught.getMessage().indexOf('SearchExpressionException') != -1) {
    message = new Message_7(($clinit_ResourceGroupCompositeDataSource() , 'No matches, enter a different pattern'), ($clinit_Message$Severity() , Error_2));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
   else {
    $handleError_0(($clinit_CoreGUI() , $clinit_ResourceGroupCompositeDataSource() , 'Failed to load group composite data'), caught);
  }
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_269(result){
  $onSuccess_258(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$criteria = null;
_.val$request = null;
_.val$response = null;
function $clinit_ResourceGroupDataSourceField(){
  $clinit_ResourceGroupDataSourceField = nullMethod;
  NAME_30 = new ResourceGroupDataSourceField_0('NAME', 0, 'name', ($clinit_CoreGUI() , 'Name'));
  DESCRIPTION = new ResourceGroupDataSourceField_0('DESCRIPTION', 1, 'description', 'Description');
  TYPE_55 = new ResourceGroupDataSourceField_0('TYPE', 2, 'resourceTypeName', 'Type');
  PLUGIN_1 = new ResourceGroupDataSourceField_0('PLUGIN', 3, 'pluginName', 'Plugin');
  CATEGORY = new ResourceGroupDataSourceField_0('CATEGORY', 4, 'groupCategory', 'Category');
  AVAIL_CHILDREN = new ResourceGroupDataSourceField_0('AVAIL_CHILDREN', 5, 'availabilityChildren', 'Children');
  AVAIL_DESCENDANTS = new ResourceGroupDataSourceField_0('AVAIL_DESCENDANTS', 6, 'availabilityDescendants', 'Descendants');
  $VALUES_130 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupDataSourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceGroupDataSourceField, [NAME_30, DESCRIPTION, TYPE_55, PLUGIN_1, CATEGORY, AVAIL_CHILDREN, AVAIL_DESCENDANTS]);
}

function ResourceGroupDataSourceField_0(enum$name, enum$ordinal, propertyName, title){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.propertyName = propertyName;
  this.title_0 = title;
}

function valueOf_139(name_0){
  $clinit_ResourceGroupDataSourceField();
  return valueOf(($clinit_ResourceGroupDataSourceField$Map() , $MAP_130), name_0);
}

function values_133(){
  $clinit_ResourceGroupDataSourceField();
  return $VALUES_130;
}

defineSeed(2980, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$ResourceGroupDataSourceField]), ResourceGroupDataSourceField_0);
_.propertyName = null;
_.title_0 = null;
var $VALUES_130, AVAIL_CHILDREN, AVAIL_DESCENDANTS, CATEGORY, DESCRIPTION, NAME_30, PLUGIN_1, TYPE_55;
function $clinit_ResourceGroupDataSourceField$Map(){
  $clinit_ResourceGroupDataSourceField$Map = nullMethod;
  $MAP_130 = createValueOfMap(($clinit_ResourceGroupDataSourceField() , $VALUES_130));
}

var $MAP_130;
function ResourceGroupListView$1_0(){
}

defineSeed(2982, 1, {}, ResourceGroupListView$1_0);
_.format_1 = function format_55(value, record, rowNum, colNum){
  var category, categoryName, icon;
  categoryName = dynamicCast(value, Q$String);
  category = ($clinit_GroupCategory() , dynamicCast(valueOf(($clinit_GroupCategory$Map() , $MAP_111), categoryName), Q$GroupCategory));
  icon = getGroupIcon(category);
  return '<img src="images/' + icon + '" />';
}
;
function ResourceGroupListView$2_0(){
}

defineSeed(2983, 1, {}, ResourceGroupListView$2_0);
_.hoverHTML_0 = function hoverHTML_27(value, record, rowNum, colNum){
  var category, categoryName, displayName;
  categoryName = $getAttribute(record, ($clinit_ResourceGroupDataSourceField() , CATEGORY).propertyName);
  category = ($clinit_GroupCategory() , dynamicCast(valueOf(($clinit_GroupCategory$Map() , $MAP_111), categoryName), Q$GroupCategory));
  switch (category.ordinal) {
    case 0:
      displayName = ($clinit_Enhanced() , 'Compatible');
      break;
    case 1:
      displayName = ($clinit_Enhanced() , 'Mixed');
      break;
    default:throw new IllegalStateException_1('Unknown group category: ' + category);
  }
  return displayName;
}
;
function ResourceGroupListView$3_0(){
}

defineSeed(2984, 1, {}, ResourceGroupListView$3_0);
_.format_1 = function format_56(value, record, i, i1){
  var groupId, groupUrl;
  groupId = getAttribute(record.jsObj, 'id');
  groupUrl = '#ResourceGroup/' + valueOf_44(__parseAndValidateInt(groupId)).value_0;
  return getHref(groupUrl, toString__devirtual$(value));
}
;
function ResourceGroupListView$4_0(this$0, $anonymous0, $anonymous1, $anonymous2){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2);
}

defineSeed(2985, 1607, {}, ResourceGroupListView$4_0);
_.executeAction = function executeAction_54(selections, actionValue){
  var groupIds, index, resourceGroupManager, selection, selection$index, selection$max;
  groupIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selections.length, 1);
  index = 0;
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    groupIds[index++] = getAttributeAsInt(selection.jsObj, 'id').value_0;
  }
  resourceGroupManager = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
  $deleteResourceGroups(resourceGroupManager, groupIds, new ResourceGroupListView$4$1_0(this));
}
;
_.this$0 = null;
function $onSuccess_259(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have successfully deleted the selected resource groups'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$1.this$0, true);
}

function ResourceGroupListView$4$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2986, 1, {}, ResourceGroupListView$4$1_0);
_.onFailure = function onFailure_270(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete the selected resource groups'), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_270(result){
  $onSuccess_259(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
function ResourceGroupListView$5_0(this$0, $anonymous0, $anonymous1){
  this.this$0 = this$0;
  AuthorizedTableAction_0.call(this, $anonymous0, ($clinit_TableActionEnablement() , ALWAYS), $anonymous1);
}

defineSeed(2987, 1607, {}, ResourceGroupListView$5_0);
_.executeAction = function executeAction_55(selection, actionValue){
  var category, categoryString;
  category = null;
  categoryString = !this.this$0.initialCriteria_0?null:$getAttribute(this.this$0.initialCriteria_0, ($clinit_ResourceGroupDataSourceField() , CATEGORY).propertyName);
  categoryString != null && (category = $equals_6(($clinit_GroupCategory() , COMPATIBLE).name_0, categoryString)?COMPATIBLE:MIXED_0);
  $startWizard(new GroupCreateWizard_0(this.this$0, category));
  $refreshTableInfo(this.this$0);
}
;
_.this$0 = null;
function ResourceGroupListView$6_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(2988, 1608, {}, ResourceGroupListView$6_0);
_.executeAction = function executeAction_56(selection, actionValue){
  var membershipView, winModal;
  membershipView = new ResourceResourceGroupsView_0(this.this$0.resourceIdToModify.value_0);
  winModal = new PopupWindow_0(membershipView);
  $setTitle(winModal, ($clinit_Enhanced() , 'Group Membership'));
  $isCreated_1(winModal)?$setProperty_0(winModal, 'width', 700):(winModal.config_0['width'] = 700 , undefined);
  $isCreated_1(winModal)?$setProperty_0(winModal, 'height', 450):(winModal.config_0['height'] = 450 , undefined);
  $addCloseClickHandler(winModal, new ResourceGroupListView$6$1_0(this));
  $setSaveButtonHandler_0(membershipView, new ResourceGroupListView$6$2_0(winModal));
  $show(winModal);
}
;
_.this$0 = null;
function ResourceGroupListView$6$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(2989, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), ResourceGroupListView$6$1_0);
_.onCloseClick_0 = function onCloseClick_12(event_0){
  $refreshTableInfo(this.this$1.this$0);
}
;
_.this$1 = null;
function $onClick(this$static){
  $markForDestroy(this$static.val$winModal);
  $clinit_CoreGUI();
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function ResourceGroupListView$6$2_0(val$winModal){
  this.val$winModal = val$winModal;
}

defineSeed(2990, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceGroupListView$6$2_0);
_.onClick = function onClick_127(event_0){
  $onClick(this);
}
;
_.val$winModal = null;
function ResourceGroupListView$7_0(){
}

defineSeed(2991, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), ResourceGroupListView$7_0);
_.onDoubleClick = function onDoubleClick_10(event_0){
  var listGrid, selectedId, selectedRows;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    selectedId = getAttribute(selectedRows[0].jsObj, 'id');
    $clinit_CoreGUI();
    goToView('#ResourceGroup/' + valueOf_44(__parseAndValidateInt(selectedId)).value_0, null, false);
  }
}
;
function $onSuccess_260(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ResourceGroupsDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2992, 1, {}, ResourceGroupsDataSource$1_0);
_.onFailure = function onFailure_271(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load Resource Groups'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_271(result){
  $onSuccess_260(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $convertLongToString(val){
  var ret;
  ret = null;
  !!val && (ret = '' + toString_8(val.value_0));
  return ret;
}

function $copyValues_48(from){
  var groupDefinition, recalcInt;
  groupDefinition = new GroupDefinition_0;
  $setId_5(groupDefinition, getAttributeAsInt(from.jsObj, 'id').value_0);
  $setName_10(groupDefinition, getAttribute(from.jsObj, 'name'));
  $setDescription_5(groupDefinition, getAttribute(from.jsObj, 'description'));
  $setExpression(groupDefinition, getAttribute(from.jsObj, 'expression'));
  $setRecursive(groupDefinition, ($clinit_Boolean() , getAttributeAsBoolean(from.jsObj, 'recursive')?TRUE:FALSE).value_0);
  recalcInt = getAttribute(from.jsObj, 'recalculationInterval');
  $setRecalculationInterval(groupDefinition, valueOf_45(recalcInt != null?mul(mul(__parseAndValidateLong(recalcInt), P3c_longLit), P3e8_longLit):P0_longLit));
  return groupDefinition;
}

function $copyValues_49(from){
  var recalcIntervalLong, record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'name', from.name_0);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_13(record, 'expression', from.expression);
  $setAttribute_16(record, 'recursive', from.recursive);
  recalcIntervalLong = div(valueOf_45(from.recalculationInterval).value_0, Pea60_longLit);
  $setAttribute_13(record, 'recalculationInterval', $convertLongToString(valueOf_45(recalcIntervalLong)));
  $setAttribute_12(record, 'modifiedTime', from.modifiedTime);
  $setAttribute_12(record, 'createdTime', from.createdTime);
  $setAttribute_13(record, 'lastCalculationTime', $convertLongToString(from.lastCalculationTime));
  $setAttribute_13(record, 'nextCalculationTime', $convertLongToString($getNextCalculationTime(from)));
  return record;
}

function $executeFetch_33(this$static, request, response, criteria){
  $findGroupDefinitionsByCriteria(this$static.groupService, criteria, new GroupDefinitionDataSource$1_0(this$static, response, request));
}

function GroupDefinitionDataSource_0(){
  var fields_0, idField, nameField, descriptionField, expressionField, lastCalculationTimeIntervalField, nextCalculationTimeField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.groupService = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , idField = new DataSourceIntegerField_1('id', 'ID') , $setAttribute_8(idField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setAttribute_8(idField, 'canEdit', FALSE) , setCheck(fields_0.array, fields_0.size_0++, idField) , nameField = new DataSourceTextField_3('name', 'Name', 100) , setCheck(fields_0.array, fields_0.size_0++, nameField) , descriptionField = new DataSourceTextField_2('description', 'Description', 100) , setCheck(fields_0.array, fields_0.size_0++, descriptionField) , expressionField = new DataSourceTextField_3('expression', 'Expression Set', 1000) , setCheck(fields_0.array, fields_0.size_0++, expressionField) , lastCalculationTimeIntervalField = new DataSourceTextField_1('lastCalculationTime', 'Last Calculation Time') , setCheck(fields_0.array, fields_0.size_0++, lastCalculationTimeIntervalField) , nextCalculationTimeField = new DataSourceTextField_1('nextCalculationTime', 'Next Calculation Time') , setCheck(fields_0.array, fields_0.size_0++, nextCalculationTimeField) , fields_0);
  $addFields(this, fields);
}

defineSeed(2993, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), GroupDefinitionDataSource_0);
_.copyValues = function copyValues_87(from){
  return $copyValues_48(from);
}
;
_.copyValues_0 = function copyValues_88(from){
  return $copyValues_49(dynamicCast(from, Q$GroupDefinition));
}
;
_.executeAdd = function executeAdd_2(recordToAdd, request, response){
  var name_0, newGroupDefinition;
  newGroupDefinition = $copyValues_48(recordToAdd);
  name_0 = newGroupDefinition.name_0;
  $createGroupDefinition(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), newGroupDefinition, new GroupDefinitionDataSource$2_0(this, response, request, name_0));
}
;
_.executeFetch = function executeFetch_47(request, response, criteria){
  $executeFetch_33(this, request, response, dynamicCast(criteria, Q$ResourceGroupDefinitionCriteria));
}
;
_.executeUpdate = function executeUpdate_2(editedRecord, oldRecord, request, response){
  var name_0, updatedGroupDefinition;
  updatedGroupDefinition = $copyValues_48(editedRecord);
  name_0 = updatedGroupDefinition.name_0;
  $updateGroupDefinition(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), updatedGroupDefinition, new GroupDefinitionDataSource$3_0(this, name_0, response, updatedGroupDefinition, request));
}
;
_.getFetchCriteria = function getFetchCriteria_59(request){
  return new ResourceGroupDefinitionCriteria_0;
}
;
var INSTANCE_38 = null;
function $onSuccess_261(this$static, result){
  $sendSuccessResponse_1(this$static.this$0, this$static.val$request, this$static.val$response, result);
}

function GroupDefinitionDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(2994, 1, {}, GroupDefinitionDataSource$1_0);
_.onFailure = function onFailure_272(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load group definitions'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_272(result){
  $onSuccess_261(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onFailure_31(this$static){
  var errors;
  errors = new HashMap_0;
  errors.put('name', ($clinit_RPCDataSource() , 'A group definition already exists with this name'));
  $setAttribute_15(this$static.val$response, 'errors', errors);
  this$static.val$response.jsObj['status'] = -4;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_262(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0('You have successfully created a group definition named [' + ($clinit_RPCDataSource() , this$static.val$name) + ']'));
  $setAttribute_17(this$static.val$response, 'data', initValues(_3Lcom_smartgwt_client_data_Record_2_classLit, makeCastMap([Q$Record_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Record, [$copyValues_49(result)]));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function GroupDefinitionDataSource$2_0(this$0, val$response, val$request, val$name){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
  this.val$name = val$name;
}

defineSeed(2995, 1, {}, GroupDefinitionDataSource$2_0);
_.onFailure = function onFailure_273(caught){
  $onFailure_31(this);
}
;
_.onSuccess_0 = function onSuccess_273(result){
  $onSuccess_262(this, dynamicCast(result, Q$GroupDefinition));
}
;
_.this$0 = null;
_.val$name = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_263(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0('You have successfully saved the group definition named [' + ($clinit_RPCDataSource() , this$static.val$name) + ']'));
  $setAttribute_17(this$static.val$response, 'data', initValues(_3Lcom_smartgwt_client_data_Record_2_classLit, makeCastMap([Q$Record_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Record, [$copyValues_49(this$static.val$updatedGroupDefinition)]));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function GroupDefinitionDataSource$3_0(this$0, val$name, val$response, val$updatedGroupDefinition, val$request){
  this.this$0 = this$0;
  this.val$name = val$name;
  this.val$response = val$response;
  this.val$updatedGroupDefinition = val$updatedGroupDefinition;
  this.val$request = val$request;
}

defineSeed(2996, 1, {}, GroupDefinitionDataSource$3_0);
_.onFailure = function onFailure_274(caught){
  instanceOf(caught, Q$DuplicateExpressionTypeException)?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(caught.getMessage(), ($clinit_Message$Severity() , Warning))):$handleError_0(($clinit_CoreGUI() , 'Failed to save the group definition named [' + ($clinit_RPCDataSource() , this.val$name) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_274(result){
  $onSuccess_263(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$name = null;
_.val$request = null;
_.val$response = null;
_.val$updatedGroupDefinition = null;
function $addExpression(this$static){
  var valueAsString;
  valueAsString = $getValueAsString_0(this$static.expressionItem);
  valueAsString != null && $trim(valueAsString).length > 0 && $addExpression_0(this$static.addExpressionHandler, valueAsString);
}

function $buildExpressionValue(this$static){
  var buf, d, eType, expressionValueString, groupBy, memberOf, resourceLevel, selectedComparison, unset;
  memberOf = $equals_6('Yes', $getValueAsString_3(this$static.memberOfItem));
  groupBy = $equals_6('Yes', $getValueAsString_3(this$static.groupByItem));
  unset = $equals_6('Yes', $getValueAsString_3(this$static.unsetItem));
  buf = new StringBuilder_0;
  if (memberOf) {
    $append_12(buf, 'memberof = ' + $getDisplayValue(this$static.memberOfGroupItem));
  }
   else {
    groupBy && ($append_1(buf.data_0, 'groupby ') , buf);
    unset && ($append_1(buf.data_0, 'empty ') , buf);
    $append_1(buf.data_0, 'resource.');
    resourceLevel = $getValueAsString_4(this$static.resourceItem);
    if ($equals_6('Resource', resourceLevel))
    ;
    else 
      $equals_6('Child', resourceLevel)?($append_1(buf.data_0, 'child.') , buf):$equals_6('Parent', resourceLevel)?($append_1(buf.data_0, 'parent.') , buf):$equals_6('Grandparent', resourceLevel)?($append_1(buf.data_0, 'grandParent.') , buf):$equals_6('GreatGrandparent', resourceLevel)?($append_1(buf.data_0, 'greatGrandParent.') , buf):$equals_6('GreatGreatGrandparent', resourceLevel) && ($append_1(buf.data_0, 'greatGreatGrandParent.') , buf);
    eType = $getValueAsString_4(this$static.expressionTypeItem);
    $equals_6('Resource', eType)?$append_12(buf, $getValueAsString_4(this$static.propertyNameItem)):$equals_6('Resource Type', eType)?($append_1(buf.data_0, 'type.plugin') , buf):$equals_6('Resource Category', eType)?($append_1(buf.data_0, 'type.category') , buf):$equals_6('Trait', eType)?$append_12(buf, 'trait[' + $getValueAsString_4(this$static.propertyNameItem) + ']'):$equals_6('Plugin Configuration', eType)?$append_12(buf, 'pluginConfiguration[' + $getValueAsString_4(this$static.propertyNameItem) + ']'):$equals_6('Resource Configuration', eType) && $append_12(buf, 'resourceConfiguration[' + $getValueAsString_4(this$static.propertyNameItem) + ']');
    if (!groupBy && !unset) {
      selectedComparison = $getValueAsString_4(this$static.compareTypeItem);
      if ($equals_6('equals', selectedComparison))
      ;
      else 
        $equals_6('contains', selectedComparison)?($append_1(buf.data_0, '.contains') , buf):$equals_6('starts with', selectedComparison)?($append_1(buf.data_0, '.startsWith') , buf):$equals_6('ends with', selectedComparison) && ($append_1(buf.data_0, '.endsWith') , buf);
      $append_1(buf.data_0, ' = ');
      if ($equals_6('Resource', eType) || $equals_6('Resource Category', eType)) {
        $append_12(buf, this$static.valueItem.getValueAsString());
      }
       else if ($equals_6('Resource Type', eType)) {
        d = $toString_1(buf.data_0);
        $append_12(buf, $getValueAsString_4(this$static.pluginItem));
        $append_1(buf.data_0, '\n');
        $append_12(buf, $replaceAll(d, 'plugin', 'name'));
        $append_12(buf, $getValueAsString_4(this$static.resourceTypeItem));
      }
       else 
        ($equals_6('Trait', eType) || $equals_6('Plugin Configuration', eType) || $equals_6('Resource Configuration', eType)) && $append_12(buf, this$static.valueItem.getValueAsString());
    }
     else if ($equals_6('Resource Type', eType)) {
      d = $toString_1(buf.data_0);
      $append_1(buf.data_0, '\n');
      $append_12(buf, $replaceAll(d, 'plugin', 'name'));
    }
  }
  expressionValueString = $toString_1(buf.data_0);
  $setValue_7(this$static.expressionItem, expressionValueString);
  $markForRedraw(this$static);
  return;
}

function $enableDisableComponents(this$static){
  var comparisonTypeAndValueDisabled, groupByDisabled, memberOfGroupDisabled, pluginAndResourceTypeDisabled, propertyNameDisabled, resourceAndExpressionTypeDisabled, unsetDisabled;
  memberOfGroupDisabled = $shouldMemberOfGroupBeDisabled(this$static);
  resourceAndExpressionTypeDisabled = $shouldResourceAndExpressionTypeBeDisabled(this$static);
  pluginAndResourceTypeDisabled = $shouldPluginAndResourceTypeBeDisabled(this$static);
  comparisonTypeAndValueDisabled = $shouldComparisonTypeAndValueBeDisabled(this$static);
  groupByDisabled = $shouldGroupByBeDisabled(this$static);
  unsetDisabled = $shouldUnsetBeDisabled(this$static);
  propertyNameDisabled = $shouldPropertyNameBeDisabled(this$static);
  $setDisabled_2(this$static.memberOfGroupItem, ($clinit_Boolean() , memberOfGroupDisabled?TRUE:FALSE));
  $setDisabled_2(this$static.resourceItem, resourceAndExpressionTypeDisabled?TRUE:FALSE);
  $setDisabled_2(this$static.expressionTypeItem, resourceAndExpressionTypeDisabled?TRUE:FALSE);
  $setDisabled_2(this$static.pluginItem, pluginAndResourceTypeDisabled?TRUE:FALSE);
  $setDisabled_2(this$static.resourceTypeItem, pluginAndResourceTypeDisabled?TRUE:FALSE);
  $setDisabled_2(this$static.compareTypeItem, comparisonTypeAndValueDisabled?TRUE:FALSE);
  $setDisabled_2(this$static.valueItem, comparisonTypeAndValueDisabled?TRUE:FALSE);
  $setDisabled_2(this$static.groupByItem, groupByDisabled?TRUE:FALSE);
  $setDisabled_2(this$static.unsetItem, unsetDisabled?TRUE:FALSE);
  $setDisabled_2(this$static.propertyNameItem, propertyNameDisabled?TRUE:FALSE);
  $markForRedraw(this$static);
}

function $loadPropertyNameDropDown(this$static){
  var expressionType, resourceType, resourceTypeId, service;
  expressionType = $getValueAsString_4(this$static.expressionTypeItem);
  resourceType = $getValueAsString_4(this$static.resourceTypeItem);
  resourceTypeId = dynamicCast(this$static.resourceTypeIds.get_2(resourceType), Q$Integer);
  this$static.propertyNameItem.setValueMap_1(initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, 0, 0));
  $clearValue_0(this$static.propertyNameItem);
  if ($equals_6('Resource', expressionType)) {
    this$static.propertyNameItem.setValueMap_1(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['id', 'name', 'version', 'availability']));
    $clearValue_0(this$static.propertyNameItem);
    $buildExpressionValue(this$static);
  }
   else if (resourceTypeId) {
    service = dynamicCast(secure(getInstance_43(), -1), Q$GroupDefinitionExpressionBuilderGWTServiceAsync);
    $equals_6('Trait', expressionType)?$getTraitPropertyNames(service, resourceTypeId.value_0, new GroupDefinitionExpressionBuilder$18_0(this$static)):$equals_6('Plugin Configuration', expressionType)?$getPluginConfigurationPropertyNames(service, resourceTypeId.value_0, new GroupDefinitionExpressionBuilder$19_0(this$static)):$equals_6('Resource Configuration', expressionType)?$getResourceConfigurationPropertyNames(service, resourceTypeId.value_0, new GroupDefinitionExpressionBuilder$20_0(this$static)):$buildExpressionValue(this$static);
  }
   else {
    $buildExpressionValue(this$static);
  }
  $markForRedraw(this$static);
  return;
}

function $loadResourceTypeDropDown(this$static, newPlugin){
  var criteria;
  criteria = new ResourceTypeCriteria_0;
  criteria.filterIgnored = ($clinit_Boolean() , $clinit_Boolean() , FALSE);
  criteria.filterPluginName = newPlugin;
  $setPageControl(criteria, new PageControl_1(0, -1));
  $setRestriction(criteria, ($clinit_Criteria$Restriction() , COLLECTION_ONLY));
  criteria.strict = true;
  $findResourceTypesByCriteria(dynamicCast(secure((!instance_28 && (instance_28 = new ResourceTypeGWTService_Proxy_0) , instance_28), -1), Q$ResourceTypeGWTServiceAsync), criteria, new GroupDefinitionExpressionBuilder$17_0(this$static, newPlugin));
}

function $shouldComparisonTypeAndValueBeDisabled(this$static){
  var expressionType, groupBy, memberOf, unset;
  memberOf = $equals_6('Yes', $getValueAsString_3(this$static.memberOfItem));
  groupBy = $equals_6('Yes', $getValueAsString_3(this$static.groupByItem));
  unset = $equals_6('Yes', $getValueAsString_3(this$static.unsetItem));
  expressionType = $getValueAsString_4(this$static.expressionTypeItem);
  if (groupBy || memberOf || unset) {
    return true;
  }
  if ($equals_6('Resource Type', expressionType)) {
    return true;
  }
  return false;
}

function $shouldGroupByBeDisabled(this$static){
  var memberOf, unset;
  memberOf = $equals_6('Yes', $getValueAsString_3(this$static.memberOfItem));
  unset = $equals_6('Yes', $getValueAsString_3(this$static.unsetItem));
  if (memberOf || unset) {
    return true;
  }
  return false;
}

function $shouldMemberOfGroupBeDisabled(this$static){
  $getValueAsString_4(this$static.expressionTypeItem);
  if ($equals_6('No', $getValueAsString_3(this$static.memberOfItem))) {
    return true;
  }
  return false;
}

function $shouldPluginAndResourceTypeBeDisabled(this$static){
  var expressionType;
  expressionType = $getValueAsString_4(this$static.expressionTypeItem);
  if ($equals_6('Yes', $getValueAsString_3(this$static.memberOfItem))) {
    return true;
  }
  if ($equals_6('Resource', expressionType)) {
    return true;
  }
  if ($equals_6('Resource Category', expressionType)) {
    return true;
  }
  if ($equals_6('Resource Type', expressionType) && $equals_6('Yes', $getValueAsString_3(this$static.groupByItem))) {
    return true;
  }
  return false;
}

function $shouldPropertyNameBeDisabled(this$static){
  var expressionType, memberOf;
  memberOf = $equals_6('Yes', $getValueAsString_3(this$static.memberOfItem));
  expressionType = $getValueAsString_4(this$static.expressionTypeItem);
  if (memberOf) {
    return true;
  }
  if ($equals_6('Resource Type', expressionType)) {
    return true;
  }
   else if ($equals_6('Resource Category', expressionType)) {
    return true;
  }
  return false;
}

function $shouldResourceAndExpressionTypeBeDisabled(this$static){
  $getValueAsString_4(this$static.expressionTypeItem);
  if ($equals_6('Yes', $getValueAsString_3(this$static.memberOfItem))) {
    return true;
  }
  return false;
}

function $shouldUnsetBeDisabled(this$static){
  var groupBy, memberOf;
  memberOf = $equals_6('Yes', $getValueAsString_3(this$static.memberOfItem));
  groupBy = $equals_6('Yes', $getValueAsString_3(this$static.groupByItem));
  if (groupBy || memberOf) {
    return true;
  }
  return false;
}

function GroupDefinitionExpressionBuilder_0(addExpressionHandler){
  $clinit_BaseWidget();
  Window_1.call(this);
  $clinit_CoreGUI();
  this.plugins = new ArrayList_0;
  this.resourceTypeIds = new HashMap_0;
  this.addExpressionHandler = addExpressionHandler;
  $setIsModal(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowModalMask(this, FALSE);
  $setShowMinimizeButton(this, TRUE);
  $setShowMaximizeButton(this, TRUE);
  $setShowCloseButton(this, TRUE);
  $setAutoSize(this, TRUE);
  $setCanDragResize_0(this, TRUE);
  $setAutoCenter(this, TRUE);
  $centerInPage(this);
  $addCloseClickHandler(this, new GroupDefinitionExpressionBuilder$1_0(this));
}

defineSeed(2997, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), GroupDefinitionExpressionBuilder_0);
_.onInit = function onInit_59(){
  var addButton, closeButton, form, layout;
  $onInit(this);
  $onInit_Layout(this);
  $isCreated_1(this)?$setProperty_3(this, 'title', 'Expression Builder'):(this.config_0['title'] = 'Expression Builder' , undefined);
  this.valueItem = new TextItem_3('value', 'Value');
  $setPrompt_1(this.valueItem, 'The string value for the expression to query');
  $setWidth_3(this.valueItem, 200);
  $setHoverWidth_0(this.valueItem, valueOf_44(250));
  $setDefaultValue_1(this.valueItem, '');
  $addChangedHandler(this.valueItem, new GroupDefinitionExpressionBuilder$2_0(this));
  this.compareTypeItem = new SortedSelectItem_2('compareType', 'Comparison Type');
  $setPrompt_1(this.compareTypeItem, 'Comparison Type');
  $setHoverWidth_0(this.compareTypeItem, valueOf_44(250));
  $setRedrawOnChange(this.compareTypeItem);
  $setWidth_2(this.compareTypeItem, '*');
  $setDefaultToFirstOption_0(this.compareTypeItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setValueMap_2(this.compareTypeItem, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['equals', 'starts with', 'ends with', 'contains']));
  $addChangedHandler(this.compareTypeItem, new GroupDefinitionExpressionBuilder$3_0(this));
  this.unsetItem = new RadioGroupItem_2('unset', 'Unset');
  $setPrompt_1(this.unsetItem, 'Unset will find all of the values that have a null value in the database. This is not possible using the "=" operator because of how databases store and query data.');
  $setHoverWidth_0(this.unsetItem, valueOf_44(250));
  $setDefaultValue_1(this.unsetItem, 'No');
  $setValueMap_0(this.unsetItem, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['Yes', 'No']));
  $setAttribute_29(this.unsetItem, 'vertical', FALSE);
  $addChangedHandler(this.unsetItem, new GroupDefinitionExpressionBuilder$4_0(this));
  this.propertyNameItem = new SelectItem_2('propertyName', 'Property Name');
  $setPrompt_1(this.propertyNameItem, 'The name of the property to query. This is defined by the expression type as well as the resource type.');
  $setHoverWidth_0(this.propertyNameItem, valueOf_44(250));
  $setRedrawOnChange(this.propertyNameItem);
  $setWidth_2(this.propertyNameItem, '*');
  $setDefaultToFirstOption_0(this.propertyNameItem, TRUE);
  $setEmptyDisplayValue(this.propertyNameItem, '--No properties--');
  $addChangedHandler(this.propertyNameItem, new GroupDefinitionExpressionBuilder$5_0(this));
  this.resourceTypeItem = new SortedSelectItem_2('resourceType', 'Resource Type');
  $setPrompt_1(this.resourceTypeItem, 'The type of resource');
  $setHoverWidth_0(this.resourceTypeItem, valueOf_44(250));
  $setRedrawOnChange(this.resourceTypeItem);
  $setWidth_2(this.resourceTypeItem, '*');
  $setDefaultToFirstOption_0(this.resourceTypeItem, TRUE);
  $setEmptyDisplayValue(this.resourceTypeItem, '--No resource types--');
  $addChangedHandler(this.resourceTypeItem, new GroupDefinitionExpressionBuilder$6_0(this));
  this.pluginItem = new SortedSelectItem_2('plugin', 'Defining Plugin');
  $setPrompt_1(this.pluginItem, 'The plugin to search');
  $setHoverWidth_0(this.pluginItem, valueOf_44(250));
  $setRedrawOnChange(this.pluginItem);
  $setWidth_2(this.pluginItem, '*');
  $setDefaultToFirstOption_0(this.pluginItem, TRUE);
  $setEmptyDisplayValue(this.pluginItem, '--No plugins--');
  $addChangedHandler(this.pluginItem, new GroupDefinitionExpressionBuilder$7_0(this));
  $getAgentPlugins(dynamicCast(secure(getInstance_47(), -1), Q$PluginGWTServiceAsync), false, new GroupDefinitionExpressionBuilder$8_0(this));
  this.expressionTypeItem = new SortedSelectItem_2('expressionType', 'Expression Type');
  $setPrompt_1(this.expressionTypeItem, 'The type of property this expression switches on:<br/> <b>Resource<\/b>: A resource property such as its name or version<br/> <b>Resource Type<\/b>: Search for resources of a specific type<br/> <b>Resource Category<\/b>: Search for resources by category: platform, server, service<br/> <b>Trait<\/b>: Resources that have selected values for a monitored trait<br/> <b>Plugin Configuration<\/b>: Search by the plugin component configuration setting of the component<br/> <b>Resource Configuration<\/b>: Search by the configuration setting of the managed resource');
  $setHoverWidth_0(this.expressionTypeItem, valueOf_44(250));
  $setRedrawOnChange(this.expressionTypeItem);
  $setWidth_2(this.expressionTypeItem, '*');
  $setDefaultToFirstOption_0(this.expressionTypeItem, TRUE);
  $setValueMap_2(this.expressionTypeItem, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['Resource', 'Resource Type', 'Resource Category', 'Trait', 'Plugin Configuration', 'Resource Configuration']));
  $addChangedHandler(this.expressionTypeItem, new GroupDefinitionExpressionBuilder$9_0(this));
  this.resourceItem = new SortedSelectItem_2('resource', 'Resource');
  $setPrompt_1(this.resourceItem, 'Choose the level of the resource you wish to select. For example, select "parent" will find resources whose parent resource matches the rest of the expression.');
  $setHoverWidth_0(this.resourceItem, valueOf_44(250));
  $setRedrawOnChange(this.resourceItem);
  $setWidth_2(this.resourceItem, '*');
  $setDefaultToFirstOption_0(this.resourceItem, TRUE);
  $setValueMap_2(this.resourceItem, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['Resource', 'Child', 'Parent', 'Grandparent', 'GreatGrandparent', 'GreatGreatGrandparent']));
  $addChangedHandler(this.resourceItem, new GroupDefinitionExpressionBuilder$10_0(this));
  this.memberOfItem = new RadioGroupItem_2('memberOf', 'Member of');
  $setPrompt_1(this.memberOfItem, 'memberof will restrict the dynagroup members to be a subset of the specified resource group. Specifying multiple memberof conditions will restrict the dynagroup members to be a subset of the union of members of the specified groups.');
  $setHoverWidth_0(this.memberOfItem, valueOf_44(250));
  $setDefaultValue_1(this.memberOfItem, 'No');
  $setValueMap_0(this.memberOfItem, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['Yes', 'No']));
  $setAttribute_29(this.memberOfItem, 'vertical', FALSE);
  $addChangedHandler(this.memberOfItem, new GroupDefinitionExpressionBuilder$11_0(this));
  this.memberOfGroupItem = new SingleResourceGroupSelectorItem_0;
  $setPrompt_1(this.memberOfGroupItem, 'GroupBy will cause the system to pivot on the values from the entered expressions creating a separate group for each value. For example, GroupBy on the cluster name to create a group for each cluster with all cluster members in it.');
  $setHoverWidth_0(this.memberOfGroupItem, valueOf_44(250));
  $setRedrawOnChange(this.memberOfGroupItem);
  $setWidth_2(this.memberOfGroupItem, '*');
  $setDefaultToFirstOption(this.memberOfGroupItem, TRUE);
  $addChangedHandler(this.memberOfGroupItem, new GroupDefinitionExpressionBuilder$12_0(this));
  this.groupByItem = new RadioGroupItem_2('groupBy', 'Group by');
  $setPrompt_1(this.groupByItem, 'GroupBy will cause the system to pivot on the values from the entered expressions creating a separate group for each value. For example, GroupBy on the cluster name to create a group for each cluster with all cluster members in it.');
  $setHoverWidth_0(this.groupByItem, valueOf_44(250));
  $setDefaultValue_1(this.groupByItem, 'No');
  $setValueMap_0(this.groupByItem, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['Yes', 'No']));
  $setAttribute_29(this.groupByItem, 'vertical', FALSE);
  $addChangedHandler(this.groupByItem, new GroupDefinitionExpressionBuilder$13_0(this));
  this.expressionItem = new TextAreaItem_2('expression', 'Expression');
  $setPrompt_1(this.expressionItem, 'This is the full expression that is represented by the selections in the form below. This text will be added to your group definition expression text when you click the "Add Expression" button.');
  $setHoverWidth_0(this.expressionItem, valueOf_44(250));
  $setAttribute_27(this.expressionItem, 'height', 75);
  $setWidth_2(this.expressionItem, '250');
  $addChangeHandler(this.expressionItem, new GroupDefinitionExpressionBuilder$14_0);
  addButton = new ButtonItem_1('add', 'Add Expression');
  $isCreated_2(addButton)?$setProperty_6(addButton, 'colSpan', 2):(addButton.jsObj['colSpan'] = 2 , undefined);
  $setAttribute_30(addButton, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setStartRow_1(addButton, TRUE);
  $setEndRow_1(addButton, TRUE);
  $addClickHandler_1(addButton, new GroupDefinitionExpressionBuilder$15_0(this));
  closeButton = new ButtonItem_1('close', 'Close');
  $isCreated_2(closeButton)?$setProperty_6(closeButton, 'colSpan', 2):(closeButton.jsObj['colSpan'] = 2 , undefined);
  $setAttribute_30(closeButton, 'align', CENTER_0.value_0);
  $addClickHandler_1(closeButton, new GroupDefinitionExpressionBuilder$16_0(this));
  $setStartRow_1(closeButton, TRUE);
  $setEndRow_1(closeButton, TRUE);
  form = new DynamicForm_0;
  $setWrapItemTitles(form, FALSE);
  $isCreated_1(form)?$setProperty_0(form, 'width', 1):(form.config_0['width'] = 1 , undefined);
  $isCreated_1(form)?$setProperty_0(form, 'height', 1):(form.config_0['height'] = 1 , undefined);
  $isCreated_1(form)?$setProperty_0(form, 'cellPadding', 5):(form.config_0['cellPadding'] = 5 , undefined);
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.expressionItem, this.memberOfItem, this.memberOfGroupItem, this.groupByItem, this.resourceItem, this.expressionTypeItem, this.pluginItem, this.resourceTypeItem, this.propertyNameItem, this.unsetItem, this.compareTypeItem, this.valueItem, addButton, closeButton]));
  layout = new EnhancedVLayout_0;
  $setLayoutMargin(layout, valueOf_44(5));
  $isCreated_1(layout)?$setProperty_0(layout, 'height', 1):(layout.config_0['height'] = 1 , undefined);
  $isCreated_1(layout)?$setProperty_0(layout, 'width', 1):(layout.config_0['width'] = 1 , undefined);
  $addMember(layout, form);
  $addItem(this, layout);
  $enableDisableComponents(this);
}
;
_.addExpressionHandler = null;
_.compareTypeItem = null;
_.expressionItem = null;
_.expressionTypeItem = null;
_.groupByItem = null;
_.memberOfGroupItem = null;
_.memberOfItem = null;
_.pluginItem = null;
_.propertyNameItem = null;
_.resourceItem = null;
_.resourceTypeItem = null;
_.unsetItem = null;
_.valueItem = null;
function GroupDefinitionExpressionBuilder$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2998, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), GroupDefinitionExpressionBuilder$1_0);
_.onCloseClick_0 = function onCloseClick_13(event_0){
  $markForDestroy(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$10_0(this$0){
  this.this$0 = this$0;
}

defineSeed(2999, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$10_0);
_.onChanged = function onChanged_56(event_0){
  $buildExpressionValue(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$11_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3000, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$11_0);
_.onChanged = function onChanged_57(event_0){
  $enableDisableComponents(this.this$0);
  $buildExpressionValue(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$12_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3001, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$12_0);
_.onChanged = function onChanged_58(event_0){
  $buildExpressionValue(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$13_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3002, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$13_0);
_.onChanged = function onChanged_59(event_0){
  $enableDisableComponents(this.this$0);
  $buildExpressionValue(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$14_0(){
}

defineSeed(3003, 1, makeCastMap([Q$EventHandler, Q$ChangeHandler]), GroupDefinitionExpressionBuilder$14_0);
_.onChange = function onChange_9(event_0){
  event_0.cancel = true;
}
;
function GroupDefinitionExpressionBuilder$15_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3004, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), GroupDefinitionExpressionBuilder$15_0);
_.onClick_0 = function onClick_128(event_0){
  $addExpression(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$16_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3005, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), GroupDefinitionExpressionBuilder$16_0);
_.onClick_0 = function onClick_129(event_0){
  $markForDestroy(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_264(this$static, result){
  var type, type$iterator, typeNames;
  this$static.this$0.resourceTypeIds.clear_0();
  if (!!result && result.size_0 != 0) {
    typeNames = new ArrayList_0;
    for (type$iterator = new AbstractList$IteratorImpl_0(result); type$iterator.i < type$iterator.this$0_0.size_1();) {
      type = dynamicCast($next_0(type$iterator), Q$ResourceType);
      $add_3(typeNames, type.name_0);
      this$static.this$0.resourceTypeIds.put(type.name_0, valueOf_44(type.id));
    }
    $setValueMap_2(this$static.this$0.resourceTypeItem, dynamicCast($toArray_1(typeNames, initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, typeNames.size_0, 0)), Q$String_$1));
  }
   else {
    $setValueMap_2(this$static.this$0.resourceTypeItem, initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, 0, 0));
  }
  $clearValue_0(this$static.this$0.resourceTypeItem);
  $loadPropertyNameDropDown(this$static.this$0);
  $markForRedraw(this$static.this$0);
}

function GroupDefinitionExpressionBuilder$17_0(this$0, val$newPlugin){
  this.this$0 = this$0;
  this.val$newPlugin = val$newPlugin;
}

defineSeed(3006, 1, {}, GroupDefinitionExpressionBuilder$17_0);
_.onFailure = function onFailure_275(caught){
  $handleError_0(($clinit_CoreGUI() , 'Cannot get list of resource types for plugin [' + this.val$newPlugin + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_275(result){
  $onSuccess_264(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$newPlugin = null;
function $onSuccess_265(this$static, result){
  !!result && this$static.this$0.propertyNameItem.setValueMap_1(dynamicCast($toArray_1(result, initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, result.size_0, 0)), Q$String_$1));
  $clearValue_0(this$static.this$0.propertyNameItem);
  $buildExpressionValue(this$static.this$0);
  $markForRedraw(this$static.this$0);
}

function GroupDefinitionExpressionBuilder$18_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3007, 1, {}, GroupDefinitionExpressionBuilder$18_0);
_.onFailure = function onFailure_276(caught){
  $handleError_0(($clinit_CoreGUI() , 'Cannot get list of properties'), caught);
}
;
_.onSuccess_0 = function onSuccess_276(result){
  $onSuccess_265(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$0 = null;
function $onSuccess_266(this$static, result){
  !!result && this$static.this$0.propertyNameItem.setValueMap_1(dynamicCast($toArray_1(result, initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, result.size_0, 0)), Q$String_$1));
  $clearValue_0(this$static.this$0.propertyNameItem);
  $buildExpressionValue(this$static.this$0);
  $markForRedraw(this$static.this$0);
}

function GroupDefinitionExpressionBuilder$19_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3008, 1, {}, GroupDefinitionExpressionBuilder$19_0);
_.onFailure = function onFailure_277(caught){
  $handleError_0(($clinit_CoreGUI() , 'Cannot get list of properties'), caught);
}
;
_.onSuccess_0 = function onSuccess_277(result){
  $onSuccess_266(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3009, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$2_0);
_.onChanged = function onChanged_60(event_0){
  $buildExpressionValue(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_267(this$static, result){
  !!result && this$static.this$0.propertyNameItem.setValueMap_1(dynamicCast($toArray_1(result, initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, result.size_0, 0)), Q$String_$1));
  $clearValue_0(this$static.this$0.propertyNameItem);
  $buildExpressionValue(this$static.this$0);
  $markForRedraw(this$static.this$0);
}

function GroupDefinitionExpressionBuilder$20_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3010, 1, {}, GroupDefinitionExpressionBuilder$20_0);
_.onFailure = function onFailure_278(caught){
  $handleError_0(($clinit_CoreGUI() , 'Cannot get list of properties'), caught);
}
;
_.onSuccess_0 = function onSuccess_278(result){
  $onSuccess_267(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3011, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$3_0);
_.onChanged = function onChanged_61(event_0){
  $buildExpressionValue(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3012, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$4_0);
_.onChanged = function onChanged_62(event_0){
  $enableDisableComponents(this.this$0);
  $buildExpressionValue(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3013, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$5_0);
_.onChanged = function onChanged_63(event_0){
  $buildExpressionValue(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3014, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$6_0);
_.onChanged = function onChanged_64(event_0){
  $loadPropertyNameDropDown(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3015, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$7_0);
_.onChanged = function onChanged_65(event_0){
  var newValue;
  newValue = $getValue_2(event_0);
  newValue != null && $loadResourceTypeDropDown(this.this$0, toString__devirtual$(newValue));
}
;
_.this$0 = null;
function $onSuccess_268(this$static, result){
  var plugin, plugin$iterator;
  $clear_2(this$static.this$0.plugins);
  for (plugin$iterator = new AbstractList$IteratorImpl_0(result); plugin$iterator.i < plugin$iterator.this$0_0.size_1();) {
    plugin = dynamicCast($next_0(plugin$iterator), Q$Plugin);
    plugin.enabled && $add_3(this$static.this$0.plugins, plugin.name_0);
  }
  sort_0(this$static.this$0.plugins);
  $setValueMap_2(this$static.this$0.pluginItem, dynamicCast($toArray_1(this$static.this$0.plugins, initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, this$static.this$0.plugins.size_0, 0)), Q$String_$1));
  $clearValue_0(this$static.this$0.pluginItem);
  this$static.this$0.plugins.size_0 == 0 || $loadResourceTypeDropDown(this$static.this$0, dynamicCast($get_0(this$static.this$0.plugins, 0), Q$String));
  $markForRedraw(this$static.this$0);
}

function GroupDefinitionExpressionBuilder$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3016, 1, {}, GroupDefinitionExpressionBuilder$8_0);
_.onFailure = function onFailure_279(caught){
  $handleError_0(($clinit_CoreGUI() , 'Cannot get the list of plugins'), caught);
}
;
_.onSuccess_0 = function onSuccess_279(result){
  $onSuccess_268(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$0 = null;
function GroupDefinitionExpressionBuilder$9_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3017, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupDefinitionExpressionBuilder$9_0);
_.onChanged = function onChanged_66(event_0){
  $enableDisableComponents(this.this$0);
  $loadPropertyNameDropDown(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionListView_0(){
  $clinit_BaseWidget();
  TableSection_0.call(this, null);
  $setDataSource(this, ($clinit_RPCDataSource() , !INSTANCE_38 && (INSTANCE_38 = new GroupDefinitionDataSource_0) , $clinit_RPCDataSource() , INSTANCE_38));
  this.escapeHtmlInDetailsLinkColumn = true;
}

defineSeed(3018, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), GroupDefinitionListView_0);
_.configureTable = function configureTable_43(){
  var descriptionField, expressionField, idField, lastCalculationTimeField, nameField, nextCalculationTimeField;
  idField = new ListGridField_3('id', ($clinit_Enhanced() , 'ID'));
  $setAttribute_13(idField, 'type', ($clinit_ListGridFieldType() , INTEGER_0).value_0);
  idField.jsObj['width'] = 50;
  nameField = new ListGridField_4('name', 'Name', 150);
  $setCellFormatter_0(nameField, new EscapedHtmlCellFormatter_0);
  descriptionField = new ListGridField_3('description', 'Description');
  $setCellFormatter_0(descriptionField, new EscapedHtmlCellFormatter_0);
  expressionField = new ListGridField_4('expression', 'Expression Set', 250);
  $setCellFormatter_0(expressionField, new GroupDefinitionListView$1_0);
  lastCalculationTimeField = new ListGridField_4('lastCalculationTime', 'Last Calculation Time', 175);
  $setCellFormatter_0(lastCalculationTimeField, new GroupDefinitionListView$2_0);
  $setAttribute_8(lastCalculationTimeField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(lastCalculationTimeField, new GroupDefinitionListView$3_0);
  nextCalculationTimeField = new ListGridField_4('nextCalculationTime', 'Next Calculation Time', 175);
  $setCellFormatter_0(nextCalculationTimeField, new GroupDefinitionListView$4_0);
  $setAttribute_8(nextCalculationTimeField, 'showHover', TRUE);
  $setHoverCustomizer_0(nextCalculationTimeField, new GroupDefinitionListView$5_0);
  $setListGridFields(this, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, nameField, descriptionField, expressionField, lastCalculationTimeField, nextCalculationTimeField]));
  $addTableAction(this, 'Delete', 'Are You Sure?', null, new GroupDefinitionListView$6_0(this, ($clinit_TableActionEnablement() , ANY_1)));
  $addTableAction(this, 'New', null, null, new GroupDefinitionListView$7_0(this));
  $addTableAction(this, 'Recalculate', null, null, new GroupDefinitionListView$8_0(this, ANY_1));
  $configureTable(this);
}
;
_.getDetailsView_0 = function getDetailsView_22(id){
  var singleGroupDefinitionView;
  singleGroupDefinitionView = new SingleGroupDefinitionView_0;
  return singleGroupDefinitionView;
}
;
_.renderView = function renderView_24(viewPath){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new GroupDefinitionListView$9_0(this, viewPath)));
}
;
function GroupDefinitionListView$1_0(){
}

defineSeed(3019, 1, {}, GroupDefinitionListView$1_0);
_.format_1 = function format_57(value, record, rowNum, colNum){
  return $replaceAll(toString__devirtual$(value), '\\n', '<br/>');
}
;
function GroupDefinitionListView$2_0(){
  $clinit_TimestampCellFormatter();
  TimestampCellFormatter_0.call(this);
}

defineSeed(3020, 2388, {}, GroupDefinitionListView$2_0);
_.format_1 = function format_58(value, record, rowNum, colNum){
  if (value == null) {
    return $clinit_Enhanced() , 'Never';
  }
  return format_30(value, this.dateTimeFormat);
}
;
function GroupDefinitionListView$3_0(){
}

defineSeed(3021, 1, {}, GroupDefinitionListView$3_0);
_.hoverHTML_0 = function hoverHTML_28(value, record, rowNum, colNum){
  var attribValue;
  attribValue = getAttribute(record.jsObj, 'lastCalculationTime');
  return attribValue != null?getHoverDateString(new Date_2((new Long_0(__parseAndValidateLong(attribValue))).value_0)):null;
}
;
function GroupDefinitionListView$4_0(){
  $clinit_TimestampCellFormatter();
  TimestampCellFormatter_0.call(this);
}

defineSeed(3022, 2388, {}, GroupDefinitionListView$4_0);
_.format_1 = function format_59(value, record, rowNum, colNum){
  if (value == null || $equals_6('0', toString__devirtual$(value))) {
    return $clinit_Enhanced() , 'N/A';
  }
  return format_30(value, this.dateTimeFormat);
}
;
function GroupDefinitionListView$5_0(){
}

defineSeed(3023, 1, {}, GroupDefinitionListView$5_0);
_.hoverHTML_0 = function hoverHTML_29(value, record, rowNum, colNum){
  var attribValue;
  attribValue = getAttribute(record.jsObj, 'nextCalculationTime');
  return attribValue != null && !$equals_6('0', attribValue)?getHoverDateString(new Date_2((new Long_0(__parseAndValidateLong(attribValue))).value_0)):null;
}
;
function GroupDefinitionListView$6_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3024, 1608, {}, GroupDefinitionListView$6_0);
_.executeAction = function executeAction_57(selection, actionValue){
  var groupDefinitionIds, groupManager;
  groupDefinitionIds = getIds_0(selection);
  groupManager = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), 60000), Q$ResourceGroupGWTServiceAsync);
  $deleteGroupDefinitions(groupManager, groupDefinitionIds, new GroupDefinitionListView$6$1_0(this, groupDefinitionIds));
}
;
_.this$0 = null;
function $onSuccess_269(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully deleted [' + ($clinit_Enhanced() , '' + this$static.val$groupDefinitionIds.length) + '] group definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$1.this$0, false);
}

function GroupDefinitionListView$6$1_0(this$1, val$groupDefinitionIds){
  this.this$1 = this$1;
  this.val$groupDefinitionIds = val$groupDefinitionIds;
}

defineSeed(3025, 1, {}, GroupDefinitionListView$6$1_0);
_.onFailure = function onFailure_280(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete the selected group definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_280(result){
  $onSuccess_269(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$groupDefinitionIds = null;
function GroupDefinitionListView$7_0(this$0){
  this.this$0 = this$0;
  AbstractTableAction_0.call(this);
}

defineSeed(3026, 1608, {}, GroupDefinitionListView$7_0);
_.executeAction = function executeAction_58(selection, actionValue){
  $newDetails(this.this$0);
}
;
_.this$0 = null;
function GroupDefinitionListView$8_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3027, 1608, {}, GroupDefinitionListView$8_0);
_.executeAction = function executeAction_59(selection, actionValue){
  var groupDefinitionIds, resourceGroupManager;
  groupDefinitionIds = getIds_0(selection);
  resourceGroupManager = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
  $recalculateGroupDefinitions(resourceGroupManager, groupDefinitionIds, new GroupDefinitionListView$8$1_0(this, groupDefinitionIds));
}
;
_.this$0 = null;
function $onSuccess_270(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully recalculated [' + ($clinit_Enhanced() , '' + this$static.val$groupDefinitionIds.length) + '] group definitions', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$1.this$0, false);
}

function GroupDefinitionListView$8$1_0(this$1, val$groupDefinitionIds){
  this.this$1 = this$1;
  this.val$groupDefinitionIds = val$groupDefinitionIds;
}

defineSeed(3028, 1, {}, GroupDefinitionListView$8$1_0);
_.onFailure = function onFailure_281(caught){
  instanceOf(caught, Q$DuplicateExpressionTypeException)?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(caught.getMessage(), ($clinit_Message$Severity() , Warning))):$handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to recalculate the selected group definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_281(result){
  $onSuccess_270(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$groupDefinitionIds = null;
function GroupDefinitionListView$9_0(this$0, val$viewPath){
  this.this$0 = this$0;
  this.val$viewPath = val$viewPath;
}

defineSeed(3029, 1, {}, GroupDefinitionListView$9_0);
_.onPermissionsLoaded = function onPermissionsLoaded_12(permissions){
  !!permissions && permissions.contains_0(($clinit_Permission() , MANAGE_INVENTORY))?$renderView_0(this.this$0, this.val$viewPath):($handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'You do not have permission to view group definitions'), null) , back_0());
}
;
_.this$0 = null;
_.val$viewPath = null;
function $clinit_SingleGroupDefinitionView(){
  $clinit_SingleGroupDefinitionView = nullMethod;
  $clinit_BaseWidget();
  TEMPLATE_JBOSSAS4_CLUSTERS = ($clinit_Enhanced() , 'JBossAS 4 - Clusters');
  TEMPLATE_JBOSSAS5_CLUSTERS = 'JBossAS 5/6 - Clusters';
  TEMPLATE_JBOSSAS4_EAR_CLUSTERS = 'JBossAS 4 - Clustered EARs';
  TEMPLATE_JBOSSAS4_UNIQUE_VERSIONS = 'JBossAS 4 - Unique versions';
  TEMPLATE_PLATFORMS = 'Platform resources in inventory';
  TEMPLATE_UNIQUE_RESOURCE_TYPES = 'Unique resource types in inventory';
  TEMPLATE_JBOSSAS4_HOSTING_APP = 'JBossAS 4 - All hosting any version of "my" app';
  TEMPLATE_JBOSSAS4_NONSECURED = 'JBossAS 4 - All non-secured';
  TEMPLATE_DOWNED_RESOURCES = 'All resources currently down';
}

function $buildForm_5(this$static){
  var expressionBuilderIcon, items;
  expressionBuilderIcon = new FormItemIcon_0;
  expressionBuilderIcon.jsObj['src'] = '[SKIN]/actions/add.png';
  $setAttribute_13(expressionBuilderIcon, 'prompt', ($clinit_Enhanced() , 'Expression Builder...'));
  $addFormItemClickHandler(expressionBuilderIcon, new SingleGroupDefinitionView$6_0(this$static));
  this$static.id = new TextItem_3('id', 'ID');
  $setVisible(this$static.id, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  this$static.name_0 = new TextItem_3('name', 'Name');
  $setWidth_3(this$static.name_0, 400);
  $setDefaultValue_1(this$static.name_0, '');
  this$static.description = new TextAreaItem_2('description', 'Description');
  $setAttribute_27(this$static.description, 'width', 400);
  $setAttribute_27(this$static.description, 'height', 50);
  $setDefaultValue_1(this$static.description, '');
  this$static.recursive = new CheckboxItem_2('recursive', 'Recursive');
  this$static.templateSelectorTitleSpacer = new SpacerItem_0;
  this$static.templateSelectorTitleSpacer.setShowTitle(FALSE);
  this$static.templateSelectorTitleSpacer.setColSpan(1);
  this$static.templateSelectorTitleSpacer.setEndRow(FALSE);
  this$static.templateSelector = new SelectItem_2('templateSelector', 'Saved Expression');
  this$static.templateStrings = (items = new LinkedHashMap_0 , $put_1(items, TEMPLATE_JBOSSAS4_CLUSTERS, buildTemplate(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['groupby resource.trait[partitionName]', 'resource.type.plugin = JBossAS', 'resource.type.name = JBossAS Server']))) , $put_1(items, TEMPLATE_JBOSSAS5_CLUSTERS, buildTemplate(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['groupby resource.trait[MCBean|ServerConfig|*|partitionName]', 'resource.type.plugin = JBossAS5', 'resource.type.name = JBossAS Server']))) , $put_1(items, TEMPLATE_JBOSSAS4_EAR_CLUSTERS, buildTemplate(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['groupby resource.parent.trait[partitionName]', 'groupby resource.name', 'resource.type.plugin = JBossAS', 'resource.type.name = Enterprise Application (EAR)']))) , $put_1(items, TEMPLATE_JBOSSAS4_UNIQUE_VERSIONS, buildTemplate(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['groupby resource.trait[jboss.system:type=Server:VersionName]', 'resource.type.plugin = JBossAS', 'resource.type.name = JBossAS Server']))) , $put_1(items, TEMPLATE_PLATFORMS, buildTemplate(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['resource.type.category = PLATFORM', 'groupby resource.name']))) , $put_1(items, TEMPLATE_UNIQUE_RESOURCE_TYPES, buildTemplate(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['groupby resource.type.plugin', 'groupby resource.type.name']))) , $put_1(items, TEMPLATE_JBOSSAS4_HOSTING_APP, buildTemplate(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['resource.type.plugin = JBossAS', 'resource.type.name = JBossAS Server', 'resource.child.name.contains = my']))) , $put_1(items, TEMPLATE_JBOSSAS4_NONSECURED, buildTemplate(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['empty resource.pluginConfiguration[principal]', 'resource.type.plugin = JBossAS', 'resource.type.name = JBossAS Server']))) , $put_1(items, TEMPLATE_DOWNED_RESOURCES, buildTemplate(initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['resource.availability = DOWN']))) , items);
  this$static.templateSelector.setValueMap_1(dynamicCast($keySet(this$static.templateStrings).toArray_0(initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, this$static.templateStrings.map.size_1(), 0)), Q$String_$1));
  $setAllowEmptyValue(this$static.templateSelector, TRUE);
  $setWidth_1(this$static.templateSelector, 300);
  $setColSpan(this$static.templateSelector, 1);
  $setEndRow_0(this$static.templateSelector, TRUE);
  $setStartRow_0(this$static.templateSelector, FALSE);
  $setIcons(this$static.templateSelector, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [expressionBuilderIcon]));
  $setHoverWidth_0(this$static.templateSelector, valueOf_44(200));
  this$static.expression = new TextAreaItem_2('expression', 'Expression');
  $setAttribute_27(this$static.expression, 'width', 400);
  $setAttribute_27(this$static.expression, 'height', 150);
  $setDefaultValue_1(this$static.expression, '');
  $addChangedHandler(this$static.expression, new SingleGroupDefinitionView$7_0(this$static));
  if (this$static.builder) {
    $destroy(this$static.builder);
    this$static.builder = null;
  }
  $addChangedHandler(this$static.templateSelector, new SingleGroupDefinitionView$8_0(this$static));
  this$static.recalculationInterval = new SpinnerItem_1('recalculationInterval', 'Recalculation Interval (min)');
  $setAttribute_11(this$static.recalculationInterval, 'min', valueOf_44(0));
  $setAttribute_11(this$static.recalculationInterval, 'max', valueOf_44(10080));
  $setAttribute_11(this$static.recalculationInterval, 'defaultValue', valueOf_44(0));
  $setAttribute_27(this$static.recalculationInterval, 'step', 1);
}

function $lookupDetails(this$static, groupDefinitionId){
  var criteria, newGroupDefinition;
  criteria = new ResourceGroupDefinitionCriteria_0;
  $addFilterId(criteria, valueOf_44(groupDefinitionId));
  if (groupDefinitionId == 0) {
    newGroupDefinition = new GroupDefinition_0;
    $setGroupDefinition(this$static, newGroupDefinition);
    $switchToEditMode_0(this$static);
  }
   else {
    $findGroupDefinitionsByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), criteria, new SingleGroupDefinitionView$9_0(this$static, groupDefinitionId));
  }
}

function $recalculate(dynaGroupChildrenView, groupDefId){
  $recalculateGroupDefinitions(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), 600000), Q$ResourceGroupGWTServiceAsync), initValues(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [groupDefId]), new SingleGroupDefinitionView$5_0(dynaGroupChildrenView));
}

function $saveForm(this$static, form, dynaGroupChildrenView, recalc){
  form.validate_0() && $saveData(form, new SingleGroupDefinitionView$4_0(this$static, form, recalc, dynaGroupChildrenView));
}

function $setGroupDefinition(this$static, groupDefinition){
  var buttonLayout, dynaGroupChildrenView, form, recalculateButton, resetButton, saveButton, saveOperationType;
  this$static.groupDefinition = groupDefinition;
  $setValue_5(this$static.id, groupDefinition.id);
  $setValue_7(this$static.name_0, groupDefinition.name_0);
  $setValue_9(this$static.recursive, groupDefinition.recursive);
  $setValue_7(this$static.description, groupDefinition.description);
  $setValue_4(this$static.recalculationInterval, toDouble(div(valueOf_45(groupDefinition.recalculationInterval).value_0, Pea60_longLit)));
  $setValue_7(this$static.expression, groupDefinition.expression);
  form = new DynamicForm_0;
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this$static.id, this$static.name_0, this$static.description, this$static.templateSelectorTitleSpacer, this$static.templateSelector, this$static.expression, this$static.recursive, this$static.recalculationInterval]));
  $setAttribute_20(form, 'dataSource', $getOrCreateJsObj(($clinit_RPCDataSource() , !INSTANCE_38 && (INSTANCE_38 = new GroupDefinitionDataSource_0) , $clinit_RPCDataSource() , INSTANCE_38)), true);
  $setHiliteRequiredFields(form, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $isCreated_1(form)?$setProperty_3(form, 'requiredTitleSuffix', ' <span style="color: red;">* <\/span>:'):(form.config_0['requiredTitleSuffix'] = ' <span style="color: red;">* <\/span>:' , undefined);
  saveOperationType = groupDefinition.id == 0?($clinit_DSOperationType() , ADD):($clinit_DSOperationType() , UPDATE);
  $setAttribute_24(form, 'saveOperationType', saveOperationType.value_0, true);
  dynaGroupChildrenView = new SingleGroupDefinitionView$DynaGroupChildrenView_0(this$static);
  saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
  $addClickHandler(saveButton, new SingleGroupDefinitionView$1_0(this$static, form, dynaGroupChildrenView));
  recalculateButton = new EnhancedIButton_1('Save & Recalculate');
  $isCreated_1(recalculateButton)?$setProperty_0(recalculateButton, 'width', 150):(recalculateButton.config_0['width'] = 150 , undefined);
  $addClickHandler(recalculateButton, new SingleGroupDefinitionView$2_0(this$static, form, dynaGroupChildrenView));
  resetButton = new EnhancedIButton_1('Reset');
  $addClickHandler(resetButton, new SingleGroupDefinitionView$3_0(form));
  buttonLayout = new HLayout_1(10);
  $setMargin(buttonLayout, valueOf_44(10));
  $addMember(buttonLayout, saveButton);
  $addMember(buttonLayout, recalculateButton);
  $addMember(buttonLayout, resetButton);
  $addMember(this$static, form);
  $addMember(this$static, buttonLayout);
  $addMember(this$static, dynaGroupChildrenView);
  $markForRedraw(this$static);
}

function $showExpressionBuilder(this$static){
  !this$static.builder && (this$static.builder = new GroupDefinitionExpressionBuilder_0(new SingleGroupDefinitionView$10_0(this$static)));
  $show(this$static.builder);
}

function $switchToEditMode_0(this$static){
  $show_0(this$static.name_0);
  $show_0(this$static.description);
  $show_0(this$static.recursive);
  $show_0(this$static.templateSelectorTitleSpacer);
  $show_0(this$static.templateSelector);
  $show_0(this$static.expression);
  $show_0(this$static.recalculationInterval);
  $markForRedraw(this$static);
}

function SingleGroupDefinitionView_0(){
  $clinit_SingleGroupDefinitionView();
  EnhancedVLayout_0.call(this);
  $buildForm_5(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
}

function buildTemplate(pieces){
  var first, next, next$index, next$max, results;
  results = new StringBuilder_0;
  first = true;
  for (next$index = 0 , next$max = pieces.length; next$index < next$max; ++next$index) {
    next = pieces[next$index];
    first?(first = false):($appendNonNull(results.data_0, '\n') , results);
    $append_1(results.data_0, next);
  }
  return $toString_1(results.data_0);
}

defineSeed(3030, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), SingleGroupDefinitionView_0);
_.renderView = function renderView_25(viewPath){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new SingleGroupDefinitionView$11_0(this, viewPath)));
}
;
_.basePath = null;
_.builder = null;
_.description = null;
_.expression = null;
_.groupDefinition = null;
_.groupDefinitionId = 0;
_.id = null;
_.name_0 = null;
_.recalculationInterval = null;
_.recursive = null;
_.templateSelector = null;
_.templateSelectorTitleSpacer = null;
_.templateStrings = null;
var TEMPLATE_DOWNED_RESOURCES, TEMPLATE_JBOSSAS4_CLUSTERS, TEMPLATE_JBOSSAS4_EAR_CLUSTERS, TEMPLATE_JBOSSAS4_HOSTING_APP, TEMPLATE_JBOSSAS4_NONSECURED, TEMPLATE_JBOSSAS4_UNIQUE_VERSIONS, TEMPLATE_JBOSSAS5_CLUSTERS, TEMPLATE_PLATFORMS, TEMPLATE_UNIQUE_RESOURCE_TYPES;
function SingleGroupDefinitionView$1_0(this$0, val$form, val$dynaGroupChildrenView){
  this.this$0 = this$0;
  this.val$form = val$form;
  this.val$dynaGroupChildrenView = val$dynaGroupChildrenView;
}

defineSeed(3031, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), SingleGroupDefinitionView$1_0);
_.onClick = function onClick_130(clickEvent){
  $saveForm(this.this$0, this.val$form, this.val$dynaGroupChildrenView, false);
}
;
_.this$0 = null;
_.val$dynaGroupChildrenView = null;
_.val$form = null;
function $addExpression_0(this$static, newExpression){
  var currentExpression, value;
  currentExpression = '';
  value = $getValueAsString_0(this$static.this$0.expression);
  value != null && (currentExpression = value + '\n');
  $setValue_7(this$static.this$0.expression, currentExpression + newExpression);
  $clearValue_0(this$static.this$0.templateSelector);
}

function SingleGroupDefinitionView$10_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3032, 1, {}, SingleGroupDefinitionView$10_0);
_.this$0 = null;
function SingleGroupDefinitionView$11_0(this$0, val$viewPath){
  this.this$0 = this$0;
  this.val$viewPath = val$viewPath;
}

defineSeed(3033, 1, {}, SingleGroupDefinitionView$11_0);
_.onPermissionsLoaded = function onPermissionsLoaded_13(permissions){
  if (!!permissions && permissions.contains_0(($clinit_Permission() , MANAGE_INVENTORY))) {
    this.this$0.groupDefinitionId = $getCurrentAsInt(this.val$viewPath);
    this.this$0.basePath = $getPathToCurrent(this.val$viewPath);
    $lookupDetails(this.this$0, this.this$0.groupDefinitionId);
  }
   else {
    $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'You do not have permission to view group definitions'), null);
    back_0();
  }
}
;
_.this$0 = null;
_.val$viewPath = null;
function SingleGroupDefinitionView$2_0(this$0, val$form, val$dynaGroupChildrenView){
  this.this$0 = this$0;
  this.val$form = val$form;
  this.val$dynaGroupChildrenView = val$dynaGroupChildrenView;
}

defineSeed(3034, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), SingleGroupDefinitionView$2_0);
_.onClick = function onClick_131(clickEvent){
  $saveForm(this.this$0, this.val$form, this.val$dynaGroupChildrenView, true);
}
;
_.this$0 = null;
_.val$dynaGroupChildrenView = null;
_.val$form = null;
function SingleGroupDefinitionView$3_0(val$form){
  this.val$form = val$form;
}

defineSeed(3035, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), SingleGroupDefinitionView$3_0);
_.onClick = function onClick_132(clickEvent){
  var self_0;
  self_0 = this.val$form.getOrCreateJsObj();
  self_0.reset();
}
;
_.val$form = null;
function SingleGroupDefinitionView$4_0(this$0, val$form, val$recalc, val$dynaGroupChildrenView){
  this.this$0 = this$0;
  this.val$form = val$form;
  this.val$recalc = val$recalc;
  this.val$dynaGroupChildrenView = val$dynaGroupChildrenView;
}

defineSeed(3036, 1, {}, SingleGroupDefinitionView$4_0);
_.execute_2 = function execute_52(response, rawData, request){
  var entryObject, entryObject$iterator, errorValue, fieldKey, hasDuplicateNameError, newGroupDefinition, newRecord, results, thisEntry;
  hasDuplicateNameError = false;
  if ($isNewRecord(this.val$form).value_0) {
    results = $getData(response);
    if (results.length != 1) {
      for (entryObject$iterator = $getErrors(response).entrySet().iterator(); entryObject$iterator.hasNext();) {
        entryObject = entryObject$iterator.next_0();
        thisEntry = dynamicCast(entryObject, Q$Map$Entry);
        fieldKey = dynamicCast(thisEntry.getKey_0(), Q$String);
        if ($equals_6(fieldKey, 'name')) {
          errorValue = dynamicCast(thisEntry.getValue_1(), Q$String);
          $handleError_0(($clinit_CoreGUI() , errorValue), null);
          hasDuplicateNameError = true;
        }
      }
      hasDuplicateNameError || $handleError_0(($clinit_CoreGUI() , 'An error occurred - there should have been one created, but instead there were [' + ($clinit_Enhanced() , '' + results.length) + '] created'), null);
    }
     else {
      newRecord = results[0];
      newGroupDefinition = $copyValues_48(($clinit_RPCDataSource() , !INSTANCE_38 && (INSTANCE_38 = new GroupDefinitionDataSource_0) , newRecord));
      this.val$recalc && $recalculate(this.val$dynaGroupChildrenView, newGroupDefinition.id);
      $clinit_CoreGUI();
      goToView(this.this$0.basePath + '/' + newGroupDefinition.id, null, false);
    }
  }
   else {
    $refresh(this.val$dynaGroupChildrenView, false);
    this.val$recalc && $recalculate(this.val$dynaGroupChildrenView, this.this$0.groupDefinitionId);
  }
}
;
_.this$0 = null;
_.val$dynaGroupChildrenView = null;
_.val$form = null;
_.val$recalc = false;
function $onSuccess_271(this$static){
  $refresh(this$static.val$dynaGroupChildrenView, false);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have successfully recalculated this group definition'), ($clinit_Message$Severity() , Info)));
}

function SingleGroupDefinitionView$5_0(val$dynaGroupChildrenView){
  this.val$dynaGroupChildrenView = val$dynaGroupChildrenView;
}

defineSeed(3037, 1, {}, SingleGroupDefinitionView$5_0);
_.onFailure = function onFailure_282(caught){
  instanceOf(caught, Q$DuplicateExpressionTypeException)?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(caught.getMessage(), ($clinit_Message$Severity() , Warning))):$handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to recalculate this group definition'), caught);
}
;
_.onSuccess_0 = function onSuccess_282(result){
  $onSuccess_271(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$dynaGroupChildrenView = null;
function SingleGroupDefinitionView$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3038, 1, makeCastMap([Q$EventHandler, Q$FormItemClickHandler]), SingleGroupDefinitionView$6_0);
_.onFormItemClick = function onFormItemClick_4(event_0){
  $showExpressionBuilder(this.this$0);
}
;
_.this$0 = null;
function SingleGroupDefinitionView$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3039, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), SingleGroupDefinitionView$7_0);
_.onChanged = function onChanged_67(event_0){
  $clearValue_0(this.this$0.templateSelector);
}
;
_.this$0 = null;
function SingleGroupDefinitionView$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3040, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), SingleGroupDefinitionView$8_0);
_.onChanged = function onChanged_68(event_0){
  var selectedTemplate, selectedTemplateId;
  if ($getValue_2(event_0) != null) {
    selectedTemplateId = toString__devirtual$($getValue_2(event_0));
    selectedTemplate = dynamicCast($get_4(this.this$0.templateStrings, selectedTemplateId), Q$String);
    $setValue_7(this.this$0.expression, selectedTemplate != null?selectedTemplate:'');
  }
   else {
    $setValue_7(this.this$0.expression, '');
  }
}
;
_.this$0 = null;
function $onSuccess_272(this$static, result){
  var existingGroupDefinition;
  if (result.size_0 == 0) {
    $handleError_0(($clinit_CoreGUI() , 'There is no group definition with the ID of [' + ($clinit_Enhanced() , '' + this$static.val$groupDefinitionId) + ']'), null);
    back_0();
  }
   else {
    existingGroupDefinition = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$GroupDefinition);
    $setGroupDefinition(this$static.this$0, existingGroupDefinition);
    $switchToEditMode_0(this$static.this$0);
  }
}

function SingleGroupDefinitionView$9_0(this$0, val$groupDefinitionId){
  this.this$0 = this$0;
  this.val$groupDefinitionId = val$groupDefinitionId;
}

defineSeed(3041, 1, {}, SingleGroupDefinitionView$9_0);
_.onFailure = function onFailure_283(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load group definition [' + ($clinit_Enhanced() , '' + this.val$groupDefinitionId) + ']'), caught);
  back_0();
}
;
_.onSuccess_0 = function onSuccess_283(result){
  $onSuccess_272(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$groupDefinitionId = 0;
function SingleGroupDefinitionView$DynaGroupChildrenView_0(this$0){
  $clinit_BaseWidget();
  Table_3.call(this, ($clinit_Enhanced() , 'DynaGroup Children'), new Criteria_2('groupDefinitionId', '' + this$0.groupDefinition.id));
  $setDataSource(this, ($clinit_RPCDataSource() , !INSTANCE_4 && (INSTANCE_4 = new ResourceGroupsDataSource_0) , $clinit_RPCDataSource() , INSTANCE_4));
}

defineSeed(3042, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), SingleGroupDefinitionView$DynaGroupChildrenView_0);
_.configureTable = function configureTable_44(){
  var categoryField, categoryImages, descriptionField, idField, nameField, pluginNameField, typeNameField;
  idField = new ListGridField_3('id', ($clinit_Enhanced() , 'ID'));
  $setAttribute_13(idField, 'type', ($clinit_ListGridFieldType() , INTEGER_0).value_0);
  idField.jsObj['width'] = '50';
  nameField = new ListGridField_3(($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName, NAME_30.title_0);
  nameField.jsObj['width'] = '*';
  $setCellFormatter_0(nameField, new SingleGroupDefinitionView$DynaGroupChildrenView$1_0);
  descriptionField = new ListGridField_3(DESCRIPTION.propertyName, DESCRIPTION.title_0);
  descriptionField.jsObj['width'] = '300';
  $setCellFormatter_0(descriptionField, new EscapedHtmlCellFormatter_0);
  typeNameField = new ListGridField_3(TYPE_55.propertyName, TYPE_55.title_0);
  typeNameField.jsObj['width'] = '100';
  pluginNameField = new ListGridField_3(PLUGIN_1.propertyName, PLUGIN_1.title_0);
  pluginNameField.jsObj['width'] = '100';
  categoryField = new ListGridField_3(CATEGORY.propertyName, CATEGORY.title_0);
  categoryField.jsObj['width'] = '30';
  $setAttribute_13(categoryField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  categoryField.jsObj['title'] = '&nbsp;';
  $setAttribute_13(categoryField, 'type', ICON_0.value_0);
  categoryImages = new HashMap_1(2);
  categoryImages.put(($clinit_GroupCategory() , COMPATIBLE).name_0, getGroupIcon(COMPATIBLE));
  categoryImages.put(MIXED_0.name_0, getGroupIcon(MIXED_0));
  setAttribute_10(categoryField.jsObj, 'valueIcons', categoryImages);
  $setAttribute_8(categoryField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(categoryField, new SingleGroupDefinitionView$DynaGroupChildrenView$2_0);
  $setListGridFields(this, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, categoryField, nameField, descriptionField, typeNameField, pluginNameField]));
  $setListGridDoubleClickHandler(this, new SingleGroupDefinitionView$DynaGroupChildrenView$3_0);
}
;
function SingleGroupDefinitionView$DynaGroupChildrenView$1_0(){
}

defineSeed(3043, 1, {}, SingleGroupDefinitionView$DynaGroupChildrenView$1_0);
_.format_1 = function format_60(value, record, rowNum, colNum){
  var linkName, linkUrl;
  linkName = $getAttributeAsString(record, ($clinit_ResourceGroupDataSourceField() , NAME_30).propertyName);
  linkUrl = '#ResourceGroup/' + getAttributeAsInt(record.jsObj, 'id').value_0;
  return '<a href="' + linkUrl + '">' + escapeHtml(linkName) + '<\/a>';
}
;
function SingleGroupDefinitionView$DynaGroupChildrenView$2_0(){
}

defineSeed(3044, 1, {}, SingleGroupDefinitionView$DynaGroupChildrenView$2_0);
_.hoverHTML_0 = function hoverHTML_30(value, record, rowNum, colNum){
  var category;
  category = $getAttributeAsString(record, ($clinit_ResourceGroupDataSourceField() , CATEGORY).propertyName);
  if ($equals_6(($clinit_GroupCategory() , COMPATIBLE).name_0, category)) {
    return $clinit_Enhanced() , 'Compatible';
  }
   else if ($equals_6(MIXED_0.name_0, category)) {
    return $clinit_Enhanced() , 'Mixed';
  }
   else {
    throw new IllegalStateException_1('Unknown group category: ' + category);
  }
}
;
function SingleGroupDefinitionView$DynaGroupChildrenView$3_0(){
}

defineSeed(3045, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), SingleGroupDefinitionView$DynaGroupChildrenView$3_0);
_.onDoubleClick = function onDoubleClick_11(event_0){
  var groupUrl, listGrid, selectedRows;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    groupUrl = '#ResourceGroup/' + getAttributeAsInt(selectedRows[0].jsObj, 'id').value_0;
    $clinit_CoreGUI();
    goToView(groupUrl, null, false);
  }
}
;
function CustomResourceGroupTreeGrid_0(){
  TreeGrid_0.call(this);
}

defineSeed(3046, 575, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$TreeGrid]), CustomResourceGroupTreeGrid_0);
_.getIcon_0 = function getIcon_1(record, defaultState){
  var icon, node, open_0, resourceType;
  if (instanceOf(record, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode)) {
    node = dynamicCast(record, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode);
    if (getAttribute(node.jsObj, 'icon') != null) {
      return getAttribute(node.jsObj, 'icon');
    }
    if (!!dynamicCast(getAttributeAsObject(node.jsObj, 'resourceType'), Q$ResourceType) && !!dynamicCast(getAttributeAsObject(node.jsObj, 'key'), Q$ClusterKey) && !$equals_6(getAttribute(node.jsObj, 'parentId'), '__fakeRoot__')) {
      resourceType = dynamicCast(getAttributeAsObject(node.jsObj, 'resourceType'), Q$ResourceType);
      icon = getClusteredResourceIcon(resourceType.category);
      return icon;
    }
     else if ($equals_6(getAttribute(node.jsObj, 'parentId'), '__fakeRoot__') && !!dynamicCast(getAttributeAsObject(node.jsObj, 'resourceType'), Q$ResourceType) && !dynamicCast(getAttributeAsObject(node.jsObj, 'key'), Q$ClusterKey) || !$equals_6(getAttribute(node.jsObj, 'parentId'), '__fakeRoot__') && !!dynamicCast(getAttributeAsObject(node.jsObj, 'resourceType'), Q$ResourceType) && !dynamicCast(getAttributeAsObject(node.jsObj, 'key'), Q$ClusterKey)) {
      open_0 = $isOpen(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this, 'data')), dynamicCast(record, Q$TreeNode)).value_0;
      return 'resources/folder_group_' + (open_0?'opened':'closed') + '.png';
    }
    open_0 = $isOpen(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this, 'data')), dynamicCast(record, Q$TreeNode)).value_0;
    return 'resources/folder_' + (open_0?'opened':'closed') + '.png';
  }
  return null;
}
;
function $buildIndividualGraph(this$static, measurementDefinition){
  var graph, graphView, metricGraphData;
  metricGraphData = ($clinit_MetricGraphData() , new MetricGraphData_1(this$static.resourceGroup.id, this$static.resourceGroup.name_0, measurementDefinition));
  graph = new StackedBarMetricGraphIE8Impl_0;
  graph.metricGraphData = metricGraphData;
  graphView = new MetricD3GraphView_1(graph);
  $isCreated_1(graphView)?$setProperty_3(graphView, 'width', '95%'):(graphView.config_0['width'] = '95%' , undefined);
  $isCreated_1(graphView)?$setProperty_0(graphView, 'height', 195):(graphView.config_0['height'] = 195 , undefined);
  !!this$static.graphsVLayout && this$static.graphsVLayout.addMember_0(graphView);
}

function $onDraw_3(this$static){
  destroyMembers(this$static);
  $addMember(this$static, this$static.measurementRangeEditor);
  if (this$static.showAvailabilityGraph) {
    this$static.availabilityGraph = new AvailabilityD3Graph_0(new AvailabilityLineGraphType_0(valueOf_44(this$static.resourceGroup.id)));
    $createGraphMarker(this$static.availabilityGraph);
    $addMember(this$static, this$static.availabilityGraph);
  }
  this$static.graphsVLayout = new VLayout_0;
  this$static.graphsVLayout.setOverflow(($clinit_Overflow() , AUTO));
  $setAttribute_24(this$static.graphsVLayout, 'width', '100%', true);
  !!this$static.resourceGroup && ($queryAvailability(this$static, forGroup_0(this$static.resourceGroup), $getStartTime(this$static.measurementRangeEditor), $getEndTime(this$static.measurementRangeEditor)) , $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(this$static.resourceGroup.resourceType.id), of(($clinit_ResourceTypeRepository$MetadataType() , measurements_0)), new D3GroupGraphListView$1_0(this$static)));
  $addMember(this$static, this$static.graphsVLayout);
}

function $queryAvailability(this$static, groupContext, startTime, endTime){
  var timerStart;
  timerStart = fromDouble(currentTimeMillis0());
  $getAvailabilitiesForResourceGroup(dynamicCast(secure(getInstance_35(), -1), Q$AvailabilityGWTServiceAsync), groupContext.groupId, startTime.value_0, endTime.value_0, new D3GroupGraphListView$2_0(this$static, timerStart));
}

function $redrawGraphs(this$static){
  $onDraw_3(this$static);
  $drawJsniChart(this$static.availabilityGraph.availabilityGraphType);
}

function D3GroupGraphListView_0(resourceGroup){
  $clinit_AbstractD3GraphListView();
  AbstractD3GraphListView_0.call(this);
  this.resourceGroup = resourceGroup;
  this.showAvailabilityGraph = true;
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , HIDDEN).value_0, false);
}

defineSeed(3047, 2906, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$D3GroupGraphListView, Q$Enhanced]), D3GroupGraphListView_0);
_.onDraw_0 = function onDraw_39(){
  $onDraw_3(this);
}
;
_.redrawGraphs = function redrawGraphs(){
  $redrawGraphs(this);
}
;
_.graphsVLayout = null;
_.resourceGroup = null;
function D3GroupGraphListView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3048, 1, {}, D3GroupGraphListView$1_0);
_.onTypesLoaded = function onTypesLoaded_18(type){
  var def, def$iterator, i, measDefIdArray, measurementDefinitions;
  measurementDefinitions = new ArrayList_0;
  for (def$iterator = type.metricDefinitions.iterator(); def$iterator.hasNext();) {
    def = dynamicCast(def$iterator.next_0(), Q$MeasurementDefinition);
    def.dataType == ($clinit_DataType() , MEASUREMENT) && def.displayType == ($clinit_DisplayType() , SUMMARY_0) && (setCheck(measurementDefinitions.array, measurementDefinitions.size_0++, def) , true);
  }
  sort_1(measurementDefinitions, new D3GroupGraphListView$1$1_0);
  measDefIdArray = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, measurementDefinitions.size_0, 1);
  for (i = 0; i < measDefIdArray.length; ++i) {
    measDefIdArray[i] = dynamicCast((checkIndex(i, measurementDefinitions.size_0) , measurementDefinitions.array[i]), Q$MeasurementDefinition).id;
  }
  $findDataForCompatibleGroup(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this.this$0.resourceGroup.id, measDefIdArray, $getStartTime(this.this$0.measurementRangeEditor).value_0, $getEndTime(this.this$0.measurementRangeEditor).value_0, new D3GroupGraphListView$1$2_0(this, measurementDefinitions));
}
;
_.this$0 = null;
function $compare_10(o1, o2){
  return $compareTo_5(new Integer_0(o1.displayOrder), valueOf_44(o2.displayOrder));
}

function D3GroupGraphListView$1$1_0(){
}

defineSeed(3049, 1, makeCastMap([Q$Comparator]), D3GroupGraphListView$1$1_0);
_.compare = function compare_11(o1, o2){
  return $compare_10(dynamicCast(o1, Q$MeasurementDefinition), dynamicCast(o2, Q$MeasurementDefinition));
}
;
function $onSuccess_273(this$static, result){
  var data$iterator, i;
  if (result.isEmpty_0()) {
    $setContents_0(($clinit_AbstractD3GraphListView() , loadingLabel_0), ($clinit_Enhanced() , 'No graphs available'));
  }
   else {
    $hide(($clinit_AbstractD3GraphListView() , loadingLabel_0));
    i = 0;
    for (data$iterator = result.iterator(); data$iterator.hasNext();) {
      dynamicCast(data$iterator.next_0(), Q$List);
      $buildIndividualGraph(this$static.this$1.this$0, dynamicCast($get_0(this$static.val$measurementDefinitions, i++), Q$MeasurementDefinition));
    }
    if (this$static.this$1.this$0.availabilityGraph) {
      $setGroupAvailabilityList_0(this$static.this$1.this$0.availabilityGraph, this$static.this$1.this$0.groupAvailabilityList);
      $drawJsniChart(this$static.this$1.this$0.availabilityGraph.availabilityGraphType);
    }
  }
}

function D3GroupGraphListView$1$2_0(this$1, val$measurementDefinitions){
  this.this$1 = this$1;
  this.val$measurementDefinitions = val$measurementDefinitions;
}

defineSeed(3050, 1, {}, D3GroupGraphListView$1$2_0);
_.onFailure = function onFailure_284(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load graph data'), caught);
  $setContents_0(($clinit_AbstractD3GraphListView() , loadingLabel_0), 'Failed to load graph data');
}
;
_.onSuccess_0 = function onSuccess_284(result){
  $onSuccess_273(this, dynamicCast(result, Q$List));
}
;
_.this$1 = null;
_.val$measurementDefinitions = null;
function $onSuccess_274(this$static, groupAvailList){
  debug('\nSuccessfully queried group availability in: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this$static.val$timerStart)) + ' ms.');
  this$static.this$0.groupAvailabilityList = groupAvailList;
}

function D3GroupGraphListView$2_0(this$0, val$timerStart){
  this.this$0 = this$0;
  this.val$timerStart = val$timerStart;
}

defineSeed(3051, 1, {}, D3GroupGraphListView$2_0);
_.onFailure = function onFailure_285(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load availability history'), caught);
}
;
_.onSuccess_0 = function onSuccess_285(groupAvailList){
  $onSuccess_274(this, dynamicCast(groupAvailList, Q$List));
}
;
_.this$0 = null;
_.val$timerStart = P0_longLit;
function GeneralProperties_0(groupComposite, titleBar, isEditable){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.resourceGroupService = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
  this.groupComposite = groupComposite;
  this.titleBar = titleBar;
  this.isEditable = isEditable;
}

defineSeed(3052, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), GeneralProperties_0);
_.onInit = function onInit_60(){
  var canEdit, countItem, createdItem, descriptionItem, dynamicItem, editableRecursiveItem, formItems, generalPropsForm, group, groupDefinition, groupDefinitionItem, groupDefinitionName, groupDefinitionUrl, hasInventoryPermission, isDynaGroup, lastModifiedByItem, lastModifiedItem, memberCount, nameItem, notEmptyOrNullValidator, notNullValidator, note, recursiveItem, spacer, spacer2, staticNameItem, togglableDescriptionItem, togglableNameItem, type, typeItem, value;
  $onInit(this);
  $onInit_Layout(this);
  group = this.groupComposite.resourceGroup;
  spacer = new HLayout_0;
  $isCreated_1(spacer)?$setProperty_0(spacer, 'height', 10):(spacer.config_0['height'] = 10 , undefined);
  $addMember(this, spacer);
  generalPropsForm = new EnhancedDynamicForm_0;
  formItems = new ArrayList_0;
  isDynaGroup = !!group.groupDefinition;
  hasInventoryPermission = this.groupComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE));
  canEdit = !isDynaGroup && this.isEditable && hasInventoryPermission;
  notEmptyOrNullValidator = new StringLengthValidator_0(valueOf_44(1), ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  notNullValidator = new StringLengthValidator_0(null, FALSE);
  if (canEdit) {
    togglableNameItem = new EditableFormItem_0;
    togglableNameItem.editItem.setValidators(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [notEmptyOrNullValidator]));
    $setValueEditedHandler(togglableNameItem, new GeneralProperties$1_0(this, group, togglableNameItem));
    nameItem = togglableNameItem;
  }
   else {
    staticNameItem = new StaticTextItem_0;
    $setEscapeHTML(staticNameItem, TRUE);
    nameItem = staticNameItem;
  }
  $isCreated_2(nameItem)?$setProperty_8(nameItem, 'name', 'name'):(nameItem.jsObj['name'] = 'name' , undefined);
  nameItem.setTitle(($clinit_Enhanced() , 'Name'));
  nameItem.setValue_4(group.name_0);
  setCheck(formItems.array, formItems.size_0++, nameItem);
  typeItem = new StaticTextItem_2('memberType', 'Member Type');
  type = group.resourceType;
  if (type) {
    $setPrompt_1(typeItem, 'Plugin: ' + type.plugin + '\n<br>Type: ' + type.name_0);
    $setValue_7(typeItem, type.name_0 + ' (' + type.plugin + ')');
  }
   else {
    $setValue_7(typeItem, '<i>Mixed<\/i>');
  }
  setCheck(formItems.array, formItems.size_0++, typeItem);
  countItem = new StaticTextItem_2('memberCount', 'Member Count');
  memberCount = this.groupComposite.implicitCount;
  $setValue_4(countItem, toDouble(memberCount));
  setCheck(formItems.array, formItems.size_0++, countItem);
  if (canEdit) {
    togglableDescriptionItem = new EditableFormItem_0;
    togglableDescriptionItem.editItem.setValidators(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [notNullValidator]));
    $setValueEditedHandler(togglableDescriptionItem, new GeneralProperties$2_0(this, group, togglableDescriptionItem));
    descriptionItem = togglableDescriptionItem;
    value = group.description;
  }
   else {
    descriptionItem = new StaticTextItem_0;
    value = escapeHtml(group.description);
  }
  $isCreated_2(descriptionItem)?$setProperty_8(descriptionItem, 'name', 'description'):(descriptionItem.jsObj['name'] = 'description' , undefined);
  descriptionItem.setTitle('Description');
  descriptionItem.setValue_4(value);
  setCheck(formItems.array, formItems.size_0++, descriptionItem);
  dynamicItem = new StaticTextItem_2('dynamic', 'Dynamic');
  $setValue_7(dynamicItem, isDynaGroup?'Yes':'No');
  setCheck(formItems.array, formItems.size_0++, dynamicItem);
  if (canEdit) {
    editableRecursiveItem = new CheckboxEditableFormItem_0('Recursive');
    $setValueEditedHandler(editableRecursiveItem, new GeneralProperties$3_0(this, group));
    recursiveItem = editableRecursiveItem;
  }
   else {
    recursiveItem = new StaticTextItem_2('recursive', 'Recursive');
  }
  recursiveItem.setValue_4(group.recursive?'Yes':'No');
  setCheck(formItems.array, formItems.size_0++, recursiveItem);
  createdItem = new StaticTextItem_2('created', 'Date Created');
  $setValue_7(createdItem, ($clinit_TimestampCellFormatter() , format_30(group.ctime, DATE_TIME_FORMAT_MEDIUM)));
  setCheck(formItems.array, formItems.size_0++, createdItem);
  lastModifiedItem = new StaticTextItem_2('lastModified', 'Last Updated');
  $setValue_7(lastModifiedItem, format_30(group.mtime, DATE_TIME_FORMAT_MEDIUM));
  setCheck(formItems.array, formItems.size_0++, lastModifiedItem);
  lastModifiedByItem = new StaticTextItem_2('lastModifiedBy', 'Last Updated By');
  $setValue_7(lastModifiedByItem, group.modifiedBy);
  setCheck(formItems.array, formItems.size_0++, lastModifiedByItem);
  if (isDynaGroup) {
    groupDefinitionItem = new StaticTextItem_2('groupDefinition', 'Group Definition');
    groupDefinition = group.groupDefinition;
    groupDefinitionUrl = '#Inventory/Groups/DynagroupDefinitions/' + groupDefinition.id;
    groupDefinitionName = escapeHtml(groupDefinition.name_0);
    $setValue_7(groupDefinitionItem, '<a href="' + groupDefinitionUrl + '">' + groupDefinitionName + '<\/a>');
    setCheck(formItems.array, formItems.size_0++, groupDefinitionItem);
  }
  $setFields_3(generalPropsForm, dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, formItems.size_0, 0)), Q$FormItem_$1));
  $addMember(this, generalPropsForm);
  if (isDynaGroup) {
    spacer = new HLayout_0;
    $isCreated_1(spacer)?$setProperty_0(spacer, 'height', 10):(spacer.config_0['height'] = 10 , undefined);
    $addMember(this, spacer);
    note = new HTMLFlow_0;
    $setContents(note, '<b>*<\/b> Dynamic group names and descriptions are managed, and therefore are not editable');
    $setAttribute_24(note, 'align', ($clinit_Alignment() , CENTER_0).value_0, true);
    $addMember(this, note);
  }
  spacer2 = new HLayout_0;
  $isCreated_1(spacer2)?$setProperty_0(spacer2, 'height', 10):(spacer2.config_0['height'] = 10 , undefined);
  $addMember(this, spacer2);
}
;
_.groupComposite = null;
_.isEditable = false;
_.titleBar = null;
function GeneralProperties$1_0(this$0, val$group, val$togglableNameItem){
  this.this$0 = this$0;
  this.val$group = val$group;
  this.val$togglableNameItem = val$togglableNameItem;
}

defineSeed(3053, 1, {}, GeneralProperties$1_0);
_.editedValue = function editedValue(newValue){
  var newName, oldName;
  newName = toString__devirtual$(newValue);
  oldName = this.val$group.name_0;
  if ($equals_6(newName, oldName)) {
    return;
  }
  $setName_9(this.val$group, newName);
  $updateResourceGroup(this.this$0.resourceGroupService, this.val$group, new GeneralProperties$1$1_0(this, this.val$group, oldName, newName, this.val$togglableNameItem));
}
;
_.this$0 = null;
_.val$group = null;
_.val$togglableNameItem = null;
function $onSuccess_275(this$static){
  $displayGroupName(this$static.this$1.this$0.titleBar, this$static.val$newName);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have changed the name of the resource group with ID [' + ($clinit_Enhanced() , '' + this$static.val$group.id) + '] from [' + this$static.val$oldName + '] to [' + this$static.val$newName + ']', ($clinit_Message$Severity() , Info)));
}

function GeneralProperties$1$1_0(this$1, val$group, val$oldName, val$newName, val$togglableNameItem){
  this.this$1 = this$1;
  this.val$group = val$group;
  this.val$oldName = val$oldName;
  this.val$newName = val$newName;
  this.val$togglableNameItem = val$togglableNameItem;
}

defineSeed(3054, 1, {}, GeneralProperties$1$1_0);
_.onFailure = function onFailure_286(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to change the name of the resource group with ID [' + ($clinit_Enhanced() , '' + this.val$group.id) + '] - could not change from [' + this.val$oldName + '] to [' + this.val$newName + ']'), caught);
  $setName_9(this.val$group, this.val$oldName);
  $setValue_13(this.val$togglableNameItem, this.val$oldName);
}
;
_.onSuccess_0 = function onSuccess_286(result){
  $onSuccess_275(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$group = null;
_.val$newName = null;
_.val$oldName = null;
_.val$togglableNameItem = null;
function GeneralProperties$2_0(this$0, val$group, val$togglableDescriptionItem){
  this.this$0 = this$0;
  this.val$group = val$group;
  this.val$togglableDescriptionItem = val$togglableDescriptionItem;
}

defineSeed(3055, 1, {}, GeneralProperties$2_0);
_.editedValue = function editedValue_0(newValue){
  var newDescription, oldDescription;
  newDescription = toString__devirtual$(newValue);
  oldDescription = this.val$group.description;
  if ($equals_6(newDescription, oldDescription)) {
    return;
  }
  $setDescription_4(this.val$group, newDescription);
  $updateResourceGroup(this.this$0.resourceGroupService, this.val$group, new GeneralProperties$2$1_0(this.val$group, oldDescription, this.val$togglableDescriptionItem));
}
;
_.this$0 = null;
_.val$group = null;
_.val$togglableDescriptionItem = null;
function GeneralProperties$2$1_0(val$group, val$oldDescription, val$togglableDescriptionItem){
  this.val$group = val$group;
  this.val$oldDescription = val$oldDescription;
  this.val$togglableDescriptionItem = val$togglableDescriptionItem;
}

defineSeed(3056, 1, {}, GeneralProperties$2$1_0);
_.onFailure = function onFailure_287(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to change the description of the resource group with ID [' + ($clinit_Enhanced() , '' + this.val$group.id) + ']'), caught);
  $setDescription_4(this.val$group, this.val$oldDescription);
  $setValue_13(this.val$togglableDescriptionItem, this.val$oldDescription);
}
;
_.onSuccess_0 = function onSuccess_287(result){
  throwClassCastExceptionUnlessNull(result);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have changed the description of this resource group'), ($clinit_Message$Severity() , Info)));
}
;
_.val$group = null;
_.val$oldDescription = null;
_.val$togglableDescriptionItem = null;
function GeneralProperties$3_0(this$0, val$group){
  this.this$0 = this$0;
  this.val$group = val$group;
}

defineSeed(3057, 1, {}, GeneralProperties$3_0);
_.editedValue = function editedValue_1(newValue){
  var isRecursive;
  isRecursive = newValue != null && dynamicCast(newValue, Q$Boolean).value_0;
  $setRecursive_1(this.this$0.resourceGroupService, this.val$group.id, isRecursive, new GeneralProperties$3$1_0(this.val$group));
}
;
_.this$0 = null;
_.val$group = null;
function $onSuccess_276(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0('You successfully changed the recursive setting for group [' + ($clinit_Enhanced() , this$static.val$group.name_0) + ']'));
}

function GeneralProperties$3$1_0(val$group){
  this.val$group = val$group;
}

defineSeed(3058, 1, {}, GeneralProperties$3$1_0);
_.onFailure = function onFailure_288(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to update the recursive setting for group [' + ($clinit_Enhanced() , '' + this.val$group.name_0) + ']'), null);
}
;
_.onSuccess_0 = function onSuccess_288(result){
  $onSuccess_276(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$group = null;
function $buildResourceGroupContextMenu(this$static, treeGrid, node, group, resourceType){
  var definitionMap, displayName, displayName$iterator, o, o$iterator, opSubMenu, operationDefinition, operationItem, operations, operationsEnabled, ordered, pluginConfigEnabled, pluginConfiguration, refresh, resourceConfigEnabled, resourceConfiguration, measurements, measurementsSubMenu, criteria, context;
  $setItems_0(this$static, initValues(_3Lcom_smartgwt_client_widgets_menu_MenuItem_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$MenuItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$MenuItem, [new MenuItem_1(group.name_0)]));
  $addItem_0(this$static, new MenuItem_1('Type: ' + resourceType.name_0));
  if (instanceOf(node, Q$ResourceTreeDatasource$AutoGroupTreeNode)) {
    $addItem_0(this$static, new MenuItemSeparator_0);
    refresh = new MenuItem_1('Refresh');
    $addClickHandler_3(refresh, new ResourceGroupContextMenu$3_0(treeGrid, node));
    $addItem_0(this$static, refresh);
  }
  $addItem_0(this$static, new MenuItemSeparator_0);
  pluginConfiguration = new MenuItem_1('Connection Settings');
  pluginConfigEnabled = !!resourceType.pluginConfigurationDefinition;
  $setAttribute_8(pluginConfiguration, 'enabled', ($clinit_Boolean() , pluginConfigEnabled?TRUE:FALSE));
  pluginConfigEnabled && $addClickHandler_3(pluginConfiguration, new ResourceGroupContextMenu$4_0(group));
  $addItem_0(this$static, pluginConfiguration);
  resourceConfiguration = new MenuItem_1('Resource Configuration');
  resourceConfigEnabled = this$static.groupComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONFIGURE_READ)) && !!resourceType.resourceConfigurationDefinition;
  $setAttribute_8(resourceConfiguration, 'enabled', resourceConfigEnabled?TRUE:FALSE);
  resourceConfigEnabled && $addClickHandler_3(resourceConfiguration, new ResourceGroupContextMenu$5_0(group));
  $addItem_0(this$static, resourceConfiguration);
  $addItem_0(this$static, new MenuItemSeparator_0);
  operations = new MenuItem_1('Operations');
  operationsEnabled = this$static.groupComposite.resourcePermission.permissions.contains_0(CONTROL_0) && !!resourceType.operationDefinitions && !resourceType.operationDefinitions.isEmpty_0();
  $setAttribute_8(operations, 'enabled', operationsEnabled?TRUE:FALSE);
  if (operationsEnabled) {
    opSubMenu = new Menu_0;
    ordered = new TreeSet_0;
    definitionMap = new HashMap_0;
    for (o$iterator = resourceType.operationDefinitions.iterator(); o$iterator.hasNext();) {
      o = dynamicCast(o$iterator.next_0(), Q$OperationDefinition);
      $add_8(ordered, o.displayName);
      definitionMap.put(o.displayName, o);
    }
    for (displayName$iterator = $iterator($keySet(ordered.map)); displayName$iterator.val$outerIter.hasNext();) {
      displayName = dynamicCast($next_1(displayName$iterator), Q$String);
      operationDefinition = dynamicCast(definitionMap.get_2(displayName), Q$OperationDefinition);
      operationItem = new MenuItem_1(operationDefinition.displayName);
      $addClickHandler_3(operationItem, new ResourceGroupContextMenu$6_0(group, operationDefinition));
      $addItem_0(opSubMenu, operationItem);
    }
    $setAttribute_5(operations, 'submenu', !opSubMenu?null:$getOrCreateJsObj_0(opSubMenu));
  }
  $addItem_0(this$static, operations);
  $addItem_0(this$static, (measurements = new MenuItem_1('Measurements') , measurementsSubMenu = new Menu_0 , criteria = new DashboardCriteria_0 , context = forGroup_0(group) , ($clinit_EntityContext$Type() , ResourceGroup) == context.type_0 && context.isAutoGroup || $findDashboardsByCriteria(dynamicCast(secure(getInstance_39(), -1), Q$DashboardGWTServiceAsync), criteria, new ResourceGroupContextMenu$7_0(this$static, resourceType, measurementsSubMenu)) , $setAttribute_5(measurements, 'submenu', !measurementsSubMenu?null:$getOrCreateJsObj_0(measurementsSubMenu)) , measurements));
}

function $showContextMenu_0(this$static, treeGrid, node, group){
  var criteria;
  criteria = new ResourceGroupCriteria_0;
  $addFilterId(criteria, valueOf_44(group.id));
  this$static.isAutoCluster = !!group.clusterResourceGroup;
  this$static.isAutoGroup = !!group.subject;
  if (this$static.isAutoCluster) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  }
   else if (this$static.isAutoGroup) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addFilterPrivate(criteria, TRUE);
  }
  $findResourceGroupCompositesByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), criteria, new ResourceGroupContextMenu$1_0(this$static, group, treeGrid, node));
}

function $showContextMenu_1(this$static, treeGrid, node, groupComposite){
  this$static.groupComposite = groupComposite;
  this$static.group = groupComposite.resourceGroup;
  if (($clinit_GroupCategory() , MIXED_0) == this$static.group.groupCategory) {
    $clinit_CoreGUI();
    goToView('#ResourceGroup/' + this$static.group.id, null, false);
    return;
  }
  this$static.groupMemberType = this$static.group.resourceType;
  this$static.isAutoCluster = !!this$static.group.clusterResourceGroup;
  this$static.isAutoGroup = !!this$static.group.subject;
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(this$static.groupMemberType.id), of_0(($clinit_ResourceTypeRepository$MetadataType() , operations_0), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceTypeRepository$MetadataType, [children_0, subCategory_0, pluginConfigurationDefinition_0, resourceConfigurationDefinition_0])), new ResourceGroupContextMenu$2_0(this$static, treeGrid, node));
}

function ResourceGroupContextMenu_0(){
  Menu_0.call(this);
  $clinit_CoreGUI();
}

defineSeed(3059, 561, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$Menu]), ResourceGroupContextMenu_0);
_.group = null;
_.groupComposite = null;
_.groupMemberType = null;
_.isAutoCluster = false;
_.isAutoGroup = false;
function $onSuccess_277(this$static, result){
  result.size_0 == 0?$handleError_0(($clinit_CoreGUI() , 'Group with id [' + this$static.val$group.id + '] does not exist or is not accessible'), null):$showContextMenu_1(this$static.this$0, this$static.val$treeGrid, this$static.val$node, dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroupComposite));
}

function ResourceGroupContextMenu$1_0(this$0, val$group, val$treeGrid, val$node){
  this.this$0 = this$0;
  this.val$group = val$group;
  this.val$treeGrid = val$treeGrid;
  this.val$node = val$node;
}

defineSeed(3060, 1, {}, ResourceGroupContextMenu$1_0);
_.onFailure = function onFailure_289(caught){
  $handleError_0(($clinit_CoreGUI() , 'Group with id [' + this.val$group.id + '] does not exist or is not accessible'), caught);
}
;
_.onSuccess_0 = function onSuccess_289(result){
  $onSuccess_277(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$group = null;
_.val$node = null;
_.val$treeGrid = null;
function ResourceGroupContextMenu$2_0(this$0, val$treeGrid, val$node){
  this.this$0 = this$0;
  this.val$treeGrid = val$treeGrid;
  this.val$node = val$node;
}

defineSeed(3061, 1, {}, ResourceGroupContextMenu$2_0);
_.onTypesLoaded = function onTypesLoaded_19(type){
  this.this$0.groupMemberType = type;
  $buildResourceGroupContextMenu(this.this$0, this.val$treeGrid, this.val$node, this.this$0.group, type);
  $showContextMenu(this.this$0);
}
;
_.this$0 = null;
_.val$node = null;
_.val$treeGrid = null;
function ResourceGroupContextMenu$3_0(val$treeGrid, val$node){
  this.val$treeGrid = val$treeGrid;
  this.val$node = val$node;
}

defineSeed(3062, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceGroupContextMenu$3_0);
_.onClick_1 = function onClick_133(event_0){
  contextMenuRefresh(this.val$treeGrid, this.val$node);
}
;
_.val$node = null;
_.val$treeGrid = null;
function ResourceGroupContextMenu$4_0(val$group){
  this.val$group = val$group;
}

defineSeed(3063, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceGroupContextMenu$4_0);
_.onClick_1 = function onClick_134(event_0){
  $clinit_CoreGUI();
  goToView(getEntityTabLink(forGroup_0(this.val$group), 'Inventory', 'ConnectionSettings'), null, false);
}
;
_.val$group = null;
function ResourceGroupContextMenu$5_0(val$group){
  this.val$group = val$group;
}

defineSeed(3064, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceGroupContextMenu$5_0);
_.onClick_1 = function onClick_135(event_0){
  $clinit_CoreGUI();
  goToView(getEntityTabLink(forGroup_0(this.val$group), 'Configuration', 'Current'), null, false);
}
;
_.val$group = null;
function ResourceGroupContextMenu$6_0(val$group, val$operationDefinition){
  this.val$group = val$group;
  this.val$operationDefinition = val$operationDefinition;
}

defineSeed(3065, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceGroupContextMenu$6_0);
_.onClick_1 = function onClick_136(event_0){
  var viewPath;
  viewPath = getEntityTabLink(forGroup_0(this.val$group), 'Operations', 'Schedules') + '/0/' + this.val$operationDefinition.id;
  $clinit_CoreGUI();
  goToView(viewPath, null, false);
}
;
_.val$group = null;
_.val$operationDefinition = null;
function $onSuccess_278(this$static, result){
  var addGraphItem, addToDBItem, currentViewPath, d, d$iterator, def, defItem, defSubItem, definitionMap, displayName, displayName$iterator, m_0, m$iterator, ordered;
  if (this$static.val$type.metricDefinitions) {
    ordered = new TreeSet_0;
    definitionMap = new HashMap_0;
    for (m$iterator = this$static.val$type.metricDefinitions.iterator(); m$iterator.hasNext();) {
      m_0 = dynamicCast(m$iterator.next_0(), Q$MeasurementDefinition);
      $add_8(ordered, m_0.displayName);
      definitionMap.put(m_0.displayName, m_0);
    }
    for (displayName$iterator = $iterator($keySet(ordered.map)); displayName$iterator.val$outerIter.hasNext();) {
      displayName = dynamicCast($next_1(displayName$iterator), Q$String);
      def = dynamicCast(definitionMap.get_2(displayName), Q$MeasurementDefinition);
      if (def.dataType == ($clinit_DataType() , MEASUREMENT)) {
        defItem = new MenuItem_1(def.displayName);
        $addItem_0(this$static.val$measurementsSubMenu, defItem);
        defSubItem = new Menu_0;
        $setAttribute_5(defItem, 'submenu', !defSubItem?null:$getOrCreateJsObj_0(defSubItem));
        for (d$iterator = new AbstractList$IteratorImpl_0(result); d$iterator.i < d$iterator.this$0_0.size_1();) {
          d = dynamicCast($next_0(d$iterator), Q$Dashboard);
          addToDBItem = new MenuItem_1('Add chart to dashboard [' + d.name_0 + ']');
          $addItem_0(defSubItem, addToDBItem);
          $addClickHandler_3(addToDBItem, new ResourceGroupContextMenu$7$1_0(this$static, def, d));
          currentViewPath = ($clinit_History() , impl_0?token_1 == null?'':token_1:'');
          if (currentViewPath.indexOf('Monitoring/NewGraphs') != -1) {
            addGraphItem = new MenuItem_1('Add Graph to Monitor View');
            $addItem_0(defSubItem, addGraphItem);
            $addClickHandler_3(addGraphItem, new ResourceGroupContextMenu$7$2_0(this$static, def));
          }
        }
      }
    }
  }
}

function ResourceGroupContextMenu$7_0(this$0, val$type, val$measurementsSubMenu){
  this.this$0 = this$0;
  this.val$type = val$type;
  this.val$measurementsSubMenu = val$measurementsSubMenu;
}

defineSeed(3066, 1, {}, ResourceGroupContextMenu$7_0);
_.onFailure = function onFailure_290(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load user dashboards'), caught);
}
;
_.onSuccess_0 = function onSuccess_290(result){
  $onSuccess_278(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$measurementsSubMenu = null;
_.val$type = null;
function ResourceGroupContextMenu$7$1_0(this$1, val$def, val$d){
  this.this$1 = this$1;
  this.val$def = val$def;
  this.val$d = val$d;
}

defineSeed(3067, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceGroupContextMenu$7$1_0);
_.onClick_1 = function onClick_137(menuItemClickEvent){
  var p;
  p = new DashboardPortlet_1('Group Metric Graph', 'ResourceGroupMetricD3', 250);
  $put_4(p.configuration, new PropertySimple_1('resourceGroupId', valueOf_44(this.this$1.this$0.group.id)));
  $put_4(p.configuration, new PropertySimple_1('definitionId', valueOf_44(this.val$def.id)));
  $addPortlet(this.val$d, p);
  $storeDashboard(dynamicCast(secure(getInstance_39(), -1), Q$DashboardGWTServiceAsync), this.val$d, new ResourceGroupContextMenu$7$1$1_0);
}
;
_.this$1 = null;
_.val$d = null;
_.val$def = null;
function ResourceGroupContextMenu$7$1$1_0(){
}

defineSeed(3068, 1, {}, ResourceGroupContextMenu$7$1$1_0);
_.onFailure = function onFailure_291(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to save the dashboard'), caught);
}
;
_.onSuccess_0 = function onSuccess_291(result){
  var msg;
  msg = 'You have saved dashboard [' + dynamicCast(result, Q$Dashboard).name_0 + ']';
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(msg, ($clinit_Message$Severity() , Info)));
}
;
function ResourceGroupContextMenu$7$2_0(this$1, val$def){
  this.this$1 = this$1;
  this.val$def = val$def;
}

defineSeed(3069, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceGroupContextMenu$7$2_0);
_.onClick_1 = function onClick_138(menuItemClickEvent){
  var $e0, b, baseUrl, e, grpGraphElements;
  grpGraphElements = '';
  this.this$1.this$0.isAutoGroup?(grpGraphElements += 'ag,'):(grpGraphElements += 'cg,');
  grpGraphElements += this.this$1.this$0.group.id + ',' + this.val$def.id;
  this.this$1.this$0.isAutoGroup && (grpGraphElements += ',' + this.this$1.this$0.group.resourceType.id);
  baseUrl = '/resource/common/monitor/visibility/IndicatorCharts.do';
  baseUrl += '?groupId=' + this.this$1.this$0.group.id;
  baseUrl += '&view=Default';
  baseUrl += '&action=addChart&metric=' + grpGraphElements;
  baseUrl += '&view=Default';
  b = new RequestBuilder_0(($clinit_RequestBuilder() , GET), baseUrl);
  try {
    $setCallback(b, new ResourceGroupContextMenu$7$2$1_0(baseUrl));
    throwIfNull('callback', b.callback);
    $doSend(b, b.requestData, b.callback);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$RequestException)) {
      e = $e0;
      $clinit_Log();
      $log_1(logger_0, ($clinit_Level() , FINEST), 'Error adding Metric:' + baseUrl, e);
    }
     else 
      throw $e0;
  }
}
;
_.this$1 = null;
_.val$def = null;
function ResourceGroupContextMenu$7$2$1_0(val$url){
  this.val$url = val$url;
}

defineSeed(3070, 1, {}, ResourceGroupContextMenu$7$2$1_0);
_.onError = function onError_4(request, t){
  trace_0('Error adding Metric:' + this.val$url, t);
}
;
_.onResponseReceived = function onResponseReceived_4(request, response){
  var currentViewPath;
  trace('Successfully submitted request to add graph to view:' + this.val$url);
  currentViewPath = ($clinit_History() , impl_0?token_1 == null?'':token_1:'');
  $clinit_CoreGUI();
  goToView(currentViewPath, null, true);
}
;
_.val$url = null;
function $createD3GraphListView(this$static){
  this$static.graphListView = new D3GroupGraphListView_0(this$static.groupComposite.resourceGroup);
  return dynamicCast(this$static.graphListView, Q$D3GroupGraphListView);
}

function $loadResourceType(this$static, groupComposite, viewPath){
  var group, groupType;
  group = this$static.groupComposite.resourceGroup;
  if (group.groupCategory == ($clinit_GroupCategory() , COMPATIBLE)) {
    groupType = group.resourceType;
    $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(groupType.id), of_0(($clinit_ResourceTypeRepository$MetadataType() , content_1), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceTypeRepository$MetadataType, [operations_0, measurements_0, events_0, resourceConfigurationDefinition_0])), new ResourceGroupDetailView$18_0(this$static, group, groupComposite, viewPath));
  }
   else {
    try {
      $updateTabContent_0(this$static, groupComposite, viewPath);
      $selectTab_2(this$static, this$static.tabName, this$static.subTabName, viewPath);
      !!this$static.graphListView && $redrawGraphs(dynamicCast(this$static.graphListView, Q$D3GroupGraphListView));
    }
     finally {
      $notifyViewRenderedListeners(this$static);
    }
  }
}

function $renderView_9(this$static, viewPath){
  if ($equals_6('AutoCluster', (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path)) {
    $renderView_8(this$static, (++viewPath.index_0 , viewPath));
  }
   else {
    if (!!this$static.groupId && $equals_6(this$static.inventoryTab.viewName.name_0, this$static.currentTabName) && $equals_6(this$static.inventoryMembers.viewName.name_0, this$static.currentSubTabName)) {
      this$static.currentTabName = null;
      this$static.currentSubTabName = null;
      this$static.groupId = null;
    }
    $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new AbstractTwoLevelTabSetView$1_0(this$static, viewPath)));
  }
}

function $selectTab_2(this$static, tabName, subtabName, viewPath){
  this$static.currentTabName = tabName;
  this$static.currentSubTabName = subtabName;
  $selectTab_1(this$static, tabName, subtabName, viewPath);
}

function $updateAlertsTab(this$static, groupCategory){
  var viewFactory, visible;
  if ($updateTab_0(this$static, this$static.alertsTab, true, true)) {
    $updateSubTab(this$static.alertsTab, this$static.alertHistory, true, true, new ResourceGroupDetailView$12_0(this$static));
    visible = groupCategory == ($clinit_GroupCategory() , COMPATIBLE);
    viewFactory = visible?new ResourceGroupDetailView$13_0(this$static):null;
    $updateSubTab(this$static.alertsTab, this$static.alertDef, visible, true, viewFactory);
  }
}

function $updateConfigurationTab(this$static, groupCategory, facets){
  var groupPermissions, visible;
  visible = groupCategory == ($clinit_GroupCategory() , COMPATIBLE) && facets.contains_0(($clinit_ResourceTypeFacet() , CONFIGURATION_2));
  groupPermissions = this$static.groupComposite.resourcePermission.permissions;
  if ($updateTab_0(this$static, this$static.configurationTab, visible, visible && groupPermissions.contains_0(($clinit_Permission() , CONFIGURE_READ)))) {
    $updateSubTab(this$static.configurationTab, this$static.configCurrent, true, true, new ResourceGroupDetailView$14_0(this$static));
    $updateSubTab(this$static.configurationTab, this$static.configHistory, true, true, new ResourceGroupDetailView$15_0(this$static));
  }
}

function $updateMonitoringTab(this$static, facets){
  var showOnPage, viewFactory, visible;
  visible = hasMetricsOfType(this$static.groupComposite, null);
  if ($updateTab_0(this$static, this$static.monitoringTab, visible, true)) {
    forGroup_0(this$static.groupComposite.resourceGroup);
    visible = hasMetricsOfType(this$static.groupComposite, ($clinit_DataType() , MEASUREMENT));
    isBrowserPreIE9()?(showOnPage = false):visible?(showOnPage = true):(showOnPage = false);
    viewFactory = showOnPage?new ResourceGroupDetailView$2_0(this$static):null;
    $updateSubTab(this$static.monitoringTab, this$static.monitorNewGraphs, visible, true, viewFactory);
    viewFactory = visible?new ResourceGroupDetailView$3_0(this$static):null;
    $updateSubTab(this$static.monitoringTab, this$static.monitorTables, visible, true, viewFactory);
    visible = hasMetricsOfType(this$static.groupComposite, TRAIT_0);
    viewFactory = visible?new ResourceGroupDetailView$4_0(this$static):null;
    $updateSubTab(this$static.monitoringTab, this$static.monitorTraits, visible, true, viewFactory);
    visible = hasMetricsOfType(this$static.groupComposite, null);
    viewFactory = visible?new ResourceGroupDetailView$5_0(this$static):null;
    $updateSubTab(this$static.monitoringTab, this$static.monitorSched, visible, true, viewFactory);
    visible = facets.contains_0(($clinit_ResourceTypeFacet() , CALL_TIME));
    viewFactory = visible?new ResourceGroupDetailView$6_0(this$static):null;
    $updateSubTab(this$static.monitoringTab, this$static.monitorCallTime, visible, true, viewFactory);
  }
}

function $updateOperationsTab(this$static, groupCategory, facets){
  if ($updateTab_0(this$static, this$static.operationsTab, groupCategory == ($clinit_GroupCategory() , COMPATIBLE) && facets.contains_0(($clinit_ResourceTypeFacet() , OPERATION)), true)) {
    $updateSubTab(this$static.operationsTab, this$static.operationsSchedules, true, true, new ResourceGroupDetailView$10_0(this$static));
    $updateSubTab(this$static.operationsTab, this$static.operationsHistory, true, true, new ResourceGroupDetailView$11_0(this$static));
  }
}

function $updateTabContent_0(this$static, groupComposite){
  var $e0, e, facets, groupCategory, canModifyMembers, visible;
  $updateTabContent(this$static);
  try {
    this$static.groupComposite = groupComposite;
    $setGroup_1(dynamicCast(this$static.titleBar, Q$ResourceGroupTitleBar), groupComposite);
    $destroyViews_0(this$static.tabSet);
    groupCategory = groupComposite.resourceGroup.groupCategory;
    facets = groupComposite.resourceFacets.facets;
    $updateSubTab(this$static.summaryTab, this$static.summaryActivity, true, true, new ResourceGroupDetailView$1_0(this$static));
    canModifyMembers = !this$static.groupComposite.resourceGroup.groupDefinition && !$equals_6('Resource/AutoGroup', this$static.baseViewPath) && !$equals_6('ResourceGroup/AutoCluster', this$static.baseViewPath) && this$static.globalPermissions.contains_0(($clinit_Permission() , MANAGE_INVENTORY));
    $updateSubTab(this$static.inventoryTab, this$static.inventoryMembers, true, true, new ResourceGroupDetailView$7_0(this$static, canModifyMembers));
    $updateSubTab(this$static.inventoryTab, this$static.inventoryConn, facets.contains_0(($clinit_ResourceTypeFacet() , PLUGIN_CONFIGURATION)), true, new ResourceGroupDetailView$8_0(this$static));
    $updateSubTab(this$static.inventoryTab, this$static.inventoryConnHistory, facets.contains_0(PLUGIN_CONFIGURATION), true, new ResourceGroupDetailView$9_0(this$static));
    $updateAlertsTab(this$static, groupCategory);
    $updateMonitoringTab(this$static, facets);
    visible = groupCategory == ($clinit_GroupCategory() , MIXED_0) || groupCategory == COMPATIBLE && facets.contains_0(EVENT_0);
    $updateTab_0(this$static, this$static.eventsTab, visible, true) && $updateSubTab(this$static.eventsTab, this$static.eventHistory, true, true, new ResourceGroupDetailView$16_0(this$static));
    $updateOperationsTab(this$static, groupCategory, facets);
    $updateConfigurationTab(this$static, groupCategory, facets);
    $show(this$static);
    $markForRedraw(this$static);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      e = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to update tab content.'), e);
    }
     else 
      throw $e0;
  }
}

function ResourceGroupDetailView_0(baseViewPath){
  $clinit_BaseWidget();
  AbstractTwoLevelTabSetView_0.call(this, baseViewPath);
  $hide(this);
}

function hasMetricsOfType(groupComposite, dataType){
  var metricDef, metricDef$iterator, metricDefs, type;
  type = groupComposite.resourceGroup.resourceType;
  if (type) {
    metricDefs = type.metricDefinitions;
    for (metricDef$iterator = metricDefs.iterator(); metricDef$iterator.hasNext();) {
      metricDef = dynamicCast(metricDef$iterator.next_0(), Q$MeasurementDefinition);
      if (!dataType || metricDef.dataType == dataType) {
        return true;
      }
    }
  }
  return false;
}

defineSeed(3071, 2928, makeCastMap([Q$HasAttachHandlers, Q$EventHandler, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$TwoLevelTabSelectedHandler, Q$Enhanced]), ResourceGroupDetailView_0);
_.createTabs = function createTabs(){
  var tabs;
  tabs = new ArrayList_0;
  this.summaryTab = new TwoLevelTab_0(new ViewName_1('Summary', ($clinit_Enhanced() , 'Summary')), getResourceIcon_0(($clinit_ResourceCategory() , SERVICE), ($clinit_AvailabilityType() , UP), '16'));
  this.summaryActivity = new SubTab_0(this.summaryTab, new ViewName_1('Activity', 'Activity'));
  this.summaryTimeline = new SubTab_0(this.summaryTab, new ViewName_1('Timeline', 'Timeline'));
  $registerSubTabs_0(this.summaryTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.summaryActivity, this.summaryTimeline]));
  $add_3(tabs, this.summaryTab);
  this.inventoryTab = new TwoLevelTab_1(new ViewName_1('Inventory', 'Inventory'), ($clinit_IconEnum() , INVENTORY_SUMMARY));
  this.inventoryMembers = new SubTab_0(this.inventoryTab, new ViewName_1('Members', 'Members'));
  this.inventoryConn = new SubTab_0(this.inventoryTab, new ViewName_1('ConnectionSettings', 'Connection Settings'));
  this.inventoryConnHistory = new SubTab_0(this.inventoryTab, new ViewName_1('ConnectionSettingsHistory', 'Connection Settings History'));
  $registerSubTabs_0(this.inventoryTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.inventoryMembers, this.inventoryConn, this.inventoryConnHistory]));
  $add_3(tabs, this.inventoryTab);
  this.alertsTab = new TwoLevelTab_1(new ViewName_1('Alerts', 'Alerts'), ALERT_DEFINITIONS);
  this.alertHistory = new SubTab_0(this.alertsTab, new ViewName_1('History', 'History'));
  this.alertDef = new SubTab_0(this.alertsTab, new ViewName_1('Definitions', 'Definitions'));
  $registerSubTabs_0(this.alertsTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.alertHistory, this.alertDef]));
  $add_3(tabs, this.alertsTab);
  this.monitoringTab = new TwoLevelTab_1(new ViewName_1('Monitoring', 'Monitoring'), SUSPECT_METRICS);
  this.monitorNewGraphs = new SubTab_0(this.monitoringTab, new ViewName_1('NewGraphs', 'Graphs'));
  this.monitorTables = new SubTab_0(this.monitoringTab, new ViewName_1('Tables', 'Tables'));
  this.monitorTraits = new SubTab_0(this.monitoringTab, new ViewName_1('Traits', 'Traits'));
  this.monitorSched = new SubTab_0(this.monitoringTab, new ViewName_1('Schedules', 'Schedules'));
  this.monitorCallTime = new SubTab_0(this.monitoringTab, new ViewName_1('CallTime', 'Calltime'));
  $registerSubTabs_0(this.monitoringTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.monitorNewGraphs, this.monitorTables, this.monitorTraits, this.monitorSched, this.monitorCallTime]));
  $add_3(tabs, this.monitoringTab);
  this.eventsTab = new TwoLevelTab_1(new ViewName_1('Events', 'Events'), EVENTS);
  this.eventHistory = new SubTab_0(this.eventsTab, new ViewName_1('History', 'History'));
  $registerSubTabs_0(this.eventsTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.eventHistory]));
  $add_3(tabs, this.eventsTab);
  this.operationsTab = new TwoLevelTab_1(new ViewName_1('Operations', 'Operations'), RECENT_OPERATIONS);
  this.operationsSchedules = new SubTab_0(this.operationsTab, new ViewName_1('Schedules', 'Schedules'));
  this.operationsHistory = new SubTab_0(this.operationsTab, new ViewName_1('History', 'History'));
  $registerSubTabs_0(this.operationsTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.operationsSchedules, this.operationsHistory]));
  $add_3(tabs, this.operationsTab);
  this.configurationTab = new TwoLevelTab_1(new ViewName_1('Configuration', 'Configuration'), CONFIGURATION_HISTORY);
  this.configCurrent = new SubTab_0(this.configurationTab, new ViewName_1('Current', 'Current'));
  this.configHistory = new SubTab_0(this.configurationTab, new ViewName_1('History', 'History'));
  $registerSubTabs_0(this.configurationTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.configCurrent, this.configHistory]));
  $add_3(tabs, this.configurationTab);
  return tabs;
}
;
_.createTitleBar = function createTitleBar(){
  return new ResourceGroupTitleBar_0($equals_6('Resource/AutoGroup', this.baseViewPath), $equals_6('ResourceGroup/AutoCluster', this.baseViewPath));
}
;
_.getSelectedItemId = function getSelectedItemId(){
  return this.groupId;
}
;
_.loadSelectedItem = function loadSelectedItem(groupId, viewPath){
  var criteria, isAutoCluster, isAutoGroup;
  this.groupId = valueOf_44(groupId);
  criteria = new ResourceGroupCriteria_0;
  $addFilterId(criteria, valueOf_44(groupId));
  isAutoCluster = $equals_6('ResourceGroup/AutoCluster', this.baseViewPath);
  isAutoGroup = $equals_6('Resource/AutoGroup', this.baseViewPath);
  if (isAutoCluster) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  }
   else if (isAutoGroup) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addFilterPrivate(criteria, TRUE);
  }
  $findResourceGroupCompositesByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), criteria, new ResourceGroupDetailView$17_0(this, groupId, viewPath, isAutoCluster, isAutoGroup));
}
;
_.onTabSelected_0 = function onTabSelected_3(tabSelectedEvent){
  var path, tabPath;
  if (!!this.groupId && $equals_6(this.inventoryTab.viewName.name_0, this.currentTabName) && $equals_6(this.inventoryMembers.viewName.name_0, this.currentSubTabName)) {
    tabPath = '/' + tabSelectedEvent.id + '/' + tabSelectedEvent.subTabId;
    path = this.baseViewPath + '/' + this.groupId + tabPath;
    this.currentTabName = null;
    this.currentSubTabName = null;
    this.groupId = null;
    $clinit_CoreGUI();
    goToView(path, null, false);
  }
   else {
    $onTabSelected(this, tabSelectedEvent);
  }
}
;
_.renderView = function renderView_26(viewPath){
  $renderView_9(this, viewPath);
}
;
_.selectTab_0 = function selectTab_0(tabName, subtabName, viewPath){
  $selectTab_2(this, tabName, subtabName, viewPath);
}
;
_.alertDef = null;
_.alertHistory = null;
_.alertsTab = null;
_.configCurrent = null;
_.configHistory = null;
_.configurationTab = null;
_.currentSubTabName = null;
_.currentTabName = null;
_.eventHistory = null;
_.eventsTab = null;
_.groupComposite = null;
_.groupId = null;
_.inventoryConn = null;
_.inventoryConnHistory = null;
_.inventoryMembers = null;
_.inventoryTab = null;
_.monitorCallTime = null;
_.monitorNewGraphs = null;
_.monitorSched = null;
_.monitorTables = null;
_.monitorTraits = null;
_.monitoringTab = null;
_.operationsHistory = null;
_.operationsSchedules = null;
_.operationsTab = null;
_.summaryActivity = null;
_.summaryTab = null;
_.summaryTimeline = null;
function ResourceGroupDetailView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3072, 1, {}, ResourceGroupDetailView$1_0);
_.createView = function createView_31(){
  return new ActivityView_0(this.this$0.groupComposite, $equals_6('ResourceGroup/AutoCluster', this.this$0.baseViewPath), $equals_6('Resource/AutoGroup', this.this$0.baseViewPath));
}
;
_.this$0 = null;
function ResourceGroupDetailView$10_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3073, 1, {}, ResourceGroupDetailView$10_0);
_.createView = function createView_32(){
  return new GroupOperationScheduleListView_0(this.this$0.groupComposite);
}
;
_.this$0 = null;
function ResourceGroupDetailView$11_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3074, 1, {}, ResourceGroupDetailView$11_0);
_.createView = function createView_33(){
  return new GroupOperationHistoryListView_0(this.this$0.groupComposite);
}
;
_.this$0 = null;
function ResourceGroupDetailView$12_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3075, 1, {}, ResourceGroupDetailView$12_0);
_.createView = function createView_34(){
  return get_18(this.this$0.groupComposite);
}
;
_.this$0 = null;
function ResourceGroupDetailView$13_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3076, 1, {}, ResourceGroupDetailView$13_0);
_.createView = function createView_35(){
  return new GroupAlertDefinitionsView_0(this.this$0.groupComposite);
}
;
_.this$0 = null;
function ResourceGroupDetailView$14_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3077, 1, {}, ResourceGroupDetailView$14_0);
_.createView = function createView_36(){
  return new GroupResourceConfigurationEditView_0(this.this$0.groupComposite);
}
;
_.this$0 = null;
function ResourceGroupDetailView$15_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3078, 1, {}, ResourceGroupDetailView$15_0);
_.createView = function createView_37(){
  return new HistoryGroupResourceConfigurationView_0(this.this$0.groupComposite);
}
;
_.this$0 = null;
function ResourceGroupDetailView$16_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3079, 1, {}, ResourceGroupDetailView$16_0);
_.createView = function createView_38(){
  return get_23(this.this$0.groupComposite);
}
;
_.this$0 = null;
function $onFailure_32(this$static){
  var message;
  message = new Message_7('Group with id [' + ($clinit_Enhanced() , '' + this$static.val$groupId) + '] does not exist or is not accessible', ($clinit_Message$Severity() , Warning));
  $clinit_CoreGUI();
  goToView(($clinit_InventoryView() , VIEW_ID_21).name_0, message, false);
}

function $onSuccess_279(this$static, result){
  if (result.size_0 == 0) {
    $onFailure_32(this$static, new Exception_1('Group with id [' + this$static.val$groupId + '] does not exist.'));
  }
   else {
    this$static.this$0.groupComposite = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroupComposite);
    $loadResourceType(this$static.this$0, this$static.this$0.groupComposite, this$static.val$viewPath);
    this$static.val$isAutoCluster || this$static.val$isAutoGroup || $addRecentResourceGroup(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), valueOf_44(this$static.val$groupId), new ResourceGroupDetailView$17$1_0(this$static.val$groupId));
  }
}

function ResourceGroupDetailView$17_0(this$0, val$groupId, val$viewPath, val$isAutoCluster, val$isAutoGroup){
  this.this$0 = this$0;
  this.val$groupId = val$groupId;
  this.val$viewPath = val$viewPath;
  this.val$isAutoCluster = val$isAutoCluster;
  this.val$isAutoGroup = val$isAutoGroup;
}

defineSeed(3080, 1, {}, ResourceGroupDetailView$17_0);
_.onFailure = function onFailure_292(caught){
  $onFailure_32(this);
}
;
_.onSuccess_0 = function onSuccess_292(result){
  $onSuccess_279(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$groupId = 0;
_.val$isAutoCluster = false;
_.val$isAutoGroup = false;
_.val$viewPath = null;
function $onSuccess_280(this$static, result){
  debug('Updated recently viewed resource groups for ' + result + ' with resourceGroupId [' + this$static.val$groupId + ']');
}

function ResourceGroupDetailView$17$1_0(val$groupId){
  this.val$groupId = val$groupId;
}

defineSeed(3081, 1, {}, ResourceGroupDetailView$17$1_0);
_.onFailure = function onFailure_293(caught){
  $clinit_Log();
  $log_1(logger_0, ($clinit_Level() , SEVERE), 'Unable to update recently viewed resource groups', caught);
}
;
_.onSuccess_0 = function onSuccess_293(result){
  $onSuccess_280(this, dynamicCast(result, Q$Subject));
}
;
_.val$groupId = 0;
function ResourceGroupDetailView$18_0(this$0, val$group, val$groupComposite, val$viewPath){
  this.this$0 = this$0;
  this.val$group = val$group;
  this.val$groupComposite = val$groupComposite;
  this.val$viewPath = val$viewPath;
}

defineSeed(3082, 1, {}, ResourceGroupDetailView$18_0);
_.onTypesLoaded = function onTypesLoaded_20(type){
  try {
    $setResourceType_1(this.val$group, type);
    $updateTabContent_0(this.this$0, this.val$groupComposite, this.val$viewPath);
    $selectTab_2(this.this$0, this.this$0.tabName, this.this$0.subTabName, this.val$viewPath);
    !!this.this$0.graphListView && $redrawGraphs(dynamicCast(this.this$0.graphListView, Q$D3GroupGraphListView));
  }
   finally {
    $notifyViewRenderedListeners(this.this$0);
  }
}
;
_.this$0 = null;
_.val$group = null;
_.val$groupComposite = null;
_.val$viewPath = null;
function ResourceGroupDetailView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3083, 1, {}, ResourceGroupDetailView$2_0);
_.createView = function createView_39(){
  return $createD3GraphListView(this.this$0);
}
;
_.this$0 = null;
function ResourceGroupDetailView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3084, 1, {}, ResourceGroupDetailView$3_0);
_.createView = function createView_40(){
  return new GroupMonitoringTablesView_0(this.this$0.groupComposite);
}
;
_.this$0 = null;
function ResourceGroupDetailView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3085, 1, {}, ResourceGroupDetailView$4_0);
_.createView = function createView_41(){
  return new TraitsView_0(this.this$0.groupId.value_0);
}
;
_.this$0 = null;
function ResourceGroupDetailView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3086, 1, {}, ResourceGroupDetailView$5_0);
_.createView = function createView_42(){
  return new ResourceGroupSchedulesView_0(this.this$0.groupComposite);
}
;
_.this$0 = null;
function ResourceGroupDetailView$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3087, 1, {}, ResourceGroupDetailView$6_0);
_.createView = function createView_43(){
  return new CalltimeView_0(forGroup_0(this.this$0.groupComposite.resourceGroup));
}
;
_.this$0 = null;
function ResourceGroupDetailView$7_0(this$0, val$canModifyMembers){
  this.this$0 = this$0;
  this.val$canModifyMembers = val$canModifyMembers;
}

defineSeed(3088, 1, {}, ResourceGroupDetailView$7_0);
_.createView = function createView_44(){
  return new MembersView_0(this.this$0.groupComposite.resourceGroup.id, this.val$canModifyMembers);
}
;
_.this$0 = null;
_.val$canModifyMembers = false;
function ResourceGroupDetailView$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3089, 1, {}, ResourceGroupDetailView$8_0);
_.createView = function createView_45(){
  return new GroupPluginConfigurationEditView_0(this.this$0.groupComposite);
}
;
_.this$0 = null;
function ResourceGroupDetailView$9_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3090, 1, {}, ResourceGroupDetailView$9_0);
_.createView = function createView_46(){
  return new HistoryGroupPluginConfigurationView_0(this.this$0.groupComposite);
}
;
_.this$0 = null;
function $clinit_ResourceGroupTitleBar(){
  $clinit_ResourceGroupTitleBar = nullMethod;
  $clinit_BaseWidget();
  COLLAPSED_TOOLTIP = ($clinit_Enhanced() , 'Click to show more details for this group');
  EXPANDED_TOOLTIP = 'Click to hide details for this group';
}

function $displayGroupName(this$static, groupName){
  var catName;
  $equals_6(this$static.group.name_0, groupName) || $setName_9(this$static.group, groupName);
  catName = null;
  switch (this$static.group.groupCategory.ordinal) {
    case 0:
      {
        catName = ($clinit_Enhanced() , 'Compatible');
        break;
      }

    case 1:
      {
        catName = ($clinit_Enhanced() , 'Mixed');
        break;
      }

  }
  $setContents(this$static.title_0, '<span class="SectionHeader">' + this$static.group.name_0 + '<\/span>&nbsp;<span class="subtitle">' + catName + '<\/span>');
  $markForRedraw(this$static.title_0);
}

function $loadTags(this$static, tagEditorView){
  var criteria;
  criteria = new ResourceGroupCriteria_0;
  $addFilterId(criteria, valueOf_44(this$static.group.id));
  if (this$static.isAutoCluster) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  }
   else if (this$static.isAutoGroup) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addFilterPrivate(criteria, TRUE);
  }
  criteria.fetchTags = true;
  $findResourceGroupsByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), criteria, new ResourceGroupTitleBar$4_0(this$static, tagEditorView));
}

function $setGroup_1(this$static, groupComposite){
  var cannedName, favorites, typeName;
  this$static.group = groupComposite.resourceGroup;
  if (this$static.isAutoCluster) {
    typeName = this$static.group.resourceType.name_0;
    cannedName = 'Group of ' + typeName;
    $equals_6(cannedName, this$static.group.name_0) && $setName_9(this$static.group, 'Group of [' + ($clinit_Enhanced() , typeName) + ']');
  }
  $update_0(this$static);
  $displayGroupName(this$static, this$static.group.name_0);
  favorites = $getPreferenceAsIntegerSet(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), '.dashContent.grouphealth.groups');
  this$static.favorite = favorites.contains_0(valueOf_44(this$static.group.id));
  $updateFavoriteButton(this$static);
  $setGroupIcons(this$static, groupComposite);
  $markForRedraw(this$static);
}

function $setGroupIcons(this$static, composite){
  var explicitGroupAvailType, implicitGroupAvailType;
  explicitGroupAvailType = $getAvailabilityType(composite, true);
  this$static.badge.setSrc(getGroupIcon_0(this$static.group.groupCategory, explicitGroupAvailType, '24'));
  this$static.explicitAvailabilityImage.setSrc(getAvailabilityGroupLargeIcon(explicitGroupAvailType));
  if (composite.resourceGroup.recursive) {
    implicitGroupAvailType = $getAvailabilityType(composite, false);
    this$static.implicitAvailabilityImage.setSrc(getAvailabilityGroupLargeIcon(implicitGroupAvailType));
  }
   else {
    $setAttribute_24(this$static.implicitAvailabilityImage, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  }
}

function $toggleFavoriteLocally(this$static){
  var favorites;
  this$static.favorite = !this$static.favorite;
  favorites = $getPreferenceAsIntegerSet(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), '.dashContent.grouphealth.groups');
  this$static.favorite?favorites.add(valueOf_44(this$static.group.id)):favorites.remove_0(valueOf_44(this$static.group.id));
  return favorites;
}

function $update_0(this$static){
  var child, child$array, child$index, child$max, criteria, hlayout, tagEditorView;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  hlayout = new EnhancedHLayout_0;
  $addMember(this$static, hlayout);
  this$static.title_0 = new HTMLFlow_0;
  $setWidth_0(this$static.title_0, '*');
  this$static.explicitAvailabilityImage = new Img_2(getAvailabilityLargeIcon(null), 24, 24);
  $setPrompt_0(this$static.explicitAvailabilityImage, ($clinit_Enhanced() , 'Group availability for explicit members (does not include recursive members).'));
  this$static.implicitAvailabilityImage = new Img_2(getAvailabilityLargeIcon(null), 24, 24);
  $setPrompt_0(this$static.implicitAvailabilityImage, 'Group availability for all members (includes recursive members).');
  if (this$static.supportsFavorite) {
    this$static.favoriteButton = new Img_2('Favorite_24.png', 24, 24);
    $addClickHandler(this$static.favoriteButton, new ResourceGroupTitleBar$1_0(this$static));
  }
  this$static.expandCollapseArrow = new Img_2('[SKIN]/ListGrid/row_collapsed.png', 16, 16);
  $setPrompt_0(this$static.expandCollapseArrow, COLLAPSED_TOOLTIP);
  $setAttribute_24(this$static.expandCollapseArrow, 'layoutAlign', ($clinit_VerticalAlignment() , BOTTOM_1).value_0, false);
  criteria = new ResourceGroupCriteria_0;
  $addFilterId(criteria, valueOf_44(this$static.group.id));
  if (this$static.isAutoCluster) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  }
   else if (this$static.isAutoGroup) {
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $addFilterPrivate(criteria, TRUE);
  }
  $findResourceGroupCompositesByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), criteria, new ResourceGroupTitleBar$2_0(this$static));
  this$static.badge = new Img_2(getGroupLargeIcon(($clinit_GroupCategory() , MIXED_0)), 24, 24);
  tagEditorView = new TagEditorView_0(this$static.group.tags, false, new ResourceGroupTitleBar$3_0(this$static));
  $loadTags(this$static, tagEditorView);
  $addMember(hlayout, this$static.expandCollapseArrow);
  $addMember(hlayout, this$static.badge);
  $addMember(hlayout, this$static.title_0);
  $addMember(hlayout, this$static.explicitAvailabilityImage);
  $addMember(hlayout, this$static.implicitAvailabilityImage);
  this$static.supportsFavorite && $addMember(hlayout, this$static.favoriteButton);
  ($clinit_CoreGUI() , $clinit_CoreGUI() , enableTagsForUI) && $addMember(this$static, tagEditorView);
}

function $updateFavoriteButton(this$static){
  if (!this$static.supportsFavorite) {
    return;
  }
  this$static.favoriteButton.setSrc(this$static.favorite?'Favorite_24_Selected.png':'Favorite_24.png');
  this$static.favorite?$setPrompt_0(this$static.favoriteButton, ($clinit_Enhanced() , 'Click to remove this as a favorite')):$setPrompt_0(this$static.favoriteButton, ($clinit_Enhanced() , 'Click to add this as a favorite'));
}

function ResourceGroupTitleBar_0(isAutoGroup, isAutoCluster){
  $clinit_ResourceGroupTitleBar();
  EnhancedVLayout_0.call(this);
  this.isAutoGroup = isAutoGroup;
  this.isAutoCluster = isAutoCluster;
  this.supportsFavorite = !(this.isAutoGroup || this.isAutoCluster);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'height', 30):(this.config_0['height'] = 30 , undefined);
  $setPadding(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
}

defineSeed(3091, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$ResourceGroupTitleBar, Q$Enhanced]), ResourceGroupTitleBar_0);
_.badge = null;
_.expandCollapseArrow = null;
_.explicitAvailabilityImage = null;
_.favorite = false;
_.favoriteButton = null;
_.generalProperties = null;
_.group = null;
_.implicitAvailabilityImage = null;
_.isAutoCluster = false;
_.isAutoGroup = false;
_.supportsFavorite = false;
_.title_0 = null;
var COLLAPSED_TOOLTIP, EXPANDED_TOOLTIP;
function ResourceGroupTitleBar$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3092, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceGroupTitleBar$1_0);
_.onClick = function onClick_139(clickEvent){
  var favorites;
  favorites = $toggleFavoriteLocally(this.this$0);
  $setFavoriteResourceGroups(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), favorites, new ResourceGroupTitleBar$UpdateFavoritesCallback_0(this.this$0));
}
;
_.this$0 = null;
function $onSuccess_281(this$static, result){
  var resultComposite;
  if (!result || result.size_0 != 1) {
    $handleError_0(($clinit_CoreGUI() , 'Failed to get general info on group [' + ($clinit_Enhanced() , this$static.this$0.group.name_0) + '] with ID [' + this$static.this$0.group.id + ']'), null);
    return;
  }
  resultComposite = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroupComposite);
  $setGroupIcons(this$static.this$0, resultComposite);
  this$static.this$0.isAutoCluster && $setName_9(resultComposite.resourceGroup, this$static.this$0.group.name_0);
  this$static.this$0.generalProperties = new GeneralProperties_0(resultComposite, this$static.this$0, !(this$static.this$0.isAutoGroup || this$static.this$0.isAutoCluster));
  $setAttribute_24(this$static.this$0.generalProperties, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  $addMember(this$static.this$0, this$static.this$0.generalProperties);
  $addClickHandler(this$static.this$0.expandCollapseArrow, new ResourceGroupTitleBar$2$1_0(this$static));
}

function ResourceGroupTitleBar$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3093, 1, {}, ResourceGroupTitleBar$2_0);
_.onFailure = function onFailure_294(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to get general info on group [' + ($clinit_Enhanced() , this.this$0.group.name_0) + '] with ID [' + this.this$0.group.id + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_294(result){
  $onSuccess_281(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function ResourceGroupTitleBar$2$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3094, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceGroupTitleBar$2$1_0);
_.onClick = function onClick_140(event_0){
  this.collapsed = !this.collapsed;
  if (this.collapsed) {
    this.this$1.this$0.expandCollapseArrow.setSrc('[SKIN]/ListGrid/row_collapsed.png');
    $setPrompt_0(this.this$1.this$0.expandCollapseArrow, ($clinit_ResourceGroupTitleBar() , COLLAPSED_TOOLTIP));
    $hide(this.this$1.this$0.generalProperties);
  }
   else {
    this.this$1.this$0.expandCollapseArrow.setSrc('[SKIN]/ListGrid/row_expanded.png');
    $setPrompt_0(this.this$1.this$0.expandCollapseArrow, ($clinit_ResourceGroupTitleBar() , EXPANDED_TOOLTIP));
    $show(this.this$1.this$0.generalProperties);
  }
  $markForRedraw(this.this$1.this$0);
}
;
_.collapsed = true;
_.this$1 = null;
function ResourceGroupTitleBar$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3095, 1, {}, ResourceGroupTitleBar$3_0);
_.tagsChanged = function tagsChanged_3(tags){
  $updateResourceGroupTags(dynamicCast(secure(getInstance_56(), -1), Q$TagGWTServiceAsync), this.this$0.group.id, tags, new ResourceGroupTitleBar$3$1_0(this, tags));
}
;
_.this$0 = null;
function $onSuccess_282(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('The tags for [' + ($clinit_Enhanced() , this$static.this$1.this$0.group.name_0) + '] have been updated', ($clinit_Message$Severity() , Info)));
  $setTags_0(this$static.this$1.this$0.group, this$static.val$tags);
}

function ResourceGroupTitleBar$3$1_0(this$1, val$tags){
  this.this$1 = this$1;
  this.val$tags = val$tags;
}

defineSeed(3096, 1, {}, ResourceGroupTitleBar$3$1_0);
_.onFailure = function onFailure_295(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to update the tags for [' + ($clinit_Enhanced() , this.this$1.this$0.group.name_0) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_295(result){
  $onSuccess_282(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$tags = null;
function $onSuccess_283(this$static, result){
  var tags;
  tags = new LinkedHashSet_0;
  $addAll(tags, dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroup).tags);
  $setTags_1(this$static.val$tagEditorView, tags);
}

function ResourceGroupTitleBar$4_0(this$0, val$tagEditorView){
  this.this$0 = this$0;
  this.val$tagEditorView = val$tagEditorView;
}

defineSeed(3097, 1, {}, ResourceGroupTitleBar$4_0);
_.onFailure = function onFailure_296(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load the tags for [' + ($clinit_Enhanced() , this.this$0.group.name_0) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_296(result){
  $onSuccess_283(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$tagEditorView = null;
function $onSuccess_284(this$static){
  var m_0;
  this$static.this$0.favorite?(m_0 = 'You have added [' + ($clinit_Enhanced() , this$static.this$0.group.name_0) + '] as a favorite'):(m_0 = 'You have removed [' + ($clinit_Enhanced() , this$static.this$0.group.name_0) + '] as one of your favorites');
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(m_0, ($clinit_Message$Severity() , Info)));
  $updateFavoriteButton(this$static.this$0);
}

function ResourceGroupTitleBar$UpdateFavoritesCallback_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3098, 1, {}, ResourceGroupTitleBar$UpdateFavoritesCallback_0);
_.onFailure = function onFailure_297(throwable){
  var m_0;
  this.this$0.favorite?(m_0 = 'Failed to add [' + ($clinit_Enhanced() , this.this$0.group.name_0) + '] as a favorite'):(m_0 = 'Failed to remove [' + ($clinit_Enhanced() , this.this$0.group.name_0) + '] as one of your favorites');
  $handleError_0(($clinit_CoreGUI() , m_0), throwable);
  $toggleFavoriteLocally(this.this$0);
}
;
_.onSuccess_0 = function onSuccess_297(subject){
  $onSuccess_284(this, dynamicCast(subject, Q$Subject));
}
;
_.this$0 = null;
function $setContent_1(this$static, newContent){
  var child, child$array, child$index, child$max;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.contentCanvas, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.contentCanvas, newContent);
  this$static.contentCanvas.markForRedraw_0();
}

function ResourceGroupTopView_0(){
  $clinit_ResourceGroupTopView();
  EnhancedHLayout_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  this.treeView = new ResourceGroupTreeView_0;
  $addMember(this, this.treeView);
  this.contentCanvas = new Canvas_1;
  $addMember(this, this.contentCanvas);
}

defineSeed(3099, 1539, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$Enhanced, Q$EnhancedHLayout]), ResourceGroupTopView_0);
_.renderView = function renderView_27(viewPath){
  var isAutoClusterPath;
  isAutoClusterPath = $equals_6('AutoCluster', (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  isAutoClusterPath != this.isAutoClusterView && (this.detailView = null);
  if (!this.detailView) {
    isAutoClusterPath?(this.detailView = new ResourceGroupDetailView_0('ResourceGroup/AutoCluster')):(this.detailView = new ResourceGroupDetailView_0(VIEW_ID_22.name_0));
    this.isAutoClusterView = isAutoClusterPath;
    $setContent_1(this, this.detailView);
  }
  $renderView_10(this.treeView, viewPath);
  $renderView_9(this.detailView, viewPath);
}
;
_.contentCanvas = null;
_.detailView = null;
_.isAutoClusterView = false;
_.treeView = null;
function $showContextMenu_2(this$static, treeGrid, node){
  var clusterKey, criteria;
  if (!!dynamicCast(getAttributeAsObject(node.jsObj, 'resourceType'), Q$ResourceType) && !!dynamicCast(getAttributeAsObject(node.jsObj, 'key'), Q$ClusterKey) && !$equals_6(getAttribute(node.jsObj, 'parentId'), '__fakeRoot__')) {
    clusterKey = dynamicCast(getAttributeAsObject(node.jsObj, 'key'), Q$ClusterKey);
    $createAutoClusterBackingGroup(dynamicCast(secure(getInstance_37(), -1), Q$ClusterGWTServiceAsync), clusterKey, new ResourceGroupTreeContextMenu$1_0(this$static, clusterKey, treeGrid, node));
  }
   else if ($equals_6(getAttribute(node.jsObj, 'parentId'), '__fakeRoot__') && !!dynamicCast(getAttributeAsObject(node.jsObj, 'resourceType'), Q$ResourceType) && !dynamicCast(getAttributeAsObject(node.jsObj, 'key'), Q$ClusterKey)) {
    criteria = new ResourceGroupCriteria_0;
    $addFilterId(criteria, valueOf_44(__parseAndValidateInt(getAttribute(node.jsObj, 'id'))));
    $findResourceGroupsByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), criteria, new ResourceGroupTreeContextMenu$2_0(this$static, treeGrid, node));
  }
}

function ResourceGroupTreeContextMenu_0(){
  ResourceGroupContextMenu_0.call(this);
}

defineSeed(3100, 3059, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$Menu]), ResourceGroupTreeContextMenu_0);
function $onSuccess_285(this$static, result){
  $showContextMenu_0(this$static.this$0, this$static.val$treeGrid, this$static.val$node, result);
}

function ResourceGroupTreeContextMenu$1_0(this$0, val$clusterKey, val$treeGrid, val$node){
  this.this$0 = this$0;
  this.val$clusterKey = val$clusterKey;
  this.val$treeGrid = val$treeGrid;
  this.val$node = val$node;
}

defineSeed(3101, 1, {}, ResourceGroupTreeContextMenu$1_0);
_.onFailure = function onFailure_298(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to create or update autocluster backing group. key: [' + $getKey(this.val$clusterKey) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_298(result){
  $onSuccess_285(this, dynamicCast(result, Q$ResourceGroup));
}
;
_.this$0 = null;
_.val$clusterKey = null;
_.val$node = null;
_.val$treeGrid = null;
function $onSuccess_286(this$static, result){
  $showContextMenu_0(this$static.this$0, this$static.val$treeGrid, this$static.val$node, dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroup));
}

function ResourceGroupTreeContextMenu$2_0(this$0, val$treeGrid, val$node){
  this.this$0 = this$0;
  this.val$treeGrid = val$treeGrid;
  this.val$node = val$node;
}

defineSeed(3102, 1, {}, ResourceGroupTreeContextMenu$2_0);
_.onFailure = function onFailure_299(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load group for context menu'), caught);
}
;
_.onSuccess_0 = function onSuccess_299(result){
  $onSuccess_286(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$node = null;
_.val$treeGrid = null;
function $createAutoTypeGroupNode(this$static, parentKey, type, memberNodes){
  var autoTypeGroupNode, autoTypeGroupNodeId, memberNode, memberNode$iterator, name_0, parentId;
  name_0 = pluralize(type.name_0);
  autoTypeGroupNode = new ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_0(name_0);
  parentId = $getKey(parentKey);
  autoTypeGroupNodeId = 'rt' + type.id;
  $setAttribute_13(autoTypeGroupNode, 'id', getSafeId(autoTypeGroupNodeId));
  $setAttribute_13(autoTypeGroupNode, 'parentId', getSafeId(parentId));
  !type?(autoTypeGroupNode.jsObj['resourceType'] = null , undefined):(autoTypeGroupNode.jsObj['resourceType'] = type , undefined);
  autoTypeGroupNode.jsObj['isFolder'] = true;
  for (memberNode$iterator = new AbstractList$IteratorImpl_0(memberNodes); memberNode$iterator.i < memberNode$iterator.this$0_0.size_1();) {
    memberNode = dynamicCast($next_0(memberNode$iterator), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode);
    $setAttribute_13(memberNode, 'parentId', getSafeId(autoTypeGroupNodeId));
  }
  $setAttribute_17(autoTypeGroupNode, 'children', (sort_1(memberNodes, this$static.treeNodeComparator) , dynamicCast($toArray_1(memberNodes, initDim(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_$1]), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode, memberNodes.size_0, 0)), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_$1)));
  return autoTypeGroupNode;
}

function $createClusterGroupNode(parentKey, type, child){
  var childName, clusterSize, id, key, keyFlyweight, memberCount, node, parentId, percentage, percentageStr, title;
  childName = child.name_0 != null?child.name_0:'?';
  $equals_6('...', childName) && (childName = 'Group of [' + ($clinit_Enhanced() , type.name_0) + ']');
  node = new ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_0(childName);
  keyFlyweight = child.clusterKey;
  key = new ClusterKey_1(parentKey, keyFlyweight.resourceTypeId, keyFlyweight.resourceKey);
  id = $getKey(key);
  parentId = $getKey(parentKey);
  $setAttribute_13(node, 'id', getSafeId(id));
  $setAttribute_13(node, 'parentId', getSafeId(parentId));
  !key?(node.jsObj['key'] = null , undefined):(node.jsObj['key'] = key , undefined);
  !type?(node.jsObj['resourceType'] = null , undefined):(node.jsObj['resourceType'] = type , undefined);
  $setAttribute_16(node, 'isFolder', !child.children_0.isEmpty_0());
  memberCount = child.members_0;
  clusterSize = child.clusterSize;
  if (memberCount < clusterSize) {
    percentage = memberCount / clusterSize;
    percentageStr = $format_0(($clinit_NumberFormat() , new NumberFormat_1('0%', $getDefaultNative(), true)), percentage);
    title = childName + ' <span style="color: red; font-style: italic">(' + percentageStr + ')<\/span>';
    node.jsObj['title'] = title;
    $setAttribute_13(node, 'tooltip', ($clinit_Enhanced() , '' + memberCount) + ' out of ' + clusterSize + " group members have a '" + childName + "' resource");
  }
  return node;
}

function $getTreeTypes(this$static, clusterFlyweight, typeIds){
  var child, child$iterator;
  !!clusterFlyweight.clusterKey && typeIds.add(valueOf_44(clusterFlyweight.clusterKey.resourceTypeId));
  for (child$iterator = clusterFlyweight.children_0.iterator(); child$iterator.hasNext();) {
    child = dynamicCast(child$iterator.next_0(), Q$ClusterFlyweight);
    $getTreeTypes(this$static, child, typeIds);
  }
}

function $loadGroup(this$static, groupId){
  var parents, selectedNode;
  if (groupId == this$static.rootGroupId) {
    this$static.currentGroup.clusterKey != null?(selectedNode = dynamicCast($find(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), 'key', this$static.currentGroup.clusterKey), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode)):(selectedNode = dynamicCast($findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), '' + this$static.currentGroup.id), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode));
    if (selectedNode) {
      parents = $getParents(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), selectedNode);
      $openFolders(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), parents);
      $openFolder(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), selectedNode);
      $selectRecord(this$static.treeGrid, selectedNode);
    }
  }
   else {
    this$static.rootGroupId = groupId;
    $getClusterTree(dynamicCast(secure(getInstance_37(), -1), Q$ClusterGWTServiceAsync), groupId, new ResourceGroupTreeView$6_0(this$static));
  }
}

function $loadTree(this$static, root){
  var escapedGroupName, fakeRoot, groupName, icon, rootKey, rootNode, rootResourceType, tree, treeString, rootNode_0, str;
  rootKey = new ClusterKey_0(root.groupId);
  fakeRoot = new ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_0('fakeRootNode');
  $setAttribute_13(fakeRoot, 'id', getSafeId('__fakeRoot__'));
  groupName = this$static.rootResourceGroup.name_0;
  escapedGroupName = escapeHtml(groupName);
  rootNode = new ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_0(escapedGroupName);
  $setAttribute_13(rootNode, 'id', getSafeId($getKey(rootKey)));
  $setAttribute_13(rootNode, 'parentId', getSafeId(getAttribute(fakeRoot.jsObj, 'id')));
  rootResourceType = dynamicCast(this$static.typeMap.get_2(valueOf_44(this$static.rootResourceGroup.resourceType.id)), Q$ResourceType);
  !rootResourceType?(rootNode.jsObj['resourceType'] = null , undefined):(rootNode.jsObj['resourceType'] = rootResourceType , undefined);
  icon = getClusteredResourceIcon(rootResourceType.category);
  rootNode.jsObj['icon'] = icon;
  fakeRoot.jsObj['children'] = convertToJavaScriptArray(initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_$1]), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode, [rootNode]));
  $loadTree_0(this$static, rootNode, root, rootKey);
  tree = new Tree_0;
  $setAttribute(tree, fakeRoot.jsObj);
  treeString = (rootNode_0 = getOrCreateRef_14($isCreated(tree)?getAttributeAsJavaScriptObject($getJsObj(tree), 'root'):$getAttributeAsJavaScriptObject(tree, 'root')) , str = new StringBuilder_0 , appendTreeNode(tree, rootNode_0, str) , $toString_1(str.data_0));
  $clinit_Log();
  $info_0(logger_0, treeString);
  $setData_0(this$static.treeGrid, tree);
  $openFolder(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), rootNode);
  $selectRecord(this$static.treeGrid, rootNode);
}

function $loadTree_0(this$static, parentNode, parentClusterGroup, parentKey){
  var autoTypeGroupNode, child, child$iterator, childNodes, childType, childType$iterator, children, childrenByType, currentSubCategory, currentSubcategoryChild, currentSubcategoryChild$iterator, currentSubcategoryChildren, currentSubcategoryNode, currentSubcategoryNodeCreated, key, keyFlyweight, lastSubcategoryNode, node, nodesByType, subCategoryChildrenByName, subCategoryNodesByName, subcatChild, subcatChild$iterator, subcategory, subcategoryChildren, subcategoryName, subcategoryName$iterator, subcategoryNode, type;
  if (!parentClusterGroup.children_0.isEmpty_0()) {
    childrenByType = new HashMap_0;
    for (child$iterator = parentClusterGroup.children_0.iterator(); child$iterator.hasNext();) {
      child = dynamicCast(child$iterator.next_0(), Q$ClusterFlyweight);
      keyFlyweight = child.clusterKey;
      type = dynamicCast(this$static.typeMap.get_2(valueOf_44(keyFlyweight.resourceTypeId)), Q$ResourceType);
      children = dynamicCast(childrenByType.get_2(type), Q$List);
      if (!children) {
        children = new ArrayList_0;
        childrenByType.put(type, children);
      }
      children.add(child);
    }
    childNodes = new ArrayList_0;
    subCategoryNodesByName = new HashMap_0;
    subCategoryChildrenByName = new HashMap_0;
    for (childType$iterator = $iterator($keySet(childrenByType)); childType$iterator.val$outerIter.hasNext();) {
      childType = dynamicCast($next_1(childType$iterator), Q$ResourceType);
      children = dynamicCast(childrenByType.get_2(childType), Q$List);
      nodesByType = new ArrayList_0;
      for (child$iterator = children.iterator(); child$iterator.hasNext();) {
        child = dynamicCast(child$iterator.next_0(), Q$ClusterFlyweight);
        node = $createClusterGroupNode(parentKey, childType, child);
        setCheck(nodesByType.array, nodesByType.size_0++, node);
        if (!child.children_0.isEmpty_0()) {
          key = dynamicCast(getAttributeAsObject(node.jsObj, 'key'), Q$ClusterKey);
          $loadTree_0(this$static, node, child, key);
        }
      }
      if (!childType.singleton) {
        autoTypeGroupNode = $createAutoTypeGroupNode(this$static, parentKey, childType, nodesByType);
        nodesByType.array = initDim(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, 0, 0);
        nodesByType.size_0 = 0;
        setCheck(nodesByType.array, nodesByType.size_0++, autoTypeGroupNode);
      }
      subcategory = childType.subCategory;
      if (subcategory) {
        lastSubcategoryNode = null;
        currentSubCategory = subcategory;
        currentSubcategoryNodeCreated = false;
        do {
          currentSubcategoryNode = dynamicCast(subCategoryNodesByName.get_2(currentSubCategory.name_0), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode);
          if (!currentSubcategoryNode) {
            currentSubcategoryNode = new ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_0(currentSubCategory.name_0);
            $setAttribute_13(currentSubcategoryNode, 'title', currentSubCategory.displayName);
            currentSubcategoryNode.jsObj['isFolder'] = true;
            $setAttribute_13(currentSubcategoryNode, 'id', getSafeId('cat' + currentSubCategory.name_0));
            $setAttribute_13(currentSubcategoryNode, 'parentId', getSafeId($getKey(parentKey)));
            subCategoryNodesByName.put(currentSubCategory.name_0, currentSubcategoryNode);
            subCategoryChildrenByName.put(currentSubCategory.name_0, new ArrayList_0);
            !currentSubCategory.parentSubCategory && (setCheck(childNodes.array, childNodes.size_0++, currentSubcategoryNode) , true);
            currentSubcategoryNodeCreated = true;
          }
          if (lastSubcategoryNode) {
            currentSubcategoryChildren = dynamicCast(subCategoryChildrenByName.get_2(getAttribute(currentSubcategoryNode.jsObj, 'name')), Q$List);
            for (currentSubcategoryChild$iterator = currentSubcategoryChildren.iterator(); currentSubcategoryChild$iterator.hasNext();) {
              currentSubcategoryChild = dynamicCast(currentSubcategoryChild$iterator.next_0(), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode);
              $setAttribute_13(currentSubcategoryChild, 'parentId', getSafeId(getAttribute(currentSubcategoryNode.jsObj, 'id')));
            }
            currentSubcategoryChildren.add(lastSubcategoryNode);
          }
          lastSubcategoryNode = currentSubcategoryNode;
        }
         while (currentSubcategoryNodeCreated && !!(currentSubCategory = currentSubCategory.parentSubCategory));
        subcategoryChildren = dynamicCast(subCategoryChildrenByName.get_2(subcategory.name_0), Q$List);
        subcategoryChildren.addAll(nodesByType);
      }
       else {
        $addAll_0(childNodes, nodesByType);
      }
    }
    for (subcategoryName$iterator = $iterator($keySet(subCategoryNodesByName)); subcategoryName$iterator.val$outerIter.hasNext();) {
      subcategoryName = dynamicCast($next_1(subcategoryName$iterator), Q$String);
      subcategoryNode = dynamicCast(subCategoryNodesByName.get_2(subcategoryName), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode);
      subcategoryChildren = dynamicCast(subCategoryChildrenByName.get_2(subcategoryName), Q$List);
      for (subcatChild$iterator = subcategoryChildren.iterator(); subcatChild$iterator.hasNext();) {
        subcatChild = dynamicCast(subcatChild$iterator.next_0(), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode);
        $setAttribute_13(subcatChild, 'parentId', getSafeId(getAttribute(subcategoryNode.jsObj, 'id')));
      }
      sort_1(subcategoryChildren, this$static.treeNodeComparator);
      dynamicCast(subcategoryChildren.toArray_0(initDim(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_$1]), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode, subcategoryChildren.size_1(), 0)), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_$1);
      $setAttribute_17(subcategoryNode, 'children', (sort_1(subcategoryChildren, this$static.treeNodeComparator) , dynamicCast(subcategoryChildren.toArray_0(initDim(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_$1]), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode, subcategoryChildren.size_1(), 0)), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_$1)));
    }
    $setAttribute_17(parentNode, 'children', (sort_1(childNodes, this$static.treeNodeComparator) , dynamicCast($toArray_1(childNodes, initDim(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_$1]), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode, childNodes.size_0, 0)), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_$1)));
  }
}

function $loadTreeTypes(this$static, root){
  var typeIds;
  typeIds = new HashSet_0;
  $add_6(typeIds, valueOf_44(this$static.rootResourceGroup.resourceType.id));
  $getTreeTypes(this$static, root, typeIds);
  $getResourceTypes_0(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), dynamicCast(typeIds.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typeIds.map.size_1(), 0)), Q$Integer_$1), of(($clinit_ResourceTypeRepository$MetadataType() , subCategory_0)), new ResourceGroupTreeView$7_0(this$static, root));
}

function $renderView_10(this$static, viewPath){
  var clusterGroupId, clusterGroupIdString, currentViewIdPath, groupId, groupIdString;
  this$static.currentViewId = viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId);
  if (this$static.currentViewId) {
    currentViewIdPath = this$static.currentViewId.path;
    if ($equals_6('AutoCluster', currentViewIdPath)) {
      this$static.currentViewId = dynamicCast($get_0(viewPath.viewPath, viewPath.index_0 + 1), Q$ViewId);
      clusterGroupIdString = this$static.currentViewId.path;
      clusterGroupId = valueOf_44(__parseAndValidateInt(clusterGroupIdString));
      $setSelectedGroup(this$static, clusterGroupId.value_0, true);
    }
     else {
      groupIdString = this$static.currentViewId.path;
      groupId = __parseAndValidateInt(groupIdString);
      $setSelectedGroup(this$static, groupId, false);
    }
  }
}

function $setSelectedGroup(this$static, groupId, isAutoCluster){
  var criteria;
  criteria = new ResourceGroupCriteria_0;
  $addFilterId(criteria, valueOf_44(groupId));
  $addFilterVisible(criteria, ($clinit_Boolean() , isAutoCluster?FALSE:TRUE));
  criteria.fetchResourceType = true;
  $findResourceGroupsByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), criteria, new ResourceGroupTreeView$5_0(this$static, groupId));
}

function ResourceGroupTreeView_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.treeNodeComparator = new ResourceGroupTreeView$1_0;
  $isCreated_1(this)?$setProperty_0(this, 'width', 250):(this.config_0['width'] = 250 , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $setShowResizeBar(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
}

defineSeed(3103, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), ResourceGroupTreeView_0);
_.onInit = function onInit_61(){
  $onInit(this);
  $onInit_Layout(this);
  this.treeGrid = new CustomResourceGroupTreeGrid_0;
  $setAttribute_24(this.treeGrid, 'width', '100%', true);
  $setAttribute_24(this.treeGrid, 'height', '100%', true);
  $setAttribute_22(this.treeGrid, 'animateFolders', ($clinit_Boolean() , $clinit_Boolean() , FALSE), true);
  $setAttribute_24(this.treeGrid, 'selectionType', ($clinit_SelectionStyle() , SINGLE).value_0, true);
  $setShowRollOver_2(this.treeGrid, FALSE);
  $setShowHeader_0(this.treeGrid, FALSE);
  $setLeaveScrollbarGap(this.treeGrid, FALSE);
  $setAttribute_24(this.treeGrid, 'openerImage', 'resources/dir.png', false);
  $setAttribute_23(this.treeGrid, 'openerIconSize', valueOf_44(16));
  $setCanHover(this.treeGrid, TRUE);
  $setShowHover(this.treeGrid, TRUE);
  $setHoverWidth(this.treeGrid, valueOf_44(250));
  $setHoverWrap(this.treeGrid, TRUE);
  $setHoverCustomizer(this.treeGrid, new ResourceGroupTreeView$2_0);
  this.contextMenu = new ResourceGroupTreeContextMenu_0;
  $setContextMenu(this.treeGrid, this.contextMenu);
  $addNodeContextClickHandler(this.treeGrid, new ResourceGroupTreeView$3_0(this));
  $addSelectionChangedHandler(this.treeGrid, new ResourceGroupTreeView$4_0(this));
  $addMember(this, this.treeGrid);
}
;
_.renderView = function renderView_28(viewPath){
  $renderView_10(this, viewPath);
}
;
_.contextMenu = null;
_.currentGroup = null;
_.currentNodeId = null;
_.currentViewId = null;
_.rootGroupId = 0;
_.rootResourceGroup = null;
_.treeGrid = null;
_.typeMap = null;
function $compare_11(o1, o2){
  var o1IsClusterNode, o1IsFolder, o2IsClusterNode, o2IsFolder, s1, s2;
  o1IsFolder = $isFolderNode(o1);
  o2IsFolder = $isFolderNode(o2);
  if (o1IsFolder != o2IsFolder) {
    return o1IsFolder?-1:1;
  }
   else if (o1IsFolder) {
    o1IsClusterNode = !!dynamicCast(getAttributeAsObject(o1.jsObj, 'key'), Q$ClusterKey);
    o2IsClusterNode = !!dynamicCast(getAttributeAsObject(o2.jsObj, 'key'), Q$ClusterKey);
    if (o1IsClusterNode != o2IsClusterNode) {
      return o1IsClusterNode?1:-1;
    }
  }
  s1 = getAttribute(o1.jsObj, 'name');
  s2 = getAttribute(o2.jsObj, 'name');
  return compareTo_11(s1.toLowerCase(), s2.toLowerCase());
}

function ResourceGroupTreeView$1_0(){
}

defineSeed(3104, 1, makeCastMap([Q$Comparator]), ResourceGroupTreeView$1_0);
_.compare = function compare_12(o1, o2){
  return $compare_11(dynamicCast(o1, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode), dynamicCast(o2, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode));
}
;
function ResourceGroupTreeView$2_0(){
}

defineSeed(3105, 1, {}, ResourceGroupTreeView$2_0);
_.hoverHTML_0 = function hoverHTML_31(value, record, rowNum, colNum){
  var tooltip;
  tooltip = getAttribute(record.jsObj, 'tooltip');
  return tooltip;
}
;
function ResourceGroupTreeView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3106, 1, makeCastMap([Q$EventHandler, Q$NodeContextClickHandler]), ResourceGroupTreeView$3_0);
_.onNodeContextClick = function onNodeContextClick(event_0){
  var contextNode, currentNode;
  event_0.cancel = true;
  contextNode = dynamicCast($getNode_0(event_0), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode);
  if (null != this.this$0.currentNodeId) {
    currentNode = $findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$0.treeGrid, 'data')), this.this$0.currentNodeId);
    if (contextNode != currentNode) {
      $deselectRecord(this.this$0.treeGrid, contextNode);
      $selectRecord(this.this$0.treeGrid, currentNode);
    }
  }
  ($equals_6(getAttribute(contextNode.jsObj, 'parentId'), '__fakeRoot__') && !!dynamicCast(getAttributeAsObject(contextNode.jsObj, 'resourceType'), Q$ResourceType) && !dynamicCast(getAttributeAsObject(contextNode.jsObj, 'key'), Q$ClusterKey) || !!dynamicCast(getAttributeAsObject(contextNode.jsObj, 'resourceType'), Q$ResourceType) && !!dynamicCast(getAttributeAsObject(contextNode.jsObj, 'key'), Q$ClusterKey) && !$equals_6(getAttribute(contextNode.jsObj, 'parentId'), '__fakeRoot__')) && $showContextMenu_2(this.this$0.contextMenu, this.this$0.treeGrid, contextNode);
}
;
_.this$0 = null;
function ResourceGroupTreeView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3107, 1, makeCastMap([Q$EventHandler, Q$SelectionChangedHandler]), ResourceGroupTreeView$4_0);
_.onSelectionChanged = function onSelectionChanged_9(selectionEvent){
  var currentNode, currentViewPath, key, newNode, viewPath;
  if (!$isRightButtonDown() && $getState(selectionEvent)) {
    newNode = dynamicCast($getRecord_1(selectionEvent), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode);
    currentNode = null != this.this$0.currentNodeId?$findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$0.treeGrid, 'data')), this.this$0.currentNodeId):null;
    if (currentNode) {
      if (newNode == currentNode) {
        return;
      }
       else {
        $deselectRecord(this.this$0.treeGrid, currentNode);
      }
    }
    $clinit_Log();
    $fine_0(logger_0, 'Node selected in tree: ' + newNode);
    if ($equals_6(getAttribute(newNode.jsObj, 'parentId'), '__fakeRoot__') && !!dynamicCast(getAttributeAsObject(newNode.jsObj, 'resourceType'), Q$ResourceType) && !dynamicCast(getAttributeAsObject(newNode.jsObj, 'key'), Q$ClusterKey)) {
      this.this$0.currentNodeId = getAttribute(newNode.jsObj, 'id');
      debug('Selecting compatible group [' + this.this$0.currentNodeId + ']...');
      viewPath = '#ResourceGroup/' + __parseAndValidateInt(this.this$0.currentNodeId);
      currentViewPath = ($clinit_History() , impl_0?token_1 == null?'':token_1:'');
      $indexOf_2(currentViewPath, $substring(viewPath, 1)) == 0?$markForRedraw_0(this.this$0.treeGrid):($clinit_CoreGUI() , goToView(viewPath, null, true));
    }
     else if (!!dynamicCast(getAttributeAsObject(newNode.jsObj, 'resourceType'), Q$ResourceType) && !!dynamicCast(getAttributeAsObject(newNode.jsObj, 'key'), Q$ClusterKey) && !$equals_6(getAttribute(newNode.jsObj, 'parentId'), '__fakeRoot__')) {
      key = dynamicCast(getAttributeAsObject(newNode.jsObj, 'key'), Q$ClusterKey);
      $fine_0(logger_0, 'Selecting autocluster group [' + key + ']...');
      this.this$0.currentNodeId = getAttribute(newNode.jsObj, 'id');
      $createAutoClusterBackingGroup(dynamicCast(secure(getInstance_37(), -1), Q$ClusterGWTServiceAsync), key, new ResourceGroupTreeView$8_0(key));
    }
     else if ($equals_6(getAttribute(newNode.jsObj, 'parentId'), '__fakeRoot__') && !dynamicCast(getAttributeAsObject(newNode.jsObj, 'resourceType'), Q$ResourceType)) {
      this.this$0.currentNodeId = getAttribute(newNode.jsObj, 'id');
      debug('Selecting mixed group [' + this.this$0.currentNodeId + ']...');
    }
     else {
      $deselectRecord(this.this$0.treeGrid, newNode);
      !!currentNode && $selectRecord(this.this$0.treeGrid, currentNode);
    }
  }
  return;
}
;
_.this$0 = null;
function $onSuccess_287(this$static, result){
  var escapedGroupName, fakeRoot, group, groupCategory, groupName, icon, rootNode, tree;
  if (result.size_0 == 0) {
    return;
  }
  group = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroup);
  this$static.this$0.currentGroup = group;
  groupCategory = group.groupCategory;
  switch (groupCategory.ordinal) {
    case 1:
      this$static.this$0.rootResourceGroup = group;
      this$static.this$0.rootGroupId = this$static.this$0.rootResourceGroup.id;
      fakeRoot = new ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_0('fakeRootNode');
      groupName = group.name_0;
      escapedGroupName = escapeHtml(groupName);
      rootNode = new ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_0(escapedGroupName);
      icon = getGroupIcon(($clinit_GroupCategory() , MIXED_0));
      rootNode.jsObj['icon'] = icon;
      $setAttribute_13(rootNode, 'id', getSafeId('' + this$static.this$0.rootResourceGroup.id));
      $setAttribute_13(fakeRoot, 'id', getSafeId('__fakeRoot__'));
      $setAttribute_13(rootNode, 'parentId', getSafeId(getAttribute(fakeRoot.jsObj, 'id')));
      fakeRoot.jsObj['children'] = convertToJavaScriptArray(initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_$1]), Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode, [rootNode]));
      tree = new Tree_0;
      $setAttribute(tree, fakeRoot.jsObj);
      $setData_0(this$static.this$0.treeGrid, tree);
      $selectRecord(this$static.this$0.treeGrid, rootNode);
      break;
    case 0:
      !group.clusterResourceGroup?(this$static.this$0.rootResourceGroup = group):(this$static.this$0.rootResourceGroup = group.clusterResourceGroup);
      $loadGroup(this$static.this$0, this$static.this$0.rootResourceGroup.id);
  }
}

function ResourceGroupTreeView$5_0(this$0, val$groupId){
  this.this$0 = this$0;
  this.val$groupId = val$groupId;
}

defineSeed(3108, 1, {}, ResourceGroupTreeView$5_0);
_.onFailure = function onFailure_300(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load group with id [' + ($clinit_Enhanced() , '' + this.val$groupId) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_300(result){
  $onSuccess_287(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$groupId = 0;
function $onSuccess_288(this$static, result){
  $loadTreeTypes(this$static.this$0, result);
}

function ResourceGroupTreeView$6_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3109, 1, {}, ResourceGroupTreeView$6_0);
_.onFailure = function onFailure_301(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load group tree'), caught);
}
;
_.onSuccess_0 = function onSuccess_301(result){
  $onSuccess_288(this, dynamicCast(result, Q$ClusterFlyweight));
}
;
_.this$0 = null;
function ResourceGroupTreeView$7_0(this$0, val$root){
  this.this$0 = this$0;
  this.val$root = val$root;
}

defineSeed(3110, 1, {}, ResourceGroupTreeView$7_0);
_.onTypesLoaded_0 = function onTypesLoaded_21(types){
  this.this$0.typeMap = types;
  $loadTree(this.this$0, this.val$root);
}
;
_.this$0 = null;
_.val$root = null;
function ResourceGroupTreeView$8_0(val$key){
  this.val$key = val$key;
}

defineSeed(3111, 1, {}, ResourceGroupTreeView$8_0);
_.onFailure = function onFailure_302(caught){
  caught.getMessage().indexOf('IllegalStateException') != -1?($clinit_CoreGUI() , goToView('#ResourceGroup/' + this.val$key.clusterGroupId, null, false)):$handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to create or update autocluster backing group'), caught);
}
;
_.onSuccess_0 = function onSuccess_302(result){
  var viewPath, currentViewPath;
  viewPath = 'ResourceGroup/AutoCluster/' + dynamicCast(result, Q$ResourceGroup).id;
  currentViewPath = ($clinit_History() , impl_0?token_1 == null?'':token_1:'');
  currentViewPath.indexOf(viewPath) == 0 || ($clinit_CoreGUI() , goToView(viewPath, null, false));
}
;
_.val$key = null;
function ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_0(name_0){
  TreeNode_2.call(this, name_0);
  name_0 != null && (this.jsObj['title'] = name_0 , undefined);
}

defineSeed(3112, 2399, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$EnhancedTreeNode, Q$ResourceGroupTreeView$ResourceGroupEnhancedTreeNode]), ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_0);
_.setID = function setID_2(id){
  $setAttribute_13(this, 'id', getSafeId(id));
}
;
_.setParentID = function setParentID_0(parentID){
  $setAttribute_13(this, 'parentId', getSafeId(parentID));
}
;
function $onSuccess_289(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function GroupResourceConfigurationDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3113, 1, {}, GroupResourceConfigurationDataSource$1_0);
_.onFailure = function onFailure_303(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to get group resource config history'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_303(result){
  $onSuccess_289(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $convertToCompositeList(this$static){
  var memberConfiguration, memberConfiguration$iterator, resourceConfigurations;
  resourceConfigurations = new ArrayList_1(this$static.memberConfigurations.size_0);
  for (memberConfiguration$iterator = new AbstractList$IteratorImpl_0(this$static.memberConfigurations); memberConfiguration$iterator.i < memberConfiguration$iterator.this$0_0.size_1();) {
    memberConfiguration = dynamicCast($next_0(memberConfiguration$iterator), Q$GroupMemberConfiguration);
    $add_3(resourceConfigurations, new ResourceConfigurationComposite_0(memberConfiguration.id, memberConfiguration.configuration));
  }
  return resourceConfigurations;
}

function $handleLoadFailure(this$static, caught){
  var msg;
  this$static.refreshing = false;
  if (caught.getMessage().indexOf('ConfigurationUpdateStillInProgressException') != -1) {
    msg = 'Failed to retrieve member Resource configurations for [' + ($clinit_Enhanced() , $toString_19(this$static.group)) + ']';
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(msg, ($clinit_Message$Severity() , Warning)));
  }
   else {
    $handleError_0(($clinit_CoreGUI() , 'Failed to retrieve member Resource configurations for [' + ($clinit_Enhanced() , $toString_19(this$static.group)) + ']'), caught);
  }
}

function $initEditor(this$static){
  if (!!this$static.configurationDefinition && !!this$static.memberConfigurations) {
    this$static.editor = new GroupConfigurationEditor_0(this$static.configurationDefinition, this$static.memberConfigurations);
    $setAttribute_24(this$static.editor, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
    $addPropertyValueChangeListener(this$static.editor, this$static);
    $setReadOnly_1(this$static.editor, !this$static.resourcePermission.permissions.contains_0(($clinit_Permission() , CONFIGURE_WRITE)));
    $addMember(this$static, this$static.editor);
    $addMember(this$static, (this$static.buttonbar = new ToolStrip_0 , $setAttribute_24(this$static.buttonbar, 'width', '100%', true) , $setExtraSpace(this$static.buttonbar, 10) , $setMembersMargin(this$static.buttonbar, 5) , $setLayoutMargin(this$static.buttonbar, valueOf_44(5)) , this$static.saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save')) , $addClickHandler(this$static.saveButton, new GroupResourceConfigurationEditView$1_0(this$static)) , $disable(this$static.saveButton) , $addMember(this$static.buttonbar, this$static.saveButton) , this$static.buttonbar));
    this$static.refreshing = false;
  }
}

function $loadConfigurationDefinition(this$static){
  var type;
  if (!this$static.configurationDefinition) {
    type = this$static.group.resourceType;
    $getResourceTypes_0(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(type.id)]), of(($clinit_ResourceTypeRepository$MetadataType() , resourceConfigurationDefinition_0)), new GroupResourceConfigurationEditView$2_0(this$static, type));
  }
}

function $refresh_18(this$static){
  if (this$static.refreshing) {
    return;
  }
  this$static.refreshing = true;
  if (this$static.editor) {
    $destroy_1(this$static.editor);
    $removeMember(this$static, this$static.editor);
    this$static.buttonbar.destroy_0();
    $removeMember(this$static, this$static.buttonbar);
  }
  $loadConfigurationDefinition(this$static);
  this$static.memberConfigurations = null;
  $findResourceConfigurationsForGroup(this$static.configurationService, this$static.group.id, new GroupResourceConfigurationEditView$3_0(this$static));
}

function $save_7(this$static){
  var resourceConfigurations;
  resourceConfigurations = $convertToCompositeList(this$static);
  $updateResourceConfigurationsForGroup(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), this$static.group.id, resourceConfigurations, new GroupResourceConfigurationEditView$4_0(this$static));
}

function GroupResourceConfigurationEditView_0(groupComposite){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  this.group = groupComposite.resourceGroup;
  this.resourcePermission = groupComposite.resourcePermission;
}

defineSeed(3114, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$PropertyValueChangeListener, Q$Enhanced]), GroupResourceConfigurationEditView_0);
_.onDraw_0 = function onDraw_40(){
  var message;
  $refresh_18(this);
  if (!this.resourcePermission.permissions.contains_0(($clinit_Permission() , CONFIGURE_WRITE))) {
    message = new Message_8(($clinit_Enhanced() , 'You do not have permission to edit this group configuration'), ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
}
;
_.propertyValueChanged = function propertyValueChanged_4(event_0){
  var invalidPropertyNames, message, messageCenter;
  messageCenter = ($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0);
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    if (invalidPropertyNames.size_1() == 0) {
      $enable(this.saveButton);
      message = new Message_8(($clinit_Enhanced() , 'All configuration properties have valid values, so the configuration can now be saved'), ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
     else {
      $disable(this.saveButton);
      message = new Message_8('The following configuration properties have invalid values and must be corrected before the configuration can be saved: [' + ($clinit_Enhanced() , $toString_3($values(invalidPropertyNames))) + ']', ($clinit_Message$Severity() , Error_2), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
    $notify(messageCenter, message);
  }
   else {
    $enable(this.saveButton);
  }
}
;
_.refresh_0 = function refresh_33(){
  $refresh_18(this);
}
;
_.buttonbar = null;
_.configurationDefinition = null;
_.editor = null;
_.group = null;
_.memberConfigurations = null;
_.refreshing = false;
_.resourcePermission = null;
_.saveButton = null;
function GroupResourceConfigurationEditView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3115, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), GroupResourceConfigurationEditView$1_0);
_.onClick = function onClick_141(clickEvent){
  $save_7(this.this$0);
}
;
_.this$0 = null;
function GroupResourceConfigurationEditView$2_0(this$0, val$type){
  this.this$0 = this$0;
  this.val$type = val$type;
}

defineSeed(3116, 1, {}, GroupResourceConfigurationEditView$2_0);
_.onTypesLoaded_0 = function onTypesLoaded_22(types){
  this.this$0.configurationDefinition = dynamicCast(types.get_2(valueOf_44(this.val$type.id)), Q$ResourceType).resourceConfigurationDefinition;
  if (!this.this$0.configurationDefinition) {
    throw new IllegalStateException_1('Configuration is not supported by this group.');
  }
  $initEditor(this.this$0);
}
;
_.this$0 = null;
_.val$type = null;
function $onSuccess_290(this$static, configMap){
  var resourceIds;
  resourceIds = dynamicCast(configMap.keySet_0().toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, configMap.size_1(), 0)), Q$Integer_$1);
  $getResourcesAncestry(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), resourceIds, ($clinit_ResourceAncestryFormat() , EXTENDED), new GroupResourceConfigurationEditView$3$1_0(this$static, configMap, resourceIds));
}

function GroupResourceConfigurationEditView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3117, 1, {}, GroupResourceConfigurationEditView$3_0);
_.onFailure = function onFailure_304(caught){
  $handleLoadFailure(this.this$0, caught);
}
;
_.onSuccess_0 = function onSuccess_304(configMap){
  $onSuccess_290(this, dynamicCast(configMap, Q$Map));
}
;
_.this$0 = null;
function $onSuccess_291(this$static, labelMap){
  var configuration, label, memberConfiguration, resourceId, resourceId$array, resourceId$index, resourceId$max;
  this$static.this$1.this$0.memberConfigurations = new ArrayList_1(this$static.val$configMap.size_1());
  for (resourceId$array = this$static.val$resourceIds , resourceId$index = 0 , resourceId$max = resourceId$array.length; resourceId$index < resourceId$max; ++resourceId$index) {
    resourceId = resourceId$array[resourceId$index];
    label = dynamicCast(labelMap.get_2(resourceId), Q$String);
    configuration = dynamicCast(this$static.val$configMap.get_2(resourceId), Q$Configuration);
    memberConfiguration = new GroupMemberConfiguration_0(resourceId.value_0, label, configuration);
    if (!configuration || (!configuration.propertiesProxy && (configuration.propertiesProxy = new Configuration$PropertiesProxy_0(configuration)) , configuration.propertiesProxy.this$0.properties.isEmpty_0())) {
      throw new RuntimeException_1('The server did not return the configuration for one or more member resources.');
    }
    $add_3(this$static.this$1.this$0.memberConfigurations, memberConfiguration);
  }
  $initEditor(this$static.this$1.this$0);
}

function GroupResourceConfigurationEditView$3$1_0(this$1, val$configMap, val$resourceIds){
  this.this$1 = this$1;
  this.val$configMap = val$configMap;
  this.val$resourceIds = val$resourceIds;
}

defineSeed(3118, 1, {}, GroupResourceConfigurationEditView$3$1_0);
_.onFailure = function onFailure_305(caught){
  $handleLoadFailure(this.this$1.this$0, caught);
}
;
_.onSuccess_0 = function onSuccess_305(labelMap){
  $onSuccess_291(this, dynamicCast(labelMap, Q$Map));
}
;
_.this$1 = null;
_.val$configMap = null;
_.val$resourceIds = null;
function $onSuccess_292(this$static){
  var configHistoryUrl, configHistoryView, message;
  configHistoryUrl = getEntityTabLink(forGroup_0(this$static.this$0.group), 'Configuration', 'History');
  configHistoryView = $substring(configHistoryUrl, 1);
  message = new Message_2(($clinit_Enhanced() , 'The group configuration updates have been initiated'), 'The group configuration updates have been initiated for the [' + this$static.this$0.group.resourceType.name_0 + '] compatible group named [' + this$static.this$0.group.name_0 + ']', ($clinit_Message$Severity() , Info));
  $clinit_CoreGUI();
  goToView(configHistoryView, message, false);
}

function GroupResourceConfigurationEditView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3119, 1, {}, GroupResourceConfigurationEditView$4_0);
_.onFailure = function onFailure_306(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to initiate group configuration update for [' + ($clinit_Enhanced() , this.this$0.group.resourceType.name_0) + '] compatible group named [' + this.this$0.group.name_0 + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_306(result){
  $onSuccess_292(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function HistoryGroupResourceConfigurationMembers_0(groupComposite, updateId){
  var backButton, backPath, table;
  EnhancedVLayout_0.call(this);
  this.group = groupComposite.resourceGroup;
  this.groupUpdateId = updateId;
  $setMargin(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
  backPath = getGroupResourceConfigurationUpdateHistoryLink(forGroup_0(this.group), null);
  backButton = new BackButton_0(($clinit_Enhanced() , 'Back to List'), backPath);
  $addMember(this, backButton);
  table = new HistoryGroupResourceConfigurationMembers$MembersTable_0(this);
  $addMember(this, table);
}

defineSeed(3120, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), HistoryGroupResourceConfigurationMembers_0);
_.onDraw_0 = function onDraw_41(){
}
;
_.group = null;
_.groupUpdateId = 0;
function $getStatusHtmlString_1(record){
  var html, obj_0;
  html = null;
  obj_0 = dynamicCast(getAttributeAsObject(record.jsObj, 'object'), Q$AbstractConfigurationUpdate);
  switch (obj_0.status_0.ordinal) {
    case 1:
      {
        html = ($clinit_Enhanced() , 'This configuration update was successful');
        break;
      }

    case 0:
      {
        html = ($clinit_Enhanced() , 'This configuration update is still in progress');
        break;
      }

    case 3:
      {
        html = ($clinit_Enhanced() , 'No changes were made to this configuration');
        break;
      }

    case 2:
      {
        html = obj_0.errorMessage_0;
        html == null && (html = ($clinit_Enhanced() , 'This configuration update failed for an unknown reason'));
        break;
      }

  }
  return html;
}

function HistoryGroupResourceConfigurationMembers$MembersTable_0(this$0){
  this.this$0 = this$0;
  Table_2.call(this, ($clinit_Enhanced() , 'Group Resource Configuration Member Histories'));
  $setDataSource(this, new HistoryGroupResourceConfigurationMembers$MembersTable$DataSource_0(this));
}

defineSeed(3121, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), HistoryGroupResourceConfigurationMembers$MembersTable_0);
_.configureTable = function configureTable_45(){
  var fieldAncestry, fieldDateCreated, fieldLastUpdated, fieldResource, fieldStatus, fieldUser, listGrid, statusIcons;
  fieldResource = new ListGridField_3('resourceName', ($clinit_Enhanced() , 'Resource'));
  $setCellFormatter_0(fieldResource, new HistoryGroupResourceConfigurationMembers$MembersTable$1_0);
  $setAttribute_8(fieldResource, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(fieldResource, new HistoryGroupResourceConfigurationMembers$MembersTable$2_0);
  fieldAncestry = setupAncestryListGridField();
  fieldDateCreated = new ListGridField_3('dateCreated', 'Date Created');
  $clinit_TimestampCellFormatter();
  prepareDateField(fieldDateCreated, getAttribute(fieldDateCreated.jsObj, 'name'));
  fieldLastUpdated = new ListGridField_3('lastUpdated', 'Last Updated');
  prepareDateField(fieldLastUpdated, getAttribute(fieldLastUpdated.jsObj, 'name'));
  fieldStatus = new ListGridField_3('status', 'Status');
  fieldUser = new ListGridField_3('user', 'User');
  fieldResource.jsObj['width'] = '30%';
  fieldAncestry.jsObj['width'] = '*';
  fieldDateCreated.jsObj['width'] = 150;
  fieldLastUpdated.jsObj['width'] = 150;
  fieldStatus.jsObj['width'] = '10%';
  fieldUser.jsObj['width'] = '10%';
  $setAttribute_13(fieldResource, 'type', ($clinit_ListGridFieldType() , LINK_0).value_0);
  fieldResource.jsObj['target'] = '_self';
  $setAttribute_13(fieldStatus, 'type', ICON_0.value_0);
  statusIcons = new HashMap_1(4);
  statusIcons.put(($clinit_ConfigurationUpdateStatus() , SUCCESS_2).name_0, getResourceConfigurationIcon(SUCCESS_2));
  statusIcons.put(FAILURE_2.name_0, getResourceConfigurationIcon(FAILURE_2));
  statusIcons.put(INPROGRESS.name_0, getResourceConfigurationIcon(INPROGRESS));
  statusIcons.put(NOCHANGE.name_0, getResourceConfigurationIcon(NOCHANGE));
  setAttribute_10(fieldStatus.jsObj, 'valueIcons', statusIcons);
  $addRecordClickHandler_0(fieldStatus, new HistoryGroupResourceConfigurationMembers$MembersTable$3_0);
  $setAttribute_8(fieldStatus, 'showHover', TRUE);
  $setHoverCustomizer_0(fieldStatus, new HistoryGroupResourceConfigurationMembers$MembersTable$4_0);
  listGrid = this.listGrid;
  $isCreated_1(listGrid)?$setProperty_2(listGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [fieldResource, fieldAncestry, fieldDateCreated, fieldLastUpdated, fieldStatus, fieldUser]))):(listGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [fieldResource, fieldAncestry, fieldDateCreated, fieldLastUpdated, fieldStatus, fieldUser])) , undefined);
}
;
_.this$0 = null;
function HistoryGroupResourceConfigurationMembers$MembersTable$1_0(){
}

defineSeed(3122, 1, {}, HistoryGroupResourceConfigurationMembers$MembersTable$1_0);
_.format_1 = function format_61(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function HistoryGroupResourceConfigurationMembers$MembersTable$2_0(){
}

defineSeed(3123, 1, {}, HistoryGroupResourceConfigurationMembers$MembersTable$2_0);
_.hoverHTML_0 = function hoverHTML_32(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function HistoryGroupResourceConfigurationMembers$MembersTable$3_0(){
}

defineSeed(3124, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), HistoryGroupResourceConfigurationMembers$MembersTable$3_0);
_.onRecordClick = function onRecordClick_11(event_0){
  var self_0;
  self_0 = (new ErrorMessageWindow_1(($clinit_Enhanced() , 'Status Details'), '<pre>' + $getStatusHtmlString_1($getRecord_0(event_0)) + '<\/pre>')).getOrCreateJsObj();
  self_0.show();
}
;
function HistoryGroupResourceConfigurationMembers$MembersTable$4_0(){
}

defineSeed(3125, 1, {}, HistoryGroupResourceConfigurationMembers$MembersTable$4_0);
_.hoverHTML_0 = function hoverHTML_33(value, record, rowNum, colNum){
  var html;
  html = $getStatusHtmlString_1(record);
  html.length > 80 && (html = '<pre>' + html.substr(0, 80 - 0) + '...<\/pre><p>' + ($clinit_Enhanced() , 'Click the status icon for full details') + '<\/p>');
  return html;
}
;
function $copyValues_50(from){
  var record, resource;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_14(record, 'dateCreated', new Date_2(from.createdTime));
  $setAttribute_14(record, 'lastUpdated', new Date_2(from.modifiedTime));
  $setAttribute_13(record, 'user', from.subjectName);
  $setAttribute_13(record, 'status', from.status_0.name_0);
  resource = from.resource;
  $setAttribute_3(record, 'resourceId', resource.id);
  $setAttribute_13(record, 'resourceName', resource.name_0);
  $setAttribute_13(record, 'resourceAncestry', resource.ancestry);
  $setAttribute_3(record, 'resourceTypeId', resource.resourceType.id);
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  return record;
}

function $executeFetch_34(this$static, request, response, criteria){
  var configurationService;
  configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  $findResourceConfigurationUpdatesByCriteria(configurationService, criteria, new HistoryGroupResourceConfigurationMembers$MembersTable$DataSource$1_0(this$static, response, request));
}

function HistoryGroupResourceConfigurationMembers$MembersTable$DataSource_0(this$1){
  $clinit_RPCDataSource();
  this.this$1 = this$1;
  RPCDataSource_0.call(this);
}

defineSeed(3126, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), HistoryGroupResourceConfigurationMembers$MembersTable$DataSource_0);
_.copyValues = function copyValues_89(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'object'), Q$ResourceConfigurationUpdate);
}
;
_.copyValues_0 = function copyValues_90(from){
  return $copyValues_50(dynamicCast(from, Q$ResourceConfigurationUpdate));
}
;
_.executeFetch = function executeFetch_48(request, response, criteria){
  $executeFetch_34(this, request, response, dynamicCast(criteria, Q$ResourceConfigurationUpdateCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_60(request){
  var criteria;
  return criteria = new ResourceConfigurationUpdateCriteria_0 , $addFilterGroupConfigurationUpdateId_0(criteria, valueOf_44(this.this$1.this$0.groupUpdateId)) , criteria.fetchResource = true , criteria;
}
;
_.this$1 = null;
function $onSuccess_293(this$static, result){
  var ancestries, resource, typeRepo, typesSet, update, update$iterator;
  typesSet = new HashSet_0;
  ancestries = new HashSet_0;
  for (update$iterator = new AbstractList$IteratorImpl_0(result); update$iterator.i < update$iterator.this$0_0.size_1();) {
    update = dynamicCast($next_0(update$iterator), Q$ResourceConfigurationUpdate);
    resource = update.resource;
    $add_6(typesSet, valueOf_44(resource.resourceType.id));
    $add_6(ancestries, resource.ancestry);
  }
  $addAll(typesSet, getAncestryTypeIds(ancestries));
  typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new HistoryGroupResourceConfigurationMembers$MembersTable$DataSource$1$1_0(this$static, result, this$static.val$response, this$static.val$request));
}

function HistoryGroupResourceConfigurationMembers$MembersTable$DataSource$1_0(this$2, val$response, val$request){
  this.this$2 = this$2;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3127, 1, {}, HistoryGroupResourceConfigurationMembers$MembersTable$DataSource$1_0);
_.onFailure = function onFailure_307(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to get resource config update history for members of group [' + ($clinit_RPCDataSource() , '' + this.this$2.this$1.this$0.groupUpdateId) + ']'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$2, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_307(result){
  $onSuccess_293(this, dynamicCast(result, Q$PageList));
}
;
_.this$2 = null;
_.val$request = null;
_.val$response = null;
function HistoryGroupResourceConfigurationMembers$MembersTable$DataSource$1$1_0(this$3, val$result, val$response, val$request){
  this.this$3 = this$3;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3128, 1, {}, HistoryGroupResourceConfigurationMembers$MembersTable$DataSource$1$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_23(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$3.this$2, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44($getTotalSize(this.val$result)));
  $processResponse_0(this.this$3.this$2, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$3 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $handleLoadFailure_0(this$static, caught){
  caught.getMessage().indexOf('ConfigurationUpdateStillInProgressException') != -1?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_4(($clinit_Enhanced() , 'A group resource configuration update is currently in progress. You must wait until the update is finished before you can view the group settings.'), caught, ($clinit_Message$Severity() , Info))):$handleError_0(($clinit_CoreGUI() , 'Failed to retrieve member resource configuration settings for [' + ($clinit_Enhanced() , $toString_19(this$static.group)) + ']'), caught);
}

function $initEditor_0(this$static){
  if (!!this$static.configurationDefinition && !!this$static.memberConfigurations) {
    this$static.editor = new GroupConfigurationEditor_0(this$static.configurationDefinition, this$static.memberConfigurations);
    $setEditorTitle(this$static.editor, ($clinit_Enhanced() , 'Group Properties') + ' - ' + this$static.groupUpdateId);
    $setAttribute_24(this$static.editor, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
    this$static.editor.readOnly = true;
    $addMember(this$static, this$static.editor);
  }
}

function $loadConfigurationDefinition_0(this$static){
  var type;
  if (!this$static.configurationDefinition) {
    type = this$static.group.resourceType;
    $getResourceTypes_0(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(type.id)]), of(($clinit_ResourceTypeRepository$MetadataType() , resourceConfigurationDefinition_0)), new HistoryGroupResourceConfigurationSettings$1_0(this$static, type));
  }
}

function HistoryGroupResourceConfigurationSettings_0(groupComposite, updateId){
  var backButton, backPath;
  EnhancedVLayout_0.call(this);
  this.group = groupComposite.resourceGroup;
  this.groupPerms = groupComposite.resourcePermission;
  this.groupUpdateId = updateId;
  $setMargin(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
  backPath = getGroupResourceConfigurationUpdateHistoryLink(forGroup_0(this.group), null);
  backButton = new BackButton_0(($clinit_Enhanced() , 'Back to List'), backPath);
  $addMember(this, backButton);
}

defineSeed(3129, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), HistoryGroupResourceConfigurationSettings_0);
_.onDraw_0 = function onDraw_42(){
  if (this.groupPerms.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE))) {
    $loadConfigurationDefinition_0(this);
    this.memberConfigurations = null;
    $findResourceConfigurationsForGroupUpdate(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), this.groupUpdateId, new HistoryGroupResourceConfigurationSettings$2_0(this));
  }
   else {
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0(($clinit_Enhanced() , 'You do not have permissions to see the resource configuration settings')));
  }
}
;
_.configurationDefinition = null;
_.editor = null;
_.group = null;
_.groupPerms = null;
_.groupUpdateId = 0;
_.memberConfigurations = null;
function HistoryGroupResourceConfigurationSettings$1_0(this$0, val$type){
  this.this$0 = this$0;
  this.val$type = val$type;
}

defineSeed(3130, 1, {}, HistoryGroupResourceConfigurationSettings$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_24(types){
  this.this$0.configurationDefinition = dynamicCast(types.get_2(valueOf_44(this.val$type.id)), Q$ResourceType).resourceConfigurationDefinition;
  if (!this.this$0.configurationDefinition) {
    throw new IllegalStateException_1('Resource configuration is not supported by this group.');
  }
  $initEditor_0(this.this$0);
}
;
_.this$0 = null;
_.val$type = null;
function $onSuccess_294(this$static, configMap){
  var resourceIds;
  resourceIds = dynamicCast(configMap.keySet_0().toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, configMap.size_1(), 0)), Q$Integer_$1);
  $getResourcesAncestry(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), resourceIds, ($clinit_ResourceAncestryFormat() , EXTENDED), new HistoryGroupResourceConfigurationSettings$2$1_0(this$static, configMap, resourceIds));
}

function HistoryGroupResourceConfigurationSettings$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3131, 1, {}, HistoryGroupResourceConfigurationSettings$2_0);
_.onFailure = function onFailure_308(caught){
  $handleLoadFailure_0(this.this$0, caught);
}
;
_.onSuccess_0 = function onSuccess_308(configMap){
  $onSuccess_294(this, dynamicCast(configMap, Q$Map));
}
;
_.this$0 = null;
function $onSuccess_295(this$static, labelMap){
  var configuration, label, memberConfiguration, resourceId, resourceId$array, resourceId$index, resourceId$max;
  this$static.this$1.this$0.memberConfigurations = new ArrayList_1(this$static.val$configMap.size_1());
  for (resourceId$array = this$static.val$resourceIds , resourceId$index = 0 , resourceId$max = resourceId$array.length; resourceId$index < resourceId$max; ++resourceId$index) {
    resourceId = resourceId$array[resourceId$index];
    label = dynamicCast(labelMap.get_2(resourceId), Q$String);
    configuration = dynamicCast(this$static.val$configMap.get_2(resourceId), Q$Configuration);
    memberConfiguration = new GroupMemberConfiguration_0(resourceId.value_0, label, configuration);
    if (!configuration || (!configuration.propertiesProxy && (configuration.propertiesProxy = new Configuration$PropertiesProxy_0(configuration)) , configuration.propertiesProxy.this$0.properties.isEmpty_0())) {
      throw new RuntimeException_1('The server did not return the configuration for one or more member resources.');
    }
    $add_3(this$static.this$1.this$0.memberConfigurations, memberConfiguration);
  }
  $initEditor_0(this$static.this$1.this$0);
}

function HistoryGroupResourceConfigurationSettings$2$1_0(this$1, val$configMap, val$resourceIds){
  this.this$1 = this$1;
  this.val$configMap = val$configMap;
  this.val$resourceIds = val$resourceIds;
}

defineSeed(3132, 1, {}, HistoryGroupResourceConfigurationSettings$2$1_0);
_.onFailure = function onFailure_309(caught){
  $handleLoadFailure_0(this.this$1.this$0, caught);
}
;
_.onSuccess_0 = function onSuccess_309(labelMap){
  $onSuccess_295(this, dynamicCast(labelMap, Q$Map));
}
;
_.this$1 = null;
_.val$configMap = null;
_.val$resourceIds = null;
function HistoryGroupResourceConfigurationTable$1_0(){
}

defineSeed(3133, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), HistoryGroupResourceConfigurationTable$1_0);
_.onRecordClick = function onRecordClick_12(event_0){
  var self_0;
  self_0 = (new ErrorMessageWindow_1(($clinit_Enhanced() , 'Error'), $getStatusHtmlString($getRecord_0(event_0)))).getOrCreateJsObj();
  self_0.show();
}
;
function HistoryGroupResourceConfigurationTable$2_0(){
}

defineSeed(3134, 1, {}, HistoryGroupResourceConfigurationTable$2_0);
_.hoverHTML_0 = function hoverHTML_34(value, record, rowNum, colNum){
  var html;
  html = $getStatusHtmlString(record);
  return html;
}
;
function HistoryGroupResourceConfigurationTable$3_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3135, 1608, {}, HistoryGroupResourceConfigurationTable$3_0);
_.executeAction = function executeAction_60(selection, actionValue){
  var groupId, i, record, record$index, record$max, service, updateIds;
  if (selection == null || selection.length == 0) {
    return;
  }
  service = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  groupId = valueOf_44(this.this$0.group.id);
  updateIds = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, selection.length, 0);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    updateIds[i++] = getAttributeAsInt(record.jsObj, 'id');
  }
  $deleteGroupResourceConfigurationUpdate(service, groupId, updateIds, new HistoryGroupResourceConfigurationTable$3$1_0(this, selection));
}
;
_.this$0 = null;
function $onSuccess_296(this$static){
  var message;
  $refresh(this$static.this$1.this$0, false);
  message = new Message_8('You have deleted [' + ($clinit_Enhanced() , '' + this$static.val$selection.length) + '] history items', ($clinit_Message$Severity() , Info), of(($clinit_Message$Option() , Transient)));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
}

function HistoryGroupResourceConfigurationTable$3$1_0(this$1, val$selection){
  this.this$1 = this$1;
  this.val$selection = val$selection;
}

defineSeed(3136, 1, {}, HistoryGroupResourceConfigurationTable$3$1_0);
_.onFailure = function onFailure_310(caught){
  this.this$1.this$0.refreshTableInfo();
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete group resource config history'), caught);
}
;
_.onSuccess_0 = function onSuccess_310(result){
  $onSuccess_296(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$selection = null;
function HistoryGroupResourceConfigurationTable$4_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3137, 1608, {}, HistoryGroupResourceConfigurationTable$4_0);
_.executeAction = function executeAction_61(selection, actionValue){
  $clinit_CoreGUI();
  goToView(getGroupResourceConfigurationUpdateHistoryLink(forGroup_0(this.this$0.group), null) + '/' + getAttribute(selection[0].jsObj, 'id') + '/Settings', null, false);
  this.this$0.refreshTableInfo();
}
;
_.this$0 = null;
function HistoryGroupResourceConfigurationTable$5_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3138, 1608, {}, HistoryGroupResourceConfigurationTable$5_0);
_.executeAction = function executeAction_62(selection, actionValue){
  $clinit_CoreGUI();
  goToView(getGroupResourceConfigurationUpdateHistoryLink(forGroup_0(this.this$0.group), null) + '/' + getAttribute(selection[0].jsObj, 'id') + '/Members', null, false);
  this.this$0.refreshTableInfo();
}
;
_.this$0 = null;
function HistoryGroupResourceConfigurationView_0(groupComposite){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.groupComposite = groupComposite;
  this.groupHistoryTable = new HistoryGroupResourceConfigurationTable_0(groupComposite);
  $addMember(this, this.groupHistoryTable);
}

defineSeed(3139, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), HistoryGroupResourceConfigurationView_0);
_.renderView = function renderView_29(viewPath){
  var configView, currentPath, groupHistoryId;
  if (viewPath.viewPath.size_0 <= viewPath.index_0) {
    $setVisibleMember(this, this.groupHistoryTable);
  }
   else {
    groupHistoryId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
    ++viewPath.index_0;
    if (viewPath.viewPath.size_0 <= viewPath.index_0) {
      configView = true;
    }
     else {
      currentPath = (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path;
      if ($equals_6('Settings', currentPath)) {
        configView = true;
      }
       else if ($equals_6('Members', currentPath)) {
        configView = false;
      }
       else {
        throw new IllegalArgumentException_1('Cannot render page - invalid URL: ' + currentPath);
      }
    }
    if (this.detailsCanvas) {
      $removeMember(this, this.detailsCanvas);
      this.detailsCanvas.destroy_0();
    }
    configView?(this.detailsCanvas = new HistoryGroupResourceConfigurationSettings_0(this.groupComposite, groupHistoryId)):(this.detailsCanvas = new HistoryGroupResourceConfigurationMembers_0(this.groupComposite, groupHistoryId));
    $addMember(this, this.detailsCanvas);
    $setVisibleMember(this, this.detailsCanvas);
  }
}
;
_.detailsCanvas = null;
_.groupComposite = null;
_.groupHistoryTable = null;
function $convertToCompositeList_0(this$static){
  var memberConfiguration, memberConfiguration$iterator, resourceConfigurations;
  resourceConfigurations = new ArrayList_1(this$static.memberConfigurations.size_0);
  for (memberConfiguration$iterator = new AbstractList$IteratorImpl_0(this$static.memberConfigurations); memberConfiguration$iterator.i < memberConfiguration$iterator.this$0_0.size_1();) {
    memberConfiguration = dynamicCast($next_0(memberConfiguration$iterator), Q$GroupMemberConfiguration);
    $add_3(resourceConfigurations, new ResourceConfigurationComposite_0(memberConfiguration.id, memberConfiguration.configuration));
  }
  return resourceConfigurations;
}

function $handleLoadFailure_1(this$static, caught){
  this$static.refreshing = false;
  caught.getMessage().indexOf('ConfigurationUpdateStillInProgressException') != -1?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_4(($clinit_Enhanced() , 'A group plugin configuration update is currently in progress. You must wait until the update is finished before you can view the group settings.'), caught, ($clinit_Message$Severity() , Info))):$handleError_0(($clinit_CoreGUI() , 'Failed to retrieve member connection settings for [' + ($clinit_Enhanced() , $toString_19(this$static.group)) + ']'), caught);
}

function $initEditor_1(this$static){
  if (!!this$static.configurationDefinition && !!this$static.memberConfigurations) {
    this$static.editor = new GroupConfigurationEditor_0(this$static.configurationDefinition, this$static.memberConfigurations);
    $setEditorTitle(this$static.editor, ($clinit_Enhanced() , 'Current Group Properties'));
    $setAttribute_24(this$static.editor, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
    $addPropertyValueChangeListener(this$static.editor, this$static);
    $setReadOnly_1(this$static.editor, !this$static.resourcePermission.permissions.contains_0(($clinit_Permission() , CONFIGURE_WRITE)));
    $addMember(this$static, this$static.editor);
    this$static.refreshing = false;
  }
}

function $loadConfigurationDefinition_1(this$static){
  var type;
  if (!this$static.configurationDefinition) {
    type = this$static.group.resourceType;
    $getResourceTypes_0(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(type.id)]), of(($clinit_ResourceTypeRepository$MetadataType() , pluginConfigurationDefinition_0)), new GroupPluginConfigurationEditView$2_0(this$static, type));
  }
}

function $refresh_19(this$static){
  if (this$static.refreshing) {
    return;
  }
  this$static.refreshing = true;
  $disable(this$static.saveButton);
  if (this$static.editor) {
    $destroy_1(this$static.editor);
    $removeMember(this$static, this$static.editor);
  }
  $loadConfigurationDefinition_1(this$static);
  this$static.memberConfigurations = null;
  $findPluginConfigurationsForGroup(this$static.configurationService, this$static.group.id, new GroupPluginConfigurationEditView$3_0(this$static));
}

function $save_8(this$static){
  var resourceConfigurations;
  resourceConfigurations = $convertToCompositeList_0(this$static);
  $updatePluginConfigurationsForGroup(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), this$static.group.id, resourceConfigurations, new GroupPluginConfigurationEditView$4_0(this$static));
}

function GroupPluginConfigurationEditView_0(groupComposite){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  this.resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  this.group = groupComposite.resourceGroup;
  this.resourcePermission = groupComposite.resourcePermission;
}

defineSeed(3140, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$PropertyValueChangeListener, Q$Enhanced]), GroupPluginConfigurationEditView_0);
_.onDraw_0 = function onDraw_43(){
  var message, toolStrip;
  toolStrip = new ToolStrip_0;
  $isCreated_1(toolStrip)?$setProperty_3(toolStrip, 'width', '100%'):(toolStrip.config_0['width'] = '100%' , undefined);
  $isCreated_1(toolStrip)?undefined:(toolStrip.config_0['extraSpace'] = 10 , undefined);
  $isCreated_1(toolStrip)?$setProperty_0(toolStrip, 'membersMargin', 5):(toolStrip.config_0['membersMargin'] = 5 , undefined);
  $setLayoutMargin(toolStrip, valueOf_44(5));
  this.saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
  $setPrompt(this.saveButton, 'Update the connection settings of all group members');
  $addClickHandler(this.saveButton, new GroupPluginConfigurationEditView$1_0(this));
  $addMember(toolStrip, this.saveButton);
  $addMember(this, toolStrip);
  $refresh_19(this);
  if (!this.resourcePermission.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE))) {
    message = new Message_8('You do not have permission to edit this group connection settings', ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
}
;
_.propertyValueChanged = function propertyValueChanged_5(event_0){
  var invalidPropertyNames, message, messageCenter;
  messageCenter = ($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0);
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    if (invalidPropertyNames.size_1() == 0) {
      $enable(this.saveButton);
      message = new Message_8(($clinit_Enhanced() , 'All connection setting properties have valid values, so the connection settings can now be saved'), ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
     else {
      $disable(this.saveButton);
      message = new Message_8('The following connection setting properties have invalid values and must be corrected before the connection settings can be saved: [' + ($clinit_Enhanced() , $toString_3($values(invalidPropertyNames))) + ']', ($clinit_Message$Severity() , Error_2), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
    $notify(messageCenter, message);
  }
   else {
    $enable(this.saveButton);
  }
}
;
_.refresh_0 = function refresh_34(){
  $refresh_19(this);
}
;
_.configurationDefinition = null;
_.editor = null;
_.group = null;
_.memberConfigurations = null;
_.refreshing = false;
_.resourcePermission = null;
_.saveButton = null;
function GroupPluginConfigurationEditView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3141, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), GroupPluginConfigurationEditView$1_0);
_.onClick = function onClick_142(clickEvent){
  $save_8(this.this$0);
}
;
_.this$0 = null;
function GroupPluginConfigurationEditView$2_0(this$0, val$type){
  this.this$0 = this$0;
  this.val$type = val$type;
}

defineSeed(3142, 1, {}, GroupPluginConfigurationEditView$2_0);
_.onTypesLoaded_0 = function onTypesLoaded_25(types){
  this.this$0.configurationDefinition = dynamicCast(types.get_2(valueOf_44(this.val$type.id)), Q$ResourceType).pluginConfigurationDefinition;
  if (!this.this$0.configurationDefinition) {
    throw new IllegalStateException_1('Connection settings are not supported by this group.');
  }
  $initEditor_1(this.this$0);
}
;
_.this$0 = null;
_.val$type = null;
function $onSuccess_297(this$static, configMap){
  var resourceIds;
  resourceIds = dynamicCast(configMap.keySet_0().toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, configMap.size_1(), 0)), Q$Integer_$1);
  $getResourcesAncestry(this$static.this$0.resourceService, resourceIds, ($clinit_ResourceAncestryFormat() , EXTENDED), new GroupPluginConfigurationEditView$3$1_0(this$static, configMap, resourceIds));
}

function GroupPluginConfigurationEditView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3143, 1, {}, GroupPluginConfigurationEditView$3_0);
_.onFailure = function onFailure_311(caught){
  $handleLoadFailure_1(this.this$0, caught);
}
;
_.onSuccess_0 = function onSuccess_311(configMap){
  $onSuccess_297(this, dynamicCast(configMap, Q$Map));
}
;
_.this$0 = null;
function $onSuccess_298(this$static, labelMap){
  var configuration, label, memberConfiguration, resourceId, resourceId$array, resourceId$index, resourceId$max;
  this$static.this$1.this$0.memberConfigurations = new ArrayList_1(this$static.val$configMap.size_1());
  for (resourceId$array = this$static.val$resourceIds , resourceId$index = 0 , resourceId$max = resourceId$array.length; resourceId$index < resourceId$max; ++resourceId$index) {
    resourceId = resourceId$array[resourceId$index];
    label = dynamicCast(labelMap.get_2(resourceId), Q$String);
    configuration = dynamicCast(this$static.val$configMap.get_2(resourceId), Q$Configuration);
    memberConfiguration = new GroupMemberConfiguration_0(resourceId.value_0, label, configuration);
    if (!configuration || (!configuration.propertiesProxy && (configuration.propertiesProxy = new Configuration$PropertiesProxy_0(configuration)) , configuration.propertiesProxy.this$0.properties.isEmpty_0())) {
      throw new RuntimeException_1('The server did not return the connection settings for one or more member resources.');
    }
    $add_3(this$static.this$1.this$0.memberConfigurations, memberConfiguration);
  }
  $initEditor_1(this$static.this$1.this$0);
}

function GroupPluginConfigurationEditView$3$1_0(this$1, val$configMap, val$resourceIds){
  this.this$1 = this$1;
  this.val$configMap = val$configMap;
  this.val$resourceIds = val$resourceIds;
}

defineSeed(3144, 1, {}, GroupPluginConfigurationEditView$3$1_0);
_.onFailure = function onFailure_312(caught){
  $handleLoadFailure_1(this.this$1.this$0, caught);
}
;
_.onSuccess_0 = function onSuccess_312(labelMap){
  $onSuccess_298(this, dynamicCast(labelMap, Q$Map));
}
;
_.this$1 = null;
_.val$configMap = null;
_.val$resourceIds = null;
function $onFailure_33(this$static, caught){
  var typeName;
  typeName = this$static.this$0.group.resourceType.name_0;
  $handleError_0(($clinit_CoreGUI() , 'Failed to initiate group connection setting update for [' + ($clinit_Enhanced() , typeName) + '] compatible group named [' + this$static.this$0.group.name_0 + ']'), caught);
}

function $onSuccess_299(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2(($clinit_Enhanced() , 'The group connection setting updates have been initiated'), 'The group connection setting updates have been initiated for the [' + this$static.this$0.group.resourceType.name_0 + '] compatible group named [' + this$static.this$0.group.name_0 + ']', ($clinit_Message$Severity() , Info)));
  $refresh_19(this$static.this$0);
}

function GroupPluginConfigurationEditView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3145, 1, {}, GroupPluginConfigurationEditView$4_0);
_.onFailure = function onFailure_313(caught){
  $onFailure_33(this, caught);
}
;
_.onSuccess_0 = function onSuccess_313(result){
  $onSuccess_299(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function HistoryGroupPluginConfigurationMembers_0(groupComposite, updateId){
  var backButton, backPath, table;
  EnhancedVLayout_0.call(this);
  this.group = groupComposite.resourceGroup;
  this.groupUpdateId = updateId;
  $setMargin(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
  backPath = getGroupPluginConfigurationUpdateHistoryLink(forGroup_0(this.group), null);
  backButton = new BackButton_0(($clinit_Enhanced() , 'Back to List'), backPath);
  $addMember(this, backButton);
  table = new HistoryGroupPluginConfigurationMembers$MembersTable_0(this);
  $addMember(this, table);
}

defineSeed(3146, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), HistoryGroupPluginConfigurationMembers_0);
_.onDraw_0 = function onDraw_44(){
}
;
_.group = null;
_.groupUpdateId = 0;
function $getStatusHtmlString_2(record){
  var html, obj_0;
  html = null;
  obj_0 = dynamicCast(getAttributeAsObject(record.jsObj, 'object'), Q$AbstractConfigurationUpdate);
  switch (obj_0.status_0.ordinal) {
    case 1:
      {
        html = ($clinit_Enhanced() , 'This configuration update was successful');
        break;
      }

    case 0:
      {
        html = ($clinit_Enhanced() , 'This configuration update is still in progress');
        break;
      }

    case 3:
      {
        html = ($clinit_Enhanced() , 'No changes were made to this configuration');
        break;
      }

    case 2:
      {
        html = obj_0.errorMessage_0;
        html == null && (html = ($clinit_Enhanced() , 'This configuration update failed for an unknown reason'));
        break;
      }

  }
  return html;
}

function HistoryGroupPluginConfigurationMembers$MembersTable_0(this$0){
  this.this$0 = this$0;
  Table_2.call(this, ($clinit_Enhanced() , 'Group Connection Settings Member Histories'));
  $setDataSource(this, new HistoryGroupPluginConfigurationMembers$MembersTable$DataSource_0(this));
}

defineSeed(3147, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), HistoryGroupPluginConfigurationMembers$MembersTable_0);
_.configureTable = function configureTable_46(){
  var fieldAncestry, fieldDateCreated, fieldLastUpdated, fieldResource, fieldStatus, fieldUser, listGrid, statusIcons;
  fieldResource = new ListGridField_3('resourceName', ($clinit_Enhanced() , 'Resource'));
  $setCellFormatter_0(fieldResource, new HistoryGroupPluginConfigurationMembers$MembersTable$1_0);
  $setAttribute_8(fieldResource, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(fieldResource, new HistoryGroupPluginConfigurationMembers$MembersTable$2_0);
  fieldAncestry = setupAncestryListGridField();
  fieldDateCreated = new ListGridField_3('dateCreated', 'Date Created');
  $clinit_TimestampCellFormatter();
  prepareDateField(fieldDateCreated, getAttribute(fieldDateCreated.jsObj, 'name'));
  fieldLastUpdated = new ListGridField_3('lastUpdated', 'Last Updated');
  prepareDateField(fieldLastUpdated, getAttribute(fieldLastUpdated.jsObj, 'name'));
  fieldStatus = new ListGridField_3('status', 'Status');
  fieldUser = new ListGridField_3('user', 'User');
  fieldResource.jsObj['width'] = '30%';
  fieldAncestry.jsObj['width'] = '*';
  fieldDateCreated.jsObj['width'] = 150;
  fieldLastUpdated.jsObj['width'] = 150;
  fieldStatus.jsObj['width'] = '10%';
  fieldUser.jsObj['width'] = '10%';
  $setAttribute_13(fieldResource, 'type', ($clinit_ListGridFieldType() , LINK_0).value_0);
  fieldResource.jsObj['target'] = '_self';
  $setAttribute_13(fieldStatus, 'type', ICON_0.value_0);
  statusIcons = new HashMap_1(4);
  statusIcons.put(($clinit_ConfigurationUpdateStatus() , SUCCESS_2).name_0, getPluginConfigurationIcon(SUCCESS_2));
  statusIcons.put(FAILURE_2.name_0, getPluginConfigurationIcon(FAILURE_2));
  statusIcons.put(INPROGRESS.name_0, getPluginConfigurationIcon(INPROGRESS));
  statusIcons.put(NOCHANGE.name_0, getPluginConfigurationIcon(NOCHANGE));
  setAttribute_10(fieldStatus.jsObj, 'valueIcons', statusIcons);
  $addRecordClickHandler_0(fieldStatus, new HistoryGroupPluginConfigurationMembers$MembersTable$3_0);
  $setAttribute_8(fieldStatus, 'showHover', TRUE);
  $setHoverCustomizer_0(fieldStatus, new HistoryGroupPluginConfigurationMembers$MembersTable$4_0);
  listGrid = this.listGrid;
  $isCreated_1(listGrid)?$setProperty_2(listGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [fieldResource, fieldAncestry, fieldDateCreated, fieldLastUpdated, fieldStatus, fieldUser]))):(listGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [fieldResource, fieldAncestry, fieldDateCreated, fieldLastUpdated, fieldStatus, fieldUser])) , undefined);
}
;
_.this$0 = null;
function HistoryGroupPluginConfigurationMembers$MembersTable$1_0(){
}

defineSeed(3148, 1, {}, HistoryGroupPluginConfigurationMembers$MembersTable$1_0);
_.format_1 = function format_62(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function HistoryGroupPluginConfigurationMembers$MembersTable$2_0(){
}

defineSeed(3149, 1, {}, HistoryGroupPluginConfigurationMembers$MembersTable$2_0);
_.hoverHTML_0 = function hoverHTML_35(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function HistoryGroupPluginConfigurationMembers$MembersTable$3_0(){
}

defineSeed(3150, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), HistoryGroupPluginConfigurationMembers$MembersTable$3_0);
_.onRecordClick = function onRecordClick_13(event_0){
  var self_0;
  self_0 = (new ErrorMessageWindow_1(($clinit_Enhanced() , 'Status Details'), '<pre>' + $getStatusHtmlString_2($getRecord_0(event_0)) + '<\/pre>')).getOrCreateJsObj();
  self_0.show();
}
;
function HistoryGroupPluginConfigurationMembers$MembersTable$4_0(){
}

defineSeed(3151, 1, {}, HistoryGroupPluginConfigurationMembers$MembersTable$4_0);
_.hoverHTML_0 = function hoverHTML_36(value, record, rowNum, colNum){
  var html;
  html = $getStatusHtmlString_2(record);
  html.length > 80 && (html = '<pre>' + html.substr(0, 80 - 0) + '...<\/pre><p>' + ($clinit_Enhanced() , 'Click the status icon for full details') + '<\/p>');
  return html;
}
;
function $copyValues_51(from){
  var record, resource;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_14(record, 'dateCreated', new Date_2(from.createdTime));
  $setAttribute_14(record, 'lastUpdated', new Date_2(from.modifiedTime));
  $setAttribute_13(record, 'user', from.subjectName);
  $setAttribute_13(record, 'status', from.status_0.name_0);
  resource = from.resource;
  $setAttribute_3(record, 'resourceId', resource.id);
  $setAttribute_13(record, 'resourceName', resource.name_0);
  $setAttribute_13(record, 'resourceAncestry', resource.ancestry);
  $setAttribute_3(record, 'resourceTypeId', resource.resourceType.id);
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  return record;
}

function $executeFetch_35(this$static, request, response, criteria){
  var configurationService;
  configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  $findPluginConfigurationUpdatesByCriteria(configurationService, criteria, new HistoryGroupPluginConfigurationMembers$MembersTable$DataSource$1_0(this$static, response, request));
}

function HistoryGroupPluginConfigurationMembers$MembersTable$DataSource_0(this$1){
  $clinit_RPCDataSource();
  this.this$1 = this$1;
  RPCDataSource_0.call(this);
}

defineSeed(3152, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), HistoryGroupPluginConfigurationMembers$MembersTable$DataSource_0);
_.copyValues = function copyValues_91(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'object'), Q$PluginConfigurationUpdate);
}
;
_.copyValues_0 = function copyValues_92(from){
  return $copyValues_51(dynamicCast(from, Q$PluginConfigurationUpdate));
}
;
_.executeFetch = function executeFetch_49(request, response, criteria){
  $executeFetch_35(this, request, response, dynamicCast(criteria, Q$PluginConfigurationUpdateCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_61(request){
  var criteria;
  return criteria = new PluginConfigurationUpdateCriteria_0 , $addFilterGroupConfigurationUpdateId(criteria, valueOf_44(this.this$1.this$0.groupUpdateId)) , criteria.fetchResource = true , criteria;
}
;
_.this$1 = null;
function $onSuccess_300(this$static, result){
  var ancestries, resource, typeRepo, typesSet, update, update$iterator;
  typesSet = new HashSet_0;
  ancestries = new HashSet_0;
  for (update$iterator = new AbstractList$IteratorImpl_0(result); update$iterator.i < update$iterator.this$0_0.size_1();) {
    update = dynamicCast($next_0(update$iterator), Q$PluginConfigurationUpdate);
    resource = update.resource;
    $add_6(typesSet, valueOf_44(resource.resourceType.id));
    $add_6(ancestries, resource.ancestry);
  }
  $addAll(typesSet, getAncestryTypeIds(ancestries));
  typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new HistoryGroupPluginConfigurationMembers$MembersTable$DataSource$1$1_0(this$static, result, this$static.val$response, this$static.val$request));
}

function HistoryGroupPluginConfigurationMembers$MembersTable$DataSource$1_0(this$2, val$response, val$request){
  this.this$2 = this$2;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3153, 1, {}, HistoryGroupPluginConfigurationMembers$MembersTable$DataSource$1_0);
_.onFailure = function onFailure_314(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to get plugin config update history for members of group [' + ($clinit_RPCDataSource() , '' + this.this$2.this$1.this$0.groupUpdateId) + ']'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$2, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_314(result){
  $onSuccess_300(this, dynamicCast(result, Q$PageList));
}
;
_.this$2 = null;
_.val$request = null;
_.val$response = null;
function HistoryGroupPluginConfigurationMembers$MembersTable$DataSource$1$1_0(this$3, val$result, val$response, val$request){
  this.this$3 = this$3;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3154, 1, {}, HistoryGroupPluginConfigurationMembers$MembersTable$DataSource$1$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_26(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$3.this$2, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44($getTotalSize(this.val$result)));
  $processResponse_0(this.this$3.this$2, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$3 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $handleLoadFailure_2(this$static, caught){
  caught.getMessage().indexOf('ConfigurationUpdateStillInProgressException') != -1?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_4(($clinit_Enhanced() , 'A group plugin configuration update is currently in progress. You must wait until the update is finished before you can view the group settings.'), caught, ($clinit_Message$Severity() , Info))):$handleError_0(($clinit_CoreGUI() , 'Failed to retrieve member connection settings for [' + ($clinit_Enhanced() , $toString_19(this$static.group)) + ']'), caught);
}

function $initEditor_2(this$static){
  if (!!this$static.configurationDefinition && !!this$static.memberConfigurations) {
    this$static.editor = new GroupConfigurationEditor_0(this$static.configurationDefinition, this$static.memberConfigurations);
    $setEditorTitle(this$static.editor, ($clinit_Enhanced() , 'Group Properties') + ' - ' + this$static.groupUpdateId);
    $setAttribute_24(this$static.editor, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
    this$static.editor.readOnly = true;
    $addMember(this$static, this$static.editor);
  }
}

function $loadConfigurationDefinition_2(this$static){
  var type;
  if (!this$static.configurationDefinition) {
    type = this$static.group.resourceType;
    $getResourceTypes_0(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(type.id)]), of(($clinit_ResourceTypeRepository$MetadataType() , pluginConfigurationDefinition_0)), new HistoryGroupPluginConfigurationSettings$1_0(this$static, type));
  }
}

function HistoryGroupPluginConfigurationSettings_0(groupComposite, updateId){
  var backButton, backPath;
  EnhancedVLayout_0.call(this);
  this.group = groupComposite.resourceGroup;
  this.groupPerms = groupComposite.resourcePermission;
  this.groupUpdateId = updateId;
  $setMargin(this, valueOf_44(5));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 5):(this.config_0['membersMargin'] = 5 , undefined);
  backPath = getGroupPluginConfigurationUpdateHistoryLink(forGroup_0(this.group), null);
  backButton = new BackButton_0(($clinit_Enhanced() , 'Back to List'), backPath);
  $addMember(this, backButton);
}

defineSeed(3155, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), HistoryGroupPluginConfigurationSettings_0);
_.onDraw_0 = function onDraw_45(){
  if (this.groupPerms.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE))) {
    $loadConfigurationDefinition_2(this);
    this.memberConfigurations = null;
    $findPluginConfigurationsForGroupUpdate(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), this.groupUpdateId, new HistoryGroupPluginConfigurationSettings$2_0(this));
  }
   else {
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_0(($clinit_Enhanced() , 'You do not have permissions to see the connection settings')));
  }
}
;
_.configurationDefinition = null;
_.editor = null;
_.group = null;
_.groupPerms = null;
_.groupUpdateId = 0;
_.memberConfigurations = null;
function HistoryGroupPluginConfigurationSettings$1_0(this$0, val$type){
  this.this$0 = this$0;
  this.val$type = val$type;
}

defineSeed(3156, 1, {}, HistoryGroupPluginConfigurationSettings$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_27(types){
  this.this$0.configurationDefinition = dynamicCast(types.get_2(valueOf_44(this.val$type.id)), Q$ResourceType).pluginConfigurationDefinition;
  if (!this.this$0.configurationDefinition) {
    throw new IllegalStateException_1('Connection settings are not supported by this group.');
  }
  $initEditor_2(this.this$0);
}
;
_.this$0 = null;
_.val$type = null;
function $onSuccess_301(this$static, configMap){
  var resourceIds;
  resourceIds = dynamicCast(configMap.keySet_0().toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, configMap.size_1(), 0)), Q$Integer_$1);
  $getResourcesAncestry(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), resourceIds, ($clinit_ResourceAncestryFormat() , EXTENDED), new HistoryGroupPluginConfigurationSettings$2$1_0(this$static, configMap, resourceIds));
}

function HistoryGroupPluginConfigurationSettings$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3157, 1, {}, HistoryGroupPluginConfigurationSettings$2_0);
_.onFailure = function onFailure_315(caught){
  $handleLoadFailure_2(this.this$0, caught);
}
;
_.onSuccess_0 = function onSuccess_315(configMap){
  $onSuccess_301(this, dynamicCast(configMap, Q$Map));
}
;
_.this$0 = null;
function $onSuccess_302(this$static, labelMap){
  var configuration, label, memberConfiguration, resourceId, resourceId$array, resourceId$index, resourceId$max;
  this$static.this$1.this$0.memberConfigurations = new ArrayList_1(this$static.val$configMap.size_1());
  for (resourceId$array = this$static.val$resourceIds , resourceId$index = 0 , resourceId$max = resourceId$array.length; resourceId$index < resourceId$max; ++resourceId$index) {
    resourceId = resourceId$array[resourceId$index];
    label = dynamicCast(labelMap.get_2(resourceId), Q$String);
    configuration = dynamicCast(this$static.val$configMap.get_2(resourceId), Q$Configuration);
    memberConfiguration = new GroupMemberConfiguration_0(resourceId.value_0, label, configuration);
    if (!configuration || (!configuration.propertiesProxy && (configuration.propertiesProxy = new Configuration$PropertiesProxy_0(configuration)) , configuration.propertiesProxy.this$0.properties.isEmpty_0())) {
      throw new RuntimeException_1('The server did not return the connection settings for one or more member resources.');
    }
    $add_3(this$static.this$1.this$0.memberConfigurations, memberConfiguration);
  }
  $initEditor_2(this$static.this$1.this$0);
}

function HistoryGroupPluginConfigurationSettings$2$1_0(this$1, val$configMap, val$resourceIds){
  this.this$1 = this$1;
  this.val$configMap = val$configMap;
  this.val$resourceIds = val$resourceIds;
}

defineSeed(3158, 1, {}, HistoryGroupPluginConfigurationSettings$2$1_0);
_.onFailure = function onFailure_316(caught){
  $handleLoadFailure_2(this.this$1.this$0, caught);
}
;
_.onSuccess_0 = function onSuccess_316(labelMap){
  $onSuccess_302(this, dynamicCast(labelMap, Q$Map));
}
;
_.this$1 = null;
_.val$configMap = null;
_.val$resourceIds = null;
function $getStatusHtmlString_3(record){
  var html, obj_0;
  html = null;
  obj_0 = dynamicCast(getAttributeAsObject(record.jsObj, 'object'), Q$AbstractConfigurationUpdate);
  switch (obj_0.status_0.ordinal) {
    case 1:
      {
        html = ($clinit_Enhanced() , 'This group configuration update was successful');
        break;
      }

    case 0:
      {
        html = '<p>' + ($clinit_Enhanced() , 'This group configuration update is still in progress') + '<\/p><p>View Member History for status of each individual resource<\/p>';
        break;
      }

    case 3:
      {
        html = ($clinit_Enhanced() , 'No changes were made to this group configuration');
        break;
      }

    case 2:
      {
        html = obj_0.errorMessage_0;
        if (html == null) {
          html = '<p>' + ($clinit_Enhanced() , 'This group configuration update failed') + '<\/p><p>View Member History for status of each individual resource<\/p>';
        }
         else {
          html.length > 80?(html = '<pre>' + html.substr(0, 80 - 0) + '...<\/pre><p>' + ($clinit_Enhanced() , 'Click the status icon for full details') + '<\/p>'):(html = '<pre>' + html + '<\/pre>');
          html = html + '<p>' + ($clinit_Enhanced() , 'View Member History for status of each individual resource') + '<\/p>';
        }
        break;
      }

  }
  return html;
}

function HistoryGroupPluginConfigurationTable_0(groupComposite){
  Table_2.call(this, ($clinit_Enhanced() , 'Group Connection Settings History'));
  this.group = groupComposite.resourceGroup;
  this.groupPerms = groupComposite.resourcePermission;
  $setDataSource(this, new HistoryGroupPluginConfigurationTable$DataSource_0(this));
}

defineSeed(3159, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), HistoryGroupPluginConfigurationTable_0);
_.configureTable = function configureTable_47(){
  var fieldDateCreated, fieldId, fieldLastUpdated, fieldStatus, fieldUser, listGrid, statusIcons;
  fieldId = new ListGridField_3('id', ($clinit_Enhanced() , 'Version'));
  fieldDateCreated = new ListGridField_3('createdTime', 'Date Created');
  fieldLastUpdated = new ListGridField_3('modifiedTime', 'Last Updated');
  fieldStatus = new ListGridField_3('status', 'Status');
  fieldUser = new ListGridField_3('subjectName', 'User');
  $clinit_TimestampCellFormatter();
  prepareDateField(fieldDateCreated, getAttribute(fieldDateCreated.jsObj, 'name'));
  prepareDateField(fieldLastUpdated, getAttribute(fieldLastUpdated.jsObj, 'name'));
  fieldId.jsObj['width'] = '10%';
  fieldDateCreated.jsObj['width'] = '35%';
  fieldLastUpdated.jsObj['width'] = '35%';
  fieldStatus.jsObj['width'] = '10%';
  fieldUser.jsObj['width'] = '*';
  $setAttribute_13(fieldStatus, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0);
  statusIcons = new HashMap_1(4);
  statusIcons.put(($clinit_ConfigurationUpdateStatus() , SUCCESS_2).name_0, getPluginConfigurationIcon(SUCCESS_2));
  statusIcons.put(FAILURE_2.name_0, getPluginConfigurationIcon(FAILURE_2));
  statusIcons.put(INPROGRESS.name_0, getPluginConfigurationIcon(INPROGRESS));
  statusIcons.put(NOCHANGE.name_0, getPluginConfigurationIcon(NOCHANGE));
  setAttribute_10(fieldStatus.jsObj, 'valueIcons', statusIcons);
  $addRecordClickHandler_0(fieldStatus, new HistoryGroupPluginConfigurationTable$1_0);
  $setAttribute_8(fieldStatus, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(fieldStatus, new HistoryGroupPluginConfigurationTable$2_0);
  listGrid = this.listGrid;
  $isCreated_1(listGrid)?$setProperty_2(listGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [fieldId, fieldDateCreated, fieldLastUpdated, fieldStatus, fieldUser]))):(listGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [fieldId, fieldDateCreated, fieldLastUpdated, fieldStatus, fieldUser])) , undefined);
  $addTableAction(this, 'Delete', 'Are You Sure?', null, new HistoryGroupPluginConfigurationTable$3_0(this, this.groupPerms.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE))?($clinit_TableActionEnablement() , ANY_1):($clinit_TableActionEnablement() , NEVER_1)));
  $addTableAction(this, 'View Settings', null, null, new HistoryGroupPluginConfigurationTable$4_0(this, ($clinit_TableActionEnablement() , SINGLE_0)));
  $addTableAction(this, 'View Member History', null, null, new HistoryGroupPluginConfigurationTable$5_0(this, SINGLE_0));
}
;
_.group = null;
_.groupPerms = null;
function HistoryGroupPluginConfigurationTable$1_0(){
}

defineSeed(3160, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), HistoryGroupPluginConfigurationTable$1_0);
_.onRecordClick = function onRecordClick_14(event_0){
  var self_0;
  self_0 = (new ErrorMessageWindow_1(($clinit_Enhanced() , 'Error'), $getStatusHtmlString_3($getRecord_0(event_0)))).getOrCreateJsObj();
  self_0.show();
}
;
function HistoryGroupPluginConfigurationTable$2_0(){
}

defineSeed(3161, 1, {}, HistoryGroupPluginConfigurationTable$2_0);
_.hoverHTML_0 = function hoverHTML_37(value, record, rowNum, colNum){
  var html;
  html = $getStatusHtmlString_3(record);
  return html;
}
;
function HistoryGroupPluginConfigurationTable$3_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3162, 1608, {}, HistoryGroupPluginConfigurationTable$3_0);
_.executeAction = function executeAction_63(selection, actionValue){
  var groupId, i, record, record$index, record$max, service, updateIds;
  if (selection == null || selection.length == 0) {
    return;
  }
  service = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  groupId = valueOf_44(this.this$0.group.id);
  updateIds = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, selection.length, 0);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    updateIds[i++] = getAttributeAsInt(record.jsObj, 'id');
  }
  $deleteGroupPluginConfigurationUpdate(service, groupId, updateIds, new HistoryGroupPluginConfigurationTable$3$1_0(this, selection));
}
;
_.this$0 = null;
function $onSuccess_303(this$static){
  var message;
  $refresh(this$static.this$1.this$0, false);
  message = new Message_8('You have deleted [' + ($clinit_Enhanced() , '' + this$static.val$selection.length) + '] history items', ($clinit_Message$Severity() , Info), of(($clinit_Message$Option() , Transient)));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
}

function HistoryGroupPluginConfigurationTable$3$1_0(this$1, val$selection){
  this.this$1 = this$1;
  this.val$selection = val$selection;
}

defineSeed(3163, 1, {}, HistoryGroupPluginConfigurationTable$3$1_0);
_.onFailure = function onFailure_317(caught){
  $refreshTableInfo(this.this$1.this$0);
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete group plugin config history'), caught);
}
;
_.onSuccess_0 = function onSuccess_317(result){
  $onSuccess_303(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$selection = null;
function HistoryGroupPluginConfigurationTable$4_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3164, 1608, {}, HistoryGroupPluginConfigurationTable$4_0);
_.executeAction = function executeAction_64(selection, actionValue){
  $clinit_CoreGUI();
  goToView(getGroupPluginConfigurationUpdateHistoryLink(forGroup_0(this.this$0.group), null) + '/' + getAttribute(selection[0].jsObj, 'id') + '/Settings', null, false);
  $refreshTableInfo(this.this$0);
}
;
_.this$0 = null;
function HistoryGroupPluginConfigurationTable$5_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3165, 1608, {}, HistoryGroupPluginConfigurationTable$5_0);
_.executeAction = function executeAction_65(selection, actionValue){
  $clinit_CoreGUI();
  goToView(getGroupPluginConfigurationUpdateHistoryLink(forGroup_0(this.this$0.group), null) + '/' + getAttribute(selection[0].jsObj, 'id') + '/Members', null, false);
  $refreshTableInfo(this.this$0);
}
;
_.this$0 = null;
function $copyValues_52(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_14(record, 'createdTime', new Date_2(from.createdTime));
  $setAttribute_14(record, 'modifiedTime', new Date_2(from.modifiedTime));
  $setAttribute_13(record, 'status', from.status_0.name_0);
  $setAttribute_13(record, 'subjectName', from.subjectName);
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  return record;
}

function $executeFetch_36(this$static, request, response, criteria){
  var configurationService;
  configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  $findGroupPluginConfigurationUpdatesByCriteria(configurationService, criteria, new HistoryGroupPluginConfigurationTable$DataSource$1_0(this$static, response, request));
}

function HistoryGroupPluginConfigurationTable$DataSource_0(this$0){
  $clinit_RPCDataSource();
  this.this$0 = this$0;
  RPCDataSource_0.call(this);
}

defineSeed(3166, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), HistoryGroupPluginConfigurationTable$DataSource_0);
_.copyValues = function copyValues_93(from){
  return dynamicCast(getAttributeAsObject(from.jsObj, 'object'), Q$GroupPluginConfigurationUpdate);
}
;
_.copyValues_0 = function copyValues_94(from){
  return $copyValues_52(dynamicCast(from, Q$GroupPluginConfigurationUpdate));
}
;
_.executeFetch = function executeFetch_50(request, response, criteria){
  $executeFetch_36(this, request, response, dynamicCast(criteria, Q$GroupPluginConfigurationUpdateCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_62(request){
  var criteria, groupList;
  return criteria = new GroupPluginConfigurationUpdateCriteria_0 , groupList = new ArrayList_1(1) , $add_3(groupList, valueOf_44(this.this$0.group.id)) , criteria.filterResourceGroupIds = groupList , criteria;
}
;
_.this$0 = null;
function $onFailure_34(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to get group plugin config history'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_304(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$1, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(max_0(result.size_0, result.totalSize)));
  $processResponse_0(this$static.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function HistoryGroupPluginConfigurationTable$DataSource$1_0(this$1, val$response, val$request){
  this.this$1 = this$1;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3167, 1, {}, HistoryGroupPluginConfigurationTable$DataSource$1_0);
_.onFailure = function onFailure_318(caught){
  $onFailure_34(this, caught);
}
;
_.onSuccess_0 = function onSuccess_318(result){
  $onSuccess_304(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function HistoryGroupPluginConfigurationView_0(groupComposite){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.groupComposite = groupComposite;
  this.groupHistoryTable = new HistoryGroupPluginConfigurationTable_0(groupComposite);
  $addMember(this, this.groupHistoryTable);
}

defineSeed(3168, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), HistoryGroupPluginConfigurationView_0);
_.renderView = function renderView_30(viewPath){
  var configView, currentPath, groupHistoryId;
  if (viewPath.viewPath.size_0 <= viewPath.index_0) {
    $setVisibleMember(this, this.groupHistoryTable);
  }
   else {
    groupHistoryId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
    ++viewPath.index_0;
    if (viewPath.viewPath.size_0 <= viewPath.index_0) {
      configView = true;
    }
     else {
      currentPath = (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path;
      if ($equals_6('Settings', currentPath)) {
        configView = true;
      }
       else if ($equals_6('Members', currentPath)) {
        configView = false;
      }
       else {
        throw new IllegalArgumentException_1('Cannot render page - invalid URL: ' + currentPath);
      }
    }
    if (this.detailsCanvas) {
      $removeMember(this, this.detailsCanvas);
      this.detailsCanvas.destroy_0();
    }
    configView?(this.detailsCanvas = new HistoryGroupPluginConfigurationSettings_0(this.groupComposite, groupHistoryId)):(this.detailsCanvas = new HistoryGroupPluginConfigurationMembers_0(this.groupComposite, groupHistoryId));
    $addMember(this, this.detailsCanvas);
    $setVisibleMember(this, this.detailsCanvas);
  }
}
;
_.detailsCanvas = null;
_.groupComposite = null;
_.groupHistoryTable = null;
function MembersView_0(groupId, canModifyMembers){
  $clinit_ResourceSearchView();
  ResourceSearchView_2.call(this, new Criteria_2('groupId', '' + groupId), ($clinit_Enhanced() , 'Member Resources'), initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, []));
  this.initialCriteriaFixed = true;
  this.canModifyMembers = canModifyMembers;
  this.groupId_0 = groupId;
}

defineSeed(3169, 2557, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), MembersView_0);
_.configureTable = function configureTable_48(){
  $configureTable_3(this);
  debug('MembersView canModifyMembers: ' + this.canModifyMembers);
  this.canModifyMembers && $addTableAction(this, ($clinit_Enhanced() , 'Update Membership...'), null, null, new MembersView$1_0(this, ($clinit_TableActionEnablement() , ALWAYS)));
}
;
_.canModifyMembers = false;
_.groupId_0 = 0;
function MembersView$1_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3170, 1608, {}, MembersView$1_0);
_.executeAction = function executeAction_66(selection, actionValue){
  var membershipView, winModal;
  winModal = new Window_1;
  $setTitle(winModal, ($clinit_Enhanced() , 'Update Membership'));
  $setAttribute_24(winModal, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $setShowMinimizeButton(winModal, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setIsModal(winModal, TRUE);
  $setShowModalMask(winModal, TRUE);
  $isCreated_1(winModal)?$setProperty_0(winModal, 'width', 700):(winModal.config_0['width'] = 700 , undefined);
  $isCreated_1(winModal)?$setProperty_0(winModal, 'height', 450):(winModal.config_0['height'] = 450 , undefined);
  $setAutoCenter(winModal, TRUE);
  $setShowResizer(winModal, TRUE);
  $setCanDragResize_0(winModal, TRUE);
  $centerInPage(winModal);
  $addCloseClickHandler(winModal, new MembersView$1$1_0(this, winModal));
  membershipView = new ResourceGroupMembershipView_0(this.this$0.groupId_0);
  $setSaveButtonHandler(membershipView, new MembersView$1$2_0(this, winModal));
  $setCancelButtonHandler(membershipView, new MembersView$1$3_0(this, winModal));
  $addItem(winModal, membershipView);
  winModal.show_0();
}
;
_.this$0 = null;
function MembersView$1$1_0(this$1, val$winModal){
  this.this$1 = this$1;
  this.val$winModal = val$winModal;
}

defineSeed(3171, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), MembersView$1$1_0);
_.onCloseClick_0 = function onCloseClick_14(event_0){
  $markForDestroy(this.val$winModal);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.this$1 = null;
_.val$winModal = null;
function $onClick_0(this$static){
  $markForDestroy(this$static.val$winModal);
  $refreshTableInfo(this$static.this$1.this$0);
  $clinit_CoreGUI();
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function MembersView$1$2_0(this$1, val$winModal){
  this.this$1 = this$1;
  this.val$winModal = val$winModal;
}

defineSeed(3172, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), MembersView$1$2_0);
_.onClick = function onClick_143(event_0){
  $onClick_0(this);
}
;
_.this$1 = null;
_.val$winModal = null;
function $onClick_1(this$static){
  $destroy(this$static.val$winModal);
  $refreshTableInfo(this$static.this$1.this$0);
}

function MembersView$1$3_0(this$1, val$winModal){
  this.this$1 = this$1;
  this.val$winModal = val$winModal;
}

defineSeed(3173, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), MembersView$1$3_0);
_.onClick = function onClick_144(event_0){
  $onClick_1(this);
}
;
_.this$1 = null;
_.val$winModal = null;
function $getSelectedResourceIds(this$static){
  var i, id, id$iterator, selectedIds, selection;
  selectedIds = $getSelection(this$static.selector);
  selection = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selectedIds.map.size_1(), 1);
  i = 0;
  for (id$iterator = $iterator($keySet(selectedIds.map)); id$iterator.val$outerIter.hasNext();) {
    id = dynamicCast($next_1(id$iterator), Q$Integer);
    selection[i++] = id.value_0;
  }
  return selection;
}

function $save_9(this$static){
  var resourceIds;
  resourceIds = $getSelectedResourceIds(this$static);
  $setAssignedResources(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), this$static.resourceGroup.id, resourceIds, true, new ResourceGroupMembershipView$4_0(this$static));
}

function $setCancelButtonHandler(this$static, cancelButtonHandler){
  this$static.cancelButtonHandler = cancelButtonHandler;
}

function $setSaveButtonHandler(this$static, saveButtonHandler){
  this$static.saveButtonHandler = saveButtonHandler;
}

function ResourceGroupMembershipView_0(resourceGroupId){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.resourceGroupId = resourceGroupId;
}

defineSeed(3174, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ResourceGroupMembershipView_0);
_.onDraw_0 = function onDraw_46(){
  var toolStrip, cancelButton, saveButton, c;
  toolStrip = new ToolStrip_0;
  $isCreated_1(toolStrip)?$setProperty_3(toolStrip, 'width', '100%'):(toolStrip.config_0['width'] = '100%' , undefined);
  $isCreated_1(toolStrip)?$setProperty_0(toolStrip, 'membersMargin', 5):(toolStrip.config_0['membersMargin'] = 5 , undefined);
  $setLayoutMargin(toolStrip, valueOf_44(5));
  $setAttribute_24(toolStrip, 'align', ($clinit_Alignment() , RIGHT_0).value_0, true);
  cancelButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Cancel'));
  $addClickHandler(cancelButton, new ResourceGroupMembershipView$1_0(this));
  $addMember(toolStrip, cancelButton);
  saveButton = new EnhancedIButton_1('Save');
  $addClickHandler(saveButton, new ResourceGroupMembershipView$2_0(this));
  $addMember(toolStrip, saveButton);
  c = new ResourceGroupCriteria_0;
  $addFilterId(c, valueOf_44(this.resourceGroupId));
  c.fetchExplicitResources = true;
  c.fetchResourceType = true;
  $findResourceGroupsByCriteria(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), c, new ResourceGroupMembershipView$3_0(this, toolStrip));
}
;
_.cancelButtonHandler = null;
_.resourceGroup = null;
_.resourceGroupId = 0;
_.saveButtonHandler = null;
_.selector = null;
function ResourceGroupMembershipView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3175, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceGroupMembershipView$1_0);
_.onClick = function onClick_145(clickEvent){
  !!this.this$0.cancelButtonHandler && $onClick_1(this.this$0.cancelButtonHandler);
  $destroy_1(this.this$0);
}
;
_.this$0 = null;
function ResourceGroupMembershipView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3176, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceGroupMembershipView$2_0);
_.onClick = function onClick_146(clickEvent){
  $save_9(this.this$0);
  !!this.this$0.saveButtonHandler && $onClick_0(this.this$0.saveButtonHandler);
}
;
_.this$0 = null;
function $onSuccess_305(this$static, result){
  var group;
  group = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroup);
  this$static.this$0.resourceGroup = group;
  this$static.this$0.selector = new ResourceGroupResourceSelector_0((!group.explicitResources && (group.explicitResources = new HashSet_0) , group.explicitResources), ($clinit_GroupCategory() , COMPATIBLE) == this$static.this$0.resourceGroup.groupCategory?group.resourceType:null);
  $addMember(this$static.this$0, this$static.this$0.selector);
  $addMember(this$static.this$0, this$static.val$toolStrip);
  $markForRedraw(this$static.this$0);
}

function ResourceGroupMembershipView$3_0(this$0, val$toolStrip){
  this.this$0 = this$0;
  this.val$toolStrip = val$toolStrip;
}

defineSeed(3177, 1, {}, ResourceGroupMembershipView$3_0);
_.onFailure = function onFailure_319(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to fetch Resource Group'), caught);
}
;
_.onSuccess_0 = function onSuccess_319(result){
  $onSuccess_305(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$toolStrip = null;
function $onSuccess_306(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have updated the membership of group [' + ($clinit_Enhanced() , this$static.this$0.resourceGroup.name_0) + ']', ($clinit_Message$Severity() , Info)));
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function ResourceGroupMembershipView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3178, 1, {}, ResourceGroupMembershipView$4_0);
_.onFailure = function onFailure_320(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to update membership of group [' + ($clinit_Enhanced() , this.this$0.resourceGroup.name_0) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_320(result){
  $onSuccess_306(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $buildResourceCategoryValueMap(){
  var categories, category, category$index, category$max, valueMap;
  valueMap = new LinkedHashMap_0;
  categories = ($clinit_ResourceCategory() , $clinit_ResourceCategory() , $VALUES_104);
  for (category$index = 0 , category$max = categories.length; category$index < category$max; ++category$index) {
    category = categories[category$index];
    $put_1(valueMap, category.name_0, category.displayName);
  }
  return valueMap;
}

function ResourceSelector_0(){
  $clinit_BaseWidget();
  ResourceSelector_1.call(this, null);
}

function ResourceSelector_1(resourceTypeFilter){
  AbstractSelector_0.call(this);
  this.resourceTypeFilter = resourceTypeFilter;
  this.forceResourceTypeFilter = false;
}

defineSeed(3180, 1699, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ResourceSelector_0);
_.getAvailableFilterForm = function getAvailableFilterForm_8(){
  var categorySelect, search, valueMap;
  if (!this.availableFilterForm) {
    this.availableFilterForm = new DynamicForm_0;
    $setNumCols(this.availableFilterForm, 6);
    $setWidth_0(this.availableFilterForm, '75%');
    search = new TextItem_3('search', ($clinit_Enhanced() , 'Search'));
    this.typeSelectItem = new IPickTreeItem_0('Type');
    $setAttribute_28(this.typeSelectItem, 'dataSource', $getOrCreateJsObj(new ResourceTypePluginTreeDataSource_0));
    $setAttribute_30(this.typeSelectItem, 'valueField', 'id');
    $setAttribute_29(this.typeSelectItem, 'canSelectParentItems', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $setAttribute_29(this.typeSelectItem, 'loadDataOnDemand', FALSE);
    $setAttribute_30(this.typeSelectItem, 'emptyMenuMessage', 'Loading...');
    $setShowIcons(this.typeSelectItem, FALSE);
    this.forceResourceTypeFilter && $setDisabled_2(this.typeSelectItem, TRUE);
    categorySelect = new SelectItem_2('category', 'Category');
    valueMap = $buildResourceCategoryValueMap();
    categorySelect.setValueMap_0(valueMap);
    $setAllowEmptyValue(categorySelect, TRUE);
    this.availableFilterForm.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [search, categorySelect, this.typeSelectItem]));
  }
  return this.availableFilterForm;
}
;
_.getDataSource_0 = function getDataSource_25(){
  !this.datasource && (this.datasource = new ResourceSelector$SelectedResourceDataSource_0(this));
  return this.datasource;
}
;
_.getItemTitle = function getItemTitle_8(){
  return 'resource';
}
;
_.getLatestCriteria = function getLatestCriteria_8(availableFilterForm){
  var $e0, category, criteria, search, type;
  search = dynamicCast($getValue(availableFilterForm, 'search'), Q$String);
  type = $getValueAsString(availableFilterForm, 'type');
  category = dynamicCast($getValue(availableFilterForm, 'category'), Q$String);
  criteria = new Criteria_0;
  null != search && $addCriteria_2(criteria, ($clinit_ResourceDataSourceField() , NAME_31).propertyName, search);
  if (null != type) {
    try {
      __parseAndValidateInt(type);
      $addCriteria_2(criteria, ($clinit_ResourceDataSourceField() , TYPE_56).propertyName, type);
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$NumberFormatException)) {
        $addCriteria_2(criteria, ($clinit_ResourceDataSourceField() , PLUGIN_2).propertyName, type);
      }
       else 
        throw $e0;
    }
  }
  null != category && $addCriteria_2(criteria, ($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName, category);
  return criteria;
}
;
_.getNameHoverCustomizer = function getNameHoverCustomizer_0(){
  return new ResourceSelector$1_0;
}
;
_.supportsNameHoverCustomizer = function supportsNameHoverCustomizer_0(){
  return true;
}
;
_.forceResourceTypeFilter = false;
_.resourceTypeFilter = null;
_.typeSelectItem = null;
function ResourceGroupResourceSelector_0(resources, resourceTypeFilter){
  $clinit_BaseWidget();
  ResourceSelector_1.call(this, resourceTypeFilter);
  this.resources = resources;
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
}

defineSeed(3179, 3180, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ResourceGroupResourceSelector_0);
_.onInit = function onInit_62(){
  var ancestries, resource, resource$iterator, typeRepo, typesSet;
  if (this.resources) {
    typesSet = new HashSet_0;
    ancestries = new HashSet_0;
    for (resource$iterator = this.resources.iterator(); resource$iterator.hasNext();) {
      resource = dynamicCast(resource$iterator.next_0(), Q$Resource);
      $add_6(typesSet, valueOf_44(resource.resourceType.id));
      $add_6(ancestries, resource.ancestry);
    }
    $addAll(typesSet, getAncestryTypeIds(ancestries));
    typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
    $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new ResourceGroupResourceSelector$1_0(this));
  }
   else {
    $onInit_3(this);
  }
}
;
_.resources = null;
function ResourceGroupResourceSelector$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3181, 1, {}, ResourceGroupResourceSelector$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_28(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(new ResourceDatasource_0, this.this$0.resources, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
  }
  $setAssigned(this.this$0, records);
  $onInit_3(this.this$0);
}
;
_.this$0 = null;
function $clinit_ResourceGroupSchedulesView(){
  $clinit_ResourceGroupSchedulesView = nullMethod;
  $clinit_AbstractSchedulesView();
  TITLE_2 = ($clinit_Enhanced() , 'Group Metric Collection Schedules');
}

function ResourceGroupSchedulesView_0(resourceGroupComposite){
  $clinit_ResourceGroupSchedulesView();
  AbstractSchedulesView_0.call(this, TITLE_2, new EntityContext_0(null, valueOf_44(resourceGroupComposite.resourceGroup.id), null), resourceGroupComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , MANAGE_MEASUREMENTS)));
  this.groupId = resourceGroupComposite.resourceGroup.id;
}

defineSeed(3182, 1753, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ResourceGroupSchedulesView_0);
_.disableSchedules = function disableSchedules_0(measurementDefinitionIds, measurementDefinitionDisplayNames){
  $disableSchedulesForCompatibleGroup(this.measurementService, this.groupId, measurementDefinitionIds, new ResourceGroupSchedulesView$2_0(this, measurementDefinitionIds, measurementDefinitionDisplayNames));
}
;
_.enableSchedules = function enableSchedules_0(measurementDefinitionIds, measurementDefinitionDisplayNames){
  $enableSchedulesForCompatibleGroup(this.measurementService, this.groupId, measurementDefinitionIds, new ResourceGroupSchedulesView$1_0(this, measurementDefinitionIds, measurementDefinitionDisplayNames));
}
;
_.updateSchedules = function updateSchedules_0(measurementDefinitionIds, measurementDefinitionDisplayNames, collectionInterval){
  $updateSchedulesForCompatibleGroup(this.measurementService, this.groupId, measurementDefinitionIds, collectionInterval, new ResourceGroupSchedulesView$3_0(this, measurementDefinitionIds, measurementDefinitionDisplayNames, collectionInterval));
}
;
_.groupId = 0;
var TITLE_2;
function $onSuccess_307(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('You have enabled the collection of [' + ($clinit_Enhanced() , '' + this$static.val$measurementDefinitionIds.length) + '] measurements', 'You have enabled the collection of [' + this$static.val$measurementDefinitionIds.length + '] measurements for the resource group with ID [' + this$static.this$0.groupId + ']. The enabled measurements are: [' + this$static.val$measurementDefinitionDisplayNames.toString$() + ']', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceGroupSchedulesView$1_0(this$0, val$measurementDefinitionIds, val$measurementDefinitionDisplayNames){
  this.this$0 = this$0;
  this.val$measurementDefinitionIds = val$measurementDefinitionIds;
  this.val$measurementDefinitionDisplayNames = val$measurementDefinitionDisplayNames;
}

defineSeed(3183, 1, {}, ResourceGroupSchedulesView$1_0);
_.onFailure = function onFailure_321(throwable){
  $handleError_0(($clinit_CoreGUI() , 'Failed to enable the collection of [' + ($clinit_Enhanced() , '' + this.val$measurementDefinitionIds.length) + '] metrics for group with ID [' + this.this$0.groupId + ']. The metrics were: [' + this.val$measurementDefinitionDisplayNames.toString$() + ']'), throwable);
}
;
_.onSuccess_0 = function onSuccess_321(aVoid){
  $onSuccess_307(this, throwClassCastExceptionUnlessNull(aVoid));
}
;
_.this$0 = null;
_.val$measurementDefinitionDisplayNames = null;
_.val$measurementDefinitionIds = null;
function $onSuccess_308(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('You have disabled the collection of [' + ($clinit_Enhanced() , '' + this$static.val$measurementDefinitionIds.length) + '] measurements', 'You have disabled the collection of [' + this$static.val$measurementDefinitionIds.length + '] measurements for the resource group with ID [' + this$static.this$0.groupId + ']. The disabled measurements are: [' + this$static.val$measurementDefinitionDisplayNames.toString$() + ']', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceGroupSchedulesView$2_0(this$0, val$measurementDefinitionIds, val$measurementDefinitionDisplayNames){
  this.this$0 = this$0;
  this.val$measurementDefinitionIds = val$measurementDefinitionIds;
  this.val$measurementDefinitionDisplayNames = val$measurementDefinitionDisplayNames;
}

defineSeed(3184, 1, {}, ResourceGroupSchedulesView$2_0);
_.onFailure = function onFailure_322(throwable){
  $handleError_0(($clinit_CoreGUI() , 'Failed to disable the collection of [' + ($clinit_Enhanced() , '' + this.val$measurementDefinitionIds.length) + '] metrics for resource group with ID [' + this.this$0.groupId + ']. The metrics were: [' + this.val$measurementDefinitionDisplayNames.toString$() + ']'), throwable);
}
;
_.onSuccess_0 = function onSuccess_322(aVoid){
  $onSuccess_308(this, throwClassCastExceptionUnlessNull(aVoid));
}
;
_.this$0 = null;
_.val$measurementDefinitionDisplayNames = null;
_.val$measurementDefinitionIds = null;
function $onSuccess_309(this$static){
  var collIntervalStr;
  collIntervalStr = '' + toString_8(div(this$static.val$collectionInterval, P3e8_longLit));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('A new collection interval of [' + ($clinit_Enhanced() , collIntervalStr) + '] seconds has been set on [' + this$static.val$measurementDefinitionIds.length + '] measurements', 'A new collection interval of [' + collIntervalStr + '] seconds has been set on [' + this$static.val$measurementDefinitionIds.length + '] measurements for resource group with ID [' + this$static.this$0.groupId + ']. The updated measurements are: [' + this$static.val$measurementDefinitionDisplayNames.toString$() + ']', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceGroupSchedulesView$3_0(this$0, val$measurementDefinitionIds, val$measurementDefinitionDisplayNames, val$collectionInterval){
  this.this$0 = this$0;
  this.val$measurementDefinitionIds = val$measurementDefinitionIds;
  this.val$measurementDefinitionDisplayNames = val$measurementDefinitionDisplayNames;
  this.val$collectionInterval = val$collectionInterval;
}

defineSeed(3185, 1, {}, ResourceGroupSchedulesView$3_0);
_.onFailure = function onFailure_323(throwable){
  $handleError_0(($clinit_CoreGUI() , 'Failed to set the collection interval of [' + ($clinit_Enhanced() , '' + this.val$measurementDefinitionIds.length) + '] metrics for resource group with ID [' + this.this$0.groupId + ']. The metrics were: [' + this.val$measurementDefinitionDisplayNames.toString$() + ']. The collection interval was to be [' + toString_8(div(this.val$collectionInterval, P3e8_longLit)) + '] seconds.'), throwable);
}
;
_.onSuccess_0 = function onSuccess_323(aVoid){
  $onSuccess_309(this, throwClassCastExceptionUnlessNull(aVoid));
}
;
_.this$0 = null;
_.val$collectionInterval = P0_longLit;
_.val$measurementDefinitionDisplayNames = null;
_.val$measurementDefinitionIds = null;
function $addMeasurementForEachResource(this$static, resourceName, resourceMeasurementList){
  $add_3(this$static.measurementForEachResource, new CompositeGroupD3GraphListView$MultiLineGraphData_0(resourceName, resourceMeasurementList));
}

function $drawGraph_0(this$static){
  debug('drawGraph in CompositeGroupD3GraphListView for: ' + this$static.definition + ',' + this$static.definitionId);
  !!this$static.titleHLayout && ($removeMember(this$static, this$static.measurementRangeEditor) , !!this$static.titleHLayout && $removeMember(this$static, this$static.titleHLayout) , !!this$static.title_0 && $removeMember(this$static, this$static.title_0) , !!this$static.graph && $removeMember(this$static, this$static.graph) , undefined);
  $addMember(this$static, this$static.measurementRangeEditor);
  this$static.titleHLayout = new EnhancedHLayout_0;
  if (this$static.definition) {
    $setAutoHeight(this$static.titleHLayout);
    $setAttribute_24(this$static.titleHLayout, 'width', '100%', true);
    $addMember(this$static, this$static.titleHLayout);
    this$static.title_0 = new HTMLFlow_1('<b>' + this$static.definition.displayName + '<\/b> ' + this$static.definition.description);
    $setAttribute_24(this$static.title_0, 'width', '100%', true);
    $addMember(this$static, this$static.title_0);
    this$static.graph = new HTMLFlow_1('<div id="mChart-' + this$static.groupId + '-' + this$static.definition.id + '" ><svg xmlns="http://www.w3.org/2000/svg" version="1.1" style="height:95%;"><\/svg><\/div>');
    $setAttribute_24(this$static.graph, 'width', '100%', true);
    $setAttribute_24(this$static.graph, 'height', '100%', true);
    $addMember(this$static, this$static.graph);
    $drawJsniChart_1(this$static);
    $markForRedraw(this$static);
  }
}

function $populateData(this$static){
  var criteria, groupService;
  groupService = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
  criteria = new ResourceGroupCriteria_0;
  $addFilterId(criteria, valueOf_44(this$static.groupId));
  criteria.fetchResourceType = true;
  $addFilterVisible(criteria, ($clinit_Boolean() , this$static.isAutogroup?FALSE:TRUE));
  criteria.fetchExplicitResources = true;
  $clear_2(this$static.measurementForEachResource);
  $findResourceGroupCompositesByCriteria(groupService, criteria, new CompositeGroupD3GraphListView$1_0(this$static));
}

function $produceInnerValuesArray(this$static, measurementList){
  var measurement, measurement$iterator, sb;
  sb = new StringBuilder_1('[');
  for (measurement$iterator = measurementList.iterator(); measurement$iterator.hasNext();) {
    measurement = dynamicCast(measurement$iterator.next_0(), Q$MeasurementDataNumericHighLowComposite);
    if (!isNaN_0(measurement.value_0)) {
      $append_12(sb, '{ x:' + toString_8(measurement.timestamp) + ',');
      $append_12(sb, ' y:' + scaleUp(new Double_0(measurement.value_0), this$static.definition.units) + '},');
    }
  }
  $setLength_1(sb, $toString_1(sb.data_0).length - 1);
  $append_1(sb.data_0, ']');
  return $toString_1(sb.data_0);
}

function $setDefinition_1(this$static, definition){
  this$static.definition = definition;
}

defineSeed(3186, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]));
_.getChartId = function getChartId_0(){
  return this.groupId + '-' + this.definition.id;
}
;
_.getJsonMetrics = function getJsonMetrics(){
  var multiLineGraphData, multiLineGraphData$iterator, sb;
  sb = new StringBuilder_1('[');
  for (multiLineGraphData$iterator = new AbstractList$IteratorImpl_0(this.measurementForEachResource); multiLineGraphData$iterator.i < multiLineGraphData$iterator.this$0_0.size_1();) {
    multiLineGraphData = dynamicCast($next_0(multiLineGraphData$iterator), Q$CompositeGroupD3GraphListView$MultiLineGraphData);
    $append_1(sb.data_0, '{ values: ');
    $append_12(sb, $produceInnerValuesArray(this, multiLineGraphData.measurementData));
    $append_1(sb.data_0, ",key: '");
    $append_12(sb, multiLineGraphData.resourceName);
    $append_1(sb.data_0, "'},");
  }
  $setLength_1(sb, $toString_1(sb.data_0).length - 1);
  $append_1(sb.data_0, ']');
  return $toString_1(sb.data_0);
}
;
_.getXAxisTitle = function getXAxisTitle(){
  return $clinit_Enhanced() , 'Time';
}
;
_.getYAxisUnits = function getYAxisUnits(){
  return this.definition.units.displayUnits;
}
;
_.onDraw_0 = function onDraw_47(){
  $drawGraph_0(this);
}
;
_.parentResized_0 = function parentResized_1(){
  $parentResized(this);
  $removeMembers(this, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')));
  $drawGraph_0(this);
}
;
_.shouldDisplayDayOfWeekInXAxisLabel = function shouldDisplayDayOfWeekInXAxisLabel(){
  var endTime, firstResourceMeasurementList, startTime;
  if (!this.measurementForEachResource || this.measurementForEachResource.size_0 == 0) {
    return true;
  }
  firstResourceMeasurementList = dynamicCast($get_0(this.measurementForEachResource, 0), Q$CompositeGroupD3GraphListView$MultiLineGraphData).measurementData;
  startTime = valueOf_45(dynamicCast(firstResourceMeasurementList.get_0(0), Q$MeasurementDataNumericHighLowComposite).timestamp);
  endTime = valueOf_45(dynamicCast(firstResourceMeasurementList.get_0(firstResourceMeasurementList.size_1() - 1), Q$MeasurementDataNumericHighLowComposite).timestamp);
  return lt(add(startTime.value_0, P5265c00_longLit), endTime.value_0);
}
;
_.definition = null;
_.definitionId = 0;
_.graph = null;
_.groupId = 0;
_.isAutogroup = false;
_.measurementForEachResource = null;
_.measurementRangeEditor = null;
_.title_0 = null;
_.titleHLayout = null;
function $onSuccess_310(this$static, result){
  var childResource, childResources, countDownLatch, parentGroup;
  if (result.size_0 == 0) {
    return;
  }
  parentGroup = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroupComposite).resourceGroup;
  debug('group name: ' + parentGroup.name_0);
  debug('# of child resources: ' + (!parentGroup.explicitResources && (parentGroup.explicitResources = new HashSet_0) , parentGroup.explicitResources).size_1());
  countDownLatch = new CountDownLatch_0((!parentGroup.explicitResources && (parentGroup.explicitResources = new HashSet_0) , parentGroup.explicitResources).size_1(), new CompositeGroupD3GraphListView$1$1_0(this$static));
  childResources = (!parentGroup.explicitResources && (parentGroup.explicitResources = new HashSet_0) , parentGroup.explicitResources);
  if (!childResources.isEmpty_0()) {
    childResource = dynamicCast(childResources.iterator().next_0(), Q$Resource);
    $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(childResource.resourceType.id), of(($clinit_ResourceTypeRepository$MetadataType() , measurements_0)), new CompositeGroupD3GraphListView$1$2_0(this$static, childResources, countDownLatch));
  }
}

function CompositeGroupD3GraphListView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3187, 1, {}, CompositeGroupD3GraphListView$1_0);
_.onFailure = function onFailure_324(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to find resource for graph'), caught);
}
;
_.onSuccess_0 = function onSuccess_324(result){
  $onSuccess_310(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function CompositeGroupD3GraphListView$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3188, 1, {}, CompositeGroupD3GraphListView$1$1_0);
_.execute_1 = function execute_53(){
  $drawGraph_0(this.this$1.this$0);
  $redraw(this.this$1.this$0);
}
;
_.this$1 = null;
function CompositeGroupD3GraphListView$1$2_0(this$1, val$childResources, val$countDownLatch){
  this.this$1 = this$1;
  this.val$childResources = val$childResources;
  this.val$countDownLatch = val$countDownLatch;
}

defineSeed(3189, 1, {}, CompositeGroupD3GraphListView$1$2_0);
_.onTypesLoaded = function onTypesLoaded_29(type){
  var childResource, childResource$iterator, def, def$iterator, endTime, startTime, times;
  for (def$iterator = type.metricDefinitions.iterator(); def$iterator.hasNext();) {
    def = dynamicCast(def$iterator.next_0(), Q$MeasurementDefinition);
    def.id == this.this$1.this$0.definitionId && $setDefinition_1(this.this$1.this$0, def);
  }
  times = $getBeginEndTimes($getMetricRangePreferences(this.this$1.this$0.measurementRangeEditor.measurementUserPrefs));
  startTime = dynamicCast((checkIndex(0, times.size_0) , times.array[0]), Q$Long);
  endTime = dynamicCast((checkIndex(1, times.size_0) , times.array[1]), Q$Long);
  $addClickHandler_1(this.this$1.this$0.measurementRangeEditor.setButton, new CompositeGroupD3GraphListView$1$2$1_0(this));
  for (childResource$iterator = this.val$childResources.iterator(); childResource$iterator.hasNext();) {
    childResource = dynamicCast(childResource$iterator.next_0(), Q$Resource);
    debug('Adding child composite: ' + childResource.name_0 + childResource.id);
    $findDataForResource(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), childResource.id, initValues(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [this.this$1.this$0.definitionId]), startTime.value_0, endTime.value_0, new CompositeGroupD3GraphListView$1$2$2_0(this, this.val$countDownLatch, childResource));
  }
}
;
_.this$1 = null;
_.val$childResources = null;
_.val$countDownLatch = null;
function CompositeGroupD3GraphListView$1$2$1_0(this$2){
  this.this$2 = this$2;
}

defineSeed(3190, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), CompositeGroupD3GraphListView$1$2$1_0);
_.onClick_0 = function onClick_147(event_0){
  $drawGraph_0(this.this$2.this$1.this$0);
  $populateData(this.this$2.this$1.this$0);
  $markForRedraw(this.this$2.this$1.this$0);
}
;
_.this$2 = null;
function $onSuccess_311(this$static, result){
  $addMeasurementForEachResource(this$static.this$2.this$1.this$0, this$static.val$childResource.name_0, (this$static.val$childResource , dynamicCast(result.get_0(0), Q$List)));
  $countDown(this$static.val$countDownLatch);
}

function CompositeGroupD3GraphListView$1$2$2_0(this$2, val$countDownLatch, val$childResource){
  this.this$2 = this$2;
  this.val$countDownLatch = val$countDownLatch;
  this.val$childResource = val$childResource;
}

defineSeed(3191, 1, {}, CompositeGroupD3GraphListView$1$2$2_0);
_.onFailure = function onFailure_325(caught){
  $countDown(this.val$countDownLatch);
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load graph data'), caught);
}
;
_.onSuccess_0 = function onSuccess_325(result){
  $onSuccess_311(this, dynamicCast(result, Q$List));
}
;
_.this$2 = null;
_.val$childResource = null;
_.val$countDownLatch = null;
function CompositeGroupD3GraphListView$MultiLineGraphData_0(resourceName, measurmentData){
  this.resourceName = resourceName;
  this.measurementData = measurmentData;
}

defineSeed(3192, 1, makeCastMap([Q$CompositeGroupD3GraphListView$MultiLineGraphData]), CompositeGroupD3GraphListView$MultiLineGraphData_0);
_.measurementData = null;
_.resourceName = null;
function $drawJsniChart_1(this$static){
  console.log('Draw nvd3 charts for composite multiline graph');
  var chartId = this$static.getChartId(), chartHandle = '#mChart-' + chartId, chartSelection = chartHandle + ' svg', yAxisUnits = this$static.getYAxisUnits(), xAxisLabel = this$static.getXAxisTitle(), displayDayOfWeek = this$static.shouldDisplayDayOfWeekInXAxisLabel(), xAxisTimeFormat = displayDayOfWeek?'%a %I %p':'%I %p', json = eval(this$static.getJsonMetrics());
  $wnd.nv.addGraph(function(){
    var chart = $wnd.nv.models.lineChart();
    chart.xAxis.axisLabel(xAxisLabel).tickFormat(function(d){
      return $wnd.d3.time.format(xAxisTimeFormat)(new Date(d));
    }
    );
    chart.yAxis.axisLabel(yAxisUnits).tickFormat($wnd.d3.format('.02f'));
    $wnd.d3.select(chartSelection).datum(json).transition().duration(300).call(chart);
    $wnd.nv.utils.windowResize(chart.update);
    return chart;
  }
  );
}

function CompositeGroupMultiLineGraphListView_0(groupId, defId, isAutogroup){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.groupId = groupId;
  this.isAutogroup = isAutogroup;
  this.definitionId = defId;
  this.definition = null;
  this.measurementForEachResource = new ArrayList_0;
  this.measurementRangeEditor = new UserPreferencesMeasurementRangeEditor_0;
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $setPadding(this, valueOf_44(10));
}

defineSeed(3193, 3186, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), CompositeGroupMultiLineGraphListView_0);
function $getMetricStringValue(value){
  return value?$toString_12(value):'';
}

function MeasurementTableDataSource_0(resourceId){
  $clinit_RPCDataSource();
  RPCDataSource_0.call(this);
  this.resourceId = resourceId;
}

defineSeed(3195, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$MeasurementTableDataSource]), MeasurementTableDataSource_0);
_.copyValues = function copyValues_95(from){
  return null;
}
;
_.copyValues_0 = function copyValues_96(from){
  return this.copyValues_7(dynamicCast(from, Q$MetricDisplaySummary));
}
;
_.copyValues_7 = function copyValues_97(from){
  var record;
  formatSimpleMetrics(from);
  record = new ListGridRecord_0;
  $setAttribute_13(record, 'label', from.label);
  $setAttribute_13(record, 'alertCount', '' + from.alertCount);
  $setAttribute_13(record, 'min', $getMetricStringValue($getMinMetric(from)));
  $setAttribute_13(record, 'max', $getMetricStringValue($getMaxMetric(from)));
  $setAttribute_13(record, 'avg', $getMetricStringValue($getAvgMetric(from)));
  $setAttribute_13(record, 'last', $getMetricStringValue($getLastMetric(from)));
  $setAttribute_11(record, 'defId', from.definitionId);
  $setAttribute_11(record, 'schedId', from.scheduleId);
  $setAttribute_13(record, 'units', from.units);
  $setAttribute_13(record, 'name', from.metricName);
  return record;
}
;
_.executeFetch = function executeFetch_51(request, response, unused){
  this.executeFetch_5(request, response, dynamicCast(unused, Q$Criteria));
}
;
_.executeFetch_5 = function executeFetch_52(request, response, unused){
  $findSchedulesForResourceAndType(dynamicCast(secure((!instance_19 && (instance_19 = new MeasurementScheduleGWTService_Proxy_0) , instance_19), -1), Q$MeasurementScheduleGWTServiceAsync), this.resourceId, ($clinit_DataType() , MEASUREMENT), new MeasurementTableDataSource$1_0(this, response, request));
}
;
_.getFetchCriteria = function getFetchCriteria_63(request){
  return null;
}
;
_.getListGridFields_0 = function getListGridFields_7(){
  var alertsField, avgField, fields, lastField, maxField, minField, nameField;
  fields = new ArrayList_1(6);
  nameField = new ListGridField_3('label', 'Name');
  nameField.jsObj['width'] = '30%';
  setCheck(fields.array, fields.size_0++, nameField);
  alertsField = new ListGridField_3('alertCount', 'Alerts');
  alertsField.jsObj['width'] = '10%';
  setCheck(fields.array, fields.size_0++, alertsField);
  minField = new ListGridField_3('min', 'Minimum');
  minField.jsObj['width'] = '15%';
  setCheck(fields.array, fields.size_0++, minField);
  maxField = new ListGridField_3('max', 'Maximum');
  maxField.jsObj['width'] = '15%';
  setCheck(fields.array, fields.size_0++, maxField);
  avgField = new ListGridField_3('avg', 'Average');
  avgField.jsObj['width'] = '15%';
  setCheck(fields.array, fields.size_0++, avgField);
  lastField = new ListGridField_3('last', 'Last');
  lastField.jsObj['width'] = '15%';
  setCheck(fields.array, fields.size_0++, lastField);
  return fields;
}
;
_.resourceId = 0;
function $getListGridFields_17(){
  var alertsField, avgField, fields, maxField, memberCountField, minField, nameField;
  fields = new ArrayList_1(6);
  memberCountField = new ListGridField_3('membersReporting', 'Members Reporting');
  memberCountField.jsObj['width'] = '15%';
  setCheck(fields.array, fields.size_0++, memberCountField);
  nameField = new ListGridField_3('label', 'Name');
  $setAttribute_13(nameField, 'type', ($clinit_ListGridFieldType() , LINK_0).value_0);
  nameField.jsObj['target'] = 'javascript';
  nameField.jsObj['width'] = '30%';
  setCheck(fields.array, fields.size_0++, nameField);
  alertsField = new ListGridField_3('alertCount', 'Alerts');
  alertsField.jsObj['width'] = '10%';
  setCheck(fields.array, fields.size_0++, alertsField);
  minField = new ListGridField_3('min', 'Minimum');
  minField.jsObj['width'] = '15%';
  setCheck(fields.array, fields.size_0++, minField);
  maxField = new ListGridField_3('max', 'Maximum');
  maxField.jsObj['width'] = '15%';
  setCheck(fields.array, fields.size_0++, maxField);
  avgField = new ListGridField_3('avg', 'Average');
  avgField.jsObj['width'] = '15%';
  setCheck(fields.array, fields.size_0++, avgField);
  return fields;
}

function GroupMeasurementTableDataSource_0(groupComposite, groupId){
  $clinit_RPCDataSource();
  MeasurementTableDataSource_0.call(this, groupId);
  this.groupComposite = groupComposite;
  this.groupId = groupId;
}

defineSeed(3194, 3195, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$GroupMeasurementTableDataSource, Q$MeasurementTableDataSource]), GroupMeasurementTableDataSource_0);
_.copyValues_7 = function copyValues_98(from){
  var record;
  formatSimpleMetrics(from);
  record = new ListGridRecord_0;
  $setAttribute_13(record, 'label', from.label);
  $setAttribute_13(record, 'alertCount', '' + from.alertCount);
  $setAttribute_13(record, 'min', $getMetricStringValue($getMinMetric(from)));
  $setAttribute_13(record, 'max', $getMetricStringValue($getMaxMetric(from)));
  $setAttribute_13(record, 'avg', $getMetricStringValue($getAvgMetric(from)));
  $setAttribute_11(record, 'defId', from.definitionId);
  $setAttribute_11(record, 'schedId', from.scheduleId);
  $setAttribute_13(record, 'units', from.units);
  $setAttribute_13(record, 'name', from.metricName);
  $setAttribute_3(record, 'membersReporting', from.numberCollecting);
  return record;
}
;
_.executeFetch_5 = function executeFetch_53(request, response, unused){
  var group, groupComposite, groupType;
  groupComposite = this.groupComposite;
  group = groupComposite.resourceGroup;
  groupType = group.resourceType;
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(groupType.id), of_0(($clinit_ResourceTypeRepository$MetadataType() , content_1), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceTypeRepository$MetadataType, [operations_0, measurements_0, events_0, resourceConfigurationDefinition_0])), new GroupMeasurementTableDataSource$1_0(this, group, response, request));
}
;
_.getListGridFields_0 = function getListGridFields_8(){
  return $getListGridFields_17();
}
;
_.groupComposite = null;
_.groupId = 0;
function GroupMeasurementTableDataSource$1_0(this$0, val$group, val$response, val$request){
  this.this$0 = this$0;
  this.val$group = val$group;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3196, 1, {}, GroupMeasurementTableDataSource$1_0);
_.onTypesLoaded = function onTypesLoaded_30(type){
  var definition, definition$iterator, definitionArrayIds, definitionToDisplay, definitionToDisplay$index, definitionToDisplay$max, definitions, displayOrder, index, measurementDefMap, mprefs, prefs, range;
  $setResourceType_1(this.val$group, type);
  definitions = type.metricDefinitions;
  measurementDefMap = new HashMap_0;
  for (definition$iterator = definitions.iterator(); definition$iterator.hasNext();) {
    definition = dynamicCast(definition$iterator.next_0(), Q$MeasurementDefinition);
    measurementDefMap.put(definition.displayName, definition);
  }
  definitionArrayIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, definitions.size_1(), 1);
  displayOrder = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, definitions.size_1(), 0);
  $keySet(measurementDefMap).toArray_0(displayOrder);
  mergeSort(displayOrder, 0, displayOrder.length, ($clinit_Comparators() , $clinit_Comparators() , NATURAL));
  index = 0;
  for (definitionToDisplay$index = 0 , definitionToDisplay$max = displayOrder.length; definitionToDisplay$index < definitionToDisplay$max; ++definitionToDisplay$index) {
    definitionToDisplay = displayOrder[definitionToDisplay$index];
    definitionArrayIds[index++] = dynamicCast(measurementDefMap.get_2(definitionToDisplay), Q$MeasurementDefinition).id;
  }
  prefs = ($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences);
  mprefs = new MeasurementUserPreferences_0(prefs);
  range = $getBeginEndTimes($getMetricRangePreferences(mprefs));
  $getMetricDisplaySummariesForCompatibleGroup(dynamicCast(secure((!instance_17 && (instance_17 = new MeasurementChartsGWTService_Proxy_0) , instance_17), -1), Q$MeasurementChartsGWTServiceAsync), this.this$0.groupId, definitionArrayIds, valueOf_45(dynamicCast((checkIndex(0, range.size_0) , range.array[0]), Q$Long).value_0).value_0, valueOf_45(dynamicCast((checkIndex(1, range.size_0) , range.array[1]), Q$Long).value_0).value_0, new GroupMeasurementTableDataSource$1$1_0(this, this.val$response, this.val$request));
}
;
_.this$0 = null;
_.val$group = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_312(this$static, result){
  var mds, mds$iterator, validSummaries;
  validSummaries = new ArrayList_0;
  for (mds$iterator = new AbstractList$IteratorImpl_0(result); mds$iterator.i < mds$iterator.this$0_0.size_1();) {
    mds = dynamicCast($next_0(mds$iterator), Q$MetricDisplaySummary);
    mds.valuesPresent && (setCheck(validSummaries.array, validSummaries.size_0++, mds) , true);
  }
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$1.this$0, validSummaries, true));
  $processResponse_0(this$static.this$1.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function GroupMeasurementTableDataSource$1$1_0(this$1, val$response, val$request){
  this.this$1 = this$1;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3197, 1, {}, GroupMeasurementTableDataSource$1$1_0);
_.onFailure = function onFailure_326(caught){
  $handleError_0(($clinit_CoreGUI() , 'Cannot load metrics'), caught);
}
;
_.onSuccess_0 = function onSuccess_326(result){
  $onSuccess_312(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function GroupMeasurementTableView_0(groupComposite, groupId){
  Table_1.call(this);
  this.groupId = groupId;
  this.isAutogroup = !!groupComposite.resourceGroup.autoGroupParentResource;
  $setDataSource(this, new GroupMeasurementTableDataSource_0(groupComposite, groupId));
  this.showFooterRefresh = true;
  $setPrompt(this, ($clinit_Enhanced() , 'Numeric Metrics'));
}

defineSeed(3198, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), GroupMeasurementTableView_0);
_.configureTable = function configureTable_49(){
  var fields;
  fields = $getListGridFields_17(dynamicCast(this.dataSource_1, Q$GroupMeasurementTableDataSource));
  $addCellClickHandler(this.listGrid, new GroupMeasurementTableView$1_0(this));
  $setListGridFields(this, false, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, $getListGridFields_17(dynamicCast(this.dataSource_1, Q$GroupMeasurementTableDataSource)).size_0, 0)), Q$ListGridField_$1));
  $addExtraWidget(this, new UserPreferencesMeasurementRangeEditor_0, true);
}
;
_.groupId = 0;
_.isAutogroup = false;
function GroupMeasurementTableView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3199, 1, makeCastMap([Q$EventHandler, Q$CellClickHandler]), GroupMeasurementTableView$1_0);
_.onCellClick = function onCellClick_2(event_0){
  var defId, graph, record, title, window_0;
  record = $getRecord(event_0);
  title = getAttribute(record.jsObj, 'label');
  window_0 = new AbstractActivityView$ChartViewWindow_1('MeasurementTableFrame', title);
  defId = getAttributeAsInt(record.jsObj, 'defId').value_0;
  graph = new CompositeGroupMultiLineGraphListView_0(this.this$0.groupId, defId, this.this$0.isAutogroup);
  $addItem(window_0, graph);
  $populateData(graph);
  $show(window_0);
}
;
_.this$0 = null;
function GroupMembersHealthView_0(groupId){
  $clinit_ResourceSearchView();
  MembersView_0.call(this, groupId, false);
  this.groupId = groupId;
  this.showFilterForm = false;
  this.showFooterRefresh = true;
  this.hideSearchBar = true;
  $setPrompt(this, ($clinit_Enhanced() , 'Group Member Health'));
}

defineSeed(3200, 3169, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), GroupMembersHealthView_0);
_.configureTable = function configureTable_50(){
  var fields;
  fields = $createFields();
  $setListGridFields(this, false, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $addTableAction(this, ($clinit_Enhanced() , 'Compare Metrics'), null, null, new GroupMembersHealthView$1_0(this));
}
;
_.groupId = 0;
function GroupMembersHealthView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3201, 1, {}, GroupMembersHealthView$1_0);
_.executeAction = function executeAction_67(selection, actionValue){
  var defId, destination, i, iframe, rId, rId$index, rId$max, record, record$index, record$max, resourceIds, window_0;
  if (selection == null || selection.length == 0) {
    return;
  }
  resourceIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selection.length, 1);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    defId = getAttributeAsInt(record.jsObj, 'id');
    resourceIds[i++] = defId.value_0;
  }
  destination = '/resource/common/monitor/Visibility.do?mode=compareMetrics&&groupId=' + this.this$0.groupId;
  for (rId$index = 0 , rId$max = resourceIds.length; rId$index < rId$max; ++rId$index) {
    rId = resourceIds[rId$index];
    destination += '&r=' + rId;
  }
  window_0 = new AbstractActivityView$ChartViewWindow_1('', ($clinit_Enhanced() , 'Compare Metrics'));
  iframe = new FullHTMLPane_0(destination);
  $addItem(window_0, iframe);
  $show(window_0);
  $refreshTableInfo(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_29(selection){
  return selection != null && selection.length > 1;
}
;
_.this$0 = null;
function GroupMonitoringTablesView_0(groupComposite){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.metrics = new GroupMeasurementTableView_0(groupComposite, groupComposite.resourceGroup.id);
  this.memberHealth = new GroupMembersHealthView_0(groupComposite.resourceGroup.id);
  $addMember(this, this.metrics);
  $addMember(this, this.memberHealth);
}

defineSeed(3202, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$Enhanced]), GroupMonitoringTablesView_0);
_.refresh_0 = function refresh_35(){
  $refresh(this.metrics, false);
}
;
_.memberHealth = null;
_.metrics = null;
function TraitsDataSource_0(groupId){
  $clinit_RPCDataSource();
  AbstractMeasurementDataTraitDataSource_0.call(this);
  this.groupId = groupId;
}

defineSeed(3203, 2907, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractMeasurementDataTraitDataSource]), TraitsDataSource_0);
_.addDataSourceFields = function addDataSourceFields_3(){
  var fields, groupIdField;
  fields = $addDataSourceFields_2();
  groupIdField = new DataSourceIntegerField_1('groupId', 'Group ID');
  $setAttribute_8(groupIdField, 'hidden', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $add_2(fields, 0, groupIdField);
  return fields;
}
;
_.copyValues_4 = function copyValues_99(from){
  var record, resource;
  record = $copyValues_41(from);
  $setAttribute_3(record, 'groupId', this.groupId);
  resource = from.schedule.resource;
  $setAttribute_3(record, 'resourceId', resource.id);
  $setAttribute_13(record, 'resourceName', resource.name_0);
  $setAttribute_13(record, 'resourceAncestry', resource.ancestry);
  $setAttribute_3(record, 'resourceTypeId', resource.resourceType.id);
  return record;
}
;
_.dataRetrieved = function dataRetrieved_1(result, response, request){
  var ancestries, resource, trait, trait$iterator, typeRepo, typesSet;
  typesSet = new HashSet_0;
  ancestries = new HashSet_0;
  for (trait$iterator = new AbstractList$IteratorImpl_0(result); trait$iterator.i < trait$iterator.this$0_0.size_1();) {
    trait = dynamicCast($next_0(trait$iterator), Q$MeasurementDataTrait);
    resource = trait.schedule.resource;
    $add_6(typesSet, valueOf_44(resource.resourceType.id));
    $add_6(ancestries, resource.ancestry);
  }
  $addAll(typesSet, getAncestryTypeIds(ancestries));
  typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new TraitsDataSource$3_0(this, result, response, request));
}
;
_.getListGridFields_0 = function getListGridFields_9(){
  var ancestryField, fields, resourceNameField;
  fields = $getListGridFields_14();
  resourceNameField = new ListGridField_3('resourceName', 'Resource');
  $setCellFormatter_0(resourceNameField, new TraitsDataSource$1_0);
  $setAttribute_8(resourceNameField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(resourceNameField, new TraitsDataSource$2_0);
  setCheck(fields.array, fields.size_0++, resourceNameField);
  ancestryField = setupAncestryListGridField();
  setCheck(fields.array, fields.size_0++, ancestryField);
  return fields;
}
;
_.groupId = 0;
function TraitsDataSource$1_0(){
}

defineSeed(3204, 1, {}, TraitsDataSource$1_0);
_.format_1 = function format_63(value, record, rowNum, colNum){
  var url;
  url = '#Resource/' + getAttributeAsInt(record.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(value));
}
;
function TraitsDataSource$2_0(){
}

defineSeed(3205, 1, {}, TraitsDataSource$2_0);
_.hoverHTML_0 = function hoverHTML_38(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function TraitsDataSource$3_0(this$0, val$result, val$response, val$request){
  this.this$0 = this$0;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3206, 1, {}, TraitsDataSource$3_0);
_.onTypesLoaded_0 = function onTypesLoaded_31(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44($getTotalSize(this.val$result)));
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function TraitsDetailView_0(groupId, definitionId){
  var criteria;
  $clinit_AbstractMeasurementDataTraitListDetailView();
  AbstractMeasurementDataTraitListDetailView_0.call(this, new TraitsDataSource_0(groupId), (criteria = new Criteria_0 , $addCriteria_1(criteria, 'groupId', valueOf_44(groupId)) , $addCriteria_1(criteria, 'definitionId', valueOf_44(definitionId)) , criteria));
}

defineSeed(3207, 2909, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), TraitsDetailView_0);
_.configureTable = function configureTable_51(){
  var listGrid, resourceNameField;
  $configureTable_7(this);
  listGrid = this.listGrid;
  resourceNameField = $getField_1(listGrid, 'resourceName');
  $setCellFormatter_0(resourceNameField, new TraitsDetailView$1_0);
  $setAttribute_8(resourceNameField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(resourceNameField, new TraitsDetailView$2_0);
  $setAttribute_8(resourceNameField, 'canGroupBy', TRUE);
  setupAncestryListGridField_0(listGrid);
}
;
function TraitsDetailView$1_0(){
}

defineSeed(3208, 1, {}, TraitsDetailView$1_0);
_.format_1 = function format_64(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function TraitsDetailView$2_0(){
}

defineSeed(3209, 1, {}, TraitsDetailView$2_0);
_.hoverHTML_0 = function hoverHTML_39(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function TraitsView_0(groupId){
  var criteria;
  $clinit_AbstractMeasurementDataTraitListView();
  AbstractMeasurementDataTraitListView_0.call(this, new TraitsDataSource_0(groupId), (criteria = new Criteria_0 , $addCriteria_1(criteria, 'groupId', valueOf_44(groupId)) , $addCriteria(criteria, 'maxTimestamp', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , criteria));
  this.groupId = groupId;
}

defineSeed(3210, 2911, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), TraitsView_0);
_.configureTable = function configureTable_52(){
  var listGrid, resourceNameField;
  $configureTable_8(this);
  listGrid = this.listGrid;
  $setShowAllRecords(listGrid, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  resourceNameField = $getField_1(listGrid, 'resourceName');
  $setCellFormatter_0(resourceNameField, new TraitsView$1_0);
  $setAttribute_8(resourceNameField, 'showHover', TRUE);
  $setHoverCustomizer_0(resourceNameField, new TraitsView$2_0);
  setupAncestryListGridField_0(listGrid);
}
;
_.decorateLiveDataGrid = function decorateLiveDataGrid(records){
  var liveDataGrid, name_0, resourceNameField, value;
  liveDataGrid = new ListGrid_0;
  $setShowAllRecords(liveDataGrid, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setData(liveDataGrid, dynamicCast($toArray_1(records, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, records.size_0, 0)), Q$ListGridRecord_$1));
  $setAttribute_24(liveDataGrid, 'selectionType', ($clinit_SelectionStyle() , NONE_4).value_0, true);
  name_0 = new ListGridField_3('displayName', ($clinit_Enhanced() , 'Trait'));
  value = new ListGridField_3('value', 'Value');
  resourceNameField = new ListGridField_3('resourceName', 'Resource');
  $setCellFormatter_0(resourceNameField, new TraitsView$4_0);
  $setAttribute_8(resourceNameField, 'showHover', TRUE);
  $setHoverCustomizer_0(resourceNameField, new TraitsView$5_0);
  $setFields_1(liveDataGrid, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [name_0, value, resourceNameField, setupAncestryListGridField()]));
  return liveDataGrid;
}
;
_.getDetailsView_0 = function getDetailsView_23(definitionId){
  return new TraitsDetailView_0(this.groupId, definitionId.value_0);
}
;
_.getLiveValueAction = function getLiveValueAction(){
  return new TraitsView$3_0(this);
}
;
_.groupId = 0;
function TraitsView$1_0(){
}

defineSeed(3211, 1, {}, TraitsView$1_0);
_.format_1 = function format_65(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function TraitsView$2_0(){
}

defineSeed(3212, 1, {}, TraitsView$2_0);
_.hoverHTML_0 = function hoverHTML_40(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function TraitsView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3213, 1, {}, TraitsView$3_0);
_.executeAction = function executeAction_68(selection, actionValue){
  var defId, definitionIds, i, record, record$index, record$max, resourceId, resourceIds, selectedRecords;
  if (selection == null || selection.length == 0) {
    return;
  }
  selectedRecords = new HashMap_0;
  definitionIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selection.length, 1);
  i = 0;
  resourceIds = new HashSet_0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    defId = getAttributeAsInt(record.jsObj, 'id');
    definitionIds[i++] = defId.value_0;
    resourceId = getAttributeAsInt(record.jsObj, 'resourceId').value_0;
    $add_6(resourceIds, valueOf_44(resourceId));
    selectedRecords.put(resourceId + ':' + getAttribute(record.jsObj, 'name'), record);
  }
  $findLiveDataForGroup(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), 60000), Q$MeasurementDataGWTServiceAsync), this.this$0.groupId, unwrapCollection(resourceIds), definitionIds, new TraitsView$3$1_0(this, selectedRecords));
}
;
_.isEnabled_0 = function isEnabled_30(selection){
  return selection != null && selection.length > 0;
}
;
_.this$0 = null;
function $onSuccess_313(this$static, result){
  var data, data$iterator, record, records;
  !result && (result = new HashSet_1(0));
  records = new ArrayList_1(result.size_1());
  for (data$iterator = result.iterator(); data$iterator.hasNext();) {
    data = dynamicCast(data$iterator.next_0(), Q$MeasurementData);
    record = dynamicCast(this$static.val$selectedRecords.get_2(data.name_0), Q$ListGridRecord);
    $setAttribute_12(record, 'value', data.getValue_1());
    setCheck(records.array, records.size_0++, record);
  }
  sort_1(records, new TraitsView$3$1$1_0);
  $showLiveData(this$static.this$1.this$0, records);
}

function TraitsView$3$1_0(this$1, val$selectedRecords){
  this.this$1 = this$1;
  this.val$selectedRecords = val$selectedRecords;
}

defineSeed(3214, 1, {}, TraitsView$3$1_0);
_.onFailure = function onFailure_327(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get live values for those metrics. Make sure the agent is running and the managed resource is up.'), caught);
}
;
_.onSuccess_0 = function onSuccess_327(result){
  $onSuccess_313(this, dynamicCast(result, Q$Set));
}
;
_.this$1 = null;
_.val$selectedRecords = null;
function $compare_12(o1, o2){
  return compareTo_11(getAttribute(o1.jsObj, 'name'), getAttribute(o2.jsObj, 'name'));
}

function TraitsView$3$1$1_0(){
}

defineSeed(3215, 1, makeCastMap([Q$Comparator]), TraitsView$3$1$1_0);
_.compare = function compare_13(o1, o2){
  return $compare_12(dynamicCast(o1, Q$ListGridRecord), dynamicCast(o2, Q$ListGridRecord));
}
;
function TraitsView$4_0(){
}

defineSeed(3216, 1, {}, TraitsView$4_0);
_.format_1 = function format_66(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function TraitsView$5_0(){
}

defineSeed(3217, 1, {}, TraitsView$5_0);
_.hoverHTML_0 = function hoverHTML_41(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function GroupMemberResourceOperationHistoryListView_0(groupComposite, groupOperationHistoryId){
  AbstractOperationHistoryListView_0.call(this, new ResourceOperationHistoryDataSource_0, new Criteria_2('groupOperationHistoryId', '' + groupOperationHistoryId));
  this.groupComposite = groupComposite;
}

defineSeed(3218, 2533, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), GroupMemberResourceOperationHistoryListView_0);
_.createFields = function createFields_2(){
  var ancestryField, fields, idField, resourceField, startedTimeField, statusField, resourceField_0;
  fields = new ArrayList_0;
  idField = new ListGridField_1('id');
  idField.jsObj['width'] = 38;
  setCheck(fields.array, fields.size_0++, idField);
  resourceField = (resourceField_0 = new ListGridField_3('resourceName', ($clinit_Enhanced() , 'Resource')) , $setAttribute_13(resourceField_0, 'align', ($clinit_Alignment() , LEFT_0).value_0) , $setAttribute_13(resourceField_0, 'cellAlign', LEFT_0.value_0) , $setCellFormatter_0(resourceField_0, new AbstractOperationHistoryListView$8_0) , $setAttribute_8(resourceField_0, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , $setHoverCustomizer_0(resourceField_0, new AbstractOperationHistoryListView$9_0) , resourceField_0);
  resourceField.jsObj['width'] = '25%';
  $setCellFormatter_0(resourceField, new GroupMemberResourceOperationHistoryListView$1_0);
  $setAttribute_8(resourceField, 'showHover', TRUE);
  $setHoverCustomizer_0(resourceField, new GroupMemberResourceOperationHistoryListView$2_0);
  setCheck(fields.array, fields.size_0++, resourceField);
  ancestryField = setupAncestryListGridField();
  ancestryField.jsObj['width'] = '35%';
  setCheck(fields.array, fields.size_0++, ancestryField);
  statusField = $createStatusField();
  setCheck(fields.array, fields.size_0++, statusField);
  startedTimeField = $createStartedTimeField();
  startedTimeField.jsObj['width'] = '30%';
  setCheck(fields.array, fields.size_0++, startedTimeField);
  return fields;
}
;
_.getDetailsView_0 = function getDetailsView_24(id){
  return new ResourceOperationHistoryDetailsView_1(true);
}
;
_.hasControlPermission_1 = function hasControlPermission_3(){
  return this.groupComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONTROL_0));
}
;
_.showDetails = function showDetails_3(record){
  var msg, opHistoryId, resourceId;
  if (!record) {
    throw new IllegalArgumentException_1("'record' parameter is null.");
  }
  resourceId = getAttributeAsInt(record.jsObj, 'resourceId').value_0;
  opHistoryId = getAttributeAsInt(record.jsObj, 'id').value_0;
  if (resourceId > 0 && opHistoryId > 0) {
    $clinit_CoreGUI();
    goToView('#Resource/' + resourceId + '/Operations/History/' + opHistoryId, null, false);
  }
   else {
    msg = 'Can not show detail for [' + ($clinit_Enhanced() , ((Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupMemberResourceOperationHistoryListView_2_classLit.modifiers & 2) != 0?'interface ':(Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupMemberResourceOperationHistoryListView_2_classLit.modifiers & 1) != 0?'':'class ') + Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupMemberResourceOperationHistoryListView_2_classLit.typeName) + ']. Illegal id: [' + resourceId + ',' + opHistoryId + ']. Please report this bug';
    $handleError_0(($clinit_CoreGUI() , msg), null);
    throw new IllegalArgumentException_1(msg);
  }
}
;
_.groupComposite = null;
function GroupMemberResourceOperationHistoryListView$1_0(){
}

defineSeed(3219, 1, {}, GroupMemberResourceOperationHistoryListView$1_0);
_.format_1 = function format_67(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function GroupMemberResourceOperationHistoryListView$2_0(){
}

defineSeed(3220, 1, {}, GroupMemberResourceOperationHistoryListView$2_0);
_.hoverHTML_0 = function hoverHTML_42(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function $onSuccess_314(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function GroupOperationHistoryDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3221, 1, {}, GroupOperationHistoryDataSource$1_0);
_.onFailure = function onFailure_328(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failure loading operation histories.'), caught);
}
;
_.onSuccess_0 = function onSuccess_328(result){
  $onSuccess_314(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $buildResultsSection(this$static){
  var memberHistoryListView, resultsSection, title;
  resultsSection = new EnhancedVLayout_0;
  title = new Label_4('<h4>' + ($clinit_Enhanced() , 'Results') + '<\/h4>');
  $isCreated_1(title)?$setProperty_0(title, 'height', 27):(title.config_0['height'] = 27 , undefined);
  $addMember(resultsSection, title);
  memberHistoryListView = new GroupMemberResourceOperationHistoryListView_0(this$static.groupComposite, dynamicCast(this$static.operationHistory, Q$GroupOperationHistory).id);
  $setAttribute_24(memberHistoryListView, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $isCreated_1(memberHistoryListView)?$setProperty_0(memberHistoryListView, 'height', 200):(memberHistoryListView.config_0['height'] = 200 , undefined);
  $addMember(resultsSection, memberHistoryListView);
  return resultsSection;
}

function GroupOperationHistoryDetailsView_0(groupComposite){
  AbstractOperationHistoryDetailsView_0.call(this);
  this.groupComposite = groupComposite;
}

defineSeed(3222, 2933, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$Enhanced]), GroupOperationHistoryDetailsView_0);
_.buildResultsSection = function buildResultsSection(operationHistory){
  return $buildResultsSection(this, dynamicCast(operationHistory, Q$GroupOperationHistory));
}
;
_.lookupDetails = function lookupDetails(historyId){
  var criteria;
  criteria = new GroupOperationHistoryCriteria_0;
  $addFilterId(criteria, valueOf_44(historyId));
  criteria.fetchOperationDefinition = true;
  criteria.fetchParameters = true;
  $findGroupOperationHistoriesByCriteria(dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync), criteria, new GroupOperationHistoryDetailsView$1_0(this));
}
;
_.groupComposite = null;
function $onSuccess_315(this$static, result){
  var groupOperationHistory;
  groupOperationHistory = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$GroupOperationHistory);
  $displayDetails(this$static.this$0, groupOperationHistory);
}

function GroupOperationHistoryDetailsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3223, 1, {}, GroupOperationHistoryDetailsView$1_0);
_.onFailure = function onFailure_329(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failure loading operation history.'), caught);
}
;
_.onSuccess_0 = function onSuccess_329(result){
  $onSuccess_315(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $copyValues_53(this$static, from){
  var executionOrder, groupOperationSchedule;
  groupOperationSchedule = dynamicCast($copyValues_43(this$static, from), Q$GroupOperationSchedule);
  executionOrder = dynamicCast(getAttributeAsObject(from.jsObj, 'executionOrder'), Q$List);
  groupOperationSchedule.executionOrder = executionOrder;
  $setHaltOnFailure(groupOperationSchedule, ($clinit_Boolean() , getAttributeAsBoolean(from.jsObj, 'haltOnFailure')?TRUE:FALSE).value_0);
  return groupOperationSchedule;
}

function $copyValues_54(this$static, from){
  var record;
  record = $copyValues_44(from);
  $setAttribute_12(record, 'executionOrder', from.executionOrder);
  $setAttribute_16(record, 'haltOnFailure', from.haltOnFailure);
  return record;
}

function $executeFetch_37(this$static, request, response){
  var scheduleId;
  scheduleId = $getAttributeAsInt($getCriteria(request), 'id');
  scheduleId?$getGroupOperationSchedule(this$static.operationService, scheduleId.value_0, new GroupOperationScheduleDataSource$1_0(this$static, request, response, scheduleId)):$findScheduledGroupOperations(this$static.operationService, this$static.groupComposite.resourceGroup.id, new GroupOperationScheduleDataSource$2_0(this$static, response, request));
}

function GroupOperationScheduleDataSource_0(groupComposite){
  $clinit_RPCDataSource();
  AbstractOperationScheduleDataSource_0.call(this, groupComposite.resourceGroup.resourceType);
  this.groupComposite = groupComposite;
}

defineSeed(3224, 2948, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractOperationScheduleDataSource]), GroupOperationScheduleDataSource_0);
_.copyValues_5 = function copyValues_100(from){
  return $copyValues_53(this, from);
}
;
_.copyValues_6 = function copyValues_101(from){
  return $copyValues_54(this, dynamicCast(from, Q$GroupOperationSchedule));
}
;
_.createOperationSchedule = function createOperationSchedule(){
  var groupOperationSchedule;
  return groupOperationSchedule = new GroupOperationSchedule_0 , $setGroup_0(groupOperationSchedule, this.groupComposite.resourceGroup) , groupOperationSchedule;
}
;
_.executeAdd = function executeAdd_3(recordToAdd, request, response){
  var scheduleToAdd, executionOrder;
  $addRequestPropertiesToRecord(request, recordToAdd);
  executionOrder = dynamicCast(getAttributeAsObject(request.jsObj, 'executionOrder'), Q$List);
  !executionOrder?(recordToAdd.jsObj['executionOrder'] = null , undefined):instanceOf(executionOrder, Q$Map)?$setAttribute_5(recordToAdd, 'executionOrder', convertMapToJavascriptObject(dynamicCast(executionOrder, Q$Map))):(recordToAdd.jsObj['executionOrder'] = executionOrder , undefined);
  scheduleToAdd = $copyValues_53(this, recordToAdd);
  $scheduleGroupOperation(this.operationService, scheduleToAdd, new GroupOperationScheduleDataSource$3_0(this, scheduleToAdd, request, response));
}
;
_.executeFetch = function executeFetch_54(request, response, unused){
  $executeFetch_37(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.executeRemove = function executeRemove_4(recordToRemove, request, response){
  var scheduleToRemove;
  scheduleToRemove = $copyValues_53(this, recordToRemove);
  $unscheduleGroupOperation(this.operationService, scheduleToRemove, new GroupOperationScheduleDataSource$4_0(this, request, response, scheduleToRemove));
}
;
_.groupComposite = null;
function $onSuccess_316(this$static, result){
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, result, null);
}

function GroupOperationScheduleDataSource$1_0(this$0, val$request, val$response, val$scheduleId){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$scheduleId = val$scheduleId;
}

defineSeed(3225, 1, {}, GroupOperationScheduleDataSource$1_0);
_.onFailure = function onFailure_330(caught){
  $sendFailureResponse(this.this$0, this.val$request, this.val$response, 'Failed to fetch GroupOperationSchedule with id ' + this.val$scheduleId + '.', caught);
}
;
_.onSuccess_0 = function onSuccess_330(result){
  $onSuccess_316(this, dynamicCast(result, Q$GroupOperationSchedule));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$scheduleId = null;
function $onFailure_35(this$static, caught){
  throw new RuntimeException_2('Failed to find scheduled operations for ' + this$static.this$0.groupComposite.resourceGroup + '.', caught);
}

function $onSuccess_317(this$static, result){
  var records;
  records = $buildRecords(this$static.this$0, result, true);
  $setAttribute_17(this$static.val$response, 'data', records);
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function GroupOperationScheduleDataSource$2_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3226, 1, {}, GroupOperationScheduleDataSource$2_0);
_.onFailure = function onFailure_331(caught){
  $onFailure_35(this, caught);
}
;
_.onSuccess_0 = function onSuccess_331(result){
  $onSuccess_317(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onFailure_36(this$static, caught){
  throw new RuntimeException_2('Failed to add ' + this$static.val$scheduleToAdd, caught);
}

function $onSuccess_318(this$static, scheduleId){
  $setId_3(this$static.val$scheduleToAdd, scheduleId.value_0);
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, this$static.val$scheduleToAdd, null);
}

function GroupOperationScheduleDataSource$3_0(this$0, val$scheduleToAdd, val$request, val$response){
  this.this$0 = this$0;
  this.val$scheduleToAdd = val$scheduleToAdd;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(3227, 1, {}, GroupOperationScheduleDataSource$3_0);
_.onFailure = function onFailure_332(caught){
  $onFailure_36(this, caught);
}
;
_.onSuccess_0 = function onSuccess_332(scheduleId){
  $onSuccess_318(this, dynamicCast(scheduleId, Q$Integer));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$scheduleToAdd = null;
function $onFailure_37(this$static, caught){
  throw new RuntimeException_2('Failed to remove ' + this$static.val$scheduleToRemove, caught);
}

function $onSuccess_319(this$static){
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, this$static.val$scheduleToRemove, null);
}

function GroupOperationScheduleDataSource$4_0(this$0, val$request, val$response, val$scheduleToRemove){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$scheduleToRemove = val$scheduleToRemove;
}

defineSeed(3228, 1, {}, GroupOperationScheduleDataSource$4_0);
_.onFailure = function onFailure_333(caught){
  $onFailure_37(this, caught);
}
;
_.onSuccess_0 = function onSuccess_333(result){
  $onSuccess_319(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$scheduleToRemove = null;
function GroupOperationScheduleDetailsView_0(groupComposite, scheduleId){
  $clinit_AbstractRecordEditor();
  AbstractOperationScheduleDetailsView_0.call(this, new GroupOperationScheduleDataSource_0(groupComposite), groupComposite.resourceGroup.resourceType, scheduleId);
  this.groupComposite = groupComposite;
}

defineSeed(3229, 2950, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$DetailsView, Q$Enhanced]), GroupOperationScheduleDetailsView_0);
_.buildContentPane = function buildContentPane_2(){
  var contentPane, executionModeItem, hLayout, haltOnFailureItem, horizontalSpacer, hr, memberIcon, nameHoverCustomizer, resourceCategory, valueMap;
  contentPane = $buildContentPane_0(this);
  hr = new HTMLFlow_1('<hr/>');
  $addMember(contentPane, hr);
  this.executionModeForm = new EnhancedDynamicForm_1(this.isReadOnly);
  $setNumCols(this.executionModeForm, 2);
  $setColWidths(this.executionModeForm, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [valueOf_44(140), '*']));
  executionModeItem = new RadioGroupItem_2('executionMode', ($clinit_Enhanced() , 'Execute'));
  valueMap = new LinkedHashMap_1(2);
  $put_1(valueMap, 'parallel', 'in parallel');
  $put_1(valueMap, 'sequential', 'in the order specified below (drag and drop member Resources to change order)');
  $isCreated_2(executionModeItem)?$setValueMapMethod(executionModeItem, convertMapToJavascriptObject(valueMap)):$isCreated_2(executionModeItem)?$setProperty_7(executionModeItem, 'valueMap', convertMapToJavascriptObject(valueMap)):(executionModeItem.jsObj['valueMap'] = convertMapToJavascriptObject(valueMap) , undefined);
  $isCreated_2(executionModeItem)?$setProperty_8(executionModeItem, 'defaultValue', 'parallel'):(executionModeItem.jsObj['defaultValue'] = 'parallel' , undefined);
  $setShowTitle_0(executionModeItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  haltOnFailureItem = new CheckboxItem_2('haltOnFailure', 'Halt on Failure?');
  $setDefaultValue(haltOnFailureItem, FALSE);
  $setVisible(haltOnFailureItem, FALSE);
  $setLabelAsTitle(haltOnFailureItem, TRUE);
  $setShowTitle_2(haltOnFailureItem, TRUE);
  $setFields_3(this.executionModeForm, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [executionModeItem, haltOnFailureItem]));
  $addMember(contentPane, this.executionModeForm);
  hLayout = new HLayout_0;
  horizontalSpacer = new VLayout_0;
  $isCreated_1(horizontalSpacer)?$setProperty_0(horizontalSpacer, 'width', 140):(horizontalSpacer.config_0['width'] = 140 , undefined);
  $addMember(hLayout, horizontalSpacer);
  resourceCategory = this.groupComposite.resourceGroup.resourceType.category;
  memberIcon = getResourceIcon_0(resourceCategory, ($clinit_AvailabilityType() , UP), '16');
  nameHoverCustomizer = new GroupOperationScheduleDetailsView$2_0;
  this.memberExecutionOrderer = new ReorderableList_0(this.memberResourceRecords, memberIcon, nameHoverCustomizer);
  $setAttribute_24(this.memberExecutionOrderer, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  this.memberExecutionOrderer.nameFieldTitle = 'Member Resource';
  $addMember(hLayout, this.memberExecutionOrderer);
  $addMember(contentPane, hLayout);
  $addChangedHandler(executionModeItem, new GroupOperationScheduleDetailsView$3_0(this, haltOnFailureItem));
  return contentPane;
}
;
_.editExistingRecord = function editExistingRecord_1(record){
  var criteria, executionOrder, haltOnFailure, haltOnFailureItem, i, resource, resource$iterator, resourceDatasource, resourceIds;
  executionOrder = dynamicCast(getAttributeAsObject(record.jsObj, 'executionOrder'), Q$List);
  if (executionOrder) {
    resourceIds = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, executionOrder.size_1(), 0);
    i = 0;
    for (resource$iterator = executionOrder.iterator(); resource$iterator.hasNext();) {
      resource = dynamicCast(resource$iterator.next_0(), Q$Resource);
      resourceIds[i++] = valueOf_44(resource.id);
    }
    resourceDatasource = new ResourceDatasource_0;
    criteria = new Criteria_0;
    criteria.jsObj['resourceIds'] = convertToJavaScriptArray(resourceIds);
    $fetchData(resourceDatasource, criteria, new GroupOperationScheduleDetailsView$4_0(this, record));
  }
   else {
    $setValue_0(this.executionModeForm, 'executionMode', 'parallel');
    haltOnFailure = $getValue(this.form_0, 'haltOnFailure');
    haltOnFailureItem = $getField_0(this.executionModeForm, 'haltOnFailure');
    haltOnFailureItem.setValue_3(haltOnFailure);
    $editExistingRecord_0(this, record);
  }
}
;
_.getResourceId = function getResourceId(){
  return -1;
}
;
_.hasControlPermission_1 = function hasControlPermission_4(){
  return this.groupComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONTROL_0));
}
;
_.init = function init_5(isReadOnly){
  var criteria, resourceDatasource;
  if (this.recordId == 0) {
    resourceDatasource = new ResourceDatasource_0;
    criteria = new Criteria_2('groupId', '' + this.groupComposite.resourceGroup.id);
    $fetchData(resourceDatasource, criteria, new GroupOperationScheduleDetailsView$1_0(this, isReadOnly));
  }
   else {
    $init_7(this, isReadOnly);
  }
}
;
_.save = function save_4(requestProperties){
  var executionMode, executionOrder, haltOnFailure, resourceDatasource, resourceRecords, resources;
  executionMode = $getValueAsString(this.executionModeForm, 'executionMode');
  if ($equals_6(executionMode, 'sequential')) {
    resourceRecords = this.memberExecutionOrderer.listGrid.getRecords();
    resourceDatasource = new ResourceDatasource_0;
    resources = $buildDataObjects(resourceDatasource, resourceRecords);
    executionOrder = new ArrayList_2(resources);
  }
   else {
    executionOrder = null;
  }
  !executionOrder?(requestProperties.jsObj['executionOrder'] = null , undefined):(requestProperties.jsObj['executionOrder'] = executionOrder , undefined);
  haltOnFailure = dynamicCast($getValue(this.executionModeForm, 'haltOnFailure'), Q$Boolean);
  $setValue_1(this.form_0, 'haltOnFailure', haltOnFailure.value_0);
  $save_6(this, requestProperties);
}
;
_.executionModeForm = null;
_.groupComposite = null;
_.memberExecutionOrderer = null;
_.memberResourceRecords = null;
function GroupOperationScheduleDetailsView$1_0(this$0, val$isReadOnly){
  this.this$0 = this$0;
  this.val$isReadOnly = val$isReadOnly;
}

defineSeed(3230, 1, {}, GroupOperationScheduleDetailsView$1_0);
_.execute_2 = function execute_54(response, rawData, request){
  var data, dataLength, i, listGridRecord, record;
  if (getAttributeAsInt(response.jsObj, 'status').value_0 != 0) {
    throw new RuntimeException_1(($clinit_Enhanced() , 'Failed to load group member Resources.'));
  }
  data = $getData(response);
  this.this$0.memberResourceRecords = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, data.length, 0);
  for (i = 0 , dataLength = data.length; i < dataLength; ++i) {
    record = data[i];
    listGridRecord = dynamicCast(record, Q$ListGridRecord);
    setCheck(this.this$0.memberResourceRecords, i, listGridRecord);
  }
  $init_7(this.this$0, this.val$isReadOnly);
}
;
_.this$0 = null;
_.val$isReadOnly = false;
function GroupOperationScheduleDetailsView$2_0(){
}

defineSeed(3231, 1, {}, GroupOperationScheduleDetailsView$2_0);
_.hoverHTML_0 = function hoverHTML_43(value, listGridRecord, rowNum, colNum){
  return getAncestryHoverHTML(listGridRecord, 0);
}
;
function GroupOperationScheduleDetailsView$3_0(this$0, val$haltOnFailureItem){
  this.this$0 = this$0;
  this.val$haltOnFailureItem = val$haltOnFailureItem;
}

defineSeed(3232, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupOperationScheduleDetailsView$3_0);
_.onChanged = function onChanged_69(event_0){
  if (equals__devirtual$($getValue_2(event_0), 'parallel')) {
    $hide_0(this.val$haltOnFailureItem);
    $hide(this.this$0.memberExecutionOrderer);
  }
   else {
    $show_0(this.val$haltOnFailureItem);
    $show(this.this$0.memberExecutionOrderer);
  }
}
;
_.this$0 = null;
_.val$haltOnFailureItem = null;
function GroupOperationScheduleDetailsView$4_0(this$0, val$record){
  this.this$0 = this$0;
  this.val$record = val$record;
}

defineSeed(3233, 1, {}, GroupOperationScheduleDetailsView$4_0);
_.execute_2 = function execute_55(response, rawData, request){
  var data, dataLength, haltOnFailure, haltOnFailureItem, i, listGridRecord, record, resourceRecords;
  if (getAttributeAsInt(response.jsObj, 'status').value_0 != 0) {
    throw new RuntimeException_1(($clinit_Enhanced() , 'Failed to load group member Resources.'));
  }
  data = $getData(response);
  resourceRecords = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, data.length, 0);
  for (i = 0 , dataLength = data.length; i < dataLength; ++i) {
    record = data[i];
    listGridRecord = dynamicCast(record, Q$ListGridRecord);
    setCheck(resourceRecords, i, listGridRecord);
  }
  $setValue_0(this.this$0.executionModeForm, 'executionMode', 'sequential');
  $setRecords_0(this.this$0.memberExecutionOrderer, resourceRecords);
  $show(this.this$0.memberExecutionOrderer);
  haltOnFailureItem = $getField_0(this.this$0.executionModeForm, 'haltOnFailure');
  haltOnFailure = $getValue(this.this$0.form_0, 'haltOnFailure');
  haltOnFailureItem.setValue_3(haltOnFailure);
  $show_0(haltOnFailureItem);
  $editExistingRecord_0(this.this$0, this.val$record);
}
;
_.this$0 = null;
_.val$record = null;
function GroupOperationScheduleListView_0(groupComposite){
  $clinit_BaseWidget();
  AbstractOperationScheduleListView_0.call(this, new GroupOperationScheduleDataSource_0(groupComposite));
  this.groupComposite = groupComposite;
}

defineSeed(3234, 2954, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), GroupOperationScheduleListView_0);
_.getDetailsView_0 = function getDetailsView_25(scheduleId){
  return new GroupOperationScheduleDetailsView_0(this.groupComposite, scheduleId.value_0);
}
;
_.hasControlPermission_1 = function hasControlPermission_5(){
  return this.groupComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONTROL_0));
}
;
_.groupComposite = null;
function $getDefaultDashboard_0(this$static){
  var alerts, dashboard, group, groupKeyNameMap, measurements, ops, sessionSubject;
  sessionSubject = ($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0);
  group = this$static.groupComposite.resourceGroup;
  dashboard = new Dashboard_0;
  $setName_7(dashboard, 'GroupDashboard_' + sessionSubject.id + '_' + group.id);
  $setCategory_0(dashboard, ($clinit_DashboardCategory() , GROUP_0));
  dashboard.group = group;
  $put_4(dashboard.configuration, new PropertySimple_1('columns', valueOf_44(2)));
  $setColumnWidths(dashboard, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['40%']));
  $put_4(dashboard.configuration, new PropertySimple_1('background', '#F1F2F3'));
  groupKeyNameMap = processPortletNameMapForGroup(this$static.groupComposite);
  this$static.colLeft = 0;
  this$static.colRight = 1;
  this$static.rowLeft = 0;
  this$static.rowRight = 0;
  if (groupKeyNameMap.map.containsKey('GroupMetrics')) {
    measurements = new DashboardPortlet_1(($clinit_GroupMetricsPortlet() , NAME_4), 'GroupMetrics', 220);
    $addPortlet_0(dashboard, measurements, this$static.colLeft, this$static.rowLeft++);
    $remove_11(groupKeyNameMap, 'GroupMetrics');
  }
  if (groupKeyNameMap.map.containsKey('GroupAlerts')) {
    alerts = new DashboardPortlet_1(($clinit_GroupAlertsPortlet() , NAME_0), 'GroupAlerts', 220);
    $addPortlet_0(dashboard, alerts, this$static.colRight, this$static.rowRight++);
    $remove_11(groupKeyNameMap, 'GroupAlerts');
  }
  if (groupKeyNameMap.map.containsKey('GroupOperations')) {
    ops = new DashboardPortlet_1(($clinit_GroupOperationsPortlet() , NAME_6), 'GroupOperations', 220);
    $addPortlet_0(dashboard, ops, this$static.colRight, this$static.rowRight++);
    $remove_11(groupKeyNameMap, 'GroupOperations');
  }
  if (groupKeyNameMap.map.containsKey('GroupConfigurationUpdates')) {
    ops = new DashboardPortlet_1(($clinit_GroupConfigurationUpdatesPortlet() , NAME_2), 'GroupConfigurationUpdates', 220);
    $addPortlet_0(dashboard, ops, this$static.colRight, this$static.rowRight++);
    $remove_11(groupKeyNameMap, 'GroupConfigurationUpdates');
  }
  this$static.displayLeft = false;
  $updateDashboardWithPortlets(this$static, groupKeyNameMap, dashboard);
  return dashboard;
}

function $setDashboard(this$static, dashboard){
  var context, members;
  members = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members'));
  $removeMembers(this$static, members);
  context = forGroup(this$static.groupComposite.resourceGroup.id, this$static.isAutoCluster, this$static.isAutoGroup);
  this$static.dashboardView = new DashboardView_1(this$static, dashboard, context, this$static.groupComposite);
  $addMember(this$static, this$static.dashboardView);
  this$static.footer = new EnhancedToolStrip_0;
  $setPadding(this$static.footer, valueOf_44(5));
  $setAttribute_24(this$static.footer, 'width', '100%', true);
  $setMembersMargin(this$static.footer, 15);
  this$static.editButton = new EnhancedIButton_1(this$static.editMode?($clinit_Enhanced() , 'View Mode'):($clinit_Enhanced() , 'Edit Mode'));
  $addClickHandler(this$static.editButton, new ActivityView$2_0(this$static));
  this$static.resetButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Reset'));
  $addClickHandler(this$static.resetButton, new ActivityView$3_0(this$static));
  $addMember(this$static.footer, this$static.editButton);
  $addMember(this$static.footer, this$static.resetButton);
  $addMember(this$static, this$static.footer);
}

function $updateDashboardWithPortlets(this$static, keyNameMap, dashboard){
  var key, key$iterator, portlet;
  if (!!keyNameMap && !!dashboard) {
    for (key$iterator = $iterator($keySet(keyNameMap)); key$iterator.val$outerIter.hasNext();) {
      key = dynamicCast($next_1(key$iterator), Q$String);
      portlet = new DashboardPortlet_1(dynamicCast($get_4(keyNameMap, key), Q$String), key, 100);
      if (this$static.rowLeft < 4) {
        $addPortlet_0(dashboard, portlet, this$static.colLeft, this$static.rowLeft++);
      }
       else {
        this$static.displayLeft?$addPortlet_0(dashboard, portlet, this$static.colLeft, this$static.rowLeft++):$addPortlet_0(dashboard, portlet, this$static.colRight, this$static.rowRight++);
        this$static.displayLeft = !this$static.displayLeft;
      }
    }
  }
}

function ActivityView_0(groupComposite, isAutoCluster, isAutoGroup){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.dashboardService = dynamicCast(secure(getInstance_39(), -1), Q$DashboardGWTServiceAsync);
  this.groupComposite = groupComposite;
  this.isAutoCluster = isAutoCluster;
  this.isAutoGroup = isAutoGroup;
}

defineSeed(3235, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$InitializableView, Q$RefreshableView, Q$Enhanced]), ActivityView_0);
_.getGlobalPermissions = function getGlobalPermissions_0(){
  return this.globalPermissions;
}
;
_.isInitialized_0 = function isInitialized_3(){
  return this.isInitialized;
}
;
_.isValidDashboardName = function isValidDashboardName_0(name_0){
  return name_0 != null && !!this.dashboardView && $equals_6(name_0, this.dashboardView.storedDashboard.name_0);
}
;
_.onInit = function onInit_63(){
  if (!this.isInitialized) {
    $onInit(this);
    $onInit_Layout(this);
    $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new ActivityView$1_0(this)));
  }
}
;
_.refresh_0 = function refresh_36(){
  this.isInitialized && $rebuild(this.dashboardView);
}
;
_.supportsDashboardNameEdit = function supportsDashboardNameEdit_0(){
  return false;
}
;
_.updateDashboardNames = function updateDashboardNames_0(){
  return;
}
;
_.colLeft = 0;
_.colRight = 1;
_.dashboardView = null;
_.displayLeft = false;
_.editButton = null;
_.editMode = false;
_.footer = null;
_.globalPermissions = null;
_.groupComposite = null;
_.isAutoCluster = false;
_.isAutoGroup = false;
_.isInitialized = false;
_.resetButton = null;
_.rowLeft = 0;
_.rowRight = 0;
function ActivityView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3236, 1, {}, ActivityView$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_14(permissions){
  var criteria;
  this.this$0.globalPermissions = permissions;
  criteria = new DashboardCriteria_0;
  $addFilterCategory(criteria, ($clinit_DashboardCategory() , GROUP_0));
  $addFilterGroupId(criteria, valueOf_44(this.this$0.groupComposite.resourceGroup.id));
  $findDashboardsByCriteria(this.this$0.dashboardService, criteria, new ActivityView$1$1_0(this));
}
;
_.this$0 = null;
function $onSuccess_320(this$static, result){
  var dashboard;
  dashboard = result.size_0 == 0?$getDefaultDashboard_0(this$static.this$1.this$0):dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Dashboard);
  $setDashboard(this$static.this$1.this$0, dashboard);
  this$static.this$1.this$0.isInitialized = true;
  $isDrawn(this$static.this$1.this$0).value_0 && $markForRedraw(this$static.this$1.this$0);
}

function ActivityView$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3237, 1, {}, ActivityView$1$1_0);
_.onFailure = function onFailure_334(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to add new dashboard'), caught);
}
;
_.onSuccess_0 = function onSuccess_334(result){
  $onSuccess_320(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
function ActivityView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3238, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ActivityView$2_0);
_.onClick = function onClick_148(clickEvent){
  this.this$0.editMode = !this.this$0.editMode;
  $setTitle_0(this.this$0.editButton, this.this$0.editMode?($clinit_Enhanced() , 'View Mode'):($clinit_Enhanced() , 'Edit Mode'));
  $setEditMode(this.this$0.dashboardView, this.this$0.editMode);
}
;
_.this$0 = null;
function ActivityView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3239, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ActivityView$3_0);
_.onClick = function onClick_149(clickEvent){
  $clinit_Enhanced();
  ask('Reset to default summary dashboard (lose local changes)?', new ActivityView$3$1_0(this));
}
;
_.this$0 = null;
function ActivityView$3$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3240, 1, {}, ActivityView$3$1_0);
_.execute_3 = function execute_56(confirmed){
  if (confirmed.value_0) {
    $delete_2(this.this$1.this$0.dashboardView);
    $setDashboard(this.this$1.this$0, $getDefaultDashboard_0(this.this$1.this$0));
    $markForRedraw(this.this$1.this$0);
  }
}
;
_.this$1 = null;
function $onFailure_38(this$static, caught){
  var msg;
  msg = caught.getMessage();
  $handleError_0(($clinit_CoreGUI() , 'Failed to create the resource group [' + ($clinit_Wizard() , $getGroup(this$static.this$0.createStep).name_0) + '] : ' + msg), caught);
}

function $onSuccess_321(this$static, result){
  var conciseMessage, detailedMessage;
  conciseMessage = 'You have created a new resource group with name [' + ($clinit_Wizard() , result.name_0) + '].';
  detailedMessage = 'You have created a new [' + result.groupCategory.name_0.toLowerCase() + '] resource group with the name [' + result.name_0 + '] that contains [' + $getSelectedResourceIds_0(this$static.this$0.memberStep).length + '] member resources';
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_1(conciseMessage, detailedMessage));
  this$static.this$0.groupCreateCallback(result);
}

function AbstractGroupCreateWizard$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3241, 1, {}, AbstractGroupCreateWizard$1_0);
_.onFailure = function onFailure_335(caught){
  $onFailure_38(this, caught);
}
;
_.onSuccess_0 = function onSuccess_335(result){
  $onSuccess_321(this, dynamicCast(result, Q$ResourceGroup));
}
;
_.this$0 = null;
function $getGroup(this$static){
  var group;
  group = new ResourceGroup_2($getValueAsString(this$static.form_0, 'name'));
  $setDescription_4(group, $getValueAsString(this$static.form_0, 'description'));
  $setRecursive_0(group, $getValue(this$static.form_0, 'recursive') != null);
  return group;
}

function GroupCreateStep_0(){
  this.groupService = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
}

defineSeed(3242, 2040, makeCastMap([Q$WizardStep]), GroupCreateStep_0);
_.getCanvas = function getCanvas_18(){
  var description, name_0, recursive;
  if (!this.form_0) {
    this.form_0 = new DynamicForm_0;
    $setAttribute_20(this.form_0, 'valuesManager', $getOrCreateJsObj(new ValuesManager_0), false);
    $setAttribute_24(this.form_0, 'width', '100%', true);
    $setNumCols(this.form_0, 2);
    name_0 = new TextItem_3('name', ($clinit_WizardStep() , 'Name'));
    $setRequired(name_0, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
    $isCreated_2(name_0)?$setProperty_6(name_0, 'width', 300):(name_0.jsObj['width'] = 300 , undefined);
    $setLength_0(name_0, valueOf_44(100));
    $addChangedHandler(name_0, new GroupCreateStep$1_0(this));
    description = new AutoFitTextAreaItem_0('Description');
    $isCreated_2(description)?$setProperty_6(description, 'width', 300):(description.jsObj['width'] = 300 , undefined);
    $setLength(description, valueOf_44(100));
    recursive = new CheckboxItem_2('recursive', 'Recursive');
    this.form_0.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [name_0, description, recursive]));
  }
  return this.form_0;
}
;
_.getName = function getName_25(){
  return $clinit_WizardStep() , 'Group Settings';
}
;
_.nextPage_0 = function nextPage_16(){
  return this.form_0.validate_0() && this.canContinue;
}
;
_.canContinue = false;
_.form_0 = null;
_.groupService = null;
function GroupCreateStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3243, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), GroupCreateStep$1_0);
_.onChanged = function onChanged_70(changedEvent){
  var criteria, newGroupName;
  newGroupName = $getValueAsString(this.this$0.form_0, 'name');
  criteria = new ResourceGroupCriteria_0;
  criteria.filterName = newGroupName;
  $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setRestriction(criteria, ($clinit_Criteria$Restriction() , COLLECTION_ONLY));
  $findResourceGroupsByCriteria(this.this$0.groupService, criteria, new GroupCreateStep$1$1_0(this, newGroupName));
}
;
_.this$0 = null;
function $onSuccess_322(this$static, resourceGroups){
  var found, group, group$iterator, msg;
  found = false;
  for (group$iterator = new AbstractList$IteratorImpl_0(resourceGroups); group$iterator.i < group$iterator.this$0_0.size_1();) {
    group = dynamicCast($next_0(group$iterator), Q$ResourceGroup);
    $equals_6(group.name_0, this$static.val$newGroupName) && (found = true);
  }
  if (found) {
    this$static.this$1.this$0.canContinue = false;
    msg = new Message_8('Group with name [' + ($clinit_WizardStep() , this$static.val$newGroupName) + '] already exists', ($clinit_Message$Severity() , Warning), of(($clinit_Message$Option() , Transient)));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  }
   else {
    this$static.this$1.this$0.canContinue = true;
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_8('', ($clinit_Message$Severity() , Blank), of(($clinit_Message$Option() , Transient))));
  }
}

function GroupCreateStep$1$1_0(this$1, val$newGroupName){
  this.this$1 = this$1;
  this.val$newGroupName = val$newGroupName;
}

defineSeed(3244, 1, {}, GroupCreateStep$1$1_0);
_.onFailure = function onFailure_336(throwable){
}
;
_.onSuccess_0 = function onSuccess_336(resourceGroups){
  $onSuccess_322(this, dynamicCast(resourceGroups, Q$PageList));
}
;
_.this$1 = null;
_.val$newGroupName = null;
function GroupCreateWizard_0(resourceGroupListView, category){
  AbstractGroupCreateWizard_0.call(this);
  this.resourceGroupListView = resourceGroupListView;
  this.category = category;
}

defineSeed(3245, 2078, {}, GroupCreateWizard_0);
_.groupCreateCallback = function groupCreateCallback_1(group){
  this.resourceGroupListView.refresh_0();
  if (!!this.category && this.category != group.groupCategory) {
    this.category == ($clinit_GroupCategory() , COMPATIBLE) && (!group.explicitResources && (group.explicitResources = new HashSet_0) , group.explicitResources).isEmpty_0() && say(($clinit_Wizard() , 'An empty group is always considered as mixed.'));
    $clinit_CoreGUI();
    goToView(COMPATIBLE == group.groupCategory?'#Inventory/Groups/CompatibleGroups':'#Inventory/Groups/MixedGroups', null, false);
  }
}
;
_.category = null;
_.resourceGroupListView = null;
function $getSelectedResourceIds_0(this$static){
  var i, id, id$iterator, selectedIds, selection;
  selectedIds = $getSelection(this$static.selector);
  selection = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selectedIds.map.size_1(), 1);
  i = 0;
  for (id$iterator = $iterator($keySet(selectedIds.map)); id$iterator.val$outerIter.hasNext();) {
    id = dynamicCast($next_1(id$iterator), Q$Integer);
    selection[i++] = id.value_0;
  }
  return selection;
}

function $getSelecterResourceTypeIds(this$static){
  var i, record, record$index, record$max, selectedRecords, selection;
  selectedRecords = this$static.selector.assignedGrid.getRecords();
  selection = initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, selectedRecords.length, 0);
  i = 0;
  for (record$index = 0 , record$max = selectedRecords.length; record$index < record$max; ++record$index) {
    record = selectedRecords[record$index];
    selection[i++] = $getAttributeAsInt(record, ($clinit_ResourceDataSourceField() , TYPE_ID).propertyName);
  }
  return selection;
}

function GroupMembersStep_0(wizard){
  this.wizard = wizard;
}

defineSeed(3246, 2040, makeCastMap([Q$WizardStep]), GroupMembersStep_0);
_.getCanvas = function getCanvas_19(){
  !this.selector && (this.selector = new ResourceSelector_0);
  return this.selector;
}
;
_.getName = function getName_26(){
  return $clinit_WizardStep() , 'Select Members';
}
;
_.nextPage_0 = function nextPage_17(){
  this.wizard.createGroup();
  return true;
}
;
_.selector = null;
_.wizard = null;
function getAncestryValue(record, generateLinks){
  $clinit_AncestryUtil();
  var ancestorName, ancestorResourceId, ancestry, ancestryEntries, entryTokens, href, i, sbResources, url;
  ancestry = getAttribute(record.jsObj, 'resourceAncestry');
  if (null == ancestry) {
    return '';
  }
  resourceId = getAttributeAsInt(record.jsObj, 'resourceId');
  resourceId?resourceId:getAttributeAsInt(record.jsObj, 'id');
  sbResources = new StringBuilder_0;
  ancestryEntries = $split(ancestry, '_::_', 0);
  for (i = 0; i < ancestryEntries.length; ++i) {
    entryTokens = $split(ancestryEntries[i], '_:_', 0);
    ancestorResourceId = valueOf_44(__parseAndValidateInt(entryTokens[1])).value_0;
    ancestorName = escapeHtml(entryTokens[2]);
    $append_1(sbResources.data_0, i > 0?' &lt; ':'');
    if (generateLinks) {
      url = '#Resource/' + ancestorResourceId;
      href = getHref(url, ancestorName);
      $append_1(sbResources.data_0, href);
    }
     else {
      $append_1(sbResources.data_0, ancestorName);
    }
  }
  return $toString_1(sbResources.data_0);
}

function getResourceHoverHTML(record){
  $clinit_AncestryUtil();
  var resourceHover, resourceName, resourceTypeId, result, sb, type, types, typesWrapper, widthObj;
  if (!record) {
    return null;
  }
  resourceHover = getAttribute(record.jsObj, 'resourceHover');
  if (resourceHover != null) {
    return resourceHover;
  }
  resourceName = getResourceName(record);
  typesWrapper = dynamicCast(getAttributeAsObject(record.jsObj, 'resourceAncestryTypes'), Q$AncestryUtil$MapWrapper);
  if (!typesWrapper) {
    return null;
  }
  types = typesWrapper.map;
  resourceTypeId = getAttributeAsInt(record.jsObj, 'resourceTypeId');
  type = dynamicCast(types.get_2(resourceTypeId), Q$ResourceType);
  widthObj = valueOf_44(500);
  sb = new StringBuilder_1('<p');
  if (widthObj) {
    $append_1(sb.data_0, " style='width:");
    $appendNonNull(sb.data_0, '' + widthObj);
    $append_1(sb.data_0, "px'");
  }
  $append_1(sb.data_0, '>');
  $append_12(sb, getResourceLongName(resourceName, type));
  $append_1(sb.data_0, '<\/p>');
  result = $toString_1(sb.data_0);
  record.jsObj['resourceHover'] = result;
  return result;
}

function setupAncestryListGridField(){
  $clinit_AncestryUtil();
  var ancestryField;
  ancestryField = new ListGridField_3('resourceAncestry', ($clinit_CoreGUI() , 'Ancestry'));
  $setAttribute_13(ancestryField, 'align', ($clinit_Alignment() , LEFT_0).value_0);
  $setAttribute_13(ancestryField, 'cellAlign', LEFT_0.value_0);
  $setAttribute_8(ancestryField, 'canSortClientOnly', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setCellFormatter_0(ancestryField, new AncestryUtil$2_0);
  $setAttribute_8(ancestryField, 'showHover', TRUE);
  $setHoverCustomizer_0(ancestryField, new AncestryUtil$1_0);
  return ancestryField;
}

function setupAncestryListGridField_0(listGrid){
  $clinit_AncestryUtil();
  var ancestryField;
  ancestryField = $getField_1(listGrid, 'resourceAncestry');
  $setAttribute_13(ancestryField, 'align', ($clinit_Alignment() , LEFT_0).value_0);
  $setAttribute_13(ancestryField, 'cellAlign', LEFT_0.value_0);
  $setCellFormatter_0(ancestryField, new AncestryUtil$2_0);
  $setAttribute_8(ancestryField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(ancestryField, new AncestryUtil$1_0);
  return ancestryField;
}

function AncestryUtil$1_0(){
}

defineSeed(3248, 1, {}, AncestryUtil$1_0);
_.hoverHTML_0 = function hoverHTML_44(value, listGridRecord, rowNum, colNum){
  return getAncestryHoverHTML(listGridRecord, 0);
}
;
function AncestryUtil$2_0(){
}

defineSeed(3249, 1, {}, AncestryUtil$2_0);
_.format_1 = function format_68(o, listGridRecord, rowNum, colNum){
  return getAttribute(listGridRecord.jsObj, 'resourceAncestryDecoded');
}
;
function $isEnabled_3(this$static, selection){
  var selectedAvailTypes;
  if (!$isEnabled_1(this$static, selection)) {
    return false;
  }
  selectedAvailTypes = this$static.availExtractor.extract(selection);
  if (!$containsAll(this$static.availabilityTypes, selectedAvailTypes)) {
    return false;
  }
  return true;
}

function AvailabilityTypeResourceAuthorizedTableAction_0(table, enablement, availabilityTypes, requiredPermission, availExtractor, idExtractor){
  ResourceAuthorizedTableAction_0.call(this, table, enablement, requiredPermission, idExtractor);
  this.availabilityTypes = availabilityTypes;
  this.availExtractor = availExtractor;
}

defineSeed(3251, 1884, {});
_.isEnabled_0 = function isEnabled_31(selection){
  return $isEnabled_3(this, selection);
}
;
_.availExtractor = null;
_.availabilityTypes = null;
function $copyValues_55(from){
  var record, res;
  res = from.resource;
  record = new ListGridRecord_0;
  !from?(record.jsObj['resourceComposite'] = null , undefined):(record.jsObj['resourceComposite'] = from , undefined);
  !res?(record.jsObj['resource'] = null , undefined):(record.jsObj['resource'] = res , undefined);
  $setAttribute_3(record, 'id', res.id);
  $setAttribute_13(record, ($clinit_ResourceDataSourceField() , NAME_31).propertyName, res.name_0);
  $setAttribute_13(record, KEY.propertyName, res.resourceKey);
  $setAttribute_13(record, DESCRIPTION_0.propertyName, res.description);
  $setAttribute_13(record, LOCATION.propertyName, res.location_0);
  $setAttribute_3(record, TYPE_56.propertyName, res.resourceType.id);
  $setAttribute_13(record, PLUGIN_2.propertyName, res.resourceType.plugin);
  $setAttribute_13(record, VERSION.propertyName, res.version_0);
  $setAttribute_13(record, CATEGORY_0.propertyName, res.resourceType.category.name_0);
  $setAttribute_13(record, 'icon', getResourceIcon_0(res.resourceType.category, res.currentAvailability.availabilityType, '16'));
  $setAttribute_13(record, AVAILABILITY_2.propertyName, getAvailabilityIconFromAvailTypeAndSize(res.currentAvailability.availabilityType, false));
  $setAttribute_4(record, CTIME.propertyName, res.ctime.value_0);
  $setAttribute_4(record, ITIME.propertyName, res.itime.value_0);
  $setAttribute_4(record, MTIME.propertyName, res.mtime.value_0);
  $setAttribute_13(record, MODIFIER_0.propertyName, res.modifiedBy);
  $setAttribute_12(record, INVENTORY_STATUS.propertyName, res.inventoryStatus);
  $setAttribute_12(record, 'resourcePermission', from.resourcePermission);
  $setAttribute_13(record, 'resourceAncestry', res.ancestry);
  $setAttribute_3(record, 'resourceTypeId', res.resourceType.id);
  return record;
}

function $dataRetrieved_5(this$static, result, response, request){
  var ancestries, resource, resourceComposite, resourceComposite$iterator, resources, type, typeRepo, typesSet;
  typesSet = new HashSet_0;
  ancestries = new HashSet_0;
  resources = new ArrayList_1(result.size_0);
  for (resourceComposite$iterator = new AbstractList$IteratorImpl_0(result); resourceComposite$iterator.i < resourceComposite$iterator.this$0_0.size_1();) {
    resourceComposite = dynamicCast($next_0(resourceComposite$iterator), Q$ResourceComposite);
    resource = resourceComposite.resource;
    setCheck(resources.array, resources.size_0++, resource);
    type = resource.resourceType;
    !!type && $add_6(typesSet, valueOf_44(type.id));
    $add_6(ancestries, resource.ancestry);
  }
  typesSet.addAll(getAncestryTypeIds(ancestries));
  typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepo, dynamicCast(typesSet.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new ResourceCompositeDataSource$2_0(this$static, result, response, request));
}

function $executeFetch_38(this$static, request, response, criteria){
  $findResourceCompositesByCriteria(this$static.resourceService, criteria, new ResourceCompositeDataSource$1_0(this$static, response, request));
}

function $getFetchCriteria_11(request){
  var criteria, invStatusFilter, parentInvStatusFilter, statuses;
  criteria = new ResourceCriteria_0;
  $addFilterId(criteria, dynamicCast(getFilter($getCriteria(request), 'id', Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterParentResourceId(criteria, dynamicCast(getFilter($getCriteria(request), 'parentId', Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterCurrentAvailability(criteria, dynamicCast(getFilter_0(request, ($clinit_ResourceDataSourceField() , AVAILABILITY_2).propertyName, Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit), Q$AvailabilityType));
  $addFilterResourceCategories(criteria, dynamicCast(getArrayFilter_0(request, CATEGORY_0.propertyName, Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit), Q$ResourceCategory_$1));
  $addFilterIds(criteria, dynamicCast(getArrayFilter($getCriteria(request), 'resourceIds', Ljava_lang_Integer_2_classLit), Q$Integer_$1));
  $addFilterImplicitGroupIds(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [dynamicCast(getFilter($getCriteria(request), 'groupId', Ljava_lang_Integer_2_classLit), Q$Integer)]));
  $addFilterName_1(criteria, dynamicCast(getFilter_0(request, NAME_31.propertyName, Ljava_lang_String_2_classLit), Q$String));
  $addFilterResourceTypeId_0(criteria, dynamicCast(getFilter_0(request, TYPE_56.propertyName, Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterPluginName(criteria, dynamicCast(getFilter_0(request, PLUGIN_2.propertyName, Ljava_lang_String_2_classLit), Q$String));
  $addFilterTagNamespace(criteria, dynamicCast(getFilter($getCriteria(request), 'tagNamespace', Ljava_lang_String_2_classLit), Q$String));
  $addFilterTagSemantic(criteria, dynamicCast(getFilter($getCriteria(request), 'tagSemantic', Ljava_lang_String_2_classLit), Q$String));
  $addFilterTagName(criteria, dynamicCast(getFilter($getCriteria(request), 'tagName', Ljava_lang_String_2_classLit), Q$String));
  $addFilterVersion(criteria, dynamicCast(getFilter($getCriteria(request), 'version', Ljava_lang_String_2_classLit), Q$String));
  $setSearchExpression(criteria, dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String));
  invStatusFilter = dynamicCast(getFilter_0(request, INVENTORY_STATUS.propertyName, Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit), Q$InventoryStatus);
  !!invStatusFilter && (criteria.filterInventoryStatus = invStatusFilter);
  parentInvStatusFilter = dynamicCast(getFilter_0(request, PARENT_INVENTORY_STATUS.propertyName, Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit), Q$InventoryStatus);
  if (parentInvStatusFilter) {
    statuses = new ArrayList_1(1);
    setCheck(statuses.array, statuses.size_0++, parentInvStatusFilter);
    criteria.filterParentInventoryStatuses = statuses;
  }
  return criteria;
}

function ResourceCompositeDataSource_0(){
  var fields_0;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , addResourceDatasourceFields(fields_0));
  $addFields(this, fields);
}

defineSeed(3252, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceCompositeDataSource_0);
_.copyValues = function copyValues_102(from){
  return new ResourceComposite_1(new Resource_2(getAttributeAsInt(from.jsObj, 'id').value_0), ($clinit_AvailabilityType() , DOWN_0));
}
;
_.copyValues_0 = function copyValues_103(from){
  return $copyValues_55(dynamicCast(from, Q$ResourceComposite));
}
;
_.executeFetch = function executeFetch_55(request, response, criteria){
  $executeFetch_38(this, request, response, dynamicCast(criteria, Q$ResourceCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_64(request){
  return $getFetchCriteria_11(request);
}
;
var INSTANCE_39 = null;
function $onSuccess_323(this$static, result){
  $dataRetrieved_5(this$static.this$0, result, this$static.val$response, this$static.val$request);
}

function ResourceCompositeDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3253, 1, {}, ResourceCompositeDataSource$1_0);
_.onFailure = function onFailure_337(caught){
  var message;
  if (caught.getMessage().indexOf('SearchExpressionException') != -1) {
    message = new Message_7('Invalid search expression.', ($clinit_Message$Severity() , Error_2));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
   else {
    $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load resource composite data'), caught);
  }
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_337(result){
  $onSuccess_323(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function ResourceCompositeDataSource$2_0(this$0, val$result, val$response, val$request){
  this.this$0 = this$0;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3254, 1, {}, ResourceCompositeDataSource$2_0);
_.onTypesLoaded_0 = function onTypesLoaded_32(types){
  var record, record$index, record$max, records, type, typeId, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    typeId = $getAttributeAsInt(record, ($clinit_ResourceDataSourceField() , TYPE_56).propertyName);
    type = dynamicCast(types.get_2(typeId), Q$ResourceType);
    !!type && $setAttribute_13(record, TYPE_56.propertyName, type.name_0);
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setPagingInfo(this.val$response, this.val$result);
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $addImportAndCreateButtons(this$static, override){
  var createAction, createTypeValueMap, displayNameMap, importAction, importTypeValueMap, parentResource;
  parentResource = this$static.parentResourceComposite.resource;
  if (this$static.canCreate && (this$static.hasCreatableTypes || this$static.hasImportableTypes)) {
    if (this$static.hasCreatableTypes) {
      displayNameMap = getDisplayNames(this$static.creatableChildTypes);
      createTypeValueMap = new LinkedHashMap_4(displayNameMap);
      $removeExistingSingletons(this$static.singletonChildren, createTypeValueMap);
      createAction = new ResourceCompositeSearchView$4_0(this$static, ($clinit_TableActionEnablement() , ALWAYS), parentResource);
      override?$updateTableAction(this$static, ($clinit_Enhanced() , 'Create Child'), createTypeValueMap, createAction):$addTableAction(this$static, ($clinit_Enhanced() , 'Create Child'), null, createTypeValueMap, createAction);
    }
    if (this$static.hasImportableTypes) {
      displayNameMap = getDisplayNames(this$static.importableChildTypes);
      importTypeValueMap = new LinkedHashMap_4(displayNameMap);
      $removeExistingSingletons(this$static.singletonChildren, importTypeValueMap);
      importAction = new ResourceCompositeSearchView$5_0(this$static, ($clinit_TableActionEnablement() , ALWAYS), parentResource);
      override?$updateTableAction(this$static, ($clinit_Enhanced() , 'Import'), importTypeValueMap, importAction):$addTableAction(this$static, ($clinit_Enhanced() , 'Import'), null, importTypeValueMap, importAction);
    }
  }
   else if (!override) {
    !this$static.canCreate && this$static.hasCreatableTypes && $addTableAction(this$static, ($clinit_Enhanced() , 'Create Child'), null, null, new ResourceCompositeSearchView$6_0(($clinit_TableActionEnablement() , NEVER_1)));
    !this$static.canCreate && this$static.hasImportableTypes && $addTableAction(this$static, ($clinit_Enhanced() , 'Import'), null, null, new ResourceCompositeSearchView$7_0(($clinit_TableActionEnablement() , NEVER_1)));
  }
}

function $refreshSingletons(this$static, parentResource, callback){
  var criteria, singletonChildTypes;
  this$static.singletonChildren = new ArrayList_0;
  singletonChildTypes = getSingletonChildTypes(parentResource.resourceType);
  if (this$static.canCreate && singletonChildTypes.length > 0 && (this$static.hasCreatableTypes || this$static.hasImportableTypes)) {
    criteria = new ResourceCriteria_0;
    $addFilterParentResourceId(criteria, valueOf_44(parentResource.id));
    criteria.filterResourceTypeIds = new Arrays$ArrayList_0(singletonChildTypes);
    $findResourcesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), criteria, new ResourceCompositeSearchView$2_0(this$static, callback, parentResource));
  }
   else {
    !!callback && callback.onSuccess_0(new PageList_0);
  }
}

function $removeExistingSingletons(singletonChildren, displayNameMap){
  var child, child$iterator, displayName, displayName$iterator, displayNames, existing, existing$iterator, existingSingletons, exists, type;
  existingSingletons = new ArrayList_0;
  displayNames = $keySet(displayNameMap);
  for (displayName$iterator = $iterator(displayNames); displayName$iterator.val$outerIter.hasNext();) {
    displayName = dynamicCast($next_1(displayName$iterator), Q$String);
    type = dynamicCast($get_4(displayNameMap, displayName), Q$ResourceType);
    if (type.singleton) {
      for (child$iterator = new AbstractList$IteratorImpl_0(singletonChildren); child$iterator.i < child$iterator.this$0_0.size_1();) {
        child = dynamicCast($next_0(child$iterator), Q$Resource);
        exists = $equals_40(child.resourceType, $get_4(displayNameMap, displayName));
        if (exists) {
          setCheck(existingSingletons.array, existingSingletons.size_0++, displayName);
          break;
        }
      }
    }
  }
  for (existing$iterator = new AbstractList$IteratorImpl_0(existingSingletons); existing$iterator.i < existing$iterator.this$0_0.size_1();) {
    existing = dynamicCast($next_0(existing$iterator), Q$String);
    $remove_11(displayNameMap, existing);
  }
}

function ResourceCompositeSearchView_0(parentResourceComposite, criteria, title, headerIcons){
  ResourceSearchView_1.call(this, criteria, title, false, headerIcons);
  this.parentResourceComposite = parentResourceComposite;
  this.canCreate = this.parentResourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CREATE_CHILD_RESOURCES));
  this.initialCriteriaFixed = true;
}

function getChildrenOf(parentResourceComposite){
  $clinit_ResourceSearchView();
  return new ResourceCompositeSearchView_0(parentResourceComposite, new Criteria_2('parentId', '' + parentResourceComposite.resource.id), ($clinit_Enhanced() , 'Child Resources'), initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, []));
}

function getCreatableChildTypes(type){
  var childType, childType$iterator, childTypes, results;
  results = new TreeSet_0;
  childTypes = type.childResourceTypes;
  for (childType$iterator = childTypes.iterator(); childType$iterator.hasNext();) {
    childType = dynamicCast(childType$iterator.next_0(), Q$ResourceType);
    (childType.createDeletePolicy == ($clinit_CreateDeletePolicy() , BOTH_1) || childType.createDeletePolicy == CREATE_ONLY) && $put_2(results.map, childType, ($clinit_Boolean() , FALSE)) == null;
  }
  return results;
}

function getDisplayNames(types){
  var allNames, displayName, repeatedNames, results, type, type$iterator, typeName;
  allNames = new HashSet_0;
  repeatedNames = new HashSet_0;
  for (type$iterator = $iterator($keySet(types.map)); type$iterator.val$outerIter.hasNext();) {
    type = dynamicCast($next_1(type$iterator), Q$ResourceType);
    typeName = type.name_0;
    allNames.map.containsKey(typeName)?$add_6(repeatedNames, typeName):$add_6(allNames, typeName);
  }
  results = new TreeMap_0;
  for (type$iterator = $iterator($keySet(types.map)); type$iterator.val$outerIter.hasNext();) {
    type = dynamicCast($next_1(type$iterator), Q$ResourceType);
    displayName = type.name_0;
    $contains_2(repeatedNames, type.name_0) && (displayName += ' (' + type.plugin + ' plugin)');
    $put_2(results, displayName, type);
  }
  return results;
}

function getImportableChildTypes(type){
  var childType, childType$iterator, childTypes, results;
  results = new TreeSet_0;
  childTypes = type.childResourceTypes;
  for (childType$iterator = childTypes.iterator(); childType$iterator.hasNext();) {
    childType = dynamicCast(childType$iterator.next_0(), Q$ResourceType);
    childType.supportsManualAdd && $put_2(results.map, childType, ($clinit_Boolean() , FALSE)) == null;
  }
  return results;
}

function getSingletonChildTypes(type){
  var childType, childType$iterator, childTypes, results;
  results = new TreeSet_0;
  childTypes = type.childResourceTypes;
  for (childType$iterator = childTypes.iterator(); childType$iterator.hasNext();) {
    childType = dynamicCast(childType$iterator.next_0(), Q$ResourceType);
    childType.singleton && $add_8(results, valueOf_44(childType.id));
  }
  return dynamicCast(results.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, results.map.size_0, 0)), Q$Integer_$1);
}

defineSeed(3255, 2557, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ResourceCompositeSearchView_0);
_.configureTable = function configureTable_53(){
  $addTableAction(this, ($clinit_Enhanced() , 'Delete'), 'Are you sure you want to delete the selected resources?', null, new ResourceCompositeSearchView$3_0(this, ($clinit_TableActionEnablement() , ANY_1)));
  $addImportAndCreateButtons(this, false);
  $configureTable_3(this);
}
;
_.getDataSourceInstance = function getDataSourceInstance_0(){
  return $clinit_RPCDataSource() , !INSTANCE_39 && (INSTANCE_39 = new ResourceCompositeDataSource_0) , $clinit_RPCDataSource() , INSTANCE_39;
}
;
_.isInitialized_0 = function isInitialized_4(){
  return this.initialized_0 && this.initialized;
}
;
_.onInit = function onInit_64(){
  var parentResource, parentType;
  parentResource = this.parentResourceComposite.resource;
  parentType = parentResource.resourceType;
  this.creatableChildTypes = getCreatableChildTypes(parentType);
  this.importableChildTypes = getImportableChildTypes(parentType);
  this.hasCreatableTypes = this.creatableChildTypes.map.size_0 != 0;
  this.hasImportableTypes = this.importableChildTypes.map.size_0 != 0;
  $refreshSingletons(this, parentResource, new ResourceCompositeSearchView$1_0(this));
}
;
_.refresh_0 = function refresh_37(){
  $refreshSingletons(this, this.parentResourceComposite.resource, new ResourceCompositeSearchView$8_0(this));
}
;
_.canCreate = false;
_.creatableChildTypes = null;
_.hasCreatableTypes = false;
_.hasImportableTypes = false;
_.importableChildTypes = null;
_.initialized = false;
_.parentResourceComposite = null;
_.singletonChildren = null;
function $onSuccess_324(this$static){
  $onInit_1(this$static.this$0);
  this$static.this$0.initialized = true;
}

function ResourceCompositeSearchView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3256, 1, {}, ResourceCompositeSearchView$1_0);
_.onFailure = function onFailure_338(caught){
  $onInit_1(this.this$0);
  this.this$0.initialized = true;
}
;
_.onSuccess_0 = function onSuccess_338(result){
  $onSuccess_324(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $onSuccess_325(this$static, result){
  this$static.this$0.singletonChildren = result;
  !!this$static.val$callback && this$static.val$callback.onSuccess_0(result);
}

function ResourceCompositeSearchView$2_0(this$0, val$callback, val$parentResource){
  this.this$0 = this$0;
  this.val$callback = val$callback;
  this.val$parentResource = val$parentResource;
}

defineSeed(3257, 1, {}, ResourceCompositeSearchView$2_0);
_.onFailure = function onFailure_339(caught){
  error_1('Failed to load child resources for [' + this.val$parentResource + ']', caught);
  !!this.val$callback && this.val$callback.onFailure(caught);
}
;
_.onSuccess_0 = function onSuccess_339(result){
  $onSuccess_325(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$callback = null;
_.val$parentResource = null;
function ResourceCompositeSearchView$3_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3258, 1608, {}, ResourceCompositeSearchView$3_0);
_.executeAction = function executeAction_69(selection, actionValue){
  var resourceIds, resourceManager;
  resourceIds = getIds_0(selection);
  resourceManager = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  $deleteResources(resourceManager, resourceIds, new ResourceCompositeSearchView$3$1_0(this));
}
;
_.isEnabled_0 = function isEnabled_32(selection){
  var isEnabled, record, record$index, record$max, res, resComposite, resPermission;
  isEnabled = $isEnabled(this, selection);
  if (isEnabled) {
    for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
      record = selection[record$index];
      resComposite = dynamicCast(getAttributeAsObject(record.jsObj, 'resourceComposite'), Q$ResourceComposite);
      res = resComposite.resource;
      if (!(isEnabled = $isDeletable(res.resourceType))) {
        break;
      }
      resPermission = resComposite.resourcePermission;
      if (!(isEnabled = resPermission.permissions.contains_0(($clinit_Permission() , DELETE_RESOURCE)))) {
        break;
      }
    }
  }
  return isEnabled;
}
;
_.this$0 = null;
function $onSuccess_326(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'A request to perform the resource deletion has been submitted successfully to the agent(s).'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$1.this$0, true);
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function ResourceCompositeSearchView$3$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3259, 1, {}, ResourceCompositeSearchView$3$1_0);
_.onFailure = function onFailure_340(caught){
  instanceOf(caught, Q$CannotConnectToAgentException)?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Failed to delete the selected resources. Cannot connect to the agent. This may indicate that the agent is down.'), ($clinit_Message$Severity() , Warning))):$handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete the selected resources.'), caught);
}
;
_.onSuccess_0 = function onSuccess_340(result){
  $onSuccess_326(this, dynamicCast(result, Q$List));
}
;
_.this$1 = null;
function ResourceCompositeSearchView$4_0(this$0, $anonymous0, val$parentResource){
  this.this$0 = this$0;
  this.val$parentResource = val$parentResource;
  this.enablement = $anonymous0;
}

defineSeed(3260, 1608, {}, ResourceCompositeSearchView$4_0);
_.executeAction = function executeAction_70(selection, actionValue){
  showCreateWizard(this.val$parentResource, dynamicCast(actionValue, Q$ResourceType));
  $refreshTableInfo(this.this$0);
}
;
_.this$0 = null;
_.val$parentResource = null;
function ResourceCompositeSearchView$5_0(this$0, $anonymous0, val$parentResource){
  this.this$0 = this$0;
  this.val$parentResource = val$parentResource;
  this.enablement = $anonymous0;
}

defineSeed(3261, 1608, {}, ResourceCompositeSearchView$5_0);
_.executeAction = function executeAction_71(selection, actionValue){
  showImportWizard(this.val$parentResource, dynamicCast(actionValue, Q$ResourceType));
  $refreshTableInfo(this.this$0);
}
;
_.this$0 = null;
_.val$parentResource = null;
function ResourceCompositeSearchView$6_0($anonymous0){
  this.enablement = $anonymous0;
}

defineSeed(3262, 1608, {}, ResourceCompositeSearchView$6_0);
_.executeAction = function executeAction_72(selection, actionValue){
}
;
function ResourceCompositeSearchView$7_0($anonymous0){
  this.enablement = $anonymous0;
}

defineSeed(3263, 1608, {}, ResourceCompositeSearchView$7_0);
_.executeAction = function executeAction_73(selection, actionValue){
}
;
function $onSuccess_327(this$static){
  $addImportAndCreateButtons(this$static.this$0, true);
  $refresh(this$static.this$0, false);
}

function ResourceCompositeSearchView$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3264, 1, {}, ResourceCompositeSearchView$8_0);
_.onFailure = function onFailure_341(caught){
  $refresh(this.this$0, false);
}
;
_.onSuccess_0 = function onSuccess_341(result){
  $onSuccess_327(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $clinit_ResourceDataSourceField(){
  $clinit_ResourceDataSourceField = nullMethod;
  NAME_31 = new ResourceDataSourceField_0('NAME', 0, 'name', ($clinit_CoreGUI() , 'Name'));
  DESCRIPTION_0 = new ResourceDataSourceField_0('DESCRIPTION', 1, 'description', 'Description');
  LOCATION = new ResourceDataSourceField_0('LOCATION', 2, 'location', 'Location');
  KEY = new ResourceDataSourceField_0('KEY', 3, 'resourceKey', 'Key');
  TYPE_56 = new ResourceDataSourceField_0('TYPE', 4, 'resourceType.name', 'Type');
  TYPE_ID = new ResourceDataSourceField_0('TYPE_ID', 5, 'resourceType.id', 'TypeID');
  PLUGIN_2 = new ResourceDataSourceField_0('PLUGIN', 6, 'pluginName', 'Plugin');
  VERSION = new ResourceDataSourceField_0('VERSION', 7, 'version', 'Version');
  CATEGORY_0 = new ResourceDataSourceField_0('CATEGORY', 8, 'resourceType.category', 'Category');
  AVAILABILITY_2 = new ResourceDataSourceField_0('AVAILABILITY', 9, 'currentAvailability', 'Availability');
  CTIME = new ResourceDataSourceField_0('CTIME', 10, 'ctime', 'Discovery Time');
  ITIME = new ResourceDataSourceField_0('ITIME', 11, 'itime', 'Import Time');
  MTIME = new ResourceDataSourceField_0('MTIME', 12, 'mtime', 'Last Modified Time');
  MODIFIER_0 = new ResourceDataSourceField_0('MODIFIER', 13, 'modifiedBy', 'Last Modifier');
  INVENTORY_STATUS = new ResourceDataSourceField_0('INVENTORY_STATUS', 14, 'inventoryStatus', 'Inventory Status');
  PARENT_INVENTORY_STATUS = new ResourceDataSourceField_0('PARENT_INVENTORY_STATUS', 15, 'parentResource.inventoryStatus', 'parent resource inventory status');
  $VALUES_131 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceDataSourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceDataSourceField, [NAME_31, DESCRIPTION_0, LOCATION, KEY, TYPE_56, TYPE_ID, PLUGIN_2, VERSION, CATEGORY_0, AVAILABILITY_2, CTIME, ITIME, MTIME, MODIFIER_0, INVENTORY_STATUS, PARENT_INVENTORY_STATUS]);
}

function ResourceDataSourceField_0(enum$name, enum$ordinal, propertyName, title){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.propertyName = propertyName;
  this.title_0 = title;
}

function valueOf_140(name_0){
  $clinit_ResourceDataSourceField();
  return valueOf(($clinit_ResourceDataSourceField$Map() , $MAP_131), name_0);
}

function values_134(){
  $clinit_ResourceDataSourceField();
  return $VALUES_131;
}

defineSeed(3265, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$ResourceDataSourceField]), ResourceDataSourceField_0);
_.propertyName = null;
_.title_0 = null;
var $VALUES_131, AVAILABILITY_2, CATEGORY_0, CTIME, DESCRIPTION_0, INVENTORY_STATUS, ITIME, KEY, LOCATION, MODIFIER_0, MTIME, NAME_31, PARENT_INVENTORY_STATUS, PLUGIN_2, TYPE_56, TYPE_ID, VERSION;
function $clinit_ResourceDataSourceField$Map(){
  $clinit_ResourceDataSourceField$Map = nullMethod;
  $MAP_131 = createValueOfMap(($clinit_ResourceDataSourceField() , $VALUES_131));
}

var $MAP_131;
function $copyValues_56(from){
  var record;
  record = new ListGridRecord_0;
  !from?(record.jsObj['resource'] = null , undefined):(record.jsObj['resource'] = from , undefined);
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'uuid', from.uuid);
  $setAttribute_13(record, ($clinit_ResourceDataSourceField() , NAME_31).propertyName, from.name_0);
  $setAttribute_13(record, KEY.propertyName, from.resourceKey);
  $setAttribute_13(record, DESCRIPTION_0.propertyName, from.description);
  $setAttribute_13(record, LOCATION.propertyName, from.location_0);
  $setAttribute_3(record, TYPE_56.propertyName, from.resourceType.id);
  $setAttribute_13(record, PLUGIN_2.propertyName, from.resourceType.plugin);
  $setAttribute_13(record, VERSION.propertyName, from.version_0);
  $setAttribute_13(record, CATEGORY_0.propertyName, from.resourceType.category.name_0);
  $setAttribute_13(record, 'icon', getResourceIcon_0(from.resourceType.category, from.currentAvailability.availabilityType, '16'));
  $setAttribute_13(record, AVAILABILITY_2.propertyName, getAvailabilityIconFromAvailTypeAndSize(from.currentAvailability.availabilityType, false));
  $setAttribute_4(record, CTIME.propertyName, from.ctime.value_0);
  $setAttribute_4(record, ITIME.propertyName, from.itime.value_0);
  $setAttribute_4(record, MTIME.propertyName, from.mtime.value_0);
  $setAttribute_13(record, MODIFIER_0.propertyName, from.modifiedBy);
  $setAttribute_13(record, INVENTORY_STATUS.propertyName, from.inventoryStatus.name_0);
  $setAttribute_13(record, 'resourceAncestry', from.ancestry);
  $setAttribute_3(record, 'resourceTypeId', from.resourceType.id);
  return record;
}

function $dataRetrieved_6(this$static, result, response, request){
  var ancestries, resource, resource$iterator, type, typeRepo, typesSet;
  typesSet = new HashSet_0;
  ancestries = new HashSet_0;
  for (resource$iterator = new AbstractList$IteratorImpl_0(result); resource$iterator.i < resource$iterator.this$0_0.size_1();) {
    resource = dynamicCast($next_0(resource$iterator), Q$Resource);
    type = resource.resourceType;
    !!type && $add_6(typesSet, valueOf_44(type.id));
    $add_6(ancestries, resource.ancestry);
  }
  $addAll(typesSet, getAncestryTypeIds(ancestries));
  typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new ResourceDatasource$2_0(this$static, result, response, request));
}

function $executeFetch_39(this$static, request, response, criteria){
  $findResourcesByCriteria(this$static.resourceService, criteria, new ResourceDatasource$1_0(this$static, criteria, request, response));
}

function $getFetchCriteria_12(this$static, request){
  var criteria, invStatusFilter, pageControl, parentInvStatusFilter, statuses;
  criteria = new ResourceCriteria_0;
  printRequestCriteria(request);
  $addFilterId(criteria, dynamicCast(getFilter($getCriteria(request), 'id', Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterParentResourceId(criteria, dynamicCast(getFilter($getCriteria(request), 'parentId', Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterCurrentAvailability(criteria, dynamicCast(getFilter_0(request, ($clinit_ResourceDataSourceField() , AVAILABILITY_2).propertyName, Lorg_rhq_core_domain_measurement_AvailabilityType_2_classLit), Q$AvailabilityType));
  $addFilterResourceCategories(criteria, dynamicCast(getArrayFilter_0(request, CATEGORY_0.propertyName, Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit), Q$ResourceCategory_$1));
  $addFilterIds(criteria, dynamicCast(getArrayFilter($getCriteria(request), 'resourceIds', Ljava_lang_Integer_2_classLit), Q$Integer_$1));
  $addFilterExplicitGroupIds(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [dynamicCast(getFilter($getCriteria(request), 'groupId', Ljava_lang_Integer_2_classLit), Q$Integer)]));
  $addFilterName_1(criteria, dynamicCast(getFilter_0(request, NAME_31.propertyName, Ljava_lang_String_2_classLit), Q$String));
  $addFilterResourceTypeId_0(criteria, dynamicCast(getFilter_0(request, TYPE_56.propertyName, Ljava_lang_Integer_2_classLit), Q$Integer));
  $addFilterPluginName(criteria, dynamicCast(getFilter_0(request, PLUGIN_2.propertyName, Ljava_lang_String_2_classLit), Q$String));
  $addFilterTagNamespace(criteria, dynamicCast(getFilter($getCriteria(request), 'tagNamespace', Ljava_lang_String_2_classLit), Q$String));
  $addFilterTagSemantic(criteria, dynamicCast(getFilter($getCriteria(request), 'tagSemantic', Ljava_lang_String_2_classLit), Q$String));
  $addFilterTagName(criteria, dynamicCast(getFilter($getCriteria(request), 'tagName', Ljava_lang_String_2_classLit), Q$String));
  $addFilterVersion(criteria, dynamicCast(getFilter($getCriteria(request), 'version', Ljava_lang_String_2_classLit), Q$String));
  $addFilterParentResourceCategory(criteria, dynamicCast(getFilter($getCriteria(request), 'parentCategory', Lorg_rhq_core_domain_resource_ResourceCategory_2_classLit), Q$ResourceCategory));
  invStatusFilter = dynamicCast(getFilter_0(request, INVENTORY_STATUS.propertyName, Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit), Q$InventoryStatus);
  !!invStatusFilter && (criteria.filterInventoryStatus = invStatusFilter);
  parentInvStatusFilter = dynamicCast(getFilter_0(request, PARENT_INVENTORY_STATUS.propertyName, Lorg_rhq_core_domain_resource_InventoryStatus_2_classLit), Q$InventoryStatus);
  if (parentInvStatusFilter) {
    statuses = new ArrayList_1(1);
    setCheck(statuses.array, statuses.size_0++, parentInvStatusFilter);
    criteria.filterParentInventoryStatuses = statuses;
  }
  debug(' *** ResourceCriteria Search String: ' + dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String));
  $setSearchExpression(criteria, dynamicCast(getFilter($getCriteria(request), 'search', Ljava_lang_String_2_classLit), Q$String));
  pageControl = $getPageControl(this$static, request);
  $removeOrderingField(pageControl, 'resourceAncestry');
  criteria.pageControlOverrides = pageControl;
  return criteria;
}

function ResourceDatasource_0(){
  var fields_0;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  fields = (fields_0 = new ArrayList_0 , addResourceDatasourceFields(fields_0));
  $addFields(this, fields);
}

function addResourceDatasourceFields(fields){
  var availabilityDataField, categoryDataField, ctimeDataField, descriptionDataField, iconField, idDataField, inventoryStatusDataField, itimeDataField, keyDataField, locationDataField, modifiedByDataField, mtimeDataField, nameDataField, pluginNameDataField, typeNameDataField, versionDataField;
  idDataField = new DataSourceIntegerField_2('id', 'ID', 50);
  $setAttribute_8(idDataField, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_8(idDataField, 'canEdit', FALSE);
  setCheck(fields.array, fields.size_0++, idDataField);
  iconField = new DataSourceImageField_1('icon', ' ');
  $setAttribute_11(iconField, 'width', valueOf_44(25));
  setCheck(fields.array, fields.size_0++, iconField);
  nameDataField = new DataSourceTextField_2(($clinit_ResourceDataSourceField() , NAME_31).propertyName, NAME_31.title_0, 200);
  $setAttribute_8(nameDataField, 'canEdit', FALSE);
  setCheck(fields.array, fields.size_0++, nameDataField);
  keyDataField = new DataSourceTextField_2(KEY.propertyName, KEY.title_0, 200);
  $setAttribute_8(keyDataField, 'canEdit', FALSE);
  $setAttribute_8(keyDataField, 'detail', TRUE);
  setCheck(fields.array, fields.size_0++, keyDataField);
  descriptionDataField = new DataSourceTextField_1(DESCRIPTION_0.propertyName, DESCRIPTION_0.title_0);
  $setAttribute_8(descriptionDataField, 'canEdit', FALSE);
  setCheck(fields.array, fields.size_0++, descriptionDataField);
  locationDataField = new DataSourceTextField_1(LOCATION.propertyName, LOCATION.title_0);
  $setAttribute_8(locationDataField, 'canEdit', FALSE);
  $setAttribute_8(locationDataField, 'detail', TRUE);
  setCheck(fields.array, fields.size_0++, locationDataField);
  typeNameDataField = new DataSourceTextField_1(TYPE_56.propertyName, TYPE_56.title_0);
  setCheck(fields.array, fields.size_0++, typeNameDataField);
  pluginNameDataField = new DataSourceTextField_1(PLUGIN_2.propertyName, PLUGIN_2.title_0);
  $setAttribute_8(pluginNameDataField, 'detail', TRUE);
  setCheck(fields.array, fields.size_0++, pluginNameDataField);
  versionDataField = new DataSourceTextField_1(VERSION.propertyName, VERSION.title_0);
  setCheck(fields.array, fields.size_0++, versionDataField);
  categoryDataField = new DataSourceTextField_1(CATEGORY_0.propertyName, CATEGORY_0.title_0);
  $setAttribute_8(categoryDataField, 'detail', TRUE);
  setCheck(fields.array, fields.size_0++, categoryDataField);
  availabilityDataField = new DataSourceImageField_2(AVAILABILITY_2.propertyName, AVAILABILITY_2.title_0);
  $setAttribute_8(availabilityDataField, 'canEdit', FALSE);
  setCheck(fields.array, fields.size_0++, availabilityDataField);
  inventoryStatusDataField = new DataSourceTextField_1(INVENTORY_STATUS.propertyName, INVENTORY_STATUS.title_0);
  $setAttribute_8(inventoryStatusDataField, 'detail', TRUE);
  setCheck(fields.array, fields.size_0++, inventoryStatusDataField);
  ctimeDataField = new DataSourceTextField_1(CTIME.propertyName, CTIME.title_0);
  $setAttribute_8(ctimeDataField, 'detail', TRUE);
  setCheck(fields.array, fields.size_0++, ctimeDataField);
  itimeDataField = new DataSourceTextField_1(ITIME.propertyName, ITIME.title_0);
  $setAttribute_8(itimeDataField, 'detail', TRUE);
  setCheck(fields.array, fields.size_0++, itimeDataField);
  mtimeDataField = new DataSourceTextField_1(MTIME.propertyName, MTIME.title_0);
  $setAttribute_8(mtimeDataField, 'detail', TRUE);
  setCheck(fields.array, fields.size_0++, mtimeDataField);
  modifiedByDataField = new DataSourceTextField_1(MODIFIER_0.propertyName, MODIFIER_0.title_0);
  $setAttribute_8(modifiedByDataField, 'detail', TRUE);
  setCheck(fields.array, fields.size_0++, modifiedByDataField);
  return fields;
}

defineSeed(3267, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceDatasource_0);
_.copyValues = function copyValues_104(from){
  var resource;
  return resource = new Resource_1 , $setId_4(resource, getAttributeAsInt(from.jsObj, 'id').value_0) , $setUuid(resource, getAttribute(from.jsObj, 'uuid')) , resource;
}
;
_.copyValues_0 = function copyValues_105(from){
  return this.copyValues_8(dynamicCast(from, Q$Resource));
}
;
_.copyValues_8 = function copyValues_106(from){
  return $copyValues_56(from);
}
;
_.executeFetch = function executeFetch_56(request, response, criteria){
  this.executeFetch_6(request, response, dynamicCast(criteria, Q$ResourceCriteria));
}
;
_.executeFetch_6 = function executeFetch_57(request, response, criteria){
  $executeFetch_39(this, request, response, criteria);
}
;
_.getFetchCriteria = function getFetchCriteria_65(request){
  return this.getFetchCriteria_9(request);
}
;
_.getFetchCriteria_9 = function getFetchCriteria_66(request){
  return $getFetchCriteria_12(this, request);
}
;
var INSTANCE_40 = null;
function $onSuccess_328(this$static, result){
  $dataRetrieved_6(this$static.this$0, result, this$static.val$response, this$static.val$request);
}

function ResourceDatasource$1_0(this$0, val$criteria, val$request, val$response){
  this.this$0 = this$0;
  this.val$criteria = val$criteria;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(3268, 1, {}, ResourceDatasource$1_0);
_.onFailure = function onFailure_342(caught){
  var message;
  if (caught.getMessage().indexOf('SearchExpressionException') != -1) {
    message = new Message_7('Invalid search expression.', ($clinit_Message$Severity() , Error_2));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
   else if (caught.getMessage().indexOf('PageList was passed an empty collection') != -1) {
    warn_0(caught.getMessage());
    $setPageControl(this.val$criteria, new PageControl_1(0, this.this$0.dataPageSize.value_0));
    this.this$0.executeFetch_6(this.val$request, this.val$response, this.val$criteria);
    return;
  }
   else {
    $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load resource composite data'), caught);
  }
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_342(result){
  $onSuccess_328(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$criteria = null;
_.val$request = null;
_.val$response = null;
function ResourceDatasource$2_0(this$0, val$result, val$response, val$request){
  this.this$0 = this$0;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3269, 1, {}, ResourceDatasource$2_0);
_.onTypesLoaded_0 = function onTypesLoaded_33(types){
  var record, record$index, record$max, records, type, typeId, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    typeId = $getAttributeAsInt(record, ($clinit_ResourceDataSourceField() , TYPE_56).propertyName);
    type = dynamicCast(types.get_2(typeId), Q$ResourceType);
    if (type) {
      $setAttribute_13(record, TYPE_56.propertyName, type.name_0);
      $setAttribute_3(record, TYPE_ID.propertyName, type.id);
    }
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setPagingInfo(this.val$response, this.val$result);
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function ResourceSearchView$1_0(){
}

defineSeed(3270, 1, {}, ResourceSearchView$1_0);
_.extract = function extract_1(records){
  var record, record$index, record$max, result;
  result = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_3(result, getAttributeAsInt(record.jsObj, 'id'));
  }
  return result;
}
;
function ResourceSearchView$10_0(){
}

defineSeed(3271, 1, {}, ResourceSearchView$10_0);
_.extract = function extract_2(records){
  var record, record$index, record$max, resCat, result;
  result = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    resCat = $getAttribute(record, ($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName);
    ($clinit_ResourceCategory() , dynamicCast(valueOf(($clinit_ResourceCategory$Map() , $MAP_104), resCat), Q$ResourceCategory)) != PLATFORM && $add_3(result, getAttributeAsInt(record.jsObj, 'id'));
  }
  return result;
}
;
function ResourceSearchView$11_0(this$0, $anonymous0, $anonymous1, $anonymous2, $anonymous3){
  this.this$0 = this$0;
  ResourceAuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2, $anonymous3);
}

defineSeed(3272, 1884, {}, ResourceSearchView$11_0);
_.executeAction = function executeAction_74(selection, actionValue){
  var i, id, id$iterator, n, numberOfPlatformsSelected, resCat, resourceIds, resourceIdsList, resourceManager, selectedRecord, selectedRecord$index, selectedRecord$max;
  if (selection == null || selection.length == 0) {
    return;
  }
  numberOfPlatformsSelected = initValues(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [0]);
  resourceIdsList = new ArrayList_1(selection.length);
  for (selectedRecord$index = 0 , selectedRecord$max = selection.length; selectedRecord$index < selectedRecord$max; ++selectedRecord$index) {
    selectedRecord = selection[selectedRecord$index];
    resCat = $getAttribute(selectedRecord, ($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName);
    ($clinit_ResourceCategory() , dynamicCast(valueOf(($clinit_ResourceCategory$Map() , $MAP_104), resCat), Q$ResourceCategory)) != PLATFORM?$add_3(resourceIdsList, getAttributeAsInt(selectedRecord.jsObj, 'id')):++numberOfPlatformsSelected[0];
  }
  if (resourceIdsList.size_0 == 0) {
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You cannot ignore platforms. All of your selections are platforms so nothing will be done. If you no longer want to manage a platform, shutdown its associated agent and uninventory the platform.'), ($clinit_Message$Severity() , Warning)));
    return;
  }
   else if (numberOfPlatformsSelected[0] > 0) {
    n = '' + numberOfPlatformsSelected[0];
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You cannot ignore platforms. The [' + ($clinit_Enhanced() , n) + '] platforms you selected will be skipped. If you no longer want to manage a platform, shutdown its associated agent and uninventory the platform.', ($clinit_Message$Severity() , Warning)));
  }
  resourceIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, resourceIdsList.size_0, 1);
  i = 0;
  for (id$iterator = new AbstractList$IteratorImpl_0(resourceIdsList); id$iterator.i < id$iterator.this$0_0.size_1();) {
    id = dynamicCast($next_0(id$iterator), Q$Integer);
    resourceIds[i++] = id.value_0;
  }
  resourceManager = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  $ignoreResources(resourceManager, resourceIds, new ResourceSearchView$11$1_0(this, numberOfPlatformsSelected));
  return;
}
;
_.isEnabled_0 = function isEnabled_33(selection){
  var nonPlatformSelected, record, record$index, record$max, resCat;
  if (selection == null || selection.length == 0) {
    return false;
  }
  nonPlatformSelected = false;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    resCat = $getAttribute(record, ($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName);
    if (($clinit_ResourceCategory() , dynamicCast(valueOf(($clinit_ResourceCategory$Map() , $MAP_104), resCat), Q$ResourceCategory)) != PLATFORM) {
      nonPlatformSelected = true;
      break;
    }
  }
  if (!nonPlatformSelected) {
    return false;
  }
  return $isEnabled_1(this, selection);
}
;
_.this$0 = null;
function $onSuccess_329(this$static){
  var msg, n;
  if (this$static.val$numberOfPlatformsSelected[0] > 0) {
    n = '' + this$static.val$numberOfPlatformsSelected[0];
    msg = 'You have successfully ignored some of the selected resources, however, the [' + ($clinit_Enhanced() , n) + '] platforms you selected were skipped. Platforms cannot be ignored. If you no longer want to manage a platform, shutdown its associated agent and uninventory the platform.';
  }
   else {
    msg = ($clinit_Enhanced() , 'You have successfully ignored the selected resources.');
  }
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(msg, ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$1.this$0, true);
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function ResourceSearchView$11$1_0(this$1, val$numberOfPlatformsSelected){
  this.this$1 = this$1;
  this.val$numberOfPlatformsSelected = val$numberOfPlatformsSelected;
}

defineSeed(3273, 1, {}, ResourceSearchView$11$1_0);
_.onFailure = function onFailure_343(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to ignore resources'), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_343(result){
  $onSuccess_329(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$numberOfPlatformsSelected = null;
function ResourceSearchView$12_0(){
}

defineSeed(3274, 1, {}, ResourceSearchView$12_0);
_.extract = function extract_3(records){
  var record, record$index, record$max, result;
  result = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_3(result, getAttributeAsInt(record.jsObj, 'id'));
  }
  return result;
}
;
function ResourceSearchView$13_0(this$0, $anonymous0, $anonymous1, $anonymous2, $anonymous3){
  this.this$0 = this$0;
  ResourceAuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2, $anonymous3);
}

defineSeed(3275, 1884, {}, ResourceSearchView$13_0);
_.executeAction = function executeAction_75(selection, actionValue){
  var resourceIds, resourceManager;
  if (selection == null || selection.length == 0) {
    return;
  }
  resourceIds = getIds_0(selection);
  resourceManager = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  $unignoreAndImportResources(resourceManager, resourceIds, new ResourceSearchView$13$1_0(this));
  return;
}
;
_.this$0 = null;
function $onSuccess_330(this$static){
  $clinit_Enhanced();
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully unignored the selected resources.', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$1.this$0, true);
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function ResourceSearchView$13$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3276, 1, {}, ResourceSearchView$13$1_0);
_.onFailure = function onFailure_344(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to unignore resources'), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_344(result){
  $onSuccess_330(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
function ResourceSearchView$14_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3277, 1, {}, ResourceSearchView$14_0);
_.executeAction = function executeAction_76(selection, actionValue){
  var criteria, exportModalWindow, reportType, resourceTypeId, version, exporter;
  criteria = this.this$0.initialCriteria_0;
  resourceTypeId = $getAttribute(criteria, ($clinit_ResourceDataSourceField() , TYPE_56).propertyName);
  version = getAttribute(criteria.jsObj, 'version');
  instanceOf(this.this$0, Q$DriftComplianceReportResourceSearchView)?(reportType = 'driftCompliance'):(reportType = 'inventorySummary');
  exportModalWindow = (exporter = new ReportExporter_0(reportType) , exporter.resourceTypeId = resourceTypeId , exporter.version_0 = version , exporter);
  $export(exportModalWindow);
  $refreshTableInfo(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_34(selection){
  return true;
}
;
_.this$0 = null;
function ResourceSearchView$15_0(){
}

defineSeed(3278, 1, {}, ResourceSearchView$15_0);
_.hoverHTML_0 = function hoverHTML_45(value, record, rowNum, colNum){
  var resCat;
  resCat = $getAttribute(record, ($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName);
  switch (($clinit_ResourceCategory() , dynamicCast(valueOf(($clinit_ResourceCategory$Map() , $MAP_104), resCat), Q$ResourceCategory)).ordinal) {
    case 0:
      return $clinit_Enhanced() , 'Platform';
    case 1:
      return $clinit_Enhanced() , 'Server';
    case 2:
      return $clinit_Enhanced() , 'Service';
  }
  return null;
}
;
function ResourceSearchView$16_0(){
}

defineSeed(3279, 1, {}, ResourceSearchView$16_0);
_.format_1 = function format_69(value, record, rowNum, colNum){
  var invStatus, name_0, url;
  invStatus = $getAttribute(record, ($clinit_ResourceDataSourceField() , INVENTORY_STATUS).propertyName);
  if (($clinit_InventoryStatus() , COMMITTED) == dynamicCast(valueOf(($clinit_InventoryStatus$Map() , $MAP_102), invStatus), Q$InventoryStatus)) {
    url = '#Resource/' + getAttributeAsInt(record.jsObj, 'id').value_0;
    name_0 = escapeHtml(toString__devirtual$(value));
    return getHref(url, name_0);
  }
   else {
    return toString__devirtual$(value);
  }
}
;
function ResourceSearchView$17_0(){
}

defineSeed(3280, 1, {}, ResourceSearchView$17_0);
_.hoverHTML_0 = function hoverHTML_46(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function ResourceSearchView$2_0(this$0, $anonymous0, $anonymous1, $anonymous2, $anonymous3){
  this.this$0 = this$0;
  ResourceAuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2, $anonymous3);
}

defineSeed(3281, 1884, {}, ResourceSearchView$2_0);
_.executeAction = function executeAction_77(selection, actionValue){
  var resourceIds, resourceManager;
  resourceIds = getIds_0(selection);
  resourceManager = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  $uninventoryResources(resourceManager, resourceIds, new ResourceSearchView$2$1_0(this));
}
;
_.this$0 = null;
function $onSuccess_331(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have successfully uninventoried the selected resources'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$1.this$0, true);
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function ResourceSearchView$2$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3282, 1, {}, ResourceSearchView$2$1_0);
_.onFailure = function onFailure_345(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to uninventory the selected resources'), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_345(result){
  $onSuccess_331(this, dynamicCast(result, Q$List));
}
;
_.this$1 = null;
function ResourceSearchView$3_0(){
}

defineSeed(3283, 1, {}, ResourceSearchView$3_0);
_.extract = function extract_4(records){
  var record, record$index, record$max, result;
  result = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_3(result, dynamicCast(getAttributeAsObject(record.jsObj, 'resource'), Q$Resource).currentAvailability.availabilityType);
  }
  return result;
}
;
function ResourceSearchView$4_0(){
}

defineSeed(3284, 1, {}, ResourceSearchView$4_0);
_.extract = function extract_5(records){
  var record, record$index, record$max, result;
  result = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_3(result, getAttributeAsInt(record.jsObj, 'id'));
  }
  return result;
}
;
function ResourceSearchView$5_0(this$0, $anonymous0, $anonymous1, $anonymous2, $anonymous3, $anonymous4, $anonymous5){
  this.this$0 = this$0;
  AvailabilityTypeResourceAuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2, $anonymous3, $anonymous4, $anonymous5);
}

defineSeed(3285, 3251, {}, ResourceSearchView$5_0);
_.executeAction = function executeAction_78(selection, actionValue){
  var resourceIds, resourceManager;
  resourceIds = getIds_0(selection);
  resourceManager = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  $disableResources(resourceManager, resourceIds, new ResourceSearchView$5$1_0(this));
}
;
_.isEnabled_0 = function isEnabled_35(records){
  var record, record$index, record$max, result;
  result = $isEnabled_3(this, records);
  if (result) {
    for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
      record = records[record$index];
      if ($equals_6($getAttribute(record, ($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName), ($clinit_ResourceCategory() , PLATFORM).name_0)) {
        result = false;
        break;
      }
    }
  }
  return result;
}
;
_.this$0 = null;
function $onSuccess_332(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully disabled the selected resources and their children, [' + ($clinit_Enhanced() , '' + result.size_1()) + '] resources.', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$1.this$0, true);
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function ResourceSearchView$5$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3286, 1, {}, ResourceSearchView$5$1_0);
_.onFailure = function onFailure_346(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to disable the selected resources.'), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_346(result){
  $onSuccess_332(this, dynamicCast(result, Q$List));
}
;
_.this$1 = null;
function ResourceSearchView$6_0(){
}

defineSeed(3287, 1, {}, ResourceSearchView$6_0);
_.extract = function extract_6(records){
  var record, record$index, record$max, result;
  result = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_3(result, dynamicCast(getAttributeAsObject(record.jsObj, 'resource'), Q$Resource).currentAvailability.availabilityType);
  }
  return result;
}
;
function ResourceSearchView$7_0(){
}

defineSeed(3288, 1, {}, ResourceSearchView$7_0);
_.extract = function extract_7(records){
  var record, record$index, record$max, result;
  result = new ArrayList_1(records.length);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    $add_3(result, getAttributeAsInt(record.jsObj, 'id'));
  }
  return result;
}
;
function ResourceSearchView$8_0(this$0, $anonymous0, $anonymous1, $anonymous2, $anonymous3, $anonymous4, $anonymous5){
  this.this$0 = this$0;
  AvailabilityTypeResourceAuthorizedTableAction_0.call(this, $anonymous0, $anonymous1, $anonymous2, $anonymous3, $anonymous4, $anonymous5);
}

defineSeed(3289, 3251, {}, ResourceSearchView$8_0);
_.executeAction = function executeAction_79(selection, actionValue){
  var resourceIds, resourceManager;
  resourceIds = getIds_0(selection);
  resourceManager = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  $enableResources(resourceManager, resourceIds, new ResourceSearchView$8$1_0(this));
}
;
_.isEnabled_0 = function isEnabled_36(records){
  var record, record$index, record$max, result;
  result = $isEnabled_3(this, records);
  if (result) {
    for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
      record = records[record$index];
      if ($equals_6($getAttribute(record, ($clinit_ResourceDataSourceField() , CATEGORY_0).propertyName), ($clinit_ResourceCategory() , PLATFORM).name_0)) {
        result = false;
        break;
      }
    }
  }
  return result;
}
;
_.this$0 = null;
function $onSuccess_333(this$static, result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have successfully enabled the selected resources and their children, [' + ($clinit_Enhanced() , '' + result.size_1()) + '] resources.', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$1.this$0, true);
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function ResourceSearchView$8$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3290, 1, {}, ResourceSearchView$8$1_0);
_.onFailure = function onFailure_347(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to enable the selected resources.'), caught);
  $refreshTableInfo(this.this$1.this$0);
}
;
_.onSuccess_0 = function onSuccess_347(result){
  $onSuccess_333(this, dynamicCast(result, Q$List));
}
;
_.this$1 = null;
function ResourceSearchView$9_0(){
}

defineSeed(3291, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), ResourceSearchView$9_0);
_.onDoubleClick = function onDoubleClick_12(event_0){
  var invStatus, listGrid, selectedId, selectedRows;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    invStatus = $getAttribute(selectedRows[0], ($clinit_ResourceDataSourceField() , INVENTORY_STATUS).propertyName);
    if (($clinit_InventoryStatus() , COMMITTED) == dynamicCast(valueOf(($clinit_InventoryStatus$Map() , $MAP_102), invStatus), Q$InventoryStatus)) {
      selectedId = getAttribute(selectedRows[0].jsObj, 'id');
      $clinit_CoreGUI();
      goToView('#Resource/' + valueOf_44(__parseAndValidateInt(selectedId)).value_0, null, false);
    }
  }
}
;
function $buildForCreate(history_0){
  var createdResourceKey, createdResourceName, createdResourceType, createdTimestamp, errorMessage, form, id, modifiedTimestamp, status_0, subject, type, typeValue;
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $isCreated_1(form)?$setProperty_3(form, 'height', '100%'):(form.config_0['height'] = '100%' , undefined);
  $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  id = new StaticTextItem_2('id', ($clinit_Enhanced() , 'ID'));
  $setValue_5(id, history_0.id);
  type = new StaticTextItem_2('type', 'Type');
  typeValue = imgHTML(($clinit_ChildHistoryView() , 'subsystems/inventory/CreateChild_16.png'));
  typeValue += 'Created Child';
  $setValue_7(type, typeValue);
  createdTimestamp = new StaticTextItem_2('created', 'Date Created');
  $setValue_7(createdTimestamp, format_30(new Date_2(history_0.ctime), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_FULL)));
  modifiedTimestamp = new StaticTextItem_2('created', 'Last Updated');
  $setValue_7(modifiedTimestamp, format_30(new Date_2(history_0.mtime), DATE_TIME_FORMAT_FULL));
  subject = new StaticTextItem_2('subject', 'User');
  $setValue_7(subject, history_0.subjectName);
  status_0 = new StaticTextItem_2('status', 'Status');
  switch (history_0.status_0.ordinal) {
    case 1:
      $setValue_7(status_0, 'Success');
      break;
    case 2:
      $setValue_7(status_0, 'Failed');
      break;
    case 0:
      $setValue_7(status_0, 'In Progress');
      break;
    case 4:
      $setValue_7(status_0, 'Invalid Artifact');
      break;
    case 3:
      $setValue_7(status_0, 'Invalid Configuration');
      break;
    case 5:
      $setValue_7(status_0, 'Timed Out.');
      break;
    default:$setValue_7(status_0, '?');
  }
  createdResourceName = new StaticTextItem_2('createdResourceName', 'Resource Name');
  $setValue_7(createdResourceName, history_0.createdResourceName);
  createdResourceKey = new StaticTextItem_2('createdResourceKey', 'Resource Key');
  $setValue_7(createdResourceKey, history_0.newResourceKey);
  createdResourceType = new StaticTextItem_2('createdResourceType', 'Resource Type');
  history_0.resourceType?$setValue_7(createdResourceType, history_0.resourceType.name_0):$setValue_7(createdResourceType, 'Unknown');
  errorMessage = new TextAreaItem_2('errorMessage', 'Error');
  $setValue_7(errorMessage, history_0.errorMessage_0);
  $setAttribute_30(errorMessage, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0);
  $isCreated_2(errorMessage)?$setProperty_6(errorMessage, 'colSpan', 2):(errorMessage.jsObj['colSpan'] = 2 , undefined);
  $setWidth_2(errorMessage, '100%');
  $setHeight_1(errorMessage, '100%');
  history_0.errorMessage_0 != null && history_0.errorMessage_0.length > 0?form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [id, type, createdTimestamp, modifiedTimestamp, subject, createdResourceName, createdResourceKey, createdResourceType, status_0, errorMessage])):form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [id, type, createdTimestamp, modifiedTimestamp, subject, createdResourceName, createdResourceKey, createdResourceType, status_0]));
  return form;
}

function $buildForDelete(history_0){
  var createdTimestamp, deletedResourceName, deletedResourceType, errorMessage, form, id, modifiedTimestamp, status_0, subject, type, typeValue;
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $isCreated_1(form)?$setProperty_3(form, 'height', '100%'):(form.config_0['height'] = '100%' , undefined);
  $setWrapItemTitles(form, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  id = new StaticTextItem_2('id', ($clinit_Enhanced() , 'ID'));
  $setValue_5(id, history_0.id);
  type = new StaticTextItem_2('type', 'Type');
  typeValue = imgHTML(($clinit_ChildHistoryView() , 'subsystems/inventory/DeleteChild_16.png'));
  typeValue += 'Deleted Child';
  $setValue_7(type, typeValue);
  createdTimestamp = new StaticTextItem_2('created', 'Date Created');
  $setValue_7(createdTimestamp, format_30(new Date_2(history_0.ctime), ($clinit_TimestampCellFormatter() , DATE_TIME_FORMAT_FULL)));
  modifiedTimestamp = new StaticTextItem_2('created', 'Last Updated');
  $setValue_7(modifiedTimestamp, format_30(new Date_2(history_0.mtime), DATE_TIME_FORMAT_FULL));
  subject = new StaticTextItem_2('subject', 'User');
  $setValue_7(subject, history_0.subjectName);
  status_0 = new StaticTextItem_2('status', 'Status');
  switch (history_0.status_0.ordinal) {
    case 1:
      $setValue_7(status_0, 'Success');
      break;
    case 2:
      $setValue_7(status_0, 'Failed');
      break;
    case 0:
      $setValue_7(status_0, 'In Progress');
      break;
    case 3:
      $setValue_7(status_0, 'Timed Out.');
      break;
    default:$setValue_7(status_0, '?');
  }
  deletedResourceName = new StaticTextItem_2('deletedResourceName', 'Resource Name');
  deletedResourceType = new StaticTextItem_2('deletedResourceType', 'Resource Type');
  if (history_0.resource) {
    $setValue_7(deletedResourceName, history_0.resource.name_0);
    history_0.resource.resourceType?$setValue_7(deletedResourceType, history_0.resource.resourceType.name_0):$setValue_7(deletedResourceType, 'Unknown');
  }
   else {
    $setValue_7(deletedResourceName, 'Unknown');
    $setValue_7(deletedResourceType, 'Unknown');
  }
  errorMessage = new TextAreaItem_2('errorMessage', 'Error');
  $setValue_7(errorMessage, history_0.errorMessage_0);
  $setAttribute_30(errorMessage, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0);
  $isCreated_2(errorMessage)?$setProperty_6(errorMessage, 'colSpan', 2):(errorMessage.jsObj['colSpan'] = 2 , undefined);
  $setWidth_2(errorMessage, '100%');
  $setHeight_1(errorMessage, '100%');
  history_0.errorMessage_0 != null && history_0.errorMessage_0.length > 0?form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [id, type, createdTimestamp, modifiedTimestamp, subject, deletedResourceName, deletedResourceType, status_0, errorMessage])):form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [id, type, createdTimestamp, modifiedTimestamp, subject, deletedResourceName, deletedResourceType, status_0]));
  return form;
}

function ChildHistoryDetails_0(history_0){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.createHistory = history_0;
  this.deleteHistory = null;
}

function ChildHistoryDetails_1(history_0){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.createHistory = null;
  this.deleteHistory = history_0;
}

defineSeed(3292, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ChildHistoryDetails_0, ChildHistoryDetails_1);
_.onDraw_0 = function onDraw_48(){
  var form;
  form = null;
  this.createHistory?(form = $buildForCreate(this.createHistory)):!!this.deleteHistory && (form = $buildForDelete(this.deleteHistory));
  $addMember(this, form);
}
;
_.createHistory = null;
_.deleteHistory = null;
function $clinit_ChildHistoryView(){
  $clinit_ChildHistoryView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_23 = new ViewName_1('ChildHistory', ($clinit_Enhanced() , 'Child History'));
}

function ChildHistoryView_0(resourceComposite){
  $clinit_ChildHistoryView();
  Table_2.call(this, VIEW_ID_23.title_0);
  this.resourceComposite = resourceComposite;
  $setDataSource(this, new ChildHistoryView$DataSource_0(this));
}

defineSeed(3293, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ChildHistoryView_0);
_.configureTable = function configureTable_54(){
  var createdField, idField, listGrid, modifiedField, statusField, subjectField, typeField, typeIcons;
  idField = new ListGridField_3('id', ($clinit_Enhanced() , 'ID'));
  idField.jsObj['width'] = 75;
  typeField = new ListGridField_3('historyType', 'Type');
  typeField.jsObj['width'] = 75;
  $setAttribute_13(typeField, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0);
  typeIcons = new HashMap_1(2);
  typeIcons.put('create', 'subsystems/inventory/CreateChild_16.png');
  typeIcons.put('delete', 'subsystems/inventory/DeleteChild_16.png');
  setAttribute_10(typeField.jsObj, 'valueIcons', typeIcons);
  $setAttribute_8(typeField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(typeField, new ChildHistoryView$1_0);
  createdField = new ListGridField_3('createdDate', 'Date Created');
  $clinit_TimestampCellFormatter();
  prepareDateField(createdField, getAttribute(createdField.jsObj, 'name'));
  modifiedField = new ListGridField_3('lastModifiedDate', 'Last Updated');
  prepareDateField(modifiedField, getAttribute(modifiedField.jsObj, 'name'));
  subjectField = new ListGridField_3('subjectName', 'User');
  statusField = new ListGridField_3('status', 'Status');
  $setCellFormatter_0(statusField, new ChildHistoryView$2_0);
  $setListGridFields(this, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [idField, typeField, createdField, modifiedField, subjectField, statusField]));
  $setListGridDoubleClickHandler(this, new ChildHistoryView$3_0);
  listGrid = this.listGrid;
  $isCreated_1(listGrid)?$setProperty_3(listGrid, 'sortField', 'createdDate'):(listGrid.config_0['sortField'] = 'createdDate' , undefined);
  $setSortDirection(listGrid, ($clinit_SortDirection() , DESCENDING));
}
;
_.configureTableFilters = function configureTableFilters_8(){
  this.dateRangeItem = new SpinnerItem_1('filterDateRange', ($clinit_Enhanced() , 'Past N Days'));
  $setValue_5(this.dateRangeItem, 30);
  $setFilterFormItems(this, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.dateRangeItem]));
}
;
_.dateRangeItem = null;
_.resourceComposite = null;
var VIEW_ID_23;
function ChildHistoryView$1_0(){
}

defineSeed(3294, 1, {}, ChildHistoryView$1_0);
_.hoverHTML_0 = function hoverHTML_47(value, record, rowNum, colNum){
  var type;
  type = getAttribute(record.jsObj, 'historyType');
  return $equals_6('create', type)?($clinit_Enhanced() , 'Created Child'):$equals_6('delete', type)?($clinit_Enhanced() , 'Deleted Child'):'?';
}
;
function ChildHistoryView$2_0(){
}

defineSeed(3295, 1, {}, ChildHistoryView$2_0);
_.format_1 = function format_70(value, record, rowNum, colNum){
  var type;
  type = getAttribute(record.jsObj, 'historyType');
  if ($equals_6('create', type)) {
    switch (valueOf_109(toString__devirtual$(value)).ordinal) {
      case 1:
        return $clinit_Enhanced() , 'Success';
      case 2:
        return $clinit_Enhanced() , 'Failed';
      case 0:
        return $clinit_Enhanced() , 'In Progress';
      case 4:
        return $clinit_Enhanced() , 'Invalid Artifact';
      case 3:
        return $clinit_Enhanced() , 'Invalid Configuration';
      case 5:
        return $clinit_Enhanced() , 'Timed out';
    }
  }
   else if ($equals_6('delete', type)) {
    switch (valueOf_110(toString__devirtual$(value)).ordinal) {
      case 1:
        return $clinit_Enhanced() , 'Success';
      case 2:
        return $clinit_Enhanced() , 'Failed';
      case 0:
        return $clinit_Enhanced() , 'In Progress';
      case 3:
        return $clinit_Enhanced() , 'Timed Out.';
    }
  }
  return '?';
}
;
function ChildHistoryView$3_0(){
}

defineSeed(3296, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), ChildHistoryView$3_0);
_.onDoubleClick = function onDoubleClick_13(event_0){
  var detailsView, history_0, listGrid, selectedRows, typeString;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    typeString = getAttribute(selectedRows[0].jsObj, 'historyType');
    detailsView = null;
    if ($equals_6('create', typeString)) {
      history_0 = dynamicCast(getAttributeAsObject(selectedRows[0].jsObj, 'object'), Q$CreateResourceHistory);
      detailsView = new ChildHistoryDetails_0(history_0);
    }
     else if ($equals_6('delete', typeString)) {
      history_0 = dynamicCast(getAttributeAsObject(selectedRows[0].jsObj, 'object'), Q$DeleteResourceHistory);
      detailsView = new ChildHistoryDetails_1(history_0);
    }
    $show(new ChildHistoryView$DetailsWindow_0(detailsView));
  }
}
;
function $executeFetch_40(this$static, request, response){
  var beginDate, beginEndRange, endDate, now, pc1, pc2;
  now = fromDouble(currentTimeMillis0());
  beginEndRange = null;
  if (this$static.this$0.dateRangeItem) {
    beginEndRange = new DateRange_0;
    $setStartDate(beginEndRange, new Date_2(sub(now, mul(P5265c00_longLit, fromInt(__parseAndValidateInt(toString__devirtual$($getValue_0(this$static.this$0.dateRangeItem))))))));
    $setEndDate(beginEndRange, new Date_2(now));
  }
  beginDate = valueOf_45(beginEndRange?$getStartDate(beginEndRange).getTime_0():sub(now, P9a7ec800_longLit));
  endDate = valueOf_45(beginEndRange?$getEndDate(beginEndRange).getTime_0():now);
  pc1 = new PageControl_1(0, -1);
  pc2 = new PageControl_1(0, -1);
  $findCreateChildResourceHistory(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), this$static.this$0.resourceComposite.resource.id, beginDate, endDate, pc1, new ChildHistoryView$DataSource$1_0(this$static, beginDate, endDate, pc2, response, request));
}

function ChildHistoryView$DataSource_0(this$0){
  $clinit_RPCDataSource();
  this.this$0 = this$0;
  RPCDataSource_0.call(this);
}

defineSeed(3297, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ChildHistoryView$DataSource_0);
_.copyValues = function copyValues_107(from){
  return getAttributeAsObject(from.jsObj, 'object');
}
;
_.copyValues_0 = function copyValues_108(from){
  var history_0, record;
  record = new ListGridRecord_0;
  instanceOf(from, Q$String) || from == null?$setAttribute_13(record, 'object', dynamicCast(from, Q$String)):instanceOf(from, Q$Integer)?$setAttribute_3(record, 'object', dynamicCast(from, Q$Integer).value_0):instanceOf(from, Q$Float)?$setAttribute_2(record, 'object', dynamicCast(from, Q$Float).value_0):instanceOf(from, Q$Double)?$setAttribute_2(record, 'object', dynamicCast(from, Q$Double).value_0):instanceOf(from, Q$Long)?$setAttribute_4(record, 'object', dynamicCast(from, Q$Long).value_0):instanceOf(from, Q$Boolean)?$setAttribute_16(record, 'object', dynamicCast(from, Q$Boolean).value_0):instanceOf(from, Q$Date)?$setAttribute_14(record, 'object', dynamicCast(from, Q$Date)):instanceOfJso(from)?$setAttribute_5(record, 'object', dynamicCastJso(from)):instanceOf(from, Q$Map)?$setAttribute_5(record, 'object', convertMapToJavascriptObject(dynamicCast(from, Q$Map))):(record.jsObj['object'] = from , undefined);
  if (instanceOf(from, Q$CreateResourceHistory)) {
    history_0 = dynamicCast(from, Q$CreateResourceHistory);
    record.jsObj['historyType'] = 'create';
    $setAttribute_3(record, 'id', history_0.id);
    $setAttribute_13(record, 'subjectName', history_0.subjectName);
    $setAttribute_14(record, 'createdDate', new Date_2(history_0.ctime));
    $setAttribute_14(record, 'lastModifiedDate', new Date_2(history_0.mtime));
    $setAttribute_13(record, 'status', history_0.status_0.name_0);
  }
   else if (instanceOf(from, Q$DeleteResourceHistory)) {
    history_0 = dynamicCast(from, Q$DeleteResourceHistory);
    record.jsObj['historyType'] = 'delete';
    $setAttribute_3(record, 'id', history_0.id);
    $setAttribute_13(record, 'subjectName', history_0.subjectName);
    $setAttribute_14(record, 'createdDate', new Date_2(history_0.ctime));
    $setAttribute_14(record, 'lastModifiedDate', new Date_2(history_0.mtime));
    $setAttribute_13(record, 'status', history_0.status_0.name_0);
  }
   else {
    $handleError_0(($clinit_CoreGUI() , 'invalid child history type: ' + getClass__devirtual$(from)), null);
  }
  return record;
}
;
_.executeFetch = function executeFetch_58(request, response, criteria){
  $executeFetch_40(this, request, response, dynamicCast(criteria, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_67(request){
  return null;
}
;
_.this$0 = null;
function $onSuccess_334(this$static, createList){
  $findDeleteChildResourceHistory(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), this$static.this$1.this$0.resourceComposite.resource.id, this$static.val$beginDate, this$static.val$endDate, this$static.val$pc2, new ChildHistoryView$DataSource$1$1_0(this$static, createList, this$static.val$response, this$static.val$request));
}

function ChildHistoryView$DataSource$1_0(this$1, val$beginDate, val$endDate, val$pc2, val$response, val$request){
  this.this$1 = this$1;
  this.val$beginDate = val$beginDate;
  this.val$endDate = val$endDate;
  this.val$pc2 = val$pc2;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3298, 1, {}, ChildHistoryView$DataSource$1_0);
_.onFailure = function onFailure_348(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load child create history'), caught);
}
;
_.onSuccess_0 = function onSuccess_348(createList){
  $onSuccess_334(this, dynamicCast(createList, Q$PageList));
}
;
_.this$1 = null;
_.val$beginDate = null;
_.val$endDate = null;
_.val$pc2 = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_335(this$static, deleteList){
  var fullList, records;
  fullList = new ArrayList_0;
  $addAll_0(fullList, this$static.val$createList);
  $addAll_0(fullList, deleteList);
  records = $buildRecords(this$static.this$2.this$1, fullList, true);
  $setAttribute_17(this$static.val$response, 'data', records);
  $processResponse_0(this$static.this$2.this$1, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ChildHistoryView$DataSource$1$1_0(this$2, val$createList, val$response, val$request){
  this.this$2 = this$2;
  this.val$createList = val$createList;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3299, 1, {}, ChildHistoryView$DataSource$1$1_0);
_.onFailure = function onFailure_349(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load child delete history'), caught);
}
;
_.onSuccess_0 = function onSuccess_349(deleteList){
  $onSuccess_335(this, dynamicCast(deleteList, Q$PageList));
}
;
_.this$2 = null;
_.val$createList = null;
_.val$request = null;
_.val$response = null;
function ChildHistoryView$DetailsWindow_0(canvas){
  $clinit_BaseWidget();
  Window_1.call(this);
  $setTitle(this, ($clinit_Enhanced() , 'Details'));
  $setShowMinimizeButton(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowMaximizeButton(this, TRUE);
  $setIsModal(this, TRUE);
  $setShowModalMask(this, TRUE);
  $isCreated_1(this)?$setProperty_0(this, 'width', 600):(this.config_0['width'] = 600 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'height', 400):(this.config_0['height'] = 400 , undefined);
  $setAutoCenter(this, TRUE);
  $setShowResizer(this, TRUE);
  $setCanDragResize_0(this, TRUE);
  $centerInPage(this);
  $addCloseClickHandler(this, new ChildHistoryView$DetailsWindow$1_0(this));
  !!canvas && $addItem(this, canvas);
}

defineSeed(3300, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), ChildHistoryView$DetailsWindow_0);
function ChildHistoryView$DetailsWindow$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3301, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), ChildHistoryView$DetailsWindow$1_0);
_.onCloseClick_0 = function onCloseClick_15(event_0){
  $markForDestroy(this.this$1);
}
;
_.this$1 = null;
function CustomResourceTreeGrid_0(){
  TreeGrid_0.call(this);
}

defineSeed(3302, 575, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$TreeGrid]), CustomResourceTreeGrid_0);
_.getIcon_0 = function getIcon_2(record, defaultState){
  var node, open_0, resource;
  if (instanceOf(record, Q$TreeNode)) {
    open_0 = $isOpen(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this, 'data')), dynamicCast(record, Q$TreeNode)).value_0;
    if (instanceOf(record, Q$ResourceTreeDatasource$ResourceTreeNode)) {
      node = dynamicCast(record, Q$ResourceTreeDatasource$ResourceTreeNode);
      if (node.isLocked) {
        return 'global/Locked_16.png';
      }
       else {
        resource = dynamicCast(record, Q$ResourceTreeDatasource$ResourceTreeNode).resource;
        return getResourceIcon_0(resource.resourceType.category, resource.currentAvailability.availabilityType, '16');
      }
    }
     else 
      return instanceOf(record, Q$ResourceTreeDatasource$SubCategoryTreeNode)?'resources/folder_mixed_' + (open_0?'opened':'closed') + '.png':'resources/folder_group_' + (open_0?'opened':'closed') + '.png';
  }
  return null;
}
;
function $buildForm_6(this$static, type){
  var ctime, ctimeItem, descriptionItem, formItem, formItemId, formItems, headerItem, itime, itimeItem, keyItem, locationItem, measurementDef, measurementDef$iterator, modifiable, modifierItem, mtime, mtimeItem, nameItem, notEmptyOrNullValidator, resource, summaryTraitDefs, togglableDescriptionItem, togglableLocationItem, togglableNameItem, trait, trait$iterator, typeItem, version, versionItem;
  notEmptyOrNullValidator = new StringLengthValidator_0(valueOf_44(1), ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  new StringLengthValidator_0(null, FALSE);
  formItems = new ArrayList_0;
  if (this$static.headerEnabled) {
    headerItem = new HeaderItem_1('Summary');
    $setValue_7(headerItem, 'Summary');
    setCheck(formItems.array, formItems.size_0++, headerItem);
  }
  typeItem = new StaticTextItem_2('type', 'Type');
  $setPrompt_1(typeItem, 'Plugin: ' + type.plugin + '\n<br>Type: ' + type.name_0);
  $setValue_7(typeItem, ($clinit_AncestryUtil() , $toString_1(addFormattedType(new StringBuilder_0, type).data_0)));
  setCheck(formItems.array, formItems.size_0++, typeItem);
  resource = this$static.resourceComposite.resource;
  keyItem = new StaticTextItem_2(($clinit_ResourceDataSourceField() , KEY).propertyName, KEY.title_0);
  $isCreated_2(keyItem)?$setProperty_9(keyItem, 'outputAsHTML', true):(keyItem.jsObj['outputAsHTML'] = true , undefined);
  $setValue_7(keyItem, resource.resourceKey);
  setCheck(formItems.array, formItems.size_0++, keyItem);
  modifiable = this$static.resourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE));
  nameItem = modifiable?new EditableFormItem_0:new StaticTextItem_0;
  $isCreated_2(nameItem)?$setProperty_8(nameItem, 'name', 'name'):(nameItem.jsObj['name'] = 'name' , undefined);
  nameItem.setTitle('Name');
  nameItem.setValue_4(resource.name_0);
  $isCreated_2(nameItem)?$setProperty_9(nameItem, 'outputAsHTML', true):(nameItem.jsObj['outputAsHTML'] = true , undefined);
  if (instanceOf(nameItem, Q$EditableFormItem)) {
    togglableNameItem = dynamicCast(nameItem, Q$EditableFormItem);
    togglableNameItem.editItem.setValidators(initValues(_3Lcom_smartgwt_client_widgets_form_validator_Validator_2_classLit, makeCastMap([Q$Validator_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Validator, [notEmptyOrNullValidator]));
    $setValueEditedHandler(togglableNameItem, new OverviewForm$3_0(this$static, resource, nameItem));
  }
  setCheck(formItems.array, formItems.size_0++, nameItem);
  descriptionItem = modifiable?new EditableFormItem_0:new StaticTextItem_0;
  $isCreated_2(descriptionItem)?$setProperty_8(descriptionItem, 'name', 'description'):(descriptionItem.jsObj['name'] = 'description' , undefined);
  descriptionItem.setTitle('Description');
  descriptionItem.setValue_4(resource.description);
  $isCreated_2(descriptionItem)?$setProperty_9(descriptionItem, 'outputAsHTML', true):(descriptionItem.jsObj['outputAsHTML'] = true , undefined);
  if (instanceOf(descriptionItem, Q$EditableFormItem)) {
    togglableDescriptionItem = dynamicCast(descriptionItem, Q$EditableFormItem);
    $setValueEditedHandler(togglableDescriptionItem, new OverviewForm$4_0(this$static, resource, descriptionItem));
  }
  setCheck(formItems.array, formItems.size_0++, descriptionItem);
  locationItem = modifiable?new EditableFormItem_0:new StaticTextItem_0;
  $isCreated_2(locationItem)?$setProperty_8(locationItem, 'name', 'location'):(locationItem.jsObj['name'] = 'location' , undefined);
  locationItem.setTitle('Location');
  locationItem.setValue_4(resource.location_0);
  $isCreated_2(locationItem)?$setProperty_9(locationItem, 'outputAsHTML', true):(locationItem.jsObj['outputAsHTML'] = true , undefined);
  if (instanceOf(locationItem, Q$EditableFormItem)) {
    togglableLocationItem = dynamicCast(locationItem, Q$EditableFormItem);
    $setValueEditedHandler(togglableLocationItem, new OverviewForm$5_0(this$static, resource, locationItem));
  }
  setCheck(formItems.array, formItems.size_0++, locationItem);
  versionItem = new StaticTextItem_2('version', 'Version');
  version = resource.version_0 != null?resource.version_0:'<i>none<\/i>';
  $setValue_7(versionItem, version);
  setCheck(formItems.array, formItems.size_0++, versionItem);
  ctimeItem = new StaticTextItem_2(CTIME.propertyName, CTIME.title_0);
  ctime = ($clinit_TimestampCellFormatter() , format_30(valueOf_45(resource.ctime.value_0), DATE_TIME_FORMAT_MEDIUM));
  $setValue_7(ctimeItem, ctime);
  setCheck(formItems.array, formItems.size_0++, ctimeItem);
  itimeItem = new StaticTextItem_2(ITIME.propertyName, ITIME.title_0);
  itime = format_30(valueOf_45(resource.itime.value_0), DATE_TIME_FORMAT_MEDIUM);
  $setValue_7(itimeItem, itime);
  setCheck(formItems.array, formItems.size_0++, itimeItem);
  mtimeItem = new StaticTextItem_2(MTIME.propertyName, MTIME.title_0);
  mtime = format_30(valueOf_45(resource.mtime.value_0), DATE_TIME_FORMAT_MEDIUM);
  $setValue_7(mtimeItem, mtime);
  setCheck(formItems.array, formItems.size_0++, mtimeItem);
  modifierItem = new StaticTextItem_2(MODIFIER_0.propertyName, MODIFIER_0.title_0);
  $setValue_7(modifierItem, resource.modifiedBy);
  setCheck(formItems.array, formItems.size_0++, modifierItem);
  summaryTraitDefs = new ArrayList_0;
  for (measurementDef$iterator = type.metricDefinitions.iterator(); measurementDef$iterator.hasNext();) {
    measurementDef = dynamicCast(measurementDef$iterator.next_0(), Q$MeasurementDefinition);
    measurementDef.dataType == ($clinit_DataType() , TRAIT_0) && measurementDef.displayType == ($clinit_DisplayType() , SUMMARY_0) && (setCheck(summaryTraitDefs.array, summaryTraitDefs.size_0++, measurementDef) , true);
  }
  sort_1(summaryTraitDefs, new OverviewForm$6_0);
  for (trait$iterator = new AbstractList$IteratorImpl_0(summaryTraitDefs); trait$iterator.i < trait$iterator.this$0_0.size_1();) {
    trait = dynamicCast($next_0(trait$iterator), Q$MeasurementDefinition);
    formItemId = $replaceAll($replaceAll(trait.displayName, '\\.', '_'), ' ', '__');
    formItem = new StaticTextItem_2(formItemId, trait.displayName);
    $setPrompt_1(formItem, trait.description);
    setCheck(formItems.array, formItems.size_0++, formItem);
  }
  this$static.displayCondensed || $add_3(formItems, new SpacerItem_0);
  $setFields_3(this$static, dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, formItems.size_0, 0)), Q$FormItem_$1));
}

function $loadTraitValues(this$static){
  var resource;
  resource = this$static.resourceComposite.resource;
  $findCurrentTraitsForResource(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), resource.id, ($clinit_DisplayType() , SUMMARY_0), new OverviewForm$2_0(this$static, resource));
}

function $setResource_1(this$static, resourceComposite){
  var resource;
  this$static.resourceComposite = resourceComposite;
  resource = resourceComposite.resource;
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(resource.resourceType.id), of(($clinit_ResourceTypeRepository$MetadataType() , measurements_0)), new OverviewForm$1_0(this$static));
}

function OverviewForm_0(resourceComposite, titleBar){
  $clinit_BaseWidget();
  EnhancedDynamicForm_0.call(this);
  this.resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  this.resourceComposite = resourceComposite;
  this.titleBar = titleBar;
}

defineSeed(3303, 2304, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm]), OverviewForm_0);
_.onDraw_0 = function onDraw_49(){
  $isCreated_1(this)?$setProperty_3(this, 'left', '10%'):(this.config_0['left'] = '10%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '80%'):(this.config_0['width'] = '80%' , undefined);
  if (this.displayCondensed) {
    $setPadding(this, valueOf_44(5));
    $setColWidths(this, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [valueOf_44(150), valueOf_44(220), valueOf_44(150), valueOf_44(220)]));
    $isCreated_1(this)?$setProperty_3(this, 'width', '45%'):(this.config_0['width'] = '45%' , undefined);
  }
  !!this.resourceComposite && $setResource_1(this, this.resourceComposite);
}
;
_.displayCondensed = false;
_.headerEnabled = true;
_.resourceComposite = null;
_.titleBar = null;
function OverviewForm$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3304, 1, {}, OverviewForm$1_0);
_.onTypesLoaded = function onTypesLoaded_34(type){
  $buildForm_6(this.this$0, type);
  $loadTraitValues(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_336(this$static, result){
  var formItemId, item, trait, trait$iterator;
  for (trait$iterator = result.iterator(); trait$iterator.hasNext();) {
    trait = dynamicCast(trait$iterator.next_0(), Q$MeasurementDataTrait);
    formItemId = ($clinit_BaseWidget() , $replaceAll($replaceAll(trait.name_0, '\\.', '_'), ' ', '__'));
    item = $getField_0(this$static.this$0, formItemId);
    !!item && $setValue_0(this$static.this$0, formItemId, trait.value_0);
  }
  $markForRedraw(this$static.this$0);
}

function OverviewForm$2_0(this$0, val$resource){
  this.this$0 = this$0;
  this.val$resource = val$resource;
}

defineSeed(3305, 1, {}, OverviewForm$2_0);
_.onFailure = function onFailure_350(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load traits for ' + $toString_18(this.val$resource) + '.'), caught);
}
;
_.onSuccess_0 = function onSuccess_350(result){
  $onSuccess_336(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
_.val$resource = null;
function OverviewForm$3_0(this$0, val$resource, val$nameItem){
  this.this$0 = this$0;
  this.val$resource = val$resource;
  this.val$nameItem = val$nameItem;
}

defineSeed(3306, 1, {}, OverviewForm$3_0);
_.editedValue = function editedValue_2(newValue){
  var newName, oldName;
  newName = toString__devirtual$(newValue);
  oldName = this.val$resource.name_0;
  if ($equals_6(newName, oldName)) {
    return;
  }
  $setName_8(this.val$resource, newName);
  $updateResource(this.this$0.resourceService, this.val$resource, new OverviewForm$3$1_0(this, this.val$resource, oldName, newName, this.val$nameItem));
}
;
_.this$0 = null;
_.val$nameItem = null;
_.val$resource = null;
function $onSuccess_337(this$static){
  $displayResourceName(this$static.this$1.this$0.titleBar, this$static.val$newName);
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Name of Resource with id ' + this$static.val$resource.id + ' was changed from [' + this$static.val$oldName + '] to [' + this$static.val$newName + '].', ($clinit_Message$Severity() , Info)));
}

function OverviewForm$3$1_0(this$1, val$resource, val$oldName, val$newName, val$nameItem){
  this.this$1 = this$1;
  this.val$resource = val$resource;
  this.val$oldName = val$oldName;
  this.val$newName = val$newName;
  this.val$nameItem = val$nameItem;
}

defineSeed(3307, 1, {}, OverviewForm$3$1_0);
_.onFailure = function onFailure_351(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to change name of Resource with id ' + this.val$resource.id + ' from [' + this.val$oldName + '] to [' + this.val$newName + '].'), caught);
  $setName_8(this.val$resource, this.val$oldName);
  this.val$nameItem.setValue_4(this.val$oldName);
}
;
_.onSuccess_0 = function onSuccess_351(result){
  $onSuccess_337(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$nameItem = null;
_.val$newName = null;
_.val$oldName = null;
_.val$resource = null;
function OverviewForm$4_0(this$0, val$resource, val$descriptionItem){
  this.this$0 = this$0;
  this.val$resource = val$resource;
  this.val$descriptionItem = val$descriptionItem;
}

defineSeed(3308, 1, {}, OverviewForm$4_0);
_.editedValue = function editedValue_3(newValue){
  var newDescription, oldDescription;
  newDescription = newValue != null?toString__devirtual$(newValue):'';
  oldDescription = this.val$resource.description;
  if ($equals_6(newDescription, oldDescription)) {
    return;
  }
  $setDescription_3(this.val$resource, newDescription);
  $updateResource(this.this$0.resourceService, this.val$resource, new OverviewForm$4$1_0(this.val$resource, oldDescription, newDescription, this.val$descriptionItem));
}
;
_.this$0 = null;
_.val$descriptionItem = null;
_.val$resource = null;
function $onSuccess_338(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Name of Resource with id ' + this$static.val$resource.id + ' was changed from [' + this$static.val$oldDescription + '] to [' + this$static.val$newDescription + '].', ($clinit_Message$Severity() , Info)));
}

function OverviewForm$4$1_0(val$resource, val$oldDescription, val$newDescription, val$descriptionItem){
  this.val$resource = val$resource;
  this.val$oldDescription = val$oldDescription;
  this.val$newDescription = val$newDescription;
  this.val$descriptionItem = val$descriptionItem;
}

defineSeed(3309, 1, {}, OverviewForm$4$1_0);
_.onFailure = function onFailure_352(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to change description of Resource with id ' + this.val$resource.id + ' from [' + this.val$oldDescription + '] to [' + this.val$newDescription + '].'), caught);
  $setDescription_3(this.val$resource, this.val$oldDescription);
  this.val$descriptionItem.setValue_4(this.val$oldDescription);
}
;
_.onSuccess_0 = function onSuccess_352(result){
  $onSuccess_338(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$descriptionItem = null;
_.val$newDescription = null;
_.val$oldDescription = null;
_.val$resource = null;
function OverviewForm$5_0(this$0, val$resource, val$locationItem){
  this.this$0 = this$0;
  this.val$resource = val$resource;
  this.val$locationItem = val$locationItem;
}

defineSeed(3310, 1, {}, OverviewForm$5_0);
_.editedValue = function editedValue_4(newValue){
  var newLocation, oldLocation;
  newLocation = newValue != null?toString__devirtual$(newValue):'';
  oldLocation = this.val$resource.location_0;
  if ($equals_6(newLocation, oldLocation)) {
    return;
  }
  $setLocation(this.val$resource, newLocation);
  $updateResource(this.this$0.resourceService, this.val$resource, new OverviewForm$5$1_0(this.val$resource, oldLocation, newLocation, this.val$locationItem));
}
;
_.this$0 = null;
_.val$locationItem = null;
_.val$resource = null;
function $onSuccess_339(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Name of Resource with id ' + this$static.val$resource.id + ' was changed from [' + this$static.val$oldLocation + '] to [' + this$static.val$newLocation + '].', ($clinit_Message$Severity() , Info)));
}

function OverviewForm$5$1_0(val$resource, val$oldLocation, val$newLocation, val$locationItem){
  this.val$resource = val$resource;
  this.val$oldLocation = val$oldLocation;
  this.val$newLocation = val$newLocation;
  this.val$locationItem = val$locationItem;
}

defineSeed(3311, 1, {}, OverviewForm$5$1_0);
_.onFailure = function onFailure_353(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to change location of Resource with id ' + this.val$resource.id + ' from [' + this.val$oldLocation + '] to [' + this.val$newLocation + '].'), caught);
  $setLocation(this.val$resource, this.val$oldLocation);
  this.val$locationItem.setValue_4(this.val$oldLocation);
}
;
_.onSuccess_0 = function onSuccess_353(result){
  $onSuccess_339(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$locationItem = null;
_.val$newLocation = null;
_.val$oldLocation = null;
_.val$resource = null;
function $compare_13(md1, md2){
  return $compareTo_5(new Integer_0(md1.displayOrder), valueOf_44(md2.displayOrder));
}

function OverviewForm$6_0(){
}

defineSeed(3312, 1, makeCastMap([Q$Comparator]), OverviewForm$6_0);
_.compare = function compare_14(md1, md2){
  return $compare_13(dynamicCast(md1, Q$MeasurementDefinition), dynamicCast(md2, Q$MeasurementDefinition));
}
;
function $createD3GraphListView_0(this$static){
  this$static.graphListView = ($clinit_AbstractD3GraphListView() , new D3GraphListView_1(this$static.resourceComposite.resource));
  return dynamicCast(this$static.graphListView, Q$D3GraphListView);
}

function $loadResourceType_0(this$static, resourceComposite, viewPath){
  var resource;
  resource = resourceComposite.resource;
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(resource.resourceType.id), of_0(($clinit_ResourceTypeRepository$MetadataType() , children_0), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceTypeRepository$MetadataType, [content_1, operations_0, measurements_0, events_0, resourceConfigurationDefinition_0])), new ResourceDetailView$28_0(this$static, resourceComposite, viewPath));
}

function $updateConfigurationTabContent(this$static, resourceComposite, resource, resourcePermissions, facets){
  if ($updateTab_0(this$static, this$static.configurationTab, facets.contains_0(($clinit_ResourceTypeFacet() , CONFIGURATION_2)), resourcePermissions.permissions.contains_0(($clinit_Permission() , CONFIGURE_READ)))) {
    $updateSubTab(this$static.configurationTab, this$static.configCurrent, true, true, new ResourceDetailView$20_0(resourceComposite));
    $updateSubTab(this$static.configurationTab, this$static.configHistory, true, true, new ResourceDetailView$21_0(resourceComposite, resource));
  }
}

function $updateContentTabContent(this$static, resource, facets){
  if ($updateTab_0(this$static, this$static.contentTab, facets.contains_0(($clinit_ResourceTypeFacet() , CONTENT_0)), true)) {
    $updateSubTab(this$static.contentTab, this$static.contentDeployed, true, true, new ResourceDetailView$23_0(resource));
    $updateSubTab(this$static.contentTab, this$static.contentNew, true, true, new ResourceDetailView$24_0(resource));
    $updateSubTab(this$static.contentTab, this$static.contentSubscrip, true, true, new ResourceDetailView$25_0(resource));
    $updateSubTab(this$static.contentTab, this$static.contentHistory, true, true, new ResourceDetailView$26_0(resource));
  }
}

function $updateOperationsTabContent(this$static, facets){
  if ($updateTab_0(this$static, this$static.operationsTab, facets.contains_0(($clinit_ResourceTypeFacet() , OPERATION)), true)) {
    $updateSubTab(this$static.operationsTab, this$static.operationsSchedules, true, true, new ResourceDetailView$18_0(this$static));
    $updateSubTab(this$static.operationsTab, this$static.operationsHistory, true, true, new ResourceDetailView$19_0(this$static));
  }
}

function $updateTabContent_1(this$static, resourceComposite, isRefresh){
  var $e0, e, facets, resource, resourcePermissions, type, visible, viewFactory, canModifyMembership, enabled, visible_0, visibleToIE8, viewFactory_0;
  $updateTabContent(this$static);
  try {
    this$static.resourceComposite = resourceComposite;
    resource = this$static.resourceComposite.resource;
    $setResource_2(dynamicCast(this$static.titleBar, Q$ResourceTitleBar), this$static.resourceComposite, isRefresh);
    $destroyViews_0(this$static.tabSet);
    resourcePermissions = this$static.resourceComposite.resourcePermission;
    facets = this$static.resourceComposite.resourceFacets.facets;
    $updateSubTab(this$static.summaryTab, this$static.summaryActivity, true, true, new ResourceDetailView$1_0(this$static));
    $updateSubTab(this$static.summaryTab, this$static.summaryTimeline, true, true, new ResourceDetailView$2_0(this$static));
    type = this$static.resourceComposite.resource.resourceType;
    visible = !type.childResourceTypes.isEmpty_0();
    viewFactory = visible?new ResourceDetailView$3_0(resourceComposite):null;
    $updateSubTab(this$static.inventoryTab, this$static.inventoryChildren, visible, true, viewFactory);
    visible = !type.childResourceTypes.isEmpty_0();
    viewFactory = visible?new ResourceDetailView$4_0(resourceComposite):null;
    $updateSubTab(this$static.inventoryTab, this$static.inventoryChildHistory, visible, true, viewFactory);
    visible = facets.contains_0(($clinit_ResourceTypeFacet() , PLUGIN_CONFIGURATION));
    viewFactory = visible?new ResourceDetailView$5_0(resourceComposite):null;
    $updateSubTab(this$static.inventoryTab, this$static.inventoryConn, visible, true, viewFactory);
    viewFactory = visible?new ResourceDetailView$6_0(resourceComposite):null;
    $updateSubTab(this$static.inventoryTab, this$static.inventoryConnHistory, visible, true, viewFactory);
    canModifyMembership = this$static.globalPermissions.contains_0(($clinit_Permission() , MANAGE_INVENTORY));
    $updateSubTab(this$static.inventoryTab, this$static.inventoryGroups, true, true, new ResourceDetailView$7_0(resource, canModifyMembership));
    enabled = this$static.globalPermissions.contains_0(MANAGE_SETTINGS);
    viewFactory = enabled?new ResourceDetailView$8_0(this$static):null;
    $updateSubTab(this$static.inventoryTab, this$static.inventoryAgent, true, enabled, viewFactory);
    $updateSubTab(this$static.alertsTab, this$static.alertHistory, true, true, new ResourceDetailView$9_0(resourceComposite));
    $updateSubTab(this$static.alertsTab, this$static.alertDef, true, true, new ResourceDetailView$10_0(resourceComposite));
    visible_0 = hasMetricsOfType_0(this$static.resourceComposite, ($clinit_DataType() , MEASUREMENT));
    visibleToIE8 = !isBrowserPreIE9();
    viewFactory_0 = visibleToIE8?new ResourceDetailView$11_0(this$static):null;
    $updateSubTab(this$static.monitoringTab, this$static.monitorNewGraphs, visible_0, visibleToIE8, viewFactory_0);
    viewFactory_0 = visible_0?new ResourceDetailView$12_0(resource):null;
    $updateSubTab(this$static.monitoringTab, this$static.monitorTables, visible_0, true, viewFactory_0);
    visible_0 = hasMetricsOfType_0(this$static.resourceComposite, TRAIT_0);
    viewFactory_0 = visible_0?new ResourceDetailView$13_0(resource):null;
    $updateSubTab(this$static.monitoringTab, this$static.monitorTraits, visible_0, true, viewFactory_0);
    $updateSubTab(this$static.monitoringTab, this$static.monitorAvail, true, true, new ResourceDetailView$14_0(this$static));
    $updateSubTab(this$static.monitoringTab, this$static.monitorSched, hasMetricsOfType_0(this$static.resourceComposite, null), true, new ResourceDetailView$15_0(this$static));
    visible_0 = facets.contains_0(CALL_TIME);
    viewFactory_0 = visible_0?new ResourceDetailView$16_0(resource):null;
    $updateSubTab(this$static.monitoringTab, this$static.monitorCallTime, visible_0, true, viewFactory_0);
    $updateTab_0(this$static, this$static.eventsTab, facets.contains_0(EVENT_0), true) && $updateSubTab(this$static.eventsTab, this$static.eventHistory, true, true, new ResourceDetailView$17_0(resourceComposite));
    $updateOperationsTabContent(this$static, facets);
    $updateConfigurationTabContent(this$static, resourceComposite, resource, resourcePermissions, facets);
    $updateTab_0(this$static, this$static.driftTab, facets.contains_0(DRIFT_1), true) && $updateSubTab(this$static.driftTab, this$static.driftDefinitions, true, true, new ResourceDetailView$22_0(resourceComposite));
    $updateContentTabContent(this$static, resource, facets);
    $show(this$static);
    $markForRedraw(this$static);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      e = $e0;
      $handleError_0(($clinit_CoreGUI() , 'Failed to update tab content.'), e);
    }
     else 
      throw $e0;
  }
}

function ResourceDetailView_0(){
  $clinit_BaseWidget();
  AbstractTwoLevelTabSetView_0.call(this, 'Resource');
  $hide(this);
}

function hasMetricsOfType_0(resourceComposite, dataType){
  var metricDef, metricDef$iterator, metricDefs, type;
  type = resourceComposite.resource.resourceType;
  metricDefs = type.metricDefinitions;
  for (metricDef$iterator = metricDefs.iterator(); metricDef$iterator.hasNext();) {
    metricDef = dynamicCast(metricDef$iterator.next_0(), Q$MeasurementDefinition);
    if (!dataType || metricDef.dataType == dataType) {
      return true;
    }
  }
  return false;
}

defineSeed(3313, 2928, makeCastMap([Q$HasAttachHandlers, Q$EventHandler, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$TwoLevelTabSelectedHandler, Q$Enhanced]), ResourceDetailView_0);
_.createTabs = function createTabs_0(){
  var tabs;
  tabs = new ArrayList_0;
  this.summaryTab = new TwoLevelTab_0(new ViewName_1('Summary', ($clinit_Enhanced() , 'Summary')), getResourceIcon_0(($clinit_ResourceCategory() , SERVICE), ($clinit_AvailabilityType() , UP), '16'));
  this.summaryActivity = new SubTab_0(this.summaryTab, new ViewName_1('Activity', 'Activity'));
  this.summaryTimeline = new SubTab_0(this.summaryTab, new ViewName_1('Timeline', 'Timeline'));
  $registerSubTabs_0(this.summaryTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.summaryActivity, this.summaryTimeline]));
  $add_3(tabs, this.summaryTab);
  this.inventoryTab = new TwoLevelTab_1(new ViewName_1('Inventory', 'Inventory'), ($clinit_IconEnum() , INVENTORY_SUMMARY));
  this.inventoryChildren = new SubTab_0(this.inventoryTab, new ViewName_1('Children', 'Child Resources'));
  this.inventoryChildHistory = new SubTab_0(this.inventoryTab, new ViewName_1('ChildHistory', 'Child History'));
  this.inventoryConn = new SubTab_0(this.inventoryTab, new ViewName_1('ConnectionSettings', 'Connection Settings'));
  this.inventoryConnHistory = new SubTab_0(this.inventoryTab, ($clinit_PluginConfigurationHistoryListView() , VIEW_ID_25));
  this.inventoryGroups = new SubTab_0(this.inventoryTab, new ViewName_1('Groups', 'Groups'));
  this.inventoryAgent = new SubTab_0(this.inventoryTab, new ViewName_1('Agent', 'Agent'));
  $registerSubTabs_0(this.inventoryTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.inventoryChildren, this.inventoryChildHistory, this.inventoryConn, this.inventoryConnHistory, this.inventoryGroups, this.inventoryAgent]));
  $add_3(tabs, this.inventoryTab);
  this.alertsTab = new TwoLevelTab_1(new ViewName_1('Alerts', 'Alerts'), ALERT_DEFINITIONS);
  this.alertHistory = new SubTab_0(this.alertsTab, new ViewName_1('History', 'History'));
  this.alertDef = new SubTab_0(this.alertsTab, new ViewName_1('Definitions', 'Definitions'));
  $registerSubTabs_0(this.alertsTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.alertHistory, this.alertDef]));
  $add_3(tabs, this.alertsTab);
  this.monitoringTab = new TwoLevelTab_1(new ViewName_1('Monitoring', 'Monitoring'), SUSPECT_METRICS);
  this.monitorNewGraphs = new SubTab_0(this.monitoringTab, new ViewName_1('NewGraphs', 'Graphs'));
  this.monitorTables = new SubTab_0(this.monitoringTab, new ViewName_1('Tables', 'Tables'));
  this.monitorTraits = new SubTab_0(this.monitoringTab, new ViewName_1('Traits', 'Traits'));
  this.monitorAvail = new SubTab_0(this.monitoringTab, new ViewName_1('Availability', 'Availability'));
  this.monitorSched = new SubTab_0(this.monitoringTab, new ViewName_1('Schedules', 'Schedules'));
  this.monitorCallTime = new SubTab_0(this.monitoringTab, new ViewName_1('CallTime', 'Calltime'));
  $registerSubTabs_0(this.monitoringTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.monitorTables, this.monitorNewGraphs, this.monitorTraits, this.monitorAvail, this.monitorSched, this.monitorCallTime]));
  $add_3(tabs, this.monitoringTab);
  this.eventsTab = new TwoLevelTab_1(new ViewName_1('Events', 'Events'), EVENTS);
  this.eventHistory = new SubTab_0(this.eventsTab, new ViewName_1('History', 'History'));
  $registerSubTabs_0(this.eventsTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.eventHistory]));
  $add_3(tabs, this.eventsTab);
  this.operationsTab = new TwoLevelTab_1(new ViewName_1('Operations', 'Operations'), RECENT_OPERATIONS);
  this.operationsSchedules = new SubTab_0(this.operationsTab, new ViewName_1('Schedules', 'Schedules'));
  this.operationsHistory = new SubTab_0(this.operationsTab, new ViewName_1('History', 'History'));
  $registerSubTabs_0(this.operationsTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.operationsSchedules, this.operationsHistory]));
  $add_3(tabs, this.operationsTab);
  this.configurationTab = new TwoLevelTab_1(new ViewName_1('Configuration', 'Configuration'), CONFIGURATION_HISTORY);
  this.configCurrent = new SubTab_0(this.configurationTab, new ViewName_1('Current', 'Current'));
  this.configHistory = new SubTab_0(this.configurationTab, new ViewName_1('History', 'History'));
  $registerSubTabs_0(this.configurationTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.configCurrent, this.configHistory]));
  $add_3(tabs, this.configurationTab);
  this.driftTab = new TwoLevelTab_1(new ViewName_1('Drift', 'Drift'), DRIFT_COMPLIANCE);
  this.driftDefinitions = new SubTab_0(this.driftTab, new ViewName_1('Definitions', 'Definitions'));
  $registerSubTabs_0(this.driftTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.driftDefinitions]));
  $add_3(tabs, this.driftTab);
  this.contentTab = new TwoLevelTab_1(new ViewName_1('Content', 'Content'), CONTENT_1);
  this.contentDeployed = new SubTab_0(this.contentTab, new ViewName_1('Deployed', 'Deployed'));
  this.contentNew = new SubTab_0(this.contentTab, new ViewName_1('New', 'New'));
  this.contentSubscrip = new SubTab_0(this.contentTab, new ViewName_1('Subscriptions', 'Subscriptions'));
  this.contentHistory = new SubTab_0(this.contentTab, new ViewName_1('History', 'History'));
  $registerSubTabs_0(this.contentTab, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SubTab, [this.contentDeployed, this.contentNew, this.contentSubscrip, this.contentHistory]));
  $add_3(tabs, this.contentTab);
  return tabs;
}
;
_.createTitleBar = function createTitleBar_0(){
  return new ResourceTitleBar_0;
}
;
_.getSelectedItemId = function getSelectedItemId_0(){
  return this.resourceId;
}
;
_.loadSelectedItem = function loadSelectedItem_0(resourceId, viewPath){
  var criteria;
  this.resourceId = valueOf_44(resourceId);
  criteria = new ResourceCriteria_0;
  $addFilterId(criteria, valueOf_44(resourceId));
  criteria.fetchTags = true;
  $findResourceCompositesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), criteria, new ResourceDetailView$27_0(this, resourceId, viewPath));
}
;
_.alertDef = null;
_.alertHistory = null;
_.alertsTab = null;
_.configCurrent = null;
_.configHistory = null;
_.configurationTab = null;
_.contentDeployed = null;
_.contentHistory = null;
_.contentNew = null;
_.contentSubscrip = null;
_.contentTab = null;
_.driftDefinitions = null;
_.driftTab = null;
_.eventHistory = null;
_.eventsTab = null;
_.inventoryAgent = null;
_.inventoryChildHistory = null;
_.inventoryChildren = null;
_.inventoryConn = null;
_.inventoryConnHistory = null;
_.inventoryGroups = null;
_.inventoryTab = null;
_.monitorAvail = null;
_.monitorCallTime = null;
_.monitorNewGraphs = null;
_.monitorSched = null;
_.monitorTables = null;
_.monitorTraits = null;
_.monitoringTab = null;
_.operationsHistory = null;
_.operationsSchedules = null;
_.operationsTab = null;
_.resourceComposite = null;
_.resourceId = null;
_.summaryActivity = null;
_.summaryTab = null;
_.summaryTimeline = null;
function ResourceDetailView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3314, 1, {}, ResourceDetailView$1_0);
_.createView = function createView_47(){
  return new ActivityView_2(this.this$0.resourceComposite);
}
;
_.this$0 = null;
function ResourceDetailView$10_0(val$resourceComposite){
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(3315, 1, {}, ResourceDetailView$10_0);
_.createView = function createView_48(){
  return new ResourceAlertDefinitionsView_0(this.val$resourceComposite);
}
;
_.val$resourceComposite = null;
function ResourceDetailView$11_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3316, 1, {}, ResourceDetailView$11_0);
_.createView = function createView_49(){
  return $createD3GraphListView_0(this.this$0);
}
;
_.this$0 = null;
function ResourceDetailView$12_0(val$resource){
  this.val$resource = val$resource;
}

defineSeed(3317, 1, {}, ResourceDetailView$12_0);
_.createView = function createView_50(){
  return new MeasurementTableView_0(this.val$resource.id);
}
;
_.val$resource = null;
function ResourceDetailView$13_0(val$resource){
  this.val$resource = val$resource;
}

defineSeed(3318, 1, {}, ResourceDetailView$13_0);
_.createView = function createView_51(){
  return new TraitsView_2(this.val$resource.id);
}
;
_.val$resource = null;
function ResourceDetailView$14_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3319, 1, {}, ResourceDetailView$14_0);
_.createView = function createView_52(){
  return new ResourceAvailabilityView_0(this.this$0.resourceComposite);
}
;
_.this$0 = null;
function ResourceDetailView$15_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3320, 1, {}, ResourceDetailView$15_0);
_.createView = function createView_53(){
  return new ResourceSchedulesView_0(this.this$0.resourceComposite);
}
;
_.this$0 = null;
function ResourceDetailView$16_0(val$resource){
  this.val$resource = val$resource;
}

defineSeed(3321, 1, {}, ResourceDetailView$16_0);
_.createView = function createView_54(){
  return new IFrameWithMeasurementRangeEditorView_0('/rhq/resource/monitor/response-plain.xhtml?id=' + this.val$resource.id);
}
;
_.val$resource = null;
function ResourceDetailView$17_0(val$resourceComposite){
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(3322, 1, {}, ResourceDetailView$17_0);
_.createView = function createView_55(){
  return get_22(this.val$resourceComposite);
}
;
_.val$resourceComposite = null;
function ResourceDetailView$18_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3323, 1, {}, ResourceDetailView$18_0);
_.createView = function createView_56(){
  return new ResourceOperationScheduleListView_0(this.this$0.resourceComposite);
}
;
_.this$0 = null;
function ResourceDetailView$19_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3324, 1, {}, ResourceDetailView$19_0);
_.createView = function createView_57(){
  return new ResourceOperationHistoryListView_0(this.this$0.resourceComposite);
}
;
_.this$0 = null;
function ResourceDetailView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3325, 1, {}, ResourceDetailView$2_0);
_.createView = function createView_58(){
  return new TimelineView_0(this.this$0.resourceComposite);
}
;
_.this$0 = null;
function ResourceDetailView$20_0(val$resourceComposite){
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(3326, 1, {}, ResourceDetailView$20_0);
_.createView = function createView_59(){
  return new ResourceConfigurationEditView_0(this.val$resourceComposite);
}
;
_.val$resourceComposite = null;
function ResourceDetailView$21_0(val$resourceComposite, val$resource){
  this.val$resourceComposite = val$resourceComposite;
  this.val$resource = val$resource;
}

defineSeed(3327, 1, {}, ResourceDetailView$21_0);
_.createView = function createView_60(){
  return new ResourceConfigurationHistoryListView_0(this.val$resourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONFIGURE_WRITE)), this.val$resource.id);
}
;
_.val$resource = null;
_.val$resourceComposite = null;
function ResourceDetailView$22_0(val$resourceComposite){
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(3328, 1, {}, ResourceDetailView$22_0);
_.createView = function createView_61(){
  return get_21(this.val$resourceComposite);
}
;
_.val$resourceComposite = null;
function ResourceDetailView$23_0(val$resource){
  this.val$resource = val$resource;
}

defineSeed(3329, 1, {}, ResourceDetailView$23_0);
_.createView = function createView_62(){
  return new FullHTMLPane_0('/rhq/resource/content/view-plain.xhtml?id=' + this.val$resource.id);
}
;
_.val$resource = null;
function ResourceDetailView$24_0(val$resource){
  this.val$resource = val$resource;
}

defineSeed(3330, 1, {}, ResourceDetailView$24_0);
_.createView = function createView_63(){
  return new FullHTMLPane_0('/rhq/resource/content/deploy-plain.xhtml?id=' + this.val$resource.id);
}
;
_.val$resource = null;
function ResourceDetailView$25_0(val$resource){
  this.val$resource = val$resource;
}

defineSeed(3331, 1, {}, ResourceDetailView$25_0);
_.createView = function createView_64(){
  return new FullHTMLPane_0('/rhq/resource/content/subscription-plain.xhtml?id=' + this.val$resource.id);
}
;
_.val$resource = null;
function ResourceDetailView$26_0(val$resource){
  this.val$resource = val$resource;
}

defineSeed(3332, 1, {}, ResourceDetailView$26_0);
_.createView = function createView_65(){
  return new FullHTMLPane_0('/rhq/resource/content/history-plain.xhtml?id=' + this.val$resource.id);
}
;
_.val$resource = null;
function $onFailure_39(this$static){
  var message;
  message = new Message_7('Resource with id [' + ($clinit_Enhanced() , '' + this$static.val$resourceId) + '] does not exist or is not accessible', ($clinit_Message$Severity() , Warning));
  $clinit_CoreGUI();
  goToView(($clinit_InventoryView() , VIEW_ID_21).name_0, message, false);
}

function $onSuccess_340(this$static, result){
  var resourceComposite;
  if (result.size_0 == 0) {
    $onFailure_39(this$static, new Exception_1('Resource with id [' + this$static.val$resourceId + '] does not exist.'));
  }
   else {
    resourceComposite = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceComposite);
    $loadResourceType_0(this$static.this$0, resourceComposite, this$static.val$viewPath);
    $addRecentResource(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), valueOf_44(this$static.val$resourceId), new ResourceDetailView$27$1_0(this$static.val$resourceId));
  }
}

function ResourceDetailView$27_0(this$0, val$resourceId, val$viewPath){
  this.this$0 = this$0;
  this.val$resourceId = val$resourceId;
  this.val$viewPath = val$viewPath;
}

defineSeed(3333, 1, {}, ResourceDetailView$27_0);
_.onFailure = function onFailure_354(caught){
  $onFailure_39(this);
}
;
_.onSuccess_0 = function onSuccess_354(result){
  $onSuccess_340(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$resourceId = 0;
_.val$viewPath = null;
function $onSuccess_341(this$static, result){
  debug('Updated recently viewed resources for ' + result + ' with resourceId [' + this$static.val$resourceId + ']');
}

function ResourceDetailView$27$1_0(val$resourceId){
  this.val$resourceId = val$resourceId;
}

defineSeed(3334, 1, {}, ResourceDetailView$27$1_0);
_.onFailure = function onFailure_355(caught){
  $clinit_Log();
  $log_1(logger_0, ($clinit_Level() , SEVERE), 'Unable to update recently viewed resources', caught);
}
;
_.onSuccess_0 = function onSuccess_355(result){
  $onSuccess_341(this, dynamicCast(result, Q$Subject));
}
;
_.val$resourceId = 0;
function ResourceDetailView$28_0(this$0, val$resourceComposite, val$viewPath){
  this.this$0 = this$0;
  this.val$resourceComposite = val$resourceComposite;
  this.val$viewPath = val$viewPath;
}

defineSeed(3335, 1, {}, ResourceDetailView$28_0);
_.onTypesLoaded = function onTypesLoaded_35(type){
  try {
    $setResourceType_0(this.val$resourceComposite.resource, type);
    $updateTabContent_1(this.this$0, this.val$resourceComposite, this.val$viewPath.refresh);
    $selectTab_1(this.this$0, this.this$0.tabName, this.this$0.subTabName, this.val$viewPath);
  }
   finally {
    $notifyViewRenderedListeners(this.this$0);
  }
}
;
_.this$0 = null;
_.val$resourceComposite = null;
_.val$viewPath = null;
function ResourceDetailView$3_0(val$resourceComposite){
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(3336, 1, {}, ResourceDetailView$3_0);
_.createView = function createView_66(){
  return getChildrenOf(this.val$resourceComposite);
}
;
_.val$resourceComposite = null;
function ResourceDetailView$4_0(val$resourceComposite){
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(3337, 1, {}, ResourceDetailView$4_0);
_.createView = function createView_67(){
  return new ChildHistoryView_0(this.val$resourceComposite);
}
;
_.val$resourceComposite = null;
function ResourceDetailView$5_0(val$resourceComposite){
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(3338, 1, {}, ResourceDetailView$5_0);
_.createView = function createView_68(){
  return new PluginConfigurationEditView_0(this.val$resourceComposite);
}
;
_.val$resourceComposite = null;
function ResourceDetailView$6_0(val$resourceComposite){
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(3339, 1, {}, ResourceDetailView$6_0);
_.createView = function createView_69(){
  return new PluginConfigurationHistoryListView_0(this.val$resourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE)), this.val$resourceComposite.resource.id);
}
;
_.val$resourceComposite = null;
function ResourceDetailView$7_0(val$resource, val$canModifyMembership){
  this.val$resource = val$resource;
  this.val$canModifyMembership = val$canModifyMembership;
}

defineSeed(3340, 1, {}, ResourceDetailView$7_0);
_.createView = function createView_70(){
  return getGroupsOf(this.val$resource.id, this.val$canModifyMembership);
}
;
_.val$canModifyMembership = false;
_.val$resource = null;
function ResourceDetailView$8_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3341, 1, {}, ResourceDetailView$8_0);
_.createView = function createView_71(){
  return new ResourceAgentView_0(this.this$0.resourceId.value_0);
}
;
_.this$0 = null;
function ResourceDetailView$9_0(val$resourceComposite){
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(3342, 1, {}, ResourceDetailView$9_0);
_.createView = function createView_72(){
  return get_19(this.val$resourceComposite);
}
;
_.val$resourceComposite = null;
function $copyValues_57(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'detail', from.detail);
  $setAttribute_13(record, 'errorType', from.errorType.name_0);
  $setAttribute_13(record, 'summary', from.summary);
  $setAttribute_14(record, 'timeOccured', new Date_2(from.timeOccurred));
  return record;
}

function $executeFetch_41(this$static, request, response){
  $findResourceErrors(this$static.resourceService, this$static.resourceId, new ResourceErrorsDataSource$1_0(this$static, response, request));
}

function ResourceErrorsDataSource_0(resourceId){
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  this.resourceId = resourceId;
  fields = new ArrayList_0;
  $addFields(this, fields);
}

defineSeed(3343, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceErrorsDataSource_0);
_.copyValues = function copyValues_109(from){
  return null;
}
;
_.copyValues_0 = function copyValues_110(from){
  return $copyValues_57(dynamicCast(from, Q$ResourceError));
}
;
_.executeFetch = function executeFetch_59(request, response, unused){
  $executeFetch_41(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_68(request){
  return null;
}
;
_.resourceId = 0;
_.resourceService = null;
function $onSuccess_342(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ResourceErrorsDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3344, 1, {}, ResourceErrorsDataSource$1_0);
_.onFailure = function onFailure_356(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to find Resource errors for Resource with id [' + ($clinit_RPCDataSource() , '' + this.this$0.resourceId) + '].'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_356(result){
  $onSuccess_342(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $popupDetails(this$static, details){
  var htmlPane, winModal;
  winModal = new Window_1;
  $setTitle(winModal, ($clinit_Enhanced() , 'Component Errors'));
  $setAttribute_24(winModal, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
  $setShowMinimizeButton(winModal, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowMaximizeButton(winModal, TRUE);
  $setIsModal(winModal, TRUE);
  $setShowModalMask(winModal, TRUE);
  $setAutoSize(winModal, TRUE);
  $setAutoCenter(winModal, TRUE);
  $setShowResizer(winModal, TRUE);
  $setCanDragResize_0(winModal, TRUE);
  $centerInPage(winModal);
  $addCloseClickHandler(winModal, new ResourceErrorsView$5_0(this$static, winModal));
  htmlPane = new HTMLPane_0;
  $setMargin(htmlPane, valueOf_44(10));
  $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultWidth', 700):(htmlPane.config_0['defaultWidth'] = 700 , undefined);
  $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultHeight', 500):(htmlPane.config_0['defaultHeight'] = 500 , undefined);
  $isCreated_1(htmlPane)?$setProperty_3(htmlPane, 'contents', '<pre>' + details + '<\/pre>'):(htmlPane.config_0['contents'] = '<pre>' + details + '<\/pre>' , undefined);
  $addItem(winModal, htmlPane);
  winModal.show_0();
}

function $refresh_20(this$static){
  $refresh(this$static, false);
  $refresh_21(this$static.titleBar);
}

function ResourceErrorsView_0(titleBar){
  $clinit_BaseWidget();
  Table_3.call(this, ($clinit_Enhanced() , 'Component Errors'), null);
  this.titleBar = titleBar;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  this.showHeader = false;
}

defineSeed(3345, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ResourceErrorsView_0);
_.configureTable = function configureTable_55(){
  var canModifyResource, errorTypeField, iconField, resourceComposite, resourcePermissions, summaryField, timeField;
  errorTypeField = new ListGridField_3('errorType', ($clinit_Enhanced() , 'Error Type'));
  $setAttribute_13(errorTypeField, 'align', ($clinit_Alignment() , CENTER_0).value_0);
  $setAttribute_8(errorTypeField, 'autoFitWidth', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_13(errorTypeField, 'autoFitWidthApproach', ($clinit_AutoFitWidthApproach() , BOTH).value_0);
  timeField = new ListGridField_3('timeOccured', 'Time');
  $setAttribute_13(timeField, 'type', ($clinit_ListGridFieldType() , DATE_0).value_0);
  $setAttribute_13(timeField, 'align', CENTER_0.value_0);
  timeField.jsObj['width'] = '20%';
  $clinit_TimestampCellFormatter();
  prepareDateField(timeField, getAttribute(timeField.jsObj, 'name'));
  summaryField = new ListGridField_3('summary', 'Summary');
  $setAttribute_13(summaryField, 'align', CENTER_0.value_0);
  $setAttribute_13(summaryField, 'cellAlign', LEFT_0.value_0);
  summaryField.jsObj['width'] = '*';
  iconField = new ListGridField_1('icon');
  $setAttribute_13(iconField, 'type', ICON_0.value_0);
  $setAttribute_13(iconField, 'align', CENTER_0.value_0);
  iconField.jsObj['icon'] = '[SKIN]/Dialog/warn.png';
  iconField.jsObj['cellIcon'] = '[SKIN]/Dialog/warn.png';
  iconField.jsObj['width'] = '50';
  $setAttribute_8(iconField, 'canSort', FALSE);
  $addRecordClickHandler_0(iconField, new ResourceErrorsView$1_0(this));
  $setAttribute_8(iconField, 'showHover', TRUE);
  $setHoverCustomizer_0(iconField, new ResourceErrorsView$2_0);
  $setListGridDoubleClickHandler(this, new ResourceErrorsView$3_0(this));
  $setListGridFields(this, false, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [errorTypeField, timeField, summaryField, iconField]));
  resourceComposite = this.titleBar.resourceComposite;
  resourcePermissions = resourceComposite.resourcePermission.permissions;
  canModifyResource = resourcePermissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE));
  $addTableAction(this, 'Delete', 'Are You Sure?', null, new ResourceErrorsView$4_0(this, canModifyResource?($clinit_TableActionEnablement() , ANY_1):($clinit_TableActionEnablement() , NEVER_1)));
}
;
_.getDefaultSelectionStyle = function getDefaultSelectionStyle_1(){
  return $clinit_SelectionStyle() , MULTIPLE;
}
;
_.refresh_0 = function refresh_38(){
  $refresh_20(this);
}
;
_.titleBar = null;
function ResourceErrorsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3346, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), ResourceErrorsView$1_0);
_.onRecordClick = function onRecordClick_15(event_0){
  var details;
  details = $getAttribute($getRecord_0(event_0), 'detail');
  $popupDetails(this.this$0, details);
}
;
_.this$0 = null;
function ResourceErrorsView$2_0(){
}

defineSeed(3347, 1, {}, ResourceErrorsView$2_0);
_.hoverHTML_0 = function hoverHTML_48(value, record, rowNum, colNum){
  var html;
  html = getAttribute(record.jsObj, 'detail');
  html.length > 80 && (html = '<pre>' + html.substr(0, 80 - 0) + '...<\/pre><p>' + ($clinit_Enhanced() , 'Click the icon for more details') + '<\/p>');
  return html;
}
;
function ResourceErrorsView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3348, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), ResourceErrorsView$3_0);
_.onDoubleClick = function onDoubleClick_14(event_0){
  var details, listGrid, selectedRows;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length > 0) {
    details = getAttribute(selectedRows[0].jsObj, 'detail');
    $popupDetails(this.this$0, details);
  }
}
;
_.this$0 = null;
function ResourceErrorsView$4_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3349, 1608, {}, ResourceErrorsView$4_0);
_.executeAction = function executeAction_80(selection, actionValue){
  var i, record, record$index, record$max, resourceErrorIds;
  if (selection == null || selection.length == 0) {
    return;
  }
  resourceErrorIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selection.length, 1);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    resourceErrorIds[i++] = getAttributeAsInt(record.jsObj, 'id').value_0;
  }
  $deleteResourceErrors(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), resourceErrorIds, new ResourceErrorsView$4$1_0(this, selection));
}
;
_.this$0 = null;
function $onSuccess_343(this$static){
  var msg;
  msg = new Message_7('You have successfully deleted [' + ($clinit_Enhanced() , '' + this$static.val$selection.length) + '] resource error messages.', ($clinit_Message$Severity() , Info));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
  $refresh_20(this$static.this$1.this$0);
}

function ResourceErrorsView$4$1_0(this$1, val$selection){
  this.this$1 = this$1;
  this.val$selection = val$selection;
}

defineSeed(3350, 1, {}, ResourceErrorsView$4$1_0);
_.onFailure = function onFailure_357(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete resource errors'), caught);
}
;
_.onSuccess_0 = function onSuccess_357(result){
  $onSuccess_343(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$selection = null;
function ResourceErrorsView$5_0(this$0, val$winModal){
  this.this$0 = this$0;
  this.val$winModal = val$winModal;
}

defineSeed(3351, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), ResourceErrorsView$5_0);
_.onCloseClick_0 = function onCloseClick_16(event_0){
  $markForDestroy(this.val$winModal);
  $refresh_21(this.this$0.titleBar);
}
;
_.this$0 = null;
_.val$winModal = null;
function $clinit_ResourceTitleBar(){
  $clinit_ResourceTitleBar = nullMethod;
  $clinit_BaseWidget();
  COLLAPSED_TOOLTIP_0 = ($clinit_Enhanced() , 'Click to show more details for this resource.');
  EXPANDED_TOOLTIP_0 = 'Click to hide details for this resource.';
}

function $displayResourceName(this$static, resourceName){
  $equals_6(this$static.resource.name_0, resourceName) || $setName_8(this$static.resource, resourceName);
  $setContents(this$static.title_0, '<span class="SectionHeader">' + escapeHtml(resourceName) + '<\/span>&nbsp;<span class="subtitle">' + this$static.resource.resourceType.name_0 + '<\/span>');
  $markForRedraw(this$static.title_0);
}

function $refresh_21(this$static){
  $findResourceErrors(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), this$static.resourceComposite.resource.id, new ResourceTitleBar$7_0(this$static));
}

function $setResource_2(this$static, resourceComposite, isRefresh){
  var favorites;
  if (!this$static.resourceComposite || resourceComposite.resource.id != this$static.resource.id || isRefresh) {
    this$static.resource = resourceComposite.resource;
    this$static.resourceComposite = resourceComposite;
    $update_1(this$static);
    $displayResourceName(this$static, this$static.resource.name_0);
    favorites = $getPreferenceAsIntegerSet(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), '.dashContent.resourcehealth.resources');
    this$static.favorite = favorites.contains_0(valueOf_44(this$static.resource.id));
    this$static.favoriteButton.setSrc(this$static.favorite?'Favorite_24_Selected.png':'Favorite_24.png');
    this$static.favorite?$setPrompt_0(this$static.favoriteButton, ($clinit_Enhanced() , 'Click to remove this as a favorite')):$setPrompt_0(this$static.favoriteButton, ($clinit_Enhanced() , 'Click to add this as a favorite'));
    this$static.availabilityImage.setSrc(getAvailabilityIconFromAvailTypeAndSize(this$static.resource.currentAvailability.availabilityType, true));
    this$static.badge.setSrc(getResourceIcon(this$static.resource, '24'));
    $markForRedraw(this$static);
  }
}

function $toggleFavoriteLocally_0(this$static){
  var favorites, resourceId;
  this$static.favorite = !this$static.favorite;
  favorites = $getPreferenceAsIntegerSet(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), '.dashContent.resourcehealth.resources');
  resourceId = this$static.resource.id;
  this$static.favorite?favorites.add(valueOf_44(resourceId)):favorites.remove_0(valueOf_44(resourceId));
  return favorites;
}

function $update_1(this$static){
  var child, child$array, child$index, child$max, tagEditorView, widthSpace, wrappedSpacer, criteria;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  this$static.title_0 = new HTMLFlow_0;
  $setWidth_0(this$static.title_0, '*');
  this$static.availabilityImage = new Img_2(getAvailabilityLargeIcon(null), 24, 24);
  $addDoubleClickHandler(this$static.availabilityImage, new ResourceTitleBar$1_0(this$static));
  this$static.favoriteButton = new Img_2('Favorite_24.png', 24, 24);
  $addClickHandler(this$static.favoriteButton, new ResourceTitleBar$2_0(this$static));
  this$static.badge = new Img_2(getResourceIcon_0(($clinit_ResourceCategory() , SERVICE), ($clinit_AvailabilityType() , UP), '24'), 24, 24);
  tagEditorView = new TagEditorView_0(this$static.resource.tags, !this$static.resourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE)), new ResourceTitleBar$3_0(this$static));
  criteria = new ResourceCriteria_0;
  $addFilterId(criteria, valueOf_44(this$static.resource.id));
  criteria.fetchTags = true;
  $findResourcesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), criteria, new ResourceTitleBar$6_0(this$static, tagEditorView));
  this$static.expandCollapseArrow = new Img_2('[SKIN]/ListGrid/row_collapsed.png', 16, 16);
  $setPrompt_0(this$static.expandCollapseArrow, COLLAPSED_TOOLTIP_0);
  $setAttribute_24(this$static.expandCollapseArrow, 'layoutAlign', ($clinit_VerticalAlignment() , BOTTOM_1).value_0, false);
  $addClickHandler(this$static.expandCollapseArrow, new ResourceTitleBar$4_0(this$static));
  this$static.pluginErrors = new Img_2('[SKIN]/Dialog/warn.png', 24, 24);
  $setAttribute_24(this$static.pluginErrors, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  $findResourceErrors(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), this$static.resourceComposite.resource.id, new ResourceTitleBar$7_0(this$static));
  $setPrompt_0(this$static.pluginErrors, ($clinit_Enhanced() , 'Shows managed component errors. Click for details'));
  $addClickHandler(this$static.pluginErrors, new ResourceTitleBar$5_0(this$static));
  $addMember(this$static.top_0, this$static.expandCollapseArrow);
  $addMember(this$static.top_0, this$static.badge);
  $addMember(this$static.top_0, this$static.title_0);
  $addMember(this$static.top_0, this$static.pluginErrors);
  $addMember(this$static.top_0, this$static.availabilityImage);
  $addMember(this$static.top_0, this$static.favoriteButton);
  this$static.detailsForm = new EnhancedHLayout_0;
  $setAttribute_24(this$static.detailsForm, 'width', '100%', true);
  $setHeight(this$static.detailsForm, 10);
  $setAttribute_24(this$static.detailsForm, 'align', ($clinit_Alignment() , LEFT_0).value_0, true);
  this$static.detailsFormSummary = new OverviewForm_0(this$static.resourceComposite, this$static);
  $setAttribute_24(this$static.detailsFormSummary, 'width', '100%', true);
  $setPadding(this$static.detailsFormSummary, valueOf_44(3));
  $setMargin(this$static.detailsFormSummary, valueOf_44(3));
  $setAttribute_24(this$static.detailsFormSummary, 'layoutAlign', LEFT_0.value_0, false);
  this$static.detailsFormSummary.headerEnabled = false;
  this$static.detailsFormSummary.displayCondensed = true;
  $addMember(this$static.detailsForm, this$static.detailsFormSummary);
  widthSpace = new SpacerItem_0;
  $isCreated_2(widthSpace)?$setProperty_6(widthSpace, 'width', 40):(widthSpace.jsObj['width'] = 40 , undefined);
  wrappedSpacer = new DynamicForm_0;
  wrappedSpacer.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [widthSpace]));
  $addMember(this$static.detailsForm, wrappedSpacer);
  $addChild(this$static.details, this$static.detailsForm);
  $hide(this$static.details);
  $addMember(this$static, this$static.top_0);
  ($clinit_CoreGUI() , $clinit_CoreGUI() , enableTagsForUI) && $addMember(this$static, tagEditorView);
  $addMember(this$static, this$static.details);
  $markForRedraw(this$static);
}

function $updateFavoriteButton_0(this$static){
  this$static.favoriteButton.setSrc(this$static.favorite?'Favorite_24_Selected.png':'Favorite_24.png');
  this$static.favorite?$setPrompt_0(this$static.favoriteButton, ($clinit_Enhanced() , 'Click to remove this as a favorite')):$setPrompt_0(this$static.favoriteButton, ($clinit_Enhanced() , 'Click to add this as a favorite'));
}

function ResourceTitleBar_0(){
  $clinit_ResourceTitleBar();
  EnhancedVLayout_0.call(this);
  this.top_0 = new EnhancedHLayout_0;
  $setPadding(this.top_0, valueOf_44(0));
  $setMembersMargin(this.top_0, 0);
  $setHeight(this.top_0, 30);
  this.details = new EnhancedHLayout_0;
  $setAttribute_24(this.details, 'width', '100%', true);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'height', 30):(this.config_0['height'] = 30 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 0):(this.config_0['membersMargin'] = 0 , undefined);
  $setPadding(this, valueOf_44(5));
}

defineSeed(3352, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$ResourceTitleBar, Q$Enhanced]), ResourceTitleBar_0);
_.availabilityImage = null;
_.badge = null;
_.details = null;
_.detailsForm = null;
_.detailsFormSummary = null;
_.expandCollapseArrow = null;
_.favorite = false;
_.favoriteButton = null;
_.pluginErrors = null;
_.resource = null;
_.resourceComposite = null;
_.title_0 = null;
_.top_0 = null;
var COLLAPSED_TOOLTIP_0, EXPANDED_TOOLTIP_0;
function ResourceTitleBar$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3353, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), ResourceTitleBar$1_0);
_.onDoubleClick = function onDoubleClick_15(event_0){
  $refresh_21(this.this$0);
}
;
_.this$0 = null;
function ResourceTitleBar$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3354, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceTitleBar$2_0);
_.onClick = function onClick_150(clickEvent){
  var favorites;
  favorites = $toggleFavoriteLocally_0(this.this$0);
  $setFavoriteResources(($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences), favorites, new ResourceTitleBar$UpdateFavoritesCallback_0(this.this$0));
}
;
_.this$0 = null;
function ResourceTitleBar$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3355, 1, {}, ResourceTitleBar$3_0);
_.tagsChanged = function tagsChanged_4(tags){
  $updateResourceTags(dynamicCast(secure(getInstance_56(), -1), Q$TagGWTServiceAsync), this.this$0.resource.id, tags, new ResourceTitleBar$3$1_0(this, tags));
}
;
_.this$0 = null;
function $onSuccess_344(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('The tags for [' + ($clinit_Enhanced() , this$static.this$1.this$0.resource.name_0) + '] have been updated', ($clinit_Message$Severity() , Info)));
  $setTags(this$static.this$1.this$0.resource, this$static.val$tags);
}

function ResourceTitleBar$3$1_0(this$1, val$tags){
  this.this$1 = this$1;
  this.val$tags = val$tags;
}

defineSeed(3356, 1, {}, ResourceTitleBar$3$1_0);
_.onFailure = function onFailure_358(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update resource tags'), caught);
}
;
_.onSuccess_0 = function onSuccess_358(result){
  $onSuccess_344(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$tags = null;
function ResourceTitleBar$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3357, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceTitleBar$4_0);
_.onClick = function onClick_151(event_0){
  this.collapsed = !this.collapsed;
  if (this.collapsed) {
    this.this$0.expandCollapseArrow.setSrc('[SKIN]/ListGrid/row_collapsed.png');
    $setPrompt_0(this.this$0.expandCollapseArrow, ($clinit_ResourceTitleBar() , COLLAPSED_TOOLTIP_0));
    $hide(this.this$0.details);
  }
   else {
    this.this$0.expandCollapseArrow.setSrc('[SKIN]/ListGrid/row_expanded.png');
    $setPrompt_0(this.this$0.expandCollapseArrow, ($clinit_ResourceTitleBar() , EXPANDED_TOOLTIP_0));
    $show(this.this$0.details);
  }
  $markForRedraw(this.this$0);
}
;
_.collapsed = true;
_.this$0 = null;
function ResourceTitleBar$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3358, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceTitleBar$5_0);
_.onClick = function onClick_152(event_0){
  var disposalReminder, errors, errorsGrid, form, resource, winModal;
  winModal = new Window_1;
  $setShowMinimizeButton(winModal, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowModalMask(winModal, TRUE);
  $setShowCloseButton(winModal, TRUE);
  $isCreated_1(winModal)?$setProperty_3(winModal, 'width', '70%'):(winModal.config_0['width'] = '70%' , undefined);
  $isCreated_1(winModal)?$setProperty_3(winModal, 'height', '70%'):(winModal.config_0['height'] = '70%' , undefined);
  $setIsModal(winModal, TRUE);
  $setShowResizer(winModal, TRUE);
  $setCanDragResize_0(winModal, TRUE);
  $centerInPage(winModal);
  $setTitle(winModal, ($clinit_Enhanced() , 'Component Errors'));
  disposalReminder = new Label_3;
  $isCreated_1(disposalReminder)?$setProperty_0(disposalReminder, 'height', 12):(disposalReminder.config_0['height'] = 12 , undefined);
  $setPadding(disposalReminder, valueOf_44(4));
  $setAttribute_24(disposalReminder, 'align', ($clinit_Alignment() , CENTER_0).value_0, true);
  $setAttribute_24(disposalReminder, 'valign', ($clinit_VerticalAlignment() , CENTER_2).value_0, true);
  $setContents_0(disposalReminder, 'After addressing the issue, you will need to delete the message below to clear the managed component error icon from the previous screen.');
  form = new EnhancedVLayout_0;
  $setAttribute_24(form, 'align', CENTER_2.value_0, true);
  $setLayoutMargin(form, valueOf_44(10));
  $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined);
  $isCreated_1(form)?$setProperty_3(form, 'height', '100%'):(form.config_0['height'] = '100%' , undefined);
  resource = this.this$0.resourceComposite.resource;
  errors = new ResourceErrorsDataSource_0(resource.id);
  errorsGrid = new ResourceErrorsView_0(this.this$0);
  errorsGrid.dataSource_1 = errors;
  $addMember(form, errorsGrid);
  $addItem(winModal, disposalReminder);
  $addItem(winModal, form);
  $setPadding(winModal, valueOf_44(2));
  winModal.show_0();
}
;
_.this$0 = null;
function $onSuccess_345(this$static, result){
  var tags;
  tags = new LinkedHashSet_0;
  $addAll(tags, dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Resource).tags);
  $setTags_1(this$static.val$tagEditorView, tags);
}

function ResourceTitleBar$6_0(this$0, val$tagEditorView){
  this.this$0 = this$0;
  this.val$tagEditorView = val$tagEditorView;
}

defineSeed(3359, 1, {}, ResourceTitleBar$6_0);
_.onFailure = function onFailure_359(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load the tags for [' + ($clinit_Enhanced() , this.this$0.resource.name_0) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_359(result){
  $onSuccess_345(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$tagEditorView = null;
function $onSuccess_346(this$static, result){
  $setAttribute_24(this$static.this$0.pluginErrors, 'visibility', (result.isEmpty_0()?($clinit_Visibility() , HIDDEN_0):($clinit_Visibility() , INHERIT)).value_0, true);
  $markForRedraw(this$static.this$0);
}

function ResourceTitleBar$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3360, 1, {}, ResourceTitleBar$7_0);
_.onFailure = function onFailure_360(caught){
  $setAttribute_24(this.this$0.pluginErrors, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  $handleError_0(($clinit_CoreGUI() , 'Failed to find Resource errors for Resource with id [' + ($clinit_Enhanced() , '' + this.this$0.resourceComposite.resource.id) + '].'), caught);
}
;
_.onSuccess_0 = function onSuccess_360(result){
  $onSuccess_346(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
function $onSuccess_347(this$static){
  var msg;
  this$static.this$0.favorite?(msg = 'You have added [' + ($clinit_Enhanced() , this$static.this$0.resource.name_0) + '] as a favorite'):(msg = 'You have removed [' + ($clinit_Enhanced() , this$static.this$0.resource.name_0) + '] as one of your favorites');
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(msg, ($clinit_Message$Severity() , Info)));
  $updateFavoriteButton_0(this$static.this$0);
}

function ResourceTitleBar$UpdateFavoritesCallback_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3361, 1, {}, ResourceTitleBar$UpdateFavoritesCallback_0);
_.onFailure = function onFailure_361(throwable){
  var msg;
  this.this$0.favorite?(msg = 'Failed to add [' + ($clinit_Enhanced() , this.this$0.resource.name_0) + '] as a favorite'):(msg = 'Failed to remove [' + ($clinit_Enhanced() , this.this$0.resource.name_0) + '] as one of your favorites');
  $handleError_0(($clinit_CoreGUI() , msg), throwable);
  $toggleFavoriteLocally_0(this.this$0);
}
;
_.onSuccess_0 = function onSuccess_361(subject){
  $onSuccess_347(this, dynamicCast(subject, Q$Subject));
}
;
_.this$0 = null;
function $setContent_2(this$static, newContent){
  var child, child$array, child$index, child$max;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.contentCanvas, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  $addChild(this$static.contentCanvas, newContent);
  this$static.contentCanvas.markForRedraw_0();
}

function $setToDetailView(this$static){
  this$static.detailView = new ResourceDetailView_0;
  $addViewRenderedListener(this$static.detailView, new ResourceTopView$1_0(this$static));
  $setContent_2(this$static, this$static.detailView);
  this$static.autoGroupDetailView = null;
}

function ResourceTopView_0(){
  $clinit_ResourceTopView();
  EnhancedHLayout_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  this.treeView = new ResourceTreeView_0;
  $addMember(this, this.treeView);
  this.contentCanvas = new Canvas_1;
  $addMember(this, this.contentCanvas);
  $setToDetailView(this);
}

defineSeed(3362, 1539, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$Enhanced, Q$EnhancedHLayout]), ResourceTopView_0);
_.renderView = function renderView_31(viewPath){
  $disable(this.treeView);
  if ($equals_6('AutoGroup', (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path)) {
    !this.autoGroupDetailView && (this.autoGroupDetailView = new ResourceGroupDetailView_0('Resource/AutoGroup') , $addViewRenderedListener(this.autoGroupDetailView, new ResourceTopView$2_0(this)) , $setContent_2(this, this.autoGroupDetailView) , this.detailView = null , undefined);
    $renderView_11(this.treeView, viewPath);
    $renderView_9(this.autoGroupDetailView, (++viewPath.index_0 , viewPath));
  }
   else {
    !this.detailView && $setToDetailView(this);
    $renderView_11(this.treeView, viewPath);
    $renderView_8(this.detailView, viewPath);
  }
}
;
_.autoGroupDetailView = null;
_.contentCanvas = null;
_.detailView = null;
_.treeView = null;
function ResourceTopView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3363, 1, makeCastMap([Q$AbstractTwoLevelTabSetView$ViewRenderedListener]), ResourceTopView$1_0);
_.onViewRendered = function onViewRendered(){
  $enable(this.this$0.treeView);
}
;
_.this$0 = null;
function ResourceTopView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3364, 1, makeCastMap([Q$AbstractTwoLevelTabSetView$ViewRenderedListener]), ResourceTopView$2_0);
_.onViewRendered = function onViewRendered_0(){
  $enable(this.this$0.treeView);
}
;
_.this$0 = null;
function $clinit_ResourceTreeDatasource(){
  $clinit_ResourceTreeDatasource = nullMethod;
  $clinit_CoreGUI();
}

function $executeFetch_42(this$static, requestId, request, response){
  var criteria, parentResourceId, temp;
  $show(this$static.loadingLabel);
  parentResourceId = $getAttribute($getCriteria(request), 'parentId');
  if (parentResourceId == null) {
    if (this$static.initialData) {
      $clinit_Log();
      $fine_0(logger_0, 'ResourceTreeDatasource: Loading initial data...');
      temp = this$static.initialData;
      this$static.initialData = null;
      $loadResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), temp, of_0(($clinit_ResourceTypeRepository$MetadataType() , operations_0), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceTypeRepository$MetadataType, [children_0, subCategory_0])), new ResourceTreeDatasource$2_0(this$static, response, requestId));
    }
     else {
      response.jsObj['status'] = -1;
      $processResponse(this$static, requestId, response);
    }
    $hide(this$static.loadingLabel);
  }
   else {
    $clinit_Log();
    $fine_0(logger_0, 'ResourceTreeDatasource: Loading Resource [' + parentResourceId + ']...');
    criteria = new ResourceCriteria_0;
    $addFilterParentResourceId(criteria, valueOf_44(__parseAndValidateInt(parentResourceId)));
    $addSortName_0(criteria, ($clinit_PageOrdering() , ASC));
    $findResourcesByCriteriaBounded(this$static.resourceService, criteria, new ResourceTreeDatasource$1_0(this$static, response, requestId));
  }
}

function $processIncomingData(this$static, result, response, requestId){
  $loadResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), result, of_0(($clinit_ResourceTypeRepository$MetadataType() , operations_0), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceTypeRepository$MetadataType, [children_0, subCategory_0])), new ResourceTreeDatasource$2_0(this$static, response, requestId));
}

function ResourceTreeDatasource_0(initialData, lockedData, treeGrid, loadingLabel){
  $clinit_ResourceTreeDatasource();
  var descriptionDataField, idDataField, nameDataField, parentIdField;
  DataSource_0.call(this);
  this.resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  $setClientOnly(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_1(this, 'dataProtocol', ($clinit_DSProtocol() , CLIENTCUSTOM).value_0);
  $setAttribute_1(this, 'dataFormat', ($clinit_DSDataFormat() , CUSTOM).value_0);
  this.initialData = initialData;
  this.lockedData = lockedData?lockedData:new ArrayList_0;
  this.treeGrid = treeGrid;
  this.loadingLabel = loadingLabel;
  idDataField = new DataSourceTextField_1('id', 'ID');
  $setAttribute_8(idDataField, 'primaryKey', TRUE);
  nameDataField = new DataSourceTextField_1('name', 'Name');
  $setAttribute_8(nameDataField, 'canEdit', FALSE);
  descriptionDataField = new DataSourceTextField_1('description', 'Description');
  $setAttribute_8(descriptionDataField, 'canEdit', FALSE);
  parentIdField = new DataSourceTextField_1('parentId', 'Parent ID');
  parentIdField.jsObj['foreignKey'] = 'id';
  $setDropExtraFields(this, FALSE);
  $setFields(this, initValues(_3Lcom_smartgwt_client_data_DataSourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$DataSourceField, [idDataField, nameDataField, descriptionDataField]));
}

function addSubCategoryNodes(allNodes, allNodeIds, resource){
  var insertAt, parentResource, subCategory, subCategoryNode, subCategoryNodeId, type;
  parentResource = resource.parentResource;
  type = resource.resourceType;
  subCategory = type.subCategory;
  insertAt = allNodes.size_0;
  do {
    subCategoryNodeId = 'subcat_' + subCategory.id + '_' + parentResource.id;
    if (!allNodeIds.map.containsKey(subCategoryNodeId)) {
      subCategoryNode = new ResourceTreeDatasource$SubCategoryTreeNode_0(subCategory, parentResource);
      $add_6(allNodeIds, subCategoryNodeId);
      $add_2(allNodes, insertAt, subCategoryNode);
    }
  }
   while (subCategory = subCategory.parentSubCategory);
}

function buildNodes(resources, lockedData, treeGrid){
  $clinit_ResourceTreeDatasource();
  var node, resource, resource$iterator, resourceNodes, result;
  if (!treeGrid || !getOrCreateRef_13($getAttributeAsJavaScriptObject_1(treeGrid, 'data'))) {
    throw new ViewChangedException_1(($clinit_ResourceTopView() , VIEW_ID_24).name_0 + '/*');
  }
  resourceNodes = new ArrayList_1(resources.size_1());
  for (resource$iterator = resources.iterator(); resource$iterator.hasNext();) {
    resource = dynamicCast(resource$iterator.next_0(), Q$Resource);
    node = new ResourceTreeDatasource$ResourceTreeNode_0(resource, $indexOf_0(lockedData, resource, 0) != -1);
    setCheck(resourceNodes.array, resourceNodes.size_0++, node);
  }
  result = introduceTypeAndCategoryNodes(resourceNodes, treeGrid);
  return dynamicCast($toArray_1(result, initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, result.size_0, 0)), Q$TreeNode_$1);
}

function introduceTypeAndCategoryNodes(resourceNodes, treeGrid){
  var allNodeIds, allNodes, ambiguouslyNamedAutoGroupNodes, ambiguouslyNamedAutogroupNode, autoGroupNodeID, autoGroupNodesByName, autogroupNode, autogroupNode$iterator, parentID, parentNodeIdToAutoGroupsByName, parentResource, parentResourceNode, parentResourceNodeId, resource, resourceNode, resourceNode$iterator, tree, typeName, name_0;
  allNodes = new ArrayList_1(resourceNodes.size_0);
  allNodeIds = new HashSet_1(resourceNodes.size_0 * 2);
  parentNodeIdToAutoGroupsByName = new HashMap_0;
  ambiguouslyNamedAutoGroupNodes = new HashSet_0;
  for (resourceNode$iterator = new AbstractList$IteratorImpl_0(resourceNodes); resourceNode$iterator.i < resourceNode$iterator.this$0_0.size_1();) {
    resourceNode = dynamicCast($next_0(resourceNode$iterator), Q$ResourceTreeDatasource$ResourceTreeNode);
    if ($contains_2(allNodeIds, getAttribute(resourceNode.jsObj, 'id'))) {
      $clinit_Log();
      $fine_0(logger_0, 'Duplicate ResourceTreeNode - Skipping: ' + resourceNode);
      continue;
    }
    resource = resourceNode.resource;
    if (resourceNode.parentSubCategory) {
      addSubCategoryNodes(allNodes, allNodeIds, resource);
    }
     else if (resourceNode.parentAutoGroup) {
      parentResource = resource.parentResource;
      parentResourceNodeId = '' + parentResource.id;
      tree = getOrCreateRef_13($getAttributeAsJavaScriptObject_1(treeGrid, 'data'));
      parentResourceNode = $findById(tree, parentResourceNodeId);
      if (parentResourceNode) {
        parentResource = dynamicCast(parentResourceNode, Q$ResourceTreeDatasource$ResourceTreeNode).resource;
        resource.parentResource = parentResource;
        $updateAncestryForResource(resource);
      }
      null == parentResource.name_0 && ($clinit_Log() , $severe_0(logger_0, 'AutoGroup node creation using invalid parent resource: ' + parentResource));
      autoGroupNodeID = getAttribute(resourceNode.jsObj, 'parentId');
      if (!allNodeIds.map.containsKey(autoGroupNodeID)) {
        autogroupNode = new ResourceTreeDatasource$AutoGroupTreeNode_0(resource);
        parentID = getAttribute(autogroupNode.jsObj, 'parentId');
        autoGroupNodesByName = dynamicCast(parentNodeIdToAutoGroupsByName.get_2(parentID), Q$Map);
        if (!autoGroupNodesByName) {
          autoGroupNodesByName = new HashMap_0;
          parentNodeIdToAutoGroupsByName.put(parentID, autoGroupNodesByName);
        }
         else {
          ambiguouslyNamedAutogroupNode = dynamicCast(autoGroupNodesByName.get_2(getAttribute(autogroupNode.jsObj, 'name')), Q$ResourceTreeDatasource$AutoGroupTreeNode);
          if (ambiguouslyNamedAutogroupNode) {
            $add_6(ambiguouslyNamedAutoGroupNodes, ambiguouslyNamedAutogroupNode);
            $add_6(ambiguouslyNamedAutoGroupNodes, autogroupNode);
          }
        }
        autoGroupNodesByName.put(getAttribute(autogroupNode.jsObj, 'name'), autogroupNode);
        autogroupNode.parentSubcategory && addSubCategoryNodes(allNodes, allNodeIds, resource);
        $add_6(allNodeIds, autoGroupNodeID);
        setCheck(allNodes.array, allNodes.size_0++, autogroupNode);
      }
    }
    $add_6(allNodeIds, getAttribute(resourceNode.jsObj, 'id'));
    setCheck(allNodes.array, allNodes.size_0++, resourceNode);
  }
  for (autogroupNode$iterator = $iterator($keySet(ambiguouslyNamedAutoGroupNodes.map)); autogroupNode$iterator.val$outerIter.hasNext();) {
    autogroupNode = dynamicCast($next_1(autogroupNode$iterator), Q$ResourceTreeDatasource$AutoGroupTreeNode);
    typeName = pluralize(autogroupNode.resourceType.name_0);
    name_0 = typeName + ' (' + autogroupNode.resourceType.plugin + ' ' + ($clinit_ResourceTreeDatasource() , 'Plugin').toLowerCase() + ')';
    autogroupNode.jsObj['name'] = name_0;
    name_0 != null && getAttribute(autogroupNode.jsObj, 'title') == null && (autogroupNode.jsObj['title'] = name_0 , undefined);
  }
  return allNodes;
}

defineSeed(3365, 337, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceTreeDatasource_0);
_.transformRequest_0 = function transformRequest_2(request){
  var requestId, response;
  requestId = getAttribute(request.jsObj, 'requestId');
  response = new DSResponse_0;
  $setAttribute_12(response, 'clientContext', getAttributeAsObject(request.jsObj, 'clientContext'));
  response.jsObj['status'] = 0;
  dynamicCast(getEnum(($clinit_DSOperationType() , $clinit_DSOperationType() , $VALUES_9), getAttribute(request.jsObj, 'operationType')), Q$DSOperationType).ordinal == 0 && $executeFetch_42(this, requestId, request, response);
  return getAttributeAsJavaScriptObject(request.jsObj, 'data');
}
;
_.initialData = null;
_.loadingLabel = null;
_.lockedData = null;
_.treeGrid = null;
function $onFailure_40(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_ResourceTreeDatasource() , 'Failed to load children for node'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse(this$static.this$0, this$static.val$requestId, this$static.val$response);
  $hide(this$static.this$0.loadingLabel);
}

function $onSuccess_348(this$static, result){
  $processIncomingData(this$static.this$0, result, this$static.val$response, this$static.val$requestId);
}

function ResourceTreeDatasource$1_0(this$0, val$response, val$requestId){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$requestId = val$requestId;
}

defineSeed(3366, 1, {}, ResourceTreeDatasource$1_0);
_.onFailure = function onFailure_362(caught){
  $onFailure_40(this, caught);
}
;
_.onSuccess_0 = function onSuccess_362(result){
  $onSuccess_348(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
_.val$requestId = null;
_.val$response = null;
function ResourceTreeDatasource$2_0(this$0, val$response, val$requestId){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$requestId = val$requestId;
}

defineSeed(3367, 1, {}, ResourceTreeDatasource$2_0);
_.onResourceTypeLoaded = function onResourceTypeLoaded(result){
  var treeNodes;
  treeNodes = buildNodes(result, this.this$0.lockedData, this.this$0.treeGrid);
  $setAttribute_17(this.val$response, 'data', treeNodes);
  $processResponse(this.this$0, this.val$requestId, this.val$response);
  $hide(this.this$0.loadingLabel);
}
;
_.this$0 = null;
_.val$requestId = null;
_.val$response = null;
function $getBackingGroupName(this$static){
  return this$static.parentResource.name_0 + ' ( ' + this$static.resourceType.name_0 + ' )';
}

function ResourceTreeDatasource$AutoGroupTreeNode_0(resource){
  var id, name_0, parentId, subcategory;
  EnhancedTreeNode_0.call(this);
  this.parentResource = resource.parentResource;
  this.resourceType = resource.resourceType;
  id = idOf(resource);
  this.jsObj['id'] = id;
  subcategory = this.resourceType.subCategory;
  if (subcategory) {
    parentId = idOf_1(subcategory, this.parentResource);
    this.parentSubcategory = true;
  }
   else {
    parentId = '' + this.parentResource.id;
  }
  this.jsObj['parentId'] = parentId;
  name_0 = pluralize(this.resourceType.name_0);
  this.jsObj['name'] = name_0;
  name_0 != null && getAttribute(this.jsObj, 'title') == null && (this.jsObj['title'] = name_0 , undefined);
  $setAttribute_13(this, 'description', this.resourceType.description);
}

function idOf(resource){
  var parentResource;
  parentResource = resource.parentResource;
  return idOf_0(parentResource, resource.resourceType);
}

function idOf_0(parentResource, resourceType){
  return parentResource?'autogroup_' + resourceType.id + '_' + parentResource.id:null;
}

defineSeed(3368, 2399, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$EnhancedTreeNode, Q$ResourceTreeDatasource$AutoGroupTreeNode]), ResourceTreeDatasource$AutoGroupTreeNode_0);
_.parentResource = null;
_.parentSubcategory = false;
_.resourceType = null;
function ResourceTreeDatasource$ResourceTreeNode_0(resource, isLocked){
  var childTypes, description, escapedDescription, escapedName, id, name_0, parentId, parentResource, subCategory;
  EnhancedTreeNode_0.call(this);
  this.resource = resource;
  this.isLocked = isLocked;
  id = '' + resource.id;
  this.jsObj['id'] = id;
  parentResource = resource.parentResource;
  parentId = null;
  if (parentResource) {
    if (resource.resourceType.singleton) {
      subCategory = resource.resourceType.subCategory;
      if (subCategory) {
        parentId = 'subcat_' + subCategory.id + '_' + parentResource.id;
        this.parentSubCategory = true;
      }
       else 
        parentId = '' + parentResource.id;
    }
     else {
      parentId = idOf(resource);
      this.parentAutoGroup = true;
    }
  }
  this.jsObj['parentId'] = parentId;
  name_0 = resource.name_0;
  escapedName = escapeHtml(name_0);
  this.jsObj['name'] = escapedName;
  escapedName != null && getAttribute(this.jsObj, 'title') == null && (this.jsObj['title'] = escapedName , undefined);
  description = resource.description;
  escapedDescription = escapeHtml(description);
  this.jsObj['description'] = escapedDescription;
  childTypes = resource.resourceType.childResourceTypes;
  $setAttribute_16(this, 'isFolder', !!childTypes && !childTypes.isEmpty_0());
}

defineSeed(3369, 2399, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$EnhancedTreeNode, Q$ResourceTreeDatasource$ResourceTreeNode]), ResourceTreeDatasource$ResourceTreeNode_0);
_.isLocked = false;
_.parentAutoGroup = false;
_.parentSubCategory = false;
_.resource = null;
function ResourceTreeDatasource$SubCategoryTreeNode_0(category, parentResource){
  var id, name_0, parentCategory, parentId;
  EnhancedTreeNode_0.call(this);
  id = 'subcat_' + category.id + '_' + parentResource.id;
  this.jsObj['id'] = id;
  parentCategory = category.parentSubCategory;
  parentId = parentCategory?'subcat_' + parentCategory.id + '_' + parentResource.id:'' + parentResource.id;
  this.jsObj['parentId'] = parentId;
  name_0 = category.displayName;
  this.jsObj['name'] = name_0;
  name_0 != null && getAttribute(this.jsObj, 'title') == null && (this.jsObj['title'] = name_0 , undefined);
  $setAttribute_13(this, 'description', category.description);
}

function idOf_1(category, parentResource){
  return 'subcat_' + category.id + '_' + parentResource.id;
}

defineSeed(3370, 2399, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$EnhancedTreeNode, Q$ResourceTreeDatasource$SubCategoryTreeNode]), ResourceTreeDatasource$SubCategoryTreeNode_0);
function $addMenu(this$static, name_0, enabled, singletonChildren, resource, displayNameMap, isCreate){
  var filteredSubMenu, menu, subMenu;
  menu = new MenuItem_1(name_0);
  if (enabled) {
    subMenu = new Menu_0;
    singletonChildren = !singletonChildren?new ArrayList_0:singletonChildren;
    filteredSubMenu = $checkForSingletons(singletonChildren, resource, displayNameMap, subMenu, isCreate);
    $setAttribute_5(menu, 'submenu', !filteredSubMenu?null:$getOrCreateJsObj_0(filteredSubMenu));
  }
   else {
    $setAttribute_8(menu, 'enabled', ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  }
  $addItem_0(this$static.resourceContextMenu, menu);
}

function $addNewMetric(id, selectedView, resourceGraphElements){
  var $e0, b, baseUrl, e;
  baseUrl = '/resource/common/monitor/visibility/IndicatorCharts.do';
  baseUrl += '?id=' + id;
  baseUrl += '&view=' + selectedView;
  baseUrl += '&action=addChart&metric=' + resourceGraphElements;
  b = new RequestBuilder_0(($clinit_RequestBuilder() , GET), baseUrl);
  try {
    $setCallback(b, new ResourceTreeView$15_0(baseUrl));
    throwIfNull('callback', b.callback);
    $doSend(b, b.requestData, b.callback);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$RequestException)) {
      e = $e0;
      $clinit_Log();
      $log_1(logger_0, ($clinit_Level() , FINEST), 'Error adding Metric:' + baseUrl, e);
    }
     else 
      throw $e0;
  }
}

function $buildAndShowResourceContextMenu(this$static, node, resourceComposite, resourceType){
  var canCreate, childResources, childResourcesEnabled, creatableChildTypes, criteria, definitionMap, displayName, displayName$iterator, displayNameMap, hasCreatableTypes, hasImportableTypes, importableChildTypes, o, o$iterator, opSubMenu, operationDefinition, operationItem, operations, operationsEnabled, ordered, pluginConfigEnabled, pluginConfiguration, refresh, resource, resourceConfigEnabled, resourceConfiguration, resourcePermission, singletonChildTypes, measurements, measurementsSubMenu, criteria_0;
  resource = resourceComposite.resource;
  resourcePermission = resourceComposite.resourcePermission;
  $setAttribute_25(this$static.resourceContextMenu, 'items', initValues(_3Lcom_smartgwt_client_widgets_menu_MenuItem_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$MenuItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$MenuItem, [new MenuItem_1(resource.name_0)]), true);
  $addItem_0(this$static.resourceContextMenu, new MenuItem_1('Type: ' + ($clinit_Enhanced() , resourceType.name_0)));
  $addItem_0(this$static.resourceContextMenu, new MenuItemSeparator_0);
  refresh = new MenuItem_1('Refresh');
  $addClickHandler_3(refresh, new ResourceTreeView$7_0(this$static, node));
  $addItem_0(this$static.resourceContextMenu, refresh);
  $addItem_0(this$static.resourceContextMenu, new MenuItemSeparator_0);
  childResources = new MenuItem_1('Child Resources');
  childResourcesEnabled = !!resourceType.childResourceTypes && !resourceType.childResourceTypes.isEmpty_0();
  $setAttribute_8(childResources, 'enabled', ($clinit_Boolean() , childResourcesEnabled?TRUE:FALSE));
  childResourcesEnabled && $addClickHandler_3(childResources, new ResourceTreeView$8_0(resource));
  $addItem_0(this$static.resourceContextMenu, childResources);
  pluginConfiguration = new MenuItem_1('Connection Settings');
  pluginConfigEnabled = !!resourceType.pluginConfigurationDefinition;
  $setAttribute_8(pluginConfiguration, 'enabled', pluginConfigEnabled?TRUE:FALSE);
  pluginConfigEnabled && $addClickHandler_3(pluginConfiguration, new ResourceTreeView$9_0(resource));
  $addItem_0(this$static.resourceContextMenu, pluginConfiguration);
  resourceConfiguration = new MenuItem_1('Resource Configuration');
  resourceConfigEnabled = resourcePermission.permissions.contains_0(($clinit_Permission() , CONFIGURE_READ)) && !!resourceType.resourceConfigurationDefinition;
  $setAttribute_8(resourceConfiguration, 'enabled', resourceConfigEnabled?TRUE:FALSE);
  resourceConfigEnabled && $addClickHandler_3(resourceConfiguration, new ResourceTreeView$10_0(resource));
  $addItem_0(this$static.resourceContextMenu, resourceConfiguration);
  $addItem_0(this$static.resourceContextMenu, new MenuItemSeparator_0);
  operations = new MenuItem_1('Operations');
  operationsEnabled = resourcePermission.permissions.contains_0(CONTROL_0) && !!resourceType.operationDefinitions && !resourceType.operationDefinitions.isEmpty_0();
  $setAttribute_8(operations, 'enabled', operationsEnabled?TRUE:FALSE);
  if (operationsEnabled) {
    opSubMenu = new Menu_0;
    ordered = new TreeSet_0;
    definitionMap = new HashMap_0;
    for (o$iterator = resourceType.operationDefinitions.iterator(); o$iterator.hasNext();) {
      o = dynamicCast(o$iterator.next_0(), Q$OperationDefinition);
      $add_8(ordered, o.displayName);
      definitionMap.put(o.displayName, o);
    }
    for (displayName$iterator = $iterator($keySet(ordered.map)); displayName$iterator.val$outerIter.hasNext();) {
      displayName = dynamicCast($next_1(displayName$iterator), Q$String);
      operationDefinition = dynamicCast(definitionMap.get_2(displayName), Q$OperationDefinition);
      operationItem = new MenuItem_1(operationDefinition.displayName);
      $addClickHandler_3(operationItem, new ResourceTreeView$11_0(resource, operationDefinition));
      $addItem_0(opSubMenu, operationItem);
    }
    $setAttribute_5(operations, 'submenu', !opSubMenu?null:$getOrCreateJsObj_0(opSubMenu));
  }
  $addItem_0(this$static.resourceContextMenu, operations);
  $addItem_0(this$static.resourceContextMenu, (measurements = new MenuItem_1('Measurements') , measurementsSubMenu = new Menu_0 , criteria_0 = new DashboardCriteria_0 , $findDashboardsByCriteria(dynamicCast(secure(getInstance_39(), -1), Q$DashboardGWTServiceAsync), criteria_0, new ResourceTreeView$14_0(resourceType, measurementsSubMenu, resource)) , $setAttribute_5(measurements, 'submenu', !measurementsSubMenu?null:$getOrCreateJsObj_0(measurementsSubMenu)) , measurements));
  creatableChildTypes = getCreatableChildTypes_0(resourceType);
  importableChildTypes = getImportableChildTypes_0(resourceType);
  hasCreatableTypes = creatableChildTypes.map.size_0 != 0;
  hasImportableTypes = importableChildTypes.map.size_0 != 0;
  canCreate = resourcePermission.permissions.contains_0(CREATE_CHILD_RESOURCES);
  singletonChildTypes = getSingletonChildTypes_0(resourceType);
  if (canCreate && singletonChildTypes.length > 0 && (hasCreatableTypes || hasImportableTypes)) {
    criteria = new ResourceCriteria_0;
    $addFilterParentResourceId(criteria, valueOf_44(resource.id));
    criteria.filterResourceTypeIds = new Arrays$ArrayList_0(singletonChildTypes);
    $findResourcesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), criteria, new ResourceTreeView$12_0(this$static, hasCreatableTypes, creatableChildTypes, resource, hasImportableTypes, importableChildTypes));
  }
   else if (canCreate && singletonChildTypes.length == 0 && (hasCreatableTypes || hasImportableTypes)) {
    if (hasCreatableTypes) {
      displayNameMap = getDisplayNames_0(creatableChildTypes);
      $addMenu(this$static, 'Create Child', true, null, resource, displayNameMap, true);
    }
    if (hasImportableTypes) {
      displayNameMap = getDisplayNames_0(importableChildTypes);
      $addMenu(this$static, 'Import', true, null, resource, displayNameMap, false);
    }
    $showContextMenu(this$static.resourceContextMenu);
  }
   else {
    !canCreate && hasCreatableTypes && $addMenu(this$static, 'Create Child', false, null, null, null, true);
    !canCreate && hasImportableTypes && $addMenu(this$static, 'Import', false, null, null, null, false);
    $showContextMenu(this$static.resourceContextMenu);
  }
}

function $buildTree_0(this$static){
  this$static.treeGrid = new CustomResourceTreeGrid_0;
  $setAttribute_24(this$static.treeGrid, 'openerImage', 'resources/dir.png', false);
  $setAttribute_23(this$static.treeGrid, 'openerIconSize', valueOf_44(16));
  $setAutoFetchData_0(this$static.treeGrid, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_22(this$static.treeGrid, 'animateFolders', FALSE, true);
  $setAttribute_24(this$static.treeGrid, 'selectionType', ($clinit_SelectionStyle() , SINGLE).value_0, true);
  $setShowRollOver_2(this$static.treeGrid, FALSE);
  $setSortField(this$static.treeGrid);
  $setShowHeader_0(this$static.treeGrid, FALSE);
  $setLoadingDataMessage(this$static.treeGrid);
  $setLeaveScrollbarGap(this$static.treeGrid, FALSE);
  this$static.resourceContextMenu = new Menu_0;
  this$static.autoGroupContextMenu = new ResourceGroupContextMenu_0;
  $addSelectionChangedHandler(this$static.treeGrid, new ResourceTreeView$1_0(this$static));
  $addNodeContextClickHandler(this$static.treeGrid, new ResourceTreeView$2_0(this$static));
  $addDataArrivedHandler_1(this$static.treeGrid, new ResourceTreeView$3_0(this$static));
}

function $checkForSingletons(singletonChildren, resource, displayNameMap, subMenu, isCreate){
  var child, child$iterator, displayName, displayName$iterator, displayNames, exists, itemToAdd, type;
  displayNames = $keySet(displayNameMap);
  for (displayName$iterator = $iterator(displayNames); displayName$iterator.val$outerIter.hasNext();) {
    displayName = dynamicCast($next_1(displayName$iterator), Q$String);
    itemToAdd = new MenuItem_1(displayName);
    type = dynamicCast($get_5(displayNameMap, displayName), Q$ResourceType);
    exists = false;
    if (type.singleton) {
      for (child$iterator = singletonChildren.iterator(); child$iterator.hasNext();) {
        child = dynamicCast(child$iterator.next_0(), Q$Resource);
        exists = $equals_40(child.resourceType, $get_5(displayNameMap, displayName));
        if (exists) {
          break;
        }
      }
    }
    if (!exists) {
      $addClickHandler_3(itemToAdd, new ResourceTreeView$13_0(isCreate, resource, type));
      $addItem_0(subMenu, itemToAdd);
    }
  }
  return subMenu;
}

function $getAutoGroupBackingGroup(this$static, agNode, callback){
  var childIds, children, criteria, i, resourceGroupService, size;
  resourceGroupService = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
  children = $getChildren(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), agNode);
  childIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, children.length, 1);
  for (i = 0 , size = children.length; i < size; ++i) {
    childIds[i] = dynamicCast(children[i], Q$ResourceTreeDatasource$ResourceTreeNode).resource.id;
  }
  criteria = new ResourceGroupCriteria_0;
  $addFilterPrivate(criteria, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $addFilterResourceTypeId_1(criteria, valueOf_44(agNode.resourceType.id));
  $addFilterAutoGroupParentResourceId_0(criteria, valueOf_44(agNode.parentResource.id));
  $addFilterVisible(criteria, FALSE);
  $show(this$static.loadingLabel);
  $findResourceGroupsByCriteria(resourceGroupService, criteria, new ResourceTreeView$4_0(this$static, callback, agNode, resourceGroupService, childIds));
}

function $getScheduleDefinitionId(resource, definitionName){
  var definition, i, id, located, schedule, schedules;
  id = -1;
  if (resource.schedules) {
    located = false;
    schedules = initDim(_3Lorg_rhq_core_domain_measurement_MeasurementSchedule_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$MeasurementSchedule, resource.schedules.size_1(), 0);
    resource.schedules.toArray_0(schedules);
    for (i = 0; !located && i < resource.schedules.size_1(); ++i) {
      schedule = schedules[i];
      definition = schedule.definition;
      if (!!definition && $equals_6(definition.name_0, definitionName)) {
        located = true;
        id = schedule.id;
      }
    }
  }
  return id;
}

function $loadTree_1(this$static, selectedResourceId, updateSelection, autogroup, callback){
  var resourceService;
  updateSelection && (this$static.selectedNodeId = '' + selectedResourceId);
  resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  $show(this$static.loadingLabel);
  $getResourceLineageAndSiblings(resourceService, selectedResourceId, new ResourceTreeView$16_0(this$static, selectedResourceId, updateSelection, autogroup, callback));
}

function $renderView_11(this$static, viewPath){
  var autoGroupId, autoGroupIdString, currentViewId, currentViewIdPath, resourceId, resourceIdString;
  currentViewId = viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId);
  currentViewIdPath = currentViewId.path;
  if ($equals_6('AutoGroup', currentViewIdPath)) {
    currentViewId = dynamicCast($get_0(viewPath.viewPath, viewPath.index_0 + 1), Q$ViewId);
    autoGroupIdString = currentViewId.path;
    autoGroupId = valueOf_44(__parseAndValidateInt(autoGroupIdString));
    $setSelectedAutoGroup(this$static, autoGroupId);
  }
   else {
    resourceIdString = currentViewId.path;
    resourceId = valueOf_44(__parseAndValidateInt(resourceIdString));
    $setSelectedResource(this$static, resourceId.value_0, viewPath.refresh);
  }
}

function $setRootResource(this$static, rootResource){
  this$static.rootResource = rootResource;
}

function $setSelectedAutoGroup(this$static, selectedAutoGroupId){
  var criteria, resourceGroupService, selectedNode;
  selectedNode = dynamicCast(this$static.autoGroupNodeMap.get_2(selectedAutoGroupId), Q$ResourceTreeDatasource$AutoGroupTreeNode);
  if (!!this$static.treeGrid && !!getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')) && !!selectedNode) {
    this$static.selectedNodeId = getAttribute(selectedNode.jsObj, 'id');
    $updateSelection(this$static, false);
  }
   else {
    resourceGroupService = dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync);
    criteria = new ResourceGroupCriteria_0;
    criteria.filterId = selectedAutoGroupId;
    $addFilterVisible(criteria, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    criteria.fetchResourceType = true;
    $show(this$static.loadingLabel);
    $findResourceGroupsByCriteria(resourceGroupService, criteria, new ResourceTreeView$17_0(this$static, selectedAutoGroupId));
  }
}

function $setSelectedResource(this$static, selectedResourceId, isRefresh){
  this$static.selectedNodeId = '' + selectedResourceId;
  !!this$static.treeGrid && !!getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')) && !!$findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), this$static.selectedNodeId)?$updateSelection(this$static, isRefresh):$loadTree_1(this$static, selectedResourceId, true, false, null);
}

function $showContextMenu_3(this$static, agNode){
  $getAutoGroupBackingGroup(this$static, agNode, new ResourceTreeView$5_0(this$static, agNode));
}

function $showContextMenu_4(this$static, node){
  var criteria, resource, resourceId;
  resource = node.resource;
  resourceId = resource.id;
  criteria = new ResourceCriteria_0;
  $addFilterId(criteria, valueOf_44(resourceId));
  criteria.fetchSchedules = true;
  $findResourceCompositesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), criteria, new ResourceTreeView$6_0(this$static, resourceId, resource, node));
}

function $updateSelection(this$static, isRefresh){
  var parents, selectedNode;
  if (!!this$static.treeGrid && !!getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')) && !!(selectedNode = $findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), this$static.selectedNodeId))) {
    parents = $getParents(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), selectedNode);
    $openFolders(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), parents);
    $openFolder(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), selectedNode);
    if (!selectedNode.equals$($getSelectedRecord_0(this$static.treeGrid))) {
      $deselectAllRecords(this$static.treeGrid);
      $selectRecord(this$static.treeGrid, selectedNode);
    }
    isRefresh && $reloadChildren(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.treeGrid, 'data')), selectedNode);
    $markForRedraw_0(this$static.treeGrid);
  }
}

function ResourceTreeView_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.autoGroupNodeMap = new HashMap_0;
  $isCreated_1(this)?$setProperty_3(this, 'width', '250'):(this.config_0['width'] = '250' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $setShowResizeBar(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
}

function contextMenuRefresh(treeGrid, node){
  $clinit_BaseWidget();
  var refreshNode, tree;
  $clinit_CoreGUI();
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
  tree = getOrCreateRef_13($getAttributeAsJavaScriptObject_1(treeGrid, 'data'));
  refreshNode = $getParent(tree, node);
  if (null == getAttribute(refreshNode.jsObj, 'name')) {
    $reloadChildren(tree, node);
    return;
  }
  while (!instanceOf(refreshNode, Q$ResourceTreeDatasource$ResourceTreeNode)) {
    refreshNode = $getParent(tree, refreshNode);
  }
  $reloadChildren(tree, refreshNode);
}

function getCreatableChildTypes_0(type){
  var childType, childType$iterator, childTypes, results;
  results = new TreeSet_0;
  childTypes = type.childResourceTypes;
  for (childType$iterator = childTypes.iterator(); childType$iterator.hasNext();) {
    childType = dynamicCast(childType$iterator.next_0(), Q$ResourceType);
    (childType.createDeletePolicy == ($clinit_CreateDeletePolicy() , BOTH_1) || childType.createDeletePolicy == CREATE_ONLY) && $put_2(results.map, childType, ($clinit_Boolean() , FALSE)) == null;
  }
  return results;
}

function getDisplayNames_0(types){
  $clinit_BaseWidget();
  var allNames, displayName, repeatedNames, results, type, type$iterator, typeName;
  allNames = new HashSet_0;
  repeatedNames = new HashSet_0;
  for (type$iterator = $iterator($keySet(types.map)); type$iterator.val$outerIter.hasNext();) {
    type = dynamicCast($next_1(type$iterator), Q$ResourceType);
    typeName = type.name_0;
    allNames.map.containsKey(typeName)?$add_6(repeatedNames, typeName):$add_6(allNames, typeName);
  }
  results = new TreeMap_0;
  for (type$iterator = $iterator($keySet(types.map)); type$iterator.val$outerIter.hasNext();) {
    type = dynamicCast($next_1(type$iterator), Q$ResourceType);
    displayName = type.name_0;
    $contains_2(repeatedNames, type.name_0) && (displayName += ' (' + type.plugin + ' plugin)');
    $put_2(results, displayName, type);
  }
  return results;
}

function getImportableChildTypes_0(type){
  var childType, childType$iterator, childTypes, results;
  results = new TreeSet_0;
  childTypes = type.childResourceTypes;
  for (childType$iterator = childTypes.iterator(); childType$iterator.hasNext();) {
    childType = dynamicCast(childType$iterator.next_0(), Q$ResourceType);
    childType.supportsManualAdd && $put_2(results.map, childType, ($clinit_Boolean() , FALSE)) == null;
  }
  return results;
}

function getSingletonChildTypes_0(type){
  var childType, childType$iterator, childTypes, results;
  results = new TreeSet_0;
  childTypes = type.childResourceTypes;
  for (childType$iterator = childTypes.iterator(); childType$iterator.hasNext();) {
    childType = dynamicCast(childType$iterator.next_0(), Q$ResourceType);
    childType.singleton && $add_8(results, valueOf_44(childType.id));
  }
  return dynamicCast(results.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, results.map.size_0, 0)), Q$Integer_$1);
}

defineSeed(3371, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ResourceTreeView_0);
_.onInit = function onInit_65(){
  this.loadingLabel = new Label_4(($clinit_Enhanced() , 'Loading...'));
  $setIcon_1(this.loadingLabel, 'ajax-loader.gif');
  $setHeight(this.loadingLabel, 20);
  $hide(this.loadingLabel);
  $addMember(this, this.loadingLabel);
}
;
_.autoGroupContextMenu = null;
_.loadingLabel = null;
_.resourceContextMenu = null;
_.rootResource = null;
_.selectedNodeId = null;
_.treeGrid = null;
function ResourceTreeView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3372, 1, makeCastMap([Q$EventHandler, Q$SelectionChangedHandler]), ResourceTreeView$1_0);
_.onSelectionChanged = function onSelectionChanged_10(selectionEvent){
  var $e0, agNode, currentViewPath, re, resourceNode, selectedRecord, viewPath;
  if (!$isRightButtonDown() && $getState(selectionEvent)) {
    selectedRecord = $getSelectedRecord_0(this.this$0.treeGrid);
    if (instanceOf(selectedRecord, Q$ResourceTreeDatasource$ResourceTreeNode)) {
      resourceNode = dynamicCast(selectedRecord, Q$ResourceTreeDatasource$ResourceTreeNode);
      if (resourceNode.isLocked) {
        $deselectRecord(this.this$0.treeGrid, resourceNode);
        null != this.this$0.selectedNodeId && $selectRecord(this.this$0.treeGrid, $findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$0.treeGrid, 'data')), this.this$0.selectedNodeId));
      }
       else {
        $clinit_Log();
        $info_0(logger_0, 'Resource Node selected in tree: ' + selectedRecord);
        this.this$0.selectedNodeId = getAttribute(resourceNode.jsObj, 'id');
        viewPath = 'Resource/' + resourceNode.resource.id;
        currentViewPath = ($clinit_History() , impl_0?token_1 == null?'':token_1:'');
        currentViewPath.indexOf(viewPath) == 0 || ($clinit_CoreGUI() , goToView(viewPath, null, false));
      }
    }
     else if (instanceOf(selectedRecord, Q$ResourceTreeDatasource$AutoGroupTreeNode)) {
      $clinit_Log();
      $info_0(logger_0, 'AutoGroup Node selected in tree: ' + selectedRecord);
      agNode = dynamicCast(selectedRecord, Q$ResourceTreeDatasource$AutoGroupTreeNode);
      this.this$0.selectedNodeId = getAttribute(agNode.jsObj, 'id');
      $disable(this.this$0);
      try {
        $show(this.this$0.loadingLabel);
        $getAutoGroupBackingGroup(this.this$0, agNode, new ResourceTreeView$1$1_0(this));
      }
       catch ($e0) {
        $e0 = caught_0($e0);
        if (instanceOf($e0, Q$RuntimeException)) {
          re = $e0;
          $hide(this.this$0.loadingLabel);
          $enable(this.this$0);
          $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to select this node'), re);
        }
         else 
          throw $e0;
      }
    }
     else {
      $deselectRecord(this.this$0.treeGrid, selectedRecord);
      null != this.this$0.selectedNodeId && $selectRecord(this.this$0.treeGrid, $findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$0.treeGrid, 'data')), this.this$0.selectedNodeId));
    }
  }
}
;
_.this$0 = null;
function $onSuccess_349(this$static, result){
  var viewPath, currentViewPath;
  $hide(this$static.this$1.this$0.loadingLabel);
  viewPath = 'Resource/AutoGroup/' + result.id;
  currentViewPath = ($clinit_History() , impl_0?token_1 == null?'':token_1:'');
  currentViewPath.indexOf(viewPath) == 0 || ($clinit_CoreGUI() , goToView(viewPath, null, false));
  $enable(this$static.this$1.this$0);
}

function ResourceTreeView$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3373, 1, {}, ResourceTreeView$1$1_0);
_.onFailure = function onFailure_363(caught){
  $hide(this.this$1.this$0.loadingLabel);
  $enable(this.this$1.this$0);
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to select this node'), caught);
}
;
_.onSuccess_0 = function onSuccess_363(result){
  $onSuccess_349(this, dynamicCast(result, Q$ResourceGroup));
}
;
_.this$1 = null;
function ResourceTreeView$10_0(val$resource){
  this.val$resource = val$resource;
}

defineSeed(3374, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceTreeView$10_0);
_.onClick_1 = function onClick_153(event_0){
  $clinit_CoreGUI();
  goToView(getResourceTabLink(this.val$resource.id, 'Configuration', 'Current'), null, false);
}
;
_.val$resource = null;
function ResourceTreeView$11_0(val$resource, val$operationDefinition){
  this.val$resource = val$resource;
  this.val$operationDefinition = val$operationDefinition;
}

defineSeed(3375, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceTreeView$11_0);
_.onClick_1 = function onClick_154(event_0){
  var viewPath;
  viewPath = getResourceTabLink(this.val$resource.id, 'Operations', 'Schedules') + '/0/' + this.val$operationDefinition.id;
  $clinit_CoreGUI();
  goToView(viewPath, null, false);
}
;
_.val$operationDefinition = null;
_.val$resource = null;
function $onSuccess_350(this$static, singletonChildren){
  var displayNameMap;
  if (this$static.val$hasCreatableTypes) {
    displayNameMap = getDisplayNames_0(this$static.val$creatableChildTypes);
    $addMenu(this$static.this$0, ($clinit_Enhanced() , 'Create Child'), true, singletonChildren, this$static.val$resource, displayNameMap, true);
  }
  if (this$static.val$hasImportableTypes) {
    displayNameMap = getDisplayNames_0(this$static.val$importableChildTypes);
    $addMenu(this$static.this$0, ($clinit_Enhanced() , 'Import'), true, singletonChildren, this$static.val$resource, displayNameMap, false);
  }
  $showContextMenu(this$static.this$0.resourceContextMenu);
}

function ResourceTreeView$12_0(this$0, val$hasCreatableTypes, val$creatableChildTypes, val$resource, val$hasImportableTypes, val$importableChildTypes){
  this.this$0 = this$0;
  this.val$hasCreatableTypes = val$hasCreatableTypes;
  this.val$creatableChildTypes = val$creatableChildTypes;
  this.val$resource = val$resource;
  this.val$hasImportableTypes = val$hasImportableTypes;
  this.val$importableChildTypes = val$importableChildTypes;
}

defineSeed(3376, 1, {}, ResourceTreeView$12_0);
_.onFailure = function onFailure_364(caught){
  error_1('Error resources with parentId:' + this.val$resource.id, caught);
  $showContextMenu(this.this$0.resourceContextMenu);
}
;
_.onSuccess_0 = function onSuccess_364(singletonChildren){
  $onSuccess_350(this, dynamicCast(singletonChildren, Q$PageList));
}
;
_.this$0 = null;
_.val$creatableChildTypes = null;
_.val$hasCreatableTypes = false;
_.val$hasImportableTypes = false;
_.val$importableChildTypes = null;
_.val$resource = null;
function ResourceTreeView$13_0(val$isCreate, val$resource, val$type){
  this.val$isCreate = val$isCreate;
  this.val$resource = val$resource;
  this.val$type = val$type;
}

defineSeed(3377, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceTreeView$13_0);
_.onClick_1 = function onClick_155(event_0){
  this.val$isCreate?showCreateWizard(this.val$resource, this.val$type):showImportWizard(this.val$resource, this.val$type);
}
;
_.val$isCreate = false;
_.val$resource = null;
_.val$type = null;
function $onSuccess_351(this$static, result){
  var addGraphItem, addToDBItem, currentViewPath, d, d$iterator, def, defItem, defSubItem, definitionMap, displayName, displayName$iterator, m_0, m$iterator, ordered;
  ordered = new TreeSet_0;
  definitionMap = new HashMap_0;
  for (m$iterator = this$static.val$type.metricDefinitions.iterator(); m$iterator.hasNext();) {
    m_0 = dynamicCast(m$iterator.next_0(), Q$MeasurementDefinition);
    $add_8(ordered, m_0.displayName);
    definitionMap.put(m_0.displayName, m_0);
  }
  for (displayName$iterator = $iterator($keySet(ordered.map)); displayName$iterator.val$outerIter.hasNext();) {
    displayName = dynamicCast($next_1(displayName$iterator), Q$String);
    def = dynamicCast(definitionMap.get_2(displayName), Q$MeasurementDefinition);
    if (def.dataType == ($clinit_DataType() , MEASUREMENT)) {
      defItem = new MenuItem_1(def.displayName);
      $addItem_0(this$static.val$measurementsSubMenu, defItem);
      defSubItem = new Menu_0;
      $setAttribute_5(defItem, 'submenu', !defSubItem?null:$getOrCreateJsObj_0(defSubItem));
      for (d$iterator = new AbstractList$IteratorImpl_0(result); d$iterator.i < d$iterator.this$0_0.size_1();) {
        d = dynamicCast($next_0(d$iterator), Q$Dashboard);
        addToDBItem = new MenuItem_1('Add chart to dashboard [' + ($clinit_Enhanced() , d.name_0) + ']');
        $addItem_0(defSubItem, addToDBItem);
        $addClickHandler_3(addToDBItem, new ResourceTreeView$14$1_0(this$static.val$resource, def, d));
      }
      currentViewPath = ($clinit_History() , impl_0?token_1 == null?'':token_1:'');
      if (currentViewPath.indexOf('Monitoring/NewGraphs') != -1) {
        addGraphItem = new MenuItem_1(($clinit_Enhanced() , 'Add Graph to Monitor View'));
        $addItem_0(defSubItem, addGraphItem);
        $addClickHandler_3(addGraphItem, new ResourceTreeView$14$2_0(this$static.val$resource, def));
      }
    }
  }
}

function ResourceTreeView$14_0(val$type, val$measurementsSubMenu, val$resource){
  this.val$type = val$type;
  this.val$measurementsSubMenu = val$measurementsSubMenu;
  this.val$resource = val$resource;
}

defineSeed(3378, 1, {}, ResourceTreeView$14_0);
_.onFailure = function onFailure_365(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load user dashboards'), caught);
}
;
_.onSuccess_0 = function onSuccess_365(result){
  $onSuccess_351(this, dynamicCast(result, Q$PageList));
}
;
_.val$measurementsSubMenu = null;
_.val$resource = null;
_.val$type = null;
function ResourceTreeView$14$1_0(val$resource, val$def, val$d){
  this.val$resource = val$resource;
  this.val$def = val$def;
  this.val$d = val$d;
}

defineSeed(3379, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceTreeView$14$1_0);
_.onClick_1 = function onClick_156(menuItemClickEvent){
  var p;
  p = new DashboardPortlet_1(($clinit_Enhanced() , 'Resource Metric Graph'), 'ResourceMetricD3', 250);
  $put_4(p.configuration, new PropertySimple_1('resourceId', valueOf_44(this.val$resource.id)));
  $put_4(p.configuration, new PropertySimple_1('definitionId', valueOf_44(this.val$def.id)));
  $addPortlet(this.val$d, p);
  $storeDashboard(dynamicCast(secure(getInstance_39(), -1), Q$DashboardGWTServiceAsync), this.val$d, new ResourceTreeView$14$1$1_0);
}
;
_.val$d = null;
_.val$def = null;
_.val$resource = null;
function $onSuccess_352(result){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('You have saved dashboard [' + ($clinit_Enhanced() , result.name_0) + ']', ($clinit_Message$Severity() , Info)));
}

function ResourceTreeView$14$1$1_0(){
}

defineSeed(3380, 1, {}, ResourceTreeView$14$1$1_0);
_.onFailure = function onFailure_366(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to save the dashboard'), caught);
}
;
_.onSuccess_0 = function onSuccess_366(result){
  $onSuccess_352(dynamicCast(result, Q$Dashboard));
}
;
function ResourceTreeView$14$2_0(val$resource, val$def){
  this.val$resource = val$resource;
  this.val$def = val$def;
}

defineSeed(3381, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceTreeView$14$2_0);
_.onClick_1 = function onClick_157(menuItemClickEvent){
  var c, resourceGraphElements, sid;
  if ($getScheduleDefinitionId(this.val$resource, this.val$def.name_0) > -1) {
    resourceGraphElements = this.val$resource.id + ',' + $getScheduleDefinitionId(this.val$resource, this.val$def.name_0);
    sid = ($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0).id;
    c = new SubjectCriteria_0;
    $addFilterId(c, valueOf_44(sid));
    $findSubjectsByCriteria(dynamicCast(secure(getInstance_54(), -1), Q$SubjectGWTServiceAsync), c, new ResourceTreeView$14$2$1_0(this.val$resource, resourceGraphElements, sid));
  }
}
;
_.val$def = null;
_.val$resource = null;
function $onSuccess_353(this$static, result){
  var mPreferences, selectedView, uPreferences;
  if (result.size_0 > 0) {
    uPreferences = new UserPreferences_0(dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Subject));
    mPreferences = new MeasurementUserPreferences_0(uPreferences);
    selectedView = $getSelectedView(mPreferences, '' + this$static.val$resource.id);
    $addNewMetric('' + this$static.val$resource.id, selectedView, this$static.val$resourceGraphElements);
  }
   else {
    trace('Error obtaining subject with id:' + this$static.val$sid);
  }
}

function ResourceTreeView$14$2$1_0(val$resource, val$resourceGraphElements, val$sid){
  this.val$resource = val$resource;
  this.val$resourceGraphElements = val$resourceGraphElements;
  this.val$sid = val$sid;
}

defineSeed(3382, 1, {}, ResourceTreeView$14$2$1_0);
_.onFailure = function onFailure_367(caught){
  trace_0('Error obtaining subject with id:' + this.val$sid, caught);
}
;
_.onSuccess_0 = function onSuccess_367(result){
  $onSuccess_353(this, dynamicCast(result, Q$PageList));
}
;
_.val$resource = null;
_.val$resourceGraphElements = null;
_.val$sid = 0;
function ResourceTreeView$15_0(val$url){
  this.val$url = val$url;
}

defineSeed(3383, 1, {}, ResourceTreeView$15_0);
_.onError = function onError_5(request, t){
  trace_0('Error adding Metric:' + this.val$url, t);
}
;
_.onResponseReceived = function onResponseReceived_5(request, response){
  var currentViewPath;
  trace('Successfully submitted request to add graph to view:' + this.val$url);
  currentViewPath = ($clinit_History() , impl_0?token_1 == null?'':token_1:'');
  $clinit_CoreGUI();
  goToView(currentViewPath, null, true);
}
;
_.val$url = null;
function $onFailure_41(this$static, caught){
  var resourceDoesNotExist;
  $hide(this$static.this$0.loadingLabel);
  resourceDoesNotExist = caught.getMessage().indexOf('ResourceNotFoundException') != -1;
  resourceDoesNotExist || $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load root for tree'), caught);
}

function $onSuccess_354(this$static, result){
  var dataSource, lineage, lockedData, r, r$iterator, root;
  root = dynamicCast(result.get_0(0), Q$ResourceLineageComposite).resource;
  lineage = new ArrayList_1(result.size_1());
  lockedData = new ArrayList_0;
  for (r$iterator = result.iterator(); r$iterator.hasNext();) {
    r = dynamicCast(r$iterator.next_0(), Q$ResourceLineageComposite);
    $add_3(lineage, r.resource);
    if (r.isLocked) {
      if (r.resource.id == this$static.val$selectedResourceId) {
        return;
      }
      $add_3(lockedData, r.resource);
    }
  }
  if ($equals_39(root, this$static.this$0.rootResource)) {
    this$static.val$autogroup?!!this$static.val$callback && $onSuccess_356(this$static.val$callback):$loadResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), lineage, of(($clinit_ResourceTypeRepository$MetadataType() , subCategory_0)), new ResourceTreeView$16$2_0(this$static, lineage, lockedData, this$static.val$updateSelection));
  }
   else {
    !!this$static.this$0.treeGrid && $destroy(this$static.this$0.treeGrid);
    $buildTree_0(this$static.this$0);
    $setRootResource(this$static.this$0, root);
    dataSource = new ResourceTreeDatasource_0(lineage, lockedData, this$static.this$0.treeGrid, this$static.this$0.loadingLabel);
    $setAttribute_20(this$static.this$0.treeGrid, 'dataSource', $getOrCreateJsObj(dataSource), true);
    $addMember(this$static.this$0, this$static.this$0.treeGrid);
    $fetchData_4(this$static.this$0.treeGrid, $getCriteria_0(this$static.this$0.treeGrid), new ResourceTreeView$16$1_0(this$static, this$static.val$updateSelection, this$static.val$callback));
    this$static.val$updateSelection && $updateSelection(this$static.this$0, false);
  }
}

function ResourceTreeView$16_0(this$0, val$selectedResourceId, val$updateSelection, val$autogroup, val$callback){
  this.this$0 = this$0;
  this.val$selectedResourceId = val$selectedResourceId;
  this.val$updateSelection = val$updateSelection;
  this.val$autogroup = val$autogroup;
  this.val$callback = val$callback;
}

defineSeed(3384, 1, {}, ResourceTreeView$16_0);
_.onFailure = function onFailure_368(caught){
  $onFailure_41(this, caught);
}
;
_.onSuccess_0 = function onSuccess_368(result){
  $onSuccess_354(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
_.val$autogroup = false;
_.val$callback = null;
_.val$selectedResourceId = 0;
_.val$updateSelection = false;
function ResourceTreeView$16$1_0(this$1, val$updateSelection, val$callback){
  this.this$1 = this$1;
  this.val$updateSelection = val$updateSelection;
  this.val$callback = val$callback;
}

defineSeed(3385, 1, {}, ResourceTreeView$16$1_0);
_.execute_2 = function execute_57(response, rawData, request){
  $clinit_Log();
  $info_0(logger_0, 'Done fetching data for tree.');
  $hide(this.this$1.this$0.loadingLabel);
  this.val$updateSelection && $updateSelection(this.this$1.this$0, false);
  !!this.val$callback && $onSuccess_356(this.val$callback);
}
;
_.this$1 = null;
_.val$callback = null;
_.val$updateSelection = false;
function ResourceTreeView$16$2_0(this$1, val$lineage, val$lockedData, val$updateSelection){
  this.this$1 = this$1;
  this.val$lineage = val$lineage;
  this.val$lockedData = val$lockedData;
  this.val$updateSelection = val$updateSelection;
}

defineSeed(3386, 1, {}, ResourceTreeView$16$2_0);
_.onResourceTypeLoaded = function onResourceTypeLoaded_0(result){
  var selectedNode;
  $linkNodes(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$1.this$0.treeGrid, 'data')), buildNodes(this.val$lineage, this.val$lockedData, this.this$1.this$0.treeGrid));
  $hide(this.this$1.this$0.loadingLabel);
  selectedNode = $findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$1.this$0.treeGrid, 'data')), this.this$1.this$0.selectedNodeId);
  !!selectedNode && this.val$updateSelection?$updateSelection(this.this$1.this$0, false):$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'Failed to select this node'), ($clinit_Message$Severity() , Warning)));
}
;
_.this$1 = null;
_.val$lineage = null;
_.val$lockedData = null;
_.val$updateSelection = false;
function $onSuccess_355(this$static, result){
  var backingGroup, updateSelection;
  backingGroup = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroup);
  updateSelection = this$static.this$0.selectedNodeId != null && this$static.this$0.selectedNodeId != '' + this$static.val$selectedAutoGroupId.value_0;
  $loadTree_1(this$static.this$0, backingGroup.autoGroupParentResource.id, updateSelection, true, new ResourceTreeView$17$1_0(this$static, backingGroup));
}

function ResourceTreeView$17_0(this$0, val$selectedAutoGroupId){
  this.this$0 = this$0;
  this.val$selectedAutoGroupId = val$selectedAutoGroupId;
}

defineSeed(3387, 1, {}, ResourceTreeView$17_0);
_.onFailure = function onFailure_369(caught){
  $hide(this.this$0.loadingLabel);
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load data for this node'), caught);
}
;
_.onSuccess_0 = function onSuccess_369(result){
  $onSuccess_355(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$selectedAutoGroupId = null;
function $onSuccess_356(this$static){
  var agNode;
  this$static.this$1.this$0.selectedNodeId = idOf_0(this$static.val$backingGroup.autoGroupParentResource, this$static.val$backingGroup.resourceType);
  agNode = dynamicCast($findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.this$1.this$0.treeGrid, 'data')), this$static.this$1.this$0.selectedNodeId), Q$ResourceTreeDatasource$AutoGroupTreeNode);
  this$static.this$1.this$0.autoGroupNodeMap.put(valueOf_44(this$static.val$backingGroup.id), agNode);
  $updateSelection(this$static.this$1.this$0, false);
  $hide(this$static.this$1.this$0.loadingLabel);
}

function ResourceTreeView$17$1_0(this$1, val$backingGroup){
  this.this$1 = this$1;
  this.val$backingGroup = val$backingGroup;
}

defineSeed(3388, 1, {}, ResourceTreeView$17$1_0);
_.onFailure = function onFailure_370(caught){
  $hide(this.this$1.this$0.loadingLabel);
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load children for node'), caught);
}
;
_.onSuccess_0 = function onSuccess_370(arg){
  $onSuccess_356(this, throwClassCastExceptionUnlessNull(arg));
}
;
_.this$1 = null;
_.val$backingGroup = null;
function ResourceTreeView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3389, 1, makeCastMap([Q$EventHandler, Q$NodeContextClickHandler]), ResourceTreeView$2_0);
_.onNodeContextClick = function onNodeContextClick_0(event_0){
  var eventNode, selectedNode;
  event_0.cancel = true;
  $deselectRecord(this.this$0.treeGrid, $getNode_0(event_0));
  eventNode = $getNode_0(event_0);
  if (null != this.this$0.selectedNodeId) {
    selectedNode = $findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$0.treeGrid, 'data')), this.this$0.selectedNodeId);
    eventNode.equals$(selectedNode) || $selectRecord(this.this$0.treeGrid, selectedNode);
  }
  instanceOf(eventNode, Q$ResourceTreeDatasource$AutoGroupTreeNode)?$showContextMenu_3(this.this$0, dynamicCast(eventNode, Q$ResourceTreeDatasource$AutoGroupTreeNode)):instanceOf(eventNode, Q$ResourceTreeDatasource$ResourceTreeNode) && (dynamicCast(eventNode, Q$ResourceTreeDatasource$ResourceTreeNode).isLocked || $showContextMenu_4(this.this$0, dynamicCast(eventNode, Q$ResourceTreeDatasource$ResourceTreeNode)));
}
;
_.this$0 = null;
function ResourceTreeView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3390, 1, makeCastMap([Q$EventHandler, Q$DataArrivedHandler_1]), ResourceTreeView$3_0);
_.this$0 = null;
function $onSuccess_357(this$static, result){
  var backingGroup, backingGroupName;
  if (result.size_0 == 0) {
    backingGroupName = $getBackingGroupName(this$static.val$agNode);
    backingGroup = new ResourceGroup_2(backingGroupName);
    $setAutoGroupParentResource(backingGroup, this$static.val$agNode.parentResource);
    $setResourceType_1(backingGroup, this$static.val$agNode.resourceType);
    backingGroup.visible = false;
    $createPrivateResourceGroup(this$static.val$resourceGroupService, backingGroup, this$static.val$childIds, new ResourceTreeView$4$1_0(this$static, this$static.val$callback, this$static.val$agNode));
  }
   else {
    backingGroup = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceGroup);
    this$static.this$0.autoGroupNodeMap.put(valueOf_44(backingGroup.id), this$static.val$agNode);
    $setAssignedResources(this$static.val$resourceGroupService, backingGroup.id, this$static.val$childIds, false, new ResourceTreeView$4$2_0(this$static, this$static.val$callback, backingGroup));
  }
}

function ResourceTreeView$4_0(this$0, val$callback, val$agNode, val$resourceGroupService, val$childIds){
  this.this$0 = this$0;
  this.val$callback = val$callback;
  this.val$agNode = val$agNode;
  this.val$resourceGroupService = val$resourceGroupService;
  this.val$childIds = val$childIds;
}

defineSeed(3391, 1, {}, ResourceTreeView$4_0);
_.onFailure = function onFailure_371(caught){
  $hide(this.this$0.loadingLabel);
  this.val$callback.onFailure(new RuntimeException_2(($clinit_Enhanced() , 'Failed to load data for this node'), caught));
}
;
_.onSuccess_0 = function onSuccess_371(result){
  $onSuccess_357(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$agNode = null;
_.val$callback = null;
_.val$childIds = null;
_.val$resourceGroupService = null;
function $onSuccess_358(this$static, result){
  $hide(this$static.this$1.this$0.loadingLabel);
  this$static.this$1.this$0.autoGroupNodeMap.put(valueOf_44(result.id), this$static.val$agNode);
  this$static.val$callback.onSuccess_0(result);
}

function ResourceTreeView$4$1_0(this$1, val$callback, val$agNode){
  this.this$1 = this$1;
  this.val$callback = val$callback;
  this.val$agNode = val$agNode;
}

defineSeed(3392, 1, {}, ResourceTreeView$4$1_0);
_.onFailure = function onFailure_372(caught){
  $hide(this.this$1.this$0.loadingLabel);
  this.val$callback.onFailure(new RuntimeException_2(($clinit_Enhanced() , 'Failed to create view for this node'), caught));
}
;
_.onSuccess_0 = function onSuccess_372(result){
  $onSuccess_358(this, dynamicCast(result, Q$ResourceGroup));
}
;
_.this$1 = null;
_.val$agNode = null;
_.val$callback = null;
function $onSuccess_359(this$static){
  $hide(this$static.this$1.this$0.loadingLabel);
  this$static.val$callback.onSuccess_0(this$static.val$backingGroup);
}

function ResourceTreeView$4$2_0(this$1, val$callback, val$backingGroup){
  this.this$1 = this$1;
  this.val$callback = val$callback;
  this.val$backingGroup = val$backingGroup;
}

defineSeed(3393, 1, {}, ResourceTreeView$4$2_0);
_.onFailure = function onFailure_373(caught){
  $hide(this.this$1.this$0.loadingLabel);
  this.val$callback.onFailure(new RuntimeException_2(($clinit_Enhanced() , 'Failed to update view for this node'), caught));
}
;
_.onSuccess_0 = function onSuccess_373(result){
  $onSuccess_359(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$backingGroup = null;
_.val$callback = null;
function $onSuccess_360(this$static, result){
  $showContextMenu_0(this$static.this$0.autoGroupContextMenu, this$static.this$0.treeGrid, this$static.val$agNode, result);
}

function ResourceTreeView$5_0(this$0, val$agNode){
  this.this$0 = this$0;
  this.val$agNode = val$agNode;
}

defineSeed(3394, 1, {}, ResourceTreeView$5_0);
_.onFailure = function onFailure_374(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to select this node'), caught);
}
;
_.onSuccess_0 = function onSuccess_374(result){
  $onSuccess_360(this, dynamicCast(result, Q$ResourceGroup));
}
;
_.this$0 = null;
_.val$agNode = null;
function $onFailure_42(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Resource with id [' + ($clinit_Enhanced() , '' + this$static.val$resourceId) + '] does not exist or is not accessible', ($clinit_Message$Severity() , Warning)));
  goToView(($clinit_InventoryView() , VIEW_ID_21).name_0, null, false);
}

function $onSuccess_361(this$static, result){
  var resourceComposite, type;
  if (result.size_0 == 0) {
    $onFailure_42(this$static, new Exception_1('Resource with id [' + ($clinit_Enhanced() , '' + this$static.val$resourceId) + '] does not exist or is not accessible'));
  }
   else {
    resourceComposite = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceComposite);
    type = this$static.val$resource.resourceType;
    $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(type.id), of_0(($clinit_ResourceTypeRepository$MetadataType() , operations_0), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$MetadataType_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ResourceTypeRepository$MetadataType, [children_0, subCategory_0, pluginConfigurationDefinition_0, resourceConfigurationDefinition_0, measurements_0])), new ResourceTreeView$6$1_0(this$static, this$static.val$node, resourceComposite));
  }
}

function ResourceTreeView$6_0(this$0, val$resourceId, val$resource, val$node){
  this.this$0 = this$0;
  this.val$resourceId = val$resourceId;
  this.val$resource = val$resource;
  this.val$node = val$node;
}

defineSeed(3395, 1, {}, ResourceTreeView$6_0);
_.onFailure = function onFailure_375(caught){
  $onFailure_42(this);
}
;
_.onSuccess_0 = function onSuccess_375(result){
  $onSuccess_361(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$node = null;
_.val$resource = null;
_.val$resourceId = 0;
function ResourceTreeView$6$1_0(this$1, val$node, val$resourceComposite){
  this.this$1 = this$1;
  this.val$node = val$node;
  this.val$resourceComposite = val$resourceComposite;
}

defineSeed(3396, 1, {}, ResourceTreeView$6$1_0);
_.onTypesLoaded = function onTypesLoaded_36(type){
  $buildAndShowResourceContextMenu(this.this$1.this$0, this.val$node, this.val$resourceComposite, type);
}
;
_.this$1 = null;
_.val$node = null;
_.val$resourceComposite = null;
function ResourceTreeView$7_0(this$0, val$node){
  this.this$0 = this$0;
  this.val$node = val$node;
}

defineSeed(3397, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceTreeView$7_0);
_.onClick_1 = function onClick_158(event_0){
  contextMenuRefresh(this.this$0.treeGrid, this.val$node);
}
;
_.this$0 = null;
_.val$node = null;
function ResourceTreeView$8_0(val$resource){
  this.val$resource = val$resource;
}

defineSeed(3398, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceTreeView$8_0);
_.onClick_1 = function onClick_159(event_0){
  $clinit_CoreGUI();
  goToView(getResourceTabLink(this.val$resource.id, 'Inventory', 'Children'), null, false);
}
;
_.val$resource = null;
function ResourceTreeView$9_0(val$resource){
  this.val$resource = val$resource;
}

defineSeed(3399, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_1]), ResourceTreeView$9_0);
_.onClick_1 = function onClick_160(event_0){
  $clinit_CoreGUI();
  goToView(getResourceTabLink(this.val$resource.id, 'Inventory', 'ConnectionSettings'), null, false);
}
;
_.val$resource = null;
function AbstractConfigurationHistoryDataSource$1_0(){
}

defineSeed(3400, 1, {}, AbstractConfigurationHistoryDataSource$1_0);
_.hoverHTML_0 = function hoverHTML_49(value, record, rowNum, colNum){
  $clinit_Boolean();
  if ($equalsIgnoreCase('true', getAttribute(record.jsObj, 'currentConfig'))) {
    return $clinit_RPCDataSource() , 'This is the current configuration';
  }
  return null;
}
;
function AbstractConfigurationHistoryDataSource$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3401, 1, {}, AbstractConfigurationHistoryDataSource$2_0);
_.format_1 = function format_71(value, listGridRecord, i, i1){
  var status_0;
  status_0 = valueOf_73(toString__devirtual$(value));
  return imgHTML_0(this.this$0.getConfigurationUpdateStatusIcon(status_0), 16, 16);
}
;
_.this$0 = null;
function AbstractConfigurationHistoryDataSource$3_0(){
}

defineSeed(3402, 1, {}, AbstractConfigurationHistoryDataSource$3_0);
_.hoverHTML_0 = function hoverHTML_50(value, record, rowNum, colNum){
  var html;
  html = $getStatusHtmlString_0(record);
  return html;
}
;
function AbstractConfigurationHistoryDataSource$4_0(){
}

defineSeed(3403, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), AbstractConfigurationHistoryDataSource$4_0);
_.onRecordClick = function onRecordClick_16(event_0){
  var err;
  err = $getAttribute($getRecord_0(event_0), 'errorMessage');
  if (err != null && err.length > 0) {
    err = '<pre>' + err + '<\/pre>';
    $show(new ErrorMessageWindow_1(($clinit_RPCDataSource() , 'Error'), err));
  }
}
;
function AbstractConfigurationHistoryDataSource$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3404, 1, {}, AbstractConfigurationHistoryDataSource$5_0);
_.format_1 = function format_72(value, record, rowNum, colNum){
  var groupId;
  if (value == null) {
    return $clinit_RPCDataSource() , 'Individual';
  }
  groupId = getAttributeAsInt(record.jsObj, 'groupId');
  return '<a href="' + this.this$0.getGroupConfigurationUpdateHistoryLink(groupId, dynamicCast(value, Q$Number)) + '">' + ($clinit_RPCDataSource() , 'Group') + '<\/a>';
}
;
_.this$0 = null;
function AbstractConfigurationHistoryDataSource$6_0(){
}

defineSeed(3405, 1, {}, AbstractConfigurationHistoryDataSource$6_0);
_.format_1 = function format_73(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function AbstractConfigurationHistoryDataSource$7_0(){
}

defineSeed(3406, 1, {}, AbstractConfigurationHistoryDataSource$7_0);
_.hoverHTML_0 = function hoverHTML_51(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function AbstractConfigurationHistoryListView$1_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3407, 1608, {}, AbstractConfigurationHistoryListView$1_0);
_.executeAction = function executeAction_81(selection, actionValue){
  var doomedIds, i, selected, selected$index, selected$max;
  if (selection != null && selection.length > 0) {
    doomedIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selection.length, 1);
    i = 0;
    for (selected$index = 0 , selected$max = selection.length; selected$index < selected$max; ++selected$index) {
      selected = selection[selected$index];
      doomedIds[i++] = getAttributeAsInt(selected.jsObj, 'id').value_0;
      if (getAttribute(selected.jsObj, 'groupConfigUpdateId') != null) {
        $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'One or more selected configuration history items are part of a group configuration update. You must purge that parent group history item before you can delete its individual resource history items.'), ($clinit_Message$Severity() , Warning)));
        return;
      }
      $clinit_Boolean();
      if ($equalsIgnoreCase('true', getAttribute(selected.jsObj, 'currentConfig'))) {
        $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'One of the selected history items represents the current configuration - you cannot delete it.'), ($clinit_Message$Severity() , Warning)));
        return;
      }
    }
    this.this$0.delete_$(doomedIds);
  }
}
;
_.this$0 = null;
function AbstractConfigurationHistoryListView$2_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3408, 1608, {}, AbstractConfigurationHistoryListView$2_0);
_.executeAction = function executeAction_82(selection, actionValue){
  var criteria, record, record$index, record$max, requestProperties, updateId, updateIds;
  updateIds = new ArrayList_0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    updateId = getAttributeAsInt(record.jsObj, 'id').value_0;
    $add_3(updateIds, valueOf_44(updateId));
  }
  criteria = new Criteria_0;
  $addCriteria_5(criteria, 'ids', dynamicCast($toArray_1(updateIds, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, updateIds.size_0, 0)), Q$Integer_$1));
  requestProperties = new DSRequest_0;
  requestProperties.jsObj['fetchConfiguration'] = true;
  $fetchData_0(dynamicCast(this.this$0.dataSource_1, Q$AbstractConfigurationHistoryDataSource), criteria, new AbstractConfigurationHistoryListView$2$1_0, requestProperties);
}
;
_.this$0 = null;
function AbstractConfigurationHistoryListView$2$1_0(){
}

defineSeed(3409, 1, {}, AbstractConfigurationHistoryListView$2$1_0);
_.execute_2 = function execute_58(response, rawData, request){
  var record, record$index, record$max, records, update, updatesWithConfigs, theFirstUpdateItem, resourceId, isResourceConfig;
  updatesWithConfigs = new ArrayList_0;
  records = $getData(response);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    update = dynamicCast(getAttributeAsObject(record.jsObj, 'object'), Q$AbstractResourceConfigurationUpdate);
    setCheck(updatesWithConfigs.array, updatesWithConfigs.size_0++, update);
  }
  $clinit_ConfigurationComparisonView();
  theFirstUpdateItem = dynamicCast((checkIndex(0, updatesWithConfigs.size_0) , updatesWithConfigs.array[0]), Q$AbstractResourceConfigurationUpdate);
  resourceId = theFirstUpdateItem.getResource().resourceType.id;
  isResourceConfig = instanceOf(theFirstUpdateItem, Q$ResourceConfigurationUpdate);
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(resourceId), isResourceConfig?of(($clinit_ResourceTypeRepository$MetadataType() , resourceConfigurationDefinition_0)):of(($clinit_ResourceTypeRepository$MetadataType() , pluginConfigurationDefinition_0)), new ConfigurationComparisonView$3_0(isResourceConfig, updatesWithConfigs));
}
;
function AbstractConfigurationHistoryListView$3_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3410, 1608, {}, AbstractConfigurationHistoryListView$3_0);
_.executeAction = function executeAction_83(selection, actionValue){
  var configHistoryIdToRollbackTo, record;
  if (selection != null && selection.length == 1) {
    record = selection[0];
    configHistoryIdToRollbackTo = getAttributeAsInt(record.jsObj, 'id').value_0;
    this.this$0.rollback(configHistoryIdToRollbackTo);
  }
}
;
_.this$0 = null;
function AbstractConfigurationHistoryListView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3411, 1, {}, AbstractConfigurationHistoryListView$4_0);
_.format_1 = function format_74(value, record, i, i1){
  var cellHtml, detailsUrl, isCurrentConfig, recordId;
  recordId = $getId(this.this$0, record);
  detailsUrl = '#' + this.this$0.getBasePath() + '/' + recordId;
  cellHtml = getHref(detailsUrl, toString__devirtual$(value));
  isCurrentConfig = getAttribute(record.jsObj, 'currentConfig');
  ($clinit_Boolean() , $equalsIgnoreCase('true', isCurrentConfig)) && (cellHtml = imgHTML('[SKIN]/actions/approve.png') + cellHtml);
  return cellHtml;
}
;
_.this$0 = null;
function $displayHistory(this$static, update){
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(update.resource.resourceType.id), of(($clinit_ResourceTypeRepository$MetadataType() , resourceConfigurationDefinition_0)), new ConfigurationHistoryDetailView$1_0(this$static, update));
}

function ConfigurationHistoryDetailView_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(3412, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), ConfigurationHistoryDetailView_0);
_.renderView = function renderView_32(viewPath){
  var criteria, updateId;
  criteria = new ResourceConfigurationUpdateCriteria_0;
  updateId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  $addFilterId(criteria, valueOf_44(updateId));
  criteria.fetchConfiguration = true;
  criteria.fetchResource = true;
  criteria.fetchGroupConfigurationUpdate = true;
  $findResourceConfigurationUpdatesByCriteria(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), criteria, new ConfigurationHistoryDetailView$2_0(this));
}
;
function ConfigurationHistoryDetailView$1_0(this$0, val$update){
  this.this$0 = this$0;
  this.val$update = val$update;
}

defineSeed(3413, 1, {}, ConfigurationHistoryDetailView$1_0);
_.onTypesLoaded = function onTypesLoaded_37(type){
  var definition, editor;
  definition = type.resourceConfigurationDefinition;
  editor = new ConfigurationEditor_1(definition, this.val$update.configuration);
  editor.readOnly = true;
  $setEditorTitle(editor, ($clinit_Enhanced() , 'Version') + ' - ' + this.val$update.id);
  $addMember(this.this$0, editor);
  $markForRedraw(this.this$0);
}
;
_.this$0 = null;
_.val$update = null;
function $onSuccess_362(this$static, result){
  var update;
  update = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceConfigurationUpdate);
  $displayHistory(this$static.this$0, update);
}

function ConfigurationHistoryDetailView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3414, 1, {}, ConfigurationHistoryDetailView$2_0);
_.onFailure = function onFailure_376(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Unable to load configuration history.'), caught);
}
;
_.onSuccess_0 = function onSuccess_376(result){
  $onSuccess_362(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $createButtonBar(this$static){
  this$static.buttonbar = new ToolStrip_0;
  $setAttribute_24(this$static.buttonbar, 'width', '100%', true);
  $setExtraSpace(this$static.buttonbar, 10);
  $setMembersMargin(this$static.buttonbar, 5);
  $setLayoutMargin(this$static.buttonbar, valueOf_44(5));
  this$static.saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
  $addClickHandler(this$static.saveButton, new ResourceConfigurationEditView$1_0(this$static));
  $addMember(this$static.buttonbar, this$static.saveButton);
  $setAttribute_24(this$static.buttonbar, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  return this$static.buttonbar;
}

function $refresh_22(this$static){
  if (this$static.refreshing) {
    return;
  }
  this$static.refreshing = true;
  if (this$static.editor) {
    $destroy_1(this$static.editor);
    $removeMember(this$static, this$static.editor);
    this$static.buttonbar.destroy_0();
    $removeMember(this$static, this$static.buttonbar);
  }
  $getLatestResourceConfigurationUpdate(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), this$static.resource.id, new ResourceConfigurationEditView$2_0(this$static));
}

function $save_10(this$static){
  var updatedConfiguration;
  updatedConfiguration = this$static.editor.configuration;
  $updateResourceConfiguration(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), this$static.resource.id, updatedConfiguration, new ResourceConfigurationEditView$3_0(this$static));
}

function ResourceConfigurationEditView_0(resourceComposite){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.resource = resourceComposite.resource;
  this.resourcePermission = resourceComposite.resourcePermission;
}

defineSeed(3415, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$PropertyValueChangeListener, Q$Enhanced]), ResourceConfigurationEditView_0);
_.onDraw_0 = function onDraw_50(){
  var message;
  $refresh_22(this);
  if (!this.resourcePermission.permissions.contains_0(($clinit_Permission() , CONFIGURE_WRITE))) {
    message = new Message_8(($clinit_Enhanced() , "You do not have permission to edit this Resource's configuration."), ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
}
;
_.propertyValueChanged = function propertyValueChanged_6(event_0){
  var invalidPropertyNames, message, messageCenter;
  messageCenter = ($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0);
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    if (invalidPropertyNames.size_1() == 0) {
      $enable(this.saveButton);
      message = new Message_8(($clinit_Enhanced() , 'All configuration properties have valid values, so the configuration can now be saved.'), ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
     else {
      $disable(this.saveButton);
      message = new Message_8('The following configuration properties have invalid values: ' + ($clinit_Enhanced() , $toString_3($values(invalidPropertyNames))) + '. The values must be corrected before the configuration can be saved.', ($clinit_Message$Severity() , Error_2), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
    $notify(messageCenter, message);
  }
   else {
    $enable(this.saveButton);
  }
}
;
_.refresh_0 = function refresh_39(){
  $refresh_22(this);
}
;
_.buttonbar = null;
_.editor = null;
_.refreshing = false;
_.resource = null;
_.resourcePermission = null;
_.saveButton = null;
function ResourceConfigurationEditView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3416, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceConfigurationEditView$1_0);
_.onClick = function onClick_161(clickEvent){
  $save_10(this.this$0);
}
;
_.this$0 = null;
function $onSuccess_363(this$static, configurationUpdate){
  var message;
  if (!configurationUpdate) {
    message = new Message_7(($clinit_Enhanced() , 'No configuration was retrieved. This means that either the plugin failed to load the configuration or that configuration collection is merely switched off in the connection settings.'), ($clinit_Message$Severity() , Info));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
    this$static.this$0.refreshing = false;
    return;
  }
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(this$static.this$0.resource.resourceType.id), of(($clinit_ResourceTypeRepository$MetadataType() , resourceConfigurationDefinition_0)), new ResourceConfigurationEditView$2$1_0(this$static, configurationUpdate));
}

function ResourceConfigurationEditView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3417, 1, {}, ResourceConfigurationEditView$2_0);
_.onFailure = function onFailure_377(caught){
  this.this$0.refreshing = false;
  $handleError_0(($clinit_CoreGUI() , 'Failed to load configuration.'), caught);
}
;
_.onSuccess_0 = function onSuccess_377(configurationUpdate){
  $onSuccess_363(this, dynamicCast(configurationUpdate, Q$ResourceConfigurationUpdate));
}
;
_.this$0 = null;
function ResourceConfigurationEditView$2$1_0(this$1, val$configurationUpdate){
  this.this$1 = this$1;
  this.val$configurationUpdate = val$configurationUpdate;
}

defineSeed(3418, 1, {}, ResourceConfigurationEditView$2$1_0);
_.onTypesLoaded = function onTypesLoaded_38(type){
  var configurationService;
  configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
  $getOptionValuesForConfigDefinition(configurationService, this.this$1.this$0.resource.id, type.resourceConfigurationDefinition, new ResourceConfigurationEditView$2$1$1_0(this, this.val$configurationUpdate));
}
;
_.this$1 = null;
_.val$configurationUpdate = null;
function $onSuccess_364(this$static, configurationDefinition){
  var configuration;
  configuration = this$static.val$configurationUpdate.configuration;
  this$static.this$2.this$1.this$0.editor = new ConfigurationEditor_1(configurationDefinition, configuration);
  $setAttribute_24(this$static.this$2.this$1.this$0.editor, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $addPropertyValueChangeListener(this$static.this$2.this$1.this$0.editor, this$static.this$2.this$1.this$0);
  $setReadOnly_1(this$static.this$2.this$1.this$0.editor, !this$static.this$2.this$1.this$0.resourcePermission.permissions.contains_0(($clinit_Permission() , CONFIGURE_WRITE)));
  $addMember(this$static.this$2.this$1.this$0, this$static.this$2.this$1.this$0.editor);
  $addMember(this$static.this$2.this$1.this$0, $createButtonBar(this$static.this$2.this$1.this$0));
  $disable(this$static.this$2.this$1.this$0.saveButton);
  $setAttribute_24(this$static.this$2.this$1.this$0.buttonbar, 'visibility', ($clinit_Visibility() , INHERIT).value_0, true);
  $markForRedraw(this$static.this$2.this$1.this$0);
  this$static.this$2.this$1.this$0.refreshing = false;
}

function ResourceConfigurationEditView$2$1$1_0(this$2, val$configurationUpdate){
  this.this$2 = this$2;
  this.val$configurationUpdate = val$configurationUpdate;
}

defineSeed(3419, 1, {}, ResourceConfigurationEditView$2$1$1_0);
_.onFailure = function onFailure_378(throwable){
  this.this$2.this$1.this$0.refreshing = false;
  $handleError_0(($clinit_CoreGUI() , 'Failed to load configuration.'), throwable);
}
;
_.onSuccess_0 = function onSuccess_378(configurationDefinition){
  $onSuccess_364(this, dynamicCast(configurationDefinition, Q$ConfigurationDefinition));
}
;
_.this$2 = null;
_.val$configurationUpdate = null;
function $onSuccess_365(this$static, result){
  var configHistoryUrl, configHistoryView, message, version;
  if (result) {
    version = '' + result.id;
    message = new Message_2('Configuration updated - current version is ' + ($clinit_Enhanced() , version) + '.', 'Configuration updated to version ' + version + ' for Resource [' + this$static.this$0.resource.name_0 + '].', ($clinit_Message$Severity() , Info));
  }
   else {
    message = new Message_7(($clinit_Enhanced() , 'Configuration was not updated, since the new configuration is equivalent to the current configuration.'), ($clinit_Message$Severity() , Warning));
  }
  configHistoryUrl = getResourceTabLink(this$static.this$0.resource.id, 'Configuration', 'History');
  configHistoryView = $substring(configHistoryUrl, 1);
  $clinit_CoreGUI();
  goToView(configHistoryView, message, false);
}

function ResourceConfigurationEditView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3420, 1, {}, ResourceConfigurationEditView$3_0);
_.onFailure = function onFailure_379(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update configuration.'), caught);
}
;
_.onSuccess_0 = function onSuccess_379(result){
  $onSuccess_365(this, dynamicCast(result, Q$ResourceConfigurationUpdate));
}
;
_.this$0 = null;
function $onSuccess_366(this$static, result){
  var ancestries, records, resource, typeRepo, typesSet, update, update$iterator;
  if (!this$static.val$resourceId) {
    typesSet = new HashSet_0;
    ancestries = new HashSet_0;
    for (update$iterator = new AbstractList$IteratorImpl_0(result); update$iterator.i < update$iterator.this$0_0.size_1();) {
      update = dynamicCast($next_0(update$iterator), Q$ResourceConfigurationUpdate);
      resource = update.resource;
      $add_6(typesSet, valueOf_44(resource.resourceType.id));
      $add_6(ancestries, resource.ancestry);
    }
    $addAll(typesSet, getAncestryTypeIds(ancestries));
    typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
    $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new ResourceConfigurationHistoryDataSource$1$1_0(this$static, result, this$static.val$response, this$static.val$request));
    return;
  }
  records = $buildRecords(this$static.this$0, result, true);
  $getLatestResourceConfigurationUpdate(this$static.this$0.configurationService, this$static.val$resourceId.value_0, new ResourceConfigurationHistoryDataSource$1$2_0(this$static, records, this$static.val$response, result, this$static.val$request));
}

function ResourceConfigurationHistoryDataSource$1_0(this$0, val$response, val$request, val$resourceId){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
  this.val$resourceId = val$resourceId;
}

defineSeed(3421, 1, {}, ResourceConfigurationHistoryDataSource$1_0);
_.onFailure = function onFailure_380(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Unable to load configuration history.'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_380(result){
  $onSuccess_366(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$resourceId = null;
_.val$response = null;
function ResourceConfigurationHistoryDataSource$1$1_0(this$1, val$result, val$response, val$request){
  this.this$1 = this$1;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3422, 1, {}, ResourceConfigurationHistoryDataSource$1$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_39(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$1.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44($getTotalSize(this.val$result)));
  $processResponse_0(this.this$1.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $finish_1(this$static){
  $setAttribute_17(this$static.val$response, 'data', this$static.val$records);
  $setTotalRows(this$static.val$response, valueOf_44($getTotalSize(this$static.val$result)));
  $processResponse_0(this$static.this$1.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_367(this$static, latestResult){
  var latest, record, record$array, record$index, record$max;
  if (latestResult) {
    for (record$array = this$static.val$records , record$index = 0 , record$max = record$array.length; record$index < record$max; ++record$index) {
      record = record$array[record$index];
      latest = getAttributeAsInt(record.jsObj, 'id').value_0 == latestResult.id;
      record.jsObj['currentConfig'] = latest;
    }
  }
  $finish_1(this$static);
}

function ResourceConfigurationHistoryDataSource$1$2_0(this$1, val$records, val$response, val$result, val$request){
  this.this$1 = this$1;
  this.val$records = val$records;
  this.val$response = val$response;
  this.val$result = val$result;
  this.val$request = val$request;
}

defineSeed(3423, 1, {}, ResourceConfigurationHistoryDataSource$1$2_0);
_.onFailure = function onFailure_381(caught){
  $clinit_Log();
  $log_1(logger_0, ($clinit_Level() , SEVERE), 'Field to get latest Resource configuration update.', caught);
  $finish_1(this);
}
;
_.onSuccess_0 = function onSuccess_381(latestResult){
  $onSuccess_367(this, dynamicCast(latestResult, Q$ResourceConfigurationUpdate));
}
;
_.this$1 = null;
_.val$records = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $onSuccess_368(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You successfully rolled back the configuration to the selected past configuration.'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceConfigurationHistoryListView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3424, 1, {}, ResourceConfigurationHistoryListView$1_0);
_.onFailure = function onFailure_382(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to rollback the configuration. The original configuration is still in effect.'), caught);
}
;
_.onSuccess_0 = function onSuccess_382(result){
  $onSuccess_368(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $onSuccess_369(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You successfully deleted the selected configuration history items.'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceConfigurationHistoryListView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3425, 1, {}, ResourceConfigurationHistoryListView$2_0);
_.onFailure = function onFailure_383(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete the configuration history items.'), caught);
}
;
_.onSuccess_0 = function onSuccess_383(result){
  $onSuccess_369(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $refresh_23(this$static){
  if (this$static.refreshingConfig || this$static.refreshingConfigDef) {
    return;
  }
  this$static.refreshingConfig = true;
  this$static.refreshingConfigDef = true;
  $disable(this$static.saveButton);
  if (this$static.editor) {
    $destroy_1(this$static.editor);
    $removeMember(this$static, this$static.editor);
  }
  this$static.editor = new ConfigurationEditor_0(this$static.resource.id, this$static.resource.resourceType.id, ($clinit_ConfigurationEditor$ConfigType() , plugin_0));
  $setAttribute_24(this$static.editor, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $addPropertyValueChangeListener(this$static.editor, this$static);
  $setReadOnly_1(this$static.editor, !this$static.resourcePermission.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE)));
  $setLoadHandler(this$static.editor, new PluginConfigurationEditView$2_0(this$static));
  $addMember(this$static, this$static.editor);
}

function $save_11(this$static){
  var updatedConfiguration;
  updatedConfiguration = this$static.editor.configuration;
  $updatePluginConfiguration(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), this$static.resource.id, updatedConfiguration, new PluginConfigurationEditView$3_0(this$static));
}

function PluginConfigurationEditView_0(resourceComposite){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.resource = resourceComposite.resource;
  this.resourcePermission = resourceComposite.resourcePermission;
}

defineSeed(3426, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$PropertyValueChangeListener, Q$Enhanced]), PluginConfigurationEditView_0);
_.onDraw_0 = function onDraw_51(){
  var message, toolStrip;
  toolStrip = new ToolStrip_0;
  $isCreated_1(toolStrip)?$setProperty_3(toolStrip, 'width', '100%'):(toolStrip.config_0['width'] = '100%' , undefined);
  $isCreated_1(toolStrip)?undefined:(toolStrip.config_0['extraSpace'] = 10 , undefined);
  $isCreated_1(toolStrip)?$setProperty_0(toolStrip, 'membersMargin', 5):(toolStrip.config_0['membersMargin'] = 5 , undefined);
  $setLayoutMargin(toolStrip, valueOf_44(5));
  this.saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
  $addClickHandler(this.saveButton, new PluginConfigurationEditView$1_0(this));
  $disable(this.saveButton);
  $addMember(toolStrip, this.saveButton);
  $addMember(this, toolStrip);
  $refresh_23(this);
  if (!this.resourcePermission.permissions.contains_0(($clinit_Permission() , MODIFY_RESOURCE))) {
    message = new Message_8("You do not have permission to edit this Resource's connection settings.", ($clinit_Message$Severity() , Info), of(($clinit_Message$Option() , Transient)));
    $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), message);
  }
}
;
_.propertyValueChanged = function propertyValueChanged_7(event_0){
  var invalidPropertyNames, message, messageCenter;
  messageCenter = ($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0);
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    if (invalidPropertyNames.size_1() == 0) {
      $enable(this.saveButton);
      message = new Message_8(($clinit_Enhanced() , 'All connection settings have valid values, so the settings can now be saved.'), ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
     else {
      $disable(this.saveButton);
      message = new Message_8('The following connection settings have invalid values: ' + ($clinit_Enhanced() , $toString_3($values(invalidPropertyNames))) + '. The values must be corrected before the settings can be saved.', ($clinit_Message$Severity() , Error_2), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
    $notify(messageCenter, message);
  }
   else {
    $enable(this.saveButton);
  }
}
;
_.refresh_0 = function refresh_40(){
  $refresh_23(this);
}
;
_.editor = null;
_.refreshingConfig = false;
_.refreshingConfigDef = false;
_.resource = null;
_.resourcePermission = null;
_.saveButton = null;
function PluginConfigurationEditView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3427, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), PluginConfigurationEditView$1_0);
_.onClick = function onClick_162(clickEvent){
  $save_11(this.this$0);
}
;
_.this$0 = null;
function PluginConfigurationEditView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3428, 1, {}, PluginConfigurationEditView$2_0);
_.this$0 = null;
function $onSuccess_370(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_1(($clinit_Enhanced() , 'Connection settings update initiated.'), 'Connection settings update initiated for Resource [' + this$static.this$0.resource.name_0 + '].'));
  $refresh_23(this$static.this$0);
}

function PluginConfigurationEditView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3429, 1, {}, PluginConfigurationEditView$3_0);
_.onFailure = function onFailure_384(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update connection settings.'), caught);
}
;
_.onSuccess_0 = function onSuccess_384(result){
  $onSuccess_370(this, dynamicCast(result, Q$PluginConfigurationUpdate));
}
;
_.this$0 = null;
function $executeFetch_43(this$static, request, response, criteria){
  var resourceId;
  resourceId = dynamicCast(convertToMap($getCriteria(request).jsObj).get_2('resourceId'), Q$Integer);
  $findPluginConfigurationUpdatesByCriteria(this$static.configurationService, criteria, new PluginConfigurationHistoryDataSource$1_0(this$static, response, request, resourceId));
}

function PluginConfigurationHistoryDataSource_0(){
  $clinit_RPCDataSource();
  AbstractConfigurationHistoryDataSource_0.call(this);
}

defineSeed(3430, 2618, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractConfigurationHistoryDataSource]), PluginConfigurationHistoryDataSource_0);
_.createFetchCriteria = function createFetchCriteria_0(){
  return new PluginConfigurationUpdateCriteria_0;
}
;
_.executeFetch = function executeFetch_60(request, response, criteria){
  $executeFetch_43(this, request, response, dynamicCast(criteria, Q$PluginConfigurationUpdateCriteria));
}
;
_.getConfigurationUpdateStatusIcon = function getConfigurationUpdateStatusIcon_0(status_0){
  return getPluginConfigurationIcon(status_0);
}
;
_.getFetchCriteria_6 = function getFetchCriteria_69(request){
  var criteria, resourceId;
  return criteria = dynamicCast($getFetchCriteria_7(this, request), Q$PluginConfigurationUpdateCriteria) , criteria.fetchResource = true , criteria.fetchGroupConfigurationUpdate = true , resourceId = dynamicCast(getFilter($getCriteria(request), 'resourceId', Ljava_lang_Integer_2_classLit), Q$Integer) , !!resourceId && (criteria.filterResourceIds = new Arrays$ArrayList_0(initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [resourceId]))) , criteria;
}
;
_.getGroupConfigurationUpdateHistoryLink = function getGroupConfigurationUpdateHistoryLink_0(groupId, value){
  return getGroupPluginConfigurationUpdateHistoryLink(new EntityContext_0(null, valueOf_44(groupId.value_0), null), valueOf_44(value.intValue()));
}
;
function $onSuccess_371(this$static, result){
  var ancestries, records, resource, typeRepo, typesSet, update, update$iterator;
  records = $buildRecords(this$static.this$0, result, true);
  if (!this$static.val$resourceId) {
    typesSet = new HashSet_0;
    ancestries = new HashSet_0;
    for (update$iterator = new AbstractList$IteratorImpl_0(result); update$iterator.i < update$iterator.this$0_0.size_1();) {
      update = dynamicCast($next_0(update$iterator), Q$PluginConfigurationUpdate);
      resource = update.resource;
      $add_6(typesSet, valueOf_44(resource.resourceType.id));
      $add_6(ancestries, resource.ancestry);
    }
    $addAll(typesSet, getAncestryTypeIds(ancestries));
    typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
    $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new PluginConfigurationHistoryDataSource$1$1_0(this$static, result, this$static.val$response, this$static.val$request));
    return;
  }
  $getLatestPluginConfigurationUpdate(this$static.this$0.configurationService, this$static.val$resourceId.value_0, new PluginConfigurationHistoryDataSource$1$2_0(this$static, records, this$static.val$response, result, this$static.val$request));
}

function PluginConfigurationHistoryDataSource$1_0(this$0, val$response, val$request, val$resourceId){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
  this.val$resourceId = val$resourceId;
}

defineSeed(3431, 1, {}, PluginConfigurationHistoryDataSource$1_0);
_.onFailure = function onFailure_385(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Unable to load configuration history.'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_385(result){
  $onSuccess_371(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$resourceId = null;
_.val$response = null;
function PluginConfigurationHistoryDataSource$1$1_0(this$1, val$result, val$response, val$request){
  this.this$1 = this$1;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3432, 1, {}, PluginConfigurationHistoryDataSource$1$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_40(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$1.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44($getTotalSize(this.val$result)));
  $processResponse_0(this.this$1.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $finish_2(this$static){
  $setAttribute_17(this$static.val$response, 'data', this$static.val$records);
  $setTotalRows(this$static.val$response, valueOf_44($getTotalSize(this$static.val$result)));
  $processResponse_0(this$static.this$1.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onFailure_43(this$static, caught){
  $clinit_Log();
  $log_1(logger_0, ($clinit_Level() , SEVERE), 'cannot get latest plugin config', caught);
  $finish_2(this$static);
}

function $onSuccess_372(this$static, latestResult){
  var latest, record, record$array, record$index, record$max;
  if (latestResult) {
    for (record$array = this$static.val$records , record$index = 0 , record$max = record$array.length; record$index < record$max; ++record$index) {
      record = record$array[record$index];
      latest = getAttributeAsInt(record.jsObj, 'id').value_0 == latestResult.id;
      record.jsObj['currentConfig'] = latest;
    }
  }
  $finish_2(this$static);
}

function PluginConfigurationHistoryDataSource$1$2_0(this$1, val$records, val$response, val$result, val$request){
  this.this$1 = this$1;
  this.val$records = val$records;
  this.val$response = val$response;
  this.val$result = val$result;
  this.val$request = val$request;
}

defineSeed(3433, 1, {}, PluginConfigurationHistoryDataSource$1$2_0);
_.onFailure = function onFailure_386(caught){
  $onFailure_43(this, caught);
}
;
_.onSuccess_0 = function onSuccess_386(latestResult){
  $onSuccess_372(this, dynamicCast(latestResult, Q$PluginConfigurationUpdate));
}
;
_.this$1 = null;
_.val$records = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $displayHistory_0(this$static, update){
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(update.resource.resourceType.id), of(($clinit_ResourceTypeRepository$MetadataType() , pluginConfigurationDefinition_0)), new PluginConfigurationHistoryDetailView$1_0(this$static, update));
}

function PluginConfigurationHistoryDetailView_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(3434, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$Enhanced]), PluginConfigurationHistoryDetailView_0);
_.renderView = function renderView_33(viewPath){
  var criteria, updateId;
  updateId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
  criteria = new PluginConfigurationUpdateCriteria_0;
  criteria.fetchConfiguration = true;
  criteria.fetchResource = true;
  $addFilterId(criteria, valueOf_44(updateId));
  $findPluginConfigurationUpdatesByCriteria(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), criteria, new PluginConfigurationHistoryDetailView$2_0(this));
}
;
function PluginConfigurationHistoryDetailView$1_0(this$0, val$update){
  this.this$0 = this$0;
  this.val$update = val$update;
}

defineSeed(3435, 1, {}, PluginConfigurationHistoryDetailView$1_0);
_.onTypesLoaded = function onTypesLoaded_41(type){
  var definition, editor;
  definition = type.pluginConfigurationDefinition;
  editor = new ConfigurationEditor_1(definition, this.val$update.configuration);
  editor.readOnly = true;
  $setEditorTitle(editor, ($clinit_Enhanced() , 'Version') + ' - ' + this.val$update.id);
  $addMember(this.this$0, editor);
  $markForRedraw(this.this$0);
}
;
_.this$0 = null;
_.val$update = null;
function $onSuccess_373(this$static, result){
  var update;
  update = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$PluginConfigurationUpdate);
  $displayHistory_0(this$static.this$0, update);
}

function PluginConfigurationHistoryDetailView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3436, 1, {}, PluginConfigurationHistoryDetailView$2_0);
_.onFailure = function onFailure_387(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Unable to load configuration history.'), caught);
}
;
_.onSuccess_0 = function onSuccess_387(result){
  $onSuccess_373(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $clinit_PluginConfigurationHistoryListView(){
  $clinit_PluginConfigurationHistoryListView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_25 = new ViewName_1('PluginConfigurationHistoryView', ($clinit_Enhanced() , 'Connection Settings History'));
}

function PluginConfigurationHistoryListView_0(hasWritePerm, resourceId){
  $clinit_PluginConfigurationHistoryListView();
  var datasource;
  AbstractConfigurationHistoryListView_0.call(this, VIEW_ID_25.title_0, hasWritePerm, resourceId);
  datasource = new PluginConfigurationHistoryDataSource_0;
  this.dataSource_1 = datasource;
}

defineSeed(3437, 2623, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), PluginConfigurationHistoryListView_0);
_.delete_$ = function delete_$_0(doomedIds){
  $purgePluginConfigurationUpdates(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), doomedIds, new PluginConfigurationHistoryListView$2_0(this));
}
;
_.getDetailsView_0 = function getDetailsView_26(id){
  var detailView;
  detailView = new PluginConfigurationHistoryDetailView_0;
  return detailView;
}
;
_.rollback = function rollback_0(configHistoryIdToRollbackTo){
  $rollbackPluginConfiguration(dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync), this.resourceId.value_0, configHistoryIdToRollbackTo, new PluginConfigurationHistoryListView$1_0(this));
}
;
var VIEW_ID_25;
function $onSuccess_374(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You successfully rolled back the configuration to the selected past configuration.'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function PluginConfigurationHistoryListView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3438, 1, {}, PluginConfigurationHistoryListView$1_0);
_.onFailure = function onFailure_388(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to rollback the configuration. The original configuration is still in effect.'), caught);
}
;
_.onSuccess_0 = function onSuccess_388(result){
  $onSuccess_374(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $onSuccess_375(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You successfully deleted the selected configuration history items.'), ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function PluginConfigurationHistoryListView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3439, 1, {}, PluginConfigurationHistoryListView$2_0);
_.onFailure = function onFailure_389(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to delete the configuration history items.'), caught);
}
;
_.onSuccess_0 = function onSuccess_389(result){
  $onSuccess_375(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $loadData_0(this$static){
  if (this$static.loading) {
    return;
  }
  this$static.loading = true;
  $getAgentForResource(dynamicCast(secure(getInstance_30(), -1), Q$AgentGWTServiceAsync), this$static.resourceId, new ResourceAgentView$1_0(this$static));
}

function ResourceAgentView_0(resourceId){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.resourceId = resourceId;
}

defineSeed(3440, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$RefreshableView, Q$Enhanced]), ResourceAgentView_0);
_.onDraw_0 = function onDraw_52(){
  var formItems, formItems_0, headerItem, agentStatus;
  $isCreated_1(this)?$setProperty_3(this, 'left', '10%'):(this.config_0['left'] = '10%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '80%'):(this.config_0['width'] = '80%' , undefined);
  this.form_0 = new DynamicForm_0;
  formItems = (formItems_0 = new ArrayList_0 , headerItem = new HeaderItem_1(($clinit_Enhanced() , 'Agent Managing this Resource')) , $setValue_7(headerItem, 'Agent Managing this Resource') , setCheck(formItems_0.array, formItems_0.size_0++, headerItem) , $add_3(formItems_0, new SpacerItem_0) , this.nameValue = new StaticTextItem_2('name', 'Name') , $add_3(formItems_0, this.nameValue) , this.addressValue = new StaticTextItem_2('address', 'Address') , $add_3(formItems_0, this.addressValue) , this.portValue = new StaticTextItem_2('port', 'Port') , $add_3(formItems_0, this.portValue) , this.agentStatusIcon = new FormItemIcon_0 , $setAttribute_13(this.agentStatusIcon, 'src', getAvailabilityLargeIcon(null)) , agentStatus = new StaticTextItem_2('agent-comm-status', 'Agent Communications Status') , $setIcons(agentStatus, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [this.agentStatusIcon])) , $setWrapTitle(agentStatus, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , setCheck(formItems_0.array, formItems_0.size_0++, agentStatus) , this.lastAvailReportValue = new StaticTextItem_2('last-avail-report', 'Last Received Availability Report') , $setWrapTitle(this.lastAvailReportValue, FALSE) , $add_3(formItems_0, this.lastAvailReportValue) , this.lastAvailPingValue = new StaticTextItem_2('last-avail-ping', 'Last Availability Ping') , $setWrapTitle(this.lastAvailPingValue, FALSE) , $add_3(formItems_0, this.lastAvailPingValue) , this.endpointValue = new StaticTextItem_2('full-endpoint', 'Full Endpoint') , $add_3(formItems_0, this.endpointValue) , this.topologyViewItem = new StaticTextItem_2('topology-view', 'Topology') , $add_3(formItems_0, this.topologyViewItem) , formItems_0);
  this.form_0.setItems(dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, formItems.size_0, 0)), Q$FormItem_$1));
  $loadData_0(this);
  $addMember(this, this.form_0);
}
;
_.refresh_0 = function refresh_41(){
  $loadData_0(this);
}
;
_.addressValue = null;
_.agentStatusIcon = null;
_.endpointValue = null;
_.form_0 = null;
_.lastAvailPingValue = null;
_.lastAvailReportValue = null;
_.loading = false;
_.nameValue = null;
_.portValue = null;
_.resourceId = 0;
_.topologyViewItem = null;
function $onFailure_44(this$static){
  var child, child$array, child$index, child$max, headerItem, permissionsMessage;
  this$static.this$0.loading = false;
  for (child$array = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static.this$0.form_0, 'children')) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
    child = child$array[child$index];
    child.destroy_0();
  }
  headerItem = new HeaderItem_1(($clinit_Enhanced() , 'Agent Managing this Resource'));
  $setValue_7(headerItem, 'Agent Managing this Resource');
  permissionsMessage = new StaticTextItem_2('permissions', 'permissionsFailure');
  $setShowTitle_0(permissionsMessage, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setValue_7(permissionsMessage, 'You do not have permission to view details for this Agent.');
  $setWrap_1(permissionsMessage, FALSE);
  this$static.this$0.form_0.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [headerItem, new SpacerItem_0, permissionsMessage]));
  $markForRedraw(this$static.this$0.form_0);
}

function $onSuccess_376(this$static, agent){
  var detailsUrl, formattedValue, lastAvailPing, lastAvailReport, remoteEndpoint, topologyViewItemText;
  $pingAgentForResource(dynamicCast(secure(getInstance_30(), -1), Q$AgentGWTServiceAsync), this$static.this$0.resourceId, new ResourceAgentView$1$1_0(this$static));
  $setValue_7(this$static.this$0.nameValue, agent.name_0);
  $setValue_7(this$static.this$0.addressValue, agent.address);
  $setValue_5(this$static.this$0.portValue, agent.port);
  lastAvailReport = agent.lastAvailabilityReport;
  $setValue_6(this$static.this$0.lastAvailReportValue, lastAvailReport?new Date_2(lastAvailReport.value_0):($clinit_Enhanced() , 'None'));
  lastAvailPing = agent.lastAvailabilityPing;
  $setValue_6(this$static.this$0.lastAvailPingValue, lastAvailPing?new Date_2(lastAvailPing.value_0):($clinit_Enhanced() , 'None'));
  remoteEndpoint = agent.remoteEndpoint;
  remoteEndpoint != null?(remoteEndpoint = $replaceAll(remoteEndpoint, '&', ' &')):(remoteEndpoint = ($clinit_Enhanced() , '!No remote endpoint associated with this resource!'));
  $setValue_7(this$static.this$0.endpointValue, remoteEndpoint);
  detailsUrl = '#' + ($clinit_AgentTableView() , VIEW_PATH_1) + '/' + agent.id;
  formattedValue = escapeHtml(($clinit_Enhanced() , 'Link'));
  topologyViewItemText = getHref(detailsUrl, formattedValue);
  $setValue_7(this$static.this$0.topologyViewItem, topologyViewItemText);
  $markForRedraw(this$static.this$0.form_0);
}

function ResourceAgentView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3441, 1, {}, ResourceAgentView$1_0);
_.onFailure = function onFailure_390(caught){
  $onFailure_44(this);
}
;
_.onSuccess_0 = function onSuccess_390(agent){
  $onSuccess_376(this, dynamicCast(agent, Q$Agent));
}
;
_.this$0 = null;
function $onFailure_45(this$static, caught){
  this$static.this$1.this$0.loading = false;
  $handleError_0(($clinit_CoreGUI() , ($clinit_Enhanced() , 'Failed to ping agent managing resource id') + ' ' + this$static.this$1.this$0.resourceId + '.'), caught);
  $setAttribute_13(this$static.this$1.this$0.agentStatusIcon, 'src', getAvailabilityLargeIcon(null));
  $markForRedraw(this$static.this$1.this$0.form_0);
}

function $onSuccess_377(this$static, isUp){
  this$static.this$1.this$0.loading = false;
  $setAttribute_13(this$static.this$1.this$0.agentStatusIcon, 'src', getAvailabilityLargeIcon(isUp));
  $markForRedraw(this$static.this$1.this$0.form_0);
}

function ResourceAgentView$1$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3442, 1, {}, ResourceAgentView$1$1_0);
_.onFailure = function onFailure_391(caught){
  $onFailure_45(this, caught);
}
;
_.onSuccess_0 = function onSuccess_391(isUp){
  $onSuccess_377(this, dynamicCast(isUp, Q$Boolean));
}
;
_.this$1 = null;
function ResourceResourceGroupSelector_0(resourceGroups){
  $clinit_ResourceGroupSelector();
  var data;
  ResourceGroupSelector_1.call(this, false);
  if (resourceGroups) {
    data = $buildRecords(new ResourceGroupsDataSource_0, resourceGroups, true);
    this.initialSelection = data;
  }
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
}

defineSeed(3443, 1703, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ResourceResourceGroupSelector_0);
function $getSelectedResourceGroupIds(this$static){
  var i, id, id$iterator, selectedIds, selection;
  selectedIds = $getSelection(this$static.selector);
  selection = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selectedIds.map.size_1(), 1);
  i = 0;
  for (id$iterator = $iterator($keySet(selectedIds.map)); id$iterator.val$outerIter.hasNext();) {
    id = dynamicCast($next_1(id$iterator), Q$Integer);
    selection[i++] = id.value_0;
  }
  return selection;
}

function $save_12(this$static){
  var resourceGroupIds;
  resourceGroupIds = $getSelectedResourceGroupIds(this$static);
  $setAssignedResourceGroupsForResource(dynamicCast(secure((!instance_27 && (instance_27 = new ResourceGroupGWTService_Proxy_0) , instance_27), -1), Q$ResourceGroupGWTServiceAsync), this$static.resource.id, resourceGroupIds, new ResourceResourceGroupsView$3_0(this$static));
}

function $setSaveButtonHandler_0(this$static, saveButtonHandler){
  this$static.saveButtonHandler = saveButtonHandler;
}

function ResourceResourceGroupsView_0(resourceId){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.resourceId = resourceId;
}

defineSeed(3444, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ResourceResourceGroupsView_0);
_.onDraw_0 = function onDraw_53(){
  var toolStrip, saveButton, c;
  toolStrip = new ToolStrip_0;
  $isCreated_1(toolStrip)?$setProperty_3(toolStrip, 'width', '100%'):(toolStrip.config_0['width'] = '100%' , undefined);
  $isCreated_1(toolStrip)?undefined:(toolStrip.config_0['extraSpace'] = 10 , undefined);
  $isCreated_1(toolStrip)?$setProperty_0(toolStrip, 'membersMargin', 5):(toolStrip.config_0['membersMargin'] = 5 , undefined);
  $setLayoutMargin(toolStrip, valueOf_44(5));
  saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
  $addClickHandler(saveButton, new ResourceResourceGroupsView$1_0(this));
  $addMember(toolStrip, saveButton);
  $addMember(this, toolStrip);
  c = new ResourceCriteria_0;
  $addFilterId(c, valueOf_44(this.resourceId));
  c.fetchExplicitGroups = true;
  $findResourcesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), c, new ResourceResourceGroupsView$2_0(this));
}
;
_.resource = null;
_.resourceId = 0;
_.saveButtonHandler = null;
_.selector = null;
function ResourceResourceGroupsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3445, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceResourceGroupsView$1_0);
_.onClick = function onClick_163(clickEvent){
  $save_12(this.this$0);
  !!this.this$0.saveButtonHandler && $onClick(this.this$0.saveButtonHandler);
}
;
_.this$0 = null;
function $onSuccess_378(this$static, result){
  this$static.this$0.resource = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Resource);
  this$static.this$0.selector = new ResourceResourceGroupSelector_0(this$static.this$0.resource.explicitGroups);
  $addMember(this$static.this$0, this$static.this$0.selector);
}

function ResourceResourceGroupsView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3446, 1, {}, ResourceResourceGroupsView$2_0);
_.onFailure = function onFailure_392(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , "Failed to fetch Resource's groups."), caught);
}
;
_.onSuccess_0 = function onSuccess_392(result){
  $onSuccess_378(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $onSuccess_379(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Group membership updated for [' + ($clinit_Enhanced() , this$static.this$0.resource.name_0) + '].', ($clinit_Message$Severity() , Info)));
  currentViewPath_0 = new ViewPath_1(currentView, true);
  $renderView(coreGUI.rootCanvas, currentViewPath_0);
}

function ResourceResourceGroupsView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3447, 1, {}, ResourceResourceGroupsView$3_0);
_.onFailure = function onFailure_393(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to update assigned Resource groups.'), caught);
}
;
_.onSuccess_0 = function onSuccess_393(result){
  $onSuccess_379(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $copyValues_58(from){
  var durationStrings, durations, record;
  durations = initValues(_3D_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [from.minimum, from.maximum, from.average, from.total]);
  durationStrings = formatToSignificantPrecision(durations, ($clinit_MeasurementUnits() , MILLISECONDS));
  record = new ListGridRecord_0;
  $setAttribute_13(record, 'calltimedatavalue.key.callDestination', from.callDestination);
  $setAttribute_4(record, 'count', from.count);
  record.jsObj['minimum'] = durations[0];
  record.jsObj['maximum'] = durations[1];
  record.jsObj['average'] = durations[2];
  record.jsObj['total'] = durations[3];
  record.jsObj['minimumString'] = durationStrings[0];
  record.jsObj['maximumString'] = durationStrings[1];
  record.jsObj['averageString'] = durationStrings[2];
  record.jsObj['totalString'] = durationStrings[3];
  return record;
}

function $executeFetch_44(this$static, request, response, criteria){
  $findCallTimeDataForContext(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this$static.entityContext, criteria, new CalltimeDataSource$5_0(this$static, request, response));
}

function $getListGridFields_18(){
  var alertsField, avgField, fields, maxField, minField, nameField, totalField;
  fields = new ArrayList_1(6);
  nameField = new ListGridField_3('calltimedatavalue.key.callDestination', 'Call Destination');
  nameField.jsObj['width'] = '50%';
  setCheck(fields.array, fields.size_0++, nameField);
  alertsField = new ListGridField_3('count', 'Count');
  alertsField.jsObj['width'] = '10%';
  setCheck(fields.array, fields.size_0++, alertsField);
  minField = new ListGridField_3('minimum', 'Minimum');
  minField.jsObj['width'] = '10%';
  $setCellFormatter_0(minField, new CalltimeDataSource$1_0);
  setCheck(fields.array, fields.size_0++, minField);
  maxField = new ListGridField_3('maximum', 'Maximum');
  maxField.jsObj['width'] = '10%';
  $setCellFormatter_0(maxField, new CalltimeDataSource$2_0);
  setCheck(fields.array, fields.size_0++, maxField);
  avgField = new ListGridField_3('average', 'Average');
  avgField.jsObj['width'] = '10%';
  $setCellFormatter_0(avgField, new CalltimeDataSource$3_0);
  setCheck(fields.array, fields.size_0++, avgField);
  totalField = new ListGridField_3('total', 'Total Time');
  totalField.jsObj['width'] = '10%';
  $setCellFormatter_0(totalField, new CalltimeDataSource$4_0);
  setCheck(fields.array, fields.size_0++, totalField);
  return fields;
}

function CalltimeDataSource_0(ec){
  $clinit_RPCDataSource();
  RPCDataSource_0.call(this);
  this.entityContext = ec;
}

defineSeed(3448, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$CalltimeDataSource]), CalltimeDataSource_0);
_.copyValues = function copyValues_111(from){
  return null;
}
;
_.copyValues_0 = function copyValues_112(from){
  return $copyValues_58(dynamicCast(from, Q$CallTimeDataComposite));
}
;
_.executeFetch = function executeFetch_61(request, response, criteria){
  $executeFetch_44(this, request, response, dynamicCast(criteria, Q$CallTimeDataCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_70(request){
  var prefs, mprefs, range, destinationFilter, criteria;
  return prefs = ($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences) , mprefs = new MeasurementUserPreferences_0(prefs) , range = $getBeginEndTimes($getMetricRangePreferences(mprefs)) , destinationFilter = dynamicCast(getFilter($getCriteria(request), 'destinationFilter', Ljava_lang_String_2_classLit), Q$String) , criteria = new CallTimeDataCriteria_0 , $addFilterBeginTime(criteria, dynamicCast((checkIndex(0, range.size_0) , range.array[0]), Q$Long)) , $addFilterEndTime_1(criteria, dynamicCast((checkIndex(1, range.size_0) , range.array[1]), Q$Long)) , destinationFilter != null && destinationFilter.length > 0 && (criteria.filterDestination = destinationFilter) , criteria;
}
;
_.entityContext = null;
function CalltimeDataSource$1_0(){
}

defineSeed(3449, 1, {}, CalltimeDataSource$1_0);
_.format_1 = function format_75(value, record, rowNum, colNum){
  return getAttribute(record.jsObj, 'minimumString');
}
;
function CalltimeDataSource$2_0(){
}

defineSeed(3450, 1, {}, CalltimeDataSource$2_0);
_.format_1 = function format_76(value, record, rowNum, colNum){
  return getAttribute(record.jsObj, 'maximumString');
}
;
function CalltimeDataSource$3_0(){
}

defineSeed(3451, 1, {}, CalltimeDataSource$3_0);
_.format_1 = function format_77(value, record, rowNum, colNum){
  return getAttribute(record.jsObj, 'averageString');
}
;
function CalltimeDataSource$4_0(){
}

defineSeed(3452, 1, {}, CalltimeDataSource$4_0);
_.format_1 = function format_78(value, record, rowNum, colNum){
  return getAttribute(record.jsObj, 'totalString');
}
;
function $onSuccess_380(this$static, result){
  $sendSuccessResponse_1(this$static.this$0, this$static.val$request, this$static.val$response, result);
}

function CalltimeDataSource$5_0(this$0, val$request, val$response){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(3453, 1, {}, CalltimeDataSource$5_0);
_.onFailure = function onFailure_394(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Could not load call time data'), caught);
}
;
_.onSuccess_0 = function onSuccess_394(result){
  $onSuccess_380(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $clinit_CalltimeView(){
  $clinit_CalltimeView = nullMethod;
  $clinit_BaseWidget();
  SUBSYSTEM_VIEW_ID_2 = new ViewName_2('CalltimeData', ($clinit_Enhanced() , 'Call Time Data'), ($clinit_IconEnum() , CALLTIME_0));
}

function CalltimeView_0(context){
  $clinit_CalltimeView();
  TableSection_0.call(this, SUBSYSTEM_VIEW_ID_2.title_0);
  $setDataSource(this, new CalltimeDataSource_0(context));
  this.destinationFilter = new TextItem_3('destinationFilter', ($clinit_Enhanced() , 'Destination Filter'));
}

defineSeed(3454, 1603, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), CalltimeView_0);
_.configureTable = function configureTable_56(){
  var dataSourceFields;
  dataSourceFields = $getListGridFields_18(dynamicCast(this.dataSource_1, Q$CalltimeDataSource));
  $setFields_1(this.listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
  $addExtraWidget(this, new UserPreferencesMeasurementRangeEditor_0, true);
  $configureTable(this);
}
;
_.configureTableFilters = function configureTableFilters_9(){
  $setFilterFormItems(this, initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.destinationFilter]));
}
;
_.getDetailsView_0 = function getDetailsView_27(id){
  return null;
}
;
_.getViewName = function getViewName_11(){
  return SUBSYSTEM_VIEW_ID_2;
}
;
_.isDetailsEnabled = function isDetailsEnabled_1(){
  return false;
}
;
_.destinationFilter = null;
var SUBSYSTEM_VIEW_ID_2;
function $addSetButtonClickHandler(this$static, clickHandler){
  debug('measurementRangeEditor ' + this$static.measurementRangeEditor);
  $addClickHandler_1(this$static.measurementRangeEditor.setButton, clickHandler);
}

function $buildSingleGraph(this$static, measurementDefinition, height){
  var graph, graphView, metricGraphData;
  metricGraphData = ($clinit_MetricGraphData() , new MetricGraphData_2(this$static.resource.id, this$static.resource.name_0, measurementDefinition));
  graph = new StackedBarMetricGraphIE8Impl_0;
  graph.metricGraphData = metricGraphData;
  graphView = new MetricD3GraphView_1(graph);
  $isCreated_1(graphView)?$setProperty_3(graphView, 'width', '95%'):(graphView.config_0['width'] = '95%' , undefined);
  $isCreated_1(graphView)?$setProperty_0(graphView, 'height', height):(graphView.config_0['height'] = height , undefined);
  this$static.vLayout.addMember_0(graphView);
}

function $onDraw_4(this$static){
  var startTimer;
  debug('D3GraphListView.onDraw() for: ' + this$static.resource.name_0);
  destroyMembers(this$static);
  $addMember(this$static, this$static.measurementRangeEditor);
  if (this$static.showAvailabilityGraph) {
    this$static.availabilityGraph = new AvailabilityD3Graph_0(new AvailabilityLineGraphType_0(valueOf_44(this$static.resource.id)));
    $createGraphMarker(this$static.availabilityGraph);
    $addMember(this$static, this$static.availabilityGraph);
  }
  this$static.vLayout = new VLayout_0;
  this$static.vLayout.setOverflow(($clinit_Overflow() , AUTO));
  $setAttribute_24(this$static.vLayout, 'width', '100%', true);
  $setAttribute_24(this$static.vLayout, 'height', '100%', true);
  !!this$static.resource && (startTimer = fromDouble(currentTimeMillis0()) , $queryAvailability_0(this$static, new EntityContext_0(valueOf_44(this$static.resource.id), null, null), $getStartTime(this$static.measurementRangeEditor), $getEndTime(this$static.measurementRangeEditor)) , $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(this$static.resource.resourceType.id), of(($clinit_ResourceTypeRepository$MetadataType() , measurements_0)), new D3GraphListView$2_0(this$static, startTimer)) , undefined);
  $addMember(this$static, this$static.vLayout);
}

function $queryAvailability_0(this$static, context, startTime, endTime){
  var timerStart;
  timerStart = fromDouble(currentTimeMillis0());
  $getAvailabilitiesForResource(dynamicCast(secure(getInstance_35(), -1), Q$AvailabilityGWTServiceAsync), context.resourceId, startTime.value_0, endTime.value_0, new D3GraphListView$1_0(this$static, timerStart));
}

function $redrawGraphs_0(this$static){
  $onDraw_4(this$static);
  $drawJsniChart(this$static.availabilityGraph.availabilityGraphType);
}

function D3GraphListView_0(resource, definitionIds){
  $clinit_AbstractD3GraphListView();
  AbstractD3GraphListView_0.call(this);
  this.resource = resource;
  this.measurementRangeEditor = new UserPreferencesMeasurementRangeEditor_0;
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , HIDDEN).value_0, false);
  this.definitionIds = definitionIds;
  this.showAvailabilityGraph = true;
}

function D3GraphListView_1(resource){
  $clinit_AbstractD3GraphListView();
  AbstractD3GraphListView_0.call(this);
  this.resource = resource;
  this.showAvailabilityGraph = true;
  this.measurementRangeEditor = new UserPreferencesMeasurementRangeEditor_0;
  $setAttribute_24(this, 'overflow', ($clinit_Overflow() , HIDDEN).value_0, false);
  this.useSummaryData = true;
}

function createSingleGraph(resource, measurementId){
  $clinit_AbstractD3GraphListView();
  var definitionIds;
  definitionIds = new TreeSet_0;
  $put_2(definitionIds.map, measurementId, ($clinit_Boolean() , FALSE)) == null;
  return new D3GraphListView_0(resource, definitionIds);
}

defineSeed(3455, 2906, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$D3GraphListView, Q$Enhanced]), D3GraphListView_0, D3GraphListView_1);
_.onDraw_0 = function onDraw_54(){
  $onDraw_4(this);
}
;
_.redrawGraphs = function redrawGraphs_0(){
  $redrawGraphs_0(this);
}
;
_.definitionIds = null;
_.measurementOOBCompositeList = null;
_.metricsDataList = null;
_.resource = null;
_.useSummaryData = false;
_.vLayout = null;
function $onSuccess_381(this$static, availList){
  debug('\nSuccessfully queried availability in: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this$static.val$timerStart)) + ' ms.');
  this$static.this$0.availabilityList = availList;
}

function D3GraphListView$1_0(this$0, val$timerStart){
  this.this$0 = this$0;
  this.val$timerStart = val$timerStart;
}

defineSeed(3456, 1, {}, D3GraphListView$1_0);
_.onFailure = function onFailure_395(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load availability history'), caught);
}
;
_.onSuccess_0 = function onSuccess_395(availList){
  $onSuccess_381(this, dynamicCast(availList, Q$List));
}
;
_.this$0 = null;
_.val$timerStart = P0_longLit;
function $buildSummaryGraphs(this$static, measurementData, summaryMeasurementDefinitions, measurementDefinitions){
  var i, measurementDefinition, measurementDefinition$iterator, summaryIds, summaryMeasurementDefinition, summaryMeasurementDefinition$iterator;
  summaryIds = new TreeSet_0;
  for (summaryMeasurementDefinition$iterator = new AbstractList$IteratorImpl_0(summaryMeasurementDefinitions); summaryMeasurementDefinition$iterator.i < summaryMeasurementDefinition$iterator.this$0_0.size_1();) {
    summaryMeasurementDefinition = dynamicCast($next_0(summaryMeasurementDefinition$iterator), Q$MeasurementDefinition);
    $add_8(summaryIds, valueOf_44(summaryMeasurementDefinition.id));
  }
  i = 0;
  for (measurementDefinition$iterator = new AbstractList$IteratorImpl_0(measurementDefinitions); measurementDefinition$iterator.i < measurementDefinition$iterator.this$0_0.size_1();) {
    measurementDefinition = dynamicCast($next_0(measurementDefinition$iterator), Q$MeasurementDefinition);
    $contains_3(summaryIds, valueOf_44(measurementDefinition.id)) && $buildSingleGraph(this$static.this$0, measurementDefinition, (dynamicCast(measurementData.get_0(i), Q$List) , 195));
    ++i;
  }
}

function $determineGraphsToBuild(this$static, measurementData, measurementDefinitions, definitionIds){
  var i, measurementDefinition, measurementId, metric$iterator, selectedDefinitionId, selectedDefinitionId$iterator;
  i = 0;
  for (metric$iterator = measurementData.iterator(); metric$iterator.hasNext();) {
    dynamicCast(metric$iterator.next_0(), Q$List);
    for (selectedDefinitionId$iterator = $iterator($keySet(definitionIds.map)); selectedDefinitionId$iterator.val$outerIter.hasNext();) {
      selectedDefinitionId = dynamicCast($next_1(selectedDefinitionId$iterator), Q$Integer);
      measurementDefinition = dynamicCast((checkIndex(i, measurementDefinitions.size_0) , measurementDefinitions.array[i]), Q$MeasurementDefinition);
      measurementId = measurementDefinition.id;
      selectedDefinitionId?measurementId == selectedDefinitionId.value_0 && $buildSingleGraph(this$static.this$0, measurementDefinition, 225):$buildSingleGraph(this$static.this$0, measurementDefinition, 195);
    }
    ++i;
  }
}

function $queryOOBMetrics(this$static, resource, countDownLatch){
  var startTime;
  startTime = fromDouble(currentTimeMillis0());
  $getHighestNOOBsForResource(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), resource.id, 60, new D3GraphListView$2$5_0(this$static, startTime, countDownLatch, resource));
}

function D3GraphListView$2_0(this$0, val$startTimer){
  this.this$0 = this$0;
  this.val$startTimer = val$startTimer;
}

defineSeed(3457, 1, {}, D3GraphListView$2_0);
_.onTypesLoaded = function onTypesLoaded_42(type){
  var countDownLatch, def, def$iterator, i, measDefIdArray, measurementDefinitions, summaryMeasurementDefinitions;
  measurementDefinitions = new ArrayList_0;
  summaryMeasurementDefinitions = new ArrayList_0;
  for (def$iterator = type.metricDefinitions.iterator(); def$iterator.hasNext();) {
    def = dynamicCast(def$iterator.next_0(), Q$MeasurementDefinition);
    def.dataType == ($clinit_DataType() , MEASUREMENT) && def.displayType == ($clinit_DisplayType() , SUMMARY_0) && (setCheck(summaryMeasurementDefinitions.array, summaryMeasurementDefinitions.size_0++, def) , true);
    setCheck(measurementDefinitions.array, measurementDefinitions.size_0++, def);
  }
  sort_1(measurementDefinitions, new D3GraphListView$2$1_0);
  sort_1(summaryMeasurementDefinitions, new D3GraphListView$2$2_0);
  measDefIdArray = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, measurementDefinitions.size_0, 1);
  for (i = 0; i < measDefIdArray.length; ++i) {
    measDefIdArray[i] = dynamicCast((checkIndex(i, measurementDefinitions.size_0) , measurementDefinitions.array[i]), Q$MeasurementDefinition).id;
  }
  countDownLatch = new CountDownLatch_0(($clinit_AbstractD3GraphListView() , 2), new D3GraphListView$2$3_0(this, this.val$startTimer, summaryMeasurementDefinitions, measurementDefinitions));
  $findDataForResource(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), this.this$0.resource.id, measDefIdArray, $getStartTime(this.this$0.measurementRangeEditor).value_0, $getEndTime(this.this$0.measurementRangeEditor).value_0, new D3GraphListView$2$4_0(this, countDownLatch, this.val$startTimer));
  $queryOOBMetrics(this, this.this$0.resource, countDownLatch);
}
;
_.this$0 = null;
_.val$startTimer = P0_longLit;
function $compare_14(o1, o2){
  return $compareTo_5(new Integer_0(o1.displayOrder), valueOf_44(o2.displayOrder));
}

function D3GraphListView$2$1_0(){
}

defineSeed(3458, 1, makeCastMap([Q$Comparator]), D3GraphListView$2$1_0);
_.compare = function compare_15(o1, o2){
  return $compare_14(dynamicCast(o1, Q$MeasurementDefinition), dynamicCast(o2, Q$MeasurementDefinition));
}
;
function $compare_15(o1, o2){
  return $compareTo_5(new Integer_0(o1.displayOrder), valueOf_44(o2.displayOrder));
}

function D3GraphListView$2$2_0(){
}

defineSeed(3459, 1, makeCastMap([Q$Comparator]), D3GraphListView$2$2_0);
_.compare = function compare_16(o1, o2){
  return $compare_15(dynamicCast(o1, Q$MeasurementDefinition), dynamicCast(o2, Q$MeasurementDefinition));
}
;
function D3GraphListView$2$3_0(this$1, val$startTimer, val$summaryMeasurementDefinitions, val$measurementDefinitions){
  this.this$1 = this$1;
  this.val$startTimer = val$startTimer;
  this.val$summaryMeasurementDefinitions = val$summaryMeasurementDefinitions;
  this.val$measurementDefinitions = val$measurementDefinitions;
}

defineSeed(3460, 1, {}, D3GraphListView$2$3_0);
_.execute_1 = function execute_59(){
  debug('Total Time for async metrics/avail query: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this.val$startTimer)));
  if (this.this$1.this$0.metricsDataList.isEmpty_0()) {
    $setContents_0(($clinit_AbstractD3GraphListView() , loadingLabel_0), ($clinit_Enhanced() , 'No graphs available'));
  }
   else {
    $hide(($clinit_AbstractD3GraphListView() , loadingLabel_0));
    this.this$1.this$0.useSummaryData?$buildSummaryGraphs(this.this$1, this.this$1.this$0.metricsDataList, this.val$summaryMeasurementDefinitions, this.val$measurementDefinitions):$determineGraphsToBuild(this.this$1, this.this$1.this$0.metricsDataList, this.val$measurementDefinitions, this.this$1.this$0.definitionIds);
    if (this.this$1.this$0.availabilityGraph) {
      $setAvailabilityList_0(this.this$1.this$0.availabilityGraph, this.this$1.this$0.availabilityList);
      $drawJsniChart(this.this$1.this$0.availabilityGraph.availabilityGraphType);
    }
  }
}
;
_.this$1 = null;
_.val$measurementDefinitions = null;
_.val$startTimer = P0_longLit;
_.val$summaryMeasurementDefinitions = null;
function $onSuccess_382(this$static, metrics){
  this$static.this$1.this$0.metricsDataList = metrics;
  debug('Regular Metric graph data queried in: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this$static.val$startTimer)) + ' ms.');
  $countDown(this$static.val$countDownLatch);
}

function D3GraphListView$2$4_0(this$1, val$countDownLatch, val$startTimer){
  this.this$1 = this$1;
  this.val$countDownLatch = val$countDownLatch;
  this.val$startTimer = val$startTimer;
}

defineSeed(3461, 1, {}, D3GraphListView$2$4_0);
_.onFailure = function onFailure_396(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load graph data'), caught);
  $setContents_0(($clinit_AbstractD3GraphListView() , loadingLabel_0), 'Failed to load graph data');
  $countDown(this.val$countDownLatch);
}
;
_.onSuccess_0 = function onSuccess_396(metrics){
  $onSuccess_382(this, dynamicCast(metrics, Q$List));
}
;
_.this$1 = null;
_.val$countDownLatch = null;
_.val$startTimer = P0_longLit;
function $onSuccess_383(this$static, measurementOOBComposites){
  this$static.this$1.this$0.measurementOOBCompositeList = measurementOOBComposites;
  debug('\nSuccessfully queried ' + this$static.this$1.this$0.measurementOOBCompositeList.size_0 + ' OOB records in: ' + toString_8(sub(fromDouble(currentTimeMillis0()), this$static.val$startTime)) + ' ms.');
  $countDown(this$static.val$countDownLatch);
}

function D3GraphListView$2$5_0(this$1, val$startTime, val$countDownLatch, val$resource){
  this.this$1 = this$1;
  this.val$startTime = val$startTime;
  this.val$countDownLatch = val$countDownLatch;
  this.val$resource = val$resource;
}

defineSeed(3462, 1, {}, D3GraphListView$2$5_0);
_.onFailure = function onFailure_397(caught){
  debug('Error retrieving out of bound metrics for resource [' + this.val$resource.id + ']:' + caught.getMessage());
  $countDown(this.val$countDownLatch);
}
;
_.onSuccess_0 = function onSuccess_397(measurementOOBComposites){
  $onSuccess_383(this, dynamicCast(measurementOOBComposites, Q$PageList));
}
;
_.this$1 = null;
_.val$countDownLatch = null;
_.val$resource = null;
_.val$startTime = P0_longLit;
function MetricD3GraphView$1_0(this$0){
  $clinit_Timer();
  this.this$0 = this$0;
}

defineSeed(3463, 73, makeCastMap([Q$Timer]), MetricD3GraphView$1_0);
_.run = function run_14(){
  $drawJsniChart_0(this.this$0);
}
;
_.this$0 = null;
function $buildRecords_2(this$static, list){
  var definitions, schedule, schedule$iterator;
  definitions = new HashSet_0;
  for (schedule$iterator = new AbstractList$IteratorImpl_0(list); schedule$iterator.i < schedule$iterator.this$0_0.size_1();) {
    schedule = dynamicCast($next_0(schedule$iterator), Q$MeasurementSchedule);
    schedule.enabled && schedule.definition.dataType == ($clinit_DataType() , MEASUREMENT) && $add_6(definitions, schedule.definition);
  }
  return $buildRecords(this$static, definitions, true);
}

function $copyValues_59(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'name', from.name_0);
  $setAttribute_13(record, 'displayName', from.displayName);
  $setAttribute_13(record, 'description', from.description);
  $setAttribute_13(record, 'units', from.units.name_0);
  $setAttribute_13(record, 'numericType', from.numericType.name_0);
  $setAttribute_13(record, 'category', from.category.name_0);
  return record;
}

function $executeFetch_45(this$static, request, response){
  var criteria;
  if (convertToMap($getCriteria(request).jsObj).containsKey('id')) {
    criteria = new MeasurementDefinitionCriteria_0;
    $addFilterId(criteria, $getAttributeAsInt($getCriteria(request), 'id'));
    $setPageControl(criteria, $getPageControl(this$static, request));
    $findMeasurementDefinitionsByCriteria(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), criteria, new ResourceScheduledMetricDatasource$1_0(this$static, response, request));
  }
   else if (convertToMap($getCriteria(request).jsObj).containsKey('resourceId')) {
    criteria = new MeasurementScheduleCriteria_0;
    criteria.fetchDefinition = true;
    $addFilterResourceId_4(criteria, $getAttributeAsInt($getCriteria(request), 'resourceId'));
    $setPageControl(criteria, $getPageControl(this$static, request));
    $findMeasurementSchedulesByCriteria(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), criteria, new ResourceScheduledMetricDatasource$2_0(this$static, response, request));
  }
   else if (convertToMap($getCriteria(request).jsObj).containsKey('resourceGroupId')) {
    criteria = new MeasurementScheduleCriteria_0;
    criteria.fetchDefinition = true;
    $addFilterResourceGroupId_0(criteria, $getAttributeAsInt($getCriteria(request), 'resourceGroupId'));
    $findMeasurementSchedulesByCriteria(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), criteria, new ResourceScheduledMetricDatasource$3_0(this$static, response, request));
  }
   else {
    $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
  }
}

function ResourceScheduledMetricDatasource_0(){
  var fields_0, id, name_0, displayName, description, units, numericType, category;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  fields = (fields_0 = new ArrayList_0 , id = new DataSourceIntegerField_1('id', 'ID') , $setAttribute_8(id, 'primaryKey', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , setCheck(fields_0.array, fields_0.size_0++, id) , name_0 = new DataSourceTextField_1('name', 'Name') , setCheck(fields_0.array, fields_0.size_0++, name_0) , displayName = new DataSourceTextField_1('displayName', 'Display Name') , setCheck(fields_0.array, fields_0.size_0++, displayName) , description = new DataSourceTextField_1('description', 'Description') , setCheck(fields_0.array, fields_0.size_0++, description) , units = new DataSourceTextField_1('units', 'Units') , setCheck(fields_0.array, fields_0.size_0++, units) , numericType = new DataSourceTextField_1('numericType', 'Numeric Type') , setCheck(fields_0.array, fields_0.size_0++, numericType) , category = new DataSourceTextField_1('category', 'Category') , setCheck(fields_0.array, fields_0.size_0++, category) , fields_0);
  $addFields(this, fields);
}

defineSeed(3464, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceScheduledMetricDatasource_0);
_.copyValues = function copyValues_113(from){
  return null;
}
;
_.copyValues_0 = function copyValues_114(from){
  return $copyValues_59(dynamicCast(from, Q$MeasurementDefinition));
}
;
_.executeFetch = function executeFetch_62(request, response, unused){
  $executeFetch_45(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_71(request){
  return null;
}
;
function $onSuccess_384(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ResourceScheduledMetricDatasource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3465, 1, {}, ResourceScheduledMetricDatasource$1_0);
_.onFailure = function onFailure_398(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load metric definitions'), caught);
}
;
_.onSuccess_0 = function onSuccess_398(result){
  $onSuccess_384(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_385(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords_2(this$static.this$0, result));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ResourceScheduledMetricDatasource$2_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3466, 1, {}, ResourceScheduledMetricDatasource$2_0);
_.onFailure = function onFailure_399(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load metric schedules'), caught);
}
;
_.onSuccess_0 = function onSuccess_399(result){
  $onSuccess_385(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_386(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords_2(this$static.this$0, result));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ResourceScheduledMetricDatasource$3_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3467, 1, {}, ResourceScheduledMetricDatasource$3_0);
_.onFailure = function onFailure_400(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load metric schedules'), caught);
}
;
_.onSuccess_0 = function onSuccess_400(result){
  $onSuccess_386(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $createGraphMarker(this$static){
  var divAndSvgDefs, graph;
  debug('drawGraph marker in AvailabilityD3Graph for: ' + this$static.availabilityGraphType.entityId);
  divAndSvgDefs = new StringBuilder_0;
  $append_12(divAndSvgDefs, '<div id="availChart-' + this$static.availabilityGraphType.entityId + '" ><svg xmlns="http://www.w3.org/2000/svg" version="1.1" style="height:20px;">');
  $append_1(divAndSvgDefs.data_0, '<\/svg><\/div>');
  graph = new HTMLFlow_1($toString_1(divAndSvgDefs.data_0));
  $isCreated_1(graph)?$setProperty_3(graph, 'width', '100%'):(graph.config_0['width'] = '100%' , undefined);
  $isCreated_1(graph)?$setProperty_0(graph, 'height', 25):(graph.config_0['height'] = 25 , undefined);
  $addMember(this$static, graph);
}

function $setAvailabilityList_0(this$static, availabilityList){
  $setAvailabilityList(this$static.availabilityGraphType, availabilityList);
}

function $setGroupAvailabilityList_0(this$static, groupAvailabilityList){
  $setGroupAvailabilityList(this$static.availabilityGraphType, groupAvailabilityList);
}

function AvailabilityD3Graph_0(graphType){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.availabilityGraphType = graphType;
  $isCreated_1(this)?$setProperty_0(this, 'height', 25):(this.config_0['height'] = 25 , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
}

defineSeed(3468, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), AvailabilityD3Graph_0);
_.destroy_0 = function destroy_16(){
  destroyMembers(this);
  $destroy(this);
}
;
_.hide_0 = function hide_1(){
  $hide(this);
}
;
_.onDraw_0 = function onDraw_55(){
  $removeMembers(this, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')));
  $createGraphMarker(this);
}
;
_.parentResized_0 = function parentResized_2(){
  $parentResized(this);
  $removeMembers(this, convertToCanvasArray($getAttributeAsJavaScriptObject_1(this, 'members')));
  $createGraphMarker(this);
  $drawJsniChart(this.availabilityGraphType);
}
;
_.availabilityGraphType = null;
function $prepareTooltip(item, tooltip){
  $setHoverWidth_0(item, valueOf_44(400));
  $isCreated_2(item)?$setProperty_8(item, 'prompt', tooltip):(item.jsObj['prompt'] = tooltip , undefined);
}

function $reloadSummaryData(this$static){
  $getResourceAvailabilitySummary(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), this$static.resourceComposite.resource.id, new ResourceAvailabilityView$1_0(this$static));
}

function ResourceAvailabilityView_0(resourceComposite){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.resourceComposite = resourceComposite;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(3469, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ResourceAvailabilityView_0);
_.onInit = function onInit_66(){
  var form;
  $onInit(this);
  $onInit_Layout(this);
  $addMember(this, (form = new DynamicForm_0 , $isCreated_1(form)?$setProperty_3(form, 'width', '100%'):(form.config_0['width'] = '100%' , undefined) , $isCreated_1(form)?$setProperty_0(form, 'height', 1):(form.config_0['height'] = 1 , undefined) , $setMargin(form, valueOf_44(10)) , $isCreated_1(form)?$setProperty_0(form, 'numCols', 4):(form.config_0['numCols'] = 4 , undefined) , this.currentField = new StaticTextItem_2('current', ($clinit_Enhanced() , 'Current Status')) , $setWrapTitle(this.currentField, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , $setColSpan(this.currentField, 4) , this.availField = new StaticTextItem_2('avail', 'Availability') , $setWrapTitle(this.availField, FALSE) , $prepareTooltip(this.availField, 'Percentage of time the resource has been UP compared to the times it was down and disabled') , this.availTimeField = new StaticTextItem_2('availTime', 'Uptime') , $setWrapTitle(this.availTimeField, FALSE) , $prepareTooltip(this.availTimeField, 'The cumulative amount of time the resource has been UP') , this.downField = new StaticTextItem_2('down', 'Down') , $setWrapTitle(this.downField, FALSE) , $prepareTooltip(this.downField, 'Percentage of time the resource has been DOWN compared to the times it was up and disabled') , this.downTimeField = new StaticTextItem_2('downTime', 'Downtime') , $setWrapTitle(this.downTimeField, FALSE) , $prepareTooltip(this.downTimeField, 'The cumulative amount of time the resource has been DOWN') , this.disabledField = new StaticTextItem_2('disabled', 'Disabled') , $setWrapTitle(this.disabledField, FALSE) , $prepareTooltip(this.disabledField, 'Percentage of time the resource has been DISABLED compared to the times it was up and down') , this.disabledTimeField = new StaticTextItem_2('disabledTime', 'Disabled Time') , $setWrapTitle(this.disabledTimeField, FALSE) , $prepareTooltip(this.disabledTimeField, 'The cumulative amount of time the resource has been DISABLED') , this.failureCountField = new StaticTextItem_2('failureCount', 'Number of Failures') , $setWrapTitle(this.failureCountField, FALSE) , $prepareTooltip(this.failureCountField, 'The total number of times this resource has entered the DOWN state') , this.disabledCountField = new StaticTextItem_2('disabledCount', 'Number of Times Disabled') , $setWrapTitle(this.disabledCountField, FALSE) , $prepareTooltip(this.disabledCountField, 'The total number of times this resource has entered the DISABLED state') , this.mtbfField = new StaticTextItem_2('mtbf', 'MTBF') , $setWrapTitle(this.mtbfField, FALSE) , $prepareTooltip(this.mtbfField, 'Mean Time Before Failure - in short, this indicates the average time spent in the UP state prior to going DOWN') , this.mttrField = new StaticTextItem_2('mttr', 'MTTR') , $setWrapTitle(this.mttrField, FALSE) , $prepareTooltip(this.mttrField, 'Mean Time To Recovery - in short, this indicates the average time spent in the DOWN state prior to going UP again') , this.unknownField = new StaticTextItem_1('unknown') , $setWrapTitle(this.unknownField, FALSE) , $setColSpan(this.unknownField, 4) , $setShowTitle_0(this.unknownField, FALSE) , this.currentTimeField = new StaticTextItem_1('currentTime') , $setWrapTitle(this.currentTimeField, FALSE) , $setColSpan(this.currentTimeField, 4) , $setShowTitle_0(this.currentTimeField, FALSE) , form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.currentField, this.availField, this.availTimeField, this.downField, this.downTimeField, this.disabledField, this.disabledTimeField, this.failureCountField, this.disabledCountField, this.mtbfField, this.mttrField, this.unknownField, this.currentTimeField])) , $getResourceAvailabilitySummary(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), this.resourceComposite.resource.id, new ResourceAvailabilityView$1_0(this)) , form));
  $addMember(this, new ResourceAvailabilityView$ListView_0(this, this.resourceComposite.resource.id));
}
;
_.availField = null;
_.availTimeField = null;
_.currentField = null;
_.currentTimeField = null;
_.disabledCountField = null;
_.disabledField = null;
_.disabledTimeField = null;
_.downField = null;
_.downTimeField = null;
_.failureCountField = null;
_.mtbfField = null;
_.mttrField = null;
_.resourceComposite = null;
_.unknownField = null;
function $onSuccess_387(this$static, result){
  var totalTime, totalTime_0, totalTime_1;
  $setValue_7(this$static.this$0.currentField, 'This resource has been ' + ($clinit_Enhanced() , result.current.name_0) + ' since ' + ($clinit_TimestampCellFormatter() , format_30(valueOf_45((new Date_2(result.lastChange)).getTime_0()), DATE_TIME_FORMAT_MEDIUM)));
  $setValue_7(this$static.this$0.availField, ($clinit_MeasurementConverterClient() , format_91(new Double_0((totalTime = add(add(result.upTime, result.downTime), result.disabledTime) , neq(totalTime, P0_longLit)?toDouble(result.upTime) / toDouble(totalTime):0)), ($clinit_MeasurementUnits() , PERCENTAGE))));
  $setValue_7(this$static.this$0.availTimeField, format_91(new Double_0(toDouble(result.upTime)), MILLISECONDS));
  $setValue_7(this$static.this$0.downField, format_91(new Double_0((totalTime_0 = add(add(result.upTime, result.downTime), result.disabledTime) , neq(totalTime_0, P0_longLit)?toDouble(result.downTime) / toDouble(totalTime_0):0)), PERCENTAGE));
  $setValue_7(this$static.this$0.downTimeField, format_91(new Double_0(toDouble(result.downTime)), MILLISECONDS));
  $setValue_7(this$static.this$0.disabledField, format_91(new Double_0((totalTime_1 = add(add(result.upTime, result.downTime), result.disabledTime) , neq(totalTime_1, P0_longLit)?toDouble(result.disabledTime) / toDouble(totalTime_1):0)), PERCENTAGE));
  $setValue_7(this$static.this$0.disabledTimeField, format_91(new Double_0(toDouble(result.disabledTime)), MILLISECONDS));
  $setValue_5(this$static.this$0.failureCountField, result.failures);
  $setValue_5(this$static.this$0.disabledCountField, result.disabled);
  $setValue_7(this$static.this$0.mtbfField, format_91(new Double_0(toDouble($getMTBF(result))), MILLISECONDS));
  $setValue_7(this$static.this$0.mttrField, format_91(new Double_0(toDouble($getMTTR(result))), MILLISECONDS));
  gt(result.unknownTime, P0_longLit)?$setValue_7(this$static.this$0.unknownField, 'This resource was in an unknown state for ' + format_91(new Double_0(toDouble(result.unknownTime)), MILLISECONDS)):$setValue_7(this$static.this$0.unknownField, '');
  $setValue_7(this$static.this$0.currentTimeField, 'This data is current as of ' + format_30(valueOf_45(result.now), DATE_TIME_FORMAT_MEDIUM));
}

function ResourceAvailabilityView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3470, 1, {}, ResourceAvailabilityView$1_0);
_.onFailure = function onFailure_401(caught){
  $setValue_7(this.this$0.currentField, ($clinit_Enhanced() , 'Error'));
  $handleError_0(($clinit_CoreGUI() , 'Failed to load resource availability summary'), caught);
}
;
_.onSuccess_0 = function onSuccess_401(result){
  $onSuccess_387(this, dynamicCast(result, Q$ResourceAvailabilitySummary));
}
;
_.this$0 = null;
function ResourceAvailabilityView$ListView_0(this$0, resourceId){
  this.this$0 = this$0;
  Table_8.call(this, null, initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [new SortSpecifier_0('startTime', ($clinit_SortDirection() , DESCENDING))]));
  this.resourceId = resourceId;
  $setDataSource(this, (!this.dataSource && (this.dataSource = new ResourceAvailabilityView$ListView$DS_0(this.resourceId)) , this.dataSource));
}

defineSeed(3471, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ResourceAvailabilityView$ListView_0);
_.configureTable = function configureTable_57(){
  var dataSourceFields;
  dataSourceFields = $getListGridFields_19(!this.dataSource && (this.dataSource = new ResourceAvailabilityView$ListView$DS_0(this.resourceId)));
  $setFields_1(this.listGrid, dynamicCast($toArray_1(dataSourceFields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, dataSourceFields.size_0, 0)), Q$ListGridField_$1));
}
;
_.configureTableContents = function configureTableContents_2(contents){
  $configureTableContents(contents);
  $isCreated_1(this)?$setProperty_0(this, 'height', 1):(this.config_0['height'] = 1 , undefined);
}
;
_.getDataSource_0 = function getDataSource_26(){
  return !this.dataSource && (this.dataSource = new ResourceAvailabilityView$ListView$DS_0(this.resourceId)) , this.dataSource;
}
;
_.refresh_0 = function refresh_42(){
  $refresh(this, false);
  $reloadSummaryData(this.this$0);
}
;
_.dataSource = null;
_.resourceId = 0;
_.this$0 = null;
function $copyValues_60(from){
  var duration, record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'availabilityType', getAvailabilityIconFromAvailTypeAndSize(from.availabilityType, false));
  $setAttribute_14(record, 'startTime', new Date_2(from.startTime.value_0));
  if (from.endTime) {
    $setAttribute_14(record, 'endTime', new Date_2(from.endTime.value_0));
    duration = sub(from.endTime.value_0, from.startTime.value_0);
    $setAttribute_13(record, 'duration', ($clinit_MeasurementConverterClient() , format_91(new Double_0(toDouble(duration)), ($clinit_MeasurementUnits() , MILLISECONDS))));
  }
   else {
    record.jsObj['endTime'] = 'none';
    duration = sub(fromDouble(currentTimeMillis0()), from.startTime.value_0);
    $setAttribute_13(record, 'duration', ($clinit_MeasurementConverterClient() , format_91(new Double_0(toDouble(duration)), ($clinit_MeasurementUnits() , MILLISECONDS))));
  }
  return record;
}

function $executeFetch_46(this$static, request, response, criteria){
  $findAvailabilityByCriteria(this$static.availService, criteria, new ResourceAvailabilityView$ListView$DS$1_0(this$static, response, request));
}

function $getListGridFields_19(){
  var availabilityField, durationField, endTimeField, fields, startTimeField;
  fields = new ArrayList_1(6);
  startTimeField = new ListGridField_3('startTime', 'Start');
  $setCellFormatter_0(startTimeField, new TimestampCellFormatter_0);
  $setAttribute_8(startTimeField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(startTimeField, ($clinit_TimestampCellFormatter() , new TimestampCellFormatter$1_0('startTime')));
  $setAttribute_8(startTimeField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, startTimeField);
  endTimeField = new ListGridField_3('endTime', 'End');
  $setCellFormatter_0(endTimeField, new TimestampCellFormatter_0);
  $setAttribute_8(endTimeField, 'showHover', TRUE);
  $setHoverCustomizer_0(endTimeField, new TimestampCellFormatter$1_0('endTime'));
  $setAttribute_8(endTimeField, 'canSortClientOnly', TRUE);
  setCheck(fields.array, fields.size_0++, endTimeField);
  durationField = new ListGridField_3('duration', 'Duration');
  $setAttribute_13(durationField, 'align', ($clinit_Alignment() , RIGHT_0).value_0);
  setCheck(fields.array, fields.size_0++, durationField);
  availabilityField = new ListGridField_3('availabilityType', 'Availability');
  $setAttribute_13(availabilityField, 'type', ($clinit_ListGridFieldType() , IMAGE_0).value_0);
  $setAttribute_13(availabilityField, 'align', CENTER_0.value_0);
  setCheck(fields.array, fields.size_0++, availabilityField);
  return fields;
}

function ResourceAvailabilityView$ListView$DS_0(resourceId){
  $clinit_RPCDataSource();
  RPCDataSource_0.call(this);
  this.availService = dynamicCast(secure(getInstance_35(), -1), Q$AvailabilityGWTServiceAsync);
  this.resourceId = resourceId;
  new ArrayList_0;
}

defineSeed(3472, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceAvailabilityView$ListView$DS_0);
_.copyValues = function copyValues_115(from){
  return null;
}
;
_.copyValues_0 = function copyValues_116(from){
  return $copyValues_60(dynamicCast(from, Q$Availability));
}
;
_.executeFetch = function executeFetch_63(request, response, criteria){
  $executeFetch_46(this, request, response, dynamicCast(criteria, Q$AvailabilityCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_72(request){
  var c, pageControl;
  return c = new AvailabilityCriteria_0 , $addFilterResourceId(c, valueOf_44(this.resourceId)) , $addFilterInitialAvailability(c, ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , pageControl = $getPageControl(this, request) , pageControl.orderingFields.size_0 == 0 && $initDefaultOrderingField(pageControl, 'startTime', ($clinit_PageOrdering() , DESC)) , c;
}
;
_.resourceId = 0;
function $onFailure_46(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Error'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$2, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_388(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$2, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_0));
  $processResponse_0(this$static.this$2, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ResourceAvailabilityView$ListView$DS$1_0(this$2, val$response, val$request){
  this.this$2 = this$2;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3473, 1, {}, ResourceAvailabilityView$ListView$DS$1_0);
_.onFailure = function onFailure_402(caught){
  $onFailure_46(this, caught);
}
;
_.onSuccess_0 = function onSuccess_402(result){
  $onSuccess_388(this, dynamicCast(result, Q$PageList));
}
;
_.this$2 = null;
_.val$request = null;
_.val$response = null;
function $clinit_ResourceSchedulesView(){
  $clinit_ResourceSchedulesView = nullMethod;
  $clinit_AbstractSchedulesView();
  TITLE_3 = ($clinit_Enhanced() , 'Resource Metric Collection Schedules');
}

function ResourceSchedulesView_0(resourceComposite){
  $clinit_ResourceSchedulesView();
  AbstractSchedulesView_0.call(this, TITLE_3, new EntityContext_0(valueOf_44(resourceComposite.resource.id), null, null), resourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , MANAGE_MEASUREMENTS)));
  this.resourceId = resourceComposite.resource.id;
}

defineSeed(3474, 1753, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ResourceSchedulesView_0);
_.disableSchedules = function disableSchedules_1(measurementDefinitionIds, measurementDefinitionDisplayNames){
  $disableSchedulesForResource(this.measurementService, this.resourceId, measurementDefinitionIds, new ResourceSchedulesView$2_0(this, measurementDefinitionIds, measurementDefinitionDisplayNames));
}
;
_.enableSchedules = function enableSchedules_1(measurementDefinitionIds, measurementDefinitionDisplayNames){
  $enableSchedulesForResource(this.measurementService, this.resourceId, measurementDefinitionIds, new ResourceSchedulesView$1_0(this, measurementDefinitionIds, measurementDefinitionDisplayNames));
}
;
_.updateSchedules = function updateSchedules_1(measurementDefinitionIds, measurementDefinitionDisplayNames, collectionInterval){
  $updateSchedulesForResource(this.measurementService, this.resourceId, measurementDefinitionIds, collectionInterval, new ResourceSchedulesView$3_0(this, measurementDefinitionIds, measurementDefinitionDisplayNames, collectionInterval));
}
;
_.resourceId = 0;
var TITLE_3;
function $onSuccess_389(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('You have enabled the collection of [' + ($clinit_Enhanced() , '' + this$static.val$measurementDefinitionIds.length) + '] measurements', 'You have enabled the collection of [' + this$static.val$measurementDefinitionIds.length + '] measurements for the resource with ID [' + this$static.this$0.resourceId + ']. The enabled measurements are: [' + this$static.val$measurementDefinitionDisplayNames.toString$() + ']', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceSchedulesView$1_0(this$0, val$measurementDefinitionIds, val$measurementDefinitionDisplayNames){
  this.this$0 = this$0;
  this.val$measurementDefinitionIds = val$measurementDefinitionIds;
  this.val$measurementDefinitionDisplayNames = val$measurementDefinitionDisplayNames;
}

defineSeed(3475, 1, {}, ResourceSchedulesView$1_0);
_.onFailure = function onFailure_403(throwable){
  $handleError_0(($clinit_CoreGUI() , 'Failed to enable the collection of [' + ($clinit_Enhanced() , '' + this.val$measurementDefinitionIds.length) + '] metrics for resource with ID [' + this.this$0.resourceId + ']. The metrics were: [' + this.val$measurementDefinitionDisplayNames.toString$() + ']'), throwable);
}
;
_.onSuccess_0 = function onSuccess_403(aVoid){
  $onSuccess_389(this, throwClassCastExceptionUnlessNull(aVoid));
}
;
_.this$0 = null;
_.val$measurementDefinitionDisplayNames = null;
_.val$measurementDefinitionIds = null;
function $onSuccess_390(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('You have disabled the collection of [' + ($clinit_Enhanced() , '' + this$static.val$measurementDefinitionIds.length) + '] measurements', 'You have disabled the collection of [' + this$static.val$measurementDefinitionIds.length + '] measurements for the resource with ID [' + this$static.this$0.resourceId + ']. The disabled measurements are: [' + this$static.val$measurementDefinitionDisplayNames.toString$() + ']', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceSchedulesView$2_0(this$0, val$measurementDefinitionIds, val$measurementDefinitionDisplayNames){
  this.this$0 = this$0;
  this.val$measurementDefinitionIds = val$measurementDefinitionIds;
  this.val$measurementDefinitionDisplayNames = val$measurementDefinitionDisplayNames;
}

defineSeed(3476, 1, {}, ResourceSchedulesView$2_0);
_.onFailure = function onFailure_404(throwable){
  $handleError_0(($clinit_CoreGUI() , 'Failed to disable the collection of [' + ($clinit_Enhanced() , '' + this.val$measurementDefinitionIds.length) + '] metrics for resource with ID [' + this.this$0.resourceId + ']. The metrics were: [' + this.val$measurementDefinitionDisplayNames.toString$() + ']'), throwable);
}
;
_.onSuccess_0 = function onSuccess_404(aVoid){
  $onSuccess_390(this, throwClassCastExceptionUnlessNull(aVoid));
}
;
_.this$0 = null;
_.val$measurementDefinitionDisplayNames = null;
_.val$measurementDefinitionIds = null;
function $onSuccess_391(this$static){
  var collIntervalStr;
  collIntervalStr = '' + toString_8(div(this$static.val$collectionInterval, P3e8_longLit));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_2('A new collection interval of [' + ($clinit_Enhanced() , collIntervalStr) + '] seconds has been set on [' + this$static.val$measurementDefinitionIds.length + '] measurements', 'A new collection interval of [' + collIntervalStr + '] seconds has been set on [' + this$static.val$measurementDefinitionIds.length + '] measurements for resource with ID [' + this$static.this$0.resourceId + ']. The updated measurements are: [' + this$static.val$measurementDefinitionDisplayNames.toString$() + ']', ($clinit_Message$Severity() , Info)));
  $refresh(this$static.this$0, false);
}

function ResourceSchedulesView$3_0(this$0, val$measurementDefinitionIds, val$measurementDefinitionDisplayNames, val$collectionInterval){
  this.this$0 = this$0;
  this.val$measurementDefinitionIds = val$measurementDefinitionIds;
  this.val$measurementDefinitionDisplayNames = val$measurementDefinitionDisplayNames;
  this.val$collectionInterval = val$collectionInterval;
}

defineSeed(3477, 1, {}, ResourceSchedulesView$3_0);
_.onFailure = function onFailure_405(throwable){
  $handleError_0(($clinit_CoreGUI() , 'Failed to set the collection interval of [' + ($clinit_Enhanced() , '' + this.val$measurementDefinitionIds.length) + '] metrics for resource with ID [' + this.this$0.resourceId + ']. The metrics were: [' + this.val$measurementDefinitionDisplayNames.toString$() + ']. The collection interval was to be [' + toString_8(div(this.val$collectionInterval, P3e8_longLit)) + '] seconds.'), throwable);
}
;
_.onSuccess_0 = function onSuccess_405(aVoid){
  $onSuccess_391(this, throwClassCastExceptionUnlessNull(aVoid));
}
;
_.this$0 = null;
_.val$collectionInterval = P0_longLit;
_.val$measurementDefinitionDisplayNames = null;
_.val$measurementDefinitionIds = null;
function $onSuccess_392(this$static, result){
  var i, measurementSchedule, measurementSchedule$iterator, mprefs, prefs, range, schedIds;
  schedIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, result.size_0, 1);
  i = 0;
  for (measurementSchedule$iterator = new AbstractList$IteratorImpl_0(result); measurementSchedule$iterator.i < measurementSchedule$iterator.this$0_0.size_1();) {
    measurementSchedule = dynamicCast($next_0(measurementSchedule$iterator), Q$MeasurementSchedule);
    schedIds[i++] = measurementSchedule.id;
  }
  prefs = ($clinit_UserSessionManager() , $clinit_UserSessionManager() , userPreferences);
  mprefs = new MeasurementUserPreferences_0(prefs);
  range = $getBeginEndTimes($getMetricRangePreferences(mprefs));
  $getMetricDisplaySummariesForResource(dynamicCast(secure((!instance_17 && (instance_17 = new MeasurementChartsGWTService_Proxy_0) , instance_17), -1), Q$MeasurementChartsGWTServiceAsync), this$static.this$0.resourceId, schedIds, dynamicCast((checkIndex(0, range.size_0) , range.array[0]), Q$Long).value_0, dynamicCast((checkIndex(1, range.size_0) , range.array[1]), Q$Long).value_0, new MeasurementTableDataSource$1$1_0(this$static, this$static.val$response, this$static.val$request));
}

function MeasurementTableDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3478, 1, {}, MeasurementTableDataSource$1_0);
_.onFailure = function onFailure_406(caught){
  $handleError_0(($clinit_CoreGUI() , 'Cannot load schedules'), caught);
}
;
_.onSuccess_0 = function onSuccess_406(result){
  $onSuccess_392(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onSuccess_393(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$1.this$0, result, true));
  $processResponse_0(this$static.this$1.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function MeasurementTableDataSource$1$1_0(this$1, val$response, val$request){
  this.this$1 = this$1;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3479, 1, {}, MeasurementTableDataSource$1$1_0);
_.onFailure = function onFailure_407(caught){
  $handleError_0(($clinit_CoreGUI() , 'Cannot load metrics'), caught);
}
;
_.onSuccess_0 = function onSuccess_407(result){
  $onSuccess_393(this, dynamicCast(result, Q$ArrayList));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function $showLiveData_0(this$static, records){
  var liveDataGrid, liveDataWindow, name_0, value;
  liveDataWindow = new Window_1;
  $setTitle(liveDataWindow, ($clinit_Enhanced() , 'Live Data'));
  $setShowModalMask(liveDataWindow, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setShowMinimizeButton(liveDataWindow, FALSE);
  $setShowMaximizeButton(liveDataWindow, TRUE);
  $setShowCloseButton(liveDataWindow, TRUE);
  $setShowResizer(liveDataWindow, TRUE);
  $setCanDragResize_0(liveDataWindow, TRUE);
  $setDismissOnEscape(liveDataWindow, TRUE);
  $setIsModal(liveDataWindow, TRUE);
  $isCreated_1(liveDataWindow)?$setProperty_0(liveDataWindow, 'width', 700):(liveDataWindow.config_0['width'] = 700 , undefined);
  $isCreated_1(liveDataWindow)?$setProperty_0(liveDataWindow, 'height', 425):(liveDataWindow.config_0['height'] = 425 , undefined);
  $setAutoCenter(liveDataWindow, TRUE);
  $centerInPage(liveDataWindow);
  $addCloseClickHandler(liveDataWindow, new MeasurementTableView$3_0(this$static, liveDataWindow));
  liveDataGrid = new ListGrid_0;
  $setShowAllRecords(liveDataGrid, TRUE);
  $setData(liveDataGrid, dynamicCast($toArray_1(records, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, records.size_0, 0)), Q$ListGridRecord_$1));
  $setAttribute_24(liveDataGrid, 'selectionType', ($clinit_SelectionStyle() , NONE_4).value_0, true);
  name_0 = new ListGridField_3('name', 'Metric');
  value = new ListGridField_3('value', 'Value');
  $isCreated_1(liveDataGrid)?$setProperty_2(liveDataGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [name_0, value]))):(liveDataGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [name_0, value])) , undefined);
  $addItem(liveDataWindow, liveDataGrid);
  liveDataWindow.show_0();
}

function MeasurementTableView_0(resourceId){
  $clinit_BaseWidget();
  Table_1.call(this);
  this.resourceId = resourceId;
  $setDataSource(this, new MeasurementTableDataSource_0(resourceId));
}

defineSeed(3480, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), MeasurementTableView_0);
_.configureTable = function configureTable_58(){
  var fields;
  fields = dynamicCast(this.dataSource_1, Q$MeasurementTableDataSource).getListGridFields_0();
  $setListGridFields(this, false, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, 0, 0)), Q$ListGridField_$1));
  $addExtraWidget(this, new UserPreferencesMeasurementRangeEditor_0, true);
  $addTableAction(this, ($clinit_Enhanced() , 'Get Live Value'), null, null, new MeasurementTableView$1_0(this));
  $addTableAction(this, 'Chart Selected Metrics', null, null, new MeasurementTableView$2_0(this));
}
;
_.resourceId = 0;
function MeasurementTableView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3481, 1, {}, MeasurementTableView$1_0);
_.executeAction = function executeAction_84(selection, actionValue){
  var defId, definitionIds, i, label, name_0, record, record$index, record$max, scheduleNamesAndUnits, units;
  if (selection == null || selection.length == 0) {
    return;
  }
  scheduleNamesAndUnits = new HashMap_0;
  definitionIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selection.length, 1);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    defId = getAttributeAsInt(record.jsObj, 'defId');
    definitionIds[i++] = defId.value_0;
    name_0 = getAttribute(record.jsObj, 'name');
    label = getAttribute(record.jsObj, 'label');
    units = getAttribute(record.jsObj, 'units');
    (units == null || units.length < 1) && (units = ($clinit_MeasurementUnits() , NONE_8).name_0);
    scheduleNamesAndUnits.put(name_0, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, [label, units]));
  }
  $findLiveData(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), 60000), Q$MeasurementDataGWTServiceAsync), this.this$0.resourceId, definitionIds, new MeasurementTableView$1$1_0(this, scheduleNamesAndUnits));
}
;
_.isEnabled_0 = function isEnabled_37(selection){
  return selection != null && selection.length > 0;
}
;
_.this$0 = null;
function $onSuccess_394(this$static, result){
  var data, data$iterator, doubleValue, nameAndUnits, record, records, value;
  !result && (result = new HashSet_1(0));
  records = new ArrayList_1(result.size_1());
  for (data$iterator = result.iterator(); data$iterator.hasNext();) {
    data = dynamicCast(data$iterator.next_0(), Q$MeasurementData);
    nameAndUnits = dynamicCast(this$static.val$scheduleNamesAndUnits.get_2(data.name_0), Q$String_$1);
    if (nameAndUnits != null) {
      instanceOf(data.getValue_1(), Q$Number)?(doubleValue = dynamicCast(data.getValue_1(), Q$Number).doubleValue()):(doubleValue = __parseAndValidateDouble(toString__devirtual$(data.getValue_1())));
      value = formatToSignificantPrecision(initValues(_3D_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, [doubleValue]), valueOf_100(nameAndUnits[1]))[0];
      record = new ListGridRecord_0;
      record.jsObj['name'] = nameAndUnits[0];
      record.jsObj['value'] = value;
      setCheck(records.array, records.size_0++, record);
    }
  }
  sort_1(records, new MeasurementTableView$1$1$1_0);
  $showLiveData_0(this$static.this$1.this$0, records);
}

function MeasurementTableView$1$1_0(this$1, val$scheduleNamesAndUnits){
  this.this$1 = this$1;
  this.val$scheduleNamesAndUnits = val$scheduleNamesAndUnits;
}

defineSeed(3482, 1, {}, MeasurementTableView$1$1_0);
_.onFailure = function onFailure_408(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get live values for those metrics. Make sure the agent is running and the managed resource is up.'), caught);
}
;
_.onSuccess_0 = function onSuccess_408(result){
  $onSuccess_394(this, dynamicCast(result, Q$Set));
}
;
_.this$1 = null;
_.val$scheduleNamesAndUnits = null;
function $compare_16(o1, o2){
  return compareTo_11(getAttribute(o1.jsObj, 'name'), getAttribute(o2.jsObj, 'name'));
}

function MeasurementTableView$1$1$1_0(){
}

defineSeed(3483, 1, makeCastMap([Q$Comparator]), MeasurementTableView$1$1$1_0);
_.compare = function compare_17(o1, o2){
  return $compare_16(dynamicCast(o1, Q$ListGridRecord), dynamicCast(o2, Q$ListGridRecord));
}
;
function MeasurementTableView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3484, 1, {}, MeasurementTableView$2_0);
_.executeAction = function executeAction_85(selection, actionValue){
  var criteria, defId, definitionIds, record, record$index, record$max;
  if (selection == null || selection.length == 0) {
    return;
  }
  definitionIds = new TreeSet_0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    defId = getAttributeAsInt(record.jsObj, 'defId');
    $put_2(definitionIds.map, defId, ($clinit_Boolean() , FALSE)) == null;
  }
  criteria = new ResourceCriteria_0;
  $addFilterId(criteria, valueOf_44(this.this$0.resourceId));
  criteria.fetchSchedules = true;
  $findResourceCompositesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), criteria, new MeasurementTableView$2$1_0(this, definitionIds));
}
;
_.isEnabled_0 = function isEnabled_38(selection){
  return selection != null && selection.length > 0;
}
;
_.this$0 = null;
function $onFailure_47(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Resource with id [' + ($clinit_Enhanced() , '' + this$static.this$1.this$0.resourceId) + '] does not exist or is not accessible', ($clinit_Message$Severity() , Warning)));
  goToView(($clinit_InventoryView() , VIEW_ID_21).name_0, null, false);
}

function $onSuccess_395(this$static, result){
  var graphListView, resourceComposite, window_0;
  if (result.size_0 == 0) {
    $onFailure_47(this$static, new Exception_1('Resource with id [' + ($clinit_Enhanced() , '' + this$static.this$1.this$0.resourceId) + '] does not exist or is not accessible'));
  }
   else {
    resourceComposite = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceComposite);
    window_0 = new AbstractActivityView$ChartViewWindow_0('');
    graphListView = ($clinit_AbstractD3GraphListView() , new D3GraphListView_0(resourceComposite.resource, this$static.val$definitionIds));
    $addSetButtonClickHandler(graphListView, new MeasurementTableView$2$1$1_0(graphListView));
    $addItem(window_0, graphListView);
    $show(window_0);
    $refreshTableInfo(this$static.this$1.this$0);
  }
}

function MeasurementTableView$2$1_0(this$1, val$definitionIds){
  this.this$1 = this$1;
  this.val$definitionIds = val$definitionIds;
}

defineSeed(3485, 1, {}, MeasurementTableView$2$1_0);
_.onFailure = function onFailure_409(caught){
  $onFailure_47(this);
}
;
_.onSuccess_0 = function onSuccess_409(result){
  $onSuccess_395(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
_.val$definitionIds = null;
function MeasurementTableView$2$1$1_0(val$graphListView){
  this.val$graphListView = val$graphListView;
}

defineSeed(3486, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), MeasurementTableView$2$1$1_0);
_.onClick_0 = function onClick_164(event_0){
  $redrawGraphs_0(this.val$graphListView);
}
;
_.val$graphListView = null;
function MeasurementTableView$3_0(this$0, val$liveDataWindow){
  this.this$0 = this$0;
  this.val$liveDataWindow = val$liveDataWindow;
}

defineSeed(3487, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), MeasurementTableView$3_0);
_.onCloseClick_0 = function onCloseClick_17(event_0){
  $destroy(this.val$liveDataWindow);
  $refreshTableInfo(this.this$0);
}
;
_.this$0 = null;
_.val$liveDataWindow = null;
function TraitsDataSource_2(){
  $clinit_RPCDataSource();
  AbstractMeasurementDataTraitDataSource_0.call(this);
}

defineSeed(3488, 2907, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractMeasurementDataTraitDataSource]), TraitsDataSource_2);
_.addDataSourceFields = function addDataSourceFields_4(){
  var fields, resourceIdField;
  fields = $addDataSourceFields_2();
  resourceIdField = new DataSourceIntegerField_1('resourceId', 'Resource ID');
  $setAttribute_8(resourceIdField, 'hidden', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $add_2(fields, 0, resourceIdField);
  return fields;
}
;
_.copyValues_4 = function copyValues_117(from){
  var record;
  record = $copyValues_41(from);
  $setAttribute_3(record, 'resourceId', from.schedule.resource.id);
  return record;
}
;
function TraitsDetailView_2(resourceId, definitionId){
  var criteria;
  $clinit_AbstractMeasurementDataTraitListDetailView();
  AbstractMeasurementDataTraitListDetailView_0.call(this, new TraitsDataSource_2, (criteria = new Criteria_0 , $addCriteria_1(criteria, 'resourceId', valueOf_44(resourceId)) , $addCriteria_1(criteria, 'definitionId', valueOf_44(definitionId)) , criteria));
}

defineSeed(3489, 2909, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), TraitsDetailView_2);
_.configureTable = function configureTable_59(){
  $configureTable_7(this);
}
;
function TraitsView_2(resourceId){
  var criteria;
  $clinit_AbstractMeasurementDataTraitListView();
  AbstractMeasurementDataTraitListView_0.call(this, new TraitsDataSource_2, (criteria = new Criteria_0 , $addCriteria_1(criteria, 'resourceId', valueOf_44(resourceId)) , $addCriteria(criteria, 'maxTimestamp', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , criteria));
  this.resourceId = resourceId;
}

defineSeed(3490, 2911, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), TraitsView_2);
_.configureTable = function configureTable_60(){
  $configureTable_8(this);
}
;
_.decorateLiveDataGrid = function decorateLiveDataGrid_0(records){
  var liveDataGrid, name_0, value;
  liveDataGrid = new ListGrid_0;
  $setShowAllRecords(liveDataGrid, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setData(liveDataGrid, dynamicCast($toArray_1(records, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, records.size_0, 0)), Q$ListGridRecord_$1));
  $setAttribute_24(liveDataGrid, 'selectionType', ($clinit_SelectionStyle() , NONE_4).value_0, true);
  name_0 = new ListGridField_3('name', ($clinit_Enhanced() , 'Trait'));
  value = new ListGridField_3('value', 'Value');
  $isCreated_1(liveDataGrid)?$setProperty_2(liveDataGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [name_0, value]))):(liveDataGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [name_0, value])) , undefined);
  return liveDataGrid;
}
;
_.getDetailsView_0 = function getDetailsView_28(definitionId){
  return new TraitsDetailView_2(this.resourceId, definitionId.value_0);
}
;
_.getLiveValueAction = function getLiveValueAction_0(){
  return new TraitsView$1_2(this);
}
;
_.resourceId = 0;
function TraitsView$1_2(this$0){
  this.this$0 = this$0;
}

defineSeed(3491, 1, {}, TraitsView$1_2);
_.executeAction = function executeAction_86(selection, actionValue){
  var defId, definitionIds, i, record, record$index, record$max, scheduleNames;
  if (selection == null || selection.length == 0) {
    return;
  }
  scheduleNames = new HashMap_0;
  definitionIds = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selection.length, 1);
  i = 0;
  for (record$index = 0 , record$max = selection.length; record$index < record$max; ++record$index) {
    record = selection[record$index];
    defId = getAttributeAsInt(record.jsObj, 'id');
    definitionIds[i++] = defId.value_0;
    scheduleNames.put(getAttribute(record.jsObj, 'name'), getAttribute(record.jsObj, 'displayName'));
  }
  $findLiveData(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), 60000), Q$MeasurementDataGWTServiceAsync), this.this$0.resourceId, definitionIds, new TraitsView$1$1_0(this, scheduleNames));
}
;
_.isEnabled_0 = function isEnabled_39(selection){
  return selection != null && selection.length > 0;
}
;
_.this$0 = null;
function $onSuccess_396(this$static, result){
  var data, data$iterator, record, records;
  !result && (result = new HashSet_1(0));
  records = new ArrayList_1(result.size_1());
  for (data$iterator = result.iterator(); data$iterator.hasNext();) {
    data = dynamicCast(data$iterator.next_0(), Q$MeasurementData);
    record = new ListGridRecord_0;
    $setAttribute_13(record, 'name', dynamicCast(this$static.val$scheduleNames.get_2(data.name_0), Q$String));
    $setAttribute_12(record, 'value', data.getValue_1());
    setCheck(records.array, records.size_0++, record);
  }
  sort_1(records, new TraitsView$1$1$1_0);
  $showLiveData(this$static.this$1.this$0, records);
}

function TraitsView$1$1_0(this$1, val$scheduleNames){
  this.this$1 = this$1;
  this.val$scheduleNames = val$scheduleNames;
}

defineSeed(3492, 1, {}, TraitsView$1$1_0);
_.onFailure = function onFailure_410(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Cannot get live values for those metrics. Make sure the agent is running and the managed resource is up.'), caught);
}
;
_.onSuccess_0 = function onSuccess_410(result){
  $onSuccess_396(this, dynamicCast(result, Q$Set));
}
;
_.this$1 = null;
_.val$scheduleNames = null;
function $compare_17(o1, o2){
  return compareTo_11(getAttribute(o1.jsObj, 'name'), getAttribute(o2.jsObj, 'name'));
}

function TraitsView$1$1$1_0(){
}

defineSeed(3493, 1, makeCastMap([Q$Comparator]), TraitsView$1$1$1_0);
_.compare = function compare_18(o1, o2){
  return $compare_17(dynamicCast(o1, Q$ListGridRecord), dynamicCast(o2, Q$ListGridRecord));
}
;
function $copyValues_61(this$static, from){
  var record;
  record = $copyValues_32(from);
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, 'resource', from.resource.name_0);
  $setAttribute_3(record, 'resourceId', from.resource.id);
  $setAttribute_13(record, 'resourceName', from.resource.name_0);
  $setAttribute_13(record, 'resourceAncestry', from.resource.ancestry);
  $setAttribute_3(record, 'resourceTypeId', from.resource.resourceType.id);
  return record;
}

function $dataRetrieved_7(this$static, result, response, request){
  var ancestries, history_0, history$iterator, resource, typeRepo, typesSet;
  typesSet = new HashSet_0;
  ancestries = new HashSet_0;
  for (history$iterator = new AbstractList$IteratorImpl_0(result); history$iterator.i < history$iterator.this$0_0.size_1();) {
    history_0 = dynamicCast($next_0(history$iterator), Q$ResourceOperationHistory);
    resource = history_0.resource;
    $add_6(typesSet, valueOf_44(resource.resourceType.id));
    $add_6(ancestries, resource.ancestry);
  }
  $addAll(typesSet, getAncestryTypeIds(ancestries));
  typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new ResourceOperationHistoryDataSource$2_0(this$static, result, response, request));
}

function $executeFetch_47(this$static, request, response, criteria){
  $findResourceOperationHistoriesByCriteria(this$static.operationService, criteria, new ResourceOperationHistoryDataSource$1_0(this$static, response, request));
}

function $getFetchCriteria_13(request){
  var criteria, groupOperationHistoryId, resourceId;
  criteria = new ResourceOperationHistoryCriteria_0;
  if (convertToMap($getCriteria(request).jsObj).containsKey('resourceId')) {
    resourceId = dynamicCast(getFilter($getCriteria(request), 'resourceId', Ljava_lang_Integer_2_classLit), Q$Integer).value_0;
    $addFilterResourceIds_5(criteria, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [valueOf_44(resourceId)]));
  }
  if (convertToMap($getCriteria(request).jsObj).containsKey('groupOperationHistoryId')) {
    groupOperationHistoryId = dynamicCast(getFilter($getCriteria(request), 'groupOperationHistoryId', Ljava_lang_Integer_2_classLit), Q$Integer).value_0;
    $addFilterGroupOperationHistoryId(criteria, valueOf_44(groupOperationHistoryId));
  }
  return criteria;
}

function ResourceOperationHistoryDataSource_0(){
  $clinit_RPCDataSource();
  AbstractOperationHistoryDataSource_0.call(this);
}

defineSeed(3494, 2529, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractOperationHistoryDataSource]), ResourceOperationHistoryDataSource_0);
_.addDataSourceFields = function addDataSourceFields_5(){
  var fields, resourceField;
  fields = $addDataSourceFields_1();
  resourceField = new DataSourceTextField_0('resource');
  setCheck(fields.array, fields.size_0++, resourceField);
  return fields;
}
;
_.copyValues_3 = function copyValues_118(from){
  return $copyValues_61(this, dynamicCast(from, Q$ResourceOperationHistory));
}
;
_.createOperationHistory = function createOperationHistory_0(){
  return new ResourceOperationHistory_1(null, null, null, null);
}
;
_.executeFetch = function executeFetch_64(request, response, criteria){
  $executeFetch_47(this, request, response, dynamicCast(criteria, Q$ResourceOperationHistoryCriteria));
}
;
_.getFetchCriteria = function getFetchCriteria_73(request){
  return $getFetchCriteria_13(request);
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_10(columnName){
  if ($equals_6('resourceAncestry', columnName)) {
    return 'resource.ancestry';
  }
  return columnName;
}
;
function $onSuccess_397(this$static, result){
  $dataRetrieved_7(this$static.this$0, result, this$static.val$response, this$static.val$request);
}

function ResourceOperationHistoryDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3495, 1, {}, ResourceOperationHistoryDataSource$1_0);
_.onFailure = function onFailure_411(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failure loading operation histories.'), caught);
}
;
_.onSuccess_0 = function onSuccess_411(result){
  $onSuccess_397(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function ResourceOperationHistoryDataSource$2_0(this$0, val$result, val$response, val$request){
  this.this$0 = this$0;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3496, 1, {}, ResourceOperationHistoryDataSource$2_0);
_.onTypesLoaded_0 = function onTypesLoaded_43(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44($getTotalSize(this.val$result)));
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $buildResultsSection_0(operationHistory){
  var editor, noResultsLabel, operationDefinition, resultsConfigurationDefinition, resultsSection, status_0, title;
  status_0 = operationHistory.status_0;
  if (status_0 == ($clinit_OperationRequestStatus() , SUCCESS_6)) {
    resultsSection = new EnhancedVLayout_0;
    title = new Label_4('<h4>' + ($clinit_Enhanced() , 'Results') + '<\/h4>');
    $isCreated_1(title)?$setProperty_0(title, 'height', 27):(title.config_0['height'] = 27 , undefined);
    $addMember(resultsSection, title);
    operationDefinition = operationHistory.operationDefinition;
    resultsConfigurationDefinition = operationDefinition.resultsConfigurationDefinition;
    if (!!resultsConfigurationDefinition && !(!resultsConfigurationDefinition.propertyDefinitions && (resultsConfigurationDefinition.propertyDefinitions = new LinkedHashMap_0) , resultsConfigurationDefinition.propertyDefinitions).isEmpty_0()) {
      editor = new ConfigurationEditor_1(operationDefinition.resultsConfigurationDefinition, operationHistory.results);
      editor.preserveTextFormatting = true;
      editor.readOnly = true;
      $addMember(resultsSection, editor);
    }
     else {
      noResultsLabel = new Label_4('This operation does not return any results.');
      $isCreated_1(noResultsLabel)?$setProperty_0(noResultsLabel, 'height', 17):(noResultsLabel.config_0['height'] = 17 , undefined);
      $addMember(resultsSection, noResultsLabel);
    }
    return resultsSection;
  }
   else {
    return null;
  }
}

function $createFields_1(this$static, operationHistory){
  var groupOperationHistory, groupOperationHistoryItem, groupOperationHistoryUrl, items, resourceItem, value;
  items = $createFields_0(operationHistory);
  if (this$static.showResourceField) {
    resourceItem = new StaticTextItem_2('resource', 'Resource');
    $setValue_7(resourceItem, this$static.disambiguatedResourceName);
    $add_2(items, 1, resourceItem);
  }
  groupOperationHistory = operationHistory.groupOperationHistory;
  if (groupOperationHistory) {
    groupOperationHistoryItem = new StaticTextItem_2('groupOperationHistory', 'Parent Group Execution');
    groupOperationHistoryUrl = getGroupOperationHistoryLink(groupOperationHistory.group, groupOperationHistory.id);
    value = '<a href="' + groupOperationHistoryUrl + '">' + groupOperationHistory.id + "<\/a> (on group '" + groupOperationHistory.group.name_0 + "')";
    $setValue_7(groupOperationHistoryItem, value);
    setCheck(items.array, items.size_0++, groupOperationHistoryItem);
  }
  return items;
}

function ResourceOperationHistoryDetailsView_0(){
  $clinit_BaseWidget();
  ResourceOperationHistoryDetailsView_1.call(this, false);
}

function ResourceOperationHistoryDetailsView_1(showResourceField){
  AbstractOperationHistoryDetailsView_0.call(this);
  this.showResourceField = showResourceField;
}

defineSeed(3497, 2933, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$Enhanced]), ResourceOperationHistoryDetailsView_0, ResourceOperationHistoryDetailsView_1);
_.buildResultsSection = function buildResultsSection_0(operationHistory){
  return $buildResultsSection_0(dynamicCast(operationHistory, Q$ResourceOperationHistory));
}
;
_.createFields_0 = function createFields_3(operationHistory){
  return $createFields_1(this, dynamicCast(operationHistory, Q$ResourceOperationHistory));
}
;
_.lookupDetails = function lookupDetails_0(historyId){
  var criteria;
  criteria = new ResourceOperationHistoryCriteria_0;
  $addFilterId(criteria, valueOf_44(historyId));
  criteria.fetchOperationDefinition = true;
  criteria.fetchParameters = true;
  criteria.fetchResults = true;
  $findResourceOperationHistoriesByCriteria(dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync), criteria, new ResourceOperationHistoryDetailsView$1_0(this));
}
;
_.disambiguatedResourceName = null;
_.showResourceField = false;
function $onSuccess_398(this$static, result){
  var resource, resourceOperationHistory, url;
  resourceOperationHistory = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$ResourceOperationHistory);
  if (this$static.this$0.showResourceField) {
    resource = resourceOperationHistory.resource;
    url = '#Resource/' + resource.id;
    this$static.this$0.disambiguatedResourceName = getHref(url, resource.name_0);
  }
  $displayDetails(this$static.this$0, resourceOperationHistory);
}

function ResourceOperationHistoryDetailsView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3498, 1, {}, ResourceOperationHistoryDetailsView$1_0);
_.onFailure = function onFailure_412(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failure loading operation history.'), caught);
}
;
_.onSuccess_0 = function onSuccess_412(result){
  $onSuccess_398(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function ResourceOperationHistoryListView_0(resourceComposite){
  $clinit_OperationHistoryView();
  OperationHistoryView_0.call(this, new EntityContext_0(valueOf_44(resourceComposite.resource.id), null, null));
  this.resourceComposite = resourceComposite;
}

defineSeed(3499, 2588, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), ResourceOperationHistoryListView_0);
_.getDetailsView_0 = function getDetailsView_29(id){
  return new ResourceOperationHistoryDetailsView_0;
}
;
_.hasControlPermission_1 = function hasControlPermission_6(){
  return this.resourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONTROL_0));
}
;
_.resourceComposite = null;
function $executeFetch_48(this$static, request, response){
  var scheduleId;
  scheduleId = $getAttributeAsInt($getCriteria(request), 'id');
  scheduleId?$getResourceOperationSchedule(this$static.operationService, scheduleId.value_0, new ResourceOperationScheduleDataSource$1_0(this$static, request, response, scheduleId)):$findScheduledResourceOperations(this$static.operationService, this$static.resourceComposite.resource.id, new ResourceOperationScheduleDataSource$2_0(this$static, response, request));
}

function ResourceOperationScheduleDataSource_0(resourceComposite){
  $clinit_RPCDataSource();
  AbstractOperationScheduleDataSource_0.call(this, resourceComposite.resource.resourceType);
  this.resourceComposite = resourceComposite;
}

defineSeed(3500, 2948, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AbstractOperationScheduleDataSource]), ResourceOperationScheduleDataSource_0);
_.createOperationSchedule = function createOperationSchedule_0(){
  var resourceOperationSchedule;
  return resourceOperationSchedule = new ResourceOperationSchedule_0 , $setResource_0(resourceOperationSchedule, this.resourceComposite.resource) , resourceOperationSchedule;
}
;
_.executeAdd = function executeAdd_4(recordToAdd, request, response){
  var scheduleToAdd;
  $addRequestPropertiesToRecord(request, recordToAdd);
  scheduleToAdd = dynamicCast($copyValues_43(this, recordToAdd), Q$ResourceOperationSchedule);
  $scheduleResourceOperation(this.operationService, scheduleToAdd, new ResourceOperationScheduleDataSource$3_0(this, scheduleToAdd, request, response));
}
;
_.executeFetch = function executeFetch_65(request, response, unused){
  $executeFetch_48(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.executeRemove = function executeRemove_5(recordToRemove, request, response){
  var scheduleToRemove;
  scheduleToRemove = dynamicCast($copyValues_43(this, recordToRemove), Q$ResourceOperationSchedule);
  $unscheduleResourceOperation(this.operationService, scheduleToRemove, new ResourceOperationScheduleDataSource$4_0(this, request, response, scheduleToRemove));
}
;
_.resourceComposite = null;
function $onSuccess_399(this$static, result){
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, result, null);
}

function ResourceOperationScheduleDataSource$1_0(this$0, val$request, val$response, val$scheduleId){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$scheduleId = val$scheduleId;
}

defineSeed(3501, 1, {}, ResourceOperationScheduleDataSource$1_0);
_.onFailure = function onFailure_413(caught){
  $sendFailureResponse(this.this$0, this.val$request, this.val$response, 'Failed to fetch ResourceOperationSchedule with id ' + this.val$scheduleId + '.', caught);
}
;
_.onSuccess_0 = function onSuccess_413(result){
  $onSuccess_399(this, dynamicCast(result, Q$ResourceOperationSchedule));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$scheduleId = null;
function $onFailure_48(this$static, caught){
  throw new RuntimeException_2('Failed to find scheduled operations for ' + this$static.this$0.resourceComposite.resource + '.', caught);
}

function $onSuccess_400(this$static, result){
  var records;
  records = $buildRecords(this$static.this$0, result, true);
  $setAttribute_17(this$static.val$response, 'data', records);
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ResourceOperationScheduleDataSource$2_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3502, 1, {}, ResourceOperationScheduleDataSource$2_0);
_.onFailure = function onFailure_414(caught){
  $onFailure_48(this, caught);
}
;
_.onSuccess_0 = function onSuccess_414(result){
  $onSuccess_400(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $onFailure_49(this$static, caught){
  throw new RuntimeException_2('Failed to add ' + this$static.val$scheduleToAdd, caught);
}

function $onSuccess_401(this$static, scheduleId){
  $setId_3(this$static.val$scheduleToAdd, scheduleId.value_0);
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, this$static.val$scheduleToAdd, null);
}

function ResourceOperationScheduleDataSource$3_0(this$0, val$scheduleToAdd, val$request, val$response){
  this.this$0 = this$0;
  this.val$scheduleToAdd = val$scheduleToAdd;
  this.val$request = val$request;
  this.val$response = val$response;
}

defineSeed(3503, 1, {}, ResourceOperationScheduleDataSource$3_0);
_.onFailure = function onFailure_415(caught){
  $onFailure_49(this, caught);
}
;
_.onSuccess_0 = function onSuccess_415(scheduleId){
  $onSuccess_401(this, dynamicCast(scheduleId, Q$Integer));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$scheduleToAdd = null;
function $onFailure_50(caught){
  throw new RuntimeException_3(caught);
}

function $onSuccess_402(this$static){
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, this$static.val$scheduleToRemove, null);
}

function ResourceOperationScheduleDataSource$4_0(this$0, val$request, val$response, val$scheduleToRemove){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$scheduleToRemove = val$scheduleToRemove;
}

defineSeed(3504, 1, {}, ResourceOperationScheduleDataSource$4_0);
_.onFailure = function onFailure_416(caught){
  $onFailure_50(caught);
}
;
_.onSuccess_0 = function onSuccess_416(result){
  $onSuccess_402(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$scheduleToRemove = null;
function ResourceOperationScheduleDetailsView_0(resourceComposite, scheduleId){
  $clinit_AbstractRecordEditor();
  AbstractOperationScheduleDetailsView_0.call(this, new ResourceOperationScheduleDataSource_0(resourceComposite), resourceComposite.resource.resourceType, scheduleId);
  this.resourceComposite = resourceComposite;
}

defineSeed(3505, 2950, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$DetailsView, Q$Enhanced]), ResourceOperationScheduleDetailsView_0);
_.getResourceId = function getResourceId_0(){
  return this.resourceComposite.resource.id;
}
;
_.hasControlPermission_1 = function hasControlPermission_7(){
  return this.resourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONTROL_0));
}
;
_.resourceComposite = null;
function ResourceOperationScheduleListView_0(resourceComposite){
  $clinit_BaseWidget();
  AbstractOperationScheduleListView_0.call(this, new ResourceOperationScheduleDataSource_0(resourceComposite));
  this.resourceComposite = resourceComposite;
}

defineSeed(3506, 2954, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), ResourceOperationScheduleListView_0);
_.getDetailsView_0 = function getDetailsView_30(scheduleId){
  return new ResourceOperationScheduleDetailsView_0(this.resourceComposite, scheduleId.value_0);
}
;
_.hasControlPermission_1 = function hasControlPermission_8(){
  return this.resourceComposite.resourcePermission.permissions.contains_0(($clinit_Permission() , CONTROL_0));
}
;
_.resourceComposite = null;
function $getDefaultDashboard_1(this$static){
  var alerts, dashboard, displayLeft, key, key$iterator, measurements, ops, portlet, resKeyNameMap, resource, rowLeft, rowRight, sessionSubject;
  sessionSubject = ($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0);
  resource = this$static.resourceComposite.resource;
  dashboard = new Dashboard_0;
  $setName_7(dashboard, 'ResourceDashboard_' + sessionSubject.id + '_' + resource.id);
  $setCategory_0(dashboard, ($clinit_DashboardCategory() , RESOURCE_1));
  dashboard.resource = resource;
  $put_4(dashboard.configuration, new PropertySimple_1('columns', valueOf_44(2)));
  $setColumnWidths(dashboard, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, ['40%']));
  $put_4(dashboard.configuration, new PropertySimple_1('background', '#F1F2F3'));
  resKeyNameMap = processPortletNameMapForResource(this$static.resourceComposite);
  rowLeft = 0;
  rowRight = 0;
  if (resKeyNameMap.map.containsKey('ResourceMetrics')) {
    measurements = new DashboardPortlet_1(($clinit_ResourceMetricsPortlet() , NAME_22), 'ResourceMetrics', 220);
    $addPortlet_0(dashboard, measurements, 0, rowLeft++);
    $remove_11(resKeyNameMap, 'ResourceMetrics');
  }
  if (resKeyNameMap.map.containsKey('ResourceAlerts')) {
    alerts = new DashboardPortlet_1(($clinit_ResourceAlertsPortlet() , NAME_18), 'ResourceAlerts', 220);
    $addPortlet_0(dashboard, alerts, 1, rowRight++);
    $remove_11(resKeyNameMap, 'ResourceAlerts');
  }
  if (resKeyNameMap.map.containsKey('ResourceOperations')) {
    ops = new DashboardPortlet_1(($clinit_ResourceOperationsPortlet() , NAME_24), 'ResourceOperations', 220);
    $addPortlet_0(dashboard, ops, 1, rowRight++);
    $remove_11(resKeyNameMap, 'ResourceOperations');
  }
  if (resKeyNameMap.map.containsKey('ResourceConfigurationUpdates')) {
    ops = new DashboardPortlet_1(($clinit_ResourceConfigurationUpdatesPortlet() , NAME_20), 'ResourceConfigurationUpdates', 220);
    $addPortlet_0(dashboard, ops, 1, rowRight++);
    $remove_11(resKeyNameMap, 'ResourceConfigurationUpdates');
  }
  displayLeft = false;
  for (key$iterator = $iterator($keySet(resKeyNameMap)); key$iterator.val$outerIter.hasNext();) {
    key = dynamicCast($next_1(key$iterator), Q$String);
    portlet = new DashboardPortlet_1(dynamicCast($get_4(resKeyNameMap, key), Q$String), key, 100);
    if (rowLeft < 4) {
      $addPortlet_0(dashboard, portlet, 0, rowLeft++);
    }
     else {
      displayLeft?$addPortlet_0(dashboard, portlet, 0, rowLeft++):$addPortlet_0(dashboard, portlet, 1, rowRight++);
      displayLeft = !displayLeft;
    }
  }
  return dashboard;
}

function $setDashboard_0(this$static, dashboard){
  var members;
  members = convertToCanvasArray($getAttributeAsJavaScriptObject_1(this$static, 'members'));
  $removeMembers(this$static, members);
  this$static.dashboardView = new DashboardView_1(this$static, dashboard, new EntityContext_0(valueOf_44(this$static.resourceComposite.resource.id), null, null), this$static.resourceComposite);
  $addMember(this$static, this$static.dashboardView);
  this$static.footer = new EnhancedToolStrip_0;
  $setPadding(this$static.footer, valueOf_44(5));
  $setAttribute_24(this$static.footer, 'width', '100%', true);
  $setMembersMargin(this$static.footer, 15);
  this$static.editButton = new EnhancedIButton_1(this$static.editMode?($clinit_Enhanced() , 'View Mode'):($clinit_Enhanced() , 'Edit Mode'));
  $addClickHandler(this$static.editButton, new ActivityView$2_2(this$static));
  this$static.resetButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Reset'));
  $addClickHandler(this$static.resetButton, new ActivityView$3_2(this$static));
  $addMember(this$static.footer, this$static.editButton);
  $addMember(this$static.footer, this$static.resetButton);
  $addMember(this$static, this$static.footer);
}

function ActivityView_2(resourceComposite){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.dashboardService = dynamicCast(secure(getInstance_39(), -1), Q$DashboardGWTServiceAsync);
  this.resourceComposite = resourceComposite;
}

defineSeed(3507, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$InitializableView, Q$RefreshableView, Q$Enhanced]), ActivityView_2);
_.getGlobalPermissions = function getGlobalPermissions_1(){
  return this.globalPermissions;
}
;
_.isInitialized_0 = function isInitialized_5(){
  return this.isInitialized;
}
;
_.isValidDashboardName = function isValidDashboardName_1(name_0){
  return name_0 != null && !!this.dashboardView && $equals_6(name_0, this.dashboardView.storedDashboard.name_0);
}
;
_.onInit = function onInit_67(){
  if (!this.isInitialized) {
    $onInit(this);
    $onInit_Layout(this);
    $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new ActivityView$1_2(this)));
  }
}
;
_.refresh_0 = function refresh_43(){
  this.isInitialized && $rebuild(this.dashboardView);
}
;
_.supportsDashboardNameEdit = function supportsDashboardNameEdit_1(){
  return false;
}
;
_.updateDashboardNames = function updateDashboardNames_1(){
  return;
}
;
_.dashboardView = null;
_.editButton = null;
_.editMode = false;
_.footer = null;
_.globalPermissions = null;
_.isInitialized = false;
_.resetButton = null;
_.resourceComposite = null;
function ActivityView$1_2(this$0){
  this.this$0 = this$0;
}

defineSeed(3508, 1, {}, ActivityView$1_2);
_.onPermissionsLoaded = function onPermissionsLoaded_15(permissions){
  var criteria;
  this.this$0.globalPermissions = permissions;
  criteria = new DashboardCriteria_0;
  $addFilterCategory(criteria, ($clinit_DashboardCategory() , RESOURCE_1));
  $addFilterResourceId_0(criteria, valueOf_44(this.this$0.resourceComposite.resource.id));
  $findDashboardsByCriteria(this.this$0.dashboardService, criteria, new ActivityView$1$1_2(this));
}
;
_.this$0 = null;
function $onSuccess_403(this$static, result){
  var dashboard;
  dashboard = result.size_0 == 0?$getDefaultDashboard_1(this$static.this$1.this$0):dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Dashboard);
  $setDashboard_0(this$static.this$1.this$0, dashboard);
  this$static.this$1.this$0.isInitialized = true;
  $isDrawn(this$static.this$1.this$0).value_0 && $markForRedraw(this$static.this$1.this$0);
}

function ActivityView$1$1_2(this$1){
  this.this$1 = this$1;
}

defineSeed(3509, 1, {}, ActivityView$1$1_2);
_.onFailure = function onFailure_417(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to add new dashboard'), caught);
}
;
_.onSuccess_0 = function onSuccess_417(result){
  $onSuccess_403(this, dynamicCast(result, Q$PageList));
}
;
_.this$1 = null;
function ActivityView$2_2(this$0){
  this.this$0 = this$0;
}

defineSeed(3510, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ActivityView$2_2);
_.onClick = function onClick_165(clickEvent){
  this.this$0.editMode = !this.this$0.editMode;
  $setTitle_0(this.this$0.editButton, this.this$0.editMode?($clinit_Enhanced() , 'View Mode'):($clinit_Enhanced() , 'Edit Mode'));
  $setEditMode(this.this$0.dashboardView, this.this$0.editMode);
}
;
_.this$0 = null;
function ActivityView$3_2(this$0){
  this.this$0 = this$0;
}

defineSeed(3511, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ActivityView$3_2);
_.onClick = function onClick_166(clickEvent){
  $clinit_Enhanced();
  ask('Reset to default summary dashboard (lose local changes)?', new ActivityView$3$1_2(this));
}
;
_.this$0 = null;
function ActivityView$3$1_2(this$1){
  this.this$1 = this$1;
}

defineSeed(3512, 1, {}, ActivityView$3$1_2);
_.execute_3 = function execute_60(confirmed){
  if (confirmed.value_0) {
    $delete_2(this.this$1.this$0.dashboardView);
    $setDashboard_0(this.this$1.this$0, $getDefaultDashboard_1(this.this$1.this$0));
    $markForRedraw(this.this$1.this$0);
  }
}
;
_.this$1 = null;
function $clinit_TimelineView(){
  $clinit_TimelineView = nullMethod;
  $clinit_BaseWidget();
  new ViewName_1('ResourceTimeline', ($clinit_Enhanced() , 'Timeline'));
}

function TimelineView_0(resourceComposite){
  $clinit_TimelineView();
  EnhancedVLayout_0.call(this);
  this.resourceComposite = resourceComposite;
  $setMargin(this, valueOf_44(10));
  $isCreated_1(this)?$setProperty_0(this, 'membersMargin', 1):(this.config_0['membersMargin'] = 1 , undefined);
}

defineSeed(3513, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), TimelineView_0);
_.onDraw_0 = function onDraw_56(){
  var range, timelinePane;
  timelinePane = new FullHTMLPane_0('/resource/common/monitor/events/EventsView.jsp?id=' + this.resourceComposite.resource.id);
  range = new TimelineView$1RangeEditor_0(timelinePane);
  $addMember(this, range);
  $addMember(this, timelinePane);
}
;
_.resourceComposite = null;
function TimelineView$1RangeEditor_0(val$timelinePane){
  $clinit_AbstractMeasurementRangeEditor();
  this.val$timelinePane = val$timelinePane;
  UserPreferencesMeasurementRangeEditor_0.call(this);
}

defineSeed(3514, 2335, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$DynamicForm, Q$TableWidget]), TimelineView$1RangeEditor_0);
_.setMetricRangeProperties = function setMetricRangeProperties_2(prefs){
  $setMetricRangePreferences_0(this.measurementUserPrefs, prefs);
  $redraw(this.val$timelinePane);
}
;
_.val$timelinePane = null;
function $clinit_AutodiscoveryQueueDataSource(){
  $clinit_AutodiscoveryQueueDataSource = nullMethod;
  $clinit_CoreGUI();
  MANAGE_INVENTORY_0 = ($clinit_Permission() , MANAGE_INVENTORY);
}

function $buildNodes_0(result){
  var child, child$iterator, childNode, nodes, platform, platform$iterator, treeNodes;
  nodes = new ArrayList_0;
  for (platform$iterator = result.keySet_0().iterator(); platform$iterator.hasNext();) {
    platform = dynamicCast(platform$iterator.next_0(), Q$Resource);
    $add_3(nodes, new AutodiscoveryQueueDataSource$ResourceTreeNode_0(platform));
    for (child$iterator = dynamicCast(result.get_2(platform), Q$List).iterator(); child$iterator.hasNext();) {
      child = dynamicCast(child$iterator.next_0(), Q$Resource);
      childNode = new AutodiscoveryQueueDataSource$ResourceTreeNode_0(child);
      childNode.jsObj['isFolder'] = false;
      setCheck(nodes.array, nodes.size_0++, childNode);
    }
  }
  treeNodes = dynamicCast($toArray_1(nodes, initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, nodes.size_0, 0)), Q$TreeNode_$1);
  return treeNodes;
}

function $executeFetch_49(this$static, request, response){
  var pc, statuses, statusesString;
  pc = $getPageControl_2(this$static, request);
  statuses = new HashSet_0;
  statusesString = $getAttributeAsString($getCriteria(request), 'status');
  if (statusesString != null) {
    if ($equals_6('New', statusesString)) {
      $add_6(statuses, ($clinit_InventoryStatus() , NEW));
    }
     else if ($equals_6('Ignored', statusesString)) {
      $add_6(statuses, ($clinit_InventoryStatus() , IGNORED));
    }
     else {
      $add_6(statuses, ($clinit_InventoryStatus() , NEW));
      $add_6(statuses, IGNORED);
    }
  }
   else {
    $add_6(statuses, ($clinit_InventoryStatus() , NEW));
  }
  $loadExplicitGlobalPermissions(new AutodiscoveryQueueDataSource$1_0(this$static, statuses, pc, response, request));
}

function $getPageControl_2(this$static, request){
  var columnName, ordering, pageControl, sort, sort$index, sort$max, sortBy, sorts;
  this$static.maximumPlatformsToDisplay > -1?(pageControl = new PageControl_1(0, this$static.maximumPlatformsToDisplay)):(pageControl = new PageControl_1(0, -1));
  sortBy = getAttribute(request.jsObj, 'sortBy');
  if (sortBy != null) {
    sorts = $split(sortBy, ',', 0);
    for (sort$index = 0 , sort$max = sorts.length; sort$index < sort$max; ++sort$index) {
      sort = sorts[sort$index];
      ordering = sort.indexOf('-') == 0?($clinit_PageOrdering() , DESC):($clinit_PageOrdering() , ASC);
      columnName = ordering == ($clinit_PageOrdering() , DESC)?$substring(sort, 1):sort;
      $addDefaultOrderingField(pageControl, columnName, ordering);
    }
  }
  return pageControl;
}

function $setMaximumPlatformsToDisplay(this$static, maximumPlatformsToDisplay){
  this$static.maximumPlatformsToDisplay = maximumPlatformsToDisplay;
}

function AutodiscoveryQueueDataSource_0(treeGrid){
  var idField, parentIdField, resourceNameField, resourceKeyField, resourceTypeField, descriptionField, timestampField, statusField;
  $clinit_AutodiscoveryQueueDataSource();
  DataSource_0.call(this);
  this.resourceService = dynamicCast(secure(getInstance_51(), 60000), Q$ResourceGWTServiceAsync);
  $clinit_PermissionsLoader();
  $setClientOnly(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_1(this, 'dataProtocol', ($clinit_DSProtocol() , CLIENTCUSTOM).value_0);
  $setAttribute_1(this, 'dataFormat', ($clinit_DSDataFormat() , CUSTOM).value_0);
  idField = new DataSourceTextField_1('id', 'ID');
  $setAttribute_8(idField, 'primaryKey', TRUE);
  parentIdField = new DataSourceTextField_1('parentId', 'Parent ID');
  parentIdField.jsObj['foreignKey'] = 'id';
  resourceNameField = new DataSourceTextField_1('name', 'Resource Name');
  resourceKeyField = new DataSourceTextField_1('resourceKey', 'Resource Key');
  resourceTypeField = new DataSourceTextField_1('typeName', 'Resource Type');
  descriptionField = new DataSourceTextField_1('description', 'Description');
  timestampField = new DataSourceTextField_1('ctime', 'Discovery Time');
  statusField = new DataSourceTextField_1('statusLabel', 'Inventory Status');
  $setFields(this, initValues(_3Lcom_smartgwt_client_data_DataSourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$DataSourceField, [idField, parentIdField, resourceNameField, resourceKeyField, resourceTypeField, descriptionField, statusField, timestampField]));
  this.dataContainerReference = treeGrid;
}

defineSeed(3515, 337, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), AutodiscoveryQueueDataSource_0);
_.transformRequest_0 = function transformRequest_3(request){
  var response;
  response = new DSResponse_0;
  $setAttribute_12(response, 'clientContext', getAttributeAsObject(request.jsObj, 'clientContext'));
  response.jsObj['status'] = 0;
  dynamicCast(getEnum(($clinit_DSOperationType() , $clinit_DSOperationType() , $VALUES_9), getAttribute(request.jsObj, 'operationType')), Q$DSOperationType).ordinal == 0 && $executeFetch_49(this, request, response);
  return getAttributeAsJavaScriptObject(request.jsObj, 'data');
}
;
_.dataContainerReference = null;
_.maximumPlatformsToDisplay = -1;
var MANAGE_INVENTORY_0;
function AutodiscoveryQueueDataSource$1_0(this$0, val$statuses, val$pc, val$response, val$request){
  this.this$0 = this$0;
  this.val$statuses = val$statuses;
  this.val$pc = val$pc;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3516, 1, {}, AutodiscoveryQueueDataSource$1_0);
_.onPermissionsLoaded = function onPermissionsLoaded_16(permissions){
  var accessGranted;
  if (permissions) {
    accessGranted = ($clinit_Boolean() , permissions.contains_0(($clinit_AutodiscoveryQueueDataSource() , MANAGE_INVENTORY_0))?TRUE:FALSE);
    if (accessGranted.value_0) {
      !!this.this$0.dataContainerReference && $setEmptyMessage(this.this$0.dataContainerReference, 'No items to show');
      $getQueuedPlatformsAndServers(this.this$0.resourceService, this.val$statuses, this.val$pc, new AutodiscoveryQueueDataSource$1$1_0(this, this.val$response, this.val$request));
    }
     else {
      debug('(User does not have required managed inventory permissions. No items to show');
      $setTotalRows(this.val$response, valueOf_44(0));
      if (this.this$0.dataContainerReference) {
        trace('Setting better empty container message.(You are not authorized to view the auto-discovery queue)');
        $setEmptyMessage(this.this$0.dataContainerReference, '(You are not authorized to view the auto-discovery queue)');
      }
      $processResponse(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
    }
  }
}
;
_.this$0 = null;
_.val$pc = null;
_.val$request = null;
_.val$response = null;
_.val$statuses = null;
function $onSuccess_404(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildNodes_0(result));
  $processResponse(this$static.this$1.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function AutodiscoveryQueueDataSource$1$1_0(this$1, val$response, val$request){
  this.this$1 = this$1;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3517, 1, {}, AutodiscoveryQueueDataSource$1$1_0);
_.onFailure = function onFailure_418(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_AutodiscoveryQueueDataSource() , 'Failed to load the inventory discovery queue'), caught);
}
;
_.onSuccess_0 = function onSuccess_418(result){
  $onSuccess_404(this, dynamicCast(result, Q$Map));
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
function AutodiscoveryQueueDataSource$ResourceTreeNode_0(resource){
  var id, parentId;
  TreeNode_0.call(this);
  id = '' + resource.id;
  parentId = !resource.parentResource?null:'' + resource.parentResource.id;
  this.jsObj['id'] = id;
  this.jsObj['parentId'] = parentId;
  this.jsObj['id'] = id;
  this.jsObj['parentId'] = parentId;
  $setAttribute_13(this, 'name', resource.name_0);
  $setAttribute_13(this, 'typeName', resource.resourceType.name_0);
  $setAttribute_13(this, 'resourceKey', resource.resourceKey);
  $setAttribute_13(this, 'description', resource.description);
  $setAttribute_14(this, 'ctime', new Date_2(resource.ctime.value_0));
  $setAttribute_13(this, 'status', resource.inventoryStatus.name_0);
  switch (resource.inventoryStatus.ordinal) {
    case 0:
      $setAttribute_13(this, 'statusLabel', ($clinit_AutodiscoveryQueueDataSource() , 'New'));
      break;
    case 2:
      $setAttribute_13(this, 'statusLabel', ($clinit_AutodiscoveryQueueDataSource() , 'Committed'));
      break;
    case 1:
      $setAttribute_13(this, 'statusLabel', ($clinit_AutodiscoveryQueueDataSource() , 'Ignored'));
      break;
    case 3:
      $setAttribute_13(this, 'statusLabel', ($clinit_AutodiscoveryQueueDataSource() , 'Deleted'));
      break;
    case 4:
      $setAttribute_13(this, 'statusLabel', ($clinit_AutodiscoveryQueueDataSource() , 'Uninventoried'));
  }
}

defineSeed(3518, 577, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode]), AutodiscoveryQueueDataSource$ResourceTreeNode_0);
function ResourceAutodiscoveryView$1_0(this$0, val$statusSelectItem){
  this.this$0 = this$0;
  this.val$statusSelectItem = val$statusSelectItem;
}

defineSeed(3519, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ResourceAutodiscoveryView$1_0);
_.onChanged = function onChanged_71(changedEvent){
  $fetchData_3(this.this$0.treeGrid, new Criteria_2('status', dynamicCast($getValue_0(this.val$statusSelectItem), Q$String)));
}
;
_.this$0 = null;
_.val$statusSelectItem = null;
function ResourceAutodiscoveryView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3520, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceAutodiscoveryView$2_0);
_.onClick = function onClick_167(clickEvent){
  this.this$0.refresh_0();
}
;
_.this$0 = null;
function ResourceAutodiscoveryView$3_0(this$0, val$selectAllButton, val$deselectAllButton, val$importButton, val$ignoreButton, val$unignoreButton){
  this.this$0 = this$0;
  this.val$selectAllButton = val$selectAllButton;
  this.val$deselectAllButton = val$deselectAllButton;
  this.val$importButton = val$importButton;
  this.val$ignoreButton = val$ignoreButton;
  this.val$unignoreButton = val$unignoreButton;
}

defineSeed(3521, 1, makeCastMap([Q$EventHandler, Q$SelectionChangedHandler]), ResourceAutodiscoveryView$3_0);
_.onSelectionChanged = function onSelectionChanged_11(selectionEvent){
  var child, child$array, child$index, child$max, isCheckboxMarked, isPlatform, parentNode, selectedNode;
  if (this.this$0.selectionChangedHandlerDisabled || $isRightButtonDown()) {
    return;
  }
  this.this$0.selectionChangedHandlerDisabled = true;
  selectedNode = $findById(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$0.treeGrid, 'data')), $getAttribute($getRecord_1(selectionEvent), 'id'));
  parentNode = $getParent(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$0.treeGrid, 'data')), selectedNode);
  isPlatform = $isRoot(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$0.treeGrid, 'data')), parentNode).value_0;
  isCheckboxMarked = $isSelected(this.this$0.treeGrid, selectedNode).value_0;
  if (isPlatform) {
    if (isCheckboxMarked) {
      ask(($clinit_Enhanced() , 'Also select the platform children?'), new ResourceAutodiscoveryView$3$1_0(this, selectedNode, this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton));
    }
     else {
      for (child$array = $getChildren(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$0.treeGrid, 'data')), selectedNode) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
        child = child$array[child$index];
        $isSelected(this.this$0.treeGrid, child).value_0 && $deselectRecord(this.this$0.treeGrid, child);
      }
      $redraw(this.this$0.treeGrid);
      $updateButtonEnablement_0(this.this$0, this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton);
      this.this$0.selectionChangedHandlerDisabled = false;
    }
  }
   else {
    isCheckboxMarked && ($isSelected(this.this$0.treeGrid, parentNode).value_0 || $selectRecord(this.this$0.treeGrid, parentNode));
    $updateButtonEnablement_0(this.this$0, this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton);
    this.this$0.selectionChangedHandlerDisabled = false;
  }
}
;
_.this$0 = null;
_.val$deselectAllButton = null;
_.val$ignoreButton = null;
_.val$importButton = null;
_.val$selectAllButton = null;
_.val$unignoreButton = null;
function ResourceAutodiscoveryView$3$1_0(this$1, val$selectedNode, val$selectAllButton, val$deselectAllButton, val$importButton, val$ignoreButton, val$unignoreButton){
  this.this$1 = this$1;
  this.val$selectedNode = val$selectedNode;
  this.val$selectAllButton = val$selectAllButton;
  this.val$deselectAllButton = val$deselectAllButton;
  this.val$importButton = val$importButton;
  this.val$ignoreButton = val$ignoreButton;
  this.val$unignoreButton = val$unignoreButton;
}

defineSeed(3522, 1, {}, ResourceAutodiscoveryView$3$1_0);
_.execute_3 = function execute_61(confirmed){
  var child, child$array, child$index, child$max;
  if (confirmed.value_0) {
    for (child$array = $getChildren(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$1.this$0.treeGrid, 'data')), this.val$selectedNode) , child$index = 0 , child$max = child$array.length; child$index < child$max; ++child$index) {
      child = child$array[child$index];
      $isSelected(this.this$1.this$0.treeGrid, child).value_0 || $selectRecord(this.this$1.this$0.treeGrid, child);
    }
  }
  $updateButtonEnablement_0(this.this$1.this$0, this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton);
  this.this$1.this$0.selectionChangedHandlerDisabled = false;
}
;
_.this$1 = null;
_.val$deselectAllButton = null;
_.val$ignoreButton = null;
_.val$importButton = null;
_.val$selectAllButton = null;
_.val$selectedNode = null;
_.val$unignoreButton = null;
function ResourceAutodiscoveryView$4_0(this$0, val$selectAllButton, val$deselectAllButton, val$importButton, val$ignoreButton, val$unignoreButton){
  this.this$0 = this$0;
  this.val$selectAllButton = val$selectAllButton;
  this.val$deselectAllButton = val$deselectAllButton;
  this.val$importButton = val$importButton;
  this.val$ignoreButton = val$ignoreButton;
  this.val$unignoreButton = val$unignoreButton;
}

defineSeed(3523, 1, makeCastMap([Q$EventHandler, Q$DataArrivedHandler_0]), ResourceAutodiscoveryView$4_0);
_.onDataArrived = function onDataArrived_2(dataArrivedEvent){
  if (this.this$0.treeGrid) {
    $updateButtonEnablement_0(this.this$0, this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton);
    $redraw(this.this$0.treeGrid);
  }
}
;
_.this$0 = null;
_.val$deselectAllButton = null;
_.val$ignoreButton = null;
_.val$importButton = null;
_.val$selectAllButton = null;
_.val$unignoreButton = null;
function ResourceAutodiscoveryView$5_0(this$0, val$selectAllButton, val$deselectAllButton, val$importButton, val$ignoreButton, val$unignoreButton){
  this.this$0 = this$0;
  this.val$selectAllButton = val$selectAllButton;
  this.val$deselectAllButton = val$deselectAllButton;
  this.val$importButton = val$importButton;
  this.val$ignoreButton = val$ignoreButton;
  this.val$unignoreButton = val$unignoreButton;
}

defineSeed(3524, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceAutodiscoveryView$5_0);
_.onClick = function onClick_168(clickEvent){
  ask(($clinit_Enhanced() , 'Also select the children of each platform?'), new ResourceAutodiscoveryView$5$1_0(this, this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton));
}
;
_.this$0 = null;
_.val$deselectAllButton = null;
_.val$ignoreButton = null;
_.val$importButton = null;
_.val$selectAllButton = null;
_.val$unignoreButton = null;
function ResourceAutodiscoveryView$5$1_0(this$1, val$selectAllButton, val$deselectAllButton, val$importButton, val$ignoreButton, val$unignoreButton){
  this.this$1 = this$1;
  this.val$selectAllButton = val$selectAllButton;
  this.val$deselectAllButton = val$deselectAllButton;
  this.val$importButton = val$importButton;
  this.val$ignoreButton = val$ignoreButton;
  this.val$unignoreButton = val$unignoreButton;
}

defineSeed(3525, 1, {}, ResourceAutodiscoveryView$5$1_0);
_.execute_3 = function execute_62(selectChildServers){
  var nodeToSelect, nodeToSelect$index, nodeToSelect$max, nodesToSelect, rootNode, self_0, nodesJS;
  this.this$1.this$0.selectionChangedHandlerDisabled = true;
  if (selectChildServers.value_0) {
    nodesToSelect = (self_0 = getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$1.this$0.treeGrid, 'data')).getOrCreateJsObj() , nodesJS = self_0.getAllNodes() , convertToTreeNodeArray(nodesJS));
  }
   else {
    rootNode = $getRoot(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$1.this$0.treeGrid, 'data')));
    nodesToSelect = $getChildren(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this.this$1.this$0.treeGrid, 'data')), rootNode);
  }
  for (nodeToSelect$index = 0 , nodeToSelect$max = nodesToSelect.length; nodeToSelect$index < nodeToSelect$max; ++nodeToSelect$index) {
    nodeToSelect = nodesToSelect[nodeToSelect$index];
    $selectRecord(this.this$1.this$0.treeGrid, nodeToSelect);
  }
  $markForRedraw_0(this.this$1.this$0.treeGrid);
  $updateButtonEnablement_0(this.this$1.this$0, this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton);
  this.this$1.this$0.selectionChangedHandlerDisabled = false;
}
;
_.this$1 = null;
_.val$deselectAllButton = null;
_.val$ignoreButton = null;
_.val$importButton = null;
_.val$selectAllButton = null;
_.val$unignoreButton = null;
function ResourceAutodiscoveryView$6_0(this$0, val$selectAllButton, val$deselectAllButton, val$importButton, val$ignoreButton, val$unignoreButton){
  this.this$0 = this$0;
  this.val$selectAllButton = val$selectAllButton;
  this.val$deselectAllButton = val$deselectAllButton;
  this.val$importButton = val$importButton;
  this.val$ignoreButton = val$ignoreButton;
  this.val$unignoreButton = val$unignoreButton;
}

defineSeed(3526, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceAutodiscoveryView$6_0);
_.onClick = function onClick_169(clickEvent){
  this.this$0.selectionChangedHandlerDisabled = true;
  $deselectAllRecords(this.this$0.treeGrid);
  $markForRedraw_0(this.this$0.treeGrid);
  $updateButtonEnablement_0(this.this$0, this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton);
  this.this$0.selectionChangedHandlerDisabled = false;
}
;
_.this$0 = null;
_.val$deselectAllButton = null;
_.val$ignoreButton = null;
_.val$importButton = null;
_.val$selectAllButton = null;
_.val$unignoreButton = null;
function ResourceAutodiscoveryView$7_0(this$0, val$selectAllButton, val$deselectAllButton, val$importButton, val$ignoreButton, val$unignoreButton){
  this.this$0 = this$0;
  this.val$selectAllButton = val$selectAllButton;
  this.val$deselectAllButton = val$deselectAllButton;
  this.val$importButton = val$importButton;
  this.val$ignoreButton = val$ignoreButton;
  this.val$unignoreButton = val$unignoreButton;
}

defineSeed(3527, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceAutodiscoveryView$7_0);
_.onClick = function onClick_170(clickEvent){
  $disableButtons_0(initValues(_3Lcom_smartgwt_client_widgets_IButton_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$IButton, [this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton]));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_8(($clinit_Enhanced() , 'Importing the selected Resources...'), ($clinit_Message$Severity() , Info), of(($clinit_Message$Option() , Transient))));
  $importResources(this.this$0.importResourceService, $getSelectedIds_4(this.this$0), new ResourceAutodiscoveryView$7$1_0(this));
}
;
_.this$0 = null;
_.val$deselectAllButton = null;
_.val$ignoreButton = null;
_.val$importButton = null;
_.val$selectAllButton = null;
_.val$unignoreButton = null;
function $onSuccess_405(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have successfully imported the selected Resources.'), ($clinit_Message$Severity() , Info)));
  this$static.this$1.this$0.refresh_0();
}

function ResourceAutodiscoveryView$7$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3528, 1, {}, ResourceAutodiscoveryView$7$1_0);
_.onFailure = function onFailure_419(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to import Resources'), caught);
}
;
_.onSuccess_0 = function onSuccess_419(result){
  $onSuccess_405(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
function ResourceAutodiscoveryView$8_0(this$0, val$selectAllButton, val$deselectAllButton, val$importButton, val$ignoreButton, val$unignoreButton){
  this.this$0 = this$0;
  this.val$selectAllButton = val$selectAllButton;
  this.val$deselectAllButton = val$deselectAllButton;
  this.val$importButton = val$importButton;
  this.val$ignoreButton = val$ignoreButton;
  this.val$unignoreButton = val$unignoreButton;
}

defineSeed(3529, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceAutodiscoveryView$8_0);
_.onClick = function onClick_171(clickEvent){
  $disableButtons_0(initValues(_3Lcom_smartgwt_client_widgets_IButton_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$IButton, [this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton]));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_8(($clinit_Enhanced() , 'Ignoring the selected Resources...'), ($clinit_Message$Severity() , Info), of(($clinit_Message$Option() , Transient))));
  $ignoreResources(this.this$0.resourceService, $getSelectedIds_4(this.this$0), new ResourceAutodiscoveryView$8$1_0(this));
}
;
_.this$0 = null;
_.val$deselectAllButton = null;
_.val$ignoreButton = null;
_.val$importButton = null;
_.val$selectAllButton = null;
_.val$unignoreButton = null;
function $onSuccess_406(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have successfully ignored the selected Resources.'), ($clinit_Message$Severity() , Info)));
  this$static.this$1.this$0.refresh_0();
}

function ResourceAutodiscoveryView$8$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3530, 1, {}, ResourceAutodiscoveryView$8$1_0);
_.onFailure = function onFailure_420(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to ignore Resources'), caught);
}
;
_.onSuccess_0 = function onSuccess_420(result){
  $onSuccess_406(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
function ResourceAutodiscoveryView$9_0(this$0, val$selectAllButton, val$deselectAllButton, val$importButton, val$ignoreButton, val$unignoreButton){
  this.this$0 = this$0;
  this.val$selectAllButton = val$selectAllButton;
  this.val$deselectAllButton = val$deselectAllButton;
  this.val$importButton = val$importButton;
  this.val$ignoreButton = val$ignoreButton;
  this.val$unignoreButton = val$unignoreButton;
}

defineSeed(3531, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), ResourceAutodiscoveryView$9_0);
_.onClick = function onClick_172(clickEvent){
  $disableButtons_0(initValues(_3Lcom_smartgwt_client_widgets_IButton_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$IButton, [this.val$selectAllButton, this.val$deselectAllButton, this.val$importButton, this.val$ignoreButton, this.val$unignoreButton]));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_8(($clinit_Enhanced() , 'Unignoring the selected Resources...'), ($clinit_Message$Severity() , Info), of(($clinit_Message$Option() , Transient))));
  $unignoreResources(this.this$0.resourceService, $getSelectedIds_4(this.this$0), new ResourceAutodiscoveryView$9$1_0(this));
}
;
_.this$0 = null;
_.val$deselectAllButton = null;
_.val$ignoreButton = null;
_.val$importButton = null;
_.val$selectAllButton = null;
_.val$unignoreButton = null;
function $onSuccess_407(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Enhanced() , 'You have successfully unignored the selected Resources.'), ($clinit_Message$Severity() , Info)));
  this$static.this$1.this$0.refresh_0();
}

function ResourceAutodiscoveryView$9$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3532, 1, {}, ResourceAutodiscoveryView$9$1_0);
_.onFailure = function onFailure_421(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to unignore Resources'), caught);
}
;
_.onSuccess_0 = function onSuccess_421(result){
  $onSuccess_407(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
function $setNewResourceArchitectureId(this$static, newResourceArchitectureId){
  this$static.newResourceArchitectureId = newResourceArchitectureId;
}

function $setNewResourceConfiguration(this$static, newResourceConfiguration){
  this$static.newResourceConfiguration = newResourceConfiguration;
}

function $setNewResourceConfigurationDefinition(this$static, newResourceConfigurationDefinition){
  var defaultTemplate;
  if (!this$static.newResourceConfigurationDefinition || this$static.newResourceConfigurationDefinition != newResourceConfigurationDefinition) {
    this$static.newResourceConfigurationDefinition = newResourceConfigurationDefinition;
    if (newResourceConfigurationDefinition) {
      defaultTemplate = $getDefaultTemplate(this$static.newResourceConfigurationDefinition);
      this$static.newResourceStartingConfiguration = defaultTemplate?$deepCopy(defaultTemplate.configuration, false):new Configuration_0;
    }
  }
}

function $setNewResourceCreateTimeout(this$static, newResourceCreateTimeout){
  this$static.newResourceCreateTimeout = newResourceCreateTimeout;
}

function $setNewResourceName(this$static, newResourceName){
  this$static.newResourceName = newResourceName;
}

function $setNewResourceStartingConfiguration(this$static, newResourceStartingConfiguration){
  this$static.newResourceStartingConfiguration = newResourceStartingConfiguration;
}

function $setNewResourceVersion(this$static, newResourceVersion){
  this$static.newResourceVersion = newResourceVersion;
}

function AbstractResourceFactoryWizard_0(parentResource, childType){
  this.parentResource = parentResource;
  this.childType = childType;
}

defineSeed(3533, 2036, {});
_.cancel_0 = function cancel_8(){
}
;
_.getSubtitle = function getSubtitle_5(){
  return null;
}
;
_.childType = null;
_.newResourceArchitectureId = null;
_.newResourceConfiguration = null;
_.newResourceConfigurationDefinition = null;
_.newResourceCreateTimeout = null;
_.newResourceName = null;
_.newResourceStartingConfiguration = null;
_.newResourceVersion = null;
_.parentResource = null;
function ResourceFactoryConfigurationStep_0(wizard){
  this.wizard = wizard;
}

defineSeed(3534, 2040, makeCastMap([Q$PropertyValueChangeListener, Q$WizardStep]), ResourceFactoryConfigurationStep_0);
_.getCanvas = function getCanvas_20(){
  var configurationService, def, doomedConfigEditor, newCanvas, productInfo, supportedUnits, timeoutForm;
  newCanvas = !this.vLayout;
  if (newCanvas) {
    this.vLayout = new EnhancedVLayout_0;
    supportedUnits = new TreeSet_0;
    $add_8(supportedUnits, ($clinit_TimeUnit() , SECONDS_0));
    $add_8(supportedUnits, MINUTES_1);
    this.timeoutItem = new DurationItem_1('timeout', ($clinit_WizardStep() , 'Timeout'), MILLISECONDS_0, supportedUnits, false, false);
    productInfo = ($clinit_CoreGUI() , $clinit_CoreGUI() , coreGUI).productInfo;
    $setContextualHelp(this.timeoutItem, 'A timeout duration that if specified will override the default timeout for child resource creation (on the ' + productInfo.shortName + ' Agent). The default timeout is set to 60 seconds. A higher value may be useful for particularly long create actions, like deployment of a large application. Usually used if a previous attempt suffered a timeout failure. Note that if there is a timeout failure, it is still possible that the resource deployment succeeded. In the event of a timeout you may want to execute a discovery scan before attempting to redeploy the resource.');
    timeoutForm = new DynamicForm_0;
    timeoutForm.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [this.timeoutItem]));
    $setMargin(timeoutForm, valueOf_44(10));
    $addMember(this.vLayout, timeoutForm);
  }
  if (newCanvas || this.startingConfig != this.wizard.newResourceStartingConfiguration) {
    def = this.wizard.newResourceConfigurationDefinition;
    if (def) {
      this.startingConfig = this.wizard.newResourceStartingConfiguration;
      if (!newCanvas) {
        doomedConfigEditor = $getMember(this.vLayout, 0);
        $removeMember(this.vLayout, doomedConfigEditor);
        doomedConfigEditor.destroy_0();
      }
      this.startingConfig = this.wizard.newResourceStartingConfiguration;
      configurationService = dynamicCast(secure((!instance_9 && (instance_9 = new ConfigurationGWTService_Proxy_0) , instance_9), -1), Q$ConfigurationGWTServiceAsync);
      $getOptionValuesForConfigDefinition(configurationService, -1, def, new ResourceFactoryConfigurationStep$1_0(this, def));
    }
  }
  return this.vLayout;
}
;
_.getName = function getName_27(){
  return $clinit_WizardStep() , 'Deployment Options';
}
;
_.isNextButtonEnabled = function isNextButtonEnabled_0(){
  return !this.editor || !$hasErrors(this.editor.topLevelPropertiesValuesManager).value_0;
}
;
_.nextPage_0 = function nextPage_18(){
  if (!this.editor || !$hasErrors(this.editor.topLevelPropertiesValuesManager).value_0) {
    $setNewResourceConfiguration(this.wizard, !this.editor?new Configuration_0:this.editor.configuration);
    $setNewResourceCreateTimeout(this.wizard, toInteger($getValue_0(this.timeoutItem)));
    this.wizard.execute_1();
    return true;
  }
  return false;
}
;
_.propertyValueChanged = function propertyValueChanged_8(event_0){
  $updateButtonEnablement(this.wizard.view);
}
;
_.editor = null;
_.startingConfig = null;
_.timeoutItem = null;
_.vLayout = null;
_.wizard = null;
function $createAndAddConfigurationEditor(this$static, def){
  this$static.this$0.editor = new ConfigurationEditor_1(def, this$static.this$0.startingConfig);
  this$static.this$0.editor.allPropertiesWritable = true;
  $addPropertyValueChangeListener(this$static.this$0.editor, this$static.this$0);
  $updateButtonEnablement(this$static.this$0.wizard.view);
  $addMember_0(this$static.this$0.vLayout, this$static.this$0.editor, 0);
}

function ResourceFactoryConfigurationStep$1_0(this$0, val$def){
  this.this$0 = this$0;
  this.val$def = val$def;
}

defineSeed(3535, 1, {}, ResourceFactoryConfigurationStep$1_0);
_.onFailure = function onFailure_422(throwable){
  $createAndAddConfigurationEditor(this, this.val$def);
}
;
_.onSuccess_0 = function onSuccess_422(result){
  $createAndAddConfigurationEditor(this, dynamicCast(result, Q$ConfigurationDefinition));
}
;
_.this$0 = null;
_.val$def = null;
function $setNewResourcePackageVersionId(this$static, newResourcePackageVersionId){
  this$static.newResourcePackageVersionId = newResourcePackageVersionId;
}

function ResourceFactoryCreateWizard_0(parentResource, childType, packageType){
  var archPrompt, deployTimeConfigDef, resourceConfigDef, steps, templates;
  AbstractResourceFactoryWizard_0.call(this, parentResource, childType);
  this.newResourcePackageType = packageType;
  steps = new ArrayList_0;
  switch (childType.creationDataType.ordinal) {
    case 1:
      {
        archPrompt = packageType.supportsArchitecture?($clinit_Wizard() , 'Package Architecture'):null;
        deployTimeConfigDef = packageType.deploymentConfigurationDefinition;
        $setNewResourceConfigurationDefinition(this, deployTimeConfigDef);
        templates = ($clinit_Collections() , $clinit_Collections() , EMPTY_MAP);
        !!deployTimeConfigDef && (templates = (!deployTimeConfigDef.templates && (deployTimeConfigDef.templates = new LinkedHashMap_0) , deployTimeConfigDef.templates));
        $add_3(steps, new ResourceFactoryInfoStep_0(this, null, ($clinit_Wizard() , 'Package Version'), archPrompt, 'Deployment Configuration Template', templates));
        $add_3(steps, new ResourceFactoryPackageStep_0(this));
        $add_3(steps, new ResourceFactoryConfigurationStep_0(this));
        this.steps = steps;
        break;
      }

    case 0:
      {
        resourceConfigDef = this.childType.resourceConfigurationDefinition;
        $setNewResourceConfigurationDefinition(this, resourceConfigDef);
        templates = resourceConfigDef?(!resourceConfigDef.templates && (resourceConfigDef.templates = new LinkedHashMap_0) , resourceConfigDef.templates):($clinit_Collections() , $clinit_Collections() , EMPTY_MAP);
        $add_3(steps, new ResourceFactoryInfoStep_1(this, ($clinit_Wizard() , 'New Resource Name'), 'Resource Configuration Template', templates));
        $add_3(steps, new ResourceFactoryConfigurationStep_0(this));
        this.steps = steps;
        break;
      }

  }
}

function showCreateWizard(parentResource, childType){
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(childType.id), of(($clinit_ResourceTypeRepository$MetadataType() , resourceConfigurationDefinition_0)), new ResourceFactoryCreateWizard$3_0(parentResource));
}

defineSeed(3536, 3533, {}, ResourceFactoryCreateWizard_0);
_.cancel_0 = function cancel_9(){
  !!this.newResourcePackageVersionId && $deletePackageVersion(dynamicCast(secure(getInstance_38(), -1), Q$ContentGWTServiceAsync), this.newResourcePackageVersionId.value_0, new ResourceFactoryCreateWizard$4_0);
}
;
_.execute_1 = function execute_63(){
  var createTypeId, deployTimeConfiguration, newResourceName, packageVersionId, parentResourceId, resourceConfiguration;
  parentResourceId = this.parentResource.id;
  createTypeId = this.childType.id;
  switch (this.childType.creationDataType.ordinal) {
    case 1:
      {
        deployTimeConfiguration = this.newResourceConfiguration;
        packageVersionId = this.newResourcePackageVersionId;
        if (!packageVersionId) {
          $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to create a new resource - there is no package version'), null);
          $closeDialog(this.view);
        }
        $createResource(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), parentResourceId, createTypeId, deployTimeConfiguration, packageVersionId.value_0, this.newResourceCreateTimeout, new ResourceFactoryCreateWizard$1_0(this));
        break;
      }

    case 0:
      {
        newResourceName = this.newResourceName;
        resourceConfiguration = this.newResourceConfiguration;
        $createResource_0(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), parentResourceId, createTypeId, newResourceName, resourceConfiguration, this.newResourceCreateTimeout, new ResourceFactoryCreateWizard$2_0(this, newResourceName));
        break;
      }

  }
}
;
_.getSubtitle = function getSubtitle_6(){
  return null;
}
;
_.getTitle = function getTitle_7(){
  return 'Create New Resource of Type [' + ($clinit_Wizard() , this.childType.name_0) + ']';
}
;
_.getWindowTitle = function getWindowTitle_3(){
  return $clinit_Wizard() , 'Resource Create Wizard';
}
;
_.newResourcePackageType = null;
_.newResourcePackageVersionId = null;
function $onSuccess_408(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('A request to create a Resource of type [' + ($clinit_Wizard() , this$static.this$0.childType.name_0) + '] has been submitted successfully. Note, it may take several minutes for the Resource to show up in inventory.', ($clinit_Message$Severity() , Info)));
  $closeDialog(this$static.this$0.view);
}

function ResourceFactoryCreateWizard$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3537, 1, {}, ResourceFactoryCreateWizard$1_0);
_.onFailure = function onFailure_423(caught){
  instanceOf(caught, Q$CannotConnectToAgentException)?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Wizard() , 'Failed to create a new resource. Cannot connect to the agent. This may indicate that the agent is down.'), ($clinit_Message$Severity() , Warning))):$handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to create a new resource'), caught);
  $closeDialog(this.this$0.view);
}
;
_.onSuccess_0 = function onSuccess_423(result){
  $onSuccess_408(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
function $onSuccess_409(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('A request to create a Resource with the name of [' + ($clinit_Wizard() , this$static.val$newResourceName) + '] has been submitted successfully. Note, it may take several minutes for the Resource to show up in inventory.', ($clinit_Message$Severity() , Info)));
  $closeDialog(this$static.this$0.view);
}

function ResourceFactoryCreateWizard$2_0(this$0, val$newResourceName){
  this.this$0 = this$0;
  this.val$newResourceName = val$newResourceName;
}

defineSeed(3538, 1, {}, ResourceFactoryCreateWizard$2_0);
_.onFailure = function onFailure_424(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to create a new resource. Cannot connect to the agent. This may indicate that the agent is down.'), caught);
  $closeDialog(this.this$0.view);
}
;
_.onSuccess_0 = function onSuccess_424(result){
  $onSuccess_409(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$newResourceName = null;
function ResourceFactoryCreateWizard$3_0(val$parentResource){
  this.val$parentResource = val$parentResource;
}

defineSeed(3539, 1, {}, ResourceFactoryCreateWizard$3_0);
_.onTypesLoaded = function onTypesLoaded_44(loadedChildType){
  var wizard;
  switch (loadedChildType.creationDataType.ordinal) {
    case 1:
      {
        $getResourceCreationPackageType(dynamicCast(secure(getInstance_38(), -1), Q$ContentGWTServiceAsync), loadedChildType.id, new ResourceFactoryCreateWizard$3$1_0(this.val$parentResource, loadedChildType));
        break;
      }

    case 0:
      {
        wizard = new ResourceFactoryCreateWizard_0(this.val$parentResource, loadedChildType, null);
        wizard.view = new WizardView_0(wizard);
        $displayDialog(wizard.view);
        break;
      }

  }
}
;
_.val$parentResource = null;
function $onSuccess_410(this$static, result){
  var wizard;
  wizard = new ResourceFactoryCreateWizard_0(this$static.val$parentResource, this$static.val$loadedChildType, result);
  wizard.view = new WizardView_0(wizard);
  $displayDialog(wizard.view);
}

function ResourceFactoryCreateWizard$3$1_0(val$parentResource, val$loadedChildType){
  this.val$parentResource = val$parentResource;
  this.val$loadedChildType = val$loadedChildType;
}

defineSeed(3540, 1, {}, ResourceFactoryCreateWizard$3$1_0);
_.onFailure = function onFailure_425(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to get backing package type for new resource'), caught);
}
;
_.onSuccess_0 = function onSuccess_425(result){
  $onSuccess_410(this, dynamicCast(result, Q$PackageType));
}
;
_.val$loadedChildType = null;
_.val$parentResource = null;
function ResourceFactoryCreateWizard$4_0(){
}

defineSeed(3541, 1, {}, ResourceFactoryCreateWizard$4_0);
_.onFailure = function onFailure_426(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to delete package version while canceling a resource create'), caught);
}
;
_.onSuccess_0 = function onSuccess_426(ignore){
  throwClassCastExceptionUnlessNull(ignore);
}
;
function ResourceFactoryImportWizard_0(parentResource, childType){
  var childTypePluginConfigDef, steps, templates;
  AbstractResourceFactoryWizard_0.call(this, parentResource, childType);
  childTypePluginConfigDef = this.childType.pluginConfigurationDefinition;
  $setNewResourceConfigurationDefinition(this, childTypePluginConfigDef);
  steps = new ArrayList_0;
  if (childTypePluginConfigDef) {
    templates = (!childTypePluginConfigDef.templates && (childTypePluginConfigDef.templates = new LinkedHashMap_0) , childTypePluginConfigDef.templates);
    if (templates.size_1() > 1) {
      this.infoStep = new ResourceFactoryInfoStep_1(this, null, ($clinit_Wizard() , 'Connection Settings Template'), templates);
      $add_3(steps, this.infoStep);
    }
  }
  this.configurationStep = new ResourceFactoryConfigurationStep_0(this);
  $add_3(steps, this.configurationStep);
  this.steps = steps;
}

function showImportWizard(parentResource, childType){
  $getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(childType.id), of(($clinit_ResourceTypeRepository$MetadataType() , pluginConfigurationDefinition_0)), new ResourceFactoryImportWizard$2_0(parentResource));
}

defineSeed(3542, 3533, {}, ResourceFactoryImportWizard_0);
_.execute_1 = function execute_64(){
  var createTypeId, newConfiguration, parentResourceId;
  parentResourceId = this.parentResource.id;
  createTypeId = this.childType.id;
  newConfiguration = this.newResourceConfiguration;
  $manuallyAddResource(dynamicCast(secure(getInstance_51(), 300000), Q$ResourceGWTServiceAsync), createTypeId, parentResourceId, newConfiguration, new ResourceFactoryImportWizard$1_0(this));
}
;
_.getTitle = function getTitle_8(){
  return 'Import Resource of Type [' + ($clinit_Wizard() , this.childType.name_0) + ']';
}
;
_.getWindowTitle = function getWindowTitle_4(){
  return $clinit_Wizard() , 'Resource Import Wizard';
}
;
_.configurationStep = null;
_.infoStep = null;
function $onSuccess_411(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('A request to import a new resource of type [' + ($clinit_Wizard() , this$static.this$0.childType.name_0) + '] has been submitted', ($clinit_Message$Severity() , Info)));
  $closeDialog(this$static.this$0.view);
}

function ResourceFactoryImportWizard$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3543, 1, {}, ResourceFactoryImportWizard$1_0);
_.onFailure = function onFailure_427(caught){
  instanceOf(caught, Q$CannotConnectToAgentException)?$notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_Wizard() , 'Failed to manually import resource. Cannot connect to the agent. This may indicate that the agent is down.'), ($clinit_Message$Severity() , Warning))):$handleError_0(($clinit_CoreGUI() , $clinit_Wizard() , 'Failed to manually import resource'), caught);
  $closeDialog(this.this$0.view);
}
;
_.onSuccess_0 = function onSuccess_427(result){
  $onSuccess_411(this, dynamicCast(result, Q$Resource));
}
;
_.this$0 = null;
function ResourceFactoryImportWizard$2_0(val$parentResource){
  this.val$parentResource = val$parentResource;
}

defineSeed(3544, 1, {}, ResourceFactoryImportWizard$2_0);
_.onTypesLoaded = function onTypesLoaded_45(type){
  var wizard;
  wizard = new ResourceFactoryImportWizard_0(this.val$parentResource, type);
  wizard.view = new WizardView_0(wizard);
  $displayDialog(wizard.view);
}
;
_.val$parentResource = null;
function ResourceFactoryInfoStep_0(wizard, namePrompt, versionPrompt, architecturePrompt, templatePrompt, templates){
  this.wizard = wizard;
  this.namePrompt = namePrompt;
  this.versionPrompt = versionPrompt;
  this.architecturePrompt = architecturePrompt;
  this.templatePrompt = templatePrompt;
  this.templates = templates;
}

function ResourceFactoryInfoStep_1(wizard, namePrompt, templatePrompt, templates){
  ResourceFactoryInfoStep_0.call(this, wizard, namePrompt, null, null, templatePrompt, templates);
}

defineSeed(3545, 2040, makeCastMap([Q$WizardStep]), ResourceFactoryInfoStep_0, ResourceFactoryInfoStep_1);
_.getCanvas = function getCanvas_21(){
  var formItems, nameItem, templateSelect, versionItem;
  if (!this.form_0) {
    this.form_0 = new DynamicForm_0;
    $setNumCols(this.form_0, 1);
    formItems = new ArrayList_1(2);
    if (null != this.namePrompt) {
      nameItem = new TextItem_3('resourceName', this.namePrompt);
      $setRequired(nameItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
      $setAttribute_30(nameItem, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0);
      $setAttribute_30(nameItem, 'align', ($clinit_Alignment() , LEFT_0).value_0);
      $isCreated_2(nameItem)?$setProperty_6(nameItem, 'width', 300):(nameItem.jsObj['width'] = 300 , undefined);
      $addChangedHandler(nameItem, new ResourceFactoryInfoStep$1_0(this));
      setCheck(formItems.array, formItems.size_0++, nameItem);
    }
    if (null != this.versionPrompt) {
      versionItem = new TextItem_3('version', this.versionPrompt);
      $setRequired(versionItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
      $setAttribute_30(versionItem, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0);
      $setAttribute_30(versionItem, 'align', ($clinit_Alignment() , LEFT_0).value_0);
      $isCreated_2(versionItem)?$setProperty_6(versionItem, 'width', 300):(versionItem.jsObj['width'] = 300 , undefined);
      $setValue_7(versionItem, '0');
      this.wizard.newResourceVersion = '0';
      $addChangedHandler(versionItem, new ResourceFactoryInfoStep$2_0(this));
      setCheck(formItems.array, formItems.size_0++, versionItem);
    }
    if (null != this.architecturePrompt) {
      this.selectArchItem = new SelectItem_2('selectArch', this.architecturePrompt);
      $setRequired(this.selectArchItem, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
      $setDisabled_2(this.selectArchItem, TRUE);
      $setAttribute_30(this.selectArchItem, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0);
      $setAttribute_30(this.selectArchItem, 'align', ($clinit_Alignment() , LEFT_0).value_0);
      $setWidth_1(this.selectArchItem, 300);
      $getArchitectures(dynamicCast(secure(getInstance_38(), -1), Q$ContentGWTServiceAsync), new ResourceFactoryInfoStep$5_0(this));
      $addChangedHandler(this.selectArchItem, new ResourceFactoryInfoStep$3_0(this));
      $add_3(formItems, this.selectArchItem);
    }
    if (null != this.templatePrompt) {
      templateSelect = new SortedSelectItem_2('template', this.templatePrompt);
      $setAttribute_30(templateSelect, 'titleOrientation', ($clinit_TitleOrientation() , TOP_1).value_0);
      $setAttribute_30(templateSelect, 'align', ($clinit_Alignment() , LEFT_0).value_0);
      $isCreated_2(templateSelect)?$setProperty_6(templateSelect, 'width', 300):(templateSelect.jsObj['width'] = 300 , undefined);
      if (!!this.templates && this.templates.size_1() > 1) {
        $setValueMap_2(templateSelect, dynamicCast(this.templates.keySet_0().toArray_0(initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, this.templates.size_1(), 0)), Q$String_$1));
        $setValue_7(templateSelect, 'default');
        $setNewResourceStartingConfiguration(this.wizard, $deepCopy(dynamicCast(this.templates.get_2('default'), Q$ConfigurationTemplate).configuration, false));
        $addChangedHandler(templateSelect, new ResourceFactoryInfoStep$4_0(this));
      }
       else {
        $setVisible(templateSelect, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
      }
      setCheck(formItems.array, formItems.size_0++, templateSelect);
    }
    this.form_0.setItems(dynamicCast($toArray_1(formItems, initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, formItems.size_0, 0)), Q$FormItem_$1));
  }
  return this.form_0;
}
;
_.getName = function getName_28(){
  return $clinit_WizardStep() , 'Resource Information';
}
;
_.nextPage_0 = function nextPage_19(){
  return this.form_0.validate_0();
}
;
_.architecturePrompt = null;
_.form_0 = null;
_.namePrompt = null;
_.selectArchItem = null;
_.selectArchValues = null;
_.templatePrompt = null;
_.templates = null;
_.versionPrompt = null;
_.wizard = null;
function ResourceFactoryInfoStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3546, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ResourceFactoryInfoStep$1_0);
_.onChanged = function onChanged_72(event_0){
  var value;
  value = $getValue_2(event_0);
  value == null && (value = '');
  $setNewResourceName(this.this$0.wizard, toString__devirtual$(value));
}
;
_.this$0 = null;
function ResourceFactoryInfoStep$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3547, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ResourceFactoryInfoStep$2_0);
_.onChanged = function onChanged_73(event_0){
  var value;
  value = $getValue_2(event_0);
  value == null && (value = '');
  $setNewResourceVersion(this.this$0.wizard, toString__devirtual$(value));
}
;
_.this$0 = null;
function ResourceFactoryInfoStep$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3548, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ResourceFactoryInfoStep$3_0);
_.onChanged = function onChanged_74(event_0){
  var value;
  value = $getValue_2(event_0);
  value != null && $setNewResourceArchitectureId(this.this$0.wizard, dynamicCast(value, Q$Integer));
}
;
_.this$0 = null;
function ResourceFactoryInfoStep$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3549, 1, makeCastMap([Q$EventHandler, Q$ChangedHandler]), ResourceFactoryInfoStep$4_0);
_.onChanged = function onChanged_75(event_0){
  var value;
  value = $getValue_2(event_0);
  value == null && (value = '');
  $setNewResourceStartingConfiguration(this.this$0.wizard, $deepCopy(dynamicCast(this.this$0.templates.get_2(value), Q$ConfigurationTemplate).configuration, false));
}
;
_.this$0 = null;
function $onSuccess_412(this$static, result){
  var arch, arch$iterator;
  this$static.this$0.selectArchValues = new LinkedHashMap_0;
  for (arch$iterator = result.iterator(); arch$iterator.hasNext();) {
    arch = dynamicCast(arch$iterator.next_0(), Q$Architecture);
    $put_1(this$static.this$0.selectArchValues, arch.name_0, valueOf_44(arch.id));
  }
  this$static.this$0.selectArchItem.setValueMap_0(this$static.this$0.selectArchValues);
  $setValue_7(this$static.this$0.selectArchItem, 'noarch');
  $setNewResourceArchitectureId(this$static.this$0.wizard, dynamicCast($get_4(this$static.this$0.selectArchValues, 'noarch'), Q$Integer));
  $setDisabled_2(this$static.this$0.selectArchItem, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $redraw_0(this$static.this$0.selectArchItem);
}

function ResourceFactoryInfoStep$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3550, 1, {}, ResourceFactoryInfoStep$5_0);
_.onFailure = function onFailure_428(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_WizardStep() , 'Failed to get available Architectures'), caught);
}
;
_.onSuccess_0 = function onSuccess_428(result){
  $onSuccess_412(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
function $handleUploadError_1(this$static, errorMessage, sendToMessageCenter){
  null != errorMessage?$showMessage(this$static.wizard.view, errorMessage):(errorMessage = '');
  sendToMessageCenter && $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7(($clinit_WizardStep() , 'Failed to upload file') + ': ' + errorMessage, ($clinit_Message$Severity() , Error_2)));
}

function $processUpload_0(this$static){
  var errorMessage;
  if ($equals_2(($clinit_Boolean() , TRUE), this$static.uploadForm.uploadResult)) {
    this$static.isUploadComplete = true;
    $setNewResourcePackageVersionId(this$static.wizard, valueOf_44(this$static.uploadForm.packageVersionId));
  }
   else {
    errorMessage = this$static.uploadForm.uploadError;
    $handleUploadError_1(this$static, errorMessage, true);
  }
}

function ResourceFactoryPackageStep_0(wizard){
  this.wizard = wizard;
}

defineSeed(3551, 2040, makeCastMap([Q$WizardStep]), ResourceFactoryPackageStep_0);
_.getCanvas = function getCanvas_22(){
  if (!this.uploadForm) {
    this.uploadForm = new PackageVersionFileUploadForm_0(this.wizard.newResourcePackageType.id, this.wizard.childType.name_0, this.wizard.newResourceVersion, this.wizard.newResourceArchitectureId, true, null);
    $setPadding(this.uploadForm, valueOf_44(20));
    $addFormHandler(this.uploadForm, new ResourceFactoryPackageStep$1_0(this));
    $addFormSubmitFailedHandler(this.uploadForm, new ResourceFactoryPackageStep$2_0);
  }
  return this.uploadForm;
}
;
_.getName = function getName_29(){
  return $clinit_WizardStep() , 'Upload Resource Content File';
}
;
_.nextPage_0 = function nextPage_20(){
  $hide(this.wizard.view.messageBar);
  if (this.uploadForm.uploadInProgress) {
    $handleUploadError_1(this, ($clinit_WizardStep() , 'The upload is in progress... This can take several minutes to complete for large distribution files.'), false);
    return false;
  }
  if (!this.isUploadComplete) {
    $submitForm_2(this.uploadForm);
    $handleUploadError_1(this, this.uploadForm.uploadError, false);
    return false;
  }
  return true;
}
;
_.isUploadComplete = false;
_.uploadForm = null;
_.wizard = null;
function ResourceFactoryPackageStep$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3552, 1, makeCastMap([Q$DynamicFormHandler]), ResourceFactoryPackageStep$1_0);
_.onSubmitComplete = function onSubmitComplete_4(event_0){
  $processUpload_0(this.this$0);
}
;
_.this$0 = null;
function ResourceFactoryPackageStep$2_0(){
}

defineSeed(3553, 1, makeCastMap([Q$EventHandler, Q$FormSubmitFailedHandler]), ResourceFactoryPackageStep$2_0);
_.onFormSubmitFailed = function onFormSubmitFailed_2(event_0){
  return;
}
;
function ResourceGroupSelector$SelectedResourceGroupsDataSource_0(){
  $clinit_RPCDataSource();
  ResourceGroupsDataSource_0.call(this);
}

defineSeed(3554, 2089, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceGroupSelector$SelectedResourceGroupsDataSource_0);
_.getFetchCriteria_2 = function getFetchCriteria_74(request){
  var result;
  result = $getFetchCriteria_6(request);
  !!result && (result.strict = false);
  return result;
}
;
function $cancel_1(this$static){
  this$static.selector = null;
  $markForDestroy(this$static);
}

function $showWarningMessage(this$static, msg){
  var timer;
  $setContents_0(this$static.warningLabel, msg);
  $show(this$static.warningLabel);
  $markForRedraw(this$static);
  timer = new ResourcePicker$4_0(this$static);
  $schedule(timer, 15000);
}

function ResourcePicker_0(okHandler){
  var cancel, form, layout, ok;
  Window_1.call(this);
  $clinit_CoreGUI();
  if (!okHandler) {
    throw new IllegalArgumentException_1('okHandler == null');
  }
  this.okHandler = okHandler;
  ($getAttributeAsString_0(this, 'title') == null || $getAttributeAsString_0(this, 'title').indexOf('Untitled') != -1) && $setTitle(this, this.getDefaultTitle());
  $setShowModalMask(this, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setShowMinimizeButton(this, FALSE);
  $setIsModal(this, TRUE);
  $isCreated_1(this)?$setProperty_0(this, 'width', 700):(this.config_0['width'] = 700 , undefined);
  $isCreated_1(this)?$setProperty_0(this, 'height', 425):(this.config_0['height'] = 425 , undefined);
  $setAutoCenter(this, TRUE);
  $centerInPage(this);
  $addCloseClickHandler(this, new ResourcePicker$1_0(this));
  layout = new EnhancedVLayout_0;
  $setAttribute_24(layout, 'layoutAlign', ($clinit_Alignment() , CENTER_0).value_0, false);
  $setLayoutMargin(layout, valueOf_44(10));
  this.warningLabel = new Label_3;
  $setContents_0(this.warningLabel, '');
  $setAttribute_24(this.warningLabel, 'align', CENTER_0.value_0, true);
  $setStyleName_0(this.warningLabel, 'WarnBlock');
  $setAutoHeight(this.warningLabel);
  $setAttribute_24(this.warningLabel, 'width', '100%', true);
  $setWrap_0(this.warningLabel, FALSE);
  $setAttribute_24(this.warningLabel, 'visibility', ($clinit_Visibility() , HIDDEN_0).value_0, true);
  this.selector = (!this.selector && (this.selector = this.createResourceSelector()) , this.selector);
  form = new DynamicForm_0;
  $setAttribute_24(form, 'layoutAlign', CENTER_0.value_0, false);
  $isCreated_1(form)?$setProperty_0(form, 'width', 1):(form.config_0['width'] = 1 , undefined);
  $isCreated_1(form)?$setProperty_0(form, 'height', 1):(form.config_0['height'] = 1 , undefined);
  $isCreated_1(form)?$setProperty_0(form, 'cellPadding', 10):(form.config_0['cellPadding'] = 10 , undefined);
  ok = new ButtonItem_1('ok', 'OK');
  $setStartRow_1(ok, TRUE);
  $setEndRow_1(ok, FALSE);
  $addClickHandler_1(ok, new ResourcePicker$2_0(this));
  cancel = new ButtonItem_1('cancel', 'Cancel');
  $addClickHandler_1(cancel, new ResourcePicker$3_0(this));
  $setStartRow_1(cancel, FALSE);
  $setEndRow_1(cancel, TRUE);
  form.setFields(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [ok, cancel]));
  $addMember(layout, this.warningLabel);
  $addMember(layout, this.selector);
  $addMember(layout, form);
  $addItem(this, layout);
}

defineSeed(3555, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]));
_.createResourceSelector = function createResourceSelector(){
  return new ResourceSelector_0;
}
;
_.getDefaultTitle = function getDefaultTitle(){
  return 'Select Resources';
}
;
_.ok = function ok_0(){
  var handler, selection;
  handler = this.okHandler;
  selection = $getSelection(this.selector);
  if (!selection || selection.map.size_1() == 0) {
    $showWarningMessage(this, 'Please select one or more resources');
  }
   else {
    if ($ok(handler, selection)) {
      this.selector = null;
      $markForDestroy(this);
    }
  }
}
;
_.okHandler = null;
_.selector = null;
_.warningLabel = null;
function ResourcePicker$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3556, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), ResourcePicker$1_0);
_.onCloseClick_0 = function onCloseClick_18(event_0){
  $cancel_1(this.this$0);
}
;
_.this$0 = null;
function ResourcePicker$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3557, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), ResourcePicker$2_0);
_.onClick_0 = function onClick_173(event_0){
  this.this$0.ok();
}
;
_.this$0 = null;
function ResourcePicker$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3558, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), ResourcePicker$3_0);
_.onClick_0 = function onClick_174(event_0){
  $cancel_1(this.this$0);
}
;
_.this$0 = null;
function ResourcePicker$4_0(this$0){
  $clinit_Timer();
  this.this$0 = this$0;
}

defineSeed(3559, 73, makeCastMap([Q$Timer]), ResourcePicker$4_0);
_.run = function run_15(){
  $hide(this.this$0.warningLabel);
  $markForRedraw(this.this$0);
}
;
_.this$0 = null;
function ResourceSelector$1_0(){
}

defineSeed(3560, 1, {}, ResourceSelector$1_0);
_.hoverHTML_0 = function hoverHTML_52(value, listGridRecord, rowNum, colNum){
  return getAncestryHoverHTML(listGridRecord, 0);
}
;
function ResourceSelector$SelectedResourceDataSource_0(this$0){
  $clinit_RPCDataSource();
  this.this$0 = this$0;
  ResourceDatasource_0.call(this);
}

defineSeed(3561, 3267, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceSelector$SelectedResourceDataSource_0);
_.getFetchCriteria_9 = function getFetchCriteria_75(request){
  var result;
  if (this.this$0.resourceTypeFilter) {
    $setValue_5(this.this$0.typeSelectItem, this.this$0.resourceTypeFilter.id);
    $addCriteria_2($getCriteria(request), ($clinit_ResourceDataSourceField() , TYPE_56).propertyName, '' + this.this$0.resourceTypeFilter.id);
    this.this$0.resourceTypeFilter = null;
  }
  result = $getFetchCriteria_12(this, request);
  result.fetchResourceType = true;
  return result;
}
;
_.this$0 = null;
function SingleResourceGroupSelector_0(categoryFilter){
  $clinit_ResourceGroupSelector();
  ResourceGroupSelector_0.call(this, categoryFilter, false);
}

defineSeed(3562, 1703, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), SingleResourceGroupSelector_0);
_.addSelectedRows = function addSelectedRows_0(){
  $getTotalRows(this.assignedGrid) == 0 && $addSelectedRows(this);
}
;
_.onInit = function onInit_68(){
  $onInit_3(this);
  $setAttribute_24(this.availableGrid, 'selectionType', ($clinit_SelectionStyle() , SINGLE).value_0, true);
}
;
_.updateButtonEnablement = function updateButtonEnablement_0(){
  $setDisabled_1(this.addButton, !$anySelected(this.availableGrid).value_0 || $getTotalRows(this.availableGrid) == 0 || $getTotalRows(this.assignedGrid) > 0);
  $setDisabled_1(this.removeButton, !$anySelected(this.assignedGrid).value_0);
  $hide(this.addAllButton);
  $hide(this.removeAllButton);
}
;
function SingleResourcePicker_0(okHandler){
  $clinit_BaseWidget();
  ResourcePicker_0.call(this, okHandler);
}

defineSeed(3563, 3555, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), SingleResourcePicker_0);
_.createResourceSelector = function createResourceSelector_0(){
  return new SingleResourceSelector_0;
}
;
_.getDefaultTitle = function getDefaultTitle_0(){
  return 'Select a Resource';
}
;
_.ok = function ok_1(){
  var handler, selection;
  handler = this.okHandler;
  selection = $getSelection((!this.selector && (this.selector = new SingleResourceSelector_0) , this.selector));
  !selection || selection.map.size_1() != 1?$showWarningMessage(this, 'Please select a resource'):$ok(handler, selection) && $markForDestroy(this);
}
;
function SingleResourceSelector_0(){
  ResourceSelector_0.call(this);
}

defineSeed(3564, 3180, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), SingleResourceSelector_0);
_.addSelectedRows = function addSelectedRows_1(){
  $getTotalRows(this.assignedGrid) == 0 && $addSelectedRows(this);
}
;
_.onInit = function onInit_69(){
  $onInit_3(this);
  $setAttribute_24(this.availableGrid, 'selectionType', ($clinit_SelectionStyle() , SINGLE).value_0, true);
}
;
_.updateButtonEnablement = function updateButtonEnablement_1(){
  $setDisabled_1(this.addButton, !$anySelected(this.availableGrid).value_0 || $getTotalRows(this.availableGrid) == 0 || $getTotalRows(this.assignedGrid) > 0);
  $setDisabled_1(this.removeButton, !$anySelected(this.assignedGrid).value_0);
  $hide(this.addAllButton);
  $hide(this.removeAllButton);
}
;
function $executeFetch_50(this$static, request, response){
  var criteria, parentIdString;
  parentIdString = $getAttributeAsString($getCriteria(request), 'parentId');
  if (parentIdString != null) {
    $processResponse(this$static, getAttribute(request.jsObj, 'requestId'), response);
  }
   else {
    criteria = new ResourceTypeCriteria_0;
    $addFilterIgnored(criteria, this$static.showIgnoredResourceTypes?null:($clinit_Boolean() , FALSE));
    criteria.fetchParentResourceTypes = true;
    $setPageControl(criteria, new PageControl_1(0, -1));
    $findResourceTypesByCriteria(this$static.resourceTypeService, criteria, new ResourceTypePluginTreeDataSource$1_0(this$static, response, request));
  }
}

function ResourceTypePluginTreeDataSource_0(){
  var idField, parentIdField, resourceKeyField, resourceNameField, resourceTypeField;
  DataSource_0.call(this);
  $clinit_CoreGUI();
  this.resourceTypeService = dynamicCast(secure((!instance_28 && (instance_28 = new ResourceTypeGWTService_Proxy_0) , instance_28), -1), Q$ResourceTypeGWTServiceAsync);
  this.showIgnoredResourceTypes = false;
  $setClientOnly(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setAttribute_1(this, 'dataProtocol', ($clinit_DSProtocol() , CLIENTCUSTOM).value_0);
  $setAttribute_1(this, 'dataFormat', ($clinit_DSDataFormat() , CUSTOM).value_0);
  idField = new DataSourceTextField_1('id', 'ID');
  $setAttribute_8(idField, 'primaryKey', TRUE);
  parentIdField = new DataSourceTextField_1('parentId', 'Parent ID');
  parentIdField.jsObj['foreignKey'] = 'id';
  resourceNameField = new DataSourceTextField_1('name', 'Name');
  resourceKeyField = new DataSourceTextField_1('plugin', 'Plugin');
  resourceTypeField = new DataSourceTextField_1('category', 'Category');
  $setFields(this, initValues(_3Lcom_smartgwt_client_data_DataSourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$DataSourceField, [idField, parentIdField, resourceNameField, resourceKeyField, resourceTypeField]));
}

function buildNodes_0(result){
  var nodes, parent_0, parent$iterator, pluginNode, pluginNodes, treeNodes, type, type$iterator;
  pluginNodes = new HashMap_0;
  nodes = new ArrayList_0;
  $add_3(nodes, new TreeNode_2(''));
  for (type$iterator = new AbstractList$IteratorImpl_0(result); type$iterator.i < type$iterator.this$0_0.size_1();) {
    type = dynamicCast($next_0(type$iterator), Q$ResourceType);
    if (!type.parentResourceTypes || type.parentResourceTypes.isEmpty_0()) {
      pluginNode = dynamicCast(pluginNodes.get_2(type.plugin), Q$ResourceTypePluginTreeDataSource$PluginTreeNode);
      if (!pluginNode) {
        pluginNode = new ResourceTypePluginTreeDataSource$PluginTreeNode_0(type.plugin);
        pluginNodes.put(type.plugin, pluginNode);
        setCheck(nodes.array, nodes.size_0++, pluginNode);
      }
      $add_3(nodes, new ResourceTypePluginTreeDataSource$ResourceTypeTreeNode_0(type, type.plugin));
    }
     else {
      for (parent$iterator = type.parentResourceTypes.iterator(); parent$iterator.hasNext();) {
        parent_0 = dynamicCast(parent$iterator.next_0(), Q$ResourceType);
        $add_3(nodes, new ResourceTypePluginTreeDataSource$ResourceTypeTreeNode_0(type, '' + parent_0.id));
      }
    }
  }
  sort_1(nodes, new ResourceTypePluginTreeDataSource$2_0);
  treeNodes = dynamicCast($toArray_1(nodes, initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, nodes.size_0, 0)), Q$TreeNode_$1);
  return treeNodes;
}

defineSeed(3565, 337, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ResourceTypePluginTreeDataSource_0);
_.transformRequest_0 = function transformRequest_4(request){
  var response;
  response = new DSResponse_0;
  $setAttribute_12(response, 'clientContext', getAttributeAsObject(request.jsObj, 'clientContext'));
  response.jsObj['status'] = 0;
  dynamicCast(getEnum(($clinit_DSOperationType() , $clinit_DSOperationType() , $VALUES_9), getAttribute(request.jsObj, 'operationType')), Q$DSOperationType).ordinal == 0 && $executeFetch_50(this, request, response);
  return getAttributeAsJavaScriptObject(request.jsObj, 'data');
}
;
_.showIgnoredResourceTypes = false;
function $onSuccess_413(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', buildNodes_0(result));
  $processResponse(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function ResourceTypePluginTreeDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3566, 1, {}, ResourceTypePluginTreeDataSource$1_0);
_.onFailure = function onFailure_429(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to load resource type tree data'), caught);
}
;
_.onSuccess_0 = function onSuccess_429(result){
  $onSuccess_413(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $compare_18(o1, o2){
  return compareTo_11(getAttribute(o1.jsObj, 'name'), getAttribute(o2.jsObj, 'name'));
}

function ResourceTypePluginTreeDataSource$2_0(){
}

defineSeed(3567, 1, makeCastMap([Q$Comparator]), ResourceTypePluginTreeDataSource$2_0);
_.compare = function compare_19(o1, o2){
  return $compare_18(dynamicCast(o1, Q$TreeNode), dynamicCast(o2, Q$TreeNode));
}
;
function $clinit_ResourceTypePluginTreeDataSource$PluginTreeNode(){
  $clinit_ResourceTypePluginTreeDataSource$PluginTreeNode = nullMethod;
  pluginStr = ($clinit_CoreGUI() , 'Plugin');
}

function ResourceTypePluginTreeDataSource$PluginTreeNode_0(pluginName){
  $clinit_ResourceTypePluginTreeDataSource$PluginTreeNode();
  TreeNode_0.call(this);
  this.jsObj['id'] = pluginName;
  this.id = pluginName;
  this.jsObj['parentId'] = null;
  $setAttribute_13(this, 'name', pluginName + ' ' + pluginStr);
  this.jsObj['icon'] = 'types/plugin_16.png';
  $setAttribute_8(this, 'enabled', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
}

defineSeed(3568, 577, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$ResourceTypePluginTreeDataSource$PluginTreeNode]), ResourceTypePluginTreeDataSource$PluginTreeNode_0);
_.equals$ = function equals_126(o){
  var that;
  if (this === o)
    return true;
  if (o == null || Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypePluginTreeDataSource$PluginTreeNode_2_classLit != getClass__devirtual$(o))
    return false;
  that = dynamicCast(o, Q$ResourceTypePluginTreeDataSource$PluginTreeNode);
  if (!$equals_6(this.id, that.id))
    return false;
  return true;
}
;
_.hashCode$ = function hashCode_126(){
  return getHashCode_0(this.id);
}
;
_.id = null;
var pluginStr;
function ResourceTypePluginTreeDataSource$ResourceTypeTreeNode_0(resourceType, parentId){
  var id;
  TreeNode_0.call(this);
  id = '' + resourceType.id;
  this.jsObj['id'] = id;
  this.id = id;
  this.jsObj['parentId'] = parentId;
  this.parentId = parentId;
  this.jsObj['id'] = id;
  this.jsObj['parentId'] = parentId;
  $setAttribute_13(this, 'name', resourceType.name_0);
  $setAttribute_13(this, 'plugin', resourceType.plugin);
  $setAttribute_13(this, 'category', resourceType.category.displayName);
  $setAttribute_13(this, 'icon', 'types/' + resourceType.category.displayName + '_up_16.png');
  this.jsObj['isFolder'] = true;
}

defineSeed(3569, 577, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$ResourceTypePluginTreeDataSource$ResourceTypeTreeNode]), ResourceTypePluginTreeDataSource$ResourceTypeTreeNode_0);
_.equals$ = function equals_127(o){
  var that;
  if (this === o)
    return true;
  if (o == null || Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypePluginTreeDataSource$ResourceTypeTreeNode_2_classLit != getClass__devirtual$(o))
    return false;
  that = dynamicCast(o, Q$ResourceTypePluginTreeDataSource$ResourceTypeTreeNode);
  if (!$equals_6(this.id, that.id))
    return false;
  if (this.parentId != null?!$equals_6(this.parentId, that.parentId):that.parentId != null)
    return false;
  return true;
}
;
_.hashCode$ = function hashCode_127(){
  var result;
  result = getHashCode_0(this.id);
  result = 31 * result + (this.parentId != null?getHashCode_0(this.parentId):0);
  return result;
}
;
_.id = null;
_.parentId = null;
function $getResourceTypes(this$static, resourceTypeId, metadataTypes, callback){
  $getResourceTypes_0(this$static, initValues(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, [resourceTypeId]), metadataTypes, new ResourceTypeRepository$3_0(callback, resourceTypeId));
}

function $loadResourceTypes(this$static, resources, metadataTypes, callback){
  var res, res$iterator, types;
  if (resources.size_1() == 0) {
    !!callback && callback.onResourceTypeLoaded(resources);
    return;
  }
  types = new HashSet_0;
  for (res$iterator = resources.iterator(); res$iterator.hasNext();) {
    res = dynamicCast(res$iterator.next_0(), Q$Resource);
    $add_6(types, valueOf_44(res.resourceType.id));
  }
  $getResourceTypes_0(this$static, dynamicCast(types.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, types.map.size_1(), 0)), Q$Integer_$1), metadataTypes, new ResourceTypeRepository$1_0(resources, callback));
}

function $loadResourceTypes_0(this$static, groups, metadataTypes){
  var group, group$iterator, type, types;
  if (groups.size_0 == 0) {
    return;
  }
  types = new HashSet_0;
  for (group$iterator = new AbstractList$IteratorImpl_0(groups); group$iterator.i < group$iterator.this$0_0.size_1();) {
    group = dynamicCast($next_0(group$iterator), Q$ResourceGroup);
    type = group.resourceType;
    !!type && $add_6(types, valueOf_44(type.id));
  }
  $getResourceTypes_0(this$static, dynamicCast(types.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, types.map.size_1(), 0)), Q$Integer_$1), metadataTypes, new ResourceTypeRepository$2_0(groups));
}

function ResourceTypeRepository$1_0(val$resources, val$callback){
  this.val$resources = val$resources;
  this.val$callback = val$callback;
}

defineSeed(3571, 1, {}, ResourceTypeRepository$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_46(types){
  var res, res$iterator;
  for (res$iterator = this.val$resources.iterator(); res$iterator.hasNext();) {
    res = dynamicCast(res$iterator.next_0(), Q$Resource);
    $setResourceType_0(res, dynamicCast(types.get_2(valueOf_44(res.resourceType.id)), Q$ResourceType));
  }
  !!this.val$callback && this.val$callback.onResourceTypeLoaded(this.val$resources);
}
;
_.val$callback = null;
_.val$resources = null;
function ResourceTypeRepository$2_0(val$groups){
  this.val$groups = val$groups;
}

defineSeed(3572, 1, {}, ResourceTypeRepository$2_0);
_.onTypesLoaded_0 = function onTypesLoaded_47(types){
  var group, group$iterator, type;
  for (group$iterator = new AbstractList$IteratorImpl_0(this.val$groups); group$iterator.i < group$iterator.this$0_0.size_1();) {
    group = dynamicCast($next_0(group$iterator), Q$ResourceGroup);
    type = group.resourceType;
    !!type && $setResourceType_1(group, dynamicCast(types.get_2(valueOf_44(type.id)), Q$ResourceType));
  }
}
;
_.val$groups = null;
function ResourceTypeRepository$3_0(val$callback, val$resourceTypeId){
  this.val$callback = val$callback;
  this.val$resourceTypeId = val$resourceTypeId;
}

defineSeed(3573, 1, {}, ResourceTypeRepository$3_0);
_.onTypesLoaded_0 = function onTypesLoaded_48(types){
  !!this.val$callback && this.val$callback.onTypesLoaded(dynamicCast(types.get_2(this.val$resourceTypeId), Q$ResourceType));
}
;
_.val$callback = null;
_.val$resourceTypeId = null;
function buildNodes_1(result){
  var noParentNonPlatformNodes, nodes, parent_0, parent$iterator, platform, platform$iterator, platformChild, platformChild$iterator, platforms, treeNodes, type, type$iterator;
  nodes = new HashSet_0;
  platforms = new HashSet_0;
  noParentNonPlatformNodes = new HashSet_0;
  for (type$iterator = new AbstractList$IteratorImpl_0(result); type$iterator.i < type$iterator.this$0_0.size_1();) {
    type = dynamicCast($next_0(type$iterator), Q$ResourceType);
    if (type.category != ($clinit_ResourceCategory() , PLATFORM) && (!type.parentResourceTypes || type.parentResourceTypes.isEmpty_0())) {
      $add_6(noParentNonPlatformNodes, type);
    }
     else if (!type.parentResourceTypes || type.parentResourceTypes.isEmpty_0()) {
      $add_6(platforms, type);
      $add_6(nodes, new ResourceTypeTreeDataSource$ResourceTypeTreeNode_0(type, type.plugin));
    }
     else {
      for (parent$iterator = type.parentResourceTypes.iterator(); parent$iterator.hasNext();) {
        parent_0 = dynamicCast(parent$iterator.next_0(), Q$ResourceType);
        $add_6(nodes, new ResourceTypeTreeDataSource$ResourceTypeTreeNode_0(type, '' + parent_0.id));
      }
    }
  }
  for (platform$iterator = $iterator($keySet(platforms.map)); platform$iterator.val$outerIter.hasNext();) {
    platform = dynamicCast($next_1(platform$iterator), Q$ResourceType);
    for (platformChild$iterator = $iterator($keySet(noParentNonPlatformNodes.map)); platformChild$iterator.val$outerIter.hasNext();) {
      platformChild = dynamicCast($next_1(platformChild$iterator), Q$ResourceType);
      $add_6(nodes, new ResourceTypeTreeDataSource$ResourceTypeTreeNode_0(platformChild, '' + platform.id));
    }
  }
  treeNodes = dynamicCast($toArray(nodes, initDim(_3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$TreeNode_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeNode, nodes.map.size_1(), 0)), Q$TreeNode_$1);
  return treeNodes;
}

function ResourceTypeTreeDataSource$ResourceTypeTreeNode_0(resourceType, parentId){
  var id;
  TreeNode_0.call(this);
  this.resourceType = resourceType;
  id = '' + resourceType.id;
  this.jsObj['id'] = id;
  this.id = id;
  this.jsObj['parentId'] = parentId;
  this.parentId = parentId;
  this.jsObj['id'] = id;
  this.jsObj['parentId'] = parentId;
  $setAttribute_13(this, 'name', resourceType.name_0);
  $setAttribute_13(this, 'plugin', resourceType.plugin);
  $setAttribute_13(this, 'category', resourceType.category.displayName);
  this.jsObj['isFolder'] = true;
}

defineSeed(3580, 577, makeCastMap([Q$DataClass, Q$JsObject, Q$RefDataClass, Q$Record, Q$ListGridRecord, Q$TreeNode, Q$ResourceTypeTreeDataSource$ResourceTypeTreeNode]), ResourceTypeTreeDataSource$ResourceTypeTreeNode_0);
_.equals$ = function equals_128(o){
  var that;
  if (this === o)
    return true;
  if (o == null || Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeTreeDataSource$ResourceTypeTreeNode_2_classLit != getClass__devirtual$(o))
    return false;
  that = dynamicCast(o, Q$ResourceTypeTreeDataSource$ResourceTypeTreeNode);
  if (!$equals_6(this.id, that.id))
    return false;
  if (this.parentId != null?!$equals_6(this.parentId, that.parentId):that.parentId != null)
    return false;
  return true;
}
;
_.hashCode$ = function hashCode_128(){
  var result;
  result = getHashCode_0(this.id);
  result = 31 * result + (this.parentId != null?getHashCode_0(this.parentId):0);
  return result;
}
;
_.id = null;
_.parentId = null;
_.resourceType = null;
function ResourceTypeTreeView_2(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
  this.resourceTypeService = dynamicCast(secure((!instance_28 && (instance_28 = new ResourceTypeGWTService_Proxy_0) , instance_28), -1), Q$ResourceTypeGWTServiceAsync);
  this.showIgnoredResourceTypes = true;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(3581, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), ResourceTypeTreeView_2);
_.onDraw_0 = function onDraw_57(){
  var category, criteria, name_0, plugin, treeGrid;
  treeGrid = new ResourceTypeTreeView$CustomResourceTypeTreeGrid_2;
  $isCreated_1(treeGrid)?$setProperty_3(treeGrid, 'height', '100%'):(treeGrid.config_0['height'] = '100%' , undefined);
  $setPrompt(treeGrid, ($clinit_Enhanced() , 'Resource Types'));
  $setAnimateFolders(treeGrid, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setResizeFieldsInRealTime(treeGrid, TRUE);
  name_0 = new TreeGridField_0('name');
  plugin = new TreeGridField_0('plugin');
  category = new TreeGridField_0('category');
  $isCreated_1(treeGrid)?$setProperty_2(treeGrid, 'fields', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_tree_TreeGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeGridField, [name_0, plugin, category]))):(treeGrid.config_0['fields'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_tree_TreeGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$TreeGridField, [name_0, plugin, category])) , undefined);
  $addMember(this, treeGrid);
  criteria = new ResourceTypeCriteria_0;
  $addFilterIgnored(criteria, this.showIgnoredResourceTypes?null:FALSE);
  criteria.fetchParentResourceTypes = true;
  $setPageControl(criteria, new PageControl_1(0, -1));
  $findResourceTypesByCriteria(this.resourceTypeService, criteria, new ResourceTypeTreeView$1_2(treeGrid));
}
;
_.showIgnoredResourceTypes = false;
function $onSuccess_416(this$static, result){
  $linkNodes(getOrCreateRef_13($getAttributeAsJavaScriptObject_1(this$static.val$treeGrid, 'data')), buildNodes_1(result));
}

function ResourceTypeTreeView$1_2(val$treeGrid){
  this.val$treeGrid = val$treeGrid;
}

defineSeed(3582, 1, {}, ResourceTypeTreeView$1_2);
_.onFailure = function onFailure_432(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load resource types'), caught);
}
;
_.onSuccess_0 = function onSuccess_432(result){
  $onSuccess_416(this, dynamicCast(result, Q$PageList));
}
;
_.val$treeGrid = null;
function ResourceTypeTreeView$CustomResourceTypeTreeGrid_2(){
  TreeGrid_0.call(this);
}

defineSeed(3583, 575, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$ListGrid, Q$HasCellSavedHandlers, Q$HasEditorEnterHandlers, Q$HasEditorExitHandlers, Q$HasRecordClickHandlers, Q$TreeGrid]), ResourceTypeTreeView$CustomResourceTypeTreeGrid_2);
_.getIcon_0 = function getIcon_3(record, defaultState){
  var resourceType;
  if (instanceOf(record, Q$TreeNode)) {
    if (instanceOf(record, Q$ResourceTypeTreeDataSource$ResourceTypeTreeNode)) {
      resourceType = dynamicCast(record, Q$ResourceTypeTreeDataSource$ResourceTypeTreeNode).resourceType;
      return getResourceIcon_0(resourceType.category, ($clinit_AvailabilityType() , UP), '16');
    }
  }
  return null;
}
;
function OperationHistoryDataSource$1_0(){
}

defineSeed(3588, 1, {}, OperationHistoryDataSource$1_0);
_.format_1 = function format_79(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function OperationHistoryDataSource$2_0(){
}

defineSeed(3589, 1, {}, OperationHistoryDataSource$2_0);
_.hoverHTML_0 = function hoverHTML_53(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function OperationHistoryDataSource$3_0(this$0){
  $clinit_TimestampCellFormatter();
  this.this$0 = this$0;
  TimestampCellFormatter_0.call(this);
}

defineSeed(3590, 2388, {}, OperationHistoryDataSource$3_0);
_.format_1 = function format_80(value, record, rowNum, colNum){
  var opHistoryId, timestamp, url;
  if (value != null) {
    timestamp = format_30(value, this.dateTimeFormat);
    opHistoryId = getAttributeAsInt(record.jsObj, 'id');
    url = getEntityTabLink(this.this$0.entityContext, 'Operations', 'History') + '/' + opHistoryId;
    return getHref(url, timestamp);
  }
   else {
    return '<i>' + ($clinit_RPCDataSource() , 'not yet started') + '<\/i>';
  }
}
;
_.this$0 = null;
function OperationHistoryDataSource$4_0(){
}

defineSeed(3591, 1, {}, OperationHistoryDataSource$4_0);
_.hoverHTML_0 = function hoverHTML_54(value, record, rowNum, colNum){
  var status_0, statusStr;
  statusStr = getAttribute(record.jsObj, 'status');
  status_0 = ($clinit_OperationRequestStatus() , dynamicCast(valueOf(($clinit_OperationRequestStatus$Map() , $MAP_96), statusStr), Q$OperationRequestStatus));
  switch (status_0.ordinal) {
    case 1:
      {
        return $clinit_RPCDataSource() , 'Success';
      }

    case 2:
      {
        return $clinit_RPCDataSource() , 'Failed';
      }

    case 0:
      {
        return $clinit_RPCDataSource() , 'In Progress';
      }

    case 3:
      {
        return $clinit_RPCDataSource() , 'Canceled';
      }

  }
  return $clinit_RPCDataSource() , 'Unknown';
}
;
function OperationHistoryDataSource$5_0(){
}

defineSeed(3592, 1, {}, OperationHistoryDataSource$5_0);
_.format_1 = function format_81(o, listGridRecord, i, i1){
  var icon, status_0;
  status_0 = valueOf_105(dynamicCast(o, Q$String));
  icon = getOperationResultsIcon(status_0);
  return imgHTML_0(icon, 16, 16);
}
;
function OperationHistoryDataSource$6_0(){
}

defineSeed(3593, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), OperationHistoryDataSource$6_0);
_.onRecordClick = function onRecordClick_17(event_0){
  var errorMsg, htmlPane, record, status_0, statusStr, winModal;
  record = $getRecord_0(event_0);
  statusStr = getAttribute(record.jsObj, 'status');
  status_0 = ($clinit_OperationRequestStatus() , dynamicCast(valueOf(($clinit_OperationRequestStatus$Map() , $MAP_96), statusStr), Q$OperationRequestStatus));
  if (status_0 == FAILURE_6) {
    winModal = new Window_1;
    $setTitle(winModal, ($clinit_RPCDataSource() , 'Details'));
    $setAttribute_24(winModal, 'overflow', ($clinit_Overflow() , VISIBLE).value_0, false);
    $setShowMinimizeButton(winModal, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
    $setShowMaximizeButton(winModal, TRUE);
    $setIsModal(winModal, TRUE);
    $setShowModalMask(winModal, TRUE);
    $setAutoSize(winModal, TRUE);
    $setAutoCenter(winModal, TRUE);
    $setShowResizer(winModal, TRUE);
    $setCanDragResize_0(winModal, TRUE);
    $centerInPage(winModal);
    $addCloseClickHandler(winModal, new OperationHistoryDataSource$6$1_0(winModal));
    htmlPane = new HTMLPane_0;
    $setMargin(htmlPane, valueOf_44(10));
    $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultWidth', 500):(htmlPane.config_0['defaultWidth'] = 500 , undefined);
    $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultHeight', 400):(htmlPane.config_0['defaultHeight'] = 400 , undefined);
    errorMsg = getAttribute(record.jsObj, 'errorMessage');
    errorMsg == null && (errorMsg = 'Failed');
    $isCreated_1(htmlPane)?$setProperty_3(htmlPane, 'contents', '<pre>' + errorMsg + '<\/pre>'):(htmlPane.config_0['contents'] = '<pre>' + errorMsg + '<\/pre>' , undefined);
    $addItem(winModal, htmlPane);
    winModal.show_0();
  }
}
;
function OperationHistoryDataSource$6$1_0(val$winModal){
  this.val$winModal = val$winModal;
}

defineSeed(3594, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), OperationHistoryDataSource$6$1_0);
_.onCloseClick_0 = function onCloseClick_19(event_0){
  $markForDestroy(this.val$winModal);
}
;
_.val$winModal = null;
function $onSuccess_417(this$static, result){
  var fetchTime;
  fetchTime = sub(fromDouble(currentTimeMillis0()), this$static.val$start);
  info_0(result.size_0 + ' operation histories fetched in: ' + toString_8(fetchTime) + 'ms');
  $dataRetrieved_0(this$static.this$0, result, this$static.val$response, this$static.val$request);
}

function OperationHistoryDataSource$7_0(this$0, val$response, val$request, val$start){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
  this.val$start = val$start;
}

defineSeed(3595, 1, {}, OperationHistoryDataSource$7_0);
_.onFailure = function onFailure_433(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failure loading operation history.'), caught);
  this.val$response.jsObj['status'] = -1;
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.onSuccess_0 = function onSuccess_433(result){
  $onSuccess_417(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$start = P0_longLit;
function OperationHistoryDataSource$8_0(this$0, val$result, val$response, val$request){
  this.this$0 = this$0;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3596, 1, {}, OperationHistoryDataSource$8_0);
_.onTypesLoaded_0 = function onTypesLoaded_49(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44(this.this$0.getTotalRows_0(this.val$result, this.val$response, this.val$request)));
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $onSuccess_418(this$static){
  $sendSuccessResponse_0(this$static.this$0, this$static.val$request, this$static.val$response, this$static.val$operationHistoryToRemove, null);
}

function OperationHistoryDataSource$9_0(this$0, val$request, val$response, val$operationHistoryToRemove){
  this.this$0 = this$0;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$operationHistoryToRemove = val$operationHistoryToRemove;
}

defineSeed(3597, 1, {}, OperationHistoryDataSource$9_0);
_.onFailure = function onFailure_434(caught){
  throw new RuntimeException_2('Failed to delete ' + this.val$operationHistoryToRemove + '.', caught);
}
;
_.onSuccess_0 = function onSuccess_434(result){
  $onSuccess_418(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$operationHistoryToRemove = null;
_.val$request = null;
_.val$response = null;
function OperationHistoryView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3598, 1, {}, OperationHistoryView$1_0);
_.executeAction = function executeAction_87(selection, actionValue){
  var historyId, numCancelRequestsSubmitted, opService, toBeCanceled, toBeCanceled$index, toBeCanceled$max;
  numCancelRequestsSubmitted = 0;
  opService = dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync);
  for (toBeCanceled$index = 0 , toBeCanceled$max = selection.length; toBeCanceled$index < toBeCanceled$max; ++toBeCanceled$index) {
    toBeCanceled = selection[toBeCanceled$index];
    if ($equals_6(($clinit_OperationRequestStatus() , INPROGRESS_1).name_0, getAttribute(toBeCanceled.jsObj, 'status'))) {
      ++numCancelRequestsSubmitted;
      historyId = getAttributeAsInt(toBeCanceled.jsObj, 'id').value_0;
      $cancelOperationHistory(opService, historyId, new OperationHistoryView$1$1_0(historyId));
    }
  }
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_7('Requests to cancel [' + ($clinit_Enhanced() , '' + numCancelRequestsSubmitted) + '] "in progress" operations have been submitted.', ($clinit_Message$Severity() , Info)));
  this.this$0.refreshTableInfo();
}
;
_.isEnabled_0 = function isEnabled_40(selection){
  var count, item, item$index, item$max;
  count = selection.length;
  for (item$index = 0 , item$max = selection.length; item$index < item$max; ++item$index) {
    item = selection[item$index];
    $equals_6(($clinit_OperationRequestStatus() , INPROGRESS_1).name_0, getAttribute(item.jsObj, 'status')) || --count;
  }
  return count >= 1 && this.this$0.hasControlPermission_1();
}
;
_.this$0 = null;
function $onSuccess_419(this$static){
  var msg;
  msg = new Message_8('The cancel request has been successfully submitted for the operation with the history ID of [' + ($clinit_Enhanced() , '' + this$static.val$historyId) + '].', ($clinit_Message$Severity() , Info), of(($clinit_Message$Option() , BackgroundJobResult)));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
}

function OperationHistoryView$1$1_0(val$historyId){
  this.val$historyId = val$historyId;
}

defineSeed(3599, 1, {}, OperationHistoryView$1$1_0);
_.onFailure = function onFailure_435(caught){
  var msg;
  msg = new Message_5('The cancel request failed for the operation with the history ID of [' + ($clinit_Enhanced() , '' + this.val$historyId) + '].', caught, ($clinit_Message$Severity() , Error_2), of(($clinit_Message$Option() , BackgroundJobResult)));
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
}
;
_.onSuccess_0 = function onSuccess_435(result){
  $onSuccess_419(this, throwClassCastExceptionUnlessNull(result));
}
;
_.val$historyId = 0;
function OperationHistoryView$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3600, 1, {}, OperationHistoryView$2_0);
_.executeAction = function executeAction_88(selection, actionValue){
  $deleteSelectedRecords_1(this.this$0, null);
}
;
_.isEnabled_0 = function isEnabled_41(selection){
  var count;
  count = selection.length;
  return count >= 1 && this.this$0.hasControlPermission_1();
}
;
_.this$0 = null;
function OperationHistoryView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3601, 1, {}, OperationHistoryView$3_0);
_.executeAction = function executeAction_89(selection, actionValue){
  var requestProperties;
  requestProperties = new DSRequest_0;
  requestProperties.jsObj['force'] = true;
  $deleteSelectedRecords_1(this.this$0, requestProperties);
}
;
_.isEnabled_0 = function isEnabled_42(selection){
  var count;
  count = selection.length;
  return count >= 1 && this.this$0.hasControlPermission_1();
}
;
_.this$0 = null;
function $onSuccess_420(this$static){
  $add_3(this$static.val$successIds, valueOf_44(this$static.val$operationHistoryToRemove.id));
  $handleCompletion_0(this$static.this$0, this$static.val$successIds, this$static.val$failureIds, this$static.val$numberOfRecordsToBeDeleted);
}

function OperationHistoryView$4_0(this$0, val$successIds, val$operationHistoryToRemove, val$failureIds, val$numberOfRecordsToBeDeleted){
  this.this$0 = this$0;
  this.val$successIds = val$successIds;
  this.val$operationHistoryToRemove = val$operationHistoryToRemove;
  this.val$failureIds = val$failureIds;
  this.val$numberOfRecordsToBeDeleted = val$numberOfRecordsToBeDeleted;
}

defineSeed(3602, 1, {}, OperationHistoryView$4_0);
_.onFailure = function onFailure_436(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to delete operation history [' + ($clinit_Enhanced() , $toString_15(this.val$operationHistoryToRemove)) + '].'), caught);
  $add_3(this.val$failureIds, valueOf_44(this.val$operationHistoryToRemove.id));
  $handleCompletion_0(this.this$0, this.val$successIds, this.val$failureIds, this.val$numberOfRecordsToBeDeleted);
}
;
_.onSuccess_0 = function onSuccess_436(result){
  $onSuccess_420(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$0 = null;
_.val$failureIds = null;
_.val$numberOfRecordsToBeDeleted = 0;
_.val$operationHistoryToRemove = null;
_.val$successIds = null;
function $copyValues_62(){
  throw new UnsupportedOperationException_1('ResourceOperationScheduleComposite data is read only');
}

function $copyValues_63(from){
  var record, resource;
  record = new ListGridRecord_0;
  if (instanceOf(from, Q$ResourceOperationScheduleComposite)) {
    resource = dynamicCast(from, Q$ResourceOperationScheduleComposite);
    $setAttribute_13(record, ($clinit_ScheduledOperationsDataSource$Field() , RESOURCE_OR_GROUP).propertyName, resource.resourceName);
    $setAttribute_3(record, 'resourceId', resource.resourceId);
    $setAttribute_13(record, 'resourceName', resource.resourceName);
    $setAttribute_13(record, 'resourceAncestry', resource.ancestry);
    $setAttribute_3(record, 'resourceTypeId', resource.resourceTypeId);
  }
   else {
    resource = dynamicCast(from, Q$GroupOperationScheduleComposite);
    $setAttribute_13(record, ($clinit_ScheduledOperationsDataSource$Field() , RESOURCE_OR_GROUP).propertyName, resource.groupName);
    $setAttribute_3(record, GROUP_ID.propertyName, resource.groupId);
    $setAttribute_13(record, GROUP_TYPE.propertyName, resource.groupResourceTypeName);
  }
  $setAttribute_3(record, 'id', from.id);
  $setAttribute_13(record, ($clinit_ScheduledOperationsDataSource$Field() , OPERATION_0).propertyName, from.operationName);
  $setAttribute_14(record, TIME_4.propertyName, new Date_2(from.operationNextFireTime));
  !from?(record.jsObj['entity'] = null , undefined):(record.jsObj['entity'] = from , undefined);
  return record;
}

function $dataRetrieved_8(this$static, result, response, request){
  var ancestries, composite, composite$iterator, resourceComposite, typeRepo, typesSet;
  typesSet = new HashSet_0;
  ancestries = new HashSet_0;
  for (composite$iterator = new AbstractList$IteratorImpl_0(result); composite$iterator.i < composite$iterator.this$0_0.size_1();) {
    composite = dynamicCast($next_0(composite$iterator), Q$OperationScheduleComposite);
    if (instanceOf(composite, Q$ResourceOperationScheduleComposite)) {
      resourceComposite = dynamicCast(composite, Q$ResourceOperationScheduleComposite);
      $add_6(typesSet, valueOf_44(resourceComposite.resourceTypeId));
      $add_6(ancestries, resourceComposite.ancestry);
    }
  }
  $addAll(typesSet, getAncestryTypeIds(ancestries));
  typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new ScheduledOperationsDataSource$2_0(this$static, result, response, request));
}

function $executeFetch_51(this$static, request, response){
  var operationsPortlet, pageSize;
  pageSize = -1;
  if (!!this$static.portlet && !!this$static.portlet) {
    operationsPortlet = this$static.portlet;
    if (operationsPortlet) {
      if (this$static.operationsRangeNextEnabled) {
        pageSize = this$static.operationsRangeScheduled;
        operationsPortlet.scheduledOperationsGrid.setEmptyMessage(($clinit_OperationSchedulePortlet() , RANGE_DISABLED_MESSAGE_DEFAULT));
      }
       else {
        operationsPortlet.scheduledOperationsGrid.setEmptyMessage(($clinit_OperationSchedulePortlet() , RANGE_DISABLED_MESSAGE));
        response.jsObj['data'] = convertToJavaScriptArray(null);
        $setTotalRows(response, valueOf_44(0));
        $processResponse_0(this$static, getAttribute(request.jsObj, 'requestId'), response);
        return;
      }
    }
  }
  $findCurrentlyScheduledResourceOperations(dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync), pageSize, new ScheduledOperationsDataSource$1_0(this$static, pageSize, response, request));
}

function $setOperationsRangeScheduleEnabled(this$static, operationsRangeNextEnabled){
  this$static.operationsRangeNextEnabled = operationsRangeNextEnabled;
}

function $setOperationsRangeScheduled(this$static, operationsRangeScheduled){
  this$static.operationsRangeScheduled = operationsRangeScheduled;
}

function ScheduledOperationsDataSource_0(portlet){
  var fields_0, resourceField, operationField, timeField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.portlet = portlet;
  fields = (fields_0 = new ArrayList_0 , resourceField = new DataSourceTextField_1(($clinit_ScheduledOperationsDataSource$Field() , RESOURCE_OR_GROUP).propertyName, RESOURCE_OR_GROUP.title_0) , setCheck(fields_0.array, fields_0.size_0++, resourceField) , operationField = new DataSourceTextField_1(OPERATION_0.propertyName, OPERATION_0.title_0) , setCheck(fields_0.array, fields_0.size_0++, operationField) , timeField = new DataSourceTextField_1(TIME_4.propertyName, TIME_4.title_0) , setCheck(fields_0.array, fields_0.size_0++, timeField) , fields_0);
  $addFields(this, fields);
}

defineSeed(3603, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), ScheduledOperationsDataSource_0);
_.copyValues = function copyValues_119(from){
  return $copyValues_62();
}
;
_.copyValues_0 = function copyValues_120(from){
  return $copyValues_63(dynamicCast(from, Q$OperationScheduleComposite));
}
;
_.executeFetch = function executeFetch_66(request, response, unused){
  $executeFetch_51(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_76(request){
  return null;
}
;
_.operationsRangeNextEnabled = false;
_.operationsRangeScheduled = -1;
_.portlet = null;
function $onSuccess_421(this$static, resources){
  $findCurrentlyScheduledGroupOperations(dynamicCast(secure(getInstance_45(), -1), Q$OperationGWTServiceAsync), this$static.val$pageSizeConst, new ScheduledOperationsDataSource$1$1_0(this$static, resources, this$static.val$pageSizeConst, this$static.val$response, this$static.val$request));
}

function ScheduledOperationsDataSource$1_0(this$0, val$pageSizeConst, val$response, val$request){
  this.this$0 = this$0;
  this.val$pageSizeConst = val$pageSizeConst;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3604, 1, {}, ScheduledOperationsDataSource$1_0);
_.onFailure = function onFailure_437(throwable){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load scheduled operations.'), throwable);
}
;
_.onSuccess_0 = function onSuccess_437(resources){
  $onSuccess_421(this, dynamicCast(resources, Q$PageList));
}
;
_.this$0 = null;
_.val$pageSizeConst = 0;
_.val$request = null;
_.val$response = null;
function $onSuccess_422(this$static, groups){
  var pageList, pc, result;
  result = new ArrayList_0;
  if (this$static.val$resources) {
    $addAll_0(result, this$static.val$resources);
    $addAll_0(result, groups);
  }
  sort_1(result, new ScheduledOperationsDataSource$1$1$1_0);
  pc = new PageControl_1(0, this$static.val$pageSizeConst);
  pageList = new PageList_1(result, pc);
  $dataRetrieved_8(this$static.this$1.this$0, pageList, this$static.val$response, this$static.val$request);
}

function ScheduledOperationsDataSource$1$1_0(this$1, val$resources, val$pageSizeConst, val$response, val$request){
  this.this$1 = this$1;
  this.val$resources = val$resources;
  this.val$pageSizeConst = val$pageSizeConst;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3605, 1, {}, ScheduledOperationsDataSource$1$1_0);
_.onFailure = function onFailure_438(throwable){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load scheduled operations.'), throwable);
}
;
_.onSuccess_0 = function onSuccess_438(groups){
  $onSuccess_422(this, dynamicCast(groups, Q$PageList));
}
;
_.this$1 = null;
_.val$pageSizeConst = 0;
_.val$request = null;
_.val$resources = null;
_.val$response = null;
function $compare_19(thisOp, thatOp){
  return lt(sub(thisOp.operationNextFireTime, thatOp.operationNextFireTime), P0_longLit)?-1:1;
}

function ScheduledOperationsDataSource$1$1$1_0(){
}

defineSeed(3606, 1, makeCastMap([Q$Comparator]), ScheduledOperationsDataSource$1$1$1_0);
_.compare = function compare_20(thisOp, thatOp){
  return $compare_19(dynamicCast(thisOp, Q$OperationScheduleComposite), dynamicCast(thatOp, Q$OperationScheduleComposite));
}
;
function ScheduledOperationsDataSource$2_0(this$0, val$result, val$response, val$request){
  this.this$0 = this$0;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3607, 1, {}, ScheduledOperationsDataSource$2_0);
_.onTypesLoaded_0 = function onTypesLoaded_50(types){
  var record, record$index, record$max, records, resultSize, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  resultSize = $getTotalSize(this.val$result);
  this.this$0.operationsRangeScheduled > 0 && this.this$0.operationsRangeScheduled < resultSize && (resultSize = this.this$0.operationsRangeScheduled);
  $setTotalRows(this.val$response, valueOf_44(resultSize));
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $clinit_ScheduledOperationsDataSource$Field(){
  $clinit_ScheduledOperationsDataSource$Field = nullMethod;
  OPERATION_0 = new ScheduledOperationsDataSource$Field_0('OPERATION', 0, 'operationName', ($clinit_RPCDataSource() , 'Operation'));
  RESOURCE_OR_GROUP = new ScheduledOperationsDataSource$Field_0('RESOURCE_OR_GROUP', 1, 'resource', 'Resource / Group');
  TIME_4 = new ScheduledOperationsDataSource$Field_0('TIME', 2, 'operationNextFireTime', 'Next Execution');
  GROUP_ID = new ScheduledOperationsDataSource$Field_0('GROUP_ID', 3, 'groupId', 'groupId');
  GROUP_TYPE = new ScheduledOperationsDataSource$Field_0('GROUP_TYPE', 4, 'groupType', 'Resource Name');
  $VALUES_133 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_operation_ScheduledOperationsDataSource$Field_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ScheduledOperationsDataSource$Field, [OPERATION_0, RESOURCE_OR_GROUP, TIME_4, GROUP_ID, GROUP_TYPE]);
}

function ScheduledOperationsDataSource$Field_0(enum$name, enum$ordinal, propertyName, title){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.propertyName = propertyName;
  this.title_0 = title;
}

function valueOf_142(name_0){
  $clinit_ScheduledOperationsDataSource$Field();
  return valueOf(($clinit_ScheduledOperationsDataSource$Field$Map() , $MAP_133), name_0);
}

function values_136(){
  $clinit_ScheduledOperationsDataSource$Field();
  return $VALUES_133;
}

defineSeed(3608, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$ScheduledOperationsDataSource$Field]), ScheduledOperationsDataSource$Field_0);
_.propertyName = null;
_.title_0 = null;
var $VALUES_133, GROUP_ID, GROUP_TYPE, OPERATION_0, RESOURCE_OR_GROUP, TIME_4;
function $clinit_ScheduledOperationsDataSource$Field$Map(){
  $clinit_ScheduledOperationsDataSource$Field$Map = nullMethod;
  $MAP_133 = createValueOfMap(($clinit_ScheduledOperationsDataSource$Field() , $VALUES_133));
}

var $MAP_133;
function $clinit_AlertDefinitionReportView(){
  $clinit_AlertDefinitionReportView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_26 = new ViewName_2('AlertDefinitions', ($clinit_Enhanced() , 'Alert Definitions'), ($clinit_IconEnum() , ALERT_DEFINITIONS));
}

function AlertDefinitionReportView_0(){
  $clinit_AlertDefinitionReportView();
  Table_1.call(this);
  $setDataSource(this, new AlertDefinitionReportView$DataSource_0);
}

defineSeed(3610, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), AlertDefinitionReportView_0);
_.configureTable = function configureTable_61(){
  var fields, listGrid;
  listGrid = this.listGrid;
  fields = $getListGridFields_20(dynamicCast(this.dataSource_1, Q$AlertDefinitionReportView$DataSource));
  $setFields_1(listGrid, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $setListGridDoubleClickHandler(this, new AlertDefinitionReportView$1_0(this));
  $addTableAction(this, 'Export', ($clinit_Enhanced() , 'Export'), null, new AlertDefinitionReportView$2_0(this));
}
;
_.getViewName = function getViewName_12(){
  return VIEW_ID_26;
}
;
var VIEW_ID_26;
function AlertDefinitionReportView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3611, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), AlertDefinitionReportView$1_0);
_.onDoubleClick = function onDoubleClick_16(event_0){
  var alertDef, alertDefId, lg, link, resourceId, selected;
  lg = dynamicCast(event_0.source, Q$ListGrid);
  selected = lg.getSelectedRecord_0();
  if (selected) {
    alertDef = $copyValues_18((dynamicCast(this.this$0.dataSource_1, Q$AlertDefinitionReportView$DataSource) , selected));
    resourceId = alertDef.resource.id;
    alertDefId = alertDef.id;
    link = getSubsystemAlertDefinitionLink(resourceId, alertDefId);
    $clinit_CoreGUI();
    goToView(link, null, false);
  }
}
;
_.this$0 = null;
function AlertDefinitionReportView$2_0(this$0){
  this.this$0 = this$0;
  AbstractTableAction_0.call(this);
}

defineSeed(3612, 1608, {}, AlertDefinitionReportView$2_0);
_.executeAction = function executeAction_90(selection, actionValue){
  var exporter;
  exporter = new ReportExporter_0('alertDefinitions');
  $export(exporter);
  $refreshTableInfo(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_43(selection){
  return $enableIfRecordsExist(this.this$0.listGrid);
}
;
_.this$0 = null;
function $getListGridFields_20(this$static){
  var ancestryField, field, field$iterator, fieldName, fields, parentField, resourceField;
  fields = $getListGridFields_6();
  for (field$iterator = new AbstractList$IteratorImpl_0(fields); field$iterator.i < field$iterator.this$0_0.size_1();) {
    field = dynamicCast($next_0(field$iterator), Q$ListGridField);
    fieldName = getAttribute(field.jsObj, 'name');
    $equals_6(fieldName, 'ctime') || $equals_6(fieldName, 'mtime')?(field.jsObj['showIf'] = 'false' , undefined):$equals_6(fieldName, 'name') && $setCellFormatter_0(field, new AlertDefinitionReportView$DataSource$1_0);
  }
  parentField = new ListGridField_3('parent', 'Parent');
  parentField.jsObj['width'] = 100;
  $setAttribute_8(parentField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(parentField, new AlertDefinitionReportView$DataSource$2_0);
  $addRecordClickHandler_0(parentField, new AlertDefinitionReportView$DataSource$3_0);
  setCheck(fields.array, fields.size_0++, parentField);
  resourceField = new ListGridField_3('resource', 'Resource');
  $setCellFormatter_0(resourceField, new AlertDefinitionReportView$DataSource$4_0);
  $setAttribute_8(resourceField, 'showHover', TRUE);
  $setHoverCustomizer_0(resourceField, new AlertDefinitionReportView$DataSource$5_0);
  setCheck(fields.array, fields.size_0++, resourceField);
  ancestryField = setupAncestryListGridField();
  setCheck(fields.array, fields.size_0++, ancestryField);
  return fields;
}

function AlertDefinitionReportView$DataSource_0(){
  $clinit_RPCDataSource();
  AbstractAlertDefinitionsDataSource_0.call(this);
}

defineSeed(3613, 1895, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$AlertDefinitionReportView$DataSource]), AlertDefinitionReportView$DataSource_0);
_.addDataSourceFields = function addDataSourceFields_6(){
  var field, field$iterator, fieldName, fields, parentField, resourceField;
  fields = $addDataSourceFields_0();
  for (field$iterator = new AbstractList$IteratorImpl_0(fields); field$iterator.i < field$iterator.this$0_0.size_1();) {
    field = dynamicCast($next_0(field$iterator), Q$DataSourceField);
    fieldName = getAttribute(field.jsObj, 'name');
    ($equals_6(fieldName, 'ctime') || $equals_6(fieldName, 'mtime')) && $setAttribute_8(field, 'hidden', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  }
  resourceField = new DataSourceTextField_0('resource');
  setCheck(fields.array, fields.size_0++, resourceField);
  parentField = new DataSourceTextField_0('resource');
  setCheck(fields.array, fields.size_0++, parentField);
  return fields;
}
;
_.copyValues_2 = function copyValues_121(from){
  var groupAlertDefinition, parentId, record, resource;
  record = $copyValues_19(from);
  resource = from.resource;
  $setAttribute_13(record, 'resource', resource.name_0);
  parentId = from.parentId;
  groupAlertDefinition = from.groupAlertDefinition;
  !!parentId && parentId.value_0 > 0?(record.jsObj['parent'] = '<b>View Template<\/b>' , undefined):!!groupAlertDefinition && (record.jsObj['parent'] = '<b>View Group Definition<\/b>' , undefined);
  $setAttribute_3(record, 'resourceId', resource.id);
  $setAttribute_13(record, 'resourceName', resource.name_0);
  $setAttribute_13(record, 'resourceAncestry', resource.ancestry);
  $setAttribute_3(record, 'resourceTypeId', resource.resourceType.id);
  return record;
}
;
_.dataRetrieved = function dataRetrieved_2(result, response, request){
  var alertDefinition, alertDefinition$iterator, ancestries, resource, typeRepo, typesSet;
  typesSet = new HashSet_0;
  ancestries = new HashSet_0;
  for (alertDefinition$iterator = new AbstractList$IteratorImpl_0(result); alertDefinition$iterator.i < alertDefinition$iterator.this$0_0.size_1();) {
    alertDefinition = dynamicCast($next_0(alertDefinition$iterator), Q$AlertDefinition);
    resource = alertDefinition.resource;
    if (resource) {
      $add_6(typesSet, valueOf_44(resource.resourceType.id));
      $add_6(ancestries, resource.ancestry);
    }
  }
  $addAll(typesSet, getAncestryTypeIds(ancestries));
  typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new AlertDefinitionReportView$DataSource$6_0(this, result, response, request));
}
;
_.getFetchCriteria = function getFetchCriteria_77(request){
  var criteria;
  return criteria = new AlertDefinitionCriteria_0 , criteria.filterResourceOnly = ($clinit_Criteria$NonBindingOverrideFilter() , ON) , $setPageControl(criteria, $getPageControl(this, request)) , criteria.fetchResource = true , criteria.fetchGroupAlertDefinition = true , criteria;
}
;
_.getListGridFields_0 = function getListGridFields_10(){
  return $getListGridFields_20(this);
}
;
_.getSimpleCriteriaForAll = function getSimpleCriteriaForAll_2(){
  var criteria;
  criteria = new AlertDefinitionCriteria_0;
  criteria.filterResourceOnly = ($clinit_Criteria$NonBindingOverrideFilter() , ON);
  $setPageControl(criteria, new PageControl_1(0, -1));
  return criteria;
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_11(columnName){
  if ($equals_6('resourceAncestry', columnName)) {
    return 'resource.ancestry';
  }
  if ($equals_6('parent', columnName)) {
    return 'parentId';
  }
  return columnName;
}
;
function AlertDefinitionReportView$DataSource$1_0(){
}

defineSeed(3614, 1, {}, AlertDefinitionReportView$DataSource$1_0);
_.format_1 = function format_82(value, record, rowNum, colNum){
  var alertDef, alertDefId, link, resourceId;
  alertDef = $copyValues_18(record);
  resourceId = alertDef.resource.id;
  alertDefId = alertDef.id;
  link = getSubsystemAlertDefinitionLink(resourceId, alertDefId);
  return '<a href="' + link + '">' + escapeHtml(alertDef.name_0) + '<\/a>';
}
;
function AlertDefinitionReportView$DataSource$2_0(){
}

defineSeed(3615, 1, {}, AlertDefinitionReportView$DataSource$2_0);
_.hoverHTML_0 = function hoverHTML_55(value, record, rowNum, colNum){
  if (getAttribute(record.jsObj, 'parent') != null) {
    return $clinit_RPCDataSource() , 'Click to go to the parent alert definition';
  }
  return $clinit_RPCDataSource() , 'N/A';
}
;
function AlertDefinitionReportView$DataSource$3_0(){
}

defineSeed(3616, 1, makeCastMap([Q$EventHandler, Q$RecordClickHandler]), AlertDefinitionReportView$DataSource$3_0);
_.onRecordClick = function onRecordClick_18(event_0){
  var alertDef, alertDefId, groupAlertDef, record, resCriteria, resourceId, templateId;
  record = $getRecord_0(event_0);
  alertDef = $copyValues_18(record);
  if (!!alertDef.parentId && alertDef.parentId.value_0 > 0) {
    templateId = valueOf_44(alertDef.parentId.value_0);
    resourceId = valueOf_44(alertDef.resource.id);
    resCriteria = new ResourceCriteria_0;
    resCriteria.filterId = resourceId;
    resCriteria.fetchResourceType = true;
    $findResourcesByCriteria(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), resCriteria, new AlertDefinitionReportView$DataSource$3$1_0(templateId));
  }
   else if (!!alertDef.parentId && alertDef.parentId.value_0 == 0) {
    resourceId = alertDef.resource.id;
    alertDefId = alertDef.id;
    $clinit_CoreGUI();
    goToView(getSubsystemAlertDefinitionLink(resourceId, alertDefId), null, false);
  }
   else if (alertDef.groupAlertDefinition) {
    groupAlertDef = alertDef.groupAlertDefinition;
    $clinit_CoreGUI();
    goToView(getEntityTabLink(forGroup_0(groupAlertDef.group), 'Alert', 'Definitions') + '/' + groupAlertDef.id, null, false);
  }
}
;
function $onSuccess_423(this$static, result){
  var typeId;
  if (!result || result.size_0 != 1) {
    $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Cannot get the template resource type - unable to view the alert template.'), null);
  }
   else {
    typeId = dynamicCast((checkIndex(0, result.size_0) , result.array[0]), Q$Resource).resourceType.id;
    $clinit_CoreGUI();
    goToView('#Administration/Configuration/' + ($clinit_AlertDefinitionTemplateTypeView() , VIEW_ID_6).name_0 + '/' + typeId + '/' + this$static.val$templateId, null, false);
  }
}

function AlertDefinitionReportView$DataSource$3$1_0(val$templateId){
  this.val$templateId = val$templateId;
}

defineSeed(3617, 1, {}, AlertDefinitionReportView$DataSource$3$1_0);
_.onFailure = function onFailure_439(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Cannot get the template resource type - unable to view the alert template.'), caught);
}
;
_.onSuccess_0 = function onSuccess_439(result){
  $onSuccess_423(this, dynamicCast(result, Q$PageList));
}
;
_.val$templateId = null;
function AlertDefinitionReportView$DataSource$4_0(){
}

defineSeed(3618, 1, {}, AlertDefinitionReportView$DataSource$4_0);
_.format_1 = function format_83(value, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return '<a href="' + url + '">' + escapeHtml(toString__devirtual$(value)) + '<\/a>';
}
;
function AlertDefinitionReportView$DataSource$5_0(){
}

defineSeed(3619, 1, {}, AlertDefinitionReportView$DataSource$5_0);
_.hoverHTML_0 = function hoverHTML_56(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function AlertDefinitionReportView$DataSource$6_0(this$1, val$result, val$response, val$request){
  this.this$1 = this$1;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3620, 1, {}, AlertDefinitionReportView$DataSource$6_0);
_.onTypesLoaded_0 = function onTypesLoaded_51(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$1, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44($getTotalSize(this.val$result)));
  $processResponse_0(this.this$1, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function DriftComplianceReportResourceSearchView_0(criteria){
  $clinit_ResourceSearchView();
  ResourceSearchView_3.call(this, criteria);
  this.initialCriteriaFixed = true;
  this.resourceTypeId = $getAttributeAsInt(criteria, ($clinit_ResourceDataSourceField() , TYPE_56).propertyName).value_0;
}

defineSeed(3621, 2557, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$DriftComplianceReportResourceSearchView, Q$Enhanced, Q$EnhancedHLayout]), DriftComplianceReportResourceSearchView_0);
_.configureTable = function configureTable_62(){
  $configureTable_3(this);
  $setListGridDoubleClickHandler(this, new DriftComplianceReportResourceSearchView$2_0);
}
;
_.createFields = function createFields_4(){
  var field, field$iterator, fields, inComplianceField, nameField;
  fields = $createFields();
  nameField = null;
  for (field$iterator = new AbstractList$IteratorImpl_0(fields); field$iterator.i < field$iterator.this$0_0.size_1();) {
    field = dynamicCast($next_0(field$iterator), Q$ListGridField);
    if ($equals_6(($clinit_ResourceDataSourceField() , NAME_31).propertyName, getAttribute(field.jsObj, 'name'))) {
      nameField = field;
      break;
    }
  }
  $setCellFormatter_0(nameField, new DriftComplianceReportResourceSearchView$1_0);
  inComplianceField = new IconField_2('inCompliance', ($clinit_Enhanced() , 'In Compliance?'), 95);
  $setAttribute_8(inComplianceField, 'canSortClientOnly', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  setCheck(fields.array, fields.size_0++, inComplianceField);
  return fields;
}
;
_.getDataSourceInstance = function getDataSourceInstance_1(){
  return new DriftComplianceReportResourceSearchView$DataSource_0(this);
}
;
_.resourceTypeId = 0;
function DriftComplianceReportResourceSearchView$1_0(){
}

defineSeed(3622, 1, {}, DriftComplianceReportResourceSearchView$1_0);
_.format_1 = function format_84(value, record, rowNum, colNum){
  var name_0, url;
  url = getResourceTabLink(getAttributeAsInt(record.jsObj, 'id').value_0, 'Drift', null);
  name_0 = escapeHtml(toString__devirtual$(value));
  return getHref(url, name_0);
}
;
function DriftComplianceReportResourceSearchView$2_0(){
}

defineSeed(3623, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), DriftComplianceReportResourceSearchView$2_0);
_.onDoubleClick = function onDoubleClick_17(event_0){
  var listGrid, selectedId, selectedRows;
  listGrid = dynamicCast(event_0.source, Q$ListGrid);
  selectedRows = $getSelectedRecords(listGrid);
  if (selectedRows != null && selectedRows.length == 1) {
    selectedId = getAttribute(selectedRows[0].jsObj, 'id');
    $clinit_CoreGUI();
    goToView(getResourceTabLink(valueOf_44(__parseAndValidateInt(selectedId)).value_0, 'Drift', null), null, false);
  }
}
;
function $isOutOfCompliance(resource){
  var def, def$iterator;
  for (def$iterator = (!resource.driftDefinitions && (resource.driftDefinitions = new LinkedHashSet_0) , resource.driftDefinitions).iterator(); def$iterator.hasNext();) {
    def = dynamicCast(def$iterator.next_0(), Q$DriftDefinition);
    if (def.complianceStatus != ($clinit_DriftComplianceStatus() , IN_COMPLIANCE)) {
      return true;
    }
  }
  return false;
}

function DriftComplianceReportResourceSearchView$DataSource_0(this$0){
  $clinit_RPCDataSource();
  this.this$0 = this$0;
  ResourceDatasource_0.call(this);
}

defineSeed(3624, 3267, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), DriftComplianceReportResourceSearchView$DataSource_0);
_.copyValues_8 = function copyValues_122(from){
  var record;
  record = $copyValues_56(from);
  this.resourceType.driftDefinitionTemplates.isEmpty_0() || $setAttribute_13(record, 'inCompliance', getAvailabilityIcon(($clinit_Boolean() , $isOutOfCompliance(from)?FALSE:TRUE)));
  return record;
}
;
_.executeFetch_6 = function executeFetch_67(request, response, criteria){
  !this.resourceType?$getResourceTypes(($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance), valueOf_44(this.this$0.resourceTypeId), of(($clinit_ResourceTypeRepository$MetadataType() , driftDefinitionTemplates_0)), new DriftComplianceReportResourceSearchView$DataSource$1_0(this, request, response, criteria)):$findResourcesByCriteria(this.resourceService, criteria, new ResourceDatasource$1_0(this, criteria, request, response));
}
;
_.getFetchCriteria_9 = function getFetchCriteria_78(request){
  var criteria, pageControl;
  criteria = $getFetchCriteria_12(this, request);
  criteria.fetchDriftDefinitions = true;
  pageControl = $getPageControl(this, request);
  $removeOrderingField(pageControl, 'inCompliance');
  criteria.pageControlOverrides = pageControl;
  return criteria;
}
;
_.resourceType = null;
_.this$0 = null;
function DriftComplianceReportResourceSearchView$DataSource$1_0(this$1, val$request, val$response, val$criteria){
  this.this$1 = this$1;
  this.val$request = val$request;
  this.val$response = val$response;
  this.val$criteria = val$criteria;
}

defineSeed(3625, 1, {}, DriftComplianceReportResourceSearchView$DataSource$1_0);
_.onTypesLoaded = function onTypesLoaded_52(type){
  this.this$1.resourceType = type;
  $executeFetch_39(this.this$1, this.val$request, this.val$response, this.val$criteria);
}
;
_.this$1 = null;
_.val$criteria = null;
_.val$request = null;
_.val$response = null;
function ReportTopView_0(){
  $clinit_ReportTopView();
  AbstractSectionedLeftNavigationView_0.call(this, VIEW_ID_27.name_0);
}

defineSeed(3626, 1581, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$Enhanced, Q$EnhancedHLayout]), ReportTopView_0);
_.defaultView = function defaultView_2(){
  var vLayout, titleBar, label;
  return vLayout = new EnhancedVLayout_0 , $isCreated_1(vLayout)?$setProperty_3(vLayout, 'width', '100%'):(vLayout.config_0['width'] = '100%' , undefined) , titleBar = new TitleBar_1(($clinit_Enhanced() , 'Reports'), ($clinit_IconEnum() , REPORT).icon24x24Path) , $addMember(vLayout, titleBar) , label = new Label_4('This section provides access to global reports.') , $setPadding(label, valueOf_44(10)) , $addMember(vLayout, label) , vLayout;
}
;
_.getNavigationSections = function getNavigationSections_2(){
  var inventorySection, sections, subsystemsSection, tagItem, suspectMetricsItem, recentConfigurationChangesItem, recentOperationsItem, recentAlertsItem, alertDefinitionsItem, recentDriftsItem, inventorySummaryItem, platformSystemInfoItem, driftComplianceItem;
  sections = new ArrayList_0;
  subsystemsSection = (tagItem = new NavigationItem_2(($clinit_TaggedView() , VIEW_ID_31), new ReportTopView$1_0) , suspectMetricsItem = new NavigationItem_2(($clinit_MeasurementOOBView() , VIEW_ID_30), new ReportTopView$2_0) , recentConfigurationChangesItem = new NavigationItem_2(($clinit_ResourceConfigurationHistoryListView() , VIEW_ID_19), new ReportTopView$3_0(this)) , recentOperationsItem = new NavigationItem_2(($clinit_OperationHistoryView() , SUBSYSTEM_VIEW_ID_0), new ReportTopView$4_0(this)) , recentAlertsItem = new NavigationItem_2(($clinit_AlertHistoryView() , SUBSYSTEM_VIEW_ID), new ReportTopView$5_0(this)) , alertDefinitionsItem = new NavigationItem_2(($clinit_AlertDefinitionReportView() , VIEW_ID_26), new ReportTopView$6_0) , recentDriftsItem = new NavigationItem_2(($clinit_DriftHistoryView() , SUBSYSTEM_VIEW_ID_1), new ReportTopView$7_0(this)) , $clinit_CoreGUI() , enableTagsForUI?new NavigationSection_0(SECTION_SUBSYSTEMS_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [tagItem, suspectMetricsItem, recentConfigurationChangesItem, recentOperationsItem, recentAlertsItem, alertDefinitionsItem, recentDriftsItem])):new NavigationSection_0(SECTION_SUBSYSTEMS_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [suspectMetricsItem, recentConfigurationChangesItem, recentOperationsItem, recentAlertsItem, alertDefinitionsItem, recentDriftsItem])));
  setCheck(sections.array, sections.size_0++, subsystemsSection);
  inventorySection = (inventorySummaryItem = new NavigationItem_3(($clinit_ResourceInstallReport() , VIEW_ID_29), new ReportTopView$8_0, this.globalPermissions_0.contains_0(($clinit_Permission() , MANAGE_INVENTORY))) , platformSystemInfoItem = new NavigationItem_2(($clinit_PlatformSummaryPortlet() , VIEW_ID_18), new ReportTopView$9_0) , driftComplianceItem = new NavigationItem_3(($clinit_DriftComplianceReport() , VIEW_ID_28), new ReportTopView$10_0, this.globalPermissions_0.contains_0(MANAGE_INVENTORY)) , new NavigationSection_0(SECTION_INVENTORY_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [inventorySummaryItem, platformSystemInfoItem, driftComplianceItem])));
  setCheck(sections.array, sections.size_0++, inventorySection);
  return sections;
}
;
function ReportTopView$1_0(){
}

defineSeed(3627, 1, {}, ReportTopView$1_0);
_.createView = function createView_73(){
  return new TaggedView_0;
}
;
function ReportTopView$10_0(){
}

defineSeed(3628, 1, {}, ReportTopView$10_0);
_.createView = function createView_74(){
  return new DriftComplianceReport_0;
}
;
function ReportTopView$2_0(){
}

defineSeed(3629, 1, {}, ReportTopView$2_0);
_.createView = function createView_75(){
  return new MeasurementOOBView_0;
}
;
function ReportTopView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3630, 1, {}, ReportTopView$3_0);
_.createView = function createView_76(){
  return new SubsystemConfigurationHistoryListView_0(this.this$0.globalPermissions_0.contains_0(($clinit_Permission() , MANAGE_INVENTORY)));
}
;
_.this$0 = null;
function ReportTopView$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3631, 1, {}, ReportTopView$4_0);
_.createView = function createView_77(){
  return new SubsystemOperationHistoryListView_0(this.this$0.globalPermissions_0.contains_0(($clinit_Permission() , MANAGE_INVENTORY)));
}
;
_.this$0 = null;
function ReportTopView$5_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3632, 1, {}, ReportTopView$5_0);
_.createView = function createView_78(){
  return new SubsystemRecentAlertsView_0(this.this$0.globalPermissions_0.contains_0(($clinit_Permission() , MANAGE_INVENTORY)));
}
;
_.this$0 = null;
function ReportTopView$6_0(){
}

defineSeed(3633, 1, {}, ReportTopView$6_0);
_.createView = function createView_79(){
  return new AlertDefinitionReportView_0;
}
;
function ReportTopView$7_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3634, 1, {}, ReportTopView$7_0);
_.createView = function createView_80(){
  return new SubsystemResourceDriftView_0(this.this$0.globalPermissions_0.contains_0(($clinit_Permission() , MANAGE_INVENTORY)));
}
;
_.this$0 = null;
function ReportTopView$8_0(){
}

defineSeed(3635, 1, {}, ReportTopView$8_0);
_.createView = function createView_81(){
  return new ResourceInstallReport_0;
}
;
function ReportTopView$9_0(){
}

defineSeed(3636, 1, {}, ReportTopView$9_0);
_.createView = function createView_82(){
  return new PlatformSummaryPortlet_1(true);
}
;
function SubsystemRecentAlertsView_0(hasWriteAccess){
  $clinit_AlertHistoryView();
  AlertHistoryView_1.call(this, ($clinit_Enhanced() , 'Recent Alerts'), new EntityContext_0(null, null, null), hasWriteAccess);
}

defineSeed(3637, 1894, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), SubsystemRecentAlertsView_0);
_.configureTable = function configureTable_63(){
  $configureTable_1(this);
  $addTableAction(this, 'Export', ($clinit_Enhanced() , 'Export'), null, new SubsystemRecentAlertsView$1_0(this));
}
;
function SubsystemRecentAlertsView$1_0(this$0){
  this.this$0 = this$0;
  AbstractTableAction_0.call(this);
}

defineSeed(3638, 1608, {}, SubsystemRecentAlertsView$1_0);
_.executeAction = function executeAction_91(selection, actionValue){
  var exporter;
  exporter = createExporterForRecentAlerts($getValues(this.this$0.priorityFilter), $getValueAsDays(this.this$0.startDateFilter), $getValueAsDays(this.this$0.endDateFilter));
  $export(exporter);
  $refreshTableInfo(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_44(selection){
  return $enableIfRecordsExist(this.this$0.listGrid);
}
;
_.this$0 = null;
function SubsystemConfigurationHistoryListView_0(hasWritePerm){
  var datasource;
  $clinit_ResourceConfigurationHistoryListView();
  $clinit_BaseWidget();
  TableSection_0.call(this, null);
  this.hasWritePerm = hasWritePerm;
  this.resourceId = null;
  datasource = new ResourceConfigurationHistoryDataSource_0;
  this.dataSource_1 = datasource;
}

defineSeed(3639, 2622, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), SubsystemConfigurationHistoryListView_0);
_.configureTable = function configureTable_64(){
  $configureTable_5(this);
  $addTableAction(this, 'Export', ($clinit_Enhanced() , 'Export'), null, new SubsystemConfigurationHistoryListView$1_0(this));
}
;
function SubsystemConfigurationHistoryListView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3640, 1, {}, SubsystemConfigurationHistoryListView$1_0);
_.executeAction = function executeAction_92(selection, actionValue){
  var exporter;
  exporter = new ReportExporter_0('configurationHistory');
  $export(exporter);
  $refreshTableInfo(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_45(selection){
  return true;
}
;
_.this$0 = null;
function $copyValues_64(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'count', toInt(valueOf_45(from.count).value_0));
  $setAttribute_13(record, 'typeName', from.typeName);
  $setAttribute_13(record, 'typePlugin', from.typePlugin);
  $setAttribute_13(record, 'category', from.category.name_0);
  $setAttribute_3(record, 'typeId', from.typeId);
  $setAttribute_13(record, 'version', from.version_0);
  !from?(record.jsObj['object'] = null , undefined):(record.jsObj['object'] = from , undefined);
  record.jsObj['exportDetails'] = false;
  return record;
}

function InventorySummaryDataSource_0(){
  $clinit_RPCDataSource();
  RPCDataSource_0.call(this);
  $setFields(this, this.getFields());
}

defineSeed(3642, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), InventorySummaryDataSource_0);
_.copyValues = function copyValues_123(from){
  return null;
}
;
_.copyValues_0 = function copyValues_124(from){
  return this.copyValues_9(dynamicCast(from, Q$ResourceInstallCount));
}
;
_.copyValues_9 = function copyValues_125(from){
  return $copyValues_64(from);
}
;
_.executeFetch = function executeFetch_68(request, response, unused){
  this.executeFetch_5(request, response, dynamicCast(unused, Q$Criteria));
}
;
_.executeFetch_5 = function executeFetch_69(request, response, unused){
  var resourceService;
  resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  $findResourceInstallCounts(resourceService, new InventorySummaryDataSource$1_0(this, response, request));
}
;
_.executeUpdate = function executeUpdate_3(editedRecord, oldRecord, request, response){
}
;
_.getFetchCriteria = function getFetchCriteria_79(request){
  return null;
}
;
_.getFields = function getFields(){
  return initValues(_3Lcom_smartgwt_client_data_DataSourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$DataSourceField, [new DataSourceLinkField_0, new DataSourceTextField_0('typePlugin'), new DataSourceImageField_0, new DataSourceTextField_0('version'), new DataSourceIntegerField_0, new DataSourceBooleanField_0('exportDetails')]);
}
;
function DriftComplianceDataSource_0(){
  $clinit_RPCDataSource();
  InventorySummaryDataSource_0.call(this);
}

defineSeed(3641, 3642, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource]), DriftComplianceDataSource_0);
_.copyValues_9 = function copyValues_126(from){
  var record;
  record = $copyValues_64(from);
  from.numDriftTemplates > 0 && $setAttribute_13(record, 'inCompliance', ($clinit_Boolean() , '' + from.inCompliance));
  return record;
}
;
_.executeFetch_5 = function executeFetch_70(request, response, unused){
  var resourceService;
  resourceService = dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync);
  $findResourceComplianceCounts(resourceService, new DriftComplianceDataSource$1_0(this, response, request));
}
;
_.getFields = function getFields_0(){
  var fields, i, newFields;
  fields = initValues(_3Lcom_smartgwt_client_data_DataSourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$DataSourceField, [new DataSourceLinkField_0, new DataSourceTextField_0('typePlugin'), new DataSourceImageField_0, new DataSourceTextField_0('version'), new DataSourceIntegerField_0, new DataSourceBooleanField_0('exportDetails')]);
  newFields = initDim(_3Lcom_smartgwt_client_data_DataSourceField_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$DataSourceField, fields.length + 1, 0);
  for (i = 0; i < fields.length - 1; ++i) {
    setCheck(newFields, i, fields[i]);
  }
  setCheck(newFields, newFields.length - 2, new DataSourceBooleanField_0('inCompliance'));
  setCheck(newFields, newFields.length - 1, fields[fields.length - 1]);
  return newFields;
}
;
function $onFailure_51(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to get inventory summary'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_424(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_1()));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function DriftComplianceDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3643, 1, {}, DriftComplianceDataSource$1_0);
_.onFailure = function onFailure_440(caught){
  $onFailure_51(this, caught);
}
;
_.onSuccess_0 = function onSuccess_440(result){
  $onSuccess_424(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function $clinit_DriftComplianceReport(){
  $clinit_DriftComplianceReport = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_28 = new ViewName_2('DriftCompliance', ($clinit_Enhanced() , 'Drift Compliance'), ($clinit_IconEnum() , DRIFT_COMPLIANCE));
}

function $hideResourceList(this$static){
  if (this$static.resourceList) {
    $removeMember(this$static, this$static.resourceList);
    $destroy_2(this$static.resourceList);
    this$static.resourceList = null;
  }
  $markForRedraw(this$static);
}

function DriftComplianceReport_0(){
  $clinit_DriftComplianceReport();
  EnhancedVLayout_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
}

defineSeed(3644, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$HasViewName, Q$Enhanced]), DriftComplianceReport_0);
_.getViewName = function getViewName_13(){
  return VIEW_ID_28;
}
;
_.onInit = function onInit_70(){
  $onInit(this);
  $onInit_Layout(this);
  $addMember(this, new DriftComplianceReportTable_0);
}
;
_.renderView = function renderView_34(viewPath){
  var criteria, resourceTypeId, resourceVersion, criteria_0, criteria_1;
  if (viewPath.viewPath.size_0 <= viewPath.index_0) {
    $hideResourceList(this);
  }
   else {
    resourceTypeId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
    ++viewPath.index_0;
    if (viewPath.viewPath.size_0 <= viewPath.index_0) {
      criteria = (criteria_0 = new Criteria_0 , $addCriteria_1(criteria_0, ($clinit_ResourceDataSourceField() , TYPE_56).propertyName, valueOf_44(resourceTypeId)) , criteria_0);
    }
     else {
      resourceVersion = (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path;
      criteria = (criteria_1 = new Criteria_0 , $addCriteria_1(criteria_1, ($clinit_ResourceDataSourceField() , TYPE_56).propertyName, valueOf_44(resourceTypeId)) , criteria_1.jsObj['version'] = resourceVersion , criteria_1);
    }
    $hideResourceList(this);
    this.resourceList = new DriftComplianceReportResourceSearchView_0(criteria);
    $addMember(this, this.resourceList);
    $markForRedraw(this);
  }
}
;
_.resourceList = null;
var VIEW_ID_28;
function $createListGridFields(this$static){
  var fields, field, field_0, field_1, categoryIcons, field_2, field_3;
  fields = new ArrayList_0;
  $add_3(fields, (field = new ListGridField_3('typeName', ($clinit_Enhanced() , 'Resource Type')) , field.jsObj['width'] = '35%' , $setCellFormatter_0(field, new InventorySummaryReportTable$2_0(this$static)) , field));
  $add_3(fields, (field_0 = new ListGridField_3('typePlugin', 'Plugin') , field_0.jsObj['width'] = '10%' , field_0));
  $add_3(fields, (field_1 = new ListGridField_3('category', 'Category') , field_1.jsObj['width'] = 70 , $setAttribute_13(field_1, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0) , $setAttribute_8(field_1, 'showValueIconOnly', ($clinit_Boolean() , $clinit_Boolean() , TRUE)) , categoryIcons = new HashMap_1(3) , categoryIcons.put(($clinit_ResourceCategory() , PLATFORM).name_0, getResourceIcon_0(PLATFORM, ($clinit_AvailabilityType() , UP), '16')) , categoryIcons.put(SERVER_0.name_0, getResourceIcon_0(SERVER_0, UP, '16')) , categoryIcons.put(SERVICE.name_0, getResourceIcon_0(SERVICE, UP, '16')) , setAttribute_10(field_1.jsObj, 'valueIcons', categoryIcons) , $setAttribute_8(field_1, 'showHover', TRUE) , $setHoverCustomizer_0(field_1, new InventorySummaryReportTable$3_0) , field_1));
  $add_3(fields, (field_2 = new ListGridField_3('version', 'Version') , field_2.jsObj['width'] = '*' , field_2));
  $add_3(fields, (field_3 = new ListGridField_3('count', 'Count') , field_3.jsObj['width'] = 60 , field_3));
  return fields;
}

function $getResourceTypeTableUrl(this$static, selected){
  var resourceTypeId, url, version;
  url = null;
  if (selected) {
    resourceTypeId = getAttributeAsInt(selected.jsObj, 'typeId').value_0;
    version = getAttribute(selected.jsObj, 'version');
    version == null?(url = '#Reports/Inventory/' + this$static.getReportNameForResourceTypeURL() + '/' + resourceTypeId):(url = '#Reports/Inventory/' + this$static.getReportNameForResourceTypeURL() + '/' + resourceTypeId + '/' + version);
  }
  return url;
}

function InventorySummaryReportTable_0(){
  $clinit_BaseWidget();
  Table_1.call(this);
  $setDataSource(this, new InventorySummaryDataSource_0);
}

defineSeed(3646, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), InventorySummaryReportTable_0);
_.configureTable = function configureTable_65(){
  var fields;
  fields = this.createListGridFields();
  $setListGridDoubleClickHandler(this, new InventorySummaryReportTable$1_0(this));
  $setListGridFields(this, false, dynamicCast($toArray_1(fields, initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, fields.size_0, 0)), Q$ListGridField_$1));
  $setAttribute_24(this.listGrid, 'editEvent', ($clinit_ListGridEditEvent() , CLICK).value_0, true);
  $setEditByCell(this.listGrid, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $addTableAction(this, 'Export', ($clinit_Enhanced() , 'Export'), null, new InventorySummaryReportTable$4_0(this));
}
;
_.createListGridFields = function createListGridFields(){
  return $createListGridFields(this);
}
;
_.getReportNameForDownloadURL = function getReportNameForDownloadURL(){
  return 'inventorySummary';
}
;
_.getReportNameForResourceTypeURL = function getReportNameForResourceTypeURL(){
  return 'InventorySummary';
}
;
function DriftComplianceReportTable_0(){
  $clinit_BaseWidget();
  InventorySummaryReportTable_0.call(this);
  $setDataSource(this, new DriftComplianceDataSource_0);
}

defineSeed(3645, 3646, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), DriftComplianceReportTable_0);
_.createListGridFields = function createListGridFields_0(){
  var fields, field, complianceIcons;
  fields = $createListGridFields(this);
  $add_2(fields, fields.size_0 - 1, (field = new ListGridField_3('inCompliance', ($clinit_Enhanced() , 'In Compliance?')) , complianceIcons = new HashMap_0 , complianceIcons.put('true', getAvailabilityIcon(($clinit_Boolean() , $clinit_Boolean() , TRUE))) , complianceIcons.put('false', getAvailabilityIcon(FALSE)) , setAttribute_10(field.jsObj, 'valueIcons', complianceIcons) , $setAttribute_13(field, 'type', ($clinit_ListGridFieldType() , ICON_0).value_0) , $setAttribute_8(field, 'canSortClientOnly', TRUE) , field.jsObj['width'] = 100 , field));
  return fields;
}
;
_.getReportNameForDownloadURL = function getReportNameForDownloadURL_0(){
  return 'driftCompliance';
}
;
_.getReportNameForResourceTypeURL = function getReportNameForResourceTypeURL_0(){
  return 'DriftCompliance';
}
;
function $onFailure_52(this$static, caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to get inventory summary'), caught);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_425(this$static, result){
  $setAttribute_17(this$static.val$response, 'data', $buildRecords(this$static.this$0, result, true));
  $setTotalRows(this$static.val$response, valueOf_44(result.size_1()));
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function InventorySummaryDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3647, 1, {}, InventorySummaryDataSource$1_0);
_.onFailure = function onFailure_441(caught){
  $onFailure_52(this, caught);
}
;
_.onSuccess_0 = function onSuccess_441(result){
  $onSuccess_425(this, dynamicCast(result, Q$List));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function InventorySummaryReportTable$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3648, 1, makeCastMap([Q$EventHandler, Q$DoubleClickHandler]), InventorySummaryReportTable$1_0);
_.onDoubleClick = function onDoubleClick_18(event_0){
  var lg, selected, url;
  lg = dynamicCast(event_0.source, Q$ListGrid);
  selected = lg.getSelectedRecord_0();
  url = $getResourceTypeTableUrl(this.this$0, selected);
  url != null && ($clinit_CoreGUI() , goToView(url, null, false));
}
;
_.this$0 = null;
function InventorySummaryReportTable$2_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3649, 1, {}, InventorySummaryReportTable$2_0);
_.format_1 = function format_85(value, record, rowNum, colNum){
  var url;
  url = $getResourceTypeTableUrl(this.this$0, record);
  if (url == null) {
    return toString__devirtual$(value);
  }
  return '<a href="' + url + '">' + toString__devirtual$(value) + '<\/a>';
}
;
_.this$0 = null;
function InventorySummaryReportTable$3_0(){
}

defineSeed(3650, 1, {}, InventorySummaryReportTable$3_0);
_.hoverHTML_0 = function hoverHTML_57(value, record, rowNum, colNum){
  var cat;
  cat = getAttribute(record.jsObj, 'category');
  if ($equals_6(($clinit_ResourceCategory() , PLATFORM).name_0, cat)) {
    return $clinit_Enhanced() , 'Platform';
  }
   else if ($equals_6(SERVER_0.name_0, cat)) {
    return $clinit_Enhanced() , 'Server';
  }
   else if ($equals_6(SERVICE.name_0, cat)) {
    return $clinit_Enhanced() , 'Service';
  }
  return '';
}
;
function InventorySummaryReportTable$4_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3651, 1, {}, InventorySummaryReportTable$4_0);
_.executeAction = function executeAction_93(selection, actionValue){
  var exportModalWindow;
  exportModalWindow = new ReportExporter_0(this.this$0.getReportNameForDownloadURL());
  $export(exportModalWindow);
  $refreshTableInfo(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_46(selection){
  return true;
}
;
_.this$0 = null;
function $clinit_ResourceInstallReport(){
  $clinit_ResourceInstallReport = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_29 = new ViewName_2('InventorySummary', ($clinit_Enhanced() , 'Inventory Summary'), ($clinit_IconEnum() , INVENTORY_SUMMARY));
}

function $hideResourceList_0(this$static){
  if (this$static.resourceList) {
    $removeMember(this$static, this$static.resourceList);
    $destroy_2(this$static.resourceList);
    this$static.resourceList = null;
  }
  $markForRedraw(this$static);
}

function ResourceInstallReport_0(){
  $clinit_ResourceInstallReport();
  EnhancedVLayout_0.call(this);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
}

defineSeed(3652, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$HasViewName, Q$Enhanced]), ResourceInstallReport_0);
_.getViewName = function getViewName_14(){
  return VIEW_ID_29;
}
;
_.onInit = function onInit_71(){
  $onInit(this);
  $onInit_Layout(this);
  $addMember(this, new InventorySummaryReportTable_0);
}
;
_.renderView = function renderView_35(viewPath){
  var criteria, resourceTypeId, resourceVersion, criteria_0, criteria_1;
  if (viewPath.viewPath.size_0 <= viewPath.index_0) {
    $hideResourceList_0(this);
  }
   else {
    resourceTypeId = __parseAndValidateInt((viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path);
    ++viewPath.index_0;
    if (viewPath.viewPath.size_0 <= viewPath.index_0) {
      criteria = (criteria_0 = new Criteria_0 , $addCriteria_1(criteria_0, ($clinit_ResourceDataSourceField() , TYPE_56).propertyName, valueOf_44(resourceTypeId)) , criteria_0);
    }
     else {
      resourceVersion = (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path;
      criteria = (criteria_1 = new Criteria_0 , $addCriteria_1(criteria_1, ($clinit_ResourceDataSourceField() , TYPE_56).propertyName, valueOf_44(resourceTypeId)) , criteria_1.jsObj['version'] = resourceVersion , criteria_1);
    }
    $hideResourceList_0(this);
    this.resourceList = new ResourceSearchView_3(criteria);
    $addMember(this, this.resourceList);
    $markForRedraw(this);
  }
}
;
_.resourceList = null;
var VIEW_ID_29;
function $buildRecords_3(this$static, dataObjects){
  var oob, oob$iterator;
  for (oob$iterator = new AbstractList$IteratorImpl_0(dataObjects); oob$iterator.i < oob$iterator.this$0_0.size_1();) {
    oob = dynamicCast($next_0(oob$iterator), Q$MeasurementOOBComposite);
    oob.factor > this$static.maximumFactor && (this$static.maximumFactor = oob.factor);
  }
  return $buildRecords(this$static, dataObjects, true);
}

function $copyValues_65(){
  throw new UnsupportedOperationException_1('OOBs Read only');
}

function $copyValues_66(this$static, from){
  var factorRankingWidth, record, min, max;
  $setFormattedOutlier(from, ($clinit_MeasurementConverterClient() , format_91(new Double_0(from.outlier), from.units)));
  min = format_91(new Double_0(from.blMin), from.units);
  max = format_91(new Double_0(from.blMax), from.units);
  from.formattedBaseband = min + ', ' + max;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'scheduleId', from.scheduleId);
  $setAttribute_13(record, 'scheduleName', from.scheduleName);
  $setAttribute_3(record, 'definitionId', from.definitionId);
  $setAttribute_3(record, 'factor', from.factor);
  $setAttribute_13(record, 'formattedBaseband', from.formattedBaseband);
  $setAttribute_13(record, 'formattedOutlier', from.formattedOutlier);
  $setAttribute_2(record, 'blMin', from.blMin);
  $setAttribute_2(record, 'blMax', from.blMax);
  $setAttribute_11(record, 'parentId', from.parentId);
  $setAttribute_13(record, 'parentName', from.parentName);
  $setAttribute_3(record, 'resourceId', from.resourceId);
  $setAttribute_13(record, 'resourceName', from.resourceName);
  $setAttribute_13(record, 'resourceAncestry', from.resourceAncestry);
  $setAttribute_3(record, 'resourceTypeId', from.resourceTypeId);
  factorRankingWidth = round_int(from.factor / this$static.maximumFactor * 100);
  $setBackgroundComponent(record, new HTMLFlow_1('<div style="width: ' + factorRankingWidth + '%; height: 100%; background-color: #A5B391;">&nbsp;<\/div>'));
  return record;
}

function $executeFetch_52(this$static, request, response){
  var pc;
  pc = $getPageControl(this$static, request);
  $getSchedulesWithOOBs(dynamicCast(secure((!instance_18 && (instance_18 = new MeasurementDataGWTService_Proxy_0) , instance_18), -1), Q$MeasurementDataGWTServiceAsync), pc, new MeasurementOOBDataSource$3_0(this$static, response, request));
}

function $getListGridFields_21(){
  var ancestryField, bandField, factorField, fields, outlierField, resourceNameField, scheduleNameField;
  fields = new ArrayList_0;
  resourceNameField = new ListGridField_3('resourceName', 'Resource');
  $setCellFormatter_0(resourceNameField, new MeasurementOOBDataSource$1_0);
  $setAttribute_8(resourceNameField, 'showHover', ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setHoverCustomizer_0(resourceNameField, new MeasurementOOBDataSource$2_0);
  setCheck(fields.array, fields.size_0++, resourceNameField);
  ancestryField = setupAncestryListGridField();
  setCheck(fields.array, fields.size_0++, ancestryField);
  scheduleNameField = new ListGridField_3('scheduleName', 'Metric');
  setCheck(fields.array, fields.size_0++, scheduleNameField);
  bandField = new ListGridField_3('formattedBaseband', 'Band');
  setCheck(fields.array, fields.size_0++, bandField);
  outlierField = new ListGridField_3('formattedOutlier', 'Outlier');
  setCheck(fields.array, fields.size_0++, outlierField);
  factorField = new ListGridField_3('factor', 'Out of Range Factor (%)');
  setCheck(fields.array, fields.size_0++, factorField);
  resourceNameField.jsObj['width'] = '20%';
  ancestryField.jsObj['width'] = '30%';
  scheduleNameField.jsObj['width'] = '20%';
  bandField.jsObj['width'] = '10%';
  outlierField.jsObj['width'] = '10%';
  factorField.jsObj['width'] = '10%';
  return fields;
}

function MeasurementOOBDataSource_0(){
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  fields = new ArrayList_0;
  $addFields(this, fields);
}

defineSeed(3653, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$MeasurementOOBDataSource]), MeasurementOOBDataSource_0);
_.buildRecords = function buildRecords_1(dataObjects){
  return $buildRecords_3(this, dataObjects);
}
;
_.copyValues = function copyValues_127(from){
  return $copyValues_65();
}
;
_.copyValues_0 = function copyValues_128(from){
  return $copyValues_66(this, dynamicCast(from, Q$MeasurementOOBComposite));
}
;
_.executeFetch = function executeFetch_71(request, response, unused){
  $executeFetch_52(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_80(request){
  return null;
}
;
_.getSortFieldForColumn = function getSortFieldForColumn_12(columnName){
  return null;
}
;
_.maximumFactor = 0;
function MeasurementOOBDataSource$1_0(){
}

defineSeed(3654, 1, {}, MeasurementOOBDataSource$1_0);
_.format_1 = function format_86(o, listGridRecord, i, i1){
  var url;
  url = '#Resource/' + getAttributeAsInt(listGridRecord.jsObj, 'resourceId').value_0;
  return getHref(url, toString__devirtual$(o));
}
;
function MeasurementOOBDataSource$2_0(){
}

defineSeed(3655, 1, {}, MeasurementOOBDataSource$2_0);
_.hoverHTML_0 = function hoverHTML_58(value, listGridRecord, rowNum, colNum){
  return getResourceHoverHTML(listGridRecord);
}
;
function $onSuccess_426(this$static, result){
  var ancestries, composite, composite$iterator, typeRepo, typesSet;
  typesSet = new HashSet_0;
  ancestries = new HashSet_0;
  for (composite$iterator = new AbstractList$IteratorImpl_0(result); composite$iterator.i < composite$iterator.this$0_0.size_1();) {
    composite = dynamicCast($next_0(composite$iterator), Q$MeasurementOOBComposite);
    $add_6(typesSet, valueOf_44(composite.resourceTypeId));
    $add_6(ancestries, composite.resourceAncestry);
  }
  typesSet.addAll(getAncestryTypeIds(ancestries));
  typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepo, dynamicCast(typesSet.toArray_0(initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new MeasurementOOBDataSource$3$1_0(this$static, result, this$static.val$response, this$static.val$request));
}

function MeasurementOOBDataSource$3_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3656, 1, {}, MeasurementOOBDataSource$3_0);
_.onFailure = function onFailure_442(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load measurement OOB information'), caught);
}
;
_.onSuccess_0 = function onSuccess_442(result){
  $onSuccess_426(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function MeasurementOOBDataSource$3$1_0(this$1, val$result, val$response, val$request){
  this.this$1 = this$1;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3657, 1, {}, MeasurementOOBDataSource$3$1_0);
_.onTypesLoaded_0 = function onTypesLoaded_53(types){
  var record, record$index, record$max, records, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords_3(this.this$1.this$0, this.val$result);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  $setTotalRows(this.val$response, valueOf_44($getTotalSize(this.val$result)));
  $processResponse_0(this.this$1.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$1 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $clinit_MeasurementOOBView(){
  $clinit_MeasurementOOBView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_30 = new ViewName_2('SuspectMetrics', ($clinit_Enhanced() , 'Suspect Metrics'), ($clinit_IconEnum() , SUSPECT_METRICS));
}

function MeasurementOOBView_0(){
  $clinit_MeasurementOOBView();
  Table_1.call(this);
  $setDataSource(this, new MeasurementOOBDataSource_0);
}

defineSeed(3658, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), MeasurementOOBView_0);
_.configureTable = function configureTable_66(){
  $setListGridFields(this, false, dynamicCast($toArray_1($getListGridFields_21(dynamicCast(this.dataSource_1, Q$MeasurementOOBDataSource)), initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, 0, 0)), Q$ListGridField_$1));
  $addTableAction(this, 'Export', ($clinit_Enhanced() , 'Export'), null, new MeasurementOOBView$1_0(this));
}
;
_.getDefaultSelectionStyle = function getDefaultSelectionStyle_2(){
  return $clinit_SelectionStyle() , NONE_4;
}
;
_.getViewName = function getViewName_15(){
  return VIEW_ID_30;
}
;
var VIEW_ID_30;
function MeasurementOOBView$1_0(this$0){
  this.this$0 = this$0;
  AbstractTableAction_0.call(this);
}

defineSeed(3659, 1608, {}, MeasurementOOBView$1_0);
_.executeAction = function executeAction_94(selection, actionValue){
  var exporter;
  exporter = new ReportExporter_0('suspectMetrics');
  $export(exporter);
  $refreshTableInfo(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_47(selection){
  return $enableIfRecordsExist(this.this$0.listGrid);
}
;
_.this$0 = null;
function SubsystemOperationHistoryListView_0(hasControlPermission){
  $clinit_OperationHistoryView();
  OperationHistoryView_1.call(this, SUBSYSTEM_VIEW_ID_0.title_0, new EntityContext_0(null, null, null), hasControlPermission);
}

defineSeed(3660, 2588, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$RefreshableView, Q$Table, Q$HasViewName, Q$Enhanced, Q$EnhancedHLayout]), SubsystemOperationHistoryListView_0);
_.configureTable = function configureTable_67(){
  $configureTable_4(this);
  $addTableAction(this, 'Export', ($clinit_Enhanced() , 'Export'), null, new SubsystemOperationHistoryListView$1_0(this));
}
;
function SubsystemOperationHistoryListView$1_0(this$0){
  this.this$0 = this$0;
  AbstractTableAction_0.call(this);
}

defineSeed(3661, 1608, {}, SubsystemOperationHistoryListView$1_0);
_.executeAction = function executeAction_95(selection, actionValue){
  var exporter;
  exporter = createExporterForRecentOperations($getValues(this.this$0.statusFilter), $getValueAsDays(this.this$0.startDateFilter), $getValueAsDays(this.this$0.endDateFilter));
  $export(exporter);
  $refreshTableInfo(this.this$0);
}
;
_.isEnabled_0 = function isEnabled_48(selection){
  return $enableIfRecordsExist(this.this$0.listGrid);
}
;
_.this$0 = null;
function $onSuccess_427(this$static, result){
  $drawTags(this$static.this$0, result);
}

function TagCloudView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3662, 1, {}, TagCloudView$1_0);
_.onFailure = function onFailure_443(caught){
  $handleError_0(($clinit_CoreGUI() , $clinit_Enhanced() , 'Failed to load tags.'), caught);
}
;
_.onSuccess_0 = function onSuccess_443(result){
  $onSuccess_427(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
function $compare_20(o1, o2){
  return compareTo_11($toString_20(o1), $toString_20(o2));
}

function TagCloudView$2_0(){
}

defineSeed(3663, 1, makeCastMap([Q$Comparator]), TagCloudView$2_0);
_.compare = function compare_21(o1, o2){
  return $compare_20(dynamicCast(o1, Q$TagReportComposite), dynamicCast(o2, Q$TagReportComposite));
}
;
function TagCloudView$3_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3664, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), TagCloudView$3_0);
_.onClick = function onClick_176(event_0){
  var doomedTag, selected;
  selected = $getSelectedTagReportComposite(this.this$0);
  if (selected) {
    doomedTag = new HashSet_1(1);
    $add_6(doomedTag, selected);
    $removeTags(dynamicCast(secure(getInstance_56(), -1), Q$TagGWTServiceAsync), doomedTag, new TagCloudView$3$1_0(this, selected));
  }
}
;
_.this$0 = null;
function $onSuccess_428(this$static){
  $remove_4(this$static.this$1.this$0.tags, this$static.val$selected);
  $clinit_CoreGUI();
  goToView('#Reports/Subsystems/Tags', null, false);
  $notify(messageCenter_0, new Message_7('You successfully deleted the tag [' + ($clinit_Enhanced() , $toString_20(this$static.val$selected)) + ']', ($clinit_Message$Severity() , Info)));
}

function TagCloudView$3$1_0(this$1, val$selected){
  this.this$1 = this$1;
  this.val$selected = val$selected;
}

defineSeed(3665, 1, {}, TagCloudView$3$1_0);
_.onFailure = function onFailure_444(caught){
  $handleError_0(($clinit_CoreGUI() , 'Failed to delete the tag [' + ($clinit_Enhanced() , $toString_20(this.val$selected)) + ']'), caught);
}
;
_.onSuccess_0 = function onSuccess_444(result){
  $onSuccess_428(this, throwClassCastExceptionUnlessNull(result));
}
;
_.this$1 = null;
_.val$selected = null;
function EnhancedIButton_0(){
  $clinit_BaseWidget();
  EnhancedIButton_1.call(this, null);
}

defineSeed(3667, 452, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$IButton, Q$StatefulCanvas, Q$StretchImg, Q$StretchImgButton, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasIconClickHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), EnhancedIButton_0);
function TagCloudView$DeleteButton_0(this$0){
  this.this$0 = this$0;
  EnhancedIButton_0.call(this);
}

defineSeed(3666, 3667, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$IButton, Q$StatefulCanvas, Q$StretchImg, Q$StretchImgButton, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasIconClickHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers]), TagCloudView$DeleteButton_0);
_.onDestroy = function onDestroy_20(){
  this.this$0.deleteButton = null;
}
;
_.this$0 = null;
function $clinit_TaggedView(){
  $clinit_TaggedView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_31 = new ViewName_2('Tags', ($clinit_Enhanced() , 'Tags'), ($clinit_IconEnum() , TAGS));
}

function $completeRenderView(this$static, viewPath){
  var tagString;
  if (viewPath.viewPath.size_0 <= viewPath.index_0) {
    $destroyTagTables(this$static);
    $setSelectedTag(this$static.tagCloudView, null);
  }
   else {
    tagString = (viewPath.index_0 >= viewPath.viewPath.size_0?null:dynamicCast($get_0(viewPath.viewPath, viewPath.index_0), Q$ViewId)).path;
    $viewTag(this$static, tagString);
  }
}

function $destroyTagTables(this$static){
  if (this$static.container) {
    $clear_2(this$static.viewsWithTags);
    $removeMember(this$static, this$static.container);
    this$static.container.destroy_0();
    this$static.container = null;
  }
}

function $viewTag(this$static, tagString){
  var bundleDeploymentListView, bundleDestinationListView, bundleVersionListView, bundlesView, criteria, resourceView, t, t$iterator, tab, tag;
  tagString != null && !$equals_6(tagString, this$static.tagCloudView.selectedTag) && $destroyTagTables(this$static);
  $setSelectedTag(this$static.tagCloudView, tagString);
  if (!this$static.container) {
    tag = new Tag_1(tagString);
    criteria = new Criteria_0;
    $addCriteria_2(criteria, 'tagNamespace', tag.namespace);
    $addCriteria_2(criteria, 'tagSemantic', tag.semantic);
    $addCriteria_2(criteria, 'tagName', tag.name_0);
    this$static.container = new TabSet_0;
    $setAttribute_24(this$static.container, 'width', '100%', true);
    $setAttribute_24(this$static.container, 'height', '100%', true);
    $setAttribute_26(this$static.container, initValues(_3Ljava_lang_Object_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Object, [$getDeleteButton(this$static.tagCloudView)]));
    $addTabSelectedHandler(this$static.container, new TaggedView$1_0(this$static));
    $setAttribute_19(this$static.container, 'selectedTab', this$static.selectedTabNum, true);
    bundlesView = new BundlesListView_0(criteria, null);
    $add_3(this$static.viewsWithTags, bundlesView);
    tab = new Tab_1(($clinit_Enhanced() , 'Bundles'));
    !tab.tabSet || !$isDrawn(tab.tabSet).value_0?(tab.jsObj['icon'] = 'subsystems/content/Content_16.png' , undefined):$setTabIcon(tab.tabSet, getAttribute(tab.jsObj, 'ID'), 'subsystems/content/Content_16.png');
    !tab.tabSet || !$isCreated_1(tab.tabSet)?$setAttribute_5(tab, 'pane', $getOrCreateJsObj_0(bundlesView)):$updateTab(tab.tabSet, tab, bundlesView);
    $addTab(this$static.container, tab);
    bundleVersionListView = new BundleVersionListView_0(criteria);
    $add_3(this$static.viewsWithTags, bundleVersionListView);
    tab = new Tab_1('Bundle Versions');
    !tab.tabSet || !$isDrawn(tab.tabSet).value_0?(tab.jsObj['icon'] = 'subsystems/bundle/BundleVersion_16.png' , undefined):$setTabIcon(tab.tabSet, getAttribute(tab.jsObj, 'ID'), 'subsystems/bundle/BundleVersion_16.png');
    !tab.tabSet || !$isCreated_1(tab.tabSet)?$setAttribute_5(tab, 'pane', $getOrCreateJsObj_0(bundleVersionListView)):$updateTab(tab.tabSet, tab, bundleVersionListView);
    $addTab(this$static.container, tab);
    bundleDeploymentListView = new BundleDeploymentListView_0(criteria, this$static.globalPermissions.contains_0(($clinit_Permission() , MANAGE_BUNDLE)));
    $add_3(this$static.viewsWithTags, bundleDeploymentListView);
    tab = new Tab_1('Bundle Deployments');
    !tab.tabSet || !$isDrawn(tab.tabSet).value_0?(tab.jsObj['icon'] = 'subsystems/bundle/BundleDeployment_16.png' , undefined):$setTabIcon(tab.tabSet, getAttribute(tab.jsObj, 'ID'), 'subsystems/bundle/BundleDeployment_16.png');
    !tab.tabSet || !$isCreated_1(tab.tabSet)?$setAttribute_5(tab, 'pane', $getOrCreateJsObj_0(bundleDeploymentListView)):$updateTab(tab.tabSet, tab, bundleDeploymentListView);
    $addTab(this$static.container, tab);
    bundleDestinationListView = new BundleDestinationListView_0(criteria);
    $add_3(this$static.viewsWithTags, bundleDestinationListView);
    tab = new Tab_1('Bundle Destinations');
    !tab.tabSet || !$isDrawn(tab.tabSet).value_0?(tab.jsObj['icon'] = 'subsystems/bundle/BundleDestination_16.png' , undefined):$setTabIcon(tab.tabSet, getAttribute(tab.jsObj, 'ID'), 'subsystems/bundle/BundleDestination_16.png');
    !tab.tabSet || !$isCreated_1(tab.tabSet)?$setAttribute_5(tab, 'pane', $getOrCreateJsObj_0(bundleDestinationListView)):$updateTab(tab.tabSet, tab, bundleDestinationListView);
    $addTab(this$static.container, tab);
    resourceView = new ResourceSearchView_2(criteria, 'Tagged Resources', initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, []));
    $add_3(this$static.viewsWithTags, resourceView);
    tab = new Tab_1('Tagged Resources');
    $setIcon_3(tab, getResourceIcon_0(($clinit_ResourceCategory() , SERVICE), ($clinit_AvailabilityType() , UP), '16'));
    !tab.tabSet || !$isCreated_1(tab.tabSet)?$setAttribute_5(tab, 'pane', $getOrCreateJsObj_0(resourceView)):$updateTab(tab.tabSet, tab, resourceView);
    $addTab(this$static.container, tab);
    for (t$iterator = new AbstractList$IteratorImpl_0(this$static.viewsWithTags); t$iterator.i < t$iterator.this$0_0.size_1();) {
      t = dynamicCast($next_0(t$iterator), Q$Table);
      t.showFooter = false;
    }
    $addMember(this$static, this$static.container);
  }
  for (t$iterator = new AbstractList$IteratorImpl_0(this$static.viewsWithTags); t$iterator.i < t$iterator.this$0_0.size_1();) {
    t = dynamicCast($next_0(t$iterator), Q$Table);
    t.refresh_0();
  }
}

function TaggedView_0(){
  $clinit_TaggedView();
  EnhancedVLayout_0.call(this);
  this.viewsWithTags = new ArrayList_0;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
}

defineSeed(3668, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$BookmarkableView, Q$HasViewName, Q$Enhanced]), TaggedView_0);
_.getViewName = function getViewName_16(){
  return VIEW_ID_31;
}
;
_.onInit = function onInit_72(){
  $onInit(this);
  $onInit_Layout(this);
  this.tagCloudView = new TagCloudView_0;
  $setAutoHeight(this.tagCloudView);
  $setExtraSpace(this.tagCloudView, 10);
  $addMember(this, this.tagCloudView);
}
;
_.renderView = function renderView_36(viewPath){
  $loadExplicitGlobalPermissions(($clinit_PermissionsLoader() , new TaggedView$2_0(this, viewPath)));
}
;
_.container = null;
_.globalPermissions = null;
_.selectedTabNum = 0;
_.tagCloudView = null;
var VIEW_ID_31;
function TaggedView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3669, 1, makeCastMap([Q$EventHandler, Q$TabSelectedHandler]), TaggedView$1_0);
_.onTabSelected = function onTabSelected_4(event_0){
  this.this$0.selectedTabNum = $getTabNum(event_0);
}
;
_.this$0 = null;
function TaggedView$2_0(this$0, val$viewPath){
  this.this$0 = this$0;
  this.val$viewPath = val$viewPath;
}

defineSeed(3670, 1, {}, TaggedView$2_0);
_.onPermissionsLoaded = function onPermissionsLoaded_17(globalPermissions){
  this.this$0.globalPermissions = globalPermissions;
  $completeRenderView(this.this$0, this.val$viewPath);
}
;
_.this$0 = null;
_.val$viewPath = null;
function $copyValues_67(){
  throw new UnsupportedOperationException_1('ProblemResource data is read only');
}

function $copyValues_68(from){
  var record;
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', from.resourceId);
  $setAttribute_4(record, ($clinit_ProblemResourcesDataSource$Field() , ALERTS).propertyName, from.numAlerts);
  $setAttribute_13(record, AVAILABILITY_3.propertyName, getAvailabilityIconFromAvailTypeAndSize(from.availabilityType, false));
  $setAttribute_13(record, RESOURCE_3.propertyName, from.resourceName);
  $setAttribute_13(record, 'resourceName', from.resourceName);
  $setAttribute_13(record, 'resourceAncestry', from.ancestry);
  $setAttribute_3(record, 'resourceTypeId', from.resourceTypeId);
  !from?(record.jsObj['entity'] = null , undefined):(record.jsObj['entity'] = from , undefined);
  return record;
}

function $dataRetrieved_9(this$static, result, response, request){
  var ancestries, resourceComposite, resourceComposite$iterator, typeRepo, typesSet;
  typesSet = new HashSet_0;
  ancestries = new HashSet_0;
  for (resourceComposite$iterator = new AbstractList$IteratorImpl_0(result); resourceComposite$iterator.i < resourceComposite$iterator.this$0_0.size_1();) {
    resourceComposite = dynamicCast($next_0(resourceComposite$iterator), Q$ProblemResourceComposite);
    $add_6(typesSet, valueOf_44(resourceComposite.resourceTypeId));
    $add_6(ancestries, resourceComposite.ancestry);
  }
  $addAll(typesSet, getAncestryTypeIds(ancestries));
  typeRepo = ($clinit_ResourceTypeRepository$Cache() , $clinit_ResourceTypeRepository$Cache() , ourInstance);
  $getResourceTypes_0(typeRepo, dynamicCast($toArray(typesSet, initDim(_3Ljava_lang_Integer_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Integer_$1, Q$Object_$1]), Q$Integer, typesSet.map.size_1(), 0)), Q$Integer_$1), null, new ProblemResourcesDataSource$2_0(this$static, result, response, request));
}

function $executeFetch_53(this$static, request, response){
  var ctime, maxItems, problemPortlet;
  ctime = N1_longLit;
  maxItems = -1;
  if (!!this$static.portlet && !!this$static.portlet) {
    problemPortlet = this$static.portlet;
    if (problemPortlet) {
      this$static.maximumProblemResourcesToDisplay > 0 && (maxItems = this$static.maximumProblemResourcesToDisplay);
      this$static.maximumProblemResourcesWithinHours > 0 && (ctime = sub(fromDouble(currentTimeMillis0()), fromInt(this$static.maximumProblemResourcesWithinHours * 60 * 60 * 1000)));
    }
  }
  $findProblemResources(dynamicCast(secure(getInstance_51(), -1), Q$ResourceGWTServiceAsync), ctime, maxItems, new ProblemResourcesDataSource$1_0(this$static, response, request));
}

function $setMaximumProblemResourcesToDisplay(this$static, maxPerRow){
  this$static.maximumProblemResourcesToDisplay = maxPerRow;
}

function $setMaximumProblemResourcesWithinHours(this$static, maximumProblemResourcesWithinHours){
  this$static.maximumProblemResourcesWithinHours = maximumProblemResourcesWithinHours;
}

function ProblemResourcesDataSource_0(problemResourcesPortlet){
  var fields_0, alertsField, availabilityField;
  $clinit_RPCDataSource();
  var fields;
  RPCDataSource_0.call(this);
  this.portlet = problemResourcesPortlet;
  fields = (fields_0 = new ArrayList_0 , alertsField = new DataSourceTextField_1(($clinit_ProblemResourcesDataSource$Field() , ALERTS).propertyName, ALERTS.title_0) , setCheck(fields_0.array, fields_0.size_0++, alertsField) , availabilityField = new DataSourceImageField_2(AVAILABILITY_3.propertyName, AVAILABILITY_3.title_0) , $setAttribute_8(availabilityField, 'canEdit', ($clinit_Boolean() , $clinit_Boolean() , FALSE)) , setCheck(fields_0.array, fields_0.size_0++, availabilityField) , fields_0);
  $addFields(this, fields);
}

defineSeed(3671, 1622, makeCastMap([Q$HasHandlers, Q$BaseClass, Q$DataSource, Q$ProblemResourcesDataSource]), ProblemResourcesDataSource_0);
_.copyValues = function copyValues_129(from){
  return $copyValues_67();
}
;
_.copyValues_0 = function copyValues_130(from){
  return $copyValues_68(dynamicCast(from, Q$ProblemResourceComposite));
}
;
_.executeFetch = function executeFetch_72(request, response, unused){
  $executeFetch_53(this, request, response, dynamicCast(unused, Q$Criteria));
}
;
_.getFetchCriteria = function getFetchCriteria_81(request){
  return null;
}
;
_.maximumProblemResourcesToDisplay = -1;
_.maximumProblemResourcesWithinHours = -1;
_.portlet = null;
function $onFailure_53(this$static, throwable){
  $handleError_0(($clinit_CoreGUI() , $clinit_RPCDataSource() , 'Failed to load Resources with alerts/unavailability.'), throwable);
  this$static.val$response.jsObj['status'] = -1;
  $processResponse_0(this$static.this$0, $getAttributeAsString(this$static.val$request, 'requestId'), this$static.val$response);
}

function $onSuccess_429(this$static, result){
  $dataRetrieved_9(this$static.this$0, result, this$static.val$response, this$static.val$request);
}

function ProblemResourcesDataSource$1_0(this$0, val$response, val$request){
  this.this$0 = this$0;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3672, 1, {}, ProblemResourcesDataSource$1_0);
_.onFailure = function onFailure_445(throwable){
  $onFailure_53(this, throwable);
}
;
_.onSuccess_0 = function onSuccess_445(result){
  $onSuccess_429(this, dynamicCast(result, Q$PageList));
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
function ProblemResourcesDataSource$2_0(this$0, val$result, val$response, val$request){
  this.this$0 = this$0;
  this.val$result = val$result;
  this.val$response = val$response;
  this.val$request = val$request;
}

defineSeed(3673, 1, {}, ProblemResourcesDataSource$2_0);
_.onTypesLoaded_0 = function onTypesLoaded_54(types){
  var record, record$index, record$max, records, resultSize, typesWrapper;
  typesWrapper = new AncestryUtil$MapWrapper_0(types);
  records = $buildRecords(this.this$0, this.val$result, true);
  for (record$index = 0 , record$max = records.length; record$index < record$max; ++record$index) {
    record = records[record$index];
    !typesWrapper?(record.jsObj['resourceAncestryTypes'] = null , undefined):(record.jsObj['resourceAncestryTypes'] = typesWrapper , undefined);
    $setAttribute_13(record, 'resourceAncestryDecoded', ($clinit_AncestryUtil() , getAncestryValue(record, true)));
  }
  $setAttribute_17(this.val$response, 'data', records);
  resultSize = $getTotalSize(this.val$result);
  this.this$0.maximumProblemResourcesToDisplay > 0 && this.this$0.maximumProblemResourcesToDisplay < resultSize && (resultSize = this.this$0.maximumProblemResourcesToDisplay);
  $setTotalRows(this.val$response, valueOf_44(resultSize));
  $processResponse_0(this.this$0, $getAttributeAsString(this.val$request, 'requestId'), this.val$response);
}
;
_.this$0 = null;
_.val$request = null;
_.val$response = null;
_.val$result = null;
function $clinit_ProblemResourcesDataSource$Field(){
  $clinit_ProblemResourcesDataSource$Field = nullMethod;
  ALERTS = new ProblemResourcesDataSource$Field_0('ALERTS', 0, 'numAlerts', ($clinit_RPCDataSource() , 'Alerts'));
  AVAILABILITY_3 = new ProblemResourcesDataSource$Field_0('AVAILABILITY', 1, 'availabilityType', 'Availability');
  RESOURCE_3 = new ProblemResourcesDataSource$Field_0('RESOURCE', 2, 'resource', 'Resource');
  $VALUES_134 = initValues(_3Lorg_rhq_enterprise_gui_coregui_client_resource_ProblemResourcesDataSource$Field_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$ProblemResourcesDataSource$Field, [ALERTS, AVAILABILITY_3, RESOURCE_3]);
}

function ProblemResourcesDataSource$Field_0(enum$name, enum$ordinal, propertyName, title){
  Enum_0.call(this, enum$name, enum$ordinal);
  this.propertyName = propertyName;
  this.title_0 = title;
}

function valueOf_143(name_0){
  $clinit_ProblemResourcesDataSource$Field();
  return valueOf(($clinit_ProblemResourcesDataSource$Field$Map() , $MAP_134), name_0);
}

function values_137(){
  $clinit_ProblemResourcesDataSource$Field();
  return $VALUES_134;
}

defineSeed(3674, 48, makeCastMap([Q$Serializable, Q$Comparable, Q$Enum, Q$ProblemResourcesDataSource$Field]), ProblemResourcesDataSource$Field_0);
_.propertyName = null;
_.title_0 = null;
var $VALUES_134, ALERTS, AVAILABILITY_3, RESOURCE_3;
function $clinit_ProblemResourcesDataSource$Field$Map(){
  $clinit_ProblemResourcesDataSource$Field$Map = nullMethod;
  $MAP_134 = createValueOfMap(($clinit_ProblemResourcesDataSource$Field() , $VALUES_134));
}

var $MAP_134;
function TestMessageCenterView_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
}

defineSeed(3711, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), TestMessageCenterView_0);
_.onDraw_0 = function onDraw_59(){
  var button, conciseMessageItem, detailsMessageItem, exceptionItem, form, opt, opt$iterator, optionChoices, optionMenu, sev, sev$iterator, severityChoices, severityMenu;
  severityChoices = new LinkedHashMap_0;
  for (sev$iterator = new EnumSet$EnumSetImpl$IteratorImpl_0(allOf(Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Severity_2_classLit)); sev$iterator.i < sev$iterator.this$1.all.length;) {
    sev = dynamicCast($next_3(sev$iterator), Q$Message$Severity);
    $put_1(severityChoices, sev.name_0, sev.name_0);
  }
  optionChoices = new LinkedHashMap_0;
  for (opt$iterator = new EnumSet$EnumSetImpl$IteratorImpl_0(allOf(Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit)); opt$iterator.i < opt$iterator.this$1.all.length;) {
    opt = dynamicCast($next_3(opt$iterator), Q$Message$Option);
    $put_1(optionChoices, opt.name_0, opt.name_0);
  }
  severityMenu = new SelectItem_2('severityItem', 'Severity');
  $isCreated_2(severityMenu)?$setProperty_6(severityMenu, 'width', 200):(severityMenu.jsObj['width'] = 200 , undefined);
  severityMenu.setValueMap_0(severityChoices);
  $setDefaultValue_1(severityMenu, ($clinit_Message$Severity() , Blank).name_0);
  optionMenu = new SelectItem_2('optionMenu', 'Message Options');
  $isCreated_2(optionMenu)?$setProperty_6(optionMenu, 'width', 200):(optionMenu.jsObj['width'] = 200 , undefined);
  $setMultiple(optionMenu, ($clinit_Boolean() , $clinit_Boolean() , TRUE));
  $setAttribute_30(optionMenu, 'multipleAppearance', ($clinit_MultipleAppearance() , GRID).value_0);
  optionMenu.setValueMap_0(optionChoices);
  $setAllowEmptyValue(optionMenu, TRUE);
  exceptionItem = new SliderItem_0;
  $isCreated_2(exceptionItem)?$setProperty_6(exceptionItem, 'width', 200):(exceptionItem.jsObj['width'] = 200 , undefined);
  $isCreated_2(exceptionItem)?$setProperty_5(exceptionItem, 'minValue', 0):(exceptionItem.jsObj['minValue'] = 0 , undefined);
  $isCreated_2(exceptionItem)?$setProperty_5(exceptionItem, 'maxValue', 10):(exceptionItem.jsObj['maxValue'] = 10 , undefined);
  $isCreated_2(exceptionItem)?$setProperty_6(exceptionItem, 'defaultValue', 0):(exceptionItem.jsObj['defaultValue'] = 0 , undefined);
  conciseMessageItem = new TextItem_3('conciseMessage', 'Concise Message');
  $isCreated_2(conciseMessageItem)?$setProperty_6(conciseMessageItem, 'width', 200):(conciseMessageItem.jsObj['width'] = 200 , undefined);
  $setValue_7(conciseMessageItem, 'A concise message string.');
  detailsMessageItem = new TextItem_3('detailsMessage', 'Details or Root Cause Message');
  $isCreated_2(detailsMessageItem)?$setProperty_6(detailsMessageItem, 'width', 200):(detailsMessageItem.jsObj['width'] = 200 , undefined);
  $setValue_7(detailsMessageItem, 'The details or the inner-most exception message.');
  button = new ButtonItem_1('showMessage', 'Show Message');
  $addClickHandler_1(button, new TestMessageCenterView$1_0(optionMenu, severityMenu, conciseMessageItem, detailsMessageItem, exceptionItem));
  form = new DynamicForm_0;
  $isCreated_1(form)?$setProperty_0(form, 'width', 500):(form.config_0['width'] = 500 , undefined);
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [severityMenu, optionMenu, exceptionItem, conciseMessageItem, detailsMessageItem, button]));
  $addMember(this, form);
}
;
function TestMessageCenterView$1_0(val$optionMenu, val$severityMenu, val$conciseMessageItem, val$detailsMessageItem, val$exceptionItem){
  this.val$optionMenu = val$optionMenu;
  this.val$severityMenu = val$severityMenu;
  this.val$conciseMessageItem = val$conciseMessageItem;
  this.val$detailsMessageItem = val$detailsMessageItem;
  this.val$exceptionItem = val$exceptionItem;
}

defineSeed(3712, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), TestMessageCenterView$1_0);
_.onClick_0 = function onClick_180(event_0){
  var conciseMessage, depth, detailsMessage, exceptionDepth, msg, optString, optString$index, optString$max, options, optionsArray, severity, t;
  options = noneOf(Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit);
  optionsArray = $getValues(this.val$optionMenu);
  if (optionsArray != null && optionsArray.length > 0) {
    for (optString$index = 0 , optString$max = optionsArray.length; optString$index < optString$max; ++optString$index) {
      optString = optionsArray[optString$index];
      $add_5(options, ($clinit_Message$Option() , dynamicCast(valueOf(($clinit_Message$Option$Map() , $MAP_136), optString), Q$Message$Option)));
    }
  }
  severity = valueOf_146($getValueAsString_4(this.val$severityMenu));
  conciseMessage = this.val$conciseMessageItem.getValueAsString();
  detailsMessage = this.val$detailsMessageItem.getValueAsString();
  exceptionDepth = dynamicCast($getValue_0(this.val$exceptionItem), Q$Number);
  if (!!exceptionDepth && exceptionDepth.intValue() > 0) {
    t = null;
    for (depth = exceptionDepth.intValue(); depth > 0; --depth) {
      !t?(t = new Throwable_1(detailsMessage)):(t = new Throwable_2('Exception at depth #' + depth, t));
    }
    msg = new Message_5(conciseMessage, t, severity, options);
  }
   else {
    msg = new Message_3(conciseMessage, detailsMessage, severity, options);
  }
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), msg);
}
;
_.val$conciseMessageItem = null;
_.val$detailsMessageItem = null;
_.val$exceptionItem = null;
_.val$optionMenu = null;
_.val$severityMenu = null;
function TestNumberFormatView_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
}

defineSeed(3713, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$Enhanced]), TestNumberFormatView_0);
_.onDraw_0 = function onDraw_60(){
  var button, form, resultsUnitItem, resultsValueItem, textItem, unit, unit$iterator, unitsChoices, unitsMenu;
  unitsChoices = new LinkedHashMap_0;
  for (unit$iterator = new EnumSet$EnumSetImpl$IteratorImpl_0(allOf(Lorg_rhq_core_domain_measurement_MeasurementUnits_2_classLit)); unit$iterator.i < unit$iterator.this$1.all.length;) {
    unit = dynamicCast($next_3(unit$iterator), Q$MeasurementUnits);
    $put_1(unitsChoices, unit.name_0, unit.name_0);
  }
  unitsMenu = new SelectItem_2('unitsItem', 'Units');
  unitsMenu.setValueMap_0(unitsChoices);
  $setDefaultValue_1(unitsMenu, ($clinit_MeasurementUnits() , BYTES).name_0);
  textItem = new TextItem_3('valueItem', 'Value');
  resultsValueItem = new StaticTextItem_2('resultsValue', 'Results Value');
  resultsUnitItem = new StaticTextItem_2('resultsUnits', 'Results Units');
  button = new ButtonItem_1('convertItem', 'Convert');
  $addClickHandler_1(button, new TestNumberFormatView$1_0(unitsMenu, textItem, resultsValueItem, resultsUnitItem));
  form = new DynamicForm_0;
  form.setItems(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItem_2_classLit, makeCastMap([Q$FormItem_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItem, [unitsMenu, textItem, button, resultsValueItem, resultsUnitItem]));
  $addMember(this, form);
}
;
function TestNumberFormatView$1_0(val$unitsMenu, val$textItem, val$resultsValueItem, val$resultsUnitItem){
  this.val$unitsMenu = val$unitsMenu;
  this.val$textItem = val$textItem;
  this.val$resultsValueItem = val$resultsValueItem;
  this.val$resultsUnitItem = val$resultsUnitItem;
}

defineSeed(3714, 1, makeCastMap([Q$EventHandler, Q$ClickHandler_0]), TestNumberFormatView$1_0);
_.onClick_0 = function onClick_181(event_0){
  var units, value, vu;
  units = valueOf_100($getValueAsString_4(this.val$unitsMenu));
  value = this.val$textItem.getValueAsString();
  vu = parse(value, units);
  $setValue_7(this.val$resultsValueItem, '' + vu.value_0.value_0);
  $setValue_7(this.val$resultsUnitItem, vu.units.name_0);
}
;
_.val$resultsUnitItem = null;
_.val$resultsValueItem = null;
_.val$textItem = null;
_.val$unitsMenu = null;
function $clinit_TestTopView(){
  $clinit_TestTopView = nullMethod;
  $clinit_BaseWidget();
  VIEW_ID_32 = new ViewName_0('Test');
  INVENTORY_SECTION_VIEW_ID = new ViewName_0('Inventory');
  PAGE_RESOURCE_SELECTOR = new ViewName_0('ResourceSelector');
  PAGE_TYPE_TREE = new ViewName_0('TypeTree');
  PAGE_SEARCH_BAR = new ViewName_0('SearchBar');
  CONFIGURATION_SECTION_VIEW_ID = new ViewName_0('Configuration');
  PAGE_CONFIG_EDITOR = new ViewName_0('ConfigEditor');
  PAGE_READONLY_CONFIG_EDITOR = new ViewName_0('ReadOnlyConfigEditor');
  PAGE_GROUP_CONFIG_EDITOR = new ViewName_0('GroupConfigEditor');
  PAGE_READONLY_GROUP_CONFIG_EDITOR = new ViewName_0('ReadOnlyGroupConfigEditor');
  SERVERACCESS_SECTION_VIEW_ID = new ViewName_0('ServerAccess');
  PAGE_REMOTE_SERVICE_STATISTICS = new ViewName_0('RemoteServiceStatistics');
  PAGE_SQL = new ViewName_0('SQL');
  PAGE_HIBERNATE = new ViewName_0('Hibernate');
  PAGE_ENTITY_BROWSER = new ViewName_0('EntityBrowser');
  PAGE_ADMIN_CONTROL = new ViewName_0('AdminControl');
  PAGE_EMAIL = new ViewName_0('EmailTest');
  PAGE_AGENT = new ViewName_0('AgentConnectivityTest');
  PAGE_USER_PREFERENCES = new ViewName_0('UserPreferences');
  MISC_SECTION_VIEW_ID = new ViewName_0('Misc');
  PAGE_MESSAGE_CENTER_TEST = new ViewName_0('MessageCenterTest');
  PAGE_NUMBER_FORMAT_TEST = new ViewName_0('NumberFormatTest');
}

function TestTopView_0(){
  $clinit_TestTopView();
  AbstractSectionedLeftNavigationView_0.call(this, VIEW_ID_32.name_0);
}

defineSeed(3728, 1581, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$BookmarkableView, Q$InitializableView, Q$Enhanced, Q$EnhancedHLayout]), TestTopView_0);
_.defaultView = function defaultView_3(){
  var label, titleBar, vLayout;
  vLayout = new EnhancedVLayout_0;
  $isCreated_1(vLayout)?$setProperty_3(vLayout, 'width', '100%'):(vLayout.config_0['width'] = '100%' , undefined);
  titleBar = new TitleBar_0(($clinit_Enhanced() , 'Test'));
  $addMember(vLayout, titleBar);
  label = new Label_4('This section contains pages for testing various GUI components.');
  $setPadding(label, valueOf_44(10));
  $addMember(vLayout, label);
  return vLayout;
}
;
_.getNavigationSections = function getNavigationSections_3(){
  var configurationSection, inventorySection, miscSection, sections, serverAccessSection, resourceSelectorItem, typeTreeItem, searchBarItem, configEditorItem, readOnlyConfigEditorItem, groupConfigEditorItem, readOnlyGroupConfigEditorItem, userPrefsItem, remoteServiceStatisticsItem, sqlItem, hibernateItem, entityBrowserItem, adminControlItem, emailItem, agentItem, messageCenterItem, numberFormatItem;
  sections = new ArrayList_0;
  inventorySection = (resourceSelectorItem = new NavigationItem_0(PAGE_RESOURCE_SELECTOR, null, new TestTopView$1_0) , typeTreeItem = new NavigationItem_0(PAGE_TYPE_TREE, null, new TestTopView$2_0) , searchBarItem = new NavigationItem_0(PAGE_SEARCH_BAR, null, new TestTopView$3_0) , new NavigationSection_0(INVENTORY_SECTION_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [resourceSelectorItem, typeTreeItem, searchBarItem])));
  setCheck(sections.array, sections.size_0++, inventorySection);
  configurationSection = (configEditorItem = new NavigationItem_0(PAGE_CONFIG_EDITOR, null, new TestTopView$4_0) , readOnlyConfigEditorItem = new NavigationItem_0(PAGE_READONLY_CONFIG_EDITOR, null, new TestTopView$5_0) , groupConfigEditorItem = new NavigationItem_0(PAGE_GROUP_CONFIG_EDITOR, null, new TestTopView$6_0) , readOnlyGroupConfigEditorItem = new NavigationItem_0(PAGE_READONLY_GROUP_CONFIG_EDITOR, null, new TestTopView$7_0) , new NavigationSection_0(CONFIGURATION_SECTION_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [configEditorItem, readOnlyConfigEditorItem, groupConfigEditorItem, readOnlyGroupConfigEditorItem])));
  setCheck(sections.array, sections.size_0++, configurationSection);
  serverAccessSection = (userPrefsItem = new NavigationItem_0(PAGE_USER_PREFERENCES, null, new TestTopView$8_0) , remoteServiceStatisticsItem = new NavigationItem_0(PAGE_REMOTE_SERVICE_STATISTICS, null, new TestTopView$9_0) , sqlItem = new NavigationItem_0(PAGE_SQL, null, new TestTopView$10_0) , hibernateItem = new NavigationItem_0(PAGE_HIBERNATE, null, new TestTopView$11_0) , entityBrowserItem = new NavigationItem_0(PAGE_ENTITY_BROWSER, null, new TestTopView$12_0) , adminControlItem = new NavigationItem_0(PAGE_ADMIN_CONTROL, null, new TestTopView$13_0) , emailItem = new NavigationItem_0(PAGE_EMAIL, null, new TestTopView$14_0) , agentItem = new NavigationItem_0(PAGE_AGENT, null, new TestTopView$15_0) , new NavigationSection_0(SERVERACCESS_SECTION_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [remoteServiceStatisticsItem, sqlItem, hibernateItem, entityBrowserItem, adminControlItem, emailItem, agentItem, userPrefsItem])));
  setCheck(sections.array, sections.size_0++, serverAccessSection);
  miscSection = (messageCenterItem = new NavigationItem_0(PAGE_MESSAGE_CENTER_TEST, null, new TestTopView$16_0) , numberFormatItem = new NavigationItem_0(PAGE_NUMBER_FORMAT_TEST, null, new TestTopView$17_0) , new NavigationSection_0(MISC_SECTION_VIEW_ID, initValues(_3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$NavigationItem_$1]), Q$NavigationItem, [messageCenterItem, numberFormatItem])));
  setCheck(sections.array, sections.size_0++, miscSection);
  return sections;
}
;
var CONFIGURATION_SECTION_VIEW_ID, INVENTORY_SECTION_VIEW_ID, MISC_SECTION_VIEW_ID, PAGE_ADMIN_CONTROL, PAGE_AGENT, PAGE_CONFIG_EDITOR, PAGE_EMAIL, PAGE_ENTITY_BROWSER, PAGE_GROUP_CONFIG_EDITOR, PAGE_HIBERNATE, PAGE_MESSAGE_CENTER_TEST, PAGE_NUMBER_FORMAT_TEST, PAGE_READONLY_CONFIG_EDITOR, PAGE_READONLY_GROUP_CONFIG_EDITOR, PAGE_REMOTE_SERVICE_STATISTICS, PAGE_RESOURCE_SELECTOR, PAGE_SEARCH_BAR, PAGE_SQL, PAGE_TYPE_TREE, PAGE_USER_PREFERENCES, SERVERACCESS_SECTION_VIEW_ID, VIEW_ID_32;
function TestTopView$1_0(){
}

defineSeed(3729, 1, {}, TestTopView$1_0);
_.createView = function createView_83(){
  return new ResourceSelector_0;
}
;
function TestTopView$10_0(){
}

defineSeed(3730, 1, {}, TestTopView$10_0);
_.createView = function createView_84(){
  return new FullHTMLPane_0('/admin/test/sql.jsp');
}
;
function TestTopView$11_0(){
}

defineSeed(3731, 1, {}, TestTopView$11_0);
_.createView = function createView_85(){
  return new FullHTMLPane_0('/admin/test/hibernate.jsp');
}
;
function TestTopView$12_0(){
}

defineSeed(3732, 1, {}, TestTopView$12_0);
_.createView = function createView_86(){
  return new FullHTMLPane_0('/admin/test/browser.jsp');
}
;
function TestTopView$13_0(){
}

defineSeed(3733, 1, {}, TestTopView$13_0);
_.createView = function createView_87(){
  return new FullHTMLPane_0('/admin/test/control.jsp');
}
;
function TestTopView$14_0(){
}

defineSeed(3734, 1, {}, TestTopView$14_0);
_.createView = function createView_88(){
  return new FullHTMLPane_0('/admin/test/email.jsp');
}
;
function TestTopView$15_0(){
}

defineSeed(3735, 1, {}, TestTopView$15_0);
_.createView = function createView_89(){
  return new FullHTMLPane_0('/admin/test/agent.jsp');
}
;
function TestTopView$16_0(){
}

defineSeed(3736, 1, {}, TestTopView$16_0);
_.createView = function createView_90(){
  return new TestMessageCenterView_0;
}
;
function TestTopView$17_0(){
}

defineSeed(3737, 1, {}, TestTopView$17_0);
_.createView = function createView_91(){
  return new TestNumberFormatView_0;
}
;
function TestTopView$2_0(){
}

defineSeed(3738, 1, {}, TestTopView$2_0);
_.createView = function createView_92(){
  return new ResourceTypeTreeView_2;
}
;
function TestTopView$3_0(){
}

defineSeed(3739, 1, {}, TestTopView$3_0);
_.createView = function createView_93(){
  return new TestSearchBarView_0;
}
;
function TestTopView$4_0(){
}

defineSeed(3740, 1, {}, TestTopView$4_0);
_.createView = function createView_94(){
  return new TestConfigurationView_0;
}
;
function TestTopView$5_0(){
}

defineSeed(3741, 1, {}, TestTopView$5_0);
_.createView = function createView_95(){
  return new TestReadOnlyConfigurationView_0;
}
;
function TestTopView$6_0(){
}

defineSeed(3742, 1, {}, TestTopView$6_0);
_.createView = function createView_96(){
  return new TestGroupConfigurationView_0;
}
;
function TestTopView$7_0(){
}

defineSeed(3743, 1, {}, TestTopView$7_0);
_.createView = function createView_97(){
  return new TestReadOnlyGroupConfigurationView_0;
}
;
function TestTopView$8_0(){
}

defineSeed(3744, 1, {}, TestTopView$8_0);
_.createView = function createView_98(){
  return new TestUserPreferencesView_0;
}
;
function TestTopView$9_0(){
}

defineSeed(3745, 1, {}, TestTopView$9_0);
_.createView = function createView_99(){
  return new TestRemoteServiceStatisticsView_0;
}
;
function $clinit_TestUserPreferencesView(){
  $clinit_TestUserPreferencesView = nullMethod;
  $clinit_BaseWidget();
  defaultSorts_1 = initValues(_3Lcom_smartgwt_client_data_SortSpecifier_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$SortSpecifier, [new SortSpecifier_0('Name', ($clinit_SortDirection() , DESCENDING))]);
}

function $refresh_26(this$static){
  $refresh(this$static, false);
  $setRecords(this$static.listGrid, $transform_3(this$static.prefs.userConfiguration));
  $refreshTableInfo(this$static);
}

function $transform_3(configuration){
  var entry, entry$iterator, i, results;
  results = initDim(_3Lcom_smartgwt_client_widgets_grid_ListGridRecord_2_classLit, makeCastMap([Q$Record_$1, Q$ListGridRecord_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridRecord, configuration.properties.size_1(), 0);
  i = 0;
  for (entry$iterator = configuration.properties.entrySet().iterator(); entry$iterator.hasNext();) {
    entry = dynamicCast(entry$iterator.next_0(), Q$Map$Entry);
    setCheck(results, i++, $transform_4(dynamicCast(entry.getValue_1(), Q$Property)));
  }
  return results;
}

function $transform_4(prop){
  var classname, record, value;
  if (instanceOf(prop, Q$PropertySimple)) {
    value = dynamicCast(prop, Q$PropertySimple).stringValue;
  }
   else {
    classname = prop.___clazz$.typeName;
    value = '(value of type ' + $substring(classname, classname.lastIndexOf('.') + 1) + ')';
  }
  record = new ListGridRecord_0;
  $setAttribute_3(record, 'id', prop.id);
  $setAttribute_13(record, 'Name', prop.name_0);
  record.jsObj['Value'] = value;
  return record;
}

function TestUserPreferencesView_0(){
  $clinit_TestUserPreferencesView();
  Table_6.call(this, 'User Preferences (' + ($clinit_UserSessionManager() , $clinit_UserSessionManager() , sessionSubject_0).name_0 + ')', null, defaultSorts_1, null, false);
  this.prefs = userPreferences;
}

defineSeed(3746, 1605, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), TestUserPreferencesView_0);
_.configureTable = function configureTable_70(){
  var id, name_0, value;
  id = new ListGridField_3('id', 'ID');
  name_0 = new ListGridField_3('Name', 'Name');
  value = new ListGridField_3('Value', 'Value');
  id.jsObj['width'] = '10%';
  name_0.jsObj['width'] = '45%';
  name_0.jsObj['width'] = '45%';
  $setFields_1(this.listGrid, initValues(_3Lcom_smartgwt_client_widgets_grid_ListGridField_2_classLit, makeCastMap([Q$ListGridField_$1, Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$ListGridField, [id, name_0, value]));
  $refresh_26(this);
  $addTableAction(this, 'Export To CSV', null, null, new TestUserPreferencesView$1_0(this, ($clinit_TableActionEnablement() , ALWAYS)));
}
;
_.getDefaultSelectionStyle = function getDefaultSelectionStyle_5(){
  return $clinit_SelectionStyle() , NONE_4;
}
;
_.refresh_0 = function refresh_46(){
  $refresh_26(this);
}
;
_.prefs = null;
var defaultSorts_1;
function TestUserPreferencesView$1_0(this$0, $anonymous0){
  this.this$0 = this$0;
  this.enablement = $anonymous0;
}

defineSeed(3747, 1608, {}, TestUserPreferencesView$1_0);
_.executeAction = function executeAction_107(selection, actionValue){
  var csv, i, record, records, recordsSize, self_0;
  csv = new StringBuilder_0;
  $append_7($append_12($append_12($append_12($append_12(($append_1(csv.data_0, 'id') , csv), '~'), 'Name'), '~'), 'Value'), 10);
  records = $getRecordList(this.this$0.listGrid);
  recordsSize = records.getLength_0();
  for (i = 0; i < recordsSize; ++i) {
    record = records.get_1(i);
    $append_7($append_12($append_12($append_12($append_12($append_12(csv, getAttribute(record.jsObj, 'id')), '~'), getAttribute(record.jsObj, 'Name')), '~'), getAttribute(record.jsObj, 'Value')), 10);
  }
  self_0 = (new TestUserPreferencesView$MessageWindow_0('<pre>' + $toString_1(csv.data_0) + '<\/pre>')).getOrCreateJsObj();
  self_0.show();
  $refreshTableInfo(this.this$0);
}
;
_.this$0 = null;
function TestUserPreferencesView$MessageWindow_0(message){
  $clinit_BaseWidget();
  var htmlPane;
  Window_1.call(this);
  htmlPane = new HTMLPane_0;
  $setMargin(htmlPane, valueOf_44(10));
  $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultWidth', 600):(htmlPane.config_0['defaultWidth'] = 600 , undefined);
  $isCreated_1(htmlPane)?$setProperty_0(htmlPane, 'defaultHeight', 400):(htmlPane.config_0['defaultHeight'] = 400 , undefined);
  $isCreated_1(htmlPane)?$setProperty_3(htmlPane, 'contents', message):(htmlPane.config_0['contents'] = message , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'title', 'Export To CSV'):(this.config_0['title'] = 'Export To CSV' , undefined);
  $setShowMinimizeButton(this, ($clinit_Boolean() , $clinit_Boolean() , FALSE));
  $setShowMaximizeButton(this, TRUE);
  $setShowCloseButton(this, TRUE);
  $setDismissOnEscape(this, FALSE);
  $setIsModal(this, TRUE);
  $setShowModalMask(this, TRUE);
  $setAutoSize(this, TRUE);
  $setAutoCenter(this, TRUE);
  $setShowResizer(this, TRUE);
  $setCanDragResize_0(this, TRUE);
  $centerInPage(this);
  $addCloseClickHandler(this, new TestUserPreferencesView$MessageWindow$1_0(this));
  $addItem(this, htmlPane);
}

defineSeed(3748, 444, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout]), TestUserPreferencesView$MessageWindow_0);
function TestUserPreferencesView$MessageWindow$1_0(this$1){
  this.this$1 = this$1;
}

defineSeed(3749, 1, makeCastMap([Q$EventHandler, Q$CloseClickHandler]), TestUserPreferencesView$MessageWindow$1_0);
_.onCloseClick_0 = function onCloseClick_24(event_0){
  $markForDestroy(this.this$1);
}
;
_.this$1 = null;
function addPropertyDefinition(configDef, propDef, orderIndex){
  propDef.order = orderIndex;
  $put_6(configDef, propDef);
}

function createBooleanPropDef(){
  var propDef;
  propDef = new PropertyDefinitionSimple_1('Boolean', 'a summary Boolean simple prop', false, ($clinit_PropertySimpleType() , BOOLEAN_2));
  $setDisplayName(propDef, propDef.name_0);
  propDef.summary = true;
  return propDef;
}

function createConfiguration(){
  var configuration, myString2Prop, openPropMap1, openPropMap2, propMap1, propMap2, propMap3, propMap4, propMap5, string2Prop;
  configuration = new Configuration_0;
  configuration.notes = 'a test config';
  configuration.version_0 = P1_longLit;
  $put_4(configuration, new PropertySimple_1('String1', 'blah'));
  string2Prop = new PropertySimple_1('String2', "a really, really, really, really, really long value that won't fit in the text input box");
  configuration.properties.put(string2Prop.name_0, string2Prop);
  string2Prop.configuration = configuration;
  $put_4(configuration, new PropertySimple_1('LongString', 'blah blah blah\nblah blah blah\nblah blah blah'));
  $put_4(configuration, new PropertySimple_1('Password', 'ou812'));
  $put_4(configuration, new PropertySimple_1('Boolean', ($clinit_Boolean() , $clinit_Boolean() , FALSE)));
  $put_4(configuration, new PropertySimple_1('Integer', valueOf_44(2147483647)));
  $put_4(configuration, new PropertySimple_1('Long', valueOf_45(P7fffffffffffffff_longLit)));
  $put_4(configuration, new PropertySimple_1('Float', new Double_0(3.141592653589793)));
  $put_4(configuration, new PropertySimple_1('StringEnum1', 'PA'));
  $put_4(configuration, new PropertySimple_1('StringEnum2', 'blue'));
  propMap1 = new PropertyMap_1('MapOfSimples');
  $put_5(propMap1, new PropertySimple_1('String1', 'One'));
  $put_5(propMap1, new PropertySimple_1('String2', 'Two'));
  $put_5(propMap1, new PropertySimple_1('Boolean', TRUE));
  $put_5(propMap1, new PropertySimple_1('Integer', valueOf_44(11)));
  configuration.properties.put(propMap1.name_0, propMap1);
  propMap1.configuration = configuration;
  openPropMap1 = new PropertyMap_1('OpenMapOfSimples');
  $put_5(openPropMap1, new PropertySimple_1('PROCESSOR_ARCHITECTURE', 'x86'));
  $put_5(openPropMap1, new PropertySimple_1('PROCESSOR_IDENTIFIER', 'x86 Family 6 Model 15 Stepping 6, GenuineIntel'));
  $put_5(openPropMap1, new PropertySimple_1('PROCESSOR_LEVEL', '6'));
  $put_5(openPropMap1, new PropertySimple_1('PROCESSOR_REVISION', '0f06'));
  configuration.properties.put(openPropMap1.name_0, openPropMap1);
  openPropMap1.configuration = configuration;
  openPropMap2 = new PropertyMap_1('ReadOnlyOpenMapOfSimples');
  $put_5(openPropMap2, new PropertySimple_1('ANT_HOME', 'C:\\opt\\ant-1.6.5'));
  $put_5(openPropMap2, new PropertySimple_1('ANT_OPTS', '-Xms128M -Xmx256M'));
  configuration.properties.put(openPropMap2.name_0, openPropMap2);
  openPropMap2.configuration = configuration;
  $put_4(configuration, new PropertyList_2('ListOfSimples', initValues(_3Lorg_rhq_core_domain_configuration_Property_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Property, [new PropertySimple_1('integer', '18'), new PropertySimple_1('integer', '127'), new PropertySimple_1('integer', '311'), new PropertySimple_1('integer', '2'), new PropertySimple_1('integer', '301'), new PropertySimple_1('integer', '79'), new PropertySimple_1('integer', '62')])));
  propMap2 = new PropertyMap_1('MapOfSimplesInList');
  $put_5(propMap2, new PropertySimple_1('String1', 'Uno'));
  $put_5(propMap2, new PropertySimple_1('String2', 'Dos'));
  $put_5(propMap2, new PropertySimple_1('Boolean', TRUE));
  $put_5(propMap2, new PropertySimple_1('Integer', valueOf_44(-2147483648)));
  propMap3 = new PropertyMap_1('MapOfSimplesInList');
  $put_5(propMap3, new PropertySimple_1('String1', 'Un'));
  $put_5(propMap3, new PropertySimple_1('String2', 'Deux'));
  $put_5(propMap3, new PropertySimple_1('Boolean', FALSE));
  $put_5(propMap3, new PropertySimple_1('Integer', valueOf_44(2147483647)));
  $put_4(configuration, new PropertyList_2('ListOfMaps', initValues(_3Lorg_rhq_core_domain_configuration_Property_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Property, [propMap2, propMap3])));
  propMap4 = new PropertyMap_1('MapOfSimplesInReadOnlyList');
  $put_5(propMap4, new PropertySimple_1('String1', 'A'));
  $put_5(propMap4, new PropertySimple_1('String2', 'B'));
  $put_5(propMap4, new PropertySimple_1('Boolean', FALSE));
  $put_5(propMap4, new PropertySimple_1('Integer', valueOf_44(999)));
  propMap5 = new PropertyMap_1('MapOfSimplesInReadOnlyList');
  $put_5(propMap5, new PropertySimple_1('String1', 'a'));
  $put_5(propMap5, new PropertySimple_1('String2', 'b'));
  $put_5(propMap5, new PropertySimple_1('Boolean', TRUE));
  $put_5(propMap5, new PropertySimple_1('Integer', valueOf_44(0)));
  $put_4(configuration, new PropertyList_2('ReadOnlyListOfMaps', initValues(_3Lorg_rhq_core_domain_configuration_Property_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Property, [propMap4, propMap5])));
  $put_4(configuration, new PropertySimple_1('myString1', 'grouped String 1'));
  myString2Prop = new PropertySimple_1('myString2', 'grouped String 2');
  configuration.properties.put(myString2Prop.name_0, myString2Prop);
  myString2Prop.configuration = configuration;
  $put_4(configuration, new PropertySimple_1('myString3', 'strings are cool'));
  $put_4(configuration, new PropertySimple_1('myEnum', 'Burlington'));
  return configuration;
}

function createConfigurationDefinition(){
  var configDef, defaultConfiguration, defaultTemplate, enumExample, listOfSimplesPropDef, listPropDef, mapInListPropDef, mapInReadOnlyListPropDef, mapPropDef, myEnums, myString, myString2, myString3, openMapPropDef, orderIndex, propDef, propDefEnums, propertyDefinitions, propertyGroupDefinition, propertyGroupDefinition2, readOnlyListPropDef, readOnlyOpenMapPropDef, simplePropDef, longPropDef;
  configDef = new ConfigurationDefinition_1('TestConfig', 'a test config');
  defaultTemplate = new ConfigurationTemplate_1;
  defaultTemplate.configurationDefinition = configDef;
  (!configDef.templates && (configDef.templates = new LinkedHashMap_0) , configDef.templates).put(defaultTemplate.name_0, defaultTemplate);
  defaultConfiguration = new Configuration_0;
  defaultTemplate.configuration = defaultConfiguration;
  propertyDefinitions = new HashMap_0;
  configDef.propertyDefinitions = propertyDefinitions;
  orderIndex = 0;
  simplePropDef = createStringPropDef1();
  addPropertyDefinition(configDef, simplePropDef, orderIndex++);
  simplePropDef = createStringPropDef2();
  addPropertyDefinition(configDef, simplePropDef, orderIndex++);
  simplePropDef = new PropertyDefinitionSimple_1('LongString', 'a Long String simple prop', false, ($clinit_PropertySimpleType() , LONG_STRING));
  $setDisplayName(simplePropDef, simplePropDef.name_0);
  addPropertyDefinition(configDef, simplePropDef, orderIndex++);
  simplePropDef = new PropertyDefinitionSimple_1('Password', 'a Password simple prop', false, PASSWORD_0);
  $setDisplayName(simplePropDef, simplePropDef.name_0);
  addPropertyDefinition(configDef, simplePropDef, orderIndex++);
  simplePropDef = createBooleanPropDef();
  addPropertyDefinition(configDef, simplePropDef, orderIndex++);
  simplePropDef = createIntegerPropDef();
  addPropertyDefinition(configDef, simplePropDef, orderIndex++);
  simplePropDef = (longPropDef = new PropertyDefinitionSimple_1('Long', 'a summary Long simple prop', false, LONG_0) , $setDisplayName(longPropDef, longPropDef.name_0) , longPropDef.summary = true , longPropDef);
  addPropertyDefinition(configDef, simplePropDef, orderIndex++);
  simplePropDef = new PropertyDefinitionSimple_1('Float', 'a Float simple prop', false, FLOAT_2);
  $setDisplayName(simplePropDef, simplePropDef.name_0);
  addPropertyDefinition(configDef, simplePropDef, orderIndex++);
  simplePropDef = new PropertyDefinitionSimple_1('StringEnum1', 'a String enum prop with <=5 items - should be rendered as radio buttons', false, STRING_0);
  $setDisplayName(simplePropDef, simplePropDef.name_0);
  $put_4(defaultConfiguration, new PropertySimple_1('StringEnum1', 'NJ'));
  propDefEnums = new ArrayList_0;
  $add_3(propDefEnums, new PropertyDefinitionEnumeration_1('NY', 'NY'));
  $add_3(propDefEnums, new PropertyDefinitionEnumeration_1('NJ', 'NJ'));
  $add_3(propDefEnums, new PropertyDefinitionEnumeration_1('PA', 'PA'));
  $setEnumeratedValues(simplePropDef, propDefEnums);
  addPropertyDefinition(configDef, simplePropDef, orderIndex++);
  simplePropDef = new PropertyDefinitionSimple_1('StringEnum2', 'a String enum prop with >5 items - should be rendered as a popup menu', false, STRING_0);
  $setDisplayName(simplePropDef, simplePropDef.name_0);
  $put_4(defaultConfiguration, new PropertySimple_1('StringEnum2', 'blue'));
  propDefEnums = new ArrayList_0;
  $add_3(propDefEnums, new PropertyDefinitionEnumeration_1('red', 'red'));
  $add_3(propDefEnums, new PropertyDefinitionEnumeration_1('orange', 'orange'));
  $add_3(propDefEnums, new PropertyDefinitionEnumeration_1('yellow', 'yellow'));
  $add_3(propDefEnums, new PropertyDefinitionEnumeration_1('green', 'green'));
  $add_3(propDefEnums, new PropertyDefinitionEnumeration_1('blue', 'blue'));
  $add_3(propDefEnums, new PropertyDefinitionEnumeration_1('purple', 'purple'));
  $setEnumeratedValues(simplePropDef, propDefEnums);
  addPropertyDefinition(configDef, simplePropDef, orderIndex++);
  mapPropDef = new PropertyDefinitionMap_1('MapOfSimples', 'a map of simples', false, initValues(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PropertyDefinition, []));
  $put_7(mapPropDef, createStringPropDef1());
  $put_7(mapPropDef, createStringPropDef2());
  $put_7(mapPropDef, createBooleanPropDef());
  $put_7(mapPropDef, createIntegerPropDef());
  $setDisplayName(mapPropDef, mapPropDef.name_0);
  addPropertyDefinition(configDef, mapPropDef, orderIndex++);
  openMapPropDef = new PropertyDefinitionMap_1('OpenMapOfSimples', 'an open map of simples', false, initValues(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PropertyDefinition, []));
  $setDisplayName(openMapPropDef, openMapPropDef.name_0);
  addPropertyDefinition(configDef, openMapPropDef, orderIndex++);
  readOnlyOpenMapPropDef = new PropertyDefinitionMap_1('ReadOnlyOpenMapOfSimples', 'a read-only open map of simples', false, initValues(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PropertyDefinition, []));
  $setDisplayName(readOnlyOpenMapPropDef, readOnlyOpenMapPropDef.name_0);
  readOnlyOpenMapPropDef.readOnly = true;
  addPropertyDefinition(configDef, readOnlyOpenMapPropDef, orderIndex++);
  listOfSimplesPropDef = new PropertyDefinitionList_1('ListOfSimples', 'a list of Integer simples', true, new PropertyDefinitionSimple_1('integer', 'an integer', false, INTEGER_1));
  $setDisplayName(listOfSimplesPropDef, listOfSimplesPropDef.name_0);
  $setMax_1(listOfSimplesPropDef, listOfSimplesPropDef.max_0);
  $setMin_1(listOfSimplesPropDef, listOfSimplesPropDef.min_0);
  addPropertyDefinition(configDef, listOfSimplesPropDef, orderIndex++);
  mapInListPropDef = new PropertyDefinitionMap_1('MapOfSimplesInList', 'a map of simples in a list', false, initValues(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PropertyDefinition, []));
  $put_7(mapInListPropDef, createStringPropDef1());
  $put_7(mapInListPropDef, createStringPropDef2());
  $put_7(mapInListPropDef, createBooleanPropDef());
  $put_7(mapInListPropDef, createIntegerPropDef());
  $setDisplayName(mapInListPropDef, mapInListPropDef.name_0);
  listPropDef = new PropertyDefinitionList_1('ListOfMaps', 'a list of maps', true, mapInListPropDef);
  $setDisplayName(listPropDef, listPropDef.name_0);
  addPropertyDefinition(configDef, listPropDef, orderIndex++);
  mapInReadOnlyListPropDef = new PropertyDefinitionMap_1('MapOfSimplesInReadOnlyList', 'a map of simples in a list', false, initValues(_3Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$PropertyDefinition, []));
  propDef = createStringPropDef1();
  propDef.readOnly = true;
  $put_7(mapInReadOnlyListPropDef, propDef);
  propDef = createStringPropDef2();
  propDef.readOnly = true;
  $put_7(mapInReadOnlyListPropDef, propDef);
  propDef = createBooleanPropDef();
  propDef.readOnly = true;
  $put_7(mapInReadOnlyListPropDef, propDef);
  propDef = createIntegerPropDef();
  propDef.readOnly = true;
  $put_7(mapInReadOnlyListPropDef, propDef);
  $setDisplayName(mapInReadOnlyListPropDef, mapInReadOnlyListPropDef.name_0);
  readOnlyListPropDef = new PropertyDefinitionList_1('ReadOnlyListOfMaps', 'a read-only list of maps', true, mapInReadOnlyListPropDef);
  $setDisplayName(readOnlyListPropDef, readOnlyListPropDef.name_0);
  readOnlyListPropDef.readOnly = true;
  addPropertyDefinition(configDef, readOnlyListPropDef, orderIndex++);
  propertyGroupDefinition = new PropertyGroupDefinition_1('myGroup');
  $setDisplayName_0(propertyGroupDefinition, propertyGroupDefinition.name_0);
  propertyGroupDefinition.description = 'this is an example group';
  myString = new PropertyDefinitionSimple_1('myString1', 'my little string', true, STRING_0);
  $setDisplayName(myString, myString.name_0);
  myString.summary = true;
  addPropertyDefinition(configDef, myString, orderIndex++);
  myString.propertyGroupDefinition = propertyGroupDefinition;
  myString2 = new PropertyDefinitionSimple_1('myString2', 'my other little string', true, STRING_0);
  $setDisplayName(myString2, myString2.name_0);
  myString2.summary = true;
  addPropertyDefinition(configDef, myString2, orderIndex++);
  myString2.propertyGroupDefinition = propertyGroupDefinition;
  propertyGroupDefinition2 = new PropertyGroupDefinition_1('myGroup2');
  $setDisplayName_0(propertyGroupDefinition2, propertyGroupDefinition2.name_0);
  propertyGroupDefinition2.description = 'this is another example group';
  myString3 = new PropertyDefinitionSimple_1('myString3', 'my third string', true, STRING_0);
  $setDisplayName(myString3, myString3.name_0);
  myString3.summary = true;
  addPropertyDefinition(configDef, myString3, orderIndex++);
  myString3.propertyGroupDefinition = propertyGroupDefinition2;
  enumExample = new PropertyDefinitionSimple_1('myEnum', 'a grouped enum prop with <=5 items', false, STRING_0);
  $setDisplayName(enumExample, enumExample.name_0);
  $put_4(defaultConfiguration, new PropertySimple_1('myEnum', 'Burlington'));
  myEnums = new ArrayList_0;
  $add_3(myEnums, new PropertyDefinitionEnumeration_1('Burlington', 'Burlington'));
  $add_3(myEnums, new PropertyDefinitionEnumeration_1('Camden', 'Camden'));
  $add_3(myEnums, new PropertyDefinitionEnumeration_1('Gloucester', 'Gloucester'));
  $setEnumeratedValues(enumExample, myEnums);
  addPropertyDefinition(configDef, enumExample, orderIndex++);
  enumExample.propertyGroupDefinition = propertyGroupDefinition2;
  return configDef;
}

function createIntegerPropDef(){
  var integerPropDef;
  integerPropDef = new PropertyDefinitionSimple_1('Integer', 'a summary Integer simple prop', false, ($clinit_PropertySimpleType() , INTEGER_1));
  $setDisplayName(integerPropDef, integerPropDef.name_0);
  integerPropDef.summary = true;
  return integerPropDef;
}

function createStringPropDef1(){
  var stringPropDef1;
  stringPropDef1 = new PropertyDefinitionSimple_1('String1', 'a String simple prop', false, ($clinit_PropertySimpleType() , STRING_0));
  $setDisplayName(stringPropDef1, stringPropDef1.name_0);
  return stringPropDef1;
}

function createStringPropDef2(){
  var stringPropDef2;
  stringPropDef2 = new PropertyDefinitionSimple_1('String2', 'a read-only required String simple prop', true, ($clinit_PropertySimpleType() , STRING_0));
  $setDisplayName(stringPropDef2, stringPropDef2.name_0);
  stringPropDef2.readOnly = true;
  return stringPropDef2;
}

function $createButtonBar_0(this$static){
  var toolStrip;
  toolStrip = new EnhancedToolStrip_0;
  $isCreated_1(toolStrip)?$setProperty_3(toolStrip, 'width', '100%'):(toolStrip.config_0['width'] = '100%' , undefined);
  $addMember(toolStrip, new LayoutSpacer_0);
  this$static.saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save'));
  $addClickHandler(this$static.saveButton, new TestConfigurationView$1_0(this$static));
  $disable(this$static.saveButton);
  $addMember(toolStrip, this$static.saveButton);
  $addSpacer(toolStrip, new ToolStripSpacer_0(40));
  return toolStrip;
}

function $createConfigurationEditor(this$static){
  var editor;
  editor = new ConfigurationEditor_1(this$static.configurationDefinition, this$static.configuration);
  editor.editorTitle = 'Test Configuration';
  $setAttribute_24(editor, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $add_6(editor.propertyValueChangeListeners, this$static);
  return editor;
}

function $getPropertyStrings(this$static, prop, str, indent){
  var map, propList, propMap, val, val$iterator, value;
  if (instanceOf(prop, Q$PropertySimple)) {
    value = dynamicCast(prop, Q$PropertySimple).stringValue;
    $append_12(str, indent + prop.name_0 + '=' + (value != null?value:'~~VALUE WAS NULL~~'));
    $append_1(str.data_0, '\n');
  }
   else if (instanceOf(prop, Q$PropertyMap)) {
    $append_12(str, indent + prop.name_0 + ' MAP:\n');
    propMap = dynamicCast(prop, Q$PropertyMap);
    map = (!propMap.map && (propMap.map = new LinkedHashMap_0) , propMap.map);
    for (val$iterator = map.values_0().iterator(); val$iterator.hasNext();) {
      val = dynamicCast(val$iterator.next_0(), Q$Property);
      $getPropertyStrings(this$static, val, str, indent + '   ');
    }
  }
   else if (instanceOf(prop, Q$PropertyList)) {
    $append_12(str, indent + prop.name_0 + ' LIST:\n');
    propList = dynamicCast(prop, Q$PropertyList);
    for (val$iterator = (!propList.list && (propList.list = new ArrayList_0) , propList.list).iterator(); val$iterator.hasNext();) {
      val = dynamicCast(val$iterator.next_0(), Q$Property);
      $getPropertyStrings(this$static, val, str, indent + '   ');
    }
  }
   else {
    $append_1(str.data_0, 'unknown prop type: ' + prop);
  }
}

function $reloadConfiguration(this$static){
  $disable(this$static.saveButton);
  if (this$static.editor) {
    $destroy_1(this$static.editor);
    $removeMember(this$static, this$static.editor);
    this$static.buttonBar.destroy_0();
    $removeMember(this$static, this$static.buttonBar);
  }
  this$static.editor = this$static.createConfigurationEditor();
  $addMember(this$static, this$static.editor);
  $addMember(this$static, $createButtonBar_0(this$static));
  $markForRedraw(this$static);
}

function $save_13(this$static){
  var allProps, c, prop, prop$iterator, str;
  str = new StringBuilder_1('=~pre~=');
  c = this$static.editor.configuration;
  allProps = c.properties;
  for (prop$iterator = allProps.values_0().iterator(); prop$iterator.hasNext();) {
    prop = dynamicCast(prop$iterator.next_0(), Q$Property);
    $getPropertyStrings(this$static, prop, str, '');
  }
  $append_1(str.data_0, '=~/pre~=');
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_1('Configuration updated.', $toString_1(str.data_0)));
  $reloadConfiguration(this$static);
}

function TestConfigurationView_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
}

defineSeed(3751, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$PropertyValueChangeListener, Q$Enhanced]), TestConfigurationView_0);
_.createConfigurationEditor = function createConfigurationEditor(){
  return $createConfigurationEditor(this);
}
;
_.onDraw_0 = function onDraw_61(){
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  this.buttonBar = $createButtonBar_0(this);
  this.configurationDefinition = createConfigurationDefinition();
  this.configuration = createConfiguration();
  $reloadConfiguration(this);
}
;
_.propertyValueChanged = function propertyValueChanged_9(event_0){
  var invalidPropertyNames, message, messageCenter;
  messageCenter = ($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0);
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    if (invalidPropertyNames.size_1() == 0) {
      $enable(this.saveButton);
      message = new Message_8('All properties now have valid values, so the configuration can now be saved.', ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
     else {
      $disable(this.saveButton);
      message = new Message_8('The following properties have invalid values: ' + $values(invalidPropertyNames) + ' - the values must be corrected before the configuration can be saved.', ($clinit_Message$Severity() , Error_2), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
    $notify(messageCenter, message);
  }
   else {
    $enable(this.saveButton);
  }
}
;
_.buttonBar = null;
_.configuration = null;
_.configurationDefinition = null;
_.editor = null;
_.saveButton = null;
function TestConfigurationView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3752, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), TestConfigurationView$1_0);
_.onClick = function onClick_182(clickEvent){
  $save_13(this.this$0);
}
;
_.this$0 = null;
function $createConfigurationEditor_0(this$static){
  var editor;
  editor = new GroupConfigurationEditor_0(this$static.configurationDefinition, this$static.memberConfigurations);
  editor.editorTitle = 'Test Group Configuration';
  $setAttribute_24(editor, 'overflow', ($clinit_Overflow() , AUTO).value_0, false);
  $add_6(editor.propertyValueChangeListeners, this$static);
  return editor;
}

function $reloadConfiguration_0(this$static){
  if (this$static.editor) {
    $destroy_1(this$static.editor);
    $removeMember(this$static, this$static.editor);
    this$static.buttonBar.destroy_0();
    $removeMember(this$static, this$static.buttonBar);
  }
  this$static.editor = this$static.createConfigurationEditor_0();
  $addMember(this$static, this$static.editor);
  $addMember(this$static, (this$static.buttonBar = new ToolStrip_0 , $setAttribute_24(this$static.buttonBar, 'width', '100%', true) , $addMember(this$static.buttonBar, new LayoutSpacer_0) , this$static.saveButton = new EnhancedIButton_1(($clinit_Enhanced() , 'Save')) , $addClickHandler(this$static.saveButton, new TestGroupConfigurationView$1_0(this$static)) , $disable(this$static.saveButton) , $addMember(this$static.buttonBar, this$static.saveButton) , $addSpacer(this$static.buttonBar, new ToolStripSpacer_0(40)) , this$static.buttonBar));
  $markForRedraw(this$static);
}

function $save_14(this$static){
  $notify(($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0), new Message_1('Member configurations updated.', 'Member configurations updated.'));
  $reloadConfiguration_0(this$static);
}

function TestGroupConfigurationView_0(){
  $clinit_BaseWidget();
  EnhancedVLayout_0.call(this);
}

defineSeed(3753, 1600, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$PropertyValueChangeListener, Q$Enhanced]), TestGroupConfigurationView_0);
_.createConfigurationEditor_0 = function createConfigurationEditor_0(){
  return $createConfigurationEditor_0(this);
}
;
_.onDraw_0 = function onDraw_62(){
  var configuration, i, memberConfiguration;
  $isCreated_1(this)?$setProperty_3(this, 'width', '100%'):(this.config_0['width'] = '100%' , undefined);
  $isCreated_1(this)?$setProperty_3(this, 'height', '100%'):(this.config_0['height'] = '100%' , undefined);
  this.configurationDefinition = createConfigurationDefinition();
  this.memberConfigurations = new ArrayList_1(2);
  for (i = 0; i < 2; ++i) {
    configuration = createConfiguration();
    memberConfiguration = new GroupMemberConfiguration_0(i, 'Member #' + i, configuration);
    $add_3(this.memberConfigurations, memberConfiguration);
  }
  $reloadConfiguration_0(this);
}
;
_.propertyValueChanged = function propertyValueChanged_10(event_0){
  var invalidPropertyNames, message, messageCenter;
  messageCenter = ($clinit_CoreGUI() , $clinit_CoreGUI() , messageCenter_0);
  if (event_0.invalidPropertySetChanged) {
    invalidPropertyNames = event_0.invalidPropertyNames;
    if (invalidPropertyNames.size_1() == 0) {
      $enable(this.saveButton);
      message = new Message_8('All properties now have valid values, so the configuration can now be saved.', ($clinit_Message$Severity() , Info), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
     else {
      $disable(this.saveButton);
      message = new Message_8('The following properties have invalid values: ' + $values(invalidPropertyNames) + ' - the values must be corrected before the configuration can be saved.', ($clinit_Message$Severity() , Error_2), of_0(($clinit_Message$Option() , Transient), initValues(_3Lorg_rhq_enterprise_gui_coregui_client_util_message_Message$Option_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Enum_$1, Q$Object_$1]), Q$Message$Option, [Sticky])));
    }
    $notify(messageCenter, message);
  }
   else {
    $enable(this.saveButton);
  }
}
;
_.buttonBar = null;
_.configurationDefinition = null;
_.editor = null;
_.memberConfigurations = null;
_.saveButton = null;
function TestGroupConfigurationView$1_0(this$0){
  this.this$0 = this$0;
}

defineSeed(3754, 1, makeCastMap([Q$EventHandler, Q$ClickHandler]), TestGroupConfigurationView$1_0);
_.onClick = function onClick_183(clickEvent){
  $save_14(this.this$0);
}
;
_.this$0 = null;
function TestReadOnlyConfigurationView_0(){
  $clinit_BaseWidget();
  TestConfigurationView_0.call(this);
}

defineSeed(3755, 3751, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$PropertyValueChangeListener, Q$Enhanced]), TestReadOnlyConfigurationView_0);
_.createConfigurationEditor = function createConfigurationEditor_1(){
  var editor;
  editor = $createConfigurationEditor(this);
  editor.editorTitle = 'Test Read-Only Configuration';
  editor.readOnly = true;
  return editor;
}
;
function TestReadOnlyGroupConfigurationView_0(){
  $clinit_BaseWidget();
  TestGroupConfigurationView_0.call(this);
}

defineSeed(3756, 3753, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$VLayout, Q$PropertyValueChangeListener, Q$Enhanced]), TestReadOnlyGroupConfigurationView_0);
_.createConfigurationEditor_0 = function createConfigurationEditor_2(){
  var editor;
  editor = $createConfigurationEditor_0(this);
  editor.editorTitle = 'Test Read-Only Group Configuration';
  editor.readOnly = true;
  return editor;
}
;
function TestSearchBarView_0(){
  $clinit_ResourceSearchView();
  ResourceSearchView_1.call(this, null, null, false, initValues(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, []));
}

defineSeed(3757, 2557, makeCastMap([Q$HasAttachHandlers, Q$HasHandlers, Q$EventListener, Q$HasVisibility, Q$IsWidget, Q$UIObject, Q$Widget, Q$BaseWidget, Q$Canvas, Q$HasClickHandlers, Q$HasDoubleClickHandlers, Q$HasDragMoveHandlers, Q$HasDragRepositionMoveHandlers, Q$HasDragRepositionStartHandlers, Q$HasDragRepositionStopHandlers, Q$HasDragResizeMoveHandlers, Q$HasDragResizeStartHandlers, Q$HasDragResizeStopHandlers, Q$HasDragStartHandlers, Q$HasDragStopHandlers, Q$HasDropHandlers, Q$HasDropMoveHandlers, Q$HasDropOutHandlers, Q$HasDropOverHandlers, Q$HasFocusChangedHandlers, Q$HasHoverHandlers, Q$HasHoverHiddenHandlers, Q$HasKeyDownHandlers, Q$HasKeyPressHandlers, Q$HasMouseDownHandlers, Q$HasMouseMoveHandlers, Q$HasMouseOutHandlers, Q$HasMouseOverHandlers, Q$HasMouseStillDownHandlers, Q$HasMouseUpHandlers, Q$HasMouseWheelHandlers, Q$HasMovedHandlers, Q$HasParentMovedHandlers, Q$HasResizedHandlers, Q$HasRightMouseDownHandlers, Q$HasScrolledHandlers, Q$HasShowContextMenuHandlers, Q$HasVisibilityChangedHandlers, Q$Layout, Q$InitializableView, Q$RefreshableView, Q$Table, Q$Enhanced, Q$EnhancedHLayout]), TestSearchBarView_0);
function graphSparkLines(){
  $wnd.jQuery('.dynamicsparkline').sparkline();
}

function isBrowserPreIE9(){
  var myUserAgent = $wnd.navigator.userAgent;
  if (/MSIE (\d+\.\d+);/.test(myUserAgent)) {
    var ieVersion = new Number(RegExp.$1);
    if (ieVersion < 9) {
      return true;
    }
  }
  return false;
}

function equals_129(criteria1, criteria2){
  var attribute, attribute$iterator, attributes1, attributes2, value1, value2;
  if (criteria1 == criteria2) {
    return true;
  }
  if (!criteria1 || !criteria2) {
    return false;
  }
  attributes1 = new HashSet_2(new Arrays$ArrayList_0(getProperties(criteria1.jsObj)));
  attributes2 = new HashSet_2(new Arrays$ArrayList_0(getProperties(criteria2.jsObj)));
  if (!$equals_8(attributes1, attributes2)) {
    return false;
  }
  for (attribute$iterator = $iterator($keySet(attributes1.map)); attribute$iterator.val$outerIter.hasNext();) {
    attribute = dynamicCast($next_1(attribute$iterator), Q$String);
    value1 = getAttribute(criteria1.jsObj, attribute);
    value2 = getAttribute(criteria2.jsObj, attribute);
    if (value1 == null && value2 != null || value1 != null && !$equals_6(value1, value2)) {
      return false;
    }
  }
  return true;
}

function addContextualHelp(item, helpText, icons){
  var allIcons, helpIcon;
  helpIcon = new FormItemIcon_0;
  helpIcon.jsObj['src'] = 'global/help.png';
  if (icons == null) {
    $isCreated_2(item)?$setProperty_7(item, 'icons', convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [helpIcon]))):(item.jsObj['icons'] = convertToJavaScriptArray(initValues(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, [helpIcon])) , undefined);
  }
   else {
    allIcons = initDim(_3Lcom_smartgwt_client_widgets_form_fields_FormItemIcon_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$FormItemIcon, icons.length + 1, 0);
    arraycopy(icons, 0, allIcons, 0, icons.length);
    allIcons[icons.length] = helpIcon;
    $isCreated_2(item)?$setProperty_7(item, 'icons', convertToJavaScriptArray(allIcons)):(item.jsObj['icons'] = convertToJavaScriptArray(allIcons) , undefined);
  }
  $addIconClickHandler(item, new FormUtility$1_0(helpIcon, helpText));
}

function FormUtility$1_0(val$helpIcon, val$helpText){
  this.val$helpIcon = val$helpIcon;
  this.val$helpText = val$helpText;
}

defineSeed(3762, 1, makeCastMap([Q$EventHandler, Q$IconClickHandler]), FormUtility$1_0);
_.onIconClick = function onIconClick_1(event_0){
  $equals_1($getIcon_0(event_0), this.val$helpIcon) && say(this.val$helpText);
}
;
_.val$helpIcon = null;
_.val$helpText = null;
function $clinit_GwtRelativeDurationConverter(){
  $clinit_GwtRelativeDurationConverter = nullMethod;
  dayFormatter = ($clinit_DateTimeFormat_0() , getFormat_0('d', $getDateTimeFormatInfo(($clinit_LocaleInfo() , $clinit_LocaleInfo() , instance_0))));
  formatter_0 = getFormat_0('hh:mm aaa Z', $getDateTimeFormatInfo(instance_0));
  $clinit_CoreGUI();
}

function format_90(eventMillis){
  $clinit_GwtRelativeDurationConverter();
  var dayOfYearEvent, dayOfYearToday, now, result;
  now = fromDouble(currentTimeMillis0());
  dayOfYearToday = __parseAndValidateInt($format(dayFormatter, new Date_2(now), null));
  dayOfYearEvent = __parseAndValidateInt($format(dayFormatter, new Date_2(eventMillis), null));
  dayOfYearEvent == dayOfYearToday && lt(sub(now, eventMillis), P5265c00_longLit)?(result = $format(formatter_0, new Date_2(eventMillis), null)):dayOfYearEvent == dayOfYearToday - 1 && lt(sub(now, eventMillis), P90321000_longLit)?(result = 'Yesterday, ' + $format(formatter_0, new Date_2(eventMillis), null)):(result = getRelativeTimeAgo(eventMillis) + ' ago');
  return result;
}

function getRelativeTimeAgo(millis){
  var buf, count, days, hours, mins, timeAgo;
  buf = new StringBuilder_0;
  timeAgo = sub(fromDouble(currentTimeMillis0()), millis);
  count = 0;
  days = toInt(div(timeAgo, P5265c00_longLit));
  timeAgo = mod(timeAgo, P5265c00_longLit);
  if (days > 0) {
    ++count;
    $append_0(buf.data_0, days);
    $appendNonNull(buf.data_0, ' ');
    days == 1?($append_1(buf.data_0, 'day') , buf):($append_1(buf.data_0, 'days') , buf);
  }
  hours = toInt(div(timeAgo, P36ee80_longLit));
  timeAgo = mod(timeAgo, P36ee80_longLit);
  if (hours > 0) {
    ++count;
    $toString_1(buf.data_0).length > 0 && ($append_1(buf.data_0, ', ') , buf);
    $append_0(buf.data_0, hours);
    $appendNonNull(buf.data_0, ' ');
    hours == 1?($append_1(buf.data_0, 'hour') , buf):($append_1(buf.data_0, 'hours') , buf);
  }
  if (count < 2) {
    mins = toInt(div(timeAgo, Pea60_longLit));
    timeAgo = mod(timeAgo, Pea60_longLit);
    if (mins > 0) {
      $toString_1(buf.data_0).length > 0 && ($append_1(buf.data_0, ', ') , buf);
      $append_0(buf.data_0, mins);
      $appendNonNull(buf.data_0, ' ');
      mins == 1?($append_1(buf.data_0, 'minute') , buf):($append_1(buf.data_0, 'minutes') , buf);
    }
  }
  return $toString_1(buf.data_0);
}

var dayFormatter, formatter_0;
function GwtTuple_0(lefty, righty){
  this.lefty = lefty;
  this.righty = righty;
}

defineSeed(3764, 1, makeCastMap([Q$GwtTuple]), GwtTuple_0);
_.equals$ = function equals_130(obj_0){
  var other;
  if (this === obj_0) {
    return true;
  }
  if (obj_0 == null || !instanceOf(obj_0, Q$GwtTuple)) {
    return false;
  }
  other = dynamicCast(obj_0, Q$GwtTuple);
  if (!this.lefty) {
    if (other.lefty) {
      return false;
    }
  }
   else if (this.lefty != other.lefty) {
    return false;
  }
  if (!this.righty) {
    if (other.righty) {
      return false;
    }
  }
   else if (!$equals_4(this.righty, other.righty)) {
    return false;
  }
  return true;
}
;
_.hashCode$ = function hashCode_129(){
  var result;
  result = 31 + (!this.lefty?0:getHashCode(this.lefty));
  result = 31 * result + (!this.righty?0:this.righty.value_0);
  return result;
}
;
_.lefty = null;
_.righty = null;
function trace_0(message, caught){
  $clinit_Log();
  $log_1(logger_0, ($clinit_Level() , FINEST), message, caught);
}

function $clinit_MeasurementConverterClient(){
  $clinit_MeasurementConverterClient = nullMethod;
  $clinit_CoreGUI();
}

function fit(origin, units){
  var biggerUnits, biggerValue, currentValueAndUnits, maxOrdinal, nextOrdinal, nextValueAndUnits, smallerUnits, smallerValue, wasNegative;
  if (!units) {
    return new MeasurementNumericValueAndUnits_0(origin, null);
  }
  if (($clinit_MeasurementUnits$Family() , ABSOLUTE_0) == units.family || DURATION == units.family) {
    return new MeasurementNumericValueAndUnits_0(origin, units);
  }
  if (RELATIVE_0 == units.family) {
    return new MeasurementNumericValueAndUnits_0(origin, units);
  }
  if (TEMPERATURE == units.family) {
    return new MeasurementNumericValueAndUnits_0(origin, units);
  }
  if (abs(origin.value_0) < 1.0E-9) {
    return new MeasurementNumericValueAndUnits_0(origin, units);
  }
  wasNegative = false;
  if (origin.value_0 < 0) {
    wasNegative = true;
    origin = new Double_0(-origin.value_0);
  }
  nextValueAndUnits = new MeasurementNumericValueAndUnits_0(origin, units);
  maxOrdinal = ($clinit_MeasurementUnits() , $clinit_MeasurementUnits() , $VALUES_91).length;
  do {
    currentValueAndUnits = nextValueAndUnits;
    nextOrdinal = nextValueAndUnits.units.ordinal + 1;
    if (nextOrdinal == maxOrdinal) {
      break;
    }
    biggerUnits = $VALUES_91[nextOrdinal];
    if (biggerUnits.family != nextValueAndUnits.units.family) {
      break;
    }
    smallerValue = scale_0(nextValueAndUnits, biggerUnits);
    nextValueAndUnits = new MeasurementNumericValueAndUnits_0(smallerValue, biggerUnits);
  }
   while (nextValueAndUnits.value_0.value_0 > 1);
  while (currentValueAndUnits.value_0.value_0 < 1) {
    nextOrdinal = currentValueAndUnits.units.ordinal - 1;
    if (nextOrdinal == -1) {
      break;
    }
    smallerUnits = $VALUES_91[nextOrdinal];
    if (smallerUnits.family != currentValueAndUnits.units.family) {
      break;
    }
    biggerValue = scale_0(currentValueAndUnits, smallerUnits);
    nextValueAndUnits = new MeasurementNumericValueAndUnits_0(biggerValue, smallerUnits);
    currentValueAndUnits = nextValueAndUnits;
  }
  if (wasNegative) {
    return new MeasurementNumericValueAndUnits_0(new Double_0(-currentValueAndUnits.value_0.value_0), currentValueAndUnits.units);
  }
  return currentValueAndUnits;
}

function format_91(value, targetUnits){
  $clinit_MeasurementConverterClient();
  var formatted, numberFormat, valueAndUnits;
  if (!value || isNaN_0(value.value_0)) {
    return '--no data available--';
  }
  valueAndUnits = fit(value, targetUnits);
  value = valueAndUnits.value_0;
  targetUnits = valueAndUnits.units;
  !!targetUnits && ($clinit_MeasurementUnits$Family() , RELATIVE_0) == targetUnits.family && (value = scaleUp(value, targetUnits));
  numberFormat = ($clinit_NumberFormat() , new NumberFormat_1(getFormat_1(1, 1), $getDefaultNative(), true));
  formatted = $format_0(numberFormat, value.value_0);
  return format_92(formatted, targetUnits);
}

function format_92(value, targetUnits){
  $clinit_MeasurementConverterClient();
  var abbr;
  if (!targetUnits) {
    return value;
  }
   else {
    abbr = getMeasurementUnitAbbreviation(targetUnits);
    return abbr.length > 0?value + ' ' + abbr:value;
  }
}

function formatToSignificantPrecision(values, targetUnits){
  $clinit_MeasurementConverterClient();
  var average, existingStrings, fittedAverage, fittedUnits, formatted, i, nf, precisionDigits, results, scaleWithMorePrecision, scaledValues, sz, wasNewElement;
  if (null == values || values.length == 0) {
    return null;
  }
  average = new Double_0(0);
  for (i = 0 , sz = values.length; i < sz; ++i) {
    average = new Double_0(average.value_0 + values[i] / sz);
  }
  fittedAverage = fit(average, targetUnits);
  fittedUnits = fittedAverage.units;
  precisionDigits = 0;
  scaleWithMorePrecision = true;
  results = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, values.length, 0);
  $clinit_NumberFormat();
  new NumberFormat_1('0.0', $getDefaultNative(), true);
  while (scaleWithMorePrecision && ++precisionDigits <= 4) {
    scaleWithMorePrecision = false;
    existingStrings = new HashSet_0;
    nf = new NumberFormat_1(getFormat_1(0, precisionDigits), $getDefaultNative(), true);
    scaledValues = initDim(_3Ljava_lang_Double_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Double_$1, Q$Object_$1]), Q$Double, values.length, 0);
    for (i = 0; i < scaledValues.length; ++i) {
      ($clinit_MeasurementUnits$Family() , RELATIVE_0) == targetUnits.family?(scaledValues[i] = scaleUp(new Double_0(values[i]), targetUnits)):(scaledValues[i] = scale_0(new MeasurementNumericValueAndUnits_0(new Double_0(values[i]), targetUnits), fittedUnits));
    }
    for (i = 0; i < results.length; ++i) {
      formatted = $format_0(nf, scaledValues[i].value_0);
      wasNewElement = $add_6(existingStrings, formatted);
      if (!wasNewElement && precisionDigits < 4) {
        scaleWithMorePrecision = true;
        break;
      }
      results[i] = formatted;
    }
  }
  for (i = 0; i < results.length; ++i) {
    results[i] = format_92(results[i], fittedUnits);
  }
  return results;
}

function getFormat_1(minDigits, maxDigits){
  var buf, i;
  buf = new StringBuilder_1('0.');
  for (i = 0; i < minDigits; ++i) {
    $append_1(buf.data_0, '0');
  }
  for (i = 0; i < maxDigits - minDigits; ++i) {
    $append_1(buf.data_0, '#');
  }
  return $toString_1(buf.data_0);
}

function getMeasurementUnitAbbreviation(units){
  switch (units.ordinal) {
    case 14:
    case 15:
    case 0:
      return '';
    case 1:
      return '%';
    case 2:
      return 'B';
    case 3:
      return 'KB';
    case 4:
      return 'MB';
    case 5:
      return 'GB';
    case 6:
      return 'TB';
    case 7:
      return 'PB';
    case 8:
      return 'b';
    case 9:
      return 'Kb';
    case 10:
      return 'Mb';
    case 11:
      return 'Gb';
    case 12:
      return 'Tb';
    case 13:
      return 'Pb';
    case 16:
      return 'j';
    case 17:
      return 'ns';
    case 18:
      return 'us';
    case 19:
      return 'ms';
    case 20:
      return 's';
    case 21:
      return 'm';
    case 22:
      return 'h';
    case 23:
      return 'd';
    case 24:
      return 'C';
    case 25:
      return 'K';
    case 26:
      return 'F';
    default:return units.displayUnits;
  }
}

function scale_0(origin, targetUnits){
  $clinit_MeasurementConverterClient();
  var originUnits, originValue;
  originUnits = origin.units;
  originValue = origin.value_0;
  return new Double_0(originValue.value_0 * calculateOffset(originUnits, targetUnits).value_0);
}

function $clinit_MeasurementUtility(){
  $clinit_MeasurementUtility = nullMethod;
  FORMATTER = ($clinit_DateTimeFormat_0() , getFormat_0('MMM d, hh:mm a', $getDateTimeFormatInfo(($clinit_LocaleInfo() , $clinit_LocaleInfo() , instance_0))));
  FORMATTER_YEAR = getFormat_0('MMM d, yyyy hh:mm a', $getDateTimeFormatInfo(instance_0));
}

function calculateTimeFrame(lastN, unit){
  $clinit_MeasurementUtility();
  var l_0, now, retrospective;
  l_0 = new ArrayList_1(0);
  if (unit == 1) {
    return null;
  }
  now = fromDouble(currentTimeMillis0());
  retrospective = fromInt(lastN);
  switch (unit) {
    case 5:
      retrospective = mul(retrospective, P240c8400_longLit);
      break;
    case 2:
      retrospective = mul(retrospective, Pea60_longLit);
      break;
    case 3:
      retrospective = mul(retrospective, P36ee80_longLit);
      break;
    case 4:
      retrospective = mul(retrospective, P5265c00_longLit);
      break;
    default:retrospective = N1_longLit;
  }
  lt(retrospective, P0_longLit) && (retrospective = now);
  $add_3(l_0, valueOf_45(sub(now, retrospective)));
  $add_3(l_0, valueOf_45(now));
  return l_0;
}

function formatSimpleMetrics(summary){
  $clinit_MeasurementUtility();
  var formattedValues, i, metricKeys;
  if (!isNaN_0($getAvgMetric(summary).value_0.value_0)) {
    summary.units.length < 1 && $setUnits(summary, ($clinit_MeasurementUnits() , NONE_8).name_0);
    formattedValues = formatToSignificantPrecision($getMetricValueDoubles(summary), valueOf_100(summary.units));
    metricKeys = $getMetricKeys(summary);
    for (i = 0; i < metricKeys.length; ++i) {
      $setValueFmt($getMetric(summary, metricKeys[i]), formattedValues[i]);
    }
  }
}

var FORMATTER, FORMATTER_YEAR;
function getAttributeAsInteger(record){
  var $e0, $e1, $e2, integerValue, value;
  try {
    value = getAttributeAsInt(record.jsObj, 'timeout');
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      try {
        value = getAttributeAsDouble(record.jsObj, 'timeout');
      }
       catch ($e1) {
        $e1 = caught_0($e1);
        if (instanceOf($e1, Q$Exception)) {
          try {
            value = getAttribute(record.jsObj, 'timeout');
          }
           catch ($e2) {
            $e2 = caught_0($e2);
            if (instanceOf($e2, Q$Exception)) {
              throw new RuntimeException_1('Failed to obtain value of attribute [timeout] of Record [' + record + '].');
            }
             else 
              throw $e2;
          }
        }
         else 
          throw $e1;
      }
    }
     else 
      throw $e0;
  }
  if (instanceOf(value, Q$Number)) {
    integerValue = valueOf_44(dynamicCast(value, Q$Number).intValue());
  }
   else if (instanceOf(value, Q$String)) {
    integerValue = valueOf_44(__parseAndValidateInt(dynamicCast(value, Q$String)));
  }
   else if (value == null) {
    integerValue = null;
  }
   else {
    throw new RuntimeException_1('Value of attribute [timeout] of Record [' + record + '] is not an integer.');
  }
  return integerValue;
}

function pluralize(singularNoun){
  var pluralNoun;
  $endsWith(singularNoun, 'y') && !$endsWith(singularNoun, 'ay') && !$endsWith(singularNoun, 'ey') && !$endsWith(singularNoun, 'oy')?(pluralNoun = $substring_0(singularNoun, 0, singularNoun.length - 1) + 'ies'):$endsWith(singularNoun, 's')?(pluralNoun = singularNoun):(pluralNoun = singularNoun + 's');
  return pluralNoun;
}

function getIds(input){
  var ids, index, next, next$iterator;
  ids = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, input.size_0, 1);
  index = 0;
  for (next$iterator = new AbstractList$IteratorImpl_0(input); next$iterator.i < next$iterator.this$0_0.size_1();) {
    next = dynamicCast($next_0(next$iterator), Q$Integer);
    ids[index++] = next.value_0;
  }
  return ids;
}

function getIds_0(selections){
  var ids, index, selection, selection$index, selection$max;
  ids = initDim(_3I_classLit, makeCastMap([Q$Serializable, Q$Cloneable]), -1, selections.length, 1);
  index = 0;
  for (selection$index = 0 , selection$max = selections.length; selection$index < selection$max; ++selection$index) {
    selection = selections[selection$index];
    ids[index++] = getAttributeAsInt(selection.jsObj, 'id').value_0;
  }
  return ids;
}

function appendTreeNode(tree, node, str){
  var childNode, childNode$index, childNode$max, childNodes, i, level, self_0;
  level = (self_0 = tree.getOrCreateJsObj() , self_0.getLevel(node.getJsObj()));
  for (i = 0; i < level; ++i) {
    $append_1(str.data_0, '    ');
  }
  $append_7($append_12(($append_1(str.data_0, '* ') , str), toString_211(node)), 10);
  childNodes = $getChildren(tree, node);
  for (childNode$index = 0 , childNode$max = childNodes.length; childNode$index < childNode$max; ++childNode$index) {
    childNode = childNodes[childNode$index];
    appendTreeNode(tree, childNode, str);
  }
}

function toString_211(node){
  var buffer, className, id, name_0, parentId, simpleClassName;
  if (instanceOf(node, Q$EnhancedTreeNode)) {
    return node.toString$();
  }
   else {
    buffer = new StringBuilder_0;
    className = node.___clazz$.typeName;
    simpleClassName = $substring(className, className.lastIndexOf('.') + 1);
    $append_12(($append_1(buffer.data_0, simpleClassName) , buffer), '[');
    id = getAttribute(node.jsObj, 'id');
    $append_12(($append_1(buffer.data_0, 'id=') , buffer), id);
    parentId = getAttribute(node.jsObj, 'parentId');
    $append_12(($append_1(buffer.data_0, ', parentId=') , buffer), parentId);
    name_0 = getAttribute(node.jsObj, 'name');
    $append_12(($append_1(buffer.data_0, ', name=') , buffer), name_0);
    $append_1(buffer.data_0, ']');
    return $toString_1(buffer.data_0);
  }
}

function toInteger(object){
  var integerValue;
  if (instanceOf(object, Q$String)) {
    integerValue = valueOf_44(__parseAndValidateInt(dynamicCast(object, Q$String)));
  }
   else if (instanceOf(object, Q$Number)) {
    integerValue = valueOf_44(dynamicCast(object, Q$Number).intValue());
  }
   else if (object == null) {
    integerValue = null;
  }
   else {
    throw new IllegalArgumentException_1('Failed to convert ' + getClass__devirtual$(object).typeName + ' [' + object + '] to an Integer.');
  }
  return integerValue;
}

function toLong(object){
  var longValue;
  if (instanceOf(object, Q$String)) {
    longValue = valueOf_45(fromInt(valueOf_44(__parseAndValidateInt(dynamicCast(object, Q$String))).value_0));
  }
   else if (instanceOf(object, Q$Number)) {
    longValue = valueOf_45(fromInt(dynamicCast(object, Q$Number).intValue()));
  }
   else if (object == null) {
    longValue = null;
  }
   else {
    throw new IllegalArgumentException_1('Failed to convert ' + getClass__devirtual$(object).typeName + ' [' + object + '] to a Long.');
  }
  return longValue;
}

function $countDown(this$static){
  this$static.count <= 0 && error_0('Illegal State in countDownLatch.count : ' + this$static.count);
  --this$static.count;
  this$static.count == 0 && this$static.command.execute_1();
}

function CountDownLatch_0(count, command){
  this.command = command;
  this.count = count;
}

defineSeed(3773, 1, {}, CountDownLatch_0);
_.command = null;
_.count = 0;
function decorate(data, startIndex, endIndex){
  var counter, letterIndex, results, wordIndex, words;
  if (startIndex == -1 || startIndex == endIndex) {
    return data;
  }
  words = $split(data, '<br/>', 0);
  counter = 0;
  wordIndex = 0;
  letterIndex = 0;
  results = new StringBuilder_0;
  while (counter < startIndex) {
    if (wordIndex == words.length) {
      break;
    }
    if (letterIndex < words[wordIndex].length) {
      $append_7(results, words[wordIndex].charCodeAt(letterIndex));
      ++letterIndex;
      ++counter;
    }
     else {
      $append_1(results.data_0, '<br/>');
      letterIndex = 0;
      ++wordIndex;
    }
  }
  $append_1(results.data_0, '<span style="background-color: yellow">');
  while (counter < endIndex) {
    if (wordIndex == words.length) {
      break;
    }
    if (letterIndex < words[wordIndex].length) {
      $append_7(results, words[wordIndex].charCodeAt(letterIndex));
      ++letterIndex;
      ++counter;
    }
     else {
      $append_1(results.data_0, '<\/span>');
      $append_1(results.data_0, '<br/>');
      letterIndex = 0;
      ++wordIndex;
      $append_1(results.data_0, '<span style="background-color: yellow">');
    }
  }
  $append_1(results.data_0, '<\/span>');
  wordIndex != words.length && $append_12(results, $substring(words[wordIndex], letterIndex));
  while (++wordIndex < words.length) {
    $append_1(results.data_0, '<br/>');
    $append_1(results.data_0, words[wordIndex]);
  }
  return $toString_1(results.data_0);
}

function highlight_0(data, filter){
  var i, lowerData, lowerFilter, matchingIndices, nextMatchingIndex, startFrom;
  lowerData = data.toLowerCase();
  lowerFilter = filter.toLowerCase();
  matchingIndices = new ArrayList_0;
  startFrom = -1;
  while ((startFrom = lowerData.indexOf(lowerFilter, startFrom + 1)) != -1) {
    $add_3(matchingIndices, valueOf_44(startFrom));
  }
  for (i = matchingIndices.size_0 - 1; i >= 0; --i) {
    nextMatchingIndex = dynamicCast((checkIndex(i, matchingIndices.size_0) , matchingIndices.array[i]), Q$Integer);
    data = decorate(data, nextMatchingIndex.value_0, nextMatchingIndex.value_0 + filter.length);
  }
  return data;
}

function getSafeId(unsafeId){
  var safeId;
  if (null == unsafeId || !$trim(unsafeId).length) {
    return 'DEFAULTID';
  }
  safeId = $replace_1($replace_1($replace_1(unsafeId, ' ', ''), '.', ''), '-', '_');
  return safeId;
}

function fit_0(origin, units){
  var biggerUnits, biggerValue, currentValueAndUnits, maxOrdinal, nextOrdinal, nextValueAndUnits, smallerUnits, smallerValue, wasNegative;
  if (!units) {
    return new MeasurementNumericValueAndUnits_0(origin, null);
  }
  if (($clinit_MeasurementUnits$Family() , ABSOLUTE_0) == units.family || DURATION == units.family) {
    return new MeasurementNumericValueAndUnits_0(origin, units);
  }
  if (RELATIVE_0 == units.family) {
    return new MeasurementNumericValueAndUnits_0(origin, units);
  }
  if (TEMPERATURE == units.family) {
    return new MeasurementNumericValueAndUnits_0(origin, units);
  }
  if (abs(origin.value_0) < 1.0E-9) {
    return new MeasurementNumericValueAndUnits_0(origin, units);
  }
  wasNegative = false;
  if (origin.value_0 < 0) {
    wasNegative = true;
    origin = new Double_0(-origin.value_0);
  }
  nextValueAndUnits = new MeasurementNumericValueAndUnits_0(origin, units);
  maxOrdinal = ($clinit_MeasurementUnits() , $clinit_MeasurementUnits() , $VALUES_91).length;
  do {
    currentValueAndUnits = nextValueAndUnits;
    nextOrdinal = nextValueAndUnits.units.ordinal + 1;
    if (nextOrdinal == maxOrdinal) {
      break;
    }
    biggerUnits = $VALUES_91[nextOrdinal];
    if (biggerUnits.family != nextValueAndUnits.units.family) {
      break;
    }
    smallerValue = scale_1(nextValueAndUnits, biggerUnits);
    nextValueAndUnits = new MeasurementNumericValueAndUnits_0(smallerValue, biggerUnits);
  }
   while (nextValueAndUnits.value_0.value_0 > 1);
  while (currentValueAndUnits.value_0.value_0 < 1) {
    nextOrdinal = currentValueAndUnits.units.ordinal - 1;
    if (nextOrdinal == -1) {
      break;
    }
    smallerUnits = $VALUES_91[nextOrdinal];
    if (smallerUnits.family != currentValueAndUnits.units.family) {
      break;
    }
    biggerValue = scale_1(currentValueAndUnits, smallerUnits);
    nextValueAndUnits = new MeasurementNumericValueAndUnits_0(biggerValue, smallerUnits);
    currentValueAndUnits = nextValueAndUnits;
  }
  if (wasNegative) {
    return new MeasurementNumericValueAndUnits_0(new Double_0(-currentValueAndUnits.value_0.value_0), currentValueAndUnits.units);
  }
  return currentValueAndUnits;
}

function formatToSignificantPrecision_0(values, targetUnits){
  var average, existingStrings, fittedAverage, fittedUnits, formatPattern, formatted, i, nf, precisionDigits, results, scaleWithMorePrecision, scaledValues, sz, wasNewElement;
  if (null == values || values.length == 0) {
    return null;
  }
  average = new Double_0(0);
  for (i = 0 , sz = values.length; i < sz; ++i) {
    average = new Double_0(average.value_0 + values[i] / sz);
  }
  fittedAverage = fit_0(average, targetUnits);
  fittedUnits = fittedAverage.units;
  precisionDigits = 1;
  scaleWithMorePrecision = true;
  results = initDim(_3Ljava_lang_String_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1, Q$String_$1]), Q$String, values.length, 0);
  $clinit_NumberFormat();
  new NumberFormat_1('##,##0.##', $getDefaultNative(), true);
  while (scaleWithMorePrecision && ++precisionDigits <= 4) {
    scaleWithMorePrecision = false;
    existingStrings = new HashSet_0;
    formatPattern = '';
    for (i = 0; i < precisionDigits; ++i) {
      formatPattern += '#';
    }
    nf = new NumberFormat_1('#,###.' + formatPattern, $getDefaultNative(), true);
    scaledValues = initDim(_3Ljava_lang_Double_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Double_$1, Q$Object_$1]), Q$Double, values.length, 0);
    for (i = 0; i < scaledValues.length; ++i) {
      ($clinit_MeasurementUnits$Family() , RELATIVE_0) == targetUnits.family?(scaledValues[i] = scaleUp(new Double_0(values[i]), targetUnits)):(scaledValues[i] = scale_1(new MeasurementNumericValueAndUnits_0(new Double_0(values[i]), targetUnits), fittedUnits));
    }
    for (i = 0; i < results.length; ++i) {
      formatted = $format_0(nf, scaledValues[i].value_0);
      wasNewElement = $add_6(existingStrings, formatted);
      if (!wasNewElement && precisionDigits < 4) {
        scaleWithMorePrecision = true;
        break;
      }
      results[i] = formatted;
    }
  }
  for (i = 0; i < results.length; ++i) {
    results[i] = !fittedUnits?results[i]:results[i] + fittedUnits;
  }
  return results;
}

function scale_1(origin, targetUnits){
  var originUnits, originValue;
  originUnits = origin.units;
  originValue = origin.value_0;
  return new Double_0(originValue.value_0 * calculateOffset(originUnits, targetUnits).value_0);
}

function formatSimpleMetrics_0(summary, md){
  var formattedValues, units;
  units = md.units.name_0;
  units.length < 1 && (units = ($clinit_MeasurementUnits() , NONE_8).name_0);
  formattedValues = formatToSignificantPrecision_0(summary, ($clinit_MeasurementUnits() , dynamicCast(valueOf(($clinit_MeasurementUnits$Map() , $MAP_92), units), Q$MeasurementUnits)));
  return formattedValues;
}

function parse(input, targetUnits){
  var $e0, ch, convertedMagnitude, fromUnits, i, magnitude, scaledMagnitude, units, valueAndUnits;
  if (input == null) {
    return new MeasurementNumericValueAndUnits_0(new Double_0(0), targetUnits);
  }
  input = $trim(input);
  if (input.length == 0) {
    return new MeasurementNumericValueAndUnits_0(new Double_0(0), targetUnits);
  }
  i = 0;
  (input.indexOf('+') == 0 || input.indexOf('-') == 0) && (i = 1);
  for (; i < input.length; ++i) {
    ch = input.charCodeAt(i);
    if (!(isDigit(ch) || ch == 46 || ch == 44)) {
      break;
    }
  }
  magnitude = input.substr(0, i - 0);
  units = '';
  if (i <= input.length) {
    units = $substring(input, i);
    units = $trim(units);
  }
  if ($equals_6(units, '')) {
    fromUnits = targetUnits;
  }
   else {
    fromUnits = getUsingDisplayUnits(units, targetUnits.family);
    if (!fromUnits || fromUnits.family != targetUnits.family) {
      throw new MeasurementConversionException_0("The units in '" + input + "' were not valid, expected '" + targetUnits.family + "' units, received '" + units + "' units");
    }
  }
  try {
    magnitude.indexOf('+') == 0 && (magnitude = $substring(magnitude, 1));
    convertedMagnitude = new Double_0($parse(($clinit_NumberFormat() , !cachedDecimalFormat && (cachedDecimalFormat = new NumberFormat_1('#,##0.###', $getDefaultNative(), false)) , $clinit_NumberFormat() , cachedDecimalFormat), magnitude));
    if (($clinit_MeasurementUnits$Family() , RELATIVE_0) == targetUnits.family) {
      scaledMagnitude = scaleDown(new Double_0(convertedMagnitude.value_0), targetUnits);
    }
     else {
      valueAndUnits = new MeasurementNumericValueAndUnits_0(new Double_0(convertedMagnitude.value_0), fromUnits);
      scaledMagnitude = scale_0(valueAndUnits, targetUnits);
    }
    return new MeasurementNumericValueAndUnits_0(scaledMagnitude, targetUnits);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (instanceOf($e0, Q$Exception)) {
      throw new MeasurementConversionException_0("The magnitude in '" + input + "' did not parse correctly as a valid, localized, stringified number ");
    }
     else 
      throw $e0;
  }
}

function Message_0(conciseMessage){
  Message_7.call(this, conciseMessage, null);
}

function Message_1(conciseMessage, detailedMessage){
  Message_3.call(this, conciseMessage, detailedMessage, null, null);
}

function Message_6(conciseMessage, options){
  Message_3.call(this, conciseMessage, null, null, options);
}

function Message_8(conciseMessage, severity, options){
  Message_3.call(this, conciseMessage, null, severity, options);
}

defineSeed(3779, 1, makeCastMap([Q$Message]), Message_0, Message_1, Message_6, Message_8);
function $clinit_MeasurementUserPreferences(){
  $clinit_MeasurementUserPreferences = nullMethod;
  DEFAULT_VALUE_RANGE_RO = ($clinit_Boolean() , FALSE).value_0?'true':'false';
  DEFAULT_VALUE_RANGE_LASTN_0 = valueOf_44(8);
  DEFAULT_VALUE_RANGE_UNIT_0 = valueOf_44(3);
}

function $getMetricRangePreferences(this$static){
  var $e0, beginEnd, prefs, range, rangeString;
  prefs = new AbstractMeasurementRangeEditor$MetricRangePreferences_0;
  prefs.explicitBeginEnd = ($clinit_Boolean() , $equalsIgnoreCase('true', $getPreferenceEmptyStringIsDefault(this$static.userPrefs, '.resource.common.monitor.visibility.metricRange.ro', DEFAULT_VALUE_RANGE_RO))?TRUE:FALSE).value_0;
  if (prefs.explicitBeginEnd) {
    try {
      rangeString = $getSimpleValue(this$static.userPrefs.userConfiguration, '.resource.common.monitor.visibility.metricRange', null);
      if (rangeString != null && $trim(rangeString).length > 0) {
        rangeString.indexOf(',') != -1 && (rangeString = $replace_1(rangeString, ',', '|'));
        beginEnd = $split(rangeString, '\\|', 0);
        prefs.begin = valueOf_45(__parseAndValidateLong(beginEnd[0]));
        prefs.end_0 = valueOf_45(__parseAndValidateLong(beginEnd[1]));
      }
    }
     catch ($e0) {
      $e0 = caught_0($e0);
      if (instanceOf($e0, Q$IllegalArgumentException)) {
        range = calculateTimeFrame(DEFAULT_VALUE_RANGE_LASTN_0.value_0, DEFAULT_VALUE_RANGE_UNIT_0.value_0);
        prefs.begin = dynamicCast((checkIndex(0, range.size_0) , range.array[0]), Q$Long);
        prefs.end_0 = dynamicCast((checkIndex(1, range.size_0) , range.array[1]), Q$Long);
      }
       else 
        throw $e0;
    }
  }
   else {
    prefs.lastN = valueOf_44(__parseAndValidateInt($getPreferenceEmptyStringIsDefault(this$static.userPrefs, '.resource.common.monitor.visibility.metricRange.lastN', '' + DEFAULT_VALUE_RANGE_LASTN_0.value_0))).value_0;
    prefs.unit = valueOf_44(__parseAndValidateInt($getPreferenceEmptyStringIsDefault(this$static.userPrefs, '.resource.common.monitor.visibility.metricRange.unit', '' + DEFAULT_VALUE_RANGE_UNIT_0.value_0))).value_0;
    range = calculateTimeFrame(prefs.lastN, prefs.unit);
    prefs.begin = dynamicCast((checkIndex(0, range.size_0) , range.array[0]), Q$Long);
    prefs.end_0 = dynamicCast((checkIndex(1, range.size_0) , range.array[1]), Q$Long);
  }
  return prefs;
}

function $getSelectedView(this$static, key){
  var value;
  value = $getPreference(this$static.userPrefs, 'monitor.visibility.indicator.views.selected.' + key);
  return value;
}

function $setMetricRangePreferences_0(this$static, prefs){
  $setPreference(this$static.userPrefs, '.resource.common.monitor.visibility.metricRange.ro', '' + prefs.explicitBeginEnd, null);
  if (prefs.explicitBeginEnd) {
    $setPreference_0(this$static.userPrefs, '.resource.common.monitor.visibility.metricRange', new Arrays$ArrayList_0(initValues(_3Ljava_lang_Long_2_classLit, makeCastMap([Q$Serializable, Q$Cloneable, Q$Object_$1]), Q$Long, [prefs.begin, prefs.end_0])), null);
  }
   else {
    $setPreference(this$static.userPrefs, '.resource.common.monitor.visibility.metricRange.lastN', '' + prefs.lastN, null);
    $setPreference(this$static.userPrefs, '.resource.common.monitor.visibility.metricRange.unit', '' + prefs.unit, null);
  }
}

function MeasurementUserPreferences_0(userPrefs){
  $clinit_MeasurementUserPreferences();
  this.userPrefs = userPrefs;
}

defineSeed(3803, 1, {}, MeasurementUserPreferences_0);
_.userPrefs = null;
var DEFAULT_VALUE_RANGE_LASTN_0, DEFAULT_VALUE_RANGE_RO, DEFAULT_VALUE_RANGE_UNIT_0;
defineSeed(3804, 1, {});
_.name_0 = null;
function $addRecentResource(this$static, resourceId, persistCallback){
  var recentResources, size;
  recentResources = $getPreferenceAsIntegerList(this$static, '.recent.resources');
  if (recentResources.size_0 != 0 && $equals_4(dynamicCast((checkIndex(0, recentResources.size_0) , recentResources.array[0]), Q$Integer), resourceId)) {
    return;
  }
  $remove_4(recentResources, resourceId);
  $add_2(recentResources, 0, resourceId);
  size = recentResources.size_0;
  size > 10 && $remove_3(recentResources, 10);
  $setPreference_0(this$static, '.recent.resources', recentResources, persistCallback);
  !this$static.autoPersister && ($updateSubjectPreferences(this$static.subjectService, this$static.subject, this$static.changedPreferenceKeys, persistCallback) , this$static.changedPreferenceKeys.map.clear_0());
}

function $addRecentResourceGroup(this$static, resourceGroupId, persistCallback){
  var recentResourceGroups, size;
  recentResourceGroups = $getPreferenceAsIntegerList(this$static, '.recent.resourceGroups');
  if (recentResourceGroups.size_0 != 0 && $equals_4(dynamicCast((checkIndex(0, recentResourceGroups.size_0) , recentResourceGroups.array[0]), Q$Integer), resourceGroupId)) {
    return;
  }
  $remove_4(recentResourceGroups, resourceGroupId);
  $add_2(recentResourceGroups, 0, resourceGroupId);
  size = recentResourceGroups.size_0;
  size > 5 && $remove_3(recentResourceGroups, 5);
  $setPreference_0(this$static, '.recent.resourceGroups', recentResourceGroups, persistCallback);
  !this$static.autoPersister && ($updateSubjectPreferences(this$static.subjectService, this$static.subject, this$static.changedPreferenceKeys, persistCallback) , this$static.changedPreferenceKeys.map.clear_0());
}

function $getPageRefreshInterval(this$static){
  ($getSimpleValue(this$static.userConfiguration, '.page.refresh.period', null) == null || valueOf_44(__parseAndValidateInt($getSimpleValue(this$static.userConfiguration, '.page.refresh.period', null))).value_0 == 60) && $setPreference(this$static, '.page.refresh.period', '60000', null);
  return $getPreferenceAsInteger(this$static).value_0;
}

function $getPreference(this$static, name_0){
  return $getSimpleValue(this$static.userConfiguration, name_0, 'Default');
}

function $getPreferenceAsInteger(this$static){
  var $e0, pref;
  pref = null;
  try {
    pref = $getSimpleValue(this$static.userConfiguration, '.page.refresh.period', null);
  }
   catch ($e0) {
    $e0 = caught_0($e0);
    if (!instanceOf($e0, Q$IllegalArgumentException))
      throw $e0;
  }
  return pref != null?valueOf_44(__parseAndValidateInt(pref)):valueOf_44(0);
}

function $getPreferenceEmptyStringIsDefault(this$static, name_0, defaultValue){
  var value;
  value = $getSimpleValue(this$static.userConfiguration, name_0, null);
  (value == null || $trim(value).length == 0) && (value = defaultValue);
  return value;
}

function $setFavoriteResourceGroups(this$static, resourceGroupIds, persistCallback){
  $setPreference_0(this$static, '.dashContent.grouphealth.groups', resourceGroupIds, persistCallback);
  !this$static.autoPersister && ($updateSubjectPreferences(this$static.subjectService, this$static.subject, this$static.changedPreferenceKeys, persistCallback) , this$static.changedPreferenceKeys.map.clear_0());
}

function $setFavoriteResources(this$static, resourceIds, persistCallback){
  $setPreference_0(this$static, '.dashContent.resourcehealth.resources', resourceIds, persistCallback);
  !this$static.autoPersister && ($updateSubjectPreferences(this$static.subjectService, this$static.subject, this$static.changedPreferenceKeys, persistCallback) , this$static.changedPreferenceKeys.map.clear_0());
}

function $setPageRefreshInterval(this$static, refreshInterval, persistCallback){
  $setPreference(this$static, '.page.refresh.period', '' + refreshInterval, persistCallback);
  !this$static.autoPersister && ($updateSubjectPreferences(this$static.subjectService, this$static.subject, this$static.changedPreferenceKeys, persistCallback) , this$static.changedPreferenceKeys.map.clear_0());
}

function $setPreference(this$static, name_0, value, persistCallback){
  var event_0, listener, listener$iterator, prop;
  prop = $getSimple(this$static.userConfiguration, name_0);
  !prop?$put_4(this$static.userConfiguration, new PropertySimple_1(name_0, value)):$setValue_12(prop, value);
  $add_6(this$static.changedPreferenceKeys, name_0);
  event_0 = new UserPreferences$AutoPersistAwareChangeEvent_0(name_0, persistCallback);
  for (listener$iterator = new AbstractList$IteratorImpl_0(this$static.changeListeners); listener$iterator.i < listener$iterator.this$0_0.size_1();) {
    listener = dynamicCast($next_0(listener$iterator), Q$UserPreferenceChangeListener);
    $store(listener.this$0, new UserPreferences$1$1_0(event_0));
  }
}

function $setPreference_0(this$static, name_0, value, persistCallback){
  var buffer, first, item, item$iterator;
  buffer = new StringBuilder_0;
  first = true;
  for (item$iterator = value.iterator(); item$iterator.hasNext();) {
    item = item$iterator.next_0();
    first?(first = false):($append_1(buffer.data_0, '|') , buffer);
    $appendNonNull(buffer.data_0, '' + item);
  }
  $setPreference(this$static, name_0, $toString_1(buffer.data_0), persistCallback);
}

function $store(this$static, persistCallback){
  $updateSubjectPreferences(this$static.subjectService, this$static.subject, this$static.changedPreferenceKeys, persistCallback);
  this$static.changedPreferenceKeys.map.clear_0();
}

function $onSuccess_436(this$static, result){
  var apaEvent, persistCallback;
  if (this$static.val$event) {
    apaEvent = this$static.val$event;
    persistCallback = apaEvent.persistCallback;
    !!persistCallback && persistCallback.onSuccess_0(result);
  }
  $indexOf_0(($clinit_UserPreferences() , preferencesThatShouldNotCauseRefresh), this$static.val$event.name_0, 0) != -1 || ($clinit_CoreGUI() , $clinit_CoreGUI() , currentViewPath_0 = new ViewPath_1(currentView, true) , $renderView(coreGUI.rootCanvas, currentViewPath_0));
}

function UserPreferences$1$1_0(val$event){
  this.val$event = val$event;
}

defineSeed(3807, 1, {}, UserPreferences$1$1_0);
_.onFailure = function onFailure_452(caught){
  var apaEvent, persistCallback;
  if (this.val$event) {
    apaEvent = this.val$event;
    persistCallback = apaEvent.persistCallback;
    !!persistCallback && persistCallback.onFailure(caught);
  }
  $handleError_0(($clinit_CoreGUI() , 'Cannot store preferences'), caught);
}
;
_.onSuccess_0 = function onSuccess_452(result){
  $onSuccess_436(this, dynamicCast(result, Q$Subject));
}
;
_.val$event = null;
function UserPreferences$AutoPersistAwareChangeEvent_0(name_0, persistCallback){
  this.name_0 = name_0;
  this.persistCallback = persistCallback;
}

defineSeed(3808, 3804, {}, UserPreferences$AutoPersistAwareChangeEvent_0);
_.persistCallback = null;
function record_1(requestId, response){
  $clinit_DataSourceResponseStatistics();
  var record;
  if (enableCollection) {
    record = new DataSourceResponseStatistics$Record_0(requestId, response);
    $add_3(statistics, record);
  }
}

function DataSourceResponseStatistics$Record_0(requestId, response){
  this.timestamp = new Date_1;
  this.requestId = requestId;
  this.status_0 = getAttributeAsInt(response.jsObj, 'status').value_0;
  this.totalRows = getAttributeAsInt(response.jsObj, 'totalRows');
  this.startRow = getAttributeAsInt(response.jsObj, 'startRow');
  this.endRow = getAttributeAsInt(response.jsObj, 'endRow');
}

defineSeed(3810, 1, makeCastMap([Q$DataSourceResponseStatistics$Record]), DataSourceResponseStatistics$Record_0);
_.endRow = null;
_.requestId = null;
_.startRow = null;
_.status_0 = 0;
_.timestamp = null;
_.totalRows = null;
var D_classLit = createForPrimitive('double', ' D'), _3D_classLit = createForArray('', '[D', 3833, D_classLit), Lcom_google_web_bindery_event_shared_SimpleEventBus$3_2_classLit = createForClass('com.google.web.bindery.event.shared.', 'SimpleEventBus$3', 321), Ljava_util_AbstractMap$2_2_classLit = createForClass('java.util.', 'AbstractMap$2', 642), Ljava_util_AbstractMap$2$1_2_classLit = createForClass('java.util.', 'AbstractMap$2$1', 643), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardsView', 2453), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardsView$1', 2454), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardsView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardsView$1$1', 2455), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardsView$2', 2456), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardsView$3', 2457), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardsView$4', 2458), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardsView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardsView$5', 2459), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardsView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardsView$6', 2460), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardsView$6$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardsView$6$1', 2461), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardsView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardsView$7', 2462), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTopView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTopView', 3099), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTopView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTopView', 3362), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTopView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTopView$1', 3363), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTopView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTopView$2', 3364), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_AbstractTwoLevelTabSetView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.', 'AbstractTwoLevelTabSetView', 2928), Lcom_smartgwt_client_widgets_tab_Tab_2_classLit = createForClass('com.smartgwt.client.widgets.tab.', 'Tab', 566), Lorg_rhq_enterprise_gui_coregui_client_components_tab_NamedTab_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tab.', 'NamedTab', 2356), Lorg_rhq_enterprise_gui_coregui_client_components_tab_TwoLevelTab_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tab.', 'TwoLevelTab', 2361), _3Lorg_rhq_enterprise_gui_coregui_client_components_tab_TwoLevelTab_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.components.tab.', 'TwoLevelTab;', 3841, Lorg_rhq_enterprise_gui_coregui_client_components_tab_TwoLevelTab_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_AbstractTwoLevelTabSetView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.', 'AbstractTwoLevelTabSetView$1', 2929), Lcom_google_gwt_core_client_impl_SchedulerImpl$Flusher_2_classLit = createForClass('com.google.gwt.core.client.impl.', 'SchedulerImpl$Flusher', 26), Lcom_google_gwt_core_client_impl_SchedulerImpl$Rescuer_2_classLit = createForClass('com.google.gwt.core.client.impl.', 'SchedulerImpl$Rescuer', 27), Lorg_rhq_enterprise_gui_coregui_client_components_table_Table$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'Table$8', 2383), Lcom_google_gwt_user_client_ui_Panel_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'Panel', 282), Lcom_google_gwt_user_client_ui_ComplexPanel_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'ComplexPanel', 281), Lcom_google_gwt_user_client_ui_AbsolutePanel_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'AbsolutePanel', 280), Lcom_google_gwt_user_client_ui_RootPanel_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'RootPanel', 306), Lcom_google_gwt_user_client_ui_RootPanel$DefaultRootPanel_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'RootPanel$DefaultRootPanel', 309), Lcom_google_gwt_user_client_ui_RootPanel$2_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'RootPanel$2', 308), Lcom_google_gwt_user_client_ui_AttachDetachException_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'AttachDetachException', 285), Lcom_google_gwt_user_client_ui_AttachDetachException$1_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'AttachDetachException$1', 286), Lcom_google_gwt_user_client_ui_AttachDetachException$2_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'AttachDetachException$2', 287), Lorg_rhq_enterprise_gui_coregui_client_util_rpc_DataSourceResponseStatistics$Record_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.rpc.', 'DataSourceResponseStatistics$Record', 3810), Lorg_rhq_enterprise_gui_coregui_client_util_RPCDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.', 'RPCDataSource', 1622), Lorg_rhq_core_domain_drift_DriftCategory_2_classLit = createForEnum('org.rhq.core.domain.drift.', 'DriftCategory', 1172, Ljava_lang_Enum_2_classLit, values_83, valueOf_89), _3Lorg_rhq_core_domain_drift_DriftCategory_2_classLit = createForArray('[Lorg.rhq.core.domain.drift.', 'DriftCategory;', 3859, Lorg_rhq_core_domain_drift_DriftCategory_2_classLit), Lorg_rhq_core_domain_cloud_PartitionEvent$ExecutionStatus_2_classLit = createForEnum('org.rhq.core.domain.cloud.', 'PartitionEvent$ExecutionStatus', 816, Ljava_lang_Enum_2_classLit, values_58, valueOf_64), _3Lorg_rhq_core_domain_cloud_PartitionEvent$ExecutionStatus_2_classLit = createForArray('[Lorg.rhq.core.domain.cloud.', 'PartitionEvent$ExecutionStatus;', 3860, Lorg_rhq_core_domain_cloud_PartitionEvent$ExecutionStatus_2_classLit), Lorg_rhq_core_domain_cloud_PartitionEventType_2_classLit = createForEnum('org.rhq.core.domain.cloud.', 'PartitionEventType', 821, Ljava_lang_Enum_2_classLit, values_59, valueOf_65), _3Lorg_rhq_core_domain_cloud_PartitionEventType_2_classLit = createForArray('[Lorg.rhq.core.domain.cloud.', 'PartitionEventType;', 3861, Lorg_rhq_core_domain_cloud_PartitionEventType_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypeRepository$1', 3571), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypeRepository$2', 3572), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeRepository$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypeRepository$3', 3573), Lorg_rhq_enterprise_gui_coregui_client_components_view_AbstractSectionedLeftNavigationView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.view.', 'AbstractSectionedLeftNavigationView', 1581), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView', 2890), Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.view.', 'NavigationItem', 2426), _3Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.components.view.', 'NavigationItem;', 3872, Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationItem_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView', 2557), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$ResourceSearchViewWrapper_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$ResourceSearchViewWrapper', 2905), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$1', 2891), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$2', 2897), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$3', 2898), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$4', 2899), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$5', 2900), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$6', 2901), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$7', 2902), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$8', 2903), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$9', 2904), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$10', 2892), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$11', 2893), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$12', 2894), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$13', 2895), Lorg_rhq_enterprise_gui_coregui_client_inventory_InventoryView$14_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.', 'InventoryView$14', 2896), _3Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit = createForArray('[Lcom.smartgwt.client.widgets.tree.', 'TreeNode;', 3873, Lcom_smartgwt_client_widgets_tree_TreeNode_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_components_view_AbstractSectionedLeftNavigationView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.view.', 'AbstractSectionedLeftNavigationView$1', 2424), Lorg_rhq_enterprise_gui_coregui_client_components_view_AbstractSectionedLeftNavigationView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.view.', 'AbstractSectionedLeftNavigationView$2', 2425), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$1', 3270), Lorg_rhq_enterprise_gui_coregui_client_components_table_ResourceAuthorizedTableAction_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'ResourceAuthorizedTableAction', 1884), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$2', 3281), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$2$1', 3282), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$3', 3283), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$4', 3284), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_AvailabilityTypeResourceAuthorizedTableAction_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'AvailabilityTypeResourceAuthorizedTableAction', 3251), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$5', 3285), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$5$1', 3286), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$6', 3287), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$7', 3288), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$8', 3289), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$8$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$8$1', 3290), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$9', 3291), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$10', 3271), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$11', 3272), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$11$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$11$1', 3273), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$12', 3274), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$13', 3275), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$13$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$13$1', 3276), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$14_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$14', 3277), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$15_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$15', 3278), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$16_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$16', 3279), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceSearchView$17_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceSearchView$17', 3280), Lorg_rhq_enterprise_gui_coregui_client_components_table_ResourceAuthorizedTableAction$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'ResourceAuthorizedTableAction$1', 2372), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView', 3626), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView$1', 3627), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView$2', 3629), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView$3', 3630), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView$4', 3631), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView$5', 3632), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView$6', 3633), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView$7', 3634), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView$8', 3635), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView$9', 3636), Lorg_rhq_enterprise_gui_coregui_client_report_ReportTopView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'ReportTopView$10', 3628), Lorg_rhq_enterprise_gui_coregui_client_bundle_BundleTopView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.', 'BundleTopView', 2033), Lorg_rhq_enterprise_gui_coregui_client_bundle_BundleTopView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.', 'BundleTopView$1', 2034), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView', 1580), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$1', 1582), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$2', 1591), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$3', 1592), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$4', 1593), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$5', 1594), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$6', 1595), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$7', 1596), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$8', 1597), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$9', 1598), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$10', 1583), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$11', 1584), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$12', 1585), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$13', 1586), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$14_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$14', 1587), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$15_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$15', 1588), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$16_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$16', 1589), Lorg_rhq_enterprise_gui_coregui_client_admin_AdministrationView$17_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AdministrationView$17', 1590), Lorg_rhq_enterprise_gui_coregui_client_help_HelpView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.help.', 'HelpView', 2887), Lorg_rhq_enterprise_gui_coregui_client_help_HelpView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.help.', 'HelpView$1', 2888), Lorg_rhq_enterprise_gui_coregui_client_help_HelpView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.help.', 'HelpView$2', 2889), Lorg_rhq_enterprise_gui_coregui_client_report_tag_TaggedView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.tag.', 'TaggedView', 3668), Lorg_rhq_enterprise_gui_coregui_client_report_tag_TaggedView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.tag.', 'TaggedView$1', 3669), Lorg_rhq_enterprise_gui_coregui_client_report_tag_TaggedView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.tag.', 'TaggedView$2', 3670), Lorg_rhq_enterprise_gui_coregui_client_components_table_AbstractTableSection_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'AbstractTableSection', 1604), Lorg_rhq_enterprise_gui_coregui_client_components_table_TableSection_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'TableSection', 1603), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView', 1880), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView$1', 1881), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView$2', 1883), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView$3', 1885), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView$4', 1886), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView$5', 1887), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView$6', 1888), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView$7', 1889), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView$8', 1890), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView$9', 1891), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertHistoryView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertHistoryView$10', 1882), Lorg_rhq_enterprise_gui_coregui_client_components_table_AbstractTableSection$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'AbstractTableSection$1', 2364), Lorg_rhq_enterprise_gui_coregui_client_components_table_AbstractTableSection$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'AbstractTableSection$2', 2365), Lorg_rhq_enterprise_gui_coregui_client_components_table_AbstractTableSection$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'AbstractTableSection$3', 2366), Lorg_rhq_enterprise_gui_coregui_client_components_table_AbstractTableSection$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'AbstractTableSection$4', 2367), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView', 3728), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$1', 3729), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$2', 3738), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$3', 3739), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$4', 3740), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$5', 3741), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$6', 3742), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$7', 3743), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$8', 3744), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$9', 3745), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$10', 3730), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$11', 3731), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$12', 3732), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$13', 3733), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$14_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$14', 3734), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$15_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$15', 3735), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$16_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$16', 3736), Lorg_rhq_enterprise_gui_coregui_client_test_TestTopView$17_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestTopView$17', 3737), Lcom_smartgwt_client_widgets_form_fields_SelectItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'SelectItem', 512), Lcom_smartgwt_client_widgets_form_fields_DateItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'DateItem', 493), Lorg_rhq_enterprise_gui_coregui_client_components_form_DateFilterItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'DateFilterItem', 2291), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView', 3371), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$1', 3372), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$1$1', 3373), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$2', 3389), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$3', 3390), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$4', 3391), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$4$1', 3392), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$4$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$4$2', 3393), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$5', 3394), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$6', 3395), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$6$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$6$1', 3396), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$7', 3397), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$8', 3398), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$9', 3399), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$10', 3374), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$11', 3375), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$12', 3376), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$13', 3377), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$14_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$14', 3378), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$14$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$14$1', 3379), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$14$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$14$1$1', 3380), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$14$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$14$2', 3381), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$14$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$14$2$1', 3382), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$15_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$15', 3383), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$16_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$16', 3384), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$16$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$16$1', 3385), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$16$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$16$2', 3386), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$17_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$17', 3387), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeView$17$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeView$17$1', 3388), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView', 3103), Lorg_rhq_enterprise_gui_coregui_client_components_tree_EnhancedTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tree.', 'EnhancedTreeNode', 2399), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView$ResourceGroupEnhancedTreeNode', 3112), _3Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView$ResourceGroupEnhancedTreeNode;', 3879, Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$ResourceGroupEnhancedTreeNode_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView$1', 3104), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView$2', 3105), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView$3', 3106), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView$4', 3107), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView$5', 3108), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView$6', 3109), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView$7', 3110), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeView$8', 3111), Lorg_rhq_core_domain_criteria_DashboardCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'DashboardCriteria', 1097), Lcom_smartgwt_client_widgets_tab_TabSet_2_classLit = createForClass('com.smartgwt.client.widgets.tab.', 'TabSet', 567), Lorg_rhq_enterprise_gui_coregui_client_components_tab_NamedTabSet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tab.', 'NamedTabSet', 2357), _3Lorg_rhq_enterprise_gui_coregui_client_components_tab_NamedTab_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.components.tab.', 'NamedTab;', 3884, Lorg_rhq_enterprise_gui_coregui_client_components_tab_NamedTab_2_classLit), _3Lcom_smartgwt_client_widgets_tab_Tab_2_classLit = createForArray('[Lcom.smartgwt.client.widgets.tab.', 'Tab;', 3885, Lcom_smartgwt_client_widgets_tab_Tab_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView', 2442), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView$UpdatePortletRefreshCallback_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView$UpdatePortletRefreshCallback', 2452), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView$1', 2443), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView$2', 2444), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView$3', 2445), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView$4', 2446), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView$5', 2447), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView$6', 2448), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView$7', 2449), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView$8', 2450), Lorg_rhq_enterprise_gui_coregui_client_dashboard_DashboardView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'DashboardView$9', 2451), Lcom_smartgwt_client_widgets_layout_SectionStack_2_classLit = createForClass('com.smartgwt.client.widgets.layout.', 'SectionStack', 557), Lcom_smartgwt_client_widgets_layout_SectionStackSection_2_classLit = createForClass('com.smartgwt.client.widgets.layout.', 'SectionStackSection', 558), _3Lcom_smartgwt_client_widgets_layout_SectionStackSection_2_classLit = createForArray('[Lcom.smartgwt.client.widgets.layout.', 'SectionStackSection;', 3886, Lcom_smartgwt_client_widgets_layout_SectionStackSection_2_classLit), Lcom_smartgwt_client_types_VisibilityMode_2_classLit = createForEnum('com.smartgwt.client.types.', 'VisibilityMode', 426, Ljava_lang_Enum_2_classLit, values_40, valueOf_41), _3Lcom_smartgwt_client_types_VisibilityMode_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'VisibilityMode;', 3887, Lcom_smartgwt_client_types_VisibilityMode_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_PermissionsLoader$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.', 'PermissionsLoader$1', 1558), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView', 3313), Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tab.', 'SubTab', 2358), _3Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.components.tab.', 'SubTab;', 3888, Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTab_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$1', 3314), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$2', 3325), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$3', 3336), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$4', 3337), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$5', 3338), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$6', 3339), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$7', 3340), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$8', 3341), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$9', 3342), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$10', 3315), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$11', 3316), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$12', 3317), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$13', 3318), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$14_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$14', 3319), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$15_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$15', 3320), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$16_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$16', 3321), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$17_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$17', 3322), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$18_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$18', 3323), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$19_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$19', 3324), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$20_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$20', 3326), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$21_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$21', 3327), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$22_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$22', 3328), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$23_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$23', 3329), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$24_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$24', 3330), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$25_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$25', 3331), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$26_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$26', 3332), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$27_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$27', 3333), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$27$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$27$1', 3334), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceDetailView$28_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceDetailView$28', 3335), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView', 3071), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$1', 3072), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$2', 3083), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$3', 3084), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$4', 3085), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$5', 3086), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$6', 3087), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$7', 3088), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$8', 3089), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$9', 3090), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$10', 3073), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$11', 3074), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$12', 3075), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$13', 3076), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$14_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$14', 3077), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$15_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$15', 3078), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$16_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$16', 3079), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$17_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$17', 3080), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$17$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$17$1', 3081), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupDetailView$18_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupDetailView$18', 3082), Lorg_rhq_enterprise_gui_coregui_client_report_tag_TagCloudView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.tag.', 'TagCloudView', 2649), Lorg_rhq_enterprise_gui_coregui_client_report_tag_TagCloudView$DeleteButton_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.tag.', 'TagCloudView$DeleteButton', 3666), Lorg_rhq_enterprise_gui_coregui_client_report_tag_TagCloudView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.tag.', 'TagCloudView$1', 3662), Lorg_rhq_enterprise_gui_coregui_client_report_tag_TagCloudView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.tag.', 'TagCloudView$2', 3663), Lorg_rhq_enterprise_gui_coregui_client_report_tag_TagCloudView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.tag.', 'TagCloudView$3', 3664), Lorg_rhq_enterprise_gui_coregui_client_report_tag_TagCloudView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.tag.', 'TagCloudView$3$1', 3665), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDataSource', 1864), _3Lcom_smartgwt_client_core_DataClass_2_classLit = createForArray('[Lcom.smartgwt.client.core.', 'DataClass;', 3889, Lcom_smartgwt_client_core_DataClass_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDataSource$1', 1865), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDataSource$2', 1866), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDataSource$3', 1867), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDataSource$4', 1868), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDataSource$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDataSource$5', 1869), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDataSource$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDataSource$6', 1870), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDataSource$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDataSource$7', 1871), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDataSource$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDataSource$8', 1872), Lorg_rhq_enterprise_gui_coregui_client_components_form_EnumSelectItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EnumSelectItem', 2306), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortalLayout_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortalLayout', 2464), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortalLayout$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortalLayout$1', 2465), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortalLayout$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortalLayout$2', 2466), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortalLayout$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortalLayout$3', 2467), Lcom_smartgwt_client_widgets_tree_TreeGrid_2_classLit = createForClass('com.smartgwt.client.widgets.tree.', 'TreeGrid', 575), Lorg_rhq_enterprise_gui_coregui_client_components_view_NavigationSection_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.view.', 'NavigationSection', 2427), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_CustomResourceGroupTreeGrid_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'CustomResourceGroupTreeGrid', 3046), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu', 3059), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeContextMenu_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeContextMenu', 3100), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeContextMenu$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeContextMenu$1', 3101), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTreeContextMenu$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTreeContextMenu$2', 3102), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$1', 3060), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$2', 3061), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$3', 3062), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$4', 3063), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$5', 3064), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$6', 3065), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$7', 3066), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$7$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$7$1', 3067), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$7$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$7$1$1', 3068), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$7$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$7$2', 3069), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupContextMenu$7$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupContextMenu$7$2$1', 3070), Lcom_smartgwt_client_types_AnimationEffect_2_classLit = createForEnum('com.smartgwt.client.types.', 'AnimationEffect', 356, Ljava_lang_Enum_2_classLit, values_5, valueOf_6), _3Lcom_smartgwt_client_types_AnimationEffect_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'AnimationEffect;', 3930, Lcom_smartgwt_client_types_AnimationEffect_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_AncestryUtil$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'AncestryUtil$1', 3248), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_AncestryUtil$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'AncestryUtil$2', 3249), Lorg_rhq_enterprise_gui_coregui_client_gwt_DashboardGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'DashboardGWTService_Proxy', 2814), Lorg_rhq_core_domain_configuration_Configuration$PropertiesProxy_2_classLit = createForClass('org.rhq.core.domain.configuration.', 'Configuration$PropertiesProxy', 873), Lorg_rhq_core_domain_dashboard_Dashboard$1_2_classLit = createForClass('org.rhq.core.domain.dashboard.', 'Dashboard$1', 1162), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeDatasource', 3365), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeDatasource$ResourceTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeDatasource$ResourceTreeNode', 3369), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeDatasource$SubCategoryTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeDatasource$SubCategoryTreeNode', 3370), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeDatasource$AutoGroupTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeDatasource$AutoGroupTreeNode', 3368), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeDatasource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeDatasource$1', 3366), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTreeDatasource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTreeDatasource$2', 3367), Lorg_rhq_enterprise_gui_coregui_client_components_tab_TwoLevelTabSet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tab.', 'TwoLevelTabSet', 2363), Lcom_smartgwt_client_types_Side_2_classLit = createForEnum('com.smartgwt.client.types.', 'Side', 412, Ljava_lang_Enum_2_classLit, values_33, valueOf_34), _3Lcom_smartgwt_client_types_Side_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'Side;', 3934, Lcom_smartgwt_client_types_Side_2_classLit), Lcom_smartgwt_client_widgets_tree_events_NodeContextClickEvent_2_classLit = createForClass('com.smartgwt.client.widgets.tree.events.', 'NodeContextClickEvent', 580), Lcom_smartgwt_client_data_fields_DataSourceIntegerField_2_classLit = createForClass('com.smartgwt.client.data.fields.', 'DataSourceIntegerField', 348), Lorg_rhq_enterprise_gui_coregui_client_components_buttons_BackButton_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.buttons.', 'BackButton', 2204), Lorg_rhq_enterprise_gui_coregui_client_components_buttons_BackButton$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.buttons.', 'BackButton$1', 2205), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDetailsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDetailsView', 1873), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDetailsView$NotificationLogsTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDetailsView$NotificationLogsTable', 1876), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDetailsView$ConditionLogsTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDetailsView$ConditionLogsTable', 1875), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDetailsView$NotificationLogsTable$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDetailsView$NotificationLogsTable$1', 1877), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDetailsView$NotificationLogsTable$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDetailsView$NotificationLogsTable$2', 1878), Lorg_rhq_enterprise_gui_coregui_client_alert_AlertDetailsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'AlertDetailsView$1', 1874), Lcom_smartgwt_client_types_MultipleAppearance_2_classLit = createForEnum('com.smartgwt.client.types.', 'MultipleAppearance', 398, Ljava_lang_Enum_2_classLit, values_26, valueOf_27), _3Lcom_smartgwt_client_types_MultipleAppearance_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'MultipleAppearance;', 3935, Lcom_smartgwt_client_types_MultipleAppearance_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_gwt_DashboardGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'DashboardGWTService_TypeSerializer', 2815), Lcom_smartgwt_client_widgets_layout_VStack_2_classLit = createForClass('com.smartgwt.client.widgets.layout.', 'VStack', 559), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortalColumn_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortalColumn', 2463), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow', 2476), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$1', 2477), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$2', 2482), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$3', 2483), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$4', 2484), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$5', 2485), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$6', 2486), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$7', 2487), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$8', 2488), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$9', 2489), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$10', 2478), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$11', 2479), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$12', 2480), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletWindow$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletWindow$13', 2481), Lorg_rhq_enterprise_gui_coregui_client_gwt_AuthorizationGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AuthorizationGWTService_Proxy', 2796), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTitleBar_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTitleBar', 3352), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTitleBar$UpdateFavoritesCallback_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTitleBar$UpdateFavoritesCallback', 3361), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTitleBar$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTitleBar$1', 3353), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTitleBar$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTitleBar$2', 3354), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTitleBar$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTitleBar$3', 3355), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTitleBar$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTitleBar$3$1', 3356), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTitleBar$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTitleBar$4', 3357), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTitleBar$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTitleBar$5', 3358), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTitleBar$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTitleBar$6', 3359), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceTitleBar$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceTitleBar$7', 3360), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTitleBar_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTitleBar', 3091), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTitleBar$UpdateFavoritesCallback_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTitleBar$UpdateFavoritesCallback', 3098), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTitleBar$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTitleBar$1', 3092), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTitleBar$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTitleBar$2', 3093), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTitleBar$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTitleBar$2$1', 3094), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTitleBar$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTitleBar$3', 3095), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTitleBar$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTitleBar$3$1', 3096), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_ResourceGroupTitleBar$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'ResourceGroupTitleBar$4', 3097), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryListView', 2623), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationHistoryListView', 3437), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationHistoryListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationHistoryListView$1', 3438), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationHistoryListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationHistoryListView$2', 3439), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryListView$1', 3407), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryListView$2', 3408), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryListView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryListView$2$1', 3409), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryListView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryListView$3', 3410), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryListView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryListView$4', 3411), Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTabLayout_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tab.', 'SubTabLayout', 2359), Lorg_rhq_enterprise_gui_coregui_client_components_tab_SubTabLayout$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tab.', 'SubTabLayout$1', 2360), Lorg_rhq_enterprise_gui_coregui_client_components_tab_TwoLevelTabSelectedEvent_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tab.', 'TwoLevelTabSelectedEvent', 2362), Lorg_rhq_core_domain_criteria_TagCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'TagCriteria', 1158), Lcom_smartgwt_client_types_DSProtocol_2_classLit = createForEnum('com.smartgwt.client.types.', 'DSProtocol', 368, Ljava_lang_Enum_2_classLit, values_11, valueOf_12), _3Lcom_smartgwt_client_types_DSProtocol_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'DSProtocol;', 3940, Lcom_smartgwt_client_types_DSProtocol_2_classLit), Lcom_smartgwt_client_types_DSDataFormat_2_classLit = createForEnum('com.smartgwt.client.types.', 'DSDataFormat', 364, Ljava_lang_Enum_2_classLit, values_9, valueOf_10), _3Lcom_smartgwt_client_types_DSDataFormat_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'DSDataFormat;', 3941, Lcom_smartgwt_client_types_DSDataFormat_2_classLit), Lcom_smartgwt_client_types_DSOperationType_2_classLit = createForEnum('com.smartgwt.client.types.', 'DSOperationType', 366, Ljava_lang_Enum_2_classLit, values_10, valueOf_11), _3Lcom_smartgwt_client_types_DSOperationType_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'DSOperationType;', 3943, Lcom_smartgwt_client_types_DSOperationType_2_classLit), Lcom_smartgwt_client_types_ImageStyle_2_classLit = createForEnum('com.smartgwt.client.types.', 'ImageStyle', 390, Ljava_lang_Enum_2_classLit, values_22, valueOf_23), _3Lcom_smartgwt_client_types_ImageStyle_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'ImageStyle;', 3944, Lcom_smartgwt_client_types_ImageStyle_2_classLit), Lcom_smartgwt_client_widgets_events_DropEvent_2_classLit = createForClass('com.smartgwt.client.widgets.events.', 'DropEvent', 468), Lcom_smartgwt_client_widgets_events_DragResizeStartEvent_2_classLit = createForClass('com.smartgwt.client.widgets.events.', 'DragResizeStartEvent', 465), Lcom_smartgwt_client_widgets_events_ResizedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.events.', 'ResizedEvent', 473), Lcom_smartgwt_client_widgets_HeaderControl_2_classLit = createForClass('com.smartgwt.client.widgets.', 'HeaderControl', 449), Lcom_smartgwt_client_widgets_HeaderControl$HeaderIcon_2_classLit = createForClass('com.smartgwt.client.widgets.', 'HeaderControl$HeaderIcon', 451), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletFactory$1InvalidPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletFactory$1InvalidPortlet', 2469), Lcom_smartgwt_client_types_DragAppearance_2_classLit = createForEnum('com.smartgwt.client.types.', 'DragAppearance', 372, Ljava_lang_Enum_2_classLit, values_13, valueOf_14), _3Lcom_smartgwt_client_types_DragAppearance_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'DragAppearance;', 3945, Lcom_smartgwt_client_types_DragAppearance_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_gwt_AuthorizationGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AuthorizationGWTService_TypeSerializer', 2797), Lorg_rhq_enterprise_gui_coregui_client_content_repository_tree_ContentRepositoryTreeView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.content.repository.tree.', 'ContentRepositoryTreeView', 2437), Lorg_rhq_enterprise_gui_coregui_client_content_repository_tree_ContentRepositoryTreeView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.content.repository.tree.', 'ContentRepositoryTreeView$1', 2438), Lorg_rhq_enterprise_gui_coregui_client_bundle_tree_BundleTreeView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.tree.', 'BundleTreeView', 2180), Lorg_rhq_enterprise_gui_coregui_client_bundle_tree_BundleTreeView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.tree.', 'BundleTreeView$1', 2181), Lorg_rhq_enterprise_gui_coregui_client_bundle_tree_BundleTreeView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.tree.', 'BundleTreeView$2', 2182), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesListView', 2152), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesListView$1', 2153), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesListView$2', 2154), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesListView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesListView$3', 2155), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesListView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesListView$4', 2156), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesListView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesListView$5', 2157), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesListView$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesListView$5$1', 2158), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesListView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesListView$6', 2159), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesListView$6$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesListView$6$1', 2160), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleView', 2142), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleView$1', 2143), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleView$1$1', 2144), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleView$2', 2145), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleView$2$1', 2146), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleView$3', 2147), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleView$3$1', 2148), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleView$3$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleView$3$1$1', 2149), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleView$4', 2150), Lcom_smartgwt_client_widgets_tab_events_TabSelectedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.tab.events.', 'TabSelectedEvent', 570), Lorg_rhq_enterprise_gui_coregui_client_gwt_AlertGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AlertGWTService_Proxy', 2790), Lorg_rhq_core_domain_criteria_AlertCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'AlertCriteria', 1069), Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition$PropertyDefinitionComparator_2_classLit = createForClass('org.rhq.core.domain.configuration.definition.', 'ConfigurationDefinition$PropertyDefinitionComparator', 915), Lorg_rhq_core_domain_configuration_definition_ConfigurationDefinition$GroupComparator_2_classLit = createForClass('org.rhq.core.domain.configuration.definition.', 'ConfigurationDefinition$GroupComparator', 914), Lorg_rhq_core_domain_configuration_definition_PropertyDefinitionMap$1_2_classLit = createForClass('org.rhq.core.domain.configuration.definition.', 'PropertyDefinitionMap$1', 928), _3Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit = createForArray('[Lorg.rhq.core.domain.configuration.definition.constraint.', 'Constraint;', 3971, Lorg_rhq_core_domain_configuration_definition_constraint_Constraint_2_classLit), _3Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit = createForArray('[Lorg.rhq.core.domain.configuration.definition.', 'PropertyDefinition;', 3972, Lorg_rhq_core_domain_configuration_definition_PropertyDefinition_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_summary_InventorySummaryPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.summary.', 'InventorySummaryPortlet', 2644), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_summary_InventorySummaryPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.summary.', 'InventorySummaryPortlet$Factory', 2647), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_summary_InventorySummaryPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.summary.', 'InventorySummaryPortlet$1', 2645), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_summary_InventorySummaryPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.summary.', 'InventorySummaryPortlet$2', 2646), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_imported_RecentlyAddedResourcesPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.imported.', 'RecentlyAddedResourcesPortlet', 2583), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_imported_RecentlyAddedResourcesPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.imported.', 'RecentlyAddedResourcesPortlet$Factory', 2586), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_imported_RecentlyAddedResourcesPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.imported.', 'RecentlyAddedResourcesPortlet$1', 2584), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_imported_RecentlyAddedResourcesPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.imported.', 'RecentlyAddedResourcesPortlet$2', 2585), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_platform_PlatformSummaryPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.platform.', 'PlatformSummaryPortlet', 2570), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_platform_PlatformSummaryPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.platform.', 'PlatformSummaryPortlet$Factory', 2574), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_platform_PlatformSummaryPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.platform.', 'PlatformSummaryPortlet$1', 2571), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_platform_PlatformSummaryPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.platform.', 'PlatformSummaryPortlet$2', 2572), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_platform_PlatformSummaryPortlet$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.platform.', 'PlatformSummaryPortlet$3', 2573), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView', 2552), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_queue_AutodiscoveryPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.queue.', 'AutodiscoveryPortlet', 2551), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_queue_AutodiscoveryPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.queue.', 'AutodiscoveryPortlet$Factory', 2555), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_queue_AutodiscoveryPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.queue.', 'AutodiscoveryPortlet$1', 2553), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_queue_AutodiscoveryPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.queue.', 'AutodiscoveryPortlet$2', 2554), Lcom_smartgwt_client_widgets_tree_TreeGridField_2_classLit = createForClass('com.smartgwt.client.widgets.tree.', 'TreeGridField', 576), _3Lcom_smartgwt_client_widgets_tree_TreeGridField_2_classLit = createForArray('[Lcom.smartgwt.client.widgets.tree.', 'TreeGridField;', 3991, Lcom_smartgwt_client_widgets_tree_TreeGridField_2_classLit), _3Lcom_smartgwt_client_widgets_IButton_2_classLit = createForArray('[Lcom.smartgwt.client.widgets.', 'IButton;', 3992, Lcom_smartgwt_client_widgets_IButton_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$1', 3519), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$2', 3520), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$3', 3521), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$3$1', 3522), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$4', 3523), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$5', 3524), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$5$1', 3525), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$6', 3526), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$7', 3527), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$7$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$7$1', 3528), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$8', 3529), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$8$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$8$1', 3530), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$9', 3531), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_ResourceAutodiscoveryView$9$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'ResourceAutodiscoveryView$9$1', 3532), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_alerts_AbstractRecentAlertsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.alerts.', 'AbstractRecentAlertsPortlet', 2496), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_alerts_RecentAlertsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.alerts.', 'RecentAlertsPortlet', 2578), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_alerts_RecentAlertsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.alerts.', 'RecentAlertsPortlet$Factory', 2579), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_alerts_AbstractRecentAlertsPortlet$AlertsPortletDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.alerts.', 'AbstractRecentAlertsPortlet$AlertsPortletDataSource', 2577), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_alerts_AbstractRecentAlertsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.alerts.', 'AbstractRecentAlertsPortlet$1', 2575), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_alerts_AbstractRecentAlertsPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.alerts.', 'AbstractRecentAlertsPortlet$2', 2576), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_MetricD3GraphView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'MetricD3GraphView', 2543), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_graph_ResourceD3GraphPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.graph.', 'ResourceD3GraphPortlet', 2560), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_graph_ResourceD3GraphPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.graph.', 'ResourceD3GraphPortlet$Factory', 2567), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_graph_ResourceD3GraphPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.graph.', 'ResourceD3GraphPortlet$1', 2561), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_graph_ResourceD3GraphPortlet$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.graph.', 'ResourceD3GraphPortlet$1$1', 2562), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_graph_ResourceD3GraphPortlet$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.graph.', 'ResourceD3GraphPortlet$1$1$1', 2563), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_graph_ResourceD3GraphPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.graph.', 'ResourceD3GraphPortlet$2', 2564), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_graph_ResourceD3GraphPortlet$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.graph.', 'ResourceD3GraphPortlet$3', 2565), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_graph_ResourceD3GraphPortlet$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.graph.', 'ResourceD3GraphPortlet$4', 2566), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_MetricD3GraphView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'MetricD3GraphView$1', 3463), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_groups_graph_ResourceGroupD3GraphPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.groups.graph.', 'ResourceGroupD3GraphPortlet', 2542), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_groups_graph_ResourceGroupD3GraphPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.groups.graph.', 'ResourceGroupD3GraphPortlet$Factory', 2550), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_groups_graph_ResourceGroupD3GraphPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.groups.graph.', 'ResourceGroupD3GraphPortlet$1', 2544), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_groups_graph_ResourceGroupD3GraphPortlet$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.groups.graph.', 'ResourceGroupD3GraphPortlet$1$1', 2545), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_groups_graph_ResourceGroupD3GraphPortlet$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.groups.graph.', 'ResourceGroupD3GraphPortlet$1$1$1', 2546), Lorg_rhq_enterprise_gui_coregui_client_components_form_SortedSelectItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'SortedSelectItem', 2317), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_groups_graph_ResourceGroupD3GraphPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.groups.graph.', 'ResourceGroupD3GraphPortlet$2', 2547), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_groups_graph_ResourceGroupD3GraphPortlet$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.groups.graph.', 'ResourceGroupD3GraphPortlet$3', 2548), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_groups_graph_ResourceGroupD3GraphPortlet$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.groups.graph.', 'ResourceGroupD3GraphPortlet$4', 2549), Lorg_rhq_enterprise_gui_coregui_client_components_form_SortedSelectItem$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'SortedSelectItem$1', 2318), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_summary_TagCloudPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.summary.', 'TagCloudPortlet', 2648), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_summary_TagCloudPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.summary.', 'TagCloudPortlet$Factory', 2650), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_FavoriteResourcesPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.', 'FavoriteResourcesPortlet', 2556), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_FavoriteResourcesPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.', 'FavoriteResourcesPortlet$Factory', 2559), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_inventory_resource_FavoriteResourcesPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.inventory.resource.', 'FavoriteResourcesPortlet$1', 2558), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView', 2492), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_FavoriteGroupsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'FavoriteGroupsPortlet', 2491), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_FavoriteGroupsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'FavoriteGroupsPortlet$Factory', 2494), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_FavoriteGroupsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'FavoriteGroupsPortlet$1', 2493), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView$1', 2982), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView$2', 2983), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView$3', 2984), Lorg_rhq_enterprise_gui_coregui_client_components_table_AuthorizedTableAction_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'AuthorizedTableAction', 1607), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView$4', 2985), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView$4$1', 2986), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView$5', 2987), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView$6', 2988), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView$6$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView$6$1', 2989), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView$6$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView$6$2', 2990), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupListView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupListView$7', 2991), Lorg_rhq_enterprise_gui_coregui_client_components_table_AuthorizedTableAction$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'AuthorizedTableAction$1', 2368), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_util_MashupPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.util.', 'MashupPortlet', 2651), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_util_MashupPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.util.', 'MashupPortlet$Factory', 2652), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_util_MessagePortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.util.', 'MessagePortlet', 2653), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_util_MessagePortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.util.', 'MessagePortlet$Factory', 2654), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_problems_ProblemResourcesPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.problems.', 'ProblemResourcesPortlet', 2603), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_problems_ProblemResourcesPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.problems.', 'ProblemResourcesPortlet$Factory', 2607), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_problems_TimeRange_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.problems.', 'TimeRange', 2608), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_problems_ProblemResourcesPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.problems.', 'ProblemResourcesPortlet$1', 2604), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_problems_ProblemResourcesPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.problems.', 'ProblemResourcesPortlet$2', 2605), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_problems_ProblemResourcesPortlet$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.problems.', 'ProblemResourcesPortlet$3', 2606), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryView', 2588), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_AbstractOperationHistoryPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'AbstractOperationHistoryPortlet', 2587), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationHistoryPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationHistoryPortlet', 2592), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationHistoryPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationHistoryPortlet$Factory', 2593), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource', 2591), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_AbstractOperationHistoryPortlet$OperationHistoryPortletDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'AbstractOperationHistoryPortlet$OperationHistoryPortletDataSource', 2590), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_AbstractOperationHistoryPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'AbstractOperationHistoryPortlet$1', 2589), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryView$1', 3598), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryView$1$1', 3599), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryView$2', 3600), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryView$3', 3601), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryView$4', 3602), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource$1', 3588), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource$2', 3589), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource$3', 3590), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource$4', 3591), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource$5', 3592), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource$6', 3593), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource$6$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource$6$1', 3594), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource$7', 3595), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource$8', 3596), Lorg_rhq_enterprise_gui_coregui_client_operation_OperationHistoryDataSource$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'OperationHistoryDataSource$9', 3597), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationSchedulePortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationSchedulePortlet', 2594), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationSchedulePortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationSchedulePortlet$Factory', 2602), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationSchedulePortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationSchedulePortlet$1', 2595), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationSchedulePortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationSchedulePortlet$2', 2596), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationSchedulePortlet$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationSchedulePortlet$3', 2597), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationSchedulePortlet$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationSchedulePortlet$4', 2598), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationSchedulePortlet$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationSchedulePortlet$5', 2599), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationSchedulePortlet$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationSchedulePortlet$6', 2600), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_operations_OperationSchedulePortlet$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.operations.', 'OperationSchedulePortlet$7', 2601), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupAlertsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupAlertsPortlet', 2495), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupAlertsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupAlertsPortlet$Factory', 2497), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupMetricsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupMetricsPortlet', 2515), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupMetricsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupMetricsPortlet$Factory', 2521), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupMetricsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupMetricsPortlet$1', 2516), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupMetricsPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupMetricsPortlet$2', 2517), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupMetricsPortlet$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupMetricsPortlet$2$1', 2518), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupMetricsPortlet$2$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupMetricsPortlet$2$1$1', 2519), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupMetricsPortlet$2$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupMetricsPortlet$2$1$1$1', 2520), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOobsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOobsPortlet', 2522), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOobsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOobsPortlet$Factory', 2526), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOobsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOobsPortlet$1', 2523), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOobsPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOobsPortlet$2', 2524), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOobsPortlet$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOobsPortlet$2$1', 2525), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupEventsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupEventsPortlet', 2511), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupEventsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupEventsPortlet$Factory', 2514), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupEventsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupEventsPortlet$1', 2512), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupEventsPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupEventsPortlet$2', 2513), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOperationsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOperationsPortlet', 2534), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOperationsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOperationsPortlet$Factory', 2537), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView', 2533), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupOperationHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.history.', 'GroupOperationHistoryListView', 2532), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOperationsCriteriaHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOperationsCriteriaHistoryListView', 2531), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryDataSource', 2529), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupOperationHistoryDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.history.', 'GroupOperationHistoryDataSource', 2528), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOperationsCriteriaDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOperationsCriteriaDataSource', 2527), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOperationsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOperationsPortlet$1', 2535), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOperationsPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOperationsPortlet$2', 2536), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupOperationsCriteriaDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupOperationsCriteriaDataSource$1', 2530), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$1', 2936), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$1$1', 2937), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$2', 2939), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$3', 2940), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$4', 2941), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$5', 2942), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$6', 2943), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$7', 2944), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$7$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$7$1', 2945), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$8', 2946), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$9', 2947), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryListView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryListView$10', 2938), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupOperationHistoryDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.history.', 'GroupOperationHistoryDataSource$1', 3221), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryDataSource$1', 2932), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupPkgHistoryPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupPkgHistoryPortlet', 2538), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupPkgHistoryPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupPkgHistoryPortlet$Factory', 2541), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupPkgHistoryPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupPkgHistoryPortlet$1', 2539), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupPkgHistoryPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupPkgHistoryPortlet$2', 2540), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupBundleDeploymentsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupBundleDeploymentsPortlet', 2498), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupBundleDeploymentsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupBundleDeploymentsPortlet$Factory', 2501), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupBundleDeploymentsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupBundleDeploymentsPortlet$1', 2499), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupBundleDeploymentsPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupBundleDeploymentsPortlet$2', 2500), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupConfigurationUpdatesPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupConfigurationUpdatesPortlet', 2502), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupConfigurationUpdatesPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupConfigurationUpdatesPortlet$Factory', 2505), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationTable', 2507), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupConfigurationUpdatesPortlet$GroupConfigurationHistoryCriteriaTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupConfigurationUpdatesPortlet$GroupConfigurationHistoryCriteriaTable', 2506), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_GroupResourceConfigurationDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'GroupResourceConfigurationDataSource', 2509), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupConfigurationUpdatesPortlet$GroupConfigurationUdpatesCriteriaDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupConfigurationUpdatesPortlet$GroupConfigurationUdpatesCriteriaDataSource', 2508), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupConfigurationUpdatesPortlet$GroupConfigurationUdpatesCriteriaDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupConfigurationUpdatesPortlet$GroupConfigurationUdpatesCriteriaDataSource$1', 2510), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupConfigurationUpdatesPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupConfigurationUpdatesPortlet$1', 2503), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_groups_GroupConfigurationUpdatesPortlet$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.groups.', 'GroupConfigurationUpdatesPortlet$2', 2504), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationTable$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationTable$1', 3133), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationTable$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationTable$2', 3134), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationTable$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationTable$3', 3135), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationTable$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationTable$3$1', 3136), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationTable$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationTable$4', 3137), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationTable$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationTable$5', 3138), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_GroupResourceConfigurationDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'GroupResourceConfigurationDataSource$1', 3113), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceMetricsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceMetricsPortlet', 2628), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceMetricsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceMetricsPortlet$Factory', 2634), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceMetricsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceMetricsPortlet$1', 2629), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceMetricsPortlet$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceMetricsPortlet$1$1', 2630), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceMetricsPortlet$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceMetricsPortlet$1$1$1', 2631), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceMetricsPortlet$1$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceMetricsPortlet$1$1$1$1', 2632), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceMetricsPortlet$1$1$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceMetricsPortlet$1$1$1$1$1', 2633), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceEventsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceEventsPortlet', 2625), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceEventsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceEventsPortlet$Factory', 2627), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceEventsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceEventsPortlet$1', 2626), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceOobsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceOobsPortlet', 2635), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceOobsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceOobsPortlet$Factory', 2638), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceOobsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceOobsPortlet$1', 2636), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceOobsPortlet$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceOobsPortlet$1$1', 2637), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceAlertsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceAlertsPortlet', 2609), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceAlertsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceAlertsPortlet$Factory', 2610), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceOperationsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceOperationsPortlet', 2639), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceOperationsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceOperationsPortlet$Factory', 2640), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourcePkgHistoryPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourcePkgHistoryPortlet', 2641), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourcePkgHistoryPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourcePkgHistoryPortlet$Factory', 2643), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourcePkgHistoryPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourcePkgHistoryPortlet$1', 2642), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceBundleDeploymentsPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceBundleDeploymentsPortlet', 2611), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceBundleDeploymentsPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceBundleDeploymentsPortlet$Factory', 2613), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceBundleDeploymentsPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceBundleDeploymentsPortlet$1', 2612), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceConfigurationUpdatesPortlet_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceConfigurationUpdatesPortlet', 2614), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceConfigurationUpdatesPortlet$Factory_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceConfigurationUpdatesPortlet$Factory', 2620), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationHistoryListView', 2622), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView', 2621), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryDataSource', 2618), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationHistoryDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationHistoryDataSource', 2617), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceConfigurationUpdatesPortlet$ConfigurationUdpatesCriteriaDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceConfigurationUpdatesPortlet$ConfigurationUdpatesCriteriaDataSource', 2616), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceConfigurationUpdatesPortlet$ResourceConfigurationHistoryCriteriaView$1', 2624), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceConfigurationUpdatesPortlet$ConfigurationUdpatesCriteriaDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceConfigurationUpdatesPortlet$ConfigurationUdpatesCriteriaDataSource$1', 2619), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_resource_ResourceConfigurationUpdatesPortlet$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.resource.', 'ResourceConfigurationUpdatesPortlet$1', 2615), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationHistoryListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationHistoryListView$1', 3424), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationHistoryListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationHistoryListView$2', 3425), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationHistoryDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationHistoryDataSource$1', 3421), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationHistoryDataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationHistoryDataSource$1$1', 3422), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationHistoryDataSource$1$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationHistoryDataSource$1$2', 3423), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryDataSource$1', 3400), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryDataSource$2', 3401), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryDataSource$3', 3402), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryDataSource$4', 3403), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryDataSource$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryDataSource$5', 3404), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryDataSource$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryDataSource$6', 3405), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_AbstractConfigurationHistoryDataSource$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'AbstractConfigurationHistoryDataSource$7', 3406), Lcom_smartgwt_client_widgets_events_MouseOverEvent_2_classLit = createForClass('com.smartgwt.client.widgets.events.', 'MouseOverEvent', 472), Lcom_smartgwt_client_types_HeaderControls_2_classLit = createForEnum('com.smartgwt.client.types.', 'HeaderControls', 388, Ljava_lang_Enum_2_classLit, values_21, valueOf_22), _3Lcom_smartgwt_client_types_HeaderControls_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'HeaderControls;', 3993, Lcom_smartgwt_client_types_HeaderControls_2_classLit), Lcom_smartgwt_client_widgets_events_DragResizeStopEvent_2_classLit = createForClass('com.smartgwt.client.widgets.events.', 'DragResizeStopEvent', 466), Lorg_rhq_enterprise_gui_coregui_client_bundle_tree_BundleTreeDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.tree.', 'BundleTreeDataSource', 2175), Lorg_rhq_enterprise_gui_coregui_client_bundle_tree_BundleTreeDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.tree.', 'BundleTreeDataSource$1', 2176), Lorg_rhq_enterprise_gui_coregui_client_bundle_tree_BundleTreeDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.tree.', 'BundleTreeDataSource$2', 2177), Lorg_rhq_enterprise_gui_coregui_client_bundle_tree_BundleTreeDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.tree.', 'BundleTreeDataSource$3', 2178), Lorg_rhq_enterprise_gui_coregui_client_bundle_tree_BundleTreeDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.tree.', 'BundleTreeDataSource$4', 2179), Lorg_rhq_enterprise_gui_coregui_client_content_repository_tree_ContentRepositoryTreeDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.content.repository.tree.', 'ContentRepositoryTreeDataSource', 2435), Lorg_rhq_enterprise_gui_coregui_client_content_repository_tree_ContentRepositoryTreeDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.content.repository.tree.', 'ContentRepositoryTreeDataSource$1', 2436), Lorg_rhq_core_domain_criteria_BundleCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'BundleCriteria', 1075), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionView', 2187), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionView$1', 2188), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionView$1$1', 2189), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionView$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionView$1$1$1', 2190), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionView$2', 2191), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionView$2$1', 2192), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionView$3', 2193), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionView$4', 2194), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView', 2097), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$1', 2098), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$2', 2099), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$3', 2100), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$3$1', 2101), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$3$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$3$1$1', 2102), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$4', 2103), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$4$1', 2104), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$4$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$4$1$1', 2105), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$5', 2106), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$5$1', 2107), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$6', 2108), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$7', 2109), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$8', 2110), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$8$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$8$1', 2111), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentView$8$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentView$8$1$1', 2112), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView', 2126), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$1', 2127), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$1$1', 2128), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$2', 2129), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$3', 2130), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$3$1', 2131), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$4', 2132), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$4$1', 2133), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$4$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$4$1$1', 2134), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$5', 2135), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$5$1', 2136), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$5$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$5$1$1', 2137), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$6', 2138), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationView$7', 2139), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_AbstractD3GraphListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'AbstractD3GraphListView', 2906), Lorg_rhq_enterprise_gui_coregui_client_gwt_TagGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'TagGWTService_Proxy', 2882), Lorg_rhq_enterprise_gui_coregui_client_gwt_AlertGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AlertGWTService_TypeSerializer', 2791), Lorg_rhq_core_domain_resource_group_ClusterKey_2_classLit = createForClass('org.rhq.core.domain.resource.group.', 'ClusterKey', 1459), Lorg_rhq_core_domain_resource_group_ClusterKey$Node_2_classLit = createForClass('org.rhq.core.domain.resource.group.', 'ClusterKey$Node', 1460), Ljava_util_Comparators$1_2_classLit = createForClass('java.util.', 'Comparators$1', 654), Lcom_smartgwt_client_widgets_events_MinimizeClickEvent_2_classLit = createForClass('com.smartgwt.client.widgets.events.', 'MinimizeClickEvent', 470), Lcom_smartgwt_client_widgets_events_RestoreClickEvent_2_classLit = createForClass('com.smartgwt.client.widgets.events.', 'RestoreClickEvent', 474), Lorg_rhq_enterprise_gui_coregui_client_report_measurement_MeasurementOOBView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.measurement.', 'MeasurementOOBView', 3658), Lorg_rhq_enterprise_gui_coregui_client_report_measurement_MeasurementOOBView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.measurement.', 'MeasurementOOBView$1', 3659), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView', 3610), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_AbstractAlertDefinitionsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'AbstractAlertDefinitionsDataSource', 1895), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView$DataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView$DataSource', 3613), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView$DataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView$DataSource$1', 3614), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView$DataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView$DataSource$2', 3615), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView$DataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView$DataSource$3', 3616), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView$DataSource$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView$DataSource$3$1', 3617), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView$DataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView$DataSource$4', 3618), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView$DataSource$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView$DataSource$5', 3619), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView$DataSource$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView$DataSource$6', 3620), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView$1', 3611), Lorg_rhq_enterprise_gui_coregui_client_report_AlertDefinitionReportView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'AlertDefinitionReportView$2', 3612), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_AbstractAlertDefinitionsDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'AbstractAlertDefinitionsDataSource$1', 1896), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_AbstractAlertDefinitionsDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'AbstractAlertDefinitionsDataSource$2', 1897), Lorg_rhq_enterprise_gui_coregui_client_components_table_StringIDTableSection_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'StringIDTableSection', 2374), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftHistoryView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftHistoryView', 2656), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftHistoryView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftHistoryView$1', 2728), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_ResourceInstallReport_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'ResourceInstallReport', 3652), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_DriftComplianceReport_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'DriftComplianceReport', 3644), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UsersView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UsersView', 1859), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UsersView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UsersView$1', 1860), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UsersView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UsersView$2', 1861), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UsersView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UsersView$3', 1862), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UsersView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UsersView$3$1', 1863), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RolesView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RolesView', 1712), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RolesView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RolesView$1', 1713), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RolesView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RolesView$2', 1714), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RolesView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RolesView$3', 1715), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView', 1676), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$1', 1677), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$2', 1680), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$3', 1681), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$4', 1682), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$5', 1683), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$6', 1684), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$7', 1685), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$8', 1686), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$9', 1687), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$10', 1678), Lorg_rhq_enterprise_gui_coregui_client_admin_agent_install_RemoteAgentInstallView$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.agent.install.', 'RemoteAgentInstallView$11', 1679), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerTableView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerTableView', 1836), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerTableView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerTableView$1', 1837), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerTableView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerTableView$2', 1838), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerTableView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerTableView$3', 1839), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerTableView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerTableView$3$1', 1840), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerTableView$3$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerTableView$3$1$1', 1841), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerTableView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerTableView$4', 1842), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerTableView$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerTableView$4$1', 1843), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerTableView$4$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerTableView$4$1$1', 1844), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerTableView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerTableView$5', 1845), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentTableView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentTableView', 1804), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentTableView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentTableView$1', 1805), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentTableView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentTableView$2', 1806), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentTableView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentTableView$3', 1807), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentTableView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentTableView$4', 1808), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentTableView$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentTableView$4$1', 1809), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentTableView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentTableView$5', 1810), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupTableView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupTableView', 1785), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupTableView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupTableView$1', 1786), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupTableView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupTableView$2', 1787), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupTableView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupTableView$2$1', 1788), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupTableView$2$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupTableView$2$1$1', 1789), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupTableView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupTableView$3', 1790), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupTableView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupTableView$4', 1791), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupTableView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupTableView$5', 1792), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupTableView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupTableView$6', 1793), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventTableView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventTableView', 1821), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventTableView$TableAction_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventTableView$TableAction', 1826, Ljava_lang_Enum_2_classLit, values_124, valueOf_130), _3Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventTableView$TableAction_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventTableView$TableAction;', 3994, Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventTableView$TableAction_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventTableView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventTableView$1', 1822), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventTableView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventTableView$2', 1823), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventTableView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventTableView$2$1', 1824), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventTableView$2$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventTableView$2$1$1', 1825), Lorg_rhq_enterprise_gui_coregui_client_admin_SystemSettingsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'SystemSettingsView', 1669), Lorg_rhq_enterprise_gui_coregui_client_admin_SystemSettingsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'SystemSettingsView$1', 1670), Lorg_rhq_enterprise_gui_coregui_client_admin_SystemSettingsView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'SystemSettingsView$1$1', 1671), Lorg_rhq_enterprise_gui_coregui_client_admin_SystemSettingsView$1$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'SystemSettingsView$1$2', 1672), Lorg_rhq_enterprise_gui_coregui_client_admin_SystemSettingsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'SystemSettingsView$2', 1673), Lorg_rhq_enterprise_gui_coregui_client_admin_SystemSettingsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'SystemSettingsView$3', 1674), Lorg_rhq_enterprise_gui_coregui_client_admin_SystemSettingsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'SystemSettingsView$4', 1675), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeView', 1717), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_AlertDefinitionTemplateTypeView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'AlertDefinitionTemplateTypeView', 1716), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeNodeBuilder_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeNodeBuilder', 1721), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_AlertDefinitionTemplateTypeView$NodeBuilder_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'AlertDefinitionTemplateTypeView$NodeBuilder', 1720), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeNodeBuilder$ResourceTypeListGridRecord', 1723), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_AlertDefinitionTemplateTypeView$NodeBuilder$GridRecord_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'AlertDefinitionTemplateTypeView$NodeBuilder$GridRecord', 1722), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeNodeBuilder$ResourceTypeTreeNode', 1725), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_AlertDefinitionTemplateTypeView$NodeBuilder$TreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'AlertDefinitionTemplateTypeView$NodeBuilder$TreeNode', 1724), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_AlertDefinitionTemplateTypeView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'AlertDefinitionTemplateTypeView$1', 1718), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_AlertDefinitionTemplateTypeView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'AlertDefinitionTemplateTypeView$2', 1719), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeView$CustomResourceTypeListGrid_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeView$CustomResourceTypeListGrid', 1746), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeView$CustomResourceTypeTreeGrid_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeView$CustomResourceTypeTreeGrid', 1749), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeView$CustomResourceTypeListGrid$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeView$CustomResourceTypeListGrid$1', 1747), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeView$CustomResourceTypeListGrid$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeView$CustomResourceTypeListGrid$1$1', 1748), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeView$CustomResourceTypeTreeGrid$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeView$CustomResourceTypeTreeGrid$1', 1750), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeView$CustomResourceTypeTreeGrid$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeView$CustomResourceTypeTreeGrid$1$1', 1751), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeView$1', 1745), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_ResourceTypeTreeNodeBuilder$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'ResourceTypeTreeNodeBuilder$1', 1744), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_DriftDefinitionTemplateTypeView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'DriftDefinitionTemplateTypeView', 1726), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_DriftDefinitionTemplateTypeView$NodeBuilder_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'DriftDefinitionTemplateTypeView$NodeBuilder', 1729), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_DriftDefinitionTemplateTypeView$NodeBuilder$GridRecord_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'DriftDefinitionTemplateTypeView$NodeBuilder$GridRecord', 1730), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_DriftDefinitionTemplateTypeView$NodeBuilder$TreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'DriftDefinitionTemplateTypeView$NodeBuilder$TreeNode', 1731), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_DriftDefinitionTemplateTypeView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'DriftDefinitionTemplateTypeView$1', 1727), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_DriftDefinitionTemplateTypeView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'DriftDefinitionTemplateTypeView$2', 1728), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_MetricTemplateTypeView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'MetricTemplateTypeView', 1739), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_MetricTemplateTypeView$NodeBuilder_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'MetricTemplateTypeView$NodeBuilder', 1741), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_MetricTemplateTypeView$NodeBuilder$GridRecord_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'MetricTemplateTypeView$NodeBuilder$GridRecord', 1742), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_MetricTemplateTypeView$NodeBuilder$TreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'MetricTemplateTypeView$NodeBuilder$TreeNode', 1743), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_MetricTemplateTypeView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'MetricTemplateTypeView$1', 1740), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_IgnoreResourceTypesView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'IgnoreResourceTypesView', 1732), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_IgnoreResourceTypesView$NodeBuilder_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'IgnoreResourceTypesView$NodeBuilder', 1736), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_IgnoreResourceTypesView$NodeBuilder$GridRecord_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'IgnoreResourceTypesView$NodeBuilder$GridRecord', 1737), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_IgnoreResourceTypesView$NodeBuilder$TreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'IgnoreResourceTypesView$NodeBuilder$TreeNode', 1738), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_IgnoreResourceTypesView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'IgnoreResourceTypesView$1', 1733), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_IgnoreResourceTypesView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'IgnoreResourceTypesView$1$1', 1734), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_IgnoreResourceTypesView$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'IgnoreResourceTypesView$1$1$1', 1735), Lorg_rhq_enterprise_gui_coregui_client_admin_DownloadsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'DownloadsView', 1624), Lorg_rhq_enterprise_gui_coregui_client_admin_DownloadsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'DownloadsView$1', 1625), Lorg_rhq_enterprise_gui_coregui_client_admin_DownloadsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'DownloadsView$2', 1626), Lorg_rhq_enterprise_gui_coregui_client_admin_DownloadsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'DownloadsView$3', 1627), Lorg_rhq_enterprise_gui_coregui_client_admin_DownloadsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'DownloadsView$4', 1628), Lorg_rhq_enterprise_gui_coregui_client_admin_DownloadsView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'DownloadsView$5', 1629), Lorg_rhq_enterprise_gui_coregui_client_admin_DownloadsView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'DownloadsView$6', 1630), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView', 1602), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$AgentPluginDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$AgentPluginDataSource', 1621), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$AgentPluginDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$AgentPluginDataSource$1', 1623), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$1', 1606), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$1$1', 1609), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$2', 1610), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$2$1', 1611), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$2$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$2$1$1', 1612), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$3', 1613), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$3$1', 1614), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$3$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$3$1$1', 1615), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$4', 1616), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$4$1', 1617), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$5', 1618), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$5$1', 1619), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginTableView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginTableView$6', 1620), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView', 1651), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$ServerPluginDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$ServerPluginDataSource', 1667), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$ServerPluginDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$ServerPluginDataSource$1', 1668), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$1', 1652), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$1$1', 1653), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$2', 1654), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$2$1', 1655), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$2$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$2$1$1', 1656), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$3', 1657), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$3$1', 1658), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$3$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$3$1$1', 1659), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$4', 1660), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$4$1', 1661), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$5', 1662), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$5$1', 1663), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$6', 1664), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$6$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$6$1', 1665), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginTableView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginTableView$7', 1666), Ljava_util_MissingResourceException_2_classLit = createForClass('java.util.', 'MissingResourceException', 678), Lcom_smartgwt_client_widgets_grid_events_GridRowColEvent_2_classLit = createForClass('com.smartgwt.client.widgets.grid.events.', 'GridRowColEvent', 542), Lcom_smartgwt_client_widgets_grid_events_CellClickEvent_2_classLit = createForClass('com.smartgwt.client.widgets.grid.events.', 'CellClickEvent', 541), Lcom_smartgwt_client_widgets_tree_events_NodeClickEvent_2_classLit = createForClass('com.smartgwt.client.widgets.tree.events.', 'NodeClickEvent', 579), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesWithLatestVersionDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesWithLatestVersionDataSource', 2161), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesWithLatestVersionDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesWithLatestVersionDataSource$1', 2162), Lorg_rhq_enterprise_gui_coregui_client_components_HeaderLabel_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.', 'HeaderLabel', 2200), Lorg_rhq_enterprise_gui_coregui_client_util_enhanced_EnhancedLayout_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.enhanced.', 'EnhancedLayout', 2391), Lorg_rhq_enterprise_gui_coregui_client_components_tagging_TagEditorView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tagging.', 'TagEditorView', 2390), Lcom_smartgwt_client_widgets_Dialog_2_classLit = createForClass('com.smartgwt.client.widgets.', 'Dialog', 443), Lorg_rhq_enterprise_gui_coregui_client_components_tagging_TagEditorView$TagInputDialog_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tagging.', 'TagEditorView$TagInputDialog', 2397), Lorg_rhq_enterprise_gui_coregui_client_components_tagging_TagEditorView$TagInputDialog$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tagging.', 'TagEditorView$TagInputDialog$1', 2398), Lorg_rhq_enterprise_gui_coregui_client_components_tagging_TagEditorView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tagging.', 'TagEditorView$1', 2392), Lorg_rhq_enterprise_gui_coregui_client_components_tagging_TagEditorView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tagging.', 'TagEditorView$2', 2393), Lorg_rhq_enterprise_gui_coregui_client_components_tagging_TagEditorView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tagging.', 'TagEditorView$3', 2394), Lorg_rhq_enterprise_gui_coregui_client_components_tagging_TagEditorView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tagging.', 'TagEditorView$4', 2395), Lorg_rhq_enterprise_gui_coregui_client_components_tagging_TagEditorView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.tagging.', 'TagEditorView$5', 2396), Lorg_rhq_core_domain_criteria_BundleVersionCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'BundleVersionCriteria', 1086), Lorg_rhq_core_domain_criteria_BundleDeploymentCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'BundleDeploymentCriteria', 1078), Lorg_rhq_core_domain_criteria_BundleDestinationCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'BundleDestinationCriteria', 1080), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionListView', 2184), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionListView$1', 2185), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_BundleVersionListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.', 'BundleVersionListView$2', 2186), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentListView', 2092), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentListView$1', 2093), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentListView$2', 2094), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentListView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentListView$3', 2095), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentListView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentListView$4', 2096), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationListView', 2121), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationListView$1', 2122), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationListView$2', 2123), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationListView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationListView$3', 2124), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationListView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationListView$4', 2125), Lorg_rhq_enterprise_gui_coregui_client_gwt_TagGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'TagGWTService_TypeSerializer', 2883), Lcom_smartgwt_client_types_RelativeDateRangePosition_2_classLit = createForEnum('com.smartgwt.client.types.', 'RelativeDateRangePosition', 404, Ljava_lang_Enum_2_classLit, values_29, valueOf_30), _3Lcom_smartgwt_client_types_RelativeDateRangePosition_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'RelativeDateRangePosition;', 3998, Lcom_smartgwt_client_types_RelativeDateRangePosition_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletSettingsWindow_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletSettingsWindow', 2471), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletSettingsWindow$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletSettingsWindow$1', 2472), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletSettingsWindow$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletSettingsWindow$2', 2473), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletSettingsWindow$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletSettingsWindow$3', 2474), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletSettingsWindow$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletSettingsWindow$4', 2475), Lorg_rhq_enterprise_gui_coregui_client_dashboard_PortletHelpWindow_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'PortletHelpWindow', 2470), Lorg_rhq_core_domain_criteria_RepoCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'RepoCriteria', 1134), Lorg_rhq_enterprise_gui_coregui_client_gwt_BundleGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'BundleGWTService_Proxy', 2802), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleVersionDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleVersionDataSource', 2140), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundleVersionDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundleVersionDataSource$1', 2141), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentDataSource', 2090), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleDeploymentDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleDeploymentDataSource$1', 2091), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationDataSource', 2118), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationDataSource$1', 2119), Lorg_rhq_enterprise_gui_coregui_client_bundle_destination_BundleDestinationDataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.destination.', 'BundleDestinationDataSource$1$1', 2120), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceDataSourceField_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceDataSourceField', 3265, Ljava_lang_Enum_2_classLit, values_134, valueOf_140), _3Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceDataSourceField_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceDataSourceField;', 3999, Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceDataSourceField_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView', 3018), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$1', 3019), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$2', 3020), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$3', 3021), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$4', 3022), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$5', 3023), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$6', 3024), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$6$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$6$1', 3025), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$7', 3026), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$8', 3027), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$8$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$8$1', 3028), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionListView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionListView$9', 3029), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupDataSourceField_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupDataSourceField', 2980, Ljava_lang_Enum_2_classLit, values_133, valueOf_139), _3Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupDataSourceField_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupDataSourceField;', 4000, Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupDataSourceField_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_report_configuration_SubsystemConfigurationHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.configuration.', 'SubsystemConfigurationHistoryListView', 3639), Lorg_rhq_enterprise_gui_coregui_client_report_configuration_SubsystemConfigurationHistoryListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.configuration.', 'SubsystemConfigurationHistoryListView$1', 3640), Lorg_rhq_enterprise_gui_coregui_client_report_operation_SubsystemOperationHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.operation.', 'SubsystemOperationHistoryListView', 3660), Lorg_rhq_enterprise_gui_coregui_client_report_operation_SubsystemOperationHistoryListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.operation.', 'SubsystemOperationHistoryListView$1', 3661), Lorg_rhq_enterprise_gui_coregui_client_alert_SubsystemResourceAlertView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'SubsystemResourceAlertView', 1894), Lorg_rhq_enterprise_gui_coregui_client_report_alert_SubsystemRecentAlertsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.alert.', 'SubsystemRecentAlertsView', 3637), Lorg_rhq_enterprise_gui_coregui_client_report_alert_SubsystemRecentAlertsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.alert.', 'SubsystemRecentAlertsView$1', 3638), Lorg_rhq_enterprise_gui_coregui_client_drift_SubsystemResourceDriftView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'SubsystemResourceDriftView', 2748), Lorg_rhq_enterprise_gui_coregui_client_drift_SubsystemResourceDriftView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'SubsystemResourceDriftView$1', 2749), Lorg_rhq_enterprise_gui_coregui_client_components_FullHTMLPane_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.', 'FullHTMLPane', 2199), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector', 1699), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_ResourceSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'ResourceSelector', 3180), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceDatasource', 3267), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_ResourceSelector$SelectedResourceDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'ResourceSelector$SelectedResourceDataSource', 3561), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_ResourceSelector$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'ResourceSelector$1', 3560), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$1', 2336), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$1$1', 2337), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$2', 2343), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$3', 2344), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$4', 2345), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$5', 2346), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$6', 2347), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$7', 2348), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$8', 2349), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$9', 2350), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$10', 2338), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$11', 2339), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$12', 2340), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$13', 2341), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AbstractSelector$14_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AbstractSelector$14', 2342), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceDatasource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceDatasource$1', 3268), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceDatasource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceDatasource$2', 3269), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeTreeView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypeTreeView', 3581), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeTreeView$CustomResourceTypeTreeGrid_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypeTreeView$CustomResourceTypeTreeGrid', 3583), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeTreeView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypeTreeView$1', 3582), Lorg_rhq_enterprise_gui_coregui_client_test_inventory_TestSearchBarView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.inventory.', 'TestSearchBarView', 3757), Lorg_rhq_enterprise_gui_coregui_client_test_configuration_TestConfigurationView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.configuration.', 'TestConfigurationView', 3751), Lorg_rhq_enterprise_gui_coregui_client_test_configuration_TestConfigurationView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.configuration.', 'TestConfigurationView$1', 3752), Lorg_rhq_enterprise_gui_coregui_client_test_configuration_TestReadOnlyConfigurationView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.configuration.', 'TestReadOnlyConfigurationView', 3755), Lorg_rhq_enterprise_gui_coregui_client_test_configuration_TestGroupConfigurationView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.configuration.', 'TestGroupConfigurationView', 3753), Lorg_rhq_enterprise_gui_coregui_client_test_configuration_TestGroupConfigurationView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.configuration.', 'TestGroupConfigurationView$1', 3754), Lorg_rhq_enterprise_gui_coregui_client_test_configuration_TestReadOnlyGroupConfigurationView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.configuration.', 'TestReadOnlyGroupConfigurationView', 3756), Lorg_rhq_enterprise_gui_coregui_client_test_TestUserPreferencesView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestUserPreferencesView', 3746), Lorg_rhq_enterprise_gui_coregui_client_test_TestUserPreferencesView$MessageWindow_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestUserPreferencesView$MessageWindow', 3748), Lorg_rhq_enterprise_gui_coregui_client_test_TestUserPreferencesView$MessageWindow$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestUserPreferencesView$MessageWindow$1', 3749), Lorg_rhq_enterprise_gui_coregui_client_test_TestUserPreferencesView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestUserPreferencesView$1', 3747), Lorg_rhq_enterprise_gui_coregui_client_test_TestMessageCenterView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestMessageCenterView', 3711), Lorg_rhq_enterprise_gui_coregui_client_test_TestMessageCenterView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestMessageCenterView$1', 3712), Lorg_rhq_enterprise_gui_coregui_client_test_TestNumberFormatView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestNumberFormatView', 3713), Lorg_rhq_enterprise_gui_coregui_client_test_TestNumberFormatView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.test.', 'TestNumberFormatView$1', 3714), Lorg_rhq_enterprise_gui_coregui_client_components_wizard_AbstractWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.wizard.', 'AbstractWizard', 2036), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_AbstractBundleCreateWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'AbstractBundleCreateWizard', 2035), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleCreateWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleCreateWizard', 2038), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_AbstractBundleCreateWizard$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'AbstractBundleCreateWizard$1', 2037), Lorg_rhq_core_domain_bundle_composite_BundleWithLatestVersionComposite_2_classLit = createForClass('org.rhq.core.domain.bundle.composite.', 'BundleWithLatestVersionComposite', 805), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_AbstractBundleDeployWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'AbstractBundleDeployWizard', 2054), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_BundleDeployWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'BundleDeployWizard', 2055), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_BundleDeployWizard$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'BundleDeployWizard$1', 2056), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_BundleDeployWizard$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'BundleDeployWizard$1$1', 2057), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_BundleDeployWizard$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'BundleDeployWizard$2', 2058), Lorg_rhq_enterprise_gui_coregui_client_gwt_BundleGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'BundleGWTService_TypeSerializer', 2803), Lorg_rhq_core_domain_criteria_BundleFileCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'BundleFileCriteria', 1082), Lorg_rhq_core_domain_criteria_BundleResourceDeploymentCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'BundleResourceDeploymentCriteria', 1084), Lorg_rhq_core_domain_criteria_GroupBundleDeploymentCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'GroupBundleDeploymentCriteria', 1109), Lorg_rhq_core_domain_criteria_ResourceBundleDeploymentCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'ResourceBundleDeploymentCriteria', 1136), Lorg_rhq_enterprise_gui_coregui_client_components_table_EscapedHtmlCellFormatter_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'EscapedHtmlCellFormatter', 2370), Lorg_rhq_core_domain_cloud_PartitionEvent_2_classLit = createForClass('org.rhq.core.domain.cloud.', 'PartitionEvent', 815), Lorg_rhq_enterprise_gui_coregui_client_gwt_ClusterGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'ClusterGWTService_Proxy', 2805), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_imported_RecentlyAddedResourceDS_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.imported.', 'RecentlyAddedResourceDS', 2580), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_imported_RecentlyAddedResourceDS$RecentlyAddedTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.imported.', 'RecentlyAddedResourceDS$RecentlyAddedTreeNode', 2582), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_recent_imported_RecentlyAddedResourceDS$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.recent.imported.', 'RecentlyAddedResourceDS$1', 2581), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_AutodiscoveryQueueDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'AutodiscoveryQueueDataSource', 3515), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_AutodiscoveryQueueDataSource$ResourceTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'AutodiscoveryQueueDataSource$ResourceTreeNode', 3518), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_AutodiscoveryQueueDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'AutodiscoveryQueueDataSource$1', 3516), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_discovery_AutodiscoveryQueueDataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.discovery.', 'AutodiscoveryQueueDataSource$1$1', 3517), Lcom_smartgwt_client_types_ContentsType_2_classLit = createForEnum('com.smartgwt.client.types.', 'ContentsType', 362, Ljava_lang_Enum_2_classLit, values_8, valueOf_9), _3Lcom_smartgwt_client_types_ContentsType_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'ContentsType;', 4001, Lcom_smartgwt_client_types_ContentsType_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_resource_ProblemResourcesDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.resource.', 'ProblemResourcesDataSource', 3671), Lorg_rhq_enterprise_gui_coregui_client_resource_ProblemResourcesDataSource$Field_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.resource.', 'ProblemResourcesDataSource$Field', 3674, Ljava_lang_Enum_2_classLit, values_137, valueOf_143), _3Lorg_rhq_enterprise_gui_coregui_client_resource_ProblemResourcesDataSource$Field_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.resource.', 'ProblemResourcesDataSource$Field;', 4002, Lorg_rhq_enterprise_gui_coregui_client_resource_ProblemResourcesDataSource$Field_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_resource_ProblemResourcesDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.resource.', 'ProblemResourcesDataSource$1', 3672), Lorg_rhq_enterprise_gui_coregui_client_resource_ProblemResourcesDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.resource.', 'ProblemResourcesDataSource$2', 3673), Lorg_rhq_enterprise_gui_coregui_client_operation_ScheduledOperationsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'ScheduledOperationsDataSource', 3603), Lorg_rhq_enterprise_gui_coregui_client_operation_ScheduledOperationsDataSource$Field_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.operation.', 'ScheduledOperationsDataSource$Field', 3608, Ljava_lang_Enum_2_classLit, values_136, valueOf_142), _3Lorg_rhq_enterprise_gui_coregui_client_operation_ScheduledOperationsDataSource$Field_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.operation.', 'ScheduledOperationsDataSource$Field;', 4003, Lorg_rhq_enterprise_gui_coregui_client_operation_ScheduledOperationsDataSource$Field_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_operation_ScheduledOperationsDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'ScheduledOperationsDataSource$1', 3604), Lorg_rhq_enterprise_gui_coregui_client_operation_ScheduledOperationsDataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'ScheduledOperationsDataSource$1$1', 3605), Lorg_rhq_enterprise_gui_coregui_client_operation_ScheduledOperationsDataSource$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'ScheduledOperationsDataSource$1$1$1', 3606), Lorg_rhq_enterprise_gui_coregui_client_operation_ScheduledOperationsDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.operation.', 'ScheduledOperationsDataSource$2', 3607), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor', 2226), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_PropertyMapListGridRecord_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'PropertyMapListGridRecord', 2276), _3Lorg_rhq_enterprise_gui_coregui_client_components_configuration_PropertyMapListGridRecord_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.components.configuration.', 'PropertyMapListGridRecord;', 4004, Lorg_rhq_enterprise_gui_coregui_client_components_configuration_PropertyMapListGridRecord_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$ConfigType_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$ConfigType', 2257, Ljava_lang_Enum_2_classLit, values_128, valueOf_134), _3Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$ConfigType_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$ConfigType;', 4005, Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$ConfigType_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$PropertyDefinitionComparator_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$PropertyDefinitionComparator', 2260), Lcom_smartgwt_client_widgets_form_validator_CustomValidator_2_classLit = createForClass('com.smartgwt.client.widgets.form.validator.', 'CustomValidator', 528), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$PluginReportedErrorValidator_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$PluginReportedErrorValidator', 2259), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$1', 2227), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$2', 2243), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$3', 2248), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$4', 2249), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$5', 2250), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$6', 2251), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$7', 2252), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$7$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$7$1', 2253), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$8', 2254), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$8$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$8$1', 2255), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$9', 2256), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$10', 2228), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$11', 2229), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$11$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$11$1', 2230), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$12', 2231), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$13', 2232), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$13$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$13$1', 2233), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$14_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$14', 2234), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$15_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$15', 2235), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$15$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$15$1', 2236), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$15$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$15$2', 2237), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$15$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$15$3', 2238), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$16_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$16', 2239), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$17_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$17', 2240), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$18_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$18', 2241), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$19_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$19', 2242), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$20_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$20', 2244), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$21_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$21', 2245), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$22_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$22', 2246), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationEditor$23_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationEditor$23', 2247), Lcom_smartgwt_client_types_LayoutPolicy_2_classLit = createForEnum('com.smartgwt.client.types.', 'LayoutPolicy', 392, Ljava_lang_Enum_2_classLit, values_23, valueOf_24), _3Lcom_smartgwt_client_types_LayoutPolicy_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'LayoutPolicy;', 4006, Lcom_smartgwt_client_types_LayoutPolicy_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionDataSource', 2993), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionDataSource$1', 2994), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionDataSource$2', 2995), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionDataSource$3', 2996), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupCompositeDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupCompositeDataSource', 2978), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupCompositeDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupCompositeDataSource$1', 2979), Lorg_rhq_enterprise_gui_coregui_client_report_measurement_MeasurementOOBDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.measurement.', 'MeasurementOOBDataSource', 3653), Lorg_rhq_enterprise_gui_coregui_client_report_measurement_MeasurementOOBDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.measurement.', 'MeasurementOOBDataSource$1', 3654), Lorg_rhq_enterprise_gui_coregui_client_report_measurement_MeasurementOOBDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.measurement.', 'MeasurementOOBDataSource$2', 3655), Lorg_rhq_enterprise_gui_coregui_client_report_measurement_MeasurementOOBDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.measurement.', 'MeasurementOOBDataSource$3', 3656), Lorg_rhq_enterprise_gui_coregui_client_report_measurement_MeasurementOOBDataSource$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.measurement.', 'MeasurementOOBDataSource$3$1', 3657), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_platform_PlatformMetricDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.platform.', 'PlatformMetricDataSource', 2568), Lorg_rhq_enterprise_gui_coregui_client_dashboard_portlets_platform_PlatformMetricDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.portlets.platform.', 'PlatformMetricDataSource$1', 2569), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UsersDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UsersDataSource', 1706), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UsersDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UsersDataSource$1', 1855), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UsersDataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UsersDataSource$1$1', 1856), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UsersDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UsersDataSource$2', 1857), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UsersDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UsersDataSource$3', 1858), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RolesDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RolesDataSource', 1707), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RolesDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RolesDataSource$1', 1708), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RolesDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RolesDataSource$2', 1709), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RolesDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RolesDataSource$3', 1710), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RolesDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RolesDataSource$4', 1711), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AbstractServerNodeDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AbstractServerNodeDatasource', 1759), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerDatasource', 1778), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDatasource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerDatasource$1', 1828), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerWithAgentCountDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerWithAgentCountDatasource', 1846), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerWithAgentCountDatasource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerWithAgentCountDatasource$1', 1847), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerWithAgentCountDatasource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerWithAgentCountDatasource$2', 1848), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_FailoverListItemDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'FailoverListItemDatasource', 1811), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_FailoverListItemDatasource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'FailoverListItemDatasource$1', 1812), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentDatasource', 1763), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentDatasource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentDatasource$1', 1798), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupWithCountsDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupWithCountsDatasource', 1794), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupWithCountsDatasource$Fields_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupWithCountsDatasource$Fields', 1796, Ljava_lang_Enum_2_classLit, values_121, valueOf_127), _3Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupWithCountsDatasource$Fields_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupWithCountsDatasource$Fields;', 4007, Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupWithCountsDatasource$Fields_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupWithCountsDatasource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupWithCountsDatasource$1', 1795), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventDatasource', 1813), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventDatasource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventDatasource$1', 1814), Lorg_rhq_enterprise_gui_coregui_client_util_preferences_UserPreferenceChangeEvent_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.preferences.', 'UserPreferenceChangeEvent', 3804), Lorg_rhq_enterprise_gui_coregui_client_util_preferences_UserPreferences$AutoPersistAwareChangeEvent_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.preferences.', 'UserPreferences$AutoPersistAwareChangeEvent', 3808), Lorg_rhq_enterprise_gui_coregui_client_util_preferences_UserPreferences$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.preferences.', 'UserPreferences$1$1', 3807), Lorg_rhq_enterprise_gui_coregui_client_gwt_RepoGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'RepoGWTService_Proxy', 2855), Lorg_rhq_enterprise_gui_coregui_client_components_wizard_AbstractWizardStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.wizard.', 'AbstractWizardStep', 2040), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDistroFileStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDistroFileStep', 2045), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDistroFileStep$RadioDynamicForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDistroFileStep$RadioDynamicForm', 2053), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDistroFileStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDistroFileStep$1', 2046), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDistroFileStep$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDistroFileStep$2', 2047), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDistroFileStep$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDistroFileStep$3', 2048), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDistroFileStep$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDistroFileStep$4', 2049), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDistroFileStep$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDistroFileStep$5', 2050), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDistroFileStep$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDistroFileStep$6', 2051), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDistroFileStep$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDistroFileStep$7', 2052), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDataStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDataStep', 2041), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDataStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDataStep$1', 2042), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDataStep$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDataStep$2', 2043), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleUploadDataStep$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleUploadDataStep$3', 2044), Lorg_rhq_enterprise_gui_coregui_client_bundle_create_BundleSummaryStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.create.', 'BundleSummaryStep', 2039), Lorg_rhq_enterprise_gui_coregui_client_components_wizard_WizardView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.wizard.', 'WizardView', 2429), Lorg_rhq_enterprise_gui_coregui_client_components_wizard_WizardView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.wizard.', 'WizardView$1', 2430), Lorg_rhq_enterprise_gui_coregui_client_components_wizard_WizardView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.wizard.', 'WizardView$2', 2431), Lorg_rhq_enterprise_gui_coregui_client_components_wizard_WizardView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.wizard.', 'WizardView$3', 2432), Lorg_rhq_enterprise_gui_coregui_client_components_wizard_WizardView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.wizard.', 'WizardView$4', 2433), Lorg_rhq_enterprise_gui_coregui_client_components_wizard_WizardView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.wizard.', 'WizardView$5', 2434), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_SelectBundleStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'SelectBundleStep', 2081), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep', 2067), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_wizard_AbstractGroupCreateWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.wizard.', 'AbstractGroupCreateWizard', 2078), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$QuickGroupCreateWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$QuickGroupCreateWizard', 2077), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$QuickGroupCreateWizard$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$QuickGroupCreateWizard$1', 2079), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$QuickGroupCreateWizard$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$QuickGroupCreateWizard$2', 2080), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$1', 2068), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$2', 2069), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$3', 2070), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$4', 2071), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$5', 2072), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$6', 2073), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$7', 2074), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$8', 2075), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDestinationStep$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDestinationStep$9', 2076), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_wizard_AbstractGroupCreateWizard$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.wizard.', 'AbstractGroupCreateWizard$1', 3241), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_SelectBundleVersionStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'SelectBundleVersionStep', 2082), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_SelectBundleVersionStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'SelectBundleVersionStep$1', 2083), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_SelectBundleVersionStep$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'SelectBundleVersionStep$2', 2084), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_SelectBundleVersionStep$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'SelectBundleVersionStep$3', 2085), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_SelectBundleVersionStep$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'SelectBundleVersionStep$3$1', 2086), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDeploymentConfigStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDeploymentConfigStep', 2062), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDeploymentInfoStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDeploymentInfoStep', 2063), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDeploymentInfoStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDeploymentInfoStep$1', 2064), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDeploymentInfoStep$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDeploymentInfoStep$1$1', 2065), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_GetDeploymentInfoStep$1$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'GetDeploymentInfoStep$1$2', 2066), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_DeployStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'DeployStep', 2059), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_DeployStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'DeployStep$1', 2060), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_DeployStep$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.', 'DeployStep$1$1', 2061), Lcom_smartgwt_client_data_fields_DataSourceDateTimeField_2_classLit = createForClass('com.smartgwt.client.data.fields.', 'DataSourceDateTimeField', 346), Lorg_rhq_enterprise_gui_coregui_client_components_table_IconField_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'IconField', 2371), Lorg_rhq_enterprise_gui_coregui_client_components_table_ResourceCategoryCellFormatter_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'ResourceCategoryCellFormatter', 2373), Lorg_rhq_enterprise_gui_coregui_client_gwt_ClusterGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'ClusterGWTService_TypeSerializer', 2806), _3Lorg_rhq_core_domain_resource_group_ClusterKey$Node_2_classLit = createForArray('[Lorg.rhq.core.domain.resource.group.', 'ClusterKey$Node;', 4010, Lorg_rhq_core_domain_resource_group_ClusterKey$Node_2_classLit), Lorg_rhq_core_domain_resource_group_composite_ClusterFlyweight_2_classLit = createForClass('org.rhq.core.domain.resource.group.composite.', 'ClusterFlyweight', 1480), _3Lorg_rhq_core_domain_resource_group_composite_ClusterFlyweight_2_classLit = createForArray('[Lorg.rhq.core.domain.resource.group.composite.', 'ClusterFlyweight;', 4011, Lorg_rhq_core_domain_resource_group_composite_ClusterFlyweight_2_classLit), Lorg_rhq_core_domain_resource_group_composite_ClusterKeyFlyweight_2_classLit = createForClass('org.rhq.core.domain.resource.group.composite.', 'ClusterKeyFlyweight', 1483), Lorg_rhq_enterprise_gui_coregui_client_dashboard_AutoRefreshUtil$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.dashboard.', 'AutoRefreshUtil$1', 2441), Lcom_smartgwt_client_types_Autofit_2_classLit = createForEnum('com.smartgwt.client.types.', 'Autofit', 360, Ljava_lang_Enum_2_classLit, values_7, valueOf_8), _3Lcom_smartgwt_client_types_Autofit_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'Autofit;', 4012, Lcom_smartgwt_client_types_Autofit_2_classLit), Lcom_smartgwt_client_types_SelectionAppearance_2_classLit = createForEnum('com.smartgwt.client.types.', 'SelectionAppearance', 406, Ljava_lang_Enum_2_classLit, values_30, valueOf_31), _3Lcom_smartgwt_client_types_SelectionAppearance_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'SelectionAppearance;', 4013, Lcom_smartgwt_client_types_SelectionAppearance_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_charttype_AbstractGraph_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.charttype.', 'AbstractGraph', 2923), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_charttype_StackedBarMetricGraphImpl_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.charttype.', 'StackedBarMetricGraphImpl', 2927), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_charttype_StackedBarMetricGraphIE8Impl_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.charttype.', 'StackedBarMetricGraphIE8Impl', 2926), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_charttype_MetricGraphData_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.charttype.', 'MetricGraphData', 2925), Lorg_rhq_enterprise_gui_coregui_client_util_enhanced_EnhancedVStack_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.enhanced.', 'EnhancedVStack', 1632), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryDetailsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryDetailsView', 2933), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_history_ResourceOperationHistoryDetailsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.history.', 'ResourceOperationHistoryDetailsView', 3497), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_history_ResourceOperationHistoryDetailsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.history.', 'ResourceOperationHistoryDetailsView$1', 3498), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryDetailsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryDetailsView$1', 2934), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_history_AbstractOperationHistoryDetailsView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.history.', 'AbstractOperationHistoryDetailsView$1$1', 2935), Lorg_rhq_enterprise_gui_coregui_client_components_measurement_AbstractMeasurementRangeEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.measurement.', 'AbstractMeasurementRangeEditor', 2327), Lorg_rhq_enterprise_gui_coregui_client_components_measurement_CustomConfigMeasurementRangeEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.measurement.', 'CustomConfigMeasurementRangeEditor', 2333), Lorg_rhq_enterprise_gui_coregui_client_components_measurement_CustomConfigMeasurementRangeEditor$ConfigurationMeasurementPreferences_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.measurement.', 'CustomConfigMeasurementRangeEditor$ConfigurationMeasurementPreferences', 2334), Lorg_rhq_enterprise_gui_coregui_client_components_measurement_AbstractMeasurementRangeEditor$MetricRangePreferences_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.measurement.', 'AbstractMeasurementRangeEditor$MetricRangePreferences', 2332), Lorg_rhq_enterprise_gui_coregui_client_components_measurement_AbstractMeasurementRangeEditor$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.measurement.', 'AbstractMeasurementRangeEditor$1', 2328), Lorg_rhq_enterprise_gui_coregui_client_components_measurement_AbstractMeasurementRangeEditor$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.measurement.', 'AbstractMeasurementRangeEditor$2', 2329), Lorg_rhq_enterprise_gui_coregui_client_components_measurement_AbstractMeasurementRangeEditor$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.measurement.', 'AbstractMeasurementRangeEditor$3', 2330), Lorg_rhq_enterprise_gui_coregui_client_components_measurement_AbstractMeasurementRangeEditor$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.measurement.', 'AbstractMeasurementRangeEditor$4', 2331), Lcom_smartgwt_client_widgets_form_fields_ComboBoxItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'ComboBoxItem', 491), Lorg_rhq_enterprise_gui_coregui_client_components_lookup_ResourceLookupComboBoxItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.lookup.', 'ResourceLookupComboBoxItem', 2324), Lorg_rhq_enterprise_gui_coregui_client_components_lookup_ResourceLookupComboBoxItem$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.lookup.', 'ResourceLookupComboBoxItem$1', 2325), Lorg_rhq_enterprise_gui_coregui_client_components_lookup_ResourceLookupComboBoxItem$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.lookup.', 'ResourceLookupComboBoxItem$2', 2326), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_ResourceScheduledMetricDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'ResourceScheduledMetricDatasource', 3464), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_ResourceScheduledMetricDatasource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'ResourceScheduledMetricDatasource$1', 3465), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_ResourceScheduledMetricDatasource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'ResourceScheduledMetricDatasource$2', 3466), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_ResourceScheduledMetricDatasource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'ResourceScheduledMetricDatasource$3', 3467), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_ResourceGroupSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'ResourceGroupSelector', 1703), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_SingleResourceGroupSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'SingleResourceGroupSelector', 3562), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupsDataSource', 2089), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_ResourceGroupSelector$SelectedResourceGroupsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'ResourceGroupSelector$SelectedResourceGroupsDataSource', 3554), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_ResourceGroupsDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.', 'ResourceGroupsDataSource$1', 2992), Lcom_smartgwt_client_types_TitleOrientation_2_classLit = createForEnum('com.smartgwt.client.types.', 'TitleOrientation', 420, Ljava_lang_Enum_2_classLit, values_37, valueOf_38), _3Lcom_smartgwt_client_types_TitleOrientation_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'TitleOrientation;', 4014, Lcom_smartgwt_client_types_TitleOrientation_2_classLit), Lcom_smartgwt_client_widgets_form_fields_CheckboxItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'CheckboxItem', 490), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView', 3030), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$DynaGroupChildrenView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$DynaGroupChildrenView', 3042), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$DynaGroupChildrenView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$DynaGroupChildrenView$1', 3043), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$DynaGroupChildrenView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$DynaGroupChildrenView$2', 3044), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$DynaGroupChildrenView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$DynaGroupChildrenView$3', 3045), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$1', 3031), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$2', 3034), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$3', 3035), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$4', 3036), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$5', 3037), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$6', 3038), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$7', 3039), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$8', 3040), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$9', 3041), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$10', 3032), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_SingleGroupDefinitionView$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'SingleGroupDefinitionView$11', 3033), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder', 2997), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$1', 2998), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$2', 3009), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$3', 3011), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$4', 3012), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$5', 3013), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$6', 3014), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$7', 3015), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$8', 3016), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$9', 3017), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$10', 2999), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$11', 3000), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$12', 3001), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$13', 3002), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$14_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$14', 3003), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$15_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$15', 3004), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$16_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$16', 3005), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$17_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$17', 3006), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$18_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$18', 3007), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$19_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$19', 3008), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_definitions_GroupDefinitionExpressionBuilder$20_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.definitions.', 'GroupDefinitionExpressionBuilder$20', 3010), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ConfigurationHistoryDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ConfigurationHistoryDetailView', 3412), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ConfigurationHistoryDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ConfigurationHistoryDetailView$1', 3413), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ConfigurationHistoryDetailView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ConfigurationHistoryDetailView$2', 3414), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDataSource', 2660), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDataSource$1', 2668), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDataSource$2', 2669), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDataSource$3', 2670), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDataSource$4', 2671), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDataSource$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDataSource$5', 2672), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_InventorySummaryReportTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'InventorySummaryReportTable', 3646), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_InventorySummaryReportTable$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'InventorySummaryReportTable$1', 3648), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_InventorySummaryReportTable$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'InventorySummaryReportTable$2', 3649), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_InventorySummaryReportTable$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'InventorySummaryReportTable$3', 3650), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_InventorySummaryReportTable$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'InventorySummaryReportTable$4', 3651), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_DriftComplianceReportTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'DriftComplianceReportTable', 3645), Lorg_rhq_enterprise_gui_coregui_client_components_form_AbstractRecordEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'AbstractRecordEditor', 1692), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UserEditView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UserEditView', 1850), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UserEditView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UserEditView$1', 1851), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UserEditView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UserEditView$1$1', 1852), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UserEditView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UserEditView$2', 1853), Lorg_rhq_enterprise_gui_coregui_client_admin_users_UserEditView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'UserEditView$3', 1854), Lorg_rhq_enterprise_gui_coregui_client_components_form_AbstractRecordEditor$ButtonBar_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'AbstractRecordEditor$ButtonBar', 2281), Lorg_rhq_enterprise_gui_coregui_client_components_form_AbstractRecordEditor$ButtonBar$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'AbstractRecordEditor$ButtonBar$1', 2282), Lorg_rhq_enterprise_gui_coregui_client_components_form_AbstractRecordEditor$ButtonBar$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'AbstractRecordEditor$ButtonBar$2', 2283), Lorg_rhq_enterprise_gui_coregui_client_components_form_AbstractRecordEditor$ButtonBar$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'AbstractRecordEditor$ButtonBar$3', 2284), Lorg_rhq_enterprise_gui_coregui_client_components_form_AbstractRecordEditor$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'AbstractRecordEditor$1', 2278), Lorg_rhq_enterprise_gui_coregui_client_components_form_AbstractRecordEditor$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'AbstractRecordEditor$2', 2279), Lorg_rhq_enterprise_gui_coregui_client_components_form_AbstractRecordEditor$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'AbstractRecordEditor$3', 2280), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleEditView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleEditView', 1691), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleEditView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleEditView$1', 1693), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleEditView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleEditView$2', 1694), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleEditView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleEditView$3', 1695), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleEditView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleEditView$4', 1696), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleEditView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleEditView$5', 1697), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDatasourceField_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerDatasourceField', 1829, Ljava_lang_Enum_2_classLit, values_125, valueOf_131), _3Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDatasourceField_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerDatasourceField;', 4015, Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDatasourceField_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerDetailView', 1831), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerDetailView$1', 1832), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDetailView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerDetailView$2', 1833), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDetailView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerDetailView$3', 1834), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_ServerDetailView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'ServerDetailView$3$1', 1835), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentDatasourceField_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentDatasourceField', 1799, Ljava_lang_Enum_2_classLit, values_122, valueOf_128), _3Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentDatasourceField_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentDatasourceField;', 4016, Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentDatasourceField_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentDetailView', 1801), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentDetailView$1', 1802), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AgentDetailView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AgentDetailView$2', 1803), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupDetailView', 1770), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupDetailView$1', 1771), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupDetailView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupDetailView$2', 1772), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupDetailView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupDetailView$3', 1773), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupDetailView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupDetailView$3$1', 1774), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventDatasourceField_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventDatasourceField', 1815, Ljava_lang_Enum_2_classLit, values_123, valueOf_129), _3Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventDatasourceField_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventDatasourceField;', 4017, Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventDatasourceField_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventDetailView', 1817), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventDetailView$1', 1818), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventDetailView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventDetailView$1$1', 1819), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_PartitionEventDetailView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'PartitionEventDetailView$2', 1820), Lorg_rhq_enterprise_gui_coregui_client_components_upload_DynamicCallbackForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'DynamicCallbackForm', 1926), Lorg_rhq_enterprise_gui_coregui_client_components_upload_FileUploadForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'FileUploadForm', 1925), Lorg_rhq_enterprise_gui_coregui_client_components_upload_PluginFileUploadForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'PluginFileUploadForm', 2419), Lorg_rhq_enterprise_gui_coregui_client_components_upload_FileUploadForm$1EnableInterceptingButtonItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'FileUploadForm$1EnableInterceptingButtonItem', 2415), Lorg_rhq_enterprise_gui_coregui_client_components_upload_FileUploadForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'FileUploadForm$1', 2414), Lorg_rhq_enterprise_gui_coregui_client_components_upload_FileUploadForm$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'FileUploadForm$2', 2416), Lorg_rhq_enterprise_gui_coregui_client_components_upload_FileUploadForm$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'FileUploadForm$3', 2417), Lorg_rhq_enterprise_gui_coregui_client_components_upload_FileUploadForm$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'FileUploadForm$4', 2418), Lorg_rhq_enterprise_gui_coregui_client_components_upload_DynamicCallbackForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'DynamicCallbackForm$1', 2409), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginDetailView', 1599), Lorg_rhq_enterprise_gui_coregui_client_admin_AgentPluginDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'AgentPluginDetailView$1', 1601), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView', 1637), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$1', 1638), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$2', 1639), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$3', 1640), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$4', 1641), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$4$1', 1642), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$4$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$4$2', 1643), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$4$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$4$3', 1644), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$4$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$4$3$1', 1645), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$5', 1646), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$5$1', 1647), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$5$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$5$2', 1648), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$5$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$5$3', 1649), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginDetailView$5$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginDetailView$5$3$1', 1650), Lcom_smartgwt_client_widgets_ImgButton_2_classLit = createForClass('com.smartgwt.client.widgets.', 'ImgButton', 455), Lcom_smartgwt_client_widgets_TransferImgButton_2_classLit = createForClass('com.smartgwt.client.widgets.', 'TransferImgButton', 458), Lcom_smartgwt_client_widgets_TransferImgButton$TransferImg_2_classLit = createForClass('com.smartgwt.client.widgets.', 'TransferImgButton$TransferImg', 459), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupMemberConfiguration_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupMemberConfiguration', 2275), Lcom_smartgwt_client_widgets_form_fields_SliderItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'SliderItem', 513), Lorg_rhq_enterprise_gui_coregui_client_gwt_RepoGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'RepoGWTService_TypeSerializer', 2856), Lcom_smartgwt_client_types_TextMatchStyle_2_classLit = createForEnum('com.smartgwt.client.types.', 'TextMatchStyle', 416, Ljava_lang_Enum_2_classLit, values_35, valueOf_36), _3Lcom_smartgwt_client_types_TextMatchStyle_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'TextMatchStyle;', 4018, Lcom_smartgwt_client_types_TextMatchStyle_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_ErrorMessageWindow_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.', 'ErrorMessageWindow', 1536), Lorg_rhq_enterprise_gui_coregui_client_ErrorMessageWindow$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.', 'ErrorMessageWindow$1', 1537), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_D3GroupGraphListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'D3GroupGraphListView', 3047), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_D3GroupGraphListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'D3GroupGraphListView$1', 3048), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_D3GroupGraphListView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'D3GroupGraphListView$1$1', 3049), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_D3GroupGraphListView$1$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'D3GroupGraphListView$1$2', 3050), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_D3GroupGraphListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'D3GroupGraphListView$2', 3051), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_CustomResourceTreeGrid_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'CustomResourceTreeGrid', 3302), Lcom_smartgwt_client_widgets_grid_events_FieldStateChangedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.grid.events.', 'FieldStateChangedEvent', 546), Lcom_smartgwt_client_data_fields_DataSourceImageField_2_classLit = createForClass('com.smartgwt.client.data.fields.', 'DataSourceImageField', 347), Lorg_rhq_core_domain_operation_composite_OperationScheduleComposite_2_classLit = createForClass('org.rhq.core.domain.operation.composite.', 'OperationScheduleComposite', 1346), Lorg_rhq_core_domain_operation_composite_ResourceOperationScheduleComposite_2_classLit = createForClass('org.rhq.core.domain.operation.composite.', 'ResourceOperationScheduleComposite', 1353), Lcom_smartgwt_client_widgets_form_fields_events_ChangeEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.events.', 'ChangeEvent', 518), Lcom_smartgwt_client_widgets_form_ValuesManager_2_classLit = createForClass('com.smartgwt.client.widgets.form.', 'ValuesManager', 479), Lorg_rhq_core_domain_criteria_AlertDefinitionCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'AlertDefinitionCriteria', 1071), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDetailsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDetailsView', 2722), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDetailsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDetailsView$1', 2723), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDetailsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDetailsView$2', 2724), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDetailsView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDetailsView$2$1', 2725), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDetailsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDetailsView$3', 2726), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDetailsView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDetailsView$3$1', 2727), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_InventorySummaryDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'InventorySummaryDataSource', 3642), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_InventorySummaryDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'InventorySummaryDataSource$1', 3647), Lorg_rhq_enterprise_gui_coregui_client_report_DriftComplianceReportResourceSearchView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'DriftComplianceReportResourceSearchView', 3621), Lorg_rhq_enterprise_gui_coregui_client_report_DriftComplianceReportResourceSearchView$DataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'DriftComplianceReportResourceSearchView$DataSource', 3624), Lorg_rhq_enterprise_gui_coregui_client_report_DriftComplianceReportResourceSearchView$DataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'DriftComplianceReportResourceSearchView$DataSource$1', 3625), Lorg_rhq_enterprise_gui_coregui_client_report_DriftComplianceReportResourceSearchView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'DriftComplianceReportResourceSearchView$1', 3622), Lorg_rhq_enterprise_gui_coregui_client_report_DriftComplianceReportResourceSearchView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.', 'DriftComplianceReportResourceSearchView$2', 3623), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_DriftComplianceDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'DriftComplianceDataSource', 3641), Lorg_rhq_enterprise_gui_coregui_client_report_inventory_DriftComplianceDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.report.inventory.', 'DriftComplianceDataSource$1', 3643), Lorg_rhq_core_domain_criteria_ServerCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'ServerCriteria', 1154), Lorg_rhq_core_domain_criteria_AgentCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'AgentCriteria', 1067), Lorg_rhq_core_domain_criteria_PartitionEventCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'PartitionEventCriteria', 1130), Lcom_smartgwt_client_widgets_form_fields_PickTreeItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'PickTreeItem', 502), Lcom_smartgwt_client_widgets_form_fields_IPickTreeItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'IPickTreeItem', 501), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypePluginTreeDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypePluginTreeDataSource', 3565), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypePluginTreeDataSource$PluginTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypePluginTreeDataSource$PluginTreeNode', 3568), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypePluginTreeDataSource$ResourceTypeTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypePluginTreeDataSource$ResourceTypeTreeNode', 3569), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypePluginTreeDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypePluginTreeDataSource$1', 3566), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypePluginTreeDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypePluginTreeDataSource$2', 3567), Lcom_smartgwt_client_types_DragDataAction_2_classLit = createForEnum('com.smartgwt.client.types.', 'DragDataAction', 374, Ljava_lang_Enum_2_classLit, values_14, valueOf_15), _3Lcom_smartgwt_client_types_DragDataAction_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'DragDataAction;', 4020, Lcom_smartgwt_client_types_DragDataAction_2_classLit), Lcom_smartgwt_client_types_DragTrackerMode_2_classLit = createForEnum('com.smartgwt.client.types.', 'DragTrackerMode', 376, Ljava_lang_Enum_2_classLit, values_15, valueOf_16), _3Lcom_smartgwt_client_types_DragTrackerMode_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'DragTrackerMode;', 4021, Lcom_smartgwt_client_types_DragTrackerMode_2_classLit), Lcom_smartgwt_client_widgets_ImgProperties_2_classLit = createForClass('com.smartgwt.client.widgets.', 'ImgProperties', 456), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor', 2261), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$1', 2262), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$2', 2267), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$3', 2268), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$4', 2269), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$5', 2270), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$6', 2271), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$7', 2272), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$8', 2273), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$9', 2274), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$10_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$10', 2263), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$11', 2264), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$12', 2265), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_GroupConfigurationEditor$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'GroupConfigurationEditor$13', 2266), Lorg_rhq_core_domain_measurement_composite_MeasurementOOBComposite_2_classLit = createForClass('org.rhq.core.domain.measurement.composite.', 'MeasurementOOBComposite', 1304), Lorg_rhq_enterprise_gui_coregui_client_components_upload_BundleDistributionFileUploadForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'BundleDistributionFileUploadForm', 2407), Lorg_rhq_enterprise_gui_coregui_client_components_form_RadioGroupWithComponentsItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'RadioGroupWithComponentsItem', 2309), Lorg_rhq_enterprise_gui_coregui_client_components_form_RadioGroupWithComponentsItem$NameAndTitle_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'RadioGroupWithComponentsItem$NameAndTitle', 2310), Lorg_rhq_enterprise_gui_coregui_client_components_form_RadioGroupWithComponentsItem$RGWCCanvas_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'RadioGroupWithComponentsItem$RGWCCanvas', 2311), Lorg_rhq_enterprise_gui_coregui_client_components_form_RadioGroupWithComponentsItem$RGWCCanvas$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'RadioGroupWithComponentsItem$RGWCCanvas$1', 2312), Lorg_rhq_enterprise_gui_coregui_client_bundle_BundleSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.', 'BundleSelector', 2029), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesDataSource', 2032), Lorg_rhq_enterprise_gui_coregui_client_bundle_BundleSelector$SelectedBundlesDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.', 'BundleSelector$SelectedBundlesDataSource', 2031), Lorg_rhq_enterprise_gui_coregui_client_bundle_BundleSelector$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.', 'BundleSelector$1', 2030), Lorg_rhq_enterprise_gui_coregui_client_bundle_list_BundlesDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.list.', 'BundlesDataSource$1', 2151), Lcom_smartgwt_client_widgets_form_fields_TextAreaItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'TextAreaItem', 486), Lorg_rhq_enterprise_gui_coregui_client_util_FormUtility$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.', 'FormUtility$1', 3762), Lcom_smartgwt_client_widgets_form_fields_RadioGroupItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'RadioGroupItem', 507), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_selection_SingleCompatibleResourceGroupSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.selection.', 'SingleCompatibleResourceGroupSelector', 2087), Lorg_rhq_enterprise_gui_coregui_client_bundle_deploy_selection_SingleCompatibleResourceGroupSelector$CompatibleResourceGroupsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deploy.selection.', 'SingleCompatibleResourceGroupSelector$CompatibleResourceGroupsDataSource', 2088), Lcom_smartgwt_client_widgets_form_validator_IsIntegerValidator_2_classLit = createForClass('com.smartgwt.client.widgets.form.validator.', 'IsIntegerValidator', 533), Lorg_rhq_enterprise_gui_coregui_client_components_ReportExporter_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.', 'ReportExporter', 2201), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_file_FileListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.file.', 'FileListView', 2195), Lorg_rhq_enterprise_gui_coregui_client_bundle_version_file_FileListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.version.file.', 'FileListView$1', 2196), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_avail_AvailabilityD3Graph_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.avail.', 'AvailabilityD3Graph', 3468), _3Ljava_lang_Double_2_classLit = createForArray('[Ljava.lang.', 'Double;', 4023, Ljava_lang_Double_2_classLit), Lcom_smartgwt_client_widgets_tree_events_DataArrivedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.tree.events.', 'DataArrivedEvent', 578), Lorg_rhq_enterprise_gui_coregui_client_gwt_ResourceBossGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'ResourceBossGWTService_Proxy', 2858), Lorg_rhq_core_domain_resource_InventorySummary_2_classLit = createForClass('org.rhq.core.domain.resource.', 'InventorySummary', 1397), Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary_2_classLit = createForClass('org.rhq.core.domain.resource.composite.', 'PlatformMetricsSummary', 1430), Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$MemoryMetric_2_classLit = createForEnum('org.rhq.core.domain.resource.composite.', 'PlatformMetricsSummary$MemoryMetric', 1433, Ljava_lang_Enum_2_classLit, values_112, valueOf_118), _3Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$MemoryMetric_2_classLit = createForArray('[Lorg.rhq.core.domain.resource.composite.', 'PlatformMetricsSummary$MemoryMetric;', 4024, Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$MemoryMetric_2_classLit), Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$CPUMetric_2_classLit = createForEnum('org.rhq.core.domain.resource.composite.', 'PlatformMetricsSummary$CPUMetric', 1431, Ljava_lang_Enum_2_classLit, values_111, valueOf_117), _3Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$CPUMetric_2_classLit = createForArray('[Lorg.rhq.core.domain.resource.composite.', 'PlatformMetricsSummary$CPUMetric;', 4025, Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$CPUMetric_2_classLit), Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$SwapMetric_2_classLit = createForEnum('org.rhq.core.domain.resource.composite.', 'PlatformMetricsSummary$SwapMetric', 1435, Ljava_lang_Enum_2_classLit, values_113, valueOf_119), _3Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$SwapMetric_2_classLit = createForArray('[Lorg.rhq.core.domain.resource.composite.', 'PlatformMetricsSummary$SwapMetric;', 4026, Lorg_rhq_core_domain_resource_composite_PlatformMetricsSummary$SwapMetric_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_wizard_GroupCreateWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.wizard.', 'GroupCreateWizard', 3245), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_ResourceResourceGroupsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'ResourceResourceGroupsView', 3444), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_ResourceResourceGroupsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'ResourceResourceGroupsView$1', 3445), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_ResourceResourceGroupsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'ResourceResourceGroupsView$2', 3446), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_ResourceResourceGroupsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'ResourceResourceGroupsView$3', 3447), Lorg_rhq_enterprise_gui_coregui_client_PopupWindow_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.', 'PopupWindow', 1559), Lorg_rhq_enterprise_gui_coregui_client_PopupWindow$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.', 'PopupWindow$1', 1560), Lorg_rhq_core_domain_criteria_InstalledPackageHistoryCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'InstalledPackageHistoryCriteria', 1118), Lorg_rhq_core_domain_criteria_MeasurementDefinitionCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'MeasurementDefinitionCriteria', 1122), Lorg_rhq_core_domain_criteria_MeasurementScheduleCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'MeasurementScheduleCriteria', 1124), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_summary_AbstractActivityView$ChartViewWindow_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.summary.', 'AbstractActivityView$ChartViewWindow', 2958), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_summary_AbstractActivityView$ChartViewWindow$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.summary.', 'AbstractActivityView$ChartViewWindow$1', 2959), Lcom_smartgwt_client_widgets_form_fields_SpinnerItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'SpinnerItem', 514), Lorg_rhq_core_domain_criteria_AbstractConfigurationUpdateCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'AbstractConfigurationUpdateCriteria', 1061), Lorg_rhq_core_domain_criteria_AbstractResourceConfigurationUpdateCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'AbstractResourceConfigurationUpdateCriteria', 1066), Lorg_rhq_core_domain_criteria_ResourceConfigurationUpdateCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'ResourceConfigurationUpdateCriteria', 1138), Lcom_smartgwt_client_types_ListGridEditEvent_2_classLit = createForEnum('com.smartgwt.client.types.', 'ListGridEditEvent', 394, Ljava_lang_Enum_2_classLit, values_24, valueOf_25), _3Lcom_smartgwt_client_types_ListGridEditEvent_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'ListGridEditEvent;', 4027, Lcom_smartgwt_client_types_ListGridEditEvent_2_classLit), Lcom_smartgwt_client_data_fields_DataSourcePasswordField_2_classLit = createForClass('com.smartgwt.client.data.fields.', 'DataSourcePasswordField', 350), Lcom_smartgwt_client_widgets_form_validator_LengthRangeValidator_2_classLit = createForClass('com.smartgwt.client.widgets.form.validator.', 'LengthRangeValidator', 534), Lcom_smartgwt_client_widgets_form_validator_MatchesFieldValidator_2_classLit = createForClass('com.smartgwt.client.widgets.form.validator.', 'MatchesFieldValidator', 535), Lorg_rhq_enterprise_gui_coregui_client_components_form_EnhancedDynamicForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EnhancedDynamicForm', 2304), Lorg_rhq_enterprise_gui_coregui_client_admin_users_SubjectRoleSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.users.', 'SubjectRoleSelector', 1849), Lorg_rhq_core_domain_criteria_RoleCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'RoleCriteria', 1150), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_PermissionsEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'PermissionsEditor', 1688), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_PermissionsEditor$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'PermissionsEditor$1', 1689), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_PermissionsEditor$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'PermissionsEditor$2', 1690), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleSubjectSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleSubjectSelector', 1704), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleSubjectSelector$RoleUsersDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleSubjectSelector$RoleUsersDataSource', 1705), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleLdapGroupSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleLdapGroupSelector', 1698), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleLdapGroupSelector$LdapGroupsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleLdapGroupSelector$LdapGroupsDataSource', 1700), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleLdapGroupSelector$LdapGroupsDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleLdapGroupSelector$LdapGroupsDataSource$1', 1701), Lorg_rhq_enterprise_gui_coregui_client_gwt_RemoteInstallGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'RemoteInstallGWTService_Proxy', 2852), Lcom_smartgwt_client_types_Encoding_2_classLit = createForEnum('com.smartgwt.client.types.', 'Encoding', 380, Ljava_lang_Enum_2_classLit, values_17, valueOf_18), _3Lcom_smartgwt_client_types_Encoding_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'Encoding;', 4028, Lcom_smartgwt_client_types_Encoding_2_classLit), Lcom_smartgwt_client_widgets_form_events_ItemChangedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.events.', 'ItemChangedEvent', 483), Lcom_smartgwt_client_widgets_grid_events_RecordDropEvent_2_classLit = createForClass('com.smartgwt.client.widgets.grid.events.', 'RecordDropEvent', 550), Lcom_smartgwt_client_widgets_events_KeyPressEvent_2_classLit = createForClass('com.smartgwt.client.widgets.events.', 'KeyPressEvent', 469), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_type_ResourceTypeTreeDataSource$ResourceTypeTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.type.', 'ResourceTypeTreeDataSource$ResourceTypeTreeNode', 3580), Lorg_rhq_core_domain_measurement_composite_MeasurementNumericValueAndUnits_2_classLit = createForClass('org.rhq.core.domain.measurement.composite.', 'MeasurementNumericValueAndUnits', 1303), Lorg_rhq_core_domain_measurement_util_MeasurementConversionException_2_classLit = createForClass('org.rhq.core.domain.measurement.util.', 'MeasurementConversionException', 1317), Lorg_rhq_core_domain_cloud_composite_ServerWithAgentCountComposite_2_classLit = createForClass('org.rhq.core.domain.cloud.composite.', 'ServerWithAgentCountComposite', 837), Lorg_rhq_core_domain_cloud_FailoverListDetails_2_classLit = createForClass('org.rhq.core.domain.cloud.', 'FailoverListDetails', 810), Lorg_rhq_core_domain_cloud_composite_AffinityGroupCountComposite_2_classLit = createForClass('org.rhq.core.domain.cloud.composite.', 'AffinityGroupCountComposite', 835), Lorg_rhq_core_domain_plugin_AbstractPlugin_2_classLit = createForClass('org.rhq.core.domain.plugin.', 'AbstractPlugin', 1355), Lorg_rhq_core_domain_plugin_Plugin_2_classLit = createForClass('org.rhq.core.domain.plugin.', 'Plugin', 1357), Lorg_rhq_core_domain_plugin_ServerPlugin_2_classLit = createForClass('org.rhq.core.domain.plugin.', 'ServerPlugin', 1367), Lorg_rhq_enterprise_gui_coregui_client_components_upload_TextFileRetrieverForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'TextFileRetrieverForm', 2420), Lorg_rhq_enterprise_gui_coregui_client_components_upload_TextFileRetrieverForm$1EnableInterceptingButtonItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'TextFileRetrieverForm$1EnableInterceptingButtonItem', 2422), Lorg_rhq_enterprise_gui_coregui_client_components_upload_TextFileRetrieverForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'TextFileRetrieverForm$1', 2421), Lorg_rhq_enterprise_gui_coregui_client_components_upload_TextFileRetrieverForm$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'TextFileRetrieverForm$2', 2423), Lcom_smartgwt_client_widgets_form_fields_events_IconClickEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.events.', 'IconClickEvent', 524), Lcom_smartgwt_client_widgets_WidgetCanvas_2_classLit = createForClass('com.smartgwt.client.widgets.', 'WidgetCanvas', 460), Lorg_rhq_core_domain_bundle_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory_2_classLit = createForClass('org.rhq.core.domain.bundle.', 'ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory', 801), Lorg_rhq_core_domain_bundle_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context_2_classLit = createForEnum('org.rhq.core.domain.bundle.', 'ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context', 802, Ljava_lang_Enum_2_classLit, values_57, valueOf_63), _3Lorg_rhq_core_domain_bundle_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context_2_classLit = createForArray('[Lorg.rhq.core.domain.bundle.', 'ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context;', 4029, Lorg_rhq_core_domain_bundle_ResourceTypeBundleConfiguration$BundleDestinationBaseDirectory$Context_2_classLit), Lcom_smartgwt_client_widgets_events_MouseOutEvent_2_classLit = createForClass('com.smartgwt.client.widgets.events.', 'MouseOutEvent', 471), Lorg_rhq_enterprise_gui_coregui_client_components_measurement_UserPreferencesMeasurementRangeEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.measurement.', 'UserPreferencesMeasurementRangeEditor', 2335), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_charttype_AvailabilityLineGraphType_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.charttype.', 'AvailabilityLineGraphType', 2924), Lorg_rhq_core_domain_alert_AlertConditionOperator_2_classLit = createForEnum('org.rhq.core.domain.alert.', 'AlertConditionOperator', 723, Ljava_lang_Enum_2_classLit, values_45, valueOf_51), _3Lorg_rhq_core_domain_alert_AlertConditionOperator_2_classLit = createForArray('[Lorg.rhq.core.domain.alert.', 'AlertConditionOperator;', 4031, Lorg_rhq_core_domain_alert_AlertConditionOperator_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_gwt_ResourceBossGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'ResourceBossGWTService_TypeSerializer', 2859), Lcom_smartgwt_client_types_EmbeddedPosition_2_classLit = createForEnum('com.smartgwt.client.types.', 'EmbeddedPosition', 378, Ljava_lang_Enum_2_classLit, values_16, valueOf_17), _3Lcom_smartgwt_client_types_EmbeddedPosition_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'EmbeddedPosition;', 4032, Lcom_smartgwt_client_types_EmbeddedPosition_2_classLit), Lorg_rhq_core_domain_criteria_OperationHistoryCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'OperationHistoryCriteria', 1112), Lorg_rhq_core_domain_criteria_ResourceOperationHistoryCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'ResourceOperationHistoryCriteria', 1146), Lorg_rhq_enterprise_gui_coregui_client_gwt_OperationGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'OperationGWTService_Proxy', 2843), Lorg_rhq_core_domain_criteria_AbstractGroupConfigurationUpdateCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'AbstractGroupConfigurationUpdateCriteria', 1064), Lorg_rhq_core_domain_criteria_GroupResourceConfigurationUpdateCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'GroupResourceConfigurationUpdateCriteria', 1116), Lcom_smartgwt_client_widgets_form_fields_DateTimeItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'DateTimeItem', 495), Lcom_smartgwt_client_types_DateDisplayFormat_2_classLit = createForEnum('com.smartgwt.client.types.', 'DateDisplayFormat', 370, Ljava_lang_Enum_2_classLit, values_12, valueOf_13), _3Lcom_smartgwt_client_types_DateDisplayFormat_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'DateDisplayFormat;', 4033, Lcom_smartgwt_client_types_DateDisplayFormat_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_gwt_ConfigurationGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'ConfigurationGWTService_Proxy', 2808), Lcom_smartgwt_client_widgets_form_fields_events_FormItemIconClickEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.events.', 'FormItemIconClickEvent', 523), Lorg_rhq_enterprise_gui_coregui_client_gwt_MeasurementDataGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'MeasurementDataGWTService_Proxy', 2837), Lorg_rhq_core_domain_drift_DriftComposite_2_classLit = createForClass('org.rhq.core.domain.drift.', 'DriftComposite', 1182), Lorg_rhq_core_domain_criteria_GenericDriftCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'GenericDriftCriteria', 1107), Lcom_smartgwt_client_data_fields_DataSourceLinkField_2_classLit = createForClass('com.smartgwt.client.data.fields.', 'DataSourceLinkField', 349), Lcom_smartgwt_client_data_fields_DataSourceBooleanField_2_classLit = createForClass('com.smartgwt.client.data.fields.', 'DataSourceBooleanField', 345), Lorg_rhq_enterprise_gui_coregui_client_gwt_PlatformUtilizationGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'PlatformUtilizationGWTService_Proxy', 2846), Lorg_rhq_enterprise_gui_coregui_client_gwt_RemoteInstallGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'RemoteInstallGWTService_TypeSerializer', 2853), Lorg_rhq_core_domain_install_remote_AgentInstallInfo_2_classLit = createForClass('org.rhq.core.domain.install.remote.', 'AgentInstallInfo', 1239), Lorg_rhq_core_domain_install_remote_AgentInstallStep_2_classLit = createForClass('org.rhq.core.domain.install.remote.', 'AgentInstallStep', 1241), _3Lorg_rhq_core_domain_install_remote_AgentInstallStep_2_classLit = createForArray('[Lorg.rhq.core.domain.install.remote.', 'AgentInstallStep;', 4034, Lorg_rhq_core_domain_install_remote_AgentInstallStep_2_classLit), Lorg_rhq_core_domain_install_remote_RemoteAccessInfo_2_classLit = createForClass('org.rhq.core.domain.install.remote.', 'RemoteAccessInfo', 1244), Lorg_rhq_enterprise_gui_coregui_client_gwt_TopologyGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'TopologyGWTService_Proxy', 2885), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupServersSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupServersSelector', 1775), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupServersSelector$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupServersSelector$1', 1776), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupServersSelector$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupServersSelector$2', 1777), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupServersSelector$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupServersSelector$2$1', 1779), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupServersSelector$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupServersSelector$3', 1780), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupServersSelector$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupServersSelector$4', 1781), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupServersSelector$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupServersSelector$5', 1782), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupServersSelector$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupServersSelector$5$1', 1783), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupServersSelector$5$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupServersSelector$5$2', 1784), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupAgentsSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupAgentsSelector', 1760), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupAgentsSelector$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupAgentsSelector$1', 1761), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupAgentsSelector$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupAgentsSelector$2', 1762), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupAgentsSelector$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupAgentsSelector$2$1', 1764), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupAgentsSelector$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupAgentsSelector$3', 1765), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupAgentsSelector$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupAgentsSelector$4', 1766), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupAgentsSelector$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupAgentsSelector$5', 1767), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupAgentsSelector$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupAgentsSelector$5$1', 1768), Lorg_rhq_enterprise_gui_coregui_client_admin_topology_AffinityGroupAgentsSelector$5$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.topology.', 'AffinityGroupAgentsSelector$5$2', 1769), Lorg_rhq_enterprise_gui_coregui_client_gwt_PluginGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'PluginGWTService_Proxy', 2849), Lcom_smartgwt_client_widgets_form_fields_UploadItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'UploadItem', 516), Lorg_rhq_enterprise_gui_coregui_client_components_upload_DynamicCallbackFormHandlerCollection_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'DynamicCallbackFormHandlerCollection', 2410), Lcom_smartgwt_client_widgets_form_events_FormSubmitFailedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.events.', 'FormSubmitFailedEvent', 481), Lcom_smartgwt_client_widgets_toolbar_ToolStripSpacer_2_classLit = createForClass('com.smartgwt.client.widgets.toolbar.', 'ToolStripSpacer', 573), Lcom_google_gwt_i18n_client_NumberFormat_2_classLit = createForClass('com.google.gwt.i18n.client.', 'NumberFormat', 96), Lorg_rhq_core_domain_operation_composite_GroupOperationScheduleComposite_2_classLit = createForClass('org.rhq.core.domain.operation.composite.', 'GroupOperationScheduleComposite', 1345), Lorg_rhq_core_domain_measurement_MeasurementData_2_classLit = createForClass('org.rhq.core.domain.measurement.', 'MeasurementData', 1264), Lorg_rhq_core_domain_plugin_PluginStatusType_2_classLit = createForEnum('org.rhq.core.domain.plugin.', 'PluginStatusType', 1363, Ljava_lang_Enum_2_classLit, values_101, valueOf_107), _3Lorg_rhq_core_domain_plugin_PluginStatusType_2_classLit = createForArray('[Lorg.rhq.core.domain.plugin.', 'PluginStatusType;', 4035, Lorg_rhq_core_domain_plugin_PluginStatusType_2_classLit), Lcom_smartgwt_client_widgets_tab_events_TabCloseClickEvent_2_classLit = createForClass('com.smartgwt.client.widgets.tab.events.', 'TabCloseClickEvent', 568), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_OverviewForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'OverviewForm', 3303), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_OverviewForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'OverviewForm$1', 3304), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_OverviewForm$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'OverviewForm$2', 3305), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_OverviewForm$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'OverviewForm$3', 3306), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_OverviewForm$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'OverviewForm$3$1', 3307), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_OverviewForm$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'OverviewForm$4', 3308), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_OverviewForm$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'OverviewForm$4$1', 3309), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_OverviewForm$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'OverviewForm$5', 3310), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_OverviewForm$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'OverviewForm$5$1', 3311), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_OverviewForm$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'OverviewForm$6', 3312), Lorg_rhq_enterprise_gui_coregui_client_components_form_SimpleEditableFormItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'SimpleEditableFormItem', 2287), Lorg_rhq_enterprise_gui_coregui_client_components_form_SimpleEditableFormItem$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'SimpleEditableFormItem$1', 2313), Lorg_rhq_enterprise_gui_coregui_client_components_form_SimpleEditableFormItem$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'SimpleEditableFormItem$2', 2314), Lorg_rhq_enterprise_gui_coregui_client_components_form_SimpleEditableFormItem$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'SimpleEditableFormItem$3', 2315), Lorg_rhq_enterprise_gui_coregui_client_util_async_CountDownLatch_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.async.', 'CountDownLatch', 3773), Lorg_rhq_core_domain_measurement_composite_MeasurementDataNumericHighLowComposite_2_classLit = createForClass('org.rhq.core.domain.measurement.composite.', 'MeasurementDataNumericHighLowComposite', 1300), Lcom_smartgwt_client_widgets_form_fields_LinkItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'LinkItem', 504), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_wizard_GroupCreateStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.wizard.', 'GroupCreateStep', 3242), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_wizard_GroupCreateStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.wizard.', 'GroupCreateStep$1', 3243), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_wizard_GroupCreateStep$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.wizard.', 'GroupCreateStep$1$1', 3244), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_wizard_GroupMembersStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.wizard.', 'GroupMembersStep', 3246), Lorg_rhq_enterprise_gui_coregui_client_gwt_OperationGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'OperationGWTService_TypeSerializer', 2844), Lcom_google_gwt_i18n_shared_impl_DateRecord_2_classLit = createForClass('com.google.gwt.i18n.shared.impl.', 'DateRecord', 103), Ljava_sql_Date_2_classLit = createForClass('java.sql.', 'Date', 626), Ljava_sql_Time_2_classLit = createForClass('java.sql.', 'Time', 627), Ljava_sql_Timestamp_2_classLit = createForClass('java.sql.', 'Timestamp', 628), Lorg_rhq_core_domain_common_JobTrigger_2_classLit = createForClass('org.rhq.core.domain.common.', 'JobTrigger', 845), Lorg_rhq_core_domain_common_JobTrigger$EndType_2_classLit = createForEnum('org.rhq.core.domain.common.', 'JobTrigger$EndType', 846, Ljava_lang_Enum_2_classLit, values_62, valueOf_68), Lorg_rhq_core_domain_common_JobTrigger$RecurrenceType_2_classLit = createForEnum('org.rhq.core.domain.common.', 'JobTrigger$RecurrenceType', 848, Ljava_lang_Enum_2_classLit, values_63, valueOf_69), Lorg_rhq_core_domain_common_JobTrigger$StartType_2_classLit = createForEnum('org.rhq.core.domain.common.', 'JobTrigger$StartType', 850, Ljava_lang_Enum_2_classLit, values_64, valueOf_70), Lorg_rhq_core_domain_criteria_GroupOperationHistoryCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'GroupOperationHistoryCriteria', 1111), Lorg_rhq_core_domain_operation_ScheduleJobId_2_classLit = createForClass('org.rhq.core.domain.operation.', 'ScheduleJobId', 1335), Lorg_rhq_core_domain_operation_bean_OperationSchedule_2_classLit = createForClass('org.rhq.core.domain.operation.bean.', 'OperationSchedule', 1338), Lorg_rhq_core_domain_operation_bean_GroupOperationSchedule_2_classLit = createForClass('org.rhq.core.domain.operation.bean.', 'GroupOperationSchedule', 1337), _3Lorg_rhq_core_domain_operation_bean_GroupOperationSchedule_2_classLit = createForArray('[Lorg.rhq.core.domain.operation.bean.', 'GroupOperationSchedule;', 4036, Lorg_rhq_core_domain_operation_bean_GroupOperationSchedule_2_classLit), Lorg_rhq_core_domain_operation_bean_ResourceOperationSchedule_2_classLit = createForClass('org.rhq.core.domain.operation.bean.', 'ResourceOperationSchedule', 1342), _3Lorg_rhq_core_domain_operation_bean_ResourceOperationSchedule_2_classLit = createForArray('[Lorg.rhq.core.domain.operation.bean.', 'ResourceOperationSchedule;', 4037, Lorg_rhq_core_domain_operation_bean_ResourceOperationSchedule_2_classLit), Lorg_rhq_core_domain_operation_composite_OperationLastCompletedComposite_2_classLit = createForClass('org.rhq.core.domain.operation.composite.', 'OperationLastCompletedComposite', 1348), Lorg_rhq_core_domain_operation_composite_ResourceOperationLastCompletedComposite_2_classLit = createForClass('org.rhq.core.domain.operation.composite.', 'ResourceOperationLastCompletedComposite', 1351), Lorg_rhq_enterprise_gui_coregui_client_gwt_EventGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'EventGWTService_Proxy', 2820), Lorg_rhq_enterprise_gui_coregui_client_gwt_ContentGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'ContentGWTService_Proxy', 2811), Lorg_rhq_enterprise_gui_coregui_client_gwt_ConfigurationGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'ConfigurationGWTService_TypeSerializer', 2809), Lorg_rhq_core_domain_configuration_composite_ResourceConfigurationComposite_2_classLit = createForClass('org.rhq.core.domain.configuration.composite.', 'ResourceConfigurationComposite', 907), _3Lorg_rhq_core_domain_configuration_composite_ResourceConfigurationComposite_2_classLit = createForArray('[Lorg.rhq.core.domain.configuration.composite.', 'ResourceConfigurationComposite;', 4038, Lorg_rhq_core_domain_configuration_composite_ResourceConfigurationComposite_2_classLit), Lorg_rhq_core_domain_criteria_GroupPluginConfigurationUpdateCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'GroupPluginConfigurationUpdateCriteria', 1114), Lorg_rhq_core_domain_criteria_PluginConfigurationUpdateCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'PluginConfigurationUpdateCriteria', 1132), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_PropertyValueChangeEvent_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'PropertyValueChangeEvent', 2277), Lorg_rhq_enterprise_gui_coregui_client_gwt_MeasurementDataGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'MeasurementDataGWTService_TypeSerializer', 2838), Lcom_google_gwt_user_client_ui_ChangeListenerCollection_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'ChangeListenerCollection', 288), Lcom_google_gwt_user_client_ui_ClickListenerCollection_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'ClickListenerCollection', 293), Lcom_google_gwt_user_client_ui_FocusListenerCollection_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'FocusListenerCollection', 296), Lcom_google_gwt_user_client_ui_KeyboardListenerCollection_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'KeyboardListenerCollection', 303), _3Ljava_util_AbstractList_2_classLit = createForArray('[Ljava.util.', 'AbstractList;', 4039, Ljava_util_AbstractList_2_classLit), _3Ljava_util_AbstractSequentialList_2_classLit = createForArray('[Ljava.util.', 'AbstractSequentialList;', 4040, Ljava_util_AbstractSequentialList_2_classLit), _3Ljava_util_ArrayList_2_classLit = createForArray('[Ljava.util.', 'ArrayList;', 4041, Ljava_util_ArrayList_2_classLit), _3Ljava_util_LinkedList_2_classLit = createForArray('[Ljava.util.', 'LinkedList;', 4042, Ljava_util_LinkedList_2_classLit), _3Ljava_util_List_2_classLit = createForArray('[Ljava.util.', 'List;', 4043, Ljava_util_List_2_classLit), _3Ljava_util_Stack_2_classLit = createForArray('[Ljava.util.', 'Stack;', 4044, Ljava_util_Stack_2_classLit), _3Ljava_util_Vector_2_classLit = createForArray('[Ljava.util.', 'Vector;', 4045, Ljava_util_Vector_2_classLit), Lorg_rhq_core_domain_criteria_CallTimeDataCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'CallTimeDataCriteria', 1088), Lorg_rhq_core_domain_criteria_MeasurementDataTraitCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'MeasurementDataTraitCriteria', 1120), Lorg_rhq_core_domain_measurement_MeasurementDataNumeric_2_classLit = createForClass('org.rhq.core.domain.measurement.', 'MeasurementDataNumeric', 1265), Lorg_rhq_core_domain_measurement_MeasurementDataNumeric1D_2_classLit = createForClass('org.rhq.core.domain.measurement.', 'MeasurementDataNumeric1D', 1266), Lorg_rhq_core_domain_measurement_MeasurementDataNumeric1H_2_classLit = createForClass('org.rhq.core.domain.measurement.', 'MeasurementDataNumeric1H', 1268), Lorg_rhq_core_domain_measurement_MeasurementDataNumeric6H_2_classLit = createForClass('org.rhq.core.domain.measurement.', 'MeasurementDataNumeric6H', 1270), Lorg_rhq_core_domain_measurement_MeasurementDataPK_2_classLit = createForClass('org.rhq.core.domain.measurement.', 'MeasurementDataPK', 1273), Lorg_rhq_core_domain_measurement_MeasurementDataTrait_2_classLit = createForClass('org.rhq.core.domain.measurement.', 'MeasurementDataTrait', 1275), _3Lorg_rhq_core_domain_measurement_MeasurementDataTrait_2_classLit = createForArray('[Lorg.rhq.core.domain.measurement.', 'MeasurementDataTrait;', 4046, Lorg_rhq_core_domain_measurement_MeasurementDataTrait_2_classLit), Lorg_rhq_core_domain_measurement_calltime_CallTimeDataComposite_2_classLit = createForClass('org.rhq.core.domain.measurement.calltime.', 'CallTimeDataComposite', 1298), _3Lorg_rhq_core_domain_measurement_composite_MeasurementDataNumericHighLowComposite_2_classLit = createForArray('[Lorg.rhq.core.domain.measurement.composite.', 'MeasurementDataNumericHighLowComposite;', 4047, Lorg_rhq_core_domain_measurement_composite_MeasurementDataNumericHighLowComposite_2_classLit), Lorg_rhq_core_domain_measurement_composite_MeasurementScheduleComposite_2_classLit = createForClass('org.rhq.core.domain.measurement.composite.', 'MeasurementScheduleComposite', 1306), _3Lorg_rhq_core_domain_util_PageList_2_classLit = createForArray('[Lorg.rhq.core.domain.util.', 'PageList;', 4048, Lorg_rhq_core_domain_util_PageList_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationComparisonView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationComparisonView', 2220), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationComparisonView$ComparisonTreeNode_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationComparisonView$ComparisonTreeNode', 2225), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationComparisonView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationComparisonView$1', 2221), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationComparisonView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationComparisonView$2', 2222), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationComparisonView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationComparisonView$3', 2223), Lorg_rhq_enterprise_gui_coregui_client_components_configuration_ConfigurationComparisonView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.configuration.', 'ConfigurationComparisonView$4', 2224), Lorg_rhq_enterprise_gui_coregui_client_gwt_AlertDefinitionGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AlertDefinitionGWTService_Proxy', 2787), Lorg_rhq_enterprise_gui_coregui_client_gwt_PlatformUtilizationGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'PlatformUtilizationGWTService_TypeSerializer', 2847), Lorg_rhq_enterprise_gui_coregui_client_gwt_RoleGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'RoleGWTService_Proxy', 2870), Lorg_rhq_enterprise_gui_coregui_client_gwt_TopologyGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'TopologyGWTService_TypeSerializer', 2886), Lorg_rhq_core_domain_cloud_FailoverList_2_classLit = createForClass('org.rhq.core.domain.cloud.', 'FailoverList', 809), _3Lorg_rhq_core_domain_cloud_FailoverListDetails_2_classLit = createForArray('[Lorg.rhq.core.domain.cloud.', 'FailoverListDetails;', 4049, Lorg_rhq_core_domain_cloud_FailoverListDetails_2_classLit), _3Lorg_rhq_core_domain_cloud_FailoverList_2_classLit = createForArray('[Lorg.rhq.core.domain.cloud.', 'FailoverList;', 4050, Lorg_rhq_core_domain_cloud_FailoverList_2_classLit), Lorg_rhq_core_domain_cloud_PartitionEventDetails_2_classLit = createForClass('org.rhq.core.domain.cloud.', 'PartitionEventDetails', 818), _3Lorg_rhq_core_domain_cloud_PartitionEventDetails_2_classLit = createForArray('[Lorg.rhq.core.domain.cloud.', 'PartitionEventDetails;', 4051, Lorg_rhq_core_domain_cloud_PartitionEventDetails_2_classLit), _3Lorg_rhq_core_domain_cloud_composite_ServerWithAgentCountComposite_2_classLit = createForArray('[Lorg.rhq.core.domain.cloud.composite.', 'ServerWithAgentCountComposite;', 4052, Lorg_rhq_core_domain_cloud_composite_ServerWithAgentCountComposite_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_gwt_PluginGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'PluginGWTService_TypeSerializer', 2850), Lorg_rhq_core_domain_plugin_PluginDeploymentType_2_classLit = createForEnum('org.rhq.core.domain.plugin.', 'PluginDeploymentType', 1358, Ljava_lang_Enum_2_classLit, values_100, valueOf_106), Lorg_rhq_core_domain_plugin_PluginKey_2_classLit = createForClass('org.rhq.core.domain.plugin.', 'PluginKey', 1361), Lorg_rhq_core_domain_plugin_ServerPluginControlDefinition_2_classLit = createForClass('org.rhq.core.domain.plugin.', 'ServerPluginControlDefinition', 1368), Lorg_rhq_core_domain_plugin_ServerPluginControlResults_2_classLit = createForClass('org.rhq.core.domain.plugin.', 'ServerPluginControlResults', 1370), Lorg_rhq_enterprise_gui_coregui_client_components_upload_BundleFileUploadForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'BundleFileUploadForm', 2408), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_summary_ActivityView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.summary.', 'ActivityView', 3235), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_summary_ActivityView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.summary.', 'ActivityView$1', 3236), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_summary_ActivityView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.summary.', 'ActivityView$1$1', 3237), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_summary_ActivityView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.summary.', 'ActivityView$2', 3238), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_summary_ActivityView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.summary.', 'ActivityView$3', 3239), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_summary_ActivityView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.summary.', 'ActivityView$3$1', 3240), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_MembersView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'MembersView', 3169), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_MembersView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'MembersView$1', 3170), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_MembersView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'MembersView$1$1', 3171), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_MembersView$1$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'MembersView$1$2', 3172), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_MembersView$1$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'MembersView$1$3', 3173), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_GroupPluginConfigurationEditView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'GroupPluginConfigurationEditView', 3140), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_GroupPluginConfigurationEditView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'GroupPluginConfigurationEditView$1', 3141), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_GroupPluginConfigurationEditView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'GroupPluginConfigurationEditView$2', 3142), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_GroupPluginConfigurationEditView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'GroupPluginConfigurationEditView$3', 3143), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_GroupPluginConfigurationEditView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'GroupPluginConfigurationEditView$3$1', 3144), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_GroupPluginConfigurationEditView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'GroupPluginConfigurationEditView$4', 3145), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationView', 3168), Lorg_rhq_enterprise_gui_coregui_client_alert_GroupAlertHistoryView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'GroupAlertHistoryView', 1892), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_AbstractAlertDefinitionsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'AbstractAlertDefinitionsView', 1898), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_GroupAlertDefinitionsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'GroupAlertDefinitionsView', 1955), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_GroupAlertDefinitionsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'GroupAlertDefinitionsView$1', 1956), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_GroupAlertDefinitionsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'GroupAlertDefinitionsView$2', 1957), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_GroupAlertDefinitionsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'GroupAlertDefinitionsView$3', 1958), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_GroupAlertDefinitionsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'GroupAlertDefinitionsView$4', 1959), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_GroupAlertDefinitionsView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'GroupAlertDefinitionsView$5', 1960), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_AbstractAlertDefinitionsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'AbstractAlertDefinitionsView$1', 1899), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_AbstractAlertDefinitionsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'AbstractAlertDefinitionsView$2', 1900), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_AbstractAlertDefinitionsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'AbstractAlertDefinitionsView$3', 1901), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_AbstractAlertDefinitionsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'AbstractAlertDefinitionsView$4', 1902), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_AbstractAlertDefinitionsView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'AbstractAlertDefinitionsView$5', 1903), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_GroupMonitoringTablesView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'GroupMonitoringTablesView', 3202), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_AbstractMeasurementDataTraitListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'AbstractMeasurementDataTraitListView', 2911), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsView', 3210), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsView$1', 3211), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsView$2', 3212), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsView$3', 3213), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsView$3$1', 3214), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsView$3$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsView$3$1$1', 3215), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsView$4', 3216), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsView$5', 3217), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_AbstractMeasurementDataTraitListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'AbstractMeasurementDataTraitListView$1', 2912), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_AbstractSchedulesView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'AbstractSchedulesView', 1753), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_schedules_ResourceGroupSchedulesView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.schedules.', 'ResourceGroupSchedulesView', 3182), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_schedules_ResourceGroupSchedulesView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.schedules.', 'ResourceGroupSchedulesView$1', 3183), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_schedules_ResourceGroupSchedulesView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.schedules.', 'ResourceGroupSchedulesView$2', 3184), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_schedules_ResourceGroupSchedulesView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.schedules.', 'ResourceGroupSchedulesView$3', 3185), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_AbstractSchedulesView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'AbstractSchedulesView$1', 2913), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_AbstractSchedulesView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'AbstractSchedulesView$2', 2914), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_CalltimeView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'CalltimeView', 3454), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeHistoryView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeHistoryView', 2972), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeHistoryView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeHistoryView$1', 2973), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeHistoryView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeHistoryView$2', 2974), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeHistoryView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeHistoryView$3', 2975), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeHistoryView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeHistoryView$4', 2976), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeHistoryView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeHistoryView$5', 2977), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_schedule_AbstractOperationScheduleListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.schedule.', 'AbstractOperationScheduleListView', 2954), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleListView', 3234), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_schedule_AbstractOperationScheduleListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.schedule.', 'AbstractOperationScheduleListView$1', 2955), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_schedule_AbstractOperationScheduleListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.schedule.', 'AbstractOperationScheduleListView$2', 2956), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_GroupResourceConfigurationEditView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'GroupResourceConfigurationEditView', 3114), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_GroupResourceConfigurationEditView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'GroupResourceConfigurationEditView$1', 3115), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_GroupResourceConfigurationEditView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'GroupResourceConfigurationEditView$2', 3116), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_GroupResourceConfigurationEditView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'GroupResourceConfigurationEditView$3', 3117), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_GroupResourceConfigurationEditView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'GroupResourceConfigurationEditView$3$1', 3118), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_GroupResourceConfigurationEditView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'GroupResourceConfigurationEditView$4', 3119), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationView', 3139), Lorg_rhq_core_domain_resource_group_composite_ResourceGroupAvailability_2_classLit = createForClass('org.rhq.core.domain.resource.group.composite.', 'ResourceGroupAvailability', 1485), Lorg_rhq_enterprise_gui_coregui_client_gwt_EventGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'EventGWTService_TypeSerializer', 2821), Lorg_rhq_core_domain_criteria_EventCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'EventCriteria', 1103), Lorg_rhq_core_domain_event_composite_EventComposite_2_classLit = createForClass('org.rhq.core.domain.event.composite.', 'EventComposite', 1237), Lorg_rhq_enterprise_gui_coregui_client_util_GwtTuple_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.', 'GwtTuple', 3764), Lorg_rhq_enterprise_gui_coregui_client_gwt_ContentGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'ContentGWTService_TypeSerializer', 2812), _3Lorg_rhq_core_domain_content_Architecture_2_classLit = createForArray('[Lorg.rhq.core.domain.content.', 'Architecture;', 4053, Lorg_rhq_core_domain_content_Architecture_2_classLit), Lorg_rhq_core_domain_content_PackageVersionFormatDescription_2_classLit = createForClass('org.rhq.core.domain.content.', 'PackageVersionFormatDescription', 1019), Lorg_rhq_core_domain_content_composite_PackageAndLatestVersionComposite_2_classLit = createForClass('org.rhq.core.domain.content.composite.', 'PackageAndLatestVersionComposite', 1054), Lorg_rhq_core_domain_content_composite_PackageTypeAndVersionFormatComposite_2_classLit = createForClass('org.rhq.core.domain.content.composite.', 'PackageTypeAndVersionFormatComposite', 1056), Lorg_rhq_core_domain_criteria_PackageCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'PackageCriteria', 1127), Lorg_rhq_core_domain_criteria_PackageVersionCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'PackageVersionCriteria', null), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupOperationHistoryDetailsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.history.', 'GroupOperationHistoryDetailsView', 3222), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupOperationHistoryDetailsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.history.', 'GroupOperationHistoryDetailsView$1', 3223), Lorg_rhq_enterprise_gui_coregui_client_gwt_AlertDefinitionGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AlertDefinitionGWTService_TypeSerializer', 2788), Lorg_rhq_enterprise_gui_coregui_client_gwt_DriftGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'DriftGWTService_Proxy', 2817), Lorg_rhq_core_domain_drift_DriftChangeSetCategory_2_classLit = createForEnum('org.rhq.core.domain.drift.', 'DriftChangeSetCategory', 1176, Ljava_lang_Enum_2_classLit, values_84, valueOf_90), _3Lorg_rhq_core_domain_drift_DriftChangeSetCategory_2_classLit = createForArray('[Lorg.rhq.core.domain.drift.', 'DriftChangeSetCategory;', 4054, Lorg_rhq_core_domain_drift_DriftChangeSetCategory_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_gwt_RoleGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'RoleGWTService_TypeSerializer', 2871), Lcom_smartgwt_client_widgets_form_validator_IntegerRangeValidator_2_classLit = createForClass('com.smartgwt.client.widgets.form.validator.', 'IntegerRangeValidator', 531), Lorg_rhq_enterprise_gui_coregui_client_components_selector_AssignedItemsChangedEvent_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'AssignedItemsChangedEvent', 2351), Lcom_google_gwt_i18n_client_constants_NumberConstantsImpl_1en_2_classLit = createForClass('com.google.gwt.i18n.client.constants.', 'NumberConstantsImpl_en', 98), Lorg_rhq_enterprise_gui_coregui_client_components_form_ColorButtonItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'ColorButtonItem', 2288), Lorg_rhq_enterprise_gui_coregui_client_components_form_ColorButtonItem$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'ColorButtonItem$1', 2289), Lorg_rhq_enterprise_gui_coregui_client_components_form_ColorButtonItem$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'ColorButtonItem$1$1', 2290), Lcom_smartgwt_client_types_AutoFitWidthApproach_2_classLit = createForEnum('com.smartgwt.client.types.', 'AutoFitWidthApproach', 358, Ljava_lang_Enum_2_classLit, values_6, valueOf_7), _3Lcom_smartgwt_client_types_AutoFitWidthApproach_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'AutoFitWidthApproach;', 4057, Lcom_smartgwt_client_types_AutoFitWidthApproach_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceErrorsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceErrorsDataSource', 3343), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceErrorsDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceErrorsDataSource$1', 3344), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceErrorsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceErrorsView', 3345), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceErrorsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceErrorsView$1', 3346), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceErrorsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceErrorsView$2', 3347), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceErrorsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceErrorsView$3', 3348), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceErrorsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceErrorsView$4', 3349), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceErrorsView$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceErrorsView$4$1', 3350), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ResourceErrorsView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ResourceErrorsView$5', 3351), Lorg_rhq_enterprise_gui_coregui_client_components_form_EditableFormItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EditableFormItem', 2286), Lorg_rhq_enterprise_gui_coregui_client_components_form_EditableFormItem$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EditableFormItem$1', 2296), Lorg_rhq_enterprise_gui_coregui_client_components_form_EditableFormItem$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EditableFormItem$2', 2297), Lorg_rhq_enterprise_gui_coregui_client_components_form_EditableFormItem$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EditableFormItem$3', 2298), Lorg_rhq_enterprise_gui_coregui_client_components_form_EditableFormItem$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EditableFormItem$4', 2299), Lorg_rhq_enterprise_gui_coregui_client_components_form_EditableFormItem$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EditableFormItem$5', 2300), Lorg_rhq_enterprise_gui_coregui_client_components_form_EditableFormItem$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EditableFormItem$6', 2301), Lorg_rhq_enterprise_gui_coregui_client_components_form_EditableFormItem$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EditableFormItem$7', 2302), Lorg_rhq_enterprise_gui_coregui_client_components_form_EditableFormItem$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'EditableFormItem$8', 2303), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_GeneralProperties_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'GeneralProperties', 3052), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_GeneralProperties$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'GeneralProperties$1', 3053), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_GeneralProperties$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'GeneralProperties$1$1', 3054), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_GeneralProperties$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'GeneralProperties$2', 3055), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_GeneralProperties$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'GeneralProperties$2$1', 3056), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_GeneralProperties$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'GeneralProperties$3', 3057), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_GeneralProperties$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.', 'GeneralProperties$3$1', 3058), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationTable', 3159), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationTable$DataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationTable$DataSource', 3166), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationTable$DataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationTable$DataSource$1', 3167), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationTable$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationTable$1', 3160), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationTable$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationTable$2', 3161), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationTable$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationTable$3', 3162), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationTable$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationTable$3$1', 3163), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationTable$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationTable$4', 3164), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationTable$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationTable$5', 3165), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_GroupMeasurementTableView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'GroupMeasurementTableView', 3198), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_GroupMeasurementTableView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'GroupMeasurementTableView$1', 3199), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_GroupMembersHealthView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'GroupMembersHealthView', 3200), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_GroupMembersHealthView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'GroupMembersHealthView$1', 3201), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_AbstractMeasurementDataTraitDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'AbstractMeasurementDataTraitDataSource', 2907), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsDataSource', 3203), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsDataSource$1', 3204), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsDataSource$2', 3205), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsDataSource$3', 3206), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_AbstractMeasurementDataTraitDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'AbstractMeasurementDataTraitDataSource$1', 2908), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_CalltimeDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'CalltimeDataSource', 3448), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_CalltimeDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'CalltimeDataSource$1', 3449), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_CalltimeDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'CalltimeDataSource$2', 3450), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_CalltimeDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'CalltimeDataSource$3', 3451), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_CalltimeDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'CalltimeDataSource$4', 3452), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_CalltimeDataSource$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'CalltimeDataSource$5', 3453), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_schedule_AbstractOperationScheduleDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.schedule.', 'AbstractOperationScheduleDataSource', 2948), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleDataSource', 3224), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleDataSource$1', 3225), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleDataSource$2', 3226), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleDataSource$3', 3227), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleDataSource$4', 3228), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_schedule_AbstractOperationScheduleDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.schedule.', 'AbstractOperationScheduleDataSource$1', 2949), Lorg_rhq_enterprise_gui_coregui_client_util_preferences_MeasurementUserPreferences_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.util.preferences.', 'MeasurementUserPreferences', 3803), Lcom_smartgwt_client_widgets_form_fields_AutoFitTextAreaItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'AutoFitTextAreaItem', 485), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_ResourceResourceGroupSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'ResourceResourceGroupSelector', 3443), Lorg_rhq_core_domain_drift_DriftDetails_2_classLit = createForClass('org.rhq.core.domain.drift.', 'DriftDetails', 1199), Lorg_rhq_enterprise_gui_coregui_client_gwt_DriftGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'DriftGWTService_TypeSerializer', 2818), Lorg_rhq_core_domain_criteria_DriftDefinitionCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'DriftDefinitionCriteria', 1099), Lorg_rhq_core_domain_criteria_DriftDefinitionTemplateCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'DriftDefinitionTemplateCriteria', 1101), Lorg_rhq_core_domain_criteria_GenericDriftChangeSetCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'GenericDriftChangeSetCriteria', 1105), Lorg_rhq_core_domain_drift_DriftDefinitionComposite_2_classLit = createForClass('org.rhq.core.domain.drift.', 'DriftDefinitionComposite', 1194), Lorg_rhq_core_domain_drift_DriftFileStatus_2_classLit = createForEnum('org.rhq.core.domain.drift.', 'DriftFileStatus', 1201, Ljava_lang_Enum_2_classLit, values_88, valueOf_94), Lorg_rhq_core_domain_drift_DriftSnapshot_2_classLit = createForClass('org.rhq.core.domain.drift.', 'DriftSnapshot', 1204), Lorg_rhq_core_domain_drift_DriftSnapshot$DriftSnapshotDirectory_2_classLit = createForClass('org.rhq.core.domain.drift.', 'DriftSnapshot$DriftSnapshotDirectory', 1205), Lorg_rhq_core_domain_drift_DriftSnapshotRequest_2_classLit = createForClass('org.rhq.core.domain.drift.', 'DriftSnapshotRequest', 1206), Lorg_rhq_core_domain_drift_FileDiffReport_2_classLit = createForClass('org.rhq.core.domain.drift.', 'FileDiffReport', 1210), Lorg_rhq_core_domain_drift_JPADrift_2_classLit = createForClass('org.rhq.core.domain.drift.', 'JPADrift', 1213), Lorg_rhq_core_domain_drift_JPADriftChangeSet_2_classLit = createForClass('org.rhq.core.domain.drift.', 'JPADriftChangeSet', 1214), Lorg_rhq_core_domain_drift_AbstractJPADriftFile_2_classLit = createForClass('org.rhq.core.domain.drift.', 'AbstractJPADriftFile', 1170), Lorg_rhq_core_domain_drift_JPADriftFile_2_classLit = createForClass('org.rhq.core.domain.drift.', 'JPADriftFile', 1216), Lorg_rhq_core_domain_drift_JPADriftSet_2_classLit = createForClass('org.rhq.core.domain.drift.', 'JPADriftSet', 1218), Lorg_rhq_core_domain_drift_dto_DriftChangeSetDTO_2_classLit = createForClass('org.rhq.core.domain.drift.dto.', 'DriftChangeSetDTO', 1221), Lorg_rhq_core_domain_drift_dto_DriftDTO_2_classLit = createForClass('org.rhq.core.domain.drift.dto.', 'DriftDTO', 1223), Lorg_rhq_core_domain_drift_dto_DriftFileDTO_2_classLit = createForClass('org.rhq.core.domain.drift.dto.', 'DriftFileDTO', 1225), _3Lorg_rhq_core_domain_plugin_PluginDeploymentType_2_classLit = createForArray('[Lorg.rhq.core.domain.plugin.', 'PluginDeploymentType;', 4058, Lorg_rhq_core_domain_plugin_PluginDeploymentType_2_classLit), Lcom_google_gwt_user_client_ui_WidgetCollection_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'WidgetCollection', 310), _3Lcom_google_gwt_user_client_ui_Widget_2_classLit = createForArray('[Lcom.google.gwt.user.client.ui.', 'Widget;', 4059, Lcom_google_gwt_user_client_ui_Widget_2_classLit), Lcom_google_gwt_user_client_ui_WidgetCollection$WidgetIterator_2_classLit = createForClass('com.google.gwt.user.client.ui.', 'WidgetCollection$WidgetIterator', 311), Lcom_smartgwt_client_widgets_form_fields_events_BlurEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.events.', 'BlurEvent', 517), Lcom_smartgwt_client_widgets_menu_events_ItemClickEvent_2_classLit = createForClass('com.smartgwt.client.widgets.menu.events.', 'ItemClickEvent', 564), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_AbstractBundleRevertWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'AbstractBundleRevertWizard', 2163), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_BundleRevertWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'BundleRevertWizard', 2164), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_summary_ActivityView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.summary.', 'ActivityView', 3507), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_summary_ActivityView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.summary.', 'ActivityView$1', 3508), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_summary_ActivityView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.summary.', 'ActivityView$1$1', 3509), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_summary_ActivityView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.summary.', 'ActivityView$2', 3510), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_summary_ActivityView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.summary.', 'ActivityView$3', 3511), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_summary_ActivityView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.summary.', 'ActivityView$3$1', 3512), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_summary_TimelineView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.summary.', 'TimelineView', 3513), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_summary_TimelineView$1RangeEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.summary.', 'TimelineView$1RangeEditor', 3514), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeSearchView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeSearchView', 3255), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeSearchView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeSearchView$1', 3256), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeSearchView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeSearchView$2', 3257), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeSearchView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeSearchView$3', 3258), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeSearchView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeSearchView$3$1', 3259), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeSearchView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeSearchView$4', 3260), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeSearchView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeSearchView$5', 3261), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeSearchView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeSearchView$6', 3262), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeSearchView$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeSearchView$7', 3263), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeSearchView$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeSearchView$8', 3264), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ChildHistoryView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ChildHistoryView', 3293), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ChildHistoryView$DataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ChildHistoryView$DataSource', 3297), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ChildHistoryView$DetailsWindow_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ChildHistoryView$DetailsWindow', 3300), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ChildHistoryView$DataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ChildHistoryView$DataSource$1', 3298), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ChildHistoryView$DataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ChildHistoryView$DataSource$1$1', 3299), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ChildHistoryView$DetailsWindow$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ChildHistoryView$DetailsWindow$1', 3301), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ChildHistoryView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ChildHistoryView$1', 3294), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ChildHistoryView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ChildHistoryView$2', 3295), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ChildHistoryView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ChildHistoryView$3', 3296), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationEditView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationEditView', 3426), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationEditView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationEditView$1', 3427), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationEditView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationEditView$2', 3428), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationEditView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationEditView$3', 3429), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_ResourceAgentView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'ResourceAgentView', 3440), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_ResourceAgentView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'ResourceAgentView$1', 3441), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_ResourceAgentView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'ResourceAgentView$1$1', 3442), Lorg_rhq_enterprise_gui_coregui_client_alert_ResourceAlertHistoryView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.', 'ResourceAlertHistoryView', 1893), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceAlertDefinitionsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceAlertDefinitionsView', 1980), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceAlertDefinitionsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceAlertDefinitionsView$1', 1981), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceAlertDefinitionsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceAlertDefinitionsView$2', 1982), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceAlertDefinitionsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceAlertDefinitionsView$3', 1983), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceAlertDefinitionsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceAlertDefinitionsView$4', 1984), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceAlertDefinitionsView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceAlertDefinitionsView$5', 1985), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_D3GraphListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'D3GraphListView', 3455), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_D3GraphListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'D3GraphListView$1', 3456), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_D3GraphListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'D3GraphListView$2', 3457), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_D3GraphListView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'D3GraphListView$2$1', 3458), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_D3GraphListView$2$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'D3GraphListView$2$2', 3459), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_D3GraphListView$2$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'D3GraphListView$2$3', 3460), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_D3GraphListView$2$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'D3GraphListView$2$4', 3461), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_D3GraphListView$2$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.', 'D3GraphListView$2$5', 3462), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableView', 3480), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableView$1', 3481), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableView$1$1', 3482), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableView$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableView$1$1$1', 3483), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableView$2', 3484), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableView$2$1', 3485), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableView$2$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableView$2$1$1', 3486), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableView$3', 3487), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_traits_TraitsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.traits.', 'TraitsView', 3490), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_traits_TraitsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.traits.', 'TraitsView$1', 3491), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_traits_TraitsView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.traits.', 'TraitsView$1$1', 3492), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_traits_TraitsView$1$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.traits.', 'TraitsView$1$1$1', 3493), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_avail_ResourceAvailabilityView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.avail.', 'ResourceAvailabilityView', 3469), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_avail_ResourceAvailabilityView$ListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.avail.', 'ResourceAvailabilityView$ListView', 3471), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_avail_ResourceAvailabilityView$ListView$DS_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.avail.', 'ResourceAvailabilityView$ListView$DS', 3472), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_avail_ResourceAvailabilityView$ListView$DS$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.avail.', 'ResourceAvailabilityView$ListView$DS$1', 3473), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_avail_ResourceAvailabilityView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.avail.', 'ResourceAvailabilityView$1', 3470), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_schedules_ResourceSchedulesView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.schedules.', 'ResourceSchedulesView', 3474), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_schedules_ResourceSchedulesView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.schedules.', 'ResourceSchedulesView$1', 3475), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_schedules_ResourceSchedulesView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.schedules.', 'ResourceSchedulesView$2', 3476), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_schedules_ResourceSchedulesView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.schedules.', 'ResourceSchedulesView$3', 3477), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_monitoring_IFrameWithMeasurementRangeEditorView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.monitoring.', 'IFrameWithMeasurementRangeEditorView', 2930), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_monitoring_IFrameWithMeasurementRangeEditorView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.monitoring.', 'IFrameWithMeasurementRangeEditorView$1', 2931), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_schedule_ResourceOperationScheduleListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.schedule.', 'ResourceOperationScheduleListView', 3506), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_history_ResourceOperationHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.history.', 'ResourceOperationHistoryListView', 3499), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationEditView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationEditView', 3415), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationEditView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationEditView$1', 3416), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationEditView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationEditView$2', 3417), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationEditView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationEditView$2$1', 3418), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationEditView$2$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationEditView$2$1$1', 3419), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_configuration_ResourceConfigurationEditView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.configuration.', 'ResourceConfigurationEditView$3', 3420), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionsView', 2713), Lorg_rhq_enterprise_gui_coregui_client_drift_ResourceDriftDefinitionsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'ResourceDriftDefinitionsView', 2747), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView$DetailView_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionsView$DetailView', 2720, Ljava_lang_Enum_2_classLit, values_132, valueOf_138), _3Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView$DetailView_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionsView$DetailView;', 4060, Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView$DetailView_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionsView$1', 2714), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionsView$2', 2715), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionsView$3', 2716), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionsView$4', 2717), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionsView$5', 2718), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionsView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionsView$6', 2719), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationSettings_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationSettings', 3155), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationSettings$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationSettings$1', 3156), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationSettings$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationSettings$2', 3157), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationSettings$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationSettings$2$1', 3158), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationMembers_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationMembers', 3146), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationMembers$MembersTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationMembers$MembersTable', 3147), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationMembers$MembersTable$DataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationMembers$MembersTable$DataSource', 3152), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationMembers$MembersTable$DataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationMembers$MembersTable$DataSource$1', 3153), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationMembers$MembersTable$DataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationMembers$MembersTable$DataSource$1$1', 3154), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationMembers$MembersTable$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationMembers$MembersTable$1', 3148), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationMembers$MembersTable$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationMembers$MembersTable$2', 3149), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationMembers$MembersTable$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationMembers$MembersTable$3', 3150), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_HistoryGroupPluginConfigurationMembers$MembersTable$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'HistoryGroupPluginConfigurationMembers$MembersTable$4', 3151), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SingleAlertDefinitionView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SingleAlertDefinitionView', 2007), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SingleAlertDefinitionView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SingleAlertDefinitionView$1', 2008), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SingleAlertDefinitionView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SingleAlertDefinitionView$2', 2009), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SingleAlertDefinitionView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SingleAlertDefinitionView$3', 2010), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SingleAlertDefinitionView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SingleAlertDefinitionView$4', 2011), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SingleAlertDefinitionView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SingleAlertDefinitionView$5', 2012), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SingleAlertDefinitionView$5$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SingleAlertDefinitionView$5$1', 2013), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SingleAlertDefinitionView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SingleAlertDefinitionView$6', 2014), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableDataSource', 3195), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_GroupMeasurementTableDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'GroupMeasurementTableDataSource', 3194), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_GroupMeasurementTableDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'GroupMeasurementTableDataSource$1', 3196), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_GroupMeasurementTableDataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'GroupMeasurementTableDataSource$1$1', 3197), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableDataSource$1', 3478), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_table_MeasurementTableDataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.table.', 'MeasurementTableDataSource$1$1', 3479), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_AbstractMeasurementDataTraitListDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'AbstractMeasurementDataTraitListDetailView', 2909), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsDetailView', 3207), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsDetailView$1', 3208), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_traits_TraitsDetailView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.traits.', 'TraitsDetailView$2', 3209), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_AbstractMeasurementDataTraitListDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'AbstractMeasurementDataTraitListDetailView$1', 2910), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_SchedulesDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'SchedulesDataSource', 2915), Lorg_rhq_enterprise_gui_coregui_client_components_table_BooleanCellFormatter_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.table.', 'BooleanCellFormatter', 2369), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_SchedulesDataSource$CollectionEnabledCellFormatter_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'SchedulesDataSource$CollectionEnabledCellFormatter', 2917), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_SchedulesDataSource$CollectionIntervalCellFormatter_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'SchedulesDataSource$CollectionIntervalCellFormatter', 2918), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_SchedulesDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'SchedulesDataSource$1', 2916), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_UpdateCollectionIntervalWidget_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'UpdateCollectionIntervalWidget', 2919), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_UpdateCollectionIntervalWidget$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'UpdateCollectionIntervalWidget$1', 2920), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_UpdateCollectionIntervalWidget$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'UpdateCollectionIntervalWidget$2', 2921), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_UpdateCollectionIntervalWidget$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.', 'UpdateCollectionIntervalWidget$3', 2922), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDatasource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDatasource', 2960), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDatasource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDatasource$1', 2961), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDatasource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDatasource$2', 2962), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDatasource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDatasource$3', 2963), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDatasource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDatasource$4', 2964), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDatasource$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDatasource$5', 2965), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDatasource$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDatasource$6', 2966), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDatasource$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDatasource$7', 2967), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDatasource$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDatasource$8', 2968), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDatasource$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDatasource$9', 2969), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_schedule_AbstractOperationScheduleDetailsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.schedule.', 'AbstractOperationScheduleDetailsView', 2950), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleDetailsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleDetailsView', 3229), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleDetailsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleDetailsView$1', 3230), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleDetailsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleDetailsView$2', 3231), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleDetailsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleDetailsView$3', 3232), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_schedule_GroupOperationScheduleDetailsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.schedule.', 'GroupOperationScheduleDetailsView$4', 3233), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_schedule_AbstractOperationScheduleDetailsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.schedule.', 'AbstractOperationScheduleDetailsView$1', 2951), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_schedule_AbstractOperationScheduleDetailsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.schedule.', 'AbstractOperationScheduleDetailsView$2', 2952), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_detail_operation_schedule_AbstractOperationScheduleDetailsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.detail.operation.schedule.', 'AbstractOperationScheduleDetailsView$3', 2953), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationSettings_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationSettings', 3129), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationSettings$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationSettings$1', 3130), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationSettings$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationSettings$2', 3131), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationSettings$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationSettings$2$1', 3132), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationMembers_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationMembers', 3120), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationMembers$MembersTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationMembers$MembersTable', 3121), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationMembers$MembersTable$DataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationMembers$MembersTable$DataSource', 3126), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationMembers$MembersTable$DataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationMembers$MembersTable$DataSource$1', 3127), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationMembers$MembersTable$DataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationMembers$MembersTable$DataSource$1$1', 3128), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationMembers$MembersTable$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationMembers$MembersTable$1', 3122), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationMembers$MembersTable$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationMembers$MembersTable$2', 3123), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationMembers$MembersTable$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationMembers$MembersTable$3', 3124), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_configuration_HistoryGroupResourceConfigurationMembers$MembersTable$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.configuration.', 'HistoryGroupResourceConfigurationMembers$MembersTable$4', 3125), Lorg_rhq_enterprise_gui_coregui_client_gwt_AvailabilityGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AvailabilityGWTService_Proxy', 2799), Lorg_rhq_enterprise_gui_coregui_client_gwt_LdapGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'LdapGWTService_Proxy', 2831), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_TemplateAlertDefinitionsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'TemplateAlertDefinitionsView', 2022), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_TemplateAlertDefinitionsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'TemplateAlertDefinitionsView$1', 2023), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_TemplateAlertDefinitionsView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'TemplateAlertDefinitionsView$2', 2024), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_TemplateAlertDefinitionsView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'TemplateAlertDefinitionsView$3', 2025), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_TemplateAlertDefinitionsView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'TemplateAlertDefinitionsView$4', 2026), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_TemplateAlertDefinitionsView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'TemplateAlertDefinitionsView$5', 2027), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_TemplateAlertDefinitionsView$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'TemplateAlertDefinitionsView$6', 2028), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView', 2700), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$DriftDefinitionTemplatesListGrid_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$DriftDefinitionTemplatesListGrid', 2704), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$TemplateDefinitionsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$TemplateDefinitionsView', 2705), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsListGrid_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsListGrid', 2712), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource', 2706), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$1', 2707), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$2', 2708), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$3', 2709), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$4', 2710), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$TemplateDefinitionsView$TemplateDefinitionsDataSource$5', 2711), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$1', 2701), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$2', 2702), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplatesView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplatesView$3', 2703), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_TemplateSchedulesView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'TemplateSchedulesView', 1752), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_TemplateSchedulesView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'TemplateSchedulesView$1', 1754), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_TemplateSchedulesView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'TemplateSchedulesView$2', 1755), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_TemplateSchedulesView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'TemplateSchedulesView$3', 1756), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleResourceDeploymentHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleResourceDeploymentHistoryListView', 2113), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleResourceDeploymentHistoryListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleResourceDeploymentHistoryListView$1', 2114), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleResourceDeploymentHistoryListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleResourceDeploymentHistoryListView$2', 2115), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleResourceDeploymentHistoryListView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleResourceDeploymentHistoryListView$3', 2116), Lorg_rhq_enterprise_gui_coregui_client_bundle_deployment_BundleResourceDeploymentHistoryListView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.deployment.', 'BundleResourceDeploymentHistoryListView$4', 2117), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_ConfirmationStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'ConfirmationStep', 2165), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_ConfirmationStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'ConfirmationStep$1', 2166), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_ConfirmationStep$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'ConfirmationStep$1$1', 2167), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_ConfirmationStep$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'ConfirmationStep$2', 2168), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_GetRevertInfoStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'GetRevertInfoStep', 2169), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_GetRevertInfoStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'GetRevertInfoStep$1', 2170), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_GetRevertInfoStep$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'GetRevertInfoStep$1$1', 2171), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_GetRevertInfoStep$1$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'GetRevertInfoStep$1$2', 2172), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_RevertStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'RevertStep', 2173), Lorg_rhq_enterprise_gui_coregui_client_bundle_revert_RevertStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.bundle.revert.', 'RevertStep$1', 2174), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationHistoryDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationHistoryDataSource', 3430), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationHistoryDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationHistoryDataSource$1', 3431), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationHistoryDataSource$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationHistoryDataSource$1$1', 3432), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationHistoryDataSource$1$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationHistoryDataSource$1$2', 3433), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_traits_TraitsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.traits.', 'TraitsDataSource', 3488), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_schedule_ResourceOperationScheduleDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.schedule.', 'ResourceOperationScheduleDataSource', 3500), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_schedule_ResourceOperationScheduleDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.schedule.', 'ResourceOperationScheduleDataSource$1', 3501), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_schedule_ResourceOperationScheduleDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.schedule.', 'ResourceOperationScheduleDataSource$2', 3502), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_schedule_ResourceOperationScheduleDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.schedule.', 'ResourceOperationScheduleDataSource$3', 3503), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_schedule_ResourceOperationScheduleDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.schedule.', 'ResourceOperationScheduleDataSource$4', 3504), Lorg_rhq_enterprise_gui_coregui_client_components_form_StringLengthValidator_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'StringLengthValidator', 2319), Lorg_rhq_enterprise_gui_coregui_client_components_form_CheckboxEditableFormItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'CheckboxEditableFormItem', 2285), Lcom_smartgwt_client_types_SelectionType_2_classLit = createForEnum('com.smartgwt.client.types.', 'SelectionType', 410, Ljava_lang_Enum_2_classLit, values_32, valueOf_33), _3Lcom_smartgwt_client_types_SelectionType_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'SelectionType;', 4061, Lcom_smartgwt_client_types_SelectionType_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_GroupAlertDefinitionsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'GroupAlertDefinitionsDataSource', 1954), Lorg_rhq_core_domain_measurement_calltime_CallTimeDataValue_2_classLit = createForClass('org.rhq.core.domain.measurement.calltime.', 'CallTimeDataValue', null), Lorg_rhq_enterprise_gui_coregui_client_components_form_DateTimeFilterItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'DateTimeFilterItem', 2292), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDetailsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDetailsView', 2970), Lorg_rhq_enterprise_gui_coregui_client_inventory_common_event_EventCompositeDetailsView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.common.event.', 'EventCompositeDetailsView$1', 2971), Lorg_rhq_enterprise_gui_coregui_client_gwt_AvailabilityGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AvailabilityGWTService_TypeSerializer', 2800), Lorg_rhq_core_domain_criteria_AvailabilityCriteria_2_classLit = createForClass('org.rhq.core.domain.criteria.', 'AvailabilityCriteria', 1073), _3Lorg_rhq_core_domain_resource_group_composite_ResourceGroupAvailability_2_classLit = createForArray('[Lorg.rhq.core.domain.resource.group.composite.', 'ResourceGroupAvailability;', 4062, Lorg_rhq_core_domain_resource_group_composite_ResourceGroupAvailability_2_classLit), _3Lorg_rhq_core_domain_common_JobTrigger$StartType_2_classLit = createForArray('[Lorg.rhq.core.domain.common.', 'JobTrigger$StartType;', 4063, Lorg_rhq_core_domain_common_JobTrigger$StartType_2_classLit), _3Lorg_rhq_core_domain_common_JobTrigger$RecurrenceType_2_classLit = createForArray('[Lorg.rhq.core.domain.common.', 'JobTrigger$RecurrenceType;', 4064, Lorg_rhq_core_domain_common_JobTrigger$RecurrenceType_2_classLit), _3Lorg_rhq_core_domain_common_JobTrigger$EndType_2_classLit = createForArray('[Lorg.rhq.core.domain.common.', 'JobTrigger$EndType;', 4065, Lorg_rhq_core_domain_common_JobTrigger$EndType_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupMemberResourceOperationHistoryListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.history.', 'GroupMemberResourceOperationHistoryListView', 3218), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupMemberResourceOperationHistoryListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.history.', 'GroupMemberResourceOperationHistoryListView$1', 3219), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_operation_history_GroupMemberResourceOperationHistoryListView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.operation.history.', 'GroupMemberResourceOperationHistoryListView$2', 3220), Lcom_smartgwt_client_widgets_form_fields_FloatItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'FloatItem', 496), _3Lorg_rhq_core_domain_drift_DriftFileStatus_2_classLit = createForArray('[Lorg.rhq.core.domain.drift.', 'DriftFileStatus;', 4066, Lorg_rhq_core_domain_drift_DriftFileStatus_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_gwt_LdapGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'LdapGWTService_TypeSerializer', 2832), Lcom_smartgwt_client_types_ExpansionMode_2_classLit = createForEnum('com.smartgwt.client.types.', 'ExpansionMode', 382, Ljava_lang_Enum_2_classLit, values_18, valueOf_19), _3Lcom_smartgwt_client_types_ExpansionMode_2_classLit = createForArray('[Lcom.smartgwt.client.types.', 'ExpansionMode;', 4067, Lcom_smartgwt_client_types_ExpansionMode_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginControlView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginControlView', 1631), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginControlView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginControlView$1', 1633), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginControlView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginControlView$2', 1634), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginControlView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginControlView$2$1', 1635), Lorg_rhq_enterprise_gui_coregui_client_admin_ServerPluginControlView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.', 'ServerPluginControlView$3', 1636), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationHistoryDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationHistoryDetailView', 3434), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationHistoryDetailView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationHistoryDetailView$1', 3435), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_inventory_PluginConfigurationHistoryDetailView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.inventory.', 'PluginConfigurationHistoryDetailView$2', 3436), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceAlertDefinitionsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceAlertDefinitionsDataSource', 1979), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_monitoring_traits_TraitsDetailView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.monitoring.traits.', 'TraitsDetailView', 3489), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_schedule_ResourceOperationScheduleDetailsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.schedule.', 'ResourceOperationScheduleDetailsView', 3505), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_ResourceGroupMembershipView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'ResourceGroupMembershipView', 3174), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_ResourceGroupMembershipView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'ResourceGroupMembershipView$1', 3175), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_ResourceGroupMembershipView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'ResourceGroupMembershipView$2', 3176), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_ResourceGroupMembershipView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'ResourceGroupMembershipView$3', 3177), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_ResourceGroupMembershipView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'ResourceGroupMembershipView$4', 3178), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_GeneralPropertiesAlertDefinitionForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'GeneralPropertiesAlertDefinitionForm', 1953), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsAlertDefinitionForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsAlertDefinitionForm', 1933), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsAlertDefinitionForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsAlertDefinitionForm$1', 1934), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NotificationsAlertDefinitionForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NotificationsAlertDefinitionForm', 1967), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NotificationsAlertDefinitionForm$NotificationDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NotificationsAlertDefinitionForm$NotificationDataSource', 1968), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NotificationsAlertDefinitionForm$NotificationTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NotificationsAlertDefinitionForm$NotificationTable', 1970), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NotificationsAlertDefinitionForm$NotificationDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NotificationsAlertDefinitionForm$NotificationDataSource$1', 1969), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NotificationsAlertDefinitionForm$NotificationTable$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NotificationsAlertDefinitionForm$NotificationTable$1', 1971), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NotificationsAlertDefinitionForm$NotificationTable$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NotificationsAlertDefinitionForm$NotificationTable$2', 1972), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NotificationsAlertDefinitionForm$NotificationTable$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NotificationsAlertDefinitionForm$NotificationTable$3', 1973), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NotificationsAlertDefinitionForm$NotificationTable$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NotificationsAlertDefinitionForm$NotificationTable$4', 1974), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NotificationsAlertDefinitionForm$NotificationTable$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NotificationsAlertDefinitionForm$NotificationTable$5', 1975), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_RecoveryAlertDefinitionForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'RecoveryAlertDefinitionForm', 1976), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_RecoveryAlertDefinitionForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'RecoveryAlertDefinitionForm$1', 1977), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_RecoveryAlertDefinitionForm$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'RecoveryAlertDefinitionForm$2', 1978), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_DampeningAlertDefinitionForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'DampeningAlertDefinitionForm', 1944), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_DampeningAlertDefinitionForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'DampeningAlertDefinitionForm$1', 1945), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_DampeningAlertDefinitionForm$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'DampeningAlertDefinitionForm$2', 1946), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_DampeningAlertDefinitionForm$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'DampeningAlertDefinitionForm$3', 1947), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_DampeningAlertDefinitionForm$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'DampeningAlertDefinitionForm$4', 1948), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_DampeningAlertDefinitionForm$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'DampeningAlertDefinitionForm$5', 1949), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_DampeningAlertDefinitionForm$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'DampeningAlertDefinitionForm$6', 1950), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_DampeningAlertDefinitionForm$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'DampeningAlertDefinitionForm$7', 1951), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_DampeningAlertDefinitionForm$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'DampeningAlertDefinitionForm$8', 1952), Lorg_rhq_core_domain_measurement_ui_MeasurementSummary_2_classLit = createForClass('org.rhq.core.domain.measurement.ui.', 'MeasurementSummary', 1309), Lorg_rhq_core_domain_measurement_ui_BaseMetricDisplay_2_classLit = createForClass('org.rhq.core.domain.measurement.ui.', 'BaseMetricDisplay', 1308), Lorg_rhq_core_domain_measurement_ui_MetricDisplaySummary_2_classLit = createForClass('org.rhq.core.domain.measurement.ui.', 'MetricDisplaySummary', 1313), Lcom_smartgwt_client_widgets_form_fields_IntegerItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'IntegerItem', 503), Lorg_rhq_enterprise_gui_coregui_client_components_form_DurationItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'DurationItem', 2293), Lorg_rhq_enterprise_gui_coregui_client_components_form_UnitType_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.components.form.', 'UnitType', 2322, Ljava_lang_Enum_2_classLit, values_130, valueOf_136), Lorg_rhq_enterprise_gui_coregui_client_components_form_DurationItem$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'DurationItem$1', 2294), Lorg_rhq_enterprise_gui_coregui_client_components_form_DurationItem$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'DurationItem$2', 2295), Lorg_rhq_enterprise_gui_coregui_client_components_trigger_JobTriggerEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.trigger.', 'JobTriggerEditor', 2400), Lorg_rhq_enterprise_gui_coregui_client_components_trigger_JobTriggerEditor$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.trigger.', 'JobTriggerEditor$1', 2401), Lorg_rhq_enterprise_gui_coregui_client_components_trigger_JobTriggerEditor$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.trigger.', 'JobTriggerEditor$2', 2402), Lorg_rhq_enterprise_gui_coregui_client_components_trigger_JobTriggerEditor$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.trigger.', 'JobTriggerEditor$3', 2403), Lorg_rhq_enterprise_gui_coregui_client_components_trigger_JobTriggerEditor$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.trigger.', 'JobTriggerEditor$4', 2404), Lorg_rhq_enterprise_gui_coregui_client_components_trigger_JobTriggerEditor$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.trigger.', 'JobTriggerEditor$5', 2405), Lorg_rhq_enterprise_gui_coregui_client_components_trigger_JobTriggerEditor$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.trigger.', 'JobTriggerEditor$6', 2406), Lorg_rhq_enterprise_gui_coregui_client_components_form_TimeUnit_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.components.form.', 'TimeUnit', 2320, Ljava_lang_Enum_2_classLit, values_129, valueOf_135), _3Lorg_rhq_enterprise_gui_coregui_client_components_form_TimeUnit_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.components.form.', 'TimeUnit;', 4068, Lorg_rhq_enterprise_gui_coregui_client_components_form_TimeUnit_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_components_sorter_ReorderableList_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.sorter.', 'ReorderableList', 2354), Lorg_rhq_enterprise_gui_coregui_client_components_sorter_ReorderableList$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.sorter.', 'ReorderableList$1', 2355), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_history_ResourceOperationHistoryDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.history.', 'ResourceOperationHistoryDataSource', 3494), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_history_ResourceOperationHistoryDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.history.', 'ResourceOperationHistoryDataSource$1', 3495), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_operation_history_ResourceOperationHistoryDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.history.', 'ResourceOperationHistoryDataSource$2', 3496), Lcom_smartgwt_client_widgets_form_validator_FloatRangeValidator_2_classLit = createForClass('com.smartgwt.client.widgets.form.validator.', 'FloatRangeValidator', 530), Lorg_rhq_enterprise_gui_coregui_client_components_form_IsLongValidator_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'IsLongValidator', 2307), Lcom_smartgwt_client_widgets_form_validator_IsFloatValidator_2_classLit = createForClass('com.smartgwt.client.widgets.form.validator.', 'IsFloatValidator', 532), Lcom_smartgwt_client_widgets_form_fields_events_FocusEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.events.', 'FocusEvent', 522), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource', 2673), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource$1', 2674), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource$2', 2675), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource$3', 2676), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource$4', 2677), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource$5', 2678), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource$6', 2679), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource$7', 2680), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource$8', 2681), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource$9', 2682), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionDataSource$9$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionDataSource$9$1', 2683), Lorg_rhq_enterprise_gui_coregui_client_admin_roles_RoleResourceGroupSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.roles.', 'RoleResourceGroupSelector', 1702), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_TemplateAlertDefinitionsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'TemplateAlertDefinitionsDataSource', 2021), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateDataSource', 2688), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateDataSource$1', 2689), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateDataSource$2', 2690), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateDataSource$3', 2691), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateDataSource$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateDataSource$4', 2692), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateDataSource$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateDataSource$5', 2693), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView', 2699), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateSnapshotView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateSnapshotView', 2698), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$DriftSnapshotListGrid_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$DriftSnapshotListGrid', 2746), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$DirectoryView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$DirectoryView', 2738), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$DirectoryView$DirectoryViewListGrid_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$DirectoryView$DirectoryViewListGrid', 2743), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$DirectoryView$DirectoryViewDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$DirectoryView$DirectoryViewDataSource', 2739), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$DirectoryView$DirectoryViewListGrid$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$DirectoryView$DirectoryViewListGrid$1', 2744), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$DirectoryView$DirectoryViewListGrid$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$DirectoryView$DirectoryViewListGrid$2', 2745), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$DirectoryView$DirectoryViewDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$DirectoryView$DirectoryViewDataSource$1', 2740), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$DirectoryView$DirectoryViewDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$DirectoryView$DirectoryViewDataSource$2', 2741), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$DirectoryView$DirectoryViewDataSource$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$DirectoryView$DirectoryViewDataSource$3', 2742), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$1', 2733), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$2', 2734), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$3', 2735), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$4', 2736), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotView$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotView$5', 2737), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateEditView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateEditView', 2694), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateEditView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateEditView$1', 2695), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateEditView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateEditView$2', 2696), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionTemplateEditView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionTemplateEditView$3', 2697), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_UpdateExistingSchedulesWidget_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'UpdateExistingSchedulesWidget', 1757), Lorg_rhq_enterprise_gui_coregui_client_admin_templates_UpdateExistingSchedulesWidget$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.admin.templates.', 'UpdateExistingSchedulesWidget$1', 1758), Lcom_smartgwt_client_widgets_form_ColorPicker_2_classLit = createForClass('com.smartgwt.client.widgets.form.', 'ColorPicker', 477), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeDataSource', 3252), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeDataSource$1', 3253), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_ResourceCompositeDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.', 'ResourceCompositeDataSource$2', 3254), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionEditView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionEditView', 2684), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionEditView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionEditView$1', 2685), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionEditView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionEditView$2', 2686), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftDefinitionEditView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftDefinitionEditView$3', 2687), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_Carousel_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'Carousel', 2207), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_BookmarkableCarousel_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'BookmarkableCarousel', 2206), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselView', 2662), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselView$1', 2663), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselView$2', 2664), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselView$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselView$2$1', 2665), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselView$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselView$3', 2666), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselView$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselView$3$1', 2667), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_BookmarkableCarousel$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'BookmarkableCarousel$1', 2208), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_BookmarkableCarousel$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'BookmarkableCarousel$2', 2209), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_Carousel$CarouselFilter_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'Carousel$CarouselFilter', 2218), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_Carousel$CarouselActionInfo_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'Carousel$CarouselActionInfo', 2217), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_Carousel$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'Carousel$1', 2210), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_Carousel$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'Carousel$1$1', 2211), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_Carousel$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'Carousel$2', 2212), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_Carousel$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'Carousel$3', 2213), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_Carousel$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'Carousel$4', 2214), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_Carousel$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'Carousel$5', 2215), Lorg_rhq_enterprise_gui_coregui_client_components_carousel_Carousel$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.carousel.', 'Carousel$6', 2216), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselMemberView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselMemberView', 2655), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselMemberView$DriftCarouselDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselMemberView$DriftCarouselDataSource', 2659), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselMemberView$DriftCarouselDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselMemberView$DriftCarouselDataSource$1', 2661), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselMemberView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselMemberView$1', 2657), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftCarouselMemberView$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftCarouselMemberView$2', 2658), Lorg_rhq_enterprise_gui_coregui_client_components_form_SimpleEditableTextAreaFormItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'SimpleEditableTextAreaFormItem', 2316), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsEditor', 1935), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsEditor$ConditionsTable_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsEditor$ConditionsTable', 1937), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsEditor$ConditionDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsEditor$ConditionDataSource', 1936), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsEditor$ConditionsTable$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsEditor$ConditionsTable$1', 1938), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsEditor$ConditionsTable$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsEditor$ConditionsTable$2', 1939), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsEditor$ConditionsTable$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsEditor$ConditionsTable$3', 1940), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsEditor$ConditionsTable$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsEditor$ConditionsTable$4', 1941), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsEditor$ConditionsTable$4$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsEditor$ConditionsTable$4$1', 1942), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionsEditor$ConditionsTable$4$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionsEditor$ConditionsTable$4$2', 1943), Lcom_smartgwt_client_widgets_events_VisibilityChangedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.events.', 'VisibilityChangedEvent', 476), Lorg_rhq_core_domain_measurement_ui_MetricDisplayValue_2_classLit = createForClass('org.rhq.core.domain.measurement.ui.', 'MetricDisplayValue', 1315), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_CompositeGroupD3GraphListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'CompositeGroupD3GraphListView', 3186), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_CompositeGroupD3GraphListView$MultiLineGraphData_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'CompositeGroupD3GraphListView$MultiLineGraphData', 3192), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_CompositeGroupD3GraphListView$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'CompositeGroupD3GraphListView$1', 3187), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_CompositeGroupD3GraphListView$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'CompositeGroupD3GraphListView$1$1', 3188), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_CompositeGroupD3GraphListView$1$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'CompositeGroupD3GraphListView$1$2', 3189), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_CompositeGroupD3GraphListView$1$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'CompositeGroupD3GraphListView$1$2$1', 3190), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_CompositeGroupD3GraphListView$1$2$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'CompositeGroupD3GraphListView$1$2$2', 3191), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_monitoring_table_CompositeGroupMultiLineGraphListView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.monitoring.table.', 'CompositeGroupMultiLineGraphListView', 3193), Ljava_util_EventObject_2_classLit = createForClass('java.util.', 'EventObject', 665), Lorg_rhq_enterprise_gui_coregui_client_components_upload_DynamicFormSubmitCompleteEvent_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'DynamicFormSubmitCompleteEvent', 2413), Lcom_smartgwt_client_widgets_form_events_ColorSelectedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.events.', 'ColorSelectedEvent', 480), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_detail_ChildHistoryDetails_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.', 'ChildHistoryDetails', 3292), Lcom_smartgwt_client_widgets_tab_events_TabDeselectedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.tab.events.', 'TabDeselectedEvent', 569), Lorg_rhq_enterprise_gui_coregui_client_gwt_MeasurementScheduleGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'MeasurementScheduleGWTService_Proxy', 2840), _3Lorg_rhq_enterprise_gui_coregui_client_components_form_UnitType_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.components.form.', 'UnitType;', 4069, Lorg_rhq_enterprise_gui_coregui_client_components_form_UnitType_2_classLit), Lcom_smartgwt_client_widgets_form_fields_events_DataArrivedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.events.', 'DataArrivedEvent', 521), Lorg_rhq_enterprise_gui_coregui_client_components_selector_SingleResourceGroupSelectorItem_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'SingleResourceGroupSelectorItem', 2352), Lorg_rhq_enterprise_gui_coregui_client_components_selector_SingleResourceGroupSelectorItem$CompatibleResourceGroupsDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.selector.', 'SingleResourceGroupSelectorItem$CompatibleResourceGroupsDataSource', 2353), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotDataSource_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotDataSource', 2729), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotDataSource$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotDataSource$1', 2730), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotDataSource$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotDataSource$2', 2731), Lorg_rhq_enterprise_gui_coregui_client_gwt_AgentGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AgentGWTService_Proxy', 2783), Lorg_rhq_enterprise_gui_coregui_client_gwt_GroupAlertDefinitionGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'GroupAlertDefinitionGWTService_Proxy', 2825), Lorg_rhq_enterprise_gui_coregui_client_gwt_AlertTemplateGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AlertTemplateGWTService_Proxy', 2793), Lcom_smartgwt_client_widgets_form_fields_events_ItemHoverEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.events.', 'ItemHoverEvent', 525), Lorg_rhq_enterprise_gui_coregui_client_gwt_MeasurementScheduleGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'MeasurementScheduleGWTService_TypeSerializer', 2841), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_AbstractResourceFactoryWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'AbstractResourceFactoryWizard', 3533), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryCreateWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryCreateWizard', 3536), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryCreateWizard$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryCreateWizard$1', 3537), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryCreateWizard$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryCreateWizard$2', 3538), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryCreateWizard$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryCreateWizard$3', 3539), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryCreateWizard$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryCreateWizard$3$1', 3540), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryCreateWizard$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryCreateWizard$4', 3541), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryImportWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryImportWizard', 3542), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryImportWizard$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryImportWizard$1', 3543), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryImportWizard$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryImportWizard$2', 3544), Lorg_rhq_enterprise_gui_coregui_client_gwt_AgentGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AgentGWTService_TypeSerializer', 2785), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_ResourceGroupResourceSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'ResourceGroupResourceSelector', 3179), Lorg_rhq_enterprise_gui_coregui_client_inventory_groups_detail_inventory_ResourceGroupResourceSelector$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.groups.detail.inventory.', 'ResourceGroupResourceSelector$1', 3181), Lorg_rhq_enterprise_gui_coregui_client_gwt_GroupAlertDefinitionGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'GroupAlertDefinitionGWTService_TypeSerializer', 2826), Lorg_rhq_enterprise_gui_coregui_client_gwt_AlertTemplateGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'AlertTemplateGWTService_TypeSerializer', 2794), Lorg_rhq_enterprise_gui_coregui_client_gwt_MeasurementChartsGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'MeasurementChartsGWTService_Proxy', 2834), Lcom_smartgwt_client_widgets_grid_events_ChangedEvent_2_classLit = createForClass('com.smartgwt.client.widgets.grid.events.', 'ChangedEvent', 544), Lcom_smartgwt_client_widgets_grid_events_ChangeEvent_2_classLit = createForClass('com.smartgwt.client.widgets.grid.events.', 'ChangeEvent', 543), Lcom_smartgwt_client_widgets_grid_events_RowEditorExitEvent_2_classLit = createForClass('com.smartgwt.client.widgets.grid.events.', 'RowEditorExitEvent', 552), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_AbstractDriftAddDefinitionWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'AbstractDriftAddDefinitionWizard', 2751), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftAddDefinitionWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftAddDefinitionWizard', 2753), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftAddDefinitionWizard$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftAddDefinitionWizard$1', 2754), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftAddDefinitionWizard$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftAddDefinitionWizard$2', 2755), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftAddDefinitionWizard$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftAddDefinitionWizard$3', 2756), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftAddDefinitionWizard$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftAddDefinitionWizard$4', 2757), Lorg_rhq_enterprise_gui_coregui_client_gwt_MeasurementChartsGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'MeasurementChartsGWTService_TypeSerializer', 2835), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_AbstractDriftPinTemplateWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'AbstractDriftPinTemplateWizard', 2752), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftPinTemplateWizard_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftPinTemplateWizard', 2761), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftPinTemplateWizard$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftPinTemplateWizard$1', 2762), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftPinTemplateWizard$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftPinTemplateWizard$2', 2763), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftPinTemplateWizard$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftPinTemplateWizard$3', 2764), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftPinTemplateWizard$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftPinTemplateWizard$3$1', 2765), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NewNotificationEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NewNotificationEditor', 1961), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NewNotificationEditor$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NewNotificationEditor$1', 1962), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NewNotificationEditor$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NewNotificationEditor$2', 1963), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NewNotificationEditor$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NewNotificationEditor$3', 1964), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NewNotificationEditor$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NewNotificationEditor$3$1', 1965), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_NewNotificationEditor$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'NewNotificationEditor$4', 1966), Lorg_rhq_enterprise_gui_coregui_client_gwt_GroupDefinitionExpressionBuilderGWTService_1Proxy_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'GroupDefinitionExpressionBuilderGWTService_Proxy', 2828), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryInfoStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryInfoStep', 3545), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryInfoStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryInfoStep$1', 3546), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryInfoStep$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryInfoStep$2', 3547), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryInfoStep$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryInfoStep$3', 3548), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryInfoStep$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryInfoStep$4', 3549), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryInfoStep$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryInfoStep$5', 3550), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryPackageStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryPackageStep', 3551), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryPackageStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryPackageStep$1', 3552), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryPackageStep$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryPackageStep$2', 3553), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryConfigurationStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryConfigurationStep', 3534), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_factory_ResourceFactoryConfigurationStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.factory.', 'ResourceFactoryConfigurationStep$1', 3535), Lorg_rhq_enterprise_gui_coregui_client_gwt_GroupDefinitionExpressionBuilderGWTService_1TypeSerializer_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.gwt.', 'GroupDefinitionExpressionBuilderGWTService_TypeSerializer', 2829), Lcom_smartgwt_client_widgets_grid_events_RecordExpandEvent_2_classLit = createForClass('com.smartgwt.client.widgets.grid.events.', 'RecordExpandEvent', 551), Lcom_smartgwt_client_widgets_grid_events_RecordCollapseEvent_2_classLit = createForClass('com.smartgwt.client.widgets.grid.events.', 'RecordCollapseEvent', 548), Lorg_rhq_enterprise_gui_coregui_client_drift_DriftSnapshotDriftDetailsView_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.', 'DriftSnapshotDriftDetailsView', 2732), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftAddDefinitionWizardInfoStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftAddDefinitionWizardInfoStep', 2759), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftAddDefinitionWizardInfoStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftAddDefinitionWizardInfoStep$1', 2760), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftAddDefinitionWizardConfigStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftAddDefinitionWizardConfigStep', 2758), Lorg_rhq_enterprise_gui_coregui_client_components_upload_PackageVersionFileUploadForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.upload.', 'PackageVersionFileUploadForm', 1924), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_AbstractNotificationSenderForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'AbstractNotificationSenderForm', 1904), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionEditor_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionEditor', 1928), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionEditor$ShowIfCategoryFunction_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionEditor$ShowIfCategoryFunction', 1932), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionEditor$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionEditor$1', 1929), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionEditor$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionEditor$2', 1930), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ConditionEditor$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ConditionEditor$3', 1931), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SystemUsersNotificationSenderForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SystemUsersNotificationSenderForm', 2018), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SystemUsersNotificationSenderForm$SubjectSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SystemUsersNotificationSenderForm$SubjectSelector', 2020), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SystemUsersNotificationSenderForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SystemUsersNotificationSenderForm$1', 2019), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SystemRolesNotificationSenderForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SystemRolesNotificationSenderForm', 2015), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SystemRolesNotificationSenderForm$RoleSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SystemRolesNotificationSenderForm$RoleSelector', 2017), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SystemRolesNotificationSenderForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SystemRolesNotificationSenderForm$1', 2016), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm', 1991), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$ShowIfModeFunction_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$ShowIfModeFunction', 2004), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$ResourceIdValidator_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$ResourceIdValidator', 2003), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$MapWrapper_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$MapWrapper', 2002), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$1', 1992), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$2', 1993), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$2$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$2$1', 1994), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$3', 1995), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$4', 1996), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$5', 1997), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$6', 1998), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$7', 1999), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$8', 2000), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationSenderForm$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationSenderForm$9', 2001), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_ResourcePicker_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'ResourcePicker', 3555), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_ResourcePicker$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'ResourcePicker$1', 3556), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_ResourcePicker$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'ResourcePicker$2', 3557), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_ResourcePicker$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'ResourcePicker$3', 3558), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_ResourcePicker$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'ResourcePicker$4', 3559), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm', 1905), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$Config_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$Config', 1922), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$PackageVersionFileUploadFormWithVersion_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$PackageVersionFileUploadFormWithVersion', 1923), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$ForwardingDynamicFormHandler_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$ForwardingDynamicFormHandler', 1909), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$PackageVersionFileUploadFormWithVersion$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$PackageVersionFileUploadFormWithVersion$1', 1927), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$1', 1906), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$1$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$1$1', 1907), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$2', 1912), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$3_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$3', 1913), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$3$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$3$1', 1914), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$4_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$4', 1915), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$5_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$5', 1916), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$6_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$6', 1917), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$7_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$7', 1918), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$8_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$8', 1919), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$9_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$9', 1920), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$9$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$9$1', 1921), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$11_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$11', 1908), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$12_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$12', 1910), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_CliNotificationSenderForm$13_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'CliNotificationSenderForm$13', 1911), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SimpleNotificationSenderForm_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SimpleNotificationSenderForm', 2005), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_SimpleNotificationSenderForm$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'SimpleNotificationSenderForm$1', 2006), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftPinTemplateWizardInfoStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftPinTemplateWizardInfoStep', 2768), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftPinTemplateWizardInfoStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftPinTemplateWizardInfoStep$1', 2769), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftPinTemplateWizardInfoStep$2_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftPinTemplateWizardInfoStep$2', 2770), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftPinTemplateWizardConfigStep_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftPinTemplateWizardConfigStep', 2766), Lorg_rhq_enterprise_gui_coregui_client_drift_wizard_DriftPinTemplateWizardConfigStep$1_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.drift.wizard.', 'DriftPinTemplateWizardConfigStep$1', 2767), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationInfo_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationInfo', 1986), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationInfo$Constants_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationInfo$Constants', 1987, Ljava_lang_Enum_2_classLit, values_126, valueOf_132), _3Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationInfo$Constants_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationInfo$Constants;', 4070, Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationInfo$Constants_2_classLit), Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationInfo$ResourceSelectionMode_2_classLit = createForEnum('org.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationInfo$ResourceSelectionMode', 1989, Ljava_lang_Enum_2_classLit, values_127, valueOf_133), _3Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationInfo$ResourceSelectionMode_2_classLit = createForArray('[Lorg.rhq.enterprise.gui.coregui.client.alert.definitions.', 'ResourceOperationNotificationInfo$ResourceSelectionMode;', 4071, Lorg_rhq_enterprise_gui_coregui_client_alert_definitions_ResourceOperationNotificationInfo$ResourceSelectionMode_2_classLit), Lorg_rhq_core_domain_drift_DriftDefinitionComparator_2_classLit = createForClass('org.rhq.core.domain.drift.', 'DriftDefinitionComparator', 1193), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_SingleResourcePicker_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'SingleResourcePicker', 3563), Lorg_rhq_enterprise_gui_coregui_client_components_form_NumberWithUnitsValidator_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.components.form.', 'NumberWithUnitsValidator', 2308), Lcom_smartgwt_client_widgets_form_fields_SectionItem_2_classLit = createForClass('com.smartgwt.client.widgets.form.fields.', 'SectionItem', 511), Lcom_smartgwt_client_widgets_form_events_ItemChangeEvent_2_classLit = createForClass('com.smartgwt.client.widgets.form.events.', 'ItemChangeEvent', 482), Lorg_rhq_enterprise_gui_coregui_client_inventory_resource_selection_SingleResourceSelector_2_classLit = createForClass('org.rhq.enterprise.gui.coregui.client.inventory.resource.selection.', 'SingleResourceSelector', 3564);
$entry(onLoad)(1);
